(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:AEDataModel.p"
; at Wednesday May 1,2002 2:38:51 pm.
; 
;      File:       AEDataModel.p
;  
;      Contains:   AppleEvent Data Model Interfaces.
;  
;      Version:    Technology: Mac OS 9
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1996-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __AEDATAMODEL__
; $SETC __AEDATAMODEL__ := 1

; $I+
; $SETC AEDataModelIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  Apple event descriptor types 

(defconstant $typeBoolean :|bool|)
(defconstant $typeChar :|TEXT|)

; 	 Preferred numeric Apple event descriptor types 	
(defconstant $typeSInt16 :|shor|)
(defconstant $typeSInt32 :|long|)
(defconstant $typeUInt32 :|magn|)
(defconstant $typeSInt64 :|comp|)
(defconstant $typeIEEE32BitFloatingPoint :|sing|)
(defconstant $typeIEEE64BitFloatingPoint :|doub|)
(defconstant $type128BitFloatingPoint :|ldbl|)
(defconstant $typeDecimalStruct :|decm|)

; 	 Non-preferred Apple event descriptor types 	
(defconstant $typeSMInt :|shor|)
(defconstant $typeShortInteger :|shor|)
(defconstant $typeInteger :|long|)
(defconstant $typeLongInteger :|long|)
(defconstant $typeMagnitude :|magn|)
(defconstant $typeComp :|comp|)
(defconstant $typeSMFloat :|sing|)
(defconstant $typeShortFloat :|sing|)
(defconstant $typeFloat :|doub|)
(defconstant $typeLongFloat :|doub|)
(defconstant $typeExtended :|exte|)

; 	 More Apple event descriptor types 	
(defconstant $typeAEList :|list|)
(defconstant $typeAERecord :|reco|)
(defconstant $typeAppleEvent :|aevt|)
(defconstant $typeEventRecord :|evrc|)
(defconstant $typeTrue :|true|)
(defconstant $typeFalse :|fals|)
(defconstant $typeAlias :|alis|)
(defconstant $typeEnumerated :|enum|)
(defconstant $typeType :|type|)
(defconstant $typeAppParameters :|appa|)
(defconstant $typeProperty :|prop|)
(defconstant $typeFSS :|fss |)
(defconstant $typeFSRef :|fsrf|)
(defconstant $typeFileURL :|furl|)
(defconstant $typeKeyword :|keyw|)
(defconstant $typeSectionH :|sect|)
(defconstant $typeWildCard :|****|)
(defconstant $typeApplSignature :|sign|)
(defconstant $typeQDRectangle :|qdrt|)
(defconstant $typeFixed :|fixd|)
(defconstant $typeProcessSerialNumber :|psn |)
(defconstant $typeApplicationURL :|aprl|)
(defconstant $typeNull :|null|)                 ;   null or nonexistent data  

; $IFC CALL_NOT_IN_CARBON 
; 	 Deprecated addressing modes under Carbon 	
(defconstant $typeSessionID :|ssid|)
(defconstant $typeTargetID :|targ|)
(defconstant $typeDispatcherID :|dspt|)

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 	 Keywords for Apple event attributes 	
(defconstant $keyTransactionIDAttr :|tran|)
(defconstant $keyReturnIDAttr :|rtid|)
(defconstant $keyEventClassAttr :|evcl|)
(defconstant $keyEventIDAttr :|evid|)
(defconstant $keyAddressAttr :|addr|)
(defconstant $keyOptionalKeywordAttr :|optk|)
(defconstant $keyTimeoutAttr :|timo|)
(defconstant $keyInteractLevelAttr :|inte|)     ;   this attribute is read only - will be set in AESend  
(defconstant $keyEventSourceAttr :|esrc|)       ;   this attribute is read only - returned as typeShortInteger  
(defconstant $keyMissedKeywordAttr :|miss|)     ;   this attribute is read only  
(defconstant $keyOriginalAddressAttr :|from|)   ;   new in 1.0.1  
(defconstant $keyAcceptTimeoutAttr :|actm|)     ;   new for Mac OS X  

; 	  Constants used for specifying the factoring of AEDescLists. 	
(defconstant $kAEDescListFactorNone 0)
(defconstant $kAEDescListFactorType 4)
(defconstant $kAEDescListFactorTypeAndSize 8)

; 	 Constants used creating an AppleEvent 	
;   Constant for the returnID param of AECreateAppleEvent  
(defconstant $kAutoGenerateReturnID -1)         ;   AECreateAppleEvent will generate a session-unique ID  
;   Constant for transaction IDs  
(defconstant $kAnyTransactionID 0)              ;   no transaction is in use  

; 	 Apple event manager data types 	

(def-mactype :desctype (find-mactype ':ostype))
(def-mactype :aekeyword (find-mactype ':ostype))
#|                                              ; $IFC OPAQUE_TOOLBOX_STRUCTS 
(def-mactype :aedatastorage (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :aedatastorageptr (find-mactype '(:pointer :aedatastorage)));  when a VAR xx:AEDataStorage parameter can be nil, it is changed to xx: AEDataStoragePtr 
 |#                                             ; $ELSEC
(def-mactype :aedatastorage (find-mactype ':handle))
; $ENDC                                         ; OPAQUE_TOOLBOX_STRUCTS

(def-mactype :aedescptr (find-mactype '(:pointer :aedesc)))
(defrecord AEDesc 
   (descriptorType :ostype)
   (dataHandle :handle)
   )

(def-mactype :aekeydescptr (find-mactype '(:pointer :aekeydesc)))
(defrecord AEKeyDesc 
   (descKey :ostype)
   (descContent :aedesc)
   )

; 	 a list of AEDesc's is a special kind of AEDesc 	
(%define-record :aedesclist (find-record-descriptor :aedesc))
(def-mactype :aedesclistptr (find-mactype '(:pointer :aedesc)))
; 	 AERecord is a list of keyworded AEDesc's 	
(%define-record :aerecord (find-record-descriptor :aedesc))
(def-mactype :aerecordptr (find-mactype '(:pointer :aedesc)))
; 	 an AEDesc which contains address data 	
(%define-record :aeaddressdesc (find-record-descriptor :aedesc))
(def-mactype :aeaddressdescptr (find-mactype '(:pointer :aedesc)))
; 	 an AERecord that contains an AppleEvent, and related data types 	
(%define-record :appleevent (find-record-descriptor :aedesc))
(def-mactype :appleeventptr (find-mactype '(:pointer :aedesc)))
(def-mactype :aereturnid (find-mactype ':signed-integer))
(def-mactype :aetransactionid (find-mactype ':signed-long))
(def-mactype :aeeventclass (find-mactype ':ostype))
(def-mactype :aeeventid (find-mactype ':ostype))
(def-mactype :aearraytype (find-mactype ':signed-byte))

(defconstant $kAEDataArray 0)
(defconstant $kAEPackedArray 1)
(defconstant $kAEDescArray 3)
(defconstant $kAEKeyDescArray 4)

(defconstant $kAEHandleArray 2)

(def-mactype :aearraydataptr (find-mactype '(:pointer :aearraydata)))
(defrecord AEArrayData 
   (:variant 
      (
      (kAEDataArray (:array :signed-integer 1))
      )
      (
      (kAEPackedArray :signed-byte)
      )
      (
      (kAEHandleArray (:array :handle 1))
      )
      (
      (kAEDescArray (:array :aedesc 1))
      )
      (
      (kAEKeyDescArray (:array :aekeydesc 1))
      )
      )
   )

(def-mactype :aearraydatapointer (find-mactype '(:pointer :aearraydata)))
(def-mactype :aearraydatapointerptr (find-mactype '(:handle :aearraydata)))
; 	*************************************************************************
; 	  These constants are used by AEMach and AEInteraction APIs.  They are not
; 	  strictly part of the data format, but are declared here due to layering.
; 	*************************************************************************	
(def-mactype :aesendpriority (find-mactype ':signed-integer))

(defconstant $kAENormalPriority #x0)            ;   post message at the end of the event queue  
(defconstant $kAEHighPriority #x1)              ;   post message at the front of the event queue (same as nAttnMsg)  

(def-mactype :aesendmode (find-mactype ':signed-long))

(defconstant $kAENoReply #x1)                   ;   sender doesn't want a reply to event  
(defconstant $kAEQueueReply #x2)                ;   sender wants a reply but won't wait  
(defconstant $kAEWaitReply #x3)                 ;   sender wants a reply and will wait  
(defconstant $kAEDontReconnect #x80)            ;   don't reconnect if there is a sessClosedErr from PPCToolbox  
(defconstant $kAEWantReceipt #x200)             ;   (nReturnReceipt) sender wants a receipt of message  
(defconstant $kAENeverInteract #x10)            ;   server should not interact with user  
(defconstant $kAECanInteract #x20)              ;   server may try to interact with user  
(defconstant $kAEAlwaysInteract #x30)           ;   server should always interact with user where appropriate  
(defconstant $kAECanSwitchLayer #x40)           ;   interaction may switch layer  
(defconstant $kAEDontRecord #x1000)             ;   don't record this event - available only in vers 1.0.1 and greater  
(defconstant $kAEDontExecute #x2000)            ;   don't send the event for recording - available only in vers 1.0.1 and greater  
(defconstant $kAEProcessNonReplyEvents #x8000)  ;   allow processing of non-reply events while awaiting synchronous AppleEvent reply  

; 	 Constants for timeout durations 	
(defconstant $kAEDefaultTimeout -1)             ;   timeout value determined by AEM  
(defconstant $kNoTimeOut -2)                    ;   wait until reply comes back, however long it takes  

; 	*************************************************************************
; 	  These calls are used to set up and modify the coercion dispatch table.
; 	*************************************************************************	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	AECoerceDescProcPtr = FUNCTION({CONST}VAR fromDesc: AEDesc; toType: DescType; handlerRefcon: LONGINT; VAR toDesc: AEDesc): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :aecoercedescprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	AECoercePtrProcPtr = FUNCTION(typeCode: DescType; dataPtr: UNIV Ptr; dataSize: Size; toType: DescType; handlerRefcon: LONGINT; VAR result: AEDesc): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :aecoerceptrprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :aecoercedescupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :aecoercedescupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :aecoerceptrupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :aecoerceptrupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppAECoerceDescProcInfo #x3FE0)
(defconstant $uppAECoercePtrProcInfo #x3FFE0)
; 
; 	 *  NewAECoerceDescUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewAECoerceDescProc 
(deftrap "_NewAECoerceDescUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewAECoercePtrUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewAECoercePtrProc 
(deftrap "_NewAECoercePtrUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeAECoerceDescUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeAECoerceDescUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeAECoercePtrUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeAECoercePtrUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeAECoerceDescUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ;  old name was CallAECoerceDescProc 
(deftrap-inline "_InvokeAECoerceDescUPP" 
      ((fromDesc (:pointer :aedesc)) (toType :ostype) (handlerRefcon :signed-long) (toDesc (:pointer :aedesc)) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeAECoercePtrUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallAECoercePtrProc 
(deftrap-inline "_InvokeAECoercePtrUPP" 
      ((typeCode :ostype) (dataPtr :pointer) (dataSize :signed-long) (toType :ostype) (handlerRefcon :signed-long) (result (:pointer :aedesc)) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

;  a AECoercionHandlerUPP is by default a AECoerceDescUPP.  If you are registering a 
;     Ptr based coercion handler you will have to add a cast to AECoerceDescUPP from 
;     your AECoercePtrUPP type.  A future release of the interfaces will fix this by
;     introducing seperate Desc and Ptr coercion handler installation/remove/query routines. 

(def-mactype :aecoercionhandlerupp (find-mactype ':pointer))
; 
; 	 *  AEInstallCoercionHandler()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_AEInstallCoercionHandler" 
      ((fromType :ostype) (toType :ostype) (handler :pointer) (handlerRefcon :signed-long) (fromTypeIsDesc :boolean) (isSysHandler :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 2594 fromType toType handler handlerRefcon fromTypeIsDesc isSysHandler))

; 
;  *  AERemoveCoercionHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AERemoveCoercionHandler" 
      ((fromType :ostype) (toType :ostype) (handler :pointer) (isSysHandler :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 1827 fromType toType handler isSysHandler))

; 
;  *  AEGetCoercionHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AEGetCoercionHandler" 
      ((fromType :ostype) (toType :ostype) (handler (:pointer :pointer)) (handlerRefcon (:pointer :signed-long)) (fromTypeIsDesc (:pointer :boolean)) (isSysHandler :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 2852 fromType toType handler handlerRefcon fromTypeIsDesc isSysHandler))

; *************************************************************************
;   The following calls provide for a coercion interface.
; *************************************************************************
; 
;  *  AECoercePtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AECoercePtr" 
      ((typeCode :ostype) (dataPtr :pointer) (dataSize :signed-long) (toType :ostype) (result (:pointer :aedesc)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 2562 typeCode dataPtr dataSize toType result))

; 
;  *  AECoerceDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_AECoerceDesc" 
      ((theAEDesc (:pointer :aedesc)) (toType :ostype) (result (:pointer :aedesc)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 1539 theAEDesc toType result))

; *************************************************************************
;  The following calls apply to any AEDesc. Every 'result' descriptor is
;  created for you, so you will be responsible for memory management
;  (including disposing) of the descriptors so created.  
; *************************************************************************
;  because AEDescs are opaque under Carbon, this AEInitializeDesc provides a
;    'clean' way of initializating them to be empty. 
; 
;  *  AEInitializeDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AEInitializeDesc" 
      ((desc (:pointer :aedesc))) 
  nil
   () )

; 
;  *  AECreateDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AECreateDesc" 
      ((typeCode :ostype) (dataPtr :pointer) (dataSize :signed-long) (result (:pointer :aedesc)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 2085 typeCode dataPtr dataSize result))

; 
;  *  AEDisposeDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AEDisposeDesc" 
      ((theAEDesc (:pointer :aedesc)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 516 theAEDesc))

; 
;  *  AEDuplicateDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_AEDuplicateDesc" 
      ((theAEDesc (:pointer :aedesc)) (result (:pointer :aedesc)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 1029 theAEDesc result))

; *************************************************************************
;   The following calls apply to AEDescList. Since AEDescList is a subtype of
;   AEDesc, the calls in the previous section can also be used for AEDescList.
;   All list and array indices are 1-based. If the data was greater than
;   maximumSize in the routines below, then actualSize will be greater than
;   maximumSize, but only maximumSize bytes will actually be retrieved.
; *************************************************************************
; 
;  *  AECreateList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AECreateList" 
      ((factoringPtr :pointer) (factoredSize :signed-long) (isRecord :boolean) (resultList (:pointer :aedesc)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 1798 factoringPtr factoredSize isRecord resultList))

; 
;  *  AECountItems()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_AECountItems" 
      ((theAEDescList (:pointer :aedesc)) (theCount (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 1031 theAEDescList theCount))

; 
;  *  AEPutPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AEPutPtr" 
      ((theAEDescList (:pointer :aedesc)) (index :signed-long) (typeCode :ostype) (dataPtr :pointer) (dataSize :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 2568 theAEDescList index typeCode dataPtr dataSize))

; 
;  *  AEPutDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_AEPutDesc" 
      ((theAEDescList (:pointer :aedesc)) (index :signed-long) (theAEDesc (:pointer :aedesc)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 1545 theAEDescList index theAEDesc))

; 
;  *  AEGetNthPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_AEGetNthPtr" 
      ((theAEDescList (:pointer :aedesc)) (index :signed-long) (desiredType :ostype) (theAEKeyword (:pointer :ostype)) (typeCode (:pointer :ostype)) (dataPtr :pointer) (maximumSize :signed-long) (actualSize (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 4106 theAEDescList index desiredType theAEKeyword typeCode dataPtr maximumSize actualSize))

; 
;  *  AEGetNthDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_AEGetNthDesc" 
      ((theAEDescList (:pointer :aedesc)) (index :signed-long) (desiredType :ostype) (theAEKeyword (:pointer :ostype)) (result (:pointer :aedesc)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 2571 theAEDescList index desiredType theAEKeyword result))

; 
;  *  AESizeOfNthItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_AESizeOfNthItem" 
      ((theAEDescList (:pointer :aedesc)) (index :signed-long) (typeCode (:pointer :ostype)) (dataSize (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 2090 theAEDescList index typeCode dataSize))

; 
;  *  AEGetArray()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_AEGetArray" 
      ((theAEDescList (:pointer :aedesc)) (arrayType :signed-byte) (arrayPtr (:pointer :aearraydata)) (maximumSize :signed-long) (itemType (:pointer :ostype)) (itemSize (:pointer :signed-long)) (itemCount (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 3340 theAEDescList arrayType arrayPtr maximumSize itemType itemSize itemCount))

; 
;  *  AEPutArray()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_AEPutArray" 
      ((theAEDescList (:pointer :aedesc)) (arrayType :signed-byte) (arrayPtr (:pointer :aearraydata)) (itemType :ostype) (itemSize :signed-long) (itemCount :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 2829 theAEDescList arrayType arrayPtr itemType itemSize itemCount))

; 
;  *  AEDeleteItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AEDeleteItem" 
      ((theAEDescList (:pointer :aedesc)) (index :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 1038 theAEDescList index))

; *************************************************************************
;  The following calls apply to AERecord. Since AERecord is a subtype of
;  AEDescList, the calls in the previous sections can also be used for
;  AERecord an AERecord can be created by using AECreateList with isRecord
;  set to true. 
; *************************************************************************
; ************************************************************************
;  AERecords can have an abitrary descriptorType.  This allows you to
;  check if desc is truly an AERecord
; ***********************************************************************
; 
;  *  AECheckIsRecord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_AECheckIsRecord" 
      ((theDesc (:pointer :aedesc))) 
  :boolean
   () )

; 
;   Note: none of the key calls were available in the PowerPC 7.x IntefaceLib.
;   In C, a #define is used to map key calls to param calls.  In pascal
;   this mapping is done in externally linked glue code.
; 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  AEPutKeyPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AEPutKeyPtr" 
      ((theAERecord (:pointer :aedesc)) (theAEKeyword :ostype) (typeCode :ostype) (dataPtr :pointer) (dataSize :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 2575 theAERecord theAEKeyword typeCode dataPtr dataSize))

; 
;  *  AEPutKeyDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_AEPutKeyDesc" 
      ((theAERecord (:pointer :aedesc)) (theAEKeyword :ostype) (theAEDesc (:pointer :aedesc)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 1552 theAERecord theAEKeyword theAEDesc))

; 
;  *  AEGetKeyPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_AEGetKeyPtr" 
      ((theAERecord (:pointer :aedesc)) (theAEKeyword :ostype) (desiredType :ostype) (typeCode (:pointer :ostype)) (dataPtr :pointer) (maximumSize :signed-long) (actualSize (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 3601 theAERecord theAEKeyword desiredType typeCode dataPtr maximumSize actualSize))

; 
;  *  AEGetKeyDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_AEGetKeyDesc" 
      ((theAERecord (:pointer :aedesc)) (theAEKeyword :ostype) (desiredType :ostype) (result (:pointer :aedesc)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 2066 theAERecord theAEKeyword desiredType result))

; 
;  *  AESizeOfKeyDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_AESizeOfKeyDesc" 
      ((theAERecord (:pointer :aedesc)) (theAEKeyword :ostype) (typeCode (:pointer :ostype)) (dataSize (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 2089 theAERecord theAEKeyword typeCode dataSize))

; 
;  *  AEDeleteKeyDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AEDeleteKeyDesc" 
      ((theAERecord (:pointer :aedesc)) (theAEKeyword :ostype))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 1043 theAERecord theAEKeyword))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; *************************************************************************
;   The following calls create and manipulate the AppleEvent data type.
; *************************************************************************
; 
;  *  AECreateAppleEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_AECreateAppleEvent" 
      ((theAEEventClass :ostype) (theAEEventID :ostype) (target (:pointer :aedesc)) (returnID :signed-integer) (transactionID :signed-long) (result (:pointer :aedesc)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 2836 theAEEventClass theAEEventID target returnID transactionID result))

; *************************************************************************
;   The following calls are used to pack and unpack parameters from records
;   of type AppleEvent. Since AppleEvent is a subtype of AERecord, the calls
;   in the previous sections can also be used for variables of type
;   AppleEvent. The next six calls are in fact identical to the six calls
;   for AERecord.
; *************************************************************************
; 
;  *  AEPutParamPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AEPutParamPtr" 
      ((theAppleEvent (:pointer :aedesc)) (theAEKeyword :ostype) (typeCode :ostype) (dataPtr :pointer) (dataSize :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 2575 theAppleEvent theAEKeyword typeCode dataPtr dataSize))

; 
;  *  AEPutParamDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_AEPutParamDesc" 
      ((theAppleEvent (:pointer :aedesc)) (theAEKeyword :ostype) (theAEDesc (:pointer :aedesc)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 1552 theAppleEvent theAEKeyword theAEDesc))

; 
;  *  AEGetParamPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_AEGetParamPtr" 
      ((theAppleEvent (:pointer :aedesc)) (theAEKeyword :ostype) (desiredType :ostype) (typeCode (:pointer :ostype)) (dataPtr :pointer) (maximumSize :signed-long) (actualSize (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 3601 theAppleEvent theAEKeyword desiredType typeCode dataPtr maximumSize actualSize))

; 
;  *  AEGetParamDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_AEGetParamDesc" 
      ((theAppleEvent (:pointer :aedesc)) (theAEKeyword :ostype) (desiredType :ostype) (result (:pointer :aedesc)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 2066 theAppleEvent theAEKeyword desiredType result))

; 
;  *  AESizeOfParam()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_AESizeOfParam" 
      ((theAppleEvent (:pointer :aedesc)) (theAEKeyword :ostype) (typeCode (:pointer :ostype)) (dataSize (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 2089 theAppleEvent theAEKeyword typeCode dataSize))

; 
;  *  AEDeleteParam()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AEDeleteParam" 
      ((theAppleEvent (:pointer :aedesc)) (theAEKeyword :ostype))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 1043 theAppleEvent theAEKeyword))

; *************************************************************************
;  The following calls also apply to type AppleEvent. Message attributes are
;  far more restricted, and can only be accessed through the following 5
;  calls. The various list and record routines cannot be used to access the
;  attributes of an event. 
; *************************************************************************
; 
;  *  AEGetAttributePtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_AEGetAttributePtr" 
      ((theAppleEvent (:pointer :aedesc)) (theAEKeyword :ostype) (desiredType :ostype) (typeCode (:pointer :ostype)) (dataPtr :pointer) (maximumSize :signed-long) (actualSize (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 3605 theAppleEvent theAEKeyword desiredType typeCode dataPtr maximumSize actualSize))

; 
;  *  AEGetAttributeDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_AEGetAttributeDesc" 
      ((theAppleEvent (:pointer :aedesc)) (theAEKeyword :ostype) (desiredType :ostype) (result (:pointer :aedesc)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 2086 theAppleEvent theAEKeyword desiredType result))

; 
;  *  AESizeOfAttribute()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_AESizeOfAttribute" 
      ((theAppleEvent (:pointer :aedesc)) (theAEKeyword :ostype) (typeCode (:pointer :ostype)) (dataSize (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 2088 theAppleEvent theAEKeyword typeCode dataSize))

; 
;  *  AEPutAttributePtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AEPutAttributePtr" 
      ((theAppleEvent (:pointer :aedesc)) (theAEKeyword :ostype) (typeCode :ostype) (dataPtr :pointer) (dataSize :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 2582 theAppleEvent theAEKeyword typeCode dataPtr dataSize))

; 
;  *  AEPutAttributeDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_AEPutAttributeDesc" 
      ((theAppleEvent (:pointer :aedesc)) (theAEKeyword :ostype) (theAEDesc (:pointer :aedesc)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 1575 theAppleEvent theAEKeyword theAEDesc))

; *************************************************************************
;  AppleEvent Serialization Support
; 
;     AESizeOfFlattenedDesc, AEFlattenDesc, AEUnflattenDesc
;     
;     These calls will work for all AppleEvent data types and between different
;     versions of the OS (including between Mac OS 9 and X)
;     
;     Basic types, AEDesc, AEList and AERecord are OK, but AppleEvent records
;     themselves may not be reliably flattened for storage.
; *************************************************************************
; 
;    AEFlattenDesc
;    Returns the amount of buffer space needed to flatten the
;    AEDesc. Call this before AEFlattenDesc to make sure your
;    buffer has enough room for the operation.
; 

; 
;  *  AESizeOfFlattenedDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_AESizeOfFlattenedDesc" 
      ((theAEDesc (:pointer :aedesc))) 
  :signed-long
   () )

; 
;    AEFlattenDesc
;    Fills a buffer with a flattened representation of the
;    AEDesc and returns the amount of buffer used in actualSize.
;    If bufferSize was too small it returns errAEBufferTooSmall
;    (-1741) and does not fill in any of the buffer. The resulting
;    buffer is only useful with an AEUnflattenDesc call.
;    
;    Note: if you pass a NULL buffer pointer it returns noErr but
;    fills in the actualSize field anyway.
; 

; 
;  *  AEFlattenDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_AEFlattenDesc" 
      ((theAEDesc (:pointer :aedesc)) (buffer :pointer) (bufferSize :signed-long) (actualSize (:pointer :signed-long))) 
  :osstatus
   () )

; 
;    AEUnflattenDesc
;    Allocates an AEDesc (given a Null Desc) given a flattened
;    data buffer. It assumes it was given a good buffer filled
;    in by AEFlattenDesc. It returns paramErr if it discovers
;    something fishy about the buffer.
; 

; 
;  *  AEUnflattenDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AEUnflattenDesc" 
      ((buffer :pointer) (result (:pointer :aedesc))) 
  :osstatus
   () )

; *************************************************************************
;  The following calls are necessary to deal with opaque data in AEDescs, because the
;  traditional way of dealing with a basic AEDesc has been to dereference the dataHandle
;  directly.  This is not supported under Carbon.
; *************************************************************************
; $IFC ACCESSOR_CALLS_ARE_FUNCTIONS 
; 
;         AEGetDescData no longer supports automatic coercion. If you'd like to
;         coerce the descriptor use AECoerceDesc.
;     
; 
;  *  AEGetDescData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; 
;  *  AEGetDescDataSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_AEGetDescData" 
      ((theAEDesc (:pointer :aedesc)) (dataPtr :pointer) (maximumSize :signed-long)) 
  :signed-integer
   () )                                         ; CONST; 
;  *  AEReplaceDescData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_AEGetDescDataSize" 
      ((theAEDesc (:pointer :aedesc))) 
  :signed-long
   () )
(deftrap-inline "_AEReplaceDescData" 
      ((typeCode :ostype) (dataPtr :pointer) (dataSize :signed-long) (theAEDesc (:pointer :aedesc))) 
  :signed-integer
   () )                                         ; $ENDC; ACCESSOR_CALLS_ARE_FUNCTIONS

; *************************************************************************
;   A AEEventHandler is installed to process an AppleEvent 
; *************************************************************************

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	AEEventHandlerProcPtr = FUNCTION({CONST}VAR theAppleEvent: AppleEvent; VAR reply: AppleEvent; handlerRefcon: LONGINT): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :aeeventhandlerprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :aeeventhandlerupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :aeeventhandlerupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppAEEventHandlerProcInfo #xFE0)
; 
; 	 *  NewAEEventHandlerUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewAEEventHandlerProc 
(deftrap "_NewAEEventHandlerUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeAEEventHandlerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeAEEventHandlerUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeAEEventHandlerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ;  old name was CallAEEventHandlerProc 
(deftrap-inline "_InvokeAEEventHandlerUPP" 
      ((theAppleEvent (:pointer :aedesc)) (reply (:pointer :aedesc)) (handlerRefcon :signed-long) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := AEDataModelIncludes

; $ENDC                                         ; __AEDATAMODEL__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'AEDataModel)