(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:AEHelpers.p"
; at Wednesday May 1,2002 2:38:52 pm.
; 
;      File:       AEHelpers.p
;  
;      Contains:   AEPrint, AEBuild and AEStream for Carbon
;  
;      Version:    Technology: Mac OS X, CarbonLib
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1999-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
; 
;  * Originally from AEGIzmos by Jens Alfke, circa 1992.
;  
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __AEHELPERS__
; $SETC __AEHELPERS__ := 1

; $I+
; $SETC AEHelpersIncludes := UsingIncludes
; $SETC UsingIncludes := 1

; $IFC UNDEFINED __APPLEEVENTS__

(require-interface 'AppleEvents)                ; $I AppleEvents.p
; $ENDC
#|                                              ; $IFC UNDEFINED __AEDATAMODEL__
|#

(require-interface 'AEDataModel)
#|                                              ; $I AEDataModel.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;  * AEBuild is only available for C programmers.
;  
; 
;  * AEPrintDescToHandle
;  *
;  * AEPrintDescToHandle provides a way to turn an AEDesc into a textual
;  * representation.  This is most useful for debugging calls to
;  * AEBuildDesc and friends.  The Handle returned should be disposed by
;  * the caller.  The size of the handle is the actual number of
;  * characters in the string.
;  
; 
;  *  AEPrintDescToHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_AEPrintDescToHandle" 
      ((desc (:pointer :aedesc)) (result (:pointer :handle))) 
  :osstatus
   () )

; 
;  * AEStream:
;  *
;  * The AEStream interface allows you to build AppleEvents by appending
;  * to an opaque structure (an AEStreamRef) and then turning this
;  * structure into an AppleEvent.  The basic idea is to open the
;  * stream, write data, and then close it - closing it produces an
;  * AEDesc, which may be partially complete, or may be a complete
;  * AppleEvent.
;  

(def-mactype :aestreamref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :aestreamrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:AEStreamRef parameter can be nil, it is changed to xx: AEStreamRefPtr 
; 
; 	   Create and return an AEStreamRef
; 	   Returns NULL on memory allocation failure
; 	
; 
; 	 *  AEStreamOpen()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_AEStreamOpen" 
      () 
  :pointer
   () )

; 
;    Closes and disposes of an AEStreamRef, producing
;    results in the desc.  You must dispose of the desc yourself.
;    If you just want to dispose of the AEStreamRef, you can pass NULL for desc.
; 
; 
;  *  AEStreamClose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AEStreamClose" 
      ((ref :pointer) (desc (:pointer :aedesc))) 
  :osstatus
   () )

; 
;    Prepares an AEStreamRef for appending data to a newly created desc.
;    You append data with AEStreamWriteData
; 
; 
;  *  AEStreamOpenDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AEStreamOpenDesc" 
      ((ref :pointer) (newType :ostype)) 
  :osstatus
   () )

;   Append data to the previously opened desc. 
; 
;  *  AEStreamWriteData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AEStreamWriteData" 
      ((ref :pointer) (data :pointer) (length :signed-long)) 
  :osstatus
   () )

; 
;    Finish a desc.  After this, you can close the stream, or adding new
;    descs, if you're assembling a list.
; 
; 
;  *  AEStreamCloseDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AEStreamCloseDesc" 
      ((ref :pointer)) 
  :osstatus
   () )

;   Write data as a desc to the stream 
; 
;  *  AEStreamWriteDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AEStreamWriteDesc" 
      ((ref :pointer) (newType :ostype) (data :pointer) (length :signed-long)) 
  :osstatus
   () )

;   Write an entire desc to the stream 
; 
;  *  AEStreamWriteAEDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_AEStreamWriteAEDesc" 
      ((ref :pointer) (desc (:pointer :aedesc))) 
  :osstatus
   () )

; 
;    Begin a list.  You can then append to the list by doing
;    AEStreamOpenDesc, or AEStreamWriteDesc.
; 
; 
;  *  AEStreamOpenList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AEStreamOpenList" 
      ((ref :pointer)) 
  :osstatus
   () )

;   Finish a list. 
; 
;  *  AEStreamCloseList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AEStreamCloseList" 
      ((ref :pointer)) 
  :osstatus
   () )

; 
;    Begin a record.  A record usually has type 'reco', however, this is
;    rather generic, and frequently a different type is used.
; 
; 
;  *  AEStreamOpenRecord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AEStreamOpenRecord" 
      ((ref :pointer) (newType :ostype)) 
  :osstatus
   () )

;   Change the type of a record. 
; 
;  *  AEStreamSetRecordType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AEStreamSetRecordType" 
      ((ref :pointer) (newType :ostype)) 
  :osstatus
   () )

;   Finish a record 
; 
;  *  AEStreamCloseRecord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AEStreamCloseRecord" 
      ((ref :pointer)) 
  :osstatus
   () )

; 
;    Add a keyed descriptor to a record.  This is analogous to AEPutParamDesc.
;    it can only be used when writing to a record.
; 
; 
;  *  AEStreamWriteKeyDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AEStreamWriteKeyDesc" 
      ((ref :pointer) (key :ostype) (newType :ostype) (data :pointer) (length :signed-long)) 
  :osstatus
   () )

; 
;    OpenDesc for a keyed record entry.  You can youse AEStreamWriteData
;    after opening a keyed desc.
; 
; 
;  *  AEStreamOpenKeyDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AEStreamOpenKeyDesc" 
      ((ref :pointer) (key :ostype) (newType :ostype)) 
  :osstatus
   () )

;   Write a key to the stream - you can follow this with an AEWriteDesc. 
; 
;  *  AEStreamWriteKey()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AEStreamWriteKey" 
      ((ref :pointer) (key :ostype)) 
  :osstatus
   () )

; 
;    Create a complete AppleEvent.  This creates and returns a new stream.
;    Use this call to populate the meta fields in an AppleEvent record.
;    After this, you can add your records, lists and other parameters.
; 
; 
;  *  AEStreamCreateEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AEStreamCreateEvent" 
      ((clazz :ostype) (id :ostype) (targetType :ostype) (targetData :pointer) (targetLength :signed-long) (returnID :signed-integer) (transactionID :signed-long)) 
  :pointer
   () )

; 
;    This call lets you augment an existing AppleEvent using the stream
;    APIs.  This would be useful, for example, in constructing the reply
;    record in an AppleEvent handler.  Note that AEStreamOpenEvent will
;    consume the AppleEvent passed in - you can't access it again until the
;    stream is closed.  When you're done building the event, AEStreamCloseStream
;     will reconstitute it.
; 
; 
;  *  AEStreamOpenEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AEStreamOpenEvent" 
      ((event (:pointer :aedesc))) 
  :pointer
   () )

;   Mark a keyword as being an optional parameter. 
; 
;  *  AEStreamOptionalParam()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AEStreamOptionalParam" 
      ((ref :pointer) (key :ostype)) 
  :osstatus
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := AEHelpersIncludes

; $ENDC                                         ; __AEHELPERS__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'AEHelpers)