(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:AEInteraction.p"
; at Wednesday May 1,2002 2:38:52 pm.
; 
;      File:       AEInteraction.p
;  
;      Contains:   AppleEvent functions that deal with Events and interacting with user
;  
;      Version:    Technology: Mac OS 9
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   2000-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __AEINTERACTION__
; $SETC __AEINTERACTION__ := 1

; $I+
; $SETC AEInteractionIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __AEDATAMODEL__
|#

(require-interface 'AEDataModel)
#|                                              ; $I AEDataModel.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __NOTIFICATION__

(require-interface 'Notification)               ; $I Notification.p
; $ENDC
; $IFC UNDEFINED __EVENTS__

(require-interface 'Events)                     ; $I Events.p
; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; *************************************************************************
;   AppleEvent callbacks. 
; *************************************************************************

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	AEIdleProcPtr = FUNCTION(VAR theEvent: EventRecord; VAR sleepTime: LONGINT; VAR mouseRgn: RgnHandle): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :aeidleprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	AEFilterProcPtr = FUNCTION(VAR theEvent: EventRecord; returnID: LONGINT; transactionID: LONGINT; {CONST}VAR sender: AEAddressDesc): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :aefilterprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :aeidleupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :aeidleupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :aefilterupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :aefilterupp (find-mactype ':pointer))
; $ENDC

; 	*************************************************************************
; 	  The next couple of calls are basic routines used to create, send,
; 	  and process AppleEvents. 
; 	*************************************************************************	
; 
; 	 *  AESend()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; CONST
(deftrap "_AESend" 
      ((theAppleEvent (:pointer :aedesc)) (reply (:pointer :aedesc)) (sendMode :signed-long) (sendPriority :signed-integer) (timeOutInTicks :signed-long) (idleProc :pointer) (filterProc :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 3351 theAppleEvent reply sendMode sendPriority timeOutInTicks idleProc filterProc))

; 
;  *  AEProcessAppleEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_AEProcessAppleEvent" 
      ((theEventRecord (:pointer :eventrecord)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 539 theEventRecord))

;  
;  Note: during event processing, an event handler may realize that it is likely
;  to exceed the client's timeout limit. Passing the reply to this
;  routine causes a wait event to be generated that asks the client
;  for more time. 
; 
; 
;  *  AEResetTimer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_AEResetTimer" 
      ((reply (:pointer :aedesc)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 537 reply))

; *************************************************************************
;   The following three calls are used to allow applications to behave
;   courteously when a user interaction such as a dialog box is needed. 
; *************************************************************************

(def-mactype :aeinteractallowed (find-mactype ':signed-byte))

(defconstant $kAEInteractWithSelf 0)
(defconstant $kAEInteractWithLocal 1)
(defconstant $kAEInteractWithAll 2)

; 
; 	 *  AEGetInteractionAllowed()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_AEGetInteractionAllowed" 
      ((level (:pointer :signed-byte)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 541 level))

; 
;  *  AESetInteractionAllowed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AESetInteractionAllowed" 
      ((level :signed-byte))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 286 level))

; 
;  *  AEInteractWithUser()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AEInteractWithUser" 
      ((timeOutInTicks :signed-long) (nmReqPtr (:pointer :nmrec)) (idleProc :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 1564 timeOutInTicks nmReqPtr idleProc))

; *************************************************************************
;  The following four calls are available for applications which need more
;  sophisticated control over when and how events are processed. Applications
;  which implement multi-session servers or which implement their own
;  internal event queueing will probably be the major clients of these
;  routines. They can be called from within a handler to prevent the AEM from
;  disposing of the AppleEvent when the handler returns. They can be used to
;  asynchronously process the event (as MacApp does).
; *************************************************************************
; 
;  *  AESuspendTheCurrentEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_AESuspendTheCurrentEvent" 
      ((theAppleEvent (:pointer :aedesc)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 555 theAppleEvent))

;  
;  Note: The following routine tells the AppleEvent manager that processing
;  is either about to resume or has been completed on a previously suspended
;  event. The procPtr passed in as the dispatcher parameter will be called to
;  attempt to redispatch the event. Several constants for the dispatcher
;  parameter allow special behavior. They are:
;     - kAEUseStandardDispatch means redispatch as if the event was just
;       received, using the standard AppleEvent dispatch mechanism.
;     - kAENoDispatch means ignore the parameter.
;       Use this in the case where the event has been handled and no
;       redispatch is needed.
;     - non nil means call the routine which the dispatcher points to.
; 
;  Constants for Refcon in AEResumeTheCurrentEvent with kAEUseStandardDispatch 

(defconstant $kAEDoNotIgnoreHandler #x0)
(defconstant $kAEIgnoreAppPhacHandler #x1)      ;   available only in vers 1.0.1 and greater  
(defconstant $kAEIgnoreAppEventHandler #x2)     ;   available only in vers 1.0.1 and greater  
(defconstant $kAEIgnoreSysPhacHandler #x4)      ;   available only in vers 1.0.1 and greater  
(defconstant $kAEIgnoreSysEventHandler #x8)     ;   available only in vers 1.0.1 and greater  
(defconstant $kAEIngoreBuiltInEventHandler #x10);   available only in vers 1.0.1 and greater  
(defconstant $kAEDontDisposeOnResume #x80000000);   available only in vers 1.0.1 and greater  

; 	 Constants for AEResumeTheCurrentEvent 	
(defconstant $kAENoDispatch 0)                  ;   dispatch parameter to AEResumeTheCurrentEvent takes a pointer to a dispatch  
(defconstant $kAEUseStandardDispatch #xFFFFFFFF);   table, or one of these two constants  

; 
; 	 *  AEResumeTheCurrentEvent()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; CONST                                         ; CONST
(deftrap "_AEResumeTheCurrentEvent" 
      ((theAppleEvent (:pointer :aedesc)) (reply (:pointer :aedesc)) (dispatcher :pointer) (handlerRefcon :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 2072 theAppleEvent reply dispatcher handlerRefcon))

; 
;  *  AEGetTheCurrentEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AEGetTheCurrentEvent" 
      ((theAppleEvent (:pointer :aedesc)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 538 theAppleEvent))

; 
;  *  AESetTheCurrentEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_AESetTheCurrentEvent" 
      ((theAppleEvent (:pointer :aedesc)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 556 theAppleEvent))

; *************************************************************************
;   AppleEvent callbacks. 
; *************************************************************************

(defconstant $uppAEIdleProcInfo #xFD0)
(defconstant $uppAEFilterProcInfo #x3FD0)
; 
; 	 *  NewAEIdleUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewAEIdleProc 
(deftrap "_NewAEIdleUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewAEFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewAEFilterProc 
(deftrap "_NewAEFilterUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeAEIdleUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeAEIdleUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeAEFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeAEFilterUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeAEIdleUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallAEIdleProc 
(deftrap-inline "_InvokeAEIdleUPP" 
      ((theEvent (:pointer :eventrecord)) (sleepTime (:pointer :signed-long)) (mouseRgn (:pointer (:handle :macregion))) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; 
;  *  InvokeAEFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ;  old name was CallAEFilterProc 
(deftrap-inline "_InvokeAEFilterUPP" 
      ((theEvent (:pointer :eventrecord)) (returnID :signed-long) (transactionID :signed-long) (sender (:pointer :aedesc)) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := AEInteractionIncludes

; $ENDC                                         ; __AEINTERACTION__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'AEInteraction)