(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:ASDebugging.p"
; at Wednesday May 1,2002 2:40:50 pm.
; 
;      File:       ASDebugging.p
;  
;      Contains:   AppleScript Debugging Interfaces.
;  
;      Version:    Technology: AppleScript 1.1
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1992-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __ASDEBUGGING__
; $SETC __ASDEBUGGING__ := 1

; $I+
; $SETC ASDebuggingIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __COMPONENTS__
|#

(require-interface 'Components)
#|                                              ; $I Components.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __APPLEEVENTS__
|#

(require-interface 'AppleEvents)
#|                                              ; $I AppleEvents.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __APPLESCRIPT__
|#

(require-interface 'AppleScript)
#|                                              ; $I AppleScript.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; *************************************************************************
;     Mode Flags
; *************************************************************************
;     This mode flag can be passed to OSASetProperty or OSASetHandler
;     and will prevent properties or handlers from being defined in a context
;     that doesn't already have bindings for them. An error is returned if
;     a current binding doesn't already exist. 
; 

(defconstant $kOSAModeDontDefine #x1)

; 	*************************************************************************
; 	    Component Selectors
; 	*************************************************************************	
(defconstant $kASSelectSetPropertyObsolete #x1101)
(defconstant $kASSelectGetPropertyObsolete #x1102)
(defconstant $kASSelectSetHandlerObsolete #x1103)
(defconstant $kASSelectGetHandlerObsolete #x1104)
(defconstant $kASSelectGetAppTerminologyObsolete #x1105)
(defconstant $kASSelectSetProperty #x1106)
(defconstant $kASSelectGetProperty #x1107)
(defconstant $kASSelectSetHandler #x1108)
(defconstant $kASSelectGetHandler #x1109)
(defconstant $kASSelectGetAppTerminology #x110A)
(defconstant $kASSelectGetSysTerminology #x110B)
(defconstant $kASSelectGetPropertyNames #x110C)
(defconstant $kASSelectGetHandlerNames #x110D)

; 	*************************************************************************
; 	    Context Accessors
; 	*************************************************************************	
; 
; 	 *  OSASetProperty()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; CONST
(deftrap "_OSASetProperty" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (modeFlags :signed-long) (contextID :unsigned-long) (variableName (:pointer :aedesc)) (scriptValueID :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent modeFlags contextID variableName scriptValueID ((+ (ash 16 16) 4358) :signed-longint)))

; 
;  *  OSAGetProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_OSAGetProperty" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (modeFlags :signed-long) (contextID :unsigned-long) (variableName (:pointer :aedesc)) (resultingScriptValueID (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent modeFlags contextID variableName resultingScriptValueID ((+ (ash 16 16) 4359) :signed-longint)))

; 
;  *  OSAGetPropertyNames()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSAGetPropertyNames" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (modeFlags :signed-long) (contextID :unsigned-long) (resultingPropertyNames (:pointer :aedesc)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent modeFlags contextID resultingPropertyNames ((+ (ash 12 16) 4364) :signed-longint)))

; 
;  *  OSASetHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_OSASetHandler" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (modeFlags :signed-long) (contextID :unsigned-long) (handlerName (:pointer :aedesc)) (compiledScriptID :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent modeFlags contextID handlerName compiledScriptID ((+ (ash 16 16) 4360) :signed-longint)))

; 
;  *  OSAGetHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_OSAGetHandler" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (modeFlags :signed-long) (contextID :unsigned-long) (handlerName (:pointer :aedesc)) (resultingCompiledScriptID (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent modeFlags contextID handlerName resultingCompiledScriptID ((+ (ash 16 16) 4361) :signed-longint)))

; 
;  *  OSAGetHandlerNames()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSAGetHandlerNames" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (modeFlags :signed-long) (contextID :unsigned-long) (resultingHandlerNames (:pointer :aedesc)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent modeFlags contextID resultingHandlerNames ((+ (ash 12 16) 4365) :signed-longint)))

; 
;  *  OSAGetAppTerminology()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSAGetAppTerminology" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (modeFlags :signed-long) (fileSpec (:pointer :fsspec)) (terminologyID :signed-integer) (didLaunch (:pointer :boolean)) (terminologyList (:pointer :aedesc)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent modeFlags fileSpec terminologyID didLaunch terminologyList ((+ (ash 18 16) 4362) :signed-longint)))

;  Errors:
;        errOSASystemError        operation failed
;     
; 
;  *  OSAGetSysTerminology()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSAGetSysTerminology" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (modeFlags :signed-long) (terminologyID :signed-integer) (terminologyList (:pointer :aedesc)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent modeFlags terminologyID terminologyList ((+ (ash 10 16) 4363) :signed-longint)))

;  Errors:
;        errOSASystemError        operation failed
;     
;  Notes on terminology ID
; 
;     A terminology ID is derived from script code and language code
;     as follows;
; 
;         terminologyID = ((scriptCode & 0x7F) << 8) | (langCode & 0xFF)
; 
; *************************************************************************
;     Obsolete versions provided for backward compatibility:
; 
; 
;  *  ASSetProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_ASSetProperty" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (contextID :unsigned-long) (variableName (:pointer :aedesc)) (scriptValueID :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent contextID variableName scriptValueID ((+ (ash 12 16) 4353) :signed-longint)))

; 
;  *  ASGetProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_ASGetProperty" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (contextID :unsigned-long) (variableName (:pointer :aedesc)) (resultingScriptValueID (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent contextID variableName resultingScriptValueID ((+ (ash 12 16) 4354) :signed-longint)))

; 
;  *  ASSetHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_ASSetHandler" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (contextID :unsigned-long) (handlerName (:pointer :aedesc)) (compiledScriptID :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent contextID handlerName compiledScriptID ((+ (ash 12 16) 4355) :signed-longint)))

; 
;  *  ASGetHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_ASGetHandler" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (contextID :unsigned-long) (handlerName (:pointer :aedesc)) (resultingCompiledScriptID (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent contextID handlerName resultingCompiledScriptID ((+ (ash 12 16) 4356) :signed-longint)))

; 
;  *  ASGetAppTerminology()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ASGetAppTerminology" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (fileSpec (:pointer :fsspec)) (terminologID :signed-integer) (didLaunch (:pointer :boolean)) (terminologyList (:pointer :aedesc)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent fileSpec terminologID didLaunch terminologyList ((+ (ash 14 16) 4357) :signed-longint)))

;  Errors:
;         errOSASystemError       operation failed
;     
; ************************************************************************

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := ASDebuggingIncludes

; $ENDC                                         ; __ASDEBUGGING__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'ASDebugging)