(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:ASRegistry.p"
; at Wednesday May 1,2002 2:40:50 pm.
; 
;      File:       ASRegistry.p
;  
;      Contains:   AppleScript Registry constants.
;  
;      Version:    Technology: AppleScript 1.3
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1991-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __ASREGISTRY__
; $SETC __ASREGISTRY__ := 1

; $I+
; $SETC ASRegistryIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __AEREGISTRY__
|#

(require-interface 'AERegistry)
#|                                              ; $I AERegistry.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __AEOBJECTS__
|#

(require-interface 'AEObjects)
#|                                              ; $I AEObjects.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $keyAETarget :|targ|)
(defconstant $keySubjectAttr :|subj|)           ;   Magic 'returning' parameter:  
(defconstant $keyASReturning :|Krtn|)           ;   AppleScript Specific Codes:  
(defconstant $kASAppleScriptSuite :|ascr|)
(defconstant $kASScriptEditorSuite :|ToyS|)
(defconstant $kASTypeNamesSuite :|tpnm|)        ;   dynamic terminologies  
(defconstant $typeAETE :|aete|)
(defconstant $typeAEUT :|aeut|)
(defconstant $kGetAETE :|gdte|)
(defconstant $kGetAEUT :|gdut|)
(defconstant $kUpdateAEUT :|udut|)
(defconstant $kUpdateAETE :|udte|)
(defconstant $kCleanUpAEUT :|cdut|)
(defconstant $kASComment :|cmnt|)
(defconstant $kASLaunchEvent :|noop|)
(defconstant $keyScszResource :|scsz|)
(defconstant $typeScszResource :|scsz|)         ;   subroutine calls  
(defconstant $kASSubroutineEvent :|psbr|)
(defconstant $keyASSubroutineName :|snam|)
(defconstant $kASPrepositionalSubroutine :|psbr|)
(defconstant $keyASPositionalArgs :|parg|)

;   Add this parameter to a Get Data result if your app handled the 'as' parameter  
(defconstant $keyAppHandledCoercion :|idas|)

;   Miscellaneous AppleScript commands  
(defconstant $kASStartLogEvent :|log1|)
(defconstant $kASStopLogEvent :|log0|)
(defconstant $kASCommentEvent :|cmnt|)

; 	 Operator Events: 	
;   Binary:  
(defconstant $kASAdd :|+   |)
(defconstant $kASSubtract :|-   |)
(defconstant $kASMultiply :|*   |)
(defconstant $kASDivide :|/   |)
(defconstant $kASQuotient :|div |)
(defconstant $kASRemainder :|mod |)
(defconstant $kASPower :|^   |)
(defconstant $kASEqual :|=   |)
(defconstant $kASNotEqual :|   |)
(defconstant $kASGreaterThan :|>   |)
(defconstant $kASGreaterThanOrEqual :|>=  |)
(defconstant $kASLessThan :|<   |)
(defconstant $kASLessThanOrEqual :|<=  |)
(defconstant $kASComesBefore :|cbfr|)
(defconstant $kASComesAfter :|cafr|)
(defconstant $kASConcatenate :|ccat|)
(defconstant $kASStartsWith :|bgwt|)
(defconstant $kASEndsWith :|ends|)
(defconstant $kASContains :|cont|)

(defconstant $kASAnd :|AND |)
(defconstant $kASOr :|OR  |)                    ;   Unary:  
(defconstant $kASNot :|NOT |)
(defconstant $kASNegate :|neg |)
(defconstant $keyASArg :|arg |)

;   event code for the 'error' statement  
(defconstant $kASErrorEventCode :|err |)
(defconstant $kOSAErrorArgs :|erra|)
(defconstant $keyAEErrorObject :|erob|)         ;   Properties:  
(defconstant $pLength :|leng|)
(defconstant $pReverse :|rvse|)
(defconstant $pRest :|rest|)
(defconstant $pInherits :|c@#^|)
(defconstant $pProperties :|pALL|)              ;   User-Defined Record Fields:  
(defconstant $keyASUserRecordFields :|usrf|)
(defconstant $typeUserRecordFields :|list|)

; 	 Prepositions: 	
(defconstant $keyASPrepositionAt :|at  |)
(defconstant $keyASPrepositionIn :|in  |)
(defconstant $keyASPrepositionFrom :|from|)
(defconstant $keyASPrepositionFor :|for |)
(defconstant $keyASPrepositionTo :|to  |)
(defconstant $keyASPrepositionThru :|thru|)
(defconstant $keyASPrepositionThrough :|thgh|)
(defconstant $keyASPrepositionBy :|by  |)
(defconstant $keyASPrepositionOn :|on  |)
(defconstant $keyASPrepositionInto :|into|)
(defconstant $keyASPrepositionOnto :|onto|)
(defconstant $keyASPrepositionBetween :|btwn|)
(defconstant $keyASPrepositionAgainst :|agst|)
(defconstant $keyASPrepositionOutOf :|outo|)
(defconstant $keyASPrepositionInsteadOf :|isto|)
(defconstant $keyASPrepositionAsideFrom :|asdf|)
(defconstant $keyASPrepositionAround :|arnd|)
(defconstant $keyASPrepositionBeside :|bsid|)
(defconstant $keyASPrepositionBeneath :|bnth|)
(defconstant $keyASPrepositionUnder :|undr|)

(defconstant $keyASPrepositionOver :|over|)
(defconstant $keyASPrepositionAbove :|abve|)
(defconstant $keyASPrepositionBelow :|belw|)
(defconstant $keyASPrepositionApartFrom :|aprt|)
(defconstant $keyASPrepositionGiven :|givn|)
(defconstant $keyASPrepositionWith :|with|)
(defconstant $keyASPrepositionWithout :|wout|)
(defconstant $keyASPrepositionAbout :|abou|)
(defconstant $keyASPrepositionSince :|snce|)
(defconstant $keyASPrepositionUntil :|till|)

;   Terminology & Dialect things:  
(defconstant $kDialectBundleResType :|Dbdl|)    ;   AppleScript Classes and Enums:  
(defconstant $cConstant :|enum|)
(defconstant $cClassIdentifier :|pcls|)
(defconstant $cObjectBeingExamined :|exmn|)
(defconstant $cList :|list|)
(defconstant $cSmallReal :|sing|)
(defconstant $cReal :|doub|)
(defconstant $cRecord :|reco|)
(defconstant $cReference :|obj |)
(defconstant $cUndefined :|undf|)
(defconstant $cMissingValue :|msng|)
(defconstant $cSymbol :|symb|)
(defconstant $cLinkedList :|llst|)
(defconstant $cVector :|vect|)
(defconstant $cEventIdentifier :|evnt|)
(defconstant $cKeyIdentifier :|kyid|)
(defconstant $cUserIdentifier :|uid |)
(defconstant $cPreposition :|prep|)
(defconstant $cKeyForm :|kfrm|)
(defconstant $cScript :|scpt|)
(defconstant $cHandler :|hand|)
(defconstant $cProcedure :|proc|)

(defconstant $cHandleBreakpoint :|brak|)

(defconstant $cClosure :|clsr|)
(defconstant $cRawData :|rdat|)
(defconstant $cStringClass :|TEXT|)
(defconstant $cNumber :|nmbr|)
(defconstant $cListElement :|celm|)
(defconstant $cListOrRecord :|lr  |)
(defconstant $cListOrString :|ls  |)
(defconstant $cListRecordOrString :|lrs |)
(defconstant $cNumberOrString :|ns  |)
(defconstant $cNumberOrDateTime :|nd  |)
(defconstant $cNumberDateTimeOrString :|nds |)
(defconstant $cAliasOrString :|sf  |)
(defconstant $cSeconds :|scnd|)
(defconstant $typeSound :|snd |)
(defconstant $enumBooleanValues :|boov|)        ;    Use this instead of typeBoolean to avoid with/without conversion   
(defconstant $kAETrue :|true|)
(defconstant $kAEFalse :|fals|)
(defconstant $enumMiscValues :|misc|)
(defconstant $kASCurrentApplication :|cura|)    ;   User-defined property ospecs:  
(defconstant $formUserPropertyID :|usrp|)

(defconstant $cString :|TEXT|)                  ;   old name for cStringClass - can't be used in .r files 

;   Global properties:  
(defconstant $pASIt :|it  |)
(defconstant $pASMe :|me  |)
(defconstant $pASResult :|rslt|)
(defconstant $pASSpace :|spac|)
(defconstant $pASReturn :|ret |)
(defconstant $pASTab :|tab |)
(defconstant $pASPi :|pi  |)
(defconstant $pASParent :|pare|)
(defconstant $kASInitializeEventCode :|init|)
(defconstant $pASPrintLength :|prln|)
(defconstant $pASPrintDepth :|prdp|)
(defconstant $pASTopLevelScript :|ascr|)

;   Considerations  
(defconstant $kAECase :|case|)
(defconstant $kAEDiacritic :|diac|)
(defconstant $kAEWhiteSpace :|whit|)
(defconstant $kAEHyphens :|hyph|)
(defconstant $kAEExpansion :|expa|)
(defconstant $kAEPunctuation :|punc|)
(defconstant $kAEZenkakuHankaku :|zkhk|)
(defconstant $kAESmallKana :|skna|)
(defconstant $kAEKataHiragana :|hika|)
(defconstant $kASConsiderReplies :|rmte|)
(defconstant $enumConsiderations :|cons|)

; 	 Considerations bit masks 	
(defconstant $kAECaseConsiderMask #x1)
(defconstant $kAEDiacriticConsiderMask #x2)
(defconstant $kAEWhiteSpaceConsiderMask #x4)
(defconstant $kAEHyphensConsiderMask #x8)
(defconstant $kAEExpansionConsiderMask #x10)
(defconstant $kAEPunctuationConsiderMask #x20)
(defconstant $kASConsiderRepliesConsiderMask #x40)
(defconstant $kAECaseIgnoreMask #x10000)
(defconstant $kAEDiacriticIgnoreMask #x20000)
(defconstant $kAEWhiteSpaceIgnoreMask #x40000)
(defconstant $kAEHyphensIgnoreMask #x80000)
(defconstant $kAEExpansionIgnoreMask #x100000)
(defconstant $kAEPunctuationIgnoreMask #x200000)
(defconstant $kASConsiderRepliesIgnoreMask #x400000)
(defconstant $enumConsidsAndIgnores :|csig|)

(defconstant $cCoercion :|coec|)
(defconstant $cCoerceUpperCase :|txup|)
(defconstant $cCoerceLowerCase :|txlo|)
(defconstant $cCoerceRemoveDiacriticals :|txdc|)
(defconstant $cCoerceRemovePunctuation :|txpc|)
(defconstant $cCoerceRemoveHyphens :|txhy|)
(defconstant $cCoerceOneByteToTwoByte :|txex|)
(defconstant $cCoerceRemoveWhiteSpace :|txws|)
(defconstant $cCoerceSmallKana :|txsk|)
(defconstant $cCoerceZenkakuhankaku :|txze|)
(defconstant $cCoerceKataHiragana :|txkh|)      ;   Lorax things:  
(defconstant $cZone :|zone|)
(defconstant $cMachine :|mach|)
(defconstant $cAddress :|addr|)
(defconstant $cRunningAddress :|radd|)
(defconstant $cStorage :|stor|)

;   DateTime things:  
(defconstant $pASWeekday :|wkdy|)
(defconstant $pASMonth :|mnth|)
(defconstant $pASDay :|day |)
(defconstant $pASYear :|year|)
(defconstant $pASTime :|time|)
(defconstant $pASDateString :|dstr|)
(defconstant $pASTimeString :|tstr|)            ;   Months  
(defconstant $cMonth :|mnth|)
(defconstant $cJanuary :|jan |)
(defconstant $cFebruary :|feb |)
(defconstant $cMarch :|mar |)
(defconstant $cApril :|apr |)
(defconstant $cMay :|may |)
(defconstant $cJune :|jun |)
(defconstant $cJuly :|jul |)
(defconstant $cAugust :|aug |)
(defconstant $cSeptember :|sep |)
(defconstant $cOctober :|oct |)
(defconstant $cNovember :|nov |)
(defconstant $cDecember :|dec |)

;   Weekdays  
(defconstant $cWeekday :|wkdy|)
(defconstant $cSunday :|sun |)
(defconstant $cMonday :|mon |)
(defconstant $cTuesday :|tue |)
(defconstant $cWednesday :|wed |)
(defconstant $cThursday :|thu |)
(defconstant $cFriday :|fri |)
(defconstant $cSaturday :|sat |)                ;   AS 1.1 Globals:  
(defconstant $pASQuote :|quot|)
(defconstant $pASSeconds :|secs|)
(defconstant $pASMinutes :|min |)
(defconstant $pASHours :|hour|)
(defconstant $pASDays :|days|)
(defconstant $pASWeeks :|week|)                 ;   Writing Code things:  
(defconstant $cWritingCodeInfo :|citl|)
(defconstant $pScriptCode :|pscd|)
(defconstant $pLangCode :|plcd|)                ;   Magic Tell and End Tell events for logging:  
(defconstant $kASMagicTellEvent :|tell|)
(defconstant $kASMagicEndTellEvent :|tend|)

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := ASRegistryIncludes

; $ENDC                                         ; __ASREGISTRY__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'ASRegistry)