(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:ATSFont.p"
; at Wednesday May 1,2002 2:40:29 pm.
; 
;      File:       ATSFont.p
;  
;      Contains:   Public interface to the font access and data management functions of ATS.
;  
;      Version:    Technology: Mac OS
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   2000-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __ATSFONT__
; $SETC __ATSFONT__ := 1

; $I+
; $SETC ATSFontIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __ATSTYPES__
|#

(require-interface 'ATSTypes)
#|                                              ; $I ATSTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFSTRING__
|#

(require-interface 'CFString)
#|                                              ; $I CFString.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __TEXTCOMMON__
|#

(require-interface 'TextCommon)
#|                                              ; $I TextCommon.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __SFNTTYPES__

(require-interface 'SFNTTypes)                  ; $I SFNTTypes.p
; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $kATSOptionFlagsDefault 0)
(defconstant $kATSOptionFlagsComposeFontPostScriptName #x1);   ATSFontGetPostScriptName  
(defconstant $kATSOptionFlagsUseDataForkAsResourceFork #x100);   ATSFontActivateFromFileSpecification  
(defconstant $kATSOptionFlagsUseResourceFork #x200)
(defconstant $kATSOptionFlagsUseDataFork #x300)

(defconstant $kATSIterationCompleted -980)
(defconstant $kATSInvalidFontFamilyAccess -981)
(defconstant $kATSInvalidFontAccess -982)
(defconstant $kATSIterationScopeModified -983)
(defconstant $kATSInvalidFontTableAccess -984)
(defconstant $kATSInvalidFontContainerAccess -985)

(def-mactype :atsfontcontext (find-mactype ':unsigned-long))

(defconstant $kATSFontContextUnspecified 0)
(defconstant $kATSFontContextGlobal 1)

(def-mactype :atsfontformat (find-mactype ':unsigned-long))

(defconstant $kATSFontFormatUnspecified 0)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ATSFontFamilyApplierFunction = FUNCTION(iFamily: ATSFontFamilyRef; iRefCon: UNIV Ptr): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :atsfontfamilyapplierfunction (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ATSFontApplierFunction = FUNCTION(iFont: ATSFontRef; iRefCon: UNIV Ptr): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :atsfontapplierfunction (find-mactype ':pointer))
; $ENDC

(def-mactype :atsfontfamilyiterator (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :atsfontfamilyiteratorptr (find-mactype '(:pointer :pointer)));  when a VAR xx:ATSFontFamilyIterator parameter can be nil, it is changed to xx: ATSFontFamilyIteratorPtr 
(def-mactype :atsfontiterator (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :atsfontiteratorptr (find-mactype '(:pointer :pointer)));  when a VAR xx:ATSFontIterator parameter can be nil, it is changed to xx: ATSFontIteratorPtr 

(defconstant $kATSFontFilterCurrentVersion 0)

(def-mactype :atsfontfilterselector (find-mactype ':signed-long))

(defconstant $kATSFontFilterSelectorUnspecified 0)
(defconstant $kATSFontFilterSelectorGeneration 3)
(defconstant $kATSFontFilterSelectorFontFamily 7)
(defconstant $kATSFontFilterSelectorFontFamilyApplierFunction 8)
(defconstant $kATSFontFilterSelectorFontApplierFunction 9)

(def-mactype :atsfontfilterptr (find-mactype '(:pointer :atsfontfilter)))
(defrecord ATSFontFilter 
   (version :unsigned-long)
   (filterSelector :signed-long)
   (:variant 
      (
      (generationFilter :unsigned-long)
      )
      (
      (fontFamilyFilter :unsigned-long)
      )
      (
      (fontFamilyApplierFunctionFilter :pointer)
      )
      (
      (fontApplierFunctionFilter :pointer)
      )
      )
   )

; 	 ----------------------------------------------------------------------------------------- 	
; 	 Font container                                                                            	
; 	 ----------------------------------------------------------------------------------------- 	
; 
; 	 *  ATSGetGeneration()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_ATSGetGeneration" 
      () 
  :unsigned-long
   () )

; 
;  *  ATSFontActivateFromFileSpecification()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_ATSFontActivateFromFileSpecification" 
      ((iFile (:pointer :fsspec)) (iContext :unsigned-long) (iFormat :unsigned-long) (iReserved :pointer) (iOptions :unsigned-long) (oContainer (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSFontActivateFromMemory()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontActivateFromMemory" 
      ((iData :pointer) (iLength :unsigned-long) (iContext :unsigned-long) (iFormat :unsigned-long) (iReserved :pointer) (iOptions :unsigned-long) (oContainer (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSFontDeactivate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontDeactivate" 
      ((iContainer :unsigned-long) (iRefCon :pointer) (iOptions :unsigned-long)) 
  :osstatus
   () )

;  ----------------------------------------------------------------------------------------- 
;  Font family                                                                               
;  ----------------------------------------------------------------------------------------- 
; 
;  *  ATSFontFamilyApplyFunction()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontFamilyApplyFunction" 
      ((iFunction :pointer) (iRefCon :pointer)) 
  :osstatus
   () )

; 
;  *  ATSFontFamilyIteratorCreate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const
(deftrap-inline "_ATSFontFamilyIteratorCreate" 
      ((iContext :unsigned-long) (iFilter (:pointer :atsfontfilter)) (iRefCon :pointer) (iOptions :unsigned-long) (ioIterator (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ATSFontFamilyIteratorRelease()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontFamilyIteratorRelease" 
      ((ioIterator (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ATSFontFamilyIteratorReset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const
(deftrap-inline "_ATSFontFamilyIteratorReset" 
      ((iContext :unsigned-long) (iFilter (:pointer :atsfontfilter)) (iRefCon :pointer) (iOptions :unsigned-long) (ioIterator (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ATSFontFamilyIteratorNext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontFamilyIteratorNext" 
      ((iIterator :pointer) (oFamily (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSFontFamilyFindFromName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontFamilyFindFromName" 
      ((iName :pointer) (iOptions :unsigned-long)) 
  :unsigned-long
   () )

; 
;  *  ATSFontFamilyGetGeneration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontFamilyGetGeneration" 
      ((iFamily :unsigned-long)) 
  :unsigned-long
   () )

; 
;  *  ATSFontFamilyGetName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontFamilyGetName" 
      ((iFamily :unsigned-long) (iOptions :unsigned-long) (oName (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ATSFontFamilyGetEncoding()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontFamilyGetEncoding" 
      ((iFamily :unsigned-long)) 
  :unsigned-long
   () )

;  ----------------------------------------------------------------------------------------- 
;  Font                                                                                      
;  ----------------------------------------------------------------------------------------- 
; 
;  *  ATSFontApplyFunction()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontApplyFunction" 
      ((iFunction :pointer) (iRefCon :pointer)) 
  :osstatus
   () )

; 
;  *  ATSFontIteratorCreate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const
(deftrap-inline "_ATSFontIteratorCreate" 
      ((iContext :unsigned-long) (iFilter (:pointer :atsfontfilter)) (iRefCon :pointer) (iOptions :unsigned-long) (ioIterator (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ATSFontIteratorRelease()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontIteratorRelease" 
      ((ioIterator (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ATSFontIteratorReset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const
(deftrap-inline "_ATSFontIteratorReset" 
      ((iContext :unsigned-long) (iFilter (:pointer :atsfontfilter)) (iRefCon :pointer) (iOptions :unsigned-long) (ioIterator (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ATSFontIteratorNext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontIteratorNext" 
      ((iIterator :pointer) (oFont (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSFontFindFromName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontFindFromName" 
      ((iName :pointer) (iOptions :unsigned-long)) 
  :unsigned-long
   () )

; 
;  *  ATSFontFindFromPostScriptName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontFindFromPostScriptName" 
      ((iName :pointer) (iOptions :unsigned-long)) 
  :unsigned-long
   () )

; 
;  *  ATSFontFindFromContainer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontFindFromContainer" 
      ((iContainer :unsigned-long) (iOptions :unsigned-long) (iCount :unsigned-long) (ioArray (:pointer :unsigned-long)) (oCount (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSFontGetGeneration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontGetGeneration" 
      ((iFont :unsigned-long)) 
  :unsigned-long
   () )

; 
;  *  ATSFontGetName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontGetName" 
      ((iFont :unsigned-long) (iOptions :unsigned-long) (oName (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ATSFontGetPostScriptName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontGetPostScriptName" 
      ((iFont :unsigned-long) (iOptions :unsigned-long) (oName (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ATSFontGetTableDirectory()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontGetTableDirectory" 
      ((iFont :unsigned-long) (iBufferSize :unsigned-long) (ioBuffer :pointer) (oSize (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSFontGetTable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontGetTable" 
      ((iFont :unsigned-long) (iTag :ostype) (iOffset :unsigned-long) (iBufferSize :unsigned-long) (ioBuffer :pointer) (oSize (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSFontGetHorizontalMetrics()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontGetHorizontalMetrics" 
      ((iFont :unsigned-long) (iOptions :unsigned-long) (oMetrics (:pointer :atsfontmetrics))) 
  :osstatus
   () )

; 
;  *  ATSFontGetVerticalMetrics()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontGetVerticalMetrics" 
      ((iFont :unsigned-long) (iOptions :unsigned-long) (oMetrics (:pointer :atsfontmetrics))) 
  :osstatus
   () )

;  ----------------------------------------------------------------------------------------- 
;  Compatibiity                                                                              
;  ----------------------------------------------------------------------------------------- 
; 
;  *  ATSFontFamilyFindFromQuickDrawName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontFamilyFindFromQuickDrawName" 
      ((iName (:string 255))) 
  :unsigned-long
   () )

; 
;  *  ATSFontFamilyGetQuickDrawName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontFamilyGetQuickDrawName" 
      ((iFamily :unsigned-long) (oName (:pointer (:string 255)))) 
  :osstatus
   () )

; 
;  *  ATSFontGetFileSpecification()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontGetFileSpecification" 
      ((iFont :unsigned-long) (oFile (:pointer :fsspec))) 
  :osstatus
   () )

; 
;  *  ATSFontGetFontFamilyResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSFontGetFontFamilyResource" 
      ((iFont :unsigned-long) (iBufferSize :unsigned-long) (ioBuffer :pointer) (oSize (:pointer :unsigned-long))) 
  :osstatus
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := ATSFontIncludes

; $ENDC                                         ; __ATSFONT__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'ATSFont)