(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:ATSTypes.p"
; at Wednesday May 1,2002 2:39:38 pm.
; 
;      File:       ATSTypes.p
;  
;      Contains:   Public interfaces for Apple Type Services components.
;  
;      Version:    Technology: Mac OS 9 / Carbon
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1997-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __ATSTYPES__
; $SETC __ATSTYPES__ := 1

; $I+
; $SETC ATSTypesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :fmgeneration (find-mactype ':unsigned-long))
; 	 The FMFontFamily reference represents a collection of fonts with the same design
; 	   characteristics. It replaces the standard QuickDraw font identifer and may be used
; 	   with all QuickDraw functions including GetFontName and TextFont. It cannot be used
; 	   with the Resource Manager to access information from a FOND resource handle. A font
; 	   reference does not imply a particular script system, nor is the character encoding
; 	   of a font family determined by an arithmetic mapping of its value.
; 		
(def-mactype :fmfontfamily (find-mactype ':signed-integer))
(def-mactype :fmfontstyle (find-mactype ':signed-integer))
(def-mactype :fmfontsize (find-mactype ':signed-integer))
; 	 
; 	   The font family is a collection of fonts, each of which is identified
; 	   by an FMFont reference that maps to a single object registered with
; 	   the font database. The font references associated with the font
; 	   family consist of individual outline and bitmapped fonts that may be
; 	   used with the font access routines of the Font Manager and ATS.
; 		
(def-mactype :fmfont (find-mactype ':unsigned-long))
(def-mactype :fmfontfamilyinstanceptr (find-mactype '(:pointer :fmfontfamilyinstance)))
(defrecord FMFontFamilyInstance 
   (fontFamily :signed-integer)
   (fontStyle :signed-integer)
   )

(def-mactype :fmfontfamilyiteratorptr (find-mactype '(:pointer :fmfontfamilyiterator)))
(defrecord FMFontFamilyIterator 
   (reserved (:array :unsigned-long 16))
   )

(def-mactype :fmfontiteratorptr (find-mactype '(:pointer :fmfontiterator)))
(defrecord FMFontIterator 
   (reserved (:array :unsigned-long 16))
   )

(def-mactype :fmfontfamilyinstanceiteratorptr (find-mactype '(:pointer :fmfontfamilyinstanceiterator)))
(defrecord FMFontFamilyInstanceIterator 
   (reserved (:array :unsigned-long 16))
   )

(defconstant $kInvalidGeneration 0)
(defconstant $kInvalidFontFamily -1)
(defconstant $kInvalidFont 0)

(defconstant $kFMCurrentFilterFormat 0)

; 	 kFMDefaultOptions & kFMUseGlobalScopeOption moved to Fonts.h 	

(def-mactype :fmfilterselector (find-mactype ':unsigned-long))

(defconstant $kFMFontTechnologyFilterSelector 1)
(defconstant $kFMFontContainerFilterSelector 2)
(defconstant $kFMGenerationFilterSelector 3)
(defconstant $kFMFontFamilyCallbackFilterSelector 4)
(defconstant $kFMFontCallbackFilterSelector 5)
(defconstant $kFMFontDirectoryFilterSelector 6)

(defconstant $kFMTrueTypeFontTechnology :|true|)
(defconstant $kFMPostScriptFontTechnology :|typ1|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	FMFontFamilyCallbackFilterProcPtr = FUNCTION(iFontFamily: FMFontFamily; iRefCon: UNIV Ptr): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :fmfontfamilycallbackfilterprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	FMFontCallbackFilterProcPtr = FUNCTION(iFont: FMFont; iRefCon: UNIV Ptr): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :fmfontcallbackfilterprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :fmfontfamilycallbackfilterupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :fmfontfamilycallbackfilterupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :fmfontcallbackfilterupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :fmfontcallbackfilterupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppFMFontFamilyCallbackFilterProcInfo #x3B0)
(defconstant $uppFMFontCallbackFilterProcInfo #x3F0)
; 
; 	 *  NewFMFontFamilyCallbackFilterUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewFMFontFamilyCallbackFilterProc 
(deftrap "_NewFMFontFamilyCallbackFilterUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewFMFontCallbackFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewFMFontCallbackFilterProc 
(deftrap "_NewFMFontCallbackFilterUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeFMFontFamilyCallbackFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeFMFontFamilyCallbackFilterUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeFMFontCallbackFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeFMFontCallbackFilterUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeFMFontFamilyCallbackFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallFMFontFamilyCallbackFilterProc 
(deftrap-inline "_InvokeFMFontFamilyCallbackFilterUPP" 
      ((iFontFamily :signed-integer) (iRefCon :pointer) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

; 
;  *  InvokeFMFontCallbackFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallFMFontCallbackFilterProc 
(deftrap-inline "_InvokeFMFontCallbackFilterUPP" 
      ((iFont :unsigned-long) (iRefCon :pointer) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

(def-mactype :fmfontdirectoryfilterptr (find-mactype '(:pointer :fmfontdirectoryfilter)))
(defrecord FMFontDirectoryFilter 
   (fontFolderDomain :signed-integer)
   (reserved (:array :unsigned-long 2))
   )

(def-mactype :fmfilterptr (find-mactype '(:pointer :fmfilter)))
(defrecord FMFilter 
   (format :unsigned-long)
   (selector :unsigned-long)
   (:variant 
      (
      (fontTechnologyFilter :ostype)
      )
      (
      (fontContainerFilter :fsspec)
      )
      (
      (generationFilter :unsigned-long)
      )
      (
      (fontFamilyCallbackFilter :pointer)
      )
      (
      (fontCallbackFilter :pointer)
      )
      (
      (fontDirectoryFilter :fmfontdirectoryfilter)
      )
      )
   )

(def-mactype :atsoptionflags (find-mactype ':unsigned-long))
(def-mactype :atsgeneration (find-mactype ':unsigned-long))
(def-mactype :atsfontcontainerref (find-mactype ':unsigned-long))
(def-mactype :atsfontfamilyref (find-mactype ':unsigned-long))
(def-mactype :atsfontref (find-mactype ':unsigned-long))
(def-mactype :atsglyphref (find-mactype ':unsigned-integer))
(def-mactype :atsfontsize (find-mactype ':single-float))

(defconstant $kATSGenerationUnspecified 0)
(defconstant $kATSFontContainerRefUnspecified 0)
(defconstant $kATSFontFamilyRefUnspecified 0)
(defconstant $kATSFontRefUnspecified 0)

(def-mactype :atsfontmetricsptr (find-mactype '(:pointer :atsfontmetrics)))
(defrecord ATSFontMetrics 
   (version :unsigned-long)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (ascent :single-float)                       ;   Maximum height above baseline reached by the glyphs in the font  
;   or maximum distance to the right of the centerline reached by the glyphs in the font  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (descent :single-float)                      ;   Maximum depth below baseline reached by the glyphs in the font  
;   or maximum distance to the left of the centerline reached by the glyphs in the font  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (leading :single-float)                      ;   Desired spacing between lines of text  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (avgAdvanceWidth :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (maxAdvanceWidth :single-float)              ;   Maximum advance width or height of the glyphs in the font  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (minLeftSideBearing :single-float)           ;   Minimum left or top side bearing  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (minRightSideBearing :single-float)          ;   Minimum right or bottom side bearing  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (stemWidth :single-float)                    ;   Width of the dominant vertical stems of the glyphs in the font  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (stemHeight :single-float)                   ;   Vertical width of the dominant horizontal stems of glyphs in the font  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (capHeight :single-float)                    ;   Height of a capital letter from the baseline to the top of the letter  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (xHeight :single-float)                      ;   Height of lowercase characters in a font, specifically the letter x, excluding ascenders and descenders  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (italicAngle :single-float)                  ;   Angle in degrees counterclockwise from the vertical of the dominant vertical strokes of the glyphs in the font  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (underlinePosition :single-float)            ;   Distance from the baseline for positioning underlining strokes  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (underlineThickness :single-float)           ;   Stroke width for underlining  
   )

(defconstant $kATSItalicQDSkew #x4000)          ;   fixed value of 0.25  
(defconstant $kATSBoldQDStretch #x18000)        ;   fixed value of 1.50  
(defconstant $kATSRadiansFactor 1144)           ;   fixed value of approx. pi/180 (0.0174560546875)  

; 	 Glyph outline path constants used in ATSFontGetNativeCurveType. 	

(def-mactype :atscurvetype (find-mactype ':unsigned-integer))

(defconstant $kATSCubicCurveType #x1)
(defconstant $kATSQuadCurveType #x2)
(defconstant $kATSOtherCurveType #x3)

(def-mactype :atsucurvepathptr (find-mactype '(:pointer :atsucurvepath)))
(defrecord ATSUCurvePath 
   (vectors :unsigned-long)
   (controlBits (:array :unsigned-long 1))
   (vector (:array :float32point 1))
   )

(def-mactype :atsucurvepathsptr (find-mactype '(:pointer :atsucurvepaths)))
(defrecord ATSUCurvePaths 
   (contours :unsigned-long)
   (contour (:array :atsucurvepath 1))
   )

; 	 Glyph ideal metrics 	
(def-mactype :atsglyphidealmetricsptr (find-mactype '(:pointer :atsglyphidealmetrics)))
(defrecord ATSGlyphIdealMetrics 
   (advance :float32point)
   (sideBearing :float32point)
   (otherSideBearing :float32point)
   )

; 	 Glyph screen metrics 	
(def-mactype :atsglyphscreenmetricsptr (find-mactype '(:pointer :atsglyphscreenmetrics)))
(defrecord ATSGlyphScreenMetrics 
   (deviceAdvance :float32point)
   (topLeft :float32point)
   (height :unsigned-long)
   (width :unsigned-long)
   (sideBearing :float32point)
   (otherSideBearing :float32point)
   )

(def-mactype :glyphid (find-mactype ':unsigned-integer))
; $ALIGN RESET
; $POP

; $SETC UsingIncludes := ATSTypesIncludes

; $ENDC                                         ; __ATSTYPES__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'ATSTypes)