(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:ATSUnicode.p"
; at Wednesday May 1,2002 2:40:31 pm.
; 
;      File:       ATSUnicode.p
;  
;      Contains:   Public interfaces for Apple Type Services for Unicode Imaging
;  
;      Version:    Technology: Mac OS 9 / Carbon
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1997-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __ATSUNICODE__
; $SETC __ATSUNICODE__ := 1

; $I+
; $SETC ATSUnicodeIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACMEMORY__
|#

(require-interface 'MacMemory)
#|                                              ; $I MacMemory.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __ATSLAYOUTTYPES__
|#

(require-interface 'ATSLayoutTypes)
#|                                              ; $I ATSLayoutTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FONTS__
|#

(require-interface 'Fonts)
#|                                              ; $I Fonts.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __SFNTTYPES__
|#

(require-interface 'SFNTTypes)
#|                                              ; $I SFNTTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __SFNTLAYOUTTYPES__
|#

(require-interface 'SFNTLayoutTypes)
#|                                              ; $I SFNTLayoutTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __TEXTCOMMON__
|#

(require-interface 'TextCommon)
#|                                              ; $I TextCommon.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __ATSTYPES__
|#

(require-interface 'ATSTypes)
#|                                              ; $I ATSTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; ******************************
;   Types and related constants 
; ******************************
; 
;    UniCharArrayHandle and UniCharArrayOffset are defined in the
;    TextCommon interface file.
; 

; 
;     ATSUTextMeasurement is specific to ATSUI in that measurement
;     quantities are in fractional Fixed format instead of shorts
;     used in QuickDraw Text.  This provides exact outline metrics and
;     line specifications such as line width, ascent, descent, and so on.  
; 

(def-mactype :atsutextmeasurement (find-mactype ':signed-long))
; 
; 	    ATSUFontID indicates a particular font family and face.  
; 	    ATSUFontID's are not guaranteed to remain constant across 
; 	    reboots.  Clients should use the font's unique name to 
; 	    get a font token to store in documents which is 
; 	    guaranteed to remain constant across reboots. 
; 	
(def-mactype :atsufontid (find-mactype ':unsigned-long))
; 
; 	    ATSUFontFeatureType and ATSUFontFeatureSelector are used 
; 	    to identify font features.  
; 	
(def-mactype :atsufontfeaturetype (find-mactype ':unsigned-integer))
(def-mactype :atsufontfeatureselector (find-mactype ':unsigned-integer))
; 
; 	    ATSUFontVariationAxis and ATSUFontVariationValue are used 
; 	    in connection with font variations.  
; 	
(def-mactype :atsufontvariationaxis (find-mactype ':ostype))
(def-mactype :atsufontvariationvalue (find-mactype ':signed-long))
;   Ptr types 
(def-mactype :atsufontfeaturetypeptr (find-mactype '(:pointer :unsigned-integer)))
(def-mactype :atsufontfeatureselectorptr (find-mactype '(:pointer :unsigned-integer)))
(def-mactype :atsufontvariationaxisptr (find-mactype '(:pointer :ostype)))
(def-mactype :atsufontvariationvalueptr (find-mactype '(:pointer :signed-long)))
; 
; 	    ATSUTextLayout is used to store the attribute information 
; 	    associated with a contiguous block of UniChar's (UInt16's) 
; 	    in memory.  It's typed to be an opaque structure.  
; 	
(def-mactype :atsutextlayout (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :atsutextlayoutptr (find-mactype '(:pointer :pointer)));  when a VAR xx:ATSUTextLayout parameter can be nil, it is changed to xx: ATSUTextLayoutPtr 
; 
; 	    ATSUStyle is used to store a set of individual attributes, 
; 	    font features, and font variations.  It's typed to be 
; 	    an opaque structure.  
; 	
(def-mactype :atsustyle (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :atsustyleptr (find-mactype '(:pointer :pointer)));  when a VAR xx:ATSUStyle parameter can be nil, it is changed to xx: ATSUStylePtr 
; 
; 	    ATSUFontFallbacks is used to store the desired font fallback 
; 	    list and associated fallback cache information.  It's typed
; 	    to be an opaque structure.  
; 	
(def-mactype :atsufontfallbacks (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :atsufontfallbacksptr (find-mactype '(:pointer :pointer)));  when a VAR xx:ATSUFontFallbacks parameter can be nil, it is changed to xx: ATSUFontFallbacksPtr 
; 
; 	    ATSUAttributeTag is used to indicate the particular type 
; 	    of attribute under consideration:  font, size, color, 
; 	    and so on.  
; 	    Each style run may have at most one attribute with a 
; 	    given ATSUAttributeTag (i.e., a style run can't have 
; 	    more than one font or size) but may have none.  
; 	    Note: Apple reserves values 0 to 65,535 (0 to 0x0000FFFF).
; 	    ATSUI clients may create their own tags with any other value.
; 	
(def-mactype :atsuattributetag (find-mactype ':unsigned-long))

;      Layout and Line Control Attribute Tags 
(defconstant $kATSULineWidthTag 1)              ;      Type:       ATSUTextMeasurement 
;      Default value: 0 
(defconstant $kATSULineRotationTag 2)           ;      Type:       Fixed (fixed value in degrees in right-handed coordinate system) 
;      Default value: 0 
(defconstant $kATSULineDirectionTag 3)          ;      Type:       Boolean; values 0 or 1 (see below for value identities) 
;      Default value: GetSysDirection() ? kATSURightToLeftBaseDirection : kATSULeftToRightBaseDirection 
(defconstant $kATSULineJustificationFactorTag 4);      Type:       Fract between 0 and 1 
;      Default value: kATSUNoJustification 
(defconstant $kATSULineFlushFactorTag 5)        ;      Type:       Fract between 0 and 1  
;      Default value: kATSUStartAlignment 
(defconstant $kATSULineBaselineValuesTag 6)     ;      Type:       BslnBaselineRecord 
;      Default value: All zeros.  Calculated from other style attributes (e.g., font and point size) 
(defconstant $kATSULineLayoutOptionsTag 7)      ;      Type:       ATSLineLayoutOptions (see ATSLayoutTypes.h) 
;      Default value: kATSLineNoLayoutOptions - other options listed in ATSLayoutTypes.h 
(defconstant $kATSULineAscentTag 8)             ;      Type:       ATSUTextMeasurement 
;      Default value: kATSUseLineHeight 
(defconstant $kATSULineDescentTag 9)            ;      Type:       ATSUTextMeasurement 
;      Default value: kATSUseLineHeight 
(defconstant $kATSULineLangRegionTag 10)        ;      Type:       RegionCode - region values listed in script.h interface file 
;      Default value: kTextRegionDontCare 
(defconstant $kATSULineTextLocatorTag 11)       ;      Type:       TextBreakLocatorRef 
;      Default value: NULL - set Region derived locator or the default Text Utilities locator 
(defconstant $kATSULineTruncationTag 12)        ;      Type:       ATSULineTruncation 
;      Default value: kATSUTruncateNone                                                        
(defconstant $kATSULineFontFallbacksTag 13)     ;      Type:       ATSUFontFallbacks 
;      Default value: globally set font fallbacks using the ATSUSetFontFallbacks                                                      
(defconstant $kATSUMaxLineTag 14)               ;      This is just for convenience - the upper limit of the ATSUTextLayout attribute tags 
;   obsolete layout tags  
(defconstant $kATSULineLanguageTag 10)          ;      Use kATSULineLangRegionTag            
;      Run Style Attribute Tags 
;   QuickDraw compatibility tags  
(defconstant $kATSUQDBoldfaceTag 256)           ;      Type:       Boolean     
;      Default value: false 
(defconstant $kATSUQDItalicTag 257)             ;      Type:       Boolean        
;      Default value: false 
(defconstant $kATSUQDUnderlineTag 258)          ;      Type:       Boolean     
;      Default value: false 
(defconstant $kATSUQDCondensedTag 259)          ;      Type:       Boolean     
;      Default value: false 
(defconstant $kATSUQDExtendedTag 260)           ;      Type:       Boolean     
;      Default value: false 
;   Common run tags  
(defconstant $kATSUFontTag 261)                 ;      Type:       ATSUFontID  
;      Default value: GetScriptVariable( smSystemScript, smScriptAppFond ) 
(defconstant $kATSUSizeTag 262)                 ;      Type:       Fixed   
;      Default value: GetScriptVariable( smSystemScript, smScriptAppFondSize )     
(defconstant $kATSUColorTag 263)                ;      Type:       RGBColor    
;      Default value: (0, 0, 0) 
;      Less common run tags  
(defconstant $kATSULangRegionTag 264)           ;      Type:       RegionCode - region values listed in script.h interface file 
;      Default value: GetScriptManagerVariable( smRegionCode ) 
(defconstant $kATSUVerticalCharacterTag 265)    ;      Type:       ATSUVerticalCharacterType   
;      Default value: kATSUStronglyHorizontal 
(defconstant $kATSUImposeWidthTag 266)          ;      Type:       ATSUTextMeasurement 
;      Default value: 0 - all glyphs use their own font defined advance widths 
(defconstant $kATSUBeforeWithStreamShiftTag 267);      Type:       Fixed 
;      Default value: 0 
(defconstant $kATSUAfterWithStreamShiftTag 268) ;      Type:       Fixed 
;      Default value: 0 
(defconstant $kATSUCrossStreamShiftTag 269)     ;      Type:       Fixed 
;      Default value: 0 
(defconstant $kATSUTrackingTag 270)             ;      Type:       Fixed 
;      Default value: kATSNoTracking 
(defconstant $kATSUHangingInhibitFactorTag 271) ;      Type:       Fract between 0 and 1 
;      Default value: 0 
(defconstant $kATSUKerningInhibitFactorTag 272) ;      Type:       Fract between 0 and 1 
;      Default value: 0 
(defconstant $kATSUDecompositionFactorTag 273)  ;      Type:       Fixed (-1.0 -> 1.0) 
;      Default value: 0 
(defconstant $kATSUBaselineClassTag 274)        ;      Type:       BslnBaselineClass  (see SFNTLayoutTypes.h) 
;      Default value: kBSLNRomanBaseline - set to kBSLNNoBaselineOverride to use intrinsic baselines 
(defconstant $kATSUPriorityJustOverrideTag 275) ;      Type:       ATSJustPriorityWidthDeltaOverrides (see ATSLayoutTypes.h) 
;      Default value: all zeros 
(defconstant $kATSUNoLigatureSplitTag 276)      ;      Type:       Boolean 
;      Default value: false - ligatures and compound characters have divisable components. 
(defconstant $kATSUNoCaretAngleTag 277)         ;      Type:       Boolean 
;      Default value: false - use the character's angularity to determine its boundaries 
(defconstant $kATSUSuppressCrossKerningTag 278) ;      Type:       Boolean 
;      Default value: false - do not suppress automatic cross kerning (defined by font) 
(defconstant $kATSUNoOpticalAlignmentTag 279)   ;      Type:       Boolean 
;      Default value: false - do not suppress character's automatic optical positional alignment 
(defconstant $kATSUForceHangingTag 280)         ;      Type:       Boolean 
;      Default value: false - do not force the character's to hang beyond the line boundaries 
(defconstant $kATSUNoSpecialJustificationTag 281);      Type:       Boolean 
;      Default value: false - perform post-compensation justification if needed 
(defconstant $kATSUStyleTextLocatorTag 282)     ;      Type:       TextBreakLocatorRef 
;      Default value: NULL - region derived locator or the default Text Utilities locator 
(defconstant $kATSUStyleRenderingOptionsTag 283);      Type:       ATSStyleRenderingOptions (see ATSLayoutTypes.h) 
;      Default value: kATSStyleApplyHints - ATS glyph rendering uses hinting 
(defconstant $kATSUMaxStyleTag 284)             ;      This is just for convenience - the upper limit of the ATSUStyle attribute tags  
;   obsolete style tags  
(defconstant $kATSULanguageTag 264)             ;      use kATSULangRegionTag                
;   special layout tag for Mac OS X  
(defconstant $kATSUCGContextTag 32767)          ;    Type:          CGContext, Default value:    NULL    
;   max  
(defconstant $kATSUMaxATSUITagValue 65535)      ;      This is the maximum Apple ATSUI reserved tag value.  Client defined tags must be larger. 

; 
; 	    ATSUAttributeValuePtr is used to provide generic access to
; 	    storage of attribute values, which vary in size.
; 	    ConstATSUAttributeValuePtr is a pointer to a const attribute value.
; 	

(def-mactype :atsuattributevalueptr (find-mactype ':pointer))
(def-mactype :constatsuattributevalueptr (find-mactype ':pointer))
; 
; 	    ATSUAttributeInfo is used to provide a tag/size pairing.  
; 	    This makes it possible to provide the client information   
; 	    about all the attributes for a given range of text.  This   
; 	    structure is only used to return to the client information   
; 	    about a complete set of attributes.  An array of   
; 	    ATSUAttributeInfos is passed as a parameter so that the   
; 	    client can find out what attributes are set and what their   
; 	    individual sizes are; with that information, they can then   
; 	    query about the values of the attributes they're interested   
; 	    in.  Because arrays of ATSUAttributeInfos are used as parameters   
; 	    to functions, they have to be of a fixed size, hence the   
; 	    value is not included in the structure.  
; 	
(def-mactype :atsuattributeinfoptr (find-mactype '(:pointer :atsuattributeinfo)))
(defrecord ATSUAttributeInfo 
   (fTag :unsigned-long)
   (fValueSize :unsigned-long)
   )

; 
; 	    ATSUCaret contains the complete information needed to render a
; 	    caret.  fX and fY is the position of one of the caret's ends
; 	    relative to the origin position of the line the caret belongs.
; 	    fDeltaX and fDeltaY is the position of the caret's other end.
; 	    Hence, to draw a caret, simply call MoveTo(fX, fY) followed by
; 	    LineTo(fDeltaX, fDeltaY) or equivalent.  The ATSUCaret will
; 	    contain the positions needed to draw carets on angled lines
; 	    and reflect angled carets and leading/trailing split caret
; 	    appearances.
; 	
(def-mactype :atsucaretptr (find-mactype '(:pointer :atsucaret)))
(defrecord ATSUCaret 
   (fX :signed-long)
   (fY :signed-long)
   (fDeltaX :signed-long)
   (fDeltaY :signed-long)
   )

; 
; 	    ATSUCursorMovementType is used to indicate how much to move
; 	    the cursor when using the ATSUI cusor movement routines. 
; 	    Note that kATSUByCharacterCluster is only available in Mac OS X
; 	    and in CarbonLib versions 1.3 and later.
; 	
(def-mactype :atsucursormovementtype (find-mactype ':unsigned-integer))

(defconstant $kATSUByCharacter 0)
(defconstant $kATSUByTypographicCluster 1)      ;   clusters based on characters or ligatures 
(defconstant $kATSUByWord 2)
(defconstant $kATSUByCharacterCluster 3)        ;   clusters based on characters only 
(defconstant $kATSUByCluster 1)                 ;   obsolete name for kATSUByTypographicCluster 

; 
; 	    ATSULineTruncation is for identifying where truncation will occur when
; 	    using a ATSUTextLayout with the ATSULineTruncation layout attribute.
; 	

(def-mactype :atsulinetruncation (find-mactype ':unsigned-long))

(defconstant $kATSUTruncateNone 0)              ;   truncation specification - add to any desired truncFeat bit options listed below 
(defconstant $kATSUTruncateStart 1)             ;   for instance, kATSUTruncateEnd with kATSUTruncFeatNoSquishing is value 0x0000000A 
(defconstant $kATSUTruncateEnd 2)
(defconstant $kATSUTruncateMiddle 3)
(defconstant $kATSUTruncateSpecificationMask #x7);   these bits are reserved for the truncation specification (0 - 7) 
;   the following bit-field options can be added to the chosen truncation specification 
(defconstant $kATSUTruncFeatNoSquishing #x8)    ;   if specified, do not perform any negative justification in lieu of truncation 

; 
; 	    ATSUVerticalCharacterType currently can take two values 
; 	    and is used to indicate whether text is to be laid out 
; 	    as vertical glyphs or horizontal glyphs.  
; 	

(def-mactype :atsuverticalcharactertype (find-mactype ':unsigned-integer))

(defconstant $kATSUStronglyHorizontal 0)
(defconstant $kATSUStronglyVertical 1)

; 
; 	    ATSUStyleComparison is an enumeration with four values, 
; 	    and is used by ATSUCompareStyles() to indicate if the
; 	    first style parameter contains as a proper subset, is
; 	    equal to, or is contained by the second style parameter.
; 	

(def-mactype :atsustylecomparison (find-mactype ':unsigned-integer))

(defconstant $kATSUStyleUnequal 0)
(defconstant $kATSUStyleContains 1)
(defconstant $kATSUStyleEquals 2)
(defconstant $kATSUStyleContainedBy 3)

; 
; 	    ATSUFontFallbackMethod type defines the method by which ATSUI will try to
; 	    find an appropriate font for a character if the assigned font does not
; 	    contain the needed glyph(s) to represent it.  This affects ATSUMatchFontsToText
; 	    and font selection during layout and drawing when ATSUSetTransientFontMatching
; 	    is set ON.
; 	

(def-mactype :atsufontfallbackmethod (find-mactype ':unsigned-integer))

(defconstant $kATSUDefaultFontFallbacks 0)
(defconstant $kATSULastResortOnlyFallback 1)
(defconstant $kATSUSequentialFallbacksPreferred 2)
(defconstant $kATSUSequentialFallbacksExclusive 3)

; $IFC CALL_NOT_IN_CARBON 
; 
; 	    ATSUMemoryCallbacks is a union struct that allows the ATSUI 
; 	    client to specify a specific heap for ATSUI use or allocation
; 	    callbacks of which ATSUI is to use each time ATSUI performs a
; 	    memory operation (alloc, grow, free).
; 	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ATSUCustomAllocFunc = FUNCTION(refCon: UNIV Ptr; howMuch: ByteCount): Ptr; C;

|#
 |#                                             ; $ELSEC
(def-mactype :atsucustomallocfunc (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ATSUCustomFreeFunc = PROCEDURE(refCon: UNIV Ptr; doomedBlock: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :atsucustomfreefunc (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ATSUCustomGrowFunc = FUNCTION(refCon: UNIV Ptr; oldBlock: UNIV Ptr; oldSize: ByteCount; newSize: ByteCount): Ptr; C;

|#
 |#                                             ; $ELSEC
(def-mactype :atsucustomgrowfunc (find-mactype ':pointer))
; $ENDC

(def-mactype :atsumemorycallbacksptr (find-mactype '(:pointer :atsumemorycallbacks)))
(defrecord ATSUMemoryCallbacks 
   (:variant 
      (
      (Alloc :pointer)
      (Free :pointer)
      (Grow :pointer)
      (memoryRefCon :pointer)
      )
      (
      (heapToUse (:pointer :zone))
      )
      )
   )

; 
; 	    ATSUHeapSpec provides the ATSUI client a means of specifying the heap
; 	    from which ATSUI should allocate its dynamic memory or specifying
; 	    that ATSUI should use the memory callback provided by the client.
; 	
(def-mactype :atsuheapspec (find-mactype ':unsigned-integer))

(defconstant $kATSUUseCurrentHeap 0)
(defconstant $kATSUUseAppHeap 1)
(defconstant $kATSUUseSpecificHeap 2)
(defconstant $kATSUUseCallbacks 3)

; 
; 	    ATSUMemorySetting is used to store the results from a ATSUSetMemoryAlloc
; 	    or a ATSUGetCurrentMemorySetting call.  It can also be used to change the
; 	    current ATSUMemorySetting by passing it into the ATSUSetCurrentMemorySetting
; 	    call.
; 	

(def-mactype :atsumemorysetting (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :atsumemorysettingptr (find-mactype '(:pointer :pointer)));  when a VAR xx:ATSUMemorySetting parameter can be nil, it is changed to xx: ATSUMemorySettingPtr 
; $ENDC                                         ; CALL_NOT_IN_CARBON

;  Types for ATSUI Low Level API 

(def-mactype :atsuglyphinfoptr (find-mactype '(:pointer :atsuglyphinfo)))
(defrecord ATSUGlyphInfo 
   (GlyphID :unsigned-integer)
   (reserved :unsigned-integer)
   (layoutFlags :unsigned-long)
   (charIndex :unsigned-long)
   (style :pointer)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (deltaY :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (idealX :single-float)
   (screenX :signed-integer)
   (caretX :signed-integer)
   )

(def-mactype :atsuglyphinfoarrayptr (find-mactype '(:pointer :atsuglyphinfoarray)))
(defrecord ATSUGlyphInfoArray 
   (layout :pointer)
   (numGlyphs :unsigned-long)
   (glyphs (:array :atsuglyphinfo 1))
   )

; 	*******************************************************************************	
; 	  ATSUI Highlighting method constants and typedefs             	
; 	*******************************************************************************	
(def-mactype :atsuhighlightmethod (find-mactype ':unsigned-long))

(defconstant $kInvertHighlighting 0)
(defconstant $kRedrawHighlighting 1)

(def-mactype :atsubackgrounddatatype (find-mactype ':unsigned-long))

(defconstant $kATSUBackgroundColor 0)
(defconstant $kATSUBackgroundCallback 1)

(def-mactype :atsubackgroundcolorptr (find-mactype '(:pointer :atsubackgroundcolor)))
(defrecord ATSUBackgroundColor 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (red :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (green :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (blue :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (alpha :single-float)
   )

; 
; 	 *  RedrawBackgroundProcPtr
; 	 *  
; 	 *  Discussion:
; 	 *    RedrawBackgroundProcPtr is a pointer to a client-supplied
; 	 *    callback function (e.g. MyRedrawBackgroundProc) for redrawing
; 	 *    complex backgrounds (and optionally the text as well) that can be
; 	 *    called by ATSUI for highlighting if the client has called
; 	 *    ATSUSetHighlightingMethod with iMethod=kRedrawHighlighting. In
; 	 *    order for ATSUI to call the client function, the client must (1)
; 	 *    pass a pointer to the client function to NewRedrawBackgroundUPP()
; 	 *    in order to obtain a RedrawBackgroundUPP, and (2) pass the
; 	 *    RedrawBackgroundUPP in the unhighlightData.backgroundUPP field of
; 	 *    the iUnhighlightData parameter for the  ATSUSetHighlightingMethod
; 	 *    call. When finished, the client should call
; 	 *    DisposeRedrawBackgroundUPP with the RedrawBackgroundUPP.
; 	 *  
; 	 *  Parameters:
; 	 *    
; 	 *    iLayout:
; 	 *      The layout to which the highlighting is being applied. The
; 	 *      client function can use this to redraw the text.
; 	 *    
; 	 *    iTextOffset:
; 	 *      The offset of the text that is being highlighted; can be used
; 	 *      by the client function to redraaw the text.
; 	 *    
; 	 *    iTextLength:
; 	 *      The length of the text that is being highlighted; can be used
; 	 *      by the client function to redraaw the text.
; 	 *    
; 	 *    iUnhighlightArea:
; 	 *      An array of ATSTrapezoids that describes the highlight area.
; 	 *      The ATSTrapezoid array is ALWAYS in QD coordinates.
; 	 *    
; 	 *    iTrapezoidCount:
; 	 *      The count of ATSTrapezoids in iUnhighlightArea.
; 	 *  
; 	 *  Result:
; 	 *    A Boolean result indicating whether ATSUI should redraw the text.
; 	 *    If the client function redraws the text, it should return false,
; 	 *    otherwise it should return true to have ATSUI redraw any text
; 	 *    that needs to be redrawn.
; 	 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	RedrawBackgroundProcPtr = FUNCTION(iLayout: ATSUTextLayout; iTextOffset: UniCharArrayOffset; iTextLength: UniCharCount; VAR iUnhighlightArea: ATSTrapezoid; iTrapezoidCount: ItemCount): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :redrawbackgroundprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :redrawbackgroundupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :redrawbackgroundupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppRedrawBackgroundProcInfo #xFFD0)
; 
; 	 *  NewRedrawBackgroundUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib on Mac OS X
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;  *  DisposeRedrawBackgroundUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib on Mac OS X
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NewRedrawBackgroundUPP" 
      ((userRoutine :pointer)) 
  :pointer
   () )                                         ; 
;  *  InvokeRedrawBackgroundUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib on Mac OS X
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DisposeRedrawBackgroundUPP" 
      ((userUPP :pointer)) 
  nil
   () )
(deftrap-inline "_InvokeRedrawBackgroundUPP" 
      ((iLayout :pointer) (iTextOffset :unsigned-long) (iTextLength :unsigned-long) (iUnhighlightArea (:pointer :atstrapezoid)) (iTrapezoidCount :unsigned-long) (userRoutine :pointer)) 
  :boolean
   () )
(def-mactype :atsubackgrounddataptr (find-mactype '(:pointer :atsubackgrounddata)))
(defrecord ATSUBackgroundData 
   (:variant 
      (
      (backgroundColor :atsubackgroundcolor)
      )
      (
      (backgroundUPP :pointer)
      )
      )
   )

(def-mactype :atsuunhighlightdataptr (find-mactype '(:pointer :atsuunhighlightdata)))
(defrecord ATSUUnhighlightData 
   (dataType :unsigned-long)
   (unhighlightData :atsubackgrounddata)
   )

; 	******************	
; 	  Other constants 	
; 	******************	
; 	 Line direction types (used for kATSULineDirectionTag values) 	

(defconstant $kATSULeftToRightBaseDirection 0)  ;      Impose left-to-right or top-to-bottom dominant direction  
(defconstant $kATSURightToLeftBaseDirection 1)  ;      Impose right-to-left or bottom-to-top dominant direction  

; 	 LineFlushFactor convenience defined values 	
(defconstant $kATSUStartAlignment #x0)
(defconstant $kATSUEndAlignment #x40000000)
(defconstant $kATSUCenterAlignment #x20000000)

; 	 LineJustificationFactor convenience defined values 	
(defconstant $kATSUNoJustification #x0)
(defconstant $kATSUFullJustification #x40000000)

; 	 Other constants  	
(defconstant $kATSUInvalidFontID 0)

(defconstant $kATSUUseLineControlWidth #x7FFFFFFF)

(defconstant $kATSUNoSelector #xFFFF)

(defconstant $kATSUUseGrafPortPenLoc #xFFFFFFFF)
(defconstant $kATSUClearAll #xFFFFFFFF)

(defconstant $kATSUFromTextBeginning #xFFFFFFFF)
(defconstant $kATSUToTextEnd #xFFFFFFFF)

; 	**************	
; 	  Functions   	
; 	**************	

; 	  Clipboard support, flattened style version 0 (it is advised to not use these routines and perform your own flattening)  	
; 
; 	 *  ATSUCopyToHandle()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_ATSUCopyToHandle" 
      ((iStyle :pointer) (oStyleHandle :handle)) 
  :osstatus
   () )

; 
;  *  ATSUPasteFromHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUPasteFromHandle" 
      ((iStyle :pointer) (iStyleHandle :handle)) 
  :osstatus
   () )

;   Memory allocation specification functions (not in Carbon)   
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  ATSUCreateMemorySetting()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.6 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ATSUCreateMemorySetting" 
      ((iHeapSpec :unsigned-integer) (iMemoryCallbacks (:pointer :atsumemorycallbacks)) (oMemorySetting (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ATSUSetCurrentMemorySetting()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.6 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ATSUSetCurrentMemorySetting" 
      ((iMemorySetting :pointer)) 
  :osstatus
   () )

; 
;  *  ATSUGetCurrentMemorySetting()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.6 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ATSUGetCurrentMemorySetting" 
      () 
  :pointer
   () )

; 
;  *  ATSUDisposeMemorySetting()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.6 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ATSUDisposeMemorySetting" 
      ((iMemorySetting :pointer)) 
  :osstatus
   () )

;   Font fallback object functions  
; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  ATSUCreateFontFallbacks()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 9.2.2 and later
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.1 and later
;  

(deftrap-inline "_ATSUCreateFontFallbacks" 
      ((oFontFallback (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ATSUDisposeFontFallbacks()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 9.2.2 and later
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.1 and later
;  

(deftrap-inline "_ATSUDisposeFontFallbacks" 
      ((iFontFallbacks :pointer)) 
  :osstatus
   () )

; 
;  *  ATSUSetObjFontFallbacks()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 9.2.2 and later
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.1 and later
;  
; CONST
(deftrap-inline "_ATSUSetObjFontFallbacks" 
      ((iFontFallbacks :pointer) (iFontFallbacksCount :unsigned-long) (iFonts (:pointer :unsigned-long)) (iFontFallbackMethod :unsigned-integer)) 
  :osstatus
   () )

; 
;  *  ATSUGetObjFontFallbacks()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 9.2.2 and later
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.1 and later
;  

(deftrap-inline "_ATSUGetObjFontFallbacks" 
      ((iFontFallbacks :pointer) (iMaxFontFallbacksCount :unsigned-long) (oFonts (:pointer :unsigned-long)) (oFontFallbackMethod (:pointer :unsigned-integer)) (oActualFallbacksCount (:pointer :unsigned-long))) 
  :osstatus
   () )

;   Basic style functions   
; 
;  *  ATSUCreateStyle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUCreateStyle" 
      ((oStyle (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ATSUCreateAndCopyStyle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUCreateAndCopyStyle" 
      ((iStyle :pointer) (oStyle (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ATSUDisposeStyle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUDisposeStyle" 
      ((iStyle :pointer)) 
  :osstatus
   () )

; 
;  *  ATSUSetStyleRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUSetStyleRefCon" 
      ((iStyle :pointer) (iRefCon :unsigned-long)) 
  :osstatus
   () )

; 
;  *  ATSUGetStyleRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetStyleRefCon" 
      ((iStyle :pointer) (oRefCon (:pointer :unsigned-long))) 
  :osstatus
   () )

;   Style comparison        
; 
;  *  ATSUCompareStyles()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUCompareStyles" 
      ((iFirstStyle :pointer) (iSecondStyle :pointer) (oComparison (:pointer :unsigned-integer))) 
  :osstatus
   () )

;   Attribute manipulations 
; 
;  *  ATSUCopyAttributes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUCopyAttributes" 
      ((iSourceStyle :pointer) (iDestinationStyle :pointer)) 
  :osstatus
   () )

; 
;  *  ATSUOverwriteAttributes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUOverwriteAttributes" 
      ((iSourceStyle :pointer) (iDestinationStyle :pointer)) 
  :osstatus
   () )

; 
;  *  ATSUUnderwriteAttributes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUUnderwriteAttributes" 
      ((iSourceStyle :pointer) (iDestinationStyle :pointer)) 
  :osstatus
   () )

;   Empty styles    
; 
;  *  ATSUClearStyle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUClearStyle" 
      ((iStyle :pointer)) 
  :osstatus
   () )

; 
;  *  ATSUStyleIsEmpty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUStyleIsEmpty" 
      ((iStyle :pointer) (oIsClear (:pointer :boolean))) 
  :osstatus
   () )

;   Get and set attributes 
; 
;  *  ATSUCalculateBaselineDeltas()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUCalculateBaselineDeltas" 
      ((iStyle :pointer) (iBaselineClass :unsigned-long) (oBaselineDeltas (:pointer :bslnbaselinerecord))) 
  :osstatus
   () )

; 
;  *  ATSUSetAttributes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST; CONST
(deftrap-inline "_ATSUSetAttributes" 
      ((iStyle :pointer) (iAttributeCount :unsigned-long) (iTag (:pointer :unsigned-long)) (iValueSize (:pointer :unsigned-long)) (iValue (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ATSUGetAttribute()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetAttribute" 
      ((iStyle :pointer) (iTag :unsigned-long) (iExpectedValueSize :unsigned-long) (oValue :pointer) (oActualValueSize (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUGetAllAttributes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetAllAttributes" 
      ((iStyle :pointer) (oAttributeInfoArray (:pointer :atsuattributeinfo)) (iTagValuePairArraySize :unsigned-long) (oTagValuePairCount (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUClearAttributes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_ATSUClearAttributes" 
      ((iStyle :pointer) (iTagCount :unsigned-long) (iTag (:pointer :unsigned-long))) 
  :osstatus
   () )

;   Font features   
; 
;  *  ATSUSetFontFeatures()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_ATSUSetFontFeatures" 
      ((iStyle :pointer) (iFeatureCount :unsigned-long) (iType (:pointer :unsigned-integer)) (iSelector (:pointer :unsigned-integer))) 
  :osstatus
   () )

; 
;  *  ATSUGetFontFeature()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetFontFeature" 
      ((iStyle :pointer) (iFeatureIndex :unsigned-long) (oFeatureType (:pointer :unsigned-integer)) (oFeatureSelector (:pointer :unsigned-integer))) 
  :osstatus
   () )

; 
;  *  ATSUGetAllFontFeatures()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetAllFontFeatures" 
      ((iStyle :pointer) (iMaximumFeatureCount :unsigned-long) (oFeatureType (:pointer :unsigned-integer)) (oFeatureSelector (:pointer :unsigned-integer)) (oActualFeatureCount (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUClearFontFeatures()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_ATSUClearFontFeatures" 
      ((iStyle :pointer) (iFeatureCount :unsigned-long) (iType (:pointer :unsigned-integer)) (iSelector (:pointer :unsigned-integer))) 
  :osstatus
   () )

;   Font variations 
; 
;  *  ATSUSetVariations()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_ATSUSetVariations" 
      ((iStyle :pointer) (iVariationCount :unsigned-long) (iAxes (:pointer :ostype)) (iValue (:pointer :signed-long))) 
  :osstatus
   () )

; 
;  *  ATSUGetFontVariationValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetFontVariationValue" 
      ((iStyle :pointer) (iFontVariationAxis :ostype) (oFontVariationValue (:pointer :signed-long))) 
  :osstatus
   () )

; 
;  *  ATSUGetAllFontVariations()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetAllFontVariations" 
      ((iStyle :pointer) (iVariationCount :unsigned-long) (oVariationAxes (:pointer :ostype)) (oFontVariationValues (:pointer :signed-long)) (oActualVariationCount (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUClearFontVariations()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_ATSUClearFontVariations" 
      ((iStyle :pointer) (iAxisCount :unsigned-long) (iAxis (:pointer :ostype))) 
  :osstatus
   () )

;   Basic text-layout functions 
; 
;  *  ATSUCreateTextLayout()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUCreateTextLayout" 
      ((oTextLayout (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ATSUCreateAndCopyTextLayout()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUCreateAndCopyTextLayout" 
      ((iTextLayout :pointer) (oTextLayout (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ATSUCreateTextLayoutWithTextPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_ATSUCreateTextLayoutWithTextPtr" 
      ((iText (:pointer :unsigned-integer)) (iTextOffset :unsigned-long) (iTextLength :unsigned-long) (iTextTotalLength :unsigned-long) (iNumberOfRuns :unsigned-long) (iRunLengths (:pointer :unsigned-long)) (iStyles (:pointer :pointer)) (oTextLayout (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ATSUCreateTextLayoutWithTextHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_ATSUCreateTextLayoutWithTextHandle" 
      ((iText (:handle :unsigned-integer)) (iTextOffset :unsigned-long) (iTextLength :unsigned-long) (iTextTotalLength :unsigned-long) (iNumberOfRuns :unsigned-long) (iRunLengths (:pointer :unsigned-long)) (iStyles (:pointer :pointer)) (oTextLayout (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ATSUClearLayoutCache()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUClearLayoutCache" 
      ((iTextLayout :pointer) (iLineStart :unsigned-long)) 
  :osstatus
   () )

; 
;  *  ATSUDisposeTextLayout()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUDisposeTextLayout" 
      ((iTextLayout :pointer)) 
  :osstatus
   () )

; 
;  *  ATSUSetTextLayoutRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUSetTextLayoutRefCon" 
      ((iTextLayout :pointer) (iRefCon :unsigned-long)) 
  :osstatus
   () )

; 
;  *  ATSUGetTextLayoutRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetTextLayoutRefCon" 
      ((iTextLayout :pointer) (oRefCon (:pointer :unsigned-long))) 
  :osstatus
   () )

;   Glyph bounds retrieval  
; 
;  *  ATSUGetGlyphBounds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetGlyphBounds" 
      ((iTextLayout :pointer) (iTextBasePointX :signed-long) (iTextBasePointY :signed-long) (iBoundsCharStart :unsigned-long) (iBoundsCharLength :unsigned-long) (iTypeOfBounds :unsigned-integer) (iMaxNumberOfBounds :unsigned-long) (oGlyphBounds (:pointer :atstrapezoid)) (oActualNumberOfBounds (:pointer :unsigned-long))) 
  :osstatus
   () )

;   Idle processing 
; 
;  *  ATSUIdle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUIdle" 
      ((iTextLayout :pointer)) 
  :osstatus
   () )

;   Text location   
; 
;  *  ATSUSetTextPointerLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUSetTextPointerLocation" 
      ((iTextLayout :pointer) (iText (:pointer :unsigned-integer)) (iTextOffset :unsigned-long) (iTextLength :unsigned-long) (iTextTotalLength :unsigned-long)) 
  :osstatus
   () )

; 
;  *  ATSUSetTextHandleLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUSetTextHandleLocation" 
      ((iTextLayout :pointer) (iText (:handle :unsigned-integer)) (iTextOffset :unsigned-long) (iTextLength :unsigned-long) (iTextTotalLength :unsigned-long)) 
  :osstatus
   () )

; 
;  *  ATSUGetTextLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetTextLocation" 
      ((iTextLayout :pointer) (oText (:pointer :pointer)) (oTextIsStoredInHandle (:pointer :boolean)) (oOffset (:pointer :unsigned-long)) (oTextLength (:pointer :unsigned-long)) (oTextTotalLength (:pointer :unsigned-long))) 
  :osstatus
   () )

;   Text manipulation   
; 
;  *  ATSUTextDeleted()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUTextDeleted" 
      ((iTextLayout :pointer) (iDeletedRangeStart :unsigned-long) (iDeletedRangeLength :unsigned-long)) 
  :osstatus
   () )

; 
;  *  ATSUTextInserted()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUTextInserted" 
      ((iTextLayout :pointer) (iInsertionLocation :unsigned-long) (iInsertionLength :unsigned-long)) 
  :osstatus
   () )

; 
;  *  ATSUTextMoved()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUTextMoved" 
      ((iTextLayout :pointer) (iNewLocation (:pointer :unsigned-integer))) 
  :osstatus
   () )

;   Layout controls 
; 
;  *  ATSUCopyLayoutControls()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUCopyLayoutControls" 
      ((iSourceTextLayout :pointer) (iDestTextLayout :pointer)) 
  :osstatus
   () )

; 
;  *  ATSUSetLayoutControls()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST; CONST
(deftrap-inline "_ATSUSetLayoutControls" 
      ((iTextLayout :pointer) (iAttributeCount :unsigned-long) (iTag (:pointer :unsigned-long)) (iValueSize (:pointer :unsigned-long)) (iValue (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ATSUGetLayoutControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetLayoutControl" 
      ((iTextLayout :pointer) (iTag :unsigned-long) (iExpectedValueSize :unsigned-long) (oValue :pointer) (oActualValueSize (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUGetAllLayoutControls()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetAllLayoutControls" 
      ((iTextLayout :pointer) (oAttributeInfoArray (:pointer :atsuattributeinfo)) (iTagValuePairArraySize :unsigned-long) (oTagValuePairCount (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUClearLayoutControls()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_ATSUClearLayoutControls" 
      ((iTextLayout :pointer) (iTagCount :unsigned-long) (iTag (:pointer :unsigned-long))) 
  :osstatus
   () )

;   Single line layout controls 
; 
;  *  ATSUCopyLineControls()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUCopyLineControls" 
      ((iSourceTextLayout :pointer) (iSourceLineStart :unsigned-long) (iDestTextLayout :pointer) (iDestLineStart :unsigned-long)) 
  :osstatus
   () )

; 
;  *  ATSUSetLineControls()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST; CONST
(deftrap-inline "_ATSUSetLineControls" 
      ((iTextLayout :pointer) (iLineStart :unsigned-long) (iAttributeCount :unsigned-long) (iTag (:pointer :unsigned-long)) (iValueSize (:pointer :unsigned-long)) (iValue (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ATSUGetLineControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetLineControl" 
      ((iTextLayout :pointer) (iLineStart :unsigned-long) (iTag :unsigned-long) (iExpectedValueSize :unsigned-long) (oValue :pointer) (oActualValueSize (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUGetAllLineControls()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetAllLineControls" 
      ((iTextLayout :pointer) (iLineStart :unsigned-long) (oAttributeInfoArray (:pointer :atsuattributeinfo)) (iTagValuePairArraySize :unsigned-long) (oTagValuePairCount (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUClearLineControls()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_ATSUClearLineControls" 
      ((iTextLayout :pointer) (iLineStart :unsigned-long) (iTagCount :unsigned-long) (iTag (:pointer :unsigned-long))) 
  :osstatus
   () )

;   Style run processing    
; 
;  *  ATSUSetRunStyle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUSetRunStyle" 
      ((iTextLayout :pointer) (iStyle :pointer) (iRunStart :unsigned-long) (iRunLength :unsigned-long)) 
  :osstatus
   () )

; 
;  *  ATSUGetRunStyle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetRunStyle" 
      ((iTextLayout :pointer) (iOffset :unsigned-long) (oStyle (:pointer :pointer)) (oRunStart (:pointer :unsigned-long)) (oRunLength (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUGetContinuousAttributes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetContinuousAttributes" 
      ((iTextLayout :pointer) (iOffset :unsigned-long) (iLength :unsigned-long) (oStyle :pointer)) 
  :osstatus
   () )

;   Drawing and measuring   
; 
;  *  ATSUDrawText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUDrawText" 
      ((iTextLayout :pointer) (iLineOffset :unsigned-long) (iLineLength :unsigned-long) (iLocationX :signed-long) (iLocationY :signed-long)) 
  :osstatus
   () )

; 
;  *  ATSUMeasureText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUMeasureText" 
      ((iTextLayout :pointer) (iLineStart :unsigned-long) (iLineLength :unsigned-long) (oTextBefore (:pointer :signed-long)) (oTextAfter (:pointer :signed-long)) (oAscent (:pointer :signed-long)) (oDescent (:pointer :signed-long))) 
  :osstatus
   () )

; 
;  *  ATSUMeasureTextImage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUMeasureTextImage" 
      ((iTextLayout :pointer) (iLineOffset :unsigned-long) (iLineLength :unsigned-long) (iLocationX :signed-long) (iLocationY :signed-long) (oTextImageRect (:pointer :rect))) 
  :osstatus
   () )

;   Highlighting    
; 
;  *  ATSUHighlightText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUHighlightText" 
      ((iTextLayout :pointer) (iTextBasePointX :signed-long) (iTextBasePointY :signed-long) (iHighlightStart :unsigned-long) (iHighlightLength :unsigned-long)) 
  :osstatus
   () )

; 
;  *  ATSUUnhighlightText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUUnhighlightText" 
      ((iTextLayout :pointer) (iTextBasePointX :signed-long) (iTextBasePointY :signed-long) (iHighlightStart :unsigned-long) (iHighlightLength :unsigned-long)) 
  :osstatus
   () )

; 
;  *  ATSUGetTextHighlight()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetTextHighlight" 
      ((iTextLayout :pointer) (iTextBasePointX :signed-long) (iTextBasePointY :signed-long) (iHighlightStart :unsigned-long) (iHighlightLength :unsigned-long) (oHighlightRegion (:handle :macregion))) 
  :osstatus
   () )

;   Hit-testing 
; 
;  *  ATSUPositionToOffset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUPositionToOffset" 
      ((iTextLayout :pointer) (iLocationX :signed-long) (iLocationY :signed-long) (ioPrimaryOffset (:pointer :unsigned-long)) (oIsLeading (:pointer :boolean)) (oSecondaryOffset (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUOffsetToPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUOffsetToPosition" 
      ((iTextLayout :pointer) (iOffset :unsigned-long) (iIsLeading :boolean) (oMainCaret (:pointer :atsucaret)) (oSecondCaret (:pointer :atsucaret)) (oCaretIsSplit (:pointer :boolean))) 
  :osstatus
   () )

; 
;  *  ATSUPositionToCursorOffset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 9.2.2 and later
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.1 and later
;  

(deftrap-inline "_ATSUPositionToCursorOffset" 
      ((iTextLayout :pointer) (iLocationX :signed-long) (iLocationY :signed-long) (iMovementType :unsigned-integer) (ioPrimaryOffset (:pointer :unsigned-long)) (oIsLeading (:pointer :boolean)) (oSecondaryOffset (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUOffsetToCursorPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 9.2.2 and later
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.1 and later
;  

(deftrap-inline "_ATSUOffsetToCursorPosition" 
      ((iTextLayout :pointer) (iOffset :unsigned-long) (iIsLeading :boolean) (iMovementType :unsigned-integer) (oMainCaret (:pointer :atsucaret)) (oSecondCaret (:pointer :atsucaret)) (oCaretIsSplit (:pointer :boolean))) 
  :osstatus
   () )

;   Cursor movement 
; 
;  *  ATSUNextCursorPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUNextCursorPosition" 
      ((iTextLayout :pointer) (iOldOffset :unsigned-long) (iMovementType :unsigned-integer) (oNewOffset (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUPreviousCursorPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUPreviousCursorPosition" 
      ((iTextLayout :pointer) (iOldOffset :unsigned-long) (iMovementType :unsigned-integer) (oNewOffset (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSURightwardCursorPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSURightwardCursorPosition" 
      ((iTextLayout :pointer) (iOldOffset :unsigned-long) (iMovementType :unsigned-integer) (oNewOffset (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSULeftwardCursorPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSULeftwardCursorPosition" 
      ((iTextLayout :pointer) (iOldOffset :unsigned-long) (iMovementType :unsigned-integer) (oNewOffset (:pointer :unsigned-long))) 
  :osstatus
   () )

;   Line breaking   
; 
;  *  ATSUBreakLine()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUBreakLine" 
      ((iTextLayout :pointer) (iLineStart :unsigned-long) (iLineWidth :signed-long) (iUseAsSoftLineBreak :boolean) (oLineBreak (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUSetSoftLineBreak()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUSetSoftLineBreak" 
      ((iTextLayout :pointer) (iLineBreak :unsigned-long)) 
  :osstatus
   () )

; 
;  *  ATSUGetSoftLineBreaks()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetSoftLineBreaks" 
      ((iTextLayout :pointer) (iRangeStart :unsigned-long) (iRangeLength :unsigned-long) (iMaximumBreaks :unsigned-long) (oBreaks (:pointer :unsigned-long)) (oBreakCount (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUClearSoftLineBreaks()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUClearSoftLineBreaks" 
      ((iTextLayout :pointer) (iRangeStart :unsigned-long) (iRangeLength :unsigned-long)) 
  :osstatus
   () )

;   Font matching   
; 
;  *  ATSUSetFontFallbacks()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_ATSUSetFontFallbacks" 
      ((iFontFallbacksCount :unsigned-long) (iFontIDs (:pointer :unsigned-long)) (iFontFallbackMethod :unsigned-integer)) 
  :osstatus
   () )

; 
;  *  ATSUGetFontFallbacks()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetFontFallbacks" 
      ((iMaxFontFallbacksCount :unsigned-long) (oFontIDs (:pointer :unsigned-long)) (oFontFallbackMethod (:pointer :unsigned-integer)) (oActualFallbacksCount (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUMatchFontsToText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUMatchFontsToText" 
      ((iTextLayout :pointer) (iTextStart :unsigned-long) (iTextLength :unsigned-long) (oFontID (:pointer :unsigned-long)) (oChangedOffset (:pointer :unsigned-long)) (oChangedLength (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUSetTransientFontMatching()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUSetTransientFontMatching" 
      ((iTextLayout :pointer) (iTransientFontMatching :boolean)) 
  :osstatus
   () )

; 
;  *  ATSUGetTransientFontMatching()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetTransientFontMatching" 
      ((iTextLayout :pointer) (oTransientFontMatching (:pointer :boolean))) 
  :osstatus
   () )

;   Font ID's   
; 
;  *  ATSUFontCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUFontCount" 
      ((oFontCount (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUGetFontIDs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetFontIDs" 
      ((oFontIDs (:pointer :unsigned-long)) (iArraySize :unsigned-long) (oFontCount (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUFONDtoFontID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUFONDtoFontID" 
      ((iFONDNumber :signed-integer) (iFONDStyle :signed-byte) (oFontID (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUFontIDtoFOND()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUFontIDtoFOND" 
      ((iFontID :unsigned-long) (oFONDNumber (:pointer :signed-integer)) (oFONDStyle (:pointer (:unsigned-byte :set (#:bold #:italic #:underline #:outline shadow #:condense #:extend))))) 
  :osstatus
   () )

;   Font names  
; 
;  *  ATSUCountFontNames()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUCountFontNames" 
      ((iFontID :unsigned-long) (oFontNameCount (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUGetIndFontName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetIndFontName" 
      ((iFontID :unsigned-long) (iFontNameIndex :unsigned-long) (iMaximumNameLength :unsigned-long) (oName :pointer) (oActualNameLength (:pointer :unsigned-long)) (oFontNameCode (:pointer :unsigned-long)) (oFontNamePlatform (:pointer :unsigned-long)) (oFontNameScript (:pointer :unsigned-long)) (oFontNameLanguage (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUFindFontName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUFindFontName" 
      ((iFontID :unsigned-long) (iFontNameCode :unsigned-long) (iFontNamePlatform :unsigned-long) (iFontNameScript :unsigned-long) (iFontNameLanguage :unsigned-long) (iMaximumNameLength :unsigned-long) (oName :pointer) (oActualNameLength (:pointer :unsigned-long)) (oFontNameIndex (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUFindFontFromName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUFindFontFromName" 
      ((iName :pointer) (iNameLength :unsigned-long) (iFontNameCode :unsigned-long) (iFontNamePlatform :unsigned-long) (iFontNameScript :unsigned-long) (iFontNameLanguage :unsigned-long) (oFontID (:pointer :unsigned-long))) 
  :osstatus
   () )

;   Font features   
; 
;  *  ATSUCountFontFeatureTypes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUCountFontFeatureTypes" 
      ((iFontID :unsigned-long) (oTypeCount (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUCountFontFeatureSelectors()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUCountFontFeatureSelectors" 
      ((iFontID :unsigned-long) (iType :unsigned-integer) (oSelectorCount (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUGetFontFeatureTypes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetFontFeatureTypes" 
      ((iFontID :unsigned-long) (iMaximumTypes :unsigned-long) (oTypes (:pointer :unsigned-integer)) (oActualTypeCount (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUGetFontFeatureSelectors()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetFontFeatureSelectors" 
      ((iFontID :unsigned-long) (iType :unsigned-integer) (iMaximumSelectors :unsigned-long) (oSelectors (:pointer :unsigned-integer)) (oSelectorIsOnByDefault (:pointer :boolean)) (oActualSelectorCount (:pointer :unsigned-long)) (oIsMutuallyExclusive (:pointer :boolean))) 
  :osstatus
   () )

; 
;  *  ATSUGetFontFeatureNameCode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetFontFeatureNameCode" 
      ((iFontID :unsigned-long) (iType :unsigned-integer) (iSelector :unsigned-integer) (oNameCode (:pointer :unsigned-long))) 
  :osstatus
   () )

;   Font tracking value & names 
; 
;  *  ATSUCountFontTracking()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUCountFontTracking" 
      ((iFontID :unsigned-long) (iCharacterOrientation :unsigned-integer) (oTrackingCount (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUGetIndFontTracking()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetIndFontTracking" 
      ((iFontID :unsigned-long) (iCharacterOrientation :unsigned-integer) (iTrackIndex :unsigned-long) (oFontTrackingValue (:pointer :signed-long)) (oNameCode (:pointer :unsigned-long))) 
  :osstatus
   () )

;   Font variations 
; 
;  *  ATSUCountFontVariations()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUCountFontVariations" 
      ((iFontID :unsigned-long) (oVariationCount (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUGetIndFontVariation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetIndFontVariation" 
      ((iFontID :unsigned-long) (iVariationIndex :unsigned-long) (oATSUFontVariationAxis (:pointer :ostype)) (oMinimumValue (:pointer :signed-long)) (oMaximumValue (:pointer :signed-long)) (oDefaultValue (:pointer :signed-long))) 
  :osstatus
   () )

; 
;  *  ATSUGetFontVariationNameCode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetFontVariationNameCode" 
      ((iFontID :unsigned-long) (iAxis :ostype) (oNameCode (:pointer :unsigned-long))) 
  :osstatus
   () )

;   Font Instances  
; 
;  *  ATSUCountFontInstances()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUCountFontInstances" 
      ((iFontID :unsigned-long) (oInstances (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUGetFontInstance()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetFontInstance" 
      ((iFontID :unsigned-long) (iFontInstanceIndex :unsigned-long) (iMaximumVariations :unsigned-long) (oAxes (:pointer :ostype)) (oValues (:pointer :signed-long)) (oActualVariationCount (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ATSUGetFontInstanceNameCode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetFontInstanceNameCode" 
      ((iFontID :unsigned-long) (iInstanceIndex :unsigned-long) (oNameCode (:pointer :unsigned-long))) 
  :osstatus
   () )

; *****************************************************************************
;  ATSUI Low-Level API                                                         
; *****************************************************************************
;  GlyphInfo access 
; 
;  *  ATSUGetGlyphInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetGlyphInfo" 
      ((iTextLayout :pointer) (iLineStart :unsigned-long) (iLineLength :unsigned-long) (ioBufferSize (:pointer :unsigned-long)) (oGlyphInfoPtr (:pointer :atsuglyphinfoarray))) 
  :osstatus
   () )

; 
;  *  ATSUDrawGlyphInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUDrawGlyphInfo" 
      ((iGlyphInfoArray (:pointer :atsuglyphinfoarray)) (iLocation :float32point)) 
  :osstatus
   () )

;  Font Data Access 
; 
;  *  ATSUGlyphGetIdealMetrics()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGlyphGetIdealMetrics" 
      ((iATSUStyle :pointer) (iNumOfGlyphs :unsigned-long) (iGlyphIDs (:pointer :unsigned-integer)) (iInputOffset :unsigned-long) (oIdealMetrics (:pointer :atsglyphidealmetrics))) 
  :osstatus
   () )

; 
;  *  ATSUGetNativeCurveType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGetNativeCurveType" 
      ((iATSUStyle :pointer) (oCurveType (:pointer :unsigned-integer))) 
  :osstatus
   () )

;  Device specific routines 
; 
;  *  ATSUGlyphGetScreenMetrics()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGlyphGetScreenMetrics" 
      ((iATSUStyle :pointer) (iNumOfGlyphs :unsigned-long) (iGlyphIDs (:pointer :unsigned-integer)) (iInputOffset :unsigned-long) (iForcingAntiAlias :boolean) (iAntiAliasSwitch :boolean) (oScreenMetrics (:pointer :atsglyphscreenmetrics))) 
  :osstatus
   () )

;  ATSUGlyphGetQuadraticPaths callbacks 

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ATSQuadraticLineProcPtr = FUNCTION({CONST}VAR pt1: Float32Point; {CONST}VAR pt2: Float32Point; callBackDataPtr: UNIV Ptr): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :atsquadraticlineprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ATSQuadraticCurveProcPtr = FUNCTION({CONST}VAR pt1: Float32Point; {CONST}VAR controlPt: Float32Point; {CONST}VAR pt2: Float32Point; callBackDataPtr: UNIV Ptr): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :atsquadraticcurveprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ATSQuadraticNewPathProcPtr = FUNCTION(callBackDataPtr: UNIV Ptr): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :atsquadraticnewpathprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ATSQuadraticClosePathProcPtr = FUNCTION(callBackDataPtr: UNIV Ptr): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :atsquadraticclosepathprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :atsquadraticlineupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :atsquadraticlineupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :atsquadraticcurveupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :atsquadraticcurveupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :atsquadraticnewpathupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :atsquadraticnewpathupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :atsquadraticclosepathupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :atsquadraticclosepathupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppATSQuadraticLineProcInfo #xFF0)
(defconstant $uppATSQuadraticCurveProcInfo #x3FF0)
(defconstant $uppATSQuadraticNewPathProcInfo #xF0)
(defconstant $uppATSQuadraticClosePathProcInfo #xF0)
; 
; 	 *  NewATSQuadraticLineUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_NewATSQuadraticLineUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewATSQuadraticCurveUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_NewATSQuadraticCurveUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewATSQuadraticNewPathUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_NewATSQuadraticNewPathUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewATSQuadraticClosePathUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_NewATSQuadraticClosePathUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeATSQuadraticLineUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeATSQuadraticLineUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeATSQuadraticCurveUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeATSQuadraticCurveUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeATSQuadraticNewPathUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeATSQuadraticNewPathUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeATSQuadraticClosePathUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeATSQuadraticClosePathUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeATSQuadraticLineUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_InvokeATSQuadraticLineUPP" 
      ((pt1 (:pointer :float32point)) (pt2 (:pointer :float32point)) (callBackDataPtr :pointer) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

; 
;  *  InvokeATSQuadraticCurveUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST; CONST
(deftrap-inline "_InvokeATSQuadraticCurveUPP" 
      ((pt1 (:pointer :float32point)) (controlPt (:pointer :float32point)) (pt2 (:pointer :float32point)) (callBackDataPtr :pointer) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

; 
;  *  InvokeATSQuadraticNewPathUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_InvokeATSQuadraticNewPathUPP" 
      ((callBackDataPtr :pointer) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

; 
;  *  InvokeATSQuadraticClosePathUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_InvokeATSQuadraticClosePathUPP" 
      ((callBackDataPtr :pointer) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

; 
;  *  ATSUGlyphGetQuadraticPaths()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGlyphGetQuadraticPaths" 
      ((iATSUStyle :pointer) (iGlyphID :unsigned-integer) (iNewPathProc :pointer) (iLineProc :pointer) (iCurveProc :pointer) (iClosePathProc :pointer) (iCallbackDataPtr :pointer) (oCallbackResult (:pointer :signed-long))) 
  :osstatus
   () )

;  ATSUGlyphGetCubicPaths callbacks 

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ATSCubicMoveToProcPtr = FUNCTION({CONST}VAR pt: Float32Point; callBackDataPtr: UNIV Ptr): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :atscubicmovetoprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ATSCubicLineToProcPtr = FUNCTION({CONST}VAR pt: Float32Point; callBackDataPtr: UNIV Ptr): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :atscubiclinetoprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ATSCubicCurveToProcPtr = FUNCTION({CONST}VAR pt1: Float32Point; {CONST}VAR pt2: Float32Point; {CONST}VAR pt3: Float32Point; callBackDataPtr: UNIV Ptr): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :atscubiccurvetoprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ATSCubicClosePathProcPtr = FUNCTION(callBackDataPtr: UNIV Ptr): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :atscubicclosepathprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :atscubicmovetoupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :atscubicmovetoupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :atscubiclinetoupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :atscubiclinetoupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :atscubiccurvetoupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :atscubiccurvetoupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :atscubicclosepathupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :atscubicclosepathupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppATSCubicMoveToProcInfo #x3F0)
(defconstant $uppATSCubicLineToProcInfo #x3F0)
(defconstant $uppATSCubicCurveToProcInfo #x3FF0)
(defconstant $uppATSCubicClosePathProcInfo #xF0)
; 
; 	 *  NewATSCubicMoveToUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_NewATSCubicMoveToUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewATSCubicLineToUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_NewATSCubicLineToUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewATSCubicCurveToUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_NewATSCubicCurveToUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewATSCubicClosePathUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_NewATSCubicClosePathUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeATSCubicMoveToUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeATSCubicMoveToUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeATSCubicLineToUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeATSCubicLineToUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeATSCubicCurveToUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeATSCubicCurveToUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeATSCubicClosePathUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeATSCubicClosePathUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeATSCubicMoveToUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_InvokeATSCubicMoveToUPP" 
      ((pt (:pointer :float32point)) (callBackDataPtr :pointer) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

; 
;  *  InvokeATSCubicLineToUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_InvokeATSCubicLineToUPP" 
      ((pt (:pointer :float32point)) (callBackDataPtr :pointer) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

; 
;  *  InvokeATSCubicCurveToUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST; CONST
(deftrap-inline "_InvokeATSCubicCurveToUPP" 
      ((pt1 (:pointer :float32point)) (pt2 (:pointer :float32point)) (pt3 (:pointer :float32point)) (callBackDataPtr :pointer) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

; 
;  *  InvokeATSCubicClosePathUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_InvokeATSCubicClosePathUPP" 
      ((callBackDataPtr :pointer) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

; 
;  *  ATSUGlyphGetCubicPaths()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGlyphGetCubicPaths" 
      ((iATSUStyle :pointer) (iGlyphID :unsigned-integer) (iMoveToProc :pointer) (iLineToProc :pointer) (iCurveToProc :pointer) (iClosePathProc :pointer) (iCallbackDataPtr :pointer) (oCallbackResult (:pointer :signed-long))) 
  :osstatus
   () )

; 
;  *  ATSUGlyphGetCurvePaths()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ATSUnicodeLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ATSUGlyphGetCurvePaths" 
      ((iATSUStyle :pointer) (iGlyphID :unsigned-integer) (ioBufferSize (:pointer :unsigned-long)) (oPaths (:pointer :atsucurvepaths))) 
  :osstatus
   () )

; ***********************************************************************
; 
;  *  ATSUSetHighlightingMethod()
;  *  
;  *  Discussion:
;  *    By default ATSUI will highlight text by simply inverting the
;  *    text. When a user is using gray-scale text this does not always
;  *    provide the best appearance. On MacOS 9 gray-scale is available,
;  *    but can be turned off by a user.  MacOS X always uses gray-scale.
;  *     A better way to highlight gray-scale text is to first paint the
;  *    highlight color and then redraw the text.  Begining with version
;  *    2.0 (?) of ATSUI this method is available.  However,
;  *    unhighlighting text when this technique is used is more
;  *    complicated.  The details of exactly what the background looks
;  *    like must be known to whoever unhighlights the text. When using
;  *    the redraw method of highlighting ATSUI will redraw the
;  *    background if it is a single color(e.g. white).  If this is the
;  *    case set iMethod to kRedrawToHighlight, set
;  *    iUnhighlightData.dataType to kATSUBackgroundColor and specify the
;  *    background color in
;  *    iUnhighlightData.unhighlightData.backgroundColor.  When these
;  *    settings are supplied then ATSUI will calculate the highlight
;  *    area paint it with the specified backgroundColor and then redraw
;  *    the text. For more complex backgrounds (multiple colors,
;  *    patterns, pictures, etc.) you need to supply a callback that
;  *    ATSUI will call when the background needs to be repainted (See
;  *    above RedrawBackgroundProcPtr ).  When your callback is called
;  *    you should redraw the background.  If you choose to also redraw
;  *    the text then you should return false as a function result. If
;  *    you return true ATSUI will redraw any text that needs to be
;  *    redrawn.
;  *  
;  *  Parameters:
;  *    
;  *    iTextLayout:
;  *      The layout to which this highlight method should be applied.
;  *    
;  *    iMethod:
;  *      The type of highlighting to use (inversion or redrawing) The
;  *      default is inversion.  If you are happy with that technique
;  *      there is no reason to call this function.
;  *    
;  *    iUnhighlightData:
;  *      Data needed to redraw the background or NULL if inversion is
;  *      being chosen.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_ATSUSetHighlightingMethod" 
      ((iTextLayout :pointer) (iMethod :unsigned-long) (iUnhighlightData (:pointer :atsuunhighlightdata))) 
  :osstatus
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := ATSUnicodeIncludes

; $ENDC                                         ; __ATSUNICODE__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'ATSUnicode)