(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:AppleTalk.p"
; at Wednesday May 1,2002 2:38:45 pm.
; 
;      File:       AppleTalk.p
;  
;      Contains:   AppleTalk Interfaces.
;  
;      Version:    Technology: System 8.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __APPLETALK__
; $SETC __APPLETALK__ := 1

; $I+
; $SETC AppleTalkIncludes := UsingIncludes
; $SETC UsingIncludes := 1

; $IFC UNDEFINED __MACTYPES__

(require-interface 'MacTypes)                   ; $I MacTypes.p
; $ENDC
; $IFC UNDEFINED __OSUTILS__

(require-interface 'OSUtils)                    ; $I OSUtils.p
; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;   Driver unit numbers (ADSP is dynamic)  
(defconstant $mppUnitNum 9)                     ;   MPP unit number  
(defconstant $atpUnitNum 10)                    ;   ATP unit number  
(defconstant $xppUnitNum 40)                    ;   XPP unit number  

;   Driver refNums (ADSP is dynamic)  
(defconstant $mppRefNum -10)                    ;   MPP reference number  
(defconstant $atpRefNum -11)                    ;   ATP reference number  
(defconstant $xppRefNum -41)                    ;   XPP reference number  

;   .MPP csCodes  
(defconstant $lookupReply 242)                  ;   This command queued to ourself  
(defconstant $writeLAP 243)                     ;   Write out LAP packet  
(defconstant $detachPH 244)                     ;   Detach LAP protocol handler  
(defconstant $attachPH 245)                     ;   Attach LAP protocol handler  
(defconstant $writeDDP 246)                     ;   Write out DDP packet  
(defconstant $closeSkt 247)                     ;   Close DDP socket  
(defconstant $openSkt 248)                      ;   Open DDP socket  
(defconstant $loadNBP 249)                      ;   Load NBP command-executing code  
(defconstant $lastResident 249)                 ;   Last resident command  
(defconstant $confirmName 250)                  ;   Confirm name  
(defconstant $lookupName 251)                   ;   Look up name on internet  
(defconstant $removeName 252)                   ;   Remove name from Names Table  
(defconstant $registerName 253)                 ;   Register name in Names Table  
(defconstant $killNBP 254)                      ;   Kill outstanding NBP request  
(defconstant $unloadNBP 255)                    ;   Unload NBP command code  
(defconstant $setSelfSend 256)                  ;   MPP: Set to allow writes to self  
(defconstant $SetMyZone 257)                    ;   Set my zone name  
(defconstant $GetATalkInfo 258)                 ;   get AppleTalk information  
(defconstant $ATalkClosePrep 259)               ;   AppleTalk close query  

;   .ATP csCodes  
(defconstant $nSendRequest 248)                 ;   NSendRequest code  
(defconstant $relRspCB 249)                     ;   Release RspCB  
(defconstant $closeATPSkt 250)                  ;   Close ATP socket  
(defconstant $addResponse 251)                  ;   Add response code | Require open skt  
(defconstant $sendResponse 252)                 ;   Send response code  
(defconstant $getRequest 253)                   ;   Get request code  
(defconstant $openATPSkt 254)                   ;   Open ATP socket  
(defconstant $sendRequest 255)                  ;   Send request code  
(defconstant $relTCB 256)                       ;   Release TCB  
(defconstant $killGetReq 257)                   ;   Kill GetRequest  
(defconstant $killSendReq 258)                  ;   Kill SendRequest  
(defconstant $killAllGetReq 259)                ;   Kill all getRequests for a skt  

;   .XPP csCodes  
(defconstant $openSess 255)                     ;   Open session  
(defconstant $closeSess 254)                    ;   Close session  
(defconstant $userCommand 253)                  ;   User command  
(defconstant $userWrite 252)                    ;   User write  
(defconstant $getStatus 251)                    ;   Get status  
(defconstant $afpCall 250)                      ;   AFP command (buffer has command code)  
(defconstant $getParms 249)                     ;   Get parameters  
(defconstant $abortOS 248)                      ;   Abort open session request  
(defconstant $closeAll 247)                     ;   Close all open sessions  
(defconstant $xCall 246)                        ;   .XPP extended calls  

;   Transition Queue transition types  
(defconstant $ATTransOpen 0)                    ;  AppleTalk has opened 
(defconstant $ATTransClose 2)                   ;  AppleTalk is about to close 
(defconstant $ATTransClosePrep 3)               ;  Is it OK to close AppleTalk ? 
(defconstant $ATTransCancelClose 4)             ;  Cancel the ClosePrep transition 

(defconstant $afpByteRangeLock 1)               ;  AFPCall command codes 
(defconstant $afpVolClose 2)                    ;  AFPCall command codes 
(defconstant $afpDirClose 3)                    ;  AFPCall command codes 
(defconstant $afpForkClose 4)                   ;  AFPCall command codes 
(defconstant $afpCopyFile 5)                    ;  AFPCall command codes 
(defconstant $afpDirCreate 6)                   ;  AFPCall command codes 
(defconstant $afpFileCreate 7)                  ;  AFPCall command codes 
(defconstant $afpDelete 8)                      ;  AFPCall command codes 
(defconstant $afpEnumerate 9)                   ;  AFPCall command codes 
(defconstant $afpFlush 10)                      ;  AFPCall command codes 
(defconstant $afpForkFlush 11)                  ;  AFPCall command codes 
(defconstant $afpGetDirParms 12)                ;  AFPCall command codes 
(defconstant $afpGetFileParms 13)               ;  AFPCall command codes 
(defconstant $afpGetForkParms 14)               ;  AFPCall command codes 
(defconstant $afpGetSInfo 15)                   ;  AFPCall command codes 
(defconstant $afpGetSParms 16)                  ;  AFPCall command codes 
(defconstant $afpGetVolParms 17)                ;  AFPCall command codes 
(defconstant $afpLogin 18)                      ;  AFPCall command codes 
(defconstant $afpContLogin 19)                  ;  AFPCall command codes 
(defconstant $afpLogout 20)                     ;  AFPCall command codes 
(defconstant $afpMapID 21)                      ;  AFPCall command codes 
(defconstant $afpMapName 22)                    ;  AFPCall command codes 
(defconstant $afpMove 23)                       ;  AFPCall command codes 
(defconstant $afpOpenVol 24)                    ;  AFPCall command codes 
(defconstant $afpOpenDir 25)                    ;  AFPCall command codes 
(defconstant $afpOpenFork 26)                   ;  AFPCall command codes 
(defconstant $afpRead 27)                       ;  AFPCall command codes 
(defconstant $afpRename 28)                     ;  AFPCall command codes 
(defconstant $afpSetDirParms 29)                ;  AFPCall command codes 
(defconstant $afpSetFileParms 30)               ;  AFPCall command codes 
(defconstant $afpSetForkParms 31)               ;  AFPCall command codes 
(defconstant $afpSetVolParms 32)                ;  AFPCall command codes 
(defconstant $afpWrite 33)                      ;  AFPCall command codes 
(defconstant $afpGetFlDrParms 34)               ;  AFPCall command codes 
(defconstant $afpSetFlDrParms 35)               ;  AFPCall command codes 
(defconstant $afpDTOpen 48)                     ;  AFPCall command codes 
(defconstant $afpDTClose 49)                    ;  AFPCall command codes 
(defconstant $afpGetIcon 51)                    ;  AFPCall command codes 
(defconstant $afpGtIcnInfo 52)                  ;  AFPCall command codes 
(defconstant $afpAddAPPL 53)                    ;  AFPCall command codes 
(defconstant $afpRmvAPPL 54)                    ;  AFPCall command codes 
(defconstant $afpGetAPPL 55)                    ;  AFPCall command codes 
(defconstant $afpAddCmt 56)                     ;  AFPCall command codes 
(defconstant $afpRmvCmt 57)                     ;  AFPCall command codes 
(defconstant $afpGetCmt 58)                     ;  AFPCall command codes 
(defconstant $afpAddIcon 192)                   ;  Special code for ASP Write commands 

(defconstant $xppLoadedBit 5)                   ;   XPP bit in PortBUse  
(defconstant $scbMemSize 192)                   ;   Size of memory for SCB  
(defconstant $xppFlagClr 0)                     ;   Cs for AFPCommandBlock  

(defconstant $xppFlagSet 128)                   ;   StartEndFlag & NewLineFlag fields.  

(defconstant $lapSize 20)
(defconstant $ddpSize 26)
(defconstant $nbpSize 26)
(defconstant $atpSize 56)

(defconstant $atpXOvalue 32)                    ;  ATP exactly-once bit  
(defconstant $atpEOMvalue 16)                   ;  ATP End-Of-Message bit  
(defconstant $atpSTSvalue 8)                    ;  ATP Send-Transmission-Status bit  
(defconstant $atpTIDValidvalue 2)               ;  ATP trans. ID valid bit  
(defconstant $atpSendChkvalue 1)                ;  ATP send checksum bit  

(defconstant $zipGetLocalZones 5)
(defconstant $zipGetZoneList 6)
(defconstant $zipGetMyZone 7)

(defconstant $LAPMgrPtr #xB18)                  ;  Entry point for LAP Manager 

(defconstant $LAPMgrCall 2)                     ;  Offset to LAP routines 
(defconstant $LAddAEQ 23)                       ;  LAPAddATQ routine selector 
(defconstant $LRmvAEQ 24)                       ;  LAPRmvATQ routine selector 

(defconstant $tLAPRead 0)
(defconstant $tLAPWrite 1)
(defconstant $tDDPRead 2)
(defconstant $tDDPWrite 3)
(defconstant $tNBPLookup 4)
(defconstant $tNBPConfirm 5)
(defconstant $tNBPRegister 6)
(defconstant $tATPSndRequest 7)
(defconstant $tATPGetRequest 8)
(defconstant $tATPSdRsp 9)
(defconstant $tATPAddRsp 10)
(defconstant $tATPRequest 11)
(defconstant $tATPResponse 12)

(def-mactype :abcalltype (find-mactype ':signed-byte))

(defconstant $lapProto 0)
(defconstant $ddpProto 1)
(defconstant $nbpProto 2)
(defconstant $atpProto 3)

(def-mactype :abprototype (find-mactype ':unsigned-byte))
(def-mactype :abbyte (find-mactype ':unsigned-byte))
(def-mactype :lapadrblockptr (find-mactype '(:pointer :lapadrblock)))
(defrecord LAPAdrBlock 
   (dstNodeID :unsigned-byte)
   (srcNodeID :unsigned-byte)
   (lapProtType :unsigned-byte)
   (filler :unsigned-byte)                      ;      Filler for proper byte alignment 
   )

(def-mactype :atqentryptr (find-mactype '(:pointer :atqentry)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ATalkTransitionEventProcPtr = FUNCTION(eventCode: LONGINT; qElem: ATQEntryPtr; eventParameter: UNIV Ptr): LONGINT; C;

|#
 |#                                             ; $ELSEC
(def-mactype :atalktransitioneventprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :atalktransitioneventupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :atalktransitioneventupp (find-mactype ':pointer))
; $ENDC
(def-mactype :atalktransitionevent (find-mactype ':pointer))
(defrecord ATQEntry 
   (qLink (:pointer :atqentry))                 ;  next queue entry 
   (qType :signed-integer)                      ;  queue type 
   (CallAddr :pointer)                          ;  your routine descriptor 
   )

; 	 
; 	    Real definition of EntityName is 3 PACKED strings of any length (32 is just an example). No
; 	    offests for Asm since each String address must be calculated by adding length byte to last string ptr.
; 	    In Pascal, String(32) will be 34 bytes long since fields never start on an odd byte unless they are 
; 	    only a byte long. So this will generate correct looking interfaces for Pascal and C, but they will not
; 	    be the same, which is OK since they are not used. 
; 		
(def-mactype :entitynameptr (find-mactype '(:pointer :entityname)))
(defrecord EntityName 
   (objStr (:string 32))
   (typeStr (:string 32))
   (zoneStr (:string 32))
   )

(def-mactype :entityptr (find-mactype '(:pointer :entityname)))
(def-mactype :addrblockptr (find-mactype '(:pointer :addrblock)))
(defrecord AddrBlock 
   (aNet :unsigned-integer)
   (aNode :unsigned-byte)
   (aSocket :unsigned-byte)
   )

(def-mactype :retranstypeptr (find-mactype '(:pointer :retranstype)))
(defrecord RetransType 
   (retransInterval :unsigned-byte)
   (retransCount :unsigned-byte)
   )

(def-mactype :bdselementptr (find-mactype '(:pointer :bdselement)))
(defrecord BDSElement 
   (buffSize :signed-integer)
   (buffPtr :pointer)
   (dataSize :signed-integer)
   (userBytes :signed-long)
   )

(defrecord BDSType (array (:array :bdselement 8)))
(def-mactype :bdsptr (find-mactype '(:pointer :bdselement)))
(defrecord BitMapType (array (:array :boolean 8 :packed)))
(def-mactype :atlaprecptr (find-mactype '(:pointer :atlaprec)))
(defrecord ATLAPRec 
   (abOpcode :signed-byte)
   (filler :signed-byte)                        ;      Filler for proper byte alignment 
   (abResult :signed-integer)
   (abUserReference :signed-long)
   (lapAddress :lapadrblock)
   (lapReqCount :signed-integer)
   (lapActCount :signed-integer)
   (lapDataPtr :pointer)
   )

(def-mactype :atlaprechandle (find-mactype '(:handle :atlaprec)))
(def-mactype :atddprecptr (find-mactype '(:pointer :atddprec)))
(defrecord ATDDPRec 
   (abOpcode :signed-byte)
   (filler :signed-byte)                        ;      Filler for proper byte alignment 
   (abResult :signed-integer)
   (abUserReference :signed-long)
   (ddpType :signed-integer)
   (ddpSocket :signed-integer)
   (ddpAddress :addrblock)
   (ddpReqCount :signed-integer)
   (ddpActCount :signed-integer)
   (ddpDataPtr :pointer)
   (ddpNodeID :signed-integer)
   )

(def-mactype :atddprechandle (find-mactype '(:handle :atddprec)))
(def-mactype :atnbprecptr (find-mactype '(:pointer :atnbprec)))
(defrecord ATNBPRec 
   (abOpcode :signed-byte)
   (filler :signed-byte)                        ;      Filler for proper byte alignment 
   (abResult :signed-integer)
   (abUserReference :signed-long)
   (nbpEntityPtr (:pointer :entityname))
   (nbpBufPtr :pointer)
   (nbpBufSize :signed-integer)
   (nbpDataField :signed-integer)
   (nbpAddress :addrblock)
   (nbpRetransmitInfo :retranstype)
   )

(def-mactype :atnbprechandle (find-mactype '(:handle :atnbprec)))
(def-mactype :atatprecptr (find-mactype '(:pointer :atatprec)))
(defrecord ATATPRec 
   (abOpcode :signed-byte)
   (filler1 :signed-byte)                       ;      Filler for proper byte alignment 
   (abResult :signed-integer)
   (abUserReference :signed-long)
   (atpSocket :signed-integer)
   (atpAddress :addrblock)
   (atpReqCount :signed-integer)
   (atpDataPtr :pointer)
   (atpRspBDSPtr (:pointer :bdselement))
   (atpBitMap :signed-byte)
   (filler2 :signed-byte)                       ;      Filler for proper byte alignment 
   (atpTransID :signed-integer)
   (atpActCount :signed-integer)
   (atpUserData :signed-long)
   (atpXO :boolean)
   (atpEOM :boolean)
   (atpTimeOut :signed-integer)
   (atpRetries :signed-integer)
   (atpNumBufs :signed-integer)
   (atpNumRsp :signed-integer)
   (atpBDSSize :signed-integer)
   (atpRspUData :signed-long)
   (atpRspBuf :pointer)
   (atpRspSize :signed-integer)
   )

(def-mactype :atatprechandle (find-mactype '(:handle :atatprec)))
(def-mactype :afpcommandblockptr (find-mactype '(:pointer :afpcommandblock)))
(defrecord AFPCommandBlock 
   (cmdByte :unsigned-byte)
   (startEndFlag :unsigned-byte)
   (forkRefNum :signed-integer)
   (rwOffset :signed-long)
   (reqCount :signed-long)
   (newLineFlag :unsigned-byte)
   (newLineChar :character)
   )

(def-mactype :mppparamblockptr (find-mactype '(:pointer :mppparamblock)))
(def-mactype :atpparamblockptr (find-mactype '(:pointer :atpparamblock)))
(def-mactype :xppparamblockptr (find-mactype '(:pointer :xppparamblock)))
(def-mactype :mpppbptr (find-mactype '(:pointer :mppparamblock)))
(def-mactype :atppbptr (find-mactype '(:pointer :atpparamblock)))
(def-mactype :xppparmblkptr (find-mactype '(:pointer :xppparamblock)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	MPPCompletionProcPtr = PROCEDURE(thePBptr: MPPPBPtr);

|#
 |#                                             ; $ELSEC
(def-mactype :mppcompletionprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ATPCompletionProcPtr = PROCEDURE(thePBptr: ATPPBPtr);

|#
 |#                                             ; $ELSEC
(def-mactype :atpcompletionprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	XPPCompletionProcPtr = PROCEDURE(thePBptr: XPPParmBlkPtr);

|#
 |#                                             ; $ELSEC
(def-mactype :xppcompletionprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	AttnRoutineProcPtr = PROCEDURE(sessRefnum: INTEGER; attnBytes: INTEGER);

|#
 |#                                             ; $ELSEC
(def-mactype :attnroutineprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :mppcompletionupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :mppcompletionupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :atpcompletionupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :atpcompletionupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :xppcompletionupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :xppcompletionupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :attnroutineupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :attnroutineupp (find-mactype ':pointer))
; $ENDC

(def-mactype :wdselementptr (find-mactype '(:pointer :wdselement)))
(defrecord WDSElement 
   (entryLength :signed-integer)
   (entryPtr :pointer)
   )

(def-mactype :ntelementptr (find-mactype '(:pointer :ntelement)))
(defrecord NTElement 
   (nteAddress :addrblock)                      ;  network address of entity 
   (filler :signed-byte)
   (entityData (:array :signed-byte 99))        ;  Object, Type & Zone 
   )

(def-mactype :namestableentryptr (find-mactype '(:pointer :namestableentry)))
(defrecord NamesTableEntry 
   (qNext :pointer)                             ;  ptr to next NTE 
   (nt :ntelement)
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	MPPProtocolHandlerProcPtr = FUNCTION(SCCAddr1: Ptr; SCCAddr2: Ptr; MPPLocalVars: Ptr; nextFreeByteInRHA: Ptr; ReadPacketAndReadRestPtr: Ptr; numBytesLeftToReadInPacket: INTEGER): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :mppprotocolhandlerprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DDPSocketListenerProcPtr = FUNCTION(SCCAddr1: Ptr; SCCAddr2: Ptr; MPPLocalVars: Ptr; nextFreeByteInRHA: Ptr; ReadPacketAndReadRestPtr: Ptr; packetDestinationNumber: ByteParameter; numBytesLeftToReadInPacket: INTEGER): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :ddpsocketlistenerprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :mppprotocolhandlerupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :mppprotocolhandlerupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :ddpsocketlistenerupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :ddpsocketlistenerupp (find-mactype ':pointer))
; $ENDC
; 	
; 	    MPPProtocolHandlerProcs and  DDPSocketListenerProcs cannot be written 
; 	    in or called from a high-level language without the help of mixed mode 
; 	    or assembly glue because they use the following parameter-passing conventions:
; 	
; 	    typedef Boolean (*MPPProtocolHandlerProcPtr)(Ptr SCCAddr1, Ptr SCCAddr2, 
; 	            Ptr MPPLocalVars, Ptr nextFreeByteInRHA, Ptr ReadPacketAndReadRestPtr, 
; 	            short numBytesLeftToReadInPacket);
; 	
; 	        In:
; 	            =>  SCCAddr1                    A0.L
; 	            =>  SCCAddr2                    A1.L
; 	            =>  MPPLocalVars                A2.L
; 	            =>  nextFreeByteInRHA           A3.L
; 	            =>  ReadPacketAndReadRestPtr    A4.L
; 	            =>  numBytesLeftToReadInPacket  D1.W
; 	        Out:
; 	            <=  Boolean                     Z bit of CCR
; 	
; 	    typedef Boolean (*DDPSocketListenerProcPtr)(Ptr SCCAddr1, Ptr SCCAddr2, 
; 	            Ptr MPPLocalVars, Ptr nextFreeByteInRHA, Ptr ReadPacketAndReadRestPtr, 
; 	            UInt8 packetDestinationNumber, short numBytesLeftToReadInPacket);
; 	
; 	        In:
; 	            =>  SCCAddr1                    A0.L
; 	            =>  SCCAddr2                    A1.L
; 	            =>  MPPLocalVars                A2.L
; 	            =>  nextFreeByteInRHA           A3.L
; 	            =>  ReadPacketAndReadRestPtr    A4.L
; 	            =>  packetDestinationNumber     D0.B
; 	            =>  numBytesLeftToReadInPacket  D1.W
; 	        Out:
; 	            <=  Boolean                     Z bit of CCR
; 	
; 		
(defrecord MPPParamBlock 
   (qLink (:pointer :qelem))                    ;  next queue entry 
   (qType :signed-integer)                      ;  queue type 
   (ioTrap :signed-integer)                     ;  routine trap 
   (ioCmdAddr :pointer)                         ;  routine address 
   (ioCompletion :pointer)                      ;  ATPCompletionUPP or MPPCompletionUPP 
   (ioResult :signed-integer)                   ;  result code 
   (userData :signed-long)                      ;  Command result (ATP user bytes) 
   (reqTID :signed-integer)                     ;  request transaction ID 
   (ioRefNum :signed-integer)                   ;  driver reference number 
   (csCode :signed-integer)                     ;  Call command code 
   (:variant 
      (
      (filler0 :signed-integer)
      (wdsPointer :pointer)
      )
      (
      (protType :unsigned-byte)
      (filler :signed-byte)
      (handler :pointer)
      )
      (
      (socket :unsigned-byte)
      (checksumFlag :unsigned-byte)
      (listener :pointer)
      )
      (
      (interval :unsigned-byte)                 ;  retry interval  
      (count :unsigned-byte)                    ;  retry count  
      (nbpPtrs :pointer)
      (:variant 
         (
         (verifyFlag :unsigned-byte)
         (filler3 :unsigned-byte)
         )
         (
         (retBuffPtr :pointer)
         (retBuffSize :signed-integer)
         (maxToGet :signed-integer)
         (numGotten :signed-integer)
         )
         (
         (confirmAddr :addrblock)
         (newSocket :unsigned-byte)
         (filler4 :unsigned-byte)
         )
         ))
      (
      (newSelfFlag :unsigned-byte)              ;  self-send toggle flag  
      (oldSelfFlag :unsigned-byte)              ;  previous self-send state  
      )
      (
      (nKillQEl :pointer)                       ;  ptr to i/o queue element to cancel  
      )
      (
      (version :signed-integer)                 ;  requested info version 
      (varsPtr :pointer)                        ;  pointer to well known MPP vars 
      (DCEPtr :pointer)                         ;  pointer to MPP DCE 
      (portID :signed-integer)                  ;  port number [0..7] 
      (configuration :signed-long)              ;  32-bit configuration word 
      (selfSend :signed-integer)                ;  non zero if SelfSend enabled 
      (netLo :signed-integer)                   ;  low value of network range 
      (netHi :signed-integer)                   ;  high value of network range 
      (ourAdd :signed-long)                     ;  our 24-bit AppleTalk address 
      (routerAddr :signed-long)                 ;  24-bit address of (last) router 
      (numOfPHs :signed-integer)                ;  max. number of protocol handlers 
      (numOfSkts :signed-integer)               ;  max. number of static sockets 
      (numNBPEs :signed-integer)                ;  max. concurrent NBP requests 
      (nTQueue :pointer)                        ;  pointer to registered name queue 
      (LAlength :signed-integer)                ;  length in bytes of data link addr 
      (linkAddr :pointer)                       ;  data link address returned 
      (zoneName :pointer)                       ;  zone name returned 
      )
      (
      (appName :pointer)                        ;  pointer to application name in buffer 
      )
      )
   )

(defrecord XPPParamBlock 
   (qLink (:pointer :qelem))
   (qType :signed-integer)
   (ioTrap :signed-integer)
   (ioCmdAddr :pointer)
   (ioCompletion :pointer)
   (ioResult :signed-integer)
   (cmdResult :signed-long)
   (ioVRefNum :signed-integer)
   (ioRefNum :signed-integer)
   (csCode :signed-integer)
   (:variant 
      (
      (abortSCBPtr :pointer)                    ;   SCB pointer for AbortOS 
      )
      (
      (aspMaxCmdSize :signed-integer)           ;  For SPGetParms 
      (aspQuantumSize :signed-integer)
      (numSesss :signed-integer)
      )
      (
      (sessRefnum :signed-integer)              ;  Offset to session refnum  
      (aspTimeout :unsigned-byte)               ;  Timeout for ATP  
      (aspRetry :unsigned-byte)                 ;  Retry count for ATP  
      (:variant 
         (
         (serverAddr :addrblock)                ;  Server address block  
         (scbPointer :pointer)                  ;  SCB pointer  
         (attnRoutine :pointer)                 ;  Attention routine pointer 
         )
         (
         (cbSize :signed-integer)               ;  Command block size  
         (cbPtr :pointer)                       ;  Command block pointer  
         (rbSize :signed-integer)               ;  Reply buffer size  
         (rbPtr :pointer)                       ;  Reply buffer pointer  
         (:variant 
            (
            (afpAddrBlock :addrblock)           ;  block in AFP login  
            (afpSCBPtr :pointer)                ;  SCB pointer in AFP login  
            (afpAttnRoutine :pointer)           ;  routine pointer in AFP login  
            )
            (
            (wdSize :signed-integer)            ;  Write Data size 
            (wdPtr :pointer)                    ;  Write Data pointer 
            (ccbStart (:array :unsigned-byte 296 :packed));  CCB memory allocated for driver afpWrite max size(CCB)=296 all other calls=150 
            )
            ))
         ))
      (
      (xppSubCode :signed-integer)
      (xppTimeout :unsigned-byte)               ;  retry interval (seconds) 
      (xppRetry :unsigned-byte)                 ;  retry count 
      (filler1 :signed-integer)
      (zipBuffPtr :pointer)                     ;  pointer to buffer (must be 578 bytes) 
      (zipNumZones :signed-integer)             ;  no. of zone names in this response 
      (zipLastFlag :unsigned-byte)              ;  non-zero if no more zones 
      (filler2 :unsigned-byte)                  ;  filler 
      (zipInfoField (:array :unsigned-byte 70 :packed));  on initial call, set first word to zero 
      )
      )
   )

(defrecord ATPParamBlock 
   (qLink (:pointer :qelem))                    ;  next queue entry 
   (qType :signed-integer)                      ;  queue type 
   (ioTrap :signed-integer)                     ;  routine trap 
   (ioCmdAddr :pointer)                         ;  routine address 
   (ioCompletion :pointer)                      ;  ATPCompletionUPP or MPPCompletionUPP 
   (ioResult :signed-integer)                   ;  result code 
   (userData :signed-long)                      ;  Command result (ATP user bytes) 
   (reqTID :signed-integer)                     ;  request transaction ID 
   (ioRefNum :signed-integer)                   ;  driver reference number 
   (csCode :signed-integer)                     ;  Call command code 
   (atpSocket :unsigned-byte)                   ;  currbitmap for requests or ATP socket number 
   (atpFlags :unsigned-byte)                    ;  control information 
   (AddrBlock :addrblock)                       ;  source/dest. socket address 
   (reqLength :signed-integer)                  ;  request/response length 
   (reqPointer :pointer)                        ;  ->request/response Data 
   (bdsPointer :pointer)                        ;  ->response BDS  
   (:variant 
      (
      (numOfBuffs :unsigned-byte)               ;  numOfBuffs  
      (timeOutVal :unsigned-byte)               ;  timeout interval  
      (numOfResps :unsigned-byte)               ;  number of responses actually received  
      (retryCount :unsigned-byte)               ;  number of retries  
      (intBuff :signed-integer)                 ;  used internally for NSendRequest  
      (TRelTime :unsigned-byte)                 ;  TRelease time for extended send request  
      (filler0 :signed-byte)
      )
      (
      (filler :unsigned-byte)
      (bdsSize :unsigned-byte)                  ;  number of BDS elements  
      (transID :signed-integer)                 ;  transaction ID recd.  
      )
      (
      (bitMap :unsigned-byte)
      (filler2 :unsigned-byte)
      )
      (
      (rspNum :unsigned-byte)
      (filler3 :unsigned-byte)
      )
      (
      (aKillQEl :pointer)                       ;  ptr to i/o queue element to cancel 
      )
      )
   )

(defconstant $uppATalkTransitionEventProcInfo #xFF1)
(defconstant $uppMPPCompletionProcInfo #x9802)
(defconstant $uppATPCompletionProcInfo #x9802)
(defconstant $uppXPPCompletionProcInfo #x9802)
(defconstant $uppAttnRoutineProcInfo #x61002)
(defconstant $uppMPPProtocolHandlerProcInfo #x7F)
(defconstant $uppDDPSocketListenerProcInfo #x8F)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewATalkTransitionEventUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewATalkTransitionEventProc 
(deftrap "_NewATalkTransitionEventUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewMPPCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewMPPCompletionProc 
(deftrap "_NewMPPCompletionUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewATPCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewATPCompletionProc 
(deftrap "_NewATPCompletionUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewXPPCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewXPPCompletionProc 
(deftrap "_NewXPPCompletionUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewAttnRoutineUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewAttnRoutineProc 
(deftrap "_NewAttnRoutineUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewMPPProtocolHandlerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewMPPProtocolHandlerProc 
(deftrap "_NewMPPProtocolHandlerUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewDDPSocketListenerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewDDPSocketListenerProc 
(deftrap "_NewDDPSocketListenerUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeATalkTransitionEventUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeATalkTransitionEventUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeMPPCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeMPPCompletionUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeATPCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeATPCompletionUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeXPPCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeXPPCompletionUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeAttnRoutineUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeAttnRoutineUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeMPPProtocolHandlerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeMPPProtocolHandlerUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeDDPSocketListenerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeDDPSocketListenerUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeATalkTransitionEventUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallATalkTransitionEventProc    ; 
;  *  InvokeMPPCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokeATalkTransitionEventUPP" 
      ((eventCode :signed-long) (qElem (:pointer :atqentry)) (eventParameter :pointer) (userRoutine :pointer)) 
  :signed-long
   () )                                         ;  old name was CallMPPCompletionProc ; 
;  *  InvokeATPCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokeMPPCompletionUPP" 
      ((thePBptr (:pointer :mppparamblock)) (userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallATPCompletionProc ; 
;  *  InvokeXPPCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokeATPCompletionUPP" 
      ((thePBptr (:pointer :atpparamblock)) (userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallXPPCompletionProc ; 
;  *  InvokeAttnRoutineUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokeXPPCompletionUPP" 
      ((thePBptr (:pointer :xppparamblock)) (userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallAttnRoutineProc ; 
;  *  InvokeMPPProtocolHandlerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokeAttnRoutineUPP" 
      ((sessRefnum :signed-integer) (attnBytes :signed-integer) (userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallMPPProtocolHandlerProc ; 
;  *  InvokeDDPSocketListenerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokeMPPProtocolHandlerUPP" 
      ((SCCAddr1 :pointer) (SCCAddr2 :pointer) (MPPLocalVars :pointer) (nextFreeByteInRHA :pointer) (ReadPacketAndReadRestPtr :pointer) (numBytesLeftToReadInPacket :signed-integer) (userRoutine :pointer)) 
  :boolean
   () )                                         ;  old name was CallDDPSocketListenerProc 
(deftrap-inline "_InvokeDDPSocketListenerUPP" 
      ((SCCAddr1 :pointer) (SCCAddr2 :pointer) (MPPLocalVars :pointer) (nextFreeByteInRHA :pointer) (ReadPacketAndReadRestPtr :pointer) (packetDestinationNumber :signed-byte) (numBytesLeftToReadInPacket :signed-integer) (userRoutine :pointer)) 
  :boolean
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  OpenXPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  ASPOpenSession()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OpenXPP" 
      ((xppRefnum (:pointer :signed-integer))) 
  :signed-integer
   () )                                         ; 
;  *  ASPCloseSession()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ASPOpenSession" 
      ((thePBptr (:pointer :xppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  ASPAbortOS()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ASPCloseSession" 
      ((thePBptr (:pointer :xppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  ASPGetParms()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ASPAbortOS" 
      ((thePBptr (:pointer :xppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  ASPCloseAll()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ASPGetParms" 
      ((thePBptr (:pointer :xppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  ASPUserWrite()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ASPCloseAll" 
      ((thePBptr (:pointer :xppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  ASPUserCommand()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ASPUserWrite" 
      ((thePBptr (:pointer :xppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  ASPGetStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ASPUserCommand" 
      ((thePBptr (:pointer :xppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  AFPCommand()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ASPGetStatus" 
      ((thePBptr (:pointer :xppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  GetLocalZones()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_AFPCommand" 
      ((thePBptr (:pointer :xppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  GetZoneList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetLocalZones" 
      ((thePBptr (:pointer :xppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  GetMyZone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetZoneList" 
      ((thePBptr (:pointer :xppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PAttachPH()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetMyZone" 
      ((thePBptr (:pointer :xppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PDetachPH()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PAttachPH" 
      ((thePBptr (:pointer :mppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PWriteLAP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PDetachPH" 
      ((thePBptr (:pointer :mppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  POpenSkt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PWriteLAP" 
      ((thePBptr (:pointer :mppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PCloseSkt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_POpenSkt" 
      ((thePBptr (:pointer :mppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PWriteDDP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PCloseSkt" 
      ((thePBptr (:pointer :mppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PRegisterName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PWriteDDP" 
      ((thePBptr (:pointer :mppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PLookupName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PRegisterName" 
      ((thePBptr (:pointer :mppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PConfirmName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PLookupName" 
      ((thePBptr (:pointer :mppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PRemoveName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PConfirmName" 
      ((thePBptr (:pointer :mppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PSetSelfSend()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PRemoveName" 
      ((thePBptr (:pointer :mppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PKillNBP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PSetSelfSend" 
      ((thePBptr (:pointer :mppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PGetAppleTalkInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PKillNBP" 
      ((thePBptr (:pointer :mppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PATalkClosePrep()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PGetAppleTalkInfo" 
      ((thePBptr (:pointer :mppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  POpenATPSkt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PATalkClosePrep" 
      ((thePBptr (:pointer :mppparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PCloseATPSkt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_POpenATPSkt" 
      ((thePBptr (:pointer :atpparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PSendRequest()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PCloseATPSkt" 
      ((thePBPtr (:pointer :atpparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PGetRequest()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PSendRequest" 
      ((thePBPtr (:pointer :atpparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PSendResponse()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PGetRequest" 
      ((thePBPtr (:pointer :atpparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PAddResponse()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PSendResponse" 
      ((thePBPtr (:pointer :atpparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PRelTCB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PAddResponse" 
      ((thePBPtr (:pointer :atpparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PRelRspCB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PRelTCB" 
      ((thePBPtr (:pointer :atpparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PNSendRequest()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PRelRspCB" 
      ((thePBPtr (:pointer :atpparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PKillSendReq()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PNSendRequest" 
      ((thePBPtr (:pointer :atpparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PKillGetReq()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PKillSendReq" 
      ((thePBPtr (:pointer :atpparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  ATPKillAllGetReq()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PKillGetReq" 
      ((thePBPtr (:pointer :atpparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  BuildLAPwds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ATPKillAllGetReq" 
      ((thePBPtr (:pointer :atpparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  BuildDDPwds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_BuildLAPwds" 
      ((wdsPtr :pointer) (dataPtr :pointer) (destHost :signed-integer) (prototype :signed-integer) (frameLen :signed-integer)) 
  nil
   () )                                         ; 
;  *  NBPSetEntity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_BuildDDPwds" 
      ((wdsPtr :pointer) (headerPtr :pointer) (dataPtr :pointer) (netAddr :addrblock) (ddpType :signed-integer) (dataLen :signed-integer)) 
  nil
   () )                                         ; 
;  *  NBPSetNTE()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_NBPSetEntity" 
      ((buffer :pointer) (nbpObject (:string 32)) (nbpType (:string 32)) (nbpZone (:string 32))) 
  nil
   () )                                         ; 
;  *  GetBridgeAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_NBPSetNTE" 
      ((ntePtr :pointer) (nbpObject (:string 32)) (nbpType (:string 32)) (nbpZone (:string 32)) (socket :signed-integer)) 
  nil
   () )                                         ; 
;  *  BuildBDS()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetBridgeAddress" 
      () 
  :signed-integer
   () )                                         ; 
;  *  MPPOpen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_BuildBDS" 
      ((buffPtr :pointer) (bdsPtr :pointer) (buffSize :signed-integer)) 
  :signed-integer
   () )                                         ; 
;  *  LAPAddATQ()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_MPPOpen" 
      () 
  :signed-integer
   () )                                         ; 
;  *  LAPRmvATQ()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LAPAddATQ" 
      ((theATQEntry (:pointer :atqentry))) 
  :signed-integer
   () )                                         ; 
;  *  ATPLoad()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LAPRmvATQ" 
      ((theATQEntry (:pointer :atqentry))) 
  :signed-integer
   () )                                         ; 
;  *  ATPUnload()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ATPLoad" 
      () 
  :signed-integer
   () )                                         ; 
;  *  NBPExtract()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ATPUnload" 
      () 
  :signed-integer
   () )                                         ; 
;  *  GetNodeAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_NBPExtract" 
      ((theBuffer :pointer) (numInBuf :signed-integer) (whichOne :signed-integer) (abEntity (:pointer :entityname)) (address (:pointer :addrblock))) 
  :signed-integer
   () )                                         ; 
;  *  IsMPPOpen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetNodeAddress" 
      ((myNode (:pointer :signed-integer)) (myNet (:pointer :signed-integer))) 
  :signed-integer
   () )                                         ; 
;  *  IsATPOpen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_IsMPPOpen" 
      () 
  :boolean
   () )                                         ; 
;  *  ATEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_IsATPOpen" 
      () 
  :boolean
   () )                                         ; 
;  *  ATPreFlightEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ATEvent" 
      ((event :signed-long) (infoPtr :pointer)) 
  nil
   () )                                         ; 
;     The following routines are obsolete and will not be supported on
;     PowerPC. Equivalent functionality is provided by the routines
;     above.
; 
(deftrap-inline "_ATPreFlightEvent" 
      ((event :signed-long) (cancel :signed-long) (infoPtr :pointer)) 
  :signed-integer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

#|                                              ; $IFC TARGET_CPU_68K 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  MPPClose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  LAPOpenProtocol()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_MPPClose" 
      () 
  :signed-integer
   () )                                         ; 
;  *  LAPCloseProtocol()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LAPOpenProtocol" 
      ((theLAPType :signed-byte) (protoPtr :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  LAPWrite()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LAPCloseProtocol" 
      ((theLAPType :signed-byte)) 
  :signed-integer
   () )                                         ; 
;  *  LAPRead()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LAPWrite" 
      ((abRecord (:handle :atlaprec)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  LAPRdCancel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LAPRead" 
      ((abRecord (:handle :atlaprec)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  DDPOpenSocket()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LAPRdCancel" 
      ((abRecord (:handle :atlaprec))) 
  :signed-integer
   () )                                         ; 
;  *  DDPCloseSocket()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_DDPOpenSocket" 
      ((theSocket (:pointer :signed-integer)) (sktListener :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  DDPRead()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_DDPCloseSocket" 
      ((theSocket :signed-integer)) 
  :signed-integer
   () )                                         ; 
;  *  DDPWrite()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_DDPRead" 
      ((abRecord (:handle :atddprec)) (retCksumErrs :boolean) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  DDPRdCancel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_DDPWrite" 
      ((abRecord (:handle :atddprec)) (doChecksum :boolean) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  ATPOpenSocket()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_DDPRdCancel" 
      ((abRecord (:handle :atddprec))) 
  :signed-integer
   () )                                         ; 
;  *  ATPCloseSocket()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ATPOpenSocket" 
      ((addrRcvd :addrblock) (atpSocket (:pointer :signed-integer))) 
  :signed-integer
   () )                                         ; 
;  *  ATPSndRequest()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ATPCloseSocket" 
      ((atpSocket :signed-integer)) 
  :signed-integer
   () )                                         ; 
;  *  ATPRequest()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ATPSndRequest" 
      ((abRecord (:handle :atatprec)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  ATPReqCancel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ATPRequest" 
      ((abRecord (:handle :atatprec)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  ATPGetRequest()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ATPReqCancel" 
      ((abRecord (:handle :atatprec)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  ATPSndRsp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ATPGetRequest" 
      ((abRecord (:handle :atatprec)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  ATPAddRsp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ATPSndRsp" 
      ((abRecord (:handle :atatprec)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  ATPResponse()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ATPAddRsp" 
      ((abRecord (:handle :atatprec))) 
  :signed-integer
   () )                                         ; 
;  *  ATPRspCancel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ATPResponse" 
      ((abRecord (:handle :atatprec)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  NBPRegister()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ATPRspCancel" 
      ((abRecord (:handle :atatprec)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  NBPLookup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_NBPRegister" 
      ((abRecord (:handle :atnbprec)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  NBPConfirm()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_NBPLookup" 
      ((abRecord (:handle :atnbprec)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  NBPRemove()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_NBPConfirm" 
      ((abRecord (:handle :atnbprec)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  NBPLoad()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_NBPRemove" 
      ((abEntity (:pointer :entityname))) 
  :signed-integer
   () )                                         ; 
;  *  NBPUnload()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_NBPLoad" 
      () 
  :signed-integer
   () )
(deftrap-inline "_NBPUnload" 
      () 
  :signed-integer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC; TARGET_CPU_68K

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := AppleTalkIncludes

; $ENDC                                         ; __APPLETALK__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'AppleTalk)