(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CFDate.p"
; at Wednesday May 1,2002 2:40:24 pm.
; 
;      File:       CFDate.p
;  
;      Contains:   CoreFoundation date
;  
;      Version:    Technology: Mac OS X
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1999-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __CFDATE__
; $SETC __CFDATE__ := 1

; $I+
; $SETC CFDateIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CFBASE__
|#

(require-interface 'CFBase)
#|                                              ; $I CFBase.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :cftimeinterval (find-mactype ':double-float))
(def-mactype :cfabsolutetime (find-mactype ':double-float))
; 	 absolute time is the time interval since the reference date 	
; 	 the reference date (epoch) is 00:00:00 1 January 2001. 	
; 
; 	 *  CFAbsoluteTimeGetCurrent()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_CFAbsoluteTimeGetCurrent" 
      () 
  :double-float
   () )

; 
;  *  kCFAbsoluteTimeIntervalSince1970
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  kCFAbsoluteTimeIntervalSince1904
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(def-mactype :cfdateref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :cfdaterefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:CFDateRef parameter can be nil, it is changed to xx: CFDateRefPtr 
; 
; 	 *  CFDateGetTypeID()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_CFDateGetTypeID" 
      () 
  :unsigned-long
   () )

; 
;  *  CFDateCreate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFDateCreate" 
      ((allocator :pointer) (at :double-float)) 
  :pointer
   () )

; 
;  *  CFDateGetAbsoluteTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFDateGetAbsoluteTime" 
      ((theDate :pointer)) 
  :double-float
   () )

; 
;  *  CFDateGetTimeIntervalSinceDate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFDateGetTimeIntervalSinceDate" 
      ((theDate :pointer) (otherDate :pointer)) 
  :double-float
   () )

; 
;  *  CFDateCompare()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFDateCompare" 
      ((theDate :pointer) (otherDate :pointer) (context :pointer)) 
  :cfcomparisonresult
   () )

(def-mactype :cftimezoneref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :cftimezonerefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:CFTimeZoneRef parameter can be nil, it is changed to xx: CFTimeZoneRefPtr 
(def-mactype :cfgregoriandateptr (find-mactype '(:pointer :cfgregoriandate)))
(defrecord CFGregorianDate 
   (year :signed-long)
   (month :signed-byte)
   (day :signed-byte)
   (hour :signed-byte)
   (minute :signed-byte)
#|
; Warning: type-size: unknown type double-float
|##|
; Warning: type-size: unknown type double-float
|#
   (second :double-float)
   )

(def-mactype :cfgregorianunitsptr (find-mactype '(:pointer :cfgregorianunits)))
(defrecord CFGregorianUnits 
   (years :signed-long)
   (months :signed-long)
   (days :signed-long)
   (hours :signed-long)
   (minutes :signed-long)
#|
; Warning: type-size: unknown type double-float
|##|
; Warning: type-size: unknown type double-float
|#
   (seconds :double-float)
   )

(def-mactype :cfgregorianunitflags (find-mactype ':signed-long))

(defconstant $kCFGregorianUnitsYears #x1)
(defconstant $kCFGregorianUnitsMonths #x2)
(defconstant $kCFGregorianUnitsDays #x4)
(defconstant $kCFGregorianUnitsHours #x8)
(defconstant $kCFGregorianUnitsMinutes #x10)
(defconstant $kCFGregorianUnitsSeconds #x20)
(defconstant $kCFGregorianAllUnits #xFFFFFF)

; 
; 	 *  CFGregorianDateIsValid()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_CFGregorianDateIsValid" 
      ((gdate :cfgregoriandate) (unitFlags :unsigned-long)) 
  :boolean
   () )

; 
;  *  CFGregorianDateGetAbsoluteTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFGregorianDateGetAbsoluteTime" 
      ((gdate :cfgregoriandate) (tz :pointer)) 
  :double-float
   () )

; 
;  *  CFAbsoluteTimeGetGregorianDate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFAbsoluteTimeGetGregorianDate" 
      ((at :double-float) (tz :pointer)) 
  :cfgregoriandate
   () )

; 
;  *  CFAbsoluteTimeAddGregorianUnits()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFAbsoluteTimeAddGregorianUnits" 
      ((at :double-float) (tz :pointer) (units :cfgregorianunits)) 
  :double-float
   () )

; 
;  *  CFAbsoluteTimeGetDifferenceAsGregorianUnits()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFAbsoluteTimeGetDifferenceAsGregorianUnits" 
      ((at1 :double-float) (at2 :double-float) (tz :pointer) (unitFlags :unsigned-long)) 
  :cfgregorianunits
   () )

; 
;  *  CFAbsoluteTimeGetDayOfWeek()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFAbsoluteTimeGetDayOfWeek" 
      ((at :double-float) (tz :pointer)) 
  :signed-long
   () )

; 
;  *  CFAbsoluteTimeGetDayOfYear()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFAbsoluteTimeGetDayOfYear" 
      ((at :double-float) (tz :pointer)) 
  :signed-long
   () )

; 
;  *  CFAbsoluteTimeGetWeekOfYear()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFAbsoluteTimeGetWeekOfYear" 
      ((at :double-float) (tz :pointer)) 
  :signed-long
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CFDateIncludes

; $ENDC                                         ; __CFDATE__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'CFDate)