(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CFNumber.p"
; at Wednesday May 1,2002 2:40:24 pm.
; 
;      File:       CFNumber.p
;  
;      Contains:   CoreFoundation numbers
;  
;      Version:    Technology: Mac OS X
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1999-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __CFNUMBER__
; $SETC __CFNUMBER__ := 1

; $I+
; $SETC CFNumberIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CFBASE__
|#

(require-interface 'CFBase)
#|                                              ; $I CFBase.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :cfbooleanref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :cfbooleanrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:CFBooleanRef parameter can be nil, it is changed to xx: CFBooleanRefPtr 
; 
; 	 *  kCFBooleanTrue
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
; 	 *  kCFBooleanFalse
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
; 	 *  CFBooleanGetTypeID()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_CFBooleanGetTypeID" 
      () 
  :unsigned-long
   () )

; 
;  *  CFBooleanGetValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFBooleanGetValue" 
      ((BOOLEAN :pointer)) 
  :boolean
   () )

(def-mactype :cfnumbertype (find-mactype ':signed-long))

;   Types from MacTypes.h  
(defconstant $kCFNumberSInt8Type 1)
(defconstant $kCFNumberSInt16Type 2)
(defconstant $kCFNumberSInt32Type 3)
(defconstant $kCFNumberSInt64Type 4)
(defconstant $kCFNumberFloat32Type 5)
(defconstant $kCFNumberFloat64Type 6)           ;   64-bit IEEE 754  
;   Basic C types  
(defconstant $kCFNumberCharType 7)
(defconstant $kCFNumberShortType 8)
(defconstant $kCFNumberIntType 9)
(defconstant $kCFNumberLongType 10)
(defconstant $kCFNumberLongLongType 11)
(defconstant $kCFNumberFloatType 12)
(defconstant $kCFNumberDoubleType 13)           ;   Other  
(defconstant $kCFNumberCFIndexType 14)
(defconstant $kCFNumberMaxType 14)

(def-mactype :cfnumberref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :cfnumberrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:CFNumberRef parameter can be nil, it is changed to xx: CFNumberRefPtr 
; 
; 	 *  kCFNumberPositiveInfinity
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
; 	 *  kCFNumberNegativeInfinity
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
; 	 *  kCFNumberNaN
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
; 	 *  CFNumberGetTypeID()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_CFNumberGetTypeID" 
      () 
  :unsigned-long
   () )

; 
;     Creates a CFNumber with the given value. The type of number pointed
;     to by the valuePtr is specified by type. If type is a floating point
;     type and the value represents one of the infinities or NaN, the
;     well-defined CFNumber for that value is returned. If either of
;     valuePtr or type is an invalid value, the result is undefined.
; 
; 
;  *  CFNumberCreate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFNumberCreate" 
      ((allocator :pointer) (theType :signed-long) (valuePtr :pointer)) 
  :pointer
   () )

; 
;     Returns the storage format of the CFNumber's value.  Note that
;     this is not necessarily the type provided in CFNumberCreate().
; 
; 
;  *  CFNumberGetType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFNumberGetType" 
      ((number :pointer)) 
  :cfnumbertype
   () )

; 
;     Returns the size in bytes of the type of the number.
; 
; 
;  *  CFNumberGetByteSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFNumberGetByteSize" 
      ((number :pointer)) 
  :cfindex
   () )

; 
;     Returns TRUE if the type of the CFNumber's value is one of
;     the defined floating point types.
; 
; 
;  *  CFNumberIsFloatType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFNumberIsFloatType" 
      ((number :pointer)) 
  :boolean
   () )

; 
;     Copies the CFNumber's value into the space pointed to by
;     valuePtr, as the specified type. If conversion needs to take
;     place, the conversion rules follow human expectation and not
;     C's promotion and truncation rules. If the conversion is
;     lossy, or the value is out of range, FALSE is returned. Best
;     attempt at conversion will still be in *valuePtr.
; 
; 
;  *  CFNumberGetValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFNumberGetValue" 
      ((number :pointer) (theType :signed-long) (valuePtr :pointer)) 
  :boolean
   () )

; 
;     Compares the two CFNumber instances. If conversion of the
;     types of the values is needed, the conversion and comparison
;     follow human expectations and not C's promotion and comparison
;     rules. Negative zero compares less than positive zero.
;     Positive infinity compares greater than everything except
;     itself, to which it compares equal. Negative infinity compares
;     less than everything except itself, to which it compares equal.
;     Unlike standard practice, if both numbers are NaN, then they
;     compare equal; if only one of the numbers is NaN, then the NaN
;     compares greater than the other number if it is negative, and
;     smaller than the other number if it is positive. (Note that in
;     CFEqual() with two CFNumbers, if either or both of the numbers
;     is NaN, FALSE is returned.)
; 
; 
;  *  CFNumberCompare()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFNumberCompare" 
      ((number :pointer) (otherNumber :pointer) (context :pointer)) 
  :cfcomparisonresult
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CFNumberIncludes

; $ENDC                                         ; __CFNUMBER__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'CFNumber)