(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CFSet.p"
; at Wednesday May 1,2002 2:40:25 pm.
; 
;      File:       CFSet.p
;  
;      Contains:   CoreFoundation set collection
;  
;      Version:    Technology: Mac OS X
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1999-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __CFSET__
; $SETC __CFSET__ := 1

; $I+
; $SETC CFSetIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CFBASE__
|#

(require-interface 'CFBase)
#|                                              ; $I CFBase.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFSetRetainCallBack = FUNCTION(allocator: CFAllocatorRef; value: UNIV Ptr): Ptr; C;

|#
 |#                                             ; $ELSEC
(def-mactype :cfsetretaincallback (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFSetReleaseCallBack = PROCEDURE(allocator: CFAllocatorRef; value: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :cfsetreleasecallback (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFSetCopyDescriptionCallBack = FUNCTION(value: UNIV Ptr): CFStringRef; C;

|#
 |#                                             ; $ELSEC
(def-mactype :cfsetcopydescriptioncallback (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFSetEqualCallBack = FUNCTION(value1: UNIV Ptr; value2: UNIV Ptr): BOOLEAN; C;

|#
 |#                                             ; $ELSEC
(def-mactype :cfsetequalcallback (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFSetHashCallBack = FUNCTION(value: UNIV Ptr): CFHashCode; C;

|#
 |#                                             ; $ELSEC
(def-mactype :cfsethashcallback (find-mactype ':pointer))
; $ENDC

(def-mactype :cfsetcallbacksptr (find-mactype '(:pointer :cfsetcallbacks)))
(defrecord CFSetCallBacks 
   (version :signed-long)
   (retain :pointer)
   (release :pointer)
   (copyDescription :pointer)
   (equal :pointer)
   (hash :pointer)
   )

; 
; 	 *  kCFTypeSetCallBacks
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
; 	 *  kCFCopyStringSetCallBacks
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFSetApplierFunction = PROCEDURE(value: UNIV Ptr; context: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :cfsetapplierfunction (find-mactype ':pointer))
; $ENDC

(def-mactype :cfsetref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :cfsetrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:CFSetRef parameter can be nil, it is changed to xx: CFSetRefPtr 
(def-mactype :cfmutablesetref (find-mactype ':pointer))
(def-mactype :cfmutablesetrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:CFMutableSetRef parameter can be nil, it is changed to xx: CFMutableSetRefPtr 
; 
; 	 *  CFSetGetTypeID()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_CFSetGetTypeID" 
      () 
  :unsigned-long
   () )

; 
;  *  CFSetCreate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_CFSetCreate" 
      ((allocator :pointer) (values (:pointer :pointer)) (numValues :signed-long) (callBacks (:pointer :cfsetcallbacks))) 
  :pointer
   () )

; 
;  *  CFSetCreateCopy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFSetCreateCopy" 
      ((allocator :pointer) (theSet :pointer)) 
  :pointer
   () )

; 
;  *  CFSetCreateMutable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_CFSetCreateMutable" 
      ((allocator :pointer) (capacity :signed-long) (callBacks (:pointer :cfsetcallbacks))) 
  :pointer
   () )

; 
;  *  CFSetCreateMutableCopy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFSetCreateMutableCopy" 
      ((allocator :pointer) (capacity :signed-long) (theSet :pointer)) 
  :pointer
   () )

; 
;  *  CFSetGetCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFSetGetCount" 
      ((theSet :pointer)) 
  :cfindex
   () )

; 
;  *  CFSetGetCountOfValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFSetGetCountOfValue" 
      ((theSet :pointer) (value :pointer)) 
  :cfindex
   () )

; 
;  *  CFSetContainsValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFSetContainsValue" 
      ((theSet :pointer) (value :pointer)) 
  :boolean
   () )

; 
;  *  CFSetGetValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFSetGetValue" 
      ((theSet :pointer) (value :pointer)) 
  :pointer
   () )

; 
;  *  CFSetGetValueIfPresent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFSetGetValueIfPresent" 
      ((theSet :pointer) (candidate :pointer) (value (:pointer :pointer))) 
  :boolean
   () )

; 
;  *  CFSetGetValues()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFSetGetValues" 
      ((theSet :pointer) (values (:pointer :pointer))) 
  nil
   () )

; 
;  *  CFSetApplyFunction()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFSetApplyFunction" 
      ((theSet :pointer) (applier :pointer) (context :pointer)) 
  nil
   () )

; 
;  *  CFSetAddValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFSetAddValue" 
      ((theSet :pointer) (value :pointer)) 
  nil
   () )

; 
;  *  CFSetReplaceValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFSetReplaceValue" 
      ((theSet :pointer) (value :pointer)) 
  nil
   () )

; 
;  *  CFSetSetValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFSetSetValue" 
      ((theSet :pointer) (value :pointer)) 
  nil
   () )

; 
;  *  CFSetRemoveValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFSetRemoveValue" 
      ((theSet :pointer) (value :pointer)) 
  nil
   () )

; 
;  *  CFSetRemoveAllValues()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFSetRemoveAllValues" 
      ((theSet :pointer)) 
  nil
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CFSetIncludes

; $ENDC                                         ; __CFSET__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'CFSet)