(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CFXMLNode.p"
; at Wednesday May 1,2002 2:40:26 pm.
; 
;      File:       CFXMLNode.p
;  
;      Contains:   CoreFoundation XML Node and XML Tree
;  
;      Version:    Technology: Mac OS X
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   2000-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __CFXMLNODE__
; $SETC __CFXMLNODE__ := 1

; $I+
; $SETC CFXMLNodeIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CFARRAY__
|#

(require-interface 'CFArray)
#|                                              ; $I CFArray.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFDICTIONARY__
|#

(require-interface 'CFDictionary)
#|                                              ; $I CFDictionary.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFSTRING__
|#

(require-interface 'CFString)
#|                                              ; $I CFString.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFTREE__
|#

(require-interface 'CFTree)
#|                                              ; $I CFTree.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFURL__
|#

(require-interface 'CFURL)
#|                                              ; $I CFURL.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :cfxmlnoderef (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :cfxmlnoderefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:CFXMLNodeRef parameter can be nil, it is changed to xx: CFXMLNodeRefPtr 
(def-mactype :cfxmltreeref (find-mactype ':pointer))
; 	  An CFXMLNode describes an individual XML construct - like a tag, or a comment, or a string
; 	    of character data.  Each CFXMLNode contains 3 main pieces of information - the node's type,
; 	    the data string, and a pointer to an additional data structure.  The node's type ID is an enum
; 	    value of type CFXMLNodeTypeID.  The data string is always a CFStringRef; the meaning of the
; 	    string is dependent on the node's type ID. The format of the additional data is also dependent
; 	    on the node's type; in general, there is a custom structure for each type that requires
; 	    additional data.  See below for the mapping from type ID to meaning of the data string and
; 	    structure of the additional data.  Note that these structures are versioned, and may change
; 	    as the parser changes.  The current version can always be identified by kCFXMLNodeCurrentVersion;
; 	    earlier versions can be identified and used by passing earlier values for the version number
; 	    (although the older structures would have been removed from the header).
; 	
; 	    An CFXMLTree is simply a CFTree whose context data is known to be an CFXMLNodeRef.  As
; 	    such, an CFXMLTree can be used to represent an entire XML document; the CFTree
; 	    provides the tree structure of the document, while the CFXMLNodes identify and describe
; 	    the nodes of the tree.  An XML document can be parsed to a CFXMLTree, and a CFXMLTree
; 	    can generate the data for the equivalent XML document - see CFXMLParser.h for more
; 	    information on parsing XML.
; 	    	

(defconstant $kCFXMLNodeCurrentVersion 1)

; 	 Type codes for the different possible XML nodes; this list may grow.	

(def-mactype :cfxmlnodetypecode (find-mactype ':signed-long))

(defconstant $kCFXMLNodeTypeDocument 1)
(defconstant $kCFXMLNodeTypeElement 2)
(defconstant $kCFXMLNodeTypeAttribute 3)
(defconstant $kCFXMLNodeTypeProcessingInstruction 4)
(defconstant $kCFXMLNodeTypeComment 5)
(defconstant $kCFXMLNodeTypeText 6)
(defconstant $kCFXMLNodeTypeCDATASection 7)
(defconstant $kCFXMLNodeTypeDocumentFragment 8)
(defconstant $kCFXMLNodeTypeEntity 9)
(defconstant $kCFXMLNodeTypeEntityReference 10)
(defconstant $kCFXMLNodeTypeDocumentType 11)
(defconstant $kCFXMLNodeTypeWhitespace 12)
(defconstant $kCFXMLNodeTypeNotation 13)
(defconstant $kCFXMLNodeTypeElementTypeDeclaration 14)
(defconstant $kCFXMLNodeTypeAttributeListDeclaration 15)

(def-mactype :cfxmlelementinfoptr (find-mactype '(:pointer :cfxmlelementinfo)))
(defrecord CFXMLElementInfo 
   (attributes :pointer)
   (attributeOrder :pointer)
   (isEmpty :boolean)
   )

(def-mactype :cfxmlprocessinginstructioninfoptr (find-mactype '(:pointer :cfxmlprocessinginstructioninfo)))
(defrecord CFXMLProcessingInstructionInfo 
   (dataString :pointer)
   )

(def-mactype :cfxmldocumentinfoptr (find-mactype '(:pointer :cfxmldocumentinfo)))
(defrecord CFXMLDocumentInfo 
   (sourceURL :pointer)
   (encoding :unsigned-long)
   )

(def-mactype :cfxmlexternalidptr (find-mactype '(:pointer :cfxmlexternalid)))
(defrecord CFXMLExternalID 
   (systemID :pointer)
   (publicID :pointer)
   )

(def-mactype :cfxmldocumenttypeinfoptr (find-mactype '(:pointer :cfxmldocumenttypeinfo)))
(defrecord CFXMLDocumentTypeInfo 
   (externalID :cfxmlexternalid)
   )

(def-mactype :cfxmlnotationinfoptr (find-mactype '(:pointer :cfxmlnotationinfo)))
(defrecord CFXMLNotationInfo 
   (externalID :cfxmlexternalid)
   )

(def-mactype :cfxmlelementtypedeclarationinfoptr (find-mactype '(:pointer :cfxmlelementtypedeclarationinfo)))
(defrecord CFXMLElementTypeDeclarationInfo 
;   This is expected to change in future versions  
   (contentDescription :pointer)
   )

(def-mactype :cfxmlattributedeclarationinfoptr (find-mactype '(:pointer :cfxmlattributedeclarationinfo)))
(defrecord CFXMLAttributeDeclarationInfo 
;   This is expected to change in future versions  
   (attributeName :pointer)
   (typeString :pointer)
   (defaultString :pointer)
   )

(def-mactype :cfxmlattributelistdeclarationinfoptr (find-mactype '(:pointer :cfxmlattributelistdeclarationinfo)))
(defrecord CFXMLAttributeListDeclarationInfo 
   (numberOfAttributes :signed-long)
   (attributes (:pointer :cfxmlattributedeclarationinfo))
   )

(def-mactype :cfxmlentitytypecode (find-mactype ':signed-long))

(defconstant $kCFXMLEntityTypeParameter 0)      ;   Implies parsed, internal  
(defconstant $kCFXMLEntityTypeParsedInternal 1)
(defconstant $kCFXMLEntityTypeParsedExternal 2)
(defconstant $kCFXMLEntityTypeUnparsed 3)
(defconstant $kCFXMLEntityTypeCharacter 4)

(def-mactype :cfxmlentityinfoptr (find-mactype '(:pointer :cfxmlentityinfo)))
(defrecord CFXMLEntityInfo 
   (entityType :signed-long)
   (replacementText :pointer)                   ;   NULL if entityType is external or unparsed  
   (entityID :cfxmlexternalid)                  ;   entityID.systemID will be NULL if entityType is internal  
   (notationName :pointer)                      ;   NULL if entityType is parsed  
   )

(def-mactype :cfxmlentityreferenceinfoptr (find-mactype '(:pointer :cfxmlentityreferenceinfo)))
(defrecord CFXMLEntityReferenceInfo 
   (entityType :signed-long)
   )

; 	
; 	 dataTypeCode                       meaning of dataString                format of infoPtr
; 	 ===========                        =====================                =================
; 	 kCFXMLNodeTypeDocument             <currently unused>                   CFXMLDocumentInfo *
; 	 kCFXMLNodeTypeElement              tag name                             CFXMLElementInfo *
; 	 kCFXMLNodeTypeAttribute            <currently unused>                   <currently unused>
; 	 kCFXMLNodeTypeProcessInstruction   name of the target                   CFXMLProcessingInstructionInfo *
; 	 kCFXMLNodeTypeComment              text of the comment                  NULL
; 	 kCFXMLNodeTypeText                 the text's contents                  NULL
; 	 kCFXMLNodeTypeCDATASection         text of the CDATA                    NULL
; 	 kCFXMLNodeTypeDocumentFragment     <currently unused>                   <currently unused>
; 	 kCFXMLNodeTypeEntity               name of the entity                   CFXMLEntityInfo *
; 	 kCFXMLNodeTypeEntityReference      name of the referenced entity        CFXMLEntityReferenceInfo *
; 	 kCFXMLNodeTypeDocumentType         name given as top-level element      CFXMLDocumentTypeInfo *
; 	 kCFXMLNodeTypeWhitespace           text of the whitespace               NULL
; 	 kCFXMLNodeTypeNotation             notation name                        CFXMLNotationInfo *
; 	 kCFXMLNodeTypeElementTypeDeclaration     tag name                       CFXMLElementTypeDeclarationInfo *
; 	 kCFXMLNodeTypeAttributeListDeclaration   tag name                       CFXMLAttributeListDeclarationInfo *
; 		
; 
; 	 *  CFXMLNodeGetTypeID()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_CFXMLNodeGetTypeID" 
      () 
  :unsigned-long
   () )

;  Creates a new node based on xmlType, dataString, and additionalInfoPtr.  version (together with xmlType) determines the expected structure of additionalInfoPtr 
; 
;  *  CFXMLNodeCreate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFXMLNodeCreate" 
      ((alloc :pointer) (xmlType :signed-long) (dataString :pointer) (additionalInfoPtr :pointer) (version :signed-long)) 
  :pointer
   () )

;  Creates a copy of origNode (which may not be NULL). 
; 
;  *  CFXMLNodeCreateCopy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFXMLNodeCreateCopy" 
      ((alloc :pointer) (origNode :pointer)) 
  :pointer
   () )

; 
;  *  CFXMLNodeGetTypeCode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFXMLNodeGetTypeCode" 
      ((node :pointer)) 
  :cfxmlnodetypecode
   () )

; 
;  *  CFXMLNodeGetString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFXMLNodeGetString" 
      ((node :pointer)) 
  :pointer
   () )

; 
;  *  CFXMLNodeGetInfoPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFXMLNodeGetInfoPtr" 
      ((node :pointer)) 
  :pointer
   () )

; 
;  *  CFXMLNodeGetVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFXMLNodeGetVersion" 
      ((node :pointer)) 
  :cfindex
   () )

;  CFXMLTreeRef 
;  Creates a childless, parentless tree from node 
; 
;  *  CFXMLTreeCreateWithNode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFXMLTreeCreateWithNode" 
      ((allocator :pointer) (node :pointer)) 
  :pointer
   () )

;  Extracts and returns the node stored in xmlTree 
; 
;  *  CFXMLTreeGetNode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFXMLTreeGetNode" 
      ((xmlTree :pointer)) 
  :pointer
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CFXMLNodeIncludes

; $ENDC                                         ; __CFXMLNODE__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'CFXMLNode)