(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CGImage.p"
; at Wednesday May 1,2002 2:39:27 pm.
; 
;      File:       CGImage.p
;  
;      Contains:   CoreGraphics images
;  
;      Version:    Technology: CoreGraphics-122 (Mac OS X 10.1)
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   2000-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 

#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __CGIMAGE__
; $SETC __CGIMAGE__ := 1

; $I+
; $SETC CGImageIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CGBASE__
|#

(require-interface 'CGBase)
#|                                              ; $I CGBase.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CGCOLORSPACE__
|#

(require-interface 'CGColorSpace)
#|                                              ; $I CGColorSpace.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CGDATAPROVIDER__
|#

(require-interface 'CGDataProvider)
#|                                              ; $I CGDataProvider.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :cgimageref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :cgimagerefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:CGImageRef parameter can be nil, it is changed to xx: CGImageRefPtr 
(def-mactype :cgimagealphainfo (find-mactype ':signed-long))

(defconstant $kCGImageAlphaNone 0)
(defconstant $kCGImageAlphaPremultipliedLast 1) ;   For example, premultiplied RGBA  
(defconstant $kCGImageAlphaPremultipliedFirst 2);   For example, premultiplied ARGB  
(defconstant $kCGImageAlphaLast 3)              ;   For example, non-premultiplied RGBA  
(defconstant $kCGImageAlphaFirst 4)             ;   For example, non-premultiplied ARGB  
(defconstant $kCGImageAlphaNoneSkipLast 5)      ;   Equivalent to kCGImageAlphaNone.  
(defconstant $kCGImageAlphaNoneSkipFirst 6)

; 	 Create an image. 	
; 
; 	 *  CGImageCreate()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; CONST
(deftrap-inline "_CGImageCreate" 
      ((width :unsigned-long) (height :unsigned-long) (bitsPerComponent :unsigned-long) (bitsPerPixel :unsigned-long) (bytesPerRow :unsigned-long) (colorspace :pointer) (alphaInfo :signed-long) (provider :pointer) (decode (:pointer :single-float)) (shouldInterpolate :signed-long) (intent :signed-long)) 
  :pointer
   () )

;  Create an image mask. 
; 
;  *  CGImageMaskCreate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_CGImageMaskCreate" 
      ((width :unsigned-long) (height :unsigned-long) (bitsPerComponent :unsigned-long) (bitsPerPixel :unsigned-long) (bytesPerRow :unsigned-long) (provider :pointer) (decode (:pointer :single-float)) (shouldInterpolate :signed-long)) 
  :pointer
   () )

;  Create an image from `source', a data provider of JPEG-encoded data. 
; 
;  *  CGImageCreateWithJPEGDataProvider()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.1 and later
;  
; CONST
(deftrap-inline "_CGImageCreateWithJPEGDataProvider" 
      ((source :pointer) (decode (:pointer :single-float)) (shouldInterpolate :signed-long) (intent :signed-long)) 
  :pointer
   () )

;  Increment the retain count of `image' and return it.  All images are
;  * created with an initial retain count of 1. 
; 
;  *  CGImageRetain()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGImageRetain" 
      ((image :pointer)) 
  :pointer
   () )

;  Decrement the retain count of `image'.  If the retain count reaches 0,
;  * then release it and any associated resources. 
; 
;  *  CGImageRelease()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGImageRelease" 
      ((image :pointer)) 
  nil
   () )

;  Return 1 if `image' is an image mask, 0 otherwise. 
; 
;  *  CGImageIsMask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGImageIsMask" 
      ((image :pointer)) 
  :int
   () )

;  Return the width of `image'. 
; 
;  *  CGImageGetWidth()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGImageGetWidth" 
      ((image :pointer)) 
  :unsigned-long
   () )

;  Return the height of `image'. 
; 
;  *  CGImageGetHeight()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGImageGetHeight" 
      ((image :pointer)) 
  :unsigned-long
   () )

;  Return the number of bits/component of `image'. 
; 
;  *  CGImageGetBitsPerComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGImageGetBitsPerComponent" 
      ((image :pointer)) 
  :unsigned-long
   () )

;  Return the number of bits/pixel of `image'. 
; 
;  *  CGImageGetBitsPerPixel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGImageGetBitsPerPixel" 
      ((image :pointer)) 
  :unsigned-long
   () )

;  Return the number of bytes/row of `image'. 
; 
;  *  CGImageGetBytesPerRow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGImageGetBytesPerRow" 
      ((image :pointer)) 
  :unsigned-long
   () )

;  Return the colorspace of `image', or NULL if `image' is an image
;  * mask. 
; 
;  *  CGImageGetColorSpace()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGImageGetColorSpace" 
      ((image :pointer)) 
  :pointer
   () )

;  Return the alpha info of `image'. 
; 
;  *  CGImageGetAlphaInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGImageGetAlphaInfo" 
      ((image :pointer)) 
  :cgimagealphainfo
   () )

; Return the data provider of `image'. 
; 
;  *  CGImageGetDataProvider()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGImageGetDataProvider" 
      ((image :pointer)) 
  :pointer
   () )

;  Return the decode array of `image'. 
; 
;  *  CGImageGetDecode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGImageGetDecode" 
      ((image :pointer)) 
  (:pointer :single-float)
   () )

;  Return the interpolation parameter of `image'. 
; 
;  *  CGImageGetShouldInterpolate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGImageGetShouldInterpolate" 
      ((image :pointer)) 
  :int
   () )

;  Return the rendering intent of `image'. 
; 
;  *  CGImageGetRenderingIntent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGImageGetRenderingIntent" 
      ((image :pointer)) 
  :cgcolorrenderingintent
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CGImageIncludes

; $ENDC                                         ; __CGIMAGE__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'CGImage)