(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CGWindowLevel.p"
; at Wednesday May 1,2002 2:40:44 pm.
; 
;      File:       CGWindowLevel.p
;  
;      Contains:   CoreGraphics window levels
;  
;      Version:    Technology: CoreGraphics-122 (Mac OS X 10.1)
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   2000-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __CGWINDOWLEVEL__
; $SETC __CGWINDOWLEVEL__ := 1

; $I+
; $SETC CGWindowLevelIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CGBASE__
|#

(require-interface 'CGBase)
#|                                              ; $I CGBase.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;  * Windows may be assigned to a particular level. When assigned to a level,
;  * the window is ordered relative to all other windows in that level.
;  * Windows with a higher level are sorted in front of windows with a lower
;  * level.
;  *
;  * A common set of window levels is defined here for use within higher
;  * level frameworks.  The levels are accessed via a key and function,
;  * so that levels may be changed or adjusted in future releases without
;  * breaking binary compatability.
;  

(def-mactype :cgwindowlevel (find-mactype ':signed-long))
(def-mactype :cgwindowlevelkey (find-mactype ':signed-long))
(def-mactype :_cgcommonwindowlevelkey (find-mactype ':signed-long))

(defconstant $kCGBaseWindowLevelKey 0)
(defconstant $kCGMinimumWindowLevelKey 1)
(defconstant $kCGDesktopWindowLevelKey 2)
(defconstant $kCGBackstopMenuLevelKey 3)
(defconstant $kCGNormalWindowLevelKey 4)
(defconstant $kCGFloatingWindowLevelKey 5)
(defconstant $kCGTornOffMenuWindowLevelKey 6)
(defconstant $kCGDockWindowLevelKey 7)
(defconstant $kCGMainMenuWindowLevelKey 8)
(defconstant $kCGStatusWindowLevelKey 9)
(defconstant $kCGModalPanelWindowLevelKey 10)
(defconstant $kCGPopUpMenuWindowLevelKey 11)
(defconstant $kCGDraggingWindowLevelKey 12)
(defconstant $kCGScreenSaverWindowLevelKey 13)
(defconstant $kCGMaximumWindowLevelKey 14)
(defconstant $kCGOverlayWindowLevelKey 15)
(defconstant $kCGHelpWindowLevelKey 16)
(defconstant $kCGUtilityWindowLevelKey 17)
(defconstant $kCGDesktopIconWindowLevelKey 18)
(defconstant $kCGNumberOfWindowLevelKeys 19)    ;   Internal bookkeeping; must be last  

; 
; 	 *  CGWindowLevelForKey()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_CGWindowLevelForKey" 
      ((key :signed-long)) 
  :cgwindowlevel
   () )

;  number of levels above kCGMaximumWindowLevel reserved for internal use 

(defconstant $kCGNumReservedWindowLevels 16)

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CGWindowLevelIncludes

; $ENDC                                         ; __CGWINDOWLEVEL__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'CGWindowLevel)