(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CMCalibrator.p"
; at Wednesday May 1,2002 2:41:09 pm.
; 
;      File:       CMCalibrator.p
;  
;      Contains:   ColorSync Calibration API
;  
;      Version:    Technology: ColorSync 2.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1998-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __CMCALIBRATOR__
; $SETC __CMCALIBRATOR__ := 1

; $I+
; $SETC CMCalibratorIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CMAPPLICATION__
|#

(require-interface 'CMApplication)
#|                                              ; $I CMApplication.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __EVENTS__
|#

(require-interface 'Events)
#|                                              ; $I Events.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CalibrateEventProcPtr = PROCEDURE(VAR event: EventRecord);

|#
 |#                                             ; $ELSEC
(def-mactype :calibrateeventprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :calibrateeventupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :calibrateeventupp (find-mactype ':pointer))
; $ENDC

;   Interface for new ColorSync monitor calibrators (ColorSync 2.6 and greater)  

(defconstant $kCalibratorNamePrefix :|cali|)

(def-mactype :calibratorinfoptr (find-mactype '(:pointer :calibratorinfo)))
(defrecord CalibratorInfo 
   (dataSize :unsigned-long)                    ;   Size of this structure - compatibility  
   (displayID :unsigned-long)                   ;   Contains an hDC on Win32  
   (profileLocationSize :unsigned-long)         ;   Max size for returned profile location  
   (profileLocationPtr (:pointer :cmprofilelocation));   For returning the profile  
   (eventProc :pointer)                         ;   Ignored on Win32  
   (isGood :boolean)                            ;   true or false  
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CanCalibrateProcPtr = FUNCTION(displayID: CMDisplayIDType; VAR errMessage: Str255): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :cancalibrateprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CalibrateProcPtr = FUNCTION(VAR theInfo: CalibratorInfo): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :calibrateprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :cancalibrateupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :cancalibrateupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :calibrateupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :calibrateupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppCalibrateEventProcInfo #xC0)
(defconstant $uppCanCalibrateProcInfo #x3D0)
(defconstant $uppCalibrateProcInfo #xE0)
; 
; 	 *  NewCalibrateEventUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewCalibrateEventProc 
(deftrap "_NewCalibrateEventUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewCanCalibrateUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  
;  old name was NewCanCalibrateProc 
(deftrap "_NewCanCalibrateUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewCalibrateUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  
;  old name was NewCalibrateProc 
(deftrap "_NewCalibrateUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeCalibrateEventUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeCalibrateEventUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeCanCalibrateUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeCanCalibrateUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeCalibrateUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeCalibrateUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeCalibrateEventUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallCalibrateEventProc 
(deftrap-inline "_InvokeCalibrateEventUPP" 
      ((event (:pointer :eventrecord)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeCanCalibrateUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  
;  old name was CallCanCalibrateProc 
(deftrap-inline "_InvokeCanCalibrateUPP" 
      ((displayID :unsigned-long) (errMessage (:pointer (:string 255))) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; 
;  *  InvokeCalibrateUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  
;  old name was CallCalibrateProc 
(deftrap-inline "_InvokeCalibrateUPP" 
      ((theInfo (:pointer :calibratorinfo)) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  CMCalibrateDisplay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  
; $IFC OLDROUTINENAMES                          ;   Interface for original ColorSync monitor calibrators (ColorSync 2.5.x)  
(deftrap-inline "_CMCalibrateDisplay" 
      ((theInfo (:pointer :calibratorinfo))) 
  :signed-integer
   () )
(defconstant $kOldCalibratorNamePrefix :|Cali|)

(def-mactype :oldcalibratorinfoptr (find-mactype '(:pointer :oldcalibratorinfo)))
(defrecord OldCalibratorInfo 
   (displayID :unsigned-long)                   ;   Contains an hDC on Win32  
   (profileLocation :cmprofilelocation)
   (eventProc :pointer)                         ;   Ignored on Win32  
   (reserved :unsigned-long)                    ;   Unused  
   (flags :unsigned-long)                       ;   Unused  
   (isGood :boolean)                            ;   true or false  
   (byteFiller :signed-byte)                    ;   Unused  
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	OldCanCalibrateProcPtr = FUNCTION(displayID: CMDisplayIDType): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :oldcancalibrateprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	OldCalibrateProcPtr = FUNCTION(VAR theInfo: OldCalibratorInfo): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :oldcalibrateprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :oldcancalibrateupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :oldcancalibrateupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :oldcalibrateupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :oldcalibrateupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppOldCanCalibrateProcInfo #xD0)
(defconstant $uppOldCalibrateProcInfo #xE0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewOldCanCalibrateUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewOldCanCalibrateProc 
(deftrap "_NewOldCanCalibrateUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewOldCalibrateUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewOldCalibrateProc 
(deftrap "_NewOldCalibrateUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeOldCanCalibrateUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeOldCanCalibrateUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeOldCalibrateUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeOldCalibrateUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeOldCanCalibrateUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallOldCanCalibrateProc 
(deftrap-inline "_InvokeOldCanCalibrateUPP" 
      ((displayID :unsigned-long) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; 
;  *  InvokeOldCalibrateUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallOldCalibrateProc 
(deftrap-inline "_InvokeOldCalibrateUPP" 
      ((theInfo (:pointer :oldcalibratorinfo)) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; OLDROUTINENAMES

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CMCalibratorIncludes

; $ENDC                                         ; __CMCALIBRATOR__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'CMCalibrator)