(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CMTypes.p"
; at Wednesday May 1,2002 2:40:35 pm.
; 
;      File:       CMTypes.p
;  
;      Contains:   xxx put contents here xxx
;  
;      Version:    Technology: ColorSync 3
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   2000-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 

#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __CMTYPES__
; $SETC __CMTYPES__ := 1

; $I+
; $SETC CMTypesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC

;  Standard type for ColorSync and other system error codes 

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :cmerror (find-mactype ':signed-long))
; 	 Abstract data type for memory-based Profile 	
(def-mactype :cmprofileref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :cmprofilerefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:CMProfileRef parameter can be nil, it is changed to xx: CMProfileRefPtr 
; 	 Abstract data type for Profile search result 	
(def-mactype :cmprofilesearchref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :cmprofilesearchrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:CMProfileSearchRef parameter can be nil, it is changed to xx: CMProfileSearchRefPtr 
; 	 Abstract data type for BeginMatching() reference 	
(def-mactype :cmmatchref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :cmmatchrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:CMMatchRef parameter can be nil, it is changed to xx: CMMatchRefPtr 
; 	 Abstract data type for ColorWorld reference 	
(def-mactype :cmworldref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :cmworldrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:CMWorldRef parameter can be nil, it is changed to xx: CMWorldRefPtr 
; 	 Data type for ColorSync DisplayID reference 	
; 	 On 8 & 9 this is a AVIDType 	
; 	 On X this is a CGSDisplayID 	
(def-mactype :cmdisplayidtype (find-mactype ':unsigned-long))

; 	 Caller-supplied flatten function 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CMFlattenProcPtr = FUNCTION(command: LONGINT; VAR size: LONGINT; data: UNIV Ptr; refCon: UNIV Ptr): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :cmflattenprocptr (find-mactype ':pointer))
; $ENDC

; 	 Caller-supplied progress function for Bitmap & PixMap matching routines 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CMBitmapCallBackProcPtr = FUNCTION(progress: LONGINT; refCon: UNIV Ptr): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :cmbitmapcallbackprocptr (find-mactype ':pointer))
; $ENDC

; 	 Caller-supplied progress function for NCMMConcatInit & NCMMNewLinkProfile routines 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CMConcatCallBackProcPtr = FUNCTION(progress: LONGINT; refCon: UNIV Ptr): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :cmconcatcallbackprocptr (find-mactype ':pointer))
; $ENDC

; 	 Caller-supplied filter function for Profile search 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CMProfileFilterProcPtr = FUNCTION(prof: CMProfileRef; refCon: UNIV Ptr): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :cmprofilefilterprocptr (find-mactype ':pointer))
; $ENDC

; 	 Caller-supplied function for profile access 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CMProfileAccessProcPtr = FUNCTION(command: LONGINT; offset: LONGINT; VAR size: LONGINT; data: UNIV Ptr; refCon: UNIV Ptr): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :cmprofileaccessprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :cmflattenupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :cmflattenupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :cmbitmapcallbackupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :cmbitmapcallbackupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :cmconcatcallbackupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :cmconcatcallbackupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :cmprofilefilterupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :cmprofilefilterupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :cmprofileaccessupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :cmprofileaccessupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppCMFlattenProcInfo #x3FE0)
(defconstant $uppCMBitmapCallBackProcInfo #x3D0)
(defconstant $uppCMConcatCallBackProcInfo #x3D0)
(defconstant $uppCMProfileFilterProcInfo #x3D0)
(defconstant $uppCMProfileAccessProcInfo #xFFE0)
; 
; 	 *  NewCMFlattenUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in 3.0 and later
; 	 	
;  old name was NewCMFlattenProc 
(deftrap "_NewCMFlattenUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewCMBitmapCallBackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in 3.0 and later
;  
;  old name was NewCMBitmapCallBackProc 
(deftrap "_NewCMBitmapCallBackUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewCMConcatCallBackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in 3.0 and later
;  
;  old name was NewCMConcatCallBackProc 
(deftrap "_NewCMConcatCallBackUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewCMProfileFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in 3.0 and later
;  
;  old name was NewCMProfileFilterProc 
(deftrap "_NewCMProfileFilterUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewCMProfileAccessUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in 3.0 and later
;  
;  old name was NewCMProfileAccessProc 
(deftrap "_NewCMProfileAccessUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeCMFlattenUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in 3.0 and later
;  

(deftrap "_DisposeCMFlattenUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeCMBitmapCallBackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in 3.0 and later
;  

(deftrap "_DisposeCMBitmapCallBackUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeCMConcatCallBackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in 3.0 and later
;  

(deftrap "_DisposeCMConcatCallBackUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeCMProfileFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in 3.0 and later
;  

(deftrap "_DisposeCMProfileFilterUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeCMProfileAccessUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in 3.0 and later
;  

(deftrap "_DisposeCMProfileAccessUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeCMFlattenUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in 3.0 and later
;  
;  old name was CallCMFlattenProc 
(deftrap-inline "_InvokeCMFlattenUPP" 
      ((command :signed-long) (size (:pointer :signed-long)) (data :pointer) (refCon :pointer) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeCMBitmapCallBackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in 3.0 and later
;  
;  old name was CallCMBitmapCallBackProc 
(deftrap-inline "_InvokeCMBitmapCallBackUPP" 
      ((progress :signed-long) (refCon :pointer) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; 
;  *  InvokeCMConcatCallBackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in 3.0 and later
;  
;  old name was CallCMConcatCallBackProc 
(deftrap-inline "_InvokeCMConcatCallBackUPP" 
      ((progress :signed-long) (refCon :pointer) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; 
;  *  InvokeCMProfileFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in 3.0 and later
;  
;  old name was CallCMProfileFilterProc 
(deftrap-inline "_InvokeCMProfileFilterUPP" 
      ((prof :pointer) (refCon :pointer) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; 
;  *  InvokeCMProfileAccessUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in 3.0 and later
;  
;  old name was CallCMProfileAccessProc 
(deftrap-inline "_InvokeCMProfileAccessUPP" 
      ((command :signed-long) (offset :signed-long) (size (:pointer :signed-long)) (data :pointer) (refCon :pointer) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CMTypesIncludes

; $ENDC                                         ; __CMTYPES__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'CMTypes)