(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CodeFragments.p"
; at Wednesday May 1,2002 2:39:42 pm.
; 
;      File:       CodeFragments.p
;  
;      Contains:   Public Code Fragment Manager Interfaces.
;  
;      Version:    Technology: Forte CFM and Carbon
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1992-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
; 
;    
;    ===========================================================================================
;    The Code Fragment Manager API
;    =============================
; 

#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __CODEFRAGMENTS__
; $SETC __CODEFRAGMENTS__ := 1

; $I+
; $SETC CodeFragmentsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $IFC UNDEFINED __CFBUNDLE__

(require-interface 'CFBundle)                   ; $I CFBundle.p
; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __MULTIPROCESSING__

(require-interface 'Multiprocessing)            ; $I Multiprocessing.p
; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;    
;    ===========================================================================================
;    General Types and Constants
;    ===========================
; 

(defconstant $kCFragResourceType :|cfrg|)
(defconstant $kCFragResourceID 0)
(defconstant $kCFragLibraryFileType :|shlb|)
(defconstant $kCFragAllFileTypes #xFFFFFFFF)

(def-mactype :cfragarchitecture (find-mactype ':ostype))

;   Values for type CFragArchitecture. 
(defconstant $kPowerPCCFragArch :|pwpc|)
(defconstant $kMotorola68KCFragArch :|m68k|)
(defconstant $kAnyCFragArch #x3F3F3F3F)

; $IFC TARGET_CPU_PPC 
(defconstant $kCompiledCFragArch :|pwpc|)

; $ENDC                                         ; TARGET_CPU_PPC

#|                                              ; $IFC TARGET_CPU_68K 
(defconstant $kCompiledCFragArch :|m68k|)

 |#                                             ; $ENDC; TARGET_CPU_68K

(def-mactype :cfragversionnumber (find-mactype ':unsigned-long))

(defconstant $kNullCFragVersion 0)
(defconstant $kWildcardCFragVersion #xFFFFFFFF)

(def-mactype :cfragusage (find-mactype ':unsigned-byte))

;   Values for type CFragUsage. 
(defconstant $kImportLibraryCFrag 0)            ;   Standard CFM import library. 
(defconstant $kApplicationCFrag 1)              ;   MacOS application. 
(defconstant $kDropInAdditionCFrag 2)           ;   Application or library private extension/plug-in 
(defconstant $kStubLibraryCFrag 3)              ;   Import library used for linking only 
(defconstant $kWeakStubLibraryCFrag 4)          ;   Import library used for linking only and will be automatically weak linked 

(defconstant $kIsCompleteCFrag 0)               ;   A "base" fragment, not an update. 
(defconstant $kFirstCFragUpdate 1)              ;   The first update, others are numbered 2, 3, ... 

(defconstant $kCFragGoesToEOF 0)

(def-mactype :cfraglocatorkind (find-mactype ':unsigned-byte))

;   Values for type CFragLocatorKind. 
(defconstant $kMemoryCFragLocator 0)            ;   Container is in memory. 
(defconstant $kDataForkCFragLocator 1)          ;   Container is in a file's data fork. 
(defconstant $kResourceCFragLocator 2)          ;   Container is in a file's resource fork. 
(defconstant $kNamedFragmentCFragLocator 4)     ;   ! Reserved for possible future use! 
(defconstant $kCFBundleCFragLocator 5)          ;   Container is in the executable of a CFBundle 
(defconstant $kCFBundleIntCFragLocator 6)       ;   passed to init routines in lieu of kCFBundleCFragLocator 

; 
; 	   --------------------------------------------------------------------------------------
; 	   A 'cfrg' resource consists of a header followed by a sequence of variable length
; 	   members.  The constant kDefaultCFragNameLen only provides for a legal ANSI declaration
; 	   and for a reasonable display in a debugger.  The actual name field is cut to fit.
; 	   There may be "extensions" after the name, the memberSize field includes them.  The
; 	   general form of an extension is a 16 bit type code followed by a 16 bit size in bytes.
; 	   Only one standard extension type is defined at present, it is used by SOM's searching
; 	   mechanism.
; 	

(def-mactype :cfragusage1unionptr (find-mactype '(:pointer :cfragusage1union)))
(defrecord CFragUsage1Union 
   (:variant 
;   ! Meaning differs depending on value of "usage". 
      (
      (appStackSize :unsigned-long)             ;   If the fragment is an application. (Not used by CFM!) 
      )
      )
   )

(def-mactype :cfragusage2unionptr (find-mactype '(:pointer :cfragusage2union)))
(defrecord CFragUsage2Union 
   (:variant 
;   ! Meaning differs depending on value of "usage". 
      (
      (appSubdirID :signed-integer)             ;   If the fragment is an application. 
      )
      (
      (libFlags :unsigned-integer)              ;   If the fragment is an import library. 
      )
      )
   )

;   Bit masks for the CFragUsage2Union libFlags variant. 
(defconstant $kCFragLibUsageMapPrivatelyMask #x1);   Put container in app heap if necessary. 

(def-mactype :cfragwhere1unionptr (find-mactype '(:pointer :cfragwhere1union)))
(defrecord CFragWhere1Union 
   (:variant 
;   ! Meaning differs depending on value of "where". 
      (
      (spaceID :unsigned-long)                  ;   If the fragment is in memory.  (Actually an AddressSpaceID.) 
      )
      )
   )

(def-mactype :cfragwhere2unionptr (find-mactype '(:pointer :cfragwhere2union)))
(defrecord CFragWhere2Union 
   (:variant 
;   ! Meaning differs depending on value of "where". 
      (
      (reserved :unsigned-integer)
      )
      )
   )

(defconstant $kDefaultCFragNameLen 16)

(def-mactype :cfragresourcememberptr (find-mactype '(:pointer :cfragresourcemember)))
(defrecord CFragResourceMember 
   (architecture :ostype)
   (reservedA :unsigned-integer)                ;   ! Must be zero! 
   (reservedB :signed-byte)                     ;   ! Must be zero! 
   (updateLevel :signed-byte)
   (currentVersion :unsigned-long)
   (oldDefVersion :unsigned-long)
   (uUsage1 :cfragusage1union)
   (uUsage2 :cfragusage2union)
   (usage :signed-byte)
   (where :signed-byte)
   (offset :unsigned-long)
   (length :unsigned-long)
   (uWhere1 :cfragwhere1union)
   (uWhere2 :cfragwhere2union)
   (extensionCount :unsigned-integer)           ;   The number of extensions beyond the name. 
   (memberSize :unsigned-integer)               ;   Size in bytes, includes all extensions. 
   (name (:array :unsigned-byte 16 :packed))    ;   ! Actually a sized PString. 
   )

(def-mactype :cfragresourceextensionheaderptr (find-mactype '(:pointer :cfragresourceextensionheader)))
(defrecord CFragResourceExtensionHeader 
   (extensionKind :unsigned-integer)
   (extensionSize :unsigned-integer)
   )

(def-mactype :cfragresourcesearchextensionptr (find-mactype '(:pointer :cfragresourcesearchextension)))
(defrecord CFragResourceSearchExtension 
   (header :cfragresourceextensionheader)
   (libKind :ostype)
   ;;Changing field qualifiers from signed-byte to unsigned-byte to match C header (educated-guess)
   (qualifiers :unsigned-byte)                  ;   ! Actually four PStrings. 
   )

(defconstant $kCFragResourceSearchExtensionKind #x30EE)

(def-mactype :cfragresourceptr (find-mactype '(:pointer :cfragresource)))
(defrecord CFragResource 
   (reservedA :unsigned-long)                   ;   ! Must be zero! 
   (reservedB :unsigned-long)                   ;   ! Must be zero! 
   (reservedC :unsigned-integer)                ;   ! Must be zero! 
   (version :unsigned-integer)
   (reservedD :unsigned-long)                   ;   ! Must be zero! 
   (reservedE :unsigned-long)                   ;   ! Must be zero! 
   (reservedF :unsigned-long)                   ;   ! Must be zero! 
   (reservedG :unsigned-long)                   ;   ! Must be zero! 
   (reservedH :unsigned-integer)                ;   ! Must be zero! 
   (memberCount :unsigned-integer)
   (firstMember :cfragresourcemember)
   )

(def-mactype :cfragresourcehandle (find-mactype '(:handle :cfragresource)))

(defconstant $kCurrCFragResourceVersion 1)

#|
; Warning: Patching def of type CFragContextID from translator table: was :pointer, is now :unsigned-long
|#
(def-mactype :cfragcontextid (find-mactype :unsigned-long))
#| 
(def-mactype :cfragcontextid (find-mactype ':pointer)) |#
#|
; Warning: Patching def of type CFragConnectionID from translator table: was :pointer, is now :unsigned-long
|#
(def-mactype :cfragconnectionid (find-mactype :unsigned-long))
#| 
(def-mactype :cfragconnectionid (find-mactype ':pointer)) |#;  an opaque 32-bit type 
(def-mactype :cfragconnectionidptr (find-mactype '(:pointer :unsigned-long)));  when a VAR xx:CFragConnectionID parameter can be nil, it is changed to xx: CFragConnectionIDPtr 
#|
; Warning: Patching def of type CFragClosureID from translator table: was :pointer, is now :unsigned-long
|#
(def-mactype :cfragclosureid (find-mactype :unsigned-long))
#| 
(def-mactype :cfragclosureid (find-mactype ':pointer)) |#;  an opaque 32-bit type 
(def-mactype :cfragclosureidptr (find-mactype '(:pointer :unsigned-long)));  when a VAR xx:CFragClosureID parameter can be nil, it is changed to xx: CFragClosureIDPtr 
#|
; Warning: Patching def of type CFragContainerID from translator table: was :pointer, is now :unsigned-long
|#
(def-mactype :cfragcontainerid (find-mactype :unsigned-long))
#| 
(def-mactype :cfragcontainerid (find-mactype ':pointer)) |#;  an opaque 32-bit type 
(def-mactype :cfragcontaineridptr (find-mactype '(:pointer :unsigned-long)));  when a VAR xx:CFragContainerID parameter can be nil, it is changed to xx: CFragContainerIDPtr 
(def-mactype :cfragloadoptions (find-mactype ':unsigned-long))

;   Values for type CFragLoadOptions. 
(defconstant $kReferenceCFrag #x1)              ;   Try to use existing copy, increment reference counts. 
(defconstant $kFindCFrag #x2)                   ;   Try find an existing copy, do not increment reference counts. 
(defconstant $kPrivateCFragCopy #x5)            ;   Prepare a new private copy.  (kReferenceCFrag | 0x0004) 

(defconstant $kUnresolvedCFragSymbolAddress 0)

(def-mactype :cfragsymbolclass (find-mactype ':unsigned-byte))

;   Values for type CFragSymbolClass. 
(defconstant $kCodeCFragSymbol 0)
(defconstant $kDataCFragSymbol 1)
(defconstant $kTVectorCFragSymbol 2)
(defconstant $kTOCCFragSymbol 3)
(defconstant $kGlueCFragSymbol 4)

; 
; 	   
; 	   ===========================================================================================
; 	   Macros and Functions
; 	   ====================
; 	

; 
; 	 *  GetSharedLibrary()
; 	 *  
; 	 *  Discussion:
; 	 *    The connID, mainAddr, and errMessage parameters may be NULL with
; 	 *    MacOS 8.5 and later. Passing NULL as those parameters when
; 	 *    running Mac OS 8.1 and earlier systems will corrupt low-memory.
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in CFragManager 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_GetSharedLibrary" 
      ((libName (:string 63)) (archType :ostype) (options :unsigned-long) (connID (:pointer :unsigned-long)) (mainAddr (:pointer :pointer)) (errMessage (:pointer (:string 255))))
   (:stack :signed-integer)
   (:stack-trap #xAA5A libName archType options connID mainAddr errMessage (1 :signed-integer)))

; 
;  *  GetDiskFragment()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CFragManager 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_GetDiskFragment" 
      ((fileSpec (:pointer :fsspec)) (offset :unsigned-long) (length :unsigned-long) (fragName (:pointer (:string 255))) (options :unsigned-long) (connID (:pointer :unsigned-long)) (mainAddr (:pointer :pointer)) (errMessage (:pointer (:string 255))))
   (:stack :signed-integer)
   (:stack-trap #xAA5A fileSpec offset length fragName options connID mainAddr errMessage (2 :signed-integer)))

; 
;  *  GetMemFragment()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CFragManager 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetMemFragment" 
      ((memAddr :pointer) (length :unsigned-long) (fragName (:pointer (:string 255))) (options :unsigned-long) (connID (:pointer :unsigned-long)) (mainAddr (:pointer :pointer)) (errMessage (:pointer (:string 255))))
   (:stack :signed-integer)
   (:stack-trap #xAA5A memAddr length fragName options connID mainAddr errMessage (3 :signed-integer)))

; 
;  *  CloseConnection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CFragManager 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CloseConnection" 
      ((connID (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA5A connID (4 :signed-integer)))

; 
;  *  FindSymbol()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CFragManager 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FindSymbol" 
      ((connID :unsigned-long) (symName (:string 255)) (symAddr (:pointer :pointer)) (symClass (:pointer :unsigned-byte)))
   (:stack :signed-integer)
   (:stack-trap #xAA5A connID symName symAddr symClass (5 :signed-integer)))

; 
;  *  CountSymbols()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CFragManager 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CountSymbols" 
      ((connID :unsigned-long) (symCount (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA5A connID symCount (6 :signed-integer)))

; 
;  *  GetIndSymbol()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CFragManager 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetIndSymbol" 
      ((connID :unsigned-long) (symIndex :signed-long) (symName (:pointer (:string 255))) (symAddr (:pointer :pointer)) (symClass (:pointer :unsigned-byte)))
   (:stack :signed-integer)
   (:stack-trap #xAA5A connID symIndex symName symAddr symClass (7 :signed-integer)))

; 
;    
;    ===========================================================================================
;    Initialization & Termination Routines
;    =====================================
; 

; 
;    -----------------------------------------------------------------------------------------
;    A fragment's initialization and termination routines are called when a new incarnation of
;    the fragment is created or destroyed, respectively.  Exactly when this occurs depends on
;    what kinds of section sharing the fragment has and how the fragment is prepared.  Import
;    libraries have at most one incarnation per process.  Fragments prepared with option
;    kPrivateCFragCopy may have many incarnations per process.
;    The initialization function is passed a pointer to an initialization information structure
;    and returns an OSErr.  If an initialization function returns a non-zero value the entire
;    closure of which it is a part fails.  The C prototype for an initialization function is:
;         OSErr   CFragInitFunction   ( const CFragInitBlock *    initBlock );
;    The termination procedure takes no parameters and returns nothing.  The C prototype for a
;    termination procedure is:
;         void    CFragTermProcedure  ( void );
;    Note that since the initialization and termination routines are themselves "CFM"-style
;    routines whether or not they have the "pascal" keyword is irrelevant.
; 

; 
;    -----------------------------------------------------------------------------------------
;    ! Note:
;    ! The "System7" portion of these type names was introduced during the evolution towards
;    ! the now defunct Copland version of Mac OS.  Copland was to be called System 8 and there
;    ! were slightly different types for System 7 and System 8.  The "generic" type names were
;    ! conditionally defined for the desired target system.
;    ! Always use the generic types, e.g. CFragInitBlock!  The "System7" names have been kept
;    ! only to avoid perturbing code that (improperly) used the target specific type.
; 

(def-mactype :cfragsystem7memorylocatorptr (find-mactype '(:pointer :cfragsystem7memorylocator)))
(defrecord CFragSystem7MemoryLocator 
   (address :pointer)
   (length :unsigned-long)
   (inPlace :boolean)
   (reservedA :signed-byte)                     ;   ! Must be zero! 
   (reservedB :unsigned-integer)                ;   ! Must be zero! 
   )

(def-mactype :cfragsystem7diskflatlocatorptr (find-mactype '(:pointer :cfragsystem7diskflatlocator)))
(defrecord CFragSystem7DiskFlatLocator 
   (fileSpec (:pointer :fsspec))
   (offset :unsigned-long)
   (length :unsigned-long)
   )

;   ! This must have a file specification at the same offset as a disk flat locator! 
(def-mactype :cfragsystem7segmentedlocatorptr (find-mactype '(:pointer :cfragsystem7segmentedlocator)))
(defrecord CFragSystem7SegmentedLocator 
   (fileSpec (:pointer :fsspec))
   (rsrcType :ostype)
   (rsrcID :signed-integer)
   (reservedA :unsigned-integer)                ;   ! Must be zero! 
   )

; 
; 	   The offset and length for a "Bundle" locator refers to the offset in
; 	   the CFM executable contained by the bundle.
; 	
(def-mactype :cfragcfbundlelocatorptr (find-mactype '(:pointer :cfragcfbundlelocator)))
(defrecord CFragCFBundleLocator 
   (fragmentBundle :pointer)                    ;   Do not call CFRelease on this bundle! 
   (offset :unsigned-long)
   (length :unsigned-long)
   )

(def-mactype :cfragsystem7locatorptr (find-mactype '(:pointer :cfragsystem7locator)))
(defrecord CFragSystem7Locator 
   (where :signed-long)
   (:variant 
      (
      (onDisk :cfragsystem7diskflatlocator)
      )
      (
      (inMem :cfragsystem7memorylocator)
      )
      (
      (inSegs :cfragsystem7segmentedlocator)
      )
      (
      (inBundle :cfragcfbundlelocator)
      )
      )
   )

(def-mactype :cfragsystem7initblockptr (find-mactype '(:pointer :cfragsystem7initblock)))
(defrecord CFragSystem7InitBlock 
   (contextID :unsigned-long)
   (closureID :unsigned-long)
   (connectionID :unsigned-long)
   (fragLocator :cfragsystem7locator)
   (libName (:pointer (:string 255)))
   (reservedA :unsigned-long)                   ;   ! Must be zero! 
   )

(%define-record :cfraginitblock (find-record-descriptor :cfragsystem7initblock))
(def-mactype :cfraginitblockptr (find-mactype '(:pointer :cfragsystem7initblock)))
;   These init/term routine types are only of value to CFM itself. 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFragInitFunction = FUNCTION({CONST}VAR initBlock: CFragInitBlock): OSErr; C;

|#
 |#                                             ; $ELSEC
(def-mactype :cfraginitfunction (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFragTermProcedure = PROCEDURE; C;

|#
 |#                                             ; $ELSEC
(def-mactype :cfragtermprocedure (find-mactype ':pointer))
; $ENDC

; 
; 	   For use by init routines. If you get a BundleIntLocator (used to be BundlePreLocator),
; 	   convert it to a CFBundleLocator with this. Only call this once per locator.
; 	
; 
; 	 *  ConvertBundlePreLocator()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.4 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;    
;    ===========================================================================================
;    Old Name Spellings
;    ==================
;                                               ; 
;    -------------------------------------------------------------------------------------------
;    We've tried to reduce the risk of name collisions in the future by introducing the phrase
;    "CFrag" into constant and type names.  The old names are defined below in terms of the new.
; 
(deftrap-inline "_ConvertBundlePreLocator" 
      ((initBlockLocator (:pointer :cfragsystem7locator))) 
  :signed-integer
   () )
(defconstant $kLoadCFrag #x1)

; $IFC OLDROUTINENAMES 

(def-mactype :connectionid (find-mactype ':unsigned-long))
(def-mactype :loadflags (find-mactype ':unsigned-long))
(def-mactype :symclass (find-mactype ':unsigned-byte))
(%define-record :initblock (find-record-descriptor :cfragsystem7initblock))
(def-mactype :initblockptr (find-mactype '(:pointer :cfragsystem7initblock)))
(%define-record :memfragment (find-record-descriptor :cfragsystem7memorylocator))
(def-mactype :memfragmentptr (find-mactype '(:pointer :cfragsystem7memorylocator)))
(%define-record :diskfragment (find-record-descriptor :cfragsystem7diskflatlocator))
(def-mactype :diskfragmentptr (find-mactype '(:pointer :cfragsystem7diskflatlocator)))
(%define-record :segmentedfragment (find-record-descriptor :cfragsystem7segmentedlocator))
(def-mactype :segmentedfragmentptr (find-mactype '(:pointer :cfragsystem7segmentedlocator)))
(%define-record :fragmentlocator (find-record-descriptor :cfragsystem7locator))
(def-mactype :fragmentlocatorptr (find-mactype '(:pointer :cfragsystem7locator)))
(%define-record :cfraghfsmemorylocator (find-record-descriptor :cfragsystem7memorylocator))
(def-mactype :cfraghfsmemorylocatorptr (find-mactype '(:pointer :cfragsystem7memorylocator)))
(%define-record :cfraghfsdiskflatlocator (find-record-descriptor :cfragsystem7diskflatlocator))
(def-mactype :cfraghfsdiskflatlocatorptr (find-mactype '(:pointer :cfragsystem7diskflatlocator)))
(%define-record :cfraghfssegmentedlocator (find-record-descriptor :cfragsystem7segmentedlocator))
(def-mactype :cfraghfssegmentedlocatorptr (find-mactype '(:pointer :cfragsystem7segmentedlocator)))
(%define-record :cfraghfslocator (find-record-descriptor :cfragsystem7locator))
(def-mactype :cfraghfslocatorptr (find-mactype '(:pointer :cfragsystem7locator)))

(defconstant $kPowerPCArch :|pwpc|)
(defconstant $kMotorola68KArch :|m68k|)
(defconstant $kAnyArchType #x3F3F3F3F)
(defconstant $kNoLibName 0)
(defconstant $kNoConnectionID 0)
(defconstant $kLoadLib #x1)
(defconstant $kFindLib #x2)
(defconstant $kNewCFragCopy #x5)
(defconstant $kLoadNewCopy #x5)
(defconstant $kUseInPlace #x80)
(defconstant $kCodeSym 0)
(defconstant $kDataSym 1)
(defconstant $kTVectSym 2)
(defconstant $kTOCSym 3)
(defconstant $kGlueSym 4)
(defconstant $kInMem 0)
(defconstant $kOnDiskFlat 1)
(defconstant $kOnDiskSegmented 2)
(defconstant $kIsLib 0)
(defconstant $kIsApp 1)
(defconstant $kIsDropIn 2)
(defconstant $kFullLib 0)
(defconstant $kUpdateLib 1)
(defconstant $kWholeFork 0)
(defconstant $kCFMRsrcType :|cfrg|)
(defconstant $kCFMRsrcID 0)
(defconstant $kSHLBFileType :|shlb|)
(defconstant $kUnresolvedSymbolAddress 0)

(defconstant $kPowerPC :|pwpc|)
(defconstant $kMotorola68K :|m68k|)

; $ENDC                                         ; OLDROUTINENAMES

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CodeFragmentsIncludes

; $ENDC                                         ; __CODEFRAGMENTS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'CodeFragments)