(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Collections.p"
; at Wednesday May 1,2002 2:39:37 pm.
; 
;      File:       Collections.p
;  
;      Contains:   Collection Manager Interfaces
;  
;      Version:    Technology: Carbon
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1989-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __COLLECTIONS__
; $SETC __COLLECTIONS__ := 1

; $I+
; $SETC CollectionsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; ***********
;  Constants 
; ***********
;  Convenience constants for functions which optionally return values 

(defconstant $kCollectionDontWantTag 0)
(defconstant $kCollectionDontWantId 0)
(defconstant $kCollectionDontWantSize 0)
(defconstant $kCollectionDontWantAttributes 0)
(defconstant $kCollectionDontWantIndex 0)
(defconstant $kCollectionDontWantData 0)

; 	 attributes bits 	
(defconstant $kCollectionNoAttributes #x0)      ;   no attributes bits set  
(defconstant $kCollectionAllAttributes #xFFFFFFFF);   all attributes bits set  
(defconstant $kCollectionUserAttributes #xFFFF) ;   user attributes bits  
(defconstant $kCollectionDefaultAttributes #x40000000);   default attributes - unlocked, persistent  

; 	 
; 	    Attribute bits 0 through 15 (entire low word) are reserved for use by the application.
; 	    Attribute bits 16 through 31 (entire high word) are reserved for use by the Collection Manager.
; 	    Only bits 31 (kCollectionLockBit) and 30 (kCollectionPersistenceBit) currently have meaning.
; 		
(defconstant $kCollectionUser0Bit 0)
(defconstant $kCollectionUser1Bit 1)
(defconstant $kCollectionUser2Bit 2)
(defconstant $kCollectionUser3Bit 3)
(defconstant $kCollectionUser4Bit 4)
(defconstant $kCollectionUser5Bit 5)
(defconstant $kCollectionUser6Bit 6)
(defconstant $kCollectionUser7Bit 7)
(defconstant $kCollectionUser8Bit 8)
(defconstant $kCollectionUser9Bit 9)
(defconstant $kCollectionUser10Bit 10)
(defconstant $kCollectionUser11Bit 11)
(defconstant $kCollectionUser12Bit 12)
(defconstant $kCollectionUser13Bit 13)
(defconstant $kCollectionUser14Bit 14)
(defconstant $kCollectionUser15Bit 15)
(defconstant $kCollectionReserved0Bit 16)
(defconstant $kCollectionReserved1Bit 17)
(defconstant $kCollectionReserved2Bit 18)
(defconstant $kCollectionReserved3Bit 19)
(defconstant $kCollectionReserved4Bit 20)
(defconstant $kCollectionReserved5Bit 21)
(defconstant $kCollectionReserved6Bit 22)
(defconstant $kCollectionReserved7Bit 23)
(defconstant $kCollectionReserved8Bit 24)
(defconstant $kCollectionReserved9Bit 25)
(defconstant $kCollectionReserved10Bit 26)
(defconstant $kCollectionReserved11Bit 27)
(defconstant $kCollectionReserved12Bit 28)
(defconstant $kCollectionReserved13Bit 29)
(defconstant $kCollectionPersistenceBit 30)
(defconstant $kCollectionLockBit 31)

; 	 attribute masks 	
(defconstant $kCollectionUser0Mask #x1)
(defconstant $kCollectionUser1Mask #x2)
(defconstant $kCollectionUser2Mask #x4)
(defconstant $kCollectionUser3Mask #x8)
(defconstant $kCollectionUser4Mask #x10)
(defconstant $kCollectionUser5Mask #x20)
(defconstant $kCollectionUser6Mask #x40)
(defconstant $kCollectionUser7Mask #x80)
(defconstant $kCollectionUser8Mask #x100)
(defconstant $kCollectionUser9Mask #x200)
(defconstant $kCollectionUser10Mask #x400)
(defconstant $kCollectionUser11Mask #x800)
(defconstant $kCollectionUser12Mask #x1000)
(defconstant $kCollectionUser13Mask #x2000)
(defconstant $kCollectionUser14Mask #x4000)
(defconstant $kCollectionUser15Mask #x8000)
(defconstant $kCollectionReserved0Mask #x10000)
(defconstant $kCollectionReserved1Mask #x20000)
(defconstant $kCollectionReserved2Mask #x40000)
(defconstant $kCollectionReserved3Mask #x80000)
(defconstant $kCollectionReserved4Mask #x100000)
(defconstant $kCollectionReserved5Mask #x200000)
(defconstant $kCollectionReserved6Mask #x400000)
(defconstant $kCollectionReserved7Mask #x800000)
(defconstant $kCollectionReserved8Mask #x1000000)
(defconstant $kCollectionReserved9Mask #x2000000)
(defconstant $kCollectionReserved10Mask #x4000000)
(defconstant $kCollectionReserved11Mask #x8000000)
(defconstant $kCollectionReserved12Mask #x10000000)
(defconstant $kCollectionReserved13Mask #x20000000)
(defconstant $kCollectionPersistenceMask #x40000000)
(defconstant $kCollectionLockMask #x80000000)

; 	*********	
; 	 Types   	
; 	*********	
; 	 abstract data type for a collection 	

(def-mactype :collection (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :collectionptr (find-mactype '(:pointer :pointer)));  when a VAR xx:Collection parameter can be nil, it is changed to xx: CollectionPtr 
; 	 collection member 4 byte tag 	
(def-mactype :collectiontag (find-mactype ':ostype))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CollectionFlattenProcPtr = FUNCTION(size: SInt32; data: UNIV Ptr; refCon: UNIV Ptr): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :collectionflattenprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CollectionExceptionProcPtr = FUNCTION(c: Collection; status: OSErr): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :collectionexceptionprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :collectionflattenupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :collectionflattenupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :collectionexceptionupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :collectionexceptionupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppCollectionFlattenProcInfo #xFE0)
(defconstant $uppCollectionExceptionProcInfo #x2E0)
; 
; 	 *  NewCollectionFlattenUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewCollectionFlattenProc 
(deftrap "_NewCollectionFlattenUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewCollectionExceptionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewCollectionExceptionProc 
(deftrap "_NewCollectionExceptionUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeCollectionFlattenUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeCollectionFlattenUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeCollectionExceptionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeCollectionExceptionUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeCollectionFlattenUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallCollectionFlattenProc 
(deftrap-inline "_InvokeCollectionFlattenUPP" 
      ((size :signed-long) (data :pointer) (refCon :pointer) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeCollectionExceptionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallCollectionExceptionProc 
(deftrap-inline "_InvokeCollectionExceptionUPP" 
      ((c :pointer) (status :signed-integer) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; *******************************************
; ************ Public interfaces ************
; *******************************************
; 
;  *  NewCollection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_NewCollection" 
      ()
   (:stack :pointer)
   (:stack-trap #xABF6 :d0 0))

; 
;  *  DisposeCollection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeCollection" 
      ((c :pointer))
   nil
   (:stack-trap #xABF6 :d0 1 c))

; 
;  *  CloneCollection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CloneCollection" 
      ((c :pointer))
   (:stack :pointer)
   (:stack-trap #xABF6 :d0 2 c))

; 
;  *  CountCollectionOwners()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CountCollectionOwners" 
      ((c :pointer))
   (:stack :signed-long)
   (:stack-trap #xABF6 :d0 3 c))

; 
;  *  RetainCollection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  ReleaseCollection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_RetainCollection" 
      ((c :pointer)) 
  :osstatus
   () )                                         ; 
;  *  GetCollectionRetainCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ReleaseCollection" 
      ((c :pointer)) 
  :osstatus
   () )                                         ; 
;  *  CopyCollection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetCollectionRetainCount" 
      ((c :pointer)) 
  :unsigned-long
   () )
(deftrap "_CopyCollection" 
      ((srcCollection :pointer) (dstCollection :pointer))
   (:stack :pointer)
   (:stack-trap #xABF6 :d0 4 srcCollection dstCollection))

; 
;  *  GetCollectionDefaultAttributes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetCollectionDefaultAttributes" 
      ((c :pointer))
   (:stack :signed-long)
   (:stack-trap #xABF6 :d0 5 c))

; 
;  *  SetCollectionDefaultAttributes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetCollectionDefaultAttributes" 
      ((c :pointer) (whichAttributes :signed-long) (newAttributes :signed-long))
   nil
   (:stack-trap #xABF6 :d0 6 c whichAttributes newAttributes))

; 
;  *  CountCollectionItems()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CountCollectionItems" 
      ((c :pointer))
   (:stack :signed-long)
   (:stack-trap #xABF6 :d0 7 c))

; 
;  *  AddCollectionItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AddCollectionItem" 
      ((c :pointer) (tag :ostype) (id :signed-long) (itemSize :signed-long) (itemData :pointer))
   (:stack :signed-integer)
   (:stack-trap #xABF6 :d0 8 c tag id itemSize itemData))

; 
;  *  GetCollectionItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetCollectionItem" 
      ((c :pointer) (tag :ostype) (id :signed-long) (itemSize (:pointer :signed-long)) (itemData :pointer))
   (:stack :signed-integer)
   (:stack-trap #xABF6 :d0 9 c tag id itemSize itemData))

; 
;  *  RemoveCollectionItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_RemoveCollectionItem" 
      ((c :pointer) (tag :ostype) (id :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xABF6 :d0 10 c tag id))

; 
;  *  SetCollectionItemInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetCollectionItemInfo" 
      ((c :pointer) (tag :ostype) (id :signed-long) (whichAttributes :signed-long) (newAttributes :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xABF6 :d0 11 c tag id whichAttributes newAttributes))

; 
;  *  GetCollectionItemInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetCollectionItemInfo" 
      ((c :pointer) (tag :ostype) (id :signed-long) (index (:pointer :signed-long)) (itemSize (:pointer :signed-long)) (attributes (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xABF6 :d0 12 c tag id index itemSize attributes))

; 
;  *  ReplaceIndexedCollectionItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ReplaceIndexedCollectionItem" 
      ((c :pointer) (index :signed-long) (itemSize :signed-long) (itemData :pointer))
   (:stack :signed-integer)
   (:stack-trap #xABF6 :d0 13 c index itemSize itemData))

; 
;  *  GetIndexedCollectionItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetIndexedCollectionItem" 
      ((c :pointer) (index :signed-long) (itemSize (:pointer :signed-long)) (itemData :pointer))
   (:stack :signed-integer)
   (:stack-trap #xABF6 :d0 14 c index itemSize itemData))

; 
;  *  RemoveIndexedCollectionItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_RemoveIndexedCollectionItem" 
      ((c :pointer) (index :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xABF6 :d0 15 c index))

; 
;  *  SetIndexedCollectionItemInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetIndexedCollectionItemInfo" 
      ((c :pointer) (index :signed-long) (whichAttributes :signed-long) (newAttributes :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xABF6 :d0 16 c index whichAttributes newAttributes))

; 
;  *  GetIndexedCollectionItemInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetIndexedCollectionItemInfo" 
      ((c :pointer) (index :signed-long) (tag (:pointer :ostype)) (id (:pointer :signed-long)) (itemSize (:pointer :signed-long)) (attributes (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xABF6 :d0 17 c index tag id itemSize attributes))

; 
;  *  CollectionTagExists()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CollectionTagExists" 
      ((c :pointer) (tag :ostype))
   (:stack :boolean)
   (:stack-trap #xABF6 :d0 18 c tag))

; 
;  *  CountCollectionTags()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CountCollectionTags" 
      ((c :pointer))
   (:stack :signed-long)
   (:stack-trap #xABF6 :d0 19 c))

; 
;  *  GetIndexedCollectionTag()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetIndexedCollectionTag" 
      ((c :pointer) (tagIndex :signed-long) (tag (:pointer :ostype)))
   (:stack :signed-integer)
   (:stack-trap #xABF6 :d0 20 c tagIndex tag))

; 
;  *  CountTaggedCollectionItems()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CountTaggedCollectionItems" 
      ((c :pointer) (tag :ostype))
   (:stack :signed-long)
   (:stack-trap #xABF6 :d0 21 c tag))

; 
;  *  GetTaggedCollectionItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetTaggedCollectionItem" 
      ((c :pointer) (tag :ostype) (whichItem :signed-long) (itemSize (:pointer :signed-long)) (itemData :pointer))
   (:stack :signed-integer)
   (:stack-trap #xABF6 :d0 22 c tag whichItem itemSize itemData))

; 
;  *  GetTaggedCollectionItemInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetTaggedCollectionItemInfo" 
      ((c :pointer) (tag :ostype) (whichItem :signed-long) (id (:pointer :signed-long)) (index (:pointer :signed-long)) (itemSize (:pointer :signed-long)) (attributes (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xABF6 :d0 23 c tag whichItem id index itemSize attributes))

; 
;  *  PurgeCollection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PurgeCollection" 
      ((c :pointer) (whichAttributes :signed-long) (matchingAttributes :signed-long))
   nil
   (:stack-trap #xABF6 :d0 24 c whichAttributes matchingAttributes))

; 
;  *  PurgeCollectionTag()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PurgeCollectionTag" 
      ((c :pointer) (tag :ostype))
   nil
   (:stack-trap #xABF6 :d0 25 c tag))

; 
;  *  EmptyCollection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_EmptyCollection" 
      ((c :pointer))
   nil
   (:stack-trap #xABF6 :d0 26 c))

; 
;  *  FlattenCollection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FlattenCollection" 
      ((c :pointer) (flattenProc :pointer) (refCon :pointer))
   (:stack :signed-integer)
   (:stack-trap #xABF6 :d0 27 c flattenProc refCon))

; 
;  *  FlattenPartialCollection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FlattenPartialCollection" 
      ((c :pointer) (flattenProc :pointer) (refCon :pointer) (whichAttributes :signed-long) (matchingAttributes :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xABF6 :d0 28 c flattenProc refCon whichAttributes matchingAttributes))

; 
;  *  UnflattenCollection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_UnflattenCollection" 
      ((c :pointer) (flattenProc :pointer) (refCon :pointer))
   (:stack :signed-integer)
   (:stack-trap #xABF6 :d0 29 c flattenProc refCon))

; 
;  *  GetCollectionExceptionProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetCollectionExceptionProc" 
      ((c :pointer))
   (:stack :pointer)
   (:stack-trap #xABF6 :d0 30 c))

; 
;  *  SetCollectionExceptionProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetCollectionExceptionProc" 
      ((c :pointer) (exceptionProc :pointer))
   nil
   (:stack-trap #xABF6 :d0 31 c exceptionProc))

; 
;  *  GetNewCollection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetNewCollection" 
      ((collectionID :signed-integer))
   (:stack :pointer)
   (:stack-trap #xABF6 :d0 32 collectionID))

; ********************************************************************
; ************* Utility routines for handle-based access *************
; ********************************************************************
; 
;  *  AddCollectionItemHdl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AddCollectionItemHdl" 
      ((aCollection :pointer) (tag :ostype) (id :signed-long) (itemData :handle))
   (:stack :signed-integer)
   (:stack-trap #xABF6 :d0 33 aCollection tag id itemData))

; 
;  *  GetCollectionItemHdl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetCollectionItemHdl" 
      ((aCollection :pointer) (tag :ostype) (id :signed-long) (itemData :handle))
   (:stack :signed-integer)
   (:stack-trap #xABF6 :d0 34 aCollection tag id itemData))

; 
;  *  ReplaceIndexedCollectionItemHdl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ReplaceIndexedCollectionItemHdl" 
      ((aCollection :pointer) (index :signed-long) (itemData :handle))
   (:stack :signed-integer)
   (:stack-trap #xABF6 :d0 35 aCollection index itemData))

; 
;  *  GetIndexedCollectionItemHdl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetIndexedCollectionItemHdl" 
      ((aCollection :pointer) (index :signed-long) (itemData :handle))
   (:stack :signed-integer)
   (:stack-trap #xABF6 :d0 36 aCollection index itemData))

; 
;  *  FlattenCollectionToHdl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FlattenCollectionToHdl" 
      ((aCollection :pointer) (flattened :handle))
   (:stack :signed-integer)
   (:stack-trap #xABF6 :d0 37 aCollection flattened))

; 
;  *  UnflattenCollectionFromHdl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CollectionsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_UnflattenCollectionFromHdl" 
      ((aCollection :pointer) (flattened :handle))
   (:stack :signed-integer)
   (:stack-trap #xABF6 :d0 38 aCollection flattened))

; $IFC OLDROUTINENAMES 

(defconstant $dontWantTag 0)
(defconstant $dontWantId 0)
(defconstant $dontWantSize 0)
(defconstant $dontWantAttributes 0)
(defconstant $dontWantIndex 0)
(defconstant $dontWantData 0)

(defconstant $noCollectionAttributes #x0)
(defconstant $allCollectionAttributes #xFFFFFFFF)
(defconstant $userCollectionAttributes #xFFFF)
(defconstant $defaultCollectionAttributes #x40000000)

(defconstant $collectionUser0Bit 0)
(defconstant $collectionUser1Bit 1)
(defconstant $collectionUser2Bit 2)
(defconstant $collectionUser3Bit 3)
(defconstant $collectionUser4Bit 4)
(defconstant $collectionUser5Bit 5)
(defconstant $collectionUser6Bit 6)
(defconstant $collectionUser7Bit 7)
(defconstant $collectionUser8Bit 8)
(defconstant $collectionUser9Bit 9)
(defconstant $collectionUser10Bit 10)
(defconstant $collectionUser11Bit 11)
(defconstant $collectionUser12Bit 12)
(defconstant $collectionUser13Bit 13)
(defconstant $collectionUser14Bit 14)
(defconstant $collectionUser15Bit 15)
(defconstant $collectionReserved0Bit 16)
(defconstant $collectionReserved1Bit 17)
(defconstant $collectionReserved2Bit 18)
(defconstant $collectionReserved3Bit 19)
(defconstant $collectionReserved4Bit 20)
(defconstant $collectionReserved5Bit 21)
(defconstant $collectionReserved6Bit 22)
(defconstant $collectionReserved7Bit 23)
(defconstant $collectionReserved8Bit 24)
(defconstant $collectionReserved9Bit 25)
(defconstant $collectionReserved10Bit 26)
(defconstant $collectionReserved11Bit 27)
(defconstant $collectionReserved12Bit 28)
(defconstant $collectionReserved13Bit 29)
(defconstant $collectionPersistenceBit 30)
(defconstant $collectionLockBit 31)

(defconstant $collectionUser0Mask #x1)
(defconstant $collectionUser1Mask #x2)
(defconstant $collectionUser2Mask #x4)
(defconstant $collectionUser3Mask #x8)
(defconstant $collectionUser4Mask #x10)
(defconstant $collectionUser5Mask #x20)
(defconstant $collectionUser6Mask #x40)
(defconstant $collectionUser7Mask #x80)
(defconstant $collectionUser8Mask #x100)
(defconstant $collectionUser9Mask #x200)
(defconstant $collectionUser10Mask #x400)
(defconstant $collectionUser11Mask #x800)
(defconstant $collectionUser12Mask #x1000)
(defconstant $collectionUser13Mask #x2000)
(defconstant $collectionUser14Mask #x4000)
(defconstant $collectionUser15Mask #x8000)
(defconstant $collectionReserved0Mask #x10000)
(defconstant $collectionReserved1Mask #x20000)
(defconstant $collectionReserved2Mask #x40000)
(defconstant $collectionReserved3Mask #x80000)
(defconstant $collectionReserved4Mask #x100000)
(defconstant $collectionReserved5Mask #x200000)
(defconstant $collectionReserved6Mask #x400000)
(defconstant $collectionReserved7Mask #x800000)
(defconstant $collectionReserved8Mask #x1000000)
(defconstant $collectionReserved9Mask #x2000000)
(defconstant $collectionReserved10Mask #x4000000)
(defconstant $collectionReserved11Mask #x8000000)
(defconstant $collectionReserved12Mask #x10000000)
(defconstant $collectionReserved13Mask #x20000000)
(defconstant $collectionPersistenceMask #x40000000)
(defconstant $collectionLockMask #x80000000)

; $ENDC                                         ; OLDROUTINENAMES

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CollectionsIncludes

; $ENDC                                         ; __COLLECTIONS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Collections)