(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CommResources.p"
; at Wednesday May 1,2002 2:41:15 pm.
; 
;      File:       CommResources.p
;  
;      Contains:   Communications Toolbox Resource Manager Interfaces.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1988-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __COMMRESOURCES__
; $SETC __COMMRESOURCES__ := 1

; $I+
; $SETC CommResourcesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __OSUTILS__
|#

(require-interface 'OSUtils)
#|                                              ; $I OSUtils.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; $IFC CALL_NOT_IN_CARBON 

;      tool classes (also the tool file types)     
(defconstant $classCM :|cbnd|)
(defconstant $classFT :|fbnd|)
(defconstant $classTM :|tbnd|)

;      version of the Comm Resource Manager    
(defconstant $curCRMVersion 2)                  ;   constants general to the use of the Communications Resource Manager  
(defconstant $crmType 9)                        ;   queue type  
(defconstant $crmRecVersion 1)                  ;   version of queue structure  
;      error codes  
(defconstant $crmGenericError -1)
(defconstant $crmNoErr 0)

; 	 data structures general to the use of the Communications Resource Manager 	

(def-mactype :crmerr (find-mactype ':signed-integer))
(def-mactype :crmrecptr (find-mactype '(:pointer :crmrec)))
(defrecord CRMRec 
   (qLink (:pointer :qelem))                    ;  reserved 
   (qType :signed-integer)                      ;  queue type -- ORD(crmType) = 9 
   (crmVersion :signed-integer)                 ;  version of queue element data structure 
   (crmPrivate :signed-long)                    ;  reserved 
   (crmReserved :signed-integer)                ;  reserved 
   (crmDeviceType :signed-long)                 ;  type of device, assigned by DTS 
   (crmDeviceID :signed-long)                   ;  device ID; assigned when CRMInstall is called 
   (crmAttributes :signed-long)                 ;  pointer to attribute block 
   (crmStatus :signed-long)                     ;  status variable - device specific 
   (crmRefCon :signed-long)                     ;  for device private use 
   )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  InitCRM()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  CRMGetHeader()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InitCRM" 
      () 
  :crmerr
   () )                                         ; 
;  *  CRMInstall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CRMGetHeader" 
      () 
  (:pointer :qhdr)
   () )                                         ; 
;  *  CRMRemove()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CRMInstall" 
      ((crmReqPtr (:pointer :crmrec))) 
  nil
   () )                                         ; 
;  *  CRMSearch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CRMRemove" 
      ((crmReqPtr (:pointer :crmrec))) 
  :signed-integer
   () )                                         ; 
;  *  CRMGetCRMVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CRMSearch" 
      ((crmReqPtr (:pointer :crmrec))) 
  (:pointer :crmrec)
   () )                                         ; 
;  *  CRMGetResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CRMGetCRMVersion" 
      () 
  :signed-integer
   () )                                         ; 
;  *  CRMGet1Resource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CRMGetResource" 
      ((theType :ostype) (theID :signed-integer)) 
  :handle
   () )                                         ; 
;  *  CRMGetIndResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CRMGet1Resource" 
      ((theType :ostype) (theID :signed-integer)) 
  :handle
   () )                                         ; 
;  *  CRMGet1IndResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CRMGetIndResource" 
      ((theType :ostype) (index :signed-integer)) 
  :handle
   () )                                         ; 
;  *  CRMGetNamedResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CRMGet1IndResource" 
      ((theType :ostype) (index :signed-integer)) 
  :handle
   () )                                         ; 
;  *  CRMGet1NamedResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CRMGetNamedResource" 
      ((theType :ostype) (name (:string 255))) 
  :handle
   () )                                         ; 
;  *  CRMReleaseResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CRMGet1NamedResource" 
      ((theType :ostype) (name (:string 255))) 
  :handle
   () )                                         ; 
;  *  CRMGetToolResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CRMReleaseResource" 
      ((theHandle :handle)) 
  nil
   () )                                         ; 
;  *  CRMGetToolNamedResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CRMGetToolResource" 
      ((procID :signed-integer) (theType :ostype) (theID :signed-integer)) 
  :handle
   () )                                         ; 
;  *  CRMReleaseToolResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CRMGetToolNamedResource" 
      ((procID :signed-integer) (theType :ostype) (name (:string 255))) 
  :handle
   () )                                         ; 
;  *  CRMGetIndex()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CRMReleaseToolResource" 
      ((procID :signed-integer) (theHandle :handle)) 
  nil
   () )                                         ; 
;  *  CRMLocalToRealID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CRMGetIndex" 
      ((theHandle :handle)) 
  :signed-long
   () )                                         ; 
;  *  CRMRealToLocalID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CRMLocalToRealID" 
      ((bundleType :ostype) (toolID :signed-integer) (theType :ostype) (localID :signed-integer)) 
  :signed-integer
   () )                                         ; 
;  *  CRMGetIndToolName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CRMRealToLocalID" 
      ((bundleType :ostype) (toolID :signed-integer) (theType :ostype) (realID :signed-integer)) 
  :signed-integer
   () )                                         ; 
;  *  CRMFindCommunications()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CRMGetIndToolName" 
      ((bundleType :ostype) (index :signed-integer) (toolName (:pointer (:string 255)))) 
  :signed-integer
   () )                                         ; 
;  *  CRMIsDriverOpen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CRMFindCommunications" 
      ((vRefNum (:pointer :signed-integer)) (dirID (:pointer :signed-long))) 
  :signed-integer
   () )                                         ; 
;  *  CRMParseCAPSResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CRMIsDriverOpen" 
      ((driverName (:string 255))) 
  :boolean
   () )                                         ; 
;  *  CRMReserveRF()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CRMParseCAPSResource" 
      ((theHandle :handle) (selector :ostype) (value (:pointer :unsigned-long))) 
  :crmerr
   () )                                         ; 
;  *  CRMReleaseRF()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CRMReserveRF" 
      ((refNum :signed-integer)) 
  :signed-integer
   () )
(deftrap-inline "_CRMReleaseRF" 
      ((refNum :signed-integer)) 
  :signed-integer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CommResourcesIncludes

; $ENDC                                         ; __COMMRESOURCES__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'CommResources)