(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Components.p"
; at Wednesday May 1,2002 2:38:52 pm.
; 
;      File:       Components.p
;  
;      Contains:   Component Manager Interfaces.
;  
;      Version:    Technology: QuickTime 5.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1991-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __COMPONENTS__
; $SETC __COMPONENTS__ := 1

; $I+
; $SETC ComponentsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __FILES__

(require-interface 'Files)                      ; $I Files.p
; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $kAppleManufacturer :|appl|)       ;   Apple supplied components  
(defconstant $kComponentResourceType :|thng|)   ;   a components resource type  
(defconstant $kComponentAliasResourceType :|thga|);   component alias resource type  

(defconstant $kAnyComponentType 0)
(defconstant $kAnyComponentSubType 0)
(defconstant $kAnyComponentManufacturer 0)
(defconstant $kAnyComponentFlagsMask 0)

(defconstant $cmpIsMissing #x20000000)
(defconstant $cmpWantsRegisterMessage #x80000000)

(defconstant $kComponentOpenSelect -1)          ;   ComponentInstance for this open  
(defconstant $kComponentCloseSelect -2)         ;   ComponentInstance for this close  
(defconstant $kComponentCanDoSelect -3)         ;   selector # being queried  
(defconstant $kComponentVersionSelect -4)       ;   no params  
(defconstant $kComponentRegisterSelect -5)      ;   no params  
(defconstant $kComponentTargetSelect -6)        ;   ComponentInstance for top of call chain  
(defconstant $kComponentUnregisterSelect -7)    ;   no params  
(defconstant $kComponentGetMPWorkFunctionSelect -8);   some params  
(defconstant $kComponentExecuteWiredActionSelect -9);   QTAtomContainer actionContainer, QTAtom actionAtom, QTCustomActionTargetPtr target, QTEventRecordPtr event  
(defconstant $kComponentGetPublicResourceSelect -10);   OSType resourceType, short resourceId, Handle *resource  

; 	 Component Resource Extension flags 	
(defconstant $componentDoAutoVersion #x1)
(defconstant $componentWantsUnregister #x2)
(defconstant $componentAutoVersionIncludeFlags #x4)
(defconstant $componentHasMultiplePlatforms #x8)
(defconstant $componentLoadResident #x10)

; 	 Set Default Component flags 	
(defconstant $defaultComponentIdentical 0)
(defconstant $defaultComponentAnyFlags 1)
(defconstant $defaultComponentAnyManufacturer 2)
(defconstant $defaultComponentAnySubType 4)
(defconstant $defaultComponentAnyFlagsAnyManufacturer 3)
(defconstant $defaultComponentAnyFlagsAnyManufacturerAnySubType 7)

; 	 RegisterComponentResource flags 	
(defconstant $registerComponentGlobal 1)
(defconstant $registerComponentNoDuplicates 2)
(defconstant $registerComponentAfterExisting 4)
(defconstant $registerComponentAliasesOnly 8)

(def-mactype :componentdescriptionptr (find-mactype '(:pointer :componentdescription)))
(defrecord ComponentDescription 
   (componentType :ostype)                      ;   A unique 4-byte code indentifying the command set  
   (componentSubType :ostype)                   ;   Particular flavor of this instance  
   (componentManufacturer :ostype)              ;   Vendor indentification  
   (componentFlags :unsigned-long)              ;   8 each for Component,Type,SubType,Manuf/revision  
   (componentFlagsMask :unsigned-long)          ;   Mask for specifying which flags to consider in search, zero during registration  
   )

(def-mactype :resourcespecptr (find-mactype '(:pointer :resourcespec)))
(defrecord ResourceSpec 
   (resType :ostype)                            ;   4-byte code     
   (resID :signed-integer)                      ;            
   )

(def-mactype :componentresourceptr (find-mactype '(:pointer :componentresource)))
(defrecord (ComponentResource :handle) 
   (cd :componentdescription)                   ;   Registration parameters  
   (component :resourcespec)                    ;   resource where Component code is found  
   (componentName :resourcespec)                ;   name string resource  
   (componentInfo :resourcespec)                ;   info string resource  
   (componentIcon :resourcespec)                ;   icon resource  
   )

(def-mactype :componentresourcehandle (find-mactype '(:handle :componentresource)))
(def-mactype :componentplatforminfoptr (find-mactype '(:pointer :componentplatforminfo)))
(defrecord ComponentPlatformInfo 
   ;;Changing field componentflags from signed-long to unsigned-long to match C header (pretty-sure)
   (componentFlags :unsigned-long)              ;   flags of Component  
   (component :resourcespec)                    ;   resource where Component code is found  
   (platformType :signed-integer)               ;   gestaltSysArchitecture result  
   )

(def-mactype :componentresourceextensionptr (find-mactype '(:pointer :componentresourceextension)))
(defrecord ComponentResourceExtension 
   (componentVersion :signed-long)              ;   version of Component  
   (componentRegisterFlags :signed-long)        ;   flags for registration  
   (componentIconFamily :signed-integer)        ;   resource id of Icon Family  
   )

(def-mactype :componentplatforminfoarrayptr (find-mactype '(:pointer :componentplatforminfoarray)))
(defrecord ComponentPlatformInfoArray 
   (count :signed-long)
   (platformArray (:array :componentplatforminfo 1))
   )

(def-mactype :extcomponentresourceptr (find-mactype '(:pointer :extcomponentresource)))
(defrecord ExtComponentResource 
   (cd :componentdescription)                   ;   registration parameters  
   (component :resourcespec)                    ;   resource where Component code is found  
   (componentName :resourcespec)                ;   name string resource  
   (componentInfo :resourcespec)                ;   info string resource  
   (componentIcon :resourcespec)                ;   icon resource  
   (componentVersion :signed-long)              ;   version of Component  
   (componentRegisterFlags :signed-long)        ;   flags for registration  
   (componentIconFamily :signed-integer)        ;   resource id of Icon Family  
   (count :signed-long)                         ;   elements in platformArray  
   (platformArray (:array :componentplatforminfo 1))
   )

(def-mactype :extcomponentresourcehandle (find-mactype '(:handle :extcomponentresource)))
(def-mactype :componentaliasresourceptr (find-mactype '(:pointer :componentaliasresource)))
(defrecord ComponentAliasResource 
   (cr :componentresource)                      ;   Registration parameters  
   (aliasCD :componentdescription)              ;   component alias description  
   )

; 	  Structure received by Component:        	
(def-mactype :componentparametersptr (find-mactype '(:pointer :componentparameters)))
(defrecord ComponentParameters 
   (flags :unsigned-byte)                       ;   call modifiers: sync/async, deferred, immed, etc  
   (paramSize :unsigned-byte)                   ;   size in bytes of actual parameters passed to this call  
   (what :signed-integer)                       ;   routine selector, negative for Component management calls  
   (params (:array :signed-long 1))             ;   actual parameters for the indicated routine  
   )

(def-mactype :componentrecordptr (find-mactype '(:pointer :componentrecord)))
(defrecord ComponentRecord 
   (data (:array :signed-long 1))
   )

(def-mactype :component (find-mactype '(:pointer :componentrecord)))
(def-mactype :componentinstancerecordptr (find-mactype '(:pointer :componentinstancerecord)))
(defrecord ComponentInstanceRecord 
   (data (:array :signed-long 1))
   )

(def-mactype :componentinstance (find-mactype '(:pointer :componentinstancerecord)))
(def-mactype :registeredcomponentrecordptr (find-mactype '(:pointer :registeredcomponentrecord)))
(defrecord RegisteredComponentRecord 
   (data (:array :signed-long 1))
   )

(def-mactype :registeredcomponentinstancerecordptr (find-mactype '(:pointer :registeredcomponentinstancerecord)))
(defrecord RegisteredComponentInstanceRecord 
   (data (:array :signed-long 1))
   )

(def-mactype :componentresult (find-mactype ':signed-long))

(defconstant $platform68k 1)                    ;   platform type (response from gestaltComponentPlatform)  
(defconstant $platformPowerPC 2)                ;   (when gestaltComponentPlatform is not implemented, use  
(defconstant $platformInterpreted 3)            ;   gestaltSysArchitecture)  
(defconstant $platformWin32 4)
(defconstant $platformPowerPCNativeEntryPoint 5)

(defconstant $mpWorkFlagDoWork #x1)
(defconstant $mpWorkFlagDoCompletion #x2)
(defconstant $mpWorkFlagCopyWorkBlock #x4)
(defconstant $mpWorkFlagDontBlock #x8)
(defconstant $mpWorkFlagGetProcessorCount #x10)
(defconstant $mpWorkFlagGetIsRunning #x40)

(defconstant $cmpAliasNoFlags 0)
(defconstant $cmpAliasOnlyThisFile 1)

(def-mactype :componentmpworkfunctionheaderrecordptr (find-mactype '(:pointer :componentmpworkfunctionheaderrecord)))
(defrecord ComponentMPWorkFunctionHeaderRecord 
   (headerSize :unsigned-long)
   (recordSize :unsigned-long)
   (workFlags :unsigned-long)
   (processorCount :unsigned-integer)
   (unused :signed-byte)
   (isRunning :signed-byte)
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ComponentMPWorkFunctionProcPtr = FUNCTION(globalRefCon: UNIV Ptr; header: ComponentMPWorkFunctionHeaderRecordPtr): ComponentResult;

|#
 |#                                             ; $ELSEC
(def-mactype :componentmpworkfunctionprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ComponentRoutineProcPtr = FUNCTION(VAR cp: ComponentParameters; componentStorage: Handle): ComponentResult;

|#
 |#                                             ; $ELSEC
(def-mactype :componentroutineprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	GetMissingComponentResourceProcPtr = FUNCTION(c: Component; resType: OSType; resID: INTEGER; refCon: UNIV Ptr; VAR resource: Handle): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :getmissingcomponentresourceprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :componentmpworkfunctionupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :componentmpworkfunctionupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :componentroutineupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :componentroutineupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :getmissingcomponentresourceupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :getmissingcomponentresourceupp (find-mactype ':pointer))
; $ENDC
; 	
; 	    The parameter list for each ComponentFunction is unique. It is
; 	    therefore up to users to create the appropriate procInfo for their
; 	    own ComponentFunctions where necessary.
; 		
(def-mactype :componentfunctionupp (find-mactype ':pointer))
; 
; 	 *  NewComponentFunctionUPP()
; 	 *  
; 	 *  Discussion:
; 	 *    For use in writing a Carbon compliant Component.  It is used to
; 	 *    create a ComponentFunctionUPP needed to call
; 	 *    CallComponentFunction in the Components dispatch routine.
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;  *  DisposeComponentFunctionUPP()
;  *  
;  *  Discussion:
;  *    For use in writing a Carbon compliant Component.  It is used to
;  *    dispose of a ComponentFunctionUPP created by
;  *    NewComponentFunctionUPP.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NewComponentFunctionUPP" 
      ((userRoutine :pointer) (procInfo :unsigned-long)) 
  :pointer
   () )                                         ; 
;  *  CallComponentUPP
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;                                               ; *******************************************************
; *                                                       *
; *               APPLICATION LEVEL CALLS                 *
; *                                                       *
; *******************************************************; *******************************************************
; * Component Database Add, Delete, and Query Routines
; *******************************************************; 
;  *  RegisterComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  
(deftrap-inline "_DisposeComponentFunctionUPP" 
      ((userUPP :pointer)) 
  nil
   () )
(deftrap "_RegisterComponent" 
      ((cd (:pointer :componentdescription)) (componentEntryPoint :pointer) (global :signed-integer) (componentName :handle) (componentInfo :handle) (componentIcon :handle))
   (:stack (:pointer :componentrecord))
   (:stack-trap #xA82A :d0 1 cd componentEntryPoint global componentName componentInfo componentIcon))

; 
;  *  RegisterComponentResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_RegisterComponentResource" 
      ((cr (:handle :componentresource)) (global :signed-integer))
   (:stack (:pointer :componentrecord))
   (:stack-trap #xA82A :d0 18 cr global))

; 
;  *  UnregisterComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_UnregisterComponent" 
      ((aComponent (:pointer :componentrecord)))
   (:stack :signed-integer)
   (:stack-trap #xA82A :d0 2 aComponent))

; 
;  *  FindNextComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_FindNextComponent" 
      ((aComponent (:pointer :componentrecord)) (looking (:pointer :componentdescription)))
   (:stack (:pointer :componentrecord))
   (:stack-trap #xA82A :d0 4 aComponent looking))

; 
;  *  CountComponents()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_CountComponents" 
      ((looking (:pointer :componentdescription)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 3 looking))

; 
;  *  GetComponentInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_GetComponentInfo" 
      ((aComponent (:pointer :componentrecord)) (cd (:pointer :componentdescription)) (componentName :handle) (componentInfo :handle) (componentIcon :handle))
   (:stack :signed-integer)
   (:stack-trap #xA82A :d0 5 aComponent cd componentName componentInfo componentIcon))

; 
;  *  GetComponentListModSeed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_GetComponentListModSeed" 
      ()
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 6))

; 
;  *  GetComponentTypeModSeed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib via QuickTime 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_GetComponentTypeModSeed" 
      ((componentType :ostype))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 44 componentType))

; *******************************************************
; * Component Instance Allocation and dispatch routines
; *******************************************************
; 
;  *  OpenAComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib via QuickTime 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_OpenAComponent" 
      ((aComponent (:pointer :componentrecord)) (ci (:pointer (:pointer :componentinstancerecord))))
   (:stack :signed-integer)
   (:stack-trap #xA82A :d0 45 aComponent ci))

; 
;  *  OpenComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_OpenComponent" 
      ((aComponent (:pointer :componentrecord)))
   (:stack (:pointer :componentinstancerecord))
   (:stack-trap #xA82A :d0 7 aComponent))

; 
;  *  CloseComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_CloseComponent" 
      ((aComponentInstance (:pointer :componentinstancerecord)))
   (:stack :signed-integer)
   (:stack-trap #xA82A :d0 8 aComponentInstance))

; 
;  *  GetComponentInstanceError()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_GetComponentInstanceError" 
      ((aComponentInstance (:pointer :componentinstancerecord)))
   (:stack :signed-integer)
   (:stack-trap #xA82A :d0 10 aComponentInstance))

; *******************************************************
; * Component aliases
; *******************************************************
; 
;  *  ResolveComponentAlias()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib via QuickTime 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_ResolveComponentAlias" 
      ((aComponent (:pointer :componentrecord)))
   (:stack (:pointer :componentrecord))
   (:stack-trap #xA82A :d0 32 aComponent))

; *******************************************************
; * Component public resources and public string lists
; *******************************************************
;  Note: GetComponentPublicResource returns a Handle, not a resource.  The caller must dispose it with DisposeHandle. 
; 
;  *  GetComponentPublicResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib via QuickTime 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetComponentPublicResource" 
      ((aComponent (:pointer :componentrecord)) (resourceType :ostype) (resourceID :signed-integer) (theResource (:pointer :handle)))
   (:stack :signed-integer)
   (:stack-trap #xA82A :d0 56 aComponent resourceType resourceID theResource))

; 
;  *  GetComponentPublicResourceList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib via QuickTime 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetComponentPublicResourceList" 
      ((resourceType :ostype) (resourceID :signed-integer) (flags :signed-long) (cd (:pointer :componentdescription)) (missingProc :pointer) (refCon :pointer) (atomContainerPtr :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA82A :d0 57 resourceType resourceID flags cd missingProc refCon atomContainerPtr))

; 
;  *  GetComponentPublicIndString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib via QuickTime 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetComponentPublicIndString" 
      ((aComponent (:pointer :componentrecord)) (theString (:pointer (:string 255))) (strListID :signed-integer) (index :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA82A :d0 58 aComponent theString strListID index))

; *******************************************************
; *                                                       *
; *                   CALLS MADE BY COMPONENTS            *
; *                                                       *
; *******************************************************
; *******************************************************
; * Component Management routines
; *******************************************************
; 
;  *  SetComponentInstanceError()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_SetComponentInstanceError" 
      ((aComponentInstance (:pointer :componentinstancerecord)) (theError :signed-integer))
   nil
   (:stack-trap #xA82A :d0 11 aComponentInstance theError))

; 
;  *  GetComponentRefcon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_GetComponentRefcon" 
      ((aComponent (:pointer :componentrecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 16 aComponent))

; 
;  *  SetComponentRefcon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_SetComponentRefcon" 
      ((aComponent (:pointer :componentrecord)) (theRefcon :signed-long))
   nil
   (:stack-trap #xA82A :d0 17 aComponent theRefcon))

; 
;  *  OpenComponentResFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_OpenComponentResFile" 
      ((aComponent (:pointer :componentrecord)))
   (:stack :signed-integer)
   (:stack-trap #xA82A :d0 21 aComponent))

; 
;  *  OpenAComponentResFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib via QuickTime 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_OpenAComponentResFile" 
      ((aComponent (:pointer :componentrecord)) (resRef (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xA82A :d0 47 aComponent resRef))

; 
;  *  CloseComponentResFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_CloseComponentResFile" 
      ((refnum :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA82A :d0 24 refnum))

;  Note: GetComponentResource returns a Handle, not a resource.  The caller must dispose it with DisposeHandle. 
; 
;  *  GetComponentResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib via QuickTime 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_GetComponentResource" 
      ((aComponent (:pointer :componentrecord)) (resType :ostype) (resID :signed-integer) (theResource (:pointer :handle)))
   (:stack :signed-integer)
   (:stack-trap #xA82A :d0 53 aComponent resType resID theResource))

; 
;  *  GetComponentIndString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib via QuickTime 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_GetComponentIndString" 
      ((aComponent (:pointer :componentrecord)) (theString (:pointer (:string 255))) (strListID :signed-integer) (index :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA82A :d0 54 aComponent theString strListID index))

; *******************************************************
; * Component Instance Management routines
; *******************************************************
; 
;  *  GetComponentInstanceStorage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_GetComponentInstanceStorage" 
      ((aComponentInstance (:pointer :componentinstancerecord)))
   (:stack :handle)
   (:stack-trap #xA82A :d0 12 aComponentInstance))

; 
;  *  SetComponentInstanceStorage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_SetComponentInstanceStorage" 
      ((aComponentInstance (:pointer :componentinstancerecord)) (theStorage :handle))
   nil
   (:stack-trap #xA82A :d0 13 aComponentInstance theStorage))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  GetComponentInstanceA5()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_GetComponentInstanceA5" 
      ((aComponentInstance (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 14 aComponentInstance))

; 
;  *  SetComponentInstanceA5()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_SetComponentInstanceA5" 
      ((aComponentInstance (:pointer :componentinstancerecord)) (theA5 :signed-long))
   nil
   (:stack-trap #xA82A :d0 15 aComponentInstance theA5))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  CountComponentInstances()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_CountComponentInstances" 
      ((aComponent (:pointer :componentrecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 19 aComponent))

;  useful helper routines for convenient method dispatching 
; 
;  *  CallComponentFunction()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CallComponentFunction" 
      ((params (:pointer :componentparameters)) (func :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 255 params func))

; 
;  *  CallComponentFunctionWithStorage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_CallComponentFunctionWithStorage" 
      ((storage :handle) (params (:pointer :componentparameters)) (func :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 255 storage params func))

; $IFC TARGET_CPU_PPC AND TARGET_OS_MAC 
; 
;  *  CallComponentFunctionWithStorageProcInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib via QuickTime 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
#|                                              ; $ELSEC
(deftrap-inline "_CallComponentFunctionWithStorageProcInfo" 
      ((storage :handle) (params (:pointer :componentparameters)) (func :pointer) (funcProcInfo :unsigned-long)) 
  :signed-long
   () )
 |#                                             ; $ENDC

; 
;  *  DelegateComponentCall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_DelegateComponentCall" 
      ((originalParams (:pointer :componentparameters)) (ci (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 36 originalParams ci))

; 
;  *  SetDefaultComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_SetDefaultComponent" 
      ((aComponent (:pointer :componentrecord)) (flags :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA82A :d0 30 aComponent flags))

; 
;  *  OpenDefaultComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_OpenDefaultComponent" 
      ((componentType :ostype) (componentSubType :ostype))
   (:stack (:pointer :componentinstancerecord))
   (:stack-trap #xA82A :d0 33 componentType componentSubType))

; 
;  *  OpenADefaultComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib via QuickTime 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_OpenADefaultComponent" 
      ((componentType :ostype) (componentSubType :ostype) (ci (:pointer (:pointer :componentinstancerecord))))
   (:stack :signed-integer)
   (:stack-trap #xA82A :d0 46 componentType componentSubType ci))

; 
;  *  CaptureComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_CaptureComponent" 
      ((capturedComponent (:pointer :componentrecord)) (capturingComponent (:pointer :componentrecord)))
   (:stack (:pointer :componentrecord))
   (:stack-trap #xA82A :d0 28 capturedComponent capturingComponent))

; 
;  *  UncaptureComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_UncaptureComponent" 
      ((aComponent (:pointer :componentrecord)))
   (:stack :signed-integer)
   (:stack-trap #xA82A :d0 29 aComponent))

; 
;  *  RegisterComponentResourceFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_RegisterComponentResourceFile" 
      ((resRefNum :signed-integer) (global :signed-integer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 20 resRefNum global))

; 
;  *  GetComponentIconSuite()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_GetComponentIconSuite" 
      ((aComponent (:pointer :componentrecord)) (iconSuite (:pointer :handle)))
   (:stack :signed-integer)
   (:stack-trap #xA82A :d0 41 aComponent iconSuite))

; *******************************************************
; *                                                       *
; *           Direct calls to the Components              *
; *                                                       *
; *******************************************************
;   Old style names 

; 
;  *  ComponentFunctionImplemented()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_ComponentFunctionImplemented" 
      ((ci (:pointer :componentinstancerecord)) (ftnNumber :signed-integer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci ftnNumber ((+ (ash 2 16) 65533) :signed-longint)))

; 
;  *  GetComponentVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_GetComponentVersion" 
      ((ci (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci ((+ (ash 0 16) 65532) :signed-longint)))

; 
;  *  ComponentSetTarget()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_ComponentSetTarget" 
      ((ci (:pointer :componentinstancerecord)) (target (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci target ((+ (ash 4 16) 65530) :signed-longint)))

;   New style names 

; 
;  *  CallComponentOpen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib via QuickTime 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_CallComponentOpen" 
      ((ci (:pointer :componentinstancerecord)) (self (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci self ((+ (ash 4 16) 65535) :signed-longint)))

; 
;  *  CallComponentClose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib via QuickTime 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_CallComponentClose" 
      ((ci (:pointer :componentinstancerecord)) (self (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci self ((+ (ash 4 16) 65534) :signed-longint)))

; 
;  *  CallComponentCanDo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib via QuickTime 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_CallComponentCanDo" 
      ((ci (:pointer :componentinstancerecord)) (ftnNumber :signed-integer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci ftnNumber ((+ (ash 2 16) 65533) :signed-longint)))

; 
;  *  CallComponentVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib via QuickTime 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_CallComponentVersion" 
      ((ci (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci ((+ (ash 0 16) 65532) :signed-longint)))

; 
;  *  CallComponentRegister()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib via QuickTime 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_CallComponentRegister" 
      ((ci (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci ((+ (ash 0 16) 65531) :signed-longint)))

; 
;  *  CallComponentTarget()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib via QuickTime 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_CallComponentTarget" 
      ((ci (:pointer :componentinstancerecord)) (target (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci target ((+ (ash 4 16) 65530) :signed-longint)))

; 
;  *  CallComponentUnregister()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib via QuickTime 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_CallComponentUnregister" 
      ((ci (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci ((+ (ash 0 16) 65529) :signed-longint)))

; 
;  *  CallComponentGetMPWorkFunction()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib via QuickTime 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_CallComponentGetMPWorkFunction" 
      ((ci (:pointer :componentinstancerecord)) (workFunction (:pointer :pointer)) (refCon (:pointer :pointer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci workFunction refCon ((+ (ash 8 16) 65528) :signed-longint)))

; 
;  *  CallComponentGetPublicResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib via QuickTime 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CallComponentGetPublicResource" 
      ((ci (:pointer :componentinstancerecord)) (resourceType :ostype) (resourceID :signed-integer) (resource (:pointer :handle)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci resourceType resourceID resource ((+ (ash 10 16) 65526) :signed-longint)))

#|                                              ; $IFC NOT TARGET_OS_MAC 
;  
;         CallComponent is used by ComponentGlue routines to manually call a component function.
;      
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  CallComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap-inline "_CallComponent" 
      ((ci (:pointer :componentinstancerecord)) (cp (:pointer :componentparameters))) 
  :signed-long
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC

; 
;     CallComponentDispatch is a CarbonLib routine that replaces CallComponent inline glue
;     to call a component function.
;  
; 
;  *  CallComponentDispatch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  UPP call backs 
(deftrap-inline "_CallComponentDispatch" 
      ((cp (:pointer :componentparameters))) 
  :signed-long
   () )
(defconstant $uppComponentMPWorkFunctionProcInfo #x3F0)
(defconstant $uppComponentRoutineProcInfo #x3F0)
(defconstant $uppGetMissingComponentResourceProcInfo #xFBE0)
; 
; 	 *  NewComponentMPWorkFunctionUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewComponentMPWorkFunctionProc 
(deftrap "_NewComponentMPWorkFunctionUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewComponentRoutineUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewComponentRoutineProc 
(deftrap "_NewComponentRoutineUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewGetMissingComponentResourceUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewGetMissingComponentResourceProc 
(deftrap "_NewGetMissingComponentResourceUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeComponentMPWorkFunctionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeComponentMPWorkFunctionUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeComponentRoutineUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeComponentRoutineUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeGetMissingComponentResourceUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeGetMissingComponentResourceUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeComponentMPWorkFunctionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallComponentMPWorkFunctionProc 
(deftrap-inline "_InvokeComponentMPWorkFunctionUPP" 
      ((globalRefCon :pointer) (header (:pointer :componentmpworkfunctionheaderrecord)) (userRoutine :pointer)) 
  :signed-long
   (#x205F #x4E90) )

; 
;  *  InvokeComponentRoutineUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallComponentRoutineProc 
(deftrap-inline "_InvokeComponentRoutineUPP" 
      ((cp (:pointer :componentparameters)) (componentStorage :handle) (userRoutine :pointer)) 
  :signed-long
   (#x205F #x4E90) )

; 
;  *  InvokeGetMissingComponentResourceUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallGetMissingComponentResourceProc 
(deftrap-inline "_InvokeGetMissingComponentResourceUPP" 
      ((c (:pointer :componentrecord)) (resType :ostype) (resID :signed-integer) (refCon :pointer) (resource (:pointer :handle)) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

;  ProcInfos 

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := ComponentsIncludes

; $ENDC                                         ; __COMPONENTS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Components)