(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Connections.p"
; at Wednesday May 1,2002 2:41:16 pm.
; 
;      File:       Connections.p
;  
;      Contains:   Communications Toolbox Connection Manager Interfaces.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1988-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __CONNECTIONS__
; $SETC __CONNECTIONS__ := 1

; $I+
; $SETC ConnectionsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __DIALOGS__
|#

(require-interface 'Dialogs)
#|                                              ; $I Dialogs.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; $IFC CALL_NOT_IN_CARBON 

(defconstant $curCMVersion 2)                   ;   current Connection Manager version 

(defconstant $curConnEnvRecVers 0)              ;      current Connection Manager Environment Record version 

;   CMErr  
(defconstant $cmGenericError -1)
(defconstant $cmNoErr 0)
(defconstant $cmRejected 1)
(defconstant $cmFailed 2)
(defconstant $cmTimeOut 3)
(defconstant $cmNotOpen 4)
(defconstant $cmNotClosed 5)
(defconstant $cmNoRequestPending 6)
(defconstant $cmNotSupported 7)
(defconstant $cmNoTools 8)
(defconstant $cmUserCancel 9)
(defconstant $cmUnknownError 11)

(def-mactype :cmerr (find-mactype ':signed-integer))

(defconstant $cmData #x1)
(defconstant $cmCntl #x2)
(defconstant $cmAttn #x4)
(defconstant $cmDataNoTimeout #x10)
(defconstant $cmCntlNoTimeout #x20)
(defconstant $cmAttnNoTimeout #x40)
(defconstant $cmDataClean #x100)
(defconstant $cmCntlClean #x200)
(defconstant $cmAttnClean #x400)                ;         Only for CMRecFlags (not CMChannel) in the rest of this enum   
(defconstant $cmNoMenus #x10000)
(defconstant $cmQuiet #x20000)
(defconstant $cmConfigChanged #x40000)

; 	 CMRecFlags and CMChannel     	
; 	      Low word of CMRecFlags is same as CMChannel 	

(def-mactype :cmrecflags (find-mactype ':signed-long))
(def-mactype :cmchannel (find-mactype ':signed-integer))

(defconstant $cmStatusOpening #x1)
(defconstant $cmStatusOpen #x2)
(defconstant $cmStatusClosing #x4)
(defconstant $cmStatusDataAvail #x8)
(defconstant $cmStatusCntlAvail #x10)
(defconstant $cmStatusAttnAvail #x20)
(defconstant $cmStatusDRPend #x40)              ;   data read pending   
(defconstant $cmStatusDWPend #x80)              ;   data write pending  
(defconstant $cmStatusCRPend #x100)             ;   cntl read pending   
(defconstant $cmStatusCWPend #x200)             ;   cntl write pending  
(defconstant $cmStatusARPend #x400)             ;   attn read pending   
(defconstant $cmStatusAWPend #x800)             ;   attn write pending  
(defconstant $cmStatusBreakPend #x1000)
(defconstant $cmStatusListenPend #x2000)
(defconstant $cmStatusIncomingCallPresent #x4000)
(defconstant $cmStatusReserved0 #x8000)

(def-mactype :cmstatflags (find-mactype ':unsigned-long))

(defconstant $cmDataIn 0)
(defconstant $cmDataOut 1)
(defconstant $cmCntlIn 2)
(defconstant $cmCntlOut 3)
(defconstant $cmAttnIn 4)
(defconstant $cmAttnOut 5)
(defconstant $cmRsrvIn 6)
(defconstant $cmRsrvOut 7)

(def-mactype :cmbuffields (find-mactype ':unsigned-integer))
(defrecord CMBuffers (array (:array :pointer 8)))
(defrecord CMBufferSizes (array (:array :signed-long 8)))
(def-mactype :constcmbuffersizesparam (find-mactype ':pointer))

(defconstant $cmSearchSevenBit #x1)

(def-mactype :cmsearchflags (find-mactype ':unsigned-integer))

(defconstant $cmFlagsEOM #x1)

(def-mactype :cmflags (find-mactype ':unsigned-integer))
(def-mactype :connenvironrecptr (find-mactype '(:pointer :connenvironrec)))
(defrecord ConnEnvironRec 
   (version :signed-integer)
   (baudRate :signed-long)
   (dataBits :signed-integer)
   (channels :signed-integer)
   (swFlowControl :boolean)
   (hwFlowControl :boolean)
   (flags :unsigned-integer)
   )

(def-mactype :connrecordptr (find-mactype '(:pointer :connrecord)))
(def-mactype :connptr (find-mactype '(:pointer :connrecord)))
(def-mactype :connhandle (find-mactype '(:handle :connrecord)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ConnectionToolDefProcPtr = FUNCTION(hConn: ConnHandle; msg: INTEGER; p1: LONGINT; p2: LONGINT; p3: LONGINT): LONGINT;

|#
 |#                                             ; $ELSEC
(def-mactype :connectiontooldefprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ConnectionSearchCallBackProcPtr = PROCEDURE(hConn: ConnHandle; matchPtr: Ptr; refNum: LONGINT);

|#
 |#                                             ; $ELSEC
(def-mactype :connectionsearchcallbackprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ConnectionCompletionProcPtr = PROCEDURE(hConn: ConnHandle);

|#
 |#                                             ; $ELSEC
(def-mactype :connectioncompletionprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ConnectionChooseIdleProcPtr = PROCEDURE;

|#
 |#                                             ; $ELSEC
(def-mactype :connectionchooseidleprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :connectiontooldefupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :connectiontooldefupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :connectionsearchcallbackupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :connectionsearchcallbackupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :connectioncompletionupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :connectioncompletionupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :connectionchooseidleupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :connectionchooseidleupp (find-mactype ':pointer))
; $ENDC
(defrecord ConnRecord 
   (procID :signed-integer)
   (flags :signed-long)
   (errCode :signed-integer)
   (refCon :signed-long)
   (userData :signed-long)
   (defProc :pointer)
   (config :pointer)
   (oldConfig :pointer)
   (asyncEOM :signed-long)
   (reserved1 :signed-long)
   (reserved2 :signed-long)
   (cmPrivate :pointer)
   (bufferArray :cmbuffers)
   (bufSizes :cmbuffersizes)
   (mluField :signed-long)
   (asyncCount :cmbuffersizes)
   )

;   CMIOPB constants and structure  
(defconstant $cmIOPBQType 10)
(defconstant $cmIOPBversion 0)

(def-mactype :cmiopbptr (find-mactype '(:pointer :cmiopb)))
(defrecord CMIOPB 
   (qLink (:pointer :qelem))
   (qType :signed-integer)                      ;   cmIOPBQType  
   (hConn (:handle :connrecord))
   (theBuffer :pointer)
   (count :signed-long)
   (flags :unsigned-integer)
   (userCompletion :pointer)
   (timeout :signed-long)
   (errCode :signed-integer)
   (channel :signed-integer)
   (asyncEOM :signed-long)
   (reserved1 :signed-long)
   (reserved2 :signed-integer)
   (version :signed-integer)                    ;   cmIOPBversion  
   (refCon :signed-long)                        ;   for application  
   (toolData1 :signed-long)                     ;   for tool  
   (toolData2 :signed-long)                     ;   for tool  
   )

(defconstant $uppConnectionToolDefProcInfo #xFEF0)
(defconstant $uppConnectionSearchCallBackProcInfo #xFC0)
(defconstant $uppConnectionCompletionProcInfo #xC0)
(defconstant $uppConnectionChooseIdleProcInfo #x0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewConnectionToolDefUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewConnectionToolDefProc 
(deftrap "_NewConnectionToolDefUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewConnectionSearchCallBackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewConnectionSearchCallBackProc 
(deftrap "_NewConnectionSearchCallBackUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewConnectionCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewConnectionCompletionProc 
(deftrap "_NewConnectionCompletionUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewConnectionChooseIdleUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewConnectionChooseIdleProc 
(deftrap "_NewConnectionChooseIdleUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeConnectionToolDefUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeConnectionToolDefUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeConnectionSearchCallBackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeConnectionSearchCallBackUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeConnectionCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeConnectionCompletionUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeConnectionChooseIdleUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeConnectionChooseIdleUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeConnectionToolDefUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallConnectionToolDefProc 
(deftrap-inline "_InvokeConnectionToolDefUPP" 
      ((hConn (:handle :connrecord)) (msg :signed-integer) (p1 :signed-long) (p2 :signed-long) (p3 :signed-long) (userRoutine :pointer)) 
  :signed-long
   (#x205F #x4E90) )

; 
;  *  InvokeConnectionSearchCallBackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallConnectionSearchCallBackProc 
(deftrap-inline "_InvokeConnectionSearchCallBackUPP" 
      ((hConn (:handle :connrecord)) (matchPtr :pointer) (refNum :signed-long) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeConnectionCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallConnectionCompletionProc 
(deftrap-inline "_InvokeConnectionCompletionUPP" 
      ((hConn (:handle :connrecord)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeConnectionChooseIdleUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallConnectionChooseIdleProc 
(deftrap "_InvokeConnectionChooseIdleUPP" 
      ((userRoutine :pointer))
   nil
   (:register-trap #x4E90 :a0 userRoutine))

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  InitCM()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  CMGetVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InitCM" 
      () 
  :signed-integer
   () )                                         ; 
;  *  CMGetCMVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMGetVersion" 
      ((hConn (:handle :connrecord))) 
  :handle
   () )
(deftrap-inline "_CMGetCMVersion" 
      () 
  :signed-integer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  CMNew()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CMNew" 
      ((procID :signed-integer) (flags :signed-long) (desiredSizes (:pointer :cmbuffersizes)) (refCon :signed-long) (userData :signed-long)) 
  (:handle :connrecord)
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  CMDispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  CMListen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMDispose" 
      ((hConn (:handle :connrecord))) 
  nil
   () )                                         ; 
;  *  CMAccept()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMListen" 
      ((hConn (:handle :connrecord)) (async :boolean) (completor :pointer) (timeout :signed-long)) 
  :signed-integer
   () )                                         ; 
;  *  CMOpen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMAccept" 
      ((hConn (:handle :connrecord)) (accept :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  CMClose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMOpen" 
      ((hConn (:handle :connrecord)) (async :boolean) (completor :pointer) (timeout :signed-long)) 
  :signed-integer
   () )                                         ; 
;  *  CMAbort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMClose" 
      ((hConn (:handle :connrecord)) (async :boolean) (completor :pointer) (timeout :signed-long) (now :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  CMStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMAbort" 
      ((hConn (:handle :connrecord))) 
  :signed-integer
   () )                                         ; 
;  *  CMIdle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMStatus" 
      ((hConn (:handle :connrecord)) (sizes (:pointer :cmbuffersizes)) (flags (:pointer :unsigned-long))) 
  :signed-integer
   () )                                         ; 
;  *  CMReset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMIdle" 
      ((hConn (:handle :connrecord))) 
  nil
   () )                                         ; 
;  *  CMBreak()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMReset" 
      ((hConn (:handle :connrecord))) 
  nil
   () )                                         ; 
;  *  CMRead()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMBreak" 
      ((hConn (:handle :connrecord)) (duration :signed-long) (async :boolean) (completor :pointer)) 
  nil
   () )                                         ; 
;  *  CMWrite()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMRead" 
      ((hConn (:handle :connrecord)) (theBuffer :pointer) (toRead (:pointer :signed-long)) (theChannel :signed-integer) (async :boolean) (completor :pointer) (timeout :signed-long) (flags (:pointer :unsigned-integer))) 
  :signed-integer
   () )                                         ; 
;  *  CMIOKill()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMWrite" 
      ((hConn (:handle :connrecord)) (theBuffer :pointer) (toWrite (:pointer :signed-long)) (theChannel :signed-integer) (async :boolean) (completor :pointer) (timeout :signed-long) (flags :unsigned-integer)) 
  :signed-integer
   () )                                         ; 
;  *  CMActivate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMIOKill" 
      ((hConn (:handle :connrecord)) (which :signed-integer)) 
  :signed-integer
   () )                                         ; 
;  *  CMResume()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMActivate" 
      ((hConn (:handle :connrecord)) (activate :boolean)) 
  nil
   () )                                         ; 
;  *  CMMenu()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMResume" 
      ((hConn (:handle :connrecord)) (resume :boolean)) 
  nil
   () )                                         ; 
;  *  CMValidate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMMenu" 
      ((hConn (:handle :connrecord)) (menuID :signed-integer) (item :signed-integer)) 
  :boolean
   () )                                         ; 
;  *  CMDefault()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMValidate" 
      ((hConn (:handle :connrecord))) 
  :boolean
   () )                                         ; 
;  *  CMSetupPreflight()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMDefault" 
      ((theConfig (:pointer :pointer)) (procID :signed-integer) (allocate :boolean)) 
  nil
   () )                                         ; 
;  *  CMSetupFilter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMSetupPreflight" 
      ((procID :signed-integer) (magicCookie (:pointer :signed-long))) 
  :handle
   () )                                         ; 
;  *  CMSetupSetup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMSetupFilter" 
      ((procID :signed-integer) (theConfig :pointer) (count :signed-integer) (theDialog (:pointer :grafport)) (theEvent (:pointer :eventrecord)) (theItem (:pointer :signed-integer)) (magicCookie (:pointer :signed-long))) 
  :boolean
   () )                                         ; 
;  *  CMSetupItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMSetupSetup" 
      ((procID :signed-integer) (theConfig :pointer) (count :signed-integer) (theDialog (:pointer :grafport)) (magicCookie (:pointer :signed-long))) 
  nil
   () )                                         ; 
;  *  CMSetupXCleanup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMSetupItem" 
      ((procID :signed-integer) (theConfig :pointer) (count :signed-integer) (theDialog (:pointer :grafport)) (theItem (:pointer :signed-integer)) (magicCookie (:pointer :signed-long))) 
  nil
   () )                                         ; 
;  *  CMSetupPostflight()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMSetupXCleanup" 
      ((procID :signed-integer) (theConfig :pointer) (count :signed-integer) (theDialog (:pointer :grafport)) (OKed :boolean) (magicCookie (:pointer :signed-long))) 
  nil
   () )                                         ; 
;  *  CMGetConfig()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMSetupPostflight" 
      ((procID :signed-integer)) 
  nil
   () )                                         ; 
;  *  CMSetConfig()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMGetConfig" 
      ((hConn (:handle :connrecord))) 
  :pointer
   () )                                         ; 
;  *  CMIntlToEnglish()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMSetConfig" 
      ((hConn (:handle :connrecord)) (thePtr :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  CMEnglishToIntl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMIntlToEnglish" 
      ((hConn (:handle :connrecord)) (inputPtr :pointer) (outputPtr (:pointer :pointer)) (language :signed-integer)) 
  :signed-integer
   () )                                         ; 
;  *  CMAddSearch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMEnglishToIntl" 
      ((hConn (:handle :connrecord)) (inputPtr :pointer) (outputPtr (:pointer :pointer)) (language :signed-integer)) 
  :signed-integer
   () )                                         ; 
;  *  CMRemoveSearch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMAddSearch" 
      ((hConn (:handle :connrecord)) (theString (:string 255)) (flags :unsigned-integer) (callBack :pointer)) 
  :signed-long
   () )                                         ; 
;  *  CMClearSearch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMRemoveSearch" 
      ((hConn (:handle :connrecord)) (refnum :signed-long)) 
  nil
   () )                                         ; 
;  *  CMGetConnEnvirons()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMClearSearch" 
      ((hConn (:handle :connrecord))) 
  nil
   () )                                         ; 
;  *  CMChoose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMGetConnEnvirons" 
      ((hConn (:handle :connrecord)) (theEnvirons (:pointer :connenvironrec))) 
  :signed-integer
   () )                                         ; 
;  *  CMEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMChoose" 
      ((hConn (:pointer (:handle :connrecord))) (where :point) (idle :pointer)) 
  :signed-integer
   () )                                         ; CONST; 
;  *  CMGetToolName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMEvent" 
      ((hConn (:handle :connrecord)) (theEvent (:pointer :eventrecord))) 
  nil
   () )                                         ; 
;  *  CMGetProcID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMGetToolName" 
      ((procID :signed-integer) (name (:pointer (:string 255)))) 
  nil
   () )                                         ; 
;  *  CMSetRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMGetProcID" 
      ((name (:string 255))) 
  :signed-integer
   () )                                         ; 
;  *  CMGetRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMSetRefCon" 
      ((hConn (:handle :connrecord)) (refCon :signed-long)) 
  nil
   () )                                         ; 
;  *  CMGetUserData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMGetRefCon" 
      ((hConn (:handle :connrecord))) 
  :signed-long
   () )                                         ; 
;  *  CMSetUserData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMGetUserData" 
      ((hConn (:handle :connrecord))) 
  :signed-long
   () )                                         ; 
;  *  CMGetErrorString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMSetUserData" 
      ((hConn (:handle :connrecord)) (userData :signed-long)) 
  nil
   () )                                         ; 
;  *  CMNewIOPB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMGetErrorString" 
      ((hConn (:handle :connrecord)) (id :signed-integer) (errMsg (:pointer (:string 255)))) 
  nil
   () )                                         ; 
;  *  CMDisposeIOPB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMNewIOPB" 
      ((hConn (:handle :connrecord)) (theIOPB (:pointer (:pointer :cmiopb)))) 
  :signed-integer
   () )                                         ; 
;  *  CMPBRead()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMDisposeIOPB" 
      ((hConn (:handle :connrecord)) (theIOPB (:pointer :cmiopb))) 
  :signed-integer
   () )                                         ; 
;  *  CMPBWrite()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMPBRead" 
      ((hConn (:handle :connrecord)) (theIOPB (:pointer :cmiopb)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  CMPBIOKill()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CMPBWrite" 
      ((hConn (:handle :connrecord)) (theIOPB (:pointer :cmiopb)) (async :boolean)) 
  :signed-integer
   () )
(deftrap-inline "_CMPBIOKill" 
      ((hConn (:handle :connrecord)) (theIOPB (:pointer :cmiopb))) 
  :signed-integer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := ConnectionsIncludes

; $ENDC                                         ; __CONNECTIONS__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'Connections)