(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Dictionary.p"
; at Wednesday May 1,2002 2:40:47 pm.
; 
;      File:       Dictionary.p
;  
;      Contains:   Dictionary Manager Interfaces
;  
;      Version:    Technology: System 7
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1992-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __DICTIONARY__
; $SETC __DICTIONARY__ := 1

; $I+
; $SETC DictionaryIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __AEREGISTRY__
|#

(require-interface 'AERegistry)
#|                                              ; $I AERegistry.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CODEFRAGMENTS__
|#

(require-interface 'CodeFragments)
#|                                              ; $I CodeFragments.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

; 
; =============================================================================================
;  Modern Dictionary Manager
; =============================================================================================
; 
; 
;     Dictionary information
; 

(defconstant $kDictionaryFileType :|dict|)
(defconstant $kDCMDictionaryHeaderSignature :|dict|)
(defconstant $kDCMDictionaryHeaderVersion 2)

(defconstant $kDCMAnyFieldTag :|****|)
(defconstant $kDCMAnyFieldType :|****|)

; 	
; 	    Contents of a Field Info Record (an AERecord)
; 		
(defconstant $keyDCMFieldTag :|ftag|)           ;   typeEnumeration  
(defconstant $keyDCMFieldType :|ftyp|)          ;   typeEnumeration  
(defconstant $keyDCMMaxRecordSize :|mrsz|)      ;   typeMagnitude  
(defconstant $keyDCMFieldAttributes :|fatr|)
(defconstant $keyDCMFieldDefaultData :|fdef|)
(defconstant $keyDCMFieldName :|fnam|)          ;   typeChar  
(defconstant $keyDCMFieldFindMethods :|ffnd|)   ;   typeAEList of typeDCMFindMethod  

; 	
; 	    Special types for fields of a Field Info Record
; 		
(defconstant $typeDCMFieldAttributes :|fatr|)
(defconstant $typeDCMFindMethod :|fmth|)

; 	
; 	    Field attributes
; 		
(defconstant $kDCMIndexedFieldMask #x1)
(defconstant $kDCMRequiredFieldMask #x2)
(defconstant $kDCMIdentifyFieldMask #x4)
(defconstant $kDCMFixedSizeFieldMask #x8)
(defconstant $kDCMHiddenFieldMask #x80000000)

(def-mactype :dcmfieldattributes (find-mactype ':unsigned-long))
; 	
; 	    Standard dictionary properties
; 		

(defconstant $pDCMAccessMethod :|amtd|)         ;   data type: typeChar ReadOnly  
(defconstant $pDCMPermission :|perm|)           ;   data type: typeUInt16  
(defconstant $pDCMListing :|list|)              ;   data type: typeUInt16  
(defconstant $pDCMMaintenance :|mtnc|)          ;   data type: typeUInt16  
(defconstant $pDCMLocale :|locl|)               ;   data type: typeUInt32.  Optional; default = kLocaleIdentifierWildCard  
(defconstant $pDCMClass :|pcls|)                ;   data type: typeUInt16  
(defconstant $pDCMCopyright :|info|)            ;   data type: typeChar  

; 	
; 	    pDCMPermission property constants
; 		
(defconstant $kDCMReadOnlyDictionary 0)
(defconstant $kDCMReadWriteDictionary 1)

; 	
; 	    pDCMListing property constants
; 		
(defconstant $kDCMAllowListing 0)
(defconstant $kDCMProhibitListing 1)

; 	
; 	    pDCMClass property constants
; 		
(defconstant $kDCMUserDictionaryClass 0)
(defconstant $kDCMSpecificDictionaryClass 1)
(defconstant $kDCMBasicDictionaryClass 2)

; 	
; 	    Standard search method
; 		
(defconstant $kDCMFindMethodExactMatch :|=   |)
(defconstant $kDCMFindMethodBeginningMatch :|bgwt|)
(defconstant $kDCMFindMethodContainsMatch :|cont|)
(defconstant $kDCMFindMethodEndingMatch :|ends|)
(defconstant $kDCMFindMethodForwardTrie :|ftri|);   used for morphological analysis 
(defconstant $kDCMFindMethodBackwardTrie :|btri|);   used for morphological analysis 

(def-mactype :dcmfindmethod (find-mactype ':ostype))
; 	
; 	    AccessMethod features
; 		

(defconstant $kDCMCanUseFileDictionaryMask #x1)
(defconstant $kDCMCanUseMemoryDictionaryMask #x2)
(defconstant $kDCMCanStreamDictionaryMask #x4)
(defconstant $kDCMCanHaveMultipleIndexMask #x8)
(defconstant $kDCMCanModifyDictionaryMask #x10)
(defconstant $kDCMCanCreateDictionaryMask #x20)
(defconstant $kDCMCanAddDictionaryFieldMask #x40)
(defconstant $kDCMCanUseTransactionMask #x80)

(def-mactype :dcmaccessmethodfeature (find-mactype ':unsigned-long))
(def-mactype :dcmuniqueid (find-mactype ':unsigned-long))
(def-mactype :dcmobjectid (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :dcmobjectidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:DCMObjectID parameter can be nil, it is changed to xx: DCMObjectIDPtr 
(def-mactype :dcmaccessmethodid (find-mactype ':pointer))
(def-mactype :dcmdictionaryid (find-mactype ':pointer))
(def-mactype :dcmobjectref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :dcmobjectrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:DCMObjectRef parameter can be nil, it is changed to xx: DCMObjectRefPtr 
(def-mactype :dcmdictionaryref (find-mactype ':pointer))
(def-mactype :dcmdictionarystreamref (find-mactype ':pointer))
(def-mactype :dcmobjectiterator (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :dcmobjectiteratorptr (find-mactype '(:pointer :pointer)));  when a VAR xx:DCMObjectIterator parameter can be nil, it is changed to xx: DCMObjectIteratorPtr 
(def-mactype :dcmaccessmethoditerator (find-mactype ':pointer))
(def-mactype :dcmdictionaryiterator (find-mactype ':pointer))
(def-mactype :dcmfoundrecorditerator (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :dcmfoundrecorditeratorptr (find-mactype '(:pointer :pointer)));  when a VAR xx:DCMFoundRecordIterator parameter can be nil, it is changed to xx: DCMFoundRecordIteratorPtr 
; 	
; 	    Field specification declarations
; 		
(def-mactype :dcmfieldtag (find-mactype ':ostype))
(def-mactype :dcmfieldtype (find-mactype ':ostype))
; 	
; 	    Dictionary header information
; 		
(def-mactype :dcmdictionaryheaderptr (find-mactype '(:pointer :dcmdictionaryheader)))
(defrecord DCMDictionaryHeader 
   (headerSignature :ostype)
   (headerVersion :unsigned-long)
   (headerSize :unsigned-long)
   (accessMethod (:string 63))
   )

; 	
; 	    Callback routines
; 		
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DCMProgressFilterProcPtr = FUNCTION(determinateProcess: BOOLEAN; percentageComplete: UInt16; callbackUD: UInt32): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :dcmprogressfilterprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :dcmprogressfilterupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :dcmprogressfilterupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppDCMProgressFilterProcInfo #xE50)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewDCMProgressFilterUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewDCMProgressFilterProc 
(deftrap "_NewDCMProgressFilterUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeDCMProgressFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeDCMProgressFilterUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeDCMProgressFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallDCMProgressFilterProc 
(deftrap-inline "_InvokeDCMProgressFilterUPP" 
      ((determinateProcess :boolean) (percentageComplete :unsigned-integer) (callbackUD :unsigned-long) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;     Library version
; 
; 
;  *  DCMLibraryVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;     Create/delete dictionary
;                                               ; 
;  *  DCMNewDictionary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMLibraryVersion" 
      () 
  :unsigned-long
   () )                                         ; CONST; CONST; 
;  *  DCMDeriveNewDictionary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMNewDictionary" 
      ((accessMethodID :pointer) (newDictionaryFile (:pointer :fsspec)) (scriptTag :signed-integer) (listOfFieldInfoRecords (:pointer :aedesc)) (invisible :boolean) (recordCapacity :unsigned-long) (newDictionary (:pointer :pointer))) 
  :osstatus
   () )                                         ; CONST; 
;  *  DCMDeleteDictionary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMDeriveNewDictionary" 
      ((srcDictionary :pointer) (newDictionaryFile (:pointer :fsspec)) (scriptTag :signed-integer) (invisible :boolean) (recordCapacity :unsigned-long) (newDictionary (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;     Register dictionary
;                                               ; 
;  *  DCMRegisterDictionaryFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMDeleteDictionary" 
      ((dictionaryID :pointer)) 
  :osstatus
   () )                                         ; CONST; 
;  *  DCMUnregisterDictionary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMRegisterDictionaryFile" 
      ((dictionaryFile (:pointer :fsspec)) (dictionaryID (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;     Open dictionary
;                                               ; 
;  *  DCMOpenDictionary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMUnregisterDictionary" 
      ((dictionaryID :pointer)) 
  :osstatus
   () )                                         ; 
;  *  DCMCloseDictionary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMOpenDictionary" 
      ((dictionaryID :pointer) (protectKeySize :unsigned-long) (protectKey :pointer) (dictionaryRef (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;     Change access privilege
;                                               ; 
;  *  DCMGetDictionaryWriteAccess()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMCloseDictionary" 
      ((dictionaryRef :pointer)) 
  :osstatus
   () )                                         ; 
;  *  DCMReleaseDictionaryWriteAccess()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMGetDictionaryWriteAccess" 
      ((dictionaryRef :pointer) (timeOutDuration :signed-long)) 
  :osstatus
   () )                                         ; 
;     Find records
;                                               ; 
;  *  DCMFindRecords()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMReleaseDictionaryWriteAccess" 
      ((dictionaryRef :pointer) (commitTransaction :boolean)) 
  :osstatus
   () )                                         ; 
;  *  DCMCountRecordIterator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMFindRecords" 
      ((dictionaryRef :pointer) (keyFieldTag :ostype) (keySize :unsigned-long) (keyData :pointer) (findMethod :ostype) (preFetchedDataNum :unsigned-long) (preFetchedData (:pointer :ostype)) (skipCount :unsigned-long) (maxRecordCount :unsigned-long) (recordIterator (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  DCMIterateFoundRecord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMCountRecordIterator" 
      ((recordIterator :pointer)) 
  :unsigned-long
   () )                                         ; 
;  *  DCMDisposeRecordIterator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMIterateFoundRecord" 
      ((recordIterator :pointer) (maxKeySize :unsigned-long) (actualKeySize (:pointer :unsigned-long)) (keyData :pointer) (uniqueID (:pointer :unsigned-long)) (dataList (:pointer :aedesc))) 
  :osstatus
   () )                                         ; 
;     Dump dictionary
;                                               ; 
;  *  DCMCountRecord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMDisposeRecordIterator" 
      ((recordIterator :pointer)) 
  :osstatus
   () )                                         ; 
;  *  DCMGetRecordSequenceNumber()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMCountRecord" 
      ((dictionaryID :pointer) (count (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  DCMGetNthRecord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMGetRecordSequenceNumber" 
      ((dictionaryRef :pointer) (keyFieldTag :ostype) (keySize :unsigned-long) (keyData :pointer) (uniqueID :unsigned-long) (sequenceNum (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  DCMGetNextRecord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMGetNthRecord" 
      ((dictionaryRef :pointer) (keyFieldTag :ostype) (serialNum :unsigned-long) (maxKeySize :unsigned-long) (keySize (:pointer :unsigned-long)) (keyData :pointer) (uniqueID (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  DCMGetPrevRecord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMGetNextRecord" 
      ((dictionaryRef :pointer) (keyFieldTag :ostype) (keySize :unsigned-long) (keyData :pointer) (uniqueID :unsigned-long) (maxKeySize :unsigned-long) (nextKeySize (:pointer :unsigned-long)) (nextKeyData :pointer) (nextUniqueID (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;     Get field data
;                                               ; 
;  *  DCMGetFieldData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMGetPrevRecord" 
      ((dictionaryRef :pointer) (keyFieldTag :ostype) (keySize :unsigned-long) (keyData :pointer) (uniqueID :unsigned-long) (maxKeySize :unsigned-long) (prevKeySize (:pointer :unsigned-long)) (prevKeyData :pointer) (prevUniqueID (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; CONST; 
;  *  DCMSetFieldData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMGetFieldData" 
      ((dictionaryRef :pointer) (keyFieldTag :ostype) (keySize :unsigned-long) (keyData :pointer) (uniqueID :unsigned-long) (numOfData :unsigned-long) (dataTag (:pointer :ostype)) (dataList (:pointer :aedesc))) 
  :osstatus
   () )                                         ; CONST; 
;     Add record
;                                               ; 
;  *  DCMAddRecord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMSetFieldData" 
      ((dictionaryRef :pointer) (keyFieldTag :ostype) (keySize :unsigned-long) (keyData :pointer) (uniqueID :unsigned-long) (dataList (:pointer :aedesc))) 
  :osstatus
   () )                                         ; CONST; 
;  *  DCMDeleteRecord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMAddRecord" 
      ((dictionaryRef :pointer) (keyFieldTag :ostype) (keySize :unsigned-long) (keyData :pointer) (checkOnly :boolean) (dataList (:pointer :aedesc)) (newUniqueID (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;     Reorganize/compact dictionary
;                                               ; 
;  *  DCMReorganizeDictionary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMDeleteRecord" 
      ((dictionaryRef :pointer) (keyFieldTag :ostype) (keySize :unsigned-long) (keyData :pointer) (uniqueID :unsigned-long)) 
  :osstatus
   () )                                         ; 
;  *  DCMCompactDictionary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMReorganizeDictionary" 
      ((dictionaryID :pointer) (extraCapacity :unsigned-long) (progressProc :pointer) (userData :unsigned-long)) 
  :osstatus
   () )                                         ; 
;     DictionaryID utilities
;                                               ; 
;  *  DCMGetFileFromDictionaryID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMCompactDictionary" 
      ((dictionaryID :pointer) (progressProc :pointer) (userData :unsigned-long)) 
  :osstatus
   () )                                         ; 
;  *  DCMGetDictionaryIDFromFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMGetFileFromDictionaryID" 
      ((dictionaryID :pointer) (fileRef (:pointer :fsspec))) 
  :osstatus
   () )                                         ; CONST; 
;  *  DCMGetDictionaryIDFromRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMGetDictionaryIDFromFile" 
      ((fileRef (:pointer :fsspec)) (dictionaryID (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;     Field information and manipulation
;                                               ; 
;  *  DCMGetDictionaryFieldInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMGetDictionaryIDFromRef" 
      ((dictionaryRef :pointer)) 
  :pointer
   () )                                         ; 
;     Dictionary property
;                                               ; 
;  *  DCMGetDictionaryProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMGetDictionaryFieldInfo" 
      ((dictionaryID :pointer) (fieldTag :ostype) (fieldInfoRecord (:pointer :aedesc))) 
  :osstatus
   () )                                         ; 
;  *  DCMSetDictionaryProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMGetDictionaryProperty" 
      ((dictionaryID :pointer) (propertyTag :ostype) (maxPropertySize :unsigned-long) (actualSize (:pointer :unsigned-long)) (propertyValue :pointer)) 
  :osstatus
   () )                                         ; 
;  *  DCMGetDictionaryPropertyList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMSetDictionaryProperty" 
      ((dictionaryID :pointer) (propertyTag :ostype) (propertySize :unsigned-long) (propertyValue :pointer)) 
  :osstatus
   () )                                         ; 
;     Seaarch dictionary
;                                               ; 
;  *  DCMCreateDictionaryIterator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMGetDictionaryPropertyList" 
      ((dictionaryID :pointer) (maxPropertyNum :unsigned-long) (numProperties (:pointer :unsigned-long)) (propertyTag (:pointer :ostype))) 
  :osstatus
   () )                                         ; 
;     Search AccessMethod
;                                               ; 
;  *  DCMCreateAccessMethodIterator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMCreateDictionaryIterator" 
      ((dictionaryIterator (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;     Iterator Operation
;                                               ; 
;  *  DCMCountObjectIterator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMCreateAccessMethodIterator" 
      ((accessMethodIterator (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  DCMIterateObject()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMCountObjectIterator" 
      ((iterator :pointer)) 
  :unsigned-long
   () )                                         ; 
;  *  DCMResetObjectIterator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMIterateObject" 
      ((iterator :pointer) (objectID (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  DCMDisposeObjectIterator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMResetObjectIterator" 
      ((iterator :pointer)) 
  :osstatus
   () )                                         ; 
;     Get AccessMethod information
;                                               ; 
;  *  DCMGetAccessMethodIDFromName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMDisposeObjectIterator" 
      ((iterator :pointer)) 
  :osstatus
   () )                                         ; 
;     Field Info Record routines
;                                               ; 
;  *  DCMCreateFieldInfoRecord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMGetAccessMethodIDFromName" 
      ((accessMethodName (:string 63)) (accessMethodID (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  DCMGetFieldTagAndType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMCreateFieldInfoRecord" 
      ((fieldTag :ostype) (fieldType :ostype) (maxRecordSize :unsigned-long) (fieldAttributes :unsigned-long) (fieldDefaultData (:pointer :aedesc)) (numberOfFindMethods :unsigned-long) (findMethods (:pointer :ostype)) (fieldInfoRecord (:pointer :aedesc))) 
  :osstatus
   () )                                         ; CONST; 
;  *  DCMGetFieldMaxRecordSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMGetFieldTagAndType" 
      ((fieldInfoRecord (:pointer :aedesc)) (fieldTag (:pointer :ostype)) (fieldType (:pointer :ostype))) 
  :osstatus
   () )                                         ; CONST; 
;  *  DCMGetFieldAttributes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMGetFieldMaxRecordSize" 
      ((fieldInfoRecord (:pointer :aedesc)) (maxRecordSize (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; CONST; 
;  *  DCMGetFieldDefaultData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMGetFieldAttributes" 
      ((fieldInfoRecord (:pointer :aedesc)) (attributes (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; CONST; 
;  *  DCMGetFieldFindMethods()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DictionaryMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DCMGetFieldDefaultData" 
      ((fieldInfoRecord (:pointer :aedesc)) (desiredType :ostype) (fieldDefaultData (:pointer :aedesc))) 
  :osstatus
   () )                                         ; CONST; 
;     Check Dictionary Manager availability
;                                               ; $IFC TARGET_RT_MAC_CFM ; 
;         DCMDictionaryManagerAvailable() is a macro available only in C/C++.  
;         To get the same functionality from pascal or assembly, you need
;         to test if Dictionary Manager functions are not NULL.
;         For instance:
;         
;             IF @DCMLibraryVersion <> kUnresolvedCFragSymbolAddress THEN
;                 gDictionaryManagerAvailable = TRUE;
;             ELSE
;                 gDictionaryManagerAvailable = FALSE;
;             END
;     
; 
#|                                              ; $ELSEC; $IFC TARGET_RT_MAC_MACHO ;  Dictionary Manager is always available on OS X 
(deftrap-inline "_DCMGetFieldFindMethods" 
      ((fieldInfoRecord (:pointer :aedesc)) (findMethodsArrayMaxSize :unsigned-long) (findMethods (:pointer :ostype)) (actualNumberOfFindMethods (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; $ENDC
 |#                                             ; $ENDC

; 
; =============================================================================================
;     Definitions for Japanese Analysis Module
; =============================================================================================
; 
; 
;     Default dictionary access method for Japanese analysis
; 
; 
;     Data length limitations of Apple Japanese dictionaries
; 

(defconstant $kMaxYomiLengthInAppleJapaneseDictionary 40)
(defconstant $kMaxKanjiLengthInAppleJapaneseDictionary 64)

; 	
; 	    Defined field tags of Apple Japanese dictionary
; 		
(defconstant $kDCMJapaneseYomiTag :|yomi|)
(defconstant $kDCMJapaneseHyokiTag :|hyok|)
(defconstant $kDCMJapaneseHinshiTag :|hins|)
(defconstant $kDCMJapaneseWeightTag :|hind|)
(defconstant $kDCMJapanesePhoneticTag :|hton|)
(defconstant $kDCMJapaneseAccentTag :|acnt|)
(defconstant $kDCMJapaneseOnKunReadingTag :|OnKn|)
(defconstant $kDCMJapaneseFukugouInfoTag :|fuku|)

(defconstant $kDCMJapaneseYomiType :|utxt|)
(defconstant $kDCMJapaneseHyokiType :|utxt|)
(defconstant $kDCMJapaneseHinshiType :|hins|)
(defconstant $kDCMJapaneseWeightType :|shor|)
(defconstant $kDCMJapanesePhoneticType :|utxt|)
(defconstant $kDCMJapaneseAccentType :|byte|)
(defconstant $kDCMJapaneseOnKunReadingType :|utxt|)
(defconstant $kDCMJapaneseFukugouInfoType :|fuku|)

; 	
; 	=============================================================================================
; 	 System 7 Dictionary Manager
; 	=============================================================================================
; 		
; $ALIGN MAC68K
;   Dictionary data insertion modes  
(defconstant $kInsert 0)                        ;   Only insert the input entry if there is nothing in the dictionary that matches the key.  
(defconstant $kReplace 1)                       ;   Only replace the entries which match the key with the input entry.  
(defconstant $kInsertOrReplace 2)               ;   Insert the entry if there is nothing in the dictionary which matches the key, otherwise replaces the existing matched entries with the input entry.  

; 	 This Was InsertMode 	

(def-mactype :dictionarydatainsertmode (find-mactype ':signed-integer))

;   Key attribute constants  
(defconstant $kIsCaseSensitive #x10)            ;   case sensitive = 16        
(defconstant $kIsNotDiacriticalSensitive #x20)  ;   diac not sensitive = 32     

;   Registered attribute type constants.    
(defconstant $kNoun -1)
(defconstant $kVerb -2)
(defconstant $kAdjective -3)
(defconstant $kAdverb -4)

; 	 This Was AttributeType 	

(def-mactype :dictionaryentryattribute (find-mactype ':signed-byte))
; 	 Dictionary information record 	
(def-mactype :dictionaryinformationptr (find-mactype '(:pointer :dictionaryinformation)))
(defrecord DictionaryInformation 
   (dictionaryFSSpec :fsspec)
   (numberOfRecords :signed-long)
   (currentGarbageSize :signed-long)
   (script :signed-integer)
   (maximumKeyLength :signed-integer)
   (keyAttributes :signed-byte)
   )

(def-mactype :dictionaryattributetableptr (find-mactype '(:pointer :dictionaryattributetable)))
(defrecord DictionaryAttributeTable 
   (datSize :unsigned-byte)
   (datTable (:array :signed-byte 1))
   )

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  InitializeDictionary()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap "_InitializeDictionary" 
      ((theFsspecPtr (:pointer :fsspec)) (maximumKeyLength :signed-integer) (keyAttributes :signed-byte) (script :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xAA53 :d0 1280 theFsspecPtr maximumKeyLength keyAttributes script))

; 
;  *  OpenDictionary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_OpenDictionary" 
      ((theFsspecPtr (:pointer :fsspec)) (accessPermission :signed-byte) (dictionaryReference (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA53 :d0 1281 theFsspecPtr accessPermission dictionaryReference))

; 
;  *  CloseDictionary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CloseDictionary" 
      ((dictionaryReference :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA53 :d0 514 dictionaryReference))

; 
;  *  InsertRecordToDictionary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_InsertRecordToDictionary" 
      ((dictionaryReference :signed-long) (key (:string 255)) (recordDataHandle :handle) (whichMode :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xAA53 :d0 1795 dictionaryReference key recordDataHandle whichMode))

; 
;  *  DeleteRecordFromDictionary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DeleteRecordFromDictionary" 
      ((dictionaryReference :signed-long) (key (:string 255)))
   (:stack :signed-integer)
   (:stack-trap #xAA53 :d0 1028 dictionaryReference key))

; 
;  *  FindRecordInDictionary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_FindRecordInDictionary" 
      ((dictionaryReference :signed-long) (key (:string 255)) (requestedAttributeTablePointer (:pointer :dictionaryattributetable)) (recordDataHandle :handle))
   (:stack :signed-integer)
   (:stack-trap #xAA53 :d0 2053 dictionaryReference key requestedAttributeTablePointer recordDataHandle))

; 
;  *  FindRecordByIndexInDictionary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_FindRecordByIndexInDictionary" 
      ((dictionaryReference :signed-long) (recordIndex :signed-long) (requestedAttributeTablePointer (:pointer :dictionaryattributetable)) (recordKey (:pointer (:string 255))) (recordDataHandle :handle))
   (:stack :signed-integer)
   (:stack-trap #xAA53 :d0 2566 dictionaryReference recordIndex requestedAttributeTablePointer recordKey recordDataHandle))

; 
;  *  GetDictionaryInformation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetDictionaryInformation" 
      ((dictionaryReference :signed-long) (theDictionaryInformation (:pointer :dictionaryinformation)))
   (:stack :signed-integer)
   (:stack-trap #xAA53 :d0 1031 dictionaryReference theDictionaryInformation))

; 
;  *  CompactDictionary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CompactDictionary" 
      ((dictionaryReference :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA53 :d0 520 dictionaryReference))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := DictionaryIncludes

; $ENDC                                         ; __DICTIONARY__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Dictionary)