(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Displays.p"
; at Wednesday May 1,2002 2:40:34 pm.
; 
;      File:       Displays.p
;  
;      Contains:   Display Manager Interfaces.
;  
;      Version:    Technology: Mac OS 8
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1993-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __DISPLAYS__
; $SETC __DISPLAYS__ := 1

; $I+
; $SETC DisplaysIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __COMPONENTS__
|#

(require-interface 'Components)
#|                                              ; $I Components.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __VIDEO__
|#

(require-interface 'Video)
#|                                              ; $I Video.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __CMAPPLICATION__

(require-interface 'CMApplication)              ; $I CMApplication.p
; $ENDC

#|                                              ; $IFC UNDEFINED __APPLEEVENTS__
|#

(require-interface 'AppleEvents)
#|                                              ; $I AppleEvents.p
 |#                                             ; $ENDC

#|                                              ; $IFC UNDEFINED __EVENTS__
|#

(require-interface 'Events)
#|                                              ; $I Events.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __PROCESSES__
|#

(require-interface 'Processes)
#|                                              ; $I Processes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __DIALOGS__
|#

(require-interface 'Dialogs)
#|                                              ; $I Dialogs.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :dmprocessinfoptr (find-mactype '(:pointer :processserialnumber)))
(def-mactype :dmmodalfilterupp (find-mactype ':pointer))

;   AppleEvents Core Suite  
(defconstant $kAESystemConfigNotice :|cnfg|)    ;   Core Suite types  
(defconstant $kAEDisplayNotice :|dspl|)
(defconstant $kAEDisplaySummary :|dsum|)
(defconstant $keyDMConfigVersion :|dmcv|)
(defconstant $keyDMConfigFlags :|dmcf|)
(defconstant $keyDMConfigReserved :|dmcr|)
(defconstant $keyDisplayID :|dmid|)
(defconstant $keyDisplayComponent :|dmdc|)
(defconstant $keyDisplayDevice :|dmdd|)
(defconstant $keyDisplayFlags :|dmdf|)
(defconstant $keyDisplayMode :|dmdm|)
(defconstant $keyDisplayModeReserved :|dmmr|)
(defconstant $keyDisplayReserved :|dmdr|)
(defconstant $keyDisplayMirroredId :|dmmi|)
(defconstant $keyDeviceFlags :|dddf|)
(defconstant $keyDeviceDepthMode :|dddm|)
(defconstant $keyDeviceRect :|dddr|)
(defconstant $keyPixMapRect :|dpdr|)
(defconstant $keyPixMapHResolution :|dphr|)
(defconstant $keyPixMapVResolution :|dpvr|)
(defconstant $keyPixMapPixelType :|dppt|)
(defconstant $keyPixMapPixelSize :|dpps|)
(defconstant $keyPixMapCmpCount :|dpcc|)
(defconstant $keyPixMapCmpSize :|dpcs|)
(defconstant $keyPixMapAlignment :|dppa|)
(defconstant $keyPixMapResReserved :|dprr|)
(defconstant $keyPixMapReserved :|dppr|)
(defconstant $keyPixMapColorTableSeed :|dpct|)
(defconstant $keySummaryMenubar :|dsmb|)
(defconstant $keySummaryChanges :|dsch|)
(defconstant $keyDisplayOldConfig :|dold|)
(defconstant $keyDisplayNewConfig :|dnew|)

(defconstant $dmOnlyActiveDisplays #$true)
(defconstant $dmAllDisplays #$false)

;   DMSendDependentNotification notifyClass  
(defconstant $kDependentNotifyClassShowCursor :|shcr|);   When display mgr shows a hidden cursor during an unmirror  
(defconstant $kDependentNotifyClassDriverOverride :|ndrv|);   When a driver is overridden  
(defconstant $kDependentNotifyClassDisplayMgrOverride :|dmgr|);   When display manager is upgraded  
(defconstant $kDependentNotifyClassProfileChanged :|prof|);   When DMSetProfileByAVID is called  

;   Switch Flags  
(defconstant $kNoSwitchConfirmBit 0)            ;   Flag indicating that there is no need to confirm a switch to this mode  
(defconstant $kDepthNotAvailableBit 1)          ;   Current depth not available in new mode  
(defconstant $kShowModeBit 3)                   ;   Show this mode even though it requires a confirm.  
(defconstant $kModeNotResizeBit 4)              ;   Do not use this mode to resize display (for cards that mode drives a different connector).  
(defconstant $kNeverShowModeBit 5)              ;   This mode should not be shown in the user interface.  

; 	    Summary Change Flags (sticky bits indicating an operation was performed)
; 	    For example, moving a display then moving it back will still set the kMovedDisplayBit.
; 		
(defconstant $kBeginEndConfigureBit 0)
(defconstant $kMovedDisplayBit 1)
(defconstant $kSetMainDisplayBit 2)
(defconstant $kSetDisplayModeBit 3)
(defconstant $kAddDisplayBit 4)
(defconstant $kRemoveDisplayBit 5)
(defconstant $kNewDisplayBit 6)
(defconstant $kDisposeDisplayBit 7)
(defconstant $kEnabledDisplayBit 8)
(defconstant $kDisabledDisplayBit 9)
(defconstant $kMirrorDisplayBit 10)
(defconstant $kUnMirrorDisplayBit 11)

;   Notification Messages for extended call back routines  
(defconstant $kDMNotifyRequestConnectionProbe 0);   Like kDMNotifyRequestDisplayProbe only not for smart displays (used in wake before all busses are awake)  
(defconstant $kDMNotifyInstalled 1)             ;   At install time  
(defconstant $kDMNotifyEvent 2)                 ;   Post change time  
(defconstant $kDMNotifyRemoved 3)               ;   At remove time  
(defconstant $kDMNotifyPrep 4)                  ;   Pre change time  
(defconstant $kDMNotifyExtendEvent 5)           ;   Allow registrees to extend apple event before it is sent  
(defconstant $kDMNotifyDependents 6)            ;   Minor notification check without full update  
(defconstant $kDMNotifySuspendConfigure 7)      ;   Temporary end of configuration  
(defconstant $kDMNotifyResumeConfigure 8)       ;   Resume configuration  
(defconstant $kDMNotifyRequestDisplayProbe 9)   ;   Request smart displays re-probe (used in sleep and hot plugging)  
;   Notification Flags  
(defconstant $kExtendedNotificationProc #x10000)

; 	 types for notifyType 	
(defconstant $kFullNotify 0)                    ;   This is the appleevent whole nine yards notify  
(defconstant $kFullDependencyNotify 1)          ;   Only sends to those who want to know about interrelated functionality (used for updating UI)  

; 	 DisplayID/DeviceID constants 	
(defconstant $kDummyDeviceID #xFF)              ;   This is the ID of the dummy display, used when the last real display is disabled. 
(defconstant $kInvalidDisplayID #x0)            ;   This is the invalid ID 
(defconstant $kFirstDisplayID #x100)

;   bits for panelListFlags  
(defconstant $kAllowDuplicatesBit 0)

;   bits for nameFlags  
(defconstant $kSuppressNumberBit 0)
(defconstant $kSuppressNumberMask 1)
(defconstant $kForceNumberBit 1)
(defconstant $kForceNumberMask 2)
(defconstant $kSuppressNameBit 2)
(defconstant $kSuppressNameMask 4)

;   DMGetNameByAVID masks 
(defconstant $kDMSupressNumbersMask #x1)        ;   Supress the numbers and return only names 
(defconstant $kDMForceNumbersMask #x2)          ;   Force numbers to always be shown (even on single display configs) 
(defconstant $kDMSupressNameMask #x4)           ;   Supress the names and return only numbers. 

; 	 Constants for fidelity checks 	
(defconstant $kNoFidelity 0)
(defconstant $kMinimumFidelity 1)
(defconstant $kDefaultFidelity 500)             ;   I'm just picking a number for Apple default panels and engines 
(defconstant $kDefaultManufacturerFidelity 1000);   I'm just picking a number for Manufacturer's panels and engines (overrides apple defaults) 

(defconstant $kAnyPanelType 0)                  ;   Pass to DMNewEngineList for list of all panels (as opposed to specific types) 
(defconstant $kAnyEngineType 0)                 ;   Pass to DMNewEngineList for list of all engines 
(defconstant $kAnyDeviceType 0)                 ;   Pass to DMNewDeviceList for list of all devices 
(defconstant $kAnyPortType 0)                   ;   Pass to DMNewDevicePortList for list of all devices 

; 	 portListFlags for DM_NewDevicePortList 	
;   Should offline devices be put into the port list (such as dummy display)  
(defconstant $kPLIncludeOfflineDevicesBit 0)

; 	 confirmFlags for DMConfirmConfiguration 	
(defconstant $kForceConfirmBit 0)               ;   Force a confirm dialog  
(defconstant $kForceConfirmMask #x1)

; 	 Flags for displayModeFlags 	
(defconstant $kDisplayModeListNotPreferredBit 0)
(defconstant $kDisplayModeListNotPreferredMask #x1)

; 	 Flags for itemFlags 	
(defconstant $kComponentListNotPreferredBit 0)
(defconstant $kComponentListNotPreferredMask #x1)

(defconstant $kDisplayTimingInfoVersionZero 1)
(defconstant $kDisplayTimingInfoReservedCountVersionZero 16)
(defconstant $kDisplayModeEntryVersionZero 0)   ;   displayModeVersion - original version 
(defconstant $kDisplayModeEntryVersionOne 1)    ;   displayModeVersion - added displayModeOverrideInfo 

(defconstant $kMakeAndModelReservedCount 4)     ;   Number of reserved fields 

;   Display Gestalt for DMDisplayGestalt 
(defconstant $kDisplayGestaltDisplayCommunicationAttr :|comm|)
(defconstant $kDisplayGestaltForbidI2CMask #x1) ;   Some displays have firmware problems if they get I2C communication.  If this bit is set, then I2C communication is forbidden 
(defconstant $kDisplayGestaltUseI2CPowerMask #x2);   Some displays require I2C power settings (most use DPMS). 
(defconstant $kDisplayGestaltCalibratorAttr :|cali|)
(defconstant $kDisplayGestaltBrightnessAffectsGammaMask #x1);   Used by default calibrator (should we show brightness panel)  
(defconstant $kDisplayGestaltViewAngleAffectsGammaMask #x2);   Currently not used by color sync 

(def-mactype :dmfidelitytype (find-mactype ':unsigned-long))
; 
; 	   AVID is an ID for ports and devices the old DisplayID type
; 	    is carried on for compatibility
; 	

(def-mactype :dmlisttype (find-mactype ':pointer))
(def-mactype :dmlistindextype (find-mactype ':unsigned-long))
(%define-record :avpowerstaterec (find-record-descriptor :vdpowerstaterec))
(def-mactype :avpowerstaterecptr (find-mactype '(:pointer :vdpowerstaterec)))
(def-mactype :avpowerstateptr (find-mactype '(:pointer :vdpowerstaterec)))
(def-mactype :dmdisplaytiminginforecptr (find-mactype '(:pointer :dmdisplaytiminginforec)))
(defrecord DMDisplayTimingInfoRec 
   (timingInfoVersion :unsigned-long)
   (timingInfoAttributes :unsigned-long)        ;   Flags  
   (timingInfoRelativeQuality :signed-long)     ;   quality of the timing  
   (timingInfoRelativeDefault :signed-long)     ;   relative default of the timing  
   (timingInfoReserved (:array :unsigned-long 16));   Reserved  
   )

(def-mactype :dmdisplaytiminginfoptr (find-mactype '(:pointer :dmdisplaytiminginforec)))

(def-mactype :dmcomponentlistentryrecptr (find-mactype '(:pointer :dmcomponentlistentryrec)))
(defrecord DMComponentListEntryRec 
   (itemID :unsigned-long)                      ;   DisplayID Manager 
   (itemComponent (:pointer :componentrecord))  ;   Component Manager 
   (itemDescription :componentdescription)      ;   We can always construct this if we use something beyond the compontent mgr. 
   (itemClass :ostype)                          ;   Class of group to put this panel (eg geometry/color/etc for panels, brightness/contrast for engines, video out/sound/etc for devices) 
   (itemFidelity :unsigned-long)                ;   How good is this item for the specified search? 
   (itemSubClass :ostype)                       ;   Subclass of group to put this panel.  Can use to do sub-grouping (eg volume for volume panel and mute panel) 
   (itemSort :point)                            ;   Set to 0 - future to sort the items in a sub group. 
   (itemFlags :unsigned-long)                   ;   Set to 0 (future expansion) 
   (itemReserved :ostype)                       ;   What kind of code does the itemReference point to  (right now - kPanelEntryTypeComponentMgr only) 
   (itemFuture1 :unsigned-long)                 ;   Set to 0 (future expansion - probably an alternate code style) 
   (itemFuture2 :unsigned-long)                 ;   Set to 0 (future expansion - probably an alternate code style) 
   (itemFuture3 :unsigned-long)                 ;   Set to 0 (future expansion - probably an alternate code style) 
   (itemFuture4 :unsigned-long)                 ;   Set to 0 (future expansion - probably an alternate code style) 
   )

(def-mactype :dmcomponentlistentryptr (find-mactype '(:pointer :dmcomponentlistentryrec)))
;    Move AVLocationRec to AVComponents.i AFTER AVComponents.i is created 
(def-mactype :avlocationrecptr (find-mactype '(:pointer :avlocationrec)))
(defrecord AVLocationRec 
   (locationConstant :unsigned-long)            ;   Set to 0 (future expansion - probably an alternate code style) 
   )

(def-mactype :avlocationptr (find-mactype '(:pointer :avlocationrec)))
(def-mactype :dmdepthinforecptr (find-mactype '(:pointer :dmdepthinforec)))
(defrecord DMDepthInfoRec 
   (depthSwitchInfo (:pointer :vdswitchinforec));   This is the switch mode to choose this timing/depth  
   (depthVPBlock (:pointer :vpblock))           ;   VPBlock (including size, depth and format)  
   (depthFlags :unsigned-long)                  ;   VDVideoParametersInfoRec.csDepthFlags   
   (depthReserved1 :unsigned-long)              ;   Reserved  
   (depthReserved2 :unsigned-long)              ;   Reserved  
   )

(def-mactype :dmdepthinfoptr (find-mactype '(:pointer :dmdepthinforec)))
(def-mactype :dmdepthinfoblockrecptr (find-mactype '(:pointer :dmdepthinfoblockrec)))
(defrecord DMDepthInfoBlockRec 
   (depthBlockCount :unsigned-long)             ;   How many depths are there?  
   (depthVPBlock (:pointer :dmdepthinforec))    ;   Array of DMDepthInfoRec  
   (depthBlockFlags :unsigned-long)             ;   Reserved  
   (depthBlockReserved1 :unsigned-long)         ;   Reserved  
   (depthBlockReserved2 :unsigned-long)         ;   Reserved  
   )

(def-mactype :dmdepthinfoblockptr (find-mactype '(:pointer :dmdepthinfoblockrec)))
(def-mactype :dmdisplaymodelistentryrecptr (find-mactype '(:pointer :dmdisplaymodelistentryrec)))
(defrecord DMDisplayModeListEntryRec 
   (displayModeFlags :unsigned-long)
   (displayModeSwitchInfo (:pointer :vdswitchinforec))
   (displayModeResolutionInfo (:pointer :vdresolutioninforec))
   (displayModeTimingInfo (:pointer :vdtiminginforec))
   (displayModeDepthBlockInfo (:pointer :dmdepthinfoblockrec));   Information about all the depths 
   (displayModeVersion :unsigned-long)          ;   What version is this record (now kDisplayModeEntryVersionOne) 
   (displayModeName (:pointer (:string 255)))   ;   Name of the timing mode 
   (displayModeDisplayInfo (:pointer :dmdisplaytiminginforec));   Information from the display. 
   )

(def-mactype :dmdisplaymodelistentryptr (find-mactype '(:pointer :dmdisplaymodelistentryrec)))

(def-mactype :dependentnotifyrecptr (find-mactype '(:pointer :dependentnotifyrec)))
(defrecord DependentNotifyRec 
   (notifyType :ostype)                         ;   What type was the engine that made the change (may be zero) 
   (notifyClass :ostype)                        ;   What class was the change (eg geometry, color etc) 
   (notifyPortID :unsigned-long)                ;   Which device was touched (kInvalidDisplayID -> all or none) 
   (notifyComponent (:pointer :componentinstancerecord));   What engine did it (may be 0)? 
   (notifyVersion :unsigned-long)               ;   Set to 0 (future expansion) 
   (notifyFlags :unsigned-long)                 ;   Set to 0 (future expansion) 
   (notifyReserved :unsigned-long)              ;   Set to 0 (future expansion) 
   (notifyFuture :unsigned-long)                ;   Set to 0 (future expansion) 
   )

(def-mactype :dependentnotifyptr (find-mactype '(:pointer :dependentnotifyrec)))

(def-mactype :dmmakeandmodelrecptr (find-mactype '(:pointer :dmmakeandmodelrec)))
(defrecord DMMakeAndModelRec 
   (manufacturer :ostype)
   (model :unsigned-long)
   (serialNumber :unsigned-long)
   (manufactureDate :unsigned-long)
   (makeReserved (:array :unsigned-long 4))
   )

(def-mactype :dmmakeandmodelptr (find-mactype '(:pointer :dmmakeandmodelrec)))
;   DMNewDisplayList displayListIncludeFlags 

(defconstant $kIncludeOnlineActiveDisplaysMask #x1)
(defconstant $kIncludeOnlineDisabledDisplaysMask #x2)
(defconstant $kIncludeOfflineDisplaysMask #x4)
(defconstant $kIncludeOfflineDummyDisplaysMask #x8)
(defconstant $kIncludeHardwareMirroredDisplaysMask #x10)

;   modeListFlags for DMNewDisplayModeList  
(defconstant $kDMModeListIncludeAllModesMask #x1);   Include all timing modes not _explicitly_ excluded (see other bits) 
(defconstant $kDMModeListIncludeOfflineModesMask #x2)
(defconstant $kDMModeListExcludeDriverModesMask #x4);   Exclude old-style timing modes (cscGetNextResolution/kDisplayModeIDFindFirstResolution modes) 
(defconstant $kDMModeListExcludeDisplayModesMask #x8);   Exclude timing modes that come from the display (always arbritrary timing modes) 
(defconstant $kDMModeListExcludeCustomModesMask #x10);   Exclude custom modes that came neither from the driver or display (need a better name) 
(defconstant $kDMModeListPreferStretchedModesMask #x20);   Prefer modes that are stretched over modes that are letterboxed when setting kDisplayModeListNotPreferredBit 
(defconstant $kDMModeListPreferSafeModesMask #x40);   Prefer modes that are safe over modes that are not when setting kDisplayModeListNotPreferredBit 
(defconstant $kDMModeListExcludeDriverScaledModesMask #x80);   Exclude modes that are scaled by the driver (usually on fixed resolution displays) 

;   DMNewDisplayList displayListFlags 

(def-mactype :displaylistentryrecptr (find-mactype '(:pointer :displaylistentryrec)))
(defrecord DisplayListEntryRec 
   (displayListEntryGDevice (:handle :gdevice))
   (displayListEntryDisplayID :unsigned-long)
   (displayListEntryIncludeFlags :unsigned-long);   Reason this entry was included 
   (displayListEntryReserved1 :unsigned-long)
   (displayListEntryReserved2 :unsigned-long)   ;   Zero 
   (displayListEntryReserved3 :unsigned-long)   ;   Zero 
   (displayListEntryReserved4 :unsigned-long)   ;   Zero 
   (displayListEntryReserved5 :unsigned-long)   ;   Zero 
   )

(def-mactype :displaylistentryptr (find-mactype '(:pointer :displaylistentryrec)))
(def-mactype :dmprofilelistentryrecptr (find-mactype '(:pointer :dmprofilelistentryrec)))
(defrecord DMProfileListEntryRec 
   (profileRef :pointer)
   (profileReserved1 :pointer)                  ;   Reserved 
   (profileReserved2 :pointer)                  ;   Reserved 
   (profileReserved3 :pointer)                  ;   Reserved 
   )

(def-mactype :dmprofilelistentryptr (find-mactype '(:pointer :dmprofilelistentryrec)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DMNotificationProcPtr = PROCEDURE(VAR theEvent: AppleEvent);

|#
 |#                                             ; $ELSEC
(def-mactype :dmnotificationprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DMExtendedNotificationProcPtr = PROCEDURE(userData: UNIV Ptr; theMessage: INTEGER; notifyData: UNIV Ptr);

|#
 |#                                             ; $ELSEC
(def-mactype :dmextendednotificationprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DMComponentListIteratorProcPtr = PROCEDURE(userData: UNIV Ptr; itemIndex: DMListIndexType; componentInfo: DMComponentListEntryPtr);

|#
 |#                                             ; $ELSEC
(def-mactype :dmcomponentlistiteratorprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DMDisplayModeListIteratorProcPtr = PROCEDURE(userData: UNIV Ptr; itemIndex: DMListIndexType; displaymodeInfo: DMDisplayModeListEntryPtr);

|#
 |#                                             ; $ELSEC
(def-mactype :dmdisplaymodelistiteratorprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DMProfileListIteratorProcPtr = PROCEDURE(userData: UNIV Ptr; itemIndex: DMListIndexType; profileInfo: DMProfileListEntryPtr);

|#
 |#                                             ; $ELSEC
(def-mactype :dmprofilelistiteratorprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DMDisplayListIteratorProcPtr = PROCEDURE(userData: UNIV Ptr; itemIndex: DMListIndexType; displaymodeInfo: DisplayListEntryPtr);

|#
 |#                                             ; $ELSEC
(def-mactype :dmdisplaylistiteratorprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :dmnotificationupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :dmnotificationupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :dmextendednotificationupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :dmextendednotificationupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :dmcomponentlistiteratorupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :dmcomponentlistiteratorupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :dmdisplaymodelistiteratorupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :dmdisplaymodelistiteratorupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :dmprofilelistiteratorupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :dmprofilelistiteratorupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :dmdisplaylistiteratorupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :dmdisplaylistiteratorupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppDMNotificationProcInfo #xC0)
(defconstant $uppDMExtendedNotificationProcInfo #xEC0)
(defconstant $uppDMComponentListIteratorProcInfo #xFC0)
(defconstant $uppDMDisplayModeListIteratorProcInfo #xFC0)
(defconstant $uppDMProfileListIteratorProcInfo #xFC0)
(defconstant $uppDMDisplayListIteratorProcInfo #xFC0)
; 
; 	 *  NewDMNotificationUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewDMNotificationProc 
(deftrap "_NewDMNotificationUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewDMExtendedNotificationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewDMExtendedNotificationProc 
(deftrap "_NewDMExtendedNotificationUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewDMComponentListIteratorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewDMComponentListIteratorProc 
(deftrap "_NewDMComponentListIteratorUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewDMDisplayModeListIteratorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewDMDisplayModeListIteratorProc 
(deftrap "_NewDMDisplayModeListIteratorUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewDMProfileListIteratorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewDMProfileListIteratorProc 
(deftrap "_NewDMProfileListIteratorUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewDMDisplayListIteratorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewDMDisplayListIteratorProc 
(deftrap "_NewDMDisplayListIteratorUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeDMNotificationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeDMNotificationUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeDMExtendedNotificationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeDMExtendedNotificationUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeDMComponentListIteratorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeDMComponentListIteratorUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeDMDisplayModeListIteratorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeDMDisplayModeListIteratorUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeDMProfileListIteratorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeDMProfileListIteratorUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeDMDisplayListIteratorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeDMDisplayListIteratorUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeDMNotificationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallDMNotificationProc 
(deftrap-inline "_InvokeDMNotificationUPP" 
      ((theEvent (:pointer :aedesc)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeDMExtendedNotificationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallDMExtendedNotificationProc 
(deftrap-inline "_InvokeDMExtendedNotificationUPP" 
      ((userData :pointer) (theMessage :signed-integer) (notifyData :pointer) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeDMComponentListIteratorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallDMComponentListIteratorProc 
(deftrap-inline "_InvokeDMComponentListIteratorUPP" 
      ((userData :pointer) (itemIndex :unsigned-long) (componentInfo (:pointer :dmcomponentlistentryrec)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeDMDisplayModeListIteratorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallDMDisplayModeListIteratorProc 
(deftrap-inline "_InvokeDMDisplayModeListIteratorUPP" 
      ((userData :pointer) (itemIndex :unsigned-long) (displaymodeInfo (:pointer :dmdisplaymodelistentryrec)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeDMProfileListIteratorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallDMProfileListIteratorProc 
(deftrap-inline "_InvokeDMProfileListIteratorUPP" 
      ((userData :pointer) (itemIndex :unsigned-long) (profileInfo (:pointer :dmprofilelistentryrec)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeDMDisplayListIteratorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallDMDisplayListIteratorProc 
(deftrap-inline "_InvokeDMDisplayListIteratorUPP" 
      ((userData :pointer) (itemIndex :unsigned-long) (displaymodeInfo (:pointer :displaylistentryrec)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  DMDisplayGestalt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib 2.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DMDisplayGestalt" 
      ((theDisplayID :unsigned-long) (displayGestaltSelector :ostype) (displayGestaltResponse (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1747 theDisplayID displayGestaltSelector displayGestaltResponse))

; 
;  *  DMUseScreenPrefs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib 2.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DMUseScreenPrefs" 
      ((usePrefs :boolean) (displayState :handle))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1004 usePrefs displayState))

; 
;  *  DMSuspendConfigure()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib 2.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DMSuspendConfigure" 
      ((displayState :handle) (reserved1 :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1257 displayState reserved1))

; 
;  *  DMResumeConfigure()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib 2.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DMResumeConfigure" 
      ((displayState :handle) (reserved1 :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1256 displayState reserved1))

; 
;  *  DMSetGammaByAVID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib 2.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DMSetGammaByAVID" 
      ((gammaAVID :unsigned-long) (setGammaFlags :unsigned-long) (theGamma (:handle :gammatbl)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1745 gammaAVID setGammaFlags theGamma))

; 
;  *  DMGetGammaByAVID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib 2.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DMGetGammaByAVID" 
      ((gammaAVID :unsigned-long) (getGammaFlags :unsigned-long) (theGamma (:pointer (:handle :gammatbl))))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1744 gammaAVID getGammaFlags theGamma))

; 
;  *  DMGetMakeAndModelByAVID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib 2.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DMGetMakeAndModelByAVID" 
      ((theAVID :unsigned-long) (theMakeAndModel (:pointer :dmmakeandmodelrec)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1239 theAVID theMakeAndModel))

; 
;  *  DMNewDisplayList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib 2.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DMNewDisplayList" 
      ((displayListIncludeFlags :unsigned-long) (reserved1 :unsigned-long) (reserved2 :unsigned-long) (theCount (:pointer :unsigned-long)) (theDisplayList (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 2774 displayListIncludeFlags reserved1 reserved2 theCount theDisplayList))

; 
;  *  DMGetIndexedDisplayFromList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib 2.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DMGetIndexedDisplayFromList" 
      ((theDisplayList :pointer) (itemIndex :unsigned-long) (reserved :unsigned-long) (listIterator :pointer) (userData :pointer))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 2773 theDisplayList itemIndex reserved listIterator userData))

; 
;  *  DMNewProfileListByAVID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib 2.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DMNewProfileListByAVID" 
      ((theAVID :unsigned-long) (reserved :unsigned-long) (profileCount (:pointer :unsigned-long)) (profileList (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 2268 theAVID reserved profileCount profileList))

; 
;  *  DMGetIndexedProfileFromList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib 2.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DMGetIndexedProfileFromList" 
      ((profileList :pointer) (itemIndex :unsigned-long) (reserved :unsigned-long) (listIterator :pointer) (userData :pointer))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 2779 profileList itemIndex reserved listIterator userData))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  DMGetFirstScreenDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMGetFirstScreenDevice" 
      ((activeOnly :boolean))
   (:stack (:handle :gdevice))
   (:stack-trap #xABEB :d0 0 activeOnly))

; 
;  *  DMGetNextScreenDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMGetNextScreenDevice" 
      ((theDevice (:handle :gdevice)) (activeOnly :boolean))
   (:stack (:handle :gdevice))
   (:stack-trap #xABEB :d0 1 theDevice activeOnly))

; 
;  *  DMDrawDesktopRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMDrawDesktopRect" 
      ((globalRect (:pointer :rect)))
   nil
   (:stack-trap #xABEB :d0 2 globalRect))

; 
;  *  DMDrawDesktopRegion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMDrawDesktopRegion" 
      ((globalRgn (:handle :macregion)))
   nil
   (:stack-trap #xABEB :d0 3 globalRgn))

; 
;  *  DMBeginConfigureDisplays()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMBeginConfigureDisplays" 
      ((displayState (:pointer :handle)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 518 displayState))

; 
;  *  DMEndConfigureDisplays()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMEndConfigureDisplays" 
      ((displayState :handle))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 519 displayState))

; 
;  *  DMAddDisplay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMAddDisplay" 
      ((newDevice (:handle :gdevice)) (driver :signed-integer) (mode :unsigned-long) (reserved :unsigned-long) (displayID :unsigned-long) (displayComponent (:pointer :componentrecord)) (displayState :handle))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 3336 newDevice driver mode reserved displayID displayComponent displayState))

; 
;  *  DMMoveDisplay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMMoveDisplay" 
      ((moveDevice (:handle :gdevice)) (x :signed-integer) (y :signed-integer) (displayState :handle))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1545 moveDevice x y displayState))

; 
;  *  DMDisableDisplay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMDisableDisplay" 
      ((disableDevice (:handle :gdevice)) (displayState :handle))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1034 disableDevice displayState))

; 
;  *  DMEnableDisplay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMEnableDisplay" 
      ((enableDevice (:handle :gdevice)) (displayState :handle))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1035 enableDevice displayState))

; 
;  *  DMRemoveDisplay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMRemoveDisplay" 
      ((removeDevice (:handle :gdevice)) (displayState :handle))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1036 removeDevice displayState))

; 
;  *  DMSetMainDisplay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMSetMainDisplay" 
      ((newMainDevice (:handle :gdevice)) (displayState :handle))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1040 newMainDevice displayState))

; 
;  *  DMSetDisplayMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMSetDisplayMode" 
      ((theDevice (:handle :gdevice)) (mode :unsigned-long) (depthMode (:pointer :unsigned-long)) (reserved :unsigned-long) (displayState :handle))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 2577 theDevice mode depthMode reserved displayState))

; 
;  *  DMCheckDisplayMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMCheckDisplayMode" 
      ((theDevice (:handle :gdevice)) (mode :unsigned-long) (depthMode :unsigned-long) (switchFlags (:pointer :unsigned-long)) (reserved :unsigned-long) (modeOk (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 3090 theDevice mode depthMode switchFlags reserved modeOk))

; 
;  *  DMGetDeskRegion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMGetDeskRegion" 
      ((desktopRegion (:pointer (:handle :macregion))))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 531 desktopRegion))

; 
;  *  DMRegisterNotifyProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMRegisterNotifyProc" 
      ((notificationProc :pointer) (whichPSN (:pointer :processserialnumber)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1044 notificationProc whichPSN))

; 
;  *  DMRemoveNotifyProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMRemoveNotifyProc" 
      ((notificationProc :pointer) (whichPSN (:pointer :processserialnumber)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1045 notificationProc whichPSN))

; 
;  *  DMQDIsMirroringCapable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMQDIsMirroringCapable" 
      ((qdIsMirroringCapable (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 534 qdIsMirroringCapable))

; 
;  *  DMCanMirrorNow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMCanMirrorNow" 
      ((canMirrorNow (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 535 canMirrorNow))

; 
;  *  DMIsMirroringOn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMIsMirroringOn" 
      ((isMirroringOn (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 536 isMirroringOn))

; 
;  *  DMMirrorDevices()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMMirrorDevices" 
      ((gD1 (:handle :gdevice)) (gD2 (:handle :gdevice)) (displayState :handle))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1561 gD1 gD2 displayState))

; 
;  *  DMUnmirrorDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMUnmirrorDevice" 
      ((gDevice (:handle :gdevice)) (displayState :handle))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1050 gDevice displayState))

; 
;  *  DMGetNextMirroredDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMGetNextMirroredDevice" 
      ((gDevice (:handle :gdevice)) (mirroredDevice (:pointer (:handle :gdevice))))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1051 gDevice mirroredDevice))

; 
;  *  DMBlockMirroring()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMBlockMirroring" 
      ()
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 28))

; 
;  *  DMUnblockMirroring()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMUnblockMirroring" 
      ()
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 29))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  DMGetDisplayMgrA5World()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DMGetDisplayMgrA5World" 
      ((dmA5 (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 542 dmA5))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  DMGetDisplayIDByGDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMGetDisplayIDByGDevice" 
      ((displayDevice (:handle :gdevice)) (displayID (:pointer :unsigned-long)) (failToMain :boolean))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1311 displayDevice displayID failToMain))

; 
;  *  DMGetGDeviceByDisplayID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMGetGDeviceByDisplayID" 
      ((displayID :unsigned-long) (displayDevice (:pointer (:handle :gdevice))) (failToMain :boolean))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1312 displayID displayDevice failToMain))

; 
;  *  DMSetDisplayComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMSetDisplayComponent" 
      ((theDevice (:handle :gdevice)) (displayComponent (:pointer :componentrecord)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1057 theDevice displayComponent))

; 
;  *  DMGetDisplayComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMGetDisplayComponent" 
      ((theDevice (:handle :gdevice)) (displayComponent (:pointer (:pointer :componentrecord))))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1058 theDevice displayComponent))

; 
;  *  DMNewDisplay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMNewDisplay" 
      ((newDevice (:pointer (:handle :gdevice))) (driverRefNum :signed-integer) (mode :unsigned-long) (reserved :unsigned-long) (displayID :unsigned-long) (displayComponent (:pointer :componentrecord)) (displayState :handle))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 3363 newDevice driverRefNum mode reserved displayID displayComponent displayState))

; 
;  *  DMDisposeDisplay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMDisposeDisplay" 
      ((disposeDevice (:handle :gdevice)) (displayState :handle))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1060 disposeDevice displayState))

; 
;  *  DMResolveDisplayComponents()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMResolveDisplayComponents" 
      ()
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 37))

; 
;  *  DMRegisterExtendedNotifyProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMRegisterExtendedNotifyProc" 
      ((notifyProc :pointer) (notifyUserData :pointer) (nofifyOnFlags :unsigned-integer) (whichPSN (:pointer :processserialnumber)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 2031 notifyProc notifyUserData nofifyOnFlags whichPSN))

; 
;  *  DMRemoveExtendedNotifyProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMRemoveExtendedNotifyProc" 
      ((notifyProc :pointer) (notifyUserData :pointer) (whichPSN (:pointer :processserialnumber)) (removeFlags :unsigned-integer))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1830 notifyProc notifyUserData whichPSN removeFlags))

; 
;  *  DMNewAVPanelList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib68k 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMNewAVPanelList" 
      ((displayID :unsigned-long) (panelType :ostype) (minimumFidelity :unsigned-long) (panelListFlags :unsigned-long) (reserved :unsigned-long) (thePanelCount (:pointer :unsigned-long)) (thePanelList (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 3111 displayID panelType minimumFidelity panelListFlags reserved thePanelCount thePanelList))

; 
;  *  DMNewAVEngineList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib68k 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMNewAVEngineList" 
      ((displayID :unsigned-long) (engineType :ostype) (minimumFidelity :unsigned-long) (engineListFlags :unsigned-long) (reserved :unsigned-long) (engineCount (:pointer :unsigned-long)) (engineList (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 3112 displayID engineType minimumFidelity engineListFlags reserved engineCount engineList))

; 
;  *  DMNewAVDeviceList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib68k 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMNewAVDeviceList" 
      ((deviceType :ostype) (deviceListFlags :unsigned-long) (reserved :unsigned-long) (deviceCount (:pointer :unsigned-long)) (deviceList (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 2601 deviceType deviceListFlags reserved deviceCount deviceList))

; 
;  *  DMNewAVPortListByPortType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib68k 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMNewAVPortListByPortType" 
      ((subType :ostype) (portListFlags :unsigned-long) (reserved :unsigned-long) (devicePortCount (:pointer :unsigned-long)) (theDevicePortList (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 2602 subType portListFlags reserved devicePortCount theDevicePortList))

; 
;  *  DMGetIndexedComponentFromList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib68k 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMGetIndexedComponentFromList" 
      ((panelList :pointer) (itemIndex :unsigned-long) (reserved :unsigned-long) (listIterator :pointer) (userData :pointer))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 2603 panelList itemIndex reserved listIterator userData))

; 
;  *  DMDisposeList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMDisposeList" 
      ((panelList :pointer))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 556 panelList))

; 
;  *  DMGetNameByAVID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib68k 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMGetNameByAVID" 
      ((theID :unsigned-long) (nameFlags :unsigned-long) (name (:pointer (:string 255))))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1581 theID nameFlags name))

; 
;  *  DMNewAVIDByPortComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib68k 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMNewAVIDByPortComponent" 
      ((thePortComponent (:pointer :componentrecord)) (portKind :ostype) (reserved :unsigned-long) (newID (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 2094 thePortComponent portKind reserved newID))

; 
;  *  DMGetPortComponentByAVID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib68k 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMGetPortComponentByAVID" 
      ((thePortID :unsigned-long) (thePortComponent (:pointer (:pointer :componentrecord))) (theDesciption (:pointer :componentdescription)) (thePortKind (:pointer :ostype)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 2095 thePortID thePortComponent theDesciption thePortKind))

; 
;  *  DMSendDependentNotification()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMSendDependentNotification" 
      ((notifyType :ostype) (notifyClass :ostype) (displayID :unsigned-long) (notifyComponent (:pointer :componentinstancerecord)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 2096 notifyType notifyClass displayID notifyComponent))

; 
;  *  DMDisposeAVComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib68k 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMDisposeAVComponent" 
      ((theAVComponent (:pointer :componentrecord)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 561 theAVComponent))

; 
;  *  DMSaveScreenPrefs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib68k 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMSaveScreenPrefs" 
      ((reserved1 :unsigned-long) (saveFlags :unsigned-long) (reserved2 :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1586 reserved1 saveFlags reserved2))

; 
;  *  DMNewAVIDByDeviceComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib68k 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMNewAVIDByDeviceComponent" 
      ((theDeviceComponent (:pointer :componentrecord)) (portKind :ostype) (reserved :unsigned-long) (newID (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 2099 theDeviceComponent portKind reserved newID))

; 
;  *  DMNewAVPortListByDeviceAVID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib68k 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMNewAVPortListByDeviceAVID" 
      ((theID :unsigned-long) (minimumFidelity :unsigned-long) (portListFlags :unsigned-long) (reserved :unsigned-long) (devicePortCount (:pointer :unsigned-long)) (theDevicePortList (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 3124 theID minimumFidelity portListFlags reserved devicePortCount theDevicePortList))

; 
;  *  DMGetDeviceComponentByAVID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib68k 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMGetDeviceComponentByAVID" 
      ((theDeviceID :unsigned-long) (theDeviceComponent (:pointer (:pointer :componentrecord))) (theDesciption (:pointer :componentdescription)) (theDeviceKind (:pointer :ostype)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 2101 theDeviceID theDeviceComponent theDesciption theDeviceKind))

; 
;  *  DMNewDisplayModeList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib68k 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMNewDisplayModeList" 
      ((displayID :unsigned-long) (modeListFlags :unsigned-long) (reserved :unsigned-long) (thePanelCount (:pointer :unsigned-long)) (thePanelList (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 2614 displayID modeListFlags reserved thePanelCount thePanelList))

; 
;  *  DMGetIndexedDisplayModeFromList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib68k 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMGetIndexedDisplayModeFromList" 
      ((panelList :pointer) (itemIndex :unsigned-long) (reserved :unsigned-long) (listIterator :pointer) (userData :pointer))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 2615 panelList itemIndex reserved listIterator userData))

; 
;  *  DMGetGraphicInfoByAVID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib68k 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMGetGraphicInfoByAVID" 
      ((theID :unsigned-long) (theAVPcit (:pointer (:handle :picture))) (theAVIconSuite (:pointer :handle)) (theAVLocation (:pointer :avlocationrec)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 2104 theID theAVPcit theAVIconSuite theAVLocation))

; 
;  *  DMGetAVPowerState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib68k 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMGetAVPowerState" 
      ((theID :unsigned-long) (getPowerState (:pointer :vdpowerstaterec)) (reserved1 :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 2105 theID getPowerState reserved1))

; 
;  *  DMSetAVPowerState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib68k 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMSetAVPowerState" 
      ((theID :unsigned-long) (setPowerState (:pointer :vdpowerstaterec)) (powerFlags :unsigned-long) (displayState :handle))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 2106 theID setPowerState powerFlags displayState))

; 
;  *  DMGetDeviceAVIDByPortAVID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib68k 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMGetDeviceAVIDByPortAVID" 
      ((portAVID :unsigned-long) (deviceAVID (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1083 portAVID deviceAVID))

; 
;  *  DMGetEnableByAVID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib68k 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMGetEnableByAVID" 
      ((theAVID :unsigned-long) (isAVIDEnabledNow (:pointer :boolean)) (canChangeEnableNow (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1596 theAVID isAVIDEnabledNow canChangeEnableNow))

; 
;  *  DMSetEnableByAVID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib68k 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMSetEnableByAVID" 
      ((theAVID :unsigned-long) (doEnable :boolean) (displayState :handle))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1341 theAVID doEnable displayState))

; 
;  *  DMGetDisplayMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib68k 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMGetDisplayMode" 
      ((theDevice (:handle :gdevice)) (switchInfo (:pointer :vdswitchinforec)))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 1086 theDevice switchInfo))

; 
;  *  DMConfirmConfiguration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DisplayLib 2.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DMConfirmConfiguration" 
      ((filterProc :pointer) (confirmFlags :unsigned-long) (reserved :unsigned-long) (displayState :handle))
   (:stack :signed-integer)
   (:stack-trap #xABEB :d0 2111 filterProc confirmFlags reserved displayState))

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := DisplaysIncludes

; $ENDC                                         ; __DISPLAYS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Displays)