(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:DriverSynchronization.p"
; at Wednesday May 1,2002 2:40:00 pm.
; 
;      File:       DriverSynchronization.p
;  
;      Contains:   Driver Synchronization Interfaces.
;  
;      Version:    Technology: MacOS 8
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __DRIVERSYNCHRONIZATION__
; $SETC __DRIVERSYNCHRONIZATION__ := 1

; $I+
; $SETC DriverSynchronizationIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SynchronizeIO()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SynchronizeIO" 
      () 
  nil
   () )
; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  CompareAndSwap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CompareAndSwap" 
      ((oldVvalue :unsigned-long) (newValue :unsigned-long) (OldValueAdr (:pointer :unsigned-long))) 
  :boolean
   () )

; 
;  *  TestAndClear()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_TestAndClear" 
      ((bit :unsigned-long) (startAddress (:pointer :unsigned-byte))) 
  :boolean
   () )

; 
;  *  TestAndSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_TestAndSet" 
      ((bit :unsigned-long) (startAddress (:pointer :unsigned-byte))) 
  :boolean
   () )

; 
;  *  IncrementAtomic8()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_IncrementAtomic8" 
      ((value (:pointer :signed-byte))) 
  :signed-byte
   () )

; 
;  *  DecrementAtomic8()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_DecrementAtomic8" 
      ((value (:pointer :signed-byte))) 
  :signed-byte
   () )

; 
;  *  AddAtomic8()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AddAtomic8" 
      ((amount :signed-long) (value (:pointer :signed-byte))) 
  :signed-byte
   () )

; 
;  *  BitAndAtomic8()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_BitAndAtomic8" 
      ((mask :unsigned-long) (value (:pointer :unsigned-byte))) 
  :uint8
   () )

; 
;  *  BitOrAtomic8()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_BitOrAtomic8" 
      ((mask :unsigned-long) (value (:pointer :unsigned-byte))) 
  :uint8
   () )

; 
;  *  BitXorAtomic8()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_BitXorAtomic8" 
      ((mask :unsigned-long) (value (:pointer :unsigned-byte))) 
  :uint8
   () )

; 
;  *  IncrementAtomic16()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_IncrementAtomic16" 
      ((value (:pointer :signed-integer))) 
  :signed-integer
   () )

; 
;  *  DecrementAtomic16()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_DecrementAtomic16" 
      ((value (:pointer :signed-integer))) 
  :signed-integer
   () )

; 
;  *  AddAtomic16()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AddAtomic16" 
      ((amount :signed-long) (value (:pointer :signed-integer))) 
  :signed-integer
   () )

; 
;  *  BitAndAtomic16()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_BitAndAtomic16" 
      ((mask :unsigned-long) (value (:pointer :unsigned-integer))) 
  :unsigned-integer
   () )

; 
;  *  BitOrAtomic16()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_BitOrAtomic16" 
      ((mask :unsigned-long) (value (:pointer :unsigned-integer))) 
  :unsigned-integer
   () )

; 
;  *  BitXorAtomic16()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_BitXorAtomic16" 
      ((mask :unsigned-long) (value (:pointer :unsigned-integer))) 
  :unsigned-integer
   () )

; 
;  *  IncrementAtomic()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_IncrementAtomic" 
      ((value (:pointer :signed-long))) 
  :signed-long
   () )

; 
;  *  DecrementAtomic()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_DecrementAtomic" 
      ((value (:pointer :signed-long))) 
  :signed-long
   () )

; 
;  *  AddAtomic()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AddAtomic" 
      ((amount :signed-long) (value (:pointer :signed-long))) 
  :signed-long
   () )

; 
;  *  BitAndAtomic()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_BitAndAtomic" 
      ((mask :unsigned-long) (value (:pointer :unsigned-long))) 
  :unsigned-long
   () )

; 
;  *  BitOrAtomic()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_BitOrAtomic" 
      ((mask :unsigned-long) (value (:pointer :unsigned-long))) 
  :unsigned-long
   () )

; 
;  *  BitXorAtomic()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_BitXorAtomic" 
      ((mask :unsigned-long) (value (:pointer :unsigned-long))) 
  :unsigned-long
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := DriverSynchronizationIncludes

; $ENDC                                         ; __DRIVERSYNCHRONIZATION__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'DriverSynchronization)