(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:FSM.p"
; at Wednesday May 1,2002 2:41:28 pm.
; 
;      File:       FSM.p
;  
;      Contains:   HFS External File System Interfaces.
;  
;      Version:    Technology: Mac OS 9
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __FSM__
; $SETC __FSM__ := 1

; $I+
; $SETC FSMIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __HFSVOLUMES__
|#

(require-interface 'HFSVolumes)
#|                                              ; $I HFSVolumes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __PROCESSES__
|#

(require-interface 'Processes)
#|                                              ; $I Processes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  VolMount declarations are now in Files. 

; 
;  * Miscellaneous file system values not in Files.
;  

(defconstant $fsUsrCNID 16)                     ;   First assignable directory or file number  
;      File system trap word attribute bits  
(defconstant $kHFSBit 9)                        ;   HFS call: bit 9  
(defconstant $kHFSMask #x200)
(defconstant $kAsyncBit 10)                     ;   Asynchronous call: bit 10  
(defconstant $kAsyncMask #x400)

; 	
; 	 * HFSCIProc selectCode values
; 	 * Note: The trap attribute bits (the HFS bit and the asynchronous bit)
; 	 * may be set in these selectCode values.
; 	 	
(defconstant $kFSMOpen #xA000)
(defconstant $kFSMClose #xA001)
(defconstant $kFSMRead #xA002)
(defconstant $kFSMWrite #xA003)
(defconstant $kFSMGetVolInfo #xA007)
(defconstant $kFSMCreate #xA008)
(defconstant $kFSMDelete #xA009)
(defconstant $kFSMOpenRF #xA00A)
(defconstant $kFSMRename #xA00B)
(defconstant $kFSMGetFileInfo #xA00C)
(defconstant $kFSMSetFileInfo #xA00D)
(defconstant $kFSMUnmountVol #xA00E)
(defconstant $kFSMMountVol #xA00F)
(defconstant $kFSMAllocate #xA010)
(defconstant $kFSMGetEOF #xA011)
(defconstant $kFSMSetEOF #xA012)
(defconstant $kFSMFlushVol #xA013)
(defconstant $kFSMGetVol #xA014)
(defconstant $kFSMSetVol #xA015)
(defconstant $kFSMEject #xA017)
(defconstant $kFSMGetFPos #xA018)
(defconstant $kFSMOffline #xA035)
(defconstant $kFSMSetFilLock #xA041)
(defconstant $kFSMRstFilLock #xA042)
(defconstant $kFSMSetFilType #xA043)
(defconstant $kFSMSetFPos #xA044)
(defconstant $kFSMFlushFile #xA045)             ;      The File System HFSDispatch selectCodes  
(defconstant $kFSMOpenWD #x1)
(defconstant $kFSMCloseWD #x2)
(defconstant $kFSMCatMove #x5)
(defconstant $kFSMDirCreate #x6)
(defconstant $kFSMGetWDInfo #x7)
(defconstant $kFSMGetFCBInfo #x8)
(defconstant $kFSMGetCatInfo #x9)
(defconstant $kFSMSetCatInfo #xA)
(defconstant $kFSMSetVolInfo #xB)
(defconstant $kFSMLockRng #x10)
(defconstant $kFSMUnlockRng #x11)
(defconstant $kFSMXGetVolInfo #x12)
(defconstant $kFSMCreateFileIDRef #x14)
(defconstant $kFSMDeleteFileIDRef #x15)
(defconstant $kFSMResolveFileIDRef #x16)
(defconstant $kFSMExchangeFiles #x17)
(defconstant $kFSMCatSearch #x18)
(defconstant $kFSMOpenDF #x1A)
(defconstant $kFSMMakeFSSpec #x1B)              ;      The Desktop Manager HFSDispatch selectCodes  
(defconstant $kFSMDTGetPath #x20)
(defconstant $kFSMDTCloseDown #x21)
(defconstant $kFSMDTAddIcon #x22)
(defconstant $kFSMDTGetIcon #x23)
(defconstant $kFSMDTGetIconInfo #x24)
(defconstant $kFSMDTAddAPPL #x25)
(defconstant $kFSMDTRemoveAPPL #x26)
(defconstant $kFSMDTGetAPPL #x27)
(defconstant $kFSMDTSetComment #x28)
(defconstant $kFSMDTRemoveComment #x29)
(defconstant $kFSMDTGetComment #x2A)
(defconstant $kFSMDTFlush #x2B)
(defconstant $kFSMDTReset #x2C)
(defconstant $kFSMDTGetInfo #x2D)
(defconstant $kFSMDTOpenInform #x2E)
(defconstant $kFSMDTDelete #x2F)                ;      The AppleShare HFSDispatch selectCodes  
(defconstant $kFSMGetVolParms #x30)
(defconstant $kFSMGetLogInInfo #x31)
(defconstant $kFSMGetDirAccess #x32)
(defconstant $kFSMSetDirAccess #x33)
(defconstant $kFSMMapID #x34)
(defconstant $kFSMMapName #x35)
(defconstant $kFSMCopyFile #x36)
(defconstant $kFSMMoveRename #x37)
(defconstant $kFSMOpenDeny #x38)
(defconstant $kFSMOpenRFDeny #x39)
(defconstant $kFSMGetXCatInfo #x3A)
(defconstant $kFSMGetVolMountInfoSize #x3F)
(defconstant $kFSMGetVolMountInfo #x40)
(defconstant $kFSMVolumeMount #x41)
(defconstant $kFSMShare #x42)
(defconstant $kFSMUnShare #x43)
(defconstant $kFSMGetUGEntry #x44)
(defconstant $kFSMGetForeignPrivs #x60)
(defconstant $kFSMSetForeignPrivs #x61)         ;   The HFSPlus API SelectCodes (below) 
(defconstant $kFSMGetVolumeInfo #x1D)           ;   Dispatched by ioVRefNum and volumeIndex  
(defconstant $kFSMSetVolumeInfo #x1E)           ;   Dispatched by ioVRefNum  
(defconstant $kFSMReadFork #x51)                ;   Fork I/O calls dispatched by forkRefNum (ioRefNum)  
(defconstant $kFSMWriteFork #x52)
(defconstant $kFSMGetForkPosition #x53)
(defconstant $kFSMSetForkPosition #x54)
(defconstant $kFSMGetForkSize #x55)
(defconstant $kFSMSetForkSize #x56)
(defconstant $kFSMAllocateFork #x57)
(defconstant $kFSMFlushFork #x58)
(defconstant $kFSMCloseFork #x59)
(defconstant $kFSMGetForkCBInfo #x5A)
(defconstant $kFSMCloseIterator #x5B)           ;   Iterator calls are dispatched by upper two bytes of "iterator",  
(defconstant $kFSMGetCatalogInfoBulk #x5C)      ;   which is treated as an ioRefNum.  By convention, the lower two  
(defconstant $kFSMCatalogSearch #x5D)           ;   bytes of the FSIterator are zero, though this is not enforced.  
(defconstant $kFSMMakeFSRef #x6E)               ;   Dispatched by ioVRefNum/ioDirID/ioNamePtr  
(defconstant $kFSMCreateFileUnicode #x70)       ;   FSRef dispatched calls.  The first two bytes of an FSRef  
(defconstant $kFSMCreateDirUnicode #x71)        ;   are a volume reference number (not a working directory reference  
(defconstant $kFSMDeleteObject #x72)            ;   number or drive number).  The remaining bytes of the FSRef are  
(defconstant $kFSMMoveObject #x73)              ;   defined by that particular volume format.  
(defconstant $kFSMRenameUnicode #x74)
(defconstant $kFSMExchangeObjects #x75)
(defconstant $kFSMGetCatalogInfo #x76)
(defconstant $kFSMSetCatalogInfo #x77)
(defconstant $kFSMOpenIterator #x78)
(defconstant $kFSMOpenFork #x79)
(defconstant $kFSMMakeFSRefUnicode #x7A)
(defconstant $kFSMCompareFSRefs #x7C)
(defconstant $kFSMCreateFork #x7D)
(defconstant $kFSMDeleteFork #x7E)
(defconstant $kFSMIterateForks #x7F)

; 	
; 	 * UTDetermineVol status values
; 	 	
(defconstant $dtmvError 0)                      ;   param error  
(defconstant $dtmvFullPathname 1)               ;   determined by full pathname  
(defconstant $dtmvVRefNum 2)                    ;   determined by volume refNum  
(defconstant $dtmvWDRefNum 3)                   ;   determined by working directory refNum  
(defconstant $dtmvDriveNum 4)                   ;   determined by drive number  
(defconstant $dtmvDefault 5)                    ;   determined by default volume  

; 	
; 	 * UTGetBlock options
; 	 	
(defconstant $gbDefault 0)                      ;   default value - read if not found  
;      bits and masks  
(defconstant $gbReadBit 0)                      ;   read block from disk (forced read)  
(defconstant $gbReadMask #x1)
(defconstant $gbExistBit 1)                     ;   get existing cache block  
(defconstant $gbExistMask #x2)
(defconstant $gbNoReadBit 2)                    ;   don't read block from disk if not found in cache  
(defconstant $gbNoReadMask #x4)
(defconstant $gbReleaseBit 3)                   ;   release block immediately after GetBlock  
(defconstant $gbReleaseMask #x8)

; 	
; 	 * UTReleaseBlock options
; 	 	
(defconstant $rbDefault 0)                      ;   default value - just mark the buffer not in-use  
;      bits and masks  
(defconstant $rbWriteBit 0)                     ;   force write buffer to disk  
(defconstant $rbWriteMask #x1)
(defconstant $rbTrashBit 1)                     ;   trash buffer contents after release  
(defconstant $rbTrashMask #x2)
(defconstant $rbDirtyBit 2)                     ;   mark buffer dirty  
(defconstant $rbDirtyMask #x4)
(defconstant $rbFreeBit 3)                      ;   free the buffer (save in the hash)  
(defconstant $rbFreeMask #xA)                   ;   rbFreeMask (rbFreeBit + rbTrashBit) works as rbTrash on < System 7.0 RamCache; on >= System 7.0, rbfreeMask overrides rbTrash  

; 	
; 	 * UTFlushCache options
; 	 	
(defconstant $fcDefault 0)                      ;   default value - pass this fcOption to just flush any dirty buffers  
;      bits and masks  
(defconstant $fcTrashBit 0)                     ;   (don't pass this as fcOption, use only for testing bit)  
(defconstant $fcTrashMask #x1)                  ;   pass this fcOption value to flush and trash cache blocks  
(defconstant $fcFreeBit 1)                      ;   (don't pass this as fcOption, use only for testing bit)  
(defconstant $fcFreeMask #x3)                   ;   pass this fcOption to flush and free cache blocks (Note: both fcTrash and fcFree bits are set)  

; 	
; 	 * UTCacheReadIP and UTCacheWriteIP cacheOption bits and masks are the ioPosMode
; 	 * bits and masks in Files.x
; 	 	

; 	
; 	 * Cache routine internal error codes
; 	 	
(defconstant $chNoBuf 1)                        ;   no free cache buffers (all in use)  
(defconstant $chInUse 2)                        ;   requested block in use  
(defconstant $chnotfound 3)                     ;   requested block not found  
(defconstant $chNotInUse 4)                     ;   block being released was not in use  

; 	
; 	 * FCBRec.fcbFlags bits
; 	 	
(defconstant $fcbWriteBit 0)                    ;   Data can be written to this file  
(defconstant $fcbWriteMask #x1)
(defconstant $fcbResourceBit 1)                 ;   This file is a resource fork  
(defconstant $fcbResourceMask #x2)
(defconstant $fcbWriteLockedBit 2)              ;   File has a locked byte range  
(defconstant $fcbWriteLockedMask #x4)
(defconstant $fcbLargeFileBit 3)                ;   File may grow beyond 2GB; cache uses file blocks, not bytes  
(defconstant $fcbLargeFileMask #x8)
(defconstant $fcbSharedWriteBit 4)              ;   File is open for shared write access  
(defconstant $fcbSharedWriteMask #x10)
(defconstant $fcbFileLockedBit 5)               ;   File is locked (write-protected)  
(defconstant $fcbFileLockedMask #x20)
(defconstant $fcbOwnClumpBit 6)                 ;   File has clump size specified in FCB  
(defconstant $fcbOwnClumpMask #x40)
(defconstant $fcbModifiedBit 7)                 ;   File has changed since it was last flushed  
(defconstant $fcbModifiedMask #x80)

; 	
; 	 *  ForkControlBlock.moreFlags bits
; 	 	
(defconstant $fcbIteratorBit 0)                 ;   FCB belongs to an FSIterator  
(defconstant $fcbIteratorMask #x1)
(defconstant $fcbUseForkIDBit 1)                ;   Use the FCB's forkID instead of fcbResourceBit  
(defconstant $fcbUseForkIDMask #x2)

; 	
; 	 *  HFS Component Interface constants
; 	 	

; 	
; 	 * compInterfMask bits specific to HFS component
; 	 	
(defconstant $hfsCIDoesHFSBit 23)               ;   set if file system supports HFS calls  
(defconstant $hfsCIDoesHFSMask #x800000)
(defconstant $hfsCIDoesAppleShareBit 22)        ;   set if AppleShare calls supported  
(defconstant $hfsCIDoesAppleShareMask #x400000)
(defconstant $hfsCIDoesDeskTopBit 21)           ;   set if Desktop Database calls supported  
(defconstant $hfsCIDoesDeskTopMask #x200000)
(defconstant $hfsCIDoesDynamicLoadBit 20)       ;   set if dynamically loading code resource  
(defconstant $hfsCIDoesDynamicLoadMask #x100000);         supported  
(defconstant $hfsCIResourceLoadedBit 19)        ;   set if code resource already loaded  
(defconstant $hfsCIResourceLoadedMask #x80000)
(defconstant $hfsCIHasHLL2PProcBit 18)          ;   set if FFS' log2PhyProc  
(defconstant $hfsCIHasHLL2PProcMask #x40000)    ;   is written in a high level language. (i.e., uses Pascal calling convention)  
(defconstant $hfsCIWantsDTSupportBit 17)        ;   set if FFS wants the Mac OS's Desktop Manager code to handle  
(defconstant $hfsCIWantsDTSupportMask #x20000)  ;   all Desktop Manager requests to its volumes.  

; 	
; 	 *  Disk Initialization Component Interface constants
; 	 	

; 	
; 	 * compInterfMask bits specific to Disk Initialization component
; 	 	
(defconstant $diCIHasExtFormatParamsBit 18)     ;   set if file system needs extended format  
(defconstant $diCIHasExtFormatParamsMask #x40000);         parameters  
(defconstant $diCIHasMultiVolTypesBit 17)       ;   set if file system supports more than one  
(defconstant $diCIHasMultiVolTypesMask #x20000) ;         volume type  
(defconstant $diCIDoesSparingBit 16)            ;   set if file system supports disk sparing  
(defconstant $diCIDoesSparingMask #x10000)
(defconstant $diCILiveBit 0)                    ;   set if file system is candidate for current  
(defconstant $diCILiveMask #x1)                 ;         formatting operation (set by PACK2)  

; 	
; 	 * Disk Initialization Component Function selectors
; 	 	
(defconstant $diCILoad 1)                       ;   Make initialization code memory resident  
(defconstant $diCIUnload 2)                     ;   Make initialization code purgeable  
(defconstant $diCIEvaluateSizeChoices 3)        ;   Evaluate size choices  
(defconstant $diCIExtendedZero 4)               ;   Write an empty volume directory  
(defconstant $diCIValidateVolName 5)            ;   Validate volume name  
(defconstant $diCIGetVolTypeInfo 6)             ;   get volume type info  
(defconstant $diCIGetFormatString 7)            ;   get dialog format string  
(defconstant $diCIGetExtFormatParams 8)         ;   get extended format parameters  
(defconstant $diCIGetDefectList 9)              ;   return the defect list for the indicated disk - reserved for future use  

; 	
; 	 * Constants used in the DICIEvaluateSizeRec and FormatListRec
; 	 	
(defconstant $diCIFmtListMax 8)                 ;   maximum number of format list entries in DICIEvaluateSizeRec.numSizeEntries  
;      bits in FormatListRec.formatFlags:  
(defconstant $diCIFmtFlagsValidBit 7)           ;   set if sec, side, tracks valid  
(defconstant $diCIFmtFlagsValidMask #x80)
(defconstant $diCIFmtFlagsCurrentBit 6)         ;   set if current disk has this fmt  
(defconstant $diCIFmtFlagsCurrentMask #x40)     ;      bits in FormatListRec.sizeListFlags:  
(defconstant $diCISizeListOKBit 15)             ;   set if this disk size usable  
(defconstant $diCISizeListOKMask #x8000)

; 	
; 	 * DICIGetFormatStringRec.stringKind format strings
; 	 	
(defconstant $diCIAlternateFormatStr 1)         ;   get alternate format  string (Balloon Help)  
(defconstant $diCISizePresentationStr 2)        ;   get size presentation string (for dialog)  

; 	
; 	 * Error codes returned by Disk Sparing
; 	 	
(defconstant $diCIUserCancelErr 1)              ;   user cancelled the disk init  
(defconstant $diCICriticalSectorBadErr 20)      ;   critical sectors are bad (hopeless)     
(defconstant $diCISparingFailedErr 21)          ;   disk cannot be spared  
(defconstant $diCITooManyBadSectorsErr 22)      ;   too many bad sectors  
(defconstant $diCIUnknownVolTypeErr 23)         ;   the volume type passed in diCIExtendedZero paramBlock is not supported  
(defconstant $diCIVolSizeMismatchErr 24)        ;   specified volume size doesnt match with formatted disk size  
(defconstant $diCIUnknownDICallErr 25)          ;   bogus DI function call selector  
(defconstant $diCINoSparingErr 26)              ;   disk is bad but the target FS doesn't do disk sparing  
(defconstant $diCINoExtendInfoErr 27)           ;   missing file system specific extra parameter in diCIExtendedZero call  
(defconstant $diCINoMessageTextErr 28)          ;   missing message text in DIReformat call  

; 	
; 	 *  File System Manager constants
; 	 	

; 	
; 	 * Miscellaneous constants used by FSM
; 	 	
(defconstant $fsdVersion1 1)                    ;   current version of FSD record  
(defconstant $fsmIgnoreFSID #xFFFE)             ;   this FSID should be ignored by the driver  
(defconstant $fsmGenericFSID #xFFFF)            ;   unknown foreign file system ID  

; 	
; 	 * compInterfMask bits common to all FSM components
; 	 	
(defconstant $fsmComponentEnableBit 31)         ;   set if FSM component interface is enabled  
(defconstant $fsmComponentEnableMask #x80000000)
(defconstant $fsmComponentBusyBit 30)           ;   set if FSM component interface is busy  
(defconstant $fsmComponentBusyMask #x40000000)

; 	
; 	 * Selectors for GetFSInfo
; 	 	
(defconstant $fsmGetFSInfoByIndex -1)           ;   get fs info by index  
(defconstant $fsmGetFSInfoByFSID 0)             ;   get fs info by FSID  
(defconstant $fsmGetFSInfoByRefNum 1)           ;   get fs info by file/vol refnum  

; 	
; 	 * InformFSM messages
; 	 	
(defconstant $fsmNopMessage 0)                  ;   nop  
(defconstant $fsmDrvQElChangedMessage 1)        ;   DQE has changed  
(defconstant $fsmGetFSIconMessage 2)            ;   Get FFS's disk icon  

; 	
; 	 * Messages passed to the fileSystemCommProc
; 	 	
(defconstant $ffsNopMessage 0)                  ;   nop, should always return noErr  
(defconstant $ffsGetIconMessage 1)              ;   return disk icon and mask  
(defconstant $ffsIDDiskMessage 2)               ;   identify the about-to-be-mounted volume  
(defconstant $ffsLoadMessage 3)                 ;   load in the FFS  
(defconstant $ffsUnloadMessage 4)               ;   unload the FFS  
(defconstant $ffsIDVolMountMessage 5)           ;   identify a VolMountInfo record  
(defconstant $ffsInformMessage 6)               ;   FFS defined message  
(defconstant $ffsGetIconInfoMessage 7)

; 	
; 	 *  HFS Utility routine records
; 	 	

; 	
; 	 * record used by UTGetPathComponentName
; 	 	

(def-mactype :parsepathrecptr (find-mactype '(:pointer :parsepathrec)))
(defrecord ParsePathRec 
   (namePtr (:pointer (:string 255)))           ;   pathname to parse  
   (startOffset :signed-integer)                ;   where to start parsing  
   (componentLength :signed-integer)            ;   the length of the pathname component parsed  
   (moreName :signed-byte)                      ;   non-zero if there are more components after this one  
   (foundDelimiter :signed-byte)                ;   non-zero if parsing stopped because a colon (:) delimiter was found  
   )

(def-mactype :wdcbrecptr (find-mactype '(:pointer :wdcbrec)))
(defrecord WDCBRec 
   (wdVCBPtr (:pointer :vcb))                   ;   Pointer to VCB of this working directory  
   (wdDirID :signed-long)                       ;   Directory ID number of this working directory  
   (wdCatHint :signed-long)                     ;   Hint for finding this working directory  
   (wdProcID :signed-long)                      ;   Process that created this working directory  
   )

(def-mactype :fcbrecptr (find-mactype '(:pointer :fcbrec)))
(defrecord FCBRec 
   (fcbFlNm :unsigned-long)                     ;   FCB file number. Non-zero marks FCB used  
   (fcbFlags :signed-byte)                      ;   FCB flags  
   (fcbTypByt :signed-byte)                     ;   File type byte  
   (fcbSBlk :unsigned-integer)                  ;   File start block (in alloc size blks)  
   (fcbEOF :unsigned-long)                      ;   Logical length or EOF in bytes  
   (fcbPLen :unsigned-long)                     ;   Physical file length in bytes  
   (fcbCrPs :unsigned-long)                     ;   Current position within file  
   (fcbVPtr (:pointer :vcb))                    ;   Pointer to the corresponding VCB  
   (fcbBfAdr :pointer)                          ;   File's buffer address  
   (fcbFlPos :unsigned-integer)                 ;   Directory block this file is in  
;   FCB Extensions for HFS  
   (fcbClmpSize :unsigned-long)                 ;   Number of bytes per clump  
   (fcbBTCBPtr :pointer)                        ;   Pointer to B*-Tree control block for file  
   (fcbExtRec :hfsextentrecord)                 ;   First 3 file extents  
   (fcbFType :ostype)                           ;   File's 4 Finder Type bytes  
   (fcbCatPos :unsigned-long)                   ;   Catalog hint for use on Close  
   (fcbDirID :unsigned-long)                    ;   Parent Directory ID  
   (fcbCName (:string 31))                      ;   CName of open file  
   )

(def-mactype :forkcontrolblockptr (find-mactype '(:pointer :forkcontrolblock)))
(defrecord ForkControlBlock 
   (fcbFlNm :unsigned-long)                     ;   FCB file number. Non-zero marks FCB used  
   (fcbFlags :signed-byte)                      ;   FCB flags  
   (fcbTypByt :signed-byte)                     ;   File type byte  
   (fcbSBlk :unsigned-integer)                  ;   File start block (in alloc size blks)  
   (fcbEOF :unsigned-long)                      ;   Logical length or EOF in bytes  
   (fcbPLen :unsigned-long)                     ;   Physical file length in bytes  
   (fcbCrPs :unsigned-long)                     ;   Current position within file  
   (fcbVPtr (:pointer :vcb))                    ;   Pointer to the corresponding VCB  
   (fcbBfAdr :pointer)                          ;   File's buffer address  
   (fcbFlPos :unsigned-integer)                 ;   Directory block this file is in  
;   FCB Extensions for HFS  
   (fcbClmpSize :unsigned-long)                 ;   Number of bytes per clump  
   (fcbBTCBPtr :pointer)                        ;   Pointer to B*-Tree control block for file  
   (fcbExtRec :hfsextentrecord)                 ;   First 3 file extents  
   (fcbFType :ostype)                           ;   File's 4 Finder Type bytes  
   (fcbCatPos :unsigned-long)                   ;   Catalog hint for use on Close  
   (fcbDirID :unsigned-long)                    ;   Parent Directory ID  
   (fcbCName (:string 31))                      ;   CName of open file  
;      New fields start here 
   (moreFlags :unsigned-integer)                ;   more flags, align following fields 
;      Old ExtendedFCB fields 
   (processID :processserialnumber)             ;   Process Mgr process that opened the file (used to clean up at process death). 
   (extents :hfsplusextentrecord)               ;   extents for HFS+ volumes 
;      New fields for HFS Plus APIs 
   (endOfFile :unsignedwide)                    ;   logical size of this fork 
   (physicalEOF :unsignedwide)                  ;   amount of space physically allocated to this fork 
   (currentPosition :unsignedwide)              ;   default offset for next read/write 
   (forkID :unsigned-long)
   (searchListPtr :pointer)                     ;   reserved for File Manager's use 
   (reserved1 (:array :unsigned-byte 8 :packed));   reserved 
   )

; 	
; 	 *  IteratorControlBlock - a ForkControlBlock used by a FSIterator
; 	 	
(def-mactype :iteratorcontrolblockptr (find-mactype '(:pointer :iteratorcontrolblock)))
(defrecord IteratorControlBlock 
   (containerID :unsigned-long)                 ;   directory ID of iterator's container 
   (flags :unsigned-integer)                    ;   reserved 
   (user1 (:array :unsigned-byte 14 :packed))   ;   14 bytes iterator's use 
   (VCBPtr (:pointer :vcb))                     ;   pointer to the iterator's VCB 
   (reserved2 :unsigned-long)                   ;   reserved 
   (user2 (:array :unsigned-byte 6 :packed))    ;   6 bytes for iterator's use 
   (reserved3 :unsigned-long)                   ;   reserved 
   (user3 (:array :unsigned-byte 12 :packed))   ;   12 bytes for iterator's use 
   (cbType :ostype)                             ;   must be 'fold' 
   (user4 (:array :unsigned-byte 40 :packed))   ;   40 bytes for iterator's use 
   (moreFlags :unsigned-integer)                ;   must be fcbIteratorMask 
   (processID :processserialnumber)             ;   Process Mgr process that opened the iterator (used to clean up at process death). 
   (user5 (:array :unsigned-byte 92 :packed))   ;   92 bytes for iterator's use 
   (searchListPtr :pointer)                     ;   reserved for File Manager's use 
   (reserved1 (:array :unsigned-byte 8 :packed));   reserved 
   )

; 	
; 	 *  HFS Component Interface records
; 	 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	Lg2PhysProcPtr = FUNCTION(fsdGlobalPtr: UNIV Ptr; volCtrlBlockPtr: VCBPtr; fileCtrlBlockPtr: FCBRecPtr; fileRefNum: INTEGER; filePosition: UInt32; reqCount: UInt32; VAR volOffset: UInt32; VAR contiguousBytes: UInt32): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :lg2physprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :lg2physupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :lg2physupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppLg2PhysProcInfo #x3FEFE0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewLg2PhysUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewLg2PhysProc 
(deftrap "_NewLg2PhysUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeLg2PhysUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeLg2PhysUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeLg2PhysUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallLg2PhysProc 
(deftrap-inline "_InvokeLg2PhysUPP" 
      ((fsdGlobalPtr :pointer) (volCtrlBlockPtr (:pointer :vcb)) (fileCtrlBlockPtr (:pointer :fcbrec)) (fileRefNum :signed-integer) (filePosition :unsigned-long) (reqCount :unsigned-long) (volOffset (:pointer :unsigned-long)) (contiguousBytes (:pointer :unsigned-long)) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	HFSCIProcPtr = FUNCTION(theVCB: VCBPtr; selectCode: INTEGER; paramBlock: UNIV Ptr; fsdGlobalPtr: UNIV Ptr; fsid: INTEGER): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :hfsciprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :hfsciupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :hfsciupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppHFSCIProcInfo #xBEE0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewHFSCIUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewHFSCIProc 
(deftrap "_NewHFSCIUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeHFSCIUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeHFSCIUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeHFSCIUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallHFSCIProc 
(deftrap-inline "_InvokeHFSCIUPP" 
      ((theVCB (:pointer :vcb)) (selectCode :signed-integer) (paramBlock :pointer) (fsdGlobalPtr :pointer) (fsid :signed-integer) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :hfscirecptr (find-mactype '(:pointer :hfscirec)))
(defrecord HFSCIRec 
   (compInterfMask :signed-long)                ;   component flags  
   (compInterfProc :pointer)                    ;   pointer to file system call processing code  
   (log2PhyProc :pointer)                       ;   pointer to Lg2PhysProc() code  
   (stackTop :pointer)                          ;   file system stack top  
   (stackSize :signed-long)                     ;   file system stack size  
   (stackPtr :pointer)                          ;   current file system stack pointer  
   ;;Changing field reserved3 from signed-long to unsigned-long to match C header (pretty-sure)
   (reserved3 :unsigned-long)                   ;   --reserved, must be zero--  
   (idSector :signed-long)                      ;   Sector you need to ID a local volume. For networked volumes, this must be -1  
   ;;Changing field reserved2 from signed-long to unsigned-long to match C header (pretty-sure)
   (reserved2 :unsigned-long)                   ;   --reserved, must be zero--  
   (reserved1 :signed-long)                     ;   --reserved, must be zero--  
   )

; 	
; 	 *  Disk Initialization Component Interface records
; 	 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DICIProcPtr = FUNCTION(whatFunction: INTEGER; paramBlock: UNIV Ptr; fsdGlobalPtr: UNIV Ptr): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :diciprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :diciupp (find-mactype ':pointer)) ;  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :diciupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppDICIProcInfo #xFA0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewDICIUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewDICIProc 
(deftrap "_NewDICIUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeDICIUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeDICIUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeDICIUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallDICIProc 
(deftrap-inline "_InvokeDICIUPP" 
      ((whatFunction :signed-integer) (paramBlock :pointer) (fsdGlobalPtr :pointer) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :dicirecptr (find-mactype '(:pointer :dicirec)))
(defrecord DICIRec 
   (compInterfMask :signed-long)                ;   component flags  
   (compInterfProc :pointer)                    ;   pointer to call processing code  
   (maxVolNameLength :signed-integer)           ;   maximum length of your volume name  
   (blockSize :unsigned-integer)                ;   your file system's block size  
   ;;Changing field reserved3 from signed-long to unsigned-long to match C header (pretty-sure)
   (reserved3 :unsigned-long)                   ;   --reserved, must be zero--  
   ;;Changing field reserved2 from signed-long to unsigned-long to match C header (pretty-sure)
   (reserved2 :unsigned-long)                   ;   --reserved, must be zero--  
   (reserved1 :signed-long)                     ;   --reserved, must be zero--  
   )

; 	
; 	 * FormatListRec as returned by the .Sony disk driver's
; 	 * Return Format List status call (csCode = 6).
; 	 * If the status call to get this list for a drive is not
; 	 * implemented by the driver, then a list with one entry
; 	 * is contructed from the drive queue element for the drive.
; 	 	
(def-mactype :formatlistrecptr (find-mactype '(:pointer :formatlistrec)))
(defrecord FormatListRec 
   (volSize :unsigned-long)                     ;   disk capacity in SECTORs  
   (formatFlags :signed-byte)                   ;   flags  
   (sectorsPerTrack :signed-byte)               ;   sectors per track side  
   (tracks :unsigned-integer)                   ;   number of tracks  
   )

; 	
; 	 * SizeListRec built from FormatListRecs as described above.
; 	 	
(def-mactype :sizelistrecptr (find-mactype '(:pointer :sizelistrec)))
(defrecord SizeListRec 
   (sizeListFlags :signed-integer)              ;   flags as set by external file system  
   (sizeEntry :formatlistrec)                   ;   disk driver format list record  
   )

; 	
; 	 * paramBlock for the diCIEvaluateSize call
; 	 	
(def-mactype :dicievaluatesizerecptr (find-mactype '(:pointer :dicievaluatesizerec)))
(defrecord DICIEvaluateSizeRec 
   (defaultSizeIndex :signed-integer)           ;   default size for this FS  
   (numSizeEntries :signed-integer)             ;   number of size entries  
   (driveNumber :signed-integer)                ;   drive number  
   (sizeListPtr (:pointer :sizelistrec))        ;   ptr to size entry table  
   (sectorSize :unsigned-integer)               ;   bytes per sector  
   )

; 	
; 	 * paramBlock for the diCIExtendedZero call
; 	 	
(def-mactype :diciextendedzerorecptr (find-mactype '(:pointer :diciextendedzerorec)))
(defrecord DICIExtendedZeroRec 
   (driveNumber :signed-integer)                ;   drive number  
   (volNamePtr (:pointer (:string 255)))        ;   ptr to volume name string  
   (fsid :signed-integer)                       ;   file system ID  
   (volTypeSelector :signed-integer)            ;   volume type selector, if supports more than 1 type  
   (numDefectBlocks :unsigned-integer)          ;   number of bad logical blocks  
   (defectListSize :unsigned-integer)           ;   size of the defect list buffer in bytes  
   (defectListPtr :pointer)                     ;   pointer to defect list buffer  
   (volSize :unsigned-long)                     ;   size of volume in SECTORs  
   (sectorSize :unsigned-integer)               ;   bytes per sector  
   (extendedInfoPtr :pointer)                   ;   ptr to extended info  
   )

; 	
; 	 * paramBlock for the diCIValidateVolName call
; 	 	
(def-mactype :dicivalidatevolnamerecptr (find-mactype '(:pointer :dicivalidatevolnamerec)))
(defrecord DICIValidateVolNameRec 
   (theChar :character)                         ;   the character to validate  
   (hasMessageBuffer :boolean)                  ;   false if no message  
   (charOffset :signed-integer)                 ;   position of the current character (first char = 1)  
   (messageBufferPtr (:pointer (:string 255)))  ;   pointer to message buffer or nil  
   (charByteType :signed-integer)               ;   theChar's byte type (smSingleByte, smFirstByte, or smLastByte)  
   )

; 	
; 	 * paramBlock for the diCIGetVolTypeInfo call
; 	 	
(def-mactype :dicigetvoltypeinforecptr (find-mactype '(:pointer :dicigetvoltypeinforec)))
(defrecord DICIGetVolTypeInfoRec 
   (volSize :unsigned-long)                     ;   size of volume in SECTORs  
   (sectorSize :unsigned-integer)               ;   bytes per sector  
   (numVolTypes :signed-integer)                ;   number of volume types supported  
   (volTypesBuffer (:array (:string 31) 4))     ;   4 string buffers  
   )

; 	
; 	 * paramBlock for the diCIGetFormatString call
; 	 	
(def-mactype :dicigetformatstringrecptr (find-mactype '(:pointer :dicigetformatstringrec)))
(defrecord DICIGetFormatStringRec 
   (volSize :unsigned-long)                     ;   volume size in SECTORs  
   (sectorSize :unsigned-integer)               ;   sector size  
   (volTypeSelector :signed-integer)            ;   volume type selector  
   (stringKind :signed-integer)                 ;   sub-function = type of string  
   (stringBuffer (:string 255))                 ;   string buffer  
   )

; 	
; 	 * paramBlock for the diCIGetExtendedFormatParams call
; 	 	
(def-mactype :dicigetextendedformatrecptr (find-mactype '(:pointer :dicigetextendedformatrec)))
(defrecord DICIGetExtendedFormatRec 
   (driveNumber :signed-integer)                ;   drive number  
   (volTypeSelector :signed-integer)            ;   volume type selector or 0  
   (volSize :unsigned-long)                     ;   size of volume in SECTORs  
   (sectorSize :unsigned-integer)               ;   bytes per sector  
   (fileSystemSpecPtr (:pointer :fsspec))       ;   pointer to the foreign file system's FSSpec  
   (extendedInfoPtr :pointer)                   ;   pointer to extended parameter structure  
   )

; 	
; 	 *  File System Manager records
; 	 	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	FSDCommProcPtr = FUNCTION(message: INTEGER; paramBlock: UNIV Ptr; globalsPtr: UNIV Ptr): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :fsdcommprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :fsdcommupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :fsdcommupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppFSDCommProcInfo #xFA0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewFSDCommUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewFSDCommProc 
(deftrap "_NewFSDCommUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeFSDCommUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeFSDCommUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeFSDCommUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallFSDCommProc 
(deftrap-inline "_InvokeFSDCommUPP" 
      ((message :signed-integer) (paramBlock :pointer) (globalsPtr :pointer) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :fsdrecptr (find-mactype '(:pointer :fsdrec)))
(defrecord FSDRec 
   (fsdLink (:pointer :fsdrec))                 ;   ptr to next  
   (fsdLength :signed-integer)                  ;   length of this FSD in BYTES  
   (fsdVersion :signed-integer)                 ;   version number  
   (fileSystemFSID :signed-integer)             ;   file system id  
   (fileSystemName (:string 31))                ;   file system name  
   (fileSystemSpec :fsspec)                     ;   foreign file system's FSSpec  
   (fileSystemGlobalsPtr :pointer)              ;   ptr to file system globals  
   (fileSystemCommProc :pointer)                ;   communication proc with the FFS  
   ;;Changing field reserved3 from signed-long to unsigned-long to match C header (pretty-sure)
   (reserved3 :unsigned-long)                   ;   --reserved, must be zero--  
   ;;Changing field reserved2 from signed-long to unsigned-long to match C header (pretty-sure)
   (reserved2 :unsigned-long)                   ;   --reserved, must be zero--  
   (reserved1 :signed-long)                     ;   --reserved, must be zero--  
   (fsdHFSCI :hfscirec)                         ;   HFS component interface     
   (fsdDICI :dicirec)                           ;   Disk Initialization component interface  
   )

(def-mactype :fsmgeticoninforecptr (find-mactype '(:pointer :fsmgeticoninforec)))
(defrecord FSMGetIconInfoRec 
   (theIcon (:array :signed-long 32))           ;   The ICN# structure  
   (theMask (:array :signed-long 32))           ;   The mask for the icon above  
   (whereStr (:string 255))
   )

; 	
; 	 * paramBlock for ffsGetIconMessage and fsmGetFSIconMessage
; 	 	
(def-mactype :fsmgeticonrecptr (find-mactype '(:pointer :fsmgeticonrec)))
(defrecord FSMGetIconRec 
   (refNum :signed-integer)                     ;   target drive num or volume refnum  
   (iconBufferPtr (:pointer :fsmgeticoninforec));   pointer to icon buffer  
   (requestSize :signed-long)                   ;   requested size of the icon buffer  
   (actualSize :signed-long)                    ;   actual size of the icon data returned  
   (iconType :signed-byte)                      ;   kind of icon. Note: A file system supporting kicnsIconFamily must  
;   return noErr, up to requestSize bytes of data, and the actual size  
;   of the 'icns' data in the actualSize field. If actualSize is greater  
;   than requestSize, the caller must resize the icon buffer and retry  
;   the request with the larger buffer and new requestSize.  
   (isEjectable :boolean)                       ;   true if the device is ejectable  
   (driveQElemPtr (:pointer :drvqel))           ;   pointer to DQE  
   (fileSystemSpecPtr (:pointer :fsspec))       ;   pointer to foreign file system's FSSpec  
   (reserved1 :signed-long)                     ;   --reserved, must be zero--  
   )

; 	
; 	 *  HFS Utility routine prototypes
; 	 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  UTAllocateFCB()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_UTAllocateFCB" 
      ((fileRefNum (:pointer :signed-integer)) (fileCtrlBlockPtr (:pointer (:pointer :fcbrec))))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 0 fileRefNum fileCtrlBlockPtr))

; 
;  *  UTReleaseFCB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTReleaseFCB" 
      ((fileRefNum :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 1 fileRefNum))

; 
;  *  UTLocateFCB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTLocateFCB" 
      ((volCtrlBlockPtr (:pointer :vcb)) (fileNum :unsigned-long) (namePtr (:pointer (:string 255))) (fileRefNum (:pointer :signed-integer)) (fileCtrlBlockPtr (:pointer (:pointer :fcbrec))))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 2 volCtrlBlockPtr fileNum namePtr fileRefNum fileCtrlBlockPtr))

; 
;  *  UTLocateNextFCB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTLocateNextFCB" 
      ((volCtrlBlockPtr (:pointer :vcb)) (fileNum :unsigned-long) (namePtr (:pointer (:string 255))) (fileRefNum (:pointer :signed-integer)) (fileCtrlBlockPtr (:pointer (:pointer :fcbrec))))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 3 volCtrlBlockPtr fileNum namePtr fileRefNum fileCtrlBlockPtr))

; 
;  *  UTIndexFCB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTIndexFCB" 
      ((volCtrlBlockPtr (:pointer :vcb)) (fileRefNum (:pointer :signed-integer)) (fileCtrlBlockPtr (:pointer (:pointer :fcbrec))))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 4 volCtrlBlockPtr fileRefNum fileCtrlBlockPtr))

; 
;  *  UTResolveFCB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTResolveFCB" 
      ((fileRefNum :signed-integer) (fileCtrlBlockPtr (:pointer (:pointer :fcbrec))))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 5 fileRefNum fileCtrlBlockPtr))

; 
;  *  UTAllocateVCB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTAllocateVCB" 
      ((sysVCBLength (:pointer :unsigned-integer)) (volCtrlBlockPtr (:pointer (:pointer :vcb))) (addSize :unsigned-integer))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 6 sysVCBLength volCtrlBlockPtr addSize))

; 
;  *  UTAddNewVCB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTAddNewVCB" 
      ((driveNum :signed-integer) (vRefNum (:pointer :signed-integer)) (volCtrlBlockPtr (:pointer :vcb)))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 7 driveNum vRefNum volCtrlBlockPtr))

; 
;  *  UTDisposeVCB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTDisposeVCB" 
      ((volCtrlBlockPtr (:pointer :vcb)))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 8 volCtrlBlockPtr))

; 
;  *  UTLocateVCBByRefNum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTLocateVCBByRefNum" 
      ((refNum :signed-integer) (vRefNum (:pointer :signed-integer)) (volCtrlBlockPtr (:pointer (:pointer :vcb))))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 9 refNum vRefNum volCtrlBlockPtr))

; 
;  *  UTLocateVCBByName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTLocateVCBByName" 
      ((namePtr (:pointer (:string 255))) (moreMatches (:pointer :signed-integer)) (vRefNum (:pointer :signed-integer)) (volCtrlBlockPtr (:pointer (:pointer :vcb))))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 10 namePtr moreMatches vRefNum volCtrlBlockPtr))

; 
;  *  UTLocateNextVCB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTLocateNextVCB" 
      ((namePtr (:pointer (:string 255))) (moreMatches (:pointer :signed-integer)) (vRefNum (:pointer :signed-integer)) (volCtrlBlockPtr (:pointer (:pointer :vcb))))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 11 namePtr moreMatches vRefNum volCtrlBlockPtr))

; 
;  *  UTAllocateWDCB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTAllocateWDCB" 
      ((paramBlock (:pointer :wdpbrec)))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 12 paramBlock))

; 
;  *  UTReleaseWDCB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTReleaseWDCB" 
      ((wdRefNum :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 13 wdRefNum))

; 
;  *  UTResolveWDCB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTResolveWDCB" 
      ((procID :signed-long) (wdIndex :signed-integer) (wdRefNum :signed-integer) (wdCtrlBlockPtr (:pointer (:pointer :wdcbrec))))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 14 procID wdIndex wdRefNum wdCtrlBlockPtr))

; 
;  *  UTFindDrive()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTFindDrive" 
      ((driveNum :signed-integer) (driveQElementPtr (:pointer (:pointer :drvqel))))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 15 driveNum driveQElementPtr))

; 
;  *  UTAdjustEOF()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTAdjustEOF" 
      ((fileRefNum :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 16 fileRefNum))

; 
;  *  UTSetDefaultVol()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTSetDefaultVol" 
      ((nodeHint :signed-long) (dirID :unsigned-long) (refNum :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 17 nodeHint dirID refNum))

; 
;  *  UTGetDefaultVol()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTGetDefaultVol" 
      ((paramBlock (:pointer :wdpbrec)))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 18 paramBlock))

; 
;  *  UTEjectVol()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTEjectVol" 
      ((volCtrlBlockPtr (:pointer :vcb)))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 43 volCtrlBlockPtr))

; 
;  *  UTCheckWDRefNum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTCheckWDRefNum" 
      ((wdRefNum :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 19 wdRefNum))

; 
;  *  UTCheckFileRefNum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTCheckFileRefNum" 
      ((fileRefNum :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 20 fileRefNum))

; 
;  *  UTCheckVolRefNum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTCheckVolRefNum" 
      ((vRefNum :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 21 vRefNum))

; 
;  *  UTCheckPermission()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTCheckPermission" 
      ((volCtrlBlockPtr (:pointer :vcb)) (modByte (:pointer :signed-integer)) (fileNum :unsigned-long) (paramBlock (:pointer :paramblockrec)))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 22 volCtrlBlockPtr modByte fileNum paramBlock))

; 
;  *  UTCheckVolOffline()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTCheckVolOffline" 
      ((vRefNum :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 23 vRefNum))

; 
;  *  UTCheckVolModifiable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTCheckVolModifiable" 
      ((vRefNum :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 24 vRefNum))

; 
;  *  UTCheckFileModifiable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTCheckFileModifiable" 
      ((fileRefNum :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 25 fileRefNum))

; 
;  *  UTCheckDirBusy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTCheckDirBusy" 
      ((volCtrlBlockPtr (:pointer :vcb)) (dirID :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 26 volCtrlBlockPtr dirID))

; 
;  *  UTParsePathname()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTParsePathname" 
      ((volNamelength (:pointer :signed-integer)) (namePtr (:pointer (:string 255))))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 27 volNamelength namePtr))

; 
;  *  UTGetPathComponentName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTGetPathComponentName" 
      ((parseRec (:pointer :parsepathrec)))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 28 parseRec))

; 
;  *  UTDetermineVol()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTDetermineVol" 
      ((paramBlock (:pointer :paramblockrec)) (status (:pointer :signed-integer)) (moreMatches (:pointer :signed-integer)) (vRefNum (:pointer :signed-integer)) (volCtrlBlockPtr (:pointer (:pointer :vcb))))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 29 paramBlock status moreMatches vRefNum volCtrlBlockPtr))

; 
;  *  UTGetBlock()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTGetBlock" 
      ((refNum :signed-integer) (log2PhyProc :pointer) (blockNum :unsigned-long) (gbOption :signed-integer) (buffer (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 31 refNum log2PhyProc blockNum gbOption buffer))

; 
;  *  UTReleaseBlock()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTReleaseBlock" 
      ((buffer :pointer) (rbOption :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 32 buffer rbOption))

; 
;  *  UTFlushCache()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTFlushCache" 
      ((refNum :signed-integer) (fcOption :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 33 refNum fcOption))

; 
;  *  UTMarkDirty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTMarkDirty" 
      ((buffer :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 35 buffer))

; 
;  *  UTTrashVolBlocks()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTTrashVolBlocks" 
      ((volCtrlBlockPtr (:pointer :vcb)))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 36 volCtrlBlockPtr))

; 
;  *  UTTrashFileBlocks()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTTrashFileBlocks" 
      ((volCtrlBlockPtr (:pointer :vcb)) (fileNum :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 37 volCtrlBlockPtr fileNum))

; 
;  *  UTTrashBlocks()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTTrashBlocks" 
      ((beginPosition :unsigned-long) (byteCount :unsigned-long) (volCtrlBlockPtr (:pointer :vcb)) (fileRefNum :signed-integer) (tbOption :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 38 beginPosition byteCount volCtrlBlockPtr fileRefNum tbOption))

; 
;  *  UTCacheReadIP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTCacheReadIP" 
      ((log2PhyProc :pointer) (filePosition :unsigned-long) (ioBuffer :pointer) (fileRefNum :signed-integer) (reqCount :unsigned-long) (actCount (:pointer :unsigned-long)) (cacheOption :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 39 log2PhyProc filePosition ioBuffer fileRefNum reqCount actCount cacheOption))

; 
;  *  UTCacheWriteIP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTCacheWriteIP" 
      ((log2PhyProc :pointer) (filePosition :unsigned-long) (ioBuffer :pointer) (fileRefNum :signed-integer) (reqCount :unsigned-long) (actCount (:pointer :unsigned-long)) (cacheOption :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 40 log2PhyProc filePosition ioBuffer fileRefNum reqCount actCount cacheOption))

; 
;  *  UTBlockInFQHashP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTBlockInFQHashP" 
      ((vRefNum :signed-integer) (diskBlock :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 44 vRefNum diskBlock))

; 
;  *  UTVolCacheReadIP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTVolCacheReadIP" 
      ((volCtrlBlockPtr (:pointer :vcb)) (blockPosition :unsigned-long) (ioBuffer :pointer) (reqCount :unsigned-long) (actCount (:pointer :unsigned-long)) (cacheOption :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 52 volCtrlBlockPtr blockPosition ioBuffer reqCount actCount cacheOption))

; 
;  *  UTVolCacheWriteIP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTVolCacheWriteIP" 
      ((volCtrlBlockPtr (:pointer :vcb)) (blockPosition :unsigned-long) (ioBuffer :pointer) (reqCount :unsigned-long) (actCount (:pointer :unsigned-long)) (cacheOption :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 53 volCtrlBlockPtr blockPosition ioBuffer reqCount actCount cacheOption))

; 
;  *  UTResolveFileRefNum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTResolveFileRefNum" 
      ((fileCtrlBlockPtr (:pointer :fcbrec)) (fileRefNum (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 54 fileCtrlBlockPtr fileRefNum))

; 
;  *  UTCheckFCB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTCheckFCB" 
      ((fileCtrlBlockPtr (:pointer :fcbrec)))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 55 fileCtrlBlockPtr))

; 
;  *  UTCheckForkPermissions()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTCheckForkPermissions" 
      ((volCtrlBlockPtr (:pointer :vcb)) (fileNum :unsigned-long) (forkID :unsigned-long) (fileLocked :boolean) (permissions :signed-byte) (useSearchList :boolean) (fcbFlags (:pointer :signed-byte)) (openForkRefNum (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 56 volCtrlBlockPtr fileNum forkID fileLocked permissions useSearchList fcbFlags openForkRefNum))

; 
;  *  UTAddFCBToSearchList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTAddFCBToSearchList" 
      ((fileCtrlBlockPtr (:pointer :fcbrec)))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 57 fileCtrlBlockPtr))

; 
;  *  UTRemoveFCBFromSearchList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTRemoveFCBFromSearchList" 
      ((fileCtrlBlockPtr (:pointer :fcbrec)))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 58 fileCtrlBlockPtr))

; 
;  *  UTLocateFCBInSearchList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTLocateFCBInSearchList" 
      ((volCtrlBlockPtr (:pointer :vcb)) (fileNum :unsigned-long) (fileRefNum (:pointer :signed-integer)) (fileCtrlBlockPtr (:pointer (:pointer :fcbrec))))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 59 volCtrlBlockPtr fileNum fileRefNum fileCtrlBlockPtr))

; 
;  *  UTGetForkControlBlockSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UTGetForkControlBlockSize" 
      ((fcbSize (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xA824 :d0 60 fcbSize))

; 
;  *  File System Manager call prototypes
;  
; 
;  *  InstallFS()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_InstallFS" 
      ((fsdPtr (:pointer :fsdrec)))
   (:d0 :signed-integer)
   (:register-trap #xA0AC :a0 fsdPtr :d0 0))

; 
;  *  RemoveFS()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_RemoveFS" 
      ((fsid :signed-integer)) 
  :signed-integer
   (#x305F #x7001 #xA0AC #x3E80) )

; 
;  *  GetFSInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  SetFSInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetFSInfo" 
      ((selector :signed-integer) (key :signed-integer) (bufSize (:pointer :signed-integer)) (fsdPtr (:pointer :fsdrec))) 
  :signed-integer
   () )                                         ; 
;  *  InformFSM()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SetFSInfo" 
      ((fsid :signed-integer) (bufSize :signed-integer) (fsdPtr (:pointer :fsdrec))) 
  :signed-integer
   () )                                         ; 
;  *  InformFFS()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InformFSM" 
      ((theMessage :signed-integer) (paramBlock :pointer)) 
  :signed-integer
   () )
(deftrap-inline "_InformFFS" 
      ((fsid :signed-integer) (paramBlock :pointer)) 
  :signed-integer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := FSMIncludes

; $ENDC                                         ; __FSM__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'FSM)