(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Fonts.p"
; at Wednesday May 1,2002 2:39:38 pm.
; 
;      File:       Fonts.p
;  
;      Contains:   Public interface to the Font Manager.
;  
;      Version:    Technology: Mac OS 9 / Carbon
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __FONTS__
; $SETC __FONTS__ := 1

; $I+
; $SETC FontsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __ATSTYPES__

(require-interface 'ATSTypes)                   ; $I ATSTypes.p
; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __TEXTCOMMON__
|#

(require-interface 'TextCommon)
#|                                              ; $I TextCommon.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $systemFont 0)
(defconstant $applFont 1)

(defconstant $kFMDefaultOptions 0)

; 	 Activation contexts 	
(defconstant $kFMDefaultActivationContext 0)
(defconstant $kFMGlobalActivationContext #x1)
(defconstant $kFMLocalActivationContext 0)

; 	 Iteration scopes 	
(defconstant $kFMDefaultIterationScope 0)
(defconstant $kFMGlobalIterationScope #x1)
(defconstant $kFMLocalIterationScope 0)

; 	 kPlatformDefaultGuiFontID is used in QuickTime 3.0. 	
; $IFC TARGET_OS_MAC 
(defconstant $kPlatformDefaultGuiFontID 1)

#|                                              ; $ELSEC
(defconstant $kPlatformDefaultGuiFontID -1)

 |#                                             ; $ENDC; TARGET_OS_MAC

(defconstant $commandMark 17)
(defconstant $checkMark 18)
(defconstant $diamondMark 19)
(defconstant $appleMark 20)

(defconstant $propFont 36864)
(defconstant $prpFntH 36865)
(defconstant $prpFntW 36866)
(defconstant $prpFntHW 36867)
(defconstant $fixedFont 45056)
(defconstant $fxdFntH 45057)
(defconstant $fxdFntW 45058)
(defconstant $fxdFntHW 45059)
(defconstant $fontWid 44208)

(def-mactype :fminputptr (find-mactype '(:pointer :fminput)))
(defrecord FMInput 
   (family :signed-integer)
   (size :signed-integer)
   (face :unsigned-byte)
   (needBits :boolean)
   (device :signed-integer)
   (numer :point)
   (denom :point)
   )

(def-mactype :fmoutputptr (find-mactype '(:pointer :fmoutput)))
(defrecord FMOutput 
   (errNum :signed-integer)
   (fontHandle :handle)
   (boldPixels :unsigned-byte)
   (italicPixels :unsigned-byte)
   (ulOffset :unsigned-byte)
   (ulShadow :unsigned-byte)
   (ulThick :unsigned-byte)
   (shadowPixels :unsigned-byte)
   (extra :signed-byte)
   (ascent :unsigned-byte)
   (descent :unsigned-byte)
   (widMax :unsigned-byte)
   (leading :signed-byte)
   (curStyle :signed-byte)
   (numer :point)
   (denom :point)
   )

(def-mactype :fmoutptr (find-mactype '(:pointer :fmoutput)))
(def-mactype :fmetricrecptr (find-mactype '(:pointer :fmetricrec)))
(defrecord FMetricRec 
   (ascent :signed-long)                        ;  base line to top 
   (descent :signed-long)                       ;  base line to bottom 
   (leading :signed-long)                       ;  leading between lines 
   (widMax :signed-long)                        ;  maximum character width 
   (wTabHandle :handle)                         ;  handle to font width table 
   )

(def-mactype :fmetricrechandle (find-mactype '(:handle :fmetricrec)))
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  InitFonts()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_InitFonts" 
      ()
   nil
   (:stack-trap #xA8FE))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  GetFontName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetFontName" 
      ((familyID :signed-integer) (name (:pointer (:string 255))))
   nil
   (:stack-trap #xA8FF))

; 
;  *  GetFNum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetFNum" 
      ((name (:string 255)) (familyID (:pointer :signed-integer)))
   nil
   (:stack-trap #xA900))

; 
;  *  RealFont()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_RealFont" 
      ((fontNum :signed-integer) (size :signed-integer))
   (:stack :boolean)
   (:stack-trap #xA902))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SetFontLock()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetFontLock" 
      ((lockFlag :boolean))
   nil
   (:stack-trap #xA903))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  FMSwapFont()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_FMSwapFont" 
      ((inRec (:pointer :fminput)))
   (:stack (:pointer :fmoutput))
   (:stack-trap #xA901))

; 
;  *  SetFScaleDisable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetFScaleDisable" 
      ((fscaleDisable :boolean))
   nil
   (:stack-trap #xA834))

; 
;  *  FontMetrics()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FontMetrics" 
      ((theMetrics (:pointer :fmetricrec)))
   nil
   (:stack-trap #xA835))

; 
;  *  SetFractEnable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetFractEnable" 
      ((fractEnable :boolean))
   nil
   (:stack-trap #xA814))

; 
;  *  GetDefFontSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetDefFontSize" 
      () 
  :signed-integer
   (#x3EB8 #xBA8 #x6604 #x3EBC #xC) )

; 
;  *  IsOutline()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_IsOutline" 
      ((numer :point) (denom :point))
   (:stack :boolean)
   (:stack-trap #xA854 :d0 0 numer denom))

; 
;  *  SetOutlinePreferred()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetOutlinePreferred" 
      ((outlinePreferred :boolean))
   nil
   (:stack-trap #xA854 :d0 1 outlinePreferred))

; 
;  *  GetOutlinePreferred()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetOutlinePreferred" 
      ()
   (:stack :boolean)
   (:stack-trap #xA854 :d0 9))

; 
;  *  OutlineMetrics()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OutlineMetrics" 
      ((byteCount :signed-integer) (textPtr :pointer) (numer :point) (denom :point) (yMax (:pointer :signed-integer)) (yMin (:pointer :signed-integer)) (awArray (:pointer :signed-long)) (lsbArray (:pointer :signed-long)) (boundsArray (:pointer :rect)))
   (:stack :signed-integer)
   (:stack-trap #xA854 :d0 8 byteCount textPtr numer denom yMax yMin awArray lsbArray boundsArray))

; 
;  *  SetPreserveGlyph()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetPreserveGlyph" 
      ((preserveGlyph :boolean))
   nil
   (:stack-trap #xA854 :d0 10 preserveGlyph))

; 
;  *  GetPreserveGlyph()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetPreserveGlyph" 
      ()
   (:stack :boolean)
   (:stack-trap #xA854 :d0 11))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  FlushFonts()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_FlushFonts" 
      ()
   (:stack :signed-integer)
   (:stack-trap #xA854 :d0 12))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  GetSysFont()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetSysFont" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2982))))

; 
;  *  GetAppFont()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetAppFont" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2436))))

; --------------------------------------------------------------------------------------
;   Extended font data functions (available only with Mac OS 8.5 or later)              
; --------------------------------------------------------------------------------------
; 
;  *  SetAntiAliasedTextEnabled()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetAntiAliasedTextEnabled" 
      ((iEnable :boolean) (iMinFontSize :signed-integer))
   (:stack :osstatus)
   (:stack-trap #xA854 :d0 17 iEnable iMinFontSize))

; 
;  *  IsAntiAliasedTextEnabled()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_IsAntiAliasedTextEnabled" 
      ((oMinFontSize (:pointer :signed-integer)))
   (:stack :boolean)
   (:stack-trap #xA854 :d0 18 oMinFontSize))

; 
;  *  QDTextBounds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_QDTextBounds" 
      ((byteCount :signed-integer) (textAddr :pointer) (bounds (:pointer :rect)))
   nil
   (:stack-trap #xA854 :d0 19 byteCount textAddr bounds))

; 
;  *  FetchFontInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FetchFontInfo" 
      ((fontID :signed-integer) (fontSize :signed-integer) (fontStyle :signed-integer) (info (:pointer :fontinfo)))
   (:stack :signed-integer)
   (:stack-trap #xA854 :d0 20 fontID fontSize fontStyle info))

; --------------------------------------------------------------------------------------
;   Font access and data management functions (available only with Mac OS 9.0 or later) 
; --------------------------------------------------------------------------------------
;  Enumeration 
; 
;  *  FMCreateFontFamilyIterator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const
(deftrap-inline "_FMCreateFontFamilyIterator" 
      ((iFilter (:pointer :fmfilter)) (iRefCon :pointer) (iOptions :unsigned-long) (ioIterator (:pointer :fmfontfamilyiterator))) 
  :osstatus
   () )

; 
;  *  FMDisposeFontFamilyIterator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FMDisposeFontFamilyIterator" 
      ((ioIterator (:pointer :fmfontfamilyiterator))) 
  :osstatus
   () )

; 
;  *  FMResetFontFamilyIterator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const
(deftrap-inline "_FMResetFontFamilyIterator" 
      ((iFilter (:pointer :fmfilter)) (iRefCon :pointer) (iOptions :unsigned-long) (ioIterator (:pointer :fmfontfamilyiterator))) 
  :osstatus
   () )

; 
;  *  FMGetNextFontFamily()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FMGetNextFontFamily" 
      ((ioIterator (:pointer :fmfontfamilyiterator)) (oFontFamily (:pointer :signed-integer))) 
  :osstatus
   () )

; 
;  *  FMCreateFontIterator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const
(deftrap-inline "_FMCreateFontIterator" 
      ((iFilter (:pointer :fmfilter)) (iRefCon :pointer) (iOptions :unsigned-long) (ioIterator (:pointer :fmfontiterator))) 
  :osstatus
   () )

; 
;  *  FMDisposeFontIterator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FMDisposeFontIterator" 
      ((ioIterator (:pointer :fmfontiterator))) 
  :osstatus
   () )

; 
;  *  FMResetFontIterator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const
(deftrap-inline "_FMResetFontIterator" 
      ((iFilter (:pointer :fmfilter)) (iRefCon :pointer) (iOptions :unsigned-long) (ioIterator (:pointer :fmfontiterator))) 
  :osstatus
   () )

; 
;  *  FMGetNextFont()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FMGetNextFont" 
      ((ioIterator (:pointer :fmfontiterator)) (oFont (:pointer :unsigned-long))) 
  :osstatus
   () )

;  Font families 
; 
;  *  FMCreateFontFamilyInstanceIterator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FMCreateFontFamilyInstanceIterator" 
      ((iFontFamily :signed-integer) (ioIterator (:pointer :fmfontfamilyinstanceiterator))) 
  :osstatus
   () )

; 
;  *  FMDisposeFontFamilyInstanceIterator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FMDisposeFontFamilyInstanceIterator" 
      ((ioIterator (:pointer :fmfontfamilyinstanceiterator))) 
  :osstatus
   () )

; 
;  *  FMResetFontFamilyInstanceIterator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FMResetFontFamilyInstanceIterator" 
      ((iFontFamily :signed-integer) (ioIterator (:pointer :fmfontfamilyinstanceiterator))) 
  :osstatus
   () )

; 
;  *  FMGetNextFontFamilyInstance()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FMGetNextFontFamilyInstance" 
      ((ioIterator (:pointer :fmfontfamilyinstanceiterator)) (oFont (:pointer :unsigned-long)) (oStyle (:pointer :signed-integer)) (oSize (:pointer :signed-integer))) 
  :osstatus
   () )

; 
;  *  FMGetFontFamilyFromName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FMGetFontFamilyFromName" 
      ((iName (:string 255))) 
  :fmfontfamily
   () )

; 
;  *  FMGetFontFamilyName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FMGetFontFamilyName" 
      ((iFontFamily :signed-integer) (oName (:pointer (:string 255)))) 
  :osstatus
   () )

; 
;  *  FMGetFontFamilyTextEncoding()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FMGetFontFamilyTextEncoding" 
      ((iFontFamily :signed-integer) (oTextEncoding (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  FMGetFontFamilyGeneration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FMGetFontFamilyGeneration" 
      ((iFontFamily :signed-integer) (oGeneration (:pointer :unsigned-long))) 
  :osstatus
   () )

;  Fonts 
; 
;  *  FMGetFontFormat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FMGetFontFormat" 
      ((iFont :unsigned-long) (oFormat (:pointer :ostype))) 
  :osstatus
   () )

; 
;  *  FMGetFontTableDirectory()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FMGetFontTableDirectory" 
      ((iFont :unsigned-long) (iLength :unsigned-long) (iBuffer :pointer) (oActualLength (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  FMGetFontTable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FMGetFontTable" 
      ((iFont :unsigned-long) (iTag :ostype) (iOffset :unsigned-long) (iLength :unsigned-long) (iBuffer :pointer) (oActualLength (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  FMGetFontGeneration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FMGetFontGeneration" 
      ((iFont :unsigned-long) (oGeneration (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  FMGetFontContainer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FMGetFontContainer" 
      ((iFont :unsigned-long) (oFontContainer (:pointer :fsspec))) 
  :osstatus
   () )

;  Conversion 
; 
;  *  FMGetFontFromFontFamilyInstance()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FMGetFontFromFontFamilyInstance" 
      ((iFontFamily :signed-integer) (iStyle :signed-integer) (oFont (:pointer :unsigned-long)) (oIntrinsicStyle (:pointer :signed-integer))) 
  :osstatus
   () )

; 
;  *  FMGetFontFamilyInstanceFromFont()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FMGetFontFamilyInstanceFromFont" 
      ((iFont :unsigned-long) (oFontFamily (:pointer :signed-integer)) (oStyle (:pointer :signed-integer))) 
  :osstatus
   () )

; 
;  *  FMGetATSFontRefFromFont()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.1 and later
;  *    Mac OS X:         in version 10.1 and later
;  

(deftrap-inline "_FMGetATSFontRefFromFont" 
      ((iFont :unsigned-long)) 
  :unsigned-long
   () )

; 
;  *  FMGetATSFontFamilyRefFromFontFamily()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.1 and later
;  *    Mac OS X:         in version 10.1 and later
;  

(deftrap-inline "_FMGetATSFontFamilyRefFromFontFamily" 
      ((iFamily :signed-integer)) 
  :unsigned-long
   () )

; 
;  *  FMGetFontFromATSFontRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.1 and later
;  *    Mac OS X:         in version 10.1 and later
;  

(deftrap-inline "_FMGetFontFromATSFontRef" 
      ((iFont :unsigned-long)) 
  :unsigned-long
   () )

; 
;  *  FMGetFontFamilyFromATSFontFamilyRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.1 and later
;  *    Mac OS X:         in version 10.1 and later
;  

(deftrap-inline "_FMGetFontFamilyFromATSFontFamilyRef" 
      ((iFamily :unsigned-long)) 
  :fmfontfamily
   () )

;  Activation 
; 
;  *  FMActivateFonts()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; Const
(deftrap-inline "_FMActivateFonts" 
      ((iFontContainer (:pointer :fsspec)) (iFilter (:pointer :fmfilter)) (iRefCon :pointer) (iOptions :unsigned-long)) 
  :osstatus
   () )

; 
;  *  FMDeactivateFonts()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; Const
(deftrap-inline "_FMDeactivateFonts" 
      ((iFontContainer (:pointer :fsspec)) (iFilter (:pointer :fmfilter)) (iRefCon :pointer) (iOptions :unsigned-long)) 
  :osstatus
   () )

; 
;  *  FMGetGeneration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in FontManager 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FMGetGeneration" 
      () 
  :unsigned-long
   () )

;  Container Access 
; 
;  *  FMGetFontContainerFromFontFamilyInstance()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.1 and later
;  

(deftrap-inline "_FMGetFontContainerFromFontFamilyInstance" 
      ((iFontFamily :signed-integer) (iStyle :signed-integer) (iFontSize :signed-integer) (oFontContainer (:pointer :fsspec))) 
  :osstatus
   () )

; 
;  *  FMGetFontFamilyResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.1 and later
;  

(deftrap-inline "_FMGetFontFamilyResource" 
      ((iFontFamily :signed-integer) (iFontStyle :signed-integer) (iFontSize :signed-integer) (iBufferSize :unsigned-long) (ioBuffer :pointer) (oSize (:pointer :unsigned-long))) 
  :osstatus
   () )

(def-mactype :fontfamilyid (find-mactype ':signed-integer))
(def-mactype :fontpointsize (find-mactype ':signed-integer))
; 	--------------------------------------------------------------------------------------	
; 	 Deprecated constant and type definitions                                             	
; 	--------------------------------------------------------------------------------------	
; 	 The font identifier constants are deprecated; use GetFNum or FMGetFontFamilyFromName
; 	   to find a font family from a standard QuickDraw name.
; 		

(defconstant $kFMUseGlobalScopeOption #x1)

(defconstant $kFontIDNewYork 2)
(defconstant $kFontIDGeneva 3)
(defconstant $kFontIDMonaco 4)
(defconstant $kFontIDVenice 5)
(defconstant $kFontIDLondon 6)
(defconstant $kFontIDAthens 7)
(defconstant $kFontIDSanFrancisco 8)
(defconstant $kFontIDToronto 9)
(defconstant $kFontIDCairo 11)
(defconstant $kFontIDLosAngeles 12)
(defconstant $kFontIDTimes 20)
(defconstant $kFontIDHelvetica 21)
(defconstant $kFontIDCourier 22)
(defconstant $kFontIDSymbol 23)
(defconstant $kFontIDMobile 24)

; 	 The following data structures referenced by the low memory global variables of the
; 	   Font Manager are deprecated on Mac OS X and CarbonLib 1.1. The low memory global
; 	   variables are not shared between processes and may result in inconsistencies
; 	   compared to previous releases of the system software. Changes made to the
; 	   information contained in the low memory global variables, including any
; 	   indirectly referenced width tables, font family records, and font records, are
; 	   not reflected in the global state of the Font Manager and may only be accessed
; 	   through the font access and data management functions of the Font Manager or ATS.
; 		

(def-mactype :widentryptr (find-mactype '(:pointer :widentry)))
(defrecord WidEntry 
   (widStyle :signed-integer)                   ;  style entry applies to 
   )

(def-mactype :widtableptr (find-mactype '(:pointer :widtable)))
(defrecord WidTable 
   (numWidths :signed-integer)                  ;  number of entries - 1 
   )

(def-mactype :asscentryptr (find-mactype '(:pointer :asscentry)))
(defrecord AsscEntry 
   (fontSize :signed-integer)
   (fontStyle :signed-integer)
   (fontID :signed-integer)                     ;  font resource ID 
   )

(def-mactype :fontassocptr (find-mactype '(:pointer :fontassoc)))
(defrecord FontAssoc 
   (numAssoc :signed-integer)                   ;  number of entries - 1 
   )

(def-mactype :styletableptr (find-mactype '(:pointer :styletable)))
(defrecord StyleTable 
   (fontClass :signed-integer)
   (offset :signed-long)
   (reserved :signed-long)
   (indexes (:array :character 48 :packed))
   )

(def-mactype :nametableptr (find-mactype '(:pointer :nametable)))
(defrecord NameTable 
   (stringCount :signed-integer)
   (baseFontName (:string 255))
   )

(def-mactype :kernpairptr (find-mactype '(:pointer :kernpair)))
(defrecord KernPair 
   (kernFirst :signed-byte)                     ;  1st character of kerned pair 
   (kernSecond :signed-byte)                    ;  2nd character of kerned pair 
   (kernWidth :signed-integer)                  ;  kerning in 1pt fixed format 
   )

(def-mactype :kernentryptr (find-mactype '(:pointer :kernentry)))
(defrecord KernEntry 
   (kernStyle :signed-integer)                  ;  style the entry applies to 
   (kernLength :signed-integer)                 ;  length of this entry 
   )

(def-mactype :kerntableptr (find-mactype '(:pointer :kerntable)))
(defrecord KernTable 
   (numKerns :signed-integer)                   ;  number of kerning entries 
   )

(def-mactype :widthtableptr (find-mactype '(:pointer :widthtable)))
(defrecord WidthTable 
   (tabData (:array :signed-long 256))          ;  character widths 
   (tabFont :handle)                            ;  font record used to build table 
   (sExtra :signed-long)                        ;  space extra used for table 
   (style :signed-long)                         ;  extra due to style 
   (fID :signed-integer)                        ;  font family ID 
   (fSize :signed-integer)                      ;  font size request 
   (face :signed-integer)                       ;  style (face) request 
   (device :signed-integer)                     ;  device requested 
   (inNumer :point)                             ;  scale factors requested 
   (inDenom :point)                             ;  scale factors requested 
   (aFID :signed-integer)                       ;  actual font family ID for table 
   (fHand :handle)                              ;  family record used to build up table 
   (usedFam :boolean)                           ;  used fixed point family widths 
   (aFace :unsigned-byte)                       ;  actual face produced 
   (vOutput :signed-integer)                    ;  vertical scale output value 
   (hOutput :signed-integer)                    ;  horizontal scale output value 
   (vFactor :signed-integer)                    ;  vertical scale output value 
   (hFactor :signed-integer)                    ;  horizontal scale output value 
   (aSize :signed-integer)                      ;  actual size of actual font used 
   (tabSize :signed-integer)                    ;  total size of table 
   )

(def-mactype :widthtablehdl (find-mactype '(:handle :widthtable)))
(def-mactype :famrecptr (find-mactype '(:pointer :famrec)))
(defrecord FamRec 
   (ffFlags :signed-integer)                    ;  flags for family 
   (ffFamID :signed-integer)                    ;  family ID number 
   (ffFirstChar :signed-integer)                ;  ASCII code of 1st character 
   (ffLastChar :signed-integer)                 ;  ASCII code of last character 
   (ffAscent :signed-integer)                   ;  maximum ascent for 1pt font 
   (ffDescent :signed-integer)                  ;  maximum descent for 1pt font 
   (ffLeading :signed-integer)                  ;  maximum leading for 1pt font 
   (ffWidMax :signed-integer)                   ;  maximum widMax for 1pt font 
   (ffWTabOff :signed-long)                     ;  offset to width table 
   (ffKernOff :signed-long)                     ;  offset to kerning table 
   (ffStylOff :signed-long)                     ;  offset to style mapping table 
   (ffProperty (:array :signed-integer 9))      ;  style property info 
   (ffIntl (:array :signed-integer 2))          ;  for international use 
   (ffVersion :signed-integer)                  ;  version number 
   )

(def-mactype :fontrecptr (find-mactype '(:pointer :fontrec)))
(defrecord FontRec 
   (fontType :signed-integer)                   ;  font type 
   (firstChar :signed-integer)                  ;  ASCII code of first character 
   (lastChar :signed-integer)                   ;  ASCII code of last character 
   (widMax :signed-integer)                     ;  maximum character width 
   (kernMax :signed-integer)                    ;  negative of maximum character kern 
   (nDescent :signed-integer)                   ;  negative of descent 
   (fRectWidth :signed-integer)                 ;  width of font rectangle 
   (fRectHeight :signed-integer)                ;  height of font rectangle 
   (owTLoc :unsigned-integer)                   ;  offset to offset/width table 
   (ascent :signed-integer)                     ;  ascent 
   (descent :signed-integer)                    ;  descent 
   (leading :signed-integer)                    ;  leading 
   (rowWords :signed-integer)                   ;  row width of bit image / 2  
   )

(def-mactype :fontrechdl (find-mactype '(:handle :fontrec)))
; 	--------------------------------------------------------------------------------------	
; $IFC OLDROUTINENAMES 

(defconstant $newYork 2)
(defconstant $geneva 3)
(defconstant $monaco 4)
(defconstant $venice 5)
(defconstant $london 6)
(defconstant $athens 7)
(defconstant $sanFran 8)
(defconstant $toronto 9)
(defconstant $cairo 11)
(defconstant $losAngeles 12)
(defconstant $times 20)
(defconstant $helvetica 21)
(defconstant $courier 22)
(defconstant $symbol 23)
(defconstant $mobile 24)

; $ENDC                                         ; OLDROUTINENAMES

; --------------------------------------------------------------------------------------
; $ALIGN RESET
; $POP

; $SETC UsingIncludes := FontsIncludes

; $ENDC                                         ; __FONTS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Fonts)