(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:HyperXCmd.p"
; at Wednesday May 1,2002 2:41:40 pm.
; 
;      File:       HyperXCmd.p
;  
;      Contains:   Interfaces for HyperCard XCMD's
;  
;      Version:    Technology: HyperCard 2.3
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1987-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __HYPERXCMD__
; $SETC __HYPERXCMD__ := 1

; $I+
; $SETC HyperXCmdIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FP__
|#

(require-interface 'fp)
#|                                              ; $I fp.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __EVENTS__
|#

(require-interface 'Events)
#|                                              ; $I Events.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __TEXTEDIT__
|#

(require-interface 'TextEdit)
#|                                              ; $I TextEdit.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MENUS__
|#

(require-interface 'Menus)
#|                                              ; $I Menus.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __STANDARDFILE__
|#

(require-interface 'StandardFile)
#|                                              ; $I StandardFile.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  result codes 

(defconstant $xresSucc 0)
(defconstant $xresFail 1)
(defconstant $xresNotImp 2)

; 	 XCMDBlock constants for event.what... 	
(defconstant $xOpenEvt 1000)                    ;   the first event after you are created  
(defconstant $xCloseEvt 1001)                   ;   your window is being forced close (Quit?)  
(defconstant $xGiveUpEditEvt 1002)              ;   you are losing Edit...  
(defconstant $xGiveUpSoundEvt 1003)             ;   you are losing the sound channel...  
(defconstant $xHidePalettesEvt 1004)            ;   someone called HideHCPalettes  
(defconstant $xShowPalettesEvt 1005)            ;   someone called ShowHCPalettes  
(defconstant $xEditUndo 1100)                   ;   EditUndo  
(defconstant $xEditCut 1102)                    ;   EditCut  
(defconstant $xEditCopy 1103)                   ;   EditCopy  
(defconstant $xEditPaste 1104)                  ;   EditPaste  
(defconstant $xEditClear 1105)                  ;   EditClear  
(defconstant $xSendEvt 1200)                    ;   script has sent you a message (text)  
(defconstant $xSetPropEvt 1201)                 ;   set a window property  
(defconstant $xGetPropEvt 1202)                 ;   get a window property  
(defconstant $xCursorWithin 1300)               ;   cursor is within the window  
(defconstant $xMenuEvt 1400)                    ;   user has selected an item in your menu  
(defconstant $xMBarClickedEvt 1401)             ;   a menu is about to be shown--update if needed  
(defconstant $xShowWatchInfoEvt 1501)           ;   for variable and message watchers  
(defconstant $xScriptErrorEvt 1502)             ;   place the insertion point  
(defconstant $xDebugErrorEvt 1503)              ;   user clicked "Debug" at a complaint  
(defconstant $xDebugStepEvt 1504)               ;   hilite the line  
(defconstant $xDebugTraceEvt 1505)              ;   same as step but tracing  
(defconstant $xDebugFinishedEvt 1506)           ;   script ended  

(defconstant $paletteProc 2048)                 ;   Windoid with grow box  
(defconstant $palNoGrowProc 2052)               ;   standard Windoid defproc  
(defconstant $palZoomProc 2056)                 ;   Windoid with zoom and grow  
(defconstant $palZoomNoGrow 2060)               ;   Windoid with zoom and no grow  

(defconstant $hasZoom 8)
(defconstant $hasTallTBar 2)
(defconstant $toggleHilite 1)

; 	 paramCount is set to these constants when first calling special XThings 	
(defconstant $xMessageWatcherID -2)
(defconstant $xVariableWatcherID -3)
(defconstant $xScriptEditorID -4)
(defconstant $xDebuggerID -5)

; 	 XTalkObjectPtr->objectKind values 	
(defconstant $stackObj 1)
(defconstant $bkgndObj 2)
(defconstant $cardObj 3)
(defconstant $fieldObj 4)
(defconstant $buttonObj 5)

; 	 selectors for ShowHCAlert's dialogs (shown as buttonID:buttonText) 	
(defconstant $errorDlgID 1)                     ;   1:OK (default)  
(defconstant $confirmDlgID 2)                   ;   1:OK (default) and 2:Cancel  
(defconstant $confirmDelDlgID 3)                ;   1:Cancel (default) and 2:Delete  
(defconstant $yesNoCancelDlgID 4)               ;   1:Yes (default), 2:Cancel, and 3:No  

; 	 type definitions 	

(def-mactype :xcmdblockptr (find-mactype '(:pointer :xcmdblock)))
(defrecord XCmdBlock 
   (paramCount :signed-integer)                 ;   If = -1 then new use for XWindoids  
   (params (:array :handle 16))
   (returnValue :handle)
   (passFlag :boolean)
   (filler1 :signed-byte)
   (entryPoint :pointer)                        ;   to call back to HyperCard  
   (request :signed-integer)
   (result :signed-integer)
   (inArgs (:array :signed-long 8))
   (outArgs (:array :signed-long 4))
   )

(def-mactype :xcmdptr (find-mactype '(:pointer :xcmdblock)))

(def-mactype :xweventinfoptr (find-mactype '(:pointer :xweventinfo)))
(defrecord XWEventInfo 
   (event :eventrecord)
   (eventWindow (:pointer :windowrecord))
   (eventParams (:array :signed-long 9))
   (eventResult :handle)
   )

(def-mactype :xtalkobjectptr (find-mactype '(:pointer :xtalkobject)))
(defrecord XTalkObject 
   (objectKind :signed-integer)                 ;   stack, bkgnd, card, field, or button  
   (stackNum :signed-long)                      ;   reference number of the source stack  
   (bkgndID :signed-long)
   (cardID :signed-long)
   (buttonID :signed-long)
   (fieldID :signed-long)
   )

; 	 maximum number of checkpoints in a script 	

(defconstant $maxCachedChecks 16)

(def-mactype :checkptsptr (find-mactype '(:pointer :checkpts)))
(defrecord CheckPts 
   (checks (:array :signed-integer 16))
   )

(def-mactype :checkptptr (find-mactype '(:pointer :checkpts)))
(def-mactype :checkpthandle (find-mactype '(:handle :checkpts)))
; 	
; 	        HyperTalk Utilities  
; 		
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  EvalExpr()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in HyperXLib 1.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; 
;  *  SendCardMessage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_EvalExpr" 
      ((paramPtr (:pointer :xcmdblock)) (expr (:string 255))) 
  :handle
   () )                                         ; 
;  *  SendHCMessage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SendCardMessage" 
      ((paramPtr (:pointer :xcmdblock)) (msg (:string 255))) 
  nil
   () )                                         ; 
;  *  RunHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SendHCMessage" 
      ((paramPtr (:pointer :xcmdblock)) (msg (:string 255))) 
  nil
   () )                                         ; 
;         Memory Utilities  
;                                               ; 
;  *  GetGlobal()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_RunHandler" 
      ((paramPtr (:pointer :xcmdblock)) (handler :handle)) 
  nil
   () )                                         ; 
;  *  SetGlobal()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetGlobal" 
      ((paramPtr (:pointer :xcmdblock)) (globName (:string 255))) 
  :handle
   () )                                         ; 
;  *  ZeroBytes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SetGlobal" 
      ((paramPtr (:pointer :xcmdblock)) (globName (:string 255)) (globValue :handle)) 
  nil
   () )                                         ; 
;         String Utilities  
;                                               ; 
;  *  ScanToReturn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ZeroBytes" 
      ((paramPtr (:pointer :xcmdblock)) (dstPtr :pointer) (longCount :signed-long)) 
  nil
   () )                                         ; 
;  *  ScanToZero()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ScanToReturn" 
      ((paramPtr (:pointer :xcmdblock)) (scanPtr (:pointer :pointer))) 
  nil
   () )                                         ; 
;  *  StringEqual()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ScanToZero" 
      ((paramPtr (:pointer :xcmdblock)) (scanPtr (:pointer :pointer))) 
  nil
   () )                                         ; 
;  *  StringLength()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_StringEqual" 
      ((paramPtr (:pointer :xcmdblock)) (str1 (:string 255)) (str2 (:string 255))) 
  :boolean
   () )                                         ; 
;  *  StringMatch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_StringLength" 
      ((paramPtr (:pointer :xcmdblock)) (strPtr :pointer)) 
  :signed-long
   () )                                         ; 
;  *  ZeroTermHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_StringMatch" 
      ((paramPtr (:pointer :xcmdblock)) (pattern (:string 255)) (target :pointer)) 
  :pointer
   () )                                         ; 
;         String Conversions  
;                                               ; 
;  *  BoolToStr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ZeroTermHandle" 
      ((paramPtr (:pointer :xcmdblock)) (hndl :handle)) 
  nil
   () )                                         ; 
;  *  Double_tToStr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_BoolToStr" 
      ((paramPtr (:pointer :xcmdblock)) (value :boolean) (str (:pointer (:string 255)))) 
  nil
   () )                                         ; 
;  *  LongToStr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_Double_tToStr" 
      ((paramPtr (:pointer :xcmdblock)) (num :double-float) (str (:pointer (:string 255)))) 
  nil
   () )                                         ; 
;  *  NumToHex()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LongToStr" 
      ((paramPtr (:pointer :xcmdblock)) (posNum :signed-long) (str (:pointer (:string 255)))) 
  nil
   () )                                         ; 
;  *  NumToStr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_NumToHex" 
      ((paramPtr (:pointer :xcmdblock)) (num :signed-long) (nDigits :signed-integer) (str (:pointer (:string 255)))) 
  nil
   () )                                         ; 
;  *  PasToZero()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_NumToStr" 
      ((paramPtr (:pointer :xcmdblock)) (num :signed-long) (str (:pointer (:string 255)))) 
  nil
   () )                                         ; 
;  *  PointToStr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PasToZero" 
      ((paramPtr (:pointer :xcmdblock)) (str (:string 255))) 
  :handle
   () )                                         ; 
;  *  RectToStr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PointToStr" 
      ((paramPtr (:pointer :xcmdblock)) (pt :point) (str (:pointer (:string 255)))) 
  nil
   () )                                         ; CONST; 
;  *  ReturnToPas()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_RectToStr" 
      ((paramPtr (:pointer :xcmdblock)) (rct (:pointer :rect)) (str (:pointer (:string 255)))) 
  nil
   () )                                         ; 
;  *  StrToBool()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ReturnToPas" 
      ((paramPtr (:pointer :xcmdblock)) (zeroStr :pointer) (pasStr (:pointer (:string 255)))) 
  nil
   () )                                         ; 
;  *  StrToDouble_t()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_StrToBool" 
      ((paramPtr (:pointer :xcmdblock)) (str (:string 255))) 
  :boolean
   () )                                         ; 
;  *  StrToLong()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_StrToDouble_t" 
      ((paramPtr (:pointer :xcmdblock)) (str (:string 255))) 
  :double-float
   () )                                         ; 
;  *  StrToNum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_StrToLong" 
      ((paramPtr (:pointer :xcmdblock)) (str (:string 255))) 
  :signed-long
   () )                                         ; 
;  *  StrToPoint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_StrToNum" 
      ((paramPtr (:pointer :xcmdblock)) (str (:string 255))) 
  :signed-long
   () )                                         ; 
;  *  StrToRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_StrToPoint" 
      ((paramPtr (:pointer :xcmdblock)) (str (:string 255)) (pt (:pointer :point))) 
  nil
   () )                                         ; 
;  *  ZeroToPas()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_StrToRect" 
      ((paramPtr (:pointer :xcmdblock)) (str (:string 255)) (rct (:pointer :rect))) 
  nil
   () )                                         ; 
;         Field Utilities  
;                                               ; 
;  *  GetFieldByID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ZeroToPas" 
      ((paramPtr (:pointer :xcmdblock)) (zeroStr :pointer) (pasStr (:pointer (:string 255)))) 
  nil
   () )                                         ; 
;  *  GetFieldByName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetFieldByID" 
      ((paramPtr (:pointer :xcmdblock)) (cardFieldFlag :boolean) (fieldID :signed-integer)) 
  :handle
   () )                                         ; 
;  *  GetFieldByNum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetFieldByName" 
      ((paramPtr (:pointer :xcmdblock)) (cardFieldFlag :boolean) (fieldName (:string 255))) 
  :handle
   () )                                         ; 
;  *  SetFieldByID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetFieldByNum" 
      ((paramPtr (:pointer :xcmdblock)) (cardFieldFlag :boolean) (fieldNum :signed-integer)) 
  :handle
   () )                                         ; 
;  *  SetFieldByName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SetFieldByID" 
      ((paramPtr (:pointer :xcmdblock)) (cardFieldFlag :boolean) (fieldID :signed-integer) (fieldVal :handle)) 
  nil
   () )                                         ; 
;  *  SetFieldByNum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SetFieldByName" 
      ((paramPtr (:pointer :xcmdblock)) (cardFieldFlag :boolean) (fieldName (:string 255)) (fieldVal :handle)) 
  nil
   () )                                         ; 
;  *  GetFieldTE()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SetFieldByNum" 
      ((paramPtr (:pointer :xcmdblock)) (cardFieldFlag :boolean) (fieldNum :signed-integer) (fieldVal :handle)) 
  nil
   () )                                         ; 
;  *  SetFieldTE()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetFieldTE" 
      ((paramPtr (:pointer :xcmdblock)) (cardFieldFlag :boolean) (fieldID :signed-integer) (fieldNum :signed-integer) (fieldName (:string 255))) 
  (:handle :terec)
   () )                                         ; 
;         Miscellaneous Utilities  
;                                               ; 
;  *  BeginXSound()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SetFieldTE" 
      ((paramPtr (:pointer :xcmdblock)) (cardFieldFlag :boolean) (fieldID :signed-integer) (fieldNum :signed-integer) (fieldName (:string 255)) (fieldTE (:handle :terec))) 
  nil
   () )                                         ; 
;  *  EndXSound()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_BeginXSound" 
      ((paramPtr (:pointer :xcmdblock)) (window (:pointer :windowrecord))) 
  nil
   () )                                         ; 
;  *  GetFilePath()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_EndXSound" 
      ((paramPtr (:pointer :xcmdblock))) 
  nil
   () )                                         ; 
;  *  GetXResInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetFilePath" 
      ((paramPtr (:pointer :xcmdblock)) (fileName (:string 255)) (numTypes :signed-integer) (typeList (:pointer :ostype)) (askUser :boolean) (fileType (:pointer :ostype)) (fullName (:pointer (:string 255)))) 
  :boolean
   () )                                         ; 
;  *  Notify()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetXResInfo" 
      ((paramPtr (:pointer :xcmdblock)) (resFile (:pointer :signed-integer)) (resID (:pointer :signed-integer)) (rType (:pointer :ostype)) (name (:pointer (:string 255)))) 
  nil
   () )                                         ; 
;  *  SendHCEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_Notify" 
      ((paramPtr (:pointer :xcmdblock))) 
  nil
   () )                                         ; CONST; 
;  *  SendWindowMessage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SendHCEvent" 
      ((paramPtr (:pointer :xcmdblock)) (event (:pointer :eventrecord))) 
  nil
   () )                                         ; 
;  *  FrontDocWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SendWindowMessage" 
      ((paramPtr (:pointer :xcmdblock)) (windPtr (:pointer :windowrecord)) (windowName (:string 255)) (msg (:string 255))) 
  nil
   () )                                         ; 
;  *  StackNameToNum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FrontDocWindow" 
      ((paramPtr (:pointer :xcmdblock))) 
  (:pointer :windowrecord)
   () )                                         ; 
;  *  ShowHCAlert()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_StackNameToNum" 
      ((paramPtr (:pointer :xcmdblock)) (stackName (:string 255))) 
  :signed-long
   () )                                         ; 
;  *  AbortInQueue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ShowHCAlert" 
      ((paramPtr (:pointer :xcmdblock)) (dlgID :signed-integer) (promptStr (:string 255))) 
  :signed-integer
   () )                                         ; 
;  *  FlushStackFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_AbortInQueue" 
      ((paramPtr (:pointer :xcmdblock))) 
  :boolean
   () )                                         ; 
;         Creating and Disposing XWindoids  
;                                               ; 
;  *  NewXWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FlushStackFile" 
      ((paramPtr (:pointer :xcmdblock))) 
  nil
   () )                                         ; CONST; 
;  *  GetNewXWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_NewXWindow" 
      ((paramPtr (:pointer :xcmdblock)) (boundsRect (:pointer :rect)) (title (:string 255)) (visible :boolean) (procID :signed-integer) (color :boolean) (floating :boolean)) 
  (:pointer :windowrecord)
   () )                                         ; 
;  *  CloseXWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetNewXWindow" 
      ((paramPtr (:pointer :xcmdblock)) (templateType :ostype) (templateID :signed-integer) (color :boolean) (floating :boolean)) 
  (:pointer :windowrecord)
   () )                                         ; 
;         XWindoid Utilities  
;                                               ; 
;  *  HideHCPalettes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CloseXWindow" 
      ((paramPtr (:pointer :xcmdblock)) (window (:pointer :windowrecord))) 
  nil
   () )                                         ; 
;  *  ShowHCPalettes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_HideHCPalettes" 
      ((paramPtr (:pointer :xcmdblock))) 
  nil
   () )                                         ; 
;  *  RegisterXWMenu()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ShowHCPalettes" 
      ((paramPtr (:pointer :xcmdblock))) 
  nil
   () )                                         ; 
;  *  SetXWIdleTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_RegisterXWMenu" 
      ((paramPtr (:pointer :xcmdblock)) (window (:pointer :windowrecord)) (menu (:handle :menuinfo)) (registering :boolean)) 
  nil
   () )                                         ; 
;  *  XWHasInterruptCode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SetXWIdleTime" 
      ((paramPtr (:pointer :xcmdblock)) (window (:pointer :windowrecord)) (interval :signed-long)) 
  nil
   () )                                         ; 
;  *  XWAlwaysMoveHigh()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_XWHasInterruptCode" 
      ((paramPtr (:pointer :xcmdblock)) (window (:pointer :windowrecord)) (haveCode :boolean)) 
  nil
   () )                                         ; 
;  *  XWAllowReEntrancy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_XWAlwaysMoveHigh" 
      ((paramPtr (:pointer :xcmdblock)) (window (:pointer :windowrecord)) (moveHigh :boolean)) 
  nil
   () )                                         ; 
;         Text Editing Utilities  
;                                               ; 
;  *  BeginXWEdit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_XWAllowReEntrancy" 
      ((paramPtr (:pointer :xcmdblock)) (window (:pointer :windowrecord)) (allowSysEvts :boolean) (allowHCEvts :boolean)) 
  nil
   () )                                         ; 
;  *  EndXWEdit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_BeginXWEdit" 
      ((paramPtr (:pointer :xcmdblock)) (window (:pointer :windowrecord))) 
  nil
   () )                                         ; 
;  *  HCWordBreakProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_EndXWEdit" 
      ((paramPtr (:pointer :xcmdblock)) (window (:pointer :windowrecord))) 
  nil
   () )                                         ; 
;  *  PrintTEHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_HCWordBreakProc" 
      ((paramPtr (:pointer :xcmdblock))) 
  :pointer
   () )                                         ; 
;         Script Editor support  
;                                               ; 
;  *  GetCheckPoints()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PrintTEHandle" 
      ((paramPtr (:pointer :xcmdblock)) (hTE (:handle :terec)) (header (:pointer (:string 255)))) 
  nil
   () )                                         ; 
;  *  SetCheckPoints()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetCheckPoints" 
      ((paramPtr (:pointer :xcmdblock))) 
  (:handle :checkpts)
   () )                                         ; 
;  *  FormatScript()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SetCheckPoints" 
      ((paramPtr (:pointer :xcmdblock)) (checkLines (:handle :checkpts))) 
  nil
   () )                                         ; 
;  *  SaveXWScript()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FormatScript" 
      ((paramPtr (:pointer :xcmdblock)) (scriptHndl :handle) (insertionPoint (:pointer :signed-long)) (quickFormat :boolean)) 
  nil
   () )                                         ; 
;  *  GetObjectName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SaveXWScript" 
      ((paramPtr (:pointer :xcmdblock)) (scriptHndl :handle)) 
  nil
   () )                                         ; 
;  *  GetObjectScript()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetObjectName" 
      ((paramPtr (:pointer :xcmdblock)) (xObjPtr (:pointer :xtalkobject)) (objName (:pointer (:string 255)))) 
  nil
   () )                                         ; 
;  *  SetObjectScript()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetObjectScript" 
      ((paramPtr (:pointer :xcmdblock)) (xObjPtr (:pointer :xtalkobject)) (scriptHndl (:pointer :handle))) 
  nil
   () )                                         ; 
;         Debugging Tools support  
;                                               ; 
;  *  AbortScript()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SetObjectScript" 
      ((paramPtr (:pointer :xcmdblock)) (xObjPtr (:pointer :xtalkobject)) (scriptHndl :handle)) 
  nil
   () )                                         ; 
;  *  GoScript()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_AbortScript" 
      ((paramPtr (:pointer :xcmdblock))) 
  nil
   () )                                         ; 
;  *  StepScript()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GoScript" 
      ((paramPtr (:pointer :xcmdblock))) 
  nil
   () )                                         ; 
;  *  CountHandlers()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_StepScript" 
      ((paramPtr (:pointer :xcmdblock)) (stepInto :boolean)) 
  nil
   () )                                         ; 
;  *  GetHandlerInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CountHandlers" 
      ((paramPtr (:pointer :xcmdblock)) (handlerCount (:pointer :signed-integer))) 
  nil
   () )                                         ; 
;  *  GetVarInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetHandlerInfo" 
      ((paramPtr (:pointer :xcmdblock)) (handlerNum :signed-integer) (handlerName (:pointer (:string 255))) (objectName (:pointer (:string 255))) (varCount (:pointer :signed-integer))) 
  nil
   () )                                         ; 
;  *  SetVarValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetVarInfo" 
      ((paramPtr (:pointer :xcmdblock)) (handlerNum :signed-integer) (varNum :signed-integer) (varName (:pointer (:string 255))) (isGlobal (:pointer :boolean)) (varValue (:pointer (:string 255))) (varHndl :handle)) 
  nil
   () )                                         ; 
;  *  GetStackCrawl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SetVarValue" 
      ((paramPtr (:pointer :xcmdblock)) (handlerNum :signed-integer) (varNum :signed-integer) (varHndl :handle)) 
  nil
   () )                                         ; 
;  *  TraceScript()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in HyperXLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetStackCrawl" 
      ((paramPtr (:pointer :xcmdblock))) 
  :handle
   () )
(deftrap-inline "_TraceScript" 
      ((paramPtr (:pointer :xcmdblock)) (traceInto :boolean)) 
  nil
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := HyperXCmdIncludes

; $ENDC                                         ; __HYPERXCMD__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'HyperXCmd)