(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:IBCarbonRuntime.p"
; at Wednesday May 1,2002 2:41:04 pm.
; 
;      File:       IBCarbonRuntime.p
;  
;      Contains:   Nib support for Carbon
;  
;      Version:    Technology: CarbonLib 1.1/Mac OS X
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   2000-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __IBCARBONRUNTIME__
; $SETC __IBCARBONRUNTIME__ := 1

; $I+
; $SETC IBCarbonRuntimeIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CFSTRING__
|#

(require-interface 'CFString)
#|                                              ; $I CFString.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFBUNDLE__
|#

(require-interface 'CFBundle)
#|                                              ; $I CFBundle.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACWINDOWS__
|#

(require-interface 'MacWindows)
#|                                              ; $I MacWindows.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CONTROLDEFINITIONS__
|#

(require-interface 'ControlDefinitions)
#|                                              ; $I ControlDefinitions.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $kIBCarbonRuntimeCantFindNibFile -10960)
(defconstant $kIBCarbonRuntimeObjectNotOfRequestedType -10961)
(defconstant $kIBCarbonRuntimeCantFindObject -10962)

; 	 ----- typedef ------ 	

(def-mactype :ibnibref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :ibnibrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:IBNibRef parameter can be nil, it is changed to xx: IBNibRefPtr 
; 	 ----- Create & Dispose NIB References ------ 	
; 
; 	 *  CreateNibReference()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_CreateNibReference" 
      ((inNibName :pointer) (outNibRef (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  CreateNibReferenceWithCFBundle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CreateNibReferenceWithCFBundle" 
      ((inBundle :pointer) (inNibName :pointer) (outNibRef (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  DisposeNibReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_DisposeNibReference" 
      ((inNibRef :pointer)) 
  nil
   () )

;  ----- Window ------ 
; 
;  *  CreateWindowFromNib()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CreateWindowFromNib" 
      ((inNibRef :pointer) (inName :pointer) (outWindow (:pointer (:pointer :windowrecord)))) 
  :osstatus
   () )

;   ----- Menu ----- 

; 
;  *  CreateMenuFromNib()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CreateMenuFromNib" 
      ((inNibRef :pointer) (inName :pointer) (outMenuRef (:pointer (:handle :menuinfo)))) 
  :osstatus
   () )

;   ----- MenuBar ------ 

; 
;  *  CreateMenuBarFromNib()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CreateMenuBarFromNib" 
      ((inNibRef :pointer) (inName :pointer) (outMenuBar (:pointer :handle))) 
  :osstatus
   () )

; 
;  *  SetMenuBarFromNib()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_SetMenuBarFromNib" 
      ((inNibRef :pointer) (inName :pointer)) 
  :osstatus
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := IBCarbonRuntimeIncludes

; $ENDC                                         ; __IBCARBONRUNTIME__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'IBCarbonRuntime)