(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:ICACamera.p"
; at Wednesday May 1,2002 2:41:11 pm.
; 
;      File:       ICACamera.p
;  
;      Contains:   Digital still camera-specific selectors and structures
;  
;      Version:    Technology: 1.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   2000-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __ICACAMERA__
; $SETC __ICACAMERA__ := 1

; $I+
; $SETC ICACameraIncludes := UsingIncludes
; $SETC UsingIncludes := 1

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;    -------------------------------------------------------------------------
;                                 Selectors           
;    -------------------------------------------------------------------------
; 

;   Camera properties 
;   Refer to section 13 of the PIMA 15740 (PTP) specification for 
;   descriptions and usage notes for these standard properties 
(defconstant $kICAPropertyCameraBatteryLevel :|5001|);   UInt8   enum/range 
(defconstant $kICAPropertyCameraFunctionalMode :|5002|);   UInt16     enum 
(defconstant $kICAPropertyCameraImageSize :|5003|);   CFString     enum/range 
(defconstant $kICAPropertyCameraCompressionSetting :|5004|);   UInt8   enum/range 
(defconstant $kICAPropertyCameraWhiteBalance :|5005|);   UInt16     enum 
(defconstant $kICAPropertyCameraRGBGain :|5006|);   null terminated string enum/range 
(defconstant $kICAPropertyCameraFNumber :|5007|);   UInt16     enum 
(defconstant $kICAPropertyCameraFocalLength :|5008|);   UInt32     enum/range 
(defconstant $kICAPropertyCameraFocusDistance :|5009|);   UInt16     enum/range 
(defconstant $kICAPropertyCameraFocusMode :|500A|);   UInt16     enum 
(defconstant $kICAPropertyCameraExposureMeteringMode :|500B|);   UInt16     enum 
(defconstant $kICAPropertyCameraFlashMode :|500C|);   UInt16     enum 
(defconstant $kICAPropertyCameraExposureTime :|500D|);   UInt32     enum/range 
(defconstant $kICAPropertyCameraExposureProgramMode :|500E|);   UInt16     enum 
(defconstant $kICAPropertyCameraExposureIndex :|500F|);   UInt16     enum/range 
(defconstant $kICAPropertyCameraExposureBiasCompensation :|5010|);   UInt16     enum/range 
(defconstant $kICAPropertyCameraDateTime :|5011|);   null terminated string     none 
(defconstant $kICAPropertyCameraCaptureDelay :|5012|);   UInt32     enum/range 
(defconstant $kICAPropertyCameraStillCaptureMode :|5013|);   UInt16     enum 
(defconstant $kICAPropertyCameraContrast :|5014|);   UInt8   enum/range 
(defconstant $kICAPropertyCameraSharpness :|5015|);   UInt8   enum/range 
(defconstant $kICAPropertyCameraDigitalZoom :|5016|);   UInt8   enum/range 
(defconstant $kICAPropertyCameraEffectMode :|5017|);   UInt16     enum 
(defconstant $kICAPropertyCameraBurstNumber :|5018|);   UInt16     enum/range 
(defconstant $kICAPropertyCameraBurstInterval :|5019|);   UInt16     enum/range 
(defconstant $kICAPropertyCameraTimelapseNumber :|501A|);   UInt16     enum/range 
(defconstant $kICAPropertyCameraTimelapseInterval :|501B|);   UInt32     enum/range 
(defconstant $kICAPropertyCameraFocusMeteringMode :|501C|);   UInt16     enum 

;   Refer to section 5.5.3 of the PTP spec 
(defconstant $kICAPropertyCameraStorageType :|stor|);   UInt16 
(defconstant $kICAPropertyCameraFilesystemType :|fsys|);   UInt16 
(defconstant $kICAPropertyCameraAccessCapability :|acap|);   UInt16 
(defconstant $kICAPropertyCameraMaxCapacity :|maxc|);   UInt64 
(defconstant $kICAPropertyCameraFreeSpaceInBytes :|fres|);   UInt64 
(defconstant $kICAPropertyCameraFreeSpaceInImages :|frei|);   UInt32 
(defconstant $kICAPropertyCameraStorageDescription :|stod|);   null terminated string 
(defconstant $kICAPropertyCameraVolumeLabel :|voll|);   null terminated string 

;   ICA specific 
(defconstant $kICAPropertyCameraIcon :|icon|)   ;   ICAThumbnail 
(defconstant $kICAPropertyCameraSupportedMessages :|msgs|);   array of OSTypes 

;   Values for kICAPropertyCameraStorageType 
(defconstant $kICAStorageFixedROM #x1)
(defconstant $kICAStorageRemovableROM #x2)
(defconstant $kICAStorageFixedRAM #x3)
(defconstant $kICAStorageRemovableRAM #x4)

;   Values for kICAPropertyCameraFilesystemType 
(defconstant $kICAFileystemGenericFlat #x1)
(defconstant $kICAFileystemGenericHierarchical #x2)
(defconstant $kICAFileystemDCF #x3)

;   Values for kICAPropertyCameraAccessCapability 
(defconstant $kICAAccessReadWrite #x0)
(defconstant $kICAAccessReadOnly #x1)
(defconstant $kICAAccessReadOnlyWithObjectDeletion #x2)

;   Camera messages 
(defconstant $kICAMessageCameraCaptureNewImage :|ccni|)
(defconstant $kICAMessageCameraDeleteOne :|del1|)
(defconstant $kICAMessageCameraDeleteAll :|dela|)
(defconstant $kICAMessageCameraSyncClock :|sclk|)
(defconstant $kICAMessageCameraUploadData :|load|)

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := ICACameraIncludes

; $ENDC                                         ; __ICACAMERA__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'ICACamera)