(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:InputSprocket.p"
; at Wednesday May 1,2002 2:41:53 pm.
; 
;      File:       InputSprocket.p
;  
;      Contains:   Games Sprockets: InputSprocket interfaaces
;  
;      Version:    Technology: InputSprocket 1.7
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1996-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __INPUTSPROCKET__
; $SETC __INPUTSPROCKET__ := 1

; $I+
; $SETC InputSprocketIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __DESKBUS__
|#

(require-interface 'DeskBus)
#|                                              ; $I DeskBus.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __DIALOGS__
|#

(require-interface 'Dialogs)
#|                                              ; $I Dialogs.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __EVENTS__
|#

(require-interface 'Events)
#|                                              ; $I Events.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __ICONS__
|#

(require-interface 'Icons)
#|                                              ; $I Icons.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

; $IFC UNDEFINED USE_OLD_INPUT_SPROCKET_LABELS 
; $SETC USE_OLD_INPUT_SPROCKET_LABELS := 0 
; $ENDC

; $IFC UNDEFINED USE_OLD_ISPNEED_STRUCT 
; $SETC USE_OLD_ISPNEED_STRUCT := 0 
; $ENDC

;  ********************* data types ********************* 

(def-mactype :ispdevicereference (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :ispdevicereferenceptr (find-mactype '(:pointer :pointer)));  when a VAR xx:ISpDeviceReference parameter can be nil, it is changed to xx: ISpDeviceReferencePtr 
(def-mactype :ispelementreference (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :ispelementreferenceptr (find-mactype '(:pointer :pointer)));  when a VAR xx:ISpElementReference parameter can be nil, it is changed to xx: ISpElementReferencePtr 
(def-mactype :ispelementlistreference (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :ispelementlistreferenceptr (find-mactype '(:pointer :pointer)));  when a VAR xx:ISpElementListReference parameter can be nil, it is changed to xx: ISpElementListReferencePtr 
; 	 ISpDeviceClass is a general classs of device, example: keyboard, mouse, joystick 	
(def-mactype :ispdeviceclass (find-mactype ':ostype))
; 	 ISpDeviceIdentifier is a specific device,  example: standard 1-button mouse, 105key ext. kbd. 	
(def-mactype :ispdeviceidentifier (find-mactype ':ostype))
(def-mactype :ispelementlabel (find-mactype ':ostype))
(def-mactype :ispelementkind (find-mactype ':ostype))

; 	 *************** resources **************** 	

(defconstant $kISpApplicationResourceType :|isap|)
(defconstant $kISpSetListResourceType :|setl|)
(defconstant $kISpSetDataResourceType :|setd|)

(def-mactype :ispapplicationresourcestructptr (find-mactype '(:pointer :ispapplicationresourcestruct)))
(defrecord ISpApplicationResourceStruct 
   (flags :unsigned-long)
   (reserved1 :unsigned-long)
   (reserved2 :unsigned-long)
   (reserved3 :unsigned-long)
   )

(defconstant $kISpAppResFlag_UsesInputSprocket #x1);   true if the application uses InputSprocket 
(defconstant $kISpAppResFlag_UsesISpInit #x2)   ;   true if the calls ISpInit (ie, uses the high level interface, calls ISpConfigure, has a needs list, etc...) 

; 	
; 	 * ISpDeviceDefinition
; 	 *
; 	 * This structure provides all the available
; 	 * information for an input device within the system
; 	 *
; 	 	

(def-mactype :ispdevicedefinitionptr (find-mactype '(:pointer :ispdevicedefinition)))
(defrecord ISpDeviceDefinition 
   (deviceName (:string 63))                    ;   a human readable name of the device  
   (theDeviceClass :ostype)                     ;   general classs of device example : keyboard, mouse, joystick  
   (theDeviceIdentifier :ostype)                ;   every distinguishable device should have an OSType  
   (permanentID :unsigned-long)                 ;   a cross reboot id unique within that deviceType, 0 if not possible  
   (flags :unsigned-long)                       ;   status flags  
   (permanentIDExtend :unsigned-long)           ;   extension of permanentID, so 64 bits total are now significant  
   (reserved2 :unsigned-long)
   (reserved3 :unsigned-long)
   )

(defconstant $kISpDeviceFlag_HandleOwnEmulation 1)

; 	
; 	 * ISpElementEvent, ISpElementEventPtr
; 	 *
; 	 * This is the structure that event data is passed in.
; 	 *
; 	 	

(def-mactype :ispelementeventptr (find-mactype '(:pointer :ispelementevent)))
(defrecord ISpElementEvent 
   (when :unsignedwide)                         ;   this is absolute time on PCI or later, otherwise it is  
;   0 for the hi 32 bits and TickCount for the low 32 bits  
   (element :pointer)                           ;   a reference to the element that generated this event  
   (refCon :unsigned-long)                      ;   for application usage, 0 on the global list  
   (data :unsigned-long)                        ;   the data for this event  
   )

; 	
; 	 * ISpElementInfo, ISpElementInfoPtr
; 	 *
; 	 * This is the generic definition of an element.
; 	 * Every element must contain this information.
; 	 *
; 	 	
(def-mactype :ispelementinfoptr (find-mactype '(:pointer :ispelementinfo)))
(defrecord ISpElementInfo 
   (theLabel :ostype)
   (theKind :ostype)
   (theString (:string 63))
   (reserved1 :unsigned-long)
   (reserved2 :unsigned-long)
   )

(def-mactype :ispneedflagbits (find-mactype ':unsigned-long))
#|                                              ; $IFC USE_OLD_ISPNEED_STRUCT 
(def-mactype :ispneedptr (find-mactype '(:pointer :ispneed)))
(defrecord ISpNeed 
   (name (:string 63))
   (iconSuiteResourceId :signed-integer)        ;   resource id of the icon suite  
   (reserved :signed-integer)
   (theKind :ostype)
   (theLabel :ostype)
   (flags :unsigned-long)
   (reserved1 :unsigned-long)
   (reserved2 :unsigned-long)
   (reserved3 :unsigned-long)
   )

 |#                                             ; $ELSEC
(defrecord ISpNeed 
   (name (:string 63))                          ;   human-readable string  
   (iconSuiteResourceId :signed-integer)        ;   resource id of the icon suite  
   (playerNum :signed-byte)                     ;   used for multi-player support  
   (group :signed-byte)                         ;   used to group related needs (eg, look left and look right button needs)  
   (theKind :ostype)
   (theLabel :ostype)
   (flags :unsigned-long)
   (reserved1 :unsigned-long)
   (reserved2 :unsigned-long)
   (reserved3 :unsigned-long)
   )

; $ENDC                                         ; USE_OLD_ISPNEED_STRUCT

(defconstant $kISpNeedFlag_NoMultiConfig #x1)   ;   once this need is autoconfigured to one device dont autoconfigure to anything else 
(defconstant $kISpNeedFlag_Utility #x2)         ;   this need is a utility function (like show framerate) which would not typically be assigned to anything but the keyboard 
(defconstant $kISpNeedFlag_PolledOnly #x4)
(defconstant $kISpNeedFlag_EventsOnly #x8)
(defconstant $kISpNeedFlag_NoAutoConfig #x10)   ;   this need can be set normally, but will not ever be auto configured 
(defconstant $kISpNeedFlag_NoConfig #x20)       ;   this need can not be changed by the user 
(defconstant $kISpNeedFlag_Invisible #x40)      ;   this need can not be seen by the user 
;   *** kISpElementKind specific flags *** 
;   these are flags specific to kISpElementKind_Button 
(defconstant $kISpNeedFlag_Button_AlreadyAxis #x10000000);   there is a axis version of this button need 
(defconstant $kISpNeedFlag_Button_ClickToggles #x20000000)
(defconstant $kISpNeedFlag_Button_ActiveWhenDown #x40000000)
(defconstant $kISpNeedFlag_Button_AlreadyDelta #x80000000);   there is a delta version of this button need 
;   these are flags specific to kISpElementKind_DPad 
;   these are flags specific to kISpElementKind_Axis 
(defconstant $kISpNeedFlag_Axis_AlreadyButton #x10000000);   there is a button version of this axis need 
(defconstant $kISpNeedFlag_Axis_Asymetric #x20000000);   this axis need is asymetric     
(defconstant $kISpNeedFlag_Axis_AlreadyDelta #x40000000);   there is a delta version of this axis need 
;   these are flags specific to kISpElementKind_Delta 
(defconstant $kISpNeedFlag_Delta_AlreadyAxis #x10000000);   there is a axis version of this delta need 
(defconstant $kISpNeedFlag_Delta_AlreadyButton #x20000000);   there is a button version of this delta need 

; 	
; 	 *
; 	 * These are the current built values for ISpDeviceClass
; 	 *
; 	 	
(defconstant $kISpDeviceClass_SpeechRecognition :|talk|)
(defconstant $kISpDeviceClass_Mouse :|mous|)
(defconstant $kISpDeviceClass_Keyboard :|keyd|)
(defconstant $kISpDeviceClass_Joystick :|joys|)
(defconstant $kISpDeviceClass_Gamepad :|gmpd|)
(defconstant $kISpDeviceClass_Wheel :|whel|)
(defconstant $kISpDeviceClass_Pedals :|pedl|)
(defconstant $kISpDeviceClass_Levers :|levr|)
(defconstant $kISpDeviceClass_Tickle :|tckl|)   ;   a device of this class requires ISpTickle 
(defconstant $kISpDeviceClass_Unknown :|????|)

; 	
; 	 * These are the current built in ISpElementKind's
; 	 * 
; 	 * These are all OSTypes.
; 	 *
; 	 	
(defconstant $kISpElementKind_Button :|butn|)
(defconstant $kISpElementKind_DPad :|dpad|)
(defconstant $kISpElementKind_Axis :|axis|)
(defconstant $kISpElementKind_Delta :|dlta|)
(defconstant $kISpElementKind_Movement :|move|)
(defconstant $kISpElementKind_Virtual :|virt|)

; 	
; 	 *
; 	 * These are the current built in ISpElementLabel's
; 	 *
; 	 * These are all OSTypes.
; 	 *
; 	 	
#|                                              ; $IFC USE_OLD_INPUT_SPROCKET_LABELS 
;   axis  
(defconstant $kISpElementLabel_XAxis :|xaxi|)
(defconstant $kISpElementLabel_YAxis :|yaxi|)
(defconstant $kISpElementLabel_ZAxis :|zaxi|)
(defconstant $kISpElementLabel_Rx :|rxax|)
(defconstant $kISpElementLabel_Ry :|ryax|)
(defconstant $kISpElementLabel_Rz :|rzax|)
(defconstant $kISpElementLabel_Gas :|gasp|)
(defconstant $kISpElementLabel_Brake :|brak|)
(defconstant $kISpElementLabel_Clutch :|cltc|)
(defconstant $kISpElementLabel_Throttle :|thrt|)
(defconstant $kISpElementLabel_Trim :|trim|)    ;   direction pad  
(defconstant $kISpElementLabel_POVHat :|povh|)
(defconstant $kISpElementLabel_PadMove :|move|) ;   buttons  
(defconstant $kISpElementLabel_Fire :|fire|)
(defconstant $kISpElementLabel_Start :|strt|)
(defconstant $kISpElementLabel_Select :|optn|)  ;   Pause/Resume was changed into 2 needs: Quit and start/pause  
(defconstant $kISpElementLabel_Btn_PauseResume :|strt|)

 |#                                             ; $ENDC; USE_OLD_INPUT_SPROCKET_LABELS

;   generic  
(defconstant $kISpElementLabel_None :|none|)    ;   axis  
(defconstant $kISpElementLabel_Axis_XAxis :|xaxi|)
(defconstant $kISpElementLabel_Axis_YAxis :|yaxi|)
(defconstant $kISpElementLabel_Axis_ZAxis :|zaxi|)
(defconstant $kISpElementLabel_Axis_Rx :|rxax|)
(defconstant $kISpElementLabel_Axis_Ry :|ryax|)
(defconstant $kISpElementLabel_Axis_Rz :|rzax|)
(defconstant $kISpElementLabel_Axis_Roll :|rzax|)
(defconstant $kISpElementLabel_Axis_Pitch :|rxax|)
(defconstant $kISpElementLabel_Axis_Yaw :|ryax|)
(defconstant $kISpElementLabel_Axis_RollTrim :|rxtm|)
(defconstant $kISpElementLabel_Axis_PitchTrim :|trim|)
(defconstant $kISpElementLabel_Axis_YawTrim :|rytm|)
(defconstant $kISpElementLabel_Axis_Gas :|gasp|)
(defconstant $kISpElementLabel_Axis_Brake :|brak|)
(defconstant $kISpElementLabel_Axis_Clutch :|cltc|)
(defconstant $kISpElementLabel_Axis_Throttle :|thrt|)
(defconstant $kISpElementLabel_Axis_Trim :|trim|)
(defconstant $kISpElementLabel_Axis_Rudder :|rudd|)
(defconstant $kISpElementLabel_Axis_ToeBrake :|toeb|);   delta  
(defconstant $kISpElementLabel_Delta_X :|xdlt|)
(defconstant $kISpElementLabel_Delta_Y :|ydlt|)
(defconstant $kISpElementLabel_Delta_Z :|zdlt|)
(defconstant $kISpElementLabel_Delta_Rx :|rxdl|)
(defconstant $kISpElementLabel_Delta_Ry :|rydl|)
(defconstant $kISpElementLabel_Delta_Rz :|rzdl|)
(defconstant $kISpElementLabel_Delta_Roll :|rzdl|)
(defconstant $kISpElementLabel_Delta_Pitch :|rxdl|)
(defconstant $kISpElementLabel_Delta_Yaw :|rydl|)
(defconstant $kISpElementLabel_Delta_Cursor_X :|curx|)
(defconstant $kISpElementLabel_Delta_Cursor_Y :|cury|);   direction pad  
(defconstant $kISpElementLabel_Pad_POV :|povh|) ;   up/down/left/right 
(defconstant $kISpElementLabel_Pad_Move :|move|);   up/down/left/right 
(defconstant $kISpElementLabel_Pad_POV_Horiz :|hpov|);   forward/back/left/right 
(defconstant $kISpElementLabel_Pad_Move_Horiz :|hmov|);   forward/back/left/right 
;   buttons  
(defconstant $kISpElementLabel_Btn_Fire :|fire|)
(defconstant $kISpElementLabel_Btn_SecondaryFire :|sfir|)
(defconstant $kISpElementLabel_Btn_Jump :|jump|)
(defconstant $kISpElementLabel_Btn_Quit :|strt|);   kISpElementLabel_Btn_Quit automatically binds to escape  
(defconstant $kISpElementLabel_Btn_StartPause :|paus|)
(defconstant $kISpElementLabel_Btn_Select :|optn|)
(defconstant $kISpElementLabel_Btn_SlideLeft :|blft|)
(defconstant $kISpElementLabel_Btn_SlideRight :|brgt|)
(defconstant $kISpElementLabel_Btn_MoveForward :|btmf|)
(defconstant $kISpElementLabel_Btn_MoveBackward :|btmb|)
(defconstant $kISpElementLabel_Btn_TurnLeft :|bttl|)
(defconstant $kISpElementLabel_Btn_TurnRight :|bttr|)
(defconstant $kISpElementLabel_Btn_LookLeft :|btll|)
(defconstant $kISpElementLabel_Btn_LookRight :|btlr|)
(defconstant $kISpElementLabel_Btn_LookUp :|btlu|)
(defconstant $kISpElementLabel_Btn_LookDown :|btld|)
(defconstant $kISpElementLabel_Btn_Next :|btnx|)
(defconstant $kISpElementLabel_Btn_Previous :|btpv|)
(defconstant $kISpElementLabel_Btn_SideStep :|side|)
(defconstant $kISpElementLabel_Btn_Run :|quik|)
(defconstant $kISpElementLabel_Btn_Look :|blok|)
(defconstant $kISpElementLabel_Btn_Minimum :|min |)
(defconstant $kISpElementLabel_Btn_Decrement :|decr|)
(defconstant $kISpElementLabel_Btn_Center :|cent|)
(defconstant $kISpElementLabel_Btn_Increment :|incr|)
(defconstant $kISpElementLabel_Btn_Maximum :|max |)
(defconstant $kISpElementLabel_Btn_10Percent :| 10 |)
(defconstant $kISpElementLabel_Btn_20Percent :| 20 |)
(defconstant $kISpElementLabel_Btn_30Percent :| 30 |)
(defconstant $kISpElementLabel_Btn_40Percent :| 40 |)
(defconstant $kISpElementLabel_Btn_50Percent :| 50 |)
(defconstant $kISpElementLabel_Btn_60Percent :| 60 |)
(defconstant $kISpElementLabel_Btn_70Percent :| 70 |)
(defconstant $kISpElementLabel_Btn_80Percent :| 80 |)
(defconstant $kISpElementLabel_Btn_90Percent :| 90 |)
(defconstant $kISpElementLabel_Btn_MouseOne :|mou1|)
(defconstant $kISpElementLabel_Btn_MouseTwo :|mou2|)
(defconstant $kISpElementLabel_Btn_MouseThree :|mou3|)

; 	
; 	 *
; 	 * direction pad data & configuration information
; 	 *
; 	 	

(def-mactype :ispdpaddata (find-mactype ':unsigned-long))

(defconstant $kISpPadIdle 0)
(defconstant $kISpPadLeft 1)
(defconstant $kISpPadUpLeft 2)
(defconstant $kISpPadUp 3)
(defconstant $kISpPadUpRight 4)
(defconstant $kISpPadRight 5)
(defconstant $kISpPadDownRight 6)
(defconstant $kISpPadDown 7)
(defconstant $kISpPadDownLeft 8)

(def-mactype :ispdpadconfigurationinfoptr (find-mactype '(:pointer :ispdpadconfigurationinfo)))
(defrecord ISpDPadConfigurationInfo 
   (id :unsigned-long)                          ;   ordering 1..n, 0 = no relavent ordering of direction pads  
   (fourWayPad :boolean)                        ;   true if this pad can only produce idle + four directions  
   )

; 	
; 	 *
; 	 * button data & configuration information
; 	 *
; 	 	
(def-mactype :ispbuttondata (find-mactype ':unsigned-long))

(defconstant $kISpButtonUp 0)
(defconstant $kISpButtonDown 1)

(def-mactype :ispbuttonconfigurationinfoptr (find-mactype '(:pointer :ispbuttonconfigurationinfo)))
(defrecord ISpButtonConfigurationInfo 
   (id :unsigned-long)                          ;   ordering 1..n, 0 = no relavent ordering of buttons  
   )

; 	
; 	 *
; 	 * axis data & configuration information 
; 	 *
; 	 	
(def-mactype :ispaxisdata (find-mactype ':unsigned-long))
(def-mactype :ispaxisconfigurationinfoptr (find-mactype '(:pointer :ispaxisconfigurationinfo)))
(defrecord ISpAxisConfigurationInfo 
   (symetricAxis :boolean)                      ;   axis is symetric, i.e. a joystick is symetric and a gas pedal is not  
   )

(def-mactype :ispdeltadata (find-mactype ':signed-long))
(def-mactype :ispdeltaconfigurationinfoptr (find-mactype '(:pointer :ispdeltaconfigurationinfo)))
(defrecord ISpDeltaConfigurationInfo 
   (reserved1 :unsigned-long)
   (reserved2 :unsigned-long)
   )

(def-mactype :ispmovementdataptr (find-mactype '(:pointer :ispmovementdata)))
(defrecord ISpMovementData 
   (xAxis :unsigned-long)
   (yAxis :unsigned-long)
   (direction :unsigned-long)                   ;   ISpDPadData version of the movement  
   )

(def-mactype :ispmovementconfigurationinfoptr (find-mactype '(:pointer :ispmovementconfigurationinfo)))
(defrecord ISpMovementConfigurationInfo 
   (reserved1 :unsigned-long)
   (reserved2 :unsigned-long)
   )

(defconstant $kISpVirtualElementFlag_UseTempMem 1)

(defconstant $kISpElementListFlag_UseTempMem 1)

(defconstant $kISpFirstIconSuite 30000)
(defconstant $kISpLastIconSuite 30100)
(defconstant $kISpNoneIconSuite 30000)

; 	 ********************* user level functions ********************* 	

; 	
; 	 *
; 	 * startup / shutdown
; 	 *
; 	 	
; 
; 	 *  ISpStartup()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InputSprocketLib 1.1 and later
; 	 *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_ISpStartup" 
      () 
  :osstatus
   () )

;   1.1 or later 
; 
;  *  ISpShutdown()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.1 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpShutdown" 
      () 
  :osstatus
   () )

;   1.1 or later 
; 
;  *
;  * polling
;  *
;  
; 
;  *  ISpTickle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.1 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpTickle" 
      () 
  :osstatus
   () )

;   1.1 or later 
; ********* user interface functions *********

; 
;  *  ISpGetVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpGetVersion" 
      () 
  :numversion
   () )

; 
;  *
;  * ISpElement_NewVirtual(ISpElementReference *outElement);
;  *
;  
; 
;  *  ISpElement_NewVirtual()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpElement_NewVirtual" 
      ((dataSize :unsigned-long) (outElement (:pointer :pointer)) (flags :unsigned-long)) 
  :osstatus
   () )

; 
;  *
;  * ISpElement_NewVirtualFromNeeds(UInt32 count, ISpNeeds *needs, ISpElementReference *outElements);
;  *
;  
; 
;  *  ISpElement_NewVirtualFromNeeds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpElement_NewVirtualFromNeeds" 
      ((count :unsigned-long) (needs (:pointer :ispneed)) (outElements (:pointer :pointer)) (flags :unsigned-long)) 
  :osstatus
   () )

; 
;  *
;  * ISpElement_DisposeVirtual(inElement);
;  *
;  
; 
;  *  ISpElement_DisposeVirtual()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpElement_DisposeVirtual" 
      ((count :unsigned-long) (inElements (:pointer :pointer))) 
  :osstatus
   () )

; 
;  * ISpInit
;  *
;  
; 
;  *  ISpInit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpInit" 
      ((count :unsigned-long) (needs (:pointer :ispneed)) (inReferences (:pointer :pointer)) (appCreatorCode :ostype) (subCreatorCode :ostype) (flags :unsigned-long) (setListResourceId :signed-integer) (reserved :unsigned-long)) 
  :osstatus
   () )

; 
;  * ISpConfigure
;  *
;  

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpEventProcPtr = FUNCTION(VAR inEvent: EventRecord): BOOLEAN; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispeventprocptr (find-mactype ':pointer))
; $ENDC

; 
; 	 *  ISpConfigure()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
; 	 *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_ISpConfigure" 
      ((inEventProcPtr :pointer)) 
  :osstatus
   () )

; 
;  *
;  * ISpStop
;  *
;  
; 
;  *  ISpStop()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpStop" 
      () 
  :osstatus
   () )

; 
;  *
;  * ISpSuspend, ISpResume
;  *
;  * ISpSuspend turns all devices off and allocates memory so that the state may be later resumed.
;  * ISpResume resumes to the previous state of the system after a suspend call.
;  * 
;  * Return Codes
;  * memFullErr
;  *
;  
; 
;  *  ISpSuspend()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpSuspend" 
      () 
  :osstatus
   () )

; 
;  *  ISpResume()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpResume" 
      () 
  :osstatus
   () )

; 
;  * ISpDevices_Extract, ISpDevices_ExtractByClass, ISpDevices_ExtractByIdentifier
;  *
;  * These will extract as many device references from the system wide list as will fit in your buffer.  
;  *
;  * inBufferCount - the size of your buffer (in units of sizeof(ISpDeviceReference)) this may be zero
;  * buffer - a pointer to your buffer
;  * outCount - contains the number of devices in the system
;  *
;  * ISpDevices_ExtractByClass extracts and counts devices of the specified ISpDeviceClass
;  * ISpDevices_ExtractByIdentifier extracts and counts devices of the specified ISpDeviceIdentifier
;  *
;  * Return Codes
;  * paramErr
;  *
;  
; 
;  *  ISpDevices_Extract()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpDevices_Extract" 
      ((inBufferCount :unsigned-long) (outCount (:pointer :unsigned-long)) (buffer (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ISpDevices_ExtractByClass()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpDevices_ExtractByClass" 
      ((inClass :ostype) (inBufferCount :unsigned-long) (outCount (:pointer :unsigned-long)) (buffer (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ISpDevices_ExtractByIdentifier()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpDevices_ExtractByIdentifier" 
      ((inIdentifier :ostype) (inBufferCount :unsigned-long) (outCount (:pointer :unsigned-long)) (buffer (:pointer :pointer))) 
  :osstatus
   () )

; 
;  * ISpDevices_ActivateClass, ISpDevices_DeactivateClass, ISpDevices_Activate, ISpDevices_Deactivate, ISpDevice_IsActive
;  *
;  * ISpDevices_Activate, ISpDevices_Deactivate
;  *
;  * This will activate/deactivate a block of devices.
;  * inDeviceCount - the number of devices to activate / deactivate
;  * inDevicesToActivate/inDevicesToDeactivate - a pointer to a block of memory contains the devices references
;  *
;  * ISpDevices_ActivateClass, ISpDevices_DeactivateClass
;  * inClass - the class of devices to activate or deactivate
;  *
;  * ISpDevice_IsActive
;  * inDevice - the device reference that you wish to 
;  * outIsActive - a boolean value that is true when the device is active
;  *
;  * Return Codes
;  * paramErr
;  *
;  
; 
;  *  ISpDevices_ActivateClass()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.1 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpDevices_ActivateClass" 
      ((inClass :ostype)) 
  :osstatus
   () )

;   1.1 or later 
; 
;  *  ISpDevices_DeactivateClass()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.1 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpDevices_DeactivateClass" 
      ((inClass :ostype)) 
  :osstatus
   () )

;   1.1 or later 
; 
;  *  ISpDevices_Activate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpDevices_Activate" 
      ((inDeviceCount :unsigned-long) (inDevicesToActivate (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ISpDevices_Deactivate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpDevices_Deactivate" 
      ((inDeviceCount :unsigned-long) (inDevicesToDeactivate (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ISpDevice_IsActive()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpDevice_IsActive" 
      ((inDevice :pointer) (outIsActive (:pointer :boolean))) 
  :osstatus
   () )

; 
;  * ISpDevice_GetDefinition
;  *
;  *
;  * inDevice - the device you want to get the definition for
;  * inBuflen - the size of the structure (sizeof(ISpDeviceDefinition))
;  * outStruct - a pointer to where you want the structure copied
;  *
;  * Return Codes
;  * paramErr
;  *
;  
; 
;  *  ISpDevice_GetDefinition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpDevice_GetDefinition" 
      ((inDevice :pointer) (inBuflen :unsigned-long) (outStruct (:pointer :ispdevicedefinition))) 
  :osstatus
   () )

; 
;  *
;  * ISpDevice_GetElementList
;  *
;  * inDevice - the device whose element list you wish to get
;  * outElementList - a pointer to where you want a reference to that list stored
;  *
;  * Return Codes
;  * paramErr
;  *
;  
; 
;  *  ISpDevice_GetElementList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpDevice_GetElementList" 
      ((inDevice :pointer) (outElementList (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *
;  * takes an ISpElementReference and returns the group that it is in or 0 if there is
;  * no group
;  *
;  * Return Codes
;  * paramErr
;  *
;  
; 
;  *  ISpElement_GetGroup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpElement_GetGroup" 
      ((inElement :pointer) (outGroup (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *
;  * takes an ISpElementReference and returns the device that the element belongs 
;  * to.
;  *
;  * Return Codes
;  * paramErr if inElement is 0 or outDevice is nil
;  *
;  
; 
;  *  ISpElement_GetDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpElement_GetDevice" 
      ((inElement :pointer) (outDevice (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *
;  * takes an ISpElementReference and gives the ISpElementInfo for that Element.  This is the
;  * the set of standard information.  You get ISpElementKind specific information
;  * through ISpElement_GetConfigurationInfo.
;  *
;  * Return Codes
;  * paramErr if inElement is 0 or outInfo is nil
;  *
;  
; 
;  *  ISpElement_GetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpElement_GetInfo" 
      ((inElement :pointer) (outInfo (:pointer :ispelementinfo))) 
  :osstatus
   () )

; 
;  *
;  *      
;  *
;  * takes an ISpElementReference and gives the ISpElementKind specific configuration information
;  * 
;  * if buflen is not long enough to hold the information ISpElement_GetConfigurationInfo will
;  * copy buflen bytes of the data into the block of memory pointed to by configInfo and
;  * will return something error.
;  *
;  * Return Codes
;  * paramErr if inElement or configInfo is nil
;  *
;  
; 
;  *  ISpElement_GetConfigurationInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpElement_GetConfigurationInfo" 
      ((inElement :pointer) (buflen :unsigned-long) (configInfo :pointer)) 
  :osstatus
   () )

; 
;  *
;  * ISpElement_GetSimpleState
;  *
;  * Takes an ISpElementReference and returns the current state of that element.  This is a 
;  * specialized version of ISpElement_GetComplexState that is only appropriate for elements
;  * whose data fits in a signed 32 bit integer.
;  *
;  *
;  *
;  * Return Codes
;  * paramErr if inElement is 0 or state is nil
;  *
;  
; 
;  *  ISpElement_GetSimpleState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpElement_GetSimpleState" 
      ((inElement :pointer) (state (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *
;  * ISpElement_GetComplexState
;  *
;  * Takes an ISpElementReference and returns the current state of that element.  
;  * Will copy up to buflen bytes of the current state of the device into
;  * state.
;  *
;  *
;  * Return Codes
;  * paramErr if inElement is 0 or state is nil
;  *
;  
; 
;  *  ISpElement_GetComplexState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpElement_GetComplexState" 
      ((inElement :pointer) (buflen :unsigned-long) (state :pointer)) 
  :osstatus
   () )

; 
;  * ISpElement_GetNextEvent
;  *
;  * It takes in an element  reference and the buffer size of the ISpElementEventPtr
;  * it will set wasEvent to true if there was an event and false otherwise.  If there
;  * was not enough space to fill in the whole event structure that event will be
;  * dequed, as much of the event as will fit in the buffer will by copied and
;  * ISpElement_GetNextEvent will return an error.
;  *
;  * Return Codes
;  * paramErr
;  *
;  
; 
;  *  ISpElement_GetNextEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpElement_GetNextEvent" 
      ((inElement :pointer) (bufSize :unsigned-long) (event (:pointer :ispelementevent)) (wasEvent (:pointer :boolean))) 
  :osstatus
   () )

; 
;  *
;  * ISpElement_Flush
;  *
;  * It takes an ISpElementReference and flushes all the events on that element.  All it guaruntees is
;  * that any events that made it to this layer before the time of the flush call will be flushed and
;  * it will not flush any events that make it to this layer after the time when the call has returned.
;  * What happens to events that occur during the flush is undefined.
;  *
;  *
;  * Return Codes
;  * paramErr
;  *
;  
; 
;  *  ISpElement_Flush()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpElement_Flush" 
      ((inElement :pointer)) 
  :osstatus
   () )

; 
;  * ISpElementList_New
;  *
;  * Creates a new element list and returns it in outElementList.  In count specifies 
;  * the number of element references in the list pointed to by inElements.  If inCount
;  * is non zero the list is created with inCount elements in at as specified by the 
;  * inElements parameter.  Otherwise the list is created empty.
;  *
;  *
;  * Return Codes
;  * out of memory - If it failed to allocate the list because it was out of memory
;                    it will also set outElementList to 0
;  * paramErr if outElementList was nil
;  *
;  *
;  * Special Concerns
;  *
;  * interrupt unsafe
;  *
;  
; 
;  *  ISpElementList_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpElementList_New" 
      ((inCount :unsigned-long) (inElements (:pointer :pointer)) (outElementList (:pointer :pointer)) (flags :unsigned-long)) 
  :osstatus
   () )

; 
;  * ISpElementList_Dispose
;  *
;  * Deletes an already existing memory list.  
;  *
;  *
;  * Return Codes
;  * paramErr if inElementList was 0
;  *
;  *
;  * Special Concerns
;  *
;  * interrupt unsafe
;  *
;  
; 
;  *  ISpElementList_Dispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpElementList_Dispose" 
      ((inElementList :pointer)) 
  :osstatus
   () )

; 
;  * ISpGetGlobalElementList
;  *
;  * returns the global element list
;  *
;  * Return Codes
;  * paramErr if outElementList is nil
;  *
;  
; 
;  *  ISpGetGlobalElementList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpGetGlobalElementList" 
      ((outElementList (:pointer :pointer))) 
  :osstatus
   () )

; 
;  * ISpElementList_AddElement
;  *
;  * adds an element to the element list
;  *
;  * Return Codes
;  * paramErr if inElementList is 0 or newElement is 0
;  * memory error if the system is unable to allocate enough memory
;  *
;  * Special Concerns
;  * interrupt Unsafe
;  * 
;  
; 
;  *  ISpElementList_AddElements()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpElementList_AddElements" 
      ((inElementList :pointer) (refCon :unsigned-long) (count :unsigned-long) (newElements (:pointer :pointer))) 
  :osstatus
   () )

; 
;  * ISpElementList_RemoveElement
;  *
;  * removes the specified element from the element list
;  *
;  * Return Codes
;  * paramErr if inElementList is 0 or oldElement is 0
;  * memory error if the system is unable to allocate enough memory
;  *
;  * Special Concerns
;  * interrupt Unsafe
;  * 
;  
; 
;  *  ISpElementList_RemoveElements()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpElementList_RemoveElements" 
      ((inElementList :pointer) (count :unsigned-long) (oldElement (:pointer :pointer))) 
  :osstatus
   () )

; 
;  * ISpElementList_Extract
;  *
;  * ISpElementList_Extract will extract as many of the elements from an element list as possible.  You pass
;  * in an element list, a pointer to an array of element references and the number of elements in that array.
;  * It will return how many items are in the element list in the outCount parameter and copy the minimum of 
;  * that number and the size of the array into the buffer.
;  *
;  * ByKind and ByLabel are the same except that they will only count and copy element references to elements
;  * that have the specified kind and label.
;  *
;  * Return Codes
;  * paramErr
;  *
;  
; 
;  *  ISpElementList_Extract()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpElementList_Extract" 
      ((inElementList :pointer) (inBufferCount :unsigned-long) (outCount (:pointer :unsigned-long)) (buffer (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ISpElementList_ExtractByKind()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpElementList_ExtractByKind" 
      ((inElementList :pointer) (inKind :ostype) (inBufferCount :unsigned-long) (outCount (:pointer :unsigned-long)) (buffer (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ISpElementList_ExtractByLabel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpElementList_ExtractByLabel" 
      ((inElementList :pointer) (inLabel :ostype) (inBufferCount :unsigned-long) (outCount (:pointer :unsigned-long)) (buffer (:pointer :pointer))) 
  :osstatus
   () )

; 
;  * ISpElementList_GetNextEvent
;  *
;  * It takes in an element list reference and the buffer size of the ISpElementEventPtr
;  * it will set wasEvent to true if there was an event and false otherwise.  If there
;  * was not enough space to fill in the whole event structure that event will be
;  * dequed, as much of the event as will fit in the buffer will by copied and
;  * ISpElementList_GetNextEvent will return an error.
;  *
;  * Return Codes
;  * paramErr
;  *
;  
; 
;  *  ISpElementList_GetNextEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpElementList_GetNextEvent" 
      ((inElementList :pointer) (bufSize :unsigned-long) (event (:pointer :ispelementevent)) (wasEvent (:pointer :boolean))) 
  :osstatus
   () )

; 
;  *
;  * ISpElementList_Flush
;  *
;  * It takes an ISpElementListReference and flushes all the events on that list.  All it guaruntees is
;  * that any events that made it to this layer before the time of the flush call will be flushed and
;  * it will not flush any events that make it to this layer after the time when the call has returned.
;  * What happens to events that occur during the flush is undefined.
;  *
;  *
;  * Return Codes
;  * paramErr
;  *
;  
; 
;  *  ISpElementList_Flush()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpElementList_Flush" 
      ((inElementList :pointer)) 
  :osstatus
   () )

; 
;  *
;  * ISpTimeToMicroseconds
;  *
;  *
;  * This function takes time from an input sprocket event and converts it
;  * into microseconds. (Version 1.2 or later of InputSprocket.)
;  *
;  *
;  * Return Codes
;  * paramErr
;  *
;  
; 
;  *  ISpTimeToMicroseconds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.2 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_ISpTimeToMicroseconds" 
      ((inTime (:pointer :unsignedwide)) (outMicroseconds (:pointer :unsignedwide))) 
  :osstatus
   () )

; 
;  *
;  * ISpUptime
;  *
;  *
;  * This funtion returns the current machine dependant time, identical in form
;  * to that in an InputSprocket event. (Version 1.1 or later of InputSprocket).
;  *
;  *
;  
; 
;  *  ISpUptime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.1 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpUptime" 
      () 
  :unsignedwide
   () )

; **************************************************************************
;   Interfaces for InputSprocket Drivers                                    
;                                                                           
;   These APIs should be called only from InputSprocket drivers             
;                                                                           
;   (Moved from InputSprocketDriver.h, which is now obsolete.               
; **************************************************************************

; 
; 
; Resource File Concerns
; 
; 1. All resource ids of a driver should be in the range of 256 to 2048
; and the res file should only be open while the drivers panel is visable.
; 
; 

(defconstant $kOSType_ISpDriverFileType :|shlb|)
(defconstant $kOSType_ISpDriverCreator :|insp|)

; 	
; 	 *
; 	 * this function will plot an icon suite of the application (usually for a need)
; 	 *
; 	 	
; 
; 	 *  ISpPlotAppIconSuite()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
; 	 *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_ISpPlotAppIconSuite" 
      ((theRect (:pointer :rect)) (align :signed-integer) (transform :signed-integer) (iconSuiteResourceId :signed-integer)) 
  :signed-integer
   () )

;   label2,5,6,7, disabled and offline are reserved 

(defconstant $kISpIconTransform_Selected #x4000);   choose one of these (optionally) (these all erase what is behind them to the dialog color) 
(defconstant $kISpIconTransform_PlotIcon #x100)
(defconstant $kISpIconTransform_PlotPopupButton #x300)
(defconstant $kISpIconTransform_PlotButton #x400);   use this is you want to plot the icon while the devices button is pressed 
;   or the devices axis is activated and so on 
(defconstant $kISpIconTransform_DeviceActive #x3)

(def-mactype :ispmetahandlerselector (find-mactype ':unsigned-long))

(defconstant $kISpSelector_Init 1)
(defconstant $kISpSelector_Stop 2)
(defconstant $kISpSelector_GetSize 3)
(defconstant $kISpSelector_HandleEvent 4)
(defconstant $kISpSelector_Show 5)
(defconstant $kISpSelector_Hide 6)
(defconstant $kISpSelector_BeginConfiguration 7)
(defconstant $kISpSelector_EndConfiguration 8)
(defconstant $kISpSelector_GetIcon 9)
(defconstant $kISpSelector_GetState 10)
(defconstant $kISpSelector_SetState 11)
(defconstant $kISpSelector_Dirty 12)
(defconstant $kISpSelector_SetActive 13)
(defconstant $kISpSelector_DialogItemHit 14)
(defconstant $kISpSelector_Tickle 15)           ;   1.03 and later 
(defconstant $kISpSelector_InterruptTickle 16)
(defconstant $kISpSelector_Draw 17)
(defconstant $kISpSelector_Click 18)
(defconstant $kISpSelector_ADBReInit 19)        ;   1.2 and later 
(defconstant $kISpSelector_GetCalibration 20)   ;   1.7 and later 
(defconstant $kISpSelector_SetCalibration 21)
(defconstant $kISpSelector_CalibrateDialog 22)

; 	
; 	 *
; 	 * typedefs for the function pointers the metahandler may return 
; 	 *
; 	 	
; 	 a generic driver function pointer 	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriverFunctionPtr_Generic = FUNCTION(refCon: UInt32; ...): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriverfunctionptr_generic (find-mactype ':pointer))
; $ENDC

; 	 the meta handler pointer 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriverFunctionPtr_MetaHandler = FUNCTION(refCon: UInt32; metaHandlerSelector: ISpMetaHandlerSelector): ISpDriverFunctionPtr_Generic; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriverfunctionptr_metahandler (find-mactype ':pointer))
; $ENDC

; 	 the pointers you get through the meta handler 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriverFunctionPtr_Init = FUNCTION(refCon: UInt32; count: UInt32; VAR needs: ISpNeed; VAR virtualElements: ISpElementReference; VAR used: BOOLEAN; appCreatorCode: OSType; subCreatorCode: OSType; reserved: UInt32; reserved2: UNIV Ptr): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriverfunctionptr_init (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriverFunctionPtr_Stop = FUNCTION(refCon: UInt32): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriverfunctionptr_stop (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriverFunctionPtr_GetSize = FUNCTION(refCon: UInt32; VAR minimum: Point; VAR best: Point): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriverfunctionptr_getsize (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriverFunctionPtr_HandleEvent = FUNCTION(refCon: UInt32; VAR theEvent: EventRecord; VAR handled: BOOLEAN): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriverfunctionptr_handleevent (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriverFunctionPtr_Show = FUNCTION(refCon: UInt32; theDialog: DialogRef; dialogItemNumber: INTEGER; VAR r: Rect): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriverfunctionptr_show (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriverFunctionPtr_Hide = FUNCTION(refCon: UInt32): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriverfunctionptr_hide (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriverFunctionPtr_BeginConfiguration = FUNCTION(refCon: UInt32; count: UInt32; VAR needs: ISpNeed): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriverfunctionptr_beginconfiguration (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriverFunctionPtr_EndConfiguration = FUNCTION(refCon: UInt32; accept: BOOLEAN): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriverfunctionptr_endconfiguration (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriverFunctionPtr_GetIcon = FUNCTION(refCon: UInt32; VAR iconSuiteResourceId: INTEGER): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriverfunctionptr_geticon (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriverFunctionPtr_GetState = FUNCTION(refCon: UInt32; buflen: UInt32; buffer: UNIV Ptr; VAR length: UInt32): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriverfunctionptr_getstate (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriverFunctionPtr_SetState = FUNCTION(refCon: UInt32; length: UInt32; buffer: UNIV Ptr): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriverfunctionptr_setstate (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriverFunctionPtr_Dirty = FUNCTION(refCon: UInt32; VAR dirty: BOOLEAN): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriverfunctionptr_dirty (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriverFunctionPtr_SetActive = FUNCTION(refCon: UInt32; active: BOOLEAN): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriverfunctionptr_setactive (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriverFunctionPtr_DialogItemHit = FUNCTION(refCon: UInt32; itemHit: INTEGER): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriverfunctionptr_dialogitemhit (find-mactype ':pointer))
; $ENDC

;   1.03 and later 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriverFunctionPtr_Tickle = FUNCTION(refCon: UInt32): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriverfunctionptr_tickle (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriverFunctionPtr_InterruptTickle = FUNCTION(refCon: UInt32): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriverfunctionptr_interrupttickle (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriverFunctionPtr_Draw = FUNCTION(refCon: UInt32): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriverfunctionptr_draw (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriverFunctionPtr_Click = FUNCTION(refCon: UInt32; {CONST}VAR event: EventRecord): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriverfunctionptr_click (find-mactype ':pointer))
; $ENDC

;   1.2 and later 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriverFunctionPtr_ADBReInit = FUNCTION(refCon: UInt32; inPostProcess: BOOLEAN): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriverfunctionptr_adbreinit (find-mactype ':pointer))
; $ENDC

;   1.7 and later 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriverFunctionPtr_GetCalibration = FUNCTION(refCon: UInt32; calibration: UNIV Ptr; VAR calibrationSize: Size): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriverfunctionptr_getcalibration (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriverFunctionPtr_SetCalibration = FUNCTION(refCon: UInt32; calibration: UNIV Ptr; calibrationSize: Size): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriverfunctionptr_setcalibration (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriverFunctionPtr_CalibrateDialog = FUNCTION(refCon: UInt32; VAR changed: BOOLEAN): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriverfunctionptr_calibratedialog (find-mactype ':pointer))
; $ENDC

;   these functions are exported in the driver's pef container (1.7 or later) 
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  ISpDriver_CheckConfiguration()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_ISpDriver_CheckConfiguration" 
      ((validConfiguration (:pointer :boolean))) 
  :osstatus
   () )

; 
;  *  ISpDriver_FindAndLoadDevices()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpDriver_FindAndLoadDevices" 
      ((keepDriverLoaded (:pointer :boolean))) 
  :osstatus
   () )

; 
;  *  ISpDriver_DisposeDevices()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpDriver_DisposeDevices" 
      () 
  :osstatus
   () )

; 
;  *  ISpDriver_Tickle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpDriver_Tickle" 
      () 
  nil
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriver_CheckConfigurationPtr = FUNCTION(VAR validConfiguration: BOOLEAN): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriver_checkconfigurationptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriver_FindAndLoadDevicesPtr = FUNCTION(VAR keepDriverLoaded: BOOLEAN): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriver_findandloaddevicesptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriver_DisposeDevicesPtr = FUNCTION: OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriver_disposedevicesptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpDriver_TicklePtr = PROCEDURE; C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispdriver_tickleptr (find-mactype ':pointer))
; $ENDC

; 	 ********************* driver level functions ********************* 	

; 	
; 	 *
; 	 * ISpDevice_New
; 	 *
; 	 * This creates a new device from the device definition structure and returns
; 	 * the result into the device reference.
; 	 *
; 	 * Returns Codes
; 	 * paramErr
; 	 * out of memory
; 	 * 
; 	 * Specical Considerations
; 	 * may not be done at interrupt time
; 	 	
; 
; 	 *  ISpDevice_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
; 	 *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_ISpDevice_New" 
      ((inStruct (:pointer :ispdevicedefinition)) (metaHandler :pointer) (refCon :unsigned-long) (outReference (:pointer :pointer))) 
  :osstatus
   () )

; 
;  * ISpDevice_Dispose
;  *
;  * This disposes an existing device.
;  *
;  * Returns Codes
;  * paramErr
;  *
;  * Special Considerations
;  * May not be done at interrupt time
;  *
;  
; 
;  *  ISpDevice_Dispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpDevice_Dispose" 
      ((inReference :pointer)) 
  :osstatus
   () )

; 
;  *
;  * ISpElementDefinitionStruct
;  *
;  * This is the structure that defines everything static about this
;  * element.  For each element on your device you will need to 
;  * fill in one of these structures when your driver loads.
;  *
;  

(def-mactype :ispelementdefinitionstructptr (find-mactype '(:pointer :ispelementdefinitionstruct)))
(defrecord ISpElementDefinitionStruct 
   (device :pointer)                            ;   device this element belongs to  
   (group :unsigned-long)                       ;   group this element belongs to or 0  
   (theString (:string 63))                     ;   a string that is a human readable identifier for this element, internationalization ?  
   (kind :ostype)
   (theLabel :ostype)
   (configInfo :pointer)                        ;   a pointer to the buffer containing the configuration information for this element  
   (configInfoLength :unsigned-long)            ;   length of that configuration info  
   (dataSize :unsigned-long)                    ;   the size of the data, so we can generate an appropriate buffer  
   (reserved1 :unsigned-long)
   (reserved2 :unsigned-long)
   (reserved3 :unsigned-long)
   )

; 	
; 	 *
; 	 * ISpElement_New
; 	 *
; 	 * ISpElement_New takes an element definition struct and gives you back a element reference.
; 	 * When you produce data you use that element reference to give the data to the system.
; 	 * 
; 	 * Return Codes
; 	 * paramErr
; 	 * memory error
; 	 *
; 	 * Special Considerations
; 	 * The ISpElement_New function may move or purge memory.  Your application should not call this function 
; 	 * at interrupt time.
; 	 * 
; 	 	
; 
; 	 *  ISpElement_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
; 	 *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_ISpElement_New" 
      ((inStruct (:pointer :ispelementdefinitionstruct)) (outElement (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *
;  * ISpElement_Dispose
;  *
;  * ISpElement_Dispose takes an element reference and deletes it.
;  * You should call this function when your driver unloads.
;  *
;  * Return Codes
;  * paramErr
;  * memory error
;  *
;  * Special Considerations
;  * The ISpElement_Dispose function may move or purge memory.  Your application should not call this function 
;  * at interrupt time.
;  * 
;  
; 
;  *  ISpElement_Dispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpElement_Dispose" 
      ((inElement :pointer)) 
  :osstatus
   () )

; 
;  *
;  * ISpElement_PushSimpleData
;  *
;  * ISpElement_PushSimpleData is the appropriate way to give the system data if your data fits exactly into
;  * a 32 bit signed number.  You pass the element reference that goes with the data, the data and the 
;  * AbsoluteTime that data was produced.  If UpTime is not available you should fill time.lo with the
;  * TickCount time and time.hi with 0.
;  *
;  * Return Codes
;  * paramErr
;  *
;  
; 
;  *  ISpElement_PushSimpleData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_ISpElement_PushSimpleData" 
      ((inElement :pointer) (data :unsigned-long) (time (:pointer :unsignedwide))) 
  :osstatus
   () )

; 
;  *
;  * ISpElement_PushComplexData
;  *
;  * ISpElement_PushComplexData is exactly like ISpElement_PushSimpleData except that it is appropriate for times
;  * when your data does not fit into a signed 32 bit integer.
;  *
;  * Instead it takes the length of your data (which must match the datasize field of your ISpElementDefinitionStruct)
;  * and a ptr to the devices state.
;  *
;  * Return Codes
;  * paramErr
;  *
;  
; 
;  *  ISpElement_PushComplexData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but InputSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_ISpElement_PushComplexData" 
      ((inElement :pointer) (buflen :unsigned-long) (state :pointer) (time (:pointer :unsignedwide))) 
  :osstatus
   () )

;   ***********************************************************************************  

(def-mactype :ispadbdeferref (find-mactype ':unsigned-long))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ISpADBDeferCallbackProcPtr = PROCEDURE(adbCommand: ByteParameter; adbBuffer: UNIV Ptr; refcon: UInt32); C;

|#
 |#                                             ; $ELSEC
(def-mactype :ispadbdefercallbackprocptr (find-mactype ':pointer))
; $ENDC

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  ISpAllocateADBDeferBlock()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InputSprocketDeferLib 1.3 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_ISpAllocateADBDeferBlock" 
      ((createBlock (:pointer :unsigned-long))) 
  :signed-integer
   () )

; 
;  *  ISpDisposeADBDeferBlock()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketDeferLib 1.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpDisposeADBDeferBlock" 
      ((disposeBlock :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  ISpInstallADBDefer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketDeferLib 1.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpInstallADBDefer" 
      ((refBlock :unsigned-long) (reqAddress :signed-byte) (installProc :pointer) (clientRefCon :unsigned-long) (prevRoutine (:pointer :pointer)) (prevDataArea (:pointer :pointer))) 
  :signed-integer
   () )

; 
;  *  ISpRemoveADBDefer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InputSprocketDeferLib 1.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ISpRemoveADBDefer" 
      ((refBlock :unsigned-long)) 
  :signed-integer
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := InputSprocketIncludes

; $ENDC                                         ; __INPUTSPROCKET__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'InputSprocket)