(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:IsochronousDataHandler.p"
; at Wednesday May 1,2002 2:41:55 pm.
; 
;      File:       IsochronousDataHandler.p
;  
;      Contains:   The defines the client API to an Isochronous Data Handler, which is
;  
;      Version:    Technology: xxx put version here xxx
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1997-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __ISOCHRONOUSDATAHANDLER__
; $SETC __ISOCHRONOUSDATAHANDLER__ := 1

; $I+
; $SETC IsochronousDataHandlerIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __MOVIESFORMAT__

(require-interface 'MoviesFormat)               ; $I MoviesFormat.p
; $ENDC
; $IFC UNDEFINED __QUICKTIMECOMPONENTS__

(require-interface 'QuickTimeComponents)        ; $I QuickTimeComponents.p
; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $kIDHComponentType :|ihlr|)        ;   Component type 
(defconstant $kIDHSubtypeDV :|dv  |)            ;   Subtype for DV (over FireWire) 
(defconstant $kIDHSubtypeFireWireConference :|fwc |);   Subtype for FW Conference 

;   Version of Isochronous Data Handler API 
(defconstant $kIDHInterfaceVersion1 #x1)        ;   Initial relase (Summer '99) 

;   atom types 

(defconstant $kIDHDeviceListAtomType :|dlst|)
(defconstant $kIDHDeviceAtomType :|devc|)       ;   to be defined elsewhere 
(defconstant $kIDHIsochServiceAtomType :|isoc|)
(defconstant $kIDHIsochModeAtomType :|mode|)
(defconstant $kIDHDeviceIDType :|dvid|)
(defconstant $kIDHDefaultIOType :|dfio|)
(defconstant $kIDHIsochVersionAtomType :|iver|)
(defconstant $kIDHUniqueIDType :|unid|)
(defconstant $kIDHNameAtomType :|name|)
(defconstant $kIDHUseCMPAtomType :|ucmp|)
(defconstant $kIDHIsochMediaType :|av  |)
(defconstant $kIDHDataTypeAtomType :|dtyp|)
(defconstant $kIDHDataSizeAtomType :|dsiz|)     ;   ??? packet size vs. buffer size 
(defconstant $kIDHDataBufferSizeAtomType :|dbuf|);   ??? packet size vs. buffer size 
(defconstant $kIDHDataIntervalAtomType :|intv|)
(defconstant $kIDHDataIODirectionAtomType :|ddir|)
(defconstant $kIDHSoundMediaAtomType :|soun|)
(defconstant $kIDHSoundTypeAtomType :|type|)
(defconstant $kIDHSoundChannelCountAtomType :|ccnt|)
(defconstant $kIDHSoundSampleSizeAtomType :|ssiz|)
(defconstant $kIDHSoundSampleRateAtomType :|srat|);   same as video out... (what does this comment mean?) 
(defconstant $kIDHVideoMediaAtomType :|vide|)
(defconstant $kIDHVideoDimensionsAtomType :|dimn|)
(defconstant $kIDHVideoResolutionAtomType :|resl|)
(defconstant $kIDHVideoRefreshRateAtomType :|refr|)
(defconstant $kIDHVideoPixelTypeAtomType :|pixl|)
(defconstant $kIDHVideoDecompressorAtomType :|deco|)
(defconstant $kIDHVideoDecompressorTypeAtomType :|dety|)
(defconstant $kIDHVideoDecompressorContinuousAtomType :|cont|)
(defconstant $kIDHVideoDecompressorComponentAtomType :|cmpt|)

;   I/O Flags  
(defconstant $kIDHDataTypeIsInput #x1)
(defconstant $kIDHDataTypeIsOutput #x2)
(defconstant $kIDHDataTypeIsInputAndOutput #x4)

;   Permission Flags  
(defconstant $kIDHOpenForReadTransactions #x1)
(defconstant $kIDHOpenForWriteTransactions #x2)
(defconstant $kIDHOpenWithExclusiveAccess #x4)
(defconstant $kIDHOpenWithHeldBuffers #x8)      ;   IDH will hold buffer until ReleaseBuffer() 
(defconstant $kIDHCloseForReadTransactions #x10)
(defconstant $kIDHCloseForWriteTransactions #x20)

; 
; 	   Errors 
; 	    These REALLY need to be moved into Errors.h
; 	   needs officially assigned numbers
; 	
(defconstant $kIDHErrDeviceDisconnected -14101)
(defconstant $kIDHErrInvalidDeviceID -14102)
(defconstant $kIDHErrDeviceInUse -14104)
(defconstant $kIDHErrDeviceNotOpened -14105)
(defconstant $kIDHErrDeviceBusy -14106)
(defconstant $kIDHErrDeviceReadError -14107)
(defconstant $kIDHErrDeviceWriteError -14108)
(defconstant $kIDHErrDeviceNotConfigured -14109)
(defconstant $kIDHErrDeviceList -14110)
(defconstant $kIDHErrCompletionPending -14111)
(defconstant $kIDHErrDeviceTimeout -14112)
(defconstant $kIDHErrInvalidIndex -14113)
(defconstant $kIDHErrDeviceCantRead -14114)
(defconstant $kIDHErrDeviceCantWrite -14115)
(defconstant $kIDHErrCallNotSupported -14116)

;   Holds Device Identification... 

(def-mactype :idhdeviceid (find-mactype ':unsigned-long))

(defconstant $kIDHInvalidDeviceID 0)
(defconstant $kIDHDeviceIDEveryDevice #xFFFFFFFF)

;    Isoch Interval Atom Data 

(def-mactype :idhisochintervalptr (find-mactype '(:pointer :idhisochinterval)))
(defrecord IDHIsochInterval 
   (duration :signed-long)
   (scale :signed-long)
   )

;   Need to fix this.  For now, cast this as a FWReferenceID 
(def-mactype :psuedoid (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :psuedoidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:PsuedoID parameter can be nil, it is changed to xx: PsuedoIDPtr 
; 
; 	   Isoch Device Status
; 	    This is atom-like, but isnt an atom
; 	
(def-mactype :idhdevicestatusptr (find-mactype '(:pointer :idhdevicestatus)))
(defrecord IDHDeviceStatus 
   (version :unsigned-long)
   (physicallyConnected :boolean)
   (readEnabled :boolean)
   (writeEnabled :boolean)
   (exclusiveAccess :boolean)
   (currentBandwidth :unsigned-long)
   (currentChannel :unsigned-long)
   (localNodeID :pointer)                       ;  may go in atoms  
   (inputStandard :signed-integer)              ;   One of the QT input standards 
   (deviceActive :boolean)
   )

; 
; 	   Isochronous Data Handler Events
; 	    
; 	
(def-mactype :idhevent (find-mactype ':unsigned-long))

(defconstant $kIDHEventInvalid 0)
(defconstant $kIDHEventDeviceAdded #x1)         ;   A new device has been added to the bus 
(defconstant $kIDHEventDeviceRemoved #x2)       ;   A device has been removed from the bus 
(defconstant $kIDHEventDeviceChanged #x4)       ;   Some device has changed state on the bus 
(defconstant $kIDHEventReadEnabled #x8)         ;   A client has enabled a device for read 
(defconstant $kIDHEventReserved1 #x10)          ;   Reserved for future use 
(defconstant $kIDHEventReadDisabled #x20)       ;   A client has disabled a device from read 
(defconstant $kIDHEventWriteEnabled #x40)       ;   A client has enabled a device for write 
(defconstant $kIDHEventReserved2 #x80)          ;   Reserved for future use 
(defconstant $kIDHEventWriteDisabled #x100)     ;   A client has disabled a device for write 
(defconstant $kIDHEventEveryEvent #xFFFFFFFF)

(def-mactype :idhnotificationid (find-mactype ':unsigned-long))
(def-mactype :idheventheaderptr (find-mactype '(:pointer :idheventheader)))
(defrecord IDHEventHeader 
   (deviceID :unsigned-long)                    ;   Device which generated event 
   (notificationID :unsigned-long)
   (event :unsigned-long)                       ;   What the event is 
   )

; 
; 	   IDHGenericEvent
; 	    An IDH will often have to post events from at interrupt time.  Since memory
; 	    allocation cannot occur from the interrupt handler, the IDH can preallocate
; 	    storage needed for handling the event by creating some IDHGenericEvent items.
; 	    Subsequently, when an event is generated, the type of event (specified in the
; 	    IDHEventHeader) will dictate how the IDHGenericEvent should be interpretted.
; 	    
; 	    IMPORTANT NOTE : This means that a specific event structure can NEVER be greater
; 	    than the size of the generic one.
; 	    
; 	
(def-mactype :idhgenericeventptr (find-mactype '(:pointer :idhgenericevent)))
(defrecord IDHGenericEvent 
   (eventHeader :idheventheader)
   (pad (:array :unsigned-long 4))
   )

; 
; 	   IDHDeviceConnectionEvent
; 	    For kIDHEventDeviceAdded or kIDHEventDeviceRemoved events.
; 	
(def-mactype :idhdeviceconnectioneventptr (find-mactype '(:pointer :idhdeviceconnectionevent)))
(defrecord IDHDeviceConnectionEvent 
   (eventHeader :idheventheader)
   )

; 
; 	   IDHDeviceIOEnableEvent
; 	    For kIDHEventReadEnabled, kIDHEventReadDisabled, kIDHEventWriteEnabled, or
; 	    kIDHEventWriteDisabled.
; 	
(def-mactype :idhdeviceioenableeventptr (find-mactype '(:pointer :idhdeviceioenableevent)))
(defrecord IDHDeviceIOEnableEvent 
   (eventHeader :idheventheader)
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	IDHNotificationProcPtr = FUNCTION(VAR event: IDHGenericEvent; userData: UNIV Ptr): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :idhnotificationprocptr (find-mactype ':pointer))
; $ENDC

(def-mactype :idhnotificationproc (find-mactype ':pointer))
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :idhnotificationupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :idhnotificationupp (find-mactype ':pointer))
; $ENDC
(def-mactype :idhparameterblockptr (find-mactype '(:pointer :idhparameterblock)))
(defrecord IDHParameterBlock 
   (reserved1 :unsigned-long)
   (reserved2 :unsigned-integer)
   (buffer :pointer)
   (requestedCount :unsigned-long)
   (actualCount :unsigned-long)
   (completionProc :pointer)
   (refCon :pointer)
   (result :signed-integer)
   )

(def-mactype :idhresolutionptr (find-mactype '(:pointer :idhresolution)))
(defrecord IDHResolution 
   (x :unsigned-long)
   (y :unsigned-long)
   )

(def-mactype :idhdimensionptr (find-mactype '(:pointer :idhdimension)))
(defrecord IDHDimension 
   (x :signed-long)
   (y :signed-long)
   )

; 
; 	 *  IDHGetDeviceList()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in IDHLib 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.3 and later
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_IDHGetDeviceList" 
      ((idh (:pointer :componentinstancerecord)) (deviceList (:pointer :handle)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 idh deviceList ((+ (ash 4 16) 1) :signed-longint)))

; 
;  *  IDHGetDeviceConfiguration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in IDHLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         not available
;  

(deftrap "_IDHGetDeviceConfiguration" 
      ((idh (:pointer :componentinstancerecord)) (configurationID (:pointer :qtatomspec)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 idh configurationID ((+ (ash 4 16) 2) :signed-longint)))

; 
;  *  IDHSetDeviceConfiguration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in IDHLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_IDHSetDeviceConfiguration" 
      ((idh (:pointer :componentinstancerecord)) (configurationID (:pointer :qtatomspec)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 idh configurationID ((+ (ash 4 16) 3) :signed-longint)))

; 
;  *  IDHGetDeviceStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in IDHLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_IDHGetDeviceStatus" 
      ((idh (:pointer :componentinstancerecord)) (configurationID (:pointer :qtatomspec)) (status (:pointer :idhdevicestatus)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 idh configurationID status ((+ (ash 8 16) 4) :signed-longint)))

; 
;  *  IDHGetDeviceClock()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in IDHLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         not available
;  

(deftrap "_IDHGetDeviceClock" 
      ((idh (:pointer :componentinstancerecord)) (clock (:pointer (:pointer :componentrecord))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 idh clock ((+ (ash 4 16) 5) :signed-longint)))

; 
;  *  IDHOpenDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in IDHLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         not available
;  

(deftrap "_IDHOpenDevice" 
      ((idh (:pointer :componentinstancerecord)) (permissions :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 idh permissions ((+ (ash 4 16) 6) :signed-longint)))

; 
;  *  IDHCloseDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in IDHLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         not available
;  

(deftrap "_IDHCloseDevice" 
      ((idh (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 idh ((+ (ash 0 16) 7) :signed-longint)))

; 
;  *  IDHRead()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in IDHLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         not available
;  

(deftrap "_IDHRead" 
      ((idh (:pointer :componentinstancerecord)) (pb (:pointer :idhparameterblock)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 idh pb ((+ (ash 4 16) 8) :signed-longint)))

; 
;  *  IDHWrite()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in IDHLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         not available
;  

(deftrap "_IDHWrite" 
      ((idh (:pointer :componentinstancerecord)) (pb (:pointer :idhparameterblock)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 idh pb ((+ (ash 4 16) 9) :signed-longint)))

; 
;  *  IDHNewNotification()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in IDHLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         not available
;  

(deftrap "_IDHNewNotification" 
      ((idh (:pointer :componentinstancerecord)) (deviceID :unsigned-long) (notificationProc :pointer) (userData :pointer) (notificationID (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 idh deviceID notificationProc userData notificationID ((+ (ash 16 16) 10) :signed-longint)))

; 
;  *  IDHNotifyMeWhen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in IDHLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         not available
;  

(deftrap "_IDHNotifyMeWhen" 
      ((idh (:pointer :componentinstancerecord)) (notificationID :unsigned-long) (events :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 idh notificationID events ((+ (ash 8 16) 11) :signed-longint)))

; 
;  *  IDHCancelNotification()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in IDHLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         not available
;  

(deftrap "_IDHCancelNotification" 
      ((idh (:pointer :componentinstancerecord)) (notificationID :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 idh notificationID ((+ (ash 4 16) 12) :signed-longint)))

; 
;  *  IDHDisposeNotification()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in IDHLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         not available
;  

(deftrap "_IDHDisposeNotification" 
      ((idh (:pointer :componentinstancerecord)) (notificationID :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 idh notificationID ((+ (ash 4 16) 13) :signed-longint)))

; 
;  *  IDHReleaseBuffer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in IDHLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         not available
;  

(deftrap "_IDHReleaseBuffer" 
      ((idh (:pointer :componentinstancerecord)) (pb (:pointer :idhparameterblock)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 idh pb ((+ (ash 4 16) 14) :signed-longint)))

; 
;  *  IDHCancelPendingIO()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in IDHLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         not available
;  

(deftrap "_IDHCancelPendingIO" 
      ((idh (:pointer :componentinstancerecord)) (pb (:pointer :idhparameterblock)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 idh pb ((+ (ash 4 16) 15) :signed-longint)))

; 
;  *  IDHGetDeviceControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in IDHLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         not available
;  

(deftrap "_IDHGetDeviceControl" 
      ((idh (:pointer :componentinstancerecord)) (deviceControl (:pointer (:pointer :componentinstancerecord))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 idh deviceControl ((+ (ash 4 16) 16) :signed-longint)))

; 
;  *  IDHUpdateDeviceList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in IDHLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         not available
;  

(deftrap "_IDHUpdateDeviceList" 
      ((idh (:pointer :componentinstancerecord)) (deviceList (:pointer :handle)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 idh deviceList ((+ (ash 4 16) 17) :signed-longint)))

; 
;  *  IDHGetDeviceTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         not available
;  

(deftrap "_IDHGetDeviceTime" 
      ((idh (:pointer :componentinstancerecord)) (deviceTime (:pointer :timerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 idh deviceTime ((+ (ash 4 16) 18) :signed-longint)))

(defconstant $uppIDHNotificationProcInfo #x3F1)
; 
; 	 *  NewIDHNotificationUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.4 and later
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_NewIDHNotificationUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeIDHNotificationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeIDHNotificationUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeIDHNotificationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         not available
;  
; $ALIGN RESET                                  ; $POP; $SETC UsingIncludes := IsochronousDataHandlerIncludes
(deftrap-inline "_InvokeIDHNotificationUPP" 
      ((event (:pointer :idhgenericevent)) (userData :pointer) (userRoutine :pointer)) 
  :osstatus
   () )                                         ; $ENDC; __ISOCHRONOUSDATAHANDLER__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'IsochronousDataHandler)