(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:KeychainCore.p"
; at Wednesday May 1,2002 2:40:27 pm.
; 
;      File:       KeychainCore.p
;  
;      Contains:   Keychain low-level Interfaces
;  
;      Version:    Technology: Keychain 3.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   2000-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __KEYCHAINCORE__
; $SETC __KEYCHAINCORE__ := 1

; $I+
; $SETC KeychainCoreIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __ALIASES__
|#

(require-interface 'Aliases)
#|                                              ; $I Aliases.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CODEFRAGMENTS__
|#

(require-interface 'CodeFragments)
#|                                              ; $I CodeFragments.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __PROCESSES__
|#

(require-interface 'Processes)
#|                                              ; $I Processes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __EVENTS__
|#

(require-interface 'Events)
#|                                              ; $I Events.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  Data structures and types 

(def-mactype :seckeychainref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :seckeychainrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:SecKeychainRef parameter can be nil, it is changed to xx: SecKeychainRefPtr 
(def-mactype :seckeychainitemref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :seckeychainitemrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:SecKeychainItemRef parameter can be nil, it is changed to xx: SecKeychainItemRefPtr 
(def-mactype :seckeychainsearchref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :seckeychainsearchrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:SecKeychainSearchRef parameter can be nil, it is changed to xx: SecKeychainSearchRefPtr 
(def-mactype :seckeychainattrtype (find-mactype ':ostype))
(def-mactype :seckeychainstatus (find-mactype ':unsigned-long))
(def-mactype :seckeychainattributeptr (find-mactype '(:pointer :seckeychainattribute)))
(defrecord SecKeychainAttribute 
   (tag :ostype)                                ;   4-byte attribute tag  
   (length :unsigned-long)                      ;   Length of attribute data  
   (data :pointer)                              ;   Pointer to attribute data  
   )

(def-mactype :seckeychainattributelistptr (find-mactype '(:pointer :seckeychainattributelist)))
(defrecord SecKeychainAttributeList 
   (count :unsigned-long)                       ;   How many attributes in the array  
   (attr (:pointer :seckeychainattribute))      ;   Pointer to first attribute in array  
   )

(def-mactype :kcref (find-mactype ':pointer))
(def-mactype :kcitemref (find-mactype ':pointer))
(def-mactype :kcsearchref (find-mactype ':pointer))
(def-mactype :kcrefptr (find-mactype '(:pointer :pointer)))
(def-mactype :kcitemrefptr (find-mactype '(:pointer :pointer)))
(def-mactype :kcsearchrefptr (find-mactype '(:pointer :pointer)))
(%define-record :kcattribute (find-record-descriptor :seckeychainattribute))
(def-mactype :kcattributeptr (find-mactype '(:pointer :seckeychainattribute)))
(%define-record :kcattributelist (find-record-descriptor :seckeychainattributelist))
(def-mactype :kcattributelistptr (find-mactype '(:pointer :seckeychainattributelist)))
(def-mactype :kcattrtype (find-mactype ':ostype))
(def-mactype :kcstatus (find-mactype ':unsigned-long))
(def-mactype :kcevent (find-mactype ':unsigned-integer))

(defconstant $kIdleKCEvent 0)                   ;   null event  
(defconstant $kLockKCEvent 1)                   ;   a keychain was locked  
(defconstant $kUnlockKCEvent 2)                 ;   a keychain was unlocked  
(defconstant $kAddKCEvent 3)                    ;   an item was added to a keychain  
(defconstant $kDeleteKCEvent 4)                 ;   an item was deleted from a keychain  
(defconstant $kUpdateKCEvent 5)                 ;   an item was updated  
(defconstant $kPasswordChangedKCEvent 6)        ;   the keychain identity was changed  
(defconstant $kSystemKCEvent 8)                 ;   the keychain client can process events  
(defconstant $kDefaultChangedKCEvent 9)         ;   the default keychain was changed  
(defconstant $kDataAccessKCEvent 10)            ;   a process has accessed a keychain item's data  
(defconstant $kKeychainListChangedKCEvent 11)   ;   the list of keychains has changed  

(def-mactype :kceventmask (find-mactype ':unsigned-integer))

(defconstant $kIdleKCEventMask #x1)
(defconstant $kLockKCEventMask #x2)
(defconstant $kUnlockKCEventMask #x4)
(defconstant $kAddKCEventMask #x8)
(defconstant $kDeleteKCEventMask #x10)
(defconstant $kUpdateKCEventMask #x20)
(defconstant $kPasswordChangedKCEventMask #x40)
(defconstant $kSystemEventKCEventMask #x100)
(defconstant $kDefaultChangedKCEventMask #x200)
(defconstant $kDataAccessKCEventMask #x400)
(defconstant $kEveryKCEventMask #xFFFF)         ;   all of the above 

(defrecord AFPServerSignature (array (:array :unsigned-byte 16 :packed)))
(defrecord KCPublicKeyHash (array (:array :unsigned-byte 20 :packed)))
(def-mactype :kccallbackinfoptr (find-mactype '(:pointer :kccallbackinfo)))
(defrecord KCCallbackInfo 
   (version :unsigned-long)
   (item :pointer)
   (processID :processserialnumber)
   (event :eventrecord)
   (keychain :pointer)
   )

(defconstant $kUnlockStateKCStatus 1)
(defconstant $kRdPermKCStatus 2)
(defconstant $kWrPermKCStatus 4)

(defconstant $kCertificateKCItemClass :|cert|)  ;   Certificate  
(defconstant $kAppleSharePasswordKCItemClass :|ashp|);   Appleshare password  
(defconstant $kInternetPasswordKCItemClass :|inet|);   Internet password  
(defconstant $kGenericPasswordKCItemClass :|genp|);   Generic password  

(def-mactype :kcitemclass (find-mactype ':ostype))

;   Common attributes  
(defconstant $kClassKCItemAttr :|clas|)         ;   Item class (KCItemClass)  
(defconstant $kCreationDateKCItemAttr :|cdat|)  ;   Date the item was created (UInt32)  
(defconstant $kModDateKCItemAttr :|mdat|)       ;   Last time the item was updated (UInt32)  
(defconstant $kDescriptionKCItemAttr :|desc|)   ;   User-visible description string (string)  
(defconstant $kCommentKCItemAttr :|icmt|)       ;   User's comment about the item (string)  
(defconstant $kCreatorKCItemAttr :|crtr|)       ;   Item's creator (OSType)  
(defconstant $kTypeKCItemAttr :|type|)          ;   Item's type (OSType)  
(defconstant $kScriptCodeKCItemAttr :|scrp|)    ;   Script code for all strings (ScriptCode)  
(defconstant $kLabelKCItemAttr :|labl|)         ;   Item label (string)  
(defconstant $kInvisibleKCItemAttr :|invi|)     ;   Invisible (boolean)  
(defconstant $kNegativeKCItemAttr :|nega|)      ;   Negative (boolean)  
(defconstant $kCustomIconKCItemAttr :|cusi|)    ;   Custom icon (boolean)  
(defconstant $kAccountKCItemAttr :|acct|)       ;   User account (string)  
;   Unique Generic password attributes  
(defconstant $kServiceKCItemAttr :|svce|)       ;   Service (string)  
(defconstant $kGenericKCItemAttr :|gena|)       ;   User-defined attribute (untyped bytes)  
;   Unique Internet password attributes  
(defconstant $kSecurityDomainKCItemAttr :|sdmn|);   Security domain (string)  
(defconstant $kServerKCItemAttr :|srvr|)        ;   Server's domain name or IP address (string)  
(defconstant $kAuthTypeKCItemAttr :|atyp|)      ;   Authentication Type (KCAuthType)  
(defconstant $kPortKCItemAttr :|port|)          ;   Port (UInt16)  
(defconstant $kPathKCItemAttr :|path|)          ;   Path (string)  
;   Unique Appleshare password attributes  
(defconstant $kVolumeKCItemAttr :|vlme|)        ;   Volume (string)  
(defconstant $kAddressKCItemAttr :|addr|)       ;   Server address (IP or domain name) or zone name (string)  
(defconstant $kSignatureKCItemAttr :|ssig|)     ;   Server signature block (AFPServerSignature)  
;   Unique AppleShare and Internet attributes  
(defconstant $kProtocolKCItemAttr :|ptcl|)      ;   Protocol (KCProtocolType)  
;   Certificate attributes  
(defconstant $kSubjectKCItemAttr :|subj|)       ;   Subject distinguished name (DER-encoded data)  
(defconstant $kCommonNameKCItemAttr :|cn  |)    ;   Common Name (UTF8-encoded string)  
(defconstant $kIssuerKCItemAttr :|issu|)        ;   Issuer distinguished name (DER-encoded data)  
(defconstant $kSerialNumberKCItemAttr :|snbr|)  ;   Certificate serial number (DER-encoded data)  
(defconstant $kEMailKCItemAttr :|mail|)         ;   E-mail address (ASCII-encoded string)  
(defconstant $kPublicKeyHashKCItemAttr :|hpky|) ;   Hash of public key (KCPublicKeyHash), 20 bytes max.  
(defconstant $kIssuerURLKCItemAttr :|iurl|)     ;   URL of the certificate issuer (ASCII-encoded string)  
;   Shared by keys and certificates  
(defconstant $kEncryptKCItemAttr :|encr|)       ;   Encrypt (Boolean)  
(defconstant $kDecryptKCItemAttr :|decr|)       ;   Decrypt (Boolean)  
(defconstant $kSignKCItemAttr :|sign|)          ;   Sign (Boolean)  
(defconstant $kVerifyKCItemAttr :|veri|)        ;   Verify (Boolean)  
(defconstant $kWrapKCItemAttr :|wrap|)          ;   Wrap (Boolean)  
(defconstant $kUnwrapKCItemAttr :|unwr|)        ;   Unwrap (Boolean)  
(defconstant $kStartDateKCItemAttr :|sdat|)     ;   Start Date (UInt32)  
(defconstant $kEndDateKCItemAttr :|edat|)       ;   End Date (UInt32)  

(def-mactype :kcitemattr (find-mactype ':ostype))

(defconstant $kKCAuthTypeNTLM :|ntlm|)
(defconstant $kKCAuthTypeMSN :|msna|)
(defconstant $kKCAuthTypeDPA :|dpaa|)
(defconstant $kKCAuthTypeRPA :|rpaa|)
(defconstant $kKCAuthTypeHTTPDigest :|httd|)
(defconstant $kKCAuthTypeDefault :|dflt|)

(def-mactype :kcauthtype (find-mactype ':ostype))

(defconstant $kKCProtocolTypeFTP :|ftp |)
(defconstant $kKCProtocolTypeFTPAccount :|ftpa|)
(defconstant $kKCProtocolTypeHTTP :|http|)
(defconstant $kKCProtocolTypeIRC :|irc |)
(defconstant $kKCProtocolTypeNNTP :|nntp|)
(defconstant $kKCProtocolTypePOP3 :|pop3|)
(defconstant $kKCProtocolTypeSMTP :|smtp|)
(defconstant $kKCProtocolTypeSOCKS :|sox |)
(defconstant $kKCProtocolTypeIMAP :|imap|)
(defconstant $kKCProtocolTypeLDAP :|ldap|)
(defconstant $kKCProtocolTypeAppleTalk :|atlk|)
(defconstant $kKCProtocolTypeAFP :|afp |)
(defconstant $kKCProtocolTypeTelnet :|teln|)

(def-mactype :kcprotocoltype (find-mactype ':ostype))
(def-mactype :kccertaddoptions (find-mactype ':unsigned-long))

(defconstant $kSecOptionReserved #xFF)          ;   First byte reserved for SecOptions flags  
(defconstant $kCertUsageShift 8)                ;   start at bit 8  
(defconstant $kCertUsageSigningAdd #x100)
(defconstant $kCertUsageSigningAskAndAdd #x200)
(defconstant $kCertUsageVerifyAdd #x400)
(defconstant $kCertUsageVerifyAskAndAdd #x800)
(defconstant $kCertUsageEncryptAdd #x1000)
(defconstant $kCertUsageEncryptAskAndAdd #x2000)
(defconstant $kCertUsageDecryptAdd #x4000)
(defconstant $kCertUsageDecryptAskAndAdd #x8000)
(defconstant $kCertUsageKeyExchAdd #x10000)
(defconstant $kCertUsageKeyExchAskAndAdd #x20000)
(defconstant $kCertUsageRootAdd #x40000)
(defconstant $kCertUsageRootAskAndAdd #x80000)
(defconstant $kCertUsageSSLAdd #x100000)
(defconstant $kCertUsageSSLAskAndAdd #x200000)
(defconstant $kCertUsageAllAdd #x7FFFFF00)

(def-mactype :kcverifystopon (find-mactype ':unsigned-integer))

(defconstant $kPolicyKCStopOn 0)
(defconstant $kNoneKCStopOn 1)
(defconstant $kFirstPassKCStopOn 2)
(defconstant $kFirstFailKCStopOn 3)

(def-mactype :kccertsearchoptions (find-mactype ':unsigned-long))

(defconstant $kCertSearchShift 0)               ;   start at bit 0  
(defconstant $kCertSearchSigningIgnored 0)
(defconstant $kCertSearchSigningAllowed #x1)
(defconstant $kCertSearchSigningDisallowed #x2)
(defconstant $kCertSearchSigningMask #x3)
(defconstant $kCertSearchVerifyIgnored 0)
(defconstant $kCertSearchVerifyAllowed #x4)
(defconstant $kCertSearchVerifyDisallowed #x8)
(defconstant $kCertSearchVerifyMask #xC)
(defconstant $kCertSearchEncryptIgnored 0)
(defconstant $kCertSearchEncryptAllowed #x10)
(defconstant $kCertSearchEncryptDisallowed #x20)
(defconstant $kCertSearchEncryptMask #x30)
(defconstant $kCertSearchDecryptIgnored 0)
(defconstant $kCertSearchDecryptAllowed #x40)
(defconstant $kCertSearchDecryptDisallowed #x80)
(defconstant $kCertSearchDecryptMask #xC0)
(defconstant $kCertSearchWrapIgnored 0)
(defconstant $kCertSearchWrapAllowed #x100)
(defconstant $kCertSearchWrapDisallowed #x200)
(defconstant $kCertSearchWrapMask #x300)
(defconstant $kCertSearchUnwrapIgnored 0)
(defconstant $kCertSearchUnwrapAllowed #x400)
(defconstant $kCertSearchUnwrapDisallowed #x800)
(defconstant $kCertSearchUnwrapMask #xC00)
(defconstant $kCertSearchPrivKeyRequired #x1000)
(defconstant $kCertSearchAny 0)

; 	 Other constants 	
(defconstant $kAnyPort 0)

(defconstant $kAnyProtocol 0)
(defconstant $kAnyAuthType 0)

; 	 Opening and getting information about the Keychain Manager 	
; 
; 	 *  KCGetKeychainManagerVersion()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in KeychainLib 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         not available
; 	 	
; $IFC TARGET_RT_MAC_CFM                        ; 
;         KeychainManagerAvailable() is a macro/inline available only in C/C++.  
;         To get the same functionality from pascal or assembly, you need
;         to test if KCGetKeychainManagerVersion function is not NULL.  For instance:
;         
;             gKeychainManagerAvailable = FALSE;
;             IF @KCGetKeychainManagerVersion <> kUnresolvedCFragSymbolAddress THEN
;                 gKeychainManagerAvailable = TRUE;
;             END
;     
;     
#|                                              ; $ELSEC; $IFC TARGET_RT_MAC_MACHO 
(deftrap-inline "_KCGetKeychainManagerVersion" 
      ((returnVers (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; $ENDC
 |#                                             ; $ENDC

;  Managing the Human Interface 
; 
;  *  KCSetInteractionAllowed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  KCIsInteractionAllowed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCSetInteractionAllowed" 
      ((state :boolean)) 
  :osstatus
   () )                                         ;  Creating references to keychains ; 
;  *  KCMakeKCRefFromFSSpec()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCIsInteractionAllowed" 
      () 
  :boolean
   () )                                         ; 
;  *  KCMakeKCRefFromAlias()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCMakeKCRefFromFSSpec" 
      ((keychainFSSpec (:pointer :fsspec)) (keychain (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  KCMakeAliasFromKCRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCMakeKCRefFromAlias" 
      ((keychainAlias (:handle :aliasrecord)) (keychain (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  KCReleaseKeychain()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCMakeAliasFromKCRef" 
      ((keychain :pointer) (keychainAlias (:pointer (:handle :aliasrecord)))) 
  :osstatus
   () )                                         ;  Specifying the default keychain ; 
;  *  KCGetDefaultKeychain()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCReleaseKeychain" 
      ((keychain (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  KCSetDefaultKeychain()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCGetDefaultKeychain" 
      ((keychain (:pointer :pointer))) 
  :osstatus
   () )                                         ;  Getting information about a keychain ; 
;  *  KCGetStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCSetDefaultKeychain" 
      ((keychain :pointer)) 
  :osstatus
   () )                                         ; 
;  *  KCGetKeychain()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCGetStatus" 
      ((keychain :pointer) (keychainStatus (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  KCGetKeychainName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCGetKeychain" 
      ((item :pointer) (keychain (:pointer :pointer))) 
  :osstatus
   () )                                         ;  Enumerating available keychains ; 
;  *  KCCountKeychains()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCGetKeychainName" 
      ((keychain :pointer) (keychainName (:pointer (:string 255)))) 
  :osstatus
   () )                                         ; 
;  *  KCGetIndKeychain()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCCountKeychains" 
      () 
  :unsigned-integer
   () )
(deftrap-inline "_KCGetIndKeychain" 
      ((index :unsigned-integer) (keychain (:pointer :pointer))) 
  :osstatus
   () )
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	KCCallbackProcPtr = FUNCTION(keychainEvent: KCEvent; VAR info: KCCallbackInfo; userContext: UNIV Ptr): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :kccallbackprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :kccallbackupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :kccallbackupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppKCCallbackProcInfo #xFB0)
; 
; 	 *  NewKCCallbackUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewKCCallbackProc 
(deftrap "_NewKCCallbackUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeKCCallbackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeKCCallbackUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeKCCallbackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallKCCallbackProc 
(deftrap-inline "_InvokeKCCallbackUPP" 
      ((keychainEvent :unsigned-integer) (info (:pointer :kccallbackinfo)) (userContext :pointer) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

;  Keychain Manager callbacks 
; 
;  *  KCAddCallback()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  KCRemoveCallback()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCAddCallback" 
      ((callbackProc :pointer) (eventMask :unsigned-integer) (userContext :pointer)) 
  :osstatus
   () )                                         ;  Creating and editing a keychain item ; 
;  *  KCNewItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCRemoveCallback" 
      ((callbackProc :pointer)) 
  :osstatus
   () )                                         ; 
;  *  KCSetAttribute()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCNewItem" 
      ((itemClass :ostype) (itemCreator :ostype) (length :unsigned-long) (data :pointer) (item (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  KCGetAttribute()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCSetAttribute" 
      ((item :pointer) (attr (:pointer :seckeychainattribute))) 
  :osstatus
   () )                                         ; 
;  *  KCSetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCGetAttribute" 
      ((item :pointer) (attr (:pointer :seckeychainattribute)) (actualLength (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ;  Managing keychain items ; 
;  *  KCUpdateItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCSetData" 
      ((item :pointer) (length :unsigned-long) (data :pointer)) 
  :osstatus
   () )                                         ; 
;  *  KCReleaseItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCUpdateItem" 
      ((item :pointer)) 
  :osstatus
   () )                                         ; 
;  *  KCCopyItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCReleaseItem" 
      ((item (:pointer :pointer))) 
  :osstatus
   () )                                         ;  Searching and enumerating keychain items ; 
;  *  KCFindFirstItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCCopyItem" 
      ((item :pointer) (destKeychain :pointer) (copy (:pointer :pointer))) 
  :osstatus
   () )                                         ; Const; 
;  *  KCFindNextItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCFindFirstItem" 
      ((keychain :pointer) (attrList (:pointer :seckeychainattributelist)) (search (:pointer :pointer)) (item (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  KCReleaseSearch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCFindNextItem" 
      ((search :pointer) (item (:pointer :pointer))) 
  :osstatus
   () )                                         ;  Managing keychain items ; 
;  *  KCDeleteItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCReleaseSearch" 
      ((search (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  KCGetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCDeleteItem" 
      ((item :pointer)) 
  :osstatus
   () )                                         ;  Storing and retrieving AppleShare passwords ; 
;  *  KCAddAppleSharePassword()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCGetData" 
      ((item :pointer) (maxLength :unsigned-long) (data :pointer) (actualLength (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  KCFindAppleSharePassword()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCAddAppleSharePassword" 
      ((serverSignature (:pointer :afpserversignature)) (serverAddress (:pointer (:string 255))) (serverName (:pointer (:string 255))) (volumeName (:pointer (:string 255))) (accountName (:pointer (:string 255))) (passwordLength :unsigned-long) (passwordData :pointer) (item (:pointer :pointer))) 
  :osstatus
   () )                                         ;  Storing and retrieving Internet passwords ; 
;  *  KCAddInternetPassword()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCFindAppleSharePassword" 
      ((serverSignature (:pointer :afpserversignature)) (serverAddress (:pointer (:string 255))) (serverName (:pointer (:string 255))) (volumeName (:pointer (:string 255))) (accountName (:pointer (:string 255))) (maxLength :unsigned-long) (passwordData :pointer) (actualLength (:pointer :unsigned-long)) (item (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  KCAddInternetPasswordWithPath()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCAddInternetPassword" 
      ((serverName (:pointer (:string 255))) (securityDomain (:pointer (:string 255))) (accountName (:pointer (:string 255))) (port :unsigned-integer) (protocol :ostype) (authType :ostype) (passwordLength :unsigned-long) (passwordData :pointer) (item (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  KCFindInternetPassword()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCAddInternetPasswordWithPath" 
      ((serverName (:pointer (:string 255))) (securityDomain (:pointer (:string 255))) (accountName (:pointer (:string 255))) (path (:pointer (:string 255))) (port :unsigned-integer) (protocol :ostype) (authType :ostype) (passwordLength :unsigned-long) (passwordData :pointer) (item (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  KCFindInternetPasswordWithPath()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCFindInternetPassword" 
      ((serverName (:pointer (:string 255))) (securityDomain (:pointer (:string 255))) (accountName (:pointer (:string 255))) (port :unsigned-integer) (protocol :ostype) (authType :ostype) (maxLength :unsigned-long) (passwordData :pointer) (actualLength (:pointer :unsigned-long)) (item (:pointer :pointer))) 
  :osstatus
   () )                                         ;  Storing and retrieving other types of passwords ; 
;  *  KCAddGenericPassword()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCFindInternetPasswordWithPath" 
      ((serverName (:pointer (:string 255))) (securityDomain (:pointer (:string 255))) (accountName (:pointer (:string 255))) (path (:pointer (:string 255))) (port :unsigned-integer) (protocol :ostype) (authType :ostype) (maxLength :unsigned-long) (passwordData :pointer) (actualLength (:pointer :unsigned-long)) (item (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  KCFindGenericPassword()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCAddGenericPassword" 
      ((serviceName (:pointer (:string 255))) (accountName (:pointer (:string 255))) (passwordLength :unsigned-long) (passwordData :pointer) (item (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  KCLock()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCFindGenericPassword" 
      ((serviceName (:pointer (:string 255))) (accountName (:pointer (:string 255))) (maxLength :unsigned-long) (passwordData :pointer) (actualLength (:pointer :unsigned-long)) (item (:pointer :pointer))) 
  :osstatus
   () )                                         ; $ALIGN RESET; $POP; $SETC UsingIncludes := KeychainCoreIncludes
(deftrap-inline "_KCLock" 
      ((keychain :pointer)) 
  :osstatus
   () )                                         ; $ENDC; __KEYCHAINCORE__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'KeychainCore)