(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:KeychainHI.p"
; at Wednesday May 1,2002 2:41:11 pm.
; 
;      File:       KeychainHI.p
;  
;      Contains:   Keychain API's with Human Interfaces
;  
;      Version:    Technology: Keychain 3.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   2000-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __KEYCHAINHI__
; $SETC __KEYCHAINHI__ := 1

; $I+
; $SETC KeychainHIIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __KEYCHAINCORE__
|#

(require-interface 'KeychainCore)
#|                                              ; $I KeychainCore.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFSTRING__
|#

(require-interface 'CFString)
#|                                              ; $I CFString.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFARRAY__
|#

(require-interface 'CFArray)
#|                                              ; $I CFArray.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFDATE__
|#

(require-interface 'CFDate)
#|                                              ; $I CFDate.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  Locking and unlocking a keychain 
; 
;  *  KCUnlock()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  Managing keychain items                      ; 
;  *  KCAddItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCUnlock" 
      ((keychain :pointer) (password (:pointer (:string 255)))) 
  :osstatus
   () )                                         ;  Creating a new keychain ; 
;  *  KCCreateKeychain()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCAddItem" 
      ((item :pointer)) 
  :osstatus
   () )                                         ;  Changing a keychain's settings ; 
;  *  KCChangeSettings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_KCCreateKeychain" 
      ((password (:pointer (:string 255))) (keychain (:pointer :pointer))) 
  :osstatus
   () )                                         ;  Working with certificates ; $IFC CALL_NOT_IN_CARBON ; 
;  *  KCFindX509Certificates()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_KCChangeSettings" 
      ((keychain :pointer)) 
  :osstatus
   () )                                         ; 
;  *  KCChooseCertificate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeychainLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_KCFindX509Certificates" 
      ((keychain :pointer) (name :pointer) (emailAddress :pointer) (options :unsigned-long) (certificateItems (:pointer :pointer))) 
  :osstatus
   () )
(deftrap-inline "_KCChooseCertificate" 
      ((items :pointer) (certificate (:pointer :pointer)) (policyOIDs :pointer) (stopOn :unsigned-integer)) 
  :osstatus
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := KeychainHIIncludes

; $ENDC                                         ; __KEYCHAINHI__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'KeychainHI)