(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:LanguageAnalysis.p"
; at Wednesday May 1,2002 2:40:47 pm.
; 
;      File:       LanguageAnalysis.p
;  
;      Contains:   Language Analysis Manager Interfaces
;  
;      Version:    Technology: Mac OS 8
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1996-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __LANGUAGEANALYSIS__
; $SETC __LANGUAGEANALYSIS__ := 1

; $I+
; $SETC LanguageAnalysisIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __AEREGISTRY__
|#

(require-interface 'AERegistry)
#|                                              ; $I AERegistry.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __DICTIONARY__

(require-interface 'Dictionary)                 ; $I Dictionary.p
; $ENDC
#|                                              ; $IFC UNDEFINED __TEXTCOMMON__
|#

(require-interface 'TextCommon)
#|                                              ; $I TextCommon.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

(def-mactype :laenvironmentref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :laenvironmentrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:LAEnvironmentRef parameter can be nil, it is changed to xx: LAEnvironmentRefPtr 
(def-mactype :lacontextref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :lacontextrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:LAContextRef parameter can be nil, it is changed to xx: LAContextRefPtr 
(def-mactype :lapropertykey (find-mactype ':ostype))
(def-mactype :lapropertytype (find-mactype ':ostype))
; 	
; 	    Data structure for high level API
; 		
(def-mactype :lamorphemerecptr (find-mactype '(:pointer :lamorphemerec)))
(defrecord LAMorphemeRec 
   (sourceTextLength :unsigned-long)
   (sourceTextPtr :pointer)
   (morphemeTextLength :unsigned-long)
   (morphemeTextPtr :pointer)
   (partOfSpeech :unsigned-long)
   )

(def-mactype :lamorphemesarrayptr (find-mactype '(:pointer :lamorphemesarray)))
(defrecord LAMorphemesArray 
   (morphemesCount :unsigned-long)
   (processedTextLength :unsigned-long)
   (morphemesTextLength :unsigned-long)
   (morphemes (:array :lamorphemerec 1))
   )

(defconstant $kLAMorphemesArrayVersion 0)

; 	
; 	    Definitions for result path/bundle structure
; 		

(%define-record :lamorphemebundle (find-record-descriptor :aedesc))
(def-mactype :lamorphemebundleptr (find-mactype '(:pointer :aedesc)))
(%define-record :lamorphemepath (find-record-descriptor :aedesc))
(def-mactype :lamorphemepathptr (find-mactype '(:pointer :aedesc)))
(%define-record :lamorpheme (find-record-descriptor :aedesc))
(def-mactype :lamorphemeptr (find-mactype '(:pointer :aedesc)))
(%define-record :lahomograph (find-record-descriptor :aedesc))
(def-mactype :lahomographptr (find-mactype '(:pointer :aedesc)))

(defconstant $keyAELAMorphemeBundle :|lmfb|)
(defconstant $keyAELAMorphemePath :|lmfp|)
(defconstant $keyAELAMorpheme :|lmfn|)
(defconstant $keyAELAHomograph :|lmfh|)

(defconstant $typeLAMorphemeBundle :|reco|)
(defconstant $typeLAMorphemePath :|reco|)
(defconstant $typeLAMorpheme :|list|)
(defconstant $typeLAHomograph :|list|)

; 	
; 	    Definitions for morpheme/homograph information
; 		
(defconstant $keyAEMorphemePartOfSpeechCode :|lamc|)
(defconstant $keyAEMorphemeTextRange :|lamt|)

(defconstant $typeAEMorphemePartOfSpeechCode :|lamc|)
(defconstant $typeAEMorphemeTextRange :|lamt|)

(def-mactype :morphemepartofspeech (find-mactype ':unsigned-long))
(def-mactype :morphemetextrangeptr (find-mactype '(:pointer :morphemetextrange)))
(defrecord MorphemeTextRange 
   (sourceOffset :unsigned-long)
   (length :unsigned-long)
   )

; 	
; 	    Mask for High level API convert flags 
; 		

(defconstant $kLAEndOfSourceTextMask #x1)

; 	
; 	    Constants for leading/trailing path of analysis function
; 		
(defconstant $kLADefaultEdge 0)
(defconstant $kLAFreeEdge 1)
(defconstant $kLAIncompleteEdge 2)

; 	
; 	    Constants for confirm and shift function
; 		
(defconstant $kLAAllMorphemes 0)

; 	
; 	    Library version
; 		
; 
; 	 *  LALibraryVersion()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in LanguageAnalysisLib 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;     High level API
;                                               ; 
;  *  LATextToMorphemes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LanguageAnalysisLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LALibraryVersion" 
      () 
  :unsigned-long
   () )                                         ; 
;     Handling Context
;                                               ; 
;  *  LAOpenAnalysisContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LanguageAnalysisLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LATextToMorphemes" 
      ((context :pointer) (preferedEncoding :unsigned-long) (textLength :unsigned-long) (sourceText :pointer) (bufferSize :unsigned-long) (convertFlags :unsigned-long) (structureVersion :unsigned-long) (acceptedLength (:pointer :unsigned-long)) (resultBuffer (:pointer :lamorphemesarray))) 
  :osstatus
   () )                                         ; 
;  *  LACloseAnalysisContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LanguageAnalysisLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LAOpenAnalysisContext" 
      ((environ :pointer) (context (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;     Handling Environment
;                                               ; 
;  *  LAGetEnvironmentList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LanguageAnalysisLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LACloseAnalysisContext" 
      ((context :pointer)) 
  :osstatus
   () )                                         ; 
;  *  LAGetEnvironmentName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LanguageAnalysisLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LAGetEnvironmentList" 
      ((maxCount :unsigned-long) (actualCount (:pointer :unsigned-long)) (environmentList (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  LAGetEnvironmentRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LanguageAnalysisLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LAGetEnvironmentName" 
      ((environment :pointer) (environmentName (:pointer (:string 63)))) 
  :osstatus
   () )                                         ; 
;  *  LACreateCustomEnvironment()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LanguageAnalysisLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LAGetEnvironmentRef" 
      ((targetEnvironmentName (:string 63)) (environment (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  LADeleteCustomEnvironment()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LanguageAnalysisLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LACreateCustomEnvironment" 
      ((baseEnvironment :pointer) (newEnvironmentName (:string 63)) (persistent :boolean) (newEnvironment (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;     Handling dictionries
;                                               ; 
;  *  LAOpenDictionary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LanguageAnalysisLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LADeleteCustomEnvironment" 
      ((environment :pointer)) 
  :osstatus
   () )                                         ; CONST; 
;  *  LACloseDictionary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LanguageAnalysisLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LAOpenDictionary" 
      ((environ :pointer) (dictionary (:pointer :fsspec))) 
  :osstatus
   () )                                         ; CONST; 
;  *  LAListAvailableDictionaries()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LanguageAnalysisLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LACloseDictionary" 
      ((environ :pointer) (dictionary (:pointer :fsspec))) 
  :osstatus
   () )                                         ; 
;  *  LAAddNewWord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LanguageAnalysisLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LAListAvailableDictionaries" 
      ((environ :pointer) (maxCount :unsigned-long) (actualCount (:pointer :unsigned-long)) (dictionaryList (:pointer :fsspec)) (opened (:pointer :boolean))) 
  :osstatus
   () )                                         ; CONST; CONST; 
;     Analyzing text
;                                               ; 
;  *  LAMorphemeAnalysis()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LanguageAnalysisLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LAAddNewWord" 
      ((environ :pointer) (dictionary (:pointer :fsspec)) (dataList (:pointer :aedesc))) 
  :osstatus
   () )                                         ; 
;  *  LAContinuousMorphemeAnalysis()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LanguageAnalysisLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LAMorphemeAnalysis" 
      ((context :pointer) (text (:pointer :unsigned-integer)) (textLength :unsigned-long) (leadingPath (:pointer :aedesc)) (trailingPath (:pointer :aedesc)) (pathCount :unsigned-long) (result (:pointer :aedesc))) 
  :osstatus
   () )                                         ; 
;  *  LAGetMorphemes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LanguageAnalysisLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LAContinuousMorphemeAnalysis" 
      ((context :pointer) (text (:pointer :unsigned-integer)) (textLength :unsigned-long) (incrementalText :boolean) (leadingPath (:pointer :aedesc)) (trailingPath (:pointer :aedesc)) (modified (:pointer :boolean))) 
  :osstatus
   () )                                         ; 
;  *  LAShiftMorphemes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LanguageAnalysisLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LAGetMorphemes" 
      ((context :pointer) (result (:pointer :aedesc))) 
  :osstatus
   () )                                         ; 
;  *  LAResetAnalysis()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in LanguageAnalysisLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LAShiftMorphemes" 
      ((context :pointer) (morphemeCount :unsigned-long) (path (:pointer :aedesc)) (shiftedLength (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;     Check Language Analysis Manager availability
;                                               ; $IFC TARGET_RT_MAC_CFM ; 
;         LALanguageAnalysisAvailable() is a macro available only in C/C++.  
;         To get the same functionality from pascal or assembly, you need
;         to test if Language Analysis Manager functions are not NULL.
;         For instance:
;         
;             IF @LALibraryVersion <> kUnresolvedCFragSymbolAddress THEN
;                 gLanguageAnalysisAvailable = TRUE;
;             ELSE
;                 gLanguageAnalysisAvailable = FALSE;
;             END
;     
; 
#|                                              ; $ELSEC; $IFC TARGET_RT_MAC_MACHO ;  Language Analysis Manager is always available on OS X 
(deftrap-inline "_LAResetAnalysis" 
      ((context :pointer)) 
  :osstatus
   () )                                         ; $ENDC
 |#                                             ; $ENDC

; 
; =============================================================================================
;     Definitions for Japanese Analysis Module
; =============================================================================================
; 
; 
;     Names for default environments for Japanese analysis
; 
; 
;     File cretor for dictionary of Apple Japanese access method
; 

(defconstant $kAppleJapaneseDictionarySignature :|jlan|)

; 	
; 	    Engine limitations
; 		
(defconstant $kMaxInputLengthOfAppleJapaneseEngine 200)

; 	
; 	    Definitions of information in the path/bundle
; 		

(def-mactype :japanesepartofspeech (find-mactype ':unsigned-long))
(def-mactype :homographweight (find-mactype ':unsigned-integer))
(def-mactype :homographaccent (find-mactype ':unsigned-byte))
; 	
; 	    AE keywords and type definitions for morpheme/homograph information
; 		

(defconstant $keyAEHomographDicInfo :|lahd|)
(defconstant $keyAEHomographWeight :|lahw|)
(defconstant $keyAEHomographAccent :|laha|)

(defconstant $typeAEHomographDicInfo :|lahd|)
(defconstant $typeAEHomographWeight :|shor|)
(defconstant $typeAEHomographAccent :|laha|)

; 	
; 	    Structure for dictionary information of homograph
; 		

(def-mactype :homographdicinforecptr (find-mactype '(:pointer :homographdicinforec)))
(defrecord HomographDicInfoRec 
   (dictionaryID :pointer)
   (uniqueID :unsigned-long)
   )

; 	
; 	=============================================================================================
; 	    Definitions for Japanese part of speeches
; 	=============================================================================================
; 		
; 	
; 	    Masks for part of speeches
; 		

(defconstant $kLASpeechRoughClassMask #xF000)
(defconstant $kLASpeechMediumClassMask #xFF00)
(defconstant $kLASpeechStrictClassMask #xFFF0)
(defconstant $kLASpeechKatsuyouMask #xF)

; 	
; 	    Part of speeches
; 		
(defconstant $kLASpeechMeishi #x0)              ;   noun  
(defconstant $kLASpeechFutsuuMeishi #x0)        ;   general noun  
(defconstant $kLASpeechJinmei #x100)            ;   person name  
(defconstant $kLASpeechJinmeiSei #x110)         ;   family name  
(defconstant $kLASpeechJinmeiMei #x120)         ;   first name  
(defconstant $kLASpeechChimei #x200)            ;   place name  
(defconstant $kLASpeechSetsubiChimei #x210)     ;   place name with suffix  
(defconstant $kLASpeechSoshikimei #x300)        ;   organization name  
(defconstant $kLASpeechKoyuuMeishi #x400)       ;   proper noun  
(defconstant $kLASpeechSahenMeishi #x500)       ;   special noun  
(defconstant $kLASpeechKeidouMeishi #x600)      ;   special noun  
(defconstant $kLASpeechRentaishi #x1000)
(defconstant $kLASpeechFukushi #x2000)          ;   adverb  
(defconstant $kLASpeechSetsuzokushi #x3000)     ;   conjunction  
(defconstant $kLASpeechKandoushi #x4000)
(defconstant $kLASpeechDoushi #x5000)           ;   verb  
(defconstant $kLASpeechGodanDoushi #x5000)
(defconstant $kLASpeechKagyouGodan #x5000)
(defconstant $kLASpeechSagyouGodan #x5010)
(defconstant $kLASpeechTagyouGodan #x5020)
(defconstant $kLASpeechNagyouGodan #x5030)
(defconstant $kLASpeechMagyouGodan #x5040)
(defconstant $kLASpeechRagyouGodan #x5050)
(defconstant $kLASpeechWagyouGodan #x5060)
(defconstant $kLASpeechGagyouGodan #x5070)
(defconstant $kLASpeechBagyouGodan #x5080)
(defconstant $kLASpeechIchidanDoushi #x5100)
(defconstant $kLASpeechKahenDoushi #x5200)
(defconstant $kLASpeechSahenDoushi #x5300)
(defconstant $kLASpeechZahenDoushi #x5400)
(defconstant $kLASpeechKeiyoushi #x6000)        ;   adjective  
(defconstant $kLASpeechKeiyoudoushi #x7000)
(defconstant $kLASpeechSettougo #x8000)         ;   prefix 
(defconstant $kLASpeechSuujiSettougo #x8100)    ;   prefix for numbers  
(defconstant $kLASpeechSetsubigo #x9000)        ;   suffix  
(defconstant $kLASpeechJinmeiSetsubigo #x9100)  ;   suffix for person name  
(defconstant $kLASpeechChimeiSetsubigo #x9200)  ;   suffix for place name  
(defconstant $kLASpeechSoshikimeiSetsubigo #x9300);   suffix for organization name  
(defconstant $kLASpeechSuujiSetsubigo #x9400)   ;   suffix for numbers  
(defconstant $kLASpeechMuhinshi #xA000)         ;   no category  
(defconstant $kLASpeechTankanji #xA000)         ;   character  
(defconstant $kLASpeechKigou #xA100)            ;   symbol  
(defconstant $kLASpeechKuten #xA110)
(defconstant $kLASpeechTouten #xA120)
(defconstant $kLASpeechSuushi #xA200)           ;   numbers  
(defconstant $kLASpeechDokuritsugo #xA300)
(defconstant $kLASpeechSeiku #xA400)
(defconstant $kLASpeechJodoushi #xB000)         ;   auxiliary verb  
(defconstant $kLASpeechJoshi #xC000)            ;   postpositional particle  

; 	
; 	    Conjugations
; 	 	
(defconstant $kLASpeechKatsuyouGokan #x1)       ;   stem  
(defconstant $kLASpeechKatsuyouMizen #x2)
(defconstant $kLASpeechKatsuyouRenyou #x3)
(defconstant $kLASpeechKatsuyouSyuushi #x4)
(defconstant $kLASpeechKatsuyouRentai #x5)
(defconstant $kLASpeechKatsuyouKatei #x6)
(defconstant $kLASpeechKatsuyouMeirei #x7)

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := LanguageAnalysisIncludes

; $ENDC                                         ; __LANGUAGEANALYSIS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'LanguageAnalysis)