(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:LaunchServices.p"
; at Wednesday May 1,2002 2:40:49 pm.
; 
;      File:       LaunchServices.p
;  
;      Contains:   Public interfaces for LaunchServices.framework
;  
;      Version:    Technology: Mac OS X
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __LAUNCHSERVICES__
; $SETC __LAUNCHSERVICES__ := 1

; $I+
; $SETC LaunchServicesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFSTRING__
|#

(require-interface 'CFString)
#|                                              ; $I CFString.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFURL__
|#

(require-interface 'CFURL)
#|                                              ; $I CFURL.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __AEDATAMODEL__
|#

(require-interface 'AEDataModel)
#|                                              ; $I AEDataModel.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  ======================================================================================================== 
;  LaunchServices Structures and Enums                                                                      
;  ======================================================================================================== 

(defconstant $kLSUnknownErr -10810)
(defconstant $kLSNotAnApplicationErr -10811)
(defconstant $kLSNotInitializedErr -10812)
(defconstant $kLSDataUnavailableErr -10813)     ;   e.g. no kind string 
(defconstant $kLSApplicationNotFoundErr -10814) ;   e.g. no application claims the file 
(defconstant $kLSUnknownTypeErr -10815)
(defconstant $kLSDataTooOldErr -10816)
(defconstant $kLSDataErr -10817)
(defconstant $kLSLaunchInProgressErr -10818)    ;   e.g. opening an alreay opening application 
(defconstant $kLSNotRegisteredErr -10819)
(defconstant $kLSAppDoesNotClaimTypeErr -10820)
(defconstant $kLSAppDoesNotSupportSchemeWarning -10821);   not an error, just a warning 
(defconstant $kLSServerCommunicationErr -10822) ;   cannot set recent items 
(defconstant $kLSCannotSetInfoErr -10823)       ;   you may not set item info for this item 

(def-mactype :lsinitializeflags (find-mactype ':unsigned-long))

(defconstant $kLSInitializeDefaults #x1)

(defconstant $kLSMinCatInfoBitmap #x180A)       ;   minimum info needed to avoid a FSGetCatalogInfo call when fetching item information  

(defconstant $kLSInvalidExtensionIndex #xFFFFFFFF);   Index returned from LSGetExtensionInfo when name has no extension 

(def-mactype :lsrequestedinfo (find-mactype ':unsigned-long))

(defconstant $kLSRequestExtension #x1)          ;   safe to use from threads 
(defconstant $kLSRequestTypeCreator #x2)        ;   safe to use from threads 
(defconstant $kLSRequestBasicFlagsOnly #x4)     ;   all but type of application and extension flags - safe to use from threads 
(defconstant $kLSRequestAppTypeFlags #x8)       ;   NOT SAFE to use from threads 
(defconstant $kLSRequestAllFlags #x10)          ;   NOT SAFE to use from threads 
(defconstant $kLSRequestIconAndKind #x20)       ;   NOT SAFE to use from threads 
(defconstant $kLSRequestExtensionFlagsOnly #x40);   safe to use from threads 
(defconstant $kLSRequestAllInfo #xFFFFFFFF)     ;   NOT SAFE to use from threads 

(def-mactype :lsiteminfoflags (find-mactype ':unsigned-long))

(defconstant $kLSItemInfoIsPlainFile #x1)       ;   none of the following applies 
(defconstant $kLSItemInfoIsPackage #x2)         ;   app, doc, or bundle package 
(defconstant $kLSItemInfoIsApplication #x4)     ;   single-file or packaged 
(defconstant $kLSItemInfoIsContainer #x8)       ;   folder or volume 
(defconstant $kLSItemInfoIsAliasFile #x10)      ;   'real' alias 
(defconstant $kLSItemInfoIsSymlink #x20)        ;   UNIX symbolic link only 
(defconstant $kLSItemInfoIsInvisible #x40)      ;   does not include '.' files or '.hidden' entries 
(defconstant $kLSItemInfoIsNativeApp #x80)      ;   Carbon or Cocoa native app 
(defconstant $kLSItemInfoIsClassicApp #x100)    ;   CFM Classic app 
(defconstant $kLSItemInfoAppPrefersNative #x200);   Carbon app that prefers to be launched natively 
(defconstant $kLSItemInfoAppPrefersClassic #x400);   Carbon app that prefers to be launched in Classic 
(defconstant $kLSItemInfoAppIsScriptable #x800) ;   App can be scripted 
(defconstant $kLSItemInfoIsVolume #x1000)       ;   item is a volume 
(defconstant $kLSItemInfoExtensionIsHidden #x100000);   item has a hidden extension 

(def-mactype :lsrolesmask (find-mactype ':unsigned-long))

(defconstant $kLSRolesNone #x1)                 ;   no claim is made about support for this type/scheme 
(defconstant $kLSRolesViewer #x2)               ;   claim to be able to view this type/scheme 
(defconstant $kLSRolesEditor #x4)               ;   claim to be able to edit this type/scheme 
(defconstant $kLSRolesAll #xFFFFFFFF)           ;   claim to do it all 

(def-mactype :lskindid (find-mactype ':unsigned-long))

(defconstant $kLSUnknownKindID 0)

(defconstant $kLSUnknownType 0)
(defconstant $kLSUnknownCreator 0)

(def-mactype :lsiteminforecordptr (find-mactype '(:pointer :lsiteminforecord)))
(defrecord LSItemInfoRecord 
   (flags :unsigned-long)
   (filetype :ostype)
   (creator :ostype)                            ;   release when finished 
   (extension :pointer)                         ;   release when finished 
   (iconFileName :pointer)                      ;   not for general use 
   (kindID :unsigned-long)                      ;   not for general use 
   )

(def-mactype :lsacceptanceflags (find-mactype ':unsigned-long))

(defconstant $kLSAcceptDefault #x1)
(defconstant $kLSAcceptAllowLoginUI #x2)        ;   show UI to log in if necessary 

(def-mactype :lslaunchflags (find-mactype ':unsigned-long))

(defconstant $kLSLaunchDefaults #x1)            ;   default = open, async, use Info.plist, start Classic 
(defconstant $kLSLaunchAndPrint #x2)            ;   print items instead of open them 
(defconstant $kLSLaunchReserved2 #x4)
(defconstant $kLSLaunchReserved3 #x8)
(defconstant $kLSLaunchReserved4 #x10)
(defconstant $kLSLaunchReserved5 #x20)
(defconstant $kLSLaunchReserved6 #x40)
(defconstant $kLSLaunchInhibitBGOnly #x80)      ;   causes launch to fail if target is background-only. 
(defconstant $kLSLaunchDontAddToRecents #x100)  ;   do not add app or documents to recents menus. 
(defconstant $kLSLaunchDontSwitch #x200)        ;   don't bring new app to the foreground. 
(defconstant $kLSLaunchNoParams #x800)          ;   Use Info.plist to determine launch parameters 
(defconstant $kLSLaunchAsync #x10000)           ;   launch async; obtain results from kCPSNotifyLaunch. 
(defconstant $kLSLaunchStartClassic #x20000)    ;   start up Classic environment if required for app. 
(defconstant $kLSLaunchInClassic #x40000)       ;   force app to launch in Classic environment. 
(defconstant $kLSLaunchNewInstance #x80000)     ;   Instantiate app even if it is already running. 
(defconstant $kLSLaunchAndHide #x100000)        ;   Send child a "hide" request as soon as it checks in. 
(defconstant $kLSLaunchAndHideOthers #x200000)  ;   Hide all other apps when child checks in. 

(def-mactype :lslaunchfsrefspecptr (find-mactype '(:pointer :lslaunchfsrefspec)))
(defrecord LSLaunchFSRefSpec 
   (appRef (:pointer :fsref))                   ;   app to use, can be NULL 
   (numDocs :unsigned-long)                     ;   items to open/print, can be NULL 
   (itemRefs (:pointer :fsref))                 ;   array of FSRefs 
   (passThruParams (:pointer :aedesc))          ;   passed untouched to application as optional parameter 
   (launchFlags :unsigned-long)
   (asyncRefCon :pointer)                       ;   used if you register for app birth/death notification 
   )

(def-mactype :lslaunchurlspecptr (find-mactype '(:pointer :lslaunchurlspec)))
(defrecord LSLaunchURLSpec 
   (appURL :pointer)                            ;   app to use, can be NULL 
   (itemURLs :pointer)                          ;   items to open/print, can be NULL 
   (passThruParams (:pointer :aedesc))          ;   passed untouched to application as optional parameter 
   (launchFlags :unsigned-long)
   (asyncRefCon :pointer)                       ;   used if you register for app birth/death notification 
   )

; 	 ======================================================================================================== 	
; 	 LaunchServices Public Entry Points                                                                       	
; 	 ======================================================================================================== 	

; 
; 	 *  LSInit()
; 	 *  
; 	 *  Summary:
; 	 *    Initialize LaunchServices for use.
; 	 *  
; 	 *  Discussion:
; 	 *    LSInit is optional but should be called by top level applications
; 	 *    to explicitly incur any startup costs at a known time. Frameworks
; 	 *    and libraries need never call LSInit.
; 	 *  
; 	 *  Parameters:
; 	 *    
; 	 *    inFlags:
; 	 *      Use kLSInitializeDefaults.
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available in CarbonLib 1.x
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;  *  LSTerm()
;  *  
;  *  Summary:
;  *    Terminate LaunchServices use.
;  *  
;  *  Discussion:
;  *    LSTerm is optional but should be called by top level applications
;  *    to explicitly terminate LaunchServices activity at a known time.
;  *    Frameworks and libraries need never call LSTerm.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LSInit" 
      ((inFlags :unsigned-long)) 
  :osstatus
   () )                                         ; 
;  *  LSCopyItemInfoForRef()
;  *  
;  *  Summary:
;  *    Return information about an item.
;  *  
;  *  Discussion:
;  *    Returns as much or as little information as requested about
;  *    inItemRef. Some information is available in a thread-safe manner,
;  *    some is not. All CFStrings must be released after use.
;  *  
;  *  Parameters:
;  *    
;  *    inItemRef:
;  *      The FSRef of the item about which information is requested.
;  *    
;  *    inWhichInfo:
;  *      Flags indicating which information to return
;  *    
;  *    outItemInfo:
;  *      Information is returned in this structure. Must not be NULL
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LSTerm" 
      () 
  :osstatus
   () )                                         ; CONST; 
;  *  LSCopyItemInfoForURL()
;  *  
;  *  Summary:
;  *    Return information about an item.
;  *  
;  *  Discussion:
;  *    Returns as much or as little information as requested about
;  *    inURL. Some information is available in a thread-safe manner,
;  *    some is not. All CFStrings must be released after use.
;  *  
;  *  Parameters:
;  *    
;  *    inURL:
;  *      The CFURLRef of the item about which information is requested.
;  *    
;  *    inWhichInfo:
;  *      Flags indicating which information to return
;  *    
;  *    outItemInfo:
;  *      Information is returned in this structure. Must not be NULL
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LSCopyItemInfoForRef" 
      ((inItemRef (:pointer :fsref)) (inWhichInfo :unsigned-long) (outItemInfo (:pointer :lsiteminforecord))) 
  :osstatus
   () )                                         ; 
;  *  LSGetExtensionInfo()
;  *  
;  *  Summary:
;  *    Get information about the extension for a file system name.
;  *  
;  *  Discussion:
;  *    Returns the starting index of the extension (not including the
;  *    period) or kLSInvalidExtensionIndex if the input name has no
;  *    extension.
;  *  
;  *  Parameters:
;  *    
;  *    inNameLen:
;  *      The number of the UniChars in inNameBuffer.
;  *    
;  *    inNameBuffer:
;  *      The buffer containing the name's Unicode characters.
;  *    
;  *    outExtStartIndex:
;  *      On success, the starting index of the extension if there is one
;  *      (not including the period). Set to kLSInvalidExtensionIndex if
;  *      inNameBuffer does not contain a valid extension.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.1 and later
;  
(deftrap-inline "_LSCopyItemInfoForURL" 
      ((inURL :pointer) (inWhichInfo :unsigned-long) (outItemInfo (:pointer :lsiteminforecord))) 
  :osstatus
   () )                                         ; CONST; 
;  *  LSCopyDisplayNameForRef()
;  *  
;  *  Summary:
;  *    Get the display name for an FSRef.
;  *  
;  *  Discussion:
;  *    Return a copy of the display name for an FSRef. Takes into
;  *    consideration whether this item has a hidden extension or not.
;  *  
;  *  Parameters:
;  *    
;  *    inRef:
;  *      The FSRef for which the display name is desired.
;  *    
;  *    outDisplayName:
;  *      Pointer to the CFString into which the display name should be
;  *      copied. Callers must dispose of the resulting CFString.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.1 and later
;  
(deftrap-inline "_LSGetExtensionInfo" 
      ((inNameLen :unsigned-long) (inNameBuffer (:pointer :unsigned-integer)) (outExtStartIndex (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; CONST; 
;  *  LSCopyDisplayNameForURL()
;  *  
;  *  Summary:
;  *    Get the display name for a CFURLRef.
;  *  
;  *  Discussion:
;  *    Return a copy of the display name for a CFURLRef. Takes into
;  *    consideration whether this item has a hidden extension or not.
;  *  
;  *  Parameters:
;  *    
;  *    inURL:
;  *      The URL for which the display name is desired.
;  *    
;  *    outDisplayName:
;  *      Pointer to the CFString into which the display name should be
;  *      copied. Callers must dispose of the resulting CFString.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.1 and later
;  
(deftrap-inline "_LSCopyDisplayNameForRef" 
      ((inRef (:pointer :fsref)) (outDisplayName (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  LSSetExtensionHiddenForRef()
;  *  
;  *  Summary:
;  *    Sets whether the extension for an FSRef is hidden or not.
;  *  
;  *  Discussion:
;  *    Sets the necessary file system state to indicate that the
;  *    extension for inRef is hidden, as in the Finder. You can
;  *    determine if an FSRef's extension is hidden using
;  *    LSCopyItemInfoForRef.
;  *  
;  *  Parameters:
;  *    
;  *    inRef:
;  *      The FSRef for which the extension is to be hidden or shown.
;  *    
;  *    inHide:
;  *      True to hide inRef's extension, false to show it.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.1 and later
;  
(deftrap-inline "_LSCopyDisplayNameForURL" 
      ((inURL :pointer) (outDisplayName (:pointer :pointer))) 
  :osstatus
   () )                                         ; CONST; 
;  *  LSSetExtensionHiddenForURL()
;  *  
;  *  Summary:
;  *    Sets whether the extension for a CFURLRef is hidden or not.
;  *  
;  *  Discussion:
;  *    Sets the necessary file system state to indicate that the
;  *    extension for inURL is hidden, as in the Finder. You can
;  *    determine if a CFURLRef's extension is hidden using
;  *    LSCopyItemInfoForURL.
;  *  
;  *  Parameters:
;  *    
;  *    inURL:
;  *      The CFURLRef for which the extension is to be hidden or shown.
;  *    
;  *    inHide:
;  *      True to hide inURL's extension, false to show it.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.1 and later
;  
(deftrap-inline "_LSSetExtensionHiddenForRef" 
      ((inRef (:pointer :fsref)) (inHide :boolean)) 
  :osstatus
   () )                                         ; 
;  *  LSCopyKindStringForRef()
;  *  
;  *  Summary:
;  *    Get the kind string for an item.
;  *  
;  *  Discussion:
;  *    Returns the kind string as used in the Finder and elsewhere for
;  *    inFSRef. The CFStringRef must be released after use.
;  *  
;  *  Parameters:
;  *    
;  *    inFSRef:
;  *      The item for which the kind string is requested.
;  *    
;  *    outKindString:
;  *      A non-NULL CFStringRef* into which the kind string will be
;  *      copied. This CFStringRef must be released after use.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LSSetExtensionHiddenForURL" 
      ((inURL :pointer) (inHide :boolean)) 
  :osstatus
   () )                                         ; CONST; 
;  *  LSCopyKindStringForURL()
;  *  
;  *  Summary:
;  *    Get the kind string for an item.
;  *  
;  *  Discussion:
;  *    Returns the kind string as used in the Finder and elsewhere for
;  *    inURL. The CFStringRef must be released after use.
;  *  
;  *  Parameters:
;  *    
;  *    inURL:
;  *      The item for which the kind string is requested.
;  *    
;  *    outKindString:
;  *      A non-NULL CFStringRef* into which the kind string will be
;  *      copied. This CFStringRef must be released after use.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LSCopyKindStringForRef" 
      ((inFSRef (:pointer :fsref)) (outKindString (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  LSGetApplicationForItem()
;  *  
;  *  Summary:
;  *    Return the application used to open an item.
;  *  
;  *  Discussion:
;  *    Consults the binding tables to return the application that would
;  *    be used to open inItemRef if it were double-clicked in the
;  *    Finder. This application will be the user-specified override if
;  *    appropriate or the default otherwise. If no application is known
;  *    to LaunchServices suitable for opening this item,
;  *    kLSApplicationNotFoundErr will be returned.
;  *  
;  *  Parameters:
;  *    
;  *    inItemRef:
;  *      The FSRef of the item for which the application is requested.
;  *    
;  *    inRoleMask:
;  *      Whether to return the editor or viewer for inItemRef. If you
;  *      don't care which, use kLSRolesAll.
;  *    
;  *    outAppRef:
;  *      Filled in with the FSRef of the application if not NULL.
;  *    
;  *    outAppURL:
;  *      Filled in with the CFURLRef of the application if not NULL.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LSCopyKindStringForURL" 
      ((inURL :pointer) (outKindString (:pointer :pointer))) 
  :osstatus
   () )                                         ; CONST; 
;  *  LSGetApplicationForInfo()
;  *  
;  *  Summary:
;  *    Return the application used to open items with particular data.
;  *  
;  *  Discussion:
;  *    Consults the binding tables to return the application that would
;  *    be used to open items with type, creator, and/or extension as
;  *    provided if they were double-clicked in the Finder. This
;  *    application will be the default for items like this if one has
;  *    been set. If no application is known to LaunchServices suitable
;  *    for opening such items, kLSApplicationNotFoundErr will be
;  *    returned. Not all three input parameters can be NULL at the same
;  *    time nor can both output parameters be NULL at the same time.
;  *  
;  *  Parameters:
;  *    
;  *    inType:
;  *      The file type to consider. Can be kLSUnknownType.
;  *    
;  *    inCreator:
;  *      The file creator to consider. Can be kLSUnknownCreator.
;  *    
;  *    inExtension:
;  *      The file name extension to consider. Can be NULL.
;  *    
;  *    inRoleMask:
;  *      Whether to return the editor or viewer for inItemRef. If you
;  *      don't care which, use kLSRolesAll.
;  *    
;  *    outAppRef:
;  *      Filled in with the FSRef of the application if not NULL.
;  *    
;  *    outAppURL:
;  *      Filled in with the CFURLRef of the application if not NULL.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LSGetApplicationForItem" 
      ((inItemRef (:pointer :fsref)) (inRoleMask :unsigned-long) (outAppRef (:pointer :fsref)) (outAppURL (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  LSGetApplicationForURL()
;  *  
;  *  Summary:
;  *    Return the application used to open an item.
;  *  
;  *  Discussion:
;  *    Consults the binding tables to return the application that would
;  *    be used to open inURL if it were double-clicked in the Finder.
;  *    This application will be the user-specified override if
;  *    appropriate or the default otherwise. If no application is known
;  *    to LaunchServices suitable for opening this item,
;  *    kLSApplicationNotFoundErr will be returned.
;  *  
;  *  Parameters:
;  *    
;  *    inURL:
;  *      The CFURLRef of the item for which the application is requested.
;  *    
;  *    inRoleMask:
;  *      Whether to return the editor or viewer for inItemRef. If you
;  *      don't care which, use kLSRolesAll.
;  *    
;  *    outAppRef:
;  *      Filled in with the FSRef of the application if not NULL.
;  *    
;  *    outAppURL:
;  *      Filled in with the CFURLRef of the application if not NULL.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LSGetApplicationForInfo" 
      ((inType :ostype) (inCreator :ostype) (inExtension :pointer) (inRoleMask :unsigned-long) (outAppRef (:pointer :fsref)) (outAppURL (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  LSFindApplicationForInfo()
;  *  
;  *  Summary:
;  *    Locate a specific application.
;  *  
;  *  Discussion:
;  *    Returns the application with the corresponding input information.
;  *    The registry of applications is consulted first in order of
;  *    bundleID, then creator, then name. All comparisons are case
;  *    insensitive and 'ties' are decided first by version, then by
;  *    native vs. Classic.
;  *  
;  *  Parameters:
;  *    
;  *    inCreator:
;  *      The file creator to consider. Can be kLSUnknownCreator.
;  *    
;  *    inBundleID:
;  *      The bundle ID to consider. Can be NULL.
;  *    
;  *    inName:
;  *      The name to consider. Can be NULL. Must include any extensions
;  *      that are part of the file system name, e.g. '.app'.
;  *    
;  *    outAppRef:
;  *      Filled in with the FSRef of the application if not NULL.
;  *    
;  *    outAppURL:
;  *      Filled in with the CFURLRef of the application if not NULL.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LSGetApplicationForURL" 
      ((inURL :pointer) (inRoleMask :unsigned-long) (outAppRef (:pointer :fsref)) (outAppURL (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  LSCanRefAcceptItem()
;  *  
;  *  Summary:
;  *    Determine whether an item can accept another item.
;  *  
;  *  Discussion:
;  *    Returns in outAcceptsItem whether inTargetRef can accept
;  *    inItemFSRef as in a drag and drop operation. If inRoleMask is
;  *    other than kLSRolesAll then make sure inTargetRef claims to
;  *    fulfill the requested role.
;  *  
;  *  Parameters:
;  *    
;  *    inItemFSRef:
;  *      FSRef of the item about which acceptance is requested.
;  *    
;  *    inTargetRef:
;  *      FSRef of the potential target.
;  *    
;  *    inRoleMask:
;  *      The role(s) the target must claim in order to consider
;  *      acceptance.
;  *    
;  *    inFlags:
;  *      Use kLSAcceptDefault.
;  *    
;  *    outAcceptsItem:
;  *      Filled in with result. Must not be NULL.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LSFindApplicationForInfo" 
      ((inCreator :ostype) (inBundleID :pointer) (inName :pointer) (outAppRef (:pointer :fsref)) (outAppURL (:pointer :pointer))) 
  :osstatus
   () )                                         ; CONST; CONST; 
;  *  LSCanURLAcceptURL()
;  *  
;  *  Summary:
;  *    Determine whether an item can accept another item.
;  *  
;  *  Discussion:
;  *    Returns in outAcceptsItem whether inTargetURL can accept
;  *    inItemURL as in a drag and drop operation. If inRoleMask is other
;  *    than kLSRolesAll then make sure inTargetRef claims to fulfill the
;  *    requested role.
;  *  
;  *  Parameters:
;  *    
;  *    inItemURL:
;  *      CFURLRef of the item about which acceptance is requested.
;  *    
;  *    inTargetURL:
;  *      CFURLRef of the potential target.
;  *    
;  *    inRoleMask:
;  *      The role(s) the target must claim in order to consider
;  *      acceptance.
;  *    
;  *    inFlags:
;  *      Use kLSAcceptDefault.
;  *    
;  *    outAcceptsItem:
;  *      Filled in with result. Must not be NULL.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LSCanRefAcceptItem" 
      ((inItemFSRef (:pointer :fsref)) (inTargetRef (:pointer :fsref)) (inRoleMask :unsigned-long) (inFlags :unsigned-long) (outAcceptsItem (:pointer :boolean))) 
  :osstatus
   () )                                         ; 
;  *  LSOpenFSRef()
;  *  
;  *  Summary:
;  *    Open an application, document, or folder.
;  *  
;  *  Discussion:
;  *    Opens applications, documents, and folders. Applications are
;  *    opened via an 'oapp' or 'rapp' event. Documents are opened in
;  *    their user-overridden or default applications as appropriate.
;  *    Folders are opened in the Finder. Use the more specific
;  *    LSOpenFromRefSpec for more control over launching.
;  *  
;  *  Parameters:
;  *    
;  *    inRef:
;  *      The FSRef of the item to launch.
;  *    
;  *    outLaunchedRef:
;  *      The FSRef of the item actually launched. For inRefs that are
;  *      documents, outLaunchedRef will be the application used to
;  *      launch the document. Can be NULL.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LSCanURLAcceptURL" 
      ((inItemURL :pointer) (inTargetURL :pointer) (inRoleMask :unsigned-long) (inFlags :unsigned-long) (outAcceptsItem (:pointer :boolean))) 
  :osstatus
   () )                                         ; CONST; 
;  *  LSOpenCFURLRef()
;  *  
;  *  Summary:
;  *    Open an application, document, or folder.
;  *  
;  *  Discussion:
;  *    Opens applications, documents, and folders. Applications are
;  *    opened via an 'oapp' or 'rapp' event. Documents are opened in
;  *    their user-overridden or default applications as appropriate.
;  *    Folders are opened in the Finder. Use the more specific
;  *    LSOpenFromURLSpec for more control over launching.
;  *  
;  *  Parameters:
;  *    
;  *    inURL:
;  *      The CFURLRef of the item to launch.
;  *    
;  *    outLaunchedURL:
;  *      The CFURLRef of the item actually launched. For inURLs that are
;  *      documents, outLaunchedURL will be the application used to
;  *      launch the document. Can be NULL.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LSOpenFSRef" 
      ((inRef (:pointer :fsref)) (outLaunchedRef (:pointer :fsref))) 
  :osstatus
   () )                                         ; 
;  *  LSOpenFromRefSpec()
;  *  
;  *  Summary:
;  *    Opens an application or one or more documents or folders.
;  *  
;  *  Discussion:
;  *    Opens applications, documents, and folders.
;  *  
;  *  Parameters:
;  *    
;  *    inLaunchSpec:
;  *      The specification of what to launch and how to launch it.
;  *    
;  *    outLaunchedRef:
;  *      The FSRef of the item actually launched. For inRefs that are
;  *      documents, outLaunchedRef will be the application used to
;  *      launch the document. Can be NULL.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LSOpenCFURLRef" 
      ((inURL :pointer) (outLaunchedURL (:pointer :pointer))) 
  :osstatus
   () )                                         ; CONST; 
;  *  LSOpenFromURLSpec()
;  *  
;  *  Summary:
;  *    Opens an application or one or more documents or folders.
;  *  
;  *  Discussion:
;  *    Opens applications, documents, and folders.
;  *  
;  *  Parameters:
;  *    
;  *    inLaunchSpec:
;  *      The specification of what to launch and how to launch it.
;  *    
;  *    outLaunchedURL:
;  *      The CFURLRef of the item actually launched. For inURLs that are
;  *      documents, outLaunchedURL will be the application used to
;  *      launch the document. Can be NULL.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LSOpenFromRefSpec" 
      ((inLaunchSpec (:pointer :lslaunchfsrefspec)) (outLaunchedRef (:pointer :fsref))) 
  :osstatus
   () )                                         ; CONST; $ALIGN RESET; $POP; $SETC UsingIncludes := LaunchServicesIncludes
(deftrap-inline "_LSOpenFromURLSpec" 
      ((inLaunchSpec (:pointer :lslaunchurlspec)) (outLaunchedURL (:pointer :pointer))) 
  :osstatus
   () )                                         ; $ENDC; __LAUNCHSERVICES__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'LaunchServices)