(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Lists.p"
; at Wednesday May 1,2002 2:40:53 pm.
; 
;      File:       Lists.p
;  
;      Contains:   List Manager Interfaces.
;  
;      Version:    Technology: Mac OS 9
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __LISTS__
; $SETC __LISTS__ := 1

; $I+
; $SETC ListsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CONTROLS__
|#

(require-interface 'Controls)
#|                                              ; $I Controls.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :cell (find-mactype ':point))
(def-mactype :cellptr (find-mactype '(:pointer :point)))
(%define-record :listbounds (find-record-descriptor :rect))
(def-mactype :listboundsptr (find-mactype '(:pointer :rect)))
(defrecord (DataArray :handle) (array (:array :character 32001 :packed)))
(def-mactype :dataptr (find-mactype '(:pointer :dataarray)))
(def-mactype :datahandle (find-mactype '(:handle :dataarray)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ListSearchProcPtr = FUNCTION(aPtr: Ptr; bPtr: Ptr; aLen: INTEGER; bLen: INTEGER): INTEGER;

|#
 |#                                             ; $ELSEC
(def-mactype :listsearchprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ListClickLoopProcPtr = FUNCTION: BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :listclickloopprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :listsearchupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :listsearchupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :listclickloopupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :listclickloopupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC NOT TARGET_OS_MAC 
; 	 QuickTime 3.0 	
(def-mactype :listnotification (find-mactype ':signed-long))

(defconstant $listNotifyNothing :|nada|)        ;   No (null) notification 
(defconstant $listNotifyClick :|clik|)          ;   Control was clicked 
(defconstant $listNotifyDoubleClick :|dblc|)    ;   Control was double-clicked 
(defconstant $listNotifyPreClick :|pclk|)       ;   Control about to be clicked 

 |#                                             ; $ENDC

(def-mactype :listrecptr (find-mactype '(:pointer :listrec)))
(defrecord (ListRec :handle) 
   (rView :rect)                                ;   in Carbon use Get/SetListViewBounds 
   (port (:pointer :grafport))                  ;   in Carbon use Get/SetListPort 
   (indent :point)                              ;   in Carbon use Get/SetListCellIndent 
   (cellSize :point)                            ;   in Carbon use Get/SetListCellSize 
   (visible :rect)                              ;   in Carbon use GetListVisibleCells 
   (vScroll (:handle :controlrecord))           ;   in Carbon use GetListVerticalScrollBar 
   (hScroll (:handle :controlrecord))           ;   in Carbon use GetListHorizontalScrollBar 
   (selFlags :signed-byte)                      ;   in Carbon use Get/SetListSelectionFlags 
   (lActive :boolean)                           ;   in Carbon use LActivate, GetListActive 
   (lReserved :signed-byte)                     ;   not supported in Carbon  
   (listFlags :signed-byte)                     ;   in Carbon use Get/SetListFlags  
   (clikTime :signed-long)                      ;   in Carbon use Get/SetListClickTime 
   (clikLoc :point)                             ;   in Carbon use GetListClickLocation 
   (mouseLoc :point)                            ;   in Carbon use GetListMouseLocation 
   (lClickLoop :pointer)                        ;   in Carbon use Get/SetListClickLoop 
   (lastClick :point)                           ;   in Carbon use SetListLastClick 
   (refCon :signed-long)                        ;   in Carbon use Get/SetListRefCon 
   (listDefProc :handle)                        ;   not supported in Carbon  
   (userHandle :handle)                         ;   in Carbon use Get/SetListUserHandle 
   (dataBounds :rect)                           ;   in Carbon use GetListDataBounds 
   (cells (:handle :dataarray))                 ;   in Carbon use LGet/SetCell 
   (maxIndex :signed-integer)                   ;   in Carbon use LGet/SetCell 
   (cellArray (:array :signed-integer 1))       ;   in Carbon use LGet/SetCell 
   )

(def-mactype :listptr (find-mactype '(:pointer :listrec)))
(def-mactype :listhandle (find-mactype '(:handle :listrec)))
;   ListRef is obsolete.  Use ListHandle.  
(def-mactype :listref (find-mactype '(:handle :listrec)))

;   ListRec.listFlags bits 
(defconstant $lDrawingModeOffBit 3)
(defconstant $lDoVAutoscrollBit 1)
(defconstant $lDoHAutoscrollBit 0)

;   ListRec.listFlags masks 
(defconstant $lDrawingModeOff 8)
(defconstant $lDoVAutoscroll 2)
(defconstant $lDoHAutoscroll 1)

;   ListRec.selFlags bits 
(defconstant $lOnlyOneBit 7)
(defconstant $lExtendDragBit 6)
(defconstant $lNoDisjointBit 5)
(defconstant $lNoExtendBit 4)
(defconstant $lNoRectBit 3)
(defconstant $lUseSenseBit 2)
(defconstant $lNoNilHiliteBit 1)

;   ListRec.selFlags masks 
(defconstant $lOnlyOne -128)
(defconstant $lExtendDrag 64)
(defconstant $lNoDisjoint 32)
(defconstant $lNoExtend 16)
(defconstant $lNoRect 8)
(defconstant $lUseSense 4)
(defconstant $lNoNilHilite 2)

;   LDEF messages 
(defconstant $lInitMsg 0)
(defconstant $lDrawMsg 1)
(defconstant $lHiliteMsg 2)
(defconstant $lCloseMsg 3)

; 
; 	   StandardIconListCellDataRec is the cell data format for
; 	   use with the standard icon list (kListDefStandardIconType).
; 	

(def-mactype :standardiconlistcelldatarecptr (find-mactype '(:pointer :standardiconlistcelldatarec)))
(defrecord StandardIconListCellDataRec 
   (iconHandle :handle)
   (font :signed-integer)
   (face :signed-integer)
   (size :signed-integer)
   (name (:string 255))
   )

(def-mactype :standardiconlistcelldataptr (find-mactype '(:pointer :standardiconlistcelldatarec)))

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ListDefProcPtr = PROCEDURE(lMessage: INTEGER; lSelect: BOOLEAN; VAR lRect: Rect; lCell: Cell; lDataOffset: INTEGER; lDataLen: INTEGER; lHandle: ListHandle);

|#
 |#                                             ; $ELSEC
(def-mactype :listdefprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :listdefupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :listdefupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppListSearchProcInfo #x2BE0)
(defconstant $uppListClickLoopProcInfo #x12)
(defconstant $uppListDefProcInfo #xEBD80)
; 
; 	 *  NewListSearchUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewListSearchProc 
(deftrap "_NewListSearchUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewListClickLoopUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewListClickLoopProc 
(deftrap "_NewListClickLoopUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewListDefUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewListDefProc 
(deftrap "_NewListDefUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeListSearchUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeListSearchUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeListClickLoopUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeListClickLoopUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeListDefUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeListDefUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeListSearchUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallListSearchProc 
(deftrap-inline "_InvokeListSearchUPP" 
      ((aPtr :pointer) (bPtr :pointer) (aLen :signed-integer) (bLen :signed-integer) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeListClickLoopUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallListClickLoopProc           ; 
;  *  InvokeListDefUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InvokeListClickLoopUPP" 
      ((userRoutine :pointer)) 
  :boolean
   () )                                         ;  old name was CallListDefProc 
(deftrap-inline "_InvokeListDefUPP" 
      ((lMessage :signed-integer) (lSelect :boolean) (lRect (:pointer :rect)) (lCell :point) (lDataOffset :signed-integer) (lDataLen :signed-integer) (lHandle (:handle :listrec)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

(defconstant $kListDefProcPtr 0)
(defconstant $kListDefUserProcType 0)
(defconstant $kListDefStandardTextType 1)
(defconstant $kListDefStandardIconType 2)

(def-mactype :listdeftype (find-mactype ':unsigned-long))
(def-mactype :listdefspecptr (find-mactype '(:pointer :listdefspec)))
(defrecord ListDefSpec 
   (defType :unsigned-long)
   (:variant 
      (
      (userProc :pointer)
      )
      )
   )

; 
; 	 *  CreateCustomList()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; CONST                                         ; CONST; CONST
#|                                              ; $IFC NOT TARGET_OS_MAC ;  QuickTime 3.0 
(deftrap-inline "_CreateCustomList" 
      ((rView (:pointer :rect)) (dataBounds (:pointer :rect)) (cellSize :point) (theSpec (:pointer :listdefspec)) (theWindow (:pointer :windowrecord)) (drawIt :boolean) (hasGrow :boolean) (scrollHoriz :boolean) (scrollVert :boolean) (outList (:pointer (:handle :listrec)))) 
  :osstatus
   () )
; $IFC TYPED_FUNCTION_POINTERS
#|
	ListNotificationProcPtr = PROCEDURE(theList: ListHandle; notification: ListNotification; param: LONGINT);

|#                                              ; $ELSEC
(def-mactype :listnotificationprocptr (find-mactype ':pointer))
; $ENDC

(def-mactype :listnotificationupp (find-mactype ':listnotificationprocptr))
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  LSetNotificationCallback()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_LSetNotificationCallback" 
      ((callBack :listnotificationprocptr) (lHandle (:handle :listrec))) 
  nil
   () )

; 
;  *  GetListVisibleBounds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetListVisibleBounds" 
      ((theList (:handle :listrec)) (visibleBounds (:pointer :rect))) 
  nil
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC

; 
;  *  LNew()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap "_LNew" 
      ((rView (:pointer :rect)) (dataBounds (:pointer :rect)) (cSize :point) (theProc :signed-integer) (theWindow (:pointer :windowrecord)) (drawIt :boolean) (hasGrow :boolean) (scrollHoriz :boolean) (scrollVert :boolean))
   (:stack (:handle :listrec))
   (:stack-trap #xA9E7 rView dataBounds cSize theProc theWindow drawIt hasGrow scrollHoriz scrollVert (68 :signed-integer)))

; 
;  *  LDispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LDispose" 
      ((lHandle (:handle :listrec)))
   nil
   (:stack-trap #xA9E7 lHandle (40 :signed-integer)))

; 
;  *  LAddColumn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LAddColumn" 
      ((count :signed-integer) (colNum :signed-integer) (lHandle (:handle :listrec)))
   (:stack :signed-integer)
   (:stack-trap #xA9E7 count colNum lHandle (4 :signed-integer)))

; 
;  *  LAddRow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LAddRow" 
      ((count :signed-integer) (rowNum :signed-integer) (lHandle (:handle :listrec)))
   (:stack :signed-integer)
   (:stack-trap #xA9E7 count rowNum lHandle (8 :signed-integer)))

; 
;  *  LDelColumn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LDelColumn" 
      ((count :signed-integer) (colNum :signed-integer) (lHandle (:handle :listrec)))
   nil
   (:stack-trap #xA9E7 count colNum lHandle (32 :signed-integer)))

; 
;  *  LDelRow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LDelRow" 
      ((count :signed-integer) (rowNum :signed-integer) (lHandle (:handle :listrec)))
   nil
   (:stack-trap #xA9E7 count rowNum lHandle (36 :signed-integer)))

; 
;  *  LGetSelect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LGetSelect" 
      ((next :boolean) (theCell (:pointer :point)) (lHandle (:handle :listrec)))
   (:stack :boolean)
   (:stack-trap #xA9E7 next theCell lHandle (60 :signed-integer)))

; 
;  *  LLastClick()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LLastClick" 
      ((lHandle (:handle :listrec)))
   (:stack :point)
   (:stack-trap #xA9E7 lHandle (64 :signed-integer)))

; 
;  *  LNextCell()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LNextCell" 
      ((hNext :boolean) (vNext :boolean) (theCell (:pointer :point)) (lHandle (:handle :listrec)))
   (:stack :boolean)
   (:stack-trap #xA9E7 hNext vNext theCell lHandle (72 :signed-integer)))

; 
;  *  LSearch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LSearch" 
      ((dataPtr :pointer) (dataLen :signed-integer) (searchProc :pointer) (theCell (:pointer :point)) (lHandle (:handle :listrec)))
   (:stack :boolean)
   (:stack-trap #xA9E7 dataPtr dataLen searchProc theCell lHandle (84 :signed-integer)))

; 
;  *  LSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LSize" 
      ((listWidth :signed-integer) (listHeight :signed-integer) (lHandle (:handle :listrec)))
   nil
   (:stack-trap #xA9E7 listWidth listHeight lHandle (96 :signed-integer)))

; 
;  *  LSetDrawingMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LSetDrawingMode" 
      ((drawIt :boolean) (lHandle (:handle :listrec)))
   nil
   (:stack-trap #xA9E7 drawIt lHandle (44 :signed-integer)))

; 
;  *  LScroll()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LScroll" 
      ((dCols :signed-integer) (dRows :signed-integer) (lHandle (:handle :listrec)))
   nil
   (:stack-trap #xA9E7 dCols dRows lHandle (80 :signed-integer)))

; 
;  *  LAutoScroll()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LAutoScroll" 
      ((lHandle (:handle :listrec)))
   nil
   (:stack-trap #xA9E7 lHandle (16 :signed-integer)))

; 
;  *  LUpdate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LUpdate" 
      ((theRgn (:handle :macregion)) (lHandle (:handle :listrec)))
   nil
   (:stack-trap #xA9E7 theRgn lHandle (100 :signed-integer)))

; 
;  *  LActivate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LActivate" 
      ((act :boolean) (lHandle (:handle :listrec))) 
  nil
   (#x4267 #xA9E7) )

; 
;  *  LCellSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LCellSize" 
      ((cSize :point) (lHandle (:handle :listrec)))
   nil
   (:stack-trap #xA9E7 cSize lHandle (20 :signed-integer)))

; 
;  *  LClick()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LClick" 
      ((pt :point) (modifiers :unsigned-integer) (lHandle (:handle :listrec)))
   (:stack :boolean)
   (:stack-trap #xA9E7 pt modifiers lHandle (24 :signed-integer)))

; 
;  *  LAddToCell()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LAddToCell" 
      ((dataPtr :pointer) (dataLen :signed-integer) (theCell :point) (lHandle (:handle :listrec)))
   nil
   (:stack-trap #xA9E7 dataPtr dataLen theCell lHandle (12 :signed-integer)))

; 
;  *  LClrCell()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LClrCell" 
      ((theCell :point) (lHandle (:handle :listrec)))
   nil
   (:stack-trap #xA9E7 theCell lHandle (28 :signed-integer)))

; 
;  *  LGetCell()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LGetCell" 
      ((dataPtr :pointer) (dataLen (:pointer :signed-integer)) (theCell :point) (lHandle (:handle :listrec)))
   nil
   (:stack-trap #xA9E7 dataPtr dataLen theCell lHandle (56 :signed-integer)))

; 
;  *  LRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LRect" 
      ((cellRect (:pointer :rect)) (theCell :point) (lHandle (:handle :listrec)))
   nil
   (:stack-trap #xA9E7 cellRect theCell lHandle (76 :signed-integer)))

; 
;  *  LSetCell()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LSetCell" 
      ((dataPtr :pointer) (dataLen :signed-integer) (theCell :point) (lHandle (:handle :listrec)))
   nil
   (:stack-trap #xA9E7 dataPtr dataLen theCell lHandle (88 :signed-integer)))

; 
;  *  LSetSelect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LSetSelect" 
      ((setIt :boolean) (theCell :point) (lHandle (:handle :listrec)))
   nil
   (:stack-trap #xA9E7 setIt theCell lHandle (92 :signed-integer)))

; 
;  *  LDraw()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LDraw" 
      ((theCell :point) (lHandle (:handle :listrec)))
   nil
   (:stack-trap #xA9E7 theCell lHandle (48 :signed-integer)))

; 
;  *  LGetCellDataLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LGetCellDataLocation" 
      ((offset (:pointer :signed-integer)) (len (:pointer :signed-integer)) (theCell :point) (lHandle (:handle :listrec)))
   nil
   (:stack-trap #xA9E7 offset len theCell lHandle (52 :signed-integer)))

;   Routines available in Carbon only 

; 
;  *  RegisterListDefinition()
;  *  
;  *  Summary:
;  *    Registers a binding between a resource ID and a list definition
;  *    function.
;  *  
;  *  Discussion:
;  *    In the Mac OS 8.x List Manager, a 'ldes' resource can contain an
;  *    embedded LDEF procID that is used by the List Manager as the
;  *    resource ID of an 'LDEF' resource to measure and draw the list.
;  *    Since LDEFs can no longer be packaged as code resources on
;  *    Carbon, the procID can no longer refer directly to an LDEF
;  *    resource. However, using RegisterListDefinition you can instead
;  *    specify a UniversalProcPtr pointing to code in your application
;  *    code fragment.
;  *  
;  *  Parameters:
;  *    
;  *    inResID:
;  *      An LDEF proc ID, as used in a 'ldes' resource.
;  *    
;  *    inDefSpec:
;  *      Specifies the ListDefUPP that should be used for lists with the
;  *      given LDEF procID.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; $IFC CALL_NOT_IN_CARBON                       ; $IFC CALL_NOT_IN_CARBON ; 
;  *  SetListDefinitionProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_RegisterListDefinition" 
      ((inResID :signed-integer) (inDefSpec (:pointer :listdefspec))) 
  :osstatus
   () )
(deftrap-inline "_SetListDefinitionProc" 
      ((resID :signed-integer) (defProc :pointer)) 
  :signed-integer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC NOT TARGET_OS_MAC 
;  QuickTime 3.0 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LSetLDEF()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LSetLDEF" 
      ((proc :pointer) (lHandle (:handle :listrec))) 
  nil
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC

; $IFC OLDROUTINENAMES 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LDoDraw()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LDoDraw" 
      ((drawIt :boolean) (lHandle (:handle :listrec)))
   nil
   (:stack-trap #xA9E7 drawIt lHandle (44 :signed-integer)))

; 
;  *  LFind()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LFind" 
      ((offset (:pointer :signed-integer)) (len (:pointer :signed-integer)) (theCell :point) (lHandle (:handle :listrec)))
   nil
   (:stack-trap #xA9E7 offset len theCell lHandle (52 :signed-integer)))

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; OLDROUTINENAMES

; $IFC ACCESSOR_CALLS_ARE_FUNCTIONS 
;  Getters 
; 
;  *  GetListViewBounds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  GetListPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetListViewBounds" 
      ((list (:handle :listrec)) (view (:pointer :rect))) 
  (:pointer :rect)
   () )                                         ; 
;  *  GetListCellIndent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetListPort" 
      ((list (:handle :listrec))) 
  (:pointer :cgrafport)
   () )                                         ; 
;  *  GetListCellSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetListCellIndent" 
      ((list (:handle :listrec)) (indent (:pointer :point))) 
  (:pointer :point)
   () )                                         ; 
;  *  GetListVisibleCells()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetListCellSize" 
      ((list (:handle :listrec)) (size (:pointer :point))) 
  (:pointer :point)
   () )                                         ; 
;  *  GetListVerticalScrollBar()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetListVisibleCells" 
      ((list (:handle :listrec)) (visible (:pointer :rect))) 
  (:pointer :rect)
   () )                                         ; 
;  *  GetListHorizontalScrollBar()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetListVerticalScrollBar" 
      ((list (:handle :listrec))) 
  (:handle :controlrecord)
   () )                                         ; 
;  *  GetListActive()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetListHorizontalScrollBar" 
      ((list (:handle :listrec))) 
  (:handle :controlrecord)
   () )                                         ; 
;  *  GetListClickTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetListActive" 
      ((list (:handle :listrec))) 
  :boolean
   () )                                         ; 
;  *  GetListClickLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetListClickTime" 
      ((list (:handle :listrec))) 
  :signed-long
   () )                                         ; 
;  *  GetListMouseLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetListClickLocation" 
      ((list (:handle :listrec)) (click (:pointer :point))) 
  (:pointer :point)
   () )                                         ; 
;  *  GetListClickLoop()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetListMouseLocation" 
      ((list (:handle :listrec)) (mouse (:pointer :point))) 
  (:pointer :point)
   () )                                         ; 
;  *  GetListRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetListClickLoop" 
      ((list (:handle :listrec))) 
  :pointer
   () )                                         ; 
;  *  GetListDefinition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetListRefCon" 
      ((list (:handle :listrec))) 
  :signed-long
   () )                                         ; 
;  *  GetListUserHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetListDefinition" 
      ((list (:handle :listrec))) 
  :handle
   () )                                         ; 
;  *  GetListDataBounds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetListUserHandle" 
      ((list (:handle :listrec))) 
  :handle
   () )                                         ; 
;  *  GetListDataHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetListDataBounds" 
      ((list (:handle :listrec)) (bounds (:pointer :rect))) 
  (:pointer :rect)
   () )                                         ; 
;  *  GetListFlags()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetListDataHandle" 
      ((list (:handle :listrec))) 
  (:handle :dataarray)
   () )                                         ; 
;  *  GetListSelectionFlags()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetListFlags" 
      ((list (:handle :listrec))) 
  :unsigned-long
   () )                                         ;  Setters ; 
;  *  SetListViewBounds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetListSelectionFlags" 
      ((list (:handle :listrec))) 
  :unsigned-long
   () )                                         ; CONST; 
;  *  SetListPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetListViewBounds" 
      ((list (:handle :listrec)) (view (:pointer :rect))) 
  nil
   () )                                         ; 
;  *  SetListCellIndent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetListPort" 
      ((list (:handle :listrec)) (port (:pointer :cgrafport))) 
  nil
   () )                                         ; 
;  *  SetListClickTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetListCellIndent" 
      ((list (:handle :listrec)) (indent (:pointer :point))) 
  nil
   () )                                         ; 
;  *  SetListClickLoop()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetListClickTime" 
      ((list (:handle :listrec)) (time :signed-long)) 
  nil
   () )                                         ; 
;  *  SetListLastClick()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetListClickLoop" 
      ((list (:handle :listrec)) (clickLoop :pointer)) 
  nil
   () )                                         ; 
;  *  SetListRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetListLastClick" 
      ((list (:handle :listrec)) (lastClick (:pointer :point))) 
  nil
   () )                                         ; 
;  *  SetListUserHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetListRefCon" 
      ((list (:handle :listrec)) (refCon :signed-long)) 
  nil
   () )                                         ; 
;  *  SetListFlags()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetListUserHandle" 
      ((list (:handle :listrec)) (userHandle :handle)) 
  nil
   () )                                         ; 
;  *  SetListSelectionFlags()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetListFlags" 
      ((list (:handle :listrec)) (listFlags :unsigned-long)) 
  nil
   () )
(deftrap-inline "_SetListSelectionFlags" 
      ((list (:handle :listrec)) (selectionFlags :unsigned-long)) 
  nil
   () )                                         ; $ENDC; ACCESSOR_CALLS_ARE_FUNCTIONS

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := ListsIncludes

; $ENDC                                         ; __LISTS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Lists)#|
; Warning: Did not recognize these types or records: (listnotificationprocptr)
|#