(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:LowMem.p"
; at Wednesday May 1,2002 2:40:08 pm.
; 
;      File:       LowMem.p
;  
;      Contains:   Low Memory Accessor Interfaces.
;  
;      Version:    Technology: Mac OS 8.1
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1993-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __LOWMEM__
; $SETC __LOWMEM__ := 1

; $I+
; $SETC LowMemIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACMEMORY__
|#

(require-interface 'MacMemory)
#|                                              ; $I MacMemory.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __OSUTILS__
|#

(require-interface 'OSUtils)
#|                                              ; $I OSUtils.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __RESOURCES__
|#

(require-interface 'Resources)
#|                                              ; $I Resources.p
 |#                                             ; $ENDC

#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CONTROLS__
|#

(require-interface 'Controls)
#|                                              ; $I Controls.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __EVENTS__
|#

(require-interface 'Events)
#|                                              ; $I Events.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MENUS__
|#

(require-interface 'Menus)
#|                                              ; $I Menus.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FONTS__
|#

(require-interface 'Fonts)
#|                                              ; $I Fonts.p
 |#                                             ; $ENDC
; $IFC NOT OPAQUE_TOOLBOX_STRUCTS 
#|                                              ; $IFC UNDEFINED __MACWINDOWS__
|#

(require-interface 'MacWindows)
#|                                              ; $I MacWindows.p
 |#                                             ; $ENDC
; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; *************************************************************************************
; 
;     SIMPLE LOWMEM ACCESSORS
; 
; *************************************************************************************
; 
;     The following functions were moved to Quickdraw.h:
;     
;         LMSetDeviceList
;         LMSetLastSPExtra
;         LMGetWidthListHand
;         LMSetWidthListHand
;         LMGetScrHRes
;         LMSetScrHRes
;         LMSetScrVRes
;         LMGetScrVRes
;         LMGetHiliteMode
;         LMSetHiliteMode
;         LMGetMainDevice
;         LMSetMainDevice
;         LMGetDeviceList
;         LMGetQDColors
;         LMSetQDColors
;         LMGetWidthPtr
;         LMSetWidthPtr
;         LMGetWidthTabHandle
;         LMSetWidthTabHandle
;         LMGetLastSPExtra
;         LMGetLastFOND
;         LMSetLastFOND
;         LMGetFractEnable
;         LMSetFractEnable
;         LMGetTheGDevice
;         LMSetTheGDevice
;         LMGetCursorNew
;         LMSetCursorNew
;         LMGetHiliteRGB
;         LMSetHiliteRGB
;     
;     The following functions were moved to TextEdit.h:
;     
;         LMGetWordRedraw
;         LMSetWordRedraw
; 
;     The following functions were moved to Menus.h:
;     
;         LMGetTheMenu
;     
;     The following functions were moved to Events.h:
;     
;         LMGetKeyRepThresh
;         LMSetKeyRepThresh
;         LMGetKeyThresh
;         LMSetKeyRepThresh
;         LMGetKbdLast
;         LMSetKbdLast
;         LMGetKbdType
;         LMSetKbdType
; 
; 

; 
;  *  LMGetMemTop()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetMemTop" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 264))))

; 
;  *  LMSetMemTop()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetMemTop" 
      ((value :pointer)) 
  nil
   (#x21DF #x108) )

; 
;  *  LMGetBufPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetBufPtr" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 268))))

; 
;  *  LMSetBufPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetBufPtr" 
      ((value :pointer)) 
  nil
   (#x21DF #x10C) )

; 
;  *  LMGetHeapEnd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetHeapEnd" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 276))))

; 
;  *  LMSetHeapEnd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetHeapEnd" 
      ((value :pointer)) 
  nil
   (#x21DF #x114) )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetTheZone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetTheZone" 
      ()
   (:no-trap (:pointer :zone))
   (:no-trap (%get-ptr (%int-to-ptr 280))))

; 
;  *  LMSetTheZone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetTheZone" 
      ((value (:pointer :zone))) 
  nil
   (#x21DF #x118) )

; 
;  *  LMGetUTableBase()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetUTableBase" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 284))))

; 
;  *  LMSetUTableBase()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetUTableBase" 
      ((value :pointer)) 
  nil
   (#x21DF #x11C) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  LMGetCPUFlag()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMGetCPUFlag" 
      () 
  :signed-byte
   (#x1EB8 #x12F) )

; 
;  *  LMSetCPUFlag()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetCPUFlag" 
      ((value :signed-byte)) 
  nil
   (#x11DF #x12F) )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetApplLimit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetApplLimit" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 304))))

; 
;  *  LMSetApplLimit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetApplLimit" 
      ((value :pointer)) 
  nil
   (#x21DF #x130) )

; 
;  *  LMGetSysEvtMask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetSysEvtMask" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 324))))

;   Carbon Usage: use SetEventMask 
; 
;  *  LMSetSysEvtMask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetSysEvtMask" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x144) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  LMGetRndSeed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetRndSeed" 
      ()
   (:no-trap :signed-long)
   (:no-trap (%get-signed-long (%int-to-ptr 342))))

; 
;  *  LMSetRndSeed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetRndSeed" 
      ((value :signed-long)) 
  nil
   (#x21DF #x156) )

; 
;  *  LMGetSEvtEnb()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMGetSEvtEnb" 
      () 
  :signed-byte
   (#x1EB8 #x15C) )

; 
;  *  LMSetSEvtEnb()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetSEvtEnb" 
      ((value :signed-byte)) 
  nil
   (#x11DF #x15C) )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetTicks()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetTicks" 
      ()
   (:no-trap :unsigned-long)
   (:no-trap (%get-unsigned-long (%int-to-ptr 362))))

; 
;  *  LMSetTicks()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetTicks" 
      ((value :unsigned-long)) 
  nil
   (#x21DF #x16A) )

; 
;  *  LMGetVIA()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetVIA" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 468))))

; 
;  *  LMSetVIA()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetVIA" 
      ((value :pointer)) 
  nil
   (#x21DF #x1D4) )

; 
;  *  LMGetSCCRd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetSCCRd" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 472))))

; 
;  *  LMSetSCCRd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetSCCRd" 
      ((value :pointer)) 
  nil
   (#x21DF #x1D8) )

; 
;  *  LMGetSCCWr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetSCCWr" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 476))))

; 
;  *  LMSetSCCWr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetSCCWr" 
      ((value :pointer)) 
  nil
   (#x21DF #x1DC) )

; 
;  *  LMGetSPValid()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMGetSPValid" 
      () 
  :signed-byte
   (#x1EB8 #x1F8) )

; 
;  *  LMSetSPValid()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetSPValid" 
      ((value :signed-byte)) 
  nil
   (#x11DF #x1F8) )

; 
;  *  LMGetSPATalkA()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMGetSPATalkA" 
      () 
  :signed-byte
   (#x1EB8 #x1F9) )

; 
;  *  LMSetSPATalkA()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetSPATalkA" 
      ((value :signed-byte)) 
  nil
   (#x11DF #x1F9) )

; 
;  *  LMGetSPATalkB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMGetSPATalkB" 
      () 
  :signed-byte
   (#x1EB8 #x1FA) )

; 
;  *  LMSetSPATalkB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetSPATalkB" 
      ((value :signed-byte)) 
  nil
   (#x11DF #x1FA) )

; 
;  *  LMGetSPConfig()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMGetSPConfig" 
      () 
  :signed-byte
   (#x1EB8 #x1FB) )

; 
;  *  LMSetSPConfig()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetSPConfig" 
      ((value :signed-byte)) 
  nil
   (#x11DF #x1FB) )

; 
;  *  LMGetSPPortA()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetSPPortA" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 508))))

; 
;  *  LMSetSPPortA()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetSPPortA" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x1FC) )

; 
;  *  LMGetSPPortB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetSPPortB" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 510))))

; 
;  *  LMSetSPPortB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetSPPortB" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x1FE) )

; 
;  *  LMGetSPAlarm()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetSPAlarm" 
      ()
   (:no-trap :signed-long)
   (:no-trap (%get-signed-long (%int-to-ptr 512))))

; 
;  *  LMSetSPAlarm()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetSPAlarm" 
      ((value :signed-long)) 
  nil
   (#x21DF #x200) )

; 
;  *  LMGetSPFont()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetSPFont" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 516))))

; 
;  *  LMSetSPFont()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetSPFont" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x204) )

; 
;  *  LMGetSPKbd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMGetSPKbd" 
      () 
  :signed-byte
   (#x1EB8 #x206) )

; 
;  *  LMSetSPKbd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetSPKbd" 
      ((value :signed-byte)) 
  nil
   (#x11DF #x206) )

; 
;  *  LMGetSPPrint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMGetSPPrint" 
      () 
  :signed-byte
   (#x1EB8 #x207) )

; 
;  *  LMSetSPPrint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetSPPrint" 
      ((value :signed-byte)) 
  nil
   (#x11DF #x207) )

; 
;  *  LMGetSPVolCtl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMGetSPVolCtl" 
      () 
  :signed-byte
   (#x1EB8 #x208) )

; 
;  *  LMSetSPVolCtl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetSPVolCtl" 
      ((value :signed-byte)) 
  nil
   (#x11DF #x208) )

; 
;  *  LMGetSPClikCaret()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMGetSPClikCaret" 
      () 
  :signed-byte
   (#x1EB8 #x209) )

; 
;  *  LMSetSPClikCaret()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetSPClikCaret" 
      ((value :signed-byte)) 
  nil
   (#x11DF #x209) )

; 
;  *  LMGetSPMisc2()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMGetSPMisc2" 
      () 
  :signed-byte
   (#x1EB8 #x20B) )

; 
;  *  LMSetSPMisc2()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetSPMisc2" 
      ((value :signed-byte)) 
  nil
   (#x11DF #x20B) )

;   Carbon Usage: use GetDateTime 
; 
;  *  LMGetTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetTime" 
      ()
   (:no-trap :signed-long)
   (:no-trap (%get-signed-long (%int-to-ptr 524))))

;   Carbon Usage: use SetDateTime 
; 
;  *  LMSetTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetTime" 
      ((value :signed-long)) 
  nil
   (#x21DF #x20C) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  LMGetBootDrive()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetBootDrive" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 528))))

; 
;  *  LMSetBootDrive()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetBootDrive" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x210) )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetSFSaveDisk()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetSFSaveDisk" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 532))))

; 
;  *  LMSetSFSaveDisk()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetSFSaveDisk" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x214) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  LMGetMemErr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetMemErr" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 544))))

; 
;  *  LMSetMemErr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetMemErr" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x220) )

; 
;  *  LMGetSdVolume()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMGetSdVolume" 
      () 
  :signed-byte
   (#x1EB8 #x260) )

; 
;  *  LMSetSdVolume()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetSdVolume" 
      ((value :signed-byte)) 
  nil
   (#x11DF #x260) )

; 
;  *  LMGetSoundPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetSoundPtr" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 610))))

; 
;  *  LMSetSoundPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetSoundPtr" 
      ((value :pointer)) 
  nil
   (#x21DF #x262) )

; 
;  *  LMGetSoundBase()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetSoundBase" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 614))))

; 
;  *  LMSetSoundBase()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetSoundBase" 
      ((value :pointer)) 
  nil
   (#x21DF #x266) )

; 
;  *  LMGetSoundLevel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMGetSoundLevel" 
      () 
  :signed-byte
   (#x1EB8 #x27F) )

; 
;  *  LMSetSoundLevel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetSoundLevel" 
      ((value :signed-byte)) 
  nil
   (#x11DF #x27F) )

; 
;  *  LMGetCurPitch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetCurPitch" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 640))))

; 
;  *  LMSetCurPitch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetCurPitch" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x280) )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetROM85()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetROM85" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 654))))

; 
;  *  LMSetROM85()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetROM85" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x28E) )

; 
;  *  LMGetPortBUse()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMGetPortBUse" 
      () 
  :signed-byte
   (#x1EB8 #x291) )

; 
;  *  LMSetPortBUse()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetPortBUse" 
      ((value :signed-byte)) 
  nil
   (#x11DF #x291) )

; 
;  *  LMGetGNEFilter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetGNEFilter" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 666))))

; 
;  *  LMSetGNEFilter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetGNEFilter" 
      ((value :pointer)) 
  nil
   (#x21DF #x29A) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  LMGetSysZone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetSysZone" 
      ()
   (:no-trap (:pointer :zone))
   (:no-trap (%get-ptr (%int-to-ptr 678))))

; 
;  *  LMSetSysZone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetSysZone" 
      ((value (:pointer :zone))) 
  nil
   (#x21DF #x2A6) )

; 
;  *  LMGetApplZone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetApplZone" 
      ()
   (:no-trap (:pointer :zone))
   (:no-trap (%get-ptr (%int-to-ptr 682))))

; 
;  *  LMSetApplZone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetApplZone" 
      ((value (:pointer :zone))) 
  nil
   (#x21DF #x2AA) )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetROMBase()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetROMBase" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 686))))

; 
;  *  LMSetROMBase()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetROMBase" 
      ((value :pointer)) 
  nil
   (#x21DF #x2AE) )

; 
;  *  LMGetRAMBase()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetRAMBase" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 690))))

; 
;  *  LMSetRAMBase()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetRAMBase" 
      ((value :pointer)) 
  nil
   (#x21DF #x2B2) )

; 
;  *  LMGetDSAlertTab()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetDSAlertTab" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 698))))

; 
;  *  LMSetDSAlertTab()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetDSAlertTab" 
      ((value :pointer)) 
  nil
   (#x21DF #x2BA) )

; 
;     NOTE:   LMGetABusVars and LMSetABusVars have been removed.
;             Their implememtation in InterfaceLib was inconsistent
;             with their prototypes here.  In InterfaceLib LMSetABusVars 
;             would copy eight bytes and LMGetABusVars would return the
;             value 0x02D8 instead of the long at that location.
;             
;             Use LMGetABusGlobals/LMSetABusGlobals to get/set the
;             long at location 0x02D8 which is a pointer to the AppleTalk
;             globals.  Use LMGetABusDCE/LMSetABusDCE to get/set the
;             long at location 0x02DC which is the .MPP driver
;             Device Control Entry. 
;             
; 
; 
;  *  LMGetABusGlobals()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetABusGlobals" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 728))))

; 
;  *  LMGetABusDCE()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetABusDCE" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 732))))

; 
;  *  LMSetABusGlobals()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetABusGlobals" 
      ((value :pointer)) 
  nil
   (#x21DF #x2D8) )

; 
;  *  LMSetABusDCE()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetABusDCE" 
      ((value :pointer)) 
  nil
   (#x21DF #x2DC) )

;   Carbon Usage: use GetDblTime 
; 
;  *  LMGetDoubleTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetDoubleTime" 
      ()
   (:no-trap :unsigned-long)
   (:no-trap (%get-unsigned-long (%int-to-ptr 752))))

; 
;  *  LMSetDoubleTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetDoubleTime" 
      ((value :unsigned-long)) 
  nil
   (#x21DF #x2F0) )

;   Carbon Usage: use GetCaretTime 
; 
;  *  LMGetCaretTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetCaretTime" 
      ()
   (:no-trap :unsigned-long)
   (:no-trap (%get-unsigned-long (%int-to-ptr 756))))

; 
;  *  LMSetCaretTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetCaretTime" 
      ((value :unsigned-long)) 
  nil
   (#x21DF #x2F4) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  LMGetScrDmpEnb()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMGetScrDmpEnb" 
      () 
  :signed-byte
   (#x1EB8 #x2F8) )

; 
;  *  LMSetScrDmpEnb()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetScrDmpEnb" 
      ((value :signed-byte)) 
  nil
   (#x11DF #x2F8) )

; 
;  *  LMGetBufTgFNum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetBufTgFNum" 
      ()
   (:no-trap :signed-long)
   (:no-trap (%get-signed-long (%int-to-ptr 764))))

; 
;  *  LMSetBufTgFNum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetBufTgFNum" 
      ((value :signed-long)) 
  nil
   (#x21DF #x2FC) )

; 
;  *  LMGetBufTgFFlg()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetBufTgFFlg" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 768))))

; 
;  *  LMSetBufTgFFlg()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetBufTgFFlg" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x300) )

; 
;  *  LMGetBufTgFBkNum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetBufTgFBkNum" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 770))))

; 
;  *  LMSetBufTgFBkNum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetBufTgFBkNum" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x302) )

; 
;  *  LMGetBufTgDate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetBufTgDate" 
      ()
   (:no-trap :signed-long)
   (:no-trap (%get-signed-long (%int-to-ptr 772))))

; 
;  *  LMSetBufTgDate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetBufTgDate" 
      ((value :signed-long)) 
  nil
   (#x21DF #x304) )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetLo3Bytes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetLo3Bytes" 
      ()
   (:no-trap :signed-long)
   (:no-trap (%get-signed-long (%int-to-ptr 794))))

; 
;  *  LMSetLo3Bytes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetLo3Bytes" 
      ((value :signed-long)) 
  nil
   (#x21DF #x31A) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  LMGetMinStack()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetMinStack" 
      ()
   (:no-trap :signed-long)
   (:no-trap (%get-signed-long (%int-to-ptr 798))))

; 
;  *  LMSetMinStack()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetMinStack" 
      ((value :signed-long)) 
  nil
   (#x21DF #x31E) )

; 
;  *  LMGetDefltStack()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetDefltStack" 
      ()
   (:no-trap :signed-long)
   (:no-trap (%get-signed-long (%int-to-ptr 802))))

; 
;  *  LMSetDefltStack()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetDefltStack" 
      ((value :signed-long)) 
  nil
   (#x21DF #x322) )

; 
;  *  LMGetGZRootHnd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetGZRootHnd" 
      ()
   (:no-trap :handle)
   (:no-trap (%get-ptr (%int-to-ptr 808))))

; 
;  *  LMSetGZRootHnd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetGZRootHnd" 
      ((value :handle)) 
  nil
   (#x21DF #x328) )

; 
;  *  LMGetGZMoveHnd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetGZMoveHnd" 
      ()
   (:no-trap :handle)
   (:no-trap (%get-ptr (%int-to-ptr 816))))

; 
;  *  LMSetGZMoveHnd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetGZMoveHnd" 
      ((value :handle)) 
  nil
   (#x21DF #x330) )

; 
;    LMGetFCBSPtr, LMSetFCBSPtr and LMSetFSFCBLen are not supported with Mac OS 9
;    and later. Access to information in File Control Blocks or Fork Control Blocks
;    (FCBs) should, if at all possible, be made with the GetFCBInfo or GetForkCBInfo
;    routines. See the Technote "FCBs, Now and Forever" or the Technical Q&A
;    "Accessing File Control Blocks" for complete information on this subject.
;    Direct access to FCBs is not allowed by Carbon. Non-Carbon programs that
;    require direct access to FCBs should use the File System Manager (FSM) FCB accessor
;    functions if FSM is available (use the Gestalt selector gestaltFSAttr to determine
;    this). Non-Carbon programs needing direct access to FCBs when FSM is not available
;    can define ENABLE_FCB_ARRAY_ACCESS to be true when compiling.
; 
; $IFC UNDEFINED ENABLE_FCB_ARRAY_ACCESS 
; $SETC ENABLE_FCB_ARRAY_ACCESS := 0 
; $ENDC

#|                                              ; $IFC ENABLE_FCB_ARRAY_ACCESS 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetFCBSPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetFCBSPtr" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 846))))

; 
;  *  LMSetFCBSPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetFCBSPtr" 
      ((value :pointer)) 
  nil
   (#x21DF #x34E) )

; 
;  *  LMSetFSFCBLen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetFSFCBLen" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x3F6) )

; $ENDC                                         ; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC; ENABLE_FCB_ARRAY_ACCESS

; 
;    LMGetFSFCBLen is supported only for the purpose of determining that the HFS
;    file system is available as documented in developer Technotes (the HFS file system
;    is available in System 3.2 and later). There is no documented use of FSFCBLen
;    other than testing it for a positive value.
; 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetFSFCBLen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetFSFCBLen" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 1014))))

; 
;  *  LMGetDefVCBPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetDefVCBPtr" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 850))))

; 
;  *  LMSetDefVCBPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetDefVCBPtr" 
      ((value :pointer)) 
  nil
   (#x21DF #x352) )

; 
;  *  LMGetCurDirStore()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetCurDirStore" 
      ()
   (:no-trap :signed-long)
   (:no-trap (%get-signed-long (%int-to-ptr 920))))

; 
;  *  LMSetCurDirStore()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetCurDirStore" 
      ((value :signed-long)) 
  nil
   (#x21DF #x398) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  LMGetToExtFS()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetToExtFS" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 1010))))

; 
;  *  LMSetToExtFS()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetToExtFS" 
      ((value :pointer)) 
  nil
   (#x21DF #x3F2) )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetScrnBase()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetScrnBase" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 2084))))

; 
;  *  LMSetScrnBase()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetScrnBase" 
      ((value :pointer)) 
  nil
   (#x21DF #x824) )

; 
;  *  LMGetCrsrBusy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMGetCrsrBusy" 
      () 
  :signed-byte
   (#x1EB8 #x8CD) )

; 
;  *  LMSetCrsrBusy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetCrsrBusy" 
      ((value :signed-byte)) 
  nil
   (#x11DF #x8CD) )

; 
;  *  LMGetJournalRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetJournalRef" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2280))))

; 
;  *  LMSetJournalRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetJournalRef" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x8E8) )

; 
;  *  LMGetCrsrThresh()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetCrsrThresh" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2284))))

; 
;  *  LMSetCrsrThresh()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetCrsrThresh" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x8EC) )

; 
;  *  LMGetJFetch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetJFetch" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 2292))))

; 
;  *  LMSetJFetch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetJFetch" 
      ((value :pointer)) 
  nil
   (#x21DF #x8F4) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  LMGetJStash()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetJStash" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 2296))))

; 
;  *  LMSetJStash()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetJStash" 
      ((value :pointer)) 
  nil
   (#x21DF #x8F8) )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetJIODone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetJIODone" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 2300))))

; 
;  *  LMSetJIODone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetJIODone" 
      ((value :pointer)) 
  nil
   (#x21DF #x8FC) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  LMGetCurApRefNum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetCurApRefNum" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2304))))

; 
;  *  LMSetCurApRefNum()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetCurApRefNum" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x900) )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetCurrentA5()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetCurrentA5" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 2308))))

; 
;  *  LMSetCurrentA5()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetCurrentA5" 
      ((value :pointer)) 
  nil
   (#x21DF #x904) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  LMGetCurStackBase()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetCurStackBase" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 2312))))

; 
;  *  LMSetCurStackBase()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetCurStackBase" 
      ((value :pointer)) 
  nil
   (#x21DF #x908) )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetCurJTOffset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetCurJTOffset" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2356))))

; 
;  *  LMSetCurJTOffset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetCurJTOffset" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x934) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  LMGetCurPageOption()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetCurPageOption" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2358))))

; 
;  *  LMSetCurPageOption()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetCurPageOption" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x936) )

; 
;  *  LMGetPrintErr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetPrintErr" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2372))))

; 
;  *  LMSetPrintErr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetPrintErr" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x944) )

;    Carbon Scrap Manager does not support low memory. 

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetScrapSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetScrapSize" 
      ()
   (:no-trap :signed-long)
   (:no-trap (%get-signed-long (%int-to-ptr 2400))))

; 
;  *  LMSetScrapSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetScrapSize" 
      ((value :signed-long)) 
  nil
   (#x21DF #x960) )

; 
;  *  LMGetScrapHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetScrapHandle" 
      ()
   (:no-trap :handle)
   (:no-trap (%get-ptr (%int-to-ptr 2404))))

; 
;  *  LMSetScrapHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetScrapHandle" 
      ((value :handle)) 
  nil
   (#x21DF #x964) )

; 
;  *  LMGetScrapCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetScrapCount" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2408))))

; 
;  *  LMSetScrapCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetScrapCount" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x968) )

; 
;  *  LMGetScrapState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetScrapState" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2410))))

; 
;  *  LMSetScrapState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetScrapState" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x96A) )

; 
;  *  LMGetScrapName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetScrapName" 
      ()
   (:no-trap (:pointer (:string 255)))
   (:no-trap (%get-ptr (%int-to-ptr 2412))))

; 
;  *  LMSetScrapName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetScrapName" 
      ((value (:pointer (:string 255)))) 
  nil
   (#x21DF #x96C) )

; 
;  *  LMGetROMFont0()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetROMFont0" 
      ()
   (:no-trap :handle)
   (:no-trap (%get-ptr (%int-to-ptr 2432))))

; 
;  *  LMSetROMFont0()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetROMFont0" 
      ((value :handle)) 
  nil
   (#x21DF #x980) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  LMGetApFontID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetApFontID" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2436))))

; 
;  *  LMSetApFontID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetApFontID" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x984) )

;  Carbon versions of the Window Manager do not support LowMem. 
;   Carbon Usage: use GetWindowList 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetWindowList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetWindowList" 
      ()
   (:no-trap (:pointer :windowrecord))
   (:no-trap (%get-ptr (%int-to-ptr 2518))))

; 
;  *  LMGetSaveUpdate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetSaveUpdate" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2522))))

; 
;  *  LMSetSaveUpdate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetSaveUpdate" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x9DA) )

; 
;  *  LMGetPaintWhite()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetPaintWhite" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2524))))

;   Carbon Usage : use InstallWindowContentPaintProc 
; 
;  *  LMSetPaintWhite()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetPaintWhite" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x9DC) )

; 
;  *  LMGetWMgrPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetWMgrPort" 
      ()
   (:no-trap (:pointer :grafport))
   (:no-trap (%get-ptr (%int-to-ptr 2526))))

; 
;  *  LMSetWMgrPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetWMgrPort" 
      ((value (:pointer :grafport))) 
  nil
   (#x21DF #x9DE) )

;   Carbon Usage: use GetGrayRgn 
; 
;  *  LMGetGrayRgn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetGrayRgn" 
      ()
   (:no-trap (:handle :macregion))
   (:no-trap (%get-ptr (%int-to-ptr 2542))))

; 
;  *  LMGetDragHook()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetDragHook" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 2550))))

; 
;  *  LMSetDragHook()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetDragHook" 
      ((value :pointer)) 
  nil
   (#x21DF #x9F6) )

; 
;  *  LMSetWindowList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetWindowList" 
      ((value (:pointer :windowrecord))) 
  nil
   (#x21DF #x9D6) )

; 
;  *  LMGetGhostWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetGhostWindow" 
      ()
   (:no-trap (:pointer :windowrecord))
   (:no-trap (%get-ptr (%int-to-ptr 2692))))

; 
;  *  LMSetGhostWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetGhostWindow" 
      ((value (:pointer :windowrecord))) 
  nil
   (#x21DF #xA84) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC NOT OPAQUE_TOOLBOX_STRUCTS 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetAuxWinHead()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetAuxWinHead" 
      ()
   (:no-trap (:handle :auxwinrec))
   (:no-trap (%get-ptr (%int-to-ptr 3280))))

; 
;  *  LMSetAuxWinHead()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetAuxWinHead" 
      ((value (:handle :auxwinrec))) 
  nil
   (#x21DF #xCD0) )

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetCurActivate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetCurActivate" 
      ()
   (:no-trap (:pointer :windowrecord))
   (:no-trap (%get-ptr (%int-to-ptr 2660))))

; 
;  *  LMSetCurActivate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetCurActivate" 
      ((value (:pointer :windowrecord))) 
  nil
   (#x21DF #xA64) )

; 
;  *  LMGetCurDeactive()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetCurDeactive" 
      ()
   (:no-trap (:pointer :windowrecord))
   (:no-trap (%get-ptr (%int-to-ptr 2664))))

; 
;  *  LMSetCurDeactive()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetCurDeactive" 
      ((value (:pointer :windowrecord))) 
  nil
   (#x21DF #xA68) )

; 
;  *  LMGetOldStructure()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetOldStructure" 
      ()
   (:no-trap (:handle :macregion))
   (:no-trap (%get-ptr (%int-to-ptr 2534))))

; 
;  *  LMSetOldStructure()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetOldStructure" 
      ((value (:handle :macregion))) 
  nil
   (#x21DF #x9E6) )

; 
;  *  LMGetOldContent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetOldContent" 
      ()
   (:no-trap (:handle :macregion))
   (:no-trap (%get-ptr (%int-to-ptr 2538))))

; 
;  *  LMSetOldContent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetOldContent" 
      ((value (:handle :macregion))) 
  nil
   (#x21DF #x9EA) )

; 
;  *  LMSetGrayRgn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetGrayRgn" 
      ((value (:handle :macregion))) 
  nil
   (#x21DF #x9EE) )

; 
;  *  LMGetSaveVisRgn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetSaveVisRgn" 
      ()
   (:no-trap (:handle :macregion))
   (:no-trap (%get-ptr (%int-to-ptr 2546))))

; 
;  *  LMSetSaveVisRgn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetSaveVisRgn" 
      ((value (:handle :macregion))) 
  nil
   (#x21DF #x9F2) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  LMGetOneOne()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetOneOne" 
      ()
   (:no-trap :signed-long)
   (:no-trap (%get-signed-long (%int-to-ptr 2562))))

; 
;  *  LMSetOneOne()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetOneOne" 
      ((value :signed-long)) 
  nil
   (#x21DF #xA02) )

; 
;  *  LMGetMinusOne()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetMinusOne" 
      ()
   (:no-trap :signed-long)
   (:no-trap (%get-signed-long (%int-to-ptr 2566))))

; 
;  *  LMSetMinusOne()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetMinusOne" 
      ((value :signed-long)) 
  nil
   (#x21DF #xA06) )

;   Carbon Usage: use GetMenuTrackingData 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetTopMenuItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetTopMenuItem" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2570))))

;   Carbon Usage: replaced by MDEF messages and GetMenuTrackingData API 
; 
;  *  LMSetTopMenuItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetTopMenuItem" 
      ((value :signed-integer)) 
  nil
   (#x31DF #xA0A) )

;   Carbon Usage: use GetMenuTrackingData 
; 
;  *  LMGetAtMenuBottom()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetAtMenuBottom" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2572))))

;   Carbon Usage: replaced by MDEF messages and GetMenuTrackingData API 
; 
;  *  LMSetAtMenuBottom()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetAtMenuBottom" 
      ((value :signed-integer)) 
  nil
   (#x31DF #xA0C) )

; 
;    Carbon usage: use GetMenuBar (which returns a newly allocated handle in
;    the same format as that returned by LMGetMenuList; dispose with DisposeMenuBar)
;    or GetRootMenu.
; 
; 
;  *  LMGetMenuList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetMenuList" 
      ()
   (:no-trap :handle)
   (:no-trap (%get-ptr (%int-to-ptr 2588))))

; 
;  *  LMSetMenuList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetMenuList" 
      ((value :handle)) 
  nil
   (#x21DF #xA1C) )

;   Carbon usage: no replacement 
; 
;  *  LMGetMBarEnable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetMBarEnable" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2592))))

; 
;  *  LMSetMBarEnable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetMBarEnable" 
      ((value :signed-integer)) 
  nil
   (#x31DF #xA20) )

;   Carbon usage: no replacement 
; 
;  *  LMGetMenuFlash()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetMenuFlash" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2596))))

; 
;  *  LMSetMenuFlash()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetMenuFlash" 
      ((value :signed-integer)) 
  nil
   (#x31DF #xA24) )

;  LMGetTheMenu() moved to Menus.h 
; 
;  *  LMSetTheMenu()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetTheMenu" 
      ((value :signed-integer)) 
  nil
   (#x31DF #xA26) )

; 
;  *  LMGetMBarHook()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetMBarHook" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 2604))))

; 
;  *  LMSetMBarHook()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetMBarHook" 
      ((value :pointer)) 
  nil
   (#x21DF #xA2C) )

; 
;  *  LMGetMenuHook()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetMenuHook" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 2608))))

; 
;  *  LMSetMenuHook()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetMenuHook" 
      ((value :pointer)) 
  nil
   (#x21DF #xA30) )

; 
;  *  LMGetTopMapHndl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetTopMapHndl" 
      ()
   (:no-trap :handle)
   (:no-trap (%get-ptr (%int-to-ptr 2640))))

; 
;  *  LMSetTopMapHndl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetTopMapHndl" 
      ((value :handle)) 
  nil
   (#x21DF #xA50) )

; 
;  *  LMGetSysMapHndl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetSysMapHndl" 
      ()
   (:no-trap :handle)
   (:no-trap (%get-ptr (%int-to-ptr 2644))))

; 
;  *  LMSetSysMapHndl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetSysMapHndl" 
      ((value :handle)) 
  nil
   (#x21DF #xA54) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  LMGetSysMap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetSysMap" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2648))))

; 
;  *  LMSetSysMap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetSysMap" 
      ((value :signed-integer)) 
  nil
   (#x31DF #xA58) )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetCurMap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetCurMap" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2650))))

; 
;  *  LMSetCurMap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetCurMap" 
      ((value :signed-integer)) 
  nil
   (#x31DF #xA5A) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  LMGetResLoad()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMGetResLoad" 
      () 
  :signed-byte
   (#x1EB8 #xA5E) )

; 
;  *  LMSetResLoad()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetResLoad" 
      ((value :signed-byte)) 
  nil
   (#x11DF #xA5E) )

; 
;  *  LMGetResErr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetResErr" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2656))))

; 
;  *  LMSetResErr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetResErr" 
      ((value :signed-integer)) 
  nil
   (#x31DF #xA60) )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetFScaleDisable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMGetFScaleDisable" 
      () 
  :signed-byte
   (#x1EB8 #xA63) )

; 
;  *  LMSetFScaleDisable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetFScaleDisable" 
      ((value :signed-byte)) 
  nil
   (#x11DF #xA63) )

; 
;  *  LMGetDeskHook()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetDeskHook" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 2668))))

; 
;  *  LMSetDeskHook()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetDeskHook" 
      ((value :pointer)) 
  nil
   (#x21DF #xA6C) )

;   Carbon Usage: Use TEGetDoTextHook. 
; 
;  *  LMGetTEDoText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetTEDoText" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 2672))))

;   Carbon Usage: Use TESetDoTextHook. 
; 
;  *  LMSetTEDoText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetTEDoText" 
      ((value :pointer)) 
  nil
   (#x21DF #xA70) )

;   Carbon Usage: Use TEGetRecalcHook. 
; 
;  *  LMGetTERecal()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetTERecal" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 2676))))

;   Carbon Usage: Use TESetRecalcHook. 
; 
;  *  LMSetTERecal()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetTERecal" 
      ((value :pointer)) 
  nil
   (#x21DF #xA74) )

; 
;  *  LMGetResumeProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetResumeProc" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 2700))))

; 
;  *  LMSetResumeProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetResumeProc" 
      ((value :pointer)) 
  nil
   (#x21DF #xA8C) )

; 
;  *  LMGetANumber()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetANumber" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2712))))

; 
;  *  LMSetANumber()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetANumber" 
      ((value :signed-integer)) 
  nil
   (#x31DF #xA98) )

;   Carbon Usage: Use GetAlertStage. 
; 
;  *  LMGetACount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetACount" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2714))))

;   Carbon Usage: Use ResetAlertStage. 
; 
;  *  LMSetACount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetACount" 
      ((value :signed-integer)) 
  nil
   (#x31DF #xA9A) )

; 
;  *  LMGetDABeeper()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetDABeeper" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 2716))))

; 
;  *  LMSetDABeeper()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetDABeeper" 
      ((value :pointer)) 
  nil
   (#x21DF #xA9C) )

;   Carbon Usage: use TEGetScrapLength 
; 
;  *  LMGetTEScrpLength()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetTEScrpLength" 
      ()
   (:no-trap :unsigned-integer)
   (:no-trap (%get-unsigned-word (%int-to-ptr 2736))))

;   Carbon Usage: use TESetScrapLength 
; 
;  *  LMSetTEScrpLength()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetTEScrpLength" 
      ((value :unsigned-integer)) 
  nil
   (#x31DF #xAB0) )

;   Carbon Usage: use TEGetScrapHandle 
; 
;  *  LMGetTEScrpHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetTEScrpHandle" 
      ()
   (:no-trap :handle)
   (:no-trap (%get-ptr (%int-to-ptr 2740))))

;   Carbon Usage: use TESetScrapHandle 
; 
;  *  LMSetTEScrpHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetTEScrpHandle" 
      ((value :handle)) 
  nil
   (#x21DF #xAB4) )

; 
;  *  LMGetAppParmHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetAppParmHandle" 
      ()
   (:no-trap :handle)
   (:no-trap (%get-ptr (%int-to-ptr 2796))))

; 
;  *  LMSetAppParmHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetAppParmHandle" 
      ((value :handle)) 
  nil
   (#x21DF #xAEC) )

; 
;  *  LMGetDSErrCode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetDSErrCode" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2800))))

; 
;  *  LMSetDSErrCode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetDSErrCode" 
      ((value :signed-integer)) 
  nil
   (#x31DF #xAF0) )

; 
;  *  LMGetResErrProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetResErrProc" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 2802))))

; 
;  *  LMSetResErrProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetResErrProc" 
      ((value :pointer)) 
  nil
   (#x21DF #xAF2) )

; 
;  *  LMGetDlgFont()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetDlgFont" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2810))))

;   Carbon Usage: use SetDialogFont 
; 
;  *  LMSetDlgFont()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetDlgFont" 
      ((value :signed-integer)) 
  nil
   (#x31DF #xAFA) )

; 
;  *  LMGetATalkHk2()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetATalkHk2" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 2840))))

; 
;  *  LMSetATalkHk2()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetATalkHk2" 
      ((value :pointer)) 
  nil
   (#x21DF #xB18) )

; 
;  *  LMGetHWCfgFlags()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetHWCfgFlags" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2850))))

; 
;  *  LMSetHWCfgFlags()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetHWCfgFlags" 
      ((value :signed-integer)) 
  nil
   (#x31DF #xB22) )

;   Carbon Usage: use GetMenuTrackingData 
; 
;  *  LMGetMenuDisable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetMenuDisable" 
      ()
   (:no-trap :signed-long)
   (:no-trap (%get-signed-long (%int-to-ptr 2900))))

;   Carbon Usage: use new MDEF messages 
; 
;  *  LMSetMenuDisable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetMenuDisable" 
      ((value :signed-long)) 
  nil
   (#x21DF #xB54) )

; 
;  *  LMGetROMMapInsert()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMGetROMMapInsert" 
      () 
  :signed-byte
   (#x1EB8 #xB9E) )

; 
;  *  LMSetROMMapInsert()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetROMMapInsert" 
      ((value :signed-byte)) 
  nil
   (#x11DF #xB9E) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  LMGetTmpResLoad()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMGetTmpResLoad" 
      () 
  :signed-byte
   (#x1EB8 #xB9F) )

; 
;  *  LMSetTmpResLoad()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetTmpResLoad" 
      ((value :signed-byte)) 
  nil
   (#x11DF #xB9F) )

; 
;  *  LMGetIntlSpec()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetIntlSpec" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 2976))))

; 
;  *  LMSetIntlSpec()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetIntlSpec" 
      ((value :pointer)) 
  nil
   (#x21DF #xBA0) )

;  LMGetWordRedraw and LMSetWordRedraw moved to TextEdit.h 
; 
;  *  LMGetSysFontFam()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetSysFontFam" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2982))))

; 
;  *  LMSetSysFontFam()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetSysFontFam" 
      ((value :signed-integer)) 
  nil
   (#x31DF #xBA6) )

; 
;  *  LMGetSysFontSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetSysFontSize" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2984))))

; 
;  *  LMSetSysFontSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetSysFontSize" 
      ((value :signed-integer)) 
  nil
   (#x31DF #xBA8) )

;   Carbon Usge: use GetMBarHeight 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetMBarHeight()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetMBarHeight" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2986))))

;   Carbon Usage: use Hide/ShowMenuBar 
; 
;  *  LMSetMBarHeight()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetMBarHeight" 
      ((value :signed-integer)) 
  nil
   (#x31DF #xBAA) )

; 
;  *  LMGetTESysJust()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetTESysJust" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2988))))

; 
;  *  LMSetTESysJust()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetTESysJust" 
      ((value :signed-integer)) 
  nil
   (#x31DF #xBAC) )

; 
;  *  LMGetMMU32Bit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMGetMMU32Bit" 
      () 
  :signed-byte
   (#x1EB8 #xCB2) )

; 
;  *  LMSetMMU32Bit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetMMU32Bit" 
      ((value :signed-byte)) 
  nil
   (#x11DF #xCB2) )

; 
;  *  LMGetDeskCPat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetDeskCPat" 
      ()
   (:no-trap (:handle :pixpat))
   (:no-trap (%get-ptr (%int-to-ptr 3288))))

; 
;  *  LMSetDeskCPat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetDeskCPat" 
      ((value (:handle :pixpat))) 
  nil
   (#x21DF #xCD8) )

; 
;  *  LMGetTimeDBRA()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetTimeDBRA" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 3328))))

; 
;  *  LMSetTimeDBRA()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetTimeDBRA" 
      ((value :signed-integer)) 
  nil
   (#x31DF #xD00) )

; 
;  *  LMGetTimeSCCDB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetTimeSCCDB" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 3330))))

; 
;  *  LMSetTimeSCCDB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetTimeSCCDB" 
      ((value :signed-integer)) 
  nil
   (#x31DF #xD02) )

; 
;  *  LMGetJVBLTask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetJVBLTask" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 3368))))

; 
;  *  LMSetJVBLTask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetJVBLTask" 
      ((value :pointer)) 
  nil
   (#x21DF #xD28) )

; 
;  *  LMGetSynListHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetSynListHandle" 
      ()
   (:no-trap :handle)
   (:no-trap (%get-ptr (%int-to-ptr 3378))))

; 
;  *  LMSetSynListHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetSynListHandle" 
      ((value :handle)) 
  nil
   (#x21DF #xD32) )

; 
;  *  LMGetMenuCInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetMenuCInfo" 
      ()
   (:no-trap (:handle :mctable))
   (:no-trap (%get-ptr (%int-to-ptr 3408))))

; 
;  *  LMSetMenuCInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetMenuCInfo" 
      ((value (:handle :mctable))) 
  nil
   (#x21DF #xD50) )

; 
;  *  LMGetJDTInstall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetJDTInstall" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 3484))))

; 
;  *  LMSetJDTInstall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetJDTInstall" 
      ((value :pointer)) 
  nil
   (#x21DF #xD9C) )

; 
;  *  LMGetTimeSCSIDB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetTimeSCSIDB" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 2852))))

; 
;  *  LMSetTimeSCSIDB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetTimeSCSIDB" 
      ((value :signed-integer)) 
  nil
   (#x31DF #xB24) )

; *************************************************************************************
; 
;     MORE COMPLEX LOWMEM ACCESSORS
; 
; *************************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC TARGET_CPU_68K AND NOT TARGET_RT_MAC_CFM 
; *************************************************************************************
;     "BIG DATA"
;     
;         These lowmem accessors access big (> 4 bytes) values.
; *************************************************************************************
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetDeskPattern()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMGetDeskPattern" 
      ((deskPatternValue (:pointer :pattern))) 
  nil
   (#x225F #x41F8 #xA3C #x22D8 #x22D8) )

; 
;  *  LMSetDeskPattern()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_LMSetDeskPattern" 
      ((deskPatternValue (:pointer :pattern))) 
  nil
   (#x205F #x43F8 #xA3C #x22D8 #x22D8) )

; $ENDC                                         ; CALL_NOT_IN_CARBON
; *************************************************************************************
;     "BLOCKMOVE ACCESSORS"
;     
;         These lowmem accessors use the BlockMove to set
; *************************************************************************************
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetCurApName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMGetCurApName" 
      () 
  (:pointer (:string 255))
   (#x41F8 #x910 #x2E88) )

; 
;  *  LMGetSysResName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMGetSysResName" 
      () 
  (:pointer (:string 255))
   (#x41F8 #xAD8 #x2E88) )

; 
;  *  LMGetFinderName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMGetFinderName" 
      () 
  (:pointer (:string 255))
   (#x41F8 #x2E0 #x2E88) )

; $ENDC                                         ; CALL_NOT_IN_CARBON
; *************************************************************************************
;     "INDEXED ACCESSORS"
;     
;         These lowmem accessors take an index parameter to get/set an indexed
;         lowmem global.
; *************************************************************************************
; ************************************************************************************
;     The DAString accessors are gone with Carbon. Please use ParamText and
;     GetParamText instead.
; *************************************************************************************
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetDAStrings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMGetDAStrings" 
      ((whichString :signed-integer)) 
  (:handle (:string 255))
   (#x301F #xE548 #x41F8 #xAA0 #x2EB0 #x0) )

; 
;  *  LMSetDAStrings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetDAStrings" 
      ((stringsValue (:handle (:string 255))) (whichString :signed-integer)) 
  nil
   (#x301F #xE548 #x41F8 #xAA0 #x219F #x0) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

 |#                                             ; $ELSEC
; *************************************************************************************
;     "BIG DATA"
;     
;         These lowmem accessors access big (> 4 bytes) values.
; *************************************************************************************

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetDSAlertRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  LMSetDSAlertRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LMGetDSAlertRect" 
      ((dsAlertRectValue (:pointer :rect))) 
  nil
   () )                                         ; CONST; 
;  *  LMGetDragPattern()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LMSetDSAlertRect" 
      ((dsAlertRectValue (:pointer :rect))) 
  nil
   () )                                         ; 
;  *  LMSetDragPattern()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LMGetDragPattern" 
      ((dragPatternValue (:pointer :pattern))) 
  nil
   () )                                         ; CONST; 
;  *  LMGetDeskPattern()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LMSetDragPattern" 
      ((dragPatternValue (:pointer :pattern))) 
  nil
   () )                                         ; 
;  *  LMSetDeskPattern()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LMGetDeskPattern" 
      ((deskPatternValue (:pointer :pattern))) 
  nil
   () )                                         ; CONST; 
;  *  LMGetEventQueue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LMSetDeskPattern" 
      ((deskPatternValue (:pointer :pattern))) 
  nil
   () )                                         ; 
;  *  LMSetEventQueue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LMGetEventQueue" 
      () 
  (:pointer :qhdr)
   () )                                         ; 
;  *  LMGetVBLQueue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LMSetEventQueue" 
      ((eventQueueValue (:pointer :qhdr))) 
  nil
   () )                                         ; 
;  *  LMSetVBLQueue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LMGetVBLQueue" 
      () 
  (:pointer :qhdr)
   () )                                         ; 
;  *  LMGetDrvQHdr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LMSetVBLQueue" 
      ((vblQueueValue (:pointer :qhdr))) 
  nil
   () )                                         ; 
;  *  LMSetDrvQHdr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LMGetDrvQHdr" 
      () 
  (:pointer :qhdr)
   () )                                         ; 
;  *  LMGetVCBQHdr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LMSetDrvQHdr" 
      ((drvQHdrValue (:pointer :qhdr))) 
  nil
   () )                                         ; 
;  *  LMSetVCBQHdr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LMGetVCBQHdr" 
      () 
  (:pointer :qhdr)
   () )                                         ; 
;  *  LMGetDTQueue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LMSetVCBQHdr" 
      ((vcbQHdrValue (:pointer :qhdr))) 
  nil
   () )                                         ; 
;  *  LMSetDTQueue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LMGetDTQueue" 
      () 
  (:pointer :qhdr)
   () )                                         ; 
;  *  LMGetFSQHdr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LMSetDTQueue" 
      ((dtQueueValue (:pointer :qhdr))) 
  nil
   () )                                         ; *************************************************************************************
;     "BLOCKMOVE ACCESSORS"
;     
;         These lowmem accessors use the BlockMove to set
; *************************************************************************************
(deftrap-inline "_LMGetFSQHdr" 
      () 
  (:pointer :qhdr)
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; 
;  *  LMGetCurApName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  LMSetCurApName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LMGetCurApName" 
      () 
  (:pointer (:string 255))
   () )                                         ; 
;  *  LMGetSysResName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LMSetCurApName" 
      ((curApNameValue (:string 31))) 
  nil
   () )                                         ; 
;  *  LMSetSysResName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LMGetSysResName" 
      () 
  (:pointer (:string 255))
   () )                                         ; 
;  *  LMGetFinderName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LMSetSysResName" 
      ((sysResNameValue (:string 15))) 
  nil
   () )                                         ; 
;  *  LMSetFinderName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LMGetFinderName" 
      () 
  (:pointer (:string 255))
   () )                                         ; $IFC CALL_NOT_IN_CARBON ; 
;  *  LMGetScratch20()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LMSetFinderName" 
      ((finderNameValue (:string 15))) 
  nil
   () )                                         ; 
;  *  LMSetScratch20()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LMGetScratch20" 
      () 
  :pointer
   () )
(deftrap-inline "_LMSetScratch20" 
      ((scratch20Value :pointer)) 
  nil
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; 
;  *  LMGetToolScratch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  LMSetToolScratch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LMGetToolScratch" 
      () 
  :pointer
   () )                                         ; $IFC CALL_NOT_IN_CARBON ; 
;  *  LMGetApplScratch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LMSetToolScratch" 
      ((toolScratchValue :pointer)) 
  nil
   () )                                         ; 
;  *  LMSetApplScratch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LMGetApplScratch" 
      () 
  :pointer
   () )                                         ; *************************************************************************************
;     "INDEXED ACCESSORS"
;     
;         These lowmem accessors take an index parameter to get/set an indexed
;         lowmem global.
; *************************************************************************************;   Carbon Usage: use GetParamText ; 
;  *  LMGetDAStrings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LMSetApplScratch" 
      ((applScratchValue :pointer)) 
  nil
   () )                                         ;   Carbon Usage: use ParamText ; 
;  *  LMSetDAStrings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LMGetDAStrings" 
      ((whichString :signed-integer)) 
  (:handle (:string 255))
   () )
(deftrap-inline "_LMSetDAStrings" 
      ((stringsValue (:handle (:string 255))) (whichString :signed-integer)) 
  nil
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; 
;  *  LMGetLvl2DT()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  LMSetLvl2DT()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_LMGetLvl2DT" 
      ((vectorNumber :signed-integer)) 
  :pointer
   () )                                         ; $IFC CALL_NOT_IN_CARBON ; 
;  *  LMGetExtStsDT()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LMSetLvl2DT" 
      ((Lvl2DTValue :pointer) (vectorNumber :signed-integer)) 
  nil
   () )                                         ; 
;  *  LMSetExtStsDT()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_LMGetExtStsDT" 
      ((vectorNumber :signed-integer)) 
  :pointer
   () )
(deftrap-inline "_LMSetExtStsDT" 
      ((ExtStsDTValue :pointer) (vectorNumber :signed-integer)) 
  nil
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; $ENDC

; *************************************************************************************
;     "Missing Accessors"
;     
;         These lowmem accessors are not in the original InterfaceLib.  They were
;         added to InterfaceLib in Mac OS 8.5.  In Universal Interfaces 3.2 they
;         were defined via a macro. In you want to use these functions on a pre-8.5
;         systems, you must write your own macros to override the function prototype
;         or write your own implementation.
;     
; *************************************************************************************

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMSetMouseTemp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetMouseTemp" 
      ((value :point)) 
  nil
   (#x21DF #x828) )

;   accesses "MTemp" 
; 
;  *  LMGetMouseTemp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetMouseTemp" 
      ()
   (:no-trap :point)
   (:no-trap (%get-point (%int-to-ptr 2088))))

; 
;    accesses "MBState"
;    Carbon Usage: use Button()
; 
; 
;  *  LMGetMouseButtonState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMGetMouseButtonState" 
      () 
  :signed-byte
   (#x1EB8 #x172) )

; 
;  *  LMSetMouseButtonState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetMouseButtonState" 
      ((value :signed-byte)) 
  nil
   (#x11DF #x172) )

; 
;    accesses "RawMouse"
;    Carbon Usage: use GetGlobalMouse
; 
; 
;  *  LMGetRawMouseLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetRawMouseLocation" 
      ()
   (:no-trap :point)
   (:no-trap (%get-point (%int-to-ptr 2092))))

;   Carbon Usage: use GetGlobalMouse 
; 
;  *  LMSetRawMouseLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetRawMouseLocation" 
      ((value :point)) 
  nil
   (#x21DF #x82C) )

; 
;    accesses "Mouse"
;    Carbon Usage: use GetGlobalMouse
; 
; 
;  *  LMGetMouseLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetMouseLocation" 
      ()
   (:no-trap :point)
   (:no-trap (%get-point (%int-to-ptr 2096))))

; 
;  *  LMSetMouseLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetMouseLocation" 
      ((value :point)) 
  nil
   (#x21DF #x830) )

;   accesses "TheCrsr" 
; 
;  *  LMGetTheCursor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMGetTheCursor" 
      ((currentCursor (:pointer :cursor))) 
  nil
   () )

; 
;  *  LMSetTheCursor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_LMSetTheCursor" 
      ((newCursor (:pointer :cursor))) 
  nil
   () )

;   accesses "HiHeapMark" 
; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  LMGetHighHeapMark()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetHighHeapMark" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 2990))))

; 
;  *  LMSetHighHeapMark()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetHighHeapMark" 
      ((value :pointer)) 
  nil
   (#x21DF #xBAE) )

;   accesses "StkLowPt" 
; 
;  *  LMGetStackLowPoint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetStackLowPoint" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 272))))

; 
;  *  LMSetStackLowPoint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetStackLowPoint" 
      ((value :pointer)) 
  nil
   (#x21DF #x110) )

;   accesses "ROMMapHndl" 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetROMMapHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetROMMapHandle" 
      ()
   (:no-trap :handle)
   (:no-trap (%get-ptr (%int-to-ptr 2822))))

; 
;  *  LMSetROMMapHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetROMMapHandle" 
      ((value :handle)) 
  nil
   (#x21DF #xB06) )

;   accesses "UnitNtryCnt" 
; 
;  *  LMGetUnitTableEntryCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetUnitTableEntryCount" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 466))))

; 
;  *  LMSetUnitTableEntryCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetUnitTableEntryCount" 
      ((value :signed-integer)) 
  nil
   (#x31DF #x1D2) )

;   accesses "FmtDefaults" 
; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  LMGetDiskFormatingHFSDefaults()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LMGetDiskFormatingHFSDefaults" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 926))))

; 
;  *  LMSetDiskFormatingHFSDefaults()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetDiskFormatingHFSDefaults" 
      ((value :pointer)) 
  nil
   (#x21DF #x39E) )

;   accesses "PortAUse" 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LMGetPortAInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMGetPortAInfo" 
      () 
  :signed-byte
   (#x1EB8 #x290) )

; 
;  *  LMSetPortAInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetPortAInfo" 
      ((value :signed-byte)) 
  nil
   (#x11DF #x290) )

; 
;  *  LMGetMBTicks()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetMBTicks" 
      ()
   (:no-trap :signed-long)
   (:no-trap (%get-signed-long (%int-to-ptr 366))))

; 
;  *  LMSetMBTicks()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetMBTicks" 
      ((value :signed-long)) 
  nil
   (#x21DF #x16E) )

; 
;  *  LMGetKeyTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_LMGetKeyTime" 
      ()
   (:no-trap :signed-long)
   (:no-trap (%get-signed-long (%int-to-ptr 390))))

; 
;  *  LMSetKeyTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LMSetKeyTime" 
      ((value :signed-long)) 
  nil
   (#x21DF #x186) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := LowMemIncludes

; $ENDC                                         ; __LOWMEM__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'LowMem)