(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:MacHelp.p"
; at Wednesday May 1,2002 2:40:56 pm.
; 
;      File:       MacHelp.p
;  
;      Contains:   Macintosh Help Package Interfaces.
;  
;      Version:    Technology: Mac OS X/CarbonLib 1.3
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1998-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __MACHELP__
; $SETC __MACHELP__ := 1

; $I+
; $SETC MacHelpIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __BALLOONS__
|#

(require-interface 'Balloons)
#|                                              ; $I Balloons.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CONTROLS__
|#

(require-interface 'Controls)
#|                                              ; $I Controls.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __DIALOGS__
|#

(require-interface 'Dialogs)
#|                                              ; $I Dialogs.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __EVENTS__
|#

(require-interface 'Events)
#|                                              ; $I Events.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACWINDOWS__
|#

(require-interface 'MacWindows)
#|                                              ; $I MacWindows.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MENUS__
|#

(require-interface 'Menus)
#|                                              ; $I Menus.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;  Help Manager constants, etc.                                                     
; 

(defconstant $kMacHelpVersion #x3)

(def-mactype :hmcontentrequest (find-mactype ':signed-integer))

(defconstant $kHMSupplyContent 0)
(defconstant $kHMDisposeContent 1)

(def-mactype :hmcontenttype (find-mactype ':unsigned-long))

(defconstant $kHMNoContent :|none|)
(defconstant $kHMCFStringContent :|cfst|)       ;   CFStringRef 
(defconstant $kHMPascalStrContent :|pstr|)
(defconstant $kHMStringResContent :|str#|)
(defconstant $kHMTEHandleContent :|txth|)       ;   NOT SUPPORTED ON MAC OS X 
(defconstant $kHMTextResContent :|text|)        ;   NOT SUPPORTED ON MAC OS X 
(defconstant $kHMStrResContent :|str |)

; 
; 	 *  HMTagDisplaySide
; 	 *  
; 	 *  Discussion:
; 	 *    Help tag display locations relative to absolute hot rect
; 	 	

(def-mactype :hmtagdisplayside (find-mactype ':signed-integer))

(defconstant $kHMDefaultSide 0)
(defconstant $kHMOutsideTopScriptAligned 1)
(defconstant $kHMOutsideLeftCenterAligned 2)
(defconstant $kHMOutsideBottomScriptAligned 3)
(defconstant $kHMOutsideRightCenterAligned 4)
(defconstant $kHMOutsideTopLeftAligned 5)
(defconstant $kHMOutsideTopRightAligned 6)
(defconstant $kHMOutsideLeftTopAligned 7)
(defconstant $kHMOutsideLeftBottomAligned 8)
(defconstant $kHMOutsideBottomLeftAligned 9)
(defconstant $kHMOutsideBottomRightAligned 10)
(defconstant $kHMOutsideRightTopAligned 11)
(defconstant $kHMOutsideRightBottomAligned 12)
(defconstant $kHMOutsideTopCenterAligned 13)
(defconstant $kHMOutsideBottomCenterAligned 14)
(defconstant $kHMInsideRightCenterAligned 15)
(defconstant $kHMInsideLeftCenterAligned 16)
(defconstant $kHMInsideBottomCenterAligned 17)
(defconstant $kHMInsideTopCenterAligned 18)
(defconstant $kHMInsideTopLeftCorner 19)
(defconstant $kHMInsideTopRightCorner 20)
(defconstant $kHMInsideBottomLeftCorner 21)
(defconstant $kHMInsideBottomRightCorner 22)
(defconstant $kHMAbsoluteCenterAligned 23)

; 	 Obsoleted constants HMTagDisplaySides, use the new ones, please 	
(defconstant $kHMTopSide 1)
(defconstant $kHMLeftSide 2)
(defconstant $kHMBottomSide 3)
(defconstant $kHMRightSide 4)
(defconstant $kHMTopLeftCorner 5)
(defconstant $kHMTopRightCorner 6)
(defconstant $kHMLeftTopCorner 7)
(defconstant $kHMLeftBottomCorner 8)
(defconstant $kHMBottomLeftCorner 9)
(defconstant $kHMBottomRightCorner 10)
(defconstant $kHMRightTopCorner 11)
(defconstant $kHMRightBottomCorner 12)

(def-mactype :hmcontentprovidedtype (find-mactype ':signed-integer))

(defconstant $kHMContentProvided 0)
(defconstant $kHMContentNotProvided 1)
(defconstant $kHMContentNotProvidedDontPropagate 2)

(defconstant $kHMMinimumContentIndex 0)         ;   first entry in HMHelpContentRec.content is the minimum content  
(defconstant $kHMMaximumContentIndex 1)         ;   second entry in HMHelpContentRec.content is the maximum content  

(defconstant $errHMIllegalContentForMinimumState -10980);   unrecognized content type for minimum content  
(defconstant $errHMIllegalContentForMaximumState -10981);   unrecognized content type for maximum content  

;   obsolete names; will be removed 
(defconstant $kHMIllegalContentForMinimumState -10980)

(defconstant $kHelpTagEventHandlerTag :|hevt|)

(def-mactype :hmhelpcontentptr (find-mactype '(:pointer :hmhelpcontent)))
(defrecord HMHelpContent 
   (contentType :unsigned-long)
   (:variant 
      (
      (tagCFString :pointer)                    ;   CFStringRef 
      )
      (
      (tagString (:string 255))                 ;   Pascal String 
      )
      (
      (tagStringRes :hmstringrestype)           ;   STR# resource ID and index 
      )
      (
      (tagTEHandle (:handle :terec))            ;   TextEdit handle (NOT SUPPORTED ON MAC OS X) 
      )
      (
      (tagTextRes :signed-integer)              ;   TEXT/styl resource ID (NOT SUPPORTED ON MAC OS X) 
      )
      (
      (tagStrRes :signed-integer)               ;   STR resource ID 
      )
      )
   )

(def-mactype :hmhelpcontentrecptr (find-mactype '(:pointer :hmhelpcontentrec)))
(defrecord HMHelpContentRec 
   (version :signed-long)
   (absHotRect :rect)
   (tagSide :signed-integer)
   (content (:array :hmhelpcontent 2))
   )

; 		
; 	 Callback procs                                       	
; 	 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	HMControlContentProcPtr = FUNCTION(inControl: ControlRef; inGlobalMouse: Point; inRequest: HMContentRequest; VAR outContentProvided: HMContentProvidedType; ioHelpContent: HMHelpContentPtr): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :hmcontrolcontentprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	HMWindowContentProcPtr = FUNCTION(inWindow: WindowRef; inGlobalMouse: Point; inRequest: HMContentRequest; VAR outContentProvided: HMContentProvidedType; ioHelpContent: HMHelpContentPtr): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :hmwindowcontentprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	HMMenuTitleContentProcPtr = FUNCTION(inMenu: MenuRef; inRequest: HMContentRequest; VAR outContentProvided: HMContentProvidedType; ioHelpContent: HMHelpContentPtr): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :hmmenutitlecontentprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	HMMenuItemContentProcPtr = FUNCTION({CONST}VAR inTrackingData: MenuTrackingData; inRequest: HMContentRequest; VAR outContentProvided: HMContentProvidedType; ioHelpContent: HMHelpContentPtr): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :hmmenuitemcontentprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :hmcontrolcontentupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :hmcontrolcontentupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :hmwindowcontentupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :hmwindowcontentupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :hmmenutitlecontentupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :hmmenutitlecontentupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :hmmenuitemcontentupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :hmmenuitemcontentupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppHMControlContentProcInfo #xFBF0)
(defconstant $uppHMWindowContentProcInfo #xFBF0)
(defconstant $uppHMMenuTitleContentProcInfo #x3EF0)
(defconstant $uppHMMenuItemContentProcInfo #x3EF0)
; 
; 	 *  NewHMControlContentUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewHMControlContentProc 
(deftrap "_NewHMControlContentUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewHMWindowContentUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewHMWindowContentProc 
(deftrap "_NewHMWindowContentUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewHMMenuTitleContentUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewHMMenuTitleContentProc 
(deftrap "_NewHMMenuTitleContentUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewHMMenuItemContentUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewHMMenuItemContentProc 
(deftrap "_NewHMMenuItemContentUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeHMControlContentUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeHMControlContentUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeHMWindowContentUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeHMWindowContentUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeHMMenuTitleContentUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeHMMenuTitleContentUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeHMMenuItemContentUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeHMMenuItemContentUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeHMControlContentUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallHMControlContentProc 
(deftrap-inline "_InvokeHMControlContentUPP" 
      ((inControl (:handle :controlrecord)) (inGlobalMouse :point) (inRequest :signed-integer) (outContentProvided (:pointer :signed-integer)) (ioHelpContent (:pointer :hmhelpcontent)) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

; 
;  *  InvokeHMWindowContentUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallHMWindowContentProc 
(deftrap-inline "_InvokeHMWindowContentUPP" 
      ((inWindow (:pointer :windowrecord)) (inGlobalMouse :point) (inRequest :signed-integer) (outContentProvided (:pointer :signed-integer)) (ioHelpContent (:pointer :hmhelpcontent)) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

; 
;  *  InvokeHMMenuTitleContentUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallHMMenuTitleContentProc 
(deftrap-inline "_InvokeHMMenuTitleContentUPP" 
      ((inMenu (:handle :menuinfo)) (inRequest :signed-integer) (outContentProvided (:pointer :signed-integer)) (ioHelpContent (:pointer :hmhelpcontent)) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

; 
;  *  InvokeHMMenuItemContentUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ;  old name was CallHMMenuItemContentProc 
(deftrap-inline "_InvokeHMMenuItemContentUPP" 
      ((inTrackingData (:pointer :menutrackingdata)) (inRequest :signed-integer) (outContentProvided (:pointer :signed-integer)) (ioHelpContent (:pointer :hmhelpcontent)) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

; 
;  API                                                                                      
; 
;  Help Menu 
; 
;  *  HMGetHelpMenu()
;  *  
;  *  Summary:
;  *    Returns a menu to which applications may add their own help items.
;  *  
;  *  Parameters:
;  *    
;  *    outHelpMenu:
;  *      On exit, contains the help menu.
;  *    
;  *    outFirstCustomItemIndex:
;  *      On exit, contains the menu item index that will be used by the
;  *      first item added by the application. This parameter may be NULL.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  Installing/Retrieving Content                ;  Menu title and item help tags are not yet supported by Carbon or CarbonLib. ;  They will be fully supported in a future release. ; 
;  *  HMSetControlHelpContent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HMGetHelpMenu" 
      ((outHelpMenu (:pointer (:handle :menuinfo))) (outFirstCustomItemIndex (:pointer :unsigned-integer))) 
  :osstatus
   () )                                         ; CONST; 
;  *  HMGetControlHelpContent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HMSetControlHelpContent" 
      ((inControl (:handle :controlrecord)) (inContent (:pointer :hmhelpcontentrec))) 
  :osstatus
   () )                                         ; 
;  *  HMSetWindowHelpContent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HMGetControlHelpContent" 
      ((inControl (:handle :controlrecord)) (outContent (:pointer :hmhelpcontentrec))) 
  :osstatus
   () )                                         ; CONST; 
;  *  HMGetWindowHelpContent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HMSetWindowHelpContent" 
      ((inWindow (:pointer :windowrecord)) (inContent (:pointer :hmhelpcontentrec))) 
  :osstatus
   () )                                         ; 
;  *  HMSetMenuItemHelpContent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HMGetWindowHelpContent" 
      ((inWindow (:pointer :windowrecord)) (outContent (:pointer :hmhelpcontentrec))) 
  :osstatus
   () )                                         ; CONST; 
;  *  HMGetMenuItemHelpContent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HMSetMenuItemHelpContent" 
      ((inMenu (:handle :menuinfo)) (inItem :unsigned-integer) (inContent (:pointer :hmhelpcontentrec))) 
  :osstatus
   () )                                         ;  Installing/Retrieving Content Callbacks ; 
;  *  HMInstallControlContentCallback()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HMGetMenuItemHelpContent" 
      ((inMenu (:handle :menuinfo)) (inItem :unsigned-integer) (outContent (:pointer :hmhelpcontentrec))) 
  :osstatus
   () )                                         ; 
;  *  HMInstallWindowContentCallback()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HMInstallControlContentCallback" 
      ((inControl (:handle :controlrecord)) (inContentUPP :pointer)) 
  :osstatus
   () )                                         ; 
;  *  HMInstallMenuTitleContentCallback()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HMInstallWindowContentCallback" 
      ((inWindow (:pointer :windowrecord)) (inContentUPP :pointer)) 
  :osstatus
   () )                                         ; 
;  *  HMInstallMenuItemContentCallback()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HMInstallMenuTitleContentCallback" 
      ((inMenu (:handle :menuinfo)) (inContentUPP :pointer)) 
  :osstatus
   () )                                         ; 
;  *  HMGetControlContentCallback()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HMInstallMenuItemContentCallback" 
      ((inMenu (:handle :menuinfo)) (inContentUPP :pointer)) 
  :osstatus
   () )                                         ; 
;  *  HMGetWindowContentCallback()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HMGetControlContentCallback" 
      ((inControl (:handle :controlrecord)) (outContentUPP (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  HMGetMenuTitleContentCallback()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HMGetWindowContentCallback" 
      ((inWindow (:pointer :windowrecord)) (outContentUPP (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  HMGetMenuItemContentCallback()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HMGetMenuTitleContentCallback" 
      ((inMenu (:handle :menuinfo)) (outContentUPP (:pointer :pointer))) 
  :osstatus
   () )                                         ;  Enabling and Disabling Help Tags ; 
;  *  HMAreHelpTagsDisplayed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HMGetMenuItemContentCallback" 
      ((inMenu (:handle :menuinfo)) (outContentUPP (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  HMSetHelpTagsDisplayed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HMAreHelpTagsDisplayed" 
      () 
  :boolean
   () )                                         ; 
;  *  HMSetTagDelay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HMSetHelpTagsDisplayed" 
      ((inDisplayTags :boolean)) 
  :osstatus
   () )                                         ; 
;  *  HMGetTagDelay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HMSetTagDelay" 
      ((inDelay :signed-long)) 
  :osstatus
   () )                                         ;  Compatibility ; 
;  *  HMSetMenuHelpFromBalloonRsrc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HMGetTagDelay" 
      ((outDelay (:pointer :signed-long))) 
  :osstatus
   () )                                         ; 
;  *  HMSetDialogHelpFromBalloonRsrc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HMSetMenuHelpFromBalloonRsrc" 
      ((inMenu (:handle :menuinfo)) (inHmnuRsrcID :signed-integer)) 
  :osstatus
   () )                                         ;  Displaying tags ; 
;  *  HMDisplayTag()
;  *  
;  *  Summary:
;  *    Displays a help tag at a user defined location.
;  *  
;  *  Parameters:
;  *    
;  *    inContent:
;  *      HMHelpContentRec describing the help tag to be displayed.
;  *  
;  *  Result:
;  *    An OSStatus code indicating success or failure.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HMSetDialogHelpFromBalloonRsrc" 
      ((inDialog (:pointer :grafport)) (inHdlgRsrcID :signed-integer) (inItemStart :signed-integer)) 
  :osstatus
   () )                                         ; CONST; 
;  *  HMHideTag()
;  *  
;  *  Summary:
;  *    HMHideTag hides the currently visible help tag.  If there is no
;  *    current help tag, this call does nothing.
;  *  
;  *  Result:
;  *    An OSStatus code indicating success or failure.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.2 and later
;  *    Mac OS X:         in version 10.1 and later
;  
(deftrap-inline "_HMDisplayTag" 
      ((inContent (:pointer :hmhelpcontentrec))) 
  :osstatus
   () )                                         ; $ALIGN RESET; $POP; $SETC UsingIncludes := MacHelpIncludes
(deftrap-inline "_HMHideTag" 
      () 
  :osstatus
   () )                                         ; $ENDC; __MACHELP__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'MacHelp)