(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:MacMemory.p"
; at Wednesday May 1,2002 2:38:46 pm.
; 
;      File:       MacMemory.p
;  
;      Contains:   Memory Manager Interfaces.
;  
;      Version:    Technology: Mac OS 9
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __MACMEMORY__
; $SETC __MACMEMORY__ := 1

; $I+
; $SETC MacMemoryIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $maxSize #x7FFFFFF0)               ;  the largest block possible 

(defconstant $defaultPhysicalEntryCount 8)

;   values returned from the GetPageState function  
(defconstant $kPageInMemory 0)
(defconstant $kPageOnDisk 1)
(defconstant $kNotPaged 2)

;   masks for Zone->heapType field  
(defconstant $k32BitHeap 1)                     ;   valid in all Memory Managers  
(defconstant $kNewStyleHeap 2)                  ;   true if new Heap Manager is present  
(defconstant $kNewDebugHeap 4)                  ;   true if new Heap Manager is running in debug mode on this heap  

;   bits for use with HGetState/HSetState 
(defconstant $kHandleIsResourceBit 5)
(defconstant $kHandlePurgeableBit 6)
(defconstant $kHandleLockedBit 7)

;   masks for use with HGetState/HSetState 
(defconstant $kHandleIsResourceMask #x20)
(defconstant $kHandlePurgeableMask #x40)
(defconstant $kHandleLockedMask #x80)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	GrowZoneProcPtr = FUNCTION(cbNeeded: Size): LONGINT;

|#
 |#                                             ; $ELSEC
(def-mactype :growzoneprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	PurgeProcPtr = PROCEDURE(blockToPurge: Handle);

|#
 |#                                             ; $ELSEC
(def-mactype :purgeprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	UserFnProcPtr = PROCEDURE(parameter: UNIV Ptr);

|#
 |#                                             ; $ELSEC
(def-mactype :userfnprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :growzoneupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :growzoneupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :purgeupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :purgeupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :userfnupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :userfnupp (find-mactype ':pointer))
; $ENDC
(def-mactype :zoneptr (find-mactype '(:pointer :zone)))
(defrecord Zone 
   (bkLim :pointer)
   (purgePtr :pointer)
   (hFstFree :pointer)
   (zcbFree :signed-long)
   (gzProc :pointer)
   (moreMast :signed-integer)
   (flags :signed-integer)
   (cntRel :signed-integer)
   (maxRel :signed-integer)
   (cntNRel :signed-integer)
   (heapType :signed-byte)                      ;   previously "maxNRel", now holds flags (e.g. k32BitHeap) 
   (unused :signed-byte)
   (cntEmpty :signed-integer)
   (cntHandles :signed-integer)
   (minCBFree :signed-long)
   (purgeProc :pointer)
   (sparePtr :pointer)
   (allocPtr :pointer)
   (heapData :signed-integer)
   )

(def-mactype :thz (find-mactype '(:pointer :zone)))
(def-mactype :thzptr (find-mactype '(:handle :zone)))
(def-mactype :memoryblockptr (find-mactype '(:pointer :memoryblock)))
(defrecord MemoryBlock 
   (address :pointer)
   (count :unsigned-long)
   )

(def-mactype :logicaltophysicaltableptr (find-mactype '(:pointer :logicaltophysicaltable)))
(defrecord LogicalToPhysicalTable 
   (logical :memoryblock)
   (physical (:array :memoryblock 8))
   )

(def-mactype :pagestate (find-mactype ':signed-integer))
(def-mactype :statusregistercontents (find-mactype ':signed-integer))

(defconstant $kVolumeVirtualMemoryInfoVersion1 1);   first version of VolumeVirtualMemoryInfo 

(def-mactype :volumevirtualmemoryinfoptr (find-mactype '(:pointer :volumevirtualmemoryinfo)))
(defrecord VolumeVirtualMemoryInfo 
   (version :unsigned-long)                     ;   Input: Version of the VolumeVirtualMemoryInfo structure 
   (volumeRefNum :signed-integer)               ;   Input: volume reference number 
   (inUse :boolean)                             ;   output: true if volume is currently used for file mapping 
   (_fill :signed-byte)
   (vmOptions :unsigned-long)                   ;   output: tells what volume can support (same as DriverGestaltVMOptionsResponse vmOptions bits in DriverGestalt) 
;   end of kVolumeVirtualMemoryInfoVersion1 structure 
   )

(defconstant $uppGrowZoneProcInfo #xF0)
(defconstant $uppPurgeProcInfo #xC0)
(defconstant $uppUserFnProcInfo #x9802)
; 
; 	 *  NewGrowZoneUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewGrowZoneProc 
(deftrap "_NewGrowZoneUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewPurgeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewPurgeProc 
(deftrap "_NewPurgeUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewUserFnUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewUserFnProc 
(deftrap "_NewUserFnUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeGrowZoneUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeGrowZoneUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposePurgeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposePurgeUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeUserFnUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeUserFnUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeGrowZoneUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallGrowZoneProc 
(deftrap-inline "_InvokeGrowZoneUPP" 
      ((cbNeeded :signed-long) (userRoutine :pointer)) 
  :signed-long
   (#x205F #x4E90) )

; 
;  *  InvokePurgeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallPurgeProc 
(deftrap-inline "_InvokePurgeUPP" 
      ((blockToPurge :handle) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeUserFnUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallUserFnProc                  ; $IFC CALL_NOT_IN_CARBON ; 
;  *  GetApplLimit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokeUserFnUPP" 
      ((parameter :pointer) (userRoutine :pointer)) 
  nil
   () )
(deftrap "_GetApplLimit" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 304))))

; 
;  *  SystemZone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SystemZone" 
      ()
   (:no-trap (:pointer :zone))
   (:no-trap (%get-ptr (%int-to-ptr 678))))

; 
;  *  ApplicationZone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ApplicationZone" 
      ()
   (:no-trap (:pointer :zone))
   (:no-trap (%get-ptr (%int-to-ptr 682))))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  GZSaveHnd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GZSaveHnd" 
      ()
   (:no-trap :handle)
   (:no-trap (%get-ptr (%int-to-ptr 808))))

; 
;  *  TopMem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TopMem" 
      ()
   (:no-trap :pointer)
   (:no-trap (%get-ptr (%int-to-ptr 264))))

; 
;  *  MemError()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_MemError" 
      ()
   (:no-trap :signed-integer)
   (:no-trap (%get-signed-word (%int-to-ptr 544))))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  GetZone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetZone" 
      () 
  (:pointer :zone)
   (#xA11A #x2E88) 
  :allow-errchk? t)

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  NewHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_NewHandle" 
      ((byteCount :signed-long)) 
  :handle
   (#x201F #xA122 #x2E88) 
  :allow-errchk? t)

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  NewHandleSys()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NewHandleSys" 
      ((byteCount :signed-long)) 
  :handle
   (#x201F #xA522 #x2E88) 
  :allow-errchk? t)

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  NewHandleClear()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_NewHandleClear" 
      ((byteCount :signed-long)) 
  :handle
   (#x201F #xA322 #x2E88) 
  :allow-errchk? t)

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  NewHandleSysClear()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NewHandleSysClear" 
      ((byteCount :signed-long)) 
  :handle
   (#x201F #xA722 #x2E88) 
  :allow-errchk? t)

; 
;  *  HandleZone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HandleZone" 
      ((h :handle)) 
  (:pointer :zone)
   (#x205F #xA126 #x2E88) 
  :allow-errchk? t)

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  RecoverHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_RecoverHandle" 
      ((p :pointer)) 
  :handle
   (#x205F #xA128 #x2E88) 
  :allow-errchk? t)

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  RecoverHandleSys()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_RecoverHandleSys" 
      ((p :pointer)) 
  :handle
   (#x205F #xA528 #x2E88) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  NewPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_NewPtr" 
      ((byteCount :signed-long)) 
  :pointer
   (#x201F #xA11E #x2E88) 
  :allow-errchk? t)

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  NewPtrSys()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NewPtrSys" 
      ((byteCount :signed-long)) 
  :pointer
   (#x201F #xA51E #x2E88) 
  :allow-errchk? t)

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  NewPtrClear()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_NewPtrClear" 
      ((byteCount :signed-long)) 
  :pointer
   (#x201F #xA31E #x2E88) 
  :allow-errchk? t)

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  NewPtrSysClear()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NewPtrSysClear" 
      ((byteCount :signed-long)) 
  :pointer
   (#x201F #xA71E #x2E88) 
  :allow-errchk? t)

; 
;  *  PtrZone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PtrZone" 
      ((p :pointer)) 
  (:pointer :zone)
   (#x205F #xA148 #x2E88) 
  :allow-errchk? t)

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  MaxBlock()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MaxBlock" 
      () 
  :signed-long
   (#xA061 #x2E80) 
  :allow-errchk? t)

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  MaxBlockSys()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MaxBlockSys" 
      () 
  :signed-long
   (#xA461 #x2E80) 
  :allow-errchk? t)

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  StackSpace()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_StackSpace" 
      () 
  :signed-long
   (#xA065 #x2E80) 
  :allow-errchk? t)

; 
;  *  NewEmptyHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_NewEmptyHandle" 
      () 
  :handle
   (#xA166 #x2E88) 
  :allow-errchk? t)

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  NewEmptyHandleSys()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NewEmptyHandleSys" 
      () 
  :handle
   (#xA566 #x2E88) 
  :allow-errchk? t)

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  HLock()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_HLock" 
      ((h :handle))
   nil
   (:register-trap #xA029 :a0 h))

; 
;  *  HUnlock()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_HUnlock" 
      ((h :handle))
   nil
   (:register-trap #xA02A :a0 h))

; 
;  *  HPurge()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_HPurge" 
      ((h :handle))
   nil
   (:register-trap #xA049 :a0 h))

; 
;  *  HNoPurge()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_HNoPurge" 
      ((h :handle))
   nil
   (:register-trap #xA04A :a0 h))

; 
;  *  HLockHi()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_HLockHi" 
      ((h :handle)) 
  nil
   (#x205F #xA064 #xA029) 
  :allow-errchk? t)

; 
;  *  TempNewHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TempNewHandle" 
      ((logicalSize :signed-long) (resultCode (:pointer :signed-integer)))
   (:stack :handle)
   (:stack-trap #xA88F logicalSize resultCode (29 :signed-integer)))

; 
;  *  TempMaxMem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TempMaxMem" 
      ((grow (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA88F grow (21 :signed-integer)))

; 
;  *  TempFreeMem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TempFreeMem" 
      ()
   (:stack :signed-long)
   (:stack-trap #xA88F (24 :signed-integer)))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  InitZone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_InitZone" 
      ((pgrowZone :pointer) (cmoreMasters :signed-integer) (limitPtr :pointer) (startPtr :pointer)) 
  nil
   () 
  :allow-errchk? t)                             ; $ENDC; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SetZone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetZone" 
      ((hz (:pointer :zone)))
   nil
   (:register-trap #xA01B :a0 hz))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  CompactMem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CompactMem" 
      ((cbNeeded :signed-long))
   (:d0 :signed-long)
   (:register-trap #xA04C :d0 cbNeeded))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  CompactMemSys()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CompactMemSys" 
      ((cbNeeded :signed-long))
   (:d0 :signed-long)
   (:register-trap #xA44C :d0 cbNeeded))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  PurgeMem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PurgeMem" 
      ((cbNeeded :signed-long))
   nil
   (:register-trap #xA04D :d0 cbNeeded))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  PurgeMemSys()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PurgeMemSys" 
      ((cbNeeded :signed-long))
   nil
   (:register-trap #xA44D :d0 cbNeeded))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  FreeMem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FreeMem" 
      () 
  :signed-long
   (#xA01C #x2E80) 
  :allow-errchk? t)

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  FreeMemSys()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_FreeMemSys" 
      () 
  :signed-long
   (#xA41C #x2E80) 
  :allow-errchk? t)

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  ReserveMem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ReserveMem" 
      ((cbNeeded :signed-long))
   nil
   (:register-trap #xA040 :d0 cbNeeded))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  ReserveMemSys()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ReserveMemSys" 
      ((cbNeeded :signed-long))
   nil
   (:register-trap #xA440 :d0 cbNeeded))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  MaxMem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MaxMem" 
      ((grow (:pointer :signed-long))) 
  :signed-long
   (#x225F #xA11D #x2288 #x2E80) 
  :allow-errchk? t)

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  MaxMemSys()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MaxMemSys" 
      ((grow (:pointer :signed-long))) 
  :signed-long
   (#x225F #xA51D #x2288 #x2E80) 
  :allow-errchk? t)

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  SetGrowZone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetGrowZone" 
      ((growZone :pointer))
   nil
   (:register-trap #xA04B :a0 growZone))

; 
;  *  GetGrowZone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  MoveHHi()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetGrowZone" 
      () 
  :pointer
   () )
(deftrap "_MoveHHi" 
      ((h :handle))
   nil
   (:register-trap #xA064 :a0 h))

; 
;  *  DisposePtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposePtr" 
      ((p :pointer))
   nil
   (:register-trap #xA01F :a0 p))

; 
;  *  GetPtrSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  SetPtrSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetPtrSize" 
      ((p :pointer)) 
  :signed-long
   () 
  :allow-errchk? t)
(deftrap "_SetPtrSize" 
      ((p :pointer) (newSize :signed-long))
   nil
   (:register-trap #xA020 :d0 newSize :a0 p))

; 
;  *  DisposeHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeHandle" 
      ((h :handle))
   nil
   (:register-trap #xA023 :a0 h))

; 
;  *  SetHandleSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetHandleSize" 
      ((h :handle) (newSize :signed-long))
   nil
   (:register-trap #xA024 :d0 newSize :a0 h))

;  
;     NOTE
;     
;     GetHandleSize and GetPtrSize are documented in Inside Mac as returning 0 
;     in case of an error, but the traps actually return an error code in D0.
;     The glue sets D0 to 0 if an error occurred.
; 
; 
;  *  GetHandleSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; $IFC CALL_NOT_IN_CARBON                       ; 
;  *  InlineGetHandleSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetHandleSize" 
      ((h :handle)) 
  :signed-long
   () 
  :allow-errchk? t)
(deftrap "_InlineGetHandleSize" 
      ((h :handle))
   (:d0 :signed-long)
   (:register-trap #xA025 :a0 h))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  ReallocateHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ReallocateHandle" 
      ((h :handle) (byteCount :signed-long))
   nil
   (:register-trap #xA027 :d0 byteCount :a0 h))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  ReallocateHandleSys()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ReallocateHandleSys" 
      ((h :handle) (byteCount :signed-long))
   nil
   (:register-trap #xA427 :d0 byteCount :a0 h))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  EmptyHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_EmptyHandle" 
      ((h :handle))
   nil
   (:register-trap #xA02B :a0 h))

; 
;  *  HSetRBit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_HSetRBit" 
      ((h :handle))
   nil
   (:register-trap #xA067 :a0 h))

; 
;  *  HClrRBit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_HClrRBit" 
      ((h :handle))
   nil
   (:register-trap #xA068 :a0 h))

; 
;  *  HGetState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_HGetState" 
      ((h :handle)) 
  :signed-byte
   (#x205F #xA069 #x1E80) 
  :allow-errchk? t)

; 
;  *  HSetState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_HSetState" 
      ((h :handle) (flags :signed-byte)) 
  nil
   (#x101F #x205F #xA06A) 
  :allow-errchk? t)

; 
;  *  PurgeSpace()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;     PurgeSpaceTotal and PurgeSpaceContiguous are currently only implement
;     on classic 68K.  The are the same as PurgeSpace() but return just
;     one value (either total space purgable or contiguous space purgable).
;     Begining in Mac OS 8.5 they are available in InterfaceLib.
;                                               ; 
;  *  PurgeSpaceTotal()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PurgeSpace" 
      ((total (:pointer :signed-long)) (contig (:pointer :signed-long))) 
  nil
   () 
  :allow-errchk? t)
(deftrap-inline "_PurgeSpaceTotal" 
      () 
  :signed-long
   (#xA062 #x2E88) )

; 
;  *  PurgeSpaceContiguous()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_PurgeSpaceContiguous" 
      () 
  :signed-long
   (#xA062 #x2E80) )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  PurgeSpaceSysTotal()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PurgeSpaceSysTotal" 
      () 
  :signed-long
   (#xA562 #x2E88) )

; 
;  *  PurgeSpaceSysContiguous()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PurgeSpaceSysContiguous" 
      () 
  :signed-long
   (#xA562 #x2E80) )

; ****************************************************************************
; 
;     The routines: 
; 
;         BlockMoveUncached, BlockMoveDataUncached
;         BlockZero, BlockZeroUncached
;     
;     were first created for developers writing drivers. Originally they only
;     existed in DriverServicesLib.  Later they were added to InterfaceLib 
;     in PCI based PowerMacs.  MacOS 8.5 provides these routines in InterfaceLib
;     on all supported machines. 
;     
; ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  BlockMove()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_BlockMove" 
      ((srcPtr :pointer) (destPtr :pointer) (byteCount :signed-long)) 
  nil
   (#x201F #x225F #x205F #xA02E) 
  :allow-errchk? t)

; 
;  *  BlockMoveData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_BlockMoveData" 
      ((srcPtr :pointer) (destPtr :pointer) (byteCount :signed-long)) 
  nil
   (#x201F #x225F #x205F #xA22E) )

; 
;  *  BlockMoveUncached()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_BlockMoveUncached" 
      ((srcPtr :pointer) (destPtr :pointer) (byteCount :signed-long)) 
  nil
   () )

; 
;  *  BlockMoveDataUncached()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_BlockMoveDataUncached" 
      ((srcPtr :pointer) (destPtr :pointer) (byteCount :signed-long)) 
  nil
   () )

; 
;  *  BlockZero()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_BlockZero" 
      ((destPtr :pointer) (byteCount :signed-long)) 
  nil
   () )

; 
;  *  BlockZeroUncached()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_BlockZeroUncached" 
      ((destPtr :pointer) (byteCount :signed-long)) 
  nil
   () )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  MaxApplZone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MaxApplZone" 
      ()
   nil
   (:stack-trap #xA063))

; 
;  *  SetApplBase()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetApplBase" 
      ((startPtr :pointer))
   nil
   (:register-trap #xA057 :a0 startPtr))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  MoreMasters()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_MoreMasters" 
      ()
   nil
   (:stack-trap #xA036))

; 
;  *  MoreMasterPointers()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MoreMasterPointers" 
      ((inCount :unsigned-long)) 
  nil
   () )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SetApplLimit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetApplLimit" 
      ((zoneLimit :pointer))
   nil
   (:register-trap #xA02D :a0 zoneLimit))

; 
;  *  InitApplZone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_InitApplZone" 
      ()
   nil
   (:stack-trap #xA02C))

;   Temporary Memory routines renamed, but obsolete, in System 7.0 and later.  
; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  TempHLock()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TempHLock" 
      ((h :handle) (resultCode (:pointer :signed-integer)))
   nil
   (:stack-trap #xA88F h resultCode (30 :signed-integer)))

; 
;  *  TempHUnlock()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TempHUnlock" 
      ((h :handle) (resultCode (:pointer :signed-integer)))
   nil
   (:stack-trap #xA88F h resultCode (31 :signed-integer)))

; 
;  *  TempDisposeHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TempDisposeHandle" 
      ((h :handle) (resultCode (:pointer :signed-integer)))
   nil
   (:stack-trap #xA88F h resultCode (32 :signed-integer)))

; 
;  *  TempTopMem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TempTopMem" 
      ()
   (:stack :pointer)
   (:stack-trap #xA88F (22 :signed-integer)))

; 
;  *  HoldMemory()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_HoldMemory" 
      ((address :pointer) (count :unsigned-long)) 
  :signed-integer
   (#x225F #x205F #x7000 #xA05C #x3E80) )

; 
;  *  UnholdMemory()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_UnholdMemory" 
      ((address :pointer) (count :unsigned-long)) 
  :signed-integer
   (#x225F #x205F #x7001 #xA05C #x3E80) )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LockMemory()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LockMemory" 
      ((address :pointer) (count :unsigned-long)) 
  :signed-integer
   (#x225F #x205F #x7002 #xA05C #x3E80) )

; 
;  *  LockMemoryForOutput()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LockMemoryForOutput" 
      ((address :pointer) (count :unsigned-long)) 
  :signed-integer
   (#x225F #x205F #x700A #xA05C #x3E80) )

; 
;  *  LockMemoryContiguous()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LockMemoryContiguous" 
      ((address :pointer) (count :unsigned-long)) 
  :signed-integer
   (#x225F #x205F #x7004 #xA05C #x3E80) )

; 
;  *  UnlockMemory()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_UnlockMemory" 
      ((address :pointer) (count :unsigned-long)) 
  :signed-integer
   (#x225F #x205F #x7003 #xA05C #x3E80) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  MakeMemoryResident()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MakeMemoryResident" 
      ((address :pointer) (count :unsigned-long)) 
  :signed-integer
   (#x225F #x205F #x700B #xA05C #x3E80) )

; 
;  *  ReleaseMemoryData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ReleaseMemoryData" 
      ((address :pointer) (count :unsigned-long)) 
  :signed-integer
   (#x225F #x205F #x700C #xA05C #x3E80) )

; 
;  *  MakeMemoryNonResident()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MakeMemoryNonResident" 
      ((address :pointer) (count :unsigned-long)) 
  :signed-integer
   (#x225F #x205F #x700D #xA05C #x3E80) )

; 
;  *  FlushMemory()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FlushMemory" 
      ((address :pointer) (count :unsigned-long)) 
  :signed-integer
   (#x225F #x205F #x700E #xA05C #x3E80) )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  GetPhysical()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetPhysical" 
      ((addresses (:pointer :logicaltophysicaltable)) (physicalEntryCount (:pointer :unsigned-long))) 
  :signed-integer
   (#x225F #x205F #x2209 #x2251 #x7005 #xA15C #x2241 #x2288 #x3E80) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  GetVolumeVirtualMemoryInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetVolumeVirtualMemoryInfo" 
      ((volVMInfo (:pointer :volumevirtualmemoryinfo)))
   (:d0 :signed-integer)
   (:register-trap #xA05C :a0 volVMInfo :d0 15))

; 
;  *  DeferUserFn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DeferUserFn" 
      ((userFunction :pointer) (argument :pointer))
   (:d0 :signed-integer)
   (:register-trap #xA08F :d0 argument :a0 userFunction))

; 
;  *  DebuggerGetMax()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_DebuggerGetMax" 
      () 
  :signed-long
   (#x7000 #xA08D #x2E80) )

; 
;  *  DebuggerEnter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_DebuggerEnter" 
      () 
  nil
   (#x7001 #xA08D) )

; 
;  *  DebuggerExit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_DebuggerExit" 
      () 
  nil
   (#x7002 #xA08D) )

; 
;  *  DebuggerPoll()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_DebuggerPoll" 
      () 
  nil
   (#x7003 #xA08D) )

; 
;  *  GetPageState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetPageState" 
      ((address :pointer))
   (:d0 :pagestate)
   (:register-trap #xA08D :a0 address :d0 4))

; 
;  *  PageFaultFatal()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PageFaultFatal" 
      () 
  :boolean
   (#x7005 #xA08D #x1E80) )

; 
;  *  DebuggerLockMemory()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_DebuggerLockMemory" 
      ((address :pointer) (count :unsigned-long)) 
  :signed-integer
   (#x225F #x205F #x7006 #xA08D #x3E80) )

; 
;  *  DebuggerUnlockMemory()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_DebuggerUnlockMemory" 
      ((address :pointer) (count :unsigned-long)) 
  :signed-integer
   (#x225F #x205F #x7007 #xA08D #x3E80) )

; 
;  *  EnterSupervisorMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EnterSupervisorMode" 
      () 
  :statusregistercontents
   (#x7008 #xA08D #x3E80) )

; 
;  *  StripAddress()
;  *  
;  *  Summary:
;  *    A trap on classic 68K, and the identity function for pre-carbon
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  


;; This form has been patched from OSX Drive:Users:bburns:Desktop:interface-translator:Patches:macmemory.patch
#|(deftrap "_StripAddress" 
      ((theAddress :pointer))
   (:d0 :pointer)
   (:register-trap #xA055 :d0 theAddress))|#
;; these may just be needed for xload-level-0??
;; probably better to move the functions - done

#|
;; in l0-utils - fn pointer-size
(deftrap "_GetPtrSize"
         ((p :pointer))
         (:d0 :signed-long)
         (:register-trap 40993 :a0 p))

(deftrap "_GetHandleSize"
         ((h :handle))
         (:d0 :signed-long)
         (:register-trap 40997 :a0 h))

;; in room in ppc-misc
(deftrap "_FreeMem" nil (:d0 :signed-long) (:register-trap 40988))
|#

(deftrap "_StripAddress"
         ((theaddress :pointer))
         (#-ppc-target :d0 #+ppc-target :no-trap :long)
  #-ppc-target
  (%int-to-ptr (:register-trap 41045 :d0 (%ptr-to-int theaddress)))
  #+ppc-target
  (:no-trap (progn theaddress)))

; 
;  *  Translate24To32()
;  *  
;  *  Summary:
;  *    A trap on classic 68K, and the identity function for pre-carbon
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_Translate24To32" 
      ((addr24 :pointer))
   (:d0 :pointer)
   (:register-trap #xA091 :d0 addr24))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  HandToHand()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  PtrToXHand()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HandToHand" 
      ((theHndl (:pointer :handle))) 
  :signed-integer
   () 
  :allow-errchk? t)
(deftrap-inline "_PtrToXHand" 
      ((srcPtr :pointer) (dstHndl :handle) (size :signed-long)) 
  :signed-integer
   (#x201F #x225F #x205F #xA9E2 #x3E80) 
  :allow-errchk? t)

; 
;  *  PtrToHand()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  HandAndHand()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PtrToHand" 
      ((srcPtr :pointer) (dstHndl (:pointer :handle)) (size :signed-long)) 
  :signed-integer
   () 
  :allow-errchk? t)
(deftrap-inline "_HandAndHand" 
      ((hand1 :handle) (hand2 :handle)) 
  :signed-integer
   (#x225F #x205F #xA9E4 #x3E80) 
  :allow-errchk? t)

; 
;  *  PtrAndHand()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_PtrAndHand" 
      ((ptr1 :pointer) (hand2 :handle) (size :signed-long)) 
  :signed-integer
   (#x201F #x225F #x205F #xA9EF #x3E80) 
  :allow-errchk? t)

;  Carbon routines to aid in debugging. 
;  Checks all applicable heaps for validity 
; 
;  *  CheckAllHeaps()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  Checks the application heap for validity     ; 
;  *  IsHeapValid()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CheckAllHeaps" 
      () 
  :boolean
   () )                                         ;  It is invalid to pass a NULL or an empty Handle to IsHandleValid ; 
;  *  IsHandleValid()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IsHeapValid" 
      () 
  :boolean
   () )                                         ;  It is invalid to pass a NULL Pointer to IsPointerValid ; 
;  *  IsPointerValid()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IsHandleValid" 
      ((h :handle)) 
  :boolean
   () )                                         ; $IFC OLDROUTINENAMES ; $IFC CALL_NOT_IN_CARBON ; 
;  *  ApplicZone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_IsPointerValid" 
      ((p :pointer)) 
  :boolean
   () )
(deftrap "_ApplicZone" 
      ()
   (:no-trap (:pointer :zone))
   (:no-trap (%get-ptr (%int-to-ptr 682))))

; 
;  *  MFTempNewHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MFTempNewHandle" 
      ((logicalSize :signed-long) (resultCode (:pointer :signed-integer)))
   (:stack :handle)
   (:stack-trap #xA88F logicalSize resultCode (29 :signed-integer)))

; 
;  *  MFMaxMem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MFMaxMem" 
      ((grow (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA88F grow (21 :signed-integer)))

; 
;  *  MFFreeMem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MFFreeMem" 
      ()
   (:stack :signed-long)
   (:stack-trap #xA88F (24 :signed-integer)))

; 
;  *  MFTempHLock()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MFTempHLock" 
      ((h :handle) (resultCode (:pointer :signed-integer)))
   nil
   (:stack-trap #xA88F h resultCode (30 :signed-integer)))

; 
;  *  MFTempHUnlock()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MFTempHUnlock" 
      ((h :handle) (resultCode (:pointer :signed-integer)))
   nil
   (:stack-trap #xA88F h resultCode (31 :signed-integer)))

; 
;  *  MFTempDisposHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MFTempDisposHandle" 
      ((h :handle) (resultCode (:pointer :signed-integer)))
   nil
   (:stack-trap #xA88F h resultCode (32 :signed-integer)))

; 
;  *  MFTopMem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MFTopMem" 
      ()
   (:stack :pointer)
   (:stack-trap #xA88F (22 :signed-integer)))

; 
;  *  ResrvMem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ResrvMem" 
      ((cbNeeded :signed-long))
   nil
   (:register-trap #xA040 :d0 cbNeeded))

; 
;  *  DisposPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposPtr" 
      ((p :pointer))
   nil
   (:register-trap #xA01F :a0 p))

; 
;  *  DisposHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposHandle" 
      ((h :handle))
   nil
   (:register-trap #xA023 :a0 h))

; 
;  *  ReallocHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ReallocHandle" 
      ((h :handle) (byteCount :signed-long))
   nil
   (:register-trap #xA027 :d0 byteCount :a0 h))

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; OLDROUTINENAMES

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := MacMemoryIncludes

; $ENDC                                         ; __MACMEMORY__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'MacMemory)