(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:MacTypes.p"
; at Wednesday May 1,2002 2:38:45 pm.
; 
;      File:       MacTypes.p
;  
;      Contains:   Basic Macintosh data types.
;  
;      Version:    Technology: Mac OS 9
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __MACTYPES__
; $SETC __MACTYPES__ := 1

; $I+
; $SETC MacTypesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; *******************************************************************************
; 
;     Base integer types for all target OS's and CPU's
;     
;         UInt8            8-bit unsigned integer 
;         SInt8            8-bit signed integer
;         UInt16          16-bit unsigned integer 
;         SInt16          16-bit signed integer           
;         UInt32          32-bit unsigned integer 
;         SInt32          32-bit signed integer   
;         UInt64          64-bit unsigned integer 
;         SInt64          64-bit signed integer   
; 
; ********************************************************************************

(def-mactype :sint8 (find-mactype ':signed-byte))
(def-mactype :sint16 (find-mactype ':signed-integer))
(def-mactype :sint32 (find-mactype ':signed-long))
; $IFC NOT UNDEFINED MWERKS
(def-mactype :uint8 (find-mactype ':unsigned-byte));  UNISIGNEDBYTE 
(def-mactype :uint16 (find-mactype ':unsigned-integer))
(def-mactype :uint32 (find-mactype ':unsigned-long))
#|                                              ; $ELSEC
(def-mactype :uint8 (find-mactype ':unsigned-byte))
(def-mactype :uint16 (find-mactype ':signed-integer))
(def-mactype :uint32 (find-mactype ':signed-long))
 |#                                             ; $ENDC

; $IFC TARGET_RT_BIG_ENDIAN 

(def-mactype :wideptr (find-mactype '(:pointer :wide)))
(defrecord wide 
   (hi :signed-long)
   (lo :unsigned-long)
   )

(def-mactype :unsignedwideptr (find-mactype '(:pointer :unsignedwide)))
(defrecord UnsignedWide 
   (hi :unsigned-long)
   (lo :unsigned-long)
   )

#|                                              ; $ELSEC

(defrecord wide 
   (lo :unsigned-long)
   (hi :signed-long)
   )

(def-mactype :wideptr (find-mactype '(:pointer :wide)))
(def-mactype :unsignedwideptr (find-mactype '(:pointer :unsignedwide)))
(defrecord UnsignedWide 
   (lo :unsigned-long)
   (hi :unsigned-long)
   )

 |#                                             ; $ENDC; TARGET_RT_BIG_ENDIAN

(%define-record :sint64 (find-record-descriptor :wide))
(def-mactype :sint64ptr (find-mactype '(:pointer :wide)))
(%define-record :uint64 (find-record-descriptor :unsignedwide))
(def-mactype :uint64ptr (find-mactype '(:pointer :unsignedwide)))
; 	*******************************************************************************
; 	
; 	    Special types for pascal
; 	    
; 	        IntegerPtr          Pointer to a 16-bit integer
; 	        LongIntPtr          Pointer to a 16-bit integer
; 	        ByteParameter       UInt8 passed as an 8-bit parameter
; 	        
; 	    Note:   The conventions for Pascal on 68K require that a UInt8 when
; 	            passed as a parameter occupy 16-bits on the stack, whereas 
; 	            an SInt8 would only occupy 8-bits.  To make C and Pascal
; 	            compatable, in pascal all function parameters of type UInt8
; 	            or equivalent are changed to ByteParameter.
; 	
; 	********************************************************************************	
(def-mactype :integerptr (find-mactype '(:pointer :signed-integer)))
(def-mactype :longintptr (find-mactype ':pointer))
(def-mactype :byteparameter (find-mactype ':signed-byte))

; 	*******************************************************************************
; 	
; 	    Base fixed point types 
; 	    
; 	        Fixed           16-bit signed integer plus 16-bit fraction
; 	        UnsignedFixed   16-bit unsigned integer plus 16-bit fraction
; 	        Fract           2-bit signed integer plus 30-bit fraction
; 	        ShortFixed      8-bit signed integer plus 8-bit fraction
; 	        
; 	********************************************************************************	
(def-mactype :fixed (find-mactype ':signed-long))
(def-mactype :fixedptr (find-mactype '(:pointer :signed-long)))
(def-mactype :fract (find-mactype ':signed-long))
(def-mactype :fractptr (find-mactype '(:pointer :signed-long)))
(def-mactype :unsignedfixed (find-mactype ':unsigned-long))
(def-mactype :unsignedfixedptr (find-mactype '(:pointer :unsigned-long)))
(def-mactype :shortfixed (find-mactype ':signed-integer))
(def-mactype :shortfixedptr (find-mactype '(:pointer :signed-integer)))

; 	*******************************************************************************
; 	
; 	    Base floating point types 
; 	    
; 	        Float32         32 bit IEEE float:  1 sign bit, 8 exponent bits, 23 fraction bits
; 	        Float64         64 bit IEEE float:  1 sign bit, 11 exponent bits, 52 fraction bits  
; 	        Float80         80 bit MacOS float: 1 sign bit, 15 exponent bits, 1 integer bit, 63 fraction bits
; 	        Float96         96 bit 68881 float: 1 sign bit, 15 exponent bits, 16 pad bits, 1 integer bit, 63 fraction bits
; 	        
; 	    Note: These are fixed size floating point types, useful when writing a floating
; 	          point value to disk.  If your compiler does not support a particular size 
; 	          float, a struct is used instead.
; 	          Use of of the NCEG types (e.g. double_t) or an ANSI C type (e.g. double) if
; 	          you want a floating point representation that is natural for any given
; 	          compiler, but might be a different size on different compilers.
; 	
; 	********************************************************************************	

(def-mactype :float32 (find-mactype ':single-float))
(def-mactype :float64 (find-mactype ':double-float))
#|                                              ; $IFC TARGET_CPU_68K
; $IFC TARGET_RT_MAC_68881 
(def-mactype :float96 (find-mactype ':pointer))
(defrecord Float80 
   (exp :signed-integer)
   (man (:array :unsigned-integer 4))
   )
; $ELSEC
(def-mactype :float80 (find-mactype ':pointer))
(defrecord Float96 
   (exp :signed-integer)
   (filler :signed-integer)
   (man (:array :unsigned-integer 4))
   )
; $ENDC
 |#                                             ; $ELSEC
(defrecord Float80 
   (exp :signed-integer)
   (man (:array :unsigned-integer 4))
   )
(defrecord Float96 
   (exp :signed-integer)
   (filler :signed-integer)
   (man (:array :unsigned-integer 4))
   )
; $ENDC
(defrecord Float32Point 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (x :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (y :single-float)
   )

; 	*******************************************************************************
; 	
; 	    MacOS Memory Manager types
; 	    
; 	        Ptr             Pointer to a non-relocatable block
; 	        Handle          Pointer to a master pointer to a relocatable block
; 	        Size            The number of bytes in a block (signed for historical reasons)
; 	        
; 	********************************************************************************	
#|
; Warning: Patching def of type Ptr from translator table: was (:pointer :signed-byte), is now :pointer
|#
(def-mactype :ptr (find-mactype :pointer))
#| 
(def-mactype :ptr (find-mactype '(:pointer :signed-byte))) |#
#|
; Warning: Patching def of type Handle from translator table: was (:pointer :pointer), is now :handle
|#
(def-mactype :handle (find-mactype :handle))
#| 
(def-mactype :handle (find-mactype '(:pointer :pointer))) |#
(def-mactype :size (find-mactype ':signed-long))

; 	*******************************************************************************
; 	
; 	    Higher level basic types
; 	    
; 	        OSErr                   16-bit result error code
; 	        OSStatus                32-bit result error code
; 	        LogicalAddress          Address in the clients virtual address space
; 	        ConstLogicalAddress     Address in the clients virtual address space that will only be read
; 	        PhysicalAddress         Real address as used on the hardware bus
; 	        BytePtr                 Pointer to an array of bytes
; 	        ByteCount               The size of an array of bytes
; 	        ByteOffset              An offset into an array of bytes
; 	        ItemCount               32-bit iteration count
; 	        OptionBits              Standard 32-bit set of bit flags
; 	        PBVersion               ?
; 	        Duration                32-bit millisecond timer for drivers
; 	        AbsoluteTime            64-bit clock
; 	        ScriptCode              A particular set of written characters (e.g. Roman vs Cyrillic) and their encoding
; 	        LangCode                A particular language (e.g. English), as represented using a particular ScriptCode
; 	        RegionCode              Designates a language as used in a particular region (e.g. British vs American
; 	                                English) together with other region-dependent characteristics (e.g. date format)
; 	        FourCharCode            A 32-bit value made by packing four 1 byte characters together
; 	        OSType                  A FourCharCode used in the OS and file system (e.g. creator)
; 	        ResType                 A FourCharCode used to tag resources (e.g. 'DLOG')
; 	        
; 	********************************************************************************	
(def-mactype :oserr (find-mactype ':signed-integer))
(def-mactype :osstatus (find-mactype ':signed-long))
(def-mactype :logicaladdress (find-mactype ':pointer))
(def-mactype :constlogicaladdress (find-mactype ':pointer))
(def-mactype :physicaladdress (find-mactype ':pointer))
(def-mactype :byteptr (find-mactype '(:pointer :unsigned-byte)))
(def-mactype :bytecount (find-mactype ':unsigned-long))
(def-mactype :byteoffset (find-mactype ':unsigned-long))
(def-mactype :duration (find-mactype ':signed-long))
(%define-record :absolutetime (find-record-descriptor :unsignedwide))
(def-mactype :absolutetimeptr (find-mactype '(:pointer :unsignedwide)))
(def-mactype :optionbits (find-mactype ':unsigned-long))
(def-mactype :itemcount (find-mactype ':unsigned-long))
(def-mactype :pbversion (find-mactype ':unsigned-long))
(def-mactype :scriptcode (find-mactype ':signed-integer))
(def-mactype :langcode (find-mactype ':signed-integer))
(def-mactype :regioncode (find-mactype ':signed-integer))
; $IFC NOT UNDEFINED MWERKS 
#|                                              ; $IFC TARGET_CPU_68K 
; Use array version of FourCharCode for compatibility with old 68k apps.
(defrecord FourCharCode (array (:array :character 4 :packed)))
 |#                                             ; $ELSEC
#|
; Warning: Patching def of type FourCharCode from translator table: was :unsigned-long, is now :ostype
|#
(def-mactype :fourcharcode (find-mactype :ostype))
#| 
(def-mactype :fourcharcode (find-mactype ':unsigned-long)) |#
; $ENDC
#|                                              ; $ELSEC
(defrecord FourCharCode (array (:array :character 4 :packed)))
 |#                                             ; $ENDC
(def-mactype :ostype (find-mactype ':ostype))
(def-mactype :restype (find-mactype ':ostype))
(def-mactype :ostypeptr (find-mactype '(:pointer :ostype)))
(def-mactype :restypeptr (find-mactype '(:pointer :ostype)))

; 	*******************************************************************************
; 	
; 	    Boolean types and values
; 	    
; 	        Boolean         A one byte value, holds "false" (0) or "true" (1)
; 	        false           The Boolean value of zero (0)
; 	        true            The Boolean value of one (1)
; 	        
; 	********************************************************************************	
;  "Boolean", "true", and "false" are built into the Pascal language 
; 	*******************************************************************************
; 	
; 	    Function Pointer Types
; 	    
; 	        ProcPtr                 Generic pointer to a function
; 	        Register68kProcPtr      Pointer to a 68K function that expects parameters in registers
; 	        UniversalProcPtr        Pointer to classic 68K code or a RoutineDescriptor
; 	        
; 	        ProcHandle              Pointer to a ProcPtr
; 	        UniversalProcHandle     Pointer to a UniversalProcPtr
; 	        
; 	********************************************************************************	
(def-mactype :procptr (find-mactype ':pointer))
(def-mactype :register68kprocptr (find-mactype ':pointer))
; 	 UniversalProcPtr is ^RoutineDescriptor on a PowerPC machine 	
(def-mactype :universalprocptr (find-mactype ':pointer))
(def-mactype :prochandle (find-mactype '(:pointer :pointer)))
(def-mactype :universalprochandle (find-mactype '(:pointer :pointer)))

; 	*******************************************************************************
; 	
; 	    Common Constants
; 	    
; 	        noErr                   OSErr: function performed properly - no error
; 	        kNilOptions             OptionBits: all flags false
; 	        kInvalidID              KernelID: NULL is for pointers as kInvalidID is for ID's
; 	        kVariableLengthArray    array bounds: variable length array
; 	
; 	    Note: kVariableLengthArray is used in array bounds to specify a variable length array.
; 	          It is ususally used in variable length structs when the last field is an array
; 	          of any size.  Before ANSI C, we used zero as the bounds of variable length 
; 	          array, but zero length array are illegal in ANSI C.  Example usage:
; 	    
; 	        struct FooList 
; 	        (
; 	            short   listLength;
; 	            Foo     elements[kVariableLengthArray];
; 	        );
; 	        
; 	********************************************************************************	

(defconstant $noErr 0)

(defconstant $kNilOptions 0)

(defconstant $kInvalidID 0)

(defconstant $kVariableLengthArray 1)

(defconstant $kUnknownType #x3F3F3F3F)          ;   "????" QuickTime 3.0: default unknown ResType or OSType  

; 	*******************************************************************************
; 	
; 	    String Types and Unicode Types
; 	    
; 	        UnicodeScalarValue,     A complete Unicode character in UTF-32 format, with
; 	        UTF32Char               values from 0 through 0x10FFFF (excluding the surrogate
; 	                                range 0xD800-0xDFFF and certain disallowed values).
; 	
; 	        UniChar,                A 16-bit Unicode code value in the default UTF-16 format.
; 	        UTF16Char               UnicodeScalarValues 0-0xFFFF are expressed in UTF-16
; 	                                format using a single UTF16Char with the same value.
; 	                                UnicodeScalarValues 0x10000-0x10FFFF are expressed in
; 	                                UTF-16 format using a pair of UTF16Chars - one in the
; 	                                high surrogate range (0xD800-0xDBFF) followed by one in
; 	                                the low surrogate range (0xDC00-0xDFFF). All of the
; 	                                characters defined in Unicode versions through 3.0 are
; 	                                in the range 0-0xFFFF and can be expressed using a single
; 	                                UTF16Char, thus the term "Unicode character" generally
; 	                                refers to a UniChar = UTF16Char.
; 	
; 	        UTF8Char                An 8-bit code value in UTF-8 format. UnicodeScalarValues
; 	                                0-0x7F are expressed in UTF-8 format using one UTF8Char
; 	                                with the same value. UnicodeScalarValues above 0x7F are
; 	                                expressed in UTF-8 format using 2-4 UTF8Chars, all with
; 	                                values in the range 0x80-0xF4 (UnicodeScalarValues
; 	                                0x100-0xFFFF use two or three UTF8Chars,
; 	                                UnicodeScalarValues 0x10000-0x10FFFF use four UTF8Chars).
; 	
; 	        UniCharCount            A count of UTF-16 code values in an array or buffer.
; 	
; 	        StrNNN                  Pascal string holding up to NNN bytes
; 	        StringPtr               Pointer to a pascal string
; 	        StringHandle            Pointer to a StringPtr
; 	        ConstStringPtr          Pointer to a read-only pascal string
; 	        ConstStrNNNParam        For function parameters only - means string is const
; 	        
; 	        CStringPtr              Pointer to a C string           (in C:  char*)
; 	        ConstCStringPtr         Pointer to a read-only C string (in C:  const char*)
; 	        
; 	    Note: The length of a pascal string is stored as the first byte.
; 	          A pascal string does not have a termination byte.
; 	          A pascal string can hold at most 255 bytes of data.
; 	          The first character in a pascal string is offset one byte from the start of the string. 
; 	          
; 	          A C string is terminated with a byte of value zero.  
; 	          A C string has no length limitation.
; 	          The first character in a C string is the zeroth byte of the string. 
; 	          
; 	        
; 	********************************************************************************	

(def-mactype :unicodescalarvalue (find-mactype ':unsigned-long))
(def-mactype :utf32char (find-mactype ':unsigned-long))
(def-mactype :unichar (find-mactype ':unsigned-integer))
(def-mactype :utf16char (find-mactype ':unsigned-integer))
(def-mactype :utf8char (find-mactype ':unsigned-byte))
(def-mactype :unicharptr (find-mactype '(:pointer :unsigned-integer)))
(def-mactype :unicharcount (find-mactype ':unsigned-long))
(def-mactype :unicharcountptr (find-mactype '(:pointer :unsigned-long)))
(defrecord :Str255 
  (length :unsigned-byte)
 (contents (:array :unsigned-byte 255)))
(defrecord :Str63 
  (length :unsigned-byte)
 (contents (:array :unsigned-byte 63)))
(defrecord :Str32 
  (length :unsigned-byte)
 (contents (:array :unsigned-byte 32)))
(defrecord :Str31 
  (length :unsigned-byte)
 (contents (:array :unsigned-byte 31)))
(defrecord :Str27 
  (length :unsigned-byte)
 (contents (:array :unsigned-byte 27)))
(defrecord :Str15 
  (length :unsigned-byte)
 (contents (:array :unsigned-byte 15)))
; 	
; 	    The type Str32 is used in many AppleTalk based data structures.
; 	    It holds up to 32 one byte chars.  The problem is that with the
; 	    length byte it is 33 bytes long.  This can cause weird alignment
; 	    problems in structures.  To fix this the type "Str32Field" has
; 	    been created.  It should only be used to hold 32 chars, but
; 	    it is 34 bytes long so that there are no alignment problems.
; 		
(defrecord :Str32Field 
  (length :unsigned-byte)
 (contents (:array :unsigned-byte 32)))
; 	
; 	    QuickTime 3.0:
; 	    The type StrFileName is used to make MacOS structs work 
; 	    cross-platform.  For example FSSpec or SFReply previously
; 	    contained a Str63 field.  They now contain a StrFileName
; 	    field which is the same when targeting the MacOS but is
; 	    a 256 char buffer for Win32 and unix, allowing them to
; 	    contain long file names.
; 		
; $IFC TARGET_OS_MAC 
(defrecord :StrFileName 
  (length :unsigned-byte)
 (contents (:array :unsigned-byte 63)))
#|                                              ; $ELSEC
(defrecord :StrFileName 
  (length :unsigned-byte)
 (contents (:array :unsigned-byte 255)))
 |#                                             ; $ENDC; TARGET_OS_MAC

(def-mactype :stringptr (find-mactype '(:pointer (:string 255))))
(def-mactype :stringhandle (find-mactype '(:handle (:string 255))))
(def-mactype :conststringptr (find-mactype '(:pointer (:string 255))))
(def-mactype :cstringptr (find-mactype ':pointer))
(def-mactype :cstringptrptr (find-mactype '(:pointer :pointer)))
(def-mactype :constcstringptr (find-mactype ':pointer))
(def-mactype :constcstringptrptr (find-mactype '(:pointer :pointer)))
(defrecord :ConstStr255Param 
  (length :unsigned-byte)
 (contents (:array :unsigned-byte 255)))
(defrecord :ConstStr63Param 
  (length :unsigned-byte)
 (contents (:array :unsigned-byte 63)))
(defrecord :ConstStr32Param 
  (length :unsigned-byte)
 (contents (:array :unsigned-byte 32)))
(defrecord :ConstStr31Param 
  (length :unsigned-byte)
 (contents (:array :unsigned-byte 31)))
(defrecord :ConstStr27Param 
  (length :unsigned-byte)
 (contents (:array :unsigned-byte 27)))
(defrecord :ConstStr15Param 
  (length :unsigned-byte)
 (contents (:array :unsigned-byte 15)))
; $IFC TARGET_OS_MAC 
(defrecord :ConstStrFileNameParam 
  (length :unsigned-byte)
 (contents (:array :unsigned-byte 63)))
#|                                              ; $ELSEC
(defrecord :ConstStrFileNameParam 
  (length :unsigned-byte)
 (contents (:array :unsigned-byte 255)))
 |#                                             ; $ENDC; TARGET_OS_MAC

; 	*******************************************************************************
; 	
; 	    Quickdraw Types
; 	    
; 	        Point               2D Quickdraw coordinate, range: -32K to +32K
; 	        Rect                Rectangular Quickdraw area
; 	        Style               Quickdraw font rendering styles
; 	        StyleParameter      Style when used as a parameter (historical 68K convention)
; 	        StyleField          Style when used as a field (historical 68K convention)
; 	        CharParameter       Char when used as a parameter (historical 68K convention)
; 	        
; 	    Note:   The original Macintosh toolbox in 68K Pascal defined Style as a SET.  
; 	            Both Style and CHAR occupy 8-bits in packed records or 16-bits when 
; 	            used as fields in non-packed records or as parameters. 
; 	        
; 	********************************************************************************	
(def-mactype :pointptr (find-mactype '(:pointer :point)))
#|
; Warning: Patching def of type Point from translator table: was :record, is now :point
|#
(def-mactype :point (find-mactype :point))
#| 
(defrecord Point 
   (:variant 
      (
      (v :signed-integer)
      (h :signed-integer)
      )
      (
      (vh (:array :signed-integer 2))
      )
      )
   ) |#

(def-mactype :rectptr (find-mactype '(:pointer :rect)))

;; This form has been patched from OSX Drive:Users:bburns:Desktop:interface-translator:Patches:mactypes.patch
#|(defrecord Rect 
   (:variant 
      (
      (top :signed-integer)
      (left :signed-integer)
      (bottom :signed-integer)
      (right :signed-integer)
      )
      (
      (topLeft :point)
      (botRight :point)
      )
      )
   )|#;; add bottomright spelling

(defrecord Rect 
   (:variant 

      ((top :signed-integer)
      (left :signed-integer)
      (bottom :signed-integer)
      (right :signed-integer))

      ((topLeft :point)
       (:variant ((botRight :point))
                 ((bottomRight :point))))
      ))

(def-mactype :fixedpointptr (find-mactype '(:pointer :fixedpoint)))
(defrecord FixedPoint 
   (x :signed-long)
   (y :signed-long)
   )

(def-mactype :fixedrectptr (find-mactype '(:pointer :fixedrect)))
(defrecord FixedRect 
   (left :signed-long)
   (top :signed-long)
   (right :signed-long)
   (bottom :signed-long)
   )

(def-mactype :charparameter (find-mactype ':character))

(def-mactype :styleitem (find-mactype ':unsigned-byte))
(defconstant $bold 0)
(defconstant $italic 1)
(defconstant $underline 2)
(defconstant $outline 3)
(defconstant $shadow 4)
(defconstant $condense 5)
(defconstant $extend 6)
(def-mactype :style (find-mactype ':unsigned-byte))
(defconstant $bold 0)
(defconstant $italic 1)
(defconstant $underline 2)
(defconstant $outline 3)
(defconstant $shadow 4)
(defconstant $condense 5)
(defconstant $extend 6)

(def-mactype :styleparameter (find-mactype ':unsigned-byte))
(defconstant $bold 0)
(defconstant $italic 1)
(defconstant $underline 2)
(defconstant $outline 3)
(defconstant $shadow 4)
(defconstant $condense 5)
(defconstant $extend 6)

(def-mactype :stylefield (find-mactype ':unsigned-byte))
(defconstant $bold 0)
(defconstant $italic 1)
(defconstant $underline 2)
(defconstant $outline 3)
(defconstant $shadow 4)
(defconstant $condense 5)
(defconstant $extend 6)

; 	*******************************************************************************
; 	
; 	    QuickTime TimeBase types (previously in Movies.h)
; 	    
; 	        TimeValue           Count of units
; 	        TimeScale           Units per second
; 	        CompTimeValue       64-bit count of units (always a struct) 
; 	        TimeValue64         64-bit count of units (long long or struct) 
; 	        TimeBase            An opaque reference to a time base
; 	        TimeRecord          Package of TimeBase, duration, and scale
; 	        
; 	********************************************************************************	
(def-mactype :timevalue (find-mactype ':signed-long))
(def-mactype :timescale (find-mactype ':signed-long))
(%define-record :comptimevalue (find-record-descriptor :wide))
(def-mactype :comptimevalueptr (find-mactype '(:pointer :wide)))
(%define-record :timevalue64 (find-record-descriptor :wide))
(def-mactype :timevalue64ptr (find-mactype '(:pointer :wide)))
(def-mactype :timebase (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :timebaseptr (find-mactype '(:pointer :pointer)));  when a VAR xx:TimeBase parameter can be nil, it is changed to xx: TimeBasePtr 
(def-mactype :timerecordptr (find-mactype '(:pointer :timerecord)))
(defrecord TimeRecord 
   (value :wide)                                ;   units (duration or absolute)  
   (scale :signed-long)                         ;   units per second  
   (base :pointer)                              ;   refernce to the time base  
   )

; 	*******************************************************************************
; 	
; 	    MacOS versioning structures
; 	    
; 	        VersRec                 Contents of a 'vers' resource
; 	        VersRecPtr              Pointer to a VersRecPtr
; 	        VersRecHndl             Resource Handle containing a VersRec
; 	        NumVersion              Packed BCD version representation (e.g. "4.2.1a3" is 0x04214003)
; 	        UniversalProcPtr        Pointer to classic 68K code or a RoutineDescriptor
; 	        
; 	        ProcHandle              Pointer to a ProcPtr
; 	        UniversalProcHandle     Pointer to a UniversalProcPtr
; 	        
; 	********************************************************************************	
; $IFC TARGET_RT_BIG_ENDIAN 
(def-mactype :numversionptr (find-mactype '(:pointer :numversion)))
(defrecord NumVersion 
;   Numeric version part of 'vers' resource  
   (majorRev :unsigned-byte)                    ;  1st part of version number in BCD 
   (minorAndBugRev :unsigned-byte)              ;  2nd & 3rd part of version number share a byte 
   (stage :unsigned-byte)                       ;  stage code: dev, alpha, beta, final 
   (nonRelRev :unsigned-byte)                   ;  revision level of non-released version 
   )

#|                                              ; $ELSEC
(defrecord NumVersion 
;   Numeric version part of 'vers' resource accessable in little endian format  
   (nonRelRev :unsigned-byte)                   ;  revision level of non-released version 
   (stage :unsigned-byte)                       ;  stage code: dev, alpha, beta, final 
   (minorAndBugRev :unsigned-byte)              ;  2nd & 3rd part of version number share a byte 
   (majorRev :unsigned-byte)                    ;  1st part of version number in BCD 
   )

 |#                                             ; $ENDC; TARGET_RT_BIG_ENDIAN

;   Version Release Stage Codes  
(defconstant $developStage #x20)
(defconstant $alphaStage #x40)
(defconstant $betaStage #x60)
(defconstant $finalStage #x80)

(def-mactype :numversionvariantptr (find-mactype '(:pointer :numversionvariant)))
(defrecord NumVersionVariant 
   (:variant 
;   NumVersionVariant is a wrapper so NumVersion can be accessed as a 32-bit value  
      (
      (parts :numversion)
      )
      (
      (whole :unsigned-long)
      )
      )
   )

(def-mactype :numversionvarianthandle (find-mactype '(:handle :numversionvariant)))
(def-mactype :versrecptr (find-mactype '(:pointer :versrec)))
(defrecord (VersRec :handle) 
;   'vers' resource format  
   (numericVersion :numversion)                 ;  encoded version number 
   (countryCode :signed-integer)                ;  country code from intl utilities 
   (shortVersion (:string 255))                 ;  version number string - worst case 
   (reserved (:string 255))                     ;  longMessage string packed after shortVersion 
   )

(def-mactype :versrechndl (find-mactype '(:handle :versrec)))
; 	********************************************************************************
; 	
; 	    Old names for types
; 	        
; 	********************************************************************************	
(def-mactype :byte (find-mactype ':unsigned-byte))
(def-mactype :signedbyte (find-mactype ':signed-byte))
(%define-record :extended80 (find-record-descriptor :float80))
(def-mactype :extended80ptr (find-mactype '(:pointer :float80)))
(%define-record :extended96 (find-record-descriptor :float96))
(def-mactype :extended96ptr (find-mactype '(:pointer :float96)))
(def-mactype :vhselect (find-mactype ':signed-byte))
(def-mactype :singleptr (find-mactype '(:pointer :single-float)))
; 	********************************************************************************
; 	
; 	    Debugger functions
; 	    
; 	********************************************************************************	
; 
; 	 *  Debugger()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_Debugger" 
      ()
   nil
   (:stack-trap #xA9FF))

; 
;  *  DebugStr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DebugStr" 
      ((debuggerMsg (:string 255)))
   nil
   (:stack-trap #xABFF))

; $IFC TARGET_OS_MAC 
; $IFC TARGET_CPU_PPC 
;  Only for Mac OS native drivers 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SysDebug()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SysDebug" 
      () 
  nil
   () )

; 
;  *  SysDebugStr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SysDebugStr" 
      ((str (:string 255))) 
  nil
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; TARGET_CPU_PPC
;  SADE break points 
; 
;  *  SysBreak()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SysBreak" 
      ()
   nil
   (:stack-trap #xA9C9 :d0 65046))

; 
;  *  SysBreakStr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SysBreakStr" 
      ((debuggerMsg (:string 255)))
   nil
   (:stack-trap #xA9C9 :d0 65045 debuggerMsg))

; 
;  *  SysBreakFunc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SysBreakFunc" 
      ((debuggerMsg (:string 255)))
   nil
   (:stack-trap #xA9C9 :d0 65044 debuggerMsg))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Debugger68k()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  DebugStr68k()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_Debugger68k" 
      () 
  nil
   () )
(deftrap-inline "_DebugStr68k" 
      ((debuggerMsg (:string 255))) 
  nil
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; $ENDC                                         ; TARGET_OS_MAC

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := MacTypesIncludes

; $ENDC                                         ; __MACTYPES__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'MacTypes)