(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:MediaHandlers.p"
; at Wednesday May 1,2002 2:42:07 pm.
; 
;      File:       MediaHandlers.p
;  
;      Contains:   QuickTime Interfaces.
;  
;      Version:    Technology: QuickTime 5.0.1
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1990-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __MEDIAHANDLERS__
; $SETC __MEDIAHANDLERS__ := 1

; $I+
; $SETC MediaHandlersIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __COMPONENTS__
|#

(require-interface 'Components)
#|                                              ; $I Components.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __SOUND__
|#

(require-interface 'Sound)
#|                                              ; $I Sound.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MOVIES__
|#

(require-interface 'Movies)
#|                                              ; $I Movies.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	PrePrerollCompleteProcPtr = PROCEDURE(mh: MediaHandler; err: OSErr; refcon: UNIV Ptr);

|#
 |#                                             ; $ELSEC
(def-mactype :preprerollcompleteprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :preprerollcompleteupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :preprerollcompleteupp (find-mactype ':pointer))
; $ENDC

(defconstant $handlerHasSpatial #x1)
(defconstant $handlerCanClip #x2)
(defconstant $handlerCanMatte #x4)
(defconstant $handlerCanTransferMode #x8)
(defconstant $handlerNeedsBuffer #x10)
(defconstant $handlerNoIdle #x20)
(defconstant $handlerNoScheduler #x40)
(defconstant $handlerWantsTime #x80)
(defconstant $handlerCGrafPortOnly #x100)
(defconstant $handlerCanSend #x200)
(defconstant $handlerCanHandleComplexMatrix #x400)
(defconstant $handlerWantsDestinationPixels #x800)
(defconstant $handlerCanSendImageData #x1000)
(defconstant $handlerCanPicSave #x2000)

; 	 media task flags 	
(defconstant $mMustDraw #x8)
(defconstant $mAtEnd #x10)
(defconstant $mPreflightDraw #x20)
(defconstant $mSyncDrawing #x40)
(defconstant $mPrecompositeOnly #x200)
(defconstant $mSoundOnly #x400)
(defconstant $mDoIdleActionsBeforeDraws #x800)
(defconstant $mDisableIdleActions #x1000)

; 	 media task result flags 	
(defconstant $mDidDraw #x1)
(defconstant $mNeedsToDraw #x4)
(defconstant $mDrawAgain #x8)
(defconstant $mPartialDraw #x10)
(defconstant $mWantIdleActions #x20)

(defconstant $forceUpdateRedraw #x1)
(defconstant $forceUpdateNewBuffer #x2)

; 	 media hit test flags 	
(defconstant $mHitTestBounds #x1)               ;      point must only be within targetRefCon's bounding box  
(defconstant $mHitTestImage #x2)                ;    point must be within the shape of the targetRefCon's image  
(defconstant $mHitTestInvisible #x4)            ;    invisible targetRefCon's may be hit tested  
(defconstant $mHitTestIsClick #x8)              ;    for codecs that want mouse events  

; 	 media is opaque flags 	
(defconstant $mOpaque #x1)
(defconstant $mInvisible #x2)

; 	 MediaSetPublicInfo/MediaGetPublicInfo selectors 	
(defconstant $kMediaQTIdleFrequencySelector :|idfq|)

(def-mactype :getmoviecompleteparamsptr (find-mactype '(:pointer :getmoviecompleteparams)))
(defrecord GetMovieCompleteParams 
   (version :signed-integer)
   (theMovie (:pointer :movierecord))
   (theTrack (:pointer :trackrecord))
   (theMedia (:pointer :mediarecord))
   (movieScale :signed-long)
   (mediaScale :signed-long)
   (movieDuration :signed-long)
   (trackDuration :signed-long)
   (mediaDuration :signed-long)
   (effectiveRate :signed-long)
   (TimeBase :pointer)
   (volume :signed-integer)
   (width :signed-long)
   (height :signed-long)
   (trackMovieMatrix :matrixrecord)
   (moviePort (:pointer :cgrafport))
   (movieGD (:handle :gdevice))
   (trackMatte (:handle :pixmap))
   (inputMap :handle)
   )

(defconstant $kMediaVideoParamBrightness 1)
(defconstant $kMediaVideoParamContrast 2)
(defconstant $kMediaVideoParamHue 3)
(defconstant $kMediaVideoParamSharpness 4)
(defconstant $kMediaVideoParamSaturation 5)
(defconstant $kMediaVideoParamBlackLevel 6)
(defconstant $kMediaVideoParamWhiteLevel 7)

;   These are for MediaGetInfo() and MediaSetInfo(). 
(defconstant $kMHInfoEncodedFrameRate :|orat|)  ;   Parameter is a MHInfoEncodedFrameRateRecord*. 

;   This holds the frame rate at which the track was encoded. 

(def-mactype :mhinfoencodedframeraterecordptr (find-mactype '(:pointer :mhinfoencodedframeraterecord)))
(defrecord MHInfoEncodedFrameRateRecord 
   (encodedFrameRate :signed-long)
   )

(def-mactype :datahandleptr (find-mactype '(:pointer :handle)))
(def-mactype :datahandlehandle (find-mactype '(:handle :handle)))

(def-mactype :qtcustomactiontargetrecordptr (find-mactype '(:pointer :qtcustomactiontargetrecord)))
(defrecord QTCustomActionTargetRecord 
   (Movie (:pointer :movierecord))
   (doMCActionCallbackProc :pointer)
   (callBackRefcon :signed-long)
   (Track (:pointer :trackrecord))
   (trackObjectRefCon :signed-long)
   (defaultTrack (:pointer :trackrecord))
   (defaultObjectRefCon :signed-long)
   (reserved1 :signed-long)
   (reserved2 :signed-long)
   )

(def-mactype :qtcustomactiontargetptr (find-mactype '(:pointer :qtcustomactiontargetrecord)))
(def-mactype :mediaeqspectrumbandsrecordptr (find-mactype '(:pointer :mediaeqspectrumbandsrecord)))
(defrecord MediaEQSpectrumBandsRecord 
   (count :signed-integer)
   (frequency (:pointer :unsigned-long))        ;   pointer to array of frequencies 
   )

; 
; 	 *  CallComponentExecuteWiredAction()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in QuickTimeLib 4.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0.2 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 *    Windows:          in qtmlClient.lib 4.0 and later
; 	 	

(deftrap "_CallComponentExecuteWiredAction" 
      ((ci (:pointer :componentinstancerecord)) (actionContainer :handle) (actionAtom :signed-long) (target (:pointer :qtcustomactiontargetrecord)) (event (:pointer :qteventrecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci actionContainer actionAtom target event ((+ (ash 16 16) 65527) :signed-longint)))

;  MediaCallRange2 
;  These are unique to each type of media handler 
;  They are also included in the public interfaces 

; **** These are the calls for dealing with the Generic media handler ****
; 
;  *  MediaInitialize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaInitialize" 
      ((mh (:pointer :componentinstancerecord)) (gmc (:pointer :getmoviecompleteparams)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh gmc ((+ (ash 4 16) 1281) :signed-longint)))

; 
;  *  MediaSetHandlerCapabilities()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaSetHandlerCapabilities" 
      ((mh (:pointer :componentinstancerecord)) (flags :signed-long) (flagsMask :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh flags flagsMask ((+ (ash 8 16) 1282) :signed-longint)))

; 
;  *  MediaIdle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  
; CONST
(deftrap "_MediaIdle" 
      ((mh (:pointer :componentinstancerecord)) (atMediaTime :signed-long) (flagsIn :signed-long) (flagsOut (:pointer :signed-long)) (movieTime (:pointer :timerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh atMediaTime flagsIn flagsOut movieTime ((+ (ash 16 16) 1283) :signed-longint)))

; 
;  *  MediaGetMediaInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaGetMediaInfo" 
      ((mh (:pointer :componentinstancerecord)) (h :handle))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh h ((+ (ash 4 16) 1284) :signed-longint)))

; 
;  *  MediaPutMediaInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaPutMediaInfo" 
      ((mh (:pointer :componentinstancerecord)) (h :handle))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh h ((+ (ash 4 16) 1285) :signed-longint)))

; 
;  *  MediaSetActive()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaSetActive" 
      ((mh (:pointer :componentinstancerecord)) (enableMedia :boolean))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh enableMedia ((+ (ash 2 16) 1286) :signed-longint)))

; 
;  *  MediaSetRate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaSetRate" 
      ((mh (:pointer :componentinstancerecord)) (rate :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh rate ((+ (ash 4 16) 1287) :signed-longint)))

; 
;  *  MediaGGetStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaGGetStatus" 
      ((mh (:pointer :componentinstancerecord)) (statusErr (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh statusErr ((+ (ash 4 16) 1288) :signed-longint)))

; 
;  *  MediaTrackEdited()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaTrackEdited" 
      ((mh (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh ((+ (ash 0 16) 1289) :signed-longint)))

; 
;  *  MediaSetMediaTimeScale()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaSetMediaTimeScale" 
      ((mh (:pointer :componentinstancerecord)) (newTimeScale :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh newTimeScale ((+ (ash 4 16) 1290) :signed-longint)))

; 
;  *  MediaSetMovieTimeScale()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaSetMovieTimeScale" 
      ((mh (:pointer :componentinstancerecord)) (newTimeScale :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh newTimeScale ((+ (ash 4 16) 1291) :signed-longint)))

; 
;  *  MediaSetGWorld()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaSetGWorld" 
      ((mh (:pointer :componentinstancerecord)) (aPort (:pointer :cgrafport)) (aGD (:handle :gdevice)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh aPort aGD ((+ (ash 8 16) 1292) :signed-longint)))

; 
;  *  MediaSetDimensions()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaSetDimensions" 
      ((mh (:pointer :componentinstancerecord)) (width :signed-long) (height :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh width height ((+ (ash 8 16) 1293) :signed-longint)))

; 
;  *  MediaSetClip()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaSetClip" 
      ((mh (:pointer :componentinstancerecord)) (theClip (:handle :macregion)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh theClip ((+ (ash 4 16) 1294) :signed-longint)))

; 
;  *  MediaSetMatrix()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaSetMatrix" 
      ((mh (:pointer :componentinstancerecord)) (trackMovieMatrix (:pointer :matrixrecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh trackMovieMatrix ((+ (ash 4 16) 1295) :signed-longint)))

; 
;  *  MediaGetTrackOpaque()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaGetTrackOpaque" 
      ((mh (:pointer :componentinstancerecord)) (trackIsOpaque (:pointer :boolean)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh trackIsOpaque ((+ (ash 4 16) 1296) :signed-longint)))

; 
;  *  MediaSetGraphicsMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  
; CONST
(deftrap "_MediaSetGraphicsMode" 
      ((mh (:pointer :componentinstancerecord)) (mode :signed-long) (opColor (:pointer :rgbcolor)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh mode opColor ((+ (ash 8 16) 1297) :signed-longint)))

; 
;  *  MediaGetGraphicsMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaGetGraphicsMode" 
      ((mh (:pointer :componentinstancerecord)) (mode (:pointer :signed-long)) (opColor (:pointer :rgbcolor)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh mode opColor ((+ (ash 8 16) 1298) :signed-longint)))

; 
;  *  MediaGSetVolume()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaGSetVolume" 
      ((mh (:pointer :componentinstancerecord)) (volume :signed-integer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh volume ((+ (ash 2 16) 1299) :signed-longint)))

; 
;  *  MediaSetSoundBalance()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaSetSoundBalance" 
      ((mh (:pointer :componentinstancerecord)) (balance :signed-integer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh balance ((+ (ash 2 16) 1300) :signed-longint)))

; 
;  *  MediaGetSoundBalance()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaGetSoundBalance" 
      ((mh (:pointer :componentinstancerecord)) (balance (:pointer :signed-integer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh balance ((+ (ash 4 16) 1301) :signed-longint)))

; 
;  *  MediaGetNextBoundsChange()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaGetNextBoundsChange" 
      ((mh (:pointer :componentinstancerecord)) (when (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh when ((+ (ash 4 16) 1302) :signed-longint)))

; 
;  *  MediaGetSrcRgn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaGetSrcRgn" 
      ((mh (:pointer :componentinstancerecord)) (rgn (:handle :macregion)) (atMediaTime :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh rgn atMediaTime ((+ (ash 8 16) 1303) :signed-longint)))

; 
;  *  MediaPreroll()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaPreroll" 
      ((mh (:pointer :componentinstancerecord)) (time :signed-long) (rate :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh time rate ((+ (ash 8 16) 1304) :signed-longint)))

; 
;  *  MediaSampleDescriptionChanged()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaSampleDescriptionChanged" 
      ((mh (:pointer :componentinstancerecord)) (index :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh index ((+ (ash 4 16) 1305) :signed-longint)))

; 
;  *  MediaHasCharacteristic()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaHasCharacteristic" 
      ((mh (:pointer :componentinstancerecord)) (characteristic :ostype) (hasIt (:pointer :boolean)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh characteristic hasIt ((+ (ash 8 16) 1306) :signed-longint)))

; 
;  *  MediaGetOffscreenBufferSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaGetOffscreenBufferSize" 
      ((mh (:pointer :componentinstancerecord)) (bounds (:pointer :rect)) (depth :signed-integer) (ctab (:handle :colortable)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh bounds depth ctab ((+ (ash 10 16) 1307) :signed-longint)))

; 
;  *  MediaSetHints()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaSetHints" 
      ((mh (:pointer :componentinstancerecord)) (hints :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh hints ((+ (ash 4 16) 1308) :signed-longint)))

; 
;  *  MediaGetName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaGetName" 
      ((mh (:pointer :componentinstancerecord)) (name (:pointer (:string 255))) (requestedLanguage :signed-long) (actualLanguage (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh name requestedLanguage actualLanguage ((+ (ash 12 16) 1309) :signed-longint)))

; 
;  *  MediaForceUpdate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaForceUpdate" 
      ((mh (:pointer :componentinstancerecord)) (forceUpdateFlags :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh forceUpdateFlags ((+ (ash 4 16) 1310) :signed-longint)))

; 
;  *  MediaGetDrawingRgn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaGetDrawingRgn" 
      ((mh (:pointer :componentinstancerecord)) (partialRgn (:pointer (:handle :macregion))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh partialRgn ((+ (ash 4 16) 1311) :signed-longint)))

; 
;  *  MediaGSetActiveSegment()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaGSetActiveSegment" 
      ((mh (:pointer :componentinstancerecord)) (activeStart :signed-long) (activeDuration :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh activeStart activeDuration ((+ (ash 8 16) 1312) :signed-longint)))

; 
;  *  MediaInvalidateRegion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaInvalidateRegion" 
      ((mh (:pointer :componentinstancerecord)) (invalRgn (:handle :macregion)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh invalRgn ((+ (ash 4 16) 1313) :signed-longint)))

; 
;  *  MediaGetNextStepTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaGetNextStepTime" 
      ((mh (:pointer :componentinstancerecord)) (flags :signed-integer) (mediaTimeIn :signed-long) (mediaTimeOut (:pointer :signed-long)) (rate :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh flags mediaTimeIn mediaTimeOut rate ((+ (ash 14 16) 1314) :signed-longint)))

; 
;  *  MediaSetNonPrimarySourceData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaSetNonPrimarySourceData" 
      ((mh (:pointer :componentinstancerecord)) (inputIndex :signed-long) (dataDescriptionSeed :signed-long) (dataDescription :handle) (data :pointer) (dataSize :signed-long) (asyncCompletionProc (:pointer :icmcompletionprocrecord)) (transferProc :pointer) (refCon :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh inputIndex dataDescriptionSeed dataDescription data dataSize asyncCompletionProc transferProc refCon ((+ (ash 32 16) 1315) :signed-longint)))

; 
;  *  MediaChangedNonPrimarySource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaChangedNonPrimarySource" 
      ((mh (:pointer :componentinstancerecord)) (inputIndex :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh inputIndex ((+ (ash 4 16) 1316) :signed-longint)))

; 
;  *  MediaTrackReferencesChanged()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaTrackReferencesChanged" 
      ((mh (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh ((+ (ash 0 16) 1317) :signed-longint)))

; 
;  *  MediaGetSampleDataPointer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaGetSampleDataPointer" 
      ((mh (:pointer :componentinstancerecord)) (sampleNum :signed-long) (dataPtr (:pointer :pointer)) (dataSize (:pointer :signed-long)) (sampleDescIndex (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh sampleNum dataPtr dataSize sampleDescIndex ((+ (ash 16 16) 1318) :signed-longint)))

; 
;  *  MediaReleaseSampleDataPointer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaReleaseSampleDataPointer" 
      ((mh (:pointer :componentinstancerecord)) (sampleNum :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh sampleNum ((+ (ash 4 16) 1319) :signed-longint)))

; 
;  *  MediaTrackPropertyAtomChanged()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaTrackPropertyAtomChanged" 
      ((mh (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh ((+ (ash 0 16) 1320) :signed-longint)))

; 
;  *  MediaSetTrackInputMapReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaSetTrackInputMapReference" 
      ((mh (:pointer :componentinstancerecord)) (inputMap :handle))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh inputMap ((+ (ash 4 16) 1321) :signed-longint)))

; 
;  *  MediaSetVideoParam()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaSetVideoParam" 
      ((mh (:pointer :componentinstancerecord)) (whichParam :signed-long) (value (:pointer :unsigned-integer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh whichParam value ((+ (ash 8 16) 1323) :signed-longint)))

; 
;  *  MediaGetVideoParam()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaGetVideoParam" 
      ((mh (:pointer :componentinstancerecord)) (whichParam :signed-long) (value (:pointer :unsigned-integer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh whichParam value ((+ (ash 8 16) 1324) :signed-longint)))

; 
;  *  MediaCompare()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaCompare" 
      ((mh (:pointer :componentinstancerecord)) (isOK (:pointer :boolean)) (srcMedia (:pointer :mediarecord)) (srcMediaComponent (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh isOK srcMedia srcMediaComponent ((+ (ash 12 16) 1325) :signed-longint)))

; 
;  *  MediaGetClock()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaGetClock" 
      ((mh (:pointer :componentinstancerecord)) (clock (:pointer (:pointer :componentinstancerecord))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh clock ((+ (ash 4 16) 1326) :signed-longint)))

; 
;  *  MediaSetSoundOutputComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaSetSoundOutputComponent" 
      ((mh (:pointer :componentinstancerecord)) (outputComponent (:pointer :componentrecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh outputComponent ((+ (ash 4 16) 1327) :signed-longint)))

; 
;  *  MediaGetSoundOutputComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaGetSoundOutputComponent" 
      ((mh (:pointer :componentinstancerecord)) (outputComponent (:pointer (:pointer :componentrecord))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh outputComponent ((+ (ash 4 16) 1328) :signed-longint)))

; 
;  *  MediaSetSoundLocalizationData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaSetSoundLocalizationData" 
      ((mh (:pointer :componentinstancerecord)) (data :handle))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh data ((+ (ash 4 16) 1329) :signed-longint)))

; 
;  *  MediaGetInvalidRegion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaGetInvalidRegion" 
      ((mh (:pointer :componentinstancerecord)) (rgn (:handle :macregion)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh rgn ((+ (ash 4 16) 1340) :signed-longint)))

; 
;  *  MediaSampleDescriptionB2N()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaSampleDescriptionB2N" 
      ((mh (:pointer :componentinstancerecord)) (sampleDescriptionH (:handle :sampledescription)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh sampleDescriptionH ((+ (ash 4 16) 1342) :signed-longint)))

; 
;  *  MediaSampleDescriptionN2B()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaSampleDescriptionN2B" 
      ((mh (:pointer :componentinstancerecord)) (sampleDescriptionH (:handle :sampledescription)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh sampleDescriptionH ((+ (ash 4 16) 1343) :signed-longint)))

; 
;  *  MediaQueueNonPrimarySourceData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  
; CONST
(deftrap "_MediaQueueNonPrimarySourceData" 
      ((mh (:pointer :componentinstancerecord)) (inputIndex :signed-long) (dataDescriptionSeed :signed-long) (dataDescription :handle) (data :pointer) (dataSize :signed-long) (asyncCompletionProc (:pointer :icmcompletionprocrecord)) (frameTime (:pointer :icmframetimerecord)) (transferProc :pointer) (refCon :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh inputIndex dataDescriptionSeed dataDescription data dataSize asyncCompletionProc frameTime transferProc refCon ((+ (ash 36 16) 1344) :signed-longint)))

; 
;  *  MediaFlushNonPrimarySourceData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaFlushNonPrimarySourceData" 
      ((mh (:pointer :componentinstancerecord)) (inputIndex :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh inputIndex ((+ (ash 4 16) 1345) :signed-longint)))

; 
;  *  MediaGetURLLink()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaGetURLLink" 
      ((mh (:pointer :componentinstancerecord)) (displayWhere :point) (urlLink (:pointer :handle)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh displayWhere urlLink ((+ (ash 8 16) 1347) :signed-longint)))

; 
;  *  MediaMakeMediaTimeTable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaMakeMediaTimeTable" 
      ((mh (:pointer :componentinstancerecord)) (offsets (:pointer :pointer)) (startTime :signed-long) (endTime :signed-long) (timeIncrement :signed-long) (firstDataRefIndex :signed-integer) (lastDataRefIndex :signed-integer) (retDataRefSkew (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh offsets startTime endTime timeIncrement firstDataRefIndex lastDataRefIndex retDataRefSkew ((+ (ash 24 16) 1349) :signed-longint)))

; 
;  *  MediaHitTestForTargetRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaHitTestForTargetRefCon" 
      ((mh (:pointer :componentinstancerecord)) (flags :signed-long) (loc :point) (targetRefCon (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh flags loc targetRefCon ((+ (ash 12 16) 1350) :signed-longint)))

; 
;  *  MediaHitTestTargetRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaHitTestTargetRefCon" 
      ((mh (:pointer :componentinstancerecord)) (targetRefCon :signed-long) (flags :signed-long) (loc :point) (wasHit (:pointer :boolean)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh targetRefCon flags loc wasHit ((+ (ash 16 16) 1351) :signed-longint)))

; 
;  *  MediaGetActionsForQTEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaGetActionsForQTEvent" 
      ((mh (:pointer :componentinstancerecord)) (event (:pointer :qteventrecord)) (targetRefCon :signed-long) (container (:pointer :handle)) (atom (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh event targetRefCon container atom ((+ (ash 16 16) 1352) :signed-longint)))

; 
;  *  MediaDisposeTargetRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaDisposeTargetRefCon" 
      ((mh (:pointer :componentinstancerecord)) (targetRefCon :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh targetRefCon ((+ (ash 4 16) 1353) :signed-longint)))

; 
;  *  MediaTargetRefConsEqual()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaTargetRefConsEqual" 
      ((mh (:pointer :componentinstancerecord)) (firstRefCon :signed-long) (secondRefCon :signed-long) (equal (:pointer :boolean)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh firstRefCon secondRefCon equal ((+ (ash 12 16) 1354) :signed-longint)))

; 
;  *  MediaSetActionsCallback()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaSetActionsCallback" 
      ((mh (:pointer :componentinstancerecord)) (actionsCallbackProc :pointer) (refcon :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh actionsCallbackProc refcon ((+ (ash 8 16) 1355) :signed-longint)))

; 
;  *  MediaPrePrerollBegin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaPrePrerollBegin" 
      ((mh (:pointer :componentinstancerecord)) (time :signed-long) (rate :signed-long) (completeProc :pointer) (refcon :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh time rate completeProc refcon ((+ (ash 16 16) 1356) :signed-longint)))

; 
;  *  MediaPrePrerollCancel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaPrePrerollCancel" 
      ((mh (:pointer :componentinstancerecord)) (refcon :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh refcon ((+ (ash 4 16) 1357) :signed-longint)))

; 
;  *  MediaEnterEmptyEdit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaEnterEmptyEdit" 
      ((mh (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh ((+ (ash 0 16) 1359) :signed-longint)))

; 
;  *  MediaCurrentMediaQueuedData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MediaCurrentMediaQueuedData" 
      ((mh (:pointer :componentinstancerecord)) (milliSecs (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh milliSecs ((+ (ash 4 16) 1360) :signed-longint)))

; 
;  *  MediaGetEffectiveVolume()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 4.0 and later
;  

(deftrap "_MediaGetEffectiveVolume" 
      ((mh (:pointer :componentinstancerecord)) (volume (:pointer :signed-integer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh volume ((+ (ash 4 16) 1361) :signed-longint)))

; 
;  *  MediaResolveTargetRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 4.0 and later
;  

(deftrap "_MediaResolveTargetRefCon" 
      ((mh (:pointer :componentinstancerecord)) (container :handle) (atom :signed-long) (targetRefCon (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh container atom targetRefCon ((+ (ash 12 16) 1362) :signed-longint)))

; 
;  *  MediaGetSoundLevelMeteringEnabled()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 4.0 and later
;  

(deftrap "_MediaGetSoundLevelMeteringEnabled" 
      ((mh (:pointer :componentinstancerecord)) (enabled (:pointer :boolean)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh enabled ((+ (ash 4 16) 1363) :signed-longint)))

; 
;  *  MediaSetSoundLevelMeteringEnabled()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 4.0 and later
;  

(deftrap "_MediaSetSoundLevelMeteringEnabled" 
      ((mh (:pointer :componentinstancerecord)) (enable :boolean))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh enable ((+ (ash 2 16) 1364) :signed-longint)))

; 
;  *  MediaGetSoundLevelMeterInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 4.0 and later
;  

(deftrap "_MediaGetSoundLevelMeterInfo" 
      ((mh (:pointer :componentinstancerecord)) (levelInfo (:pointer :levelmeterinfo)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh levelInfo ((+ (ash 4 16) 1365) :signed-longint)))

; 
;  *  MediaGetEffectiveSoundBalance()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 4.0 and later
;  

(deftrap "_MediaGetEffectiveSoundBalance" 
      ((mh (:pointer :componentinstancerecord)) (balance (:pointer :signed-integer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh balance ((+ (ash 4 16) 1366) :signed-longint)))

; 
;  *  MediaSetScreenLock()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 4.0 and later
;  

(deftrap "_MediaSetScreenLock" 
      ((mh (:pointer :componentinstancerecord)) (lockIt :boolean))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh lockIt ((+ (ash 2 16) 1367) :signed-longint)))

; 
;  *  MediaSetDoMCActionCallback()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 4.0 and later
;  

(deftrap "_MediaSetDoMCActionCallback" 
      ((mh (:pointer :componentinstancerecord)) (doMCActionCallbackProc :pointer) (refcon :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh doMCActionCallbackProc refcon ((+ (ash 8 16) 1368) :signed-longint)))

; 
;  *  MediaGetErrorString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 4.0 and later
;  

(deftrap "_MediaGetErrorString" 
      ((mh (:pointer :componentinstancerecord)) (theError :signed-long) (errorString (:pointer (:string 255))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh theError errorString ((+ (ash 8 16) 1369) :signed-longint)))

; 
;  *  MediaGetSoundEqualizerBands()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 4.0 and later
;  

(deftrap "_MediaGetSoundEqualizerBands" 
      ((mh (:pointer :componentinstancerecord)) (spectrumInfo (:pointer :mediaeqspectrumbandsrecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh spectrumInfo ((+ (ash 4 16) 1370) :signed-longint)))

; 
;  *  MediaSetSoundEqualizerBands()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 4.0 and later
;  

(deftrap "_MediaSetSoundEqualizerBands" 
      ((mh (:pointer :componentinstancerecord)) (spectrumInfo (:pointer :mediaeqspectrumbandsrecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh spectrumInfo ((+ (ash 4 16) 1371) :signed-longint)))

; 
;  *  MediaGetSoundEqualizerBandLevels()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 4.0 and later
;  

(deftrap "_MediaGetSoundEqualizerBandLevels" 
      ((mh (:pointer :componentinstancerecord)) (bandLevels (:pointer :unsigned-byte)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh bandLevels ((+ (ash 4 16) 1372) :signed-longint)))

; 
;  *  MediaDoIdleActions()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 4.0 and later
;  

(deftrap "_MediaDoIdleActions" 
      ((mh (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh ((+ (ash 0 16) 1373) :signed-longint)))

; 
;  *  MediaSetSoundBassAndTreble()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 4.0 and later
;  

(deftrap "_MediaSetSoundBassAndTreble" 
      ((mh (:pointer :componentinstancerecord)) (bass :signed-integer) (treble :signed-integer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh bass treble ((+ (ash 4 16) 1374) :signed-longint)))

; 
;  *  MediaGetSoundBassAndTreble()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 4.0 and later
;  

(deftrap "_MediaGetSoundBassAndTreble" 
      ((mh (:pointer :componentinstancerecord)) (bass (:pointer :signed-integer)) (treble (:pointer :signed-integer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh bass treble ((+ (ash 8 16) 1375) :signed-longint)))

; 
;  *  MediaTimeBaseChanged()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 4.0 and later
;  

(deftrap "_MediaTimeBaseChanged" 
      ((mh (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh ((+ (ash 0 16) 1376) :signed-longint)))

; 
;  *  MediaMCIsPlayerEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 4.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 4.1 and later
;  
; CONST
(deftrap "_MediaMCIsPlayerEvent" 
      ((mh (:pointer :componentinstancerecord)) (e (:pointer :eventrecord)) (handledIt (:pointer :boolean)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh e handledIt ((+ (ash 8 16) 1377) :signed-longint)))

; 
;  *  MediaGetMediaLoadState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 4.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 4.1 and later
;  

(deftrap "_MediaGetMediaLoadState" 
      ((mh (:pointer :componentinstancerecord)) (mediaLoadState (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh mediaLoadState ((+ (ash 4 16) 1378) :signed-longint)))

; 
;  *  MediaVideoOutputChanged()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 5.0 and later
;  

(deftrap "_MediaVideoOutputChanged" 
      ((mh (:pointer :componentinstancerecord)) (vout (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh vout ((+ (ash 4 16) 1379) :signed-longint)))

; 
;  *  MediaEmptySampleCache()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 5.0 and later
;  

(deftrap "_MediaEmptySampleCache" 
      ((mh (:pointer :componentinstancerecord)) (sampleNum :signed-long) (sampleCount :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh sampleNum sampleCount ((+ (ash 8 16) 1380) :signed-longint)))

; 
;  *  MediaGetPublicInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 5.0 and later
;  

(deftrap "_MediaGetPublicInfo" 
      ((mh (:pointer :componentinstancerecord)) (infoSelector :ostype) (infoDataPtr :pointer) (ioDataSize (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh infoSelector infoDataPtr ioDataSize ((+ (ash 12 16) 1381) :signed-longint)))

; 
;  *  MediaSetPublicInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 5.0 and later
;  

(deftrap "_MediaSetPublicInfo" 
      ((mh (:pointer :componentinstancerecord)) (infoSelector :ostype) (infoDataPtr :pointer) (dataSize :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh infoSelector infoDataPtr dataSize ((+ (ash 12 16) 1382) :signed-longint)))

; 
;  *  MediaGetUserPreferredCodecs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 5.0 and later
;  

(deftrap "_MediaGetUserPreferredCodecs" 
      ((mh (:pointer :componentinstancerecord)) (userPreferredCodecs (:pointer (:pointer (:handle :componentrecord)))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh userPreferredCodecs ((+ (ash 4 16) 1383) :signed-longint)))

; 
;  *  MediaSetUserPreferredCodecs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 5.0 and later
;  

(deftrap "_MediaSetUserPreferredCodecs" 
      ((mh (:pointer :componentinstancerecord)) (userPreferredCodecs (:pointer (:handle :componentrecord))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh userPreferredCodecs ((+ (ash 4 16) 1384) :signed-longint)))

(defconstant $uppPrePrerollCompleteProcInfo #xEC0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewPrePrerollCompleteUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewPrePrerollCompleteProc 
(deftrap "_NewPrePrerollCompleteUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposePrePrerollCompleteUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposePrePrerollCompleteUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokePrePrerollCompleteUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallPrePrerollCompleteProc 
(deftrap-inline "_InvokePrePrerollCompleteUPP" 
      ((mh (:pointer :componentinstancerecord)) (err :signed-integer) (refcon :pointer) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := MediaHandlersIncludes

; $ENDC                                         ; __MEDIAHANDLERS__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'MediaHandlers)