(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:MultiprocessingInfo.p"
; at Wednesday May 1,2002 2:40:07 pm.
; 
;      File:       MultiprocessingInfo.p
;  
;      Contains:   Multiprocessing Information interfaces
;  
;      Version:    Technology: Multiprocessing Information API version 2.2
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 DayStar Digital, Inc.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 

; 
;    ==========================================================================================================================
;    *** WARNING: You must properly check the availability of MP services before calling them!
;    See the section titled "Checking API Availability".
;    ==========================================================================================================================
; 

#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __MULTIPROCESSINGINFO__
; $SETC __MULTIPROCESSINGINFO__ := 1

; $I+
; $SETC MultiprocessingInfoIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MULTIPROCESSING__
|#

(require-interface 'Multiprocessing)
#|                                              ; $I Multiprocessing.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

; 
;    ==========================================================================================================================
;    This is the header file for version 2.3 of the Mac OS multiprocessing information support. 
;    ==========================================================================================================================
; 

; 
;    ==========================================================================================================================
;    The following services are new in version 2.1:
;     MPGetNextTaskID
;     MPGetNextCpuID
;    ==========================================================================================================================
; 

; 
;    ==========================================================================================================================
;    The following services are new in version 2.2:
;     MPGetPageSizeClasses
;     MPGetPageSize
;     MPGetNextAreaID
;    ==========================================================================================================================
; 

; 
;    ==========================================================================================================================
;    The following services are new in version 2.3:
;     MPGetNextCoherenceID
;     MPGetNextProcessID
;     MPGetNextAddressSpaceID
;     MPGetNextQueueID
;     MPGetNextSemaphoreID
;     MPGetNextCriticalRegionID
;     MPGetNextTimerID
;     MPGetNextEventID
;     MPGetNextNotificationID
;     MPGetNextConsoleID
;    ==========================================================================================================================
; 

; 
;    
;    ==========================================================================================================================
;    Page size Services
;    ==================
; 

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  MPGetPageSizeClasses()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPDiagnostics 2.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MPGetPageSizeClasses" 
      () 
  :unsigned-long
   () )

;   The number of page size classes, 1 to n. 
; $ENDC                                         ; CALL_NOT_IN_CARBON

;   ------------------------------------------------------------------------------------------- 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  MPGetPageSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPDiagnostics 2.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MPGetPageSize" 
      ((pageClass :unsigned-long)) 
  :unsigned-long
   () )

;   The page size in bytes. 
; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;    
;    ==========================================================================================================================
;    ID Iterator Services
;    ==========================
; 

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  MPGetNextCoherenceID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPDiagnostics 2.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MPGetNextCoherenceID" 
      ((coherenceID (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  MPGetNextCpuID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPDiagnostics 2.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MPGetNextCpuID" 
      ((owningCoherenceID :pointer) (cpuID (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  MPGetNextProcessID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPDiagnostics 2.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MPGetNextProcessID" 
      ((processID (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  MPGetNextAddressSpaceID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPDiagnostics 2.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MPGetNextAddressSpaceID" 
      ((owningProcessID :pointer) (addressSpaceID (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  MPGetNextTaskID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPDiagnostics 2.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MPGetNextTaskID" 
      ((owningProcessID :pointer) (taskID (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  MPGetNextQueueID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPDiagnostics 2.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MPGetNextQueueID" 
      ((owningProcessID :pointer) (queueID (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  MPGetNextSemaphoreID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPDiagnostics 2.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MPGetNextSemaphoreID" 
      ((owningProcessID :pointer) (semaphoreID (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  MPGetNextCriticalRegionID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPDiagnostics 2.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MPGetNextCriticalRegionID" 
      ((owningProcessID :pointer) (criticalRegionID (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  MPGetNextTimerID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPDiagnostics 2.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MPGetNextTimerID" 
      ((owningProcessID :pointer) (timerID (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  MPGetNextEventID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPDiagnostics 2.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MPGetNextEventID" 
      ((owningProcessID :pointer) (eventID (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  MPGetNextNotificationID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPDiagnostics 2.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MPGetNextNotificationID" 
      ((owningProcessID :pointer) (notificationID (:pointer :pointer))) 
  :osstatus
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  MPGetNextAreaID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPDiagnostics 2.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MPGetNextAreaID" 
      ((owningSpaceID :pointer) (areaID (:pointer :pointer))) 
  :osstatus
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  MPGetNextConsoleID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPDiagnostics 2.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MPGetNextConsoleID" 
      ((consoleID (:pointer :pointer))) 
  :osstatus
   () )

;   ------------------------------------------------------------------------------------------- 

; 
;  *  MPGetNextID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPDiagnostics 2.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MPGetNextID" 
      ((kind :unsigned-long) (id (:pointer :pointer))) 
  :osstatus
   () )

; 
;    
;    ==========================================================================================================================
;    Object Information Services
;    ===========================
; 

; 
;    ----------------------------------------------------------------------------------------------
;    ! The implementation of MPGetObjectInfo assumes that all info records are in 4 byte multiples.
; 

; $ENDC                                         ; CALL_NOT_IN_CARBON

;   The version of the MPAreaInfo structure requested. 
(defconstant $kMPQueueInfoVersion 262145)
(defconstant $kMPSemaphoreInfoVersion 327681)
(defconstant $kMPEventInfoVersion 589825)
(defconstant $kMPCriticalRegionInfoVersion 393217)
(defconstant $kMPNotificationInfoVersion 786433)
(defconstant $kMPAddressSpaceInfoVersion 524289)

(def-mactype :mpqueueinfoptr (find-mactype '(:pointer :mpqueueinfo)))
(defrecord MPQueueInfo 
   (version :unsigned-long)                     ;   Version of the data structure requested 
   (processID :pointer)                         ;   Owning process ID 
   (queueName :ostype)                          ;   Queue name 
   (nWaiting :unsigned-long)
   (waitingTaskID :pointer)                     ;   First waiting task. 
   (nMessages :unsigned-long)
   (nReserved :unsigned-long)
   (p1 :pointer)                                ;   First message parameters... 
   (p2 :pointer)
   (p3 :pointer)
   )

(def-mactype :mpsemaphoreinfoptr (find-mactype '(:pointer :mpsemaphoreinfo)))
(defrecord MPSemaphoreInfo 
   (version :unsigned-long)                     ;   Version of the data structure requested 
   (processID :pointer)                         ;   Owning process ID 
   (semaphoreName :ostype)                      ;   Semaphore name 
   (nWaiting :unsigned-long)
   (waitingTaskID :pointer)                     ;   First waiting task. 
   (maximum :unsigned-long)
   (count :unsigned-long)
   )

(def-mactype :mpeventinfoptr (find-mactype '(:pointer :mpeventinfo)))
(defrecord MPEventInfo 
   (version :unsigned-long)                     ;   Version of the data structure requested 
   (processID :pointer)                         ;   Owning process ID 
   (eventName :ostype)                          ;   Event name 
   (nWaiting :unsigned-long)
   (waitingTaskID :pointer)                     ;   First waiting task. 
   (events :unsigned-long)
   )

(def-mactype :mpcriticalregioninfoptr (find-mactype '(:pointer :mpcriticalregioninfo)))
(defrecord MPCriticalRegionInfo 
   (version :unsigned-long)                     ;   Version of the data structure requested 
   (processID :pointer)                         ;   Owning process ID 
   (regionName :ostype)                         ;   Critical region name 
   (nWaiting :unsigned-long)
   (waitingTaskID :pointer)                     ;   First waiting task. 
   (owningTask :pointer)
   (count :unsigned-long)
   )

(def-mactype :mpnotificationinfoptr (find-mactype '(:pointer :mpnotificationinfo)))
(defrecord MPNotificationInfo 
   (version :unsigned-long)                     ;   Version of the data structure requested 
   (processID :pointer)                         ;   Owning process ID 
   (notificationName :ostype)                   ;   Notification name 
   (queueID :pointer)                           ;   Queue to notify. 
   (p1 :pointer)
   (p2 :pointer)
   (p3 :pointer)
   (eventID :pointer)                           ;   Event to set. 
   (events :unsigned-long)
   (semaphoreID :pointer)                       ;   Sempahore to signal.    
   )

(def-mactype :mpaddressspaceinfoptr (find-mactype '(:pointer :mpaddressspaceinfo)))
(defrecord MPAddressSpaceInfo 
   (version :unsigned-long)                     ;   Version of the data structure requested 
   (processID :pointer)                         ;   Owning process ID 
   (groupID :pointer)                           ;   Related coherence group. 
   (nTasks :unsigned-long)                      ;   Number of tasks in this space. 
   (vsid (:array :unsigned-long 16))            ;   Segment register VSIDs. 
   )

;   *** We should put the task info call here instead of in MPExtractTaskState. 

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  MPGetQueueInfo()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in MPDiagnostics 2.3 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_MPGetQueueInfo" 
      ((id :pointer) (version :unsigned-long) (info_o (:pointer :mpqueueinfo))) 
  :osstatus
   () )

; 
;  *  MPGetSemaphoreInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPDiagnostics 2.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MPGetSemaphoreInfo" 
      ((id :pointer) (version :unsigned-long) (info_o (:pointer :mpsemaphoreinfo))) 
  :osstatus
   () )

; 
;  *  MPGetEventInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPDiagnostics 2.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MPGetEventInfo" 
      ((id :pointer) (version :unsigned-long) (info_o (:pointer :mpeventinfo))) 
  :osstatus
   () )

; 
;  *  MPGetCriticalRegionInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPDiagnostics 2.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MPGetCriticalRegionInfo" 
      ((id :pointer) (version :unsigned-long) (info_o (:pointer :mpcriticalregioninfo))) 
  :osstatus
   () )

; 
;  *  MPGetNotificationInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPDiagnostics 2.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MPGetNotificationInfo" 
      ((id :pointer) (version :unsigned-long) (info_o (:pointer :mpnotificationinfo))) 
  :osstatus
   () )

; 
;  *  MPGetAddressSpaceInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in MPDiagnostics 2.3 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MPGetAddressSpaceInfo" 
      ((id :pointer) (version :unsigned-long) (info_o (:pointer :mpaddressspaceinfo))) 
  :osstatus
   () )

;   ========================================================================================================================== 

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := MultiprocessingInfoIncludes

; $ENDC                                         ; __MULTIPROCESSINGINFO__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'MultiprocessingInfo)