(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:NSL.p"
; at Wednesday May 1,2002 2:41:10 pm.
; 
;      File:       NSL.p
;  
;      Contains:   Interface to API for using the NSL User Interface
;  
;      Version:    Technology: Mac OS X
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __NSL__
; $SETC __NSL__ := 1

; $I+
; $SETC NSLIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __EVENTS__
|#

(require-interface 'Events)
#|                                              ; $I Events.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __NSLCORE__
|#

(require-interface 'NSLCore)
#|                                              ; $I NSLCore.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :nsldialogoptionflags (find-mactype ':unsigned-long))

(defconstant $kNSLDefaultNSLDlogOptions #x0)    ;   use defaults for all the options  
(defconstant $kNSLNoURLTEField #x1)             ;   don't show url text field for manual entry  
(defconstant $kNSLAddServiceTypes #x2)          ;   add the service type if a user enters an incomplete URL  
(defconstant $kNSLClientHandlesRecents #x4)     ;   Stops NSLStandardGetURL from adding the selection to the recent items folder  

(def-mactype :nsldialogoptionsptr (find-mactype '(:pointer :nsldialogoptions)))
(defrecord NSLDialogOptions 
   (version :unsigned-integer)
   (dialogOptionFlags :unsigned-long)           ;   option flags for affecting the dialog's behavior  
   (windowTitle (:string 255))
   (actionButtonLabel (:string 255))            ;   label of the default button (or null string for default)  
   (cancelButtonLabel (:string 255))            ;   label of the cancel button (or null string for default)  
   (message (:string 255))                      ;   custom message prompt (or null string for default)  
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	NSLURLFilterProcPtr = FUNCTION(url: CStringPtr; VAR displayString: Str255): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :nslurlfilterprocptr (find-mactype ':pointer))
; $ENDC

;   you can provide for calls to NSLStandardGetURL 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	NSLEventProcPtr = PROCEDURE(VAR newEvent: EventRecord; userContext: UNIV Ptr);

|#
 |#                                             ; $ELSEC
(def-mactype :nsleventprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :nslurlfilterupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :nslurlfilterupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :nsleventupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :nsleventupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppNSLURLFilterProcInfo #x3D0)
(defconstant $uppNSLEventProcInfo #x3C0)
; 
; 	 *  NewNSLURLFilterUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewNSLURLFilterProc 
(deftrap "_NewNSLURLFilterUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewNSLEventUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewNSLEventProc 
(deftrap "_NewNSLEventUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeNSLURLFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeNSLURLFilterUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeNSLEventUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeNSLEventUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeNSLURLFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallNSLURLFilterProc 
(deftrap-inline "_InvokeNSLURLFilterUPP" 
      ((url :pointer) (displayString (:pointer (:string 255))) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; 
;  *  InvokeNSLEventUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallNSLEventProc 
(deftrap-inline "_InvokeNSLEventUPP" 
      ((newEvent (:pointer :eventrecord)) (userContext :pointer) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

;  <--- function returns OSStatus of the operation.  noErr will be returned if valid, kNSLUserCanceled will be returned if the user cancels 
;  ---> dialogOptions 
;  ---> eventProc 
;  ---> eventProcContextPtr 
;  ---> filterProc 
;  ---> serviceTypeList 
;  <--- userSelectedURL 
;  NSLDialogOptions* dialogOptions 
; 
;    dialogOptions is a user defined structure defining the look, feel and operation of NSLStandardGetURL dialog
;    default behavior can be achieved by passing in a pointer to a structure that has been filled out by a previous
;    call to NSLGetDefaultDialogOptions or by passing in NULL.
; 
;  NSLEventUPP eventProc 
; 
;    the eventProc is a callback NSLURLFilterUPP that will
;    get called with Events that the dialog doesn't handle.  If you pass in nil,
;    you won't get update events while the NSLStandardGetURL dialog is open.
; 
;  void* eventProcContextPtr 
;   you can provide a pointer to some contextual data that you want to have sent to your eventProc filter 
;  NSLURLFilterProcPtr filterProc 
; 
;    the filter param is a callback NSLURLFilterUPP that
;    will get called (if not nil) for each url that is going to be displayed in
;    the dialog's result list.  A result of false will not include the url for the
;    user to select from.  You also have the option of handling the way the url looks
;    in the dialog listing by copying the preferred name into the displayString
;    parameter.  (If left alone, NSLStandardGetURL dialog will strip the service type
;    portion off the url).
; 
;  char* serviceTypeList 
; 
;    the serviceTypeList parameter is a null terminated string that will 
;    directly affect the contents of the services popup in the dialog.
;    The structure of this string is a set of tuples as follows:
;    Name of ServiceType as to be represented in the popup followed by
;    a comma delimted list of service descriptors (ie http,https) that will
;    used in the search of that type.  Each comma delimited tuple is delimited
;    by semi-colons.
; 
; 
;    For example:
;    If you want to search for services of type http (web), https (secure web),
;    and ftp, you could pass in the string "Web Servers,http,https;FTP Servers,ftp".
;    This would result in a popup list with two items ("Web Servers" and "FTP Servers")
;    and searches performed on them will provide results of type http and https for the
;    first, and ftp for the second.
; 

; 
;    Results list Icons:
;    NSLStandardGetURL provides icons in its listings for the following types:
;    "http", "https", "ftp", "afp", "lpr", "LaserWriter", "AFPServer"
;    any other types will get a generic icon.  However, you can provide icons
;    if you wish by including an '#ics8' resource id at the end of your comma
;    delimited list.  The dialog will then use that icon if found in its results
;    list.  This icon will be used for all types in a tuple.
;    For example:
;    The param "Web Servers,http,https;Telnet Servers,telnet;NFS Servers,nfs,129"
;    would result in lists of http and https services to be shown with their default
;    icons, telnet servers would be shown with the default misc. icon and nfs
;    servers would be shown with your icon at resource id 129.
; 

;  char** url 
; 
;    pass in the address of a char* and it will point to the resulting url.  If the user
;    cancels (the function returns false), the pointer will be set to nil.  If the function
;    returns true (user selected a url), then you must call NSLFreeURL on the pointer when
;    you are done with it.
; 
; 
;    Call this to have the user select a url based service from a dialog.
;    Function takes on input an optional filter proc, a serviceTypeList, and an address to a Ptr.
;    Function sets the value of the Ptr to a newly created c-style null terminated string
;    containing the user's choice of URL.
; 

; 
;  *  NSLStandardGetURL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  NSLGetDefaultDialogOptions()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLStandardGetURL" 
      ((dialogOptions (:pointer :nsldialogoptions)) (eventProc :pointer) (eventProcContextPtr :pointer) (filterProc :pointer) (serviceTypeList :pointer) (userSelectedURL (:pointer :pointer))) 
  :osstatus
   () )                                         ;  <--- function returns null (useful for setting variable at same time as freeing it ;  ---> url is memory created by a call to NSLStandardGetURL ; 
;  *  NSLFreeURL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLGetDefaultDialogOptions" 
      ((dialogOptions (:pointer :nsldialogoptions))) 
  :osstatus
   () )                                         ;  <--- function returns kNSLErrNullPtrError, file mgr errors, or resource mgr errors ;  ---> folderSelectorType is one of the well-known folders defined in Folders.h ;  ---> url is any valid url ;  ---> userFriendlyName is used for the file name and the display name (in the UI) ; 
;  *  NSLSaveURLAliasToFolder()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NSLPPCLib 1.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NSLFreeURL" 
      ((url :pointer)) 
  :pointer
   () )                                         ; $ALIGN RESET; $POP; $SETC UsingIncludes := NSLIncludes
(deftrap-inline "_NSLSaveURLAliasToFolder" 
      ((folderSelectorType :ostype) (url :pointer) (userFriendlyName :pointer)) 
  :signed-integer
   () )                                         ; $ENDC; __NSL__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'NSL)