(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:OSAGeneric.p"
; at Wednesday May 1,2002 2:41:06 pm.
; 
;      File:       OSAGeneric.p
;  
;      Contains:   AppleScript Generic Component Interfaces.
;  
;      Version:    Technology: AppleScript 1.1
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1992-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __OSAGENERIC__
; $SETC __OSAGENERIC__ := 1

; $I+
; $SETC OSAGenericIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __APPLEEVENTS__
|#

(require-interface 'AppleEvents)
#|                                              ; $I AppleEvents.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __OSA__
|#

(require-interface 'OSA)
#|                                              ; $I OSA.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;     NOTE:   This interface defines a "generic scripting component."
;             The Generic Scripting Component allows automatic dispatch to a
;             specific scripting component that conforms to the OSA interface.
;             This component supports OSA, by calling AppleScript or some other 
;             scripting component.  Additionally it provides access to the default
;             and the user-prefered scripting component.
; 

;   Component version this header file describes  
(defconstant $kGenericComponentVersion #x100)

(defconstant $kGSSSelectGetDefaultScriptingComponent #x1001)
(defconstant $kGSSSelectSetDefaultScriptingComponent #x1002)
(defconstant $kGSSSelectGetScriptingComponent #x1003)
(defconstant $kGSSSelectGetScriptingComponentFromStored #x1004)
(defconstant $kGSSSelectGenericToRealID #x1005)
(defconstant $kGSSSelectRealToGenericID #x1006)
(defconstant $kGSSSelectOutOfRange #x1007)

(def-mactype :scriptingcomponentselector (find-mactype ':ostype))
(def-mactype :genericid (find-mactype ':unsigned-long))
; 	 get and set the default scripting component 	
; 
; 	 *  OSAGetDefaultScriptingComponent()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_OSAGetDefaultScriptingComponent" 
      ((genericScriptingComponent (:pointer :componentinstancerecord)) (scriptingSubType (:pointer :ostype)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 genericScriptingComponent scriptingSubType ((+ (ash 4 16) 4097) :signed-longint)))

; 
;  *  OSASetDefaultScriptingComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSASetDefaultScriptingComponent" 
      ((genericScriptingComponent (:pointer :componentinstancerecord)) (scriptingSubType :ostype))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 genericScriptingComponent scriptingSubType ((+ (ash 4 16) 4098) :signed-longint)))

;  get a scripting component instance from its subtype code 
; 
;  *  OSAGetScriptingComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSAGetScriptingComponent" 
      ((genericScriptingComponent (:pointer :componentinstancerecord)) (scriptingSubType :ostype) (scriptingInstance (:pointer (:pointer :componentinstancerecord))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 genericScriptingComponent scriptingSubType scriptingInstance ((+ (ash 8 16) 4099) :signed-longint)))

;  get a scripting component selector (subType) from a stored script 
; 
;  *  OSAGetScriptingComponentFromStored()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_OSAGetScriptingComponentFromStored" 
      ((genericScriptingComponent (:pointer :componentinstancerecord)) (scriptData (:pointer :aedesc)) (scriptingSubType (:pointer :ostype)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 genericScriptingComponent scriptData scriptingSubType ((+ (ash 8 16) 4100) :signed-longint)))

;  get a real component instance and script id from a generic id 
; 
;  *  OSAGenericToRealID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSAGenericToRealID" 
      ((genericScriptingComponent (:pointer :componentinstancerecord)) (theScriptID (:pointer :unsigned-long)) (theExactComponent (:pointer (:pointer :componentinstancerecord))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 genericScriptingComponent theScriptID theExactComponent ((+ (ash 8 16) 4101) :signed-longint)))

;  get a generic id from a real component instance and script id 
; 
;  *  OSARealToGenericID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSARealToGenericID" 
      ((genericScriptingComponent (:pointer :componentinstancerecord)) (theScriptID (:pointer :unsigned-long)) (theExactComponent (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 genericScriptingComponent theScriptID theExactComponent ((+ (ash 8 16) 4102) :signed-longint)))

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := OSAGenericIncludes

; $ENDC                                         ; __OSAGENERIC__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'OSAGeneric)