(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:OpenTransport.p"
; at Wednesday May 1,2002 2:40:12 pm.
; 
;      File:       OpenTransport.p
;  
;      Contains:   Open Transport client interface file.  This contains all the client APIs
;  
;      Version:    Technology: Open Transport 2.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
;
;; by hand lose commented out all ifc not otkernel 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __OPENTRANSPORT__
; $SETC __OPENTRANSPORT__ := 1

; $I+
; $SETC OpenTransportIncludes := UsingIncludes
; $SETC UsingIncludes := 1

; 
;    The following table shows how to map from the old (pre-Universal
;    Interfaces) header file name to the equivalent Universal Interfaces
;    header file name.
;     Old Header              New Header
;     ----------              ----------
;     cred.h                  OpenTransportProtocol.h
;     dlpi.h                  OpenTransportProtocol.h
;     miioccom.h              OpenTransportProtocol.h
;     mistream.h              OpenTransportProtocol.h/OpenTransportKernel.h
;     modnames.h              OpenTransportProtocol.h
;     OpenTptAppleTalk.h      OpenTransportProviders.h
;     OpenTptClient.h         OpenTransportProtocol.h
;     OpenTptCommon.h         OpenTransportProtocol.h
;     OpenTptConfig.h         OpenTransportProtocol.h
;     OpenTptDevLinks.h       OpenTransportProviders.h
;     OpenTptInternet.h       OpenTransportProviders.h
;     OpenTptISDN.h           OpenTransportProviders.h
;     OpenTptLinks.h          OpenTransportProviders.h
;     OpenTptModule.h         OpenTransportKernel.h
;     OpenTptPCISupport.h     OpenTransportKernel.h
;     OpenTptSerial.h         OpenTransportProviders.h
;     OpenTptXTI.h            OpenTransportUNIX.r
;     OpenTransport.h         OpenTransport.h
;     OpenTransport.r         OpenTransport.r
;     OTConfig.r              OpenTransportProtocol.r
;     OTDebug.h               OpenTransport.h
;     OTSharedLibs.h          OpenTransportProviders.h
;     strlog.h                OpenTransportProtocol.h/OpenTransportKernel.h
;     stropts.h               OpenTransportProtocol.h/OpenTransportUNIX.h
;     strstat.h               OpenTransportProtocol.h
;     tihdr.h                 OpenTransportProtocol.h
; 

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; $ifc not undefined MWERKS and TARGET_CPU_68K
; $pragmac d0_pointers on
; $endc

;   ***** Setup Default Compiler Variables ***** 

; 
;    OTKERNEL is used to indicate whether the code is being built
;    for the kernel environment.  It defaults to 0.  If you include
;    "OpenTransportKernel.h" before including this file,
;    it will be 1 and you will only be able to see stuff available
;    to kernel code.
; 

#|                                              ; $IFC UNDEFINED OTKERNEL 
; $SETC OTKERNEL := 0 
 |#                                             ; $ENDC

; 
;    OTUNIXERRORS determines whether this file defines a bunch of
;    common UNIX error codes, like EPERM.  Typically, client code does
;    not want to do this because of the possibility of a clash with
;    other code modules, like the standard C libraries, that also
;    defines these routines.  However, client code can turn it on to
;    get these definitions.  This might be done by protocol stack
;    infrastructure, or some other low-level code.
;    "OpenTransportKernel.i" sets this flag before include
;    "OpenTransport.h" because kernel modules typically need these
;    error codes.  Note that kernel modules shouldn't be including
;    standard C libraries, so this is rarely a problem.
;    In general, the clash between OT and standard C definitions
;    of these error codes is rarely a problem becasue both OT
;    and the C libraries define them to have the same value.  But
;    I'm sure this check is useful to some people.
; 
#|                                              ; $IFC UNDEFINED OTUNIXERRORS 
; $SETC OTUNIXERRORS := 0 
 |#                                             ; $ENDC

; 
;    OTDEBUG is used to control the behaviour of the OT debugging
;    macros.  If you set it to non-zero, the macros will generate code
;    that drops you into the debugger.  If you set it to 0, or leave it
;    undefined, the macros are compiled out.
;    Setting up this compiler variable is a little tricky because previous
;    versions of the OT interfaces used a different variable, qDebug.
;    We replaced qDebug with OTDEBUG because qDebug does not fit into
;    the OT namespace.  But I didn't want to break a lot of currently
;    building code.  The following tricky compiler variable footwork
;    avoids this.
;    There are four outcomes when this code is compiled, depending on
;    whether qDebug and OTDEBUG are defined beforehand.  The following
;    table shows the outcome in each case.
;    qDebug     OTDEBUG    Outcome       Explanation  
;    ------     -------    -------       -----------
;    defined    defined    OTDEBUG wins  Mixed legacy and new code, we believe the new code.
;    defined    undefined  qDebug wins   Legacy code.
;    undefined  defined    OTDEBUG wins  New code.
;    undefined  undefined  no debugging  No debugging.
; 
; $IFC NOT UNDEFINED qDebug 
; $IFC UNDEFINED OTDEBUG 
; $SETC OTDebug := qDebug 
; $ENDC
; $ENDC

#|                                              ; $IFC UNDEFINED OTDEBUG 
; $SETC OTDEBUG := 0 
 |#                                             ; $ENDC

;   Carbon Applications have some restrictions on using OT 
; $IFC UNDEFINED OTCARBONAPPLICATION 
; $SETC OTCARBONAPPLICATION := 0 
; $ENDC

; 
;    ***** Normalise 68K Calling C Conventions *****
;    Define special types that handle the difference in parameter passing
;    between different Mac OS C compilers when generating 68K code.  OT
;    exports C calling conventions routines, and various C compilers use
;    various different conventions.  Differences in the placement of the result
;    are covered above, where we output pragma pointers_in_D0.  The other big
;    difference is how the compilers pass integer parameters less than 32 bits.
;    The MPW compiler always extends these to 32 bits; other compilers simply
;    push a value of the appropriate size.  We overcome this difference by
;    defining special OTFooParam types, which are only used when passing
;    sub 32 bit values to routines.  They are always defined to a 32 bit
;    size, which makes all the compilers do the same thing.
;    One weird consequence of this is that in more strict type checking
;    languages (eg Pascal) OTBooleanParam is not compatible with Boolean.
;    Sorry.
; 

#|                                              ; $IFC TARGET_CPU_68K 

(def-mactype :otuint8param (find-mactype ':unsigned-long))
(def-mactype :otuint16param (find-mactype ':unsigned-long))
(def-mactype :otsint16param (find-mactype ':signed-long))
(def-mactype :otsint8param (find-mactype ':signed-long))
(def-mactype :otbooleanparam (find-mactype ':signed-long))
 |#                                             ; $ELSEC

(def-mactype :otuint8param (find-mactype ':unsigned-byte))
(def-mactype :otuint16param (find-mactype ':unsigned-integer))
(def-mactype :otsint16param (find-mactype ':signed-integer))
(def-mactype :otsint8param (find-mactype ':signed-byte))
(def-mactype :otbooleanparam (find-mactype ':boolean))
; $ENDC                                         ; TARGET_CPU_68K

(def-mactype :otbytecount (find-mactype ':unsigned-long))
(def-mactype :otitemcount (find-mactype ':unsigned-long))
(def-mactype :otint32 (find-mactype ':signed-long))
(def-mactype :otuint32 (find-mactype ':unsigned-long))

;   ***** C++ Support ***** 

; 
; 	   Setup _MDECL to be _cdecl when compiling C++ code with
; 	   compilers that support it, or nothing otherwise.
; 	

;   ***** Shared Library Prefixes ***** 

(defconstant $kOTCFMClass :|otan|)

;   ***** Miscellaneous Type Definitions ***** 

;   A millisecond timeout value 

(def-mactype :ottimeout (find-mactype ':unsigned-long))
; 	 An ID number in connections/transactions     	
(def-mactype :otsequence (find-mactype ':signed-long))
; 	 An ID number for registered names            	
(def-mactype :otnameid (find-mactype ':signed-long))
; 
; 	   A protocol-specific reason code for failure.
; 	   Usually a Unix-style positive error code.
; 	
(def-mactype :otreason (find-mactype ':signed-long))
;   Number of outstanding connection requests at a time. 
(def-mactype :otqlen (find-mactype ':unsigned-long))
;   Will become internationalizeable shortly (yeah, right). 
(def-mactype :otclientname (find-mactype '(:pointer :unsigned-byte)))
;   The command code in STREAMS messages. 
(def-mactype :otcommand (find-mactype ':signed-long))
;   value describing a client 
(def-mactype :otclient (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :otclientptr (find-mactype '(:pointer :pointer)));  when a VAR xx:OTClient parameter can be nil, it is changed to xx: OTClientPtr 
;   ***** Debugging Macros ***** 

;   Debugging macros are only available in the C header file.  Sorry. 
; 
; 	   ***** Flags Used When Opening Providers *****
; 	   Important
; 	   OT does not currently support any of these flags.  You should
; 	   always pass 0 to a parameter of type OTOpenFlags.  If you need
; 	   to modify the mode of operation of a provider, use OTSetBlocking,
; 	   OTSetSynchronous, etc.
; 	
(def-mactype :otopenflags (find-mactype ':unsigned-long))

(defconstant $kO_ASYNC #x1)
(defconstant $kO_NDELAY #x4)
(defconstant $kO_NONBLOCK #x4)

; $IFC CALL_NOT_IN_CARBON 
; 
; 	   BSD defines O_ASYNC, O_NDELAY and O_NONBLOCK in fcntl.h 
; 	   Use kO_ASYNC, kO_NDELAY and kO_NONBLOCK in the unlikely event you need the OT value in Carbon
; 	
(defconstant $O_ASYNC #x1)
(defconstant $O_NDELAY #x4)
(defconstant $O_NONBLOCK #x4)

; $ENDC                                         ; CALL_NOT_IN_CARBON

;   ***** UNIX-Style Error Codes ***** 

(def-mactype :otunixerr (find-mactype ':unsigned-integer))
; 
; 	   These definitions are only compiled if you're building kernel code
; 	   or you explicit request them by setting OTUNIXERRORS.  See the
; 	   description of these compiler variables, given above.
; 	
; $IFC OTKERNEL OR OTUNIXERRORS 
; 
; 	   There may be some error code confusions with other compiler vendor header
; 	   files - However, these match both MPW and AIX definitions.
; 	
; 
; 	   First we undefine the #defined ones we know about so that we can put them
; 	   in an enum.  Of course, this is only going to work in C, but hopefully
; 	   other languages won't have these symbols overloaded.
; 	

(defconstant $EPERM 1)                          ;   Permission denied             
(defconstant $ENOENT 2)                         ;   No such file or directory        
(defconstant $ENORSRC 3)                        ;   No such resource                
(defconstant $EINTR 4)                          ;   Interrupted system service         
(defconstant $EIO 5)                            ;   I/O error                  
(defconstant $ENXIO 6)                          ;   No such device or address        
(defconstant $EBADF 9)                          ;   Bad file number                  
(defconstant $EAGAIN 11)                        ;   Try operation again later        
(defconstant $ENOMEM 12)                        ;   Not enough space                
(defconstant $EACCES 13)                        ;   Permission denied             
(defconstant $EFAULT 14)                        ;   Bad address                    
(defconstant $EBUSY 16)                         ;   Device or resource busy           
(defconstant $EEXIST 17)                        ;   File exists                    
(defconstant $ENODEV 19)                        ;   No such device                
(defconstant $EINVAL 22)                        ;   Invalid argument                
(defconstant $ENOTTY 25)                        ;   Not a character device           
(defconstant $EPIPE 32)                         ;   Broken pipe                    
(defconstant $ERANGE 34)                        ;   Math result not representable    
(defconstant $EDEADLK 35)                       ;   Call would block so was aborted        
(defconstant $EWOULDBLOCK 35)                   ;   Or a deadlock would occur        
(defconstant $EALREADY 37)
(defconstant $ENOTSOCK 38)                      ;   Socket operation on non-socket      
(defconstant $EDESTADDRREQ 39)                  ;   Destination address required       
(defconstant $EMSGSIZE 40)                      ;   Message too long                
(defconstant $EPROTOTYPE 41)                    ;   Protocol wrong type for socket      
(defconstant $ENOPROTOOPT 42)                   ;   Protocol not available           
(defconstant $EPROTONOSUPPORT 43)               ;   Protocol not supported           
(defconstant $ESOCKTNOSUPPORT 44)               ;   Socket type not supported        
(defconstant $EOPNOTSUPP 45)                    ;   Operation not supported on socket   
(defconstant $EADDRINUSE 48)                    ;   Address already in use           
(defconstant $EADDRNOTAVAIL 49)                 ;   Can't assign requested address      
(defconstant $ENETDOWN 50)                      ;   Network is down                  
(defconstant $ENETUNREACH 51)                   ;   Network is unreachable           
(defconstant $ENETRESET 52)                     ;   Network dropped connection on reset     
(defconstant $ECONNABORTED 53)                  ;   Software caused connection abort      
(defconstant $ECONNRESET 54)                    ;   Connection reset by peer           
(defconstant $ENOBUFS 55)                       ;   No buffer space available        
(defconstant $EISCONN 56)                       ;   Socket is already connected          
(defconstant $ENOTCONN 57)                      ;   Socket is not connected           
(defconstant $ESHUTDOWN 58)                     ;   Can't send after socket shutdown      
(defconstant $ETOOMANYREFS 59)                  ;   Too many references: can't splice   
(defconstant $ETIMEDOUT 60)                     ;   Connection timed out              
(defconstant $ECONNREFUSED 61)                  ;   Connection refused            
(defconstant $EHOSTDOWN 64)                     ;   Host is down                 
(defconstant $EHOSTUNREACH 65)                  ;   No route to host                
(defconstant $EPROTO 70)                        ;   STREAMS protocol error           
(defconstant $ETIME 71)
(defconstant $ENOSR 72)
(defconstant $EBADMSG 73)
(defconstant $ECANCEL 74)
(defconstant $ENOSTR 75)
(defconstant $ENODATA 76)
(defconstant $EINPROGRESS 77)
(defconstant $ESRCH 78)
(defconstant $ENOMSG 79)
(defconstant $ELASTERRNO 79)

; $ENDC

;   ***** Open Transport/XTI Error codes ***** 

(def-mactype :otxtierr (find-mactype ':unsigned-integer))

(defconstant $TSUCCESS 0)                       ;   No Error occurred              
(defconstant $TBADADDR 1)                       ;   A Bad address was specified           
(defconstant $TBADOPT 2)                        ;   A Bad option was specified           
(defconstant $TACCES 3)                         ;   Missing access permission           
(defconstant $TBADF 4)                          ;   Bad provider reference            
(defconstant $TNOADDR 5)                        ;   No address was specified              
(defconstant $TOUTSTATE 6)                      ;   Call issued in wrong state           
(defconstant $TBADSEQ 7)                        ;   Sequence specified does not exist    
(defconstant $TSYSERR 8)                        ;   A system error occurred               
(defconstant $TLOOK 9)                          ;   An event occurred - call Look()          
(defconstant $TBADDATA 10)                      ;   An illegal amount of data was specified     
(defconstant $TBUFOVFLW 11)                     ;   Passed buffer not big enough           
(defconstant $TFLOW 12)                         ;   Provider is flow-controlled           
(defconstant $TNODATA 13)                       ;   No data available for reading        
(defconstant $TNODIS 14)                        ;   No disconnect indication available      
(defconstant $TNOUDERR 15)                      ;   No Unit Data Error indication available     
(defconstant $TBADFLAG 16)                      ;   A Bad flag value was supplied        
(defconstant $TNOREL 17)                        ;   No orderly release indication available     
(defconstant $TNOTSUPPORT 18)                   ;   Command is not supported              
(defconstant $TSTATECHNG 19)                    ;   State is changing - try again later        
(defconstant $TNOSTRUCTYPE 20)                  ;   Bad structure type requested for OTAlloc    
(defconstant $TBADNAME 21)                      ;   A bad endpoint name was supplied       
(defconstant $TBADQLEN 22)                      ;   A Bind to an in-use address with qlen > 0 
(defconstant $TADDRBUSY 23)                     ;   Address requested is already in use        
(defconstant $TINDOUT 24)                       ;   Accept failed because of pending listen     
(defconstant $TPROVMISMATCH 25)                 ;   Tried to accept on incompatible endpoint    
(defconstant $TRESQLEN 26)
(defconstant $TRESADDR 27)
(defconstant $TQFULL 28)
(defconstant $TPROTO 29)                        ;   An unspecified provider error occurred  
(defconstant $TBADSYNC 30)                      ;   A synchronous call at interrupt time      
(defconstant $TCANCELED 31)                     ;   The command was cancelled           
(defconstant $TLASTXTIERROR 31)

; 
; 	   ***** Mac OS Error Codes *****
; 	   Most OT client routines return an OSStatus error code, a 32 bit type
; 	   defined in "MacTypes.h".  The OT-unique error code values are
; 	   defined below.  Many of these are generated by remapping XTI error
; 	   codes (Txxxx) and UNIX error codes (Exxxx) to a reserved range
; 	   in the OSStatus space.
; 	   Some routines return an OTResult type, indicating
; 	   that the routine might fail with a negative error, succeed with noErr,
; 	   or possible return a positive value indicating some status.
; 	

(def-mactype :otresult (find-mactype ':signed-long))
;   ***** OTAddress ***** 

; 
; 	   OTAddress type defines the standard header for all OT address formats.
; 	   It consists of one 16 bit integer, which defines the address format
; 	   used, followed by an arbitrary number of bytes which are protocol-specific.
; 	   Conceptually, all OT address formats are subtypes of this type,
; 	   extended with fields that are specific to the protocol.  For example,
; 	   OTInetAddress starts with the OTAddressType field and then continues
; 	   to include a host IP address and a port number.
; 	

(defconstant $kOTGenericName 0)                 ;   Protocol specific data is just a string, interpreted in a protocol-specific fashion. 

(def-mactype :otaddresstype (find-mactype ':unsigned-integer))
(def-mactype :otaddressptr (find-mactype '(:pointer :otaddress)))
(defrecord OTAddress 
   (fAddressType :unsigned-integer)             ;   The address format of this address... 
   (fAddress :signed-byte)                      ;   ... followed by protocol specific address information. 
   )

; 
; 	   ***** OTAlloc Constants *****
; 	   Note:
; 	   In general, Apple recommends that you avoid the OTAlloc call because
; 	   using it extensively causes your program to allocate and deallocate
; 	   many memory blocks, with each extra memory allocation costing time.
; 	
; 
; 	   OTStructType defines the structure type to be allocated using the OTAlloc
; 	   call.
; 	

(defconstant $T_BIND 1)
(defconstant $T_OPTMGMT 2)
(defconstant $T_CALL 3)
(defconstant $T_DIS 4)
(defconstant $T_UNITDATA 5)
(defconstant $T_UDERROR 6)
(defconstant $T_INFO 7)
(defconstant $T_REPLYDATA 8)
(defconstant $T_REQUESTDATA 9)
(defconstant $T_UNITREQUEST 10)
(defconstant $T_UNITREPLY 11)

(def-mactype :otstructtype (find-mactype ':unsigned-long))
; 
; 	   These values are used in the "fields" parameter of the OTAlloc call
; 	   to define which fields of the structure should be allocated.
; 	

(defconstant $T_ADDR #x1)
(defconstant $T_OPT #x2)
(defconstant $T_UDATA #x4)
(defconstant $T_ALL #xFFFF)

(def-mactype :otfieldstype (find-mactype ':unsigned-long))
;   ***** OTFlags ***** 
; 
; 	   This type is used to describe bitwise flags in OT data structures
; 	   and parameters.  Think of it as the OT analogue to the OptionBits
; 	   type in "MacTypes.h".
; 	

(def-mactype :otflags (find-mactype ':unsigned-long))
; 
; 	   These flags are used when sending and receiving data.  The
; 	   constants defined are masks.
; 	

(defconstant $T_MORE #x1)                       ;   More data to come in message      
(defconstant $T_EXPEDITED #x2)                  ;   Data is expedited, if possible  
(defconstant $T_ACKNOWLEDGED #x4)               ;   Acknowledge transaction          
(defconstant $T_PARTIALDATA #x8)                ;   Partial data - more coming      
(defconstant $T_NORECEIPT #x10)                 ;   No event on transaction done      
(defconstant $T_TIMEDOUT #x20)                  ;   Reply timed out               

;   These flags are used in the TOptMgmt structure to request services. 

(defconstant $T_NEGOTIATE #x4)
(defconstant $T_CHECK #x8)
(defconstant $T_DEFAULT #x10)
(defconstant $T_CURRENT #x80)

; 
; 	   These flags are used in the TOptMgmt and TOption structures to
; 	   return results.
; 	

(defconstant $T_SUCCESS #x20)
(defconstant $T_FAILURE #x40)
(defconstant $T_PARTSUCCESS #x100)
(defconstant $T_READONLY #x200)
(defconstant $T_NOTSUPPORT #x400)

; 
; 	   ***** OTBand *****
; 	   A band is a STREAMS concepts which defines the priority of data
; 	   on a stream.  Although this type is defined as a 32 bit number
; 	   for efficiency's sake, bands actually only range from 0 to 255. 
; 	   Typically band 0 is used for normal data and band 1 for expedited data.
; 	

(def-mactype :otband (find-mactype ':unsigned-long))
;   ***** Object References ***** 
; 
; 	   The C header file has a special mechanism to define these
; 	   types so that the object hierarchy is checked by the compiler,
; 	   at least when you engage the C++ compiler.  This special
; 	   case is not propagated to your language of choice.  All
; 	   OT object references are completely opaque.
; 	   See the C header file for more details.
; 	
(def-mactype :providerref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :providerrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:ProviderRef parameter can be nil, it is changed to xx: ProviderRefPtr 
(def-mactype :endpointref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :endpointrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:EndpointRef parameter can be nil, it is changed to xx: EndpointRefPtr 
(def-mactype :mapperref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :mapperrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:MapperRef parameter can be nil, it is changed to xx: MapperRefPtr 

(defconstant $kOTInvalidRef 0)
(defconstant $kOTInvalidProviderRef 0)
(defconstant $kOTInvalidEndpointRef 0)
(defconstant $kOTInvalidMapperRef 0)

;   ***** Event Codes ***** 
; 
; 	   OT event codes values for Open Transport.  These are the event codes that
; 	   are sent to notification routine (notifiers).
; 	

(def-mactype :oteventcode (find-mactype ':unsigned-long))
; 
; 	   Events are divided into numerous categories:
; 	   
; 	   1. (0x0000xxxx) The core XTI events have identifiers of the form
; 	      T_XXXX.  These signal that an XTI event has occured on a stream.
; 	   2. (0x1000xxxx) Private events are reserved for protocol specific
; 	      events.  Each protocol stack defines them as appropriate for
; 	      its own usage.
; 	   3. (0x2000xxxxx) Completion events have identifiers of the form
; 	      T_XXXXCOMPLETE.  These signal the completion of some asynchronous
; 	      API routine, and are only delivered if the endpoint is in asynchronous
; 	      mode.
; 	   4. (0x2100xxxx) Stream events are generally encountered when programming
; 	      the raw streams API and indicate some event on a raw stream, or
; 	      some other event of interest in the STREAMS kernel.
; 	   5. (0x2200xxxx) Signal events indicate that a signal has arrived on
; 	      a raw stream.  See "Signal Values" for details.
; 	   6. (0x2300xxxx) General provider events that might be generated by any
; 	      provider.
; 	   7. (0x2400xxxx) System events sent to all providers.
; 	   8. (0x2500xxxx) System events sent to registered clients.
; 	   9. (0x2600xxxx) System events used by configurators.
; 	  10. (0x2700xxxx) Events sent to registered OT clients.
; 	
; 
; 	   All event codes not described here are reserved by Apple.  If you receive
; 	   an event code you do not understand, ignore it!
; 	

(defconstant $T_LISTEN #x1)                     ;   An connection request is available      
(defconstant $T_CONNECT #x2)                    ;   Confirmation of a connect request   
(defconstant $T_DATA #x4)                       ;   Standard data is available         
(defconstant $T_EXDATA #x8)                     ;   Expedited data is available          
(defconstant $T_DISCONNECT #x10)                ;   A disconnect is available        
(defconstant $T_ERROR #x20)                     ;   obsolete/unused in library         
(defconstant $T_UDERR #x40)                     ;   A Unit Data Error has occurred      
(defconstant $T_ORDREL #x80)                    ;   An orderly release is available        
(defconstant $T_GODATA #x100)                   ;   Flow control lifted on standard data    
(defconstant $T_GOEXDATA #x200)                 ;   Flow control lifted on expedited data 
(defconstant $T_REQUEST #x400)                  ;   An Incoming request is available      
(defconstant $T_REPLY #x800)                    ;   An Incoming reply is available      
(defconstant $T_PASSCON #x1000)                 ;   State is now T_DATAXFER           
(defconstant $T_RESET #x2000)                   ;   Protocol has been reset           
(defconstant $kPRIVATEEVENT #x10000000)         ;   Base of the private event range. 
(defconstant $kCOMPLETEEVENT #x20000000)        ;   Base of the completion event range. 
(defconstant $T_BINDCOMPLETE #x20000001)        ;   Bind call is complete           
(defconstant $T_UNBINDCOMPLETE #x20000002)      ;   Unbind call is complete           
(defconstant $T_ACCEPTCOMPLETE #x20000003)      ;   Accept call is complete           
(defconstant $T_REPLYCOMPLETE #x20000004)       ;   SendReply call is complete         
(defconstant $T_DISCONNECTCOMPLETE #x20000005)  ;   Disconnect call is complete          
(defconstant $T_OPTMGMTCOMPLETE #x20000006)     ;   OptMgmt call is complete           
(defconstant $T_OPENCOMPLETE #x20000007)        ;   An Open call is complete           
(defconstant $T_GETPROTADDRCOMPLETE #x20000008) ;   GetProtAddress call is complete        
(defconstant $T_RESOLVEADDRCOMPLETE #x20000009) ;   A ResolveAddress call is complet      
(defconstant $T_GETINFOCOMPLETE #x2000000A)     ;   A GetInfo call is complete         
(defconstant $T_SYNCCOMPLETE #x2000000B)        ;   A Sync call is complete           
(defconstant $T_MEMORYRELEASED #x2000000C)      ;   No-copy memory was released          
(defconstant $T_REGNAMECOMPLETE #x2000000D)     ;   A RegisterName call is complete        
(defconstant $T_DELNAMECOMPLETE #x2000000E)     ;   A DeleteName call is complete    
(defconstant $T_LKUPNAMECOMPLETE #x2000000F)    ;   A LookupName call is complete    
(defconstant $T_LKUPNAMERESULT #x20000010)      ;   A LookupName is returning a name      
(defconstant $kOTSyncIdleEvent #x20000011)      ;   Synchronous call Idle event          
(defconstant $kSTREAMEVENT #x21000000)          ;   Base of the raw stream event range. 
(defconstant $kOTReservedEvent1 #x21000001)     ;   reserved for internal use by OT        
(defconstant $kGetmsgEvent #x21000002)          ;   A GetMessage call is complete    
(defconstant $kStreamReadEvent #x21000003)      ;   A Read call is complete           
(defconstant $kStreamWriteEvent #x21000004)     ;   A Write call is complete           
(defconstant $kStreamIoctlEvent #x21000005)     ;   An Ioctl call is complete        
(defconstant $kOTReservedEvent2 #x21000006)     ;   reserved for internal use by OT        
(defconstant $kStreamOpenEvent #x21000007)      ;   An OpenStream call is complete      
(defconstant $kPollEvent #x21000008)            ;   A Poll call is complete           
(defconstant $kOTReservedEvent3 #x21000009)     ;   reserved for internal use by OT        
(defconstant $kOTReservedEvent4 #x2100000A)     ;   reserved for internal use by OT        
(defconstant $kOTReservedEvent5 #x2100000B)     ;   reserved for internal use by OT        
(defconstant $kOTReservedEvent6 #x2100000C)     ;   reserved for internal use by OT        
(defconstant $kOTReservedEvent7 #x2100000D)     ;   reserved for internal use by OT        
(defconstant $kOTReservedEvent8 #x2100000E)     ;   reserved for internal use by OT        
(defconstant $kSIGNALEVENT #x22000000)          ;   A signal has arrived on a raw stream, see "Signal Values" below. 
(defconstant $kPROTOCOLEVENT #x23000000)        ;   Some event from the protocols    
(defconstant $kOTProviderIsDisconnected #x23000001);   Provider is temporarily off-line      
(defconstant $kOTProviderIsReconnected #x23000002);   Provider is now back on-line       
(defconstant $kOTProviderWillClose #x24000001)  ;   Provider will close immediately        
(defconstant $kOTProviderIsClosed #x24000002)   ;   Provider was closed               
(defconstant $kOTPortDisabled #x25000001)       ;   Port is now disabled, result is 0, cookie is port ref  
(defconstant $kOTPortEnabled #x25000002)        ;   Port is now enabled, result is 0, cookie is port ref  
(defconstant $kOTPortOffline #x25000003)        ;   Port is now offline, result is 0, cookie is port ref  
(defconstant $kOTPortOnline #x25000004)         ;   Port is now online, result is 0, cookie is port ref  
(defconstant $kOTClosePortRequest #x25000005)   ;   Request to close/yield, result is reason, cookie is OTPortCloseStruct*  
(defconstant $kOTYieldPortRequest #x25000005)   ;   Request to close/yield, result is reason, cookie is OTPortCloseStruct*  
(defconstant $kOTNewPortRegistered #x25000006)  ;   New port has been registered, cookie is port ref  
(defconstant $kOTPortNetworkChange #x25000007)  ;   Port may have moved to a new network, result is 0, cookie is port ref  
(defconstant $kOTConfigurationChanged #x26000001);   Protocol configuration changed      
(defconstant $kOTSystemSleep #x26000002)
(defconstant $kOTSystemShutdown #x26000003)
(defconstant $kOTSystemAwaken #x26000004)
(defconstant $kOTSystemIdle #x26000005)
(defconstant $kOTSystemSleepPrep #x26000006)
(defconstant $kOTSystemShutdownPrep #x26000007)
(defconstant $kOTSystemAwakenPrep #x26000008)
(defconstant $kOTStackIsLoading #x27000001)     ;   Sent before Open Transport attempts to load the TCP/IP protocol stack. 
(defconstant $kOTStackWasLoaded #x27000002)     ;   Sent after the TCP/IP stack has been successfully loaded. 
(defconstant $kOTStackIsUnloading #x27000003)   ;   Sent before Open Transport unloads the TCP/IP stack. 

; 
; 	   ***** Signal Values *****
; 	   Signals that are generated by a raw stream.  When writing a notifier
; 	   for a raw stream, add these values to kSIGNALEVENT to determine what
; 	   event you are receiving.
; 	

(defconstant $kSIGHUP 1)
(defconstant $kSIGURG 16)
(defconstant $kSIGPOLL 30)

(defconstant $SIGHUP 1)
(defconstant $SIGURG 16)
(defconstant $SIGPOLL 30)

; 
; 	   ***** Notifier Type Definition *****
; 	   Open Transport notifiers must conform to the OTNotifyProcPtr prototype.
; 	   Even though a OTNotifyUPP is a OTNotifyProcPtr on pre-Carbon system,
; 	   use NewOTNotifyUPP() and friends to make your source code portable to OS X and Carbon.
; 	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	OTNotifyProcPtr = PROCEDURE(contextPtr: UNIV Ptr; code: OTEventCode; result: OTResult; cookie: UNIV Ptr);

|#
 |#                                             ; $ELSEC
(def-mactype :otnotifyprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :otnotifyupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :otnotifyupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppOTNotifyProcInfo #x3FC0)
; 
; 	 *  NewOTNotifyUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_NewOTNotifyUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeOTNotifyUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeOTNotifyUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeOTNotifyUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_InvokeOTNotifyUPP" 
      ((contextPtr :pointer) (code :unsigned-long) (result :signed-long) (cookie :pointer) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

;   ***** Option Management Definitions ***** 
;   The XTI Level number of a protocol. 

(defconstant $XTI_GENERIC #xFFFF)               ;   level for XTI options  

(def-mactype :otxtilevel (find-mactype ':unsigned-long))
;   The XTI name of a protocol option. 
(def-mactype :otxtiname (find-mactype ':unsigned-long))
;   XTI names for options used with XTI_GENERIC above 

(defconstant $XTI_DEBUG #x1)
(defconstant $XTI_LINGER #x80)
(defconstant $XTI_RCVBUF #x1002)
(defconstant $XTI_RCVLOWAT #x1004)
(defconstant $XTI_SNDBUF #x1001)
(defconstant $XTI_SNDLOWAT #x1003)
(defconstant $XTI_PROTOTYPE #x1005)
(defconstant $OPT_CHECKSUM #x600)               ;   Set checksumming = UInt32 - 0 or 1) 
(defconstant $OPT_RETRYCNT #x601)               ;   Set a retry counter = UInt32 (0 = infinite) 
(defconstant $OPT_INTERVAL #x602)               ;   Set a retry interval = UInt32 milliseconds 
(defconstant $OPT_ENABLEEOM #x603)              ;   Enable the EOM indication = UInt8 (0 or 1) 
(defconstant $OPT_SELFSEND #x604)               ;   Enable Self-sending on broadcasts = UInt32 (0 or 1) 
(defconstant $OPT_SERVERSTATUS #x605)           ;   Set Server Status (format is proto dependent) 
(defconstant $OPT_ALERTENABLE #x606)            ;   Enable/Disable protocol alerts 
(defconstant $OPT_KEEPALIVE #x8)                ;   See t_keepalive structure 

;   ***** Ioctl Definitions ***** 

; 
; 	   All OT ioctl numbers are formed using the MIOC_CMD macro,
; 	   which divides the ioctl space by protocol space (the
; 	   first parameter) and ioctl number within that protocol
; 	   space (the second parameter).  This macro is only available
; 	   to C users but it's relatively easy to synthesise its
; 	   results in other languages.
; 	

;   The following is a registry of the ioctls protocol spaces. 

(defconstant $MIOC_STREAMIO 65)                 ;   Basic Stream ioctl() cmds - I_PUSH, I_LOOK, etc.  
(defconstant $MIOC_TMOD 97)                     ;   ioctl's for tmod test module     
(defconstant $MIOC_STRLOG 98)                   ;   ioctl's for Mentat's log device       
(defconstant $MIOC_ND 99)                       ;   ioctl's for Mentat's nd device         
(defconstant $MIOC_ECHO 100)                    ;   ioctl's for Mentat's echo device    
(defconstant $MIOC_TLI 101)                     ;   ioctl's for Mentat's timod module   
(defconstant $MIOC_RESERVEDf 102)               ;   reserved, used by SVR4 FIOxxx    
(defconstant $MIOC_SAD 103)                     ;   ioctl's for Mentat's sad module       
(defconstant $MIOC_ARP 104)                     ;   ioctl's for Mentat's arp module       
(defconstant $MIOC_HAVOC 72)                    ;   Havoc module ioctls.            
(defconstant $MIOC_RESERVEDi 105)               ;   reserved, used by SVR4 SIOCxxx      
(defconstant $MIOC_SIOC 106)                    ;   sockio.h socket ioctl's            
(defconstant $MIOC_TCP 107)                     ;   tcp.h ioctl's                 
(defconstant $MIOC_DLPI 108)                    ;   dlpi.h additions              
(defconstant $MIOC_SOCKETS 109)                 ;   Mentat sockmod ioctl's            
(defconstant $MIOC_IPX 111)                     ;   ioctls for IPX                
(defconstant $MIOC_OT 79)                       ;   ioctls for Open Transport        
(defconstant $MIOC_ATALK 84)                    ;   ioctl's for AppleTalk           
(defconstant $MIOC_SRL 85)                      ;   ioctl's for Serial            
(defconstant $MIOC_RESERVEDp 112)               ;   reserved, used by SVR4           
(defconstant $MIOC_RESERVEDr 114)               ;   reserved, used by SVR4           
(defconstant $MIOC_RESERVEDs 115)               ;   reserved, used by SVR4           
(defconstant $MIOC_CFIG 122)                    ;   ioctl's for private configuration  

;   OT specific ioctls. 

(defconstant $I_OTGetMiscellaneousEvents #x4F01);   sign up for Misc Events               
(defconstant $I_OTSetFramingType #x4F02)        ;   Set framing option for link           
(defconstant $kOTGetFramingValue #xFFFFFFFF)    ;   Use this value to read framing         
(defconstant $I_OTSetRawMode #x4F03)            ;   Set raw mode for link             
(defconstant $kOTSetRecvMode #x1)
(defconstant $kOTSendErrorPacket #x2)
(defconstant $I_OTConnect #x4F04)               ;   Generic connect request for links    
(defconstant $I_OTDisconnect #x4F05)            ;   Generic disconnect request for links      
(defconstant $I_OTScript #x4F06)                ;   Send a script to a module           

;   Structure for the I_OTScript Ioctl. 

(def-mactype :otscriptinfoptr (find-mactype '(:pointer :otscriptinfo)))
(defrecord OTScriptInfo 
   (fScriptType :unsigned-long)
   (fTheScript :pointer)
   (fScriptLength :unsigned-long)
   )

; 
; 	   ***** XTI States *****
; 	   These are the potential values returned by OTGetEndpointState and OTSync
; 	   which represent the XTI state of an endpoint.
; 	
(def-mactype :otxtistates (find-mactype ':unsigned-long))

(defconstant $T_UNINIT 0)                       ;   addition to standard xti.h  
(defconstant $T_UNBND 1)                        ;   unbound                  
(defconstant $T_IDLE 2)                         ;   idle                 
(defconstant $T_OUTCON 3)                       ;   outgoing connection pending     
(defconstant $T_INCON 4)                        ;   incoming connection pending     
(defconstant $T_DATAXFER 5)                     ;   data transfer           
(defconstant $T_OUTREL 6)                       ;   outgoing orderly release      
(defconstant $T_INREL 7)                        ;   incoming orderly release      

; 
; 	   ***** General XTI Definitions *****
; 	   These definitions are typically used during option management.
; 	

(defconstant $T_YES 1)
(defconstant $T_NO 0)
(defconstant $T_UNUSED -1)
(defconstant $kT_NULL 0)
(defconstant $T_ABSREQ #x8000)

(defconstant $kT_UNSPEC #xFFFFFFFD)
(defconstant $T_ALLOPT 0)

(defconstant $T_NULL 0)
(defconstant $T_UNSPEC #xFFFFFFFD)

; 
; 	   ***** OTConfiguration *****
; 	   This is a "black box" structure used to define the configuration of a
; 	   provider or endpoint.  This file defines a very limited set of operations
; 	   on a configuration.  "OpenTransportClient.h" extends this with extra
; 	   operations used by protocol stacks but not typically needed by clients.
; 	

(def-mactype :otconfigurationref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :otconfigurationrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:OTConfigurationRef parameter can be nil, it is changed to xx: OTConfigurationRefPtr 

(defconstant $kOTNoMemoryConfigurationPtr 0)
(defconstant $kOTInvalidConfigurationPtr -1)

;   ***** Option Management Structures ***** 

;   This structure describes the contents of a single option in a buffer. 

(def-mactype :toptionheaderptr (find-mactype '(:pointer :toptionheader)))
(defrecord TOptionHeader 
   (len :unsigned-long)                         ;   total length of option           
;   = sizeof(TOptionHeader) + length      
;       of option value in bytes        
   (level :unsigned-long)                       ;   protocol affected             
   (name :unsigned-long)                        ;   option name                    
   (status :unsigned-long)                      ;   status value                 
   )

; 
; 	   This structure describes the contents of a single option in a buffer.
; 	   It differs from TOptionHeader in that it includes the value field,
; 	   which acts as an unbounded array representing the value of the option.
; 	
(def-mactype :toptionptr (find-mactype '(:pointer :toption)))

;; This form has been patched from OSX Drive:Users:bburns:Desktop:interface-translator:Patches:opentransport.patch
#|(defrecord TOption 
   (len :unsigned-long)                         ;   total length of option           
;   = sizeof(TOption) + length  
;       of option value in bytes        
   (level :unsigned-long)                       ;   protocol affected             
   (name :unsigned-long)                        ;   option name                    
   (status :unsigned-long)                      ;   status value                 
   (value (:array :unsigned-long 1))            ;   data goes here                
   )|#;; these are void* in c headers which somehow became ;  upaque 32 bit in p headers
;; I vote for pointer
#| patched in settings.lisp
(def-mactype :providerref (find-mactype ':pointer));  an opaque mumble that pascal or we got wrong
(def-mactype :endpointref (find-mactype ':pointer));  an opaque ditto 
(def-mactype :mapperref (find-mactype ':pointer));  an opaque ditto
|#
;; fixed parens from Shannon Spires
;; variant optname = name
(defrecord TOption 
   (len :unsigned-long)                ;  total length of option				
;  = sizeof(TOption) + length	
; 	 of option value in bytes			
   (level :unsigned-long)              ;  protocol affected					
   (:variant ((optName :unsigned-long))            ;  option name
              ((name :unsigned-long)))
   (status :unsigned-long)             ;  status value							
   (value (:ARRAY :unsigned-long 1))   ;  data goes here						
   )

;   Some useful constants when manipulating option buffers. 

(defconstant $kOTOptionHeaderSize 16)
(defconstant $kOTBooleanOptionDataSize 4)
(defconstant $kOTBooleanOptionSize 20)
(defconstant $kOTOneByteOptionSize 17)
(defconstant $kOTTwoByteOptionSize 18)
(defconstant $kOTFourByteOptionSize 20)

;   t_kpalive is used with OPT_KEEPALIVE option. 

(def-mactype :t_kpaliveptr (find-mactype '(:pointer :t_kpalive)))
(defrecord t_kpalive 
   (kp_onoff :signed-long)                      ;   option on/off    
   (kp_timeout :signed-long)                    ;   timeout in minutes  
   )

;   t_linger is used with XTI_LINGER option. 
(def-mactype :t_lingerptr (find-mactype '(:pointer :t_linger)))
(defrecord t_linger 
   (l_onoff :signed-long)                       ;   option on/off  
   (l_linger :signed-long)                      ;   linger time  
   )

; 
; 	   ***** TEndpointInfo *****
; 	   This structure is returned from the GetEndpointInfo call and contains
; 	   information about an endpoint.  But first, some special flags and types.
; 	
;   Values returned in servtype field of TEndpointInfo. 

(def-mactype :otservicetype (find-mactype ':unsigned-long))

(defconstant $T_COTS 1)                         ;   Connection-mode service                     
(defconstant $T_COTS_ORD 2)                     ;   Connection service with orderly release           
(defconstant $T_CLTS 3)                         ;   Connectionless-mode service                    
(defconstant $T_TRANS 5)                        ;   Connection-mode transaction service               
(defconstant $T_TRANS_ORD 6)                    ;   Connection transaction service with orderly release     
(defconstant $T_TRANS_CLTS 7)                   ;   Connectionless transaction service            

;   Masks for the flags field of TEndpointInfo. 

(defconstant $T_SENDZERO #x1)                   ;   supports 0-length TSDU's           
(defconstant $T_XPG4_1 #x2)                     ;   supports the GetProtAddress call      
(defconstant $T_CAN_SUPPORT_MDATA #x10000000)   ;   support M_DATAs on packet protocols     
(defconstant $T_CAN_RESOLVE_ADDR #x40000000)    ;   Supports ResolveAddress call       
(defconstant $T_CAN_SUPPLY_MIB #x20000000)      ;   Supports SNMP MIB data           

; 
; 	   Special-case values for in the tsdu, etsdu, connect, and discon
; 	   fields of TEndpointInfo.
; 	

(defconstant $T_INFINITE -1)                    ;   supports infinit amounts of data      
(defconstant $T_INVALID -2)                     ;   Does not support data transmission  

(def-mactype :otdatasize (find-mactype ':signed-long))
;   Now the TEndpointInfo structure proper. 
(def-mactype :tendpointinfoptr (find-mactype '(:pointer :tendpointinfo)))
(defrecord TEndpointInfo 
   (addr :signed-long)                          ;   Maximum size of an address         
   (options :signed-long)                       ;   Maximum size of options           
   (tsdu :signed-long)                          ;   Standard data transmit unit size      
   (etsdu :signed-long)                         ;   Expedited data transmit unit size   
   (connect :signed-long)                       ;   Maximum data size on connect       
   (discon :signed-long)                        ;   Maximum data size on disconnect        
   (servtype :unsigned-long)                    ;   service type                 
   (flags :unsigned-long)                       ;   Flags (see above for values)       
   )

; 
; 	   "OpenTransport.h" no longer defines "struct t_info".  We recommend
; 	   that you use TEndpointInfo instead.  If this is impossible, use
; 	   the definition of "struct t_info" in "OpenTransportXTI.h".
; 	
;   ***** OTPortRecord ***** 

;   Unique identifier for a port. 

(def-mactype :otportref (find-mactype ':unsigned-long))
(def-mactype :otportrefptr (find-mactype '(:pointer :unsigned-long)))

(defconstant $kOTInvalidPortRef 0)

;   Valid values for the bus type element of an OTPortRef. 

(def-mactype :otbustype (find-mactype ':unsigned-byte))

(defconstant $kOTUnknownBusPort 0)
(defconstant $kOTMotherboardBus 1)
(defconstant $kOTNuBus 2)
(defconstant $kOTPCIBus 3)
(defconstant $kOTGeoPort 4)
(defconstant $kOTPCCardBus 5)
(defconstant $kOTFireWireBus 6)
(defconstant $kOTLastBusIndex 15)

; 
; 	   A couple of special values for the device type element of an
; 	   OTPortRef.  See "OpenTransportDevices.h" for the standard values.
; 	

(def-mactype :otdevicetype (find-mactype ':unsigned-integer))

(defconstant $kOTNoDeviceType 0)
(defconstant $kOTADEVDevice 1)                  ;   An Atalk ADEV    
(defconstant $kOTMDEVDevice 2)                  ;   A TCP/IP MDEV    
(defconstant $kOTLocalTalkDevice 3)             ;   LocalTalk        
(defconstant $kOTIRTalkDevice 4)                ;   IRTalk           
(defconstant $kOTTokenRingDevice 5)             ;   Token Ring         
(defconstant $kOTISDNDevice 6)                  ;   ISDN              
(defconstant $kOTATMDevice 7)                   ;   ATM               
(defconstant $kOTSMDSDevice 8)                  ;   SMDS              
(defconstant $kOTSerialDevice 9)                ;   Serial            
(defconstant $kOTEthernetDevice 10)             ;   Ethernet           
(defconstant $kOTSLIPDevice 11)                 ;   SLIP Pseudo-device  
(defconstant $kOTPPPDevice 12)                  ;   PPP Pseudo-device   
(defconstant $kOTModemDevice 13)                ;   Modem Pseudo-Device     
(defconstant $kOTFastEthernetDevice 14)         ;   100 MB Ethernet        
(defconstant $kOTFDDIDevice 15)                 ;   FDDI              
(defconstant $kOTIrDADevice 16)                 ;   IrDA Infrared    
(defconstant $kOTATMSNAPDevice 17)              ;   ATM SNAP emulation  
(defconstant $kOTFibreChannelDevice 18)         ;   Fibre Channel    
(defconstant $kOTFireWireDevice 19)             ;   FireWire link Device    
(defconstant $kOTPseudoDevice 1023)             ;   used where no other defined device type will work 
(defconstant $kOTLastDeviceIndex 1022)

;   Special case values for the slot number element of an OTPortRef. 

(defconstant $kOTLastSlotNumber 255)
(defconstant $kOTLastOtherNumber 255)

(def-mactype :otslotnumber (find-mactype ':unsigned-integer))
;   Accessor functions for the various elements of the OTPortRef. 
; 
; 	 *  OTCreatePortRef()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;  *  OTGetDeviceTypeFromPortRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTCreatePortRef" 
      ((busType :signed-byte) (devType :unsigned-integer) (slot :unsigned-integer) (other :unsigned-integer)) 
  :unsigned-long
   () )                                         ; 
;  *  OTGetBusTypeFromPortRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTGetDeviceTypeFromPortRef" 
      ((ref :unsigned-long)) 
  :unsigned-integer
   () )                                         ; 
;  *  OTGetSlotFromPortRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTGetBusTypeFromPortRef" 
      ((ref :unsigned-long)) 
  :unsigned-integer
   () )                                         ; 
;  *  OTSetDeviceTypeInPortRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTGetSlotFromPortRef" 
      ((ref :unsigned-long) (other (:pointer :unsigned-integer))) 
  :unsigned-integer
   () )                                         ; 
;  *  OTSetBusTypeInPortRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTSetDeviceTypeInPortRef" 
      ((ref :unsigned-long) (devType :unsigned-integer)) 
  :unsigned-long
   () )                                         ;   Name length definitions for various fields in OTPortRecord. 
(deftrap-inline "_OTSetBusTypeInPortRef" 
      ((ref :unsigned-long) (busType :signed-byte)) 
  :unsigned-long
   () )
(defconstant $kMaxModuleNameLength 31)          ;   max length of a STREAMS module name 
(defconstant $kMaxModuleNameSize 32)
(defconstant $kMaxProviderNameLength 35)        ;   providers allow 4 characters for minor number 
(defconstant $kMaxProviderNameSize 36)
(defconstant $kMaxSlotIDLength 7)               ;   PCI slot names tend to be short 
(defconstant $kMaxSlotIDSize 8)
(defconstant $kMaxResourceInfoLength 31)        ;   max length of a configuration helper name 
(defconstant $kMaxResourceInfoSize 32)
(defconstant $kMaxPortNameLength 35)            ;   max size allowed to define a port 
(defconstant $kMaxPortNameSize 36)

; 
; 	   Masks for the fPortFlags field of OTPortRecord
; 	   If no bits are set, the port is currently inactive.
; 	

(defconstant $kOTPortIsActive #x1)
(defconstant $kOTPortIsDisabled #x2)
(defconstant $kOTPortIsUnavailable #x4)
(defconstant $kOTPortIsOffline #x8)

;   Masks for the fInfoFlags field of the OTPortRecord. 

(defconstant $kOTPortIsDLPI #x1)
(defconstant $kOTPortIsTPI #x2)
(defconstant $kOTPortCanYield #x4)              ;   will not be set until the port is used for the first time 
(defconstant $kOTPortCanArbitrate #x8)          ;   will not be set until the port is used for the first time 
(defconstant $kOTPortIsTransitory #x10)
(defconstant $kOTPortAutoConnects #x20)
(defconstant $kOTPortIsSystemRegistered #x4000)
(defconstant $kOTPortIsPrivate #x8000)
(defconstant $kOTPortIsAlias #x80000000)

; 
; 	   One OTPortRecord is created for each instance of a port.
; 	   For Instance 'enet' identifies an ethernet port.
; 	   A OTPortRecord for each ethernet card it finds, with an
; 	   OTPortRef that will uniquely allow the driver to determine which
; 	   port it is supposed to open on.
; 	

(def-mactype :otportrecordptr (find-mactype '(:pointer :otportrecord)))
(defrecord OTPortRecord 
   (fRef :unsigned-long)
   (fPortFlags :unsigned-long)
   (fInfoFlags :unsigned-long)
   (fCapabilities :unsigned-long)
   (fNumChildPorts :unsigned-long)
   (fChildPorts (:pointer :unsigned-long))
   (fPortName (:array :character 36 :packed))
   (fModuleName (:array :character 32 :packed))
   (fSlotID (:array :character 8 :packed))
   (fResourceInfo (:array :character 32 :packed))
   (fReserved (:array :character 164 :packed))
   )

; 
; 	   Routines for finding, registering and unregistering ports.
; 	   IMPORTANT:
; 	   These routines have two versions, one for the client and one
; 	   for the kernel.  Make sure you use and link with the right ones.
; 	
                                              ; $IFC NOT OTKERNEL 
; 
; 	 *  OTGetIndexedPort()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in OTClientUtilLib 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;   Index through the ports in the system       ; 
;  *  OTFindPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientUtilLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTGetIndexedPort" 
      ((portRecord (:pointer :otportrecord)) (index :unsigned-long)) 
  :boolean
   () )                                         ;   Find an OTPortRecord for a port using it's name ; 
;  *  OTFindPortByRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientUtilLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTFindPort" 
      ((portRecord (:pointer :otportrecord)) (portName :pointer)) 
  :boolean
   () )                                         ;   Find an OTPortRecord for a port using it's OTPortRef ; $IFC CALL_NOT_IN_CARBON ; 
;  *  OTRegisterPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientUtilLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTFindPortByRef" 
      ((portRecord (:pointer :otportrecord)) (ref :unsigned-long)) 
  :boolean
   () )
(deftrap-inline "_OTRegisterPort" 
      ((portRecord (:pointer :otportrecord)) (ref :pointer)) 
  :osstatus
   () )

; 
;    Register a port. The name the port was registered under is returned in
;    the fPortName field.
; 
; 
;  *  OTUnregisterPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientUtilLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_OTUnregisterPort" 
      ((portName :pointer) (ref (:pointer :pointer))) 
  :osstatus
   () )

; 
;    Unregister the port with the given name (If you re-register the
;    port, it may get a different name - use OTChangePortState if
;    that is not desireable).  Since a single OTPortRef can be registered
;    with several names, the API needs to use the portName rather than
;    the OTPortRef to disambiguate.
; 
; 
;  *  OTChangePortState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientUtilLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_OTChangePortState" 
      ((portRef :unsigned-long) (theChange :unsigned-long) (why :signed-long)) 
  :osstatus
   () )

;   Change the state of the port. 
; $ENDC                                         ; CALL_NOT_IN_CARBON
                                              ; $ENDC

;   ***** Data Buffers ***** 
; 
;    TNetbuf is the basic structure used to pass data back and forth
;    between the Open Transport protocols and their clients
; 

(def-mactype :tnetbufptr (find-mactype '(:pointer :tnetbuf)))
(defrecord TNetbuf 
   (maxlen :unsigned-long)
   (len :unsigned-long)
   (buf :pointer)
   )

; 
; 	   Some rarely used low-level routines in this file take a strbuf
; 	   as a parameter.  This is the raw streams equivalent of a TNetbuf.
; 	   The key difference is that the maxlen and len fields are signed,
; 	   which allows you to specify extra operations by providing a
; 	   negative value.
; 	

(def-mactype :strbufptr (find-mactype '(:pointer :strbuf)))
(defrecord strbuf 
   (maxlen :signed-long)                        ;   max buffer length  
   (len :signed-long)                           ;   length of data  
   (buf :pointer)                               ;   pointer to buffer  
   )

; 
; 	   OTData is used in a TNetbuf or netbuf to send
; 	   non-contiguous data.  Set the 'len' field of the netbuf to the
; 	   constant kNetbufDataIsOTData to signal that the 'buf' field of the
; 	   netbuf actually points to one of these structures instead of a
; 	   memory buffer.
; 	
(def-mactype :otdataptr (find-mactype '(:pointer :otdata)))
(defrecord OTData 
   (fNext :pointer)
   (fData :pointer)
   (fLen :unsigned-long)
   )

(defconstant $kNetbufDataIsOTData #xFFFFFFFE)

; 
; 	   OTBuffer is used for no-copy receives.  When receiving, you can
; 	   set the receive length to kOTNetbufDataIsOTBufferStar and then
; 	   pass the address of an OTBuffer* as the receive buffer.  OT will
; 	   fill it out to point to a chain of OTBuffers.
; 	   When you are done with it, you must call the OTReleaseBuffer function.
; 	   For best performance, you need to call OTReleaseBuffer quickly.
; 	   Only data netbufs may use this - no netbufs for addresses or options, or the like.
; 	   Any OTBuffer returned to you by OT is read only!
; 	   The astute will notice that this has a high correlation with the
; 	   STREAMS msgb data type.  The fields are commented with their
; 	   corresponding msgb field name.
; 	

(def-mactype :otbufferptr (find-mactype '(:pointer :otbuffer)))
(defrecord OTBuffer 
   (fLink :pointer)                             ;   b_next 
   (fLink2 :pointer)                            ;   b_prev 
   (fNext (:pointer :otbuffer))                 ;   b_cont 
   (fData :pointer)                             ;   b_rptr 
   (fLen :unsigned-long)                        ;   b_wptr 
   (fSave :pointer)                             ;   b_datap 
   (fBand :signed-byte)                         ;   b_band 
   (fType :signed-byte)                         ;   b_pad1 
   (fPad1 :signed-byte)
   (fFlags :signed-byte)                        ;   b_flag 
   )

(defconstant $kOTNetbufDataIsOTBufferStar #xFFFFFFFD)

; 
; 	   OTBufferInfo is used with OTReadBuffer to keep track of where you
; 	   are in the buffer, since the OTBuffer is "read-only".
; 	
; 
; 	   To initialise this structure, copy the code from the OTInitBuffer macro in
; 	   the C header file.
; 	

(def-mactype :otbufferinfoptr (find-mactype '(:pointer :otbufferinfo)))
(defrecord OTBufferInfo 
   (fBuffer (:pointer :otbuffer))
   (fOffset :unsigned-long)
   (fPad :signed-byte)
   )

; 
; 	   If the endpoint supports "raw mode" (the T_CAN_SUPPORT_MDATA bit will
; 	   be set in the TEndpointInfo::flags field), then you specify the
; 	   raw mode packet by putting the kOTNetbufIsRawMode value in
; 	   the udata.addr.len field when calling OTSndUData and also set the
; 	   udata.opt.len, udata.opt.buf, and udata.addr.buf fields to 0.
; 	

(defconstant $kOTNetbufIsRawMode #xFFFFFFFF)

; 
; 	   ***** Standard XTI Parameter Types *****
; 	   These structures are all used as parameters to the standard
; 	   XTI routines.
; 	

; 
; 	   TBind holds binding information for calls to
; 	   OTGetProtAddress, OTResolveAddress and OTBind.
; 	

(def-mactype :tbindptr (find-mactype '(:pointer :tbind)))
(defrecord TBind 
   (addr :tnetbuf)
   (qlen :unsigned-long)
   )

; 
; 	   TDiscon is passed to RcvDisconnect to find out additional information
; 	   about the disconnect.
; 	
(def-mactype :tdisconptr (find-mactype '(:pointer :tdiscon)))
(defrecord TDiscon 
   (udata :tnetbuf)
   (reason :signed-long)
   (sequence :signed-long)
   )

; 
; 	   TCall holds information about a connection and is a parameter to
; 	   OTConnect, OTRcvConnect, OTListen, OTAccept, and OTSndDisconnect.
; 	
(def-mactype :tcallptr (find-mactype '(:pointer :tcall)))
(defrecord TCall 
   (addr :tnetbuf)
   (opt :tnetbuf)
   (udata :tnetbuf)
   (sequence :signed-long)
   )

;   TUnitData describes a datagram in calls to OTSndUData and OTRcvUData. 
(def-mactype :tunitdataptr (find-mactype '(:pointer :tunitdata)))
(defrecord TUnitData 
   (addr :tnetbuf)
   (opt :tnetbuf)
   (udata :tnetbuf)
   )

; 
; 	   TUDErr is used to get information about a datagram error using
; 	   OTRcvUDErr.
; 	
(def-mactype :tuderrptr (find-mactype '(:pointer :tuderr)))
(defrecord TUDErr 
   (addr :tnetbuf)
   (opt :tnetbuf)
   (error :signed-long)
   )

;   TOptMgmt is passed to the OTOptionManagement call to read or set protocol 
(def-mactype :toptmgmtptr (find-mactype '(:pointer :toptmgmt)))
(defrecord TOptMgmt 
   (opt :tnetbuf)
   (flags :unsigned-long)
   )

; 
; 	   ***** Transactional XTI Parameter Types *****
; 	   These structures are all used as parameters to the OT's
; 	   XTI-like routines for transaction protocols.
; 	
; 
; 	   TRequest is passed to OTSndRequest and OTRcvRequest that contains the information
; 	   about the request.
; 	

(def-mactype :trequestptr (find-mactype '(:pointer :trequest)))
(defrecord TRequest 
   (data :tnetbuf)
   (opt :tnetbuf)
   (sequence :signed-long)
   )

;   TReply is passed to OTSndReply to send a reply to an incoming request. 
(def-mactype :treplyptr (find-mactype '(:pointer :treply)))
(defrecord TReply 
   (data :tnetbuf)
   (opt :tnetbuf)
   (sequence :signed-long)
   )

; 
; 	   TUnitRequest is passed to OTSndURequest and OTRcvURequest that contains
; 	   the information about the request.
; 	
(def-mactype :tunitrequestptr (find-mactype '(:pointer :tunitrequest)))
(defrecord TUnitRequest 
   (addr :tnetbuf)
   (opt :tnetbuf)
   (udata :tnetbuf)
   (sequence :signed-long)
   )

;   TUnitReply is passed to OTSndUReply to send a reply to an incoming request. 
(def-mactype :tunitreplyptr (find-mactype '(:pointer :tunitreply)))
(defrecord TUnitReply 
   (opt :tnetbuf)
   (udata :tnetbuf)
   (sequence :signed-long)
   )

; 
; 	   ***** Mapper Parameter Types *****
; 	   These structures are all used as parameters to the OT's
; 	   mapper routines.
; 	
;   TRegisterRequest holds the name to register in a call to OTRegisterName. 

(def-mactype :tregisterrequestptr (find-mactype '(:pointer :tregisterrequest)))
(defrecord TRegisterRequest 
   (name :tnetbuf)
   (addr :tnetbuf)
   (flags :unsigned-long)
   )

; 
; 	   TRegisterReply returns information about the registered name in a call
; 	   to OTRegisterName.
; 	
(def-mactype :tregisterreplyptr (find-mactype '(:pointer :tregisterreply)))
(defrecord TRegisterReply 
   (addr :tnetbuf)
   (nameid :signed-long)
   )

;   TLookupRequest holds the name to look up in a call to OTLookupName. 
(def-mactype :tlookuprequestptr (find-mactype '(:pointer :tlookuprequest)))
(defrecord TLookupRequest 
   (name :tnetbuf)
   (addr :tnetbuf)
   (maxcnt :unsigned-long)
   (timeout :unsigned-long)
   (flags :unsigned-long)
   )

; 
; 	   TLookupReply returns information about the found names after a call
; 	   to OTLookupName.
; 	
(def-mactype :tlookupreplyptr (find-mactype '(:pointer :tlookupreply)))
(defrecord TLookupReply 
   (names :tnetbuf)
   (rspcount :unsigned-long)
   )

; 
; 	   TLookupBuffer describes the contents of the names buffer pointed
; 	   to by the TLookupReply.
; 	
(def-mactype :tlookupbufferptr (find-mactype '(:pointer :tlookupbuffer)))
(defrecord TLookupBuffer 
   (fAddressLength :unsigned-integer)
   (fNameLength :unsigned-integer)
   (fAddressBuffer :signed-byte)
   )

;   ***** Initializing and Shutting Down Open Transport ***** 

                                             ; $IFC NOT OTKERNEL 
(def-mactype :otclientcontextptr (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :otclientcontextptrptr (find-mactype '(:pointer :pointer)));  when a VAR xx:OTClientContextPtr parameter can be nil, it is changed to xx: OTClientContextPtrPtr 
; 
; 	   For Carbon the InitOpenTransport interface has changed so it takes a flags parameter 
; 	   and returns a client context pointer.
; 	   The flag passed to indicates whether OT should be initialized for application use or for some other target
; 	   (for example, plugins that run in an application context but not the application itself.)
; 	   Applications that are not interested in the value of the client context pointer may pass NULL
; 	   as outClientContext -- they will pass NULL to other routines that take a OTClientContextPtr.
; 	
(def-mactype :otinitializationflags (find-mactype ':unsigned-long))

(defconstant $kInitOTForApplicationMask 1)
(defconstant $kInitOTForExtensionMask 2)

; 
; 	 *  InitOpenTransportInContext()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;    Under Carbon, CloseOpenTransport takes a client context pointer.  Applications may pass NULL
;    after calling InitOpenTransport(kInitOTForApplicationMask, ...).  Non-applications must always pass a
;    valid client context.
;                                               ; 
;  *  CloseOpenTransportInContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InitOpenTransportInContext" 
      ((flags :otinitializationflags) (outClientContext :otclientcontextptrptr)) 
  :osstatus
   () )                                         ; $IFC CALL_NOT_IN_CARBON ; 
;  *  InitOpenTransport()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CloseOpenTransportInContext" 
      ((clientContext :pointer)) 
  nil
   () )                                         ; 
;  *  InitOpenTransportUtilities()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InitOpenTransport" 
      () 
  :osstatus
   () )                                         ; 
;  *  CloseOpenTransport()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InitOpenTransportUtilities" 
      () 
  :osstatus
   () )                                         ; 
;  *  OTRegisterAsClient()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CloseOpenTransport" 
      () 
  nil
   () )                                         ; 
;    This registers yourself as a client for any miscellaneous Open Transport
;    notifications that come along. CloseOpenTransport will automatically do
;    an OTUnregisterAsClient, if you have not already done so.
;                                               ; 
;  *  OTUnregisterAsClient()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTRegisterAsClient" 
      ((name (:pointer :unsigned-byte)) (proc :pointer)) 
  :osstatus
   () )
(deftrap-inline "_OTUnregisterAsClient" 
      () 
  :osstatus
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; 
;  *  OTRegisterAsClientInContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  OTUnregisterAsClientInContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTRegisterAsClientInContext" 
      ((name (:pointer :unsigned-byte)) (proc :pointer) (clientContext :pointer)) 
  :osstatus
   () )                                         ; $IFC OTCARBONAPPLICATION ;   The following macro may be used by applications only. 
(deftrap-inline "_OTUnregisterAsClientInContext" 
      ((clientContext :pointer)) 
  :osstatus
   () )                                         ; $ENDC; OTCARBONAPPLICATION
                                             ; $ENDC

;   ***** Tasking Model ***** 
; 
;    OTEnterInterrupt/OTLeaveInterrupt are normally used within the kernel to
;    tell Open Transport we're at hardware interrupt time.  Clients can also
;    them to do the same.
; 

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  OTEnterInterrupt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  OTLeaveInterrupt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTEnterInterrupt" 
      () 
  nil
   () )                                         ; 
;  *  OTIsAtInterruptLevel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTLeaveInterrupt" 
      () 
  nil
   () )
(deftrap-inline "_OTIsAtInterruptLevel" 
      () 
  :boolean
   () )

; 
;  *  OTCanLoadLibraries()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_OTCanLoadLibraries" 
      () 
  :boolean
   () )

; 
;    All OT task callbacks use the same prototype, shown below.
;    This is only a UPP for CFM-68K clients.
; 

; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	OTProcessProcPtr = PROCEDURE(arg: UNIV Ptr);

|#
 |#                                             ; $ELSEC
(def-mactype :otprocessprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :otprocessupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :otprocessupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppOTProcessProcInfo #xC0)
; 
; 	 *  NewOTProcessUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_NewOTProcessUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeOTProcessUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeOTProcessUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeOTProcessUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_InvokeOTProcessUPP" 
      ((arg :pointer) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

                                              ; $IFC NOT OTKERNEL 
; 
;    Under Carbon, OTCreateDeferredTask takes a client context pointer.  Applications may pass NULL
;    after calling InitOpenTransport(kInitOTForApplicationMask, ...).  Non-applications must always pass a
;    valid client context.
; 
; 
;  *  OTCreateDeferredTaskInContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTCreateDeferredTaskInContext" 
      ((upp :pointer) (arg :pointer) (clientContext :pointer)) 
  :signed-long
   () )
                                              ; $ENDC

; 
;    OT deferred tasks are often more convenience that standard Mac OS
;    although they have no significant advantages beyond convenience.
; 

(def-mactype :otdeferredtaskref (find-mactype ':signed-long))
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  OTCreateDeferredTask()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_OTCreateDeferredTask" 
      ((proc :pointer) (arg :pointer)) 
  :otdeferredtaskref
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; 
;  *  OTScheduleDeferredTask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; $IFC CALL_NOT_IN_CARBON                       ; 
;  *  OTScheduleInterruptTask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTScheduleDeferredTask" 
      ((dtCookie :signed-long)) 
  :boolean
   () )
(deftrap-inline "_OTScheduleInterruptTask" 
      ((dtCookie :signed-long)) 
  :boolean
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; 
;  *  OTDestroyDeferredTask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
#|                                              ; $IFC OTCARBONAPPLICATION ;   The following macro may be used by applications only. 
(deftrap-inline "_OTDestroyDeferredTask" 
      ((dtCookie :signed-long)) 
  :osstatus
   () )
 |#                                             ; $ENDC; OTCARBONAPPLICATION

                                              ; $IFC NOT OTKERNEL 
; 
;    OT system tasks allow you to schedule a procedure to be called
;    at system task time.  Potentially useful, but it relies on someone
;    calling SystemTask (or WaitNextEvent, which calls SystemTask).
;    Not available to kernel code because relying on system task time
;    to make progress is likely to result in deadlocks.
; 

(def-mactype :otsystemtaskref (find-mactype ':signed-long))
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  OTCreateSystemTask()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; 
;  *  OTDestroySystemTask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCreateSystemTask" 
      ((proc :pointer) (arg :pointer)) 
  :otsystemtaskref
   () )                                         ; 
;  *  OTScheduleSystemTask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTDestroySystemTask" 
      ((stCookie :otsystemtaskref)) 
  :osstatus
   () )                                         ; 
;  *  OTCancelSystemTask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTScheduleSystemTask" 
      ((stCookie :otsystemtaskref)) 
  :boolean
   () )
(deftrap-inline "_OTCancelSystemTask" 
      ((stCookie :otsystemtaskref)) 
  :boolean
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; 
;  *  OTCanMakeSyncCall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTCanMakeSyncCall" 
      () 
  :boolean
   () )
                                             ; $ENDC

;   ***** Interface to Providers ***** 
                                              ; $IFC NOT OTKERNEL 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  OTAsyncOpenProvider()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  OTOpenProvider()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTAsyncOpenProvider" 
      ((cfig :pointer) (flags :unsigned-long) (proc :pointer) (contextPtr :pointer)) 
  :osstatus
   () )
(deftrap-inline "_OTOpenProvider" 
      ((cfig :pointer) (flags :unsigned-long) (errPtr (:pointer :signed-long))) 
  :pointer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; 
;  *  OTCloseProvider()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; $IFC CALL_NOT_IN_CARBON                       ; 
;  *  OTTransferProviderOwnership()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCloseProvider" 
      ((ref :pointer)) 
  :osstatus
   () )                                         ; 
;  *  OTWhoAmI()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTTransferProviderOwnership" 
      ((ref :pointer) (prevOwner :pointer) (errPtr (:pointer :signed-long))) 
  :pointer
   () )                                         ; 
;  *  OTGetProviderPortRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTWhoAmI" 
      () 
  :pointer
   () )
(deftrap-inline "_OTGetProviderPortRef" 
      ((ref :pointer)) 
  :unsigned-long
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; 
;  *  OTIoctl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; $IFC CALL_NOT_IN_CARBON                       ; 
;  *  OTGetMessage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTIoctl" 
      ((ref :pointer) (cmd :unsigned-long) (data :pointer)) 
  :signed-long
   () )                                         ; 
;  *  OTGetPriorityMessage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTGetMessage" 
      ((ref :pointer) (ctlbuf (:pointer :strbuf)) (databuf (:pointer :strbuf)) (flagsPtr (:pointer :unsigned-long))) 
  :otresult
   () )                                         ; 
;  *  OTPutMessage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTGetPriorityMessage" 
      ((ref :pointer) (ctlbuf (:pointer :strbuf)) (databuf (:pointer :strbuf)) (bandPtr (:pointer :unsigned-long)) (flagsPtr (:pointer :unsigned-long))) 
  :otresult
   () )                                         ; CONST; CONST; 
;  *  OTPutPriorityMessage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTPutMessage" 
      ((ref :pointer) (ctlbuf (:pointer :strbuf)) (databuf (:pointer :strbuf)) (flags :unsigned-long)) 
  :osstatus
   () )                                         ; CONST; CONST
(deftrap-inline "_OTPutPriorityMessage" 
      ((ref :pointer) (ctlbuf (:pointer :strbuf)) (databuf (:pointer :strbuf)) (band :unsigned-long) (flags :unsigned-long)) 
  :osstatus
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; 
;  *  OTSetAsynchronous()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  OTSetSynchronous()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTSetAsynchronous" 
      ((ref :pointer)) 
  :osstatus
   () )                                         ; 
;  *  OTIsSynchronous()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTSetSynchronous" 
      ((ref :pointer)) 
  :osstatus
   () )                                         ; 
;  *  OTSetBlocking()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTIsSynchronous" 
      ((ref :pointer)) 
  :boolean
   () )                                         ; 
;  *  OTSetNonBlocking()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTSetBlocking" 
      ((ref :pointer)) 
  :osstatus
   () )                                         ; 
;  *  OTIsBlocking()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTSetNonBlocking" 
      ((ref :pointer)) 
  :osstatus
   () )                                         ; 
;  *  OTInstallNotifier()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTIsBlocking" 
      ((ref :pointer)) 
  :boolean
   () )                                         ; 
;  *  OTUseSyncIdleEvents()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTInstallNotifier" 
      ((ref :pointer) (proc :pointer) (contextPtr :pointer)) 
  :osstatus
   () )                                         ; 
;  *  OTRemoveNotifier()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTUseSyncIdleEvents" 
      ((ref :pointer) (useEvents :boolean)) 
  :osstatus
   () )                                         ; 
;  *  OTLeaveNotifier()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTRemoveNotifier" 
      ((ref :pointer)) 
  nil
   () )                                         ; 
;  *  OTEnterNotifier()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTLeaveNotifier" 
      ((ref :pointer)) 
  nil
   () )                                         ; 
;  *  OTAckSends()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTEnterNotifier" 
      ((ref :pointer)) 
  :boolean
   () )                                         ; 
;  *  OTDontAckSends()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTAckSends" 
      ((ref :pointer)) 
  :osstatus
   () )                                         ; 
;  *  OTIsAckingSends()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTDontAckSends" 
      ((ref :pointer)) 
  :osstatus
   () )                                         ; 
;  *  OTCancelSynchronousCalls()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTIsAckingSends" 
      ((ref :pointer)) 
  :boolean
   () )
(deftrap-inline "_OTCancelSynchronousCalls" 
      ((ref :pointer) (err :signed-long)) 
  :osstatus
   () )
                                             ; $ENDC

;   ***** Interface to Endpoints ***** 
                                              ; $IFC NOT OTKERNEL 
;   Open/Close 
; 
;    Under Carbon, the OpenEndpoint routines take a client context pointer.  Applications may pass NULL after
;    calling InitOpenTransport(kInitOTForApplicationMask, ...).  Non-applications must always pass a
;    valid client context.
; 
; 
;  *  OTOpenEndpointInContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  OTAsyncOpenEndpointInContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTOpenEndpointInContext" 
      ((config :pointer) (oflag :unsigned-long) (info (:pointer :tendpointinfo)) (err (:pointer :signed-long)) (clientContext :pointer)) 
  :pointer
   () )                                         ; $IFC CALL_NOT_IN_CARBON ; 
;  *  OTOpenEndpoint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTAsyncOpenEndpointInContext" 
      ((config :pointer) (oflag :unsigned-long) (info (:pointer :tendpointinfo)) (upp :pointer) (contextPtr :pointer) (clientContext :pointer)) 
  :osstatus
   () )                                         ; 
;  *  OTAsyncOpenEndpoint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTOpenEndpoint" 
      ((cfig :pointer) (oflag :unsigned-long) (info (:pointer :tendpointinfo)) (err (:pointer :signed-long))) 
  :pointer
   () )
(deftrap-inline "_OTAsyncOpenEndpoint" 
      ((cfig :pointer) (oflag :unsigned-long) (info (:pointer :tendpointinfo)) (proc :pointer) (contextPtr :pointer)) 
  :osstatus
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; $IFC OTCARBONAPPLICATION 
;   The following macros may be used by applications only. 
; $ENDC                                         ; OTCARBONAPPLICATION
;   Misc Information 

; 
;  *  OTGetEndpointInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  OTGetEndpointState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTGetEndpointInfo" 
      ((ref :pointer) (info (:pointer :tendpointinfo))) 
  :osstatus
   () )                                         ; 
;  *  OTLook()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTGetEndpointState" 
      ((ref :pointer)) 
  :otresult
   () )                                         ; $IFC CALL_NOT_IN_CARBON ; 
;  *  OTSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTLook" 
      ((ref :pointer)) 
  :otresult
   () )
(deftrap-inline "_OTSync" 
      ((ref :pointer)) 
  :otresult
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; 
;  *  OTCountDataBytes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  OTGetProtAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTCountDataBytes" 
      ((ref :pointer) (countPtr (:pointer :unsigned-long))) 
  :otresult
   () )                                         ; 
;  *  OTResolveAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTGetProtAddress" 
      ((ref :pointer) (boundAddr (:pointer :tbind)) (peerAddr (:pointer :tbind))) 
  :osstatus
   () )                                         ;   Allocating structures ; 
;    Note:
;    In general, Apple recommends that you avoid the OTAlloc call because
;    using it extensively causes your program to allocate and deallocate
;    many memory blocks, with each extra memory allocation costing time.
;                                               ; 
;    Under Carbon, OTAlloc takes a client context pointer.  Applications may pass NULL after
;    calling InitOpenTransport(kInitOTForApplicationMask, ...).  Non-applications must always pass a
;    valid client context.
;                                               ; 
;  *  OTAllocInContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTResolveAddress" 
      ((ref :pointer) (reqAddr (:pointer :tbind)) (retAddr (:pointer :tbind)) (timeOut :unsigned-long)) 
  :osstatus
   () )                                         ; $IFC CALL_NOT_IN_CARBON ; 
;  *  OTAlloc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTAllocInContext" 
      ((ref :pointer) (structType :unsigned-long) (fields :unsigned-long) (err (:pointer :signed-long)) (clientContext :pointer)) 
  :pointer
   () )
(deftrap-inline "_OTAlloc" 
      ((ref :pointer) (structType :unsigned-long) (fields :unsigned-long) (err (:pointer :signed-long))) 
  :pointer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; $IFC OTCARBONAPPLICATION 
;   The following macro may be used by applications only. 
; $ENDC                                         ; OTCARBONAPPLICATION
; 
;  *  OTFree()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;   Option management                           ;   It looks simple enough... ; 
;  *  OTOptionManagement()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTFree" 
      ((Ptr :pointer) (structType :unsigned-long)) 
  :otresult
   () )                                         ;   ... but then the hidden complexity emerges. ; $IFC CALL_NOT_IN_CARBON ; 
;  *  OTCreateOptions()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientUtilLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTOptionManagement" 
      ((ref :pointer) (req (:pointer :toptmgmt)) (ret (:pointer :toptmgmt))) 
  :osstatus
   () )                                         ; 
;  *  OTCreateOptionString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientUtilLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCreateOptions" 
      ((endPtName :pointer) (strPtr (:pointer :pointer)) (buf (:pointer :tnetbuf))) 
  :osstatus
   () )
(deftrap-inline "_OTCreateOptionString" 
      ((endPtName :pointer) (opt (:pointer (:pointer :toption))) (bufEnd :pointer) (str :pointer) (stringSize :unsigned-long)) 
  :osstatus
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; 
;  *  OTNextOption()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  OTFindOption()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTNextOption" 
      ((buffer (:pointer :unsigned-byte)) (buflen :unsigned-long) (prevOptPtr (:pointer (:pointer :toption)))) 
  :osstatus
   () )                                         ;   Bind/Unbind ; 
;  *  OTBind()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTFindOption" 
      ((buffer (:pointer :unsigned-byte)) (buflen :unsigned-long) (level :unsigned-long) (name :unsigned-long)) 
  (:pointer :toption)
   () )                                         ; 
;  *  OTUnbind()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTBind" 
      ((ref :pointer) (reqAddr (:pointer :tbind)) (retAddr (:pointer :tbind))) 
  :osstatus
   () )                                         ;   Connection creation/tear-down ; 
;  *  OTConnect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTUnbind" 
      ((ref :pointer)) 
  :osstatus
   () )                                         ; 
;  *  OTRcvConnect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTConnect" 
      ((ref :pointer) (sndCall (:pointer :tcall)) (rcvCall (:pointer :tcall))) 
  :osstatus
   () )                                         ; 
;  *  OTListen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTRcvConnect" 
      ((ref :pointer) (call (:pointer :tcall))) 
  :osstatus
   () )                                         ; 
;  *  OTAccept()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTListen" 
      ((ref :pointer) (call (:pointer :tcall))) 
  :osstatus
   () )                                         ; 
;  *  OTSndDisconnect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTAccept" 
      ((listener :pointer) (worker :pointer) (call (:pointer :tcall))) 
  :osstatus
   () )                                         ; 
;  *  OTSndOrderlyDisconnect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTSndDisconnect" 
      ((ref :pointer) (call (:pointer :tcall))) 
  :osstatus
   () )                                         ; 
;  *  OTRcvDisconnect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTSndOrderlyDisconnect" 
      ((ref :pointer)) 
  :osstatus
   () )                                         ; 
;  *  OTRcvOrderlyDisconnect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTRcvDisconnect" 
      ((ref :pointer) (discon (:pointer :tdiscon))) 
  :osstatus
   () )                                         ;   Connection-oriented send/receive ; 
;  *  OTRcv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTRcvOrderlyDisconnect" 
      ((ref :pointer)) 
  :osstatus
   () )                                         ; 
;  *  OTSnd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTRcv" 
      ((ref :pointer) (buf :pointer) (nbytes :unsigned-long) (flags (:pointer :unsigned-long))) 
  :otresult
   () )                                         ;   Connectionless send/receive ; 
;  *  OTSndUData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTSnd" 
      ((ref :pointer) (buf :pointer) (nbytes :unsigned-long) (flags :unsigned-long)) 
  :otresult
   () )                                         ; 
;  *  OTRcvUData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTSndUData" 
      ((ref :pointer) (udata (:pointer :tunitdata))) 
  :osstatus
   () )                                         ; 
;  *  OTRcvUDErr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTRcvUData" 
      ((ref :pointer) (udata (:pointer :tunitdata)) (flags (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ;   Connection-oriented transactions ; $IFC CALL_NOT_IN_CARBON ; 
;  *  OTSndRequest()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTRcvUDErr" 
      ((ref :pointer) (uderr (:pointer :tuderr))) 
  :osstatus
   () )                                         ; 
;  *  OTRcvReply()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTSndRequest" 
      ((ref :pointer) (req (:pointer :trequest)) (reqFlags :unsigned-long)) 
  :osstatus
   () )                                         ; 
;  *  OTSndReply()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTRcvReply" 
      ((ref :pointer) (reply (:pointer :treply)) (replyFlags (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  OTRcvRequest()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTSndReply" 
      ((ref :pointer) (reply (:pointer :treply)) (replyFlags :unsigned-long)) 
  :osstatus
   () )                                         ; 
;  *  OTCancelRequest()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTRcvRequest" 
      ((ref :pointer) (req (:pointer :trequest)) (reqFlags (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  OTCancelReply()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCancelRequest" 
      ((ref :pointer) (sequence :signed-long)) 
  :osstatus
   () )                                         ;   Connectionless transactions ; 
;  *  OTSndURequest()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCancelReply" 
      ((ref :pointer) (sequence :signed-long)) 
  :osstatus
   () )                                         ; 
;  *  OTRcvUReply()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTSndURequest" 
      ((ref :pointer) (req (:pointer :tunitrequest)) (reqFlags :unsigned-long)) 
  :osstatus
   () )                                         ; 
;  *  OTSndUReply()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTRcvUReply" 
      ((ref :pointer) (reply (:pointer :tunitreply)) (replyFlags (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  OTRcvURequest()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTSndUReply" 
      ((ref :pointer) (reply (:pointer :tunitreply)) (replyFlags :unsigned-long)) 
  :osstatus
   () )                                         ; 
;  *  OTCancelURequest()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTRcvURequest" 
      ((ref :pointer) (req (:pointer :tunitrequest)) (reqFlags (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  OTCancelUReply()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTCancelURequest" 
      ((ref :pointer) (seq :signed-long)) 
  :osstatus
   () )                                         ;   Interface to Mappers ; 
;    Under Carbon, the OpenMapper routines take a client context pointer.  Applications may pass NULL after
;    calling InitOpenTransport(kInitOTForApplicationMask, ...).  Non-applications must always pass a
;    valid client context.
; 
(deftrap-inline "_OTCancelUReply" 
      ((ref :pointer) (seq :signed-long)) 
  :osstatus
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; 
;  *  OTAsyncOpenMapperInContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  OTOpenMapperInContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTAsyncOpenMapperInContext" 
      ((config :pointer) (oflag :unsigned-long) (upp :pointer) (contextPtr :pointer) (clientContext :pointer)) 
  :osstatus
   () )                                         ; $IFC CALL_NOT_IN_CARBON ; 
;  *  OTAsyncOpenMapper()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTOpenMapperInContext" 
      ((config :pointer) (oflag :unsigned-long) (err (:pointer :signed-long)) (clientContext :pointer)) 
  :pointer
   () )                                         ; 
;  *  OTOpenMapper()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTAsyncOpenMapper" 
      ((cfig :pointer) (oflag :unsigned-long) (proc :pointer) (contextPtr :pointer)) 
  :osstatus
   () )
(deftrap-inline "_OTOpenMapper" 
      ((cfig :pointer) (oflag :unsigned-long) (err (:pointer :signed-long))) 
  :pointer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; $IFC OTCARBONAPPLICATION 
;   The following macros may be used by applications only. 
; $ENDC                                         ; OTCARBONAPPLICATION
; 
;  *  OTRegisterName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  OTDeleteName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTRegisterName" 
      ((ref :pointer) (req (:pointer :tregisterrequest)) (reply (:pointer :tregisterreply))) 
  :osstatus
   () )                                         ; 
;  *  OTDeleteNameByID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTDeleteName" 
      ((ref :pointer) (name (:pointer :tnetbuf))) 
  :osstatus
   () )                                         ; 
;  *  OTLookupName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTDeleteNameByID" 
      ((ref :pointer) (nameID :signed-long)) 
  :osstatus
   () )                                         ;   Basic configuration manipulation ; 
;  *  OTCreateConfiguration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientUtilLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTLookupName" 
      ((ref :pointer) (req (:pointer :tlookuprequest)) (reply (:pointer :tlookupreply))) 
  :osstatus
   () )                                         ; 
;  *  OTCloneConfiguration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientUtilLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTCreateConfiguration" 
      ((path :pointer)) 
  :pointer
   () )                                         ; 
;  *  OTDestroyConfiguration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientUtilLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTCloneConfiguration" 
      ((cfig :pointer)) 
  :pointer
   () )                                         ; 
;    This file defines a very limited set of operations
;    on a configuration.  "OpenTransportClient.h" extends this with extra
;    operations used by protocol stacks but not typically needed by clients.
;                                               ;   Interrupt-safe memory allocators ; 
;    Under Carbon, OTAllocMem takes a client context pointer.  Applications may pass NULL after
;    calling InitOpenTransport(kInitOTForApplicationMask, ...).  Non-applications must always pass a
;    valid client context.
;                                               ; 
;  *  OTAllocMemInContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTDestroyConfiguration" 
      ((cfig :pointer)) 
  nil
   () )
(deftrap-inline "_OTAllocMemInContext" 
      ((size :unsigned-long) (clientContext :pointer)) 
  :pointer
   () )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  OTAllocMem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_OTAllocMem" 
      ((size :unsigned-long)) 
  :pointer
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
; 
;  *  OTFreeMem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientUtilLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTFreeMem" 
      ((mem :pointer)) 
  nil
   () )

; $IFC OTCARBONAPPLICATION 
;   The following macros may be used by applications only. 
; $ENDC                                         ; OTCARBONAPPLICATION
;   Miscellaneous and Generic Routines 

; 
;    Neither of these routines should be necessary to the correct
;    operation of an OT program.  If you're calling them, think again.
; 

; 
;  *  OTDelay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  OTIdle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTClientLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTDelay" 
      ((seconds :unsigned-long)) 
  nil
   () )
(deftrap-inline "_OTIdle" 
      () 
  nil
   () )
                                              ; $ENDC

; 
;    ***** Open Transport Utility Routines *****
;    All of these routines are available to both client and kernel.
; 
;   Memory and String Routines 

; 
;    These are preferable, especially in the kernel case, to the standard
;    C equivalents because they don't require you to link with StdCLib.
; 

; 
;  *  OTMemcpy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTMemcpy" 
      ((dest :pointer) (src :pointer) (nBytes :unsigned-long)) 
  nil
   () )

; 
;  *  OTMemcmp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTMemcmp" 
      ((mem1 :pointer) (mem2 :pointer) (nBytes :unsigned-long)) 
  :boolean
   () )

; 
;  *  OTMemmove()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTMemmove" 
      ((dest :pointer) (src :pointer) (nBytes :unsigned-long)) 
  nil
   () )

; 
;  *  OTMemzero()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTMemzero" 
      ((dest :pointer) (nBytes :unsigned-long)) 
  nil
   () )

; 
;  *  OTMemset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTMemset" 
      ((dest :pointer) (toSet :unsigned-byte) (nBytes :unsigned-long)) 
  nil
   () )

; 
;  *  OTStrLength()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTStrLength" 
      ((str :pointer)) 
  :unsigned-long
   () )

; 
;  *  OTStrCopy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTStrCopy" 
      ((dest :pointer) (src :pointer)) 
  nil
   () )

; 
;  *  OTStrCat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTStrCat" 
      ((dest :pointer) (src :pointer)) 
  nil
   () )

; 
;  *  OTStrEqual()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTStrEqual" 
      ((src1 :pointer) (src2 :pointer)) 
  :boolean
   () )

;   Timer Utilities 

; 
;    OTGetTimeStamp returns time in "tick" numbers, stored in 64 bits.
;    This timestamp can be used as a base number for calculating elapsed 
;    time.
;    OTSubtractTimeStamps returns a pointer to the "result" parameter.
;     
;    OTGetClockTimeInSecs returns time since Open Transport was initialized
;    in seconds.
; 

(%define-record :ottimestamp (find-record-descriptor :unsignedwide))
(def-mactype :ottimestampptr (find-mactype '(:pointer :unsignedwide)))
; 
; 	 *  OTGetTimeStamp()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_OTGetTimeStamp" 
      ((currentTime (:pointer :unsignedwide))) 
  nil
   () )

; 
;  *  OTSubtractTimeStamps()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTSubtractTimeStamps" 
      ((result (:pointer :unsignedwide)) (startTime (:pointer :unsignedwide)) (endEnd (:pointer :unsignedwide))) 
  (:pointer :unsignedwide)
   () )

; 
;  *  OTTimeStampInMilliseconds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTTimeStampInMilliseconds" 
      ((delta (:pointer :unsignedwide))) 
  :unsigned-long
   () )

; 
;  *  OTTimeStampInMicroseconds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTTimeStampInMicroseconds" 
      ((delta (:pointer :unsignedwide))) 
  :unsigned-long
   () )

; 
;  *  OTElapsedMilliseconds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTElapsedMilliseconds" 
      ((startTime (:pointer :unsignedwide))) 
  :unsigned-long
   () )

; 
;  *  OTElapsedMicroseconds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTElapsedMicroseconds" 
      ((startTime (:pointer :unsignedwide))) 
  :unsigned-long
   () )

; 
;  *  OTGetClockTimeInSecs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTGetClockTimeInSecs" 
      () 
  :unsigned-long
   () )

;   ***** OT Link Element ***** 

; 
;    When using OT linked lists, all pointers to other elements are
;    represented by the OTLink structure.  When operating on link
;    lists, you always pass in the address of the OTLink on which
;    list elements are chained.
; 

(def-mactype :otlinkptr (find-mactype '(:pointer :otlink)))
(defrecord OTLink 
   (fNext (:pointer :otlink))
   )

;   OTLIFO 

; 
; 	   These are functions to implement a LIFO list that is interrupt-safe.
; 	   The only function which is not is OTReverseList.  Normally, you create
; 	   a LIFO list, populate it at interrupt time, and then use OTLIFOStealList
; 	   to atomically remove the list, and OTReverseList to flip the list so that
; 	   it is a FIFO list, which tends to be more useful.
; 	

(def-mactype :otlifoptr (find-mactype '(:pointer :otlifo)))
(defrecord OTLIFO 
   (fHead (:pointer :otlink))
   )

; 
; 	   This function atomically enqueues the link onto the
; 	   front of the list.
; 	
; 
; 	 *  OTLIFOEnqueue()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_OTLIFOEnqueue" 
      ((list (:pointer :otlifo)) (link (:pointer :otlink))) 
  nil
   () )

; 
;    This function atomically dequeues the first element
;    on the list.
; 
; 
;  *  OTLIFODequeue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTLIFODequeue" 
      ((list (:pointer :otlifo))) 
  (:pointer :otlink)
   () )

; 
;    This function atomically empties the list and returns a
;    pointer to the first element on the list.
; 
; 
;  *  OTLIFOStealList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTLIFOStealList" 
      ((list (:pointer :otlifo))) 
  (:pointer :otlink)
   () )

; 
;    This function reverses a list that was stolen by
;    OTLIFOStealList.  It is NOT atomic.  It returns the
;    new starting list.
; 
; 
;  *  OTReverseList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTReverseList" 
      ((list (:pointer :otlink))) 
  (:pointer :otlink)
   () )

;   OTList 

; 
;    An OTList is a non-interrupt-safe list, but has more features than the
;    OTLIFO list. It is a standard singly-linked list.
; 

; 
;    The following is the prototype for a list element comparison function,
;    which returns true if the element described by linkToCheck matches
;    the client criteria (typically held in ref).
;    This is only a UPP for CFM-68K clients.
; 

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	OTListSearchProcPtr = FUNCTION(ref: UNIV Ptr; VAR linkToCheck: OTLink): BOOLEAN; C;

|#
 |#                                             ; $ELSEC
(def-mactype :otlistsearchprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :otlistsearchupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :otlistsearchupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppOTListSearchProcInfo #x3D1)
; 
; 	 *  NewOTListSearchUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_NewOTListSearchUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeOTListSearchUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeOTListSearchUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeOTListSearchUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_InvokeOTListSearchUPP" 
      ((ref :pointer) (linkToCheck (:pointer :otlink)) (userRoutine :pointer)) 
  :boolean
   () )
(def-mactype :otlistptr (find-mactype '(:pointer :otlist)))
(defrecord OTList 
   (fHead (:pointer :otlink))
   )

;   Add the link to the list at the front 
; 
; 	 *  OTAddFirst()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_OTAddFirst" 
      ((list (:pointer :otlist)) (link (:pointer :otlink))) 
  nil
   () )

;   Add the link to the list at the end 
; 
;  *  OTAddLast()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTAddLast" 
      ((list (:pointer :otlist)) (link (:pointer :otlink))) 
  nil
   () )

;   Remove the first link from the list 
; 
;  *  OTRemoveFirst()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTRemoveFirst" 
      ((list (:pointer :otlist))) 
  (:pointer :otlink)
   () )

;   Remove the last link from the list 
; 
;  *  OTRemoveLast()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTRemoveLast" 
      ((list (:pointer :otlist))) 
  (:pointer :otlink)
   () )

;   Return the first link from the list 
; 
;  *  OTGetFirst()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTGetFirst" 
      ((list (:pointer :otlist))) 
  (:pointer :otlink)
   () )

;   Return the last link from the list 
; 
;  *  OTGetLast()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTGetLast" 
      ((list (:pointer :otlist))) 
  (:pointer :otlink)
   () )

;   Return true if the link is present in the list 
; 
;  *  OTIsInList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTIsInList" 
      ((list (:pointer :otlist)) (link (:pointer :otlink))) 
  :boolean
   () )

; 
;    Find a link in the list which matches the search criteria
;    established by the search proc and the refPtr.  This is done
;    by calling the search proc, passing it the refPtr and each
;    link in the list, until the search proc returns true.
;    NULL is returned if the search proc never returned true.
; 
; 
;  *  OTFindLink()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTFindLink" 
      ((list (:pointer :otlist)) (proc :pointer) (ref :pointer)) 
  (:pointer :otlink)
   () )

;   Remove the specified link from the list, returning true if it was found 
; 
;  *  OTRemoveLink()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTRemoveLink" 
      ((list (:pointer :otlist)) (link (:pointer :otlink))) 
  :boolean
   () )

;   Similar to OTFindLink, but it also removes it from the list. 
; 
;  *  OTFindAndRemoveLink()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTFindAndRemoveLink" 
      ((list (:pointer :otlist)) (proc :pointer) (ref :pointer)) 
  (:pointer :otlink)
   () )

;   Return the "index"th link in the list 
; 
;  *  OTGetIndexedLink()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTGetIndexedLink" 
      ((list (:pointer :otlist)) (index :unsigned-long)) 
  (:pointer :otlink)
   () )

;   OTEnqueue/OTDequeue 

; 
;    These routines are atomic, mighty weird, and generally not
;    worth the complexity.  If you need atomic list operations,
;    use OTLIFO instead.
; 

; 
;    This function puts "object" on the listHead, and places the
;    previous value at listHead into the pointer at "object" plus
;    linkOffset.
; 
; 
;  *  OTEnqueue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTEnqueue" 
      ((listHead (:pointer :pointer)) (object :pointer) (linkOffset :unsigned-long)) 
  nil
   () )

; 
;    This function returns the head object of the list, and places
;    the pointer at "object" + linkOffset into the listHead
; 
; 
;  *  OTDequeue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTDequeue" 
      ((listHead (:pointer :pointer)) (linkOffset :unsigned-long)) 
  :pointer
   () )

;   Atomic Operations 

; 
;    Note:
;    The Bit operations return the previous value of the bit (0 or non-zero).
;    The memory pointed to must be a single byte and only bits 0 through 7 are
;    valid.  Bit 0 corresponds to a mask of 0x01, and Bit 7 to a mask of 0x80.
; 

; 
;    WARNING!
;    void* and UInt32 locations MUST be on 4-byte boundaries.
;    UInt16 locations must not cross a 4-byte boundary.
; 

; 
;  *  OTAtomicSetBit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTAtomicSetBit" 
      ((bytePtr (:pointer :unsigned-byte)) (bitNumber :unsigned-long)) 
  :boolean
   () )
; 
;    bset.b d0,(a0)
;    sne d0
;    moveq #1,d1
;    and.l d1,d0
; 
; 
;  *  OTAtomicClearBit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTAtomicClearBit" 
      ((bytePtr (:pointer :unsigned-byte)) (bitNumber :unsigned-long)) 
  :boolean
   () )
; 
;    bclr.b d0,(a0)
;    sne d0
;    moveq #1,d1
;    and.l d1,d0
; 
; 
;  *  OTAtomicTestBit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTAtomicTestBit" 
      ((bytePtr (:pointer :unsigned-byte)) (bitNumber :unsigned-long)) 
  :boolean
   () )
; 
;    btst.b d0,(a0)
;    sne d0 */
;    moveq #1,d1
;    and.l d1,d0 */
; 
; 
;  *  OTCompareAndSwapPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTCompareAndSwapPtr" 
      ((oldValue :pointer) (newValue :pointer) (dest (:pointer :pointer))) 
  :boolean
   () )
; 
;    cas.l    d0,d1,(a0)  */
;    seq      d0          */
;    moveq #1,d1; and.l d1,d0 */
; 
; 
;  *  OTCompareAndSwap32()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTCompareAndSwap32" 
      ((oldValue :unsigned-long) (newValue :unsigned-long) (dest (:pointer :unsigned-long))) 
  :boolean
   () )
; 
;    cas.l    d0,d1,(a0)  */
;    seq      d0          */
;    moveq #1,d1; and.l d1,d0 */
; 
; 
;  *  OTCompareAndSwap16()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTCompareAndSwap16" 
      ((oldValue :unsigned-long) (newValue :unsigned-long) (dest (:pointer :unsigned-integer))) 
  :boolean
   () )
; 
;    cas.w    d0,d1,(a0)  */
;    seq      d0          */
;    moveq #1,d1; and.l d1,d0 */
; 
; 
;  *  OTCompareAndSwap8()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTCompareAndSwap8" 
      ((oldValue :unsigned-long) (newValue :unsigned-long) (dest (:pointer :unsigned-byte))) 
  :boolean
   () )
; 
;    cas.b    d0,d1,(a0)  */
;    seq      d0          */
;    moveq #1,d1; and.l d1,d0 */
; 
; 
;  *  OTAtomicAdd32()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTAtomicAdd32" 
      ((toAdd :signed-long) (dest (:pointer :signed-long))) 
  :signed-long
   () )
; 
;    move.l   d0,a1       */
;    move.l   (a0),d1     */
;    move.l   d1,d0       */
;    add.l    a1,d0       */
;    cas.l    d1,d0,(a0)  */
;    bne.s    @1          */
; 
; 
;  *  OTAtomicAdd16()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTAtomicAdd16" 
      ((toAdd :signed-long) (dest (:pointer :signed-integer))) 
  :signed-integer
   () )

;   Not used frequently enough to justify inlining. 
; 
;  *  OTAtomicAdd8()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in OTUtilityLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_OTAtomicAdd8" 
      ((toAdd :signed-long) (dest (:pointer :signed-byte))) 
  :signed-byte
   () )

;   Not used frequently enough to justify inlining. 
;   OTLock is just a convenience type with some convenient macros. 

(def-mactype :otlock (find-mactype ':unsigned-byte))

; $ifc not undefined MWERKS and TARGET_CPU_68K
; $pragmac d0_pointers reset
; $endc

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := OpenTransportIncludes

; $ENDC                                         ; __OPENTRANSPORT__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'OpenTransport)#|
; Warning: Did not recognize these types or records: (otinitializationflags otclientcontextptrptr otsystemtaskref)
|#
;; This form has been added from patch file OSX Drive:Users:bburns:Desktop:interface-translator:Patches:opentransport.patch

;; in interfaces for 4.3 these were in OpenTptInternet - got lost in newer universal interfaces
(defconstant $kDNRName "dnr")
;; This form has been added from patch file OSX Drive:Users:bburns:Desktop:interface-translator:Patches:opentransport.patch
(defconstant $kTCPName "tcp")
;; This form has been added from patch file OSX Drive:Users:bburns:Desktop:interface-translator:Patches:opentransport.patch
(defconstant $kUDPName "udp")
;; This form has been added from patch file OSX Drive:Users:bburns:Desktop:interface-translator:Patches:opentransport.patch
(defconstant $kRawIPName "rawip")