(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:OpenTransportProviders.p"
; at Wednesday May 1,2002 2:40:15 pm.
; 
;      File:       OpenTransportProviders.p
;  
;      Contains:   This file contains provider-specific definitions for various built-in providers.
;  
;      Version:    Technology: 2.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1993-2001 by Apple Computer, Inc. and Mentat Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;; hand edited re ifc not otkernel
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __OPENTRANSPORTPROVIDERS__
; $SETC __OPENTRANSPORTPROVIDERS__ := 1

; $I+
; $SETC OpenTransportProvidersIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __OPENTRANSPORT__
|#

(require-interface 'OpenTransport)
#|                                              ; $I OpenTransport.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; $ifc not undefined MWERKS and TARGET_CPU_68K
; $pragmac d0_pointers on
; $endc

;   ***** TCP/IP ***** 

;   Basic types 

(def-mactype :inetport (find-mactype ':unsigned-integer))
(def-mactype :inethost (find-mactype ':unsigned-long))
;    Enums used as address type designations. 

(defconstant $AF_INET 2)                        ;   Traditonal 

(defconstant $AF_DNS 42)

; 
; 	    Enum which can be used to bind to all IP interfaces
; 	    rather than a specific one.
; 	

(defconstant $kOTAnyInetAddress 0)              ;   Wildcard 

; 
; 	   Define the InetSvcRef type.  This type needs special
; 	   processing because in C++ it's a subclass of TProvider.
; 	   See the definition of TEndpointRef in "OpenTransport.h"
; 	   for the logic behind this definition.
; 	

(def-mactype :inetsvcref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :inetsvcrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:InetSvcRef parameter can be nil, it is changed to xx: InetSvcRefPtr 

(defconstant $kDefaultInternetServicesPath -3)

;   Shared library prefixes 

;   Module Names 

;   XTI Options 

;   Protocol levels 

(defconstant $INET_IP #x0)
(defconstant $INET_TCP #x6)
(defconstant $INET_UDP #x11)

;   TCP Level Options 

(defconstant $TCP_NODELAY #x1)
(defconstant $TCP_MAXSEG #x2)
(defconstant $TCP_NOTIFY_THRESHOLD #x10)        ;  * not a real XTI option  
(defconstant $TCP_ABORT_THRESHOLD #x11)         ;  * not a real XTI option  
(defconstant $TCP_CONN_NOTIFY_THRESHOLD #x12)   ;  * not a real XTI option  
(defconstant $TCP_CONN_ABORT_THRESHOLD #x13)    ;  * not a real XTI option  
(defconstant $TCP_OOBINLINE #x14)               ;  * not a real XTI option  
(defconstant $TCP_URGENT_PTR_TYPE #x15)         ;  * not a real XTI option  
(defconstant $TCP_KEEPALIVE #x8)                ;   keepalive defined in OpenTransport.h  

(defconstant $T_GARBAGE 2)

;   UDP Level Options 

(defconstant $UDP_CHECKSUM #x600)
(defconstant $UDP_RX_ICMP #x2)

;   IP Level Options 
(defconstant $kIP_OPTIONS #x1)
(defconstant $kIP_TOS #x2)
(defconstant $kIP_TTL #x3)
(defconstant $kIP_REUSEADDR #x4)
(defconstant $kIP_DONTROUTE #x10)
(defconstant $kIP_BROADCAST #x20)
(defconstant $kIP_REUSEPORT #x200)
(defconstant $kIP_HDRINCL #x1002)
(defconstant $kIP_RCVOPTS #x1005)
(defconstant $kIP_RCVDSTADDR #x1007)
(defconstant $kIP_MULTICAST_IF #x1010)          ;   set/get IP multicast interface  
(defconstant $kIP_MULTICAST_TTL #x1011)         ;   set/get IP multicast timetolive     
(defconstant $kIP_MULTICAST_LOOP #x1012)        ;   set/get IP multicast loopback   
(defconstant $kIP_ADD_MEMBERSHIP #x1013)        ;   add an IP group membership      
(defconstant $kIP_DROP_MEMBERSHIP #x1014)       ;   drop an IP group membership        
(defconstant $kIP_BROADCAST_IFNAME #x1015)      ;   Set interface for broadcasts    
(defconstant $kIP_RCVIFADDR #x1016)             ;   Set interface for broadcasts    

(defconstant $IP_OPTIONS #x1)
(defconstant $IP_TOS #x2)
(defconstant $IP_TTL #x3)
(defconstant $IP_REUSEADDR #x4)
(defconstant $IP_DONTROUTE #x10)
(defconstant $IP_BROADCAST #x20)
(defconstant $IP_REUSEPORT #x200)
(defconstant $IP_HDRINCL #x1002)
(defconstant $IP_RCVOPTS #x1005)
(defconstant $IP_RCVDSTADDR #x1007)
(defconstant $IP_MULTICAST_IF #x1010)           ;   set/get IP multicast interface  
(defconstant $IP_MULTICAST_TTL #x1011)          ;   set/get IP multicast timetolive     
(defconstant $IP_MULTICAST_LOOP #x1012)         ;   set/get IP multicast loopback   
(defconstant $IP_ADD_MEMBERSHIP #x1013)         ;   add an IP group membership      
(defconstant $IP_DROP_MEMBERSHIP #x1014)        ;   drop an IP group membership        
(defconstant $IP_BROADCAST_IFNAME #x1015)       ;   Set interface for broadcasts    
(defconstant $IP_RCVIFADDR #x1016)              ;   Set interface for broadcasts    

(defconstant $DVMRP_INIT 100)                   ;   DVMRP-specific setsockopt commands, from ip_mroute.h 
(defconstant $DVMRP_DONE 101)
(defconstant $DVMRP_ADD_VIF 102)
(defconstant $DVMRP_DEL_VIF 103)
(defconstant $DVMRP_ADD_LGRP 104)
(defconstant $DVMRP_DEL_LGRP 105)
(defconstant $DVMRP_ADD_MRT 106)
(defconstant $DVMRP_DEL_MRT 107)

;   IP_TOS precdence levels 

(defconstant $T_ROUTINE 0)
(defconstant $T_PRIORITY 1)
(defconstant $T_IMMEDIATE 2)
(defconstant $T_FLASH 3)
(defconstant $T_OVERRIDEFLASH 4)
(defconstant $T_CRITIC_ECP 5)
(defconstant $T_INETCONTROL 6)
(defconstant $T_NETCONTROL 7)

;    IP_TOS type of service 

(defconstant $T_NOTOS #x0)
(defconstant $T_LDELAY #x10)
(defconstant $T_HITHRPT #x8)
(defconstant $T_HIREL #x4)

;   IP Multicast option structures 

(def-mactype :tipaddmulticastptr (find-mactype '(:pointer :tipaddmulticast)))
(defrecord TIPAddMulticast 
   (multicastGroupAddress :unsigned-long)
   (interfaceAddress :unsigned-long)
   )

;   Protocol-specific events 

(defconstant $T_DNRSTRINGTOADDRCOMPLETE #x10000001)
(defconstant $T_DNRADDRTONAMECOMPLETE #x10000002)
(defconstant $T_DNRSYSINFOCOMPLETE #x10000003)
(defconstant $T_DNRMAILEXCHANGECOMPLETE #x10000004)
(defconstant $T_DNRQUERYCOMPLETE #x10000005)

;   InetAddress 

(def-mactype :inetaddressptr (find-mactype '(:pointer :inetaddress)))
(defrecord InetAddress 
   (fAddressType :unsigned-integer)             ;   always AF_INET 
   (fPort :unsigned-integer)                    ;   Port number  
   (fHost :unsigned-long)                       ;   Host address in net byte order 
   (fUnused (:array :unsigned-byte 8 :packed))  ;   Traditional unused bytes 
   )

;   Domain Name Resolver (DNR)  

(defconstant $kMaxHostAddrs 10)
(defconstant $kMaxSysStringLen 32)
(defconstant $kMaxHostNameLen 255)

(defrecord InetDomainName (array (:array :character 256 :packed)))
(def-mactype :inethostinfoptr (find-mactype '(:pointer :inethostinfo)))
(defrecord InetHostInfo 
   (name :inetdomainname)
   (addrs (:array :unsigned-long 10))
   )

(def-mactype :inetsysinfoptr (find-mactype '(:pointer :inetsysinfo)))
(defrecord InetSysInfo 
   (cpuType (:array :character 32 :packed))
   (osType (:array :character 32 :packed))
   )

(def-mactype :inetmailexchangeptr (find-mactype '(:pointer :inetmailexchange)))
(defrecord InetMailExchange 
   (preference :unsigned-integer)
   (exchange :inetdomainname)
   )

(def-mactype :dnsqueryinfoptr (find-mactype '(:pointer :dnsqueryinfo)))
(defrecord DNSQueryInfo 
   (qType :unsigned-integer)
   (qClass :unsigned-integer)
   (ttl :unsigned-long)
   (name :inetdomainname)
   (responseType :unsigned-integer)             ;   answer, authority, or additional 
   (resourceLen :unsigned-integer)              ;   actual length of array which follows 
   (resourceData (:array :character 4 :packed)) ;   size varies 
   )

;   DNSAddress 
; 
; 	   The DNSAddress format is optional and may be used in connects,
; 	   datagram sends, and resolve address calls.   The name takes the 
; 	   format "somewhere.com" or "somewhere.com:portnumber" where
; 	   the ":portnumber" is optional.   The length of this structure
; 	   is arbitrarily limited to the overall max length of a domain
; 	   name (255 chars), although a longer one can be use successfully
; 	   if you use this as a template for doing so.   However, the domain name 
; 	   is still limited to 255 characters.
; 	

(def-mactype :dnsaddressptr (find-mactype '(:pointer :dnsaddress)))
(defrecord DNSAddress 
   (fAddressType :unsigned-integer)             ;   always AF_DNS 
   (fName :inetdomainname)
   )

;   InetInterfaceInfo 

(defconstant $kDefaultInetInterface -1)

(defconstant $kInetInterfaceInfoVersion 3)

(def-mactype :inetinterfaceinfoptr (find-mactype '(:pointer :inetinterfaceinfo)))
(defrecord InetInterfaceInfo 
   (fAddress :unsigned-long)
   (fNetmask :unsigned-long)
   (fBroadcastAddr :unsigned-long)
   (fDefaultGatewayAddr :unsigned-long)
   (fDNSAddr :unsigned-long)
   (fVersion :unsigned-integer)
   (fHWAddrLen :unsigned-integer)
   (fHWAddr :pointer)
   (fIfMTU :unsigned-long)
   (fReservedPtrs (:array :pointer 2))
   (fDomainName :inetdomainname)
   (fIPSecondaryCount :unsigned-long)
   (fReserved (:array :unsigned-byte 252 :packed))
   )

;   InetDHCPOption 

(defconstant $kAllDHCPOptions -1)
(defconstant $kDHCPLongOption 126)
(defconstant $kDHCPLongOptionReq 127)

(def-mactype :inetdhcpoptionptr (find-mactype '(:pointer :inetdhcpoption)))
(defrecord InetDHCPOption 
   (fOptionTag :signed-byte)
   (fOptionLen :signed-byte)
   (fOptionValue :signed-byte)
   )

;   TCP/IP Utility Routines 

; 
; 	 *  OTInitInetAddress()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;  *  OTInitDNSAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTInitInetAddress" 
      ((addr (:pointer :inetaddress)) (port :unsigned-integer) (host :unsigned-long)) 
  nil
   () )                                         ; 
;  *  OTInetStringToHost()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTInitDNSAddress" 
      ((addr (:pointer :dnsaddress)) (str :pointer)) 
  :unsigned-long
   () )                                         ; 
;  *  OTInetHostToString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTInetStringToHost" 
      ((str :pointer) (host (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  OTInetGetInterfaceInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTInetHostToString" 
      ((host :unsigned-long) (str :pointer)) 
  nil
   () )                                         ; 
;  *  OTInetGetSecondaryAddresses()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTInetGetInterfaceInfo" 
      ((info (:pointer :inetinterfaceinfo)) (val :signed-long)) 
  :osstatus
   () )                                         ; $IFC CALL_NOT_IN_CARBON ; 
;  *  OTInetGetDHCPConfigInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTInetGetSecondaryAddresses" 
      ((addr (:pointer :unsigned-long)) (count (:pointer :unsigned-long)) (val :signed-long)) 
  :osstatus
   () )                                         ;   InetServices & DNR Calls 
(deftrap-inline "_OTInetGetDHCPConfigInfo" 
      ((buf (:pointer :inetdhcpoption)) (bufSize :unsigned-long) (index :signed-long) (opt :signed-long)) 
  :osstatus
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

                                              ; $IFC NOT OTKERNEL 
; 
;    Under Carbon, OTOpenInternetServices routines take a client context pointer.  Applications may pass NULL
;    after calling InitOpenTransport(kInitOTForApplicationMask, ...).  Non-applications must always pass a
;    valid client context.
; 
; 
;  *  OTOpenInternetServicesInContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  OTAsyncOpenInternetServicesInContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTOpenInternetServicesInContext" 
      ((cfig :pointer) (oflag :unsigned-long) (err (:pointer :signed-long)) (clientContext :pointer)) 
  :pointer
   () )                                         ; $IFC CALL_NOT_IN_CARBON ; 
;  *  OTOpenInternetServices()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTAsyncOpenInternetServicesInContext" 
      ((cfig :pointer) (oflag :unsigned-long) (upp :pointer) (contextPtr :pointer) (clientContext :pointer)) 
  :osstatus
   () )                                         ; 
;  *  OTAsyncOpenInternetServices()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTOpenInternetServices" 
      ((cfig :pointer) (oflag :unsigned-long) (err (:pointer :signed-long))) 
  :pointer
   () )
(deftrap-inline "_OTAsyncOpenInternetServices" 
      ((cfig :pointer) (oflag :unsigned-long) (proc :pointer) (contextPtr :pointer)) 
  :osstatus
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; $IFC OTCARBONAPPLICATION 
;   The following macro may be used by applications only. 
; $ENDC                                         ; OTCARBONAPPLICATION
; 
;  *  OTInetStringToAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  OTInetAddressToName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTInetStringToAddress" 
      ((ref :pointer) (name :pointer) (hinfo (:pointer :inethostinfo))) 
  :osstatus
   () )                                         ; 
;  *  OTInetSysInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTInetAddressToName" 
      ((ref :pointer) (addr :unsigned-long) (name (:pointer :inetdomainname))) 
  :osstatus
   () )                                         ; 
;  *  OTInetMailExchange()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTInetSysInfo" 
      ((ref :pointer) (name :pointer) (sysinfo (:pointer :inetsysinfo))) 
  :osstatus
   () )                                         ; 
;  *  OTInetQuery()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTInetMailExchange" 
      ((ref :pointer) (name :pointer) (num (:pointer :unsigned-integer)) (mx (:pointer :inetmailexchange))) 
  :osstatus
   () )
(deftrap-inline "_OTInetQuery" 
      ((ref :pointer) (name :pointer) (qClass :unsigned-integer) (qType :unsigned-integer) (buf :pointer) (buflen :unsigned-long) (argv (:pointer :pointer)) (argvlen :unsigned-long) (flags :unsigned-long)) 
  :osstatus
   () )
                                              ; $ENDC

;   ***** AppleTalk ***** 
;   Shared library prefixes 

; ******************************************************************************
; ** Module definitions
; *******************************************************************************
;   XTI Levels 

(defconstant $ATK_DDP :|DDP |)
(defconstant $ATK_AARP :|AARP|)
(defconstant $ATK_ATP :|ATP |)
(defconstant $ATK_ADSP :|ADSP|)
(defconstant $ATK_ASP :|ASP |)
(defconstant $ATK_PAP :|PAP |)
(defconstant $ATK_NBP :|NBP |)
(defconstant $ATK_ZIP :|ZIP |)

;   Module Names 

; 
; 	   Protocol-specific Options
; 	   NOTE:
; 	   All Protocols support OPT_CHECKSUM (Value is (unsigned long)T_YES/T_NO)
; 	   ATP supports OPT_RETRYCNT (# Retries, 0 = try once) and
; 	                OPT_INTERVAL (# Milliseconds to wait)
; 	

(defconstant $DDP_OPT_CHECKSUM #x600)
(defconstant $DDP_OPT_SRCADDR #x2101)           ;   DDP UnitDataReq Only - set src address, Value is DDPAddress  
(defconstant $ATP_OPT_REPLYCNT #x2110)          ;   AppleTalk - ATP Resp Pkt Ct Type, Value is (unsigned long)  pkt count  
(defconstant $ATP_OPT_DATALEN #x2111)           ;   AppleTalk - ATP Pkt Data Len Type, Value is (unsigned long) length  
(defconstant $ATP_OPT_RELTIMER #x2112)          ;   AppleTalk - ATP Release Timer Type, Value is (unsigned long) timer, (See Inside AppleTalk, second edition  
(defconstant $ATP_OPT_TRANID #x2113)            ;   Value is (unsigned long) Boolean, Used to request Transaction ID, Returned with Transaction ID on requests  
(defconstant $PAP_OPT_OPENRETRY #x2120)         ;   AppleTalk - PAP OpenConn Retry count, Value is (unsigned long) T_YES/T_NO  

;   Protocol-Specific Events 

; 
; 	   If you send the IOCTL: OTIoctl(I_OTGetMiscellaneousEvents, 1),
; 	   you will receive the T_ATALKxxx events on your endpoint.
; 	   NOTE: The endpoint does not need to be bound.
; 	

(defconstant $kAppleTalkEvent #x23010000)
(defconstant $T_GETMYZONECOMPLETE #x23010001)
(defconstant $T_GETLOCALZONESCOMPLETE #x23010002)
(defconstant $T_GETZONELISTCOMPLETE #x23010003)
(defconstant $T_GETATALKINFOCOMPLETE #x23010004)
(defconstant $T_ATALKROUTERDOWNEVENT #x23010033);   No routers have been seen for a while.  If the cookie is NULL, all routers are gone.  Otherwise, there is still an ARA router hanging around being used, and only the local cable has been  timed out. 
(defconstant $T_ATALKROUTERUPEVENT #x23010034)  ;   We didn't have a router, but now one has come up. Cookie is NULL for a normal router coming up, non-NULL for an ARA router coming on-line 
(defconstant $T_ATALKZONENAMECHANGEDEVENT #x23010035);   A Zone name change was issued from the router, so our AppleTalk Zone has changed. 
(defconstant $T_ATALKCONNECTIVITYCHANGEDEVENT #x23010036);   An ARA connection was established (cookie != NULL), or was disconnected (cookie == NULL) 
(defconstant $T_ATALKINTERNETAVAILABLEEVENT #x23010037);   A router has appeared, and our address is in the startup range.  Cookie is hi/lo of new cable range. 
(defconstant $T_ATALKCABLERANGECHANGEDEVENT #x23010038);   A router has appeared, and it's incompatible with our current address.  Cookie is hi/lo of new cable range. 

(defconstant $kAllATalkRoutersDown 0)           ;   This indicates that all routers are offline 
(defconstant $kLocalATalkRoutersDown -1)        ;   This indicates that all local routers went offline, but an ARA router is still active 
(defconstant $kARARouterDisconnected -2)        ;   This indicates that ARA was disconnected, do it's router went offline, and we have no local routers to fall back onto. 

(defconstant $kARARouterOnline -1)              ;   We had no local routers, but an ARA router is now online. 
(defconstant $kATalkRouterOnline 0)             ;   We had no routers, but a local router is now online 
(defconstant $kLocalATalkRouterOnline -2)       ;   We have an ARA router, but now we've seen a local router as well 

;   Protocol-specific IOCTLs 

(defconstant $ATALK_IOC_FULLSELFSEND #x542F)    ;   Turn on/off full self-send (it's automatic for non-backward-compatible links) 
(defconstant $ADSP_IOC_FORWARDRESET #x543C)     ;   ADSP Forward Reset 

;   Protocol-specific constants 

;   ECHO 

(defconstant $kECHO_TSDU 585)                   ;   Max. # of data bytes. 

;   NBP 

(defconstant $kNBPMaxNameLength 32)
(defconstant $kNBPMaxTypeLength 32)
(defconstant $kNBPMaxZoneLength 32)
(defconstant $kNBPSlushLength 9)                ;   Extra space for @, : and a few escape chars 
(defconstant $kNBPMaxEntityLength 99)
(defconstant $kNBPEntityBufferSize 105)
(defconstant $kNBPWildCard #x3D)                ;   NBP name and type match anything '=' 
(defconstant $kNBPImbeddedWildCard #xC5)        ;   NBP name and type match some '' 
(defconstant $kNBPDefaultZone #x2A)             ;   NBP default zone '*' 

;   ZIP 

(defconstant $kZIPMaxZoneLength 32)

(defconstant $kDDPAddressLength 8)              ;   value to use in netbuf.len field, Maximum length of AppleTalk address 
(defconstant $kNBPAddressLength 105)
(defconstant $kAppleTalkAddressLength 113)

; 	******************************************************************************
; 	** CLASS TAppleTalkServices
; 	*******************************************************************************	
                                              ; $IFC NOT OTKERNEL 
; 
; 	   Define the ATSvcRef type.  This type needs special
; 	   processing because in C++ it's a subclass of TProvider.
; 	   See the definition of TEndpointRef in "OpenTransport.h"
; 	   for the logic behind this definition.
; 	

(def-mactype :atsvcref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :atsvcrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:ATSvcRef parameter can be nil, it is changed to xx: ATSvcRefPtr 

(defconstant $kDefaultAppleTalkServicesPath -3)

; 
; 	   Under Carbon, OpenAppleTalkServices routines take a client context pointer.  Applications may pass NULL
; 	   after calling InitOpenTransport(kInitOTForApplicationMask, ...).  Non-applications must always pass a
; 	   valid client context.
; 	
; 
; 	 *  OTAsyncOpenAppleTalkServicesInContext()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;  *  OTOpenAppleTalkServicesInContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTAsyncOpenAppleTalkServicesInContext" 
      ((cfig :pointer) (flags :unsigned-long) (proc :pointer) (contextPtr :pointer) (clientContext :pointer)) 
  :osstatus
   () )                                         ; $IFC CALL_NOT_IN_CARBON ; 
;  *  OTAsyncOpenAppleTalkServices()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTOpenAppleTalkServicesInContext" 
      ((cfig :pointer) (flags :unsigned-long) (err (:pointer :signed-long)) (clientContext :pointer)) 
  :pointer
   () )                                         ; 
;  *  OTOpenAppleTalkServices()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OTAsyncOpenAppleTalkServices" 
      ((cfig :pointer) (flags :unsigned-long) (proc :pointer) (contextPtr :pointer)) 
  :osstatus
   () )
(deftrap-inline "_OTOpenAppleTalkServices" 
      ((cfig :pointer) (flags :unsigned-long) (err (:pointer :signed-long))) 
  :pointer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; $IFC OTCARBONAPPLICATION 
;   The following macro may be used by applications only. 
; $ENDC                                         ; OTCARBONAPPLICATION
;   Get the zone associated with the ATSvcRef 
; 
;  *  OTATalkGetMyZone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;    Get the list of available zones associated with the local cable
;    of the ATSvcRef
;                                               ; 
;  *  OTATalkGetLocalZones()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTATalkGetMyZone" 
      ((ref :pointer) (zone (:pointer :tnetbuf))) 
  :osstatus
   () )                                         ;   Get the list of all zones on the internet specified by the ATSvcRef ; 
;  *  OTATalkGetZoneList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTATalkGetLocalZones" 
      ((ref :pointer) (zones (:pointer :tnetbuf))) 
  :osstatus
   () )                                         ;   Stores an AppleTalkInfo structure into the TNetbuf (see later in this file) ; 
;  *  OTATalkGetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTATalkGetZoneList" 
      ((ref :pointer) (zones (:pointer :tnetbuf))) 
  :osstatus
   () )
(deftrap-inline "_OTATalkGetInfo" 
      ((ref :pointer) (info (:pointer :tnetbuf))) 
  :osstatus
   () )
                                             ; $ENDC

;   AppleTalk Addressing 
; 
;    The NBPEntity structure is used to manipulate NBP names without regard
;    to issues of what kind of "special" characters are in the name.
;    
;    When stored as an address in an NBPAddress or DDPNBPAddress, they are 
;    stored as a character string, which is currently just ASCII, but in the
;    future may be UniChar, or some other internationalizable scripting set.
;    The string following an NBPAddress or DDPNBPAddress is intended to be
;    suitable for showing to users, whereas NBPEntity is not.
;    WARNING: NBPAddress and DDPNBPAddress structures do not "know" the length
;    of the address.  That must have been obtained as part of a Lookup or
;    ResolveAddress call.
; 

(defconstant $AF_ATALK_FAMILY #x100)
(defconstant $AF_ATALK_DDP #x100)
(defconstant $AF_ATALK_DDPNBP #x101)
(defconstant $AF_ATALK_NBP #x102)
(defconstant $AF_ATALK_MNODE #x103)

(def-mactype :nbpentityptr (find-mactype '(:pointer :nbpentity)))
(defrecord NBPEntity 
   (fEntity (:array :unsigned-byte 99 :packed))
   )

(def-mactype :ddpaddressptr (find-mactype '(:pointer :ddpaddress)))
(defrecord DDPAddress 
   (fAddressType :unsigned-integer)             ;   One of the enums above 
   (fNetwork :unsigned-integer)
   (fNodeID :signed-byte)
   (fSocket :signed-byte)
   (fDDPType :signed-byte)
   (fPad :signed-byte)
   )

(def-mactype :nbpaddressptr (find-mactype '(:pointer :nbpaddress)))
(defrecord NBPAddress 
   (fAddressType :unsigned-integer)             ;   One of the enums above 
   (fNBPNameBuffer (:array :unsigned-byte 105 :packed))
   )

(def-mactype :ddpnbpaddressptr (find-mactype '(:pointer :ddpnbpaddress)))
(defrecord DDPNBPAddress 
   (fAddressType :unsigned-integer)             ;   One of the enums above 
   (fNetwork :unsigned-integer)
   (fNodeID :signed-byte)
   (fSocket :signed-byte)
   (fDDPType :signed-byte)
   (fPad :signed-byte)
   (fNBPNameBuffer (:array :unsigned-byte 105 :packed))
   )

;   These are some utility routines for dealing with NBP and DDP addresses.  

;   Functions to initialize the various AppleTalk Address types 
; 
; 	 *  OTInitDDPAddress()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;  *  OTInitNBPAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTInitDDPAddress" 
      ((addr (:pointer :ddpaddress)) (net :unsigned-integer) (node :signed-byte) (socket :signed-byte) (ddpType :signed-byte)) 
  nil
   () )                                         ; 
;  *  OTInitDDPNBPAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTInitNBPAddress" 
      ((addr (:pointer :nbpaddress)) (name :pointer)) 
  :unsigned-long
   () )                                         ;   Compare 2 DDP addresses for equality ; 
;  *  OTCompareDDPAddresses()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTInitDDPNBPAddress" 
      ((addr (:pointer :ddpnbpaddress)) (name :pointer) (net :unsigned-integer) (node :signed-byte) (socket :signed-byte) (ddpType :signed-byte)) 
  :unsigned-long
   () )                                         ; CONST; CONST;   Init an NBPEntity to a NULL name ; 
;  *  OTInitNBPEntity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTCompareDDPAddresses" 
      ((addr1 (:pointer :ddpaddress)) (addr2 (:pointer :ddpaddress))) 
  :boolean
   () )                                         ;   Get the length an NBPEntity would have when stored as an address ; 
;  *  OTGetNBPEntityLengthAsAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTInitNBPEntity" 
      ((entity (:pointer :nbpentity))) 
  nil
   () )                                         ; CONST;   Store an NBPEntity into an address buffer ; 
;  *  OTSetAddressFromNBPEntity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTGetNBPEntityLengthAsAddress" 
      ((entity (:pointer :nbpentity))) 
  :unsigned-long
   () )                                         ; CONST;   Create an address buffer from a string (use -1 for len to use strlen) ; 
;  *  OTSetAddressFromNBPString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTSetAddressFromNBPEntity" 
      ((nameBuf (:pointer :unsigned-byte)) (entity (:pointer :nbpentity))) 
  :unsigned-long
   () )                                         ; 
;    Create an NBPEntity from an address buffer. False is returned if
;      the address was truncated.
;                                               ; 
;  *  OTSetNBPEntityFromAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTSetAddressFromNBPString" 
      ((addrBuf (:pointer :unsigned-byte)) (name :pointer) (len :signed-long)) 
  :unsigned-long
   () )                                         ; CONST;   Routines to set a piece of an NBP entity from a character string ; 
;  *  OTSetNBPName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTSetNBPEntityFromAddress" 
      ((entity (:pointer :nbpentity)) (addrBuf (:pointer :unsigned-byte)) (len :unsigned-long)) 
  :boolean
   () )                                         ; 
;  *  OTSetNBPType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTSetNBPName" 
      ((entity (:pointer :nbpentity)) (name :pointer)) 
  :boolean
   () )                                         ; 
;  *  OTSetNBPZone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTSetNBPType" 
      ((entity (:pointer :nbpentity)) (typeVal :pointer)) 
  :boolean
   () )                                         ;   Routines to extract pieces of an NBP entity ; 
;  *  OTExtractNBPName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTSetNBPZone" 
      ((entity (:pointer :nbpentity)) (zone :pointer)) 
  :boolean
   () )                                         ; CONST; 
;  *  OTExtractNBPType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTExtractNBPName" 
      ((entity (:pointer :nbpentity)) (name :pointer)) 
  nil
   () )                                         ; CONST; 
;  *  OTExtractNBPZone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_OTExtractNBPType" 
      ((entity (:pointer :nbpentity)) (typeVal :pointer)) 
  nil
   () )                                         ; CONST;   AppleTalkInfo as used by the OTGetATalkInfo function 
(deftrap-inline "_OTExtractNBPZone" 
      ((entity (:pointer :nbpentity)) (zone :pointer)) 
  nil
   () )
(def-mactype :appletalkinfoptr (find-mactype '(:pointer :appletalkinfo)))
(defrecord AppleTalkInfo 
   (fOurAddress :ddpaddress)                    ;   Our DDP address (network # & node) 
   (fRouterAddress :ddpaddress)                 ;   The address of a router on our cable 
   (fCableRange (:array :unsigned-integer 2))   ;   The current cable range 
   (fFlags :unsigned-integer)                   ;   See below 
   )

;   For the fFlags field in AppleTalkInfo 

(defconstant $kATalkInfoIsExtended #x1)         ;   This is an extended (phase 2) network 
(defconstant $kATalkInfoHasRouter #x2)          ;   This cable has a router 
(defconstant $kATalkInfoOneZone #x4)            ;   This cable has only one zone 

;   ***** Ethernet ***** 

;   Interface option flags 

;   Ethernet framing options 

(defconstant $kOTFramingEthernet #x1)
(defconstant $kOTFramingEthernetIPX #x2)
(defconstant $kOTFraming8023 #x4)
(defconstant $kOTFraming8022 #x8)

; 
; 	   These are obsolete and will be going away in OT 1.5.
; 	   Hmmm, OT 1.5 got cancelled.  The status of these options
; 	   is uncertain.
; 	

;   RawMode options 

(defconstant $kOTRawRcvOn 0)
(defconstant $kOTRawRcvOff 1)
(defconstant $kOTRawRcvOnWithTimeStamp 2)

(defconstant $DL_PROMISC_OFF 0)                 ;   OPT_SETPROMISCUOUS value 

;   Module definitions 

;   Module IDs 

(defconstant $kT8022ModuleID 7100)
(defconstant $kEnetModuleID 7101)
(defconstant $kTokenRingModuleID 7102)
(defconstant $kFDDIModuleID 7103)

;   Module Names 

;   Address Family 

(defconstant $AF_8022 8200)                     ;   Our 802.2 generic address family 

;   XTI Levels 

(defconstant $LNK_ENET :|ENET|)
(defconstant $LNK_TOKN :|TOKN|)
(defconstant $LNK_FDDI :|FDDI|)
(defconstant $LNK_TPI :|LTPI|)

;   Options 

(defconstant $OPT_ADDMCAST #x1000)
(defconstant $OPT_DELMCAST #x1001)
(defconstant $OPT_RCVPACKETTYPE #x1002)
(defconstant $OPT_RCVDESTADDR #x1003)
(defconstant $OPT_SETRAWMODE #x1004)
(defconstant $OPT_SETPROMISCUOUS #x1005)

(def-mactype :otpackettype (find-mactype ':unsigned-long))

(defconstant $kETypeStandard 0)
(defconstant $kETypeMulticast 1)
(defconstant $kETypeBroadcast 2)
(defconstant $kETRawPacketBit #x80000000)
(defconstant $kETTimeStampBit #x40000000)

;   Link related constants 

(defconstant $kMulticastLength 6)               ;   length of an ENET hardware addressaddress 
(defconstant $k48BitAddrLength 6)
(defconstant $k8022DLSAPLength 2)               ;   The protocol type is our DLSAP 
(defconstant $k8022SNAPLength 5)
(defconstant $kEnetAddressLength 8)             ;   length of an address field used by the ENET enpoint 
;      = k48BitAddrLength + sizeof(protocol type) 
(defconstant $kSNAPSAP #xAA)                    ;   Special DLSAPS for ENET 
(defconstant $kIPXSAP #xFF)
(defconstant $kMax8022SAP #xFE)
(defconstant $k8022GlobalSAP #xFF)
(defconstant $kMinDIXSAP 1501)
(defconstant $kMaxDIXSAP #xFFFF)

;   Generic Address Structure 

(def-mactype :t8022addressptr (find-mactype '(:pointer :t8022address)))
(defrecord T8022Address 
   (fAddrFamily :unsigned-integer)
   (fHWAddr (:array :unsigned-byte 6 :packed))
   (fSAP :unsigned-integer)
   (fSNAP (:array :unsigned-byte 5 :packed))
   )

(defconstant $k8022BasicAddressLength 10)
(defconstant $k8022SNAPAddressLength 15)

;   Some helpful stuff for dealing with 48 bit addresses 

;   Link related constants 

(defconstant $kEnetPacketHeaderLength 14)
(defconstant $kEnetTSDU 1514)                   ;   The TSDU for ethernet. 
(defconstant $kTokenRingTSDU 4458)              ;   The TSDU for TokenRing. 
(defconstant $kFDDITSDU 4458)                   ;   The TSDU for FDDI.  
(defconstant $k8022SAPLength 1)
(defconstant $k8022BasicHeaderLength 3)         ;   define the length of the header portion of an 802.2 packet. 
;   = SSAP+DSAP+ControlByte 
(defconstant $k8022SNAPHeaderLength 8)

; 	******************************************************************************
; 	** Address Types recognized by the Enet DLPI
; 	*******************************************************************************	

(def-mactype :eaddrtype (find-mactype ':unsigned-long))

(defconstant $keaStandardAddress 0)
(defconstant $keaMulticast 1)
(defconstant $keaBroadcast 2)
(defconstant $keaBadAddress 3)
(defconstant $keaRawPacketBit #x80000000)
(defconstant $keaTimeStampBit #x40000000)

;   Packet Header Structures 

(def-mactype :enetpacketheaderptr (find-mactype '(:pointer :enetpacketheader)))
(defrecord EnetPacketHeader 
   (fDestAddr (:array :unsigned-byte 6 :packed))
   (fSourceAddr (:array :unsigned-byte 6 :packed))
   (fProto :unsigned-integer)
   )

(def-mactype :t8022headerptr (find-mactype '(:pointer :t8022header)))
(defrecord T8022Header 
   (fDSAP :signed-byte)
   (fSSAP :signed-byte)
   (fCtrl :signed-byte)
   )

(def-mactype :t8022snapheaderptr (find-mactype '(:pointer :t8022snapheader)))
(defrecord T8022SNAPHeader 
   (fDSAP :signed-byte)
   (fSSAP :signed-byte)
   (fCtrl :signed-byte)
   (fSNAP (:array :unsigned-byte 5 :packed))
   )

(def-mactype :t8022fullpacketheaderptr (find-mactype '(:pointer :t8022fullpacketheader)))
(defrecord T8022FullPacketHeader 
   (fEnetPart :enetpacketheader)
   (f8022Part :t8022snapheader)
   )

;   Define the lengths of the structures above 

(defconstant $kT8022HeaderLength 3)
(defconstant $kT8022SNAPHeaderLength 8)
(defconstant $kT8022FullPacketHeaderLength 22)

;   ***** Serial ***** 

;   Module Definitions 

;   XTI Level 

(defconstant $COM_SERIAL :|SERL|)

;   Version Number 

;   Module Names 

(defconstant $kSerialABModuleID 7200)

(defconstant $kOTSerialFramingAsync #x1)        ;   Support Async serial mode          
(defconstant $kOTSerialFramingHDLC #x2)         ;   Support HDLC synchronous serial mode    
(defconstant $kOTSerialFramingSDLC #x4)         ;   Support SDLC synchronous serial mode    
(defconstant $kOTSerialFramingAsyncPackets #x8) ;   Support Async "packet" serial mode  
(defconstant $kOTSerialFramingPPP #x10)         ;   Port does its own PPP framing - wants unframed packets from PPP  

;   IOCTL Calls for Serial Drivers 

(defconstant $I_SetSerialDTR #x5500)            ;   Set DTR (0 = off, 1 = on) 
(defconstant $kOTSerialSetDTROff 0)
(defconstant $kOTSerialSetDTROn 1)
(defconstant $I_SetSerialBreak #x5501)          ;   Send a break on the line - kOTSerialSetBreakOff = off, kOTSerialSetBreakOn = on, 
;   Any other number is the number of milliseconds to leave break on, then 
;   auto shutoff 
(defconstant $kOTSerialSetBreakOn #xFFFFFFFF)
(defconstant $kOTSerialSetBreakOff 0)
(defconstant $I_SetSerialXOffState #x5502)      ;   Force XOFF state - 0 = Unconditionally clear XOFF state, 1 = unconditionally set it 
(defconstant $kOTSerialForceXOffTrue 1)
(defconstant $kOTSerialForceXOffFalse 0)
(defconstant $I_SetSerialXOn #x5503)            ;   Send an XON character, 0 = send only if in XOFF state, 1 = send always 
(defconstant $kOTSerialSendXOnAlways 1)
(defconstant $kOTSerialSendXOnIfXOffTrue 0)
(defconstant $I_SetSerialXOff #x5504)           ;   Send an XOFF character, 0 = send only if in XON state, 1 = send always 
(defconstant $kOTSerialSendXOffAlways 1)
(defconstant $kOTSerialSendXOffIfXOnTrue 0)

;   Option Management for Serial Drivers 

; 
; 	   These options are all 4-byte values.
; 	   BaudRate is the baud rate.
; 	   DataBits is the number of data bits.
; 	   StopBits is the number of stop bits times 10.
; 	   Parity is an enum
; 	

(defconstant $SERIAL_OPT_BAUDRATE #x100)        ;   UInt32  
(defconstant $SERIAL_OPT_DATABITS #x101)        ;   UInt32  
(defconstant $SERIAL_OPT_STOPBITS #x102)        ;   UInt32 10, 15 or 20 for 1, 1.5 or 2     
(defconstant $SERIAL_OPT_PARITY #x103)          ;   UInt32  
(defconstant $SERIAL_OPT_STATUS #x104)          ;   UInt32  
;   The "Status" option is a 4-byte value option that is ReadOnly 
;   It returns a bitmap of the current serial status 
(defconstant $SERIAL_OPT_HANDSHAKE #x105)       ;   UInt32  
;   The "Handshake" option defines what kind of handshaking the serial port 
;   will do for line flow control.  The value is a 32-bit value defined by 
;   the function or macro SerialHandshakeData below. 
;   For no handshake, or CTS handshake, the onChar and offChar parameters 
;   are ignored. 
(defconstant $SERIAL_OPT_RCVTIMEOUT #x106)      ;   The "RcvTimeout" option defines how long the receiver should wait before delivering 
;   less than the RcvLoWat number of characters.  If RcvLoWat is 0, then the RcvTimeout 
;   is how long a gap to wait for before delivering characters.  This parameter is advisory, 
;   and serial drivers are free to deliver data whenever they deem it convenient.  For instance, 
;   many serial drivers will deliver data whenever 64 bytes have been received, since 64 bytes 
;   is the smallest STREAMS buffer size. Keep in mind that timeouts are quantized, so be sure to 
;   look at the return value of the option to determine what it was negotiated to. 
(defconstant $SERIAL_OPT_ERRORCHARACTER #x107)  ;   This option defines how characters with parity errors are handled. 
;   A 0 value will disable all replacement.  A single character value in the low 
;   byte designates the replacement character.  When characters are received with a  
;   parity error, they are replaced by this specified character.  If a valid incoming 
;   character matches the replacement character, then the received character's msb is 
;   cleared. For this situation, the alternate character is used, if specified in bits 
;   8 through 15 of the option long, with 0xff being place in bits 16 through 23. 
;   Whenever a valid character is received that matches the first replacement character, 
;   it is replaced with this alternate character. 
(defconstant $SERIAL_OPT_EXTCLOCK #x108)        ;   The "ExtClock" requests an external clock.  A 0-value turns off external clocking. 
;   Any other value is a requested divisor for the external clock.  Be aware that 
;   not all serial implementations support an external clock, and that not all 
;   requested divisors will be supported if it does support an external clock. 
(defconstant $SERIAL_OPT_BURSTMODE #x109)       ;   The "BurstMode" option informs the serial driver that it should continue looping, 
;   reading incoming characters, rather than waiting for an interrupt for each character. 
;   This option may not be supported by all Serial driver 
(defconstant $SERIAL_OPT_DUMMY #x10A)           ;   placeholder 

(def-mactype :parityoptionvalues (find-mactype ':unsigned-long))

(defconstant $kOTSerialNoParity 0)
(defconstant $kOTSerialOddParity 1)
(defconstant $kOTSerialEvenParity 2)

(defconstant $kOTSerialSwOverRunErr #x1)
(defconstant $kOTSerialBreakOn #x8)
(defconstant $kOTSerialParityErr #x10)
(defconstant $kOTSerialOverrunErr #x20)
(defconstant $kOTSerialFramingErr #x40)
(defconstant $kOTSerialXOffSent #x10000)
(defconstant $kOTSerialDTRNegated #x20000)
(defconstant $kOTSerialCTLHold #x40000)
(defconstant $kOTSerialXOffHold #x80000)
(defconstant $kOTSerialOutputBreakOn #x1000000)

(defconstant $kOTSerialXOnOffInputHandshake 1)  ;   Want XOn/XOff handshake for incoming characters     
(defconstant $kOTSerialXOnOffOutputHandshake 2) ;   Want XOn/XOff handshake for outgoing characters     
(defconstant $kOTSerialCTSInputHandshake 4)     ;   Want CTS handshake for incoming characters      
(defconstant $kOTSerialDTROutputHandshake 8)    ;   Want DTR handshake for outoing characters    

;   Default attributes for the serial ports 

(defconstant $kOTSerialDefaultBaudRate 19200)
(defconstant $kOTSerialDefaultDataBits 8)
(defconstant $kOTSerialDefaultStopBits 10)
(defconstant $kOTSerialDefaultParity 0)
(defconstant $kOTSerialDefaultHandshake 0)
(defconstant $kOTSerialDefaultOnChar 17)
(defconstant $kOTSerialDefaultOffChar 19)
(defconstant $kOTSerialDefaultSndBufSize 1024)
(defconstant $kOTSerialDefaultRcvBufSize 1024)
(defconstant $kOTSerialDefaultSndLoWat 96)
(defconstant $kOTSerialDefaultRcvLoWat 1)
(defconstant $kOTSerialDefaultRcvTimeout 10)

;   ***** ISDN ***** 

;   Module Definitions 

;   XTI Level 

(defconstant $COM_ISDN :|ISDN|)

;   Module Names 

(defconstant $kISDNModuleID 7300)

;   ISDN framing methods, set using the I_OTSetFramingType IOCTL 

(defconstant $kOTISDNFramingTransparentSupported #x10);   Support Transparent mode     
(defconstant $kOTISDNFramingHDLCSupported #x20) ;   Support HDLC Synchronous mode   
(defconstant $kOTISDNFramingV110Supported #x40) ;   Support V.110 Asynchronous mode     
(defconstant $kOTISDNFramingV14ESupported #x80) ;   Support V.14 Asynchronous mode      

;   Miscellaneous equates 

;   Disconnect reason codes (from Q.931) 

(defconstant $kOTISDNUnallocatedNumber 1)
(defconstant $kOTISDNNoRouteToSpecifiedTransitNetwork 2)
(defconstant $kOTISDNNoRouteToDestination 3)
(defconstant $kOTISDNChannelUnacceptable 6)
(defconstant $kOTISDNNormal 16)
(defconstant $kOTISDNUserBusy 17)
(defconstant $kOTISDNNoUserResponding 18)
(defconstant $kOTISDNNoAnswerFromUser 19)
(defconstant $kOTISDNCallRejected 21)
(defconstant $kOTISDNNumberChanged 22)
(defconstant $kOTISDNNonSelectedUserClearing 26)
(defconstant $kOTISDNDestinationOutOfOrder 27)
(defconstant $kOTISDNInvalidNumberFormat 28)
(defconstant $kOTISDNFacilityRejected 29)
(defconstant $kOTISDNNormalUnspecified 31)
(defconstant $kOTISDNNoCircuitChannelAvailable 34)
(defconstant $kOTISDNNetworkOutOfOrder 41)
(defconstant $kOTISDNSwitchingEquipmentCongestion 42)
(defconstant $kOTISDNAccessInformationDiscarded 43)
(defconstant $kOTISDNRequestedCircuitChannelNotAvailable 44)
(defconstant $kOTISDNResourceUnavailableUnspecified 45)
(defconstant $kOTISDNQualityOfServiceUnvailable 49)
(defconstant $kOTISDNRequestedFacilityNotSubscribed 50)
(defconstant $kOTISDNBearerCapabilityNotAuthorized 57)
(defconstant $kOTISDNBearerCapabilityNotPresentlyAvailable 58)
(defconstant $kOTISDNCallRestricted 59)
(defconstant $kOTISDNServiceOrOptionNotAvilableUnspecified 63)
(defconstant $kOTISDNBearerCapabilityNotImplemented 65)
(defconstant $kOTISDNRequestedFacilityNotImplemented 69)
(defconstant $kOTISDNOnlyRestrictedDigitalBearer 70)
(defconstant $kOTISDNServiceOrOptionNotImplementedUnspecified 79)
(defconstant $kOTISDNCallIdentityNotUsed 83)
(defconstant $kOTISDNCallIdentityInUse 84)
(defconstant $kOTISDNNoCallSuspended 85)
(defconstant $kOTISDNCallIdentityCleared 86)
(defconstant $kOTISDNIncompatibleDestination 88)
(defconstant $kOTISDNInvalidTransitNetworkSelection 91)
(defconstant $kOTISDNInvalidMessageUnspecified 95)
(defconstant $kOTISDNMandatoryInformationElementIsMissing 96)
(defconstant $kOTISDNMessageTypeNonExistentOrNotImplemented 97)
(defconstant $kOTISDNInterworkingUnspecified 127)

;   OTISDNAddress 

; 
; 	   The OTISDNAddress has the following format:
; 	   "xxxxxx*yy"
; 	   where 'x' is the phone number and 'y' is the sub address (if available
; 	   in the network. The characters are coded in ASCII (IA5), and valid
; 	   characters are: '0'-'9','#','*'.
; 	   The max length of the each phone number is 21 characters (?) and the max
; 	   subaddress length is network dependent.
; 	   When using bonded channels the phone numbers are separated by '&'.
; 	   The X.25 user data is preceded by '@'.
; 	

(defconstant $kAF_ISDN #x2000)

(defconstant $AF_ISDN #x2000)

(defconstant $kOTISDNMaxPhoneSize 32)
(defconstant $kOTISDNMaxSubSize 4)

(def-mactype :otisdnaddressptr (find-mactype '(:pointer :otisdnaddress)))
(defrecord OTISDNAddress 
   (fAddressType :unsigned-integer)
   (fPhoneLength :unsigned-integer)
   (fPhoneNumber (:array :character 37 :packed))
   )

;   IOCTL Calls for ISDN 
;   ISDN shares the same ioctl space as serial. 

(defconstant $MIOC_ISDN 85)                     ;   ISDN ioctl() cmds  

(defconstant $I_OTISDNAlerting #x5564)          ;   Send or receive an ALERTING message 
(defconstant $I_OTISDNSuspend #x5565)           ;   Send a SUSPEND message 
;   The parameter is the Call Identity (Maximum 8 octets) 
(defconstant $I_OTISDNSuspendAcknowledge #x5566);   Receive a SUSPEND ACKNOWLEDGE message 
(defconstant $I_OTISDNSuspendReject #x5567)     ;   Receive a SUSPEND REJECT message 
(defconstant $I_OTISDNResume #x5568)            ;   Send a RESUME message 
;   The parameter is the Call Identity (Maximum 8 octets) 
(defconstant $I_OTISDNResumeAcknowledge #x5569) ;   Receive a RESUME ACKNOWLEDGE message 
(defconstant $I_OTISDNResumeReject #x556A)      ;   Receive a RESUME REJECT message 
(defconstant $I_OTISDNFaciltity #x556B)         ;   Send or receive a FACILITY message 

;   Connect user data size 

(defconstant $kOTISDNMaxUserDataSize 32)

;   Option management calls for ISDN 

(defconstant $ISDN_OPT_COMMTYPE #x200)
(defconstant $ISDN_OPT_FRAMINGTYPE #x201)
(defconstant $ISDN_OPT_56KADAPTATION #x202)

;   For ISDN_OPT_COMMTYPE... 

(defconstant $kOTISDNTelephoneALaw 1)           ;   G.711 A-law                 
(defconstant $kOTISDNTelephoneMuLaw 26)         ;   G.711 -law                 
(defconstant $kOTISDNDigital64k 13)             ;   unrestricted digital (default)      
(defconstant $kOTISDNDigital56k 37)             ;   user rate 56Kb/s            
(defconstant $kOTISDNVideo64k 41)               ;   video terminal at 64Kb/s     
(defconstant $kOTISDNVideo56k 42)               ;   video terminal at 56Kb/s     

;   For ISDN_OPT_FRAMINGTYPE... 

(defconstant $kOTISDNFramingTransparent #x10)   ;   Transparent mode            
(defconstant $kOTISDNFramingHDLC #x20)          ;   HDLC synchronous mode (default)     
(defconstant $kOTISDNFramingV110 #x40)          ;   V.110 asynchronous mode        
(defconstant $kOTISDNFramingV14E #x80)          ;   V.14E asynchronous mode          

;   For ISDN_OPT_56KADAPTATION... 

(defconstant $kOTISDNNot56KAdaptation #$false)  ;   not 56K Adaptation (default)      
(defconstant $kOTISDN56KAdaptation #$true)      ;   56K Adaptation            

;   Default options, you do not need to set these 

(defconstant $kOTISDNDefaultCommType 13)
(defconstant $kOTISDNDefaultFramingType #x20)
(defconstant $kOTISDNDefault56KAdaptation 0)

; 	******************************************************************************
; 	*   Constants for Open Transport-based Remote Access/PPP API
; 	*******************************************************************************	

;   OTCreateConfiguration name for PPP control endpoint 

;   XTI Level 

(defconstant $COM_PPP :|PPPC|)

;   Options limits 

(defconstant $kPPPMaxIDLength 255)
(defconstant $kPPPMaxPasswordLength 255)
(defconstant $kPPPMaxDTEAddressLength 127)
(defconstant $kPPPMaxCallInfoLength 255)

;   Various XTI option value constants 

(defconstant $kPPPStateInitial 1)
(defconstant $kPPPStateClosed 2)
(defconstant $kPPPStateClosing 3)
(defconstant $kPPPStateOpening 4)
(defconstant $kPPPStateOpened 5)

(defconstant $kPPPConnectionStatusIdle 1)
(defconstant $kPPPConnectionStatusConnecting 2)
(defconstant $kPPPConnectionStatusConnected 3)
(defconstant $kPPPConnectionStatusDisconnecting 4)

(defconstant $kPPPMinMRU 0)
(defconstant $kPPPMaxMRU 4500)

(defconstant $kIPCPTCPHdrCompressionDisabled 0)
(defconstant $kIPCPTCPHdrCompressionEnabled 1)

(defconstant $kPPPCompressionDisabled #x0)
(defconstant $kPPPProtoCompression #x1)
(defconstant $kPPPAddrCompression #x2)

(defconstant $kPPPNoOutAuthentication 0)
(defconstant $kPPPCHAPOrPAPOutAuthentication 1)

(defconstant $kCCReminderTimerDisabled 0)
(defconstant $kCCIPIdleTimerDisabled 0)

(defconstant $kPPPScriptTypeModem 1)
(defconstant $kPPPScriptTypeConnect 2)
(defconstant $kPPPMaxScriptSize 32000)

(defconstant $kE164Address 1)
(defconstant $kPhoneAddress 1)
(defconstant $kCompoundPhoneAddress 2)
(defconstant $kX121Address 3)

(defconstant $kPPPConnectionStatusDialogsFlag #x1)
(defconstant $kPPPConnectionRemindersFlag #x2)
(defconstant $kPPPConnectionFlashingIconFlag #x4)
(defconstant $kPPPOutPasswordDialogsFlag #x8)
(defconstant $kPPPAllAlertsDisabledFlag #x0)
(defconstant $kPPPAllAlertsEnabledFlag #xF)

(defconstant $kPPPAsyncMapCharsNone #x0)
(defconstant $kPPPAsyncMapCharsXOnXOff #xA0000)
(defconstant $kPPPAsyncMapCharsAll #xFFFFFFFF)

;   Option names 

(defconstant $IPCP_OPT_GETREMOTEPROTOADDR #x7000)
(defconstant $IPCP_OPT_GETLOCALPROTOADDR #x7001)
(defconstant $IPCP_OPT_TCPHDRCOMPRESSION #x7002)
(defconstant $LCP_OPT_PPPCOMPRESSION #x7003)
(defconstant $LCP_OPT_MRU #x7004)
(defconstant $LCP_OPT_RCACCMAP #x7005)
(defconstant $LCP_OPT_TXACCMAP #x7006)
(defconstant $SEC_OPT_OUTAUTHENTICATION #x7007)
(defconstant $SEC_OPT_ID #x7008)
(defconstant $SEC_OPT_PASSWORD #x7009)
(defconstant $CC_OPT_REMINDERTIMER #x7010)
(defconstant $CC_OPT_IPIDLETIMER #x7011)
(defconstant $CC_OPT_DTEADDRESSTYPE #x7012)
(defconstant $CC_OPT_DTEADDRESS #x7013)
(defconstant $CC_OPT_CALLINFO #x7014)
(defconstant $CC_OPT_GETMISCINFO #x7015)
(defconstant $PPP_OPT_GETCURRENTSTATE #x7016)
(defconstant $LCP_OPT_ECHO #x7017)              ;   Available on Mac OS X only  
(defconstant $CC_OPT_SERIALPORTNAME #x7200)

;   Endpoint events 

(defconstant $kPPPEvent #x230F0000)
(defconstant $kPPPConnectCompleteEvent #x230F0001)
(defconstant $kPPPSetScriptCompleteEvent #x230F0002)
(defconstant $kPPPDisconnectCompleteEvent #x230F0003)
(defconstant $kPPPDisconnectEvent #x230F0004)
(defconstant $kPPPIPCPUpEvent #x230F0005)
(defconstant $kPPPIPCPDownEvent #x230F0006)
(defconstant $kPPPLCPUpEvent #x230F0007)
(defconstant $kPPPLCPDownEvent #x230F0008)
(defconstant $kPPPLowerLayerUpEvent #x230F0009)
(defconstant $kPPPLowerLayerDownEvent #x230F000A)
(defconstant $kPPPAuthenticationStartedEvent #x230F000B)
(defconstant $kPPPAuthenticationFinishedEvent #x230F000C)
(defconstant $kPPPDCEInitStartedEvent #x230F000D)
(defconstant $kPPPDCEInitFinishedEvent #x230F000E)
(defconstant $kPPPDCECallStartedEvent #x230F000F)
(defconstant $kPPPDCECallFinishedEvent #x230F0010)

; $IFC CALL_NOT_IN_CARBON 
; $ENDC                                         ; CALL_NOT_IN_CARBON

; 	******************************************************************************
; 	*   IOCTL constants for I_OTConnect, I_OTDisconnect and I_OTScript
; 	*   are defined in OpenTransport.h
; 	*******************************************************************************	

; 	******************************************************************************
; 	*   PPPMRULimits
; 	*******************************************************************************	

(def-mactype :pppmrulimitsptr (find-mactype '(:pointer :pppmrulimits)))
(defrecord PPPMRULimits 
   (mruSize :unsigned-long)                     ;   proposed or actual 
   (upperMRULimit :unsigned-long)
   (lowerMRULimit :unsigned-long)
   )

; 	******************************************************************************
; 	*   CCMiscInfo
; 	*******************************************************************************	
(def-mactype :ccmiscinfoptr (find-mactype '(:pointer :ccmiscinfo)))
(defrecord CCMiscInfo 
   (connectionStatus :unsigned-long)
   (connectionTimeElapsed :unsigned-long)
   (connectionTimeRemaining :unsigned-long)
   (bytesTransmitted :unsigned-long)
   (bytesReceived :unsigned-long)
   (reserved :unsigned-long)
   )

; 	******************************************************************************
; 	*   LCPEcho
; 	*******************************************************************************	
;   Set both fields to zero to disable sending of LCP echo requests 

(def-mactype :lcpechoptr (find-mactype '(:pointer :lcpecho)))
(defrecord LCPEcho 
   (retryCount :unsigned-long)
   (retryPeriod :unsigned-long)                 ;   in milliseconds 
   )

; 	******************************************************************************
; 	*   Bits used to tell kind of product
; 	*******************************************************************************	

(defconstant $kRAProductClientOnly 2)
(defconstant $kRAProductOnePortServer 3)
(defconstant $kRAProductManyPortServer 4)

; $ifc not undefined MWERKS and TARGET_CPU_68K
; $pragmac d0_pointers reset
; $endc

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := OpenTransportProvidersIncludes

; $ENDC                                         ; __OPENTRANSPORTPROVIDERS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'OpenTransportProviders)