(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:PCCard.p"
; at Wednesday May 1,2002 2:42:15 pm.
; 
;      File:       PCCard.p
;  
;      Contains:   PC Card Family Programming interface
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1996-2001 by Apple Computer, Inc.  All rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __PCCARD__
; $SETC __PCCARD__ := 1

; $I+
; $SETC PCCardIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __NAMEREGISTRY__
|#

(require-interface 'NameRegistry)
#|                                              ; $I NameRegistry.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

(defconstant $kServiceCategoryPCCard :|pccd|)

(def-mactype :pccardevent (find-mactype ':unsigned-long))
(def-mactype :pccardeventmask (find-mactype ':unsigned-long))
(def-mactype :pccardclientid (find-mactype ':unsigned-long))
(def-mactype :pccardtimerid (find-mactype ':unsigned-long))
(def-mactype :pccardsocket (find-mactype ':unsigned-long))
(def-mactype :pccardwindowid (find-mactype ':unsigned-long))
(def-mactype :pccardwindowtype (find-mactype ':unsigned-long))
(def-mactype :pccardwindowsize (find-mactype ':unsigned-long))
(def-mactype :pccardwindowoffset (find-mactype ':unsigned-long))
(def-mactype :pccardwindowalign (find-mactype ':unsigned-long))
(def-mactype :pccardwindowstate (find-mactype ':unsigned-long))
(def-mactype :pccardaccessspeed (find-mactype ':unsigned-long))
(def-mactype :pccardwindowparam (find-mactype ':unsigned-long))
(def-mactype :pccardpage (find-mactype ':unsigned-long))
(def-mactype :pccardvoltage (find-mactype ':unsigned-long))
; 	
; 	    Several of the client notification bit flags have been REMOVED since the first
; 	    release of this header.  These were unused codes that were either
; 	    copied directly from PC Card 2.x, or from the PCMCIA standard.  In all cases,
; 	    they were completely unimplemented and would never be sent under PCCard 3.0.
; 	    
; 	    The removed flags are:
; 	        kPCCardClientInfoMessage, kPCCardSSUpdatedMessage,
; 	        and kPCCardFunctionInterruptMessage.
; 	    
; 	    If your software used any of these flags, you should delete any references
; 	    to them.  These event codes are being recycled for new features.
; 		
; 	 Client notification bit flags 	

(defconstant $kPCCardNullMessage #x0)           ;   no messages pending (not sent to clients) 
(defconstant $kPCCardInsertionMessage #x1)      ;   card has been inserted into the socket 
(defconstant $kPCCardRemovalMessage #x2)        ;   card has been removed from the socket- do not touch hardware! 
;   Lock and Unlock may be used for a hardware locking card-cage.  
(defconstant $kPCCardLockMessage #x4)           ;   card is locked into the socket with a mechanical latch  
(defconstant $kPCCardUnlockMessage #x8)         ;   card is no longer locked into the socket  
;   Ready and Reset are holdovers from PC Card 2.x, but someone might be using them (!?)  
(defconstant $kPCCardReadyMessage #x10)         ;   card is ready to be accessed -- do not use! this event is never sent! (use kPCCardInsertion instead)  
(defconstant $kPCCardResetMessage #x20)         ;   physical reset has completed -- do not use! this event is never sent! (use kPCCardResetComplete instead)  
;   InsertionRequest and InsertionComplete may be used with certain cages (??)  
(defconstant $kPCCardInsertionRequestMessage #x40);   request to insert a card using insertion motor  
(defconstant $kPCCardInsertionCompleteMessage #x80);   insertion motor has finished inserting a card  
(defconstant $kPCCardEjectionRequestMessage #x100);   user or other client is requesting a card ejection 
(defconstant $kPCCardEjectionCompleteMessage #x200);   card ejection succeeded- do not touch hardware!  
(defconstant $kPCCardEjectionFailedMessage #x400);   eject failure due to electrical/mechanical problems 
(defconstant $kPCCardPMResumeMessage #x800)     ;   power management resume  
(defconstant $kPCCardPMSuspendMessage #x1000)   ;   power management suspend  
(defconstant $kPCCardPMSuspendRequest #x2000)   ;   power management sleep request  
(defconstant $kPCCardPMSuspendRevoke #x4000)    ;   power management sleep revoke  
(defconstant $kPCCardResetPhysicalMessage #x8000);   physical reset is about to occur on this card -- this event is never sent!  
(defconstant $kPCCardResetRequestMessage #x10000);   physical reset has been requested by a client 
(defconstant $kPCCardResetCompleteMessage #x20000);   ResetCard() background reset has completed 
(defconstant $kPCCardBatteryDeadMessage #x40000);   battery is no longer useable, data will be lost 
(defconstant $kPCCardBatteryLowMessage #x80000) ;   battery is weak and should be replaced 
(defconstant $kPCCardWriteProtectMessage #x100000);   card is now write protected 
(defconstant $kPCCardWriteEnabledMessage #x200000);   card is now write enabled 
(defconstant $kPCCardDisplayEjectDSATMessage #x400000);   about to display a DSAT for the user to re-insert a manually ejected card  
(defconstant $kPCCardUnexpectedRemovalMessage #x2000000);   card has unexpectedly been manually ejected  
;   Unconfigured is a (currently unused) holdover from PC Card 2.x  
(defconstant $kPCCardUnconfiguredMessage #x4000000);   a CARD_READY was delivered to all clients and no client  
;      requested a configuration for the socket -- this event is never sent under PCCard 3.0!  
(defconstant $kPCCardStatusChangedMessage #x8000000);   status change for cards in I/O mode 
(defconstant $kPCCardTimerExpiredMessage #x10000000);   message sent when requested time has expired  
(defconstant $kPCCardRequestAttentionMessage #x20000000)
(defconstant $kPCCardEraseCompleteMessage #x40000000)
(defconstant $kPCCardRegistrationCompleteMessage #x80000000);   notifications available only in PCCard 3.1 and later  
(defconstant $kPCCardPMEnabledMessage #x800000) ;   power management has been enabled by the user; if appropriate, clients should call PCCardSetPowerLevel(off)  

(def-mactype :pccardwindowattributes (find-mactype ':unsigned-long))
; 	  window state (values of PCCardWindowAttributes) 	

(defconstant $kWSCommon #x1)                    ;   common memory window  
(defconstant $kWSAttribute #x2)                 ;   attribute memory window 
(defconstant $kWSIO #x4)                        ;   I/O window 
(defconstant $kWSCardBus #x800)                 ;   CardBus bridge window  
(defconstant $kWSTypeMask #x807)                ;   window type mask 
(defconstant $kWSEnabled #x8)                   ;   window enabled 
(defconstant $kWS8bit #x10)                     ;   8-bit data width window 
(defconstant $kWS16bit #x20)                    ;   16-bit data width window 
(defconstant $kWS32bit #x40)                    ;   32-bit data width window 
(defconstant $kWSAutoSize #x80)                 ;   auto-size data width window 
(defconstant $kWSWidthMask #xF0)                ;   window data width mask 
(defconstant $kWSProtected #x100)               ;   window write protected 
(defconstant $kWSPrefetchable #x200)            ;   bridge window prefetchable 
(defconstant $kWSPageShared #x400)              ;   page register is shared 
(defconstant $kWSWindowSizeOffset #x4000)
(defconstant $kWSChangeAccessSpeed #x8000)      ;   Used by CSModifyWindow only  

; 	 window speed (sample values of PCCardAccessSpeed) for use in PCCardRequestWindow  	
(defconstant $kAccessSpeed600ns #x6A)
(defconstant $kAccessSpeed500ns #x5A)
(defconstant $kAccessSpeed400ns #x4A)
(defconstant $kAccessSpeed300ns #x3A)
(defconstant $kAccessSpeed250ns #x1)
(defconstant $kAccessSpeed200ns #x2)
(defconstant $kAccessSpeed150ns #x3)
(defconstant $kAccessSpeed100ns #x4)

(def-mactype :pccardinterfacetype (find-mactype ':unsigned-long))
; 	 InterfaceType bit-mask (values of PCCardInterfaceType) 	

(defconstant $kIFTypeMask #x3)                  ;   IO & memory type mask 
(defconstant $kIFCardBus #x0)                   ;   if bits 0 & 1 are zero then cardbus interface 
(defconstant $kIFMemory #x1)                    ;   if bit 0 set memory IF 
(defconstant $kIFIO #x2)                        ;   if bit 1 set IO IF 
(defconstant $kIFReserved #x3)                  ;   bits 0 and 1 set is reserved  
(defconstant $kIFDMA #x8)                       ;   if bit 3 set DMA supported 
(defconstant $kIFVSKey #x10)                    ;   if bit 4 set supports low Voltage key 
(defconstant $kIF33VCC #x20)                    ;   if bit 5 set socket suports 3.3v 
(defconstant $kIFXXVCC #x40)                    ;   if bit 6 set socket supports X.X voltage 
(defconstant $kIFYYVCC #x80)                    ;   if bit 7 set socket supports Y.Y voltage 

(def-mactype :pccardcustominterfaceid (find-mactype ':unsigned-long))
; 	 Custom Interface Identifiers (values of PCCardCustomInterfaceID) 	

(defconstant $kIFCustom_None #x0)               ;   no custom interface ID  
(defconstant $kIFCustom_ZOOM #x41)              ;   ZOOM Video Mode custom interface identifier  

(def-mactype :pccardconfigoptions (find-mactype ':unsigned-long))
; 	 Bit mask values for PCCardConfigOptions in the configuration calls 	

(defconstant $kEnableIRQSteering #x2)
(defconstant $kIRQChangeValid #x4)
(defconstant $kVppChangeValid #x10)
(defconstant $kEnableDMAChannel #x40)
(defconstant $kDMAChangeValid #x80)
(defconstant $kVSOverride #x200)                ;   Bits 10..31 reserved  

; 
; 	   Configuration Registers Presence Mask for the FCR
; 	   Used by PCCardConfigPresentMask
; 	
(defconstant $kConfigOptionPresent #x1)
(defconstant $kConfigStatusPresent #x2)
(defconstant $kPinReplacePresent #x4)
(defconstant $kSocketCopyPresent #x8)
(defconstant $kExtendedStatusPresent #x10)
(defconstant $kIOBase0Present #x20)
(defconstant $kIOBase1Present #x40)
(defconstant $kIOBase2Present #x80)
(defconstant $kIOBase3Present #x100)
(defconstant $kIOLimitPresent #x200)

(def-mactype :pccardconfigpresentmask (find-mactype ':unsigned-long))
(def-mactype :pccardconfigregisterindex (find-mactype ':unsigned-long))
(def-mactype :pccardconfigregisteroffset (find-mactype ':unsigned-long))
(def-mactype :pccardfunctionconfigregptr (find-mactype '(:pointer :pccardfunctionconfigreg)))
(defrecord PCCardFunctionConfigReg 
   (configOptionReg :signed-byte)
   (configStatusReg :signed-byte)
   (pinReplaceReg :signed-byte)
   (socketCopyReg :signed-byte)
   (extendedStatusReg :signed-byte)
   (ioBase0 :signed-byte)
   (ioBase1 :signed-byte)
   (ioBase2 :signed-byte)
   (ioBase3 :signed-byte)
   (ioLimit :signed-byte)
   )

(def-mactype :pccardsocketstatus (find-mactype ':unsigned-long))
; 	  general socket status bits (values of PCCardSocketStatus) 	

(defconstant $kSTBatteryDead #x1)               ;   battery dead 
(defconstant $kSTBatteryLow #x2)                ;   battery low 
(defconstant $kSTBatteryGood #x4)               ;   battery good 
(defconstant $kSTPower #x8)                     ;   power is applied 
(defconstant $kST16bit #x10)                    ;   16-bit PC Card present 
(defconstant $kSTCardBus #x20)                  ;   CardBus PC Card present 
(defconstant $kSTMemoryCard #x40)               ;   memory card present 
(defconstant $kSTIOCard #x80)                   ;   I/O card present 
(defconstant $kSTNotACard #x100)                ;   unrecognizable PC Card detected 
(defconstant $kSTReady #x200)                   ;   ready 
(defconstant $kSTWriteProtect #x400)            ;   card is write-protected 
(defconstant $kSTDataLost #x800)                ;   data may have been lost due to card removal 
(defconstant $kSTRingIndicate #x1000)           ;   ring indicator is active 
(defconstant $kSTReserved #xE000)

; 	 Bit mask for PCCardPowerOptions in the power management calls 	

(def-mactype :pccardpoweroptions (find-mactype ':unsigned-long))

(defconstant $kPCCardPowerOn #x1)
(defconstant $kPCCardPowerOff #x2)
(defconstant $kPCCardLowPower #x4)

(def-mactype :pccardadaptercapabilities (find-mactype ':unsigned-long))
(def-mactype :pccardadapterpowerstate (find-mactype ':unsigned-long))
(def-mactype :pccardscevents (find-mactype ':unsigned-long))
(def-mactype :pccardwindow (find-mactype ':unsigned-long))
(def-mactype :pccardirq (find-mactype ':unsigned-long))
(def-mactype :pccarddma (find-mactype ':unsigned-long))
; 	 Selectors for PCCardGetGlobalOptions 	
; 	  The type of the "value" parameter is provided for each selector. 	
(def-mactype :pccardoptionselector (find-mactype ':unsigned-long))

(defconstant $kPCCardPowerManagementAttrib 1)   ;   value = (Boolean*) enabled   

;   Types and structures for accessing the PCCard Assigned-Address property. 

(defconstant $kPCCardNonRelocatableSpace #x80)
(defconstant $kPCCardPrefetchableSpace #x40)
(defconstant $kPCCard16BitSpace #x20)
(defconstant $kPCCardAddressTypeCodeMask #x7)
(defconstant $kPCCardConfigSpace 0)
(defconstant $kPCCardIOSpace 1)
(defconstant $kPCCardMemorySpace 2)
(defconstant $kPCCardAttributeMemorySpace 4)

(def-mactype :pccardaddressspaceflags (find-mactype ':unsigned-byte))

(defconstant $kPCCardSocketNumberMask #xF8)
(defconstant $kPCCardFunctionNumberMask #x7)

(def-mactype :pccardsocketfunction (find-mactype ':unsigned-byte))
(def-mactype :pccardbusnumber (find-mactype ':unsigned-byte))
(def-mactype :pccardregisternumber (find-mactype ':unsigned-byte))
; 
; 	   note: this structure is similar, but not the same as the PCIAssignedAddress structure
; 	         16-bit cards use this structure, CardBus cards use PCIAssignedAddress
; 	
(def-mactype :pccardassignedaddressptr (find-mactype '(:pointer :pccardassignedaddress)))
(defrecord PCCardAssignedAddress 
   (addressSpaceFlags :unsigned-byte)
   (reserved :unsigned-byte)
   (socketFunctionNumber :unsigned-byte)
   (registerNumber :unsigned-byte)
   (address :unsigned-long)
   (size :unsigned-long)
   )

; 	----------------------------------------------------------------------
; 	    Client Support
; 	----------------------------------------------------------------------	
; 	 Prototype for client callback 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	PCCardEventHandler = FUNCTION(theEvent: PCCardEvent; vSocket: PCCardSocket; device: UInt32; info: UInt32; MTDRequest: UInt32; VAR Buffer: UInt32; misc: UInt32; status: UInt32; clientParam: UNIV Ptr): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :pccardeventhandler (find-mactype ':pointer))
; $ENDC

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  PCCardRegisterClient()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in PCCard 3.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_PCCardRegisterClient" 
      ((deviceRef (:pointer :regentryid)) (eventMask :unsigned-long) (clientCallBack :pointer) (clientParam :pointer) (newClientID (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  PCCardDeRegisterClient()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PCCardDeRegisterClient" 
      ((theClientID :unsigned-long)) 
  :osstatus
   () )

; 
;  *  PCCardRegisterTimer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PCCardRegisterTimer" 
      ((registeredClientID :unsigned-long) (lpNewTimerID (:pointer :unsigned-long)) (delay :signed-long)) 
  :osstatus
   () )

; 
;  *  PCCardDeRegisterTimer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PCCardDeRegisterTimer" 
      ((timerID :unsigned-long)) 
  nil
   () )

; 
;  *  PCCardSetEventMask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PCCardSetEventMask" 
      ((theClientID :unsigned-long) (newEventMask :unsigned-long)) 
  :osstatus
   () )

; 
;  *  PCCardGetEventMask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PCCardGetEventMask" 
      ((theClientID :unsigned-long) (newEventMask (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  PCCardGetCardServicesInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PCCardGetCardServicesInfo" 
      ((socketCount (:pointer :unsigned-long)) (complianceLevel (:pointer :unsigned-long)) (version (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  PCCardGetSocketRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PCCardGetSocketRef" 
      ((vSocket :unsigned-long) (socketRef (:pointer :regentryid))) 
  :osstatus
   () )

; 
;  *  PCCardGetCardRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PCCardGetCardRef" 
      ((vSocket :unsigned-long) (cardRef (:pointer :regentryid))) 
  :osstatus
   () )

; 
;  *  PCCardGetDeviceRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PCCardGetDeviceRef" 
      ((vSocket :unsigned-long) (device :unsigned-long) (deviceRef (:pointer :regentryid))) 
  :osstatus
   () )

; 
;  *  PCCardGetSocketAndDeviceFromDeviceRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_PCCardGetSocketAndDeviceFromDeviceRef" 
      ((deviceRef (:pointer :regentryid)) (vSocket (:pointer :unsigned-long)) (device (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  PCCardGetCardRefFromDeviceRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_PCCardGetCardRefFromDeviceRef" 
      ((deviceRef (:pointer :regentryid)) (cardRef (:pointer :regentryid))) 
  :osstatus
   () )

; ----------------------------------------------------------------------
;     Resource Management
; ----------------------------------------------------------------------
; 
;  *  PCCardRequestWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_PCCardRequestWindow" 
      ((deviceRef (:pointer :regentryid)) (windowAttributes :unsigned-long) (windowBase (:pointer :pointer)) (windowSize (:pointer :unsigned-long)) (windowSpeed (:pointer :unsigned-long)) (windowOffset (:pointer :unsigned-long)) (windowID (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  PCCardModifyWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PCCardModifyWindow" 
      ((windowID :unsigned-long) (windowAttributes :unsigned-long) (windowSpeed :unsigned-long) (windowOffset :unsigned-long)) 
  :osstatus
   () )

; 
;  *  PCCardReleaseWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PCCardReleaseWindow" 
      ((windowID :unsigned-long)) 
  :osstatus
   () )

; 
;  *  PCCardInquireWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_PCCardInquireWindow" 
      ((deviceRef (:pointer :regentryid)) (windowID :unsigned-long) (windowAttributes (:pointer :unsigned-long)) (windowBase (:pointer :pointer)) (windowSize (:pointer :unsigned-long)) (windowSpeed (:pointer :unsigned-long)) (windowOffset (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  PCCardGetStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_PCCardGetStatus" 
      ((deviceRef (:pointer :regentryid)) (currentState (:pointer :unsigned-long)) (changedState (:pointer :unsigned-long)) (Vcc (:pointer :unsigned-long)) (Vpp (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  PCCardRequestConfiguration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_PCCardRequestConfiguration" 
      ((deviceRef (:pointer :regentryid)) (configOptions :unsigned-long) (ifType :unsigned-long) (ifCustomType :unsigned-long) (vcc :unsigned-long) (vpp :unsigned-long) (configRegistersBase :pointer) (configRegistersPresent :unsigned-long) (configRegisterValues (:pointer :pccardfunctionconfigreg))) 
  :osstatus
   () )

; 
;  *  PCCardReleaseConfiguration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_PCCardReleaseConfiguration" 
      ((deviceRef (:pointer :regentryid))) 
  :osstatus
   () )

; 
;  *  PCCardModifyConfiguration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_PCCardModifyConfiguration" 
      ((deviceRef (:pointer :regentryid)) (configOptions :unsigned-long) (vpp :unsigned-long)) 
  :osstatus
   () )

; 
;  *  PCCardReadConfigurationRegister()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_PCCardReadConfigurationRegister" 
      ((deviceRef (:pointer :regentryid)) (whichRegister :unsigned-long) (offset :unsigned-long) (value (:pointer :unsigned-byte))) 
  :osstatus
   () )

; 
;  *  PCCardWriteConfigurationRegister()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_PCCardWriteConfigurationRegister" 
      ((deviceRef (:pointer :regentryid)) (whichRegister :unsigned-long) (offset :unsigned-long) (value :signed-byte)) 
  :osstatus
   () )

; 
;  *  PCCardResetFunction()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_PCCardResetFunction" 
      ((deviceRef (:pointer :regentryid))) 
  :osstatus
   () )

; ----------------------------------------------------------------------
;     Client Utilities
; ----------------------------------------------------------------------
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :pccardtuplekind (find-mactype ':unsigned-byte))
(def-mactype :pccardtupleiterator (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :pccardtupleiteratorptr (find-mactype '(:pointer :pointer)));  when a VAR xx:PCCardTupleIterator parameter can be nil, it is changed to xx: PCCardTupleIteratorPtr 
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  PCCardNewTupleIterator()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in PCCard 3.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_PCCardNewTupleIterator" 
      () 
  :pointer
   () )

; 
;  *  PCCardDisposeTupleIterator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PCCardDisposeTupleIterator" 
      ((tupleIterator :pointer)) 
  :osstatus
   () )

; 
;  *  PCCardGetFirstTuple()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_PCCardGetFirstTuple" 
      ((deviceID (:pointer :regentryid)) (desiredTuple :signed-byte) (tupleIterator :pointer) (dataBuffer :pointer) (dataBufferSize (:pointer :unsigned-long)) (foundTuple (:pointer :unsigned-byte)) (foundTupleDataSize (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  PCCardGetNextTuple()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_PCCardGetNextTuple" 
      ((deviceRef (:pointer :regentryid)) (desiredTuple :signed-byte) (tupleIterator :pointer) (dataBuffer :pointer) (dataBufferSize (:pointer :unsigned-long)) (foundTuple (:pointer :unsigned-byte)) (foundTupleDataSize (:pointer :unsigned-long))) 
  :osstatus
   () )

; ----------------------------------------------------------------------
;     Miscellaneous
; ----------------------------------------------------------------------
; 
;  *  PCCardEject()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_PCCardEject" 
      ((cardRef (:pointer :regentryid))) 
  :osstatus
   () )

; 
;  *  PCCardEnableModemSound()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_PCCardEnableModemSound" 
      ((cardRef (:pointer :regentryid)) (enableSound :boolean)) 
  :osstatus
   () )

; 
;  *  PCCardEnableZoomedVideo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_PCCardEnableZoomedVideo" 
      ((cardRef (:pointer :regentryid)) (enableZoomedVideo :boolean)) 
  :osstatus
   () )

; 
;  *  PCCardEnableZoomedVideoSound()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_PCCardEnableZoomedVideoSound" 
      ((cardRef (:pointer :regentryid)) (enableSound :boolean)) 
  :osstatus
   () )

; 
;  *  PCCardSetPowerLevel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_PCCardSetPowerLevel" 
      ((deviceRef (:pointer :regentryid)) (powerLevel :unsigned-long)) 
  :osstatus
   () )

; 
;  *  PCCardSetRingIndicate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_PCCardSetRingIndicate" 
      ((deviceRef (:pointer :regentryid)) (setRingIndicate :boolean)) 
  :osstatus
   () )

; 
;  *  PCCardGetGlobalOptions()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCCard 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PCCardGetGlobalOptions" 
      ((selector :unsigned-long) (value :pointer)) 
  :osstatus
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :pccarddevtype (find-mactype ':unsigned-long))
(def-mactype :pccardsubtype (find-mactype ':unsigned-long))
;   values for PCCardType and PCCardSubType 

(defconstant $kPCCardUnknownType 0)
(defconstant $kPCCardMultiFunctionType 1)
(defconstant $kPCCardMemoryType 2)
(defconstant $kPCCardNullSubType 0)             ;   Memory sub types  
(defconstant $kPCCardRomSubType 1)
(defconstant $kPCCardOTPromSubType 2)
(defconstant $kPCCardEpromSubType 3)
(defconstant $kPCCardEEpromSubType 4)
(defconstant $kPCCardFlashSubType 5)
(defconstant $kPCCardSramSubType 6)
(defconstant $kPCCardDramSubType 7)
(defconstant $kPCCardSerialPortType 3)
(defconstant $kPCCardSerialOnlySubType 0)
(defconstant $kPCCardDataModemSubType 1)
(defconstant $kPCCardFaxModemSubType 2)
(defconstant $kPCCardFaxAndDataModemMask 3)
(defconstant $kPCCardVoiceEncodingSubType 4)
(defconstant $kPCCardParallelPortType 4)
(defconstant $kPCCardFixedDiskType 5)
(defconstant $kPCCardUnknownFixedDiskType 0)
(defconstant $kPCCardATAInterfaceDiskSubType 1)
(defconstant $kPCCardRotatingDeviceSubType #x0)
(defconstant $kPCCardSiliconDevice #x80)
(defconstant $kPCCardVideoAdaptorType 6)
(defconstant $kPCCardNetworkAdaptorType 7)
(defconstant $kPCCardArcNetSubType 1)           ;   network sub types  
(defconstant $kPCCardEthernetSubType 2)
(defconstant $kPCCardTokenRingSubType 3)
(defconstant $kPCCardLocalTalkSubType 4)
(defconstant $kPCCardFDDI_CDDISubType 5)
(defconstant $kPCCardATMSubType 6)
(defconstant $kPCCardWirelessSubType 7)
(defconstant $kPCCardAIMSType 8)
(defconstant $kPCCardSCSIType 9)
(defconstant $kPCCardSerialBusType 10)
(defconstant $kPCCardUSBBusSubType 1)
(defconstant $kPCCardFirewireBusSubType 2)

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  PCCardGetCardInfo()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in PCCard 3.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_PCCardGetCardInfo" 
      ((cardRef (:pointer :regentryid)) (cardType (:pointer :unsigned-long)) (cardSubType (:pointer :unsigned-long)) (cardName (:pointer (:string 255))) (vendorName (:pointer (:string 255)))) 
  :osstatus
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $kPCCard16HardwareType :|pc16|)
(defconstant $kCardBusHardwareType :|cdbs|)

(def-mactype :pccardhardwaretype (find-mactype ':unsigned-long))
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  PCCardGetCardType()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in PCCard 3.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_PCCardGetCardType" 
      ((socketRef (:pointer :regentryid)) (cardType (:pointer :unsigned-long))) 
  :osstatus
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := PCCardIncludes

; $ENDC                                         ; __PCCARD__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'PCCard)