(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Palettes.p"
; at Wednesday May 1,2002 2:40:30 pm.
; 
;      File:       Palettes.p
;  
;      Contains:   Palette Manager Interfaces.
;  
;      Version:    Technology: Mac OS 8
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1987-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __PALETTES__
; $SETC __PALETTES__ := 1

; $I+
; $SETC PalettesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $pmCourteous 0)                    ;  Record use of color on each device touched. 
(defconstant $pmDithered #x1)
(defconstant $pmTolerant #x2)                   ;  render ciRGB if ciTolerance is exceeded by best match. 
(defconstant $pmAnimated #x4)                   ;  reserve an index on each device touched and render ciRGB. 
(defconstant $pmExplicit #x8)                   ;  no reserve, no render, no record; stuff index into port. 
(defconstant $pmWhite #x10)
(defconstant $pmBlack #x20)
(defconstant $pmInhibitG2 #x100)
(defconstant $pmInhibitC2 #x200)
(defconstant $pmInhibitG4 #x400)
(defconstant $pmInhibitC4 #x800)
(defconstant $pmInhibitG8 #x1000)
(defconstant $pmInhibitC8 #x2000)               ;   NSetPalette Update Constants  
(defconstant $pmNoUpdates #x8000)               ;  no updates 
(defconstant $pmBkUpdates #xA000)               ;  background updates only 
(defconstant $pmFgUpdates #xC000)               ;  foreground updates only 
(defconstant $pmAllUpdates #xE000)              ;  all updates 

(def-mactype :colorinfoptr (find-mactype '(:pointer :colorinfo)))
(defrecord ColorInfo 
   (ciRGB :rgbcolor)                            ;  true RGB values 
   (ciUsage :signed-integer)                    ;  color usage 
   (ciTolerance :signed-integer)                ;  tolerance value 
   (ciDataFields (:array :signed-integer 3))    ;  private fields 
   )

(def-mactype :colorinfohandle (find-mactype '(:handle :colorinfo)))
(def-mactype :paletteptr (find-mactype '(:pointer :palette)))
(defrecord (Palette :handle) 
   (pmEntries :signed-integer)                  ;  entries in pmTable 
   (pmDataFields (:array :signed-integer 7))    ;  private fields 
   (pmInfo (:array :colorinfo 1))
   )

(def-mactype :palettehandle (find-mactype '(:handle :palette)))
; 
; 	 *  InitPalettes()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_InitPalettes" 
      ()
   nil
   (:stack-trap #xAA90))

; 
;  *  NewPalette()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_NewPalette" 
      ((entries :signed-integer) (srcColors (:handle :colortable)) (srcUsage :signed-integer) (srcTolerance :signed-integer))
   (:stack (:handle :palette))
   (:stack-trap #xAA91))

; 
;  *  GetNewPalette()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetNewPalette" 
      ((PaletteID :signed-integer))
   (:stack (:handle :palette))
   (:stack-trap #xAA92))

; 
;  *  DisposePalette()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposePalette" 
      ((srcPalette (:handle :palette)))
   nil
   (:stack-trap #xAA93))

; 
;  *  ActivatePalette()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ActivatePalette" 
      ((srcWindow (:pointer :windowrecord)))
   nil
   (:stack-trap #xAA94))

; 
;  *  SetPalette()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetPalette" 
      ((dstWindow (:pointer :windowrecord)) (srcPalette (:handle :palette)) (cUpdates :boolean))
   nil
   (:stack-trap #xAA95))

; 
;  *  NSetPalette()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_NSetPalette" 
      ((dstWindow (:pointer :windowrecord)) (srcPalette (:handle :palette)) (nCUpdates :signed-integer))
   nil
   (:stack-trap #xAA95))

; 
;  *  GetPalette()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetPalette" 
      ((srcWindow (:pointer :windowrecord)))
   (:stack (:handle :palette))
   (:stack-trap #xAA96))

; 
;  *  CopyPalette()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CopyPalette" 
      ((srcPalette (:handle :palette)) (dstPalette (:handle :palette)) (srcEntry :signed-integer) (dstEntry :signed-integer) (dstLength :signed-integer))
   nil
   (:stack-trap #xAAA1))

; 
;  *  PmForeColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PmForeColor" 
      ((dstEntry :signed-integer))
   nil
   (:stack-trap #xAA97))

; 
;  *  PmBackColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PmBackColor" 
      ((dstEntry :signed-integer))
   nil
   (:stack-trap #xAA98))

; 
;  *  AnimateEntry()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_AnimateEntry" 
      ((dstWindow (:pointer :windowrecord)) (dstEntry :signed-integer) (srcRGB (:pointer :rgbcolor)))
   nil
   (:stack-trap #xAA99))

; 
;  *  [Mac]AnimatePalette()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AnimatePalette" 
      ((dstWindow (:pointer :windowrecord)) (srcCTab (:handle :colortable)) (srcIndex :signed-integer) (dstEntry :signed-integer) (dstLength :signed-integer))
   nil
   (:stack-trap #xAA9A))

; 
;  *  GetEntryColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetEntryColor" 
      ((srcPalette (:handle :palette)) (srcEntry :signed-integer) (dstRGB (:pointer :rgbcolor)))
   nil
   (:stack-trap #xAA9B))

; 
;  *  SetEntryColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_SetEntryColor" 
      ((dstPalette (:handle :palette)) (dstEntry :signed-integer) (srcRGB (:pointer :rgbcolor)))
   nil
   (:stack-trap #xAA9C))

; 
;  *  GetEntryUsage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetEntryUsage" 
      ((srcPalette (:handle :palette)) (srcEntry :signed-integer) (dstUsage (:pointer :signed-integer)) (dstTolerance (:pointer :signed-integer)))
   nil
   (:stack-trap #xAA9D))

; 
;  *  SetEntryUsage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetEntryUsage" 
      ((dstPalette (:handle :palette)) (dstEntry :signed-integer) (srcUsage :signed-integer) (srcTolerance :signed-integer))
   nil
   (:stack-trap #xAA9E))

; 
;  *  CTab2Palette()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CTab2Palette" 
      ((srcCTab (:handle :colortable)) (dstPalette (:handle :palette)) (srcUsage :signed-integer) (srcTolerance :signed-integer))
   nil
   (:stack-trap #xAA9F))

; 
;  *  Palette2CTab()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_Palette2CTab" 
      ((srcPalette (:handle :palette)) (dstCTab (:handle :colortable)))
   nil
   (:stack-trap #xAAA0))

; 
;  *  Entry2Index()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_Entry2Index" 
      ((entry :signed-integer))
   (:stack :signed-long)
   (:stack-trap #xAAA2 :d0 0 entry))

; 
;  *  RestoreDeviceClut()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_RestoreDeviceClut" 
      ((gd (:handle :gdevice)))
   nil
   (:stack-trap #xAAA2 :d0 2 gd))

; 
;  *  [Mac]ResizePalette()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ResizePalette" 
      ((p (:handle :palette)) (size :signed-integer))
   nil
   (:stack-trap #xAAA2 :d0 3 p size))

; 
;  *  SaveFore()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SaveFore" 
      ((c (:pointer :colorspec)))
   nil
   (:stack-trap #xAAA2 :d0 1037 c))

; 
;  *  SaveBack()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SaveBack" 
      ((c (:pointer :colorspec)))
   nil
   (:stack-trap #xAAA2 :d0 1038 c))

; 
;  *  RestoreFore()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_RestoreFore" 
      ((c (:pointer :colorspec)))
   nil
   (:stack-trap #xAAA2 :d0 1039 c))

; 
;  *  RestoreBack()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_RestoreBack" 
      ((c (:pointer :colorspec)))
   nil
   (:stack-trap #xAAA2 :d0 1040 c))

; 
;  *  SetDepth()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetDepth" 
      ((gd (:handle :gdevice)) (depth :signed-integer) (whichFlags :signed-integer) (flags :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xAAA2 :d0 2579 gd depth whichFlags flags))

; 
;  *  HasDepth()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_HasDepth" 
      ((gd (:handle :gdevice)) (depth :signed-integer) (whichFlags :signed-integer) (flags :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xAAA2 :d0 2580 gd depth whichFlags flags))

; 
;  *  PMgrVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PMgrVersion" 
      ()
   (:stack :signed-integer)
   (:stack-trap #xAAA2 :d0 21))

; 
;  *  SetPaletteUpdates()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetPaletteUpdates" 
      ((p (:handle :palette)) (updates :signed-integer))
   nil
   (:stack-trap #xAAA2 :d0 1558 p updates))

; 
;  *  GetPaletteUpdates()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetPaletteUpdates" 
      ((p (:handle :palette)))
   (:stack :signed-integer)
   (:stack-trap #xAAA2 :d0 1047 p))

; 
;  *  GetGray()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_GetGray" 
      ((device (:handle :gdevice)) (backGround (:pointer :rgbcolor)) (foreGround (:pointer :rgbcolor)))
   (:stack :boolean)
   (:stack-trap #xAAA2 :d0 3097 device backGround foreGround))

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := PalettesIncludes

; $ENDC                                         ; __PALETTES__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Palettes)