(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Processes.p"
; at Wednesday May 1,2002 2:39:39 pm.
; 
;      File:       Processes.p
;  
;      Contains:   Process Manager Interfaces.
;  
;      Version:    Technology: Mac OS 9
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1989-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __PROCESSES__
; $SETC __PROCESSES__ := 1

; $I+
; $SETC ProcessesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __EVENTS__
|#

(require-interface 'Events)
#|                                              ; $I Events.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __TEXTCOMMON__
|#

(require-interface 'TextCommon)
#|                                              ; $I TextCommon.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFSTRING__
|#

(require-interface 'CFString)
#|                                              ; $I CFString.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  type for unique process identifier 

(def-mactype :processserialnumberptr (find-mactype '(:pointer :processserialnumber)))
(defrecord ProcessSerialNumber 
   (highLongOfPSN :unsigned-long)
   (lowLongOfPSN :unsigned-long)
   )

;   Process identifier - Various reserved process serial numbers  
(defconstant $kNoProcess 0)
(defconstant $kSystemProcess 1)
(defconstant $kCurrentProcess 2)

; 	 Definition of the parameter block passed to _Launch 	
;   Typedef and flags for launchControlFlags field 

(def-mactype :launchflags (find-mactype ':unsigned-integer))

(defconstant $launchContinue #x4000)
(defconstant $launchNoFileFlags #x800)
(defconstant $launchUseMinimum #x400)
(defconstant $launchDontSwitch #x200)
(defconstant $launchAllow24Bit #x100)
(defconstant $launchInhibitDaemon #x80)

; 	 Format for first AppleEvent to pass to new process.  The size of the overall
; 	  buffer variable: the message body immediately follows the messageLength 	

(def-mactype :appparametersptr (find-mactype '(:pointer :appparameters)))
(defrecord AppParameters 
   (theMsgEvent :eventrecord)
   (eventRefCon :unsigned-long)
   (messageLength :unsigned-long)
   )

; 	 Parameter block to _Launch 	
(def-mactype :launchparamblockrecptr (find-mactype '(:pointer :launchparamblockrec)))
(defrecord LaunchParamBlockRec 
   (reserved1 :unsigned-long)
   (reserved2 :unsigned-integer)
   (launchBlockID :unsigned-integer)
   (launchEPBLength :unsigned-long)
   (launchFileFlags :unsigned-integer)
   (launchControlFlags :unsigned-integer)
   (launchAppSpec (:pointer :fsspec))
   (launchProcessSN :processserialnumber)
   (launchPreferredSize :unsigned-long)
   (launchMinimumSize :unsigned-long)
   (launchAvailableSize :unsigned-long)
   (launchAppParameters (:pointer :appparameters))
   )

(def-mactype :launchpbptr (find-mactype '(:pointer :launchparamblockrec)))
; 	 Set launchBlockID to extendedBlock to specify that extensions exist.
; 	 Set launchEPBLength to extendedBlockLen for compatibility.	

(defconstant $extendedBlock #x4C43)             ;   'LC'  
(defconstant $extendedBlockLen 32)

;   Definition of the information block returned by GetProcessInformation  
(defconstant $modeReserved #x1000000)
(defconstant $modeControlPanel #x80000)
(defconstant $modeLaunchDontSwitch #x40000)
(defconstant $modeDeskAccessory #x20000)
(defconstant $modeMultiLaunch #x10000)
(defconstant $modeNeedSuspendResume #x4000)
(defconstant $modeCanBackground #x1000)
(defconstant $modeDoesActivateOnFGSwitch #x800)
(defconstant $modeOnlyBackground #x400)
(defconstant $modeGetFrontClicks #x200)
(defconstant $modeGetAppDiedMsg #x100)
(defconstant $mode32BitCompatible #x80)
(defconstant $modeHighLevelEventAware #x40)
(defconstant $modeLocalAndRemoteHLEvents #x20)
(defconstant $modeStationeryAware #x10)
(defconstant $modeUseTextEditServices #x8)
(defconstant $modeDisplayManagerAware #x4)

; 
; 	   Record returned by GetProcessInformation
; 	    When calling GetProcessInformation(), the input ProcesInfoRec
; 	    should have the processInfoLength set to sizeof(ProcessInfoRec),
; 	    the processName field set to nil or a pointer to a Str255, and
; 	    processAppSpec set to nil or a pointer to an FSSpec.  If
; 	    processName or processAppSpec are not specified, this routine
; 	    will very likely write data to whatever random location in memory
; 	    these happen to point to, which is not a good thing.
; 	

(def-mactype :processinforecptr (find-mactype '(:pointer :processinforec)))
(defrecord ProcessInfoRec 
   (processInfoLength :unsigned-long)
   (processName (:pointer (:string 255)))
   (processNumber :processserialnumber)
   (processType :unsigned-long)
   (processSignature :ostype)
   (processMode :unsigned-long)
   (processLocation :pointer)
   (processSize :unsigned-long)
   (processFreeMem :unsigned-long)
   (processLauncher :processserialnumber)
   (processLaunchDate :unsigned-long)
   (processActiveTime :unsigned-long)
   (processAppSpec (:pointer :fsspec))
   )

; 
; 	    Some applications assumed the size of a ProcessInfoRec would never change,
; 	    which has caused problems trying to return additional information.  In
; 	    the future, we will add fields to ProcessInfoExtendedRec when necessary,
; 	    and callers which wish to access 'more' data than originally was present
; 	    in ProcessInfoRec should allocate space for a ProcessInfoExtendedRec,
; 	    fill in the processInfoLength ( and processName and processAppSpec ptrs ),
; 	    then coerce this to a ProcessInfoRecPtr in the call to
; 	    GetProcessInformation().
; 	
(def-mactype :processinfoextendedrecptr (find-mactype '(:pointer :processinfoextendedrec)))
(defrecord ProcessInfoExtendedRec 
   (processInfoLength :unsigned-long)
   (processName (:pointer (:string 255)))
   (processNumber :processserialnumber)
   (processType :unsigned-long)
   (processSignature :ostype)
   (processMode :unsigned-long)
   (processLocation :pointer)
   (processSize :unsigned-long)
   (processFreeMem :unsigned-long)
   (processLauncher :processserialnumber)
   (processLaunchDate :unsigned-long)
   (processActiveTime :unsigned-long)
   (processAppSpec (:pointer :fsspec))
   (processTempMemTotal :unsigned-long)
   (processPurgeableTempMemTotal :unsigned-long)
   )

; 	 Record corresponding to the SIZE resource definition 	
(def-mactype :sizeresourcerecptr (find-mactype '(:pointer :sizeresourcerec)))
(defrecord SizeResourceRec 
   (flags :unsigned-integer)
   (preferredHeapSize :unsigned-long)
   (minimumHeapSize :unsigned-long)
   )

(def-mactype :sizeresourcerechandle (find-mactype '(:handle :sizeresourcerec)))
; 
; 	    Applications and background applications can control when they are asked to quit
; 	    by the system at restart/shutdown by setting these bits in a 'quit' ( 0 ) resource
; 	    in their application's resource fork.  Applications without a 'quit' ( 0 ) will
; 	    be quit at kQuitAtNormalTime mask.
; 	

(defconstant $kQuitBeforeNormalTimeMask 1)
(defconstant $kQuitAtNormalTimeMask 2)
(defconstant $kQuitBeforeFBAsQuitMask 4)
(defconstant $kQuitBeforeShellQuitsMask 8)
(defconstant $kQuitBeforeTerminatorAppQuitsMask 16)
(defconstant $kQuitNeverMask 32)
(defconstant $kQuitOptionsMask #x7F)
(defconstant $kQuitNotQuitDuringInstallMask #x100)
(defconstant $kQuitNotQuitDuringLogoutMask #x200)

; 
; 	 *  LaunchApplication()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_LaunchApplication" 
      ((LaunchParams (:pointer :launchparamblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA9F2 :a0 LaunchParams))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LaunchDeskAccessory()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_LaunchDeskAccessory" 
      ((pFileSpec (:pointer :fsspec)) (pDAName (:string 255)))
   (:stack :signed-integer)
   (:stack-trap #xA88F pFileSpec pDAName (54 :signed-integer)))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  [Mac]GetCurrentProcess()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetCurrentProcess" 
      ((PSN (:pointer :processserialnumber)))
   (:stack :signed-integer)
   (:stack-trap #xA88F PSN (55 :signed-integer)))

; 
;  *  GetFrontProcess()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetFrontProcess" 
      ((PSN (:pointer :processserialnumber))) 
  :signed-integer
   (#x70FF #x2F00 #x3F3C #x39 #xA88F) )

; 
;  *  GetNextProcess()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetNextProcess" 
      ((PSN (:pointer :processserialnumber)))
   (:stack :signed-integer)
   (:stack-trap #xA88F PSN (56 :signed-integer)))

; 
;  *  GetProcessInformation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_GetProcessInformation" 
      ((PSN (:pointer :processserialnumber)) (info (:pointer :processinforec)))
   (:stack :signed-integer)
   (:stack-trap #xA88F PSN info (58 :signed-integer)))

; 
;  *  SetFrontProcess()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_SetFrontProcess" 
      ((PSN (:pointer :processserialnumber)))
   (:stack :signed-integer)
   (:stack-trap #xA88F PSN (59 :signed-integer)))

; 
;  *  WakeUpProcess()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_WakeUpProcess" 
      ((PSN (:pointer :processserialnumber)))
   (:stack :signed-integer)
   (:stack-trap #xA88F PSN (60 :signed-integer)))

; 
;  *  SameProcess()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap "_SameProcess" 
      ((PSN1 (:pointer :processserialnumber)) (PSN2 (:pointer :processserialnumber)) (result (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xA88F PSN1 PSN2 result (61 :signed-integer)))

;    ExitToShell was previously in SegLoad.h 
; 
;  *  ExitToShell()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ExitToShell" 
      ()
   nil
   (:stack-trap #xA9F4))

; 
;    LaunchControlPanel is similar to LaunchDeskAccessory, but for Control Panel files instead.
;    It launches a control panel in an application shell maintained by the Process Manager.
; 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  LaunchControlPanel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_LaunchControlPanel" 
      ((pFileSpec (:pointer :fsspec)))
   (:stack :signed-integer)
   (:stack-trap #xA88F pFileSpec (123 :signed-integer)))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  GetApplicationTextEncoding()
;  *  
;  *  Summary:
;  *    Returns the application text encoding for Resource Manager
;  *    resources.
;  *  
;  *  Discussion:
;  *    The application text encoding is used when you create a
;  *    CFStringRef from text stored in Resource Manager resources, which
;  *    typically uses one of the Mac encodings such as MacRoman or
;  *    MacJapanese.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  GetApplicationScript()
;  *  
;  *  Summary:
;  *    Returns the application script.
;  *  
;  *  Discussion:
;  *    The application script is used when you need a ScriptCode to pass
;  *    to some other API, such as UseThemeFont.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetApplicationTextEncoding" 
      () 
  :unsigned-long
   () )                                         ; 
;  *  GetProcessBundleLocation()
;  *  
;  *  Summary:
;  *    Retrieve the filesystem location of the process bundle, or
;  *    executable if unbundled.
;  *  
;  *  Discussion:
;  *    Retrieves a reference to the filesystem location of the specified
;  *    application.  For an application that is packaged as an app
;  *    bundle, this will be the app bundle directory; otherwise it will
;  *    be the location of the executable itself.
;  *  
;  *  Parameters:
;  *    
;  *    psn:
;  *      Serial number of the target process
;  *    
;  *    location:
;  *      Location of the bundle or executable, as an FSRef
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetApplicationScript" 
      () 
  :scriptcode
   () )                                         ; CONST
(deftrap-inline "_GetProcessBundleLocation" 
      ((psn (:pointer :processserialnumber)) (location (:pointer :fsref))) 
  :osstatus
   () )

; 
;  *  CopyProcessName()
;  *  
;  *  Summary:
;  *    Get a copy of the name of a process.
;  *  
;  *  Discussion:
;  *    Use this call to get the name of a process as a CFString.  The
;  *    name returned is a copy, so the caller must CFRelease the name
;  *    when finished with it.  The difference between this call and the
;  *    processName field filled in by GetProcessInformation is that the
;  *    name here is a CFString, and thus is capable of representing a
;  *    multi-lingual name, whereas previously only a mac-encoded string
;  *    was possible.
;  *  
;  *  Parameters:
;  *    
;  *    psn:
;  *      Serial number of the target process
;  *    
;  *    name:
;  *      CFString representing the name of the process (must be released
;  *      by caller with CFRelease)
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_CopyProcessName" 
      ((psn (:pointer :processserialnumber)) (name (:pointer :pointer))) 
  :osstatus
   () )

; ************************************************************************
;  *  Process Visibility.
;  ************************************************************************
; 
;  *  IsProcessVisible()
;  *  
;  *  Summary:
;  *    Determines whether a particular process is visible or not.
;  *  
;  *  Discussion:
;  *    Given a psn, this call will return true or false depending on
;  *    whether or not the process is currently visible.
;  *  
;  *  Parameters:
;  *    
;  *    psn:
;  *      Serial number of the process
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.1 and later
;  
; CONST
(deftrap "_IsProcessVisible" 
      ((psn (:pointer :processserialnumber)))
   (:stack :boolean)
   (:stack-trap #xA88F psn (95 :signed-integer)))

; 
;  *  ShowHideProcess()
;  *  
;  *  Summary:
;  *    Hides or shows a given process.
;  *  
;  *  Discussion:
;  *    Given a psn, this call will hide or show the process specified in
;  *    the psn parameter. You determine whether you would like to show
;  *    or hide the process with the visible parameter. True passed into
;  *    visible indicates you wish for the process to become visible.
;  *  
;  *  Parameters:
;  *    
;  *    psn:
;  *      Serial number of the process
;  *    
;  *    visible:
;  *      true = show process; false = hide process
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.1 and later
;  
; CONST
(deftrap "_ShowHideProcess" 
      ((psn (:pointer :processserialnumber)) (visible :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA88F psn visible (96 :signed-integer)))

;  Values of the 'message' parameter to a Control Panel 'cdev' 

(defconstant $initDev 0)                        ;  Time for cdev to initialize itself 
(defconstant $hitDev 1)                         ;  Hit on one of my items 
(defconstant $closeDev 2)                       ;  Close yourself 
(defconstant $nulDev 3)                         ;  Null event 
(defconstant $updateDev 4)                      ;  Update event 
(defconstant $activDev 5)                       ;  Activate event 
(defconstant $deactivDev 6)                     ;  Deactivate event 
(defconstant $keyEvtDev 7)                      ;  Key down/auto key 
(defconstant $macDev 8)                         ;  Decide whether or not to show up 
(defconstant $undoDev 9)
(defconstant $cutDev 10)
(defconstant $copyDev 11)
(defconstant $pasteDev 12)
(defconstant $clearDev 13)
(defconstant $cursorDev 14)

; 	 Special values a Control Panel 'cdev' can return 	
(defconstant $cdevGenErr -1)                    ;  General error; gray cdev w/o alert 
(defconstant $cdevMemErr 0)                     ;  Memory shortfall; alert user please 
(defconstant $cdevResErr 1)                     ;  Couldn't get a needed resource; alert 
(defconstant $cdevUnset 3)                      ;   cdevValue is initialized to this 

; 	 Control Panel Default Proc 	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ControlPanelDefProcPtr = FUNCTION(message: INTEGER; item: INTEGER; numItems: INTEGER; cPanelID: INTEGER; VAR theEvent: EventRecord; cdevValue: LONGINT; cpDialog: DialogPtr): LONGINT;

|#
 |#                                             ; $ELSEC
(def-mactype :controlpaneldefprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :controlpaneldefupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :controlpaneldefupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppControlPanelDefProcInfo #xFEAB0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewControlPanelDefUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewControlPanelDefProc 
(deftrap "_NewControlPanelDefUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeControlPanelDefUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeControlPanelDefUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeControlPanelDefUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallControlPanelDefProc 
(deftrap-inline "_InvokeControlPanelDefUPP" 
      ((message :signed-integer) (item :signed-integer) (numItems :signed-integer) (cPanelID :signed-integer) (theEvent (:pointer :eventrecord)) (cdevValue :signed-long) (cpDialog (:pointer :grafport)) (userRoutine :pointer)) 
  :signed-long
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := ProcessesIncludes

; $ENDC                                         ; __PROCESSES__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Processes)