(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QD3DAcceleration.p"
; at Wednesday May 1,2002 2:42:19 pm.
; 
;      File:       QD3DAcceleration.p
;  
;      Contains:   Header file for low-level 3D driver API
;  
;      Version:    Technology: Quickdraw 3D 1.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __QD3DACCELERATION__
; $SETC __QD3DACCELERATION__ := 1

; $I+
; $SETC QD3DAccelerationIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __QD3D__
|#

(require-interface 'QD3D)
#|                                              ; $I QD3D.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

; *****************************************************************************
;  **                                                                          **
;  **                         Vendor ID definitions                            **
;  **                                                                          **
;  ****************************************************************************
; 
;  * If kQAVendor_BestChoice is used, the system chooses the "best" drawing engine
;  * available for the target device. This should be used for the default.
;  

(defconstant $kQAVendor_BestChoice -1)

; 	
; 	 * The other definitions (kQAVendor_Apple, etc.) identify specific vendors
; 	 * of drawing engines. When a vendor ID is used in conjunction with a
; 	 * vendor-defined engine ID, a specific drawing engine can be selected.
; 	 	
(defconstant $kQAVendor_Apple 0)
(defconstant $kQAVendor_ATI 1)
(defconstant $kQAVendor_Radius 2)
(defconstant $kQAVendor_DesignMark 3)
(defconstant $kQAVendor_Matrox 4)
(defconstant $kQAVendor_Yarc 5)
(defconstant $kQAVendor_DiamondMM 6)
(defconstant $kQAVendor_3DLabs 7)
(defconstant $kQAVendor_D3DAdaptor 8)
(defconstant $kQAVendor_IXMicro 9)
(defconstant $kQAVendor_NumberNine 10)
(defconstant $kQAVendor_MicroConversions 11)
(defconstant $kQAVendor_PurpleShark 12)
(defconstant $kQAVendor_VillageTronic 14)

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                      Apple's engine ID definitions                       **
; 	 **                                                                          **
; 	 ****************************************************************************	
(defconstant $kQAEngine_AppleSW 0)              ;   Default software rasterizer 
(defconstant $kQAEngine_AppleHW -1)             ;   Apple accelerator 
(defconstant $kQAEngine_AppleHW2 1)             ;   Another Apple accelerator 
(defconstant $kQAEngine_AppleHW3 2)             ;   Another Apple accelerator 

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QD3DAccelerationIncludes

; $ENDC                                         ; __QD3DACCELERATION__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'QD3DAcceleration)