(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QD3DController.p"
; at Wednesday May 1,2002 2:42:20 pm.
; 
;      File:       QD3DController.p
;  
;      Contains:   Q3Controller methods
;  
;      Version:    Technology: Quickdraw 3D 1.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __QD3DCONTROLLER__
; $SETC __QD3DCONTROLLER__ := 1

; $I+
; $SETC QD3DControllerIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __QD3D__
|#

(require-interface 'QD3D)
#|                                              ; $I QD3D.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

; *****************************************************************************
;  **                                                                          **
;  **                             Type Definitions                             **
;  **                                                                          **
;  ****************************************************************************

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3ChannelGetMethod = FUNCTION(controllerRef: TQ3ControllerRef; channel: UInt32; data: UNIV Ptr; VAR dataSize: UInt32): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3channelgetmethod (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3ChannelSetMethod = FUNCTION(controllerRef: TQ3ControllerRef; channel: UInt32; data: UNIV Ptr; dataSize: UInt32): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3channelsetmethod (find-mactype ':pointer))
; $ENDC

(def-mactype :tq3controllerdataptr (find-mactype '(:pointer :tq3controllerdata)))
(defrecord TQ3ControllerData 
   (signature :pointer)
   (valueCount :unsigned-long)
   (channelCount :unsigned-long)
   (channelGetMethod :pointer)
   (channelSetMethod :pointer)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                                  Routines                                **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Controller_GetListChanged()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3Controller_GetListChanged" 
      ((listChanged (:pointer :signed-long)) (serialNumber (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Controller_Next()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Controller_Next" 
      ((controllerRef :pointer) (nextControllerRef (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Controller_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Controller_New" 
      ((controllerData (:pointer :tq3controllerdata))) 
  :pointer
   () )

; 
;  *  Q3Controller_Decommission()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Controller_Decommission" 
      ((controllerRef :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Controller_SetActivation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Controller_SetActivation" 
      ((controllerRef :pointer) (active :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3Controller_GetActivation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Controller_GetActivation" 
      ((controllerRef :pointer) (active (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3Controller_GetSignature()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Controller_GetSignature" 
      ((controllerRef :pointer) (signature :pointer) (numChars :unsigned-long)) 
  :tq3status
   () )

; 
;  *  Q3Controller_SetChannel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Controller_SetChannel" 
      ((controllerRef :pointer) (channel :unsigned-long) (data :pointer) (dataSize :unsigned-long)) 
  :tq3status
   () )

; 
;  *  Q3Controller_GetChannel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Controller_GetChannel" 
      ((controllerRef :pointer) (channel :unsigned-long) (data :pointer) (dataSize (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Controller_GetValueCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Controller_GetValueCount" 
      ((controllerRef :pointer) (valueCount (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Controller_SetTracker()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Controller_SetTracker" 
      ((controllerRef :pointer) (tracker :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Controller_HasTracker()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Controller_HasTracker" 
      ((controllerRef :pointer) (hasTracker (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3Controller_Track2DCursor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Controller_Track2DCursor" 
      ((controllerRef :pointer) (track2DCursor (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3Controller_Track3DCursor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Controller_Track3DCursor" 
      ((controllerRef :pointer) (track3DCursor (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3Controller_GetButtons()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Controller_GetButtons" 
      ((controllerRef :pointer) (buttons (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Controller_SetButtons()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Controller_SetButtons" 
      ((controllerRef :pointer) (buttons :unsigned-long)) 
  :tq3status
   () )

; 
;  *  Q3Controller_GetTrackerPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Controller_GetTrackerPosition" 
      ((controllerRef :pointer) (position (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Controller_SetTrackerPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Controller_SetTrackerPosition" 
      ((controllerRef :pointer) (position (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Controller_MoveTrackerPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Controller_MoveTrackerPosition" 
      ((controllerRef :pointer) (delta (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Controller_GetTrackerOrientation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Controller_GetTrackerOrientation" 
      ((controllerRef :pointer) (orientation (:pointer :tq3quaternion))) 
  :tq3status
   () )

; 
;  *  Q3Controller_SetTrackerOrientation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Controller_SetTrackerOrientation" 
      ((controllerRef :pointer) (orientation (:pointer :tq3quaternion))) 
  :tq3status
   () )

; 
;  *  Q3Controller_MoveTrackerOrientation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Controller_MoveTrackerOrientation" 
      ((controllerRef :pointer) (delta (:pointer :tq3quaternion))) 
  :tq3status
   () )

; 
;  *  Q3Controller_GetValues()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Controller_GetValues" 
      ((controllerRef :pointer) (valueCount :unsigned-long) (values (:pointer :single-float)) (changed (:pointer :signed-long)) (serialNumber (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Controller_SetValues()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Controller_SetValues" 
      ((controllerRef :pointer) (values (:pointer :single-float)) (valueCount :unsigned-long)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                                  Routines                                **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ControllerState_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ControllerState_New" 
      ((controllerRef :pointer)) 
  :pointer
   () )

; 
;  *  Q3ControllerState_SaveAndReset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ControllerState_SaveAndReset" 
      ((controllerStateObject :pointer)) 
  :tq3status
   () )

; 
;  *  Q3ControllerState_Restore()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ControllerState_Restore" 
      ((controllerStateObject :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Type Definitions                             **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3TrackerNotifyFunc = FUNCTION(trackerObject: TQ3TrackerObject; controllerRef: TQ3ControllerRef): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3trackernotifyfunc (find-mactype ':pointer))
; $ENDC

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                                  Routines                                **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Tracker_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3Tracker_New" 
      ((notifyFunc :pointer)) 
  :pointer
   () )

; 
;  *  Q3Tracker_SetNotifyThresholds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Tracker_SetNotifyThresholds" 
      ((trackerObject :pointer) (positionThresh :single-float) (orientationThresh :single-float)) 
  :tq3status
   () )

; 
;  *  Q3Tracker_GetNotifyThresholds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Tracker_GetNotifyThresholds" 
      ((trackerObject :pointer) (positionThresh (:pointer :single-float)) (orientationThresh (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3Tracker_SetActivation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Tracker_SetActivation" 
      ((trackerObject :pointer) (active :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3Tracker_GetActivation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Tracker_GetActivation" 
      ((trackerObject :pointer) (active (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3Tracker_GetButtons()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Tracker_GetButtons" 
      ((trackerObject :pointer) (buttons (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Tracker_ChangeButtons()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Tracker_ChangeButtons" 
      ((trackerObject :pointer) (controllerRef :pointer) (buttons :unsigned-long) (buttonMask :unsigned-long)) 
  :tq3status
   () )

; 
;  *  Q3Tracker_GetPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Tracker_GetPosition" 
      ((trackerObject :pointer) (position (:pointer :tq3point3d)) (delta (:pointer :tq3vector3d)) (changed (:pointer :signed-long)) (serialNumber (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Tracker_SetPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Tracker_SetPosition" 
      ((trackerObject :pointer) (controllerRef :pointer) (position (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Tracker_MovePosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Tracker_MovePosition" 
      ((trackerObject :pointer) (controllerRef :pointer) (delta (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Tracker_GetOrientation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Tracker_GetOrientation" 
      ((trackerObject :pointer) (orientation (:pointer :tq3quaternion)) (delta (:pointer :tq3quaternion)) (changed (:pointer :signed-long)) (serialNumber (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Tracker_SetOrientation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Tracker_SetOrientation" 
      ((trackerObject :pointer) (controllerRef :pointer) (orientation (:pointer :tq3quaternion))) 
  :tq3status
   () )

; 
;  *  Q3Tracker_MoveOrientation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Tracker_MoveOrientation" 
      ((trackerObject :pointer) (controllerRef :pointer) (delta (:pointer :tq3quaternion))) 
  :tq3status
   () )

; 
;  *  Q3Tracker_SetEventCoordinates()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Tracker_SetEventCoordinates" 
      ((trackerObject :pointer) (timeStamp :unsigned-long) (buttons :unsigned-long) (position (:pointer :tq3point3d)) (orientation (:pointer :tq3quaternion))) 
  :tq3status
   () )

; 
;  *  Q3Tracker_GetEventCoordinates()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Tracker_GetEventCoordinates" 
      ((trackerObject :pointer) (timeStamp :unsigned-long) (buttons (:pointer :unsigned-long)) (position (:pointer :tq3point3d)) (orientation (:pointer :tq3quaternion))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                              Types                                       **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3CursorTrackerNotifyFunc = PROCEDURE; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3cursortrackernotifyfunc (find-mactype ':pointer))
; $ENDC

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                              Routines                                    **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3CursorTracker_PrepareTracking()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3CursorTracker_PrepareTracking" 
      () 
  :tq3status
   () )

; 
;  *  Q3CursorTracker_SetTrackDeltas()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3CursorTracker_SetTrackDeltas" 
      ((trackDeltas :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3CursorTracker_GetAndClearDeltas()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3CursorTracker_GetAndClearDeltas" 
      ((depth (:pointer :single-float)) (orientation (:pointer :tq3quaternion)) (hasOrientation (:pointer :signed-long)) (changed (:pointer :signed-long)) (serialNumber (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3CursorTracker_SetNotifyFunc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3CursorTracker_SetNotifyFunc" 
      ((notifyFunc :pointer)) 
  :tq3status
   () )

; 
;  *  Q3CursorTracker_GetNotifyFunc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3CursorTracker_GetNotifyFunc" 
      ((notifyFunc (:pointer :pointer))) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QD3DControllerIncludes

; $ENDC                                         ; __QD3DCONTROLLER__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'QD3DController)