(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QD3DCustomElements.p"
; at Wednesday May 1,2002 2:42:21 pm.
; 
;      File:       QD3DCustomElements.p
;  
;      Contains:   Custom QuickTime Elements in QuickDraw 3D
;  
;      Version:    Technology: Quickdraw 3D 1.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __QD3DCUSTOMELEMENTS__
; $SETC __QD3DCUSTOMELEMENTS__ := 1

; $I+
; $SETC QD3DCustomElementsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __QD3D__
|#

(require-interface 'QD3D)
#|                                              ; $I QD3D.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MOVIES__
|#

(require-interface 'Movies)
#|                                              ; $I Movies.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

; *****************************************************************************
;  **                                                                          **
;  **                     Custom Name Element Functions                        **
;  **                                                                          **
;  ****************************************************************************
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  CENameElement_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CENameElement_SetData" 
      ((object :pointer) (name :pointer)) 
  :tq3status
   () )

; 
;  *  CENameElement_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CENameElement_GetData" 
      ((object :pointer) (name (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  CENameElement_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CENameElement_EmptyData" 
      ((name (:pointer :pointer))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         URL Data Structure Definitions                   **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tceurloptions (find-mactype ':signed-long))

(defconstant $kCEUrlOptionNone 0)
(defconstant $kCEUrlOptionUseMap 1)

(def-mactype :tceurldataptr (find-mactype '(:pointer :tceurldata)))
(defrecord TCEUrlData 
   (url :pointer)
   (description :pointer)
   (options :signed-long)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                     Custom URL Element Functions                         **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  CEUrlElement_SetData()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_CEUrlElement_SetData" 
      ((object :pointer) (urlData (:pointer :tceurldata))) 
  :tq3status
   () )

; 
;  *  CEUrlElement_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CEUrlElement_GetData" 
      ((object :pointer) (urlData (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  CEUrlElement_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CEUrlElement_EmptyData" 
      ((urlData (:pointer :pointer))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Wire Data Definitions                            **
;  **                                                                          **
;  ****************************************************************************

; *****************************************************************************
;  **                                                                          **
;  **                     Wire Custom Element Functions                        **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  CEWireElement_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CEWireElement_SetData" 
      ((object :pointer) (wireData :handle)) 
  :tq3status
   () )

; 
;  *  CEWireElement_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CEWireElement_GetData" 
      ((object :pointer) (wireData (:pointer :handle))) 
  :tq3status
   () )

; 
;  *  CEWireElement_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CEWireElement_EmptyData" 
      ((wireData (:pointer :handle))) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QD3DCustomElementsIncludes

; $ENDC                                         ; __QD3DCUSTOMELEMENTS__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'QD3DCustomElements)