(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QD3DDrawContext.p"
; at Wednesday May 1,2002 2:42:21 pm.
; 
;      File:       QD3DDrawContext.p
;  
;      Contains:   Draw context class types and routines
;  
;      Version:    Technology: Quickdraw 3D 1.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __QD3DDRAWCONTEXT__
; $SETC __QD3DDRAWCONTEXT__ := 1

; $I+
; $SETC QD3DDrawContextIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __QD3D__
|#

(require-interface 'QD3D)
#|                                              ; $I QD3D.p
 |#                                             ; $ENDC

; $IFC TARGET_OS_MAC 
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FIXMATH__
|#

(require-interface 'FixMath)
#|                                              ; $I FixMath.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __GXTYPES__
|#

(require-interface 'GXTypes)
#|                                              ; $I GXTypes.p
 |#                                             ; $ENDC
; $ENDC                                         ; TARGET_OS_MAC

; $PUSH
; $ALIGN POWER
; $LibExport+

; *****************************************************************************
;  **                                                                          **
;  **                         DrawContext Data Structures                      **
;  **                                                                          **
;  ****************************************************************************

(def-mactype :tq3drawcontextclearimagemethod (find-mactype ':signed-long))

(defconstant $kQ3ClearMethodNone 0)
(defconstant $kQ3ClearMethodWithColor 1)

(def-mactype :tq3drawcontextdataptr (find-mactype '(:pointer :tq3drawcontextdata)))
(defrecord TQ3DrawContextData 
   (clearImageMethod :signed-long)
   (clearImageColor :tq3colorargb)
   (pane :tq3area)
   (paneState :signed-long)
   (mask :tq3bitmap)
   (maskState :signed-long)
   (doubleBufferState :signed-long)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             DrawContext Routines                         **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3DrawContext_GetType()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3DrawContext_GetType" 
      ((drawContext :pointer)) 
  :tq3objecttype
   () )

; 
;  *  Q3DrawContext_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3DrawContext_SetData" 
      ((context :pointer) (contextData (:pointer :tq3drawcontextdata))) 
  :tq3status
   () )

; 
;  *  Q3DrawContext_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DrawContext_GetData" 
      ((context :pointer) (contextData (:pointer :tq3drawcontextdata))) 
  :tq3status
   () )

; 
;  *  Q3DrawContext_SetClearImageColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3DrawContext_SetClearImageColor" 
      ((context :pointer) (color (:pointer :tq3colorargb))) 
  :tq3status
   () )

; 
;  *  Q3DrawContext_GetClearImageColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DrawContext_GetClearImageColor" 
      ((context :pointer) (color (:pointer :tq3colorargb))) 
  :tq3status
   () )

; 
;  *  Q3DrawContext_SetPane()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3DrawContext_SetPane" 
      ((context :pointer) (pane (:pointer :tq3area))) 
  :tq3status
   () )

; 
;  *  Q3DrawContext_GetPane()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DrawContext_GetPane" 
      ((context :pointer) (pane (:pointer :tq3area))) 
  :tq3status
   () )

; 
;  *  Q3DrawContext_SetPaneState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DrawContext_SetPaneState" 
      ((context :pointer) (state :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3DrawContext_GetPaneState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DrawContext_GetPaneState" 
      ((context :pointer) (state (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3DrawContext_SetClearImageMethod()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DrawContext_SetClearImageMethod" 
      ((context :pointer) (method :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3DrawContext_GetClearImageMethod()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DrawContext_GetClearImageMethod" 
      ((context :pointer) (method (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3DrawContext_SetMask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3DrawContext_SetMask" 
      ((context :pointer) (mask (:pointer :tq3bitmap))) 
  :tq3status
   () )

; 
;  *  Q3DrawContext_GetMask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DrawContext_GetMask" 
      ((context :pointer) (mask (:pointer :tq3bitmap))) 
  :tq3status
   () )

; 
;  *  Q3DrawContext_SetMaskState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DrawContext_SetMaskState" 
      ((context :pointer) (state :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3DrawContext_GetMaskState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DrawContext_GetMaskState" 
      ((context :pointer) (state (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3DrawContext_SetDoubleBufferState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DrawContext_SetDoubleBufferState" 
      ((context :pointer) (state :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3DrawContext_GetDoubleBufferState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DrawContext_GetDoubleBufferState" 
      ((context :pointer) (state (:pointer :signed-long))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Pixmap Data Structure                            **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3pixmapdrawcontextdataptr (find-mactype '(:pointer :tq3pixmapdrawcontextdata)))
(defrecord TQ3PixmapDrawContextData 
   (drawContextData :tq3drawcontextdata)
   (pixmap :tq3pixmap)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                     Pixmap DrawContext Routines                          **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3PixmapDrawContext_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3PixmapDrawContext_New" 
      ((contextData (:pointer :tq3pixmapdrawcontextdata))) 
  :pointer
   () )

; 
;  *  Q3PixmapDrawContext_SetPixmap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3PixmapDrawContext_SetPixmap" 
      ((drawContext :pointer) (pixmap (:pointer :tq3pixmap))) 
  :tq3status
   () )

; 
;  *  Q3PixmapDrawContext_GetPixmap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PixmapDrawContext_GetPixmap" 
      ((drawContext :pointer) (pixmap (:pointer :tq3pixmap))) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC TARGET_OS_MAC 
; *****************************************************************************
;  **                                                                          **
;  **                     Macintosh DrawContext Data Structures                **
;  **                                                                          **
;  ****************************************************************************

(def-mactype :tq3macdrawcontext2dlibrary (find-mactype ':signed-long))

(defconstant $kQ3Mac2DLibraryNone 0)
(defconstant $kQ3Mac2DLibraryQuickDraw 1)
(defconstant $kQ3Mac2DLibraryQuickDrawGX 2)

(def-mactype :tq3macdrawcontextdataptr (find-mactype '(:pointer :tq3macdrawcontextdata)))
(defrecord TQ3MacDrawContextData 
   (drawContextData :tq3drawcontextdata)
   (window (:pointer :cgrafport))
   (library :signed-long)
   (viewPort :pointer)
   (grafPort (:pointer :cgrafport))
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                     Macintosh DrawContext Routines                       **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3MacDrawContext_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3MacDrawContext_New" 
      ((drawContextData (:pointer :tq3macdrawcontextdata))) 
  :pointer
   () )

; 
;  *  Q3MacDrawContext_SetWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3MacDrawContext_SetWindow" 
      ((drawContext :pointer) (window (:pointer :cgrafport))) 
  :tq3status
   () )

; 
;  *  Q3MacDrawContext_GetWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3MacDrawContext_GetWindow" 
      ((drawContext :pointer) (window (:pointer (:pointer :cgrafport)))) 
  :tq3status
   () )

; 
;  *  Q3MacDrawContext_SetGXViewPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3MacDrawContext_SetGXViewPort" 
      ((drawContext :pointer) (viewPort :pointer)) 
  :tq3status
   () )

; 
;  *  Q3MacDrawContext_GetGXViewPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3MacDrawContext_GetGXViewPort" 
      ((drawContext :pointer) (viewPort (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3MacDrawContext_SetGrafPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3MacDrawContext_SetGrafPort" 
      ((drawContext :pointer) (grafPort (:pointer :cgrafport))) 
  :tq3status
   () )

; 
;  *  Q3MacDrawContext_GetGrafPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3MacDrawContext_GetGrafPort" 
      ((drawContext :pointer) (grafPort (:pointer (:pointer :cgrafport)))) 
  :tq3status
   () )

; 
;  *  Q3MacDrawContext_Set2DLibrary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3MacDrawContext_Set2DLibrary" 
      ((drawContext :pointer) (library :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3MacDrawContext_Get2DLibrary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3MacDrawContext_Get2DLibrary" 
      ((drawContext :pointer) (library (:pointer :signed-long))) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; TARGET_OS_MAC

#|                                              ; $IFC TARGET_OS_UNIX 
; *****************************************************************************
;  **                                                                          **
;  **                     X/Windows DrawContext Data Structures                **
;  **                                                                          **
;  ****************************************************************************

(def-mactype :tq3xbufferobject (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :tq3xbufferobjectptr (find-mactype '(:pointer :tq3xbufferobject)));  when a VAR xx:TQ3XBufferObject parameter can be nil, it is changed to xx: TQ3XBufferObjectPtr 
(def-mactype :tq3xcolormapdataptr (find-mactype '(:pointer :tq3xcolormapdata)))
(defrecord TQ3XColormapData 
   (baseEntry :signed-long)
   (maxRed :signed-long)
   (maxGreen :signed-long)
   (maxBlue :signed-long)
   (multRed :signed-long)
   (multGreen :signed-long)
   (multBlue :signed-long)
   )

(def-mactype :tq3xdrawcontextdataptr (find-mactype '(:pointer :tq3xdrawcontextdata)))
(defrecord TQ3XDrawContextData 
   (contextData :tq3drawcontextdata)
   (Display (:pointer :display))
#|
; Warning: type-size: unknown type drawable
|##|
; Warning: type-size: unknown type drawable
|#
   (Drawable :drawable)
   (Visual (:pointer :visual))
#|
; Warning: type-size: unknown type colormap
|##|
; Warning: type-size: unknown type colormap
|#
   (cmap :colormap)
#|
; Warning: type-size: unknown type tq3xcolormapdataptr
|##|
; Warning: type-size: unknown type tq3xcolormapdataptr
|#
   (colorMapData :tq3xcolormapdataptr)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                     X/Windows DrawContext Routines                       **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC NOT UNDEFINED XDC_OLD 
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3XDrawContext_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3XDrawContext_New" 
      () 
  :pointer
   () )

; 
;  *  Q3XDrawContext_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawContext_Set" 
      ((drawContext :pointer) (flag :unsigned-long) (data :pointer)) 
  nil
   () )

; 
;  *  Q3XDrawContext_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawContext_Get" 
      ((drawContext :pointer) (flag :unsigned-long) (data :pointer)) 
  nil
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Q3XBuffers_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XBuffers_New" 
      ((dpy (:pointer :display)) (numBuffers :unsigned-long) (Window :window)) 
  :tq3xbufferobject
   () )

; 
;  *  Q3XBuffers_Swap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XBuffers_Swap" 
      ((dpy (:pointer :display)) (buffers :tq3xbufferobject)) 
  nil
   () )

; 
;  *  Q3X_GetVisualInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3X_GetVisualInfo" 
      ((dpy (:pointer :display)) (Screen (:pointer :screen))) 
  (:pointer :xvisualinfo)
   () )

; 
;  *  Q3XDrawContext_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3XDrawContext_New" 
      ((xContextData (:pointer :tq3xdrawcontextdata))) 
  :pointer
   () )

; 
;  *  Q3XDrawContext_SetDisplay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3XDrawContext_SetDisplay" 
      ((drawContext :pointer) (Display (:pointer :display))) 
  :tq3status
   () )

; 
;  *  Q3XDrawContext_GetDisplay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawContext_GetDisplay" 
      ((drawContext :pointer) (display (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3XDrawContext_SetDrawable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawContext_SetDrawable" 
      ((drawContext :pointer) (Drawable :drawable)) 
  :tq3status
   () )

; 
;  *  Q3XDrawContext_GetDrawable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawContext_GetDrawable" 
      ((drawContext :pointer) (Drawable (:pointer :drawable))) 
  :tq3status
   () )

; 
;  *  Q3XDrawContext_SetVisual()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3XDrawContext_SetVisual" 
      ((drawContext :pointer) (Visual (:pointer :visual))) 
  :tq3status
   () )

; 
;  *  Q3XDrawContext_GetVisual()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawContext_GetVisual" 
      ((drawContext :pointer) (visual (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3XDrawContext_SetColormap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawContext_SetColormap" 
      ((drawContext :pointer) (Colormap :colormap)) 
  :tq3status
   () )

; 
;  *  Q3XDrawContext_GetColormap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawContext_GetColormap" 
      ((drawContext :pointer) (Colormap (:pointer :colormap))) 
  :tq3status
   () )

; 
;  *  Q3XDrawContext_SetColormapData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3XDrawContext_SetColormapData" 
      ((drawContext :pointer) (colormapData (:pointer :tq3xcolormapdata))) 
  :tq3status
   () )

; 
;  *  Q3XDrawContext_GetColormapData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawContext_GetColormapData" 
      ((drawContext :pointer) (colormapData (:pointer :tq3xcolormapdata))) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC; TARGET_OS_UNIX

#|                                              ; $IFC TARGET_OS_WIN32 
; *****************************************************************************
;  **                                                                          **
;  **                      Win32 DrawContext Data Structures                   **
;  **                                                                          **
;  ****************************************************************************

(def-mactype :tq3win32dcdrawcontextdataptr (find-mactype '(:pointer :tq3win32dcdrawcontextdata)))
(defrecord TQ3Win32DCDrawContextData 
   (drawContextData :tq3drawcontextdata)
#|
; Warning: type-size: unknown type hdc
|##|
; Warning: type-size: unknown type hdc
|#
   (_hdc :hdc)
   )

; $IFC UNDEFINED QD3D_NO_DIRECTDRAW 
(def-mactype :tq3directdrawobjectselector (find-mactype ':signed-long))

(defconstant $kQ3DirectDrawObject 1)
(defconstant $kQ3DirectDrawObject2 2)

(def-mactype :tq3directdrawsurfaceselector (find-mactype ':signed-long))

(defconstant $kQ3DirectDrawSurface 1)
(defconstant $kQ3DirectDrawSurface2 2)

(def-mactype :tq3ddsurfacedescriptorptr (find-mactype '(:pointer :tq3ddsurfacedescriptor)))
(defrecord TQ3DDSurfaceDescriptor 
#|
; Warning: type-size: unknown type tq3directdrawobjectselector
|##|
; Warning: type-size: unknown type tq3directdrawobjectselector
|#
   (objectSelector :tq3directdrawobjectselector)
   (filler (:array :signed-long 4))
   )

(def-mactype :tq3ddsurfacedrawcontextdataptr (find-mactype '(:pointer :tq3ddsurfacedrawcontextdata)))
(defrecord TQ3DDSurfaceDrawContextData 
   (drawContextData :tq3drawcontextdata)
#|
; Warning: type-size: unknown type tq3ddsurfacedescriptor
|##|
; Warning: type-size: unknown type tq3ddsurfacedescriptor
|#
   (ddSurfaceDescriptor :tq3ddsurfacedescriptor)
   )

; $ENDC
; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                         Win32DC DrawContext Routines                     **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Win32DCDrawContext_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3Win32DCDrawContext_New" 
      ((drawContextData (:pointer :tq3win32dcdrawcontextdata))) 
  :pointer
   () )

; 
;  *  Q3Win32DCDrawContext_SetDC()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Win32DCDrawContext_SetDC" 
      ((drawContext :pointer) (newHDC :hdc)) 
  :tq3status
   () )

; 
;  *  Q3Win32DCDrawContext_GetDC()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Win32DCDrawContext_GetDC" 
      ((drawContext :pointer) (curHDC (:pointer :hdc))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         DDSurface DrawContext Routines                   **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON
; $IFC UNDEFINED QD3D_NO_DIRECTDRAW 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Q3DDSurfaceDrawContext_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3DDSurfaceDrawContext_New" 
      ((drawContextData (:pointer :tq3ddsurfacedrawcontextdata))) 
  :pointer
   () )

; 
;  *  Q3DDSurfaceDrawContext_SetDirectDrawSurface()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3DDSurfaceDrawContext_SetDirectDrawSurface" 
      ((drawContext :pointer) (ddSurfaceDescriptor (:pointer :tq3ddsurfacedescriptor))) 
  :tq3status
   () )

; 
;  *  Q3DDSurfaceDrawContext_GetDirectDrawSurface()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DDSurfaceDrawContext_GetDirectDrawSurface" 
      ((drawContext :pointer) (ddSurfaceDescriptor (:pointer :tq3ddsurfacedescriptor))) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC
 |#                                             ; $ENDC; TARGET_OS_WIN32

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QD3DDrawContextIncludes

; $ENDC                                         ; __QD3DDRAWCONTEXT__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'QD3DDrawContext)#|
; Warning: Did not recognize these types or records: (tq3xbufferobject tq3xcolormapdata tq3xdrawcontextdata display drawable visual colormap tq3xcolormapdataptr window screen xvisualinfo tq3win32dcdrawcontextdata hdc tq3ddsurfacedescriptor tq3directdrawobjectselector tq3ddsurfacedrawcontextdata)
|#