(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QD3DErrors.p"
; at Wednesday May 1,2002 2:42:22 pm.
; 
;      File:       QD3DErrors.p
;  
;      Contains:   Error API and error codes
;  
;      Version:    Technology: Quickdraw 3D 1.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __QD3DERRORS__
; $SETC __QD3DERRORS__ := 1

; $I+
; $SETC QD3DErrorsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __QD3D__
|#

(require-interface 'QD3D)
#|                                              ; $I QD3D.p
 |#                                             ; $ENDC

; $IFC TARGET_OS_MAC 
#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
; $ENDC                                         ; TARGET_OS_MAC

; $PUSH
; $ALIGN POWER
; $LibExport+

; *****************************************************************************
;  **                                                                          **
;  **                         Error Types and Codes                            **
;  **                                                                          **
;  ****************************************************************************

(def-mactype :tq3error (find-mactype ':signed-long))

(defconstant $kQ3ErrorNone 0)                   ;   Fatal Errors  
(defconstant $kQ3ErrorInternalError -28500)
(defconstant $kQ3ErrorNoRecovery -28499)
(defconstant $kQ3ErrorLastFatalError -28498)    ;   System Errors  
(defconstant $kQ3ErrorNotInitialized -28490)
(defconstant $kQ3ErrorAlreadyInitialized -28489)
(defconstant $kQ3ErrorUnimplemented -28488)
(defconstant $kQ3ErrorRegistrationFailed -28487);   OS Errors  
(defconstant $kQ3ErrorUnixError -28486)
(defconstant $kQ3ErrorMacintoshError -28485)
(defconstant $kQ3ErrorX11Error -28484)          ;   Memory Errors  
(defconstant $kQ3ErrorMemoryLeak -28483)
(defconstant $kQ3ErrorOutOfMemory -28482)       ;   Parameter errors  
(defconstant $kQ3ErrorNULLParameter -28481)
(defconstant $kQ3ErrorParameterOutOfRange -28480)
(defconstant $kQ3ErrorInvalidParameter -28479)
(defconstant $kQ3ErrorInvalidData -28478)
(defconstant $kQ3ErrorAcceleratorAlreadySet -28477)
(defconstant $kQ3ErrorVector3DNotUnitLength -28476)
(defconstant $kQ3ErrorVector3DZeroLength -28475);   Object Errors  
(defconstant $kQ3ErrorInvalidObject -28474)
(defconstant $kQ3ErrorInvalidObjectClass -28473)
(defconstant $kQ3ErrorInvalidObjectType -28472)
(defconstant $kQ3ErrorInvalidObjectName -28471)
(defconstant $kQ3ErrorObjectClassInUse -28470)
(defconstant $kQ3ErrorAccessRestricted -28469)
(defconstant $kQ3ErrorMetaHandlerRequired -28468)
(defconstant $kQ3ErrorNeedRequiredMethods -28467)
(defconstant $kQ3ErrorNoSubClassType -28466)
(defconstant $kQ3ErrorUnknownElementType -28465)
(defconstant $kQ3ErrorNotSupported -28464)      ;   Extension Errors  
(defconstant $kQ3ErrorNoExtensionsFolder -28463)
(defconstant $kQ3ErrorExtensionError -28462)
(defconstant $kQ3ErrorPrivateExtensionError -28461);   Geometry Errors  
(defconstant $kQ3ErrorDegenerateGeometry -28460)
(defconstant $kQ3ErrorGeometryInsufficientNumberOfPoints -28459);   IO Errors  
(defconstant $kQ3ErrorNoStorageSetForFile -28458)
(defconstant $kQ3ErrorEndOfFile -28457)
(defconstant $kQ3ErrorFileCancelled -28456)
(defconstant $kQ3ErrorInvalidMetafile -28455)
(defconstant $kQ3ErrorInvalidMetafilePrimitive -28454)
(defconstant $kQ3ErrorInvalidMetafileLabel -28453)
(defconstant $kQ3ErrorInvalidMetafileObject -28452)
(defconstant $kQ3ErrorInvalidMetafileSubObject -28451)
(defconstant $kQ3ErrorInvalidSubObjectForObject -28450)
(defconstant $kQ3ErrorUnresolvableReference -28449)
(defconstant $kQ3ErrorUnknownObject -28448)
(defconstant $kQ3ErrorStorageInUse -28447)
(defconstant $kQ3ErrorStorageAlreadyOpen -28446)
(defconstant $kQ3ErrorStorageNotOpen -28445)
(defconstant $kQ3ErrorStorageIsOpen -28444)
(defconstant $kQ3ErrorFileAlreadyOpen -28443)
(defconstant $kQ3ErrorFileNotOpen -28442)
(defconstant $kQ3ErrorFileIsOpen -28441)
(defconstant $kQ3ErrorBeginWriteAlreadyCalled -28440)
(defconstant $kQ3ErrorBeginWriteNotCalled -28439)
(defconstant $kQ3ErrorEndWriteNotCalled -28438)
(defconstant $kQ3ErrorReadStateInactive -28437)
(defconstant $kQ3ErrorStateUnavailable -28436)
(defconstant $kQ3ErrorWriteStateInactive -28435)
(defconstant $kQ3ErrorSizeNotLongAligned -28434)
(defconstant $kQ3ErrorFileModeRestriction -28433)
(defconstant $kQ3ErrorInvalidHexString -28432)
(defconstant $kQ3ErrorWroteMoreThanSize -28431)
(defconstant $kQ3ErrorWroteLessThanSize -28430)
(defconstant $kQ3ErrorReadLessThanSize -28429)
(defconstant $kQ3ErrorReadMoreThanSize -28428)
(defconstant $kQ3ErrorNoBeginGroup -28427)
(defconstant $kQ3ErrorSizeMismatch -28426)
(defconstant $kQ3ErrorStringExceedsMaximumLength -28425)
(defconstant $kQ3ErrorValueExceedsMaximumSize -28424)
(defconstant $kQ3ErrorNonUniqueLabel -28423)
(defconstant $kQ3ErrorEndOfContainer -28422)
(defconstant $kQ3ErrorUnmatchedEndGroup -28421)
(defconstant $kQ3ErrorFileVersionExists -28420) ;   View errors  
(defconstant $kQ3ErrorViewNotStarted -28419)
(defconstant $kQ3ErrorViewIsStarted -28418)
(defconstant $kQ3ErrorRendererNotSet -28417)
(defconstant $kQ3ErrorRenderingIsActive -28416)
(defconstant $kQ3ErrorImmediateModeUnderflow -28415)
(defconstant $kQ3ErrorDisplayNotSet -28414)
(defconstant $kQ3ErrorCameraNotSet -28413)
(defconstant $kQ3ErrorDrawContextNotSet -28412)
(defconstant $kQ3ErrorNonInvertibleMatrix -28411)
(defconstant $kQ3ErrorRenderingNotStarted -28410)
(defconstant $kQ3ErrorPickingNotStarted -28409)
(defconstant $kQ3ErrorBoundsNotStarted -28408)
(defconstant $kQ3ErrorDataNotAvailable -28407)
(defconstant $kQ3ErrorNothingToPop -28406)      ;   Renderer Errors  
(defconstant $kQ3ErrorUnknownStudioType -28405)
(defconstant $kQ3ErrorAlreadyRendering -28404)
(defconstant $kQ3ErrorStartGroupRange -28403)
(defconstant $kQ3ErrorUnsupportedGeometryType -28402)
(defconstant $kQ3ErrorInvalidGeometryType -28401)
(defconstant $kQ3ErrorUnsupportedFunctionality -28400);   Group Errors  
(defconstant $kQ3ErrorInvalidPositionForGroup -28399)
(defconstant $kQ3ErrorInvalidObjectForGroup -28398)
(defconstant $kQ3ErrorInvalidObjectForPosition -28397);   Transform Errors  
(defconstant $kQ3ErrorScaleOfZero -28396)       ;   String Errors  
(defconstant $kQ3ErrorBadStringType -28395)     ;   Attribute Errors  
(defconstant $kQ3ErrorAttributeNotContained -28394)
(defconstant $kQ3ErrorAttributeInvalidType -28393);   Camera Errors  
(defconstant $kQ3ErrorInvalidCameraValues -28392);   DrawContext Errors  
(defconstant $kQ3ErrorBadDrawContextType -28391)
(defconstant $kQ3ErrorBadDrawContextFlag -28390)
(defconstant $kQ3ErrorBadDrawContext -28389)
(defconstant $kQ3ErrorUnsupportedPixelDepth -28388);   Controller Errors  
(defconstant $kQ3ErrorController -28387)        ;   Tracker Errors  
(defconstant $kQ3ErrorTracker -28386)           ;   Another OS Error  
(defconstant $kQ3ErrorWin32Error -28385)        ;   Object Errors  
(defconstant $kQ3ErrorTypeAlreadyExistsAndHasSubclasses -28384)
(defconstant $kQ3ErrorTypeAlreadyExistsAndOtherClassesDependOnIt -28383)
(defconstant $kQ3ErrorTypeAlreadyExistsAndHasObjectInstances -28382);   submit loop errors: if you ever get one of these check the previous 
;   error posted, it may be kQ3ErrorOutOfMemory.  If so you *may* be able 
;   to recover by freeing up some memory and trying again 
(defconstant $kQ3ErrorPickingLoopFailed -28381)
(defconstant $kQ3ErrorRenderingLoopFailed -28380)
(defconstant $kQ3ErrorWritingLoopFailed -28379)
(defconstant $kQ3ErrorBoundingLoopFailed -28378)

(def-mactype :tq3warning (find-mactype ':signed-long))

(defconstant $kQ3WarningNone 0)                 ;   General System  
(defconstant $kQ3WarningInternalException -28300);   Object Warnings  
(defconstant $kQ3WarningNoObjectSupportForDuplicateMethod -28299)
(defconstant $kQ3WarningNoObjectSupportForDrawMethod -28298)
(defconstant $kQ3WarningNoObjectSupportForWriteMethod -28297)
(defconstant $kQ3WarningNoObjectSupportForReadMethod -28296)
(defconstant $kQ3WarningUnknownElementType -28295)
(defconstant $kQ3WarningTypeAndMethodAlreadyDefined -28294)
(defconstant $kQ3WarningTypeIsOutOfRange -28293)
(defconstant $kQ3WarningTypeHasNotBeenRegistered -28292);   Parameter Warnings  
(defconstant $kQ3WarningVector3DNotUnitLength -28291);   IO Warnings  
(defconstant $kQ3WarningInvalidSubObjectForObject -28290)
(defconstant $kQ3WarningInvalidHexString -28289)
(defconstant $kQ3WarningUnknownObject -28288)
(defconstant $kQ3WarningInvalidMetafileObject -28287)
(defconstant $kQ3WarningUnmatchedBeginGroup -28286)
(defconstant $kQ3WarningUnmatchedEndGroup -28285)
(defconstant $kQ3WarningInvalidTableOfContents -28284)
(defconstant $kQ3WarningUnresolvableReference -28283)
(defconstant $kQ3WarningNoAttachMethod -28282)
(defconstant $kQ3WarningInconsistentData -28281)
(defconstant $kQ3WarningReadLessThanSize -28280)
(defconstant $kQ3WarningFilePointerResolutionFailed -28279)
(defconstant $kQ3WarningFilePointerRedefined -28278)
(defconstant $kQ3WarningStringExceedsMaximumLength -28277);   Memory Warnings  
(defconstant $kQ3WarningLowMemory -28276)
(defconstant $kQ3WarningPossibleMemoryLeak -28275);   View Warnings  
(defconstant $kQ3WarningViewTraversalInProgress -28274)
(defconstant $kQ3WarningNonInvertibleMatrix -28273);   Quaternion Warning  
(defconstant $kQ3WarningQuaternionEntriesAreZero -28272);   Renderer Warning  
(defconstant $kQ3WarningFunctionalityNotSupported -28271);   DrawContext Warning  
(defconstant $kQ3WarningInvalidPaneDimensions -28270);   Pick Warning  
(defconstant $kQ3WarningPickParamOutside -28269);   Scale Warnings  
(defconstant $kQ3WarningScaleEntriesAllZero -28268)
(defconstant $kQ3WarningScaleContainsNegativeEntries -28267);   Generic Warnings  
(defconstant $kQ3WarningParameterOutOfRange -28266);   Extension Warnings  
(defconstant $kQ3WarningExtensionNotLoading -28265);   Object Warnings  
(defconstant $kQ3WarningTypeAlreadyRegistered -28264)
(defconstant $kQ3WarningTypeSameVersionAlreadyRegistered -28263)
(defconstant $kQ3WarningTypeNewerVersionAlreadyRegistered -28262);   Invalid Group Object  
(defconstant $kQ3WarningInvalidObjectInGroupMetafile -28261)

(def-mactype :tq3notice (find-mactype ':signed-long))

(defconstant $kQ3NoticeNone 0)
(defconstant $kQ3NoticeDataAlreadyEmpty -28100)
(defconstant $kQ3NoticeMethodNotSupported -28099)
(defconstant $kQ3NoticeObjectAlreadySet -28098)
(defconstant $kQ3NoticeParameterOutOfRange -28097)
(defconstant $kQ3NoticeFileAliasWasChanged -28096)
(defconstant $kQ3NoticeMeshVertexHasNoComponent -28095)
(defconstant $kQ3NoticeMeshInvalidVertexFacePair -28094)
(defconstant $kQ3NoticeMeshEdgeVertexDoNotCorrespond -28093)
(defconstant $kQ3NoticeMeshEdgeIsNotBoundary -28092)
(defconstant $kQ3NoticeDrawContextNotSetUsingInternalDefaults -28091)
(defconstant $kQ3NoticeInvalidAttenuationTypeUsingInternalDefaults -28090)
(defconstant $kQ3NoticeBrightnessGreaterThanOne -28089)
(defconstant $kQ3NoticeScaleContainsZeroEntries -28088)
(defconstant $kQ3NoticeSystemAlreadyInitialized -28087)
(defconstant $kQ3NoticeViewSyncCalledAgain -28086)
(defconstant $kQ3NoticeFileCancelled -28085)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3ErrorMethod = PROCEDURE(firstError: TQ3Error; lastError: TQ3Error; reference: LONGINT); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3errormethod (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3WarningMethod = PROCEDURE(firstWarning: TQ3Warning; lastWarning: TQ3Warning; reference: LONGINT); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3warningmethod (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3NoticeMethod = PROCEDURE(firstNotice: TQ3Notice; lastNotice: TQ3Notice; reference: LONGINT); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3noticemethod (find-mactype ':pointer))
; $ENDC

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             Error Routines                               **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Error_Register()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3Error_Register" 
      ((errorPost :pointer) (reference :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3Warning_Register()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Warning_Register" 
      ((warningPost :pointer) (reference :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3Notice_Register()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Notice_Register" 
      ((noticePost :pointer) (reference :signed-long)) 
  :tq3status
   () )

; 
;  *  Getting error codes -
;  *  Clears error type on next entry into system (except all of these 
;  *  error calls), and returns the last error, and optionally the 
;  *  first error. The parameter to these "_Get" calls may be NULL.
;  
; 
;  *  Q3Error_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Error_Get" 
      ((firstError (:pointer :signed-long))) 
  :tq3error
   () )

; 
;  *  Q3Error_IsFatalError()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Error_IsFatalError" 
      ((error :signed-long)) 
  :tq3boolean
   () )

; 
;  *  Q3Warning_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Warning_Get" 
      ((firstWarning (:pointer :signed-long))) 
  :tq3warning
   () )

; 
;  *  Q3Notice_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Notice_Get" 
      ((firstNotice (:pointer :signed-long))) 
  :tq3notice
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC TARGET_OS_MAC 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Q3MacintoshError_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3MacintoshError_Get" 
      ((firstMacErr (:pointer :signed-integer))) 
  :signed-integer
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; TARGET_OS_MAC

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QD3DErrorsIncludes

; $ENDC                                         ; __QD3DERRORS__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'QD3DErrors)