(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QD3DGeometry.p"
; at Wednesday May 1,2002 2:42:23 pm.
; 
;      File:       QD3DGeometry.p
;  
;      Contains:   Q3Geometry methods
;  
;      Version:    Technology: Quickdraw 3D 1.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __QD3DGEOMETRY__
; $SETC __QD3DGEOMETRY__ := 1

; $I+
; $SETC QD3DGeometryIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __QD3D__
|#

(require-interface 'QD3D)
#|                                              ; $I QD3D.p
 |#                                             ; $ENDC

; $IFC UNDEFINED __QD3DSET__

(require-interface 'QD3DSet)                    ; $I QD3DSet.p
; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

; *****************************************************************************
;  **                                                                          **
;  **                             Geometry Routines                            **
;  **                                                                          **
;  ****************************************************************************
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Q3Geometry_GetType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Geometry_GetType" 
      ((geometry :pointer)) 
  :tq3objecttype
   () )

; 
;  *  Q3Geometry_GetAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Geometry_GetAttributeSet" 
      ((geometry :pointer) (attributeSet (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Geometry_SetAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Geometry_SetAttributeSet" 
      ((geometry :pointer) (attributeSet :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Geometry_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Geometry_Submit" 
      ((geometry :pointer) (view :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Box Data Structure Definitions                   **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(defrecord TQ3AttributeSetArray (array (:array :pointer 6)))
(def-mactype :tq3attributesetarrayptr (find-mactype '(:pointer :tq3attributesetarray)))
(def-mactype :tq3boxdataptr (find-mactype '(:pointer :tq3boxdata)))
(defrecord TQ3BoxData 
   (origin :tq3point3d)
   (orientation :tq3vector3d)
   (majorAxis :tq3vector3d)
   (minorAxis :tq3vector3d)
   (faceAttributeSet (:pointer :tq3attributesetarray));   Ordering : Left, right,     
;             front, back,    
;             top, bottom     
   (boxAttributeSet :pointer)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             Box Routines                                 **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Box_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3Box_New" 
      ((boxData (:pointer :tq3boxdata))) 
  :pointer
   () )

; 
;  *  Q3Box_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Box_Submit" 
      ((boxData (:pointer :tq3boxdata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Box_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Box_SetData" 
      ((box :pointer) (boxData (:pointer :tq3boxdata))) 
  :tq3status
   () )

; 
;  *  Q3Box_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Box_GetData" 
      ((box :pointer) (boxData (:pointer :tq3boxdata))) 
  :tq3status
   () )

; 
;  *  Q3Box_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Box_EmptyData" 
      ((boxData (:pointer :tq3boxdata))) 
  :tq3status
   () )

; 
;  *  Q3Box_SetOrigin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Box_SetOrigin" 
      ((box :pointer) (origin (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Box_SetOrientation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Box_SetOrientation" 
      ((box :pointer) (orientation (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Box_SetMajorAxis()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Box_SetMajorAxis" 
      ((box :pointer) (majorAxis (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Box_SetMinorAxis()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Box_SetMinorAxis" 
      ((box :pointer) (minorAxis (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Box_GetOrigin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Box_GetOrigin" 
      ((box :pointer) (origin (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Box_GetOrientation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Box_GetOrientation" 
      ((box :pointer) (orientation (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Box_GetMajorAxis()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Box_GetMajorAxis" 
      ((box :pointer) (majorAxis (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Box_GetMinorAxis()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Box_GetMinorAxis" 
      ((box :pointer) (minorAxis (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Box_GetFaceAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Box_GetFaceAttributeSet" 
      ((box :pointer) (faceIndex :unsigned-long) (faceAttributeSet (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Box_SetFaceAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Box_SetFaceAttributeSet" 
      ((box :pointer) (faceIndex :unsigned-long) (faceAttributeSet :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Cone Data Structure Definitions                      **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3conedataptr (find-mactype '(:pointer :tq3conedata)))
(defrecord TQ3ConeData 
   (origin :tq3point3d)
   (orientation :tq3vector3d)
   (majorRadius :tq3vector3d)
   (minorRadius :tq3vector3d)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (uMin :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (uMax :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (vMin :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (vMax :single-float)
   (caps :unsigned-long)
   (interiorAttributeSet :pointer)
   (faceAttributeSet :pointer)
   (bottomAttributeSet :pointer)
   (coneAttributeSet :pointer)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             Cone Routines                                **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Cone_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3Cone_New" 
      ((coneData (:pointer :tq3conedata))) 
  :pointer
   () )

; 
;  *  Q3Cone_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Cone_Submit" 
      ((coneData (:pointer :tq3conedata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Cone_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Cone_SetData" 
      ((cone :pointer) (coneData (:pointer :tq3conedata))) 
  :tq3status
   () )

; 
;  *  Q3Cone_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cone_GetData" 
      ((cone :pointer) (coneData (:pointer :tq3conedata))) 
  :tq3status
   () )

; 
;  *  Q3Cone_SetOrigin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Cone_SetOrigin" 
      ((cone :pointer) (origin (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Cone_SetOrientation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Cone_SetOrientation" 
      ((cone :pointer) (orientation (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Cone_SetMajorRadius()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Cone_SetMajorRadius" 
      ((cone :pointer) (majorRadius (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Cone_SetMinorRadius()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Cone_SetMinorRadius" 
      ((cone :pointer) (minorRadius (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Cone_GetOrigin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cone_GetOrigin" 
      ((cone :pointer) (origin (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Cone_GetOrientation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cone_GetOrientation" 
      ((cone :pointer) (orientation (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Cone_GetMajorRadius()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cone_GetMajorRadius" 
      ((cone :pointer) (majorRadius (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Cone_GetMinorRadius()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cone_GetMinorRadius" 
      ((cone :pointer) (minorRadius (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Cone_SetCaps()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cone_SetCaps" 
      ((cone :pointer) (caps :unsigned-long)) 
  :tq3status
   () )

; 
;  *  Q3Cone_GetCaps()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cone_GetCaps" 
      ((cone :pointer) (caps (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Cone_SetBottomAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cone_SetBottomAttributeSet" 
      ((cone :pointer) (bottomAttributeSet :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Cone_GetBottomAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cone_GetBottomAttributeSet" 
      ((cone :pointer) (bottomAttributeSet (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Cone_SetFaceAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cone_SetFaceAttributeSet" 
      ((cone :pointer) (faceAttributeSet :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Cone_GetFaceAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cone_GetFaceAttributeSet" 
      ((cone :pointer) (faceAttributeSet (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Cone_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cone_EmptyData" 
      ((coneData (:pointer :tq3conedata))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Cylinder Data Structure Definitions                  **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3cylinderdataptr (find-mactype '(:pointer :tq3cylinderdata)))
(defrecord TQ3CylinderData 
   (origin :tq3point3d)
   (orientation :tq3vector3d)
   (majorRadius :tq3vector3d)
   (minorRadius :tq3vector3d)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (uMin :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (uMax :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (vMin :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (vMax :single-float)
   (caps :unsigned-long)
   (interiorAttributeSet :pointer)
   (topAttributeSet :pointer)
   (faceAttributeSet :pointer)
   (bottomAttributeSet :pointer)
   (cylinderAttributeSet :pointer)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                         Cylinder Routines                                **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Cylinder_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3Cylinder_New" 
      ((cylinderData (:pointer :tq3cylinderdata))) 
  :pointer
   () )

; 
;  *  Q3Cylinder_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Cylinder_Submit" 
      ((cylinderData (:pointer :tq3cylinderdata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Cylinder_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Cylinder_SetData" 
      ((cylinder :pointer) (cylinderData (:pointer :tq3cylinderdata))) 
  :tq3status
   () )

; 
;  *  Q3Cylinder_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cylinder_GetData" 
      ((cylinder :pointer) (cylinderData (:pointer :tq3cylinderdata))) 
  :tq3status
   () )

; 
;  *  Q3Cylinder_SetOrigin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Cylinder_SetOrigin" 
      ((cylinder :pointer) (origin (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Cylinder_SetOrientation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Cylinder_SetOrientation" 
      ((cylinder :pointer) (orientation (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Cylinder_SetMajorRadius()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Cylinder_SetMajorRadius" 
      ((cylinder :pointer) (majorRadius (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Cylinder_SetMinorRadius()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Cylinder_SetMinorRadius" 
      ((cylinder :pointer) (minorRadius (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Cylinder_GetOrigin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cylinder_GetOrigin" 
      ((cylinder :pointer) (origin (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Cylinder_GetOrientation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cylinder_GetOrientation" 
      ((cylinder :pointer) (orientation (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Cylinder_GetMajorRadius()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cylinder_GetMajorRadius" 
      ((cylinder :pointer) (majorRadius (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Cylinder_GetMinorRadius()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cylinder_GetMinorRadius" 
      ((cylinder :pointer) (minorRadius (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Cylinder_SetCaps()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cylinder_SetCaps" 
      ((cylinder :pointer) (caps :unsigned-long)) 
  :tq3status
   () )

; 
;  *  Q3Cylinder_GetCaps()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cylinder_GetCaps" 
      ((cylinder :pointer) (caps (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Cylinder_SetTopAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cylinder_SetTopAttributeSet" 
      ((cylinder :pointer) (topAttributeSet :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Cylinder_GetTopAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cylinder_GetTopAttributeSet" 
      ((cylinder :pointer) (topAttributeSet (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Cylinder_SetBottomAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cylinder_SetBottomAttributeSet" 
      ((cylinder :pointer) (bottomAttributeSet :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Cylinder_GetBottomAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cylinder_GetBottomAttributeSet" 
      ((cylinder :pointer) (bottomAttributeSet (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Cylinder_SetFaceAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cylinder_SetFaceAttributeSet" 
      ((cylinder :pointer) (faceAttributeSet :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Cylinder_GetFaceAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cylinder_GetFaceAttributeSet" 
      ((cylinder :pointer) (faceAttributeSet (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Cylinder_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Cylinder_EmptyData" 
      ((cylinderData (:pointer :tq3cylinderdata))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Disk Data Structure Definitions                      **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3diskdataptr (find-mactype '(:pointer :tq3diskdata)))
(defrecord TQ3DiskData 
   (origin :tq3point3d)
   (majorRadius :tq3vector3d)
   (minorRadius :tq3vector3d)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (uMin :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (uMax :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (vMin :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (vMax :single-float)
   (diskAttributeSet :pointer)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             Disk Routines                                **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Disk_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3Disk_New" 
      ((diskData (:pointer :tq3diskdata))) 
  :pointer
   () )

; 
;  *  Q3Disk_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Disk_Submit" 
      ((diskData (:pointer :tq3diskdata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Disk_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Disk_SetData" 
      ((disk :pointer) (diskData (:pointer :tq3diskdata))) 
  :tq3status
   () )

; 
;  *  Q3Disk_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Disk_GetData" 
      ((disk :pointer) (diskData (:pointer :tq3diskdata))) 
  :tq3status
   () )

; 
;  *  Q3Disk_SetOrigin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Disk_SetOrigin" 
      ((disk :pointer) (origin (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Disk_SetMajorRadius()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Disk_SetMajorRadius" 
      ((disk :pointer) (majorRadius (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Disk_SetMinorRadius()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Disk_SetMinorRadius" 
      ((disk :pointer) (minorRadius (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Disk_GetOrigin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Disk_GetOrigin" 
      ((disk :pointer) (origin (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Disk_GetMajorRadius()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Disk_GetMajorRadius" 
      ((disk :pointer) (majorRadius (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Disk_GetMinorRadius()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Disk_GetMinorRadius" 
      ((disk :pointer) (minorRadius (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Disk_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Disk_EmptyData" 
      ((diskData (:pointer :tq3diskdata))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                  Ellipse Data Structure Definitions                      **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3ellipsedataptr (find-mactype '(:pointer :tq3ellipsedata)))
(defrecord TQ3EllipseData 
   (origin :tq3point3d)
   (majorRadius :tq3vector3d)
   (minorRadius :tq3vector3d)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (uMin :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (uMax :single-float)
   (ellipseAttributeSet :pointer)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             Ellipse Routines                             **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Ellipse_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3Ellipse_New" 
      ((ellipseData (:pointer :tq3ellipsedata))) 
  :pointer
   () )

; 
;  *  Q3Ellipse_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Ellipse_Submit" 
      ((ellipseData (:pointer :tq3ellipsedata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Ellipse_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Ellipse_SetData" 
      ((ellipse :pointer) (ellipseData (:pointer :tq3ellipsedata))) 
  :tq3status
   () )

; 
;  *  Q3Ellipse_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Ellipse_GetData" 
      ((ellipse :pointer) (ellipseData (:pointer :tq3ellipsedata))) 
  :tq3status
   () )

; 
;  *  Q3Ellipse_SetOrigin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Ellipse_SetOrigin" 
      ((ellipse :pointer) (origin (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Ellipse_SetMajorRadius()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Ellipse_SetMajorRadius" 
      ((ellipse :pointer) (majorRadius (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Ellipse_SetMinorRadius()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Ellipse_SetMinorRadius" 
      ((ellipse :pointer) (minorRadius (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Ellipse_GetOrigin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Ellipse_GetOrigin" 
      ((ellipse :pointer) (origin (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Ellipse_GetMajorRadius()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Ellipse_GetMajorRadius" 
      ((ellipse :pointer) (majorRadius (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Ellipse_GetMinorRadius()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Ellipse_GetMinorRadius" 
      ((ellipse :pointer) (minorRadius (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Ellipse_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Ellipse_EmptyData" 
      ((ellipseData (:pointer :tq3ellipsedata))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Ellipsoid Data structures                        **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3ellipsoiddataptr (find-mactype '(:pointer :tq3ellipsoiddata)))
(defrecord TQ3EllipsoidData 
   (origin :tq3point3d)
   (orientation :tq3vector3d)
   (majorRadius :tq3vector3d)
   (minorRadius :tq3vector3d)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (uMin :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (uMax :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (vMin :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (vMax :single-float)
   (caps :unsigned-long)
   (interiorAttributeSet :pointer)
   (ellipsoidAttributeSet :pointer)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                         Ellipsoid Routines                               **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Ellipsoid_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3Ellipsoid_New" 
      ((ellipsoidData (:pointer :tq3ellipsoiddata))) 
  :pointer
   () )

; 
;  *  Q3Ellipsoid_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Ellipsoid_Submit" 
      ((ellipsoidData (:pointer :tq3ellipsoiddata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Ellipsoid_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Ellipsoid_SetData" 
      ((ellipsoid :pointer) (ellipsoidData (:pointer :tq3ellipsoiddata))) 
  :tq3status
   () )

; 
;  *  Q3Ellipsoid_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Ellipsoid_GetData" 
      ((ellipsoid :pointer) (ellipsoidData (:pointer :tq3ellipsoiddata))) 
  :tq3status
   () )

; 
;  *  Q3Ellipsoid_SetOrigin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Ellipsoid_SetOrigin" 
      ((ellipsoid :pointer) (origin (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Ellipsoid_SetOrientation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Ellipsoid_SetOrientation" 
      ((ellipsoid :pointer) (orientation (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Ellipsoid_SetMajorRadius()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Ellipsoid_SetMajorRadius" 
      ((ellipsoid :pointer) (majorRadius (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Ellipsoid_SetMinorRadius()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Ellipsoid_SetMinorRadius" 
      ((ellipsoid :pointer) (minorRadius (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Ellipsoid_GetOrigin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Ellipsoid_GetOrigin" 
      ((ellipsoid :pointer) (origin (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Ellipsoid_GetOrientation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Ellipsoid_GetOrientation" 
      ((ellipsoid :pointer) (orientation (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Ellipsoid_GetMajorRadius()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Ellipsoid_GetMajorRadius" 
      ((ellipsoid :pointer) (majorRadius (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Ellipsoid_GetMinorRadius()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Ellipsoid_GetMinorRadius" 
      ((ellipsoid :pointer) (minorRadius (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Ellipsoid_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Ellipsoid_EmptyData" 
      ((ellipsoidData (:pointer :tq3ellipsoiddata))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                 General Polygon Data Structure Definitions               **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3generalpolygonshapehint (find-mactype ':signed-long))

(defconstant $kQ3GeneralPolygonShapeHintComplex 0)
(defconstant $kQ3GeneralPolygonShapeHintConcave 1)
(defconstant $kQ3GeneralPolygonShapeHintConvex 2)

(def-mactype :tq3generalpolygoncontourdataptr (find-mactype '(:pointer :tq3generalpolygoncontourdata)))
(defrecord TQ3GeneralPolygonContourData 
   (numVertices :unsigned-long)
   (vertices (:pointer :tq3vertex3d))
   )

(def-mactype :tq3generalpolygondataptr (find-mactype '(:pointer :tq3generalpolygondata)))
(defrecord TQ3GeneralPolygonData 
   (numContours :unsigned-long)
   (contours (:pointer :tq3generalpolygoncontourdata))
   (shapeHint :signed-long)
   (generalPolygonAttributeSet :pointer)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                         General polygon Routines                         **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3GeneralPolygon_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3GeneralPolygon_New" 
      ((generalPolygonData (:pointer :tq3generalpolygondata))) 
  :pointer
   () )

; 
;  *  Q3GeneralPolygon_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3GeneralPolygon_Submit" 
      ((generalPolygonData (:pointer :tq3generalpolygondata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3GeneralPolygon_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3GeneralPolygon_SetData" 
      ((generalPolygon :pointer) (generalPolygonData (:pointer :tq3generalpolygondata))) 
  :tq3status
   () )

; 
;  *  Q3GeneralPolygon_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3GeneralPolygon_GetData" 
      ((polygon :pointer) (generalPolygonData (:pointer :tq3generalpolygondata))) 
  :tq3status
   () )

; 
;  *  Q3GeneralPolygon_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3GeneralPolygon_EmptyData" 
      ((generalPolygonData (:pointer :tq3generalpolygondata))) 
  :tq3status
   () )

; 
;  *  Q3GeneralPolygon_GetVertexPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3GeneralPolygon_GetVertexPosition" 
      ((generalPolygon :pointer) (contourIndex :unsigned-long) (pointIndex :unsigned-long) (position (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3GeneralPolygon_SetVertexPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3GeneralPolygon_SetVertexPosition" 
      ((generalPolygon :pointer) (contourIndex :unsigned-long) (pointIndex :unsigned-long) (position (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3GeneralPolygon_GetVertexAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3GeneralPolygon_GetVertexAttributeSet" 
      ((generalPolygon :pointer) (contourIndex :unsigned-long) (pointIndex :unsigned-long) (attributeSet (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3GeneralPolygon_SetVertexAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3GeneralPolygon_SetVertexAttributeSet" 
      ((generalPolygon :pointer) (contourIndex :unsigned-long) (pointIndex :unsigned-long) (attributeSet :pointer)) 
  :tq3status
   () )

; 
;  *  Q3GeneralPolygon_SetShapeHint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3GeneralPolygon_SetShapeHint" 
      ((generalPolygon :pointer) (shapeHint :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3GeneralPolygon_GetShapeHint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3GeneralPolygon_GetShapeHint" 
      ((generalPolygon :pointer) (shapeHint (:pointer :signed-long))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Line Data Structure Definitions                      **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3linedataptr (find-mactype '(:pointer :tq3linedata)))
(defrecord TQ3LineData 
   (vertices (:array :tq3vertex3d 2))
   (lineAttributeSet :pointer)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                         Line Routines                                    **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Line_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3Line_New" 
      ((lineData (:pointer :tq3linedata))) 
  :pointer
   () )

; 
;  *  Q3Line_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Line_Submit" 
      ((lineData (:pointer :tq3linedata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Line_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Line_GetData" 
      ((line :pointer) (lineData (:pointer :tq3linedata))) 
  :tq3status
   () )

; 
;  *  Q3Line_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Line_SetData" 
      ((line :pointer) (lineData (:pointer :tq3linedata))) 
  :tq3status
   () )

; 
;  *  Q3Line_GetVertexPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Line_GetVertexPosition" 
      ((line :pointer) (index :unsigned-long) (position (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Line_SetVertexPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Line_SetVertexPosition" 
      ((line :pointer) (index :unsigned-long) (position (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Line_GetVertexAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Line_GetVertexAttributeSet" 
      ((line :pointer) (index :unsigned-long) (attributeSet (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Line_SetVertexAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Line_SetVertexAttributeSet" 
      ((line :pointer) (index :unsigned-long) (attributeSet :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Line_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Line_EmptyData" 
      ((lineData (:pointer :tq3linedata))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Marker Data Structure Definitions                    **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3markerdataptr (find-mactype '(:pointer :tq3markerdata)))
(defrecord TQ3MarkerData 
   (location :tq3point3d)
   (xOffset :signed-long)
   (yOffset :signed-long)
   (bitmap :tq3bitmap)
   (markerAttributeSet :pointer)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             Marker Routines                              **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Marker_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3Marker_New" 
      ((markerData (:pointer :tq3markerdata))) 
  :pointer
   () )

; 
;  *  Q3Marker_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Marker_Submit" 
      ((markerData (:pointer :tq3markerdata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Marker_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Marker_SetData" 
      ((geometry :pointer) (markerData (:pointer :tq3markerdata))) 
  :tq3status
   () )

; 
;  *  Q3Marker_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Marker_GetData" 
      ((geometry :pointer) (markerData (:pointer :tq3markerdata))) 
  :tq3status
   () )

; 
;  *  Q3Marker_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Marker_EmptyData" 
      ((markerData (:pointer :tq3markerdata))) 
  :tq3status
   () )

; 
;  *  Q3Marker_GetPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Marker_GetPosition" 
      ((marker :pointer) (location (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Marker_SetPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Marker_SetPosition" 
      ((marker :pointer) (location (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Marker_GetXOffset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Marker_GetXOffset" 
      ((marker :pointer) (xOffset (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3Marker_SetXOffset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Marker_SetXOffset" 
      ((marker :pointer) (xOffset :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3Marker_GetYOffset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Marker_GetYOffset" 
      ((marker :pointer) (yOffset (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3Marker_SetYOffset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Marker_SetYOffset" 
      ((marker :pointer) (yOffset :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3Marker_GetBitmap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Marker_GetBitmap" 
      ((marker :pointer) (bitmap (:pointer :tq3bitmap))) 
  :tq3status
   () )

; 
;  *  Q3Marker_SetBitmap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Marker_SetBitmap" 
      ((marker :pointer) (bitmap (:pointer :tq3bitmap))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Mesh Data Structure Definitions                      **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3meshcomponent (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :tq3meshcomponentptr (find-mactype '(:pointer :pointer)));  when a VAR xx:TQ3MeshComponent parameter can be nil, it is changed to xx: TQ3MeshComponentPtr 
(def-mactype :tq3meshvertex (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :tq3meshvertexptr (find-mactype '(:pointer :pointer)));  when a VAR xx:TQ3MeshVertex parameter can be nil, it is changed to xx: TQ3MeshVertexPtr 
(def-mactype :tq3meshface (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :tq3meshfaceptr (find-mactype '(:pointer :pointer)));  when a VAR xx:TQ3MeshFace parameter can be nil, it is changed to xx: TQ3MeshFacePtr 
(def-mactype :tq3meshedge (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :tq3meshedgeptr (find-mactype '(:pointer :pointer)));  when a VAR xx:TQ3MeshEdge parameter can be nil, it is changed to xx: TQ3MeshEdgePtr 
(def-mactype :tq3meshcontour (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :tq3meshcontourptr (find-mactype '(:pointer :pointer)));  when a VAR xx:TQ3MeshContour parameter can be nil, it is changed to xx: TQ3MeshContourPtr 
; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                         Mesh Routines                                    **
; 	 **                                                                          **
; 	 ****************************************************************************	
; 	
; 	 *  Constructors
; 	 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Mesh_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3Mesh_New" 
      () 
  :pointer
   () )

; 
;  *  Q3Mesh_VertexNew()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Mesh_VertexNew" 
      ((mesh :pointer) (vertex (:pointer :tq3vertex3d))) 
  :pointer
   () )

; 
;  *  Q3Mesh_FaceNew()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Mesh_FaceNew" 
      ((mesh :pointer) (numVertices :unsigned-long) (vertices (:pointer :pointer)) (attributeSet :pointer)) 
  :pointer
   () )

; 
;  *  Destructors
;  
; 
;  *  Q3Mesh_VertexDelete()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_VertexDelete" 
      ((mesh :pointer) (vertex :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Mesh_FaceDelete()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_FaceDelete" 
      ((mesh :pointer) (face :pointer)) 
  :tq3status
   () )

; 
;  * Methods
;  
; 
;  *  Q3Mesh_DelayUpdates()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_DelayUpdates" 
      ((mesh :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Mesh_ResumeUpdates()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_ResumeUpdates" 
      ((mesh :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Mesh_FaceToContour()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_FaceToContour" 
      ((mesh :pointer) (containerFace :pointer) (face :pointer)) 
  :pointer
   () )

; 
;  *  Q3Mesh_ContourToFace()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_ContourToFace" 
      ((mesh :pointer) (contour :pointer)) 
  :pointer
   () )

; 
;  * Mesh
;  
; 
;  *  Q3Mesh_GetNumComponents()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetNumComponents" 
      ((mesh :pointer) (numComponents (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_GetNumEdges()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetNumEdges" 
      ((mesh :pointer) (numEdges (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_GetNumVertices()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetNumVertices" 
      ((mesh :pointer) (numVertices (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_GetNumFaces()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetNumFaces" 
      ((mesh :pointer) (numFaces (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_GetNumCorners()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetNumCorners" 
      ((mesh :pointer) (numCorners (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_GetOrientable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetOrientable" 
      ((mesh :pointer) (orientable (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  * Component
;  
; 
;  *  Q3Mesh_GetComponentNumVertices()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetComponentNumVertices" 
      ((mesh :pointer) (component :pointer) (numVertices (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_GetComponentNumEdges()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetComponentNumEdges" 
      ((mesh :pointer) (component :pointer) (numEdges (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_GetComponentBoundingBox()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetComponentBoundingBox" 
      ((mesh :pointer) (component :pointer) (boundingBox (:pointer :tq3boundingbox))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_GetComponentOrientable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetComponentOrientable" 
      ((mesh :pointer) (component :pointer) (orientable (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  * Vertex
;  
; 
;  *  Q3Mesh_GetVertexCoordinates()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetVertexCoordinates" 
      ((mesh :pointer) (vertex :pointer) (coordinates (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_GetVertexIndex()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetVertexIndex" 
      ((mesh :pointer) (vertex :pointer) (index (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_GetVertexOnBoundary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetVertexOnBoundary" 
      ((mesh :pointer) (vertex :pointer) (onBoundary (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_GetVertexComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetVertexComponent" 
      ((mesh :pointer) (vertex :pointer) (component (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_GetVertexAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetVertexAttributeSet" 
      ((mesh :pointer) (vertex :pointer) (attributeSet (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_SetVertexCoordinates()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Mesh_SetVertexCoordinates" 
      ((mesh :pointer) (vertex :pointer) (coordinates (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_SetVertexAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_SetVertexAttributeSet" 
      ((mesh :pointer) (vertex :pointer) (attributeSet :pointer)) 
  :tq3status
   () )

; 
;  * Face
;  
; 
;  *  Q3Mesh_GetFaceNumVertices()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetFaceNumVertices" 
      ((mesh :pointer) (face :pointer) (numVertices (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_GetFacePlaneEquation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetFacePlaneEquation" 
      ((mesh :pointer) (face :pointer) (planeEquation (:pointer :tq3planeequation))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_GetFaceNumContours()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetFaceNumContours" 
      ((mesh :pointer) (face :pointer) (numContours (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_GetFaceIndex()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetFaceIndex" 
      ((mesh :pointer) (face :pointer) (index (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_GetFaceComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetFaceComponent" 
      ((mesh :pointer) (face :pointer) (component (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_GetFaceAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetFaceAttributeSet" 
      ((mesh :pointer) (face :pointer) (attributeSet (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_SetFaceAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_SetFaceAttributeSet" 
      ((mesh :pointer) (face :pointer) (attributeSet :pointer)) 
  :tq3status
   () )

; 
;  * Edge
;  
; 
;  *  Q3Mesh_GetEdgeVertices()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetEdgeVertices" 
      ((mesh :pointer) (edge :pointer) (vertex1 (:pointer :pointer)) (vertex2 (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_GetEdgeFaces()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetEdgeFaces" 
      ((mesh :pointer) (edge :pointer) (face1 (:pointer :pointer)) (face2 (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_GetEdgeOnBoundary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetEdgeOnBoundary" 
      ((mesh :pointer) (edge :pointer) (onBoundary (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_GetEdgeComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetEdgeComponent" 
      ((mesh :pointer) (edge :pointer) (component (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_GetEdgeAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetEdgeAttributeSet" 
      ((mesh :pointer) (edge :pointer) (attributeSet (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_SetEdgeAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_SetEdgeAttributeSet" 
      ((mesh :pointer) (edge :pointer) (attributeSet :pointer)) 
  :tq3status
   () )

; 
;  * Contour
;  
; 
;  *  Q3Mesh_GetContourFace()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetContourFace" 
      ((mesh :pointer) (contour :pointer) (face (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_GetContourNumVertices()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetContourNumVertices" 
      ((mesh :pointer) (contour :pointer) (numVertices (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  * Corner
;  
; 
;  *  Q3Mesh_GetCornerAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_GetCornerAttributeSet" 
      ((mesh :pointer) (vertex :pointer) (face :pointer) (attributeSet (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Mesh_SetCornerAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_SetCornerAttributeSet" 
      ((mesh :pointer) (vertex :pointer) (face :pointer) (attributeSet :pointer)) 
  :tq3status
   () )

; 
;  * Public Mesh Iterators
;  
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3meshiteratorptr (find-mactype '(:pointer :tq3meshiterator)))
(defrecord TQ3MeshIterator 
   (var1 :pointer)
   (var2 :pointer)
   (var3 :pointer)
   (field1 :pointer)
   (field2 (:array :character 4 :packed))
   )

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Mesh_FirstMeshComponent()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3Mesh_FirstMeshComponent" 
      ((mesh :pointer) (iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_NextMeshComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_NextMeshComponent" 
      ((iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_FirstComponentVertex()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_FirstComponentVertex" 
      ((component :pointer) (iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_NextComponentVertex()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_NextComponentVertex" 
      ((iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_FirstComponentEdge()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_FirstComponentEdge" 
      ((component :pointer) (iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_NextComponentEdge()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_NextComponentEdge" 
      ((iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_FirstMeshVertex()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_FirstMeshVertex" 
      ((mesh :pointer) (iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_NextMeshVertex()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_NextMeshVertex" 
      ((iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_FirstMeshFace()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_FirstMeshFace" 
      ((mesh :pointer) (iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_NextMeshFace()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_NextMeshFace" 
      ((iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_FirstMeshEdge()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_FirstMeshEdge" 
      ((mesh :pointer) (iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_NextMeshEdge()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_NextMeshEdge" 
      ((iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_FirstVertexEdge()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_FirstVertexEdge" 
      ((vertex :pointer) (iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_NextVertexEdge()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_NextVertexEdge" 
      ((iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_FirstVertexVertex()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_FirstVertexVertex" 
      ((vertex :pointer) (iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_NextVertexVertex()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_NextVertexVertex" 
      ((iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_FirstVertexFace()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_FirstVertexFace" 
      ((vertex :pointer) (iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_NextVertexFace()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_NextVertexFace" 
      ((iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_FirstFaceEdge()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_FirstFaceEdge" 
      ((face :pointer) (iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_NextFaceEdge()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_NextFaceEdge" 
      ((iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_FirstFaceVertex()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_FirstFaceVertex" 
      ((face :pointer) (iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_NextFaceVertex()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_NextFaceVertex" 
      ((iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_FirstFaceFace()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_FirstFaceFace" 
      ((face :pointer) (iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_NextFaceFace()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_NextFaceFace" 
      ((iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_FirstFaceContour()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_FirstFaceContour" 
      ((face :pointer) (iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_NextFaceContour()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_NextFaceContour" 
      ((iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_FirstContourEdge()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_FirstContourEdge" 
      ((contour :pointer) (iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_NextContourEdge()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_NextContourEdge" 
      ((iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_FirstContourVertex()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_FirstContourVertex" 
      ((contour :pointer) (iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_NextContourVertex()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_NextContourVertex" 
      ((iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_FirstContourFace()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_FirstContourFace" 
      ((contour :pointer) (iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; 
;  *  Q3Mesh_NextContourFace()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Mesh_NextContourFace" 
      ((iterator (:pointer :tq3meshiterator))) 
  :pointer
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; *****************************************************************************
;  **                                                                          **
;  **                         Maximum order for NURB Curves                    **
;  **                                                                          **
;  ****************************************************************************

; *****************************************************************************
;  **                                                                          **
;  **                     NURB Data Structure Definitions                      **
;  **                                                                          **
;  ****************************************************************************

(def-mactype :tq3nurbcurvedataptr (find-mactype '(:pointer :tq3nurbcurvedata)))
(defrecord TQ3NURBCurveData 
   (order :unsigned-long)
   (numPoints :unsigned-long)
   (controlPoints (:pointer :tq3rationalpoint4d))
   (knots (:pointer :single-float))
   (curveAttributeSet :pointer)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             NURB Curve Routines                          **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3NURBCurve_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3NURBCurve_New" 
      ((curveData (:pointer :tq3nurbcurvedata))) 
  :pointer
   () )

; 
;  *  Q3NURBCurve_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3NURBCurve_Submit" 
      ((curveData (:pointer :tq3nurbcurvedata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3NURBCurve_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3NURBCurve_SetData" 
      ((curve :pointer) (nurbCurveData (:pointer :tq3nurbcurvedata))) 
  :tq3status
   () )

; 
;  *  Q3NURBCurve_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3NURBCurve_GetData" 
      ((curve :pointer) (nurbCurveData (:pointer :tq3nurbcurvedata))) 
  :tq3status
   () )

; 
;  *  Q3NURBCurve_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3NURBCurve_EmptyData" 
      ((nurbCurveData (:pointer :tq3nurbcurvedata))) 
  :tq3status
   () )

; 
;  *  Q3NURBCurve_SetControlPoint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3NURBCurve_SetControlPoint" 
      ((curve :pointer) (pointIndex :unsigned-long) (point4D (:pointer :tq3rationalpoint4d))) 
  :tq3status
   () )

; 
;  *  Q3NURBCurve_GetControlPoint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3NURBCurve_GetControlPoint" 
      ((curve :pointer) (pointIndex :unsigned-long) (point4D (:pointer :tq3rationalpoint4d))) 
  :tq3status
   () )

; 
;  *  Q3NURBCurve_SetKnot()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3NURBCurve_SetKnot" 
      ((curve :pointer) (knotIndex :unsigned-long) (knotValue :single-float)) 
  :tq3status
   () )

; 
;  *  Q3NURBCurve_GetKnot()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3NURBCurve_GetKnot" 
      ((curve :pointer) (knotIndex :unsigned-long) (knotValue (:pointer :single-float))) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; *****************************************************************************
;  **                                                                          **
;  **                         Maximum NURB Patch Order                         **
;  **                                                                          **
;  ****************************************************************************
; *****************************************************************************
;  **                                                                          **
;  **                     NURB Patch Data Structure Definitions                **
;  **                                                                          **
;  ****************************************************************************

(def-mactype :tq3nurbpatchtrimcurvedataptr (find-mactype '(:pointer :tq3nurbpatchtrimcurvedata)))
(defrecord TQ3NURBPatchTrimCurveData 
   (order :unsigned-long)
   (numPoints :unsigned-long)
   (controlPoints (:pointer :tq3rationalpoint3d))
   (knots (:pointer :single-float))
   )

(def-mactype :tq3nurbpatchtrimloopdataptr (find-mactype '(:pointer :tq3nurbpatchtrimloopdata)))
(defrecord TQ3NURBPatchTrimLoopData 
   (numTrimCurves :unsigned-long)
   (trimCurves (:pointer :tq3nurbpatchtrimcurvedata))
   )

(def-mactype :tq3nurbpatchdataptr (find-mactype '(:pointer :tq3nurbpatchdata)))
(defrecord TQ3NURBPatchData 
   (uOrder :unsigned-long)
   (vOrder :unsigned-long)
   (numRows :unsigned-long)
   (numColumns :unsigned-long)
   (controlPoints (:pointer :tq3rationalpoint4d))
   (uKnots (:pointer :single-float))
   (vKnots (:pointer :single-float))
   (numTrimLoops :unsigned-long)
   (trimLoops (:pointer :tq3nurbpatchtrimloopdata))
   (patchAttributeSet :pointer)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             NURB Patch Routines                          **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3NURBPatch_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3NURBPatch_New" 
      ((nurbPatchData (:pointer :tq3nurbpatchdata))) 
  :pointer
   () )

; 
;  *  Q3NURBPatch_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3NURBPatch_Submit" 
      ((nurbPatchData (:pointer :tq3nurbpatchdata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3NURBPatch_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3NURBPatch_SetData" 
      ((nurbPatch :pointer) (nurbPatchData (:pointer :tq3nurbpatchdata))) 
  :tq3status
   () )

; 
;  *  Q3NURBPatch_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3NURBPatch_GetData" 
      ((nurbPatch :pointer) (nurbPatchData (:pointer :tq3nurbpatchdata))) 
  :tq3status
   () )

; 
;  *  Q3NURBPatch_SetControlPoint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3NURBPatch_SetControlPoint" 
      ((nurbPatch :pointer) (rowIndex :unsigned-long) (columnIndex :unsigned-long) (point4D (:pointer :tq3rationalpoint4d))) 
  :tq3status
   () )

; 
;  *  Q3NURBPatch_GetControlPoint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3NURBPatch_GetControlPoint" 
      ((nurbPatch :pointer) (rowIndex :unsigned-long) (columnIndex :unsigned-long) (point4D (:pointer :tq3rationalpoint4d))) 
  :tq3status
   () )

; 
;  *  Q3NURBPatch_SetUKnot()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3NURBPatch_SetUKnot" 
      ((nurbPatch :pointer) (knotIndex :unsigned-long) (knotValue :single-float)) 
  :tq3status
   () )

; 
;  *  Q3NURBPatch_SetVKnot()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3NURBPatch_SetVKnot" 
      ((nurbPatch :pointer) (knotIndex :unsigned-long) (knotValue :single-float)) 
  :tq3status
   () )

; 
;  *  Q3NURBPatch_GetUKnot()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3NURBPatch_GetUKnot" 
      ((nurbPatch :pointer) (knotIndex :unsigned-long) (knotValue (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3NURBPatch_GetVKnot()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3NURBPatch_GetVKnot" 
      ((nurbPatch :pointer) (knotIndex :unsigned-long) (knotValue (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3NURBPatch_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3NURBPatch_EmptyData" 
      ((nurbPatchData (:pointer :tq3nurbpatchdata))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Pixmap Marker Data Structure Definitions             **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3pixmapmarkerdataptr (find-mactype '(:pointer :tq3pixmapmarkerdata)))
(defrecord TQ3PixmapMarkerData 
   (position :tq3point3d)
   (xOffset :signed-long)
   (yOffset :signed-long)
   (pixmap :tq3storagepixmap)
   (pixmapMarkerAttributeSet :pointer)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             Pixmap Marker Routines                       **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3PixmapMarker_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3PixmapMarker_New" 
      ((pixmapMarkerData (:pointer :tq3pixmapmarkerdata))) 
  :pointer
   () )

; 
;  *  Q3PixmapMarker_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3PixmapMarker_Submit" 
      ((pixmapMarkerData (:pointer :tq3pixmapmarkerdata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3PixmapMarker_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3PixmapMarker_SetData" 
      ((geometry :pointer) (pixmapMarkerData (:pointer :tq3pixmapmarkerdata))) 
  :tq3status
   () )

; 
;  *  Q3PixmapMarker_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PixmapMarker_GetData" 
      ((geometry :pointer) (pixmapMarkerData (:pointer :tq3pixmapmarkerdata))) 
  :tq3status
   () )

; 
;  *  Q3PixmapMarker_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PixmapMarker_EmptyData" 
      ((pixmapMarkerData (:pointer :tq3pixmapmarkerdata))) 
  :tq3status
   () )

; 
;  *  Q3PixmapMarker_GetPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PixmapMarker_GetPosition" 
      ((pixmapMarker :pointer) (position (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3PixmapMarker_SetPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3PixmapMarker_SetPosition" 
      ((pixmapMarker :pointer) (position (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3PixmapMarker_GetXOffset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PixmapMarker_GetXOffset" 
      ((pixmapMarker :pointer) (xOffset (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3PixmapMarker_SetXOffset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PixmapMarker_SetXOffset" 
      ((pixmapMarker :pointer) (xOffset :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3PixmapMarker_GetYOffset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PixmapMarker_GetYOffset" 
      ((pixmapMarker :pointer) (yOffset (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3PixmapMarker_SetYOffset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PixmapMarker_SetYOffset" 
      ((pixmapMarker :pointer) (yOffset :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3PixmapMarker_GetPixmap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PixmapMarker_GetPixmap" 
      ((pixmapMarker :pointer) (pixmap (:pointer :tq3storagepixmap))) 
  :tq3status
   () )

; 
;  *  Q3PixmapMarker_SetPixmap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3PixmapMarker_SetPixmap" 
      ((pixmapMarker :pointer) (pixmap (:pointer :tq3storagepixmap))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Point Data Structure Definitions                     **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3pointdataptr (find-mactype '(:pointer :tq3pointdata)))
(defrecord TQ3PointData 
   (point :tq3point3d)
   (pointAttributeSet :pointer)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             Point Routines                               **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Point_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3Point_New" 
      ((pointData (:pointer :tq3pointdata))) 
  :pointer
   () )

; 
;  *  Q3Point_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Point_Submit" 
      ((pointData (:pointer :tq3pointdata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Point_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Point_GetData" 
      ((point :pointer) (pointData (:pointer :tq3pointdata))) 
  :tq3status
   () )

; 
;  *  Q3Point_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Point_SetData" 
      ((point :pointer) (pointData (:pointer :tq3pointdata))) 
  :tq3status
   () )

; 
;  *  Q3Point_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Point_EmptyData" 
      ((pointData (:pointer :tq3pointdata))) 
  :tq3status
   () )

; 
;  *  Q3Point_SetPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Point_SetPosition" 
      ((point :pointer) (position (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Point_GetPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Point_GetPosition" 
      ((point :pointer) (position (:pointer :tq3point3d))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Polygon Data Structure Definitions                   **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3polygondataptr (find-mactype '(:pointer :tq3polygondata)))
(defrecord TQ3PolygonData 
   (numVertices :unsigned-long)
   (vertices (:pointer :tq3vertex3d))
   (polygonAttributeSet :pointer)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                         Polygon Routines                                 **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Polygon_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3Polygon_New" 
      ((polygonData (:pointer :tq3polygondata))) 
  :pointer
   () )

; 
;  *  Q3Polygon_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Polygon_Submit" 
      ((polygonData (:pointer :tq3polygondata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Polygon_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Polygon_SetData" 
      ((polygon :pointer) (polygonData (:pointer :tq3polygondata))) 
  :tq3status
   () )

; 
;  *  Q3Polygon_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Polygon_GetData" 
      ((polygon :pointer) (polygonData (:pointer :tq3polygondata))) 
  :tq3status
   () )

; 
;  *  Q3Polygon_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Polygon_EmptyData" 
      ((polygonData (:pointer :tq3polygondata))) 
  :tq3status
   () )

; 
;  *  Q3Polygon_GetVertexPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Polygon_GetVertexPosition" 
      ((polygon :pointer) (index :unsigned-long) (point (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Polygon_SetVertexPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Polygon_SetVertexPosition" 
      ((polygon :pointer) (index :unsigned-long) (point (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Polygon_GetVertexAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Polygon_GetVertexAttributeSet" 
      ((polygon :pointer) (index :unsigned-long) (attributeSet (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Polygon_SetVertexAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Polygon_SetVertexAttributeSet" 
      ((polygon :pointer) (index :unsigned-long) (attributeSet :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Polyhedron Data Structure Definitions                **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3polyhedronedgemasks (find-mactype ':signed-long))

(defconstant $kQ3PolyhedronEdgeNone 0)
(defconstant $kQ3PolyhedronEdge01 #x1)
(defconstant $kQ3PolyhedronEdge12 #x2)
(defconstant $kQ3PolyhedronEdge20 #x4)
(defconstant $kQ3PolyhedronEdgeAll #x7)

(def-mactype :tq3polyhedronedge (find-mactype ':unsigned-long))
(def-mactype :tq3polyhedronedgedataptr (find-mactype '(:pointer :tq3polyhedronedgedata)))
(defrecord TQ3PolyhedronEdgeData 
   (vertexIndices (:array :unsigned-long 2))
   (triangleIndices (:array :unsigned-long 2))
   (edgeAttributeSet :pointer)
   )

(def-mactype :tq3polyhedrontriangledataptr (find-mactype '(:pointer :tq3polyhedrontriangledata)))
(defrecord TQ3PolyhedronTriangleData 
   (vertexIndices (:array :unsigned-long 3))
   (edgeFlag :unsigned-long)
   (triangleAttributeSet :pointer)
   )

(def-mactype :tq3polyhedrondataptr (find-mactype '(:pointer :tq3polyhedrondata)))
(defrecord TQ3PolyhedronData 
   (numVertices :unsigned-long)
   (vertices (:pointer :tq3vertex3d))
   (numEdges :unsigned-long)
   (edges (:pointer :tq3polyhedronedgedata))
   (numTriangles :unsigned-long)
   (triangles (:pointer :tq3polyhedrontriangledata))
   (polyhedronAttributeSet :pointer)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             Polyhedron Routines                          **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Polyhedron_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3Polyhedron_New" 
      ((polyhedronData (:pointer :tq3polyhedrondata))) 
  :pointer
   () )

; 
;  *  Q3Polyhedron_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Polyhedron_Submit" 
      ((polyhedronData (:pointer :tq3polyhedrondata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Polyhedron_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Polyhedron_SetData" 
      ((polyhedron :pointer) (polyhedronData (:pointer :tq3polyhedrondata))) 
  :tq3status
   () )

; 
;  *  Q3Polyhedron_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Polyhedron_GetData" 
      ((polyhedron :pointer) (polyhedronData (:pointer :tq3polyhedrondata))) 
  :tq3status
   () )

; 
;  *  Q3Polyhedron_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Polyhedron_EmptyData" 
      ((polyhedronData (:pointer :tq3polyhedrondata))) 
  :tq3status
   () )

; 
;  *  Q3Polyhedron_SetVertexPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Polyhedron_SetVertexPosition" 
      ((polyhedron :pointer) (index :unsigned-long) (point (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Polyhedron_GetVertexPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Polyhedron_GetVertexPosition" 
      ((polyhedron :pointer) (index :unsigned-long) (point (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Polyhedron_SetVertexAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Polyhedron_SetVertexAttributeSet" 
      ((polyhedron :pointer) (index :unsigned-long) (attributeSet :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Polyhedron_GetVertexAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Polyhedron_GetVertexAttributeSet" 
      ((polyhedron :pointer) (index :unsigned-long) (attributeSet (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Polyhedron_GetTriangleData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Polyhedron_GetTriangleData" 
      ((polyhedron :pointer) (triangleIndex :unsigned-long) (triangleData (:pointer :tq3polyhedrontriangledata))) 
  :tq3status
   () )

; 
;  *  Q3Polyhedron_SetTriangleData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Polyhedron_SetTriangleData" 
      ((polyhedron :pointer) (triangleIndex :unsigned-long) (triangleData (:pointer :tq3polyhedrontriangledata))) 
  :tq3status
   () )

; 
;  *  Q3Polyhedron_GetEdgeData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Polyhedron_GetEdgeData" 
      ((polyhedron :pointer) (edgeIndex :unsigned-long) (edgeData (:pointer :tq3polyhedronedgedata))) 
  :tq3status
   () )

; 
;  *  Q3Polyhedron_SetEdgeData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Polyhedron_SetEdgeData" 
      ((polyhedron :pointer) (edgeIndex :unsigned-long) (edgeData (:pointer :tq3polyhedronedgedata))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     PolyLine Data Structure Definitions                  **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3polylinedataptr (find-mactype '(:pointer :tq3polylinedata)))
(defrecord TQ3PolyLineData 
   (numVertices :unsigned-long)
   (vertices (:pointer :tq3vertex3d))
   (segmentAttributeSet (:pointer :pointer))
   (polyLineAttributeSet :pointer)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                         PolyLine Routines                                **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3PolyLine_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3PolyLine_New" 
      ((polylineData (:pointer :tq3polylinedata))) 
  :pointer
   () )

; 
;  *  Q3PolyLine_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3PolyLine_Submit" 
      ((polyLineData (:pointer :tq3polylinedata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3PolyLine_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3PolyLine_SetData" 
      ((polyLine :pointer) (polyLineData (:pointer :tq3polylinedata))) 
  :tq3status
   () )

; 
;  *  Q3PolyLine_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PolyLine_GetData" 
      ((polyLine :pointer) (polyLineData (:pointer :tq3polylinedata))) 
  :tq3status
   () )

; 
;  *  Q3PolyLine_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PolyLine_EmptyData" 
      ((polyLineData (:pointer :tq3polylinedata))) 
  :tq3status
   () )

; 
;  *  Q3PolyLine_GetVertexPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PolyLine_GetVertexPosition" 
      ((polyLine :pointer) (index :unsigned-long) (position (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3PolyLine_SetVertexPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3PolyLine_SetVertexPosition" 
      ((polyLine :pointer) (index :unsigned-long) (position (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3PolyLine_GetVertexAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PolyLine_GetVertexAttributeSet" 
      ((polyLine :pointer) (index :unsigned-long) (attributeSet (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3PolyLine_SetVertexAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PolyLine_SetVertexAttributeSet" 
      ((polyLine :pointer) (index :unsigned-long) (attributeSet :pointer)) 
  :tq3status
   () )

; 
;  *  Q3PolyLine_GetSegmentAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PolyLine_GetSegmentAttributeSet" 
      ((polyLine :pointer) (index :unsigned-long) (attributeSet (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3PolyLine_SetSegmentAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PolyLine_SetSegmentAttributeSet" 
      ((polyLine :pointer) (index :unsigned-long) (attributeSet :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Torus Data Structure Definitions                     **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3torusdataptr (find-mactype '(:pointer :tq3torusdata)))
(defrecord TQ3TorusData 
   (origin :tq3point3d)
   (orientation :tq3vector3d)
   (majorRadius :tq3vector3d)
   (minorRadius :tq3vector3d)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (ratio :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (uMin :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (uMax :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (vMin :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (vMax :single-float)
   (caps :unsigned-long)
   (interiorAttributeSet :pointer)
   (torusAttributeSet :pointer)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             Torus Routines                               **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Torus_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3Torus_New" 
      ((torusData (:pointer :tq3torusdata))) 
  :pointer
   () )

; 
;  *  Q3Torus_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Torus_Submit" 
      ((torusData (:pointer :tq3torusdata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Torus_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Torus_SetData" 
      ((torus :pointer) (torusData (:pointer :tq3torusdata))) 
  :tq3status
   () )

; 
;  *  Q3Torus_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Torus_GetData" 
      ((torus :pointer) (torusData (:pointer :tq3torusdata))) 
  :tq3status
   () )

; 
;  *  Q3Torus_SetOrigin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Torus_SetOrigin" 
      ((torus :pointer) (origin (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Torus_SetOrientation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Torus_SetOrientation" 
      ((torus :pointer) (orientation (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Torus_SetMajorRadius()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Torus_SetMajorRadius" 
      ((torus :pointer) (majorRadius (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Torus_SetMinorRadius()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Torus_SetMinorRadius" 
      ((torus :pointer) (minorRadius (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Torus_SetRatio()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Torus_SetRatio" 
      ((torus :pointer) (ratio :single-float)) 
  :tq3status
   () )

; 
;  *  Q3Torus_GetOrigin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Torus_GetOrigin" 
      ((torus :pointer) (origin (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Torus_GetOrientation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Torus_GetOrientation" 
      ((torus :pointer) (orientation (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Torus_GetMajorRadius()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Torus_GetMajorRadius" 
      ((torus :pointer) (majorRadius (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Torus_GetMinorRadius()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Torus_GetMinorRadius" 
      ((torus :pointer) (minorRadius (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3Torus_GetRatio()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Torus_GetRatio" 
      ((torus :pointer) (ratio (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3Torus_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Torus_EmptyData" 
      ((torusData (:pointer :tq3torusdata))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Triangle Data Structure Definitions                  **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3triangledataptr (find-mactype '(:pointer :tq3triangledata)))
(defrecord TQ3TriangleData 
   (vertices (:array :tq3vertex3d 3))
   (triangleAttributeSet :pointer)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                         Triangle Routines                                **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Triangle_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3Triangle_New" 
      ((triangleData (:pointer :tq3triangledata))) 
  :pointer
   () )

; 
;  *  Q3Triangle_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Triangle_Submit" 
      ((triangleData (:pointer :tq3triangledata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Triangle_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Triangle_SetData" 
      ((triangle :pointer) (triangleData (:pointer :tq3triangledata))) 
  :tq3status
   () )

; 
;  *  Q3Triangle_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Triangle_GetData" 
      ((triangle :pointer) (triangleData (:pointer :tq3triangledata))) 
  :tq3status
   () )

; 
;  *  Q3Triangle_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Triangle_EmptyData" 
      ((triangleData (:pointer :tq3triangledata))) 
  :tq3status
   () )

; 
;  *  Q3Triangle_GetVertexPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Triangle_GetVertexPosition" 
      ((triangle :pointer) (index :unsigned-long) (point (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Triangle_SetVertexPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Triangle_SetVertexPosition" 
      ((triangle :pointer) (index :unsigned-long) (point (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3Triangle_GetVertexAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Triangle_GetVertexAttributeSet" 
      ((triangle :pointer) (index :unsigned-long) (attributeSet (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Triangle_SetVertexAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Triangle_SetVertexAttributeSet" 
      ((triangle :pointer) (index :unsigned-long) (attributeSet :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     TriGrid Data Structure Definitions                   **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3trigriddataptr (find-mactype '(:pointer :tq3trigriddata)))
(defrecord TQ3TriGridData 
   (numRows :unsigned-long)
   (numColumns :unsigned-long)
   (vertices (:pointer :tq3vertex3d))
   (facetAttributeSet (:pointer :pointer))
   (triGridAttributeSet :pointer)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             TriGrid Routines                             **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3TriGrid_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3TriGrid_New" 
      ((triGridData (:pointer :tq3trigriddata))) 
  :pointer
   () )

; 
;  *  Q3TriGrid_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3TriGrid_Submit" 
      ((triGridData (:pointer :tq3trigriddata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3TriGrid_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3TriGrid_SetData" 
      ((triGrid :pointer) (triGridData (:pointer :tq3trigriddata))) 
  :tq3status
   () )

; 
;  *  Q3TriGrid_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3TriGrid_GetData" 
      ((triGrid :pointer) (triGridData (:pointer :tq3trigriddata))) 
  :tq3status
   () )

; 
;  *  Q3TriGrid_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3TriGrid_EmptyData" 
      ((triGridData (:pointer :tq3trigriddata))) 
  :tq3status
   () )

; 
;  *  Q3TriGrid_GetVertexPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3TriGrid_GetVertexPosition" 
      ((triGrid :pointer) (rowIndex :unsigned-long) (columnIndex :unsigned-long) (position (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3TriGrid_SetVertexPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3TriGrid_SetVertexPosition" 
      ((triGrid :pointer) (rowIndex :unsigned-long) (columnIndex :unsigned-long) (position (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3TriGrid_GetVertexAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3TriGrid_GetVertexAttributeSet" 
      ((triGrid :pointer) (rowIndex :unsigned-long) (columnIndex :unsigned-long) (attributeSet (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3TriGrid_SetVertexAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3TriGrid_SetVertexAttributeSet" 
      ((triGrid :pointer) (rowIndex :unsigned-long) (columnIndex :unsigned-long) (attributeSet :pointer)) 
  :tq3status
   () )

; 
;  *  Q3TriGrid_GetFacetAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3TriGrid_GetFacetAttributeSet" 
      ((triGrid :pointer) (faceIndex :unsigned-long) (facetAttributeSet (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3TriGrid_SetFacetAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3TriGrid_SetFacetAttributeSet" 
      ((triGrid :pointer) (faceIndex :unsigned-long) (facetAttributeSet :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     TriMesh Data Structure Definitions                   **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3trimeshtriangledataptr (find-mactype '(:pointer :tq3trimeshtriangledata)))
(defrecord TQ3TriMeshTriangleData 
   (pointIndices (:array :unsigned-long 3))
   )

(def-mactype :tq3trimeshedgedataptr (find-mactype '(:pointer :tq3trimeshedgedata)))
(defrecord TQ3TriMeshEdgeData 
   (pointIndices (:array :unsigned-long 2))
   (triangleIndices (:array :unsigned-long 2))
   )

(def-mactype :tq3trimeshattributedataptr (find-mactype '(:pointer :tq3trimeshattributedata)))
(defrecord TQ3TriMeshAttributeData 
   (attributeType :signed-long)                 ;   The type of attribute        
   (data :pointer)                              ;   Pointer to the contiguous      
;   attribute data.            
   (attributeUseArray :pointer)                 ;   This is only used with custom  
;   attributes                 
   )

(def-mactype :tq3trimeshdataptr (find-mactype '(:pointer :tq3trimeshdata)))
(defrecord TQ3TriMeshData 
   (triMeshAttributeSet :pointer)
   (numTriangles :unsigned-long)
   (triangles (:pointer :tq3trimeshtriangledata))
   (numTriangleAttributeTypes :unsigned-long)
   (triangleAttributeTypes (:pointer :tq3trimeshattributedata))
   (numEdges :unsigned-long)
   (edges (:pointer :tq3trimeshedgedata))
   (numEdgeAttributeTypes :unsigned-long)
   (edgeAttributeTypes (:pointer :tq3trimeshattributedata))
   (numPoints :unsigned-long)
   (points (:pointer :tq3point3d))
   (numVertexAttributeTypes :unsigned-long)
   (vertexAttributeTypes (:pointer :tq3trimeshattributedata))
   (bBox :tq3boundingbox)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                         TriMesh Routines                                 **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3TriMesh_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3TriMesh_New" 
      ((triMeshData (:pointer :tq3trimeshdata))) 
  :pointer
   () )

; 
;  *  Q3TriMesh_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3TriMesh_Submit" 
      ((triMeshData (:pointer :tq3trimeshdata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3TriMesh_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3TriMesh_SetData" 
      ((triMesh :pointer) (triMeshData (:pointer :tq3trimeshdata))) 
  :tq3status
   () )

; 
;  *  Q3TriMesh_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3TriMesh_GetData" 
      ((triMesh :pointer) (triMeshData (:pointer :tq3trimeshdata))) 
  :tq3status
   () )

; 
;  *  Q3TriMesh_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3TriMesh_EmptyData" 
      ((triMeshData (:pointer :tq3trimeshdata))) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QD3DGeometryIncludes

; $ENDC                                         ; __QD3DGEOMETRY__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'QD3DGeometry)