(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QD3DLight.p"
; at Wednesday May 1,2002 2:42:33 pm.
; 
;      File:       QD3DLight.p
;  
;      Contains:   Generic light routines
;  
;      Version:    Technology: Quickdraw 3D 1.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __QD3DLIGHT__
; $SETC __QD3DLIGHT__ := 1

; $I+
; $SETC QD3DLightIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __QD3D__
|#

(require-interface 'QD3D)
#|                                              ; $I QD3D.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

; *****************************************************************************
;  **                                                                          **
;  **                         Enum Definitions                                 **
;  **                                                                          **
;  ****************************************************************************

(def-mactype :tq3attenuationtype (find-mactype ':signed-long))

(defconstant $kQ3AttenuationTypeNone 0)
(defconstant $kQ3AttenuationTypeInverseDistance 1)
(defconstant $kQ3AttenuationTypeInverseDistanceSquared 2)

(def-mactype :tq3fallofftype (find-mactype ':signed-long))

(defconstant $kQ3FallOffTypeNone 0)
(defconstant $kQ3FallOffTypeLinear 1)
(defconstant $kQ3FallOffTypeExponential 2)
(defconstant $kQ3FallOffTypeCosine 3)

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                         Data Structure Definitions                       **
; 	 **                                                                          **
; 	 ****************************************************************************	

(def-mactype :tq3lightdataptr (find-mactype '(:pointer :tq3lightdata)))
(defrecord TQ3LightData 
   (isOn :signed-long)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (brightness :single-float)
   (color :tq3colorrgb)
   )

(def-mactype :tq3directionallightdataptr (find-mactype '(:pointer :tq3directionallightdata)))
(defrecord TQ3DirectionalLightData 
   (lightData :tq3lightdata)
   (castsShadows :signed-long)
   (direction :tq3vector3d)
   )

(def-mactype :tq3pointlightdataptr (find-mactype '(:pointer :tq3pointlightdata)))
(defrecord TQ3PointLightData 
   (lightData :tq3lightdata)
   (castsShadows :signed-long)
   (attenuation :signed-long)
   (location :tq3point3d)
   )

(def-mactype :tq3spotlightdataptr (find-mactype '(:pointer :tq3spotlightdata)))
(defrecord TQ3SpotLightData 
   (lightData :tq3lightdata)
   (castsShadows :signed-long)
   (attenuation :signed-long)
   (location :tq3point3d)
   (direction :tq3vector3d)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (hotAngle :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (outerAngle :single-float)
   (fallOff :signed-long)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                 Light routines (apply to all TQ3LightObjects)            **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Light_GetType()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3Light_GetType" 
      ((light :pointer)) 
  :tq3objecttype
   () )

; 
;  *  Q3Light_GetState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Light_GetState" 
      ((light :pointer) (isOn (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3Light_GetBrightness()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Light_GetBrightness" 
      ((light :pointer) (brightness (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3Light_GetColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Light_GetColor" 
      ((light :pointer) (color (:pointer :tq3colorrgb))) 
  :tq3status
   () )

; 
;  *  Q3Light_SetState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Light_SetState" 
      ((light :pointer) (isOn :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3Light_SetBrightness()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Light_SetBrightness" 
      ((light :pointer) (brightness :single-float)) 
  :tq3status
   () )

; 
;  *  Q3Light_SetColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Light_SetColor" 
      ((light :pointer) (color (:pointer :tq3colorrgb))) 
  :tq3status
   () )

; 
;  *  Q3Light_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Light_GetData" 
      ((light :pointer) (lightData (:pointer :tq3lightdata))) 
  :tq3status
   () )

; 
;  *  Q3Light_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Light_SetData" 
      ((light :pointer) (lightData (:pointer :tq3lightdata))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Specific Light Routines                          **
;  **                                                                          **
;  ****************************************************************************
; *****************************************************************************
;  **                                                                          **
;  **                         Ambient Light                                    **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3AmbientLight_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3AmbientLight_New" 
      ((lightData (:pointer :tq3lightdata))) 
  :pointer
   () )

; 
;  *  Q3AmbientLight_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3AmbientLight_GetData" 
      ((light :pointer) (lightData (:pointer :tq3lightdata))) 
  :tq3status
   () )

; 
;  *  Q3AmbientLight_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3AmbientLight_SetData" 
      ((light :pointer) (lightData (:pointer :tq3lightdata))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Directional Light                                    **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3DirectionalLight_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3DirectionalLight_New" 
      ((directionalLightData (:pointer :tq3directionallightdata))) 
  :pointer
   () )

; 
;  *  Q3DirectionalLight_GetCastShadowsState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DirectionalLight_GetCastShadowsState" 
      ((light :pointer) (castsShadows (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3DirectionalLight_GetDirection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DirectionalLight_GetDirection" 
      ((light :pointer) (direction (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3DirectionalLight_SetCastShadowsState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DirectionalLight_SetCastShadowsState" 
      ((light :pointer) (castsShadows :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3DirectionalLight_SetDirection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3DirectionalLight_SetDirection" 
      ((light :pointer) (direction (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3DirectionalLight_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DirectionalLight_GetData" 
      ((light :pointer) (directionalLightData (:pointer :tq3directionallightdata))) 
  :tq3status
   () )

; 
;  *  Q3DirectionalLight_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3DirectionalLight_SetData" 
      ((light :pointer) (directionalLightData (:pointer :tq3directionallightdata))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Point Light                                          **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3PointLight_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3PointLight_New" 
      ((pointLightData (:pointer :tq3pointlightdata))) 
  :pointer
   () )

; 
;  *  Q3PointLight_GetCastShadowsState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PointLight_GetCastShadowsState" 
      ((light :pointer) (castsShadows (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3PointLight_GetAttenuation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PointLight_GetAttenuation" 
      ((light :pointer) (attenuation (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3PointLight_GetLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PointLight_GetLocation" 
      ((light :pointer) (location (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3PointLight_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PointLight_GetData" 
      ((light :pointer) (pointLightData (:pointer :tq3pointlightdata))) 
  :tq3status
   () )

; 
;  *  Q3PointLight_SetCastShadowsState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PointLight_SetCastShadowsState" 
      ((light :pointer) (castsShadows :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3PointLight_SetAttenuation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PointLight_SetAttenuation" 
      ((light :pointer) (attenuation :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3PointLight_SetLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3PointLight_SetLocation" 
      ((light :pointer) (location (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3PointLight_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3PointLight_SetData" 
      ((light :pointer) (pointLightData (:pointer :tq3pointlightdata))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Spot Light                                           **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3SpotLight_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3SpotLight_New" 
      ((spotLightData (:pointer :tq3spotlightdata))) 
  :pointer
   () )

; 
;  *  Q3SpotLight_GetCastShadowsState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3SpotLight_GetCastShadowsState" 
      ((light :pointer) (castsShadows (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3SpotLight_GetAttenuation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3SpotLight_GetAttenuation" 
      ((light :pointer) (attenuation (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3SpotLight_GetLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3SpotLight_GetLocation" 
      ((light :pointer) (location (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3SpotLight_GetDirection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3SpotLight_GetDirection" 
      ((light :pointer) (direction (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3SpotLight_GetHotAngle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3SpotLight_GetHotAngle" 
      ((light :pointer) (hotAngle (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3SpotLight_GetOuterAngle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3SpotLight_GetOuterAngle" 
      ((light :pointer) (outerAngle (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3SpotLight_GetFallOff()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3SpotLight_GetFallOff" 
      ((light :pointer) (fallOff (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3SpotLight_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3SpotLight_GetData" 
      ((light :pointer) (spotLightData (:pointer :tq3spotlightdata))) 
  :tq3status
   () )

; 
;  *  Q3SpotLight_SetCastShadowsState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3SpotLight_SetCastShadowsState" 
      ((light :pointer) (castsShadows :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3SpotLight_SetAttenuation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3SpotLight_SetAttenuation" 
      ((light :pointer) (attenuation :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3SpotLight_SetLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3SpotLight_SetLocation" 
      ((light :pointer) (location (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3SpotLight_SetDirection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3SpotLight_SetDirection" 
      ((light :pointer) (direction (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3SpotLight_SetHotAngle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3SpotLight_SetHotAngle" 
      ((light :pointer) (hotAngle :single-float)) 
  :tq3status
   () )

; 
;  *  Q3SpotLight_SetOuterAngle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3SpotLight_SetOuterAngle" 
      ((light :pointer) (outerAngle :single-float)) 
  :tq3status
   () )

; 
;  *  Q3SpotLight_SetFallOff()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3SpotLight_SetFallOff" 
      ((light :pointer) (fallOff :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3SpotLight_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3SpotLight_SetData" 
      ((light :pointer) (spotLightData (:pointer :tq3spotlightdata))) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QD3DLightIncludes

; $ENDC                                         ; __QD3DLIGHT__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'QD3DLight)