(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QD3DSet.p"
; at Wednesday May 1,2002 2:42:23 pm.
; 
;      File:       QD3DSet.p
;  
;      Contains:   Q3Set types and routines
;  
;      Version:    Technology: Quickdraw 3D 1.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __QD3DSET__
; $SETC __QD3DSET__ := 1

; $I+
; $SETC QD3DSetIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __QD3D__
|#

(require-interface 'QD3D)
#|                                              ; $I QD3D.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

; *****************************************************************************
;  **                                                                          **
;  **                             Set Routines                                 **
;  **                                                                          **
;  ****************************************************************************
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Q3Set_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Set_New" 
      () 
  :pointer
   () )

; 
;  *  Q3Set_GetType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Set_GetType" 
      ((theSet :pointer)) 
  :tq3objecttype
   () )

; 
;  *  Q3Set_Add()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Set_Add" 
      ((theSet :pointer) (theType :signed-long) (data :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Set_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Set_Get" 
      ((theSet :pointer) (theType :signed-long) (data :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Set_Contains()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Set_Contains" 
      ((theSet :pointer) (theType :signed-long)) 
  :tq3boolean
   () )

; 
;  *  Q3Set_Clear()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Set_Clear" 
      ((theSet :pointer) (theType :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3Set_Empty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Set_Empty" 
      ((target :pointer)) 
  :tq3status
   () )

; 
;  *  Iterating through all elements in a set
;  *
;  *  Pass in kQ3ElementTypeNone to get first type
;  *  kQ3ElementTypeNone is returned when end of list is reached
;  
; 
;  *  Q3Set_GetNextElementType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Set_GetNextElementType" 
      ((theSet :pointer) (theType (:pointer :signed-long))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Attribute Types                              **
;  **                                                                          **
;  ****************************************************************************
;  
;  *  For the data types listed below, pass in a pointer to it in the _Add 
;  *  and _Get calls.
;  *
;  *  For surface shader attributes, reference counts are incremented on 
;  *  the _Add and _Get 
;  
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3attributetypes (find-mactype ':signed-long))

;   Data Type           
(defconstant $kQ3AttributeTypeNone 0)           ;   ---------           
(defconstant $kQ3AttributeTypeSurfaceUV 1)      ;   TQ3Param2D           
(defconstant $kQ3AttributeTypeShadingUV 2)      ;   TQ3Param2D            
(defconstant $kQ3AttributeTypeNormal 3)         ;   TQ3Vector3D            
(defconstant $kQ3AttributeTypeAmbientCoefficient 4);   float             
(defconstant $kQ3AttributeTypeDiffuseColor 5)   ;   TQ3ColorRGB           
(defconstant $kQ3AttributeTypeSpecularColor 6)  ;   TQ3ColorRGB           
(defconstant $kQ3AttributeTypeSpecularControl 7);   float             
(defconstant $kQ3AttributeTypeTransparencyColor 8);   TQ3ColorRGB           
(defconstant $kQ3AttributeTypeSurfaceTangent 9) ;   TQ3Tangent2D           
(defconstant $kQ3AttributeTypeHighlightState 10);   TQ3Switch            
(defconstant $kQ3AttributeTypeSurfaceShader 11) ;   TQ3SurfaceShaderObject  
(defconstant $kQ3AttributeTypeNumTypes 12)

(def-mactype :tq3attributetype (find-mactype ':signed-long))
; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             Attribute Drawing                            **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Attribute_Submit()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3Attribute_Submit" 
      ((attributeType :signed-long) (data :pointer) (view :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         AttributeSet Routines                            **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3AttributeSet_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3AttributeSet_New" 
      () 
  :pointer
   () )

; 
;  *  Q3AttributeSet_Add()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3AttributeSet_Add" 
      ((attributeSet :pointer) (theType :signed-long) (data :pointer)) 
  :tq3status
   () )

; 
;  *  Q3AttributeSet_Contains()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3AttributeSet_Contains" 
      ((attributeSet :pointer) (attributeType :signed-long)) 
  :tq3boolean
   () )

; 
;  *  Q3AttributeSet_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3AttributeSet_Get" 
      ((attributeSet :pointer) (theType :signed-long) (data :pointer)) 
  :tq3status
   () )

; 
;  *  Q3AttributeSet_Clear()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3AttributeSet_Clear" 
      ((attributeSet :pointer) (theType :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3AttributeSet_Empty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3AttributeSet_Empty" 
      ((target :pointer)) 
  :tq3status
   () )

; 
;  * Q3AttributeSet_GetNextAttributeType
;  *
;  * Pass in kQ3AttributeTypeNone to get first type
;  * kQ3AttributeTypeNone is returned when end of list is reached
;  
; 
;  *  Q3AttributeSet_GetNextAttributeType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3AttributeSet_GetNextAttributeType" 
      ((source :pointer) (theType (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3AttributeSet_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3AttributeSet_Submit" 
      ((attributeSet :pointer) (view :pointer)) 
  :tq3status
   () )

; 
;  * Inherit from parent->child into result
;  *  Result attributes are:
;  *      all child attributes + all parent attributes NOT in the child
;  
; 
;  *  Q3AttributeSet_Inherit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3AttributeSet_Inherit" 
      ((parent :pointer) (child :pointer) (result :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Custom Element Registration                      **
;  **                                                                          **
;  ****************************************************************************
; 
;  * Element Methods - 
;  *
;  *      When you create a custom element, you control what structures are 
;  *      passed around the API. For example, you may allow the Q3Set_Add call 
;  *      take one type of argument, store your element internally in some 
;  *      abstract data type, and have the Q3Set_Get call take a different 
;  *      argument.
;  *
;  *      For example:
;  *          
;  *      There are four calls which at some point will copy an element:
;  *
;  *      Q3Set_Add (copied from Application memory to QuickDraw3D memory)
;  *      Q3Set_Get (copied from QuickDraw3D memory to Application memory)
;  *      Q3Object_Duplicate (all elements are copied internally)
;  *      Q3AttributeSet_Inherit (all elements are copied internally)
;  *
;  *      Either CopyAdd or CopyReplace is called during the "_Add" call.
;  *          - CopyAdd is destructive and should assume "toElement" is garbage
;  *          - CopyReplace is replacing an existing element.
;  *
;  *      CopyGet is called during the "_Get" call.
;  *
;  *      CopyDuplicate is called to duplicate an element's internal structure.
;  *
;  * Attributes Methods - 
;  *
;  *      For copying data while Inheriting. Element methods are used
;  *      at all other times.
;  *  
;  *      CopyInherit is called to duplicate an element's internal structure 
;  *          during inheritance. You should make this as fast as possible.
;  *          (for example, if your custom element contains objects, you
;  *           should do a Q3Shared_GetReference instead of a Q3Object_Duplicate)
;  *          
;  *      The ElementDelete method will be called for all of your elements 
;  *      copied around via CopyAdd, CopyReplace, CopyDuplicate, and 
;  *      CopyInherit.
;  *      If CopyGet allocates any memory in it's destination, it is up to the 
;  *      application to delete it on its side.
;  
; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $kQ3XMethodTypeElementCopyAdd :|ecpa|)
(defconstant $kQ3XMethodTypeElementCopyReplace :|ecpr|)
(defconstant $kQ3XMethodTypeElementCopyGet :|ecpg|)
(defconstant $kQ3XMethodTypeElementCopyDuplicate :|eccd|)
(defconstant $kQ3XMethodTypeElementDelete :|ecpl|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XElementCopyAddMethod = FUNCTION(fromAPIElement: UNIV Ptr; toInternalElement: UNIV Ptr): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xelementcopyaddmethod (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XElementCopyReplaceMethod = FUNCTION(fromAPIElement: UNIV Ptr; ontoInternalElement: UNIV Ptr): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xelementcopyreplacemethod (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XElementCopyGetMethod = FUNCTION(fromInternalElement: UNIV Ptr; toAPIElement: UNIV Ptr): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xelementcopygetmethod (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XElementCopyDuplicateMethod = FUNCTION(fromInternalElement: UNIV Ptr; toInternalElement: UNIV Ptr): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xelementcopyduplicatemethod (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XElementDeleteMethod = FUNCTION(internalElement: UNIV Ptr): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xelementdeletemethod (find-mactype ':pointer))
; $ENDC

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3XElementClass_Register()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3XElementClass_Register" 
      ((elementType (:pointer :signed-long)) (name :pointer) (sizeOfElement :unsigned-long) (metaHandler :pointer)) 
  :pointer
   () )

; 
;  *  Q3XElementType_GetElementSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XElementType_GetElementSize" 
      ((elementType :signed-long) (sizeOfElement (:pointer :unsigned-long))) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; *****************************************************************************
;  **                                                                          **
;  **                     Custom Attribute Registration                        **
;  **                                                                          **
;  ****************************************************************************

(def-mactype :tq3xattributeinheritmethod (find-mactype ':signed-long))
; 	 return kQ3True or kQ3False in your metahandler 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XAttributeCopyInheritMethod = FUNCTION(fromInternalAttribute: UNIV Ptr; toInternalAttribute: UNIV Ptr): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xattributecopyinheritmethod (find-mactype ':pointer))
; $ENDC

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3XAttributeClass_Register()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3XAttributeClass_Register" 
      ((attributeType (:pointer :signed-long)) (creatorName :pointer) (sizeOfElement :unsigned-long) (metaHandler :pointer)) 
  :pointer
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  Version 1.5
;  

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XAttributeDefaultMethod = FUNCTION(internalElement: UNIV Ptr): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xattributedefaultmethod (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XAttributeIsDefaultMethod = FUNCTION(internalElement: UNIV Ptr): TQ3Boolean; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xattributeisdefaultmethod (find-mactype ':pointer))
; $ENDC

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QD3DSetIncludes

; $ENDC                                         ; __QD3DSET__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'QD3DSet)