(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QD3DStyle.p"
; at Wednesday May 1,2002 2:42:30 pm.
; 
;      File:       QD3DStyle.p
;  
;      Contains:   Q3Style types and routines
;  
;      Version:    Technology: Quickdraw 3D 1.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __QD3DSTYLE__
; $SETC __QD3DSTYLE__ := 1

; $I+
; $SETC QD3DStyleIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __QD3D__
|#

(require-interface 'QD3D)
#|                                              ; $I QD3D.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

; *****************************************************************************
;  **                                                                          **
;  **                 Style Base Class Routines                                **
;  **                                                                          **
;  ****************************************************************************
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Q3Style_GetType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Style_GetType" 
      ((style :pointer)) 
  :tq3objecttype
   () )

; 
;  *  Q3Style_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Style_Submit" 
      ((style :pointer) (view :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                              Subdivision                                 **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3subdivisionmethod (find-mactype ':signed-long))

(defconstant $kQ3SubdivisionMethodConstant 0)
(defconstant $kQ3SubdivisionMethodWorldSpace 1)
(defconstant $kQ3SubdivisionMethodScreenSpace 2)

(def-mactype :tq3subdivisionstyledataptr (find-mactype '(:pointer :tq3subdivisionstyledata)))
(defrecord TQ3SubdivisionStyleData 
   (method :signed-long)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (c1 :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (c2 :single-float)
   )

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3SubdivisionStyle_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3SubdivisionStyle_New" 
      ((data (:pointer :tq3subdivisionstyledata))) 
  :pointer
   () )

; 
;  *  Q3SubdivisionStyle_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3SubdivisionStyle_Submit" 
      ((data (:pointer :tq3subdivisionstyledata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3SubdivisionStyle_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3SubdivisionStyle_SetData" 
      ((subdiv :pointer) (data (:pointer :tq3subdivisionstyledata))) 
  :tq3status
   () )

; 
;  *  Q3SubdivisionStyle_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3SubdivisionStyle_GetData" 
      ((subdiv :pointer) (data (:pointer :tq3subdivisionstyledata))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Pick ID                                      **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3PickIDStyle_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PickIDStyle_New" 
      ((id :unsigned-long)) 
  :pointer
   () )

; 
;  *  Q3PickIDStyle_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PickIDStyle_Submit" 
      ((id :unsigned-long) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3PickIDStyle_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PickIDStyle_Get" 
      ((pickIDObject :pointer) (id (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3PickIDStyle_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PickIDStyle_Set" 
      ((pickIDObject :pointer) (id :unsigned-long)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Pick Parts                                   **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3pickpartsmasks (find-mactype ':signed-long))

(defconstant $kQ3PickPartsObject 0)
(defconstant $kQ3PickPartsMaskFace #x1)
(defconstant $kQ3PickPartsMaskEdge #x2)
(defconstant $kQ3PickPartsMaskVertex #x4)

(def-mactype :tq3pickparts (find-mactype ':unsigned-long))
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3PickPartsStyle_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3PickPartsStyle_New" 
      ((parts :unsigned-long)) 
  :pointer
   () )

; 
;  *  Q3PickPartsStyle_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PickPartsStyle_Submit" 
      ((parts :unsigned-long) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3PickPartsStyle_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PickPartsStyle_Get" 
      ((pickPartsObject :pointer) (parts (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3PickPartsStyle_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PickPartsStyle_Set" 
      ((pickPartsObject :pointer) (parts :unsigned-long)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Receive Shadows                                      **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ReceiveShadowsStyle_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ReceiveShadowsStyle_New" 
      ((receives :signed-long)) 
  :pointer
   () )

; 
;  *  Q3ReceiveShadowsStyle_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ReceiveShadowsStyle_Submit" 
      ((receives :signed-long) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3ReceiveShadowsStyle_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ReceiveShadowsStyle_Get" 
      ((styleObject :pointer) (receives (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3ReceiveShadowsStyle_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ReceiveShadowsStyle_Set" 
      ((styleObject :pointer) (receives :signed-long)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Fill Styles                                      **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3fillstyle (find-mactype ':signed-long))

(defconstant $kQ3FillStyleFilled 0)
(defconstant $kQ3FillStyleEdges 1)
(defconstant $kQ3FillStylePoints 2)

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3FillStyle_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3FillStyle_New" 
      ((fillStyle :signed-long)) 
  :pointer
   () )

; 
;  *  Q3FillStyle_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3FillStyle_Submit" 
      ((fillStyle :signed-long) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3FillStyle_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3FillStyle_Get" 
      ((styleObject :pointer) (fillStyle (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3FillStyle_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3FillStyle_Set" 
      ((styleObject :pointer) (fillStyle :signed-long)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Backfacing Styles                                **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3backfacingstyle (find-mactype ':signed-long))

(defconstant $kQ3BackfacingStyleBoth 0)
(defconstant $kQ3BackfacingStyleRemove 1)
(defconstant $kQ3BackfacingStyleFlip 2)

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3BackfacingStyle_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3BackfacingStyle_New" 
      ((backfacingStyle :signed-long)) 
  :pointer
   () )

; 
;  *  Q3BackfacingStyle_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3BackfacingStyle_Submit" 
      ((backfacingStyle :signed-long) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3BackfacingStyle_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3BackfacingStyle_Get" 
      ((backfacingObject :pointer) (backfacingStyle (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3BackfacingStyle_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3BackfacingStyle_Set" 
      ((backfacingObject :pointer) (backfacingStyle :signed-long)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Interpolation Types                              **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3interpolationstyle (find-mactype ':signed-long))

(defconstant $kQ3InterpolationStyleNone 0)
(defconstant $kQ3InterpolationStyleVertex 1)
(defconstant $kQ3InterpolationStylePixel 2)

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3InterpolationStyle_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3InterpolationStyle_New" 
      ((interpolationStyle :signed-long)) 
  :pointer
   () )

; 
;  *  Q3InterpolationStyle_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3InterpolationStyle_Submit" 
      ((interpolationStyle :signed-long) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3InterpolationStyle_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3InterpolationStyle_Get" 
      ((interpolationObject :pointer) (interpolationStyle (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3InterpolationStyle_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3InterpolationStyle_Set" 
      ((interpolationObject :pointer) (interpolationStyle :signed-long)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Highlight Style                              **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3HighlightStyle_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3HighlightStyle_New" 
      ((highlightAttribute :pointer)) 
  :pointer
   () )

; 
;  *  Q3HighlightStyle_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3HighlightStyle_Submit" 
      ((highlightAttribute :pointer) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3HighlightStyle_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3HighlightStyle_Get" 
      ((highlight :pointer) (highlightAttribute (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3HighlightStyle_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3HighlightStyle_Set" 
      ((highlight :pointer) (highlightAttribute :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         FrontFacing Direction Styles                     **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3orientationstyle (find-mactype ':signed-long))

(defconstant $kQ3OrientationStyleCounterClockwise 0)
(defconstant $kQ3OrientationStyleClockwise 1)

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3OrientationStyle_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3OrientationStyle_New" 
      ((frontFacingDirection :signed-long)) 
  :pointer
   () )

; 
;  *  Q3OrientationStyle_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3OrientationStyle_Submit" 
      ((frontFacingDirection :signed-long) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3OrientationStyle_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3OrientationStyle_Get" 
      ((frontFacingDirectionObject :pointer) (frontFacingDirection (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3OrientationStyle_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3OrientationStyle_Set" 
      ((frontFacingDirectionObject :pointer) (frontFacingDirection :signed-long)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             AntiAlias Style                              **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3antialiasmodemasks (find-mactype ':signed-long))

(defconstant $kQ3AntiAliasModeMaskEdges #x1)
(defconstant $kQ3AntiAliasModeMaskFilled #x2)

(def-mactype :tq3antialiasmode (find-mactype ':unsigned-long))
(def-mactype :tq3antialiasstyledataptr (find-mactype '(:pointer :tq3antialiasstyledata)))
(defrecord TQ3AntiAliasStyleData 
   (state :signed-long)
   (mode :unsigned-long)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (quality :single-float)
   )

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3AntiAliasStyle_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3AntiAliasStyle_New" 
      ((data (:pointer :tq3antialiasstyledata))) 
  :pointer
   () )

; 
;  *  Q3AntiAliasStyle_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3AntiAliasStyle_Submit" 
      ((data (:pointer :tq3antialiasstyledata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3AntiAliasStyle_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3AntiAliasStyle_GetData" 
      ((styleObject :pointer) (data (:pointer :tq3antialiasstyledata))) 
  :tq3status
   () )

; 
;  *  Q3AntiAliasStyle_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3AntiAliasStyle_SetData" 
      ((styleObject :pointer) (data (:pointer :tq3antialiasstyledata))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                                 Fog Style                                **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3fogmode (find-mactype ':signed-long))

(defconstant $kQ3FogModeLinear 0)
(defconstant $kQ3FogModeExponential 1)
(defconstant $kQ3FogModeExponentialSquared 2)
(defconstant $kQ3FogModeAlpha 3)

(def-mactype :tq3fogstyledataptr (find-mactype '(:pointer :tq3fogstyledata)))
(defrecord TQ3FogStyleData 
   (state :signed-long)
   (mode :signed-long)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (fogStart :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (fogEnd :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (density :single-float)
   (color :tq3colorargb)
   )

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3FogStyle_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3FogStyle_New" 
      ((data (:pointer :tq3fogstyledata))) 
  :pointer
   () )

; 
;  *  Q3FogStyle_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3FogStyle_Submit" 
      ((data (:pointer :tq3fogstyledata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3FogStyle_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3FogStyle_GetData" 
      ((styleObject :pointer) (data (:pointer :tq3fogstyledata))) 
  :tq3status
   () )

; 
;  *  Q3FogStyle_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3FogStyle_SetData" 
      ((styleObject :pointer) (data (:pointer :tq3fogstyledata))) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QD3DStyleIncludes

; $ENDC                                         ; __QD3DSTYLE__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'QD3DStyle)