(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QD3DTransform.p"
; at Wednesday May 1,2002 2:42:40 pm.
; 
;      File:       QD3DTransform.p
;  
;      Contains:   Q3Transform routines
;  
;      Version:    Technology: Quickdraw 3D 1.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __QD3DTRANSFORM__
; $SETC __QD3DTRANSFORM__ := 1

; $I+
; $SETC QD3DTransformIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __QD3D__
|#

(require-interface 'QD3D)
#|                                              ; $I QD3D.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

; *****************************************************************************
;  **                                                                          **
;  **                         Transform Routines                               **
;  **                                                                          **
;  ****************************************************************************
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Q3Transform_GetType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Transform_GetType" 
      ((transform :pointer)) 
  :tq3objecttype
   () )

; 
;  *  Q3Transform_GetMatrix()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Transform_GetMatrix" 
      ((transform :pointer) (matrix (:pointer :tq3matrix4x4))) 
  (:pointer :tq3matrix4x4)
   () )

; 
;  *  Q3Transform_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Transform_Submit" 
      ((transform :pointer) (view :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         MatrixTransform Routines                         **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3MatrixTransform_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3MatrixTransform_New" 
      ((matrix (:pointer :tq3matrix4x4))) 
  :pointer
   () )

; 
;  *  Q3MatrixTransform_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3MatrixTransform_Submit" 
      ((matrix (:pointer :tq3matrix4x4)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3MatrixTransform_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3MatrixTransform_Set" 
      ((transform :pointer) (matrix (:pointer :tq3matrix4x4))) 
  :tq3status
   () )

; 
;  *  Q3MatrixTransform_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3MatrixTransform_Get" 
      ((transform :pointer) (matrix (:pointer :tq3matrix4x4))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         RotateTransform Data                             **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3rotatetransformdataptr (find-mactype '(:pointer :tq3rotatetransformdata)))
(defrecord TQ3RotateTransformData 
   (axis :signed-long)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (radians :single-float)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                         RotateTransform Routines                         **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3RotateTransform_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3RotateTransform_New" 
      ((data (:pointer :tq3rotatetransformdata))) 
  :pointer
   () )

; 
;  *  Q3RotateTransform_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3RotateTransform_Submit" 
      ((data (:pointer :tq3rotatetransformdata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3RotateTransform_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3RotateTransform_SetData" 
      ((transform :pointer) (data (:pointer :tq3rotatetransformdata))) 
  :tq3status
   () )

; 
;  *  Q3RotateTransform_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3RotateTransform_GetData" 
      ((transform :pointer) (data (:pointer :tq3rotatetransformdata))) 
  :tq3status
   () )

; 
;  *  Q3RotateTransform_SetAxis()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3RotateTransform_SetAxis" 
      ((transform :pointer) (axis :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3RotateTransform_SetAngle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3RotateTransform_SetAngle" 
      ((transform :pointer) (radians :single-float)) 
  :tq3status
   () )

; 
;  *  Q3RotateTransform_GetAxis()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3RotateTransform_GetAxis" 
      ((renderable :pointer) (axis (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3RotateTransform_GetAngle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3RotateTransform_GetAngle" 
      ((transform :pointer) (radians (:pointer :single-float))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                 RotateAboutPointTransform Data                           **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3rotateaboutpointtransformdataptr (find-mactype '(:pointer :tq3rotateaboutpointtransformdata)))
(defrecord TQ3RotateAboutPointTransformData 
   (axis :signed-long)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (radians :single-float)
   (about :tq3point3d)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                 RotateAboutPointTransform Routines                       **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3RotateAboutPointTransform_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3RotateAboutPointTransform_New" 
      ((data (:pointer :tq3rotateaboutpointtransformdata))) 
  :pointer
   () )

; 
;  *  Q3RotateAboutPointTransform_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3RotateAboutPointTransform_Submit" 
      ((data (:pointer :tq3rotateaboutpointtransformdata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3RotateAboutPointTransform_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3RotateAboutPointTransform_SetData" 
      ((transform :pointer) (data (:pointer :tq3rotateaboutpointtransformdata))) 
  :tq3status
   () )

; 
;  *  Q3RotateAboutPointTransform_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3RotateAboutPointTransform_GetData" 
      ((transform :pointer) (data (:pointer :tq3rotateaboutpointtransformdata))) 
  :tq3status
   () )

; 
;  *  Q3RotateAboutPointTransform_SetAxis()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3RotateAboutPointTransform_SetAxis" 
      ((transform :pointer) (axis :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3RotateAboutPointTransform_GetAxis()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3RotateAboutPointTransform_GetAxis" 
      ((transform :pointer) (axis (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3RotateAboutPointTransform_SetAngle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3RotateAboutPointTransform_SetAngle" 
      ((transform :pointer) (radians :single-float)) 
  :tq3status
   () )

; 
;  *  Q3RotateAboutPointTransform_GetAngle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3RotateAboutPointTransform_GetAngle" 
      ((transform :pointer) (radians (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3RotateAboutPointTransform_SetAboutPoint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3RotateAboutPointTransform_SetAboutPoint" 
      ((transform :pointer) (about (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3RotateAboutPointTransform_GetAboutPoint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3RotateAboutPointTransform_GetAboutPoint" 
      ((transform :pointer) (about (:pointer :tq3point3d))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                 RotateAboutAxisTransform Data                            **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3rotateaboutaxistransformdataptr (find-mactype '(:pointer :tq3rotateaboutaxistransformdata)))
(defrecord TQ3RotateAboutAxisTransformData 
   (origin :tq3point3d)
   (orientation :tq3vector3d)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (radians :single-float)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                 RotateAboutAxisTransform Routines                        **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3RotateAboutAxisTransform_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_Q3RotateAboutAxisTransform_New" 
      ((data (:pointer :tq3rotateaboutaxistransformdata))) 
  :pointer
   () )

; 
;  *  Q3RotateAboutAxisTransform_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3RotateAboutAxisTransform_Submit" 
      ((data (:pointer :tq3rotateaboutaxistransformdata)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3RotateAboutAxisTransform_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3RotateAboutAxisTransform_SetData" 
      ((transform :pointer) (data (:pointer :tq3rotateaboutaxistransformdata))) 
  :tq3status
   () )

; 
;  *  Q3RotateAboutAxisTransform_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3RotateAboutAxisTransform_GetData" 
      ((transform :pointer) (data (:pointer :tq3rotateaboutaxistransformdata))) 
  :tq3status
   () )

; 
;  *  Q3RotateAboutAxisTransform_SetOrientation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3RotateAboutAxisTransform_SetOrientation" 
      ((transform :pointer) (axis (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3RotateAboutAxisTransform_GetOrientation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3RotateAboutAxisTransform_GetOrientation" 
      ((transform :pointer) (axis (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3RotateAboutAxisTransform_SetAngle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3RotateAboutAxisTransform_SetAngle" 
      ((transform :pointer) (radians :single-float)) 
  :tq3status
   () )

; 
;  *  Q3RotateAboutAxisTransform_GetAngle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3RotateAboutAxisTransform_GetAngle" 
      ((transform :pointer) (radians (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3RotateAboutAxisTransform_SetOrigin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3RotateAboutAxisTransform_SetOrigin" 
      ((transform :pointer) (origin (:pointer :tq3point3d))) 
  :tq3status
   () )

; 
;  *  Q3RotateAboutAxisTransform_GetOrigin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3RotateAboutAxisTransform_GetOrigin" 
      ((transform :pointer) (origin (:pointer :tq3point3d))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         ScaleTransform Routines                          **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ScaleTransform_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3ScaleTransform_New" 
      ((scale (:pointer :tq3vector3d))) 
  :pointer
   () )

; 
;  *  Q3ScaleTransform_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3ScaleTransform_Submit" 
      ((scale (:pointer :tq3vector3d)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3ScaleTransform_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3ScaleTransform_Set" 
      ((transform :pointer) (scale (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3ScaleTransform_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ScaleTransform_Get" 
      ((transform :pointer) (scale (:pointer :tq3vector3d))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         TranslateTransform Routines                      **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3TranslateTransform_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3TranslateTransform_New" 
      ((translate (:pointer :tq3vector3d))) 
  :pointer
   () )

; 
;  *  Q3TranslateTransform_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3TranslateTransform_Submit" 
      ((translate (:pointer :tq3vector3d)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3TranslateTransform_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3TranslateTransform_Set" 
      ((transform :pointer) (translate (:pointer :tq3vector3d))) 
  :tq3status
   () )

; 
;  *  Q3TranslateTransform_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3TranslateTransform_Get" 
      ((transform :pointer) (translate (:pointer :tq3vector3d))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         QuaternionTransform Routines                     **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3QuaternionTransform_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3QuaternionTransform_New" 
      ((quaternion (:pointer :tq3quaternion))) 
  :pointer
   () )

; 
;  *  Q3QuaternionTransform_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3QuaternionTransform_Submit" 
      ((quaternion (:pointer :tq3quaternion)) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3QuaternionTransform_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3QuaternionTransform_Set" 
      ((transform :pointer) (quaternion (:pointer :tq3quaternion))) 
  :tq3status
   () )

; 
;  *  Q3QuaternionTransform_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3QuaternionTransform_Get" 
      ((transform :pointer) (quaternion (:pointer :tq3quaternion))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         ResetTransform Routines                          **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ResetTransform_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ResetTransform_New" 
      () 
  :pointer
   () )

; 
;  *  Q3ResetTransform_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ResetTransform_Submit" 
      ((view :pointer)) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QD3DTransformIncludes

; $ENDC                                         ; __QD3DTRANSFORM__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'QD3DTransform)