(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QD3DViewer.p"
; at Wednesday May 1,2002 2:42:41 pm.
; 
;      File:       QD3DViewer.p
;  
;      Contains:   MacOS Viewer Controller Interface File.
;  
;      Version:    Technology: Quickdraw 3D 1.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __QD3DVIEWER__
; $SETC __QD3DVIEWER__ := 1

; $I+
; $SETC QD3DViewerIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __QD3D__
|#

(require-interface 'QD3D)
#|                                              ; $I QD3D.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QD3DGROUP__
|#

(require-interface 'QD3DGroup)
#|                                              ; $I QD3DGroup.p
 |#                                             ; $ENDC

; $IFC TARGET_OS_MAC 
#|                                              ; $IFC UNDEFINED __EVENTS__
|#

(require-interface 'Events)
#|                                              ; $I Events.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC
; $ENDC                                         ; TARGET_OS_MAC

; $PUSH
; $ALIGN POWER
; $LibExport+

(def-mactype :tq3viewerobject (find-mactype ':pointer))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3ViewerWindowResizeCallbackMethod = FUNCTION(theViewer: TQ3ViewerObject; data: UNIV Ptr): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3viewerwindowresizecallbackmethod (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3ViewerPaneResizeNotifyCallbackMethod = FUNCTION(theViewer: TQ3ViewerObject; data: UNIV Ptr): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3viewerpaneresizenotifycallbackmethod (find-mactype ':pointer))
; $ENDC

; $IFC TARGET_OS_MAC 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3ViewerDrawingCallbackMethod = FUNCTION(theViewer: TQ3ViewerObject; data: UNIV Ptr): OSErr; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3viewerdrawingcallbackmethod (find-mactype ':pointer))
; $ENDC

(defconstant $kQ3ViewerShowBadge #x1)
(defconstant $kQ3ViewerActive #x2)
(defconstant $kQ3ViewerControllerVisible #x4)
(defconstant $kQ3ViewerDrawFrame #x8)
(defconstant $kQ3ViewerDraggingOff #x10)
(defconstant $kQ3ViewerButtonCamera #x20)
(defconstant $kQ3ViewerButtonTruck #x40)
(defconstant $kQ3ViewerButtonOrbit #x80)
(defconstant $kQ3ViewerButtonZoom #x100)
(defconstant $kQ3ViewerButtonDolly #x200)
(defconstant $kQ3ViewerButtonReset #x400)
(defconstant $kQ3ViewerOutputTextMode #x800)
(defconstant $kQ3ViewerDragMode #x1000)
(defconstant $kQ3ViewerDrawGrowBox #x2000)
(defconstant $kQ3ViewerDrawDragBorder #x4000)
(defconstant $kQ3ViewerDraggingInOff #x8000)
(defconstant $kQ3ViewerDraggingOutOff #x10000)
(defconstant $kQ3ViewerButtonOptions #x20000)
(defconstant $kQ3ViewerPaneGrowBox #x40000)
(defconstant $kQ3ViewerDefault #x80000000)

(defconstant $kQ3ViewerEmpty 0)
(defconstant $kQ3ViewerHasModel #x1)
(defconstant $kQ3ViewerHasUndo #x2)

(def-mactype :tq3viewercameraview (find-mactype ':signed-long))

(defconstant $kQ3ViewerCameraRestore 0)
(defconstant $kQ3ViewerCameraFit 1)
(defconstant $kQ3ViewerCameraFront 2)
(defconstant $kQ3ViewerCameraBack 3)
(defconstant $kQ3ViewerCameraLeft 4)
(defconstant $kQ3ViewerCameraRight 5)
(defconstant $kQ3ViewerCameraTop 6)
(defconstant $kQ3ViewerCameraBottom 7)

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **     Return viewer version number                                         **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3ViewerGetVersion()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3ViewerGetVersion" 
      ((majorRevision (:pointer :unsigned-long)) (minorRevision (:pointer :unsigned-long))) 
  :signed-integer
   () )

; *****************************************************************************
;  **                                                                          **
;  **     Return viewer release version number                                 **
;  **     (in 'vers' format - e.g. 0x01518000 ==> 1.5.1 release)               **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ViewerGetReleaseVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerGetReleaseVersion" 
      ((releaseRevision (:pointer :unsigned-long))) 
  :signed-integer
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Creation and destruction                             **
;  **             Note that this is not a QuickDraw 3D object                  **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ViewerNew()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerNew" 
      ((port (:pointer :cgrafport)) (Rect (:pointer :rect)) (flags :unsigned-long)) 
  :pointer
   () )

; 
;  *  Q3ViewerDispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerDispose" 
      ((theViewer :pointer)) 
  :signed-integer
   () )

; *****************************************************************************
;  **                                                                          **
;  **                 Functions to attach data to a viewer                     **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ViewerUseFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerUseFile" 
      ((theViewer :pointer) (refNum :signed-long)) 
  :signed-integer
   () )

; 
;  *  Q3ViewerUseData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerUseData" 
      ((theViewer :pointer) (data :pointer) (size :signed-long)) 
  :signed-integer
   () )

; *****************************************************************************
;  **                                                                          **
;  **     Functions to write data out from the Viewer                          **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ViewerWriteFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerWriteFile" 
      ((theViewer :pointer) (refNum :signed-long)) 
  :signed-integer
   () )

; 
;  *  Q3ViewerWriteData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerWriteData" 
      ((theViewer :pointer) (data :handle)) 
  :unsigned-long
   () )

; *****************************************************************************
;  **                                                                          **
;  **     Use this function to force the Viewer to re-draw                     **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ViewerDraw()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerDraw" 
      ((theViewer :pointer)) 
  :signed-integer
   () )

; 
;  *  Q3ViewerDrawContent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerDrawContent" 
      ((theViewer :pointer)) 
  :signed-integer
   () )

; 
;  *  Q3ViewerDrawControlStrip()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerDrawControlStrip" 
      ((theViewer :pointer)) 
  :signed-integer
   () )

; *****************************************************************************
;  **                                                                          **
;  **     Function used by the Viewer to filter and handle events              **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ViewerEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerEvent" 
      ((theViewer :pointer) (evt (:pointer :eventrecord))) 
  :boolean
   () )

; *****************************************************************************
;  **                                                                          **
;  **     This function returns a PICT of the contents of the                  **
;  **     Viewer's window.  The application should dispose the PICT.           **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ViewerGetPict()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerGetPict" 
      ((theViewer :pointer)) 
  (:handle :picture)
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Calls for dealing with Buttons                       **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ViewerGetButtonRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerGetButtonRect" 
      ((theViewer :pointer) (button :unsigned-long) (Rect (:pointer :rect))) 
  :signed-integer
   () )

; 
;  *  Q3ViewerGetCurrentButton()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerGetCurrentButton" 
      ((theViewer :pointer)) 
  :unsigned-long
   () )

; 
;  *  Q3ViewerSetCurrentButton()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerSetCurrentButton" 
      ((theViewer :pointer) (button :unsigned-long)) 
  :signed-integer
   () )

; *****************************************************************************
;  **                                                                          **
;  **     Functions to set/get the group to be displayed by the Viewer.        **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ViewerUseGroup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerUseGroup" 
      ((theViewer :pointer) (group :pointer)) 
  :signed-integer
   () )

; 
;  *  Q3ViewerGetGroup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerGetGroup" 
      ((theViewer :pointer)) 
  :pointer
   () )

; *****************************************************************************
;  **                                                                          **
;  **     Functions to set/get the color used to clear the window              **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ViewerSetBackgroundColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerSetBackgroundColor" 
      ((theViewer :pointer) (color (:pointer :tq3colorargb))) 
  :signed-integer
   () )

; 
;  *  Q3ViewerGetBackgroundColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerGetBackgroundColor" 
      ((theViewer :pointer) (color (:pointer :tq3colorargb))) 
  :signed-integer
   () )

; *****************************************************************************
;  **                                                                          **
;  **     Getting/Setting a Viewer's View object.                              **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ViewerGetView()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerGetView" 
      ((theViewer :pointer)) 
  :pointer
   () )

; 
;  *  Q3ViewerRestoreView()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerRestoreView" 
      ((theViewer :pointer)) 
  :signed-integer
   () )

; *****************************************************************************
;  **                                                                          **
;  **     Calls for setting/getting viewer flags                               **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ViewerSetFlags()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerSetFlags" 
      ((theViewer :pointer) (flags :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  Q3ViewerGetFlags()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerGetFlags" 
      ((theViewer :pointer)) 
  :unsigned-long
   () )

; *****************************************************************************
;  **                                                                          **
;  **     Calls related to bounds/dimensions.  Bounds is the size of           **
;  **     the window.  Dimensions can either be the Rect from the ViewHints    **
;  **     or the current dimensions of the window (if you do a Set).           **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ViewerSetBounds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerSetBounds" 
      ((theViewer :pointer) (bounds (:pointer :rect))) 
  :signed-integer
   () )

; 
;  *  Q3ViewerGetBounds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerGetBounds" 
      ((theViewer :pointer) (bounds (:pointer :rect))) 
  :signed-integer
   () )

; 
;  *  Q3ViewerSetDimension()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerSetDimension" 
      ((theViewer :pointer) (width :unsigned-long) (height :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  Q3ViewerGetDimension()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerGetDimension" 
      ((theViewer :pointer) (width (:pointer :unsigned-long)) (height (:pointer :unsigned-long))) 
  :signed-integer
   () )

; 
;  *  Q3ViewerGetMinimumDimension()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerGetMinimumDimension" 
      ((theViewer :pointer) (width (:pointer :unsigned-long)) (height (:pointer :unsigned-long))) 
  :signed-integer
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Port related calls                               **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ViewerSetPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerSetPort" 
      ((theViewer :pointer) (port (:pointer :cgrafport))) 
  :signed-integer
   () )

; 
;  *  Q3ViewerGetPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerGetPort" 
      ((theViewer :pointer)) 
  (:pointer :cgrafport)
   () )

; *****************************************************************************
;  **                                                                          **
;  **     Adjust Cursor should be called from idle loop to allow the Viewer    **
;  **     to change the cursor according to the cursor position/object under   **
;  **     the cursor.                                                          **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ViewerAdjustCursor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerAdjustCursor" 
      ((theViewer :pointer) (pt (:pointer :point))) 
  :boolean
   () )

; 
;  *  Q3ViewerCursorChanged()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerCursorChanged" 
      ((theViewer :pointer)) 
  :signed-integer
   () )

; *****************************************************************************
;  **                                                                          **
;  **     Returns the state of the viewer.  See the constant defined at the    **
;  **     top of this file.                                                    **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ViewerGetState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerGetState" 
      ((theViewer :pointer)) 
  :unsigned-long
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Clipboard utilities                              **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ViewerClear()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerClear" 
      ((theViewer :pointer)) 
  :signed-integer
   () )

; 
;  *  Q3ViewerCut()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerCut" 
      ((theViewer :pointer)) 
  :signed-integer
   () )

; 
;  *  Q3ViewerCopy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerCopy" 
      ((theViewer :pointer)) 
  :signed-integer
   () )

; 
;  *  Q3ViewerPaste()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerPaste" 
      ((theViewer :pointer)) 
  :signed-integer
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         New Event Model                                  **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ViewerMouseDown()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerMouseDown" 
      ((theViewer :pointer) (x :signed-long) (y :signed-long)) 
  :boolean
   () )

; 
;  *  Q3ViewerContinueTracking()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerContinueTracking" 
      ((theViewer :pointer) (x :signed-long) (y :signed-long)) 
  :boolean
   () )

; 
;  *  Q3ViewerMouseUp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerMouseUp" 
      ((theViewer :pointer) (x :signed-long) (y :signed-long)) 
  :boolean
   () )

; 
;  *  Q3ViewerHandleKeyEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerHandleKeyEvent" 
      ((theViewer :pointer) (evt (:pointer :eventrecord))) 
  :boolean
   () )

; *****************************************************************************
;  **                                                                          **
;  **                                 CallBacks                                **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ViewerSetDrawingCallbackMethod()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerSetDrawingCallbackMethod" 
      ((theViewer :pointer) (callbackMethod :pointer) (data :pointer)) 
  :signed-integer
   () )

; 
;  *  Q3ViewerSetWindowResizeCallback()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerSetWindowResizeCallback" 
      ((theViewer :pointer) (windowResizeCallbackMethod :pointer) (data :pointer)) 
  :signed-integer
   () )

; 
;  *  Q3ViewerSetPaneResizeNotifyCallback()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerSetPaneResizeNotifyCallback" 
      ((theViewer :pointer) (paneResizeNotifyCallbackMethod :pointer) (data :pointer)) 
  :signed-integer
   () )

; *****************************************************************************
;  **                                                                          **
;  **                                 Undo                                     **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ViewerUndo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerUndo" 
      ((theViewer :pointer)) 
  :signed-integer
   () )

; 
;  *  Q3ViewerGetUndoString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerGetUndoString" 
      ((theViewer :pointer) (str :pointer) (cnt (:pointer :unsigned-long))) 
  :boolean
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Camera Support                               **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ViewerGetCameraCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerGetCameraCount" 
      ((theViewer :pointer) (cnt (:pointer :unsigned-long))) 
  :signed-integer
   () )

; 
;  *  Q3ViewerSetCameraByNumber()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerSetCameraByNumber" 
      ((theViewer :pointer) (cameraNo :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  Q3ViewerSetCameraByView()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerSetCameraByView" 
      ((theViewer :pointer) (viewType :signed-long)) 
  :signed-integer
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Pop-up Button Options                            **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ViewerSetRendererType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerSetRendererType" 
      ((theViewer :pointer) (rendererType :signed-long)) 
  :signed-integer
   () )

; 
;  *  Q3ViewerGetRendererType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerGetRendererType" 
      ((theViewer :pointer) (rendererType (:pointer :signed-long))) 
  :signed-integer
   () )

; 
;  *  Q3ViewerChangeBrightness()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerChangeBrightness" 
      ((theViewer :pointer) (brightness :single-float)) 
  :signed-integer
   () )

; 
;  *  Q3ViewerSetRemoveBackfaces()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerSetRemoveBackfaces" 
      ((theViewer :pointer) (remove :signed-long)) 
  :signed-integer
   () )

; 
;  *  Q3ViewerGetRemoveBackfaces()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerGetRemoveBackfaces" 
      ((theViewer :pointer) (remove (:pointer :signed-long))) 
  :signed-integer
   () )

; 
;  *  Q3ViewerSetPhongShading()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerSetPhongShading" 
      ((theViewer :pointer) (phong :signed-long)) 
  :signed-integer
   () )

; 
;  *  Q3ViewerGetPhongShading()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ViewerGetPhongShading" 
      ((theViewer :pointer) (phong (:pointer :signed-long))) 
  :signed-integer
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; TARGET_OS_MAC

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QD3DViewerIncludes

; $ENDC                                         ; __QD3DVIEWER__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'QD3DViewer)