(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QD3DWinViewer.p"
; at Wednesday May 1,2002 2:42:42 pm.
; 
;      File:       QD3DWinViewer.p
;  
;      Contains:   Win32 Viewer Controller Interface File.
;  
;      Version:    Technology: Quickdraw 3D 1.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __QD3DWINVIEWER__
; $SETC __QD3DWINVIEWER__ := 1

; $I+
; $SETC QD3DWinViewerIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __QD3D__
|#

(require-interface 'QD3D)
#|                                              ; $I QD3D.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QD3DGROUP__
|#

(require-interface 'QD3DGroup)
#|                                              ; $I QD3DGroup.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

#|                                              ; $IFC TARGET_OS_WIN32 

(def-mactype :tq3viewerobject (find-mactype ':pointer))
; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3ViewerDrawingCallbackMethod = FUNCTION(theViewer: TQ3ViewerObject; data: UNIV Ptr): TQ3Status; C;

|#                                              ; $ELSEC
(def-mactype :tq3viewerdrawingcallbackmethod (find-mactype ':pointer))
; $ENDC

; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3ViewerWindowResizeCallbackMethod = FUNCTION(theViewer: TQ3ViewerObject; data: UNIV Ptr): TQ3Status; C;

|#                                              ; $ELSEC
(def-mactype :tq3viewerwindowresizecallbackmethod (find-mactype ':pointer))
; $ENDC

; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3ViewerPaneResizeNotifyCallbackMethod = FUNCTION(theViewer: TQ3ViewerObject; data: UNIV Ptr): TQ3Status; C;

|#                                              ; $ELSEC
(def-mactype :tq3viewerpaneresizenotifycallbackmethod (find-mactype ':pointer))
; $ENDC

(defconstant $kQ3ViewerShowBadge #x1)
(defconstant $kQ3ViewerActive #x2)
(defconstant $kQ3ViewerControllerVisible #x4)
(defconstant $kQ3ViewerButtonCamera #x8)
(defconstant $kQ3ViewerButtonTruck #x10)
(defconstant $kQ3ViewerButtonOrbit #x20)
(defconstant $kQ3ViewerButtonZoom #x40)
(defconstant $kQ3ViewerButtonDolly #x80)
(defconstant $kQ3ViewerButtonReset #x100)
(defconstant $kQ3ViewerButtonNone #x200)
(defconstant $kQ3ViewerOutputTextMode #x400)
(defconstant $kQ3ViewerDraggingInOff #x800)
(defconstant $kQ3ViewerButtonOptions #x1000)
(defconstant $kQ3ViewerPaneGrowBox #x2000)
(defconstant $kQ3ViewerDefault #x8000)

(defconstant $kQ3ViewerEmpty 0)
(defconstant $kQ3ViewerHasModel #x1)
(defconstant $kQ3ViewerHasUndo #x2)

(def-mactype :tq3viewercameraview (find-mactype ':signed-long))

(defconstant $kQ3ViewerCameraRestore 0)
(defconstant $kQ3ViewerCameraFit 1)
(defconstant $kQ3ViewerCameraFront 2)
(defconstant $kQ3ViewerCameraBack 3)
(defconstant $kQ3ViewerCameraLeft 4)
(defconstant $kQ3ViewerCameraRight 5)
(defconstant $kQ3ViewerCameraTop 6)
(defconstant $kQ3ViewerCameraBottom 7)

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             WM_NOTIFY structures                         **
; 	 **                                                                          **
; 	 ****************************************************************************	

(def-mactype :tq3viewerdropfilesptr (find-mactype '(:pointer :tq3viewerdropfiles)))
(defrecord TQ3ViewerDropFiles 
#|
; Warning: type-size: unknown type nmhdr
|##|
; Warning: type-size: unknown type nmhdr
|#
   (_nmhdr :nmhdr)
   (hDrop :handle)
   )

(def-mactype :tq3viewersetviewptr (find-mactype '(:pointer :tq3viewersetview)))
(defrecord TQ3ViewerSetView 
#|
; Warning: type-size: unknown type nmhdr
|##|
; Warning: type-size: unknown type nmhdr
|#
   (_nmhdr :nmhdr)
   (view :signed-long)
   )

(def-mactype :tq3viewersetviewnumberptr (find-mactype '(:pointer :tq3viewersetviewnumber)))
(defrecord TQ3ViewerSetViewNumber 
#|
; Warning: type-size: unknown type nmhdr
|##|
; Warning: type-size: unknown type nmhdr
|#
   (_nmhdr :nmhdr)
   (number :unsigned-long)
   )

(def-mactype :tq3viewerbuttonsetptr (find-mactype '(:pointer :tq3viewerbuttonset)))
(defrecord TQ3ViewerButtonSet 
#|
; Warning: type-size: unknown type nmhdr
|##|
; Warning: type-size: unknown type nmhdr
|#
   (_nmhdr :nmhdr)
   (button :unsigned-long)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             WM_NOTIFY defines                            **
; 	 **                                                                          **
; 	 ****************************************************************************	
; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                         Win32 Window Class Name                          **
; 	 **     Can be passed as a parameter to CreateWindow or CreateWindowEx       **
; 	 **                                                                          **
; 	 ****************************************************************************	

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                         Win32 Clipboard type                             **
; 	 **                                                                          **
; 	 ****************************************************************************	
; 	*****************************************************************************
; 	 **                                                                          **
; 	 **     Return viewer version number                                         **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3WinViewerGetVersion()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3WinViewerGetVersion" 
      ((majorRevision (:pointer :unsigned-long)) (minorRevision (:pointer :unsigned-long))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **     Return viewer release version number                                 **
;  **     (in 'vers' format - e.g. 0x01518000 ==> 1.5.1 release)               **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3WinViewerGetReleaseVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerGetReleaseVersion" 
      ((releaseRevision (:pointer :unsigned-long))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Creation and destruction                             **
;  **             Note that this is not a QuickDraw 3D object                  **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3WinViewerNew()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3WinViewerNew" 
      ((window :hwnd) (RECT (:pointer :rect)) (flags :unsigned-long)) 
  :pointer
   () )

; 
;  *  Q3WinViewerDispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerDispose" 
      ((viewer :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                 Functions to attach data to a WinViewer                  **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3WinViewerUseFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerUseFile" 
      ((viewer :pointer) (fileHandle :handle)) 
  :tq3status
   () )

; 
;  *  Q3WinViewerUseData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerUseData" 
      ((viewer :pointer) (data :pointer) (size :unsigned-long)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **             Functions to write data out from the WinViewer               **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3WinViewerWriteFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerWriteFile" 
      ((viewer :pointer) (fileHandle :handle)) 
  :tq3status
   () )

; 
;  *  Q3WinViewerWriteData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerWriteData" 
      ((viewer :pointer) (data :pointer) (dataSize :unsigned-long) (actualDataSize (:pointer :unsigned-long))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **     Use this function to force the WinViewer to re-draw                  **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3WinViewerDraw()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerDraw" 
      ((viewer :pointer)) 
  :tq3status
   () )

; 
;  *  Q3WinViewerDrawContent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerDrawContent" 
      ((viewer :pointer)) 
  :tq3status
   () )

; 
;  *  Q3WinViewerDrawControlStrip()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerDrawControlStrip" 
      ((viewer :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **     Function used by the WinViewer to filter and handle events           **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3WinViewerMouseDown()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerMouseDown" 
      ((viewer :pointer) (x :signed-long) (y :signed-long)) 
  :bool
   () )

; 
;  *  Q3WinViewerContinueTracking()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerContinueTracking" 
      ((viewer :pointer) (x :signed-long) (y :signed-long)) 
  :bool
   () )

; 
;  *  Q3WinViewerMouseUp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerMouseUp" 
      ((viewer :pointer) (x :signed-long) (y :signed-long)) 
  :bool
   () )

; *****************************************************************************
;  **                                                                          **
;  **     This function returns a Bitmap of the contents of the                **
;  **     WinViewer's window.  The application should dispose the Bitmap.      **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3WinViewerGetBitmap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerGetBitmap" 
      ((viewer :pointer)) 
  :hbitmap
   () )

; *****************************************************************************
;  **                                                                          **
;  **                 Calls for dealing with Buttons                           **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3WinViewerGetButtonRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerGetButtonRect" 
      ((viewer :pointer) (button :unsigned-long) (rectangle (:pointer :rect))) 
  :tq3status
   () )

; 
;  *  Q3WinViewerGetCurrentButton()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerGetCurrentButton" 
      ((viewer :pointer)) 
  :unsigned-long
   () )

; 
;  *  Q3WinViewerSetCurrentButton()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerSetCurrentButton" 
      ((viewer :pointer) (button :unsigned-long)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **     Functions to set/get the group to be displayed by the WinViewer.     **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3WinViewerUseGroup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerUseGroup" 
      ((viewer :pointer) (group :pointer)) 
  :tq3status
   () )

; 
;  *  Q3WinViewerGetGroup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerGetGroup" 
      ((viewer :pointer)) 
  :pointer
   () )

; *****************************************************************************
;  **                                                                          **
;  **     Functions to set/get the color used to clear the window              **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3WinViewerSetBackgroundColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerSetBackgroundColor" 
      ((viewer :pointer) (color (:pointer :tq3colorargb))) 
  :tq3status
   () )

; 
;  *  Q3WinViewerGetBackgroundColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerGetBackgroundColor" 
      ((viewer :pointer) (color (:pointer :tq3colorargb))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **     Getting/Setting a WinViewer's View object.                           **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3WinViewerGetView()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerGetView" 
      ((viewer :pointer)) 
  :pointer
   () )

; 
;  *  Q3WinViewerRestoreView()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerRestoreView" 
      ((viewer :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **     Calls for setting/getting WinViewer flags                            **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3WinViewerSetFlags()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerSetFlags" 
      ((viewer :pointer) (flags :unsigned-long)) 
  :tq3status
   () )

; 
;  *  Q3WinViewerGetFlags()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerGetFlags" 
      ((viewer :pointer)) 
  :unsigned-long
   () )

; *****************************************************************************
;  **                                                                          **
;  **     Calls related to bounds/dimensions.  Bounds is the size of           **
;  **     the window.  Dimensions can either be the Rect from the ViewHints    **
;  **     or the current dimensions of the window (if you do a Set).           **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3WinViewerSetBounds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerSetBounds" 
      ((viewer :pointer) (bounds (:pointer :rect))) 
  :tq3status
   () )

; 
;  *  Q3WinViewerGetBounds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerGetBounds" 
      ((viewer :pointer) (bounds (:pointer :rect))) 
  :tq3status
   () )

; 
;  *  Q3WinViewerSetDimension()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerSetDimension" 
      ((viewer :pointer) (width :unsigned-long) (height :unsigned-long)) 
  :tq3status
   () )

; 
;  *  Q3WinViewerGetDimension()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerGetDimension" 
      ((viewer :pointer) (width (:pointer :unsigned-long)) (height (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3WinViewerGetMinimumDimension()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerGetMinimumDimension" 
      ((viewer :pointer) (width (:pointer :unsigned-long)) (height (:pointer :unsigned-long))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Window related calls                             **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3WinViewerSetWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerSetWindow" 
      ((viewer :pointer) (window :hwnd)) 
  :tq3status
   () )

; 
;  *  Q3WinViewerGetWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerGetWindow" 
      ((viewer :pointer)) 
  :hwnd
   () )

; 
;  *  Q3WinViewerGetViewer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerGetViewer" 
      ((theWindow :hwnd)) 
  :pointer
   () )

; 
;  *  Q3WinViewerGetControlStrip()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerGetControlStrip" 
      ((viewer :pointer)) 
  :hwnd
   () )

; *****************************************************************************
;  **                                                                          **
;  **     Adjust Cursor provided for compatibility with Mac Viewer             **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3WinViewerAdjustCursor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerAdjustCursor" 
      ((viewer :pointer) (x :signed-long) (y :signed-long)) 
  :tq3boolean
   () )

; 
;  *  Q3WinViewerCursorChanged()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerCursorChanged" 
      ((viewer :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **     Returns the state of the WinViewer.  See the constant defined at the **
;  **     top of this file.                                                    **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3WinViewerGetState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerGetState" 
      ((viewer :pointer)) 
  :unsigned-long
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Clipboard utilities                              **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3WinViewerClear()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerClear" 
      ((viewer :pointer)) 
  :tq3status
   () )

; 
;  *  Q3WinViewerCut()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerCut" 
      ((viewer :pointer)) 
  :tq3status
   () )

; 
;  *  Q3WinViewerCopy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerCopy" 
      ((viewer :pointer)) 
  :tq3status
   () )

; 
;  *  Q3WinViewerPaste()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerPaste" 
      ((viewer :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Undo                                         **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3WinViewerUndo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerUndo" 
      ((viewer :pointer)) 
  :tq3status
   () )

; 
;  *  Q3WinViewerGetUndoString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerGetUndoString" 
      ((viewer :pointer) (theString :pointer) (stringSize :unsigned-long) (actualSize (:pointer :unsigned-long))) 
  :tq3boolean
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         New Camera Stuff                                 **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3WinViewerGetCameraCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerGetCameraCount" 
      ((viewer :pointer) (count (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3WinViewerSetCameraNumber()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerSetCameraNumber" 
      ((viewer :pointer) (cameraNo :unsigned-long)) 
  :tq3status
   () )

; 
;  *  Q3WinViewerSetCameraView()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WinViewerSetCameraView" 
      ((viewer :pointer) (viewType :signed-long)) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC; TARGET_OS_WIN32

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QD3DWinViewerIncludes

; $ENDC                                         ; __QD3DWINVIEWER__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'QD3DWinViewer)#|
; Warning: Did not recognize these types or records: (tq3viewerdropfiles nmhdr tq3viewersetview tq3viewersetviewnumber tq3viewerbuttonset hwnd bool hbitmap)
|#