(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QDOffscreen.p"
; at Wednesday May 1,2002 2:39:36 pm.
; 
;      File:       QDOffscreen.p
;  
;      Contains:   Quickdraw Offscreen GWorld Interfaces.
;  
;      Version:    Technology: Mac OS 8
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __QDOFFSCREEN__
; $SETC __QDOFFSCREEN__ := 1

; $I+
; $SETC QDOffscreenIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;     NOTE:   GWorldFlags is no longer defined as a SET.  Instead it is a LONGINT
;             and the set elements are bit masks.  You will need to use Bit-OR's 
;             to build a set and Bit-AND's to test sets.
; 

(defconstant $pixPurgeBit 0)
(defconstant $noNewDeviceBit 1)
(defconstant $useTempMemBit 2)
(defconstant $keepLocalBit 3)
(defconstant $useDistantHdwrMemBit 4)
(defconstant $useLocalHdwrMemBit 5)
(defconstant $pixelsPurgeableBit 6)
(defconstant $pixelsLockedBit 7)
(defconstant $mapPixBit 16)
(defconstant $newDepthBit 17)
(defconstant $alignPixBit 18)
(defconstant $newRowBytesBit 19)
(defconstant $reallocPixBit 20)
(defconstant $clipPixBit 28)
(defconstant $stretchPixBit 29)
(defconstant $ditherPixBit 30)
(defconstant $gwFlagErrBit 31)

(defconstant $pixPurge #x1)
(defconstant $noNewDevice #x2)
(defconstant $useTempMem #x4)
(defconstant $keepLocal #x8)
(defconstant $useDistantHdwrMem #x10)
(defconstant $useLocalHdwrMem #x20)
(defconstant $pixelsPurgeable #x40)
(defconstant $pixelsLocked #x80)
(defconstant $kAllocDirectDrawSurface #x4000)
(defconstant $mapPix #x10000)
(defconstant $newDepth #x20000)
(defconstant $alignPix #x40000)
(defconstant $newRowBytes #x80000)
(defconstant $reallocPix #x100000)
(defconstant $clipPix #x10000000)
(defconstant $stretchPix #x20000000)
(defconstant $ditherPix #x40000000)
(defconstant $gwFlagErr #x80000000)

(def-mactype :gworldflags (find-mactype ':unsigned-long))
; 	 Type definition of a GWorldPtr 	
(def-mactype :gworldptr (find-mactype '(:pointer :cgrafport)))
; 
; 	 *  NewGWorld()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; CONST
(deftrap "_NewGWorld" 
      ((offscreenGWorld (:pointer (:pointer :cgrafport))) (PixelDepth :signed-integer) (boundsRect (:pointer :rect)) (cTable (:handle :colortable)) (aGDevice (:handle :gdevice)) (flags :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xAB1D :d0 (+ (ash 22 16) 0) offscreenGWorld PixelDepth boundsRect cTable aGDevice flags))

;   GDevice attribute bits for Carbon and QuickTime 3.0 

(defconstant $deviceIsIndirect #x1)
(defconstant $deviceNeedsLock #x2)
(defconstant $deviceIsStatic #x4)
(defconstant $deviceIsExternalBuffer #x8)
(defconstant $deviceIsDDSurface #x10)
(defconstant $deviceIsDCISurface #x20)
(defconstant $deviceIsGDISurface #x40)
(defconstant $deviceIsAScreen #x80)
(defconstant $deviceIsOverlaySurface #x100)

#|                                              ; $IFC TARGET_OS_WIN32 
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  GetGDeviceSurface()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; 
;  *  GetGDeviceAttributes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetGDeviceSurface" 
      ((gdh (:handle :gdevice))) 
  :pointer
   () )                                         ;  to allocate non-mac-rgb GWorlds use QTNewGWorld (ImageCompression.h) ; 
;  *  NewGWorldFromHBITMAP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetGDeviceAttributes" 
      ((gdh (:handle :gdevice))) 
  :unsigned-long
   () )
(deftrap-inline "_NewGWorldFromHBITMAP" 
      ((offscreenGWorld (:pointer (:pointer :cgrafport))) (cTable (:handle :colortable)) (aGDevice (:handle :gdevice)) (flags :unsigned-long) (newHBITMAP :pointer) (newHDC :pointer)) 
  :signed-integer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC; TARGET_OS_WIN32

; 
;  *  NewGWorldFromPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; 
;  *  LockPixels()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NewGWorldFromPtr" 
      ((offscreenGWorld (:pointer (:pointer :cgrafport))) (PixelFormat :unsigned-long) (boundsRect (:pointer :rect)) (cTable (:handle :colortable)) (aGDevice (:handle :gdevice)) (flags :unsigned-long) (newBuffer :pointer) (rowBytes :signed-long)) 
  :signed-integer
   () )
(deftrap "_LockPixels" 
      ((pm (:handle :pixmap)))
   (:stack :boolean)
   (:stack-trap #xAB1D :d0 (+ (ash 4 16) 1) pm))

; 
;  *  UnlockPixels()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_UnlockPixels" 
      ((pm (:handle :pixmap)))
   nil
   (:stack-trap #xAB1D :d0 (+ (ash 4 16) 2) pm))

; 
;  *  UpdateGWorld()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_UpdateGWorld" 
      ((offscreenGWorld (:pointer (:pointer :cgrafport))) (pixelDepth :signed-integer) (boundsRect (:pointer :rect)) (cTable (:handle :colortable)) (aGDevice (:handle :gdevice)) (flags :unsigned-long))
   (:stack :unsigned-long)
   (:stack-trap #xAB1D :d0 (+ (ash 22 16) 3) offscreenGWorld pixelDepth boundsRect cTable aGDevice flags))

; 
;  *  DisposeGWorld()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeGWorld" 
      ((offscreenGWorld (:pointer :cgrafport)))
   nil
   (:stack-trap #xAB1D :d0 (+ (ash 4 16) 4) offscreenGWorld))

; 
;  *  GetGWorld()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetGWorld" 
      ((port (:pointer (:pointer :cgrafport))) (gdh (:pointer (:handle :gdevice))))
   nil
   (:stack-trap #xAB1D :d0 (+ (ash 8 16) 5) port gdh))

; 
;  *  SetGWorld()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetGWorld" 
      ((port (:pointer :cgrafport)) (gdh (:handle :gdevice)))
   nil
   (:stack-trap #xAB1D :d0 (+ (ash 8 16) 6) port gdh))

; 
;  *  CTabChanged()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CTabChanged" 
      ((ctab (:handle :colortable)))
   nil
   (:stack-trap #xAB1D :d0 (+ (ash 4 16) 7) ctab))

; 
;  *  PixPatChanged()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PixPatChanged" 
      ((ppat (:handle :pixpat)))
   nil
   (:stack-trap #xAB1D :d0 (+ (ash 4 16) 8) ppat))

; 
;  *  PortChanged()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PortChanged" 
      ((port (:pointer :grafport)))
   nil
   (:stack-trap #xAB1D :d0 (+ (ash 4 16) 9) port))

; 
;  *  GDeviceChanged()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GDeviceChanged" 
      ((gdh (:handle :gdevice)))
   nil
   (:stack-trap #xAB1D :d0 (+ (ash 4 16) 10) gdh))

; 
;  *  AllowPurgePixels()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AllowPurgePixels" 
      ((pm (:handle :pixmap)))
   nil
   (:stack-trap #xAB1D :d0 (+ (ash 4 16) 11) pm))

; 
;  *  NoPurgePixels()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_NoPurgePixels" 
      ((pm (:handle :pixmap)))
   nil
   (:stack-trap #xAB1D :d0 (+ (ash 4 16) 12) pm))

; 
;  *  GetPixelsState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetPixelsState" 
      ((pm (:handle :pixmap)))
   (:stack :unsigned-long)
   (:stack-trap #xAB1D :d0 (+ (ash 4 16) 13) pm))

; 
;  *  SetPixelsState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetPixelsState" 
      ((pm (:handle :pixmap)) (state :unsigned-long))
   nil
   (:stack-trap #xAB1D :d0 (+ (ash 8 16) 14) pm state))

; 
;  *  GetPixBaseAddr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetPixBaseAddr" 
      ((pm (:handle :pixmap)))
   (:stack :pointer)
   (:stack-trap #xAB1D :d0 (+ (ash 4 16) 15) pm))

; 
;  *  GetPixRowBytes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetPixRowBytes" 
      ((pm (:handle :pixmap)))
   (:stack :signed-long)
   (:stack-trap #xAB1D :d0 (+ (ash 4 16) 24) pm))

; 
;  *  NewScreenBuffer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_NewScreenBuffer" 
      ((globalRect (:pointer :rect)) (purgeable :boolean) (gdh (:pointer (:handle :gdevice))) (offscreenPixMap (:pointer (:handle :pixmap))))
   (:stack :signed-integer)
   (:stack-trap #xAB1D :d0 (+ (ash 14 16) 16) globalRect purgeable gdh offscreenPixMap))

; 
;  *  DisposeScreenBuffer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeScreenBuffer" 
      ((offscreenPixMap (:handle :pixmap)))
   nil
   (:stack-trap #xAB1D :d0 (+ (ash 4 16) 17) offscreenPixMap))

; 
;  *  GetGWorldDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetGWorldDevice" 
      ((offscreenGWorld (:pointer :cgrafport)))
   (:stack (:handle :gdevice))
   (:stack-trap #xAB1D :d0 (+ (ash 4 16) 18) offscreenGWorld))

; 
;  *  QDDone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_QDDone" 
      ((port (:pointer :grafport)))
   (:stack :boolean)
   (:stack-trap #xAB1D :d0 (+ (ash 4 16) 19) port))

; 
;  *  OffscreenVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OffscreenVersion" 
      ()
   (:stack :signed-long)
   (:stack-trap #xAB1D :d0 20))

; 
;  *  NewTempScreenBuffer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_NewTempScreenBuffer" 
      ((globalRect (:pointer :rect)) (purgeable :boolean) (gdh (:pointer (:handle :gdevice))) (offscreenPixMap (:pointer (:handle :pixmap))))
   (:stack :signed-integer)
   (:stack-trap #xAB1D :d0 (+ (ash 14 16) 21) globalRect purgeable gdh offscreenPixMap))

; 
;  *  PixMap32Bit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PixMap32Bit" 
      ((pmHandle (:handle :pixmap)))
   (:stack :boolean)
   (:stack-trap #xAB1D :d0 (+ (ash 4 16) 22) pmHandle))

; 
;  *  GetGWorldPixMap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetGWorldPixMap" 
      ((offscreenGWorld (:pointer :cgrafport)))
   (:stack (:handle :pixmap))
   (:stack-trap #xAB1D :d0 (+ (ash 4 16) 23) offscreenGWorld))

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QDOffscreenIncludes

; $ENDC                                         ; __QDOFFSCREEN__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'QDOffscreen)