(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QTSMovie.p"
; at Wednesday May 1,2002 2:42:43 pm.
; 
;      File:       QTSMovie.p
;  
;      Contains:   QuickTime Interfaces.
;  
;      Version:    Universal Interfaces 3.4.1
;  
;      Copyright:   1990-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __QTSMOVIE__
; $SETC __QTSMOVIE__ := 1

; $I+
; $SETC QTSMovieIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __COMPONENTS__
|#

(require-interface 'Components)
#|                                              ; $I Components.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MOVIES__
|#

(require-interface 'Movies)
#|                                              ; $I Movies.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __QUICKTIMESTREAMING__

(require-interface 'QuickTimeStreaming)         ; $I QuickTimeStreaming.p
; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $kQTSStreamMediaType :|strm|)

(def-mactype :qtssampledescriptionptr (find-mactype '(:pointer :qtssampledescription)))
(defrecord QTSSampleDescription 
   (descSize :signed-long)
   (dataFormat :signed-long)
   (resvd1 :signed-long)                        ;   set to 0 
   (resvd2 :signed-integer)                     ;   set to 0 
   (dataRefIndex :signed-integer)
   (version :unsigned-long)
   (resvd3 :unsigned-long)                      ;   set to 0 
   (flags :signed-long)
;   qt atoms follow: 
;        long size, long type, some data 
;        repeat as necessary 
   )

(def-mactype :qtssampledescriptionhandle (find-mactype '(:handle :qtssampledescription)))

(defconstant $kQTSSampleDescriptionVersion1 1)

(defconstant $kQTSDefaultMediaTimeScale 600)

;   sample description flags 
(defconstant $kQTSSampleDescPassSampleDataAsHandleFlag #x1)

; 	============================================================================
; 	        Stream Media Handler
; 	============================================================================	
; 	-----------------------------------------
; 	    Info Selectors
; 	-----------------------------------------	
; 	 all indexes start at 1 	

(defconstant $kQTSMediaPresentationInfo :|pres|);   QTSMediaPresentationParams*  
(defconstant $kQTSMediaNotificationInfo :|noti|);   QTSMediaNotificationParams*  
(defconstant $kQTSMediaTotalDataRateInfo :|dtrt|);   UInt32*, bits/sec  
(defconstant $kQTSMediaLostPercentInfo :|lspc|) ;   Fixed*  
(defconstant $kQTSMediaNumStreamsInfo :|nstr|)  ;   UInt32*  
(defconstant $kQTSMediaIndSampleDescriptionInfo :|isdc|);   QTSMediaIndSampleDescriptionParams*  

(def-mactype :qtsmediapresentationparamsptr (find-mactype '(:pointer :qtsmediapresentationparams)))
(defrecord QTSMediaPresentationParams 
   (presentationID (:pointer :qtspresentationrecord))
   )

(def-mactype :qtsmedianotificationparamsptr (find-mactype '(:pointer :qtsmedianotificationparams)))
(defrecord QTSMediaNotificationParams 
   (notificationProc :pointer)
   (notificationRefCon :pointer)
   (flags :signed-long)
   )

(def-mactype :qtsmediaindsampledescriptionparamsptr (find-mactype '(:pointer :qtsmediaindsampledescriptionparams)))
(defrecord QTSMediaIndSampleDescriptionParams 
   (index :signed-long)
   (returnedMediaType :ostype)
   (returnedSampleDescription (:handle :sampledescription))
   )

; 	-----------------------------------------
; 	    QTS Media Handler Selectors
; 	-----------------------------------------	

(defconstant $kQTSMediaSetInfoSelect #x100)
(defconstant $kQTSMediaGetInfoSelect #x101)
(defconstant $kQTSMediaSetIndStreamInfoSelect #x102)
(defconstant $kQTSMediaGetIndStreamInfoSelect #x103)

; 	-----------------------------------------
; 	    QTS Media Handler functions
; 	-----------------------------------------	
; 
; 	 *  QTSMediaSetInfo()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 *    Windows:          in QTSClient.lib 4.0 and later
; 	 	

(deftrap "_QTSMediaSetInfo" 
      ((mh (:pointer :componentinstancerecord)) (inSelector :ostype) (ioParams :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh inSelector ioParams ((+ (ash 8 16) 256) :signed-longint)))

; 
;  *  QTSMediaGetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_QTSMediaGetInfo" 
      ((mh (:pointer :componentinstancerecord)) (inSelector :ostype) (ioParams :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh inSelector ioParams ((+ (ash 8 16) 257) :signed-longint)))

; 
;  *  QTSMediaSetIndStreamInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_QTSMediaSetIndStreamInfo" 
      ((mh (:pointer :componentinstancerecord)) (inIndex :signed-long) (inSelector :ostype) (ioParams :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh inIndex inSelector ioParams ((+ (ash 12 16) 258) :signed-longint)))

; 
;  *  QTSMediaGetIndStreamInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_QTSMediaGetIndStreamInfo" 
      ((mh (:pointer :componentinstancerecord)) (inIndex :signed-long) (inSelector :ostype) (ioParams :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mh inIndex inSelector ioParams ((+ (ash 12 16) 259) :signed-longint)))

; ============================================================================
;         Hint Media Handler
; ============================================================================

(defconstant $kQTSHintMediaType :|hint|)

(defconstant $kQTSHintTrackReference :|hint|)

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QTSMovieIncludes

; $ENDC                                         ; __QTSMOVIE__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'QTSMovie)