(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QTStreamingComponents.p"
; at Wednesday May 1,2002 2:42:44 pm.
; 
;      File:       QTStreamingComponents.p
;  
;      Contains:   QuickTime Interfaces.
;  
;      Version:    Technology: QuickTime 5.0.1
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1990-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __QTSTREAMINGCOMPONENTS__
; $SETC __QTSTREAMINGCOMPONENTS__ := 1

; $I+
; $SETC QTStreamingComponentsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __COMPONENTS__
|#

(require-interface 'Components)
#|                                              ; $I Components.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MOVIES__
|#

(require-interface 'Movies)
#|                                              ; $I Movies.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKTIMESTREAMING__
|#

(require-interface 'QuickTimeStreaming)
#|                                              ; $I QuickTimeStreaming.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; ============================================================================
;         Stream Sourcer
; ============================================================================

(defconstant $kQTSSourcerType :|srcr|)

(def-mactype :qtssourcer (find-mactype '(:pointer :componentinstancerecord)))

(defconstant $kQTSSGChannelSourcerType :|sgch|)
(defconstant $kQTSMovieTrackSourcerType :|trak|)
(defconstant $kQTSPushDataSourcerType :|push|)

; 	 flags for sourcer data 	
(defconstant $kQTSSourcerDataFlag_SyncSample #x1)

(defconstant $kQTSSourcerInitParamsVersion1 1)

(def-mactype :qtssourcerinitparamsptr (find-mactype '(:pointer :qtssourcerinitparams)))
(defrecord QTSSourcerInitParams 
   (version :signed-long)
   (flags :signed-long)
   (dataType :ostype)
   (data :pointer)
   (dataLength :unsigned-long)
   )

; 
; 	 *  QTSNewSourcer()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.3 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; CONST
(deftrap-inline "_QTSNewSourcer" 
      ((params :pointer) (inInitParams (:pointer :qtssourcerinitparams)) (inFlags :signed-long) (outSourcer (:pointer (:pointer :componentinstancerecord)))) 
  :signed-integer
   () )

;  info selectors for sourcers - get and set 

(defconstant $kQTSInfo_Track :|trak|)           ;   QTSTrackParams*  
(defconstant $kQTSInfo_Loop :|loop|)            ;   QTSLoopParams*  
(defconstant $kQTSInfo_SourcerTiming :|stim|)   ;   QTSSourcerTimingParams*  
(defconstant $kQTSInfo_TargetFrameRate :|tfps|) ;   Fixed * in frames per second  
(defconstant $kQTSInfo_PushData :|push|)        ;   QTSPushDataParams*  
(defconstant $kQTSInfo_SourcerCallbackProc :|scbp|);   QTSSourcerCallbackProcParams*  
(defconstant $kQTSInfo_TargetDataRate :|tdrt|)  ;   UInt32 * in bytes per second  
(defconstant $kQTSInfo_AudioAutoGainOnOff :|agc |);   Boolean*  - error if unavailable 
(defconstant $kQTSInfo_AudioGain :|gain|)       ;   Fixed* kFixed1 is unity gain  
(defconstant $kQTSInfo_CroppedInputRect :|crpr|);   Rect* - defined relative to kQTSInfo_FullInputRect below  
(defconstant $kQTSInfo_SpatialSettings :|sptl|) ;   pointer to SCSpatialSettings struct 
(defconstant $kQTSInfo_TemporalSettings :|tprl|);   pointer to SCTemporalSettings struct 
(defconstant $kQTSInfo_DataRateSettings :|drat|);   pointer to SCDataRateSettings struct 
(defconstant $kQTSInfo_CodecFlags :|cflg|)      ;   pointer to CodecFlags 
(defconstant $kQTSInfo_CodecSettings :|cdec|)   ;   pointer to Handle 
(defconstant $kQTSInfo_ForceKeyValue :|ksim|)   ;   pointer to long 
(defconstant $kQTSInfo_SoundSampleRate :|ssrt|) ;   pointer to UnsignedFixed 
(defconstant $kQTSInfo_SoundSampleSize :|ssss|) ;   pointer to short 
(defconstant $kQTSInfo_SoundChannelCount :|sscc|);   pointer to short 
(defconstant $kQTSInfo_SoundCompression :|ssct|);   pointer to OSType 
(defconstant $kQTSInfo_CompressionList :|ctyl|) ;   pointer to OSType Handle 
(defconstant $kQTSInfo_VideoHue :|hue |)        ;   UInt16*  
(defconstant $kQTSInfo_VideoSaturation :|satr|) ;   UInt16*  
(defconstant $kQTSInfo_VideoContrast :|trst|)   ;   UInt16*  
(defconstant $kQTSInfo_VideoBrightness :|brit|) ;   UInt16*  
(defconstant $kQTSInfo_VideoSharpness :|shrp|)  ;   UInt16*  
(defconstant $kQTSInfo_TimeScale :|scal|)       ;   UInt32*  

; 	 info selectors for sourcers - get only	
(defconstant $kQTSInfo_SGChannel :|sgch|)       ;   SGChannel*  
(defconstant $kQTSInfo_InputDeviceName :|innm|) ;   Handle*  
(defconstant $kQTSInfo_InputSourceName :|srnm|) ;   Handle*  
(defconstant $kQTSInfo_FullInputRect :|fulr|)   ;   Rect*  

; 	 loop flags 	
(defconstant $kQTSLoopFlag_Loop #x1)

(defconstant $kQTSLoopParamsVersion1 1)

(def-mactype :qtsloopparamsptr (find-mactype '(:pointer :qtsloopparams)))
(defrecord QTSLoopParams 
   (version :signed-long)
   (flags :signed-long)
   (loopFlags :signed-long)
   (flagsMask :signed-long)
   (numLoops :signed-long)
   )

(defconstant $kQTSTrackParamsVersion1 1)

(def-mactype :qtstrackparamsptr (find-mactype '(:pointer :qtstrackparams)))
(defrecord QTSTrackParams 
   (version :signed-long)
   (flags :signed-long)
   (Track (:pointer :trackrecord))
   (trackStartOffset :wide)                     ;   to start other than at the beginning otherwise set to 0 
   (duration :wide)                             ;   to limit the duration otherwise set to 0 
   (loopParams (:pointer :qtsloopparams))       ;   set to NULL if not using; default is no looping  
   )

(defconstant $kQTSSourcerTimingParamsVersion1 1)

(def-mactype :qtssourcertimingparamsptr (find-mactype '(:pointer :qtssourcertimingparams)))
(defrecord QTSSourcerTimingParams 
   (version :signed-long)
   (flags :signed-long)
   (TimeScale :signed-long)
   (presentationStartTime :wide)
   (presentationEndTime :wide)
   (presentationCurrentTime :wide)
   (localStartTime :wide)
   (localEndTime :wide)
   (localCurrentTime :wide)
   )

(defconstant $kQTSPushDataParamsVersion1 1)

(defconstant $kQTSPushDataFlag_SampleTimeIsValid #x1)
(defconstant $kQTSPushDataFlag_DurationIsValid #x2)

(def-mactype :qtspushdataparamsptr (find-mactype '(:pointer :qtspushdataparams)))
(defrecord QTSPushDataParams 
   (version :signed-long)
   (flags :signed-long)
   (sampleDescription (:handle :sampledescription));   caller owns the handle  
   (sampleDescSeed :unsigned-long)
   (sampleTime :wide)                           ;   also set flag if you set this  
   (duration :wide)                             ;   also set flag if you set this  
   (dataLength :unsigned-long)
   (dataPtr :pointer)                           ;   this does not have to be a real macintosh Ptr  
   )

(defconstant $kQTSSourcerCallbackProcParamsVersion1 1)

(def-mactype :qtssourcercallbackprocparamsptr (find-mactype '(:pointer :qtssourcercallbackprocparams)))
(defrecord QTSSourcerCallbackProcParams 
   (version :signed-long)
   (flags :signed-long)
   (proc :pointer)
   (refCon :pointer)
   )

;   track sourcer callback selectors 

(defconstant $kQTSSourcerCallback_Done :|done|) ;   QTSSourcerDoneParams*  

;   push data sourcer callback selectors 
(defconstant $kQTSPushDataSourcerCallback_HasCharacteristic #x50D);   QTSPushDataHasCharacteristicParams*  
(defconstant $kQTSPushDataSourcerCallback_SetInfo #x507);   QTSPushDataInfoParams*  
(defconstant $kQTSPushDataSourcerCallback_GetInfo #x508);   QTSPushDataInfoParams*  

(def-mactype :qtspushdatahascharacteristicparamsptr (find-mactype '(:pointer :qtspushdatahascharacteristicparams)))
(defrecord QTSPushDataHasCharacteristicParams 
   (version :signed-long)
   (flags :signed-long)
   (characteristic :ostype)
   (returnedHasIt :boolean)
   (reserved (:array :character 3 :packed))
   )

(def-mactype :qtspushdatainfoparamsptr (find-mactype '(:pointer :qtspushdatainfoparams)))
(defrecord QTSPushDataInfoParams 
   (version :signed-long)
   (flags :signed-long)
   (selector :ostype)
   (ioParams :pointer)
   )

(defconstant $kQTSSourcerDoneParamsVersion1 1)

(def-mactype :qtssourcerdoneparamsptr (find-mactype '(:pointer :qtssourcerdoneparams)))
(defrecord QTSSourcerDoneParams 
   (version :signed-long)
   (flags :signed-long)
   (sourcer (:pointer :componentinstancerecord))
   )

; 	-----------------------------------------
; 	    Stream Sourcer Selectors
; 	-----------------------------------------	

(defconstant $kQTSSourcerInitializeSelect #x500)
(defconstant $kQTSSourcerSetEnableSelect #x503)
(defconstant $kQTSSourcerGetEnableSelect #x504)
(defconstant $kQTSSourcerSetInfoSelect #x507)
(defconstant $kQTSSourcerGetInfoSelect #x508)
(defconstant $kQTSSourcerSetTimeScaleSelect #x50E)
(defconstant $kQTSSourcerGetTimeScaleSelect #x50F)
(defconstant $kQTSSourcerIdleSelect #x516)

; 	-----------------------------------------
; 	    Stream Sourcer Prototypes
; 	-----------------------------------------	
; 
; 	 *  QTSSourcerInitialize()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in QTStreamLib 5.0.1 and later
; 	 *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.1 and later
; 	 *    Mac OS X:         in version 10.1 and later
; 	 	
; CONST
(deftrap "_QTSSourcerInitialize" 
      ((inSourcer (:pointer :componentinstancerecord)) (inInitParams (:pointer :qtssourcerinitparams)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 inSourcer inInitParams ((+ (ash 4 16) 1280) :signed-longint)))

; 
;  *  QTSSourcerIdle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_QTSSourcerIdle" 
      ((inSourcer (:pointer :componentinstancerecord)) (inTime (:pointer :wide)) (inFlags :signed-long) (outFlags (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 inSourcer inTime inFlags outFlags ((+ (ash 12 16) 1302) :signed-longint)))

; 
;  *  QTSSourcerSetEnable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_QTSSourcerSetEnable" 
      ((inSourcer (:pointer :componentinstancerecord)) (inEnableMode :boolean) (inFlags :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 inSourcer inEnableMode inFlags ((+ (ash 6 16) 1283) :signed-longint)))

; 
;  *  QTSSourcerGetEnable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_QTSSourcerGetEnable" 
      ((inSourcer (:pointer :componentinstancerecord)) (outEnableMode (:pointer :boolean)) (inFlags :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 inSourcer outEnableMode inFlags ((+ (ash 8 16) 1284) :signed-longint)))

; 
;  *  QTSSourcerSetTimeScale()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_QTSSourcerSetTimeScale" 
      ((inSourcer (:pointer :componentinstancerecord)) (inTimeScale :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 inSourcer inTimeScale ((+ (ash 4 16) 1294) :signed-longint)))

; 
;  *  QTSSourcerGetTimeScale()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_QTSSourcerGetTimeScale" 
      ((inSourcer (:pointer :componentinstancerecord)) (outTimeScale (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 inSourcer outTimeScale ((+ (ash 4 16) 1295) :signed-longint)))

; 
;  *  QTSSourcerSetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_QTSSourcerSetInfo" 
      ((inSourcer (:pointer :componentinstancerecord)) (inSelector :ostype) (ioParams :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 inSourcer inSelector ioParams ((+ (ash 8 16) 1287) :signed-longint)))

; 
;  *  QTSSourcerGetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_QTSSourcerGetInfo" 
      ((inSourcer (:pointer :componentinstancerecord)) (inSelector :ostype) (ioParams :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 inSourcer inSelector ioParams ((+ (ash 8 16) 1288) :signed-longint)))

; ============================================================================
;         Stream Handler
; ============================================================================

; 
;     Server edits are only valid for the current chunk
; 

(def-mactype :shservereditparametersptr (find-mactype '(:pointer :shservereditparameters)))
(defrecord SHServerEditParameters 
   (version :unsigned-long)
   (editRate :signed-long)
   (dataStartTime_mediaAxis :wide)
   (dataEndTime_mediaAxis :wide)
   )

(defconstant $kSHNoChunkDispatchFlags 0)
(defconstant $kSHChunkFlagSyncSample #x4)
(defconstant $kSHChunkFlagDataLoss #x10)

(def-mactype :shchunkrecordptr (find-mactype '(:pointer :shchunkrecord)))
(defrecord SHChunkRecord 
   (version :unsigned-long)
   (reserved1 :signed-long)
   (flags :signed-long)
   (dataSize :unsigned-long)
   (dataPtr :pointer)
   (reserved2 :signed-long)
   (reserved3 :signed-long)
   (presentationTime :wide)
   (reserved4 :signed-long)
   (reserved5 :signed-long)
   (serverEditParameters (:pointer :shservereditparameters))
   (reserved6 :signed-long)
   (reserved7 :signed-long)
   )

; 	============================================================================
; 	        RTP Components
; 	============================================================================	
(def-mactype :rtpssrc (find-mactype ':unsigned-long))

(defconstant $kRTPInvalidSSRC 0)

; 	 RTP standard content encodings for audio 	
(defconstant $kRTPPayload_PCMU 0)               ;   8kHz PCM mu-law mono  
(defconstant $kRTPPayload_1016 1)               ;   8kHz CELP (Fed Std 1016) mono  
(defconstant $kRTPPayload_G721 2)               ;   8kHz G.721 ADPCM mono  
(defconstant $kRTPPayload_GSM 3)                ;   8kHz GSM mono  
(defconstant $kRTPPayload_G723 4)               ;   8kHz G.723 ADPCM mono  
(defconstant $kRTPPayload_DVI_8 5)              ;   8kHz Intel DVI ADPCM mono  
(defconstant $kRTPPayload_DVI_16 6)             ;   16kHz Intel DVI ADPCM mono  
(defconstant $kRTPPayload_LPC 7)                ;   8kHz LPC  
(defconstant $kRTPPayload_PCMA 8)               ;   8kHz PCM a-law mono  
(defconstant $kRTPPayload_L16_44_2 10)          ;   44.1kHz 16-bit linear stereo  
(defconstant $kRTPPayload_L16_44_1 11)          ;   44.1kHz 16-bit linear mono  
(defconstant $kRTPPayload_PureVoice 12)         ;   8kHz PureVoice mono (QCELP)  
(defconstant $kRTPPayload_MPEGAUDIO 14)         ;   MPEG I and II audio  
(defconstant $kRTPPayload_DVI_11 16)            ;   11kHz Intel DVI ADPCM mono  
(defconstant $kRTPPayload_DVI_22 17)            ;   22kHz Intel DVI ADPCM mono  

; 	 RTP standard content encodings for video 	
(defconstant $kRTPPayload_CELLB 25)             ;   Sun CellB  
(defconstant $kRTPPayload_JPEG 26)              ;   JPEG  
(defconstant $kRTPPayload_CUSEEME 27)           ;   Cornell CU-SeeMe  
(defconstant $kRTPPayload_NV 28)                ;   Xerox PARC nv  
(defconstant $kRTPPayload_PICWIN 29)            ;   BBN Picture Window  
(defconstant $kRTPPayload_CPV 30)               ;   Bolter CPV  
(defconstant $kRTPPayload_H261 31)              ;   CCITT H.261  
(defconstant $kRTPPayload_MPEGVIDEO 32)         ;   MPEG I and II video  
(defconstant $kRTPPayload_H263 34)              ;   CCITT H.263  

; 	 Other RTP standard content encodings 	
(defconstant $kRTPPayload_MPEG2T 33)            ;   MPEG 2 Transport  

; 	 Dynamic encodings 	
(defconstant $kRTPPayload_FirstDynamic 96)
(defconstant $kRTPPayload_LastDynamic 127)
(defconstant $kRTPPayload_Unknown #xFF)

; 	
; 	-----------------------------------------
; 	    RTP Info selectors
; 	-----------------------------------------
; 		
; 	 ----- these are get and set ----- 	
(defconstant $kRTPInfo_SSRC :|ssrc|)            ;   UInt32*  
(defconstant $kRTPInfo_NextSeqNum :|rnsn|)      ;   UInt16*  

; 	-----------------------------------------
; 	    RTP Statistics
; 	-----------------------------------------	
(defconstant $kRTPTotalReceivedPktsStat :|trcp|)
(defconstant $kRTPTotalLostPktsStat :|tlsp|)
(defconstant $kRTPTotalProcessedPktsStat :|tprp|)
(defconstant $kRTPTotalDroppedPktsStat :|tdrp|)
(defconstant $kRTPBadHeaderDroppedPktsStat :|bhdp|)
(defconstant $kRTPOurHeaderDroppedPktsStat :|ohdp|)
(defconstant $kRTPNotReceivingSenderDroppedPktsStat :|nsdp|)
(defconstant $kRTPNotProcessingDroppedPktsStat :|npdp|)
(defconstant $kRTPBadSeqDroppedPktsStat :|bsdp|)
(defconstant $kRTPArriveTooLatePktsStat :|artl|)
(defconstant $kRTPWaitForSeqDroppedPktsStat :|wsdp|)
(defconstant $kRTPBadStateDroppedPktsStat :|stdp|)
(defconstant $kRTPBadPayloadDroppedPktsStat :|bpdp|)
(defconstant $kRTPNoTimeScaleDroppedPktsStat :|ntdp|)
(defconstant $kRTPDupSeqNumDroppedPktsStat :|dsdp|)
(defconstant $kRTPLostPktsPercentStat :|lspp|)
(defconstant $kRTPDroppedPktsPercentStat :|dppp|)
(defconstant $kRTPTotalUnprocessedPktsPercentStat :|tupp|)
(defconstant $kRTPRTCPDataRateStat :|rrcd|)
(defconstant $kRTPPayloadIDStat :|rpid|)
(defconstant $kRTPPayloadNameStat :|rpnm|)
(defconstant $kRTPNumPktsInQueueStat :|rnpq|)
(defconstant $kRTPTotalPktsInQueueStat :|rtpq|)
(defconstant $kRTPTotalOutOfOrderPktsStat :|rtoo|)
(defconstant $kRTPRetransmissionStat :|rrtx|)

; 	-----------------------------------------
; 	    Payload Info
; 	-----------------------------------------	
(defconstant $kRTPPayloadSpeedTag :|sped|)      ;   0-255, 255 is fastest 
(defconstant $kRTPPayloadLossRecoveryTag :|loss|);   0-255, 0 can't handle any loss, 128 can handle 50% packet loss 

(def-mactype :rtppayloadcharacteristicptr (find-mactype '(:pointer :rtppayloadcharacteristic)))
(defrecord RTPPayloadCharacteristic 
   (tag :ostype)
   (value :signed-long)
   )

; 	
; 	    pass RTPPayloadSortRequest to QTSFindMediaPacketizer or QTSFindMediaPacketizerForTrack.
; 	    define the characteristics to sort by. tag is key to sort on. value is positive for ascending
; 	    sort (low value first), negative for descending sort (high value first).
; 		
(def-mactype :rtppayloadsortrequestptr (find-mactype '(:pointer :rtppayloadsortrequest)))
(defrecord RTPPayloadSortRequest 
   (characteristicCount :signed-long)
   (characteristic (:array :rtppayloadcharacteristic 1));   tag is key to sort on, value is + for ascending, - for descending 
   )

; 	 flags for RTPPayloadInfo 	

(defconstant $kRTPPayloadTypeStaticFlag #x1)
(defconstant $kRTPPayloadTypeDynamicFlag #x2)

(def-mactype :rtppayloadinfoptr (find-mactype '(:pointer :rtppayloadinfo)))
(defrecord RTPPayloadInfo 
   (payloadFlags :signed-long)
   (payloadID :signed-byte)
   (unused (:array :character 3 :packed))
   (payloadName :signed-byte)
   )

(def-mactype :rtppayloadinfohandle (find-mactype '(:handle :rtppayloadinfo)))
; 	============================================================================
; 	        RTP Reassembler
; 	============================================================================	
(def-mactype :rtpreassembler (find-mactype '(:pointer :componentinstancerecord)))

(defconstant $kRTPReassemblerType :|rtpr|)

(defconstant $kRTPBaseReassemblerType :|gnrc|)
(defconstant $kRTP261ReassemblerType :|h261|)
(defconstant $kRTP263ReassemblerType :|h263|)
(defconstant $kRTP263PlusReassemblerType :|263+|)
(defconstant $kRTPAudioReassemblerType :|soun|)
(defconstant $kRTPQTReassemblerType :|qtim|)
(defconstant $kRTPPureVoiceReassemblerType :|Qclp|)
(defconstant $kRTPMp3ReassemblerType :|mp3 |)
(defconstant $kRTPJPEGReassemblerType :|jpeg|)
(defconstant $kRTPQDesign2ReassemblerType :|QDM2|)
(defconstant $kRTPSorensonReassemblerType :|SVQ1|)

(def-mactype :rtprssminitparamsptr (find-mactype '(:pointer :rtprssminitparams)))
(defrecord RTPRssmInitParams 
   (ssrc :unsigned-long)
   (payloadType :signed-byte)
   (pad (:array :unsigned-byte 3 :packed))
   (TimeBase :pointer)
   (TimeScale :signed-long)
   )

(def-mactype :rtprssmpacketptr (find-mactype '(:pointer :rtprssmpacket)))
(defrecord RTPRssmPacket 
   (next (:pointer :rtprssmpacket))
   (prev (:pointer :rtprssmpacket))
   (streamBuffer (:pointer :qtsstreambuffer))
   (paramsFilledIn :boolean)
   (pad :signed-byte)
   (sequenceNum :unsigned-integer)
   (transportHeaderLength :unsigned-long)       ;   filled in by base 
   (payloadHeaderLength :unsigned-long)         ;   derived adjusts this  
   (dataLength :unsigned-long)
   (serverEditParams :shservereditparameters)
   (timeStamp :wide)                            ;   lower 32 bits is original rtp timestamp 
   (chunkFlags :signed-long)                    ;   these are or'd together 
   (flags :signed-long)
   )

;   flags for RTPRssmPacket struct 

(defconstant $kRTPRssmPacketHasMarkerBitSet #x1)
(defconstant $kRTPRssmPacketHasServerEditFlag #x10000)

;   flags for RTPRssmSendStreamBufferRange 
(defconstant $kRTPRssmCanRefStreamBuffer #x1)

;   flags for RTPRssmSendPacketList 
(defconstant $kRTPRssmLostSomePackets #x1)

;   flags for RTPRssmSetFlags 
(defconstant $kRTPRssmEveryPacketAChunkFlag #x1)
(defconstant $kRTPRssmQueueAndUseMarkerBitFlag #x2)
(defconstant $kRTPRssmTrackLostPacketsFlag #x10000)
(defconstant $kRTPRssmNoReorderingRequiredFlag #x20000)

(def-mactype :rtpsendstreambufferrangeparamsptr (find-mactype '(:pointer :rtpsendstreambufferrangeparams)))
(defrecord RTPSendStreamBufferRangeParams 
   (streamBuffer (:pointer :qtsstreambuffer))
   (presentationTime :wide)
   (chunkStartPosition :unsigned-long)
   (numDataBytes :unsigned-long)
   (chunkFlags :signed-long)
   (flags :signed-long)
   (serverEditParams (:pointer :shservereditparameters));   NULL if no edit 
   )

;   characteristics 

(defconstant $kRTPCharacteristic_RequiresOrderedPackets :|rrop|)
(defconstant $kRTPCharacteristic_TimeStampsNotMonoIncreasing :|tsmi|)

(defconstant $kRTPReassemblerInfoResType :|rsmi|)

(def-mactype :rtpreassemblerinfoptr (find-mactype '(:pointer :rtpreassemblerinfo)))
(defrecord RTPReassemblerInfo 
   (characteristicCount :signed-long)
   (characteristic (:array :rtppayloadcharacteristic 1))
;   after the last characteristic, the payload name (defined by the MediaPacketizerPayloadInfo 
;   structure) is present.  
   )

(def-mactype :rtpreassemblerinfohandle (find-mactype '(:handle :rtpreassemblerinfo)))
; 	 RTPReassemblerInfoElement structs are padded to 32 bits 	

(defconstant $kRTPReassemblerInfoPadUpToBytes 4)

; 
; 	 *  QTSFindReassemblerForPayloadID()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 *    Windows:          in QTSClient.lib 4.0 and later
; 	 	

(deftrap-inline "_QTSFindReassemblerForPayloadID" 
      ((inPayloadID :signed-byte) (inSortInfo (:pointer :rtppayloadsortrequest)) (outReassemblerList (:pointer :handle))) 
  :signed-integer
   () )

; 
;  *  QTSFindReassemblerForPayloadName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSFindReassemblerForPayloadName" 
      ((inPayloadName :pointer) (inSortInfo (:pointer :rtppayloadsortrequest)) (outReassemblerList (:pointer :handle))) 
  :signed-integer
   () )

; -----------------------------------------
;     RTP Reassembler Selectors
; -----------------------------------------

(defconstant $kRTPRssmSetCapabilitiesSelect #x100)
(defconstant $kRTPRssmGetCapabilitiesSelect #x101)
(defconstant $kRTPRssmSetPayloadHeaderLengthSelect #x102)
(defconstant $kRTPRssmGetPayloadHeaderLengthSelect #x103)
(defconstant $kRTPRssmSetTimeScaleSelect #x104)
(defconstant $kRTPRssmGetTimeScaleSelect #x105)
(defconstant $kRTPRssmNewStreamHandlerSelect #x106)
(defconstant $kRTPRssmSetStreamHandlerSelect #x107)
(defconstant $kRTPRssmGetStreamHandlerSelect #x108)
(defconstant $kRTPRssmSendStreamHandlerChangedSelect #x109)
(defconstant $kRTPRssmSetSampleDescriptionSelect #x10A)
(defconstant $kRTPRssmGetChunkAndIncrRefCountSelect #x10D)
(defconstant $kRTPRssmSendChunkAndDecrRefCountSelect #x10E)
(defconstant $kRTPRssmSendLostChunkSelect #x10F)
(defconstant $kRTPRssmSendStreamBufferRangeSelect #x110)
(defconstant $kRTPRssmClearCachedPackets #x111)
(defconstant $kRTPRssmFillPacketListParamsSelect #x113)
(defconstant $kRTPRssmReleasePacketListSelect #x114)
(defconstant $kRTPRssmIncrChunkRefCountSelect #x115)
(defconstant $kRTPRssmDecrChunkRefCountSelect #x116)
(defconstant $kRTPRssmInitializeSelect #x500)
(defconstant $kRTPRssmHandleNewPacketSelect #x501)
(defconstant $kRTPRssmComputeChunkSizeSelect #x502)
(defconstant $kRTPRssmAdjustPacketParamsSelect #x503)
(defconstant $kRTPRssmCopyDataToChunkSelect #x504)
(defconstant $kRTPRssmSendPacketListSelect #x505)
(defconstant $kRTPRssmGetTimeScaleFromPacketSelect #x506)
(defconstant $kRTPRssmSetInfoSelect #x509)
(defconstant $kRTPRssmGetInfoSelect #x50A)
(defconstant $kRTPRssmHasCharacteristicSelect #x50B)
(defconstant $kRTPRssmResetSelect #x50C)

; 	-----------------------------------------
; 	    RTP Reassembler functions - base to derived
; 	-----------------------------------------	

; 
; 	 *  RTPRssmInitialize()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 *    Windows:          in QTSClient.lib 4.0 and later
; 	 	

(deftrap "_RTPRssmInitialize" 
      ((rtpr (:pointer :componentinstancerecord)) (inInitParams (:pointer :rtprssminitparams)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inInitParams ((+ (ash 4 16) 1280) :signed-longint)))

; 
;  *  RTPRssmHandleNewPacket()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmHandleNewPacket" 
      ((rtpr (:pointer :componentinstancerecord)) (inStreamBuffer (:pointer :qtsstreambuffer)) (inNumWraparounds :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inStreamBuffer inNumWraparounds ((+ (ash 8 16) 1281) :signed-longint)))

; 
;  *  RTPRssmComputeChunkSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmComputeChunkSize" 
      ((rtpr (:pointer :componentinstancerecord)) (inPacketListHead (:pointer :rtprssmpacket)) (inFlags :signed-long) (outChunkDataSize (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inPacketListHead inFlags outChunkDataSize ((+ (ash 12 16) 1282) :signed-longint)))

; 
;  *  RTPRssmAdjustPacketParams()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmAdjustPacketParams" 
      ((rtpr (:pointer :componentinstancerecord)) (inPacket (:pointer :rtprssmpacket)) (inFlags :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inPacket inFlags ((+ (ash 8 16) 1283) :signed-longint)))

; 
;  *  RTPRssmCopyDataToChunk()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmCopyDataToChunk" 
      ((rtpr (:pointer :componentinstancerecord)) (inPacketListHead (:pointer :rtprssmpacket)) (inMaxChunkDataSize :unsigned-long) (inChunk (:pointer :shchunkrecord)) (inFlags :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inPacketListHead inMaxChunkDataSize inChunk inFlags ((+ (ash 16 16) 1284) :signed-longint)))

; 
;  *  RTPRssmSendPacketList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  
; CONST
(deftrap "_RTPRssmSendPacketList" 
      ((rtpr (:pointer :componentinstancerecord)) (inPacketListHead (:pointer :rtprssmpacket)) (inLastChunkPresentationTime (:pointer :wide)) (inFlags :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inPacketListHead inLastChunkPresentationTime inFlags ((+ (ash 12 16) 1285) :signed-longint)))

; 
;  *  RTPRssmGetTimeScaleFromPacket()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmGetTimeScaleFromPacket" 
      ((rtpr (:pointer :componentinstancerecord)) (inStreamBuffer (:pointer :qtsstreambuffer)) (outTimeScale (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inStreamBuffer outTimeScale ((+ (ash 8 16) 1286) :signed-longint)))

; 
;  *  RTPRssmSetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmSetInfo" 
      ((rtpr (:pointer :componentinstancerecord)) (inSelector :ostype) (ioParams :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inSelector ioParams ((+ (ash 8 16) 1289) :signed-longint)))

; 
;  *  RTPRssmGetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmGetInfo" 
      ((rtpr (:pointer :componentinstancerecord)) (inSelector :ostype) (ioParams :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inSelector ioParams ((+ (ash 8 16) 1290) :signed-longint)))

; 
;  *  RTPRssmHasCharacteristic()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmHasCharacteristic" 
      ((rtpr (:pointer :componentinstancerecord)) (inCharacteristic :ostype) (outHasIt (:pointer :boolean)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inCharacteristic outHasIt ((+ (ash 8 16) 1291) :signed-longint)))

; 
;  *  RTPRssmReset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmReset" 
      ((rtpr (:pointer :componentinstancerecord)) (inFlags :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inFlags ((+ (ash 4 16) 1292) :signed-longint)))

; -----------------------------------------
;     RTP Reassembler functions - derived to base
; -----------------------------------------
;   ----- setup 
; 
;  *  RTPRssmSetCapabilities()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmSetCapabilities" 
      ((rtpr (:pointer :componentinstancerecord)) (inFlags :signed-long) (inFlagsMask :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inFlags inFlagsMask ((+ (ash 8 16) 256) :signed-longint)))

; 
;  *  RTPRssmGetCapabilities()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmGetCapabilities" 
      ((rtpr (:pointer :componentinstancerecord)) (outFlags (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr outFlags ((+ (ash 4 16) 257) :signed-longint)))

; 
;  *  RTPRssmSetPayloadHeaderLength()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmSetPayloadHeaderLength" 
      ((rtpr (:pointer :componentinstancerecord)) (inPayloadHeaderLength :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inPayloadHeaderLength ((+ (ash 4 16) 258) :signed-longint)))

; 
;  *  RTPRssmGetPayloadHeaderLength()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmGetPayloadHeaderLength" 
      ((rtpr (:pointer :componentinstancerecord)) (outPayloadHeaderLength (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr outPayloadHeaderLength ((+ (ash 4 16) 259) :signed-longint)))

; 
;  *  RTPRssmSetTimeScale()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmSetTimeScale" 
      ((rtpr (:pointer :componentinstancerecord)) (inSHTimeScale :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inSHTimeScale ((+ (ash 4 16) 260) :signed-longint)))

; 
;  *  RTPRssmGetTimeScale()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmGetTimeScale" 
      ((rtpr (:pointer :componentinstancerecord)) (outSHTimeScale (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr outSHTimeScale ((+ (ash 4 16) 261) :signed-longint)))

; 
;  *  RTPRssmNewStreamHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmNewStreamHandler" 
      ((rtpr (:pointer :componentinstancerecord)) (inSHType :ostype) (inSampleDescription (:handle :sampledescription)) (inSHTimeScale :signed-long) (outHandler (:pointer (:pointer :componentinstancerecord))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inSHType inSampleDescription inSHTimeScale outHandler ((+ (ash 16 16) 262) :signed-longint)))

; 
;  *  RTPRssmSetStreamHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmSetStreamHandler" 
      ((rtpr (:pointer :componentinstancerecord)) (inStreamHandler (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inStreamHandler ((+ (ash 4 16) 263) :signed-longint)))

; 
;  *  RTPRssmGetStreamHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmGetStreamHandler" 
      ((rtpr (:pointer :componentinstancerecord)) (outStreamHandler (:pointer (:pointer :componentinstancerecord))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr outStreamHandler ((+ (ash 4 16) 264) :signed-longint)))

; 
;  *  RTPRssmSendStreamHandlerChanged()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmSendStreamHandlerChanged" 
      ((rtpr (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr ((+ (ash 0 16) 265) :signed-longint)))

; 
;  *  RTPRssmSetSampleDescription()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmSetSampleDescription" 
      ((rtpr (:pointer :componentinstancerecord)) (inSampleDescription (:handle :sampledescription)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inSampleDescription ((+ (ash 4 16) 266) :signed-longint)))

;   ----- manually sending chunks 
; 
;  *  RTPRssmGetChunkAndIncrRefCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  
; CONST
(deftrap "_RTPRssmGetChunkAndIncrRefCount" 
      ((rtpr (:pointer :componentinstancerecord)) (inChunkDataSize :unsigned-long) (inChunkPresentationTime (:pointer :wide)) (outChunk (:pointer :pointer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inChunkDataSize inChunkPresentationTime outChunk ((+ (ash 12 16) 269) :signed-longint)))

; 
;  *  RTPRssmSendChunkAndDecrRefCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  
; CONST
(deftrap "_RTPRssmSendChunkAndDecrRefCount" 
      ((rtpr (:pointer :componentinstancerecord)) (inChunk (:pointer :shchunkrecord)) (inServerEdit (:pointer :shservereditparameters)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inChunk inServerEdit ((+ (ash 8 16) 270) :signed-longint)))

; 
;  *  RTPRssmSendLostChunk()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  
; CONST
(deftrap "_RTPRssmSendLostChunk" 
      ((rtpr (:pointer :componentinstancerecord)) (inChunkPresentationTime (:pointer :wide)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inChunkPresentationTime ((+ (ash 4 16) 271) :signed-longint)))

; 
;  *  RTPRssmSendStreamBufferRange()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmSendStreamBufferRange" 
      ((rtpr (:pointer :componentinstancerecord)) (inParams (:pointer :rtpsendstreambufferrangeparams)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inParams ((+ (ash 4 16) 272) :signed-longint)))

; 
;  *  RTPRssmClearCachedPackets()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmClearCachedPackets" 
      ((rtpr (:pointer :componentinstancerecord)) (inFlags :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inFlags ((+ (ash 4 16) 273) :signed-longint)))

; 
;  *  RTPRssmFillPacketListParams()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmFillPacketListParams" 
      ((rtpr (:pointer :componentinstancerecord)) (inPacketListHead (:pointer :rtprssmpacket)) (inNumWraparounds :signed-long) (inFlags :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inPacketListHead inNumWraparounds inFlags ((+ (ash 12 16) 275) :signed-longint)))

; 
;  *  RTPRssmReleasePacketList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmReleasePacketList" 
      ((rtpr (:pointer :componentinstancerecord)) (inPacketListHead (:pointer :rtprssmpacket)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inPacketListHead ((+ (ash 4 16) 276) :signed-longint)))

; 
;  *  RTPRssmIncrChunkRefCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmIncrChunkRefCount" 
      ((rtpr (:pointer :componentinstancerecord)) (inChunk (:pointer :shchunkrecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inChunk ((+ (ash 4 16) 277) :signed-longint)))

; 
;  *  RTPRssmDecrChunkRefCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPRssmDecrChunkRefCount" 
      ((rtpr (:pointer :componentinstancerecord)) (inChunk (:pointer :shchunkrecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpr inChunk ((+ (ash 4 16) 278) :signed-longint)))

; ============================================================================
;         RTP Media Packetizer
; ============================================================================

(defconstant $kRTPMediaPacketizerType :|rtpm|)

(def-mactype :rtpmediapacketizer (find-mactype '(:pointer :componentinstancerecord)))

(defconstant $kRTPBaseMediaPacketizerType :|gnrc|)
(defconstant $kRTP261MediaPacketizerType :|h261|)
(defconstant $kRTP263PlusMediaPacketizerType :|263+|)
(defconstant $kRTPAudioMediaPacketizerType :|soun|)
(defconstant $kRTPQTMediaPacketizerType :|qtim|)
(defconstant $kRTPPureVoiceMediaPacketizerType :|Qclp|)
(defconstant $kRTPMp3MediaPacketizerType :|mp3 |)
(defconstant $kRTPJPEGMediaPacketizerType :|jpeg|)
(defconstant $kRTPQDesign2MediaPacketizerType :|QDM2|)
(defconstant $kRTPSorensonMediaPacketizerType :|SVQ1|)

(def-mactype :rtpmpsampleref (find-mactype ':unsigned-long))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	RTPMPDataReleaseProcPtr = PROCEDURE(VAR inData: UInt8; inRefCon: UNIV Ptr);

|#
 |#                                             ; $ELSEC
(def-mactype :rtpmpdatareleaseprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :rtpmpdatareleaseupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :rtpmpdatareleaseupp (find-mactype ':pointer))
; $ENDC

(defconstant $kMediaPacketizerCanPackEditRate #x1)
(defconstant $kMediaPacketizerCanPackLayer #x2)
(defconstant $kMediaPacketizerCanPackVolume #x4)
(defconstant $kMediaPacketizerCanPackBalance #x8)
(defconstant $kMediaPacketizerCanPackGraphicsMode #x10)
(defconstant $kMediaPacketizerCanPackEmptyEdit #x20)

(def-mactype :mediapacketizerrequirementsptr (find-mactype '(:pointer :mediapacketizerrequirements)))
(defrecord MediaPacketizerRequirements 
   (mediaType :ostype)                          ;   media type supported (0 for all) 
   (dataFormat :ostype)                         ;   data format (e.g., compression) supported (0 for all) 
   (capabilityFlags :unsigned-long)             ;   ability to handle non-standard track characteristics 
   (canPackMatrixType :signed-byte)             ;   can pack any matrix type up to this (identityMatrixType for identity only) 
   (pad (:array :unsigned-byte 3 :packed))
   )

(def-mactype :mediapacketizerinfoptr (find-mactype '(:pointer :mediapacketizerinfo)))
(defrecord MediaPacketizerInfo 
   (mediaType :ostype)                          ;   media type supported (0 for all) 
   (dataFormat :ostype)                         ;   data format (e.g., compression) supported (0 for all) 
   (vendor :ostype)                             ;   manufacturer of this packetizer (e.g., 'appl' for Apple) 
   (capabilityFlags :unsigned-long)             ;   ability to handle non-standard track characteristics 
   (canPackMatrixType :signed-byte)             ;   can pack any matrix type up to this (identityMatrixType for identity only) 
   (pad (:array :unsigned-byte 3 :packed))
   (characteristicCount :signed-long)
   (characteristic (:array :rtppayloadcharacteristic 1))
;   after the last characteristic, the payload name (defined by the RTPPayloadInfo 
;   structure) is present.  
   )

(def-mactype :mediapacketizerinfohandle (find-mactype '(:handle :mediapacketizerinfo)))
; 	 MediaPacketizerInfo structs are padded to 32 bits 	

(defconstant $kMediaPacketizerInfoPadUpToBytes 4)

; 
; 	 *  QTSFindMediaPacketizer()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 *    Windows:          in QTSClient.lib 4.0 and later
; 	 	

(deftrap-inline "_QTSFindMediaPacketizer" 
      ((inPacketizerinfo (:pointer :mediapacketizerrequirements)) (inSampleDescription (:handle :sampledescription)) (inSortInfo (:pointer :rtppayloadsortrequest)) (outPacketizerList (:pointer :handle))) 
  :signed-integer
   () )

; 
;  *  QTSFindMediaPacketizerForTrack()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSFindMediaPacketizerForTrack" 
      ((inTrack (:pointer :trackrecord)) (inSampleDescriptionIndex :signed-long) (inSortInfo (:pointer :rtppayloadsortrequest)) (outPacketizerList (:pointer :handle))) 
  :signed-integer
   () )

; 
;  *  QTSFindMediaPacketizerForPayloadID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSFindMediaPacketizerForPayloadID" 
      ((payloadID :signed-long) (inSortInfo (:pointer :rtppayloadsortrequest)) (outPacketizerList (:pointer :handle))) 
  :signed-integer
   () )

; 
;  *  QTSFindMediaPacketizerForPayloadName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSFindMediaPacketizerForPayloadName" 
      ((payloadName :pointer) (inSortInfo (:pointer :rtppayloadsortrequest)) (outPacketizerList (:pointer :handle))) 
  :signed-integer
   () )

;   flags for RTPMPInitialize 

(defconstant $kRTPMPRealtimeModeFlag #x1)

;   flags for RTPMPSampleDataParams 
(defconstant $kRTPMPSyncSampleFlag #x1)
(defconstant $kRTPMPRespectDurationFlag #x2)

(def-mactype :rtpmpsampledataparamsptr (find-mactype '(:pointer :rtpmpsampledataparams)))
(defrecord RTPMPSampleDataParams 
   (version :unsigned-long)
   (timeStamp :unsigned-long)
   (duration :unsigned-long)                    ;   0 = unknown duration 
   (playOffset :unsigned-long)
   (playRate :signed-long)
   (flags :signed-long)
   (sampleDescSeed :unsigned-long)
   (sampleDescription :handle)
   (sampleRef :unsigned-long)
   (dataLength :unsigned-long)
   (data :pointer)
   (releaseProc :pointer)
   (refCon :pointer)
   )

;   out flags for idle, RTPMPSetSampleData, and RTPMPFlush 

(defconstant $kRTPMPStillProcessingData #x1)    ;   not done with data you've got 

(def-mactype :rtpmppayloadtypeparamsptr (find-mactype '(:pointer :rtpmppayloadtypeparams)))
(defrecord RTPMPPayloadTypeParams 
   (flags :unsigned-long)
   (payloadNumber :unsigned-long)
   (nameLength :signed-integer)                 ;   in: size of payloadName buffer (counting null terminator) -- this will be reset to needed length and paramErr returned if too small  
   (payloadName :pointer)                       ;   caller must provide buffer  
   )

; 	-----------------------------------------
; 	    RTP Media Packetizer Info selectors
; 	-----------------------------------------	
; 	 info selectors - get only 	

(defconstant $kRTPMPPayloadTypeInfo :|rtpp|)    ;   RTPMPPayloadTypeParams*  
(defconstant $kRTPMPRTPTimeScaleInfo :|rtpt|)   ;   TimeScale*  
(defconstant $kRTPMPRequiredSampleDescriptionInfo :|sdsc|);   SampleDescriptionHandle*  
(defconstant $kRTPMPMinPayloadSize :|mins|)     ;   UInt32* in bytes, does not include rtp header; default is 0  
(defconstant $kRTPMPMinPacketDuration :|mind|)  ;   UInt3* in milliseconds; default is no min required  
(defconstant $kRTPMPSuggestedRepeatPktCountInfo :|srpc|);   UInt32*  
(defconstant $kRTPMPSuggestedRepeatPktSpacingInfo :|srps|);   UInt32* in milliseconds  
(defconstant $kRTPMPMaxPartialSampleSizeInfo :|mpss|);   UInt32* in bytes  
(defconstant $kRTPMPPreferredBufferDelayInfo :|prbd|);   UInt32* in milliseconds  
(defconstant $kRTPMPPayloadNameInfo :|name|)    ;   StringPtr  

; 	-----------------------------------------
; 	    RTP Media Packetizer Characteristics
; 	-----------------------------------------	
; 	 also supports relevant ones in Movies.h and QTSToolbox.h 	
(defconstant $kRTPMPNoSampleDataRequiredCharacteristic :|nsdr|)
(defconstant $kRTPMPHasUserSettingsDialogCharacteristic :|sdlg|)
(defconstant $kRTPMPPrefersReliableTransportCharacteristic :|rely|)
(defconstant $kRTPMPRequiresOutOfBandDimensionsCharacteristic :|robd|)
(defconstant $kRTPMPReadsPartialSamplesCharacteristic :|rpsp|)

; 	-----------------------------------------
; 	    RTP Media Packetizer selectors
; 	-----------------------------------------	
(defconstant $kRTPMPInitializeSelect #x500)
(defconstant $kRTPMPPreflightMediaSelect #x501)
(defconstant $kRTPMPIdleSelect #x502)
(defconstant $kRTPMPSetSampleDataSelect #x503)
(defconstant $kRTPMPFlushSelect #x504)
(defconstant $kRTPMPResetSelect #x505)
(defconstant $kRTPMPSetInfoSelect #x506)
(defconstant $kRTPMPGetInfoSelect #x507)
(defconstant $kRTPMPSetTimeScaleSelect #x508)
(defconstant $kRTPMPGetTimeScaleSelect #x509)
(defconstant $kRTPMPSetTimeBaseSelect #x50A)
(defconstant $kRTPMPGetTimeBaseSelect #x50B)
(defconstant $kRTPMPHasCharacteristicSelect #x50C)
(defconstant $kRTPMPSetPacketBuilderSelect #x50E)
(defconstant $kRTPMPGetPacketBuilderSelect #x50F)
(defconstant $kRTPMPSetMediaTypeSelect #x510)
(defconstant $kRTPMPGetMediaTypeSelect #x511)
(defconstant $kRTPMPSetMaxPacketSizeSelect #x512)
(defconstant $kRTPMPGetMaxPacketSizeSelect #x513)
(defconstant $kRTPMPSetMaxPacketDurationSelect #x514)
(defconstant $kRTPMPGetMaxPacketDurationSelect #x515);   for export component and apps who want to 
;   access dialogs for Media-specific settings 
;   (such as Pure Voice interleave factor) 
(defconstant $kRTPMPDoUserDialogSelect #x516)
(defconstant $kRTPMPSetSettingsFromAtomContainerAtAtomSelect #x517)
(defconstant $kRTPMPGetSettingsIntoAtomContainerAtAtomSelect #x518)
(defconstant $kRTPMPGetSettingsAsTextSelect #x519)
(defconstant $kRTPMPGetSettingsSelect #x51A)
(defconstant $kRTPMPSetSettingsSelect #x51B)

; 	-----------------------------------------
; 	    RTP Media Packetizer functions
; 	-----------------------------------------	

; 
; 	 *  RTPMPInitialize()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 *    Windows:          in QTSClient.lib 4.0 and later
; 	 	

(deftrap "_RTPMPInitialize" 
      ((rtpm (:pointer :componentinstancerecord)) (inFlags :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm inFlags ((+ (ash 4 16) 1280) :signed-longint)))

;  return noErr if you can handle this media 
; 
;  *  RTPMPPreflightMedia()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPMPPreflightMedia" 
      ((rtpm (:pointer :componentinstancerecord)) (inMediaType :ostype) (inSampleDescription (:handle :sampledescription)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm inMediaType inSampleDescription ((+ (ash 8 16) 1281) :signed-longint)))

; 
;    do work here if you need to - give up time periodically
;    if you're doing time consuming operations
; 
; 
;  *  RTPMPIdle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPMPIdle" 
      ((rtpm (:pointer :componentinstancerecord)) (inFlags :signed-long) (outFlags (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm inFlags outFlags ((+ (ash 8 16) 1282) :signed-longint)))

; 
;    caller owns the RTPMPSampleDataParams struct
;    media Packetizer must copy any fields of the struct it wants to keep
;    media Packetizer must call release proc when done with the data
;    you can do the processing work here if it does not take up too
;    much cpu time - otherwise do it in idle
; 
; 
;  *  RTPMPSetSampleData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  
; CONST
(deftrap "_RTPMPSetSampleData" 
      ((rtpm (:pointer :componentinstancerecord)) (inSampleData (:pointer :rtpmpsampledataparams)) (outFlags (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm inSampleData outFlags ((+ (ash 8 16) 1283) :signed-longint)))

; 
;    send everything you have buffered - you will get idles while
;    you set the kRTPMPStillProcessingData flag here and in idle
; 
; 
;  *  RTPMPFlush()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPMPFlush" 
      ((rtpm (:pointer :componentinstancerecord)) (inFlags :signed-long) (outFlags (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm inFlags outFlags ((+ (ash 8 16) 1284) :signed-longint)))

; 
;    dispose of anything buffered and get rid of state
;    do not send the buffered data (because presumably
;    there is no connection for you to send on)
;    state should be the same as if you were just initialized
; 
; 
;  *  RTPMPReset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPMPReset" 
      ((rtpm (:pointer :componentinstancerecord)) (inFlags :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm inFlags ((+ (ash 4 16) 1285) :signed-longint)))

; -----------------------------------------
;     RTP Media Packetizer get / set functions
; -----------------------------------------
; 
;  *  RTPMPSetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPMPSetInfo" 
      ((rtpm (:pointer :componentinstancerecord)) (inSelector :ostype) (ioParams :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm inSelector ioParams ((+ (ash 8 16) 1286) :signed-longint)))

; 
;  *  RTPMPGetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPMPGetInfo" 
      ((rtpm (:pointer :componentinstancerecord)) (inSelector :ostype) (ioParams :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm inSelector ioParams ((+ (ash 8 16) 1287) :signed-longint)))

; 
;  *  RTPMPSetTimeScale()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPMPSetTimeScale" 
      ((rtpm (:pointer :componentinstancerecord)) (inTimeScale :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm inTimeScale ((+ (ash 4 16) 1288) :signed-longint)))

; 
;  *  RTPMPGetTimeScale()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPMPGetTimeScale" 
      ((rtpm (:pointer :componentinstancerecord)) (outTimeScale (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm outTimeScale ((+ (ash 4 16) 1289) :signed-longint)))

; 
;  *  RTPMPSetTimeBase()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPMPSetTimeBase" 
      ((rtpm (:pointer :componentinstancerecord)) (inTimeBase :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm inTimeBase ((+ (ash 4 16) 1290) :signed-longint)))

; 
;  *  RTPMPGetTimeBase()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPMPGetTimeBase" 
      ((rtpm (:pointer :componentinstancerecord)) (outTimeBase (:pointer :pointer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm outTimeBase ((+ (ash 4 16) 1291) :signed-longint)))

; 
;  *  RTPMPHasCharacteristic()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPMPHasCharacteristic" 
      ((rtpm (:pointer :componentinstancerecord)) (inSelector :ostype) (outHasIt (:pointer :boolean)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm inSelector outHasIt ((+ (ash 8 16) 1292) :signed-longint)))

; 
;  *  RTPMPSetPacketBuilder()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPMPSetPacketBuilder" 
      ((rtpm (:pointer :componentinstancerecord)) (inPacketBuilder (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm inPacketBuilder ((+ (ash 4 16) 1294) :signed-longint)))

; 
;  *  RTPMPGetPacketBuilder()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPMPGetPacketBuilder" 
      ((rtpm (:pointer :componentinstancerecord)) (outPacketBuilder (:pointer (:pointer :componentinstancerecord))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm outPacketBuilder ((+ (ash 4 16) 1295) :signed-longint)))

; 
;  *  RTPMPSetMediaType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPMPSetMediaType" 
      ((rtpm (:pointer :componentinstancerecord)) (inMediaType :ostype))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm inMediaType ((+ (ash 4 16) 1296) :signed-longint)))

; 
;  *  RTPMPGetMediaType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPMPGetMediaType" 
      ((rtpm (:pointer :componentinstancerecord)) (outMediaType (:pointer :ostype)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm outMediaType ((+ (ash 4 16) 1297) :signed-longint)))

;   size is in bytes 
; 
;  *  RTPMPSetMaxPacketSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPMPSetMaxPacketSize" 
      ((rtpm (:pointer :componentinstancerecord)) (inMaxPacketSize :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm inMaxPacketSize ((+ (ash 4 16) 1298) :signed-longint)))

; 
;  *  RTPMPGetMaxPacketSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPMPGetMaxPacketSize" 
      ((rtpm (:pointer :componentinstancerecord)) (outMaxPacketSize (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm outMaxPacketSize ((+ (ash 4 16) 1299) :signed-longint)))

;   duration is in milliseconds 
; 
;  *  RTPMPSetMaxPacketDuration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPMPSetMaxPacketDuration" 
      ((rtpm (:pointer :componentinstancerecord)) (inMaxPacketDuration :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm inMaxPacketDuration ((+ (ash 4 16) 1300) :signed-longint)))

; 
;  *  RTPMPGetMaxPacketDuration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPMPGetMaxPacketDuration" 
      ((rtpm (:pointer :componentinstancerecord)) (outMaxPacketDuration (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm outMaxPacketDuration ((+ (ash 4 16) 1301) :signed-longint)))

; 
;  *  RTPMPDoUserDialog()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPMPDoUserDialog" 
      ((rtpm (:pointer :componentinstancerecord)) (inFilterUPP :pointer) (canceled (:pointer :boolean)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm inFilterUPP canceled ((+ (ash 8 16) 1302) :signed-longint)))

; 
;  *  RTPMPSetSettingsFromAtomContainerAtAtom()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPMPSetSettingsFromAtomContainerAtAtom" 
      ((rtpm (:pointer :componentinstancerecord)) (inContainer :handle) (inParentAtom :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm inContainer inParentAtom ((+ (ash 8 16) 1303) :signed-longint)))

; 
;  *  RTPMPGetSettingsIntoAtomContainerAtAtom()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPMPGetSettingsIntoAtomContainerAtAtom" 
      ((rtpm (:pointer :componentinstancerecord)) (inOutContainer :handle) (inParentAtom :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm inOutContainer inParentAtom ((+ (ash 8 16) 1304) :signed-longint)))

; 
;  *  RTPMPGetSettingsAsText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPMPGetSettingsAsText" 
      ((rtpm (:pointer :componentinstancerecord)) (text (:pointer :handle)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm text ((+ (ash 4 16) 1305) :signed-longint)))

; 
;  *  RTPMPGetSettings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 5.0 and later
;  

(deftrap "_RTPMPGetSettings" 
      ((rtpm (:pointer :componentinstancerecord)) (outSettings (:pointer :handle)) (inFlags :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm outSettings inFlags ((+ (ash 8 16) 1306) :signed-longint)))

; 
;  *  RTPMPSetSettings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 5.0 and later
;  

(deftrap "_RTPMPSetSettings" 
      ((rtpm (:pointer :componentinstancerecord)) (inSettings (:pointer :qtatomspec)) (inFlags :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpm inSettings inFlags ((+ (ash 8 16) 1307) :signed-longint)))

; ============================================================================
;         RTP Packet Builder
; ============================================================================

(defconstant $kRTPPacketBuilderType :|rtpb|)

(def-mactype :rtppacketbuilder (find-mactype '(:pointer :componentinstancerecord)))
(def-mactype :rtppacketgroupref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :rtppacketgrouprefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:RTPPacketGroupRef parameter can be nil, it is changed to xx: RTPPacketGroupRefPtr 
(def-mactype :rtppacketref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :rtppacketrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:RTPPacketRef parameter can be nil, it is changed to xx: RTPPacketRefPtr 
(def-mactype :rtppacketrepeateddataref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :rtppacketrepeateddatarefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:RTPPacketRepeatedDataRef parameter can be nil, it is changed to xx: RTPPacketRepeatedDataRefPtr 
;   flags for RTPPBBegin/EndPacket, RTPPBBegin/EndPacketGroup 

(defconstant $kRTPPBSetMarkerFlag #x1)
(defconstant $kRTPPBRepeatPacketFlag #x2)
(defconstant $kRTPPBSyncSampleFlag #x10000)
(defconstant $kRTPPBBFrameFlag #x20000)
(defconstant $kRTPPBDontSendFlag #x10000000)    ;   when set in EndPacketGroup, will not add group 

(defconstant $kRTPPBUnknownPacketMediaDataLength 0)

;   flags for RTPPBGetSampleData 
(defconstant $kRTPPBEndOfDataFlag #x1)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	RTPPBCallbackProcPtr = PROCEDURE(inSelector: OSType; ioParams: UNIV Ptr; inRefCon: UNIV Ptr);

|#
 |#                                             ; $ELSEC
(def-mactype :rtppbcallbackprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :rtppbcallbackupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :rtppbcallbackupp (find-mactype ':pointer))
; $ENDC
; 	-----------------------------------------
; 	    RTP Packet Builder selectors
; 	-----------------------------------------	

(defconstant $kRTPPBBeginPacketGroupSelect #x500)
(defconstant $kRTPPBEndPacketGroupSelect #x501)
(defconstant $kRTPPBBeginPacketSelect #x502)
(defconstant $kRTPPBEndPacketSelect #x503)
(defconstant $kRTPPBAddPacketLiteralDataSelect #x504)
(defconstant $kRTPPBAddPacketSampleDataSelect #x505)
(defconstant $kRTPPBAddPacketRepeatedDataSelect #x506)
(defconstant $kRTPPBReleaseRepeatedDataSelect #x507)
(defconstant $kRTPPBSetPacketSequenceNumberSelect #x508)
(defconstant $kRTPPBGetPacketSequenceNumberSelect #x509)
(defconstant $kRTPPBSetCallbackSelect #x50A)
(defconstant $kRTPPBGetCallbackSelect #x50B)
(defconstant $kRTPPBSetInfoSelect #x50C)
(defconstant $kRTPPBGetInfoSelect #x50D)
(defconstant $kRTPPBSetPacketTimeStampOffsetSelect #x50E)
(defconstant $kRTPPBGetPacketTimeStampOffsetSelect #x50F)
(defconstant $kRTPPBAddPacketSampleData64Select #x510)
(defconstant $kRTPPBGetSampleDataSelect #x511)
(defconstant $kRTPPBAddRepeatPacketSelect #x512)

; 	-----------------------------------------
; 	    RTP Packet Builder functions
; 	-----------------------------------------	
; 
; 	 *  RTPPBBeginPacketGroup()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 *    Windows:          in QTSClient.lib 4.0 and later
; 	 	

(deftrap "_RTPPBBeginPacketGroup" 
      ((rtpb (:pointer :componentinstancerecord)) (inFlags :signed-long) (inTimeStamp :unsigned-long) (outPacketGroup (:pointer :pointer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpb inFlags inTimeStamp outPacketGroup ((+ (ash 12 16) 1280) :signed-longint)))

; 
;  *  RTPPBEndPacketGroup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPPBEndPacketGroup" 
      ((rtpb (:pointer :componentinstancerecord)) (inFlags :signed-long) (inPacketGroup :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpb inFlags inPacketGroup ((+ (ash 8 16) 1281) :signed-longint)))

; 
;  *  RTPPBBeginPacket()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPPBBeginPacket" 
      ((rtpb (:pointer :componentinstancerecord)) (inFlags :signed-long) (inPacketGroup :pointer) (inPacketMediaDataLength :unsigned-long) (outPacket (:pointer :pointer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpb inFlags inPacketGroup inPacketMediaDataLength outPacket ((+ (ash 16 16) 1282) :signed-longint)))

; 
;  *  RTPPBEndPacket()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPPBEndPacket" 
      ((rtpb (:pointer :componentinstancerecord)) (inFlags :signed-long) (inPacketGroup :pointer) (inPacket :pointer) (inTransmissionTimeOffset :unsigned-long) (inDuration :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpb inFlags inPacketGroup inPacket inTransmissionTimeOffset inDuration ((+ (ash 20 16) 1283) :signed-longint)))

; 
;    non-NULL RTPPacketRepeatedDataRef means this data will be repeated later
;    pb must return a repeated data ref
; 
; 
;  *  RTPPBAddPacketLiteralData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPPBAddPacketLiteralData" 
      ((rtpb (:pointer :componentinstancerecord)) (inFlags :signed-long) (inPacketGroup :pointer) (inPacket :pointer) (inData (:pointer :unsigned-byte)) (inDataLength :unsigned-long) (outDataRef (:pointer :pointer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpb inFlags inPacketGroup inPacket inData inDataLength outDataRef ((+ (ash 24 16) 1284) :signed-longint)))

; 
;    non-NULL RTPPacketRepeatedDataRef means this data will be repeated later
;    pb must return a repeated data ref
; 
; 
;  *  RTPPBAddPacketSampleData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPPBAddPacketSampleData" 
      ((rtpb (:pointer :componentinstancerecord)) (inFlags :signed-long) (inPacketGroup :pointer) (inPacket :pointer) (inSampleDataParams (:pointer :rtpmpsampledataparams)) (inSampleOffset :unsigned-long) (inSampleDataLength :unsigned-long) (outDataRef (:pointer :pointer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpb inFlags inPacketGroup inPacket inSampleDataParams inSampleOffset inSampleDataLength outDataRef ((+ (ash 28 16) 1285) :signed-longint)))

; 
;    non-NULL RTPPacketRepeatedDataRef means this data will be repeated later
;    pb must return a repeated data ref
; 
; 
;  *  RTPPBAddPacketSampleData64()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 5.0 and later
;  
; CONST
(deftrap "_RTPPBAddPacketSampleData64" 
      ((rtpb (:pointer :componentinstancerecord)) (inFlags :signed-long) (inPacketGroup :pointer) (inPacket :pointer) (inSampleDataParams (:pointer :rtpmpsampledataparams)) (inSampleOffset (:pointer :unsignedwide)) (inSampleDataLength :unsigned-long) (outDataRef (:pointer :pointer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpb inFlags inPacketGroup inPacket inSampleDataParams inSampleOffset inSampleDataLength outDataRef ((+ (ash 28 16) 1296) :signed-longint)))

; 
;    call to add the repeated data using the ref you got from
;    RTPPBAddPacketLiteralData or RTPPBAddPacketSampleData
; 
; 
;  *  RTPPBAddPacketRepeatedData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPPBAddPacketRepeatedData" 
      ((rtpb (:pointer :componentinstancerecord)) (inFlags :signed-long) (inPacketGroup :pointer) (inPacket :pointer) (inDataRef :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpb inFlags inPacketGroup inPacket inDataRef ((+ (ash 16 16) 1286) :signed-longint)))

;   call when done with repeated data 
; 
;  *  RTPPBReleaseRepeatedData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPPBReleaseRepeatedData" 
      ((rtpb (:pointer :componentinstancerecord)) (inDataRef :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpb inDataRef ((+ (ash 4 16) 1287) :signed-longint)))

; 
;    seq number is just relative seq number
;    don't call if you don't care when seq # is used
; 
; 
;  *  RTPPBSetPacketSequenceNumber()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPPBSetPacketSequenceNumber" 
      ((rtpb (:pointer :componentinstancerecord)) (inFlags :signed-long) (inPacketGroup :pointer) (inPacket :pointer) (inSequenceNumber :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpb inFlags inPacketGroup inPacket inSequenceNumber ((+ (ash 16 16) 1288) :signed-longint)))

; 
;  *  RTPPBGetPacketSequenceNumber()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPPBGetPacketSequenceNumber" 
      ((rtpb (:pointer :componentinstancerecord)) (inFlags :signed-long) (inPacketGroup :pointer) (inPacket :pointer) (outSequenceNumber (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpb inFlags inPacketGroup inPacket outSequenceNumber ((+ (ash 16 16) 1289) :signed-longint)))

; 
;  *  RTPPBSetPacketTimeStampOffset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 5.0 and later
;  

(deftrap "_RTPPBSetPacketTimeStampOffset" 
      ((rtpb (:pointer :componentinstancerecord)) (inFlags :signed-long) (inPacketGroup :pointer) (inPacket :pointer) (inTimeStampOffset :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpb inFlags inPacketGroup inPacket inTimeStampOffset ((+ (ash 16 16) 1294) :signed-longint)))

; 
;  *  RTPPBGetPacketTimeStampOffset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 5.0 and later
;  

(deftrap "_RTPPBGetPacketTimeStampOffset" 
      ((rtpb (:pointer :componentinstancerecord)) (inFlags :signed-long) (inPacketGroup :pointer) (inPacket :pointer) (outTimeStampOffset (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpb inFlags inPacketGroup inPacket outTimeStampOffset ((+ (ash 16 16) 1295) :signed-longint)))

; 
;  *  RTPPBAddRepeatPacket()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 5.0 and later
;  

(deftrap "_RTPPBAddRepeatPacket" 
      ((rtpb (:pointer :componentinstancerecord)) (inFlags :signed-long) (inPacketGroup :pointer) (inPacket :pointer) (inTransmissionOffset :signed-long) (inSequenceNumber :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpb inFlags inPacketGroup inPacket inTransmissionOffset inSequenceNumber ((+ (ash 20 16) 1298) :signed-longint)))

; 
;    used for communicating with the caller of the media packetizers if needed
;    NOT used for communicating with the media packetizers themselves
; 
; 
;  *  RTPPBSetCallback()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPPBSetCallback" 
      ((rtpb (:pointer :componentinstancerecord)) (inCallback :pointer) (inRefCon :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpb inCallback inRefCon ((+ (ash 8 16) 1290) :signed-longint)))

; 
;  *  RTPPBGetCallback()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPPBGetCallback" 
      ((rtpb (:pointer :componentinstancerecord)) (outCallback (:pointer :pointer)) (outRefCon (:pointer :pointer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpb outCallback outRefCon ((+ (ash 8 16) 1291) :signed-longint)))

; 
;  *  RTPPBSetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPPBSetInfo" 
      ((rtpb (:pointer :componentinstancerecord)) (inSelector :ostype) (ioParams :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpb inSelector ioParams ((+ (ash 8 16) 1292) :signed-longint)))

; 
;  *  RTPPBGetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap "_RTPPBGetInfo" 
      ((rtpb (:pointer :componentinstancerecord)) (inSelector :ostype) (ioParams :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpb inSelector ioParams ((+ (ash 8 16) 1293) :signed-longint)))

; 
;  *  RTPPBGetSampleData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 5.0 and later
;  
; CONST
(deftrap "_RTPPBGetSampleData" 
      ((rtpb (:pointer :componentinstancerecord)) (inParams (:pointer :rtpmpsampledataparams)) (inStartOffset (:pointer :unsignedwide)) (outDataBuffer (:pointer :unsigned-byte)) (inBytesToRead :unsigned-long) (outBytesRead (:pointer :unsigned-long)) (outFlags (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 rtpb inParams inStartOffset outDataBuffer inBytesToRead outBytesRead outFlags ((+ (ash 24 16) 1297) :signed-longint)))

;  UPP call backs 

(defconstant $uppRTPMPDataReleaseProcInfo #x3C0)
(defconstant $uppRTPPBCallbackProcInfo #xFC0)
; 
; 	 *  NewRTPMPDataReleaseUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.3 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewRTPMPDataReleaseProc 
(deftrap "_NewRTPMPDataReleaseUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewRTPPBCallbackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewRTPPBCallbackProc 
(deftrap "_NewRTPPBCallbackUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeRTPMPDataReleaseUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeRTPMPDataReleaseUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeRTPPBCallbackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeRTPPBCallbackUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeRTPMPDataReleaseUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallRTPMPDataReleaseProc 
(deftrap-inline "_InvokeRTPMPDataReleaseUPP" 
      ((inData (:pointer :unsigned-byte)) (inRefCon :pointer) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeRTPPBCallbackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallRTPPBCallbackProc 
(deftrap-inline "_InvokeRTPPBCallbackUPP" 
      ((inSelector :ostype) (ioParams :pointer) (inRefCon :pointer) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QTStreamingComponentsIncludes

; $ENDC                                         ; __QTSTREAMINGCOMPONENTS__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'QTStreamingComponents)