(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QuickTimeStreaming.p"
; at Wednesday May 1,2002 2:42:43 pm.
; 
;      File:       QuickTimeStreaming.p
;  
;      Contains:   QuickTime Interfaces.
;  
;      Version:    Technology: QuickTime 5.0.1
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1990-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __QUICKTIMESTREAMING__
; $SETC __QUICKTIMESTREAMING__ := 1

; $I+
; $SETC QuickTimeStreamingIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __COMPONENTS__
|#

(require-interface 'Components)
#|                                              ; $I Components.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MOVIES__
|#

(require-interface 'Movies)
#|                                              ; $I Movies.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKTIMECOMPONENTS__
|#

(require-interface 'QuickTimeComponents)
#|                                              ; $I QuickTimeComponents.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $kQTSInfiniteDuration #x7FFFFFFF)
(defconstant $kQTSUnknownDuration #x0)
(defconstant $kQTSNormalForwardRate #x10000)
(defconstant $kQTSStoppedRate #x0)

(def-mactype :qtspresentationrecordptr (find-mactype '(:pointer :qtspresentationrecord)))
(defrecord QTSPresentationRecord 
   (data (:array :signed-long 1))
   )

(def-mactype :qtspresentation (find-mactype '(:pointer :qtspresentationrecord)))
(def-mactype :qtsstreamrecordptr (find-mactype '(:pointer :qtsstreamrecord)))
(defrecord QTSStreamRecord 
   (data (:array :signed-long 1))
   )

(def-mactype :qtsstream (find-mactype '(:pointer :qtsstreamrecord)))
(def-mactype :qtseditentryptr (find-mactype '(:pointer :qtseditentry)))
(defrecord QTSEditEntry 
   (presentationDuration :wide)
   (streamStartTime :wide)
   (streamRate :signed-long)
   )

(def-mactype :qtseditlistptr (find-mactype '(:pointer :qtseditlist)))
(defrecord QTSEditList 
   (numEdits :signed-long)
   (edits (:array :qtseditentry 1))
   )

(def-mactype :qtseditlisthandle (find-mactype '(:handle :qtseditlist)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	QTSNotificationProcPtr = FUNCTION(inErr: ComponentResult; inNotificationType: OSType; inNotificationParams: UNIV Ptr; inRefCon: UNIV Ptr): ComponentResult;

|#
 |#                                             ; $ELSEC
(def-mactype :qtsnotificationprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :qtsnotificationupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :qtsnotificationupp (find-mactype ':pointer))
; $ENDC
; 	-----------------------------------------
; 	    Get / Set Info
; 	-----------------------------------------	

(defconstant $kQTSGetURLLink :|gull|)           ;   QTSGetURLLinkRecord*  

; 	 get and set 	
(defconstant $kQTSTargetBufferDurationInfo :|bufr|);   Fixed* in seconds; expected, not actual  
(defconstant $kQTSDurationInfo :|dura|)         ;   QTSDurationAtom*  
(defconstant $kQTSSoundLevelMeteringEnabledInfo :|mtrn|);   Boolean*  
(defconstant $kQTSSoundLevelMeterInfo :|levm|)  ;   LevelMeterInfoPtr  
(defconstant $kQTSSourceTrackIDInfo :|otid|)    ;   UInt32*  
(defconstant $kQTSSourceLayerInfo :|olyr|)      ;   UInt16*  
(defconstant $kQTSSourceLanguageInfo :|olng|)   ;   UInt16*  
(defconstant $kQTSSourceTrackFlagsInfo :|otfl|) ;   SInt32*  
(defconstant $kQTSSourceDimensionsInfo :|odim|) ;   QTSDimensionParams*  
(defconstant $kQTSSourceVolumesInfo :|ovol|)    ;   QTSVolumesParams*  
(defconstant $kQTSSourceMatrixInfo :|omat|)     ;   MatrixRecord*  
(defconstant $kQTSSourceClipRectInfo :|oclp|)   ;   Rect*  
(defconstant $kQTSSourceGraphicsModeInfo :|ogrm|);   QTSGraphicsModeParams*  
(defconstant $kQTSSourceScaleInfo :|oscl|)      ;   Point*  
(defconstant $kQTSSourceBoundingRectInfo :|orct|);   Rect*  
(defconstant $kQTSSourceUserDataInfo :|oudt|)   ;   UserData  
(defconstant $kQTSSourceInputMapInfo :|oimp|)   ;   QTAtomContainer  
(defconstant $kQTSInfo_DataProc :|datp|)        ;   QTSDataProcParams*  
(defconstant $kQTSInfo_SendDataExtras :|dext|)  ;   QTSSendDataExtrasParams*  
(defconstant $kQTSInfo_HintTrackID :|htid|)     ;   long*  

; 	 get only 	
(defconstant $kQTSStatisticsInfo :|stat|)       ;   QTSStatisticsParams*  
(defconstant $kQTSMinStatusDimensionsInfo :|mstd|);   QTSDimensionParams*  
(defconstant $kQTSNormalStatusDimensionsInfo :|nstd|);   QTSDimensionParams*  
(defconstant $kQTSTotalDataRateInfo :|drtt|)    ;   UInt32*, add to what's there  
(defconstant $kQTSTotalDataRateInInfo :|drti|)  ;   UInt32*, add to what's there  
(defconstant $kQTSTotalDataRateOutInfo :|drto|) ;   UInt32*, add to what's there  
(defconstant $kQTSLostPercentInfo :|lpct|)      ;   QTSLostPercentParams*, add to what's there  
(defconstant $kQTSNumViewersInfo :|nviw|)       ;   UInt32*  
(defconstant $kQTSMediaTypeInfo :|mtyp|)        ;   OSType*  
(defconstant $kQTSNameInfo :|name|)             ;   QTSNameParams*  
(defconstant $kQTSCanHandleSendDataType :|chsd|);   QTSCanHandleSendDataTypeParams*  
(defconstant $kQTSAnnotationsInfo :|meta|)      ;   QTAtomContainer  
(defconstant $kQTSRemainingBufferTimeInfo :|btms|);   UInt32* remaining buffer time before playback, in microseconds  
(defconstant $kQTSInfo_SettingsText :|sttx|)    ;   QTSSettingsTextParams*  

(defconstant $kQTSTargetBufferDurationTimeScale 1000)

(def-mactype :qtspanelfilterparamsptr (find-mactype '(:pointer :qtspanelfilterparams)))
(defrecord QTSPanelFilterParams 
   (version :signed-long)
   (inStream (:pointer :qtsstreamrecord))
   (inPanelType :ostype)
   (inPanelSubType :ostype)
   (details :qtatomspec)
   )

;   return true to keep this panel 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	QTSPanelFilterProcPtr = FUNCTION(VAR inParams: QTSPanelFilterParams; inRefCon: UNIV Ptr): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :qtspanelfilterprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :qtspanelfilterupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :qtspanelfilterupp (find-mactype ':pointer))
; $ENDC

(defconstant $kQTSSettingsTextSummary :|set1|)
(defconstant $kQTSSettingsTextDetails :|setd|)

(def-mactype :qtssettingstextparamsptr (find-mactype '(:pointer :qtssettingstextparams)))
(defrecord QTSSettingsTextParams 
   (flags :signed-long)                         ;   None yet defined 
   (inSettingsSelector :ostype)                 ;   which kind of setting you want from enum above 
   (outSettingsAsText :handle)                  ;   QTS allocates; Caller disposes 
   (inPanelFilterProc :pointer)                 ;   To get a subset filter with this    
   (inPanelFilterProcRefCon :pointer)
   )

(def-mactype :qtscanhandlesenddatatypeparamsptr (find-mactype '(:pointer :qtscanhandlesenddatatypeparams)))
(defrecord QTSCanHandleSendDataTypeParams 
   (modifierTypeOrInputID :signed-long)
   (isModifierType :boolean)
   (returnedCanHandleSendDataType :boolean)     ;   callee sets to true if it can handle it 
   )

(def-mactype :qtsnameparamsptr (find-mactype '(:pointer :qtsnameparams)))
(defrecord QTSNameParams 
   (maxNameLength :signed-long)
   (requestedLanguage :signed-long)
   (returnedActualLanguage :signed-long)
   (returnedName :pointer)                      ;   pascal string; caller supplies 
   )

(def-mactype :qtslostpercentparamsptr (find-mactype '(:pointer :qtslostpercentparams)))
(defrecord QTSLostPercentParams 
   (receivedPkts :unsigned-long)
   (lostPkts :unsigned-long)
   (percent :signed-long)
   )

(def-mactype :qtsdimensionparamsptr (find-mactype '(:pointer :qtsdimensionparams)))
(defrecord QTSDimensionParams 
   (width :signed-long)
   (height :signed-long)
   )

(def-mactype :qtsvolumesparamsptr (find-mactype '(:pointer :qtsvolumesparams)))
(defrecord QTSVolumesParams 
   (leftVolume :signed-integer)
   (rightVolume :signed-integer)
   )

(def-mactype :qtsgraphicsmodeparamsptr (find-mactype '(:pointer :qtsgraphicsmodeparams)))
(defrecord QTSGraphicsModeParams 
   (graphicsMode :signed-integer)
   (opColor :rgbcolor)
   )

(def-mactype :qtsgeturllinkrecordptr (find-mactype '(:pointer :qtsgeturllinkrecord)))
(defrecord QTSGetURLLinkRecord 
   (displayWhere :point)
   (returnedURLLink :handle)
   )

(defconstant $kQTSDataProcParamsVersion1 1)

(defconstant $kQTSDataProcType_MediaSample :|mdia|)
(defconstant $kQTSDataProcType_HintSample :|hint|)

(def-mactype :qtsdataprocparamsptr (find-mactype '(:pointer :qtsdataprocparams)))
(defrecord QTSDataProcParams 
   (version :signed-long)
   (flags :signed-long)
   (stream (:pointer :qtsstreamrecord))
   (procType :ostype)
   (proc :pointer)
   (procRefCon :pointer)
   )

(defconstant $kQTSDataProcSelector_SampleData :|samp|)
(defconstant $kQTSDataProcSelector_UserData :|user|)

(defconstant $kQTSSampleDataCallbackParamsVersion1 1)

(def-mactype :qtssampledatacallbackparamsptr (find-mactype '(:pointer :qtssampledatacallbackparams)))
(defrecord QTSSampleDataCallbackParams 
   (version :signed-long)
   (flags :signed-long)
   (stream (:pointer :qtsstreamrecord))
   (procType :ostype)
   (mediaType :ostype)
   (mediaTimeScale :signed-long)
   (sampleDesc (:handle :sampledescription))
   (sampleDescSeed :unsigned-long)
   (sampleTime :wide)
   (duration :wide)                             ;   could be 0  
   (sampleFlags :signed-long)
   (dataLength :unsigned-long)
   (data :pointer)
   )

(defconstant $kQTSUserDataCallbackParamsVersion1 1)

(def-mactype :qtsuserdatacallbackparamsptr (find-mactype '(:pointer :qtsuserdatacallbackparams)))
(defrecord QTSUserDataCallbackParams 
   (version :signed-long)
   (flags :signed-long)
   (stream (:pointer :qtsstreamrecord))
   (procType :ostype)
   (userDataType :ostype)
   (userDataHandle :handle)                     ;   caller must make copy if it wants to keep the data around 
   )

(defconstant $kQTSSendDataExtrasParamsVersion1 1)

(def-mactype :qtssenddataextrasparamsptr (find-mactype '(:pointer :qtssenddataextrasparams)))
(defrecord QTSSendDataExtrasParams 
   (version :signed-long)
   (flags :signed-long)
   (procType :ostype)
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	QTSModalFilterProcPtr = FUNCTION(inDialog: DialogPtr; {CONST}VAR inEvent: EventRecord; VAR ioItemHit: SInt16; inRefCon: UNIV Ptr): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :qtsmodalfilterprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :qtsmodalfilterupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :qtsmodalfilterupp (find-mactype ':pointer))
; $ENDC
; 	-----------------------------------------
; 	    Characteristics
; 	-----------------------------------------	
; 	 characteristics in Movies.h work here too 	

(defconstant $kQTSSupportsPerStreamControlCharacteristic :|psct|)

(def-mactype :qtsvideoparamsptr (find-mactype '(:pointer :qtsvideoparams)))
(defrecord QTSVideoParams 
   (width :signed-long)
   (height :signed-long)
   (matrix :matrixrecord)
   (gWorld (:pointer :cgrafport))
   (GDHandle (:handle :gdevice))
   (clip (:handle :macregion))
   (graphicsMode :signed-integer)
   (opColor :rgbcolor)
   )

(def-mactype :qtsaudioparamsptr (find-mactype '(:pointer :qtsaudioparams)))
(defrecord QTSAudioParams 
   (leftVolume :signed-integer)
   (rightVolume :signed-integer)
   (bassLevel :signed-integer)
   (trebleLevel :signed-integer)
   (frequencyBandsCount :signed-integer)
   (frequencyBands :pointer)
   (levelMeteringEnabled :boolean)
   )

(def-mactype :qtsmediaparamsptr (find-mactype '(:pointer :qtsmediaparams)))
(defrecord QTSMediaParams 
   (v :qtsvideoparams)
   (a :qtsaudioparams)
   )

(defconstant $kQTSMustDraw #x8)
(defconstant $kQTSAtEnd #x10)
(defconstant $kQTSPreflightDraw #x20)
(defconstant $kQTSSyncDrawing #x40)

; 	 media task result flags 	
(defconstant $kQTSDidDraw #x1)
(defconstant $kQTSNeedsToDraw #x4)
(defconstant $kQTSDrawAgain #x8)
(defconstant $kQTSPartialDraw #x10)

; 	============================================================================
; 	        Notifications
; 	============================================================================	
; 	 ------ notification types ------ 	
(defconstant $kQTSNullNotification :|null|)     ;   NULL  
(defconstant $kQTSErrorNotification :|err |)    ;   QTSErrorParams*, optional  
(defconstant $kQTSNewPresDetectedNotification :|newp|);   QTSNewPresDetectedParams*  
(defconstant $kQTSPresBeginChangingNotification :|prcb|);   NULL  
(defconstant $kQTSPresDoneChangingNotification :|prcd|);   NULL  
(defconstant $kQTSPresentationChangedNotification :|prch|);   NULL  
(defconstant $kQTSNewStreamNotification :|stnw|);   QTSNewStreamParams*  
(defconstant $kQTSStreamBeginChangingNotification :|stcb|);   QTSStream  
(defconstant $kQTSStreamDoneChangingNotification :|stcd|);   QTSStream  
(defconstant $kQTSStreamChangedNotification :|stch|);   QTSStreamChangedParams*  
(defconstant $kQTSStreamGoneNotification :|stgn|);   QTSStreamGoneParams*  
(defconstant $kQTSPreviewAckNotification :|pvak|);   QTSStream  
(defconstant $kQTSPrerollAckNotification :|pack|);   QTSStream  
(defconstant $kQTSStartAckNotification :|sack|) ;   QTSStream  
(defconstant $kQTSStopAckNotification :|xack|)  ;   QTSStream  
(defconstant $kQTSStatusNotification :|stat|)   ;   QTSStatusParams*  
(defconstant $kQTSURLNotification :|url |)      ;   QTSURLParams*  
(defconstant $kQTSDurationNotification :|dura|) ;   QTSDurationAtom*  
(defconstant $kQTSNewPresentationNotification :|nprs|);   QTSPresentation  
(defconstant $kQTSPresentationGoneNotification :|xprs|);   QTSPresentation  
(defconstant $kQTSPresentationDoneNotification :|pdon|);   NULL  
(defconstant $kQTSBandwidthAlertNotification :|bwal|);   QTSBandwidthAlertParams*  
(defconstant $kQTSAnnotationsChangedNotification :|meta|);   NULL  

; 	 flags for QTSErrorParams 	
(defconstant $kQTSFatalErrorFlag #x1)

(def-mactype :qtserrorparamsptr (find-mactype '(:pointer :qtserrorparams)))
(defrecord QTSErrorParams 
   (errorString :pointer)
   (flags :signed-long)
   )

(def-mactype :qtsnewpresdetectedparamsptr (find-mactype '(:pointer :qtsnewpresdetectedparams)))
(defrecord QTSNewPresDetectedParams 
   (data :pointer)
   )

(def-mactype :qtsnewstreamparamsptr (find-mactype '(:pointer :qtsnewstreamparams)))
(defrecord QTSNewStreamParams 
   (stream (:pointer :qtsstreamrecord))
   )

(def-mactype :qtsstreamchangedparamsptr (find-mactype '(:pointer :qtsstreamchangedparams)))
(defrecord QTSStreamChangedParams 
   (stream (:pointer :qtsstreamrecord))
   (mediaComponent (:pointer :componentinstancerecord));   could be NULL  
   )

(def-mactype :qtsstreamgoneparamsptr (find-mactype '(:pointer :qtsstreamgoneparams)))
(defrecord QTSStreamGoneParams 
   (stream (:pointer :qtsstreamrecord))
   )

(def-mactype :qtsstatusparamsptr (find-mactype '(:pointer :qtsstatusparams)))
(defrecord QTSStatusParams 
   (status :unsigned-long)
   (statusString :pointer)
   (detailedStatus :unsigned-long)
   (detailedStatusString :pointer)
   )

(def-mactype :qtsinfoparamsptr (find-mactype '(:pointer :qtsinfoparams)))
(defrecord QTSInfoParams 
   (infoType :ostype)
   (infoParams :pointer)
   )

(def-mactype :qtsurlparamsptr (find-mactype '(:pointer :qtsurlparams)))
(defrecord QTSURLParams 
   (urlLength :unsigned-long)
   (url :pointer)
   )

(defconstant $kQTSBandwidthAlertNeedToStop #x1)
(defconstant $kQTSBandwidthAlertRestartAt #x2)

(def-mactype :qtsbandwidthalertparamsptr (find-mactype '(:pointer :qtsbandwidthalertparams)))
(defrecord QTSBandwidthAlertParams 
   (flags :signed-long)
   (restartAt :signed-long)                     ;   new field in QT 4.1 
   (reserved :pointer)
   )

; 	============================================================================
; 	        Presentation
; 	============================================================================	
; 	-----------------------------------------
; 	     Flags
; 	-----------------------------------------	
; 	 flags for NewPresentationFromData 	

(defconstant $kQTSAutoModeFlag #x1)
(defconstant $kQTSDontShowStatusFlag #x8)
(defconstant $kQTSSendMediaFlag #x10000)
(defconstant $kQTSReceiveMediaFlag #x20000)

(def-mactype :qtsnewpresentationparamsptr (find-mactype '(:pointer :qtsnewpresentationparams)))
(defrecord QTSNewPresentationParams 
   (dataType :ostype)
   (data :pointer)
   (dataLength :unsigned-long)
   (editList (:handle :qtseditlist))
   (flags :signed-long)
   (TimeScale :signed-long)                     ;   set to 0 for default timescale  
   (mediaParams (:pointer :qtsmediaparams))
   (notificationProc :pointer)
   (notificationRefCon :pointer)
   )

(def-mactype :qtspresparamsptr (find-mactype '(:pointer :qtspresparams)))
(defrecord QTSPresParams 
   (version :unsigned-long)
   (editList (:handle :qtseditlist))
   (flags :signed-long)
   (TimeScale :signed-long)                     ;   set to 0 for default timescale  
   (mediaParams (:pointer :qtsmediaparams))
   (notificationProc :pointer)
   (notificationRefCon :pointer)
   )

(defconstant $kQTSPresParamsVersion1 1)

(def-mactype :qtspresidleparamsptr (find-mactype '(:pointer :qtspresidleparams)))
(defrecord QTSPresIdleParams 
   (stream (:pointer :qtsstreamrecord))
   (movieTimeToDisplay :wide)
   (flagsIn :signed-long)
   (flagsOut :signed-long)
   )

(defconstant $kQTSExportFlag_ShowDialog #x1)

(defconstant $kQTSExportParamsVersion1 1)

(def-mactype :qtsexportparamsptr (find-mactype '(:pointer :qtsexportparams)))
(defrecord QTSExportParams 
   (version :signed-long)
   (exportType :ostype)
   (exportExtraData :pointer)
   (destinationContainerType :ostype)
   (destinationContainerData :pointer)
   (destinationContainerExtras :pointer)
   (flagsIn :signed-long)
   (flagsOut :signed-long)
   (filterProc :pointer)
   (filterProcRefCon :pointer)
   (exportComponent (:pointer :componentrecord));   NULL unless you want to override  
   )

; 	-----------------------------------------
; 	    Toolbox Init/Close
; 	-----------------------------------------	
; 	 all "apps" must call this 	
; 
; 	 *  InitializeQTS()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 *    Windows:          in QTSClient.lib 4.0 and later
; 	 	

(deftrap-inline "_InitializeQTS" 
      () 
  :signed-integer
   () )

; 
;  *  TerminateQTS()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_TerminateQTS" 
      () 
  :signed-integer
   () )

; -----------------------------------------
;     Presentation Functions
; -----------------------------------------
; 
;  *  QTSNewPresentation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  
; CONST
(deftrap-inline "_QTSNewPresentation" 
      ((inParams (:pointer :qtsnewpresentationparams)) (outPresentation (:pointer (:pointer :qtspresentationrecord)))) 
  :signed-integer
   () )

; 
;  *  QTSNewPresentationFromData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 5.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_QTSNewPresentationFromData" 
      ((inDataType :ostype) (inData :pointer) (inDataLength (:pointer :wide)) (inPresParams (:pointer :qtspresparams)) (outPresentation (:pointer (:pointer :qtspresentationrecord)))) 
  :signed-integer
   () )

; 
;  *  QTSNewPresentationFromFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 5.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_QTSNewPresentationFromFile" 
      ((inFileSpec (:pointer :fsspec)) (inPresParams (:pointer :qtspresparams)) (outPresentation (:pointer (:pointer :qtspresentationrecord)))) 
  :signed-integer
   () )

; 
;  *  QTSNewPresentationFromDataRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 5.0 and later
;  
; CONST
(deftrap-inline "_QTSNewPresentationFromDataRef" 
      ((inDataRef :handle) (inDataRefType :ostype) (inPresParams (:pointer :qtspresparams)) (outPresentation (:pointer (:pointer :qtspresentationrecord)))) 
  :signed-integer
   () )

; 
;  *  QTSDisposePresentation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSDisposePresentation" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inFlags :signed-long)) 
  :signed-integer
   () )

; 
;  *  QTSPresExport()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 5.0 and later
;  

(deftrap-inline "_QTSPresExport" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inExportParams (:pointer :qtsexportparams))) 
  :signed-integer
   () )

; 
;  *  QTSPresIdle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresIdle" 
      ((inPresentation (:pointer :qtspresentationrecord)) (ioParams (:pointer :qtspresidleparams))) 
  nil
   () )

; 
;  *  QTSPresInvalidateRegion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresInvalidateRegion" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inRegion (:handle :macregion))) 
  :signed-integer
   () )

; -----------------------------------------
;     Presentation Configuration
; -----------------------------------------
; 
;  *  QTSPresSetFlags()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresSetFlags" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inFlags :signed-long) (inFlagsMask :signed-long)) 
  :signed-integer
   () )

; 
;  *  QTSPresGetFlags()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresGetFlags" 
      ((inPresentation (:pointer :qtspresentationrecord)) (outFlags (:pointer :signed-long))) 
  :signed-integer
   () )

; 
;  *  QTSPresGetTimeBase()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresGetTimeBase" 
      ((inPresentation (:pointer :qtspresentationrecord)) (outTimeBase (:pointer :pointer))) 
  :signed-integer
   () )

; 
;  *  QTSPresGetTimeScale()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresGetTimeScale" 
      ((inPresentation (:pointer :qtspresentationrecord)) (outTimeScale (:pointer :signed-long))) 
  :signed-integer
   () )

; 
;  *  QTSPresSetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresSetInfo" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inSelector :ostype) (ioParam :pointer)) 
  :signed-integer
   () )

; 
;  *  QTSPresGetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresGetInfo" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inSelector :ostype) (ioParam :pointer)) 
  :signed-integer
   () )

; 
;  *  QTSPresHasCharacteristic()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresHasCharacteristic" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inCharacteristic :ostype) (outHasIt (:pointer :boolean))) 
  :signed-integer
   () )

; 
;  *  QTSPresSetNotificationProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresSetNotificationProc" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inNotificationProc :pointer) (inRefCon :pointer)) 
  :signed-integer
   () )

; 
;  *  QTSPresGetNotificationProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresGetNotificationProc" 
      ((inPresentation (:pointer :qtspresentationrecord)) (outNotificationProc (:pointer :pointer)) (outRefCon (:pointer :pointer))) 
  :signed-integer
   () )

; -----------------------------------------
;     Presentation Control
; -----------------------------------------
; 
;  *  QTSPresPreview()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_QTSPresPreview" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inTimeValue (:pointer :wide)) (inRate :signed-long) (inFlags :signed-long)) 
  :signed-integer
   () )

; 
;  *  QTSPresPreroll()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresPreroll" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inTimeValue :unsigned-long) (inRate :signed-long) (inFlags :signed-long)) 
  :signed-integer
   () )

; 
;  *  QTSPresPreroll64()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.1 and later
;  
; CONST
(deftrap-inline "_QTSPresPreroll64" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inPrerollTime (:pointer :wide)) (inRate :signed-long) (inFlags :signed-long)) 
  :signed-integer
   () )

; 
;  *  QTSPresStart()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresStart" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inFlags :signed-long)) 
  :signed-integer
   () )

; 
;  *  QTSPresSkipTo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresSkipTo" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inTimeValue :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  QTSPresSkipTo64()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.1 and later
;  
; CONST
(deftrap-inline "_QTSPresSkipTo64" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inTimeValue (:pointer :wide))) 
  :signed-integer
   () )

; 
;  *  QTSPresStop()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresStop" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inFlags :signed-long)) 
  :signed-integer
   () )

; ============================================================================
;         Streams
; ============================================================================
; -----------------------------------------
;     Stream Functions
; -----------------------------------------
; 
;  *  QTSPresNewStream()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresNewStream" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inDataType :ostype) (inData :pointer) (inDataLength :unsigned-long) (inFlags :signed-long) (outStream (:pointer (:pointer :qtsstreamrecord)))) 
  :signed-integer
   () )

; 
;  *  QTSDisposeStream()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSDisposeStream" 
      ((inStream (:pointer :qtsstreamrecord)) (inFlags :signed-long)) 
  :signed-integer
   () )

; 
;  *  QTSPresGetNumStreams()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresGetNumStreams" 
      ((inPresentation (:pointer :qtspresentationrecord))) 
  :unsigned-long
   () )

; 
;  *  QTSPresGetIndStream()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresGetIndStream" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inIndex :unsigned-long)) 
  (:pointer :qtsstreamrecord)
   () )

; 
;  *  QTSGetStreamPresentation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSGetStreamPresentation" 
      ((inStream (:pointer :qtsstreamrecord))) 
  (:pointer :qtspresentationrecord)
   () )

; 
;  *  QTSPresSetPreferredRate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresSetPreferredRate" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inRate :signed-long) (inFlags :signed-long)) 
  :signed-integer
   () )

; 
;  *  QTSPresGetPreferredRate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresGetPreferredRate" 
      ((inPresentation (:pointer :qtspresentationrecord)) (outRate (:pointer :signed-long))) 
  :signed-integer
   () )

; 
;  *  QTSPresSetEnable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresSetEnable" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inEnableMode :boolean)) 
  :signed-integer
   () )

; 
;  *  QTSPresGetEnable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresGetEnable" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (outEnableMode (:pointer :boolean))) 
  :signed-integer
   () )

; 
;  *  QTSPresSetPresenting()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresSetPresenting" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inPresentingMode :boolean)) 
  :signed-integer
   () )

; 
;  *  QTSPresGetPresenting()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresGetPresenting" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (outPresentingMode (:pointer :boolean))) 
  :signed-integer
   () )

; 
;  *  QTSPresSetActiveSegment()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.1 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_QTSPresSetActiveSegment" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inStartTime (:pointer :wide)) (inDuration (:pointer :wide))) 
  :signed-integer
   () )

; 
;  *  QTSPresGetActiveSegment()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.1 and later
;  

(deftrap-inline "_QTSPresGetActiveSegment" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (outStartTime (:pointer :wide)) (outDuration (:pointer :wide))) 
  :signed-integer
   () )

; 
;  *  QTSPresSetPlayHints()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresSetPlayHints" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inFlags :signed-long) (inFlagsMask :signed-long)) 
  :signed-integer
   () )

; 
;  *  QTSPresGetPlayHints()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresGetPlayHints" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (outFlags (:pointer :signed-long))) 
  :signed-integer
   () )

; -----------------------------------------
;     Stream Spatial Functions
; -----------------------------------------
; 
;  *  QTSPresSetGWorld()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresSetGWorld" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inGWorld (:pointer :cgrafport)) (inGDHandle (:handle :gdevice))) 
  :signed-integer
   () )

; 
;  *  QTSPresGetGWorld()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresGetGWorld" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (outGWorld (:pointer (:pointer :cgrafport))) (outGDHandle (:pointer (:handle :gdevice)))) 
  :signed-integer
   () )

; 
;  *  QTSPresSetClip()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresSetClip" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inClip (:handle :macregion))) 
  :signed-integer
   () )

; 
;  *  QTSPresGetClip()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresGetClip" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (outClip (:pointer (:handle :macregion)))) 
  :signed-integer
   () )

; 
;  *  QTSPresSetMatrix()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  
; CONST
(deftrap-inline "_QTSPresSetMatrix" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inMatrix (:pointer :matrixrecord))) 
  :signed-integer
   () )

; 
;  *  QTSPresGetMatrix()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresGetMatrix" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (outMatrix (:pointer :matrixrecord))) 
  :signed-integer
   () )

; 
;  *  QTSPresSetDimensions()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresSetDimensions" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inWidth :signed-long) (inHeight :signed-long)) 
  :signed-integer
   () )

; 
;  *  QTSPresGetDimensions()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresGetDimensions" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (outWidth (:pointer :signed-long)) (outHeight (:pointer :signed-long))) 
  :signed-integer
   () )

; 
;  *  QTSPresSetGraphicsMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  
; CONST
(deftrap-inline "_QTSPresSetGraphicsMode" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inMode :signed-integer) (inOpColor (:pointer :rgbcolor))) 
  :signed-integer
   () )

; 
;  *  QTSPresGetGraphicsMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresGetGraphicsMode" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (outMode (:pointer :signed-integer)) (outOpColor (:pointer :rgbcolor))) 
  :signed-integer
   () )

; 
;  *  QTSPresGetPicture()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresGetPicture" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (outPicture (:pointer (:handle :picture)))) 
  :signed-integer
   () )

; -----------------------------------------
;     Stream Sound Functions
; -----------------------------------------
; 
;  *  QTSPresSetVolumes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresSetVolumes" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inLeftVolume :signed-integer) (inRightVolume :signed-integer)) 
  :signed-integer
   () )

; 
;  *  QTSPresGetVolumes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSPresGetVolumes" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (outLeftVolume (:pointer :signed-integer)) (outRightVolume (:pointer :signed-integer))) 
  :signed-integer
   () )

; -----------------------------------------
;     Sourcing
; -----------------------------------------
; 
;  *  QTSPresGetSettingsAsText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0.1 and later
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.1 and later
;  *    Mac OS X:         in version 10.1 and later
;  

(deftrap-inline "_QTSPresGetSettingsAsText" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inFlags :signed-long) (inSettingsType :ostype) (outText (:pointer :handle)) (inPanelFilterProc :pointer) (inPanelFilterProcRefCon :pointer)) 
  :signed-integer
   () )

; 
;  *  QTSPresSettingsDialog()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_QTSPresSettingsDialog" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inFlags :signed-long) (inFilterProc :pointer) (inFilterProcRefCon :pointer)) 
  :signed-integer
   () )

; 
;  *  QTSPresSettingsDialogWithFilters()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0.1 and later
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.1 and later
;  *    Mac OS X:         in version 10.1 and later
;  

(deftrap-inline "_QTSPresSettingsDialogWithFilters" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inFlags :signed-long) (inFilterProc :pointer) (inFilterProcRefCon :pointer) (inPanelFilterProc :pointer) (inPanelFilterProcRefCon :pointer)) 
  :signed-integer
   () )

; 
;  *  QTSPresSetSettings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_QTSPresSetSettings" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inSettings (:pointer :qtatomspec)) (inFlags :signed-long)) 
  :signed-integer
   () )

; 
;  *  QTSPresGetSettings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_QTSPresGetSettings" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (outSettings (:pointer :handle)) (inFlags :signed-long)) 
  :signed-integer
   () )

; 
;  *  QTSPresAddSourcer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_QTSPresAddSourcer" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inSourcer (:pointer :componentinstancerecord)) (inFlags :signed-long)) 
  :signed-integer
   () )

; 
;  *  QTSPresRemoveSourcer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_QTSPresRemoveSourcer" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inSourcer (:pointer :componentinstancerecord)) (inFlags :signed-long)) 
  :signed-integer
   () )

; 
;  *  QTSPresGetNumSourcers()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_QTSPresGetNumSourcers" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord))) 
  :unsigned-long
   () )

; 
;  *  QTSPresGetIndSourcer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_QTSPresGetIndSourcer" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inIndex :unsigned-long) (outSourcer (:pointer (:pointer :componentinstancerecord)))) 
  :signed-integer
   () )

; ============================================================================
;         Misc
; ============================================================================
;  flags for Get/SetNetworkAppName 

(defconstant $kQTSNetworkAppNameIsFullNameFlag #x1)

; 
; 	 *  QTSSetNetworkAppName()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in QTStreamLib 4.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 *    Windows:          in QTSClient.lib 4.1 and later
; 	 	

(deftrap-inline "_QTSSetNetworkAppName" 
      ((inAppName :pointer) (inFlags :signed-long)) 
  :signed-integer
   () )

; 
;  *  QTSGetNetworkAppName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.1 and later
;  

(deftrap-inline "_QTSGetNetworkAppName" 
      ((inFlags :signed-long) (outCStringPtr (:pointer :pointer))) 
  :signed-integer
   () )

; -----------------------------------------
;     Statistics Utilities
; -----------------------------------------

(def-mactype :qtsstathelperrecordptr (find-mactype '(:pointer :qtsstathelperrecord)))
(defrecord QTSStatHelperRecord 
   (data (:array :signed-long 1))
   )

(def-mactype :qtsstathelper (find-mactype '(:pointer :qtsstathelperrecord)))

(defconstant $kQTSInvalidStatHelper 0)

; 	 flags for QTSStatHelperNextParams 	
(defconstant $kQTSStatHelperReturnPascalStringsFlag #x1)

(def-mactype :qtsstathelpernextparamsptr (find-mactype '(:pointer :qtsstathelpernextparams)))
(defrecord QTSStatHelperNextParams 
   (flags :signed-long)
   (returnedStatisticsType :ostype)
   (returnedStream (:pointer :qtsstreamrecord))
   (maxStatNameLength :unsigned-long)
   (returnedStatName :pointer)                  ;   NULL if you don't want it 
   (maxStatStringLength :unsigned-long)
   (returnedStatString :pointer)                ;   NULL if you don't want it 
   (maxStatUnitLength :unsigned-long)
   (returnedStatUnit :pointer)                  ;   NULL if you don't want it 
   )

(def-mactype :qtsstatisticsparamsptr (find-mactype '(:pointer :qtsstatisticsparams)))
(defrecord QTSStatisticsParams 
   (statisticsType :ostype)
   (container :handle)
   (parentAtom :signed-long)
   (flags :signed-long)
   )

; 	 general statistics types 	

(defconstant $kQTSAllStatisticsType :|all |)
(defconstant $kQTSShortStatisticsType :|shrt|)
(defconstant $kQTSSummaryStatisticsType :|summ|)

; 	 statistics flags 	
(defconstant $kQTSGetNameStatisticsFlag #x1)
(defconstant $kQTSDontGetDataStatisticsFlag #x2)
(defconstant $kQTSUpdateAtomsStatisticsFlag #x4)
(defconstant $kQTSGetUnitsStatisticsFlag #x8)
(defconstant $kQTSUpdateAllIfNecessaryStatisticsFlag #x10000)

; 	 statistics atom types 	
(defconstant $kQTSStatisticsStreamAtomType :|strm|)
(defconstant $kQTSStatisticsNameAtomType :|name|);   chars only, no length or terminator  
(defconstant $kQTSStatisticsDataFormatAtomType :|frmt|);   OSType  
(defconstant $kQTSStatisticsDataAtomType :|data|)
(defconstant $kQTSStatisticsUnitsAtomType :|unit|);   OSType  
(defconstant $kQTSStatisticsUnitsNameAtomType :|unin|);   chars only, no length or terminator  

; 	 statistics data formats 	
(defconstant $kQTSStatisticsSInt32DataFormat :|si32|)
(defconstant $kQTSStatisticsUInt32DataFormat :|ui32|)
(defconstant $kQTSStatisticsSInt16DataFormat :|si16|)
(defconstant $kQTSStatisticsUInt16DataFormat :|ui16|)
(defconstant $kQTSStatisticsFixedDataFormat :|fixd|)
(defconstant $kQTSStatisticsUnsignedFixedDataFormat :|ufix|)
(defconstant $kQTSStatisticsStringDataFormat :|strg|)
(defconstant $kQTSStatisticsOSTypeDataFormat :|ostp|)
(defconstant $kQTSStatisticsRectDataFormat :|rect|)
(defconstant $kQTSStatisticsPointDataFormat :|pont|)

; 	 statistics units types 	
(defconstant $kQTSStatisticsNoUnitsType 0)
(defconstant $kQTSStatisticsPercentUnitsType :|pcnt|)
(defconstant $kQTSStatisticsBitsPerSecUnitsType :|bps |)
(defconstant $kQTSStatisticsFramesPerSecUnitsType :|fps |)

; 	 specific statistics types 	
(defconstant $kQTSTotalDataRateStat :|drtt|)
(defconstant $kQTSTotalDataRateInStat :|drti|)
(defconstant $kQTSTotalDataRateOutStat :|drto|)
(defconstant $kQTSNetworkIDStringStat :|nids|)

; 
; 	 *  QTSNewStatHelper()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 *    Windows:          in QTSClient.lib 4.0 and later
; 	 	

(deftrap-inline "_QTSNewStatHelper" 
      ((inPresentation (:pointer :qtspresentationrecord)) (inStream (:pointer :qtsstreamrecord)) (inStatType :ostype) (inFlags :signed-long) (outStatHelper (:pointer (:pointer :qtsstathelperrecord)))) 
  :signed-integer
   () )

; 
;  *  QTSDisposeStatHelper()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSDisposeStatHelper" 
      ((inStatHelper (:pointer :qtsstathelperrecord))) 
  :signed-integer
   () )

; 
;  *  QTSStatHelperGetStats()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSStatHelperGetStats" 
      ((inStatHelper (:pointer :qtsstathelperrecord))) 
  :signed-integer
   () )

; 
;  *  QTSStatHelperResetIter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSStatHelperResetIter" 
      ((inStatHelper (:pointer :qtsstathelperrecord))) 
  :signed-integer
   () )

; 
;  *  QTSStatHelperNext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSStatHelperNext" 
      ((inStatHelper (:pointer :qtsstathelperrecord)) (ioParams (:pointer :qtsstathelpernextparams))) 
  :boolean
   () )

; 
;  *  QTSStatHelperGetNumStats()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSStatHelperGetNumStats" 
      ((inStatHelper (:pointer :qtsstathelperrecord))) 
  :unsigned-long
   () )

;  used by components to put statistics into the atom container 
; 
;  *  QTSGetOrMakeStatAtomForStream()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSGetOrMakeStatAtomForStream" 
      ((inContainer :handle) (inStream (:pointer :qtsstreamrecord)) (outParentAtom (:pointer :signed-long))) 
  :signed-integer
   () )

; 
;  *  QTSInsertStatistic()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSInsertStatistic" 
      ((inContainer :handle) (inParentAtom :signed-long) (inStatType :ostype) (inStatData :pointer) (inStatDataLength :unsigned-long) (inStatDataFormat :ostype) (inFlags :signed-long)) 
  :signed-integer
   () )

; 
;  *  QTSInsertStatisticName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSInsertStatisticName" 
      ((inContainer :handle) (inParentAtom :signed-long) (inStatType :ostype) (inStatName :pointer) (inStatNameLength :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  QTSInsertStatisticUnits()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSInsertStatisticUnits" 
      ((inContainer :handle) (inParentAtom :signed-long) (inStatType :ostype) (inUnitsType :ostype) (inUnitsName :pointer) (inUnitsNameLength :unsigned-long)) 
  :signed-integer
   () )

; ============================================================================
;         Data Formats
; ============================================================================
; -----------------------------------------
;     Data Types
; -----------------------------------------
;  universal data types 

(defconstant $kQTSNullDataType :|NULL|)
(defconstant $kQTSUnknownDataType :|huh?|)
(defconstant $kQTSAtomContainerDataType :|qtac|);   QTAtomContainer  
(defconstant $kQTSAtomDataType :|qtat|)         ;   QTSAtomContainerDataStruct*  
(defconstant $kQTSAliasDataType :|alis|)
(defconstant $kQTSFileDataType :|fspc|)         ;   FSSpec*  
(defconstant $kQTSFileSpecDataType :|fspc|)     ;   FSSpec*  
(defconstant $kQTSHandleDataType :|hndl|)       ;   Handle*  
(defconstant $kQTSDataRefDataType :|dref|)      ;   DataReferencePtr  

; 	 these data types are specific to presentations 	
(defconstant $kQTSRTSPDataType :|rtsp|)
(defconstant $kQTSSDPDataType :|sdp |)

; 	-----------------------------------------
; 	    Atom IDs
; 	-----------------------------------------	
(defconstant $kQTSAtomType_Presentation :|pres|)
(defconstant $kQTSAtomType_PresentationHeader :|phdr|);   QTSPresentationHeaderAtom  
(defconstant $kQTSAtomType_MediaStream :|mstr|)
(defconstant $kQTSAtomType_MediaStreamHeader :|mshd|);   QTSMediaStreamHeaderAtom  
(defconstant $kQTSAtomType_MediaDescriptionText :|mdes|);   chars, no length  
(defconstant $kQTSAtomType_ClipRect :|clip|)    ;   QTSClipRectAtom  
(defconstant $kQTSAtomType_Duration :|dura|)    ;   QTSDurationAtom  
(defconstant $kQTSAtomType_BufferTime :|bufr|)  ;   QTSBufferTimeAtom  

(def-mactype :qtsatomcontainerdatastructptr (find-mactype '(:pointer :qtsatomcontainerdatastruct)))
(defrecord QTSAtomContainerDataStruct 
   (container :handle)
   (parentAtom :signed-long)
   )

; 	 flags for QTSPresentationHeaderAtom 	

(defconstant $kQTSPresHeaderTypeIsData #x100)
(defconstant $kQTSPresHeaderDataIsHandle #x200)

(def-mactype :qtspresentationheaderatomptr (find-mactype '(:pointer :qtspresentationheaderatom)))
(defrecord QTSPresentationHeaderAtom 
   (versionAndFlags :signed-long)
   (conductorOrDataType :ostype)
   (dataAtomType :ostype)                       ;   where the data really is 
   )

(def-mactype :qtsmediastreamheaderatomptr (find-mactype '(:pointer :qtsmediastreamheaderatom)))
(defrecord QTSMediaStreamHeaderAtom 
   (versionAndFlags :signed-long)
   (mediaTransportType :ostype)
   (mediaTransportDataAID :ostype)              ;   where the data really is 
   )

(def-mactype :qtsbuffertimeatomptr (find-mactype '(:pointer :qtsbuffertimeatom)))
(defrecord QTSBufferTimeAtom 
   (versionAndFlags :signed-long)
   (bufferTime :signed-long)
   )

(def-mactype :qtsdurationatomptr (find-mactype '(:pointer :qtsdurationatom)))
(defrecord QTSDurationAtom 
   (versionAndFlags :signed-long)
   (TimeScale :signed-long)
   (duration :wide)
   )

(def-mactype :qtscliprectatomptr (find-mactype '(:pointer :qtscliprectatom)))
(defrecord QTSClipRectAtom 
   (versionAndFlags :signed-long)
   (clipRect :rect)
   )

(defconstant $kQTSEmptyEditStreamStartTime -1)

(def-mactype :qtsstatus (find-mactype ':unsigned-long))

(defconstant $kQTSNullStatus 0)
(defconstant $kQTSUninitializedStatus 1)
(defconstant $kQTSConnectingStatus 2)
(defconstant $kQTSOpeningConnectionDetailedStatus 3)
(defconstant $kQTSMadeConnectionDetailedStatus 4)
(defconstant $kQTSNegotiatingStatus 5)
(defconstant $kQTSGettingDescriptionDetailedStatus 6)
(defconstant $kQTSGotDescriptionDetailedStatus 7)
(defconstant $kQTSSentSetupCmdDetailedStatus 8)
(defconstant $kQTSReceivedSetupResponseDetailedStatus 9)
(defconstant $kQTSSentPlayCmdDetailedStatus 10)
(defconstant $kQTSReceivedPlayResponseDetailedStatus 11)
(defconstant $kQTSBufferingStatus 12)
(defconstant $kQTSPlayingStatus 13)
(defconstant $kQTSPausedStatus 14)
(defconstant $kQTSAutoConfiguringStatus 15)
(defconstant $kQTSDownloadingStatus 16)
(defconstant $kQTSBufferingWithTimeStatus 17)
(defconstant $kQTSWaitingDisconnectStatus 100)

; 	-----------------------------------------
; 	    QuickTime Preferences Types
; 	-----------------------------------------	
(defconstant $kQTSConnectionPrefsType :|stcm|)  ;   root atom that all other atoms are contained in 
;      kQTSNotUsedForProxyPrefsType = 'nopr',     //        comma-delimited list of URLs that are never used for proxies 
(defconstant $kQTSConnectionMethodPrefsType :|mthd|);        connection method (OSType that matches one of the following three) 
(defconstant $kQTSDirectConnectPrefsType :|drct|);         used if direct connect (QTSDirectConnectPrefsRecord) 
;      kQTSRTSPProxyPrefsType =     'rtsp',   //   used if RTSP Proxy (QTSProxyPrefsRecord) 
(defconstant $kQTSSOCKSPrefsType :|sock|)       ;         used if SOCKS Proxy (QTSProxyPrefsRecord) 

(defconstant $kQTSDirectConnectHTTPProtocol :|http|)
(defconstant $kQTSDirectConnectRTSPProtocol :|rtsp|)

(def-mactype :qtsdirectconnectprefsrecordptr (find-mactype '(:pointer :qtsdirectconnectprefsrecord)))
(defrecord QTSDirectConnectPrefsRecord 
   (tcpPortID :unsigned-long)
   (protocol :ostype)
   )

(def-mactype :qtsproxyprefsrecordptr (find-mactype '(:pointer :qtsproxyprefsrecord)))
(defrecord QTSProxyPrefsRecord 
   (serverNameStr (:string 255))
   (portID :unsigned-long)
   )

(defconstant $kConnectionActive #x1)
(defconstant $kConnectionUseSystemPref #x2)

(def-mactype :qtstransportprefptr (find-mactype '(:pointer :qtstransportpref)))
(defrecord QTSTransportPref 
   (protocol :ostype)                           ;   udp, http, tcp, etc 
   (portID :signed-long)                        ;   port to use for this connection type 
   (flags :unsigned-long)                       ;   connection flags 
   (seed :unsigned-long)                        ;   seed value last time this setting was read from system prefs 
   )

(defconstant $kProxyActive #x1)
(defconstant $kProxyUseSystemPref #x2)

(def-mactype :qtsproxyprefptr (find-mactype '(:pointer :qtsproxypref)))
(defrecord QTSProxyPref 
   (flags :unsigned-long)                       ;   proxy flags 
   (portID :signed-long)                        ;   port to use for this connection type 
   (seed :unsigned-long)                        ;   seed value last time this setting was read from system prefs 
   (serverNameStr (:string 255))                ;   proxy server url 
   )

(defconstant $kNoProxyUseSystemPref #x1)

(def-mactype :qtsnoproxyprefptr (find-mactype '(:pointer :qtsnoproxypref)))
(defrecord QTSNoProxyPref 
   (flags :unsigned-long)                       ;   no-proxy flags 
   (seed :unsigned-long)                        ;   seed value last time this setting was read from system prefs 
   (urlList :signed-byte)                       ;   NULL terminated, comma delimited list of urls 
   )

(defconstant $kQTSTransAndProxyAtomType :|strp|);   transport/proxy prefs root atom 
(defconstant $kQTSConnectionPrefsVersion :|vers|);     prefs format version 
(defconstant $kQTSTransportPrefsAtomType :|trns|);     tranport prefs root atom 
(defconstant $kQTSConnectionAtomType :|conn|)   ;       connection prefs atom type, one for each transport type 
(defconstant $kQTSUDPTransportType :|udp |)     ;       udp transport prefs 
(defconstant $kQTSHTTPTransportType :|http|)    ;       http transport prefs 
(defconstant $kQTSTCPTransportType :|tcp |)     ;       tcp transport prefs     
(defconstant $kQTSProxyPrefsAtomType :|prxy|)   ;     proxy prefs root atom 
(defconstant $kQTSHTTPProxyPrefsType :|http|)   ;       http proxy settings 
(defconstant $kQTSRTSPProxyPrefsType :|rtsp|)   ;       rtsp proxy settings 
(defconstant $kQTSSOCKSProxyPrefsType :|scks|)  ;       socks proxy settings 
(defconstant $kQTSProxyUserInfoPrefsType :|user|);     proxy username/password root atom 
(defconstant $kQTSDontProxyPrefsAtomType :|nopr|);     no-proxy prefs root atom 
(defconstant $kQTSDontProxyDataType :|data|)    ;       no proxy settings 

; 
; 	 *  QTSPrefsAddProxySetting()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in QTStreamLib 4.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 *    Windows:          in QTSClient.lib 4.1 and later
; 	 	

(deftrap-inline "_QTSPrefsAddProxySetting" 
      ((proxyType :ostype) (portID :signed-long) (flags :unsigned-long) (seed :unsigned-long) (srvrURL (:pointer (:string 255)))) 
  :signed-integer
   () )

; 
;  *  QTSPrefsFindProxyByType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.1 and later
;  

(deftrap-inline "_QTSPrefsFindProxyByType" 
      ((proxyType :ostype) (flags :unsigned-long) (flagsMask :unsigned-long) (proxyHndl (:pointer :pointer)) (count (:pointer :signed-integer))) 
  :signed-integer
   () )

; 
;  *  QTSPrefsAddConnectionSetting()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.1 and later
;  

(deftrap-inline "_QTSPrefsAddConnectionSetting" 
      ((protocol :ostype) (portID :signed-long) (flags :unsigned-long) (seed :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  QTSPrefsFindConnectionByType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.1 and later
;  

(deftrap-inline "_QTSPrefsFindConnectionByType" 
      ((protocol :ostype) (flags :unsigned-long) (flagsMask :unsigned-long) (connectionHndl (:pointer :pointer)) (count (:pointer :signed-integer))) 
  :signed-integer
   () )

; 
;  *  QTSPrefsGetActiveConnection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.1 and later
;  

(deftrap-inline "_QTSPrefsGetActiveConnection" 
      ((protocol :ostype) (connectInfo (:pointer :qtstransportpref))) 
  :signed-integer
   () )

; 
;  *  QTSPrefsGetNoProxyURLs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.1 and later
;  

(deftrap-inline "_QTSPrefsGetNoProxyURLs" 
      ((noProxyHndl (:pointer :pointer))) 
  :signed-integer
   () )

; 
;  *  QTSPrefsSetNoProxyURLs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.1 and later
;  

(deftrap-inline "_QTSPrefsSetNoProxyURLs" 
      ((urls :pointer) (flags :unsigned-long) (seed :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  QTSPrefsAddProxyUserInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0.1 and later
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.1 and later
;  *    Mac OS X:         in version 10.1 and later
;  *    Windows:          in QTSClient.lib 5.0.1 and later
;  

(deftrap-inline "_QTSPrefsAddProxyUserInfo" 
      ((proxyType :ostype) (flags :signed-long) (flagsMask :signed-long) (username (:pointer (:string 255))) (password (:pointer (:string 255)))) 
  :signed-integer
   () )

; 
;  *  QTSPrefsFindProxyUserInfoByType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0.1 and later
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.1 and later
;  *    Mac OS X:         in version 10.1 and later
;  *    Windows:          in QTSClient.lib 5.0.1 and later
;  

(deftrap-inline "_QTSPrefsFindProxyUserInfoByType" 
      ((proxyType :ostype) (flags :signed-long) (flagsMask :signed-long) (username (:pointer (:string 255))) (password (:pointer (:string 255)))) 
  :signed-integer
   () )

; ============================================================================
;         Memory Management Services
; ============================================================================
; 
;    These routines allocate normal pointers and handles,
;    but do the correct checking, etc.
;    Dispose using the normal DisposePtr and DisposeHandle
;    Call these routines for one time memory allocations.
;    You do not need to set any hints to use these calls.
; 

; 
;  *  QTSNewPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSNewPtr" 
      ((inByteCount :unsigned-long) (inFlags :signed-long) (outFlags (:pointer :signed-long))) 
  :pointer
   () )

; 
;  *  QTSNewHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSNewHandle" 
      ((inByteCount :unsigned-long) (inFlags :signed-long) (outFlags (:pointer :signed-long))) 
  :handle
   () )

;   flags in 

(defconstant $kQTSMemAllocClearMem #x1)
(defconstant $kQTSMemAllocDontUseTempMem #x2)
(defconstant $kQTSMemAllocTryTempMemFirst #x4)
(defconstant $kQTSMemAllocDontUseSystemMem #x8)
(defconstant $kQTSMemAllocTrySystemMemFirst #x10)
(defconstant $kQTSMemAllocHoldMemory #x1000)
(defconstant $kQTSMemAllocIsInterruptTime #x1010000);   currently not supported for alloc 

;   flags out 
(defconstant $kQTSMemAllocAllocatedInTempMem #x1)
(defconstant $kQTSMemAllocAllocatedInSystemMem #x2)

(def-mactype :qtsmemptr (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :qtsmemptrptr (find-mactype '(:pointer :pointer)));  when a VAR xx:QTSMemPtr parameter can be nil, it is changed to xx: QTSMemPtrPtr 
; 
; 	   These routines are for buffers that will be recirculated
; 	   you must use QTReleaseMemPtr instead of DisposePtr
; 	   QTSReleaseMemPtr can be used at interrupt time
; 	   but QTSAllocMemPtr currently cannot 
; 	
; 
; 	 *  QTSAllocMemPtr()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 *    Windows:          in QTSClient.lib 4.0 and later
; 	 	

(deftrap-inline "_QTSAllocMemPtr" 
      ((inByteCount :unsigned-long) (inFlags :signed-long)) 
  :pointer
   () )

; 
;  *  QTSReleaseMemPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSReleaseMemPtr" 
      ((inMemPtr :pointer) (inFlags :signed-long)) 
  nil
   () )

; ============================================================================
;         Buffer Management Services
; ============================================================================

(defconstant $kQTSStreamBufferVersion1 1)

(def-mactype :qtsstreambufferptr (find-mactype '(:pointer :qtsstreambuffer)))
(defrecord QTSStreamBuffer 
   (reserved1 (:pointer :qtsstreambuffer))
   (reserved2 (:pointer :qtsstreambuffer))
   (next (:pointer :qtsstreambuffer))           ;   next message block in a message  
   (rptr :pointer)                              ;   first byte with real data in the DataBuffer  
   (wptr :pointer)                              ;   last+1 byte with real data in the DataBuffer  
   (version :signed-long)
   (metadata (:array :unsigned-long 4))         ;   usage defined by message sender  
   (flags :signed-long)                         ;   reserved  
   (reserved3 :signed-long)
   (reserved4 :signed-long)
   (reserved5 :signed-long)
   (moreMeta (:array :unsigned-long 8))
   )

;   flags for QTSDuplicateMessage 

(defconstant $kQTSDuplicateBufferFlag_CopyData #x1)
(defconstant $kQTSDuplicateBufferFlag_FlattenMessage #x2)

; 
; 	 *  QTSNewStreamBuffer()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.3 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 *    Windows:          in QTSClient.lib 5.0 and later
; 	 	

(deftrap-inline "_QTSNewStreamBuffer" 
      ((inDataSize :unsigned-long) (inFlags :signed-long) (outStreamBuffer (:pointer :pointer))) 
  :signed-integer
   () )

; 
;  *  QTSFreeMessage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSFreeMessage" 
      ((inMessage (:pointer :qtsstreambuffer))) 
  nil
   () )

; 
;     kQTSDuplicateBufferFlag_CopyData - forces a copy of the data itself
;     kQTSCopyBufferFlag_FlattenMessage - copies the data if it needs to be flattened
;     QTSDuplicateMessage never frees the old message
; 
; 
;  *  QTSDuplicateMessage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 5.0 and later
;  

(deftrap-inline "_QTSDuplicateMessage" 
      ((inMessage (:pointer :qtsstreambuffer)) (inFlags :signed-long) (outDuplicatedMessage (:pointer :pointer))) 
  :signed-integer
   () )

; 
;  *  QTSMessageLength()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSMessageLength" 
      ((inMessage (:pointer :qtsstreambuffer))) 
  :unsigned-long
   () )

; 
;  *  QTSStreamBufferDataInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 5.0 and later
;  

(deftrap-inline "_QTSStreamBufferDataInfo" 
      ((inStreamBuffer (:pointer :qtsstreambuffer)) (outDataStart (:pointer :pointer)) (outDataMaxLength (:pointer :unsigned-long))) 
  nil
   () )

;   ---- old calls (don't use these) 

; 
;  *  QTSAllocBuffer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSAllocBuffer" 
      ((inSize :signed-long)) 
  (:pointer :qtsstreambuffer)
   () )

; 
;  *  QTSDupMessage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSDupMessage" 
      ((inMessage (:pointer :qtsstreambuffer))) 
  (:pointer :qtsstreambuffer)
   () )

; 
;  *  QTSCopyMessage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSCopyMessage" 
      ((inMessage (:pointer :qtsstreambuffer))) 
  (:pointer :qtsstreambuffer)
   () )

; 
;  *  QTSFlattenMessage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSFlattenMessage" 
      ((inMessage (:pointer :qtsstreambuffer))) 
  (:pointer :qtsstreambuffer)
   () )

; ============================================================================
;         Misc
; ============================================================================
; 
;  *  QTSGetErrorString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 4.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTSClient.lib 4.0 and later
;  

(deftrap-inline "_QTSGetErrorString" 
      ((inErrorCode :signed-long) (inMaxErrorStringLength :unsigned-long) (outErrorString :pointer) (inFlags :signed-long)) 
  :boolean
   () )

; 
;  *  QTSInitializeMediaParams()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QTStreamLib 5.0.1 and later
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.1 and later
;  *    Mac OS X:         in version 10.1 and later
;  *    Windows:          in QTSClient.lib 5.0.1 and later
;  

(deftrap-inline "_QTSInitializeMediaParams" 
      ((inMediaParams (:pointer :qtsmediaparams))) 
  :signed-integer
   () )

;  UPP call backs 

(defconstant $uppQTSNotificationProcInfo #x3FF0)
(defconstant $uppQTSPanelFilterProcInfo #x3D0)
(defconstant $uppQTSModalFilterProcInfo #x3FD0)
; 
; 	 *  NewQTSNotificationUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.3 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewQTSNotificationProc 
(deftrap "_NewQTSNotificationUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewQTSPanelFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib on Mac OS X
;  *    Mac OS X:         in version 10.1 and later
;  
;  old name was NewQTSPanelFilterProc 
(deftrap "_NewQTSPanelFilterUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewQTSModalFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewQTSModalFilterProc 
(deftrap "_NewQTSModalFilterUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeQTSNotificationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeQTSNotificationUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeQTSPanelFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib on Mac OS X
;  *    Mac OS X:         in version 10.1 and later
;  

(deftrap "_DisposeQTSPanelFilterUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeQTSModalFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeQTSModalFilterUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeQTSNotificationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallQTSNotificationProc 
(deftrap-inline "_InvokeQTSNotificationUPP" 
      ((inErr :signed-long) (inNotificationType :ostype) (inNotificationParams :pointer) (inRefCon :pointer) (userRoutine :pointer)) 
  :signed-long
   (#x205F #x4E90) )

; 
;  *  InvokeQTSPanelFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib on Mac OS X
;  *    Mac OS X:         in version 10.1 and later
;  
;  old name was CallQTSPanelFilterProc 
(deftrap-inline "_InvokeQTSPanelFilterUPP" 
      ((inParams (:pointer :qtspanelfilterparams)) (inRefCon :pointer) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; 
;  *  InvokeQTSModalFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ;  old name was CallQTSModalFilterProc 
(deftrap-inline "_InvokeQTSModalFilterUPP" 
      ((inDialog (:pointer :grafport)) (inEvent (:pointer :eventrecord)) (ioItemHit (:pointer :signed-integer)) (inRefCon :pointer) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QuickTimeStreamingIncludes

; $ENDC                                         ; __QUICKTIMESTREAMING__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'QuickTimeStreaming)