(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QuickTimeVR.p"
; at Wednesday May 1,2002 2:42:46 pm.
; 
;      File:       QuickTimeVR.p
;  
;      Contains:   QuickTime VR interfaces
;  
;      Version:    Technology: QuickTime VR 5.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1997-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __QUICKTIMEVR__
; $SETC __QUICKTIMEVR__ := 1

; $I+
; $SETC QuickTimeVRIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MOVIES__
|#

(require-interface 'Movies)
#|                                              ; $I Movies.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :qtvrinstance (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :qtvrinstanceptr (find-mactype '(:pointer :pointer)));  when a VAR xx:QTVRInstance parameter can be nil, it is changed to xx: QTVRInstancePtr 

(defconstant $kQTVRControllerSubType :|ctyp|)
(defconstant $kQTVRQTVRType :|qtvr|)
(defconstant $kQTVRPanoramaType :|pano|)
(defconstant $kQTVRObjectType :|obje|)
(defconstant $kQTVROldPanoType :|STpn|)         ;   Used in QTVR 1.0 release 
(defconstant $kQTVROldObjectType :|stna|)       ;   Used in QTVR 1.0 release 

; $IFC TARGET_OS_MAC 
#|                                              ; $ELSEC
 |#                                             ; $ENDC; TARGET_OS_MAC

;   QTVR hot spot types 
(defconstant $kQTVRHotSpotLinkType :|link|)
(defconstant $kQTVRHotSpotURLType :|url |)
(defconstant $kQTVRHotSpotUndefinedType :|undf|)

;   Special Values for nodeID in QTVRGoToNodeID 
(defconstant $kQTVRCurrentNode 0)
(defconstant $kQTVRPreviousNode #x80000000)
(defconstant $kQTVRDefaultNode #x80000001)

;   Panorama correction modes used for the kQTVRImagingCorrection imaging property 
(defconstant $kQTVRNoCorrection 0)
(defconstant $kQTVRPartialCorrection 1)
(defconstant $kQTVRFullCorrection 2)

;   Imaging Modes used by QTVRSetImagingProperty, QTVRGetImagingProperty, QTVRUpdate, QTVRBeginUpdate 

(def-mactype :qtvrimagingmode (find-mactype ':unsigned-long))

(defconstant $kQTVRStatic 1)
(defconstant $kQTVRMotion 2)
(defconstant $kQTVRCurrentMode 0)               ;   Special Value for QTVRUpdate 
(defconstant $kQTVRAllModes 100)                ;   Special value for QTVRSetProperty 

;   Imaging Properties used by QTVRSetImagingProperty, QTVRGetImagingProperty 
(defconstant $kQTVRImagingCorrection 1)
(defconstant $kQTVRImagingQuality 2)
(defconstant $kQTVRImagingDirectDraw 3)
(defconstant $kQTVRImagingCurrentMode 100)      ;   Get Only 

;   OR the above with kImagingDefaultValue to get/set the default value 
(defconstant $kImagingDefaultValue #x80000000)

;   Transition Types used by QTVRSetTransitionProperty, QTVREnableTransition 
(defconstant $kQTVRTransitionSwing 1)

;   Transition Properties QTVRSetTransitionProperty 
(defconstant $kQTVRTransitionSpeed 1)
(defconstant $kQTVRTransitionDirection 2)

;   Constraint values used to construct value returned by GetConstraintStatus 
(defconstant $kQTVRUnconstrained 0)
(defconstant $kQTVRCantPanLeft #x1)
(defconstant $kQTVRCantPanRight #x2)
(defconstant $kQTVRCantPanUp #x4)
(defconstant $kQTVRCantPanDown #x8)
(defconstant $kQTVRCantZoomIn #x10)
(defconstant $kQTVRCantZoomOut #x20)
(defconstant $kQTVRCantTranslateLeft #x40)
(defconstant $kQTVRCantTranslateRight #x80)
(defconstant $kQTVRCantTranslateUp #x100)
(defconstant $kQTVRCantTranslateDown #x200)

;   Object-only mouse mode values used to construct value returned by QTVRGetCurrentMouseMode 
(defconstant $kQTVRPanning #x1)                 ;   standard objects, "object only" controllers 
(defconstant $kQTVRTranslating #x2)             ;   all objects 
(defconstant $kQTVRZooming #x4)                 ;   all objects 
(defconstant $kQTVRScrolling #x8)               ;   standard object arrow scrollers and joystick object 
(defconstant $kQTVRSelecting #x10)              ;   object absolute controller 

;   Properties for use with QTVRSetInteractionProperty/GetInteractionProperty 
(defconstant $kQTVRInteractionMouseClickHysteresis 1);   pixels within which the mouse is considered not to have moved (UInt16) 
(defconstant $kQTVRInteractionMouseClickTimeout 2);   ticks after which a mouse click times out and turns into panning (UInt32) 
(defconstant $kQTVRInteractionPanTiltSpeed 3)   ;   control the relative pan/tilt speed from 1 (slowest) to 10 (fastest). (UInt32) Default is 5; 
(defconstant $kQTVRInteractionZoomSpeed 4)      ;   control the relative zooming speed from 1 (slowest) to 10 (fastest). (UInt32) Default is 5; 
(defconstant $kQTVRInteractionTranslateOnMouseDown 101);   Holding MouseDown with this setting translates zoomed object movies (Boolean) 
(defconstant $kQTVRInteractionMouseMotionScale 102);   The maximum angle of rotation caused by dragging across the display window. (* float) 
(defconstant $kQTVRInteractionNudgeMode 103)    ;   A QTVRNudgeMode: rotate, translate, or the same as the current mouse mode. Requires QTVR 2.1 

;   OR the above with kQTVRInteractionDefaultValue to get/set the default value 
(defconstant $kQTVRInteractionDefaultValue #x80000000)

;   Geometry constants used in QTVRSetBackBufferPrefs, QTVRGetBackBufferSettings, QTVRGetBackBufferMemInfo 
(defconstant $kQTVRUseMovieGeometry 0)
(defconstant $kQTVRVerticalCylinder :|vcyl|)
(defconstant $kQTVRHorizontalCylinder :|hcyl|)
(defconstant $kQTVRCube :|cube|)

;   Resolution constants used in QTVRSetBackBufferPrefs, QTVRGetBackBufferSettings, QTVRGetBackBufferMemInfo 
(defconstant $kQTVRDefaultRes 0)
(defconstant $kQTVRFullRes #x1)
(defconstant $kQTVRHalfRes #x2)
(defconstant $kQTVRQuarterRes #x4)

;   QTVR-specific pixelFormat constants used in QTVRSetBackBufferPrefs, QTVRGetBackBufferSettings, QTVRGetBackBufferMemInfo 
(defconstant $kQTVRUseMovieDepth 0)

;   Cache Size Pref constants used in QTVRSetBackBufferPrefs, QTVRGetBackBufferSettings 
(defconstant $kQTVRMinimumCache -1)
(defconstant $kQTVRSuggestedCache 0)
(defconstant $kQTVRFullCache 1)

;   Angular units used by QTVRSetAngularUnits 

(def-mactype :qtvrangularunits (find-mactype ':unsigned-long))

(defconstant $kQTVRDegrees 0)
(defconstant $kQTVRRadians 1)

;   Values for enableFlag parameter in QTVREnableHotSpot 
(defconstant $kQTVRHotSpotID 0)
(defconstant $kQTVRHotSpotType 1)
(defconstant $kQTVRAllHotSpots 2)

;   Values for viewParameter for QTVRSet/GetViewParameter 
(defconstant $kQTVRPanAngle #x100)              ;   default units; &float, &float 
(defconstant $kQTVRTiltAngle #x101)             ;   default units; &float, &float 
(defconstant $kQTVRFieldOfViewAngle #x103)      ;   default units; &float, &float 
(defconstant $kQTVRViewCenter #x104)            ;   pixels (per object movies); &QTVRFloatPoint, &QTVRFloatPoint 
(defconstant $kQTVRHotSpotsVisible #x200)       ;   Boolean, &Boolean 

;   Values for flagsIn for QTVRSet/GetViewParameter 
(defconstant $kQTVRValueIsRelative #x1)         ;   Is the value absolute or relative to the current value? 
(defconstant $kQTVRValueIsRate #x2)             ;   Is the value absolute or a rate of change to be applied? 
(defconstant $kQTVRValueIsUserPrefRelative #x4) ;   Is the value a percentage of the user rate pref? 

;   Values for kind parameter in QTVRGet/SetConstraints, QTVRGetViewingLimits 
(defconstant $kQTVRPan 0)
(defconstant $kQTVRTilt 1)
(defconstant $kQTVRFieldOfView 2)
(defconstant $kQTVRViewCenterH 4)               ;   WrapAndConstrain only 
(defconstant $kQTVRViewCenterV 5)               ;   WrapAndConstrain only 

;   Values for setting parameter in QTVRSetAnimationSetting, QTVRGetAnimationSetting 

(def-mactype :qtvrobjectanimationsetting (find-mactype ':unsigned-long))

;   View Frame Animation Settings 
(defconstant $kQTVRPalindromeViewFrames 1)
(defconstant $kQTVRStartFirstViewFrame 2)
(defconstant $kQTVRDontLoopViewFrames 3)
(defconstant $kQTVRPlayEveryViewFrame 4)        ;   Requires QTVR 2.1 (kQTVRAPIMajorVersion02 + kQTVRAPIMinorVersion10) 
;   View Animation Settings 
(defconstant $kQTVRSyncViewToFrameRate 16)
(defconstant $kQTVRPalindromeViews 17)
(defconstant $kQTVRPlayStreamingViews 18)       ;   Requires QTVR 2.1 (kQTVRAPIMajorVersion02 + kQTVRAPIMinorVersion10) 

(def-mactype :qtvrcontrolsetting (find-mactype ':unsigned-long))

(defconstant $kQTVRWrapPan 1)
(defconstant $kQTVRWrapTilt 2)
(defconstant $kQTVRCanZoom 3)
(defconstant $kQTVRReverseHControl 4)
(defconstant $kQTVRReverseVControl 5)
(defconstant $kQTVRSwapHVControl 6)
(defconstant $kQTVRTranslation 7)

(def-mactype :qtvrviewstatetype (find-mactype ':unsigned-long))

(defconstant $kQTVRDefault 0)
(defconstant $kQTVRCurrent 2)
(defconstant $kQTVRMouseDown 3)

(def-mactype :qtvrnudgecontrol (find-mactype ':unsigned-long))

(defconstant $kQTVRRight 0)
(defconstant $kQTVRUpRight 45)
(defconstant $kQTVRUp 90)
(defconstant $kQTVRUpLeft 135)
(defconstant $kQTVRLeft 180)
(defconstant $kQTVRDownLeft 225)
(defconstant $kQTVRDown 270)
(defconstant $kQTVRDownRight 315)

(def-mactype :qtvrnudgemode (find-mactype ':unsigned-long))

(defconstant $kQTVRNudgeRotate 0)
(defconstant $kQTVRNudgeTranslate 1)
(defconstant $kQTVRNudgeSameAsMouse 2)

;   Flags to control elements of the QTVR control bar (set via mcActionSetFlags)  
(defconstant $mcFlagQTVRSuppressBackBtn #x10000)
(defconstant $mcFlagQTVRSuppressZoomBtns #x20000)
(defconstant $mcFlagQTVRSuppressHotSpotBtn #x40000)
(defconstant $mcFlagQTVRSuppressTranslateBtn #x80000)
(defconstant $mcFlagQTVRSuppressHelpText #x100000)
(defconstant $mcFlagQTVRSuppressHotSpotNames #x200000)
(defconstant $mcFlagQTVRExplicitFlagSet #x80000000);   bits 0->30 should be interpreted as "explicit on" for the corresponding suppression bits 

;   Cursor types used in type field of QTVRCursorRecord 
(defconstant $kQTVRUseDefaultCursor 0)
(defconstant $kQTVRStdCursorType 1)
(defconstant $kQTVRColorCursorType 2)

;   Values for flags parameter in QTVRMouseOverHotSpot callback 
(defconstant $kQTVRHotSpotEnter 0)
(defconstant $kQTVRHotSpotWithin 1)
(defconstant $kQTVRHotSpotLeave 2)

;   Values for flags parameter in QTVRSetPrescreenImagingCompleteProc 
(defconstant $kQTVRPreScreenEveryIdle #x1)      ;   Requires QTVR 2.1 (kQTVRAPIMajorVersion02 + kQTVRAPIMinorVersion10) 

;   Values for flags field of areasOfInterest in QTVRSetBackBufferImagingProc 
(defconstant $kQTVRBackBufferEveryUpdate #x1)
(defconstant $kQTVRBackBufferEveryIdle #x2)
(defconstant $kQTVRBackBufferAlwaysRefresh #x4)
(defconstant $kQTVRBackBufferHorizontal #x8)    ;   Requires that backbuffer proc be long-rowBytes aware (gestaltQDHasLongRowBytes) 

;   Values for flagsIn parameter in QTVRBackBufferImaging callback 
(defconstant $kQTVRBackBufferRectVisible #x1)
(defconstant $kQTVRBackBufferWasRefreshed #x2)

;   Values for flagsOut parameter in QTVRBackBufferImaging callback 
(defconstant $kQTVRBackBufferFlagDidDraw #x1)
(defconstant $kQTVRBackBufferFlagLastFlag #x80000000)

;   QTVRCursorRecord used in QTVRReplaceCursor 

(def-mactype :qtvrcursorrecordptr (find-mactype '(:pointer :qtvrcursorrecord)))
(defrecord QTVRCursorRecord 
   (theType :unsigned-integer)                  ;   field was previously named "type" 
   (rsrcID :signed-integer)
   (Handle :handle)
   )

(def-mactype :qtvrfloatpointptr (find-mactype '(:pointer :qtvrfloatpoint)))
(defrecord QTVRFloatPoint 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (x :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (y :single-float)
   )

;   Struct used for areasOfInterest parameter in QTVRSetBackBufferImagingProc 
(def-mactype :qtvrareaofinterestptr (find-mactype '(:pointer :qtvrareaofinterest)))
(defrecord QTVRAreaOfInterest 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (panAngle :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (tiltAngle :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (width :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (height :single-float)
   (flags :unsigned-long)
   )

; 
; 	  =================================================================================================
; 	   Callback routines 
; 	  -------------------------------------------------------------------------------------------------
; 	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	QTVRLeavingNodeProcPtr = FUNCTION(qtvr: QTVRInstance; fromNodeID: UInt32; toNodeID: UInt32; VAR cancel: BOOLEAN; refCon: SInt32): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :qtvrleavingnodeprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	QTVREnteringNodeProcPtr = FUNCTION(qtvr: QTVRInstance; nodeID: UInt32; refCon: SInt32): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :qtvrenteringnodeprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	QTVRMouseOverHotSpotProcPtr = FUNCTION(qtvr: QTVRInstance; hotSpotID: UInt32; flags: UInt32; refCon: SInt32): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :qtvrmouseoverhotspotprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	QTVRImagingCompleteProcPtr = FUNCTION(qtvr: QTVRInstance; refCon: SInt32): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :qtvrimagingcompleteprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	QTVRBackBufferImagingProcPtr = FUNCTION(qtvr: QTVRInstance; VAR drawRect: Rect; areaIndex: UInt16; flagsIn: UInt32; VAR flagsOut: UInt32; refCon: SInt32): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :qtvrbackbufferimagingprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :qtvrleavingnodeupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :qtvrleavingnodeupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :qtvrenteringnodeupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :qtvrenteringnodeupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :qtvrmouseoverhotspotupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :qtvrmouseoverhotspotupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :qtvrimagingcompleteupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :qtvrimagingcompleteupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :qtvrbackbufferimagingupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :qtvrbackbufferimagingupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppQTVRLeavingNodeProcInfo #xFFE0)
(defconstant $uppQTVREnteringNodeProcInfo #xFE0)
(defconstant $uppQTVRMouseOverHotSpotProcInfo #x3FE0)
(defconstant $uppQTVRImagingCompleteProcInfo #x3E0)
(defconstant $uppQTVRBackBufferImagingProcInfo #x3FBE0)
; 
; 	 *  NewQTVRLeavingNodeUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewQTVRLeavingNodeProc 
(deftrap "_NewQTVRLeavingNodeUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewQTVREnteringNodeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewQTVREnteringNodeProc 
(deftrap "_NewQTVREnteringNodeUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewQTVRMouseOverHotSpotUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewQTVRMouseOverHotSpotProc 
(deftrap "_NewQTVRMouseOverHotSpotUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewQTVRImagingCompleteUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewQTVRImagingCompleteProc 
(deftrap "_NewQTVRImagingCompleteUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewQTVRBackBufferImagingUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewQTVRBackBufferImagingProc 
(deftrap "_NewQTVRBackBufferImagingUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeQTVRLeavingNodeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeQTVRLeavingNodeUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeQTVREnteringNodeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeQTVREnteringNodeUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeQTVRMouseOverHotSpotUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeQTVRMouseOverHotSpotUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeQTVRImagingCompleteUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeQTVRImagingCompleteUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeQTVRBackBufferImagingUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeQTVRBackBufferImagingUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeQTVRLeavingNodeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallQTVRLeavingNodeProc 
(deftrap-inline "_InvokeQTVRLeavingNodeUPP" 
      ((qtvr :pointer) (fromNodeID :unsigned-long) (toNodeID :unsigned-long) (cancel (:pointer :boolean)) (refCon :signed-long) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeQTVREnteringNodeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallQTVREnteringNodeProc 
(deftrap-inline "_InvokeQTVREnteringNodeUPP" 
      ((qtvr :pointer) (nodeID :unsigned-long) (refCon :signed-long) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeQTVRMouseOverHotSpotUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallQTVRMouseOverHotSpotProc 
(deftrap-inline "_InvokeQTVRMouseOverHotSpotUPP" 
      ((qtvr :pointer) (hotSpotID :unsigned-long) (flags :unsigned-long) (refCon :signed-long) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeQTVRImagingCompleteUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallQTVRImagingCompleteProc 
(deftrap-inline "_InvokeQTVRImagingCompleteUPP" 
      ((qtvr :pointer) (refCon :signed-long) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeQTVRBackBufferImagingUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallQTVRBackBufferImagingProc 
(deftrap-inline "_InvokeQTVRBackBufferImagingUPP" 
      ((qtvr :pointer) (drawRect (:pointer :rect)) (areaIndex :unsigned-integer) (flagsIn :unsigned-long) (flagsOut (:pointer :unsigned-long)) (refCon :signed-long) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;   =================================================================================================
;     QTVR Intercept Struct, Callback, Routine Descriptors 
;   -------------------------------------------------------------------------------------------------
; 

(def-mactype :qtvrprocselector (find-mactype ':unsigned-long))

(defconstant $kQTVRSetPanAngleSelector #x2000)
(defconstant $kQTVRSetTiltAngleSelector #x2001)
(defconstant $kQTVRSetFieldOfViewSelector #x2002)
(defconstant $kQTVRSetViewCenterSelector #x2003)
(defconstant $kQTVRMouseEnterSelector #x2004)
(defconstant $kQTVRMouseWithinSelector #x2005)
(defconstant $kQTVRMouseLeaveSelector #x2006)
(defconstant $kQTVRMouseDownSelector #x2007)
(defconstant $kQTVRMouseStillDownSelector #x2008)
(defconstant $kQTVRMouseUpSelector #x2009)
(defconstant $kQTVRTriggerHotSpotSelector #x200A)
(defconstant $kQTVRGetHotSpotTypeSelector #x200B);   Requires QTVR 2.1 (kQTVRAPIMajorVersion02 + kQTVRAPIMinorVersion10) 
(defconstant $kQTVRSetViewParameterSelector #x200C);   Requires QTVR 5.0 (kQTVRAPIMajorVersion05 + kQTVRAPIMinorVersion00) 
(defconstant $kQTVRGetViewParameterSelector #x200D);   Requires QTVR 5.0 (kQTVRAPIMajorVersion05 + kQTVRAPIMinorVersion00) 

(def-mactype :qtvrinterceptrecordptr (find-mactype '(:pointer :qtvrinterceptrecord)))
(defrecord QTVRInterceptRecord 
   (reserved1 :signed-long)
   (selector :signed-long)
   (reserved2 :signed-long)
   (reserved3 :signed-long)
   (paramCount :signed-long)
   (parameter (:array :pointer 6))
   )

(def-mactype :qtvrinterceptptr (find-mactype '(:pointer :qtvrinterceptrecord)))
;   Prototype for Intercept Proc callback 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	QTVRInterceptProcPtr = PROCEDURE(qtvr: QTVRInstance; qtvrMsg: QTVRInterceptPtr; refCon: SInt32; VAR cancel: BOOLEAN);

|#
 |#                                             ; $ELSEC
(def-mactype :qtvrinterceptprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :qtvrinterceptupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :qtvrinterceptupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppQTVRInterceptProcInfo #x3FC0)
; 
; 	 *  NewQTVRInterceptUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewQTVRInterceptProc 
(deftrap "_NewQTVRInterceptUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeQTVRInterceptUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeQTVRInterceptUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeQTVRInterceptUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallQTVRInterceptProc 
(deftrap-inline "_InvokeQTVRInterceptUPP" 
      ((qtvr :pointer) (qtvrMsg (:pointer :qtvrinterceptrecord)) (refCon :signed-long) (cancel (:pointer :boolean)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;   =================================================================================================
;     Initialization QTVR calls 
;   -------------------------------------------------------------------------------------------------
;    Requires QTVR 2.1 (kQTVRAPIMajorVersion02 + kQTVRAPIMinorVersion10) and only work on Non-Macintosh platforms
; 
#|                                              ; $IFC NOT TARGET_OS_MAC 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  InitializeQTVR()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_InitializeQTVR" 
      () 
  :signed-integer
   () )

; 
;  *  TerminateQTVR()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_TerminateQTVR" 
      () 
  :signed-integer
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC

; 
;   =================================================================================================
;     General QTVR calls 
;   -------------------------------------------------------------------------------------------------
; 
; 
;  *  QTVRGetQTVRTrack()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetQTVRTrack" 
      ((theMovie (:pointer :movierecord)) (index :signed-long)) 
  (:pointer :trackrecord)
   () )

; 
;  *  QTVRGetQTVRInstance()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetQTVRInstance" 
      ((qtvr (:pointer :pointer)) (qtvrTrack (:pointer :trackrecord)) (mc (:pointer :componentinstancerecord))) 
  :signed-integer
   () )

; 
;   =================================================================================================
;     Viewing Angles and Zooming 
;   -------------------------------------------------------------------------------------------------
; 

;   QTVRSetViewParameter requires QTVR 5.0 (kQTVRAPIMajorVersion05 + kQTVRAPIMinorVersion00) 
; 
;  *  QTVRSetViewParameter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 5.0 and later
;  

(deftrap-inline "_QTVRSetViewParameter" 
      ((qtvr :pointer) (viewParameter :unsigned-long) (value :pointer) (flagsIn :unsigned-long)) 
  :signed-integer
   () )

;   QTVRGetViewParameter requires QTVR 5.0 (kQTVRAPIMajorVersion05 + kQTVRAPIMinorVersion00) 
; 
;  *  QTVRGetViewParameter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 5.0 and later
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 5.0 and later
;  

(deftrap-inline "_QTVRGetViewParameter" 
      ((qtvr :pointer) (viewParameter :unsigned-long) (value :pointer) (flagsIn :unsigned-long) (flagsOut (:pointer :unsigned-long))) 
  :signed-integer
   () )

; 
;  *  QTVRSetPanAngle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRSetPanAngle" 
      ((qtvr :pointer) (panAngle :single-float)) 
  :signed-integer
   () )

; 
;  *  QTVRGetPanAngle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetPanAngle" 
      ((qtvr :pointer)) 
  :single-float
   () )

; 
;  *  QTVRSetTiltAngle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRSetTiltAngle" 
      ((qtvr :pointer) (tiltAngle :single-float)) 
  :signed-integer
   () )

; 
;  *  QTVRGetTiltAngle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetTiltAngle" 
      ((qtvr :pointer)) 
  :single-float
   () )

; 
;  *  QTVRSetFieldOfView()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRSetFieldOfView" 
      ((qtvr :pointer) (fieldOfView :single-float)) 
  :signed-integer
   () )

; 
;  *  QTVRGetFieldOfView()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetFieldOfView" 
      ((qtvr :pointer)) 
  :single-float
   () )

; 
;  *  QTVRShowDefaultView()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRShowDefaultView" 
      ((qtvr :pointer)) 
  :signed-integer
   () )

;   Object Specific 
; 
;  *  QTVRSetViewCenter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  
; CONST
(deftrap-inline "_QTVRSetViewCenter" 
      ((qtvr :pointer) (viewCenter (:pointer :qtvrfloatpoint))) 
  :signed-integer
   () )

; 
;  *  QTVRGetViewCenter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetViewCenter" 
      ((qtvr :pointer) (viewCenter (:pointer :qtvrfloatpoint))) 
  :signed-integer
   () )

; 
;  *  QTVRNudge()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRNudge" 
      ((qtvr :pointer) (direction :unsigned-long)) 
  :signed-integer
   () )

;   QTVRInteractionNudge requires QTVR 2.1 (kQTVRAPIMajorVersion02 + kQTVRAPIMinorVersion10) 
; 
;  *  QTVRInteractionNudge()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRInteractionNudge" 
      ((qtvr :pointer) (direction :unsigned-long)) 
  :signed-integer
   () )

; 
;   =================================================================================================
;     Scene and Node Location Information 
;   -------------------------------------------------------------------------------------------------
; 

; 
;  *  QTVRGetVRWorld()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetVRWorld" 
      ((qtvr :pointer) (VRWorld (:pointer :handle))) 
  :signed-integer
   () )

; 
;  *  QTVRGetNodeInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetNodeInfo" 
      ((qtvr :pointer) (nodeID :unsigned-long) (nodeInfo (:pointer :handle))) 
  :signed-integer
   () )

; 
;  *  QTVRGoToNodeID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGoToNodeID" 
      ((qtvr :pointer) (nodeID :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  QTVRGetCurrentNodeID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetCurrentNodeID" 
      ((qtvr :pointer)) 
  :unsigned-long
   () )

; 
;  *  QTVRGetNodeType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetNodeType" 
      ((qtvr :pointer) (nodeID :unsigned-long)) 
  :ostype
   () )

; 
;   =================================================================================================
;     Hot Spot related calls 
;   -------------------------------------------------------------------------------------------------
; 

; 
;  *  QTVRPtToHotSpotID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRPtToHotSpotID" 
      ((qtvr :pointer) (pt :point) (hotSpotID (:pointer :unsigned-long))) 
  :signed-integer
   () )

;   QTVRGetHotSpotType requires QTVR 2.1 (kQTVRAPIMajorVersion02 + kQTVRAPIMinorVersion10) 
; 
;  *  QTVRGetHotSpotType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetHotSpotType" 
      ((qtvr :pointer) (hotSpotID :unsigned-long) (hotSpotType (:pointer :ostype))) 
  :signed-integer
   () )

; 
;  *  QTVRTriggerHotSpot()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRTriggerHotSpot" 
      ((qtvr :pointer) (hotSpotID :unsigned-long) (nodeInfo :handle) (selectedAtom :signed-long)) 
  :signed-integer
   () )

; 
;  *  QTVRSetMouseOverHotSpotProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRSetMouseOverHotSpotProc" 
      ((qtvr :pointer) (mouseOverHotSpotProc :pointer) (refCon :signed-long) (flags :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  QTVREnableHotSpot()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVREnableHotSpot" 
      ((qtvr :pointer) (enableFlag :unsigned-long) (hotSpotValue :unsigned-long) (enable :boolean)) 
  :signed-integer
   () )

; 
;  *  QTVRGetVisibleHotSpots()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetVisibleHotSpots" 
      ((qtvr :pointer) (hotSpots :handle)) 
  :unsigned-long
   () )

; 
;  *  QTVRGetHotSpotRegion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetHotSpotRegion" 
      ((qtvr :pointer) (hotSpotID :unsigned-long) (hotSpotRegion (:handle :macregion))) 
  :signed-integer
   () )

; 
;   =================================================================================================
;     Event & Cursor Handling Calls 
;   -------------------------------------------------------------------------------------------------
; 

; 
;  *  QTVRSetMouseOverTracking()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRSetMouseOverTracking" 
      ((qtvr :pointer) (enable :boolean)) 
  :signed-integer
   () )

; 
;  *  QTVRGetMouseOverTracking()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetMouseOverTracking" 
      ((qtvr :pointer)) 
  :boolean
   () )

; 
;  *  QTVRSetMouseDownTracking()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRSetMouseDownTracking" 
      ((qtvr :pointer) (enable :boolean)) 
  :signed-integer
   () )

; 
;  *  QTVRGetMouseDownTracking()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetMouseDownTracking" 
      ((qtvr :pointer)) 
  :boolean
   () )

; 
;  *  QTVRMouseEnter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRMouseEnter" 
      ((qtvr :pointer) (pt :point) (hotSpotID (:pointer :unsigned-long)) (w (:pointer :windowrecord))) 
  :signed-integer
   () )

; 
;  *  QTVRMouseWithin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRMouseWithin" 
      ((qtvr :pointer) (pt :point) (hotSpotID (:pointer :unsigned-long)) (w (:pointer :windowrecord))) 
  :signed-integer
   () )

; 
;  *  QTVRMouseLeave()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRMouseLeave" 
      ((qtvr :pointer) (pt :point) (w (:pointer :windowrecord))) 
  :signed-integer
   () )

; 
;  *  QTVRMouseDown()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRMouseDown" 
      ((qtvr :pointer) (pt :point) (when :unsigned-long) (modifiers :unsigned-integer) (hotSpotID (:pointer :unsigned-long)) (w (:pointer :windowrecord))) 
  :signed-integer
   () )

; 
;  *  QTVRMouseStillDown()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRMouseStillDown" 
      ((qtvr :pointer) (pt :point) (hotSpotID (:pointer :unsigned-long)) (w (:pointer :windowrecord))) 
  :signed-integer
   () )

; 
;  *  QTVRMouseUp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRMouseUp" 
      ((qtvr :pointer) (pt :point) (hotSpotID (:pointer :unsigned-long)) (w (:pointer :windowrecord))) 
  :signed-integer
   () )

;   These require QTVR 2.01 (kQTVRAPIMajorVersion02 + kQTVRAPIMinorVersion01) 
; 
;  *  QTVRMouseStillDownExtended()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRMouseStillDownExtended" 
      ((qtvr :pointer) (pt :point) (hotSpotID (:pointer :unsigned-long)) (w (:pointer :windowrecord)) (when :unsigned-long) (modifiers :unsigned-integer)) 
  :signed-integer
   () )

; 
;  *  QTVRMouseUpExtended()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRMouseUpExtended" 
      ((qtvr :pointer) (pt :point) (hotSpotID (:pointer :unsigned-long)) (w (:pointer :windowrecord)) (when :unsigned-long) (modifiers :unsigned-integer)) 
  :signed-integer
   () )

; 
;   =================================================================================================
;     Intercept Routines 
;   -------------------------------------------------------------------------------------------------
; 

; 
;  *  QTVRInstallInterceptProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRInstallInterceptProc" 
      ((qtvr :pointer) (selector :unsigned-long) (interceptProc :pointer) (refCon :signed-long) (flags :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  QTVRCallInterceptedProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRCallInterceptedProc" 
      ((qtvr :pointer) (qtvrMsg (:pointer :qtvrinterceptrecord))) 
  :signed-integer
   () )

; 
;   =================================================================================================
;     Object Movie Specific Calls 
;   -------------------------------------------------------------------------------------------------
;    QTVRGetCurrentMouseMode requires QTRVR 2.1 (kQTVRAPIMajorVersion02 + kQTVRAPIMinorVersion10)
; 
; 
;  *  QTVRGetCurrentMouseMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetCurrentMouseMode" 
      ((qtvr :pointer)) 
  :unsigned-long
   () )

; 
;  *  QTVRSetFrameRate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRSetFrameRate" 
      ((qtvr :pointer) (rate :single-float)) 
  :signed-integer
   () )

; 
;  *  QTVRGetFrameRate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetFrameRate" 
      ((qtvr :pointer)) 
  :single-float
   () )

; 
;  *  QTVRSetViewRate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRSetViewRate" 
      ((qtvr :pointer) (rate :single-float)) 
  :signed-integer
   () )

; 
;  *  QTVRGetViewRate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetViewRate" 
      ((qtvr :pointer)) 
  :single-float
   () )

; 
;  *  QTVRSetViewCurrentTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRSetViewCurrentTime" 
      ((qtvr :pointer) (time :signed-long)) 
  :signed-integer
   () )

; 
;  *  QTVRGetViewCurrentTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetViewCurrentTime" 
      ((qtvr :pointer)) 
  :timevalue
   () )

; 
;  *  QTVRGetCurrentViewDuration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetCurrentViewDuration" 
      ((qtvr :pointer)) 
  :timevalue
   () )

; 
;   =================================================================================================
;    View State Calls - QTVR Object Only
;   -------------------------------------------------------------------------------------------------
; 

; 
;  *  QTVRSetViewState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRSetViewState" 
      ((qtvr :pointer) (viewStateType :unsigned-long) (state :unsigned-integer)) 
  :signed-integer
   () )

; 
;  *  QTVRGetViewState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetViewState" 
      ((qtvr :pointer) (viewStateType :unsigned-long) (state (:pointer :unsigned-integer))) 
  :signed-integer
   () )

; 
;  *  QTVRGetViewStateCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetViewStateCount" 
      ((qtvr :pointer)) 
  :unsigned-integer
   () )

; 
;  *  QTVRSetAnimationSetting()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRSetAnimationSetting" 
      ((qtvr :pointer) (setting :unsigned-long) (enable :boolean)) 
  :signed-integer
   () )

; 
;  *  QTVRGetAnimationSetting()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetAnimationSetting" 
      ((qtvr :pointer) (setting :unsigned-long) (enable (:pointer :boolean))) 
  :signed-integer
   () )

; 
;  *  QTVRSetControlSetting()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRSetControlSetting" 
      ((qtvr :pointer) (setting :unsigned-long) (enable :boolean)) 
  :signed-integer
   () )

; 
;  *  QTVRGetControlSetting()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetControlSetting" 
      ((qtvr :pointer) (setting :unsigned-long) (enable (:pointer :boolean))) 
  :signed-integer
   () )

; 
;  *  QTVREnableFrameAnimation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVREnableFrameAnimation" 
      ((qtvr :pointer) (enable :boolean)) 
  :signed-integer
   () )

; 
;  *  QTVRGetFrameAnimation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetFrameAnimation" 
      ((qtvr :pointer)) 
  :boolean
   () )

; 
;  *  QTVREnableViewAnimation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVREnableViewAnimation" 
      ((qtvr :pointer) (enable :boolean)) 
  :signed-integer
   () )

; 
;  *  QTVRGetViewAnimation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetViewAnimation" 
      ((qtvr :pointer)) 
  :boolean
   () )

; 
;   =================================================================================================
;     Imaging Characteristics 
;   -------------------------------------------------------------------------------------------------
; 

; 
;  *  QTVRSetVisible()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRSetVisible" 
      ((qtvr :pointer) (visible :boolean)) 
  :signed-integer
   () )

; 
;  *  QTVRGetVisible()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetVisible" 
      ((qtvr :pointer)) 
  :boolean
   () )

; 
;  *  QTVRSetImagingProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRSetImagingProperty" 
      ((qtvr :pointer) (imagingMode :unsigned-long) (imagingProperty :unsigned-long) (propertyValue :signed-long)) 
  :signed-integer
   () )

; 
;  *  QTVRGetImagingProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetImagingProperty" 
      ((qtvr :pointer) (imagingMode :unsigned-long) (imagingProperty :unsigned-long) (propertyValue (:pointer :signed-long))) 
  :signed-integer
   () )

; 
;  *  QTVRUpdate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRUpdate" 
      ((qtvr :pointer) (imagingMode :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  QTVRBeginUpdateStream()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRBeginUpdateStream" 
      ((qtvr :pointer) (imagingMode :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  QTVREndUpdateStream()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVREndUpdateStream" 
      ((qtvr :pointer)) 
  :signed-integer
   () )

; 
;  *  QTVRSetTransitionProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRSetTransitionProperty" 
      ((qtvr :pointer) (transitionType :unsigned-long) (transitionProperty :unsigned-long) (transitionValue :signed-long)) 
  :signed-integer
   () )

; 
;  *  QTVREnableTransition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVREnableTransition" 
      ((qtvr :pointer) (transitionType :unsigned-long) (enable :boolean)) 
  :signed-integer
   () )

; 
;   =================================================================================================
;     Basic Conversion and Math Routines 
;   -------------------------------------------------------------------------------------------------
; 

; 
;  *  QTVRSetAngularUnits()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRSetAngularUnits" 
      ((qtvr :pointer) (units :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  QTVRGetAngularUnits()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetAngularUnits" 
      ((qtvr :pointer)) 
  :unsigned-long
   () )

;   Pano specific routines 
; 
;  *  QTVRPtToAngles()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRPtToAngles" 
      ((qtvr :pointer) (pt :point) (panAngle (:pointer :single-float)) (tiltAngle (:pointer :single-float))) 
  :signed-integer
   () )

; 
;  *  QTVRCoordToAngles()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRCoordToAngles" 
      ((qtvr :pointer) (coord (:pointer :qtvrfloatpoint)) (panAngle (:pointer :single-float)) (tiltAngle (:pointer :single-float))) 
  :signed-integer
   () )

; 
;  *  QTVRAnglesToCoord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRAnglesToCoord" 
      ((qtvr :pointer) (panAngle :single-float) (tiltAngle :single-float) (coord (:pointer :qtvrfloatpoint))) 
  :signed-integer
   () )

;   Object specific routines 
; 
;  *  QTVRPanToColumn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRPanToColumn" 
      ((qtvr :pointer) (panAngle :single-float)) 
  :signed-integer
   () )

;   zero based    
; 
;  *  QTVRColumnToPan()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRColumnToPan" 
      ((qtvr :pointer) (column :signed-integer)) 
  :single-float
   () )

;   zero based    
; 
;  *  QTVRTiltToRow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRTiltToRow" 
      ((qtvr :pointer) (tiltAngle :single-float)) 
  :signed-integer
   () )

;   zero based    
; 
;  *  QTVRRowToTilt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRRowToTilt" 
      ((qtvr :pointer) (row :signed-integer)) 
  :single-float
   () )

;   zero based                
; 
;  *  QTVRWrapAndConstrain()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRWrapAndConstrain" 
      ((qtvr :pointer) (kind :signed-integer) (value :single-float) (result (:pointer :single-float))) 
  :signed-integer
   () )

; 
;   =================================================================================================
;     Interaction Routines 
;   -------------------------------------------------------------------------------------------------
; 

; 
;  *  QTVRSetEnteringNodeProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRSetEnteringNodeProc" 
      ((qtvr :pointer) (enteringNodeProc :pointer) (refCon :signed-long) (flags :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  QTVRSetLeavingNodeProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRSetLeavingNodeProc" 
      ((qtvr :pointer) (leavingNodeProc :pointer) (refCon :signed-long) (flags :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  QTVRSetInteractionProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRSetInteractionProperty" 
      ((qtvr :pointer) (property :unsigned-long) (value :pointer)) 
  :signed-integer
   () )

; 
;  *  QTVRGetInteractionProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetInteractionProperty" 
      ((qtvr :pointer) (property :unsigned-long) (value :pointer)) 
  :signed-integer
   () )

; 
;  *  QTVRReplaceCursor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRReplaceCursor" 
      ((qtvr :pointer) (cursRecord (:pointer :qtvrcursorrecord))) 
  :signed-integer
   () )

; 
;   =================================================================================================
;     Viewing Limits and Constraints 
;   -------------------------------------------------------------------------------------------------
; 

; 
;  *  QTVRGetViewingLimits()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetViewingLimits" 
      ((qtvr :pointer) (kind :unsigned-integer) (minValue (:pointer :single-float)) (maxValue (:pointer :single-float))) 
  :signed-integer
   () )

; 
;  *  QTVRGetConstraintStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetConstraintStatus" 
      ((qtvr :pointer)) 
  :unsigned-long
   () )

; 
;  *  QTVRGetConstraints()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetConstraints" 
      ((qtvr :pointer) (kind :unsigned-integer) (minValue (:pointer :single-float)) (maxValue (:pointer :single-float))) 
  :signed-integer
   () )

; 
;  *  QTVRSetConstraints()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRSetConstraints" 
      ((qtvr :pointer) (kind :unsigned-integer) (minValue :single-float) (maxValue :single-float)) 
  :signed-integer
   () )

; 
;   =================================================================================================
;     Back Buffer Memory Management 
;   -------------------------------------------------------------------------------------------------
; 

; 
;  *  QTVRGetAvailableResolutions()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetAvailableResolutions" 
      ((qtvr :pointer) (resolutionsMask (:pointer :unsigned-integer))) 
  :signed-integer
   () )

;   These require QTVR 2.1 (kQTVRAPIMajorVersion02 + kQTVRAPIMinorVersion10) 
; 
;  *  QTVRGetBackBufferMemInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetBackBufferMemInfo" 
      ((qtvr :pointer) (geometry :unsigned-long) (resolution :unsigned-integer) (cachePixelFormat :unsigned-long) (minCacheBytes (:pointer :signed-long)) (suggestedCacheBytes (:pointer :signed-long)) (fullCacheBytes (:pointer :signed-long))) 
  :signed-integer
   () )

; 
;  *  QTVRGetBackBufferSettings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRGetBackBufferSettings" 
      ((qtvr :pointer) (geometry (:pointer :unsigned-long)) (resolution (:pointer :unsigned-integer)) (cachePixelFormat (:pointer :unsigned-long)) (cacheSize (:pointer :signed-integer))) 
  :signed-integer
   () )

; 
;  *  QTVRSetBackBufferPrefs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRSetBackBufferPrefs" 
      ((qtvr :pointer) (geometry :unsigned-long) (resolution :unsigned-integer) (cachePixelFormat :unsigned-long) (cacheSize :signed-integer)) 
  :signed-integer
   () )

; 
;   =================================================================================================
;     Buffer Access 
;   -------------------------------------------------------------------------------------------------
; 

; 
;  *  QTVRSetPrescreenImagingCompleteProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRSetPrescreenImagingCompleteProc" 
      ((qtvr :pointer) (imagingCompleteProc :pointer) (refCon :signed-long) (flags :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  QTVRSetBackBufferImagingProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRSetBackBufferImagingProc" 
      ((qtvr :pointer) (backBufferImagingProc :pointer) (numAreas :unsigned-integer) (areasOfInterest (:pointer :qtvrareaofinterest)) (refCon :signed-long)) 
  :signed-integer
   () )

; 
;  *  QTVRRefreshBackBuffer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeVRLib 2.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in QTVR.lib 2.1 and later
;  

(deftrap-inline "_QTVRRefreshBackBuffer" 
      ((qtvr :pointer) (flags :unsigned-long)) 
  :signed-integer
   () )

; 
;   =================================================================================================
;     Old Names
;   -------------------------------------------------------------------------------------------------
; 
; $IFC OLDROUTINENAMES 

(%define-record :cursorrecord (find-record-descriptor :qtvrcursorrecord))
(def-mactype :cursorrecordptr (find-mactype '(:pointer :qtvrcursorrecord)))
(%define-record :areaofinterest (find-record-descriptor :qtvrareaofinterest))
(def-mactype :areaofinterestptr (find-mactype '(:pointer :qtvrareaofinterest)))
(%define-record :floatpoint (find-record-descriptor :qtvrfloatpoint))
(def-mactype :floatpointptr (find-mactype '(:pointer :qtvrfloatpoint)))
(def-mactype :leavingnodeprocptr (find-mactype ':pointer))
(def-mactype :leavingnodeupp (find-mactype ':pointer))
(def-mactype :enteringnodeprocptr (find-mactype ':pointer))
(def-mactype :enteringnodeupp (find-mactype ':pointer))
(def-mactype :mouseoverhotspotprocptr (find-mactype ':pointer))
(def-mactype :mouseoverhotspotupp (find-mactype ':pointer))
(def-mactype :imagingcompleteprocptr (find-mactype ':pointer))
(def-mactype :imagingcompleteupp (find-mactype ':pointer))
(def-mactype :backbufferimagingprocptr (find-mactype ':pointer))
(def-mactype :backbufferimagingupp (find-mactype ':pointer))
; $ENDC                                         ; OLDROUTINENAMES

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QuickTimeVRIncludes

; $ENDC                                         ; __QUICKTIMEVR__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'QuickTimeVR)