(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:RAVE.p"
; at Wednesday May 1,2002 2:42:36 pm.
; 
;      File:       RAVE.p
;  
;      Contains:   Interface for RAVE (Renderer Acceleration Virtual Engine)
;  
;      Version:    Technology: Quickdraw 3D 1.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __RAVE__
; $SETC __RAVE__ := 1

; $I+
; $SETC RAVEIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC

; $IFC TARGET_OS_MAC 
#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QDOFFSCREEN__
|#

(require-interface 'QDOffscreen)
#|                                              ; $I QDOffscreen.p
 |#                                             ; $ENDC

; $ENDC                                         ; TARGET_OS_MAC

#|                                              ; $IFC TARGET_OS_WIN32 
; $IFC UNDEFINED RAVE_NO_DIRECTDRAW 
; $ENDC
 |#                                             ; $ENDC; TARGET_OS_WIN32

; $PUSH
; $ALIGN POWER
; $LibExport+

; $SETC RAVE_OBSOLETE := 0 
; *****************************************************************************
;  *
;  * Platform dependent datatypes: TQAImagePixelType, TQADevice, TQAClip, and TQARect.
;  *
;  ****************************************************************************

(def-mactype :tqaimagepixeltype (find-mactype ':signed-long))

(defconstant $kQAPixel_Alpha1 0)                ;   1 bit/pixel alpha  
(defconstant $kQAPixel_RGB16 1)                 ;   16 bits/pixel, R=14:10, G=9:5, B=4:0  
(defconstant $kQAPixel_ARGB16 2)                ;   16 bits/pixel, A=15, R=14:10, G=9:5, B=4:0  
(defconstant $kQAPixel_RGB32 3)                 ;   32 bits/pixel, R=23:16, G=15:8, B=7:0  
(defconstant $kQAPixel_ARGB32 4)                ;   32 bits/pixel, A=31:24, R=23:16, G=15:8, B=7:0  
(defconstant $kQAPixel_CL4 5)                   ;   4 bit color look up table, always big endian, ie high 4 bits effect left pixel  
(defconstant $kQAPixel_CL8 6)                   ;   8 bit color look up table  
(defconstant $kQAPixel_RGB16_565 7)             ;   Win32 ONLY  16 bits/pixel, no alpha, R:5, G:6, B:5  
(defconstant $kQAPixel_RGB24 8)                 ;   Win32 ONLY  24 bits/pixel, no alpha, R:8, G:8, B:8  
(defconstant $kQAPixel_RGB8_332 9)              ;   8 bits/pixel, R=7:5, G = 4:2, B = 1:0  
(defconstant $kQAPixel_ARGB16_4444 10)          ;   16 bits/pixel, A=15:12, R=11:8, G=7:4, B=3:0  
(defconstant $kQAPixel_ACL16_88 11)             ;   16 bits/pixel, A=15:8, CL=7:0, 8 bit alpha + 8 bit color lookup  
(defconstant $kQAPixel_I8 12)                   ;   8 bits/pixel, I=7:0, intensity map (grayscale)  
(defconstant $kQAPixel_AI16_88 13)              ;   16 bits/pixel, A=15:8, I=7:0, intensity map (grayscale)  
(defconstant $kQAPixel_YUVS 14)                 ;   16 bits/pixel, QD's kYUVSPixelFormat (4:2:2, YUYV ordering, unsigned UV)  
(defconstant $kQAPixel_YUVU 15)                 ;   16 bits/pixel, QD's kYUVUPixelFormat (4:2:2, YUYV ordering, signed UV)  
(defconstant $kQAPixel_YVYU422 16)              ;   16 bits/pixel, QD's kYVYU422PixelFormat (4:2:2, YVYU ordering, unsigned UV)  
(defconstant $kQAPixel_UYVY422 17)              ;   16 bits/pixel, QD's kUYVY422PixelFormat (4:2:2, UYVY ordering, unsigned UV)  

(def-mactype :tqacolortabletype (find-mactype ':signed-long))

(defconstant $kQAColorTable_CL8_RGB32 0)        ;   256 entry, 32 bit/pixel, R=23:16, G=15:8, B=7:0  
(defconstant $kQAColorTable_CL4_RGB32 1)        ;   16 entry, 32 bit/pixel, R=23:16, G=15:8, B=7:0  

; 	 Selects target device type 	

(def-mactype :tqadevicetype (find-mactype ':signed-long))

(defconstant $kQADeviceMemory 0)                ;   Memory draw context  
(defconstant $kQADeviceGDevice 1)               ;   Macintosh GDevice draw context  
(defconstant $kQADeviceWin32DC 2)               ;   Win32 DC  
(defconstant $kQADeviceDDSurface 3)             ;   Win32 DirectDraw Surface  

; 	 Generic memory pixmap device 	

(def-mactype :tqadevicememoryptr (find-mactype '(:pointer :tqadevicememory)))
(defrecord TQADeviceMemory 
   (rowBytes :signed-long)                      ;   Rowbytes  
   (pixelType :signed-long)                     ;   Depth, color space, etc.  
   (width :signed-long)                         ;   Width in pixels  
   (height :signed-long)                        ;   Height in pixels  
   (baseAddr :pointer)                          ;   Base address of pixmap  
   )

; 	 Offscreen Device 	
(def-mactype :tqadeviceoffscreenptr (find-mactype '(:pointer :tqadeviceoffscreen)))
(defrecord TQADeviceOffscreen 
   (pixelType :signed-long)                     ;   Depth, color space, etc.  
   )

; 	 Selects target clip type 	
(def-mactype :tqacliptype (find-mactype ':signed-long))

(defconstant $kQAClipRgn 0)                     ;   Macintosh clipRgn with serial number  
(defconstant $kQAClipWin32Rgn 1)                ;   Win32 clip region  

(def-mactype :tqarectptr (find-mactype '(:pointer :tqarect)))
(defrecord TQARect 
   (left :signed-long)
   (right :signed-long)
   (top :signed-long)
   (bottom :signed-long)
   )

; $IFC TARGET_OS_MAC 
(def-mactype :tqaplatformdeviceptr (find-mactype '(:pointer :tqaplatformdevice)))
(defrecord TQAPlatformDevice 
   (:variant 
      (
      (memoryDevice :tqadevicememory)
      )
      (
      (gDevice (:handle :gdevice))
      )
      )
   )

(def-mactype :tqaplatformclipptr (find-mactype '(:pointer :tqaplatformclip)))
(defrecord TQAPlatformClip 
   (:variant 
      (
      (clipRgn (:handle :macregion))
      )
      )
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQADrawNotificationProcPtr = PROCEDURE(left: INTEGER; top: INTEGER; right: INTEGER; bottom: INTEGER; refCon: LONGINT);

|#
 |#                                             ; $ELSEC
(def-mactype :tqadrawnotificationprocptr (find-mactype ':pointer))
; $ENDC

(def-mactype :tqadrawnotificationprocrefnum (find-mactype ':signed-long))
; 	 used to unregister your proc 	
#|                                              ; $ELSEC
; $IFC TARGET_OS_WIN32 
; $ELSEC
; 	
; 	     * Generic platform supports memory device only. TQARect is generic. TQAClip is ???.
; 	     	
(defrecord TQAPlatformDevice 
   (:variant 
      (
      (memoryDevice :tqadevicememory)
      )
      )
   )

(defrecord TQAPlatformClip 
   (:variant 
      (
      (region :pointer)                         ;   ???  
      )
      )
   )

; $ENDC
 |#                                             ; $ENDC

(def-mactype :tqadeviceptr (find-mactype '(:pointer :tqadevice)))
(defrecord TQADevice 
   (deviceType :signed-long)
   (device :tqaplatformdevice)
   )

(def-mactype :tqaclipptr (find-mactype '(:pointer :tqaclip)))
(defrecord TQAClip 
   (clipType :signed-long)
   (clip :tqaplatformclip)
   )

; 	*****************************************************************************
; 	 *
; 	 * Basic data types.
; 	 *
; 	 ****************************************************************************	

(def-mactype :tqaengine (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :tqaengineptr (find-mactype '(:pointer :pointer)));  when a VAR xx:TQAEngine parameter can be nil, it is changed to xx: TQAEnginePtr 
#|
; Warning: Type TQAEnginePtr multiply defined: old (from OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:RAVE.p) is (:pointer :pointer); ignoring new definition of pointer
|#
#| 
(def-mactype :tqaengineptr (find-mactype ':pointer)) |#;  an opaque 32-bit type 
(def-mactype :tqaengineptrptr (find-mactype '(:handle :pointer)));  when a VAR xx:TQAEnginePtr parameter can be nil, it is changed to xx: TQAEnginePtrPtr 
(def-mactype :tqatexture (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :tqatextureptr (find-mactype '(:pointer :pointer)));  when a VAR xx:TQATexture parameter can be nil, it is changed to xx: TQATexturePtr 
#|
; Warning: Type TQATexturePtr multiply defined: old (from OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:RAVE.p) is (:pointer :pointer); ignoring new definition of pointer
|#
#| 
(def-mactype :tqatextureptr (find-mactype ':pointer)) |#;  an opaque 32-bit type 
(def-mactype :tqatextureptrptr (find-mactype '(:handle :pointer)));  when a VAR xx:TQATexturePtr parameter can be nil, it is changed to xx: TQATexturePtrPtr 
(def-mactype :tqabitmap (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :tqabitmapptr (find-mactype '(:pointer :pointer)));  when a VAR xx:TQABitmap parameter can be nil, it is changed to xx: TQABitmapPtr 
#|
; Warning: Type TQABitmapPtr multiply defined: old (from OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:RAVE.p) is (:pointer :pointer); ignoring new definition of pointer
|#
#| 
(def-mactype :tqabitmapptr (find-mactype ':pointer)) |#;  an opaque 32-bit type 
(def-mactype :tqabitmapptrptr (find-mactype '(:handle :pointer)));  when a VAR xx:TQABitmapPtr parameter can be nil, it is changed to xx: TQABitmapPtrPtr 
(def-mactype :tqadrawprivate (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :tqadrawprivateptr (find-mactype '(:pointer :pointer)));  when a VAR xx:TQADrawPrivate parameter can be nil, it is changed to xx: TQADrawPrivatePtr 
#|
; Warning: Type TQADrawPrivatePtr multiply defined: old (from OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:RAVE.p) is (:pointer :pointer); ignoring new definition of pointer
|#
#| 
(def-mactype :tqadrawprivateptr (find-mactype ':pointer)) |#;  an opaque 32-bit type 
(def-mactype :tqadrawprivateptrptr (find-mactype '(:handle :pointer)));  when a VAR xx:TQADrawPrivatePtr parameter can be nil, it is changed to xx: TQADrawPrivatePtrPtr 
(def-mactype :tqacolortable (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :tqacolortableptr (find-mactype '(:pointer :pointer)));  when a VAR xx:TQAColorTable parameter can be nil, it is changed to xx: TQAColorTablePtr 
#|
; Warning: Type TQAColorTablePtr multiply defined: old (from OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:RAVE.p) is (:pointer :pointer); ignoring new definition of pointer
|#
#| 
(def-mactype :tqacolortableptr (find-mactype ':pointer)) |#;  an opaque 32-bit type 
(def-mactype :tqacolortableptrptr (find-mactype '(:handle :pointer)));  when a VAR xx:TQAColorTablePtr parameter can be nil, it is changed to xx: TQAColorTablePtrPtr 
; 	 A single triangle element for QADrawTriMesh 	
(def-mactype :tqaindexedtriangleptr (find-mactype '(:pointer :tqaindexedtriangle)))
(defrecord TQAIndexedTriangle 
   (triangleFlags :unsigned-long)               ;   Triangle flags, see kQATriFlags_  
   (vertices (:array :unsigned-long 3))         ;   Indices into a vertex array  
   )

; 	 An image for use as texture or bitmap 	
(def-mactype :tqaimageptr (find-mactype '(:pointer :tqaimage)))
(defrecord TQAImage 
   (width :signed-long)                         ;   Width of pixmap  
   (height :signed-long)                        ;   Height of pixmap  
   (rowBytes :signed-long)                      ;   Rowbytes of pixmap  
   (pixmap :pointer)                            ;   Pixmap  
   )

; 	 a pixel buffer 	
(%define-record :tqapixelbuffer (find-record-descriptor :tqadevicememory))
(def-mactype :tqapixelbufferptr (find-mactype '(:pointer :tqadevicememory)))
; 	 a zbuffer 	
(def-mactype :tqazbufferptr (find-mactype '(:pointer :tqazbuffer)))
(defrecord TQAZBuffer 
   (width :signed-long)                         ;   Width of pixmap  
   (height :signed-long)                        ;   Height of pixmap  
   (rowBytes :signed-long)                      ;   Rowbytes of pixmap  
   (zbuffer :pointer)                           ;   pointer to the zbuffer data  
   (zDepth :signed-long)                        ;   bit depth of zbuffer (16,24,32...)  
   (isBigEndian :signed-long)                   ;   true if zbuffer values are in big-endian format, false if little-endian  
   )

; 	 Standard error type 	
(def-mactype :tqaerror (find-mactype ':signed-long))

(defconstant $kQANoErr 0)                       ;   No error  
(defconstant $kQAError 1)                       ;   Generic error flag  
(defconstant $kQAOutOfMemory 2)                 ;   Insufficient memory  
(defconstant $kQANotSupported 3)                ;   Requested feature is not supported  
(defconstant $kQAOutOfDate 4)                   ;   A newer drawing engine was registered  
(defconstant $kQAParamErr 5)                    ;   Error in passed parameters  
(defconstant $kQAGestaltUnknown 6)              ;   Requested gestalt type isn't available  
(defconstant $kQADisplayModeUnsupported 7)      ;   Engine cannot render to the display in its current ,  
;   mode, but could if it were in some other mode  
(defconstant $kQAOutOfVideoMemory 8)            ;   There is not enough VRAM to support the desired context dimensions  

; 	 TQABoolean 	

(def-mactype :tqaboolean (find-mactype ':unsigned-byte))
; 	***********************************************************************************************
; 	 *
; 	 * Vertex data types.
; 	 *
; 	 **********************************************************************************************	
; 	
; 	 * TQAVGouraud is used for Gouraud shading. Each vertex specifies position, color and Z.
; 	 *
; 	 * Alpha is always treated as indicating transparency. Drawing engines which don't
; 	 * support Z-sorted rendering use the back-to-front transparency blending functions
; 	 * shown below. (ARGBsrc are the source (new) values, ARGBdest are  the destination
; 	 * (previous) pixel values.)
; 	 *
; 	 *      Premultiplied                           Interpolated
; 	 *
; 	 *      A = 1 - (1 - Asrc) * (1 - Adest)        A = 1 - (1 - Asrc) * (1 - Adest) 
; 	 *      R = (1 - Asrc) * Rdest + Rsrc           R = (1 - Asrc) * Rdest + Asrc * Rsrc
; 	 *      G = (1 - Asrc) * Gdest + Gsrc           G = (1 - Asrc) * Gdest + Asrc * Gsrc
; 	 *      B = (1 - Asrc) * Bdest + Bsrc           B = (1 - Asrc) * Bdest + Asrc * Bsrc
; 	 *
; 	 * Note that the use of other blending modes to implement antialiasing is performed
; 	 * automatically by the drawing engine when the kQATag_Antialias variable !=
; 	 * kQAAntiAlias_Fast. The driving software should continue to use the alpha fields
; 	 * for transparency even when antialiasing is being used (the drawing engine will
; 	 * resolve the multiple blending requirements as best as it can).
; 	 *
; 	 * Drawing engines which perform front-to-back Z-sorted rendering should replace
; 	 * the blending function shown above with the equivalent front-to-back formula.
; 	 	
(def-mactype :tqavgouraudptr (find-mactype '(:pointer :tqavgouraud)))
(defrecord TQAVGouraud 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (x :single-float)                            ;   X pixel coordinate, 0.0 <= x < width  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (y :single-float)                            ;   Y pixel coordinate, 0.0 <= y < height  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (z :single-float)                            ;   Z coordinate, 0.0 <= z <= 1.0  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (invW :single-float)                         ;   1 / w; required only when kQAPerspectiveZ_On is set  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (r :single-float)                            ;   Red, 0.0 <= r <= 1.0  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (g :single-float)                            ;   Green, 0.0 <= g <= 1.0  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (b :single-float)                            ;   Blue, 0.0 <= b <= 1.0  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (a :single-float)                            ;   Alpha, 0.0 <= a <= 1.0, 1.0 is opaque  
   )

; 	
; 	 * TQAVTexture is used for texture mapping. The texture mapping operation
; 	 * is controlled by the kQATag_TextureOp variable, which is a mask of
; 	 * kQATextureOp_None/Modulate/Highlight/Decal. Below is pseudo-code for the
; 	 * texture shading operation:
; 	 *
; 	 *      texPix = TextureLookup (uq/q, vq/q);
; 	 *      if (kQATextureOp_Decal)
; 	 *      (
; 	 *          texPix.r = texPix.a * texPix.r + (1 - texPix.a) * r;
; 	 *          texPix.g = texPix.a * texPix.g + (1 - texPix.a) * g;
; 	 *          texPix.b = texPix.a * texPix.b + (1 - texPix.a) * b;
; 	 *          texPix.a = a;
; 	 *      )
; 	 *      else
; 	 *      (
; 	 *          texPix.a = texPix.a * a;
; 	 *      )
; 	 *      if (kQATextureOp_Modulate)
; 	 *      (
; 	 *          texPix.r *= kd_r;       // Clamped to prevent overflow
; 	 *          texPix.g *= kd_g;       // Clamped to prevent overflow
; 	 *          texPix.b *= kd_b;       // Clamped to prevent overflow
; 	 *      )
; 	 *      if (kQATextureOp_Highlight)
; 	 *      (
; 	 *          texPix.r += ks_r;       // Clamped to prevent overflow
; 	 *          texPix.g += ks_g;       // Clamped to prevent overflow
; 	 *          texPix.b += ks_b;       // Clamped to prevent overflow
; 	 *      )
; 	 *
; 	 * After computation of texPix, transparency blending (as shown
; 	 * above for TQAVGouraud) is performed.
; 	 	
(def-mactype :tqavtextureptr (find-mactype '(:pointer :tqavtexture)))
(defrecord TQAVTexture 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (x :single-float)                            ;   X pixel coordinate, 0.0 <= x < width  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (y :single-float)                            ;   Y pixel coordinate, 0.0 <= y < height  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (z :single-float)                            ;   Z coordinate, 0.0 <= z <= 1.0  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (invW :single-float)                         ;   1 / w (always required)  
;   rgb are used only when kQATextureOp_Decal is set. a is always required  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (r :single-float)                            ;   Red, 0.0 <= r <= 1.0  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (g :single-float)                            ;   Green, 0.0 <= g <= 1.0  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (b :single-float)                            ;   Blue, 0.0 <= b <= 1.0  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (a :single-float)                            ;   Alpha, 0.0 <= a <= 1.0, 1.0 is opaque  
;   uOverW and vOverW are required by all modes  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (uOverW :single-float)                       ;   u / w  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (vOverW :single-float)                       ;   v / w  
;   kd_r/g/b are used only when kQATextureOp_Modulate is set  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (kd_r :single-float)                         ;   Scale factor for texture red, 0.0 <= kd_r  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (kd_g :single-float)                         ;   Scale factor for texture green, 0.0 <= kd_g  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (kd_b :single-float)                         ;   Scale factor for texture blue, 0.0 <= kd_b  
;   ks_r/g/b are used only when kQATextureOp_Highlight is set  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (ks_r :single-float)                         ;   Red specular highlight, 0.0 <= ks_r <= 1.0  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (ks_g :single-float)                         ;   Green specular highlight, 0.0 <= ks_g <= 1.0  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (ks_b :single-float)                         ;   Blue specular highlight, 0.0 <= ks_b <= 1.0  
   )

; 	
; 	*  TQAVMultiTexture allows you to specify the uv and invW values
; 	*  for secondary textures.  This data is submitted with the
; 	*  QASubmitMultiTextureParams() call.
; 		
(def-mactype :tqavmultitextureptr (find-mactype '(:pointer :tqavmultitexture)))
(defrecord TQAVMultiTexture 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (invW :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (uOverW :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (vOverW :single-float)
   )

; 	***********************************************************************************************
; 	 *
; 	 * Constants used for the state variables.
; 	 *
; 	 **********************************************************************************************	
; 	
; 	 * kQATag_xxx is used to select a state variable when calling QASetFloat(), QASetInt(),
; 	 * QAGetFloat() and QAGetInt(). The kQATag values are split into three separate enumerated
; 	 * types: TQATagInt, TQATagPtr and TQATagFloat. TQATagInt is used for the QASet/GetInt()
; 	 * functions, TQATagPtr is used for the QASet/GetPtr() functions, and TQATagFloat is used for 
; 	 * the QASet/GetFloat() functions. (This is so that a compiler that typechecks enums can flag
; 	 * a float/int tag mismatch during compile.)
; 	 *
; 	 * -=- All tag values must be unique even across all three types. -=-
; 	 *
; 	 * These variables are required by all drawing engines:
; 	 *      kQATag_ZFunction            (Int)   One of kQAZFunction_xxx
; 	 *      kQATag_ColorBG_a            (Float) Background color alpha
; 	 *      kQATag_ColorBG_r            (Float) Background color red
; 	 *      kQATag_ColorBG_g            (Float) Background color green
; 	 *      kQATag_ColorBG_b            (Float) Background color blue
; 	 *      kQATag_Width                (Float) Line and point width (pixels)
; 	 *      kQATag_ZMinOffset           (Float) Min offset to Z to guarantee visibility (Read only!)
; 	 *      kQATag_ZMinScale            (Float) Min scale to Z to guarantee visibility (Read only!)
; 	 
; 	 * These variables are used for optional features:
; 	 *      kQATag_Antialias            (Int)   One of kQAAntiAlias_xxx
; 	 *      kQATag_Blend                (Int)   One of kQABlend_xxx
; 	 *      kQATag_PerspectiveZ         (Int)   One of kQAPerspectiveZ_xxx
; 	 *      kQATag_TextureFilter        (Int)   One of kQATextureFilter_xxx
; 	 *      kQATag_TextureOp            (Int)   Mask of kQATextureOp_xxx
; 	 *      kQATag_Texture              (Ptr)   Pointer to current TQATexture
; 	 *      kQATag_CSGTag               (Int)   One of kQACSGTag_xxx
; 	 *      kQATag_CSGEquation          (Int)   32 bit CSG truth table
; 	 *      kQATag_FogMode              (Int)   One of kQAFogMode_xxxx
; 	 *      kQATag_FogColor_a           (Float) Fog color alpha
; 	 *      kQATag_FogColor_r           (Float) Fog color red
; 	 *      kQATag_FogColor_g           (Float) Fog color green
; 	 *      kQATag_FogColor_b           (Float) Fog color blue
; 	 *      kQATag_FogStart             (Float) Fog start
; 	 *      kQATag_FogEnd               (Float) Fog end
; 	 *      kQATag_FogDensity           (Float) Fog density
; 	 *      kQATag_FogMaxDepth          (Float) Maximun value for 1.0 / invW
; 	 *      kQATag_MipmapBias           (Float) The mipmap page bias factor
; 	 *      kQATag_ChannelMask          (Int) one of kQAChannelMask_xxx
; 	 *      kQATag_ZBufferMask          (Int) one of kQAZBufferMask_xxx
; 	 *      kQATag_ZSortedHint          (Int) 1 = depth sort transparent triangles, 0 = do not sort.
; 	 *      kQATag_Chromakey_r          (Float) chroma key red
; 	 *      kQATag_Chromakey_g          (Float) chroma key green
; 	 *      kQATag_Chromakey_b          (Float) chroma key blue
; 	 *      kQATag_ChromakeyEnable      (Int) 1 = enable chroma keying, 0 = disable chroma keying
; 	 *      kQATag_AlphaTestFunc        (Int) one of kQAAlphaTest_xxx
; 	 *      kQATag_AlphaTestRef         (Float) from 0 to 1
; 	 *      kQATag_DontSwap             (Int) 1 = dont swap buffers during QARenderEnd, 0 = do swap buffers during QARenderEnd.
; 	
; 	 *      kQATag_MultiTextureOp       (Int) One of kQAMultiTexture_xxx
; 	 *      kQATag_MultiTextureFilter   (Int) One of kQATextureFilter_xxx
; 	 *      kQATag_MultiTextureCurrent  (Int) which multitexture layer to use for all other multitexture funcs
; 	 *      kQATag_MultiTextureEnable   (Int) how many multitexture layers to use (0 = no multitexturing).
; 	 *      kQATag_MultiTextureWrapU    (Int)
; 	 *      kQATag_MultiTextureWrapV    (Int)
; 	 *      kQATag_MultiTextureMagFilter (Int)
; 	 *      kQATag_MultiTextureMinFilter (Int)
; 	 *      kQATag_MultiTextureBorder_a (Float)
; 	 *      kQATag_MultiTextureBorder_r (Float)
; 	 *      kQATag_MultiTextureBorder_g (Float)
; 	 *      kQATag_MultiTextureBorder_b (Float)
; 	 *      k
(def-mactype :tqatagint (find-mactype ':signed-long))

(defconstant $kQATag_ZFunction 0)
(defconstant $kQATag_Antialias 8)
(defconstant $kQATag_Blend 9)
(defconstant $kQATag_PerspectiveZ 10)
(defconstant $kQATag_TextureFilter 11)
(defconstant $kQATag_TextureOp 12)
(defconstant $kQATag_CSGTag 14)
(defconstant $kQATag_CSGEquation 15)
(defconstant $kQATag_BufferComposite 16)
(defconstant $kQATag_FogMode 17)
(defconstant $kQATag_ChannelMask 27)
(defconstant $kQATag_ZBufferMask 28)
(defconstant $kQATag_ZSortedHint 29)
(defconstant $kQATag_ChromakeyEnable 30)
(defconstant $kQATag_AlphaTestFunc 31)
(defconstant $kQATag_DontSwap 32)
(defconstant $kQATag_MultiTextureEnable 33)
(defconstant $kQATag_MultiTextureCurrent 34)
(defconstant $kQATag_MultiTextureOp 35)
(defconstant $kQATag_MultiTextureFilter 36)
(defconstant $kQATag_MultiTextureWrapU 37)
(defconstant $kQATag_MultiTextureWrapV 38)
(defconstant $kQATag_MultiTextureMagFilter 39)
(defconstant $kQATag_MultiTextureMinFilter 40)
(defconstant $kQATag_BitmapFilter 54)           ;   filter to use while scaling bitmaps, one of kQAFilter_xxx  
(defconstant $kQATag_DrawContextFilter 55)      ;   filter to use while scaling draw contexts, one of kQAFilter_xxx  
(defconstant $kQATagGL_DrawBuffer 100)
(defconstant $kQATagGL_TextureWrapU 101)
(defconstant $kQATagGL_TextureWrapV 102)
(defconstant $kQATagGL_TextureMagFilter 103)
(defconstant $kQATagGL_TextureMinFilter 104)
(defconstant $kQATagGL_ScissorXMin 105)
(defconstant $kQATagGL_ScissorYMin 106)
(defconstant $kQATagGL_ScissorXMax 107)
(defconstant $kQATagGL_ScissorYMax 108)
(defconstant $kQATagGL_BlendSrc 109)
(defconstant $kQATagGL_BlendDst 110)
(defconstant $kQATagGL_LinePattern 111)
(defconstant $kQATagGL_AreaPattern0 117)        ;   ...kQATagGL_AreaPattern1-30  
(defconstant $kQATagGL_AreaPattern31 148)
(defconstant $kQATagGL_LinePatternFactor 149)   ;   equivalent to GL_LINE_STIPPLE_REPEAT  
(defconstant $kQATag_EngineSpecific_Minimum 1000)

(def-mactype :tqatagptr (find-mactype ':signed-long))

(defconstant $kQATag_Texture 13)
(defconstant $kQATag_MultiTexture 26)

(def-mactype :tqatagfloat (find-mactype ':signed-long))

(defconstant $kQATag_ColorBG_a 1)
(defconstant $kQATag_ColorBG_r 2)
(defconstant $kQATag_ColorBG_g 3)
(defconstant $kQATag_ColorBG_b 4)
(defconstant $kQATag_Width 5)
(defconstant $kQATag_ZMinOffset 6)
(defconstant $kQATag_ZMinScale 7)
(defconstant $kQATag_FogColor_a 18)
(defconstant $kQATag_FogColor_r 19)
(defconstant $kQATag_FogColor_g 20)
(defconstant $kQATag_FogColor_b 21)
(defconstant $kQATag_FogStart 22)
(defconstant $kQATag_FogEnd 23)
(defconstant $kQATag_FogDensity 24)
(defconstant $kQATag_FogMaxDepth 25)
(defconstant $kQATag_MipmapBias 41)
(defconstant $kQATag_MultiTextureMipmapBias 42)
(defconstant $kQATag_Chromakey_r 43)
(defconstant $kQATag_Chromakey_g 44)
(defconstant $kQATag_Chromakey_b 45)
(defconstant $kQATag_AlphaTestRef 46)
(defconstant $kQATag_MultiTextureBorder_a 47)
(defconstant $kQATag_MultiTextureBorder_r 48)
(defconstant $kQATag_MultiTextureBorder_g 49)
(defconstant $kQATag_MultiTextureBorder_b 50)
(defconstant $kQATag_MultiTextureFactor 51)
(defconstant $kQATag_BitmapScale_x 52)          ;   horizontal bitmap scale factor, default value is 1.0  
(defconstant $kQATag_BitmapScale_y 53)          ;   vertical bitmap scale factor, default value is 1.0  
(defconstant $kQATag_MultiTextureEnvColor_a 56)
(defconstant $kQATag_MultiTextureEnvColor_r 57)
(defconstant $kQATag_MultiTextureEnvColor_g 58)
(defconstant $kQATag_MultiTextureEnvColor_b 59)
(defconstant $kQATagGL_DepthBG 112)
(defconstant $kQATagGL_TextureBorder_a 113)
(defconstant $kQATagGL_TextureBorder_r 114)
(defconstant $kQATagGL_TextureBorder_g 115)
(defconstant $kQATagGL_TextureBorder_b 116)
(defconstant $kQATagGL_TextureEnvColor_a 150)
(defconstant $kQATagGL_TextureEnvColor_r 151)
(defconstant $kQATagGL_TextureEnvColor_g 152)
(defconstant $kQATagGL_TextureEnvColor_b 153)

; 	 kQATag_ZFunction 	
(defconstant $kQAZFunction_None 0)              ;   Z is neither tested nor written (same as no Z buffer)  
(defconstant $kQAZFunction_LT 1)                ;   Znew < Zbuffer is visible  
(defconstant $kQAZFunction_EQ 2)                ;   Znew == Zbuffer is visible  
(defconstant $kQAZFunction_LE 3)                ;   Znew <= Zbuffer is visible  
(defconstant $kQAZFunction_GT 4)                ;   Znew > Zbuffer is visible  
(defconstant $kQAZFunction_NE 5)                ;   Znew != Zbuffer is visible  
(defconstant $kQAZFunction_GE 6)                ;   Znew >= Zbuffer is visible  
(defconstant $kQAZFunction_True 7)              ;   Znew is always visible  
(defconstant $kQAZFunction_False 8)             ;   Znew is never visible  

; 	 kQATag_Width 	
(defconstant $kQAMaxWidth 128.0)
; 	 kQATag_Antialias 	
(defconstant $kQAAntiAlias_Off 0)
(defconstant $kQAAntiAlias_Fast 1)
(defconstant $kQAAntiAlias_Mid 2)
(defconstant $kQAAntiAlias_Best 3)

; 	 kQATag_Blend 	
(defconstant $kQABlend_PreMultiply 0)
(defconstant $kQABlend_Interpolate 1)
(defconstant $kQABlend_OpenGL 2)

; 	 kQATag_BufferComposite 	
(defconstant $kQABufferComposite_None 0)        ;   Default: New pixels overwrite initial buffer contents  
(defconstant $kQABufferComposite_PreMultiply 1) ;   New pixels are blended with initial buffer contents via PreMultiply  
(defconstant $kQABufferComposite_Interpolate 2) ;   New pixels are blended with initial buffer contents via Interpolate  

; 	 kQATag_PerspectiveZ 	
(defconstant $kQAPerspectiveZ_Off 0)            ;   Use Z for hidden surface removal  
(defconstant $kQAPerspectiveZ_On 1)             ;   Use InvW for hidden surface removal  

; 	 kQATag_TextureFilter 	
;   suggested meanings of these values  
(defconstant $kQATextureFilter_Fast 0)          ;   No filtering, pick nearest  
(defconstant $kQATextureFilter_Mid 1)           ;   Fastest method that does some filtering  
(defconstant $kQATextureFilter_Best 2)          ;   Highest quality renderer can do  

; 	 filter tag values 	
;   suggested meanings of these values  
(defconstant $kQAFilter_Fast 0)                 ;   No filtering, pick nearest  
(defconstant $kQAFilter_Mid 1)                  ;   Fastest method that does some filtering  
(defconstant $kQAFilter_Best 2)                 ;   Highest quality renderer can do  

; 	 kQATag_TextureOp (mask of one or more) 	
(defconstant $kQATextureOp_None 0)              ;   Default texture mapping mode  
(defconstant $kQATextureOp_Modulate #x1)        ;   Modulate texture color with kd_r/g/b  
(defconstant $kQATextureOp_Highlight #x2)       ;   Add highlight value ks_r/g/b  
(defconstant $kQATextureOp_Decal #x4)           ;   When texture alpha == 0, use rgb instead  
(defconstant $kQATextureOp_Shrink #x8)          ;   This is a non-wrapping texture, so the ???  
(defconstant $kQATextureOp_Blend #x10)          ;   Same as GL_TEXTURE_ENV_MODE GL_BLEND  

; 	 kQATag_MultiTextureOp 	
(defconstant $kQAMultiTexture_Add 0)            ;   texels are added to form final pixel  
(defconstant $kQAMultiTexture_Modulate 1)       ;   texels are multiplied to form final pixel  
(defconstant $kQAMultiTexture_BlendAlpha 2)     ;   texels are blended according to 2nd texel's alpha  
(defconstant $kQAMultiTexture_Fixed 3)          ;   texels are blended by a fixed factor via kQATag_MultiTextureFactor   

; 	 kQATag_CSGTag 	
(defconstant $kQACSGTag_0 0)                    ;   Submitted tris have CSG ID 0  
(defconstant $kQACSGTag_1 1)                    ;   Submitted tris have CSG ID 1  
(defconstant $kQACSGTag_2 2)                    ;   Submitted tris have CSG ID 2  
(defconstant $kQACSGTag_3 3)                    ;   Submitted tris have CSG ID 3  
(defconstant $kQACSGTag_4 4)                    ;   Submitted tris have CSG ID 4  

; 	 kQATagGL_TextureWrapU/V 	
(defconstant $kQAGL_Repeat 0)
(defconstant $kQAGL_Clamp 1)

; 	 kQATagGL_BlendSrc 	
(defconstant $kQAGL_SourceBlend_XXX 0)

; 	 kQATagGL_BlendDst 	
(defconstant $kQAGL_DestBlend_XXX 0)

; 	 kQATagGL_DrawBuffer (mask of one or more) 	
(defconstant $kQAGL_DrawBuffer_None 0)
(defconstant $kQAGL_DrawBuffer_FrontLeft #x1)
(defconstant $kQAGL_DrawBuffer_FrontRight #x2)
(defconstant $kQAGL_DrawBuffer_BackLeft #x4)
(defconstant $kQAGL_DrawBuffer_BackRight #x8)
(defconstant $kQAGL_DrawBuffer_Front #x3)
(defconstant $kQAGL_DrawBuffer_Back #xC)

; 	 kQATag_FogMode 	
(defconstant $kQAFogMode_None 0)                ;   no fog                      
(defconstant $kQAFogMode_Alpha 1)               ;   fog value is alpha                
(defconstant $kQAFogMode_Linear 2)              ;   fog = (end - z) / (end - start)          
(defconstant $kQAFogMode_Exponential 3)         ;   fog = exp(-density * z)               
(defconstant $kQAFogMode_ExponentialSquared 4)  ;   fog = exp(-density * z * density * z)   

; 	 kQATag_ChannelMask 	
(defconstant $kQAChannelMask_r #x1)
(defconstant $kQAChannelMask_g #x2)
(defconstant $kQAChannelMask_b #x4)
(defconstant $kQAChannelMask_a #x8)

; 	 kQATag_ZBufferMask 	
(defconstant $kQAZBufferMask_Disable 0)
(defconstant $kQAZBufferMask_Enable 1)

; 	 kQATag_AlphaTestFunc 	
(defconstant $kQAAlphaTest_None 0)
(defconstant $kQAAlphaTest_LT 1)
(defconstant $kQAAlphaTest_EQ 2)
(defconstant $kQAAlphaTest_LE 3)
(defconstant $kQAAlphaTest_GT 4)
(defconstant $kQAAlphaTest_NE 5)
(defconstant $kQAAlphaTest_GE 6)
(defconstant $kQAAlphaTest_True 7)

; 	 flags for QAAccess__xxx 	
(defconstant $kQANoCopyNeeded #x1)

; 	***********************************************************************************************
; 	 *
; 	 * Constants used as function parameters.
; 	 *
; 	 **********************************************************************************************	
; 	
; 	 * TQAVertexMode is a parameter to QADrawVGouraud() and QADrawVTexture() that specifies how
; 	 * to interpret and draw the vertex array.
; 	 	

(def-mactype :tqavertexmode (find-mactype ':signed-long))

(defconstant $kQAVertexMode_Point 0)            ;   Draw nVertices points  
(defconstant $kQAVertexMode_Line 1)             ;   Draw nVertices/2 line segments  
(defconstant $kQAVertexMode_Polyline 2)         ;   Draw nVertices-1 connected line segments  
(defconstant $kQAVertexMode_Tri 3)              ;   Draw nVertices/3 triangles  
(defconstant $kQAVertexMode_Strip 4)            ;   Draw nVertices-2 triangles as a strip  
(defconstant $kQAVertexMode_Fan 5)              ;   Draw nVertices-2 triangles as a fan from v0  
(defconstant $kQAVertexMode_NumModes 6)

; 	
; 	 * TQAGestaltSelector is a parameter to QAEngineGestalt(). It selects which gestalt
; 	 * parameter will be copied into 'response'.
; 	 	

(def-mactype :tqagestaltselector (find-mactype ':signed-long))

(defconstant $kQAGestalt_OptionalFeatures 0)    ;   Mask of one or more kQAOptional_xxx  
(defconstant $kQAGestalt_FastFeatures 1)        ;   Mask of one or more kQAFast_xxx  
(defconstant $kQAGestalt_VendorID 2)            ;   Vendor ID  
(defconstant $kQAGestalt_EngineID 3)            ;   Engine ID  
(defconstant $kQAGestalt_Revision 4)            ;   Revision number of this engine  
(defconstant $kQAGestalt_ASCIINameLength 5)     ;   strlen (asciiName)  
(defconstant $kQAGestalt_ASCIIName 6)           ;   Causes strcpy (response, asciiName)  
(defconstant $kQAGestalt_TextureMemory 7)       ;   amount of texture RAM currently available  
(defconstant $kQAGestalt_FastTextureMemory 8)   ;   amount of texture RAM currently available  
(defconstant $kQAGestalt_DrawContextPixelTypesAllowed 9);   returns all the draw context pixel types supported by the RAVE engine  
(defconstant $kQAGestalt_DrawContextPixelTypesPreferred 10);   returns all the draw context pixel types that are preferred by the RAVE engine.  
(defconstant $kQAGestalt_TexturePixelTypesAllowed 11);   returns all the texture pixel types that are supported by the RAVE engine  
(defconstant $kQAGestalt_TexturePixelTypesPreferred 12);   returns all the texture pixel types that are preferred by the RAVE engine. 
(defconstant $kQAGestalt_BitmapPixelTypesAllowed 13);   returns all the bitmap pixel types that are supported by the RAVE engine.  
(defconstant $kQAGestalt_BitmapPixelTypesPreferred 14);   returns all the bitmap pixel types that are preferred by the RAVE engine.  
(defconstant $kQAGestalt_OptionalFeatures2 15)  ;   Mask of one or more kQAOptional2_xxx  
(defconstant $kQAGestalt_MultiTextureMax 16)    ;   max number of multi textures supported by this engine  
(defconstant $kQAGestalt_NumSelectors 17)
(defconstant $kQAGestalt_EngineSpecific_Minimum 1000);   all gestalts here and above are for engine specific purposes  

; 	
; 	 * TQAMethodSelector is a parameter to QASetNoticeMethod to select the notice method
; 	 	
#|                                              ; $IFC RAVE_OBSOLETE 

(def-mactype :tqamethodselector (find-mactype ':signed-long))

(defconstant $kQAMethod_RenderCompletion 0)     ;   Called when rendering has completed and buffers swapped  
(defconstant $kQAMethod_DisplayModeChanged 1)   ;   Called when a display mode has changed  
(defconstant $kQAMethod_ReloadTextures 2)       ;   Called when texture memory has been invalidated  
(defconstant $kQAMethod_BufferInitialize 3)     ;   Called when a buffer needs to be initialized  
(defconstant $kQAMethod_BufferComposite 4)      ;   Called when rendering is finished and its safe to composite  
(defconstant $kQAMethod_NumSelectors 5)

 |#                                             ; $ELSEC

(def-mactype :tqamethodselector (find-mactype ':signed-long))

(defconstant $kQAMethod_RenderCompletion 0)     ;   Called when rendering has completed and buffers swapped  
(defconstant $kQAMethod_DisplayModeChanged 1)   ;   Called when a display mode has changed  
(defconstant $kQAMethod_ReloadTextures 2)       ;   Called when texture memory has been invalidated  
(defconstant $kQAMethod_ImageBufferInitialize 3);   Called when a buffer needs to be initialized  
(defconstant $kQAMethod_ImageBuffer2DComposite 4);   Called when rendering is finished and its safe to composite  
(defconstant $kQAMethod_NumSelectors 5)

; $ENDC                                         ; RAVE_OBSOLETE

; 	
; 	 * kQATriFlags_xxx are ORed together to generate the 'flags' parameter
; 	 * to QADrawTriGouraud() and QADrawTriTexture().
; 	 	
(defconstant $kQATriFlags_None 0)               ;   No flags (triangle is front-facing or don't care)  
(defconstant $kQATriFlags_Backfacing #x1)       ;   Triangle is back-facing  

; 	
; 	 * kQATexture_xxx are ORed together to generate the 'flags' parameter to QATextureNew().
; 	 	
(defconstant $kQATexture_None 0)                ;   No flags  
(defconstant $kQATexture_Lock #x1)              ;   Don't swap this texture out  
(defconstant $kQATexture_Mipmap #x2)            ;   This texture is mipmapped  
(defconstant $kQATexture_NoCompression #x4)     ;   Do not compress this texture  
(defconstant $kQATexture_HighCompression #x8)   ;   Compress texture, even if it takes a while  
(defconstant $kQATexture_NonRelocatable #x10)   ;   Image buffer in VRAM should be non-relocatable  
(defconstant $kQATexture_NoCopy #x20)           ;   Don't copy image to VRAM when creating it  
(defconstant $kQATexture_FlipOrigin #x40)       ;   The image(s) is(are) in a bottom-up format. (The image(s) is(are) flipped vertically.)  
(defconstant $kQATexture_PriorityBits #xF0000000);   Texture priority: 4 upper bits for 16 levels of priority  

; 	
; 	 * kQABitmap_xxx are ORed together to generate the 'flags' parameter to QABitmapNew().
; 	 	
(defconstant $kQABitmap_None 0)                 ;   No flags  
(defconstant $kQABitmap_Lock #x2)               ;   Don't swap this bitmap out  
(defconstant $kQABitmap_NoCompression #x4)      ;   Do not compress this bitmap  
(defconstant $kQABitmap_HighCompression #x8)    ;   Compress bitmap, even if it takes a while  
(defconstant $kQABitmap_NonRelocatable #x10)    ;   Image buffer in VRAM should be non-relocatable  
(defconstant $kQABitmap_NoCopy #x20)            ;   Don't copy image to VRAM when creating it  
(defconstant $kQABitmap_FlipOrigin #x40)        ;   The image is in a bottom-up format. (The image is flipped vertically.)  
(defconstant $kQABitmap_PriorityBits #xF0000000);   Bitmap priority: 4 upper bits for 16 levels of priority  

; 	
; 	 * kQAContext_xxx are ORed together to generate the 'flags' parameter for QADrawContextNew().
; 	 	
(defconstant $kQAContext_None 0)                ;   No flags  
(defconstant $kQAContext_NoZBuffer #x1)         ;   No hidden surface removal  
(defconstant $kQAContext_DeepZ #x2)             ;   Hidden surface precision >= 24 bits  
(defconstant $kQAContext_DoubleBuffer #x4)      ;   Double buffered window  
(defconstant $kQAContext_Cache #x8)             ;   This is a cache context  
(defconstant $kQAContext_NoDither #x10)         ;   No dithering, straight color banding  
(defconstant $kQAContext_Scale #x20)            ;   The draw context is to be scaled.  The front buffer is a different size than the back buffer.  
(defconstant $kQAContext_NonRelocatable #x40)   ;   The back buffer and the z buffer must not move in memory  
(defconstant $kQAContext_EngineSpecific1 #x10000000);   engine specific flag # 1  
(defconstant $kQAContext_EngineSpecific2 #x20000000);   engine specific flag # 2  
(defconstant $kQAContext_EngineSpecific3 #x40000000);   engine specific flag # 3  
(defconstant $kQAContext_EngineSpecific4 #x80000000);   engine specific flag # 4  

; 	
; 	 * kQAOptional_xxx are ORed together to generate the kQAGestalt_OptionalFeatures response
; 	 * from QAEngineGestalt().
; 	 	
(defconstant $kQAOptional_None 0)               ;   No optional features  
(defconstant $kQAOptional_DeepZ #x1)            ;   Hidden surface precision >= 24 bits  
(defconstant $kQAOptional_Texture #x2)          ;   Texture mapping  
(defconstant $kQAOptional_TextureHQ #x4)        ;   High quality texture (tri-linear mip or better)  
(defconstant $kQAOptional_TextureColor #x8)     ;   Full color modulation and highlight of textures  
(defconstant $kQAOptional_Blend #x10)           ;   Transparency blending of RGB  
(defconstant $kQAOptional_BlendAlpha #x20)      ;   Transparency blending includes alpha channel  
(defconstant $kQAOptional_Antialias #x40)       ;   Antialiased rendering  
(defconstant $kQAOptional_ZSorted #x80)         ;   Z sorted rendering (for transparency, etc.)  
(defconstant $kQAOptional_PerspectiveZ #x100)   ;   Hidden surface removal using InvW instead of Z  
(defconstant $kQAOptional_OpenGL #x200)         ;   Extended rasterization features for OpenGL  
(defconstant $kQAOptional_NoClear #x400)        ;   This drawing engine doesn't clear before drawing  
(defconstant $kQAOptional_CSG #x800)            ;   kQATag_CSGxxx are implemented  
(defconstant $kQAOptional_BoundToDevice #x1000) ;   This engine is tightly bound to GDevice  
(defconstant $kQAOptional_CL4 #x2000)           ;   This engine suports kQAPixel_CL4  
(defconstant $kQAOptional_CL8 #x4000)           ;   This engine suports kQAPixel_CL8  
(defconstant $kQAOptional_BufferComposite #x8000);   This engine can composite with initial buffer contents  
(defconstant $kQAOptional_NoDither #x10000)     ;   This engine can draw with no dithering  
(defconstant $kQAOptional_FogAlpha #x20000)     ;   This engine suports alpha based fog  
(defconstant $kQAOptional_FogDepth #x40000)     ;   This engine suports depth based fog  
(defconstant $kQAOptional_MultiTextures #x80000);   This bit set if engine supports texture compositing  
(defconstant $kQAOptional_MipmapBias #x100000)  ;   This bit is set if the engine supports mipmap selection bias  
(defconstant $kQAOptional_ChannelMask #x200000)
(defconstant $kQAOptional_ZBufferMask #x400000)
(defconstant $kQAOptional_AlphaTest #x800000)   ;   this engine supports alpha testing  
(defconstant $kQAOptional_AccessTexture #x1000000);   if engine supports access to texture  
(defconstant $kQAOptional_AccessBitmap #x2000000);   if engine supports access to bitmaps  
(defconstant $kQAOptional_AccessDrawBuffer #x4000000);   if engine supports access to draw buffer  
(defconstant $kQAOptional_AccessZBuffer #x8000000);   if engine supports access to zbuffer  
(defconstant $kQAOptional_ClearDrawBuffer #x10000000);   if engine supports QAClearDrawBuffer()  
(defconstant $kQAOptional_ClearZBuffer #x20000000);   if engine supports QAClearZBuffer()  
(defconstant $kQAOptional_OffscreenDrawContexts #x40000000);   if engine supports TQADeviceOffscreen  

; 	
; 	 * kQAOptional2_xxx are ORed together to generate the kQAGestalt_OptionalFeatures2 response
; 	 * from QAEngineGestalt().
; 	 	
(defconstant $kQAOptional2_None 0)
(defconstant $kQAOptional2_TextureDrawContexts #x2);   if engine supports QATextureNewFromDrawContext()  
(defconstant $kQAOptional2_BitmapDrawContexts #x4);   if engine supports QABitmapNewFromDrawContext()  
(defconstant $kQAOptional2_Busy #x8)            ;   if engine supports QABusy()  
(defconstant $kQAOptional2_SwapBuffers #x10)    ;   if engine supports QASwapBuffers()  
(defconstant $kQAOptional2_Chromakey #x20)      ;   if engine supports chromakeying via kQATag_Chromakey_xxx  
(defconstant $kQAOptional2_NonRelocatable #x40) ;   if engine supports nonrelocatable texture & bitmap image buffers in VRAM  
(defconstant $kQAOptional2_NoCopy #x80)         ;   if engine supports ability to not copy texture & bitmap image to VRAM  
(defconstant $kQAOptional2_PriorityBits #x100)  ;   if engine supports texture & bitmap priority levels  
(defconstant $kQAOptional2_FlipOrigin #x200)    ;   if engine supports textures & bitmaps that are vertically flipped  
(defconstant $kQAOptional2_BitmapScale #x400)   ;   if engine supports scaled bitmap drawing  
(defconstant $kQAOptional2_DrawContextScale #x800);   if engine supports scaled draw contexts  
(defconstant $kQAOptional2_DrawContextNonRelocatable #x1000);   if engine supports draw contexts with non relocatable buffers  

; 	
; 	 * kQAFast_xxx are ORed together to generate the kQAGestalt_FastFeatures response
; 	 * from QAEngineGestalt().
; 	 	
(defconstant $kQAFast_None 0)                   ;   No accelerated features  
(defconstant $kQAFast_Line #x1)                 ;   Line drawing  
(defconstant $kQAFast_Gouraud #x2)              ;   Gouraud shaded triangles  
(defconstant $kQAFast_Texture #x4)              ;   Texture mapped triangles  
(defconstant $kQAFast_TextureHQ #x8)            ;   High quality texture (tri-linear mip or better)  
(defconstant $kQAFast_Blend #x10)               ;   Transparency blending  
(defconstant $kQAFast_Antialiasing #x20)        ;   Antialiased rendering  
(defconstant $kQAFast_ZSorted #x40)             ;   Z sorted rendering of non-opaque objects  
(defconstant $kQAFast_CL4 #x80)                 ;   This engine accelerates kQAPixel_CL4  
(defconstant $kQAFast_CL8 #x100)                ;   This engine accelerates kQAPixel_CL8  
(defconstant $kQAFast_FogAlpha #x200)           ;   This engine accelerates alpha based fog  
(defconstant $kQAFast_FogDepth #x400)           ;   This engine accelerates depth based fog  
(defconstant $kQAFast_MultiTextures #x800)      ;   This engine accelerates texture compositing  
(defconstant $kQAFast_BitmapScale #x1000)       ;   This engine accelerates scaled bitmap drawing  
(defconstant $kQAFast_DrawContextScale #x2000)  ;   This engine accelerates scaled draw contexts  

; 	*******************************************************************
; 	 * TQAVersion sets the TQADrawContext 'version' field. It is set by
; 	 * the manager to indicate the version of the TQADrawContext structure.
; 	 ******************************************************************	

(def-mactype :tqaversion (find-mactype ':signed-long))

(defconstant $kQAVersion_Prerelease 0)
(defconstant $kQAVersion_1_0 1)
(defconstant $kQAVersion_1_0_5 2)               ;   Added tri mesh functions, color tables  
(defconstant $kQAVersion_1_5 3)                 ;   Added call backs, texture compression, and new error return code  
(defconstant $kQAVersion_1_6 4)                 ;   Added QAAccess_xxx, fog, _Options2, Clear_xxx, etc.  

; 	**********************************************************************
; 	 * TQADrawContext structure holds method pointers.
; 	 * This is a forward refrence. The structure is defined later.
; 	 *********************************************************************	

(def-mactype :tqadrawcontextptr (find-mactype '(:pointer :tqadrawcontext)))
; 	***********************************************************************************************
; 	 *
; 	 * Typedefs of draw method functions provided by the drawing engine. One function pointer
; 	 * for each of these function types in stored in the TQADrawContext public data structure.
; 	 *
; 	 * These functions should be accessed through the QA<function>(context,...) macros,
; 	 * defined above.
; 	 *
; 	 **********************************************************************************************	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQAStandardNoticeMethod = PROCEDURE({CONST}VAR drawContext: TQADrawContext; refCon: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqastandardnoticemethod (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQABufferNoticeMethod = PROCEDURE({CONST}VAR drawContext: TQADrawContext; {CONST}VAR buffer: TQADevice; {CONST}VAR dirtyRect: TQARect; refCon: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqabuffernoticemethod (find-mactype ':pointer))
; $ENDC

(def-mactype :tqanoticemethodptr (find-mactype '(:pointer :tqanoticemethod)))
(defrecord TQANoticeMethod 
   (:variant 
      (
      (standardNoticeMethod :pointer)           ;   Used for non-buffer related methods  
      )
      (
      (bufferNoticeMethod :pointer)             ;   Used for buffer handling methods  
      )
      )
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQASetFloat = PROCEDURE(drawContext: TQADrawContextPtr; tag: TQATagFloat; newValue: Single); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqasetfloat (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQASetInt = PROCEDURE(drawContext: TQADrawContextPtr; tag: TQATagInt; newValue: UInt32); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqasetint (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQASetPtr = PROCEDURE(drawContext: TQADrawContextPtr; tag: TQATagPtr; newValue: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqasetptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQAGetFloat = FUNCTION({CONST}VAR drawContext: TQADrawContext; tag: TQATagFloat): Single; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqagetfloat (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQAGetInt = FUNCTION({CONST}VAR drawContext: TQADrawContext; tag: TQATagInt): UInt32; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqagetint (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQAGetPtr = FUNCTION({CONST}VAR drawContext: TQADrawContext; tag: TQATagPtr): Ptr; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqagetptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQADrawPoint = PROCEDURE({CONST}VAR drawContext: TQADrawContext; {CONST}VAR v: TQAVGouraud); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqadrawpoint (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQADrawLine = PROCEDURE({CONST}VAR drawContext: TQADrawContext; {CONST}VAR v0: TQAVGouraud; {CONST}VAR v1: TQAVGouraud); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqadrawline (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQADrawTriGouraud = PROCEDURE({CONST}VAR drawContext: TQADrawContext; {CONST}VAR v0: TQAVGouraud; {CONST}VAR v1: TQAVGouraud; {CONST}VAR v2: TQAVGouraud; flags: UInt32); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqadrawtrigouraud (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQADrawTriTexture = PROCEDURE({CONST}VAR drawContext: TQADrawContext; {CONST}VAR v0: TQAVTexture; {CONST}VAR v1: TQAVTexture; {CONST}VAR v2: TQAVTexture; flags: UInt32); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqadrawtritexture (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQASubmitVerticesGouraud = PROCEDURE({CONST}VAR drawContext: TQADrawContext; nVertices: UInt32; {CONST}VAR vertices: TQAVGouraud); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqasubmitverticesgouraud (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQASubmitVerticesTexture = PROCEDURE({CONST}VAR drawContext: TQADrawContext; nVertices: UInt32; {CONST}VAR vertices: TQAVTexture); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqasubmitverticestexture (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQADrawTriMeshGouraud = PROCEDURE({CONST}VAR drawContext: TQADrawContext; nTriangles: UInt32; {CONST}VAR triangles: TQAIndexedTriangle); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqadrawtrimeshgouraud (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQADrawTriMeshTexture = PROCEDURE({CONST}VAR drawContext: TQADrawContext; nTriangles: UInt32; {CONST}VAR triangles: TQAIndexedTriangle); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqadrawtrimeshtexture (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQADrawVGouraud = PROCEDURE({CONST}VAR drawContext: TQADrawContext; nVertices: UInt32; vertexMode: TQAVertexMode; {CONST}VAR vertices: TQAVGouraud; {CONST}VAR flags: UInt32); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqadrawvgouraud (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQADrawVTexture = PROCEDURE({CONST}VAR drawContext: TQADrawContext; nVertices: UInt32; vertexMode: TQAVertexMode; {CONST}VAR vertices: TQAVTexture; {CONST}VAR flags: UInt32); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqadrawvtexture (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQADrawBitmap = PROCEDURE({CONST}VAR drawContext: TQADrawContext; {CONST}VAR v: TQAVGouraud; VAR bitmap: TQABitmap); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqadrawbitmap (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQARenderStart = PROCEDURE({CONST}VAR drawContext: TQADrawContext; {CONST}VAR dirtyRect: TQARect; {CONST}VAR initialContext: TQADrawContext); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqarenderstart (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQARenderEnd = FUNCTION({CONST}VAR drawContext: TQADrawContext; {CONST}VAR modifiedRect: TQARect): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqarenderend (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQARenderAbort = FUNCTION({CONST}VAR drawContext: TQADrawContext): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqarenderabort (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQAFlush = FUNCTION({CONST}VAR drawContext: TQADrawContext): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqaflush (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQASync = FUNCTION({CONST}VAR drawContext: TQADrawContext): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqasync (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQASetNoticeMethod = FUNCTION({CONST}VAR drawContext: TQADrawContext; method: TQAMethodSelector; completionCallBack: TQANoticeMethod; refCon: UNIV Ptr): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqasetnoticemethod (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQAGetNoticeMethod = FUNCTION({CONST}VAR drawContext: TQADrawContext; method: TQAMethodSelector; VAR completionCallBack: TQANoticeMethod; VAR refCon: UNIV Ptr): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqagetnoticemethod (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQASubmitMultiTextureParams = PROCEDURE({CONST}VAR drawContext: TQADrawContext; nParams: UInt32; {CONST}VAR params: TQAVMultiTexture); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqasubmitmultitextureparams (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQAAccessDrawBuffer = FUNCTION({CONST}VAR drawContext: TQADrawContext; VAR buffer: TQAPixelBuffer): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqaaccessdrawbuffer (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQAAccessDrawBufferEnd = FUNCTION({CONST}VAR drawContext: TQADrawContext; {CONST}VAR dirtyRect: TQARect): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqaaccessdrawbufferend (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQAAccessZBuffer = FUNCTION({CONST}VAR drawContext: TQADrawContext; VAR buffer: TQAZBuffer): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqaaccesszbuffer (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQAAccessZBufferEnd = FUNCTION({CONST}VAR drawContext: TQADrawContext; {CONST}VAR dirtyRect: TQARect): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqaaccesszbufferend (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQAClearDrawBuffer = FUNCTION({CONST}VAR drawContext: TQADrawContext; {CONST}VAR rect: TQARect; {CONST}VAR initialContext: TQADrawContext): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqacleardrawbuffer (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQAClearZBuffer = FUNCTION({CONST}VAR drawContext: TQADrawContext; {CONST}VAR rect: TQARect; {CONST}VAR initialContext: TQADrawContext): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqaclearzbuffer (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQATextureNewFromDrawContext = FUNCTION({CONST}VAR drawContext: TQADrawContext; flags: UInt32; VAR newTexture: UNIV Ptr): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqatexturenewfromdrawcontext (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQABitmapNewFromDrawContext = FUNCTION({CONST}VAR drawContext: TQADrawContext; flags: UInt32; VAR newBitmap: UNIV Ptr): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqabitmapnewfromdrawcontext (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQABusy = FUNCTION({CONST}VAR drawContext: TQADrawContext): ByteParameter; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqabusy (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQASwapBuffers = FUNCTION({CONST}VAR drawContext: TQADrawContext; {CONST}VAR dirtyRect: TQARect): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqaswapbuffers (find-mactype ':pointer))
; $ENDC

; 	***********************************************************************************************
; 	 *
; 	 * Public TQADrawContext structure. This contains function pointers for the chosen
; 	 * drawing engine.
; 	 *
; 	 **********************************************************************************************	
(defrecord TQADrawContext 
   (drawPrivate (:pointer :pointer))            ;   Engine's private data for this context  
   (version :signed-long)                       ;   Version number  
   (setFloat :pointer)                          ;   Method: Set a float state variable  
   (setInt :pointer)                            ;   Method: Set an unsigned long state variable  
   (setPtr :pointer)                            ;   Method: Set an unsigned long state variable  
   (getFloat :pointer)                          ;   Method: Get a float state variable  
   (getInt :pointer)                            ;   Method: Get an unsigned long state variable  
   (getPtr :pointer)                            ;   Method: Get an pointer state variable  
   (drawPoint :pointer)                         ;   Method: Draw a point  
   (drawLine :pointer)                          ;   Method: Draw a line  
   (drawTriGouraud :pointer)                    ;   Method: Draw a Gouraud shaded triangle  
   (drawTriTexture :pointer)                    ;   Method: Draw a texture mapped triangle  
   (drawVGouraud :pointer)                      ;   Method: Draw Gouraud vertices  
   (drawVTexture :pointer)                      ;   Method: Draw texture vertices  
   (drawBitmap :pointer)                        ;   Method: Draw a bitmap  
   (renderStart :pointer)                       ;   Method: Initialize for rendering  
   (renderEnd :pointer)                         ;   Method: Complete rendering and display  
   (renderAbort :pointer)                       ;   Method: Abort any outstanding rendering (blocking)  
   (flush :pointer)                             ;   Method: Start render of any queued commands (non-blocking)  
   (sync :pointer)                              ;   Method: Wait for completion of all rendering (blocking)  
   (submitVerticesGouraud :pointer)             ;   Method: Submit Gouraud vertices for trimesh  
   (submitVerticesTexture :pointer)             ;   Method: Submit Texture vertices for trimesh  
   (drawTriMeshGouraud :pointer)                ;   Method: Draw a Gouraud triangle mesh  
   (drawTriMeshTexture :pointer)                ;   Method: Draw a Texture triangle mesh  
   (setNoticeMethod :pointer)                   ;   Method: Set a notice method  
   (getNoticeMethod :pointer)                   ;   Method: Get a notice method  
   (submitMultiTextureParams :pointer)          ;   Method: Submit Secondary texture params  
   (accessDrawBuffer :pointer)
   (accessDrawBufferEnd :pointer)
   (accessZBuffer :pointer)
   (accessZBufferEnd :pointer)
   (clearDrawBuffer :pointer)
   (clearZBuffer :pointer)
   (textureFromContext :pointer)
   (bitmapFromContext :pointer)
   (busy :pointer)
   (swapBuffers :pointer)
   )

; 	***********************************************************************************************
; 	 *
; 	 * Acceleration manager function prototypes.
; 	 *
; 	 **********************************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  QADrawContextNew()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST                                         ; CONST; CONST; CONST
(deftrap-inline "_QADrawContextNew" 
      ((device (:pointer :tqadevice)) (rect (:pointer :tqarect)) (clip (:pointer :tqaclip)) (engine (:pointer :pointer)) (flags :unsigned-long) (newDrawContext (:pointer :pointer))) 
  :tqaerror
   () )

; 
;  *  QADrawContextDelete()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_QADrawContextDelete" 
      ((drawContext (:pointer :tqadrawcontext))) 
  nil
   () )

; 
;  *  QAColorTableNew()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_QAColorTableNew" 
      ((engine (:pointer :pointer)) (tableType :signed-long) (pixelData :pointer) (transparentIndexFlag :signed-long) (newTable (:pointer :pointer))) 
  :tqaerror
   () )

; 
;  *  QAColorTableDelete()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_QAColorTableDelete" 
      ((engine (:pointer :pointer)) (colorTable (:pointer :pointer))) 
  nil
   () )

; 
;  *  QATextureNew()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_QATextureNew" 
      ((engine (:pointer :pointer)) (flags :unsigned-long) (pixelType :signed-long) (images (:pointer :tqaimage)) (newTexture (:pointer :pointer))) 
  :tqaerror
   () )

; 
;  *  QATextureDetach()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_QATextureDetach" 
      ((engine (:pointer :pointer)) (texture (:pointer :pointer))) 
  :tqaerror
   () )

; 
;  *  QATextureDelete()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_QATextureDelete" 
      ((engine (:pointer :pointer)) (texture (:pointer :pointer))) 
  nil
   () )

; 
;  *  QATextureBindColorTable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_QATextureBindColorTable" 
      ((engine (:pointer :pointer)) (texture (:pointer :pointer)) (colorTable (:pointer :pointer))) 
  :tqaerror
   () )

; 
;  *  QABitmapNew()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_QABitmapNew" 
      ((engine (:pointer :pointer)) (flags :unsigned-long) (pixelType :signed-long) (image (:pointer :tqaimage)) (newBitmap (:pointer :pointer))) 
  :tqaerror
   () )

; 
;  *  QABitmapDetach()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_QABitmapDetach" 
      ((engine (:pointer :pointer)) (bitmap (:pointer :pointer))) 
  :tqaerror
   () )

; 
;  *  QABitmapDelete()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_QABitmapDelete" 
      ((engine (:pointer :pointer)) (bitmap (:pointer :pointer))) 
  nil
   () )

; 
;  *  QABitmapBindColorTable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_QABitmapBindColorTable" 
      ((engine (:pointer :pointer)) (bitmap (:pointer :pointer)) (colorTable (:pointer :pointer))) 
  :tqaerror
   () )

; 
;  *  QADeviceGetFirstEngine()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_QADeviceGetFirstEngine" 
      ((device (:pointer :tqadevice))) 
  (:pointer :pointer)
   () )

; 
;  *  QADeviceGetNextEngine()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_QADeviceGetNextEngine" 
      ((device (:pointer :tqadevice)) (currentEngine (:pointer :pointer))) 
  (:pointer :pointer)
   () )

; 
;  *  QAEngineCheckDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_QAEngineCheckDevice" 
      ((engine (:pointer :pointer)) (device (:pointer :tqadevice))) 
  :tqaerror
   () )

; 
;  *  QAEngineGestalt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_QAEngineGestalt" 
      ((engine (:pointer :pointer)) (selector :signed-long) (response :pointer)) 
  :tqaerror
   () )

; 
;  *  QAEngineEnable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_QAEngineEnable" 
      ((vendorID :signed-long) (engineID :signed-long)) 
  :tqaerror
   () )

; 
;  *  QAEngineDisable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_QAEngineDisable" 
      ((vendorID :signed-long) (engineID :signed-long)) 
  :tqaerror
   () )

; 
;  *  QAAccessTexture()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_QAAccessTexture" 
      ((engine (:pointer :pointer)) (texture (:pointer :pointer)) (mipmapLevel :signed-long) (flags :signed-long) (buffer (:pointer :tqadevicememory))) 
  :tqaerror
   () )

; 
;  *  QAAccessTextureEnd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_QAAccessTextureEnd" 
      ((engine (:pointer :pointer)) (texture (:pointer :pointer)) (dirtyRect (:pointer :tqarect))) 
  :tqaerror
   () )

; 
;  *  QAAccessBitmap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_QAAccessBitmap" 
      ((engine (:pointer :pointer)) (bitmap (:pointer :pointer)) (flags :signed-long) (buffer (:pointer :tqadevicememory))) 
  :tqaerror
   () )

; 
;  *  QAAccessBitmapEnd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_QAAccessBitmapEnd" 
      ((engine (:pointer :pointer)) (bitmap (:pointer :pointer)) (dirtyRect (:pointer :tqarect))) 
  :tqaerror
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC TARGET_OS_MAC 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  QARegisterDrawNotificationProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_QARegisterDrawNotificationProc" 
      ((globalRect (:pointer :rect)) (proc :pointer) (refCon :signed-long) (refNum (:pointer :signed-long))) 
  :tqaerror
   () )

; 
;  *  QAUnregisterDrawNotificationProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_QAUnregisterDrawNotificationProc" 
      ((refNum :signed-long)) 
  :tqaerror
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; TARGET_OS_MAC

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := RAVEIncludes

; $ENDC                                         ; __RAVE__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'RAVE)