(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:RAVESystem.p"
; at Wednesday May 1,2002 2:42:48 pm.
; 
;      File:       RAVESystem.p
;  
;      Contains:   Interfaces needed when building RAVE engines
;  
;      Version:    Technology: Quickdraw 3D 1.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __RAVESYSTEM__
; $SETC __RAVESYSTEM__ := 1

; $I+
; $SETC RAVESystemIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __RAVE__
|#

(require-interface 'RAVE)
#|                                              ; $I RAVE.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

; ***********************************************************************************************
;  *
;  * Typedefs of texture/bitmap method functions provided by the drawing engine.
;  *
;  **********************************************************************************************
;  TQAColorTableNew parameter descriptions 
;  TQAColorTableType    pixelType           Depth, color space, etc. 
;  void                 *pixelData          lookup table entries in pixelType format 
;  long                 transparentIndex    boolean, false means no transparency, true means index 0 is transparent 
;  TQAColorTable        **newTable          (Out) Newly created TQAColorTable 

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQAColorTableNew = FUNCTION(pixelType: TQAColorTableType; pixelData: UNIV Ptr; transparentIndex: LONGINT; VAR newTable: UNIV Ptr): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqacolortablenew (find-mactype ':pointer))
; $ENDC

; 	 TQAColorTableDelete  parameter descriptions 	
; 	 TQAColorTable        *colorTable     Previously allocated by QAColorTableNew() 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQAColorTableDelete = PROCEDURE(VAR colorTable: TQAColorTable); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqacolortabledelete (find-mactype ':pointer))
; $ENDC

; 	 TQATextureNew    parameter descriptions 	
; 	  unsigned long       flags               Mask of kQATexture_xxx flags 	
; 	  TQAImagePixelType   pixelType           Depth, color space, etc. 	
; 	  const TQAImage      images[]            Image(s) for texture 	
; 	  TQATexture          **newTexture        (Out) Newly created TQATexture, or NULL on error 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQATextureNew = FUNCTION(flags: UInt32; pixelType: TQAImagePixelType; {CONST}VAR images: TQAImage; VAR newTexture: UNIV Ptr): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqatexturenew (find-mactype ':pointer))
; $ENDC

; 	 TQATextureDetach parameter descriptions 	
; 	  TQATexture          *texture            Previously allocated by QATextureNew() 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQATextureDetach = FUNCTION(VAR texture: TQATexture): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqatexturedetach (find-mactype ':pointer))
; $ENDC

; 	 TQATextureDelete parameter descriptions 	
; 	  TQATexture          *texture            Previously allocated by QATextureNew() 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQATextureDelete = PROCEDURE(VAR texture: TQATexture); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqatexturedelete (find-mactype ':pointer))
; $ENDC

; 	 TQATextureBindColorTable parameter descriptions 	
; 	  TQATexture          *texture            Previously allocated by QATextureNew() 	
; 	  TQAColorTable       *colorTable         Previously allocated by QAColorTableNew() 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQATextureBindColorTable = FUNCTION(VAR texture: TQATexture; VAR colorTable: TQAColorTable): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqatexturebindcolortable (find-mactype ':pointer))
; $ENDC

; 	 TQABitmapNew parameter descriptions 	
; 	  unsigned long       flags               Mask of kQABitmap_xxx flags 	
; 	  TQAImagePixelType   pixelType           Depth, color space, etc. 	
; 	  const TQAImage      *image              Image 	
; 	  TQABitmap           **newBitmap         (Out) Newly created TQABitmap, or NULL on error 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQABitmapNew = FUNCTION(flags: UInt32; pixelType: TQAImagePixelType; {CONST}VAR image: TQAImage; VAR newBitmap: UNIV Ptr): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqabitmapnew (find-mactype ':pointer))
; $ENDC

; 	 TQABitmapDetach  parameter descriptions 	
; 	  TQABitmap           *bitmap         Previously allocated by QABitmapNew() 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQABitmapDetach = FUNCTION(VAR bitmap: TQABitmap): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqabitmapdetach (find-mactype ':pointer))
; $ENDC

; 	 TQABitmapDelete  parameter descriptions 	
; 	  TQABitmap           *bitmap         Previously allocated by QABitmapNew() 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQABitmapDelete = PROCEDURE(VAR bitmap: TQABitmap); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqabitmapdelete (find-mactype ':pointer))
; $ENDC

; 	 TQABitmapBindColorTable  parameter descriptions 	
; 	  TQABitmap           *bitmap         Previously allocated by QABitmapNew() 	
; 	  TQAColorTable       *colorTable     Previously allocated by QAColorTableNew() 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQABitmapBindColorTable = FUNCTION(VAR bitmap: TQABitmap; VAR colorTable: TQAColorTable): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqabitmapbindcolortable (find-mactype ':pointer))
; $ENDC

; 	***********************************************************************************************
; 	 *
; 	 * Typedefs of private (system-only) functions provided by the drawing engine.
; 	 *
; 	 * The TQADrawPrivateNew function returns a TQADrawPrivate *, which points to the
; 	 * engine-specific private data created for the context. (TQADrawPrivate is a dummy
; 	 * type which is then cast to the correct engine-specific datatype by the engine code.)
; 	 *
; 	 * The TQADrawPrivateDelete function deletes the engine-specific private data.
; 	 *
; 	 * TQAStorePrivateNew and TQAStorePrivateDelete provide the same function as QADrawPrivateNew
; 	 * and TQADrawPrivateDelete, but for the texture and bitmap storage context.
; 	 *
; 	 * TQADrawMethodGet and TQAStoreMethodGet are called by the RAVE manager to retrieve
; 	 * the method pointers for a drawing engine.
; 	 *
; 	 * The TQAEngineCheckDevice function returns TRUE if the engine can render to the
; 	 * indicated GDevice.
; 	 *
; 	 **********************************************************************************************	
; 	 TQADrawPrivateNew    parameter descriptions 	
; 	  TQADrawContext      *newDrawContext     Draw context to initialize 	
; 	  const TQADevice     *device             Target device 	
; 	  const TQARect       *rect               Target rectangle (device coordinates) 	
; 	  const TQAClip       *clip               2D clip region (or NULL) 	
; 	  unsigned long       flags               Mask of kQAContext_xxx 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQADrawPrivateNew = FUNCTION(VAR newDrawContext: TQADrawContext; {CONST}VAR device: TQADevice; {CONST}VAR rect: TQARect; {CONST}VAR clip: TQAClip; flags: UInt32): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqadrawprivatenew (find-mactype ':pointer))
; $ENDC

; 	 TQADrawPrivateDelete parameter descriptions 	
; 	  TQADrawPrivate      *drawPrivate        Private context data to delete 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQADrawPrivateDelete = PROCEDURE(VAR drawPrivate: TQADrawPrivate); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqadrawprivatedelete (find-mactype ':pointer))
; $ENDC

; 	 TQAEngineCheckDevice parameter descriptions 	
; 	  const TQADevice     *device         Target device 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQAEngineCheckDevice = FUNCTION({CONST}VAR device: TQADevice): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqaenginecheckdevice (find-mactype ':pointer))
; $ENDC

; 	 TQAEngineGestalt parameter descriptions 	
; 	  TQAGestaltSelector  selector            Gestalt parameter being requested 	
; 	  void                *response           Buffer that receives response 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQAEngineGestalt = FUNCTION(selector: TQAGestaltSelector; response: UNIV Ptr): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqaenginegestalt (find-mactype ':pointer))
; $ENDC

; 	 new engine methods for RAVE 1.6 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQAAccessTexture = FUNCTION(VAR texture: TQATexture; mipmapLevel: LONGINT; flags: LONGINT; VAR buffer: TQAPixelBuffer): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqaaccesstexture (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQAAccessTextureEnd = FUNCTION(VAR texture: TQATexture; {CONST}VAR dirtyRect: TQARect): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqaaccesstextureend (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQAAccessBitmap = FUNCTION(VAR bitmap: TQABitmap; flags: LONGINT; VAR buffer: TQAPixelBuffer): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqaaccessbitmap (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQAAccessBitmapEnd = FUNCTION(VAR bitmap: TQABitmap; {CONST}VAR dirtyRect: TQARect): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqaaccessbitmapend (find-mactype ':pointer))
; $ENDC

; 	***********************************************************************************************
; 	 *
; 	 * The TQAEngineMethod union is used to represent a single engine method (it's a
; 	 * parameter to QAEngineGetMethod). TQAEngineMethodTag identifies which method is being
; 	 * requested.
; 	 *
; 	 **********************************************************************************************	
(def-mactype :tqaenginemethodptr (find-mactype '(:pointer :tqaenginemethod)))
(defrecord TQAEngineMethod 
   (:variant 
      (
      (drawPrivateNew :pointer)                 ;   Method: Create a private draw context  
      )
      (
      (drawPrivateDelete :pointer)              ;   Method: Delete a private draw context  
      )
      (
      (engineCheckDevice :pointer)              ;   Method: Check a device for drawing  
      )
      (
      (engineGestalt :pointer)                  ;   Method: Gestalt  
      )
      (
      (textureNew :pointer)                     ;   Method: Create a texture (load is non-blocking)  
      )
      (
      (textureDetach :pointer)                  ;   Method: Complete load of a texture (blocking)  
      )
      (
      (textureDelete :pointer)                  ;   Method: Delete a texture  
      )
      (
      (bitmapNew :pointer)                      ;   Method: Create a bitmap (load is non-blocking)   
      )
      (
      (bitmapDetach :pointer)                   ;   Method: Complete load of a bitmap (blocking)  
      )
      (
      (bitmapDelete :pointer)                   ;   Method: Delete a bitmap  
      )
      (
      (colorTableNew :pointer)                  ;   Method: Create a new color table  
      )
      (
      (colorTableDelete :pointer)               ;   Method: Create a new color table  
      )
      (
      (textureBindColorTable :pointer)          ;   Method: Bind a CLUT to a texture  
      )
      (
      (bitmapBindColorTable :pointer)           ;   Method: Bind a CLUT to a bitmap  
      )
      (
      (accessTexture :pointer)
      )
      (
      (accessTextureEnd :pointer)
      )
      (
      (accessBitmap :pointer)
      )
      (
      (accessBitmapEnd :pointer)
      )
      )
   )

(def-mactype :tqaenginemethodtag (find-mactype ':signed-long))

(defconstant $kQADrawPrivateNew 0)
(defconstant $kQADrawPrivateDelete 1)
(defconstant $kQAEngineCheckDevice 2)
(defconstant $kQAEngineGestalt 3)
(defconstant $kQATextureNew 4)
(defconstant $kQATextureDetach 5)
(defconstant $kQATextureDelete 6)
(defconstant $kQABitmapNew 7)
(defconstant $kQABitmapDetach 8)
(defconstant $kQABitmapDelete 9)
(defconstant $kQAColorTableNew 10)
(defconstant $kQAColorTableDelete 11)
(defconstant $kQATextureBindColorTable 12)
(defconstant $kQABitmapBindColorTable 13)
(defconstant $kQAAccessTexture 14)
(defconstant $kQAAccessTextureEnd 15)
(defconstant $kQAAccessBitmap 16)
(defconstant $kQAAccessBitmapEnd 17)

; 	***********************************************************************************************
; 	 *
; 	 * QARegisterEngine() registers a new engine. This is called at boot time by the drawing engine
; 	 * initialization code to register itself with the system. This call takes only one parameter,
; 	 * the engine's function that allows the manager to request the other methods.
; 	 *
; 	 **********************************************************************************************	
; 	 TQAEngineGetMethod   parameter descriptions 	
; 	  TQAEngineMethodTag      methodTag               Method being requested 	
; 	  TQAEngineMethod         *method                 (Out) Method 	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQAEngineGetMethod = FUNCTION(methodTag: TQAEngineMethodTag; VAR method: TQAEngineMethod): TQAError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tqaenginegetmethod (find-mactype ':pointer))
; $ENDC

; 	 QARegisterEngine parameter descriptions 	
; 	  TQAEngineGetMethod      engineGetMethod     Engine's getMethod method 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  QARegisterEngine()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_QARegisterEngine" 
      ((engineGetMethod :pointer)) 
  :tqaerror
   () )

;  QARegisterEngineWithRefCon parameter descriptions 
;   TQAEngineGetMethod      engineGetMethod     Engine's getMethod method 
;   long                    refCon              Engine RefCon 
; 
;  *  QARegisterEngineWithRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_QARegisterEngineWithRefCon" 
      ((engineGetMethod :pointer) (refCon :signed-long)) 
  :tqaerror
   () )

;  QAGetEngineRefCon parameter descriptions 
; 
;  *  QAGetCurrentEngineRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_QAGetCurrentEngineRefCon" 
      () 
  :signed-long
   () )

; ***********************************************************************************************
;  *
;  * The TQADrawMethod union is used to represent a single draw context method (it's a
;  * parameter to QARegisterDrawMethod). TQADrawMethodTag identifies which method is being
;  * passed.
;  *
;  **********************************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tqadrawmethodptr (find-mactype '(:pointer :tqadrawmethod)))
(defrecord TQADrawMethod 
   (:variant 
      (
      (setFloat :pointer)                       ;   Method: Set a float state variable  
      )
      (
      (setInt :pointer)                         ;   Method: Set an unsigned long state variable  
      )
      (
      (setPtr :pointer)                         ;   Method: Set an unsigned long state variable  
      )
      (
      (getFloat :pointer)                       ;   Method: Get a float state variable  
      )
      (
      (getInt :pointer)                         ;   Method: Get an unsigned long state variable  
      )
      (
      (getPtr :pointer)                         ;   Method: Get an pointer state variable  
      )
      (
      (drawPoint :pointer)                      ;   Method: Draw a point  
      )
      (
      (drawLine :pointer)                       ;   Method: Draw a line  
      )
      (
      (drawTriGouraud :pointer)                 ;   Method: Draw a Gouraud shaded triangle  
      )
      (
      (drawTriTexture :pointer)                 ;   Method: Draw a texture mapped triangle  
      )
      (
      (drawVGouraud :pointer)                   ;   Method: Draw Gouraud vertices  
      )
      (
      (drawVTexture :pointer)                   ;   Method: Draw texture vertices  
      )
      (
      (drawBitmap :pointer)                     ;   Method: Draw a bitmap  
      )
      (
      (renderStart :pointer)                    ;   Method: Initialize for rendering  
      )
      (
      (renderEnd :pointer)                      ;   Method: Complete rendering and display  
      )
      (
      (renderAbort :pointer)                    ;   Method: Abort any outstanding rendering (blocking)  
      )
      (
      (flush :pointer)                          ;   Method: Start render of any queued commands (non-blocking)  
      )
      (
      (sync :pointer)                           ;   Method: Wait for completion of all rendering (blocking)  
      )
      (
      (submitVerticesGouraud :pointer)          ;   Method: Submit Gouraud vertices for trimesh  
      )
      (
      (submitVerticesTexture :pointer)          ;   Method: Submit Texture vertices for trimesh  
      )
      (
      (drawTriMeshGouraud :pointer)             ;   Method: Draw a Gouraud triangle mesh  
      )
      (
      (drawTriMeshTexture :pointer)             ;   Method: Draw a Texture triangle mesh  
      )
      (
      (setNoticeMethod :pointer)                ;   Method: Set a notice method  
      )
      (
      (getNoticeMethod :pointer)                ;   Method: Get a notice method  
      )
;   new in 1.6  
      (
      (submitMultiTextureParams :pointer)       ;   Method: Submit secondary texture params  
      )
      (
      (accessDrawBuffer :pointer)
      )
      (
      (accessDrawBufferEnd :pointer)
      )
      (
      (accessZBuffer :pointer)
      )
      (
      (accessZBufferEnd :pointer)
      )
      (
      (clearDrawBuffer :pointer)
      )
      (
      (clearZBuffer :pointer)
      )
      (
      (textureFromContext :pointer)
      )
      (
      (bitmapFromContext :pointer)
      )
      (
      (busy :pointer)
      )
      (
      (swapBuffers :pointer)
      )
      )
   )

(def-mactype :tqadrawmethodtag (find-mactype ':signed-long))

(defconstant $kQASetFloat 0)
(defconstant $kQASetInt 1)
(defconstant $kQASetPtr 2)
(defconstant $kQAGetFloat 3)
(defconstant $kQAGetInt 4)
(defconstant $kQAGetPtr 5)
(defconstant $kQADrawPoint 6)
(defconstant $kQADrawLine 7)
(defconstant $kQADrawTriGouraud 8)
(defconstant $kQADrawTriTexture 9)
(defconstant $kQADrawVGouraud 10)
(defconstant $kQADrawVTexture 11)
(defconstant $kQADrawBitmap 12)
(defconstant $kQARenderStart 13)
(defconstant $kQARenderEnd 14)
(defconstant $kQARenderAbort 15)
(defconstant $kQAFlush 16)
(defconstant $kQASync 17)
(defconstant $kQASubmitVerticesGouraud 18)
(defconstant $kQASubmitVerticesTexture 19)
(defconstant $kQADrawTriMeshGouraud 20)
(defconstant $kQADrawTriMeshTexture 21)
(defconstant $kQASetNoticeMethod 22)
(defconstant $kQAGetNoticeMethod 23)
(defconstant $kQSubmitMultiTextureParams 24)
(defconstant $kQAccessDrawBuffer 25)
(defconstant $kQAccessDrawBufferEnd 26)
(defconstant $kQAccessZBuffer 27)
(defconstant $kQAccessZBufferEnd 28)
(defconstant $kQClearDrawBuffer 29)
(defconstant $kQClearZBuffer 30)
(defconstant $kQTextureNewFromDrawContext 31)
(defconstant $kQBitmapNewFromDrawContext 32)
(defconstant $kQBusy 33)
(defconstant $kQSwapBuffers 34)

; 	***********************************************************************************************
; 	 *
; 	 * System call to register a new method for an engine. This is called during the engine's
; 	 * draw private new functions (to set the initial value of the draw methods), and possibly
; 	 * at other times when the engine needs to change a draw method.
; 	 *
; 	 **********************************************************************************************	
; 	 QARegisterDrawMethod parameter descriptions 	
; 	  TQADrawContext          *drawContext            Draw context in which to set method 	
; 	  TQADrawMethodTag        methodTag               Method to set 	
; 	  TQADrawMethod           method                  Method 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  QARegisterDrawMethod()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_QARegisterDrawMethod" 
      ((drawContext (:pointer :tqadrawcontext)) (methodTag :signed-long) (method :tqadrawmethod)) 
  :tqaerror
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := RAVESystemIncludes

; $ENDC                                         ; __RAVESYSTEM__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'RAVESystem)