(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:SFNTLayoutTypes.p"
; at Wednesday May 1,2002 2:40:28 pm.
; 
;      File:       SFNTLayoutTypes.p
;  
;      Contains:   SFNT file layout structures and constants.
;  
;      Version:    Technology: Mac OS 9 / Carbon
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1994-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __SFNTLAYOUTTYPES__
; $SETC __SFNTLAYOUTTYPES__ := 1

; $I+
; $SETC SFNTLayoutTypesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  ----------------------------------------------------------------------------------------- 
;  CONSTANTS 
; 
;     The following values can be used to set run feature values. Note that unless the
;     feature is defaulted differently in different fonts, the zero value for the
;     selectors represents the default value.  Check the following URL site for further info:
;     "http://fonts.apple.com/Registry"
; 

; 
;  *  Summary:
;  *    Feature types
;  

(defconstant $kAllTypographicFeaturesType 0)
(defconstant $kLigaturesType 1)
(defconstant $kCursiveConnectionType 2)
(defconstant $kLetterCaseType 3)
(defconstant $kVerticalSubstitutionType 4)
(defconstant $kLinguisticRearrangementType 5)
(defconstant $kNumberSpacingType 6)
(defconstant $kSmartSwashType 8)
(defconstant $kDiacriticsType 9)
(defconstant $kVerticalPositionType 10)
(defconstant $kFractionsType 11)
(defconstant $kOverlappingCharactersType 13)
(defconstant $kTypographicExtrasType 14)
(defconstant $kMathematicalExtrasType 15)
(defconstant $kOrnamentSetsType 16)
(defconstant $kCharacterAlternativesType 17)
(defconstant $kDesignComplexityType 18)
(defconstant $kStyleOptionsType 19)
(defconstant $kCharacterShapeType 20)
(defconstant $kNumberCaseType 21)
(defconstant $kTextSpacingType 22)
(defconstant $kTransliterationType 23)
(defconstant $kAnnotationType 24)
(defconstant $kKanaSpacingType 25)
(defconstant $kIdeographicSpacingType 26)
(defconstant $kUnicodeDecompositionType 27)
(defconstant $kRubyKanaType 28)
(defconstant $kCJKSymbolAlternativesType 29)
(defconstant $kIdeographicAlternativesType 30)
(defconstant $kCJKVerticalRomanPlacementType 31)
(defconstant $kItalicCJKRomanType 32)
(defconstant $kCJKRomanSpacingType 103)
(defconstant $kLastFeatureType -1)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kAllTypographicFeaturesType
; 	 	
(defconstant $kAllTypeFeaturesOnSelector 0)
(defconstant $kAllTypeFeaturesOffSelector 1)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kLigaturesType
; 	 	
(defconstant $kRequiredLigaturesOnSelector 0)
(defconstant $kRequiredLigaturesOffSelector 1)
(defconstant $kCommonLigaturesOnSelector 2)
(defconstant $kCommonLigaturesOffSelector 3)
(defconstant $kRareLigaturesOnSelector 4)
(defconstant $kRareLigaturesOffSelector 5)
(defconstant $kLogosOnSelector 6)
(defconstant $kLogosOffSelector 7)
(defconstant $kRebusPicturesOnSelector 8)
(defconstant $kRebusPicturesOffSelector 9)
(defconstant $kDiphthongLigaturesOnSelector 10)
(defconstant $kDiphthongLigaturesOffSelector 11)
(defconstant $kSquaredLigaturesOnSelector 12)
(defconstant $kSquaredLigaturesOffSelector 13)
(defconstant $kAbbrevSquaredLigaturesOnSelector 14)
(defconstant $kAbbrevSquaredLigaturesOffSelector 15)
(defconstant $kSymbolLigaturesOnSelector 16)
(defconstant $kSymbolLigaturesOffSelector 17)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kCursiveConnectionType
; 	 	
(defconstant $kUnconnectedSelector 0)
(defconstant $kPartiallyConnectedSelector 1)
(defconstant $kCursiveSelector 2)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kLetterCaseType
; 	 	
(defconstant $kUpperAndLowerCaseSelector 0)
(defconstant $kAllCapsSelector 1)
(defconstant $kAllLowerCaseSelector 2)
(defconstant $kSmallCapsSelector 3)
(defconstant $kInitialCapsSelector 4)
(defconstant $kInitialCapsAndSmallCapsSelector 5)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kVerticalSubstitutionType
; 	 	
(defconstant $kSubstituteVerticalFormsOnSelector 0)
(defconstant $kSubstituteVerticalFormsOffSelector 1)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kLinguisticRearrangementType
; 	 	
(defconstant $kLinguisticRearrangementOnSelector 0)
(defconstant $kLinguisticRearrangementOffSelector 1)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kNumberSpacingType
; 	 	
(defconstant $kMonospacedNumbersSelector 0)
(defconstant $kProportionalNumbersSelector 1)
(defconstant $kThirdWidthNumbersSelector 2)
(defconstant $kQuarterWidthNumbersSelector 3)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kSmartSwashType
; 	 	
(defconstant $kWordInitialSwashesOnSelector 0)
(defconstant $kWordInitialSwashesOffSelector 1)
(defconstant $kWordFinalSwashesOnSelector 2)
(defconstant $kWordFinalSwashesOffSelector 3)
(defconstant $kLineInitialSwashesOnSelector 4)
(defconstant $kLineInitialSwashesOffSelector 5)
(defconstant $kLineFinalSwashesOnSelector 6)
(defconstant $kLineFinalSwashesOffSelector 7)
(defconstant $kNonFinalSwashesOnSelector 8)
(defconstant $kNonFinalSwashesOffSelector 9)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kDiacriticsType
; 	 	
(defconstant $kShowDiacriticsSelector 0)
(defconstant $kHideDiacriticsSelector 1)
(defconstant $kDecomposeDiacriticsSelector 2)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kVerticalPositionType
; 	 	
(defconstant $kNormalPositionSelector 0)
(defconstant $kSuperiorsSelector 1)
(defconstant $kInferiorsSelector 2)
(defconstant $kOrdinalsSelector 3)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kFractionsType
; 	 	
(defconstant $kNoFractionsSelector 0)
(defconstant $kVerticalFractionsSelector 1)
(defconstant $kDiagonalFractionsSelector 2)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kOverlappingCharactersType
; 	 	
(defconstant $kPreventOverlapOnSelector 0)
(defconstant $kPreventOverlapOffSelector 1)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kTypographicExtrasType
; 	 	
(defconstant $kHyphensToEmDashOnSelector 0)
(defconstant $kHyphensToEmDashOffSelector 1)
(defconstant $kHyphenToEnDashOnSelector 2)
(defconstant $kHyphenToEnDashOffSelector 3)
(defconstant $kSlashedZeroOnSelector 4)
(defconstant $kSlashedZeroOffSelector 5)
(defconstant $kFormInterrobangOnSelector 6)
(defconstant $kFormInterrobangOffSelector 7)
(defconstant $kSmartQuotesOnSelector 8)
(defconstant $kSmartQuotesOffSelector 9)
(defconstant $kPeriodsToEllipsisOnSelector 10)
(defconstant $kPeriodsToEllipsisOffSelector 11)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kMathematicalExtrasType
; 	 	
(defconstant $kHyphenToMinusOnSelector 0)
(defconstant $kHyphenToMinusOffSelector 1)
(defconstant $kAsteriskToMultiplyOnSelector 2)
(defconstant $kAsteriskToMultiplyOffSelector 3)
(defconstant $kSlashToDivideOnSelector 4)
(defconstant $kSlashToDivideOffSelector 5)
(defconstant $kInequalityLigaturesOnSelector 6)
(defconstant $kInequalityLigaturesOffSelector 7)
(defconstant $kExponentsOnSelector 8)
(defconstant $kExponentsOffSelector 9)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kOrnamentSetsType
; 	 	
(defconstant $kNoOrnamentsSelector 0)
(defconstant $kDingbatsSelector 1)
(defconstant $kPiCharactersSelector 2)
(defconstant $kFleuronsSelector 3)
(defconstant $kDecorativeBordersSelector 4)
(defconstant $kInternationalSymbolsSelector 5)
(defconstant $kMathSymbolsSelector 6)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kCharacterAlternativesType
; 	 	
(defconstant $kNoAlternatesSelector 0)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kDesignComplexityType
; 	 	
(defconstant $kDesignLevel1Selector 0)
(defconstant $kDesignLevel2Selector 1)
(defconstant $kDesignLevel3Selector 2)
(defconstant $kDesignLevel4Selector 3)
(defconstant $kDesignLevel5Selector 4)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kStyleOptionsType
; 	 	
(defconstant $kNoStyleOptionsSelector 0)
(defconstant $kDisplayTextSelector 1)
(defconstant $kEngravedTextSelector 2)
(defconstant $kIlluminatedCapsSelector 3)
(defconstant $kTitlingCapsSelector 4)
(defconstant $kTallCapsSelector 5)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kCharacterShapeType
; 	 	
(defconstant $kTraditionalCharactersSelector 0)
(defconstant $kSimplifiedCharactersSelector 1)
(defconstant $kJIS1978CharactersSelector 2)
(defconstant $kJIS1983CharactersSelector 3)
(defconstant $kJIS1990CharactersSelector 4)
(defconstant $kTraditionalAltOneSelector 5)
(defconstant $kTraditionalAltTwoSelector 6)
(defconstant $kTraditionalAltThreeSelector 7)
(defconstant $kTraditionalAltFourSelector 8)
(defconstant $kTraditionalAltFiveSelector 9)
(defconstant $kExpertCharactersSelector 10)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kNumberCaseType
; 	 	
(defconstant $kLowerCaseNumbersSelector 0)
(defconstant $kUpperCaseNumbersSelector 1)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kTextSpacingType
; 	 	
(defconstant $kProportionalTextSelector 0)
(defconstant $kMonospacedTextSelector 1)
(defconstant $kHalfWidthTextSelector 2)
(defconstant $kNormallySpacedTextSelector 3)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kTransliterationType
; 	 	
(defconstant $kNoTransliterationSelector 0)
(defconstant $kHanjaToHangulSelector 1)
(defconstant $kHiraganaToKatakanaSelector 2)
(defconstant $kKatakanaToHiraganaSelector 3)
(defconstant $kKanaToRomanizationSelector 4)
(defconstant $kRomanizationToHiraganaSelector 5)
(defconstant $kRomanizationToKatakanaSelector 6)
(defconstant $kHanjaToHangulAltOneSelector 7)
(defconstant $kHanjaToHangulAltTwoSelector 8)
(defconstant $kHanjaToHangulAltThreeSelector 9)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kAnnotationType
; 	 	
(defconstant $kNoAnnotationSelector 0)
(defconstant $kBoxAnnotationSelector 1)
(defconstant $kRoundedBoxAnnotationSelector 2)
(defconstant $kCircleAnnotationSelector 3)
(defconstant $kInvertedCircleAnnotationSelector 4)
(defconstant $kParenthesisAnnotationSelector 5)
(defconstant $kPeriodAnnotationSelector 6)
(defconstant $kRomanNumeralAnnotationSelector 7)
(defconstant $kDiamondAnnotationSelector 8)
(defconstant $kInvertedBoxAnnotationSelector 9)
(defconstant $kInvertedRoundedBoxAnnotationSelector 10)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kKanaSpacingType
; 	 	
(defconstant $kFullWidthKanaSelector 0)
(defconstant $kProportionalKanaSelector 1)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kIdeographicSpacingType
; 	 	
(defconstant $kFullWidthIdeographsSelector 0)
(defconstant $kProportionalIdeographsSelector 1)
(defconstant $kHalfWidthIdeographsSelector 2)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kUnicodeDecompositionType
; 	 	
(defconstant $kCanonicalCompositionOnSelector 0)
(defconstant $kCanonicalCompositionOffSelector 1)
(defconstant $kCompatibilityCompositionOnSelector 2)
(defconstant $kCompatibilityCompositionOffSelector 3)
(defconstant $kTranscodingCompositionOnSelector 4)
(defconstant $kTranscodingCompositionOffSelector 5)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kRubyKanaType
; 	 	
(defconstant $kNoRubyKanaSelector 0)
(defconstant $kRubyKanaSelector 1)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kCJKSymbolAlternativesType
; 	 	
(defconstant $kNoCJKSymbolAlternativesSelector 0)
(defconstant $kCJKSymbolAltOneSelector 1)
(defconstant $kCJKSymbolAltTwoSelector 2)
(defconstant $kCJKSymbolAltThreeSelector 3)
(defconstant $kCJKSymbolAltFourSelector 4)
(defconstant $kCJKSymbolAltFiveSelector 5)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kIdeographicAlternativesType
; 	 	
(defconstant $kNoIdeographicAlternativesSelector 0)
(defconstant $kIdeographicAltOneSelector 1)
(defconstant $kIdeographicAltTwoSelector 2)
(defconstant $kIdeographicAltThreeSelector 3)
(defconstant $kIdeographicAltFourSelector 4)
(defconstant $kIdeographicAltFiveSelector 5)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kCJKVerticalRomanPlacementType
; 	 	
(defconstant $kCJKVerticalRomanCenteredSelector 0)
(defconstant $kCJKVerticalRomanHBaselineSelector 1)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kItalicCJKRomanType
; 	 	
(defconstant $kNoCJKItalicRomanSelector 0)
(defconstant $kCJKItalicRomanSelector 1)

; 
; 	 *  Summary:
; 	 *    Selectors for feature type kCJKRomanSpacingType
; 	 	
(defconstant $kHalfWidthCJKRomanSelector 0)
(defconstant $kProportionalCJKRomanSelector 1)
(defconstant $kDefaultCJKRomanSelector 2)
(defconstant $kFullWidthCJKRomanSelector 3)

; 	 --------------------------------------------------------------------------- 	
; 	 ---------------- Table Specific Typedefs and Constants -------------------- 	
; 	 --------------------------------------------------------------------------- 	
; 	 FORMATS FOR TABLE: lookup tables - used within various other tables 	
(defconstant $kSFNTLookupSimpleArray 0)         ;   a simple array indexed by glyph code  
(defconstant $kSFNTLookupSegmentSingle 2)       ;   segment mapping to single value  
(defconstant $kSFNTLookupSegmentArray 4)        ;   segment mapping to lookup array  
(defconstant $kSFNTLookupSingleTable 6)         ;   sorted list of glyph, value pairs  
(defconstant $kSFNTLookupTrimmedArray 8)        ;   a simple trimmed array indexed by glyph code  

(def-mactype :sfntlookuptableformat (find-mactype ':unsigned-integer))
(def-mactype :sfntlookupvalue (find-mactype ':unsigned-integer))
(def-mactype :sfntlookupoffset (find-mactype ':unsigned-integer))
(def-mactype :sfntlookupkind (find-mactype ':unsigned-long))
; 	
; 	    A BinarySearchHeader defines the five standard fields needed to perform quick
; 	    lookups in a lookup table (note that using UInt16s, and not ItemCounts or
; 	    similar types, is important here, since these tables are in fonts, and the
; 	    documented font formats specify 16-bit quantities).
; 		
(def-mactype :sfntlookupbinarysearchheaderptr (find-mactype '(:pointer :sfntlookupbinarysearchheader)))
(defrecord SFNTLookupBinarySearchHeader 
   (unitSize :unsigned-integer)                 ;   size of a unit in bytes  
   (nUnits :unsigned-integer)                   ;   number of units in table  
   (searchRange :unsigned-integer)              ;   (largest power of two <= nUnits) * unitSize  
   (entrySelector :unsigned-integer)            ;   log2 (largest power of two <= nUnits)  
   (rangeShift :unsigned-integer)               ;   (nUnits - largest power of two <= nUnits) * unitSize  
   )

; 	 A format 0 lookup table maps all glyphs in the font to lookup values 	
(def-mactype :sfntlookuparrayheaderptr (find-mactype '(:pointer :sfntlookuparrayheader)))
(defrecord SFNTLookupArrayHeader 
   (lookupValues (:array :unsigned-integer 1))
   )

; 	 A format 8 lookup table maps some range of glyphs in the font to lookup values 	
(def-mactype :sfntlookuptrimmedarrayheaderptr (find-mactype '(:pointer :sfntlookuptrimmedarrayheader)))
(defrecord SFNTLookupTrimmedArrayHeader 
   (firstGlyph :unsigned-integer)
   (count :unsigned-integer)
   (valueArray (:array :unsigned-integer 1))
   )

; 	
; 	    Format 2 and format 4 lookup tables map ranges of glyphs to either single lookup
; 	    values (format 2), or per-glyph lookup values (format 4). Since both formats
; 	    use the same kind of data, only one unified set of segment-related structures
; 	    is defined.
; 		
(def-mactype :sfntlookupsegmentptr (find-mactype '(:pointer :sfntlookupsegment)))
(defrecord SFNTLookupSegment 
   (lastGlyph :unsigned-integer)
   (firstGlyph :unsigned-integer)
   (value (:array :unsigned-integer 1))
   )

(def-mactype :sfntlookupsegmentheaderptr (find-mactype '(:pointer :sfntlookupsegmentheader)))
(defrecord SFNTLookupSegmentHeader 
   (binSearch :sfntlookupbinarysearchheader)
   (segments (:array :sfntlookupsegment 1))
   )

; 	 A format 6 lookup table maps single glyphs to lookup values. 	
(def-mactype :sfntlookupsingleptr (find-mactype '(:pointer :sfntlookupsingle)))
(defrecord SFNTLookupSingle 
   (glyph :unsigned-integer)
   (value (:array :unsigned-integer 1))
   )

(def-mactype :sfntlookupsingleheaderptr (find-mactype '(:pointer :sfntlookupsingleheader)))
(defrecord SFNTLookupSingleHeader 
   (binSearch :sfntlookupbinarysearchheader)
   (entries (:array :sfntlookupsingle 1))
   )

; 	 The format-specific part of the subtable header 	
(def-mactype :sfntlookupformatspecificheaderptr (find-mactype '(:pointer :sfntlookupformatspecificheader)))
(defrecord SFNTLookupFormatSpecificHeader 
   (:variant 
      (
      (theArray :sfntlookuparrayheader)
      )
      (
      (segment :sfntlookupsegmentheader)
      )
      (
      (single :sfntlookupsingleheader)
      )
      (
      (trimmedArray :sfntlookuptrimmedarrayheader)
      )
      )
   )

; 	 The overall subtable header 	
(def-mactype :sfntlookuptableptr (find-mactype '(:pointer :sfntlookuptable)))
(defrecord SFNTLookupTable 
   (format :unsigned-integer)                   ;   table format  
   (fsHeader :sfntlookupformatspecificheader)   ;   format specific header  
   )

(def-mactype :sfntlookuptablehandle (find-mactype '(:handle :sfntlookuptable)))
; 	 --------------------------------------------------------------------------- 	
; 	 GENERAL FORMATS FOR STATE TABLES -- prefix "ST" 	

(defconstant $kSTClassEndOfText 0)
(defconstant $kSTClassOutOfBounds 1)
(defconstant $kSTClassDeletedGlyph 2)
(defconstant $kSTClassEndOfLine 3)
(defconstant $kSTSetMark #x8000)
(defconstant $kSTNoAdvance #x4000)
(defconstant $kSTMarkEnd #x2000)
(defconstant $kSTLigActionMask #x3FFF)
(defconstant $kSTRearrVerbMask #xF)

(def-mactype :stclass (find-mactype ':unsigned-byte))
(def-mactype :stentryindex (find-mactype ':unsigned-byte))
(def-mactype :stheaderptr (find-mactype '(:pointer :stheader)))
(defrecord STHeader 
   (filler :signed-byte)
   (nClasses :signed-byte)
   (classTableOffset :unsigned-integer)
   (stateArrayOffset :unsigned-integer)
   (entryTableOffset :unsigned-integer)
   )

(def-mactype :stclasstableptr (find-mactype '(:pointer :stclasstable)))
(defrecord STClassTable 
   (firstGlyph :unsigned-integer)
   (nGlyphs :unsigned-integer)
   (classes :signed-byte)
   )

(def-mactype :stentryzeroptr (find-mactype '(:pointer :stentryzero)))
(defrecord STEntryZero 
   (newState :unsigned-integer)
   (flags :unsigned-integer)
   )

(def-mactype :stentryoneptr (find-mactype '(:pointer :stentryone)))
(defrecord STEntryOne 
   (newState :unsigned-integer)
   (flags :unsigned-integer)
   (offset1 :unsigned-integer)
   )

(def-mactype :stentrytwoptr (find-mactype '(:pointer :stentrytwo)))
(defrecord STEntryTwo 
   (newState :unsigned-integer)
   (flags :unsigned-integer)
   (offset1 :unsigned-integer)
   (offset2 :unsigned-integer)
   )

; 	 --------------------------------------------------------------------------- 	
; 	 GENERAL FORMATS FOR STATE TABLES to be used with 'morx' tables -- prefix "STX" 	

(defconstant $kSTXHasLigAction #x2000)

(def-mactype :stxclass (find-mactype ':unsigned-integer))
(def-mactype :stxstateindex (find-mactype ':unsigned-integer))
(def-mactype :stxentryindex (find-mactype ':unsigned-integer))
(def-mactype :stxheaderptr (find-mactype '(:pointer :stxheader)))
(defrecord STXHeader 
   (nClasses :unsigned-long)
   (classTableOffset :unsigned-long)
   (stateArrayOffset :unsigned-long)
   (entryTableOffset :unsigned-long)
   )

(%define-record :stxclasstable (find-record-descriptor :sfntlookuptable))
(def-mactype :stxclasstableptr (find-mactype '(:pointer :sfntlookuptable)))
(def-mactype :stxentryzeroptr (find-mactype '(:pointer :stxentryzero)))
(defrecord STXEntryZero 
   (newState :unsigned-integer)
   (flags :unsigned-integer)
   )

(def-mactype :stxentryoneptr (find-mactype '(:pointer :stxentryone)))
(defrecord STXEntryOne 
   (newState :unsigned-integer)
   (flags :unsigned-integer)
   (index1 :unsigned-integer)
   )

(def-mactype :stxentrytwoptr (find-mactype '(:pointer :stxentrytwo)))
(defrecord STXEntryTwo 
   (newState :unsigned-integer)
   (flags :unsigned-integer)
   (index1 :unsigned-integer)
   (index2 :unsigned-integer)
   )

; 	 --------------------------------------------------------------------------- 	
; 	 FORMATS FOR TABLE: 'lcar' 	
; 	 CONSTANTS 	

(defconstant $kLCARTag #x6C636172)              ;   'lcar'  
(defconstant $kLCARCurrentVersion #x10000)      ;   current version number for 'lcar' table  
(defconstant $kLCARLinearFormat 0)
(defconstant $kLCARCtlPointFormat 1)

; 	 TYPES 	

(def-mactype :lcarcaretclassentryptr (find-mactype '(:pointer :lcarcaretclassentry)))
(defrecord LcarCaretClassEntry 
   (count :unsigned-integer)
   (partials (:array :unsigned-integer 1))      ;   these are either FUnits or control-point numbers  
   )

(def-mactype :lcarcarettableptr (find-mactype '(:pointer :lcarcarettable)))
(defrecord LcarCaretTable 
   (version :signed-long)
   (format :unsigned-integer)
   (lookup :sfntlookuptable)
   )

; 	 --------------------------------------------------------------------------- 	
; 	 FORMATS FOR TABLE: 'just' 	
; 	 CONSTANTS 	

(defconstant $kJUSTTag #x6A757374)              ;   'just'  
(defconstant $kJUSTCurrentVersion #x10000)
(defconstant $kJUSTStandardFormat 0)
(defconstant $kJUSTnoGlyphcode #xFFFF)          ;   used in a pcConditionalAddAction  
(defconstant $kJUSTpcDecompositionAction 0)
(defconstant $kJUSTpcUnconditionalAddAction 1)
(defconstant $kJUSTpcConditionalAddAction 2)
(defconstant $kJUSTpcGlyphStretchAction 3)
(defconstant $kJUSTpcDuctilityAction 4)
(defconstant $kJUSTpcGlyphRepeatAddAction 5)

; 	 Justification priority levels 	
(defconstant $kJUSTKashidaPriority 0)
(defconstant $kJUSTSpacePriority 1)
(defconstant $kJUSTLetterPriority 2)
(defconstant $kJUSTNullPriority 3)
(defconstant $kJUSTPriorityCount 4)

; 	 Justification flags 	
(defconstant $kJUSTOverridePriority #x8000)
(defconstant $kJUSTOverrideLimits #x4000)
(defconstant $kJUSTOverrideUnlimited #x2000)
(defconstant $kJUSTUnlimited #x1000)
(defconstant $kJUSTPriorityMask #x3)

; 	 TYPES 	

(def-mactype :justpcactiontype (find-mactype ':unsigned-integer))
(def-mactype :justificationflags (find-mactype ':unsigned-integer))
; 	 A JustPCDecompositionAction defines a ligature decomposition action. 	
(def-mactype :justpcdecompositionactionptr (find-mactype '(:pointer :justpcdecompositionaction)))
(defrecord JustPCDecompositionAction 
   (lowerLimit :signed-long)
   (upperLimit :signed-long)
   (order :unsigned-integer)
   (count :unsigned-integer)
   (glyphs (:array :unsigned-integer 1))
   )

; 	 A JUSTPCUnconditionalAddAction defines an unconditional glyph add action. 	
(def-mactype :justpcunconditionaladdaction (find-mactype ':unsigned-integer))
; 	
; 	    A JUSTPCConditionalAddAction defines a glyph substitution and add action. If the addGlyph
; 	    is equal to kJUSTnoGlyphcode, then no glyph will be added, and the justification for
; 	    the line will be redone.
; 		
(def-mactype :justpcconditionaladdactionptr (find-mactype '(:pointer :justpcconditionaladdaction)))
(defrecord JustPCConditionalAddAction 
   (substThreshhold :signed-long)               ;   threshhold of growth factor at which subst occurs  
   (addGlyph :unsigned-integer)
   (substGlyph :unsigned-integer)
   )

; 	 A PCDuctilityAction defines a ductile axis along which the glyph will be varied. 	
(def-mactype :justpcductilityactionptr (find-mactype '(:pointer :justpcductilityaction)))
(defrecord JustPCDuctilityAction 
   (ductilityAxis :unsigned-long)
   (minimumLimit :signed-long)
   (noStretchValue :signed-long)
   (maximumLimit :signed-long)
   )

; 	
; 	    A PCGlyphRepetitionAction defines a glyph which will not be stretched or otherwise
; 	    transformed, but rather which will be emplaced however many times are needed to fill
; 	    the needed gap.
; 		
(def-mactype :justpcglyphrepeataddactionptr (find-mactype '(:pointer :justpcglyphrepeataddaction)))
(defrecord JustPCGlyphRepeatAddAction 
   (flags :unsigned-integer)
   (glyph :unsigned-integer)
   )

; 	 PCActionSubrecords contain the actual postcompensation actions. 	
(def-mactype :justpcactionsubrecordptr (find-mactype '(:pointer :justpcactionsubrecord)))
(defrecord JustPCActionSubrecord 
   (theClass :unsigned-integer)                 ;   justification class value associated with this rec  
   (theType :unsigned-integer)
   (length :unsigned-long)
   (data :unsigned-long)                        ;   not really a UInt32; cast as ptr to appropriate action  
   )

; 	 The set of postcompensation records is defined in a PCAction struct. 	
(def-mactype :justpcactionptr (find-mactype '(:pointer :justpcaction)))
(defrecord JustPCAction 
   (actionCount :unsigned-long)                 ;   long for alignment purposes  
   (actions (:array :justpcactionsubrecord 1))
   )

; 	
; 	    JustWidthDeltaEntry is the justification table entry structure.  The justClass value (which is
; 	    actually limited to 7 bits by the state table structure) is defined as a long for PPC alignment reasons.
; 		
(def-mactype :justwidthdeltaentryptr (find-mactype '(:pointer :justwidthdeltaentry)))
(defrecord JustWidthDeltaEntry 
   (justClass :unsigned-long)
   (beforeGrowLimit :signed-long)               ;   ems AW can grow by at most on LT  
   (beforeShrinkLimit :signed-long)             ;   ems AW can shrink by at most on LT  
   (afterGrowLimit :signed-long)                ;   ems AW can grow by at most on RB  
   (afterShrinkLimit :signed-long)              ;   ems AW can shrink by at most on RB  
   (growFlags :unsigned-integer)                ;   flags controlling grow case  
   (shrinkFlags :unsigned-integer)              ;   flags controlling shrink case  
   )

(def-mactype :justwidthdeltagroupptr (find-mactype '(:pointer :justwidthdeltagroup)))
(defrecord JustWidthDeltaGroup 
   (count :unsigned-long)
   (entries (:array :justwidthdeltaentry 1))
   )

; 	 Overall structure of a postcompensation table is defined in PostcompTable. 	
(def-mactype :justpostcomptableptr (find-mactype '(:pointer :justpostcomptable)))
(defrecord JustPostcompTable 
   (lookupTable :sfntlookuptable)
;   action records here  
   )

(def-mactype :justdirectiontableptr (find-mactype '(:pointer :justdirectiontable)))
(defrecord JustDirectionTable 
   (justClass :unsigned-integer)                ;   offset to state table (0=none)  
   (widthDeltaClusters :unsigned-integer)       ;   offset to clusters  
   (postcomp :unsigned-integer)                 ;   offset to postcomp table (0=none)  
   (lookup :sfntlookuptable)
   )

(def-mactype :justtableptr (find-mactype '(:pointer :justtable)))
(defrecord JustTable 
   (version :signed-long)
   (format :unsigned-integer)
   (horizHeaderOffset :unsigned-integer)
   (vertHeaderOffset :unsigned-integer)
   )

; 	 --------------------------------------------------------------------------- 	
; 	 FORMATS FOR TABLE: 'opbd' 	
; 	 CONSTANTS 	

(defconstant $kOPBDTag #x6F706264)              ;   'opbd'  
(defconstant $kOPBDCurrentVersion #x10000)
(defconstant $kOPBDDistanceFormat 0)
(defconstant $kOPBDControlPointFormat 1)

; 	 TYPES 	

(def-mactype :opbdtableformat (find-mactype ':unsigned-integer))
; 	
; 	    The OpbdSideValues struct is the lookup result from the FindSingle call for the
; 	    optical tables. It contains the 4 FUnit values that are relevant to the specified
; 	    glyph, or the 4 control gxPoint values.
; 		
(def-mactype :opbdsidevaluesptr (find-mactype '(:pointer :opbdsidevalues)))
(defrecord OpbdSideValues 
   (leftSideShift :signed-integer)
   (topSideShift :signed-integer)
   (rightSideShift :signed-integer)
   (bottomSideShift :signed-integer)
   )

(def-mactype :opbdtableptr (find-mactype '(:pointer :opbdtable)))
(defrecord OpbdTable 
   (version :signed-long)
   (format :unsigned-integer)
   (lookupTable :sfntlookuptable)
   )

; 	 --------------------------------------------------------------------------- 	
; 	 FORMATS FOR TABLE: 'mort' 	
; 	 CONSTANTS 	

(defconstant $kMORTTag #x6D6F7274)              ;   'mort'  
(defconstant $kMORTCurrentVersion #x10000)      ;   current version number for 'mort' table  
;   Coverage masks  
(defconstant $kMORTCoverVertical #x8000)
(defconstant $kMORTCoverDescending #x4000)
(defconstant $kMORTCoverIgnoreVertical #x2000)
(defconstant $kMORTCoverTypeMask #xF)           ;   Subtable types  
(defconstant $kMORTRearrangementType 0)
(defconstant $kMORTContextualType 1)
(defconstant $kMORTLigatureType 2)
(defconstant $kMORTSwashType 4)
(defconstant $kMORTInsertionType 5)             ;   Ligature subtable constants  
(defconstant $kMORTLigLastAction #x80000000)
(defconstant $kMORTLigStoreLigature #x40000000)
(defconstant $kMORTLigFormOffsetMask #x3FFFFFFF)
(defconstant $kMORTLigFormOffsetShift 2)        ;   Rearrangement subtable actions  
(defconstant $kMORTraNoAction 0)                ;      no action    
(defconstant $kMORTraxA 1)                      ;        Ax => xA     
(defconstant $kMORTraDx 2)                      ;        xD => Dx     
(defconstant $kMORTraDxA 3)                     ;       AxD => DxA    
(defconstant $kMORTraxAB 4)                     ;     ABx => xAB    
(defconstant $kMORTraxBA 5)                     ;     ABx => xBA    
(defconstant $kMORTraCDx 6)                     ;     xCD => CDx    
(defconstant $kMORTraDCx 7)                     ;     xCD => DCx    
(defconstant $kMORTraCDxA 8)                    ;    AxCD => CDxA   
(defconstant $kMORTraDCxA 9)                    ;    AxCD => DCxA   
(defconstant $kMORTraDxAB 10)                   ;    ABxD => DxAB   
(defconstant $kMORTraDxBA 11)                   ;    ABxD => DxBA   
(defconstant $kMORTraCDxAB 12)                  ;   ABxCD => CDxAB  
(defconstant $kMORTraCDxBA 13)                  ;   ABxCD => CDxBA  
(defconstant $kMORTraDCxAB 14)                  ;   ABxCD => DCxAB  
(defconstant $kMORTraDCxBA 15)                  ;   ABxCD => DCxBA  
;   Insertion subtable constants  
(defconstant $kMORTDoInsertionsBefore #x80)
(defconstant $kMORTIsSplitVowelPiece #x40)
(defconstant $kMORTInsertionsCountMask #x3F)
(defconstant $kMORTCurrInsertKashidaLike #x2000)
(defconstant $kMORTMarkInsertKashidaLike #x1000)
(defconstant $kMORTCurrInsertBefore #x800)
(defconstant $kMORTMarkInsertBefore #x400)
(defconstant $kMORTMarkJustTableCountMask #x3F80)
(defconstant $kMORTMarkJustTableCountShift 7)   ;   JustTableIndex for marked character  
(defconstant $kMORTCurrJustTableCountMask #x7F)
(defconstant $kMORTCurrJustTableCountShift 0)   ;   JustTableIndex for current character  
(defconstant $kMORTCurrInsertCountMask #x3E0)
(defconstant $kMORTCurrInsertCountShift 5)      ;   count to insert after current glyphRec  
(defconstant $kMORTMarkInsertCountMask #x1F)
(defconstant $kMORTMarkInsertCountShift 0)      ;   count to insert after marked glyphRec  

; 	 TYPES 	

(def-mactype :mortsubtablemaskflags (find-mactype ':unsigned-long))
(def-mactype :mortligatureactionentry (find-mactype ':unsigned-long))
(def-mactype :mortrearrangementsubtableptr (find-mactype '(:pointer :mortrearrangementsubtable)))
(defrecord MortRearrangementSubtable 
   (header :stheader)
   )

(def-mactype :mortcontextualsubtableptr (find-mactype '(:pointer :mortcontextualsubtable)))
(defrecord MortContextualSubtable 
   (header :stheader)
   (substitutionTableOffset :unsigned-integer)
   )

(def-mactype :mortligaturesubtableptr (find-mactype '(:pointer :mortligaturesubtable)))
(defrecord MortLigatureSubtable 
   (header :stheader)
   (ligatureActionTableOffset :unsigned-integer)
   (componentTableOffset :unsigned-integer)
   (ligatureTableOffset :unsigned-integer)
   )

(def-mactype :mortswashsubtableptr (find-mactype '(:pointer :mortswashsubtable)))
(defrecord MortSwashSubtable 
   (lookup :sfntlookuptable)
   )

(def-mactype :mortinsertionsubtableptr (find-mactype '(:pointer :mortinsertionsubtable)))
(defrecord MortInsertionSubtable 
   (header :stheader)
   )

(def-mactype :mortspecificsubtableptr (find-mactype '(:pointer :mortspecificsubtable)))
(defrecord MortSpecificSubtable 
   (:variant 
      (
      (rearrangement :mortrearrangementsubtable)
      )
      (
      (contextual :mortcontextualsubtable)
      )
      (
      (ligature :mortligaturesubtable)
      )
      (
      (swash :mortswashsubtable)
      )
      (
      (insertion :mortinsertionsubtable)
      )
      )
   )

(def-mactype :mortsubtableptr (find-mactype '(:pointer :mortsubtable)))
(defrecord MortSubtable 
   (length :unsigned-integer)
   (coverage :unsigned-integer)
   (flags :unsigned-long)
   (u :mortspecificsubtable)
   )

(def-mactype :mortfeatureentryptr (find-mactype '(:pointer :mortfeatureentry)))
(defrecord MortFeatureEntry 
   (featureType :unsigned-integer)
   (featureSelector :unsigned-integer)
   (enableFlags :unsigned-long)
   (disableFlags :unsigned-long)
   )

(def-mactype :mortchainptr (find-mactype '(:pointer :mortchain)))
(defrecord MortChain 
   (defaultFlags :unsigned-long)                ;   default flags for this chain  
   (length :unsigned-long)                      ;   byte length of this chain  
   (nFeatures :unsigned-integer)                ;   number of feature entries  
   (nSubtables :unsigned-integer)               ;   number of subtables  
   (featureEntries (:array :mortfeatureentry 1))
;   the subtables follow  
   )

(def-mactype :morttableptr (find-mactype '(:pointer :morttable)))
(defrecord MortTable 
   (version :signed-long)
   (nChains :unsigned-long)
   (chains (:array :mortchain 1))
   )

; 	 --------------------------------------------------------------------------- 	
; 	 FORMATS FOR TABLE: 'morx' (version 2 and beyond metamorphosis tables) 	
; 	 CONSTANTS 	

(defconstant $kMORXTag #x6D6F7278)              ;   'morx'  
(defconstant $kMORXCurrentVersion #x20000)      ;   version number for current 'morx' table  
;   Coverage masks  
(defconstant $kMORXCoverVertical #x80000000)
(defconstant $kMORXCoverDescending #x40000000)
(defconstant $kMORXCoverIgnoreVertical #x20000000)
(defconstant $kMORXCoverTypeMask #xFF)

; 	 TYPES 	

(def-mactype :morxrearrangementsubtableptr (find-mactype '(:pointer :morxrearrangementsubtable)))
(defrecord MorxRearrangementSubtable 
   (header :stxheader)
   )

(def-mactype :morxcontextualsubtableptr (find-mactype '(:pointer :morxcontextualsubtable)))
(defrecord MorxContextualSubtable 
   (header :stxheader)
   (substitutionTableOffset :unsigned-long)
   )

(def-mactype :morxligaturesubtableptr (find-mactype '(:pointer :morxligaturesubtable)))
(defrecord MorxLigatureSubtable 
   (header :stxheader)
   (ligatureActionTableOffset :unsigned-long)
   (componentTableOffset :unsigned-long)
   (ligatureTableOffset :unsigned-long)
   )

(def-mactype :morxinsertionsubtableptr (find-mactype '(:pointer :morxinsertionsubtable)))
(defrecord MorxInsertionSubtable 
   (header :stxheader)
   (insertionGlyphTableOffset :unsigned-long)
   )

(def-mactype :morxspecificsubtableptr (find-mactype '(:pointer :morxspecificsubtable)))
(defrecord MorxSpecificSubtable 
   (:variant 
      (
      (rearrangement :morxrearrangementsubtable)
      )
      (
      (contextual :morxcontextualsubtable)
      )
      (
      (ligature :morxligaturesubtable)
      )
      (
      (swash :mortswashsubtable)
      )
      (
      (insertion :morxinsertionsubtable)
      )
      )
   )

(def-mactype :morxsubtableptr (find-mactype '(:pointer :morxsubtable)))
(defrecord MorxSubtable 
   (length :unsigned-long)
   (coverage :unsigned-long)
   (flags :unsigned-long)
   (u :morxspecificsubtable)
   )

(def-mactype :morxchainptr (find-mactype '(:pointer :morxchain)))
(defrecord MorxChain 
   (defaultFlags :unsigned-long)                ;   default flags for this chain  
   (length :unsigned-long)                      ;   byte length of this chain  
   (nFeatures :unsigned-long)                   ;   number of feature entries  
   (nSubtables :unsigned-long)                  ;   number of subtables  
   (featureEntries (:array :mortfeatureentry 1))
;   the subtables follow  
   )

(def-mactype :morxtableptr (find-mactype '(:pointer :morxtable)))
(defrecord MorxTable 
   (version :signed-long)
   (nChains :unsigned-long)
   (chains (:array :morxchain 1))
   )

; 	 --------------------------------------------------------------------------- 	
; 	 FORMATS FOR TABLE: 'prop' 	
; 	 CONSTANTS 	

(defconstant $kPROPTag #x70726F70)              ;   'prop'  
(defconstant $kPROPCurrentVersion #x20000)      ;   current version number for 'prop' table  
(defconstant $kPROPPairOffsetShift 8)
(defconstant $kPROPPairOffsetSign 7)
(defconstant $kPROPIsFloaterMask #x8000)        ;   glyph is floater  
(defconstant $kPROPCanHangLTMask #x4000)        ;   glyph can hang left/top  
(defconstant $kPROPCanHangRBMask #x2000)        ;   glyph can hang right/bottom  
(defconstant $kPROPUseRLPairMask #x1000)        ;   if glyph lands in RL streak, use paired glyph  
(defconstant $kPROPPairOffsetMask #xF00)        ;   4-bit signed offset to other pair member  
(defconstant $kPROPRightConnectMask #x80)       ;   glyph connects to glyph on right  
(defconstant $kPROPZeroReserved #x60)           ;   must be zero  
(defconstant $kPROPDirectionMask #x1F)          ;   direction bits  

; 	 These are the Unicode direction classes (plus the Special European Number class). 	
(defconstant $kPROPLDirectionClass 0)           ;   Left-to-Right  
(defconstant $kPROPRDirectionClass 1)           ;   Right-to-Left  
(defconstant $kPROPALDirectionClass 2)          ;   Right-to-Left Arabic Letter  
(defconstant $kPROPENDirectionClass 3)          ;   European Number  
(defconstant $kPROPESDirectionClass 4)          ;   European Number Seperator  
(defconstant $kPROPETDirectionClass 5)          ;   European Number Terminator  
(defconstant $kPROPANDirectionClass 6)          ;   Arabic Number  
(defconstant $kPROPCSDirectionClass 7)          ;   Common Number Seperator  
(defconstant $kPROPPSDirectionClass 8)          ;   Paragraph Seperator (also referred to as Block Separator)  
(defconstant $kPROPSDirectionClass 9)           ;   Segment Seperator  
(defconstant $kPROPWSDirectionClass 10)         ;   Whitespace  
(defconstant $kPROPONDirectionClass 11)         ;   Other Neutral  
(defconstant $kPROPSENDirectionClass 12)        ;   Special European Number (not a Unicode class)  
(defconstant $kPROPLREDirectionClass 13)        ;   Left-to-Right Embeding  
(defconstant $kPROPLRODirectionClass 14)        ;   Left-to-Right Override  
(defconstant $kPROPRLEDirectionClass 15)        ;   Right-to-Left Embeding  
(defconstant $kPROPRLODirectionClass 16)        ;   Right-to-Left Override  
(defconstant $kPROPPDFDirectionClass 17)        ;   Pop Directional Format  
(defconstant $kPROPNSMDirectionClass 18)        ;   Non-Spacing Mark  
(defconstant $kPROPBNDirectionClass 19)         ;   Boundary Neutral  
(defconstant $kPROPNumDirectionClasses 20)      ;   Number of Unicode directional types + Special European Number  

; 	 TYPES 	

(def-mactype :propcharproperties (find-mactype ':unsigned-integer))
(def-mactype :proptableptr (find-mactype '(:pointer :proptable)))
(defrecord PropTable 
   (version :signed-long)
   (format :unsigned-integer)
   (defaultProps :unsigned-integer)
   (lookup :sfntlookuptable)
   )

(def-mactype :proplookupsegmentptr (find-mactype '(:pointer :proplookupsegment)))
(defrecord PropLookupSegment 
   (lastGlyph :unsigned-integer)
   (firstGlyph :unsigned-integer)
   (value :unsigned-integer)
   )

(def-mactype :proplookupsingleptr (find-mactype '(:pointer :proplookupsingle)))
(defrecord PropLookupSingle 
   (glyph :unsigned-integer)
   (props :unsigned-integer)
   )

; 	 --------------------------------------------------------------------------- 	
; 	 FORMATS FOR TABLE: 'trak' 	
; 	 CONSTANTS 	

(defconstant $kTRAKTag #x7472616B)              ;   'trak'  
(defconstant $kTRAKCurrentVersion #x10000)      ;   current version number for 'trak' table  
(defconstant $kTRAKUniformFormat 0)             ;      kTRAKPerGlyphFormat         = 2 

; 	 TYPES 	

(def-mactype :trakvalue (find-mactype ':signed-integer))
(def-mactype :traktableentryptr (find-mactype '(:pointer :traktableentry)))
(defrecord TrakTableEntry 
   (track :signed-long)
   (nameTableIndex :unsigned-integer)
   (sizesOffset :unsigned-integer)              ;   offset to array of TrackingValues  
   )

(def-mactype :traktabledataptr (find-mactype '(:pointer :traktabledata)))
(defrecord TrakTableData 
   (nTracks :unsigned-integer)
   (nSizes :unsigned-integer)
   (sizeTableOffset :unsigned-long)
   (trakTable (:array :traktableentry 1))
   )

(def-mactype :traktableptr (find-mactype '(:pointer :traktable)))
(defrecord TrakTable 
   (version :signed-long)
   (format :unsigned-integer)
   (horizOffset :unsigned-integer)
   (vertOffset :unsigned-integer)
   )

; 	 --------------------------------------------------------------------------- 	
; 	 FORMATS FOR TABLE: 'kern' 	
; 	 CONSTANTS 	

(defconstant $kKERNTag #x6B65726E)              ;   'kern'  
(defconstant $kKERNCurrentVersion #x10000)
(defconstant $kKERNVertical #x8000)             ;   set if this table has vertical kerning information  
(defconstant $kKERNResetCrossStream #x8000)     ;   this value in a cross-stream table means reset to zero  
(defconstant $kKERNCrossStream #x4000)          ;   set if this table contains cross-stream kerning values  
(defconstant $kKERNVariation #x2000)            ;   set if this table contains variation kerning values  
(defconstant $kKERNUnusedBits #x1F00)           ;   UNUSED, MUST BE ZERO  
(defconstant $kKERNFormatMask #xFF)             ;   format of this subtable  

(defconstant $kKERNOrderedList 0)               ;   ordered list of kerning pairs  
(defconstant $kKERNStateTable 1)                ;   state table for n-way contextual kerning  
(defconstant $kKERNSimpleArray 2)               ;   simple n X m array of kerning values  
(defconstant $kKERNIndexArray 3)                ;   modifed version of SimpleArray  

; 	 Message Type Flags 	
(defconstant $kKERNLineStart #x1)               ;   Array of glyphs starts a line  
(defconstant $kKERNLineEndKerning #x2)          ;   Array of glyphs ends a line  
(defconstant $kKERNNoCrossKerning #x4)          ;   Prohibit cross kerning  
(defconstant $kKERNNotesRequested #x8)          ;   Caller wants kerning notes  
(defconstant $kKERNNoStakeNote 1)               ;   Indicates a glyph was involved in a kerning pair/group  
(defconstant $kKERNCrossStreamResetNote 2)      ;   Indicates a return-to-baseline in cross-stream kerning  
(defconstant $kKERNNotApplied #x1)              ;   All kerning values were zero, kerning call had no effect  

; 	 TYPES 	

(def-mactype :kerntableformat (find-mactype ':unsigned-byte))
(def-mactype :kernsubtableinfo (find-mactype ':unsigned-integer))
(def-mactype :kernkerningvalue (find-mactype ':signed-integer))
(def-mactype :kernarrayoffset (find-mactype ':unsigned-integer))
; 	 header for version 0 kerning table 	
(def-mactype :kernversion0headerptr (find-mactype '(:pointer :kernversion0header)))
(defrecord KernVersion0Header 
   (version :unsigned-integer)                  ;   font version number (will be 0!)  
   (nTables :unsigned-integer)                  ;   number of subtables present  
   (firstSubtable (:array :unsigned-integer 1)) ;   first subtable starts here  
   )

; 	 Header for a kerning table 	
(def-mactype :kerntableheaderptr (find-mactype '(:pointer :kerntableheader)))
(defrecord KernTableHeader 
   (version :signed-long)                       ;   font version number (currently 1.0)  
   (nTables :signed-long)                       ;   number of subtables present  
   (firstSubtable (:array :unsigned-integer 1)) ;   first subtable starts here  
   )

(def-mactype :kerntableheaderhandle (find-mactype '(:handle :kerntableheader)))
; 	
; 	    F O R M A T   S P E C I F I C   D E F I N I T I O N S
; 	
; 	    kernOrderedList:
; 	    
; 	    The table is a sorted list of [left glyph, right glyph, value] triples.
; 	    There's enough information in the header so that the list can be
; 	    efficiently binary searched. 
; 		
; 	 defines a single kerning pair of Glyphcodes  	
(def-mactype :kernkerningpairptr (find-mactype '(:pointer :kernkerningpair)))
(defrecord KernKerningPair 
   (left :unsigned-integer)
   (right :unsigned-integer)
   )

; 	 a single list entry 	
(def-mactype :kernorderedlistentryptr (find-mactype '(:pointer :kernorderedlistentry)))
(defrecord KernOrderedListEntry 
   (pair :kernkerningpair)                      ;   the kerning pair  
   (value :signed-integer)                      ;   the kerning value for the above pair  
   )

; 	 the header information for binary searching the list 	
(def-mactype :kernorderedlistheaderptr (find-mactype '(:pointer :kernorderedlistheader)))
(defrecord KernOrderedListHeader 
   (nPairs :unsigned-integer)                   ;   number of kerning pairs in table  
   (searchRange :unsigned-integer)              ;   (largest power of two <= nPairs) * entry size  
   (entrySelector :unsigned-integer)            ;   log2 (largest power of two <= nPairs)  
   (rangeShift :unsigned-integer)               ;   (nPairs - largest power of two <= nPairs) * entry size  
   (table (:array :unsigned-integer 1))         ;   entries are first glyph, second glyph, and value  
   )

; 	 KernStateTable: like the the generic state tables 	
(def-mactype :kernstateheaderptr (find-mactype '(:pointer :kernstateheader)))
(defrecord KernStateHeader 
   (header :stheader)                           ;   state table header  
   (valueTable :unsigned-integer)               ;   offset to kerning value table  
   (firstTable :signed-byte)                    ;   first table starts here  
   )

(def-mactype :kernstateentryptr (find-mactype '(:pointer :kernstateentry)))
(defrecord KernStateEntry 
   (newState :unsigned-integer)
   (flags :unsigned-integer)                    ;   flags per above enum  
   )

; 	
; 	    Kern offset table header.
; 	    The offset table is a trimmed array from firstGlyph to limitGlyph.
; 	    Glyphs outside of this range should get zero for right-hand glyphs
; 	    and the offset of the beginning of the kerning array for left-hand glyphs.
; 		
(def-mactype :kernoffsettableptr (find-mactype '(:pointer :kernoffsettable)))
(defrecord KernOffsetTable 
   (firstGlyph :unsigned-integer)               ;   first glyph in class range  
   (nGlyphs :unsigned-integer)                  ;   number of glyphs in class range  
   (offsetTable (:array :unsigned-integer 1))   ;   offset table starts here  
   )

; 	 Header information for accessing offset tables and kerning array 	
; 	
; 	    KernSimpleArray:
; 	    
; 	    The array is an nXm array of kenring values. Each row in the array
; 	    represents one left-hand glyph, and each column one right-hand glyph.
; 	    The zeroth row and column always represent glyphs that are out of bounds
; 	    and will always contain zero.
; 	    
; 	    A pair is looked up by indexing the left-hand glyph through the left
; 	    offset table, the right-hand glyph through the right offset table,
; 	    adding both offsets to the starting address of the kerning array,
; 	    and fetching the kerning value pointed to.
; 		
; 	 Kern offset table header. 	
; 	 The offset table is a trimmed array from firstGlyph to limitGlyph. 	
; 	 Glyphs outside of this range should get zero for right-hand glyphs 	
; 	 and the offset of the beginning of the kerning array for left- 	
; 	 hand glyphs. 	
(def-mactype :kernsimplearrayheaderptr (find-mactype '(:pointer :kernsimplearrayheader)))
(defrecord KernSimpleArrayHeader 
   (rowWidth :unsigned-integer)                 ;   width, in bytes, of a row in the table  
   (leftOffsetTable :unsigned-integer)          ;   offset to left-hand offset table  
   (rightOffsetTable :unsigned-integer)         ;   offset to right-hand offset table  
   (theArray :unsigned-integer)                 ;   offset to start of kerning array  
   (firstTable (:array :unsigned-integer 1))    ;   first offset table starts here...  
   )

; 	 Index Array 	
(def-mactype :kernindexarrayheaderptr (find-mactype '(:pointer :kernindexarrayheader)))
(defrecord KernIndexArrayHeader 
   (glyphCount :unsigned-integer)
   (kernValueCount :signed-byte)
   (leftClassCount :signed-byte)
   (rightClassCount :signed-byte)
   (flags :signed-byte)                         ;   set to 0 for now  
   (kernValue (:array :signed-integer 1))       ;   actual kerning values reference by index in kernIndex  
   (leftClass :signed-byte)                     ;   maps left glyph to offset into kern index  
   (rightClass :signed-byte)                    ;   maps right glyph to offset into kern index  
   (kernIndex :signed-byte)                     ;   contains indicies into kernValue  
   )

; 	 format specific part of subtable header 	
(def-mactype :kernformatspecificheaderptr (find-mactype '(:pointer :kernformatspecificheader)))
(defrecord KernFormatSpecificHeader 
   (:variant 
      (
      (orderedList :kernorderedlistheader)
      )
      (
      (stateTable :kernstateheader)
      )
      (
      (simpleArray :kernsimplearrayheader)
      )
      (
      (indexArray :kernindexarrayheader)
      )
      )
   )

; 	 version 0 subtable header 	
(def-mactype :kernversion0subtableheaderptr (find-mactype '(:pointer :kernversion0subtableheader)))
(defrecord KernVersion0SubtableHeader 
   (version :unsigned-integer)                  ;   kerning table version number  
   (length :unsigned-integer)                   ;   length in bytes (including this header)  
   (stInfo :unsigned-integer)                   ;   sub-table info  
   (fsHeader :kernformatspecificheader)         ;   format specific sub-header  
   )

; 	 Overall Subtable header format 	
(def-mactype :kernsubtableheaderptr (find-mactype '(:pointer :kernsubtableheader)))
(defrecord KernSubtableHeader 
   (length :signed-long)                        ;   length in bytes (including this header)  
   (stInfo :unsigned-integer)                   ;   subtable info  
   (tupleIndex :signed-integer)                 ;   tuple index for variation subtables  
   (fsHeader :kernformatspecificheader)         ;   format specific sub-header  
   )

; 	 --------------------------------------------------------------------------- 	
; 	 FORMATS FOR TABLE: 'bsln' 	
; 	 CONSTANTS 	

(defconstant $kBSLNTag #x62736C6E)              ;   'bsln'  
(defconstant $kBSLNCurrentVersion #x10000)      ;   current version number for 'bsln' table  
(defconstant $kBSLNDistanceFormatNoMap 0)
(defconstant $kBSLNDistanceFormatWithMap 1)
(defconstant $kBSLNControlPointFormatNoMap 2)
(defconstant $kBSLNControlPointFormatWithMap 3)

; 	 Baseline classes and constants 	
(defconstant $kBSLNRomanBaseline 0)
(defconstant $kBSLNIdeographicCenterBaseline 1)
(defconstant $kBSLNIdeographicLowBaseline 2)
(defconstant $kBSLNHangingBaseline 3)
(defconstant $kBSLNMathBaseline 4)
(defconstant $kBSLNLastBaseline 31)
(defconstant $kBSLNNumBaselineClasses 32)
(defconstant $kBSLNNoBaselineOverride 255)

; 	 TYPES 	

(def-mactype :bslnbaselineclass (find-mactype ':unsigned-long))
; 	 The BslnBaselineRecord array defines the baseline deltas for the line. 	
(defrecord BslnBaselineRecord (array (:array :signed-long 32)))
; 	
; 	    BslnFormat0Part is the format-specific data for a distance table with no mapping (i.e.
; 	    all the glyphs belong to the defaultBaseline).
; 		
(def-mactype :bslnformat0partptr (find-mactype '(:pointer :bslnformat0part)))
(defrecord BslnFormat0Part 
   (deltas (:array :signed-integer 32))
   )

; 	 BslnFormat1Part is the format-specific data for a distance table with a gxMapping. 	
(def-mactype :bslnformat1partptr (find-mactype '(:pointer :bslnformat1part)))
(defrecord BslnFormat1Part 
   (deltas (:array :signed-integer 32))
   (mappingData :sfntlookuptable)
   )

; 	
; 	    BslnFormat2Part is the format-specific data for a control-point table with no
; 	    mapping (i.e. all the glyphs belong to the defaultBaseline). It specifies a single
; 	    glyph to use and the set of control points in that glyph that designate each of
; 	    the baselines.
; 		
(def-mactype :bslnformat2partptr (find-mactype '(:pointer :bslnformat2part)))
(defrecord BslnFormat2Part 
   (stdGlyph :unsigned-integer)
   (ctlPoints (:array :signed-integer 32))
   )

; 	
; 	    BslnFormat3Part is the format-specific data for a distance table with a mapping. Like
; 	    format 2, it contains a single glyph and its set of control-point values for each
; 	    of the baselines.
; 		
(def-mactype :bslnformat3partptr (find-mactype '(:pointer :bslnformat3part)))
(defrecord BslnFormat3Part 
   (stdGlyph :unsigned-integer)
   (ctlPoints (:array :signed-integer 32))
   (mappingData :sfntlookuptable)
   )

; 	 The BslnFormatUnion is a union containing the format-specific parts of the baseline table. 	
(def-mactype :bslnformatunionptr (find-mactype '(:pointer :bslnformatunion)))
(defrecord BslnFormatUnion 
   (:variant 
      (
      (fmt0Part :bslnformat0part)
      )
      (
      (fmt1Part :bslnformat1part)
      )
      (
      (fmt2Part :bslnformat2part)
      )
      (
      (fmt3Part :bslnformat3part)
      )
      )
   )

; 	 The table format used in BaselineTable 	
(def-mactype :bslntableformat (find-mactype ':unsigned-integer))
; 	 BaselineTable defines the top-level format of the baseline table in the font. 	
(def-mactype :bslntableptr (find-mactype '(:pointer :bslntable)))
(defrecord BslnTable 
   (version :signed-long)
   (format :unsigned-integer)
   (defaultBaseline :unsigned-integer)
   (parts :bslnformatunion)
   )

; 	 --------------------------------------------------------------------------- 	
; $ALIGN RESET
; $POP

; $SETC UsingIncludes := SFNTLayoutTypesIncludes

; $ENDC                                         ; __SFNTLAYOUTTYPES__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'SFNTLayoutTypes)