(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:SegLoad.p"
; at Wednesday May 1,2002 2:42:49 pm.
; 
;      File:       SegLoad.p
;  
;      Contains:   Segment Loader Interfaces.
;  
;      Version:    Technology: Mac OS 8
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __SEGLOAD__
; $SETC __SEGLOAD__ := 1

; $I+
; $SETC SegLoadIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

#|                                              ; $IFC TARGET_CPU_68K AND NOT TARGET_RT_MAC_CFM OR NOT TARGET_OS_MAC 
; 
;    CountAppFiles, GetAppFiles, ClrAppFiles, GetAppParms, getappparms, 
;    and the AppFile data structure and enums are obsolete. 
;    They are still supported for writing old style 68K apps, 
;    but they are not supported for CFM-based apps.
;    Use AppleEvents to determine which files are to be 
;    opened or printed from the Finder.
; 

(defconstant $appOpen 0)                        ;  Open the Document (s) 
(defconstant $appPrint 1)                       ;  Print the Document (s) 

(def-mactype :appfileptr (find-mactype '(:pointer :appfile)))
(defrecord AppFile 
   (vRefNum :signed-integer)
   (fType :ostype)
   (versNum :signed-integer)                    ;  versNum in high byte 
   (fName (:string 255))
   )

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  CountAppFiles()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; 
;  *  GetAppFiles()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CountAppFiles" 
      ((message (:pointer :signed-integer)) (count (:pointer :signed-integer))) 
  nil
   () )                                         ; 
;  *  ClrAppFiles()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetAppFiles" 
      ((index :signed-integer) (theFile (:pointer :appfile))) 
  nil
   () )                                         ; 
;  *  GetAppParms()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ClrAppFiles" 
      ((index :signed-integer)) 
  nil
   () )
(deftrap "_GetAppParms" 
      ((apName (:pointer (:string 255))) (apRefNum (:pointer :signed-integer)) (apParam (:pointer :handle)))
   nil
   (:stack-trap #xA9F5))

; $ENDC                                         ; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC

; 
;    Because PowerPC applications dont have segments.
;    But, in order to allow applications to not have conditionalized
;    source code, UnloadSeg is macro'ed away for PowerPC.
; 
#|                                              ; $IFC TARGET_CPU_68K 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  UnloadSeg()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UnloadSeg" 
      ((routineAddr :pointer))
   nil
   (:stack-trap #xA9F1))

; $ENDC                                         ; CALL_NOT_IN_CARBON
 |#                                             ; $ELSEC
; $ENDC                                         ; TARGET_CPU_68K

;   ExitToShell() has moved to Process.h 

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := SegLoadIncludes

; $ENDC                                         ; __SEGLOAD__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'SegLoad)#|
; Warning: Did not recognize these types or records: (appfile)
|#