(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:SocketServices.p"
; at Wednesday May 1,2002 2:42:50 pm.
; 
;      File:       SocketServices.p
;  
;      Contains:   This file contains constants and data structures that
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1994-2001 by Apple Computer, Inc. All rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __SOCKETSERVICES__
; $SETC __SOCKETSERVICES__ := 1

; $I+
; $SETC SocketServicesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;   ///////////////////////////////////////////////////////////////////////////////////////
;     TypeDefs for the Socket Services function codes
; 

(def-mactype :ss_byte (find-mactype ':unsigned-byte))
(def-mactype :ss_flags8 (find-mactype ':unsigned-byte))
(def-mactype :ss_irq (find-mactype ':unsigned-byte))
(def-mactype :ss_pwrlevel (find-mactype ':unsigned-byte))
(def-mactype :ss_adapter (find-mactype ':unsigned-integer))
(def-mactype :ss_bcd (find-mactype ':unsigned-integer))
(def-mactype :ss_count (find-mactype ':unsigned-integer))
(def-mactype :ss_edc (find-mactype ':unsigned-integer))
(def-mactype :ss_flags16 (find-mactype ':unsigned-integer))
(def-mactype :ss_page (find-mactype ':unsigned-integer))
(def-mactype :ss_pwrindex (find-mactype ':unsigned-integer))
(def-mactype :ss_signature (find-mactype ':unsigned-integer))
(def-mactype :ss_sktbits (find-mactype ':unsigned-integer))
(def-mactype :ss_socket (find-mactype ':unsigned-integer))
(def-mactype :ss_speed (find-mactype ':unsigned-integer))
(def-mactype :ss_window (find-mactype ':unsigned-integer))
(def-mactype :ss_word (find-mactype ':unsigned-integer))
(def-mactype :ss_base (find-mactype ':unsigned-long))
(def-mactype :ss_flags32 (find-mactype ':unsigned-long))
(def-mactype :ss_offset (find-mactype ':unsigned-long))
(def-mactype :ss_size (find-mactype ':unsigned-long))
(def-mactype :ss_ptr (find-mactype ':pointer))
(def-mactype :ss_retcode (find-mactype ':signed-integer))
(def-mactype :ss_schartblptr (find-mactype '(:pointer :ss_schartbl)))
(defrecord SS_SCHARTBL 
   (sktCaps :unsigned-integer)                  ;      SS_FLAGS16 
   (activeHigh :unsigned-long)                  ;      SS_FLAGS32 
   (activeLow :unsigned-long)                   ;      SS_FLAGS32 
   )

(def-mactype :ss_sistructptr (find-mactype '(:pointer :ss_sistruct)))
(defrecord SS_SISTRUCT 
   (bufferLength :unsigned-integer)             ;      SS_WORD 
   (dataLength :unsigned-integer)               ;      SS_WORD 
   (charTable :ss_schartbl)                     ;      SS_FLAGS16 
   )

(defconstant $STR_SIZE 24)

;   minimum string length 

(def-mactype :ss_vistructptr (find-mactype '(:pointer :ss_vistruct)))
(defrecord SS_VISTRUCT 
   (bufferLength :unsigned-integer)             ;      SS_WORD 
   (dataLength :unsigned-integer)               ;      SS_WORD 
   (szImplementor :signed-byte)                 ;      SS_WORD 
   (padding :signed-byte)                       ;       
   )

(def-mactype :ss_achartblptr (find-mactype '(:pointer :ss_achartbl)))
(defrecord SS_ACHARTBL 
   (adpCaps :unsigned-integer)                  ;      SS_FLAGS16 
   (activeHigh :unsigned-long)                  ;      SS_FLAGS32 
   (activeLow :unsigned-long)                   ;      SS_FLAGS32 
   )

(def-mactype :ss_pwrentryptr (find-mactype '(:pointer :ss_pwrentry)))
(defrecord SS_PWRENTRY 
   (powerLevel :signed-byte)                    ;      SS_PWRLEVEL 
   (validSignals :signed-byte)                  ;      SS_FLAGS8 
   )

(def-mactype :ss_aistructptr (find-mactype '(:pointer :ss_aistruct)))
(defrecord SS_AISTRUCT 
   (bufferLength :unsigned-integer)             ;      SS_WORD 
   (dataLength :unsigned-integer)               ;      SS_WORD 
   (charTable :ss_achartbl)
   (numPwrEntries :unsigned-integer)            ;      SS_WORD 
   (pwrEntryPtr (:pointer :ss_pwrentry))
   )

(def-mactype :ss_memwintblptr (find-mactype '(:pointer :ss_memwintbl)))
(defrecord SS_MEMWINTBL 
   (memWndCaps :unsigned-integer)               ;      SS_FLAGS16 
   (firstByte :unsigned-long)                   ;      SS_BASE 
   (lastByte :unsigned-long)                    ;      SS_BASE 
   (minSize :unsigned-long)                     ;      SS_SIZE 
   (maxSize :unsigned-long)                     ;      SS_SIZE 
   (reqGran :unsigned-long)                     ;      SS_SIZE 
   (reqBase :unsigned-long)                     ;      SS_SIZE 
   (reqOffset :unsigned-long)                   ;      SS_SIZE 
   (slowest :unsigned-integer)                  ;      SS_SPEED 
   (fastest :unsigned-integer)                  ;      SS_SPEED 
   )

(def-mactype :ss_iowintblptr (find-mactype '(:pointer :ss_iowintbl)))
(defrecord SS_IOWINTBL 
   (ioWndCaps :unsigned-integer)                ;      SS_FLAGS16 
   (firstByte :unsigned-long)                   ;      SS_BASE 
   (lastByte :unsigned-long)                    ;      SS_BASE 
   (minSize :unsigned-long)                     ;      SS_SIZE 
   (maxSize :unsigned-long)                     ;      SS_SIZE 
   (reqGran :unsigned-long)                     ;      SS_SIZE 
   (addrLines :unsigned-integer)                ;      SS_COUNT 
   (eisaSlot :signed-byte)                      ;      SS_FLAGS8 
   (padding :signed-byte)                       ;       
   )

(def-mactype :ss_wistructptr (find-mactype '(:pointer :ss_wistruct)))
(defrecord SS_WISTRUCT 
   (bufferLength :unsigned-integer)             ;      SS_WORD 
   (dataLength :unsigned-integer)               ;      SS_WORD 
   (numTblEntries :unsigned-integer)            ;      SS_WORD 
   (memWinTbl :ss_memwintbl)
   (ioWinTbl :ss_iowintbl)
   )

; 	
; 	    function selectors passed to Socket Service entry point
; 		

(defconstant $fnSSGetAdapterCount #x80)
(defconstant $fnSSUnsupported81 #x81)
(defconstant $fnSSUnsupported82 #x82)
(defconstant $fnSSGetSSInfo #x83)
(defconstant $fnSSInquireAdapter #x84)
(defconstant $fnSSGetAdapter #x85)
(defconstant $fnSSSetAdapter #x86)
(defconstant $fnSSInquireWindow #x87)
(defconstant $fnSSGetWindow #x88)
(defconstant $fnSSSetWindow #x89)
(defconstant $fnSSGetPage #x8A)
(defconstant $fnSSSetPage #x8B)
(defconstant $fnSSInquireSocket #x8C)
(defconstant $fnSSGetSocket #x8D)
(defconstant $fnSSSetSocket #x8E)
(defconstant $fnSSGetStatus #x8F)
(defconstant $fnSSResetSocket #x90)
(defconstant $fnSSUnsupported91 #x91)
(defconstant $fnSSUnsupported92 #x92)
(defconstant $fnSSUnsupported93 #x93)
(defconstant $fnSSUnsupported94 #x94)
(defconstant $fnSSInquireEDC #x95)
(defconstant $fnSSGetEDC #x96)
(defconstant $fnSSSetEDC #x97)
(defconstant $fnSSStartEDC #x98)
(defconstant $fnSSPauseEDC #x99)
(defconstant $fnSSResumeEDC #x9A)
(defconstant $fnSSStopEDC #x9B)
(defconstant $fnSSReadEDC #x9C)
(defconstant $fnSSGetVendorInfo #x9D)
(defconstant $fnSSAcknowledgeInterrupt #x9E)
(defconstant $fnSSGetSetPriorHandler #x9F)
(defconstant $fnSSGetSetSSAddr #xA0)
(defconstant $fnSSGetAccessOffsets #xA1)
(defconstant $fnSSUnsupportedA2 #xA2)
(defconstant $fnSSUnsupportedA3 #xA3)
(defconstant $fnSSUnsupportedA4 #xA4)
(defconstant $fnSSUnsupportedA5 #xA5)
(defconstant $fnSSUnsupportedA6 #xA6)
(defconstant $fnSSUnsupportedA7 #xA7)
(defconstant $fnSSUnsupportedA8 #xA8)
(defconstant $fnSSUnsupportedA9 #xA9)
(defconstant $fnSSUnsupportedAA #xAA)
(defconstant $fnSSUnsupportedAB #xAB)
(defconstant $fnSSUnsupportedAC #xAC)
(defconstant $fnSSUnsupportedAD #xAD)
(defconstant $fnSSVendorSpecific #xAE)

;    SSVendorSpecificPB.function values 

(defconstant $fnVSReserved #x0)
(defconstant $fnVSGetSocketLocationIcon #x1)
(defconstant $fnVSGetSocketLocationText #x2)
(defconstant $fnVSDoSocketLocalization #x3)
(defconstant $fnVSAppleSocketCapabilities #x4)
(defconstant $fnVSSleepWakeNotification #x5)

; 	
; 	    defines for the Socket Services function codes
; 		
(defconstant $AC_IND 1)                         ;   adapter characteristics 
(defconstant $AC_PWR 2)
(defconstant $AC_DBW 4)

(defconstant $AS_POWERDOWN 1)
(defconstant $AS_MAINTAIN 2)

(defconstant $EC_UNI 1)
(defconstant $EC_BI 2)
(defconstant $EC_REGISTER 4)
(defconstant $EC_MEMORY 8)
(defconstant $EC_PAUSABLE 16)
(defconstant $EC_WRITE 16)

(defconstant $ET_CHECK8 1)
(defconstant $ET_SDLC16 2)

(defconstant $IF_MEMORY 1)
(defconstant $IF_IO 2)

(defconstant $IRQ_HIGH 64)
(defconstant $IRQ_ENABLE 128)

(defconstant $IRQ_MEMORY 4)
(defconstant $IRQ_IO 4)

(defconstant $PS_ATTRIBUTE #x1)
(defconstant $PS_ENABLED #x2)
(defconstant $PS_WP #x4)

(defconstant $PWR_VCC 128)                      ;   Power pins in PwrEntry elements 
(defconstant $PWR_VPP1 64)
(defconstant $PWR_VPP2 32)

(defconstant $SBM_WP 1)
(defconstant $SBM_LOCKED 2)
(defconstant $SBM_EJECT 4)
(defconstant $SBM_INSERT 8)
(defconstant $SBM_BVD1 16)
(defconstant $SBM_BVD2 32)
(defconstant $SBM_RDYBSY 64)
(defconstant $SBM_CD 128)

(defconstant $SBM_LOCK 16)
(defconstant $SBM_BATT 32)
(defconstant $SBM_BUSY 64)
(defconstant $SBM_XIP 128)

; 	 Vendor Specific Apple Socket Capabilities 	
(defconstant $SBM_SLEEP_PWR 1)

(defconstant $WC_COMMON 1)
(defconstant $WC_IO 2)
(defconstant $WC_ATTRIBUTE 4)
(defconstant $WC_TYPE_MASK 7)
(defconstant $WC_WAIT 128)

(defconstant $WC_BASE 1)
(defconstant $WC_SIZE 2)
(defconstant $WC_WENABLE 4)
(defconstant $WC_8BIT 8)
(defconstant $WC_16BIT 16)
(defconstant $WC_BALIGN 32)
(defconstant $WC_POW2 64)
(defconstant $WC_CALIGN 128)
(defconstant $WC_PAVAIL 256)
(defconstant $WC_PSHARED 512)
(defconstant $WC_PENABLE 1024)
(defconstant $WC_WP 2048)

(defconstant $WC_INPACK 128)
(defconstant $WC_EISA 256)
(defconstant $WC_CENABLE 512)

(defconstant $WS_IO 1)
(defconstant $WS_ENABLED 2)
(defconstant $WS_16BIT 4)

(defconstant $WS_PAGED 8)
(defconstant $WS_EISA 16)
(defconstant $WS_CENABLE 32)
(defconstant $WS_SWAP_LITTLE_TO_BIG_ENDIAN 64)

(defconstant $SS_SIG_VALUE #x5353)              ;   'SS' 

(defconstant $SS_CMPL_1_00 #x100)               ;   compliant with rev 1.0 of SS standard 
(defconstant $SS_CMPL_1_01 #x101)               ;   compliant with rev 1.01 of SS standard 
(defconstant $SS_CMPL_2_00 #x200)               ;   compliant with rev 2.0 of SS standard 
(defconstant $SS_CMPL_2_10 #x210)               ;   compliant with rev 2.1 of SS standard 

; 	
; 	    Universal ProcPtr for Socket Service entry point
; 		

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	PCCardSSEntryProcPtr = FUNCTION(fnCode: UInt16; callPB: Ptr; dataPtr: Ptr): INTEGER;

|#
 |#                                             ; $ELSEC
(def-mactype :pccardssentryprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :pccardssentryupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :pccardssentryupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppPCCardSSEntryProcInfo #xFA0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewPCCardSSEntryUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewPCCardSSEntryProc 
(deftrap "_NewPCCardSSEntryUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposePCCardSSEntryUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposePCCardSSEntryUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokePCCardSSEntryUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallPCCardSSEntryProc 
(deftrap-inline "_InvokePCCardSSEntryUPP" 
      ((fnCode :unsigned-integer) (callPB :pointer) (dataPtr :pointer) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;     Card Services calls used by a Socket Service
; 

(def-mactype :csevententrypbptr (find-mactype '(:pointer :csevententrypb)))
(defrecord CSEventEntryPB 
   (ssHandlerID :unsigned-long)
   (adapter :unsigned-integer)
   (socket :unsigned-integer)
   (message :unsigned-integer)
   (intrpBits :signed-byte)
   (padding :signed-byte)
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	PCCardCSEntryProcPtr = PROCEDURE(VAR pb: CSEventEntryPB);

|#
 |#                                             ; $ELSEC
(def-mactype :pccardcsentryprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :pccardcsentryupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :pccardcsentryupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppPCCardCSEntryProcInfo #xC0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewPCCardCSEntryUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewPCCardCSEntryProc 
(deftrap "_NewPCCardCSEntryUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposePCCardCSEntryUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposePCCardCSEntryUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokePCCardCSEntryUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallPCCardCSEntryProc 
(deftrap-inline "_InvokePCCardCSEntryUPP" 
      ((pb (:pointer :csevententrypb)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

;  ------------      AddSocketServices       ------------                             

(def-mactype :addsocketservicespbptr (find-mactype '(:pointer :addsocketservicespb)))
(defrecord AddSocketServicesPB 
   (ssEntry :pointer)                           ;   -> given to CS for its use 
   (csEntry :pointer)                           ;   <- taken from CS so we know where to enter 
   (dataPtr :unsigned-long)
   (attributes :unsigned-long)
   (numAdapters :unsigned-integer)
   (numSockets :unsigned-integer)
   )

;  ------------      ReplaceSocketServices   ------------                             

(def-mactype :replacesocketservicespbptr (find-mactype '(:pointer :replacesocketservicespb)))
(defrecord ReplaceSocketServicesPB 
   (ssEntry :pointer)
   (oldSSEntry :pointer)
   (dataPtr :unsigned-long)
   (socket :unsigned-integer)
   (numSockets :unsigned-integer)
   (attributes :unsigned-integer)
   )

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  CSAddSocketServices()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_CSAddSocketServices" 
      ((pb (:pointer :addsocketservicespb)))
   (:stack :signed-integer)
   (:stack-trap #xAAF0 :d0 80 pb))

; 
;  *  CSReplaceSocketServices()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CSReplaceSocketServices" 
      ((pb (:pointer :replacesocketservicespb)))
   (:stack :signed-integer)
   (:stack-trap #xAAF0 :d0 81 pb))

; 
;     parameter blocks for each Socket Service function
; 
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :ssacknowledgeinterruptpbptr (find-mactype '(:pointer :ssacknowledgeinterruptpb)))
(defrecord SSAcknowledgeInterruptPB 
   (adapter :unsigned-integer)                  ;      SS_ADAPTER 
   (sockets :unsigned-integer)                  ;      SS_SKTBITS 
   )

(def-mactype :ssgetaccessoffsetspbptr (find-mactype '(:pointer :ssgetaccessoffsetspb)))
(defrecord SSGetAccessOffsetsPB 
   (adapter :unsigned-integer)                  ;      SS_ADAPTER 
   (mode :signed-byte)                          ;      SS_BYTE 
   (reserved :signed-byte)                      ;      padding 
   (count :unsigned-integer)                    ;      SS_COUNT 
   (buffer :pointer)                            ;      SS_PTR 
   (numAvail :unsigned-integer)                 ;      SS_COUNT 
   )

(def-mactype :ssgetadaptercountpbptr (find-mactype '(:pointer :ssgetadaptercountpb)))
(defrecord SSGetAdapterCountPB 
   (totalAdapters :unsigned-integer)            ;      SS_COUNT 
   (sig :unsigned-integer)                      ;      SS_SIGNATURE 
   )

(def-mactype :ssgetsetadapterpbptr (find-mactype '(:pointer :ssgetsetadapterpb)))
(defrecord SSGetSetAdapterPB 
   (adapter :unsigned-integer)                  ;      SS_ADAPTER 
   (state :signed-byte)                         ;      SS_FLAGS8 
   (irqStatus :signed-byte)                     ;      SS_IRQ 
   )

(def-mactype :ssgetsetedcpbptr (find-mactype '(:pointer :ssgetsetedcpb)))
(defrecord SSGetSetEDCPB 
   (adapter :unsigned-integer)                  ;      SS_ADAPTER 
   (edc :unsigned-integer)                      ;      SS_EDC 
   (socket :unsigned-integer)                   ;      SS_SOCKET 
   (state :signed-byte)                         ;      SS_FLAGS8 
   (edcType :signed-byte)                       ;      SS_FLAGS8 
   )

(def-mactype :ssgetsetpagepbptr (find-mactype '(:pointer :ssgetsetpagepb)))
(defrecord SSGetSetPagePB 
   (adapter :unsigned-integer)                  ;      SS_ADAPTER 
   (window :unsigned-integer)                   ;      SS_WINDOW 
   (page :unsigned-integer)                     ;      SS_PAGE 
   (state :signed-byte)                         ;      SS_FLAGS8 
   (reserved :signed-byte)                      ;      padding 
   (offset :unsigned-long)                      ;      SS_OFFSET 
   )

(def-mactype :ssgetsetpriorhandlerpbptr (find-mactype '(:pointer :ssgetsetpriorhandlerpb)))
(defrecord SSGetSetPriorHandlerPB 
   (adapter :unsigned-integer)                  ;      SS_ADAPTER 
   (mode :signed-byte)                          ;      SS_FLAGS8 
   (reserved :signed-byte)                      ;      padding 
   (handler :pointer)                           ;      SS_PTR 
   )

(def-mactype :ssgetsetsocketpbptr (find-mactype '(:pointer :ssgetsetsocketpb)))
(defrecord SSGetSetSocketPB 
   (adapter :unsigned-integer)                  ;      SS_ADAPTER 
   (socket :unsigned-integer)                   ;      SS_SOCKET 
   (vccIndex :unsigned-integer)                 ;      SS_PWRINDEX 
   (vpp1Index :unsigned-integer)                ;      SS_PWRINDEX 
   (vpp2Index :unsigned-integer)                ;      SS_PWRINDEX 
   (scIntMask :signed-byte)                     ;      SS_FLAGS8 
   (state :signed-byte)                         ;      SS_FLAGS8 
   (ctlInd :signed-byte)                        ;      SS_FLAGS8 
   (ireqRouting :signed-byte)                   ;      SS_IRQ 
   (ifType :signed-byte)                        ;      SS_FLAGS8 
   (padding :signed-byte)                       ;       
   )

(def-mactype :ssgetsetssaddrpbptr (find-mactype '(:pointer :ssgetsetssaddrpb)))
(defrecord SSGetSetSSAddrPB 
   (adapter :unsigned-integer)                  ;      SS_ADAPTER 
   (mode :signed-byte)                          ;      SS_BYTE 
   (subfunc :signed-byte)                       ;      SS_BYTE 
   (numAddData :unsigned-integer)               ;      SS_COUNT 
   (buffer :pointer)                            ;      SS_PTR 
   )

(def-mactype :ssgetsetwindowpbptr (find-mactype '(:pointer :ssgetsetwindowpb)))
(defrecord SSGetSetWindowPB 
   (adapter :unsigned-integer)                  ;      SS_ADAPTER 
   (window :unsigned-integer)                   ;      SS_WINDOW 
   (socket :unsigned-integer)                   ;      SS_SOCKET 
   (size :unsigned-long)                        ;      SS_SIZE 
   (state :signed-byte)                         ;      SS_FLAGS8 
   (reserved :signed-byte)                      ;      padding 
   (speed :unsigned-integer)                    ;      SS_SPEED 
   (base :unsigned-long)                        ;      SS_BASE 
   )

(def-mactype :ssgetssinfopbptr (find-mactype '(:pointer :ssgetssinfopb)))
(defrecord SSGetSSInfoPB 
   (adapter :unsigned-integer)                  ;      SS_ADAPTER 
   (compliance :unsigned-integer)               ;      SS_BCD 
   (numAdapters :unsigned-integer)              ;      SS_COUNT 
   (firstAdapter :unsigned-integer)             ;      SS_ADAPTER 
   )

(def-mactype :ssgetstatuspbptr (find-mactype '(:pointer :ssgetstatuspb)))
(defrecord SSGetStatusPB 
   (adapter :unsigned-integer)                  ;      SS_ADAPTER 
   (socket :unsigned-integer)                   ;      SS_SOCKET 
   (cardState :signed-byte)                     ;      SS_FLAGS8 
   (socketState :signed-byte)                   ;      SS_FLAGS8 
   (ctlInd :signed-byte)                        ;      SS_FLAGS8 
   (ireqRouting :signed-byte)                   ;      SS_IRQ 
   (ifType :signed-byte)                        ;      SS_FLAGS8 
   (padding :signed-byte)                       ;       
   )

(def-mactype :ssgetvendorinfopbptr (find-mactype '(:pointer :ssgetvendorinfopb)))
(defrecord SSGetVendorInfoPB 
   (adapter :unsigned-integer)                  ;      SS_ADAPTER 
   (vendorInfoType :signed-byte)                ;      SS_BYTE 
   (reserved :signed-byte)                      ;      padding 
   (buffer :pointer)                            ;      SS_PTR 
   (release :unsigned-integer)                  ;      SS_BCD 
   )

(def-mactype :ssinquireadapterpbptr (find-mactype '(:pointer :ssinquireadapterpb)))
(defrecord SSInquireAdapterPB 
   (adapter :unsigned-integer)                  ;      SS_ADAPTER 
   (buffer :pointer)                            ;      SS_PTR 
   (numSockets :unsigned-integer)               ;      SS_COUNT 
   (numWindows :unsigned-integer)               ;      SS_COUNT 
   (numEDCs :unsigned-integer)                  ;      SS_COUNT 
   )

(def-mactype :ssinquireedcpbptr (find-mactype '(:pointer :ssinquireedcpb)))
(defrecord SSInquireEDCPB 
   (adapter :unsigned-integer)                  ;      SS_ADAPTER 
   (edc :unsigned-integer)                      ;      SS_EDC 
   (sockets :unsigned-integer)                  ;      SS_SKTBITS 
   (caps :signed-byte)                          ;      SS_FLAGS8 
   (types :signed-byte)                         ;      SS_FLAGS8 
   )

(def-mactype :ssinquiresocketpbptr (find-mactype '(:pointer :ssinquiresocketpb)))
(defrecord SSInquireSocketPB 
   (adapter :unsigned-integer)                  ;      SS_ADAPTER 
   (socket :unsigned-integer)                   ;      SS_SOCKET 
   (buffer :pointer)                            ;      SS_PTR 
   (scIntCaps :signed-byte)                     ;      SS_FLAGS8 
   (scRptCaps :signed-byte)                     ;      SS_FLAGS8 
   (ctlIndCaps :signed-byte)                    ;      SS_FLAGS8 
   (padding :signed-byte)                       ;       
   )

(def-mactype :ssinquirewindowpbptr (find-mactype '(:pointer :ssinquirewindowpb)))
(defrecord SSInquireWindowPB 
   (adapter :unsigned-integer)                  ;      SS_ADAPTER 
   (window :unsigned-integer)                   ;      SS_WINDOW 
   (buffer :pointer)                            ;      SS_PTR 
   (wndCaps :signed-byte)                       ;      SS_FLAGS8 
   (reserved :signed-byte)                      ;      padding 
   (sockets :unsigned-integer)                  ;      SS_SKTBITS 
   )

(def-mactype :sspauseedcpbptr (find-mactype '(:pointer :sspauseedcpb)))
(defrecord SSPauseEDCPB 
   (adapter :unsigned-integer)                  ;      SS_ADAPTER 
   (edc :unsigned-integer)                      ;      SS_EDC 
   )

(def-mactype :ssreadedcpbptr (find-mactype '(:pointer :ssreadedcpb)))
(defrecord SSReadEDCPB 
   (adapter :unsigned-integer)                  ;      SS_ADAPTER 
   (edc :unsigned-integer)                      ;      SS_EDC 
   (value :unsigned-integer)                    ;      SS_WORD 
   )

(def-mactype :ssresetsocketpbptr (find-mactype '(:pointer :ssresetsocketpb)))
(defrecord SSResetSocketPB 
   (adapter :unsigned-integer)                  ;      SS_ADAPTER 
   (socket :unsigned-integer)                   ;      SS_SOCKET 
   )

(def-mactype :ssresumeedcpbptr (find-mactype '(:pointer :ssresumeedcpb)))
(defrecord SSResumeEDCPB 
   (adapter :unsigned-integer)                  ;      SS_ADAPTER 
   (edc :unsigned-integer)                      ;      SS_EDC 
   )

(def-mactype :ssstartedcpbptr (find-mactype '(:pointer :ssstartedcpb)))
(defrecord SSStartEDCPB 
   (adapter :unsigned-integer)                  ;      SS_ADAPTER 
   (edc :unsigned-integer)                      ;      SS_EDC 
   )

(def-mactype :ssstopedcpbptr (find-mactype '(:pointer :ssstopedcpb)))
(defrecord SSStopEDCPB 
   (adapter :unsigned-integer)                  ;      SS_ADAPTER 
   (edc :unsigned-integer)                      ;      SS_EDC 
   )

(def-mactype :ssvendorspecificpbptr (find-mactype '(:pointer :ssvendorspecificpb)))
(defrecord SSVendorSpecificPB 
   (vsFunction :unsigned-integer)               ;      SS_WORD 
   (adapter :unsigned-integer)                  ;      SS_ADAPTER 
   (socket :unsigned-integer)                   ;      SS_SOCKET 
   (bufferSize :unsigned-integer)               ;      SS_WORD 
   (buffer :pointer)                            ;      SS_PTR 
   (attributes :unsigned-long)                  ;      SS_LONG 
   )

; 	  attributes constants 	

(defconstant $kSSGoingToSleep #x1)
(defconstant $kSSWakingFromSleep #x2)

; 	
; 	    Non-specific Socket Services Functions
; 		
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  SSGetAdapterCount()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; 
;     Adapter Functions
; ; 
;  *  SSAcknowledgeInterrupt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSGetAdapterCount" 
      ((pb (:pointer :ssgetadaptercountpb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;  *  SSGetSetPriorHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSAcknowledgeInterrupt" 
      ((pb (:pointer :ssacknowledgeinterruptpb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;  *  SSGetSetSSAddr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSGetSetPriorHandler" 
      ((pb (:pointer :ssgetsetpriorhandlerpb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;  *  SSGetAccessOffsets()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSGetSetSSAddr" 
      ((pb (:pointer :ssgetsetssaddrpb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;  *  SSGetAdapter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSGetAccessOffsets" 
      ((pb (:pointer :ssgetaccessoffsetspb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;  *  SSGetSSInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSGetAdapter" 
      ((pb (:pointer :ssgetsetadapterpb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;  *  SSGetVendorInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSGetSSInfo" 
      ((pb (:pointer :ssgetssinfopb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;  *  SSInquireAdapter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSGetVendorInfo" 
      ((pb (:pointer :ssgetvendorinfopb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;  *  SSSetAdapter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSInquireAdapter" 
      ((pb (:pointer :ssinquireadapterpb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;  *  SSVendorSpecific()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSSetAdapter" 
      ((pb (:pointer :ssgetsetadapterpb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;     Socket Functions
; ; 
;  *  SSGetSocket()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSVendorSpecific" 
      ((pb (:pointer :ssvendorspecificpb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;  *  SSGetStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSGetSocket" 
      ((pb (:pointer :ssgetsetsocketpb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;  *  SSInquireSocket()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSGetStatus" 
      ((pb (:pointer :ssgetstatuspb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;  *  SSResetSocket()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSInquireSocket" 
      ((pb (:pointer :ssinquiresocketpb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;  *  SSSetSocket()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSResetSocket" 
      ((pb (:pointer :ssresetsocketpb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;     Window Functions
; ; 
;  *  SSGetPage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSSetSocket" 
      ((pb (:pointer :ssgetsetsocketpb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;  *  SSGetWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSGetPage" 
      ((pb (:pointer :ssgetsetpagepb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;  *  SSInquireWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSGetWindow" 
      ((pb (:pointer :ssgetsetwindowpb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;  *  SSSetPage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSInquireWindow" 
      ((pb (:pointer :ssinquirewindowpb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;  *  SSSetWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSSetPage" 
      ((pb (:pointer :ssgetsetpagepb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;     Error Detection Functions
; ; 
;  *  SSGetEDC()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSSetWindow" 
      ((pb (:pointer :ssgetsetwindowpb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;  *  SSInquireEDC()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSGetEDC" 
      ((pb (:pointer :ssgetsetedcpb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;  *  SSPauseEDC()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSInquireEDC" 
      ((pb (:pointer :ssinquireedcpb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;  *  SSReadEDC()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSPauseEDC" 
      ((pb (:pointer :sspauseedcpb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;  *  SSResumeEDC()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSReadEDC" 
      ((pb (:pointer :ssreadedcpb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;  *  SSSetEDC()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSResumeEDC" 
      ((pb (:pointer :ssresumeedcpb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;  *  SSStartEDC()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSSetEDC" 
      ((pb (:pointer :ssgetsetedcpb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; 
;  *  SSStopEDC()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SSStartEDC" 
      ((pb (:pointer :ssstartedcpb)) (dataPtr :pointer)) 
  :ss_retcode
   () )
(deftrap-inline "_SSStopEDC" 
      ((pb (:pointer :ssstopedcpb)) (dataPtr :pointer)) 
  :ss_retcode
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := SocketServicesIncludes

; $ENDC                                         ; __SOCKETSERVICES__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'SocketServices)