(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Sound.p"
; at Wednesday May 1,2002 2:41:04 pm.
; 
;      File:       Sound.p
;  
;      Contains:   Sound Manager Interfaces.
;  
;      Version:    Technology: Sound Manager 3.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1986-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __SOUND__
; $SETC __SOUND__ := 1

; $I+
; $SETC SoundIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __COMPONENTS__
|#

(require-interface 'Components)
#|                                              ; $I Components.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __DIALOGS__
|#

(require-interface 'Dialogs)
#|                                              ; $I Dialogs.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;                         * * *  N O T E  * * *
; 
;     This file has been updated to include Sound Manager 3.3 interfaces.
; 
;     Some of the Sound Manager 3.0 interfaces were not put into the InterfaceLib
;     that originally shipped with the PowerMacs. These missing functions and the
;     new 3.3 interfaces have been released in the SoundLib library for PowerPC
;     developers to link with. The runtime library for these functions are
;     installed by the Sound Manager. The following functions are found in SoundLib.
; 
;         GetCompressionInfo(), GetSoundPreference(), SetSoundPreference(),
;         UnsignedFixedMulDiv(), SndGetInfo(), SndSetInfo(), GetSoundOutputInfo(),
;         SetSoundOutputInfo(), GetCompressionName(), SoundConverterOpen(),
;         SoundConverterClose(), SoundConverterGetBufferSizes(), SoundConverterBeginConversion(),
;         SoundConverterConvertBuffer(), SoundConverterEndConversion(),
;         AudioGetBass(), AudioGetInfo(), AudioGetMute(), AudioGetOutputDevice(),
;         AudioGetTreble(), AudioGetVolume(), AudioMuteOnEvent(), AudioSetBass(),
;         AudioSetMute(), AudioSetToDefaults(), AudioSetTreble(), AudioSetVolume(),
;         OpenMixerSoundComponent(), CloseMixerSoundComponent(), SoundComponentAddSource(),
;         SoundComponentGetInfo(), SoundComponentGetSource(), SoundComponentGetSourceData(),
;         SoundComponentInitOutputDevice(), SoundComponentPauseSource(),
;         SoundComponentPlaySourceBuffer(), SoundComponentRemoveSource(),
;         SoundComponentSetInfo(), SoundComponentSetOutput(), SoundComponentSetSource(),
;         SoundComponentStartSource(), SoundComponentStopSource(),
;         ParseAIFFHeader(), ParseSndHeader(), SoundConverterGetInfo(), SoundConverterSetInfo()
; 
; 
;     Interfaces for Sound Driver, !!! OBSOLETE and NOT SUPPORTED !!!
; 
;     These items are no longer defined, but appear here so that someone
;     searching the interfaces might find them. If you are using one of these
;     items, you must change your code to support the Sound Manager.
; 
;         swMode, ftMode, ffMode
;         FreeWave, FFSynthRec, Tone, SWSynthRec, Wave, FTSoundRec
;         SndCompletionProcPtr
;         StartSound, StopSound, SoundDone
;         SetSoundVol, GetSoundVol
; 
; 
;   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;    constants
;   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; 
(defconstant $twelfthRootTwo 1.5946309435)

(defconstant $soundListRsrc :|snd |)            ;  Resource type used by Sound Manager 

(defconstant $kSimpleBeepID 1)                  ;  reserved resource ID for Simple Beep 

(defconstant $rate48khz #xBB800000)             ;  48000.00000 in fixed-point 
(defconstant $rate44khz #xAC440000)             ;  44100.00000 in fixed-point 
(defconstant $rate32khz #x7D000000)             ;  32000.00000 in fixed-point 
(defconstant $rate22050hz #x56220000)           ;  22050.00000 in fixed-point 
(defconstant $rate22khz #x56EE8BA3)             ;  22254.54545 in fixed-point 
(defconstant $rate16khz #x3E800000)             ;  16000.00000 in fixed-point 
(defconstant $rate11khz #x2B7745D1)             ;  11127.27273 in fixed-point 
(defconstant $rate11025hz #x2B110000)           ;  11025.00000 in fixed-point 
(defconstant $rate8khz #x1F400000)              ;   8000.00000 in fixed-point 

; 	synthesizer numbers for SndNewChannel	
(defconstant $sampledSynth 5)                   ;  sampled sound synthesizer 

; $IFC CALL_NOT_IN_CARBON 
(defconstant $squareWaveSynth 1)                ;  square wave synthesizer 
(defconstant $waveTableSynth 3)                 ;  wave table synthesizer 
;  old Sound Manager MACE synthesizer numbers 
(defconstant $MACE3snthID 11)
(defconstant $MACE6snthID 13)

; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $kMiddleC 60)                      ;  MIDI note value for middle C 

(defconstant $kNoVolume 0)                      ;  setting for no sound volume 
(defconstant $kFullVolume #x100)                ;  1.0, setting for full hardware output volume 

(defconstant $stdQLength 128)

(defconstant $dataOffsetFlag #x8000)

(defconstant $kUseOptionalOutputDevice -1)      ;  only for Sound Manager 3.0 or later 

(defconstant $notCompressed 0)                  ;  compression ID's 
(defconstant $fixedCompression -1)              ;  compression ID for fixed-sized compression 
(defconstant $variableCompression -2)           ;  compression ID for variable-sized compression 

(defconstant $twoToOne 1)
(defconstant $eightToThree 2)
(defconstant $threeToOne 3)
(defconstant $sixToOne 4)
(defconstant $sixToOnePacketSize 8)
(defconstant $threeToOnePacketSize 16)

(defconstant $stateBlockSize 64)
(defconstant $leftOverBlockSize 32)

(defconstant $firstSoundFormat #x1)             ;  general sound format 
(defconstant $secondSoundFormat #x2)            ;  special sampled sound format (HyperCard) 

; $IFC CALL_NOT_IN_CARBON 
(defconstant $dbBufferReady #x1)                ;  double buffer is filled 
(defconstant $dbLastBuffer #x4)                 ;  last double buffer to play 

; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $sysBeepDisable #x0)               ;  SysBeep() enable flags 
(defconstant $sysBeepEnable #x1)
(defconstant $sysBeepSynchronous #x2)           ;  if bit set, make alert sounds synchronous 

(defconstant $unitTypeNoSelection #xFFFF)       ;  unitTypes for AudioSelection.unitType 
(defconstant $unitTypeSeconds #x0)

(defconstant $stdSH #x0)                        ;  Standard sound header encode value 
(defconstant $extSH #xFF)                       ;  Extended sound header encode value 
(defconstant $cmpSH #xFE)                       ;  Compressed sound header encode value 

; 	command numbers for SndDoCommand and SndDoImmediate	
(defconstant $nullCmd 0)
(defconstant $quietCmd 3)
(defconstant $flushCmd 4)
(defconstant $reInitCmd 5)
(defconstant $waitCmd 10)
(defconstant $pauseCmd 11)
(defconstant $resumeCmd 12)
(defconstant $callBackCmd 13)
(defconstant $syncCmd 14)
(defconstant $availableCmd 24)
(defconstant $versionCmd 25)
(defconstant $volumeCmd 46)                     ;  sound manager 3.0 or later only 
(defconstant $getVolumeCmd 47)                  ;  sound manager 3.0 or later only 
(defconstant $clockComponentCmd 50)             ;  sound manager 3.2.1 or later only 
(defconstant $getClockComponentCmd 51)          ;  sound manager 3.2.1 or later only 
(defconstant $scheduledSoundCmd 52)             ;  sound manager 3.3 or later only 
(defconstant $linkSoundComponentsCmd 53)        ;  sound manager 3.3 or later only 
(defconstant $soundCmd 80)
(defconstant $bufferCmd 81)
(defconstant $rateMultiplierCmd 86)
(defconstant $getRateMultiplierCmd 87)

; $IFC CALL_NOT_IN_CARBON 
; 	command numbers for SndDoCommand and SndDoImmediate that are not available for use in Carbon 	
(defconstant $initCmd 1)
(defconstant $freeCmd 2)
(defconstant $totalLoadCmd 26)
(defconstant $loadCmd 27)
(defconstant $freqDurationCmd 40)
(defconstant $restCmd 41)
(defconstant $freqCmd 42)
(defconstant $ampCmd 43)
(defconstant $timbreCmd 44)
(defconstant $getAmpCmd 45)
(defconstant $waveTableCmd 60)
(defconstant $phaseCmd 61)
(defconstant $rateCmd 82)
(defconstant $continueCmd 83)
(defconstant $doubleBufferCmd 84)
(defconstant $getRateCmd 85)
(defconstant $sizeCmd 90)                       ;  obsolete command 
(defconstant $convertCmd 91)                    ;  obsolete MACE command 

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC OLDROUTINENAMES 
; 	channel initialization parameters	
(defconstant $waveInitChannelMask #x7)
(defconstant $waveInitChannel0 #x4)             ;  wave table only, Sound Manager 2.0 and earlier 
(defconstant $waveInitChannel1 #x5)             ;  wave table only, Sound Manager 2.0 and earlier 
(defconstant $waveInitChannel2 #x6)             ;  wave table only, Sound Manager 2.0 and earlier 
(defconstant $waveInitChannel3 #x7)             ;  wave table only, Sound Manager 2.0 and earlier 
(defconstant $initChan0 #x4)                    ;  obsolete spelling 
(defconstant $initChan1 #x5)                    ;  obsolete spelling 
(defconstant $initChan2 #x6)                    ;  obsolete spelling 
(defconstant $initChan3 #x7)                    ;  obsolete spelling 

(defconstant $outsideCmpSH 0)                   ;  obsolete MACE constant 
(defconstant $insideCmpSH 1)                    ;  obsolete MACE constant 
(defconstant $aceSuccess 0)                     ;  obsolete MACE constant 
(defconstant $aceMemFull 1)                     ;  obsolete MACE constant 
(defconstant $aceNilBlock 2)                    ;  obsolete MACE constant 
(defconstant $aceBadComp 3)                     ;  obsolete MACE constant 
(defconstant $aceBadEncode 4)                   ;  obsolete MACE constant 
(defconstant $aceBadDest 5)                     ;  obsolete MACE constant 
(defconstant $aceBadCmd 6)                      ;  obsolete MACE constant 

; $ENDC                                         ; OLDROUTINENAMES

(defconstant $initChanLeft #x2)                 ;  left stereo channel 
(defconstant $initChanRight #x3)                ;  right stereo channel 
(defconstant $initNoInterp #x4)                 ;  no linear interpolation 
(defconstant $initNoDrop #x8)                   ;  no drop-sample conversion 
(defconstant $initMono #x80)                    ;  monophonic channel 
(defconstant $initStereo #xC0)                  ;  stereo channel 
(defconstant $initMACE3 #x300)                  ;  MACE 3:1 
(defconstant $initMACE6 #x400)                  ;  MACE 6:1 
(defconstant $initPanMask #x3)                  ;  mask for right/left pan values 
(defconstant $initSRateMask #x30)               ;  mask for sample rate values 
(defconstant $initStereoMask #xC0)              ;  mask for mono/stereo values 
(defconstant $initCompMask #xFF00)              ;  mask for compression IDs 

; 	Get&Set Sound Information Selectors	
(defconstant $siActiveChannels :|chac|)         ;  active channels 
(defconstant $siActiveLevels :|lmac|)           ;  active meter levels 
(defconstant $siAGCOnOff :|agc |)               ;  automatic gain control state 
(defconstant $siAsync :|asyn|)                  ;  asynchronous capability 
(defconstant $siAVDisplayBehavior :|avdb|)
(defconstant $siChannelAvailable :|chav|)       ;  number of channels available 
(defconstant $siCompressionAvailable :|cmav|)   ;  compression types available 
(defconstant $siCompressionChannels :|cpct|)    ;  compressor's number of channels 
(defconstant $siCompressionFactor :|cmfa|)      ;  current compression factor 
(defconstant $siCompressionHeader :|cmhd|)      ;  return compression header 
(defconstant $siCompressionNames :|cnam|)       ;  compression type names available 
(defconstant $siCompressionParams :|evaw|)      ;  compression parameters 
(defconstant $siCompressionSampleRate :|cprt|)  ;  compressor's sample rate 
(defconstant $siCompressionType :|comp|)        ;  current compression type 
(defconstant $siContinuous :|cont|)             ;  continous recording 
(defconstant $siDecompressionParams :|wave|)    ;  decompression parameters 
(defconstant $siDeviceBufferInfo :|dbin|)       ;  size of interrupt buffer 
(defconstant $siDeviceConnected :|dcon|)        ;  input device connection status 
(defconstant $siDeviceIcon :|icon|)             ;  input device icon 
(defconstant $siDeviceName :|name|)             ;  input device name 
(defconstant $siEQSpectrumBands :|eqsb|)        ;   number of spectrum bands 
(defconstant $siEQSpectrumLevels :|eqlv|)       ;   gets spectum meter levels 
(defconstant $siEQSpectrumOnOff :|eqlo|)        ;   turn on/off spectum meter levels 
(defconstant $siEQSpectrumResolution :|eqrs|)   ;   set the resolution of the FFT, 0 = low res (<=16 bands), 1 = high res (16-64 bands) 
(defconstant $siEQToneControlGain :|eqtg|)      ;   set the bass and treble gain 
(defconstant $siEQToneControlOnOff :|eqtc|)     ;   turn on equalizer attenuation 
(defconstant $siHardwareBalance :|hbal|)
(defconstant $siHardwareBalanceSteps :|hbls|)
(defconstant $siHardwareBass :|hbas|)
(defconstant $siHardwareBassSteps :|hbst|)
(defconstant $siHardwareBusy :|hwbs|)           ;  sound hardware is in use 
(defconstant $siHardwareFormat :|hwfm|)         ;  get hardware format 
(defconstant $siHardwareMute :|hmut|)           ;  mute state of all hardware 
(defconstant $siHardwareMuteNoPrefs :|hmnp|)    ;  mute state of all hardware, but don't store in prefs  
(defconstant $siHardwareTreble :|htrb|)
(defconstant $siHardwareTrebleSteps :|hwts|)
(defconstant $siHardwareVolume :|hvol|)         ;  volume level of all hardware 
(defconstant $siHardwareVolumeSteps :|hstp|)    ;  number of volume steps for hardware 
(defconstant $siHeadphoneMute :|pmut|)          ;  mute state of headphones 
(defconstant $siHeadphoneVolume :|pvol|)        ;  volume level of headphones 
(defconstant $siHeadphoneVolumeSteps :|hdst|)   ;  number of volume steps for headphones 
(defconstant $siInputAvailable :|inav|)         ;  input sources available 
(defconstant $siInputGain :|gain|)              ;  input gain 
(defconstant $siInputSource :|sour|)            ;  input source selector 
(defconstant $siInputSourceNames :|snam|)       ;  input source names 
(defconstant $siLevelMeterOnOff :|lmet|)        ;  level meter state 
(defconstant $siModemGain :|mgai|)              ;  modem input gain 
(defconstant $siMonitorAvailable :|mnav|)
(defconstant $siMonitorSource :|mons|)
(defconstant $siNumberChannels :|chan|)         ;  current number of channels 
(defconstant $siOptionsDialog :|optd|)          ;  display options dialog 
(defconstant $siOSTypeInputSource :|inpt|)      ;  input source by OSType 
(defconstant $siOSTypeInputAvailable :|inav|)   ;  list of available input source OSTypes 
(defconstant $siOutputDeviceName :|onam|)       ;  output device name 
(defconstant $siPlayThruOnOff :|plth|)          ;  playthrough state 
(defconstant $siPostMixerSoundComponent :|psmx|);  install post-mixer effect 
(defconstant $siPreMixerSoundComponent :|prmx|) ;  install pre-mixer effect 
(defconstant $siQuality :|qual|)                ;  quality setting 
(defconstant $siRateMultiplier :|rmul|)         ;  throttle rate setting 
(defconstant $siRecordingQuality :|qual|)       ;  recording quality 
(defconstant $siSampleRate :|srat|)             ;  current sample rate 
(defconstant $siSampleRateAvailable :|srav|)    ;  sample rates available 
(defconstant $siSampleSize :|ssiz|)             ;  current sample size 
(defconstant $siSampleSizeAvailable :|ssav|)    ;  sample sizes available 
(defconstant $siSetupCDAudio :|sucd|)           ;  setup sound hardware for CD audio 
(defconstant $siSetupModemAudio :|sumd|)        ;  setup sound hardware for modem audio 
(defconstant $siSlopeAndIntercept :|flap|)      ;  floating point variables for conversion 
(defconstant $siSoundClock :|sclk|)
(defconstant $siUseThisSoundClock :|sclc|)      ;  sdev uses this to tell the mixer to use his sound clock 
(defconstant $siSpeakerMute :|smut|)            ;  mute state of all built-in speaker 
(defconstant $siSpeakerVolume :|svol|)          ;  volume level of built-in speaker 
(defconstant $siSSpCPULoadLimit :|3dll|)
(defconstant $siSSpLocalization :|3dif|)
(defconstant $siSSpSpeakerSetup :|3dst|)
(defconstant $siStereoInputGain :|sgai|)        ;  stereo input gain 
(defconstant $siSubwooferMute :|bmut|)          ;  mute state of sub-woofer 
(defconstant $siTerminalType :|ttyp|)           ;   usb terminal type  
(defconstant $siTwosComplementOnOff :|twos|)    ;  two's complement state 
(defconstant $siVendorProduct :|vpro|)          ;   vendor and product ID  
(defconstant $siVolume :|volu|)                 ;  volume level of source 
(defconstant $siVoxRecordInfo :|voxr|)          ;  VOX record parameters 
(defconstant $siVoxStopInfo :|voxs|)            ;  VOX stop parameters 
(defconstant $siWideStereo :|wide|)             ;  wide stereo setting 
(defconstant $siSupportedExtendedFlags :|exfl|) ;  which flags are supported in Extended sound data structures 
(defconstant $siRateConverterRollOffSlope :|rcdb|);  the roll-off slope for the rate converter's filter, in whole dB as a long this value is a long whose range is from 20 (worst quality/fastest performance) to 90 (best quality/slowest performance) 
(defconstant $siOutputLatency :|olte|)          ;  latency of sound output component 

(defconstant $siCloseDriver :|clos|)            ;  reserved for internal use only 
(defconstant $siInitializeDriver :|init|)       ;  reserved for internal use only 
(defconstant $siPauseRecording :|paus|)         ;  reserved for internal use only 
(defconstant $siUserInterruptProc :|user|)      ;  reserved for internal use only 

;   input source Types 
(defconstant $kInvalidSource #xFFFFFFFF)        ;  this source may be returned from GetInfo if no other source is the monitored source 
(defconstant $kNoSource :|none|)                ;  no source selection 
(defconstant $kCDSource :|cd  |)                ;  internal CD player input 
(defconstant $kExtMicSource :|emic|)            ;  external mic input 
(defconstant $kSoundInSource :|sinj|)           ;  sound input jack 
(defconstant $kRCAInSource :|irca|)             ;  RCA jack input 
(defconstant $kTVFMTunerSource :|tvfm|)
(defconstant $kDAVInSource :|idav|)             ;  DAV analog input 
(defconstant $kIntMicSource :|imic|)            ;  internal mic input 
(defconstant $kMediaBaySource :|mbay|)          ;  media bay input 
(defconstant $kModemSource :|modm|)             ;  modem input (internal modem on desktops, PCI input on PowerBooks) 
(defconstant $kPCCardSource :|pcm |)            ;  PC Card pwm input 
(defconstant $kZoomVideoSource :|zvpc|)         ;  zoom video input 
(defconstant $kDVDSource :|dvda|)               ;   DVD audio input 
(defconstant $kMicrophoneArray :|mica|)         ;   microphone array 

;  Sound Component Types and Subtypes 
(defconstant $kNoSoundComponentType :|****|)
(defconstant $kSoundComponentType :|sift|)      ;  component type 
(defconstant $kSoundComponentPPCType :|nift|)   ;  component type for PowerPC code 
(defconstant $kRate8SubType :|ratb|)            ;  8-bit rate converter 
(defconstant $kRate16SubType :|ratw|)           ;  16-bit rate converter 
(defconstant $kConverterSubType :|conv|)        ;  sample format converter 
(defconstant $kSndSourceSubType :|sour|)        ;  generic source component 
(defconstant $kMixerType :|mixr|)
(defconstant $kMixer8SubType :|mixb|)           ;  8-bit mixer 
(defconstant $kMixer16SubType :|mixw|)          ;  16-bit mixer 
(defconstant $kSoundInputDeviceType :|sinp|)    ;  sound input component 
(defconstant $kWaveInSubType :|wavi|)           ;  Windows waveIn 
(defconstant $kWaveInSnifferSubType :|wisn|)    ;  Windows waveIn sniffer 
(defconstant $kSoundOutputDeviceType :|sdev|)   ;  sound output component 
(defconstant $kClassicSubType :|clas|)          ;  classic hardware, i.e. Mac Plus 
(defconstant $kASCSubType :|asc |)              ;  Apple Sound Chip device 
(defconstant $kDSPSubType :|dsp |)              ;  DSP device 
(defconstant $kAwacsSubType :|awac|)            ;  Another of Will's Audio Chips device 
(defconstant $kGCAwacsSubType :|awgc|)          ;  Awacs audio with Grand Central DMA 
(defconstant $kSingerSubType :|sing|)           ;  Singer (via Whitney) based sound 
(defconstant $kSinger2SubType :|sng2|)          ;  Singer 2 (via Whitney) for Acme 
(defconstant $kWhitSubType :|whit|)             ;  Whit sound component for PrimeTime 3 
(defconstant $kSoundBlasterSubType :|sbls|)     ;  Sound Blaster for CHRP 
(defconstant $kWaveOutSubType :|wavo|)          ;  Windows waveOut 
(defconstant $kWaveOutSnifferSubType :|wosn|)   ;  Windows waveOut sniffer 
(defconstant $kDirectSoundSubType :|dsnd|)      ;  Windows DirectSound 
(defconstant $kDirectSoundSnifferSubType :|dssn|);  Windows DirectSound sniffer 
(defconstant $kUNIXsdevSubType :|un1x|)         ;  UNIX base sdev 
(defconstant $kUSBSubType :|usb |)              ;  USB device 
(defconstant $kBlueBoxSubType :|bsnd|)          ;  Blue Box sound component 
(defconstant $kSoundCompressor :|scom|)
(defconstant $kSoundDecompressor :|sdec|)
(defconstant $kAudioComponentType :|adio|)      ;  Audio components and sub-types 
(defconstant $kAwacsPhoneSubType :|hphn|)
(defconstant $kAudioVisionSpeakerSubType :|telc|)
(defconstant $kAudioVisionHeadphoneSubType :|telh|)
(defconstant $kPhilipsFaderSubType :|tvav|)
(defconstant $kSGSToneSubType :|sgs0|)
(defconstant $kSoundEffectsType :|snfx|)        ;  sound effects type 
(defconstant $kEqualizerSubType :|eqal|)        ;  frequency equalizer 
(defconstant $kSSpLocalizationSubType :|snd3|)

;  Format Types 
(defconstant $kSoundNotCompressed :|NONE|)      ;  sound is not compressed 
(defconstant $k8BitOffsetBinaryFormat :|raw |)  ;  8-bit offset binary 
(defconstant $k16BitBigEndianFormat :|twos|)    ;  16-bit big endian 
(defconstant $k16BitLittleEndianFormat :|sowt|) ;  16-bit little endian 
(defconstant $kFloat32Format :|fl32|)           ;  32-bit floating point 
(defconstant $kFloat64Format :|fl64|)           ;  64-bit floating point 
(defconstant $k24BitFormat :|in24|)             ;  24-bit integer 
(defconstant $k32BitFormat :|in32|)             ;  32-bit integer 
(defconstant $k32BitLittleEndianFormat :|23ni|) ;  32-bit little endian integer  
(defconstant $kMACE3Compression :|MAC3|)        ;  MACE 3:1 
(defconstant $kMACE6Compression :|MAC6|)        ;  MACE 6:1 
(defconstant $kCDXA4Compression :|cdx4|)        ;  CD/XA 4:1 
(defconstant $kCDXA2Compression :|cdx2|)        ;  CD/XA 2:1 
(defconstant $kIMACompression :|ima4|)          ;  IMA 4:1 
(defconstant $kULawCompression :|ulaw|)         ;  Law 2:1 
(defconstant $kALawCompression :|alaw|)         ;  aLaw 2:1 
(defconstant $kMicrosoftADPCMFormat #x6D730002) ;  Microsoft ADPCM - ACM code 2 
(defconstant $kDVIIntelIMAFormat #x6D730011)    ;  DVI/Intel IMA ADPCM - ACM code 17 
(defconstant $kDVAudioFormat :|dvca|)           ;  DV Audio 
(defconstant $kQDesignCompression :|QDMC|)      ;  QDesign music 
(defconstant $kQDesign2Compression :|QDM2|)     ;  QDesign2 music 
(defconstant $kQUALCOMMCompression :|Qclp|)     ;  QUALCOMM PureVoice 
(defconstant $kOffsetBinary :|raw |)            ;  for compatibility 
(defconstant $kTwosComplement :|twos|)          ;  for compatibility 
(defconstant $kLittleEndianFormat :|sowt|)      ;  for compatibility 
(defconstant $kMPEGLayer3Format #x6D730055)     ;  MPEG Layer 3, CBR only (pre QT4.1) 
(defconstant $kFullMPEGLay3Format :|.mp3|)      ;  MPEG Layer 3, CBR & VBR (QT4.1 and later) 

#|                                              ; $IFC TARGET_RT_LITTLE_ENDIAN 
(defconstant $k16BitNativeEndianFormat :|sowt|)
(defconstant $k16BitNonNativeEndianFormat :|twos|)

 |#                                             ; $ELSEC
(defconstant $k16BitNativeEndianFormat :|twos|)
(defconstant $k16BitNonNativeEndianFormat :|sowt|)

; $ENDC                                         ; TARGET_RT_LITTLE_ENDIAN

;  Features Flags 
(defconstant $k8BitRawIn #x1)                   ;  data description 
(defconstant $k8BitTwosIn #x2)
(defconstant $k16BitIn #x4)
(defconstant $kStereoIn #x8)
(defconstant $k8BitRawOut #x100)
(defconstant $k8BitTwosOut #x200)
(defconstant $k16BitOut #x400)
(defconstant $kStereoOut #x800)
(defconstant $kReverse #x10000)                 ;    function description 
(defconstant $kRateConvert #x20000)
(defconstant $kCreateSoundSource #x40000)
(defconstant $kVMAwareness #x200000)            ;   component will hold its memory 
(defconstant $kHighQuality #x400000)            ;    performance description 
(defconstant $kNonRealTime #x800000)

;  SoundComponentPlaySourceBuffer action flags 
(defconstant $kSourcePaused #x1)
(defconstant $kPassThrough #x10000)
(defconstant $kNoSoundComponentChain #x20000)

;  SoundParamBlock flags, usefull for OpenMixerSoundComponent 
(defconstant $kNoMixing #x1)                    ;  don't mix source 
(defconstant $kNoSampleRateConversion #x2)      ;  don't convert sample rate (i.e. 11 kHz -> 22 kHz) 
(defconstant $kNoSampleSizeConversion #x4)      ;  don't convert sample size (i.e. 16 -> 8) 
(defconstant $kNoSampleFormatConversion #x8)    ;  don't convert sample format (i.e. 'twos' -> 'raw ') 
(defconstant $kNoChannelConversion #x10)        ;  don't convert stereo/mono 
(defconstant $kNoDecompression #x20)            ;  don't decompress (i.e. 'MAC3' -> 'raw ') 
(defconstant $kNoVolumeConversion #x40)         ;  don't apply volume 
(defconstant $kNoRealtimeProcessing #x80)       ;  won't run at interrupt time 
(defconstant $kScheduledSource #x100)           ;  source is scheduled 
(defconstant $kNonInterleavedBuffer #x200)      ;  buffer is not interleaved samples 
(defconstant $kNonPagingMixer #x400)            ;  if VM is on, use the non-paging mixer 
(defconstant $kSoundConverterMixer #x800)       ;  the mixer is to be used by the SoundConverter 
(defconstant $kPagingMixer #x1000)              ;  the mixer is to be used as a paging mixer when VM is on 
(defconstant $kVMAwareMixer #x2000)             ;  passed to the output device when the SM is going to deal with VM safety 
(defconstant $kExtendedSoundData #x4000)        ;  SoundComponentData record is actually an ExtendedSoundComponentData 

;  SoundParamBlock quality settings 
(defconstant $kBestQuality #x1)                 ;  use interpolation in rate conversion 

;  useful bit masks 
(defconstant $kInputMask #xFF)                  ;  masks off input bits 
(defconstant $kOutputMask #xFF00)               ;  masks off output bits 
(defconstant $kOutputShift 8)                   ;  amount output bits are shifted 
(defconstant $kActionMask #xFF0000)             ;  masks off action bits 
(defconstant $kSoundComponentBits #xFFFFFF)

;  audio atom types 
(defconstant $kAudioFormatAtomType :|frma|)
(defconstant $kAudioEndianAtomType :|enda|)
(defconstant $kAudioVBRAtomType :|vbra|)
(defconstant $kAudioTerminatorAtomType 0)

;  siAVDisplayBehavior types 
(defconstant $kAVDisplayHeadphoneRemove 0)      ;   monitor does not have a headphone attached 
(defconstant $kAVDisplayHeadphoneInsert 1)      ;   monitor has a headphone attached 
(defconstant $kAVDisplayPlainTalkRemove 2)      ;   monitor either sending no input through CPU input port or unable to tell if input is coming in 
(defconstant $kAVDisplayPlainTalkInsert 3)      ;   monitor sending PlainTalk level microphone source input through sound input port 

;  Audio Component constants 
;  Values for whichChannel parameter 
(defconstant $audioAllChannels 0)               ;  All channels (usually interpreted as both left and right) 
(defconstant $audioLeftChannel 1)               ;  Left channel 
(defconstant $audioRightChannel 2)              ;  Right channel 
;  Values for mute parameter 
(defconstant $audioUnmuted 0)                   ;  Device is unmuted 
(defconstant $audioMuted 1)                     ;  Device is muted 
;  Capabilities flags definitions 
(defconstant $audioDoesMono #x1)                ;  Device supports mono output 
(defconstant $audioDoesStereo #x2)              ;  Device supports stereo output 
(defconstant $audioDoesIndependentChannels #x4) ;  Device supports independent software control of each channel 

; 	Sound Input Qualities	
(defconstant $siCDQuality :|cd  |)              ;  44.1kHz, stereo, 16 bit 
(defconstant $siBestQuality :|best|)            ;  22kHz, mono, 8 bit 
(defconstant $siBetterQuality :|betr|)          ;  22kHz, mono, MACE 3:1 
(defconstant $siGoodQuality :|good|)            ;  22kHz, mono, MACE 6:1 
(defconstant $siNoneQuality :|none|)            ;  settings don't match any quality for a get call 

(defconstant $siDeviceIsConnected 1)            ;  input device is connected and ready for input 
(defconstant $siDeviceNotConnected 0)           ;  input device is not connected 
(defconstant $siDontKnowIfConnected -1)         ;  can't tell if input device is connected 
(defconstant $siReadPermission 0)               ;  permission passed to SPBOpenDevice 
(defconstant $siWritePermission 1)              ;  permission passed to SPBOpenDevice 

;  flags that SoundConverterFillBuffer will return 
(defconstant $kSoundConverterDidntFillBuffer #x1);  set if the converter couldn't completely satisfy a SoundConverterFillBuffer request 
(defconstant $kSoundConverterHasLeftOverData #x2);  set if the converter had left over data after completely satisfying a SoundConverterFillBuffer call 

;   flags for extendedFlags fields of ExtendedSoundComponentData, ExtendedSoundParamBlock, and ExtendedScheduledSoundHeader 
(defconstant $kExtendedSoundSampleCountNotValid #x1);   set if sampleCount of SoundComponentData isn't meaningful; use buffer size instead 
(defconstant $kExtendedSoundBufferSizeValid #x2);   set if bufferSize field is valid 

; 
; 	  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; 	   typedefs
; 	  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; 	

(def-mactype :sndcommandptr (find-mactype '(:pointer :sndcommand)))
(defrecord SndCommand 
   (cmd :unsigned-integer)
   (param1 :signed-integer)
   (param2 :signed-long)
   )

(def-mactype :sndchannelptr (find-mactype '(:pointer :sndchannel)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SndCallBackProcPtr = PROCEDURE(chan: SndChannelPtr; VAR cmd: SndCommand);

|#
 |#                                             ; $ELSEC
(def-mactype :sndcallbackprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :sndcallbackupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :sndcallbackupp (find-mactype ':pointer))
; $ENDC
(defrecord SndChannel 
   (nextChan (:pointer :sndchannel))
   (firstMod :pointer)                          ;   reserved for the Sound Manager  
   (callBack :pointer)
   (userInfo :signed-long)
   (wait :signed-long)                          ;   The following is for internal Sound Manager use only. 
   (cmdInProgress :sndcommand)
   (flags :signed-integer)
   (qLength :signed-integer)
   (qHead :signed-integer)
   (qTail :signed-integer)
   (queue (:array :sndcommand 128))
   )

(defconstant $uppSndCallBackProcInfo #x3C0)
; 
; 	 *  NewSndCallBackUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewSndCallBackProc 
(deftrap "_NewSndCallBackUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeSndCallBackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeSndCallBackUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeSndCallBackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallSndCallBackProc 
(deftrap-inline "_InvokeSndCallBackUPP" 
      ((chan (:pointer :sndchannel)) (cmd (:pointer :sndcommand)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; MACE structures

(def-mactype :stateblockptr (find-mactype '(:pointer :stateblock)))
(defrecord StateBlock 
   (stateVar (:array :signed-integer 64))
   )

(def-mactype :leftoverblockptr (find-mactype '(:pointer :leftoverblock)))
(defrecord LeftOverBlock 
   (count :unsigned-long)
   (sampleArea (:array :signed-byte 32))
   )

(def-mactype :modrefptr (find-mactype '(:pointer :modref)))
(defrecord ModRef 
   (modNumber :unsigned-integer)
   (modInit :signed-long)
   )

(def-mactype :sndlistresourceptr (find-mactype '(:pointer :sndlistresource)))
(defrecord SndListResource 
   (format :signed-integer)
   (numModifiers :signed-integer)
   (modifierPart (:array :modref 1))
   (numCommands :signed-integer)
   (commandPart (:array :sndcommand 1))
   (dataPart :signed-byte)
   )

(def-mactype :sndlistptr (find-mactype '(:pointer :sndlistresource)))
(def-mactype :sndlisthandle (find-mactype '(:handle :sndlistresource)))
(def-mactype :sndlisthndl (find-mactype '(:handle :sndlistresource)))
; 	HyperCard sound resource format	
(def-mactype :snd2listresourceptr (find-mactype '(:pointer :snd2listresource)))
(defrecord Snd2ListResource 
   (format :signed-integer)
   (refCount :signed-integer)
   (numCommands :signed-integer)
   (commandPart (:array :sndcommand 1))
   (dataPart :signed-byte)
   )

(def-mactype :snd2listptr (find-mactype '(:pointer :snd2listresource)))
(def-mactype :snd2listhandle (find-mactype '(:handle :snd2listresource)))
(def-mactype :snd2listhndl (find-mactype '(:handle :snd2listresource)))
(def-mactype :soundheaderptr (find-mactype '(:pointer :soundheader)))
(defrecord SoundHeader 
   (samplePtr :pointer)                         ;  if NIL then samples are in sampleArea 
   (length :unsigned-long)                      ;  length of sound in bytes 
   (sampleRate :unsigned-long)                  ;  sample rate for this sound 
   (loopStart :unsigned-long)                   ;  start of looping portion 
   (loopEnd :unsigned-long)                     ;  end of looping portion 
   (encode :unsigned-byte)                      ;  header encoding 
   (baseFrequency :unsigned-byte)               ;  baseFrequency value 
   (sampleArea (:array :unsigned-byte 1 :packed));  space for when samples follow directly 
   )

(def-mactype :cmpsoundheaderptr (find-mactype '(:pointer :cmpsoundheader)))
(defrecord CmpSoundHeader 
   (samplePtr :pointer)                         ;  if nil then samples are in sample area 
   (numChannels :unsigned-long)                 ;  number of channels i.e. mono = 1 
   (sampleRate :unsigned-long)                  ;  sample rate in Apples Fixed point representation 
   (loopStart :unsigned-long)                   ;  loopStart of sound before compression 
   (loopEnd :unsigned-long)                     ;  loopEnd of sound before compression 
   (encode :unsigned-byte)                      ;  data structure used , stdSH, extSH, or cmpSH 
   (baseFrequency :unsigned-byte)               ;  same meaning as regular SoundHeader 
   (numFrames :unsigned-long)                   ;  length in frames ( packetFrames or sampleFrames ) 
   (AIFFSampleRate :float80)                    ;  IEEE sample rate 
   (markerChunk :pointer)                       ;  sync track 
   (format :ostype)                             ;  data format type, was futureUse1 
   (futureUse2 :unsigned-long)                  ;  reserved by Apple 
   (stateVars (:pointer :stateblock))           ;  pointer to State Block 
   (leftOverSamples (:pointer :leftoverblock))  ;  used to save truncated samples between compression calls 
   (compressionID :signed-integer)              ;  0 means no compression, non zero means compressionID 
   (packetSize :unsigned-integer)               ;  number of bits in compressed sample packet 
   (snthID :unsigned-integer)                   ;  resource ID of Sound Manager snth that contains NRT C/E 
   (sampleSize :unsigned-integer)               ;  number of bits in non-compressed sample 
   (sampleArea (:array :unsigned-byte 1 :packed));  space for when samples follow directly 
   )

(def-mactype :extsoundheaderptr (find-mactype '(:pointer :extsoundheader)))
(defrecord ExtSoundHeader 
   (samplePtr :pointer)                         ;  if nil then samples are in sample area 
   (numChannels :unsigned-long)                 ;  number of channels,  ie mono = 1 
   (sampleRate :unsigned-long)                  ;  sample rate in Apples Fixed point representation 
   (loopStart :unsigned-long)                   ;  same meaning as regular SoundHeader 
   (loopEnd :unsigned-long)                     ;  same meaning as regular SoundHeader 
   (encode :unsigned-byte)                      ;  data structure used , stdSH, extSH, or cmpSH 
   (baseFrequency :unsigned-byte)               ;  same meaning as regular SoundHeader 
   (numFrames :unsigned-long)                   ;  length in total number of frames 
   (AIFFSampleRate :float80)                    ;  IEEE sample rate 
   (markerChunk :pointer)                       ;  sync track 
   (instrumentChunks :pointer)                  ;  AIFF instrument chunks 
   (AESRecording :pointer)
   (sampleSize :unsigned-integer)               ;  number of bits in sample 
   (futureUse1 :unsigned-integer)               ;  reserved by Apple 
   (futureUse2 :unsigned-long)                  ;  reserved by Apple 
   (futureUse3 :unsigned-long)                  ;  reserved by Apple 
   (futureUse4 :unsigned-long)                  ;  reserved by Apple 
   (sampleArea (:array :unsigned-byte 1 :packed));  space for when samples follow directly 
   )

(def-mactype :soundheaderunionptr (find-mactype '(:pointer :soundheaderunion)))
(defrecord SoundHeaderUnion 
   (:variant 
      (
      (stdHeader :soundheader)
      )
      (
      (cmpHeader :cmpsoundheader)
      )
      (
      (extHeader :extsoundheader)
      )
      )
   )

(def-mactype :conversionblockptr (find-mactype '(:pointer :conversionblock)))
(defrecord ConversionBlock 
   (destination :signed-integer)
   (unused :signed-integer)
   (inputPtr (:pointer :cmpsoundheader))
   (outputPtr (:pointer :cmpsoundheader))
   )

;   ScheduledSoundHeader flags 

(defconstant $kScheduledSoundDoScheduled #x1)
(defconstant $kScheduledSoundDoCallBack #x2)
(defconstant $kScheduledSoundExtendedHdr #x4)

(def-mactype :scheduledsoundheaderptr (find-mactype '(:pointer :scheduledsoundheader)))
(defrecord ScheduledSoundHeader 
   (u :soundheaderunion)
   (flags :signed-long)
   (reserved :signed-integer)
   (callBackParam1 :signed-integer)
   (callBackParam2 :signed-long)
   (startTime :timerecord)
   )

(def-mactype :extendedscheduledsoundheaderptr (find-mactype '(:pointer :extendedscheduledsoundheader)))
(defrecord ExtendedScheduledSoundHeader 
   (u :soundheaderunion)
   (flags :signed-long)
   (reserved :signed-integer)
   (callBackParam1 :signed-integer)
   (callBackParam2 :signed-long)
   (startTime :timerecord)
   (recordSize :signed-long)
   (extendedFlags :signed-long)
   (bufferSize :signed-long)
   )

(def-mactype :smstatusptr (find-mactype '(:pointer :smstatus)))
(defrecord SMStatus 
   (smMaxCPULoad :signed-integer)
   (smNumChannels :signed-integer)
   (smCurCPULoad :signed-integer)
   )

(def-mactype :scstatusptr (find-mactype '(:pointer :scstatus)))
(defrecord SCStatus 
   (scStartTime :unsigned-long)
   (scEndTime :unsigned-long)
   (scCurrentTime :unsigned-long)
   (scChannelBusy :boolean)
   (scChannelDisposed :boolean)
   (scChannelPaused :boolean)
   (scUnused :boolean)
   (scChannelAttributes :unsigned-long)
   (scCPULoad :signed-long)
   )

(def-mactype :audioselectionptr (find-mactype '(:pointer :audioselection)))
(defrecord AudioSelection 
   (unitType :signed-long)
   (selStart :unsigned-long)
   (selEnd :unsigned-long)
   )

; $IFC CALL_NOT_IN_CARBON 
(def-mactype :snddoublebufferptr (find-mactype '(:pointer :snddoublebuffer)))
(defrecord SndDoubleBuffer 
   (dbNumFrames :signed-long)
   (dbFlags :signed-long)
   (dbUserInfo (:array :signed-long 2))
   (dbSoundData (:array :signed-byte 1))
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SndDoubleBackProcPtr = PROCEDURE(channel: SndChannelPtr; doubleBufferPtr: SndDoubleBufferPtr);

|#
 |#                                             ; $ELSEC
(def-mactype :snddoublebackprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :snddoublebackupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :snddoublebackupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppSndDoubleBackProcInfo #x3C0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewSndDoubleBackUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewSndDoubleBackProc 
(deftrap "_NewSndDoubleBackUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeSndDoubleBackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeSndDoubleBackUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeSndDoubleBackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallSndDoubleBackProc 
(deftrap-inline "_InvokeSndDoubleBackUPP" 
      ((channel (:pointer :sndchannel)) (doubleBufferPtr (:pointer :snddoublebuffer)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :snddoublebufferheaderptr (find-mactype '(:pointer :snddoublebufferheader)))
(defrecord SndDoubleBufferHeader 
   (dbhNumChannels :signed-integer)
   (dbhSampleSize :signed-integer)
   (dbhCompressionID :signed-integer)
   (dbhPacketSize :signed-integer)
   (dbhSampleRate :unsigned-long)
   (dbhBufferPtr (:array (:pointer :snddoublebuffer) 2))
   (dbhDoubleBack :pointer)
   )

(def-mactype :snddoublebufferheader2ptr (find-mactype '(:pointer :snddoublebufferheader2)))
(defrecord SndDoubleBufferHeader2 
   (dbhNumChannels :signed-integer)
   (dbhSampleSize :signed-integer)
   (dbhCompressionID :signed-integer)
   (dbhPacketSize :signed-integer)
   (dbhSampleRate :unsigned-long)
   (dbhBufferPtr (:array (:pointer :snddoublebuffer) 2))
   (dbhDoubleBack :pointer)
   (dbhFormat :ostype)
   )

; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :soundinfolistptr (find-mactype '(:pointer :soundinfolist)))
(defrecord SoundInfoList 
   (count :signed-integer)
   (infoHandle :handle)
   )

(def-mactype :soundcomponentdataptr (find-mactype '(:pointer :soundcomponentdata)))
(defrecord SoundComponentData 
   (flags :signed-long)
   (format :ostype)
   (numChannels :signed-integer)
   (sampleSize :signed-integer)
   (sampleRate :unsigned-long)
   (sampleCount :signed-long)
   (buffer :pointer)
   (reserved :signed-long)
   )

(def-mactype :extendedsoundcomponentdataptr (find-mactype '(:pointer :extendedsoundcomponentdata)))
(defrecord ExtendedSoundComponentData 
   (desc :soundcomponentdata)                   ;  description of sound buffer 
   (recordSize :signed-long)                    ;  size of this record in bytes 
   (extendedFlags :signed-long)                 ;  flags for extended record 
   (bufferSize :signed-long)                    ;  size of buffer in bytes 
   )

(def-mactype :soundparamblockptr (find-mactype '(:pointer :soundparamblock)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SoundParamProcPtr = FUNCTION(VAR pb: SoundParamBlockPtr): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :soundparamprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :soundparamupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :soundparamupp (find-mactype ':pointer))
; $ENDC
(defrecord SoundParamBlock 
   (recordSize :signed-long)                    ;  size of this record in bytes 
   (desc :soundcomponentdata)                   ;  description of sound buffer 
   (rateMultiplier :unsigned-long)              ;  rate multiplier to apply to sound 
   (leftVolume :signed-integer)                 ;  volumes to apply to sound 
   (rightVolume :signed-integer)
   (quality :signed-long)                       ;  quality to apply to sound 
   (filter (:pointer :componentinstancerecord)) ;  filter to apply to sound 
   (moreRtn :pointer)                           ;  routine to call to get more data 
   (completionRtn :pointer)                     ;  routine to call when buffer is complete 
   (refCon :signed-long)                        ;  user refcon 
   (result :signed-integer)                     ;  result 
   )

(def-mactype :extendedsoundparamblockptr (find-mactype '(:pointer :extendedsoundparamblock)))
(defrecord ExtendedSoundParamBlock 
   (pb :soundparamblock)                        ;  classic SoundParamBlock except recordSize == sizeof(ExtendedSoundParamBlock) 
   (reserved :signed-integer)
   (extendedFlags :signed-long)                 ;  flags 
   (bufferSize :signed-long)                    ;  size of buffer in bytes 
   )

(def-mactype :compressioninfoptr (find-mactype '(:pointer :compressioninfo)))
(defrecord CompressionInfo 
   (recordSize :signed-long)
   (format :ostype)
   (compressionID :signed-integer)
   (samplesPerPacket :unsigned-integer)
   (bytesPerPacket :unsigned-integer)
   (bytesPerFrame :unsigned-integer)
   (bytesPerSample :unsigned-integer)
   (futureUse1 :unsigned-integer)
   )

(def-mactype :compressioninfohandle (find-mactype '(:handle :compressioninfo)))
;  variables for floating point conversion 
(def-mactype :soundslopeandinterceptrecordptr (find-mactype '(:pointer :soundslopeandinterceptrecord)))
(defrecord SoundSlopeAndInterceptRecord 
#|
; Warning: type-size: unknown type double-float
|##|
; Warning: type-size: unknown type double-float
|#
   (slope :double-float)
#|
; Warning: type-size: unknown type double-float
|##|
; Warning: type-size: unknown type double-float
|#
   (intercept :double-float)
#|
; Warning: type-size: unknown type double-float
|##|
; Warning: type-size: unknown type double-float
|#
   (minClip :double-float)
#|
; Warning: type-size: unknown type double-float
|##|
; Warning: type-size: unknown type double-float
|#
   (maxClip :double-float)
   )

(def-mactype :soundslopeandinterceptptr (find-mactype '(:pointer :soundslopeandinterceptrecord)))
;  private thing to use as a reference to a Sound Converter 
(def-mactype :soundconverter (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :soundconverterptr (find-mactype '(:pointer :pointer)));  when a VAR xx:SoundConverter parameter can be nil, it is changed to xx: SoundConverterPtr 
;  callback routine to provide data to the Sound Converter 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SoundConverterFillBufferDataProcPtr = FUNCTION(VAR data: SoundComponentDataPtr; refCon: UNIV Ptr): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :soundconverterfillbufferdataprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :soundconverterfillbufferdataupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :soundconverterfillbufferdataupp (find-mactype ':pointer))
; $ENDC
;  private thing to use as a reference to a Sound Source 
(def-mactype :soundsource (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :soundsourceptr (find-mactype '(:pointer :pointer)));  when a VAR xx:SoundSource parameter can be nil, it is changed to xx: SoundSourcePtr 
(def-mactype :soundcomponentlinkptr (find-mactype '(:pointer :soundcomponentlink)))
(defrecord SoundComponentLink 
   (description :componentdescription)          ;  Describes the sound component 
   (mixerID :pointer)                           ;  Reserved by Apple 
   (linkID (:pointer :pointer))                 ;  Reserved by Apple 
   )

(def-mactype :audioinfoptr (find-mactype '(:pointer :audioinfo)))
(defrecord AudioInfo 
   (capabilitiesFlags :signed-long)             ;  Describes device capabilities 
   (reserved :signed-long)                      ;  Reserved by Apple 
   (numVolumeSteps :unsigned-integer)           ;  Number of significant increments between min and max volume 
   )

(def-mactype :audioformatatomptr (find-mactype '(:pointer :audioformatatom)))
(defrecord AudioFormatAtom 
   (size :signed-long)                          ;   = sizeof(AudioFormatAtom) 
   (atomType :ostype)                           ;   = kAudioFormatAtomType 
   (format :ostype)
   )

(def-mactype :audioendianatomptr (find-mactype '(:pointer :audioendianatom)))
(defrecord AudioEndianAtom 
   (size :signed-long)                          ;   = sizeof(AudioEndianAtom) 
   (atomType :ostype)                           ;   = kAudioEndianAtomType 
   (littleEndian :signed-integer)
   )

(def-mactype :audioterminatoratomptr (find-mactype '(:pointer :audioterminatoratom)))
(defrecord AudioTerminatorAtom 
   (size :signed-long)                          ;   = sizeof(AudioTerminatorAtom) 
   (atomType :ostype)                           ;   = kAudioTerminatorAtomType 
   )

(def-mactype :levelmeterinfoptr (find-mactype '(:pointer :levelmeterinfo)))
(defrecord LevelMeterInfo 
   (numChannels :signed-integer)                ;   mono or stereo source 
   (leftMeter :signed-byte)                     ;   0-255 range 
   (rightMeter :signed-byte)                    ;   0-255 range 
   )

(def-mactype :eqspectrumbandsrecordptr (find-mactype '(:pointer :eqspectrumbandsrecord)))
(defrecord EQSpectrumBandsRecord 
   (count :signed-integer)
   (frequency (:pointer :unsigned-long))        ;   pointer to array of frequencies 
   )

;   Sound Input Structures 
(def-mactype :spbptr (find-mactype '(:pointer :spb)))
; 	user procedures called by sound input routines	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SIInterruptProcPtr = PROCEDURE(inParamPtr: SPBPtr; dataBuffer: Ptr; peakAmplitude: INTEGER; sampleSize: LONGINT);

|#
 |#                                             ; $ELSEC
(def-mactype :siinterruptprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SICompletionProcPtr = PROCEDURE(inParamPtr: SPBPtr);

|#
 |#                                             ; $ELSEC
(def-mactype :sicompletionprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :siinterruptupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :siinterruptupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :sicompletionupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :sicompletionupp (find-mactype ':pointer))
; $ENDC
; 	Sound Input Parameter Block	
(defrecord SPB 
   (inRefNum :signed-long)                      ;  reference number of sound input device 
   (count :unsigned-long)                       ;  number of bytes to record 
   (milliseconds :unsigned-long)                ;  number of milliseconds to record 
   (bufferLength :unsigned-long)                ;  length of buffer in bytes 
   (bufferPtr :pointer)                         ;  buffer to store sound data in 
   (completionRoutine :pointer)                 ;  completion routine 
   (interruptRoutine :pointer)                  ;  interrupt routine 
   (userLong :signed-long)                      ;  user-defined field 
   (error :signed-integer)                      ;  error 
   (unused1 :signed-long)                       ;  reserved - must be zero 
   )

(defconstant $uppSoundParamProcInfo #xD0)
(defconstant $uppSoundConverterFillBufferDataProcInfo #x3D0)
(defconstant $uppSIInterruptProcInfo #x1C579802)
(defconstant $uppSICompletionProcInfo #xC0)
; 
; 	 *  NewSoundParamUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewSoundParamProc 
(deftrap "_NewSoundParamUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewSoundConverterFillBufferDataUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewSoundConverterFillBufferDataProc 
(deftrap "_NewSoundConverterFillBufferDataUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewSIInterruptUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewSIInterruptProc 
(deftrap "_NewSIInterruptUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewSICompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewSICompletionProc 
(deftrap "_NewSICompletionUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeSoundParamUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeSoundParamUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeSoundConverterFillBufferDataUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeSoundConverterFillBufferDataUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeSIInterruptUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeSIInterruptUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeSICompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeSICompletionUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeSoundParamUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallSoundParamProc 
(deftrap-inline "_InvokeSoundParamUPP" 
      ((pb (:pointer (:pointer :soundparamblock))) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; 
;  *  InvokeSoundConverterFillBufferDataUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallSoundConverterFillBufferDataProc 
(deftrap-inline "_InvokeSoundConverterFillBufferDataUPP" 
      ((data (:pointer (:pointer :soundcomponentdata))) (refCon :pointer) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; 
;  *  InvokeSIInterruptUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallSIInterruptProc             ; 
;  *  InvokeSICompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InvokeSIInterruptUPP" 
      ((inParamPtr (:pointer :spb)) (dataBuffer :pointer) (peakAmplitude :signed-integer) (sampleSize :signed-long) (userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallSICompletionProc 
(deftrap-inline "_InvokeSICompletionUPP" 
      ((inParamPtr (:pointer :spb)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	FilePlayCompletionProcPtr = PROCEDURE(chan: SndChannelPtr);

|#
 |#                                             ; $ELSEC
(def-mactype :fileplaycompletionprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :fileplaycompletionupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :fileplaycompletionupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppFilePlayCompletionProcInfo #xC0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewFilePlayCompletionUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewFilePlayCompletionProc 
(deftrap "_NewFilePlayCompletionUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeFilePlayCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeFilePlayCompletionUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeFilePlayCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallFilePlayCompletionProc 
(deftrap-inline "_InvokeFilePlayCompletionUPP" 
      ((chan (:pointer :sndchannel)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;    prototypes
;   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; 
;  Sound Manager routines 
; 
;  *  SysBeep()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SysBeep" 
      ((duration :signed-integer))
   nil
   (:stack-trap #xA9C8))

; 
;  *  SndDoCommand()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_SndDoCommand" 
      ((chan (:pointer :sndchannel)) (cmd (:pointer :sndcommand)) (noWait :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA803))

; 
;  *  SndDoImmediate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_SndDoImmediate" 
      ((chan (:pointer :sndchannel)) (cmd (:pointer :sndcommand)))
   (:stack :signed-integer)
   (:stack-trap #xA804))

; 
;  *  SndNewChannel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SndNewChannel" 
      ((chan (:pointer (:pointer :sndchannel))) (synth :signed-integer) (init :signed-long) (userRoutine :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA807))

; 
;  *  SndDisposeChannel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SndDisposeChannel" 
      ((chan (:pointer :sndchannel)) (quietNow :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA801))

; 
;  *  SndPlay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SndPlay" 
      ((chan (:pointer :sndchannel)) (sndHandle (:handle :sndlistresource)) (async :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA805))

; $IFC OLDROUTINENAMES 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SndAddModifier()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SndAddModifier" 
      ((chan (:pointer :sndchannel)) (modifier :pointer) (id :signed-integer) (init :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA802))

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; OLDROUTINENAMES

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SndControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SndControl" 
      ((id :signed-integer) (cmd (:pointer :sndcommand)))
   (:stack :signed-integer)
   (:stack-trap #xA806))

;  Sound Manager 2.0 and later, uses _SoundDispatch 
; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  SndSoundManagerVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SndSoundManagerVersion" 
      ()
   (:stack :numversion)
   (:stack-trap #xA800 :d0 (+ (ash 12 16) 8)))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SndStartFilePlay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SndStartFilePlay" 
      ((chan (:pointer :sndchannel)) (fRefNum :signed-integer) (resNum :signed-integer) (bufferSize :signed-long) (theBuffer :pointer) (theSelection (:pointer :audioselection)) (theCompletion :pointer) (async :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 3328 16) 8) chan fRefNum resNum bufferSize theBuffer theSelection theCompletion async))

; 
;  *  SndPauseFilePlay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SndPauseFilePlay" 
      ((chan (:pointer :sndchannel)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 516 16) 8) chan))

; 
;  *  SndStopFilePlay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SndStopFilePlay" 
      ((chan (:pointer :sndchannel)) (quietNow :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 776 16) 8) chan quietNow))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  SndChannelStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SndChannelStatus" 
      ((chan (:pointer :sndchannel)) (theLength :signed-integer) (theStatus (:pointer :scstatus)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1296 16) 8) chan theLength theStatus))

; 
;  *  SndManagerStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SndManagerStatus" 
      ((theLength :signed-integer) (theStatus (:pointer :smstatus)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 788 16) 8) theLength theStatus))

; 
;  *  SndGetSysBeepState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SndGetSysBeepState" 
      ((sysBeepState (:pointer :signed-integer)))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 536 16) 8) sysBeepState))

; 
;  *  SndSetSysBeepState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SndSetSysBeepState" 
      ((sysBeepState :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 284 16) 8) sysBeepState))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SndPlayDoubleBuffer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SndPlayDoubleBuffer" 
      ((chan (:pointer :sndchannel)) (theParams (:pointer :snddoublebufferheader)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1056 16) 8) chan theParams))

;  MACE compression routines, uses _SoundDispatch 
; 
;  *  MACEVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MACEVersion" 
      ()
   (:stack :numversion)
   (:stack-trap #xA800 :d0 (+ (ash 0 16) 16)))

; 
;  *  Comp3to1()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_Comp3to1" 
      ((inBuffer :pointer) (outBuffer :pointer) (cnt :unsigned-long) (inState (:pointer :stateblock)) (outState (:pointer :stateblock)) (numChannels :unsigned-long) (whichChannel :unsigned-long))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 4 16) 16) inBuffer outBuffer cnt inState outState numChannels whichChannel))

; 
;  *  Exp1to3()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_Exp1to3" 
      ((inBuffer :pointer) (outBuffer :pointer) (cnt :unsigned-long) (inState (:pointer :stateblock)) (outState (:pointer :stateblock)) (numChannels :unsigned-long) (whichChannel :unsigned-long))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 8 16) 16) inBuffer outBuffer cnt inState outState numChannels whichChannel))

; 
;  *  Comp6to1()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_Comp6to1" 
      ((inBuffer :pointer) (outBuffer :pointer) (cnt :unsigned-long) (inState (:pointer :stateblock)) (outState (:pointer :stateblock)) (numChannels :unsigned-long) (whichChannel :unsigned-long))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 12 16) 16) inBuffer outBuffer cnt inState outState numChannels whichChannel))

; 
;  *  Exp1to6()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_Exp1to6" 
      ((inBuffer :pointer) (outBuffer :pointer) (cnt :unsigned-long) (inState (:pointer :stateblock)) (outState (:pointer :stateblock)) (numChannels :unsigned-long) (whichChannel :unsigned-long))
   nil
   (:stack-trap #xA800 :d0 (+ (ash 16 16) 16) inBuffer outBuffer cnt inState outState numChannels whichChannel))

;  Sound Manager 3.0 and later calls, uses _SoundDispatch 
; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  GetSysBeepVolume()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetSysBeepVolume" 
      ((level (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 548 16) 24) level))

; 
;  *  SetSysBeepVolume()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetSysBeepVolume" 
      ((level :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 552 16) 24) level))

; 
;  *  GetDefaultOutputVolume()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetDefaultOutputVolume" 
      ((level (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 556 16) 24) level))

; 
;  *  SetDefaultOutputVolume()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetDefaultOutputVolume" 
      ((level :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 560 16) 24) level))

; 
;  *  GetSoundHeaderOffset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetSoundHeaderOffset" 
      ((sndHandle (:handle :sndlistresource)) (offset (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1028 16) 24) sndHandle offset))

; 
;  *  UnsignedFixedMulDiv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         not available
;  

(deftrap "_UnsignedFixedMulDiv" 
      ((value :unsigned-long) (multiplier :unsigned-long) (divisor :unsigned-long))
   (:stack :unsigned-long)
   (:stack-trap #xA800 :d0 (+ (ash 1548 16) 24) value multiplier divisor))

; 
;  *  GetCompressionInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetCompressionInfo" 
      ((compressionID :signed-integer) (format :ostype) (numChannels :signed-integer) (sampleSize :signed-integer) (cp (:pointer :compressioninfo)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1808 16) 24) compressionID format numChannels sampleSize cp))

; 
;  *  SetSoundPreference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetSoundPreference" 
      ((theType :ostype) (name (:pointer (:string 255))) (settings :handle))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1588 16) 24) theType name settings))

; 
;  *  GetSoundPreference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetSoundPreference" 
      ((theType :ostype) (name (:pointer (:string 255))) (settings :handle))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1592 16) 24) theType name settings))

; 
;  *  OpenMixerSoundComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OpenMixerSoundComponent" 
      ((outputDescription (:pointer :soundcomponentdata)) (outputFlags :signed-long) (mixerComponent (:pointer (:pointer :componentinstancerecord))))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1556 16) 24) outputDescription outputFlags mixerComponent))

; 
;  *  CloseMixerSoundComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CloseMixerSoundComponent" 
      ((ci (:pointer :componentinstancerecord)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 536 16) 24) ci))

;  Sound Manager 3.1 and later calls, uses _SoundDispatch 
; 
;  *  SndGetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SndGetInfo" 
      ((chan (:pointer :sndchannel)) (selector :ostype) (infoPtr :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1596 16) 24) chan selector infoPtr))

; 
;  *  SndSetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SndSetInfo" 
      ((chan (:pointer :sndchannel)) (selector :ostype) (infoPtr :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1600 16) 24) chan selector infoPtr))

; 
;  *  GetSoundOutputInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetSoundOutputInfo" 
      ((outputDevice (:pointer :componentrecord)) (selector :ostype) (infoPtr :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1604 16) 24) outputDevice selector infoPtr))

; 
;  *  SetSoundOutputInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetSoundOutputInfo" 
      ((outputDevice (:pointer :componentrecord)) (selector :ostype) (infoPtr :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1608 16) 24) outputDevice selector infoPtr))

;  Sound Manager 3.2 and later calls, uses _SoundDispatch 
; 
;  *  GetCompressionName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetCompressionName" 
      ((compressionType :ostype) (compressionName (:pointer (:string 255))))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1100 16) 24) compressionType compressionName))

; 
;  *  SoundConverterOpen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap "_SoundConverterOpen" 
      ((inputFormat (:pointer :soundcomponentdata)) (outputFormat (:pointer :soundcomponentdata)) (sc (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1616 16) 24) inputFormat outputFormat sc))

; 
;  *  SoundConverterClose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SoundConverterClose" 
      ((sc :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 596 16) 24) sc))

; 
;  *  SoundConverterGetBufferSizes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SoundConverterGetBufferSizes" 
      ((sc :pointer) (inputBytesTarget :unsigned-long) (inputFrames (:pointer :unsigned-long)) (inputBytes (:pointer :unsigned-long)) (outputBytes (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 2648 16) 24) sc inputBytesTarget inputFrames inputBytes outputBytes))

; 
;  *  SoundConverterBeginConversion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SoundConverterBeginConversion" 
      ((sc :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 604 16) 24) sc))

; 
;  *  SoundConverterConvertBuffer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SoundConverterConvertBuffer" 
      ((sc :pointer) (inputPtr :pointer) (inputFrames :unsigned-long) (outputPtr :pointer) (outputFrames (:pointer :unsigned-long)) (outputBytes (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 3168 16) 24) sc inputPtr inputFrames outputPtr outputFrames outputBytes))

; 
;  *  SoundConverterEndConversion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SoundConverterEndConversion" 
      ((sc :pointer) (outputPtr :pointer) (outputFrames (:pointer :unsigned-long)) (outputBytes (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 2148 16) 24) sc outputPtr outputFrames outputBytes))

;  Sound Manager 3.3 and later calls, uses _SoundDispatch 
; 
;  *  SoundConverterGetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.3 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SoundConverterGetInfo" 
      ((sc :pointer) (selector :ostype) (infoPtr :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1640 16) 24) sc selector infoPtr))

; 
;  *  SoundConverterSetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.3 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SoundConverterSetInfo" 
      ((sc :pointer) (selector :ostype) (infoPtr :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1644 16) 24) sc selector infoPtr))

;  Sound Manager 3.6 and later calls, uses _SoundDispatch 
; 
;  *  SoundConverterFillBuffer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.6 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SoundConverterFillBuffer" 
      ((sc :pointer) (fillBufferDataUPP :pointer) (fillBufferDataRefCon :pointer) (outputBuffer :pointer) (outputBufferByteSize :unsigned-long) (bytesWritten (:pointer :unsigned-long)) (framesWritten (:pointer :unsigned-long)) (outputFlags (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 4216 16) 24) sc fillBufferDataUPP fillBufferDataRefCon outputBuffer outputBufferByteSize bytesWritten framesWritten outputFlags))

; 
;  *  SoundManagerGetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.6 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SoundManagerGetInfo" 
      ((selector :ostype) (infoPtr :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1148 16) 24) selector infoPtr))

; 
;  *  SoundManagerSetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.6 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SoundManagerSetInfo" 
      ((selector :ostype) (infoPtr :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1152 16) 24) selector infoPtr))

; 
;   Sound Component Functions
;    basic sound component functions
; 

; 
;  *  SoundComponentInitOutputDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SoundComponentInitOutputDevice" 
      ((ti (:pointer :componentinstancerecord)) (actions :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ti actions ((+ (ash 4 16) 1) :signed-longint)))

; 
;  *  SoundComponentSetSource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SoundComponentSetSource" 
      ((ti (:pointer :componentinstancerecord)) (sourceID :pointer) (source (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ti sourceID source ((+ (ash 8 16) 2) :signed-longint)))

; 
;  *  SoundComponentGetSource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SoundComponentGetSource" 
      ((ti (:pointer :componentinstancerecord)) (sourceID :pointer) (source (:pointer (:pointer :componentinstancerecord))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ti sourceID source ((+ (ash 8 16) 3) :signed-longint)))

; 
;  *  SoundComponentGetSourceData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SoundComponentGetSourceData" 
      ((ti (:pointer :componentinstancerecord)) (sourceData (:pointer (:pointer :soundcomponentdata))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ti sourceData ((+ (ash 4 16) 4) :signed-longint)))

; 
;  *  SoundComponentSetOutput()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SoundComponentSetOutput" 
      ((ti (:pointer :componentinstancerecord)) (requested (:pointer :soundcomponentdata)) (actual (:pointer (:pointer :soundcomponentdata))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ti requested actual ((+ (ash 8 16) 5) :signed-longint)))

;   junction methods for the mixer, must be called at non-interrupt level 
; 
;  *  SoundComponentAddSource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SoundComponentAddSource" 
      ((ti (:pointer :componentinstancerecord)) (sourceID (:pointer :pointer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ti sourceID ((+ (ash 4 16) 257) :signed-longint)))

; 
;  *  SoundComponentRemoveSource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SoundComponentRemoveSource" 
      ((ti (:pointer :componentinstancerecord)) (sourceID :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ti sourceID ((+ (ash 4 16) 258) :signed-longint)))

;   info methods 
; 
;  *  SoundComponentGetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SoundComponentGetInfo" 
      ((ti (:pointer :componentinstancerecord)) (sourceID :pointer) (selector :ostype) (infoPtr :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ti sourceID selector infoPtr ((+ (ash 12 16) 259) :signed-longint)))

; 
;  *  SoundComponentSetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SoundComponentSetInfo" 
      ((ti (:pointer :componentinstancerecord)) (sourceID :pointer) (selector :ostype) (infoPtr :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ti sourceID selector infoPtr ((+ (ash 12 16) 260) :signed-longint)))

;   control methods 
; 
;  *  SoundComponentStartSource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SoundComponentStartSource" 
      ((ti (:pointer :componentinstancerecord)) (count :signed-integer) (sources (:pointer :pointer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ti count sources ((+ (ash 6 16) 261) :signed-longint)))

; 
;  *  SoundComponentStopSource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SoundComponentStopSource" 
      ((ti (:pointer :componentinstancerecord)) (count :signed-integer) (sources (:pointer :pointer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ti count sources ((+ (ash 6 16) 262) :signed-longint)))

; 
;  *  SoundComponentPauseSource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SoundComponentPauseSource" 
      ((ti (:pointer :componentinstancerecord)) (count :signed-integer) (sources (:pointer :pointer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ti count sources ((+ (ash 6 16) 263) :signed-longint)))

; 
;  *  SoundComponentPlaySourceBuffer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SoundComponentPlaySourceBuffer" 
      ((ti (:pointer :componentinstancerecord)) (sourceID :pointer) (pb (:pointer :soundparamblock)) (actions :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ti sourceID pb actions ((+ (ash 12 16) 264) :signed-longint)))

;  Audio Components 
; Volume is described as a value between 0 and 1, with 0 indicating minimum
;   volume and 1 indicating maximum volume; if the device doesn't support
;   software control of volume, then a value of unimpErr is returned, indicating
;   that these functions are not supported by the device
; 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  AudioGetVolume()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AudioGetVolume" 
      ((ac (:pointer :componentinstancerecord)) (whichChannel :signed-integer) (volume (:pointer :signed-integer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ac whichChannel volume ((+ (ash 6 16) 0) :signed-longint)))

; 
;  *  AudioSetVolume()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AudioSetVolume" 
      ((ac (:pointer :componentinstancerecord)) (whichChannel :signed-integer) (volume :signed-integer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ac whichChannel volume ((+ (ash 4 16) 1) :signed-longint)))

; If the device doesn't support software control of mute, then a value of unimpErr is
; returned, indicating that these functions are not supported by the device.
; 
;  *  AudioGetMute()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AudioGetMute" 
      ((ac (:pointer :componentinstancerecord)) (whichChannel :signed-integer) (mute (:pointer :signed-integer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ac whichChannel mute ((+ (ash 6 16) 2) :signed-longint)))

; 
;  *  AudioSetMute()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AudioSetMute" 
      ((ac (:pointer :componentinstancerecord)) (whichChannel :signed-integer) (mute :signed-integer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ac whichChannel mute ((+ (ash 4 16) 3) :signed-longint)))

; AudioSetToDefaults causes the associated device to reset its volume and mute values
; (and perhaps other characteristics, e.g. attenuation) to "factory default" settings
; 
;  *  AudioSetToDefaults()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AudioSetToDefaults" 
      ((ac (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ac ((+ (ash 0 16) 4) :signed-longint)))

;  This routine is required; it must be implemented by all audio components 

; 
;  *  AudioGetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AudioGetInfo" 
      ((ac (:pointer :componentinstancerecord)) (info (:pointer :audioinfo)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ac info ((+ (ash 4 16) 5) :signed-longint)))

; 
;  *  AudioGetBass()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AudioGetBass" 
      ((ac (:pointer :componentinstancerecord)) (whichChannel :signed-integer) (bass (:pointer :signed-integer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ac whichChannel bass ((+ (ash 6 16) 6) :signed-longint)))

; 
;  *  AudioSetBass()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AudioSetBass" 
      ((ac (:pointer :componentinstancerecord)) (whichChannel :signed-integer) (bass :signed-integer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ac whichChannel bass ((+ (ash 4 16) 7) :signed-longint)))

; 
;  *  AudioGetTreble()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AudioGetTreble" 
      ((ac (:pointer :componentinstancerecord)) (whichChannel :signed-integer) (Treble (:pointer :signed-integer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ac whichChannel Treble ((+ (ash 6 16) 8) :signed-longint)))

; 
;  *  AudioSetTreble()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AudioSetTreble" 
      ((ac (:pointer :componentinstancerecord)) (whichChannel :signed-integer) (Treble :signed-integer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ac whichChannel Treble ((+ (ash 4 16) 9) :signed-longint)))

; 
;  *  AudioGetOutputDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AudioGetOutputDevice" 
      ((ac (:pointer :componentinstancerecord)) (outputDevice (:pointer (:pointer :componentrecord))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ac outputDevice ((+ (ash 4 16) 10) :signed-longint)))

;  This is routine is private to the AudioVision component.  It enables the watching of the mute key. 
; 
;  *  AudioMuteOnEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AudioMuteOnEvent" 
      ((ac (:pointer :componentinstancerecord)) (muteOnEvent :signed-integer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ac muteOnEvent ((+ (ash 2 16) 129) :signed-longint)))

; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $kDelegatedSoundComponentSelectors #x100)

; 	 Sound Input Manager routines, uses _SoundDispatch 	
; 
; 	 *  SPBVersion()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_SPBVersion" 
      ()
   (:stack :numversion)
   (:stack-trap #xA800 :d0 (+ (ash 0 16) 20)))

; 
;  *  SndRecord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SndRecord" 
      ((filterProc :pointer) (corner :point) (quality :ostype) (sndHandle (:pointer (:handle :sndlistresource))))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 2052 16) 20) filterProc corner quality sndHandle))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SndRecordToFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SndRecordToFile" 
      ((filterProc :pointer) (corner :point) (quality :ostype) (fRefNum :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1800 16) 20) filterProc corner quality fRefNum))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  SPBSignInDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SPBSignInDevice" 
      ((deviceRefNum :signed-integer) (deviceName (:string 255)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 780 16) 20) deviceRefNum deviceName))

; 
;  *  SPBSignOutDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SPBSignOutDevice" 
      ((deviceRefNum :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 272 16) 20) deviceRefNum))

; 
;  *  SPBGetIndexedDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SPBGetIndexedDevice" 
      ((count :signed-integer) (deviceName (:pointer (:string 255))) (deviceIconHandle (:pointer :handle)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1300 16) 20) count deviceName deviceIconHandle))

; 
;  *  SPBOpenDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SPBOpenDevice" 
      ((deviceName (:string 255)) (permission :signed-integer) (inRefNum (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1304 16) 20) deviceName permission inRefNum))

; 
;  *  SPBCloseDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SPBCloseDevice" 
      ((inRefNum :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 540 16) 20) inRefNum))

; 
;  *  SPBRecord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SPBRecord" 
      ((inParamPtr (:pointer :spb)) (asynchFlag :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 800 16) 20) inParamPtr asynchFlag))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SPBRecordToFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SPBRecordToFile" 
      ((fRefNum :signed-integer) (inParamPtr (:pointer :spb)) (asynchFlag :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1060 16) 20) fRefNum inParamPtr asynchFlag))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  SPBPauseRecording()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SPBPauseRecording" 
      ((inRefNum :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 552 16) 20) inRefNum))

; 
;  *  SPBResumeRecording()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SPBResumeRecording" 
      ((inRefNum :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 556 16) 20) inRefNum))

; 
;  *  SPBStopRecording()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SPBStopRecording" 
      ((inRefNum :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 560 16) 20) inRefNum))

; 
;  *  SPBGetRecordingStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SPBGetRecordingStatus" 
      ((inRefNum :signed-long) (recordingStatus (:pointer :signed-integer)) (meterLevel (:pointer :signed-integer)) (totalSamplesToRecord (:pointer :unsigned-long)) (numberOfSamplesRecorded (:pointer :unsigned-long)) (totalMsecsToRecord (:pointer :unsigned-long)) (numberOfMsecsRecorded (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 3636 16) 20) inRefNum recordingStatus meterLevel totalSamplesToRecord numberOfSamplesRecorded totalMsecsToRecord numberOfMsecsRecorded))

; 
;  *  SPBGetDeviceInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SPBGetDeviceInfo" 
      ((inRefNum :signed-long) (infoType :ostype) (infoData :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1592 16) 20) inRefNum infoType infoData))

; 
;  *  SPBSetDeviceInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SPBSetDeviceInfo" 
      ((inRefNum :signed-long) (infoType :ostype) (infoData :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1596 16) 20) inRefNum infoType infoData))

; 
;  *  SPBMillisecondsToBytes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SPBMillisecondsToBytes" 
      ((inRefNum :signed-long) (milliseconds (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1088 16) 20) inRefNum milliseconds))

; 
;  *  SPBBytesToMilliseconds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SPBBytesToMilliseconds" 
      ((inRefNum :signed-long) (byteCount (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1092 16) 20) inRefNum byteCount))

; 
;  *  SetupSndHeader()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetupSndHeader" 
      ((sndHandle (:handle :sndlistresource)) (numChannels :signed-integer) (sampleRate :unsigned-long) (sampleSize :signed-integer) (compressionType :ostype) (baseNote :signed-integer) (numBytes :unsigned-long) (headerLen (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 3400 16) 20) sndHandle numChannels sampleRate sampleSize compressionType baseNote numBytes headerLen))

; 
;  *  SetupAIFFHeader()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetupAIFFHeader" 
      ((fRefNum :signed-integer) (numChannels :signed-integer) (sampleRate :unsigned-long) (sampleSize :signed-integer) (compressionType :ostype) (numBytes :unsigned-long) (numFrames :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 2892 16) 20) fRefNum numChannels sampleRate sampleSize compressionType numBytes numFrames))

;  Sound Input Manager 1.1 and later calls, uses _SoundDispatch 
; 
;  *  ParseAIFFHeader()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ParseAIFFHeader" 
      ((fRefNum :signed-integer) (sndInfo (:pointer :soundcomponentdata)) (numFrames (:pointer :unsigned-long)) (dataOffset (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1880 16) 20) fRefNum sndInfo numFrames dataOffset))

; 
;  *  ParseSndHeader()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ParseSndHeader" 
      ((sndHandle (:handle :sndlistresource)) (sndInfo (:pointer :soundcomponentdata)) (numFrames (:pointer :unsigned-long)) (dataOffset (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 2140 16) 20) sndHandle sndInfo numFrames dataOffset))

#|                                              ; $IFC NOT TARGET_OS_MAC OR TARGET_API_MAC_CARBON 
;   Only to be used if you are writing a sound input component; this 
;   is the param block for a read request from the SoundMgr to the   
;   sound input component.  Not to be confused with the SPB struct   
;   above, which is the param block for a read request from an app   
;   to the SoundMgr.                                                 

(def-mactype :sndinputcmpparamptr (find-mactype '(:pointer :sndinputcmpparam)))
; $IFC TYPED_FUNCTION_POINTERS
#|
	SICCompletionProcPtr = PROCEDURE(SICParmPtr: SndInputCmpParamPtr);

|#                                              ; $ELSEC
(def-mactype :siccompletionprocptr (find-mactype ':pointer))
; $ENDC

(defrecord SndInputCmpParam 
#|
; Warning: type-size: unknown type siccompletionprocptr
|##|
; Warning: type-size: unknown type siccompletionprocptr
|#
   (ioCompletion :siccompletionprocptr)         ;   completion routine [pointer] 
   (ioInterrupt :pointer)                       ;   interrupt routine [pointer] 
   (ioResult :signed-integer)                   ;   I/O result code [word] 
   (pad :signed-integer)
   (ioReqCount :unsigned-long)
   (ioActCount :unsigned-long)
   (ioBuffer :pointer)
   (ioMisc :pointer)
   )

; 
; 	 *  SndInputReadAsync()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_SndInputReadAsync" 
      ((self (:pointer :componentinstancerecord)) (SICParmPtr :sndinputcmpparamptr))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 self SICParmPtr ((+ (ash 4 16) 1) :signed-longint)))

; 
;  *  SndInputReadSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SndInputReadSync" 
      ((self (:pointer :componentinstancerecord)) (SICParmPtr :sndinputcmpparamptr))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 self SICParmPtr ((+ (ash 4 16) 2) :signed-longint)))

; 
;  *  SndInputPauseRecording()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SndInputPauseRecording" 
      ((self (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 self ((+ (ash 0 16) 3) :signed-longint)))

; 
;  *  SndInputResumeRecording()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SndInputResumeRecording" 
      ((self (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 self ((+ (ash 0 16) 4) :signed-longint)))

; 
;  *  SndInputStopRecording()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SndInputStopRecording" 
      ((self (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 self ((+ (ash 0 16) 5) :signed-longint)))

; 
;  *  SndInputGetStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SndInputGetStatus" 
      ((self (:pointer :componentinstancerecord)) (recordingStatus (:pointer :signed-integer)) (totalSamplesToRecord (:pointer :unsigned-long)) (numberOfSamplesRecorded (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 self recordingStatus totalSamplesToRecord numberOfSamplesRecorded ((+ (ash 12 16) 6) :signed-longint)))

; 
;  *  SndInputGetDeviceInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SndInputGetDeviceInfo" 
      ((self (:pointer :componentinstancerecord)) (infoType :ostype) (infoData :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 self infoType infoData ((+ (ash 8 16) 7) :signed-longint)))

; 
;  *  SndInputSetDeviceInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SndInputSetDeviceInfo" 
      ((self (:pointer :componentinstancerecord)) (infoType :ostype) (infoData :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 self infoType infoData ((+ (ash 8 16) 8) :signed-longint)))

; 
;  *  SndInputInitHardware()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SndInputInitHardware" 
      ((self (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 self ((+ (ash 0 16) 9) :signed-longint)))

 |#                                             ; $ENDC

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := SoundIncludes

; $ENDC                                         ; __SOUND__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Sound)#|
; Warning: Did not recognize these types or records: (sndinputcmpparam siccompletionprocptr sndinputcmpparamptr)
|#