(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:SoundSprocket.p"
; at Wednesday May 1,2002 2:42:52 pm.
; 
;      File:       SoundSprocket.p
;  
;      Contains:   SoundSprocket interfaces
;  
;      Version:    Technology: 1.7
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1996-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __SOUNDSPROCKET__
; $SETC __SOUNDSPROCKET__ := 1

; $I+
; $SETC SoundSprocketIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __EVENTS__
|#

(require-interface 'Events)
#|                                              ; $I Events.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QD3D__
|#

(require-interface 'QD3D)
#|                                              ; $I QD3D.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QD3DCAMERA__
|#

(require-interface 'QD3DCamera)
#|                                              ; $I QD3DCamera.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; ******************************************************************************
;  *  SndSetInfo/SndGetInfo Messages
;  *****************************************************************************
;   The siSSpCPULoadLimit = '3dll' selector for SndGetInfo fills in a value of  
;   type UInt32.                                                                

(defconstant $kSSpSpeakerKind_Stereo 0)
(defconstant $kSSpSpeakerKind_Mono 1)
(defconstant $kSSpSpeakerKind_Headphones 2)

; 	  This is the data type is used with the SndGet/SetInfo selector              	
; 	  siSSpSpeakerSetup = '3dst'                                                  	

(def-mactype :sspspeakersetupdataptr (find-mactype '(:pointer :sspspeakersetupdata)))
(defrecord SSpSpeakerSetupData 
   (speakerKind :unsigned-long)                 ;   Speaker configuration           
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (speakerAngle :single-float)                 ;   Angle formed by user and speakers   
   (reserved0 :unsigned-long)                   ;   Reserved for future use -- set to 0     
   (reserved1 :unsigned-long)                   ;   Reserved for future use -- set to 0     
   )

(defconstant $kSSpMedium_Air 0)
(defconstant $kSSpMedium_Water 1)

(defconstant $kSSpSourceMode_Unfiltered 0)      ;   No filtering applied              
(defconstant $kSSpSourceMode_Localized 1)       ;   Localized by source position       
(defconstant $kSSpSourceMode_Ambient 2)         ;   Coming from all around           
(defconstant $kSSpSourceMode_Binaural 3)        ;   Already binaurally localized       

(def-mactype :ssplocationdataptr (find-mactype '(:pointer :ssplocationdata)))
(defrecord SSpLocationData 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (elevation :single-float)                    ;   Angle of the meridian -- pos is up  
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (azimuth :single-float)                      ;   Angle of the parallel -- pos is left    
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (distance :single-float)                     ;   Distance between source and listener    
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (projectionAngle :single-float)              ;   Cos(angle) between cone and listener    
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (sourceVelocity :single-float)               ;   Speed of source toward the listener     
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (listenerVelocity :single-float)             ;  Speed of listener toward the source  
   )

(def-mactype :sspvirtualsourcedataptr (find-mactype '(:pointer :sspvirtualsourcedata)))
(defrecord SSpVirtualSourceData 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (attenuation :single-float)                  ;   Attenuation factor            
   (location :ssplocationdata)                  ;   Location of virtual source         
   )

; 	  This is the data type is used with the SndGet/SetInfo selector              	
; 	  siSSpLocalization = '3dif'                                                  	
(def-mactype :ssplocalizationdataptr (find-mactype '(:pointer :ssplocalizationdata)))
(defrecord SSpLocalizationData 
   (cpuLoad :unsigned-long)                     ;   CPU load vs. quality -- 0 is best   
   (medium :unsigned-long)                      ;   Medium for sound propagation       
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (humidity :single-float)                     ;   Humidity when medium is air          
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (roomSize :single-float)                     ;   Reverb model -- distance bet. walls     
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (roomReflectivity :single-float)             ;  Reverb model -- bounce attenuation   
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (reverbAttenuation :single-float)            ;  Reverb model -- mix level       
   (sourceMode :unsigned-long)                  ;   Type of filtering to apply         
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (referenceDistance :single-float)            ;  Nominal distance for recording    
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (coneAngleCos :single-float)                 ;   Cos(angle/2) of attenuation cone      
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (coneAttenuation :single-float)              ;   Attenuation outside the cone       
   (currentLocation :ssplocationdata)           ;   Location of the sound            
   (reserved0 :unsigned-long)                   ;   Reserved for future use -- set to 0     
   (reserved1 :unsigned-long)                   ;   Reserved for future use -- set to 0     
   (reserved2 :unsigned-long)                   ;   Reserved for future use -- set to 0     
   (reserved3 :unsigned-long)                   ;   Reserved for future use -- set to 0     
   (virtualSourceCount :unsigned-long)          ;  Number of reflections           
   (virtualSource (:array :sspvirtualsourcedata 4));  The reflections                
   )

; $IFC TARGET_CPU_PPC 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SSpEventProcPtr = FUNCTION(VAR inEvent: EventRecord): BOOLEAN; C;

|#
 |#                                             ; $ELSEC
(def-mactype :sspeventprocptr (find-mactype ':pointer))
; $ENDC

; 	******************************************************************************
; 	 *  Global functions
; 	 *****************************************************************************	
; 
; 	 *  SSpConfigureSpeakerSetup()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
; 	 *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_SSpConfigureSpeakerSetup" 
      ((inEventProcPtr :pointer)) 
  :osstatus
   () )

; 
;  *  SSpGetCPULoadLimit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpGetCPULoadLimit" 
      ((outCPULoadLimit (:pointer :unsigned-long))) 
  :osstatus
   () )

; ******************************************************************************
;  *  Routines for Maniulating Listeners
;  *****************************************************************************

(def-mactype :ssplistenerreference (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :ssplistenerreferenceptr (find-mactype '(:pointer :pointer)));  when a VAR xx:SSpListenerReference parameter can be nil, it is changed to xx: SSpListenerReferencePtr 
; 
; 	 *  SSpListener_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
; 	 *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_SSpListener_New" 
      ((outListenerReference (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  SSpListener_Dispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_Dispose" 
      ((inListenerReference :pointer)) 
  :osstatus
   () )

; 
;  *  SSpListener_SetTransform()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SSpListener_SetTransform" 
      ((inListenerReference :pointer) (inTransform (:pointer :tq3matrix4x4))) 
  :osstatus
   () )

; 
;  *  SSpListener_GetTransform()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_GetTransform" 
      ((inListenerReference :pointer) (outTransform (:pointer :tq3matrix4x4))) 
  :osstatus
   () )

; 
;  *  SSpListener_SetPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SSpListener_SetPosition" 
      ((inListenerReference :pointer) (inPosition (:pointer :tq3point3d))) 
  :osstatus
   () )

; 
;  *  SSpListener_GetPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_GetPosition" 
      ((inListenerReference :pointer) (outPosition (:pointer :tq3point3d))) 
  :osstatus
   () )

; 
;  *  SSpListener_SetOrientation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SSpListener_SetOrientation" 
      ((inListenerReference :pointer) (inOrientation (:pointer :tq3vector3d))) 
  :osstatus
   () )

; 
;  *  SSpListener_GetOrientation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_GetOrientation" 
      ((inListenerReference :pointer) (outOrientation (:pointer :tq3vector3d))) 
  :osstatus
   () )

; 
;  *  SSpListener_SetUpVector()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SSpListener_SetUpVector" 
      ((inListenerReference :pointer) (inUpVector (:pointer :tq3vector3d))) 
  :osstatus
   () )

; 
;  *  SSpListener_GetUpVector()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_GetUpVector" 
      ((inListenerReference :pointer) (outUpVector (:pointer :tq3vector3d))) 
  :osstatus
   () )

; 
;  *  SSpListener_SetCameraPlacement()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SSpListener_SetCameraPlacement" 
      ((inListenerReference :pointer) (inCameraPlacement (:pointer :tq3cameraplacement))) 
  :osstatus
   () )

; 
;  *  SSpListener_GetCameraPlacement()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_GetCameraPlacement" 
      ((inListenerReference :pointer) (outCameraPlacement (:pointer :tq3cameraplacement))) 
  :osstatus
   () )

; 
;  *  SSpListener_SetVelocity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SSpListener_SetVelocity" 
      ((inListenerReference :pointer) (inVelocity (:pointer :tq3vector3d))) 
  :osstatus
   () )

; 
;  *  SSpListener_GetVelocity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_GetVelocity" 
      ((inListenerReference :pointer) (outVelocity (:pointer :tq3vector3d))) 
  :osstatus
   () )

; 
;  *  SSpListener_GetActualVelocity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_GetActualVelocity" 
      ((inListenerReference :pointer) (outVelocity (:pointer :tq3vector3d))) 
  :osstatus
   () )

; 
;  *  SSpListener_SetMedium()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_SetMedium" 
      ((inListenerReference :pointer) (inMedium :unsigned-long) (inHumidity :single-float)) 
  :osstatus
   () )

; 
;  *  SSpListener_GetMedium()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_GetMedium" 
      ((inListenerReference :pointer) (outMedium (:pointer :unsigned-long)) (outHumidity (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpListener_SetReverb()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_SetReverb" 
      ((inListenerReference :pointer) (inRoomSize :single-float) (inRoomReflectivity :single-float) (inReverbAttenuation :single-float)) 
  :osstatus
   () )

; 
;  *  SSpListener_GetReverb()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_GetReverb" 
      ((inListenerReference :pointer) (outRoomSize (:pointer :single-float)) (outRoomReflectivity (:pointer :single-float)) (outReverbAttenuation (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpListener_SetMetersPerUnit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_SetMetersPerUnit" 
      ((inListenerReference :pointer) (inMetersPerUnit :single-float)) 
  :osstatus
   () )

; 
;  *  SSpListener_GetMetersPerUnit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_GetMetersPerUnit" 
      ((inListenerReference :pointer) (outMetersPerUnit (:pointer :single-float))) 
  :osstatus
   () )

; ******************************************************************************
;  *  Routines for Manipulating Sources
;  *****************************************************************************

(def-mactype :sspsourcereference (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :sspsourcereferenceptr (find-mactype '(:pointer :pointer)));  when a VAR xx:SSpSourceReference parameter can be nil, it is changed to xx: SSpSourceReferencePtr 
; 
; 	 *  SSpSource_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
; 	 *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_SSpSource_New" 
      ((outSourceReference (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  SSpSource_Dispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_Dispose" 
      ((inSourceReference :pointer)) 
  :osstatus
   () )

; 
;  *  SSpSource_CalcLocalization()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_CalcLocalization" 
      ((inSourceReference :pointer) (inListenerReference :pointer) (out3DInfo (:pointer :ssplocalizationdata))) 
  :osstatus
   () )

; 
;  *  SSpSource_SetTransform()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SSpSource_SetTransform" 
      ((inSourceReference :pointer) (inTransform (:pointer :tq3matrix4x4))) 
  :osstatus
   () )

; 
;  *  SSpSource_GetTransform()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_GetTransform" 
      ((inSourceReference :pointer) (outTransform (:pointer :tq3matrix4x4))) 
  :osstatus
   () )

; 
;  *  SSpSource_SetPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SSpSource_SetPosition" 
      ((inSourceReference :pointer) (inPosition (:pointer :tq3point3d))) 
  :osstatus
   () )

; 
;  *  SSpSource_GetPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_GetPosition" 
      ((inSourceReference :pointer) (outPosition (:pointer :tq3point3d))) 
  :osstatus
   () )

; 
;  *  SSpSource_SetOrientation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SSpSource_SetOrientation" 
      ((inSourceReference :pointer) (inOrientation (:pointer :tq3vector3d))) 
  :osstatus
   () )

; 
;  *  SSpSource_GetOrientation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_GetOrientation" 
      ((inSourceReference :pointer) (outOrientation (:pointer :tq3vector3d))) 
  :osstatus
   () )

; 
;  *  SSpSource_SetUpVector()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SSpSource_SetUpVector" 
      ((inSourceReference :pointer) (inUpVector (:pointer :tq3vector3d))) 
  :osstatus
   () )

; 
;  *  SSpSource_GetUpVector()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_GetUpVector" 
      ((inSourceReference :pointer) (outUpVector (:pointer :tq3vector3d))) 
  :osstatus
   () )

; 
;  *  SSpSource_SetCameraPlacement()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SSpSource_SetCameraPlacement" 
      ((inSourceReference :pointer) (inCameraPlacement (:pointer :tq3cameraplacement))) 
  :osstatus
   () )

; 
;  *  SSpSource_GetCameraPlacement()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_GetCameraPlacement" 
      ((inSourceReference :pointer) (outCameraPlacement (:pointer :tq3cameraplacement))) 
  :osstatus
   () )

; 
;  *  SSpSource_SetVelocity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SSpSource_SetVelocity" 
      ((inSourceReference :pointer) (inVelocity (:pointer :tq3vector3d))) 
  :osstatus
   () )

; 
;  *  SSpSource_GetVelocity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_GetVelocity" 
      ((inSourceReference :pointer) (outVelocity (:pointer :tq3vector3d))) 
  :osstatus
   () )

; 
;  *  SSpSource_GetActualVelocity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_GetActualVelocity" 
      ((inSourceReference :pointer) (outVelocity (:pointer :tq3vector3d))) 
  :osstatus
   () )

; 
;  *  SSpSource_SetCPULoad()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_SetCPULoad" 
      ((inSourceReference :pointer) (inCPULoad :unsigned-long)) 
  :osstatus
   () )

; 
;  *  SSpSource_GetCPULoad()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_GetCPULoad" 
      ((inSourceReference :pointer) (outCPULoad (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  SSpSource_SetMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_SetMode" 
      ((inSourceReference :pointer) (inMode :unsigned-long)) 
  :osstatus
   () )

; 
;  *  SSpSource_GetMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_GetMode" 
      ((inSourceReference :pointer) (outMode (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  SSpSource_SetReferenceDistance()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_SetReferenceDistance" 
      ((inSourceReference :pointer) (inReferenceDistance :single-float)) 
  :osstatus
   () )

; 
;  *  SSpSource_GetReferenceDistance()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_GetReferenceDistance" 
      ((inSourceReference :pointer) (outReferenceDistance (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpSource_SetSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_SetSize" 
      ((inSourceReference :pointer) (inLength :single-float) (inWidth :single-float) (inHeight :single-float)) 
  :osstatus
   () )

; 
;  *  SSpSource_GetSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_GetSize" 
      ((inSourceReference :pointer) (outLength (:pointer :single-float)) (outWidth (:pointer :single-float)) (outHeight (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpSource_SetAngularAttenuation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_SetAngularAttenuation" 
      ((inSourceReference :pointer) (inConeAngle :single-float) (inConeAttenuation :single-float)) 
  :osstatus
   () )

; 
;  *  SSpSource_GetAngularAttenuation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_GetAngularAttenuation" 
      ((inSourceReference :pointer) (outConeAngle (:pointer :single-float)) (outConeAttenuation (:pointer :single-float))) 
  :osstatus
   () )

; ******************************************************************************
;  *  OpenGL Calling Convention Call Variants
;  *****************************************************************************
; 
;  *  SSpListener_SetTransformfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SSpListener_SetTransformfv" 
      ((inListenerReference :pointer) (inTransform (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpListener_GetTransformfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_GetTransformfv" 
      ((inListenerReference :pointer) (outTransform (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpListener_SetPosition3f()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_SetPosition3f" 
      ((inListenerReference :pointer) (inX :single-float) (inY :single-float) (inZ :single-float)) 
  :osstatus
   () )

; 
;  *  SSpListener_SetPositionfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SSpListener_SetPositionfv" 
      ((inListenerReference :pointer) (inPosition (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpListener_GetPositionfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_GetPositionfv" 
      ((inListenerReference :pointer) (outPosition (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpListener_SetOrientation3f()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_SetOrientation3f" 
      ((inListenerReference :pointer) (inX :single-float) (inY :single-float) (inZ :single-float)) 
  :osstatus
   () )

; 
;  *  SSpListener_SetOrientationfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SSpListener_SetOrientationfv" 
      ((inListenerReference :pointer) (inOrientation (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpListener_GetOrientationfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_GetOrientationfv" 
      ((inListenerReference :pointer) (outOrientation (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpListener_SetUpVector3f()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_SetUpVector3f" 
      ((inListenerReference :pointer) (inX :single-float) (inY :single-float) (inZ :single-float)) 
  :osstatus
   () )

; 
;  *  SSpListener_SetUpVectorfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SSpListener_SetUpVectorfv" 
      ((inListenerReference :pointer) (inUpVector (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpListener_GetUpVectorfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_GetUpVectorfv" 
      ((inListenerReference :pointer) (outUpVector (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpListener_SetCameraPlacementfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST; CONST
(deftrap-inline "_SSpListener_SetCameraPlacementfv" 
      ((inListenerReference :pointer) (inCameraLocation (:pointer :single-float)) (inPointOfInterest (:pointer :single-float)) (inUpVector (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpListener_GetCameraPlacementfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_GetCameraPlacementfv" 
      ((inListenerReference :pointer) (outCameraPlacement (:pointer :single-float)) (outPointOfInterest (:pointer :single-float)) (outUpVector (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpListener_SetVelocity3f()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_SetVelocity3f" 
      ((inListenerReference :pointer) (inX :single-float) (inY :single-float) (inZ :single-float)) 
  :osstatus
   () )

; 
;  *  SSpListener_SetVelocityfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SSpListener_SetVelocityfv" 
      ((inListenerReference :pointer) (inVelocity (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpListener_GetVelocityfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_GetVelocityfv" 
      ((inListenerReference :pointer) (outVelocity (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpListener_GetActualVelocityfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpListener_GetActualVelocityfv" 
      ((inListenerReference :pointer) (outVelocity (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpSource_SetTransformfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SSpSource_SetTransformfv" 
      ((inSourceReference :pointer) (inTransform (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpSource_GetTransformfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_GetTransformfv" 
      ((inSourceReference :pointer) (outTransform (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpSource_SetPosition3f()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_SetPosition3f" 
      ((inSourceReference :pointer) (inX :single-float) (inY :single-float) (inZ :single-float)) 
  :osstatus
   () )

; 
;  *  SSpSource_SetPositionfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SSpSource_SetPositionfv" 
      ((inSourceReference :pointer) (inPosition (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpSource_GetPositionfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_GetPositionfv" 
      ((inSourceReference :pointer) (outPosition (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpSource_SetOrientation3f()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_SetOrientation3f" 
      ((inSourceReference :pointer) (inX :single-float) (inY :single-float) (inZ :single-float)) 
  :osstatus
   () )

; 
;  *  SSpSource_SetOrientationfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SSpSource_SetOrientationfv" 
      ((inSourceReference :pointer) (inOrientation (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpSource_GetOrientationfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_GetOrientationfv" 
      ((inSourceReference :pointer) (outOrientation (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpSource_SetUpVector3f()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_SetUpVector3f" 
      ((inSourceReference :pointer) (inX :single-float) (inY :single-float) (inZ :single-float)) 
  :osstatus
   () )

; 
;  *  SSpSource_SetUpVectorfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SSpSource_SetUpVectorfv" 
      ((inSourceReference :pointer) (inUpVector (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpSource_GetUpVectorfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_GetUpVectorfv" 
      ((inSourceReference :pointer) (outUpVector (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpSource_SetCameraPlacementfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST; CONST
(deftrap-inline "_SSpSource_SetCameraPlacementfv" 
      ((inSourceReference :pointer) (inCameraLocation (:pointer :single-float)) (inPointOfInterest (:pointer :single-float)) (inUpVector (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpSource_GetCameraPlacementfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_GetCameraPlacementfv" 
      ((inSourceReference :pointer) (outCameraPlacement (:pointer :single-float)) (outPointOfInterest (:pointer :single-float)) (outUpVector (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpSource_SetVelocity3f()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_SetVelocity3f" 
      ((inSourceReference :pointer) (inX :single-float) (inY :single-float) (inZ :single-float)) 
  :osstatus
   () )

; 
;  *  SSpSource_SetVelocityfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SSpSource_SetVelocityfv" 
      ((inSourceReference :pointer) (inVelocity (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpSource_GetVelocityfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_GetVelocityfv" 
      ((inSourceReference :pointer) (outVelocity (:pointer :single-float))) 
  :osstatus
   () )

; 
;  *  SSpSource_GetActualVelocityfv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SoundSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but SoundSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SSpSource_GetActualVelocityfv" 
      ((inSourceReference :pointer) (outVelocity (:pointer :single-float))) 
  :osstatus
   () )

; $ENDC                                         ; TARGET_CPU_PPC

; ******************************************************************************
;  *  MORE LATE-BREAKING NEWS
;  *
;  *  The SndGetInfo selector siSSpFilterVersion and datatype SSpFilterVersionData
;  *  have been removed in favor of an alternate way of accessing filter version
;  *  information.  The following function may be used for this purpose.
;  *******************************************************************************
; // **************************** GetSSpFilterVersion ****************************
; // Finds the manufacturer and version number of the SoundSprocket filter that
; // may be installed.  inManufacturer should be the manufacturer code specified
; // at the installation time, which may be zero to allow any manufacturer.
; // If no error is encountered, outManufacturer is set to the actual manufacturer
; // code and outMajorVersion and outMinorVersion are set to the component
; // specification level and manufacturer's implementation revision, respectively.
; OSStatus GetSSpFilterVersion(
;     OSType                  inManufacturer,
;     OSType*                 outManufacturer,
;     UInt32*                 outMajorVersion,
;     UInt32*                 outMinorVersion)
; (
;     OSStatus                err;
;     ComponentDescription    description;
;     Component               componentRef;
;     UInt32                  vers;
;     
;     // Set up the component description
;     description.componentType           = kSoundEffectsType;
;     description.componentSubType        = kSSpLocalizationSubType;
;     description.componentManufacturer   = inManufacturer;
;     description.componentFlags          = 0;        
;     description.componentFlagsMask      = 0;    
;     
;     // Find a component matching the description
;     componentRef = FindNextComponent(nil, &description);
;     if (componentRef == nil)  return couldntGetRequiredComponent;
;     
;     // Get the component description (for the manufacturer code)
;     err = GetComponentInfo(componentRef, &description, nil, nil, nil);
;     if (err != noErr)  return err;
;     
;     // Get the version composite
;     vers = (UInt32) GetComponentVersion((ComponentInstance) componentRef);
;     
;     // Return the results
;     *outManufacturer = description.componentManufacturer;
;     *outMajorVersion = HiWord(vers);
;     *outMinorVersion = LoWord(vers);
;     
;     return noErr;
; )
; ******************************************************************************

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := SoundSprocketIncludes

; $ENDC                                         ; __SOUNDSPROCKET__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'SoundSprocket)