(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:SpeechRecognition.p"
; at Wednesday May 1,2002 2:41:10 pm.
; 
;      File:       SpeechRecognition.p
;  
;      Contains:   Apple Speech Recognition Toolbox Interfaces.
;  
;      Version:    Technology: PlainTalk 1.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1992-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __SPEECHRECOGNITION__
; $SETC __SPEECHRECOGNITION__ := 1

; $I+
; $SETC SpeechRecognitionIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  Error Codes [Speech recognition gets -5100 through -5199] 

(defconstant $kSRNotAvailable -5100)            ;   the service requested is not avail or applicable  
(defconstant $kSRInternalError -5101)           ;   a system internal or hardware error condition  
(defconstant $kSRComponentNotFound -5102)       ;   a needed system resource was not located  
(defconstant $kSROutOfMemory -5103)             ;   an out of memory error occurred in the toolbox memory space  
(defconstant $kSRNotASpeechObject -5104)        ;   the object specified is no longer or never was valid  
(defconstant $kSRBadParameter -5105)            ;   an invalid parameter was specified  
(defconstant $kSRParamOutOfRange -5106)         ;   when we say 0-100, don't pass in 101.  
(defconstant $kSRBadSelector -5107)             ;   an unrecognized selector was specified  
(defconstant $kSRBufferTooSmall -5108)          ;   returned from attribute access functions  
(defconstant $kSRNotARecSystem -5109)           ;   the object used was not a SRRecognitionSystem  
(defconstant $kSRFeedbackNotAvail -5110)        ;   there is no feedback window associated with SRRecognizer  
(defconstant $kSRCantSetProperty -5111)         ;   a non-settable property was specified  
(defconstant $kSRCantGetProperty -5112)         ;   a non-gettable property was specified  
(defconstant $kSRCantSetDuringRecognition -5113);   the property can't be set while recognition is in progress -- do before or between utterances.  
(defconstant $kSRAlreadyListening -5114)        ;   in response to SRStartListening  
(defconstant $kSRNotListeningState -5115)       ;   in response to SRStopListening  
(defconstant $kSRModelMismatch -5116)           ;   no acoustical models are avail to match request  
(defconstant $kSRNoClientLanguageModel -5117)   ;   trying to access a non-specified SRLanguageModel  
(defconstant $kSRNoPendingUtterances -5118)     ;   nothing to continue search on  
(defconstant $kSRRecognitionCanceled -5119)     ;   an abort error occurred during search  
(defconstant $kSRRecognitionDone -5120)         ;   search has finished, but nothing was recognized  
(defconstant $kSROtherRecAlreadyModal -5121)    ;   another recognizer is modal at the moment, so can't set this recognizer's kSRBlockModally property right now  
(defconstant $kSRHasNoSubItems -5122)           ;   SRCountItems or related routine was called on an object without subelements -- e.g. a word -- rather than phrase, path, or LM.  
(defconstant $kSRSubItemNotFound -5123)         ;   returned when accessing a non-existent sub item of a container  
(defconstant $kSRLanguageModelTooBig -5124)     ;   Cant build language models so big  
(defconstant $kSRAlreadyReleased -5125)         ;   this object has already been released before  
(defconstant $kSRAlreadyFinished -5126)         ;   the language model can't be finished twice  
(defconstant $kSRWordNotFound -5127)            ;   the spelling couldn't be found in lookup(s)  
(defconstant $kSRNotFinishedWithRejection -5128);   property not found because the LMObj is not finished with rejection  
(defconstant $kSRExpansionTooDeep -5129)        ;   Language model is left recursive or is embedded too many levels  
(defconstant $kSRTooManyElements -5130)         ;   Too many elements added to phrase or path or other langauge model object  
(defconstant $kSRCantAdd -5131)                 ;   Can't add given type of object to the base SRLanguageObject (e.g.in SRAddLanguageObject)    
(defconstant $kSRSndInSourceDisconnected -5132) ;   Sound input source is disconnected  
(defconstant $kSRCantReadLanguageObject -5133)  ;   An error while trying to create new Language object from file or pointer -- possibly bad format  
;   non-release debugging error codes are included here  
(defconstant $kSRNotImplementedYet -5199)       ;   you'd better wait for this feature in a future release  

; 	 Type Definitions 	

(def-mactype :srspeechobject (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :srspeechobjectptr (find-mactype '(:pointer :pointer)));  when a VAR xx:SRSpeechObject parameter can be nil, it is changed to xx: SRSpeechObjectPtr 
(def-mactype :srrecognitionsystem (find-mactype ':pointer))
(def-mactype :srrecognizer (find-mactype ':pointer))
(def-mactype :srspeechsource (find-mactype ':pointer))
(def-mactype :srrecognitionresult (find-mactype ':pointer))
(def-mactype :srlanguageobject (find-mactype ':pointer))
(def-mactype :srlanguagemodel (find-mactype ':pointer))
(def-mactype :srpath (find-mactype ':pointer))
(def-mactype :srphrase (find-mactype ':pointer))
(def-mactype :srword (find-mactype ':pointer))
; 	 between 0 and 100 	
(def-mactype :srspeedsetting (find-mactype ':unsigned-integer))
; 	 between 0 and 100 	
(def-mactype :srrejectionlevel (find-mactype ':unsigned-integer))
; 	 When an event occurs, the user supplied proc will be called with a pointer   	
; 	  to the param passed in and a flag to indicate conditions such               	
; 	  as interrupt time or system background time.                                	
(def-mactype :srcallbackstructptr (find-mactype '(:pointer :srcallbackstruct)))
(defrecord SRCallBackStruct 
   (what :signed-long)                          ;   one of notification flags  
   (message :signed-long)                       ;   contains SRRecognitionResult id  
   (instance :pointer)                          ;   ID of recognizer being notified  
   (status :signed-integer)                     ;   result status of last search  
   (flags :signed-integer)                      ;   non-zero if occurs during interrupt  
   (refCon :signed-long)                        ;   user defined - set from SRCallBackParam  
   )

; 	 Call back procedure definition 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SRCallBackProcPtr = PROCEDURE(VAR param: SRCallBackStruct);

|#
 |#                                             ; $ELSEC
(def-mactype :srcallbackprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :srcallbackupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :srcallbackupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppSRCallBackProcInfo #xC0)
; 
; 	 *  NewSRCallBackUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0.2 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewSRCallBackProc 
(deftrap "_NewSRCallBackUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeSRCallBackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeSRCallBackUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeSRCallBackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallSRCallBackProc 
(deftrap-inline "_InvokeSRCallBackUPP" 
      ((param (:pointer :srcallbackstruct)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

(def-mactype :srcallbackparamptr (find-mactype '(:pointer :srcallbackparam)))
(defrecord SRCallBackParam 
   (callBack :pointer)
   (refCon :signed-long)
   )

; 	 Recognition System Types 	

(defconstant $kSRDefaultRecognitionSystemID 0)

; 	 Recognition System Properties 	
(defconstant $kSRFeedbackAndListeningModes :|fbwn|);   short: one of kSRNoFeedbackHasListenModes, kSRHasFeedbackHasListenModes, kSRNoFeedbackNoListenModes  
(defconstant $kSRRejectedWord :|rejq|)          ;   the SRWord used to represent a rejection  
(defconstant $kSRCleanupOnClientExit :|clup|)   ;   Boolean: Default is true. The rec system and everything it owns is disposed when the client application quits  

(defconstant $kSRNoFeedbackNoListenModes 0)     ;   next allocated recognizer has no feedback window and doesn't use listening modes    
(defconstant $kSRHasFeedbackHasListenModes 1)   ;   next allocated recognizer has feedback window and uses listening modes           
(defconstant $kSRNoFeedbackHasListenModes 2)    ;   next allocated recognizer has no feedback window but does use listening modes   

; 	 Speech Source Types 	
(defconstant $kSRDefaultSpeechSource 0)
(defconstant $kSRLiveDesktopSpeechSource :|dklv|);   live desktop sound input  
(defconstant $kSRCanned22kHzSpeechSource :|ca22|);   AIFF file based 16 bit, 22.050 KHz sound input  

; 	 Notification via Apple Event or Callback 	
; 	 Notification Flags 	
(defconstant $kSRNotifyRecognitionBeginning #x1);   recognition can begin. client must now call SRContinueRecognition or SRCancelRecognition  
(defconstant $kSRNotifyRecognitionDone #x2)     ;   recognition has terminated. result (if any) is available.  

; 	 Apple Event selectors 	
; 	 AppleEvent message class  	
(defconstant $kAESpeechSuite :|sprc|)

; 	 AppleEvent message event ids 	
(defconstant $kAESpeechDone :|srsd|)
(defconstant $kAESpeechDetected :|srbd|)

; 	 AppleEvent Parameter ids 	
(defconstant $keySRRecognizer :|krec|)
(defconstant $keySRSpeechResult :|kspr|)
(defconstant $keySRSpeechStatus :|ksst|)

; 	 AppleEvent Parameter types 	
(defconstant $typeSRRecognizer :|trec|)
(defconstant $typeSRSpeechResult :|tspr|)

; 	 SRRecognizer Properties 	
(defconstant $kSRNotificationParam :|noti|)     ;   see notification flags below  
(defconstant $kSRCallBackParam :|call|)         ;   type SRCallBackParam  
(defconstant $kSRSearchStatusParam :|stat|)     ;   see status flags below  
(defconstant $kSRAutoFinishingParam :|afin|)    ;   automatic finishing applied on LM for search  
(defconstant $kSRForegroundOnly :|fgon|)        ;   Boolean. Default is true. If true, client recognizer only active when in foreground.    
(defconstant $kSRBlockBackground :|blbg|)       ;   Boolean. Default is false. If true, when client recognizer in foreground, rest of LMs are inactive.     
(defconstant $kSRBlockModally :|blmd|)          ;   Boolean. Default is false. When true, this client's LM is only active LM; all other LMs are inactive. Be nice, don't be modal for long periods!  
(defconstant $kSRWantsResultTextDrawn :|txfb|)  ;   Boolean. Default is true. If true, search results are posted to Feedback window  
(defconstant $kSRWantsAutoFBGestures :|dfbr|)   ;   Boolean. Default is true. If true, client needn't call SRProcessBegin/End to get default feedback behavior  
(defconstant $kSRSoundInVolume :|volu|)         ;   short in [0..100] log scaled sound input power. Can't set this property  
(defconstant $kSRReadAudioFSSpec :|aurd|)       ;   *FSSpec. Specify FSSpec where raw audio is to be read (AIFF format) using kSRCanned22kHzSpeechSource. Reads until EOF  
(defconstant $kSRCancelOnSoundOut :|caso|)      ;   Boolean: Default is true.  If any sound is played out during utterance, recognition is aborted.  
(defconstant $kSRSpeedVsAccuracyParam :|sped|)  ;   SRSpeedSetting between 0 and 100  

; 	 0 means more accurate but slower. 	
; 	 100 means (much) less accurate but faster. 	
(defconstant $kSRUseToggleListen 0)             ;   listen key modes  
(defconstant $kSRUsePushToTalk 1)

(defconstant $kSRListenKeyMode :|lkmd|)         ;   short: either kSRUseToggleListen or kSRUsePushToTalk  
(defconstant $kSRListenKeyCombo :|lkey|)        ;   short: Push-To-Talk key combination; high byte is high byte of event->modifiers, the low byte is the keycode from event->message  
(defconstant $kSRListenKeyName :|lnam|)         ;   Str63: string representing ListenKeyCombo  
(defconstant $kSRKeyWord :|kwrd|)               ;   Str255: keyword preceding spoken commands in kSRUseToggleListen mode  
(defconstant $kSRKeyExpected :|kexp|)           ;   Boolean: Must the PTT key be depressed or the key word spoken before recognition can occur?  

; 	 Operational Status Flags 	
(defconstant $kSRIdleRecognizer #x1)            ;   engine is not active  
(defconstant $kSRSearchInProgress #x2)          ;   search is in progress  
(defconstant $kSRSearchWaitForAllClients #x4)   ;   search is suspended waiting on all clients' input  
(defconstant $kSRMustCancelSearch #x8)          ;   something has occurred (sound played, non-speech detected) requiring the search to abort  
(defconstant $kSRPendingSearch #x10)            ;   we're about to start searching  

; 	 Recognition Result Properties 	
(defconstant $kSRTEXTFormat :|TEXT|)            ;   raw text in user supplied memory  
(defconstant $kSRPhraseFormat :|lmph|)          ;   SRPhrase containing result words  
(defconstant $kSRPathFormat :|lmpt|)            ;   SRPath containing result phrases or words  
(defconstant $kSRLanguageModelFormat :|lmfm|)   ;   top level SRLanguageModel for post parse  

; 	 SRLanguageObject Family Properties 	
(defconstant $kSRSpelling :|spel|)              ;   spelling of a SRWord or SRPhrase or SRPath, or name of a SRLanguageModel  
(defconstant $kSRLMObjType :|lmtp|)             ;   Returns one of SRLanguageObject Types listed below  
(defconstant $kSRRefCon :|refc|)                ;   4 bytes of user storage  
(defconstant $kSROptional :|optl|)              ;   Boolean -- true if SRLanguageObject is optional     
(defconstant $kSREnabled :|enbl|)               ;   Boolean -- true if SRLanguageObject enabled  
(defconstant $kSRRepeatable :|rptb|)            ;   Boolean -- true if SRLanguageObject is repeatable  
(defconstant $kSRRejectable :|rjbl|)            ;   Boolean -- true if SRLanguageObject is rejectable (Recognition System's kSRRejectedWord  
;         object can be returned in place of SRLanguageObject with this property)    
(defconstant $kSRRejectionLevel :|rjct|)        ;   SRRejectionLevel between 0 and 100  

; 	 LM Object Types -- returned as kSRLMObjType property of language model objects 	
(defconstant $kSRLanguageModelType :|lmob|)     ;   SRLanguageModel  
(defconstant $kSRPathType :|path|)              ;   SRPath  
(defconstant $kSRPhraseType :|phra|)            ;   SRPhrase  
(defconstant $kSRWordType :|word|)              ;   SRWord  

; 	 a normal and reasonable rejection level 	
(defconstant $kSRDefaultRejectionLevel 50)

; 	******************************************************************************	
; 	                      NOTES ON USING THE API                                  	
; 	                                                                              	
; 	      All operations (with the exception of SRGetRecognitionSystem) are       	
; 	      directed toward an object allocated or begot from New, Get and Read     	
; 	      type calls.                                                             	
; 	                                                                              	
; 	      There is a simple rule in dealing with allocation and disposal:         	
; 	                                                                              	
; 	      *   all toolbox allocations are obtained from a SRRecognitionSystem     	
; 	                                                                              	
; 	      *   if you obtain an object via New or Get, then you own a reference    	
; 	          to that object and it must be released via SRReleaseObject when     	
; 	          you no longer need it                                               	
; 	                                                                              	
; 	      *   when you receive a SRRecognitionResult object via AppleEvent or     	
; 	          callback, it has essentially been created on your behalf and so     	
; 	          you are responsible for releasing it as above                       	
; 	                                                                              	
; 	      *   when you close a SRRecognitionSystem, all remaining objects which       	
; 	          were allocated with it will be forcefully released and any          	
; 	          remaining references to those objects will be invalid.              	
; 	                                                                              	
; 	      This translates into a very simple guideline:                           	
; 	          If you allocate it or have it allocated for you, you must release   	
; 	          it.  If you are only peeking at it, then don't release it.          	
; 	                                                                              	
; 	******************************************************************************	
; 	 Opening and Closing of the SRRecognitionSystem 	
; 
; 	 *  SROpenRecognitionSystem()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_SROpenRecognitionSystem" 
      ((system (:pointer :pointer)) (systemID :ostype))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 1024 system systemID))

; 
;  *  SRCloseRecognitionSystem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRCloseRecognitionSystem" 
      ((system :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 513 system))

;  Accessing Properties of any Speech Object 
; 
;  *  SRSetProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRSetProperty" 
      ((srObject :pointer) (selector :ostype) (property :pointer) (propertyLen :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 2050 srObject selector property propertyLen))

; 
;  *  SRGetProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRGetProperty" 
      ((srObject :pointer) (selector :ostype) (property :pointer) (propertyLen (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 2051 srObject selector property propertyLen))

;  Any object obtained via New or Get type calls must be released 
; 
;  *  SRReleaseObject()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRReleaseObject" 
      ((srObject :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 516 srObject))

; 
;  *  SRGetReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRGetReference" 
      ((srObject :pointer) (newObjectRef (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 1061 srObject newObjectRef))

;  SRRecognizer Instance Functions 
; 
;  *  SRNewRecognizer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRNewRecognizer" 
      ((system :pointer) (recognizer (:pointer :pointer)) (sourceID :ostype))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 1546 system recognizer sourceID))

; 
;  *  SRStartListening()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRStartListening" 
      ((recognizer :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 524 recognizer))

; 
;  *  SRStopListening()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRStopListening" 
      ((recognizer :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 525 recognizer))

; 
;  *  SRSetLanguageModel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRSetLanguageModel" 
      ((recognizer :pointer) (languageModel :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 1038 recognizer languageModel))

; 
;  *  SRGetLanguageModel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRGetLanguageModel" 
      ((recognizer :pointer) (languageModel (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 1039 recognizer languageModel))

; 
;  *  SRContinueRecognition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRContinueRecognition" 
      ((recognizer :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 528 recognizer))

; 
;  *  SRCancelRecognition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRCancelRecognition" 
      ((recognizer :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 529 recognizer))

; 
;  *  SRIdle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRIdle" 
      ()
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 40))

;  Language Model Building and Manipulation Functions 
; 
;  *  SRNewLanguageModel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRNewLanguageModel" 
      ((system :pointer) (model (:pointer :pointer)) (name :pointer) (nameLength :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 2066 system model name nameLength))

; 
;  *  SRNewPath()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRNewPath" 
      ((system :pointer) (path (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 1043 system path))

; 
;  *  SRNewPhrase()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRNewPhrase" 
      ((system :pointer) (phrase (:pointer :pointer)) (text :pointer) (textLength :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 2068 system phrase text textLength))

; 
;  *  SRNewWord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRNewWord" 
      ((system :pointer) (word (:pointer :pointer)) (text :pointer) (textLength :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 2069 system word text textLength))

;  Operations on any object of the SRLanguageObject family 
; 
;  *  SRPutLanguageObjectIntoHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRPutLanguageObjectIntoHandle" 
      ((languageObject :pointer) (lobjHandle :handle))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 1046 languageObject lobjHandle))

; 
;  *  SRPutLanguageObjectIntoDataFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRPutLanguageObjectIntoDataFile" 
      ((languageObject :pointer) (fRefNum :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 808 languageObject fRefNum))

; 
;  *  SRNewLanguageObjectFromHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRNewLanguageObjectFromHandle" 
      ((system :pointer) (languageObject (:pointer :pointer)) (lObjHandle :handle))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 1047 system languageObject lObjHandle))

; 
;  *  SRNewLanguageObjectFromDataFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRNewLanguageObjectFromDataFile" 
      ((system :pointer) (languageObject (:pointer :pointer)) (fRefNum :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 1063 system languageObject fRefNum))

; 
;  *  SREmptyLanguageObject()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SREmptyLanguageObject" 
      ((languageObject :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 536 languageObject))

; 
;  *  SRChangeLanguageObject()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRChangeLanguageObject" 
      ((languageObject :pointer) (text :pointer) (textLength :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 1561 languageObject text textLength))

; 
;  *  SRAddLanguageObject()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRAddLanguageObject" 
      ((base :pointer) (addon :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 1050 base addon))

; 
;  *  SRAddText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRAddText" 
      ((base :pointer) (text :pointer) (textLength :signed-long) (refCon :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 2075 base text textLength refCon))

; 
;  *  SRRemoveLanguageObject()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRRemoveLanguageObject" 
      ((base :pointer) (toRemove :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 1052 base toRemove))

;  Traversing SRRecognitionResults or SRLanguageObjects 
; 
;  *  SRCountItems()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRCountItems" 
      ((container :pointer) (count (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 1029 container count))

; 
;  *  SRGetIndexedItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRGetIndexedItem" 
      ((container :pointer) (item (:pointer :pointer)) (index :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 1542 container item index))

; 
;  *  SRSetIndexedItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRSetIndexedItem" 
      ((container :pointer) (item :pointer) (index :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 1543 container item index))

; 
;  *  SRRemoveIndexedItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRRemoveIndexedItem" 
      ((container :pointer) (index :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 1032 container index))

;  Utilizing the System Feedback Window 
; 
;  *  SRDrawText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRDrawText" 
      ((recognizer :pointer) (dispText :pointer) (dispLength :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 1569 recognizer dispText dispLength))

; 
;  *  SRDrawRecognizedText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRDrawRecognizedText" 
      ((recognizer :pointer) (dispText :pointer) (dispLength :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 1570 recognizer dispText dispLength))

; 
;  *  SRSpeakText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRSpeakText" 
      ((recognizer :pointer) (speakText :pointer) (speakLength :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 1568 recognizer speakText speakLength))

; 
;  *  SRSpeakAndDrawText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRSpeakAndDrawText" 
      ((recognizer :pointer) (text :pointer) (textLength :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 1567 recognizer text textLength))

; 
;  *  SRStopSpeech()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRStopSpeech" 
      ((recognizer :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 547 recognizer))

; 
;  *  SRSpeechBusy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRSpeechBusy" 
      ((recognizer :pointer))
   (:stack :boolean)
   (:stack-trap #xAA56 :d0 548 recognizer))

; 
;  *  SRProcessBegin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRProcessBegin" 
      ((recognizer :pointer) (failed :boolean))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 797 recognizer failed))

; 
;  *  SRProcessEnd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechRecognitionLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SRProcessEnd" 
      ((recognizer :pointer) (failed :boolean))
   (:stack :signed-integer)
   (:stack-trap #xAA56 :d0 798 recognizer failed))

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := SpeechRecognitionIncludes

; $ENDC                                         ; __SPEECHRECOGNITION__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'SpeechRecognition)