(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:StandardFile.p"
; at Wednesday May 1,2002 2:41:26 pm.
; 
;      File:       StandardFile.p
;  
;      Contains:   Standard File package Interfaces.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1990-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __STANDARDFILE__
; $SETC __STANDARDFILE__ := 1

; $I+
; $SETC StandardFileIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __DIALOGS__
|#

(require-interface 'Dialogs)
#|                                              ; $I Dialogs.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;   resource IDs of pre-7.0 get and put dialogs  
(defconstant $putDlgID -3999)
(defconstant $getDlgID -4000)

;   item offsets of pre-7.0 get and put dialogs  
(defconstant $putSave 1)
(defconstant $putCancel 2)
(defconstant $putEject 5)
(defconstant $putDrive 6)
(defconstant $putName 7)
(defconstant $getOpen 1)
(defconstant $getCancel 3)
(defconstant $getEject 5)
(defconstant $getDrive 6)
(defconstant $getNmList 7)
(defconstant $getScroll 8)

;   resource IDs of 7.0 get and put dialogs  
(defconstant $sfPutDialogID -6043)
(defconstant $sfGetDialogID -6042)

;   item offsets of 7.0 get and put dialogs  
(defconstant $sfItemOpenButton 1)
(defconstant $sfItemCancelButton 2)
(defconstant $sfItemBalloonHelp 3)
(defconstant $sfItemVolumeUser 4)
(defconstant $sfItemEjectButton 5)
(defconstant $sfItemDesktopButton 6)
(defconstant $sfItemFileListUser 7)
(defconstant $sfItemPopUpMenuUser 8)
(defconstant $sfItemDividerLinePict 9)
(defconstant $sfItemFileNameTextEdit 10)
(defconstant $sfItemPromptStaticText 11)
(defconstant $sfItemNewFolderUser 12)

;   pseudo-item hits for use in DlgHook  
(defconstant $sfHookFirstCall -1)
(defconstant $sfHookCharOffset #x1000)
(defconstant $sfHookNullEvent 100)
(defconstant $sfHookRebuildList 101)
(defconstant $sfHookFolderPopUp 102)
(defconstant $sfHookOpenFolder 103)             ;   the following are only in system 7.0+  
(defconstant $sfHookLastCall -2)
(defconstant $sfHookOpenAlias 104)
(defconstant $sfHookGoToDesktop 105)
(defconstant $sfHookGoToAliasTarget 106)
(defconstant $sfHookGoToParent 107)
(defconstant $sfHookGoToNextDrive 108)
(defconstant $sfHookGoToPrevDrive 109)
(defconstant $sfHookChangeSelection 110)
(defconstant $sfHookSetActiveOffset 200)

; 	 the refcon field of the dialog record during a
; 	 modalfilter or dialoghook contains one of the following 	
(defconstant $sfMainDialogRefCon :|stdf|)
(defconstant $sfNewFolderDialogRefCon :|nfdr|)
(defconstant $sfReplaceDialogRefCon :|rplc|)
(defconstant $sfStatWarnDialogRefCon :|stat|)
(defconstant $sfLockWarnDialogRefCon :|lock|)
(defconstant $sfErrorDialogRefCon :|err |)

(def-mactype :sfreplyptr (find-mactype '(:pointer :sfreply)))
(defrecord SFReply 
   (good :boolean)
   (copy :boolean)
   (fType :ostype)
   (vRefNum :signed-integer)
   (version :signed-integer)
   (fName (:string 63))                         ;   a Str63 on MacOS  
   )

(def-mactype :standardfilereplyptr (find-mactype '(:pointer :standardfilereply)))
(defrecord StandardFileReply 
   (sfGood :boolean)
   (sfReplacing :boolean)
   (sfType :ostype)
   (sfFile :fsspec)
   (sfScript :signed-integer)
   (sfFlags :signed-integer)
   (sfIsFolder :boolean)
   (sfIsVolume :boolean)
   (sfReserved1 :signed-long)
   (sfReserved2 :signed-integer)
   )

; 	 for CustomXXXFile, ActivationOrderListPtr parameter is a pointer to an array of item numbers 	
(def-mactype :activationorderlistptr (find-mactype '(:pointer :signed-integer)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DlgHookProcPtr = FUNCTION(item: INTEGER; theDialog: DialogRef): INTEGER;

|#
 |#                                             ; $ELSEC
(def-mactype :dlghookprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	FileFilterProcPtr = FUNCTION(pb: CInfoPBPtr): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :filefilterprocptr (find-mactype ':pointer))
; $ENDC

; 	 the following also include an extra parameter of "your data pointer" 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DlgHookYDProcPtr = FUNCTION(item: INTEGER; theDialog: DialogRef; yourDataPtr: UNIV Ptr): INTEGER;

|#
 |#                                             ; $ELSEC
(def-mactype :dlghookydprocptr (find-mactype ':pointer))
; $ENDC

; 	 ModalFilterYDProcPtr moved to Dialogs.h 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	FileFilterYDProcPtr = FUNCTION(pb: CInfoPBPtr; yourDataPtr: UNIV Ptr): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :filefilterydprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ActivateYDProcPtr = PROCEDURE(theDialog: DialogRef; itemNo: INTEGER; activating: BOOLEAN; yourDataPtr: UNIV Ptr);

|#
 |#                                             ; $ELSEC
(def-mactype :activateydprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :dlghookupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :dlghookupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :filefilterupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :filefilterupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :dlghookydupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :dlghookydupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :filefilterydupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :filefilterydupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :activateydupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :activateydupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppDlgHookProcInfo #x3A0)
(defconstant $uppFileFilterProcInfo #xD0)
(defconstant $uppDlgHookYDProcInfo #xFA0)
(defconstant $uppFileFilterYDProcInfo #x3D0)
(defconstant $uppActivateYDProcInfo #x36C0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewDlgHookUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewDlgHookProc 
(deftrap "_NewDlgHookUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewFileFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewFileFilterProc 
(deftrap "_NewFileFilterUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewDlgHookYDUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewDlgHookYDProc 
(deftrap "_NewDlgHookYDUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewFileFilterYDUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewFileFilterYDProc 
(deftrap "_NewFileFilterYDUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewActivateYDUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewActivateYDProc 
(deftrap "_NewActivateYDUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeDlgHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeDlgHookUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeFileFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeFileFilterUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeDlgHookYDUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeDlgHookYDUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeFileFilterYDUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeFileFilterYDUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeActivateYDUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeActivateYDUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeDlgHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallDlgHookProc 
(deftrap-inline "_InvokeDlgHookUPP" 
      ((item :signed-integer) (theDialog (:pointer :grafport)) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeFileFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallFileFilterProc 
(deftrap-inline "_InvokeFileFilterUPP" 
      ((pb (:pointer :cinfopbrec)) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; 
;  *  InvokeDlgHookYDUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallDlgHookYDProc 
(deftrap-inline "_InvokeDlgHookYDUPP" 
      ((item :signed-integer) (theDialog (:pointer :grafport)) (yourDataPtr :pointer) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeFileFilterYDUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallFileFilterYDProc 
(deftrap-inline "_InvokeFileFilterYDUPP" 
      ((pb (:pointer :cinfopbrec)) (yourDataPtr :pointer) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; 
;  *  InvokeActivateYDUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallActivateYDProc 
(deftrap-inline "_InvokeActivateYDUPP" 
      ((theDialog (:pointer :grafport)) (itemNo :signed-integer) (activating :boolean) (yourDataPtr :pointer) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

(defrecord SFTypeList (array (:array :ostype 4)))
; 	
; 	    The GetFile "typeList" parameter type has changed from "SFTypeList" to "ConstSFTypeListPtr".
; 	    For C, this will add "const" and make it an in-only parameter.
; 	    For Pascal, this will require client code to use the @ operator, but make it easier to specify long lists.
; 	
; 	    ConstSFTypeListPtr is a pointer to an array of OSTypes.
; 		
(def-mactype :constsftypelistptr (find-mactype '(:pointer :ostype)))
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  SFPutFile()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_SFPutFile" 
      ((where :point) (prompt (:pointer (:string 255))) (origName (:string 255)) (dlgHook :pointer) (reply (:pointer :sfreply)))
   nil
   (:stack-trap #xA9EA where prompt origName dlgHook reply (1 :signed-integer)))

; 
;  *  SFGetFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SFGetFile" 
      ((where :point) (prompt (:string 255)) (fileFilter :pointer) (numTypes :signed-integer) (typeList (:pointer :ostype)) (dlgHook :pointer) (reply (:pointer :sfreply)))
   nil
   (:stack-trap #xA9EA where prompt fileFilter numTypes typeList dlgHook reply (2 :signed-integer)))

; 
;  *  SFPPutFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SFPPutFile" 
      ((where :point) (prompt (:pointer (:string 255))) (origName (:string 255)) (dlgHook :pointer) (reply (:pointer :sfreply)) (dlgID :signed-integer) (filterProc :pointer))
   nil
   (:stack-trap #xA9EA where prompt origName dlgHook reply dlgID filterProc (3 :signed-integer)))

; 
;  *  SFPGetFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SFPGetFile" 
      ((where :point) (prompt (:string 255)) (fileFilter :pointer) (numTypes :signed-integer) (typeList (:pointer :ostype)) (dlgHook :pointer) (reply (:pointer :sfreply)) (dlgID :signed-integer) (filterProc :pointer))
   nil
   (:stack-trap #xA9EA where prompt fileFilter numTypes typeList dlgHook reply dlgID filterProc (4 :signed-integer)))

; 
;  *  StandardPutFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_StandardPutFile" 
      ((prompt (:pointer (:string 255))) (defaultName (:string 255)) (reply (:pointer :standardfilereply)))
   nil
   (:stack-trap #xA9EA prompt defaultName reply (5 :signed-integer)))

; 
;  *  StandardGetFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_StandardGetFile" 
      ((fileFilter :pointer) (numTypes :signed-integer) (typeList (:pointer :ostype)) (reply (:pointer :standardfilereply)))
   nil
   (:stack-trap #xA9EA fileFilter numTypes typeList reply (6 :signed-integer)))

; 
;  *  CustomPutFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CustomPutFile" 
      ((prompt (:pointer (:string 255))) (defaultName (:string 255)) (reply (:pointer :standardfilereply)) (dlgID :signed-integer) (where :point) (dlgHook :pointer) (filterProc :pointer) (activeList (:pointer :signed-integer)) (activate :pointer) (yourDataPtr :pointer))
   nil
   (:stack-trap #xA9EA prompt defaultName reply dlgID where dlgHook filterProc activeList activate yourDataPtr (7 :signed-integer)))

; 
;  *  CustomGetFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CustomGetFile" 
      ((fileFilter :pointer) (numTypes :signed-integer) (typeList (:pointer :ostype)) (reply (:pointer :standardfilereply)) (dlgID :signed-integer) (where :point) (dlgHook :pointer) (filterProc :pointer) (activeList (:pointer :signed-integer)) (activate :pointer) (yourDataPtr :pointer))
   nil
   (:stack-trap #xA9EA fileFilter numTypes typeList reply dlgID where dlgHook filterProc activeList activate yourDataPtr (8 :signed-integer)))

; 
;  *  StandardOpenDialog()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in Translation 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_StandardOpenDialog" 
      ((reply (:pointer :standardfilereply))) 
  :signed-integer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := StandardFileIncludes

; $ENDC                                         ; __STANDARDFILE__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'StandardFile)