(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:TerminalTools.p"
; at Wednesday May 1,2002 2:42:57 pm.
; 
;      File:       TerminalTools.p
;  
;      Contains:   Communications Toolbox Terminal tools Interfaces.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1988-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __TERMINALTOOLS__
; $SETC __TERMINALTOOLS__ := 1

; $I+
; $SETC TerminalToolsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __DIALOGS__
|#

(require-interface 'Dialogs)
#|                                              ; $I Dialogs.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __TERMINALS__
|#

(require-interface 'Terminals)
#|                                              ; $I Terminals.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; $IFC CALL_NOT_IN_CARBON 

(defconstant $tdefType :|tdef|)
(defconstant $tvalType :|tval|)
(defconstant $tsetType :|tset|)
(defconstant $tlocType :|tloc|)
(defconstant $tscrType :|tscr|)
(defconstant $tbndType :|tbnd|)
(defconstant $tverType :|vers|)

;   messages  
(defconstant $tmInitMsg 0)
(defconstant $tmDisposeMsg 1)
(defconstant $tmSuspendMsg 2)
(defconstant $tmResumeMsg 3)
(defconstant $tmMenuMsg 4)
(defconstant $tmEventMsg 5)
(defconstant $tmActivateMsg 6)
(defconstant $tmDeactivateMsg 7)
(defconstant $tmGetErrorStringMsg 8)
(defconstant $tmIdleMsg 50)
(defconstant $tmResetMsg 51)
(defconstant $tmKeyMsg 100)
(defconstant $tmStreamMsg 101)
(defconstant $tmResizeMsg 102)
(defconstant $tmUpdateMsg 103)
(defconstant $tmClickMsg 104)
(defconstant $tmGetSelectionMsg 105)
(defconstant $tmSetSelectionMsg 106)
(defconstant $tmScrollMsg 107)
(defconstant $tmClearMsg 108)
(defconstant $tmGetLineMsg 109)
(defconstant $tmPaintMsg 110)
(defconstant $tmCursorMsg 111)
(defconstant $tmGetEnvironsMsg 112)
(defconstant $tmDoTermKeyMsg 113)
(defconstant $tmCountTermKeysMsg 114)
(defconstant $tmGetIndTermKeyMsg 115)

;   messages for validate DefProc     
(defconstant $tmValidateMsg 0)
(defconstant $tmDefaultMsg 1)

;   messages for Setup DefProc     
(defconstant $tmSpreflightMsg 0)
(defconstant $tmSsetupMsg 1)
(defconstant $tmSitemMsg 2)
(defconstant $tmSfilterMsg 3)
(defconstant $tmScleanupMsg 4)

;   messages for scripting defProc     
(defconstant $tmMgetMsg 0)
(defconstant $tmMsetMsg 1)

;   messages for localization defProc   
(defconstant $tmL2English 0)
(defconstant $tmL2Intl 1)

(def-mactype :tmsearchblockptr (find-mactype '(:pointer :tmsearchblock)))
(defrecord TMSearchBlock 
   (theString (:handle (:string 255)))
   (where :rect)
   (searchType :unsigned-integer)
   (callBack :pointer)
   (refnum :signed-integer)
   (next (:pointer :tmsearchblock))
   )

(def-mactype :tmsetupstructptr (find-mactype '(:pointer :tmsetupstruct)))
(defrecord TMSetupStruct 
   (theDialog (:pointer :grafport))
   (count :signed-integer)
   (theConfig :pointer)
   (procID :signed-integer)                     ;   procID of the tool  
   )

(def-mactype :tmsetupptr (find-mactype '(:pointer :tmsetupstruct)))
; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := TerminalToolsIncludes

; $ENDC                                         ; __TERMINALTOOLS__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'TerminalTools)