(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:TextEdit.p"
; at Wednesday May 1,2002 2:39:35 pm.
; 
;      File:       TextEdit.p
;  
;      Contains:   TextEdit Interfaces.
;  
;      Version:    Technology: System 8.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __TEXTEDIT__
; $SETC __TEXTEDIT__ := 1

; $I+
; $SETC TextEditIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :terecptr (find-mactype '(:pointer :terec)))
(def-mactype :teptr (find-mactype '(:pointer :terec)))
(def-mactype :tehandle (find-mactype '(:handle :terec)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	HighHookProcPtr = PROCEDURE({CONST}VAR r: Rect; pTE: TEPtr);

|#
 |#                                             ; $ELSEC
(def-mactype :highhookprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	EOLHookProcPtr = FUNCTION(theChar: ByteParameter; pTE: TEPtr; hTE: TEHandle): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :eolhookprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CaretHookProcPtr = PROCEDURE({CONST}VAR r: Rect; pTE: TEPtr);

|#
 |#                                             ; $ELSEC
(def-mactype :carethookprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	WidthHookProcPtr = FUNCTION(textLen: UInt16; textOffset: UInt16; textBufferPtr: UNIV Ptr; pTE: TEPtr; hTE: TEHandle): UInt16;

|#
 |#                                             ; $ELSEC
(def-mactype :widthhookprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TextWidthHookProcPtr = FUNCTION(textLen: UInt16; textOffset: UInt16; textBufferPtr: UNIV Ptr; pTE: TEPtr; hTE: TEHandle): UInt16;

|#
 |#                                             ; $ELSEC
(def-mactype :textwidthhookprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	NWidthHookProcPtr = FUNCTION(styleRunLen: UInt16; styleRunOffset: UInt16; slop: INTEGER; direction: INTEGER; textBufferPtr: UNIV Ptr; VAR lineStart: INTEGER; pTE: TEPtr; hTE: TEHandle): UInt16;

|#
 |#                                             ; $ELSEC
(def-mactype :nwidthhookprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DrawHookProcPtr = PROCEDURE(textOffset: UInt16; drawLen: UInt16; textBufferPtr: UNIV Ptr; pTE: TEPtr; hTE: TEHandle);

|#
 |#                                             ; $ELSEC
(def-mactype :drawhookprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	HitTestHookProcPtr = FUNCTION(styleRunLen: UInt16; styleRunOffset: UInt16; slop: UInt16; textBufferPtr: UNIV Ptr; pTE: TEPtr; hTE: TEHandle; VAR pixelWidth: UInt16; VAR charOffset: UInt16; VAR pixelInChar: BOOLEAN): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :hittesthookprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TEFindWordProcPtr = PROCEDURE(currentPos: UInt16; caller: INTEGER; pTE: TEPtr; hTE: TEHandle; VAR wordStart: UInt16; VAR wordEnd: UInt16);

|#
 |#                                             ; $ELSEC
(def-mactype :tefindwordprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TERecalcProcPtr = PROCEDURE(pTE: TEPtr; changeLength: UInt16; VAR lineStart: UInt16; VAR firstChar: UInt16; VAR lastChar: UInt16);

|#
 |#                                             ; $ELSEC
(def-mactype :terecalcprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TEDoTextProcPtr = PROCEDURE(pTE: TEPtr; firstChar: UInt16; lastChar: UInt16; selector: INTEGER; VAR currentGrafPort: GrafPtr; VAR charPosition: INTEGER);

|#
 |#                                             ; $ELSEC
(def-mactype :tedotextprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TEClickLoopProcPtr = FUNCTION(pTE: TEPtr): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :teclickloopprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	WordBreakProcPtr = FUNCTION(text: Ptr; charPos: INTEGER): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :wordbreakprocptr (find-mactype ':pointer))
; $ENDC

; 	 
; 	    Important note about TEClickLoopProcPtr and WordBreakProcPtr
; 	
; 	    At one point these were defined as returning the function result in the 
; 	    condition code Z-bit.  This was correct, in that it was what the 68K
; 	    implementation of TextEdit actually tested.  But, MixedMode had a different 
; 	    idea of what returning a boolean in the Z-bit meant.  MixedMode was setting
; 	    the Z-bit the complement of what was wanted.  
; 	    
; 	    Therefore, these ProcPtrs have been changed (back) to return the result in
; 	    register D0.  It turns out that for register based routines, 
; 	    MixedMode sets the Z-bit of the 68K emulator based on the contents 
; 	    of the return result register.  Thus we can get the Z-bit set correctly.  
; 	    
; 	    But, when TextEdit is recoded in PowerPC, if it calls a 68K ClickLoop
; 	    or WordBreak routine, register D0 had better have the result (in addition
; 	    to the Z-bit). Therefore all 68K apps should make sure their ClickLoop or
; 	    WordBreak routines set register D0 at the end.
; 		

; 	 
; 	    There is no function to get/set the low-mem for FindWordHook at 0x07F8.
; 	    This is because it is not a low-mem ProcPtr. That address is the entry
; 	    in the OS TrapTable for trap 0xA0FE.  You can use Get/SetTrapAddress to 
; 	    acccess it. 
; 		

; 	
; 	    The following ProcPtrs cannot be written in or called from a high-level 
; 	    language without the help of mixed mode or assembly glue because they 
; 	    use the following parameter-passing conventions:
; 	
; 	    typedef pascal void (*HighHookProcPtr)(const Rect *r, TEPtr pTE);
; 	    typedef pascal void (*CaretHookProcPtr)(const Rect *r, TEPtr pTE);
; 	
; 	        In:
; 	            =>  r                       on stack
; 	            =>  pTE                     A3.L
; 	        Out:
; 	            none
; 	
; 	    typedef pascal Boolean (*EOLHookProcPtr)(char theChar, TEPtr pTE, TEHandle hTE);
; 	
; 	        In:
; 	            =>  theChar                 D0.B
; 	            =>  pTE                     A3.L
; 	            =>  hTE                     A4.L
; 	        Out:
; 	            <=  Boolean                 Z bit of the CCR
; 	
; 	    typedef pascal unsigned short (*WidthHookProcPtr)(unsigned short textLen,
; 	     unsigned short textOffset, void *textBufferPtr, TEPtr pTE, TEHandle hTE);
; 	    typedef pascal unsigned short (*TextWidthHookProcPtr)(unsigned short textLen,
; 	     unsigned short textOffset, void *textBufferPtr, TEPtr pTE, TEHandle hTE);
; 	
; 	        In:
; 	            =>  textLen                 D0.W
; 	            =>  textOffset              D1.W
; 	            =>  textBufferPtr           A0.L
; 	            =>  pTE                     A3.L
; 	            =>  hTE                     A4.L
; 	        Out:
; 	            <=  unsigned short          D1.W
; 	
; 	    typedef pascal unsigned short (*NWidthHookProcPtr)(unsigned short styleRunLen,
; 	     unsigned short styleRunOffset, short slop, short direction, void *textBufferPtr, 
; 	     short *lineStart, TEPtr pTE, TEHandle hTE);
; 	
; 	        In:
; 	            =>  styleRunLen             D0.W
; 	            =>  styleRunOffset          D1.W
; 	            =>  slop                    D2.W (low)
; 	            =>  direction               D2.W (high)
; 	            =>  textBufferPtr           A0.L
; 	            =>  lineStart               A2.L
; 	            =>  pTE                     A3.L
; 	            =>  hTE                     A4.L
; 	        Out:
; 	            <=  unsigned short          D1.W
; 	
; 	    typedef pascal void (*DrawHookProcPtr)(unsigned short textOffset, unsigned short drawLen,
; 	     void *textBufferPtr, TEPtr pTE, TEHandle hTE);
; 	
; 	        In:
; 	            =>  textOffset              D0.W
; 	            =>  drawLen                 D1.W
; 	            =>  textBufferPtr           A0.L
; 	            =>  pTE                     A3.L
; 	            =>  hTE                     A4.L
; 	        Out:
; 	            none
; 	
; 	    typedef pascal Boolean (*HitTestHookProcPtr)(unsigned short styleRunLen,
; 	     unsigned short styleRunOffset, unsigned short slop, void *textBufferPtr,
; 	     TEPtr pTE, TEHandle hTE, unsigned short *pixelWidth, unsigned short *charOffset, 
; 	     Boolean *pixelInChar);
; 	
; 	        In:
; 	            =>  styleRunLen             D0.W
; 	            =>  styleRunOffset          D1.W
; 	            =>  slop                    D2.W
; 	            =>  textBufferPtr           A0.L
; 	            =>  pTE                     A3.L
; 	            =>  hTE                     A4.L
; 	        Out:
; 	            <=  pixelWidth              D0.W (low)
; 	            <=  Boolean                 D0.W (high)
; 	            <=  charOffset              D1.W
; 	            <=  pixelInChar             D2.W
; 	
; 	    typedef pascal void (*TEFindWordProcPtr)(unsigned short currentPos, short caller, 
; 	     TEPtr pTE, TEHandle hTE, unsigned short *wordStart, unsigned short *wordEnd);
; 	
; 	        In:
; 	            =>  currentPos              D0.W
; 	            =>  caller                  D2.W
; 	            =>  pTE                     A3.L
; 	            =>  hTE                     A4.L
; 	        Out:
; 	            <=  wordStart               D0.W
; 	            <=  wordEnd                 D1.W
; 	
; 	    typedef pascal void (*TERecalcProcPtr)(TEPtr pTE, unsigned short changeLength,
; 	     unsign
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :highhookupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :highhookupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :eolhookupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :eolhookupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :carethookupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :carethookupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :widthhookupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :widthhookupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :textwidthhookupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :textwidthhookupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :nwidthhookupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :nwidthhookupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :drawhookupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :drawhookupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :hittesthookupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :hittesthookupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :tefindwordupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :tefindwordupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :terecalcupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :terecalcupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :tedotextupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :tedotextupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :teclickloopupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :teclickloopupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :wordbreakupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :wordbreakupp (find-mactype ':pointer))
; $ENDC
(defrecord (TERec :handle) 
   (destRect :rect)
   (viewRect :rect)
   (selRect :rect)
   (lineHeight :signed-integer)
   (fontAscent :signed-integer)
   (selPoint :point)
   (selStart :signed-integer)
   (selEnd :signed-integer)
   (active :signed-integer)
   (wordBreak :pointer)                         ;   NOTE: This field is ignored on non-Roman systems and on Carbon (see IM-Text 2-60)  
   (clickLoop :pointer)
   (clickTime :signed-long)
   (clickLoc :signed-integer)
   (caretTime :signed-long)
   (caretState :signed-integer)
   (just :signed-integer)
   (teLength :signed-integer)
   (hText :handle)
   (hDispatchRec :signed-long)                  ;   added to replace recalBack & recalLines.  it's a handle anyway  
   (clikStuff :signed-integer)
   (crOnly :signed-integer)
   (txFont :signed-integer)
   (txFace :unsigned-byte)                      ;  StyleField occupies 16-bits, but only first 8-bits are used 
   (txMode :signed-integer)
   (txSize :signed-integer)
   (inPort (:pointer :grafport))
   (highHook :pointer)
   (caretHook :pointer)
   (nLines :signed-integer)
   (lineStarts (:array :signed-integer 16001))
   )

;   Justification (word alignment) styles  
(defconstant $teJustLeft 0)
(defconstant $teJustCenter 1)
(defconstant $teJustRight -1)
(defconstant $teForceLeft -2)                   ;   new names for the Justification (word alignment) styles  
(defconstant $teFlushDefault 0)                 ;  flush according to the line direction  
(defconstant $teCenter 1)                       ;  center justify (word alignment)  
(defconstant $teFlushRight -1)                  ;  flush right for all scripts  
(defconstant $teFlushLeft -2)                   ;  flush left for all scripts  

;   Set/Replace style modes  
(defconstant $fontBit 0)                        ;  set font 
(defconstant $faceBit 1)                        ;  set face 
(defconstant $sizeBit 2)                        ;  set size 
(defconstant $clrBit 3)                         ;  set color 
(defconstant $addSizeBit 4)                     ;  add size mode 
(defconstant $toggleBit 5)                      ;  set faces in toggle mode 

;   TESetStyle/TEContinuousStyle modes  
(defconstant $doFont 1)                         ;   set font (family) number 
(defconstant $doFace 2)                         ;  set character style 
(defconstant $doSize 4)                         ;  set type size 
(defconstant $doColor 8)                        ;  set color 
(defconstant $doAll 15)                         ;  set all attributes 
(defconstant $addSize 16)                       ;  adjust type size 
(defconstant $doToggle 32)                      ;  toggle mode for TESetStyle 

;   offsets into TEDispatchRec  
(defconstant $EOLHook 0)                        ;  [UniversalProcPtr] TEEOLHook 
(defconstant $DRAWHook 4)                       ;  [UniversalProcPtr] TEWidthHook 
(defconstant $WIDTHHook 8)                      ;  [UniversalProcPtr] TEDrawHook 
(defconstant $HITTESTHook 12)                   ;  [UniversalProcPtr] TEHitTestHook 
(defconstant $nWIDTHHook 24)                    ;  [UniversalProcPtr] nTEWidthHook 
(defconstant $TextWidthHook 28)                 ;  [UniversalProcPtr] TETextWidthHook 

;   selectors for TECustomHook  
(defconstant $intEOLHook 0)                     ;  TEIntHook value 
(defconstant $intDrawHook 1)                    ;  TEIntHook value 
(defconstant $intWidthHook 2)                   ;  TEIntHook value 
(defconstant $intHitTestHook 3)                 ;  TEIntHook value 
(defconstant $intNWidthHook 6)                  ;  TEIntHook value for new version of WidthHook 
(defconstant $intTextWidthHook 7)               ;  TEIntHook value for new TextWidthHook 
(defconstant $intInlineInputTSMTEPreUpdateHook 8);  TEIntHook value for TSMTEPreUpdateProcPtr callback 
(defconstant $intInlineInputTSMTEPostUpdateHook 9);  TEIntHook value for TSMTEPostUpdateProcPtr callback 

;   feature or bit definitions for TEFeatureFlag  
(defconstant $teFAutoScroll 0)                  ;  00000001b 
(defconstant $teFTextBuffering 1)               ;  00000010b 
(defconstant $teFOutlineHilite 2)               ;  00000100b 
(defconstant $teFInlineInput 3)                 ;  00001000b  
(defconstant $teFUseWhiteBackground 4)          ;  00010000b  
(defconstant $teFUseInlineInput 5)              ;  00100000b  
(defconstant $teFInlineInputAutoScroll 6)       ;  01000000b  

;   feature or bit definitions for TEFeatureFlag -- Carbon only                 
;   To avoid having to call TEIdle in Carbon apps, automatic idling can be activated    
;   via the following feature flag, but you must ensure that the destRect and/or      
;   GrafPort's origin be setup properly for drawing in a given TERec when        
;   the timer fires.    When this feature flag is set, TEIdle is a noop.           
;   Activate this feature flag before calling TEActivate.                  
(defconstant $teFIdleWithEventLoopTimer 7)      ;  10000000b  

;   action for the new "bit (un)set" interface, TEFeatureFlag  
(defconstant $teBitClear 0)
(defconstant $teBitSet 1)                       ;  set the selector bit 
(defconstant $teBitTest -1)                     ;  no change; just return the current setting 

;  constants for identifying the routine that called FindWord  
(defconstant $teWordSelect 4)                   ;  clickExpand to select word 
(defconstant $teWordDrag 8)                     ;  clickExpand to drag new word 
(defconstant $teFromFind 12)                    ;  FindLine called it ($0C) 
(defconstant $teFromRecal 16)                   ;  RecalLines called it ($10)      obsolete  

;  constants for identifying TEDoText selectors  
(defconstant $teFind 0)                         ;  TEDoText called for searching 
(defconstant $teHighlight 1)                    ;  TEDoText called for highlighting 
(defconstant $teDraw -1)                        ;  TEDoText called for drawing text 
(defconstant $teCaret -2)                       ;  TEDoText called for drawing the caret 

(defrecord (Chars :handle) (array (:array :character 32001 :packed)))
(def-mactype :charsptr (find-mactype '(:pointer :chars)))
(def-mactype :charshandle (find-mactype '(:handle :chars)))
(def-mactype :stylerunptr (find-mactype '(:pointer :stylerun)))
(defrecord StyleRun 
   (startChar :signed-integer)                  ;  starting character position 
   (styleIndex :signed-integer)                 ;  index in style table 
   )

(def-mactype :stelementptr (find-mactype '(:pointer :stelement)))
(defrecord STElement 
   (stCount :signed-integer)                    ;  number of runs in this style 
   (stHeight :signed-integer)                   ;  line height 
   (stAscent :signed-integer)                   ;  font ascent 
   (stFont :signed-integer)                     ;  font (family) number 
   (stFace :unsigned-byte)                      ;  StyleField occupies 16-bits, but only first 8-bits are used  
   (stSize :signed-integer)                     ;  size in points 
   (stColor :rgbcolor)                          ;  absolute (RGB) color 
   )

(defrecord (TEStyleTable :handle) (array (:array :stelement 1777)))
(def-mactype :stptr (find-mactype '(:pointer :testyletable)))
(def-mactype :sthandle (find-mactype '(:handle :testyletable)))
(def-mactype :lhelementptr (find-mactype '(:pointer :lhelement)))
(defrecord LHElement 
   (lhHeight :signed-integer)                   ;  maximum height in line 
   (lhAscent :signed-integer)                   ;  maximum ascent in line 
   )

(defrecord (LHTable :handle) (array (:array :lhelement 8001)))
(def-mactype :lhptr (find-mactype '(:pointer :lhtable)))
(def-mactype :lhhandle (find-mactype '(:handle :lhtable)))
(def-mactype :scrpstelementptr (find-mactype '(:pointer :scrpstelement)))
(defrecord ScrpSTElement 
   (scrpStartChar :signed-long)                 ;  starting character position 
   (scrpHeight :signed-integer)
   (scrpAscent :signed-integer)
   (scrpFont :signed-integer)
   (scrpFace :unsigned-byte)                    ;  StyleField occupies 16-bits, but only first 8-bits are used 
   (scrpSize :signed-integer)
   (scrpColor :rgbcolor)
   )

; 	 ARRAY [0..1600] OF ScrpSTElement 	
(defrecord ScrpSTTable (array (:array :scrpstelement 1601)))
(def-mactype :stscrprecptr (find-mactype '(:pointer :stscrprec)))
(defrecord (StScrpRec :handle) 
   (scrpNStyles :signed-integer)                ;  number of styles in scrap 
   (scrpStyleTab :scrpsttable)                  ;  table of styles for scrap 
   )

(def-mactype :stscrpptr (find-mactype '(:pointer :stscrprec)))
(def-mactype :stscrphandle (find-mactype '(:handle :stscrprec)))
(def-mactype :nullstrecptr (find-mactype '(:pointer :nullstrec)))
(defrecord (NullStRec :handle) 
   (teReserved :signed-long)                    ;  reserved for future expansion 
   (nullScrap (:handle :stscrprec))             ;  handle to scrap style table 
   )

(def-mactype :nullstptr (find-mactype '(:pointer :nullstrec)))
(def-mactype :nullsthandle (find-mactype '(:handle :nullstrec)))
(def-mactype :testylerecptr (find-mactype '(:pointer :testylerec)))
(defrecord (TEStyleRec :handle) 
   (nRuns :signed-integer)                      ;  number of style runs 
   (nStyles :signed-integer)                    ;  size of style table 
   (styleTab (:handle :testyletable))           ;  handle to style table 
   (lhTab (:handle :lhtable))                   ;  handle to line-height table 
   (teRefCon :signed-long)                      ;  reserved for application use 
   (nullStyle (:handle :nullstrec))             ;  Handle to style set at null selection 
   (runs (:array :stylerun 8001))               ;  ARRAY [0..8000] OF StyleRun 
   )

(def-mactype :testyleptr (find-mactype '(:pointer :testylerec)))
(def-mactype :testylehandle (find-mactype '(:handle :testylerec)))
(def-mactype :textstyleptr (find-mactype '(:pointer :textstyle)))
(defrecord (TextStyle :handle) 
   (tsFont :signed-integer)                     ;  font (family) number 
   (tsFace :unsigned-byte)                      ;  StyleField occupies 16-bits, but only first 8-bits are used 
   (tsSize :signed-integer)                     ;  size in point 
   (tsColor :rgbcolor)                          ;  absolute (RGB) color 
   )

(def-mactype :textstylehandle (find-mactype '(:handle :textstyle)))
(def-mactype :teinthook (find-mactype ':signed-integer))

(defconstant $uppHighHookProcInfo #xF)
(defconstant $uppEOLHookProcInfo #x1F)
(defconstant $uppCaretHookProcInfo #xF)
(defconstant $uppWidthHookProcInfo #x2F)
(defconstant $uppTextWidthHookProcInfo #x2F)
(defconstant $uppNWidthHookProcInfo #x3F)
(defconstant $uppDrawHookProcInfo #x4F)
(defconstant $uppHitTestHookProcInfo #x5F)
(defconstant $uppTEFindWordProcInfo #x6F)
(defconstant $uppTERecalcProcInfo #x9F)
(defconstant $uppTEDoTextProcInfo #xAF)
(defconstant $uppTEClickLoopProcInfo #xF812)
(defconstant $uppWordBreakProcInfo #x29812)
; 
; 	 *  NewHighHookUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewHighHookProc 
(deftrap "_NewHighHookUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewEOLHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewEOLHookProc 
(deftrap "_NewEOLHookUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewCaretHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewCaretHookProc 
(deftrap "_NewCaretHookUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewWidthHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewWidthHookProc 
(deftrap "_NewWidthHookUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewTextWidthHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewTextWidthHookProc 
(deftrap "_NewTextWidthHookUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewNWidthHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewNWidthHookProc 
(deftrap "_NewNWidthHookUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewDrawHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewDrawHookProc 
(deftrap "_NewDrawHookUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewHitTestHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewHitTestHookProc 
(deftrap "_NewHitTestHookUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewTEFindWordUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewTEFindWordProc 
(deftrap "_NewTEFindWordUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewTERecalcUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewTERecalcProc 
(deftrap "_NewTERecalcUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewTEDoTextUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewTEDoTextProc 
(deftrap "_NewTEDoTextUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewTEClickLoopUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewTEClickLoopProc 
(deftrap "_NewTEClickLoopUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  NewWordBreakUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewWordBreakProc 
(deftrap "_NewWordBreakUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  DisposeHighHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeHighHookUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeEOLHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeEOLHookUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeCaretHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeCaretHookUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeWidthHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeWidthHookUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeTextWidthHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeTextWidthHookUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeNWidthHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeNWidthHookUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeDrawHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeDrawHookUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeHitTestHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeHitTestHookUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeTEFindWordUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeTEFindWordUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeTERecalcUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeTERecalcUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeTEDoTextUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeTEDoTextUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeTEClickLoopUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeTEClickLoopUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  DisposeWordBreakUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeWordBreakUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  InvokeHighHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ;  old name was CallHighHookProc ; 
;  *  InvokeEOLHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InvokeHighHookUPP" 
      ((r (:pointer :rect)) (pTE (:pointer :terec)) (userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallEOLHookProc ; 
;  *  InvokeCaretHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InvokeEOLHookUPP" 
      ((theChar :signed-byte) (pTE (:pointer :terec)) (hTE (:handle :terec)) (userRoutine :pointer)) 
  :boolean
   () )                                         ; CONST;  old name was CallCaretHookProc ; 
;  *  InvokeWidthHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InvokeCaretHookUPP" 
      ((r (:pointer :rect)) (pTE (:pointer :terec)) (userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallWidthHookProc ; 
;  *  InvokeTextWidthHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InvokeWidthHookUPP" 
      ((textLen :unsigned-integer) (textOffset :unsigned-integer) (textBufferPtr :pointer) (pTE (:pointer :terec)) (hTE (:handle :terec)) (userRoutine :pointer)) 
  :unsigned-integer
   () )                                         ;  old name was CallTextWidthHookProc ; 
;  *  InvokeNWidthHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InvokeTextWidthHookUPP" 
      ((textLen :unsigned-integer) (textOffset :unsigned-integer) (textBufferPtr :pointer) (pTE (:pointer :terec)) (hTE (:handle :terec)) (userRoutine :pointer)) 
  :unsigned-integer
   () )                                         ;  old name was CallNWidthHookProc ; 
;  *  InvokeDrawHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InvokeNWidthHookUPP" 
      ((styleRunLen :unsigned-integer) (styleRunOffset :unsigned-integer) (slop :signed-integer) (direction :signed-integer) (textBufferPtr :pointer) (lineStart (:pointer :signed-integer)) (pTE (:pointer :terec)) (hTE (:handle :terec)) (userRoutine :pointer)) 
  :unsigned-integer
   () )                                         ;  old name was CallDrawHookProc ; 
;  *  InvokeHitTestHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InvokeDrawHookUPP" 
      ((textOffset :unsigned-integer) (drawLen :unsigned-integer) (textBufferPtr :pointer) (pTE (:pointer :terec)) (hTE (:handle :terec)) (userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallHitTestHookProc ; 
;  *  InvokeTEFindWordUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InvokeHitTestHookUPP" 
      ((styleRunLen :unsigned-integer) (styleRunOffset :unsigned-integer) (slop :unsigned-integer) (textBufferPtr :pointer) (pTE (:pointer :terec)) (hTE (:handle :terec)) (pixelWidth (:pointer :unsigned-integer)) (charOffset (:pointer :unsigned-integer)) (pixelInChar (:pointer :boolean)) (userRoutine :pointer)) 
  :boolean
   () )                                         ;  old name was CallTEFindWordProc ; 
;  *  InvokeTERecalcUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InvokeTEFindWordUPP" 
      ((currentPos :unsigned-integer) (caller :signed-integer) (pTE (:pointer :terec)) (hTE (:handle :terec)) (wordStart (:pointer :unsigned-integer)) (wordEnd (:pointer :unsigned-integer)) (userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallTERecalcProc ; 
;  *  InvokeTEDoTextUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InvokeTERecalcUPP" 
      ((pTE (:pointer :terec)) (changeLength :unsigned-integer) (lineStart (:pointer :unsigned-integer)) (firstChar (:pointer :unsigned-integer)) (lastChar (:pointer :unsigned-integer)) (userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallTEDoTextProc ; 
;  *  InvokeTEClickLoopUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InvokeTEDoTextUPP" 
      ((pTE (:pointer :terec)) (firstChar :unsigned-integer) (lastChar :unsigned-integer) (selector :signed-integer) (currentGrafPort (:pointer (:pointer :grafport))) (charPosition (:pointer :signed-integer)) (userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallTEClickLoopProc ; $IFC CALL_NOT_IN_CARBON ; 
;  *  InvokeWordBreakUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokeTEClickLoopUPP" 
      ((pTE (:pointer :terec)) (userRoutine :pointer)) 
  :boolean
   () )                                         ;  old name was CallWordBreakProc 
(deftrap-inline "_InvokeWordBreakUPP" 
      ((text :pointer) (charPos :signed-integer) (userRoutine :pointer)) 
  :boolean
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

;   feature bit 4 for TEFeatureFlag no longer in use  
(defconstant $teFUseTextServices 4)             ;  00010000b  

; 
; 	 *  TEScrapHandle()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_TEScrapHandle" 
      ()
   (:no-trap :handle)
   (:no-trap (%get-ptr (%int-to-ptr 2740))))

; 
;  *  TEGetScrapLength()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; $IFC CALL_NOT_IN_CARBON                       ; 
;  *  TEInit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TEGetScrapLength" 
      () 
  :signed-long
   () )
(deftrap "_TEInit" 
      ()
   nil
   (:stack-trap #xA9CC))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  TENew()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap "_TENew" 
      ((destRect (:pointer :rect)) (viewRect (:pointer :rect)))
   (:stack (:handle :terec))
   (:stack-trap #xA9D2))

; 
;  *  TEDispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEDispose" 
      ((hTE (:handle :terec)))
   nil
   (:stack-trap #xA9CD))

; 
;  *  TESetText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TESetText" 
      ((text :pointer) (length :signed-long) (hTE (:handle :terec)))
   nil
   (:stack-trap #xA9CF))

; 
;  *  TEGetText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEGetText" 
      ((hTE (:handle :terec)))
   (:stack (:handle :chars))
   (:stack-trap #xA9CB))

; 
;  *  TEIdle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEIdle" 
      ((hTE (:handle :terec)))
   nil
   (:stack-trap #xA9DA))

; 
;  *  TESetSelect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TESetSelect" 
      ((selStart :signed-long) (selEnd :signed-long) (hTE (:handle :terec)))
   nil
   (:stack-trap #xA9D1))

; 
;  *  TEActivate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEActivate" 
      ((hTE (:handle :terec)))
   nil
   (:stack-trap #xA9D8))

; 
;  *  TEDeactivate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEDeactivate" 
      ((hTE (:handle :terec)))
   nil
   (:stack-trap #xA9D9))

; 
;  *  TEKey()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEKey" 
      ((key :character) (hTE (:handle :terec)))
   nil
   (:stack-trap #xA9DC))

; 
;  *  TECut()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TECut" 
      ((hTE (:handle :terec)))
   nil
   (:stack-trap #xA9D6))

; 
;  *  TECopy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TECopy" 
      ((hTE (:handle :terec)))
   nil
   (:stack-trap #xA9D5))

; 
;  *  TEPaste()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEPaste" 
      ((hTE (:handle :terec)))
   nil
   (:stack-trap #xA9DB))

; 
;  *  TEDelete()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEDelete" 
      ((hTE (:handle :terec)))
   nil
   (:stack-trap #xA9D7))

; 
;  *  TEInsert()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEInsert" 
      ((text :pointer) (length :signed-long) (hTE (:handle :terec)))
   nil
   (:stack-trap #xA9DE))

; 
;  *  TESetAlignment()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TESetAlignment" 
      ((just :signed-integer) (hTE (:handle :terec)))
   nil
   (:stack-trap #xA9DF))

; 
;  *  TEUpdate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_TEUpdate" 
      ((rUpdate (:pointer :rect)) (hTE (:handle :terec)))
   nil
   (:stack-trap #xA9D3))

; 
;  *  TETextBox()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_TETextBox" 
      ((text :pointer) (length :signed-long) (box (:pointer :rect)) (just :signed-integer))
   nil
   (:stack-trap #xA9CE))

; 
;  *  TEScroll()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEScroll" 
      ((dh :signed-integer) (dv :signed-integer) (hTE (:handle :terec)))
   nil
   (:stack-trap #xA9DD))

; 
;  *  TESelView()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TESelView" 
      ((hTE (:handle :terec)))
   nil
   (:stack-trap #xA811))

; 
;  *  TEPinScroll()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEPinScroll" 
      ((dh :signed-integer) (dv :signed-integer) (hTE (:handle :terec)))
   nil
   (:stack-trap #xA812))

; 
;  *  TEAutoView()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEAutoView" 
      ((fAuto :boolean) (hTE (:handle :terec)))
   nil
   (:stack-trap #xA813))

; 
;  *  TECalText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TECalText" 
      ((hTE (:handle :terec)))
   nil
   (:stack-trap #xA9D0))

; 
;  *  TEGetOffset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEGetOffset" 
      ((pt :point) (hTE (:handle :terec)))
   (:stack :signed-integer)
   (:stack-trap #xA83C))

; 
;  *  TEGetPoint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEGetPoint" 
      ((offset :signed-integer) (hTE (:handle :terec)))
   (:stack :point)
   (:stack-trap #xA83D offset hTE (8 :signed-integer)))

; 
;  *  TEClick()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEClick" 
      ((pt :point) (fExtend :boolean) (h (:handle :terec)))
   nil
   (:stack-trap #xA9D4))

; 
;  *  TEStyleNew()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap "_TEStyleNew" 
      ((destRect (:pointer :rect)) (viewRect (:pointer :rect)))
   (:stack (:handle :terec))
   (:stack-trap #xA83E))

; 
;  *  TESetStyleHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TESetStyleHandle" 
      ((theHandle (:handle :testylerec)) (hTE (:handle :terec)))
   nil
   (:stack-trap #xA83D theHandle hTE (5 :signed-integer)))

; 
;  *  TEGetStyleHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEGetStyleHandle" 
      ((hTE (:handle :terec)))
   (:stack (:handle :testylerec))
   (:stack-trap #xA83D hTE (4 :signed-integer)))

; 
;  *  TEGetStyle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEGetStyle" 
      ((offset :signed-integer) (theStyle (:pointer :textstyle)) (lineHeight (:pointer :signed-integer)) (fontAscent (:pointer :signed-integer)) (hTE (:handle :terec)))
   nil
   (:stack-trap #xA83D offset theStyle lineHeight fontAscent hTE (3 :signed-integer)))

; 
;  *  TEStylePaste()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEStylePaste" 
      ((hTE (:handle :terec)))
   nil
   (:stack-trap #xA83D hTE (0 :signed-integer)))

; 
;  *  TESetStyle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_TESetStyle" 
      ((mode :signed-integer) (newStyle (:pointer :textstyle)) (fRedraw :boolean) (hTE (:handle :terec)))
   nil
   (:stack-trap #xA83D mode newStyle fRedraw hTE (1 :signed-integer)))

; 
;  *  TEReplaceStyle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap "_TEReplaceStyle" 
      ((mode :signed-integer) (oldStyle (:pointer :textstyle)) (newStyle (:pointer :textstyle)) (fRedraw :boolean) (hTE (:handle :terec)))
   nil
   (:stack-trap #xA83D mode oldStyle newStyle fRedraw hTE (2 :signed-integer)))

; 
;  *  TEGetStyleScrapHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEGetStyleScrapHandle" 
      ((hTE (:handle :terec)))
   (:stack (:handle :stscrprec))
   (:stack-trap #xA83D hTE (6 :signed-integer)))

; 
;  *  TEStyleInsert()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEStyleInsert" 
      ((text :pointer) (length :signed-long) (hST (:handle :stscrprec)) (hTE (:handle :terec)))
   nil
   (:stack-trap #xA83D text length hST hTE (7 :signed-integer)))

; 
;  *  TEGetHeight()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEGetHeight" 
      ((endLine :signed-long) (startLine :signed-long) (hTE (:handle :terec)))
   (:stack :signed-long)
   (:stack-trap #xA83D endLine startLine hTE (9 :signed-integer)))

; 
;  *  TEContinuousStyle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEContinuousStyle" 
      ((mode (:pointer :signed-integer)) (aStyle (:pointer :textstyle)) (hTE (:handle :terec)))
   (:stack :boolean)
   (:stack-trap #xA83D mode aStyle hTE (10 :signed-integer)))

; 
;  *  TEUseStyleScrap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEUseStyleScrap" 
      ((rangeStart :signed-long) (rangeEnd :signed-long) (newStyles (:handle :stscrprec)) (fRedraw :boolean) (hTE (:handle :terec)))
   nil
   (:stack-trap #xA83D rangeStart rangeEnd newStyles fRedraw hTE (11 :signed-integer)))

; 
;  *  TECustomHook()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TECustomHook" 
      ((which :signed-integer) (addr (:pointer :pointer)) (hTE (:handle :terec)))
   nil
   (:stack-trap #xA83D which addr hTE (12 :signed-integer)))

; 
;  *  TENumStyles()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TENumStyles" 
      ((rangeStart :signed-long) (rangeEnd :signed-long) (hTE (:handle :terec)))
   (:stack :signed-long)
   (:stack-trap #xA83D rangeStart rangeEnd hTE (13 :signed-integer)))

; 
;  *  TEFeatureFlag()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEFeatureFlag" 
      ((feature :signed-integer) (action :signed-integer) (hTE (:handle :terec)))
   (:stack :signed-integer)
   (:stack-trap #xA83D feature action hTE (14 :signed-integer)))

; 
;  *  TEGetHiliteRgn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DragLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TEGetHiliteRgn" 
      ((region (:handle :macregion)) (hTE (:handle :terec)))
   (:stack :signed-integer)
   (:stack-trap #xA83D region hTE (15 :signed-integer)))

; 
;  *  TESetScrapLength()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  TEFromScrap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TESetScrapLength" 
      ((length :signed-long)) 
  nil
   () )                                         ; 
;  *  TEToScrap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TEFromScrap" 
      () 
  :signed-integer
   () )                                         ; 
;  *  TESetClickLoop()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TEToScrap" 
      () 
  :signed-integer
   () )                                         ; $IFC CALL_NOT_IN_CARBON ; 
;  *  TESetWordBreak()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TESetClickLoop" 
      ((clikProc :pointer) (hTE (:handle :terec))) 
  nil
   () )
(deftrap-inline "_TESetWordBreak" 
      ((wBrkProc :pointer) (hTE (:handle :terec))) 
  nil
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; 
;  *  TEGetDoTextHook()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  TESetDoTextHook()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TEGetDoTextHook" 
      () 
  :pointer
   () )                                         ; 
;  *  TEGetRecalcHook()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TESetDoTextHook" 
      ((value :pointer)) 
  nil
   () )                                         ; 
;  *  TESetRecalcHook()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TEGetRecalcHook" 
      () 
  :pointer
   () )                                         ; 
;  *  TEGetFindWordHook()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TESetRecalcHook" 
      ((value :pointer)) 
  nil
   () )                                         ; 
;  *  TESetFindWordHook()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TEGetFindWordHook" 
      () 
  :pointer
   () )                                         ; 
;  *  TEGetScrapHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TESetFindWordHook" 
      ((value :pointer)) 
  nil
   () )                                         ; 
;  *  TESetScrapHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TEGetScrapHandle" 
      () 
  :handle
   () )                                         ;  LMGetWordRedraw and LMSetWordRedraw were previously in LowMem.h  ;  Deprecated for Carbon on MacOS X                                 ;  This lomem is no longer used by the implementation of TextEdit   ;  on MacOS X, so setting it will have no effect.                   ; 
;  *  LMGetWordRedraw()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TESetScrapHandle" 
      ((value :handle)) 
  nil
   () )
(deftrap-inline "_LMGetWordRedraw" 
      () 
  :uint8
   (#x1EB8 #xBA5) )

; 
;  *  LMSetWordRedraw()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_LMSetWordRedraw" 
      ((value :signed-byte)) 
  nil
   (#x11DF #xBA5) )

; $IFC OLDROUTINENAMES 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  TESetJust()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_TESetJust" 
      ((just :signed-integer) (hTE (:handle :terec)))
   nil
   (:stack-trap #xA9DF))

; 
;  *  TextBox()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_TextBox" 
      ((text :pointer) (length :signed-long) (box (:pointer :rect)) (just :signed-integer))
   nil
   (:stack-trap #xA9CE))

; 
;  *  TEStylNew()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap "_TEStylNew" 
      ((destRect (:pointer :rect)) (viewRect (:pointer :rect)))
   (:stack (:handle :terec))
   (:stack-trap #xA83E))

; 
;  *  SetStylHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetStylHandle" 
      ((theHandle (:handle :testylerec)) (hTE (:handle :terec)))
   nil
   (:stack-trap #xA83D theHandle hTE (5 :signed-integer)))

; 
;  *  SetStyleHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetStyleHandle" 
      ((theHandle (:handle :testylerec)) (hTE (:handle :terec)))
   nil
   (:stack-trap #xA83D theHandle hTE (5 :signed-integer)))

; 
;  *  GetStylHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetStylHandle" 
      ((hTE (:handle :terec)))
   (:stack (:handle :testylerec))
   (:stack-trap #xA83D hTE (4 :signed-integer)))

; 
;  *  GetStyleHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetStyleHandle" 
      ((hTE (:handle :terec)))
   (:stack (:handle :testylerec))
   (:stack-trap #xA83D hTE (4 :signed-integer)))

; 
;  *  TEStylPaste()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_TEStylPaste" 
      ((hTE (:handle :terec)))
   nil
   (:stack-trap #xA83D hTE (0 :signed-integer)))

; 
;  *  GetStylScrap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetStylScrap" 
      ((hTE (:handle :terec)))
   (:stack (:handle :stscrprec))
   (:stack-trap #xA83D hTE (6 :signed-integer)))

; 
;  *  GetStyleScrap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetStyleScrap" 
      ((hTE (:handle :terec)))
   (:stack (:handle :stscrprec))
   (:stack-trap #xA83D hTE (6 :signed-integer)))

; 
;  *  SetStylScrap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetStylScrap" 
      ((rangeStart :signed-long) (rangeEnd :signed-long) (newStyles (:handle :stscrprec)) (fRedraw :boolean) (hTE (:handle :terec)))
   nil
   (:stack-trap #xA83D rangeStart rangeEnd newStyles fRedraw hTE (11 :signed-integer)))

; 
;  *  SetStyleScrap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetStyleScrap" 
      ((rangeStart :signed-long) (rangeEnd :signed-long) (newStyles (:handle :stscrprec)) (fRedraw :boolean) (hTE (:handle :terec)))
   nil
   (:stack-trap #xA83D rangeStart rangeEnd newStyles fRedraw hTE (11 :signed-integer)))

; 
;  *  TEStylInsert()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_TEStylInsert" 
      ((text :pointer) (length :signed-long) (hST (:handle :stscrprec)) (hTE (:handle :terec)))
   nil
   (:stack-trap #xA83D text length hST hTE (7 :signed-integer)))

; 
;  *  TESetScrapLen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  TEGetScrapLen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TESetScrapLen" 
      ((length :signed-long)) 
  nil
   () )                                         ; 
;  *  SetClikLoop()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TEGetScrapLen" 
      () 
  :signed-long
   () )                                         ; 
;  *  SetWordBreak()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SetClikLoop" 
      ((clikProc :pointer) (hTE (:handle :terec))) 
  nil
   () )
(deftrap-inline "_SetWordBreak" 
      ((wBrkProc :pointer) (hTE (:handle :terec))) 
  nil
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; $ENDC                                         ; OLDROUTINENAMES

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := TextEditIncludes

; $ENDC                                         ; __TEXTEDIT__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'TextEdit)