(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:TextEncodingConverter.p"
; at Wednesday May 1,2002 2:40:05 pm.
; 
;      File:       TextEncodingConverter.p
;  
;      Contains:   Text Encoding Conversion Interfaces.
;  
;      Version:    Technology: Mac OS 9.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1994-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __TEXTENCODINGCONVERTER__
; $SETC __TEXTENCODINGCONVERTER__ := 1

; $I+
; $SETC TextEncodingConverterIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __TEXTCOMMON__
|#

(require-interface 'TextCommon)
#|                                              ; $I TextCommon.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :tecpluginsignature (find-mactype ':ostype))
(def-mactype :tecpluginversion (find-mactype ':unsigned-long))
; 	 plugin signatures 	

(defconstant $kTECSignature :|encv|)
(defconstant $kTECUnicodePluginSignature :|puni|)
(defconstant $kTECJapanesePluginSignature :|pjpn|)
(defconstant $kTECChinesePluginSignature :|pzho|)
(defconstant $kTECKoreanPluginSignature :|pkor|)

; 	 converter object reference 	

(def-mactype :tecobjectref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :tecobjectrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:TECObjectRef parameter can be nil, it is changed to xx: TECObjectRefPtr 
(def-mactype :tecsnifferobjectref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :tecsnifferobjectrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:TECSnifferObjectRef parameter can be nil, it is changed to xx: TECSnifferObjectRefPtr 
(def-mactype :tecpluginsig (find-mactype ':ostype))
(def-mactype :tecconversioninfoptr (find-mactype '(:pointer :tecconversioninfo)))
(defrecord TECConversionInfo 
   (sourceEncoding :unsigned-long)
   (destinationEncoding :unsigned-long)
   (reserved1 :unsigned-integer)
   (reserved2 :unsigned-integer)
   )

; 	 return number of encodings types supported by user's configuraton of the encoding converter 	
; 
; 	 *  TECCountAvailableTextEncodings()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in TextEncodingConverter 1.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  fill in an array of type TextEncoding passed in by the user with types of encodings the current configuration of the encoder can handle. ; 
;  *  TECGetAvailableTextEncodings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECCountAvailableTextEncodings" 
      ((numberEncodings (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ;  return number of from-to encoding conversion pairs supported  ; 
;  *  TECCountDirectTextEncodingConversions()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECGetAvailableTextEncodings" 
      ((availableEncodings (:pointer :unsigned-long)) (maxAvailableEncodings :unsigned-long) (actualAvailableEncodings (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ;  fill in an array of type TextEncodingPair passed in by the user with types of encoding pairs the current configuration of the encoder can handle. ; 
;  *  TECGetDirectTextEncodingConversions()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECCountDirectTextEncodingConversions" 
      ((numberOfEncodings (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ;  return number of encodings a given encoding can be converter into ; 
;  *  TECCountDestinationTextEncodings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECGetDirectTextEncodingConversions" 
      ((availableConversions (:pointer :tecconversioninfo)) (maxAvailableConversions :unsigned-long) (actualAvailableConversions (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ;  fill in an array of type TextEncodingPair passed in by the user with types of encodings pairs the current configuration of the encoder can handle. ; 
;  *  TECGetDestinationTextEncodings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECCountDestinationTextEncodings" 
      ((inputEncoding :unsigned-long) (numberOfEncodings (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ;  get info about a text encoding ; 
;  *  TECGetTextEncodingInternetName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECGetDestinationTextEncodings" 
      ((inputEncoding :unsigned-long) (destinationEncodings (:pointer :unsigned-long)) (maxDestinationEncodings :unsigned-long) (actualDestinationEncodings (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  TECGetTextEncodingFromInternetName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECGetTextEncodingInternetName" 
      ((TextEncoding :unsigned-long) (encodingName (:pointer (:string 255)))) 
  :osstatus
   () )                                         ;  create/dispose converters ; 
;  *  TECCreateConverter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECGetTextEncodingFromInternetName" 
      ((TextEncoding (:pointer :unsigned-long)) (encodingName (:string 255))) 
  :osstatus
   () )                                         ; 
;  *  TECCreateConverterFromPath()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECCreateConverter" 
      ((newEncodingConverter (:pointer :pointer)) (inputEncoding :unsigned-long) (outputEncoding :unsigned-long)) 
  :osstatus
   () )                                         ; CONST; 
;  *  TECDisposeConverter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECCreateConverterFromPath" 
      ((newEncodingConverter (:pointer :pointer)) (inPath (:pointer :unsigned-long)) (inEncodings :unsigned-long)) 
  :osstatus
   () )                                         ;  convert text encodings ; 
;  *  TECClearConverterContextInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECDisposeConverter" 
      ((newEncodingConverter :pointer)) 
  :osstatus
   () )                                         ; 
;  *  TECConvertText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECClearConverterContextInfo" 
      ((encodingConverter :pointer)) 
  :osstatus
   () )                                         ; 
;  *  TECFlushText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECConvertText" 
      ((encodingConverter :pointer) (inputBuffer (:pointer :unsigned-byte)) (inputBufferLength :unsigned-long) (actualInputLength (:pointer :unsigned-long)) (outputBuffer (:pointer :unsigned-byte)) (outputBufferLength :unsigned-long) (actualOutputLength (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ;  one-to-many routines ; 
;  *  TECCountSubTextEncodings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECFlushText" 
      ((encodingConverter :pointer) (outputBuffer (:pointer :unsigned-byte)) (outputBufferLength :unsigned-long) (actualOutputLength (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  TECGetSubTextEncodings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECCountSubTextEncodings" 
      ((inputEncoding :unsigned-long) (numberOfEncodings (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  TECGetEncodingList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECGetSubTextEncodings" 
      ((inputEncoding :unsigned-long) (subEncodings (:pointer :unsigned-long)) (maxSubEncodings :unsigned-long) (actualSubEncodings (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  TECCreateOneToManyConverter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECGetEncodingList" 
      ((encodingConverter :pointer) (numEncodings (:pointer :unsigned-long)) (encodingList (:pointer :handle))) 
  :osstatus
   () )                                         ; CONST; 
;  *  TECConvertTextToMultipleEncodings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECCreateOneToManyConverter" 
      ((newEncodingConverter (:pointer :pointer)) (inputEncoding :unsigned-long) (numOutputEncodings :unsigned-long) (outputEncodings (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  TECFlushMultipleEncodings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECConvertTextToMultipleEncodings" 
      ((encodingConverter :pointer) (inputBuffer (:pointer :unsigned-byte)) (inputBufferLength :unsigned-long) (actualInputLength (:pointer :unsigned-long)) (outputBuffer (:pointer :unsigned-byte)) (outputBufferLength :unsigned-long) (actualOutputLength (:pointer :unsigned-long)) (outEncodingsBuffer (:pointer :textencodingrun)) (maxOutEncodingRuns :unsigned-long) (actualOutEncodingRuns (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ;  international internet info ; 
;  *  TECCountWebTextEncodings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECFlushMultipleEncodings" 
      ((encodingConverter :pointer) (outputBuffer (:pointer :unsigned-byte)) (outputBufferLength :unsigned-long) (actualOutputLength (:pointer :unsigned-long)) (outEncodingsBuffer (:pointer :textencodingrun)) (maxOutEncodingRuns :unsigned-long) (actualOutEncodingRuns (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  TECGetWebTextEncodings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECCountWebTextEncodings" 
      ((locale :signed-integer) (numberEncodings (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  TECCountMailTextEncodings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECGetWebTextEncodings" 
      ((locale :signed-integer) (availableEncodings (:pointer :unsigned-long)) (maxAvailableEncodings :unsigned-long) (actualAvailableEncodings (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  TECGetMailTextEncodings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECCountMailTextEncodings" 
      ((locale :signed-integer) (numberEncodings (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ;  examine text encodings ; 
;  *  TECCountAvailableSniffers()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECGetMailTextEncodings" 
      ((locale :signed-integer) (availableEncodings (:pointer :unsigned-long)) (maxAvailableEncodings :unsigned-long) (actualAvailableEncodings (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  TECGetAvailableSniffers()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECCountAvailableSniffers" 
      ((numberOfEncodings (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  TECCreateSniffer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECGetAvailableSniffers" 
      ((availableSniffers (:pointer :unsigned-long)) (maxAvailableSniffers :unsigned-long) (actualAvailableSniffers (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  TECSniffTextEncoding()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECCreateSniffer" 
      ((encodingSniffer (:pointer :pointer)) (testEncodings (:pointer :unsigned-long)) (numTextEncodings :unsigned-long)) 
  :osstatus
   () )                                         ; 
;  *  TECDisposeSniffer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECSniffTextEncoding" 
      ((encodingSniffer :pointer) (inputBuffer (:pointer :unsigned-byte)) (inputBufferLength :unsigned-long) (testEncodings (:pointer :unsigned-long)) (numTextEncodings :unsigned-long) (numErrsArray (:pointer :unsigned-long)) (maxErrs :unsigned-long) (numFeaturesArray (:pointer :unsigned-long)) (maxFeatures :unsigned-long)) 
  :osstatus
   () )                                         ; 
;  *  TECClearSnifferContextInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TECDisposeSniffer" 
      ((encodingSniffer :pointer)) 
  :osstatus
   () )                                         ; $IFC CALL_NOT_IN_CARBON ; 
;  *  TECSetBasicOptions()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in TextEncodingConverter 1.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TECClearSnifferContextInfo" 
      ((encodingSniffer :pointer)) 
  :osstatus
   () )
(deftrap-inline "_TECSetBasicOptions" 
      ((encodingConverter :pointer) (controlFlags :unsigned-long)) 
  :osstatus
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := TextEncodingConverterIncludes

; $ENDC                                         ; __TEXTENCODINGCONVERTER__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'TextEncodingConverter)