(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:ToolUtils.p"
; at Wednesday May 1,2002 2:40:04 pm.
; 
;      File:       ToolUtils.p
;  
;      Contains:   Toolbox Utilities Interfaces.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1990-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __TOOLUTILS__
; $SETC __TOOLUTILS__ := 1

; $I+
; $SETC ToolUtilsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FIXMATH__
|#

(require-interface 'FixMath)
#|                                              ; $I FixMath.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __TEXTUTILS__
|#

(require-interface 'TextUtils)
#|                                              ; $I TextUtils.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __ICONS__
|#

(require-interface 'Icons)
#|                                              ; $I Icons.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
; 
;     Note: 
;     
;     The following routines that used to be in this header file, have moved to
;     more appropriate headers.  
;     
;         FixMath.h:      FixMul
;                         FixRatio
;                         FixRound
;         
;         Icons.h:        GetIcon
;                         PlotIcon
;                         
;         Quickdraw.h:    AngleFromSlope
;                         DeltaPoint
;                         GetCursor
;                         GetIndPattern
;                         GetPattern
;                         GetPicture
;                         PackBits
;                         ScreenRes
;                         ShieldCursor
;                         SlopeFromAngle
;                         UnpackBits
;                         
;         TextUtils.h:    Munger
;                         GetIndString
;                         GetString
;                         NewString
;                         SetString
; 
; 

; 
;  *  BitTst()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_BitTst" 
      ((bytePtr :pointer) (bitNum :signed-long))
   (:stack :boolean)
   (:stack-trap #xA85D))

; 
;  *  BitSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_BitSet" 
      ((bytePtr :pointer) (bitNum :signed-long))
   nil
   (:stack-trap #xA85E))

; 
;  *  BitClr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_BitClr" 
      ((bytePtr :pointer) (bitNum :signed-long))
   nil
   (:stack-trap #xA85F))

; 
;  *  BitAnd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_BitAnd" 
      ((value1 :signed-long) (value2 :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA858))

; 
;  *  BitOr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_BitOr" 
      ((value1 :signed-long) (value2 :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA85B))

; 
;  *  BitXor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_BitXor" 
      ((value1 :signed-long) (value2 :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA859))

; 
;  *  BitNot()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_BitNot" 
      ((value :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA85A))

; 
;  *  BitShift()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_BitShift" 
      ((value :signed-long) (count :signed-integer))
   (:stack :signed-long)
   (:stack-trap #xA85C))

#|                                              ; $IFC TARGET_CPU_68K 

(def-mactype :int64bitptr (find-mactype '(:pointer :int64bit)))
(defrecord Int64Bit 
   (hiLong :signed-long)
   (loLong :unsigned-long)
   )

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  LongMul()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_LongMul" 
      ((a :signed-long) (b :signed-long) (result (:pointer :int64bit)))
   nil
   (:stack-trap #xA867))

; $ENDC                                         ; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC; TARGET_CPU_68K

; 
;    HiWord and LoWord are not in Carbon, but Metrowerks 
;    supplies an implementation on PPC
; 
; 
;  *  HiWord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib H.a.c.k and later
;  *    Mac OS X:         not available
;  

(deftrap "_HiWord" 
      ((x :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA86A))

; 
;  *  LoWord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib H.a.c.k and later
;  *    Mac OS X:         not available
;  

(deftrap "_LoWord" 
      ((x :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA86B))

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := ToolUtilsIncludes

; $ENDC                                         ; __TOOLUTILS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'ToolUtils)#|
; Warning: Did not recognize these types or records: (int64bit)
|#