(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:TranslationExtensions.p"
; at Wednesday May 1,2002 2:41:01 pm.
; 
;      File:       TranslationExtensions.p
;  
;      Contains:   Macintosh Easy Open Translation Extension Interfaces.
;  
;      Version:    Technology: Macintosh Easy Open 1.1
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1989-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __TRANSLATIONEXTENSIONS__
; $SETC __TRANSLATIONEXTENSIONS__ := 1

; $I+
; $SETC TranslationExtensionsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __COMPONENTS__
|#

(require-interface 'Components)
#|                                              ; $I Components.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $kSupportsFileTranslation 1)
(defconstant $kSupportsScrapTranslation 2)
(defconstant $kTranslatorCanGenerateFilename 4)

; 	****************************************************************************************	
;   better names for 4-char codes 

(def-mactype :filetype (find-mactype ':ostype))
(def-mactype :scraptype (find-mactype ':ostype))
; 	****************************************************************************************	
(def-mactype :translationattributes (find-mactype ':unsigned-long))

(defconstant $taDstDocNeedsResourceFork 1)
(defconstant $taDstIsAppTranslation 2)

; 	****************************************************************************************	

(def-mactype :filetypespecptr (find-mactype '(:pointer :filetypespec)))
(defrecord FileTypeSpec 
   (format :ostype)
   (hint :signed-long)
   (flags :unsigned-long)                       ;   taDstDocNeedsResourceFork, taDstIsAppTranslation 
   (catInfoType :ostype)
   (catInfoCreator :ostype)
   )

(def-mactype :filetranslationlistptr (find-mactype '(:pointer :filetranslationlist)))
(defrecord FileTranslationList 
   (modDate :unsigned-long)
   (groupCount :unsigned-long)
;   conceptual declarations: 
;      unsigned long group1SrcCount; 
;      unsigned long group1SrcEntrySize = sizeof(FileTypeSpec); 
;    FileTypeSpec  group1SrcTypes[group1SrcCount] 
;    unsigned long group1DstCount; 
;    unsigned long group1DstEntrySize = sizeof(FileTypeSpec); 
;    FileTypeSpec  group1DstTypes[group1DstCount] 
   )

(def-mactype :filetranslationlisthandle (find-mactype '(:handle :filetranslationlist)))
; 	****************************************************************************************	
(def-mactype :scraptypespecptr (find-mactype '(:pointer :scraptypespec)))
(defrecord ScrapTypeSpec 
   (format :ostype)
   (hint :signed-long)
   )

(def-mactype :scraptranslationlistptr (find-mactype '(:pointer :scraptranslationlist)))
(defrecord ScrapTranslationList 
   (modDate :unsigned-long)
   (groupCount :unsigned-long)
;   conceptual declarations: 
;      unsigned long     group1SrcCount; 
;      unsigned long     group1SrcEntrySize = sizeof(ScrapTypeSpec); 
;    ScrapTypeSpec     group1SrcTypes[group1SrcCount] 
;    unsigned long     group1DstCount; 
;      unsigned long     group1DstEntrySize = sizeof(ScrapTypeSpec); 
;    ScrapTypeSpec     group1DstTypes[group1DstCount] 
   )

(def-mactype :scraptranslationlisthandle (find-mactype '(:handle :scraptranslationlist)))
; 	******************************************************************************************
; 	
; 	    definition of callbacks to update progress dialog
; 	
; 	******************************************************************************************	
(def-mactype :translationrefnum (find-mactype ':signed-long))
; 	******************************************************************************************
; 	
; 	    This routine sets the advertisement in the top half of the progress dialog.
; 	    It is called once at the beginning of your DoTranslateFile routine.
; 	
; 	    Enter   :   refNum          Translation reference supplied to DoTranslateFile.
; 	                advertisement   A handle to the picture to display.  This must be non-purgable.
; 	                                Before returning from DoTranslateFile, you should dispose
; 	                                of the memory.  (Normally, it is in the temp translation heap
; 	                                so it is cleaned up for you.)
; 	
; 	    Exit    :   returns         noErr, paramErr, or memFullErr
; 	
; 	******************************************************************************************	
; 
; 	 *  SetTranslationAdvertisement()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in Translation 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 thru 1.0.2
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_SetTranslationAdvertisement" 
      ((refNum :signed-long) (advertisement (:handle :picture)))
   (:stack :signed-integer)
   (:stack-trap #xABFC :d0 2 refNum advertisement))

; ******************************************************************************************
; 
;     This routine updates the progress bar in the progress dialog.
;     It is called repeatedly from within your DoTranslateFile routine.
;     It should be called often, so that the user will get feedback if
;     he tries to cancel.
; 
;     Enter   :   refNum      translation reference supplied to DoTranslateFile.
;                 progress    percent complete (0-100)
; 
;     Exit    :   canceled    TRUE if the user clicked the Cancel button, FALSE otherwise
; 
;     Return  :   noErr, paramErr, or memFullErr
; 
; ******************************************************************************************
; 
;  *  UpdateTranslationProgress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in Translation 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 thru 1.0.2
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_UpdateTranslationProgress" 
      ((refNum :signed-long) (percentDone :signed-integer) (canceled (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xABFC :d0 1 refNum percentDone canceled))

; ******************************************************************************************
; 
;     Component Manager component selectors for translation extension routines
; 
; ******************************************************************************************

(defconstant $kTranslateGetFileTranslationList 0)
(defconstant $kTranslateIdentifyFile 1)
(defconstant $kTranslateTranslateFile 2)
(defconstant $kTranslateGetTranslatedFilename 3)
(defconstant $kTranslateGetScrapTranslationList 10)
(defconstant $kTranslateIdentifyScrap 11)
(defconstant $kTranslateTranslateScrap 12)
(defconstant $kTranslateGetScrapTranslationListConsideringData 13)

; 	******************************************************************************************
; 	
; 	    routines which implement translation extensions
; 	
; 	******************************************************************************************	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DoGetFileTranslationListProcPtr = FUNCTION(self: ComponentInstance; translationList: FileTranslationListHandle): ComponentResult;

|#
 |#                                             ; $ELSEC
(def-mactype :dogetfiletranslationlistprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DoIdentifyFileProcPtr = FUNCTION(self: ComponentInstance; {CONST}VAR theDocument: FSSpec; VAR docType: FileType): ComponentResult;

|#
 |#                                             ; $ELSEC
(def-mactype :doidentifyfileprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DoTranslateFileProcPtr = FUNCTION(self: ComponentInstance; refNum: TranslationRefNum; {CONST}VAR sourceDocument: FSSpec; srcType: FileType; srcTypeHint: LONGINT; {CONST}VAR dstDoc: FSSpec; dstType: FileType; dstTypeHint: LONGINT): ComponentResult;

|#
 |#                                             ; $ELSEC
(def-mactype :dotranslatefileprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DoGetTranslatedFilenameProcPtr = FUNCTION(self: ComponentInstance; dstType: FileType; dstTypeHint: LONGINT; VAR theDocument: FSSpec): ComponentResult;

|#
 |#                                             ; $ELSEC
(def-mactype :dogettranslatedfilenameprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DoGetScrapTranslationListProcPtr = FUNCTION(self: ComponentInstance; list: ScrapTranslationListHandle): ComponentResult;

|#
 |#                                             ; $ELSEC
(def-mactype :dogetscraptranslationlistprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DoIdentifyScrapProcPtr = FUNCTION(self: ComponentInstance; dataPtr: UNIV Ptr; dataLength: Size; VAR dataFormat: ScrapType): ComponentResult;

|#
 |#                                             ; $ELSEC
(def-mactype :doidentifyscrapprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DoTranslateScrapProcPtr = FUNCTION(self: ComponentInstance; refNum: TranslationRefNum; srcDataPtr: UNIV Ptr; srcDataLength: Size; srcType: ScrapType; srcTypeHint: LONGINT; dstData: Handle; dstType: ScrapType; dstTypeHint: LONGINT): ComponentResult;

|#
 |#                                             ; $ELSEC
(def-mactype :dotranslatescrapprocptr (find-mactype ':pointer))
; $ENDC

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := TranslationExtensionsIncludes

; $ENDC                                         ; __TRANSLATIONEXTENSIONS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'TranslationExtensions)