(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:UnicodeConverter.p"
; at Wednesday May 1,2002 2:40:06 pm.
; 
;      File:       UnicodeConverter.p
;  
;      Contains:   Types, constants, and prototypes for Unicode Converter
;  
;      Version:    Technology: Mac OS 9.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1994-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __UNICODECONVERTER__
; $SETC __UNICODECONVERTER__ := 1

; $I+
; $SETC UnicodeConverterIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __TEXTCOMMON__
|#

(require-interface 'TextCommon)
#|                                              ; $I TextCommon.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  Unicode conversion contexts: 

(def-mactype :texttounicodeinfo (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :texttounicodeinfoptr (find-mactype '(:pointer :pointer)));  when a VAR xx:TextToUnicodeInfo parameter can be nil, it is changed to xx: TextToUnicodeInfoPtr 
(def-mactype :unicodetotextinfo (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :unicodetotextinfoptr (find-mactype '(:pointer :pointer)));  when a VAR xx:UnicodeToTextInfo parameter can be nil, it is changed to xx: UnicodeToTextInfoPtr 
(def-mactype :unicodetotextruninfo (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :unicodetotextruninfoptr (find-mactype '(:pointer :pointer)));  when a VAR xx:UnicodeToTextRunInfo parameter can be nil, it is changed to xx: UnicodeToTextRunInfoPtr 
(def-mactype :consttexttounicodeinfo (find-mactype ':pointer))
(def-mactype :constunicodetotextinfo (find-mactype ':pointer))
; 	 UnicodeMapVersion type & values 	
(def-mactype :unicodemapversion (find-mactype ':signed-long))

(defconstant $kUnicodeUseLatestMapping -1)
(defconstant $kUnicodeUseHFSPlusMapping 4)

; 	 Types used in conversion 	

(def-mactype :unicodemappingptr (find-mactype '(:pointer :unicodemapping)))
(defrecord UnicodeMapping 
   (unicodeEncoding :unsigned-long)
   (otherEncoding :unsigned-long)
   (mappingVersion :signed-long)
   )

(def-mactype :constunicodemappingptr (find-mactype '(:pointer :unicodemapping)))
; 	 Control flags for ConvertFromUnicodeToText and ConvertFromTextToUnicode 	

(defconstant $kUnicodeUseFallbacksBit 0)
(defconstant $kUnicodeKeepInfoBit 1)
(defconstant $kUnicodeDirectionalityBits 2)
(defconstant $kUnicodeVerticalFormBit 4)
(defconstant $kUnicodeLooseMappingsBit 5)
(defconstant $kUnicodeStringUnterminatedBit 6)
(defconstant $kUnicodeTextRunBit 7)
(defconstant $kUnicodeKeepSameEncodingBit 8)
(defconstant $kUnicodeForceASCIIRangeBit 9)
(defconstant $kUnicodeNoHalfwidthCharsBit 10)
(defconstant $kUnicodeTextRunHeuristicsBit 11)

(defconstant $kUnicodeUseFallbacksMask #x1)
(defconstant $kUnicodeKeepInfoMask #x2)
(defconstant $kUnicodeDirectionalityMask #xC)
(defconstant $kUnicodeVerticalFormMask #x10)
(defconstant $kUnicodeLooseMappingsMask #x20)
(defconstant $kUnicodeStringUnterminatedMask #x40)
(defconstant $kUnicodeTextRunMask #x80)
(defconstant $kUnicodeKeepSameEncodingMask #x100)
(defconstant $kUnicodeForceASCIIRangeMask #x200)
(defconstant $kUnicodeNoHalfwidthCharsMask #x400)
(defconstant $kUnicodeTextRunHeuristicsMask #x800)

; 	 Values for kUnicodeDirectionality field 	
(defconstant $kUnicodeDefaultDirection 0)
(defconstant $kUnicodeLeftToRight 1)
(defconstant $kUnicodeRightToLeft 2)

; 	 Directionality masks for control flags 	
(defconstant $kUnicodeDefaultDirectionMask #x0)
(defconstant $kUnicodeLeftToRightMask #x4)
(defconstant $kUnicodeRightToLeftMask #x8)

; 	 Control flags for TruncateForUnicodeToText: 	
; 
; 	   Now TruncateForUnicodeToText uses control flags from the same set as used by
; 	   ConvertFromTextToUnicode, ConvertFromUnicodeToText, etc., but only
; 	   kUnicodeStringUnterminatedMask is meaningful for TruncateForUnicodeToText.
; 	   
; 	   Previously two special control flags were defined for TruncateForUnicodeToText:
; 	        kUnicodeTextElementSafeBit = 0
; 	        kUnicodeRestartSafeBit = 1
; 	   However, neither of these was implemented.
; 	   Instead of implementing kUnicodeTextElementSafeBit, we now use
; 	   kUnicodeStringUnterminatedMask since it accomplishes the same thing and avoids
; 	   having special flags just for TruncateForUnicodeToText
; 	   Also, kUnicodeRestartSafeBit is unnecessary, since restart-safeness is handled by
; 	   setting kUnicodeKeepInfoBit with ConvertFromUnicodeToText.
; 	   If TruncateForUnicodeToText is called with one or both of the old special control
; 	   flags set (bits 0 or 1), it will not generate a paramErr, but the old bits have no
; 	   effect on its operation.
; 	

; 	 Filter bits for filter field in QueryUnicodeMappings and CountUnicodeMappings: 	
(defconstant $kUnicodeMatchUnicodeBaseBit 0)
(defconstant $kUnicodeMatchUnicodeVariantBit 1)
(defconstant $kUnicodeMatchUnicodeFormatBit 2)
(defconstant $kUnicodeMatchOtherBaseBit 3)
(defconstant $kUnicodeMatchOtherVariantBit 4)
(defconstant $kUnicodeMatchOtherFormatBit 5)

(defconstant $kUnicodeMatchUnicodeBaseMask #x1)
(defconstant $kUnicodeMatchUnicodeVariantMask #x2)
(defconstant $kUnicodeMatchUnicodeFormatMask #x4)
(defconstant $kUnicodeMatchOtherBaseMask #x8)
(defconstant $kUnicodeMatchOtherVariantMask #x10)
(defconstant $kUnicodeMatchOtherFormatMask #x20)

; 	 Control flags for SetFallbackUnicodeToText 	
(defconstant $kUnicodeFallbackSequencingBits 0)

(defconstant $kUnicodeFallbackSequencingMask #x3)
(defconstant $kUnicodeFallbackInterruptSafeMask #x4);   To indicate that caller fallback routine doesnt move memory 

; 	 values for kUnicodeFallbackSequencing field 	
(defconstant $kUnicodeFallbackDefaultOnly 0)
(defconstant $kUnicodeFallbackCustomOnly 1)
(defconstant $kUnicodeFallbackDefaultFirst 2)
(defconstant $kUnicodeFallbackCustomFirst 3)

; 	 Caller-supplied entry point to a fallback handler 	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	UnicodeToTextFallbackProcPtr = FUNCTION(VAR iSrcUniStr: UniChar; iSrcUniStrLen: ByteCount; VAR oSrcConvLen: ByteCount; oDestStr: TextPtr; iDestStrLen: ByteCount; VAR oDestConvLen: ByteCount; iInfoPtr: LogicalAddress; iUnicodeMappingPtr: ConstUnicodeMappingPtr): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :unicodetotextfallbackprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :unicodetotextfallbackupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :unicodetotextfallbackupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppUnicodeToTextFallbackProcInfo #x3FFFF0)
; 
; 	 *  NewUnicodeToTextFallbackUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewUnicodeToTextFallbackProc 
(deftrap "_NewUnicodeToTextFallbackUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeUnicodeToTextFallbackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeUnicodeToTextFallbackUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeUnicodeToTextFallbackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallUnicodeToTextFallbackProc 
(deftrap-inline "_InvokeUnicodeToTextFallbackUPP" 
      ((iSrcUniStr (:pointer :unsigned-integer)) (iSrcUniStrLen :unsigned-long) (oSrcConvLen (:pointer :unsigned-long)) (oDestStr (:pointer :unsigned-byte)) (iDestStrLen :unsigned-long) (oDestConvLen (:pointer :unsigned-long)) (iInfoPtr :pointer) (iUnicodeMappingPtr (:pointer :unicodemapping)) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

;  Function prototypes 
#|                                              ; $IFC TARGET_CPU_68K AND NOT TARGET_RT_MAC_CFM 
; 
;     Routine to Initialize the Unicode Converter and cleanup once done with it. 
;     These routines must be called from Static Library clients.
; 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  InitializeUnicodeConverter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  TerminateUnicodeConverter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InitializeUnicodeConverter" 
      ((TECFileName (:pointer (:string 255)))) 
  :osstatus
   () )                                         ;   Note: the old names (InitializeUnicode, TerminateUnicode) for the above are still exported. 
(deftrap-inline "_TerminateUnicodeConverter" 
      () 
  nil
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC

; 
;  *  CreateTextToUnicodeInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  CreateTextToUnicodeInfoByEncoding()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CreateTextToUnicodeInfo" 
      ((iUnicodeMapping (:pointer :unicodemapping)) (oTextToUnicodeInfo (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  CreateUnicodeToTextInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CreateTextToUnicodeInfoByEncoding" 
      ((iEncoding :unsigned-long) (oTextToUnicodeInfo (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  CreateUnicodeToTextInfoByEncoding()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CreateUnicodeToTextInfo" 
      ((iUnicodeMapping (:pointer :unicodemapping)) (oUnicodeToTextInfo (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  CreateUnicodeToTextRunInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CreateUnicodeToTextInfoByEncoding" 
      ((iEncoding :unsigned-long) (oUnicodeToTextInfo (:pointer :pointer))) 
  :osstatus
   () )                                         ; CONST; 
;  *  CreateUnicodeToTextRunInfoByEncoding()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CreateUnicodeToTextRunInfo" 
      ((iNumberOfMappings :unsigned-long) (iUnicodeMappings (:pointer :unicodemapping)) (oUnicodeToTextInfo (:pointer :pointer))) 
  :osstatus
   () )                                         ; CONST; 
;  *  CreateUnicodeToTextRunInfoByScriptCode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CreateUnicodeToTextRunInfoByEncoding" 
      ((iNumberOfEncodings :unsigned-long) (iEncodings (:pointer :unsigned-long)) (oUnicodeToTextInfo (:pointer :pointer))) 
  :osstatus
   () )                                         ; CONST;  Change the TextToUnicodeInfo to another mapping. ; 
;  *  ChangeTextToUnicodeInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CreateUnicodeToTextRunInfoByScriptCode" 
      ((iNumberOfScriptCodes :unsigned-long) (iScripts (:pointer :signed-integer)) (oUnicodeToTextInfo (:pointer :pointer))) 
  :osstatus
   () )                                         ;  Change the UnicodeToTextInfo to another mapping. ; 
;  *  ChangeUnicodeToTextInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ChangeTextToUnicodeInfo" 
      ((ioTextToUnicodeInfo :pointer) (iUnicodeMapping (:pointer :unicodemapping))) 
  :osstatus
   () )                                         ; 
;  *  DisposeTextToUnicodeInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ChangeUnicodeToTextInfo" 
      ((ioUnicodeToTextInfo :pointer) (iUnicodeMapping (:pointer :unicodemapping))) 
  :osstatus
   () )                                         ; 
;  *  DisposeUnicodeToTextInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DisposeTextToUnicodeInfo" 
      ((ioTextToUnicodeInfo (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  DisposeUnicodeToTextRunInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DisposeUnicodeToTextInfo" 
      ((ioUnicodeToTextInfo (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  ConvertFromTextToUnicode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DisposeUnicodeToTextRunInfo" 
      ((ioUnicodeToTextRunInfo (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  ConvertFromUnicodeToText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ConvertFromTextToUnicode" 
      ((iTextToUnicodeInfo :pointer) (iSourceLen :unsigned-long) (iSourceStr :pointer) (iControlFlags :unsigned-long) (iOffsetCount :unsigned-long) (iOffsetArray :pointer) (oOffsetCount (:pointer :unsigned-long)) (oOffsetArray :pointer) (iOutputBufLen :unsigned-long) (oSourceRead (:pointer :unsigned-long)) (oUnicodeLen (:pointer :unsigned-long)) (oUnicodeStr (:pointer :unsigned-integer))) 
  :osstatus
   () )                                         ; CONST; 
;  *  ConvertFromUnicodeToTextRun()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ConvertFromUnicodeToText" 
      ((iUnicodeToTextInfo :pointer) (iUnicodeLen :unsigned-long) (iUnicodeStr (:pointer :unsigned-integer)) (iControlFlags :unsigned-long) (iOffsetCount :unsigned-long) (iOffsetArray :pointer) (oOffsetCount (:pointer :unsigned-long)) (oOffsetArray :pointer) (iOutputBufLen :unsigned-long) (oInputRead (:pointer :unsigned-long)) (oOutputLen (:pointer :unsigned-long)) (oOutputStr :pointer)) 
  :osstatus
   () )                                         ; CONST; 
;  *  ConvertFromUnicodeToScriptCodeRun()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ConvertFromUnicodeToTextRun" 
      ((iUnicodeToTextInfo :pointer) (iUnicodeLen :unsigned-long) (iUnicodeStr (:pointer :unsigned-integer)) (iControlFlags :unsigned-long) (iOffsetCount :unsigned-long) (iOffsetArray :pointer) (oOffsetCount (:pointer :unsigned-long)) (oOffsetArray :pointer) (iOutputBufLen :unsigned-long) (oInputRead (:pointer :unsigned-long)) (oOutputLen (:pointer :unsigned-long)) (oOutputStr :pointer) (iEncodingRunBufLen :unsigned-long) (oEncodingRunOutLen (:pointer :unsigned-long)) (oEncodingRuns (:pointer :textencodingrun))) 
  :osstatus
   () )                                         ; CONST;  Truncate a multibyte string at a safe place. ; 
;  *  TruncateForTextToUnicode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ConvertFromUnicodeToScriptCodeRun" 
      ((iUnicodeToTextInfo :pointer) (iUnicodeLen :unsigned-long) (iUnicodeStr (:pointer :unsigned-integer)) (iControlFlags :unsigned-long) (iOffsetCount :unsigned-long) (iOffsetArray :pointer) (oOffsetCount (:pointer :unsigned-long)) (oOffsetArray :pointer) (iOutputBufLen :unsigned-long) (oInputRead (:pointer :unsigned-long)) (oOutputLen (:pointer :unsigned-long)) (oOutputStr :pointer) (iScriptRunBufLen :unsigned-long) (oScriptRunOutLen (:pointer :unsigned-long)) (oScriptCodeRuns (:pointer :scriptcoderun))) 
  :osstatus
   () )                                         ;  Truncate a Unicode string at a safe place. ; 
;  *  TruncateForUnicodeToText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TruncateForTextToUnicode" 
      ((iTextToUnicodeInfo :pointer) (iSourceLen :unsigned-long) (iSourceStr :pointer) (iMaxLen :unsigned-long) (oTruncatedLen (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; CONST;  Convert a Pascal string to Unicode string. ; 
;  *  ConvertFromPStringToUnicode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TruncateForUnicodeToText" 
      ((iUnicodeToTextInfo :pointer) (iSourceLen :unsigned-long) (iSourceStr (:pointer :unsigned-integer)) (iControlFlags :unsigned-long) (iMaxLen :unsigned-long) (oTruncatedLen (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ;  Convert a Unicode string to Pascal string. ; 
;  *  ConvertFromUnicodeToPString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ConvertFromPStringToUnicode" 
      ((iTextToUnicodeInfo :pointer) (iPascalStr (:string 255)) (iOutputBufLen :unsigned-long) (oUnicodeLen (:pointer :unsigned-long)) (oUnicodeStr (:pointer :unsigned-integer))) 
  :osstatus
   () )                                         ; CONST;  Count the available conversion mappings. ; 
;  *  CountUnicodeMappings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ConvertFromUnicodeToPString" 
      ((iUnicodeToTextInfo :pointer) (iUnicodeLen :unsigned-long) (iUnicodeStr (:pointer :unsigned-integer)) (oPascalStr (:pointer (:string 255)))) 
  :osstatus
   () )                                         ;  Get a list of the available conversion mappings. ; 
;  *  QueryUnicodeMappings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CountUnicodeMappings" 
      ((iFilter :unsigned-long) (iFindMapping (:pointer :unicodemapping)) (oActualCount (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ;  Setup the fallback handler for converting Unicode To Text. ; 
;  *  SetFallbackUnicodeToText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_QueryUnicodeMappings" 
      ((iFilter :unsigned-long) (iFindMapping (:pointer :unicodemapping)) (iMaxCount :unsigned-long) (oActualCount (:pointer :unsigned-long)) (oReturnedMappings (:pointer :unicodemapping))) 
  :osstatus
   () )                                         ;  Setup the fallback handler for converting Unicode To TextRuns. ; 
;  *  SetFallbackUnicodeToTextRun()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetFallbackUnicodeToText" 
      ((iUnicodeToTextInfo :pointer) (iFallback :pointer) (iControlFlags :unsigned-long) (iInfoPtr :pointer)) 
  :osstatus
   () )                                         ;  Re-initialize all state information kept by the context objects. ; 
;  *  ResetTextToUnicodeInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.3 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetFallbackUnicodeToTextRun" 
      ((iUnicodeToTextRunInfo :pointer) (iFallback :pointer) (iControlFlags :unsigned-long) (iInfoPtr :pointer)) 
  :osstatus
   () )                                         ;  Re-initialize all state information kept by the context objects. ; 
;  *  ResetUnicodeToTextInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ResetTextToUnicodeInfo" 
      ((ioTextToUnicodeInfo :pointer)) 
  :osstatus
   () )                                         ;  Re-initialize all state information kept by the context objects in TextRun conversions. ; 
;  *  ResetUnicodeToTextRunInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in UnicodeConverter 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ResetUnicodeToTextInfo" 
      ((ioUnicodeToTextInfo :pointer)) 
  :osstatus
   () )                                         ; $ALIGN RESET; $POP; $SETC UsingIncludes := UnicodeConverterIncludes
(deftrap-inline "_ResetUnicodeToTextRunInfo" 
      ((ioUnicodeToTextRunInfo :pointer)) 
  :osstatus
   () )                                         ; $ENDC; __UNICODECONVERTER__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'UnicodeConverter)