(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Video.p"
; at Wednesday May 1,2002 2:40:33 pm.
; 
;      File:       Video.p
;  
;      Contains:   Video Driver Interfaces.
;  
;      Version:    Technology: System 9.X
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1986-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __VIDEO__
; $SETC __VIDEO__ := 1

; $I+
; $SETC VideoIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __NAMEREGISTRY__
|#

(require-interface 'NameRegistry)
#|                                              ; $I NameRegistry.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $mBaseOffset 1)                    ;  Id of mBaseOffset. 
(defconstant $mRowBytes 2)                      ;  Video sResource parameter Id's  
(defconstant $mBounds 3)                        ;  Video sResource parameter Id's  
(defconstant $mVersion 4)                       ;  Video sResource parameter Id's  
(defconstant $mHRes 5)                          ;  Video sResource parameter Id's  
(defconstant $mVRes 6)                          ;  Video sResource parameter Id's  
(defconstant $mPixelType 7)                     ;  Video sResource parameter Id's  
(defconstant $mPixelSize 8)                     ;  Video sResource parameter Id's  
(defconstant $mCmpCount 9)                      ;  Video sResource parameter Id's  
(defconstant $mCmpSize 10)                      ;  Video sResource parameter Id's  
(defconstant $mPlaneBytes 11)                   ;  Video sResource parameter Id's  
(defconstant $mVertRefRate 14)                  ;  Video sResource parameter Id's  
(defconstant $mVidParams 1)                     ;  Video parameter block id. 
(defconstant $mTable 2)                         ;  Offset to the table. 
(defconstant $mPageCnt 3)                       ;  Number of pages 
(defconstant $mDevType 4)                       ;  Device Type 
(defconstant $oneBitMode 128)                   ;  Id of OneBitMode Parameter list. 
(defconstant $twoBitMode 129)                   ;  Id of TwoBitMode Parameter list. 
(defconstant $fourBitMode 130)                  ;  Id of FourBitMode Parameter list. 
(defconstant $eightBitMode 131)                 ;  Id of EightBitMode Parameter list. 

(defconstant $sixteenBitMode 132)               ;  Id of SixteenBitMode Parameter list. 
(defconstant $thirtyTwoBitMode 133)             ;  Id of ThirtyTwoBitMode Parameter list. 
(defconstant $firstVidMode 128)                 ;  The new, better way to do the above.  
(defconstant $secondVidMode 129)                ;   QuickDraw only supports six video  
(defconstant $thirdVidMode 130)                 ;   at this time.       
(defconstant $fourthVidMode 131)
(defconstant $fifthVidMode 132)
(defconstant $sixthVidMode 133)
(defconstant $spGammaDir 64)
(defconstant $spVidNamesDir 65)

; 	 csTimingFormat values in VDTimingInfo 	
; 	 look in the declaration rom for timing info 	
(defconstant $kDeclROMtables :|decl|)
(defconstant $kDetailedTimingFormat :|arba|)    ;   Timing is a detailed timing 

; 	 Size of a block of EDID (Extended Display Identification Data) 	
(defconstant $kDDCBlockSize 128)

;   ddcBlockType constants 
(defconstant $kDDCBlockTypeEDID 0)              ;   EDID block type.  

;   ddcFlags constants 
(defconstant $kDDCForceReadBit 0)               ;   Force a new read of the EDID.  
(defconstant $kDDCForceReadMask #x1)            ;   Mask for kddcForceReadBit.  

; 	 Timing mode constants for Display Manager MultiMode support
; 	    Corresponding   .h equates are in Video.h
; 	                    .a equates are in Video.a
; 	                    .r equates are in DepVideoEqu.r
; 	    
; 	    The second enum is the old names (for compatibility).
; 	    The first enum is the new names.
; 		
(defconstant $timingInvalid 0)                  ;      Unknown timing force user to confirm.  
(defconstant $timingInvalid_SM_T24 8)           ;      Work around bug in SM Thunder24 card. 
(defconstant $timingApple_FixedRateLCD 42)      ;      Lump all fixed-rate LCDs into one category. 
(defconstant $timingApple_512x384_60hz 130)     ;    512x384  (60 Hz) Rubik timing.  
(defconstant $timingApple_560x384_60hz 135)     ;    560x384  (60 Hz) Rubik-560 timing.  
(defconstant $timingApple_640x480_67hz 140)     ;    640x480  (67 Hz) HR timing.  
(defconstant $timingApple_640x400_67hz 145)     ;    640x400  (67 Hz) HR-400 timing.  
(defconstant $timingVESA_640x480_60hz 150)      ;    640x480  (60 Hz) VGA timing.  
(defconstant $timingVESA_640x480_72hz 152)      ;    640x480  (72 Hz) VGA timing.  
(defconstant $timingVESA_640x480_75hz 154)      ;    640x480  (75 Hz) VGA timing.  
(defconstant $timingVESA_640x480_85hz 158)      ;    640x480  (85 Hz) VGA timing.  
(defconstant $timingGTF_640x480_120hz 159)      ;    640x480  (120 Hz) VESA Generalized Timing Formula  
(defconstant $timingApple_640x870_75hz 160)     ;    640x870  (75 Hz) FPD timing. 
(defconstant $timingApple_640x818_75hz 165)     ;    640x818  (75 Hz) FPD-818 timing. 
(defconstant $timingApple_832x624_75hz 170)     ;    832x624  (75 Hz) GoldFish timing. 
(defconstant $timingVESA_800x600_56hz 180)      ;    800x600  (56 Hz) SVGA timing.  
(defconstant $timingVESA_800x600_60hz 182)      ;    800x600  (60 Hz) SVGA timing.  
(defconstant $timingVESA_800x600_72hz 184)      ;    800x600  (72 Hz) SVGA timing.  
(defconstant $timingVESA_800x600_75hz 186)      ;    800x600  (75 Hz) SVGA timing.  
(defconstant $timingVESA_800x600_85hz 188)      ;    800x600  (85 Hz) SVGA timing.  
(defconstant $timingVESA_1024x768_60hz 190)     ;   1024x768  (60 Hz) VESA 1K-60Hz timing.  
(defconstant $timingVESA_1024x768_70hz 200)     ;   1024x768  (70 Hz) VESA 1K-70Hz timing.  
(defconstant $timingVESA_1024x768_75hz 204)     ;   1024x768  (75 Hz) VESA 1K-75Hz timing (very similar to timingApple_1024x768_75hz).  
(defconstant $timingVESA_1024x768_85hz 208)     ;   1024x768  (85 Hz) VESA timing.  
(defconstant $timingApple_1024x768_75hz 210)    ;   1024x768  (75 Hz) Apple 19" RGB.  
(defconstant $timingApple_1152x870_75hz 220)    ;   1152x870  (75 Hz) Apple 21" RGB.  
(defconstant $timingAppleNTSC_ST 230)           ;    512x384  (60 Hz, interlaced, non-convolved).  
(defconstant $timingAppleNTSC_FF 232)           ;    640x480  (60 Hz, interlaced, non-convolved).  
(defconstant $timingAppleNTSC_STconv 234)       ;    512x384  (60 Hz, interlaced, convolved).  
(defconstant $timingAppleNTSC_FFconv 236)       ;    640x480  (60 Hz, interlaced, convolved).  
(defconstant $timingApplePAL_ST 238)            ;    640x480  (50 Hz, interlaced, non-convolved).  
(defconstant $timingApplePAL_FF 240)            ;    768x576  (50 Hz, interlaced, non-convolved).  
(defconstant $timingApplePAL_STconv 242)        ;    640x480  (50 Hz, interlaced, convolved).  
(defconstant $timingApplePAL_FFconv 244)        ;    768x576  (50 Hz, interlaced, convolved).  
(defconstant $timingVESA_1280x960_75hz 250)     ;   1280x960  (75 Hz)  
(defconstant $timingVESA_1280x960_60hz 252)     ;   1280x960  (60 Hz)  
(defconstant $timingVESA_1280x960_85hz 254)     ;   1280x960  (85 Hz)  
(defconstant $timingVESA_1280x1024_60hz 260)    ;   1280x1024 (60 Hz)  
(defconstant $timingVESA_1280x1024_75hz 262)    ;   1280x1024 (75 Hz)  
(defconstant $timingVESA_1280x1024_85hz 268)    ;   1280x1024 (85 Hz)  
(defconstant $timingVESA_1600x1200_60hz 280)    ;   1600x1200 (60 Hz) VESA timing.  
(defconstant $timingVESA_1600x1200_65hz 282)    ;   1600x1200 (65 Hz) VESA timing.  
(defconstant $timingVESA_1600x1200_70hz 284)    ;   1600x1200 (70 Hz) VESA timing.  
(defconstant $timingVESA_1600x1200_75hz 286)    ;   1600x1200 (75 Hz) VESA timing (pixel clock is 189.2 Mhz dot clock).  
(defconstant $timingVESA_1600x1200_80hz 288)    ;   1600x1200 (80 Hz) VESA timing (pixel clock is 216>? Mhz dot clock) - proposed only.  
(defconstant $timingVESA_1600x1200_85hz 289)    ;   1600x1200 (85 Hz) VESA timing (pixel clock is 229.5 Mhz dot clock).  
(defconstant $timingVESA_1792x1344_60hz 296)    ;   1792x1344 (60 Hz) VESA timing (204.75 Mhz dot clock).  
(defconstant $timingVESA_1792x1344_75hz 298)    ;   1792x1344 (75 Hz) VESA timing (261.75 Mhz dot clock).  
(defconstant $timingVESA_1856x1392_60hz 300)    ;   1856x1392 (60 Hz) VESA timing (218.25 Mhz dot clock).  
(defconstant $timingVESA_1856x1392_75hz 302)    ;   1856x1392 (75 Hz) VESA timing (288 Mhz dot clock).  
(defconstant $timingVESA_1920x1440_60hz 304)    ;   1920x1440 (60 Hz) VESA timing (234 Mhz dot clock).  
(defconstant $timingVESA_1920x1440_75hz 306)    ;   1920x1440 (75 Hz) VESA timing (297 Mhz dot clock).  
(defconstant $timingSMPTE240M_60hz 400)         ;   60Hz V, 33.75KHz H, interlaced timing, 16:9 aspect, typical resolution of 1920x1035.  
(defconstant $timingFilmRate_48hz 410)          ;   48Hz V, 25.20KHz H, non-interlaced timing, typical resolution of 640x480.  
(defconstant $timingSony_1600x1024_76hz 500)    ;   1600x1024 (76 Hz) Sony timing (pixel clock is 170.447 Mhz dot clock).  
(defconstant $timingSony_1920x1080_60hz 510)    ;   1920x1080 (60 Hz) Sony timing (pixel clock is 159.84 Mhz dot clock).  
(defconstant $timingSony_1920x1080_72hz 520)    ;   1920x1080 (72 Hz) Sony timing (pixel clock is 216.023 Mhz dot clock).  
(defconstant $timingSony_1920x1200_76hz 540)    ;   1900x1200 (76 Hz) Sony timing (pixel clock is 243.20 Mhz dot clock).  
(defconstant $timingApple_0x0_0hz_Offline 550)  ;   Indicates that this timing will take the display off-line and remove it from the system.  

;   Deprecated timing names. 
(defconstant $timingApple12 130)
(defconstant $timingApple12x 135)
(defconstant $timingApple13 140)
(defconstant $timingApple13x 145)
(defconstant $timingAppleVGA 150)
(defconstant $timingApple15 160)
(defconstant $timingApple15x 165)
(defconstant $timingApple16 170)
(defconstant $timingAppleSVGA 180)
(defconstant $timingApple1Ka 190)
(defconstant $timingApple1Kb 200)
(defconstant $timingApple19 210)
(defconstant $timingApple21 220)
(defconstant $timingSony_1900x1200_74hz 530)    ;   1900x1200 (74 Hz) Sony timing (pixel clock is 236.25 Mhz dot clock).  
(defconstant $timingSony_1900x1200_76hz 540)    ;   1900x1200 (76 Hz) Sony timing (pixel clock is 245.48 Mhz dot clock).  

; 	 csConnectFlags values in VDDisplayConnectInfo 	
(defconstant $kAllModesValid 0)                 ;   All modes not trimmed by primary init are good close enough to try  
(defconstant $kAllModesSafe 1)                  ;   All modes not trimmed by primary init are know to be safe  
(defconstant $kReportsTagging 2)                ;   Can detect tagged displays (to identify smart monitors)  
(defconstant $kHasDirectConnection 3)           ;   True implies that driver can talk directly to device (e.g. serial data link via sense lines)  
(defconstant $kIsMonoDev 4)                     ;   Says whether theres an RGB (0) or Monochrome (1) connection.  
(defconstant $kUncertainConnection 5)           ;   There may not be a display (no sense lines?).  
(defconstant $kTaggingInfoNonStandard 6)        ;   Set when csConnectTaggedType/csConnectTaggedData are non-standard (i.e., not the Apple CRT sense codes).  
(defconstant $kReportsDDCConnection 7)          ;   Card can do ddc (set kHasDirectConnect && kHasDDCConnect if you actually found a ddc display).  
(defconstant $kHasDDCConnection 8)              ;   Card has ddc connect now.  
(defconstant $kConnectionInactive 9)            ;   Set when the connection is NOT currently active (generally used in a multiconnection environment).  
(defconstant $kDependentConnection 10)          ;   Set when some ascpect of THIS connection depends on another (will generally be set in a kModeSimulscan environment).  
(defconstant $kBuiltInConnection 11)            ;   Set when connection is KNOWN to be built-in (this is not the same as kHasDirectConnection).  
(defconstant $kOverrideConnection 12)           ;   Set when the reported connection is not the true one, but is one that has been forced through a SetConnection call  
(defconstant $kFastCheckForDDC 13)              ;   Set when all 3 are true: 1) sense codes indicate DDC display could be attached 2) attempted fast check 3) DDC failed  
(defconstant $kReportsHotPlugging 14)           ;   Detects and reports hot pluggging on connector (via VSL also implies DDC will be up to date w/o force read)  

; 	 csDisplayType values in VDDisplayConnectInfo 	
(defconstant $kUnknownConnect 1)                ;   Not sure how well use this, but seems like a good idea.  
(defconstant $kPanelConnect 2)                  ;   For use with fixed-in-place LCD panels.  
(defconstant $kPanelTFTConnect 2)               ;   Alias for kPanelConnect  
(defconstant $kFixedModeCRTConnect 3)           ;    For use with fixed-mode (i.e., very limited range) displays.  
(defconstant $kMultiModeCRT1Connect 4)          ;   320x200 maybe, 12" maybe, 13" (default), 16" certain, 19" maybe, 21" maybe  
(defconstant $kMultiModeCRT2Connect 5)          ;   320x200 maybe, 12" maybe, 13" certain, 16" (default), 19" certain, 21" maybe  
(defconstant $kMultiModeCRT3Connect 6)          ;   320x200 maybe, 12" maybe, 13" certain, 16" certain, 19" default, 21" certain  
(defconstant $kMultiModeCRT4Connect 7)          ;   Expansion to large multi mode (not yet used)  
(defconstant $kModelessConnect 8)               ;   Expansion to modeless model (not yet used)  
(defconstant $kFullPageConnect 9)               ;   640x818 (to get 8bpp in 512K case) and 640x870 (these two only)  
(defconstant $kVGAConnect 10)                   ;   640x480 VGA default -- question everything else  
(defconstant $kNTSCConnect 11)                  ;   NTSC ST (default), FF, STconv, FFconv  
(defconstant $kPALConnect 12)                   ;   PAL ST (default), FF, STconv, FFconv  
(defconstant $kHRConnect 13)                    ;   Straight-6 connect -- 640x480 and 640x400 (to get 8bpp in 256K case) (these two only)  
(defconstant $kPanelFSTNConnect 14)             ;   For use with fixed-in-place LCD FSTN (aka Supertwist) panels  
(defconstant $kMonoTwoPageConnect 15)           ;   1152x870 Apple color two-page display  
(defconstant $kColorTwoPageConnect 16)          ;   1152x870 Apple B&W two-page display  
(defconstant $kColor16Connect 17)               ;   832x624 Apple B&W two-page display  
(defconstant $kColor19Connect 18)               ;   1024x768 Apple B&W two-page display  
(defconstant $kGenericCRT 19)                   ;   Indicates nothing except that connection is CRT in nature.  
(defconstant $kGenericLCD 20)                   ;   Indicates nothing except that connection is LCD in nature.  
(defconstant $kDDCConnect 21)                   ;   DDC connection, always set kHasDDCConnection  
(defconstant $kNoConnect 22)                    ;   No display is connected - load sensing or similar level of hardware detection is assumed (used by resident drivers that support hot plugging when nothing is currently connected)  

; 	 csTimingFlags values in VDTimingInfoRec 	
(defconstant $kModeValid 0)                     ;   Says that this mode should NOT be trimmed.  
(defconstant $kModeSafe 1)                      ;   This mode does not need confirmation  
(defconstant $kModeDefault 2)                   ;   This is the default mode for this type of connection  
(defconstant $kModeShowNow 3)                   ;   This mode should always be shown (even though it may require a confirm)  
(defconstant $kModeNotResize 4)                 ;   This mode should not be used to resize the display (eg. mode selects a different connector on card)  
(defconstant $kModeRequiresPan 5)               ;   This mode has more pixels than are actually displayed  
(defconstant $kModeInterlaced 6)                ;   This mode is interlaced (single pixel lines look bad).  
(defconstant $kModeShowNever 7)                 ;   This mode should not be shown in the user interface.  
(defconstant $kModeSimulscan 8)                 ;   Indicates that more than one display connection can be driven from a single framebuffer controller.  
(defconstant $kModeNotPreset 9)                 ;   Indicates that the timing is not a factory preset for the current display (geometry may need correction)  
(defconstant $kModeBuiltIn 10)                  ;   Indicates that the display mode is for the built-in connect only (on multiconnect devices like the PB 3400) Only the driver is quieried  
(defconstant $kModeStretched 11)                ;   Indicates that the display mode will be stretched/distorted to match the display aspect ratio  
(defconstant $kModeNotGraphicsQuality 12)       ;   Indicates that the display mode is not the highest quality (eg. stretching artifacts).  Intended as a hint  

; 	 csDepthFlags in VDVideoParametersInfoRec 	
(defconstant $kDepthDependent 0)                ;   Says that this depth mode may cause dependent changes in other framebuffers (and .  

; 	 csResolutionFlags bit flags for VDResolutionInfoRec 	
(defconstant $kResolutionHasMultipleDepthSizes 0);   Says that this mode has different csHorizontalPixels, csVerticalLines at different depths (usually slightly larger at lower depths)  

;      Power Mode constants for VDPowerStateRec.powerState.  Note the numeric order does not match the power state order  
(defconstant $kAVPowerOff 0)
(defconstant $kAVPowerStandby 1)
(defconstant $kAVPowerSuspend 2)
(defconstant $kAVPowerOn 3)
(defconstant $kHardwareSleep 128)
(defconstant $kHardwareWake 129)
(defconstant $kHardwareWakeFromSuspend 130)
(defconstant $kHardwareWakeToDoze 131)
(defconstant $kHardwareWakeToDozeFromSuspend 132)
(defconstant $kHardwarePark 133)
(defconstant $kHardwareDrive 134)

;      Power Mode masks and bits for VDPowerStateRec.powerFlags.   
(defconstant $kPowerStateNeedsRefresh 0)        ;   When leaving this power mode, a display will need refreshing    
(defconstant $kPowerStateSleepAwareBit 1)       ;   if gestaltPCCardDockingSelectorFix, Docking mgr checks this bit before checking kPowerStateSleepAllowedBit  
(defconstant $kPowerStateSleepForbiddenBit 2)   ;   if kPowerStateSleepAwareBit, Docking mgr checks this bit before sleeping  
(defconstant $kPowerStateSleepCanPowerOffBit 3) ;   supports power down sleep (ie PCI power off) 
(defconstant $kPowerStateSleepNoDPMSBit 4)      ;   Bug #2425210.  Do not use DPMS with this display. 
(defconstant $kPowerStateSleepWaketoDozeBit 5)  ;   Supports Wake to Doze  
(defconstant $kPowerStateNeedsRefreshMask #x1)
(defconstant $kPowerStateSleepAwareMask #x2)
(defconstant $kPowerStateSleepForbiddenMask #x4)
(defconstant $kPowerStateSleepCanPowerOffMask #x8)
(defconstant $kPowerStateSleepNoDPMSMask #x10)
(defconstant $kPowerStateSleepWaketoDozeMask #x20)

;   Control Codes  
(defconstant $cscReset 0)
(defconstant $cscKillIO 1)
(defconstant $cscSetMode 2)
(defconstant $cscSetEntries 3)
(defconstant $cscSetGamma 4)
(defconstant $cscGrayPage 5)
(defconstant $cscGrayScreen 5)
(defconstant $cscSetGray 6)
(defconstant $cscSetInterrupt 7)
(defconstant $cscDirectSetEntries 8)
(defconstant $cscSetDefaultMode 9)
(defconstant $cscSwitchMode 10)                 ;   Takes a VDSwitchInfoPtr  
(defconstant $cscSetSync 11)                    ;   Takes a VDSyncInfoPtr  
(defconstant $cscSavePreferredConfiguration 16) ;   Takes a VDSwitchInfoPtr  
(defconstant $cscSetHardwareCursor 22)          ;   Takes a VDSetHardwareCursorPtr  
(defconstant $cscDrawHardwareCursor 23)         ;   Takes a VDDrawHardwareCursorPtr  
(defconstant $cscSetConvolution 24)             ;   Takes a VDConvolutionInfoPtr  
(defconstant $cscSetPowerState 25)              ;   Takes a VDPowerStatePtr  
(defconstant $cscPrivateControlCall 26)         ;   Takes a VDPrivateSelectorDataPtr  
(defconstant $cscSetMultiConnect 28)            ;   Takes a VDMultiConnectInfoPtr  
(defconstant $cscSetClutBehavior 29)            ;   Takes a VDClutBehavior  
(defconstant $cscSetDetailedTiming 31)          ;   Takes a VDDetailedTimingPtr  
(defconstant $cscDoCommunication 33)            ;   Takes a VDCommunicationPtr  
(defconstant $cscProbeConnection 34)            ;   Takes nil pointer (may generate a kFBConnectInterruptServiceType service interrupt) 
(defconstant $cscSetScaler 36)                  ;   Takes a VDScalerPtr 
(defconstant $cscSetMirror 37)                  ;   Takes a VDMirrorPtr 
(defconstant $cscUnusedCall 127)                ;   This call used to expend the scrn resource.  Its imbedded data contains more control info  

;   Status Codes  
(defconstant $cscGetMode 2)
(defconstant $cscGetEntries 3)
(defconstant $cscGetPageCnt 4)
(defconstant $cscGetPages 4)                    ;   This is what C&D 2 calls it.  
(defconstant $cscGetPageBase 5)
(defconstant $cscGetBaseAddr 5)                 ;   This is what C&D 2 calls it.  
(defconstant $cscGetGray 6)
(defconstant $cscGetInterrupt 7)
(defconstant $cscGetGamma 8)
(defconstant $cscGetDefaultMode 9)
(defconstant $cscGetCurMode 10)                 ;   Takes a VDSwitchInfoPtr  
(defconstant $cscGetSync 11)                    ;   Takes a VDSyncInfoPtr  
(defconstant $cscGetConnection 12)              ;   Return information about the connection to the display  
(defconstant $cscGetModeTiming 13)              ;   Return timing info for a mode  
(defconstant $cscGetModeBaseAddress 14)         ;   Return base address information about a particular mode  
(defconstant $cscGetScanProc 15)                ;   QuickTime scan chasing routine  
(defconstant $cscGetPreferredConfiguration 16)  ;   Takes a VDSwitchInfoPtr  
(defconstant $cscGetNextResolution 17)          ;   Takes a VDResolutionInfoPtr  
(defconstant $cscGetVideoParameters 18)         ;   Takes a VDVideoParametersInfoPtr  
(defconstant $cscGetGammaInfoList 20)           ;   Takes a VDGetGammaListPtr  
(defconstant $cscRetrieveGammaTable 21)         ;   Takes a VDRetrieveGammaPtr  
(defconstant $cscSupportsHardwareCursor 22)     ;   Takes a VDSupportsHardwareCursorPtr  
(defconstant $cscGetHardwareCursorDrawState 23) ;   Takes a VDHardwareCursorDrawStatePtr  
(defconstant $cscGetConvolution 24)             ;   Takes a VDConvolutionInfoPtr  
(defconstant $cscGetPowerState 25)              ;   Takes a VDPowerStatePtr  
(defconstant $cscPrivateStatusCall 26)          ;   Takes a VDPrivateSelectorDataPtr  
(defconstant $cscGetDDCBlock 27)                ;   Takes a VDDDCBlockPtr   
(defconstant $cscGetMultiConnect 28)            ;   Takes a VDMultiConnectInfoPtr  
(defconstant $cscGetClutBehavior 29)            ;   Takes a VDClutBehaviorPtr  
(defconstant $cscGetTimingRanges 30)            ;   Takes a VDDisplayTimingRangePtr  
(defconstant $cscGetDetailedTiming 31)          ;   Takes a VDDetailedTimingPtr  
(defconstant $cscGetCommunicationInfo 32)       ;   Takes a VDCommunicationInfoPtr  
(defconstant $cscGetScalerInfo 35)              ;   Takes a VDScalerInfoPtr  
(defconstant $cscGetScaler 36)                  ;   Takes a VDScalerPtr 
(defconstant $cscGetMirror 37)                  ;   Takes a VDMirrorPtr 

;   Bit definitions for the Get/Set Sync call 
(defconstant $kDisableHorizontalSyncBit 0)
(defconstant $kDisableVerticalSyncBit 1)
(defconstant $kDisableCompositeSyncBit 2)
(defconstant $kEnableSyncOnBlue 3)
(defconstant $kEnableSyncOnGreen 4)
(defconstant $kEnableSyncOnRed 5)
(defconstant $kNoSeparateSyncControlBit 6)
(defconstant $kTriStateSyncBit 7)
(defconstant $kHorizontalSyncMask #x1)
(defconstant $kVerticalSyncMask #x2)
(defconstant $kCompositeSyncMask #x4)
(defconstant $kDPMSSyncMask #x7)
(defconstant $kTriStateSyncMask #x80)
(defconstant $kSyncOnBlueMask #x8)
(defconstant $kSyncOnGreenMask #x10)
(defconstant $kSyncOnRedMask #x20)
(defconstant $kSyncOnMask #x38)

;      Power Mode constants for translating DPMS modes to Get/SetSync calls.   
(defconstant $kDPMSSyncOn 0)
(defconstant $kDPMSSyncStandby 1)
(defconstant $kDPMSSyncSuspend 2)
(defconstant $kDPMSSyncOff 7)

;   Bit definitions for the Get/Set Convolution call 
(defconstant $kConvolved 0)
(defconstant $kLiveVideoPassThru 1)
(defconstant $kConvolvedMask #x1)
(defconstant $kLiveVideoPassThruMask #x2)

(def-mactype :vpblockptr (find-mactype '(:pointer :vpblock)))
(defrecord VPBlock 
   (vpBaseOffset :signed-long)                  ;  Offset to page zero of video RAM (From minorBaseOS). 
   (vpRowBytes :signed-integer)                 ;  Width of each row of video memory. 
   (vpBounds :rect)                             ;  BoundsRect for the video display (gives dimensions). 
   (vpVersion :signed-integer)                  ;  PixelMap version number. 
   (vpPackType :signed-integer)
   (vpPackSize :signed-long)
   (vpHRes :signed-long)                        ;  Horizontal resolution of the device (pixels per inch). 
   (vpVRes :signed-long)                        ;  Vertical resolution of the device (pixels per inch). 
   (vpPixelType :signed-integer)                ;  Defines the pixel type. 
   (vpPixelSize :signed-integer)                ;  Number of bits in pixel. 
   (vpCmpCount :signed-integer)                 ;  Number of components in pixel. 
   (vpCmpSize :signed-integer)                  ;  Number of bits per component 
   (vpPlaneBytes :signed-long)                  ;  Offset from one plane to the next. 
   )

(def-mactype :vdentryrecordptr (find-mactype '(:pointer :vdentryrecord)))
(defrecord VDEntryRecord 
   (csTable :pointer)                           ;  (long) pointer to color table entry=value, r,g,b:INTEGER 
   )

(def-mactype :vdentrecptr (find-mactype '(:pointer :vdentryrecord)))
; 	 Parm block for SetGray control call 	
(def-mactype :vdgrayrecordptr (find-mactype '(:pointer :vdgrayrecord)))
(defrecord VDGrayRecord 
   (csMode :boolean)                            ;  Same as GDDevType value (0=color, 1=mono) 
   (filler :signed-byte)
   )

(def-mactype :vdgrayptr (find-mactype '(:pointer :vdgrayrecord)))
; 	 Parm block for SetInterrupt call 	
(def-mactype :vdflagrecordptr (find-mactype '(:pointer :vdflagrecord)))
(defrecord VDFlagRecord 
   ;;Changing field csmode from signed-byte to unsigned-byte to match C header (educated-guess)
   (csMode :unsigned-byte)
   (filler :signed-byte)
   )

(def-mactype :vdflagrecptr (find-mactype '(:pointer :vdflagrecord)))
; 	 Parm block for SetEntries control call 	
(def-mactype :vdsetentryrecordptr (find-mactype '(:pointer :vdsetentryrecord)))
(defrecord VDSetEntryRecord 
   (csTable (:pointer :colorspec))              ;  Pointer to an array of color specs 
   (csStart :signed-integer)                    ;  Which spec in array to start with, or -1 
   (csCount :signed-integer)                    ;  Number of color spec entries to set 
   )

(def-mactype :vdsetentryptr (find-mactype '(:pointer :vdsetentryrecord)))
; 	 Parm block for SetGamma control call 	
(def-mactype :vdgammarecordptr (find-mactype '(:pointer :vdgammarecord)))
(defrecord VDGammaRecord 
   (csGTable :pointer)                          ;  pointer to gamma table 
   )

(def-mactype :vdgamrecptr (find-mactype '(:pointer :vdgammarecord)))
(def-mactype :vdbaseaddressinforecptr (find-mactype '(:pointer :vdbaseaddressinforec)))
(defrecord VDBaseAddressInfoRec 
   (csDevData :signed-long)                     ;   LONGINT - (long) timing mode  
   (csDevBase :signed-long)                     ;   LONGINT - (long) base address of the mode  
   (csModeReserved :signed-integer)             ;   INTEGER - (short) will some day be the depth  
   (csModeBase :signed-long)                    ;   LONGINT - (long) reserved  
   )

(def-mactype :vdbaseaddressinfoptr (find-mactype '(:pointer :vdbaseaddressinforec)))
(def-mactype :vdswitchinforecptr (find-mactype '(:pointer :vdswitchinforec)))
(defrecord VDSwitchInfoRec 
   (csMode :unsigned-integer)                   ;  (word) mode depth 
   (csData :unsigned-long)                      ;  (long) functional sResource of mode 
   (csPage :unsigned-integer)                   ;  (word) page to switch in 
   (csBaseAddr :pointer)                        ;  (long) base address of page (return value) 
   (csReserved :unsigned-long)                  ;  (long) Reserved (set to 0)  
   )

(def-mactype :vdswitchinfoptr (find-mactype '(:pointer :vdswitchinforec)))
(def-mactype :vdtiminginforecptr (find-mactype '(:pointer :vdtiminginforec)))
(defrecord VDTimingInfoRec 
   (csTimingMode :unsigned-long)                ;   LONGINT - (long) timing mode (a la InitGDevice)  
   (csTimingReserved :unsigned-long)            ;   LONGINT - (long) reserved  
   (csTimingFormat :unsigned-long)              ;   LONGINT - (long) what format is the timing info  
   (csTimingData :unsigned-long)                ;   LONGINT - (long) data supplied by driver  
   (csTimingFlags :unsigned-long)               ;   LONGINT - (long) mode within device  
   )

(def-mactype :vdtiminginfoptr (find-mactype '(:pointer :vdtiminginforec)))
(def-mactype :vddisplayconnectinforecptr (find-mactype '(:pointer :vddisplayconnectinforec)))
(defrecord VDDisplayConnectInfoRec 
   (csDisplayType :unsigned-integer)            ;   INTEGER - (word) Type of display connected  
   ;;Changing field csconnecttaggedtype from signed-byte to unsigned-byte to match C header (educated-guess)
   (csConnectTaggedType :unsigned-byte)         ;   BYTE - type of tagging  
   ;;Changing field csconnecttaggeddata from signed-byte to unsigned-byte to match C header (educated-guess)
   (csConnectTaggedData :unsigned-byte)         ;   BYTE - tagging data  
   (csConnectFlags :unsigned-long)              ;   LONGINT - (long) tell us about the connection  
   (csDisplayComponent :unsigned-long)          ;   LONGINT - (long) if the card has a direct connection to the display, it returns the display component here (FUTURE)  
   (csConnectReserved :unsigned-long)           ;   LONGINT - (long) reserved  
   )

(def-mactype :vddisplayconnectinfoptr (find-mactype '(:pointer :vddisplayconnectinforec)))
(def-mactype :vdmulticonnectinforecptr (find-mactype '(:pointer :vdmulticonnectinforec)))
(defrecord VDMultiConnectInfoRec 
   (csDisplayCountOrNumber :unsigned-long)      ;   For GetMultiConnect, returns count n of 1..n connections; otherwise, indicates the ith connection. 
   (csConnectInfo :vddisplayconnectinforec)     ;   Standard VDDisplayConnectionInfo for connection i. 
   )

(def-mactype :vdmulticonnectinfoptr (find-mactype '(:pointer :vdmulticonnectinforec)))
; 	 RawSenseCode
; 	    This abstract data type is not exactly abstract.  Rather, it is merely enumerated constants
; 	    for the possible raw sense code values when 'standard' sense code hardware is implemented.
; 	
; 	    For 'standard' sense code hardware, the raw sense is obtained as follows:
; 	         Instruct the frame buffer controller NOT to actively drive any of the monitor sense lines
; 	         Read the state of the monitor sense lines 2, 1, and 0.  (2 is the MSB, 0 the LSB)
; 	
; 	    IMPORTANT Note: 
; 	    When the 'kTaggingInfoNonStandard' bit of 'csConnectFlags' is FALSE, then these constants 
; 	    are valid 'csConnectTaggedType' values in 'VDDisplayConnectInfo' 
; 	
; 		
(def-mactype :rawsensecode (find-mactype ':unsigned-byte))

(defconstant $kRSCZero 0)
(defconstant $kRSCOne 1)
(defconstant $kRSCTwo 2)
(defconstant $kRSCThree 3)
(defconstant $kRSCFour 4)
(defconstant $kRSCFive 5)
(defconstant $kRSCSix 6)
(defconstant $kRSCSeven 7)

; 	 ExtendedSenseCode
; 	    This abstract data type is not exactly abstract.  Rather, it is merely enumerated constants
; 	    for the values which are possible when the extended sense algorithm is applied to hardware
; 	    which implements 'standard' sense code hardware.
; 	
; 	    For 'standard' sense code hardware, the extended sense code algorithm is as follows:
; 	    (Note:  as described here, sense line 'A' corresponds to '2', 'B' to '1', and 'C' to '0')
; 	         Drive sense line 'A' low and read the values of 'B' and 'C'.  
; 	         Drive sense line 'B' low and read the values of 'A' and 'C'.
; 	         Drive sense line 'C' low and read the values of 'A' and 'B'.
; 	
; 	    In this way, a six-bit number of the form BC/AC/AB is generated. 
; 	
; 	    IMPORTANT Note: 
; 	    When the 'kTaggingInfoNonStandard' bit of 'csConnectFlags' is FALSE, then these constants 
; 	    are valid 'csConnectTaggedData' values in 'VDDisplayConnectInfo' 
; 	
; 		

(def-mactype :extendedsensecode (find-mactype ':unsigned-byte))

(defconstant $kESCZero21Inch #x0)               ;   21" RGB                      
(defconstant $kESCOnePortraitMono #x14)         ;   Portrait Monochrome               
(defconstant $kESCTwo12Inch #x21)               ;   12" RGB                     
(defconstant $kESCThree21InchRadius #x31)       ;   21" RGB (Radius)                
(defconstant $kESCThree21InchMonoRadius #x34)   ;   21" Monochrome (Radius)            
(defconstant $kESCThree21InchMono #x35)         ;   21" Monochrome                
(defconstant $kESCFourNTSC #xA)                 ;   NTSC                      
(defconstant $kESCFivePortrait #x1E)            ;   Portrait RGB               
(defconstant $kESCSixMSB1 #x3)                  ;   MultiScan Band-1 (12" thru 1Six")   
(defconstant $kESCSixMSB2 #xB)                  ;   MultiScan Band-2 (13" thru 19")        
(defconstant $kESCSixMSB3 #x23)                 ;   MultiScan Band-3 (13" thru 21")        
(defconstant $kESCSixStandard #x2B)             ;   13"/14" RGB or 12" Monochrome    
(defconstant $kESCSevenPAL #x0)                 ;   PAL                         
(defconstant $kESCSevenNTSC #x14)               ;   NTSC                      
(defconstant $kESCSevenVGA #x17)                ;   VGA                         
(defconstant $kESCSeven16Inch #x2D)             ;   16" RGB (GoldFish)                
(defconstant $kESCSevenPALAlternate #x30)       ;   PAL (Alternate)                 
(defconstant $kESCSeven19Inch #x3A)             ;   Third-Party 19                  
(defconstant $kESCSevenDDC #x3E)                ;   DDC display                    
(defconstant $kESCSevenNoDisplay #x3F)          ;   No display connected            

; 	 DepthMode
; 	    This abstract data type is used to to reference RELATIVE pixel depths.
; 	    Its definition is largely derived from its past usage, analogous to 'xxxVidMode'
; 	
; 	    Bits per pixel DOES NOT directly map to 'DepthMode'  For example, on some
; 	    graphics hardware, 'kDepthMode1' may represent 1 BPP, whereas on other
; 	    hardware, 'kDepthMode1' may represent 8BPP.
; 	
; 	    DepthMode IS considered to be ordinal, i.e., operations such as <, >, ==, etc.
; 	    behave as expected.  The values of the constants which comprise the set are such
; 	    that 'kDepthMode4 < kDepthMode6' behaves as expected.
; 		

(def-mactype :depthmode (find-mactype ':unsigned-integer))

(defconstant $kDepthMode1 128)
(defconstant $kDepthMode2 129)
(defconstant $kDepthMode3 130)
(defconstant $kDepthMode4 131)
(defconstant $kDepthMode5 132)
(defconstant $kDepthMode6 133)

(defconstant $kFirstDepthMode 128)              ;   These constants are obsolete, and just included     
(defconstant $kSecondDepthMode 129)             ;   for clients that have converted to the above      
(defconstant $kThirdDepthMode 130)              ;   kDepthModeXXX constants.                 
(defconstant $kFourthDepthMode 131)
(defconstant $kFifthDepthMode 132)
(defconstant $kSixthDepthMode 133)

(def-mactype :vdpageinfoptr (find-mactype '(:pointer :vdpageinfo)))
(defrecord VDPageInfo 
   ;;Changing field csmode from signed-integer to unsigned-word to match C header (pretty-darn-sure)
   (csMode :unsigned-word)                      ;  (word) mode within device 
   ;;Changing field csdata from signed-long to unsigned-long to match C header (pretty-darn-sure)
   (csData :unsigned-long)                      ;  (long) data supplied by driver 
   ;;Changing field cspage from signed-integer to unsigned-word to match C header (pretty-sure)
   (csPage :unsigned-word)                      ;  (word) page to switch in 
   (csBaseAddr :pointer)                        ;  (long) base address of page 
   )

(def-mactype :vdpginfoptr (find-mactype '(:pointer :vdpageinfo)))
(def-mactype :vdsizeinfoptr (find-mactype '(:pointer :vdsizeinfo)))
(defrecord VDSizeInfo 
   (csHSize :signed-integer)                    ;  (word) desired/returned h size 
   (csHPos :signed-integer)                     ;  (word) desired/returned h position 
   (csVSize :signed-integer)                    ;  (word) desired/returned v size 
   (csVPos :signed-integer)                     ;  (word) desired/returned v position 
   )

(def-mactype :vdszinfoptr (find-mactype '(:pointer :vdsizeinfo)))
(def-mactype :vdsettingsptr (find-mactype '(:pointer :vdsettings)))
(defrecord VDSettings 
   (csParamCnt :signed-integer)                 ;  (word) number of params 
   (csBrightMax :signed-integer)                ;  (word) max brightness 
   (csBrightDef :signed-integer)                ;  (word) default brightness 
   (csBrightVal :signed-integer)                ;  (word) current brightness 
   (csCntrstMax :signed-integer)                ;  (word) max contrast 
   (csCntrstDef :signed-integer)                ;  (word) default contrast 
   (csCntrstVal :signed-integer)                ;  (word) current contrast 
   (csTintMax :signed-integer)                  ;  (word) max tint 
   (csTintDef :signed-integer)                  ;  (word) default tint 
   (csTintVal :signed-integer)                  ;  (word) current tint 
   (csHueMax :signed-integer)                   ;  (word) max hue 
   (csHueDef :signed-integer)                   ;  (word) default hue 
   (csHueVal :signed-integer)                   ;  (word) current hue 
   (csHorizDef :signed-integer)                 ;  (word) default horizontal 
   (csHorizVal :signed-integer)                 ;  (word) current horizontal 
   (csHorizMax :signed-integer)                 ;  (word) max horizontal 
   (csVertDef :signed-integer)                  ;  (word) default vertical 
   (csVertVal :signed-integer)                  ;  (word) current vertical 
   (csVertMax :signed-integer)                  ;  (word) max vertical 
   )

(def-mactype :vddefmodeptr (find-mactype '(:pointer :vddefmode)))
(defrecord VDDefMode 
   (csID :signed-byte)
   (filler :signed-byte)
   )

(def-mactype :vdsyncinforecptr (find-mactype '(:pointer :vdsyncinforec)))
(defrecord VDSyncInfoRec 
   ;;Changing field csmode from signed-byte to unsigned-byte to match C header (educated-guess)
   (csMode :unsigned-byte)
   (csFlags :signed-byte)
   )

(def-mactype :vdsyncinfoptr (find-mactype '(:pointer :vdsyncinforec)))
(def-mactype :avidtype (find-mactype ':unsigned-long))
(def-mactype :displayidtype (find-mactype ':unsigned-long))
(def-mactype :displaymodeid (find-mactype ':unsigned-long))
(def-mactype :videodevicetype (find-mactype ':unsigned-long))
(def-mactype :gammatableid (find-mactype ':unsigned-long))
; 
; 	   All displayModeID values from 0x80000000 to 0xFFFFFFFF and 0x00
; 	   are reserved for Apple Computer.
; 	
; 	 Constants for the cscGetNextResolution call 	

(defconstant $kDisplayModeIDCurrent #x0)        ;   Reference the Current DisplayModeID  
(defconstant $kDisplayModeIDInvalid #xFFFFFFFF) ;   A bogus DisplayModeID in all cases  
(defconstant $kDisplayModeIDFindFirstResolution #xFFFFFFFE);   Used in cscGetNextResolution to reset iterator  
(defconstant $kDisplayModeIDNoMoreResolutions #xFFFFFFFD);   Used in cscGetNextResolution to indicate End Of List  
(defconstant $kDisplayModeIDFindFirstProgrammable #xFFFFFFFC);   Used in cscGetNextResolution to find unused programmable timing  
(defconstant $kDisplayModeIDBootProgrammable #xFFFFFFFB);   This is the ID given at boot time by the OF driver to a programmable timing  
(defconstant $kDisplayModeIDReservedBase #x80000000);   Lowest (unsigned) DisplayModeID reserved by Apple  

; 	 Constants for the GetGammaInfoList call 	
(defconstant $kGammaTableIDFindFirst #xFFFFFFFE);   Get the first gamma table ID  
(defconstant $kGammaTableIDNoMoreTables #xFFFFFFFD);   Used to indicate end of list  
(defconstant $kGammaTableIDSpecific #x0)        ;   Return the info for the given table id  

;   Constants for GetMultiConnect call 
(defconstant $kGetConnectionCount #xFFFFFFFF)   ;   Used to get the number of possible connections in a multi-headed framebuffer environment. 
(defconstant $kActivateConnection #x0)          ;   Used for activating a connection (csConnectFlags value). 
(defconstant $kDeactivateConnection #x200)      ;   Used for deactivating a connection (csConnectFlags value.) 

;   VDCommunicationRec.csBusID values 
(defconstant $kVideoDefaultBus 0)

;   VDCommunicationInfoRec.csBusType values 
(defconstant $kVideoBusTypeInvalid 0)
(defconstant $kVideoBusTypeI2C 1)

;   VDCommunicationRec.csSendType and VDCommunicationRec.csReplyType values and bits in VDCommunicationInfoRec.csSupportedTypes. 
(defconstant $kVideoNoTransactionType 0)        ;   No transaction 
(defconstant $kVideoSimpleI2CType 1)            ;   Simple I2C message 
(defconstant $kVideoDDCciReplyType 2)           ;   DDC/ci message (with imbedded length) 

;   VDCommunicationRec.csCommFlags and VDCommunicationInfoRec.csSupportedCommFlags 
(defconstant $kVideoReplyMicroSecDelayMask #x1) ;   If set, the driver should delay csMinReplyDelay micro seconds between send and recieve 

(def-mactype :vdresolutioninforecptr (find-mactype '(:pointer :vdresolutioninforec)))
(defrecord VDResolutionInfoRec 
   (csPreviousDisplayModeID :unsigned-long)     ;   ID of the previous resolution in a chain  
   (csDisplayModeID :unsigned-long)             ;   ID of the next resolution  
   (csHorizontalPixels :unsigned-long)          ;   # of pixels in a horizontal line at the max depth  
   (csVerticalLines :unsigned-long)             ;   # of lines in a screen at the max depth  
   (csRefreshRate :signed-long)                 ;   Vertical Refresh Rate in Hz  
   (csMaxDepthMode :unsigned-integer)           ;   0x80-based number representing max bit depth  
   (csResolutionFlags :unsigned-long)           ;   Reserved - flag bits  
   (csReserved :unsigned-long)                  ;   Reserved  
   )

(def-mactype :vdresolutioninfoptr (find-mactype '(:pointer :vdresolutioninforec)))
(def-mactype :vdvideoparametersinforecptr (find-mactype '(:pointer :vdvideoparametersinforec)))
(defrecord VDVideoParametersInfoRec 
   (csDisplayModeID :unsigned-long)             ;   the ID of the resolution we want info on  
   (csDepthMode :unsigned-integer)              ;   The bit depth we want the info on (0x80 based)  
   (csVPBlockPtr (:pointer :vpblock))           ;   Pointer to a video parameter block  
   (csPageCount :unsigned-long)                 ;   Number of pages supported by the resolution  
   (csDeviceType :unsigned-long)                ;   Device Type:  Direct, Fixed or CLUT;  
   (csDepthFlags :unsigned-long)                ;   Flags  
   )

(def-mactype :vdvideoparametersinfoptr (find-mactype '(:pointer :vdvideoparametersinforec)))
(def-mactype :vdgammainforecptr (find-mactype '(:pointer :vdgammainforec)))
(defrecord VDGammaInfoRec 
   (csLastGammaID :unsigned-long)               ;   the ID of the previous gamma table  
   (csNextGammaID :unsigned-long)               ;   the ID of the next gamma table  
   (csGammaPtr :pointer)                        ;   Ptr to a gamma table data  
   (csReserved :unsigned-long)                  ;   Reserved  
   )

(def-mactype :vdgammainfoptr (find-mactype '(:pointer :vdgammainforec)))
(def-mactype :vdgetgammalistrecptr (find-mactype '(:pointer :vdgetgammalistrec)))
(defrecord VDGetGammaListRec 
   (csPreviousGammaTableID :unsigned-long)      ;   ID of the previous gamma table  
   (csGammaTableID :unsigned-long)              ;   ID of the gamma table following csPreviousDisplayModeID  
   (csGammaTableSize :unsigned-long)            ;   Size of the gamma table in bytes  
   (csGammaTableName :pointer)                  ;   Gamma table name (c-string)  
   )

(def-mactype :vdgetgammalistptr (find-mactype '(:pointer :vdgetgammalistrec)))
(def-mactype :vdretrievegammarecptr (find-mactype '(:pointer :vdretrievegammarec)))
(defrecord VDRetrieveGammaRec 
   (csGammaTableID :unsigned-long)              ;   ID of gamma table to retrieve  
   (csGammaTablePtr (:pointer :gammatbl))       ;   Location to copy desired gamma to  
   )

(def-mactype :vdretrievegammaptr (find-mactype '(:pointer :vdretrievegammarec)))
(def-mactype :vdsethardwarecursorrecptr (find-mactype '(:pointer :vdsethardwarecursorrec)))
(defrecord VDSetHardwareCursorRec 
   (csCursorRef :pointer)                       ;   reference to cursor data  
   (csReserved1 :unsigned-long)                 ;   reserved for future use  
   (csReserved2 :unsigned-long)                 ;   should be ignored  
   )

(def-mactype :vdsethardwarecursorptr (find-mactype '(:pointer :vdsethardwarecursorrec)))
(def-mactype :vddrawhardwarecursorrecptr (find-mactype '(:pointer :vddrawhardwarecursorrec)))
(defrecord VDDrawHardwareCursorRec 
   (csCursorX :signed-long)                     ;   x coordinate  
   (csCursorY :signed-long)                     ;   y coordinate  
   (csCursorVisible :unsigned-long)             ;   true if cursor is must be visible  
   (csReserved1 :unsigned-long)                 ;   reserved for future use  
   (csReserved2 :unsigned-long)                 ;   should be ignored  
   )

(def-mactype :vddrawhardwarecursorptr (find-mactype '(:pointer :vddrawhardwarecursorrec)))
(def-mactype :vdsupportshardwarecursorrecptr (find-mactype '(:pointer :vdsupportshardwarecursorrec)))
(defrecord VDSupportsHardwareCursorRec 
   (csSupportsHardwareCursor :unsigned-long)
;   true if hardware cursor is supported  
   (csReserved1 :unsigned-long)                 ;   reserved for future use  
   (csReserved2 :unsigned-long)                 ;   must be zero  
   )

(def-mactype :vdsupportshardwarecursorptr (find-mactype '(:pointer :vdsupportshardwarecursorrec)))
(def-mactype :vdhardwarecursordrawstaterecptr (find-mactype '(:pointer :vdhardwarecursordrawstaterec)))
(defrecord VDHardwareCursorDrawStateRec 
   (csCursorX :signed-long)                     ;   x coordinate  
   (csCursorY :signed-long)                     ;   y coordinate  
   (csCursorVisible :unsigned-long)             ;   true if cursor is visible  
   (csCursorSet :unsigned-long)                 ;   true if cursor successfully set by last set control call  
   (csReserved1 :unsigned-long)                 ;   reserved for future use  
   (csReserved2 :unsigned-long)                 ;   must be zero  
   )

(def-mactype :vdhardwarecursordrawstateptr (find-mactype '(:pointer :vdhardwarecursordrawstaterec)))
(def-mactype :vdconvolutioninforecptr (find-mactype '(:pointer :vdconvolutioninforec)))
(defrecord VDConvolutionInfoRec 
   (csDisplayModeID :unsigned-long)             ;   the ID of the resolution we want info on  
   (csDepthMode :unsigned-integer)              ;   The bit depth we want the info on (0x80 based)  
   (csPage :unsigned-long)
   (csFlags :unsigned-long)
   (csReserved :unsigned-long)
   )

(def-mactype :vdconvolutioninfoptr (find-mactype '(:pointer :vdconvolutioninforec)))
(def-mactype :vdpowerstaterecptr (find-mactype '(:pointer :vdpowerstaterec)))
(defrecord VDPowerStateRec 
   (powerState :unsigned-long)
   (powerFlags :unsigned-long)
   (powerReserved1 :unsigned-long)
   (powerReserved2 :unsigned-long)
   )

(def-mactype :vdpowerstateptr (find-mactype '(:pointer :vdpowerstaterec)))
; 	
; 	    Private Data to video drivers.
; 	    
; 	    In versions of MacOS with multiple address spaces (System 8), the OS 
; 	    must know the extent of parameters in order to move them between the caller
; 	    and driver.  The old private-selector model for video drivers does not have
; 	    this information so:
; 	    
; 	    For post-7.x Systems private calls should be implemented using the cscPrivateCall
; 		
(def-mactype :vdprivateselectordatarecptr (find-mactype '(:pointer :vdprivateselectordatarec)))
(defrecord VDPrivateSelectorDataRec 
   (privateParameters :pointer)                 ;   Caller's parameters 
   (privateParametersSize :unsigned-long)       ;   Size of data sent from caller to driver 
   (privateResults :pointer)                    ;   Caller's return area. Can be nil, or same as privateParameters. 
   (privateResultsSize :unsigned-long)          ;   Size of data driver returns to caller. Can be nil, or same as privateParametersSize. 
   )

(def-mactype :vdprivateselectorrecptr (find-mactype '(:pointer :vdprivateselectorrec)))
(defrecord VDPrivateSelectorRec 
   (reserved :unsigned-long)                    ;   Reserved (set to 0).  
   (data (:array :vdprivateselectordatarec 1))
   )

(def-mactype :vdddcblockrecptr (find-mactype '(:pointer :vdddcblockrec)))
(defrecord VDDDCBlockRec 
   (ddcBlockNumber :unsigned-long)              ;   Input -- DDC EDID (Extended Display Identification Data) number (1-based)  
   (ddcBlockType :ostype)                       ;   Input -- DDC block type (EDID/VDIF)  
   (ddcFlags :unsigned-long)                    ;   Input -- DDC Flags 
   (ddcReserved :unsigned-long)                 ;   Reserved  
   (ddcBlockData (:array :unsigned-byte 128 :packed));   Output -- DDC EDID/VDIF data (kDDCBlockSize)  
   )

(def-mactype :vdddcblockptr (find-mactype '(:pointer :vdddcblockrec)))

;   timingSyncConfiguration 
(defconstant $kSyncInterlaceMask #x80)
(defconstant $kSyncAnalogCompositeMask 0)
(defconstant $kSyncAnalogCompositeSerrateMask #x4)
(defconstant $kSyncAnalogCompositeRGBSyncMask #x2)
(defconstant $kSyncAnalogBipolarMask #x8)
(defconstant $kSyncAnalogBipolarSerrateMask #x4)
(defconstant $kSyncAnalogBipolarSRGBSyncMask #x2)
(defconstant $kSyncDigitalCompositeMask #x10)
(defconstant $kSyncDigitalCompositeSerrateMask #x4)
(defconstant $kSyncDigitalCompositeMatchHSyncMask #x4)
(defconstant $kSyncDigitalSeperateMask #x18)
(defconstant $kSyncDigitalVSyncPositiveMask #x4)
(defconstant $kSyncDigitalHSyncPositiveMask #x2)

(def-mactype :vddisplaytimingrangerecptr (find-mactype '(:pointer :vddisplaytimingrangerec)))
(defrecord VDDisplayTimingRangeRec 
   (csRangeSize :unsigned-long)                 ;   Init to sizeof(VDDisplayTimingRangeRec)  
   (csRangeType :unsigned-long)                 ;   Init to 0  
   (csRangeVersion :unsigned-long)              ;   Init to 0  
   (csRangeReserved :unsigned-long)             ;   Init to 0  
   (csRangeBlockIndex :unsigned-long)           ;   Requested block (first index is 0) 
   (csRangeGroup :unsigned-long)                ;   set to 0  
   (csRangeBlockCount :unsigned-long)           ;   # blocks  
   (csRangeFlags :unsigned-long)                ;   dependent video  
   (csMinPixelClock :unsignedwide)              ;   Min dot clock in Hz  
   (csMaxPixelClock :unsignedwide)              ;   Max dot clock in Hz  
   (csMaxPixelError :unsigned-long)             ;   Max dot clock error  
   (csTimingRangeSyncFlags :unsigned-long)
   (csTimingRangeSignalLevels :unsigned-long)
   (csReserved0 :unsigned-long)
   (csMinFrameRate :unsigned-long)              ;   Hz  
   (csMaxFrameRate :unsigned-long)              ;   Hz  
   (csMinLineRate :unsigned-long)               ;   Hz  
   (csMaxLineRate :unsigned-long)               ;   Hz  
   (csMaxHorizontalTotal :unsigned-long)        ;   Clocks - Maximum total (active + blanking)  
   (csMaxVerticalTotal :unsigned-long)          ;   Clocks - Maximum total (active + blanking)  
   (csMaxTotalReserved1 :unsigned-long)         ;   Reserved  
   (csMaxTotalReserved2 :unsigned-long)         ;   Reserved  
;   Some cards require that some timing elements 
;   be multiples of a "character size" (often 8 
;   clocks).  The "xxxxCharSize" fields document 
;   those requirements. 
   (csCharSizeHorizontalActive :signed-byte)    ;   Character size  
   (csCharSizeHorizontalBlanking :signed-byte)  ;   Character size  
   (csCharSizeHorizontalSyncOffset :signed-byte);   Character size  
   (csCharSizeHorizontalSyncPulse :signed-byte) ;   Character size  
   (csCharSizeVerticalActive :signed-byte)      ;   Character size  
   (csCharSizeVerticalBlanking :signed-byte)    ;   Character size  
   (csCharSizeVerticalSyncOffset :signed-byte)  ;   Character size  
   (csCharSizeVerticalSyncPulse :signed-byte)   ;   Character size  
   (csCharSizeHorizontalBorderLeft :signed-byte);   Character size  
   (csCharSizeHorizontalBorderRight :signed-byte);   Character size  
   (csCharSizeVerticalBorderTop :signed-byte)   ;   Character size  
   (csCharSizeVerticalBorderBottom :signed-byte);   Character size  
   (csCharSizeHorizontalTotal :signed-byte)     ;   Character size for active + blanking  
   (csCharSizeVerticalTotal :signed-byte)       ;   Character size for active + blanking  
   (csCharSizeReserved1 :unsigned-integer)      ;   Reserved (Init to 0)  
   (csMinHorizontalActiveClocks :unsigned-long)
   (csMaxHorizontalActiveClocks :unsigned-long)
   (csMinHorizontalBlankingClocks :unsigned-long)
   (csMaxHorizontalBlankingClocks :unsigned-long)
   (csMinHorizontalSyncOffsetClocks :unsigned-long)
   (csMaxHorizontalSyncOffsetClocks :unsigned-long)
   (csMinHorizontalPulseWidthClocks :unsigned-long)
   (csMaxHorizontalPulseWidthClocks :unsigned-long)
   (csMinVerticalActiveClocks :unsigned-long)
   (csMaxVerticalActiveClocks :unsigned-long)
   (csMinVerticalBlankingClocks :unsigned-long)
   (csMaxVerticalBlankingClocks :unsigned-long)
   (csMinVerticalSyncOffsetClocks :unsigned-long)
   (csMaxVerticalSyncOffsetClocks :unsigned-long)
   (csMinVerticalPulseWidthClocks :unsigned-long)
   (csMaxVerticalPulseWidthClocks :unsigned-long)
   (csMinHorizontalBorderLeft :unsigned-long)
   (csMaxHorizontalBorderLeft :unsigned-long)
   (csMinHorizontalBorderRight :unsigned-long)
   (csMaxHorizontalBorderRight :unsigned-long)
   (csMinVerticalBorderTop :unsigned-long)
   (csMaxVerticalBorderTop :unsigned-long)
   (csMinVerticalBorderBottom :unsigned-long)
   (csMaxVerticalBorderBottom :unsigned-long)
   (csReserved1 :unsigned-long)                 ;   Reserved (Init to 0) 
   (csReserved2 :unsigned-long)                 ;   Reserved (Init to 0) 
   (csReserved3 :unsigned-long)                 ;   Reserved (Init to 0) 
   (csReserved4 :unsigned-long)                 ;   Reserved (Init to 0) 
   (csReserved5 :unsigned-long)                 ;   Reserved (Init to 0) 
   (csReserved6 :unsigned-long)                 ;   Reserved (Init to 0) 
   (csReserved7 :unsigned-long)                 ;   Reserved (Init to 0) 
   (csReserved8 :unsigned-long)                 ;   Reserved (Init to 0) 
   )

(def-mactype :vddisplaytimingrangeptr (find-mactype '(:pointer :vddisplaytimingrangerec)))

;   csDisplayModeState 
(defconstant $kDMSModeReady 0)                  ;   Display Mode ID is configured and ready 
(defconstant $kDMSModeNotReady 1)               ;   Display Mode ID is is being programmed 
(defconstant $kDMSModeFree 2)                   ;   Display Mode ID is not associated with a timing 

; 	 Video driver Errors -10930 to -10959 	
(defconstant $kTimingChangeRestrictedErr -10930)
(defconstant $kVideoI2CReplyPendingErr -10931)
(defconstant $kVideoI2CTransactionErr -10932)
(defconstant $kVideoI2CBusyErr -10933)
(defconstant $kVideoI2CTransactionTypeErr -10934)
(defconstant $kVideoBufferSizeErr -10935)
(defconstant $kVideoCannotMirrorErr -10936)

;   csTimingRangeSignalLevels 
(defconstant $kRangeSupportsSignal_0700_0300_Bit 0)
(defconstant $kRangeSupportsSignal_0714_0286_Bit 1)
(defconstant $kRangeSupportsSignal_1000_0400_Bit 2)
(defconstant $kRangeSupportsSignal_0700_0000_Bit 3)
(defconstant $kRangeSupportsSignal_0700_0300_Mask #x1)
(defconstant $kRangeSupportsSignal_0714_0286_Mask #x2)
(defconstant $kRangeSupportsSignal_1000_0400_Mask #x4)
(defconstant $kRangeSupportsSignal_0700_0000_Mask #x8)

;   csSignalConfig 
(defconstant $kDigitalSignalBit 0)              ;   Do not set.  Mac OS does not currently support arbitrary digital timings 
(defconstant $kAnalogSetupExpectedBit 1)        ;   Analog displays - display expects a blank-to-black setup or pedestal.  See VESA signal standards. 
(defconstant $kDigitalSignalMask #x1)
(defconstant $kAnalogSetupExpectedMask #x2)

;   csSignalLevels for analog 
(defconstant $kAnalogSignalLevel_0700_0300 0)
(defconstant $kAnalogSignalLevel_0714_0286 1)
(defconstant $kAnalogSignalLevel_1000_0400 2)
(defconstant $kAnalogSignalLevel_0700_0000 3)

;   csTimingRangeSyncFlags 
(defconstant $kRangeSupportsSeperateSyncsBit 0)
(defconstant $kRangeSupportsSyncOnGreenBit 1)
(defconstant $kRangeSupportsCompositeSyncBit 2)
(defconstant $kRangeSupportsVSyncSerrationBit 3)
(defconstant $kRangeSupportsSeperateSyncsMask #x1)
(defconstant $kRangeSupportsSyncOnGreenMask #x2)
(defconstant $kRangeSupportsCompositeSyncMask #x4)
(defconstant $kRangeSupportsVSyncSerrationMask #x8)

;   csHorizontalSyncConfig and csVerticalSyncConfig 
(defconstant $kSyncPositivePolarityBit 0)       ;   Digital separate sync polarity for analog interfaces (0 => negative polarity) 
(defconstant $kSyncPositivePolarityMask #x1)

;   For timings with kDetailedTimingFormat. 

(def-mactype :vddetailedtimingrecptr (find-mactype '(:pointer :vddetailedtimingrec)))
(defrecord VDDetailedTimingRec 
   (csTimingSize :unsigned-long)                ;   Init to sizeof(VDDetailedTimingRec) 
   (csTimingType :unsigned-long)                ;   Init to 0 
   (csTimingVersion :unsigned-long)             ;   Init to 0 
   (csTimingReserved :unsigned-long)            ;   Init to 0 
   (csDisplayModeID :unsigned-long)             ;   Init to 0 
   (csDisplayModeSeed :unsigned-long)           ;    
   (csDisplayModeState :unsigned-long)          ;   Display Mode state 
   (csDisplayModeAlias :unsigned-long)          ;   Mode to use when programmed. 
   (csSignalConfig :unsigned-long)
   (csSignalLevels :unsigned-long)
   (csPixelClock :unsignedwide)                 ;   Hz 
   (csMinPixelClock :unsignedwide)              ;   Hz - With error what is slowest actual clock  
   (csMaxPixelClock :unsignedwide)              ;   Hz - With error what is fasted actual clock  
   (csHorizontalActive :unsigned-long)          ;   Pixels 
   (csHorizontalBlanking :unsigned-long)        ;   Pixels 
   (csHorizontalSyncOffset :unsigned-long)      ;   Pixels 
   (csHorizontalSyncPulseWidth :unsigned-long)  ;   Pixels 
   (csVerticalActive :unsigned-long)            ;   Lines 
   (csVerticalBlanking :unsigned-long)          ;   Lines 
   (csVerticalSyncOffset :unsigned-long)        ;   Lines 
   (csVerticalSyncPulseWidth :unsigned-long)    ;   Lines 
   (csHorizontalBorderLeft :unsigned-long)      ;   Pixels 
   (csHorizontalBorderRight :unsigned-long)     ;   Pixels 
   (csVerticalBorderTop :unsigned-long)         ;   Lines 
   (csVerticalBorderBottom :unsigned-long)      ;   Lines 
   (csHorizontalSyncConfig :unsigned-long)
   (csHorizontalSyncLevel :unsigned-long)       ;   Future use (init to 0) 
   (csVerticalSyncConfig :unsigned-long)
   (csVerticalSyncLevel :unsigned-long)         ;   Future use (init to 0) 
   (csReserved1 :unsigned-long)                 ;   Init to 0 
   (csReserved2 :unsigned-long)                 ;   Init to 0 
   (csReserved3 :unsigned-long)                 ;   Init to 0 
   (csReserved4 :unsigned-long)                 ;   Init to 0 
   (csReserved5 :unsigned-long)                 ;   Init to 0 
   (csReserved6 :unsigned-long)                 ;   Init to 0 
   (csReserved7 :unsigned-long)                 ;   Init to 0 
   (csReserved8 :unsigned-long)                 ;   Init to 0 
   )

(def-mactype :vddetailedtimingptr (find-mactype '(:pointer :vddetailedtimingrec)))

;   csScalerFeatures 
(defconstant $kScaleStretchOnlyMask #x1)        ;   True means the driver cannot add borders to avoid non-square pixels 
(defconstant $kScaleCanUpSamplePixelsMask #x2)  ;   True means timings with more active clocks than pixels (ie 640x480 pixels on a 1600x1200 timing) 
(defconstant $kScaleCanDownSamplePixelsMask #x4);   True means timings with fewer active clocks than pixels (ie 1600x1200  pixels on a 640x480 timing) 

;   csScalerFlags 
(defconstant $kScaleStretchToFitMask #x1)       ;   True means the driver should avoid borders and allow non-square pixels 

(def-mactype :vdclutbehavior (find-mactype ':unsigned-long))
(def-mactype :vdclutbehaviorptr (find-mactype '(:pointer :unsigned-long)))

(defconstant $kSetClutAtSetEntries 0)           ;   SetEntries behavior is to update clut during SetEntries call 
(defconstant $kSetClutAtVBL 1)                  ;   SetEntries behavior is to upate clut at next vbl 

(def-mactype :vdcommunicationrecptr (find-mactype '(:pointer :vdcommunicationrec)))
(defrecord VDCommunicationRec 
   (csBusID :signed-long)                       ;   kVideoDefaultBus for single headed cards. 
   (csCommFlags :unsigned-long)                 ;   Always zero 
   (csMinReplyDelay :unsigned-long)             ;   Minimum delay between send and reply transactions (units depend on csCommFlags) 
   (csReserved2 :unsigned-long)                 ;   Always zero 
   (csSendAddress :unsigned-long)               ;   Usually I2C address (eg 0x6E) 
   (csSendType :unsigned-long)                  ;   See kVideoSimpleI2CType etc. 
   (csSendBuffer :pointer)                      ;   Pointer to the send buffer 
   (csSendSize :unsigned-long)                  ;   Number of bytes to send 
   (csReplyAddress :unsigned-long)              ;   Address from which to read (eg 0x6F for kVideoDDCciReplyType I2C address) 
   (csReplyType :unsigned-long)                 ;   See kVideoDDCciReplyType etc. 
   (csReplyBuffer :pointer)                     ;   Pointer to the reply buffer 
   (csReplySize :unsigned-long)                 ;   Max bytes to reply (size of csReplyBuffer) 
   (csReserved3 :unsigned-long)
   (csReserved4 :unsigned-long)
   (csReserved5 :unsigned-long)                 ;   Always zero 
   (csReserved6 :unsigned-long)                 ;   Always zero 
   )

(def-mactype :vdcommunicationptr (find-mactype '(:pointer :vdcommunicationrec)))
(def-mactype :vdcommunicationinforecptr (find-mactype '(:pointer :vdcommunicationinforec)))
(defrecord VDCommunicationInfoRec 
   (csBusID :signed-long)                       ;   kVideoDefaultBus for single headed cards.  
   (csBusType :unsigned-long)                   ;   See kVideoBusI2C etc. 
   (csMinBus :signed-long)                      ;   Minimum bus (usually kVideoDefaultBus).  Used to probe additional busses 
   (csMaxBus :signed-long)                      ;   Max bus (usually kVideoDefaultBus).  Used to probe additional busses 
   (csSupportedTypes :unsigned-long)            ;   Bit field for first 32 supported transaction types.  Eg. 0x07 => support for kVideoNoTransactionType, kVideoSimpleI2CType and kVideoDDCciReplyType. 
   (csSupportedCommFlags :unsigned-long)        ;   Return the flags csCommFlags understood by this driver. 
   (csReserved2 :unsigned-long)                 ;   Always zero 
   (csReserved3 :unsigned-long)                 ;   Always zero 
   (csReserved4 :unsigned-long)                 ;   Always zero 
   (csReserved5 :unsigned-long)                 ;   Always zero 
   (csReserved6 :unsigned-long)                 ;   Always zero 
   (csReserved7 :unsigned-long)                 ;   Always zero 
   )

(def-mactype :vdcommunicationinfoptr (find-mactype '(:pointer :vdcommunicationinforec)))
(def-mactype :vdscalerrecptr (find-mactype '(:pointer :vdscalerrec)))
(defrecord VDScalerRec 
   (csScalerSize :unsigned-long)                ;   Init to sizeof(VDScalerRec) 
   (csScalerVersion :unsigned-long)             ;   Init to 0 
   (csReserved1 :unsigned-long)                 ;   Init to 0 
   (csReserved2 :unsigned-long)                 ;   Init to 0 
   (csDisplayModeID :unsigned-long)             ;   Display Mode ID modified by this call. 
   (csDisplayModeSeed :unsigned-long)           ;    
   (csDisplayModeState :unsigned-long)          ;   Display Mode state 
   (csReserved3 :unsigned-long)                 ;   Init to 0 
   (csScalerFlags :unsigned-long)               ;   Init to 0 
   (csHorizontalPixels :unsigned-long)          ;   Graphics system addressable pixels 
   (csVerticalPixels :unsigned-long)            ;   Graphics system addressable lines 
   (csReserved4 :unsigned-long)                 ;   Init to 0 
   (csReserved5 :unsigned-long)                 ;   Init to 0 
   (csReserved6 :unsigned-long)                 ;   Init to 0 
   (csReserved7 :unsigned-long)                 ;   Init to 0 
   (csReserved8 :unsigned-long)                 ;   Init to 0 
   )

(def-mactype :vdscalerptr (find-mactype '(:pointer :vdscalerrec)))
(def-mactype :vdscalerinforecptr (find-mactype '(:pointer :vdscalerinforec)))
(defrecord VDScalerInfoRec 
   (csScalerInfoSize :unsigned-long)            ;   Init to sizeof(VDScalerInfoRec) 
   (csScalerInfoVersion :unsigned-long)         ;   Init to 0 
   (csReserved1 :unsigned-long)                 ;   Init to 0 
   (csReserved2 :unsigned-long)                 ;   Init to 0 
   (csScalerFeatures :unsigned-long)            ;   Feature flags 
   (csMaxHorizontalPixels :unsigned-long)       ;   limit to horizontal scaled pixels 
   (csMaxVerticalPixels :unsigned-long)         ;   limit to vertical scaled pixels 
   (csReserved3 :unsigned-long)                 ;   Init to 0 
   (csReserved4 :unsigned-long)                 ;   Init to 0 
   (csReserved5 :unsigned-long)                 ;   Init to 0 
   (csReserved6 :unsigned-long)                 ;   Init to 0 
   (csReserved7 :unsigned-long)                 ;   Init to 0 
   )

(def-mactype :vdscalerinfoptr (find-mactype '(:pointer :vdscalerinforec)))

;   csMirrorFeatures 
(defconstant $kMirrorSameDepthOnlyMirrorMask #x1);   Commonly true - Mirroring can only be done if the displays are the same bitdepth 
(defconstant $kMirrorSameSizeOnlyMirrorMask #x2);   Commonly false - Mirroring can only be done if the displays are the same size 
(defconstant $kMirrorSameTimingOnlyMirrorMask #x4);   Sometimes true - Mirroring can only be done if the displays are the same timing 
(defconstant $kMirrorCommonGammaMask #x8)       ;   Sometimes true - Only one gamma correction LUT. 

;   csMirrorSupportedFlags and csMirrorFlags 
(defconstant $kMirrorCanMirrorMask #x1)         ;   Set means we can HW mirrored right now (uses csMirrorEntryID) 
(defconstant $kMirrorAreMirroredMask #x2)       ;   Set means we are HW mirrored right now (uses csMirrorEntryID) 
(defconstant $kMirrorUnclippedMirrorMask #x4)   ;   Set means mirrored displays are not clipped to their intersection 
(defconstant $kMirrorHAlignCenterMirrorMask #x8);   Set means mirrored displays can/should be centered horizontally 
(defconstant $kMirrorVAlignCenterMirrorMask #x10);   Set means mirrored displays can/should be centered vertically 
(defconstant $kMirrorCanChangePixelFormatMask #x20);   Set means mirrored the device should change the pixel format of mirrored displays to allow mirroring. 
(defconstant $kMirrorCanChangeTimingMask #x40)  ;   Set means mirrored the device should change the timing of mirrored displays to allow mirroring. 

(def-mactype :vdmirrorrecptr (find-mactype '(:pointer :vdmirrorrec)))
(defrecord VDMirrorRec 
   (csMirrorSize :unsigned-long)                ;   Init to sizeof(VDMirrorRec) 
   (csMirrorVersion :unsigned-long)             ;   Init to 0 
   (csMirrorRequestID :regentryid)              ;   Input RegEntryID to check for mirroring support and state 
   (csMirrorResultID :regentryid)               ;   Output RegEntryID of the next mirrored device 
   (csMirrorFeatures :unsigned-long)            ;   Output summary features of the driver 
   (csMirrorSupportedFlags :unsigned-long)      ;   Output configuration options supported by the driver 
   (csMirrorFlags :unsigned-long)               ;   Output configuration options active now 
   (csReserved1 :unsigned-long)                 ;   Init to 0 
   (csReserved2 :unsigned-long)                 ;   Init to 0 
   (csReserved3 :unsigned-long)                 ;   Init to 0 
   (csReserved4 :unsigned-long)                 ;   Init to 0 
   (csReserved5 :unsigned-long)                 ;   Init to 0 
   )

(def-mactype :vdmirrorptr (find-mactype '(:pointer :vdmirrorrec)))
; $ALIGN RESET
; $POP

; $SETC UsingIncludes := VideoIncludes

; $ENDC                                         ; __VIDEO__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Video)