(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:VideoServices.p"
; at Wednesday May 1,2002 2:42:59 pm.
; 
;      File:       VideoServices.p
;  
;      Contains:   Video Services Library Interfaces.
;  
;      Version:    Technology: PowerSurge 1.0.2
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1994-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __VIDEOSERVICES__
; $SETC __VIDEOSERVICES__ := 1

; $I+
; $SETC VideoServicesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __NAMEREGISTRY__
|#

(require-interface 'NameRegistry)
#|                                              ; $I NameRegistry.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $kTransparentEncoding 0)
(defconstant $kInvertingEncoding 1)

(defconstant $kTransparentEncodingShift #x0)
(defconstant $kTransparentEncodedPixel #x1)
(defconstant $kInvertingEncodingShift #x2)
(defconstant $kInvertingEncodedPixel #x4)

(defconstant $kHardwareCursorDescriptorMajorVersion #x1)
(defconstant $kHardwareCursorDescriptorMinorVersion #x0)

(def-mactype :uint32ptr (find-mactype '(:pointer :unsigned-long)))
(def-mactype :hardwarecursordescriptorrecptr (find-mactype '(:pointer :hardwarecursordescriptorrec)))
(defrecord HardwareCursorDescriptorRec 
   (majorVersion :unsigned-integer)
   (minorVersion :unsigned-integer)
   (height :unsigned-long)
   (width :unsigned-long)
   (bitDepth :unsigned-long)
   (maskBitDepth :unsigned-long)
   (numColors :unsigned-long)
   (colorEncodings (:pointer :unsigned-long))
   (flags :unsigned-long)
   (supportedSpecialEncodings :unsigned-long)
   (specialEncodings (:array :unsigned-long 16))
   )

(def-mactype :hardwarecursordescriptorptr (find-mactype '(:pointer :hardwarecursordescriptorrec)))

(defconstant $kHardwareCursorInfoMajorVersion #x1)
(defconstant $kHardwareCursorInfoMinorVersion #x0)

(def-mactype :hardwarecursorinforecptr (find-mactype '(:pointer :hardwarecursorinforec)))
(defrecord HardwareCursorInfoRec 
   (majorVersion :unsigned-integer)             ;   Test tool should check for kHardwareCursorInfoMajorVersion1 
   (minorVersion :unsigned-integer)             ;   Test tool should check for kHardwareCursorInfoMinorVersion1 
   (cursorHeight :unsigned-long)
   (cursorWidth :unsigned-long)
   (colorMap (:pointer :colortable))            ;   nil or big enough for hardware's max colors 
   (hardwareCursor :pointer)
   (reserved (:array :unsigned-long 6))         ;   Test tool should check for 0s 
   )

(def-mactype :hardwarecursorinfoptr (find-mactype '(:pointer :hardwarecursorinforec)))

(defconstant $kVBLInterruptServiceType :|vbl |)
(defconstant $kHBLInterruptServiceType :|hbl |)
(defconstant $kFrameInterruptServiceType :|fram|)
(defconstant $kConnectInterruptServiceType :|dci |);   Renamed -- Use kFBCheckInterruptServiceType 
(defconstant $kFBConnectInterruptServiceType :|dci |);   Demand to check configuration (Hardware unchanged) 
(defconstant $kFBChangedInterruptServiceType :|chng|);   Demand to rebuild (Hardware has reinitialized on dependent change) 
(defconstant $kFBOfflineInterruptServiceType :|remv|);   Demand to remove framebuffer (Hardware not available on dependent change -- but must not buserror) 
(defconstant $kFBOnlineInterruptServiceType :|add |);   Notice that hardware is available (after being removed) 

(defconstant $kMaxDisplayConfigDataSize 64)     ;   Max data size for VSLSetDisplayConfiguration 

(def-mactype :interruptservicetype (find-mactype ':ostype))
(def-mactype :interruptserviceidtype (find-mactype ':unsigned-long))
(def-mactype :interruptserviceidptr (find-mactype '(:pointer :unsigned-long)))
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  VSLNewInterruptService()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in VideoServicesLib 1.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_VSLNewInterruptService" 
      ((serviceDevice (:pointer :regentryid)) (serviceType :ostype) (serviceID (:pointer :unsigned-long))) 
  :signed-integer
   () )

; 
;  *  VSLWaitOnInterruptService()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in VideoServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_VSLWaitOnInterruptService" 
      ((serviceID :unsigned-long) (timeout :signed-long)) 
  :signed-integer
   () )

; 
;  *  VSLDisposeInterruptService()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in VideoServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_VSLDisposeInterruptService" 
      ((serviceID :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  VSLDoInterruptService()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in VideoServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_VSLDoInterruptService" 
      ((serviceID :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  VSLPrepareCursorForHardwareCursor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in VideoServicesLib 1.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_VSLPrepareCursorForHardwareCursor" 
      ((cursorRef :pointer) (hardwareDescriptor (:pointer :hardwarecursordescriptorrec)) (hwCursorInfo (:pointer :hardwarecursorinforec))) 
  :boolean
   () )

; 
;  *  VSLSetDisplayConfiguration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_VSLSetDisplayConfiguration" 
      ((device (:pointer :regentryid)) (propertyName (:pointer :character)) (configData :pointer) (configDataSize :signed-long)) 
  :signed-integer
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := VideoServicesIncludes

; $ENDC                                         ; __VIDEOSERVICES__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'VideoServices)