;form to reload plasm code files only
(defun RELOAD-PLASM-FILES ()
  (progn 
    (setf *warn-if-redefine* nil)
    (mapcar (function load)
            (let ((dir-path (choose-directory-dialog)))
              (mapcar #'(lambda (x) (make-pathname :directory dir-path
                                                   :name (string x)
                                                   :type "lsp"))
                      '( 
                        ;the commented lines are for the untouched files 
                        ;  not necessary condition!
                        ; grm       ;this cannot be changed
                        ; s_ambig   ;this cannot be changed
                        ; syntax
                        ; lex       ;not changed yet
                         struct
                        error
                         eval_p
                         eval_def
                        p_misc    
                        ; inout     ;not changed yet
                        p_vrml
                        p_iv
                        anim

                        
                        fenvs
                        ))))
    (setf *warn-if-redefine* T)))

(RELOAD-PLASM-FILES)
  