(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:AEObjects.p"
; at Wednesday May 1,2002 2:39:33 pm.
; 
;      File:       AEObjects.p
;  
;      Contains:   Object Support Library Interfaces.
;  
;      Version:    Technology: System 8.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1991-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __AEOBJECTS__
; $SETC __AEOBJECTS__ := 1

; $I+
; $SETC AEObjectsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __OSUTILS__
|#

(require-interface 'OSUtils)
#|                                              ; $I OSUtils.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __APPLEEVENTS__
|#

(require-interface 'AppleEvents)
#|                                              ; $I AppleEvents.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  *** LOGICAL OPERATOR CONSTANTS  *** 
(defconstant $kAEAND :|AND |)                   ;    0x414e4420   
(defconstant $kAEOR :|OR  |)                    ;    0x4f522020   
(defconstant $kAENOT :|NOT |)                   ;    0x4e4f5420   
;  *** ABSOLUTE ORDINAL CONSTANTS  *** 
(defconstant $kAEFirst :|firs|)                 ;    0x66697273   
(defconstant $kAELast :|last|)                  ;    0x6c617374   
(defconstant $kAEMiddle :|midd|)                ;    0x6d696464   
(defconstant $kAEAny :|any |)                   ;    0x616e7920   
(defconstant $kAEAll :|all |)                   ;    0x616c6c20   
;  *** RELATIVE ORDINAL CONSTANTS  *** 
(defconstant $kAENext :|next|)                  ;    0x6e657874   
(defconstant $kAEPrevious :|prev|)              ;    0x70726576   
;  *** KEYWORD CONSTANT    *** 
(defconstant $keyAECompOperator :|relo|)        ;    0x72656c6f   
(defconstant $keyAELogicalTerms :|term|)        ;    0x7465726d   
(defconstant $keyAELogicalOperator :|logc|)     ;    0x6c6f6763   
(defconstant $keyAEObject1 :|obj1|)             ;    0x6f626a31   
(defconstant $keyAEObject2 :|obj2|)             ;    0x6f626a32   
;      ... for Keywords for getting fields out of object specifier records.  
(defconstant $keyAEDesiredClass :|want|)        ;    0x77616e74   
(defconstant $keyAEContainer :|from|)           ;    0x66726f6d   
(defconstant $keyAEKeyForm :|form|)             ;    0x666f726d   
(defconstant $keyAEKeyData :|seld|)             ;    0x73656c64   

;      ... for Keywords for getting fields out of Range specifier records.  
(defconstant $keyAERangeStart :|star|)          ;    0x73746172   
(defconstant $keyAERangeStop :|stop|)           ;    0x73746f70   
;      ... special handler selectors for OSL Callbacks.  
(defconstant $keyDisposeTokenProc :|xtok|)      ;    0x78746f6b   
(defconstant $keyAECompareProc :|cmpr|)         ;    0x636d7072   
(defconstant $keyAECountProc :|cont|)           ;    0x636f6e74   
(defconstant $keyAEMarkTokenProc :|mkid|)       ;    0x6d6b6964   
(defconstant $keyAEMarkProc :|mark|)            ;    0x6d61726b   
(defconstant $keyAEAdjustMarksProc :|adjm|)     ;    0x61646a6d   
(defconstant $keyAEGetErrDescProc :|indc|)      ;    0x696e6463   

; 	***   VALUE and TYPE CONSTANTS    ***	
;      ... possible values for the keyAEKeyForm field of an object specifier.  
(defconstant $formAbsolutePosition :|indx|)     ;    0x696e6478   
(defconstant $formRelativePosition :|rele|)     ;    0x72656c65   
(defconstant $formTest :|test|)                 ;    0x74657374   
(defconstant $formRange :|rang|)                ;    0x72616e67   
(defconstant $formPropertyID :|prop|)           ;    0x70726f70   
(defconstant $formName :|name|)                 ;    0x6e616d65   
;      ... relevant types (some of these are often pared with forms above).  
(defconstant $typeObjectSpecifier :|obj |)      ;    0x6f626a20   
(defconstant $typeObjectBeingExamined :|exmn|)  ;    0x65786d6e   
(defconstant $typeCurrentContainer :|ccnt|)     ;    0x63636e74   
(defconstant $typeToken :|toke|)                ;    0x746f6b65   
(defconstant $typeRelativeDescriptor :|rel |)   ;    0x72656c20   
(defconstant $typeAbsoluteOrdinal :|abso|)      ;    0x6162736f   
(defconstant $typeIndexDescriptor :|inde|)      ;    0x696e6465   
(defconstant $typeRangeDescriptor :|rang|)      ;    0x72616e67   
(defconstant $typeLogicalDescriptor :|logi|)    ;    0x6c6f6769   
(defconstant $typeCompDescriptor :|cmpd|)       ;    0x636d7064   
(defconstant $typeOSLTokenList :|ostl|)         ;    0x6F73746C   

; 	 Possible values for flags parameter to AEResolve.  They're additive 	
(defconstant $kAEIDoMinimum #x0)
(defconstant $kAEIDoWhose #x1)
(defconstant $kAEIDoMarking #x4)
(defconstant $kAEPassSubDescs #x8)
(defconstant $kAEResolveNestedLists #x10)
(defconstant $kAEHandleSimpleRanges #x20)
(defconstant $kAEUseRelativeIterators #x40)

; 	*** SPECIAL CONSTANTS FOR CUSTOM WHOSE-CLAUSE RESOLUTION 	
(defconstant $typeWhoseDescriptor :|whos|)      ;    0x77686f73   
(defconstant $formWhose :|whos|)                ;    0x77686f73   
(defconstant $typeWhoseRange :|wrng|)           ;    0x77726e67   
(defconstant $keyAEWhoseRangeStart :|wstr|)     ;    0x77737472   
(defconstant $keyAEWhoseRangeStop :|wstp|)      ;    0x77737470   
(defconstant $keyAEIndex :|kidx|)               ;    0x6b696478   
(defconstant $keyAETest :|ktst|)                ;    0x6b747374   

; 	
; 	    used for rewriting tokens in place of 'ccnt' descriptors
; 	    This record is only of interest to those who, when they...
; 	    ...get ranges as key data in their accessor procs, choose
; 	    ...to resolve them manually rather than call AEResolve again.
; 		

(def-mactype :ccnttokenrecordptr (find-mactype '(:pointer :ccnttokenrecord)))
(defrecord ccntTokenRecord 
   (tokenClass :ostype)
   (token :aedesc)
   )

(def-mactype :ccnttokenrecptr (find-mactype '(:pointer :ccnttokenrecord)))
(def-mactype :ccnttokenrechandle (find-mactype '(:handle :ccnttokenrecord)))
; $IFC OLDROUTINENAMES 
(def-mactype :descptr (find-mactype '(:pointer :aedesc)))
(def-mactype :deschandle (find-mactype '(:handle :aedesc)))
; $ENDC                                         ; OLDROUTINENAMES

; 	 typedefs providing type checking for procedure pointers 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	OSLAccessorProcPtr = FUNCTION(desiredClass: DescType; {CONST}VAR container: AEDesc; containerClass: DescType; form: DescType; {CONST}VAR selectionData: AEDesc; VAR value: AEDesc; accessorRefcon: LONGINT): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :oslaccessorprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	OSLCompareProcPtr = FUNCTION(oper: DescType; {CONST}VAR obj1: AEDesc; {CONST}VAR obj2: AEDesc; VAR result: BOOLEAN): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :oslcompareprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	OSLCountProcPtr = FUNCTION(desiredType: DescType; containerClass: DescType; {CONST}VAR container: AEDesc; VAR result: LONGINT): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :oslcountprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	OSLDisposeTokenProcPtr = FUNCTION(VAR unneededToken: AEDesc): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :osldisposetokenprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	OSLGetMarkTokenProcPtr = FUNCTION({CONST}VAR dContainerToken: AEDesc; containerClass: DescType; VAR result: AEDesc): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :oslgetmarktokenprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	OSLGetErrDescProcPtr = FUNCTION(VAR appDescPtr: AEDescPtr): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :oslgeterrdescprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	OSLMarkProcPtr = FUNCTION({CONST}VAR dToken: AEDesc; {CONST}VAR markToken: AEDesc; index: LONGINT): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :oslmarkprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	OSLAdjustMarksProcPtr = FUNCTION(newStart: LONGINT; newStop: LONGINT; {CONST}VAR markToken: AEDesc): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :osladjustmarksprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :oslaccessorupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :oslaccessorupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :oslcompareupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :oslcompareupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :oslcountupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :oslcountupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :osldisposetokenupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :osldisposetokenupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :oslgetmarktokenupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :oslgetmarktokenupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :oslgeterrdescupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :oslgeterrdescupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :oslmarkupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :oslmarkupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :osladjustmarksupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :osladjustmarksupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppOSLAccessorProcInfo #xFFFE0)
(defconstant $uppOSLCompareProcInfo #x3FE0)
(defconstant $uppOSLCountProcInfo #x3FE0)
(defconstant $uppOSLDisposeTokenProcInfo #xE0)
(defconstant $uppOSLGetMarkTokenProcInfo #xFE0)
(defconstant $uppOSLGetErrDescProcInfo #xE0)
(defconstant $uppOSLMarkProcInfo #xFE0)
(defconstant $uppOSLAdjustMarksProcInfo #xFE0)
; 
; 	 *  NewOSLAccessorUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewOSLAccessorProc 
(deftrap "_NewOSLAccessorUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewOSLCompareUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewOSLCompareProc 
(deftrap "_NewOSLCompareUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewOSLCountUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewOSLCountProc 
(deftrap "_NewOSLCountUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewOSLDisposeTokenUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewOSLDisposeTokenProc 
(deftrap "_NewOSLDisposeTokenUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewOSLGetMarkTokenUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewOSLGetMarkTokenProc 
(deftrap "_NewOSLGetMarkTokenUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewOSLGetErrDescUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewOSLGetErrDescProc 
(deftrap "_NewOSLGetErrDescUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewOSLMarkUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewOSLMarkProc 
(deftrap "_NewOSLMarkUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewOSLAdjustMarksUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewOSLAdjustMarksProc 
(deftrap "_NewOSLAdjustMarksUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeOSLAccessorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeOSLAccessorUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeOSLCompareUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeOSLCompareUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeOSLCountUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeOSLCountUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeOSLDisposeTokenUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeOSLDisposeTokenUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeOSLGetMarkTokenUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeOSLGetMarkTokenUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeOSLGetErrDescUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeOSLGetErrDescUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeOSLMarkUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeOSLMarkUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeOSLAdjustMarksUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeOSLAdjustMarksUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeOSLAccessorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST;  old name was CallOSLAccessorProc 
(deftrap-inline "_InvokeOSLAccessorUPP" 
      ((desiredClass :ostype) (container (:pointer :aedesc)) (containerClass :ostype) (form :ostype) (selectionData (:pointer :aedesc)) (value (:pointer :aedesc)) (accessorRefcon :signed-long) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeOSLCompareUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST;  old name was CallOSLCompareProc 
(deftrap-inline "_InvokeOSLCompareUPP" 
      ((oper :ostype) (obj1 (:pointer :aedesc)) (obj2 (:pointer :aedesc)) (result (:pointer :boolean)) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeOSLCountUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ;  old name was CallOSLCountProc 
(deftrap-inline "_InvokeOSLCountUPP" 
      ((desiredType :ostype) (containerClass :ostype) (container (:pointer :aedesc)) (result (:pointer :signed-long)) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeOSLDisposeTokenUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallOSLDisposeTokenProc 
(deftrap-inline "_InvokeOSLDisposeTokenUPP" 
      ((unneededToken (:pointer :aedesc)) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeOSLGetMarkTokenUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ;  old name was CallOSLGetMarkTokenProc 
(deftrap-inline "_InvokeOSLGetMarkTokenUPP" 
      ((dContainerToken (:pointer :aedesc)) (containerClass :ostype) (result (:pointer :aedesc)) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeOSLGetErrDescUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallOSLGetErrDescProc 
(deftrap-inline "_InvokeOSLGetErrDescUPP" 
      ((appDescPtr (:pointer (:pointer :aedesc))) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeOSLMarkUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST;  old name was CallOSLMarkProc 
(deftrap-inline "_InvokeOSLMarkUPP" 
      ((dToken (:pointer :aedesc)) (markToken (:pointer :aedesc)) (index :signed-long) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeOSLAdjustMarksUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ;  old name was CallOSLAdjustMarksProc 
(deftrap-inline "_InvokeOSLAdjustMarksUPP" 
      ((newStart :signed-long) (newStop :signed-long) (markToken (:pointer :aedesc)) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  AEObjectInit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ObjectSupportLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  Not done by inline, but by direct linking into code.  It sets up the pack
;   such that further calls can be via inline   ; 
;  *  AESetObjectCallbacks()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ObjectSupportLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_AEObjectInit" 
      () 
  :signed-integer
   () )
(deftrap "_AESetObjectCallbacks" 
      ((myCompareProc :pointer) (myCountProc :pointer) (myDisposeTokenProc :pointer) (myGetMarkTokenProc :pointer) (myMarkProc :pointer) (myAdjustMarksProc :pointer) (myGetErrDescProcPtr :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 3637 myCompareProc myCountProc myDisposeTokenProc myGetMarkTokenProc myMarkProc myAdjustMarksProc myGetErrDescProcPtr))

; 
;  *  AEResolve()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ObjectSupportLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_AEResolve" 
      ((objectSpecifier (:pointer :aedesc)) (callbackFlags :signed-integer) (theToken (:pointer :aedesc)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 1334 objectSpecifier callbackFlags theToken))

; 
;  *  AEInstallObjectAccessor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ObjectSupportLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AEInstallObjectAccessor" 
      ((desiredClass :ostype) (containerType :ostype) (theAccessor :pointer) (accessorRefcon :signed-long) (isSysHandler :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 2359 desiredClass containerType theAccessor accessorRefcon isSysHandler))

; 
;  *  AERemoveObjectAccessor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ObjectSupportLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AERemoveObjectAccessor" 
      ((desiredClass :ostype) (containerType :ostype) (theAccessor :pointer) (isSysHandler :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 1848 desiredClass containerType theAccessor isSysHandler))

; 
;  *  AEGetObjectAccessor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ObjectSupportLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AEGetObjectAccessor" 
      ((desiredClass :ostype) (containerType :ostype) (accessor (:pointer :pointer)) (accessorRefcon (:pointer :signed-long)) (isSysHandler :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 2361 desiredClass containerType accessor accessorRefcon isSysHandler))

; 
;  *  AEDisposeToken()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ObjectSupportLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AEDisposeToken" 
      ((theToken (:pointer :aedesc)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 570 theToken))

; 
;  *  AECallObjectAccessor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ObjectSupportLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap "_AECallObjectAccessor" 
      ((desiredClass :ostype) (containerToken (:pointer :aedesc)) (containerClass :ostype) (keyForm :ostype) (keyData (:pointer :aedesc)) (token (:pointer :aedesc)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 3131 desiredClass containerToken containerClass keyForm keyData token))

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := AEObjectsIncludes

; $ENDC                                         ; __AEOBJECTS__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'AEObjects)