(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Appearance.p"
; at Wednesday May 1,2002 2:39:35 pm.
; 
;      File:       Appearance.p
;  
;      Contains:   Appearance Manager Interfaces.
;  
;      Version:    Technology: Mac OS 9
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1994-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __APPEARANCE__
; $SETC __APPEARANCE__ := 1

; $I+
; $SETC AppearanceIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __TEXTEDIT__

(require-interface 'TextEdit)                   ; $I TextEdit.p
; $ENDC
; $IFC UNDEFINED __QDOFFSCREEN__

(require-interface 'QDOffscreen)                ; $I QDOffscreen.p
; $ENDC
; $IFC UNDEFINED __MACWINDOWS__

(require-interface 'MacWindows)                 ; $I MacWindows.p
; $ENDC
; $IFC UNDEFINED __CONTROLS__

(require-interface 'Controls)                   ; $I Controls.p
; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __TEXTUTILS__

(require-interface 'TextUtils)                  ; $I TextUtils.p
; $ENDC
#|                                              ; $IFC UNDEFINED __CFSTRING__
|#

(require-interface 'CFString)
#|                                              ; $I CFString.p
 |#                                             ; $ENDC
; 
;  Appearance Manager constants, etc.                                               
; 
;  Appearance Manager Apple Events (1.1 and later)              

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $kAppearanceEventClass :|appr|)    ;   Event Class  
(defconstant $kAEAppearanceChanged :|thme|)     ;   Appearance changed (e.g. platinum to hi-tech)  
(defconstant $kAESystemFontChanged :|sysf|)     ;   system font changed  
(defconstant $kAESmallSystemFontChanged :|ssfn|);   small system font changed  
(defconstant $kAEViewsFontChanged :|vfnt|)      ;   views font changed  

; 		
; 	 Appearance Manager file types                                                    	
; 		
(defconstant $kThemeDataFileType :|thme|)       ;   file type for theme files  
(defconstant $kThemePlatinumFileType :|pltn|)   ;   file type for platinum appearance  
(defconstant $kThemeCustomThemesFileType :|scen|);   file type for user themes  
(defconstant $kThemeSoundTrackFileType :|tsnd|)

; 		
; 	 Appearance Manager Supported Themes                                              	
; 	 Use CopyThemeIdentifier to get the current theme ID                              	
; 		
(defconstant $kThemeBrushDialogBackgroundActive 1);   Dialogs  
(defconstant $kThemeBrushDialogBackgroundInactive 2);   Dialogs  
(defconstant $kThemeBrushAlertBackgroundActive 3)
(defconstant $kThemeBrushAlertBackgroundInactive 4)
(defconstant $kThemeBrushModelessDialogBackgroundActive 5)
(defconstant $kThemeBrushModelessDialogBackgroundInactive 6)
(defconstant $kThemeBrushUtilityWindowBackgroundActive 7);   Miscellaneous  
(defconstant $kThemeBrushUtilityWindowBackgroundInactive 8);   Miscellaneous  
(defconstant $kThemeBrushListViewSortColumnBackground 9);   Finder  
(defconstant $kThemeBrushListViewBackground 10)
(defconstant $kThemeBrushIconLabelBackground 11)
(defconstant $kThemeBrushListViewSeparator 12)
(defconstant $kThemeBrushChasingArrows 13)
(defconstant $kThemeBrushDragHilite 14)
(defconstant $kThemeBrushDocumentWindowBackground 15)
(defconstant $kThemeBrushFinderWindowBackground 16)

; 	 Brushes available in Appearance 1.1 or later 	
(defconstant $kThemeBrushScrollBarDelimiterActive 17)
(defconstant $kThemeBrushScrollBarDelimiterInactive 18)
(defconstant $kThemeBrushFocusHighlight 19)
(defconstant $kThemeBrushPopupArrowActive 20)
(defconstant $kThemeBrushPopupArrowPressed 21)
(defconstant $kThemeBrushPopupArrowInactive 22)
(defconstant $kThemeBrushAppleGuideCoachmark 23)
(defconstant $kThemeBrushIconLabelBackgroundSelected 24)
(defconstant $kThemeBrushStaticAreaFill 25)
(defconstant $kThemeBrushActiveAreaFill 26)
(defconstant $kThemeBrushButtonFrameActive 27)
(defconstant $kThemeBrushButtonFrameInactive 28)
(defconstant $kThemeBrushButtonFaceActive 29)
(defconstant $kThemeBrushButtonFaceInactive 30)
(defconstant $kThemeBrushButtonFacePressed 31)
(defconstant $kThemeBrushButtonActiveDarkShadow 32)
(defconstant $kThemeBrushButtonActiveDarkHighlight 33)
(defconstant $kThemeBrushButtonActiveLightShadow 34)
(defconstant $kThemeBrushButtonActiveLightHighlight 35)
(defconstant $kThemeBrushButtonInactiveDarkShadow 36)
(defconstant $kThemeBrushButtonInactiveDarkHighlight 37)
(defconstant $kThemeBrushButtonInactiveLightShadow 38)
(defconstant $kThemeBrushButtonInactiveLightHighlight 39)
(defconstant $kThemeBrushButtonPressedDarkShadow 40)
(defconstant $kThemeBrushButtonPressedDarkHighlight 41)
(defconstant $kThemeBrushButtonPressedLightShadow 42)
(defconstant $kThemeBrushButtonPressedLightHighlight 43)
(defconstant $kThemeBrushBevelActiveLight 44)
(defconstant $kThemeBrushBevelActiveDark 45)
(defconstant $kThemeBrushBevelInactiveLight 46)
(defconstant $kThemeBrushBevelInactiveDark 47)

; 	 Brushes available in Appearance 1.1.1 or later 	
(defconstant $kThemeBrushNotificationWindowBackground 48)

; 	 Brushes available in Appearance X or later 	
(defconstant $kThemeBrushMovableModalBackground 49)
(defconstant $kThemeBrushSheetBackgroundOpaque 50)
(defconstant $kThemeBrushDrawerBackground 51)
(defconstant $kThemeBrushToolbarBackground 52)
(defconstant $kThemeBrushSheetBackgroundTransparent 53)

; 	 Appearance X or later theme brush compatibility synonyms 	
(defconstant $kThemeBrushSheetBackground 50)

; 	 These values are meta-brushes, specific colors that do not       	
; 	 change from theme to theme. You can use them instead of using    	
; 	 direct RGB values.                                               	
(defconstant $kThemeBrushBlack -1)
(defconstant $kThemeBrushWhite -2)

(def-mactype :themebrush (find-mactype ':signed-integer))

(defconstant $kThemeTextColorDialogActive 1)
(defconstant $kThemeTextColorDialogInactive 2)
(defconstant $kThemeTextColorAlertActive 3)
(defconstant $kThemeTextColorAlertInactive 4)
(defconstant $kThemeTextColorModelessDialogActive 5)
(defconstant $kThemeTextColorModelessDialogInactive 6)
(defconstant $kThemeTextColorWindowHeaderActive 7)
(defconstant $kThemeTextColorWindowHeaderInactive 8)
(defconstant $kThemeTextColorPlacardActive 9)
(defconstant $kThemeTextColorPlacardInactive 10)
(defconstant $kThemeTextColorPlacardPressed 11)
(defconstant $kThemeTextColorPushButtonActive 12)
(defconstant $kThemeTextColorPushButtonInactive 13)
(defconstant $kThemeTextColorPushButtonPressed 14)
(defconstant $kThemeTextColorBevelButtonActive 15)
(defconstant $kThemeTextColorBevelButtonInactive 16)
(defconstant $kThemeTextColorBevelButtonPressed 17)
(defconstant $kThemeTextColorPopupButtonActive 18)
(defconstant $kThemeTextColorPopupButtonInactive 19)
(defconstant $kThemeTextColorPopupButtonPressed 20)
(defconstant $kThemeTextColorIconLabel 21)
(defconstant $kThemeTextColorListView 22)

; 	 Text Colors available in Appearance 1.0.1 or later 	
(defconstant $kThemeTextColorDocumentWindowTitleActive 23)
(defconstant $kThemeTextColorDocumentWindowTitleInactive 24)
(defconstant $kThemeTextColorMovableModalWindowTitleActive 25)
(defconstant $kThemeTextColorMovableModalWindowTitleInactive 26)
(defconstant $kThemeTextColorUtilityWindowTitleActive 27)
(defconstant $kThemeTextColorUtilityWindowTitleInactive 28)
(defconstant $kThemeTextColorPopupWindowTitleActive 29)
(defconstant $kThemeTextColorPopupWindowTitleInactive 30)
(defconstant $kThemeTextColorRootMenuActive 31)
(defconstant $kThemeTextColorRootMenuSelected 32)
(defconstant $kThemeTextColorRootMenuDisabled 33)
(defconstant $kThemeTextColorMenuItemActive 34)
(defconstant $kThemeTextColorMenuItemSelected 35)
(defconstant $kThemeTextColorMenuItemDisabled 36)
(defconstant $kThemeTextColorPopupLabelActive 37)
(defconstant $kThemeTextColorPopupLabelInactive 38)

; 	 Text colors available in Appearance 1.1 or later 	
(defconstant $kThemeTextColorTabFrontActive 39)
(defconstant $kThemeTextColorTabNonFrontActive 40)
(defconstant $kThemeTextColorTabNonFrontPressed 41)
(defconstant $kThemeTextColorTabFrontInactive 42)
(defconstant $kThemeTextColorTabNonFrontInactive 43)
(defconstant $kThemeTextColorIconLabelSelected 44)
(defconstant $kThemeTextColorBevelButtonStickyActive 45)
(defconstant $kThemeTextColorBevelButtonStickyInactive 46)

; 	 Text colors available in Appearance 1.1.1 or later 	
(defconstant $kThemeTextColorNotification 47)

; 	 These values are specific colors that do not change from             	
; 	 theme to theme. You can use them instead of using direct RGB values. 	
(defconstant $kThemeTextColorBlack -1)
(defconstant $kThemeTextColorWhite -2)

(def-mactype :themetextcolor (find-mactype ':signed-integer))
; 	 States to draw primitives: disabled, active, and pressed (hilited) 	

(defconstant $kThemeStateInactive 0)
(defconstant $kThemeStateActive 1)
(defconstant $kThemeStatePressed 2)
(defconstant $kThemeStateRollover 6)
(defconstant $kThemeStateUnavailable 7)
(defconstant $kThemeStateUnavailableInactive 8)

; 	 obsolete name 	
(defconstant $kThemeStateDisabled 0)

(defconstant $kThemeStatePressedUp 2)           ;   draw with up pressed     (increment/decrement buttons)  
(defconstant $kThemeStatePressedDown 3)         ;   draw with down pressed (increment/decrement buttons)  

(def-mactype :themedrawstate (find-mactype ':unsigned-long))
; 		
; 	 Theme cursor selectors available in Appearance 1.1 or later                      	
; 		

(defconstant $kThemeArrowCursor 0)
(defconstant $kThemeCopyArrowCursor 1)
(defconstant $kThemeAliasArrowCursor 2)
(defconstant $kThemeContextualMenuArrowCursor 3)
(defconstant $kThemeIBeamCursor 4)
(defconstant $kThemeCrossCursor 5)
(defconstant $kThemePlusCursor 6)
(defconstant $kThemeWatchCursor 7)              ;   Can Animate  
(defconstant $kThemeClosedHandCursor 8)
(defconstant $kThemeOpenHandCursor 9)
(defconstant $kThemePointingHandCursor 10)
(defconstant $kThemeCountingUpHandCursor 11)    ;   Can Animate  
(defconstant $kThemeCountingDownHandCursor 12)  ;   Can Animate  
(defconstant $kThemeCountingUpAndDownHandCursor 13);   Can Animate  
(defconstant $kThemeSpinningCursor 14)          ;   Can Animate  
(defconstant $kThemeResizeLeftCursor 15)
(defconstant $kThemeResizeRightCursor 16)
(defconstant $kThemeResizeLeftRightCursor 17)

(def-mactype :themecursor (find-mactype ':unsigned-long))
; 		
; 	 Theme menu bar drawing states                                                    	
; 		

(defconstant $kThemeMenuBarNormal 0)
(defconstant $kThemeMenuBarSelected 1)

(def-mactype :thememenubarstate (find-mactype ':unsigned-integer))
; 	 attributes 	

(defconstant $kThemeMenuSquareMenuBar #x1)

; 		
; 	 Theme menu drawing states                                                        	
; 		
(defconstant $kThemeMenuActive 0)
(defconstant $kThemeMenuSelected 1)
(defconstant $kThemeMenuDisabled 3)

(def-mactype :thememenustate (find-mactype ':unsigned-integer))
; 		
; 	 MenuType: add kThemeMenuTypeInactive to menu type for DrawThemeMenuBackground if entire  	
; 	 menu is inactive                                                                         	
; 		

(defconstant $kThemeMenuTypePullDown 0)
(defconstant $kThemeMenuTypePopUp 1)
(defconstant $kThemeMenuTypeHierarchical 2)
(defconstant $kThemeMenuTypeInactive #x100)

(def-mactype :thememenutype (find-mactype ':unsigned-integer))

(defconstant $kThemeMenuItemPlain 0)
(defconstant $kThemeMenuItemHierarchical 1)     ;   item has hierarchical arrow 
(defconstant $kThemeMenuItemScrollUpArrow 2)    ;   for scrollable menus, indicates item is scroller 
(defconstant $kThemeMenuItemScrollDownArrow 3)
(defconstant $kThemeMenuItemAtTop #x100)        ;   indicates item is being drawn at top of menu 
(defconstant $kThemeMenuItemAtBottom #x200)     ;   indicates item is being drawn at bottom of menu 
(defconstant $kThemeMenuItemHierBackground #x400);   item is within a hierarchical menu 
(defconstant $kThemeMenuItemPopUpBackground #x800);   item is within a popped up menu 
(defconstant $kThemeMenuItemHasIcon #x8000)     ;   add into non-arrow type when icon present 
(defconstant $kThemeMenuItemNoBackground #x4000);   don't draw the menu background while drawing this item (Mac OS X only) 

(def-mactype :thememenuitemtype (find-mactype ':unsigned-integer))
; 		
; 	 Theme Backgrounds                                                                        	
; 		

(defconstant $kThemeBackgroundTabPane 1)
(defconstant $kThemeBackgroundPlacard 2)
(defconstant $kThemeBackgroundWindowHeader 3)
(defconstant $kThemeBackgroundListViewWindowHeader 4)
(defconstant $kThemeBackgroundSecondaryGroupBox 5)

(def-mactype :themebackgroundkind (find-mactype ':unsigned-long))
; 		
; 	 Theme Collection tags for Get/SetTheme                                                   	
; 	                                                                                          	
; 	  X ALERT: Please note that Get/SetTheme are severely neutered under Mac OS X at present. 	
; 	           The first group of tags below are available to get under both 9 and X. The     	
; 	           second group is 9 only. None of the tags can be used in SetTheme on X, as it   	
; 	           is completely inert on X, and will return unimpErr.                            	
; 		

(defconstant $kThemeNameTag :|name|)            ;   Str255 
(defconstant $kThemeVariantNameTag :|varn|)     ;   Str255 
(defconstant $kThemeVariantBaseTintTag :|tint|) ;   RGBColor (10.1 and later) 
(defconstant $kThemeHighlightColorTag :|hcol|)  ;   RGBColor 
(defconstant $kThemeScrollBarArrowStyleTag :|sbar|);   ThemeScrollBarArrowStyle 
(defconstant $kThemeScrollBarThumbStyleTag :|sbth|);   ThemeScrollBarThumbStyle 
(defconstant $kThemeSoundsEnabledTag :|snds|)   ;   Boolean 
(defconstant $kThemeDblClickCollapseTag :|coll|);   Boolean 

(defconstant $kThemeAppearanceFileNameTag :|thme|);   Str255 
(defconstant $kThemeSystemFontTag :|lgsf|)      ;   Str255 
(defconstant $kThemeSmallSystemFontTag :|smsf|) ;   Str255 
(defconstant $kThemeViewsFontTag :|vfnt|)       ;   Str255 
(defconstant $kThemeViewsFontSizeTag :|vfsz|)   ;   SInt16 
(defconstant $kThemeDesktopPatternNameTag :|patn|);   Str255 
(defconstant $kThemeDesktopPatternTag :|patt|)  ;   <variable-length data> (flattened pattern) 
(defconstant $kThemeDesktopPictureNameTag :|dpnm|);   Str255 
(defconstant $kThemeDesktopPictureAliasTag :|dpal|);   <alias handle> 
(defconstant $kThemeDesktopPictureAlignmentTag :|dpan|);   UInt32 (see the Picture Alignments below) 
(defconstant $kThemeHighlightColorNameTag :|hcnm|);   Str255 
(defconstant $kThemeExamplePictureIDTag :|epic|);   SInt16 
(defconstant $kThemeSoundTrackNameTag :|sndt|)  ;   Str255 
(defconstant $kThemeSoundMaskTag :|smsk|)       ;   UInt32 
(defconstant $kThemeUserDefinedTag :|user|)     ;   Boolean (this should _always_ be true if present - used by Control Panel). 
(defconstant $kThemeSmoothFontEnabledTag :|smoo|);   Boolean 
(defconstant $kThemeSmoothFontMinSizeTag :|smos|);   UInt16 (must be >= 12 and <= 24) 

;   Picture Aligmnents that might be reported in the data for kThemeDesktopPictureAlignmentTag 
(defconstant $kTiledOnScreen 1)                 ;   draws picture repeatedly 
(defconstant $kCenterOnScreen 2)                ;   "actual size", shows pattern on sides or clips picture if necessary 
(defconstant $kFitToScreen 3)                   ;   shrinks if necessary 
(defconstant $kFillScreen 4)                    ;   messes up aspect ratio if necessary 
(defconstant $kUseBestGuess 5)                  ;   heuristically determines the best way to display the picture based on picture and monitor sizes 

; 		
; 	 Theme Control Settings                                                                   	
; 		
(defconstant $kThemeCheckBoxClassicX 0)         ;   check box with an 'X' 
(defconstant $kThemeCheckBoxCheckMark 1)        ;   check box with a real check mark 

(def-mactype :themecheckboxstyle (find-mactype ':unsigned-integer))

(defconstant $kThemeScrollBarArrowsSingle 0)    ;   single arrow on each end 
(defconstant $kThemeScrollBarArrowsLowerRight 1);   double arrows only on right or bottom 

(def-mactype :themescrollbararrowstyle (find-mactype ':unsigned-integer))

(defconstant $kThemeScrollBarThumbNormal 0)     ;   normal, classic thumb size 
(defconstant $kThemeScrollBarThumbProportional 1);   proportional thumbs 

(def-mactype :themescrollbarthumbstyle (find-mactype ':unsigned-integer))
; 		
; 	 Font constants                                                                           	
; 		

; 
; 	 *  Summary:
; 	 *    A ThemeFontID value is a virtual font ID which can be passed to
; 	 *    one of the Appearance Manager's text-related routines. Within
; 	 *    those routines, the ThemeFontID is mapped into the appropriate
; 	 *    real font (or fonts), size, and style based on the system
; 	 *    appearance (Platinum on Mac OS 9, Aqua on Mac OS X), the string
; 	 *    to be rendered (if any), the language/ script that the app is
; 	 *    running in, and possibly other factors. The ThemeFontIDs allow
; 	 *    you to get the correct text appearance for the platform your app
; 	 *    is currently running on.
; 	 	

(defconstant $kThemeSystemFont 0)
(defconstant $kThemeSmallSystemFont 1)
(defconstant $kThemeSmallEmphasizedSystemFont 2)
(defconstant $kThemeViewsFont 3)                ;   The following ID's are only available with MacOS X or CarbonLib 1.3 and later 
(defconstant $kThemeEmphasizedSystemFont 4)
(defconstant $kThemeApplicationFont 5)
(defconstant $kThemeLabelFont 6)
(defconstant $kThemeMenuTitleFont 100)
(defconstant $kThemeMenuItemFont 101)
(defconstant $kThemeMenuItemMarkFont 102)
(defconstant $kThemeMenuItemCmdKeyFont 103)
(defconstant $kThemeWindowTitleFont 104)
(defconstant $kThemePushButtonFont 105)
(defconstant $kThemeUtilityWindowTitleFont 106)
(defconstant $kThemeAlertHeaderFont 107)
(defconstant $kThemeCurrentPortFont 200)

(def-mactype :themefontid (find-mactype ':unsigned-integer))
; 		
; 	 Tab constants                                                                            	
; 		

(defconstant $kThemeTabNonFront 0)
(defconstant $kThemeTabNonFrontPressed 1)
(defconstant $kThemeTabNonFrontInactive 2)
(defconstant $kThemeTabFront 3)
(defconstant $kThemeTabFrontInactive 4)
(defconstant $kThemeTabNonFrontUnavailable 5)
(defconstant $kThemeTabFrontUnavailable 6)

(def-mactype :themetabstyle (find-mactype ':unsigned-integer))

(defconstant $kThemeTabNorth 0)
(defconstant $kThemeTabSouth 1)
(defconstant $kThemeTabEast 2)
(defconstant $kThemeTabWest 3)

(def-mactype :themetabdirection (find-mactype ':unsigned-integer))
; 	 NOTE ON TAB HEIGHT                                                                       	
; 	 Use the kThemeSmallTabHeightMax and kThemeLargeTabHeightMax when calculating the rects   	
; 	 to draw tabs into. This height includes the tab frame overlap. Tabs that are not in the  	
; 	 front are only drawn down to where they meet the frame, as if the height was just        	
; 	 kThemeLargeTabHeight, for example, as opposed to the ...Max constant. Remember that for  	
; 	 East and West tabs, the height referred to below is actually the width.                  	

(defconstant $kThemeSmallTabHeight 16)          ;   amount small tabs protrude from frame. 
(defconstant $kThemeLargeTabHeight 21)          ;   amount large tabs protrude from frame. 
(defconstant $kThemeTabPaneOverlap 3)           ;   amount tabs overlap frame. 
(defconstant $kThemeSmallTabHeightMax 19)       ;   small tab height + overlap 
(defconstant $kThemeLargeTabHeightMax 24)       ;   large tab height + overlap 

; 		
; 	 Track kinds                                                                              	
; 		
(defconstant $kThemeMediumScrollBar 0)
(defconstant $kThemeSmallScrollBar 1)
(defconstant $kThemeMediumSlider 2)
(defconstant $kThemeMediumProgressBar 3)
(defconstant $kThemeMediumIndeterminateBar 4)
(defconstant $kThemeRelevanceBar 5)
(defconstant $kThemeSmallSlider 6)
(defconstant $kThemeLargeProgressBar 7)
(defconstant $kThemeLargeIndeterminateBar 8)

(def-mactype :themetrackkind (find-mactype ':unsigned-integer))
; 		
; 	 Track enable states                                                                      	
; 		

;   track states  
(defconstant $kThemeTrackActive 0)
(defconstant $kThemeTrackDisabled 1)
(defconstant $kThemeTrackNothingToScroll 2)
(defconstant $kThemeTrackInactive 3)

(def-mactype :themetrackenablestate (find-mactype ':unsigned-byte))
; 		
; 	 Track pressed states                                                                     	
; 		

;   press states (ignored unless track is active)  
(defconstant $kThemeLeftOutsideArrowPressed #x1)
(defconstant $kThemeLeftInsideArrowPressed #x2)
(defconstant $kThemeLeftTrackPressed #x4)
(defconstant $kThemeThumbPressed #x8)
(defconstant $kThemeRightTrackPressed #x10)
(defconstant $kThemeRightInsideArrowPressed #x20)
(defconstant $kThemeRightOutsideArrowPressed #x40)
(defconstant $kThemeTopOutsideArrowPressed #x1)
(defconstant $kThemeTopInsideArrowPressed #x2)
(defconstant $kThemeTopTrackPressed #x4)
(defconstant $kThemeBottomTrackPressed #x10)
(defconstant $kThemeBottomInsideArrowPressed #x20)
(defconstant $kThemeBottomOutsideArrowPressed #x40)

(def-mactype :themetrackpressstate (find-mactype ':unsigned-byte))
; 		
; 	 Thumb directions                                                                         	
; 		

;   thumb direction  
(defconstant $kThemeThumbPlain 0)
(defconstant $kThemeThumbUpward 1)
(defconstant $kThemeThumbDownward 2)

(def-mactype :themethumbdirection (find-mactype ':unsigned-byte))
; 		
; 	 Track attributes                                                                         	
; 		

(defconstant $kThemeTrackHorizontal #x1)        ;   track is drawn horizontally 
(defconstant $kThemeTrackRightToLeft #x2)       ;   track progresses from right to left 
(defconstant $kThemeTrackShowThumb #x4)         ;   track's thumb should be drawn 
(defconstant $kThemeTrackThumbRgnIsNotGhost #x8);   the provided thumbRgn should be drawn opaque, not as a ghost 
(defconstant $kThemeTrackNoScrollBarArrows #x10);   the scroll bar doesn't have arrows 

(def-mactype :themetrackattributes (find-mactype ':unsigned-integer))
; 		
; 	 Track info block                                                                         	
; 		
(def-mactype :scrollbartrackinfoptr (find-mactype '(:pointer :scrollbartrackinfo)))
(defrecord ScrollBarTrackInfo 
   (viewsize :signed-long)                      ;   current view range size  
   (pressState :signed-byte)                    ;   pressed parts state  
   )

(def-mactype :slidertrackinfoptr (find-mactype '(:pointer :slidertrackinfo)))
(defrecord SliderTrackInfo 
   (thumbDir :signed-byte)                      ;   thumb direction  
   (pressState :signed-byte)                    ;   pressed parts state  
   )

(def-mactype :progresstrackinfoptr (find-mactype '(:pointer :progresstrackinfo)))
(defrecord ProgressTrackInfo 
   (phase :signed-byte)                         ;   phase for indeterminate progress  
   )

(def-mactype :themetrackdrawinfoptr (find-mactype '(:pointer :themetrackdrawinfo)))
(defrecord ThemeTrackDrawInfo 
   (kind :unsigned-integer)                     ;   what kind of track this info is for  
   (bounds :rect)                               ;   track basis rectangle  
   (min :signed-long)                           ;   min track value  
   (max :signed-long)                           ;   max track value  
   (value :signed-long)                         ;   current thumb value  
   (reserved :unsigned-long)
   (attributes :unsigned-integer)               ;   various track attributes  
   (enableState :signed-byte)                   ;   enable state  
   (filler1 :signed-byte)
   (:variant 
      (
      (scrollbar :scrollbartrackinfo)
      )
      (
      (slider :slidertrackinfo)
      )
      (
      (progress :progresstrackinfo)
      )
      )
   )

; 		
; 	 ThemeWindowAttributes                                                                    	
; 		

(defconstant $kThemeWindowHasGrow #x1)          ;   can the size of the window be changed by the user?  
(defconstant $kThemeWindowHasHorizontalZoom #x8);   window can zoom only horizontally  
(defconstant $kThemeWindowHasVerticalZoom #x10) ;   window can zoom only vertically  
(defconstant $kThemeWindowHasFullZoom #x18)     ;   window zooms in all directions  
(defconstant $kThemeWindowHasCloseBox #x20)     ;   window has a close box  
(defconstant $kThemeWindowHasCollapseBox #x40)  ;   window has a collapse box  
(defconstant $kThemeWindowHasTitleText #x80)    ;   window has a title/title icon  
(defconstant $kThemeWindowIsCollapsed #x100)    ;   window is in the collapsed state  
(defconstant $kThemeWindowHasDirty #x200)

(def-mactype :themewindowattributes (find-mactype ':unsigned-long))
; 		
; 	 Window Types Supported by the Appearance Manager                                         	
; 		

(defconstant $kThemeDocumentWindow 0)
(defconstant $kThemeDialogWindow 1)
(defconstant $kThemeMovableDialogWindow 2)
(defconstant $kThemeAlertWindow 3)
(defconstant $kThemeMovableAlertWindow 4)
(defconstant $kThemePlainDialogWindow 5)
(defconstant $kThemeShadowDialogWindow 6)
(defconstant $kThemePopupWindow 7)
(defconstant $kThemeUtilityWindow 8)
(defconstant $kThemeUtilitySideWindow 9)
(defconstant $kThemeSheetWindow 10)

(def-mactype :themewindowtype (find-mactype ':unsigned-integer))
; 		
; 	 Window Widgets Supported by the Appearance Manager                                       	
; 		

(defconstant $kThemeWidgetCloseBox 0)
(defconstant $kThemeWidgetZoomBox 1)
(defconstant $kThemeWidgetCollapseBox 2)
(defconstant $kThemeWidgetDirtyCloseBox 6)

(def-mactype :themetitlebarwidget (find-mactype ':unsigned-integer))
; 		
; 	 Popup arrow orientations                                                                 	
; 		

(defconstant $kThemeArrowLeft 0)
(defconstant $kThemeArrowDown 1)
(defconstant $kThemeArrowRight 2)
(defconstant $kThemeArrowUp 3)

(def-mactype :themearroworientation (find-mactype ':unsigned-integer))
; 		
; 	 Popup arrow sizes                                                                        	
; 		

(defconstant $kThemeArrow3pt 0)
(defconstant $kThemeArrow5pt 1)
(defconstant $kThemeArrow7pt 2)
(defconstant $kThemeArrow9pt 3)

(def-mactype :themepopuparrowsize (find-mactype ':unsigned-integer))
; 		
; 	 Grow box directions                                                                      	
; 		

(defconstant $kThemeGrowLeft #x1)               ;   can grow to the left  
(defconstant $kThemeGrowRight #x2)              ;   can grow to the right  
(defconstant $kThemeGrowUp #x4)                 ;   can grow up  
(defconstant $kThemeGrowDown #x8)               ;   can grow down  

(def-mactype :themegrowdirection (find-mactype ':unsigned-integer))
; 		
; 	 Button kinds                                                                             	
; 		

(defconstant $kThemePushButton 0)
(defconstant $kThemeCheckBox 1)
(defconstant $kThemeRadioButton 2)
(defconstant $kThemeBevelButton 3)              ;   bevel button (obsolete)  
(defconstant $kThemeArrowButton 4)              ;   popup button without text (no label). See ThemeButtonAdornment for glyphs.  
(defconstant $kThemePopupButton 5)              ;   popup button  
(defconstant $kThemeDisclosureButton 6)
(defconstant $kThemeIncDecButton 7)             ;   increment/decrement buttons  (no label)  
(defconstant $kThemeSmallBevelButton 8)         ;   small-shadow bevel button  
(defconstant $kThemeMediumBevelButton 3)        ;   med-shadow bevel button  
(defconstant $kThemeLargeBevelButton 9)         ;   large-shadow bevel button  
(defconstant $kThemeListHeaderButton 10)        ;   sort button for top of list  
(defconstant $kThemeRoundButton 11)             ;   round button  
(defconstant $kThemeLargeRoundButton 12)        ;   large round button  
(defconstant $kThemeSmallCheckBox 13)           ;   small checkbox  
(defconstant $kThemeSmallRadioButton 14)        ;   small radio button  
(defconstant $kThemeRoundedBevelButton 15)      ;   rounded bevel button  
(defconstant $kThemeNormalCheckBox 1)
(defconstant $kThemeNormalRadioButton 2)

(def-mactype :themebuttonkind (find-mactype ':unsigned-integer))
; 		
; 	 Common button values                                                                     	
; 		

(defconstant $kThemeButtonOff 0)
(defconstant $kThemeButtonOn 1)
(defconstant $kThemeButtonMixed 2)
(defconstant $kThemeDisclosureRight 0)
(defconstant $kThemeDisclosureDown 1)
(defconstant $kThemeDisclosureLeft 2)

(def-mactype :themebuttonvalue (find-mactype ':unsigned-integer))
; 		
; 	 Button adornment types                                                                   	
; 		

(defconstant $kThemeAdornmentNone 0)
(defconstant $kThemeAdornmentDefault #x1)       ;   if set, draw default ornamentation ( for push button and generic well )  
(defconstant $kThemeAdornmentFocus #x4)         ;   if set, draw focus  
(defconstant $kThemeAdornmentRightToLeft #x10)  ;   if set, draw right to left label  
(defconstant $kThemeAdornmentDrawIndicatorOnly #x20);   if set, don't draw or erase label ( radio, check, disclosure )  
(defconstant $kThemeAdornmentHeaderButtonLeftNeighborSelected #x40);   if set, draw the left border of the button as selected ( list header button only )  
(defconstant $kThemeAdornmentHeaderButtonRightNeighborSelected #x80);   if set, draw the right border of the button ( list header button only )  
(defconstant $kThemeAdornmentHeaderButtonSortUp #x100);   if set, draw the sort indicator pointing upward ( list header button only )  
(defconstant $kThemeAdornmentHeaderMenuButton #x200);   if set, draw as a header menu button ( list header button only )  
(defconstant $kThemeAdornmentHeaderButtonNoShadow #x400);   if set, draw the non-shadow area of the button ( list header button only )  
(defconstant $kThemeAdornmentHeaderButtonShadowOnly #x800);   if set, draw the only the shadow area of the button ( list header button only )  
(defconstant $kThemeAdornmentNoShadow #x400)    ;   old name  
(defconstant $kThemeAdornmentShadowOnly #x800)  ;   old name  
(defconstant $kThemeAdornmentArrowLeftArrow #x40);   If set, draw a left arrow on the arrow button  
(defconstant $kThemeAdornmentArrowDownArrow #x80);   If set, draw a down arrow on the arrow button  
(defconstant $kThemeAdornmentArrowDoubleArrow #x100);   If set, draw a double arrow on the arrow button  
(defconstant $kThemeAdornmentArrowUpArrow #x200);   If set, draw a up arrow on the arrow button  

(def-mactype :themebuttonadornment (find-mactype ':unsigned-integer))
; 		
; 	 Button drawing info block                                                                	
; 		
(def-mactype :themebuttondrawinfoptr (find-mactype '(:pointer :themebuttondrawinfo)))
(defrecord ThemeButtonDrawInfo 
   (state :unsigned-long)
   (value :unsigned-integer)
   (adornment :unsigned-integer)
   )

; 		
; 	 Sound Support                                                                            	
; 	                                                                                          	
; 	  X ALERT: Please note that none of the theme sound APIs currently function on X.         	
; 		
; 		
; 	 Sound classes                                                                            	
; 	                                                                                          	
; 	 You can use the constants below to set what sounds are active using the SetTheme API.    	
; 	 Use these with the kThemeSoundMask tag.                                                  	
; 		

(defconstant $kThemeNoSounds 0)
(defconstant $kThemeWindowSoundsMask #x1)
(defconstant $kThemeMenuSoundsMask #x2)
(defconstant $kThemeControlSoundsMask #x4)
(defconstant $kThemeFinderSoundsMask #x8)

; 		
; 	 Drag Sounds                                                                              	
; 	                                                                                          	
; 	 Drag sounds are looped for the duration of the drag.                                     	
; 	                                                                                          	
; 	 Call BeginThemeDragSound at the start of the drag.                                       	
; 	 Call EndThemeDragSound when the drag has finished.                                       	
; 	                                                                                          	
; 	 Note that in order to maintain a consistent user experience, only one drag sound may     	
; 	 occur at a time.  The sound should be attached to a mouse action, start after the        	
; 	 mouse goes down and stop when the mouse is released.                                     	
; 		
(defconstant $kThemeDragSoundNone 0)
(defconstant $kThemeDragSoundMoveWindow :|wmov|)
(defconstant $kThemeDragSoundGrowWindow :|wgro|)
(defconstant $kThemeDragSoundMoveUtilWindow :|umov|)
(defconstant $kThemeDragSoundGrowUtilWindow :|ugro|)
(defconstant $kThemeDragSoundMoveDialog :|dmov|)
(defconstant $kThemeDragSoundMoveAlert :|amov|)
(defconstant $kThemeDragSoundMoveIcon :|imov|)
(defconstant $kThemeDragSoundSliderThumb :|slth|)
(defconstant $kThemeDragSoundSliderGhost :|slgh|)
(defconstant $kThemeDragSoundScrollBarThumb :|sbth|)
(defconstant $kThemeDragSoundScrollBarGhost :|sbgh|)
(defconstant $kThemeDragSoundScrollBarArrowDecreasing :|sbad|)
(defconstant $kThemeDragSoundScrollBarArrowIncreasing :|sbai|)
(defconstant $kThemeDragSoundDragging :|drag|)

(def-mactype :themedragsoundkind (find-mactype ':ostype))
; 		
; 	 State-change sounds                                                      	
; 	                                                                          	
; 	 State-change sounds are played asynchonously as a one-shot.              	
; 	                                                                          	
; 	 Call PlayThemeSound to play the sound.  The sound will play              	
; 	 asynchronously until complete, then stop automatically.                  	
; 		

(defconstant $kThemeSoundNone 0)
(defconstant $kThemeSoundMenuOpen :|mnuo|)      ;   menu sounds  
(defconstant $kThemeSoundMenuClose :|mnuc|)
(defconstant $kThemeSoundMenuItemHilite :|mnui|)
(defconstant $kThemeSoundMenuItemRelease :|mnus|)
(defconstant $kThemeSoundWindowClosePress :|wclp|);   window sounds  
(defconstant $kThemeSoundWindowCloseEnter :|wcle|)
(defconstant $kThemeSoundWindowCloseExit :|wclx|)
(defconstant $kThemeSoundWindowCloseRelease :|wclr|)
(defconstant $kThemeSoundWindowZoomPress :|wzmp|)
(defconstant $kThemeSoundWindowZoomEnter :|wzme|)
(defconstant $kThemeSoundWindowZoomExit :|wzmx|)
(defconstant $kThemeSoundWindowZoomRelease :|wzmr|)
(defconstant $kThemeSoundWindowCollapsePress :|wcop|)
(defconstant $kThemeSoundWindowCollapseEnter :|wcoe|)
(defconstant $kThemeSoundWindowCollapseExit :|wcox|)
(defconstant $kThemeSoundWindowCollapseRelease :|wcor|)
(defconstant $kThemeSoundWindowDragBoundary :|wdbd|)
(defconstant $kThemeSoundUtilWinClosePress :|uclp|);   utility window sounds  
(defconstant $kThemeSoundUtilWinCloseEnter :|ucle|)
(defconstant $kThemeSoundUtilWinCloseExit :|uclx|)
(defconstant $kThemeSoundUtilWinCloseRelease :|uclr|)
(defconstant $kThemeSoundUtilWinZoomPress :|uzmp|)
(defconstant $kThemeSoundUtilWinZoomEnter :|uzme|)
(defconstant $kThemeSoundUtilWinZoomExit :|uzmx|)
(defconstant $kThemeSoundUtilWinZoomRelease :|uzmr|)
(defconstant $kThemeSoundUtilWinCollapsePress :|ucop|)
(defconstant $kThemeSoundUtilWinCollapseEnter :|ucoe|)
(defconstant $kThemeSoundUtilWinCollapseExit :|ucox|)
(defconstant $kThemeSoundUtilWinCollapseRelease :|ucor|)
(defconstant $kThemeSoundUtilWinDragBoundary :|udbd|)
(defconstant $kThemeSoundWindowOpen :|wopn|)    ;   window close and zoom action  
(defconstant $kThemeSoundWindowClose :|wcls|)
(defconstant $kThemeSoundWindowZoomIn :|wzmi|)
(defconstant $kThemeSoundWindowZoomOut :|wzmo|)
(defconstant $kThemeSoundWindowCollapseUp :|wcol|)
(defconstant $kThemeSoundWindowCollapseDown :|wexp|)
(defconstant $kThemeSoundWindowActivate :|wact|)
(defconstant $kThemeSoundUtilWindowOpen :|uopn|)
(defconstant $kThemeSoundUtilWindowClose :|ucls|)
(defconstant $kThemeSoundUtilWindowZoomIn :|uzmi|)
(defconstant $kThemeSoundUtilWindowZoomOut :|uzmo|)
(defconstant $kThemeSoundUtilWindowCollapseUp :|ucol|)
(defconstant $kThemeSoundUtilWindowCollapseDown :|uexp|)
(defconstant $kThemeSoundUtilWindowActivate :|uact|)
(defconstant $kThemeSoundDialogOpen :|dopn|)
(defconstant $kThemeSoundDialogClose :|dlgc|)
(defconstant $kThemeSoundAlertOpen :|aopn|)
(defconstant $kThemeSoundAlertClose :|altc|)
(defconstant $kThemeSoundPopupWindowOpen :|pwop|)
(defconstant $kThemeSoundPopupWindowClose :|pwcl|)
(defconstant $kThemeSoundButtonPress :|btnp|)   ;   button  
(defconstant $kThemeSoundButtonEnter :|btne|)
(defconstant $kThemeSoundButtonExit :|btnx|)
(defconstant $kThemeSoundButtonRelease :|btnr|)
(defconstant $kThemeSoundDefaultButtonPress :|dbtp|);   default button  
(defconstant $kThemeSoundDefaultButtonEnter :|dbte|)
(defconstant $kThemeSoundDefaultButtonExit :|dbtx|)
(defconstant $kThemeSoundDefaultButtonRelease :|dbtr|)
(defconstant $kThemeSoundCancelButtonPress :|cbtp|);   cancel button  
(defconstant $kThemeSoundCancelButtonEnter :|cbte|)
(defconstant $kThemeSoundCancelButtonExit :|cbtx|)
(defconstant $kThemeSoundCancelButtonRelease :|cbtr|)
(defconstant $kThemeSoundCheckboxPress :|chkp|) ;   checkboxes  
(defconstant $kThemeSoundCheckboxEnter :|chke|)
(defconstant $kThemeSoundCheckboxExit :|chkx|)
(defconstant $kThemeSoundCheckboxRelease :|chkr|)
(defconstant $kThemeSoundRadioPress :|radp|)    ;   radio buttons  
(defconstant $kThemeSoundRadioEnter :|rade|)
(defconstant $kThemeSoundRadioExit :|radx|)
(defconstant $kThemeSoundRadioRelease :|radr|)
(defconstant $kThemeSoundScrollArrowPress :|sbap|);   scroll bars  
(defconstant $kThemeSoundScrollArrowEnter :|sbae|)
(defconstant $kThemeSoundScrollArrowExit :|sbax|)
(defconstant $kThemeSoundScrollArrowRelease :|sbar|)
(defconstant $kThemeSoundScrollEndOfTrack :|sbte|)
(defconstant $kThemeSoundScrollTrackPress :|sbtp|)
(defconstant $kThemeSoundSliderEndOfTrack :|slte|);   sliders  
(defconstant $kThemeSoundSliderTrackPress :|sltp|)
(defconstant $kThemeSoundBalloonOpen :|blno|)   ;   help balloons  
(defconstant $kThemeSoundBalloonClose :|blnc|)
(defconstant $kThemeSoundBevelPress :|bevp|)    ;   Bevel buttons  
(defconstant $kThemeSoundBevelEnter :|beve|)
(defconstant $kThemeSoundBevelExit :|bevx|)
(defconstant $kThemeSoundBevelRelease :|bevr|)
(defconstant $kThemeSoundLittleArrowUpPress :|laup|);   Little Arrows  
(defconstant $kThemeSoundLittleArrowDnPress :|ladp|)
(defconstant $kThemeSoundLittleArrowEnter :|lare|)
(defconstant $kThemeSoundLittleArrowExit :|larx|)
(defconstant $kThemeSoundLittleArrowUpRelease :|laur|)
(defconstant $kThemeSoundLittleArrowDnRelease :|ladr|)
(defconstant $kThemeSoundPopupPress :|popp|)    ;   Popup Buttons  
(defconstant $kThemeSoundPopupEnter :|pope|)
(defconstant $kThemeSoundPopupExit :|popx|)
(defconstant $kThemeSoundPopupRelease :|popr|)
(defconstant $kThemeSoundDisclosurePress :|dscp|);   Disclosure Buttons  
(defconstant $kThemeSoundDisclosureEnter :|dsce|)
(defconstant $kThemeSoundDisclosureExit :|dscx|)
(defconstant $kThemeSoundDisclosureRelease :|dscr|)
(defconstant $kThemeSoundTabPressed :|tabp|)    ;   Tabs  
(defconstant $kThemeSoundTabEnter :|tabe|)
(defconstant $kThemeSoundTabExit :|tabx|)
(defconstant $kThemeSoundTabRelease :|tabr|)
(defconstant $kThemeSoundDragTargetHilite :|dthi|);   drag manager  
(defconstant $kThemeSoundDragTargetUnhilite :|dtuh|)
(defconstant $kThemeSoundDragTargetDrop :|dtdr|)
(defconstant $kThemeSoundEmptyTrash :|ftrs|)    ;   finder  
(defconstant $kThemeSoundSelectItem :|fsel|)
(defconstant $kThemeSoundNewItem :|fnew|)
(defconstant $kThemeSoundReceiveDrop :|fdrp|)
(defconstant $kThemeSoundCopyDone :|fcpd|)
(defconstant $kThemeSoundResolveAlias :|fral|)
(defconstant $kThemeSoundLaunchApp :|flap|)
(defconstant $kThemeSoundDiskInsert :|dski|)
(defconstant $kThemeSoundDiskEject :|dske|)
(defconstant $kThemeSoundFinderDragOnIcon :|fdon|)
(defconstant $kThemeSoundFinderDragOffIcon :|fdof|)

(def-mactype :themesoundkind (find-mactype ':ostype))
; 		
; 	 Window Metrics                                                                           	
; 		
; 	  Window metrics are used by the Appearance manager to fill in the blanks necessary to    	
; 	  draw windows. If a value is not appropriate for the type of window, be sure to fill in  	
; 	  the slot in the structure with zero.    For the popupTabOffset parameter, you can pass a	
; 	  real value based on the left edge of the window. This value might be interpreted in a   	
; 	  different manner when depending on the value of the popupTabPosition field. The values  	
; 	  you can pass into popupTabPosition are:                                                 	
; 	                                                                                          	
; 	  kThemePopupTabNormalPosition                                                            	
; 	      Starts the tab left edge at the position indicated by the popupTabOffset field.     	
; 	                                                                                          	
; 	  kThemePopupTabCenterOnWindow                                                            	
; 	      tells us to ignore the offset field and instead simply center the width of the      	
; 	      handle on the window.                                                               	
; 	                                                                                          	
; 	  kThemePopupTabCenterOnOffset                                                            	
; 	      tells us to center the width of the handle around the value passed in offset.       	
; 	                                                                                          	
; 	  The Appearance Manager will try its best to accomodate the requested placement, but may 	
; 	  move the handle slightly to make it fit correctly.                                      	
; 	                                                                                          	

(defconstant $kThemePopupTabNormalPosition 0)
(defconstant $kThemePopupTabCenterOnWindow 1)
(defconstant $kThemePopupTabCenterOnOffset 2)

(def-mactype :themewindowmetricsptr (find-mactype '(:pointer :themewindowmetrics)))
(defrecord ThemeWindowMetrics 
   (metricSize :unsigned-integer)               ;   should be always be sizeof( ThemeWindowMetrics ) 
   (titleHeight :signed-integer)
   (titleWidth :signed-integer)
   (popupTabOffset :signed-integer)
   (popupTabWidth :signed-integer)
   (popupTabPosition :unsigned-integer)
   )

; 		
; 	 Theme Metrics                                                                            	
; 		

; 
; 	 *  Discussion:
; 	 *    Theme metrics allow you to find out sizes of things in the
; 	 *    current environment, such as how wide a scroll bar is, etc.
; 	 	

(defconstant $kThemeMetricScrollBarWidth 0)
(defconstant $kThemeMetricSmallScrollBarWidth 1)
(defconstant $kThemeMetricCheckBoxHeight 2)
(defconstant $kThemeMetricRadioButtonHeight 3)
(defconstant $kThemeMetricEditTextWhitespace 4)
(defconstant $kThemeMetricEditTextFrameOutset 5)
(defconstant $kThemeMetricListBoxFrameOutset 6)
(defconstant $kThemeMetricFocusRectOutset 7)
(defconstant $kThemeMetricImageWellThickness 8)
(defconstant $kThemeMetricScrollBarOverlap 9)
(defconstant $kThemeMetricLargeTabHeight 10)
(defconstant $kThemeMetricLargeTabCapsWidth 11)
(defconstant $kThemeMetricTabFrameOverlap 12)
(defconstant $kThemeMetricTabIndentOrStyle 13)
(defconstant $kThemeMetricTabOverlap 14)
(defconstant $kThemeMetricSmallTabHeight 15)
(defconstant $kThemeMetricSmallTabCapsWidth 16)
(defconstant $kThemeMetricDisclosureButtonHeight 17)
(defconstant $kThemeMetricRoundButtonSize 18)
(defconstant $kThemeMetricPushButtonHeight 19)
(defconstant $kThemeMetricListHeaderHeight 20)
(defconstant $kThemeMetricSmallCheckBoxHeight 21)
(defconstant $kThemeMetricDisclosureButtonWidth 22)
(defconstant $kThemeMetricSmallDisclosureButtonHeight 23)
(defconstant $kThemeMetricSmallDisclosureButtonWidth 24)
(defconstant $kThemeMetricDisclosureTriangleHeight 25)
(defconstant $kThemeMetricDisclosureTriangleWidth 26)
(defconstant $kThemeMetricLittleArrowsHeight 27)
(defconstant $kThemeMetricLittleArrowsWidth 28)
(defconstant $kThemeMetricPaneSplitterHeight 29)
(defconstant $kThemeMetricPopupButtonHeight 30)
(defconstant $kThemeMetricSmallPopupButtonHeight 31)
(defconstant $kThemeMetricLargeProgressBarThickness 32)
(defconstant $kThemeMetricPullDownHeight 33)
(defconstant $kThemeMetricSmallPullDownHeight 34)
(defconstant $kThemeMetricSmallPushButtonHeight 35)
(defconstant $kThemeMetricSmallRadioButtonHeight 36)
(defconstant $kThemeMetricRelevanceIndicatorHeight 37)
(defconstant $kThemeMetricResizeControlHeight 38)
(defconstant $kThemeMetricSmallResizeControlHeight 39)
(defconstant $kThemeMetricLargeRoundButtonSize 40)
(defconstant $kThemeMetricHSliderHeight 41)
(defconstant $kThemeMetricHSliderTickHeight 42)
(defconstant $kThemeMetricSmallHSliderHeight 43)
(defconstant $kThemeMetricSmallHSliderTickHeight 44)
(defconstant $kThemeMetricVSliderWidth 45)
(defconstant $kThemeMetricVSliderTickWidth 46)
(defconstant $kThemeMetricSmallVSliderWidth 47)
(defconstant $kThemeMetricSmallVSliderTickWidth 48)
(defconstant $kThemeMetricTitleBarControlsHeight 49)
(defconstant $kThemeMetricCheckBoxWidth 50)
(defconstant $kThemeMetricSmallCheckBoxWidth 51)
(defconstant $kThemeMetricRadioButtonWidth 52)
(defconstant $kThemeMetricSmallRadioButtonWidth 53)
(defconstant $kThemeMetricSmallHSliderMinThumbWidth 54)
(defconstant $kThemeMetricSmallVSliderMinThumbHeight 55)
(defconstant $kThemeMetricSmallHSliderTickOffset 56)
(defconstant $kThemeMetricSmallVSliderTickOffset 57)
(defconstant $kThemeMetricNormalProgressBarThickness 58)
(defconstant $kThemeMetricProgressBarShadowOutset 59)
(defconstant $kThemeMetricSmallProgressBarShadowOutset 60)
(defconstant $kThemeMetricPrimaryGroupBoxContentInset 61)
(defconstant $kThemeMetricSecondaryGroupBoxContentInset 62)
(defconstant $kThemeMetricMenuMarkColumnWidth 63)
(defconstant $kThemeMetricMenuExcludedMarkColumnWidth 64)
(defconstant $kThemeMetricMenuMarkIndent 65)
(defconstant $kThemeMetricMenuTextLeadingEdgeMargin 66)
(defconstant $kThemeMetricMenuTextTrailingEdgeMargin 67)
(defconstant $kThemeMetricMenuIndentWidth 68)
(defconstant $kThemeMetricMenuIconTrailingEdgeMargin 69)

(def-mactype :thememetric (find-mactype ':unsigned-long))
; 		
; 	 Drawing State                                                                            	
; 		
(def-mactype :themedrawingstate (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :themedrawingstateptr (find-mactype '(:pointer :pointer)));  when a VAR xx:ThemeDrawingState parameter can be nil, it is changed to xx: ThemeDrawingStatePtr 
; 		
; 	 Callback procs                                                                           	
; 		
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ThemeTabTitleDrawProcPtr = PROCEDURE({CONST}VAR bounds: Rect; style: ThemeTabStyle; direction: ThemeTabDirection; depth: SInt16; isColorDev: BOOLEAN; userData: UInt32);

|#
 |#                                             ; $ELSEC
(def-mactype :themetabtitledrawprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ThemeEraseProcPtr = PROCEDURE({CONST}VAR bounds: Rect; eraseData: UInt32; depth: SInt16; isColorDev: BOOLEAN);

|#
 |#                                             ; $ELSEC
(def-mactype :themeeraseprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ThemeButtonDrawProcPtr = PROCEDURE({CONST}VAR bounds: Rect; kind: ThemeButtonKind; {CONST}VAR info: ThemeButtonDrawInfo; userData: UInt32; depth: SInt16; isColorDev: BOOLEAN);

|#
 |#                                             ; $ELSEC
(def-mactype :themebuttondrawprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	WindowTitleDrawingProcPtr = PROCEDURE({CONST}VAR bounds: Rect; depth: SInt16; colorDevice: BOOLEAN; userData: UInt32);

|#
 |#                                             ; $ELSEC
(def-mactype :windowtitledrawingprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ThemeIteratorProcPtr = FUNCTION(inFileName: Str255; resID: SInt16; inThemeSettings: Collection; inUserData: UNIV Ptr): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :themeiteratorprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :themetabtitledrawupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :themetabtitledrawupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :themeeraseupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :themeeraseupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :themebuttondrawupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :themebuttondrawupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :windowtitledrawingupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :windowtitledrawingupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :themeiteratorupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :themeiteratorupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppThemeTabTitleDrawProcInfo #x36AC0)
(defconstant $uppThemeEraseProcInfo #x1BC0)
(defconstant $uppThemeButtonDrawProcInfo #x1BEC0)
(defconstant $uppWindowTitleDrawingProcInfo #x36C0)
(defconstant $uppThemeIteratorProcInfo #x3ED0)
; 
; 	 *  NewThemeTabTitleDrawUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewThemeTabTitleDrawProc 
(deftrap "_NewThemeTabTitleDrawUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewThemeEraseUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewThemeEraseProc 
(deftrap "_NewThemeEraseUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewThemeButtonDrawUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewThemeButtonDrawProc 
(deftrap "_NewThemeButtonDrawUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewWindowTitleDrawingUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewWindowTitleDrawingProc 
(deftrap "_NewWindowTitleDrawingUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewThemeIteratorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewThemeIteratorProc 
(deftrap "_NewThemeIteratorUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeThemeTabTitleDrawUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeThemeTabTitleDrawUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeThemeEraseUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeThemeEraseUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeThemeButtonDrawUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeThemeButtonDrawUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeWindowTitleDrawingUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeWindowTitleDrawingUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeThemeIteratorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeThemeIteratorUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeThemeTabTitleDrawUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ;  old name was CallThemeTabTitleDrawProc 
(deftrap-inline "_InvokeThemeTabTitleDrawUPP" 
      ((bounds (:pointer :rect)) (style :unsigned-integer) (direction :unsigned-integer) (depth :signed-integer) (isColorDev :boolean) (userData :unsigned-long) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeThemeEraseUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ;  old name was CallThemeEraseProc 
(deftrap-inline "_InvokeThemeEraseUPP" 
      ((bounds (:pointer :rect)) (eraseData :unsigned-long) (depth :signed-integer) (isColorDev :boolean) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeThemeButtonDrawUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST;  old name was CallThemeButtonDrawProc 
(deftrap-inline "_InvokeThemeButtonDrawUPP" 
      ((bounds (:pointer :rect)) (kind :unsigned-integer) (info (:pointer :themebuttondrawinfo)) (userData :unsigned-long) (depth :signed-integer) (isColorDev :boolean) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeWindowTitleDrawingUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ;  old name was CallWindowTitleDrawingProc 
(deftrap-inline "_InvokeWindowTitleDrawingUPP" 
      ((bounds (:pointer :rect)) (depth :signed-integer) (colorDevice :boolean) (userData :unsigned-long) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeThemeIteratorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallThemeIteratorProc 
(deftrap-inline "_InvokeThemeIteratorUPP" 
      ((inFileName (:string 255)) (resID :signed-integer) (inThemeSettings :pointer) (inUserData :pointer) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; 
;  Menu Drawing callbacks                                                           
; 

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	MenuTitleDrawingProcPtr = PROCEDURE({CONST}VAR inBounds: Rect; inDepth: SInt16; inIsColorDevice: BOOLEAN; inUserData: SInt32);

|#
 |#                                             ; $ELSEC
(def-mactype :menutitledrawingprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	MenuItemDrawingProcPtr = PROCEDURE({CONST}VAR inBounds: Rect; inDepth: SInt16; inIsColorDevice: BOOLEAN; inUserData: SInt32);

|#
 |#                                             ; $ELSEC
(def-mactype :menuitemdrawingprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :menutitledrawingupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :menutitledrawingupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :menuitemdrawingupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :menuitemdrawingupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppMenuTitleDrawingProcInfo #x36C0)
(defconstant $uppMenuItemDrawingProcInfo #x36C0)
; 
; 	 *  NewMenuTitleDrawingUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewMenuTitleDrawingProc 
(deftrap "_NewMenuTitleDrawingUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewMenuItemDrawingUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewMenuItemDrawingProc 
(deftrap "_NewMenuItemDrawingUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeMenuTitleDrawingUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeMenuTitleDrawingUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeMenuItemDrawingUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeMenuItemDrawingUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeMenuTitleDrawingUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ;  old name was CallMenuTitleDrawingProc 
(deftrap-inline "_InvokeMenuTitleDrawingUPP" 
      ((inBounds (:pointer :rect)) (inDepth :signed-integer) (inIsColorDevice :boolean) (inUserData :signed-long) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeMenuItemDrawingUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ;  old name was CallMenuItemDrawingProc 
(deftrap-inline "_InvokeMenuItemDrawingUPP" 
      ((inBounds (:pointer :rect)) (inDepth :signed-integer) (inIsColorDevice :boolean) (inUserData :signed-long) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;   Appearance Manager APIs                                                         
; 
;  Registering Appearance-Savvy Applications 
; 
;  *  RegisterAppearanceClient()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_RegisterAppearanceClient" 
      ()
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 21))

; 
;  *  UnregisterAppearanceClient()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_UnregisterAppearanceClient" 
      ()
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 22))

; 
;  *  IsAppearanceClient()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_IsAppearanceClient" 
      ((process (:pointer :processserialnumber)))
   (:stack :boolean)
   (:stack-trap #xAA74 :d0 65535 process))

; ****************************************************************************
;     NOTES ON THEME BRUSHES
;     Theme brushes can be either colors or patterns, depending on the theme.
;     Because of this, you should be prepared to handle the case where a brush
;     is a pattern and save and restore the pnPixPat and bkPixPat fields of
;     your GrafPorts when saving the fore and back colors. Also, since patterns
;     in bkPixPat override the background color of the window, you should use
;     BackPat to set your background pattern to a normal white pattern. This
;     will ensure that you can use RGBBackColor to set your back color to white,
;     call EraseRect and get the expected results.
; ****************************************************************************

; 
;  *  SetThemePen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetThemePen" 
      ((inBrush :signed-integer) (inDepth :signed-integer) (inIsColorDevice :boolean))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 1 inBrush inDepth inIsColorDevice))

; 
;  *  SetThemeBackground()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetThemeBackground" 
      ((inBrush :signed-integer) (inDepth :signed-integer) (inIsColorDevice :boolean))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 2 inBrush inDepth inIsColorDevice))

; 
;  *  SetThemeTextColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetThemeTextColor" 
      ((inColor :signed-integer) (inDepth :signed-integer) (inIsColorDevice :boolean))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 3 inColor inDepth inIsColorDevice))

; 
;  *  SetThemeWindowBackground()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetThemeWindowBackground" 
      ((inWindow (:pointer :windowrecord)) (inBrush :signed-integer) (inUpdate :boolean))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 4 inWindow inBrush inUpdate))

;  Window Placards, Headers and Frames 
; 
;  *  DrawThemeWindowHeader()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_DrawThemeWindowHeader" 
      ((inRect (:pointer :rect)) (inState :unsigned-long))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 5 inRect inState))

; 
;  *  DrawThemeWindowListViewHeader()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_DrawThemeWindowListViewHeader" 
      ((inRect (:pointer :rect)) (inState :unsigned-long))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 6 inRect inState))

; 
;  *  DrawThemePlacard()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_DrawThemePlacard" 
      ((inRect (:pointer :rect)) (inState :unsigned-long))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 7 inRect inState))

; 
;  *  DrawThemeEditTextFrame()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_DrawThemeEditTextFrame" 
      ((inRect (:pointer :rect)) (inState :unsigned-long))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 9 inRect inState))

; 
;  *  DrawThemeListBoxFrame()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_DrawThemeListBoxFrame" 
      ((inRect (:pointer :rect)) (inState :unsigned-long))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 10 inRect inState))

;  Keyboard Focus Drawing 
; 
;  *  DrawThemeFocusRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_DrawThemeFocusRect" 
      ((inRect (:pointer :rect)) (inHasFocus :boolean))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 11 inRect inHasFocus))

;  Dialog Group Boxes and Separators 
; 
;  *  DrawThemePrimaryGroup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_DrawThemePrimaryGroup" 
      ((inRect (:pointer :rect)) (inState :unsigned-long))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 12 inRect inState))

; 
;  *  DrawThemeSecondaryGroup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_DrawThemeSecondaryGroup" 
      ((inRect (:pointer :rect)) (inState :unsigned-long))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 13 inRect inState))

; 
;  *  DrawThemeSeparator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_DrawThemeSeparator" 
      ((inRect (:pointer :rect)) (inState :unsigned-long))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 14 inRect inState))

;  BEGIN APPEARANCE 1.0.1 
;  The following Appearance Manager APIs are only available 
;  in Appearance 1.0.1 or later                             
; 
;  *  DrawThemeModelessDialogFrame()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_DrawThemeModelessDialogFrame" 
      ((inRect (:pointer :rect)) (inState :unsigned-long))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 8 inRect inState))

; 
;  *  DrawThemeGenericWell()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_DrawThemeGenericWell" 
      ((inRect (:pointer :rect)) (inState :unsigned-long) (inFillCenter :boolean))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 34 inRect inState inFillCenter))

; 
;  *  DrawThemeFocusRegion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DrawThemeFocusRegion" 
      ((inRegion (:handle :macregion)) (inHasFocus :boolean))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 35 inRegion inHasFocus))

; 
;  *  IsThemeInColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_IsThemeInColor" 
      ((inDepth :signed-integer) (inIsColorDevice :boolean))
   (:stack :boolean)
   (:stack-trap #xAA74 :d0 36 inDepth inIsColorDevice))

;  IMPORTANT: GetThemeAccentColors will only work in the platinum theme. Any other theme will 
;  most likely return an error 
; 
;  *  GetThemeAccentColors()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetThemeAccentColors" 
      ((outColors (:pointer (:handle :colortable))))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 37 outColors))

; 
;  *  DrawThemeMenuBarBackground()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_DrawThemeMenuBarBackground" 
      ((inBounds (:pointer :rect)) (inState :unsigned-integer) (inAttributes :unsigned-long))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 24 inBounds inState inAttributes))

; 
;  *  DrawThemeMenuTitle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap "_DrawThemeMenuTitle" 
      ((inMenuBarRect (:pointer :rect)) (inTitleRect (:pointer :rect)) (inState :unsigned-integer) (inAttributes :unsigned-long) (inTitleProc :pointer) (inTitleData :unsigned-long))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 25 inMenuBarRect inTitleRect inState inAttributes inTitleProc inTitleData))

; 
;  *  GetThemeMenuBarHeight()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetThemeMenuBarHeight" 
      ((outHeight (:pointer :signed-integer)))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 26 outHeight))

; 
;  *  DrawThemeMenuBackground()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_DrawThemeMenuBackground" 
      ((inMenuRect (:pointer :rect)) (inMenuType :unsigned-integer))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 27 inMenuRect inMenuType))

; 
;  *  GetThemeMenuBackgroundRegion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_GetThemeMenuBackgroundRegion" 
      ((inMenuRect (:pointer :rect)) (menuType :unsigned-integer) (region (:handle :macregion)))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 28 inMenuRect menuType region))

; 
;  *  DrawThemeMenuItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap "_DrawThemeMenuItem" 
      ((inMenuRect (:pointer :rect)) (inItemRect (:pointer :rect)) (inVirtualMenuTop :signed-integer) (inVirtualMenuBottom :signed-integer) (inState :unsigned-integer) (inItemType :unsigned-integer) (inDrawProc :pointer) (inUserData :unsigned-long))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 29 inMenuRect inItemRect inVirtualMenuTop inVirtualMenuBottom inState inItemType inDrawProc inUserData))

; 
;  *  DrawThemeMenuSeparator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_DrawThemeMenuSeparator" 
      ((inItemRect (:pointer :rect)))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 30 inItemRect))

; 
;  *  GetThemeMenuSeparatorHeight()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetThemeMenuSeparatorHeight" 
      ((outHeight (:pointer :signed-integer)))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 31 outHeight))

; 
;  *  GetThemeMenuItemExtra()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetThemeMenuItemExtra" 
      ((inItemType :unsigned-integer) (outHeight (:pointer :signed-integer)) (outWidth (:pointer :signed-integer)))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 32 inItemType outHeight outWidth))

; 
;  *  GetThemeMenuTitleExtra()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetThemeMenuTitleExtra" 
      ((outWidth (:pointer :signed-integer)) (inIsSquished :boolean))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 33 outWidth inIsSquished))

;  BEGIN APPEARANCE 1.1 
;  THEME SWITCHING 
;                                                                                                   
;   X ALERT: Please note that Get/SetTheme are severely neutered under Mac OS X at present.         
;            See the note above regarding what collection tags are supported under X.               

; 
;  *  GetTheme()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  SetTheme()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetTheme" 
      ((ioCollection :pointer)) 
  :osstatus
   () )                                         ; 
;  *  IterateThemes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetTheme" 
      ((ioCollection :pointer)) 
  :osstatus
   () )                                         ;  TABS ; 
;  *  DrawThemeTabPane()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IterateThemes" 
      ((inProc :pointer) (inUserData :pointer)) 
  :osstatus
   () )                                         ; CONST; 
;  *  DrawThemeTab()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DrawThemeTabPane" 
      ((inRect (:pointer :rect)) (inState :unsigned-long)) 
  :osstatus
   () )                                         ; CONST; 
;  *  GetThemeTabRegion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DrawThemeTab" 
      ((inRect (:pointer :rect)) (inStyle :unsigned-integer) (inDirection :unsigned-integer) (labelProc :pointer) (userData :unsigned-long)) 
  :osstatus
   () )                                         ; CONST;  CURSORS ; 
;  *  SetThemeCursor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetThemeTabRegion" 
      ((inRect (:pointer :rect)) (inStyle :unsigned-integer) (inDirection :unsigned-integer) (ioRgn (:handle :macregion))) 
  :osstatus
   () )                                         ; 
;  *  SetAnimatedThemeCursor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetThemeCursor" 
      ((inCursor :unsigned-long)) 
  :osstatus
   () )                                         ;  CONTROL STYLE SETTINGS ; 
;  *  GetThemeScrollBarThumbStyle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetAnimatedThemeCursor" 
      ((inCursor :unsigned-long) (inAnimationStep :unsigned-long)) 
  :osstatus
   () )                                         ; 
;  *  GetThemeScrollBarArrowStyle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetThemeScrollBarThumbStyle" 
      ((outStyle (:pointer :unsigned-integer))) 
  :osstatus
   () )                                         ; 
;  *  GetThemeCheckBoxStyle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetThemeScrollBarArrowStyle" 
      ((outStyle (:pointer :unsigned-integer))) 
  :osstatus
   () )                                         ;  FONTS/TEXT ; 
;  *  UseThemeFont()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetThemeCheckBoxStyle" 
      ((outStyle (:pointer :unsigned-integer))) 
  :osstatus
   () )                                         ; 
;  *  GetThemeFont()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_UseThemeFont" 
      ((inFontID :unsigned-integer) (inScript :signed-integer)) 
  :osstatus
   () )                                         ; 
;  *  DrawThemeTextBox()
;  *  
;  *  Summary:
;  *    Draws text into the area you specify.
;  *  
;  *  Discussion:
;  *    DrawThemeTextBox allows you to draw theme-savvy (ie. Aqua-savvy
;  *    on Mac OS X) text. It is unicode savvy (although only partially
;  *    so under CarbonLib), and allows you to customize certain text
;  *    rendering characteristics such as the font, wrapping behavior,
;  *    and justification. The text is drawn into the CGContextRef you
;  *    provide, or into the current Quickdraw port if no CGContextRef is
;  *    provided. None of DrawThemeTextBox's parameters imply a color, so
;  *    you must set up the desired text color separately before calling
;  *    DrawThemeTextBox. If you provide a CGContextRef, its fill color
;  *    will be used to draw the text. If you do not provide a
;  *    CGContextRef, a color based on the current Quickdraw port's
;  *    foreground color and the grayishTextOr mode (if set) will be used
;  *    to draw the text.
;  *  
;  *  Parameters:
;  *    
;  *    inString:
;  *      A CFStringRef containing the unicode characters you wish to
;  *      render. You MUST NOT pass in a CFStringRef that was allocated
;  *      with any of the "NoCopy" CFString creation APIs; a string
;  *      created with a "NoCopy" API has transient storage which is
;  *      incompatible with DrawThemeTextBox's caches.
;  *    
;  *    inFontID:
;  *      The ThemeFontID describing the font you'd like to render the
;  *      text with. See the discussion of ThemeFontIDs elsewhere in this
;  *      header.
;  *    
;  *    inState:
;  *      The ThemeDrawState describing the the state of the interface
;  *      element you are drawing the text for. If, for example, you are
;  *      drawing text for an inactive window, you would pass
;  *      kThemeStateInactive. The ThemeDrawState is generally only used
;  *      to determine the shadow characteristics for the text on Mac OS
;  *      X. Note that the ThemeDrawState does NOT imply a color. It is
;  *      NOT used as a mechanism for graying the text. If you wish to
;  *      draw grayed text, you must set up the desired gray color and
;  *      apply it to either the current Quickdraw port or the
;  *      CGContextRef as appropriate.
;  *    
;  *    inWrapToWidth:
;  *      A Boolean indicating whether you want to draw multiple lines of
;  *      text wrapped to a bounding box. False indicates that only one
;  *      line of text should be drawn without any sort of wrapping.
;  *    
;  *    inBoundingBox:
;  *      The rectangle (in coordinates relative to the current Quickdraw
;  *      port) describing the area to draw the text within. The first
;  *      line of text will be top-justified to this rectangle. Wrapping
;  *      (if desired) will happen at the horizontal extent of this
;  *      rectangle. Regardless of the amount of text in your
;  *      CFStringRef, all drawn text will be clipped to this rectangle.
;  *    
;  *    inJust:
;  *      The horizontal justification you would like for your text. You
;  *      can use one of the standard justification constants from
;  *      TextEdit.h.
;  *    
;  *    inContext:
;  *      The CGContextRef into which you would like to draw the text. On
;  *      Mac OS X, all text drawing happens in CGContextRefs; if you
;  *      pass NULL, a transient CGContextRef will be allocated and
;  *      deallocated for use within the single API call. Relying on the
;  *      system behavior if transiently createing CGContextRefs may
;  *      result in performance problems. On Mac OS 9, the CGContextRef
;  *      parameter is ignored.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetThemeFont" 
      ((inFontID :unsigned-integer) (inScript :signed-integer) (outFontName (:pointer (:string 255))) (outFontSize (:pointer :signed-integer)) (outStyle (:pointer (:unsigned-byte :set (#:bold #:italic #:underline #:outline shadow #:condense #:extend))))) 
  :osstatus
   () )                                         ; CONST; 
;  *  TruncateThemeText()
;  *  
;  *  Summary:
;  *    Truncates text to fit within the width you specify.
;  *  
;  *  Discussion:
;  *    TruncateThemeText alters a unicode string to fit within a width
;  *    that you specify. It is unicode savvy (although only partially so
;  *    under CarbonLib), and makes its calculations (and any subsequent
;  *    string alteration) based on the font and state you specify. If
;  *    the string needs to be truncated, it will be reduced to the
;  *    maximum number of characters which (with the addition of an
;  *    ellipsis character) fits within the specified width.
;  *  
;  *  Parameters:
;  *    
;  *    inString:
;  *      A CFMutableStringRef containing the unicode characters you wish
;  *      to truncate. On output, inString may have been altered to fit
;  *      within the specified width. You MUST NOT pass in a CFStringRef
;  *      that was allocated with any of the "NoCopy" CFString creation
;  *      APIs (see note in DrawThemeTextBox above).
;  *    
;  *    inFontID:
;  *      The ThemeFontID to use for text measurements. See the
;  *      discussion of ThemeFontIDs elsewhere in this header.
;  *    
;  *    inState:
;  *      The ThemeDrawState which matches the state you will ultimately
;  *      render the string width. This may affect text measurement
;  *      during truncation, so you should be sure the value you pass to
;  *      TruncateThemeText matches the value you will eventually use for
;  *      drawing.
;  *    
;  *    inPixelWidthLimit:
;  *      The maximum width (in pixels) that the resulting truncated
;  *      string may have.
;  *    
;  *    inTruncWhere:
;  *      A TruncCode indicating where you would like truncation to occur.
;  *    
;  *    outTruncated:
;  *      On output, this Boolean value indicates whether the string was
;  *      truncated. True means the string was truncated. False means the
;  *      string was not (and did not need to be) truncated.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DrawThemeTextBox" 
      ((inString :pointer) (inFontID :unsigned-integer) (inState :unsigned-long) (inWrapToWidth :boolean) (inBoundingBox (:pointer :rect)) (inJust :signed-integer) (inContext :pointer)) 
  :osstatus
   () )                                         ; 
;  *  GetThemeTextDimensions()
;  *  
;  *  Summary:
;  *    Tells you the height, width, and baseline for a string.
;  *  
;  *  Discussion:
;  *    GetThemeTextDimensions measures the given string using a font and
;  *    state you specify. It always reports the actual height and
;  *    baseline. It sometimes reports the actual width (see below). It
;  *    can measure a string that wraps. It is unicode savvy (although
;  *    only partially so under CarbonLib).
;  *  
;  *  Parameters:
;  *    
;  *    inString:
;  *      A CFStringRef containing the unicode characters you wish to
;  *      measure. You MUST NOT pass in a CFStringRef that was allocated
;  *      with any of the "NoCopy" CFString creation APIs (see note in
;  *      DrawThemeTextBox above).
;  *    
;  *    inFontID:
;  *      The ThemeFontID describing the font you'd like to measure the
;  *      text with. See the discussion of ThemeFontIDs elsewhere in this
;  *      header.
;  *    
;  *    inState:
;  *      The ThemeDrawState which matches the state you will ultimately
;  *      render the string width. This may affect text measurement, so
;  *      you should be sure the value you pass to TruncateThemeText
;  *      matches the value you will eventually use for drawing.
;  *    
;  *    inWrapToWidth:
;  *      A Boolean indicating whether you want the measurements based on
;  *      wrapping the text to a specific width. If you pass true, you
;  *      must specify the desired width in ioBounds->h.
;  *    
;  *    ioBounds:
;  *      On output, ioBounds->v contains the height of the text. If you
;  *      pass false to inWrapToWidth, ioBounds->h will contain the width
;  *      of the text on output. If you pass true to inWrapToWidth,
;  *      ioBounds->h must (on input) contain the desired width for
;  *      wrapping; on output, ioBounds->h contains the same value you
;  *      specified on input.
;  *    
;  *    outBaseline:
;  *      On output, outBaseline contains the offset (in Quickdraw space)
;  *      from the bottom edge of the last line of text to the baseline
;  *      of the first line of text. outBaseline will generally be a
;  *      negative value.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TruncateThemeText" 
      ((inString :pointer) (inFontID :unsigned-integer) (inState :unsigned-long) (inPixelWidthLimit :signed-integer) (inTruncWhere :signed-integer) (outTruncated (:pointer :boolean))) 
  :osstatus
   () )                                         ; 
;  *  GetThemeTextShadowOutset()
;  *  
;  *  Summary:
;  *    Tells you the amount of space taken up by the shadow for a given
;  *    font/state combination.
;  *  
;  *  Discussion:
;  *    GetThemeTextShadowOutset passes back the maximum amount of space
;  *    the shadow will take up for text drawn in the specified font and
;  *    state. While GetThemeTextDimensions tells you how much space is
;  *    taken up by the character glyphs themselves, it does not
;  *    incorporate the font/state shadow into its calculations. If you
;  *    need to know how much total space including the shadow will be
;  *    taken up, call GetThemeTextDimensions followed by
;  *    GetThemeTextShadowOutset.
;  *  
;  *  Parameters:
;  *    
;  *    inFontID:
;  *      The ThemeFontID describing the font you'd like the shadow
;  *      characteristics of. Font and state both determine the amount of
;  *      shadow that will be used on rendered text. See the discussion
;  *      of ThemeFontIDs elsewhere in this header.
;  *    
;  *    inState:
;  *      The ThemeDrawState which matches the state you'd like the
;  *      shadow characteristics of. Font and state both determine the
;  *      amount of shadow that will be used on rendered text.
;  *    
;  *    outOutset:
;  *      On output, outOutset contains the amount of space the shadow
;  *      will take up beyond each edge of the text bounding rectangle
;  *      returned by GetThemeTextDimensions. The fields of outOutset
;  *      will either be positive values or zero.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetThemeTextDimensions" 
      ((inString :pointer) (inFontID :unsigned-integer) (inState :unsigned-long) (inWrapToWidth :boolean) (ioBounds (:pointer :point)) (outBaseline (:pointer :signed-integer))) 
  :osstatus
   () )                                         ;  TRACKS ; 
;  *  DrawThemeTrack()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetThemeTextShadowOutset" 
      ((inFontID :unsigned-integer) (inState :unsigned-long) (outOutset (:pointer :rect))) 
  :osstatus
   () )                                         ; CONST; 
;  *  HitTestThemeTrack()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DrawThemeTrack" 
      ((drawInfo (:pointer :themetrackdrawinfo)) (rgnGhost (:handle :macregion)) (eraseProc :pointer) (eraseData :unsigned-long)) 
  :osstatus
   () )                                         ; CONST; 
;  *  GetThemeTrackBounds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HitTestThemeTrack" 
      ((drawInfo (:pointer :themetrackdrawinfo)) (mousePoint :point) (partHit (:pointer :signed-integer))) 
  :boolean
   () )                                         ; CONST; 
;  *  GetThemeTrackThumbRgn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetThemeTrackBounds" 
      ((drawInfo (:pointer :themetrackdrawinfo)) (bounds (:pointer :rect))) 
  :osstatus
   () )                                         ; CONST; 
;  *  GetThemeTrackDragRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetThemeTrackThumbRgn" 
      ((drawInfo (:pointer :themetrackdrawinfo)) (thumbRgn (:handle :macregion))) 
  :osstatus
   () )                                         ; CONST; 
;  *  DrawThemeTrackTickMarks()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetThemeTrackDragRect" 
      ((drawInfo (:pointer :themetrackdrawinfo)) (dragRect (:pointer :rect))) 
  :osstatus
   () )                                         ; CONST; 
;  *  GetThemeTrackThumbPositionFromOffset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DrawThemeTrackTickMarks" 
      ((drawInfo (:pointer :themetrackdrawinfo)) (numTicks :unsigned-long) (eraseProc :pointer) (eraseData :unsigned-long)) 
  :osstatus
   () )                                         ; CONST; 
;  *  GetThemeTrackThumbPositionFromRegion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetThemeTrackThumbPositionFromOffset" 
      ((drawInfo (:pointer :themetrackdrawinfo)) (thumbOffset :point) (relativePosition (:pointer :signed-long))) 
  :osstatus
   () )                                         ; CONST; 
;  *  GetThemeTrackLiveValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetThemeTrackThumbPositionFromRegion" 
      ((drawInfo (:pointer :themetrackdrawinfo)) (thumbRgn (:handle :macregion)) (relativePosition (:pointer :signed-long))) 
  :osstatus
   () )                                         ; CONST;  SCROLLBAR ARROWS ; 
;  *  DrawThemeScrollBarArrows()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetThemeTrackLiveValue" 
      ((drawInfo (:pointer :themetrackdrawinfo)) (relativePosition :signed-long) (value (:pointer :signed-long))) 
  :osstatus
   () )                                         ; CONST; 
;  *  GetThemeScrollBarTrackRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DrawThemeScrollBarArrows" 
      ((bounds (:pointer :rect)) (enableState :signed-byte) (pressState :signed-byte) (isHoriz :boolean) (trackBounds (:pointer :rect))) 
  :osstatus
   () )                                         ; CONST; 
;  *  HitTestThemeScrollBarArrows()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetThemeScrollBarTrackRect" 
      ((bounds (:pointer :rect)) (enableState :signed-byte) (pressState :signed-byte) (isHoriz :boolean) (trackBounds (:pointer :rect))) 
  :osstatus
   () )                                         ; CONST;  WINDOWS ; 
;  *  GetThemeWindowRegion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HitTestThemeScrollBarArrows" 
      ((scrollBarBounds (:pointer :rect)) (enableState :signed-byte) (pressState :signed-byte) (isHoriz :boolean) (ptHit :point) (trackBounds (:pointer :rect)) (partcode (:pointer :signed-integer))) 
  :boolean
   () )                                         ; CONST; CONST; 
;  *  DrawThemeWindowFrame()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetThemeWindowRegion" 
      ((flavor :unsigned-integer) (contRect (:pointer :rect)) (state :unsigned-long) (metrics (:pointer :themewindowmetrics)) (attributes :unsigned-long) (winRegion :unsigned-integer) (rgn (:handle :macregion))) 
  :osstatus
   () )                                         ; CONST; CONST; 
;  *  DrawThemeTitleBarWidget()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DrawThemeWindowFrame" 
      ((flavor :unsigned-integer) (contRect (:pointer :rect)) (state :unsigned-long) (metrics (:pointer :themewindowmetrics)) (attributes :unsigned-long) (titleProc :pointer) (titleData :unsigned-long)) 
  :osstatus
   () )                                         ; CONST; CONST; 
;  *  GetThemeWindowRegionHit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DrawThemeTitleBarWidget" 
      ((flavor :unsigned-integer) (contRect (:pointer :rect)) (state :unsigned-long) (metrics (:pointer :themewindowmetrics)) (attributes :unsigned-long) (widget :unsigned-integer)) 
  :osstatus
   () )                                         ; CONST; CONST; 
;  *  DrawThemeScrollBarDelimiters()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetThemeWindowRegionHit" 
      ((flavor :unsigned-integer) (inContRect (:pointer :rect)) (state :unsigned-long) (metrics (:pointer :themewindowmetrics)) (inAttributes :unsigned-long) (inPoint :point) (outRegionHit (:pointer :unsigned-integer))) 
  :boolean
   () )                                         ; CONST;  BUTTONS ; 
;  *  DrawThemeButton()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DrawThemeScrollBarDelimiters" 
      ((flavor :unsigned-integer) (inContRect (:pointer :rect)) (state :unsigned-long) (attributes :unsigned-long)) 
  :osstatus
   () )                                         ; CONST; CONST; Const; 
;  *  GetThemeButtonRegion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DrawThemeButton" 
      ((inBounds (:pointer :rect)) (inKind :unsigned-integer) (inNewInfo (:pointer :themebuttondrawinfo)) (inPrevInfo (:pointer :themebuttondrawinfo)) (inEraseProc :pointer) (inLabelProc :pointer) (inUserData :unsigned-long)) 
  :osstatus
   () )                                         ; CONST; CONST; 
;  *  GetThemeButtonContentBounds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetThemeButtonRegion" 
      ((inBounds (:pointer :rect)) (inKind :unsigned-integer) (inNewInfo (:pointer :themebuttondrawinfo)) (outRegion (:handle :macregion))) 
  :osstatus
   () )                                         ; CONST; CONST; 
;  *  GetThemeButtonBackgroundBounds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetThemeButtonContentBounds" 
      ((inBounds (:pointer :rect)) (inKind :unsigned-integer) (inDrawInfo (:pointer :themebuttondrawinfo)) (outBounds (:pointer :rect))) 
  :osstatus
   () )                                         ; CONST; CONST;  INTERFACE SOUNDS ;                                                                                                   ;   X ALERT: Please note that the sound APIs do not work on Mac OS X at present.                    ; 
;  *  PlayThemeSound()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetThemeButtonBackgroundBounds" 
      ((inBounds (:pointer :rect)) (inKind :unsigned-integer) (inDrawInfo (:pointer :themebuttondrawinfo)) (outBounds (:pointer :rect))) 
  :osstatus
   () )
(deftrap "_PlayThemeSound" 
      ((kind :ostype))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 38 kind))

; 
;  *  BeginThemeDragSound()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_BeginThemeDragSound" 
      ((kind :ostype))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 39 kind))

; 
;  *  EndThemeDragSound()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_EndThemeDragSound" 
      ()
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 40))

;  PRIMITIVES 
; 
;  *  DrawThemeTickMark()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; 
;  *  DrawThemeChasingArrows()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DrawThemeTickMark" 
      ((bounds (:pointer :rect)) (state :unsigned-long)) 
  :osstatus
   () )                                         ; CONST; 
;  *  DrawThemePopupArrow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DrawThemeChasingArrows" 
      ((bounds (:pointer :rect)) (index :unsigned-long) (state :unsigned-long) (eraseProc :pointer) (eraseData :unsigned-long)) 
  :osstatus
   () )                                         ; CONST; 
;  *  DrawThemeStandaloneGrowBox()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DrawThemePopupArrow" 
      ((bounds (:pointer :rect)) (orientation :unsigned-integer) (size :unsigned-integer) (state :unsigned-long) (eraseProc :pointer) (eraseData :unsigned-long)) 
  :osstatus
   () )                                         ; 
;  *  DrawThemeStandaloneNoGrowBox()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DrawThemeStandaloneGrowBox" 
      ((origin :point) (growDirection :unsigned-integer) (isSmall :boolean) (state :unsigned-long)) 
  :osstatus
   () )                                         ; 
;  *  GetThemeStandaloneGrowBoxBounds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DrawThemeStandaloneNoGrowBox" 
      ((origin :point) (growDirection :unsigned-integer) (isSmall :boolean) (state :unsigned-long)) 
  :osstatus
   () )                                         ;  DRAWING STATE ;  The following routines help you save and restore the drawing state in a theme-savvy manner. With ;  these weapons in your arsenal, there is no grafport you cannot tame. Use ThemeGetDrawingState to ;  get the current drawing settings for the current port. It will return an opaque object for you   ;  to pass into SetThemeDrawingState later on. When you are finished with the state, call the       ;  DisposeThemeDrawingState routine. You can alternatively pass true into the inDisposeNow          ;  parameter of the SetThemeDrawingState routine.  You can use this routine to copy the drawing     ;  state from one port to another as well.                                                          ;                                                                                                   ;  As of this writing (Mac OS 9.1 and Mac OS X), Get/SetThemeDrawingState will save and restore     ;  this data in the port:                                                                           ;                                                                                                   ;       pen size                                                                                    ;       pen location                                                                                ;       pen mode                                                                                    ;       pen Pattern and PixPat                                                                      ;       background Pattern and PixPat                                                               ;       RGB foreground and background colors                                                        ;       text mode                                                                                   ;       pattern origin                                                                              ;                                                                                                   ;  Get/SetThemeDrawingState may save and restore additional port state in the future, but you can   ;  rely on them to always save at least this port state.                                            ; 
;  *  NormalizeThemeDrawingState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetThemeStandaloneGrowBoxBounds" 
      ((origin :point) (growDirection :unsigned-integer) (isSmall :boolean) (bounds (:pointer :rect))) 
  :osstatus
   () )                                         ; 
;  *  GetThemeDrawingState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NormalizeThemeDrawingState" 
      () 
  :osstatus
   () )                                         ; 
;  *  SetThemeDrawingState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetThemeDrawingState" 
      ((outState (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  DisposeThemeDrawingState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetThemeDrawingState" 
      ((inState :pointer) (inDisposeNow :boolean)) 
  :osstatus
   () )                                         ;  MISCELLANEOUS ;  ApplyThemeBackground is used to set up the background for embedded controls  ;  It is normally called by controls that are embedders. The standard controls  ;  call this API to ensure a correct background for the current theme. You pass ;  in the same rectangle you would if you were calling the drawing primitive.   ; 
;  *  ApplyThemeBackground()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DisposeThemeDrawingState" 
      ((inState :pointer)) 
  :osstatus
   () )                                         ; CONST; 
;  *  SetThemeTextColorForWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ApplyThemeBackground" 
      ((inKind :unsigned-long) (bounds (:pointer :rect)) (inState :unsigned-long) (inDepth :signed-integer) (inColorDev :boolean)) 
  :osstatus
   () )                                         ; 
;  *  IsValidAppearanceFileType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetThemeTextColorForWindow" 
      ((window (:pointer :windowrecord)) (isActive :boolean) (depth :signed-integer) (isColorDev :boolean)) 
  :osstatus
   () )                                         ; 
;  *  GetThemeBrushAsColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IsValidAppearanceFileType" 
      ((fileType :ostype)) 
  :boolean
   () )                                         ; 
;  *  GetThemeTextColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetThemeBrushAsColor" 
      ((inBrush :signed-integer) (inDepth :signed-integer) (inColorDev :boolean) (outColor (:pointer :rgbcolor))) 
  :osstatus
   () )                                         ;  BEGIN CARBON ; 
;  *  GetThemeMetric()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetThemeTextColor" 
      ((inColor :signed-integer) (inDepth :signed-integer) (inColorDev :boolean) (outColor (:pointer :rgbcolor))) 
  :osstatus
   () )                                         ; 
;  *  GetTextAndEncodingFromCFString()
;  *  
;  *  Summary:
;  *    Converts the contents of a CFString to the one- or two-byte
;  *    encoding that most accurately represents the original Unicode
;  *    characters in the string.
;  *  
;  *  Discussion:
;  *    Because the Macintosh toolbox has had, until Carbon, little
;  *    support for Unicode, you may often find that your applications
;  *    need to translate a CFString (containing Unicode characters) back
;  *    to a one- or two-byte encoding of the string in order to draw,
;  *    measure, or otherwise use the text in the string.
;  *    GetTextAndEncodingFromCFString is a utility that may be helpful
;  *    to do this, in some circumstances. The Carbon toolbox uses this
;  *    API itself when translating CFStrings to Pascal strings.
;  *    GetTextAndEncodingFromCFString attempts to convert the Unicode
;  *    characters in the string to the closest non-Unicode
;  *    representation of the string. For example, a string containing
;  *    only Unicode characters that are present in the MacRoman one-byte
;  *    encoding will be translated to MacRoman, and
;  *    kTextEncodingMacRoman will be returned as the encoding of the
;  *    text. A string containing Unicode characters that are present in
;  *    the MacJapanese two-byte encoding will be translated to
;  *    MacJapanese (Shift-JIS), and kTextEncodingMacJapanese will be
;  *    returned as the encoding of the text.
;  *    GetTextAndEncodingFromCFString is designed to be used for simple
;  *    strings which contain only text from a single language. It is not
;  *    designed to translate strings with multiple runs of text from
;  *    different languages, and will only return the first run of such a
;  *    string; for example, if you pass it a string containing a run of
;  *    Roman characters followed by a run of Japanese characters, it
;  *    will only return the Roman characters in the output buffer. For
;  *    more complex text translation, you should call the Unicode
;  *    converter directly (see ConvertFromUnicodeToTextRun, which
;  *    GetTextAndEncodingFromCFString uses internally).
;  *  
;  *  Parameters:
;  *    
;  *    inString:
;  *      The string to convert.
;  *    
;  *    outText:
;  *      The output buffer in which to place the converted text.
;  *    
;  *    inTextMaxLength:
;  *      The length in bytes of the input buffer.
;  *    
;  *    outTextLength:
;  *      On exit, contains the length in bytes of the text that was
;  *      placed into the output buffer.
;  *    
;  *    outEncoding:
;  *      On exit, contains the encoding of the text that was placed into
;  *      the output buffer.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.2.5 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetThemeMetric" 
      ((inMetric :unsigned-long) (outMetric (:pointer :signed-long))) 
  :osstatus
   () )                                         ; 
;  *  CopyThemeIdentifier()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.1 and later
;  
(deftrap-inline "_GetTextAndEncodingFromCFString" 
      ((inString :pointer) (outText (:pointer :unsigned-byte)) (inTextMaxLength :unsigned-long) (outTextLength (:pointer :unsigned-long)) (outEncoding (:pointer :unsigned-long))) 
  :osstatus
   () )
(deftrap-inline "_CopyThemeIdentifier" 
      ((outIdentifier (:pointer :pointer))) 
  :osstatus
   () )

; 
;  Obsolete symbolic names                                                                          
; 
;  Obsolete error codes - use the new ones, s'il vous plait / kudasai 

(defconstant $appearanceBadBrushIndexErr -30560);   pattern index invalid  
(defconstant $appearanceProcessRegisteredErr -30561)
(defconstant $appearanceProcessNotRegisteredErr -30562)
(defconstant $appearanceBadTextColorIndexErr -30563)
(defconstant $appearanceThemeHasNoAccents -30564)
(defconstant $appearanceBadCursorIndexErr -30565)

(defconstant $kThemeActiveDialogBackgroundBrush 1)
(defconstant $kThemeInactiveDialogBackgroundBrush 2)
(defconstant $kThemeActiveAlertBackgroundBrush 3)
(defconstant $kThemeInactiveAlertBackgroundBrush 4)
(defconstant $kThemeActiveModelessDialogBackgroundBrush 5)
(defconstant $kThemeInactiveModelessDialogBackgroundBrush 6)
(defconstant $kThemeActiveUtilityWindowBackgroundBrush 7)
(defconstant $kThemeInactiveUtilityWindowBackgroundBrush 8)
(defconstant $kThemeListViewSortColumnBackgroundBrush 9)
(defconstant $kThemeListViewBackgroundBrush 10)
(defconstant $kThemeIconLabelBackgroundBrush 11)
(defconstant $kThemeListViewSeparatorBrush 12)
(defconstant $kThemeChasingArrowsBrush 13)
(defconstant $kThemeDragHiliteBrush 14)
(defconstant $kThemeDocumentWindowBackgroundBrush 15)
(defconstant $kThemeFinderWindowBackgroundBrush 16)

(defconstant $kThemeActiveScrollBarDelimiterBrush 17)
(defconstant $kThemeInactiveScrollBarDelimiterBrush 18)
(defconstant $kThemeFocusHighlightBrush 19)
(defconstant $kThemeActivePopupArrowBrush 20)
(defconstant $kThemePressedPopupArrowBrush 21)
(defconstant $kThemeInactivePopupArrowBrush 22)
(defconstant $kThemeAppleGuideCoachmarkBrush 23)

(defconstant $kThemeActiveDialogTextColor 1)
(defconstant $kThemeInactiveDialogTextColor 2)
(defconstant $kThemeActiveAlertTextColor 3)
(defconstant $kThemeInactiveAlertTextColor 4)
(defconstant $kThemeActiveModelessDialogTextColor 5)
(defconstant $kThemeInactiveModelessDialogTextColor 6)
(defconstant $kThemeActiveWindowHeaderTextColor 7)
(defconstant $kThemeInactiveWindowHeaderTextColor 8)
(defconstant $kThemeActivePlacardTextColor 9)
(defconstant $kThemeInactivePlacardTextColor 10)
(defconstant $kThemePressedPlacardTextColor 11)
(defconstant $kThemeActivePushButtonTextColor 12)
(defconstant $kThemeInactivePushButtonTextColor 13)
(defconstant $kThemePressedPushButtonTextColor 14)
(defconstant $kThemeActiveBevelButtonTextColor 15)
(defconstant $kThemeInactiveBevelButtonTextColor 16)
(defconstant $kThemePressedBevelButtonTextColor 17)
(defconstant $kThemeActivePopupButtonTextColor 18)
(defconstant $kThemeInactivePopupButtonTextColor 19)
(defconstant $kThemePressedPopupButtonTextColor 20)
(defconstant $kThemeIconLabelTextColor 21)
(defconstant $kThemeListViewTextColor 22)

(defconstant $kThemeActiveDocumentWindowTitleTextColor 23)
(defconstant $kThemeInactiveDocumentWindowTitleTextColor 24)
(defconstant $kThemeActiveMovableModalWindowTitleTextColor 25)
(defconstant $kThemeInactiveMovableModalWindowTitleTextColor 26)
(defconstant $kThemeActiveUtilityWindowTitleTextColor 27)
(defconstant $kThemeInactiveUtilityWindowTitleTextColor 28)
(defconstant $kThemeActivePopupWindowTitleColor 29)
(defconstant $kThemeInactivePopupWindowTitleColor 30)
(defconstant $kThemeActiveRootMenuTextColor 31)
(defconstant $kThemeSelectedRootMenuTextColor 32)
(defconstant $kThemeDisabledRootMenuTextColor 33)
(defconstant $kThemeActiveMenuItemTextColor 34)
(defconstant $kThemeSelectedMenuItemTextColor 35)
(defconstant $kThemeDisabledMenuItemTextColor 36)
(defconstant $kThemeActivePopupLabelTextColor 37)
(defconstant $kThemeInactivePopupLabelTextColor 38)

(defconstant $kAEThemeSwitch :|thme|)           ;   Event ID's: Theme Switched  

(defconstant $kThemeNoAdornment 0)
(defconstant $kThemeDefaultAdornment #x1)
(defconstant $kThemeFocusAdornment #x4)
(defconstant $kThemeRightToLeftAdornment #x10)
(defconstant $kThemeDrawIndicatorOnly #x20)

(defconstant $kThemeBrushPassiveAreaFill 25)

(defconstant $kThemeMetricCheckBoxGlyphHeight 2)
(defconstant $kThemeMetricRadioButtonGlyphHeight 3)
(defconstant $kThemeMetricDisclosureButtonSize 17)
(defconstant $kThemeMetricBestListHeaderHeight 20)
(defconstant $kThemeMetricSmallProgressBarThickness 58);   obsolete  
(defconstant $kThemeMetricProgressBarThickness 32);   obsolete  

(defconstant $kThemeScrollBar 0)
(defconstant $kThemeSlider 2)
(defconstant $kThemeProgressBar 3)
(defconstant $kThemeIndeterminateBar 4)

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := AppearanceIncludes

; $ENDC                                         ; __APPEARANCE__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'Appearance)