(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:AppleEvents.p"
; at Wednesday May 1,2002 2:38:52 pm.
; 
;      File:       AppleEvents.p
;  
;      Contains:   AppleEvent Package Interfaces.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1989-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __APPLEEVENTS__
; $SETC __APPLEEVENTS__ := 1

; $I+
; $SETC AppleEventsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC
; 
;     Note:   The functions and types for the building and parsing AppleEvent  
;             messages has moved to AEDataModel.h
; 
#|                                              ; $IFC UNDEFINED __AEDATAMODEL__
|#

(require-interface 'AEDataModel)
#|                                              ; $I AEDataModel.p
 |#                                             ; $ENDC

; 
;     Note:   The functions for interacting with events has moved to AEInteraction.h
; 
; $IFC UNDEFINED __AEINTERACTION__

(require-interface 'AEInteraction)              ; $I AEInteraction.p
; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;   Keywords for Apple event parameters  
(defconstant $keyDirectObject :|----|)
(defconstant $keyErrorNumber :|errn|)
(defconstant $keyErrorString :|errs|)
(defconstant $keyProcessSerialNumber :|psn |)   ;   Keywords for special handlers  
(defconstant $keyPreDispatch :|phac|)           ;   preHandler accessor call  
(defconstant $keySelectProc :|selh|)            ;   more selector call  
;   Keyword for recording  
(defconstant $keyAERecorderCount :|recr|)       ;   available only in vers 1.0.1 and greater  
;   Keyword for version information  
(defconstant $keyAEVersion :|vers|)             ;   available only in vers 1.0.1 and greater  

; 	 Event Class 	
(defconstant $kCoreEventClass :|aevt|)

; 	 Event IDs 	
(defconstant $kAEOpenApplication :|oapp|)
(defconstant $kAEOpenDocuments :|odoc|)
(defconstant $kAEPrintDocuments :|pdoc|)
(defconstant $kAEQuitApplication :|quit|)
(defconstant $kAEAnswer :|ansr|)
(defconstant $kAEApplicationDied :|obit|)
(defconstant $kAEShowPreferences :|pref|)       ;   sent by Mac OS X when the user chooses the Preferences item  

; 	 Constants for recording 	
(defconstant $kAEStartRecording :|reca|)        ;   available only in vers 1.0.1 and greater  
(defconstant $kAEStopRecording :|recc|)         ;   available only in vers 1.0.1 and greater  
(defconstant $kAENotifyStartRecording :|rec1|)  ;   available only in vers 1.0.1 and greater  
(defconstant $kAENotifyStopRecording :|rec0|)   ;   available only in vers 1.0.1 and greater  
(defconstant $kAENotifyRecording :|recr|)       ;   available only in vers 1.0.1 and greater  

; 	
; 	 * AEEventSource is defined as an SInt8 for compatability with pascal.
; 	 * Important note: keyEventSourceAttr is returned by AttributePtr as a typeShortInteger.
; 	 * Be sure to pass at least two bytes of storage to AEGetAttributePtr - the result can be
; 	 * compared directly against the following enums.
; 	 	

(def-mactype :aeeventsource (find-mactype ':signed-byte))

(defconstant $kAEUnknownSource 0)
(defconstant $kAEDirectCall 1)
(defconstant $kAESameProcess 2)
(defconstant $kAELocalProcess 3)
(defconstant $kAERemoteProcess 4)

; 	*************************************************************************
; 	  These calls are used to set up and modify the event dispatch table.
; 	*************************************************************************	
; 
; 	 *  AEInstallEventHandler()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_AEInstallEventHandler" 
      ((theAEEventClass :ostype) (theAEEventID :ostype) (handler :pointer) (handlerRefcon :signed-long) (isSysHandler :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 2335 theAEEventClass theAEEventID handler handlerRefcon isSysHandler))

; 
;  *  AERemoveEventHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AERemoveEventHandler" 
      ((theAEEventClass :ostype) (theAEEventID :ostype) (handler :pointer) (isSysHandler :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 1824 theAEEventClass theAEEventID handler isSysHandler))

; 
;  *  AEGetEventHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AEGetEventHandler" 
      ((theAEEventClass :ostype) (theAEEventID :ostype) (handler (:pointer :pointer)) (handlerRefcon (:pointer :signed-long)) (isSysHandler :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 2337 theAEEventClass theAEEventID handler handlerRefcon isSysHandler))

; *************************************************************************
;   These calls are used to set up and modify special hooks into the
;   AppleEvent manager.
; *************************************************************************
; 
;  *  AEInstallSpecialHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AEInstallSpecialHandler" 
      ((functionClass :ostype) (handler :pointer) (isSysHandler :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 1280 functionClass handler isSysHandler))

; 
;  *  AERemoveSpecialHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AERemoveSpecialHandler" 
      ((functionClass :ostype) (handler :pointer) (isSysHandler :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 1281 functionClass handler isSysHandler))

; 
;  *  AEGetSpecialHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AEGetSpecialHandler" 
      ((functionClass :ostype) (handler (:pointer :pointer)) (isSysHandler :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 1325 functionClass handler isSysHandler))

; *************************************************************************
;   This call was added in version 1.0.1. If called with the keyword
;   keyAERecorderCount ('recr'), the number of recorders that are
;   currently active is returned in 'result'
;   (available only in vers 1.0.1 and greater).
; *************************************************************************
; 
;  *  AEManagerInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AEManagerInfo" 
      ((keyWord :ostype) (result (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xA816 :d0 1089 keyWord result))

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := AppleEventsIncludes

; $ENDC                                         ; __APPLEEVENTS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'AppleEvents)