(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:AppleGuide.p"
; at Wednesday May 1,2002 2:39:55 pm.
; 
;      File:       AppleGuide.p
;  
;      Contains:   Apple Guide Interfaces.
;  
;      Version:    Technology: Mac OS 8
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1994-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __APPLEGUIDE__
; $SETC __APPLEGUIDE__ := 1

; $I+
; $SETC AppleGuideIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __APPLEEVENTS__
|#

(require-interface 'AppleEvents)
#|                                              ; $I AppleEvents.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;   Types 

(def-mactype :agrefnum (find-mactype ':unsigned-long))
(def-mactype :agcoachrefnum (find-mactype ':unsigned-long))
(def-mactype :agcontextrefnum (find-mactype ':unsigned-long))
(def-mactype :agappinfoptr (find-mactype '(:pointer :agappinfo)))
(defrecord AGAppInfo 
   (eventId :ostype)
   (refCon :signed-long)
   (contextObj :pointer)                        ;   private system field 
   )

(def-mactype :agappinfohdl (find-mactype '(:handle :agappinfo)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CoachReplyProcPtr = FUNCTION(VAR pRect: Rect; name: Ptr; refCon: LONGINT): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :coachreplyprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ContextReplyProcPtr = FUNCTION(pInputData: Ptr; inputDataSize: Size; VAR ppOutputData: Ptr; VAR pOutputDataSize: Size; hAppInfo: AGAppInfoHdl): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :contextreplyprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :coachreplyupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :coachreplyupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :contextreplyupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :contextreplyupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppCoachReplyProcInfo #xFE0)
(defconstant $uppContextReplyProcInfo #xFFE0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewCoachReplyUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewCoachReplyProc 
(deftrap "_NewCoachReplyUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewContextReplyUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewContextReplyProc 
(deftrap "_NewContextReplyUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeCoachReplyUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeCoachReplyUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeContextReplyUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeContextReplyUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeCoachReplyUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallCoachReplyProc 
(deftrap-inline "_InvokeCoachReplyUPP" 
      ((pRect (:pointer :rect)) (name :pointer) (refCon :signed-long) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeContextReplyUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallContextReplyProc 
(deftrap-inline "_InvokeContextReplyUPP" 
      ((pInputData :pointer) (inputDataSize :signed-long) (ppOutputData (:pointer :pointer)) (pOutputDataSize (:pointer :signed-long)) (hAppInfo (:handle :agappinfo)) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

;   Constants 

(defconstant $kAGDefault 0)
(defconstant $kAGFrontDatabase 1)
(defconstant $kAGNoMixin -1)

(defconstant $kAGViewFullHowdy 1)               ;   Full-size Howdy 
(defconstant $kAGViewTopicAreas 2)              ;   Full-size Topic Areas 
(defconstant $kAGViewIndex 3)                   ;   Full-size Index Terms 
(defconstant $kAGViewLookFor 4)                 ;   Full-size Look-For (Search) 
(defconstant $kAGViewSingleHowdy 5)             ;   Single-list-size Howdy 
(defconstant $kAGViewSingleTopics 6)            ;   Single-list-size Topics 

(defconstant $kAGFileMain :|poco|)
(defconstant $kAGFileMixin :|mixn|)

;   To test against AGGetAvailableDBTypes 
(defconstant $kAGDBTypeBitAny #x1)
(defconstant $kAGDBTypeBitHelp #x2)
(defconstant $kAGDBTypeBitTutorial #x4)
(defconstant $kAGDBTypeBitShortcuts #x8)
(defconstant $kAGDBTypeBitAbout #x10)
(defconstant $kAGDBTypeBitOther #x80)

(def-mactype :agstatus (find-mactype ':unsigned-integer))
;   Returned by AGGetStatus 

(defconstant $kAGIsNotRunning 0)
(defconstant $kAGIsSleeping 1)
(defconstant $kAGIsActive 2)

;   Flags used in AGOpen, AGOpenWithSearch, AGOpenWithView 
(defconstant $kHelpViewerSearchAll #x1)

(def-mactype :agwindowkind (find-mactype ':unsigned-integer))
;   Returned by AGGetFrontWindowKind 

(defconstant $kAGNoWindow 0)
(defconstant $kAGAccessWindow 1)
(defconstant $kAGPresentationWindow 2)

;   Error Codes 

;   Not an enum, because other OSErrs are valid. 

(def-mactype :agerr (find-mactype ':signed-integer))
;   Apple Guide error codes 

;   -------------------- Apple event reply codes 
(defconstant $kAGErrUnknownEvent -2900)
(defconstant $kAGErrCantStartup -2901)
(defconstant $kAGErrNoAccWin -2902)
(defconstant $kAGErrNoPreWin -2903)
(defconstant $kAGErrNoSequence -2904)
(defconstant $kAGErrNotOopsSequence -2905)
(defconstant $kAGErrReserved06 -2906)
(defconstant $kAGErrNoPanel -2907)
(defconstant $kAGErrContentNotFound -2908)
(defconstant $kAGErrMissingString -2909)
(defconstant $kAGErrInfoNotAvail -2910)
(defconstant $kAGErrEventNotAvailable -2911)
(defconstant $kAGErrCannotMakeCoach -2912)
(defconstant $kAGErrSessionIDsNotMatch -2913)
(defconstant $kAGErrMissingDatabaseSpec -2914)
(defconstant $kAGMissingSequenceMap -2915)      ;   -------------------- Coach's Chalkboard reply codes 
(defconstant $kAGErrItemNotFound -2925)
(defconstant $kAGErrBalloonResourceNotFound -2926)
(defconstant $kAGErrChalkResourceNotFound -2927)
(defconstant $kAGErrChdvResourceNotFound -2928)
(defconstant $kAGErrAlreadyShowing -2929)
(defconstant $kAGErrBalloonResourceSkip -2930)
(defconstant $kAGErrItemNotVisible -2931)
(defconstant $kAGErrReserved32 -2932)
(defconstant $kAGErrNotFrontProcess -2933)
(defconstant $kAGErrMacroResourceNotFound -2934);   -------------------- API reply codes 
(defconstant $kAGErrAppleGuideNotAvailable -2951)
(defconstant $kAGErrCannotInitCoach -2952)
(defconstant $kAGErrCannotInitContext -2953)
(defconstant $kAGErrCannotOpenAliasFile -2954)
(defconstant $kAGErrNoAliasResource -2955)
(defconstant $kAGErrDatabaseNotAvailable -2956)
(defconstant $kAGErrDatabaseNotOpen -2957)
(defconstant $kAGErrMissingAppInfoHdl -2958)
(defconstant $kAGErrMissingContextObject -2959)
(defconstant $kAGErrInvalidRefNum -2960)
(defconstant $kAGErrDatabaseOpen -2961)
(defconstant $kAGErrInsufficientMemory -2962)

;   Events 

;   Not an enum because we want to make assignments. 

(def-mactype :agevent (find-mactype ':unsigned-long))
;   Handy events for AGGeneral. 

;   Panel actions (Require a presentation window). 
(defconstant $kAGEventDoCoach :|doco|)
(defconstant $kAGEventDoHuh :|dhuh|)
(defconstant $kAGEventGoNext :|gonp|)
(defconstant $kAGEventGoPrev :|gopp|)
(defconstant $kAGEventHidePanel :|pahi|)
(defconstant $kAGEventReturnBack :|gobk|)
(defconstant $kAGEventShowPanel :|pash|)
(defconstant $kAGEventTogglePanel :|patg|)

;   Functions 

; 
; 	   AGClose
; 	   Close the database associated with the AGRefNum.
; 	

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  AGClose()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in AppleGuideLib 2.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_AGClose" 
      ((refNum (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA6E :d0 17 refNum))

; 
;    AGGeneral
;    Cause various events to happen.
; 

; 
;  *  AGGeneral()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AGGeneral" 
      ((refNum :unsigned-long) (theEvent :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xAA6E :d0 13 refNum theEvent))

; 
;    AGGetAvailableDBTypes
;    Return the database types available for this application.
; 

; 
;  *  AGGetAvailableDBTypes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AGGetAvailableDBTypes" 
      ()
   (:stack :unsigned-long)
   (:stack-trap #xAA6E :d0 8))

; 
;    AGGetFrontWindowKind
;    Return the kind of the front window.
; 

; 
;  *  AGGetFrontWindowKind()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AGGetFrontWindowKind" 
      ((refNum :unsigned-long))
   (:stack :unsigned-integer)
   (:stack-trap #xAA6E :d0 12 refNum))

; 
;    AGGetFSSpec
;    Return the FSSpec for the AGRefNum.
; 

; 
;  *  AGGetFSSpec()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AGGetFSSpec" 
      ((refNum :unsigned-long) (fileSpec (:pointer :fsspec)))
   (:stack :signed-integer)
   (:stack-trap #xAA6E :d0 15 refNum fileSpec))

; 
;    AGGetStatus
;    Return the status of Apple Guide.
; 

; 
;  *  AGGetStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AGGetStatus" 
      ()
   (:stack :unsigned-integer)
   (:stack-trap #xAA6E :d0 9))

; 
;    AGInstallCoachHandler
;    Install a Coach object location query handler.
; 

; 
;  *  AGInstallCoachHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AGInstallCoachHandler" 
      ((coachReplyProc :pointer) (refCon :signed-long) (resultRefNum (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA6E :d0 18 coachReplyProc refCon resultRefNum))

; 
;    AGInstallContextHandler
;    Install a context check query handler.
; 

; 
;  *  AGInstallContextHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AGInstallContextHandler" 
      ((contextReplyProc :pointer) (eventID :ostype) (refCon :signed-long) (resultRefNum (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA6E :d0 19 contextReplyProc eventID refCon resultRefNum))

; 
;    AGIsDatabaseOpen
;    Return true if the database associated with the AGRefNum is open.
; 

; 
;  *  AGIsDatabaseOpen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AGIsDatabaseOpen" 
      ((refNum :unsigned-long))
   (:stack :boolean)
   (:stack-trap #xAA6E :d0 6 refNum))

; 
;    AGOpen
;    Open a guide database.
; 

; 
;  *  AGOpen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AGOpen" 
      ((fileSpec (:pointer :fsspec)) (flags :unsigned-long) (mixinControl :handle) (resultRefNum (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA6E :d0 1 fileSpec flags mixinControl resultRefNum))

; 
;    AGOpenWithSearch
;    Open a guide database and preset a search string.
; 

; 
;  *  AGOpenWithSearch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AGOpenWithSearch" 
      ((fileSpec (:pointer :fsspec)) (flags :unsigned-long) (mixinControl :handle) (searchString (:string 255)) (resultRefNum (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA6E :d0 2 fileSpec flags mixinControl searchString resultRefNum))

; 
;    AGOpenWithSequence
;    Open a guide database and display a presentation window sequence.
; 

; 
;  *  AGOpenWithSequence()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AGOpenWithSequence" 
      ((fileSpec (:pointer :fsspec)) (flags :unsigned-long) (mixinControl :handle) (sequenceID :signed-integer) (resultRefNum (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA6E :d0 4 fileSpec flags mixinControl sequenceID resultRefNum))

; 
;    AGOpenWithView
;    Open a guide database and override the default view.
; 

; 
;  *  AGOpenWithView()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AGOpenWithView" 
      ((fileSpec (:pointer :fsspec)) (flags :unsigned-long) (mixinControl :handle) (viewNum :signed-integer) (resultRefNum (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA6E :d0 5 fileSpec flags mixinControl viewNum resultRefNum))

; 
;    AGQuit
;    Make Apple Guide quit.
; 

; 
;  *  AGQuit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AGQuit" 
      ()
   (:stack :signed-integer)
   (:stack-trap #xAA6E :d0 16))

; 
;    AGRemoveCoachHandler
;    Remove the Coach object location query handler.
; 

; 
;  *  AGRemoveCoachHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AGRemoveCoachHandler" 
      ((resultRefNum (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA6E :d0 20 resultRefNum))

; 
;    AGRemoveContextHandler
;    Remove the context check query handler.
; 

; 
;  *  AGRemoveContextHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AGRemoveContextHandler" 
      ((resultRefNum (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA6E :d0 21 resultRefNum))

; 
;    AGStart
;    Start up Apple Guide in the background.
; 

; 
;  *  AGStart()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AGStart" 
      ()
   (:stack :signed-integer)
   (:stack-trap #xAA6E :d0 10))

;   typedef's 

; $ENDC                                         ; CALL_NOT_IN_CARBON

(%define-record :agfilefsspectype (find-record-descriptor :fsspec))
(def-mactype :agfilefsspectypeptr (find-mactype '(:pointer :fsspec)))
(def-mactype :agfileselectorcounttype (find-mactype ':signed-integer))
(def-mactype :agfileselectorindextype (find-mactype ':signed-integer))
(def-mactype :agfileselectortype (find-mactype ':ostype))
(def-mactype :agfileselectorvaluetype (find-mactype ':signed-long))
(def-mactype :agfiledbtype (find-mactype ':signed-integer))
(defrecord :AGFileDBMenuNamePtr 
  (length :unsigned-byte)
 (contents (:array :unsigned-byte 63)))
(def-mactype :agfiledbscripttype (find-mactype ':signed-integer))
(def-mactype :agfiledbregiontype (find-mactype ':signed-integer))
(def-mactype :agfilemajorrevtype (find-mactype ':signed-integer))
(def-mactype :agfileminorrevtype (find-mactype ':signed-integer))
(def-mactype :agfilecounttype (find-mactype ':signed-integer))
;   Database types (for AGFileDBType parameter). 

(defconstant $kAGFileDBTypeAny 0)
(defconstant $kAGFileDBTypeHelp 1)
(defconstant $kAGFileDBTypeTutorial 2)
(defconstant $kAGFileDBTypeShortcuts 3)
(defconstant $kAGFileDBTypeAbout 4)
(defconstant $kAGFileDBTypeOther 8)

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  AGFileGetDBMenuName()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in AppleGuideLib 2.2 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST                                         ;   Get the database type. ; 
;  *  AGFileGetDBType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_AGFileGetDBMenuName" 
      ((fileSpec (:pointer :fsspec)) (menuItemNameString (:pointer (:string 63)))) 
  :signed-integer
   () )                                         ; CONST; 
;    Get the version of the software
;    that created this database.
;                                               ; 
;  *  AGFileGetDBVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_AGFileGetDBType" 
      ((fileSpec (:pointer :fsspec)) (databaseType (:pointer :signed-integer))) 
  :signed-integer
   () )                                         ; CONST;   Get the database script and region information. ; 
;  *  AGFileGetDBCountry()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_AGFileGetDBVersion" 
      ((fileSpec (:pointer :fsspec)) (majorRev (:pointer :signed-integer)) (minorRev (:pointer :signed-integer))) 
  :signed-integer
   () )                                         ; CONST;   Return the number of selectors in database. ; 
;  *  AGFileGetSelectorCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_AGFileGetDBCountry" 
      ((fileSpec (:pointer :fsspec)) (script (:pointer :signed-integer)) (region (:pointer :signed-integer))) 
  :signed-integer
   () )                                         ; CONST; 
;    Get the i-th database selector (1 to AGFileSelectorCountType)
;    and its value.
;                                               ; 
;  *  AGFileGetSelector()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_AGFileGetSelectorCount" 
      ((fileSpec (:pointer :fsspec))) 
  :agfileselectorcounttype
   () )                                         ; CONST;   Return true if database is mixin. ; 
;  *  AGFileIsMixin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_AGFileGetSelector" 
      ((fileSpec (:pointer :fsspec)) (selectorNumber :signed-integer) (selector (:pointer :ostype)) (value (:pointer :signed-long))) 
  :signed-integer
   () )                                         ; CONST; 
;    Return the number of database files
;    of the specified databaseType and main/mixin.
;    Any file creator is acceptible,
;    but type must be kAGFileMain or kAGFileMixin.
;                                               ; 
;  *  AGFileGetDBCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_AGFileIsMixin" 
      ((fileSpec (:pointer :fsspec))) 
  :boolean
   () )                                         ; 
;    Get the FSSpec for the dbIndex-th database
;    of the specified databaseType and main/mixin.
;    Any file creator is acceptible,
;    but type must be kAGFileMain or kAGFileMixin.
;                                               ; 
;  *  AGFileGetIndDB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_AGFileGetDBCount" 
      ((vRefNum :signed-integer) (dirID :signed-long) (databaseType :signed-integer) (wantMixin :boolean)) 
  :agfilecounttype
   () )                                         ; 
;    This selector must match with the application
;    creator in order for this file to appear in the 
;    application's Help menu. Ignored for mixin files
;    because they never appear in the Help menu anyway.
;    If empty (zeros), will appear in the Help menu
;    of any host application.
;                                               ; 
;  *  AGFileGetHelpMenuAppCreator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_AGFileGetIndDB" 
      ((vRefNum :signed-integer) (dirID :signed-long) (databaseType :signed-integer) (wantMixin :boolean) (dbIndex :signed-integer) (fileSpec (:pointer :fsspec))) 
  :signed-integer
   () )                                         ; CONST; 
;    This selector must match in the main and mixin
;    files in order for the mixin to mix-in with the main.
;    Empty (zeros) selectors are valid matches.
;    A '****' selector will mix-in with any main.
;                                               ; 
;  *  AGFileGetMixinMatchSelector()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_AGFileGetHelpMenuAppCreator" 
      ((fileSpec (:pointer :fsspec)) (helpMenuAppCreator (:pointer :ostype))) 
  :signed-integer
   () )                                         ; CONST; 
;    This is the text of the balloon for the
;    Help menu item for this database.
;                                               ; 
;  *  AGFileGetHelpMenuBalloonText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_AGFileGetMixinMatchSelector" 
      ((fileSpec (:pointer :fsspec)) (mixinMatchSelector (:pointer :ostype))) 
  :signed-integer
   () )                                         ; CONST; 
;  *  AGGetSystemDB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleGuideLib 2.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_AGFileGetHelpMenuBalloonText" 
      ((fileSpec (:pointer :fsspec)) (helpMenuBalloonString (:pointer (:string 255)))) 
  :signed-integer
   () )
(deftrap-inline "_AGGetSystemDB" 
      ((databaseType :signed-integer) (wantMixin :boolean) (pFileSpec (:pointer :fsspec))) 
  :signed-integer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := AppleGuideIncludes

; $ENDC                                         ; __APPLEGUIDE__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'AppleGuide)