(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Balloons.p"
; at Wednesday May 1,2002 2:40:53 pm.
; 
;      File:       Balloons.p
;  
;      Contains:   Balloon Help Package Interfaces.
;  
;      Version:    Technology: System 7.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1990-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __BALLOONS__
; $SETC __BALLOONS__ := 1

; $I+
; $SETC BalloonsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MENUS__
|#

(require-interface 'Menus)
#|                                              ; $I Menus.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __TEXTEDIT__
|#

(require-interface 'TextEdit)
#|                                              ; $I TextEdit.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;    Carbon clients should use MacHelp. The definitions below will NOT work for Carbon and
;    are only defined for those files that need to build pre-Carbon applications.
; 
;   constants 

(def-mactype :balloonvariant (find-mactype ':signed-integer))

(defconstant $kTopLeftTipPointsLeftVariant 0)
(defconstant $kTopLeftTipPointsUpVariant 1)
(defconstant $kTopRightTipPointsUpVariant 2)
(defconstant $kTopRightTipPointsRightVariant 3)
(defconstant $kBottomRightTipPointsRightVariant 4)
(defconstant $kBottomRightTipPointsDownVariant 5)
(defconstant $kBottomLeftTipPointsDownVariant 6)
(defconstant $kBottomLeftTipPointsLeftVariant 7)
(defconstant $kBalloonVariantCount 8)

(defconstant $hmBalloonHelpVersion #x2)         ;   The real version of the Help Manager  

(defconstant $kHMHelpMenuID -16490)             ;   Resource ID and menu ID of help menu  
(defconstant $kHMAboutHelpItem 1)               ;   help menu item number of About Balloon Help  
(defconstant $kHMShowBalloonsItem 3)            ;   help menu item number of Show/Hide Balloons  

(defconstant $kHMHelpID -5696)                  ;   ID of various Help Mgr package resources (in Pack14 range)  
(defconstant $kBalloonWDEFID 126)               ;   Resource ID of the WDEF proc used in standard balloons  

;   Dialog item template type constant  
(defconstant $helpItem 1)                       ;   key value in DITL template that corresponds to the help item  

;   Options for Help Manager resources in 'hmnu', 'hdlg', 'hrct', 'hovr', & 'hfdr' resources  
(defconstant $hmDefaultOptions 0)               ;   default options for help manager resources  
(defconstant $hmUseSubIDBit 0)
(defconstant $hmAbsoluteCoordsBit 1)
(defconstant $hmSaveBitsNoWindowBit 2)
(defconstant $hmSaveBitsWindowBit 3)
(defconstant $hmMatchInTitleBit 4)
(defconstant $hmUseSubIDMask #x1)               ;   treat resID's in resources as subID's of driver base ID (for Desk Accessories)  
(defconstant $hmAbsoluteCoordsMask #x2)         ;   ignore window port origin and treat rectangles as absolute coords (local to window)  
(defconstant $hmSaveBitsNoWindowMask #x4)       ;   don't create a window, just blast bits on screen. No update event is generated  
(defconstant $hmSaveBitsWindowMask #x8)         ;   create a window, but restore bits behind window when window goes away & generate update event  
(defconstant $hmMatchInTitleMask #x10)          ;   for hwin resources, match string anywhere in window title string  

; $IFC OLDROUTINENAMES 
(defconstant $hmUseSubID #x1)
(defconstant $hmAbsoluteCoords #x2)
(defconstant $hmSaveBitsNoWindow #x4)
(defconstant $hmSaveBitsWindow #x8)
(defconstant $hmMatchInTitle #x10)

; $ENDC                                         ; OLDROUTINENAMES

;   Constants for Help Types in 'hmnu', 'hdlg', 'hrct', 'hovr', & 'hfdr' resources  
(defconstant $kHMStringItem 1)                  ;   pstring used in resource  
(defconstant $kHMPictItem 2)                    ;   'PICT' ResID used in resource  
(defconstant $kHMStringResItem 3)               ;   'STR#' ResID & index used in resource  
(defconstant $kHMTEResItem 6)                   ;   Styled Text Edit ResID used in resource ('TEXT' & 'styl')  
(defconstant $kHMSTRResItem 7)                  ;   'STR ' ResID used in resource  
(defconstant $kHMSkipItem 256)                  ;   don't display a balloon  
(defconstant $kHMCompareItem 512)               ;   Compare pstring in menu item w/ PString in resource item ('hmnu' only)  
(defconstant $kHMNamedResourceItem 1024)        ;   Use pstring in menu item to get 'STR#', 'PICT', or 'STR ' resource ('hmnu' only)  
(defconstant $kHMTrackCntlItem 2048)            ;   Reserved  

;   Constants for hmmHelpType's when filling out HMMessageRecord  
(defconstant $khmmString 1)                     ;   help message contains a PString  
(defconstant $khmmPict 2)                       ;   help message contains a resource ID to a 'PICT' resource  
(defconstant $khmmStringRes 3)                  ;   help message contains a res ID & index to a 'STR#' resource  
(defconstant $khmmTEHandle 4)                   ;   help message contains a Text Edit handle  
(defconstant $khmmPictHandle 5)                 ;   help message contains a Picture handle  
(defconstant $khmmTERes 6)                      ;   help message contains a res ID to 'TEXT' & 'styl' resources  
(defconstant $khmmSTRRes 7)                     ;   help message contains a res ID to a 'STR ' resource  
(defconstant $kHMEnabledItem 0)                 ;   item is enabled, but not checked or control value = 0  

;   ResTypes for Styled TE Handles in Resources  
(defconstant $kHMTETextResType :|TEXT|)         ;   Resource Type of text data for styled TE record w/o style info  
(defconstant $kHMTEStyleResType :|styl|)        ;   Resource Type of style information for styled TE record  

(defconstant $kHMDisabledItem 1)                ;   item is disabled, grayed in menus or disabled in dialogs  
(defconstant $kHMCheckedItem 2)                 ;   item is enabled, and checked or control value = 1  
(defconstant $kHMOtherItem 3)                   ;   item is enabled, and control value > 1  
;   Method parameters to pass to HMShowBalloon  
(defconstant $kHMRegularWindow 0)               ;   Create a regular window floating above all windows  
(defconstant $kHMSaveBitsNoWindow 1)            ;   Just save the bits and draw (for MDEF calls)  
(defconstant $kHMSaveBitsWindow 2)              ;   Regular window, save bits behind, AND generate update event  

;   Resource Types for whichType parameter used when extracting 'hmnu' & 'hdlg' messages  
(defconstant $kHMMenuResType :|hmnu|)           ;   ResType of help resource for supporting menus  
(defconstant $kHMDialogResType :|hdlg|)         ;   ResType of help resource for supporting dialogs  
(defconstant $kHMWindListResType :|hwin|)       ;   ResType of help resource for supporting windows  
(defconstant $kHMRectListResType :|hrct|)       ;   ResType of help resource for rectangles in windows  
(defconstant $kHMOverrideResType :|hovr|)       ;   ResType of help resource for overriding system balloons  
(defconstant $kHMFinderApplResType :|hfdr|)     ;   ResType of help resource for custom balloon in Finder  

(def-mactype :hmstringrestypeptr (find-mactype '(:pointer :hmstringrestype)))
(defrecord HMStringResType 
   (hmmResID :signed-integer)
   (hmmIndex :signed-integer)
   )

(def-mactype :hmmessagerecordptr (find-mactype '(:pointer :hmmessagerecord)))
(defrecord HMMessageRecord 
   (hmmHelpType :signed-integer)
   (:variant 
      (
      (hmmString (:string 255))
      )
      (
      (hmmPict :signed-integer)
      )
      (
      (hmmTEHandle (:handle :terec))
      )
      (
      (hmmStringRes :hmstringrestype)
      )
      (
      (hmmPictRes :signed-integer)
      )
      (
      (hmmPictHandle (:handle :picture))
      )
      (
      (hmmTERes :signed-integer)
      )
      (
      (hmmSTRRes :signed-integer)
      )
      )
   )

(def-mactype :hmmessagerecptr (find-mactype '(:pointer :hmmessagerecord)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TipFunctionProcPtr = FUNCTION(tip: Point; structure: RgnHandle; VAR r: Rect; VAR balloonVariant: BalloonVariant): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :tipfunctionprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :tipfunctionupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :tipfunctionupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppTipFunctionProcInfo #x3FE0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewTipFunctionUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewTipFunctionProc 
(deftrap "_NewTipFunctionUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeTipFunctionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeTipFunctionUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeTipFunctionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallTipFunctionProc 
(deftrap-inline "_InvokeTipFunctionUPP" 
      ((tip :point) (structure (:handle :macregion)) (r (:pointer :rect)) (BalloonVariant (:pointer :signed-integer)) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

;   Public Interfaces  
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  HMGetHelpMenuHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_HMGetHelpMenuHandle" 
      ((mh (:pointer (:handle :menuinfo))))
   (:stack :signed-integer)
   (:stack-trap #xA830 :d0 512 mh))

; 
;  *  HMShowBalloon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_HMShowBalloon" 
      ((inHelpMessage (:pointer :hmmessagerecord)) (inTip :point) (inHotRect (:pointer :rect)) (inTipProc :pointer) (inWindowProcID :signed-integer) (inBalloonVariant :signed-integer) (inMethod :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA830 :d0 2817 inHelpMessage inTip inHotRect inTipProc inWindowProcID inBalloonVariant inMethod))

; 
;  *  HMShowMenuBalloon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_HMShowMenuBalloon" 
      ((itemNum :signed-integer) (itemMenuID :signed-integer) (itemFlags :signed-long) (itemReserved :signed-long) (tip :point) (alternateRect (:pointer :rect)) (tipProc :pointer) (theProc :signed-integer) (BalloonVariant :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA830 :d0 3589 itemNum itemMenuID itemFlags itemReserved tip alternateRect tipProc theProc BalloonVariant))

; 
;  *  HMRemoveBalloon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_HMRemoveBalloon" 
      ()
   (:stack :signed-integer)
   (:stack-trap #xA830 :d0 2))

; 
;  *  HMGetIndHelpMsg()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_HMGetIndHelpMsg" 
      ((inWhichResType :ostype) (inWhichResID :signed-integer) (inMessageIndex :signed-integer) (inMessageState :signed-integer) (outOptions (:pointer :unsigned-long)) (outTip (:pointer :point)) (outHotRect (:pointer :rect)) (outWindowProcID (:pointer :signed-integer)) (outBalloonVariant (:pointer :signed-integer)) (outHelpMessage (:pointer :hmmessagerecord)) (outMessageCount (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xA830 :d0 4870 inWhichResType inWhichResID inMessageIndex inMessageState outOptions outTip outHotRect outWindowProcID outBalloonVariant outHelpMessage outMessageCount))

; 
;  *  HMIsBalloon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_HMIsBalloon" 
      ()
   (:stack :boolean)
   (:stack-trap #xA830 :d0 7))

; 
;  *  HMGetBalloons()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_HMGetBalloons" 
      ()
   (:stack :boolean)
   (:stack-trap #xA830 :d0 3))

; 
;  *  HMSetBalloons()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_HMSetBalloons" 
      ((flag :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA830 :d0 260 flag))

; 
;  *  HMSetFont()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_HMSetFont" 
      ((font :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA830 :d0 264 font))

; 
;  *  HMSetFontSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_HMSetFontSize" 
      ((fontSize :unsigned-integer))
   (:stack :signed-integer)
   (:stack-trap #xA830 :d0 265 fontSize))

; 
;  *  HMGetFont()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_HMGetFont" 
      ((font (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xA830 :d0 522 font))

; 
;  *  HMGetFontSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_HMGetFontSize" 
      ((fontSize (:pointer :unsigned-integer)))
   (:stack :signed-integer)
   (:stack-trap #xA830 :d0 523 fontSize))

; 
;  *  HMSetDialogResID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_HMSetDialogResID" 
      ((resID :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA830 :d0 268 resID))

; 
;  *  HMSetMenuResID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_HMSetMenuResID" 
      ((menuID :signed-integer) (resID :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA830 :d0 525 menuID resID))

; 
;  *  HMBalloonRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_HMBalloonRect" 
      ((inMessage (:pointer :hmmessagerecord)) (outRect (:pointer :rect)))
   (:stack :signed-integer)
   (:stack-trap #xA830 :d0 1038 inMessage outRect))

; 
;  *  HMBalloonPict()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_HMBalloonPict" 
      ((inMessage (:pointer :hmmessagerecord)) (outPict (:pointer (:handle :picture))))
   (:stack :signed-integer)
   (:stack-trap #xA830 :d0 1039 inMessage outPict))

; 
;  *  HMScanTemplateItems()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_HMScanTemplateItems" 
      ((whichID :signed-integer) (whichResFile :signed-integer) (whichType :ostype))
   (:stack :signed-integer)
   (:stack-trap #xA830 :d0 1040 whichID whichResFile whichType))

; 
;  *  HMExtractHelpMsg()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_HMExtractHelpMsg" 
      ((inType :ostype) (inResID :signed-integer) (inMessageIndex :signed-integer) (inMessageState :signed-integer) (outMessage (:pointer :hmmessagerecord)))
   (:stack :signed-integer)
   (:stack-trap #xA830 :d0 1809 inType inResID inMessageIndex inMessageState outMessage))

; 
;  *  HMGetDialogResID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_HMGetDialogResID" 
      ((resID (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xA830 :d0 531 resID))

; 
;  *  HMGetMenuResID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_HMGetMenuResID" 
      ((menuID :signed-integer) (resID (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xA830 :d0 788 menuID resID))

; 
;  *  HMGetBalloonWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_HMGetBalloonWindow" 
      ((window (:pointer (:pointer :windowrecord))))
   (:stack :signed-integer)
   (:stack-trap #xA830 :d0 533 window))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := BalloonsIncludes

; $ENDC                                         ; __BALLOONS__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'Balloons)