(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CFBase.p"
; at Wednesday May 1,2002 2:38:48 pm.
; 
;      File:       CFBase.p
;  
;      Contains:   CoreFoundation base types
;  
;      Version:    Technology: Mac OS X
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1999-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __CFBASE__
; $SETC __CFBASE__ := 1

; $I+
; $SETC CFBaseIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :cftypeid (find-mactype ':unsigned-long))
(def-mactype :cfoptionflags (find-mactype ':unsigned-long))
(def-mactype :cfhashcode (find-mactype ':unsigned-long))
(def-mactype :cfindex (find-mactype ':signed-long))
(def-mactype :cfstringref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :cfstringrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:CFStringRef parameter can be nil, it is changed to xx: CFStringRefPtr 
(def-mactype :cfmutablestringref (find-mactype ':pointer))
(def-mactype :cfmutablestringrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:CFMutableStringRef parameter can be nil, it is changed to xx: CFMutableStringRefPtr 
; 	 Values returned from comparison functions 	
(def-mactype :cfcomparisonresult (find-mactype ':signed-long))

(defconstant $kCFCompareLessThan -1)
(defconstant $kCFCompareEqualTo 0)
(defconstant $kCFCompareGreaterThan 1)

; 	 A standard comparison function 	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFComparatorFunction = FUNCTION(val1: UNIV Ptr; val2: UNIV Ptr; context: UNIV Ptr): CFComparisonResult; C;

|#
 |#                                             ; $ELSEC
(def-mactype :cfcomparatorfunction (find-mactype ':pointer))
; $ENDC

; 	 Constant used by some functions to indicate failed searches. 	
; 	 This is of type CFIndex. 	
(def-mactype :cfnotfound (find-mactype ':signed-long))

(defconstant $kCFNotFound -1)

; 	 Range type 	

(def-mactype :cfrangeptr (find-mactype '(:pointer :cfrange)))
(defrecord CFRange 
   (location :signed-long)
   (length :signed-long)
   )

; 	 Allocator API
; 	
; 	   Most of the time when specifying an allocator to Create functions, the NULL
; 	   argument indicates "use the default"; this is the same as using kCFAllocatorDefault
; 	   or the return value from CFAllocatorGetDefault().  This assures that you will use
; 	   the allocator in effect at that time.
; 	
; 	   You should rarely use kCFAllocatorSystemDefault, the default default allocator.
; 		
(def-mactype :cfallocatorref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :cfallocatorrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:CFAllocatorRef parameter can be nil, it is changed to xx: CFAllocatorRefPtr 
; 	 This is a synonym for NULL, if you'd rather use a named constant. 	
; 
; 	 *  kCFAllocatorDefault
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 	 Default system allocator; you rarely need to use this. 	
; 
; 	 *  kCFAllocatorSystemDefault
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 	 This allocator uses malloc(), realloc(), and free(). This should not be
; 	   generally used; stick to kCFAllocatorDefault whenever possible. This
; 	   allocator is useful as the "bytesDeallocator" in CFData or
; 	   "contentsDeallocator" in CFString where the memory was obtained as a
; 	   result of malloc() type functions.
; 		
; 
; 	 *  kCFAllocatorMalloc
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 	 Null allocator which does nothing and allocates no memory. This allocator
; 	   is useful as the "bytesDeallocator" in CFData or "contentsDeallocator"
; 	   in CFString where the memory should not be freed.
; 		
; 
; 	 *  kCFAllocatorNull
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 	 Special allocator argument to CFAllocatorCreate() which means
; 	   "use the functions given in the context to allocate the allocator
; 	   itself as well".
; 		
; 
; 	 *  kCFAllocatorUseContext
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFAllocatorRetainCallBack = FUNCTION(info: UNIV Ptr): Ptr; C;

|#
 |#                                             ; $ELSEC
(def-mactype :cfallocatorretaincallback (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFAllocatorReleaseCallBack = PROCEDURE(info: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :cfallocatorreleasecallback (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFAllocatorCopyDescriptionCallBack = FUNCTION(info: UNIV Ptr): CFStringRef; C;

|#
 |#                                             ; $ELSEC
(def-mactype :cfallocatorcopydescriptioncallback (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFAllocatorAllocateCallBack = FUNCTION(allocSize: CFIndex; hint: CFOptionFlags; info: UNIV Ptr): Ptr; C;

|#
 |#                                             ; $ELSEC
(def-mactype :cfallocatorallocatecallback (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFAllocatorReallocateCallBack = FUNCTION(ptr: UNIV Ptr; newsize: CFIndex; hint: CFOptionFlags; info: UNIV Ptr): Ptr; C;

|#
 |#                                             ; $ELSEC
(def-mactype :cfallocatorreallocatecallback (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFAllocatorDeallocateCallBack = PROCEDURE(ptr: UNIV Ptr; info: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :cfallocatordeallocatecallback (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFAllocatorPreferredSizeCallBack = FUNCTION(size: CFIndex; hint: CFOptionFlags; info: UNIV Ptr): CFIndex; C;

|#
 |#                                             ; $ELSEC
(def-mactype :cfallocatorpreferredsizecallback (find-mactype ':pointer))
; $ENDC

(def-mactype :cfallocatorcontextptr (find-mactype '(:pointer :cfallocatorcontext)))
(defrecord CFAllocatorContext 
   (version :signed-long)
   (info :pointer)
   (retain :pointer)
   (release :pointer)
   (copyDescription :pointer)
   (allocate :pointer)
   (reallocate :pointer)
   (deallocate :pointer)
   (preferredSize :pointer)
   )

; 
; 	 *  CFAllocatorGetTypeID()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_CFAllocatorGetTypeID" 
      () 
  :unsigned-long
   () )

; 
;     CFAllocatorSetDefault() sets the allocator that is used in the current
;     thread whenever NULL is specified as an allocator argument. This means
;     that most, if not all allocations will go through this allocator. It
;     also means that any allocator set as the default needs to be ready to
;     deal with arbitrary memory allocation requests; in addition, the size
;     and number of requests will change between releases.
; 
;     An allocator set as the default will never be released, even if later
;     another allocator replaces it as the default. Not only is it impractical
;     for it to be released (as there might be caches created under the covers
;     that refer to the allocator), in general it's also safer and more
;     efficient to keep it around.
; 
;     If you wish to use a custom allocator in a context, it's best to provide
;     it as the argument to the various creation functions rather than setting
;     it as the default. Setting the default allocator is not encouraged.
; 
;     If you do set an allocator as the default, either do it for all time in
;     your app, or do it in a nested fashion (by restoring the previous allocator
;     when you exit your context). The latter might be appropriate for plug-ins
;     or libraries that wish to set the default allocator.
; 
; 
;  *  CFAllocatorSetDefault()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFAllocatorSetDefault" 
      ((allocator :pointer)) 
  nil
   () )

; 
;  *  CFAllocatorGetDefault()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFAllocatorGetDefault" 
      () 
  :pointer
   () )

; 
;  *  CFAllocatorCreate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFAllocatorCreate" 
      ((allocator :pointer) (context (:pointer :cfallocatorcontext))) 
  :pointer
   () )

; 
;  *  CFAllocatorAllocate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFAllocatorAllocate" 
      ((allocator :pointer) (size :signed-long) (hint :unsigned-long)) 
  :pointer
   () )

; 
;  *  CFAllocatorReallocate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFAllocatorReallocate" 
      ((allocator :pointer) (Ptr :pointer) (newsize :signed-long) (hint :unsigned-long)) 
  :pointer
   () )

; 
;  *  CFAllocatorDeallocate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFAllocatorDeallocate" 
      ((allocator :pointer) (Ptr :pointer)) 
  nil
   () )

; 
;  *  CFAllocatorGetPreferredSizeForSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFAllocatorGetPreferredSizeForSize" 
      ((allocator :pointer) (size :signed-long) (hint :unsigned-long)) 
  :cfindex
   () )

; 
;  *  CFAllocatorGetContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFAllocatorGetContext" 
      ((allocator :pointer) (context (:pointer :cfallocatorcontext))) 
  nil
   () )

;  Base "type" of all "CF objects", and polymorphic functions on them 

(def-mactype :cftyperef (find-mactype ':pointer))
; 
; 	 *  CFGetTypeID()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_CFGetTypeID" 
      ((cf :pointer)) 
  :unsigned-long
   () )

; 
;  *  CFCopyTypeIDDescription()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFCopyTypeIDDescription" 
      ((type_id :unsigned-long)) 
  :pointer
   () )

; 
;  *  CFRetain()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFRetain" 
      ((cf :pointer)) 
  :pointer
   () )

; 
;  *  CFRelease()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFRelease" 
      ((cf :pointer)) 
  nil
   () )

; 
;  *  CFGetRetainCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFGetRetainCount" 
      ((cf :pointer)) 
  :cfindex
   () )

; 
;  *  CFEqual()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFEqual" 
      ((cf1 :pointer) (cf2 :pointer)) 
  :boolean
   () )

; 
;  *  CFHash()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFHash" 
      ((cf :pointer)) 
  :unsigned-long
   () )

; 
;  *  CFCopyDescription()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFCopyDescription" 
      ((cf :pointer)) 
  :pointer
   () )

; 
;  *  CFGetAllocator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFGetAllocator" 
      ((cf :pointer)) 
  :pointer
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CFBaseIncludes

; $ENDC                                         ; __CFBASE__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'CFBase)