(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CFTree.p"
; at Wednesday May 1,2002 2:40:25 pm.
; 
;      File:       CFTree.p
;  
;      Contains:   CoreFoundation tree collection
;  
;      Version:    Technology: Mac OS X
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1999-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __CFTREE__
; $SETC __CFTREE__ := 1

; $I+
; $SETC CFTreeIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CFBASE__
|#

(require-interface 'CFBase)
#|                                              ; $I CFBase.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFTreeRetainCallBack = FUNCTION(info: UNIV Ptr): Ptr; C;

|#
 |#                                             ; $ELSEC
(def-mactype :cftreeretaincallback (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFTreeReleaseCallBack = PROCEDURE(info: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :cftreereleasecallback (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFTreeCopyDescriptionCallBack = FUNCTION(info: UNIV Ptr): CFStringRef; C;

|#
 |#                                             ; $ELSEC
(def-mactype :cftreecopydescriptioncallback (find-mactype ':pointer))
; $ENDC

(def-mactype :cftreecontextptr (find-mactype '(:pointer :cftreecontext)))
(defrecord CFTreeContext 
   (version :signed-long)
   (info :pointer)
   (retain :pointer)
   (release :pointer)
   (copyDescription :pointer)
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFTreeApplierFunction = PROCEDURE(value: UNIV Ptr; context: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :cftreeapplierfunction (find-mactype ':pointer))
; $ENDC

(def-mactype :cftreeref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :cftreerefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:CFTreeRef parameter can be nil, it is changed to xx: CFTreeRefPtr 
; 
; 	 *  CFTreeGetTypeID()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_CFTreeGetTypeID" 
      () 
  :unsigned-long
   () )

; 
;  *  CFTreeCreate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_CFTreeCreate" 
      ((allocator :pointer) (context (:pointer :cftreecontext))) 
  :pointer
   () )

; 
;  *  CFTreeGetParent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFTreeGetParent" 
      ((tree :pointer)) 
  :pointer
   () )

; 
;  *  CFTreeGetNextSibling()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFTreeGetNextSibling" 
      ((tree :pointer)) 
  :pointer
   () )

; 
;  *  CFTreeGetFirstChild()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFTreeGetFirstChild" 
      ((tree :pointer)) 
  :pointer
   () )

; 
;  *  CFTreeGetContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFTreeGetContext" 
      ((tree :pointer) (context (:pointer :cftreecontext))) 
  nil
   () )

; 
;  *  CFTreeGetChildCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFTreeGetChildCount" 
      ((tree :pointer)) 
  :cfindex
   () )

; 
;  *  CFTreeGetChildAtIndex()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFTreeGetChildAtIndex" 
      ((tree :pointer) (idx :signed-long)) 
  :pointer
   () )

; 
;  *  CFTreeGetChildren()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFTreeGetChildren" 
      ((tree :pointer) (children (:pointer :pointer))) 
  nil
   () )

; 
;  *  CFTreeApplyFunctionToChildren()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFTreeApplyFunctionToChildren" 
      ((tree :pointer) (applier :pointer) (context :pointer)) 
  nil
   () )

; 
;  *  CFTreeFindRoot()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFTreeFindRoot" 
      ((tree :pointer)) 
  :pointer
   () )

; 
;  *  CFTreeSetContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_CFTreeSetContext" 
      ((tree :pointer) (context (:pointer :cftreecontext))) 
  nil
   () )

;  adds newChild as tree's first child 
; 
;  *  CFTreePrependChild()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFTreePrependChild" 
      ((tree :pointer) (newChild :pointer)) 
  nil
   () )

;  adds newChild as tree's last child 
; 
;  *  CFTreeAppendChild()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFTreeAppendChild" 
      ((tree :pointer) (newChild :pointer)) 
  nil
   () )

;  Inserts newSibling after tree.  tree and newSibling will have the same parent 
; 
;  *  CFTreeInsertSibling()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFTreeInsertSibling" 
      ((tree :pointer) (newSibling :pointer)) 
  nil
   () )

;  Removes tree from its parent 
; 
;  *  CFTreeRemove()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFTreeRemove" 
      ((tree :pointer)) 
  nil
   () )

;  Removes all the children of tree 
; 
;  *  CFTreeRemoveAllChildren()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFTreeRemoveAllChildren" 
      ((tree :pointer)) 
  nil
   () )

; 
;  *  CFTreeSortChildren()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFTreeSortChildren" 
      ((tree :pointer) (comparator :pointer) (context :pointer)) 
  nil
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CFTreeIncludes

; $ENDC                                         ; __CFTREE__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'CFTree)