(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CFXMLParser.p"
; at Wednesday May 1,2002 2:40:26 pm.
; 
;      File:       CFXMLParser.p
;  
;      Contains:   CoreFoundation XML parser
;  
;      Version:    Technology: Mac OS X
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1999-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __CFXMLPARSER__
; $SETC __CFXMLPARSER__ := 1

; $I+
; $SETC CFXMLParserIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CFBASE__
|#

(require-interface 'CFBase)
#|                                              ; $I CFBase.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFARRAY__
|#

(require-interface 'CFArray)
#|                                              ; $I CFArray.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFDATA__
|#

(require-interface 'CFData)
#|                                              ; $I CFData.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFDICTIONARY__
|#

(require-interface 'CFDictionary)
#|                                              ; $I CFDictionary.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFTREE__
|#

(require-interface 'CFTree)
#|                                              ; $I CFTree.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFURL__
|#

(require-interface 'CFURL)
#|                                              ; $I CFURL.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFXMLNODE__
|#

(require-interface 'CFXMLNode)
#|                                              ; $I CFXMLNode.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :cfxmlparserref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :cfxmlparserrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:CFXMLParserRef parameter can be nil, it is changed to xx: CFXMLParserRefPtr 
; 	 These are the various options you can configure the parser with.  These are
; 	   chosen such that an option flag of 0 (kCFXMLParserNoOptions) leaves the XML
; 	   as "intact" as possible (reports all structures; performs no replacements).
; 	   Hence, to make the parser do the most work, returning only the pure element
; 	   tree, set the option flag to kCFXMLParserAllOptions.
; 	
; 	kCFXMLParserValidateDocument -
; 	   validate the document against its grammar from the DTD, reporting any errors.
; 	   Currently not supported.
; 	
; 	kCFXMLParserSkipMetaData -
; 	   silently skip over metadata constructs (the DTD and comments)
; 	
; 	kCFXMLParserReplacePhysicalEntities -
; 	   replace declared entities like &lt;.  Note that other than the 5 predefined
; 	   entities (lt, gt, quot, amp, apos), these must be defined in the DTD.
; 	   Currently not supported.
; 	
; 	kCFXMLParserSkipWhitespace -
; 	   skip over all whitespace that does not abut non-whitespace character data.
; 	   In other words, given <foo>  <bar> blah </bar></foo>, the whitespace between
; 	   foo's open tag and bar's open tag would be suppressed, but the whitespace
; 	   around blah would be preserved.
; 	
; 	kCFXMLParserAddImpliedAttributes -
; 	   where the DTD specifies implied attribute-value pairs for a particular element,
; 	   add those pairs to any occurances of the element in the element tree.
; 	   Currently not supported.
; 		
(def-mactype :cfxmlparseroptions (find-mactype ':signed-long))

(defconstant $kCFXMLParserValidateDocument #x1)
(defconstant $kCFXMLParserSkipMetaData #x2)
(defconstant $kCFXMLParserReplacePhysicalEntities #x4)
(defconstant $kCFXMLParserSkipWhitespace #x8)
(defconstant $kCFXMLParserResolveExternalEntities #x10)
(defconstant $kCFXMLParserAddImpliedAttributes #x20)
(defconstant $kCFXMLParserAllOptions #xFFFFFF)
(defconstant $kCFXMLParserNoOptions 0)

; 	 This list is expected to grow 	

(def-mactype :cfxmlparserstatuscode (find-mactype ':signed-long))

(defconstant $kCFXMLStatusParseNotBegun -2)
(defconstant $kCFXMLStatusParseInProgress -1)
(defconstant $kCFXMLStatusParseSuccessful 0)
(defconstant $kCFXMLErrorUnexpectedEOF 1)
(defconstant $kCFXMLErrorUnknownEncoding 2)
(defconstant $kCFXMLErrorEncodingConversionFailure 3)
(defconstant $kCFXMLErrorMalformedProcessingInstruction 4)
(defconstant $kCFXMLErrorMalformedDTD 5)
(defconstant $kCFXMLErrorMalformedName 6)
(defconstant $kCFXMLErrorMalformedCDSect 7)
(defconstant $kCFXMLErrorMalformedCloseTag 8)
(defconstant $kCFXMLErrorMalformedStartTag 9)
(defconstant $kCFXMLErrorMalformedDocument 10)
(defconstant $kCFXMLErrorElementlessDocument 11)
(defconstant $kCFXMLErrorMalformedComment 12)
(defconstant $kCFXMLErrorMalformedCharacterReference 13)
(defconstant $kCFXMLErrorMalformedParsedCharacterData 14)
(defconstant $kCFXMLErrorNoData 15)

; 	  These functions are called as a parse progresses.
; 	
; 	createXMLStructure -
; 	  called as new XML structures are encountered by the parser.  May return NULL to indicate
; 	  that the given structure should be skipped; if NULL is returned for a given structure,
; 	  only minimal parsing is done for that structure (enough to correctly determine its end,
; 	  and to extract any data necessary for the remainder of the parse, such as Entity definitions).
; 	  createXMLStructure (or indeed, any of the tree-creation callbacks) will not be called for any
; 	  children of the skipped structure.  The only exception is that the top-most element will always
; 	  be reported even if NULL was returned for the document as a whole.  NOTE: for performance reasons,
; 	  the node passed to createXMLStructure cannot be safely retained by the client; the node as
; 	  a whole must be copied (via CFXMLNodeCreateCopy), or its contents must be extracted and copied.
; 	
; 	addChild -
; 	  called as children are parsed and are ready to be added to the tree.  If createXMLStructure
; 	  returns NULL for a given structure, that structure is omitted entirely, and addChild will
; 	  NOT be called for either a NULL child or parent.
; 	
; 	endXMLStructure -
; 	  called once a structure (and all its children) are completely parsed.  As elements are encountered,
; 	  createXMLStructure is called for them first, then addChild to add the new structure to its parent,
; 	  then addChild (potentially several times) to add the new structure's children to it, then finally
; 	  endXMLStructure to show that the structure has been fully parsed.
; 	
; 	createXMLStructure, addChild, and endXMLStructure are all REQUIRED TO BE NON-NULL.
; 	
; 	resolveExternalEntity -
; 	  called when external entities are referenced (NOT when they are simply defined).  If the function
; 	  pointer is NULL, the parser uses its internal routines to try and resolve the entity.  If the
; 	  function pointer is set, and the function returns NULL, a place holder for the external entity
; 	  is inserted into the tree.  In this manner, the parser's client can prevent any external network
; 	  or file accesses.
; 	
; 	handleError - called as errors/warnings are encountered in the data stream.  At some point, we will
; 	  have an enum of the expected errors, some of which will be fatal, others of which will not.  If
; 	  the function pointer is NULL, the parser will silently attempt to recover.  The
; 	  handleError function may always return FALSE to force the parser to stop; if handleError returns
; 	  TRUE, the parser will attempt to recover (fatal errors will still cause the parse to abort
; 	  immediately).
; 		

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFXMLParserCreateXMLStructureCallBack = FUNCTION(parser: CFXMLParserRef; nodeDesc: CFXMLNodeRef; info: UNIV Ptr): Ptr; C;

|#
 |#                                             ; $ELSEC
(def-mactype :cfxmlparsercreatexmlstructurecallback (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFXMLParserAddChildCallBack = PROCEDURE(parser: CFXMLParserRef; parent: UNIV Ptr; child: UNIV Ptr; info: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :cfxmlparseraddchildcallback (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFXMLParserEndXMLStructureCallBack = PROCEDURE(parser: CFXMLParserRef; xmlType: UNIV Ptr; info: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :cfxmlparserendxmlstructurecallback (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFXMLParserResolveExternalEntityCallBack = FUNCTION(parser: CFXMLParserRef; VAR extID: CFXMLExternalID; info: UNIV Ptr): CFDataRef; C;

|#
 |#                                             ; $ELSEC
(def-mactype :cfxmlparserresolveexternalentitycallback (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFXMLParserHandleErrorCallBack = FUNCTION(parser: CFXMLParserRef; error: CFXMLParserStatusCode; info: UNIV Ptr): BOOLEAN; C;

|#
 |#                                             ; $ELSEC
(def-mactype :cfxmlparserhandleerrorcallback (find-mactype ':pointer))
; $ENDC

(def-mactype :cfxmlparsercallbacksptr (find-mactype '(:pointer :cfxmlparsercallbacks)))
(defrecord CFXMLParserCallBacks 
   (version :signed-long)
   (createXMLStructure :pointer)
   (addChild :pointer)
   (endXMLStructure :pointer)
   (resolveExternalEntity :pointer)
   (handleError :pointer)
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFXMLParserRetainCallBack = FUNCTION(info: UNIV Ptr): Ptr; C;

|#
 |#                                             ; $ELSEC
(def-mactype :cfxmlparserretaincallback (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFXMLParserReleaseCallBack = PROCEDURE(info: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :cfxmlparserreleasecallback (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CFXMLParserCopyDescriptionCallBack = FUNCTION(info: UNIV Ptr): CFStringRef; C;

|#
 |#                                             ; $ELSEC
(def-mactype :cfxmlparsercopydescriptioncallback (find-mactype ':pointer))
; $ENDC

(def-mactype :cfxmlparsercontextptr (find-mactype '(:pointer :cfxmlparsercontext)))
(defrecord CFXMLParserContext 
   (version :signed-long)
   (info :pointer)
   (retain :pointer)
   (release :pointer)
   (copyDescription :pointer)
   )

; 
; 	 *  CFXMLParserGetTypeID()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.3 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_CFXMLParserGetTypeID" 
      () 
  :unsigned-long
   () )

;  Creates a parser which will parse the given data with the given options.  xmlData may not be NULL.
;    dataSource should be the URL from which the data came, and may be NULL; it is used to resolve any
;    relative references found in xmlData. versionOfNodes determines which version CFXMLNodes are produced
;    by the parser; see CFXMLNode.h for more details.  callBacks are the callbacks called by the parser as
;    the parse progresses; callBacks, callBacks->createXMLStructure, callBacks->addChild, and
;    callBacks->endXMLStructure must all be non-NULL.  context determines what if any info pointer is
;    passed to the callbacks as the parse progresses; context may be NULL.  
; 
;  *  CFXMLParserCreate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFXMLParserCreate" 
      ((allocator :pointer) (xmlData :pointer) (dataSource :pointer) (parseOptions :unsigned-long) (versionOfNodes :signed-long) (callBacks (:pointer :cfxmlparsercallbacks)) (context (:pointer :cfxmlparsercontext))) 
  :pointer
   () )

;  Arguments as above, except that the data to be parsed is loaded directly
;    from dataSource.  dataSource may not be NULL.  
; 
;  *  CFXMLParserCreateWithDataFromURL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFXMLParserCreateWithDataFromURL" 
      ((allocator :pointer) (dataSource :pointer) (parseOptions :unsigned-long) (versionOfNodes :signed-long) (callBacks (:pointer :cfxmlparsercallbacks)) (context (:pointer :cfxmlparsercontext))) 
  :pointer
   () )

; 
;  *  CFXMLParserGetContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFXMLParserGetContext" 
      ((parser :pointer) (context (:pointer :cfxmlparsercontext))) 
  nil
   () )

; 
;  *  CFXMLParserGetCallBacks()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFXMLParserGetCallBacks" 
      ((parser :pointer) (callBacks (:pointer :cfxmlparsercallbacks))) 
  nil
   () )

; 
;  *  CFXMLParserGetSourceURL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFXMLParserGetSourceURL" 
      ((parser :pointer)) 
  :pointer
   () )

;  Returns the character index of the current parse location 
; 
;  *  CFXMLParserGetLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFXMLParserGetLocation" 
      ((parser :pointer)) 
  :cfindex
   () )

;  Returns the line number of the current parse location 
; 
;  *  CFXMLParserGetLineNumber()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFXMLParserGetLineNumber" 
      ((parser :pointer)) 
  :cfindex
   () )

;  Returns the top-most object returned by the createXMLStructure callback 
; 
;  *  CFXMLParserGetDocument()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFXMLParserGetDocument" 
      ((parser :pointer)) 
  :pointer
   () )

;  Get the status code or a user-readable description of the last error that occurred in a parse.
;    If no error has occurred, a null description string is returned.  See the enum above for
;    possible status returns 
; 
;  *  CFXMLParserGetStatusCode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFXMLParserGetStatusCode" 
      ((parser :pointer)) 
  :cfxmlparserstatuscode
   () )

; 
;  *  CFXMLParserCopyErrorDescription()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFXMLParserCopyErrorDescription" 
      ((parser :pointer)) 
  :pointer
   () )

;  Cause any in-progress parse to abort with the given error code and description.  errorCode
;    must be positive, and errorDescription may not be NULL.  Cannot be called asynchronously
;    (i.e. must be called from within a parser callback) 
; 
;  *  CFXMLParserAbort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFXMLParserAbort" 
      ((parser :pointer) (errorCode :signed-long) (errorDescription :pointer)) 
  nil
   () )

;  Starts a parse of the data the parser was created with; returns success or failure.
;    Upon success, use CFXMLParserGetDocument() to get the product of the parse.  Upon
;    failure, use CFXMLParserGetErrorCode() or CFXMLParserCopyErrorDescription() to get
;    information about the error.  It is an error to call CFXMLParserParse() while a
;    parse is already underway. 
; 
;  *  CFXMLParserParse()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFXMLParserParse" 
      ((parser :pointer)) 
  :boolean
   () )

;  These functions provide a higher-level interface.  The XML data is parsed to a
;    special CFTree (an CFXMLTree) with known contexts and callbacks.  See CFXMLNode.h
;    for full details on using an CFXMLTree and the CFXMLNodes contained therein.
; 
;  Parse to an CFXMLTreeRef.  parseOptions are as above. versionOfNodes determines
;    what version CFXMLNodes are used to populate the tree.  
; 
;  *  CFXMLTreeCreateFromData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFXMLTreeCreateFromData" 
      ((allocator :pointer) (xmlData :pointer) (dataSource :pointer) (parseOptions :unsigned-long) (versionOfNodes :signed-long)) 
  :pointer
   () )

;  Loads the data to be parsed directly from dataSource.  Arguments as above. 
; 
;  *  CFXMLTreeCreateWithDataFromURL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFXMLTreeCreateWithDataFromURL" 
      ((allocator :pointer) (dataSource :pointer) (parseOptions :unsigned-long) (versionOfNodes :signed-long)) 
  :pointer
   () )

;  Generate the XMLData (ready to be written to whatever permanent storage is to be
;    used) from an CFXMLTree.  Will NOT regenerate entity references (except those
;    required for syntactic correctness) if they were replaced at the parse time;
;    clients that wish this should walk the tree and re-insert any entity references
;    that should appear in the final output file. 
; 
;  *  CFXMLTreeCreateXMLData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CFXMLTreeCreateXMLData" 
      ((allocator :pointer) (xmlTree :pointer)) 
  :pointer
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CFXMLParserIncludes

; $ENDC                                         ; __CFXMLPARSER__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'CFXMLParser)