(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CGDataConsumer.p"
; at Wednesday May 1,2002 2:40:42 pm.
; 
;      File:       CGDataConsumer.p
;  
;      Contains:   xxx put contents here xxx
;  
;      Version:    Technology: from CoreGraphics-70.root
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   2000-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __CGDATACONSUMER__
; $SETC __CGDATACONSUMER__ := 1

; $I+
; $SETC CGDataConsumerIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CGBASE__
|#

(require-interface 'CGBase)
#|                                              ; $I CGBase.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFURL__
|#

(require-interface 'CFURL)
#|                                              ; $I CFURL.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :cgdataconsumerref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :cgdataconsumerrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:CGDataConsumerRef parameter can be nil, it is changed to xx: CGDataConsumerRefPtr 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CGPutBytesProcPtr = FUNCTION(info: UNIV Ptr; buffer: UNIV Ptr; count: size_t): size_t; C;

|#
 |#                                             ; $ELSEC
(def-mactype :cgputbytesprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CGReleaseConsumerProcPtr = PROCEDURE(info: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :cgreleaseconsumerprocptr (find-mactype ':pointer))
; $ENDC

; 	 Callbacks for accessing data.
; 	 * `putBytes' copies `count' bytes from `buffer' to the consumer, and
; 	 * returns the number of bytes copied.  It should return 0 if no more data
; 	 * can be written to the consumer.
; 	 * `releaseConsumer', if non-NULL, is called when the consumer is freed. 	
(def-mactype :cgdataconsumercallbacksptr (find-mactype '(:pointer :cgdataconsumercallbacks)))
(defrecord CGDataConsumerCallbacks 
   (putBytes :pointer)
   (releaseConsumer :pointer)
   )

; 	 Create a data consumer using `callbacks' to handle the data.  `info' is
; 	 * passed to each of the callback functions. 	
; 
; 	 *  CGDataConsumerCreate()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; CONST
(deftrap-inline "_CGDataConsumerCreate" 
      ((info :pointer) (callbacks (:pointer :cgdataconsumercallbacks))) 
  :pointer
   () )

;  Create a data consumer which writes data to `url'. 
; 
;  *  CGDataConsumerCreateWithURL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDataConsumerCreateWithURL" 
      ((url :pointer)) 
  :pointer
   () )

;  Increment the retain count of `consumer' and return it.  All data
;  * consumers are created with an initial retain count of 1. 
; 
;  *  CGDataConsumerRetain()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDataConsumerRetain" 
      ((consumer :pointer)) 
  :pointer
   () )

;  Decrement the retain count of `consumer'.  If the retain count reaches
;  * 0, then release it and any associated resources. 
; 
;  *  CGDataConsumerRelease()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDataConsumerRelease" 
      ((consumer :pointer)) 
  nil
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CGDataConsumerIncludes

; $ENDC                                         ; __CGDATACONSUMER__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'CGDataConsumer)