(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CGDataProvider.p"
; at Wednesday May 1,2002 2:39:21 pm.
; 
;      File:       CGDataProvider.p
;  
;      Contains:   xxx put contents here xxx
;  
;      Version:    Technology: from CoreGraphics-70.root
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   2000-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 

#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __CGDATAPROVIDER__
; $SETC __CGDATAPROVIDER__ := 1

; $I+
; $SETC CGDataProviderIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CGBASE__
|#

(require-interface 'CGBase)
#|                                              ; $I CGBase.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __CFURL__

(require-interface 'CFURL)                      ; $I CFURL.p
; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :cgdataproviderref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :cgdataproviderrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:CGDataProviderRef parameter can be nil, it is changed to xx: CGDataProviderRefPtr 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CGGetBytesProcPtr = FUNCTION(info: UNIV Ptr; buffer: UNIV Ptr; count: size_t): size_t; C;

|#
 |#                                             ; $ELSEC
(def-mactype :cggetbytesprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CGSkipBytesProcPtr = PROCEDURE(info: UNIV Ptr; count: size_t); C;

|#
 |#                                             ; $ELSEC
(def-mactype :cgskipbytesprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CGRewindProcPtr = PROCEDURE(info: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :cgrewindprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CGReleaseProviderProcPtr = PROCEDURE(info: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :cgreleaseproviderprocptr (find-mactype ':pointer))
; $ENDC

; 	 Callbacks for sequentially accessing data.
; 	 * `getBytes' is called to copy `count' bytes from the provider's data to
; 	 * `buffer'.  It should return the number of bytes copied, or 0 if there's
; 	 * no more data.
; 	 * `skipBytes' is called to skip ahead in the provider's data by `count' bytes.
; 	 * `rewind' is called to rewind the provider to the beginning of the data.
; 	 * `releaseProvider', if non-NULL, is called when the provider is freed. 	
(def-mactype :cgdataprovidercallbacksptr (find-mactype '(:pointer :cgdataprovidercallbacks)))
(defrecord CGDataProviderCallbacks 
   (getBytes :pointer)
   (skipBytes :pointer)
   (rewind :pointer)
   (releaseProvider :pointer)
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CGGetBytePointerProcPtr = FUNCTION(info: UNIV Ptr): Ptr; C;

|#
 |#                                             ; $ELSEC
(def-mactype :cggetbytepointerprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CGReleaseByteProcPtr = PROCEDURE(info: UNIV Ptr; pointer: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :cgreleasebyteprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CGGetBytesDirectProcPtr = FUNCTION(info: UNIV Ptr; buffer: UNIV Ptr; offset: size_t; count: size_t): size_t; C;

|#
 |#                                             ; $ELSEC
(def-mactype :cggetbytesdirectprocptr (find-mactype ':pointer))
; $ENDC

; 	 Callbacks for directly accessing data.
; 	 * `getBytePointer', if non-NULL, is called to return a pointer to the
; 	 * provider's entire block of data.
; 	 * `releaseBytePointer', if non-NULL, is called to release a pointer to
; 	 * the provider's entire block of data.
; 	 * `getBytes', if non-NULL, is called to copy `count' bytes at offset
; 	 * `offset' from the provider's data to `buffer'.  It should return the
; 	 * number of bytes copied, or 0 if there's no more data.
; 	 * `releaseProvider', if non-NULL, is called when the provider is freed.
; 	 * At least one of `getBytePointer' or `getBytes' must be non-NULL.  	
(def-mactype :cgdataproviderdirectaccesscallbacksptr (find-mactype '(:pointer :cgdataproviderdirectaccesscallbacks)))
(defrecord CGDataProviderDirectAccessCallbacks 
   (getBytePointer :pointer)
   (releaseBytePointer :pointer)
   (getBytes :pointer)
   (releaseProvider :pointer)
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CGReleaseDataProcPtr = PROCEDURE(info: UNIV Ptr; data: UNIV Ptr; size: size_t); C;

|#
 |#                                             ; $ELSEC
(def-mactype :cgreleasedataprocptr (find-mactype ':pointer))
; $ENDC

; 	 Create a sequential-access data provider using `callbacks' to provide
; 	 * the data.  `info' is passed to each of the callback functions. 	
; 
; 	 *  CGDataProviderCreate()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; CONST
(deftrap-inline "_CGDataProviderCreate" 
      ((info :pointer) (callbacks (:pointer :cgdataprovidercallbacks))) 
  :pointer
   () )

;  Create a direct-access data provider using `callbacks' to supply `size'
;  * bytes of data. `info' is passed to each of the callback functions. 
; 
;  *  CGDataProviderCreateDirectAccess()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_CGDataProviderCreateDirectAccess" 
      ((info :pointer) (size :unsigned-long) (callbacks (:pointer :cgdataproviderdirectaccesscallbacks))) 
  :pointer
   () )

;  Create a direct-access data provider using `data', an array of `size'
;  * bytes.  `releaseData' is called when the data provider is freed, and is
;  * passed `info' as its first argument. 
; 
;  *  CGDataProviderCreateWithData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDataProviderCreateWithData" 
      ((info :pointer) (data :pointer) (size :unsigned-long) (releaseData :pointer)) 
  :pointer
   () )

;  Create a data provider using `url'. 
; 
;  *  CGDataProviderCreateWithURL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDataProviderCreateWithURL" 
      ((url :pointer)) 
  :pointer
   () )

;  Increment the retain count of `provider' and return it.  All data
;  * providers are created with an initial retain count of 1. 
; 
;  *  CGDataProviderRetain()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDataProviderRetain" 
      ((provider :pointer)) 
  :pointer
   () )

;  Decrement the retain count of `provider'.  If the retain count reaches
;  * 0, then free `provider' and any associated resources. 
; 
;  *  CGDataProviderRelease()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDataProviderRelease" 
      ((provider :pointer)) 
  nil
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CGDataProviderIncludes

; $ENDC                                         ; __CGDATAPROVIDER__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'CGDataProvider)