(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CGDirectDisplay.p"
; at Wednesday May 1,2002 2:40:43 pm.
; 
;      File:       CGDirectDisplay.p
;  
;      Contains:   CoreGraphics direct display
;  
;      Version:    Technology: CoreGraphics-122 (Mac OS X 10.1)
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   2000-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __CGDIRECTDISPLAY__
; $SETC __CGDIRECTDISPLAY__ := 1

; $I+
; $SETC CGDirectDisplayIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CGBASE__
|#

(require-interface 'CGBase)
#|                                              ; $I CGBase.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CGGEOMETRY__
|#

(require-interface 'CGGeometry)
#|                                              ; $I CGGeometry.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CGERROR__
|#

(require-interface 'CGError)
#|                                              ; $I CGError.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFARRAY__
|#

(require-interface 'CFArray)
#|                                              ; $I CFArray.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFSTRING__
|#

(require-interface 'CFString)
#|                                              ; $I CFString.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFDICTIONARY__
|#

(require-interface 'CFDictionary)
#|                                              ; $I CFDictionary.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :cgdirectdisplayid (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :cgdirectdisplayidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:CGDirectDisplayID parameter can be nil, it is changed to xx: CGDirectDisplayIDPtr 
(def-mactype :cgdirectpaletteref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :cgdirectpaletterefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:CGDirectPaletteRef parameter can be nil, it is changed to xx: CGDirectPaletteRefPtr 
(def-mactype :cgdisplaycount (find-mactype ':unsigned-long))
(def-mactype :cgtablecount (find-mactype ':unsigned-long))
(def-mactype :cgdisplaycoord (find-mactype ':signed-long))
(def-mactype :cgbytevalue (find-mactype ':unsigned-byte))
(def-mactype :cgopengldisplaymask (find-mactype ':unsigned-long))
(def-mactype :cgbeamposition (find-mactype ':unsigned-long))
(def-mactype :cgmousedelta (find-mactype ':signed-long))
(def-mactype :cgrefreshrate (find-mactype ':double-float))
(def-mactype :cgdisplayerr (find-mactype ':signed-long))

(defconstant $CGDisplayNoErr 0)

; 	 A NULL value points to the main display device as a programming convention 	
; $IFC NOT UNDEFINED MWERKS
(defconstant $kCGDirectMainDisplay nil)
; $ENDC

; 	
; 	 * Mechanisms used to find screen IDs
; 	 * An array length (maxDisplays) and array of CGDirectDisplayIDs are passed in.
; 	 * Up to maxDisplays of the array are filled in with the displays meeting the
; 	 * specified criteria.  The actual number of displays filled in is returned in
; 	 * dspyCnt.
; 	 *
; 	 * If the dspys array is NULL, maxDisplays is ignored, and *dspyCnt is filled
; 	 * in with the number of displays meeting the function's requirements.
; 	 	
; 
; 	 *  CGGetDisplaysWithPoint()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_CGGetDisplaysWithPoint" 
      ((point :cgpoint) (maxDisplays :unsigned-long) (dspys (:pointer :pointer)) (dspyCnt (:pointer :unsigned-long))) 
  :cgdisplayerr
   () )

; 
;  *  CGGetDisplaysWithRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGGetDisplaysWithRect" 
      ((rect :cgrect) (maxDisplays :unsigned-long) (dspys (:pointer :pointer)) (dspyCnt (:pointer :unsigned-long))) 
  :cgdisplayerr
   () )

; 
;  *  CGGetDisplaysWithOpenGLDisplayMask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGGetDisplaysWithOpenGLDisplayMask" 
      ((mask :unsigned-long) (maxDisplays :unsigned-long) (dspys (:pointer :pointer)) (dspyCnt (:pointer :unsigned-long))) 
  :cgdisplayerr
   () )

; 
;  * Get lists of displays.  Use this to determine display IDs
;  *
;  * If the activeDspys array is NULL, maxDisplays is ignored, and *dspyCnt is filled
;  * in with the number of displays meeting the function's requirements.
;  *
;  * The first display returned in the list is the main display,
;  * the one with the menu bar.
;  * When mirroring, this will be the largest display,
;  * or if all are the same size, the one with the deepest pixel depth.
;  
; 
;  *  CGGetActiveDisplayList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGGetActiveDisplayList" 
      ((maxDisplays :unsigned-long) (activeDspys (:pointer :pointer)) (dspyCnt (:pointer :unsigned-long))) 
  :cgdisplayerr
   () )

;  Map a display to an OpenGL display mask; returns 0 on invalid display 
; 
;  *  CGDisplayIDToOpenGLDisplayMask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplayIDToOpenGLDisplayMask" 
      ((display :pointer)) 
  :unsigned-long
   () )

;  Return screen size and origin in global coords; Empty rect if display is invalid 
; 
;  *  CGDisplayBounds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplayBounds" 
      ((display :pointer)) 
  :cgrect
   () )

; 
;  *  CGDisplayPixelsWide()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplayPixelsWide" 
      ((display :pointer)) 
  :unsigned-long
   () )

; 
;  *  CGDisplayPixelsHigh()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplayPixelsHigh" 
      ((display :pointer)) 
  :unsigned-long
   () )

; 
;  * Display mode selection
;  * Display modes are represented as CFDictionaries
;  * All dictionaries and arrays returned via these mechanisms are
;  * owned by the framework and should not be released.  The framework
;  * will not release them out from under your application.
;  *
;  * Values associated with the following keys are CFNumber types.
;  * With CFNumberGetValue(), use kCFNumberLongType for best results.
;  
; 
;  * Keys used in mode dictionaries.  Source C strings shown won't change.
;  * Some CFM environments cannot import data variables, and so
;  * duplicate these CFStringRefs locally.
;  
; 
;  *  kCGDisplayWidth
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  kCGDisplayHeight
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  kCGDisplayMode
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  kCGDisplayBitsPerPixel
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  kCGDisplayBitsPerSample
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  kCGDisplaySamplesPerPixel
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  kCGDisplayRefreshRate
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  kCGDisplayModeUsableForDesktopGUI
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  kCGDisplayIOFlags
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  * Return a CFArray of CFDictionaries describing all display modes.
;  * Returns NULL if the display is invalid.
;  
; 
;  *  CGDisplayAvailableModes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplayAvailableModes" 
      ((display :pointer)) 
  :pointer
   () )

; 
;  * Try to find a display mode of specified depth with dimensions equal or greater than
;  * specified.
;  * If no depth match is found, try for the next larger depth with dimensions equal or greater
;  * than specified.  If no luck, then just return the current mode.
;  *
;  * exactmatch, if not NULL, is set to 'true' if an exact match in width, height, and depth is found,
;  * and 'false' otherwise.
;  * Returns NULL if display is invalid.
;  
; 
;  *  CGDisplayBestModeForParameters()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplayBestModeForParameters" 
      ((display :pointer) (bitsPerPixel :unsigned-long) (width :unsigned-long) (height :unsigned-long) (exactMatch (:pointer :signed-long))) 
  :pointer
   () )

; 
;  *  CGDisplayBestModeForParametersAndRefreshRate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplayBestModeForParametersAndRefreshRate" 
      ((display :pointer) (bitsPerPixel :unsigned-long) (width :unsigned-long) (height :unsigned-long) (refresh :double-float) (exactMatch (:pointer :signed-long))) 
  :pointer
   () )

; 
;  * Return a CFDictionary describing the current display mode.
;  * Returns NULL if display is invalid.
;  
; 
;  *  CGDisplayCurrentMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplayCurrentMode" 
      ((display :pointer)) 
  :pointer
   () )

; 
;  * Switch display mode.  Note that after switching, 
;  * display parameters and addresses may change.
;  * The selected display mode persists for the life of the program, and automatically
;  * reverts to the permanent setting made by Preferences when the program terminates.
;  * The mode dictionary passed in must be a dictionary vended by other CGDirectDisplay
;  * APIs such as CGDisplayBestModeForParameters() and CGDisplayAvailableModes().
;  
; 
;  *  CGDisplaySwitchToMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplaySwitchToMode" 
      ((display :pointer) (mode :pointer)) 
  :cgdisplayerr
   () )

;  Query parameters for current mode 
; 
;  *  CGDisplayBitsPerPixel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplayBitsPerPixel" 
      ((display :pointer)) 
  :unsigned-long
   () )

; 
;  *  CGDisplayBitsPerSample()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplayBitsPerSample" 
      ((display :pointer)) 
  :unsigned-long
   () )

; 
;  *  CGDisplaySamplesPerPixel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplaySamplesPerPixel" 
      ((display :pointer)) 
  :unsigned-long
   () )

; 
;  *  CGDisplayBytesPerRow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplayBytesPerRow" 
      ((display :pointer)) 
  :unsigned-long
   () )

; 
;  * Set a display gamma/transfer function from a formula specifying
;  * min and max values and a gamma for each channel.
;  * Gamma values must be greater than 0.0.
;  * To get an antigamma of 1.6, one would specify a value of (1.0 / 1.6)
;  * Min values must be greater than or equal to 0.0 and less than 1.0.
;  * Max values must be greater than 0.0 and less than or equal to 1.0.
;  * Out of range values, or Max greater than or equal to Min result
;  * in a kCGSRangeCheck error.
;  *
;  * Values are computed by sampling a function for a range of indices from 0 through 1:
;  *  value = Min + ((Max - Min) * pow(index, Gamma))
;  * The resulting values are converted to a machine specific format
;  * and loaded into hardware.
;  

(def-mactype :cggammavalue (find-mactype ':single-float))
; 
; 	 *  CGSetDisplayTransferByFormula()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_CGSetDisplayTransferByFormula" 
      ((display :pointer) (redMin :single-float) (redMax :single-float) (redGamma :single-float) (greenMin :single-float) (greenMax :single-float) (greenGamma :single-float) (blueMin :single-float) (blueMax :single-float) (blueGamma :single-float)) 
  :cgdisplayerr
   () )

; 
;  *  CGGetDisplayTransferByFormula()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGGetDisplayTransferByFormula" 
      ((display :pointer) (redMin (:pointer :single-float)) (redMax (:pointer :single-float)) (redGamma (:pointer :single-float)) (greenMin (:pointer :single-float)) (greenMax (:pointer :single-float)) (greenGamma (:pointer :single-float)) (blueMin (:pointer :single-float)) (blueMax (:pointer :single-float)) (blueGamma (:pointer :single-float))) 
  :cgdisplayerr
   () )

; 
;  * Set a display gamma/transfer function using tables of data for each channel.
;  * Values within each table should have values in the range of 0.0 through 1.0.
;  * The same table may be passed in for red, green, and blue channels. 'tableSize'
;  * indicates the number of entries in each table.
;  * The tables are interpolated as needed to generate the number of samples needed
;  * by hardware.
;  
; 
;  *  CGSetDisplayTransferByTable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST; CONST
(deftrap-inline "_CGSetDisplayTransferByTable" 
      ((display :pointer) (tableSize :unsigned-long) (redTable (:pointer :single-float)) (greenTable (:pointer :single-float)) (blueTable (:pointer :single-float))) 
  :cgdisplayerr
   () )

; 
;  * Get transfer tables.  Capacity should contain the number of samples each
;  * array can hold, and *sampleCount is filled in with the number of samples
;  * actually copied in.
;  
; 
;  *  CGGetDisplayTransferByTable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGGetDisplayTransferByTable" 
      ((display :pointer) (capacity :unsigned-long) (redTable (:pointer :single-float)) (greenTable (:pointer :single-float)) (blueTable (:pointer :single-float)) (sampleCount (:pointer :unsigned-long))) 
  :cgdisplayerr
   () )

;  As a convenience, allow setting of the gamma table by byte values 
; 
;  *  CGSetDisplayTransferByByteTable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST; CONST
(deftrap-inline "_CGSetDisplayTransferByByteTable" 
      ((display :pointer) (tableSize :unsigned-long) (redTable (:pointer :unsigned-byte)) (greenTable (:pointer :unsigned-byte)) (blueTable (:pointer :unsigned-byte))) 
  :cgdisplayerr
   () )

;  Restore gamma tables of system displays to the user's ColorSync specified values 
; 
;  *  CGDisplayRestoreColorSyncSettings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplayRestoreColorSyncSettings" 
      () 
  nil
   () )

;  Display capture and release 
; 
;  *  CGDisplayIsCaptured()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplayIsCaptured" 
      ((display :pointer)) 
  :boolean_t
   () )

; 
;  *  CGDisplayCapture()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplayCapture" 
      ((display :pointer)) 
  :cgdisplayerr
   () )

; 
;  *  CGDisplayRelease()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplayRelease" 
      ((display :pointer)) 
  :cgdisplayerr
   () )

; 
;  * Capture all displays; this has the nice effect of providing an immersive
;  * environment, and preventing other apps from trying to adjust themselves
;  * to display changes only needed by your app.
;  
; 
;  *  CGCaptureAllDisplays()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGCaptureAllDisplays" 
      () 
  :cgdisplayerr
   () )

; 
;  * Release all captured displays, and restore the display modes to the
;  * user's preferences.  May be used in conjunction with CGDisplayCapture()
;  * or CGCaptureAllDisplays().
;  
; 
;  *  CGReleaseAllDisplays()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGReleaseAllDisplays" 
      () 
  :cgdisplayerr
   () )

; 
;  * Returns CoreGraphics raw shield window ID or NULL if not shielded
;  * This value may be used with drawing surface APIs.
;  
; 
;  *  CGShieldingWindowID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGShieldingWindowID" 
      ((display :pointer)) 
  :pointer
   () )

; 
;  * Returns the window level used for the shield window.
;  * This value may be used with Cocoa windows to position the
;  * Cocoa window in the same window level as the shield window.
;  
; 
;  *  CGShieldingWindowLevel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGShieldingWindowLevel" 
      () 
  :int32_t
   () )

; 
;  * Returns base address of display or NULL for an invalid display.
;  * If the display has not been captured, the returned address may refer
;  * to read-only memory.
;  
; 
;  *  CGDisplayBaseAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplayBaseAddress" 
      ((display :pointer)) 
  :pointer
   () )

; 
;  * return address for X,Y in screen coordinates;
;  *  (0,0) represents the upper left corner of the display.
;  * returns NULL for an invalid display or out of bounds coordinates
;  * If the display has not been captured, the returned address may refer
;  * to read-only memory.
;  
; 
;  *  CGDisplayAddressForPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplayAddressForPosition" 
      ((display :pointer) (x :signed-long) (y :signed-long)) 
  :pointer
   () )

;  Mouse Cursor controls 
; 
;  *  CGDisplayHideCursor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplayHideCursor" 
      ((display :pointer)) 
  :cgdisplayerr
   () )

;  increments hide cursor count 
; 
;  *  CGDisplayShowCursor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplayShowCursor" 
      ((display :pointer)) 
  :cgdisplayerr
   () )

;  decrements hide cursor count  
; 
;  * Move the cursor to the specified point relative to the display origin
;  * (the upper left corner of the display).  Returns CGDisplayNoErr on success.
;  * No events are generated as a result of this move.
;  * Points that would lie outside the desktop are clipped to the desktop.
;  
; 
;  *  CGDisplayMoveCursorToPoint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplayMoveCursorToPoint" 
      ((display :pointer) (point :cgpoint)) 
  :cgdisplayerr
   () )

; 
;  * Report the mouse position change associated with the last mouse move event
;  * recieved by this application.
;  
; 
;  *  CGGetLastMouseDelta()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGGetLastMouseDelta" 
      ((deltaX (:pointer :signed-long)) (deltaY (:pointer :signed-long))) 
  nil
   () )

;  Palette controls (8 bit pseudocolor only) 
; 
;  * Returns TRUE if the current display mode supports palettes
;  
; 
;  *  CGDisplayCanSetPalette()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplayCanSetPalette" 
      ((display :pointer)) 
  :boolean_t
   () )

; 
;  * Set a palette.  The current gamma function is applied to the palette
;  * elements before being loaded into hardware.
;  
; 
;  *  CGDisplaySetPalette()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplaySetPalette" 
      ((display :pointer) (palette :pointer)) 
  :cgdisplayerr
   () )

; 
;  * Wait until the beam position is outside the range specified by upperScanLine and lowerScanLine.
;  * Note that if upperScanLine and lowerScanLine encompass the entire display height,
;  * the function returns an error.
;  * lowerScanLine must be greater than or equal to upperScanLine.
;  *
;  * Some display systems may not conventional video vertical and horizontal sweep in painting.
;  * These displays report a kCGDisplayRefreshRate of 0 in the CFDictionaryRef returned by
;  * CGDisplayCurrentMode().  On such displays, this function returns at once.
;  *
;  * Some drivers may not implement support for this mechanism.
;  * On such displays, this function returns at once.
;  *
;  * Returns CGDisplayNoErr on success, and an error if display or upperScanLine and
;  * lowerScanLine are invalid.
;  *
;  * The app should set the values of upperScanLine and lowerScanLine to allow enough lead time
;  * for the drawing operation to complete.  A common strategy is to wait for the beam to pass
;  * the bottom of the drawing area, allowing almost a full vertical sweep period to perform drawing.
;  * To do this, set upperScanLine to 0, and set lowerScanLine to the bottom of the bounding box:
;  *  lowerScanLine = (CGBeamPosition)(cgrect.origin.y + cgrect.size.height);
;  *
;  * IOKit may implement this as a spin-loop on the beam position call used for CGDisplayBeamPosition().
;  * On such system the function is CPU bound, and subject to all the usual scheduling pre-emption.
;  * In particular, attempting to wait for the beam to hit a specific scanline may be an exercise in frustration.
;  *
;  * These functions are advisary in nature, and depend on IOKit and hardware specific drivers to implement
;  * support. If you need extremely precise timing, or access to vertical blanking interrupts,
;  * you should consider writing a device driver to tie into hardware-specific capabilities.
;  
; 
;  *  CGDisplayWaitForBeamPositionOutsideLines()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplayWaitForBeamPositionOutsideLines" 
      ((display :pointer) (upperScanLine :unsigned-long) (lowerScanLine :unsigned-long)) 
  :cgdisplayerr
   () )

; 
;  * Returns the current beam position on the display.  If display is invalid,
;  * or the display does not implement conventional video vertical and horizontal
;  * sweep in painting, or the driver does not implement this functionality, 0 is returned.
;  
; 
;  *  CGDisplayBeamPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CGDisplayBeamPosition" 
      ((display :pointer)) 
  :unsigned-long
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CGDirectDisplayIncludes

; $ENDC                                         ; __CGDIRECTDISPLAY__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'CGDirectDisplay)