(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CGPDFContext.p"
; at Wednesday May 1,2002 2:40:44 pm.
; 
;      File:       CGPDFContext.p
;  
;      Contains:   CoreGraphics PDF context
;  
;      Version:    Technology: CoreGraphics-122 (Mac OS X 10.1)
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   2000-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 

#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __CGPDFCONTEXT__
; $SETC __CGPDFCONTEXT__ := 1

; $I+
; $SETC CGPDFContextIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CGBASE__
|#

(require-interface 'CGBase)
#|                                              ; $I CGBase.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CGCONTEXT__
|#

(require-interface 'CGContext)
#|                                              ; $I CGContext.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CGDATACONSUMER__
|#

(require-interface 'CGDataConsumer)
#|                                              ; $I CGDataConsumer.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFDICTIONARY__
|#

(require-interface 'CFDictionary)
#|                                              ; $I CFDictionary.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  Create a PDF context, using `consumer' for output. `mediaBox' is the
;  * default page media bounding box; if NULL, then a default page size is
;  * used.  `auxiliaryInfo' specifies additional information used by the PDF
;  * context when generating the PDF file.  The keys and values in
;  * `auxiliaryInfo' must be CFStrings.  The following keys are recognized:
;  *   Key       Value
;  *   --------  --------
;  *   Title     The document's title.
;  *   Author    The name of the person who created the document.
;  *   Creator   If the document was converted to PDF from another format,
;  *             the name of the application that created the original
;  *             document from which it was converted. 
;  
; 
;  *  CGPDFContextCreate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_CGPDFContextCreate" 
      ((consumer :pointer) (mediaBox (:pointer :cgrect)) (auxiliaryInfo :pointer)) 
  :pointer
   () )

;  Convenience function: create a PDF context, writing to `url'. 
; 
;  *  CGPDFContextCreateWithURL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_CGPDFContextCreateWithURL" 
      ((url :pointer) (mediaBox (:pointer :cgrect)) (auxiliaryInfo :pointer)) 
  :pointer
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CGPDFContextIncludes

; $ENDC                                         ; __CGPDFCONTEXT__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'CGPDFContext)