(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CMICCProfile.p"
; at Wednesday May 1,2002 2:40:34 pm.
; 
;      File:       CMICCProfile.p
;  
;      Contains:   ICC Profile Format Definitions
;  
;      Version:    Technology: ColorSync 2.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1994-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __CMICCPROFILE__
; $SETC __CMICCPROFILE__ := 1

; $I+
; $SETC CMICCProfileIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  ICC Profile version constants  

(defconstant $cmICCProfileVersion2 #x2000000)
(defconstant $cmICCProfileVersion21 #x2100000)
(defconstant $cmCS2ProfileVersion #x2000000)
(defconstant $cmCS1ProfileVersion #x100)        ;   ColorSync 1.0 profile version  

; 	 Current Major version number 	
(defconstant $cmProfileMajorVersionMask #xFF000000)
(defconstant $cmCurrentProfileMajorVersion #x2000000)

; 	 magic cookie number for anonymous file ID 	
(defconstant $cmMagicNumber :|acsp|)

; 	**********************************************************************	
; 	************** ColorSync 2.0 profile specification *******************	
; 	**********************************************************************	
; 	*** flags field  ***	
(defconstant $cmICCReservedFlagsMask #xFFFF)    ;   these bits of the flags field are defined and reserved by ICC  
(defconstant $cmEmbeddedMask #x1)               ;   if bit 0 is 0 then not embedded profile, if 1 then embedded profile  
(defconstant $cmEmbeddedUseMask #x2)            ;   if bit 1 is 0 then ok to use anywhere, if 1 then ok to use as embedded profile only  
(defconstant $cmCMSReservedFlagsMask #xFFFF0000);   these bits of the flags field are defined and reserved by CMS vendor  
(defconstant $cmQualityMask #x30000)            ;   if bits 16-17 is 0 then normal, if 1 then draft, if 2 then best  
(defconstant $cmInterpolationMask #x40000)      ;   if bit 18 is 0 then interpolation, if 1 then lookup only  
(defconstant $cmGamutCheckingMask #x80000)      ;   if bit 19 is 0 then create gamut checking info, if 1 then no gamut checking info  

; 	 copyright-protection flag options 	
(defconstant $cmEmbeddedProfile 0)              ;   0 is not embedded profile, 1 is embedded profile  
(defconstant $cmEmbeddedUse 1)                  ;   0 is to use anywhere, 1 is to use as embedded profile only  

; 	 speed and quality flag options 	
(defconstant $cmNormalMode 0)                   ;   it uses the least significent two bits in the high word of flag  
(defconstant $cmDraftMode 1)                    ;   it should be evaulated like this: right shift 16 bits first, mask off the  
(defconstant $cmBestMode 2)                     ;   high 14 bits, and then compare with the enum to determine the option value  

; 	*** deviceAttributes fields ***	
; 	 deviceAttributes[0] is defined by and reserved for device vendors 	
; 	 deviceAttributes[1] is defined by and reserved for ICC 	
; 	 The following bits of deviceAttributes[1] are currently defined 	
(defconstant $cmReflectiveTransparentMask #x1)  ;   if bit 0 is 0 then reflective media, if 1 then transparency media  
(defconstant $cmGlossyMatteMask #x2)            ;   if bit 1 is 0 then glossy, if 1 then matte  

; 	 device/media attributes element values  	
(defconstant $cmReflective 0)                   ;   if bit 0 is 0 then reflective media, if 1 then transparency media  
(defconstant $cmGlossy 1)                       ;   if bit 1 is 0 then glossy, if 1 then matte  

; 	*** renderingIntent field ***	
(defconstant $cmPerceptual 0)                   ;   Photographic images  
(defconstant $cmRelativeColorimetric 1)         ;   Logo Colors  
(defconstant $cmSaturation 2)                   ;   Business graphics  
(defconstant $cmAbsoluteColorimetric 3)         ;   Logo Colors  

; 	 data type element values 	
(defconstant $cmAsciiData 0)
(defconstant $cmBinaryData 1)

; 	 screen encodings  	
(defconstant $cmPrtrDefaultScreens 0)           ;   Use printer default screens.  0 is false, 1 is ture  
(defconstant $cmLinesPer 1)                     ;   0 is LinesPerCm, 1 is LinesPerInch  

; 	 2.0 tag type information 	
(defconstant $cmNumHeaderElements 10)

; 	 public tags 	
(defconstant $cmAToB0Tag :|A2B0|)
(defconstant $cmAToB1Tag :|A2B1|)
(defconstant $cmAToB2Tag :|A2B2|)
(defconstant $cmBlueColorantTag :|bXYZ|)
(defconstant $cmBlueTRCTag :|bTRC|)
(defconstant $cmBToA0Tag :|B2A0|)
(defconstant $cmBToA1Tag :|B2A1|)
(defconstant $cmBToA2Tag :|B2A2|)
(defconstant $cmCalibrationDateTimeTag :|calt|)
(defconstant $cmChromaticAdaptationTag :|chad|)
(defconstant $cmCharTargetTag :|targ|)
(defconstant $cmCopyrightTag :|cprt|)
(defconstant $cmDeviceMfgDescTag :|dmnd|)
(defconstant $cmDeviceModelDescTag :|dmdd|)
(defconstant $cmGamutTag :|gamt|)
(defconstant $cmGrayTRCTag :|kTRC|)
(defconstant $cmGreenColorantTag :|gXYZ|)
(defconstant $cmGreenTRCTag :|gTRC|)
(defconstant $cmLuminanceTag :|lumi|)
(defconstant $cmMeasurementTag :|meas|)
(defconstant $cmMediaBlackPointTag :|bkpt|)
(defconstant $cmMediaWhitePointTag :|wtpt|)
(defconstant $cmNamedColorTag :|ncol|)
(defconstant $cmNamedColor2Tag :|ncl2|)
(defconstant $cmPreview0Tag :|pre0|)
(defconstant $cmPreview1Tag :|pre1|)
(defconstant $cmPreview2Tag :|pre2|)
(defconstant $cmProfileDescriptionTag :|desc|)
(defconstant $cmProfileSequenceDescTag :|pseq|)
(defconstant $cmPS2CRD0Tag :|psd0|)
(defconstant $cmPS2CRD1Tag :|psd1|)
(defconstant $cmPS2CRD2Tag :|psd2|)
(defconstant $cmPS2CRD3Tag :|psd3|)
(defconstant $cmPS2CSATag :|ps2s|)
(defconstant $cmPS2RenderingIntentTag :|ps2i|)
(defconstant $cmRedColorantTag :|rXYZ|)
(defconstant $cmRedTRCTag :|rTRC|)
(defconstant $cmScreeningDescTag :|scrd|)
(defconstant $cmScreeningTag :|scrn|)
(defconstant $cmTechnologyTag :|tech|)
(defconstant $cmUcrBgTag :|bfd |)
(defconstant $cmViewingConditionsDescTag :|vued|)
(defconstant $cmViewingConditionsTag :|view|)

; 	 custom tags 	
(defconstant $cmPS2CRDVMSizeTag :|psvm|)
(defconstant $cmVideoCardGammaTag :|vcgt|)
(defconstant $cmMakeAndModelTag :|mmod|)
(defconstant $cmProfileDescriptionMLTag :|dscm|)

; 	 technology tag descriptions 	
(defconstant $cmTechnologyFilmScanner :|fscn|)
(defconstant $cmTechnologyReflectiveScanner :|rscn|)
(defconstant $cmTechnologyInkJetPrinter :|ijet|)
(defconstant $cmTechnologyThermalWaxPrinter :|twax|)
(defconstant $cmTechnologyElectrophotographicPrinter :|epho|)
(defconstant $cmTechnologyElectrostaticPrinter :|esta|)
(defconstant $cmTechnologyDyeSublimationPrinter :|dsub|)
(defconstant $cmTechnologyPhotographicPaperPrinter :|rpho|)
(defconstant $cmTechnologyFilmWriter :|fprn|)
(defconstant $cmTechnologyVideoMonitor :|vidm|)
(defconstant $cmTechnologyVideoCamera :|vidc|)
(defconstant $cmTechnologyProjectionTelevision :|pjtv|)
(defconstant $cmTechnologyCRTDisplay :|CRT |)
(defconstant $cmTechnologyPMDisplay :|PMD |)
(defconstant $cmTechnologyAMDisplay :|AMD |)
(defconstant $cmTechnologyPhotoCD :|KPCD|)
(defconstant $cmTechnologyPhotoImageSetter :|imgs|)
(defconstant $cmTechnologyGravure :|grav|)
(defconstant $cmTechnologyOffsetLithography :|offs|)
(defconstant $cmTechnologySilkscreen :|silk|)
(defconstant $cmTechnologyFlexography :|flex|)

; 	 public type signatures 	
(defconstant $cmSigCurveType :|curv|)
(defconstant $cmSigDataType :|data|)
(defconstant $cmSigDateTimeType :|dtim|)
(defconstant $cmSigLut16Type :|mft2|)
(defconstant $cmSigLut8Type :|mft1|)
(defconstant $cmSigMeasurementType :|meas|)
(defconstant $cmSigNamedColorType :|ncol|)
(defconstant $cmSigNamedColor2Type :|ncl2|)
(defconstant $cmSigProfileDescriptionType :|desc|)
(defconstant $cmSigScreeningType :|scrn|)
(defconstant $cmSigS15Fixed16Type :|sf32|)
(defconstant $cmSigSignatureType :|sig |)
(defconstant $cmSigTextType :|text|)
(defconstant $cmSigU16Fixed16Type :|uf32|)
(defconstant $cmSigU1Fixed15Type :|uf16|)
(defconstant $cmSigUInt8Type :|ui08|)
(defconstant $cmSigUInt16Type :|ui16|)
(defconstant $cmSigUInt32Type :|ui32|)
(defconstant $cmSigUInt64Type :|ui64|)
(defconstant $cmSigUcrBgType :|bfd |)
(defconstant $cmSigUnicodeTextType :|utxt|)
(defconstant $cmSigViewingConditionsType :|view|)
(defconstant $cmSigXYZType :|XYZ |)

; 	 custom type signatures 	
(defconstant $cmSigPS2CRDVMSizeType :|psvm|)
(defconstant $cmSigVideoCardGammaType :|vcgt|)
(defconstant $cmSigMakeAndModelType :|mmod|)
(defconstant $cmSigMultiLocalizedUniCodeType :|mluc|)

; 	 Measurement type encodings 	
; 	 Measurement Flare 	
(defconstant $cmFlare0 #x0)
(defconstant $cmFlare100 #x1)

; 	 Measurement Geometry 	
(defconstant $cmGeometryUnknown #x0)
(defconstant $cmGeometry045or450 #x1)
(defconstant $cmGeometry0dord0 #x2)

; 	 Standard Observer    	
(defconstant $cmStdobsUnknown #x0)
(defconstant $cmStdobs1931TwoDegrees #x1)
(defconstant $cmStdobs1964TenDegrees #x2)

; 	 Standard Illuminant 	
(defconstant $cmIlluminantUnknown #x0)
(defconstant $cmIlluminantD50 #x1)
(defconstant $cmIlluminantD65 #x2)
(defconstant $cmIlluminantD93 #x3)
(defconstant $cmIlluminantF2 #x4)
(defconstant $cmIlluminantD55 #x5)
(defconstant $cmIlluminantA #x6)
(defconstant $cmIlluminantEquiPower #x7)
(defconstant $cmIlluminantF8 #x8)

; 	 Spot Function Value 	
(defconstant $cmSpotFunctionUnknown 0)
(defconstant $cmSpotFunctionDefault 1)
(defconstant $cmSpotFunctionRound 2)
(defconstant $cmSpotFunctionDiamond 3)
(defconstant $cmSpotFunctionEllipse 4)
(defconstant $cmSpotFunctionLine 5)
(defconstant $cmSpotFunctionSquare 6)
(defconstant $cmSpotFunctionCross 7)

; 	 Color Space Signatures 	
(defconstant $cmXYZData :|XYZ |)
(defconstant $cmLabData :|Lab |)
(defconstant $cmLuvData :|Luv |)
(defconstant $cmYxyData :|Yxy |)
(defconstant $cmRGBData :|RGB |)
(defconstant $cmSRGBData :|sRGB|)
(defconstant $cmGrayData :|GRAY|)
(defconstant $cmHSVData :|HSV |)
(defconstant $cmHLSData :|HLS |)
(defconstant $cmCMYKData :|CMYK|)
(defconstant $cmCMYData :|CMY |)
(defconstant $cmMCH5Data :|MCH5|)
(defconstant $cmMCH6Data :|MCH6|)
(defconstant $cmMCH7Data :|MCH7|)
(defconstant $cmMCH8Data :|MCH8|)
(defconstant $cm3CLRData :|3CLR|)
(defconstant $cm4CLRData :|4CLR|)
(defconstant $cm5CLRData :|5CLR|)
(defconstant $cm6CLRData :|6CLR|)
(defconstant $cm7CLRData :|7CLR|)
(defconstant $cm8CLRData :|8CLR|)
(defconstant $cmNamedData :|NAME|)

; 	 profileClass enumerations 	
(defconstant $cmInputClass :|scnr|)
(defconstant $cmDisplayClass :|mntr|)
(defconstant $cmOutputClass :|prtr|)
(defconstant $cmLinkClass :|link|)
(defconstant $cmAbstractClass :|abst|)
(defconstant $cmColorSpaceClass :|spac|)
(defconstant $cmNamedColorClass :|nmcl|)

; 	 platform enumerations 	
(defconstant $cmMacintosh :|APPL|)
(defconstant $cmMicrosoft :|MSFT|)
(defconstant $cmSolaris :|SUNW|)
(defconstant $cmSiliconGraphics :|SGI |)
(defconstant $cmTaligent :|TGNT|)

; 	 ColorSync 1.0 elements 	
(defconstant $cmCS1ChromTag :|chrm|)
(defconstant $cmCS1TRCTag :|trc |)
(defconstant $cmCS1NameTag :|name|)
(defconstant $cmCS1CustTag :|cust|)

; 	 General element data types 	

(def-mactype :cmdatetimeptr (find-mactype '(:pointer :cmdatetime)))
(defrecord CMDateTime 
   (year :unsigned-integer)
   (month :unsigned-integer)
   (dayOfTheMonth :unsigned-integer)
   (hours :unsigned-integer)
   (minutes :unsigned-integer)
   (seconds :unsigned-integer)
   )

(def-mactype :cmfixedxyzcolorptr (find-mactype '(:pointer :cmfixedxyzcolor)))
(defrecord CMFixedXYZColor 
   (X :signed-long)
   (Y :signed-long)
   (Z :signed-long)
   )

(def-mactype :cmxyzcomponent (find-mactype ':unsigned-integer))
(def-mactype :cmxyzcolorptr (find-mactype '(:pointer :cmxyzcolor)))
(defrecord CMXYZColor 
   (X :unsigned-integer)
   (Y :unsigned-integer)
   (Z :unsigned-integer)
   )

(def-mactype :cm2headerptr (find-mactype '(:pointer :cm2header)))
(defrecord CM2Header 
   (size :unsigned-long)                        ;   This is the total size of the Profile  
   (CMMType :ostype)                            ;   CMM signature,  Registered with CS2 consortium   
   (profileVersion :unsigned-long)              ;   Version of CMProfile format  
   (profileClass :ostype)                       ;   input, display, output, devicelink, abstract, or color conversion profile type  
   (dataColorSpace :ostype)                     ;   color space of data  
   (profileConnectionSpace :ostype)             ;   profile connection color space  
   (dateTime :cmdatetime)                       ;   date and time of profile creation  
   (CS2profileSignature :ostype)                ;   'acsp' constant ColorSync 2.0 file ID  
   (platform :ostype)                           ;   primary profile platform, Registered with CS2 consortium  
   (flags :unsigned-long)                       ;   profile flags  
   (deviceManufacturer :ostype)                 ;   Registered with ICC consortium  
   (deviceModel :unsigned-long)                 ;   Registered with ICC consortium  
   (deviceAttributes (:array :unsigned-long 2)) ;   Attributes[0] is for device vendors, [1] is for ICC  
   (renderingIntent :unsigned-long)             ;   preferred rendering intent of tagged object  
   (white :cmfixedxyzcolor)                     ;   profile illuminant  
   (creator :ostype)                            ;   profile creator  
   (reserved (:array :character 44 :packed))    ;   reserved for future use  
   )

(def-mactype :cmtagrecordptr (find-mactype '(:pointer :cmtagrecord)))
(defrecord CMTagRecord 
   (tag :ostype)                                ;   Registered with CS2 consortium  
   (elementOffset :unsigned-long)               ;   Relative to start of CMProfile  
   (elementSize :unsigned-long)
   )

(def-mactype :cmtagelemtableptr (find-mactype '(:pointer :cmtagelemtable)))
(defrecord CMTagElemTable 
   (count :unsigned-long)
   (tagList (:array :cmtagrecord 1))            ;   variable size, determined by count  
   )

(def-mactype :cm2profileptr (find-mactype '(:pointer :cm2profile)))
(defrecord CM2Profile 
   (header :cm2header)
   (tagTable :cmtagelemtable)
   (elemData :signed-byte)                      ;   variable size data for tagged element storage  
   )

(def-mactype :cm2profilehandle (find-mactype '(:handle :cm2profile)))
; 	 Tag Type Definitions 	
(def-mactype :cmadaptationmatrixtypeptr (find-mactype '(:pointer :cmadaptationmatrixtype)))
(defrecord CMAdaptationMatrixType 
   (typeDescriptor :ostype)                     ;   'sf32' = cmSigS15Fixed16Type  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (adaptationMatrix (:array :signed-long 9))   ;   fixed size of nine matrix entries  
   )

(def-mactype :cmcurvetypeptr (find-mactype '(:pointer :cmcurvetype)))
(defrecord CMCurveType 
   (typeDescriptor :ostype)                     ;   'curv' = cmSigCurveType  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (countValue :unsigned-long)                  ;   number of entries in table that follows  
   (data (:array :unsigned-integer 1))          ;   variable size, determined by countValue  
   )

(def-mactype :cmdatatypeptr (find-mactype '(:pointer :cmdatatype)))
(defrecord CMDataType 
   (typeDescriptor :ostype)                     ;   'data' = cmSigDataType 
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (dataFlag :unsigned-long)                    ;   0 = ASCII, 1 = binary  
   (data :signed-byte)                          ;   variable size, determined by tag element size  
   )

(def-mactype :cmdatetimetypeptr (find-mactype '(:pointer :cmdatetimetype)))
(defrecord CMDateTimeType 
   (typeDescriptor :ostype)                     ;   'dtim' = cmSigDateTimeType  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (dateTime :cmdatetime)                       ;    
   )

(def-mactype :cmlut16typeptr (find-mactype '(:pointer :cmlut16type)))
(defrecord CMLut16Type 
   (typeDescriptor :ostype)                     ;   'mft2' = cmSigLut16Type  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (inputChannels :signed-byte)                 ;   Number of input channels  
   (outputChannels :signed-byte)                ;   Number of output channels  
   (gridPoints :signed-byte)                    ;   Number of clutTable grid points  
   (reserved2 :signed-byte)                     ;   fill with 0x00  
   (matrix (:array :signed-long 3 3))           ;    
   (inputTableEntries :unsigned-integer)        ;   Number of entries in 1-D input luts  
   (outputTableEntries :unsigned-integer)       ;   Number of entries in 1-D output luts  
   (inputTable (:array :unsigned-integer 1))    ;   variable size, determined by inputChannels*inputTableEntries  
   )

(def-mactype :cmlut8typeptr (find-mactype '(:pointer :cmlut8type)))
(defrecord CMLut8Type 
   (typeDescriptor :ostype)                     ;   'mft1' = cmSigLut8Type  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (inputChannels :signed-byte)                 ;   Number of input channels  
   (outputChannels :signed-byte)                ;   Number of output channels  
   (gridPoints :signed-byte)                    ;   Number of clutTable grid points  
   (reserved2 :signed-byte)                     ;   fill with 0x00  
   (matrix (:array :signed-long 3 3))           ;    
   (inputTable :signed-byte)                    ;   variable size, determined by inputChannels*256  
   )

(def-mactype :cmmeasurementtypeptr (find-mactype '(:pointer :cmmeasurementtype)))
(defrecord CMMeasurementType 
   (typeDescriptor :ostype)                     ;   'meas' = cmSigMeasurementType  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (standardObserver :unsigned-long)            ;   cmStdobsUnknown, cmStdobs1931TwoDegrees, cmStdobs1964TenDegrees  
   (backingXYZ :cmfixedxyzcolor)                ;   absolute XYZ values of backing  
   (geometry :unsigned-long)                    ;   cmGeometryUnknown, cmGeometry045or450 (0/45), cmGeometry0dord0 (0/d or d/0)  
   (flare :unsigned-long)                       ;   cmFlare0, cmFlare100  
   (illuminant :unsigned-long)                  ;   cmIlluminantUnknown, cmIlluminantD50, ...  
   )

(def-mactype :cmnamedcolortypeptr (find-mactype '(:pointer :cmnamedcolortype)))
(defrecord CMNamedColorType 
   (typeDescriptor :ostype)                     ;   'ncol' = cmSigNamedColorType  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (vendorFlag :unsigned-long)                  ;    
   (count :unsigned-long)                       ;   count of named colors in array that follows  
   (prefixName :signed-byte)                    ;   variable size, max = 32  
   )

(def-mactype :cmnamedcolor2entrytypeptr (find-mactype '(:pointer :cmnamedcolor2entrytype)))
(defrecord CMNamedColor2EntryType 
   (rootName (:array :unsigned-byte 32 :packed));   32 byte field.  7 bit ASCII null terminated  
   (PCSColorCoords (:array :unsigned-integer 3));   Lab or XYZ color  
   (DeviceColorCoords (:array :unsigned-integer 1));   variable size  
   )

(def-mactype :cmnamedcolor2typeptr (find-mactype '(:pointer :cmnamedcolor2type)))
(defrecord CMNamedColor2Type 
   (typeDescriptor :ostype)                     ;   'ncl2' = cmSigNamedColor2Type  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (vendorFlag :unsigned-long)                  ;   lower 16 bits reserved for ICC use  
   (count :unsigned-long)                       ;   count of named colors in array that follows  
   (deviceChannelCount :unsigned-long)          ;   number of device channels, 0 indicates no device value available  
   (prefixName (:array :unsigned-byte 32 :packed));   Fixed 32 byte size.  7 bit ASCII null terminated  
   (suffixName (:array :unsigned-byte 32 :packed));   Fixed 32 byte size.  7 bit ASCII null terminated  
   (data :signed-byte)                          ;   variable size data for CMNamedColor2EntryType  
   )

(def-mactype :cmtextdescriptiontypeptr (find-mactype '(:pointer :cmtextdescriptiontype)))
(defrecord CMTextDescriptionType 
   (typeDescriptor :ostype)                     ;   'desc' = cmSigProfileDescriptionType  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (ASCIICount :unsigned-long)                  ;   Count of bytes (including null terminator)   
   (ASCIIName (:array :unsigned-byte 2 :packed));   variable size, determined by ASCIICount.  7 bit ASCII null terminated  
   )

(def-mactype :cmtexttypeptr (find-mactype '(:pointer :cmtexttype)))
(defrecord CMTextType 
   (typeDescriptor :ostype)                     ;   'text' = cmSigTextType  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (text :signed-byte)                          ;   variable size, determined by tag element size  
   )

(def-mactype :cmunicodetexttypeptr (find-mactype '(:pointer :cmunicodetexttype)))
(defrecord CMUnicodeTextType 
   (typeDescriptor :ostype)                     ;   'utxt' = cmSigUnicodeTextType  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (text (:array :unsigned-integer 1))          ;   variable size, determined by tag element size   
   )

(def-mactype :cmscreeningchannelrecptr (find-mactype '(:pointer :cmscreeningchannelrec)))
(defrecord CMScreeningChannelRec 
   (frequency :signed-long)
   (angle :signed-long)
   (spotFunction :unsigned-long)
   )

(def-mactype :cmscreeningtypeptr (find-mactype '(:pointer :cmscreeningtype)))
(defrecord CMScreeningType 
   (typeDescriptor :ostype)                     ;   'scrn' = cmSigScreeningType  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (screeningFlag :unsigned-long)               ;   bit 0 : use printer default screens, bit 1 : inch/cm  
   (channelCount :unsigned-long)                ;    
   (channelInfo (:array :cmscreeningchannelrec 1));   variable size, determined by channelCount  
   )

(def-mactype :cmsignaturetypeptr (find-mactype '(:pointer :cmsignaturetype)))
(defrecord CMSignatureType 
   (typeDescriptor :ostype)                     ;   'sig ' = cmSigSignatureType  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (signature :ostype)
   )

(def-mactype :cms15fixed16arraytypeptr (find-mactype '(:pointer :cms15fixed16arraytype)))
(defrecord CMS15Fixed16ArrayType 
   (typeDescriptor :ostype)                     ;   'sf32' = cmSigS15Fixed16Type  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (value (:array :signed-long 1))              ;   variable size, determined by tag element size  
   )

(def-mactype :cmu16fixed16arraytypeptr (find-mactype '(:pointer :cmu16fixed16arraytype)))
(defrecord CMU16Fixed16ArrayType 
   (typeDescriptor :ostype)                     ;   'uf32' = cmSigU16Fixed16Type  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (value (:array :unsigned-long 1))            ;   variable size, determined by tag element size  
   )

(def-mactype :cmuint8arraytypeptr (find-mactype '(:pointer :cmuint8arraytype)))
(defrecord CMUInt8ArrayType 
   (typeDescriptor :ostype)                     ;   'ui08' = cmSigUInt8Type  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (value :signed-byte)                         ;   variable size, determined by tag element size  
   )

(def-mactype :cmuint16arraytypeptr (find-mactype '(:pointer :cmuint16arraytype)))
(defrecord CMUInt16ArrayType 
   (typeDescriptor :ostype)                     ;   'ui16' = cmSigUInt16Type  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (value (:array :unsigned-integer 1))         ;   variable size, determined by tag element size  
   )

(def-mactype :cmuint32arraytypeptr (find-mactype '(:pointer :cmuint32arraytype)))
(defrecord CMUInt32ArrayType 
   (typeDescriptor :ostype)                     ;   'ui32' = cmSigUInt32Type  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (value (:array :unsigned-long 1))            ;   variable size, determined by tag element size  
   )

(def-mactype :cmuint64arraytypeptr (find-mactype '(:pointer :cmuint64arraytype)))
(defrecord CMUInt64ArrayType 
   (typeDescriptor :ostype)                     ;   'ui64' = cmSigUInt64Type  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (value (:array :unsigned-long 1))            ;   variable size, determined by tag element size  
   )

(def-mactype :cmviewingconditionstypeptr (find-mactype '(:pointer :cmviewingconditionstype)))
(defrecord CMViewingConditionsType 
   (typeDescriptor :ostype)                     ;   'view' = cmSigViewingConditionsType  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (illuminant :cmfixedxyzcolor)                ;   absolute XYZs of illuminant  in cd/m^2  
   (surround :cmfixedxyzcolor)                  ;   absolute XYZs of surround in cd/m^2  
   (stdIlluminant :unsigned-long)               ;   see definitions of std illuminants  
   )

(def-mactype :cmxyztypeptr (find-mactype '(:pointer :cmxyztype)))
(defrecord CMXYZType 
   (typeDescriptor :ostype)                     ;   'XYZ ' = cmSigXYZType  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (XYZ (:array :cmfixedxyzcolor 1))            ;   variable size, determined by tag element size  
   )

(def-mactype :cmprofilesequencedesctypeptr (find-mactype '(:pointer :cmprofilesequencedesctype)))
(defrecord CMProfileSequenceDescType 
   (typeDescriptor :ostype)                     ;   'pseq' = cmProfileSequenceDescTag  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (count :unsigned-long)                       ;   Number of descriptions  
   (data :signed-byte)                          ;   variable size data explained in ICC spec  
   )

(def-mactype :cmucrbgtypeptr (find-mactype '(:pointer :cmucrbgtype)))
(defrecord CMUcrBgType 
   (typeDescriptor :ostype)                     ;   'bfd ' = cmSigUcrBgType  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (ucrCount :unsigned-long)                    ;   Number of UCR entries  
   (ucrValues (:array :unsigned-integer 1))     ;   variable size, determined by ucrCount  
   )

; 	 Private Tag Type Definitions 	
(def-mactype :cmintentcrdvmsizeptr (find-mactype '(:pointer :cmintentcrdvmsize)))
(defrecord CMIntentCRDVMSize 
   (renderingIntent :signed-long)               ;   rendering intent  
   (VMSize :unsigned-long)                      ;   VM size taken up by the CRD  
   )

(def-mactype :cmps2crdvmsizetypeptr (find-mactype '(:pointer :cmps2crdvmsizetype)))
(defrecord CMPS2CRDVMSizeType 
   (typeDescriptor :ostype)                     ;   'psvm' = cmSigPS2CRDVMSizeType  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (count :unsigned-long)                       ;   number of intent entries  
   (intentCRD (:array :cmintentcrdvmsize 1))    ;   variable size, determined by count  
   )

(defconstant $cmVideoCardGammaTableType 0)
(defconstant $cmVideoCardGammaFormulaType 1)

(def-mactype :cmvideocardgammatableptr (find-mactype '(:pointer :cmvideocardgammatable)))
(defrecord CMVideoCardGammaTable 
   (channels :unsigned-integer)                 ;   # of gamma channels (1 or 3)  
   (entryCount :unsigned-integer)               ;   1-based number of entries per channel  
   (entrySize :unsigned-integer)                ;   size in bytes of each entry  
   (data :signed-byte)                          ;   variable size, determined by channels*entryCount*entrySize  
   )

(def-mactype :cmvideocardgammaformulaptr (find-mactype '(:pointer :cmvideocardgammaformula)))
(defrecord CMVideoCardGammaFormula 
   (redGamma :signed-long)                      ;   must be > 0.0  
   (redMin :signed-long)                        ;   must be > 0.0 and < 1.0  
   (redMax :signed-long)                        ;   must be > 0.0 and < 1.0  
   (greenGamma :signed-long)                    ;   must be > 0.0  
   (greenMin :signed-long)                      ;   must be > 0.0 and < 1.0  
   (greenMax :signed-long)                      ;   must be > 0.0 and < 1.0  
   (blueGamma :signed-long)                     ;   must be > 0.0  
   (blueMin :signed-long)                       ;   must be > 0.0 and < 1.0  
   (blueMax :signed-long)                       ;   must be > 0.0 and < 1.0  
   )

(def-mactype :cmvideocardgammaptr (find-mactype '(:pointer :cmvideocardgamma)))
(defrecord CMVideoCardGamma 
   (tagType :unsigned-long)
   (:variant 
      (
      (table :cmvideocardgammatable)
      )
      (
      (formula :cmvideocardgammaformula)
      )
      )
   )

(def-mactype :cmvideocardgammatypeptr (find-mactype '(:pointer :cmvideocardgammatype)))
(defrecord CMVideoCardGammaType 
   (typeDescriptor :ostype)                     ;   'vcgt' = cmSigVideoCardGammaType  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (gamma :cmvideocardgamma)
   )

(def-mactype :cmmakeandmodelptr (find-mactype '(:pointer :cmmakeandmodel)))
(defrecord CMMakeAndModel 
   (manufacturer :ostype)
   (model :unsigned-long)
   (serialNumber :unsigned-long)
   (manufactureDate :unsigned-long)
   (reserved1 :unsigned-long)                   ;   fill with 0x00  
   (reserved2 :unsigned-long)                   ;   fill with 0x00  
   (reserved3 :unsigned-long)                   ;   fill with 0x00  
   (reserved4 :unsigned-long)                   ;   fill with 0x00  
   )

(def-mactype :cmmakeandmodeltypeptr (find-mactype '(:pointer :cmmakeandmodeltype)))
(defrecord CMMakeAndModelType 
   (typeDescriptor :ostype)                     ;   'mmod' = cmSigMakeAndModelType  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (makeAndModel :cmmakeandmodel)
   )

(def-mactype :cmmultilocalizedunicodeentryrecptr (find-mactype '(:pointer :cmmultilocalizedunicodeentryrec)))
(defrecord CMMultiLocalizedUniCodeEntryRec 
   (languageCode (:array :character 2 :packed)) ;   language code from ISO-639  
   (regionCode (:array :character 2 :packed))   ;   region code from ISO-3166  
   (textLength :unsigned-long)                  ;   the length in bytes of the string  
   (textOffset :unsigned-long)                  ;   the offset from the start of tag in bytes  
   )

(def-mactype :cmmultilocalizedunicodetypeptr (find-mactype '(:pointer :cmmultilocalizedunicodetype)))
(defrecord CMMultiLocalizedUniCodeType 
   (typeDescriptor :ostype)                     ;   'mluc' = cmSigMultiLocalizedUniCodeType  
   (reserved :unsigned-long)                    ;   fill with 0x00  
   (entryCount :unsigned-long)                  ;   1-based number of name records that follow  
   (entrySize :unsigned-long)                   ;   size in bytes of name records that follow  
;   variable-length data for storage of CMMultiLocalizedUniCodeEntryRec  
;   variable-length data for storage of Unicode strings 
   )

; 	**********************************************************************	
; 	************** ColorSync 1.0 profile specification *******************	
; 	**********************************************************************	

(defconstant $cmGrayResponse 0)
(defconstant $cmRedResponse 1)
(defconstant $cmGreenResponse 2)
(defconstant $cmBlueResponse 3)
(defconstant $cmCyanResponse 4)
(defconstant $cmMagentaResponse 5)
(defconstant $cmYellowResponse 6)
(defconstant $cmUcrResponse 7)
(defconstant $cmBgResponse 8)
(defconstant $cmOnePlusLastResponse 9)

; 	 Device types 	
(defconstant $cmMonitorDevice :|mntr|)
(defconstant $cmScannerDevice :|scnr|)
(defconstant $cmPrinterDevice :|prtr|)

(def-mactype :cmistringptr (find-mactype '(:pointer :cmistring)))
(defrecord CMIString 
   (theScript :signed-integer)
   (theString (:string 63))
   )

; 	 Profile options 	

(defconstant $cmPerceptualMatch #x0)            ;   Default. For photographic images  
(defconstant $cmColorimetricMatch #x1)          ;   Exact matching when possible  
(defconstant $cmSaturationMatch #x2)            ;   For solid colors  

; 	 Profile flags 	
(defconstant $cmNativeMatchingPreferred #x1)    ;   Default to native not preferred  
(defconstant $cmTurnOffCache #x2)               ;   Default to turn on CMM cache  

(def-mactype :cmmatchoption (find-mactype ':signed-long))
(def-mactype :cmmatchflag (find-mactype ':signed-long))
(def-mactype :cmheaderptr (find-mactype '(:pointer :cmheader)))
(defrecord CMHeader 
   (size :unsigned-long)
   (CMMType :ostype)
   (applProfileVersion :unsigned-long)
   (dataType :ostype)
   (deviceType :ostype)
   (deviceManufacturer :ostype)
   (deviceModel :unsigned-long)
   (deviceAttributes (:array :unsigned-long 2))
   (profileNameOffset :unsigned-long)
   (customDataOffset :unsigned-long)
   (flags :signed-long)
   (options :signed-long)
   (white :cmxyzcolor)
   (black :cmxyzcolor)
   )

(def-mactype :cmprofilechromaticitiesptr (find-mactype '(:pointer :cmprofilechromaticities)))
(defrecord CMProfileChromaticities 
   (red :cmxyzcolor)
   (green :cmxyzcolor)
   (blue :cmxyzcolor)
   (cyan :cmxyzcolor)
   (magenta :cmxyzcolor)
   (yellow :cmxyzcolor)
   )

(def-mactype :cmprofileresponseptr (find-mactype '(:pointer :cmprofileresponse)))
(defrecord CMProfileResponse 
   (counts (:array :unsigned-integer 9))
   (data (:array :unsigned-integer 1))          ;   Variable size  
   )

(def-mactype :cmprofileptr (find-mactype '(:pointer :cmprofile)))
(defrecord CMProfile 
   (header :cmheader)
   (profile :cmprofilechromaticities)
   (response :cmprofileresponse)
   (profileName :cmistring)
   (customData :signed-byte)                    ;   Variable size  
   )

(def-mactype :cmprofilehandle (find-mactype '(:handle :cmprofile)))
; $IFC OLDROUTINENAMES 

(defconstant $kCMApplProfileVersion #x100)

(defconstant $grayResponse 0)
(defconstant $redResponse 1)
(defconstant $greenResponse 2)
(defconstant $blueResponse 3)
(defconstant $cyanResponse 4)
(defconstant $magentaResponse 5)
(defconstant $yellowResponse 6)
(defconstant $ucrResponse 7)
(defconstant $bgResponse 8)
(defconstant $onePlusLastResponse 9)

(defconstant $rgbData :|RGB |)
(defconstant $cmykData :|CMYK|)
(defconstant $grayData :|GRAY|)
(defconstant $xyzData :|XYZ |)

(defconstant $monitorDevice :|mntr|)
(defconstant $scannerDevice :|scnr|)
(defconstant $printerDevice :|prtr|)

(def-mactype :xyzcomponent (find-mactype ':unsigned-integer))
(%define-record :xyzcolor (find-record-descriptor :cmxyzcolor))
(def-mactype :xyzcolorptr (find-mactype '(:pointer :cmxyzcolor)))
(def-mactype :cmresponsedata (find-mactype ':unsigned-integer))
(%define-record :istring (find-record-descriptor :cmistring))
(def-mactype :istringptr (find-mactype '(:pointer :cmistring)))
(def-mactype :cmresponsecolor (find-mactype ':signed-long))
(def-mactype :responsecolor (find-mactype ':signed-long))
; $ENDC                                         ; OLDROUTINENAMES

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CMICCProfileIncludes

; $ENDC                                         ; __CMICCPROFILE__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'CMICCProfile)