(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CMMComponent.p"
; at Wednesday May 1,2002 2:40:45 pm.
; 
;      File:       CMMComponent.p
;  
;      Contains:   ColorSync CMM Component API
;  
;      Version:    Technology: ColorSync 2.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1994-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __CMMCOMPONENT__
; $SETC __CMMCOMPONENT__ := 1

; $I+
; $SETC CMMComponentIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CMAPPLICATION__
|#

(require-interface 'CMApplication)
#|                                              ; $I CMApplication.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __COMPONENTS__
|#

(require-interface 'Components)
#|                                              ; $I Components.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  Component-based CMM interface version 

(defconstant $CMMInterfaceVersion 1)

; 	 Component-based CMM function selectors 	
;   Required  
(defconstant $kCMMOpen -1)                      ;   kComponentOpenSelect, 
(defconstant $kCMMClose -2)                     ;   kComponentCloseSelect, 
(defconstant $kCMMGetInfo -4)                   ;   kComponentVersionSelect 
(defconstant $kNCMMInit 6)
(defconstant $kCMMMatchColors 1)
(defconstant $kCMMCheckColors 2)                ;   
;   
;   Optional  
(defconstant $kCMMValidateProfile 8)
(defconstant $kCMMMatchBitmap 9)
(defconstant $kCMMCheckBitmap 10)
(defconstant $kCMMConcatenateProfiles 5)
(defconstant $kCMMConcatInit 7)
(defconstant $kCMMNewLinkProfile 16)
(defconstant $kNCMMConcatInit 18)
(defconstant $kNCMMNewLinkProfile 19)
(defconstant $kCMMGetPS2ColorSpace 11)
(defconstant $kCMMGetPS2ColorRenderingIntent 12)
(defconstant $kCMMGetPS2ColorRendering 13)
(defconstant $kCMMGetPS2ColorRenderingVMSize 17);   
;   
;   obsolete with ColorSync 2.5  
(defconstant $kCMMFlattenProfile 14)
(defconstant $kCMMUnflattenProfile 15)          ;   
;   
;   obsolete with ColorSync 2.6  
(defconstant $kCMMInit 0)
(defconstant $kCMMGetNamedColorInfo 70)
(defconstant $kCMMGetNamedColorValue 71)
(defconstant $kCMMGetIndNamedColorValue 72)
(defconstant $kCMMGetNamedColorIndex 73)
(defconstant $kCMMGetNamedColorName 74)         ;   
;   
;   obsolete with ColorSync 3.0  
(defconstant $kCMMMatchPixMap 3)
(defconstant $kCMMCheckPixMap 4)

#|                                              ; $IFC TARGET_API_MAC_OS8 

(def-mactype :cmmcomponentinst (find-mactype '(:pointer :componentinstancerecord)))
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NCMMInit()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_NCMMInit" 
      ((cmm :cmmcomponentinst) (srcProfile :pointer) (dstProfile :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm srcProfile dstProfile ((+ (ash 8 16) 6) :signed-longint)))

; 
;  *  CMMInit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CMMInit" 
      ((cmm :cmmcomponentinst) (srcProfile (:handle :cmprofile)) (dstProfile (:handle :cmprofile)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm srcProfile dstProfile ((+ (ash 8 16) 0) :signed-longint)))

; 
;  *  CMMMatchColors()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CMMMatchColors" 
      ((cmm :cmmcomponentinst) (colors (:pointer :cmcolor)) (count :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm colors count ((+ (ash 8 16) 1) :signed-longint)))

; 
;  *  CMMCheckColors()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CMMCheckColors" 
      ((cmm :cmmcomponentinst) (colors (:pointer :cmcolor)) (count :unsigned-long) (result (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm colors count result ((+ (ash 12 16) 2) :signed-longint)))

; 
;  *  CMMValidateProfile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CMMValidateProfile" 
      ((cmm :cmmcomponentinst) (prof :pointer) (valid (:pointer :boolean)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm prof valid ((+ (ash 8 16) 8) :signed-longint)))

; 
;  *  CMMFlattenProfile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CMMFlattenProfile" 
      ((cmm :cmmcomponentinst) (prof :pointer) (flags :unsigned-long) (proc :pointer) (refCon :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm prof flags proc refCon ((+ (ash 16 16) 14) :signed-longint)))

; 
;  *  CMMUnflattenProfile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CMMUnflattenProfile" 
      ((cmm :cmmcomponentinst) (resultFileSpec (:pointer :fsspec)) (proc :pointer) (refCon :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm resultFileSpec proc refCon ((+ (ash 12 16) 15) :signed-longint)))

; 
;  *  CMMMatchBitmap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CMMMatchBitmap" 
      ((cmm :cmmcomponentinst) (bitmap (:pointer :cmbitmap)) (progressProc :pointer) (refCon :pointer) (matchedBitmap (:pointer :cmbitmap)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm bitmap progressProc refCon matchedBitmap ((+ (ash 16 16) 9) :signed-longint)))

; 
;  *  CMMCheckBitmap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_CMMCheckBitmap" 
      ((cmm :cmmcomponentinst) (bitmap (:pointer :cmbitmap)) (progressProc :pointer) (refCon :pointer) (resultBitmap (:pointer :cmbitmap)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm bitmap progressProc refCon resultBitmap ((+ (ash 16 16) 10) :signed-longint)))

; 
;  *  CMMMatchPixMap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CMMMatchPixMap" 
      ((cmm :cmmcomponentinst) (PixMap (:pointer :pixmap)) (progressProc :pointer) (refCon :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm PixMap progressProc refCon ((+ (ash 12 16) 3) :signed-longint)))

; 
;  *  CMMCheckPixMap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_CMMCheckPixMap" 
      ((cmm :cmmcomponentinst) (PixMap (:pointer :pixmap)) (progressProc :pointer) (BitMap (:pointer :bitmap)) (refCon :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm PixMap progressProc BitMap refCon ((+ (ash 16 16) 4) :signed-longint)))

; 
;  *  CMMConcatInit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CMMConcatInit" 
      ((cmm :cmmcomponentinst) (profileSet (:pointer :cmconcatprofileset)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm profileSet ((+ (ash 4 16) 7) :signed-longint)))

; 
;  *  NCMMConcatInit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_NCMMConcatInit" 
      ((cmm :cmmcomponentinst) (profileSet (:pointer :ncmconcatprofileset)) (proc :pointer) (refCon :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm profileSet proc refCon ((+ (ash 12 16) 18) :signed-longint)))

; 
;  *  CMMNewLinkProfile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_CMMNewLinkProfile" 
      ((cmm :cmmcomponentinst) (prof (:pointer :pointer)) (targetLocation (:pointer :cmprofilelocation)) (profileSet (:pointer :cmconcatprofileset)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm prof targetLocation profileSet ((+ (ash 12 16) 16) :signed-longint)))

; 
;  *  NCMMNewLinkProfile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_NCMMNewLinkProfile" 
      ((cmm :cmmcomponentinst) (prof :pointer) (profileSet (:pointer :ncmconcatprofileset)) (proc :pointer) (refCon :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm prof profileSet proc refCon ((+ (ash 16 16) 19) :signed-longint)))

; 
;  *  CMMGetPS2ColorSpace()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CMMGetPS2ColorSpace" 
      ((cmm :cmmcomponentinst) (srcProf :pointer) (flags :unsigned-long) (proc :pointer) (refCon :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm srcProf flags proc refCon ((+ (ash 16 16) 11) :signed-longint)))

; 
;  *  CMMGetPS2ColorRenderingIntent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CMMGetPS2ColorRenderingIntent" 
      ((cmm :cmmcomponentinst) (srcProf :pointer) (flags :unsigned-long) (proc :pointer) (refCon :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm srcProf flags proc refCon ((+ (ash 16 16) 12) :signed-longint)))

; 
;  *  CMMGetPS2ColorRendering()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CMMGetPS2ColorRendering" 
      ((cmm :cmmcomponentinst) (srcProf :pointer) (dstProf :pointer) (flags :unsigned-long) (proc :pointer) (refCon :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm srcProf dstProf flags proc refCon ((+ (ash 20 16) 13) :signed-longint)))

; 
;  *  CMMGetPS2ColorRenderingVMSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CMMGetPS2ColorRenderingVMSize" 
      ((cmm :cmmcomponentinst) (srcProf :pointer) (dstProf :pointer) (vmSize (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm srcProf dstProf vmSize ((+ (ash 12 16) 17) :signed-longint)))

; 
;  *  CMMConcatenateProfiles()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CMMConcatenateProfiles" 
      ((cmm :cmmcomponentinst) (thru (:handle :cmprofile)) (dst (:handle :cmprofile)) (newDst (:pointer (:handle :cmprofile))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm thru dst newDst ((+ (ash 12 16) 5) :signed-longint)))

; 
;  *  CMMGetNamedColorInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CMMGetNamedColorInfo" 
      ((cmm :cmmcomponentinst) (srcProf :pointer) (deviceChannels (:pointer :unsigned-long)) (deviceColorSpace (:pointer :ostype)) (PCSColorSpace (:pointer :ostype)) (count (:pointer :unsigned-long)) (prefix (:pointer (:string 255))) (suffix (:pointer (:string 255))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm srcProf deviceChannels deviceColorSpace PCSColorSpace count prefix suffix ((+ (ash 28 16) 70) :signed-longint)))

; 
;  *  CMMGetNamedColorValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CMMGetNamedColorValue" 
      ((cmm :cmmcomponentinst) (prof :pointer) (name (:pointer (:string 255))) (deviceColor (:pointer :cmcolor)) (PCSColor (:pointer :cmcolor)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm prof name deviceColor PCSColor ((+ (ash 16 16) 71) :signed-longint)))

; 
;  *  CMMGetIndNamedColorValue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CMMGetIndNamedColorValue" 
      ((cmm :cmmcomponentinst) (prof :pointer) (index :unsigned-long) (deviceColor (:pointer :cmcolor)) (PCSColor (:pointer :cmcolor)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm prof index deviceColor PCSColor ((+ (ash 16 16) 72) :signed-longint)))

; 
;  *  CMMGetNamedColorIndex()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CMMGetNamedColorIndex" 
      ((cmm :cmmcomponentinst) (prof :pointer) (name (:pointer (:string 255))) (index (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm prof name index ((+ (ash 12 16) 73) :signed-longint)))

; 
;  *  CMMGetNamedColorName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CMMGetNamedColorName" 
      ((cmm :cmmcomponentinst) (prof :pointer) (index :unsigned-long) (name (:pointer (:string 255))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 cmm prof index name ((+ (ash 12 16) 74) :signed-longint)))

; $ENDC                                         ; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC; TARGET_API_MAC_OS8

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CMMComponentIncludes

; $ENDC                                         ; __CMMCOMPONENT__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'CMMComponent)#|
; Warning: Did not recognize these types or records: (cmmcomponentinst)
|#