(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CMPRComponent.p"
; at Wednesday May 1,2002 2:41:13 pm.
; 
;      File:       CMPRComponent.p
;  
;      Contains:   ColorSync ProfileResponder Component API
;  
;      Version:    Technology: ColorSync 1.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1993-2001 by Apple Computer, Inc. All rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __CMPRCOMPONENT__
; $SETC __CMPRCOMPONENT__ := 1

; $I+
; $SETC CMPRComponentIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __COMPONENTS__
|#

(require-interface 'Components)
#|                                              ; $I Components.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CMAPPLICATION__
|#

(require-interface 'CMApplication)
#|                                              ; $I CMApplication.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $CMPRInterfaceVersion 0)

; 	 Component function selectors 	
(defconstant $kCMPRGetProfile 0)
(defconstant $kCMPRSetProfile 1)
(defconstant $kCMPRSetProfileDescription 2)
(defconstant $kCMPRGetIndexedProfile 3)
(defconstant $kCMPRDeleteDeviceProfile 4)

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  CMGetProfile()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in ColorSyncLibPriv 2.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_CMGetProfile" 
      ((pr (:pointer :componentinstancerecord)) (aProfile (:handle :cmprofile)) (returnedProfile (:pointer (:handle :cmprofile))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 pr aProfile returnedProfile ((+ (ash 8 16) 0) :signed-longint)))

; 
;  *  CMSetProfile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ColorSyncLibPriv 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CMSetProfile" 
      ((pr (:pointer :componentinstancerecord)) (newProfile (:handle :cmprofile)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 pr newProfile ((+ (ash 4 16) 1) :signed-longint)))

; 
;  *  CMSetProfileDescription()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ColorSyncLibPriv 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CMSetProfileDescription" 
      ((pr (:pointer :componentinstancerecord)) (DeviceData :signed-long) (hProfile (:handle :cmprofile)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 pr DeviceData hProfile ((+ (ash 8 16) 2) :signed-longint)))

; 
;  *  CMGetIndexedProfile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ColorSyncLibPriv 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CMGetIndexedProfile" 
      ((pr (:pointer :componentinstancerecord)) (search (:handle :cmprofilesearchrecord)) (returnProfile (:pointer (:handle :cmprofile))) (index (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 pr search returnProfile index ((+ (ash 12 16) 3) :signed-longint)))

; 
;  *  CMDeleteDeviceProfile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ColorSyncLibPriv 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CMDeleteDeviceProfile" 
      ((pr (:pointer :componentinstancerecord)) (deleteMe (:handle :cmprofile)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 pr deleteMe ((+ (ash 4 16) 4) :signed-longint)))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CMPRComponentIncludes

; $ENDC                                         ; __CMPRCOMPONENT__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'CMPRComponent)