(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CMScriptingPlugin.p"
; at Wednesday May 1,2002 2:40:45 pm.
; 
;      File:       CMScriptingPlugin.p
;  
;      Contains:   ColorSync Scripting Plugin API
;  
;      Version:    Technology: ColorSync 2.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1998-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __CMSCRIPTINGPLUGIN__
; $SETC __CMSCRIPTINGPLUGIN__ := 1

; $I+
; $SETC CMScriptingPluginIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CMAPPLICATION__
|#

(require-interface 'CMApplication)
#|                                              ; $I CMApplication.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;   ColorSync Scripting AppleEvent Errors  
(defconstant $cmspInvalidImageFile -4220)       ;   Plugin cannot handle this image file type  
(defconstant $cmspInvalidImageSpace -4221)      ;   Plugin cannot create an image file of this colorspace  
(defconstant $cmspInvalidProfileEmbed -4222)    ;   Specific invalid profile errors  
(defconstant $cmspInvalidProfileSource -4223)
(defconstant $cmspInvalidProfileDest -4224)
(defconstant $cmspInvalidProfileProof -4225)
(defconstant $cmspInvalidProfileLink -4226)

; 	*** embedFlags field  ***	
; 	 reserved for future use: currently 0 	

; 	*** matchFlags field  ***	
(defconstant $cmspFavorEmbeddedMask #x1)        ;   if bit 0 is 0 then use srcProf profile, if 1 then use profile embedded in image if present 

; 	*** scripting plugin entry points  ***	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ValidateImageProcPtr = FUNCTION({CONST}VAR spec: FSSpec): CMError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :validateimageprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	GetImageSpaceProcPtr = FUNCTION({CONST}VAR spec: FSSpec; VAR space: OSType): CMError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :getimagespaceprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ValidateSpaceProcPtr = FUNCTION({CONST}VAR spec: FSSpec; VAR space: OSType): CMError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :validatespaceprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	EmbedImageProcPtr = FUNCTION({CONST}VAR specFrom: FSSpec; {CONST}VAR specInto: FSSpec; embedProf: CMProfileRef; embedFlags: UInt32): CMError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :embedimageprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	UnembedImageProcPtr = FUNCTION({CONST}VAR specFrom: FSSpec; {CONST}VAR specInto: FSSpec): CMError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :unembedimageprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	MatchImageProcPtr = FUNCTION({CONST}VAR specFrom: FSSpec; {CONST}VAR specInto: FSSpec; qual: UInt32; srcIntent: UInt32; srcProf: CMProfileRef; dstProf: CMProfileRef; prfProf: CMProfileRef; matchFlags: UInt32): CMError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :matchimageprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	CountImageProfilesProcPtr = FUNCTION({CONST}VAR spec: FSSpec; VAR count: UInt32): CMError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :countimageprofilesprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	GetIndImageProfileProcPtr = FUNCTION({CONST}VAR spec: FSSpec; index: UInt32; VAR prof: CMProfileRef): CMError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :getindimageprofileprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SetIndImageProfileProcPtr = FUNCTION({CONST}VAR specFrom: FSSpec; {CONST}VAR specInto: FSSpec; index: UInt32; prof: CMProfileRef; embedFlags: UInt32): CMError; C;

|#
 |#                                             ; $ELSEC
(def-mactype :setindimageprofileprocptr (find-mactype ':pointer))
; $ENDC

; 	*** CSScriptingLib API  ***	

; 
; 	 *  CMValidImage()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in CSScriptingLib 2.6 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in 3.0 and later
; 	 	
; CONST
(deftrap-inline "_CMValidImage" 
      ((spec (:pointer :fsspec))) 
  :signed-long
   () )

; 
;  *  CMGetImageSpace()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CSScriptingLib 2.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in 3.0 and later
;  
; CONST
(deftrap-inline "_CMGetImageSpace" 
      ((spec (:pointer :fsspec)) (space (:pointer :ostype))) 
  :signed-long
   () )

; 
;  *  CMEmbedImage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CSScriptingLib 2.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in 3.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_CMEmbedImage" 
      ((specFrom (:pointer :fsspec)) (specInto (:pointer :fsspec)) (repl :boolean) (embProf :pointer)) 
  :signed-long
   () )

; 
;  *  CMUnembedImage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CSScriptingLib 2.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in 3.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_CMUnembedImage" 
      ((specFrom (:pointer :fsspec)) (specInto (:pointer :fsspec)) (repl :boolean)) 
  :signed-long
   () )

; 
;  *  CMMatchImage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CSScriptingLib 2.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in 3.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_CMMatchImage" 
      ((specFrom (:pointer :fsspec)) (specInto (:pointer :fsspec)) (repl :boolean) (qual :unsigned-long) (srcProf :pointer) (srcIntent :unsigned-long) (dstProf :pointer)) 
  :signed-long
   () )

; 
;  *  CMProofImage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CSScriptingLib 2.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in 3.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_CMProofImage" 
      ((specFrom (:pointer :fsspec)) (specInto (:pointer :fsspec)) (repl :boolean) (qual :unsigned-long) (srcProf :pointer) (srcIntent :unsigned-long) (dstProf :pointer) (prfProf :pointer)) 
  :signed-long
   () )

; 
;  *  CMLinkImage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CSScriptingLib 2.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in 3.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_CMLinkImage" 
      ((specFrom (:pointer :fsspec)) (specInto (:pointer :fsspec)) (repl :boolean) (qual :unsigned-long) (lnkProf :pointer) (lnkIntent :unsigned-long)) 
  :signed-long
   () )

; 
;  *  CMCountImageProfiles()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CSScriptingLib 2.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in 3.0 and later
;  
; CONST
(deftrap-inline "_CMCountImageProfiles" 
      ((spec (:pointer :fsspec)) (count (:pointer :unsigned-long))) 
  :signed-long
   () )

; 
;  *  CMGetIndImageProfile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CSScriptingLib 2.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in 3.0 and later
;  
; CONST
(deftrap-inline "_CMGetIndImageProfile" 
      ((spec (:pointer :fsspec)) (index :unsigned-long) (prof (:pointer :pointer))) 
  :signed-long
   () )

; 
;  *  CMSetIndImageProfile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CSScriptingLib 2.6 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in 3.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_CMSetIndImageProfile" 
      ((specFrom (:pointer :fsspec)) (specInto (:pointer :fsspec)) (repl :boolean) (index :unsigned-long) (prof :pointer)) 
  :signed-long
   () )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CMScriptingPluginIncludes

; $ENDC                                         ; __CMSCRIPTINGPLUGIN__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'CMScriptingPlugin)