(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CRMSerialDevices.p"
; at Wednesday May 1,2002 2:41:17 pm.
; 
;      File:       CRMSerialDevices.p
;  
;      Contains:   Communications Resource Manager Serial Device interfaces.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1988-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __CRMSERIALDEVICES__
; $SETC __CRMSERIALDEVICES__ := 1

; $I+
; $SETC CRMSerialDevicesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; $IFC CALL_NOT_IN_CARBON 

;      for the crmDeviceType field of the CRMRec data structure   
(defconstant $crmSerialDevice 1)                ;      version of the CRMSerialRecord below    
(defconstant $curCRMSerRecVers 1)

; 	 Maintains compatibility w/ apps & tools that expect an old style icon    	

(def-mactype :crmiconrecordptr (find-mactype '(:pointer :crmiconrecord)))
(defrecord CRMIconRecord 
   (oldIcon (:array :signed-long 32))           ;   ICN#    
   (oldMask (:array :signed-long 32))
   (theSuite :handle)                           ;   Handle to an IconSuite  
   (reserved :signed-long)
   )

(def-mactype :crmiconptr (find-mactype '(:pointer :crmiconrecord)))
(def-mactype :crmiconhandle (find-mactype '(:handle :crmiconrecord)))
(def-mactype :crmserialrecordptr (find-mactype '(:pointer :crmserialrecord)))
(defrecord CRMSerialRecord 
   (version :signed-integer)
   (inputDriverName (:handle (:string 255)))
   (outputDriverName (:handle (:string 255)))
   (name (:handle (:string 255)))
   (deviceIcon (:handle :crmiconrecord))
   (ratedSpeed :signed-long)
   (maxSpeed :signed-long)
   (reserved :signed-long)
   )

(def-mactype :crmserialptr (find-mactype '(:pointer :crmserialrecord)))
; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CRMSerialDevicesIncludes

; $ENDC                                         ; __CRMSERIALDEVICES__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'CRMSerialDevices)