(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:ConnectionTools.p"
; at Wednesday May 1,2002 2:41:16 pm.
; 
;      File:       ConnectionTools.p
;  
;      Contains:   Communications Toolbox Connection Tools Interfaces.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1988-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __CONNECTIONTOOLS__
; $SETC __CONNECTIONTOOLS__ := 1

; $I+
; $SETC ConnectionToolsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __DIALOGS__
|#

(require-interface 'Dialogs)
#|                                              ; $I Dialogs.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CONNECTIONS__
|#

(require-interface 'Connections)
#|                                              ; $I Connections.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; $IFC CALL_NOT_IN_CARBON 

;   messages for DefProc  
(defconstant $cmInitMsg 0)
(defconstant $cmDisposeMsg 1)
(defconstant $cmSuspendMsg 2)
(defconstant $cmResumeMsg 3)
(defconstant $cmMenuMsg 4)
(defconstant $cmEventMsg 5)
(defconstant $cmActivateMsg 6)
(defconstant $cmDeactivateMsg 7)
(defconstant $cmIdleMsg 50)
(defconstant $cmResetMsg 51)
(defconstant $cmAbortMsg 52)
(defconstant $cmReadMsg 100)
(defconstant $cmWriteMsg 101)
(defconstant $cmStatusMsg 102)
(defconstant $cmListenMsg 103)
(defconstant $cmAcceptMsg 104)
(defconstant $cmCloseMsg 105)
(defconstant $cmOpenMsg 106)
(defconstant $cmBreakMsg 107)
(defconstant $cmIOKillMsg 108)
(defconstant $cmEnvironsMsg 109)                ;   new connection tool messages for ctb 1.1  
(defconstant $cmNewIOPBMsg 110)
(defconstant $cmDisposeIOPBMsg 111)
(defconstant $cmGetErrorStringMsg 112)
(defconstant $cmPBReadMsg 113)
(defconstant $cmPBWriteMsg 114)
(defconstant $cmPBIOKillMsg 115)

;      messages for validate DefProc   
(defconstant $cmValidateMsg 0)
(defconstant $cmDefaultMsg 1)

;      messages for Setup DefProc  
(defconstant $cmSpreflightMsg 0)
(defconstant $cmSsetupMsg 1)
(defconstant $cmSitemMsg 2)
(defconstant $cmSfilterMsg 3)
(defconstant $cmScleanupMsg 4)

;      messages for scripting defProc  
(defconstant $cmMgetMsg 0)
(defconstant $cmMsetMsg 1)

;      messages for localization defProc   
(defconstant $cmL2English 0)
(defconstant $cmL2Intl 1)

;   private data constants  
(defconstant $cdefType :|cdef|)                 ;   main connection definition procedure  
(defconstant $cvalType :|cval|)                 ;   validation definition procedure  
(defconstant $csetType :|cset|)                 ;   connection setup definition procedure  
(defconstant $clocType :|cloc|)                 ;   connection configuration localization defProc  
(defconstant $cscrType :|cscr|)                 ;   connection scripting defProc interfaces  
(defconstant $cbndType :|cbnd|)                 ;   bundle type for connection  
(defconstant $cverType :|vers|)

(def-mactype :cmdatabufferptr (find-mactype '(:pointer :cmdatabuffer)))
(defrecord CMDataBuffer 
   (thePtr :pointer)
   (count :signed-long)
   (channel :signed-integer)
   (flags :unsigned-integer)
   )

(def-mactype :cmcompletorrecordptr (find-mactype '(:pointer :cmcompletorrecord)))
(defrecord CMCompletorRecord 
   (async :boolean)
   (filler :signed-byte)
   (completionRoutine :pointer)
   )

(def-mactype :cmcompletorptr (find-mactype '(:pointer :cmcompletorrecord)))
; 	  Private Data Structure  	
(def-mactype :cmsetupstructptr (find-mactype '(:pointer :cmsetupstruct)))
(defrecord CMSetupStruct 
   (theDialog (:pointer :grafport))
   (count :signed-integer)
   (theConfig :pointer)
   (procID :signed-integer)                     ;   procID of the tool  
   )

(def-mactype :cmsetupptr (find-mactype '(:pointer :cmsetupstruct)))
; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := ConnectionToolsIncludes

; $ENDC                                         ; __CONNECTIONTOOLS__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'ConnectionTools)