(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:ControlStrip.p"
; at Wednesday May 1,2002 2:41:17 pm.
; 
;      File:       ControlStrip.p
;  
;      Contains:   Control Strip (for Powerbooks and Duos) Interfaces.
;  
;      Version:    Technology: ControlStrip 1.4
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1992-2001 by Apple Computer, Inc. All rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __CONTROLSTRIP__
; $SETC __CONTROLSTRIP__ := 1

; $I+
; $SETC ControlStripIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MENUS__
|#

(require-interface 'Menus)
#|                                              ; $I Menus.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __DIALOGS__
|#

(require-interface 'Dialogs)
#|                                              ; $I Dialogs.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; ********************************************************************************************
; 
;     messages passed to the modules
; 
; ********************************************************************************************

(defconstant $sdevInitModule 0)                 ;   initialize the module 
(defconstant $sdevCloseModule 1)                ;   clean up before being closed 
(defconstant $sdevFeatures 2)                   ;   return feature bits 
(defconstant $sdevGetDisplayWidth 3)            ;   returns the width of the module's display 
(defconstant $sdevPeriodicTickle 4)             ;   periodic tickle when nothing else is happening 
(defconstant $sdevDrawStatus 5)                 ;   update the interface in the Control Strip 
(defconstant $sdevMouseClick 6)                 ;   user clicked on the module's display area in the Control Strip 
(defconstant $sdevSaveSettings 7)               ;   saved any changed settings in module's preferences file 
(defconstant $sdevShowBalloonHelp 8)            ;   puts up a help balloon, if the module has one to display 

; 	********************************************************************************************
; 	
; 	    Features supported by the module.  If a bit is set, it means that feature is supported.
; 	    All undefined bits are reserved for future use by Apple, and should be set to zero.
; 	
; 	********************************************************************************************	
(defconstant $sdevWantMouseClicks 0)            ;   notify the module of mouseDown events 
(defconstant $sdevDontAutoTrack 1)              ;   call the module to do mouse tracking 
(defconstant $sdevHasCustomHelp 2)              ;   module provides its own help messages 
(defconstant $sdevKeepModuleLocked 3)           ;   module needs to be locked in the heap 

; 	********************************************************************************************
; 	
; 	    Result values returned by the sdevPeriodicTickle and sdevIconMouseClick selectors.
; 	    If a bit is set, the module can request that a specific function is performed by
; 	    the Control Strip.  A result of zero will do nothing.  All undefined bits are reserved
; 	    for future use by Apple, and should be set to zero.
; 	
; 	********************************************************************************************	
(defconstant $sdevResizeDisplay 0)              ;   resize the module's display 
(defconstant $sdevNeedToSave 1)                 ;   need to save changed settings, when convenient 
(defconstant $sdevHelpStateChange 2)            ;   need to update the help message because of a state change 
(defconstant $sdevCloseNow 3)                   ;   close a module because it doesn't want to stay around 

; 	********************************************************************************************
; 	
; 	    miscellaneous
; 	
; 	********************************************************************************************	
(defconstant $sdevFileType :|sdev|)             ;   module's file type 

(defconstant $sdevMenuItemMark #xA5)            ;   ԥ: checkmark to use in popup menus 

;    direction values for SBDrawBarGraph 

(defconstant $BarGraphSlopeLeft -1)             ;   max end of sloping bar graph is on the left 
(defconstant $BarGraphFlatRight 0)              ;   max end of flat bar graph is on the right 
(defconstant $BarGraphSlopeRight 1)             ;   max end of sloping bar graph is on the right 

; 	********************************************************************************************
; 	
; 	    utility routines to provide standard interface elements and support for common functions
; 	
; 	********************************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  SBIsControlStripVisible()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in ControlStripLib 1.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_SBIsControlStripVisible" 
      ()
   (:stack :boolean)
   (:stack-trap #xAAF2 :d0 0))

; 
;  *  SBShowHideControlStrip()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlStripLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SBShowHideControlStrip" 
      ((showIt :boolean))
   nil
   (:stack-trap #xAAF2 :d0 257 showIt))

; 
;  *  SBSafeToAccessStartupDisk()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlStripLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SBSafeToAccessStartupDisk" 
      ()
   (:stack :boolean)
   (:stack-trap #xAAF2 :d0 2))

; 
;  *  SBOpenModuleResourceFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlStripLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SBOpenModuleResourceFile" 
      ((fileCreator :ostype))
   (:stack :signed-integer)
   (:stack-trap #xAAF2 :d0 515 fileCreator))

; 
;  *  SBLoadPreferences()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlStripLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SBLoadPreferences" 
      ((prefsResourceName (:string 255)) (preferences (:pointer :handle)))
   (:stack :signed-integer)
   (:stack-trap #xAAF2 :d0 1028 prefsResourceName preferences))

; 
;  *  SBSavePreferences()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlStripLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SBSavePreferences" 
      ((prefsResourceName (:string 255)) (preferences :handle))
   (:stack :signed-integer)
   (:stack-trap #xAAF2 :d0 1029 prefsResourceName preferences))

; 
;  *  SBGetDetachedIndString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlStripLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SBGetDetachedIndString" 
      ((theString (:pointer (:string 255))) (stringList :handle) (whichString :signed-integer))
   nil
   (:stack-trap #xAAF2 :d0 1286 theString stringList whichString))

; 
;  *  SBGetDetachIconSuite()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlStripLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SBGetDetachIconSuite" 
      ((theIconSuite (:pointer :handle)) (theResID :signed-integer) (selector :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xAAF2 :d0 1287 theIconSuite theResID selector))

; 
;  *  SBTrackPopupMenu()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlStripLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_SBTrackPopupMenu" 
      ((moduleRect (:pointer :rect)) (theMenu (:handle :menuinfo)))
   (:stack :signed-integer)
   (:stack-trap #xAAF2 :d0 1032 moduleRect theMenu))

; 
;  *  SBTrackSlider()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlStripLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_SBTrackSlider" 
      ((moduleRect (:pointer :rect)) (ticksOnSlider :signed-integer) (initialValue :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xAAF2 :d0 1033 moduleRect ticksOnSlider initialValue))

; 
;  *  SBShowHelpString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlStripLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_SBShowHelpString" 
      ((moduleRect (:pointer :rect)) (helpString (:pointer (:string 255))))
   (:stack :signed-integer)
   (:stack-trap #xAAF2 :d0 1034 moduleRect helpString))

; 
;  *  SBGetBarGraphWidth()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlStripLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SBGetBarGraphWidth" 
      ((barCount :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xAAF2 :d0 267 barCount))

; 
;  *  SBDrawBarGraph()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlStripLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SBDrawBarGraph" 
      ((level :signed-integer) (barCount :signed-integer) (direction :signed-integer) (barGraphTopLeft :point))
   nil
   (:stack-trap #xAAF2 :d0 1292 level barCount direction barGraphTopLeft))

; 
;  *  SBModalDialogInContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlStripLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SBModalDialogInContext" 
      ((filterProc :pointer) (itemHit (:pointer :signed-integer)))
   nil
   (:stack-trap #xAAF2 :d0 1037 filterProc itemHit))

;  The following routines are available in Control Strip 1.2 and later. 
; 
;  *  SBGetControlStripFontID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlStripLib 1.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SBGetControlStripFontID" 
      ((fontID (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xAAF2 :d0 526 fontID))

; 
;  *  SBSetControlStripFontID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlStripLib 1.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SBSetControlStripFontID" 
      ((fontID :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xAAF2 :d0 271 fontID))

; 
;  *  SBGetControlStripFontSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlStripLib 1.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SBGetControlStripFontSize" 
      ((fontSize (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xAAF2 :d0 528 fontSize))

; 
;  *  SBSetControlStripFontSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlStripLib 1.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SBSetControlStripFontSize" 
      ((fontSize :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xAAF2 :d0 273 fontSize))

; 
;  *  SBGetShowHideHotKey()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlStripLib 1.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SBGetShowHideHotKey" 
      ((modifiers (:pointer :signed-integer)) (keyCode (:pointer :unsigned-byte)))
   (:stack :signed-integer)
   (:stack-trap #xAAF2 :d0 1042 modifiers keyCode))

; 
;  *  SBSetShowHideHotKey()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlStripLib 1.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SBSetShowHideHotKey" 
      ((modifiers :signed-integer) (keyCode :signed-byte))
   (:stack :signed-integer)
   (:stack-trap #xAAF2 :d0 531 modifiers keyCode))

; 
;  *  SBIsShowHideHotKeyEnabled()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlStripLib 1.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SBIsShowHideHotKeyEnabled" 
      ((enabled (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xAAF2 :d0 532 enabled))

; 
;  *  SBEnableShowHideHotKey()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlStripLib 1.2 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SBEnableShowHideHotKey" 
      ((enabled :boolean))
   (:stack :signed-integer)
   (:stack-trap #xAAF2 :d0 277 enabled))

;  The following routines are available in Control Strip 1.4 and later. 
; 
;  *  SBHitTrackSlider()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ControlStripLib 1.4 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_SBHitTrackSlider" 
      ((moduleRect (:pointer :rect)) (ticksOnSlider :signed-integer) (initialValue :signed-integer) (hit (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xAAF2 :d0 1558 moduleRect ticksOnSlider initialValue hit))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := ControlStripIncludes

; $ENDC                                         ; __CONTROLSTRIP__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'ControlStrip)