(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:CryptoMessageSyntax.p"
; at Wednesday May 1,2002 2:41:17 pm.
; 
;      File:       CryptoMessageSyntax.p
;  
;      Contains:   CMS Interfaces.
;  
;      Version:    Technology: 1.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1999-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __CRYPTOMESSAGESYNTAX__
; $SETC __CRYPTOMESSAGESYNTAX__ := 1

; $I+
; $SETC CryptoMessageSyntaxIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CODEFRAGMENTS__
|#

(require-interface 'CodeFragments)
#|                                              ; $I CodeFragments.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __EVENTS__
|#

(require-interface 'Events)
#|                                              ; $I Events.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;     Data structures and types
; 

(def-mactype :sectyperef (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :sectyperefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:SecTypeRef parameter can be nil, it is changed to xx: SecTypeRefPtr 
(def-mactype :secsignerref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :secsignerrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:SecSignerRef parameter can be nil, it is changed to xx: SecSignerRefPtr 
; 	 Signer object manipulation 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  SecSignerGetStatus()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in CMSLib 1.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; 
;  *  SecRetain()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CMSLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SecSignerGetStatus" 
      ((signer :pointer)) 
  :osstatus
   () )                                         ; 
;  *  SecRelease()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CMSLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SecRetain" 
      ((sec :pointer)) 
  :pointer
   () )                                         ; 
;  *  SecRetainCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CMSLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SecRelease" 
      ((sec :pointer)) 
  nil
   () )                                         ;  Errors Codes  
(deftrap-inline "_SecRetainCount" 
      ((sec :pointer)) 
  :unsigned-long
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

(defconstant $errSecUnsupported -13843)
(defconstant $errSecInvalidData -13844)
(defconstant $errSecTooMuchData -13845)
(defconstant $errSecMissingData -13846)
(defconstant $errSecNoSigners -13847)
(defconstant $errSecSignerFailed -13848)
(defconstant $errSecInvalidPolicy -13849)
(defconstant $errSecUnknownPolicy -13850)
(defconstant $errSecInvalidStopOn -13851)
(defconstant $errSecMissingCert -13852)
(defconstant $errSecInvalidCert -13853)
(defconstant $errSecNotSigner -13854)
(defconstant $errSecNotTrusted -13855)
(defconstant $errSecMissingAttribute -13856)
(defconstant $errSecMissingDigest -13857)
(defconstant $errSecDigestMismatch -13858)
(defconstant $errSecInvalidSignature -13859)
(defconstant $errSecAlgMismatch -13860)
(defconstant $errSecUnsupportedAlgorithm -13864)
(defconstant $errSecContentTypeMismatch -13865)
(defconstant $errSecDebugRoot -13866)

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := CryptoMessageSyntaxIncludes

; $ENDC                                         ; __CRYPTOMESSAGESYNTAX__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'CryptoMessageSyntax)