(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:DeskBus.p"
; at Wednesday May 1,2002 2:41:18 pm.
; 
;      File:       DeskBus.p
;  
;      Contains:   Apple Desktop Bus (ADB) Interfaces.
;  
;      Version:    Technology: System 8.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1987-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __DESKBUS__
; $SETC __DESKBUS__ := 1

; $I+
; $SETC DeskBusIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; $IFC TARGET_OS_MAC 

(def-mactype :adbaddress (find-mactype ':signed-byte))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ADBCompletionProcPtr = PROCEDURE(buffer: Ptr; refCon: Ptr; command: LONGINT);

|#
 |#                                             ; $ELSEC
(def-mactype :adbcompletionprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ADBDeviceDriverProcPtr = PROCEDURE(devAddress: SInt8; devType: SInt8);

|#
 |#                                             ; $ELSEC
(def-mactype :adbdevicedriverprocptr (find-mactype ':pointer))
; $ENDC

; 	
; 	    TempADBServiceRoutineUPP is needed because of circular definition of
; 	    ADBServiceRoutineProcPtr and ADBServiceRoutineUPP depending on each other.
; 		
(def-mactype :tempadbserviceroutineupp (find-mactype ':pointer))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ADBServiceRoutineProcPtr = PROCEDURE(buffer: Ptr; completionProc: TempADBServiceRoutineUPP; refCon: Ptr; command: LONGINT);

|#
 |#                                             ; $ELSEC
(def-mactype :adbserviceroutineprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ADBInitProcPtr = PROCEDURE(callOrder: SInt8);

|#
 |#                                             ; $ELSEC
(def-mactype :adbinitprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :adbcompletionupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :adbcompletionupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :adbdevicedriverupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :adbdevicedriverupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :adbserviceroutineupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :adbserviceroutineupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :adbinitupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :adbinitupp (find-mactype ':pointer))
; $ENDC
(def-mactype :adbdatablockptr (find-mactype '(:pointer :adbdatablock)))
(defrecord ADBDataBlock 
   (devType :signed-byte)                       ;   original handler ID  
   (origADBAddr :signed-byte)                   ;   original ADB Address  
   (dbServiceRtPtr :pointer)                    ;   service routine pointer  
   (dbDataAreaAddr :pointer)                    ;   this field is passed as the refCon parameter to the service routine  
   )

(def-mactype :adbdblkptr (find-mactype '(:pointer :adbdatablock)))
(def-mactype :adbsetinfoblockptr (find-mactype '(:pointer :adbsetinfoblock)))
(defrecord ADBSetInfoBlock 
   (siService :pointer)                         ;   service routine pointer  
   (siDataAreaAddr :pointer)                    ;   this field is passed as the refCon parameter to the service routine  
   )

(def-mactype :adbsinfoptr (find-mactype '(:pointer :adbsetinfoblock)))
; 	 ADBOpBlock is only used when calling ADBOp from 68k assembly code 	
(def-mactype :adbopblockptr (find-mactype '(:pointer :adbopblock)))
(defrecord ADBOpBlock 
   (dataBuffPtr :pointer)                       ;   buffer: pointer to variable length data buffer  
   (opServiceRtPtr :pointer)                    ;   completionProc: completion routine pointer  
   (opDataAreaPtr :pointer)                     ;   refCon: this field is passed as the refCon parameter to the completion routine  
   )

(def-mactype :adbopbptr (find-mactype '(:pointer :adbopblock)))
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  ADBReInit()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_ADBReInit" 
      ()
   nil
   (:stack-trap #xA07B))

; 
;     ADBOp has a different interface for 68k assembly than for everything else
;     for 68k assembly the interface is 
;     #pragma parameter __D0 ADBOp(__A0,__D0)
;     OSErr ADBOp( ADBOpBlock * pb, short commandNum );
; 
; 
;     IMPORTANT NOTE:
;     "Inside Macintosh: Devices" documents the completion routine for ADBOp will be called with
;     four parameters using 68k register based calling conventions, specifically the completion routine
;     passed in should be of type ADBServiceRoutineProcPtr. However, when upp types were first added
;     to this interface file, the type ADBCompletionUPP was mistakenly used for the second parameter
;     to ADBOp. Since applications have shipped using completion routines of type ADBCompletionUPP,
;     the mistake cannot be corrected.
;     The only difference between ADBServiceRoutineUPP and ADBCompletionUPP is the former takes an extra
;     argument which is a pointer to itself, fortunately not needed for PowerPC code.
;     For compatibility with existing 68k code, when an ADBOp completion routine is called,
;     68k register A1 will point to the completion routine, as documented in Inside Mac.
; 
; $ENDC                                         ; CALL_NOT_IN_CARBON
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  ADBOp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ADBOp" 
      ((refCon :pointer) (compRout :pointer) (buffer :pointer) (commandNum :signed-integer)) 
  :signed-integer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  CountADBs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CountADBs" 
      () 
  :signed-integer
   (#xA077 #x3E80) )

; 
;  *  GetIndADB()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetIndADB" 
      ((info (:pointer :adbdatablock)) (devTableIndex :signed-integer)) 
  :adbaddress
   (#x301F #x205F #xA078 #x1E80) )

; 
;  *  GetADBInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetADBInfo" 
      ((info (:pointer :adbdatablock)) (adbAddr :signed-byte)) 
  :signed-integer
   (#x101F #x205F #xA079 #x3E80) )

; 
;  *  SetADBInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SetADBInfo" 
      ((info (:pointer :adbsetinfoblock)) (adbAddr :signed-byte)) 
  :signed-integer
   (#x101F #x205F #xA07A #x3E80) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $uppADBCompletionProcInfo #x7B9802)
(defconstant $uppADBDeviceDriverProcInfo #x50802)
(defconstant $uppADBServiceRoutineProcInfo #xF779802)
(defconstant $uppADBInitProcInfo #x802)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewADBCompletionUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewADBCompletionProc 
(deftrap "_NewADBCompletionUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewADBDeviceDriverUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewADBDeviceDriverProc 
(deftrap "_NewADBDeviceDriverUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewADBServiceRoutineUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewADBServiceRoutineProc 
(deftrap "_NewADBServiceRoutineUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewADBInitUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewADBInitProc 
(deftrap "_NewADBInitUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeADBCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeADBCompletionUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeADBDeviceDriverUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeADBDeviceDriverUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeADBServiceRoutineUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeADBServiceRoutineUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeADBInitUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeADBInitUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeADBCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallADBCompletionProc           ; 
;  *  InvokeADBDeviceDriverUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokeADBCompletionUPP" 
      ((buffer :pointer) (refCon :pointer) (command :signed-long) (userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallADBDeviceDriverProc ; 
;  *  InvokeADBServiceRoutineUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokeADBDeviceDriverUPP" 
      ((devAddress :signed-byte) (devType :signed-byte) (userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallADBServiceRoutineProc ; 
;  *  InvokeADBInitUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokeADBServiceRoutineUPP" 
      ((buffer :pointer) (completionProc :pointer) (refCon :pointer) (command :signed-long) (userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallADBInitProc 
(deftrap-inline "_InvokeADBInitUPP" 
      ((callOrder :signed-byte) (userRoutine :pointer)) 
  nil
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; $ENDC                                         ; TARGET_OS_MAC

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := DeskBusIncludes

; $ENDC                                         ; __DESKBUS__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'DeskBus)