(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:DeviceControl.p"
; at Wednesday May 1,2002 2:41:19 pm.
; 
;      File:       DeviceControl.p
;  
;      Contains:   Component API for doing AVC transactions.
;  
;      Version:    Technology: xxx put version here xxx
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1999-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __DEVICECONTROL__
; $SETC __DEVICECONTROL__ := 1

; $I+
; $SETC DeviceControlIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __COMPONENTS__
|#

(require-interface 'Components)
#|                                              ; $I Components.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DCResponseHandler = FUNCTION(fwCommandObjectID: UInt32; responseBuffer: Ptr; responseLength: UInt32): UInt32; C;

|#
 |#                                             ; $ELSEC
(def-mactype :dcresponsehandler (find-mactype ':pointer))
; $ENDC

(def-mactype :dvctransactionparamsptr (find-mactype '(:pointer :dvctransactionparams)))
(defrecord DVCTransactionParams 
   (commandBufferPtr :pointer)
   (commandLength :unsigned-long)
   (responseBufferPtr :pointer)
   (responseBufferSize :unsigned-long)
   (responseHandler (:pointer :pointer))
   )

; 
; 	 *  DeviceControlDoAVCTransaction()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in IDHLib 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.3 and later
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_DeviceControlDoAVCTransaction" 
      ((instance (:pointer :componentinstancerecord)) (params (:pointer :dvctransactionparams)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 instance params ((+ (ash 4 16) 1) :signed-longint)))

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := DeviceControlIncludes

; $ENDC                                         ; __DEVICECONTROL__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'DeviceControl)