(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Devices.p"
; at Wednesday May 1,2002 2:40:00 pm.
; 
;      File:       Devices.p
;  
;      Contains:   Device Manager Interfaces.
;  
;      Version:    Technology: Mac OS 8
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __DEVICES__
; $SETC __DEVICES__ := 1

; $I+
; $SETC DevicesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __OSUTILS__
|#

(require-interface 'OSUtils)
#|                                              ; $I OSUtils.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __NAMEREGISTRY__

(require-interface 'NameRegistry)               ; $I NameRegistry.p
; $ENDC
#|                                              ; $IFC UNDEFINED __CODEFRAGMENTS__
|#

(require-interface 'CodeFragments)
#|                                              ; $I CodeFragments.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MULTIPROCESSING__
|#

(require-interface 'Multiprocessing)
#|                                              ; $I Multiprocessing.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __DRIVERFAMILYMATCHING__

(require-interface 'DriverFamilyMatching)       ; $I DriverFamilyMatching.p
; $ENDC
; $IFC UNDEFINED __DISKS__

(require-interface 'Disks)                      ; $I Disks.p
; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  Values of the 'message' parameter to a Chooser device package 

(defconstant $chooserInitMsg 11)                ;   the user selected this device package  
(defconstant $newSelMsg 12)                     ;   the user made new device selections  
(defconstant $fillListMsg 13)                   ;   fill the device list with choices  
(defconstant $getSelMsg 14)                     ;   mark one or more choices as selected  
(defconstant $selectMsg 15)                     ;   the user made a selection  
(defconstant $deselectMsg 16)                   ;   the user canceled a selection  
(defconstant $terminateMsg 17)                  ;   allows device package to clean up  
(defconstant $buttonMsg 19)                     ;   the user selected a button  

; 	 Values of the 'caller' parameter to a Chooser device package 	
(defconstant $chooserID 1)

; 	 Values of the 'message' parameter to a Monitor 'mntr' 	
(defconstant $initMsg 1)                        ;  initialization 
(defconstant $okMsg 2)                          ;  user clicked OK button 
(defconstant $cancelMsg 3)                      ;  user clicked Cancel button 
(defconstant $hitMsg 4)                         ;  user clicked control in Options dialog 
(defconstant $nulMsg 5)                         ;  periodic event 
(defconstant $updateMsg 6)                      ;  update event 
(defconstant $activateMsg 7)                    ;  not used 
(defconstant $deactivateMsg 8)                  ;  not used 
(defconstant $keyEvtMsg 9)                      ;  keyboard event 
(defconstant $superMsg 10)                      ;  show superuser controls 
(defconstant $normalMsg 11)                     ;  show only normal controls 
(defconstant $startupMsg 12)                    ;  code has been loaded 

; 	 control codes for DeskAccessories 	
(defconstant $goodbye -1)                       ;   heap being reinitialized  
(defconstant $killCode 1)                       ;   KillIO requested  
(defconstant $accEvent 64)                      ;   handle an event  
(defconstant $accRun 65)                        ;   time for periodic action  
(defconstant $accCursor 66)                     ;   change cursor shape  
(defconstant $accMenu 67)                       ;   handle menu item  
(defconstant $accUndo 68)                       ;   handle undo command  
(defconstant $accCut 70)                        ;   handle cut command  
(defconstant $accCopy 71)                       ;   handle copy command  
(defconstant $accPaste 72)                      ;   handle paste command  
(defconstant $accClear 73)                      ;   handle clear command  

; 	 Control/Status Call Codes 	
; 	 drvStsCode, ejectCode and tgBuffCode are now defined in Disks.h/p/a 	

; 	 miscellaneous Device Manager constants 	
(defconstant $ioInProgress 1)                   ;   predefined value of ioResult while I/O is pending  
(defconstant $aRdCmd 2)                         ;   low byte of ioTrap for Read calls  
(defconstant $aWrCmd 3)                         ;   low byte of ioTrap for Write calls  
(defconstant $asyncTrpBit 10)                   ;   trap word modifier  
(defconstant $noQueueBit 9)                     ;   trap word modifier  

; 	 flags used in the driver header and device control entry 	
(defconstant $dReadEnable 0)                    ;   set if driver responds to read requests  
(defconstant $dWritEnable 1)                    ;   set if driver responds to write requests  
(defconstant $dCtlEnable 2)                     ;   set if driver responds to control requests  
(defconstant $dStatEnable 3)                    ;   set if driver responds to status requests  
(defconstant $dNeedGoodBye 4)                   ;   set if driver needs time for performing periodic tasks  
(defconstant $dNeedTime 5)                      ;   set if driver needs time for performing periodic tasks  
(defconstant $dNeedLock 6)                      ;   set if driver must be locked in memory as soon as it is opened  

(defconstant $dNeedLockMask #x4000)             ;   set if driver must be locked in memory as soon as it is opened  
(defconstant $dNeedTimeMask #x2000)             ;   set if driver needs time for performing periodic tasks  
(defconstant $dNeedGoodByeMask #x1000)          ;   set if driver needs to be called before the application heap is initialized  
(defconstant $dStatEnableMask #x800)            ;   set if driver responds to status requests  
(defconstant $dCtlEnableMask #x400)             ;   set if driver responds to control requests  
(defconstant $dWritEnableMask #x200)            ;   set if driver responds to write requests  
(defconstant $dReadEnableMask #x100)            ;   set if driver responds to read requests  

; 	 run-time flags used in the device control entry 	
(defconstant $dVMImmuneBit 0)                   ;   driver does not need VM protection  
(defconstant $dOpened 5)                        ;   driver is open  
(defconstant $dRAMBased 6)                      ;   dCtlDriver is a handle (1) or pointer (0)  
(defconstant $drvrActive 7)                     ;   driver is currently processing a request  

(defconstant $dVMImmuneMask #x1)                ;   driver does not need VM protection  
(defconstant $dOpenedMask #x20)                 ;   driver is open  
(defconstant $dRAMBasedMask #x40)               ;   dCtlDriver is a handle (1) or pointer (0)  
(defconstant $drvrActiveMask #x80)              ;   driver is currently processing a request  

(def-mactype :drvrheaderptr (find-mactype '(:pointer :drvrheader)))
(defrecord DRVRHeader 
   (drvrFlags :signed-integer)
   (drvrDelay :signed-integer)
   (drvrEMask :signed-integer)
   (drvrMenu :signed-integer)
   (drvrOpen :signed-integer)
   (drvrPrime :signed-integer)
   (drvrCtl :signed-integer)
   (drvrStatus :signed-integer)
   (drvrClose :signed-integer)
   ;;Changing field drvrname from signed-byte to unsigned-byte to match C header (educated-guess)
   (drvrName :unsigned-byte)
   )

(def-mactype :drvrheaderhandle (find-mactype '(:handle :drvrheader)))
(def-mactype :dctlentryptr (find-mactype '(:pointer :dctlentry)))
(defrecord (DCtlEntry :handle) 
   (dCtlDriver :pointer)
   (dCtlFlags :signed-integer)
   (dCtlQHdr :qhdr)
   (dCtlPosition :signed-long)
   (dCtlStorage :handle)
   (dCtlRefNum :signed-integer)
   (dCtlCurTicks :signed-long)
   (dCtlWindow (:pointer :grafport))
   (dCtlDelay :signed-integer)
   (dCtlEMask :signed-integer)
   (dCtlMenu :signed-integer)
   )

(def-mactype :dctlptr (find-mactype '(:pointer :dctlentry)))
(def-mactype :dctlhandle (find-mactype '(:handle :dctlentry)))
(def-mactype :auxdceptr (find-mactype '(:pointer :auxdce)))
(defrecord (AuxDCE :handle) 
   (dCtlDriver :pointer)
   (dCtlFlags :signed-integer)
   (dCtlQHdr :qhdr)
   (dCtlPosition :signed-long)
   (dCtlStorage :handle)
   (dCtlRefNum :signed-integer)
   (dCtlCurTicks :signed-long)
   (dCtlWindow (:pointer :grafport))
   (dCtlDelay :signed-integer)
   (dCtlEMask :signed-integer)
   (dCtlMenu :signed-integer)
   (dCtlSlot :signed-byte)
   (dCtlSlotId :signed-byte)
   (dCtlDevBase :signed-long)
   (dCtlOwner :pointer)
   (dCtlExtDev :signed-byte)
   (fillByte :signed-byte)
   (dCtlNodeID :unsigned-long)
   )

(def-mactype :auxdcehandle (find-mactype '(:handle :auxdce)))
; 	  The NDRV Driver IO Entry Point and Commands 	
(def-mactype :unitnumber (find-mactype ':unsigned-integer))
(def-mactype :driveropencount (find-mactype ':unsigned-long))
(def-mactype :driverrefnum (find-mactype ':signed-integer))
(def-mactype :driverflags (find-mactype ':signed-integer))
(def-mactype :iocommandcode (find-mactype ':unsigned-long))

(defconstant $kOpenCommand 0)
(defconstant $kCloseCommand 1)
(defconstant $kReadCommand 2)
(defconstant $kWriteCommand 3)
(defconstant $kControlCommand 4)
(defconstant $kStatusCommand 5)
(defconstant $kKillIOCommand 6)
(defconstant $kInitializeCommand 7)             ;   init driver and device 
(defconstant $kFinalizeCommand 8)               ;   shutdown driver and device 
(defconstant $kReplaceCommand 9)                ;   replace an old driver 
(defconstant $kSupersededCommand 10)            ;   prepare to be replaced by a new driver 
(defconstant $kSuspendCommand 11)               ;   prepare driver to go to sleep 
(defconstant $kResumeCommand 12)                ;   wake up sleeping driver 

;   one more IOCommandCode 
(defconstant $kPowerManagementCommand 13)       ;   power management command, supercedes kSuspendCommand and kResumeCommand 

(def-mactype :addressspaceid (find-mactype ':pointer))
(def-mactype :iocommandid (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :iocommandidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:IOCommandID parameter can be nil, it is changed to xx: IOCommandIDPtr 
(def-mactype :iocommandkind (find-mactype ':unsigned-long))

(defconstant $kSynchronousIOCommandKind #x1)
(defconstant $kAsynchronousIOCommandKind #x2)
(defconstant $kImmediateIOCommandKind #x4)

(def-mactype :driverinitinfoptr (find-mactype '(:pointer :driverinitinfo)))
(defrecord DriverInitInfo 
   (refNum :signed-integer)
   (deviceEntry :regentryid)
   )

(%define-record :driverreplaceinfo (find-record-descriptor :driverinitinfo))
(def-mactype :driverreplaceinfoptr (find-mactype '(:pointer :driverinitinfo)))
(def-mactype :driverfinalinfoptr (find-mactype '(:pointer :driverfinalinfo)))
(defrecord DriverFinalInfo 
   (refNum :signed-integer)
   (deviceEntry :regentryid)
   )

(%define-record :driversupersededinfo (find-record-descriptor :driverfinalinfo))
(def-mactype :driversupersededinfoptr (find-mactype '(:pointer :driverfinalinfo)))

;   Contents are command specific 

(def-mactype :iocommandcontentsptr (find-mactype '(:pointer :iocommandcontents)))
(defrecord IOCommandContents 
   (:variant 
      (
      (pb (:pointer :paramblockrec))
      )
      (
      (initialInfo (:pointer :driverinitinfo))
      )
      (
      (finalInfo (:pointer :driverfinalinfo))
      )
      (
      (replaceInfo (:pointer :driverinitinfo))
      )
      (
      (supersededInfo (:pointer :driverfinalinfo))
      )
      )
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DriverEntryPointPtr = FUNCTION(SpaceID: AddressSpaceID; CommandID: IOCommandID; Contents: IOCommandContents; Code: IOCommandCode; Kind: IOCommandKind): OSErr; C;

|#
 |#                                             ; $ELSEC
(def-mactype :driverentrypointptr (find-mactype ':pointer))
; $ENDC

; 	 Record to describe a file-based driver candidate 	
(def-mactype :filebaseddriverrecordptr (find-mactype '(:pointer :filebaseddriverrecord)))
(defrecord FileBasedDriverRecord 
   (theSpec :fsspec)                            ;   file specification 
   (theType :macdrivertype)                     ;   nameInfoStr + version number 
   (compatibleProp :boolean)                    ;   true if matched using a compatible name 
   (pad (:array :unsigned-byte 3 :packed))      ;   alignment 
   )

; 	 Detailed Record to describe a file-based driver candidate. Includes fragment name 	
(def-mactype :filebaseddriverdetailedptr (find-mactype '(:pointer :filebaseddriverdetailed)))
(defrecord FileBasedDriverDetailed 
   (fileBasedDriver :filebaseddriverrecord)
   (fragName (:string 63))
   )

; 	 Driver Loader API 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  HigherDriverVersion()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in DriverLoaderLib 1.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST                                         ; CONST
(deftrap-inline "_HigherDriverVersion" 
      ((driverVersion1 (:pointer :numversion)) (driverVersion2 (:pointer :numversion))) 
  :signed-integer
   () )

; 
;  *  VerifyFragmentAsDriver()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_VerifyFragmentAsDriver" 
      ((fragmentConnID :unsigned-long) (fragmentMain (:pointer :pointer)) (driverDesc (:pointer (:pointer :driverdescription)))) 
  :signed-integer
   () )

; 
;  *  GetDriverMemoryFragment()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetDriverMemoryFragment" 
      ((memAddr :pointer) (length :signed-long) (fragName (:string 63)) (fragmentConnID (:pointer :unsigned-long)) (fragmentMain (:pointer :pointer)) (driverDesc (:pointer (:pointer :driverdescription)))) 
  :signed-integer
   () )

; 
;  *  GetDriverDiskFragment()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetDriverDiskFragment" 
      ((fragmentSpec (:pointer :fsspec)) (fragmentConnID (:pointer :unsigned-long)) (fragmentMain (:pointer :pointer)) (driverDesc (:pointer (:pointer :driverdescription)))) 
  :signed-integer
   () )

; 
;  *  GetNamedDriverDiskFragment()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetNamedDriverDiskFragment" 
      ((fragmentSpec (:pointer :fsspec)) (fragName (:string 63)) (fragmentConnID (:pointer :unsigned-long)) (fragmentMain (:pointer :pointer)) (driverDesc (:pointer (:pointer :driverdescription)))) 
  :signed-integer
   () )

; 
;  *  InstallDriverFromFragment()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_InstallDriverFromFragment" 
      ((fragmentConnID :unsigned-long) (device (:pointer :regentryid)) (beginningUnit :unsigned-integer) (endingUnit :unsigned-integer) (refNum (:pointer :signed-integer))) 
  :signed-integer
   () )

; 
;  *  InstallDriverFromFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_InstallDriverFromFile" 
      ((fragmentSpec (:pointer :fsspec)) (device (:pointer :regentryid)) (beginningUnit :unsigned-integer) (endingUnit :unsigned-integer) (refNum (:pointer :signed-integer))) 
  :signed-integer
   () )

; 
;  *  InstallDriverFromMemory()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_InstallDriverFromMemory" 
      ((memory :pointer) (length :signed-long) (fragName (:string 63)) (device (:pointer :regentryid)) (beginningUnit :unsigned-integer) (endingUnit :unsigned-integer) (refNum (:pointer :signed-integer))) 
  :signed-integer
   () )

; 
;  *  InstallDriverFromResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_InstallDriverFromResource" 
      ((theRsrcID :signed-integer) (theRsrcName (:string 255)) (theDevice (:pointer :regentryid)) (theBeginningUnit :unsigned-integer) (theEndingUnit :unsigned-integer) (theRefNum (:pointer :signed-integer))) 
  :signed-integer
   () )

; 
;  *  InstallDriverFromDisk()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_InstallDriverFromDisk" 
      ((theDriverName :pointer) (theDevice (:pointer :regentryid)) (theBeginningUnit :unsigned-integer) (theEndingUnit :unsigned-integer) (theRefNum (:pointer :signed-integer))) 
  :signed-integer
   () )

; 
;  *  FindDriversForDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_FindDriversForDevice" 
      ((device (:pointer :regentryid)) (fragmentSpec (:pointer :fsspec)) (fileDriverDesc (:pointer :driverdescription)) (memAddr (:pointer :pointer)) (length (:pointer :signed-long)) (fragName (:pointer (:string 255))) (memDriverDesc (:pointer :driverdescription))) 
  :signed-integer
   () )

; 
;  *  FindDriverForDeviceFromFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_FindDriverForDeviceFromFile" 
      ((device (:pointer :regentryid)) (fragmentSpec (:pointer :fsspec)) (driverDesc (:pointer :driverdescription)) (fragName (:pointer (:string 255)))) 
  :signed-integer
   () )

; 
;  *  FindDriverCandidates()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_FindDriverCandidates" 
      ((deviceID (:pointer :regentryid)) (propBasedDriver (:pointer :pointer)) (propBasedDriverSize (:pointer :unsigned-long)) (deviceName (:pointer (:string 255))) (propBasedDriverType (:pointer :macdrivertype)) (gotPropBasedDriver (:pointer :boolean)) (fileBasedDrivers (:pointer :filebaseddriverrecord)) (nFileBasedDrivers (:pointer :unsigned-long))) 
  :signed-integer
   () )

; 
;  *  FindDriverCandidatesDetailed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_FindDriverCandidatesDetailed" 
      ((deviceID (:pointer :regentryid)) (propBasedDriver (:pointer :pointer)) (propBasedDriverSize (:pointer :unsigned-long)) (deviceName (:pointer (:string 255))) (propBasedDriverType (:pointer :macdrivertype)) (gotPropBasedDriver (:pointer :boolean)) (fileBasedDrivers (:pointer :filebaseddriverdetailed)) (nFileBasedDrivers (:pointer :unsigned-long))) 
  :signed-integer
   () )

; 
;  *  ScanDriverCandidates()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ScanDriverCandidates" 
      ((deviceID (:pointer :regentryid)) (fileBasedDrivers (:pointer :filebaseddriverrecord)) (nFileBasedDrivers :unsigned-long) (matchingDrivers (:pointer :filebaseddriverrecord)) (nMatchingDrivers (:pointer :unsigned-long))) 
  :signed-integer
   () )

; 
;  *  ScanDriverCandidatesDetailed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ScanDriverCandidatesDetailed" 
      ((deviceID (:pointer :regentryid)) (fileBasedDrivers (:pointer :filebaseddriverdetailed)) (nFileBasedDrivers :unsigned-long) (matchingDrivers (:pointer :filebaseddriverdetailed)) (nMatchingDrivers (:pointer :unsigned-long))) 
  :signed-integer
   () )

; 
;  *  CompareFileCandToPropCand()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CompareFileCandToPropCand" 
      ((device (:pointer :regentryid)) (deviceName (:pointer (:string 255))) (propBasedCandidate (:pointer :macdrivertype)) (fileBasedCandidate (:pointer :filebaseddriverrecord))) 
  :signed-integer
   () )

; 
;  *  GetCompatibleProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetCompatibleProperty" 
      ((device (:pointer :regentryid)) (compatibleNames (:pointer (:pointer (:string 255)))) (nCompatibleNames (:pointer :unsigned-long))) 
  nil
   () )

; 
;  *  CompatibleDriverNames()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CompatibleDriverNames" 
      ((nameInfoStr (:pointer (:string 255))) (compatibleNames (:pointer (:string 255))) (nCompatibleNames :unsigned-long) (nameCount (:pointer :signed-long))) 
  :boolean
   () )

; 
;  *  GetDriverForDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetDriverForDevice" 
      ((device (:pointer :regentryid)) (fragmentConnID (:pointer :unsigned-long)) (fragmentMain (:pointer :pointer)) (driverDesc (:pointer (:pointer :driverdescription)))) 
  :signed-integer
   () )

; 
;  *  InstallDriverForDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_InstallDriverForDevice" 
      ((device (:pointer :regentryid)) (beginningUnit :unsigned-integer) (endingUnit :unsigned-integer) (refNum (:pointer :signed-integer))) 
  :signed-integer
   () )

; 
;  *  GetDriverInformation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetDriverInformation" 
      ((refNum :signed-integer) (unitNum (:pointer :unsigned-integer)) (flags (:pointer :signed-integer)) (count (:pointer :unsigned-long)) (name (:pointer (:string 255))) (device (:pointer :regentryid)) (driverLoadLocation (:pointer :cfragsystem7locator)) (fragmentConnID (:pointer :unsigned-long)) (fragmentMain (:pointer :pointer)) (driverDesc (:pointer :driverdescription))) 
  :signed-integer
   () )

; 
;  *  GetDriverDescription()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetDriverDescription" 
      ((fragmentPtr :pointer) (theDriverDesc (:pointer (:pointer :driverdescription)))) 
  :signed-integer
   () )

; 
;  *  GetNamedDriverDescFromFSSpec()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetNamedDriverDescFromFSSpec" 
      ((fragmentSpec (:pointer :fsspec)) (fragName (:pointer (:string 255))) (driverDesc (:pointer (:pointer :driverdescription)))) 
  :osstatus
   () )

; 
;  *  SetDriverClosureMemory()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SetDriverClosureMemory" 
      ((fragmentConnID :unsigned-long) (holdDriverMemory :boolean)) 
  :signed-integer
   () )

; 
;  *  ReplaceDriverWithFragment()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ReplaceDriverWithFragment" 
      ((theRefNum :signed-integer) (fragmentConnID :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  OpenInstalledDriver()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_OpenInstalledDriver" 
      ((refNum :signed-integer) (ioPermission :signed-byte)) 
  :signed-integer
   () )

; 
;  *  RenameDriver()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_RenameDriver" 
      ((refNum :signed-integer) (newDriverName (:pointer (:string 255)))) 
  :signed-integer
   () )

; 
;  *  RemoveDriver()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_RemoveDriver" 
      ((refNum :signed-integer) (immediate :boolean)) 
  :signed-integer
   () )

; 
;  *  LookupDrivers()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LookupDrivers" 
      ((beginningUnit :unsigned-integer) (endingUnit :unsigned-integer) (emptyUnits :boolean) (returnedRefNums (:pointer :unsigned-long)) (refNums (:pointer :signed-integer))) 
  :signed-integer
   () )

; 
;  *  HighestUnitNumber()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_HighestUnitNumber" 
      () 
  :unsigned-integer
   () )

; 
;  *  DriverGestaltOn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_DriverGestaltOn" 
      ((refNum :signed-integer)) 
  :signed-integer
   () )

; 
;  *  DriverGestaltOff()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_DriverGestaltOff" 
      ((refNum :signed-integer)) 
  :signed-integer
   () )

; 
;  *  DriverGestaltIsOn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverLoaderLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_DriverGestaltIsOn" 
      ((flags :signed-integer)) 
  :boolean
   () )

; 
;  *  PBOpenSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PBOpenSync" 
      ((paramBlock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA000 :a0 paramBlock))

; 
;  *  PBOpenAsync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PBOpenAsync" 
      ((paramBlock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA400 :a0 paramBlock))

; 
;  *  PBOpenImmed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PBOpenImmed" 
      ((paramBlock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA200 :a0 paramBlock))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  PBCloseSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PBCloseSync" 
      ((paramBlock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA001 :a0 paramBlock))

; 
;  *  PBCloseAsync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PBCloseAsync" 
      ((paramBlock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA401 :a0 paramBlock))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  PBCloseImmed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PBCloseImmed" 
      ((paramBlock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA201 :a0 paramBlock))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  PBReadSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PBReadSync" 
      ((paramBlock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA002 :a0 paramBlock))

; 
;  *  PBReadAsync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PBReadAsync" 
      ((paramBlock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA402 :a0 paramBlock))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  PBReadImmed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PBReadImmed" 
      ((paramBlock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA202 :a0 paramBlock))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  PBWriteSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PBWriteSync" 
      ((paramBlock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA003 :a0 paramBlock))

; 
;  *  PBWriteAsync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PBWriteAsync" 
      ((paramBlock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA403 :a0 paramBlock))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  PBWriteImmed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PBWriteImmed" 
      ((paramBlock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA203 :a0 paramBlock))

; 
;     PBWaitIOComplete is a friendly way for applications to monitor
;     a pending asynchronous I/O operation in power-managed and
;     preemptive multitasking systems.
;  
; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  PBWaitIOComplete()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  AddDrive and GetDrvQHdr are now defined in Disks.h/p/a ; $IFC CALL_NOT_IN_CARBON ; 
;  *  GetDCtlEntry()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PBWaitIOComplete" 
      ((paramBlock (:pointer :paramblockrec)) (timeout :signed-long)) 
  :signed-integer
   () )                                         ; 
;     SetChooserAlert used to simply set a bit in a low-mem global
;     to tell the Chooser not to display its warning message when
;     the printer is changed. However, under MultiFinder and System 7,
;     this low-mem is swapped out when a layer change occurs, and the
;     Chooser never sees the change. It is obsolete, and completely
;     unsupported on the PowerPC. 68K apps can still call it if they
;     wish.
;     
;     pascal Boolean SetChooserAlert(Boolean f);
; 
;                                               ; 
;  *  DriverInstall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetDCtlEntry" 
      ((refNum :signed-integer)) 
  (:handle :dctlentry)
   () )
(deftrap "_DriverInstall" 
      ((drvrPtr (:pointer :drvrheader)) (refNum :signed-integer))
   (:d0 :signed-integer)
   (:register-trap #xA03D :d0 refNum :a0 drvrPtr))

; 
;  *  DriverInstallReserveMem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DriverInstallReserveMem" 
      ((drvrPtr (:pointer :drvrheader)) (refNum :signed-integer))
   (:d0 :signed-integer)
   (:register-trap #xA43D :d0 refNum :a0 drvrPtr))

; 
;   Note: DrvrInstall() is no longer supported, becuase it never really worked anyways.
;         There will soon be a DriverInstall() which does the right thing.
; 
;         DrvrRemove has been renamed to DriverRemove.  But, InterfaceLib for PowerPC
;         still exports DrvrRemove, so a macro is used to map the new name to old.
; 
; 
; 
;  *  DrvrRemove()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DrvrRemove" 
      ((refNum :signed-integer))
   (:d0 :signed-integer)
   (:register-trap #xA03E :d0 refNum))

; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC TARGET_CPU_68K 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  DriverRemove()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DriverRemove" 
      ((refNum :signed-integer))
   (:d0 :signed-integer)
   (:register-trap #xA03E :d0 refNum))

; $ENDC                                         ; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC; TARGET_CPU_68K

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  [Mac]OpenDriver()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  [Mac]CloseDriver()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OpenDriver" 
      ((name (:string 255)) (drvrRefNum (:pointer :signed-integer))) 
  :signed-integer
   () )                                         ; 
;  *  Control()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CloseDriver" 
      ((refNum :signed-integer)) 
  :signed-integer
   () )                                         ; 
;  *  Status()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_Control" 
      ((refNum :signed-integer) (csCode :signed-integer) (csParamPtr :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  KillIO()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_Status" 
      ((refNum :signed-integer) (csCode :signed-integer) (csParamPtr :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  Fetch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_KillIO" 
      ((refNum :signed-integer)) 
  :signed-integer
   () )
(deftrap-inline "_Fetch" 
      ((dce (:pointer :dctlentry))) 
  :signed-long
   (#x225F #x2078 #x8F4 #x4E90 #x2E80) )

; 
;  *  Stash()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Stash" 
      ((dce (:pointer :dctlentry)) (data :signed-byte)) 
  :signed-long
   (#x101F #x225F #x2078 #x8F8 #x4E90 #x2E80) )

; 
;  *  IODone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_IODone" 
      ((dce (:pointer :dctlentry)) (ioResult :signed-integer)) 
  nil
   (#x301F #x225F #x2078 #x8FC #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  PBControlSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PBControlSync" 
      ((paramBlock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA004 :a0 paramBlock))

; 
;  *  PBControlAsync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PBControlAsync" 
      ((paramBlock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA404 :a0 paramBlock))

; 
;  *  PBControlImmed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PBControlImmed" 
      ((paramBlock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA204 :a0 paramBlock))

; 
;  *  PBStatusSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PBStatusSync" 
      ((paramBlock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA005 :a0 paramBlock))

; 
;  *  PBStatusAsync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PBStatusAsync" 
      ((paramBlock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA405 :a0 paramBlock))

; 
;  *  PBStatusImmed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PBStatusImmed" 
      ((paramBlock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA205 :a0 paramBlock))

; 
;  *  PBKillIOSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PBKillIOSync" 
      ((paramBlock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA006 :a0 paramBlock))

; 
;  *  PBKillIOAsync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PBKillIOAsync" 
      ((paramBlock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA406 :a0 paramBlock))

; 
;  *  PBKillIOImmed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PBKillIOImmed" 
      ((paramBlock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA206 :a0 paramBlock))

; 
;  *  OpenDeskAcc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_OpenDeskAcc" 
      ((deskAccName (:string 255)))
   (:stack :signed-integer)
   (:stack-trap #xA9B6))

; 
;  *  CloseDeskAcc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CloseDeskAcc" 
      ((refNum :signed-integer))
   nil
   (:stack-trap #xA9B7))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;     The PBxxx() routines are obsolete.  
;     
;     Use the PBxxxSync(), PBxxxAsync(), or PBxxxImmed version instead.
; 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  PBControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  PBStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PBControl" 
      ((paramBlock (:pointer :paramblockrec)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PBKillIO()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PBStatus" 
      ((paramBlock (:pointer :paramblockrec)) (async :boolean)) 
  :signed-integer
   () )
(deftrap-inline "_PBKillIO" 
      ((paramBlock (:pointer :paramblockrec)) (async :boolean)) 
  :signed-integer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  PBOpen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  PBClose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PBOpen" 
      ((paramBlock (:pointer :paramblockrec)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PBRead()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PBClose" 
      ((paramBlock (:pointer :paramblockrec)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PBWrite()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PBRead" 
      ((paramBlock (:pointer :paramblockrec)) (async :boolean)) 
  :signed-integer
   () )
(deftrap-inline "_PBWrite" 
      ((paramBlock (:pointer :paramblockrec)) (async :boolean)) 
  :signed-integer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := DevicesIncludes

; $ENDC                                         ; __DEVICES__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Devices)