(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:DiskInit.p"
; at Wednesday May 1,2002 2:41:19 pm.
; 
;      File:       DiskInit.p
;  
;      Contains:   Disk Initialization Package ('PACK' 2) Interfaces.
;  
;      Version:    Technology: System 8.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __DISKINIT__
; $SETC __DISKINIT__ := 1

; $I+
; $SETC DiskInitIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :hfsdefaultsptr (find-mactype '(:pointer :hfsdefaults)))
(defrecord HFSDefaults 
   (sigWord (:array :character 2 :packed))      ;   signature word  
   (abSize :signed-long)                        ;   allocation block size in bytes  
   (clpSize :signed-long)                       ;   clump size in bytes  
   (nxFreeFN :signed-long)                      ;   next free file number  
   (btClpSize :signed-long)                     ;   B-Tree clump size in bytes  
   (rsrv1 :signed-integer)                      ;   reserved  
   (rsrv2 :signed-integer)                      ;   reserved  
   (rsrv3 :signed-integer)                      ;   reserved  
   )

(defconstant $kHFSPlusDefaultsVersion 1)

(def-mactype :hfsplusdefaultsptr (find-mactype '(:pointer :hfsplusdefaults)))
(defrecord HFSPlusDefaults 
   (version :unsigned-integer)                  ;   version of this structure  
   (flags :unsigned-integer)                    ;   currently undefined; pass zero  
   (blockSize :unsigned-long)                   ;   allocation block size in bytes  
   (rsrcClumpSize :unsigned-long)               ;   clump size for resource forks  
   (dataClumpSize :unsigned-long)               ;   clump size for data forks  
   (nextFreeFileID :unsigned-long)              ;   next free file number  
   (catalogClumpSize :unsigned-long)            ;   clump size for catalog B-tree  
   (catalogNodeSize :unsigned-long)             ;   node size for catalog B-tree  
   (extentsClumpSize :unsigned-long)            ;   clump size for extents B-tree  
   (extentsNodeSize :unsigned-long)             ;   node size for extents B-tree  
   (attributesClumpSize :unsigned-long)         ;   clump size for attributes B-tree  
   (attributesNodeSize :unsigned-long)          ;   node size for attributes B-tree  
   (allocationClumpSize :unsigned-long)         ;   clump size for allocation bitmap file  
   )

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  DILoad()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_DILoad" 
      () 
  nil
   (#x7002 #x3F00 #xA9E9) )

; 
;  *  DIUnload()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_DIUnload" 
      () 
  nil
   (#x7004 #x3F00 #xA9E9) )

; 
;  *  DIBadMount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_DIBadMount" 
      ((where :point) (evtMessage :unsigned-long)) 
  :signed-integer
   (#x7000 #x3F00 #xA9E9) )

; 
;  *  DIFormat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_DIFormat" 
      ((drvNum :signed-integer)) 
  :signed-integer
   (#x7006 #x3F00 #xA9E9) )

; 
;  *  DIVerify()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_DIVerify" 
      ((drvNum :signed-integer)) 
  :signed-integer
   (#x7008 #x3F00 #xA9E9) )

; 
;  *  DIZero()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_DIZero" 
      ((drvNum :signed-integer) (volName (:string 255))) 
  :signed-integer
   (#x700A #x3F00 #xA9E9) )

; 
;     DIXFormat, DIXZero, and DIReformat are only available when FSM (File System Manager) is installed.
;     FSM is part of Macintosh PC Exchange and System 7.5.
; 
; 
;  *  DIXFormat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_DIXFormat" 
      ((drvNum :signed-integer) (fmtFlag :boolean) (fmtArg :unsigned-long) (actSize (:pointer :unsigned-long))) 
  :signed-integer
   (#x700C #x3F00 #xA9E9) )

; 
;  *  DIXZero()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_DIXZero" 
      ((drvNum :signed-integer) (volName (:string 255)) (fsid :signed-integer) (mediaStatus :signed-integer) (volTypeSelector :signed-integer) (volSize :unsigned-long) (extendedInfoPtr :pointer)) 
  :signed-integer
   (#x700E #x3F00 #xA9E9) )

; 
;  *  DIReformat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_DIReformat" 
      ((drvNum :signed-integer) (fsid :signed-integer) (volName (:string 255)) (msgText (:string 255))) 
  :signed-integer
   (#x7010 #x3F00 #xA9E9) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := DiskInitIncludes

; $ENDC                                         ; __DISKINIT__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'DiskInit)