(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:DriverServices.p"
; at Wednesday May 1,2002 2:40:02 pm.
; 
;      File:       DriverServices.p
;  
;      Contains:   Driver Services Interfaces.
;  
;      Version:    Technology: PowerSurge 1.0.2
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __DRIVERSERVICES__
; $SETC __DRIVERSERVICES__ := 1

; $I+
; $SETC DriverServicesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __MACHINEEXCEPTIONS__

(require-interface 'MachineExceptions)          ; $I MachineExceptions.p
; $ENDC
#|                                              ; $IFC UNDEFINED __DEVICES__
|#

(require-interface 'Devices)
#|                                              ; $I Devices.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __DRIVERSYNCHRONIZATION__
|#

(require-interface 'DriverSynchronization)
#|                                              ; $I DriverSynchronization.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __NAMEREGISTRY__
|#

(require-interface 'NameRegistry)
#|                                              ; $I NameRegistry.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

; *****************************************************************
;  *
;  *      Previously in Kernel.h
;  *
;  *****************************************************************
;   Kernel basics 

(def-mactype :iopreparationid (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :iopreparationidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:IOPreparationID parameter can be nil, it is changed to xx: IOPreparationIDPtr 
(def-mactype :softwareinterruptid (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :softwareinterruptidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:SoftwareInterruptID parameter can be nil, it is changed to xx: SoftwareInterruptIDPtr 
(def-mactype :taskid (find-mactype ':pointer))  ;  an opaque 32-bit type 
(def-mactype :taskidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:TaskID parameter can be nil, it is changed to xx: TaskIDPtr 
(def-mactype :timerid (find-mactype ':pointer)) ;  an opaque 32-bit type 
(def-mactype :timeridptr (find-mactype '(:pointer :pointer)));  when a VAR xx:TimerID parameter can be nil, it is changed to xx: TimerIDPtr 
;   Tasking 
(def-mactype :executionlevel (find-mactype ':unsigned-long))

(defconstant $kTaskLevel 0)
(defconstant $kSoftwareInterruptLevel 1)
(defconstant $kAcceptFunctionLevel 2)
(defconstant $kKernelLevel 3)
(defconstant $kSIHAcceptFunctionLevel 4)
(defconstant $kSecondaryInterruptLevel 5)
(defconstant $kHardwareInterruptLevel 6)
(defconstant $kMPTaskLevel 7)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SoftwareInterruptHandler = PROCEDURE(p1: UNIV Ptr; p2: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :softwareinterrupthandler (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SecondaryInterruptHandler2 = FUNCTION(p1: UNIV Ptr; p2: UNIV Ptr): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :secondaryinterrupthandler2 (find-mactype ':pointer))
; $ENDC

(defconstant $kCurrentAddressSpaceID -1)

;   Memory System basics 

(def-mactype :logicaladdressrangeptr (find-mactype '(:pointer :logicaladdressrange)))
(defrecord LogicalAddressRange 
   (address :pointer)
   (count :unsigned-long)
   )

(def-mactype :physicaladdressrangeptr (find-mactype '(:pointer :physicaladdressrange)))
(defrecord PhysicalAddressRange 
   (address :pointer)
   (count :unsigned-long)
   )

;   For PrepareMemoryForIO and CheckpointIO 
(def-mactype :iopreparationoptions (find-mactype ':unsigned-long))

(defconstant $kIOMultipleRanges #x1)
(defconstant $kIOLogicalRanges #x2)
(defconstant $kIOMinimalLogicalMapping #x4)
(defconstant $kIOShareMappingTables #x8)
(defconstant $kIOIsInput #x10)
(defconstant $kIOIsOutput #x20)
(defconstant $kIOCoherentDataPath #x40)
(defconstant $kIOTransferIsLogical #x80)
(defconstant $kIOClientIsUserMode #x80)

(def-mactype :iopreparationstate (find-mactype ':unsigned-long))

(defconstant $kIOStateDone #x1)

(defconstant $kInvalidPageAddress -1)

(def-mactype :addressrangeptr (find-mactype '(:pointer :addressrange)))
(defrecord AddressRange 
   (base :pointer)
   (length :unsigned-long)
   )

;   C's treatment of arrays and array pointers is atypical 
(defrecord LogicalMappingTable (array (:array :pointer 1)))
(def-mactype :logicalmappingtableptr (find-mactype '(:pointer :logicalmappingtable)))
(defrecord PhysicalMappingTable (array (:array :pointer 1)))
(def-mactype :physicalmappingtableptr (find-mactype '(:pointer :physicalmappingtable)))
(defrecord AddressRangeTable (array (:array :addressrange 1)))
(def-mactype :addressrangetableptr (find-mactype '(:pointer :addressrangetable)))
(def-mactype :multipleaddressrangeptr (find-mactype '(:pointer :multipleaddressrange)))
(defrecord MultipleAddressRange 
   (entryCount :unsigned-long)
   (rangeTable (:pointer :addressrangetable))
   )

; 
; 	   Separate C definition so that union has a name.  A future version of the interfacer
; 	   tool will allow a name (that gets thrown out in Pascal and Asm).
; 	
(def-mactype :iopreparationtableptr (find-mactype '(:pointer :iopreparationtable)))
(defrecord IOPreparationTable 
   (options :unsigned-long)
   (state :unsigned-long)
   (preparationID :pointer)
   (addressSpace :pointer)
   (granularity :unsigned-long)
   (firstPrepared :unsigned-long)
   (lengthPrepared :unsigned-long)
   (mappingEntryCount :unsigned-long)
   (logicalMapping (:pointer :logicalmappingtable))
   (physicalMapping (:pointer :physicalmappingtable))
   (:variant 
      (
      (range :addressrange)
      )
      (
      (multipleRanges :multipleaddressrange)
      )
      )
   )

(def-mactype :iocheckpointoptions (find-mactype ':unsigned-long))

(defconstant $kNextIOIsInput #x1)
(defconstant $kNextIOIsOutput #x2)
(defconstant $kMoreIOTransfers #x4)

;   For SetProcessorCacheMode 

(def-mactype :processorcachemode (find-mactype ':unsigned-long))

(defconstant $kProcessorCacheModeDefault 0)
(defconstant $kProcessorCacheModeInhibited 1)
(defconstant $kProcessorCacheModeWriteThrough 2)
(defconstant $kProcessorCacheModeCopyBack 3)

; 
; 	   For GetPageInformation
; 	   (Note: if kPageInformationVersion fails, try 0 -- old versions of DSL defined  kPageInformationVersion as 0)
; 	

(defconstant $kPageInformationVersion 1)

(def-mactype :pagestateinformation (find-mactype ':unsigned-long))

(defconstant $kPageIsProtected #x1)
(defconstant $kPageIsProtectedPrivileged #x2)
(defconstant $kPageIsModified #x4)
(defconstant $kPageIsReferenced #x8)
(defconstant $kPageIsLockedResident #x10)       ;   held and locked resident 
(defconstant $kPageIsInMemory #x20)
(defconstant $kPageIsShared #x40)
(defconstant $kPageIsWriteThroughCached #x80)
(defconstant $kPageIsCopyBackCached #x100)
(defconstant $kPageIsHeldResident #x200)        ;   held resident - use kPageIsLockedResident to check for locked state 
(defconstant $kPageIsLocked #x10)               ;   Deprecated 
(defconstant $kPageIsResident #x20)             ;   Deprecated 

(def-mactype :pageinformationptr (find-mactype '(:pointer :pageinformation)))
(defrecord PageInformation 
   (area :pointer)
   (count :unsigned-long)
   (information (:array :unsigned-long 1))
   )

; 	  Tasks  	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  CurrentExecutionLevel()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_CurrentExecutionLevel" 
      () 
  :unsigned-long
   () )

; 
;  *  CurrentTaskID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CurrentTaskID" 
      () 
  :pointer
   () )

; 
;  *  DelayFor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_DelayFor" 
      ((delayDuration :signed-long)) 
  :osstatus
   () )

; 
;  *  InPrivilegedMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_InPrivilegedMode" 
      () 
  :boolean
   () )

;   Software Interrupts  
; 
;  *  CreateSoftwareInterrupt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CreateSoftwareInterrupt" 
      ((handler :pointer) (task :pointer) (p1 :pointer) (persistent :boolean) (theSoftwareInterrupt (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  SendSoftwareInterrupt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SendSoftwareInterrupt" 
      ((theSoftwareInterrupt :pointer) (p2 :pointer)) 
  :osstatus
   () )

; 
;  *  DeleteSoftwareInterrupt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_DeleteSoftwareInterrupt" 
      ((theSoftwareInterrupt :pointer)) 
  :osstatus
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC TARGET_OS_MAC 
;   Secondary Interrupts  
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  CallSecondaryInterruptHandler2()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CallSecondaryInterruptHandler2" 
      ((theHandler :pointer) (ExceptionHandler :pointer) (p1 :pointer) (p2 :pointer)) 
  :osstatus
   () )

; 
;  *  QueueSecondaryInterruptHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_QueueSecondaryInterruptHandler" 
      ((theHandler :pointer) (ExceptionHandler :pointer) (p1 :pointer) (p2 :pointer)) 
  :osstatus
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; TARGET_OS_MAC

;   Timers  
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SetInterruptTimer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SetInterruptTimer" 
      ((expirationTime (:pointer :unsignedwide)) (handler :pointer) (p1 :pointer) (theTimer (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  SetPersistentTimer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SetPersistentTimer" 
      ((frequency :signed-long) (theHandler :pointer) (p1 :pointer) (theTimer (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  CancelTimer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CancelTimer" 
      ((theTimer :pointer) (timeRemaining (:pointer :unsignedwide))) 
  :osstatus
   () )

;   I/O related Operations  
; 
;  *  PrepareMemoryForIO()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PrepareMemoryForIO" 
      ((theIOPreparationTable (:pointer :iopreparationtable))) 
  :osstatus
   () )

; 
;  *  CheckpointIO()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CheckpointIO" 
      ((theIOPreparation :pointer) (options :unsigned-long)) 
  :osstatus
   () )

;   Memory Operations  
; 
;  *  GetPageInformation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetPageInformation" 
      ((addressSpace :pointer) (base :pointer) (length :unsigned-long) (version :unsigned-long) (thePageInfo (:pointer :pageinformation))) 
  :osstatus
   () )

;   Processor Cache Related  
; 
;  *  SetProcessorCacheMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SetProcessorCacheMode" 
      ((addressSpace :pointer) (base :pointer) (length :unsigned-long) (cacheMode :unsigned-long)) 
  :osstatus
   () )

; *****************************************************************
;  *
;  *      Was in DriverSupport.h or DriverServices.h
;  *
;  *****************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :devicelogicaladdressptr (find-mactype '(:pointer :pointer)))

(defconstant $durationMicrosecond -1)           ;   Microseconds are negative 
(defconstant $durationMillisecond 1)            ;   Milliseconds are positive 
(defconstant $durationSecond 1000)              ;   1000 * durationMillisecond 
(defconstant $durationMinute 60000)             ;   60 * durationSecond, 
(defconstant $durationHour 3600000)             ;   60 * durationMinute, 
(defconstant $durationDay 86400000)             ;   24 * durationHour, 
(defconstant $durationNoWait 0)                 ;   don't block 
(defconstant $durationForever #x7FFFFFFF)       ;   no time limit 

(defconstant $k8BitAccess 0)                    ;   access as 8 bit 
(defconstant $k16BitAccess 1)                   ;   access as 16 bit 
(defconstant $k32BitAccess 2)                   ;   access as 32 bit 

(%define-record :nanoseconds (find-record-descriptor :unsignedwide))
(def-mactype :nanosecondsptr (find-mactype '(:pointer :unsignedwide)))

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  IOCommandIsComplete()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_IOCommandIsComplete" 
      ((theID :pointer) (theResult :signed-integer)) 
  :signed-integer
   () )

; 
;  *  GetIOCommandInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetIOCommandInfo" 
      ((theID :pointer) (theContents (:pointer :iocommandcontents)) (theCommand (:pointer :unsigned-long)) (theKind (:pointer :unsigned-long))) 
  :signed-integer
   () )

; 
;  *  UpdateDeviceActivity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_UpdateDeviceActivity" 
      ((deviceEntry (:pointer :regentryid))) 
  nil
   () )

; 
;  *  BlockCopy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_BlockCopy" 
      ((srcPtr :pointer) (destPtr :pointer) (byteCount :signed-long)) 
  nil
   () )

; 
;  *  PoolAllocateResident()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PoolAllocateResident" 
      ((byteSize :unsigned-long) (clear :boolean)) 
  :pointer
   () )

; 
;  *  PoolDeallocate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PoolDeallocate" 
      ((address :pointer)) 
  :osstatus
   () )

; 
;  *  GetLogicalPageSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetLogicalPageSize" 
      () 
  :unsigned-long
   () )

; 
;  *  GetDataCacheLineSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetDataCacheLineSize" 
      () 
  :unsigned-long
   () )

; 
;  *  FlushProcessorCache()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_FlushProcessorCache" 
      ((spaceID :pointer) (base :pointer) (length :unsigned-long)) 
  :osstatus
   () )

; 
;  *  MemAllocatePhysicallyContiguous()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MemAllocatePhysicallyContiguous" 
      ((byteSize :unsigned-long) (clear :boolean)) 
  :pointer
   () )

; 
;  *  MemDeallocatePhysicallyContiguous()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MemDeallocatePhysicallyContiguous" 
      ((address :pointer)) 
  :osstatus
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  UpTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_UpTime" 
      () 
  :unsignedwide
   () )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  GetTimeBaseInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.6 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetTimeBaseInfo" 
      ((minAbsoluteTimeDelta (:pointer :unsigned-long)) (theAbsoluteTimeToNanosecondNumerator (:pointer :unsigned-long)) (theAbsoluteTimeToNanosecondDenominator (:pointer :unsigned-long)) (theProcessorToAbsoluteTimeNumerator (:pointer :unsigned-long)) (theProcessorToAbsoluteTimeDenominator (:pointer :unsigned-long))) 
  nil
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  AbsoluteToNanoseconds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AbsoluteToNanoseconds" 
      ((AbsoluteTime :unsignedwide)) 
  :unsignedwide
   () )

; 
;  *  AbsoluteToDuration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AbsoluteToDuration" 
      ((AbsoluteTime :unsignedwide)) 
  :duration
   () )

; 
;  *  NanosecondsToAbsolute()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_NanosecondsToAbsolute" 
      ((Nanoseconds :unsignedwide)) 
  :unsignedwide
   () )

; 
;  *  DurationToAbsolute()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_DurationToAbsolute" 
      ((Duration :signed-long)) 
  :unsignedwide
   () )

; 
;  *  AddAbsoluteToAbsolute()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AddAbsoluteToAbsolute" 
      ((absoluteTime1 :unsignedwide) (absoluteTime2 :unsignedwide)) 
  :unsignedwide
   () )

; 
;  *  SubAbsoluteFromAbsolute()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_SubAbsoluteFromAbsolute" 
      ((leftAbsoluteTime :unsignedwide) (rightAbsoluteTime :unsignedwide)) 
  :unsignedwide
   () )

; 
;  *  AddNanosecondsToAbsolute()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AddNanosecondsToAbsolute" 
      ((Nanoseconds :unsignedwide) (AbsoluteTime :unsignedwide)) 
  :unsignedwide
   () )

; 
;  *  AddDurationToAbsolute()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AddDurationToAbsolute" 
      ((Duration :signed-long) (AbsoluteTime :unsignedwide)) 
  :unsignedwide
   () )

; 
;  *  SubNanosecondsFromAbsolute()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_SubNanosecondsFromAbsolute" 
      ((Nanoseconds :unsignedwide) (AbsoluteTime :unsignedwide)) 
  :unsignedwide
   () )

; 
;  *  SubDurationFromAbsolute()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_SubDurationFromAbsolute" 
      ((Duration :signed-long) (AbsoluteTime :unsignedwide)) 
  :unsignedwide
   () )

; 
;  *  AbsoluteDeltaToNanoseconds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AbsoluteDeltaToNanoseconds" 
      ((leftAbsoluteTime :unsignedwide) (rightAbsoluteTime :unsignedwide)) 
  :unsignedwide
   () )

; 
;  *  AbsoluteDeltaToDuration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AbsoluteDeltaToDuration" 
      ((leftAbsoluteTime :unsignedwide) (rightAbsoluteTime :unsignedwide)) 
  :duration
   () )

; 
;  *  DurationToNanoseconds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_DurationToNanoseconds" 
      ((theDuration :signed-long)) 
  :unsignedwide
   () )

; 
;  *  NanosecondsToDuration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.6 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_NanosecondsToDuration" 
      ((theNanoseconds :unsignedwide)) 
  :duration
   () )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  PBQueueInit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PBQueueInit" 
      ((qHeader (:pointer :qhdr))) 
  :signed-integer
   () )

; 
;  *  PBQueueCreate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PBQueueCreate" 
      ((qHeader (:pointer (:pointer :qhdr)))) 
  :signed-integer
   () )

; 
;  *  PBQueueDelete()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PBQueueDelete" 
      ((qHeader (:pointer :qhdr))) 
  :signed-integer
   () )

; 
;  *  PBEnqueue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PBEnqueue" 
      ((qElement (:pointer :qelem)) (qHeader (:pointer :qhdr))) 
  nil
   () )

; 
;  *  PBEnqueueLast()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PBEnqueueLast" 
      ((qElement (:pointer :qelem)) (qHeader (:pointer :qhdr))) 
  :signed-integer
   () )

; 
;  *  PBDequeue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PBDequeue" 
      ((qElement (:pointer :qelem)) (qHeader (:pointer :qhdr))) 
  :signed-integer
   () )

; 
;  *  PBDequeueFirst()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PBDequeueFirst" 
      ((qHeader (:pointer :qhdr)) (theFirstqElem (:pointer (:pointer :qelem)))) 
  :signed-integer
   () )

; 
;  *  PBDequeueLast()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PBDequeueLast" 
      ((qHeader (:pointer :qhdr)) (theLastqElem (:pointer (:pointer :qelem)))) 
  :signed-integer
   () )

; 
;  *  CStrCopy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CStrCopy" 
      ((dst :pointer) (src :pointer)) 
  :pointer
   () )

; 
;  *  PStrCopy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PStrCopy" 
      ((dst (:pointer (:string 255))) (src (:string 255))) 
  (:pointer (:string 255))
   () )

; 
;  *  CStrNCopy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CStrNCopy" 
      ((dst :pointer) (src :pointer) (max :unsigned-long)) 
  :pointer
   () )

; 
;  *  PStrNCopy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PStrNCopy" 
      ((dst (:pointer (:string 255))) (src (:string 255)) (max :unsigned-long)) 
  (:pointer (:string 255))
   () )

; 
;  *  CStrCat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CStrCat" 
      ((dst :pointer) (src :pointer)) 
  :pointer
   () )

; 
;  *  PStrCat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PStrCat" 
      ((dst (:pointer (:string 255))) (src (:string 255))) 
  (:pointer (:string 255))
   () )

; 
;  *  CStrNCat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CStrNCat" 
      ((dst :pointer) (src :pointer) (max :unsigned-long)) 
  :pointer
   () )

; 
;  *  PStrNCat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PStrNCat" 
      ((dst (:pointer (:string 255))) (src (:string 255)) (max :unsigned-long)) 
  (:pointer (:string 255))
   () )

; 
;  *  PStrToCStr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PStrToCStr" 
      ((dst :pointer) (src (:string 255))) 
  nil
   () )

; 
;  *  CStrToPStr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CStrToPStr" 
      ((dst (:pointer (:string 255))) (src :pointer)) 
  nil
   () )

; 
;  *  CStrCmp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CStrCmp" 
      ((s1 :pointer) (s2 :pointer)) 
  :signed-integer
   () )

; 
;  *  PStrCmp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PStrCmp" 
      ((str1 (:string 255)) (str2 (:string 255))) 
  :signed-integer
   () )

; 
;  *  CStrNCmp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CStrNCmp" 
      ((s1 :pointer) (s2 :pointer) (max :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  PStrNCmp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PStrNCmp" 
      ((str1 (:string 255)) (str2 (:string 255)) (max :unsigned-long)) 
  :signed-integer
   () )

; 
;  *  CStrLen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_CStrLen" 
      ((src :pointer)) 
  :unsigned-long
   () )

; 
;  *  PStrLen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_PStrLen" 
      ((src (:string 255))) 
  :unsigned-long
   () )

; 
;  *  DeviceProbe()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_DeviceProbe" 
      ((theSrc :pointer) (theDest :pointer) (AccessType :unsigned-long)) 
  :osstatus
   () )

; 
;  *  DelayForHardware()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_DelayForHardware" 
      ((AbsoluteTime :unsignedwide)) 
  :osstatus
   () )

; *****************************************************************
;  *
;  *      Was in Interrupts.h 
;  *
;  *****************************************************************
;   Interrupt types  
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :interruptsetid (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :interruptsetidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:InterruptSetID parameter can be nil, it is changed to xx: InterruptSetIDPtr 
(def-mactype :interruptmembernumber (find-mactype ':signed-long))
(def-mactype :interruptsetmemberptr (find-mactype '(:pointer :interruptsetmember)))
(defrecord InterruptSetMember 
   (setID :pointer)
   (member :signed-long)
   )

(defconstant $kISTChipInterruptSource 0)
(defconstant $kISTOutputDMAInterruptSource 1)
(defconstant $kISTInputDMAInterruptSource 2)
(defconstant $kISTPropertyMemberCount 3)

(defrecord ISTProperty (array (:array :interruptsetmember 3)))
(def-mactype :interruptreturnvalue (find-mactype ':signed-long))

(defconstant $kFirstMemberNumber 1)
(defconstant $kIsrIsComplete 0)
(defconstant $kIsrIsNotComplete -1)
(defconstant $kMemberNumberParent -2)

(def-mactype :interruptsourcestate (find-mactype ':boolean))

(defconstant $kSourceWasEnabled #$true)
(defconstant $kSourceWasDisabled #$false)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	InterruptHandler = FUNCTION(ISTmember: InterruptSetMember; refCon: UNIV Ptr; theIntCount: UInt32): InterruptMemberNumber; C;

|#
 |#                                             ; $ELSEC
(def-mactype :interrupthandler (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	InterruptEnabler = PROCEDURE(ISTmember: InterruptSetMember; refCon: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :interruptenabler (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	InterruptDisabler = FUNCTION(ISTmember: InterruptSetMember; refCon: UNIV Ptr): ByteParameter; C;

|#
 |#                                             ; $ELSEC
(def-mactype :interruptdisabler (find-mactype ':pointer))
; $ENDC

(defconstant $kReturnToParentWhenComplete #x1)
(defconstant $kReturnToParentWhenNotComplete #x2)

(def-mactype :interruptsetoptions (find-mactype ':unsigned-long))
; 	  Interrupt Services  	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  CreateInterruptSet()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_CreateInterruptSet" 
      ((parentSet :pointer) (parentMember :signed-long) (setSize :signed-long) (setID (:pointer :pointer)) (options :unsigned-long)) 
  :osstatus
   () )

; 
;  *  InstallInterruptFunctions()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_InstallInterruptFunctions" 
      ((setID :pointer) (member :signed-long) (refCon :pointer) (handlerFunction :pointer) (enableFunction :pointer) (disableFunction :pointer)) 
  :osstatus
   () )

; 
;  *  GetInterruptFunctions()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetInterruptFunctions" 
      ((setID :pointer) (member :signed-long) (refCon (:pointer :pointer)) (handlerFunction (:pointer :pointer)) (enableFunction (:pointer :pointer)) (disableFunction (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  ChangeInterruptSetOptions()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ChangeInterruptSetOptions" 
      ((setID :pointer) (options :unsigned-long)) 
  :osstatus
   () )

; 
;  *  GetInterruptSetOptions()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetInterruptSetOptions" 
      ((setID :pointer) (options (:pointer :unsigned-long))) 
  :osstatus
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := DriverServicesIncludes

; $ENDC                                         ; __DRIVERSERVICES__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'DriverServices)