(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:ENET.p"
; at Wednesday May 1,2002 2:41:24 pm.
; 
;      File:       ENET.p
;  
;      Contains:   Ethernet Interfaces.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1990-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __ENET__
; $SETC __ENET__ := 1

; $I+
; $SETC ENETIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __OSUTILS__
|#

(require-interface 'OSUtils)
#|                                              ; $I OSUtils.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $ENetSetGeneral 253)               ;  Set "general" mode 
(defconstant $ENetGetInfo 252)                  ;  Get info 
(defconstant $ENetRdCancel 251)                 ;  Cancel read 
(defconstant $ENetRead 250)                     ;  Read 
(defconstant $ENetWrite 249)                    ;  Write 
(defconstant $ENetDetachPH 248)                 ;  Detach protocol handler 
(defconstant $ENetAttachPH 247)                 ;  Attach protocol handler 
(defconstant $ENetAddMulti 246)                 ;  Add a multicast address 
(defconstant $ENetDelMulti 245)                 ;  Delete a multicast address 

(defconstant $EAddrRType :|eadr|)               ;  Alternate address resource type 

(def-mactype :eparamblockptr (find-mactype '(:pointer :eparamblock)))
(def-mactype :eparamblkptr (find-mactype '(:pointer :eparamblock)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ENETCompletionProcPtr = PROCEDURE(thePBPtr: EParamBlkPtr);

|#
 |#                                             ; $ELSEC
(def-mactype :enetcompletionprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :enetcompletionupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :enetcompletionupp (find-mactype ':pointer))
; $ENDC
(defrecord EParamBlock 
   (qLink (:pointer :qelem))                    ;  General EParams 
   (qType :signed-integer)                      ;  queue type 
   (ioTrap :signed-integer)                     ;  routine trap 
   (ioCmdAddr :pointer)                         ;  routine address 
   (ioCompletion :pointer)                      ;  completion routine 
   (ioResult :signed-integer)                   ;  result code 
   (ioNamePtr (:pointer (:string 255)))         ;  ->filename 
   (ioVRefNum :signed-integer)                  ;  volume reference or drive number 
   (ioRefNum :signed-integer)                   ;  driver reference number 
   (csCode :signed-integer)                     ;  Call command code 
   (:variant 
      (
      (eProtType :signed-integer)               ;  Ethernet protocol type 
      (ePointer :pointer)                       ;  No support for PowerPC code 
      (eBuffSize :signed-integer)               ;  buffer size 
      (eDataSize :signed-integer)               ;  number of bytes read 
      )
      (
      (eMultiAddr (:array :unsigned-byte 6 :packed));  Multicast Address 
      )
      )
   )

(defconstant $uppENETCompletionProcInfo #x9802)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewENETCompletionUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewENETCompletionProc 
(deftrap "_NewENETCompletionUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeENETCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeENETCompletionUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeENETCompletionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallENETCompletionProc 
(deftrap-inline "_InvokeENETCompletionUPP" 
      ((thePBPtr (:pointer :eparamblock)) (userRoutine :pointer)) 
  nil
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  EWrite()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  EAttachPH()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_EWrite" 
      ((thePBptr (:pointer :eparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  EDetachPH()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_EAttachPH" 
      ((thePBptr (:pointer :eparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  ERead()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_EDetachPH" 
      ((thePBptr (:pointer :eparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  ERdCancel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ERead" 
      ((thePBptr (:pointer :eparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  EGetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ERdCancel" 
      ((thePBptr (:pointer :eparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  ESetGeneral()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_EGetInfo" 
      ((thePBptr (:pointer :eparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  EAddMulti()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_ESetGeneral" 
      ((thePBptr (:pointer :eparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  EDelMulti()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_EAddMulti" 
      ((thePBptr (:pointer :eparamblock)) (async :boolean)) 
  :signed-integer
   () )
(deftrap-inline "_EDelMulti" 
      ((thePBptr (:pointer :eparamblock)) (async :boolean)) 
  :signed-integer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := ENETIncludes

; $ENDC                                         ; __ENET__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'ENET)