(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Editions.p"
; at Wednesday May 1,2002 2:41:23 pm.
; 
;      File:       Editions.p
;  
;      Contains:   Edition Manager Interfaces.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1989-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __EDITIONS__
; $SETC __EDITIONS__ := 1

; $I+
; $SETC EditionsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __ALIASES__
|#

(require-interface 'Aliases)
#|                                              ; $I Aliases.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __DIALOGS__
|#

(require-interface 'Dialogs)
#|                                              ; $I Dialogs.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;   resource types   
(defconstant $rSectionType :|sect|)             ;   ResType of saved SectionRecords  
;   Finder types for edition files  
(defconstant $kPICTEditionFileType :|edtp|)
(defconstant $kTEXTEditionFileType :|edtt|)
(defconstant $ksndEditionFileType :|edts|)
(defconstant $kUnknownEditionFileType :|edtu|)
(defconstant $kPublisherDocAliasFormat :|alis|)
(defconstant $kPreviewFormat :|prvw|)
(defconstant $kFormatListFormat :|fmts|)

;   section types  
(defconstant $stSubscriber #x1)
(defconstant $stPublisher #xA)

(defconstant $sumAutomatic 0)                   ;   subscriber update mode - Automatically      
(defconstant $sumManual 1)                      ;   subscriber update mode - Manually  
(defconstant $pumOnSave 0)                      ;   publisher update mode - OnSave             
(defconstant $pumManual 1)                      ;   publisher update mode - Manually  

(defconstant $kPartsNotUsed 0)
(defconstant $kPartNumberUnknown -1)

(defconstant $kPreviewWidth 120)
(defconstant $kPreviewHeight 120)

;   bits for formatsMask  
(defconstant $kPICTformatMask 1)
(defconstant $kTEXTformatMask 2)
(defconstant $ksndFormatMask 4)

;   pseudo-item hits for dialogHooks the first is for NewPublisher or NewSubscriber Dialogs  
(defconstant $emHookRedrawPreview 150)          ;   the following are for SectionOptions Dialog  
(defconstant $emHookCancelSection 160)
(defconstant $emHookGoToPublisher 161)
(defconstant $emHookGetEditionNow 162)
(defconstant $emHookSendEditionNow 162)
(defconstant $emHookManualUpdateMode 163)
(defconstant $emHookAutoUpdateMode 164)

;   the refcon field of the dialog record during a modalfilter or dialoghook contains one the following  
(defconstant $emOptionsDialogRefCon :|optn|)
(defconstant $emCancelSectionDialogRefCon :|cncl|)
(defconstant $emGoToPubErrDialogRefCon :|gerr|)

(defconstant $kFormatLengthUnknown -1)

; 	 one byte, stSubscriber or stPublisher 	

(def-mactype :sectiontype (find-mactype ':signed-byte))
; 	 seconds since 1904 	
(def-mactype :timestamp (find-mactype ':unsigned-long))
; 	 similar to ResType 	
(def-mactype :formattype (find-mactype ':ostype))
; 	 used in Edition I/O 	
(def-mactype :editionrefnum (find-mactype ':handle))
; 	 update modes 	
; 	 sumAutomatic, pumSuspend, etc 	
(def-mactype :updatemode (find-mactype ':signed-integer))
(def-mactype :sectionrecordptr (find-mactype '(:pointer :sectionrecord)))
(def-mactype :sectionptr (find-mactype '(:pointer :sectionrecord)))
(def-mactype :sectionhandle (find-mactype '(:handle :sectionrecord)))
(defrecord (SectionRecord :handle) 
   (version :signed-byte)                       ;   always 0x01 in system 7.0  
   (kind :signed-byte)                          ;   stSubscriber or stPublisher  
   (mode :signed-integer)                       ;   auto or manual  
   (mdDate :unsigned-long)                      ;   last change in document  
   (sectionID :signed-long)                     ;   app. specific, unique per document  
   (refCon :signed-long)                        ;   application specific  
   (alias (:handle :aliasrecord))               ;   handle to Alias Record  
   (subPart :signed-long)                       ;   which part of container file  
   (nextSection (:handle :sectionrecord))       ;   for linked list of app's Sections  
   (controlBlock :handle)                       ;   used internally  
   (refNum :handle)                             ;   used internally  
   )

(def-mactype :editioncontainerspecptr (find-mactype '(:pointer :editioncontainerspec)))
(defrecord EditionContainerSpec 
   (theFile :fsspec)
   (theFileScript :signed-integer)
   (thePart :signed-long)
   (thePartName (:string 31))
   (thePartScript :signed-integer)
   )

(def-mactype :editioninforecordptr (find-mactype '(:pointer :editioninforecord)))
(defrecord EditionInfoRecord 
   (crDate :unsigned-long)                      ;   date EditionContainer was created  
   (mdDate :unsigned-long)                      ;   date of last change  
   (fdCreator :ostype)                          ;   file creator  
   (fdType :ostype)                             ;   file type  
   (container :editioncontainerspec)            ;   the Edition  
   )

(def-mactype :newpublisherreplyptr (find-mactype '(:pointer :newpublisherreply)))
(defrecord NewPublisherReply 
   (canceled :boolean)                          ;   O  
   (replacing :boolean)
   (usePart :boolean)                           ;   I  
   (filler :signed-byte)
   (preview :handle)                            ;   I  
   (previewFormat :ostype)                      ;   I  
   (container :editioncontainerspec)            ;   I/O  
   )

(def-mactype :newsubscriberreplyptr (find-mactype '(:pointer :newsubscriberreply)))
(defrecord NewSubscriberReply 
   (canceled :boolean)                          ;   O  
   (formatsMask :signed-byte)
   (container :editioncontainerspec)            ;  I/O 
   )

(def-mactype :sectionoptionsreplyptr (find-mactype '(:pointer :sectionoptionsreply)))
(defrecord SectionOptionsReply 
   (canceled :boolean)                          ;   O  
   (changed :boolean)                           ;   O  
   (sectionH (:handle :sectionrecord))          ;   I  
   (action :ostype)                             ;   O  
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ExpModalFilterProcPtr = FUNCTION(theDialog: DialogRef; VAR theEvent: EventRecord; itemOffset: INTEGER; VAR itemHit: INTEGER; yourDataPtr: Ptr): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :expmodalfilterprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ExpDlgHookProcPtr = FUNCTION(itemOffset: INTEGER; itemHit: INTEGER; theDialog: DialogRef; yourDataPtr: Ptr): INTEGER;

|#
 |#                                             ; $ELSEC
(def-mactype :expdlghookprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :expmodalfilterupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :expmodalfilterupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :expdlghookupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :expdlghookupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppExpModalFilterProcInfo #xFBD0)
(defconstant $uppExpDlgHookProcInfo #x3EA0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewExpModalFilterUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewExpModalFilterProc 
(deftrap "_NewExpModalFilterUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewExpDlgHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewExpDlgHookProc 
(deftrap "_NewExpDlgHookUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeExpModalFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeExpModalFilterUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeExpDlgHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeExpDlgHookUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeExpModalFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallExpModalFilterProc 
(deftrap-inline "_InvokeExpModalFilterUPP" 
      ((theDialog (:pointer :grafport)) (theEvent (:pointer :eventrecord)) (itemOffset :signed-integer) (itemHit (:pointer :signed-integer)) (yourDataPtr :pointer) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; 
;  *  InvokeExpDlgHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallExpDlgHookProc 
(deftrap-inline "_InvokeExpDlgHookUPP" 
      ((itemOffset :signed-integer) (itemHit :signed-integer) (theDialog (:pointer :grafport)) (yourDataPtr :pointer) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :formatioverb (find-mactype ':signed-byte))

(defconstant $ioHasFormat 0)
(defconstant $ioReadFormat 1)
(defconstant $ioNewFormat 2)
(defconstant $ioWriteFormat 3)

(def-mactype :editionopenerverb (find-mactype ':signed-byte))

(defconstant $eoOpen 0)
(defconstant $eoClose 1)
(defconstant $eoOpenNew 2)
(defconstant $eoCloseNew 3)
(defconstant $eoCanSubscribe 4)

(def-mactype :formatioparamblockptr (find-mactype '(:pointer :formatioparamblock)))
(defrecord FormatIOParamBlock 
   (ioRefNum :signed-long)
   (format :ostype)
   (formatIndex :signed-long)
   (offset :unsigned-long)
   (buffPtr :pointer)
   (buffLen :unsigned-long)
   )

(def-mactype :editionopenerparamblockptr (find-mactype '(:pointer :editionopenerparamblock)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	FormatIOProcPtr = FUNCTION(selector: ByteParameter; VAR PB: FormatIOParamBlock): INTEGER;

|#
 |#                                             ; $ELSEC
(def-mactype :formatioprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	EditionOpenerProcPtr = FUNCTION(selector: ByteParameter; PB: EditionOpenerParamBlockPtr): INTEGER;

|#
 |#                                             ; $ELSEC
(def-mactype :editionopenerprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :formatioupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :formatioupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :editionopenerupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :editionopenerupp (find-mactype ':pointer))
; $ENDC
(defrecord EditionOpenerParamBlock 
   (info :editioninforecord)
   (sectionH (:handle :sectionrecord))
   (document (:pointer :fsspec))
   (fdCreator :ostype)
   (ioRefNum :signed-long)
   (ioProc :pointer)
   (success :boolean)
   (formatsMask :signed-byte)
   )

(defconstant $uppFormatIOProcInfo #x360)
(defconstant $uppEditionOpenerProcInfo #x360)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewFormatIOUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewFormatIOProc 
(deftrap "_NewFormatIOUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewEditionOpenerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewEditionOpenerProc 
(deftrap "_NewEditionOpenerUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; $ENDC                                         ; CALL_NOT_IN_CARBON

;  
;  Section events now arrive in the message buffer using the AppleEvent format.
;  The direct object parameter is an aeTemporaryIDParamType ('tid '). The temporary
;  ID's type is rSectionType ('sect') and the 32-bit value is a SectionHandle.
;  The following is a sample buffer
;  
;  name       offset  contents
;  ----       ------  --------
;  header         0   'aevt'
;  majorVersion   4   0x01
;  minorVersion   6   0x01
;  endOfMetaData  8   ';;;;' 
;  directObjKey   12  '----' 
;  paramType      16  'tid ' 
;  paramLength    20  0x0008 
;  tempIDType     24  'sect' 
;  tempID         28  the SectionHandle <-- this is want you want
; 

(defconstant $sectionEventMsgClass :|sect|)
(defconstant $sectionReadMsgID :|read|)
(defconstant $sectionWriteMsgID :|writ|)
(defconstant $sectionScrollMsgID :|scrl|)
(defconstant $sectionCancelMsgID :|cncl|)

(defconstant $currentEditionMgrVers #x11)

; $IFC TARGET_RT_MAC_CFM 
; 	 Use InitEditionPackVersion(currentEditionMgrVers) instead of InitEditionPack 	
#|                                              ; $ELSEC
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  InitEditionPack()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_InitEditionPack" 
      () 
  :signed-integer
   (#x3F3C #x11 #x303C #x100 #xA82D) )

; $ENDC                                         ; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC; TARGET_RT_MAC_CFM

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  InitEditionPackVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_InitEditionPackVersion" 
      ((curEditionMgrVers :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 256 curEditionMgrVers))

; 
;  *  NewSection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; Const
(deftrap "_NewSection" 
      ((container (:pointer :editioncontainerspec)) (sectionDocument (:pointer :fsspec)) (kind :signed-byte) (sectionID :signed-long) (initalMode :signed-integer) (sectionH (:pointer (:handle :sectionrecord))))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 2562 container sectionDocument kind sectionID initalMode sectionH))

; 
;  *  RegisterSection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_RegisterSection" 
      ((sectionDocument (:pointer :fsspec)) (sectionH (:handle :sectionrecord)) (aliasWasUpdated (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 1540 sectionDocument sectionH aliasWasUpdated))

; 
;  *  UnRegisterSection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UnRegisterSection" 
      ((sectionH (:handle :sectionrecord)))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 518 sectionH))

; 
;  *  IsRegisteredSection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_IsRegisteredSection" 
      ((sectionH (:handle :sectionrecord)))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 520 sectionH))

; 
;  *  AssociateSection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_AssociateSection" 
      ((sectionH (:handle :sectionrecord)) (newSectionDocument (:pointer :fsspec)))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 1036 sectionH newSectionDocument))

; 
;  *  CreateEditionContainerFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_CreateEditionContainerFile" 
      ((editionFile (:pointer :fsspec)) (fdCreator :ostype) (editionFileNameScript :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 1294 editionFile fdCreator editionFileNameScript))

; 
;  *  DeleteEditionContainerFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_DeleteEditionContainerFile" 
      ((editionFile (:pointer :fsspec)))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 528 editionFile))

; 
;  *  OpenEdition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_OpenEdition" 
      ((subscriberSectionH (:handle :sectionrecord)) (refNum (:pointer :handle)))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 1042 subscriberSectionH refNum))

; 
;  *  OpenNewEdition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; Const
(deftrap "_OpenNewEdition" 
      ((publisherSectionH (:handle :sectionrecord)) (fdCreator :ostype) (publisherSectionDocument (:pointer :fsspec)) (refNum (:pointer :handle)))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 2068 publisherSectionH fdCreator publisherSectionDocument refNum))

; 
;  *  CloseEdition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CloseEdition" 
      ((whichEdition :handle) (successful :boolean))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 790 whichEdition successful))

; 
;  *  EditionHasFormat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_EditionHasFormat" 
      ((whichEdition :handle) (whichFormat :ostype) (formatSize (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 1560 whichEdition whichFormat formatSize))

; 
;  *  ReadEdition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ReadEdition" 
      ((whichEdition :handle) (whichFormat :ostype) (buffPtr :pointer) (buffLen (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 2074 whichEdition whichFormat buffPtr buffLen))

; 
;  *  WriteEdition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_WriteEdition" 
      ((whichEdition :handle) (whichFormat :ostype) (buffPtr :pointer) (buffLen :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 2076 whichEdition whichFormat buffPtr buffLen))

; 
;  *  GetEditionFormatMark()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetEditionFormatMark" 
      ((whichEdition :handle) (whichFormat :ostype) (currentMark (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 1566 whichEdition whichFormat currentMark))

; 
;  *  SetEditionFormatMark()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetEditionFormatMark" 
      ((whichEdition :handle) (whichFormat :ostype) (setMarkTo :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 1568 whichEdition whichFormat setMarkTo))

; 
;  *  GetEditionInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetEditionInfo" 
      ((sectionH (:handle :sectionrecord)) (editionInfo (:pointer :editioninforecord)))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 1058 sectionH editionInfo))

; 
;  *  GoToPublisherSection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_GoToPublisherSection" 
      ((container (:pointer :editioncontainerspec)))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 548 container))

; 
;  *  GetLastEditionContainerUsed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetLastEditionContainerUsed" 
      ((container (:pointer :editioncontainerspec)))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 550 container))

; 
;  *  GetStandardFormats()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_GetStandardFormats" 
      ((container (:pointer :editioncontainerspec)) (previewFormat (:pointer :ostype)) (preview :handle) (publisherAlias :handle) (formats :handle))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 2600 container previewFormat preview publisherAlias formats))

; 
;  *  GetEditionOpenerProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetEditionOpenerProc" 
      ((opener (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 554 opener))

; 
;  *  SetEditionOpenerProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetEditionOpenerProc" 
      ((opener :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 556 opener))

; 
;  *  CallEditionOpenerProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CallEditionOpenerProc" 
      ((selector :signed-byte) (PB (:pointer :editionopenerparamblock)) (routine :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 1326 selector PB routine))

; 
;  *  CallFormatIOProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CallFormatIOProc" 
      ((selector :signed-byte) (PB (:pointer :formatioparamblock)) (routine :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 1328 selector PB routine))

; 
;  *  NewSubscriberDialog()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_NewSubscriberDialog" 
      ((reply (:pointer :newsubscriberreply)))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 562 reply))

; 
;  *  NewSubscriberExpDialog()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_NewSubscriberExpDialog" 
      ((reply (:pointer :newsubscriberreply)) (where :point) (expansionDITLresID :signed-integer) (dlgHook :pointer) (filter :pointer) (yourDataPtr :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 2868 reply where expansionDITLresID dlgHook filter yourDataPtr))

; 
;  *  NewPublisherDialog()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_NewPublisherDialog" 
      ((reply (:pointer :newpublisherreply)))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 566 reply))

; 
;  *  NewPublisherExpDialog()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_NewPublisherExpDialog" 
      ((reply (:pointer :newpublisherreply)) (where :point) (expansionDITLresID :signed-integer) (dlgHook :pointer) (filter :pointer) (yourDataPtr :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 2872 reply where expansionDITLresID dlgHook filter yourDataPtr))

; 
;  *  SectionOptionsDialog()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SectionOptionsDialog" 
      ((reply (:pointer :sectionoptionsreply)))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 570 reply))

; 
;  *  SectionOptionsExpDialog()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SectionOptionsExpDialog" 
      ((reply (:pointer :sectionoptionsreply)) (where :point) (expansionDITLresID :signed-integer) (dlgHook :pointer) (filter :pointer) (yourDataPtr :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA82D :d0 2876 reply where expansionDITLresID dlgHook filter yourDataPtr))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := EditionsIncludes

; $ENDC                                         ; __EDITIONS__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'Editions)