(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:FileTransferTools.p"
; at Wednesday May 1,2002 2:41:28 pm.
; 
;      File:       FileTransferTools.p
;  
;      Contains:   CommToolbox File Transfer Tools Interfaces.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1988-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __FILETRANSFERTOOLS__
; $SETC __FILETRANSFERTOOLS__ := 1

; $I+
; $SETC FileTransferToolsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __DIALOGS__
|#

(require-interface 'Dialogs)
#|                                              ; $I Dialogs.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILETRANSFERS__
|#

(require-interface 'FileTransfers)
#|                                              ; $I FileTransfers.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; $IFC CALL_NOT_IN_CARBON 

;   DEFs  
(defconstant $fdefType :|fdef|)
(defconstant $fsetType :|fset|)
(defconstant $fvalType :|fval|)
(defconstant $flocType :|floc|)
(defconstant $fscrType :|fscr|)
(defconstant $fbndType :|fbnd|)
(defconstant $fverType :|vers|)

;   control  
(defconstant $ftInitMsg 0)
(defconstant $ftDisposeMsg 1)
(defconstant $ftSuspendMsg 2)
(defconstant $ftResumeMsg 3)
(defconstant $ftMenuMsg 4)
(defconstant $ftEventMsg 5)
(defconstant $ftActivateMsg 6)
(defconstant $ftDeactivateMsg 7)
(defconstant $ftGetErrorStringMsg 8)
(defconstant $ftAbortMsg 52)
(defconstant $ftStartMsg 100)
(defconstant $ftExecMsg 102)
(defconstant $ftSendMsg 103)
(defconstant $ftReceiveMsg 104)

;   setup  
(defconstant $ftSpreflightMsg 0)
(defconstant $ftSsetupMsg 1)
(defconstant $ftSitemMsg 2)
(defconstant $ftSfilterMsg 3)
(defconstant $ftScleanupMsg 4)

;   validate  
(defconstant $ftValidateMsg 0)
(defconstant $ftDefaultMsg 1)

;   scripting  
(defconstant $ftMgetMsg 0)
(defconstant $ftMsetMsg 1)

;   localization  
(defconstant $ftL2English 0)
(defconstant $ftL2Intl 1)

(def-mactype :ftsetupstructptr (find-mactype '(:pointer :ftsetupstruct)))
(defrecord FTSetupStruct 
   (theDialog (:pointer :grafport))             ;   the dialog form the application  
   (count :signed-integer)                      ;   first appended item  
   (theConfig :pointer)                         ;   the config record to setup  
   (procID :signed-integer)                     ;   procID of the tool  
   )

(def-mactype :ftsetupptr (find-mactype '(:pointer :ftsetupstruct)))
; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := FileTransferToolsIncludes

; $ENDC                                         ; __FILETRANSFERTOOLS__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'FileTransferTools)