(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:FileTransfers.p"
; at Wednesday May 1,2002 2:41:26 pm.
; 
;      File:       FileTransfers.p
;  
;      Contains:   CommToolbox File Transfer Manager Interfaces.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1988-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __FILETRANSFERS__
; $SETC __FILETRANSFERS__ := 1

; $I+
; $SETC FileTransfersIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __STANDARDFILE__

(require-interface 'StandardFile)               ; $I StandardFile.p
; $ENDC
#|                                              ; $IFC UNDEFINED __CTBUTILITIES__
|#

(require-interface 'CTBUtilities)
#|                                              ; $I CTBUtilities.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CONNECTIONS__
|#

(require-interface 'Connections)
#|                                              ; $I Connections.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __TERMINALS__

(require-interface 'Terminals)                  ; $I Terminals.p
; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; $IFC CALL_NOT_IN_CARBON 

(defconstant $curFTVersion 2)                   ;   current file transfer manager version 

;   FTErr     
(defconstant $ftGenericError -1)
(defconstant $ftNoErr 0)
(defconstant $ftRejected 1)
(defconstant $ftFailed 2)
(defconstant $ftTimeOut 3)
(defconstant $ftTooManyRetry 4)
(defconstant $ftNotEnoughDSpace 5)
(defconstant $ftRemoteCancel 6)
(defconstant $ftWrongFormat 7)
(defconstant $ftNoTools 8)
(defconstant $ftUserCancel 9)
(defconstant $ftNotSupported 10)

(def-mactype :fterr (find-mactype ':signed-integer))

(defconstant $ftIsFTMode #x1)
(defconstant $ftNoMenus #x2)
(defconstant $ftQuiet #x4)
(defconstant $ftConfigChanged #x10)
(defconstant $ftSucc #x80)

(def-mactype :ftflags (find-mactype ':unsigned-long))

(defconstant $ftSameCircuit #x1)
(defconstant $ftSendDisable #x2)
(defconstant $ftReceiveDisable #x4)
(defconstant $ftTextOnly #x8)
(defconstant $ftNoStdFile #x10)
(defconstant $ftMultipleFileSend #x20)

(def-mactype :ftattributes (find-mactype ':unsigned-integer))

(defconstant $ftReceiving 0)
(defconstant $ftTransmitting 1)
(defconstant $ftFullDuplex 2)                   ;   (16) added ftFullDuplex bit. 

(def-mactype :ftdirection (find-mactype ':unsigned-integer))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	FileTransferDefProcPtr = FUNCTION(hTerm: TermHandle; msg: INTEGER; p1: LONGINT; p2: LONGINT; p3: LONGINT): LONGINT;

|#
 |#                                             ; $ELSEC
(def-mactype :filetransferdefprocptr (find-mactype ':pointer))
; $ENDC

; 	  application routines type definitions 	
(def-mactype :ftrecordptr (find-mactype '(:pointer :ftrecord)))
(def-mactype :ftptr (find-mactype '(:pointer :ftrecord)))
(def-mactype :fthandle (find-mactype '(:handle :ftrecord)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	FileTransferReadProcPtr = FUNCTION(VAR count: UInt32; pData: Ptr; refCon: LONGINT; fileMsg: INTEGER): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :filetransferreadprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	FileTransferWriteProcPtr = FUNCTION(VAR count: UInt32; pData: Ptr; refCon: LONGINT; fileMsg: INTEGER): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :filetransferwriteprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	FileTransferSendProcPtr = FUNCTION(thePtr: Ptr; theSize: LONGINT; refCon: LONGINT; channel: CMChannel; flag: CMFlags): Size;

|#
 |#                                             ; $ELSEC
(def-mactype :filetransfersendprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	FileTransferReceiveProcPtr = FUNCTION(thePtr: Ptr; theSize: LONGINT; refCon: LONGINT; channel: CMChannel; VAR flag: CMFlags): Size;

|#
 |#                                             ; $ELSEC
(def-mactype :filetransferreceiveprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	FileTransferEnvironsProcPtr = FUNCTION(refCon: LONGINT; VAR theEnvirons: ConnEnvironRec): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :filetransferenvironsprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	FileTransferNotificationProcPtr = PROCEDURE(hFT: FTHandle; {CONST}VAR pFSSpec: FSSpec);

|#
 |#                                             ; $ELSEC
(def-mactype :filetransfernotificationprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	FileTransferChooseIdleProcPtr = PROCEDURE;

|#
 |#                                             ; $ELSEC
(def-mactype :filetransferchooseidleprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :filetransferdefupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :filetransferdefupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :filetransferreadupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :filetransferreadupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :filetransferwriteupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :filetransferwriteupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :filetransfersendupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :filetransfersendupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :filetransferreceiveupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :filetransferreceiveupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :filetransferenvironsupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :filetransferenvironsupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :filetransfernotificationupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :filetransfernotificationupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :filetransferchooseidleupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :filetransferchooseidleupp (find-mactype ':pointer))
; $ENDC
(defrecord FTRecord 
   (procID :signed-integer)
   (flags :unsigned-long)
   (errCode :signed-integer)
   (refCon :signed-long)
   (userData :signed-long)
   (defProc :pointer)
   (config :pointer)
   (oldConfig :pointer)
   (environsProc :pointer)
   (reserved1 :signed-long)
   (reserved2 :signed-long)
   (ftPrivate :pointer)
   (sendProc :pointer)
   (recvProc :pointer)
   (writeProc :pointer)
   (readProc :pointer)
   (owner (:pointer :windowrecord))
   (direction :unsigned-integer)
   (theReply :sfreply)
   (writePtr :signed-long)
   (readPtr :signed-long)
   (theBuf :pointer)
   (bufSize :signed-long)
   (autoRec (:string 255))
   (attributes :unsigned-integer)
   )

(def-mactype :ftcompletionkind (find-mactype ':unsigned-integer))

;   FTReadProc messages  
(defconstant $ftReadOpenFile 0)                 ;   count = forkFlags, buffer = pblock from PBGetFInfo  
(defconstant $ftReadDataFork 1)
(defconstant $ftReadRsrcFork 2)
(defconstant $ftReadAbort 3)
(defconstant $ftReadComplete 4)
(defconstant $ftReadSetFPos 6)                  ;   count = forkFlags, buffer = pBlock same as PBSetFPos  
(defconstant $ftReadGetFPos 7)                  ;   count = forkFlags, buffer = pBlock same as PBGetFPos  

;   FTWriteProc messages  
(defconstant $ftWriteOpenFile 0)                ;   count = forkFlags, buffer = pblock from PBGetFInfo  
(defconstant $ftWriteDataFork 1)
(defconstant $ftWriteRsrcFork 2)
(defconstant $ftWriteAbort 3)
(defconstant $ftWriteComplete 4)
(defconstant $ftWriteFileInfo 5)
(defconstant $ftWriteSetFPos 6)                 ;   count = forkFlags, buffer = pBlock same as PBSetFPos  
(defconstant $ftWriteGetFPos 7)                 ;   count = forkFlags, buffer = pBlock same as PBGetFPos  

;      fork flags  
(defconstant $ftOpenDataFork 1)
(defconstant $ftOpenRsrcFork 2)

(defconstant $uppFileTransferDefProcInfo #xFEF0)
(defconstant $uppFileTransferReadProcInfo #x2FE0)
(defconstant $uppFileTransferWriteProcInfo #x2FE0)
(defconstant $uppFileTransferSendProcInfo #xAFF0)
(defconstant $uppFileTransferReceiveProcInfo #xEFF0)
(defconstant $uppFileTransferEnvironsProcInfo #x3E0)
(defconstant $uppFileTransferNotificationProcInfo #x3C0)
(defconstant $uppFileTransferChooseIdleProcInfo #x0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewFileTransferDefUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewFileTransferDefProc 
(deftrap "_NewFileTransferDefUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewFileTransferReadUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewFileTransferReadProc 
(deftrap "_NewFileTransferReadUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewFileTransferWriteUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewFileTransferWriteProc 
(deftrap "_NewFileTransferWriteUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewFileTransferSendUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewFileTransferSendProc 
(deftrap "_NewFileTransferSendUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewFileTransferReceiveUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewFileTransferReceiveProc 
(deftrap "_NewFileTransferReceiveUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewFileTransferEnvironsUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewFileTransferEnvironsProc 
(deftrap "_NewFileTransferEnvironsUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewFileTransferNotificationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewFileTransferNotificationProc 
(deftrap "_NewFileTransferNotificationUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewFileTransferChooseIdleUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewFileTransferChooseIdleProc 
(deftrap "_NewFileTransferChooseIdleUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeFileTransferDefUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeFileTransferDefUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeFileTransferReadUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeFileTransferReadUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeFileTransferWriteUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeFileTransferWriteUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeFileTransferSendUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeFileTransferSendUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeFileTransferReceiveUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeFileTransferReceiveUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeFileTransferEnvironsUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeFileTransferEnvironsUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeFileTransferNotificationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeFileTransferNotificationUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeFileTransferChooseIdleUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeFileTransferChooseIdleUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeFileTransferDefUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallFileTransferDefProc 
(deftrap-inline "_InvokeFileTransferDefUPP" 
      ((hTerm (:handle :termrecord)) (msg :signed-integer) (p1 :signed-long) (p2 :signed-long) (p3 :signed-long) (userRoutine :pointer)) 
  :signed-long
   (#x205F #x4E90) )

; 
;  *  InvokeFileTransferReadUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallFileTransferReadProc 
(deftrap-inline "_InvokeFileTransferReadUPP" 
      ((count (:pointer :unsigned-long)) (pData :pointer) (refCon :signed-long) (fileMsg :signed-integer) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeFileTransferWriteUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallFileTransferWriteProc 
(deftrap-inline "_InvokeFileTransferWriteUPP" 
      ((count (:pointer :unsigned-long)) (pData :pointer) (refCon :signed-long) (fileMsg :signed-integer) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeFileTransferSendUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallFileTransferSendProc 
(deftrap-inline "_InvokeFileTransferSendUPP" 
      ((thePtr :pointer) (theSize :signed-long) (refCon :signed-long) (channel :signed-integer) (flag :unsigned-integer) (userRoutine :pointer)) 
  :signed-long
   (#x205F #x4E90) )

; 
;  *  InvokeFileTransferReceiveUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallFileTransferReceiveProc 
(deftrap-inline "_InvokeFileTransferReceiveUPP" 
      ((thePtr :pointer) (theSize :signed-long) (refCon :signed-long) (channel :signed-integer) (flag (:pointer :unsigned-integer)) (userRoutine :pointer)) 
  :signed-long
   (#x205F #x4E90) )

; 
;  *  InvokeFileTransferEnvironsUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallFileTransferEnvironsProc 
(deftrap-inline "_InvokeFileTransferEnvironsUPP" 
      ((refCon :signed-long) (theEnvirons (:pointer :connenvironrec)) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeFileTransferNotificationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ;  old name was CallFileTransferNotificationProc 
(deftrap-inline "_InvokeFileTransferNotificationUPP" 
      ((hFT (:handle :ftrecord)) (pFSSpec (:pointer :fsspec)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeFileTransferChooseIdleUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallFileTransferChooseIdleProc 
(deftrap "_InvokeFileTransferChooseIdleUPP" 
      ((userRoutine :pointer))
   nil
   (:register-trap #x4E90 :a0 userRoutine))

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  InitFT()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  FTGetVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InitFT" 
      () 
  :fterr
   () )                                         ; 
;  *  FTGetFTVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTGetVersion" 
      ((hFT (:handle :ftrecord))) 
  :handle
   () )                                         ; 
;  *  FTNew()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTGetFTVersion" 
      () 
  :signed-integer
   () )                                         ; 
;  *  FTDispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTNew" 
      ((procID :signed-integer) (flags :unsigned-long) (sendProc :pointer) (recvProc :pointer) (readProc :pointer) (writeProc :pointer) (environsProc :pointer) (owner (:pointer :windowrecord)) (refCon :signed-long) (userData :signed-long)) 
  (:handle :ftrecord)
   () )                                         ; 
;  *  FTStart()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTDispose" 
      ((hFT (:handle :ftrecord))) 
  nil
   () )                                         ; CONST; 
;  *  FTAbort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTStart" 
      ((hFT (:handle :ftrecord)) (direction :unsigned-integer) (fileInfo (:pointer :sfreply))) 
  :fterr
   () )                                         ; 
;  *  FTSend()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTAbort" 
      ((hFT (:handle :ftrecord))) 
  :fterr
   () )                                         ; 
;  *  FTReceive()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTSend" 
      ((hFT (:handle :ftrecord)) (numFiles :signed-integer) (pFSSpec (:pointer :fsspecarray)) (notifyProc :pointer)) 
  :fterr
   () )                                         ; 
;  *  FTExec()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTReceive" 
      ((hFT (:handle :ftrecord)) (pFSSpec (:pointer :fsspec)) (notifyProc :pointer)) 
  :fterr
   () )                                         ; 
;  *  FTActivate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTExec" 
      ((hFT (:handle :ftrecord))) 
  nil
   () )                                         ; 
;  *  FTResume()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTActivate" 
      ((hFT (:handle :ftrecord)) (activate :boolean)) 
  nil
   () )                                         ; 
;  *  FTMenu()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTResume" 
      ((hFT (:handle :ftrecord)) (resume :boolean)) 
  nil
   () )                                         ; 
;  *  FTChoose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTMenu" 
      ((hFT (:handle :ftrecord)) (menuID :signed-integer) (item :signed-integer)) 
  :boolean
   () )                                         ; 
;  *  FTEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTChoose" 
      ((hFT (:pointer (:handle :ftrecord))) (where :point) (idleProc :pointer)) 
  :signed-integer
   () )                                         ; CONST; 
;  *  FTValidate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTEvent" 
      ((hFT (:handle :ftrecord)) (theEvent (:pointer :eventrecord))) 
  nil
   () )                                         ; 
;  *  FTDefault()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTValidate" 
      ((hFT (:handle :ftrecord))) 
  :boolean
   () )                                         ; 
;  *  FTSetupPreflight()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTDefault" 
      ((theConfig (:pointer :pointer)) (procID :signed-integer) (allocate :boolean)) 
  nil
   () )                                         ; 
;  *  FTSetupSetup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTSetupPreflight" 
      ((procID :signed-integer) (magicCookie (:pointer :signed-long))) 
  :handle
   () )                                         ; 
;  *  FTSetupFilter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTSetupSetup" 
      ((procID :signed-integer) (theConfig :pointer) (count :signed-integer) (theDialog (:pointer :grafport)) (magicCookie (:pointer :signed-long))) 
  nil
   () )                                         ; 
;  *  FTSetupItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTSetupFilter" 
      ((procID :signed-integer) (theConfig :pointer) (count :signed-integer) (theDialog (:pointer :grafport)) (theEvent (:pointer :eventrecord)) (theItem (:pointer :signed-integer)) (magicCookie (:pointer :signed-long))) 
  :boolean
   () )                                         ; 
;  *  FTSetupXCleanup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTSetupItem" 
      ((procID :signed-integer) (theConfig :pointer) (count :signed-integer) (theDialog (:pointer :grafport)) (theItem (:pointer :signed-integer)) (magicCookie (:pointer :signed-long))) 
  nil
   () )                                         ; 
;  *  FTSetupPostflight()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTSetupXCleanup" 
      ((procID :signed-integer) (theConfig :pointer) (count :signed-integer) (theDialog (:pointer :grafport)) (OKed :boolean) (magicCookie (:pointer :signed-long))) 
  nil
   () )                                         ; 
;  *  FTGetConfig()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTSetupPostflight" 
      ((procID :signed-integer)) 
  nil
   () )                                         ; 
;  *  FTSetConfig()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTGetConfig" 
      ((hFT (:handle :ftrecord))) 
  :pointer
   () )                                         ; 
;  *  FTIntlToEnglish()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTSetConfig" 
      ((hFT (:handle :ftrecord)) (thePtr :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  FTEnglishToIntl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTIntlToEnglish" 
      ((hFT (:handle :ftrecord)) (inputPtr :pointer) (outputPtr (:pointer :pointer)) (language :signed-integer)) 
  :fterr
   () )                                         ; 
;  *  FTGetToolName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTEnglishToIntl" 
      ((hFT (:handle :ftrecord)) (inputPtr :pointer) (outputPtr (:pointer :pointer)) (language :signed-integer)) 
  :fterr
   () )                                         ; 
;  *  FTGetProcID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTGetToolName" 
      ((procID :signed-integer) (name (:pointer (:string 255)))) 
  nil
   () )                                         ; 
;  *  FTSetRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTGetProcID" 
      ((name (:string 255))) 
  :signed-integer
   () )                                         ; 
;  *  FTGetRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTSetRefCon" 
      ((hFT (:handle :ftrecord)) (refCon :signed-long)) 
  nil
   () )                                         ; 
;  *  FTSetUserData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTGetRefCon" 
      ((hFT (:handle :ftrecord))) 
  :signed-long
   () )                                         ; 
;  *  FTGetUserData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTSetUserData" 
      ((hFT (:handle :ftrecord)) (userData :signed-long)) 
  nil
   () )                                         ; 
;  *  FTGetErrorString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTGetUserData" 
      ((hFT (:handle :ftrecord))) 
  :signed-long
   () )                                         ; 
;     These Async routines were added to InterfaceLib in System 7.5
;                                               ; 
;  *  FTSendAsync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTGetErrorString" 
      ((hFT (:handle :ftrecord)) (id :signed-integer) (errMsg (:pointer (:string 255)))) 
  nil
   () )                                         ; 
;  *  FTReceiveAsync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTSendAsync" 
      ((hFT (:handle :ftrecord)) (numFiles :signed-integer) (pFSSpec (:pointer :fsspecarray)) (notifyProc :pointer)) 
  :fterr
   () )                                         ; 
;  *  FTCompletionAsync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_FTReceiveAsync" 
      ((hFT (:handle :ftrecord)) (pFSSpec (:pointer :fsspec)) (notifyProc :pointer)) 
  :fterr
   () )
(deftrap-inline "_FTCompletionAsync" 
      ((hFT (:handle :ftrecord)) (completionCall :unsigned-integer)) 
  :fterr
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := FileTransfersIncludes

; $ENDC                                         ; __FILETRANSFERS__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'FileTransfers)