(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Finder.p"
; at Wednesday May 1,2002 2:39:01 pm.
; 
;      File:       Finder.p
;  
;      Contains:   Finder flags and container types.
;  
;      Version:    Technology: Mac OS 8.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1990-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __FINDER__
; $SETC __FINDER__ := 1

; $I+
; $SETC FinderIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  Creator and type of clipping files 

(defconstant $kClippingCreator :|drag|)
(defconstant $kClippingPictureType :|clpp|)
(defconstant $kClippingTextType :|clpt|)
(defconstant $kClippingSoundType :|clps|)
(defconstant $kClippingUnknownType :|clpu|)

; 	 Creator and type of Internet Location files 	
(defconstant $kInternetLocationCreator :|drag|)
(defconstant $kInternetLocationHTTP :|ilht|)
(defconstant $kInternetLocationFTP :|ilft|)
(defconstant $kInternetLocationFile :|ilfi|)
(defconstant $kInternetLocationMail :|ilma|)
(defconstant $kInternetLocationNNTP :|ilnw|)
(defconstant $kInternetLocationAFP :|ilaf|)
(defconstant $kInternetLocationAppleTalk :|ilat|)
(defconstant $kInternetLocationNSL :|ilns|)
(defconstant $kInternetLocationGeneric :|ilge|)

(defconstant $kCustomIconResource -16455)       ;   Custom icon family resource ID  

; 	 In order to specify any of the information described in the 	
; 	 CustomBadgeResource data structure you must clear the kExtendedFlagsAreInvalid 	
; 	 and set kExtendedFlagHasCustomBadge of the FXInfo.fdXFlags or DXInfo.frXFlags field, 	
; 	 and add a resource of type kCustomBadgeResourceType and ID kCustomBadgeResourceID to 	
; 	 the file or to the "Icon/n" file for a folder 	
(defconstant $kCustomBadgeResourceType :|badg|)
(defconstant $kCustomBadgeResourceID -16455)
(defconstant $kCustomBadgeResourceVersion 0)

(def-mactype :custombadgeresourceptr (find-mactype '(:pointer :custombadgeresource)))
(defrecord CustomBadgeResource 
   (version :signed-integer)                    ;   This is version kCustomBadgeResourceVersion 
   (customBadgeResourceID :signed-integer)      ;   If not 0, the ID of a resource to use on top 
;   of the icon for this file or folder 
   (customBadgeType :ostype)                    ;   If not 0, the type and creator of an icon 
   (customBadgeCreator :ostype)                 ;   to use on top of the icon 
   (windowBadgeType :ostype)                    ;   If not 0, the type and creator of an icon 
   (windowBadgeCreator :ostype)                 ;   to display in the header of the window for this  
;   file or folder 
   (overrideType :ostype)                       ;   If not 0, the type and creator of an icon to 
   (overrideCreator :ostype)                    ;   use INSTEAD of the icon for this file or folder 
   )

(def-mactype :custombadgeresourcehandle (find-mactype '(:handle :custombadgeresource)))
; 	 You can specify routing information for a file by including a 'rout' 0 
; 	    resource in it and setting the kExtendedFlagHasRoutingInfo bit in the extended 
; 	    Finder flags. 
; 	    The 'rout' resource is an array of RoutingResourceEntry. Each entry is considered
; 	    in turn. The first matching entry is used.
; 	    If the creator and fileType match the file being dropped and targetFolder match
; 	    the folder ID of the folder being dropped onto, then the file is rerouted 
; 	    into the specified destination folder.
; 	    The only target folder currently supported is the system folder, 
; 	    kSystemFolderType = 'macs'.
; 		

(defconstant $kRoutingResourceType :|rout|)
(defconstant $kRoutingResourceID 0)

(def-mactype :routingresourceentryptr (find-mactype '(:pointer :routingresourceentry)))
(defrecord RoutingResourceEntry 
   (creator :ostype)                            ;   Use '****' or 0 to match any creator  
   (fileType :ostype)                           ;   Use '****' or 0 to match any file type  
   (targetFolder :ostype)                       ;   Folder ID of the folder this file was dropped onto  
   (destinationFolder :ostype)                  ;   Folder that the source will be routed to  
   (reservedField :ostype)                      ;   Set to 0  
   )

(def-mactype :routingresourceptr (find-mactype '(:pointer :routingresourceentry)))
(def-mactype :routingresourcehandle (find-mactype '(:handle :routingresourceentry)))

; 	 Types for special container aliases 	

(defconstant $kContainerFolderAliasType :|fdrp|);   type for folder aliases  
(defconstant $kContainerTrashAliasType :|trsh|) ;   type for trash folder aliases  
(defconstant $kContainerHardDiskAliasType :|hdsk|);   type for hard disk aliases  
(defconstant $kContainerFloppyAliasType :|flpy|);   type for floppy aliases  
(defconstant $kContainerServerAliasType :|srvr|);   type for server aliases  
(defconstant $kApplicationAliasType :|adrp|)    ;   type for application aliases  
(defconstant $kContainerAliasType :|drop|)      ;   type for all other containers  
(defconstant $kDesktopPrinterAliasType :|dtpa|) ;   type for Desktop Printer alias  
(defconstant $kContainerCDROMAliasType :|cddr|) ;   type for CD-ROM alias  
(defconstant $kApplicationCPAliasType :|acdp|)  ;   type for application control panel alias  
(defconstant $kApplicationDAAliasType :|addp|)  ;   type for application DA alias  
(defconstant $kPackageAliasType :|fpka|)        ;   type for plain package alias  
(defconstant $kAppPackageAliasType :|fapa|)     ;   type for application package alias  

; 	 Types for Special folder aliases 	
(defconstant $kSystemFolderAliasType :|fasy|)
(defconstant $kAppleMenuFolderAliasType :|faam|)
(defconstant $kStartupFolderAliasType :|fast|)
(defconstant $kPrintMonitorDocsFolderAliasType :|fapn|)
(defconstant $kPreferencesFolderAliasType :|fapf|)
(defconstant $kControlPanelFolderAliasType :|fact|)
(defconstant $kExtensionFolderAliasType :|faex|)

; 	 Types for AppleShare folder aliases 	
(defconstant $kExportedFolderAliasType :|faet|)
(defconstant $kDropFolderAliasType :|fadr|)
(defconstant $kSharedFolderAliasType :|fash|)
(defconstant $kMountedFolderAliasType :|famn|)

; 	 Finder flags (finderFlags, fdFlags and frFlags) 	
; 	 Any flag reserved or not specified should be set to 0. 	
; 	 If a flag applies to a file, but not to a folder, make sure to check 	
; 	 that the item is not a folder by checking ((ParamBlockRec.ioFlAttrib & ioDirMask) == 0) 	
(defconstant $kIsOnDesk #x1)                    ;   Files and folders (System 6)  
(defconstant $kColor #xE)                       ;   Files and folders  
;   bit 0x0020 was kRequireSwitchLaunch, but is now reserved for future use 
(defconstant $kIsShared #x40)                   ;   Files only (Applications only)  
;   If clear, the application needs to write to  
;   its resource fork, and therefore cannot be  
;   shared on a server  
(defconstant $kHasNoINITs #x80)                 ;   Files only (Extensions/Control Panels only)  
;   This file contains no INIT resource  
(defconstant $kHasBeenInited #x100)             ;   Files only  
;   Clear if the file contains desktop database  
;   resources ('BNDL', 'FREF', 'open', 'kind'...)  
;   that have not been added yet. Set only by the Finder  
;   Reserved for folders - make sure this bit is cleared for folders  
;   bit 0x0200 was the letter bit for AOCE, but is now reserved for future use  
(defconstant $kHasCustomIcon #x400)             ;   Files and folders  
(defconstant $kIsStationery #x800)              ;   Files only  
(defconstant $kNameLocked #x1000)               ;   Files and folders  
(defconstant $kHasBundle #x2000)                ;   Files only  
(defconstant $kIsInvisible #x4000)              ;   Files and folders  
(defconstant $kIsAlias #x8000)                  ;   Files only  

; 	 Obsolete. Use names defined above. 	
(defconstant $fOnDesk #x1)
(defconstant $fHasBundle #x2000)
(defconstant $fInvisible #x4000)

; 	 Obsolete 	
(defconstant $fTrash -3)
(defconstant $fDesktop -2)
(defconstant $fDisk 0)

; $IFC OLDROUTINENAMES 
(defconstant $kIsStationary #x800)

; $ENDC                                         ; OLDROUTINENAMES

; 	 Extended flags (extendedFinderFlags, fdXFlags and frXFlags) 	
; 	 Any flag not specified should be set to 0. 	
(defconstant $kExtendedFlagsAreInvalid #x8000)  ;   If set the other extended flags are ignored  
(defconstant $kExtendedFlagHasCustomBadge #x100);   Set if the file or folder has a badge resource  
(defconstant $kExtendedFlagHasRoutingInfo #x4)  ;   Set if the file contains routing info resource  

; 	 Use a filetype in this range to indicate that a file is temporarily busy 	
; 	 (while it is being downloaded or installed, for example).  This prevents 	
; 	 Finder 8.5 and later from trying to change the item's attributes before it 	
; 	 is fully created. -- If you provide a series of 'BNDL' icons for your creator 	
; 	 and some of these filetypes, you can achieve limited icon animation while 	
; 	 the file creation progresses. 	
(defconstant $kFirstMagicBusyFiletype :|bzy |)
(defconstant $kLastMagicBusyFiletype :|bzy?|)

; 	 Use this date as a file's or folder's creation date to indicate that it is 	
; 	 temporarily busy (while it is being downloaded or installed, for example). 	
; 	 This prevents Finder from trying to change the item's attributes before it 	
; 	 is fully created (Finder 8.5 and 8.6 check file creation dates; later Finders 	
; 	 may check folder creation dates as well). 	
(defconstant $kMagicBusyCreationDate #x4F3AFDB0)

; 	------------------------------------------------------------------------	
; 
; 	   The following data structures are binary compatible with FInfo, DInfo,
; 	   FXInfo and DXInfo but represent the Mac OS 8 semantic of the fields.
; 	   Use these data structures preferably to FInfo, etc...
; 	
; 	------------------------------------------------------------------------	

(def-mactype :fileinfoptr (find-mactype '(:pointer :fileinfo)))
(defrecord FileInfo 
   (fileType :ostype)                           ;   The type of the file  
   (fileCreator :ostype)                        ;   The file's creator  
   (finderFlags :unsigned-integer)              ;   ex: kHasBundle, kIsInvisible...  
   (location :point)                            ;   File's location in the folder  
;   If set to (0, 0), the Finder will place the item automatically  
   (reservedField :unsigned-integer)            ;   (set to 0)  
   )

(def-mactype :folderinfoptr (find-mactype '(:pointer :folderinfo)))
(defrecord FolderInfo 
   (windowBounds :rect)                         ;   The position and dimension of the folder's window  
   (finderFlags :unsigned-integer)              ;   ex. kIsInvisible, kNameLocked, etc. 
   (location :point)                            ;   Folder's location in the parent folder  
;   If set to (0, 0), the Finder will place the item automatically  
   (reservedField :unsigned-integer)            ;   (set to 0)  
   )

(def-mactype :extendedfileinfoptr (find-mactype '(:pointer :extendedfileinfo)))
(defrecord ExtendedFileInfo 
   (reserved1 (:array :signed-integer 4))       ;   Reserved (set to 0)  
   (extendedFinderFlags :unsigned-integer)      ;   Extended flags (custom badge, routing info...)  
   (reserved2 :signed-integer)                  ;   Reserved (set to 0). Comment ID if high-bit is clear  
   (putAwayFolderID :signed-long)               ;   Put away folder ID  
   )

(def-mactype :extendedfolderinfoptr (find-mactype '(:pointer :extendedfolderinfo)))
(defrecord ExtendedFolderInfo 
   (scrollPosition :point)                      ;   Scroll position (for icon views)  
   (reserved1 :signed-long)                     ;   Reserved (set to 0)  
   (extendedFinderFlags :unsigned-integer)      ;   Extended flags (custom badge, routing info...)  
   (reserved2 :signed-integer)                  ;   Reserved (set to 0). Comment ID if high-bit is clear  
   (putAwayFolderID :signed-long)               ;   Put away folder ID  
   )

; 	------------------------------------------------------------------------	
; 
; 	   The following data structures are here for compatibility.
; 	   Use the new data structures replacing them if possible (i.e. FileInfo 
; 	   instead of FInfo, etc...)
; 	
; 	------------------------------------------------------------------------	
; 	 File info 	
; 
; 	     IMPORTANT:
; 	     In MacOS 8, the fdFldr field has become reserved for the Finder.
; 	
(def-mactype :finfoptr (find-mactype '(:pointer :finfo)))
(defrecord FInfo 
   (fdType :ostype)                             ;   The type of the file  
   (fdCreator :ostype)                          ;   The file's creator  
   (fdFlags :unsigned-integer)                  ;   Flags ex. kHasBundle, kIsInvisible, etc.  
   (fdLocation :point)                          ;   File's location in folder.  
;   If set to (0, 0), the Finder will place the item automatically  
   (fdFldr :signed-integer)                     ;   Reserved (set to 0)  
   )

; 	 Extended file info 	
; 
; 	     IMPORTANT:
; 	     In MacOS 8, the fdIconID and fdComment fields were changed
; 	     to become reserved fields for the Finder.
; 	     The fdScript has become an extended flag.
; 	
(def-mactype :fxinfoptr (find-mactype '(:pointer :fxinfo)))
(defrecord FXInfo 
   (fdIconID :signed-integer)                   ;   Reserved (set to 0)  
   (fdReserved (:array :signed-integer 3))      ;   Reserved (set to 0)  
   (fdScript :signed-byte)                      ;   Extended flags. Script code if high-bit is set  
   (fdXFlags :signed-byte)                      ;   Extended flags  
   (fdComment :signed-integer)                  ;   Reserved (set to 0). Comment ID if high-bit is clear  
   (fdPutAway :signed-long)                     ;   Put away folder ID  
   )

; 	 Folder info 	
; 
; 	     IMPORTANT:
; 	     In MacOS 8, the frView field was changed to become reserved 
; 	     field for the Finder.
; 	
(def-mactype :dinfoptr (find-mactype '(:pointer :dinfo)))
(defrecord DInfo 
   (frRect :rect)                               ;   Folder's window bounds  
   (frFlags :unsigned-integer)                  ;   Flags ex. kIsInvisible, kNameLocked, etc. 
   (frLocation :point)                          ;   Folder's location in parent folder  
;   If set to (0, 0), the Finder will place the item automatically  
   (frView :signed-integer)                     ;   Reserved (set to 0)  
   )

; 	 Extended folder info 	
; 
; 	     IMPORTANT:
; 	     In MacOS 8, the frOpenChain and frComment fields were changed
; 	     to become reserved fields for the Finder.
; 	     The frScript has become an extended flag.
; 	
(def-mactype :dxinfoptr (find-mactype '(:pointer :dxinfo)))
(defrecord DXInfo 
   (frScroll :point)                            ;   Scroll position  
   (frOpenChain :signed-long)                   ;   Reserved (set to 0)  
   (frScript :signed-byte)                      ;   Extended flags. Script code if high-bit is set  
   (frXFlags :signed-byte)                      ;   Extended flags  
   (frComment :signed-integer)                  ;   Reserved (set to 0). Comment ID if high-bit is clear  
   (frPutAway :signed-long)                     ;   Put away folder ID  
   )

;   ControlPanelDefProcPtr and cdev constants have all been moved to Processes.i 
; $ALIGN RESET
; $POP

; $SETC UsingIncludes := FinderIncludes

; $ENDC                                         ; __FINDER__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Finder)