(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:FixMath.p"
; at Wednesday May 1,2002 2:39:56 pm.
; 
;      File:       FixMath.p
;  
;      Contains:   Fixed Math Interfaces.
;  
;      Version:    Technology: Mac OS 8
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __FIXMATH__
; $SETC __FIXMATH__ := 1

; $I+
; $SETC FixMathIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $fixed1 #x10000)
(defconstant $fract1 #x40000000)
(defconstant $positiveInfinity #x7FFFFFFF)
(defconstant $negativeInfinity #x80000000)

; 	
; 	    FixRatio, FixMul, and FixRound were previously in ToolUtils.h
; 		
; 
; 	 *  FixRatio()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_FixRatio" 
      ((numer :signed-integer) (denom :signed-integer))
   (:stack :fixed)
   (:stack-trap #xA869))

; 
;  *  FixMul()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FixMul" 
      ((a :signed-long) (b :signed-long))
   (:stack :fixed)
   (:stack-trap #xA868))

; 
;  *  FixRound()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FixRound" 
      ((x :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA86C))

; 
;  *  Fix2Frac()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_Fix2Frac" 
      ((x :signed-long))
   (:stack :fract)
   (:stack-trap #xA841))

; 
;  *  Fix2Long()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_Fix2Long" 
      ((x :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA840))

; 
;  *  Long2Fix()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_Long2Fix" 
      ((x :signed-long))
   (:stack :fixed)
   (:stack-trap #xA83F))

; 
;  *  Frac2Fix()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_Frac2Fix" 
      ((x :signed-long))
   (:stack :fixed)
   (:stack-trap #xA842))

; 
;  *  FracMul()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FracMul" 
      ((x :signed-long) (y :signed-long))
   (:stack :fract)
   (:stack-trap #xA84A))

; 
;  *  FixDiv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FixDiv" 
      ((x :signed-long) (y :signed-long))
   (:stack :fixed)
   (:stack-trap #xA84D))

; 
;  *  FracDiv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FracDiv" 
      ((x :signed-long) (y :signed-long))
   (:stack :fract)
   (:stack-trap #xA84B))

; 
;  *  FracSqrt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FracSqrt" 
      ((x :signed-long))
   (:stack :fract)
   (:stack-trap #xA849))

; 
;  *  FracSin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FracSin" 
      ((x :signed-long))
   (:stack :fract)
   (:stack-trap #xA848))

; 
;  *  FracCos()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FracCos" 
      ((x :signed-long))
   (:stack :fract)
   (:stack-trap #xA847))

; 
;  *  FixATan2()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FixATan2" 
      ((x :signed-long) (y :signed-long))
   (:stack :fixed)
   (:stack-trap #xA818))

; 
;     Frac2X, Fix2X, X2Fix, and X2Frac translate to and from
;     the floating point type "extended" (that's what the X is for).
;     On the original Mac this was 80-bits and the functions could be
;     accessed via A-Traps.  When the 68881 co-processor was added,
;     it used 96-bit floating point types, so the A-Traps could not 
;     be used.  When PowerPC was added, it used 64-bit floating point
;     types, so yet another prototype was added.
; 
#|                                              ; $IFC TARGET_CPU_68K 
; $IFC TARGET_RT_MAC_68881 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Frac2X()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  Fix2X()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_Frac2X" 
      ((x :signed-long)) 
  :pointer
   () )                                         ; 
;  *  X2Fix()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_Fix2X" 
      ((x :signed-long)) 
  :pointer
   () )                                         ; 
;  *  X2Frac()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_X2Fix" 
      ((x :pointer)) 
  :fixed
   () )
(deftrap-inline "_X2Frac" 
      ((x :pointer)) 
  :fract
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; $ELSEC
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Frac2X()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_Frac2X" 
      ((x :signed-long))
   (:stack :pointer)
   (:stack-trap #xA845))

; 
;  *  Fix2X()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_Fix2X" 
      ((x :signed-long))
   (:stack :pointer)
   (:stack-trap #xA843))

; 
;  *  X2Fix()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_X2Fix" 
      ((x :pointer))
   (:stack :fixed)
   (:stack-trap #xA844))

; 
;  *  X2Frac()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_X2Frac" 
      ((x :pointer))
   (:stack :fract)
   (:stack-trap #xA846))

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; TARGET_RT_MAC_68881
 |#                                             ; $ELSEC
; 
;  *  Frac2X()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  Fix2X()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_Frac2X" 
      ((x :signed-long)) 
  :double-float
   () )                                         ; 
;  *  X2Fix()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_Fix2X" 
      ((x :signed-long)) 
  :double-float
   () )                                         ; 
;  *  X2Frac()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_X2Fix" 
      ((x :double-float)) 
  :fixed
   () )
(deftrap-inline "_X2Frac" 
      ((x :double-float)) 
  :fract
   () )                                         ; $ENDC; TARGET_CPU_68K

;   QuickTime 3.0 makes these Wide routines available on other platforms 
#|                                              ; $IFC TARGET_CPU_PPC OR NOT TARGET_OS_MAC 
; 
;  *  WideCompare()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap-inline "_WideCompare" 
      ((target (:pointer :wide)) (source (:pointer :wide))) 
  :signed-integer
   () )

; 
;  *  WideAdd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_WideAdd" 
      ((target (:pointer :wide)) (source (:pointer :wide))) 
  (:pointer :wide)
   () )

; 
;  *  WideSubtract()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_WideSubtract" 
      ((target (:pointer :wide)) (source (:pointer :wide))) 
  (:pointer :wide)
   () )

; 
;  *  WideNegate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_WideNegate" 
      ((target (:pointer :wide))) 
  (:pointer :wide)
   () )

; 
;  *  WideShift()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_WideShift" 
      ((target (:pointer :wide)) (shift :signed-long)) 
  (:pointer :wide)
   () )

; 
;  *  WideSquareRoot()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_WideSquareRoot" 
      ((source (:pointer :wide))) 
  :unsigned-long
   () )

; 
;  *  WideMultiply()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_WideMultiply" 
      ((multiplicand :signed-long) (multiplier :signed-long) (target (:pointer :wide))) 
  (:pointer :wide)
   () )

;  returns the quotient 
; 
;  *  WideDivide()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_WideDivide" 
      ((dividend (:pointer :wide)) (divisor :signed-long) (remainder (:pointer :signed-long))) 
  :signed-long
   () )

;  quotient replaces dividend 
; 
;  *  WideWideDivide()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_WideWideDivide" 
      ((dividend (:pointer :wide)) (divisor :signed-long) (remainder (:pointer :signed-long))) 
  (:pointer :wide)
   () )

; 
;  *  WideBitShift()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_WideBitShift" 
      ((src (:pointer :wide)) (shift :signed-long)) 
  (:pointer :wide)
   () )

 |#                                             ; $ENDC

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := FixMathIncludes

; $ENDC                                         ; __FIXMATH__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'FixMath)