(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:GXEnvironment.p"
; at Wednesday May 1,2002 2:41:30 pm.
; 
;      File:       GXEnvironment.p
;  
;      Contains:   QuickDraw GX environment constants and interfaces
;  
;      Version:    Technology: Quickdraw GX 1.1
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1994-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __GXENVIRONMENT__
; $SETC __GXENVIRONMENT__ := 1

; $I+
; $SETC GXEnvironmentIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __GXTYPES__

(require-interface 'GXTypes)                    ; $I GXTypes.p
; $ENDC
#|                                              ; $IFC UNDEFINED __CMAPPLICATION__
|#

(require-interface 'CMApplication)
#|                                              ; $I CMApplication.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $defaultPollingHandlerFlags #x0)
(defconstant $okToSwitchDuringPollFlag #x0)
(defconstant $dontSwitchDuringPollFlag #x1)

(def-mactype :gxpollinghandlerflags (find-mactype ':signed-long))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	gxPollingHandlerProcPtr = PROCEDURE(reference: LONGINT; flags: gxPollingHandlerFlags); C;

|#
 |#                                             ; $ELSEC
(def-mactype :gxpollinghandlerprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :gxpollinghandlerupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :gxpollinghandlerupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppgxPollingHandlerProcInfo #x3C1)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewgxPollingHandlerUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewgxPollingHandlerProc 
(deftrap "_NewgxPollingHandlerUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposegxPollingHandlerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposegxPollingHandlerUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokegxPollingHandlerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallgxPollingHandlerProc 
(deftrap-inline "_InvokegxPollingHandlerUPP" 
      ((reference :signed-long) (flags :signed-long) (userRoutine :pointer)) 
  nil
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  GXGetGraphicsPollingHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXGetGraphicsPollingHandler" 
      ((reference (:pointer :signed-long))) 
  :pointer
   () )
; 
;  *  GXSetGraphicsPollingHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXSetGraphicsPollingHandler" 
      ((handler :pointer) (reference :signed-long)) 
  nil
   () )

;  QD to QD GX Translator typedefs 
; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $gxDefaultOptionsTranslation #x0)
(defconstant $gxOptimizedTranslation #x1)
(defconstant $gxReplaceLineWidthTranslation #x2)
(defconstant $gxSimpleScalingTranslation #x4)
(defconstant $gxSimpleGeometryTranslation #x8)  ;   implies simple scaling  
(defconstant $gxSimpleLinesTranslation #xC)     ;   implies simple geometry & scaling  
(defconstant $gxLayoutTextTranslation #x10)     ;   turn on gxLine layout (normally off)  
(defconstant $gxRasterTargetTranslation #x20)
(defconstant $gxPostScriptTargetTranslation #x40)
(defconstant $gxVectorTargetTranslation #x80)
(defconstant $gxPDDTargetTranslation #x100)
(defconstant $gxDontConvertPatternsTranslation #x1000)
(defconstant $gxDontSplitBitmapsTranslation #x2000)

(def-mactype :gxtranslationoption (find-mactype ':signed-long))

(defconstant $gxContainsFormsBegin #x1)
(defconstant $gxContainsFormsEnd #x2)
(defconstant $gxContainsPostScript #x4)
(defconstant $gxContainsEmptyPostScript #x8)

(def-mactype :gxtranslationstatistic (find-mactype ':signed-long))

(defconstant $gxQuickDrawPictTag :|pict|)

(def-mactype :gxquickdrawpictptr (find-mactype '(:pointer :gxquickdrawpict)))
(defrecord gxQuickDrawPict 
;   translator inputs  
   (options :signed-long)
   (srcRect :rect)
   (styleStretch :point)
;   size of quickdraw picture data  
   (dataLength :unsigned-long)
;   file alias  
   (alias :gxbitmapdatasourcealias)
   )

; 	 WindowRecord utilities 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  GXNewWindowViewPort()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_GXNewWindowViewPort" 
      ((qdWindow (:pointer :windowrecord))) 
  :pointer
   () )
; 
;  *  GXGetWindowViewPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXGetWindowViewPort" 
      ((qdWindow (:pointer :windowrecord))) 
  :pointer
   () )
; 
;  *  GXGetViewPortWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXGetViewPortWindow" 
      ((portOrder :pointer)) 
  (:pointer :windowrecord)
   () )
;  GDevice utilities 
; 
;  *  GXGetViewDeviceGDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXGetViewDeviceGDevice" 
      ((theDevice :pointer)) 
  (:handle :gdevice)
   () )
; 
;  *  GXGetGDeviceViewDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXGetGDeviceViewDevice" 
      ((qdGDevice (:handle :gdevice))) 
  :pointer
   () )
;  gxPoint utilities 
; 
;  *  GXConvertQDPoint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_GXConvertQDPoint" 
      ((shortPt (:pointer :point)) (portOrder :pointer) (fixedPt (:pointer :gxpoint))) 
  nil
   () )
; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	gxShapeSpoolProcPtr = FUNCTION(toSpool: gxShape; refCon: LONGINT): OSErr; C;

|#
 |#                                             ; $ELSEC
(def-mactype :gxshapespoolprocptr (find-mactype ':pointer))
; $ENDC

; 	 printing utilities typedef 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	gxUserViewPortFilterProcPtr = PROCEDURE(toFilter: gxShape; portOrder: gxViewPort; refCon: LONGINT); C;

|#
 |#                                             ; $ELSEC
(def-mactype :gxuserviewportfilterprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	gxConvertQDFontProcPtr = FUNCTION(dst: gxStyle; txFont: LONGINT; txFace: LONGINT): LONGINT; C;

|#
 |#                                             ; $ELSEC
(def-mactype :gxconvertqdfontprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :gxshapespoolupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :gxshapespoolupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :gxuserviewportfilterupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :gxuserviewportfilterupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :gxconvertqdfontupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :gxconvertqdfontupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppgxShapeSpoolProcInfo #x3E1)
(defconstant $uppgxUserViewPortFilterProcInfo #xFC1)
(defconstant $uppgxConvertQDFontProcInfo #xFF1)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewgxShapeSpoolUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewgxShapeSpoolProc 
(deftrap "_NewgxShapeSpoolUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewgxUserViewPortFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewgxUserViewPortFilterProc 
(deftrap "_NewgxUserViewPortFilterUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewgxConvertQDFontUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewgxConvertQDFontProc 
(deftrap "_NewgxConvertQDFontUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposegxShapeSpoolUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposegxShapeSpoolUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposegxUserViewPortFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposegxUserViewPortFilterUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposegxConvertQDFontUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposegxConvertQDFontUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokegxShapeSpoolUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallgxShapeSpoolProc            ; 
;  *  InvokegxUserViewPortFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokegxShapeSpoolUPP" 
      ((toSpool :pointer) (refCon :signed-long) (userRoutine :pointer)) 
  :signed-integer
   () )                                         ;  old name was CallgxUserViewPortFilterProc ; 
;  *  InvokegxConvertQDFontUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokegxUserViewPortFilterUPP" 
      ((toFilter :pointer) (portOrder :pointer) (refCon :signed-long) (userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallgxConvertQDFontProc 
(deftrap-inline "_InvokegxConvertQDFontUPP" 
      ((dst :pointer) (txFont :signed-long) (txFace :signed-long) (userRoutine :pointer)) 
  :signed-long
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

(def-mactype :gxshapespoolfunction (find-mactype ':pointer))
(def-mactype :gxuserviewportfilter (find-mactype ':pointer))
(def-mactype :gxconvertqdfontfunction (find-mactype ':pointer))
; 	 mouse utilities 	
; 	 return mouse location in fixed-gxPoint global space 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  GXGetGlobalMouse()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_GXGetGlobalMouse" 
      ((globalPt (:pointer :gxpoint))) 
  nil
   () )
;  return fixed-gxPoint local mouse (gxViewPort == 0 --> default) 
; 
;  *  GXGetViewPortMouse()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXGetViewPortMouse" 
      ((portOrder :pointer) (localPt (:pointer :gxpoint))) 
  nil
   () )
;  printing utilities 
; 
;  *  GXGetViewPortFilter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXGetViewPortFilter" 
      ((portOrder :pointer) (refCon (:pointer :signed-long))) 
  :pointer
   () )
; 
;  *  GXSetViewPortFilter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXSetViewPortFilter" 
      ((portOrder :pointer) (filter :pointer) (refCon :signed-long)) 
  nil
   () )
;  QD to QD GX Translator functions 
; 
;  *  GXInstallQDTranslator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_GXInstallQDTranslator" 
      ((port (:pointer :grafport)) (options :signed-long) (srcRect (:pointer :rect)) (dstRect (:pointer :rect)) (styleStrech :point) (userFunction :pointer) (reference :pointer)) 
  nil
   () )
; 
;  *  GXRemoveQDTranslator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXRemoveQDTranslator" 
      ((port (:pointer :grafport)) (statistic (:pointer :signed-long))) 
  :gxtranslationstatistic
   () )
; 
;  *  GXConvertPICTToShape()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_GXConvertPICTToShape" 
      ((pict (:handle :picture)) (options :signed-long) (srcRect (:pointer :rect)) (dstRect (:pointer :rect)) (styleStretch :point) (destination :pointer) (stats (:pointer :signed-long))) 
  :pointer
   () )
;  Find the best GX style given a QD font and face. Called by the QD->GX translator 
; 
;  *  GXConvertQDFont()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXConvertQDFont" 
      ((theStyle :pointer) (txFont :signed-long) (txFace :signed-long)) 
  :signed-long
   () )
; 
;  *  GXGetConvertQDFont()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXGetConvertQDFont" 
      () 
  :pointer
   () )
; 
;  *  GXSetConvertQDFont()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXSetConvertQDFont" 
      ((userFunction :pointer)) 
  nil
   () )
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :gxprofilepoolattributes (find-mactype ':unsigned-long))
(def-mactype :gxflatprofilelistitemptr (find-mactype '(:pointer :gxflatprofilelistitem)))
(defrecord gxFlatProfileListItem 
   (attributes :unsigned-long)                  ;   information about this particular profile's source 
   (profileRef :pointer)                        ;   reference to profile, only valid before shape is disposed 
   (identifier :cmprofileidentifier)            ;   information on how to find the profile upon unflattening 
   )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := GXEnvironmentIncludes

; $ENDC                                         ; __GXENVIRONMENT__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'GXEnvironment)