(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:GXErrors.p"
; at Wednesday May 1,2002 2:41:32 pm.
; 
;      File:       GXErrors.p
;  
;      Contains:   QuickDraw GX error constants and debugging routines
;  
;      Version:    Technology: Quickdraw GX 1.1
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1994-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __GXERRORS__
; $SETC __GXERRORS__ := 1

; $I+
; $SETC GXErrorsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __GXTYPES__
|#

(require-interface 'GXTypes)
#|                                              ; $I GXTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $gxFirstSystemError -27999)        ;   0xffff92a1  
(defconstant $gxFirstFatalError -27999)
(defconstant $gxLastFatalError -27951)
(defconstant $gxFirstNonfatalError -27950)
(defconstant $gxFirstFontScalerError -27900)
(defconstant $gxLastFontScalerError -27851)
(defconstant $gxFirstParameterError -27850)
(defconstant $gxFirstImplementationLimitError -27800)
(defconstant $gxFirstSystemDebuggingError -27700)
(defconstant $gxLastSystemError -27000)         ;   0xffff9688  
(defconstant $gxFirstLibraryError 1048576)      ;   0x00100000  
(defconstant $gxLastLibraryError 2097151)       ;   0x001fffff  
(defconstant $gxFirstAppError 2097152)          ;   0x00200000  
(defconstant $gxLastAppError 4194303)           ;   0x003fffff  
(defconstant $gxFirstSystemWarning -26999)      ;   0xffff9689  
(defconstant $gxFirstResultOutOfRangeWarning -26950)
(defconstant $gxFirstParameterOutOfRangeWarning -26900)
(defconstant $gxFirstFontScalerWarning -26850)
(defconstant $gxFirstSystemDebuggingWarning -26700)
(defconstant $gxLastSystemWarning -26000)       ;   0xffff9a70  
(defconstant $gxFirstLibraryWarning 4194304)    ;   0x00400000  
(defconstant $gxLastLibraryWarning 5242879)     ;   0x004fffff  
(defconstant $gxFirstAppWarning 5242880)        ;   0x00500000  
(defconstant $gxLastAppWarning 7340031)         ;   0x006fffff  
(defconstant $gxFirstSystemNotice -25999)       ;   0xffff9a71  
(defconstant $gxLastSystemNotice -25500)        ;   0xffff9c64  
(defconstant $gxFirstLibraryNotice 7340032)     ;   0x00700000  
(defconstant $gxLastLibraryNotice 7602175)      ;   0x0073ffff  
(defconstant $gxFirstAppNotice 7602176)         ;   0x00740000  
(defconstant $gxLastAppNotice 8388607)          ;   0x007fffff  

;   truly fatal errors  
(defconstant $out_of_memory -27999)
(defconstant $internal_fatal_error -27998)
(defconstant $no_outline_font_found -27997)
(defconstant $not_enough_memory_for_graphics_client_heap -27996)
(defconstant $could_not_create_backing_store -27995)

;   internal errors  
(defconstant $internal_error -27950)
(defconstant $internal_font_error -27949)
(defconstant $internal_layout_error -27948)

;   recoverable errors  
(defconstant $could_not_dispose_backing_store -27946)
(defconstant $unflattening_interrupted_by_client -27945)

;   font manager errors  
(defconstant $font_cannot_be_changed -27944)
(defconstant $illegal_font_parameter -27943)

;   gxFont scaler errors  
(defconstant $null_font_scaler_context -27900)
(defconstant $null_font_scaler_input -27899)
(defconstant $invalid_font_scaler_context -27898)
(defconstant $invalid_font_scaler_input -27897)
(defconstant $invalid_font_scaler_font_data -27896)
(defconstant $font_scaler_newblock_failed -27895)
(defconstant $font_scaler_getfonttable_failed -27894)
(defconstant $font_scaler_bitmap_allocation_failed -27893)
(defconstant $font_scaler_outline_allocation_failed -27892)
(defconstant $required_font_scaler_table_missing -27891)
(defconstant $unsupported_font_scaler_outline_format -27890)
(defconstant $unsupported_font_scaler_stream_format -27889)
(defconstant $unsupported_font_scaler_font_format -27888)
(defconstant $font_scaler_hinting_error -27887)
(defconstant $font_scaler_rasterizer_error -27886)
(defconstant $font_scaler_internal_error -27885)
(defconstant $font_scaler_invalid_matrix -27884)
(defconstant $font_scaler_fixed_overflow -27883)
(defconstant $font_scaler_api_version_mismatch -27882)
(defconstant $font_scaler_streaming_aborted -27881)
(defconstant $unknown_font_scaler_error -27880)

;   bad parameters  
(defconstant $parameter_is_nil -27850)
(defconstant $shape_is_nil -27849)
(defconstant $style_is_nil -27848)
(defconstant $transform_is_nil -27847)
(defconstant $ink_is_nil -27846)
(defconstant $transferMode_is_nil -27845)
(defconstant $color_is_nil -27844)
(defconstant $colorProfile_is_nil -27843)
(defconstant $colorSet_is_nil -27842)
(defconstant $spoolProcedure_is_nil -27841)
(defconstant $tag_is_nil -27840)
(defconstant $type_is_nil -27839)
(defconstant $mapping_is_nil -27838)
(defconstant $invalid_viewDevice_reference -27837)
(defconstant $invalid_viewGroup_reference -27836)
(defconstant $invalid_viewPort_reference -27835)

;   implementation limits, these should be right before the debugging errors  
(defconstant $number_of_contours_exceeds_implementation_limit -27800)
(defconstant $number_of_points_exceeds_implementation_limit -27799)
(defconstant $size_of_polygon_exceeds_implementation_limit -27798)
(defconstant $size_of_path_exceeds_implementation_limit -27797)
(defconstant $size_of_text_exceeds_implementation_limit -27796)
(defconstant $size_of_bitmap_exceeds_implementation_limit -27795)
(defconstant $number_of_colors_exceeds_implementation_limit -27794)
(defconstant $procedure_not_reentrant -27793)

;   internal debugging errors  
(defconstant $functionality_unimplemented -27700)
(defconstant $clip_to_frame_shape_unimplemented -27699);   font parameter debugging errors  
(defconstant $illegal_font_storage_type -27698)
(defconstant $illegal_font_storage_reference -27697)
(defconstant $illegal_font_attributes -27696)   ;   parameter debugging errors  
(defconstant $parameter_out_of_range -27695)
(defconstant $inconsistent_parameters -27694)
(defconstant $index_is_less_than_zero -27693)
(defconstant $index_is_less_than_one -27692)
(defconstant $count_is_less_than_zero -27691)
(defconstant $count_is_less_than_one -27690)
(defconstant $contour_is_less_than_zero -27689)
(defconstant $length_is_less_than_zero -27688)
(defconstant $invalid_client_reference -27687)
(defconstant $invalid_graphics_heap_start_pointer -27686)
(defconstant $invalid_nongraphic_globals_pointer -27685)
(defconstant $colorSpace_out_of_range -27684)
(defconstant $pattern_lattice_out_of_range -27683)
(defconstant $frequency_parameter_out_of_range -27682)
(defconstant $tinting_parameter_out_of_range -27681)
(defconstant $method_parameter_out_of_range -27680)
(defconstant $space_may_not_be_indexed -27679)
(defconstant $glyph_index_too_small -27678)
(defconstant $no_glyphs_added_to_font -27677)
(defconstant $glyph_not_added_to_font -27676)
(defconstant $point_does_not_intersect_bitmap -27675)
(defconstant $required_font_table_not_present -27674)
(defconstant $unknown_font_table_format -27673) ;   the styles encoding is not present in the font  
(defconstant $shapeFill_not_allowed -27672)
(defconstant $inverseFill_face_must_set_clipLayer_flag -27671)
(defconstant $invalid_transferMode_colorSpace -27670)
(defconstant $colorProfile_must_be_nil -27669)
(defconstant $bitmap_pixel_size_must_be_1 -27668)
(defconstant $empty_shape_not_allowed -27667)
(defconstant $ignorePlatformShape_not_allowed -27666)
(defconstant $nil_style_in_glyph_not_allowed -27665)
(defconstant $complex_glyph_style_not_allowed -27664)
(defconstant $invalid_mapping -27663)
(defconstant $cannot_set_item_shapes_to_nil -27662)
(defconstant $cannot_use_original_item_shapes_when_growing_picture -27661)
(defconstant $cannot_add_unspecified_new_glyphs -27660)
(defconstant $cannot_dispose_locked_tag -27659)
(defconstant $cannot_dispose_locked_shape -27658)

;   restricted access  
(defconstant $shape_access_not_allowed -27657)
(defconstant $colorSet_access_restricted -27656)
(defconstant $colorProfile_access_restricted -27655)
(defconstant $tag_access_restricted -27654)
(defconstant $viewDevice_access_restricted -27653)
(defconstant $graphic_type_does_not_have_a_structure -27652)
(defconstant $style_run_array_does_not_match_number_of_characters -27651)
(defconstant $rectangles_cannot_be_inserted_into -27650)
(defconstant $unknown_graphics_heap -27649)
(defconstant $graphics_routine_selector_is_obsolete -27648)
(defconstant $cannot_set_graphics_client_memory_without_setting_size -27647)
(defconstant $graphics_client_memory_too_small -27646)
(defconstant $graphics_client_memory_is_already_allocated -27645)
(defconstant $viewPort_is_a_window -27644)      ;   wrong type/bad reference  
(defconstant $illegal_type_for_shape -27643)
(defconstant $shape_does_not_contain_a_bitmap -27642)
(defconstant $shape_does_not_contain_text -27641)
(defconstant $picture_expected -27640)
(defconstant $bitmap_is_not_resizable -27639)
(defconstant $shape_may_not_be_a_bitmap -27638)
(defconstant $shape_may_not_be_a_picture -27637)
(defconstant $graphic_type_does_not_contain_points -27636)
(defconstant $graphic_type_does_not_have_multiple_contours -27635)
(defconstant $graphic_type_cannot_be_mapped -27634)
(defconstant $graphic_type_cannot_be_moved -27633)
(defconstant $graphic_type_cannot_be_scaled -27632)
(defconstant $graphic_type_cannot_be_rotated -27631)
(defconstant $graphic_type_cannot_be_skewed -27630)
(defconstant $graphic_type_cannot_be_reset -27629)
(defconstant $graphic_type_cannot_be_dashed -27628)
(defconstant $graphic_type_cannot_be_reduced -27627)
(defconstant $graphic_type_cannot_be_inset -27626)
(defconstant $shape_cannot_be_inverted -27625)
(defconstant $shape_does_not_have_area -27624)
(defconstant $shape_does_not_have_length -27623)
(defconstant $first_glyph_advance_must_be_absolute -27622)
(defconstant $picture_cannot_contain_itself -27621)
(defconstant $viewPort_cannot_contain_itself -27620)
(defconstant $cannot_set_unique_items_attribute_when_picture_contains_items -27619)
(defconstant $layer_style_cannot_contain_a_face -27618)
(defconstant $layer_glyph_shape_cannot_contain_nil_styles -27617)

;   validation errors  
(defconstant $object_wrong_type -27616)
(defconstant $shape_wrong_type -27615)
(defconstant $style_wrong_type -27614)
(defconstant $ink_wrong_type -27613)
(defconstant $transform_wrong_type -27612)
(defconstant $device_wrong_type -27611)
(defconstant $port_wrong_type -27610)

;   validation cache errors  
(defconstant $shape_cache_wrong_type -27609)
(defconstant $style_cache_wrong_type -27608)
(defconstant $ink_cache_wrong_type -27607)
(defconstant $transform_cache_wrong_type -27606)
(defconstant $port_cache_wrong_type -27605)
(defconstant $shape_cache_parent_mismatch -27604)
(defconstant $style_cache_parent_mismatch -27603)
(defconstant $ink_cache_parent_mismatch -27602)
(defconstant $transform_cache_parent_mismatch -27601)
(defconstant $port_cache_parent_mismatch -27600)
(defconstant $invalid_shape_cache_port -27599)
(defconstant $invalid_shape_cache_device -27598)
(defconstant $invalid_ink_cache_port -27597)
(defconstant $invalid_ink_cache_device -27596)
(defconstant $invalid_style_cache_port -27595)
(defconstant $invalid_style_cache_device -27594)
(defconstant $invalid_transform_cache_port -27593)
(defconstant $invalid_transform_cache_device -27592)
(defconstant $recursive_caches -27591)

;   validation shape cache errors  
(defconstant $invalid_fillShape_ownerCount -27590)
(defconstant $recursive_fillShapes -27589)

;   validation memory block errors  
(defconstant $indirect_memory_block_too_small -27588)
(defconstant $indirect_memory_block_too_large -27587)
(defconstant $unexpected_nil_pointer -27586)
(defconstant $bad_address -27585)

;   validation object errors  
(defconstant $no_owners -27584)
(defconstant $invalid_pointer -27583)
(defconstant $invalid_seed -27582)
(defconstant $invalid_frame_seed -27581)
(defconstant $invalid_text_seed -27580)
(defconstant $invalid_draw_seed -27579)
(defconstant $bad_private_flags -27578)

;   validation path and polygon errors  
(defconstant $invalid_vector_count -27577)
(defconstant $invalid_contour_count -27576)

;   validation bitmap errors  
(defconstant $bitmap_ptr_too_small -27575)
(defconstant $bitmap_ptr_not_aligned -27574)
(defconstant $bitmap_rowBytes_negative -27573)
(defconstant $bitmap_width_negative -27572)
(defconstant $bitmap_height_negative -27571)
(defconstant $invalid_pixelSize -27570)
(defconstant $bitmap_rowBytes_too_small -27569)
(defconstant $bitmap_rowBytes_not_aligned -27568)
(defconstant $bitmap_rowBytes_must_be_specified_for_user_image_buffer -27567)

;   validation bitmap image errors  
(defconstant $invalid_bitImage_fileOffset -27566)
(defconstant $invalid_bitImage_owners -27565)
(defconstant $invalid_bitImage_rowBytes -27564)
(defconstant $invalid_bitImage_internal_flag -27563)

;   validation text errors  
(defconstant $text_bounds_cache_wrong_size -27562)
(defconstant $text_metrics_cache_wrong_size -27561)
(defconstant $text_index_cache_wrong_size -27560)

;   validation glyph errors  
(defconstant $glyph_run_count_negative -27559)
(defconstant $glyph_run_count_zero -27558)
(defconstant $glyph_run_counts_do_not_sum_to_character_count -27557)
(defconstant $glyph_first_advance_bit_set_not_allowed -27556)
(defconstant $glyph_tangent_vectors_both_zero -27555)

;   validation layout errors  
(defconstant $layout_run_length_negative -27554)
(defconstant $layout_run_length_zero -27553)
(defconstant $layout_run_level_negative -27552)
(defconstant $layout_run_lengths_do_not_sum_to_text_length -27551)

;   validation picture errors  
(defconstant $bad_shape_in_picture -27550)
(defconstant $bad_style_in_picture -27549)
(defconstant $bad_ink_in_picture -27548)
(defconstant $bad_transform_in_picture -27547)
(defconstant $bad_shape_cache_in_picture -27546)
(defconstant $bad_seed_in_picture -27545)
(defconstant $invalid_picture_count -27544)

;   validation text face errors  
(defconstant $bad_textLayer_count -27543)
(defconstant $bad_fillType_in_textFace -27542)
(defconstant $bad_style_in_textFace -27541)
(defconstant $bad_transform_in_textFace -27540)

;   validation transform errors  
(defconstant $invalid_matrix_flag -27539)
(defconstant $transform_clip_missing -27538)

;   validation font cache errors  
(defconstant $metrics_wrong_type -27537)
(defconstant $metrics_point_size_probably_bad -27536)
(defconstant $scalar_block_wrong_type -27535)
(defconstant $scalar_block_parent_mismatch -27534)
(defconstant $scalar_block_too_small -27533)
(defconstant $scalar_block_too_large -27532)
(defconstant $invalid_metrics_range -27531)
(defconstant $invalid_metrics_flags -27530)
(defconstant $metrics_maxWidth_probably_bad -27529)
(defconstant $font_wrong_type -27528)
(defconstant $font_wrong_size -27527)
(defconstant $invalid_font_platform -27526)
(defconstant $invalid_lookup_range -27525)
(defconstant $invalid_lookup_platform -27524)
(defconstant $font_not_in_font_list -27523)
(defconstant $metrics_not_in_metrics_list -27522)

;   validation view device errors  
(defconstant $bad_device_private_flags -27521)
(defconstant $bad_device_attributes -27520)
(defconstant $invalid_device_number -27519)
(defconstant $invalid_device_viewGroup -27518)
(defconstant $invalid_device_bounds -27517)
(defconstant $invalid_bitmap_in_device -27516)

;   validation color set errors  
(defconstant $colorSet_wrong_type -27515)
(defconstant $invalid_colorSet_viewDevice_owners -27514)
(defconstant $invalid_colorSet_colorSpace -27513)
(defconstant $invalid_colorSet_count -27512)

;   validation color profile errors  
(defconstant $colorProfile_wrong_type -27511)
(defconstant $invalid_colorProfile_flags -27510)
(defconstant $invalid_colorProfile_response_count -27509)

;   validation internal backing store errors  
(defconstant $backing_free_parent_mismatch -27508)
(defconstant $backing_store_parent_mismatch -27507)

;   warnings about warnings  
(defconstant $warning_stack_underflow -26999)
(defconstant $warning_stack_overflow -26998)
(defconstant $notice_stack_underflow -26997)
(defconstant $notice_stack_overflow -26996)
(defconstant $about_to_grow_heap -26995)
(defconstant $about_to_unload_objects -26994)

;   result went out of range  
(defconstant $map_shape_out_of_range -26950)
(defconstant $move_shape_out_of_range -26949)
(defconstant $scale_shape_out_of_range -26948)
(defconstant $rotate_shape_out_of_range -26947)
(defconstant $skew_shape_out_of_range -26946)
(defconstant $map_transform_out_of_range -26945)
(defconstant $move_transform_out_of_range -26944)
(defconstant $scale_transform_out_of_range -26943)
(defconstant $rotate_transform_out_of_range -26942)
(defconstant $skew_transform_out_of_range -26941)
(defconstant $map_points_out_of_range -26940)

;   gave a parameter out of range  
(defconstant $contour_out_of_range -26900)
(defconstant $index_out_of_range_in_contour -26899)
(defconstant $picture_index_out_of_range -26898)
(defconstant $color_index_requested_not_found -26897)
(defconstant $colorSet_index_out_of_range -26896)
(defconstant $index_out_of_range -26895)
(defconstant $count_out_of_range -26894)
(defconstant $length_out_of_range -26893)
(defconstant $font_table_index_out_of_range -26892)
(defconstant $font_glyph_index_out_of_range -26891)
(defconstant $point_out_of_range -26890)
(defconstant $profile_response_out_of_range -26889)

;   gxFont scaler warnings  
(defconstant $font_scaler_no_output -26850)
(defconstant $font_scaler_fake_metrics -26849)
(defconstant $font_scaler_fake_linespacing -26848)
(defconstant $font_scaler_glyph_substitution -26847)
(defconstant $font_scaler_no_kerning_applied -26846);   might not be what you expected  
(defconstant $character_substitution_took_place -26845)
(defconstant $unable_to_get_bounds_on_multiple_devices -26844)
(defconstant $font_language_not_found -26843)
(defconstant $font_not_found_during_unflattening -26842);  storage  
(defconstant $unrecognized_stream_version -26841)
(defconstant $bad_data_in_stream -26840)

;   nonsense data  
(defconstant $new_shape_contains_invalid_data -26700)
(defconstant $new_tag_contains_invalid_data -26699)
(defconstant $extra_data_passed_was_ignored -26698)
(defconstant $font_table_not_found -26697)
(defconstant $font_name_not_found -26696)

;   doesn't make sense to do  
(defconstant $unable_to_traverse_open_contour_that_starts_or_ends_off_the_curve -26695)
(defconstant $unable_to_draw_open_contour_that_starts_or_ends_off_the_curve -26694)
(defconstant $cannot_dispose_default_shape -26693)
(defconstant $cannot_dispose_default_style -26692)
(defconstant $cannot_dispose_default_ink -26691)
(defconstant $cannot_dispose_default_transform -26690)
(defconstant $cannot_dispose_default_colorProfile -26689)
(defconstant $cannot_dispose_default_colorSet -26688)
(defconstant $shape_direct_attribute_not_set -26687)

;   couldn't find what you were looking for  
(defconstant $point_does_not_intersect_port -26686)
(defconstant $cannot_dispose_non_font -26685)
(defconstant $face_override_style_font_must_match_style -26684)
(defconstant $union_of_area_and_length_returns_area_only -26683)
(defconstant $insufficient_coordinate_space_for_new_device -26682)

;   other  
(defconstant $shape_passed_has_no_bounds -26681)
(defconstant $tags_of_type_flst_removed -26680)
(defconstant $translator_not_installed_on_this_grafport -26679)

(defconstant $parameters_have_no_effect -25999)
(defconstant $attributes_already_set -25998)
(defconstant $caps_already_set -25997)
(defconstant $clip_already_set -25996)
(defconstant $color_already_set -25995)
(defconstant $curve_error_already_set -25994)
(defconstant $dash_already_set -25993)
(defconstant $default_colorProfile_already_set -25992)
(defconstant $default_ink_already_set -25991)
(defconstant $default_transform_already_set -25990)
(defconstant $default_shape_already_set -25989)
(defconstant $default_style_already_set -25988)
(defconstant $dither_already_set -25987)
(defconstant $encoding_already_set -25986)
(defconstant $face_already_set -25985)
(defconstant $fill_already_set -25984)
(defconstant $font_already_set -25983)
(defconstant $font_variations_already_set -25982)
(defconstant $glyph_positions_are_already_set -25981)
(defconstant $glyph_tangents_are_already_set -25980)
(defconstant $halftone_already_set -25979)
(defconstant $hit_test_already_set -25978)
(defconstant $ink_already_set -25977)
(defconstant $join_already_set -25976)
(defconstant $justification_already_set -25975)
(defconstant $mapping_already_set -25974)
(defconstant $pattern_already_set -25973)
(defconstant $pen_already_set -25972)
(defconstant $style_already_set -25971)
(defconstant $tag_already_set -25970)
(defconstant $text_attributes_already_set -25969)
(defconstant $text_size_already_set -25968)
(defconstant $transfer_already_set -25967)
(defconstant $translator_already_installed_on_this_grafport -25966)
(defconstant $transform_already_set -25965)
(defconstant $type_already_set -25964)
(defconstant $validation_level_already_set -25963)
(defconstant $viewPorts_already_set -25962)
(defconstant $viewPort_already_in_viewGroup -25961)
(defconstant $viewDevice_already_in_viewGroup -25960)

(defconstant $geometry_unaffected -25959)
(defconstant $mapping_unaffected -25958)
(defconstant $tags_in_shape_ignored -25957)

(defconstant $shape_already_in_primitive_form -25956)
(defconstant $shape_already_in_simple_form -25955)
(defconstant $shape_already_broken -25954)
(defconstant $shape_already_joined -25953)
(defconstant $cache_already_cleared -25952)

(defconstant $shape_not_disposed -25951)
(defconstant $style_not_disposed -25950)
(defconstant $ink_not_disposed -25949)
(defconstant $transform_not_disposed -25948)
(defconstant $colorSet_not_disposed -25947)
(defconstant $colorProfile_not_disposed -25946)
(defconstant $font_not_disposed -25945)

(defconstant $glyph_tangents_have_no_effect -25944)
(defconstant $glyph_positions_determined_by_advance -25943)
(defconstant $transform_viewPorts_already_set -25942)

(defconstant $directShape_attribute_set_as_side_effect -25941)
(defconstant $lockShape_called_as_side_effect -25940)
(defconstant $lockTag_called_as_side_effect -25939)
(defconstant $shapes_unlocked_as_side_effect -25938)
(defconstant $shape_not_locked -25937)
(defconstant $tag_not_locked -25936)

(defconstant $profile_not_locked -25936)
(defconstant $lockProfile_called_as_side_effect -25939)

(defconstant $disposed_dead_caches -25935)
(defconstant $disposed_live_caches -25934)
(defconstant $low_on_memory -25933)
(defconstant $very_low_on_memory -25932)

(defconstant $transform_references_disposed_viewPort -25931)

(def-mactype :gxgraphicserror (find-mactype ':signed-long))
(def-mactype :gxgraphicswarning (find-mactype ':signed-long))
(def-mactype :gxgraphicsnotice (find-mactype ':signed-long))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	gxUserErrorProcPtr = PROCEDURE(status: gxGraphicsError; refcon: LONGINT); C;

|#
 |#                                             ; $ELSEC
(def-mactype :gxusererrorprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	gxUserWarningProcPtr = PROCEDURE(status: gxGraphicsWarning; refcon: LONGINT); C;

|#
 |#                                             ; $ELSEC
(def-mactype :gxuserwarningprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	gxUserNoticeProcPtr = PROCEDURE(status: gxGraphicsNotice; refcon: LONGINT); C;

|#
 |#                                             ; $ELSEC
(def-mactype :gxusernoticeprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :gxusererrorupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :gxusererrorupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :gxuserwarningupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :gxuserwarningupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :gxusernoticeupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :gxusernoticeupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppgxUserErrorProcInfo #x3C1)
(defconstant $uppgxUserWarningProcInfo #x3C1)
(defconstant $uppgxUserNoticeProcInfo #x3C1)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewgxUserErrorUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewgxUserErrorProc 
(deftrap "_NewgxUserErrorUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewgxUserWarningUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewgxUserWarningProc 
(deftrap "_NewgxUserWarningUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewgxUserNoticeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewgxUserNoticeProc 
(deftrap "_NewgxUserNoticeUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposegxUserErrorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposegxUserErrorUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposegxUserWarningUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposegxUserWarningUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposegxUserNoticeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposegxUserNoticeUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokegxUserErrorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallgxUserErrorProc             ; 
;  *  InvokegxUserWarningUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokegxUserErrorUPP" 
      ((status :signed-long) (refcon :signed-long) (userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallgxUserWarningProc ; 
;  *  InvokegxUserNoticeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InvokegxUserWarningUPP" 
      ((status :signed-long) (refcon :signed-long) (userRoutine :pointer)) 
  nil
   () )                                         ;  old name was CallgxUserNoticeProc 
(deftrap-inline "_InvokegxUserNoticeUPP" 
      ((status :signed-long) (refcon :signed-long) (userRoutine :pointer)) 
  nil
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

(def-mactype :gxusererrorfunction (find-mactype ':pointer))
(def-mactype :gxuserwarningfunction (find-mactype ':pointer))
(def-mactype :gxusernoticefunction (find-mactype ':pointer))

(defconstant $common_colors_not_initialized 1048576)
(defconstant $no_open_picture 1048577)
(defconstant $picture_already_open 1048578)
(defconstant $no_open_poly 1048579)
(defconstant $poly_already_open 1048580)
(defconstant $no_open_region 1048581)
(defconstant $region_already_open 1048582)
(defconstant $no_active_picture 1048583)

(defconstant $no_picture_drawn 4194304)
(defconstant $polygons_have_different_size_contours 4194305)
(defconstant $graphic_type_cannot_be_specifed_by_four_values 4194306)
(defconstant $graphic_type_cannot_be_specifed_by_six_values 4194307)
(defconstant $point_expected 4194308)
(defconstant $line_or_rectangle_expected 4194309)
(defconstant $curve_expected 4194310)
(defconstant $graphic_type_does_not_contain_control_bits 4194311)
(defconstant $request_exceeds_available_data 4194312)
(defconstant $extra_data_unread 4194313)
(defconstant $no_variable_length_user_data_saved 4194314)

(defconstant $zero_length_string_passed 7340032)

;   These levels tell how to validate routines.  Choose one.  
(defconstant $gxNoValidation #x0)               ;   no validation  
(defconstant $gxPublicValidation #x1)           ;   check parameters to public routines  
(defconstant $gxInternalValidation #x2)         ;   check parameters to internal routines  
;   These levels tell how to validate types.  Choose one.  
(defconstant $gxTypeValidation #x0)             ;   check types of objects  
(defconstant $gxStructureValidation #x10)       ;   check fields of private structures  
(defconstant $gxAllObjectValidation #x20)       ;   check every object over every call  
;   These levels tell how to validate memory manager blocks.  Choose any combination.  
(defconstant $gxNoMemoryManagerValidation #x0)
(defconstant $gxApBlockValidation #x100)        ;   check the relevant block structures after each memory mgr. call  
(defconstant $gxFontBlockValidation #x200)      ;   check the system gxHeap as well  
(defconstant $gxApHeapValidation #x400)         ;   check the memory managers gxHeap after every mem. call  
(defconstant $gxFontHeapValidation #x800)       ;   check the system gxHeap as well  
(defconstant $gxCheckApHeapValidation #x1000)   ;   check the memory managers gxHeap if checking routine parameters  
(defconstant $gxCheckFontHeapValidation #x2000) ;   check the system gxHeap as well  

(def-mactype :gxvalidationlevel (find-mactype ':signed-long))

(defconstant $no_draw_error 0)

;   gxShape type errors  
(defconstant $shape_emptyType 1)
(defconstant $shape_inverse_fullType 2)
(defconstant $rectangle_zero_width 3)
(defconstant $rectangle_zero_height 4)
(defconstant $polygon_empty 5)
(defconstant $path_empty 6)
(defconstant $bitmap_zero_width 7)
(defconstant $bitmap_zero_height 8)
(defconstant $text_empty 9)
(defconstant $glyph_empty 10)
(defconstant $layout_empty 11)
(defconstant $picture_empty 12)

;   general gxShape errors  
(defconstant $shape_no_fill 13)
(defconstant $shape_no_enclosed_area 14)
(defconstant $shape_no_enclosed_pixels 15)
(defconstant $shape_very_small 16)
(defconstant $shape_very_large 17)
(defconstant $shape_contours_cancel 18)

;   gxStyle errors  
(defconstant $pen_too_small 19)
(defconstant $text_size_too_small 20)
(defconstant $dash_empty 21)
(defconstant $start_cap_empty 22)
(defconstant $pattern_empty 23)
(defconstant $textFace_empty 24)
(defconstant $shape_primitive_empty 25)
(defconstant $shape_primitive_very_small 26)

;   gxInk errors  
(defconstant $transfer_equals_noMode 27)
(defconstant $transfer_matrix_ignores_source 28)
(defconstant $transfer_matrix_ignores_device 29)
(defconstant $transfer_source_reject 30)
(defconstant $transfer_mode_ineffective 31)
(defconstant $colorSet_no_entries 32)
(defconstant $bitmap_colorSet_one_entry 33)

;   gxTransform errors  
(defconstant $transform_scale_too_small 34)
(defconstant $transform_map_too_large 35)
(defconstant $transform_move_too_large 36)
(defconstant $transform_scale_too_large 37)
(defconstant $transform_rotate_too_large 38)
(defconstant $transform_perspective_too_large 39)
(defconstant $transform_skew_too_large 40)
(defconstant $transform_clip_no_intersection 41)
(defconstant $transform_clip_empty 42)
(defconstant $transform_no_viewPorts 43)

;   gxViewPort errors  
(defconstant $viewPort_disposed 44)
(defconstant $viewPort_clip_empty 45)
(defconstant $viewPort_clip_no_intersection 46)
(defconstant $viewPort_scale_too_small 47)
(defconstant $viewPort_map_too_large 48)
(defconstant $viewPort_move_too_large 49)
(defconstant $viewPort_scale_too_large 50)
(defconstant $viewPort_rotate_too_large 51)
(defconstant $viewPort_perspective_too_large 52)
(defconstant $viewPort_skew_too_large 53)
(defconstant $viewPort_viewGroup_offscreen 54)

;   gxViewDevice errors  
(defconstant $viewDevice_clip_no_intersection 55)
(defconstant $viewDevice_scale_too_small 56)
(defconstant $viewDevice_map_too_large 57)
(defconstant $viewDevice_move_too_large 58)
(defconstant $viewDevice_scale_too_large 59)
(defconstant $viewDevice_rotate_too_large 60)
(defconstant $viewDevice_perspective_too_large 61)
(defconstant $viewDevice_skew_too_large 62)

(def-mactype :gxdrawerror (find-mactype ':signed-long))
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  GXGetShapeDrawError()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_GXGetShapeDrawError" 
      ((source :pointer)) 
  :gxdrawerror
   () )
; 
;  *  GXValidateAll()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXValidateAll" 
      () 
  nil
   () )
; 
;  *  GXValidateColorSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXValidateColorSet" 
      ((target :pointer)) 
  nil
   () )
; 
;  *  GXValidateColorProfile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXValidateColorProfile" 
      ((target :pointer)) 
  nil
   () )
; 
;  *  GXValidateGraphicsClient()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXValidateGraphicsClient" 
      ((target :pointer)) 
  nil
   () )
; 
;  *  GXValidateInk()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXValidateInk" 
      ((target :pointer)) 
  nil
   () )
; 
;  *  GXValidateShape()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXValidateShape" 
      ((target :pointer)) 
  nil
   () )
; 
;  *  GXValidateStyle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXValidateStyle" 
      ((target :pointer)) 
  nil
   () )
; 
;  *  GXValidateTag()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXValidateTag" 
      ((target :pointer)) 
  nil
   () )
; 
;  *  GXValidateTransform()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXValidateTransform" 
      ((target :pointer)) 
  nil
   () )
; 
;  *  GXValidateViewDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXValidateViewDevice" 
      ((target :pointer)) 
  nil
   () )
; 
;  *  GXValidateViewPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXValidateViewPort" 
      ((target :pointer)) 
  nil
   () )
; 
;  *  GXValidateViewGroup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXValidateViewGroup" 
      ((target :pointer)) 
  nil
   () )
; 
;  *  GXGetValidation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXGetValidation" 
      () 
  :gxvalidationlevel
   () )
; 
;  *  GXSetValidation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXSetValidation" 
      ((level :signed-long)) 
  nil
   () )
; 
;  *  GXGetValidationError()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GXGetValidationError" 
      ((procedureName :pointer) (argument (:pointer :pointer)) (argumentNumber (:pointer :signed-long))) 
  :signed-long
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := GXErrorsIncludes

; $ENDC                                         ; __GXERRORS__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'GXErrors)