(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:GXMath.p"
; at Wednesday May 1,2002 2:41:30 pm.
; 
;      File:       GXMath.p
;  
;      Contains:   QuickDraw GX math routine interfaces.
;  
;      Version:    Technology: Quickdraw GX 1.1
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1994-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __GXMATH__
; $SETC __GXMATH__ := 1

; $I+
; $SETC GXMathIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FIXMATH__
|#

(require-interface 'FixMath)
#|                                              ; $I FixMath.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :gxpointptr (find-mactype '(:pointer :gxpoint)))
(defrecord gxPoint 
   (x :signed-long)
   (y :signed-long)
   )

(def-mactype :gxcolorvalue (find-mactype ':unsigned-integer))
(def-mactype :gxpolarptr (find-mactype '(:pointer :gxpolar)))
(defrecord gxPolar 
   (radius :signed-long)
   (angle :signed-long)
   )

(def-mactype :gxmappingptr (find-mactype '(:pointer :gxmapping)))
(defrecord gxMapping 
   (map (:array :signed-long 3 3))
   )

(defconstant $gxColorValue1 #xFFFF)             ;   gxColorValue 1.0  

(defconstant $gxPositiveInfinity #x7FFFFFFF)    ;   for Fixed and Fract  
(defconstant $gxNegativeInfinity #x80000000)    ;   for Fixed and Fract  

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  CopyToMapping()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_CopyToMapping" 
      ((target (:pointer :gxmapping)) (source (:pointer :gxmapping))) 
  (:pointer :gxmapping)
   () )
; 
;  *  InvertMapping()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_InvertMapping" 
      ((target (:pointer :gxmapping)) (source (:pointer :gxmapping))) 
  (:pointer :gxmapping)
   () )
; 
;  *  MapMapping()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_MapMapping" 
      ((target (:pointer :gxmapping)) (source (:pointer :gxmapping))) 
  (:pointer :gxmapping)
   () )
; 
;  *  MoveMapping()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MoveMapping" 
      ((target (:pointer :gxmapping)) (hOffset :signed-long) (vOffset :signed-long)) 
  (:pointer :gxmapping)
   () )
; 
;  *  MoveMappingTo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MoveMappingTo" 
      ((target (:pointer :gxmapping)) (hPosition :signed-long) (vPosition :signed-long)) 
  (:pointer :gxmapping)
   () )
; 
;  *  NormalizeMapping()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NormalizeMapping" 
      ((target (:pointer :gxmapping))) 
  (:pointer :gxmapping)
   () )
; 
;  *  RotateMapping()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_RotateMapping" 
      ((target (:pointer :gxmapping)) (angle :signed-long) (xCenter :signed-long) (yCenter :signed-long)) 
  (:pointer :gxmapping)
   () )
; 
;  *  ScaleMapping()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ScaleMapping" 
      ((target (:pointer :gxmapping)) (hFactor :signed-long) (vFactor :signed-long) (xCenter :signed-long) (yCenter :signed-long)) 
  (:pointer :gxmapping)
   () )
; 
;  *  ResetMapping()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_ResetMapping" 
      ((target (:pointer :gxmapping))) 
  (:pointer :gxmapping)
   () )
; 
;  *  SkewMapping()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SkewMapping" 
      ((target (:pointer :gxmapping)) (skewX :signed-long) (skewY :signed-long) (xCenter :signed-long) (yCenter :signed-long)) 
  (:pointer :gxmapping)
   () )
; 
;  *  MapPoints()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_MapPoints" 
      ((source (:pointer :gxmapping)) (count :signed-long) (theVector (:pointer :gxpoint))) 
  nil
   () )
; 
;  *  FirstBit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_FirstBit" 
      ((x :unsigned-long)) 
  :signed-integer
   () )
; 
;  *  WideScale()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_WideScale" 
      ((source (:pointer :wide))) 
  :signed-integer
   () )
; 
;  *  LinearRoot()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_LinearRoot" 
      ((first :signed-long) (last :signed-long) (t (:pointer :signed-long))) 
  :signed-integer
   () )
; 
;  *  QuadraticRoot()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_QuadraticRoot" 
      ((first :signed-long) (control :signed-long) (last :signed-long) (t (:pointer :signed-long))) 
  :signed-integer
   () )
; 
;  *  PolarToPoint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_PolarToPoint" 
      ((ra (:pointer :gxpolar)) (xy (:pointer :gxpoint))) 
  (:pointer :gxpoint)
   () )
; 
;  *  PointToPolar()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_PointToPolar" 
      ((xy (:pointer :gxpoint)) (ra (:pointer :gxpolar))) 
  (:pointer :gxpolar)
   () )
; 
;  *  FractCubeRoot()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_FractCubeRoot" 
      ((source :signed-long)) 
  :fract
   () )
; 
;  *  FractDivide()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_FractDivide" 
      ((dividend :signed-long) (divisor :signed-long)) 
  :fract
   () )
; 
;  *  FractMultiply()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_FractMultiply" 
      ((multiplicand :signed-long) (multiplier :signed-long)) 
  :fract
   () )
; 
;  *  FractSineCosine()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_FractSineCosine" 
      ((degrees :signed-long) (cosine (:pointer :signed-long))) 
  :fract
   () )
; 
;  *  FractSquareRoot()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_FractSquareRoot" 
      ((source :signed-long)) 
  :fract
   () )
; 
;  *  FixedDivide()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_FixedDivide" 
      ((dividend :signed-long) (divisor :signed-long)) 
  :fixed
   () )
; 
;  *  FixedMultiply()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_FixedMultiply" 
      ((multiplicand :signed-long) (multiplier :signed-long)) 
  :fixed
   () )
;  This next call is (source * multiplier / divisor) -- it avoids underflow, overflow by using wides 
; 
;  *  MultiplyDivide()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_MultiplyDivide" 
      ((source :signed-long) (multiplier :signed-long) (divisor :signed-long)) 
  :signed-long
   () )
; 
;  *  Magnitude()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Magnitude" 
      ((deltaX :signed-long) (deltaY :signed-long)) 
  :unsigned-long
   () )
; 
;  *  VectorMultiplyDivide()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_VectorMultiplyDivide" 
      ((count :signed-long) (vector1 (:pointer :signed-long)) (step1 :signed-long) (vector2 (:pointer :signed-long)) (step2 :signed-long) (divisor :signed-long)) 
  :signed-long
   () )

;  wide operations are defined within FixMath.h for PowerPC 
; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC TARGET_OS_MAC AND TARGET_CPU_68K 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  WideAdd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_WideAdd" 
      ((target (:pointer :wide)) (source (:pointer :wide))) 
  (:pointer :wide)
   () )
; 
;  *  WideCompare()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_WideCompare" 
      ((target (:pointer :wide)) (source (:pointer :wide))) 
  :signed-integer
   () )
; 
;  *  WideNegate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_WideNegate" 
      ((target (:pointer :wide))) 
  (:pointer :wide)
   () )
; 
;  *  WideShift()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_WideShift" 
      ((target (:pointer :wide)) (shift :signed-long)) 
  (:pointer :wide)
   () )
; 
;  *  WideSquareRoot()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_WideSquareRoot" 
      ((source (:pointer :wide))) 
  :unsigned-long
   () )
; 
;  *  WideSubtract()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_WideSubtract" 
      ((target (:pointer :wide)) (source (:pointer :wide))) 
  (:pointer :wide)
   () )
; 
;  *  WideMultiply()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_WideMultiply" 
      ((multiplicand :signed-long) (multiplier :signed-long) (target (:pointer :wide))) 
  (:pointer :wide)
   () )
;  returns the quotient 
; 
;  *  WideDivide()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_WideDivide" 
      ((dividend (:pointer :wide)) (divisor :signed-long) (remainder (:pointer :signed-long))) 
  :signed-long
   () )
;  quotient replaces dividend 
; 
;  *  WideWideDivide()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_WideWideDivide" 
      ((dividend (:pointer :wide)) (divisor :signed-long) (remainder (:pointer :signed-long))) 
  (:pointer :wide)
   () )
; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  VectorMultiply()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_VectorMultiply" 
      ((count :signed-long) (vector1 (:pointer :signed-long)) (step1 :signed-long) (vector2 (:pointer :signed-long)) (step2 :signed-long) (dot (:pointer :wide))) 
  (:pointer :wide)
   () )
; 
;  *  RandomBits()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_RandomBits" 
      ((count :signed-long) (focus :signed-long)) 
  :unsigned-long
   () )
; 
;  *  SetRandomSeed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_SetRandomSeed" 
      ((seed (:pointer :wide))) 
  nil
   () )
; 
;  *  GetRandomSeed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetRandomSeed" 
      ((seed (:pointer :wide))) 
  (:pointer :wide)
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := GXMathIncludes

; $ENDC                                         ; __GXMATH__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'GXMath)