(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:ICAApplication.p"
; at Wednesday May 1,2002 2:41:11 pm.
; 
;      File:       ICAApplication.p
;  
;      Contains:   General purpose Image Capture definitions
;  
;      Version:    Technology: 1.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   2000-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __ICAAPPLICATION__
; $SETC __ICAAPPLICATION__ := 1

; $I+
; $SETC ICAApplicationIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFDICTIONARY__
|#

(require-interface 'CFDictionary)
#|                                              ; $I CFDictionary.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :icaobject (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :icaobjectptr (find-mactype '(:pointer :pointer)));  when a VAR xx:ICAObject parameter can be nil, it is changed to xx: ICAObjectPtr 
(def-mactype :icaproperty (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :icapropertyptr (find-mactype '(:pointer :pointer)));  when a VAR xx:ICAProperty parameter can be nil, it is changed to xx: ICAPropertyPtr 
(def-mactype :icaconnectionid (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :icaconnectionidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:ICAConnectionID parameter can be nil, it is changed to xx: ICAConnectionIDPtr 
; 	
; 	--------------- Defines --------------- 
; 		
;   Error codes (Image Capture range = -9900...-9949) 

(defconstant $kICACommunicationErr -9900)
(defconstant $kICADeviceNotFoundErr -9901)
(defconstant $kICADeviceNotOpenErr -9902)
(defconstant $kICAFileCorruptedErr -9903)
(defconstant $kICAIOPendingErr -9904)
(defconstant $kICAInvalidObjectErr -9905)
(defconstant $kICAInvalidPropertyErr -9906)
(defconstant $kICAIndexOutOfRangeErr -9907)
(defconstant $kICAPropertyTypeNotFoundErr -9908)

; 	
; 	NOTE: vendor specific constants are UPPERCASE  (exception: 'TEXT')
; 		
;   ICAObject types and subtypes  
(defconstant $kICADevice :|icdv|)               ;   Also creator of device library files  
(defconstant $kICADeviceCamera :|cmra|)         ;   Also file type of device library files  
(defconstant $kICADeviceScanner :|scan|)        ;   Also file type of device library files  
(defconstant $kICADeviceMFP :|mfp |)            ;   Also file type of device library files  
(defconstant $kICAList :|objl|)
(defconstant $kICADirectory :|dire|)
(defconstant $kICAFile :|file|)
(defconstant $kICAFileImage :|imag|)
(defconstant $kICAFileMovie :|moov|)
(defconstant $kICAFileAudio :|audo|)
(defconstant $kICAFileFirmware :|firm|)
(defconstant $kICAFileOther :|othe|)

;   ICAProperties  
(defconstant $kICAProperty :|prop|)             ;    
;      file properties  
;    
;   for images, refer to 'Digital Still Camera Image File Format Standard' Exif Version 2.1 section 2.6.4. and 2.6.5. 
(defconstant $kICAPropertyImageWidth :|0100|)   ;   UInt32  
(defconstant $kICAPropertyImageHeight :|0101|)  ;   UInt32  
(defconstant $kICAPropertyImageBitDepth :|0102|);   UInt32  
(defconstant $kICAPropertyImageDPI :|011A|)     ;   UInt32  
(defconstant $kICAPropertyImageExposureTime :|829A|)
(defconstant $kICAPropertyImageFNumber :|829D|)
(defconstant $kICAPropertyImageDateOriginal :|9003|);   null terminated string (YYYYMMDDThhmmss.s)  
(defconstant $kICAPropertyImageDateDigitized :|9004|);   null terminated string (YYYYMMDDThhmmss.s)  
(defconstant $kICAPropertyImageShutterSpeed :|9201|);    
(defconstant $kICAPropertyImageAperture :|9202|);    
(defconstant $kICAPropertyImageFlash :|9209|)   ;   UInt16 
(defconstant $kICAPropertyColorSpace :|A001|)   ;   UInt16 
(defconstant $kICAPropertyImageFilename :|ifil|);   null terminated string  
(defconstant $kICAPropertyImageSize :|isiz|)    ;   UInt32  
(defconstant $kICAPropertyImageData :|idat|)    ;   void *  
(defconstant $kICAPropertyImageThumbnail :|thum|);   void *  
(defconstant $kICAPropertyColorSyncProfile :|prof|)

;   Messages  
(defconstant $kICAMessageConnect :|open|)
(defconstant $kICAMessageDisconnect :|clos|)
(defconstant $kICAMessageReset :|rese|)
(defconstant $kICAMessageCheckDevice :|chkd|)

;   Data type definitions, mapped to AppleEvent types  
(defconstant $kICATypeUInt16 :|ui16|)           ;   UInt16  
(defconstant $kICATypeUInt32 :|ui32|)           ;   UInt32  
(defconstant $kICATypeUInt64 :|ui64|)           ;   UInt64  
(defconstant $kICATypeSInt16 :|si16|)           ;   SInt16  
(defconstant $kICATypeSInt32 :|si32|)           ;   SInt32  
(defconstant $kICATypeSInt64 :|si64|)           ;   SInt64  
(defconstant $kICATypeFixed :|sing|)            ;   typeIEEE32BitFloatingPoint  
(defconstant $kICATypeBoolean :|bool|)          ;   typeBoolean  
(defconstant $kICATypeString :|TEXT|)           ;   typeChar  
(defconstant $kICATypeData :|data|)             ;   void *  
(defconstant $kICATypeThumbnail :|thum|)        ;   ICAThumbnail 

;   Flags for PropertyInfo flag element  
(defconstant $kICAFlagReadWriteAccess #x1)
(defconstant $kICAFlagReadAccess #x2)

;   Notification types (Refer to section 12.4 of PTP spec)  
(defconstant $kICAEventCancelTransaction :|ecnt|)
(defconstant $kICAEventObjectAdded :|eoba|)
(defconstant $kICAEventObjectRemoved :|eobr|)
(defconstant $kICAEventStoreAdded :|esta|)
(defconstant $kICAEventStoreRemoved :|estr|)
(defconstant $kICAEventDeviceAdded :|edea|)
(defconstant $kICAEventDeviceRemoved :|eder|)
(defconstant $kICAEventDevicePropChanged :|edpc|)
(defconstant $kICAEventObjectInfoChanged :|eoic|)
(defconstant $kICAEventDeviceInfoChanged :|edic|)
(defconstant $kICAEventRequestObjectTransfer :|erot|)
(defconstant $kICAEventStoreFull :|estf|)
(defconstant $kICAEventDeviceReset :|edvr|)
(defconstant $kICAEventStorageInfoChanged :|esic|)
(defconstant $kICAEventCaptureComplete :|ecpc|)
(defconstant $kICAEventUnreportedStatus :|eurs|)

;   Used for partial reads via ICAGetPropertyData  
(defconstant $kICAStartAtBeginning 0)
(defconstant $kICAEntireLength -1)

;   ICADownloadFile flags  
(defconstant $kDeleteAfterDownload #x1)
(defconstant $kCreateCustomIcon #x2)
(defconstant $kAddMetaDataToFinderComment #x4)
(defconstant $kAdjustCreationDate #x8)
(defconstant $kSetFileTypeAndCreator #x10)
(defconstant $kEmbedColorSyncProfile #x20)
(defconstant $kRotateImage #x40)

; 	
; 	--------------- Structures --------------- 
; 		

(def-mactype :icaobjectinfoptr (find-mactype '(:pointer :icaobjectinfo)))
(defrecord ICAObjectInfo 
   (objectType :ostype)                         ;   i.e. kICAFile 
   (objectSubtype :ostype)                      ;   i.e. kICAFileImage   
   )

(def-mactype :icapropertyinfoptr (find-mactype '(:pointer :icapropertyinfo)))
(defrecord ICAPropertyInfo 
   (propertyType :ostype)
   (dataType :ostype)
   (dataSize :unsigned-long)
   (dataFlags :unsigned-long)
   )

(def-mactype :icamessageptr (find-mactype '(:pointer :icamessage)))
(defrecord ICAMessage 
   (messageType :ostype)                        ;   <--  i.e. kICAMessageCameraCaptureNewImage  
   (startByte :unsigned-long)                   ;   <--  
   (dataPtr :pointer)                           ;   <--  
   (dataSize :unsigned-long)                    ;   <--  
   (dataType :ostype)                           ;   <--  
   )

(def-mactype :icathumbnailptr (find-mactype '(:pointer :icathumbnail)))
(defrecord ICAThumbnail 
   (width :unsigned-long)
   (height :unsigned-long)
   (dataSize :unsigned-long)
   (data :signed-byte)                          ;   8-bit RGB data (RGBRGBRGB...) 
   )

(defconstant $kICAPBVersion #x10000)

; 	 
; 	--------------- Completion Procs --------------- 
; 		
; 
; 	   
; 	   NOTE: the parameter for the completion proc (ICAHeader*) has to be casted to the appropriate type
; 	   e.g. (ICAGetChildCountPB*), ...
; 	   
; 	

(def-mactype :icaheaderptr (find-mactype '(:pointer :icaheader)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ICACompletion = PROCEDURE(pb: ICAHeaderPtr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :icacompletion (find-mactype ':pointer))
; $ENDC

; 	 
; 	--------------- ICAHeader --------------- 
; 		
(defrecord ICAHeader 
   (err :signed-integer)                        ;   -->  
   (refcon :unsigned-long)                      ;   <--  
   )

; 	
; 	--------------- Object parameter blocks --------------- 
; 		
(def-mactype :icagetchildcountpbptr (find-mactype '(:pointer :icagetchildcountpb)))
(defrecord ICAGetChildCountPB 
   (header :icaheader)
   (object :pointer)                            ;   <--  
   (count :unsigned-long)                       ;   -->  
   )

(def-mactype :icagetnthchildpbptr (find-mactype '(:pointer :icagetnthchildpb)))
(defrecord ICAGetNthChildPB 
   (header :icaheader)
   (parentObject :pointer)                      ;   <--  
   (index :unsigned-long)                       ;   <-- zero based  
   (childObject :pointer)                       ;   -->  
   (childInfo :icaobjectinfo)                   ;   -->  
   )

(def-mactype :icagetobjectinfopbptr (find-mactype '(:pointer :icagetobjectinfopb)))
(defrecord ICAGetObjectInfoPB 
   (header :icaheader)
   (object :pointer)                            ;   <--  
   (objectInfo :icaobjectinfo)                  ;   -->  
   )

(def-mactype :icagetparentofobjectpbptr (find-mactype '(:pointer :icagetparentofobjectpb)))
(defrecord ICAGetParentOfObjectPB 
   (header :icaheader)
   (object :pointer)                            ;   <--  
   (parentObject :pointer)                      ;   -->  
   (parentInfo :icaobjectinfo)                  ;   -->  
   )

(def-mactype :icagetrootofobjectpbptr (find-mactype '(:pointer :icagetrootofobjectpb)))
(defrecord ICAGetRootOfObjectPB 
   (header :icaheader)
   (object :pointer)                            ;   <--  
   (rootObject :pointer)                        ;   -->  
   (rootInfo :icaobjectinfo)                    ;   -->  
   )

(def-mactype :icagetobjectrefconpbptr (find-mactype '(:pointer :icagetobjectrefconpb)))
(defrecord ICAGetObjectRefConPB 
   (header :icaheader)
   (object :pointer)                            ;   <--  
   (objectRefCon :unsigned-long)                ;   -->  
   )

(def-mactype :icasetobjectrefconpbptr (find-mactype '(:pointer :icasetobjectrefconpb)))
(defrecord ICASetObjectRefConPB 
   (header :icaheader)
   (object :pointer)                            ;   <--  
   (objectRefCon :unsigned-long)                ;   <--  
   )

; 	
; 	--------------- Property parameter blocks --------------- 
; 		
(def-mactype :icagetpropertycountpbptr (find-mactype '(:pointer :icagetpropertycountpb)))
(defrecord ICAGetPropertyCountPB 
   (header :icaheader)
   (object :pointer)                            ;   <--  
   (count :unsigned-long)                       ;   -->  
   )

(def-mactype :icagetnthpropertypbptr (find-mactype '(:pointer :icagetnthpropertypb)))
(defrecord ICAGetNthPropertyPB 
   (header :icaheader)
   (object :pointer)                            ;   <--  
   (index :unsigned-long)                       ;   <-- zero based  
   (property :pointer)                          ;   -->  
   (propertyInfo :icapropertyinfo)              ;   -->  
   )

(def-mactype :icagetpropertybytypepbptr (find-mactype '(:pointer :icagetpropertybytypepb)))
(defrecord ICAGetPropertyByTypePB 
   (header :icaheader)
   (object :pointer)                            ;   <--  
   (propertyType :ostype)                       ;   <--  
   (property :pointer)                          ;   -->  
   (propertyInfo :icapropertyinfo)              ;   -->  
   )

(def-mactype :icagetpropertyinfopbptr (find-mactype '(:pointer :icagetpropertyinfopb)))
(defrecord ICAGetPropertyInfoPB 
   (header :icaheader)
   (property :pointer)                          ;   <--  
   (propertyInfo :icapropertyinfo)              ;   -->  
   )

(def-mactype :icagetpropertydatapbptr (find-mactype '(:pointer :icagetpropertydatapb)))
(defrecord ICAGetPropertyDataPB 
   (header :icaheader)
   (property :pointer)                          ;   <--  
   (startByte :unsigned-long)                   ;   <--  
   (requestedSize :unsigned-long)               ;   <--  
   (dataPtr :pointer)                           ;   <->  
   (actualSize :unsigned-long)                  ;   -->  
   (dataType :ostype)                           ;   -->  
   )

(def-mactype :icasetpropertydatapbptr (find-mactype '(:pointer :icasetpropertydatapb)))
(defrecord ICASetPropertyDataPB 
   (header :icaheader)
   (property :pointer)                          ;   <--  
   (startByte :unsigned-long)                   ;   <--  
   (dataPtr :pointer)                           ;   <--  
   (dataSize :unsigned-long)                    ;   <--  
   (dataType :ostype)                           ;   <--  
   )

(def-mactype :icagetparentofpropertypbptr (find-mactype '(:pointer :icagetparentofpropertypb)))
(defrecord ICAGetParentOfPropertyPB 
   (header :icaheader)
   (property :pointer)                          ;   <--  
   (parentObject :pointer)                      ;   -->  
   (parentInfo :icaobjectinfo)                  ;   -->  
   )

(def-mactype :icagetrootofpropertypbptr (find-mactype '(:pointer :icagetrootofpropertypb)))
(defrecord ICAGetRootOfPropertyPB 
   (header :icaheader)
   (property :pointer)                          ;   <--  
   (rootObject :pointer)                        ;   -->  
   (rootInfo :icaobjectinfo)                    ;   -->  
   )

(def-mactype :icagetpropertyrefconpbptr (find-mactype '(:pointer :icagetpropertyrefconpb)))
(defrecord ICAGetPropertyRefConPB 
   (header :icaheader)
   (property :pointer)                          ;   <--  
   (propertyRefCon :unsigned-long)              ;   -->  
   )

(def-mactype :icasetpropertyrefconpbptr (find-mactype '(:pointer :icasetpropertyrefconpb)))
(defrecord ICASetPropertyRefConPB 
   (header :icaheader)
   (property :pointer)                          ;   <--  
   (propertyRefCon :unsigned-long)              ;   <--  
   )

; 	
; 	--------------- Device parameter blocks --------------- 
; 		
(def-mactype :icagetdevicelistpbptr (find-mactype '(:pointer :icagetdevicelistpb)))
(defrecord ICAGetDeviceListPB 
   (header :icaheader)
   (object :pointer)                            ;   -->  
   )

(def-mactype :icaobjectsendmessagepbptr (find-mactype '(:pointer :icaobjectsendmessagepb)))
(defrecord ICAObjectSendMessagePB 
   (header :icaheader)
   (object :pointer)                            ;   <--  
   (message :icamessage)                        ;   <--  
   (result :unsigned-long)                      ;   --> message specific result 
   )

(def-mactype :icaregistereventnotificationpbptr (find-mactype '(:pointer :icaregistereventnotificationpb)))
(defrecord ICARegisterEventNotificationPB 
   (header :icaheader)
   (object :pointer)                            ;   <--  
   (notifyType :ostype)                         ;   <--  
   (notifyProc :pointer)                        ;   <--  
   )

(def-mactype :icadownloadfilepbptr (find-mactype '(:pointer :icadownloadfilepb)))
(defrecord ICADownloadFilePB 
   (header :icaheader)
   (object :pointer)                            ;   <--  
   (dirFSRef (:pointer :fsref))                 ;   <--  
   (flags :unsigned-long)                       ;   <--  
   (fileType :ostype)                           ;   <--  
   (fileCreator :ostype)                        ;   <--  
   (rotationAngle :signed-long)                 ;   <--  
   (fileFSRef (:pointer :fsref))                ;   --> can be NULL 
   )

(def-mactype :icacopyobjectpropertydictionarypbptr (find-mactype '(:pointer :icacopyobjectpropertydictionarypb)))
(defrecord ICACopyObjectPropertyDictionaryPB 
   (header :icaheader)
   (object :pointer)                            ;   <--  
   (theDict (:pointer :pointer))                ;   -->  
   )

; 
; 	   
; 	   NOTE: for all APIs - pass NULL as completion parameter to make a synchronous call 
; 	   
; 	
; 	
; 	--------------- Object functions --------------- 
; 		

; 
; 	 *  ICAGetChildCount()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;  *  ICAGetNthChild()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ICAGetChildCount" 
      ((pb (:pointer :icagetchildcountpb)) (completion :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  ICAGetObjectInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ICAGetNthChild" 
      ((pb (:pointer :icagetnthchildpb)) (completion :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  ICAGetParentOfObject()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ICAGetObjectInfo" 
      ((pb (:pointer :icagetobjectinfopb)) (completion :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  ICAGetRootOfObject()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ICAGetParentOfObject" 
      ((pb (:pointer :icagetparentofobjectpb)) (completion :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  ICAGetObjectRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ICAGetRootOfObject" 
      ((pb (:pointer :icagetrootofobjectpb)) (completion :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  ICASetObjectRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ICAGetObjectRefCon" 
      ((pb (:pointer :icagetobjectrefconpb)) (completion :pointer)) 
  :signed-integer
   () )                                         ; 
; --------------- Property functions --------------- 
;                                               ; 
;  *  ICAGetPropertyCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ICASetObjectRefCon" 
      ((pb (:pointer :icasetobjectrefconpb)) (completion :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  ICAGetNthProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ICAGetPropertyCount" 
      ((pb (:pointer :icagetpropertycountpb)) (completion :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  ICAGetPropertyByType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ICAGetNthProperty" 
      ((pb (:pointer :icagetnthpropertypb)) (completion :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  ICAGetPropertyInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ICAGetPropertyByType" 
      ((pb (:pointer :icagetpropertybytypepb)) (completion :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  ICAGetPropertyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ICAGetPropertyInfo" 
      ((pb (:pointer :icagetpropertyinfopb)) (completion :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  ICASetPropertyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ICAGetPropertyData" 
      ((pb (:pointer :icagetpropertydatapb)) (completion :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  ICAGetParentOfProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ICASetPropertyData" 
      ((pb (:pointer :icasetpropertydatapb)) (completion :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  ICAGetRootOfProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ICAGetParentOfProperty" 
      ((pb (:pointer :icagetparentofpropertypb)) (completion :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  ICAGetPropertyRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ICAGetRootOfProperty" 
      ((pb (:pointer :icagetrootofpropertypb)) (completion :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  ICASetPropertyRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ICAGetPropertyRefCon" 
      ((pb (:pointer :icagetpropertyrefconpb)) (completion :pointer)) 
  :signed-integer
   () )                                         ;  
; --------------- Device functions --------------- 
;                                               ; 
;  *  ICAGetDeviceList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ICASetPropertyRefCon" 
      ((pb (:pointer :icasetpropertyrefconpb)) (completion :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  ICAObjectSendMessage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ICAGetDeviceList" 
      ((pb (:pointer :icagetdevicelistpb)) (completion :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  ICARegisterEventNotification()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ICAObjectSendMessage" 
      ((pb (:pointer :icaobjectsendmessagepb)) (completion :pointer)) 
  :signed-integer
   () )                                         ;  
; ------------------------------------------------ 
;                                               ; 
;  *  ICADownloadFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.1 and later
;  
(deftrap-inline "_ICARegisterEventNotification" 
      ((pb (:pointer :icaregistereventnotificationpb)) (completion :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  ICACopyObjectPropertyDictionary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.1 and later
;  
(deftrap-inline "_ICADownloadFile" 
      ((pb (:pointer :icadownloadfilepb)) (completion :pointer)) 
  :signed-integer
   () )                                         ; $ALIGN RESET; $POP; $SETC UsingIncludes := ICAApplicationIncludes
(deftrap-inline "_ICACopyObjectPropertyDictionary" 
      ((pb (:pointer :icacopyobjectpropertydictionarypb)) (completion :pointer)) 
  :signed-integer
   () )                                         ; $ENDC; __ICAAPPLICATION__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'ICAApplication)