(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:ICADevice.p"
; at Wednesday May 1,2002 2:41:11 pm.
; 
;      File:       ICADevice.p
;  
;      Contains:   Image Capture device definitions.  This file is included
;  
;      Version:    Technology: 1.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   2000-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __ICADEVICE__
; $SETC __ICADEVICE__ := 1

; $I+
; $SETC ICADeviceIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __ICAAPPLICATION__
|#

(require-interface 'ICAApplication)
#|                                              ; $I ICAApplication.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  
; --------------- Completion Procs --------------- 
; 
; 
;    
;    NOTE: the parameter for the completion proc (ICDHeader*) has to be casted to the appropriate type
;    e.g. (ICD_BuildObjectChildrenPB*), ...
;    
; 

(def-mactype :icdheaderptr (find-mactype '(:pointer :icdheader)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ICDCompletion = PROCEDURE(pb: ICDHeaderPtr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :icdcompletion (find-mactype ':pointer))
; $ENDC

; 	 
; 	--------------- ICDHeader --------------- 
; 		
(defrecord ICDHeader 
   (err :signed-integer)                        ;   -->  
   (refcon :unsigned-long)                      ;   <--  
   )

; 	
; 	--------------- Object parameter blocks ---------------
; 		
(def-mactype :icd_newobjectpbptr (find-mactype '(:pointer :icd_newobjectpb)))
(defrecord ICD_NewObjectPB 
   (header :icdheader)
   (parentObject :pointer)                      ;   <--  
   (objectInfo :icaobjectinfo)                  ;   <--  
   (object :pointer)                            ;   -->  
   )

(def-mactype :icd_disposeobjectpbptr (find-mactype '(:pointer :icd_disposeobjectpb)))
(defrecord ICD_DisposeObjectPB 
   (header :icdheader)
   (object :pointer)                            ;   <--  
   )

; 	
; 	--------------- Property parameter blocks ---------------
; 		
(def-mactype :icd_newpropertypbptr (find-mactype '(:pointer :icd_newpropertypb)))
(defrecord ICD_NewPropertyPB 
   (header :icdheader)
   (object :pointer)                            ;   <--  
   (propertyInfo :icapropertyinfo)              ;   <--  
   (property :pointer)                          ;   -->  
   )

(def-mactype :icd_disposepropertypbptr (find-mactype '(:pointer :icd_disposepropertypb)))
(defrecord ICD_DisposePropertyPB 
   (header :icdheader)
   (property :pointer)                          ;   <--  
   )

; 
; 	   
; 	   NOTE: for all APIs - pass NULL as completion parameter to make a synchronous call 
; 	   
; 	

; 	 
; 	--------------- Object utilities for device libraries --------------- 
; 		
; 
; 	 *  ICDNewObject()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;  *  ICDDisposeObject()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ICDNewObject" 
      ((pb (:pointer :icd_newobjectpb)) (completion :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  ICDNewProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ICDDisposeObject" 
      ((pb (:pointer :icd_disposeobjectpb)) (completion :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  ICDDisposeProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ImageCaptureLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ICDNewProperty" 
      ((pb (:pointer :icd_newpropertypb)) (completion :pointer)) 
  :signed-integer
   () )                                         ; $ALIGN RESET; $POP; $SETC UsingIncludes := ICADeviceIncludes
(deftrap-inline "_ICDDisposeProperty" 
      ((pb (:pointer :icd_disposepropertypb)) (completion :pointer)) 
  :signed-integer
   () )                                         ; $ENDC; __ICADEVICE__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'ICADevice)