(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:JManager.p"
; at Wednesday May 1,2002 2:42:04 pm.
; 
;      File:       JManager.p
;  
;      Contains:   Routines that can be used to invoke the Java Virtual Machine in MRJ
;  
;      Version:    Technology: MRJ 2.1
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1996-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __JMANAGER__
; $SETC __JMANAGER__ := 1

; $I+
; $SETC JManagerIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __DRAG__
|#

(require-interface 'Drag)
#|                                              ; $I Drag.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MENUS__
|#

(require-interface 'Menus)
#|                                              ; $I Menus.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __TEXTCOMMON__
|#

(require-interface 'TextCommon)
#|                                              ; $I TextCommon.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CODEFRAGMENTS__
|#

(require-interface 'CodeFragments)
#|                                              ; $I CodeFragments.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $kJMVersion #x11800007)            ;   using Sun's 1.1.8 APIs, our rev 7 APIs.  
(defconstant $kDefaultJMTime #x400)             ;   how much time to give the JM library on "empty" events, in milliseconds.  

(defconstant $kJMVersionError -60000)
(defconstant $kJMExceptionOccurred -60001)
(defconstant $kJMBadClassPathError -60002)

; 	
; 	 * Special codes for JMFrameKey, JMFrameKeyRelease:
; 	 *
; 	 * When your app notices that a modifiers is pressed (must be done by polling,
; 	 * unless Mac OS changes to support sending modifiers as events)
; 	 * you should notify the runtime using JMFrameKey, JMFrameKeyRelease, using
; 	 * these constants for asciiChar and keyCode.  This will allow the AWT to
; 	 * synthesize the appropriate events
; 	 	
(defconstant $kModifierAsciiChar 0)
(defconstant $kModifierKeyCode 0)

; 	
; 	 *  Private data structures
; 	 *
; 	 *  JMClientData        - enough bits to reliably store a pointer to arbitrary, client-specific data. 
; 	 *  JMSessionRef        - references the entire java runtime 
; 	 *  JMTextRef           - a Text string, length, and encoding 
; 	 *  JMTextEncoding      - which encoding to use when converting in and out of Java strings.
; 	 *  JMFrameRef          - a java frame 
; 	 *  JMAWTContextRef     - a context for the AWT to request frames, process events 
; 	 *  JMAppletLocatorRef  - a device for locating, fetching, and parsing URLs that may contain applets 
; 	 *  JMAppletViewerRef   - an object that displays applets in a Frame 
; 	 *  JMAppletPageRef     - a way to group JMAWTContextRef's so they share the same class loader
; 	 	

(def-mactype :jmclientdata (find-mactype ':pointer))
(def-mactype :jmsessionref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :jmsessionrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:JMSessionRef parameter can be nil, it is changed to xx: JMSessionRefPtr 
(def-mactype :jmframeref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :jmframerefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:JMFrameRef parameter can be nil, it is changed to xx: JMFrameRefPtr 
(def-mactype :jmtextref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :jmtextrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:JMTextRef parameter can be nil, it is changed to xx: JMTextRefPtr 
(def-mactype :jmawtcontextref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :jmawtcontextrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:JMAWTContextRef parameter can be nil, it is changed to xx: JMAWTContextRefPtr 
(def-mactype :jmappletlocatorref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :jmappletlocatorrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:JMAppletLocatorRef parameter can be nil, it is changed to xx: JMAppletLocatorRefPtr 
(def-mactype :jmappletviewerref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :jmappletviewerrefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:JMAppletViewerRef parameter can be nil, it is changed to xx: JMAppletViewerRefPtr 
(def-mactype :jmappletpageref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :jmappletpagerefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:JMAppletPageRef parameter can be nil, it is changed to xx: JMAppletPageRefPtr 
(def-mactype :jmtextencoding (find-mactype ':unsigned-long))

; 	
; 	 * The runtime requires certain callbacks be used to communicate between
; 	 * session events and the embedding application.
; 	 *
; 	 * In general, you can pass nil as a callback and a "good" default will be used.
; 	 *
; 	 *  JMConsoleProcPtr        - redirect stderr or stdout - the message is delivered in the encoding specified when
; 	 *                              you created the session, or possibly binary data.
; 	 *  JMConsoleReadProcPtr    - take input from the user from a console or file.  The input is expected to 
; 	 *                              be in the encoding specified when you opened the session.
; 	 *  JMExitProcPtr           - called via System.exit(int), return "true" to kill the current thread,
; 	 *                              false, to cause a 'QUIT' AppleEvent to be sent to the current process,
; 	 *                              or just tear down the runtime and exit to shell immediately
; 	 * JMLowMemoryProcPtr       - This callback is available to notify the embedding application that
; 	 *                              a low memory situation has occurred so it can attempt to recover appropriately.
; 	 * JMAuthenicateURLProcPtr  - prompt the user for autentication based on the URL.  If you pass
; 	 *                              nil, JManager will prompt the user.  Return false if the user pressed cancel.
; 	 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	JMConsoleProcPtr = PROCEDURE(session: JMSessionRef; message: UNIV Ptr; messageLengthInBytes: SInt32); C;

|#
 |#                                             ; $ELSEC
(def-mactype :jmconsoleprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	JMConsoleReadProcPtr = FUNCTION(session: JMSessionRef; buffer: UNIV Ptr; maxBufferLength: SInt32): SInt32; C;

|#
 |#                                             ; $ELSEC
(def-mactype :jmconsolereadprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	JMExitProcPtr = FUNCTION(session: JMSessionRef; status: SInt32): BOOLEAN; C;

|#
 |#                                             ; $ELSEC
(def-mactype :jmexitprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	JMAuthenticateURLProcPtr = FUNCTION(session: JMSessionRef; url: ConstCStringPtr; realm: ConstCStringPtr; VAR userName: CHAR; VAR password: CHAR): BOOLEAN; C;

|#
 |#                                             ; $ELSEC
(def-mactype :jmauthenticateurlprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	JMLowMemoryProcPtr = PROCEDURE(session: JMSessionRef); C;

|#
 |#                                             ; $ELSEC
(def-mactype :jmlowmemoryprocptr (find-mactype ':pointer))
; $ENDC

(def-mactype :jmsessioncallbacksptr (find-mactype '(:pointer :jmsessioncallbacks)))
(defrecord JMSessionCallbacks 
   (fVersion :unsigned-long)                    ;   should be set to kJMVersion  
   (fStandardOutput :pointer)                   ;   JM will route "stdout" to this function.  
   (fStandardError :pointer)                    ;   JM will route "stderr" to this function.  
   (fStandardIn :pointer)                       ;   read from console - can be nil for default behavior (no console IO)  
   (fExitProc :pointer)                         ;   handle System.exit(int) requests  
   (fAuthenticateProc :pointer)                 ;   present basic authentication dialog  
   (fLowMemProc :pointer)                       ;   Low Memory notification Proc  
   )

(def-mactype :jmverifieroptions (find-mactype ':signed-long))

(defconstant $eDontCheckCode 0)
(defconstant $eCheckRemoteCode 1)
(defconstant $eCheckAllCode 2)

; 	
; 	 * JMRuntimeOptions is a mask that allows you to specify certain attributes
; 	 * for the runtime. Bitwise or the fields together, or use one of the "premade" entries.
; 	 * eJManager2Defaults is the factory default, and best bet to use.
; 	 	

(def-mactype :jmruntimeoptions (find-mactype ':signed-long))

(defconstant $eJManager2Defaults 0)
(defconstant $eUseAppHeapOnly #x1)
(defconstant $eDisableJITC #x2)
(defconstant $eEnableDebugger #x4)
(defconstant $eDisableInternetConfig #x8)
(defconstant $eInhibitClassUnloading #x10)
(defconstant $eEnableProfiling #x20)
(defconstant $eJManager1Compatible #x18)

; 	
; 	 * Returns the version of the currently installed JManager library.
; 	 * Compare to kJMVersion.  This is the only call that doesn't
; 	 * require a session, or a reference to something that references
; 	 * a session.
; 	 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  JMGetVersion()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in JManager 2.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_JMGetVersion" 
      () 
  :unsigned-long
   () )

; 
;  * Returns the version number of the MRJ installation.  This is an
;  * official version number that will change for each official release
;  * of MRJ, whereas for an incremental MRJ release, the version number
;  * returned by JMGetVersion may not change.
;  
; 
;  *  JMGetMRJRuntimeVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMGetMRJRuntimeVersion" 
      () 
  :unsigned-long
   () )

; 
;  * JMOpenSession creates a new Java Runtime.  Note that JManger 2.0 doesn't set 
;  * security options at the time of runtime instantiation.  AppletViewer Objecs have
;  * seperate security attributes bound to them, and the verifier is availiable elsewhere
;  * as well.  The client data parameter lets a client associate an arbitgrary tagged pointer
;  * with the seession.
;  * When you create the session, you must specify the desired Text Encoding to use for
;  * console IO.  Usually, its OK to use "kTextEncodingMacRoman".  See TextCommon.h for the list.
;  
; 
;  *  JMOpenSession()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_JMOpenSession" 
      ((session (:pointer :pointer)) (runtimeOptions :signed-long) (verifyMode :signed-long) (callbacks (:pointer :jmsessioncallbacks)) (desiredEncoding :unsigned-long) (data :pointer)) 
  :osstatus
   () )

; 
;  *  JMCloseSession()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMCloseSession" 
      ((session :pointer)) 
  :osstatus
   () )

; 
;  * Client data getter/setter functions.
;  
; 
;  *  JMGetSessionData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMGetSessionData" 
      ((session :pointer) (data (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  JMSetSessionData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMSetSessionData" 
      ((session :pointer) (data :pointer)) 
  :osstatus
   () )

; 
;  * Prepend the target of the FSSpec to the class path.
;  * If a file, .zip or other known archive file - not a .class file
;  
; 
;  *  JMAddToClassPath()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_JMAddToClassPath" 
      ((session :pointer) (spec (:pointer :fsspec))) 
  :osstatus
   () )

; 
;  * Utility returns (client owned) null terminated handle containing "file://xxxx", or nil if fnfErr
;  
; 
;  *  JMFSSToURL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_JMFSSToURL" 
      ((session :pointer) (spec (:pointer :fsspec))) 
  :handle
   () )

; 
;  * Turns "file:///disk/file" into an FSSpec.  other handlers return paramErr
;  
; 
;  *  JMURLToFSS()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMURLToFSS" 
      ((session :pointer) (urlString :pointer) (spec (:pointer :fsspec))) 
  :osstatus
   () )

; 
;  * JMIdle gives time to all Java threads. Giving more time makes Java programs run faster,
;  * but can reduce overall system responsiveness. JMIdle will return sooner if low-level (user)
;  * events appear in the event queue.
;  
; 
;  *  JMIdle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMIdle" 
      ((session :pointer) (jmTimeMillis :unsigned-long)) 
  :osstatus
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  * Java defines system-wide properties that applets can use to make queries about the
;  * host system. Many of these properties correspond to defaults provided by "Internet Config."
;  * JMPutSessionProperty can be used by a client program to modify various system-wide properties.
;  
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  JMGetSessionProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMGetSessionProperty" 
      ((session :pointer) (propertyName :pointer) (propertyValue (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  JMPutSessionProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMPutSessionProperty" 
      ((session :pointer) (propertyName :pointer) (propertyValue :pointer)) 
  :osstatus
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  * JMText: opaque object that encapsulates a string, length, and
;  * character encoding.  Strings passed between JManager and the
;  * embedding application goes through this interface.  Only the most
;  * rudimentary conversion routines are supplied - it is expected that
;  * the embedding application will most of its work in the System Script.
;  *
;  * These APIs present some questions about who actually owns the 
;  * JMText.  The rule is, if you created a JMTextRef, you are responsible
;  * for deleting it after passing it into the runtime.  If the runtime passes
;  * one to you, it will be deleted after the callback.
;  *
;  * If a pointer to an uninitialised JMTextRef is passed in to a routine (eg JMGetSessionProperty),
;  * it is assumed to have been created for the caller, and it is the callers responsibility to
;  * dispose of it.
;  *
;  * The encoding types are taken verbatim from the Text Encoding Converter,
;  * which handles the ugly backside of script conversion.
;  
; 
;  * JMNewTextRef can create from a buffer of data in the specified encoding
;  
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  JMNewTextRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMNewTextRef" 
      ((session :pointer) (textRef (:pointer :pointer)) (encoding :unsigned-long) (charBuffer :pointer) (bufferLengthInBytes :unsigned-long)) 
  :osstatus
   () )

; 
;  * JMCopyTextRef clones a text ref.
;  
; 
;  *  JMCopyTextRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMCopyTextRef" 
      ((textRefSrc :pointer) (textRefDst (:pointer :pointer))) 
  :osstatus
   () )

; 
;  * Disposes of a text ref passed back from the runtime, or created explicitly through JMNewTextRef
;  
; 
;  *  JMDisposeTextRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMDisposeTextRef" 
      ((textRef :pointer)) 
  :osstatus
   () )

; 
;  * Returns the text length, in characters
;  
; 
;  *  JMGetTextLength()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMGetTextLength" 
      ((textRef :pointer) (textLengthInCharacters (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  * Returns the text length, in number of bytes taken in the destination encoding
;  
; 
;  *  JMGetTextLengthInBytes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMGetTextLengthInBytes" 
      ((textRef :pointer) (dstEncoding :unsigned-long) (textLengthInBytes (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  * Copies the specified number of characters to the destination buffer with the appropriate
;  * destination encoding.
;  
; 
;  *  JMGetTextBytes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMGetTextBytes" 
      ((textRef :pointer) (dstEncoding :unsigned-long) (textBuffer :pointer) (textBufferLength :unsigned-long) (numCharsCopied (:pointer :unsigned-long))) 
  :osstatus
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  * Returns a Handle to a null terminated, "C" string in the System Script.
;  * Note that using this routine could result in data loss, if the characters
;  * are not availiable in the System Script.
;  
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  JMTextToMacOSCStringHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMTextToMacOSCStringHandle" 
      ((textRef :pointer)) 
  :handle
   () )

; 
;  * Proxy properties in the runtime.
;  *
;  * These will only be checked if InternetConfig isn't used to specify properties,
;  * or if it doesn't have the data for these.
;  
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :jmproxyinfoptr (find-mactype '(:pointer :jmproxyinfo)))
(defrecord JMProxyInfo 
   (useProxy :boolean)
   (proxyHost (:array :character 255 :packed))
   (proxyPort :unsigned-integer)
   )

(def-mactype :jmproxytype (find-mactype ':signed-long))

(defconstant $eHTTPProxy 0)
(defconstant $eFirewallProxy 1)
(defconstant $eFTPProxy 2)

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  JMGetProxyInfo()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in JManager 2.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_JMGetProxyInfo" 
      ((session :pointer) (proxyType :signed-long) (proxyInfo (:pointer :jmproxyinfo))) 
  :osstatus
   () )

; 
;  *  JMSetProxyInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_JMSetProxyInfo" 
      ((session :pointer) (proxyType :signed-long) (proxyInfo (:pointer :jmproxyinfo))) 
  :osstatus
   () )

; 
;  * Security - JManager 2.0 security is handled on a per-applet basis.
;  * There are some security settings that are inherited from InternetConfig
;  * (Proxy Servers) but the verifier can now be enabled and disabled.
;  
; 
;  *  JMGetVerifyMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMGetVerifyMode" 
      ((session :pointer) (verifierOptions (:pointer :signed-long))) 
  :osstatus
   () )

; 
;  *  JMSetVerifyMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMSetVerifyMode" 
      ((session :pointer) (verifierOptions :signed-long)) 
  :osstatus
   () )

; 
;  * The basic unit of AWT interaction is the JMFrame.  A JMFrame is bound to top level
;  * awt Frame, Window, or Dialog.  When a user event occurs for a MacOS window, the event is passed
;  * to the corrosponding frame object.  Similarly, when an AWT event occurs that requires the
;  * Mac OS Window to change, a callback is made.  JManager 1.x bound the frame to the window through
;  * a callback to set and restore the windows GrafPort.  In JManager 2.0, a GrafPort, Offset, and 
;  * ClipRgn are specified up front - changes in visibility and structure require that these be re-set.
;  * This enables support for the JavaSoft DrawingSurface API - and also improves graphics performance.
;  * You should reset the graphics attributes anytime the visiblity changes, like when scrolling.
;  * You should also set it initially when the AWTContext requests the frame.
;  * At various times, JM will call back to the client to register a new JMFrame, 
;  * indicating the frame type.  The client should take the following steps:
;  *
;  *  o   Create a new invisible window of the specified type
;  *  o   Fill in the callbacks parameter with function pointers
;  *  o   Do something to bind the frame to the window (like stuff the WindowPtr in the JMClientData of the frame)
;  *  o   Register the visiblity parameters (GrafPtr, etc) with the frame
;  
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :reorderrequest (find-mactype ':signed-long))

(defconstant $eBringToFront 0)                  ;   bring the window to front  
(defconstant $eSendToBack 1)                    ;   send the window to back  
(defconstant $eSendBehindFront 2)               ;   send the window behind the front window  

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	JMSetFrameSizeProcPtr = PROCEDURE(frame: JMFrameRef; {CONST}VAR newBounds: Rect); C;

|#
 |#                                             ; $ELSEC
(def-mactype :jmsetframesizeprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	JMFrameInvalRectProcPtr = PROCEDURE(frame: JMFrameRef; {CONST}VAR r: Rect); C;

|#
 |#                                             ; $ELSEC
(def-mactype :jmframeinvalrectprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	JMFrameShowHideProcPtr = PROCEDURE(frame: JMFrameRef; showFrameRequested: BOOLEAN); C;

|#
 |#                                             ; $ELSEC
(def-mactype :jmframeshowhideprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	JMSetTitleProcPtr = PROCEDURE(frame: JMFrameRef; title: JMTextRef); C;

|#
 |#                                             ; $ELSEC
(def-mactype :jmsettitleprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	JMCheckUpdateProcPtr = PROCEDURE(frame: JMFrameRef); C;

|#
 |#                                             ; $ELSEC
(def-mactype :jmcheckupdateprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	JMReorderFrame = PROCEDURE(frame: JMFrameRef; theRequest: ReorderRequest); C;

|#
 |#                                             ; $ELSEC
(def-mactype :jmreorderframe (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	JMSetResizeable = PROCEDURE(frame: JMFrameRef; resizeable: BOOLEAN); C;

|#
 |#                                             ; $ELSEC
(def-mactype :jmsetresizeable (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	JMGetFrameInsets = PROCEDURE(frame: JMFrameRef; VAR insets: Rect); C;

|#
 |#                                             ; $ELSEC
(def-mactype :jmgetframeinsets (find-mactype ':pointer))
; $ENDC

; 	
; 	 * New in JManager 2.1:
; 	 *  If the AWT needs to set focus to a frame (in the case of multiple JMFrames within
; 	 *  a single Mac OS Frame) it will call back to the embedding application using
; 	 *  JMRRequestFocus.  The application should then defocus what it thought did have the
; 	 *  focus, and set the focus to the new frame.
; 	 *  If the user is tabbing within a JMFrame, and the focus reaches the last focusable
; 	 *  component (or the first, if focus is traversing backwards) JMNexetFocus will be called.
; 	 *  The application should defocus the component that requests this, and focus the next application
; 	 *  visible focusable element.  (If none, send focus back to the frame.)
; 	 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	JMNextFocus = PROCEDURE(frame: JMFrameRef; forward: BOOLEAN); C;

|#
 |#                                             ; $ELSEC
(def-mactype :jmnextfocus (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	JMRequestFocus = PROCEDURE(frame: JMFrameRef); C;

|#
 |#                                             ; $ELSEC
(def-mactype :jmrequestfocus (find-mactype ':pointer))
; $ENDC

(def-mactype :jmframecallbacksptr (find-mactype '(:pointer :jmframecallbacks)))
(defrecord JMFrameCallbacks 
   (fVersion :unsigned-long)                    ;   should be set to kJMVersion  
   (fSetFrameSize :pointer)
   (fInvalRect :pointer)
   (fShowHide :pointer)
   (fSetTitle :pointer)
   (fCheckUpdate :pointer)
   (fReorderFrame :pointer)
   (fSetResizeable :pointer)
   (fGetInsets :pointer)
   (fNextFocus :pointer)
   (fRequestFocus :pointer)
   )

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  JMSetFrameVisibility()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in JManager 2.1 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_JMSetFrameVisibility" 
      ((frame :pointer) (famePort (:pointer :grafport)) (frameOrigin :point) (frameClip (:handle :macregion))) 
  :osstatus
   () )

; 
;  *  JMGetFrameData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMGetFrameData" 
      ((frame :pointer) (data (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  JMSetFrameData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMSetFrameData" 
      ((frame :pointer) (data :pointer)) 
  :osstatus
   () )

; 
;  *  JMGetFrameSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMGetFrameSize" 
      ((frame :pointer) (result (:pointer :rect))) 
  :osstatus
   () )

;  note that the top left indicates the "global" position of this frame 
;  use this to update the frame position when it gets moved 
; 
;  *  JMSetFrameSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_JMSetFrameSize" 
      ((frame :pointer) (newSize (:pointer :rect))) 
  :osstatus
   () )

; 
;  * Dispatch a particular event to an embedded frame
;  
; 
;  *  JMFrameClickWithEventRecord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_JMFrameClickWithEventRecord" 
      ((frame :pointer) (localPos :point) (event (:pointer :eventrecord))) 
  :osstatus
   () )

; 
;  *  JMFrameKey()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMFrameKey" 
      ((frame :pointer) (asciiChar :signed-byte) (keyCode :signed-byte) (modifiers :signed-integer)) 
  :osstatus
   () )

; 
;  *  JMFrameKeyRelease()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMFrameKeyRelease" 
      ((frame :pointer) (asciiChar :signed-byte) (keyCode :signed-byte) (modifiers :signed-integer)) 
  :osstatus
   () )

; 
;  *  JMFrameUpdate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMFrameUpdate" 
      ((frame :pointer) (updateRgn (:handle :macregion))) 
  :osstatus
   () )

; 
;  *  JMFrameActivate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMFrameActivate" 
      ((frame :pointer) (activate :boolean)) 
  :osstatus
   () )

; 
;  *  JMFrameResume()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMFrameResume" 
      ((frame :pointer) (resume :boolean)) 
  :osstatus
   () )

; 
;  *  JMFrameMouseOver()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMFrameMouseOver" 
      ((frame :pointer) (localPos :point) (modifiers :signed-integer)) 
  :osstatus
   () )

; 
;  *  JMFrameShowHide()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMFrameShowHide" 
      ((frame :pointer) (showFrame :boolean)) 
  :osstatus
   () )

; 
;  *  JMFrameGoAway()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMFrameGoAway" 
      ((frame :pointer)) 
  :osstatus
   () )

; 
;  *  JMGetFrameContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMGetFrameContext" 
      ((frame :pointer)) 
  :pointer
   () )

; 
;  *  JMFrameDragTracking()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMFrameDragTracking" 
      ((frame :pointer) (message :signed-integer) (theDragRef :signed-long)) 
  :osstatus
   () )

; 
;  *  JMFrameDragReceive()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMFrameDragReceive" 
      ((frame :pointer) (theDragRef :signed-long)) 
  :osstatus
   () )

; 
;  * JMFrameClick is deprecated - please use JMFrameClickWithEventRecord instead.
;  
; 
;  *  JMFrameClick()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMFrameClick" 
      ((frame :pointer) (localPos :point) (modifiers :signed-integer)) 
  :osstatus
   () )

; 
;  * If you may have multiple JMFrames in a single Mac OS Window (for example,
;  * in a browser) then use JMFrameFocus to control when you believe the
;  * frame should logically contain the focus.  This will allow for the correct
;  * appearance of Controls and Text Fields.  If you will only have one
;  * JMFrame per Mac OS Window, use JMFrameFocus as well as JMFrameActivate to
;  * control hiliting.
;  
; 
;  *  JMFrameFocus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMFrameFocus" 
      ((frame :pointer) (gotFocus :boolean)) 
  :osstatus
   () )

; 
;  * Cause a Frame and its contents to be rendered in a GrafPort.
;  * This is typically going to be used to cause an applet to print itself
;  * into a PrGrafPort.
;  * If you pass 'true' as the last parameter, the paint(Graphics) method of the
;  * frame is called, rather than print(Graphics).
;  
; 
;  *  JMDrawFrameInPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMDrawFrameInPort" 
      ((frame :pointer) (framePort (:pointer :grafport)) (frameOrigin :point) (clipRgn (:handle :macregion)) (callPaintAsOpposedToPrint :boolean)) 
  :osstatus
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  * Window types
;  

(def-mactype :jmframekind (find-mactype ':signed-long))

(defconstant $eBorderlessModelessWindowFrame 0)
(defconstant $eModelessWindowFrame 1)
(defconstant $eModalWindowFrame 2)
(defconstant $eModelessDialogFrame 3)

; 	 JMAppletPageRef -
; 	 * Creating a "page" is optional. 
; 	 * Applets will share the same class loader (and thus static variables) iff
; 	 * they are share the same JMAppletPageRef and have the same codebase.
; 	 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  JMNewAppletPage()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in JManager 2.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_JMNewAppletPage" 
      ((page (:pointer :pointer)) (session :pointer)) 
  :osstatus
   () )

; 
;  *  JMDisposeAppletPage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMDisposeAppletPage" 
      ((page :pointer)) 
  :osstatus
   () )

;  JMAWTContext -
;  * To create a top level frame, you must use a JMAWTContext object.
;  * The JMAWTContext provides a context for the AWT to request frames.
;  * A AWTContext has a threadgroup associated with it - all events and processing occurs
;  * there.  When you create one, it is quiescent, you must call resume before it begins executing.
;  
; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	JMRequestFrameProcPtr = FUNCTION(context: JMAWTContextRef; newFrame: JMFrameRef; kind: JMFrameKind; {CONST}VAR initialBounds: Rect; resizeable: BOOLEAN; VAR callbacks: JMFrameCallbacks): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :jmrequestframeprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	JMReleaseFrameProcPtr = FUNCTION(context: JMAWTContextRef; oldFrame: JMFrameRef): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :jmreleaseframeprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	JMUniqueMenuIDProcPtr = FUNCTION(context: JMAWTContextRef; isSubmenu: BOOLEAN): SInt16; C;

|#
 |#                                             ; $ELSEC
(def-mactype :jmuniquemenuidprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	JMExceptionOccurredProcPtr = PROCEDURE(context: JMAWTContextRef; exceptionName: JMTextRef; exceptionMsg: JMTextRef; stackTrace: JMTextRef); C;

|#
 |#                                             ; $ELSEC
(def-mactype :jmexceptionoccurredprocptr (find-mactype ':pointer))
; $ENDC

(def-mactype :jmawtcontextcallbacksptr (find-mactype '(:pointer :jmawtcontextcallbacks)))
(defrecord JMAWTContextCallbacks 
   (fVersion :unsigned-long)                    ;   should be set to kJMVersion  
   (fRequestFrame :pointer)                     ;   a new frame is being created.  
   (fReleaseFrame :pointer)                     ;   an existing frame is being destroyed.  
   (fUniqueMenuID :pointer)                     ;   a new menu will be created with this id.  
   (fExceptionOccurred :pointer)                ;   just some notification that some recent operation caused an exception.  You can't do anything really from here.  
   )

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  JMNewAWTContext()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in JManager 2.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_JMNewAWTContext" 
      ((context (:pointer :pointer)) (session :pointer) (callbacks (:pointer :jmawtcontextcallbacks)) (data :pointer)) 
  :osstatus
   () )

; 
;  *  JMNewAWTContextInPage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_JMNewAWTContextInPage" 
      ((context (:pointer :pointer)) (session :pointer) (page :pointer) (callbacks (:pointer :jmawtcontextcallbacks)) (data :pointer)) 
  :osstatus
   () )

; 
;  *  JMDisposeAWTContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMDisposeAWTContext" 
      ((context :pointer)) 
  :osstatus
   () )

; 
;  *  JMGetAWTContextData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMGetAWTContextData" 
      ((context :pointer) (data (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  JMSetAWTContextData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMSetAWTContextData" 
      ((context :pointer) (data :pointer)) 
  :osstatus
   () )

; 
;  *  JMCountAWTContextFrames()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMCountAWTContextFrames" 
      ((context :pointer) (frameCount (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  JMGetAWTContextFrame()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMGetAWTContextFrame" 
      ((context :pointer) (frameIndex :unsigned-long) (frame (:pointer :pointer))) 
  :osstatus
   () )

; 
;  * Starting in MRJ 2.1, JMMenuSelected is deprecated.  Please use JMMenuSelectedWithModifiers instead.
;  
; 
;  *  JMMenuSelected()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMMenuSelected" 
      ((context :pointer) (hMenu (:handle :menuinfo)) (menuItem :signed-integer)) 
  :osstatus
   () )

; 
;  * Starting in MRJ 2.1, this call takes an additional 'modifiers' parameter that you can get
;  * from your event record.
;  
; 
;  *  JMMenuSelectedWithModifiers()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMMenuSelectedWithModifiers" 
      ((context :pointer) (hMenu (:handle :menuinfo)) (menuItem :signed-integer) (modifiers :signed-integer)) 
  :osstatus
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  * JMAppletLocator - Since Java applets are always referenced by a Uniform Resource Locator
;  * (see RFC 1737, http://www.w3.org/pub/WWW/Addressing/rfc1738.txt), we provide an object
;  * that encapsulates the information about a set of applets. A JMAppletLocator is built
;  * by providing a base URL, which must point at a valid HTML document containing applet
;  * tags. To save a network transaction, the contents of the document may be passed optionally. 
;  *
;  * You can also use a JMLocatorInfoBlock for a synchronous resolution of the applet,
;  * assuming that you already have the info for the tag.
;  

(def-mactype :jmlocatorerrors (find-mactype ':signed-long))

(defconstant $eLocatorNoErr 0)                  ;   the html was retrieved successfully 
(defconstant $eHostNotFound 1)                  ;   the host specified by the url could not be found 
(defconstant $eFileNotFound 2)                  ;   the file could not be found on the host 
(defconstant $eLocatorTimeout 3)                ;   a timeout occurred retrieving the html text 
(defconstant $eLocatorKilled 4)                 ;   in response to a JMDisposeAppletLocator before it has completed 

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	JMFetchCompleted = PROCEDURE(ref: JMAppletLocatorRef; status: JMLocatorErrors); C;

|#
 |#                                             ; $ELSEC
(def-mactype :jmfetchcompleted (find-mactype ':pointer))
; $ENDC

(def-mactype :jmappletlocatorcallbacksptr (find-mactype '(:pointer :jmappletlocatorcallbacks)))
(defrecord JMAppletLocatorCallbacks 
   (fVersion :unsigned-long)                    ;   should be set to kJMVersion  
   (fCompleted :pointer)                        ;   called when the html has been completely fetched  
   )

; 	
; 	 * These structures are used to pass pre-parsed parameter
; 	 * tags to the AppletLocator.  Implies synchronous semantics.
; 	 	

(def-mactype :jmliboptionalparamsptr (find-mactype '(:pointer :jmliboptionalparams)))
(defrecord JMLIBOptionalParams 
   (fParamName :pointer)                        ;   could be from a <parameter name=foo value=bar> or "zipbase", etc  
   (fParamValue :pointer)                       ;   the value of this optional tag  
   )

(def-mactype :jmlocatorinfoblockptr (find-mactype '(:pointer :jmlocatorinfoblock)))
(defrecord JMLocatorInfoBlock 
   (fVersion :unsigned-long)                    ;   should be set to kJMVersion  
;   These are required to be present and not nil  
   (fBaseURL :pointer)                          ;   the URL of this applet's host page  
   (fAppletCode :pointer)                       ;   code= parameter  
   (fWidth :signed-integer)                     ;   width= parameter  
   (fHeight :signed-integer)                    ;   height= parameter  
;   These are optional parameters  
   (fOptionalParameterCount :signed-long)       ;   how many in this array  
   (fParams (:pointer :jmliboptionalparams))    ;   pointer to an array of these (points to first element)  
   )

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  JMNewAppletLocator()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in JManager 2.1 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_JMNewAppletLocator" 
      ((locatorRef (:pointer :pointer)) (session :pointer) (callbacks (:pointer :jmappletlocatorcallbacks)) (url :pointer) (htmlText :pointer) (data :pointer)) 
  :osstatus
   () )

; 
;  *  JMNewAppletLocatorFromInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_JMNewAppletLocatorFromInfo" 
      ((locatorRef (:pointer :pointer)) (session :pointer) (info (:pointer :jmlocatorinfoblock)) (data :pointer)) 
  :osstatus
   () )

; 
;  *  JMDisposeAppletLocator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMDisposeAppletLocator" 
      ((locatorRef :pointer)) 
  :osstatus
   () )

; 
;  *  JMGetAppletLocatorData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMGetAppletLocatorData" 
      ((locatorRef :pointer) (data (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  JMSetAppletLocatorData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMSetAppletLocatorData" 
      ((locatorRef :pointer) (data :pointer)) 
  :osstatus
   () )

; 
;  *  JMCountApplets()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMCountApplets" 
      ((locatorRef :pointer) (appletCount (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  JMGetAppletDimensions()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMGetAppletDimensions" 
      ((locatorRef :pointer) (appletIndex :unsigned-long) (width (:pointer :unsigned-long)) (height (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  JMGetAppletTag()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMGetAppletTag" 
      ((locatorRef :pointer) (appletIndex :unsigned-long) (tagRef (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  JMGetAppletName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMGetAppletName" 
      ((locatorRef :pointer) (appletIndex :unsigned-long) (nameRef (:pointer :pointer))) 
  :osstatus
   () )

; 
;  * JMAppletViewer - Applets are instantiated, one by one, by specifying a JMAppletLocator and
;  * a zero-based index (Macintosh API's usually use one-based indexing, the Java language
;  * uses zero, however.). The resulting applet is encapsulated in a JMAppletViewer object. 
;  * Since applets can have one or more visible areas to draw in, one or more JMFrame objects
;  * may be requested while the viewer is being created, or at a later time, thus the client
;  * must provide callbacks to satisfy these requests.
;  *
;  * The window name for the ShowDocument callback is one of:
;  *   _self      show in current frame
;  *   _parent    show in parent frame
;  *   _top       show in top-most frame
;  *   _blank     show in new unnamed top-level window
;  *   <other>    show in new top-level window named <other> 
;  
; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	JMShowDocumentProcPtr = PROCEDURE(viewer: JMAppletViewerRef; urlString: JMTextRef; windowName: JMTextRef); C;

|#
 |#                                             ; $ELSEC
(def-mactype :jmshowdocumentprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	JMSetStatusMsgProcPtr = PROCEDURE(viewer: JMAppletViewerRef; statusMsg: JMTextRef); C;

|#
 |#                                             ; $ELSEC
(def-mactype :jmsetstatusmsgprocptr (find-mactype ':pointer))
; $ENDC

(def-mactype :jmappletviewercallbacksptr (find-mactype '(:pointer :jmappletviewercallbacks)))
(defrecord JMAppletViewerCallbacks 
   (fVersion :unsigned-long)                    ;   should be set to kJMVersion  
   (fShowDocument :pointer)                     ;   go to a url, optionally in a new window  
   (fSetStatusMsg :pointer)                     ;   applet changed status message  
   )

; 	
; 	 * NEW: per-applet security settings
; 	 * Previously, these settings were attached to the session.
; 	 * JManager 2.0 allows them to be attached to each viewer.
; 	 	
(def-mactype :jmnetworksecurityoptions (find-mactype ':signed-long))

(defconstant $eNoNetworkAccess 0)
(defconstant $eAppletHostAccess 1)
(defconstant $eUnrestrictedAccess 2)

(def-mactype :jmfilesystemoptions (find-mactype ':signed-long))

(defconstant $eNoFSAccess 0)
(defconstant $eLocalAppletAccess 1)
(defconstant $eAllFSAccess 2)

; 	
; 	 * Lists of packages are comma separated,
; 	 * the default for mrj.security.system.access is
; 	 * "sun,netscape,com.apple".
; 	 	

(def-mactype :jmappletsecurityptr (find-mactype '(:pointer :jmappletsecurity)))
(defrecord JMAppletSecurity 
   (fVersion :unsigned-long)                    ;   should be set to kJMVersion  
   (fNetworkSecurity :signed-long)              ;   can this applet access network resources  
   (fFileSystemSecurity :signed-long)           ;   can this applet access network resources  
   (fRestrictSystemAccess :boolean)             ;   restrict access to system packages (com.apple.*, sun.*, netscape.*) also found in the property "mrj.security.system.access"  
   (fRestrictSystemDefine :boolean)             ;   restrict classes from loading system packages (com.apple.*, sun.*, netscape.*) also found in the property "mrj.security.system.define"  
   (fRestrictApplicationAccess :boolean)        ;   restrict access to application packages found in the property "mrj.security.application.access"  
   (fRestrictApplicationDefine :boolean)        ;   restrict access to application packages found in the property "mrj.security.application.access"  
   )

; 	
; 	 * AppletViewer methods
; 	 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  JMNewAppletViewer()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in JManager 2.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST                                         ; CONST
(deftrap-inline "_JMNewAppletViewer" 
      ((viewer (:pointer :pointer)) (context :pointer) (locatorRef :pointer) (appletIndex :unsigned-long) (security (:pointer :jmappletsecurity)) (callbacks (:pointer :jmappletviewercallbacks)) (data :pointer)) 
  :osstatus
   () )

; 
;  *  JMDisposeAppletViewer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMDisposeAppletViewer" 
      ((viewer :pointer)) 
  :osstatus
   () )

; 
;  *  JMGetAppletViewerData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMGetAppletViewerData" 
      ((viewer :pointer) (data (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  JMSetAppletViewerData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMSetAppletViewerData" 
      ((viewer :pointer) (data :pointer)) 
  :osstatus
   () )

; 
;  * You can change the applet security on the fly
;  
; 
;  *  JMGetAppletViewerSecurity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMGetAppletViewerSecurity" 
      ((viewer :pointer) (data (:pointer :jmappletsecurity))) 
  :osstatus
   () )

; 
;  *  JMSetAppletViewerSecurity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_JMSetAppletViewerSecurity" 
      ((viewer :pointer) (data (:pointer :jmappletsecurity))) 
  :osstatus
   () )

; 
;  * JMReloadApplet reloads viewer's applet from the source.
;  * JMRestartApplet reinstantiates the applet without reloading.
;  
; 
;  *  JMReloadApplet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMReloadApplet" 
      ((viewer :pointer)) 
  :osstatus
   () )

; 
;  *  JMRestartApplet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMRestartApplet" 
      ((viewer :pointer)) 
  :osstatus
   () )

; 
;  * JMSuspendApplet tells the Java thread scheduler to stop executing the viewer's applet.
;  * JMResumeApplet resumes execution of the viewer's applet.
;  
; 
;  *  JMSuspendApplet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMSuspendApplet" 
      ((viewer :pointer)) 
  :osstatus
   () )

; 
;  *  JMResumeApplet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMResumeApplet" 
      ((viewer :pointer)) 
  :osstatus
   () )

;  
;  * To get back to the JMAppletViewerRef instance from whence a frame came,
;  * as well as the ultimate frame parent (the one created _for_ the applet viewer)
;  
; 
;  *  JMGetFrameViewer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMGetFrameViewer" 
      ((frame :pointer) (viewer (:pointer :pointer)) (parentFrame (:pointer :pointer))) 
  :osstatus
   () )

; 
;  * To get a ref back to the Frame that was created for this JMAppletViewerRef
;  
; 
;  *  JMGetViewerFrame()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMGetViewerFrame" 
      ((viewer :pointer) (frame (:pointer :pointer))) 
  :osstatus
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  * Tell MRJ to add connID to its list of shared libraries used when searching for
;  * JNI (and JRI) native methods. This is useful for overriding or redirecting
;  * a java call to System.loadLibrary().  In particular System.loadLibrary()
;  * does not reuse CFM connections to libraries already open by someone outside
;  * of the java session.  It always forces its own private copy of a shared library 
;  * to be opened.  This can result in multiple instances of the data/TOC section
;  * of a shared library.  
;  * Note: This function has no effect on JDirect based native methods.
;  * If connID exports a function named "JNI_OnLoad", it is immediately called.
;  * If javaShouldClose is true, MRJ will close the connection when the session is closed.
;  * Returns false and does nothing if a library with that name is already registered.
;  
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  JMRegisterLibrary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in JManager 2.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_JMRegisterLibrary" 
      ((session :pointer) (libraryName (:string 63)) (connID :unsigned-long) (javaShouldClose :boolean)) 
  :boolean
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := JManagerIncludes

; $ENDC                                         ; __JMANAGER__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'JManager)