(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Keyboards.p"
; at Wednesday May 1,2002 2:41:03 pm.
; 
;      File:       Keyboards.p
;  
;      Contains:   Keyboard API.
;  
;      Version:    Technology: Keyboard 1.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1997-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __KEYBOARDS__
; $SETC __KEYBOARDS__ := 1

; $I+
; $SETC KeyboardsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;  Keyboard API constants                                                           
; 
;  Keyboard API Trap Number. Should be moved to Traps.i 

(defconstant _KeyboardDispatch #xAA7A)

; 	 Gestalt selector and values for the Keyboard API 	
(defconstant $gestaltKeyboardsAttr :|kbds|)
(defconstant $gestaltKBPS2Keyboards 1)
(defconstant $gestaltKBPS2SetIDToAny 2)
(defconstant $gestaltKBPS2SetTranslationTable 4)

; 	 Keyboard API Error Codes 	
; 
; 	   I stole the range blow from the empty space in the Allocation project but should
; 	   be updated to the officially registered range.
; 	
(defconstant $errKBPS2KeyboardNotAvailable -30850)
(defconstant $errKBIlligalParameters -30851)
(defconstant $errKBFailSettingID -30852)
(defconstant $errKBFailSettingTranslationTable -30853)
(defconstant $errKBFailWritePreference -30854)

; 	 Keyboard HW Layout Types 	
(defconstant $kKeyboardJIS :|JIS |)
(defconstant $kKeyboardANSI :|ANSI|)
(defconstant $kKeyboardISO :|ISO |)
(defconstant $kKeyboardUnknown #x3F3F3F3F)      ;   '????' 

; 		
; 	 Keyboard API types                                                               	
; 		

; 		
; 	 Keyboard API routines                                                            	
; 		

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  KBInitialize()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in KeyboardsLib 1.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_KBInitialize" 
      ()
   (:stack :signed-integer)
   (:stack-trap #xAA7A :d0 0))

; 
;  *  KBSetupPS2Keyboard()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeyboardsLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_KBSetupPS2Keyboard" 
      ((keyboardType :signed-integer) (alternativeTable (:pointer :signed-byte)))
   (:stack :signed-integer)
   (:stack-trap #xAA7A :d0 1 keyboardType alternativeTable))

; 
;  *  KBGetPS2KeyboardID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeyboardsLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_KBGetPS2KeyboardID" 
      ((keyboardType (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xAA7A :d0 2 keyboardType))

; 
;  *  KBIsPS2KeyboardConnected()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeyboardsLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_KBIsPS2KeyboardConnected" 
      ()
   (:stack :boolean)
   (:stack-trap #xAA7A :d0 3))

; 
;  *  KBIsPS2KeyboardEnabled()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeyboardsLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_KBIsPS2KeyboardEnabled" 
      ()
   (:stack :boolean)
   (:stack-trap #xAA7A :d0 4))

; 
;  *  KBGetPS2KeyboardAttributes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeyboardsLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_KBGetPS2KeyboardAttributes" 
      ()
   (:stack :signed-long)
   (:stack-trap #xAA7A :d0 5))

; 
;  *  KBSetKCAPForPS2Keyboard()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeyboardsLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_KBSetKCAPForPS2Keyboard" 
      ((kcapHandle :handle))
   (:stack :signed-integer)
   (:stack-trap #xAA7A :d0 6 kcapHandle))

; 
;  *  KBSetupPS2KeyboardFromLayoutType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeyboardsLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_KBSetupPS2KeyboardFromLayoutType" 
      ((layoutType :ostype))
   (:stack :signed-integer)
   (:stack-trap #xAA7A :d0 8 layoutType))

; 
;  *  KBGetPS2KeyboardLayoutType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeyboardsLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_KBGetPS2KeyboardLayoutType" 
      ((layoutType (:pointer :ostype)))
   (:stack :signed-integer)
   (:stack-trap #xAA7A :d0 9 layoutType))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  KBGetLayoutType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in KeyboardsLib 1.0 and later
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_KBGetLayoutType" 
      ((keyboardType :signed-integer))
   (:stack :ostype)
   (:stack-trap #xAA7A :d0 7 keyboardType))

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := KeyboardsIncludes

; $ENDC                                         ; __KEYBOARDS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Keyboards)