(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:LocationManager.p"
; at Wednesday May 1,2002 2:42:06 pm.
; 
;      File:       LocationManager.p
;  
;      Contains:   LocationManager (manages groups of settings)
;  
;      Version:    Technology: Mac OS 8
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __LOCATIONMANAGER__
; $SETC __LOCATIONMANAGER__ := 1

; $I+
; $SETC LocationManagerIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __APPLEEVENTS__
|#

(require-interface 'AppleEvents)
#|                                              ; $I AppleEvents.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __COMPONENTS__
|#

(require-interface 'Components)
#|                                              ; $I Components.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __DIALOGS__
|#

(require-interface 'Dialogs)
#|                                              ; $I Dialogs.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __PROCESSES__
|#

(require-interface 'Processes)
#|                                              ; $I Processes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __STANDARDFILE__
|#

(require-interface 'StandardFile)
#|                                              ; $I StandardFile.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;   Location Manager API Support --------------------------------------------------------------------  
;   A Location Token uniquely identifies a Location on a machine...  

(def-mactype :almtoken (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :almtokenptr (find-mactype '(:pointer :pointer)));  when a VAR xx:ALMToken parameter can be nil, it is changed to xx: ALMTokenPtr 
;   ALMToken of "off" Location... 

(defconstant $kALMNoLocationToken -1)
(defconstant $kALMLocationNameMaxLen 31)        ;   name (actually imposed by file system)...  
(defconstant $kALMNoLocationIndex -1)           ;   index for the "off" Location (kALMNoLocationToken)...  

(defrecord :ALMLocationName 
  (length :unsigned-byte)
 (contents (:array :unsigned-byte 31)))
;   Returned from ALMConfirmName...  
(def-mactype :almconfirmchoice (find-mactype ':signed-integer))

(defconstant $kALMConfirmRename 1)
(defconstant $kALMConfirmReplace 2)

;   ALMConfirmName dialog item numbers for use in callbacks (ALM 2.0)...  

(defconstant $kALMDuplicateRenameButton 1)      ;   if Window refcon is kALMDuplicateDialogRefCon...  
(defconstant $kALMDuplicateReplaceButton 2)
(defconstant $kALMDuplicateCancelButton 3)
(defconstant $kALMDuplicatePromptText 5)

(defconstant $kALMRenameRenameButton 1)         ;   if Window refcon is kALMRenameDialogRefCon...  
(defconstant $kALMRenameCancelButton 2)
(defconstant $kALMRenameEditText 3)
(defconstant $kALMRenamePromptText 4)

;   Refcons of two windows in ALMConfirmName (ALM 2.0)...  

(defconstant $kALMDuplicateDialogRefCon :|dupl|)
(defconstant $kALMRenameDialogRefCon :|rnam|)

;   Callback routine for Location awareness (mimics AppleEvents) in non-application code...  

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ALMNotificationProcPtr = PROCEDURE(VAR theEvent: AppleEvent);

|#
 |#                                             ; $ELSEC
(def-mactype :almnotificationprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :almnotificationupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :almnotificationupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppALMNotificationProcInfo #xC0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewALMNotificationUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewALMNotificationProc 
(deftrap "_NewALMNotificationUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeALMNotificationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeALMNotificationUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeALMNotificationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallALMNotificationProc 
(deftrap-inline "_InvokeALMNotificationUPP" 
      ((theEvent (:pointer :aedesc)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

;   Notification AppleEvents sent to apps/registered code...   

(defconstant $kAELocationChangedNoticeKey :|walk|);   Current Location changed...  
(defconstant $kAELocationRescanNoticeKey :|trip|);   Location created/renamed/deleted...  

;   ALMSwitchToLocation masks...  

(def-mactype :almswitchactionflags (find-mactype ':signed-long))

(defconstant $kALMDefaultSwitchFlags #x0)       ;   No special action to take...  
(defconstant $kALMDontShowStatusWindow #x1)     ;   Suppress "switching" window...  
(defconstant $kALMSignalViaAE #x2)              ;   Switch by sending Finder AppleEvent...  

;   Parameters for Get/Put/Merge Location calls...  

(def-mactype :constalmmoduletypelistptr (find-mactype '(:pointer :ostype)))

(defconstant $kALMAddAllOnSimple 0)             ;   Add all single-instance, non-action modules...  
(defconstant $kALMAddAllOff -1)                 ;   Add all modules but turn them off...  

;   Item numbers for use in Get/Put/Merge Location filters...  

(defconstant $kALMLocationSelectButton 1)
(defconstant $kALMLocationCancelButton 2)
(defconstant $kALMLocationBalloonHelp 3)
(defconstant $kALMLocationLocationList 7)
(defconstant $kALMLocationLocationNameEdit 10)
(defconstant $kALMLocationPromptText 11)

(defconstant $kALMLocationSaveButton 1)

;   Location Manager Module API Support -------------------------------------------------------------  

;   ALMGetScriptInfo stuff...  

(defconstant $kALMScriptInfoVersion 2)          ;   Customarily put in resource for localization...  

(def-mactype :almscriptmanagerinfoptr (find-mactype '(:pointer :almscriptmanagerinfo)))
(defrecord ALMScriptManagerInfo 
   (version :signed-integer)                    ;   Set to kALMScriptInfoVersion...  
   (scriptCode :signed-integer)
   (regionCode :signed-integer)
   (langCode :signed-integer)
   (fontNum :signed-integer)
   (fontSize :signed-integer)
   )

; 
; 	   Alternate form of ScriptInfo is easier to localize in resources; it is used extensively in
; 	   samples and internally, so....
; 	
(def-mactype :almaltscriptmanagerinfoptr (find-mactype '(:pointer :almaltscriptmanagerinfo)))
(defrecord ALMAltScriptManagerInfo 
   (version :signed-integer)
   (scriptCode :signed-integer)
   (regionCode :signed-integer)
   (langCode :signed-integer)
   (fontSize :signed-integer)
   (fontName (:string 63))
   )

(def-mactype :almaltscriptmanagerinfohandle (find-mactype '(:handle :almaltscriptmanagerinfo)))

(defconstant $kALMAltScriptManagerInfoRsrcType :|trip|)
(defconstant $kALMAltScriptManagerInfoRsrcID 0)

;   Reboot information used on ALMSetCurrent (input/output parameter)...  

(def-mactype :almrebootflags (find-mactype ':unsigned-long))

(defconstant $kALMNoChange 0)
(defconstant $kALMAvailableNow 1)
(defconstant $kALMFinderRestart 2)
(defconstant $kALMProcesses 3)
(defconstant $kALMExtensions 4)
(defconstant $kALMWarmBoot 5)
(defconstant $kALMColdBoot 6)
(defconstant $kALMShutdown 7)

; 
; 	   File types and signatures...
; 	   Note: auto-routing of modules will not be supported for 'thng' files...
; 	

(defconstant $kALMFileCreator :|fall|)          ;   Creator of Location Manager files...  
(defconstant $kALMComponentModuleFileType :|thng|);   Type of a Component Manager Module file [v1.0]...  
(defconstant $kALMComponentStateModuleFileType :|almn|);   Type of a CM 'state' Module file...  
(defconstant $kALMComponentActionModuleFileType :|almb|);   Type of a CM 'action' Module file...  
(defconstant $kALMCFMStateModuleFileType :|almm|);   Type of a CFM 'state' Module file...  
(defconstant $kALMCFMActionModuleFileType :|alma|);   Type of a CFM 'action' Module file...  

;   Component Manager 'thng' info...  

(defconstant $kALMComponentRsrcType :|thng|)
(defconstant $kALMComponentType :|walk|)

;   CFM Modules require a bit of information (replacing some of the 'thng' resource)...  

(defconstant $kALMModuleInfoRsrcType :|walk|)
(defconstant $kALMModuleInfoOriginalVersion 0)

;   These masks apply to the "Flags" field in the 'thng' or 'walk' resource...  

(defconstant $kALMMultiplePerLocation #x1)      ;   Module can be added more than once to a Location...  
(defconstant $kALMDescriptionGetsStale #x2)     ;   Descriptions may change though the setting didn't...   

;   Misc stuff for older implementations ------------------------------------------------------------  

; $IFC OLDROUTINENAMES 
;   Old error codes for compatibility - new names are in Errors interface...  
(defconstant $ALMInternalErr -30049)            ;   use kALMInternalErr  
(defconstant $ALMLocationNotFound -30048)       ;   use kALMLocationNotFoundErr  
(defconstant $ALMNoSuchModuleErr -30047)        ;   use kALMNoSuchModuleErr  
(defconstant $ALMModuleCommunicationErr -30046) ;   use kALMModuleCommunicationErr  
(defconstant $ALMDuplicateModuleErr -30045)     ;   use kALMDuplicateModuleErr  
(defconstant $ALMInstallationErr -30044)        ;   use kALMInstallationErr  
(defconstant $ALMDeferSwitchErr -30043)         ;   use kALMDeferSwitchErr  

;   Old ALMConfirmName constants...  

(defconstant $ALMConfirmRenameConfig 1)
(defconstant $ALMConfirmReplaceConfig 2)

;   Old AppleEvents...  

(defconstant $kAELocationNotice :|walk|)

(%define-record :almscriptmgrinfo (find-record-descriptor :almscriptmanagerinfo))
(def-mactype :almscriptmgrinfoptr (find-mactype '(:pointer :almscriptmanagerinfo)))
(def-mactype :almcomponentflagsenum (find-mactype ':unsigned-long))
; $ENDC                                         ; OLDROUTINENAMES

;   Location Manager API ----------------------------------------------------------------------------  

;   The following 7 routines are present if gestaltALMAttr has bit gestaltALMPresent set...  

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  ALMGetCurrentLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in Walkabout 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ALMGetCurrentLocation" 
      ((index (:pointer :signed-integer)) (token (:pointer :pointer)) (name (:pointer (:string 31))))
   (:stack :signed-integer)
   (:stack-trap #xAAA4 :d0 1536 index token name))

; 
;  *  ALMGetIndLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in Walkabout 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ALMGetIndLocation" 
      ((index :signed-integer) (token (:pointer :pointer)) (name (:pointer (:string 31))))
   (:stack :signed-integer)
   (:stack-trap #xAAA4 :d0 1281 index token name))

; 
;  *  ALMCountLocations()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in Walkabout 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ALMCountLocations" 
      ((locationCount (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xAAA4 :d0 514 locationCount))

; 
;  *  ALMSwitchToLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in Walkabout 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ALMSwitchToLocation" 
      ((newLocation :pointer) (switchFlags :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAAA4 :d0 1027 newLocation switchFlags))

; 
;  *  ALMRegisterNotifyProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in Walkabout 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_ALMRegisterNotifyProc" 
      ((notificationProc :pointer) (whichPSN (:pointer :processserialnumber)))
   (:stack :signed-integer)
   (:stack-trap #xAAA4 :d0 1028 notificationProc whichPSN))

; 
;  *  ALMRemoveNotifyProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in Walkabout 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_ALMRemoveNotifyProc" 
      ((notificationProc :pointer) (whichPSN (:pointer :processserialnumber)))
   (:stack :signed-integer)
   (:stack-trap #xAAA4 :d0 1029 notificationProc whichPSN))

; 
;  *  ALMConfirmName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in Walkabout 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ALMConfirmName" 
      ((message (:string 255)) (theName (:pointer (:string 255))) (choice (:pointer :signed-integer)) (filter :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAAA4 :d0 2054 message theName choice filter))

;   The following 3 routines are present if gestaltALMAttr has bit gestaltALMHasSFLocation set...  

; 
;  *  ALMPutLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in Walkabout 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ALMPutLocation" 
      ((prompt (:string 255)) (name (:pointer (:string 31))) (numTypes :signed-integer) (typeList (:pointer :ostype)) (filter :pointer) (yourDataPtr :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAAA4 :d0 2823 prompt name numTypes typeList filter yourDataPtr))

; 
;  *  ALMGetLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in Walkabout 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ALMGetLocation" 
      ((prompt (:string 255)) (name (:pointer (:string 31))) (filter :pointer) (yourDataPtr :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAAA4 :d0 2056 prompt name filter yourDataPtr))

; 
;  *  ALMMergeLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in Walkabout 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ALMMergeLocation" 
      ((prompt (:string 255)) (name (:pointer (:string 31))) (numTypes :signed-integer) (typeList (:pointer :ostype)) (filter :pointer) (yourDataPtr :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAAA4 :d0 2825 prompt name numTypes typeList filter yourDataPtr))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := LocationManagerIncludes

; $ENDC                                         ; __LOCATIONMANAGER__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'LocationManager)