(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:MacWindows.p"
; at Wednesday May 1,2002 2:39:36 pm.
; 
;      File:       MacWindows.p
;  
;      Contains:   Window Manager Interfaces
;  
;      Version:    Technology: Mac OS 9
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1997-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __MACWINDOWS__
; $SETC __MACWINDOWS__ := 1

; $I+
; $SETC MacWindowsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __ALIASES__
|#

(require-interface 'Aliases)
#|                                              ; $I Aliases.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __APPLEEVENTS__
|#

(require-interface 'AppleEvents)
#|                                              ; $I AppleEvents.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __COLLECTIONS__

(require-interface 'Collections)                ; $I Collections.p
; $ENDC
; $IFC UNDEFINED __DRAG__

(require-interface 'Drag)                       ; $I Drag.p
; $ENDC
#|                                              ; $IFC UNDEFINED __EVENTS__
|#

(require-interface 'Events)
#|                                              ; $I Events.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __MENUS__

(require-interface 'Menus)                      ; $I Menus.p
; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QDOFFSCREEN__
|#

(require-interface 'QDOffscreen)
#|                                              ; $I QDOffscreen.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __TEXTCOMMON__
|#

(require-interface 'TextCommon)
#|                                              ; $I TextCommon.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __ICONS__

(require-interface 'Icons)                      ; $I Icons.p
; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFSTRING__
|#

(require-interface 'CFString)
#|                                              ; $I CFString.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;                                                                                                       
;  Current documentation for the Mac OS Window Manager is available on the web:                         
;   <http://developer.apple.com/techpubs/macos8/HumanInterfaceToolbox/WindowManager/windowmanager.html> 
;                                                                                                       
; 
;   Property Types                                                                     
; 

(def-mactype :propertycreator (find-mactype ':ostype))
(def-mactype :propertytag (find-mactype ':ostype))
; 		
; 	  Window Classes                                                                     	
; 		
(def-mactype :windowclass (find-mactype ':unsigned-long))

(defconstant $kAlertWindowClass 1)              ;   I need your attention now. 
(defconstant $kMovableAlertWindowClass 2)       ;   I need your attention now, but Im kind enough to let you switch out of this app to do other things. 
(defconstant $kModalWindowClass 3)              ;   system modal, not draggable 
(defconstant $kMovableModalWindowClass 4)       ;   application modal, draggable 
(defconstant $kFloatingWindowClass 5)           ;   floats above all other application windows 
(defconstant $kDocumentWindowClass 6)           ;   document windows 
(defconstant $kUtilityWindowClass 8)            ;   system-wide floating windows (TSM, AppleGuide) (available in CarbonLib 1.1) 
(defconstant $kHelpWindowClass 10)              ;   help window (no frame; coachmarks, help tags ) (available in CarbonLib 1.1) 
(defconstant $kSheetWindowClass 11)             ;   sheet windows for dialogs (available in Mac OS X and CarbonLib 1.3) 
(defconstant $kToolbarWindowClass 12)           ;   toolbar windows (above documents, below floating windows) (available in CarbonLib 1.1) 
(defconstant $kPlainWindowClass 13)             ;   plain window (in document layer) 
(defconstant $kOverlayWindowClass 14)           ;   transparent window which allows 'screen' drawing via CoreGraphics (Mac OS X only) 
(defconstant $kSheetAlertWindowClass 15)        ;   sheet windows for alerts (available in Mac OS X after 10.0.x and CarbonLib 1.3) 
(defconstant $kAltPlainWindowClass 16)          ;   alternate plain window (in document layer) (available in Mac OS X after 10.0.x and CarbonLib 1.3) 
(defconstant $kAllWindowClasses #xFFFFFFFF)     ;   for use with GetFrontWindowOfClass, FindWindowOfClass, GetNextWindowOfClass 

; 		
; 	  Window Attributes                                                                  	
; 		

(def-mactype :windowattributes (find-mactype ':unsigned-long))

; 
; 	 *  Summary:
; 	 *    Window attributes
; 	 	

(defconstant $kWindowNoAttributes 0)
(defconstant $kWindowCloseBoxAttribute #x1)
(defconstant $kWindowHorizontalZoomAttribute #x2)
(defconstant $kWindowVerticalZoomAttribute #x4)
(defconstant $kWindowFullZoomAttribute #x6)
(defconstant $kWindowCollapseBoxAttribute #x8)
(defconstant $kWindowResizableAttribute #x10)
(defconstant $kWindowSideTitlebarAttribute #x20)
(defconstant $kWindowToolbarButtonAttribute #x40)
(defconstant $kWindowMetalAttribute #x100)
(defconstant $kWindowNoUpdatesAttribute #x10000)
(defconstant $kWindowNoActivatesAttribute #x20000)
(defconstant $kWindowOpaqueForEventsAttribute #x40000)
(defconstant $kWindowNoShadowAttribute #x200000)
(defconstant $kWindowHideOnSuspendAttribute #x1000000)
(defconstant $kWindowStandardHandlerAttribute #x2000000)
(defconstant $kWindowHideOnFullScreenAttribute #x4000000)
(defconstant $kWindowInWindowMenuAttribute #x8000000)
(defconstant $kWindowLiveResizeAttribute #x10000000)
(defconstant $kWindowNoConstrainAttribute #x80000000)
(defconstant $kWindowStandardDocumentAttributes #x1F)
(defconstant $kWindowStandardFloatingAttributes #x9)

; 		
; 	  Window Definition Type                                                             	
; 		
(defconstant $kWindowDefProcType :|WDEF|)

; 		
; 	  Mac OS 7.5 Window Definition Resource IDs                                          	
; 		
(defconstant $kStandardWindowDefinition 0)      ;   for document windows and dialogs 
(defconstant $kRoundWindowDefinition 1)         ;   old da-style window 
(defconstant $kFloatingWindowDefinition 124)    ;   for floating windows 

; 		
; 	  Variant Codes                                                                      	
; 		
;   for use with kStandardWindowDefinition  
(defconstant $kDocumentWindowVariantCode 0)
(defconstant $kModalDialogVariantCode 1)
(defconstant $kPlainDialogVariantCode 2)
(defconstant $kShadowDialogVariantCode 3)
(defconstant $kMovableModalDialogVariantCode 5)
(defconstant $kAlertVariantCode 7)
(defconstant $kMovableAlertVariantCode 9)       ;   for use with kFloatingWindowDefinition  
(defconstant $kSideFloaterVariantCode 8)

; 		
; 	  DefProc IDs                                                                        	
; 		
;   classic ids  
(defconstant $documentProc 0)
(defconstant $dBoxProc 1)
(defconstant $plainDBox 2)
(defconstant $altDBoxProc 3)
(defconstant $noGrowDocProc 4)
(defconstant $movableDBoxProc 5)
(defconstant $zoomDocProc 8)
(defconstant $zoomNoGrow 12)                    ;   floating window defproc ids  
(defconstant $floatProc 1985)
(defconstant $floatGrowProc 1987)
(defconstant $floatZoomProc 1989)
(defconstant $floatZoomGrowProc 1991)
(defconstant $floatSideProc 1993)
(defconstant $floatSideGrowProc 1995)
(defconstant $floatSideZoomProc 1997)
(defconstant $floatSideZoomGrowProc 1999)

; $IFC CALL_NOT_IN_CARBON 
;   The rDocProc (rounded WDEF, ala calculator) is not supported in Carbon. 
(defconstant $rDocProc 16)

; $ENDC                                         ; CALL_NOT_IN_CARBON

;   Resource IDs for theme-savvy window defprocs  
(defconstant $kWindowDocumentDefProcResID 64)
(defconstant $kWindowDialogDefProcResID 65)
(defconstant $kWindowUtilityDefProcResID 66)
(defconstant $kWindowUtilitySideTitleDefProcResID 67)
(defconstant $kWindowSheetDefProcResID 68)
(defconstant $kWindowSimpleDefProcResID 69)
(defconstant $kWindowSheetAlertDefProcResID 70)

;   Proc IDs for theme-savvy windows  
(defconstant $kWindowDocumentProc 1024)
(defconstant $kWindowGrowDocumentProc 1025)
(defconstant $kWindowVertZoomDocumentProc 1026)
(defconstant $kWindowVertZoomGrowDocumentProc 1027)
(defconstant $kWindowHorizZoomDocumentProc 1028)
(defconstant $kWindowHorizZoomGrowDocumentProc 1029)
(defconstant $kWindowFullZoomDocumentProc 1030)
(defconstant $kWindowFullZoomGrowDocumentProc 1031)

;   Proc IDs for theme-savvy dialogs  
(defconstant $kWindowPlainDialogProc 1040)
(defconstant $kWindowShadowDialogProc 1041)
(defconstant $kWindowModalDialogProc 1042)
(defconstant $kWindowMovableModalDialogProc 1043)
(defconstant $kWindowAlertProc 1044)
(defconstant $kWindowMovableAlertProc 1045)

;   procIDs available from Mac OS 8.1 (Appearance 1.0.1) forward  
(defconstant $kWindowMovableModalGrowProc 1046)

;   Proc IDs for top title bar theme-savvy floating windows  
(defconstant $kWindowFloatProc 1057)
(defconstant $kWindowFloatGrowProc 1059)
(defconstant $kWindowFloatVertZoomProc 1061)
(defconstant $kWindowFloatVertZoomGrowProc 1063)
(defconstant $kWindowFloatHorizZoomProc 1065)
(defconstant $kWindowFloatHorizZoomGrowProc 1067)
(defconstant $kWindowFloatFullZoomProc 1069)
(defconstant $kWindowFloatFullZoomGrowProc 1071)

;   Proc IDs for side title bar theme-savvy floating windows  
(defconstant $kWindowFloatSideProc 1073)
(defconstant $kWindowFloatSideGrowProc 1075)
(defconstant $kWindowFloatSideVertZoomProc 1077)
(defconstant $kWindowFloatSideVertZoomGrowProc 1079)
(defconstant $kWindowFloatSideHorizZoomProc 1081)
(defconstant $kWindowFloatSideHorizZoomGrowProc 1083)
(defconstant $kWindowFloatSideFullZoomProc 1085)
(defconstant $kWindowFloatSideFullZoomGrowProc 1087)

;   Proc IDs for sheet windows  
(defconstant $kWindowSheetProc 1088)            ;   available in Mac OS X and CarbonLib 1.3  
(defconstant $kWindowSheetAlertProc 1120)       ;   available in Mac OS X after 1.0, and CarbonLib 1.3  

; 
; 	 *  Discussion:
; 	 *    Window defproc IDs for simple windows
; 	 	
;   Proc IDs for simple windows  
(defconstant $kWindowSimpleProc 1104)
(defconstant $kWindowSimpleFrameProc 1105)

; 		
; 	  System 7 Window Positioning Constants                                              	
; 	                                                                                      	
; 	 Passed into StandardAlert and used in WIND, DLOG, and ALRT templates           	
; 	 StandardAlert uses zero to specify the default position. Other calls use zero to     	
; 	 specify no position.  Do not pass these constants to RepositionWindow.  Do not     	
; 	 store these constants in the BasicWindowDescription of a wind resource.            	
; 		

(defconstant $kWindowNoPosition #x0)
(defconstant $kWindowDefaultPosition #x0)       ;   used by StandardAlert 
(defconstant $kWindowCenterMainScreen #x280A)
(defconstant $kWindowAlertPositionMainScreen #x300A)
(defconstant $kWindowStaggerMainScreen #x380A)
(defconstant $kWindowCenterParentWindow #xA80A)
(defconstant $kWindowAlertPositionParentWindow #xB00A)
(defconstant $kWindowStaggerParentWindow #xB80A)
(defconstant $kWindowCenterParentWindowScreen #x680A)
(defconstant $kWindowAlertPositionParentWindowScreen #x700A)
(defconstant $kWindowStaggerParentWindowScreen #x780A)

; 		
; 	  Window Positioning Methods                                                         	
; 	                                                                                      	
; 	 Positioning methods passed to RepositionWindow.                                      	
; 	 Do not use them in WIND, ALRT, DLOG templates.                                       	
; 	 Do not confuse these constants with the constants above                              	
; 		

(def-mactype :windowpositionmethod (find-mactype ':unsigned-long))

(defconstant $kWindowCenterOnMainScreen #x1)
(defconstant $kWindowCenterOnParentWindow #x2)
(defconstant $kWindowCenterOnParentWindowScreen #x3)
(defconstant $kWindowCascadeOnMainScreen #x4)
(defconstant $kWindowCascadeOnParentWindow #x5)
(defconstant $kWindowCascadeOnParentWindowScreen #x6)
(defconstant $kWindowAlertPositionOnMainScreen #x7)
(defconstant $kWindowAlertPositionOnParentWindow #x8)
(defconstant $kWindowAlertPositionOnParentWindowScreen #x9)

; 		
; 	  GetWindowRegion Types                                                              	
; 		

(def-mactype :windowregioncode (find-mactype ':unsigned-integer))

;   Region values to pass into GetWindowRegion & GetWindowBounds  
(defconstant $kWindowTitleBarRgn 0)
(defconstant $kWindowTitleTextRgn 1)
(defconstant $kWindowCloseBoxRgn 2)
(defconstant $kWindowZoomBoxRgn 3)
(defconstant $kWindowDragRgn 5)
(defconstant $kWindowGrowRgn 6)
(defconstant $kWindowCollapseBoxRgn 7)
(defconstant $kWindowTitleProxyIconRgn 8)       ;   Mac OS 8.5 forward 
(defconstant $kWindowStructureRgn 32)
(defconstant $kWindowContentRgn 33)             ;   Content area of the window; empty when the window is collapsed 
(defconstant $kWindowUpdateRgn 34)              ;   Carbon forward 
(defconstant $kWindowOpaqueRgn 35)              ;   Mac OS X: Area of window considered to be opaque. Only valid for windows with alpha channels. 
(defconstant $kWindowGlobalPortRgn 40)          ;   Carbon forward - bounds of the windows port in global coordinates; not affected by CollapseWindow 

;   GetWindowRegionRec - a pointer to this is passed in WDEF param for kWindowMsgGetRegion 

(def-mactype :getwindowregionrecptr (find-mactype '(:pointer :getwindowregionrec)))
(defrecord GetWindowRegionRec 
   (winRgn (:handle :macregion))
   (regionCode :unsigned-integer)
   )

(def-mactype :getwindowregionptr (find-mactype '(:pointer :getwindowregionrec)))
; 		
; 	  WDEF Message Types                                                                 	
; 		
; 
; 	   SetupWindowProxyDragImageRec - setup the proxy icon drag image
; 	   Both regions are allocated and disposed by the Window Manager.
; 	   The GWorld is disposed of by the Window Manager, but the WDEF must allocate
; 	   it.  See Technote on Drag Manager 1.1 additions for more information and sample code for
; 	   setting up drag images.
; 	

(def-mactype :setupwindowproxydragimagerecptr (find-mactype '(:pointer :setupwindowproxydragimagerec)))
(defrecord SetupWindowProxyDragImageRec 
   (imageGWorld (:pointer :cgrafport))          ;   locked GWorld containing the drag image - output - can be NULL 
   (imageRgn (:handle :macregion))              ;   image clip region, contains the portion of the image which gets blitted to screen - preallocated output - if imageGWorld is NULL, this is ignored 
   (outlineRgn (:handle :macregion))            ;   the outline region used on shallow monitors - preallocated output - must always be non-empty 
   )

;   MeasureWindowTitleRec - a pointer to this is passed in WDEF param for kWindowMsgMeasureTitle 
(def-mactype :measurewindowtitlerecptr (find-mactype '(:pointer :measurewindowtitlerec)))
(defrecord MeasureWindowTitleRec 
;   output parameters (filled in by the WDEF) 
   (fullTitleWidth :signed-integer)             ;   text + proxy icon width 
   (titleTextWidth :signed-integer)             ;   text width 
   )

; 
; 	   GetGrowImageRegionRec - generate a region to be xored during GrowWindow and ResizeWindow.
; 	   This is passed along with a kWindowMsgGetGrowImageRegion message. On input, the growRect
; 	   parameter is the window's new bounds in global coordinates. The growImageRegion parameter
; 	   will be allocated and disposed automatically; the window definition should alter the 
; 	   region appropriately.
; 	
(def-mactype :getgrowimageregionrecptr (find-mactype '(:pointer :getgrowimageregionrec)))
(defrecord GetGrowImageRegionRec 
   (growRect :rect)
   (growImageRegion (:handle :macregion))
   )

; 		
; 	  Standard Window Kinds                                                              	
; 		

(defconstant $dialogKind 2)
(defconstant $userKind 8)
(defconstant $kDialogWindowKind 2)
(defconstant $kApplicationWindowKind 8)

; 		
; 	  FindWindow Result Codes                                                            	
; 		

(def-mactype :windowpartcode (find-mactype ':signed-integer))

(defconstant $inDesk 0)
(defconstant $inNoWindow 0)
(defconstant $inMenuBar 1)
(defconstant $inSysWindow 2)
(defconstant $inContent 3)
(defconstant $inDrag 4)
(defconstant $inGrow 5)
(defconstant $inGoAway 6)
(defconstant $inZoomIn 7)
(defconstant $inZoomOut 8)
(defconstant $inCollapseBox 11)                 ;   Mac OS 8.0 forward 
(defconstant $inProxyIcon 12)                   ;   Mac OS 8.5 forward 
(defconstant $inToolbarButton 13)               ;   Mac OS X forward 
(defconstant $inStructure 15)                   ;   Mac OS X 10.1 forward 

; 		
; 	  Window Definition Hit Test Result Codes                                            	
; 		

(def-mactype :windowdefpartcode (find-mactype ':signed-integer))

(defconstant $wNoHit 0)
(defconstant $wInContent 1)
(defconstant $wInDrag 2)
(defconstant $wInGrow 3)
(defconstant $wInGoAway 4)
(defconstant $wInZoomIn 5)
(defconstant $wInZoomOut 6)
(defconstant $wInCollapseBox 9)                 ;   Mac OS 8.0 forward 
(defconstant $wInProxyIcon 10)                  ;   Mac OS 8.5 forward 
(defconstant $wInToolbarButton 11)              ;   Mac OS X forward 
(defconstant $wInStructure 13)                  ;   Mac OS X 10.1 forward 

; 		
; 	  Window Definition Messages                                                         	
; 		

(defconstant $kWindowMsgDraw 0)
(defconstant $kWindowMsgHitTest 1)
(defconstant $kWindowMsgCalculateShape 2)
(defconstant $kWindowMsgInitialize 3)
(defconstant $kWindowMsgCleanUp 4)
(defconstant $kWindowMsgDrawGrowOutline 5)
(defconstant $kWindowMsgDrawGrowBox 6)

;   Messages available from Mac OS 8.0 forward 
(defconstant $kWindowMsgGetFeatures 7)
(defconstant $kWindowMsgGetRegion 8)

;   Messages available from Mac OS 8.5 forward 
(defconstant $kWindowMsgDragHilite 9)           ;   parameter boolean indicating on or off 
(defconstant $kWindowMsgModified 10)            ;   parameter boolean indicating saved (false) or modified (true) 
(defconstant $kWindowMsgDrawInCurrentPort 11)   ;   same as kWindowMsgDraw, but must draw in current port 
(defconstant $kWindowMsgSetupProxyDragImage 12) ;   parameter pointer to SetupWindowProxyDragImageRec 
(defconstant $kWindowMsgStateChanged 13)        ;   something about the window's state has changed 
(defconstant $kWindowMsgMeasureTitle 14)        ;   measure and return the ideal title width 

;   Messages only available in Carbon 
(defconstant $kWindowMsgGetGrowImageRegion 19)  ;   get region to xor during grow/resize. parameter pointer to GetGrowImageRegionRec. 

;   old names 
(defconstant $wDraw 0)
(defconstant $wHit 1)
(defconstant $wCalcRgns 2)
(defconstant $wNew 3)
(defconstant $wDispose 4)
(defconstant $wGrow 5)
(defconstant $wDrawGIcon 6)

; 		
; 	  State-changed Flags for kWindowMsgStateChanged                                     	
; 		
(defconstant $kWindowStateTitleChanged #x1)

; 		
; 	  Window Feature Bits                                                                	
; 		
(defconstant $kWindowCanGrow #x1)
(defconstant $kWindowCanZoom #x2)
(defconstant $kWindowCanCollapse #x4)
(defconstant $kWindowIsModal #x8)
(defconstant $kWindowCanGetWindowRegion #x10)
(defconstant $kWindowIsAlert #x20)
(defconstant $kWindowHasTitleBar #x40)

;   Feature bits available from Mac OS 8.5 forward 
(defconstant $kWindowSupportsDragHilite #x80)   ;   window definition supports kWindowMsgDragHilite 
(defconstant $kWindowSupportsModifiedBit #x100) ;   window definition supports kWindowMsgModified 
(defconstant $kWindowCanDrawInCurrentPort #x200);   window definition supports kWindowMsgDrawInCurrentPort 
(defconstant $kWindowCanSetupProxyDragImage #x400);   window definition supports kWindowMsgSetupProxyDragImage 
(defconstant $kWindowCanMeasureTitle #x800)     ;   window definition supports kWindowMsgMeasureTitle 
(defconstant $kWindowWantsDisposeAtProcessDeath #x1000);   window definition wants a Dispose message for windows still extant during ExitToShell 
(defconstant $kWindowSupportsGetGrowImageRegion #x2000);   window definition will calculate the grow image region manually. 
(defconstant $kWindowDefSupportsColorGrafPort #x40000002)

;   Feature bits for post MacOS 10.0 
(defconstant $kWindowIsOpaque #x4000)           ;   Window doesn't need an alpha channel. Saves memory. 

; 
; 	   THIS CONSTANT IS GOING AWAY. IT IS NAMED INCORRECTLY. USE THE GETGROWIMAGE CONSTANT ABOVE INSTEAD.
; 	   DO YOU HEAR ME! AM I YELLING LOUD ENOUGH?!
; 	
(defconstant $kWindowSupportsSetGrowImageRegion #x2000)

; 		
; 	  Desktop Pattern Resource ID                                                        	
; 		
(defconstant $deskPatID 16)

; 		
; 	  Window Color Part Codes                                                            	
; 		
(defconstant $wContentColor 0)
(defconstant $wFrameColor 1)
(defconstant $wTextColor 2)
(defconstant $wHiliteColor 3)
(defconstant $wTitleBarColor 4)

; 		
; 	   Region Dragging Constants                                                         	
; 		

(defconstant $kMouseUpOutOfSlop #x80008000)

; 		
; 	  Window Color Table                                                                 	
; 		

(def-mactype :winctabptr (find-mactype '(:pointer :winctab)))
(defrecord (WinCTab :handle) 
   (wCSeed :signed-long)                        ;   reserved  
   (wCReserved :signed-integer)                 ;   reserved  
   (ctSize :signed-integer)                     ;   usually 4 for windows  
   (ctTable (:array :colorspec 5))
   )

(def-mactype :wctabptr (find-mactype '(:pointer :winctab)))
(def-mactype :wctabhandle (find-mactype '(:handle :winctab)))
; 		
; 	  WindowRecord                                                                       	
; 		
; $IFC NOT OPAQUE_TOOLBOX_STRUCTS 
(def-mactype :windowrecordptr (find-mactype '(:pointer :windowrecord)))
(def-mactype :windowpeek (find-mactype '(:pointer :windowrecord)))

;; This form has been patched from OSX Drive:Users:bburns:Desktop:interface-translator:Patches:macwindows.patch
#|(defrecord WindowRecord 
   (port :grafport)                             ;   in Carbon use GetWindowPort 
   (windowKind :signed-integer)                 ;   in Carbon use Get/SetWindowKind 
   (visible :boolean)                           ;   in Carbon use Hide/ShowWindow, ShowHide, IsWindowVisible 
   (hilited :boolean)                           ;   in Carbon use HiliteWindow, IsWindowHilited 
   (goAwayFlag :boolean)                        ;   in Carbon use ChangeWindowAttributes 
   (spareFlag :boolean)                         ;   in Carbon use ChangeWindowAttributes 
   (strucRgn (:handle :macregion))              ;   in Carbon use GetWindowRegion 
   (contRgn (:handle :macregion))               ;   in Carbon use GetWindowRegion 
   (updateRgn (:handle :macregion))             ;   in Carbon use GetWindowRegion 
   (windowDefProc :handle)                      ;   not supported in Carbon  
   (dataHandle :handle)                         ;   not supported in Carbon  
   (titleHandle (:handle (:string 255)))        ;   in Carbon use Get/SetWTitle  
   (titleWidth :signed-integer)                 ;   in Carbon use GetWindowRegion  
   (controlList :handle)                        ;   in Carbon use GetRootControl  
   (nextWindow (:pointer :windowrecord))        ;   in Carbon use GetNextWindow  
   (windowPic (:handle :picture))               ;   in Carbon use Get/SetWindowPic  
   (refCon :signed-long)                        ;   in Carbon use Get/SetWRefCon 
   )|#;;; needs the :include keyword added

(defrecord WindowRecord 
   (port :grafport :include t)
   (windowKind :signed-integer)
   (visible :boolean)
   (hilited :boolean)
   (goAwayFlag :boolean)
   (spareFlag :boolean)
   (strucRgn (:handle :region))
   (contRgn (:handle :region))
   (updateRgn (:handle :region))
   (windowDefProc :handle)
   (dataHandle :handle)
   (titleHandle (:handle (:string 255)))
   (titleWidth :signed-integer)
   (controlList (:handle :controlrecord))
   (nextWindow (:pointer :windowrecord))
   (windowPic (:handle :picture))
   (refCon :signed-long)
   )

; $ENDC

; 		
; 	  Color WindowRecord                                                                 	
; 		
; $IFC NOT OPAQUE_TOOLBOX_STRUCTS 
(def-mactype :cwindowrecordptr (find-mactype '(:pointer :cwindowrecord)))
(def-mactype :cwindowpeek (find-mactype '(:pointer :cwindowrecord)))
(defrecord CWindowRecord 
   (port :cgrafport)                            ;   in Carbon use GetWindowPort 
   (windowKind :signed-integer)                 ;   in Carbon use Get/SetWindowKind     
   (visible :boolean)                           ;   in Carbon use Hide/ShowWindow, ShowHide, IsWindowVisible      
   (hilited :boolean)                           ;   in Carbon use HiliteWindow, IsWindowHilited 
   (goAwayFlag :boolean)                        ;   in Carbon use ChangeWindowAttributes    
   (spareFlag :boolean)                         ;   in Carbon use ChangeWindowAttributes    
   (strucRgn (:handle :macregion))              ;   in Carbon use GetWindowRegion   
   (contRgn (:handle :macregion))               ;   in Carbon use GetWindowRegion   
   (updateRgn (:handle :macregion))             ;   in Carbon use GetWindowRegion   
   (windowDefProc :handle)                      ;   not supported in Carbon  
   (dataHandle :handle)                         ;   not supported in Carbon  
   (titleHandle (:handle (:string 255)))        ;   in Carbon use Get/SetWTitle  
   (titleWidth :signed-integer)                 ;   in Carbon use GetWindowRegion  
   (controlList :handle)                        ;   in Carbon use GetRootControl  
   (nextWindow (:pointer :cwindowrecord))       ;   in Carbon use GetNextWindow  
   (windowPic (:handle :picture))               ;   in Carbon use Get/SetWindowPic      
   (refCon :signed-long)                        ;   in Carbon use Get/SetWRefCon       
   )

; $ENDC

; 		
; 	  AuxWinHandle                                                                       	
; 		
; $IFC NOT OPAQUE_TOOLBOX_STRUCTS 
(def-mactype :auxwinrecptr (find-mactype '(:pointer :auxwinrec)))
(def-mactype :auxwinptr (find-mactype '(:pointer :auxwinrec)))
(def-mactype :auxwinhandle (find-mactype '(:handle :auxwinrec)))
(defrecord (AuxWinRec :handle) 
   (awNext (:handle :auxwinrec))                ;   handle to next AuxWinRec, not supported in Carbon 
   (awOwner (:pointer :windowrecord))           ;   not supported in Carbon 
   (awCTable (:handle :colortable))             ;   color table for this window, use  Get/SetWindowContentColor in Carbon 
   (reserved :handle)                           ;   not supported in Carbon 
   (awFlags :signed-long)                       ;   reserved for expansion, not supported in Carbon 
   (awReserved (:handle :colortable))           ;   reserved for expansion, not supported in Carbon 
   (awRefCon :signed-long)                      ;   user constant, in Carbon use Get/SetWindowProperty if you need more refCons 
   )

; $ENDC

; 		
; 	   BasicWindowDescription                                                            	
; 	                                                                                      	
; 	  Contains statically-sized basic attributes of the window, for storage in a          	
; 	  collection item.                                                                    	
; 		
;   constants for the version field 

(defconstant $kWindowDefinitionVersionOne 1)
(defconstant $kWindowDefinitionVersionTwo 2)

;   constants for the stateflags bit field  
(defconstant $kWindowIsCollapsedState #x1)

(def-mactype :basicwindowdescriptionptr (find-mactype '(:pointer :basicwindowdescription)))
(defrecord BasicWindowDescription 
   (descriptionSize :unsigned-long)             ;   sizeof(BasicWindowDescription) 
   (windowContentRect :rect)                    ;   location on screen 
   (windowZoomRect :rect)                       ;   location on screen when zoomed out 
   (windowRefCon :unsigned-long)                ;   the refcon - __avoid saving stale pointers here__   
   (windowStateFlags :unsigned-long)            ;   window state bit flags 
   (WindowPositionMethod :unsigned-long)        ;   method last used by RepositionWindow to position the window (if any) 
   (windowDefinitionVersion :unsigned-long)
   (:variant 
      (
      (windowDefProc :signed-integer)           ;   defProc and variant 
      (windowHasCloseBox :boolean)
      )
      (
      (WindowClass :unsigned-long)              ;   the class 
      (WindowAttributes :unsigned-long)         ;   the attributes 
      )
      )
   )

;    the window manager stores the default collection items using these IDs 

(defconstant $kStoredWindowSystemTag :|appl|)   ;   Only Apple collection items will be of this tag 
(defconstant $kStoredBasicWindowDescriptionID :|sbas|);   BasicWindowDescription 
(defconstant $kStoredWindowPascalTitleID :|s255|);   pascal title string 

; 		
; 	  Window Class Ordering                                                              	
; 	                                                                                      	
; 	  Special cases for the behind parameter in window creation calls.                  	
; 		
(defconstant $kFirstWindowOfClass -1)
(defconstant $kLastWindowOfClass 0)

; 		
; 	  Zoom Information Handle                                                            	
; 		

(def-mactype :wstatedataptr (find-mactype '(:pointer :wstatedata)))
(defrecord (WStateData :handle) 
   (userState :rect)                            ;  user zoom state 
   (stdState :rect)                             ;  standard zoom state 
   )

(def-mactype :wstatedatahandle (find-mactype '(:handle :wstatedata)))
; 		
; 	  MixedMode & ProcPtrs                                                               	
; 		
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	WindowDefProcPtr = FUNCTION(varCode: INTEGER; window: WindowRef; message: INTEGER; param: LONGINT): LONGINT;

|#
 |#                                             ; $ELSEC
(def-mactype :windowdefprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DeskHookProcPtr = PROCEDURE(mouseClick: BOOLEAN; VAR theEvent: EventRecord);

|#
 |#                                             ; $ELSEC
(def-mactype :deskhookprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	WindowPaintProcPtr = FUNCTION(device: GDHandle; qdContext: GrafPtr; window: WindowRef; inClientPaintRgn: RgnHandle; outSystemPaintRgn: RgnHandle; refCon: UNIV Ptr): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :windowpaintprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :windowdefupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :windowdefupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :deskhookupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :deskhookupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :windowpaintupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :windowpaintupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppWindowDefProcInfo #x3BB0)
(defconstant $uppDeskHookProcInfo #x130802)
(defconstant $uppWindowPaintProcInfo #x3FFF0)
; 
; 	 *  NewWindowDefUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewWindowDefProc 
(deftrap "_NewWindowDefUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  NewDeskHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewDeskHookProc 
(deftrap "_NewDeskHookUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  NewWindowPaintUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewWindowPaintProc 
(deftrap "_NewWindowPaintUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeWindowDefUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeWindowDefUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  DisposeDeskHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeDeskHookUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  DisposeWindowPaintUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeWindowPaintUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeWindowDefUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallWindowDefProc 
(deftrap-inline "_InvokeWindowDefUPP" 
      ((varCode :signed-integer) (window (:pointer :windowrecord)) (message :signed-integer) (param :signed-long) (userRoutine :pointer)) 
  :signed-long
   (#x205F #x4E90) )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  InvokeDeskHookUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallDeskHookProc 
(deftrap-inline "_InvokeDeskHookUPP" 
      ((mouseClick :boolean) (theEvent (:pointer :eventrecord)) (userRoutine :pointer)) 
  nil
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; 
;  *  InvokeWindowPaintUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallWindowPaintProc 
(deftrap-inline "_InvokeWindowPaintUPP" 
      ((device (:handle :gdevice)) (qdContext (:pointer :grafport)) (window (:pointer :windowrecord)) (inClientPaintRgn (:handle :macregion)) (outSystemPaintRgn (:handle :macregion)) (refCon :pointer) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

; 
;   Window Definition Spec.  Used in Carbon to specify the code that defines a window. 
; 

(defconstant $kWindowDefProcPtr 0)              ;   raw proc-ptr based access 
(defconstant $kWindowDefObjectClass 1)          ;   event-based definition (Carbon 1.1 or later) 
(defconstant $kWindowDefProcID 2)               ;   explicit proc ID; overrides the window class default proc ID 

(def-mactype :windowdeftype (find-mactype ':unsigned-long))
(def-mactype :windowdefspecptr (find-mactype '(:pointer :windowdefspec)))
(defrecord WindowDefSpec 
   (defType :unsigned-long)
   (:variant 
      (
      (defProc :pointer)
      )
      (
      (classRef :pointer)
      )
      (
      (procID :signed-integer)
      )
      )
   )

; 		
; 	  Window Creation & Persistence                                                      	
; 		
; 
; 	 *  GetNewCWindow()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_GetNewCWindow" 
      ((windowID :signed-integer) (wStorage :pointer) (behind (:pointer :windowrecord)))
   (:stack (:pointer :windowrecord))
   (:stack-trap #xAA46))

; 
;  *  NewWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_NewWindow" 
      ((wStorage :pointer) (boundsRect (:pointer :rect)) (title (:string 255)) (visible :boolean) (theProc :signed-integer) (behind (:pointer :windowrecord)) (goAwayFlag :boolean) (refCon :signed-long))
   (:stack (:pointer :windowrecord))
   (:stack-trap #xA913))

; 
;  *  GetNewWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetNewWindow" 
      ((windowID :signed-integer) (wStorage :pointer) (behind (:pointer :windowrecord)))
   (:stack (:pointer :windowrecord))
   (:stack-trap #xA9BD))

; 
;  *  NewCWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_NewCWindow" 
      ((wStorage :pointer) (boundsRect (:pointer :rect)) (title (:string 255)) (visible :boolean) (procID :signed-integer) (behind (:pointer :windowrecord)) (goAwayFlag :boolean) (refCon :signed-long))
   (:stack (:pointer :windowrecord))
   (:stack-trap #xAA45))

; 
;  *  DisposeWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeWindow" 
      ((window (:pointer :windowrecord)))
   nil
   (:stack-trap #xA914))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  [Mac]CloseWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CloseWindow" 
      ((window (:pointer :windowrecord)))
   nil
   (:stack-trap #xA92D))

; 
;    Routines available from Mac OS 8.5 forward
;    or from Mac OS 8.1 forward when linking to CarbonLib 1.0 forward
; 

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  CreateNewWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ;   Routines available from Mac OS 8.5 forward ;   Create a window from a wind resource ; 
;  *  CreateWindowFromResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CreateNewWindow" 
      ((WindowClass :unsigned-long) (attributes :unsigned-long) (contentBounds (:pointer :rect)) (outWindow (:pointer (:pointer :windowrecord)))) 
  :osstatus
   () )                                         ;   window persistence ; 
;  *  StoreWindowIntoCollection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CreateWindowFromResource" 
      ((resID :signed-integer) (outWindow (:pointer (:pointer :windowrecord)))) 
  :osstatus
   () )                                         ; 
;  *  CreateWindowFromCollection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_StoreWindowIntoCollection" 
      ((window (:pointer :windowrecord)) (Collection :pointer)) 
  :osstatus
   () )                                         ;   window refcounting ; 
;  *  GetWindowOwnerCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CreateWindowFromCollection" 
      ((Collection :pointer) (outWindow (:pointer (:pointer :windowrecord)))) 
  :osstatus
   () )                                         ; 
;  *  CloneWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetWindowOwnerCount" 
      ((window (:pointer :windowrecord)) (outCount (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  GetWindowRetainCount()
;  *  
;  *  Summary:
;  *    Returns the retain count of a window.
;  *  
;  *  Discussion:
;  *    This API is equivalent to GetWindowOwnerCount. For consistency
;  *    with CoreFoundation and Carbon Events, it is preferred over
;  *    GetWindowOwnerCount. Both APIs will continue to be supported.
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window whose retain count to retrieve.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CloneWindow" 
      ((window (:pointer :windowrecord))) 
  :osstatus
   () )                                         ; 
;  *  RetainWindow()
;  *  
;  *  Summary:
;  *    Increments the retain count of a window.
;  *  
;  *  Discussion:
;  *    This API is equivalent to CloneWindow. For consistency with
;  *    CoreFoundation and Carbon Events, it is preferred over
;  *    CloneWindow. Both APIs will continue to be supported.
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window whose retain count to increment.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetWindowRetainCount" 
      ((inWindow (:pointer :windowrecord))) 
  :unsigned-long
   () )                                         ; 
;  *  ReleaseWindow()
;  *  
;  *  Summary:
;  *    Decrements the retain count of a window, and destroys the window
;  *    if the retain count falls to zero.
;  *  
;  *  Discussion:
;  *    This API is equivalent to DisposeWindow. For consistency with
;  *    CoreFoundation and Carbon Events, it is preferred over
;  *    DisposeWindow. Both APIs will continue to be supported.
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window whose retain count to decrement.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_RetainWindow" 
      ((inWindow (:pointer :windowrecord))) 
  :osstatus
   () )                                         ; ;   Custom Windows                                                                     ; ;   Routines available from Mac OS 8.1 forward when linking to CarbonLib 1.0 forward ; 
;  *  CreateCustomWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ReleaseWindow" 
      ((inWindow (:pointer :windowrecord))) 
  :osstatus
   () )                                         ; CONST; CONST; 
;  *  ReshapeCustomWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CreateCustomWindow" 
      ((def (:pointer :windowdefspec)) (WindowClass :unsigned-long) (attributes :unsigned-long) (contentBounds (:pointer :rect)) (outWindow (:pointer (:pointer :windowrecord)))) 
  :osstatus
   () )                                         ; 
;  *  RegisterWindowDefinition()
;  *  
;  *  Summary:
;  *    Registers or unregisters a binding between a resource ID and a
;  *    window definition function.
;  *  
;  *  Discussion:
;  *    In the Mac OS 8.x Window Manager, a 'WIND' resource can contain
;  *    an embedded WDEF procID that is used by the Window Manager as the
;  *    resource ID of an 'WDEF' resource to lay out and draw the window.
;  *    The 'WDEF' resource is loaded by the Window Manager when you load
;  *    the menu with GetNewWindow. Since WDEFs can no longer be packaged
;  *    as code resources on Carbon, the procID can no longer refer
;  *    directly to a WDEF resource. However, using
;  *    RegisterWindowDefinition you can instead specify a
;  *    UniversalProcPtr pointing to code in your application code
;  *    fragment. RegisterWindowDefinition is available when linking to
;  *    CarbonLib 1.1 forward.
;  *  
;  *  Parameters:
;  *    
;  *    inResID:
;  *      A WDEF proc ID, as used in a 'WIND' resource.
;  *    
;  *    inDefSpec:
;  *      Specifies the WindowDefUPP that should be used for windows with
;  *      the given WDEF proc ID. Passing NULL allows you to unregister
;  *      the window definition that had been associated with the given
;  *      WDEF proc ID.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ReshapeCustomWindow" 
      ((window (:pointer :windowrecord))) 
  :osstatus
   () )                                         ; CONST; ;   Window part tracking                                                               ; ; 
;    Routines available from Mac OS 8.5 forward
;         (or from Mac OS 8.6 forward when linking to CarbonLib 1.1 forward)
;                                               ; 
;  *  GetWindowWidgetHilite()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_RegisterWindowDefinition" 
      ((inResID :signed-integer) (inDefSpec (:pointer :windowdefspec))) 
  :osstatus
   () )                                         ; ;   Window Metainformation Accessors                                                   ; ; 
;  *  IsValidWindowClass()
;  *  
;  *  Summary:
;  *    Indicates whether a window class is supported by the Window
;  *    Manager.
;  *  
;  *  Parameters:
;  *    
;  *    inClass:
;  *      The window class.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.1 and later
;  
(deftrap-inline "_GetWindowWidgetHilite" 
      ((inWindow (:pointer :windowrecord)) (outHilite (:pointer :signed-integer))) 
  :osstatus
   () )
(deftrap-inline "_IsValidWindowClass" 
      ((inClass :unsigned-long)) 
  :boolean
   () )

; 
;  *  GetAvailableWindowAttributes()
;  *  
;  *  Summary:
;  *    Returns the window attributes that are valid for a window class.
;  *  
;  *  Discussion:
;  *    This API is useful because some window classes support different
;  *    attributes on different platforms (for example, floating windows
;  *    can have collapse boxes on 9, but not on X), and the Window
;  *    Manager will return an error if you attempt to create a window
;  *    with attributes that aren't supported for the requested window
;  *    class. You can use this API to remove attributes that are not
;  *    supported by the current platform before calling CreateNewWindow.
;  *  
;  *  Parameters:
;  *    
;  *    inClass:
;  *      The window class.
;  *  
;  *  Result:
;  *    The window attributes that are supported for the specified window
;  *    class.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.1 and later
;  

(deftrap-inline "_GetAvailableWindowAttributes" 
      ((inClass :unsigned-long)) 
  :unsigned-long
   () )

; 
;    Routines available from Mac OS 8.5 forward
;    or from Mac OS 8.1 forward when linking to CarbonLib 1.0 forward
; 
; 
;  *  GetWindowClass()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  GetWindowAttributes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetWindowClass" 
      ((window (:pointer :windowrecord)) (outClass (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;    Routines available from Mac OS 9.0 forward
;    or from Mac OS 8.1 forward when linking to CarbonLib 1.0 forward
;                                               ; 
;  *  ChangeWindowAttributes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetWindowAttributes" 
      ((window (:pointer :windowrecord)) (outAttributes (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;     WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
;     WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
;     
;     SetWindowClass will disappear in the near future. Instead of SetWindowClass,
;     you should use SetWindowGroup to move a window into the group of the desired
;     class. This API is very dangerous in that is actually does change the class
;     of the window, but class was meant to be an immutable property of the window.
;     At the very least, this API will be modified to only change the layer of the
;     window to match the layer that the specified class normally lives in. Consider
;     yourself warned!
;     
;     WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
;     WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
;                                               ; 
;  *  SetWindowClass()
;  *  
;  *  Summary:
;  *    Changes the window class of a window.
;  *  
;  *  Discussion:
;  *    SetWindowClass changes the class of a window. It also changes the
;  *    window's z-order so that it is grouped with other windows of the
;  *    same class. It does not change the visual appearance of the
;  *    window. In CarbonLib, SetWindowClass may not be used to change a
;  *    non-utility window to have utility window class, or to make a
;  *    utility window have non-utility class. SetWindowClass is
;  *    available from CarbonLib 1.1 forward.
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window whose class to change.
;  *    
;  *    inWindowClass:
;  *      The new window class.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ChangeWindowAttributes" 
      ((window (:pointer :windowrecord)) (setTheseAttributes :unsigned-long) (clearTheseAttributes :unsigned-long)) 
  :osstatus
   () )                                         ; ;    Window Modality                                                                   ; ; 
;  *  WindowModality
;  *  
;  
(deftrap-inline "_SetWindowClass" 
      ((inWindow (:pointer :windowrecord)) (inWindowClass :unsigned-long)) 
  :osstatus
   () )
(def-mactype :windowmodality (find-mactype ':unsigned-long))

(defconstant $kWindowModalityNone 0)
(defconstant $kWindowModalitySystemModal 1)
(defconstant $kWindowModalityAppModal 2)
(defconstant $kWindowModalityWindowModal 3)

; 
; 	 *  SetWindowModality()
; 	 *  
; 	 *  Summary:
; 	 *    Sets the modality of a window.
; 	 *  
; 	 *  Discussion:
; 	 *    The modality of a window is used by the Carbon event manager to
; 	 *    automatically determine appropriate event handling.
; 	 *  
; 	 *  Parameters:
; 	 *    
; 	 *    inWindow:
; 	 *      The window whose modality to set.
; 	 *    
; 	 *    inModalKind:
; 	 *      The new modality for the window.
; 	 *    
; 	 *    inUnavailableWindow:
; 	 *      If the window is becoming window-modal, this parameter
; 	 *      specifies the window to which the inWindow parameter is modal.
; 	 *      The unavailableWindow will not be available while inWindow is
; 	 *      in window-modal state.
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;  *  GetWindowModality()
;  *  
;  *  Summary:
;  *    Retrieves the modality of a window.
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window whose modality to retrieve.
;  *    
;  *    outModalKind:
;  *      On exit, contains the modality of the window.
;  *    
;  *    outUnavailableWindow:
;  *      On exit, ifthe window is window-modal, contains the target
;  *      window of the specified window's modality.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetWindowModality" 
      ((inWindow (:pointer :windowrecord)) (inModalKind :unsigned-long) (inUnavailableWindow (:pointer :windowrecord))) 
  :osstatus
   () )                                         ; ;   Floating Windows                                                                   ; ; 
;    Routines available from Mac OS 8.6 forward
;    or from Mac OS 8.1 forward when linking to CarbonLib 1.0 forward
;                                               ; 
;  *  ShowFloatingWindows()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetWindowModality" 
      ((inWindow (:pointer :windowrecord)) (outModalKind (:pointer :unsigned-long)) (outUnavailableWindow (:pointer (:pointer :windowrecord)))) 
  :osstatus
   () )                                         ; 
;  *  HideFloatingWindows()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ShowFloatingWindows" 
      () 
  :osstatus
   () )                                         ; 
;  *  AreFloatingWindowsVisible()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HideFloatingWindows" 
      () 
  :osstatus
   () )                                         ; ;   Window Groups                                                                      ;                                                                                       ;  The Window Group API allows the creation and management of groups of windows,        ;  allowing control of the z-order, activation, and positioning of the windows.         ;  Internally to the Window Manager, each of the standard window tiers (document,       ;  toolbar, floating, modal, utility, help, and overlay) is implemented as a window     ;  group; you can access the window group for a class with GetWindowGroupOfClass.       ;  You can create your own window groups, if you would like your windows to float,      ;  for example, above the floating window layer but below the modal layer. It is        ;  also possible to create more complex hierarchical arrangements of window groups.     ; 
(deftrap-inline "_AreFloatingWindowsVisible" 
      () 
  :boolean
   () )
(def-mactype :windowgroupref (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :windowgrouprefptr (find-mactype '(:pointer :pointer)));  when a VAR xx:WindowGroupRef parameter can be nil, it is changed to xx: WindowGroupRefPtr 
;   may be passed as the "behindWindow" parameter to NewCWindow and SendBehind 

(defconstant $kFirstWindowOfGroup -1)
; $IFC NOT UNDEFINED MWERKS
(defconstant $kLastWindowOfGroup nil)
; $ENDC
;   may be passed as the "behindGroup" parameter to SendWindowGroupBehind 
(defconstant $kFirstWindowGroup -1)
; $IFC NOT UNDEFINED MWERKS
(defconstant $kLastWindowGroup nil)
; $ENDC

; 
; 	 *  WindowGroupAttributes
; 	 *  
; 	 *  Summary:
; 	 *    These are attributes that may be applied to a window group.
; 	 	

(def-mactype :windowgroupattributes (find-mactype ':unsigned-long))

(defconstant $kWindowGroupAttrSelectAsLayer #x1)
(defconstant $kWindowGroupAttrMoveTogether #x2)
(defconstant $kWindowGroupAttrLayerTogether #x4)
(defconstant $kWindowGroupAttrSharedActivation #x8)
(defconstant $kWindowGroupAttrHideOnCollapse #x10)

; 
; 	 *  WindowActivationScope
; 	 *  
; 	 *  Discussion:
; 	 *    Every window has a WindowActivationScope. It defines how windows
; 	 *    are activated by the Window Manager with respect to other windows
; 	 *    in the windows group and in the current process.
; 	 	

(def-mactype :windowactivationscope (find-mactype ':unsigned-long))

(defconstant $kWindowActivationScopeNone 0)
(defconstant $kWindowActivationScopeIndependent 1)
(defconstant $kWindowActivationScopeAll 2)

; 
; 	 *  Summary:
; 	 *    These are constants that can be used for the inNextGroup
; 	 *    parameter to GetSiblingWindowGroup.
; 	 	
(defconstant $kNextWindowGroup #$true)
(defconstant $kPreviousWindowGroup #$false)

; 
; 	 *  WindowGroupContentOptions
; 	 *  
; 	 *  Discussion:
; 	 *    Window group contents options are used to control what group
; 	 *    content is counted or returned by the CountWindowGroupContents
; 	 *    and GetWindowGroupContents APIs.
; 	 	

(def-mactype :windowgroupcontentoptions (find-mactype ':unsigned-long))

(defconstant $kWindowGroupContentsReturnWindows #x1)
(defconstant $kWindowGroupContentsRecurse #x2)
(defconstant $kWindowGroupContentsVisible #x4)

; 	----------------------------------------------------------------------------------	
; 	   Group creation, destruction, and refcounting                                  	
; 	----------------------------------------------------------------------------------	
; 
; 	 *  CreateWindowGroup()
; 	 *  
; 	 *  Summary:
; 	 *    Creates a new window group.
; 	 *  
; 	 *  Parameters:
; 	 *    
; 	 *    inAttributes:
; 	 *      Attributes for the new window group.
; 	 *    
; 	 *    outGroup:
; 	 *      On exit, contains the new window group.
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap-inline "_CreateWindowGroup" 
      ((inAttributes :unsigned-long) (outGroup (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  RetainWindowGroup()
;  *  
;  *  Summary:
;  *    Increments the refcount of a window group.
;  *  
;  *  Parameters:
;  *    
;  *    inGroup:
;  *      The group whose refcount to increment.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_RetainWindowGroup" 
      ((inGroup :pointer)) 
  :osstatus
   () )

; 
;  *  ReleaseWindowGroup()
;  *  
;  *  Summary:
;  *    Releases a refcount on a window group. If the refcount goes to
;  *    zero, the group is destroyed, and a refcount is released from all
;  *    contained objects.
;  *  
;  *  Parameters:
;  *    
;  *    inGroup:
;  *      The group whose refcount to decrement.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ReleaseWindowGroup" 
      ((inGroup :pointer)) 
  :osstatus
   () )

; 
;  *  GetWindowGroupRetainCount()
;  *  
;  *  Summary:
;  *    Returns the refcount of a window group.
;  *  
;  *  Parameters:
;  *    
;  *    inGroup:
;  *      The group whose refcount to return.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.1 and later
;  

(deftrap-inline "_GetWindowGroupRetainCount" 
      ((inGroup :pointer)) 
  :unsigned-long
   () )

; 
;  *  GetWindowGroupOfClass()
;  *  
;  *  Summary:
;  *    Gets the window group in which windows of a given class are
;  *    placed.
;  *  
;  *  Discussion:
;  *    The Window Manager uses window groups internally to manage the
;  *    ordering of windows of different classes. In some cases, multiple
;  *    classes are placed within the same group; for example, windows
;  *    from all of the modal and alert window classes are placed into
;  *    the same modal window group. The refcount of the group returned
;  *    by this API is not incremented, and the caller does not need to
;  *    release the reference.
;  *  
;  *  Parameters:
;  *    
;  *    windowClass:
;  *      The class whose window group to retrieve. You may pass
;  *      kAllWindowClasses to retrieve the root window group.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetWindowGroupOfClass" 
      ((WindowClass :unsigned-long)) 
  :pointer
   () )

; ----------------------------------------------------------------------------------
;   Group name, attributes, and level                                             
; ----------------------------------------------------------------------------------
; 
;  *  SetWindowGroupName()
;  *  
;  *  Summary:
;  *    Sets the name of a window group.
;  *  
;  *  Discussion:
;  *    The name of a window group is never displayed to the user.
;  *    However, it is displayed by debugging functions such as
;  *    DebugPrintWindowGroup. This can be very useful when debugging the
;  *    structure of your window groups.
;  *  
;  *  Parameters:
;  *    
;  *    inGroup:
;  *      The group whose name to set.
;  *    
;  *    inName:
;  *      The name of the group.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_SetWindowGroupName" 
      ((inGroup :pointer) (inName :pointer)) 
  :osstatus
   () )

; 
;  *  CopyWindowGroupName()
;  *  
;  *  Summary:
;  *    Returns a copy of the name of a window group.
;  *  
;  *  Parameters:
;  *    
;  *    inGroup:
;  *      The group whose name to retrieve.
;  *    
;  *    outName:
;  *      On exit, contains the name of the group. It is the caller's
;  *      responsibility to release the name.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CopyWindowGroupName" 
      ((inGroup :pointer) (outName (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  GetWindowGroupAttributes()
;  *  
;  *  Summary:
;  *    Retrieves the attributes of a window group.
;  *  
;  *  Parameters:
;  *    
;  *    inGroup:
;  *      The group whose attributes to retrieve.
;  *    
;  *    outAttributes:
;  *      On exit, the groups attributes.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetWindowGroupAttributes" 
      ((inGroup :pointer) (outAttributes (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  ChangeWindowGroupAttributes()
;  *  
;  *  Summary:
;  *    Changes the attributes of a window group.
;  *  
;  *  Parameters:
;  *    
;  *    inGroup:
;  *      The group whose attributes to change.
;  *    
;  *    setTheseAttributes:
;  *      The attributes to set.
;  *    
;  *    clearTheseAttributes:
;  *      The attributes to clear.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ChangeWindowGroupAttributes" 
      ((inGroup :pointer) (setTheseAttributes :unsigned-long) (clearTheseAttributes :unsigned-long)) 
  :osstatus
   () )

; 
;  *  SetWindowGroupLevel()
;  *  
;  *  Summary:
;  *    Sets the CoreGraphics window group level of windows in a group.
;  *  
;  *  Discussion:
;  *    CoreGraphics windows (used to implement all windows in Carbon and
;  *    Cocoa applications on Mac OS X) are divided into layers specified
;  *    by a window level. Standard window levels are listed in
;  *    <CoreGraphics/CGWindowLevel.h>. By default, a new window group
;  *    has a window level of kCGNormalWindowLevel. When a window is
;  *    placed into a window group, its window level is determined by the
;  *    window level of its "base group". This is the containing group
;  *    that is a child of the root group. For example, if group A is a
;  *    child of the root group, and group B is a child of group A, and
;  *    window C is in group B, then window C's base group is group A,
;  *    and group A's window level determines the level of window C.
;  *    SetWindowGroupLevel only allows changing the window level of
;  *    groups that are children of the root group. It returns paramErr
;  *    for other groups, since a group that is not a child of the root
;  *    group is not a base group and changing its level has no effect.
;  *    Changing the level of a group also changes the level of all
;  *    windows currently contained by the group.
;  *  
;  *  Parameters:
;  *    
;  *    inGroup:
;  *      The window group whose level to change.
;  *    
;  *    inLevel:
;  *      The new level for the windows in this group.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_SetWindowGroupLevel" 
      ((inGroup :pointer) (inLevel :signed-long)) 
  :osstatus
   () )

; 
;  *  GetWindowGroupLevel()
;  *  
;  *  Summary:
;  *    Gets the CoreGraphics window group level of windows in a group.
;  *  
;  *  Parameters:
;  *    
;  *    inGroup:
;  *      The window group whose level to return.
;  *    
;  *    outLevel:
;  *      On exit, contains the window level of the windows in this group.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetWindowGroupLevel" 
      ((inGroup :pointer) (outLevel (:pointer :signed-long))) 
  :osstatus
   () )

; ----------------------------------------------------------------------------------
;   Group z-ordering                                                              
; ----------------------------------------------------------------------------------
; 
;  *  SendWindowGroupBehind()
;  *  
;  *  Summary:
;  *    Changes the z-order of a group, if the group does not have the
;  *    kWindowGroupAttributeLayerTogether attribute set.
;  *  
;  *  Discussion:
;  *    SendWindowGroupBehind currently requires that the group being
;  *    moved and the behindGroup have the same parent group.
;  *  
;  *  Parameters:
;  *    
;  *    inGroup:
;  *      The group whose z-order to change.
;  *    
;  *    behindGroup:
;  *      The group behind which to position the specified group.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_SendWindowGroupBehind" 
      ((inGroup :pointer) (behindGroup :pointer)) 
  :osstatus
   () )

; ----------------------------------------------------------------------------------
;   Group containment hierarchy manipulation                                      
; ----------------------------------------------------------------------------------
; 
;  *  GetWindowGroup()
;  *  
;  *  Summary:
;  *    Gets the window group that contains a window.
;  *  
;  *  Discussion:
;  *    The refcount of the group returned by this API is not
;  *    incremented, and the caller does not need to release the
;  *    reference.
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window whose containing group to retrieve.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetWindowGroup" 
      ((inWindow (:pointer :windowrecord))) 
  :pointer
   () )

; 
;  *  SetWindowGroup()
;  *  
;  *  Summary:
;  *    Sets the window group that contains a window.
;  *  
;  *  Discussion:
;  *    The windows z-order relative to windows in the current process
;  *    may also be changed by this API. If the new window group is
;  *    z-ordered above the windows current group, the window will be
;  *    placed at the end of the new group. If the new window group is
;  *    z-ordered below the windows current group, the window will be
;  *    placed at the top of the new group. You may not place a window
;  *    directly into the root group.
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window whose group to change.
;  *    
;  *    inNewGroup:
;  *      The new containing group.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_SetWindowGroup" 
      ((inWindow (:pointer :windowrecord)) (inNewGroup :pointer)) 
  :osstatus
   () )

; 
;  *  IsWindowContainedInGroup()
;  *  
;  *  Summary:
;  *    Indicates whether a window is contained within a group or any of
;  *    its subgroups.
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window whose containment to examine.
;  *    
;  *    inGroup:
;  *      The group that might contain the window.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_IsWindowContainedInGroup" 
      ((inWindow (:pointer :windowrecord)) (inGroup :pointer)) 
  :boolean
   () )

; 
;  *  GetWindowGroupParent()
;  *  
;  *  Summary:
;  *    Gets the window group that contains a group.
;  *  
;  *  Parameters:
;  *    
;  *    inGroup:
;  *      The group whose containing group to retrieve.
;  *    
;  *    outGroup:
;  *      On exit, the containing window group of the group. The groups
;  *      refcount is not incremented by this API, and the caller does
;  *      not need to release the reference.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetWindowGroupParent" 
      ((inGroup :pointer)) 
  :pointer
   () )

; 
;  *  SetWindowGroupParent()
;  *  
;  *  Summary:
;  *    Sets the window group that contains a group.
;  *  
;  *  Discussion:
;  *    SetWindowGroupParent currently requires that the group have no
;  *    windows in it.
;  *  
;  *  Parameters:
;  *    
;  *    inGroup:
;  *      The group whose containing group to change.
;  *    
;  *    inNewGroup:
;  *      The new containing group.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_SetWindowGroupParent" 
      ((inGroup :pointer) (inNewGroup :pointer)) 
  :osstatus
   () )

; 
;  *  GetWindowGroupSibling()
;  *  
;  *  Summary:
;  *    Returns the next or previous group of a window group.
;  *  
;  *  Parameters:
;  *    
;  *    inGroup:
;  *      The group whose sibling to return.
;  *    
;  *    inNextGroup:
;  *      True to return the next sibling, false to return the previous
;  *      sibling.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetWindowGroupSibling" 
      ((inGroup :pointer) (inNextGroup :boolean)) 
  :pointer
   () )

; 
;  *  GetWindowGroupOwner()
;  *  
;  *  Summary:
;  *    Returns the window that owns a window group, or NULL if none.
;  *  
;  *  Discussion:
;  *    A window may own one or more window groups. The windows in an
;  *    owned window group will always be z-ordered above the owner
;  *    window. Whenever the owner window changes z-order, the windows in
;  *    the groups owned by the window will be moved also.
;  *  
;  *  Parameters:
;  *    
;  *    inGroup:
;  *      The group whose owner to retrieve.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetWindowGroupOwner" 
      ((inGroup :pointer)) 
  (:pointer :windowrecord)
   () )

; 
;  *  SetWindowGroupOwner()
;  *  
;  *  Summary:
;  *    Sets the window that owns a window group.
;  *  
;  *  Discussion:
;  *    The group and the window must have the same parent group.
;  *    SetWindowGroupOwner currently requires that the group have no
;  *    windows in it.
;  *  
;  *  Parameters:
;  *    
;  *    inGroup:
;  *      The group whose owner to set.
;  *    
;  *    inWindow:
;  *      The group's new owner.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_SetWindowGroupOwner" 
      ((inGroup :pointer) (inWindow (:pointer :windowrecord))) 
  :osstatus
   () )

; ----------------------------------------------------------------------------------
;    Inspection of group contents                                                  
; ----------------------------------------------------------------------------------

; 
;  *  CountWindowGroupContents()
;  *  
;  *  Summary:
;  *    Counts the windows or groups contained in a group.
;  *  
;  *  Parameters:
;  *    
;  *    inGroup:
;  *      The group whose contents to count.
;  *    
;  *    inOptions:
;  *      Specifies how to count the groups contents.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CountWindowGroupContents" 
      ((inGroup :pointer) (inOptions :unsigned-long)) 
  :unsigned-long
   () )

; 
;  *  GetWindowGroupContents()
;  *  
;  *  Summary:
;  *    Retrieves the windows or groups contained in a group.
;  *  
;  *  Discussion:
;  *    The windows or groups returned by this API will be placed into
;  *    the output buffer in z-order, from highest to lowest.
;  *  
;  *  Parameters:
;  *    
;  *    inGroup:
;  *      The group whose contents to retrieve.
;  *    
;  *    inOptions:
;  *      Specifies which content to retrieve.
;  *    
;  *    inAllowedItems:
;  *      The number of items that will fit in the output buffer.
;  *    
;  *    outNumItems:
;  *      On exit, the number of items that were returned. May be NULL.
;  *    
;  *    outItems:
;  *      On entry, points to enough memory to hold inAllowedSize
;  *      WindowRefs or WindowGroupRefs. On exit, contains *outNumItems
;  *      WindowRefs or WindowGroupRefs.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetWindowGroupContents" 
      ((inGroup :pointer) (inOptions :unsigned-long) (inAllowedItems :unsigned-long) (outNumItems (:pointer :unsigned-long)) (outItems (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  GetIndexedWindow()
;  *  
;  *  Summary:
;  *    Retrieves a specified window from a group.
;  *  
;  *  Discussion:
;  *    GetIndexedWindow is provided as an easier way to get a particular
;  *    window from a group than using GetWindowGroupContents. If you
;  *    only need to retrieve, say, the last window in a group, it is
;  *    easier and more efficient to use GetIndexedWindow. If you need to
;  *    retrieve all the windows in a group, it is more efficient to use
;  *    GetWindowGroupContents.
;  *  
;  *  Parameters:
;  *    
;  *    inGroup:
;  *      The group containing the window to retrieve.
;  *    
;  *    inIndex:
;  *      The index of the window. This parameter may range from 1 to
;  *      CountWindowGroupContents( inGroup,
;  *      kWindowGroupContentsReturnWindows | inOptions );
;  *    
;  *    inOptions:
;  *      Indicates how to locate the specified window.
;  *      kWindowGroupContentsReturnWindows is implied by this API and
;  *      does not need to be explicitly specified.
;  *    
;  *    outWindow:
;  *      On exit, the window at the specified index.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetIndexedWindow" 
      ((inGroup :pointer) (inIndex :unsigned-long) (inOptions :unsigned-long) (outWindow (:pointer (:pointer :windowrecord)))) 
  :osstatus
   () )

; 
;  *  GetWindowIndex()
;  *  
;  *  Summary:
;  *    Retrieves the z-order index of a window inside a group.
;  *  
;  *  Discussion:
;  *    The z-order index of a window is its relative position in z-order
;  *    inside a group. The index ranges from 1 to the number of windows
;  *    in the group.
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window whose z-order index to retrieve.
;  *    
;  *    inStartGroup:
;  *      The group on which to base the z-order index. This should be
;  *      either the containing group of the window, or NULL. If NULL,
;  *      this API returns the z-order index of the window across the
;  *      entire process.
;  *    
;  *    inOptions:
;  *      Indicates how to enumerate the specified window.
;  *      kWindowGroupContentsReturnWindows is implied by this API and
;  *      does not need to be explicitly specified.
;  *    
;  *    outIndex:
;  *      On exit, contains the windows z-order index.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetWindowIndex" 
      ((inWindow (:pointer :windowrecord)) (inStartGroup :pointer) (inOptions :unsigned-long) (outIndex (:pointer :unsigned-long))) 
  :osstatus
   () )

; ----------------------------------------------------------------------------------
;   Window activation                                                             
; ----------------------------------------------------------------------------------
; 
;  *  ActiveNonFloatingWindow()
;  *  
;  *  Summary:
;  *    Returns the window, among all windows with activation scope of
;  *    kWindowActivationScopeAll, that is considered active.
;  *  
;  *  Discussion:
;  *    The Mac OS 8.5 Window Manager introduced the
;  *    FrontNonFloatingWindow API, which was designed to return the
;  *    window that should be considered active by the application. With
;  *    the advent of window groups, it is now possible to have a window
;  *    that looks active (is highlighted, and accepts keyboard input)
;  *    but to have other non-floating windows grouped above the active
;  *    window. The ActiveNonFloatingWindow API returns the active window
;  *    regardless of where it is positioned in the z-order. Most code
;  *    that currently uses FrontNonFloatingWindow or
;  *    GetFrontWindowOfClass(kDocumentClass) to get the active window
;  *    should use ActiveNonFloatingWindow instead.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ActiveNonFloatingWindow" 
      () 
  (:pointer :windowrecord)
   () )

; 
;  *  IsWindowActive()
;  *  
;  *  Summary:
;  *    Indicates whether a window is active.
;  *  
;  *  Discussion:
;  *    The active state of a window is simply determined by whether its
;  *    window frame is drawn using an active appearance. This does not
;  *    indicate whether the window has keyboard focus. To get the window
;  *    with keyboard focus, use GetUserFocusWindow().
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window whose active state to retrieve.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_IsWindowActive" 
      ((inWindow (:pointer :windowrecord))) 
  :boolean
   () )

; 
;  *  ActivateWindow()
;  *  
;  *  Summary:
;  *    Activates or deactivates a window.
;  *  
;  *  Discussion:
;  *    Window activation consists of two steps: hiliting the window
;  *    frame and sending an activate event to the window. ActivateWindow
;  *    handles both of these steps and also updates internal Window
;  *    Manager state. If you just need to hilite the window frame, you
;  *    may use HiliteWindow. If you need to send an activate event, you
;  *    should always use ActivateWindow rather than creating and sending
;  *    the event yourself.
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window to activate or deactivate.
;  *    
;  *    inActivate:
;  *      Whether to activate or deactivate the window.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ActivateWindow" 
      ((inWindow (:pointer :windowrecord)) (inActivate :boolean)) 
  :osstatus
   () )

; 
;  *  GetWindowActivationScope()
;  *  
;  *  Summary:
;  *    Retrieves a windows activation scope.
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window whose activation scope to retrieve.
;  *    
;  *    outScope:
;  *      On exit, the windows activation scope.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetWindowActivationScope" 
      ((inWindow (:pointer :windowrecord)) (outScope (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  SetWindowActivationScope()
;  *  
;  *  Summary:
;  *    Sets a windows activation scope.
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window whose activation scope to set.
;  *    
;  *    inScope:
;  *      The new activation scope.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_SetWindowActivationScope" 
      ((inWindow (:pointer :windowrecord)) (inScope :unsigned-long)) 
  :osstatus
   () )

; ----------------------------------------------------------------------------------
;   Debugging Utilities                                                           
; ----------------------------------------------------------------------------------
; 
;  *  DebugPrintWindowGroup()
;  *  
;  *  Summary:
;  *    Prints the contents of a window group to stdout.
;  *  
;  *  Parameters:
;  *    
;  *    inGroup:
;  *      The group whose contents to print.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_DebugPrintWindowGroup" 
      ((inGroup :pointer)) 
  nil
   () )

; 
;  *  DebugPrintAllWindowGroups()
;  *  
;  *  Summary:
;  *    Prints the full window group hierarchy, starting at the root
;  *    group.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_DebugPrintAllWindowGroups" 
      () 
  nil
   () )

; 
;   Background Image                                                                   
; 
;   SetWinColor is not available in Carbon. 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SetWinColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetWinColor" 
      ((window (:pointer :windowrecord)) (newColorTable (:handle :winctab)))
   nil
   (:stack-trap #xAA41))

;   SetDeskCPat is not available in Carbon. 
; 
;  *  SetDeskCPat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetDeskCPat" 
      ((deskPixPat (:handle :pixpat)))
   nil
   (:stack-trap #xAA47))

; 
;    Routines available from Mac OS 8.5 forward
;    or from Mac OS 8.1 forward when linking to CarbonLib 1.0 forward
; 
; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  SetWindowContentColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; 
;  *  GetWindowContentColor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetWindowContentColor" 
      ((window (:pointer :windowrecord)) (color (:pointer :rgbcolor))) 
  :osstatus
   () )                                         ;   Routines available from Mac OS 8.5 forward ; 
;  *  GetWindowContentPattern()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetWindowContentColor" 
      ((window (:pointer :windowrecord)) (color (:pointer :rgbcolor))) 
  :osstatus
   () )                                         ; 
;  *  SetWindowContentPattern()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetWindowContentPattern" 
      ((window (:pointer :windowrecord)) (outPixPat (:handle :pixpat))) 
  :osstatus
   () )                                         ;   Routines available from Mac OS 9.0 forward 
(deftrap-inline "_SetWindowContentPattern" 
      ((window (:pointer :windowrecord)) (pixPat (:handle :pixpat))) 
  :osstatus
   () )
(def-mactype :windowpaintprocoptions (find-mactype ':unsigned-long))

(defconstant $kWindowPaintProcOptionsNone 0)

; 
; 	 *  InstallWindowContentPaintProc()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in WindowsLib 9.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; ;   Scrolling Routines                                                                 ; 
(deftrap-inline "_InstallWindowContentPaintProc" 
      ((window (:pointer :windowrecord)) (paintProc :pointer) (options :unsigned-long) (refCon :pointer)) 
  :osstatus
   () )
(def-mactype :scrollwindowoptions (find-mactype ':unsigned-long))

(defconstant $kScrollWindowNoOptions 0)
(defconstant $kScrollWindowInvalidate #x1)      ;   add the exposed area to the windows update region 
(defconstant $kScrollWindowEraseToPortBackground #x2);   erase the exposed area using the background color/pattern of the windows grafport 

;   Routines available from Mac OS 8.1 forward when linking to CarbonLib 1.0 forward 

; 
; 	 *  ScrollWindowRect()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; CONST                                         ; 
;  *  ScrollWindowRegion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ScrollWindowRect" 
      ((inWindow (:pointer :windowrecord)) (inScrollRect (:pointer :rect)) (inHPixels :signed-integer) (inVPixels :signed-integer) (inOptions :unsigned-long) (outExposedRgn (:handle :macregion))) 
  :osstatus
   () )                                         ; ;   Low-Level Region & Painting Routines                                               ; ; 
;  *  ClipAbove()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ScrollWindowRegion" 
      ((inWindow (:pointer :windowrecord)) (inScrollRgn (:handle :macregion)) (inHPixels :signed-integer) (inVPixels :signed-integer) (inOptions :unsigned-long) (outExposedRgn (:handle :macregion))) 
  :osstatus
   () )
(deftrap "_ClipAbove" 
      ((window (:pointer :windowrecord)))
   nil
   (:stack-trap #xA90B))

;   SaveOld/DrawNew are not available in Carbon.  Use ReshapeCustomWindow instead. 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SaveOld()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SaveOld" 
      ((window (:pointer :windowrecord)))
   nil
   (:stack-trap #xA90E))

; 
;  *  DrawNew()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DrawNew" 
      ((window (:pointer :windowrecord)) (update :boolean))
   nil
   (:stack-trap #xA90F))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  PaintOne()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PaintOne" 
      ((window (:pointer :windowrecord)) (clobberedRgn (:handle :macregion)))
   nil
   (:stack-trap #xA90C))

; 
;  *  PaintBehind()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PaintBehind" 
      ((startWindow (:pointer :windowrecord)) (clobberedRgn (:handle :macregion)))
   nil
   (:stack-trap #xA90D))

; 
;  *  CalcVis()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CalcVis" 
      ((window (:pointer :windowrecord)))
   nil
   (:stack-trap #xA909))

; 
;  *  CalcVisBehind()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CalcVisBehind" 
      ((startWindow (:pointer :windowrecord)) (clobberedRgn (:handle :macregion)))
   nil
   (:stack-trap #xA90A))

; 
;  *  CheckUpdate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CheckUpdate" 
      ((theEvent (:pointer :eventrecord)))
   (:stack :boolean)
   (:stack-trap #xA911))

; 
;   Window List                                                                        
; 
; 
;  *  [Mac]FindWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FindWindow" 
      ((thePoint :point) (window (:pointer (:pointer :windowrecord))))
   (:stack :signed-integer)
   (:stack-trap #xA92C))

; 
;  *  FrontWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FrontWindow" 
      ()
   (:stack (:pointer :windowrecord))
   (:stack-trap #xA924))

; 
;  *  BringToFront()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_BringToFront" 
      ((window (:pointer :windowrecord)))
   nil
   (:stack-trap #xA920))

; 
;  *  SendBehind()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SendBehind" 
      ((window (:pointer :windowrecord)) (behindWindow (:pointer :windowrecord)))
   nil
   (:stack-trap #xA921))

; 
;  *  SelectWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SelectWindow" 
      ((window (:pointer :windowrecord)))
   nil
   (:stack-trap #xA91F))

; 
;    Routines available from Mac OS 8.6 forward
;    or from Mac OS 8.1 forward when linking to CarbonLib 1.0 forward
; 

; 
;  *  FrontNonFloatingWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;   Routines available from Mac OS 8.1 forward when linking to CarbonLib 1.0 forward ; 
;  *  GetNextWindowOfClass()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_FrontNonFloatingWindow" 
      () 
  (:pointer :windowrecord)
   () )                                         ; 
;  *  GetFrontWindowOfClass()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetNextWindowOfClass" 
      ((inWindow (:pointer :windowrecord)) (inWindowClass :unsigned-long) (mustBeVisible :boolean)) 
  (:pointer :windowrecord)
   () )                                         ; 
;  *  FindWindowOfClass()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetFrontWindowOfClass" 
      ((inWindowClass :unsigned-long) (mustBeVisible :boolean)) 
  (:pointer :windowrecord)
   () )                                         ; CONST;   Carbon only ; 
;  *  CreateStandardWindowMenu()
;  *  
;  *  Discussion:
;  *    Creates a standard Window menu for your application. You can call
;  *    this to create a window menu for your application and insert it
;  *    in your menu bar (typically at the end of your menu list). To
;  *    register a window to be tracked by this menu, you either create
;  *    your window with CreateNewWindow, passing the
;  *    kWindowInWindowMenuAttribute, or you can use
;  *    ChangeWindowAttributes after the window is created. The Toolbox
;  *    takes care of acting on the standard items such as zoom and
;  *    minimize, as well as bringing selected windows to the front. All
;  *    you need to do is install it and register your windows and the
;  *    Toolbox does the rest.
;  *  
;  *  Parameters:
;  *    
;  *    inOptions:
;  *      Currently you must pass zero for this parameter.
;  *    
;  *    outMenu:
;  *      Receives a new menu reference which contains the standard
;  *      window menu items and commands.
;  *  
;  *  Result:
;  *    An operating system status code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_FindWindowOfClass" 
      ((where (:pointer :point)) (inWindowClass :unsigned-long) (outWindow (:pointer (:pointer :windowrecord))) (outWindowPart (:pointer :signed-integer))) 
  :osstatus
   () )                                         ; 
;  *  SetWindowAlternateTitle()
;  *  
;  *  Discussion:
;  *    This API sets an alternate title for a window. The alternate
;  *    title overrides what is displayed in the Window menu. If you do
;  *    not set an alternate title, the normal window title is used. You
;  *    would normally use this if the window title was not expressive
;  *    enough to be used in the Window menu (or similar text-only
;  *    situation).
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window to set the alternate title.
;  *    
;  *    inTitle:
;  *      The alternate title for the window. Passing NULL for this
;  *      parameter will remove any alternate title that might be present.
;  *  
;  *  Result:
;  *    An operating system status code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CreateStandardWindowMenu" 
      ((inOptions :unsigned-long) (outMenu (:pointer (:handle :menuinfo)))) 
  :osstatus
   () )                                         ; 
;  *  CopyWindowAlternateTitle()
;  *  
;  *  Discussion:
;  *    This API gets the alternate title for a window. See the
;  *    discussion of SetWindowAlternateTitle for more info.
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window to get the alternate title from.
;  *    
;  *    outTitle:
;  *      Receives the alternate title for the window. If the window does
;  *      not have an alternate title, NULL will be returned in outTitle.
;  *  
;  *  Result:
;  *    An operating system status code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetWindowAlternateTitle" 
      ((inWindow (:pointer :windowrecord)) (inTitle :pointer)) 
  :osstatus
   () )                                         ; ;   Misc Low-Level stuff                                                               ; ; $IFC CALL_NOT_IN_CARBON ; 
;  *  InitWindows()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_CopyWindowAlternateTitle" 
      ((inWindow (:pointer :windowrecord)) (outTitle (:pointer :pointer))) 
  :osstatus
   () )
(deftrap "_InitWindows" 
      ()
   nil
   (:stack-trap #xA912))

;   The window manager port does not exist in Carbon.   
;   We are investigating replacement technologies.      
; 
;  *  GetWMgrPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetWMgrPort" 
      ((wPort (:pointer (:pointer :grafport))))
   nil
   (:stack-trap #xA910))

; 
;  *  GetCWMgrPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetCWMgrPort" 
      ((wMgrCPort (:pointer (:pointer :cgrafport))))
   nil
   (:stack-trap #xAA48))

; 
;    Routines available from Mac OS 8.5 forward
;    or from Mac OS 8.1 forward when linking to CarbonLib 1.0 forward
; 
; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  IsValidWindowPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;    Routines available from Mac OS 8.6 forward
;    InitFloatingWindows is not available in Carbon;
;    window ordering is always active for Carbon clients
;                                               ; $IFC CALL_NOT_IN_CARBON ; 
;  *  InitFloatingWindows()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_IsValidWindowPtr" 
      ((possibleWindow (:pointer :windowrecord))) 
  :boolean
   () )                                         ; ;   Various & Sundry Window Accessors                                                  ; 
(deftrap-inline "_InitFloatingWindows" 
      () 
  :osstatus
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; 
;  *  HiliteWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_HiliteWindow" 
      ((window (:pointer :windowrecord)) (fHilite :boolean))
   nil
   (:stack-trap #xA91C))

; 
;  *  SetWRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetWRefCon" 
      ((window (:pointer :windowrecord)) (data :signed-long))
   nil
   (:stack-trap #xA918))

; 
;  *  GetWRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetWRefCon" 
      ((window (:pointer :windowrecord)))
   (:stack :signed-long)
   (:stack-trap #xA917))

; 
;  *  SetWindowPic()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetWindowPic" 
      ((window (:pointer :windowrecord)) (pic (:handle :picture)))
   nil
   (:stack-trap #xA92E))

; 
;  *  GetWindowPic()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetWindowPic" 
      ((window (:pointer :windowrecord)))
   (:stack (:handle :picture))
   (:stack-trap #xA92F))

; 
;  *  GetWVariant()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetWVariant" 
      ((window (:pointer :windowrecord)))
   (:stack :signed-integer)
   (:stack-trap #xA80A))

;   Routines available from Mac OS 8.0 (Appearance 1.0) forward 
; 
;  *  GetWindowFeatures()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetWindowFeatures" 
      ((window (:pointer :windowrecord)) (outFeatures (:pointer :unsigned-long)))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 19 window outFeatures))

; 
;  *  GetWindowRegion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetWindowRegion" 
      ((window (:pointer :windowrecord)) (inRegionCode :unsigned-integer) (ioWinRgn (:handle :macregion)))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 20 window inRegionCode ioWinRgn))

; 
;  *  GetWindowStructureWidths()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; ;   Update Events                                                                      ; ; 
;    These aren't present in Carbon. Please use the InvalWindowRect, etc. routines
;    below instead.
;                                               ; $IFC CALL_NOT_IN_CARBON ; 
;  *  InvalRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetWindowStructureWidths" 
      ((inWindow (:pointer :windowrecord)) (outRect (:pointer :rect))) 
  :osstatus
   () )                                         ; CONST
(deftrap "_InvalRect" 
      ((badRect (:pointer :rect)))
   nil
   (:stack-trap #xA928))

; 
;  *  InvalRgn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_InvalRgn" 
      ((badRgn (:handle :macregion)))
   nil
   (:stack-trap #xA927))

; 
;  *  ValidRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_ValidRect" 
      ((goodRect (:pointer :rect)))
   nil
   (:stack-trap #xA92A))

; 
;  *  ValidRgn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ValidRgn" 
      ((goodRgn (:handle :macregion)))
   nil
   (:stack-trap #xA929))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  BeginUpdate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_BeginUpdate" 
      ((window (:pointer :windowrecord)))
   nil
   (:stack-trap #xA922))

; 
;  *  EndUpdate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_EndUpdate" 
      ((window (:pointer :windowrecord)))
   nil
   (:stack-trap #xA923))

; 
;    Routines available from Mac OS 8.5 forward
;    or from Mac OS 8.1 forward when linking to CarbonLib 1.0 forward
; 

; 
;  *  InvalWindowRgn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  InvalWindowRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InvalWindowRgn" 
      ((window (:pointer :windowrecord)) (region (:handle :macregion))) 
  :osstatus
   () )                                         ; CONST; 
;  *  ValidWindowRgn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InvalWindowRect" 
      ((window (:pointer :windowrecord)) (bounds (:pointer :rect))) 
  :osstatus
   () )                                         ; 
;  *  ValidWindowRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ValidWindowRgn" 
      ((window (:pointer :windowrecord)) (region (:handle :macregion))) 
  :osstatus
   () )                                         ; CONST; ;   DrawGrowIcon                                                                       ;                                                                                       ;   DrawGrowIcon is deprecated from Mac OS 8.0 forward.  Theme-savvy window defprocs    ;   include the grow box in the window frame.                                           ; ; 
;  *  DrawGrowIcon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ValidWindowRect" 
      ((window (:pointer :windowrecord)) (bounds (:pointer :rect))) 
  :osstatus
   () )
(deftrap "_DrawGrowIcon" 
      ((window (:pointer :windowrecord)))
   nil
   (:stack-trap #xA904))

; 
;   Window Titles                                                                      
; 
; 
;  *  SetWTitle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetWTitle" 
      ((window (:pointer :windowrecord)) (title (:string 255)))
   nil
   (:stack-trap #xA91A))

; 
;  *  GetWTitle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetWTitle" 
      ((window (:pointer :windowrecord)) (title (:pointer (:string 255))))
   nil
   (:stack-trap #xA919))

; 
;  *  SetWindowTitleWithCFString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  CopyWindowTitleAsCFString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetWindowTitleWithCFString" 
      ((inWindow (:pointer :windowrecord)) (inString :pointer)) 
  :osstatus
   () )                                         ; ;   Window Proxies                                                                     ; ;   Routines available from Mac OS 8.5 forward ; 
;  *  SetWindowProxyFSSpec()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CopyWindowTitleAsCFString" 
      ((inWindow (:pointer :windowrecord)) (outString (:pointer :pointer))) 
  :osstatus
   () )                                         ; CONST; 
;  *  GetWindowProxyFSSpec()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetWindowProxyFSSpec" 
      ((window (:pointer :windowrecord)) (inFile (:pointer :fsspec))) 
  :osstatus
   () )                                         ; 
;  *  SetWindowProxyAlias()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetWindowProxyFSSpec" 
      ((window (:pointer :windowrecord)) (outFile (:pointer :fsspec))) 
  :osstatus
   () )                                         ; 
;  *  GetWindowProxyAlias()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetWindowProxyAlias" 
      ((window (:pointer :windowrecord)) (alias (:handle :aliasrecord))) 
  :osstatus
   () )                                         ; 
;  *  SetWindowProxyCreatorAndType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetWindowProxyAlias" 
      ((window (:pointer :windowrecord)) (alias (:pointer (:handle :aliasrecord)))) 
  :osstatus
   () )                                         ; 
;  *  GetWindowProxyIcon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetWindowProxyCreatorAndType" 
      ((window (:pointer :windowrecord)) (fileCreator :ostype) (fileType :ostype) (vRefNum :signed-integer)) 
  :osstatus
   () )                                         ; 
;  *  SetWindowProxyIcon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetWindowProxyIcon" 
      ((window (:pointer :windowrecord)) (outIcon (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  RemoveWindowProxy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetWindowProxyIcon" 
      ((window (:pointer :windowrecord)) (icon :pointer)) 
  :osstatus
   () )                                         ; 
;  *  BeginWindowProxyDrag()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_RemoveWindowProxy" 
      ((window (:pointer :windowrecord))) 
  :osstatus
   () )                                         ; 
;  *  EndWindowProxyDrag()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_BeginWindowProxyDrag" 
      ((window (:pointer :windowrecord)) (outNewDrag (:pointer :signed-long)) (outDragOutlineRgn (:handle :macregion))) 
  :osstatus
   () )                                         ; 
;  *  TrackWindowProxyFromExistingDrag()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_EndWindowProxyDrag" 
      ((window (:pointer :windowrecord)) (theDrag :signed-long)) 
  :osstatus
   () )                                         ; 
;  *  TrackWindowProxyDrag()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TrackWindowProxyFromExistingDrag" 
      ((window (:pointer :windowrecord)) (startPt :point) (drag :signed-long) (inDragOutlineRgn (:handle :macregion))) 
  :osstatus
   () )                                         ; 
;  *  IsWindowModified()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TrackWindowProxyDrag" 
      ((window (:pointer :windowrecord)) (startPt :point)) 
  :osstatus
   () )                                         ; 
;  *  SetWindowModified()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IsWindowModified" 
      ((window (:pointer :windowrecord))) 
  :boolean
   () )                                         ; 
;  *  IsWindowPathSelectClick()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetWindowModified" 
      ((window (:pointer :windowrecord)) (modified :boolean)) 
  :osstatus
   () )                                         ; CONST; 
;  *  WindowPathSelect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IsWindowPathSelectClick" 
      ((window (:pointer :windowrecord)) (event (:pointer :eventrecord))) 
  :boolean
   () )                                         ; 
;  *  IsWindowPathSelectEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_WindowPathSelect" 
      ((window (:pointer :windowrecord)) (menu (:handle :menuinfo)) (outMenuResult (:pointer :signed-long))) 
  :osstatus
   () )                                         ; ;    HiliteWindowFrameForDrag                                                          ;                                                                                       ;   If you call ShowDragHilite and HideDragHilite, you dont need to use this routine.  ;   If you implement custom drag hiliting, you should call HiliteWindowFrameForDrag     ;   when the drag is tracking inside a window with drag-hilited content.                ; ;   Routines available from Mac OS 8.5 forward ; 
;  *  HiliteWindowFrameForDrag()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IsWindowPathSelectEvent" 
      ((window (:pointer :windowrecord)) (inEvent :pointer)) 
  :boolean
   () )
(deftrap "_HiliteWindowFrameForDrag" 
      ((window (:pointer :windowrecord)) (hilited :boolean))
   (:stack :osstatus)
   (:stack-trap #xA829 :d0 25 window hilited))

; 
;   Window Transitions                                                                 
;                                                                                       
;   TransitionWindow displays a window with accompanying animation and sound.           
; 

; 
;  *  WindowTransitionEffect
;  *  
;  *  Summary:
;  *    Visual effects that are provided by TransitionWindow
;  

(def-mactype :windowtransitioneffect (find-mactype ':unsigned-long))

(defconstant $kWindowZoomTransitionEffect 1)
(defconstant $kWindowSheetTransitionEffect 2)
(defconstant $kWindowSlideTransitionEffect 3)

; 
; 	 *  WindowTransitionAction
; 	 *  
; 	 *  Summary:
; 	 *    Modifications to window state that are provided by
; 	 *    TransitionWindow
; 	 	

(def-mactype :windowtransitionaction (find-mactype ':unsigned-long))

(defconstant $kWindowShowTransitionAction 1)
(defconstant $kWindowHideTransitionAction 2)
(defconstant $kWindowMoveTransitionAction 3)
(defconstant $kWindowResizeTransitionAction 4)

; 
; 	 *  TransitionWindow()
; 	 *  
; 	 *  Summary:
; 	 *    Shows, hides, moves, or resizes a window with appropriate
; 	 *    animation and sound.
; 	 *  
; 	 *  Parameters:
; 	 *    
; 	 *    inWindow:
; 	 *      The window on which to act.
; 	 *    
; 	 *    inEffect:
; 	 *      The type of visual effect to use. TransitionWindow supports the
; 	 *      Zoom and Slide transition effects. The Slide effect is
; 	 *      supported on Mac OS X and in CarbonLib 1.5 and later.
; 	 *    
; 	 *    inAction:
; 	 *      The action to take on the window. TransitionWindow supports the
; 	 *      Show, Hide, Move, and Resize actions. The Move and Resize
; 	 *      actions are supported on Mac OS X and in CarbonLib 1.5 and
; 	 *      later.
; 	 *    
; 	 *    inRect:
; 	 *      A screen rect in global coordinates. The interpretation of the
; 	 *      rect is dependent on the transition action; see the
; 	 *      documentation for each action for details. May be NULL for some
; 	 *      transition actions.
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in WindowsLib 8.5 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; Const                                         ; 
;  *  TransitionWindowAndParent()
;  *  
;  *  Summary:
;  *    Shows or hides a window, potentially also moving a second window,
;  *    with appropriate animation and sound.
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window on which to act.
;  *    
;  *    inParentWindow:
;  *      The window to which the primary window is related.
;  *    
;  *    inEffect:
;  *      The type of visual effect to use. TransitionWindowAndParent
;  *      supports the Sheet transition effect.
;  *    
;  *    inAction:
;  *      The action to take on the window. TransitionWindowAndParent
;  *      supports the Show and Hide actions.
;  *    
;  *    inRect:
;  *      A screen rect in global coordinates. The interpretation of the
;  *      rect is dependent on the transition action; see the
;  *      documentation for each action for details. May be NULL for some
;  *      transition actions.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TransitionWindow" 
      ((inWindow (:pointer :windowrecord)) (inEffect :unsigned-long) (inAction :unsigned-long) (inRect (:pointer :rect))) 
  :osstatus
   () )                                         ; Const; ;   Window Positioning                                                                 ; ; 
;  *  [Mac]MoveWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_TransitionWindowAndParent" 
      ((inWindow (:pointer :windowrecord)) (inParentWindow (:pointer :windowrecord)) (inEffect :unsigned-long) (inAction :unsigned-long) (inRect (:pointer :rect))) 
  :osstatus
   () )
(deftrap "_MoveWindow" 
      ((window (:pointer :windowrecord)) (hGlobal :signed-integer) (vGlobal :signed-integer) (front :boolean))
   nil
   (:stack-trap #xA91B))

; 
;  *  SizeWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SizeWindow" 
      ((window (:pointer :windowrecord)) (w :signed-integer) (h :signed-integer) (fUpdate :boolean))
   nil
   (:stack-trap #xA91D))

;  Note: bBox can only be NULL when linking to CarbonLib 1.0 forward 
; 
;  *  GrowWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const
(deftrap "_GrowWindow" 
      ((window (:pointer :windowrecord)) (startPt :point) (bBox (:pointer :rect)))
   (:stack :signed-long)
   (:stack-trap #xA92B))

;  Note: boundsRect can only be NULL when linking to CarbonLib 1.0 forward 
; 
;  *  DragWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; Const
(deftrap "_DragWindow" 
      ((window (:pointer :windowrecord)) (startPt :point) (boundsRect (:pointer :rect)))
   nil
   (:stack-trap #xA925))

; 
;  *  ZoomWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ZoomWindow" 
      ((window (:pointer :windowrecord)) (partCode :signed-integer) (front :boolean))
   nil
   (:stack-trap #xA83A))

; 
;   Window Collapsing/Expanding                                                        
; 
;   Routines available from Mac OS 8.0 (Appearance 1.0) forward 
; 
;  *  IsWindowCollapsable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_IsWindowCollapsable" 
      ((window (:pointer :windowrecord)))
   (:stack :boolean)
   (:stack-trap #xAA74 :d0 15 window))

; 
;  *  IsWindowCollapsed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_IsWindowCollapsed" 
      ((window (:pointer :windowrecord)))
   (:stack :boolean)
   (:stack-trap #xAA74 :d0 16 window))

; 
;  *  CollapseWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CollapseWindow" 
      ((window (:pointer :windowrecord)) (collapse :boolean))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 17 window collapse))

; 
;  *  CollapseAllWindows()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppearanceLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CollapseAllWindows" 
      ((collapse :boolean))
   (:stack :osstatus)
   (:stack-trap #xAA74 :d0 18 collapse))

;   Routines available on Mac OS X 

; 
;  *  CreateQDContextForCollapsedWindowDockTile()
;  *  
;  *  Discussion:
;  *    Creates and returns a CGrafPtr for a collapsed window's tile in
;  *    the dock. You can use this port to draw into your window's dock
;  *    tile with Quickdraw. You **MUST** call
;  *    ReleaseQDContextForCollapsedWindowDockTile and NOT DisposePort
;  *    when using this API, as it maintains more state than just the
;  *    port. If you call DisposePort, you may leak system resources.
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window to create the dock tile port for. If this window is
;  *      not collapsed, an error is returned.
;  *    
;  *    outContext:
;  *      The Quickdraw port for you to use to draw into. If you wish to
;  *      use CoreGraphics (Quartz) drawing, call CreateCGContextForPort
;  *      with this port to obtain a CGContext.
;  *  
;  *  Result:
;  *    An operating system result code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CreateQDContextForCollapsedWindowDockTile" 
      ((inWindow (:pointer :windowrecord)) (outContext (:pointer (:pointer :cgrafport)))) 
  :osstatus
   () )

; 
;  *  ReleaseQDContextForCollapsedWindowDockTile()
;  *  
;  *  Discussion:
;  *    Releases a port and other state created by the
;  *    CreateQDContextForCollapsedWindowDockTile API. You MUST call this
;  *    instead of DisposePort directly, or you may leak system resources.
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window you created the port for. If this window is not
;  *      collapsed, an error is returned.
;  *    
;  *    inContext:
;  *      The Quickdraw context to dispose.
;  *  
;  *  Result:
;  *    An operating system result code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ReleaseQDContextForCollapsedWindowDockTile" 
      ((inWindow (:pointer :windowrecord)) (inContext (:pointer :cgrafport))) 
  :osstatus
   () )

; 
;  *  UpdateCollapsedWindowDockTile()
;  *  
;  *  Discussion:
;  *    Automatically updates the image of a particular window in the
;  *    dock to the current contents of the window. Use this for periodic
;  *    updates, etc. Do not use this for animation purposes, if you want
;  *    animation, use the above create/release drawing context APIs.
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window to update the dock tile for. If this window is not
;  *      collapsed, an error is returned.
;  *  
;  *  Result:
;  *    An operating system result code.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available in CarbonLib 1.x, is available on Mac OS X version 10.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_UpdateCollapsedWindowDockTile" 
      ((inWindow (:pointer :windowrecord))) 
  :osstatus
   () )

; 
;    Routines available from Mac OS 8.5 forward
;    or from Mac OS 8.1 forward when linking to CarbonLib 1.0 forward
; 

; 
;  *  GetWindowBounds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  Note: newContentRect can only be NULL when linking to CarbonLib 1.0 forward ; 
;  *  ResizeWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetWindowBounds" 
      ((window (:pointer :windowrecord)) (regionCode :unsigned-integer) (globalBounds (:pointer :rect))) 
  :osstatus
   () )                                         ; Const; 
;    Routines available from Mac OS 8.5 forward,
;    or from Mac OS 8.1 forward when linking to CarbonLib 1.0.2 forward
;                                               ; 
;  *  SetWindowBounds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ResizeWindow" 
      ((window (:pointer :windowrecord)) (startPoint :point) (sizeConstraints (:pointer :rect)) (newContentRect (:pointer :rect))) 
  :boolean
   () )                                         ; CONST;   Routines available from Mac OS 8.5 forward ; 
;  *  RepositionWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetWindowBounds" 
      ((window (:pointer :windowrecord)) (regionCode :unsigned-integer) (globalBounds (:pointer :rect))) 
  :osstatus
   () )                                         ; 
;  *  MoveWindowStructure()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_RepositionWindow" 
      ((window (:pointer :windowrecord)) (parentWindow (:pointer :windowrecord)) (method :unsigned-long)) 
  :osstatus
   () )                                         ; 
;    Routines available from Mac OS 8.5 forward,
;    or from Mac OS 8.6 forward when linking to CarbonLib 1.1 forward
;                                               ; 
;  *  IsWindowInStandardState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_MoveWindowStructure" 
      ((window (:pointer :windowrecord)) (hGlobal :signed-integer) (vGlobal :signed-integer)) 
  :osstatus
   () )                                         ; 
;  *  ZoomWindowIdeal()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IsWindowInStandardState" 
      ((window (:pointer :windowrecord)) (idealSize (:pointer :point)) (idealStandardState (:pointer :rect))) 
  :boolean
   () )                                         ; 
;  *  GetWindowIdealUserState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ZoomWindowIdeal" 
      ((window (:pointer :windowrecord)) (partCode :signed-integer) (ioIdealSize (:pointer :point))) 
  :osstatus
   () )                                         ; 
;  *  SetWindowIdealUserState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetWindowIdealUserState" 
      ((window (:pointer :windowrecord)) (userState (:pointer :rect))) 
  :osstatus
   () )                                         ; CONST;   Routines available in CarbonLib 1.1 and later ; 
;  *  GetWindowGreatestAreaDevice()
;  *  
;  *  Summary:
;  *    Returns the graphics device with the greatest area of
;  *    intersection with a specified window region.
;  *  
;  *  Parameters:
;  *    
;  *    inWindow:
;  *      The window to compare against.
;  *    
;  *    inRegion:
;  *      The window region to compare against.
;  *    
;  *    outGreatestDevice:
;  *      On exit, the graphics device with the greatest intersection.
;  *      May be NULL.
;  *    
;  *    outGreatestDeviceRect:
;  *      On exit, the bounds of the graphics device with the greatest
;  *      intersection. May be NULL. If the device with the greatest
;  *      intersection also contains the menu bar, the device rect will
;  *      exclude the menu bar area.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetWindowIdealUserState" 
      ((window (:pointer :windowrecord)) (userState (:pointer :rect))) 
  :osstatus
   () )                                         ; 
;  *  WindowConstrainOptions
;  *  
;  
(deftrap-inline "_GetWindowGreatestAreaDevice" 
      ((inWindow (:pointer :windowrecord)) (inRegion :unsigned-integer) (outGreatestDevice (:pointer (:handle :gdevice))) (outGreatestDeviceRect (:pointer :rect))) 
  :osstatus
   () )
(def-mactype :windowconstrainoptions (find-mactype ':unsigned-long))

(defconstant $kWindowConstrainMayResize #x1)
(defconstant $kWindowConstrainMoveRegardlessOfFit #x2)
(defconstant $kWindowConstrainAllowPartial #x4)
(defconstant $kWindowConstrainCalcOnly #x8)
(defconstant $kWindowConstrainUseTransitionWindow #x10)
(defconstant $kWindowConstrainStandardOptions #x2)

; 
; 	 *  ConstrainWindowToScreen()
; 	 *  
; 	 *  Summary:
; 	 *    Moves and resizes a window so that it's contained entirely on a
; 	 *    single screen.
; 	 *  
; 	 *  Parameters:
; 	 *    
; 	 *    inWindowRef:
; 	 *      The window to constrain.
; 	 *    
; 	 *    inRegionCode:
; 	 *      The window region to constrain.
; 	 *    
; 	 *    inOptions:
; 	 *      Flags controlling how the window is constrained.
; 	 *    
; 	 *    inScreenRect:
; 	 *      A rectangle, in global coordinates, in which to constrain the
; 	 *      window. May be NULL. If NULL, the window is constrained to the
; 	 *      screen with the greatest intersection with the specified window
; 	 *      region.
; 	 *    
; 	 *    outStructure:
; 	 *      On exit, contains the new structure bounds of the window, in
; 	 *      global coordinates. May be NULL.
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; Const                                         ; 
;  *  GetAvailableWindowPositioningBounds()
;  *  
;  *  Summary:
;  *    Returns the available window positioning bounds on the given
;  *    screen (i.e., the screen rect minus the MenuBar and Dock if
;  *    located on that screen).
;  *  
;  *  Parameters:
;  *    
;  *    inDevice:
;  *      The device for which to find the available bounds.
;  *    
;  *    availableRect:
;  *      On exit, contains the available bounds for the given device.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ConstrainWindowToScreen" 
      ((inWindowRef (:pointer :windowrecord)) (inRegionCode :unsigned-integer) (inOptions :unsigned-long) (inScreenRect (:pointer :rect)) (outStructure (:pointer :rect))) 
  :osstatus
   () )                                         ; ;   Window Visibility                                                                  ; ; 
;  *  HideWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetAvailableWindowPositioningBounds" 
      ((inDevice (:handle :gdevice)) (availableRect (:pointer :rect))) 
  :osstatus
   () )
(deftrap "_HideWindow" 
      ((window (:pointer :windowrecord)))
   nil
   (:stack-trap #xA916))

; 
;  *  [Mac]ShowWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ShowWindow" 
      ((window (:pointer :windowrecord)))
   nil
   (:stack-trap #xA915))

; 
;  *  ShowHide()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ShowHide" 
      ((window (:pointer :windowrecord)) (showFlag :boolean))
   nil
   (:stack-trap #xA908))

; 
;  *  [Mac]IsWindowVisible()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;   
;     Latent window visibility
;   
;                                               ; 
;  *  WindowLatentVisibility
;  *  
;  *  Summary:
;  *    Reasons why a window is currently invisible when ordinarily it
;  *    would be visible.
;  
(deftrap-inline "_IsWindowVisible" 
      ((window (:pointer :windowrecord))) 
  :boolean
   () )
(def-mactype :windowlatentvisibility (find-mactype ':unsigned-long))

(defconstant $kWindowLatentVisibleFloater #x1)
(defconstant $kWindowLatentVisibleSuspend #x2)
(defconstant $kWindowLatentVisibleFullScreen #x4)
(defconstant $kWindowLatentVisibleAppHidden #x8)
(defconstant $kWindowLatentVisibleCollapsedOwner #x10)
(defconstant $kWindowLatentVisibleCollapsedGroup #x20)

; 
; 	 *  IsWindowLatentVisible()
; 	 *  
; 	 *  Summary:
; 	 *    Indicates whether a window is visible onscreen and also whether
; 	 *    it is latently visible but not currently onscreen.
; 	 *  
; 	 *  Discussion:
; 	 *    All windows are either onscreen or offscreen. A window that is
; 	 *    offscreen may still be latently visible; this occurs, for
; 	 *    example, when a floating window is hidden as an application is
; 	 *    suspended. The floating window is not visible onscreen, but it is
; 	 *    latently visible and is only hidden due to the suspended state of
; 	 *    the application; when the application becomes active again, the
; 	 *    floating window will be placed back onscreen.
; 	 *    IsWindowLatentVisible may be used to determine both the window's
; 	 *    onscreen/offscreen status and its latent visibility (if the
; 	 *    window is offscreen).
; 	 *  
; 	 *  Parameters:
; 	 *    
; 	 *    inWindow:
; 	 *      The window whose visibility to return.
; 	 *    
; 	 *    outLatentVisible:
; 	 *      If the window is onscreen, the latent visibility is zero. If
; 	 *      the window is offscreen, this parameter is used to return the
; 	 *      latent visibility flags of the window. If any of the flags are
; 	 *      set, then the window is latently visible.
; 	 *  
; 	 *  Result:
; 	 *    Indicates whether the window is currently onscreen.
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.5 and later
; 	 *    Mac OS X:         in version 10.1 and later
; 	 	

(deftrap-inline "_IsWindowLatentVisible" 
      ((inWindow (:pointer :windowrecord)) (outLatentVisible (:pointer :unsigned-long))) 
  :boolean
   () )

; 
; 
;      Sheets
;     
;     Sheets are a new user interface object in Mac OS X. A sheet is a modal alert or dialog,
;     but unlike a traditional alert or dialog window (which is visually separate from the
;     frontmost document window), a sheet appears to be attached to its parent window; it
;     moves and z-orders simultaneously with its parent. Furthermore, sheets on Mac OS X
;     use a new type of modality called window modality. A traditional alert or dialog is
;     app-modal; it prevents user interaction with all other windows in the current application.
;     A sheet is window-modal; it only prevents user interaction with its parent window, and
;     events continue to flow to other windows in the application.
;     
;      Sheet Event Handling
;     
;     Implementing a sheet window in your application generally requires some modifications
;     to your event-handling code. A traditional app-modal window is implemented using a modal
;     event loop; your application starts a new event loop (either by processing events itself,
;     or by calling ModalDialog), which does not return back to your application's main event
;     loop until the app-modal window has closed.
;     
;     Starting a new event loop doesn't work with sheets, because typically the modal event loop
;     will only handle events destined for the sheet, and not events for other windows, but
;     a sheet only blocks events for its parent window, and your application must still handle
;     events for the rest of its windows as normal. Therefore, you will usually not use a modal
;     event loop to handle events in a sheet. Rather, you will show the sheet window, and then
;     return directly back to your main event loop. The Carbon Event Manager automatically 
;     prevents events in the sheet's parent window from reaching it; events in your application's
;     other windows are still returned to you via WaitNextEvent or your application's Carbon
;     event handlers, where you can process them as normal.
;     
;     You have several choices for handling events in the sheet itself. A sheet is, at the most
;     basic level, simply another window in your application, and you can use any of the standard
;     event-handling APIs to receive events in the sheet. For example, you can:
;     
;         -   receive events in the sheet via WaitNextEvent, and handle them directly in your
;             main event loop
;             
;         -   create the sheet using Dialog Manager APIs, and use IsDialogEvent and DialogSelect
;             to handle events in the sheet
;             
;         -   install Carbon event handlers on the sheet, and respond to events in your handlers
;     
;     Which approach you choose is up to you.
;     
;      Sheets in CarbonLib
;     
;     The sheet window class, sheet WDEF procIDs, and ShowSheetWindow, HideSheetWindow, and
;     GetSheetWindowParent APIs are implemented in CarbonLib starting with version 1.3. However,
;     since Mac OS 8 and 9 do not traditionally support a window-modal user interface, sheet
;     windows are displayed as app-modal windows by CarbonLib. From your application's perspective,
;     event handling for a sheet in CarbonLib is the same as event handling for a sheet on X;
;     ShowSheetWindow still returns immediately, and your application should still return back
;     to its main event loop and be prepared to handle events in other windows. On CarbonLib,
;     your application will simply never receive an user input in any of your other windows;
;     since the sheet has application modality, the Carbon Event Manager will discard events
;     in any windows other than the sheet.
;     
;     Creating a Sheet
;     
;     A sheet is just a normal window with a special window class: kSheetWindowClass or
;     kSheetAlertWindowClass. As such, it can be created in any of the ways you might create
;     a window: NewWindow, NewCWindow, CreateNewWindow, GetNewWindow, GetNewCWindow, 
;     CreateWindowFromCollection, CreateWindowFromResource, CreateWindowFromNib, NewDialog
; 
;  *  ShowSheetWindow()
;  *  
;  *  Summary:
;  *    Shows a sheet window using appropriate visual effects.
;  *  
;  *  Discussion:
;  *    ShowSheetWindow is implemented in both CarbonLib 1.3 and Mac OS
;  *    X. Since Mac OS 9 does not use a window-modal user interface for
;  *    alerts and dialogs, ShowSheetWindow in CarbonLib does not bind
;  *    the sheet to the parent window in the same way that it does on
;  *    Mac OS X; instead, it shows the sheet like a standard
;  *    movable-modal dialog window. Sheet windows must use the window
;  *    classes kSheetWindowClass or kSheetAlertWindowClass to get the
;  *    right appearance on both platforms.
;  *  
;  *  Parameters:
;  *    
;  *    inSheet:
;  *      The sheet window to show.
;  *    
;  *    inParentWindow:
;  *      The sheet's parent window.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  HideSheetWindow()
;  *  
;  *  Summary:
;  *    Hides a sheet window using appropriate visual effects.
;  *  
;  *  Parameters:
;  *    
;  *    inSheet:
;  *      The sheet window to hide.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ShowSheetWindow" 
      ((inSheet (:pointer :windowrecord)) (inParentWindow (:pointer :windowrecord))) 
  :osstatus
   () )                                         ; 
;  *  GetSheetWindowParent()
;  *  
;  *  Summary:
;  *    Returns the parent window of a sheet.
;  *  
;  *  Parameters:
;  *    
;  *    inSheet:
;  *      The sheet window whose parent to retrieve.
;  *    
;  *    outParentWindow:
;  *      On exit, contains the parent window of the sheet.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_HideSheetWindow" 
      ((inSheet (:pointer :windowrecord))) 
  :osstatus
   () )                                         ; ;   Disabling Screen Redraw                                                            ; ; 
;    disable and enable screen updates for changes to the current applications windows
;    (OS X only for now)
;                                               ; 
;  *  DisableScreenUpdates()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetSheetWindowParent" 
      ((inSheet (:pointer :windowrecord)) (outParentWindow (:pointer (:pointer :windowrecord)))) 
  :osstatus
   () )                                         ; 
;  *  EnableScreenUpdates()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DisableScreenUpdates" 
      () 
  :osstatus
   () )                                         ; ;   Window Properties                                                                  ; ; 
;    Routines available from Mac OS 8.5 forward
;    or from Mac OS 8.1 forward when linking to CarbonLib 1.0 forward
;                                               ; 
;  *  GetWindowProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_EnableScreenUpdates" 
      () 
  :osstatus
   () )                                         ; 
;  *  GetWindowPropertySize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetWindowProperty" 
      ((window (:pointer :windowrecord)) (PropertyCreator :ostype) (PropertyTag :ostype) (bufferSize :unsigned-long) (actualSize (:pointer :unsigned-long)) (propertyBuffer :pointer)) 
  :osstatus
   () )                                         ; 
;  *  SetWindowProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetWindowPropertySize" 
      ((window (:pointer :windowrecord)) (creator :ostype) (tag :ostype) (size (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  RemoveWindowProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in WindowsLib 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetWindowProperty" 
      ((window (:pointer :windowrecord)) (PropertyCreator :ostype) (PropertyTag :ostype) (propertySize :unsigned-long) (propertyBuffer :pointer)) 
  :osstatus
   () )                                         ;   Routines available from Mac OS 8.1 forward when linking to CarbonLib 1.0 forward 
(deftrap-inline "_RemoveWindowProperty" 
      ((window (:pointer :windowrecord)) (PropertyCreator :ostype) (PropertyTag :ostype)) 
  :osstatus
   () )
(defconstant $kWindowPropertyPersistent #x1)    ;   whether this property gets saved when flattening the window  

; 
; 	 *  GetWindowPropertyAttributes()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;  *  ChangeWindowPropertyAttributes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetWindowPropertyAttributes" 
      ((window (:pointer :windowrecord)) (propertyCreator :ostype) (propertyTag :ostype) (attributes (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; ;   Utilities                                                                          ; ; 
;  *  PinRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_ChangeWindowPropertyAttributes" 
      ((window (:pointer :windowrecord)) (propertyCreator :ostype) (propertyTag :ostype) (attributesToSet :unsigned-long) (attributesToClear :unsigned-long)) 
  :osstatus
   () )                                         ; CONST
(deftrap "_PinRect" 
      ((theRect (:pointer :rect)) (thePt :point))
   (:stack :signed-long)
   (:stack-trap #xA94E))

; 
;  *  GetGrayRgn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetGrayRgn" 
      ()
   (:no-trap (:handle :macregion))
   (:no-trap (%get-ptr (%int-to-ptr 2542))))

; 
;   Window Part Tracking                                                               
; 
; 
;  *  TrackBox()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TrackBox" 
      ((window (:pointer :windowrecord)) (thePt :point) (partCode :signed-integer))
   (:stack :boolean)
   (:stack-trap #xA83B))

; 
;  *  TrackGoAway()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TrackGoAway" 
      ((window (:pointer :windowrecord)) (thePt :point))
   (:stack :boolean)
   (:stack-trap #xA91E))

; 
;   Region Dragging                                                                    
; 
; 
;  *  DragGrayRgn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap "_DragGrayRgn" 
      ((theRgn (:handle :macregion)) (startPt :point) (limitRect (:pointer :rect)) (slopRect (:pointer :rect)) (axis :signed-integer) (actionProc :pointer))
   (:stack :signed-long)
   (:stack-trap #xA905))

; 
;  *  DragTheRgn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST
(deftrap "_DragTheRgn" 
      ((theRgn (:handle :macregion)) (startPt :point) (limitRect (:pointer :rect)) (slopRect (:pointer :rect)) (axis :signed-integer) (actionProc :pointer))
   (:stack :signed-long)
   (:stack-trap #xA926))

; 
;    GetAuxWin                                                                         
;                                                                                       
;   GetAuxWin is not available in Carbon                                                
; 
; $IFC NOT OPAQUE_TOOLBOX_STRUCTS 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  GetAuxWin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetAuxWin" 
      ((window (:pointer :windowrecord)) (awHndl (:pointer (:handle :auxwinrec))))
   (:stack :boolean)
   (:stack-trap #xAA42))

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC

; 
;   Window Accessors                                                                   
; 

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  GetWindowGoAwayFlag()
;  *  
;  *  Discussion:
;  *    use GetWindowAttributes in Carbon
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later or as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  GetWindowSpareFlag()
;  *  
;  *  Discussion:
;  *    use GetWindowAttributes in Carbon
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later or as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetWindowGoAwayFlag" 
      ((window (:pointer :windowrecord))) 
  :boolean
   () )
(deftrap-inline "_GetWindowSpareFlag" 
      ((window (:pointer :windowrecord))) 
  :boolean
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; 
;  *  GetWindowList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0.2 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  GetWindowPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetWindowList" 
      () 
  (:pointer :windowrecord)
   () )                                         ; 
;  *  GetWindowStructurePort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.1 and later
;  
(deftrap-inline "_GetWindowPort" 
      ((window (:pointer :windowrecord))) 
  (:pointer :cgrafport)
   () )                                         ; 
;  *  GetWindowKind()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetWindowStructurePort" 
      ((inWindow (:pointer :windowrecord))) 
  (:pointer :cgrafport)
   () )                                         ; 
;  *  IsWindowHilited()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetWindowKind" 
      ((window (:pointer :windowrecord))) 
  :signed-integer
   () )                                         ; 
;  *  IsWindowUpdatePending()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IsWindowHilited" 
      ((window (:pointer :windowrecord))) 
  :boolean
   () )                                         ; 
;  *  [Mac]GetNextWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0.2 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IsWindowUpdatePending" 
      ((window (:pointer :windowrecord))) 
  :boolean
   () )                                         ; 
;  *  GetWindowStandardState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetNextWindow" 
      ((window (:pointer :windowrecord))) 
  (:pointer :windowrecord)
   () )                                         ; 
;  *  GetWindowUserState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetWindowStandardState" 
      ((window (:pointer :windowrecord)) (Rect (:pointer :rect))) 
  (:pointer :rect)
   () )                                         ; 
;  *  SetWindowKind()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetWindowUserState" 
      ((window (:pointer :windowrecord)) (Rect (:pointer :rect))) 
  (:pointer :rect)
   () )                                         ; 
;  *  SetWindowStandardState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetWindowKind" 
      ((window (:pointer :windowrecord)) (kind :signed-integer)) 
  nil
   () )                                         ; CONST; 
;  *  SetWindowUserState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetWindowStandardState" 
      ((window (:pointer :windowrecord)) (Rect (:pointer :rect))) 
  nil
   () )                                         ; CONST; 
;  *  SetPortWindowPort()
;  *  
;  *  Discussion:
;  *    set the current QuickDraw port to the port associated with the
;  *    window
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetWindowUserState" 
      ((window (:pointer :windowrecord)) (Rect (:pointer :rect))) 
  nil
   () )                                         ; 
;  *  GetWindowPortBounds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetPortWindowPort" 
      ((window (:pointer :windowrecord))) 
  nil
   () )                                         ; 
;  *  GetWindowFromPort()
;  *  
;  *  Discussion:
;  *    Needed to cast up to a WindowRef from a GrafPtr
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0 and later or as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetWindowPortBounds" 
      ((window (:pointer :windowrecord)) (bounds (:pointer :rect))) 
  (:pointer :rect)
   () )                                         ;   old accessors ; $IFC CALL_NOT_IN_CARBON ; 
;  *  GetWindowDataHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetWindowFromPort" 
      ((port (:pointer :cgrafport))) 
  (:pointer :windowrecord)
   () )
(deftrap-inline "_GetWindowDataHandle" 
      ((window (:pointer :windowrecord))) 
  :handle
   () )

; 
;  *  SetWindowDataHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SetWindowDataHandle" 
      ((window (:pointer :windowrecord)) (data :handle)) 
  nil
   () )

; 
;  *  GetWindowZoomFlag()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetWindowZoomFlag" 
      ((window (:pointer :windowrecord))) 
  :boolean
   () )

; 
;  *  GetWindowStructureRgn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetWindowStructureRgn" 
      ((window (:pointer :windowrecord)) (r (:handle :macregion))) 
  nil
   () )

; 
;  *  GetWindowContentRgn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetWindowContentRgn" 
      ((window (:pointer :windowrecord)) (r (:handle :macregion))) 
  nil
   () )

; 
;  *  GetWindowUpdateRgn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetWindowUpdateRgn" 
      ((window (:pointer :windowrecord)) (r (:handle :macregion))) 
  nil
   () )

; 
;  *  GetWindowTitleWidth()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetWindowTitleWidth" 
      ((window (:pointer :windowrecord))) 
  :signed-integer
   () )

; 
;  Obsolete symbolic names                                                                          
; 
; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $kWindowGroupAttrSelectable #x1)
(defconstant $kWindowGroupAttrPositionFixed #x2)
(defconstant $kWindowGroupAttrZOrderFixed #x4)

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := MacWindowsIncludes

; $ENDC                                         ; __MACWINDOWS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'MacWindows)