(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:NameRegistry.p"
; at Wednesday May 1,2002 2:40:00 pm.
; 
;      File:       NameRegistry.p
;  
;      Contains:   NameRegistry Interfaces
;  
;      Version:    Technology: MacOS
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1993-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __NAMEREGISTRY__
; $SETC __NAMEREGISTRY__ := 1

; $I+
; $SETC NameRegistryIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

; ******************************************************************************
;  * 
;  * Foundation Types
;  *
;  
;  Value of a property 

(def-mactype :regpropertyvalue (find-mactype ':pointer))
; 	 Length of property value 	
(def-mactype :regpropertyvaluesize (find-mactype ':unsigned-long))
; 	******************************************************************************
; 	 * 
; 	 * RegEntryID   :   The Global x-Namespace Entry Identifier
; 	 *
; 	 	
(def-mactype :regentryidptr (find-mactype '(:pointer :regentryid)))
(defrecord RegEntryID 
   (contents (:array :unsigned-long 4))
   )

; 	******************************************************************************
; 	 *
; 	 * Root Entry Name Definitions  (Applies to all Names in the RootNameSpace)
; 	 *
; 	 *   Names are a colon-separated list of name components.  Name components
; 	 *    may not themselves contain colons.  
; 	 *   Names are presented as null-terminated ASCII character strings.
; 	 *   Names follow similar parsing rules to Apple file system absolute
; 	 *    and relative paths.  However the '::' parent directory syntax is
; 	 *    not currently supported.
; 	 	
; 	 Max length of Entry Name 	

(defconstant $kRegCStrMaxEntryNameLength 47)

; 	 Entry Names are single byte ASCII 	

(def-mactype :regcstrentryname (find-mactype ':character))
(def-mactype :regcstrentrynameptr (find-mactype '(:pointer :character)))
;   length of RegCStrEntryNameBuf =  kRegCStrMaxEntryNameLength+1 
(defrecord RegCStrEntryNameBuf (array (:array :character 48 :packed)))
(def-mactype :regcstrpathname (find-mactype ':character))
(def-mactype :regpathnamesize (find-mactype ':unsigned-long))

(defconstant $kRegPathNameSeparator 58)         ;   0x3A  
(defconstant $kRegEntryNameTerminator #x0)      ;   '\0'  
(defconstant $kRegPathNameTerminator #x0)       ;   '\0'  

; 	******************************************************************************
; 	 *
; 	 * Property Name and ID Definitions
; 	 *  (Applies to all Properties Regardless of NameSpace)
; 	 	
(defconstant $kRegMaximumPropertyNameLength 31) ;   Max length of Property Name  
(defconstant $kRegPropertyNameTerminator #x0)   ;   '\0'  

(defrecord RegPropertyNameBuf (array (:array :character 32 :packed)))
(def-mactype :regpropertyname (find-mactype ':character))
(def-mactype :regpropertynameptr (find-mactype '(:pointer :character)))
; 	******************************************************************************
; 	 *
; 	 * Iteration Operations
; 	 *
; 	 *  These specify direction when traversing the name relationships
; 	 	
(def-mactype :regiterationop (find-mactype ':unsigned-long))
(def-mactype :regentryiterationop (find-mactype ':unsigned-long))

;   Absolute locations 
(defconstant $kRegIterRoot #x2)                 ;   "Upward" Relationships  
(defconstant $kRegIterParents #x3)              ;   include all  parent(s) of entry  
;   "Downward" Relationships 
(defconstant $kRegIterChildren #x4)             ;   include all children  
(defconstant $kRegIterSubTrees #x5)             ;   include all sub trees of entry  
(defconstant $kRegIterDescendants #x5)          ;   include all descendants of entry  
;   "Horizontal" Relationships  
(defconstant $kRegIterSibling #x6)              ;   include all siblings  
;   Keep doing the same thing 
(defconstant $kRegIterContinue #x1)

; 	******************************************************************************
; 	 *
; 	 * Name Entry and Property Modifiers
; 	 *
; 	 *
; 	 *
; 	 * Modifiers describe special characteristics of names
; 	 * and properties.  Modifiers might be supported for
; 	 * some names and not others.
; 	 * 
; 	 * Device Drivers should not rely on functionality
; 	 * specified as a modifier.
; 	 	

(def-mactype :regmodifiers (find-mactype ':unsigned-long))
(def-mactype :regentrymodifiers (find-mactype ':unsigned-long))
(def-mactype :regpropertymodifiers (find-mactype ':unsigned-long))

(defconstant $kRegNoModifiers #x0)              ;   no entry modifiers in place  
(defconstant $kRegUniversalModifierMask #xFFFF) ;   mods to all entries  
(defconstant $kRegNameSpaceModifierMask #xFF0000);   mods to all entries within namespace  
(defconstant $kRegModifierMask #xFF000000)      ;   mods to just this entry  

; 	 Universal Property Modifiers 	
(defconstant $kRegPropertyValueIsSavedToNVRAM #x20);   property is non-volatile (saved in NVRAM)  
(defconstant $kRegPropertyValueIsSavedToDisk #x40);   property is non-volatile (saved on disk)  

; 	 NameRegistry version, Gestalt/PEF-style -- MUST BE KEPT IN SYNC WITH MAKEFILE !! 	
(defconstant $LatestNR_PEFVersion #x1030000)    ;   latest NameRegistryLib version (Gestalt/PEF-style)  

; 	 ///////////////////////
; 	//
; 	// The Registry API
; 	//
; 	/////////////////////// 	
; 	 NameRegistry dispatch indexes 	
(defconstant $kSelectRegistryEntryIDInit 0)
(defconstant $kSelectRegistryEntryIDCompare 1)
(defconstant $kSelectRegistryEntryIDCopy 2)
(defconstant $kSelectRegistryEntryIDDispose 3)
(defconstant $kSelectRegistryCStrEntryCreate 4)
(defconstant $kSelectRegistryEntryDelete 5)
(defconstant $kSelectRegistryEntryCopy 6)
(defconstant $kSelectRegistryEntryIterateCreate 7)
(defconstant $kSelectRegistryEntryIterateDispose 8)
(defconstant $kSelectRegistryEntryIterateSet 9)
(defconstant $kSelectRegistryEntryIterate 10)
(defconstant $kSelectRegistryEntrySearch 11)
(defconstant $kSelectRegistryCStrEntryLookup 12)
(defconstant $kSelectRegistryEntryToPathSize 13)
(defconstant $kSelectRegistryCStrEntryToPath 14)
(defconstant $kSelectRegistryCStrEntryToName 15)
(defconstant $kSelectRegistryPropertyCreate 16)
(defconstant $kSelectRegistryPropertyDelete 17)
(defconstant $kSelectRegistryPropertyRename 18)
(defconstant $kSelectRegistryPropertyIterateCreate 19)
(defconstant $kSelectRegistryPropertyIterateDispose 20)
(defconstant $kSelectRegistryPropertyIterate 21)
(defconstant $kSelectRegistryPropertyGetSize 22)
(defconstant $kSelectRegistryPropertyGet 23)
(defconstant $kSelectRegistryPropertySet 24)
(defconstant $kSelectRegistryEntryGetMod 25)
(defconstant $kSelectRegistryEntrySetMod 26)
(defconstant $kSelectRegistryPropertyGetMod 27)
(defconstant $kSelectRegistryPropertySetMod 28)
(defconstant $kSelectRegistryEntryMod 29)
(defconstant $kSelectRegistryEntryPropertyMod 30);   if you add more selectors here, remember to change 'kSelectRegistryHighestSelector' below 
(defconstant $kSelectRegistryHighestSelector 30)

; 	 ///////////////////////
; 	//
; 	// Entry Management
; 	//
; 	/////////////////////// 	

; 	-------------------------------
; 	 * EntryID handling
; 	 	
; 	
; 	 * Initialize an EntryID to a known invalid state
; 	 *   note: invalid != uninitialized
; 	 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  RegistryEntryIDInit()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_RegistryEntryIDInit" 
      ((id (:pointer :regentryid))) 
  :osstatus
   () )
; 
;  * Compare EntryID's for equality or if invalid
;  *
;  * If a NULL value is given for either id1 or id2, the other id 
;  * is compared with an invalid ID.  If both are NULL, the id's 
;  * are consided equal (result = true). 
;  
; 
;  *  RegistryEntryIDCompare()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_RegistryEntryIDCompare" 
      ((id1 (:pointer :regentryid)) (id2 (:pointer :regentryid))) 
  :boolean
   () )
; 
;  * Copy an EntryID
;  
; 
;  *  RegistryEntryIDCopy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_RegistryEntryIDCopy" 
      ((src (:pointer :regentryid)) (dst (:pointer :regentryid))) 
  :osstatus
   () )
; 
;  * Free an ID so it can be reused.
;  
; 
;  *  RegistryEntryIDDispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_RegistryEntryIDDispose" 
      ((id (:pointer :regentryid))) 
  :osstatus
   () )
; -------------------------------
;  * Adding and removing entries
;  *
;  * If (parentEntry) is NULL, the name is assumed
;  * to be a rooted path. It is rooted to an anonymous, unnamed root.
;  
; 
;  *  RegistryCStrEntryCreate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_RegistryCStrEntryCreate" 
      ((parentEntry (:pointer :regentryid)) (name (:pointer :character)) (newEntry (:pointer :regentryid))) 
  :osstatus
   () )
; 
;  *  RegistryEntryDelete()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_RegistryEntryDelete" 
      ((id (:pointer :regentryid))) 
  :osstatus
   () )
; 
;  *  RegistryEntryCopy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_RegistryEntryCopy" 
      ((parentEntryID (:pointer :regentryid)) (sourceDevice (:pointer :regentryid)) (destDevice (:pointer :regentryid))) 
  :osstatus
   () )
; ---------------------------
;  * Traversing the namespace
;  *
;  * To support arbitrary namespace implementations in the future,
;  * I have hidden the form that the place pointer takes.  The previous
;  * interface exposed the place pointer by specifying it as a
;  * RegEntryID.
;  *
;  * I have also removed any notion of returning the entries
;  * in a particular order, because an implementation might
;  * return the names in semi-random order.  Many name service
;  * implementations will store the names in a hashed lookup
;  * table.
;  *
;  * Writing code to traverse some set of names consists of
;  * a call to begin the iteration, the iteration loop, and
;  * a call to end the iteration.  The begin call initializes
;  * the iteration cookie data structure.  The call to end the 
;  * iteration should be called even in the case of error so 
;  * that allocated data structures can be freed.
;  *
;  *  Create(...)
;  *  do (
;  *      Iterate(...);
;  *  ) while (!done);
;  *  Dispose(...);
;  *
;  * This is the basic code structure for callers of the iteration
;  * interface.
;  
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :regentryiter (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :regentryiterptr (find-mactype '(:pointer :pointer)));  when a VAR xx:RegEntryIter parameter can be nil, it is changed to xx: RegEntryIterPtr 
; 	 
; 	 * create/dispose the iterator structure
; 	 *   defaults to root with relationship = kRegIterDescendants
; 	 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  RegistryEntryIterateCreate()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_RegistryEntryIterateCreate" 
      ((cookie (:pointer :pointer))) 
  :osstatus
   () )
; 
;  *  RegistryEntryIterateDispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_RegistryEntryIterateDispose" 
      ((cookie (:pointer :pointer))) 
  :osstatus
   () )
;  
;  * set Entry Iterator to specified entry
;  
; 
;  *  RegistryEntryIterateSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_RegistryEntryIterateSet" 
      ((cookie (:pointer :pointer)) (startEntryID (:pointer :regentryid))) 
  :osstatus
   () )
; 
;  * Return each value of the iteration
;  *
;  * return entries related to the current entry
;  * with the specified relationship
;  
; 
;  *  RegistryEntryIterate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_RegistryEntryIterate" 
      ((cookie (:pointer :pointer)) (relationship :unsigned-long) (foundEntry (:pointer :regentryid)) (done (:pointer :boolean))) 
  :osstatus
   () )
; 
;  * return entries with the specified property
;  *
;  * A NULL RegPropertyValue pointer will return an
;  * entry with the property containing any value.
;  
; 
;  *  RegistryEntrySearch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_RegistryEntrySearch" 
      ((cookie (:pointer :pointer)) (relationship :unsigned-long) (foundEntry (:pointer :regentryid)) (done (:pointer :boolean)) (propertyName (:pointer :character)) (propertyValue :pointer) (propertySize :unsigned-long)) 
  :osstatus
   () )
; --------------------------------
;  * Find a name in the namespace
;  *
;  * This is the fast lookup mechanism.
;  * NOTE:  A reverse lookup mechanism
;  *    has not been provided because
;  *        some name services may not
;  *        provide a fast, general reverse
;  *        lookup.
;  
; 
;  *  RegistryCStrEntryLookup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_RegistryCStrEntryLookup" 
      ((searchPointID (:pointer :regentryid)) (pathName (:pointer :character)) (foundEntry (:pointer :regentryid))) 
  :osstatus
   () )
; ---------------------------------------------
;  * Convert an entry to a rooted name string
;  *
;  * A utility routine to turn an Entry ID
;  * back into a name string.
;  
; 
;  *  RegistryEntryToPathSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_RegistryEntryToPathSize" 
      ((entryID (:pointer :regentryid)) (pathSize (:pointer :unsigned-long))) 
  :osstatus
   () )
; 
;  *  RegistryCStrEntryToPath()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_RegistryCStrEntryToPath" 
      ((entryID (:pointer :regentryid)) (pathName (:pointer :character)) (pathSize :unsigned-long)) 
  :osstatus
   () )
; 
;  * Parse a path name.
;  *
;  * Retrieve the last component of the path, and
;  * return a spec for the parent.
;  
; 
;  *  RegistryCStrEntryToName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_RegistryCStrEntryToName" 
      ((entryID (:pointer :regentryid)) (parentEntry (:pointer :regentryid)) (nameComponent (:pointer :character)) (done (:pointer :boolean))) 
  :osstatus
   () )
;  //////////////////////////////////////////////////////
; //
; // Property Management
; //
; ////////////////////////////////////////////////////// 
; -------------------------------
;  * Adding and removing properties
;  
; 
;  *  RegistryPropertyCreate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_RegistryPropertyCreate" 
      ((entryID (:pointer :regentryid)) (propertyName (:pointer :character)) (propertyValue :pointer) (propertySize :unsigned-long)) 
  :osstatus
   () )
; 
;  *  RegistryPropertyDelete()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_RegistryPropertyDelete" 
      ((entryID (:pointer :regentryid)) (propertyName (:pointer :character))) 
  :osstatus
   () )
; 
;  *  RegistryPropertyRename()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST; CONST
(deftrap-inline "_RegistryPropertyRename" 
      ((entry (:pointer :regentryid)) (oldName (:pointer :character)) (newName (:pointer :character))) 
  :osstatus
   () )
; ---------------------------
;  * Traversing the Properties of a name
;  *
;  
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :regpropertyiter (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :regpropertyiterptr (find-mactype '(:pointer :pointer)));  when a VAR xx:RegPropertyIter parameter can be nil, it is changed to xx: RegPropertyIterPtr 
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  RegistryPropertyIterateCreate()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
; CONST
(deftrap-inline "_RegistryPropertyIterateCreate" 
      ((entry (:pointer :regentryid)) (cookie (:pointer :pointer))) 
  :osstatus
   () )
; 
;  *  RegistryPropertyIterateDispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_RegistryPropertyIterateDispose" 
      ((cookie (:pointer :pointer))) 
  :osstatus
   () )
; 
;  *  RegistryPropertyIterate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_RegistryPropertyIterate" 
      ((cookie (:pointer :pointer)) (foundProperty (:pointer :character)) (done (:pointer :boolean))) 
  :osstatus
   () )
; 
;  * Get the value of the specified property for the specified entry.
;  *
;  
; 
;  *  RegistryPropertyGetSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_RegistryPropertyGetSize" 
      ((entryID (:pointer :regentryid)) (propertyName (:pointer :character)) (propertySize (:pointer :unsigned-long))) 
  :osstatus
   () )
; 
;  * (*propertySize) is the maximum size of the value returned in the buffer
;  * pointed to by (propertyValue).  Upon return, (*propertySize) is the size of the
;  * value returned.
;  
; 
;  *  RegistryPropertyGet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_RegistryPropertyGet" 
      ((entryID (:pointer :regentryid)) (propertyName (:pointer :character)) (propertyValue :pointer) (propertySize (:pointer :unsigned-long))) 
  :osstatus
   () )
; 
;  *  RegistryPropertySet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_RegistryPropertySet" 
      ((entryID (:pointer :regentryid)) (propertyName (:pointer :character)) (propertyValue :pointer) (propertySize :unsigned-long)) 
  :osstatus
   () )
;  //////////////////////////////////////////////////////
; //
; // Modifier Management
; //
; ////////////////////////////////////////////////////// 
; 
;  * Modifiers describe special characteristics of names
;  * and properties.  Modifiers might be supported for
;  * some names and not others.
;  * 
;  * Device Drivers should not rely on functionality
;  * specified as a modifier.  These interfaces
;  * are for use in writing Experts.
;  
; 
;  * Get and Set operators for entry modifiers
;  
; 
;  *  RegistryEntryGetMod()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_RegistryEntryGetMod" 
      ((entry (:pointer :regentryid)) (modifiers (:pointer :unsigned-long))) 
  :osstatus
   () )
; 
;  *  RegistryEntrySetMod()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_RegistryEntrySetMod" 
      ((entry (:pointer :regentryid)) (modifiers :unsigned-long)) 
  :osstatus
   () )
; 
;  * Get and Set operators for property modifiers
;  
; 
;  *  RegistryPropertyGetMod()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_RegistryPropertyGetMod" 
      ((entry (:pointer :regentryid)) (name (:pointer :character)) (modifiers (:pointer :unsigned-long))) 
  :osstatus
   () )
; 
;  *  RegistryPropertySetMod()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_RegistryPropertySetMod" 
      ((entry (:pointer :regentryid)) (name (:pointer :character)) (modifiers :unsigned-long)) 
  :osstatus
   () )
; 
;  * Iterator operator for entry modifier search
;  
; 
;  *  RegistryEntryMod()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_RegistryEntryMod" 
      ((cookie (:pointer :pointer)) (relationship :unsigned-long) (foundEntry (:pointer :regentryid)) (done (:pointer :boolean)) (matchingModifiers :unsigned-long)) 
  :osstatus
   () )
; 
;  * Iterator operator for entries with matching 
;  * property modifiers
;  
; 
;  *  RegistryEntryPropertyMod()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NameRegistryLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_RegistryEntryPropertyMod" 
      ((cookie (:pointer :pointer)) (relationship :unsigned-long) (foundEntry (:pointer :regentryid)) (done (:pointer :boolean)) (matchingModifiers :unsigned-long)) 
  :osstatus
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := NameRegistryIncludes

; $ENDC                                         ; __NAMEREGISTRY__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'NameRegistry)