(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:NetSprocket.p"
; at Wednesday May 1,2002 2:42:09 pm.
; 
;      File:       NetSprocket.p
;  
;      Contains:   Games Sprockets: NetSprocket interfaces
;  
;      Version:    Technology: NetSprocket 1.7
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1996-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __NETSPROCKET__
; $SETC __NETSPROCKET__ := 1

; $I+
; $SETC NetSprocketIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __EVENTS__
|#

(require-interface 'Events)
#|                                              ; $I Events.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __OPENTRANSPORT__
|#

(require-interface 'OpenTransport)
#|                                              ; $I OpenTransport.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __OPENTRANSPORTPROVIDERS__
|#

(require-interface 'OpenTransportProviders)
#|                                              ; $I OpenTransportProviders.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

; $IFC TARGET_OS_MAC 

(defconstant $kNSpMaxPlayerNameLen 31)
(defconstant $kNSpMaxGroupNameLen 31)
(defconstant $kNSpMaxPasswordLen 31)
(defconstant $kNSpMaxGameNameLen 31)
(defconstant $kNSpMaxDefinitionStringLen 255)

; 	 NetSprocket basic types 	

(def-mactype :nspgamereference (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :nspgamereferenceptr (find-mactype '(:pointer :pointer)));  when a VAR xx:NSpGameReference parameter can be nil, it is changed to xx: NSpGameReferencePtr 
(def-mactype :nspprotocolreference (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :nspprotocolreferenceptr (find-mactype '(:pointer :pointer)));  when a VAR xx:NSpProtocolReference parameter can be nil, it is changed to xx: NSpProtocolReferencePtr 
(def-mactype :nspprotocollistreference (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :nspprotocollistreferenceptr (find-mactype '(:pointer :pointer)));  when a VAR xx:NSpProtocolListReference parameter can be nil, it is changed to xx: NSpProtocolListReferencePtr 
(def-mactype :nspaddressreference (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :nspaddressreferenceptr (find-mactype '(:pointer :pointer)));  when a VAR xx:NSpAddressReference parameter can be nil, it is changed to xx: NSpAddressReferencePtr 
(def-mactype :nspeventcode (find-mactype ':signed-long))
(def-mactype :nspgameid (find-mactype ':signed-long))
(def-mactype :nspplayerid (find-mactype ':signed-long))
(def-mactype :nspgroupid (find-mactype ':signed-long))
(def-mactype :nspplayertype (find-mactype ':unsigned-long))
(def-mactype :nspflags (find-mactype ':signed-long))
(defrecord :NSpPlayerName 
  (length :unsigned-byte)
 (contents (:array :unsigned-byte 31)))
; 	 Individual player info 	
(def-mactype :nspplayerinfoptr (find-mactype '(:pointer :nspplayerinfo)))
(defrecord NSpPlayerInfo 
   (id :signed-long)
   (playerType :unsigned-long)                  ;   "type" in C 
   (name (:string 31))
   (groupCount :unsigned-long)
   (groups (:array :signed-long 1))
   )

; 	 list of all players 	
(def-mactype :nspplayerenumerationptr (find-mactype '(:pointer :nspplayerenumeration)))
(defrecord NSpPlayerEnumeration 
   (count :unsigned-long)
   (playerInfo (:array (:pointer :nspplayerinfo) 1))
   )

; 	 Individual group info 	
(def-mactype :nspgroupinfoptr (find-mactype '(:pointer :nspgroupinfo)))
(defrecord NSpGroupInfo 
   (id :signed-long)
   (playerCount :unsigned-long)
   (players (:array :signed-long 1))
   )

; 	 List of all groups 	
(def-mactype :nspgroupenumerationptr (find-mactype '(:pointer :nspgroupenumeration)))
(defrecord NSpGroupEnumeration 
   (count :unsigned-long)
   (groups (:array (:pointer :nspgroupinfo) 1))
   )

; 	 Topology types 	
(def-mactype :nsptopology (find-mactype ':unsigned-long))

(defconstant $kNSpClientServer #x1)

; 	 Game information 	

(def-mactype :nspgameinfoptr (find-mactype '(:pointer :nspgameinfo)))
(defrecord NSpGameInfo 
   (maxPlayers :unsigned-long)
   (currentPlayers :unsigned-long)
   (currentGroups :unsigned-long)
   (topology :unsigned-long)
   (reserved :unsigned-long)
   (name (:string 31))
   (password (:string 31))
   )

; 	 Structure used for sending and receiving network messages 	
(def-mactype :nspmessageheaderptr (find-mactype '(:pointer :nspmessageheader)))
(defrecord NSpMessageHeader 
   (version :unsigned-long)                     ;   Used by NetSprocket.  Don't touch this  
   (what :signed-long)                          ;   The kind of message (e.g. player joined)  
   (from :signed-long)                          ;   ID of the sender  
   (toID :signed-long)                          ;   (player or group) id of the intended recipient (was "to)  
   (id :unsigned-long)                          ;   Unique ID for this message & (from) player  
   (when :unsigned-long)                        ;   Timestamp for the message  
   (messageLen :unsigned-long)                  ;   Bytes of data in the entire message (including the header)  
   )

; 	 NetSprocket-defined message structures 	
(def-mactype :nsperrormessageptr (find-mactype '(:pointer :nsperrormessage)))
(defrecord NSpErrorMessage 
   (header :nspmessageheader)
   (error :signed-long)
   )

(def-mactype :nspjoinrequestmessageptr (find-mactype '(:pointer :nspjoinrequestmessage)))
(defrecord NSpJoinRequestMessage 
   (header :nspmessageheader)
   (name (:string 31))
   (password (:string 31))
   (theType :unsigned-long)
   (customDataLen :unsigned-long)
   (customData :signed-byte)
   )

(def-mactype :nspjoinapprovedmessageptr (find-mactype '(:pointer :nspjoinapprovedmessage)))
(defrecord NSpJoinApprovedMessage 
   (header :nspmessageheader)
   )

(def-mactype :nspjoindeniedmessageptr (find-mactype '(:pointer :nspjoindeniedmessage)))
(defrecord NSpJoinDeniedMessage 
   (header :nspmessageheader)
   (reason (:string 255))
   )

(def-mactype :nspplayerjoinedmessageptr (find-mactype '(:pointer :nspplayerjoinedmessage)))
(defrecord NSpPlayerJoinedMessage 
   (header :nspmessageheader)
   (playerCount :unsigned-long)
   (playerInfo :nspplayerinfo)
   )

(def-mactype :nspplayerleftmessageptr (find-mactype '(:pointer :nspplayerleftmessage)))
(defrecord NSpPlayerLeftMessage 
   (header :nspmessageheader)
   (playerCount :unsigned-long)
   (playerID :signed-long)
   (playerName (:string 31))
   )

(def-mactype :nsphostchangedmessageptr (find-mactype '(:pointer :nsphostchangedmessage)))
(defrecord NSpHostChangedMessage 
   (header :nspmessageheader)
   (newHost :signed-long)
   )

(def-mactype :nspgameterminatedmessageptr (find-mactype '(:pointer :nspgameterminatedmessage)))
(defrecord NSpGameTerminatedMessage 
   (header :nspmessageheader)
   )

(def-mactype :nspcreategroupmessageptr (find-mactype '(:pointer :nspcreategroupmessage)))
(defrecord NSpCreateGroupMessage 
   (header :nspmessageheader)
   (groupID :signed-long)
   (requestingPlayer :signed-long)
   )

(def-mactype :nspdeletegroupmessageptr (find-mactype '(:pointer :nspdeletegroupmessage)))
(defrecord NSpDeleteGroupMessage 
   (header :nspmessageheader)
   (groupID :signed-long)
   (requestingPlayer :signed-long)
   )

(def-mactype :nspaddplayertogroupmessageptr (find-mactype '(:pointer :nspaddplayertogroupmessage)))
(defrecord NSpAddPlayerToGroupMessage 
   (header :nspmessageheader)
   (group :signed-long)
   (player :signed-long)
   )

(def-mactype :nspremoveplayerfromgroupmessageptr (find-mactype '(:pointer :nspremoveplayerfromgroupmessage)))
(defrecord NSpRemovePlayerFromGroupMessage 
   (header :nspmessageheader)
   (group :signed-long)
   (player :signed-long)
   )

(def-mactype :nspplayertypechangedmessageptr (find-mactype '(:pointer :nspplayertypechangedmessage)))
(defrecord NSpPlayerTypeChangedMessage 
   (header :nspmessageheader)
   (player :signed-long)
   (newType :unsigned-long)
   )

; 	 Different kinds of messages.  These can NOT be bitwise ORed together 	

(defconstant $kNSpSendFlag_Junk #x100000)       ;   will be sent (try once) when there is nothing else pending  
(defconstant $kNSpSendFlag_Normal #x200000)     ;   will be sent immediately (try once)  
(defconstant $kNSpSendFlag_Registered #x400000) ;   will be sent immediately (guaranteed, in order)  

; 	 Options for message delivery.  These can be bitwise ORed together with each other,
; 	        as well as with ONE of the above 	
(defconstant $kNSpSendFlag_FailIfPipeFull #x1)
(defconstant $kNSpSendFlag_SelfSend #x2)
(defconstant $kNSpSendFlag_Blocking #x4)

; 	 Options for Hosting Joining, and Deleting games 	
(defconstant $kNSpGameFlag_DontAdvertise #x1)
(defconstant $kNSpGameFlag_ForceTerminateGame #x2)

; 	 Message "what" types 	
; 	 Apple reserves all negative "what" values (anything with high bit set) 	
(defconstant $kNSpSystemMessagePrefix #x80000000)
(defconstant $kNSpError #xFFFFFFFF)
(defconstant $kNSpJoinRequest #x80000001)
(defconstant $kNSpJoinApproved #x80000002)
(defconstant $kNSpJoinDenied #x80000003)
(defconstant $kNSpPlayerJoined #x80000004)
(defconstant $kNSpPlayerLeft #x80000005)
(defconstant $kNSpHostChanged #x80000006)
(defconstant $kNSpGameTerminated #x80000007)
(defconstant $kNSpGroupCreated #x80000008)
(defconstant $kNSpGroupDeleted #x80000009)
(defconstant $kNSpPlayerAddedToGroup #x8000000A)
(defconstant $kNSpPlayerRemovedFromGroup #x8000000B)
(defconstant $kNSpPlayerTypeChanged #x8000000C)

; 	 Special TPlayerIDs  for sending messages 	
(defconstant $kNSpAllPlayers #x0)
(defconstant $kNSpHostOnly #xFFFFFFFF)

; 	***********************  Initialization  ***********************	
; 
; 	 *  NSpInitialize()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
; 	 *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_NSpInitialize" 
      ((inStandardMessageSize :unsigned-long) (inBufferSize :unsigned-long) (inQElements :unsigned-long) (inGameID :signed-long) (inTimeout :unsigned-long)) 
  :osstatus
   () )

; *************************  Protocols  *************************
;  Programmatic protocol routines 
; 
;  *  NSpProtocol_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpProtocol_New" 
      ((inDefinitionString :pointer) (outReference (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  NSpProtocol_Dispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpProtocol_Dispose" 
      ((inProtocolRef :pointer)) 
  nil
   () )

; 
;  *  NSpProtocol_ExtractDefinitionString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpProtocol_ExtractDefinitionString" 
      ((inProtocolRef :pointer) (outDefinitionString :pointer)) 
  :osstatus
   () )

;  Protocol list routines 
; 
;  *  NSpProtocolList_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpProtocolList_New" 
      ((inProtocolRef :pointer) (outList (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  NSpProtocolList_Dispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpProtocolList_Dispose" 
      ((inProtocolList :pointer)) 
  nil
   () )

; 
;  *  NSpProtocolList_Append()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpProtocolList_Append" 
      ((inProtocolList :pointer) (inProtocolRef :pointer)) 
  :osstatus
   () )

; 
;  *  NSpProtocolList_Remove()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpProtocolList_Remove" 
      ((inProtocolList :pointer) (inProtocolRef :pointer)) 
  :osstatus
   () )

; 
;  *  NSpProtocolList_RemoveIndexed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpProtocolList_RemoveIndexed" 
      ((inProtocolList :pointer) (inIndex :unsigned-long)) 
  :osstatus
   () )

; 
;  *  NSpProtocolList_GetCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpProtocolList_GetCount" 
      ((inProtocolList :pointer)) 
  :unsigned-long
   () )

; 
;  *  NSpProtocolList_GetIndexedRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpProtocolList_GetIndexedRef" 
      ((inProtocolList :pointer) (inIndex :unsigned-long)) 
  :pointer
   () )

;  Helpers 
; 
;  *  NSpProtocol_CreateAppleTalk()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpProtocol_CreateAppleTalk" 
      ((inNBPName (:string 31)) (inNBPType (:string 31)) (inMaxRTT :unsigned-long) (inMinThruput :unsigned-long)) 
  :pointer
   () )

; 
;  *  NSpProtocol_CreateIP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpProtocol_CreateIP" 
      ((inPort :unsigned-integer) (inMaxRTT :unsigned-long) (inMinThruput :unsigned-long)) 
  :pointer
   () )

; **********************  Human Interface  ***********************

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	NSpEventProcPtr = FUNCTION(VAR inEvent: EventRecord): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :nspeventprocptr (find-mactype ':pointer))
; $ENDC

; 
; 	 *  NSpDoModalJoinDialog()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
; 	 *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_NSpDoModalJoinDialog" 
      ((inGameType (:string 31)) (inEntityListLabel (:string 255)) (ioName (:pointer (:string 31))) (ioPassword (:pointer (:string 31))) (inEventProcPtr :pointer)) 
  :pointer
   () )

; 
;  *  NSpDoModalHostDialog()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpDoModalHostDialog" 
      ((ioProtocolList :pointer) (ioGameName (:pointer (:string 31))) (ioPlayerName (:pointer (:string 31))) (ioPassword (:pointer (:string 31))) (inEventProcPtr :pointer)) 
  :boolean
   () )

; ********************  Hosting and Joining  *********************
; 
;  *  NSpGame_Host()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpGame_Host" 
      ((outGame (:pointer :pointer)) (inProtocolList :pointer) (inMaxPlayers :unsigned-long) (inGameName (:string 31)) (inPassword (:string 31)) (inPlayerName (:string 31)) (inPlayerType :unsigned-long) (inTopology :unsigned-long) (inFlags :signed-long)) 
  :osstatus
   () )

; 
;  *  NSpGame_Join()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpGame_Join" 
      ((outGame (:pointer :pointer)) (inAddress :pointer) (inName (:string 31)) (inPassword (:string 31)) (inType :unsigned-long) (inCustomData :pointer) (inCustomDataLen :unsigned-long) (inFlags :signed-long)) 
  :osstatus
   () )

; 
;  *  NSpGame_EnableAdvertising()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpGame_EnableAdvertising" 
      ((inGame :pointer) (inProtocol :pointer) (inEnable :boolean)) 
  :osstatus
   () )

; 
;  *  NSpGame_Dispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpGame_Dispose" 
      ((inGame :pointer) (inFlags :signed-long)) 
  :osstatus
   () )

; 
;  *  NSpGame_GetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0.3 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpGame_GetInfo" 
      ((inGame :pointer) (ioInfo (:pointer :nspgameinfo))) 
  :osstatus
   () )

; *************************  Messaging  *************************
; 
;  *  NSpMessage_Send()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpMessage_Send" 
      ((inGame :pointer) (inMessage (:pointer :nspmessageheader)) (inFlags :signed-long)) 
  :osstatus
   () )

; 
;  *  NSpMessage_Get()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpMessage_Get" 
      ((inGame :pointer)) 
  (:pointer :nspmessageheader)
   () )

; 
;  *  NSpMessage_Release()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpMessage_Release" 
      ((inGame :pointer) (inMessage (:pointer :nspmessageheader))) 
  nil
   () )

;  Helpers 
; 
;  *  NSpMessage_SendTo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpMessage_SendTo" 
      ((inGame :pointer) (inTo :signed-long) (inWhat :signed-long) (inData :pointer) (inDataLen :unsigned-long) (inFlags :signed-long)) 
  :osstatus
   () )

; ********************  Player Information  *********************
; 
;  *  NSpPlayer_ChangeType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpPlayer_ChangeType" 
      ((inGame :pointer) (inPlayerID :signed-long) (inNewType :unsigned-long)) 
  :osstatus
   () )

; 
;  *  NSpPlayer_Remove()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpPlayer_Remove" 
      ((inGame :pointer) (inPlayerID :signed-long)) 
  :osstatus
   () )

; 
;  *  NSpPlayer_GetAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpPlayer_GetAddress" 
      ((inGame :pointer) (inPlayerID :signed-long) (outAddress (:pointer :pointer))) 
  :osstatus
   () )

; 
;  *  NSpPlayer_GetMyID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpPlayer_GetMyID" 
      ((inGame :pointer)) 
  :nspplayerid
   () )

; 
;  *  NSpPlayer_GetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpPlayer_GetInfo" 
      ((inGame :pointer) (inPlayerID :signed-long) (outInfo (:pointer (:pointer :nspplayerinfo)))) 
  :osstatus
   () )

; 
;  *  NSpPlayer_ReleaseInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpPlayer_ReleaseInfo" 
      ((inGame :pointer) (inInfo (:pointer :nspplayerinfo))) 
  nil
   () )

; 
;  *  NSpPlayer_GetEnumeration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpPlayer_GetEnumeration" 
      ((inGame :pointer) (outPlayers (:pointer (:pointer :nspplayerenumeration)))) 
  :osstatus
   () )

; 
;  *  NSpPlayer_ReleaseEnumeration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpPlayer_ReleaseEnumeration" 
      ((inGame :pointer) (inPlayers (:pointer :nspplayerenumeration))) 
  nil
   () )

; 
;  *  NSpPlayer_GetRoundTripTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpPlayer_GetRoundTripTime" 
      ((inGame :pointer) (inPlayer :signed-long)) 
  :unsigned-long
   () )

; 
;  *  NSpPlayer_GetThruput()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpPlayer_GetThruput" 
      ((inGame :pointer) (inPlayer :signed-long)) 
  :unsigned-long
   () )

; ********************  Group Management  *********************
; 
;  *  NSpGroup_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpGroup_New" 
      ((inGame :pointer) (outGroupID (:pointer :signed-long))) 
  :osstatus
   () )

; 
;  *  NSpGroup_Dispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpGroup_Dispose" 
      ((inGame :pointer) (inGroupID :signed-long)) 
  :osstatus
   () )

; 
;  *  NSpGroup_AddPlayer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpGroup_AddPlayer" 
      ((inGame :pointer) (inGroupID :signed-long) (inPlayerID :signed-long)) 
  :osstatus
   () )

; 
;  *  NSpGroup_RemovePlayer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpGroup_RemovePlayer" 
      ((inGame :pointer) (inGroupID :signed-long) (inPlayerID :signed-long)) 
  :osstatus
   () )

; 
;  *  NSpGroup_GetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpGroup_GetInfo" 
      ((inGame :pointer) (inGroupID :signed-long) (outInfo (:pointer (:pointer :nspgroupinfo)))) 
  :osstatus
   () )

; 
;  *  NSpGroup_ReleaseInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpGroup_ReleaseInfo" 
      ((inGame :pointer) (inInfo (:pointer :nspgroupinfo))) 
  nil
   () )

; 
;  *  NSpGroup_GetEnumeration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpGroup_GetEnumeration" 
      ((inGame :pointer) (outGroups (:pointer (:pointer :nspgroupenumeration)))) 
  :osstatus
   () )

; 
;  *  NSpGroup_ReleaseEnumeration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpGroup_ReleaseEnumeration" 
      ((inGame :pointer) (inGroups (:pointer :nspgroupenumeration))) 
  nil
   () )

; *************************  Utilities  **************************
; 
;  *  NSpGetVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0.3 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpGetVersion" 
      () 
  :numversion
   () )

; 
;  *  NSpSetConnectTimeout()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.7 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpSetConnectTimeout" 
      ((inSeconds :unsigned-long)) 
  nil
   () )

; 
;  *  NSpClearMessageHeader()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpClearMessageHeader" 
      ((inMessage (:pointer :nspmessageheader))) 
  nil
   () )

; 
;  *  NSpGetCurrentTimeStamp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpGetCurrentTimeStamp" 
      ((inGame :pointer)) 
  :unsigned-long
   () )

; 
;  *  NSpConvertOTAddrToAddressReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpConvertOTAddrToAddressReference" 
      ((inAddress (:pointer :otaddress))) 
  :pointer
   () )

; 
;  *  NSpConvertAddressReferenceToOTAddr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpConvertAddressReferenceToOTAddr" 
      ((inAddress :pointer)) 
  (:pointer :otaddress)
   () )

; 
;  *  NSpReleaseAddressReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
;  *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NSpReleaseAddressReference" 
      ((inAddress :pointer)) 
  nil
   () )

; *********************** Advanced/Async routines ***************

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	NSpCallbackProcPtr = PROCEDURE(inGame: NSpGameReference; inContext: UNIV Ptr; inCode: NSpEventCode; inStatus: OSStatus; inCookie: UNIV Ptr);

|#
 |#                                             ; $ELSEC
(def-mactype :nspcallbackprocptr (find-mactype ':pointer))
; $ENDC

; 
; 	 *  NSpInstallCallbackHandler()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
; 	 *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_NSpInstallCallbackHandler" 
      ((inHandler :pointer) (inContext :pointer)) 
  :osstatus
   () )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	NSpJoinRequestHandlerProcPtr = FUNCTION(inGame: NSpGameReference; VAR inMessage: NSpJoinRequestMessage; inContext: UNIV Ptr; VAR outReason: Str255): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :nspjoinrequesthandlerprocptr (find-mactype ':pointer))
; $ENDC

; 
; 	 *  NSpInstallJoinRequestHandler()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
; 	 *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_NSpInstallJoinRequestHandler" 
      ((inHandler :pointer) (inContext :pointer)) 
  :osstatus
   () )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	NSpMessageHandlerProcPtr = FUNCTION(inGame: NSpGameReference; VAR inMessage: NSpMessageHeader; inContext: UNIV Ptr): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :nspmessagehandlerprocptr (find-mactype ':pointer))
; $ENDC

; 
; 	 *  NSpInstallAsyncMessageHandler()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in NetSprocketLib 1.0 and later
; 	 *    CarbonLib:        not in Carbon, but NetSprocketLib is compatible with Carbon
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_NSpInstallAsyncMessageHandler" 
      ((inHandler :pointer) (inContext :pointer)) 
  :osstatus
   () )

; $ENDC                                         ; TARGET_OS_MAC

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := NetSprocketIncludes

; $ENDC                                         ; __NETSPROCKET__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'NetSprocket)