(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Notification.p"
; at Wednesday May 1,2002 2:38:52 pm.
; 
;      File:       Notification.p
;  
;      Contains:   Notification Manager interfaces
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1989-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __NOTIFICATION__
; $SETC __NOTIFICATION__ := 1

; $I+
; $SETC NotificationIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __OSUTILS__
|#

(require-interface 'OSUtils)
#|                                              ; $I OSUtils.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :nmrecptr (find-mactype '(:pointer :nmrec)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	NMProcPtr = PROCEDURE(nmReqPtr: NMRecPtr);

|#
 |#                                             ; $ELSEC
(def-mactype :nmprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :nmupp (find-mactype ':pointer))   ;  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :nmupp (find-mactype ':pointer))
; $ENDC
(defrecord NMRec 
   (qLink (:pointer :qelem))                    ;   next queue entry 
   (qType :signed-integer)                      ;   queue type -- ORD(nmType) = 8 
   (nmFlags :signed-integer)                    ;   reserved 
   (nmPrivate :signed-long)                     ;   reserved 
   (nmReserved :signed-integer)                 ;   reserved 
   (nmMark :signed-integer)                     ;   item to mark in Apple menu 
   (nmIcon :handle)                             ;   handle to small icon 
   (nmSound :handle)                            ;   handle to sound record 
   (nmStr (:pointer (:string 255)))             ;   string to appear in alert 
   (nmResp :pointer)                            ;   pointer to response routine 
   (nmRefCon :signed-long)                      ;   for application use 
   )

(defconstant $uppNMProcInfo #xC0)
; 
; 	 *  NewNMUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewNMProc 
(deftrap "_NewNMUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeNMUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeNMUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeNMUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallNMProc 
(deftrap-inline "_InvokeNMUPP" 
      ((nmReqPtr (:pointer :nmrec)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  NMInstall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_NMInstall" 
      ((nmReqPtr (:pointer :nmrec)))
   (:d0 :signed-integer)
   (:register-trap #xA05E :a0 nmReqPtr))

; 
;  *  NMRemove()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_NMRemove" 
      ((nmReqPtr (:pointer :nmrec)))
   (:d0 :signed-integer)
   (:register-trap #xA05F :a0 nmReqPtr))

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := NotificationIncludes

; $ENDC                                         ; __NOTIFICATION__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Notification)