(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:OSA.p"
; at Wednesday May 1,2002 2:39:55 pm.
; 
;      File:       OSA.p
;  
;      Contains:   Open Scripting Architecture Client Interfaces.
;  
;      Version:    Technology: AppleScript 1.4
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1992-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __OSA__
; $SETC __OSA__ := 1

; $I+
; $SETC OSAIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __APPLEEVENTS__
|#

(require-interface 'AppleEvents)
#|                                              ; $I AppleEvents.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __AEOBJECTS__
|#

(require-interface 'AEObjects)
#|                                              ; $I AEObjects.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __AEINTERACTION__
|#

(require-interface 'AEInteraction)
#|                                              ; $I AEInteraction.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __COMPONENTS__
|#

(require-interface 'Components)
#|                                              ; $I Components.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; *************************************************************************
;     Types and Constants
; *************************************************************************

;     The componenent manager type code for components that
;         support the OSA interface defined here. 
;  0x6f736120 

(defconstant $kOSAComponentType :|osa |)

; 	 0x73637074 	
(defconstant $kOSAGenericScriptingComponentSubtype :|scpt|)

; 	  Type of script document files.  	
; 	 0x6f736173 	
(defconstant $kOSAFileType :|osas|)

; 	
; 	        Suite and event code of the RecordedText event. 
; 	        (See OSAStartRecording, below.)
; 	    	
; 	 0x61736372 	
(defconstant $kOSASuite :|ascr|)

; 	 0x72656364 	
(defconstant $kOSARecordedText :|recd|)

; 	 Selector returns boolean 	
; 	 0x6d6f6469 	
(defconstant $kOSAScriptIsModified :|modi|)

; 	 Selector returns boolean 	
; 	 0x63736372 	
(defconstant $kOSAScriptIsTypeCompiledScript :|cscr|)

; 	 Selector returns boolean 	
; 	 0x76616c75 	
(defconstant $kOSAScriptIsTypeScriptValue :|valu|)

; 	 Selector returns boolean 	
; 	 0x636e7478 	
(defconstant $kOSAScriptIsTypeScriptContext :|cntx|)

; 	 Selector returns a DescType which may be passed to OSACoerceToDesc 	
; 	 0x62657374 	
(defconstant $kOSAScriptBestType :|best|)

; 	
; 	        This selector is used to determine whether a script has source 
; 	        associated with it that when given to OSAGetSource, the call will not
; 	        fail.  The selector returns a boolean.
; 	    	
; 	 0x67737263 	
(defconstant $kOSACanGetSource :|gsrc|)

(defconstant $typeOSADialectInfo :|difo|)       ;    0x6469666f    
(defconstant $keyOSADialectName :|dnam|)        ;    0x646e616d    
(defconstant $keyOSADialectCode :|dcod|)        ;    0x64636f64    
(defconstant $keyOSADialectLangCode :|dlcd|)    ;    0x646c6364    
(defconstant $keyOSADialectScriptCode :|dscd|)  ;    0x64736364    

(def-mactype :osaerror (find-mactype ':signed-long))
; 	 Under the Open Scripting Architecture all error results are longs 	
(def-mactype :osaid (find-mactype ':unsigned-long))
; 	
; 	        OSAIDs allow transparent manipulation of scripts associated with
; 	        various scripting systems.
; 	    	

(defconstant $kOSANullScript 0)

; 	 No -script constant. 	
(defconstant $kOSANullMode 0)                   ;   sounds better  
(defconstant $kOSAModeNull 0)                   ;   tastes consistent  

; 	
; 	        Some routines take flags that control their execution.  This constant
; 	        declares default mode settings are used.
; 	    	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	OSACreateAppleEventProcPtr = FUNCTION(theAEEventClass: AEEventClass; theAEEventID: AEEventID; {CONST}VAR target: AEAddressDesc; returnID: INTEGER; transactionID: LONGINT; VAR result: AppleEvent; refCon: LONGINT): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :osacreateappleeventprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	OSASendProcPtr = FUNCTION({CONST}VAR theAppleEvent: AppleEvent; VAR reply: AppleEvent; sendMode: AESendMode; sendPriority: AESendPriority; timeOutInTicks: LONGINT; idleProc: AEIdleUPP; filterProc: AEFilterUPP; refCon: LONGINT): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :osasendprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :osacreateappleeventupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :osacreateappleeventupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :osasendupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :osasendupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppOSACreateAppleEventProcInfo #xFEFE0)
(defconstant $uppOSASendProcInfo #x3FEFE0)
; 
; 	 *  NewOSACreateAppleEventUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewOSACreateAppleEventProc 
(deftrap "_NewOSACreateAppleEventUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewOSASendUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewOSASendProc 
(deftrap "_NewOSASendUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeOSACreateAppleEventUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeOSACreateAppleEventUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeOSASendUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeOSASendUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeOSACreateAppleEventUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ;  old name was CallOSACreateAppleEventProc 
(deftrap-inline "_InvokeOSACreateAppleEventUPP" 
      ((theAEEventClass :ostype) (theAEEventID :ostype) (target (:pointer :aedesc)) (returnID :signed-integer) (transactionID :signed-long) (result (:pointer :aedesc)) (refCon :signed-long) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeOSASendUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ;  old name was CallOSASendProc 
(deftrap-inline "_InvokeOSASendUPP" 
      ((theAppleEvent (:pointer :aedesc)) (reply (:pointer :aedesc)) (sendMode :signed-long) (sendPriority :signed-integer) (timeOutInTicks :signed-long) (idleProc :pointer) (filterProc :pointer) (refCon :signed-long) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; *************************************************************************
;     OSA Interface Descriptions
; **************************************************************************
;     The OSA Interface is broken down into a required interface, and several
;     optional interfaces to support additional functionality.  A given scripting
;     component may choose to support only some of the optional interfaces in
;     addition to the basic interface.  The OSA Component Flags may be used to 
;     query the Component Manager to find a scripting component with a particular
;     capability, or determine if a particular scripting component supports a 
;     particular capability.
; *************************************************************************
;  OSA Component Flags: 

(defconstant $kOSASupportsCompiling #x2)
(defconstant $kOSASupportsGetSource #x4)
(defconstant $kOSASupportsAECoercion #x8)
(defconstant $kOSASupportsAESending #x10)
(defconstant $kOSASupportsRecording #x20)
(defconstant $kOSASupportsConvenience #x40)
(defconstant $kOSASupportsDialects #x80)
(defconstant $kOSASupportsEventHandling #x100)

; 	 Component Selectors: 	
(defconstant $kOSASelectLoad #x1)
(defconstant $kOSASelectStore #x2)
(defconstant $kOSASelectExecute #x3)
(defconstant $kOSASelectDisplay #x4)
(defconstant $kOSASelectScriptError #x5)
(defconstant $kOSASelectDispose #x6)
(defconstant $kOSASelectSetScriptInfo #x7)
(defconstant $kOSASelectGetScriptInfo #x8)
(defconstant $kOSASelectSetActiveProc #x9)
(defconstant $kOSASelectGetActiveProc #xA)

; 	 Compiling: 	
(defconstant $kOSASelectScriptingComponentName #x102)
(defconstant $kOSASelectCompile #x103)
(defconstant $kOSASelectCopyID #x104)

(defconstant $kOSASelectCopyScript #x105)

; 	 GetSource: 	
(defconstant $kOSASelectGetSource #x201)

; 	 AECoercion: 	
(defconstant $kOSASelectCoerceFromDesc #x301)
(defconstant $kOSASelectCoerceToDesc #x302)

; 	 AESending: 	
(defconstant $kOSASelectSetSendProc #x401)
(defconstant $kOSASelectGetSendProc #x402)
(defconstant $kOSASelectSetCreateProc #x403)
(defconstant $kOSASelectGetCreateProc #x404)
(defconstant $kOSASelectSetDefaultTarget #x405)

; 	 Recording: 	
(defconstant $kOSASelectStartRecording #x501)
(defconstant $kOSASelectStopRecording #x502)

; 	 Convenience: 	
(defconstant $kOSASelectLoadExecute #x601)
(defconstant $kOSASelectCompileExecute #x602)
(defconstant $kOSASelectDoScript #x603)

; 	 Dialects: 	
(defconstant $kOSASelectSetCurrentDialect #x701)
(defconstant $kOSASelectGetCurrentDialect #x702)
(defconstant $kOSASelectAvailableDialects #x703)
(defconstant $kOSASelectGetDialectInfo #x704)
(defconstant $kOSASelectAvailableDialectCodeList #x705)

; 	 Event Handling: 	
(defconstant $kOSASelectSetResumeDispatchProc #x801)
(defconstant $kOSASelectGetResumeDispatchProc #x802)
(defconstant $kOSASelectExecuteEvent #x803)
(defconstant $kOSASelectDoEvent #x804)
(defconstant $kOSASelectMakeContext #x805)

; 	 Debugging 	
(defconstant $kOSADebuggerCreateSession #x901)
(defconstant $kOSADebuggerGetSessionState #x902)
(defconstant $kOSADebuggerSessionStep #x903)
(defconstant $kOSADebuggerDisposeSession #x904)
(defconstant $kOSADebuggerGetStatementRanges #x905)
(defconstant $kOSADebuggerGetBreakpoint #x910)
(defconstant $kOSADebuggerSetBreakpoint #x911)
(defconstant $kOSADebuggerGetDefaultBreakpoint #x912)
(defconstant $kOSADebuggerGetCurrentCallFrame #x906)
(defconstant $kOSADebuggerGetCallFrameState #x907)
(defconstant $kOSADebuggerGetVariable #x908)
(defconstant $kOSADebuggerSetVariable #x909)
(defconstant $kOSADebuggerGetPreviousCallFrame #x90A)
(defconstant $kOSADebuggerDisposeCallFrame #x90B)
(defconstant $kOSADebuggerCountVariables #x90C)

; 	 scripting component specific selectors are added beginning with this value  	
(defconstant $kOSASelectComponentSpecificStart #x1001)

; 	        Mode Flags:
; 	
; 	    Warning: These should not conflict with the AESend mode flags in
; 	    AppleEvents.h, because we may want to use them as OSA mode flags too.
; 		

; 	
; 	        This mode flag may be passed to OSALoad, OSAStore or OSACompile to
; 	        instruct the scripting component to not retain the "source" of an
; 	        expression.  This will cause the OSAGetSource call to return the error
; 	        errOSASourceNotAvailable if used.  However, some scripting components
; 	        may not retain the source anyway.  This is mainly used when either space
; 	        efficiency is desired, or a script is to be "locked" so that its
; 	        implementation may not be viewed.
; 	    	
(defconstant $kOSAModePreventGetSource #x1)

; 	
; 	        These mode flags may be passed to OSACompile, OSAExecute, OSALoadExecute
; 	        OSACompileExecute, OSADoScript, OSAExecuteEvent, or OSADoEvent to
; 	        indicate whether or not the script may interact with the user, switch
; 	        layer or reconnect if necessary.  Any AppleEvents will be sent with the
; 	        corresponding AESend mode supplied.
; 	    	
(defconstant $kOSAModeNeverInteract #x10)
(defconstant $kOSAModeCanInteract #x20)
(defconstant $kOSAModeAlwaysInteract #x30)
(defconstant $kOSAModeDontReconnect #x80)

; 	
; 	        This mode flag may be passed to OSACompile, OSAExecute, OSALoadExecute
; 	        OSACompileExecute, OSADoScript, OSAExecuteEvent, or OSADoEvent to
; 	        indicate whether or not AppleEvents should be sent with the
; 	        kAECanSwitchLayer mode flag sent or not. NOTE: This flag is exactly the
; 	        opposite sense of the AppleEvent flag kAECanSwitchLayer.  This is to
; 	        provide a more convenient default, i.e. not supplying any mode
; 	        (kOSAModeNull) means to send events with kAECanSwitchLayer.  Supplying
; 	        the kOSAModeCantSwitchLayer mode flag will cause AESend to be called
; 	        without kAECanSwitchLayer.
; 	    	
(defconstant $kOSAModeCantSwitchLayer #x40)

; 	
; 	        This mode flag may be passed to OSACompile, OSAExecute, OSALoadExecute
; 	        OSACompileExecute, OSADoScript, OSAExecuteEvent, or OSADoEvent to
; 	        indicate whether or not AppleEvents should be sent with the kAEDontRecord
; 	        mode flag sent or not. NOTE: This flag is exactly the opposite sense of
; 	        the AppleEvent flag kAEDontRecord.  This is to provide a more convenient
; 	        default, i.e. not supplying any mode (kOSAModeNull) means to send events
; 	        with kAEDontRecord.  Supplying the kOSAModeDoRecord mode flag will 
; 	        cause AESend to be called without kAEDontRecord.
; 	    	
(defconstant $kOSAModeDoRecord #x1000)

; 	
; 	        This is a mode flag for OSACompile that indicates that a context should
; 	        be created as the result of compilation. All handler definitions are
; 	        inserted into the new context, and variables are initialized by
; 	        evaluating their initial values in a null context (i.e. they must be
; 	        constant expressions).
; 	    	
(defconstant $kOSAModeCompileIntoContext #x2)

; 	
; 	        This is a mode flag for OSACompile that indicates that the previous
; 	        script ID (input to OSACompile) should be augmented with any new
; 	        definitions in the sourceData rather than replaced with a new script.
; 	        This means that the previous script ID must designate a context.
; 	        The presence of this flag causes the kOSAModeCompileIntoContext flag
; 	        to be implicitly used, causing any new definitions to be initialized
; 	        in a null context.
; 	    	
(defconstant $kOSAModeAugmentContext #x4)

; 	
; 	        This mode flag may be passed to OSADisplay or OSADoScript to indicate
; 	        that output only need be human-readable, not re-compilable by OSACompile.
; 	        If used, output may be arbitrarily "beautified", e.g. quotes may be left
; 	        off of string values, long lists may have elipses, etc.
; 	    	
(defconstant $kOSAModeDisplayForHumans #x8)

; 	
; 	        This mode flag may be passed to OSAStore in the case where the scriptID
; 	        is a context.  This causes the context to be saved, but not the context's
; 	        parent context.  When the stored context is loaded back in, the parent
; 	        will be kOSANullScript.
; 	    	
(defconstant $kOSAModeDontStoreParent #x10000)

; 	
; 	        This mode flag may be passed to OSAExecuteEvent to cause the event to
; 	        be dispatched to the direct object of the event. The direct object (or
; 	        subject attribute if the direct object is a non-object specifier) will
; 	        be resolved, and the resulting script object will be the recipient of
; 	        the message. The context argument to OSAExecuteEvent will serve as the
; 	        root of the lookup/resolution process.
; 	    	
(defconstant $kOSAModeDispatchToDirectObject #x20000)

; 	
; 	        This mode flag may be passed to OSAExecuteEvent to indicate that
; 	        components do not have to get the data of object specifier arguments.
; 	    	
(defconstant $kOSAModeDontGetDataForArguments #x40000)

; 	*************************************************************************
; 	    OSA Basic Scripting Interface
; 	**************************************************************************
; 	    Scripting components must at least support the Basic Scripting interface.
; 	*************************************************************************	
; 	        Loading and Storing Scripts:
; 	
; 	    These routines allow scripts to be loaded and stored in their internal
; 	    (possibly compiled, non-text) representation.
; 		

; 	 Resource type for scripts 	
(defconstant $kOSAScriptResourceType :|scpt|)

; 	
; 	        Default type given to OSAStore which creates "generic" loadable script
; 	        data descriptors.
; 	    	
(defconstant $typeOSAGenericStorage :|scpt|)

; 
; 	 *  OSALoad()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; CONST
(deftrap "_OSALoad" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (scriptData (:pointer :aedesc)) (modeFlags :signed-long) (resultingScriptID (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent scriptData modeFlags resultingScriptID ((+ (ash 12 16) 1) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectLoad, 12);
;     
;         Errors:
;             badComponentInstance        invalid scripting component instance
;             errOSASystemError
;             errOSABadStorageType:       scriptData not for this scripting component
;             errOSACorruptData:          data seems to be corrupt
;             errOSADataFormatObsolete    script data format is no longer supported
;             errOSADataFormatTooNew      script data format is from a newer version
;         
;         ModeFlags:
;             kOSAModePreventGetSource
;     
; 
;  *  OSAStore()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSAStore" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (scriptID :unsigned-long) (desiredType :ostype) (modeFlags :signed-long) (resultingScriptData (:pointer :aedesc)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent scriptID desiredType modeFlags resultingScriptData ((+ (ash 16 16) 2) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectStore, 16);
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;             errOSAInvalidID
;             errOSABadStorageType:   desiredType not for this scripting component
;         
;         ModeFlags:
;             kOSAModePreventGetSource
;             kOSAModeDontStoreParent
;     
;  Executing Scripts: 
; 
;  *  OSAExecute()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSAExecute" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (compiledScriptID :unsigned-long) (contextID :unsigned-long) (modeFlags :signed-long) (resultingScriptValueID (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent compiledScriptID contextID modeFlags resultingScriptValueID ((+ (ash 16 16) 3) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectExecute, 16);
;         This call runs a script.  The contextID represents the environment
;         with which global variables in the script are resolved.  The constant
;         kOSANullScript may be used for the contextID if the application wishes
;         to not deal with context directly (a default one is associated with each
;         scripting component instance).  The resultingScriptValueID is the 
;         result of evaluation, and contains a value which may be displayed using
;         the OSAGetSource call.  The modeFlags convey scripting component
;         specific information.
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;             errOSAInvalidID
;             errOSAScriptError:      the executing script got an error
;     
;         ModeFlags:
;             kOSAModeNeverInteract
;             kOSAModeCanInteract
;             kOSAModeAlwaysInteract
;             kOSAModeCantSwitchLayer
;             kOSAModeDontReconnect
;             kOSAModeDoRecord
;     
;  Displaying results: 
; 
;  *  OSADisplay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSADisplay" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (scriptValueID :unsigned-long) (desiredType :ostype) (modeFlags :signed-long) (resultingText (:pointer :aedesc)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent scriptValueID desiredType modeFlags resultingText ((+ (ash 16 16) 4) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectDisplay, 16);
;         This call is used to convert results (script value IDs) into displayable
;         text. The desiredType should be at least typeChar, and modeFlags are
;         scripting system specific flags to control the formatting of the
;         resulting text. This call differs from OSAGetSource in that (1) it
;         always produces at least typeChar, (2) is only works on script values,
;         (3) it may display it's output in non-compilable form (e.g. without
;         string quotes, elipses inserted in long and/or circular lists, etc.) and
;         (4) it is required by the basic scripting interface.
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;             errOSAInvalidID
;             errAECoercionFail:      desiredType not supported by scripting component
;     
;         ModeFlags:
;             kOSAModeDisplayForHumans
;     
;  Getting Error Information: 
; 
;  *  OSAScriptError()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSAScriptError" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (selector :ostype) (desiredType :ostype) (resultingErrorDescription (:pointer :aedesc)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent selector desiredType resultingErrorDescription ((+ (ash 12 16) 5) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectScriptError, 12);
;         Whenever script execution returns errOSAExecutionError, this routine
;         may be used to get information about that error.  The selector describes
;         the type of information desired about the error (various selectors are
;         listed below).  The desiredType indicates the data type of the result
;         desired for that selector.
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;             errOSABadSelector:      selector not supported by scripting component
;             errAECoercionFail:      desiredType not supported by scripting component
;     
;  OSAScriptError selectors: 
; 
;         This selector is used to determine the error number of a script error.
;         These error numbers may be either system error numbers, or error numbers
;         that are scripting component specific.
;         Required desiredTypes:  
;             typeShortInteger
;     

(defconstant $kOSAErrorNumber :|errn|)

; 	
; 	        This selector is used to determine the full error message associated
; 	        with the error number.  It should include the name of the application
; 	        which caused the error, as well as the specific error that occurred.
; 	        This selector is sufficient for simple error reporting (but see
; 	        kOSAErrorBriefMessage, below).
; 	        Required desiredTypes:
; 	            typeChar                    error message string
; 	    	
(defconstant $kOSAErrorMessage :|errs|)

; 	
; 	        This selector is used to determine a brief error message associated with
; 	        the error number.  This message and should not mention the name of the
; 	        application which caused the error, any partial results or offending
; 	        object (see kOSAErrorApp, kOSAErrorPartialResult and
; 	        kOSAErrorOffendingObject, below).
; 	        Required desiredTypes:
; 	            typeChar                    brief error message string
; 	    	
; 	  0x65727262  	
(defconstant $kOSAErrorBriefMessage :|errb|)

; 	
; 	        This selector is used to determine which application actually got the
; 	        error (if it was the result of an AESend), or the current application
; 	        if ....
; 	        Required desiredTypes:
; 	            typeProcessSerialNumber     PSN of the errant application
; 	            typeChar                    name of the errant application
; 	    	
; 	  0x65726170  	
(defconstant $kOSAErrorApp :|erap|)

; 	
; 	        This selector is used to determine any partial result returned by an 
; 	        operation. If an AESend call failed, but a partial result was returned,
; 	        then the partial result may be returned as an AEDesc.
; 	        Required desiredTypes:
; 	            typeBest                    AEDesc of any partial result
; 	    	
; 	  0x70746c72   	
(defconstant $kOSAErrorPartialResult :|ptlr|)

; 	
; 	        This selector is used to determine any object which caused the error
; 	        that may have been indicated by an application.  The result is an 
; 	        AEDesc.
; 	        Required desiredTypes:
; 	            typeBest                    AEDesc of any offending object
; 	    	
; 	  0x65726f62   	
(defconstant $kOSAErrorOffendingObject :|erob|)

; 	
; 	        This selector is used to determine the type expected by a coercion 
; 	        operation if a type error occurred.
; 	    	
; 	  0x65727274   	
(defconstant $kOSAErrorExpectedType :|errt|)

; 	
; 	        This selector is used to determine the source text range (start and 
; 	        end positions) of where the error occurred.
; 	        Required desiredTypes:
; 	            typeOSAErrorRange
; 	    	
; 	  0x65726e67  	
(defconstant $kOSAErrorRange :|erng|)

; 	
; 	        An AERecord type containing keyOSASourceStart and keyOSASourceEnd fields
; 	        of type short.
; 	    	
; 	  0x65726e67   	
(defconstant $typeOSAErrorRange :|erng|)

; 	 Field of a typeOSAErrorRange record of typeShortInteger 	
; 	  0x73726373    	
(defconstant $keyOSASourceStart :|srcs|)

; 	 Field of a typeOSAErrorRange record of typeShortInteger 	
; 	  0x73726365   	
(defconstant $keyOSASourceEnd :|srce|)

; 	 Disposing Script IDs: 	
; 
; 	 *  OSADispose()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_OSADispose" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (scriptID :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent scriptID ((+ (ash 4 16) 6) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectDispose, 4);
;         Disposes a script or context.
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;             errOSAInvalidID
;     
;  Getting and Setting Script Information: 
; 
;  *  OSASetScriptInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSASetScriptInfo" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (scriptID :unsigned-long) (selector :ostype) (value :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent scriptID selector value ((+ (ash 12 16) 7) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectSetScriptInfo, 12);
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;             errOSAInvalidID
;             errOSABadSelector:      selector not supported by scripting component
;                                     or selector not for this scriptID
;     
; 
;  *  OSAGetScriptInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSAGetScriptInfo" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (scriptID :unsigned-long) (selector :ostype) (result (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent scriptID selector result ((+ (ash 12 16) 8) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectGetScriptInfo, 12);
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;             errOSAInvalidID
;             errOSABadSelector:      selector not supported by scripting component
;                                     or selector not for this scriptID
;     
;  Manipulating the ActiveProc:
; 
;     Scripting systems will supply default values for these procedures if they
;     are not set by the client:
; 

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	OSAActiveProcPtr = FUNCTION(refCon: LONGINT): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :osaactiveprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :osaactiveupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :osaactiveupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppOSAActiveProcInfo #xE0)
; 
; 	 *  NewOSAActiveUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewOSAActiveProc 
(deftrap "_NewOSAActiveUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeOSAActiveUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeOSAActiveUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeOSAActiveUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallOSAActiveProc 
(deftrap-inline "_InvokeOSAActiveUPP" 
      ((refCon :signed-long) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  OSASetActiveProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSASetActiveProc" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (activeProc :pointer) (refCon :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent activeProc refCon ((+ (ash 8 16) 9) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectSetActiveProc, 8);
;         If activeProc is nil, the default activeProc is used.
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;     
; 
;  *  OSAGetActiveProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSAGetActiveProc" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (activeProc (:pointer :pointer)) (refCon (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent activeProc refCon ((+ (ash 8 16) 10) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectGetActiveProc, 8);
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;     
; *************************************************************************
;     OSA Optional Compiling Interface
; **************************************************************************
;     Scripting components that support the Compiling interface have the 
;     kOSASupportsCompiling bit set in it's ComponentDescription.
; *************************************************************************
; 
;  *  OSAScriptingComponentName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSAScriptingComponentName" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (resultingScriptingComponentName (:pointer :aedesc)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent resultingScriptingComponentName ((+ (ash 4 16) 258) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectScriptingComponentName, 4);
;         Given a scripting component, this routine returns the name of that
;         scripting component in a type that is coercable to text (typeChar).
;         The generic scripting component returns the name of the default
;         scripting component.  This name should be sufficient to convey to the
;         user the kind of script (syntax) he is expected to write.
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;     
; 
;  *  OSACompile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_OSACompile" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (sourceData (:pointer :aedesc)) (modeFlags :signed-long) (previousAndResultingScriptID (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent sourceData modeFlags previousAndResultingScriptID ((+ (ash 12 16) 259) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectCompile, 12);
;         Coerces input desc (possibly text) into a script's internal format.
;         Once compiled, the script is ready to run.  The modeFlags convey
;         scripting component specific information.  The previous script ID
;         (result parameter) is made to refer to the newly compiled script,
;         unless it was originally kOSANullScript.  In this case a new script
;         ID is created and used.
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;             errAECoercionFail:      sourceData is not compilable
;             errOSAScriptError:      sourceData was a bad script (syntax error)
;             errOSAInvalidID:        previousAndResultingCompiledScriptID was not
;                                     valid on input
;     
;         ModeFlags:
;             kOSAModePreventGetSource
;             kOSAModeCompileIntoContext
;             kOSAModeAugmentContext
;             kOSAModeNeverInteract
;             kOSAModeCanInteract
;             kOSAModeAlwaysInteract
;             kOSAModeCantSwitchLayer
;             kOSAModeDontReconnect
;             kOSAModeDoRecord
;     
; 
;  *  OSACopyID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSACopyID" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (fromID :unsigned-long) (toID (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent fromID toID ((+ (ash 8 16) 260) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectCopyID, 8);
;         If toID is a reference to kOSANullScript then it is updated to have a
;         new scriptID value.  This call can be used to perform undo or revert
;         operations on scripts. 
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;             errOSAInvalidID
;     
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  OSACopyScript()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_OSACopyScript" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (fromID :unsigned-long) (toID (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent fromID toID ((+ (ash 8 16) 261) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectCopyScript, 8);
;         Creates a duplicate copy of the script with the given OSAID and returns
;         a new OSAID for it.  Can be used by script editors or debuggers. 
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;             errOSAInvalidID
;     
; $ENDC                                         ; CALL_NOT_IN_CARBON

; *************************************************************************
;     OSA Optional GetSource Interface
; **************************************************************************
;     Scripting components that support the GetSource interface have the 
;     kOSASupportsGetSource bit set in their ComponentDescription.
; *************************************************************************
; 
;  *  OSAGetSource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSAGetSource" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (scriptID :unsigned-long) (desiredType :ostype) (resultingSourceData (:pointer :aedesc)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent scriptID desiredType resultingSourceData ((+ (ash 12 16) 513) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectGetSource, 12);
;         This routine causes a compiled script to be output in a form (possibly
;         text) such that it is suitable to be passed back to OSACompile.
; 
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;             errOSAInvalidID
;             errOSASourceNotAvailable    can't get source for this scriptID
;     
; *************************************************************************
;     OSA Optional AECoercion Interface
; **************************************************************************
;     Scripting components that support the AECoercion interface have the 
;     kOSASupportsAECoercion bit set in their ComponentDescription.
; *************************************************************************
; 
;  *  OSACoerceFromDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_OSACoerceFromDesc" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (scriptData (:pointer :aedesc)) (modeFlags :signed-long) (resultingScriptID (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent scriptData modeFlags resultingScriptID ((+ (ash 12 16) 769) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectCoerceFromDesc, 12);
;         This routine causes script data to be coerced into a script value.
;         If the scriptData is an AppleEvent, then the resultingScriptID is a
;         compiled script ID (mode flags for OSACompile may be used in this case).
;         Other scriptData descriptors create script value IDs.
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;     
;         ModeFlags:
;             kOSAModePreventGetSource
;             kOSAModeCompileIntoContext
;             kOSAModeNeverInteract
;             kOSAModeCanInteract
;             kOSAModeAlwaysInteract
;             kOSAModeCantSwitchLayer
;             kOSAModeDontReconnect
;             kOSAModeDoRecord
;     
; 
;  *  OSACoerceToDesc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSACoerceToDesc" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (scriptID :unsigned-long) (desiredType :ostype) (modeFlags :signed-long) (result (:pointer :aedesc)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent scriptID desiredType modeFlags result ((+ (ash 16 16) 770) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectCoerceToDesc, 16);
;         This routine causes a script value to be coerced into any desired form.
;         If the scriptID denotes a compiled script, then it may be coerced to 
;         typeAppleEvent.
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;             errOSAInvalidID
;     
; *************************************************************************
;     OSA Optional AESending Interface
; **************************************************************************
;     Scripting components that support the AESending interface have the 
;     kOSASupportsAESending bit set in their ComponentDescription.
; *************************************************************************
; 
;     Scripting systems will supply default values for these procedures if they
;     are not set by the client:
; 
; 
;  *  OSASetSendProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSASetSendProc" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (sendProc :pointer) (refCon :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent sendProc refCon ((+ (ash 8 16) 1025) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectSetSendProc, 8);
;         If sendProc is nil, the default sendProc is used.
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;     
; 
;  *  OSAGetSendProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSAGetSendProc" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (sendProc (:pointer :pointer)) (refCon (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent sendProc refCon ((+ (ash 8 16) 1026) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectGetSendProc, 8);
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;     
; 
;  *  OSASetCreateProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSASetCreateProc" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (createProc :pointer) (refCon :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent createProc refCon ((+ (ash 8 16) 1027) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectSetCreateProc, 8);
;         If createProc is nil, the default createProc is used.
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;     
; 
;  *  OSAGetCreateProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSAGetCreateProc" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (createProc (:pointer :pointer)) (refCon (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent createProc refCon ((+ (ash 8 16) 1028) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectGetCreateProc, 8);
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;     
; 
;  *  OSASetDefaultTarget()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_OSASetDefaultTarget" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (target (:pointer :aedesc)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent target ((+ (ash 4 16) 1029) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectSetDefaultTarget, 4);
;         This routine sets the default target application for AE sending.
;         It also establishes the default target from which terminologies come.
;         It is effectively like having an AppleScript "tell" statement around
;         the entire program.  If this routine is not called, or if the target 
;         is a null AEDesc, then the current application is the default target.
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;     
; *************************************************************************
;     OSA Optional Recording Interface
; **************************************************************************
;     Scripting components that support the Recording interface have the 
;     kOSASupportsRecording bit set in their ComponentDescription.
; *************************************************************************
; 
;  *  OSAStartRecording()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSAStartRecording" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (compiledScriptToModifyID (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent compiledScriptToModifyID ((+ (ash 4 16) 1281) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectStartRecording, 4);
;         Starts recording.  If compiledScriptToModifyID is kOSANullScript, a
;         new script ID is created and returned.  If the current application has
;         a handler for the kOSARecordedText event, then kOSARecordedText events
;         are sent to the application containing the text of each AppleEvent 
;         recorded.
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;             errOSAInvalidID
;             errOSARecordingIsAlreadyOn
;     
; 
;  *  OSAStopRecording()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSAStopRecording" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (compiledScriptID :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent compiledScriptID ((+ (ash 4 16) 1282) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectStopRecording, 4);
;         If compiledScriptID is not being recorded into or recording is not
;         currently on, no error is returned.
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;             errOSAInvalidID
;     
; *************************************************************************
;     OSA Optional Convenience Interface
; **************************************************************************
;     Scripting components that support the Convenience interface have the 
;     kOSASupportsConvenience bit set in their ComponentDescription.
; *************************************************************************
; 
;  *  OSALoadExecute()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_OSALoadExecute" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (scriptData (:pointer :aedesc)) (contextID :unsigned-long) (modeFlags :signed-long) (resultingScriptValueID (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent scriptData contextID modeFlags resultingScriptValueID ((+ (ash 16 16) 1537) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectLoadExecute, 16);
;         This routine is effectively equivalent to calling OSALoad followed by
;         OSAExecute.  After execution, the compiled source is disposed.  Only the
;         resulting value ID is retained.
;     
;         Errors:
;             badComponentInstance        invalid scripting component instance
;             errOSASystemError
;             errOSABadStorageType:       scriptData not for this scripting component
;             errOSACorruptData:          data seems to be corrupt
;             errOSADataFormatObsolete    script data format is no longer supported
;             errOSADataFormatTooNew      script data format is from a newer version
;             errOSAInvalidID
;             errOSAScriptError:          the executing script got an error
;     
;         ModeFlags:
;             kOSAModeNeverInteract
;             kOSAModeCanInteract
;             kOSAModeAlwaysInteract
;             kOSAModeCantSwitchLayer
;             kOSAModeDontReconnect
;             kOSAModeDoRecord
;     
; 
;  *  OSACompileExecute()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_OSACompileExecute" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (sourceData (:pointer :aedesc)) (contextID :unsigned-long) (modeFlags :signed-long) (resultingScriptValueID (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent sourceData contextID modeFlags resultingScriptValueID ((+ (ash 16 16) 1538) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectCompileExecute, 16);
;         This routine is effectively equivalent to calling OSACompile followed by
;         OSAExecute.  After execution, the compiled source is disposed.  Only the
;         resulting value ID is retained.
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;             errAECoercionFail:      sourceData is not compilable
;             errOSAScriptError:      sourceData was a bad script (syntax error)
;             errOSAInvalidID:        previousAndResultingCompiledScriptID was not
;                                     valid on input
;             errOSAScriptError:      the executing script got an error
;     
;         ModeFlags:
;             kOSAModeNeverInteract
;             kOSAModeCanInteract
;             kOSAModeAlwaysInteract
;             kOSAModeCantSwitchLayer
;             kOSAModeDontReconnect
;             kOSAModeDoRecord
;     
; 
;  *  OSADoScript()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_OSADoScript" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (sourceData (:pointer :aedesc)) (contextID :unsigned-long) (desiredType :ostype) (modeFlags :signed-long) (resultingText (:pointer :aedesc)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent sourceData contextID desiredType modeFlags resultingText ((+ (ash 20 16) 1539) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectDoScript, 20);
;         This routine is effectively equivalent to calling OSACompile followed by
;         OSAExecute and then OSADisplay.  After execution, the compiled source
;         and the resulting value are is disposed.  Only the resultingText
;         descriptor is retained.  If a script error occur during processing, the 
;         resultingText gets the error message of the error, and errOSAScriptError
;         is returned.  OSAScriptError may still be used to extract more 
;         information about the particular error.
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;             errAECoercionFail:      sourceData is not compilable or 
;                                     desiredType not supported by scripting component
;             errOSAScriptError:      sourceData was a bad script (syntax error)
;             errOSAInvalidID:        previousAndResultingCompiledScriptID was not
;                                     valid on input
;             errOSAScriptError:      the executing script got an error
;     
;         ModeFlags:
;             kOSAModeNeverInteract
;             kOSAModeCanInteract
;             kOSAModeAlwaysInteract
;             kOSAModeCantSwitchLayer
;             kOSAModeDontReconnect
;             kOSAModeDoRecord
;             kOSAModeDisplayForHumans
;     
; *************************************************************************
;     OSA Optional Dialects Interface
; **************************************************************************
;     Scripting components that support the Dialects interface have the 
;     kOSASupportsDialects bit set in their ComponentDescription.
; *************************************************************************
; 
;     These calls allows an scripting component that supports different dialects
;     to dynamically switch between those dialects.  Although this interface is
;     specified, the particular dialect codes are scripting component dependent.
; 
; 
;  *  OSASetCurrentDialect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSASetCurrentDialect" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (dialectCode :signed-integer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent dialectCode ((+ (ash 2 16) 1793) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectSetCurrentDialect, 2);
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;             errOSANoSuchDialect:    invalid dialectCode
;     
; 
;  *  OSAGetCurrentDialect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSAGetCurrentDialect" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (resultingDialectCode (:pointer :signed-integer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent resultingDialectCode ((+ (ash 4 16) 1794) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectGetCurrentDialect, 4);
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;     
; 
;  *  OSAAvailableDialects()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSAAvailableDialects" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (resultingDialectInfoList (:pointer :aedesc)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent resultingDialectInfoList ((+ (ash 4 16) 1795) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectAvailableDialects, 4);
;         This call return an AEList containing information about each of the
;         currently available dialects of a scripting component.  Each item
;         is an AERecord of typeOSADialectInfo that contains at least the fields
;         keyOSADialectName, keyOSADialectCode, KeyOSADialectLangCode and 
;         keyOSADialectScriptCode.
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;     
; 
;  *  OSAGetDialectInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSAGetDialectInfo" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (dialectCode :signed-integer) (selector :ostype) (resultingDialectInfo (:pointer :aedesc)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent dialectCode selector resultingDialectInfo ((+ (ash 10 16) 1796) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectGetDialectInfo, 10);
;         This call gives information about the specified dialect of a scripting
;         component. It returns an AEDesc whose type depends on the selector 
;         specified. Available selectors are the same as the field keys for a
;         dialect info record. The type of AEDesc returned is the same as the 
;         type of the field that has same key as the selector.
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;             errOSABadSelector
;             errOSANoSuchDialect:    invalid dialectCode
;     
; 
;  *  OSAAvailableDialectCodeList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSAAvailableDialectCodeList" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (resultingDialectCodeList (:pointer :aedesc)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent resultingDialectCodeList ((+ (ash 4 16) 1797) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectAvailableDialectCodeList, 4);
;         This is alternative to OSAGetAvailableDialectCodeList. Use this call
;         and  OSAGetDialectInfo to get information on dialects.
;         This call return an AEList containing dialect code for each of the
;         currently available dialects of a scripting component. Each dialect
;         code is a short integer of type typeShortInteger.
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
; 
;         Type of a dialect info record containing at least keyOSADialectName
;         and keyOSADialectCode fields.
; 
;         keys for dialect info record, also used as selectors to OSAGetDialectInfo.
; 
;         Field of a typeOSADialectInfo record of typeChar.
;         Field of a typeOSADialectInfo record of typeShortInteger.
;         Field of a typeOSADialectInfo record of typeShortInteger.
;         Field of a typeOSADialectInfo record of typeShortInteger.
;     
; *************************************************************************
;     OSA Optional Event Handling Interface
; **************************************************************************
;     Scripting components that support the Event Handling interface have the 
;     kOSASupportsEventHandling bit set in their ComponentDescription.
; *************************************************************************
; 
;  *  OSASetResumeDispatchProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSASetResumeDispatchProc" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (resumeDispatchProc :pointer) (refCon :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent resumeDispatchProc refCon ((+ (ash 8 16) 2049) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectSetResumeDispatchProc, 8);
;         This function is used to set the ResumeDispatchProc that will be used
;         by OSAExecuteEvent and OSADoEvent if either no event handler can be
;         found in the context, or the context event hander "continues" control
;         onward. The two constants kOSAUseStandardDispatch and kOSANoDispatch
;         may also be passed to this routine indicating that the handler registered
;         in the application with AEInstallEventHandler should be used, or no
;         dispatch should occur, respectively.
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;     

(defconstant $kOSAUseStandardDispatch #xFFFFFFFF)

; 	
; 	        Special ResumeDispatchProc constant which may be passed to 
; 	        OSASetResumeDispatchProc indicating that the handler registered
; 	        in the application with AEInstallEventHandler should be used.
; 	        
; 	        NOTE:   Had to remove the cast (AEEventHandlerUPP).  The C compiler
; 	                doesn't allow pointer types to be assigned to an enum.  All
; 	                constants must be assigned as enums to translate properly to
; 	                Pascal.
; 	    	
(defconstant $kOSANoDispatch 0)

; 	
; 	        Special ResumeDispatchProc constant which may be passed to 
; 	        OSASetResumeDispatchProc indicating that no dispatch should occur.
; 	        
; 	        NOTE:   Had to remove the cast (AEEventHandlerUPP).  The C compiler
; 	                doesn't allow pointer types to be assigned to an enum.  All
; 	                constants must be assigned as enums to translate properly to
; 	                Pascal.
; 	    	
(defconstant $kOSADontUsePhac #x1)

; 	
; 	        Special refCon constant that may be given to OSASetResumeDispatchProc
; 	        only when kOSAUseStandardDispatch is used as the ResumeDispatchProc.
; 	        This causes the standard dispatch to be performed, except the phac
; 	        handler is not called.  This is useful during tinkerability, when
; 	        the phac handler is used to lookup a context associated with an event's 
; 	        direct parameter, and call OSAExecuteEvent or OSADoEvent.  Failure to
; 	        bypass the phac handler would result in an infinite loop.
; 	    	
; 
; 	 *  OSAGetResumeDispatchProc()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_OSAGetResumeDispatchProc" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (resumeDispatchProc (:pointer :pointer)) (refCon (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent resumeDispatchProc refCon ((+ (ash 8 16) 2050) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectGetResumeDispatchProc, 8);
;         Returns the registered ResumeDispatchProc.  If no ResumeDispatchProc has
;         been registered, then kOSAUseStandardDispatch (the default) is returned.
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;     
; 
;  *  OSAExecuteEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_OSAExecuteEvent" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (theAppleEvent (:pointer :aedesc)) (contextID :unsigned-long) (modeFlags :signed-long) (resultingScriptValueID (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent theAppleEvent contextID modeFlags resultingScriptValueID ((+ (ash 16 16) 2051) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectExecuteEvent, 16);
;         This call is similar to OSAExecute except the initial command to
;         execute comes in the form of an AppleEvent.  If the contextID
;         defines any event handlers for that event, they are used to process
;         the event.  If no event handler can be found in the context
;         errAEEventNotHandled is returned.  If an event handler is found and
;         the hander "continues" control onward, the ResumeDispatchProc
;         (registered with OSASetResumeDispatchProc, above) is called given the
;         AppleEvent.  The result is returned as a scriptValueID.
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;             errOSAInvalidID
;             errOSAScriptError:      the executing script got an error
;             errAEEventNotHandled:   no handler for event in contextID
;     
;         ModeFlags:
;             kOSAModeNeverInteract
;             kOSAModeCanInteract
;             kOSAModeAlwaysInteract
;             kOSAModeCantSwitchLayer
;             kOSAModeDontReconnect
;             kOSAModeDoRecord
;     
; 
;  *  OSADoEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_OSADoEvent" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (theAppleEvent (:pointer :aedesc)) (contextID :unsigned-long) (modeFlags :signed-long) (reply (:pointer :aedesc)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent theAppleEvent contextID modeFlags reply ((+ (ash 16 16) 2052) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectDoEvent, 16);
;         This call is similar to OSADoScript except the initial command to
;         execute comes in the form of an AppleEvent, and the result is an 
;         AppleEvent reply record.  If the contextID defines any event handlers
;         for that event, they are used to process the event.  If no event handler
;         can be found in the context errAEEventNotHandled is returned.  If an
;         event handler is found and the hander "continues" control onward, the
;         ResumeDispatchProc (registered with OSASetResumeDispatchProc, above) is
;         called given the AppleEvent.  The result is returned in the form of an
;         AppleEvent reply descriptor. If at any time the script gets an error, or
;         if the ResumeDispatchProc returns a reply event indicating an error,
;         then the OSADoEvent call itself returns an error reply (i.e. OSADoEvent
;         should never return errOSAScriptError).  Any error result returned by
;         the ResumeDispatchProc will be returned by OSADoEvent.
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;             errOSAInvalidID
;             errAEEventNotHandled:   no handler for event in contextID
;     
;         ModeFlags:
;             kOSAModeNeverInteract
;             kOSAModeCanInteract
;             kOSAModeAlwaysInteract
;             kOSAModeCantSwitchLayer
;             kOSAModeDontReconnect
;             kOSAModeDoRecord
;     
; 
;  *  OSAMakeContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_OSAMakeContext" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (contextName (:pointer :aedesc)) (parentContext :unsigned-long) (resultingContextID (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent contextName parentContext resultingContextID ((+ (ash 12 16) 2053) :signed-longint)))

; 
;         OSAComponentFunctionInline(kOSASelectMakeContext, 12);
;         Makes a new empty context which may be passed to OSAExecute or 
;         OSAExecuteEvent.  If contextName is typeNull, an unnamed context is
;         created. If parentContext is kOSANullScript then the resulting context
;         does not inherit bindings from any other context.
;     
;         Errors:
;             badComponentInstance    invalid scripting component instance
;             errOSASystemError
;             errOSAInvalidID
;             errAECoercionFail:      contextName is invalid
;     
; 
;  * Debugging API
;  
; 
;  * Types
;  

(def-mactype :osadebugsessionref (find-mactype ':unsigned-long))
(def-mactype :osadebugcallframeref (find-mactype ':unsigned-long))
; 	
; 	 * Constants
; 	 	
(def-mactype :osaprogramstate (find-mactype ':unsigned-long))

(defconstant $eNotStarted 0)
(defconstant $eRunnable 1)
(defconstant $eRunning 2)
(defconstant $eStopped 3)
(defconstant $eTerminated 4)

(def-mactype :osadebugstepkind (find-mactype ':unsigned-long))

(defconstant $eStepOver 0)
(defconstant $eStepIn 1)
(defconstant $eStepOut 2)
(defconstant $eRun 3)

(def-mactype :osalocalorglobal (find-mactype ':unsigned-long))

(defconstant $eLocal 0)
(defconstant $eGlobal 1)
(defconstant $eProperties 2)

; 	
; 	 * Session Information
; 	 	
(defconstant $keyProgramState :|dsps|)

; 	
; 	 * Call Frame Information
; 	 	

(def-mactype :statementrangeptr (find-mactype '(:pointer :statementrange)))
(defrecord StatementRange 
   (startPos :unsigned-long)
   (endPos :unsigned-long)
   )

(defconstant $typeStatementRange :|srng|)

(defconstant $keyProcedureName :|dfnm|)         ;   typeChar  
(defconstant $keyStatementRange :|dfsr|)        ;   typeStatementRange  
(defconstant $keyLocalsNames :|dfln|)           ;   typeAEList of typeChar  
(defconstant $keyGlobalsNames :|dfgn|)          ;   typeAEList of typeChar  
(defconstant $keyParamsNames :|dfpn|)           ;   typeAEList of typeChar  

; 	
; 	 * Sessions
; 	 	
; 
; 	 *  OSADebuggerCreateSession()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in AppleScriptLib 1.5 and later
; 	 *    CarbonLib:        in CarbonLib 1.1 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_OSADebuggerCreateSession" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (inScript :unsigned-long) (inContext :unsigned-long) (outSession (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent inScript inContext outSession ((+ (ash 12 16) 2305) :signed-longint)))

; 
;  *  OSADebuggerGetSessionState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.5 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSADebuggerGetSessionState" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (inSession :unsigned-long) (outState (:pointer :aedesc)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent inSession outState ((+ (ash 8 16) 2306) :signed-longint)))

; 
;  *  OSADebuggerSessionStep()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.5 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSADebuggerSessionStep" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (inSession :unsigned-long) (inKind :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent inSession inKind ((+ (ash 8 16) 2307) :signed-longint)))

; 
;  *  OSADebuggerDisposeSession()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.5 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSADebuggerDisposeSession" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (inSession :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent inSession ((+ (ash 4 16) 2308) :signed-longint)))

; 
;  *  OSADebuggerGetStatementRanges()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.5 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSADebuggerGetStatementRanges" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (inSession :unsigned-long) (outStatementRangeArray (:pointer :aedesc)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent inSession outStatementRangeArray ((+ (ash 8 16) 2309) :signed-longint)))

;   Returns an array of StatementRange objects. 
; 
;  *  OSADebuggerGetBreakpoint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.5 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSADebuggerGetBreakpoint" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (inSession :unsigned-long) (inSrcOffset :unsigned-long) (outBreakpoint (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent inSession inSrcOffset outBreakpoint ((+ (ash 12 16) 2320) :signed-longint)))

; 
;  *  OSADebuggerSetBreakpoint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.5 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSADebuggerSetBreakpoint" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (inSession :unsigned-long) (inSrcOffset :unsigned-long) (inBreakpoint :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent inSession inSrcOffset inBreakpoint ((+ (ash 12 16) 2321) :signed-longint)))

; 
;  *  OSADebuggerGetDefaultBreakpoint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.5 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSADebuggerGetDefaultBreakpoint" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (inSession :unsigned-long) (outBreakpoint (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent inSession outBreakpoint ((+ (ash 8 16) 2322) :signed-longint)))

; 
;  * Call Frames
;  
; 
;  *  OSADebuggerGetCurrentCallFrame()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.5 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSADebuggerGetCurrentCallFrame" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (inSession :unsigned-long) (outCallFrame (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent inSession outCallFrame ((+ (ash 8 16) 2310) :signed-longint)))

; 
;  *  OSADebuggerGetCallFrameState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.5 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSADebuggerGetCallFrameState" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (inCallFrame :unsigned-long) (outState (:pointer :aedesc)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent inCallFrame outState ((+ (ash 8 16) 2311) :signed-longint)))

; 
;  *  OSADebuggerGetVariable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.5 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_OSADebuggerGetVariable" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (inCallFrame :unsigned-long) (inVariableName (:pointer :aedesc)) (outVariable (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent inCallFrame inVariableName outVariable ((+ (ash 12 16) 2312) :signed-longint)))

; 
;  *  OSADebuggerSetVariable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.5 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_OSADebuggerSetVariable" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (inCallFrame :unsigned-long) (inVariableName (:pointer :aedesc)) (inVariable :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent inCallFrame inVariableName inVariable ((+ (ash 12 16) 2313) :signed-longint)))

; 
;  *  OSADebuggerGetPreviousCallFrame()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.5 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSADebuggerGetPreviousCallFrame" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (inCurrentFrame :unsigned-long) (outPrevFrame (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent inCurrentFrame outPrevFrame ((+ (ash 8 16) 2314) :signed-longint)))

; 
;  *  OSADebuggerDisposeCallFrame()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.5 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSADebuggerDisposeCallFrame" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (inCallFrame :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent inCallFrame ((+ (ash 4 16) 2315) :signed-longint)))

; 
;  *  OSADebuggerCountVariables()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in AppleScriptLib 1.5 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OSADebuggerCountVariables" 
      ((scriptingComponent (:pointer :componentinstancerecord)) (inSession :unsigned-long) (inCallFrame :unsigned-long) (inWhichSet :unsigned-long) (outVariableCount (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 scriptingComponent inSession inCallFrame inWhichSet outVariableCount ((+ (ash 16 16) 2316) :signed-longint)))

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := OSAIncludes

; $ENDC                                         ; __OSA__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'OSA)