(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:OSUtils.p"
; at Wednesday May 1,2002 2:38:45 pm.
; 
;      File:       OSUtils.p
;  
;      Contains:   OS Utilities Interfaces.
;  
;      Version:    Technology: Mac OS 9
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __OSUTILS__
; $SETC __OSUTILS__ := 1

; $I+
; $SETC OSUtilsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __MIXEDMODE__

(require-interface 'MixedMode)                  ; $I MixedMode.p
; $ENDC
;   HandToHand and other memory utilties were moved to MacMemory.h 
; $IFC UNDEFINED __MACMEMORY__

(require-interface 'MacMemory)                  ; $I MacMemory.p
; $ENDC
;   GetTrapAddress and other trap table utilties were moved to Patches.h 
; $IFC UNDEFINED __PATCHES__

(require-interface 'Patches)                    ; $I Patches.p
; $ENDC
;   Date and Time utilties were moved to DateTimeUtils.h 
; $IFC UNDEFINED __DATETIMEUTILS__

(require-interface 'DateTimeUtils)              ; $I DateTimeUtils.p
; $ENDC
; $IFC UNDEFINED __CFSTRING__

(require-interface 'CFString)                   ; $I CFString.p
; $ENDC
#|                                              ; $IFC NOT TARGET_OS_MAC 
; $IFC UNDEFINED __ENDIAN__
|#

(require-interface 'Endian)
#|                                              ; $I Endian.p
; $ENDC
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $useFree 0)
(defconstant $useATalk 1)
(defconstant $useAsync 2)
(defconstant $useExtClk 3)                      ;  Externally clocked 
(defconstant $useMIDI 4)

(defconstant $false32b 0)                       ;  24 bit addressing error 
(defconstant $true32b 1)                        ;  32 bit addressing error 

;   result types for RelString Call  
(defconstant $sortsBefore -1)                   ;  first string < second string 
(defconstant $sortsEqual 0)                     ;  first string = second string 
(defconstant $sortsAfter 1)                     ;  first string > second string 

(defconstant $dummyType 0)
(defconstant $vType 1)
(defconstant $ioQType 2)
(defconstant $drvQType 3)
(defconstant $evType 4)
(defconstant $fsQType 5)
(defconstant $sIQType 6)
(defconstant $dtQType 7)
(defconstant $nmType 8)

(def-mactype :qtypes (find-mactype ':signed-byte))
(def-mactype :sysparmtypeptr (find-mactype '(:pointer :sysparmtype)))
(defrecord SysParmType 
   (valid :unsigned-byte)
   (aTalkA :unsigned-byte)
   (aTalkB :unsigned-byte)
   (config :unsigned-byte)
   (portA :signed-integer)
   (portB :signed-integer)
   (alarm :signed-long)
   (font :signed-integer)
   (kbdPrint :signed-integer)
   (volClik :signed-integer)
   (misc :signed-integer)
   )

(def-mactype :syspptr (find-mactype '(:pointer :sysparmtype)))
(def-mactype :qelemptr (find-mactype '(:pointer :qelem)))
(defrecord QElem 
   (qLink (:pointer :qelem))
   (qType :signed-integer)
   (qData (:array :signed-integer 1))
   )

; $IFC TARGET_OS_MAC 
(def-mactype :qhdrptr (find-mactype '(:pointer :qhdr)))
(defrecord QHdr 
   (qFlags :signed-integer)
   (qHead (:pointer :qelem))
   (qTail (:pointer :qelem))
   )

#|                                              ; $ELSEC
; 
; 	   QuickTime 3.0
; 	   this version of QHdr contains the Mutex necessary for
; 	   non-mac non-interrupt code
; 	
(def-mactype :qhdrptr (find-mactype '(:pointer :qhdr)))
(defrecord QHdr 
   (qFlags :signed-integer)
   (pad :signed-integer)
   (MutexID :signed-long)
   (qHead (:pointer :qelem))
   (qTail (:pointer :qelem))
   )

 |#                                             ; $ENDC; TARGET_OS_MAC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DeferredTaskProcPtr = PROCEDURE(dtParam: LONGINT);

|#
 |#                                             ; $ELSEC
(def-mactype :deferredtaskprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :deferredtaskupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :deferredtaskupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppDeferredTaskProcInfo #xB802)
; 
; 	 *  NewDeferredTaskUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewDeferredTaskProc 
(deftrap "_NewDeferredTaskUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeDeferredTaskUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeDeferredTaskUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeDeferredTaskUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallDeferredTaskProc 
(deftrap-inline "_InvokeDeferredTaskUPP" 
      ((dtParam :signed-long) (userRoutine :pointer)) 
  nil
   () )
(def-mactype :deferredtaskptr (find-mactype '(:pointer :deferredtask)))
(defrecord DeferredTask 
   (qLink (:pointer :qelem))
   (qType :signed-integer)
   (dtFlags :signed-integer)
   (dtAddr :pointer)
   (dtParam :signed-long)
   (dtReserved :signed-long)
   )

; $IFC TARGET_OS_MAC 
(def-mactype :machinelocationptr (find-mactype '(:pointer :machinelocation)))
(defrecord MachineLocation 
   (latitude :signed-long)
   (longitude :signed-long)
   (:variant 
      (
      (dlsDelta :signed-byte)                   ;   signed byte; daylight savings delta  
      )
      (
      (gmtDelta :signed-long)                   ;   use low 24-bits only  
      )
      )
   )

#|                                              ; $ELSEC
; 	
; 	    QuickTime 3.0:
; 	    Alignment of MachineLocation is weird. The union above used for delta
; 	    tends not to work on non-Mac compilers.
; 		
(defrecord MachineLocation 
   (latitude :signed-long)
   (longitude :signed-long)
   (delta :signed-long)                         ;   high byte is daylight savings delta, low 24-bits is GMT delta  
   )

 |#                                             ; $ENDC; TARGET_OS_MAC

; 
; 	 *  IsMetric()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_IsMetric" 
      ()
   (:stack :boolean)
   (:stack-trap #xA9ED (4 :signed-integer)))

; 
;  *  GetSysPPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetSysPPtr" 
      () 
  (:pointer :sysparmtype)
   (#x2EBC #x0 #x1F8) )

; 
;     NOTE: SysBeep() has been moved to Sound.h.  
;           We could not automatically #include Sound.h in this file
;           because Sound.h indirectly #include's OSUtils.h which
;           would make a circular include.
; 
; 
;  *  DTInstall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DTInstall" 
      ((dtTaskPtr (:pointer :deferredtask)))
   (:d0 :signed-integer)
   (:register-trap #xA082 :a0 dtTaskPtr))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  GetMMUMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetMMUMode" 
      () 
  :signed-byte
   (#x1EB8 #xCB2) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SwapMMUMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SwapMMUMode" 
      ((mode (:pointer :signed-byte))) 
  nil
   (#x205F #x1010 #xA05D #x1080) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  Delay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_Delay" 
      ((numTicks :unsigned-long) (finalTicks (:pointer :unsigned-long))) 
  nil
   (#x225F #x205F #xA03B #x2280) )

; 
;  *  WriteParam()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  Enqueue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_WriteParam" 
      () 
  :signed-integer
   () )
(deftrap-inline "_Enqueue" 
      ((qElement (:pointer :qelem)) (qHeader (:pointer :qhdr))) 
  nil
   (#x225F #x205F #xA96F) )

; 
;  *  Dequeue()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_Dequeue" 
      ((qElement (:pointer :qelem)) (qHeader (:pointer :qhdr))) 
  :signed-integer
   (#x225F #x205F #xA96E #x3E80) )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SetCurrentA5()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SetCurrentA5" 
      () 
  :signed-long
   (#x2E8D #x2A78 #x904) )

; 
;  *  SetA5()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SetA5" 
      ((newA5 :signed-long)) 
  :signed-long
   (#x2F4D #x4 #x2A5F) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  InitUtil()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_InitUtil" 
      () 
  :signed-integer
   (#xA03F #x3E80) )

; $IFC NOT TARGET_CPU_68K 
; 
;  *  MakeDataExecutable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MakeDataExecutable" 
      ((baseAddress :pointer) (length :unsigned-long)) 
  nil
   () )                                         ; $ENDC

#|                                              ; $IFC TARGET_CPU_68K 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SwapInstructionCache()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  SwapDataCache()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SwapInstructionCache" 
      ((cacheEnable :boolean)) 
  :boolean
   () )
(deftrap-inline "_SwapDataCache" 
      ((cacheEnable :boolean)) 
  :boolean
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  FlushInstructionCache()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_FlushInstructionCache" 
      () 
  nil
   (#x7001 #xA098) )

; 
;  *  FlushDataCache()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_FlushDataCache" 
      () 
  nil
   (#x7003 #xA098) )

; 
;  *  FlushCodeCache()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_FlushCodeCache" 
      ()
   nil
   (:stack-trap #xA0BD))

; $ENDC                                         ; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC; TARGET_CPU_68K

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  FlushCodeCacheRange()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_FlushCodeCacheRange" 
      ((address :pointer) (count :unsigned-long)) 
  :signed-integer
   (#x225F #x205F #x7009 #xA098 #x3E80) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  ReadLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_ReadLocation" 
      ((loc (:pointer :machinelocation))) 
  nil
   (#x205F #x203C #xC #xE4 #xA051) )

; 
;  *  WriteLocation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_WriteLocation" 
      ((loc (:pointer :machinelocation))) 
  nil
   (#x205F #x203C #xC #xE4 #xA052) )

; 
;  *  TickCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TickCount" 
      ()
   (:stack :unsigned-long)
   (:stack-trap #xA975))

; 
;  *  CSCopyUserName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CSCopyUserName" 
      ((useShortName :boolean)) 
  :pointer
   () )

; 
;  *  CSCopyMachineName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CSCopyMachineName" 
      () 
  :pointer
   () )

; $IFC OLDROUTINENAMES 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  IUMetric()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_IUMetric" 
      ()
   (:stack :boolean)
   (:stack-trap #xA9ED (4 :signed-integer)))

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; OLDROUTINENAMES

; 
;     NOTE: SysEnvirons is obsolete.  You should be using Gestalt.
; 
;  Environs Equates 

(defconstant $curSysEnvVers 2)                  ;  Updated to equal latest SysEnvirons version 

(def-mactype :sysenvrecptr (find-mactype '(:pointer :sysenvrec)))
(defrecord SysEnvRec 
   (environsVersion :signed-integer)
   (machineType :signed-integer)
   (systemVersion :signed-integer)
   (processor :signed-integer)
   (hasFPU :boolean)
   (hasColorQD :boolean)
   (keyBoardType :signed-integer)
   (atDrvrVersNum :signed-integer)
   (sysVRefNum :signed-integer)
   )

;   Machine Types  
(defconstant $envMac -1)
(defconstant $envXL -2)
(defconstant $envMachUnknown 0)
(defconstant $env512KE 1)
(defconstant $envMacPlus 2)
(defconstant $envSE 3)
(defconstant $envMacII 4)
(defconstant $envMacIIx 5)
(defconstant $envMacIIcx 6)
(defconstant $envSE30 7)
(defconstant $envPortable 8)
(defconstant $envMacIIci 9)
(defconstant $envMacIIfx 11)

;   CPU types  
(defconstant $envCPUUnknown 0)
(defconstant $env68000 1)
(defconstant $env68010 2)
(defconstant $env68020 3)
(defconstant $env68030 4)
(defconstant $env68040 5)

;   Keyboard types  
(defconstant $envUnknownKbd 0)
(defconstant $envMacKbd 1)
(defconstant $envMacAndPad 2)
(defconstant $envMacPlusKbd 3)
(defconstant $envAExtendKbd 4)
(defconstant $envStandADBKbd 5)
(defconstant $envPrtblADBKbd 6)
(defconstant $envPrtblISOKbd 7)
(defconstant $envStdISOADBKbd 8)
(defconstant $envExtISOADBKbd 9)

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  SysEnvirons()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_SysEnvirons" 
      ((versionRequested :signed-integer) (theWorld (:pointer :sysenvrec))) 
  :signed-integer
   (#x205F #x301F #xA090 #x3E80) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := OSUtilsIncludes

; $ENDC                                         ; __OSUTILS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'OSUtils)