(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:OpenTransportKernel.p"
; at Wednesday May 1,2002 2:42:13 pm.
; 
;      File:       OpenTransportKernel.p
;  
;      Contains:   Definitions for Open Transport kernel code, such as drivers and protocol modules.
;  
;      Version:    Technology: 2.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1993-2001 by Apple Computer, Inc. and Mentat Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __OPENTRANSPORTKERNEL__
; $SETC __OPENTRANSPORTKERNEL__ := 1

; $I+
; $SETC OpenTransportKernelIncludes := UsingIncludes
; $SETC UsingIncludes := 1

; $IFC NOT UNDEFINED OTKERNEL 
#|                                              ; $IFC NOT OTKERNEL 
 |#                                             ; $ENDC
; $ENDC

; $SETC OTKERNEL := 1 
; 
;    We include "OpenTransportProtocol.h", which in turn includes
;    "OpenTransport.h", thereby picking up all the stuff which
;    is shared between client and kernel.
; 
#|                                              ; $IFC UNDEFINED __OPENTRANSPORTPROTOCOL__
|#

(require-interface 'OpenTransportProtocol)
#|                                              ; $I OpenTransportProtocol.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __NAMEREGISTRY__
|#

(require-interface 'NameRegistry)
#|                                              ; $I NameRegistry.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; $ifc not undefined MWERKS and TARGET_CPU_68K
; $pragmac d0_pointers on
; $endc

;   ***** From the Mentat "mistream.h" ***** 

; 
;    Parts of "mistream.h" that are shared by the client
;    and the kernel are in "OpenTransportProtocol.h".
; 

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  allocb()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_allocb" 
      ((size :unsigned-long) (pri :signed-long)) 
  (:pointer :msgb)
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	allocbiProc = PROCEDURE(arg: CStringPtr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :allocbiproc (find-mactype ':pointer))
; $ENDC

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  allocbi()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_allocbi" 
      ((size :unsigned-long) (pri :signed-long) (pfv :pointer) (arg :pointer) (base (:pointer :unsigned-byte))) 
  (:pointer :msgb)
   () )

; 
;  *  allocq()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_allocq" 
      () 
  (:pointer :queue)
   () )

; 
;  *  adjmsg()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_adjmsg" 
      ((mp (:pointer :msgb)) (len_param :signed-long)) 
  :otint32
   () )

; 
;  *  backq()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_backq" 
      ((q (:pointer :queue))) 
  (:pointer :queue)
   () )

; 
;  *  bcanput()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_bcanput" 
      ((q (:pointer :queue)) (pri :unsigned-byte)) 
  :otint32
   () )

; 
;  *  bcanputnext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_bcanputnext" 
      ((q (:pointer :queue)) (pri :unsigned-byte)) 
  :otint32
   () )

; 
;  *  bufcall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_bufcall" 
      ((memNeeded :unsigned-long) (pri :signed-long) (proc :pointer) (context :signed-long)) 
  :otint32
   () )

; 
;  *  canput()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_canput" 
      ((q (:pointer :queue))) 
  :otint32
   () )

; 
;  *  canputnext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_canputnext" 
      ((q (:pointer :queue))) 
  :otint32
   () )

; 
;  *  copyb()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_copyb" 
      ((mp (:pointer :msgb))) 
  (:pointer :msgb)
   () )

; 
;  *  copymsg()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_copymsg" 
      ((mp (:pointer :msgb))) 
  (:pointer :msgb)
   () )

; 
;  *  dupb()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_dupb" 
      ((mp (:pointer :msgb))) 
  (:pointer :msgb)
   () )

; 
;  *  dupmsg()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_dupmsg" 
      ((mp (:pointer :msgb))) 
  (:pointer :msgb)
   () )

; 
;  *  esballoc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_esballoc" 
      ((base (:pointer :unsigned-byte)) (size :unsigned-long) (pri :signed-long) (freeInfo (:pointer :free_rtn))) 
  (:pointer :msgb)
   () )

; 
;  *  esballoca()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_esballoca" 
      ((base (:pointer :unsigned-byte)) (size :unsigned-long) (pri :signed-long) (freeInfo (:pointer :free_rtn))) 
  (:pointer :msgb)
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	esbbcallProc = PROCEDURE(arg: LONGINT); C;

|#
 |#                                             ; $ELSEC
(def-mactype :esbbcallproc (find-mactype ':pointer))
; $ENDC

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  esbbcall()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_esbbcall" 
      ((pri :signed-long) (func :pointer) (arg :signed-long)) 
  :otint32
   () )

; 
;  *  flushband()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_flushband" 
      ((q (:pointer :queue)) (pri :unsigned-byte) (flag :signed-long)) 
  nil
   () )

; 
;  *  flushq()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_flushq" 
      ((q (:pointer :queue)) (flag :signed-long)) 
  nil
   () )

; 
;  *  freeb()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_freeb" 
      ((mp (:pointer :msgb))) 
  nil
   () )

; 
;  *  freemsg()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_freemsg" 
      ((mp (:pointer :msgb))) 
  nil
   () )

; 
;  *  freeq()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_freeq" 
      ((q (:pointer :queue))) 
  :otint32
   () )

; 
;  *  freezestr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_freezestr" 
      ((q (:pointer :queue))) 
  :otint32
   () )

; 
;  *  getadmin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_getadmin" 
      ((mid :unsigned-integer)) 
  :pointer
   () )

; 
;  *  getmid()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_getmid" 
      ((name :pointer)) 
  :unsigned-integer
   () )

; 
;  *  getq()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_getq" 
      ((q (:pointer :queue))) 
  (:pointer :msgb)
   () )

; 
;  *  insq()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_insq" 
      ((q (:pointer :queue)) (emp (:pointer :msgb)) (nmp (:pointer :msgb))) 
  :otint32
   () )

; 
;  *  linkb()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_linkb" 
      ((mp1 (:pointer :msgb)) (mp2 (:pointer :msgb))) 
  nil
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	mpnotifyProc = PROCEDURE(arg: CStringPtr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :mpnotifyproc (find-mactype ':pointer))
; $ENDC

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  mpnotify()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_mpnotify" 
      ((mp (:pointer :msgb)) (pfv :pointer) (arg :pointer)) 
  :otint32
   () )

; 
;  *  msgdsize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_msgdsize" 
      ((mp (:pointer :msgb))) 
  :otint32
   () )

; 
;  *  msgpullup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_msgpullup" 
      ((mp (:pointer :msgb)) (len :signed-long)) 
  (:pointer :msgb)
   () )

; 
;  *  pullupmsg()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_pullupmsg" 
      ((mp (:pointer :msgb)) (len :signed-long)) 
  :otint32
   () )

; 
;  *  put()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_put" 
      ((q (:pointer :queue)) (mp (:pointer :msgb))) 
  :otint32
   () )

; 
;  *  putbq()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_putbq" 
      ((q (:pointer :queue)) (mp (:pointer :msgb))) 
  :otint32
   () )

; 
;  *  putctl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_putctl" 
      ((q (:pointer :queue)) (mType :signed-long)) 
  :otint32
   () )

; 
;  *  putnextctl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_putnextctl" 
      ((q (:pointer :queue)) (mType :signed-long)) 
  :otint32
   () )

; 
;  *  putctl1()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_putctl1" 
      ((q (:pointer :queue)) (mType :signed-long) (C :signed-long)) 
  :otint32
   () )

; 
;  *  putnextctl1()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_putnextctl1" 
      ((q (:pointer :queue)) (mType :signed-long) (C :signed-long)) 
  :otint32
   () )

; 
;  *  putctl2()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_putctl2" 
      ((q (:pointer :queue)) (mType :signed-long) (c1 :signed-long) (c2 :signed-long)) 
  :otint32
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC UNDEFINED puthere 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  puthere()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_puthere" 
      ((q (:pointer :queue)) (mp (:pointer :msgb))) 
  :otint32
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  putnext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_putnext" 
      ((q (:pointer :queue)) (mp (:pointer :msgb))) 
  :otint32
   () )

; 
;  *  putq()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_putq" 
      ((q (:pointer :queue)) (mp (:pointer :msgb))) 
  :otint32
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  qenable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_qenable" 
      ((q (:pointer :queue))) 
  nil
   () )

; 
;  *  qprocson()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_qprocson" 
      ((q (:pointer :queue))) 
  nil
   () )

; 
;  *  qprocsoff()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_qprocsoff" 
      ((q (:pointer :queue))) 
  nil
   () )

; 
;  *  qreply()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_qreply" 
      ((q (:pointer :queue)) (mp (:pointer :msgb))) 
  :otint32
   () )

; 
;  *  qsize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_qsize" 
      ((q (:pointer :queue))) 
  :otint32
   () )

; 
;  *  rmvb()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_rmvb" 
      ((mp (:pointer :msgb)) (bp (:pointer :msgb))) 
  (:pointer :msgb)
   () )

; 
;  *  rmvq()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_rmvq" 
      ((q (:pointer :queue)) (mp (:pointer :msgb))) 
  nil
   () )

;  prototype for strlog in "strlog.h" section, below 
; 
;  *  strqget()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_strqget" 
      ((q (:pointer :queue)) (what :signed-long) (pri :unsigned-byte) (valp (:pointer :signed-long))) 
  :otint32
   () )

; 
;  *  strqset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_strqset" 
      ((q (:pointer :queue)) (what :signed-long) (pri :unsigned-byte) (val :signed-long)) 
  :otint32
   () )

; 
;  *  testb()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_testb" 
      ((size :unsigned-long) (pri :signed-long)) 
  :otint32
   () )

; 
;  *  unbufcall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_unbufcall" 
      ((id :signed-long)) 
  nil
   () )

; 
;  *  unfreezestr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_unfreezestr" 
      ((q (:pointer :queue)) (oldpri :signed-long)) 
  nil
   () )

; 
;  *  unlinkb()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_unlinkb" 
      ((mp (:pointer :msgb))) 
  (:pointer :msgb)
   () )

;   ***** From the Mentat "strlog.h" ***** 

; $IFC NOT UNDEFINED MWERKS 
; 
;  *  strlog()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_strlog" 
      ((mid :signed-long) (sid :signed-long) (level :signed-long) (flags :unsigned-long) (fmt :pointer)) 
  :otint32
   () )

; $ENDC
;   ***** Printing Functions ***** 

; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $kOTPrintOnly 0)
(defconstant $kOTPrintThenStop 1)

; $IFC NOT UNDEFINED MWERKS 
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  OTKernelPrintf()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	


;; This form has been patched from OSX Drive:Users:bburns:Desktop:interface-translator:Patches:opentransportkernel.patch
#|(deftrap-inline "_OTKernelPrintf" 
      ((:dots :signed-long) (#\. :signed-long) (toDo :signed-long) (fmt :pointer)) 
  :otint32
   () )|#

;;; screwed up by ... = &rest?
(deftrap-inline "_OTKernelPrintf" 
      ((toDo :signed-long) (fmt :pointer)) 
  :otint32
   () )

; $ENDC
; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $CE_CONT 0)                        ;   Does kOTPrintOnly    
(defconstant $CE_NOTE 0)                        ;   Just print  
(defconstant $CE_WARN 1)                        ;   Does kOTPrintThenStop   
(defconstant $CE_PANIC 2)                       ;   Does System Error 107   

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  cmn_err()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	


;; This form has been patched from OSX Drive:Users:bburns:Desktop:interface-translator:Patches:opentransportkernel.patch
#|(deftrap-inline "_cmn_err" 
      ((:dots :signed-long) (#\. :signed-long) (errType :signed-long) (fmt :pointer)) 
  nil
   () )|#;; dots disease

(deftrap-inline "_cmn_err" 
      ((errType :signed-long) (fmt :pointer)) 
  nil
   () )

; $IFC NOT UNDEFINED MWERKS 
; 
;  *  mi_sprintf()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  


;; This form has been patched from OSX Drive:Users:bburns:Desktop:interface-translator:Patches:opentransportkernel.patch
#|(deftrap-inline "_mi_sprintf" 
      ((:dots :pointer) (#\. :pointer) (buf :pointer) (fmt :pointer)) 
  :otint32
   () )|#

(deftrap-inline "_mi_sprintf" 
      ((buf :pointer) (fmt :pointer)) 
  :otint32
   () )

; $ENDC
;   Create sprintf and printf functions that will work in STREAM modules. 

;   ***** FIIK ***** 

;    useful header comment please  

; 
;    Function to convert the "long" value that comes back in some of the
;    netbufs as a result code to the equivalent OSStatus
; 

; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :oterror (find-mactype ':signed-long))
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  OTErrorToOSStatus()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	


;; This form has been patched from OSX Drive:Users:bburns:Desktop:interface-translator:Patches:opentransportkernel.patch
#|(deftrap-inline "_OTErrorToOSStatus" 
      ((:dots :signed-long) (#\. :signed-long) (err :signed-long)) 
  :osstatus
   () )|#

(deftrap-inline "_OTErrorToOSStatus" 
      ( (err :signed-long)) 
  :osstatus
   () )

;   ***** STREAMS Plug-in Interface **** 

; 
;    Synchronization level codes.  These are supplied to modsw_install and
;    stored in the appropriate tables.  sth_osr_open and
;    sth_ipush use these to set up synch queue subordination for new devices
;    and modules.
; 

; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $SQLVL_QUEUE 1)
(defconstant $SQLVL_QUEUEPAIR 2)
(defconstant $SQLVL_MODULE 3)
(defconstant $SQLVL_GLOBAL 4)
(defconstant $SQLVL_DEFAULT 3)

;   The install_info structure. 

(def-mactype :install_infoptr (find-mactype '(:pointer :install_info)))
(defrecord install_info 
   (install_str (:pointer :streamtab))          ;   Streamtab pointer.      
   (install_flags :unsigned-long)
   (install_sqlvl :unsigned-long)               ;   Synchronization level.  
   (install_buddy :pointer)                     ;   Shared writer list buddy  
   (ref_load :signed-long)                      ;   Set to 0              
   (ref_count :unsigned-long)                   ;   set to 0              
   )

;    Flags used in the install_flags field 

(defconstant $kOTModIsDriver #x1)
(defconstant $kOTModIsModule #x2)
(defconstant $kOTModNoWriter #x10)
(defconstant $kOTModUpperIsTPI #x1000)
(defconstant $kOTModUpperIsDLPI #x2000)
(defconstant $kOTModLowerIsTPI #x4000)
(defconstant $kOTModLowerIsDLPI #x8000)
(defconstant $kOTModGlobalContext #x800000)     ;   This flag says you don't want per-context globals 
(defconstant $kOTModUsesInterrupts #x8000000)   ;   This flag is only valid if kOTModIsDriver is set and the driver is a PCI-card driver using the Name Registry 
(defconstant $kOTModIsComplexDriver #x20000000) ;   This flag is only valid if kOTModIsDriver is set. 
(defconstant $kOTModIsFilter #x40000000)        ;   This flag is only valid if kOTModIsModule is set. 

;   Typedef for the GetOTInstallInfo function 

; 
; 	   Your module must export this function, and return a pointer to the
; 	   install_info structure for the module.
; 	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	GetOTInstallInfoProcPtr = FUNCTION: install_infoPtr; C;

|#
 |#                                             ; $ELSEC
(def-mactype :getotinstallinfoprocptr (find-mactype ':pointer))
; $ENDC

;   Typedef for the InitStreamModule function 
; 
; 	   Your module can optionally export this function.  It will be called 
; 	   whenever your module is about to be loaded into a stream for the
; 	   first time, or if it is about to be reloaded after having been 
; 	   unloaded. Return false if your module should NOT be loaded.
; 	   For STREAMS modules, the void* parameter will be NULL.  For drivers, it
; 	   will be the same cookie parameter that was used for registering the module.
; 	   For PCI card drivers, this will be a pointer to the OTPCIInfo structure,
; 	   which can also be interpreted as a RegEntryIDPtr.
; 	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	InitStreamModuleProcPtr = FUNCTION(portInfo: UNIV Ptr): BOOLEAN; C;

|#
 |#                                             ; $ELSEC
(def-mactype :initstreammoduleprocptr (find-mactype ':pointer))
; $ENDC

;   Typedef for the TerminateStreamModule function 
; 
; 	   Your module can optionally export this function.  It will be called 
; 	   whenever your module has been closed for the last time (i.e. no other 
; 	   outstanding instances of the module exist).
; 	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TerminateStreamModuleProcPtr = PROCEDURE(portInfo: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :terminatestreammoduleprocptr (find-mactype ':pointer))
; $ENDC

;   Equates for shared library prefixes 

;   ***** Majors and Minors ***** 

;   Functions for dealing with major and minor device numbers 

(def-mactype :major_t (find-mactype ':unsigned-integer))
(def-mactype :minor_t (find-mactype ':unsigned-integer))
; 
; 	   This is the first minor number that Apple OT drivers use for CLONEOPENs.
; 	   Minor numbers 0 through 9 are reserved for use by the modules
; 	   for various control streams.  Note that Mentat drivers, which
; 	   use mi_open_comm, start minor numbers from 5.
; 	

(defconstant $kFirstMinorNumber 10)

;   ***** Logging Macros ***** 

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  OTStrlog()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_OTStrlog" 
      ((q (:pointer :queue)) (lvl :signed-long) (flags :signed-long) (str :pointer)) 
  nil
   () )

;   These are enums for the level value 

; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $kOTLvlFatal 0)
(defconstant $kOTLvlNonfatal 1)
(defconstant $kOTLvlExtFatal 2)
(defconstant $kOTLvlExtNonfatal 3)
(defconstant $kOTLvlUserErr 4)
(defconstant $kOTLvlInfoErr 5)
(defconstant $kOTLvlInfoOnly 6)

;   ***** TPI Additions ***** 

; 
; 	   Extra OTCommand codes that may appear on your module queue.
; 	   These are extensions to the TPI specification for Open Transport.
; 	   T_PRIVATE_REQ is the first available TPI message number for private
; 	   use by modules (assuming you don't want to be confused by standard
; 	   TPI messages).
; 	

(defconstant $kOTT_TIMER_REQ 80)                ;   Timer event                    
(defconstant $kOTT_MIB_REQ 81)                  ;   Request module's MIB              
(defconstant $kOTT_MIB_ACK 82)                  ;   The module's MIB is available    
(defconstant $kOTT_PRIVATE_REQ 90)              ;   The first private request available     

(def-mactype :t_mib_reqptr (find-mactype '(:pointer :t_mib_req)))
(defrecord T_MIB_req 
   (PRIM_type :signed-long)                     ;   Always T_MIB_REQ  
   )

(def-mactype :t_mib_ackptr (find-mactype '(:pointer :t_mib_ack)))
(defrecord T_MIB_ack 
   (PRIM_type :signed-long)                     ;   Always T_MIB_ACK    
   (MIB_length :signed-long)                    ;   MIB length           
   (MIB_offset :signed-long)                    ;   MIB Offset          
   )

(def-mactype :t_stream_timerptr (find-mactype '(:pointer :t_stream_timer)))
(defrecord T_stream_timer 
   (PRIM_type :signed-long)                     ;   Always T_TIMER_REQ  
   (:variant 
      (
      (USER_long :signed-long)
      )
      (
      (USER_ptr :pointer)
      )
      )
   )

;   ***** Kernel Port Stuff ***** 
; 
; 	   Kernel port record, which is a direct analogue of
; 	   the OTPortRecord in "OpenTransport.h".  Note that
; 	   when working with TPortRecord's, you're always
; 	   working with OT's one true copy of the record,
; 	   whereas when working with OTPortRecord's, you're
; 	   always working with a copy.
; 	

(def-mactype :tportrecordptr (find-mactype '(:pointer :tportrecord)))
(defrecord TPortRecord 
   (fLink :otlink)
   (fPortName :pointer)
   (fModuleName :pointer)
   (fResourceInfo :pointer)
   (fSlotID :pointer)
   (fAlias (:pointer :tportrecord))
   (fNumChildren :unsigned-long)
   (fChildPorts (:pointer :unsigned-long))
   (fPortFlags :unsigned-long)
   (fInfoFlags :unsigned-long)
   (fCapabilities :unsigned-long)
   (fRef :unsigned-long)
   (fStreamtab (:pointer :streamtab))
   (fContext :pointer)
   (fExtra :pointer)
   )

;   Port utilities 
; 
; 	   These routines can be used by kernel code to register, find and iterate
; 	   through the various ports on the machine.  Do not confuse these with
; 	   the client-side routines, defined in "OpenTransport.h".
; 	

; 
; 	   Register a port. The name the port was registered under is returned in
; 	   the fPortName field.  This routine allocates a TPortRecord and
; 	   copies the supplied OTPortRecord into it.
; 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  OTRegisterPort()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_OTRegisterPort" 
      ((portInfo (:pointer :otportrecord)) (ref :pointer)) 
  :osstatus
   () )

; 
;    Unregister the port with the given name (If you re-register the
;    port, it may get a different name - use OTChangePortState if
;    that is not desireable).  Since a single OTPortRef can be registered
;    with several names, the API needs to use the portName rather than
;    the OTPortRef to disambiguate.
; 
; 
;  *  OTUnregisterPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_OTUnregisterPort" 
      ((portName :pointer) (refPtr (:pointer :pointer))) 
  :osstatus
   () )

;   Change the state of the port. 
; 
;  *  OTChangePortState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_OTChangePortState" 
      ((portRef :unsigned-long) (theChange :unsigned-long) (why :signed-long)) 
  :osstatus
   () )

;   Find the TPortRecord for a given Port Name 
; 
;  *  OTFindPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  


;; This form has been patched from OSX Drive:Users:bburns:Desktop:interface-translator:Patches:opentransportkernel.patch
#|(deftrap-inline "_OTFindPort" 
      ((portName :pointer)) 
  (:pointer :tportrecord)
   () )|#
                                         
;   Find an OTPortRecord for a port using it's name 
(deftrap-inline "_OTFindPort" 
      ((portRecord (:pointer :otportrecord)) (portName :pointer)) 
  :boolean
   () )

;   Find the "nth" TPortRecord 
; 
;  *  OTGetIndexedPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  


;; This form has been patched from OSX Drive:Users:bburns:Desktop:interface-translator:Patches:opentransportkernel.patch
#|(deftrap-inline "_OTGetIndexedPort" 
      ((index :unsigned-long)) 
  (:pointer :tportrecord)
   () )|# 

;; these are from Opentransport - opentransportkernel has defs with different args.
;; what a horrible thing to do! there are others but not in carbon


(deftrap-inline "_OTGetIndexedPort" 
      ((portRecord (:pointer :otportrecord)) (index :unsigned-long)) 
  :boolean
   () )

; 
;    Find another port that is active and conflicts with
;    the port described by "ref"
; 
; 
;  *  OTFindPortConflict()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_OTFindPortConflict" 
      ((ref :unsigned-long)) 
  (:pointer :tportrecord)
   () )

;   Other ways of finding the port 
; 
;  *  OTFindPortByRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  


;; This form has been patched from OSX Drive:Users:bburns:Desktop:interface-translator:Patches:opentransportkernel.patch
#|(deftrap-inline "_OTFindPortByRef" 
      ((ref :unsigned-long)) 
  (:pointer :tportrecord)
   () )|#

;;; use the non  kernel def
(deftrap-inline "_OTFindPortByRef" 
      ((portRecord (:pointer :otportrecord)) (ref :unsigned-long)) 
  :boolean
   () )

; 
;  *  OTFindPortByDev()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_OTFindPortByDev" 
      ((dev :unsigned-long)) 
  (:pointer :tportrecord)
   () )

;   ***** Port Scanners ***** 

;   Shared library definitions 

; 
;    Prefix for Open Transport port scanners.
;    Your port-scanning ASLM function set must use the prefix kOTPortScannerPrefix.
; 

; 
;    The kOTPortScannerInterfaceID define is what you need to add to your
;    export file for the "interfaceID = " clause.  
; 

;   OTScanPorts entry point. 

;   Your port-scanning function must be exported by the name "OTScanPorts". 

;   Selectors for the scanType parameter to PortScanProcPtr. 

; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $kOTInitialScan 0)
(defconstant $kOTScanAfterSleep 1)

;   PortScanProcPtr is the typedef for the scanning function. 

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	PortScanProcPtr = PROCEDURE(scanType: UInt32); C;

|#
 |#                                             ; $ELSEC
(def-mactype :portscanprocptr (find-mactype ':pointer))
; $ENDC

; 
; 	   Memory allocation for port persistent data, such as the
; 	   memory referenced by the ref parameter you pass to
; 	   OTRegisterPort.
; 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  OTAllocPortMem()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_OTAllocPortMem" 
      ((size :unsigned-long)) 
  :pointer
   () )

; 
;  *  OTFreePortMem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_OTFreePortMem" 
      ((mem :pointer)) 
  nil
   () )

;   ***** Interrupt Control Functions **** 

; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC TARGET_CPU_68K 
; 
;    MPS_INTR_STATE saves the current interrupt state
;    Its definition changes with the definition
;    of mps_intr_enable/disable, so this typedef is
;    also inside the TARGET_CPU_68K conditional.
; 

(def-mactype :mps_intr_state (find-mactype ':unsigned-byte))
;   Disable interrupts and save the state 
; $IFC OTDEBUG 
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  mps_intr_disable()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_mps_intr_disable" 
      ((oldState (:pointer :mps_intr_state))) 
  nil
   () )
; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ELSEC
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  mps_intr_disable()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_mps_intr_disable" 
      ((oldState (:pointer :mps_intr_state))) 
  nil
   () )
; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; OTDEBUG
; 
;    move sr,d0
;    asr.w #8,d0
;    ori #$600,sr
;    andi #$FEFF,sr
;    move.b d0,(a0)
;    #if OTDEBUG
;        andi.b #$70,d0
;        cmpi.b #$70,d0
;        bne.s @3
;        DebugBreak
;    #endif
; 
;   Enable interrupts from the saved state 
; $IFC OTDEBUG 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  mps_intr_enable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mps_intr_enable" 
      ((oldState (:pointer :mps_intr_state))) 
  nil
   () )
; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ELSEC
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  mps_intr_enable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mps_intr_enable" 
      ((oldState (:pointer :mps_intr_state))) 
  nil
   () )
; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; OTDEBUG
; 
;    #if OTDEBUG
;        move sr,d0
;        andi.w #$700,d0
;        cmpi.w #$600,d0
;        beq.s @2
;        DebugBreak
;    #endif
;    move.b (a0),d0
;    #if OTDEBUG
;        andi.b #$70,d0
;        cmpi.b #$70,d0
;        bne.s @3
;        DebugBreak
;        move.b (a0),d0
;    #endif
;    asl.w #8,d0
;    move d0,sr
; 
 |#                                             ; $ELSEC

(def-mactype :mps_intr_state (find-mactype ':unsigned-byte))
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  mps_intr_disable()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_mps_intr_disable" 
      ((oldState (:pointer :unsigned-byte))) 
  nil
   () )

; 
;  *  mps_intr_enable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mps_intr_enable" 
      ((oldState (:pointer :unsigned-byte))) 
  nil
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; TARGET_CPU_68K

;   ***** Timer Functions ***** 

(defconstant $kOTMinimumTimerValue 8)           ;   8 milliseconds is the minimum timeout value 

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  mi_timer_alloc()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_mi_timer_alloc" 
      ((q (:pointer :queue)) (size :unsigned-long)) 
  (:pointer :msgb)
   () )

; 
;  *  mi_timer_free()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_timer_free" 
      ((mp (:pointer :msgb))) 
  nil
   () )

; 
;  *  mi_timer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_timer" 
      ((mp (:pointer :msgb)) (milliSeconds :unsigned-long)) 
  nil
   () )

; 
;  *  mi_timer_cancel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_timer_cancel" 
      ((mp (:pointer :msgb))) 
  :boolean
   () )

; 
;  *  mi_timer_valid()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_timer_valid" 
      ((mp (:pointer :msgb))) 
  :boolean
   () )

; 
;  *  mi_timer_q_switch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_timer_q_switch" 
      ((mp (:pointer :msgb)) (q (:pointer :queue)) (new_mp (:pointer :msgb))) 
  (:pointer :msgb)
   () )

;   ***** Driver Deferred Task Extras ***** 

; 
;    This routine is used by a driver at interrupt time to schedule
;    a deferred task to run their interrupt processing code.
; 
; 
;  *  OTScheduleDriverDeferredTask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_OTScheduleDriverDeferredTask" 
      ((dtCookie :signed-long)) 
  :boolean
   () )

;   ***** Driver Memory Routines ***** 

; 
;    These routines are different from the
;    similarly named routines in "OpenTransport.h" because they allocate
;    memory in the OT kernel pool.  See Technote  "Understanding
;    Open Transport Memory Management" for details.
; 

; 
;    This is the typedef for a function that will be called when a message
;    created by OTAllocMsg is destroyed.
; 

; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	EsbFreeProcPtr = PROCEDURE(arg: CStringPtr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :esbfreeprocptr (find-mactype ':pointer))
; $ENDC

; 
; 	   This function creates a message which points to "size" bytes of data
; 	   at "buf".  When the message is freed, the EsbFreeProcPtr function "func"
; 	   will be called with the argument "arg".
; 	   NOTE: This function allows users of your buffer to modify the buffer.
; 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  OTAllocMsg()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_OTAllocMsg" 
      ((buf :pointer) (size :unsigned-long) (func :pointer) (arg :pointer)) 
  (:pointer :msgb)
   () )

; 
;    Routines to allocate and free memory in your modules (these are
;    interrupt-time safe!).
; 

; 
;  *  OTAllocMem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_OTAllocMem" 
      ((size :unsigned-long)) 
  :pointer
   () )

; 
;  *  OTFreeMem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_OTFreeMem" 
      ((mem :pointer)) 
  nil
   () )

; 
;  *  OTReallocMem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_OTReallocMem" 
      ((Ptr :pointer) (newSize :unsigned-long)) 
  :pointer
   () )

; 
;    Also, make sure that calling traditional "C" allocation routines
;    will not compile.
; 

;   ***** Kernel Memory Utilities ***** 

; 
;  *  mi_bcmp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_bcmp" 
      ((first :pointer) (second :pointer) (nBytes :unsigned-long)) 
  :otint32
   () )

;   Standard STREAMS memory utilities. 

; 
;    Standard STREAMS bcopy, bzero, & bcmp take char* parameters.
;    The BCOPY, BZERO, and BCMP routines take void* so that we do not have
;    to cast all the pointers.
; 

; ******************************************************************************
; ** Some helpful utilites from Mentat
; *******************************************************************************
;   Routines to calculate various sizes of STREAM messages 

;   Useful macros for STREAMS copy in and out. 

; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	OTWriterProcPtr = PROCEDURE(VAR q: queue_t; VAR mp: mblk_t); C;

|#
 |#                                             ; $ELSEC
(def-mactype :otwriterprocptr (find-mactype ':pointer))
; $ENDC

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  mps_become_writer()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_mps_become_writer" 
      ((q (:pointer :queue)) (mp (:pointer :msgb)) (proc :pointer)) 
  nil
   () )

; 
;  *  drv_priv()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_drv_priv" 
      ((credp (:pointer :cred))) 
  :otint32
   () )

; 
;  *  mi_allocq()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_allocq" 
      ((st (:pointer :streamtab))) 
  (:pointer :queue)
   () )

; 
;  *  mi_tpi_ack_alloc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_tpi_ack_alloc" 
      ((mp (:pointer :msgb)) (size :unsigned-long) (primType :signed-long)) 
  (:pointer :msgb)
   () )

; 
;  *  mi_tpi_conn_con()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_tpi_conn_con" 
      ((trailer_mp (:pointer :msgb)) (src :pointer) (src_length :unsigned-long) (opt :pointer) (opt_length :unsigned-long)) 
  (:pointer :msgb)
   () )

; 
;  *  mi_tpi_conn_ind()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_tpi_conn_ind" 
      ((trailer_mp (:pointer :msgb)) (src :pointer) (src_length :unsigned-long) (opt :pointer) (opt_length :unsigned-long) (seqnum :signed-long)) 
  (:pointer :msgb)
   () )

; 
;  *  mi_tpi_conn_req()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_tpi_conn_req" 
      ((trailer_mp (:pointer :msgb)) (dest :pointer) (dest_length :unsigned-long) (opt :pointer) (opt_length :unsigned-long)) 
  (:pointer :msgb)
   () )

; 
;  *  mi_tpi_data_ind()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_tpi_data_ind" 
      ((trailer_mp (:pointer :msgb)) (flags :signed-long) (ptype :signed-long)) 
  (:pointer :msgb)
   () )

; 
;  *  mi_tpi_data_req()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_tpi_data_req" 
      ((trailer_mp (:pointer :msgb)) (flags :signed-long) (pttype :signed-long)) 
  (:pointer :msgb)
   () )

; 
;  *  mi_tpi_discon_ind()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_tpi_discon_ind" 
      ((trailer_mp (:pointer :msgb)) (reason :signed-long) (seqnum :signed-long)) 
  (:pointer :msgb)
   () )

; 
;  *  mi_tpi_discon_req()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_tpi_discon_req" 
      ((trailer_mp (:pointer :msgb)) (seqnum :signed-long)) 
  (:pointer :msgb)
   () )

; 
;  *  mi_tpi_err_ack_alloc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_tpi_err_ack_alloc" 
      ((mp (:pointer :msgb)) (tlierr :signed-long) (unixerr :signed-long)) 
  (:pointer :msgb)
   () )

; 
;  *  mi_tpi_exdata_ind()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_tpi_exdata_ind" 
      ((trailer_mp (:pointer :msgb)) (flags :signed-long) (ptype :signed-long)) 
  (:pointer :msgb)
   () )

; 
;  *  mi_tpi_exdata_req()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_tpi_exdata_req" 
      ((trailer_mp (:pointer :msgb)) (flags :signed-long) (ptype :signed-long)) 
  (:pointer :msgb)
   () )

; 
;  *  mi_tpi_info_req()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_tpi_info_req" 
      () 
  (:pointer :msgb)
   () )

; 
;  *  mi_tpi_ok_ack_alloc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_tpi_ok_ack_alloc" 
      ((mp (:pointer :msgb))) 
  (:pointer :msgb)
   () )

; 
;  *  mi_tpi_ordrel_ind()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_tpi_ordrel_ind" 
      () 
  (:pointer :msgb)
   () )

; 
;  *  mi_tpi_ordrel_req()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_tpi_ordrel_req" 
      () 
  (:pointer :msgb)
   () )

; 
;  *  mi_tpi_uderror_ind()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_tpi_uderror_ind" 
      ((dest :pointer) (dest_length :unsigned-long) (opt :pointer) (opt_length :unsigned-long) (error :signed-long)) 
  (:pointer :msgb)
   () )

; 
;  *  mi_tpi_unitdata_ind()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_tpi_unitdata_ind" 
      ((trailer_mp (:pointer :msgb)) (src :pointer) (src_length :unsigned-long) (opt :pointer) (opt_length :unsigned-long)) 
  (:pointer :msgb)
   () )

; 
;  *  mi_tpi_unitdata_req()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_tpi_unitdata_req" 
      ((trailer_mp (:pointer :msgb)) (dst :pointer) (dst_length :unsigned-long) (opt :pointer) (opt_length :unsigned-long)) 
  (:pointer :msgb)
   () )

; 
;  *  mi_reuse_proto()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_reuse_proto" 
      ((toReuse (:pointer :msgb)) (sizeDesired :unsigned-long) (keepOnError :boolean)) 
  (:pointer :msgb)
   () )

; 
;  *  mi_reallocb()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_reallocb" 
      ((old_mp (:pointer :msgb)) (new_size :unsigned-long)) 
  (:pointer :msgb)
   () )

; 
;  *  mi_set_sth_hiwat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_set_sth_hiwat" 
      ((q (:pointer :queue)) (size :unsigned-long)) 
  :boolean
   () )

; 
;  *  mi_set_sth_lowat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_set_sth_lowat" 
      ((q (:pointer :queue)) (size :unsigned-long)) 
  :boolean
   () )

; 
;  *  mi_set_sth_maxblk()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_set_sth_maxblk" 
      ((q (:pointer :queue)) (size :unsigned-long)) 
  :boolean
   () )

; 
;  *  mi_set_sth_wroff()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_set_sth_wroff" 
      ((q (:pointer :queue)) (size :unsigned-long)) 
  :boolean
   () )

; 
;  *  mi_offset_param()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_offset_param" 
      ((mp (:pointer :msgb)) (offset :signed-long) (len :signed-long)) 
  :pointer
   () )

; 
;  *  mi_offset_paramc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_offset_paramc" 
      ((mp (:pointer :msgb)) (offset :signed-long) (len :signed-long)) 
  :pointer
   () )

; 
;  *  mi_open_detached()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_open_detached" 
      ((mi_opp_orig (:pointer :pointer)) (size :unsigned-long) (devp (:pointer :unsigned-long))) 
  :pointer
   () )

; 
;  *  mi_open_comm()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_open_comm" 
      ((mi_opp_orig (:pointer :pointer)) (size :unsigned-long) (q (:pointer :queue)) (dev (:pointer :unsigned-long)) (flag :signed-long) (sflag :signed-long) (credp (:pointer :cred))) 
  :otint32
   () )

; 
;  *  mi_close_comm()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_close_comm" 
      ((mi_opp_orig (:pointer :pointer)) (q (:pointer :queue))) 
  :otint32
   () )

; 
;  *  mi_bufcall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_bufcall" 
      ((q (:pointer :queue)) (size :unsigned-long) (pri :signed-long)) 
  nil
   () )

; 
;  *  mi_detach()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_detach" 
      ((q (:pointer :queue)) (ptr :pointer)) 
  nil
   () )

; 
;  *  mi_close_detached()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_close_detached" 
      ((mi_opp_orig (:pointer :pointer)) (ptr :pointer)) 
  nil
   () )

; 
;  *  mi_next_ptr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_next_ptr" 
      ((ptr :pointer)) 
  :pointer
   () )

; 
;  *  mi_copyin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_copyin" 
      ((q (:pointer :queue)) (mp (:pointer :msgb)) (uaddr :pointer) (len :unsigned-long)) 
  nil
   () )

; 
;  *  mi_copyout()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_copyout" 
      ((q (:pointer :queue)) (mp (:pointer :msgb))) 
  nil
   () )

; 
;  *  mi_copyout_alloc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_copyout_alloc" 
      ((q (:pointer :queue)) (mp (:pointer :msgb)) (uaddr :pointer) (len :unsigned-long)) 
  (:pointer :msgb)
   () )

; 
;  *  mi_copy_done()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_copy_done" 
      ((q (:pointer :queue)) (mp (:pointer :msgb)) (err :signed-long)) 
  nil
   () )

; 
;  *  mi_copy_set_rval()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_copy_set_rval" 
      ((mp (:pointer :msgb)) (rval :signed-long)) 
  nil
   () )

; 
;  *  mi_copy_state()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_mi_copy_state" 
      ((q (:pointer :queue)) (mp (:pointer :msgb)) (mpp (:pointer :pointer))) 
  :otint32
   () )

;   ***** PCI-Specific Stuff 

;   This is the cookie that is passed to your STREAM Module. 

; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :otpciinfoptr (find-mactype '(:pointer :otpciinfo)))
(defrecord OTPCIInfo 
   (fTheID :regentryid)
   (fConfigurationInfo :pointer)
   (fConfigurationLength :unsigned-long)
   )

;   Driver Description 
; 
; 	   All PCI card drivers should have the following bits set in their
; 	   install_info structure:
; 	   
; 	   o kOTModIsDriver.
; 	   
; 	   They should NEVER have the kOTModPushAlways or the kOTModIsModule
; 	   flags set.
; 	   The kOTModIsLowerMux bits should be set if the driver is a lower
; 	   multiplexor, although Open Transport does nothing with the information
; 	   today.
; 	   The kOTModUpperIsDLPI bit should be set if the driver uses the DLPI message
; 	   specification.  The kOTModUpperIsTPI bit should be set if the driver uses
; 	   the TPI message specification.
; 	

; 
; 	   Macro to put together the driverServices.service[x].serviceType field:
; 	   xxxxxddd dddddddd ffffffff xxxxxxTD
; 	   where "d" is the device type for Open Transport,
; 	   the lower two bits are whether the driver is TPI or DLPI,
; 	   and the "f" bits are the framing option flags.
; 	   and all other bits should be 0
; 	

; 
; 	   Typedef for the ValidateHardware function.  This function will be
; 	   called only once, at system boot time, before installing your driver
; 	   into the Open Transport module registry.
; 	   The param pointer will is a OTPCIInfo pointer - don't be changing the
; 	   values there!
; 	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ValidateHardwareProcPtr = FUNCTION(VAR param: OTPCIInfo): OTResult; C;

|#
 |#                                             ; $ELSEC
(def-mactype :validatehardwareprocptr (find-mactype ':pointer))
; $ENDC

; 
; 	   Your driver can return this value if it loaded correctly
; 	   but wants to stay resident, presumably because it's hooked
; 	   itself irrevokably into some other system service.
; 	

(defconstant $kOTPCINoErrorStayLoaded 1)

; 
; 	   Some descriptors we use - these should eventually show up
; 	   in system header files somewhere.
; 	

; 
; 	   Maximum # of services support by Open Transport.  If your module
; 	   exports more than this # of services, Open Transport will not be
; 	   able to use the module.
; 	

(defconstant $kMaxServices 20)

; $ifc not undefined MWERKS and TARGET_CPU_68K
; $pragmac d0_pointers reset
; $endc

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := OpenTransportKernelIncludes

; $ENDC                                         ; __OPENTRANSPORTKERNEL__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'OpenTransportKernel)