(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:PCI.p"
; at Wednesday May 1,2002 2:42:17 pm.
; 
;      File:       PCI.p
;  
;      Contains:   PCI Bus Interfaces.
;  
;      Version:    Technology: PowerSurge 1.0.2
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1993-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __PCI__
; $SETC __PCI__ := 1

; $I+
; $SETC PCIIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __NAMEREGISTRY__
|#

(require-interface 'NameRegistry)
#|                                              ; $I NameRegistry.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;   Definitions for the PCI Config Registers 

(defconstant $kPCIConfigVendorID #x0)
(defconstant $kPCIConfigDeviceID #x2)
(defconstant $kPCIConfigCommand #x4)
(defconstant $kPCIConfigStatus #x6)
(defconstant $kPCIConfigRevisionID #x8)
(defconstant $kPCIConfigClassCode #x9)
(defconstant $kPCIConfigCacheLineSize #xC)
(defconstant $kPCIConfigLatencyTimer #xD)
(defconstant $kPCIConfigHeaderType #xE)
(defconstant $kPCIConfigBIST #xF)
(defconstant $kPCIConfigBaseAddress0 #x10)
(defconstant $kPCIConfigBaseAddress1 #x14)
(defconstant $kPCIConfigBaseAddress2 #x18)
(defconstant $kPCIConfigBaseAddress3 #x1C)
(defconstant $kPCIConfigBaseAddress4 #x20)
(defconstant $kPCIConfigBaseAddress5 #x24)
(defconstant $kPCIConfigCardBusCISPtr #x28)
(defconstant $kPCIConfigSubSystemVendorID #x2C)
(defconstant $kPCIConfigSubSystemID #x2E)
(defconstant $kPCIConfigExpansionROMBase #x30)
(defconstant $kPCIConfigCapabilitiesPtr #x34)
(defconstant $kPCIConfigInterruptLine #x3C)
(defconstant $kPCIConfigInterruptPin #x3D)
(defconstant $kPCIConfigMinimumGrant #x3E)
(defconstant $kPCIConfigMaximumLatency #x3F)

;   Definitions for the Capabilities PCI Config Register 
(defconstant $kPCICapabilityIDOffset #x0)
(defconstant $kPCINextCapabilityOffset #x1)
(defconstant $kPCIPowerManagementCapability #x1)
(defconstant $kPCIAGPCapability #x2)

;   Types and structures for accessing the PCI Assigned-Address property. 

(defconstant $kPCIRelocatableSpace #x80)
(defconstant $kPCIPrefetchableSpace #x40)
(defconstant $kPCIAliasedSpace #x20)
(defconstant $kPCIAddressTypeCodeMask #x3)
(defconstant $kPCIConfigSpace 0)
(defconstant $kPCIIOSpace 1)
(defconstant $kPCI32BitMemorySpace 2)
(defconstant $kPCI64BitMemorySpace 3)

(def-mactype :pciaddressspaceflags (find-mactype ':unsigned-byte))

(defconstant $kPCIDeviceNumberMask #x1F)
(defconstant $kPCIFunctionNumberMask #x7)

(def-mactype :pcidevicefunction (find-mactype ':unsigned-byte))
(def-mactype :pcibusnumber (find-mactype ':unsigned-byte))
(def-mactype :pciregisternumber (find-mactype ':unsigned-byte))
(def-mactype :pciassignedaddressptr (find-mactype '(:pointer :pciassignedaddress)))
(defrecord PCIAssignedAddress 
   (addressSpaceFlags :unsigned-byte)
   (busNumber :unsigned-byte)
   (deviceFunctionNumber :unsigned-byte)
   (registerNumber :unsigned-byte)
   (address :unsignedwide)
   (size :unsignedwide)
   )

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  EndianSwap16Bit()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in PCILib 1.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_EndianSwap16Bit" 
      ((data16 :unsigned-integer))
   (:d0 :unsigned-integer)
   (:register-trap #xE158 :d0 data16))

; 
;  *  EndianSwap32Bit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCILib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EndianSwap32Bit" 
      ((data32 :unsigned-long)) 
  :unsigned-long
   (#x201F #xE158 #x4840 #xE158 #x2E80) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  ExpMgrConfigReadByte()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCILib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ExpMgrConfigReadByte" 
      ((node (:pointer :regentryid)) (configAddr :pointer) (valuePtr (:pointer :unsigned-byte)))
   (:stack :signed-integer)
   (:stack-trap #xAAF3 :d0 1568 node configAddr valuePtr))

; 
;  *  ExpMgrConfigReadWord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCILib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ExpMgrConfigReadWord" 
      ((node (:pointer :regentryid)) (configAddr :pointer) (valuePtr (:pointer :unsigned-integer)))
   (:stack :signed-integer)
   (:stack-trap #xAAF3 :d0 1569 node configAddr valuePtr))

; 
;  *  ExpMgrConfigReadLong()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCILib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ExpMgrConfigReadLong" 
      ((node (:pointer :regentryid)) (configAddr :pointer) (valuePtr (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xAAF3 :d0 1570 node configAddr valuePtr))

; 
;  *  ExpMgrConfigWriteByte()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCILib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ExpMgrConfigWriteByte" 
      ((node (:pointer :regentryid)) (configAddr :pointer) (value :signed-byte))
   (:stack :signed-integer)
   (:stack-trap #xAAF3 :d0 1315 node configAddr value))

; 
;  *  ExpMgrConfigWriteWord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCILib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ExpMgrConfigWriteWord" 
      ((node (:pointer :regentryid)) (configAddr :pointer) (value :unsigned-integer))
   (:stack :signed-integer)
   (:stack-trap #xAAF3 :d0 1316 node configAddr value))

; 
;  *  ExpMgrConfigWriteLong()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCILib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ExpMgrConfigWriteLong" 
      ((node (:pointer :regentryid)) (configAddr :pointer) (value :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xAAF3 :d0 1573 node configAddr value))

; 
;  *  ExpMgrIOReadByte()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCILib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ExpMgrIOReadByte" 
      ((node (:pointer :regentryid)) (ioAddr :pointer) (valuePtr (:pointer :unsigned-byte)))
   (:stack :signed-integer)
   (:stack-trap #xAAF3 :d0 1574 node ioAddr valuePtr))

; 
;  *  ExpMgrIOReadWord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCILib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ExpMgrIOReadWord" 
      ((node (:pointer :regentryid)) (ioAddr :pointer) (valuePtr (:pointer :unsigned-integer)))
   (:stack :signed-integer)
   (:stack-trap #xAAF3 :d0 1575 node ioAddr valuePtr))

; 
;  *  ExpMgrIOReadLong()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCILib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ExpMgrIOReadLong" 
      ((node (:pointer :regentryid)) (ioAddr :pointer) (valuePtr (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xAAF3 :d0 1576 node ioAddr valuePtr))

; 
;  *  ExpMgrIOWriteByte()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCILib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ExpMgrIOWriteByte" 
      ((node (:pointer :regentryid)) (ioAddr :pointer) (value :signed-byte))
   (:stack :signed-integer)
   (:stack-trap #xAAF3 :d0 1321 node ioAddr value))

; 
;  *  ExpMgrIOWriteWord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCILib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ExpMgrIOWriteWord" 
      ((node (:pointer :regentryid)) (ioAddr :pointer) (value :unsigned-integer))
   (:stack :signed-integer)
   (:stack-trap #xAAF3 :d0 1322 node ioAddr value))

; 
;  *  ExpMgrIOWriteLong()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCILib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ExpMgrIOWriteLong" 
      ((node (:pointer :regentryid)) (ioAddr :pointer) (value :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xAAF3 :d0 1579 node ioAddr value))

; 
;  *  ExpMgrInterruptAcknowledgeReadByte()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCILib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ExpMgrInterruptAcknowledgeReadByte" 
      ((entry (:pointer :regentryid)) (valuePtr (:pointer :unsigned-byte)))
   (:stack :signed-integer)
   (:stack-trap #xAAF3 :d0 1041 entry valuePtr))

; 
;  *  ExpMgrInterruptAcknowledgeReadWord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCILib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ExpMgrInterruptAcknowledgeReadWord" 
      ((entry (:pointer :regentryid)) (valuePtr (:pointer :unsigned-integer)))
   (:stack :signed-integer)
   (:stack-trap #xAAF3 :d0 1042 entry valuePtr))

; 
;  *  ExpMgrInterruptAcknowledgeReadLong()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCILib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ExpMgrInterruptAcknowledgeReadLong" 
      ((entry (:pointer :regentryid)) (valuePtr (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xAAF3 :d0 1043 entry valuePtr))

; 
;  *  ExpMgrSpecialCycleWriteLong()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCILib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ExpMgrSpecialCycleWriteLong" 
      ((entry (:pointer :regentryid)) (value :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xAAF3 :d0 1049 entry value))

; 
;  *  ExpMgrSpecialCycleBroadcastLong()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PCILib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ExpMgrSpecialCycleBroadcastLong" 
      ((value :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xAAF3 :d0 538 value))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := PCIIncludes

; $ENDC                                         ; __PCI__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'PCI)