(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:PMCore.p"
; at Wednesday May 1,2002 2:40:45 pm.
; 
;      File:       PMCore.p
;  
;      Contains:   Carbon Printing Manager Interfaces.
;  
;      Version:    Technology: Mac OS X
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1998-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
;
;; hand edited to include both session and non session APIs
 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __PMCORE__
; $SETC __PMCORE__ := 1

; $I+
; $SETC PMCoreIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CMAPPLICATION__
|#

(require-interface 'CMApplication)
#|                                              ; $I CMApplication.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __PMDEFINITIONS__

(require-interface 'PMDefinitions)              ; $I PMDefinitions.p
; $ENDC
#|                                              ; $IFC UNDEFINED __CFSTRING__
|#

(require-interface 'CFString)
#|                                              ; $I CFString.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFURL__
|#

(require-interface 'CFURL)
#|                                              ; $I CFURL.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; $IFC UNDEFINED PM_USE_SESSION_APIS 
; $SETC PM_USE_SESSION_APIS := 1 
; $ENDC

;  Callbacks 

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	PMIdleProcPtr = PROCEDURE;

|#
 |#                                             ; $ELSEC
(def-mactype :pmidleprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :pmidleupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :pmidleupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppPMIdleProcInfo #x0)
; 
; 	 *  NewPMIdleUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;  *  DisposePMIdleUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_NewPMIdleUPP" 
      ((userRoutine :pointer)) 
  :pointer
   () )                                         ; 
;  *  InvokePMIdleUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DisposePMIdleUPP" 
      ((userUPP :pointer)) 
  nil
   () )                                         ; $IFC PM_USE_SESSION_APIS ;  Session routines ;  Session support ; 
;  *  PMRetain()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InvokePMIdleUPP" 
      ((userRoutine :pointer)) 
  nil
   () )                                         ; 
;  *  PMRelease()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMRetain" 
      ((object :pointer)) 
  :osstatus
   () )                                         ;  Session Print loop ; **********************;  A session is created with a refcount of 1. ; **********************; 
;  *  PMCreateSession()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMRelease" 
      ((object :pointer)) 
  :osstatus
   () )                                         ;  Session PMPageFormat ; **********************;  A pageformat is created with a refcount of 1. ; **********************; 
;  *  PMCreatePageFormat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMCreateSession" 
      ((printSession (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  PMSessionDefaultPageFormat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMCreatePageFormat" 
      ((pageFormat (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  PMSessionValidatePageFormat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionDefaultPageFormat" 
      ((printSession :pointer) (pageFormat :pointer)) 
  :osstatus
   () )                                         ;  Session PMPrintSettings ; **********************;  A printSettings is created with a refcount of 1. ; **********************; 
;  *  PMCreatePrintSettings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionValidatePageFormat" 
      ((printSession :pointer) (pageFormat :pointer) (result (:pointer :boolean))) 
  :osstatus
   () )                                         ; 
;  *  PMSessionDefaultPrintSettings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMCreatePrintSettings" 
      ((printSettings (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  PMSessionValidatePrintSettings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionDefaultPrintSettings" 
      ((printSession :pointer) (printSettings :pointer)) 
  :osstatus
   () )                                         ;  Session Classic support ; 
;  *  PMSessionGeneral()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionValidatePrintSettings" 
      ((printSession :pointer) (printSettings :pointer) (result (:pointer :boolean))) 
  :osstatus
   () )                                         ; 
;  *  PMSessionConvertOldPrintRecord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionGeneral" 
      ((printSession :pointer) (pData :pointer)) 
  :osstatus
   () )                                         ; 
;  *  PMSessionMakeOldPrintRecord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionConvertOldPrintRecord" 
      ((printSession :pointer) (printRecordHandle :handle) (printSettings (:pointer :pointer)) (pageFormat (:pointer :pointer))) 
  :osstatus
   () )                                         ;  Session Driver Information ; 
;  *  PMPrinterGetDescriptionURL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionMakeOldPrintRecord" 
      ((printSession :pointer) (printSettings :pointer) (pageFormat :pointer) (printRecordHandle (:pointer :handle))) 
  :osstatus
   () )                                         ; 
;  *  PMSessionGetCurrentPrinter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMPrinterGetDescriptionURL" 
      ((printer :pointer) (descriptionType :pointer) (fileURL (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  PMPrinterGetLanguageInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionGetCurrentPrinter" 
      ((printSession :pointer) (currentPrinter (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  PMPrinterGetDriverCreator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMPrinterGetLanguageInfo" 
      ((printer :pointer) (info (:pointer :pmlanguageinfo))) 
  :osstatus
   () )                                         ; 
;  *  PMPrinterGetDriverReleaseInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMPrinterGetDriverCreator" 
      ((printer :pointer) (creator (:pointer :ostype))) 
  :osstatus
   () )                                         ; 
;  *  PMPrinterGetPrinterResolutionCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMPrinterGetDriverReleaseInfo" 
      ((printer :pointer) (release (:pointer :versrec))) 
  :osstatus
   () )                                         ; 
;  *  PMPrinterGetPrinterResolution()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMPrinterGetPrinterResolutionCount" 
      ((printer :pointer) (count (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  PMPrinterGetIndexedPrinterResolution()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMPrinterGetPrinterResolution" 
      ((printer :pointer) (tag :unsigned-long) (res (:pointer :pmresolution))) 
  :osstatus
   () )                                         ;  Session ColorSync & PostScript Support ; 
;  *  PMSessionEnableColorSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMPrinterGetIndexedPrinterResolution" 
      ((printer :pointer) (index :unsigned-long) (res (:pointer :pmresolution))) 
  :osstatus
   () )                                         ; 
;  *  PMSessionDisableColorSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionEnableColorSync" 
      ((printSession :pointer)) 
  :osstatus
   () )                                         ; 
;  *  PMSessionPostScriptBegin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionDisableColorSync" 
      ((printSession :pointer)) 
  :osstatus
   () )                                         ; 
;  *  PMSessionPostScriptEnd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionPostScriptBegin" 
      ((printSession :pointer)) 
  :osstatus
   () )                                         ; 
;  *  PMSessionPostScriptHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionPostScriptEnd" 
      ((printSession :pointer)) 
  :osstatus
   () )                                         ; 
;  *  PMSessionPostScriptData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionPostScriptHandle" 
      ((printSession :pointer) (psHandle :handle)) 
  :osstatus
   () )                                         ; 
;  *  PMSessionPostScriptFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionPostScriptData" 
      ((printSession :pointer) (psPtr :pointer) (len :signed-long)) 
  :osstatus
   () )                                         ; 
;  *  PMSessionSetPSInjectionData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionPostScriptFile" 
      ((printSession :pointer) (psFile (:pointer :fsspec))) 
  :osstatus
   () )                                         ;  Session Error ; 
;  *  PMSessionError()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionSetPSInjectionData" 
      ((printSession :pointer) (printSettings :pointer) (injectionDictArray :pointer)) 
  :osstatus
   () )                                         ; 
;  *  PMSessionSetError()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionError" 
      ((printSession :pointer)) 
  :osstatus
   () )                                         ;  Other Session routines ; 
;  *  PMSessionGetDocumentFormatGeneration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionSetError" 
      ((printSession :pointer) (printError :signed-long)) 
  :osstatus
   () )                                         ; 
;  *  PMSessionSetDocumentFormatGeneration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionGetDocumentFormatGeneration" 
      ((printSession :pointer) (docFormats (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  PMSessionGetDocumentFormatSupported()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionSetDocumentFormatGeneration" 
      ((printSession :pointer) (docFormat :pointer) (graphicsContextTypes :pointer) (options :pointer)) 
  :osstatus
   () )                                         ; 
;  *  PMSessionIsDocumentFormatSupported()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionGetDocumentFormatSupported" 
      ((printSession :pointer) (docFormats (:pointer :pointer)) (limit :unsigned-long)) 
  :osstatus
   () )                                         ; 
;  *  PMSessionGetGraphicsContext()
;  *  
;  *  Parameters:
;  *    
;  *    printSession:
;  *      the session
;  *    
;  *    graphicsContextType:
;  *      either kPMGraphicsContextQuickdraw or
;  *      kPMGraphicsContextCoreGraphics
;  *    
;  *    graphicsContext:
;  *      returns a GrafPtr or a CGContextRef
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionIsDocumentFormatSupported" 
      ((printSession :pointer) (docFormat :pointer) (supported (:pointer :boolean))) 
  :osstatus
   () )                                         ; 
;  *  PMSessionSetIdleProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionGetGraphicsContext" 
      ((printSession :pointer) (graphicsContextType :pointer) (graphicsContext (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  PMSessionSetDataInSession()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionSetIdleProc" 
      ((printSession :pointer) (idleProc :pointer)) 
  :osstatus
   () )                                         ; 
;  *  PMSessionGetDataFromSession()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionSetDataInSession" 
      ((printSession :pointer) (key :pointer) (data :pointer)) 
  :osstatus
   () )                                         ; 
;  *  PMSessionCreatePrinterList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionGetDataFromSession" 
      ((printSession :pointer) (key :pointer) (data (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  PMSessionSetCurrentPrinter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.4 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionCreatePrinterList" 
      ((printSession :pointer) (printerList (:pointer :pointer)) (currentIndex (:pointer :signed-long)) (currentPrinter (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  PMSessionSetDestination()
;  *  
;  *  Summary:
;  *    Alter a print session and print settings so that an associated
;  *    print job is sent to the provided destination type in the,
;  *    optional, MIME document format.
;  *  
;  *  Discussion:
;  *    This function is most useful when an application would like to
;  *    write its print output to disk without requiring user
;  *    interaction. The list of MIME types that can be sent to the
;  *    provided destination can be obtained from
;  *    PMSessionCopyOutputFormatList and one of these passed to this
;  *    function.
;  *  
;  *  Parameters:
;  *    
;  *    printSession:
;  *      The session to be used for a print job. The session holds the
;  *      preview setting which can override the destination type in the
;  *      print settings.
;  *    
;  *    printSettings:
;  *      The print settings to be used for a print job. The print
;  *      settings specify whether a job will be directed toward a
;  *      printer or to file. It also holds the requested MIME output
;  *      type.
;  *    
;  *    destType:
;  *      The destiation type for a print job associated with the
;  *      provided print session and print settings. Fax is currently not
;  *      supported, but kPMDestinationPrinter, kPMDestinationFile, and
;  *      kPMDestinationPreview can be set.
;  *    
;  *    destFormat:
;  *      The MIME type to be generated for the provided destination
;  *      type. This parameter can be NULL in which the default format
;  *      for the requested destination type is used. To obtain a list of
;  *      valid formats for a given destiation type, use the function
;  *      PMSessionCopyOutputFormatList.
;  *    
;  *    destLocation:
;  *      Some destination types support a destination location. The
;  *      clearest example is the kPMDestinationFile destination type
;  *      which allows a caller to also supply a file URL specifying
;  *      where the output file is to be created.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionSetCurrentPrinter" 
      ((session :pointer) (printerName :pointer)) 
  :osstatus
   () )                                         ; 
;  *  PMSessionGetDestinationType()
;  *  
;  *  Summary:
;  *    Hand back the destination type that will be used for a print job
;  *    with the specified print settings and print session.
;  *  
;  *  Discussion:
;  *    Currently there are four destination types:
;  *    kPMDestinationPrinter, kPMDestinationFile, kPMDestinationFax and
;  *    kPMDestinationPreview. The first three destination types are
;  *    stored in the print settings. The switch for preview is stored in
;  *    the print session and, if enabled, overrides the destination in
;  *    the print setting. This function is preferred over
;  *    PMGetDestination as the latter does not take a print session
;  *    parameter and therefore can not indicate whether preview has been
;  *    selected as the destination.
;  *  
;  *  Parameters:
;  *    
;  *    printSession:
;  *      The session to be used for a print job. The session holds the
;  *      preview setting which can override the destination type in the
;  *      print settings.
;  *    
;  *    printSettings:
;  *      The print settings to be used for a print job. The print
;  *      settings specify whether a job will be directed toward a
;  *      printer or to file.
;  *    
;  *    destTypeP:
;  *      A pointer to a caller supplied PMDestinationType variable. If
;  *      this function succeeds then *'destTypeP' will be filled in with
;  *      the destination type for a print job that used the specified
;  *      session and print settings. If this function fails, then
;  *      *'destType' will be set to kPMDestinationInvalid.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionSetDestination" 
      ((printSession :pointer) (printSettings :pointer) (destType :unsigned-integer) (destFormat :pointer) (destLocation :pointer)) 
  :osstatus
   () )                                         ; 
;  *  PMSessionCopyDestinationFormat()
;  *  
;  *  Summary:
;  *    Hand back the destination output MIME type associated with the
;  *    provided print session and print settings.
;  *  
;  *  Parameters:
;  *    
;  *    printSession:
;  *      A currently open print session.
;  *    
;  *    printSettings:
;  *      The print settings that are to be searched.
;  *    
;  *    destFormatP:
;  *      A pointer to a caller allocated CFStringRef variable. If this
;  *      routine returns noErr then *'destFormatP' will either be a copy
;  *      of a CFStringRef specifying the output format for the print
;  *      job, or NULL indicating that the default output format will be
;  *      used. If this function return an error, then *'destFormatP'
;  *      will be set to NULL.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionGetDestinationType" 
      ((printSession :pointer) (printSettings :pointer) (destTypeP (:pointer :unsigned-integer))) 
  :osstatus
   () )                                         ; 
;  *  PMSessionCopyDestinationLocation()
;  *  
;  *  Summary:
;  *    Hand back the URL destination location given a print session and
;  *    print settings.
;  *  
;  *  Discussion:
;  *    Some destination type support a destination location which
;  *    further defines where the output from a pritn job should be sent.
;  *    The kPMDestinationFile destiation type, for example, will use a
;  *    file URL to determine where a new file should be created.
;  *  
;  *  Parameters:
;  *    
;  *    printSession:
;  *      A currently open print session.
;  *    
;  *    printSettings:
;  *      The print settings that are to be searched.
;  *    
;  *    destLocationP:
;  *      A pointer to a caller allocated CFURLRef variable. If this
;  *      routine returns noErr then *'outputFileP' will either be NULL
;  *      indicating that the job is using the default destination
;  *      location for the current destination type or a copy of a
;  *      CFURLRef will be placed in *'destLocationP'. If this function
;  *      returns an error then 'destLocationP' will be set to NULL.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.5 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionCopyDestinationFormat" 
      ((printSession :pointer) (printSettings :pointer) (destFormatP (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  PMSessionCopyOutputFormatList()
;  *  
;  *  Summary:
;  *    Hands back an an array of MIME types describing the possible
;  *    output formats for the printer module associated with the current
;  *    printer.
;  *  
;  *  Parameters:
;  *    
;  *    printSession:
;  *      This session's current printer's printer module will be queried
;  *      for its supported output MIME types.
;  *    
;  *    destType:
;  *      A print job can have one of several possible destination types.
;  *      The list of valid output formats is dependent upon the
;  *      destination type. This parameter specifies destination type of
;  *      interest when retrieving the output formats list.
;  *    
;  *    documentFormatP:
;  *      A pointer to a caller's CFArrayRef variable. If this routine
;  *      completes successfully, then *'documentFormatP' will be set to
;  *      a CFArrayRef containing CFStringRefs. Each CFStringRef in the
;  *      array is a MIME type specifying a type of output that can be
;  *      generated by the printer module associated with the current
;  *      printer.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionCopyDestinationLocation" 
      ((printSession :pointer) (printSettings :pointer) (destLocationP (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  PMSessionCreatePageFormatList()
;  *  
;  *  Summary:
;  *    Hand back a list of page format instances. Each page format
;  *    instance describes a paper size available on the specified
;  *    printer.
;  *  
;  *  Parameters:
;  *    
;  *    printSession:
;  *      A currently open print session.
;  *    
;  *    printer:
;  *      The printer whose page size list should be enumerated. To get
;  *      the session's current printer, see PMSessionGetCurrentPrinter().
;  *    
;  *    pageFormatList:
;  *      If this function is successful then noErr will be returned and
;  *      *'pageFormatList' will be set to a newly created CFArray. Each
;  *      element in the array will be a PMPageFormat describing an
;  *      available paper size for the specified printer. If this
;  *      function fails then a non-zero error code will be returned and
;  *      *'pageFormatList' will be set to NULL.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionCopyOutputFormatList" 
      ((printSession :pointer) (destType :unsigned-integer) (documentFormatP (:pointer :pointer))) 
  :osstatus
   () )
                                             ; $ELSEC; 
;  *  PMSetIdleProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSessionCreatePageFormatList" 
      ((printSession :pointer) (printer :pointer) (pageFormatList (:pointer :pointer))) 
  :osstatus
   () )                                         ;  Print loop ; 
;  *  PMBegin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSetIdleProc" 
      ((idleProc :pointer)) 
  :osstatus
   () )                                         ; 
;  *  PMEnd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMBegin" 
      () 
  :osstatus
   () )                                         ; **********************;   Valid only within a PMBeginPage/PMEndPage block. You should retrieve the printing ;   port with this call and set it before imaging a page. ; **********************; 
;  *  PMGetGrafPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMEnd" 
      () 
  :osstatus
   () )                                         ;  PMPageFormat ; 
;  *  PMNewPageFormat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetGrafPtr" 
      ((printContext :pointer) (grafPort (:pointer (:pointer :grafport)))) 
  :osstatus
   () )                                         ; 
;  *  PMDisposePageFormat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMNewPageFormat" 
      ((pageFormat (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  PMDefaultPageFormat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMDisposePageFormat" 
      ((pageFormat :pointer)) 
  :osstatus
   () )                                         ; 
;  *  PMValidatePageFormat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMDefaultPageFormat" 
      ((pageFormat :pointer)) 
  :osstatus
   () )                                         ;  PMPrintSettings ; 
;  *  PMNewPrintSettings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMValidatePageFormat" 
      ((pageFormat :pointer) (result (:pointer :boolean))) 
  :osstatus
   () )                                         ; 
;  *  PMDisposePrintSettings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMNewPrintSettings" 
      ((printSettings (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  PMDefaultPrintSettings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMDisposePrintSettings" 
      ((printSettings :pointer)) 
  :osstatus
   () )                                         ; 
;  *  PMValidatePrintSettings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMDefaultPrintSettings" 
      ((printSettings :pointer)) 
  :osstatus
   () )                                         ;  Classic Support ; 
;  *  PMGeneral()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMValidatePrintSettings" 
      ((printSettings :pointer) (result (:pointer :boolean))) 
  :osstatus
   () )                                         ; 
;  *  PMConvertOldPrintRecord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGeneral" 
      ((pData :pointer)) 
  :osstatus
   () )                                         ; 
;  *  PMMakeOldPrintRecord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMConvertOldPrintRecord" 
      ((printRecordHandle :handle) (printSettings (:pointer :pointer)) (pageFormat (:pointer :pointer))) 
  :osstatus
   () )                                         ;  Driver Information ; 
;  *  PMIsPostScriptDriver()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMMakeOldPrintRecord" 
      ((printSettings :pointer) (pageFormat :pointer) (printRecordHandle (:pointer :handle))) 
  :osstatus
   () )                                         ; 
;  *  PMGetLanguageInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMIsPostScriptDriver" 
      ((isPostScript (:pointer :boolean))) 
  :osstatus
   () )                                         ; 
;  *  PMGetDriverCreator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetLanguageInfo" 
      ((info (:pointer :pmlanguageinfo))) 
  :osstatus
   () )                                         ; 
;  *  PMGetDriverReleaseInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetDriverCreator" 
      ((creator (:pointer :ostype))) 
  :osstatus
   () )                                         ; 
;  *  PMGetPrinterResolutionCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetDriverReleaseInfo" 
      ((release (:pointer :versrec))) 
  :osstatus
   () )                                         ; 
;  *  PMGetPrinterResolution()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetPrinterResolutionCount" 
      ((count (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  PMGetIndexedPrinterResolution()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetPrinterResolution" 
      ((tag :unsigned-long) (res (:pointer :pmresolution))) 
  :osstatus
   () )                                         ; **********************;   PMEnableColorSync and PMDisableColorSync are valid within ;   BeginPage/EndPage block ; **********************;  ColorSync & PostScript Support ; 
;  *  PMEnableColorSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetIndexedPrinterResolution" 
      ((index :unsigned-long) (res (:pointer :pmresolution))) 
  :osstatus
   () )                                         ; 
;  *  PMDisableColorSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMEnableColorSync" 
      () 
  :osstatus
   () )                                         ; **********************;   The PMPostScriptxxx calls are valid within a ;   BeginPage/EndPage block ; **********************; 
;  *  PMPostScriptBegin()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMDisableColorSync" 
      () 
  :osstatus
   () )                                         ; 
;  *  PMPostScriptEnd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMPostScriptBegin" 
      () 
  :osstatus
   () )                                         ; **********************;   These PMPostScriptxxx calls are valid within a ;   PMPostScriptBegin/PMPostScriptEnd block ; **********************; 
;  *  PMPostScriptHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMPostScriptEnd" 
      () 
  :osstatus
   () )                                         ; 
;  *  PMPostScriptData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMPostScriptHandle" 
      ((psHandle :handle)) 
  :osstatus
   () )                                         ; 
;  *  PMPostScriptFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMPostScriptData" 
      ((psPtr :pointer) (len :signed-long)) 
  :osstatus
   () )                                         ;  Error ; 
;  *  PMError()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMPostScriptFile" 
      ((psFile (:pointer :fsspec))) 
  :osstatus
   () )                                         ; 
;  *  PMSetError()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMError" 
      () 
  :osstatus
   () )
(deftrap-inline "_PMSetError" 
      ((printError :signed-long)) 
  :osstatus
   () )
                                              ; $ENDC; PM_USE_SESSION_APIS

;  PMPageFormat 
; 
;  *  PMCopyPageFormat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; **********************                        ;   Flattening a page format should only be necessary if you intend to preserve ;   the object settings along with a document. A page format will persist outside of a ;   PMBegin/PMEnd block. This will allow you to use any accessors on the object without ;   the need to flatten and unflatten. Keep in mind accessors make no assumption ;   on the validity of the value you set. This can only be done thru PMValidatePageFormat ;   in a PMBegin/PMEnd block or with PMSessionValidatePageFormat with a valid session. ;   It is your responsibility for disposing of the handle. ; **********************; 
;  *  PMFlattenPageFormat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMCopyPageFormat" 
      ((formatSrc :pointer) (formatDest :pointer)) 
  :osstatus
   () )                                         ; 
;  *  PMUnflattenPageFormat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMFlattenPageFormat" 
      ((pageFormat :pointer) (flatFormat (:pointer :handle))) 
  :osstatus
   () )                                         ;  PMPageFormat Accessors ; **********************;  PMSetxxx calls only saves the value inside the printing object. They make no assumption on the ;  validity of the value. This should be done using PMValidatePageFormat/PMSessionValidatePageFormat ;  Any dependant settings are also updated during a validate call. ;  For example: ;  PMGetAdjustedPaperRect - returns a rect of a certain size ;  PMSetScale( aPageFormat, 500.0 )  ;  PMGetAdjustedPaperRect - returns the SAME rect as the first call  ; ;  PMGetAdjustedPaperRect - returns a rect of a certain size ;  PMSetScale( aPageFormat, 500.0 ) ;  PMValidatePageFormat or PMSessionValidatePageFormat ;  PMGetAdjustedPaperRect - returns a rect thats scaled 500% from the first call ; **********************; 
;  *  PMGetPageFormatExtendedData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMUnflattenPageFormat" 
      ((flatFormat :handle) (pageFormat (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  PMSetPageFormatExtendedData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetPageFormatExtendedData" 
      ((pageFormat :pointer) (dataID :ostype) (size (:pointer :unsigned-long)) (extendedData :pointer)) 
  :osstatus
   () )                                         ; **********************;   A value of 100.0 means 100% (no scaling). 50.0 means 50% scaling ; **********************; 
;  *  PMGetScale()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSetPageFormatExtendedData" 
      ((pageFormat :pointer) (dataID :ostype) (size :unsigned-long) (extendedData :pointer)) 
  :osstatus
   () )                                         ; 
;  *  PMSetScale()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetScale" 
      ((pageFormat :pointer) (scale (:pointer :double-float))) 
  :osstatus
   () )                                         ; **********************;   This is the drawing resolution of an app. This should not be confused with ;   the resolution of the printer. You can call PMGetPrinterResolution to see ;   what resolutions are avaliable for the current printer. ; **********************; 
;  *  PMGetResolution()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSetScale" 
      ((pageFormat :pointer) (scale :double-float)) 
  :osstatus
   () )                                         ; 
;  *  PMSetResolution()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetResolution" 
      ((pageFormat :pointer) (res (:pointer :pmresolution))) 
  :osstatus
   () )                                         ; CONST; **********************;   This is the physical size of the paper without regard to resolution, orientation ;   or scaling. It is returned as a 72dpi value. ; **********************; 
;  *  PMGetPhysicalPaperSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSetResolution" 
      ((pageFormat :pointer) (res (:pointer :pmresolution))) 
  :osstatus
   () )                                         ; 
;  *  PMSetPhysicalPaperSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetPhysicalPaperSize" 
      ((pageFormat :pointer) (paperSize (:pointer :pmrect))) 
  :osstatus
   () )                                         ; CONST; **********************;   This is the physical size of the page without regard to resolution, orientation ;   or scaling. It is returned as a 72dpi value. ; **********************; 
;  *  PMGetPhysicalPageSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSetPhysicalPaperSize" 
      ((pageFormat :pointer) (paperSize (:pointer :pmrect))) 
  :osstatus
   () )                                         ; 
;  *  PMGetAdjustedPaperRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetPhysicalPageSize" 
      ((pageFormat :pointer) (pageSize (:pointer :pmrect))) 
  :osstatus
   () )                                         ; 
;  *  PMGetAdjustedPageRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetAdjustedPaperRect" 
      ((pageFormat :pointer) (paperRect (:pointer :pmrect))) 
  :osstatus
   () )                                         ; 
;  *  PMGetUnadjustedPaperRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetAdjustedPageRect" 
      ((pageFormat :pointer) (pageRect (:pointer :pmrect))) 
  :osstatus
   () )                                         ; 
;  *  PMSetUnadjustedPaperRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetUnadjustedPaperRect" 
      ((pageFormat :pointer) (paperRect (:pointer :pmrect))) 
  :osstatus
   () )                                         ; CONST; 
;  *  PMGetUnadjustedPageRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSetUnadjustedPaperRect" 
      ((pageFormat :pointer) (paperRect (:pointer :pmrect))) 
  :osstatus
   () )                                         ; 
;  *  PMSetAdjustedPageRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetUnadjustedPageRect" 
      ((pageFormat :pointer) (pageRect (:pointer :pmrect))) 
  :osstatus
   () )                                         ; CONST; 
;  *  PMGetOrientation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSetAdjustedPageRect" 
      ((pageFormat :pointer) (pageRect (:pointer :pmrect))) 
  :osstatus
   () )                                         ; 
;  *  PMSetOrientation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetOrientation" 
      ((pageFormat :pointer) (orientation (:pointer :unsigned-integer))) 
  :osstatus
   () )                                         ;  PMPrintSettings ; 
;  *  PMCopyPrintSettings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSetOrientation" 
      ((pageFormat :pointer) (orientation :unsigned-integer) (lock :boolean)) 
  :osstatus
   () )                                         ; **********************;   Flattening a print settings should only be necessary if you intend to preserve ;   the object settings along with a document. A print settings will persist outside of a ;   PMBegin/PMEnd block. This allows you to use any accessors on the object without ;   the need to flatten and unflatten. Keep in mind the accessors make no assumption ;   on the validity of the value. This can only be done thru PMValidatePrintSettings ;   in a PMBegin/PMEnd block or with PMSessionValidatePrintSettings with a valid session. ;   It is your responsibility for disposing of the handle. ; **********************; 
;  *  PMFlattenPrintSettings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMCopyPrintSettings" 
      ((settingSrc :pointer) (settingDest :pointer)) 
  :osstatus
   () )                                         ; 
;  *  PMUnflattenPrintSettings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMFlattenPrintSettings" 
      ((printSettings :pointer) (flatSettings (:pointer :handle))) 
  :osstatus
   () )                                         ;  PMPrintSettings Accessors ; 
;  *  PMGetPrintSettingsExtendedData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMUnflattenPrintSettings" 
      ((flatSettings :handle) (printSettings (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  PMSetPrintSettingsExtendedData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetPrintSettingsExtendedData" 
      ((printSettings :pointer) (dataID :ostype) (size (:pointer :unsigned-long)) (extendedData :pointer)) 
  :osstatus
   () )                                         ; 
;  *  PMGetDestination()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSetPrintSettingsExtendedData" 
      ((printSettings :pointer) (dataID :ostype) (size :unsigned-long) (extendedData :pointer)) 
  :osstatus
   () )                                         ; 
;  *  PMGetJobName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetDestination" 
      ((printSettings :pointer) (destType (:pointer :unsigned-integer)) (fileURL (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  PMSetJobName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetJobName" 
      ((printSettings :pointer) (name (:pointer (:string 255)))) 
  :osstatus
   () )                                         ; 
;  *  PMGetCopies()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSetJobName" 
      ((printSettings :pointer) (name (:pointer (:string 255)))) 
  :osstatus
   () )                                         ; 
;  *  PMSetCopies()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetCopies" 
      ((printSettings :pointer) (copies (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  PMGetFirstPage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSetCopies" 
      ((printSettings :pointer) (copies :unsigned-long) (lock :boolean)) 
  :osstatus
   () )                                         ; 
;  *  PMSetFirstPage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetFirstPage" 
      ((printSettings :pointer) (first (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  PMGetLastPage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSetFirstPage" 
      ((printSettings :pointer) (first :unsigned-long) (lock :boolean)) 
  :osstatus
   () )                                         ; 
;  *  PMSetLastPage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetLastPage" 
      ((printSettings :pointer) (last (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; **********************;   The default page range is from 1-32000. The page range is something that is ;   set by the application. It is NOT the first and last page to print. It serves ;   as limits for setting the first and last page. You may pass kPMPrintAllPages for ;   the maxPage value to specified that all pages are available for printing. ; **********************; 
;  *  PMGetPageRange()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSetLastPage" 
      ((printSettings :pointer) (last :unsigned-long) (lock :boolean)) 
  :osstatus
   () )                                         ; **********************;  The first and last page are immediately clipped to the new range ; **********************; 
;  *  PMSetPageRange()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetPageRange" 
      ((printSettings :pointer) (minPage (:pointer :unsigned-long)) (maxPage (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  PMSetProfile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSetPageRange" 
      ((printSettings :pointer) (minPage :unsigned-long) (maxPage :unsigned-long)) 
  :osstatus
   () )                                         ; CONST; 
;  *  PMGetColorMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSetProfile" 
      ((printSettings :pointer) (tag :unsigned-long) (profile (:pointer :cmprofilelocation))) 
  :osstatus
   () )                                         ; 
;  *  PMSetColorMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetColorMode" 
      ((printSettings :pointer) (colorMode (:pointer :unsigned-integer))) 
  :osstatus
   () )                                         ; 
;  *  PMGetJobNameCFString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMSetColorMode" 
      ((printSettings :pointer) (colorMode :unsigned-integer)) 
  :osstatus
   () )                                         ; 
;  *  PMSetJobNameCFString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_PMGetJobNameCFString" 
      ((printSettings :pointer) (name (:pointer :pointer))) 
  :osstatus
   () )                                         ; $ALIGN RESET; $POP; $SETC UsingIncludes := PMCoreIncludes
(deftrap-inline "_PMSetJobNameCFString" 
      ((printSettings :pointer) (name :pointer)) 
  :osstatus
   () )                                         ; $ENDC; __PMCORE__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'PMCore)