(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:PMDefinitions.p"
; at Wednesday May 1,2002 2:40:46 pm.
; 
;      File:       PMDefinitions.p
;  
;      Contains:   Carbon Printing Manager Interfaces.
;  
;      Version:    Technology: Mac OS X
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1998-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __PMDEFINITIONS__
; $SETC __PMDEFINITIONS__ := 1

; $I+
; $SETC PMDefinitionsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CFSTRING__
|#

(require-interface 'CFString)
#|                                              ; $I CFString.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  Printing objects 

(def-mactype :pmobject (find-mactype ':pointer))
(def-mactype :pmdialog (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :pmdialogptr (find-mactype '(:pointer :pointer)));  when a VAR xx:PMDialog parameter can be nil, it is changed to xx: PMDialogPtr 
(def-mactype :pmprintsettings (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :pmprintsettingsptr (find-mactype '(:pointer :pointer)));  when a VAR xx:PMPrintSettings parameter can be nil, it is changed to xx: PMPrintSettingsPtr 
(def-mactype :pmpageformat (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :pmpageformatptr (find-mactype '(:pointer :pointer)));  when a VAR xx:PMPageFormat parameter can be nil, it is changed to xx: PMPageFormatPtr 
(def-mactype :pmprintcontext (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :pmprintcontextptr (find-mactype '(:pointer :pointer)));  when a VAR xx:PMPrintContext parameter can be nil, it is changed to xx: PMPrintContextPtr 
(def-mactype :pmprintsession (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :pmprintsessionptr (find-mactype '(:pointer :pointer)));  when a VAR xx:PMPrintSession parameter can be nil, it is changed to xx: PMPrintSessionPtr 
(def-mactype :pmprinter (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :pmprinterptr (find-mactype '(:pointer :pointer)));  when a VAR xx:PMPrinter parameter can be nil, it is changed to xx: PMPrinterPtr 

(defconstant $kPMCancel #x80)                   ;   user hit cancel button in dialog  

; $IFC NOT UNDEFINED MWERKS
; 	 for parameters which take a PrintSettings reference 	
; $IFC NOT UNDEFINED MWERKS
(defconstant $kPMNoPrintSettings nil)
; $ENDC
; 	 for parameters which take a PageFormat reference 	
; $IFC NOT UNDEFINED MWERKS
(defconstant $kPMNoPageFormat nil)
; $ENDC
; $ENDC

(def-mactype :pmdestinationtype (find-mactype ':unsigned-integer))

(defconstant $kPMDestinationInvalid 0)
(defconstant $kPMDestinationPrinter 1)
(defconstant $kPMDestinationFile 2)
(defconstant $kPMDestinationFax 3)
(defconstant $kPMDestinationPreview 4)

(def-mactype :pmtag (find-mactype ':unsigned-long))

;   common tags  
(defconstant $kPMCurrentValue :|curr|)          ;   current setting or value  
(defconstant $kPMDefaultValue :|dflt|)          ;   default setting or value  
(defconstant $kPMMinimumValue :|minv|)          ;   the minimum setting or value  
(defconstant $kPMMaximumValue :|maxv|)          ;   the maximum setting or value  
;   profile tags  
(defconstant $kPMSourceProfile :|srcp|)         ;   source profile  
;   resolution tags  
(defconstant $kPMMinRange :|mnrg|)              ;   Min range supported by a printer  
(defconstant $kPMMaxRange :|mxrg|)              ;   Max range supported by a printer  
(defconstant $kPMMinSquareResolution :|mins|)   ;   Min with X and Y resolution equal  
(defconstant $kPMMaxSquareResolution :|maxs|)   ;   Max with X and Y resolution equal  
(defconstant $kPMDefaultResolution :|dftr|)     ;   printer default resolution  

(def-mactype :pmorientation (find-mactype ':unsigned-integer))

(defconstant $kPMPortrait 1)
(defconstant $kPMLandscape 2)
(defconstant $kPMReversePortrait 3)             ;   will revert to kPortrait for current drivers  
(defconstant $kPMReverseLandscape 4)            ;   will revert to kLandscape for current drivers  

(defconstant $kSizeOfTPrint 120)                ;   size of old TPrint record  

(def-mactype :pmcolormode (find-mactype ':unsigned-integer))

(defconstant $kPMBlackAndWhite 1)
(defconstant $kPMGray 2)
(defconstant $kPMColor 3)
(defconstant $kPMColorModeDuotone 4)            ;   2 channels  
(defconstant $kPMColorModeSpecialColor 5)       ;   to allow for special colors such as metalic, light cyan, etc.  

; 	 Constants to define the ColorSync Intents. These intents may be used 	
; 	 to set an intent part way through a page or for an entire document. 	

(def-mactype :pmcolorsyncintent (find-mactype ':unsigned-long))

(defconstant $kPMColorIntentUndefined #x0)      ;   User or application have not declared an intent, use the printer's default.  
(defconstant $kPMColorIntentAutomatic #x1)      ;   Automatically match for photos and graphics anywhere on the page.  
(defconstant $kPMColorIntentPhoto #x2)          ;   Use Photographic (cmPerceptual) intent for all contents.  
(defconstant $kPMColorIntentBusiness #x4)       ;   Use Business Graphics (cmSaturation) intent for all contents.  
(defconstant $kPMColorIntentRelColor #x8)       ;   Use Relative Colormetrics (Logo Colors) for the page.  
(defconstant $kPMColorIntentAbsColor #x10)      ;   Use absolute colormetric for the page.  
(defconstant $kPMColorIntentUnused #xFFE0)      ;   Remaining bits unused at this time.  

; 	 Print quality modes "standard options" 	

(def-mactype :pmqualitymode (find-mactype ':unsigned-long))

(defconstant $kPMQualityLowest #x0)             ;   Absolute lowest print quality  
(defconstant $kPMQualityInkSaver #x1)           ;   Saves ink but may be slower  
(defconstant $kPMQualityDraft #x4)              ;   Print at highest speed, ink used is secondary consideration  
(defconstant $kPMQualityNormal #x8)             ;   Print in printers "general usage" mode for good balance between quality and speed  
(defconstant $kPMQualityPhoto #xB)              ;   Optimize quality of photos on the page. Speed is not a concern  
(defconstant $kPMQualityBest #xD)               ;   Get best quality output for all objects and photos.  
(defconstant $kPMQualityHighest #xF)            ;   Absolute highest quality attained from a printers  

; 	 Constants for our "standard" paper types 	

(def-mactype :pmpapertype (find-mactype ':unsigned-long))

(defconstant $kPMPaperTypeUnknown #x0)          ;   Not sure yet what paper type we have.  
(defconstant $kPMPaperTypePlain #x1)            ;   Plain paper  
(defconstant $kPMPaperTypeCoated #x2)           ;   Has a special coating for sharper images and text  
(defconstant $kPMPaperTypePremium #x3)          ;   Special premium coated paper  
(defconstant $kPMPaperTypeGlossy #x4)           ;   High gloss special coating  
(defconstant $kPMPaperTypeTransparency #x5)     ;   Used for overheads  
(defconstant $kPMPaperTypeTShirt #x6)           ;   Used to iron on t-shirts  

; 	 Scaling alignment: 	

(def-mactype :pmscalingalignment (find-mactype ':unsigned-integer))

(defconstant $kPMScalingPinTopLeft 1)
(defconstant $kPMScalingPinTopRight 2)
(defconstant $kPMScalingPinBottomLeft 3)
(defconstant $kPMScalingPinBottomRight 4)
(defconstant $kPMScalingCenterOnPaper 5)
(defconstant $kPMScalingCenterOnImgArea 6)

; 	 Duplex binding directions: 	

(def-mactype :pmduplexbinding (find-mactype ':unsigned-integer))

(defconstant $kPMDuplexBindingLeftRight 1)
(defconstant $kPMDuplexBindingTopDown 2)

; 	 Layout directions: 	

(def-mactype :pmlayoutdirection (find-mactype ':unsigned-integer))

;   Horizontal-major directions:  
(defconstant $kPMLayoutLeftRightTopBottom 1)    ;   English reading direction.  
(defconstant $kPMLayoutLeftRightBottomTop 2)
(defconstant $kPMLayoutRightLeftTopBottom 3)
(defconstant $kPMLayoutRightLeftBottomTop 4)    ;   Vertical-major directions:  
(defconstant $kPMLayoutTopBottomLeftRight 5)
(defconstant $kPMLayoutTopBottomRightLeft 6)
(defconstant $kPMLayoutBottomTopLeftRight 7)
(defconstant $kPMLayoutBottomTopRightLeft 8)

; 	 Page borders: 	

(def-mactype :pmbordertype (find-mactype ':unsigned-integer))

(defconstant $kPMBorderSingleHairline 1)
(defconstant $kPMBorderDoubleHairline 2)
(defconstant $kPMBorderSingleThickline 3)
(defconstant $kPMBorderDoubleThickline 4)

; 	 Useful Constants for PostScript Injection 	
(defconstant $kPSPageInjectAllPages -1)         ;   specifies to inject on all pages  
(defconstant $kPSInjectionMaxDictSize 5)        ;   maximum size of a dictionary used for PSInjection  

; 	 PostScript Injection values for kPSInjectionPlacementKey 	

(def-mactype :psinjectionplacement (find-mactype ':unsigned-integer))

(defconstant $kPSInjectionBeforeSubsection 1)
(defconstant $kPSInjectionAfterSubsection 2)
(defconstant $kPSInjectionReplaceSubsection 3)

; 	 PostScript Injection values for kPSInjectionSectionKey 	

(def-mactype :psinjectionsection (find-mactype ':signed-long))

;   Job  
(defconstant $kInjectionSectJob 1)              ;   CoverPage  
(defconstant $kInjectionSectCoverPage 2)

; 	 PostScript Injection values for kPSInjectionSubSectionKey 	

(def-mactype :psinjectionsubsection (find-mactype ':signed-long))

(defconstant $kInjectionSubPSAdobe 1)           ;   %!PS-Adobe            
(defconstant $kInjectionSubPSAdobeEPS 2)        ;   %!PS-Adobe-3.0 EPSF-3.0     
(defconstant $kInjectionSubBoundingBox 3)       ;   BoundingBox           
(defconstant $kInjectionSubEndComments 4)       ;   EndComments           
(defconstant $kInjectionSubOrientation 5)       ;   Orientation           
(defconstant $kInjectionSubPages 6)             ;   Pages             
(defconstant $kInjectionSubPageOrder 7)         ;   PageOrder           
(defconstant $kInjectionSubBeginProlog 8)       ;   BeginProlog           
(defconstant $kInjectionSubEndProlog 9)         ;   EndProlog           
(defconstant $kInjectionSubBeginSetup 10)       ;   BeginSetup           
(defconstant $kInjectionSubEndSetup 11)         ;   EndSetup              
(defconstant $kInjectionSubBeginDefaults 12)    ;   BeginDefaults        
(defconstant $kInjectionSubEndDefaults 13)      ;   EndDefaults           
(defconstant $kInjectionSubDocFonts 14)         ;   DocumentFonts        
(defconstant $kInjectionSubDocNeededFonts 15)   ;   DocumentNeededFonts        
(defconstant $kInjectionSubDocSuppliedFonts 16) ;   DocumentSuppliedFonts   
(defconstant $kInjectionSubDocNeededRes 17)     ;   DocumentNeededResources     
(defconstant $kInjectionSubDocSuppliedRes 18)   ;   DocumentSuppliedResources 
(defconstant $kInjectionSubDocCustomColors 19)  ;   DocumentCustomColors      
(defconstant $kInjectionSubDocProcessColors 20) ;   DocumentProcessColors   
(defconstant $kInjectionSubPlateColor 21)       ;   PlateColor           
(defconstant $kInjectionSubPageTrailer 22)      ;   PageTrailer            
(defconstant $kInjectionSubTrailer 23)          ;   Trailer               
(defconstant $kInjectionSubEOF 24)              ;   EOF                  
(defconstant $kInjectionSubBeginFont 25)        ;   BeginFont           
(defconstant $kInjectionSubEndFont 26)          ;   EndFont               
(defconstant $kInjectionSubBeginResource 27)    ;   BeginResource        
(defconstant $kInjectionSubEndResource 28)      ;   EndResource           
(defconstant $kInjectionSubPage 29)             ;   Page                
(defconstant $kInjectionSubBeginPageSetup 30)   ;   BeginPageSetup         
(defconstant $kInjectionSubEndPageSetup 31)     ;   EndPageSetup           

; 	 Description types 	
;  kPMPPDDescriptionType = CFSTR("PMPPDDescriptionType"); 
; 	 Document format strings 	
;  kPMDocumentFormatDefault = CFSTR("com.apple.documentformat.default"); 
;  kPMDocumentFormatPDF = CFSTR("application/pdf"); 
;  kPMDocumentFormatPICT = CFSTR("application/vnd.apple.printing-pict"); 
;  kPMDocumentFormatPICTPS = CFSTR("application/vnd.apple.printing-pict-ps"); 
;  kPMDocumentFormatPostScript = CFSTR("application/postscript"); 
; 	 Graphic context strings 	
;  kPMGraphicsContextDefault = CFSTR("com.apple.graphicscontext.default"); 
;  kPMGraphicsContextQuickdraw = CFSTR("com.apple.graphicscontext.quickdraw"); 
;  kPMGraphicsContextCoreGraphics = CFSTR("com.apple.graphicscontext.coregraphics"); 
; 	 Data format strings 	
;  kPMDataFormatPS = CFSTR(kPMDocumentFormatPostScript); 
;  kPMDataFormatPDF = CFSTR(kPMDocumentFormatPDF); 
;  kPMDataFormatPICT = CFSTR(kPMDocumentFormatPICT); 
;  kPMDataFormatPICTwPS = CFSTR(kPMDocumentFormatPICTPS); 
; 	 PostScript Injection Dictionary Keys 	
;  kPSInjectionSectionKey = CFSTR("section"); 
;  kPSInjectionSubSectionKey = CFSTR("subsection"); 
;  kPSInjectionPageKey = CFSTR("page"); 
;  kPSInjectionPlacementKey = CFSTR("place"); 
;  kPSInjectionPostScriptKey = CFSTR("psdata"); 
; 	 OSStatus return codes 	
(defconstant $kPMNoError 0)
(defconstant $kPMGeneralError -30870)
(defconstant $kPMOutOfScope -30871)             ;   an API call is out of scope  
(defconstant $kPMInvalidParameter -50)          ;   a required parameter is missing or invalid  
(defconstant $kPMNoDefaultPrinter -30872)       ;   no default printer selected  
(defconstant $kPMNotImplemented -30873)         ;   this API call is not supported  
(defconstant $kPMNoSuchEntry -30874)            ;   no such entry  
(defconstant $kPMInvalidPrintSettings -30875)   ;   the printsettings reference is invalid  
(defconstant $kPMInvalidPageFormat -30876)      ;   the pageformat reference is invalid  
(defconstant $kPMValueOutOfRange -30877)        ;   a value passed in is out of range  
(defconstant $kPMLockIgnored -30878)            ;   the lock value was ignored  

(defconstant $kPMInvalidPrintSession -30879)    ;   the print session is invalid  
(defconstant $kPMInvalidPrinter -30880)         ;   the printer reference is invalid  
(defconstant $kPMObjectInUse -30881)            ;   the object is in use  

(defconstant $kPMPrintAllPages -1)

(def-mactype :pmrectptr (find-mactype '(:pointer :pmrect)))
(defrecord PMRect 
#|
; Warning: type-size: unknown type double-float
|##|
; Warning: type-size: unknown type double-float
|#
   (top :double-float)
#|
; Warning: type-size: unknown type double-float
|##|
; Warning: type-size: unknown type double-float
|#
   (left :double-float)
#|
; Warning: type-size: unknown type double-float
|##|
; Warning: type-size: unknown type double-float
|#
   (bottom :double-float)
#|
; Warning: type-size: unknown type double-float
|##|
; Warning: type-size: unknown type double-float
|#
   (right :double-float)
   )

(def-mactype :pmresolutionptr (find-mactype '(:pointer :pmresolution)))
(defrecord PMResolution 
#|
; Warning: type-size: unknown type double-float
|##|
; Warning: type-size: unknown type double-float
|#
   (hRes :double-float)
#|
; Warning: type-size: unknown type double-float
|##|
; Warning: type-size: unknown type double-float
|#
   (vRes :double-float)
   )

(def-mactype :pmlanguageinfoptr (find-mactype '(:pointer :pmlanguageinfo)))
(defrecord PMLanguageInfo 
   (level (:string 32))
   (version (:string 32))
   (release (:string 32))
   )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := PMDefinitionsIncludes

; $ENDC                                         ; __PMDEFINITIONS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'PMDefinitions)