(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:PPCToolbox.p"
; at Wednesday May 1,2002 2:41:24 pm.
; 
;      File:       PPCToolbox.p
;  
;      Contains:   Program-Program Communications Toolbox Interfaces.
;  
;      Version:    Technology: Mac OS 9
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1989-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __PPCTOOLBOX__
; $SETC __PPCTOOLBOX__ := 1

; $I+
; $SETC PPCToolboxIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __APPLETALK__
|#

(require-interface 'AppleTalk)
#|                                              ; $I AppleTalk.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :ppcservicetype (find-mactype ':unsigned-byte))

(defconstant $ppcServiceRealTime 1)

(def-mactype :ppclocationkind (find-mactype ':signed-integer))

(defconstant $ppcNoLocation 0)                  ;   There is no PPCLocName  
(defconstant $ppcNBPLocation 1)                 ;   Use AppleTalk NBP       
(defconstant $ppcNBPTypeLocation 2)             ;   Used for specifying a location name type during PPCOpen only  
(defconstant $ppcXTIAddrLocation 3)             ;   Use TCP/IP or DNS host name address  

(def-mactype :ppcportkinds (find-mactype ':signed-integer))

(defconstant $ppcByCreatorAndType 1)            ;   Port type is specified as colloquial Mac creator and type  
(defconstant $ppcByString 2)                    ;   Port type is in pascal string format  

; 	 Values returned for request field in PPCInform call 	

(def-mactype :ppcsessionorigin (find-mactype ':unsigned-byte))

(defconstant $ppcLocalOrigin 1)                 ;   session originated from this machine  
(defconstant $ppcRemoteOrigin 2)                ;   session originated from remote machine  

(def-mactype :ppcportrefnum (find-mactype ':signed-integer))
(def-mactype :ppcsessrefnum (find-mactype ':signed-long))

; 	  The maximum allowed size of a fAddress in PPCXTIAddress 	

(defconstant $kMaxPPCXTIAddress 95)

; 	    
; 	    The possible types of information found in the fAddressType field of a PPCXTIAddress record
; 	    Note:   These constants are the same as the AF_INET & AF_DNS constants, defined in OpenTptInternet.x
; 		

(def-mactype :ppcxtiaddresstype (find-mactype ':signed-integer))

(defconstant $kINETAddrType 2)                  ;      An IP address in binary form (type InetHost). 
(defconstant $kDNSAddrType 42)                  ;      A DNS or dotted-decimal name string (no leading length byte, no NULL termination byte) 

; 	    
; 	    This structure specifies a transport independent network address in a 
; 	    form that can be used by Open Transport, or as a XTI/TLI/socket network 
; 	    address in UNIX terminology.
; 		

(def-mactype :ppcxtiaddressptr (find-mactype '(:pointer :ppcxtiaddress)))
(defrecord PPCXTIAddress 
   (fAddressType :signed-integer)               ;   A constant specifying what kind of network address this is  
   (fAddress (:array :unsigned-byte 96 :packed));   The contents of the network address (variable length, NULL terminated).  
   )

; 	
; 	    This structure is the variant type used in a LocationNameRec when an IP connection
; 	    is being established for a PPC Toolbox session.
; 	    
; 	    NOTE: The value of the xtiAddrLen must be the length of the entire PPCXTIAddress structure 
; 	    in the xtiAddr field, and not just the length of the fAddress field of the PPCXTIAddress structure.
; 		
(def-mactype :ppcaddrrecptr (find-mactype '(:pointer :ppcaddrrec)))
(defrecord PPCAddrRec 
   (xtiAddrLen :unsigned-long)                  ;   size of the xtiAddr field              
   (xtiAddr :ppcxtiaddress)                     ;   the transport-independent network address    
   )

(def-mactype :locationnamerecptr (find-mactype '(:pointer :locationnamerec)))
(defrecord LocationNameRec 
   (locationKindSelector :signed-integer)       ;   which variant  
   (:variant 
      (
      (nbpEntity :entityname)                   ;   NBP name entity                    
      )
      (
      (nbpType (:string 32))                    ;   just the NBP type string, for PPCOpen   
      )
      (
      (xtiType :ppcaddrrec)                     ;   an XTI-type network address record      
      )
      )
   )

(def-mactype :locationnameptr (find-mactype '(:pointer :locationnamerec)))

(def-mactype :ppcportrecptr (find-mactype '(:pointer :ppcportrec)))
(defrecord PPCPortRec 
   (nameScript :signed-integer)                 ;   script of name  
   (name (:string 32))                          ;   name of port as seen in browser  
   (portKindSelector :signed-integer)           ;   which variant  
   (:variant 
      (
      (portTypeStr (:string 32))                ;   pascal type string  
      )
      (
      (portCreator :ostype)
      (portType :ostype)
      )
      )
   )

(def-mactype :ppcportptr (find-mactype '(:pointer :ppcportrec)))
(def-mactype :portinforecptr (find-mactype '(:pointer :portinforec)))
(defrecord PortInfoRec 
   (filler1 :signed-byte)
   (authRequired :boolean)
   (name :ppcportrec)
   )

(def-mactype :portinfoptr (find-mactype '(:pointer :portinforec)))
(def-mactype :portinfoarrayptr (find-mactype '(:pointer :portinforec)))
(def-mactype :ppcparamblockrecptr (find-mactype '(:pointer :ppcparamblockrec)))
(def-mactype :ppcparamblockptr (find-mactype '(:pointer :ppcparamblockrec)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	PPCCompProcPtr = PROCEDURE(pb: PPCParamBlockPtr);

|#
 |#                                             ; $ELSEC
(def-mactype :ppccompprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :ppccompupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :ppccompupp (find-mactype ':pointer))
; $ENDC
(def-mactype :ppcopenpbrecptr (find-mactype '(:pointer :ppcopenpbrec)))
(defrecord PPCOpenPBRec 
   (qLink :pointer)                             ;   PPC's Internal Use  
   (csCode :unsigned-integer)                   ;   Requested PPC command  
   (intUse :unsigned-integer)                   ;   Internal Use  
   (intUsePtr :pointer)                         ;   Internal Use  
   (ioCompletion :pointer)                      ;   12 --> Completion Routine  
   (ioResult :signed-integer)                   ;   16 <--     Command Result Code  
   (Reserved (:array :unsigned-long 5))         ;   Reserved for PPC, Don't use  
   (portRefNum :signed-integer)                 ;   38 <--   Port Reference  
   (filler1 :signed-long)
   (serviceType :unsigned-byte)                 ;   44 -->    Bit field describing the requested port service  
   (resFlag :unsigned-byte)                     ;   Must be set to 0  
   (portName (:pointer :ppcportrec))            ;   46 -->   PortName for PPC  
   (locationName (:pointer :locationnamerec))   ;   50 -->   If NBP Registration is required  
   (networkVisible :boolean)                    ;   54 -->   make this network visible on network  
   (nbpRegistered :boolean)                     ;   55 <--   The given location name was registered on the network  
   )

(def-mactype :ppcopenpbptr (find-mactype '(:pointer :ppcopenpbrec)))
(def-mactype :ppcinformpbrecptr (find-mactype '(:pointer :ppcinformpbrec)))
(defrecord PPCInformPBRec 
   (qLink :pointer)                             ;   PPC's Internal Use  
   (csCode :unsigned-integer)                   ;   Requested PPC command  
   (intUse :unsigned-integer)                   ;   Internal Use  
   (intUsePtr :pointer)                         ;   Internal Use  
   (ioCompletion :pointer)                      ;   12 --> Completion Routine  
   (ioResult :signed-integer)                   ;   16 <--     Command Result Code  
   (Reserved (:array :unsigned-long 5))         ;   Reserved for PPC, Don't use  
   (portRefNum :signed-integer)                 ;   38 -->   Port Identifier  
   (sessRefNum :signed-long)                    ;   40 <--   Session Reference  
   (serviceType :unsigned-byte)                 ;   44 <--   Status Flags for type of session, local, remote  
   (autoAccept :boolean)                        ;   45 -->   if true session will be accepted automatically  
   (portName (:pointer :ppcportrec))            ;   46 -->   Buffer for Source PPCPortRec  
   (locationName (:pointer :locationnamerec))   ;   50 -->   Buffer for Source LocationNameRec  
   (userName (:pointer (:string 255)))          ;   54 -->   Buffer for Soure user's name trying to link.  
   (userData :unsigned-long)                    ;   58 <--   value included in PPCStart's userData  
   (requestType :unsigned-byte)                 ;   62 <--   Local or Network  
   (filler :signed-byte)
   )

(def-mactype :ppcinformpbptr (find-mactype '(:pointer :ppcinformpbrec)))
(def-mactype :ppcstartpbrecptr (find-mactype '(:pointer :ppcstartpbrec)))
(defrecord PPCStartPBRec 
   (qLink :pointer)                             ;   PPC's Internal Use  
   (csCode :unsigned-integer)                   ;   Requested PPC command  
   (intUse :unsigned-integer)                   ;   Internal Use  
   (intUsePtr :pointer)                         ;   Internal Use  
   (ioCompletion :pointer)                      ;   12 --> Completion Routine  
   (ioResult :signed-integer)                   ;   16 <--     Command Result Code  
   (Reserved (:array :unsigned-long 5))         ;   Reserved for PPC, Don't use  
   (portRefNum :signed-integer)                 ;   38 -->   Port Identifier  
   (sessRefNum :signed-long)                    ;   40 <--   Session Reference  
   (serviceType :unsigned-byte)                 ;   44 <--   Actual service method (realTime)  
   (resFlag :unsigned-byte)                     ;   45 -->   Must be set to 0   
   (portName (:pointer :ppcportrec))            ;   46 -->   Destination portName  
   (locationName (:pointer :locationnamerec))   ;   50 -->   NBP or NAS style service location name  
   (rejectInfo :unsigned-long)                  ;   54 <--   reason for rejecting the session request  
   (userData :unsigned-long)                    ;   58 -->   Copied to destination PPCInform parameter block  
   (userRefNum :unsigned-long)                  ;   62 -->   userRefNum (obtained during login process)   
   )

(def-mactype :ppcstartpbptr (find-mactype '(:pointer :ppcstartpbrec)))
(def-mactype :ppcacceptpbrecptr (find-mactype '(:pointer :ppcacceptpbrec)))
(defrecord PPCAcceptPBRec 
   (qLink :pointer)                             ;   PPC's Internal Use  
   (csCode :unsigned-integer)                   ;   Requested PPC command  
   (intUse :unsigned-integer)                   ;   Internal Use  
   (intUsePtr :pointer)                         ;   Internal Use  
   (ioCompletion :pointer)                      ;   12 --> Completion Routine  
   (ioResult :signed-integer)                   ;   16 <--     Command Result Code  
   (Reserved (:array :unsigned-long 5))         ;   Reserved for PPC, Don't use  
   (filler1 :signed-integer)
   (sessRefNum :signed-long)                    ;   40 -->   Session Reference  
   )

(def-mactype :ppcacceptpbptr (find-mactype '(:pointer :ppcacceptpbrec)))
(def-mactype :ppcrejectpbrecptr (find-mactype '(:pointer :ppcrejectpbrec)))
(defrecord PPCRejectPBRec 
   (qLink :pointer)                             ;   PPC's Internal Use  
   (csCode :unsigned-integer)                   ;   Requested PPC command  
   (intUse :unsigned-integer)                   ;   Internal Use  
   (intUsePtr :pointer)                         ;   Internal Use  
   (ioCompletion :pointer)                      ;   12 --> Completion Routine  
   (ioResult :signed-integer)                   ;   16 <--     Command Result Code  
   (Reserved (:array :unsigned-long 5))         ;   Reserved for PPC, Don't use  
   (filler1 :signed-integer)
   (sessRefNum :signed-long)                    ;   40 -->   Session Reference  
   (filler2 :signed-integer)
   (filler3 :signed-long)
   (filler4 :signed-long)
   (rejectInfo :unsigned-long)                  ;   54 -->   reason for rejecting the session request   
   )

(def-mactype :ppcrejectpbptr (find-mactype '(:pointer :ppcrejectpbrec)))
(def-mactype :ppcwritepbrecptr (find-mactype '(:pointer :ppcwritepbrec)))
(defrecord PPCWritePBRec 
   (qLink :pointer)                             ;   PPC's Internal Use  
   (csCode :unsigned-integer)                   ;   Requested PPC command  
   (intUse :unsigned-integer)                   ;   Internal Use  
   (intUsePtr :pointer)                         ;   Internal Use  
   (ioCompletion :pointer)                      ;   12 --> Completion Routine  
   (ioResult :signed-integer)                   ;   16 <--     Command Result Code  
   (Reserved (:array :unsigned-long 5))         ;   Reserved for PPC, Don't use  
   (filler1 :signed-integer)
   (sessRefNum :signed-long)                    ;   40 -->   Session Reference  
   (bufferLength :signed-long)                  ;   44 -->   Length of the message buffer  
   (actualLength :signed-long)                  ;   48 <--   Actual Length Written  
   (bufferPtr :pointer)                         ;   52 -->   Pointer to message buffer  
   (more :boolean)                              ;   56 -->   if more data in this block will be written  
   (filler2 :signed-byte)
   (userData :unsigned-long)                    ;   58 -->   Message block userData Uninterpreted by PPC  
   (blockCreator :ostype)                       ;   62 -->   Message block creator Uninterpreted by PPC  
   (blockType :ostype)                          ;   66 -->   Message block type Uninterpreted by PPC  
   )

(def-mactype :ppcwritepbptr (find-mactype '(:pointer :ppcwritepbrec)))
(def-mactype :ppcreadpbrecptr (find-mactype '(:pointer :ppcreadpbrec)))
(defrecord PPCReadPBRec 
   (qLink :pointer)                             ;   PPC's Internal Use  
   (csCode :unsigned-integer)                   ;   Requested PPC command  
   (intUse :unsigned-integer)                   ;   Internal Use  
   (intUsePtr :pointer)                         ;   Internal Use  
   (ioCompletion :pointer)                      ;   12 --> Completion Routine  
   (ioResult :signed-integer)                   ;   16 <--     Command Result Code  
   (Reserved (:array :unsigned-long 5))         ;   Reserved for PPC, Don't use  
   (filler1 :signed-integer)
   (sessRefNum :signed-long)                    ;   40 -->   Session Reference  
   (bufferLength :signed-long)                  ;   44 -->   Length of the message buffer  
   (actualLength :signed-long)                  ;   48 <--   Actual length read  
   (bufferPtr :pointer)                         ;   52 -->   Pointer to message buffer  
   (more :boolean)                              ;   56 <--   if true more data in this block to be read  
   (filler2 :signed-byte)
   (userData :unsigned-long)                    ;   58 <--   Message block userData Uninterpreted by PPC  
   (blockCreator :ostype)                       ;   62 <--   Message block creator Uninterpreted by PPC  
   (blockType :ostype)                          ;   66 <--   Message block type Uninterpreted by PPC  
   )

(def-mactype :ppcreadpbptr (find-mactype '(:pointer :ppcreadpbrec)))
(def-mactype :ppcendpbrecptr (find-mactype '(:pointer :ppcendpbrec)))
(defrecord PPCEndPBRec 
   (qLink :pointer)                             ;   PPC's Internal Use  
   (csCode :unsigned-integer)                   ;   Requested PPC command  
   (intUse :unsigned-integer)                   ;   Internal Use  
   (intUsePtr :pointer)                         ;   Internal Use  
   (ioCompletion :pointer)                      ;   12 --> Completion Routine  
   (ioResult :signed-integer)                   ;   16 <--     Command Result Code  
   (Reserved (:array :unsigned-long 5))         ;   Reserved for PPC, Don't use  
   (filler1 :signed-integer)
   (sessRefNum :signed-long)                    ;   40 -->   Session Reference  
   )

(def-mactype :ppcendpbptr (find-mactype '(:pointer :ppcendpbrec)))
(def-mactype :ppcclosepbrecptr (find-mactype '(:pointer :ppcclosepbrec)))
(defrecord PPCClosePBRec 
   (qLink :pointer)                             ;   PPC's Internal Use  
   (csCode :unsigned-integer)                   ;   Requested PPC command  
   (intUse :unsigned-integer)                   ;   Internal Use  
   (intUsePtr :pointer)                         ;   Internal Use  
   (ioCompletion :pointer)                      ;   12 --> Completion Routine  
   (ioResult :signed-integer)                   ;   16 <--     Command Result Code  
   (Reserved (:array :unsigned-long 5))         ;   Reserved for PPC, Don't use  
   (portRefNum :signed-integer)                 ;   38 -->   Port Identifier  
   )

(def-mactype :ppcclosepbptr (find-mactype '(:pointer :ppcclosepbrec)))
(def-mactype :ipclistportspbrecptr (find-mactype '(:pointer :ipclistportspbrec)))
(defrecord IPCListPortsPBRec 
   (qLink :pointer)                             ;   PPC's Internal Use  
   (csCode :unsigned-integer)                   ;   Requested PPC command  
   (intUse :unsigned-integer)                   ;   Internal Use  
   (intUsePtr :pointer)                         ;   Internal Use  
   (ioCompletion :pointer)                      ;   12 --> Completion Routine  
   (ioResult :signed-integer)                   ;   16 <--     Command Result Code  
   (Reserved (:array :unsigned-long 5))         ;   Reserved for PPC, Don't use  
   (filler1 :signed-integer)
   (startIndex :unsigned-integer)               ;   40 -->   Start Index  
   (requestCount :unsigned-integer)             ;   42 -->   Number of entries to be returned  
   (actualCount :unsigned-integer)              ;   44 <--   Actual Number of entries to be returned  
   (portName (:pointer :ppcportrec))            ;   46 -->   PortName Match  
   (locationName (:pointer :locationnamerec))   ;   50 -->   NBP or NAS type name to locate the Port Location  
   (bufferPtr (:pointer :portinforec))          ;   54 -->   Pointer to a buffer requestCount*sizeof(PortInfo) bytes big  
   )

(def-mactype :ipclistportspbptr (find-mactype '(:pointer :ipclistportspbrec)))
(defrecord PPCParamBlockRec 
   (:variant 
      (
      (openParam :ppcopenpbrec)
      )
      (
      (informParam :ppcinformpbrec)
      )
      (
      (startParam :ppcstartpbrec)
      )
      (
      (acceptParam :ppcacceptpbrec)
      )
      (
      (rejectParam :ppcrejectpbrec)
      )
      (
      (writeParam :ppcwritepbrec)
      )
      (
      (readParam :ppcreadpbrec)
      )
      (
      (endParam :ppcendpbrec)
      )
      (
      (closeParam :ppcclosepbrec)
      )
      (
      (listPortsParam :ipclistportspbrec)
      )
      )
   )

; 	  PPC Calling Conventions  	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  PPCInit()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_PPCInit" 
      () 
  :signed-integer
   (#x7000 #xA0DD #x3E80) )

; 
;  *  PPCOpenSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PPCOpenSync" 
      ((pb (:pointer :ppcopenpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA0DD :a0 pb :d0 1))

; 
;  *  PPCOpenAsync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PPCOpenAsync" 
      ((pb (:pointer :ppcopenpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA4DD :a0 pb :d0 1))

; 
;  *  PPCInformSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PPCInformSync" 
      ((pb (:pointer :ppcinformpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA0DD :a0 pb :d0 3))

; 
;  *  PPCInformAsync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PPCInformAsync" 
      ((pb (:pointer :ppcinformpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA4DD :a0 pb :d0 3))

; 
;  *  PPCStartSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PPCStartSync" 
      ((pb (:pointer :ppcstartpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA0DD :a0 pb :d0 2))

; 
;  *  PPCStartAsync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PPCStartAsync" 
      ((pb (:pointer :ppcstartpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA4DD :a0 pb :d0 2))

; 
;  *  PPCAcceptSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PPCAcceptSync" 
      ((pb (:pointer :ppcacceptpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA0DD :a0 pb :d0 4))

; 
;  *  PPCAcceptAsync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PPCAcceptAsync" 
      ((pb (:pointer :ppcacceptpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA4DD :a0 pb :d0 4))

; 
;  *  PPCRejectSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PPCRejectSync" 
      ((pb (:pointer :ppcrejectpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA0DD :a0 pb :d0 5))

; 
;  *  PPCRejectAsync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PPCRejectAsync" 
      ((pb (:pointer :ppcrejectpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA4DD :a0 pb :d0 5))

; 
;  *  PPCWriteSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PPCWriteSync" 
      ((pb (:pointer :ppcwritepbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA0DD :a0 pb :d0 6))

; 
;  *  PPCWriteAsync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PPCWriteAsync" 
      ((pb (:pointer :ppcwritepbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA4DD :a0 pb :d0 6))

; 
;  *  PPCReadSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PPCReadSync" 
      ((pb (:pointer :ppcreadpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA0DD :a0 pb :d0 7))

; 
;  *  PPCReadAsync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PPCReadAsync" 
      ((pb (:pointer :ppcreadpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA4DD :a0 pb :d0 7))

; 
;  *  PPCEndSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PPCEndSync" 
      ((pb (:pointer :ppcendpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA0DD :a0 pb :d0 8))

; 
;  *  PPCEndAsync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PPCEndAsync" 
      ((pb (:pointer :ppcendpbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA4DD :a0 pb :d0 8))

; 
;  *  PPCCloseSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PPCCloseSync" 
      ((pb (:pointer :ppcclosepbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA0DD :a0 pb :d0 9))

; 
;  *  PPCCloseAsync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PPCCloseAsync" 
      ((pb (:pointer :ppcclosepbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA4DD :a0 pb :d0 9))

; 
;  *  IPCListPortsSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_IPCListPortsSync" 
      ((pb (:pointer :ipclistportspbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA0DD :a0 pb :d0 10))

; 
;  *  IPCListPortsAsync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_IPCListPortsAsync" 
      ((pb (:pointer :ipclistportspbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA4DD :a0 pb :d0 10))

; 
;  *  IPCKillListPorts()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_IPCKillListPorts" 
      ((pb (:pointer :ipclistportspbrec)))
   (:d0 :signed-integer)
   (:register-trap #xA0DD :a0 pb :d0 11))

; 
;  *  DeleteUserIdentity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  GetDefaultUser()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_DeleteUserIdentity" 
      ((userRef :unsigned-long)) 
  :signed-integer
   () )                                         ; 
;  *  StartSecureSession()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetDefaultUser" 
      ((userRef (:pointer :unsigned-long)) (userName (:pointer (:string 32)))) 
  :signed-integer
   () )
(deftrap-inline "_StartSecureSession" 
      ((pb (:pointer :ppcstartpbrec)) (userName (:pointer (:string 32))) (useDefault :boolean) (allowGuest :boolean) (guestSelected (:pointer :boolean)) (prompt (:string 255))) 
  :signed-integer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	PPCFilterProcPtr = FUNCTION(name: LocationNamePtr; port: PortInfoPtr): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :ppcfilterprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :ppcfilterupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :ppcfilterupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppPPCCompProcInfo #xC0)
(defconstant $uppPPCFilterProcInfo #x3D0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewPPCCompUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewPPCCompProc 
(deftrap "_NewPPCCompUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewPPCFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewPPCFilterProc 
(deftrap "_NewPPCFilterUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposePPCCompUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposePPCCompUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposePPCFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposePPCFilterUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokePPCCompUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallPPCCompProc 
(deftrap-inline "_InvokePPCCompUPP" 
      ((pb (:pointer :ppcparamblockrec)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokePPCFilterUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallPPCFilterProc 
(deftrap-inline "_InvokePPCFilterUPP" 
      ((name (:pointer :locationnamerec)) (port (:pointer :portinforec)) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  PPCBrowser()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PPCBrowser" 
      ((prompt (:string 255)) (applListLabel (:string 255)) (defaultSpecified :boolean) (theLocation (:pointer :locationnamerec)) (thePortInfo (:pointer :portinforec)) (portFilter :pointer) (theLocNBPType (:string 32)))
   (:stack :signed-integer)
   (:stack-trap #xA82B :d0 3328 prompt applListLabel defaultSpecified theLocation thePortInfo portFilter theLocNBPType))

; 
;   The ParamBlock calls without the "Sync" or "Async" suffix are being phased out.
; 
; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  PPCOpen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  PPCInform()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PPCOpen" 
      ((pb (:pointer :ppcopenpbrec)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PPCStart()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PPCInform" 
      ((pb (:pointer :ppcinformpbrec)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PPCAccept()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PPCStart" 
      ((pb (:pointer :ppcstartpbrec)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PPCReject()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PPCAccept" 
      ((pb (:pointer :ppcacceptpbrec)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PPCWrite()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PPCReject" 
      ((pb (:pointer :ppcrejectpbrec)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PPCRead()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PPCWrite" 
      ((pb (:pointer :ppcwritepbrec)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PPCEnd()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PPCRead" 
      ((pb (:pointer :ppcreadpbrec)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  PPCClose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PPCEnd" 
      ((pb (:pointer :ppcendpbrec)) (async :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  IPCListPorts()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_PPCClose" 
      ((pb (:pointer :ppcclosepbrec)) (async :boolean)) 
  :signed-integer
   () )
(deftrap-inline "_IPCListPorts" 
      ((pb (:pointer :ipclistportspbrec)) (async :boolean)) 
  :signed-integer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := PPCToolboxIncludes

; $ENDC                                         ; __PPCTOOLBOX__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'PPCToolbox)