(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Patches.p"
; at Wednesday May 1,2002 2:38:47 pm.
; 
;      File:       Patches.p
;  
;      Contains:   Patch Manager Interfaces.
;  
;      Version:    Technology: System 8
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1994-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 

#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __PATCHES__
; $SETC __PATCHES__ := 1

; $I+
; $SETC PatchesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; $IFC CALL_NOT_IN_CARBON 

(defconstant $kOSTrapType 0)
(defconstant $kToolboxTrapType 1)

(def-mactype :traptype (find-mactype ':signed-byte))

(defconstant $OSTrap 0)                         ;   old name  
(defconstant $ToolTrap 1)                       ;   old name  

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;     GetTrapAddress and SetTrapAddress are obsolete and should not
;     be used. Always use NGetTrapAddress and NSetTrapAddress instead.
;     The old routines will not be supported for PowerPC apps.
; 
#|                                              ; $IFC TARGET_CPU_68K AND NOT TARGET_RT_MAC_CFM 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  GetTrapAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetTrapAddress" 
      ((trapNum :unsigned-integer)) 
  :pointer
   (#x301F #xA146 #x2E88) )

; 
;  *  SetTrapAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetTrapAddress" 
      ((trapAddr :pointer) (trapNum :unsigned-integer))
   nil
   (:register-trap #xA047 :d0 trapNum :a0 trapAddr))

; $ENDC                                         ; CALL_NOT_IN_CARBON
 |#                                             ; $ENDC

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  NGetTrapAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  NSetTrapAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_NGetTrapAddress" 
      ((trapNum :unsigned-integer) (tTyp :signed-byte)) 
  :pointer
   () )
(deftrap-inline "_NSetTrapAddress" 
      ((trapAddr :pointer) (trapNum :unsigned-integer) (tTyp :signed-byte)) 
  nil
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  GetOSTrapAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetOSTrapAddress" 
      ((trapNum :unsigned-integer)) 
  :pointer
   (#x301F #xA346 #x2E88) )

; 
;  *  SetOSTrapAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetOSTrapAddress" 
      ((trapAddr :pointer) (trapNum :unsigned-integer))
   nil
   (:register-trap #xA247 :d0 trapNum :a0 trapAddr))

; 
;  *  GetToolTrapAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetToolTrapAddress" 
      ((trapNum :unsigned-integer)) 
  :pointer
   (#x301F #xA746 #x2E88) )

; 
;  *  SetToolTrapAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetToolTrapAddress" 
      ((trapAddr :pointer) (trapNum :unsigned-integer))
   nil
   (:register-trap #xA647 :d0 trapNum :a0 trapAddr))

; 
;  *  GetToolboxTrapAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetToolboxTrapAddress" 
      ((trapNum :unsigned-integer)) 
  :pointer
   (#x301F #xA746 #x2E88) )

; 
;  *  SetToolboxTrapAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetToolboxTrapAddress" 
      ((trapAddr :pointer) (trapNum :unsigned-integer))
   nil
   (:register-trap #xA647 :d0 trapNum :a0 trapAddr))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC TARGET_CPU_PPC 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  GetTrapVector()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetTrapVector" 
      ((trapNumber :unsigned-integer)) 
  (:pointer :pointer)
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON
; $ENDC                                         ; TARGET_CPU_PPC

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := PatchesIncludes

; $ENDC                                         ; __PATCHES__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Patches)