(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Power.p"
; at Wednesday May 1,2002 2:40:21 pm.
; 
;      File:       Power.p
;  
;      Contains:   Power Manager Interfaces.
;  
;      Version:    Technology: Mac OS 9
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1990-2001 by Apple Computer, Inc.  All rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __POWER__
; $SETC __POWER__ := 1

; $I+
; $SETC PowerIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MULTIPROCESSING__
|#

(require-interface 'Multiprocessing)
#|                                              ; $I Multiprocessing.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __NAMEREGISTRY__
|#

(require-interface 'NameRegistry)
#|                                              ; $I NameRegistry.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;   Bit positions for ModemByte  
(defconstant $modemOnBit 0)
(defconstant $ringWakeUpBit 2)
(defconstant $modemInstalledBit 3)
(defconstant $ringDetectBit 4)
(defconstant $modemOnHookBit 5)

;   masks for ModemByte  
(defconstant $modemOnMask #x1)
(defconstant $ringWakeUpMask #x4)
(defconstant $modemInstalledMask #x8)
(defconstant $ringDetectMask #x10)
(defconstant $modemOnHookMask #x20)

;   bit positions for BatteryByte  
(defconstant $chargerConnBit 0)
(defconstant $hiChargeBit 1)
(defconstant $chargeOverFlowBit 2)
(defconstant $batteryDeadBit 3)
(defconstant $batteryLowBit 4)
(defconstant $connChangedBit 5)

;   masks for BatteryByte  
(defconstant $chargerConnMask #x1)
(defconstant $hiChargeMask #x2)
(defconstant $chargeOverFlowMask #x4)
(defconstant $batteryDeadMask #x8)
(defconstant $batteryLowMask #x10)
(defconstant $connChangedMask #x20)

;   bit positions for SoundMixerByte  
(defconstant $MediaBaySndEnBit 0)
(defconstant $PCISndEnBit 1)
(defconstant $ZVSndEnBit 2)
(defconstant $PCCardSndEnBit 3)

;   masks for SoundMixerByte  
(defconstant $MediaBaySndEnMask #x1)
(defconstant $PCISndEnMask #x2)
(defconstant $ZVSndEnMask #x4)
(defconstant $PCCardSndEnMask #x8)

;   commands to SleepQRec sleepQProc  
(defconstant $kSleepRequest 1)
(defconstant $kSleepDemand 2)
(defconstant $kSleepWakeUp 3)
(defconstant $kSleepRevoke 4)
(defconstant $kSleepUnlock 4)
(defconstant $kSleepDeny 5)                     ;   A non-zero value clients can use to deny requests 
(defconstant $kSleepNow 6)
(defconstant $kDozeDemand 7)
(defconstant $kDozeWakeUp 8)
(defconstant $kDozeRequest 9)                   ;   additional messages for Power Mgr 2.0 
(defconstant $kEnterStandby 10)                 ;   Idle Queue Only 
(defconstant $kEnterRun 11)                     ;   Idle Queue Only 
(defconstant $kSuspendRequest 12)
(defconstant $kSuspendDemand 13)
(defconstant $kSuspendRevoke 14)
(defconstant $kSuspendWakeUp 15)
(defconstant $kGetPowerLevel 16)
(defconstant $kSetPowerLevel 17)
(defconstant $kDeviceInitiatedWake 18)
(defconstant $kWakeToDoze 19)
(defconstant $kDozeToFullWakeUp 20)
(defconstant $kGetPowerInfo 21)
(defconstant $kGetWakeOnNetInfo 22)
(defconstant $kSuspendWakeToDoze 23)
(defconstant $kEnterIdle 24)                    ;   Idle Queue Only 
(defconstant $kStillIdle 25)                    ;   Idle Queue Only 
(defconstant $kExitIdle 26)                     ;   Idle Queue Only 

;   depreciated commands to SleepQRec sleepQProc  
(defconstant $sleepRequest 1)
(defconstant $sleepDemand 2)
(defconstant $sleepWakeUp 3)
(defconstant $sleepRevoke 4)
(defconstant $sleepUnlock 4)
(defconstant $sleepDeny 5)
(defconstant $sleepNow 6)
(defconstant $dozeDemand 7)
(defconstant $dozeWakeUp 8)
(defconstant $dozeRequest 9)
(defconstant $enterStandby 10)
(defconstant $enterRun 11)
(defconstant $suspendRequestMsg 12)
(defconstant $suspendDemandMsg 13)
(defconstant $suspendRevokeMsg 14)
(defconstant $suspendWakeUpMsg 15)
(defconstant $getPowerLevel 16)
(defconstant $setPowerLevel 17)

; 	 Power Handler func messages 	

(def-mactype :powerlevel (find-mactype ':unsigned-long))
; 	 Power levels corresponding to PCI Bus Power Management Interface Spec (PMIS) 	

(defconstant $kPMDevicePowerLevel_On 0)         ;   fully-powered 'On' state (D0 state)     
(defconstant $kPMDevicePowerLevel_D1 1)         ;   not used by Apple system SW          
(defconstant $kPMDevicePowerLevel_D2 2)         ;   not used by Apple system SW          
(defconstant $kPMDevicePowerLevel_Off 3)        ;   main PCI bus power 'Off', but PCI standby power available (D3cold state)  

; 	 PowerHandlerProc definition 	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	PowerHandlerProcPtr = FUNCTION(message: UInt32; param: UNIV Ptr; refCon: UInt32; VAR regEntryID: RegEntryID): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :powerhandlerprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :powerhandlerupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :powerhandlerupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppPowerHandlerProcInfo #x3FF0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewPowerHandlerUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewPowerHandlerProc 
(deftrap "_NewPowerHandlerUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposePowerHandlerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposePowerHandlerUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokePowerHandlerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallPowerHandlerProc 
(deftrap-inline "_InvokePowerHandlerUPP" 
      ((message :unsigned-long) (param :pointer) (refCon :unsigned-long) (RegEntryID (:pointer :regentryid)) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;    Use kIdleQueueDeviceType as the deviceType argument to AddDevicePowerHandler() to get the
;    handler into the idle queue instead of the device sleep queue.
; 
;   PCI power management support 

(defconstant $kUseDefaultMinimumWakeTime 0)     ;   Defaults to 5 minutes 
(defconstant $kPowerSummaryVersion 1)           ;   Version of PowerSummary structure. 
(defconstant $kDevicePowerInfoVersion 1)        ;   Version of DevicePowerInfo structure. 

;   PowerSummary flags 
(defconstant $kPCIPowerOffAllowed #x1)          ;   PCI power off is allowed. 

;   DevicePowerInfo flags 
(defconstant $kDevicePCIPowerOffAllowed #x1)    ;   PCI power off is allowed for device. 
(defconstant $kDeviceSupportsPMIS #x2)          ;   Device supports Power Mgt Interface Spec. 
(defconstant $kDeviceCanAssertPMEDuringSleep #x4);   Device can assert PME# during sleep. 
(defconstant $kDeviceUsesCommonLogicPower #x8)  ;   Device uses common-logic power 
(defconstant $kDeviceDriverPresent #x10)        ;   Driver present for device. 
(defconstant $kDeviceDriverSupportsPowerMgt #x20);   Driver installed a power handler. 

(def-mactype :devicepowerinfoptr (find-mactype '(:pointer :devicepowerinfo)))
(defrecord DevicePowerInfo 
   (version :unsigned-long)                     ;   Version of this structure. 
   (regID :regentryid)                          ;   RegEntryID for device. 
   (flags :unsigned-long)                       ;   Flags 
   (minimumWakeTime :unsigned-long)             ;   Minimum seconds before sleeping again. 
   (sleepPowerNeeded :unsigned-long)            ;   Milliwatts needed in the sleep state. 
   )

(def-mactype :powersummaryptr (find-mactype '(:pointer :powersummary)))
(defrecord PowerSummary 
   (version :unsigned-long)                     ;   Version of this structure. 
   (flags :unsigned-long)                       ;   Flags 
   (sleepPowerAvailable :unsigned-long)         ;   Milliwatts available during sleep. 
   (sleepPowerNeeded :unsigned-long)            ;   Milliwatts needed during sleep. 
   (minimumWakeTime :unsigned-long)             ;   Minimum seconds before sleeping again. 
   (deviceCount :unsigned-long)                 ;   Number of device power info records. 
   (devices (:array :devicepowerinfo 1))        ;   Array of device power info records. 
   )

;   SleepQRec.sleepQFlags  
(defconstant $noCalls 1)
(defconstant $noRequest 2)
(defconstant $slpQType 16)
(defconstant $sleepQType 16)

; 	 Power Mgt Apple Event types and errors 	
;   power mgt class 
(defconstant $kAEMacPowerMgtEvt :|pmgt|)        ;   event ids 
(defconstant $kAEMacToWake :|wake|)
(defconstant $kAEMacLowPowerSaveData :|pmsd|)
(defconstant $kAEMacEmergencySleep :|emsl|)
(defconstant $kAEMacEmergencyShutdown :|emsd|)

; 
; 	   These are result values returned by a Power Handler when queries
; 	   by the Power Mgr if the device which that Power Handler represents
; 	   woke the machine.
; 	
(defconstant $kDeviceDidNotWakeMachine 0)       ;   device did NOT wake machine 
(defconstant $kDeviceRequestsFullWake 1)        ;   device did wake machine and requests full wakeup 
(defconstant $kDeviceRequestsWakeToDoze 2)      ;   device did wake machine and requests partial wakeup 

; 	 bits in bitfield returned by PMFeatures 	
(defconstant $hasWakeupTimer 0)                 ;   1=wakeup timer is supported                     
(defconstant $hasSharedModemPort 1)             ;   1=modem port shared by SCC and internal modem        
(defconstant $hasProcessorCycling 2)            ;   1=processor cycling is supported                 
(defconstant $mustProcessorCycle 3)             ;   1=processor cycling should not be turned off           
(defconstant $hasReducedSpeed 4)                ;   1=processor can be started up at reduced speed         
(defconstant $dynamicSpeedChange 5)             ;   1=processor speed can be switched dynamically        
(defconstant $hasSCSIDiskMode 6)                ;   1=SCSI Disk Mode is supported                  
(defconstant $canGetBatteryTime 7)              ;   1=battery time can be calculated                 
(defconstant $canWakeupOnRing 8)                ;   1=can wakeup when the modem detects a ring           
(defconstant $hasDimmingSupport 9)              ;   1=has dimming support built in (DPMS standby by default)    
(defconstant $hasStartupTimer 10)               ;   1=startup timer is supported                     
(defconstant $hasChargeNotification 11)         ;   1=client can determine of charge connect status change notifications available  
(defconstant $hasDimSuspendSupport 12)          ;   1=supports dimming LCD and CRT to DPMS suspend state      
(defconstant $hasWakeOnNetActivity 13)          ;   1=hardware supports wake on network activity           
(defconstant $hasWakeOnLid 14)                  ;   1=hardware can wake when opened                    
(defconstant $canPowerOffPCIBus 15)             ;   1=hardware can power off PCI bus during sleep if cards allow  
(defconstant $hasDeepSleep 16)                  ;   1=hardware supports deep sleep (hibernation) mode    
(defconstant $hasSleep 17)                      ;   1=hardware supports normal (PowerBook-like) sleep    
(defconstant $supportsServerModeAPIs 18)        ;   1=hardware supports server mode API routines           
(defconstant $supportsUPSIntegration 19)        ;   1=hardware support UPS integration and reporting       
(defconstant $hasAggressiveIdling 20)           ;   1=Power Manager only resets OverallAct on UsrActvity      
(defconstant $supportsIdleQueue 21)             ;   1=Power Manager supports the idle queue               

; 	 bits in bitfield returned by GetIntModemInfo and set by SetIntModemState 	
(defconstant $hasInternalModem 0)               ;   1=internal modem installed                
(defconstant $intModemRingDetect 1)             ;   1=internal modem has detected a ring           
(defconstant $intModemOffHook 2)                ;   1=internal modem is off hook                
(defconstant $intModemRingWakeEnb 3)            ;   1=wakeup on ring is enabled                  
(defconstant $extModemSelected 4)               ;   1=external modem selected              
(defconstant $modemSetBit 15)                   ;   1=set bit, 0=clear bit (SetIntModemState)    

; 	 bits in BatteryInfo.flags                                    	
; 	 ("chargerConnected" doesn't mean the charger is plugged in)  	
(defconstant $batteryInstalled 7)               ;   1=battery is currently connected              
(defconstant $batteryCharging 6)                ;   1=battery is being charged                
(defconstant $chargerConnected 5)               ;   1=charger is connected to the PowerBook          
(defconstant $upsConnected 4)                   ;   1=there is a UPS connected                
(defconstant $upsIsPowerSource 3)               ;   1=UPS is source of power                 

(defconstant $HDPwrQType #x4844)                ;   'HD' hard disk spindown queue element type      
(defconstant $PMgrStateQType #x504D)            ;   'PM' Power Manager state queue element type        

; 	 client notification bits in PMgrQueueElement.pmNotifyBits 	
(defconstant $pmSleepTimeoutChanged 0)
(defconstant $pmSleepEnableChanged 1)
(defconstant $pmHardDiskTimeoutChanged 2)
(defconstant $pmHardDiskSpindownChanged 3)
(defconstant $pmDimmingTimeoutChanged 4)
(defconstant $pmDimmingEnableChanged 5)
(defconstant $pmDiskModeAddressChanged 6)
(defconstant $pmProcessorCyclingChanged 7)
(defconstant $pmProcessorSpeedChanged 8)
(defconstant $pmWakeupTimerChanged 9)
(defconstant $pmStartupTimerChanged 10)
(defconstant $pmHardDiskPowerRemovedbyUser 11)
(defconstant $pmChargeStatusChanged 12)
(defconstant $pmPowerLevelChanged 13)
(defconstant $pmWakeOnNetActivityChanged 14)

(defconstant $pmSleepTimeoutChangedMask #x1)
(defconstant $pmSleepEnableChangedMask #x2)
(defconstant $pmHardDiskTimeoutChangedMask #x4)
(defconstant $pmHardDiskSpindownChangedMask #x8)
(defconstant $pmDimmingTimeoutChangedMask #x10)
(defconstant $pmDimmingEnableChangedMask #x20)
(defconstant $pmDiskModeAddressChangedMask #x40)
(defconstant $pmProcessorCyclingChangedMask #x80)
(defconstant $pmProcessorSpeedChangedMask #x100)
(defconstant $pmWakeupTimerChangedMask #x200)
(defconstant $pmStartupTimerChangedMask #x400)
(defconstant $pmHardDiskPowerRemovedbyUserMask #x800)
(defconstant $pmChargeStatusChangedMask #x1000)
(defconstant $pmPowerLevelChangedMask #x2000)
(defconstant $pmWakeOnNetActivityChangedMask #x4000)

; 	 System Activity Selectors 	
; 	 Notes:  The IdleActivity selector is not available unless the hasAggressiveIdling PMFeatures bit is set. 	
; 	         Use IdleActivity where you used to use OverallAct if necessary.  OverallAct will only            	
; 	         delay power cycling if it's enabled, and will delay sleep by a small amount when                 	
; 	         hasAggressiveIdling is set.  Don't use IdleActivity unless hasAggressiveIdling is set; when      	
; 	         hasAggressiveIdling is not set, the use of IdleActivity is undefined, and well do different      	
; 	         things depending on which Power Manager is currently running.                                    	
(defconstant $OverallAct 0)                     ;   Delays idle sleep by small amount                  
(defconstant $UsrActivity 1)                    ;   Delays idle sleep and dimming by timeout time           
(defconstant $NetActivity 2)                    ;   Delays idle sleep and power cycling by small amount          
(defconstant $HDActivity 3)                     ;   Delays hard drive spindown and idle sleep by small amount   
(defconstant $IdleActivity 4)                   ;   Delays idle sleep by timeout time                  

; 	 Storage Media sleep mode defines 	
(defconstant $kMediaModeOn 0)                   ;   Media active (Drive spinning and at full power)     
(defconstant $kMediaModeStandBy 1)              ;   Media standby (not implemented)     
(defconstant $kMediaModeSuspend 2)              ;   Media Idle (not implemented)    
(defconstant $kMediaModeOff 3)                  ;   Media Sleep (Drive not spinning and at min power, max recovery time)    

(defconstant $kMediaPowerCSCode 70)

; 	 definitions for HDQueueElement.hdFlags   	
(defconstant $kHDQueuePostBit 0)                ;   1 = call this routine on the second pass      
(defconstant $kHDQueuePostMask #x1)

(def-mactype :activityinfoptr (find-mactype '(:pointer :activityinfo)))
(defrecord ActivityInfo 
   (ActivityType :signed-integer)               ;   Type of activity to be fetched.  Same as UpdateSystemActivity Selectors  
   (ActivityTime :unsigned-long)                ;   Time of last activity (in ticks) of specified type.  
   )

; 	 information returned by GetScaledBatteryInfo 	
(def-mactype :batteryinfoptr (find-mactype '(:pointer :batteryinfo)))
(defrecord BatteryInfo 
   (flags :unsigned-byte)                       ;   misc flags (see below)                   
   (warningLevel :unsigned-byte)                ;   scaled warning level (0-255)                
   (reserved :unsigned-byte)                    ;   reserved for internal use              
   (batteryLevel :unsigned-byte)                ;   scaled battery level (0-255)                
   )

(def-mactype :modembyte (find-mactype ':signed-byte))
(def-mactype :batterybyte (find-mactype ':signed-byte))
(def-mactype :soundmixerbyte (find-mactype ':signed-byte))
(def-mactype :pmresultcode (find-mactype ':signed-long))
(def-mactype :sleepqrecptr (find-mactype '(:pointer :sleepqrec)))
(def-mactype :hdqueueelementptr (find-mactype '(:pointer :hdqueueelement)))
(def-mactype :pmgrqueueelementptr (find-mactype '(:pointer :pmgrqueueelement)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SleepQProcPtr = FUNCTION(message: LONGINT; qRecPtr: SleepQRecPtr): LONGINT;

|#
 |#                                             ; $ELSEC
(def-mactype :sleepqprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	HDSpindownProcPtr = PROCEDURE(theElement: HDQueueElementPtr);

|#
 |#                                             ; $ELSEC
(def-mactype :hdspindownprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	PMgrStateChangeProcPtr = PROCEDURE(theElement: PMgrQueueElementPtr; stateBits: LONGINT);

|#
 |#                                             ; $ELSEC
(def-mactype :pmgrstatechangeprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :sleepqupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :sleepqupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :hdspindownupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :hdspindownupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :pmgrstatechangeupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :pmgrstatechangeupp (find-mactype ':pointer))
; $ENDC
(defrecord SleepQRec 
   (sleepQLink (:pointer :sleepqrec))           ;   pointer to next queue element           
   (sleepQType :signed-integer)                 ;   queue element type (must be SleepQType)        
   (sleepQProc :pointer)                        ;   pointer to sleep universal proc ptr          
   (sleepQFlags :signed-integer)                ;   flags                        
   )

(defrecord HDQueueElement 
   (hdQLink (:pointer :hdqueueelement))         ;   pointer to next queue element           
   (hdQType :signed-integer)                    ;   queue element type (must be HDPwrQType)        
   (hdFlags :signed-integer)                    ;   miscellaneous flags                    
   (hdProc :pointer)                            ;   pointer to routine to call            
   (hdUser :signed-long)                        ;   user-defined (variable storage, etc.)    
   )

(defrecord PMgrQueueElement 
   (pmQLink (:pointer :pmgrqueueelement))       ;   pointer to next queue element           
   (pmQType :signed-integer)                    ;   queue element type (must be PMgrStateQType)     
   (pmFlags :signed-integer)                    ;   miscellaneous flags                    
   (pmNotifyBits :signed-long)                  ;   bitmap of which changes to be notified for  
   (pmProc :pointer)                            ;   pointer to routine to call            
   (pmUser :signed-long)                        ;   user-defined (variable storage, etc.)    
   )

(def-mactype :batterytimerecptr (find-mactype '(:pointer :batterytimerec)))
(defrecord BatteryTimeRec 
   (expectedBatteryTime :unsigned-long)         ;   estimated battery time remaining (seconds)  
   (minimumBatteryTime :unsigned-long)          ;   minimum battery time remaining (seconds)      
   (maximumBatteryTime :unsigned-long)          ;   maximum battery time remaining (seconds)      
   (timeUntilCharged :unsigned-long)            ;   time until battery is fully charged (seconds) 
   )

(def-mactype :wakeuptimeptr (find-mactype '(:pointer :wakeuptime)))
(defrecord WakeupTime 
   (wakeTime :unsigned-long)                    ;   wakeup time (same format as current time)    
   (wakeEnabled :boolean)                       ;   1=enable wakeup timer, 0=disable wakeup timer   
   (filler :signed-byte)
   )

(def-mactype :startuptimeptr (find-mactype '(:pointer :startuptime)))
(defrecord StartupTime 
   (startTime :unsigned-long)                   ;   startup time (same format as current time)      
   (startEnabled :boolean)                      ;   1=enable startup timer, 0=disable startup timer     
   (filler :signed-byte)
   )

;   PowerSource version 

(defconstant $kVersionOnePowerSource 1)
(defconstant $kVersionTwoPowerSource 2)
(defconstant $kCurrentPowerSourceVersion 2)

;   PowerSourceAttrs bits 

(defconstant $bSourceIsBattery 0)               ;   power source is battery 
(defconstant $bSourceIsAC 1)                    ;   power source is AC 
(defconstant $bSourceCanBeCharged 2)            ;   power source can be charged 
(defconstant $bSourceIsUPS 3)                   ;   power source is UPS. NOTE: software should set bSourceIsBattery and bSourceIsAC also, as appropriate 
(defconstant $bSourceProvidesWarnLevels 4)      ;   power source provides low power and dead battery warning levels 
(defconstant $kSourceIsBatteryMask #x1)
(defconstant $kSourceIsACMask #x2)
(defconstant $kSourceCanBeChargedMask #x4)
(defconstant $kSourceIsUPSMask #x8)
(defconstant $kSourceProvidesWarnLevelsMask #x10)

;   PowerSourceFlags bits 

(defconstant $bSourceIsAvailable 0)             ;   power source is installed 
(defconstant $bSourceIsCharging 1)              ;   power source being charged 
(defconstant $bChargerIsAttached 2)             ;   a charger is connected 
(defconstant $kSourceIsAvailableMask #x1)
(defconstant $kSourceIsChargingMask #x2)
(defconstant $kChargerIsAttachedMask #x4)

;   Power Capacity Types 

(defconstant $kCapacityIsActual 0)              ;   current capacity is expessed as actual capacity in same units as max 
(defconstant $kCapacityIsPercentOfMax 1)        ;   current capacity is expressed as a percentage of maximumCapacity 

;   Net Activity Wake Options 
(defconstant $kConfigSupportsWakeOnNetBit 0)
(defconstant $kWakeOnNetAdminAccessesBit 1)
(defconstant $kWakeOnAllNetAccessesBit 2)
(defconstant $kUnmountServersBeforeSleepingBit 3)
(defconstant $kConfigSupportsWakeOnNetMask #x1)
(defconstant $kWakeOnNetAdminAccessesMask #x2)
(defconstant $kWakeOnAllNetAccessesMask #x4)
(defconstant $kUnmountServersBeforeSleepingMask #x8)

;   Power Source capacity usage types 
(defconstant $kCurrentCapacityIsActualValue 0)  ;   currentCapacity is a real value in same units as maxCapacity 
(defconstant $kCurrentCapacityIsPercentOfMax 1) ;   currentCapacity is expressed as a percentage of maxCapacity. 

(def-mactype :powersourceid (find-mactype ':signed-integer))
(def-mactype :powersourceparamblockptr (find-mactype '(:pointer :powersourceparamblock)))
(defrecord PowerSourceParamBlock 
   (sourceID :signed-integer)                   ;   unique id assigned by Power Mgr 
   (sourceCapacityUsage :unsigned-integer)      ;   how currentCapacity is used 
   (sourceVersion :unsigned-long)               ;   version of this record 
   (sourceAttr :unsigned-long)                  ;   attribute flags (see below) 
   (sourceState :unsigned-long)                 ;   state flags (see below) 
   (currentCapacity :unsigned-long)             ;   current capacity, in 
;     milliwatts or % 
   (maxCapacity :unsigned-long)                 ;   full capacity, in milliwatts 
   (timeRemaining :unsigned-long)               ;   time left to deplete,  
;     in milliwatt-hours 
   (timeToFullCharge :unsigned-long)            ;   time to charge,  
;     in milliwatt-hours 
   (voltage :unsigned-long)                     ;   voltage in millivolts 
   (current :signed-long)                       ;   current in milliamperes  
;    (negative if consuming,  
;     positive if charging) 
   (lowWarnLevel :unsigned-long)                ;   low warning level in milliwatts (or % if sourceCapacityUsage is %) 
   (deadWarnLevel :unsigned-long)               ;   dead warning level in milliwatts (or % if sourceCapacityUsage is %) 
   (reserved (:array :unsigned-long 16))        ;   for future expansion 
   )

; 
; 	 *  DisableWUTime()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;  *  SetWUTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DisableWUTime" 
      () 
  :signed-integer
   () )                                         ; $IFC CALL_NOT_IN_CARBON ; 
;  *  GetWUTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SetWUTime" 
      ((wuTime :signed-long)) 
  :signed-integer
   () )                                         ; 
;  *  BatteryStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetWUTime" 
      ((wuTime (:pointer :signed-long)) (wuFlag (:pointer :signed-byte))) 
  :signed-integer
   () )                                         ; 
;  *  ModemStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_BatteryStatus" 
      ((status (:pointer :signed-byte)) (power (:pointer :signed-byte))) 
  :signed-integer
   () )
(deftrap-inline "_ModemStatus" 
      ((status (:pointer :signed-byte))) 
  :signed-integer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; 
;  *  IdleUpdate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_IdleUpdate" 
      () 
  :signed-long
   (#xA285 #x2E80) )

; 
;  *  GetCPUSpeed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetCPUSpeed" 
      () 
  :signed-long
   (#x70FF #xA485 #x2E80) )

; 
;  *  EnableIdle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_EnableIdle" 
      () 
  nil
   (#x7000 #xA485) )

; 
;  *  DisableIdle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_DisableIdle" 
      () 
  nil
   (#x7001 #xA485) )

; 
;  *  SleepQInstall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SleepQInstall" 
      ((qRecPtr (:pointer :sleepqrec)))
   nil
   (:register-trap #xA28A :a0 qRecPtr))

; 
;  *  SleepQRemove()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SleepQRemove" 
      ((qRecPtr (:pointer :sleepqrec)))
   nil
   (:register-trap #xA48A :a0 qRecPtr))

; 
;  *  AOn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AOn" 
      () 
  nil
   (#x7004 #xA685) )

; 
;  *  AOnIgnoreModem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AOnIgnoreModem" 
      () 
  nil
   (#x7005 #xA685) )

; 
;  *  BOn()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_BOn" 
      () 
  nil
   (#x7000 #xA685) )

; 
;  *  AOff()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AOff" 
      () 
  nil
   (#x7084 #xA685) )

; 
;  *  BOff()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_BOff" 
      () 
  nil
   (#x7080 #xA685) )

;  Public Power Management API  
; 
;  *  PMSelectorCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_PMSelectorCount" 
      () 
  :signed-integer
   (#x7000 #xA09E #x3E80) )

; 
;  *  PMFeatures()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_PMFeatures" 
      () 
  :unsigned-long
   (#x7001 #xA09E #x2E80) )

; 
;  *  GetSleepTimeout()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetSleepTimeout" 
      () 
  :uint8
   (#x7002 #xA09E #x1E80) )

; 
;  *  SetSleepTimeout()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_SetSleepTimeout" 
      ((timeout :signed-byte)) 
  nil
   (#x101F #x4840 #x303C #x3 #xA09E) )

; 
;  *  GetHardDiskTimeout()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetHardDiskTimeout" 
      () 
  :uint8
   (#x7004 #xA09E #x1E80) )

; 
;  *  SetHardDiskTimeout()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_SetHardDiskTimeout" 
      ((timeout :signed-byte)) 
  nil
   (#x101F #x4840 #x303C #x5 #xA09E) )

; 
;  *  HardDiskPowered()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_HardDiskPowered" 
      () 
  :boolean
   (#x7006 #xA09E #x1E80) )

; 
;  *  SpinDownHardDisk()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_SpinDownHardDisk" 
      () 
  nil
   (#x7007 #xA09E) )

; 
;  *  IsSpindownDisabled()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_IsSpindownDisabled" 
      () 
  :boolean
   (#x7008 #xA09E #x1E80) )

; 
;  *  SetSpindownDisable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_SetSpindownDisable" 
      ((setDisable :boolean)) 
  nil
   (#x101F #x4840 #x303C #x9 #xA09E) )

; 
;  *  HardDiskQInstall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_HardDiskQInstall" 
      ((theElement (:pointer :hdqueueelement)))
   (:d0 :signed-integer)
   (:register-trap #xA09E :a0 theElement :d0 10))

; 
;  *  HardDiskQRemove()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_HardDiskQRemove" 
      ((theElement (:pointer :hdqueueelement)))
   (:d0 :signed-integer)
   (:register-trap #xA09E :a0 theElement :d0 11))

; 
;  *  GetScaledBatteryInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetScaledBatteryInfo" 
      ((whichBattery :signed-integer) (theInfo (:pointer :batteryinfo))) 
  nil
   (#x205F #x301F #x4840 #x303C #xC #xA09E #x2080) )

; 
;  *  AutoSleepControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_AutoSleepControl" 
      ((enableSleep :boolean)) 
  nil
   (#x101F #x4840 #x303C #xD #xA09E) )

; 
;  *  GetIntModemInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetIntModemInfo" 
      () 
  :unsigned-long
   (#x700E #xA09E #x2E80) )

; 
;  *  SetIntModemState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_SetIntModemState" 
      ((theState :signed-integer)) 
  nil
   (#x301F #x4840 #x303C #xF #xA09E) )

; 
;  *  MaximumProcessorSpeed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MaximumProcessorSpeed" 
      () 
  :signed-integer
   (#x7010 #xA09E #x3E80) )

; 
;  *  MinimumProcessorSpeed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_MinimumProcessorSpeed" 
      () 
  :signed-integer
   (#x7036 #xA09E #x3E80) )

; 
;  *  CurrentProcessorSpeed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_CurrentProcessorSpeed" 
      () 
  :signed-integer
   (#x7011 #xA09E #x3E80) )

; 
;  *  FullProcessorSpeed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_FullProcessorSpeed" 
      () 
  :boolean
   (#x7012 #xA09E #x1E80) )

; 
;  *  SetProcessorSpeed()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_SetProcessorSpeed" 
      ((fullSpeed :boolean)) 
  :boolean
   (#x101F #x4840 #x303C #x13 #xA09E #x1E80) )

; 
;  *  GetSCSIDiskModeAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetSCSIDiskModeAddress" 
      () 
  :signed-integer
   (#x7014 #xA09E #x3E80) )

; 
;  *  SetSCSIDiskModeAddress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_SetSCSIDiskModeAddress" 
      ((scsiAddress :signed-integer)) 
  nil
   (#x301F #x4840 #x303C #x15 #xA09E) )

; 
;  *  GetWakeupTimer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetWakeupTimer" 
      ((theTime (:pointer :wakeuptime))) 
  nil
   (#x205F #x7016 #xA09E) )

; 
;  *  SetWakeupTimer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_SetWakeupTimer" 
      ((theTime (:pointer :wakeuptime))) 
  nil
   (#x205F #x7017 #xA09E) )

; 
;  *  IsProcessorCyclingEnabled()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_IsProcessorCyclingEnabled" 
      () 
  :boolean
   (#x7018 #xA09E #x1E80) )

; 
;  *  EnableProcessorCycling()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_EnableProcessorCycling" 
      ((enable :boolean)) 
  nil
   (#x101F #x4840 #x303C #x19 #xA09E) )

; 
;  *  BatteryCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_BatteryCount" 
      () 
  :signed-integer
   (#x701A #xA09E #x3E80) )

; 
;  *  GetBatteryVoltage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetBatteryVoltage" 
      ((whichBattery :signed-integer)) 
  :fixed
   (#x301F #x4840 #x303C #x1B #xA09E #x2E80) )

; 
;  *  GetBatteryTimes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetBatteryTimes" 
      ((whichBattery :signed-integer) (theTimes (:pointer :batterytimerec))) 
  nil
   (#x205F #x301F #x4840 #x303C #x1C #xA09E) )

; 
;  *  GetDimmingTimeout()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetDimmingTimeout" 
      () 
  :uint8
   (#x701D #xA09E #x1E80) )

; 
;  *  SetDimmingTimeout()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_SetDimmingTimeout" 
      ((timeout :signed-byte)) 
  nil
   (#x101F #x4840 #x303C #x1E #xA09E) )

; 
;  *  DimmingControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_DimmingControl" 
      ((enableSleep :boolean)) 
  nil
   (#x101F #x4840 #x303C #x1F #xA09E) )

; 
;  *  IsDimmingControlDisabled()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_IsDimmingControlDisabled" 
      () 
  :boolean
   (#x7020 #xA09E #x1E80) )

; 
;  *  IsAutoSlpControlDisabled()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_IsAutoSlpControlDisabled" 
      () 
  :boolean
   (#x7021 #xA09E #x1E80) )

; 
;  *  PMgrStateQInstall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PMgrStateQInstall" 
      ((theElement (:pointer :pmgrqueueelement)))
   (:d0 :signed-integer)
   (:register-trap #xA09E :a0 theElement :d0 34))

; 
;  *  PMgrStateQRemove()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PMgrStateQRemove" 
      ((theElement (:pointer :pmgrqueueelement)))
   (:d0 :signed-integer)
   (:register-trap #xA09E :a0 theElement :d0 35))

; 
;  *  UpdateSystemActivity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_UpdateSystemActivity" 
      ((activity :signed-byte)) 
  :signed-integer
   (#x101F #x4840 #x303C #x24 #xA09E #x3E80) )

; 
;  *  DelaySystemIdle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_DelaySystemIdle" 
      () 
  :signed-integer
   (#x7025 #xA09E #x3E80) )

; 
;  *  GetStartupTimer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetStartupTimer" 
      ((theTime (:pointer :startuptime)))
   (:d0 :signed-integer)
   (:register-trap #xA09E :a0 theTime :d0 38))

; 
;  *  SetStartupTimer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetStartupTimer" 
      ((theTime (:pointer :startuptime)))
   (:d0 :signed-integer)
   (:register-trap #xA09E :a0 theTime :d0 39))

; 
;  *  GetLastActivity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetLastActivity" 
      ((theActivity (:pointer :activityinfo)))
   (:d0 :signed-integer)
   (:register-trap #xA09E :a0 theActivity :d0 40))

; 
;  *  GetSoundMixerState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetSoundMixerState" 
      ((theSoundMixerByte (:pointer :signed-byte)))
   (:d0 :signed-integer)
   (:register-trap #xA09E :a0 theSoundMixerByte :d0 41))

; 
;  *  SetSoundMixerState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetSoundMixerState" 
      ((theSoundMixerByte (:pointer :signed-byte)))
   (:d0 :signed-integer)
   (:register-trap #xA09E :a0 theSoundMixerByte :d0 42))

; 
;  *  GetDimSuspendState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_GetDimSuspendState" 
      () 
  :boolean
   (#x702B #xA09E #x1E80) )

; 
;  *  SetDimSuspendState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 1.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_SetDimSuspendState" 
      ((dimSuspendState :boolean)) 
  nil
   (#x101F #x4840 #x303C #x2C #xA09E) )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  GetCoreProcessorTemperature()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetCoreProcessorTemperature" 
      ((inCpuID :pointer))
   (:d0 :signed-long)
   (:register-trap #xA09E :a0 inCpuID :d0 45))

; 
;  *  GetWakeOnNetworkOptions()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetWakeOnNetworkOptions" 
      () 
  :unsigned-long
   (#x702E #xA09E #x2E80) )

; 
;  *  SetWakeOnNetworkOptions()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SetWakeOnNetworkOptions" 
      ((inOptions :unsigned-long)) 
  nil
   (#x205F #x702F #xA09E) )

; 
;  *  AddPowerSource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AddPowerSource" 
      ((ioPowerSource (:pointer :powersourceparamblock)))
   (:d0 :osstatus)
   (:register-trap #xA09E :a0 ioPowerSource :d0 48))

; 
;  *  RemovePowerSource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_RemovePowerSource" 
      ((inSourceID :signed-integer)) 
  :osstatus
   (#x301F #x4840 #x303C #x31 #xA09E #x2E80) )

; 
;  *  UpdatePowerSource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UpdatePowerSource" 
      ((ioSource (:pointer :powersourceparamblock)))
   (:d0 :osstatus)
   (:register-trap #xA09E :a0 ioSource :d0 50))

; 
;  *  IsServerModeEnabled()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_IsServerModeEnabled" 
      () 
  :boolean
   (#x7033 #xA09E #x1E80) )

; 
;  *  EnableServerMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EnableServerMode" 
      ((inEnable :boolean)) 
  nil
   (#x101F #x4840 #x303C #x34 #xA09E) )

;  
;    NumBatteriesInstalled is different from BatteryCount in that it
;    indicates how many batteries are actually available at the time
;    it is called (including UPS batteries). BatteryCount shows a 
;    static number of batteries a machine is capable of holding which does NOT
;    include UPS batteries. So, while a desktop might show a BatteryCount
;    of zero, its NumBatteriesInstalled value might be 1 or more if a UPS
;    is attached. 
; 
; 
;  *  NumBatteriesInstalled()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in PowerMgrLib 2.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_NumBatteriesInstalled" 
      () 
  :unsigned-long
   (#x7035 #xA09E #x2E80) )

;  Power Handler Management 
; 
;  *  IsPCIPowerOffDisabled()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_IsPCIPowerOffDisabled" 
      () 
  :boolean
   () )

; 
;  *  EnablePCIPowerOff()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_EnablePCIPowerOff" 
      ((inEnable :boolean)) 
  nil
   () )

; 
;  *  AddDevicePowerHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_AddDevicePowerHandler" 
      ((regEntryID (:pointer :regentryid)) (handler :pointer) (refCon :unsigned-long) (deviceType :pointer)) 
  :osstatus
   () )

; 
;  *  RemoveDevicePowerHandler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_RemoveDevicePowerHandler" 
      ((regEntryID (:pointer :regentryid))) 
  :osstatus
   () )

; 
;  *  RemoveDevicePowerHandlerForProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_RemoveDevicePowerHandlerForProc" 
      ((proc :pointer)) 
  :osstatus
   () )

; 
;  *  GetDevicePowerLevel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetDevicePowerLevel" 
      ((regEntryID (:pointer :regentryid)) (devicePowerLevel (:pointer :unsigned-long))) 
  :osstatus
   () )

; 
;  *  SetDevicePowerLevel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in DriverServicesLib 1.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SetDevicePowerLevel" 
      ((regEntryID (:pointer :regentryid)) (devicePowerLevel :unsigned-long)) 
  :osstatus
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $uppSleepQProcInfo #x131832)
(defconstant $uppHDSpindownProcInfo #xC0)
(defconstant $uppPMgrStateChangeProcInfo #x3C0)
; 
; 	 *  NewSleepQUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewSleepQProc 
(deftrap "_NewSleepQUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewHDSpindownUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewHDSpindownProc 
(deftrap "_NewHDSpindownUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewPMgrStateChangeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewPMgrStateChangeProc 
(deftrap "_NewPMgrStateChangeUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeSleepQUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeSleepQUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeHDSpindownUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeHDSpindownUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposePMgrStateChangeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposePMgrStateChangeUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeSleepQUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallSleepQProc                  ; 
;  *  InvokeHDSpindownUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InvokeSleepQUPP" 
      ((message :signed-long) (qRecPtr (:pointer :sleepqrec)) (userRoutine :pointer)) 
  :signed-long
   () )                                         ;  old name was CallHDSpindownProc 
(deftrap-inline "_InvokeHDSpindownUPP" 
      ((theElement (:pointer :hdqueueelement)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokePMgrStateChangeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallPMgrStateChangeProc 
(deftrap-inline "_InvokePMgrStateChangeUPP" 
      ((theElement (:pointer :pmgrqueueelement)) (stateBits :signed-long) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := PowerIncludes

; $ENDC                                         ; __POWER__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Power)