(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QD3DGroup.p"
; at Wednesday May 1,2002 2:42:29 pm.
; 
;      File:       QD3DGroup.p
;  
;      Contains:   Q3Group methods
;  
;      Version:    Technology: Quickdraw 3D 1.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __QD3DGROUP__
; $SETC __QD3DGROUP__ := 1

; $I+
; $SETC QD3DGroupIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __QD3D__
|#

(require-interface 'QD3D)
#|                                              ; $I QD3D.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

; *****************************************************************************
;  **                                                                          **
;  **                         Group Typedefs                                   **
;  **                                                                          **
;  ****************************************************************************
; 
;  * These flags affect how a group is traversed
;  * They apply to when a group is "drawn", "picked", "bounded", "written"
;  

(def-mactype :tq3displaygroupstatemasks (find-mactype ':signed-long))

(defconstant $kQ3DisplayGroupStateNone 0)
(defconstant $kQ3DisplayGroupStateMaskIsDrawn #x1)
(defconstant $kQ3DisplayGroupStateMaskIsInline #x2)
(defconstant $kQ3DisplayGroupStateMaskUseBoundingBox #x4)
(defconstant $kQ3DisplayGroupStateMaskUseBoundingSphere #x8)
(defconstant $kQ3DisplayGroupStateMaskIsPicked #x10)
(defconstant $kQ3DisplayGroupStateMaskIsWritten #x20)

(def-mactype :tq3displaygroupstate (find-mactype ':unsigned-long))
; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                 Group Routines (apply to all groups)                     **
; 	 **                                                                          **
; 	 ****************************************************************************	
; 	 May contain any shared object 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Group_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3Group_New" 
      () 
  :pointer
   () )

; 
;  *  Q3Group_GetType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Group_GetType" 
      ((group :pointer)) 
  :tq3objecttype
   () )

; 
;  *  Q3Group_AddObject()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Group_AddObject" 
      ((group :pointer) (object :pointer)) 
  :pointer
   () )

; 
;  *  Q3Group_AddObjectBefore()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Group_AddObjectBefore" 
      ((group :pointer) (position :pointer) (object :pointer)) 
  :pointer
   () )

; 
;  *  Q3Group_AddObjectAfter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Group_AddObjectAfter" 
      ((group :pointer) (position :pointer) (object :pointer)) 
  :pointer
   () )

; 
;  *  Q3Group_GetPositionObject()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Group_GetPositionObject" 
      ((group :pointer) (position :pointer) (object (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Group_SetPositionObject()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Group_SetPositionObject" 
      ((group :pointer) (position :pointer) (object :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Group_RemovePosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Group_RemovePosition" 
      ((group :pointer) (position :pointer)) 
  :pointer
   () )

; 
;  *  Q3Group_GetFirstPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Group_GetFirstPosition" 
      ((group :pointer) (position (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Group_GetLastPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Group_GetLastPosition" 
      ((group :pointer) (position (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Group_GetNextPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Group_GetNextPosition" 
      ((group :pointer) (position (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Group_GetPreviousPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Group_GetPreviousPosition" 
      ((group :pointer) (position (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Group_CountObjects()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Group_CountObjects" 
      ((group :pointer) (nObjects (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Group_EmptyObjects()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Group_EmptyObjects" 
      ((group :pointer)) 
  :tq3status
   () )

; 
;  *  Typed Access
;  
; 
;  *  Q3Group_GetFirstPositionOfType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Group_GetFirstPositionOfType" 
      ((group :pointer) (isType :signed-long) (position (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Group_GetLastPositionOfType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Group_GetLastPositionOfType" 
      ((group :pointer) (isType :signed-long) (position (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Group_GetNextPositionOfType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Group_GetNextPositionOfType" 
      ((group :pointer) (isType :signed-long) (position (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Group_GetPreviousPositionOfType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Group_GetPreviousPositionOfType" 
      ((group :pointer) (isType :signed-long) (position (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Group_CountObjectsOfType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Group_CountObjectsOfType" 
      ((group :pointer) (isType :signed-long) (nObjects (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Group_EmptyObjectsOfType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Group_EmptyObjectsOfType" 
      ((group :pointer) (isType :signed-long)) 
  :tq3status
   () )

; 
;  *  Determine position of objects in a group
;  
; 
;  *  Q3Group_GetFirstObjectPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Group_GetFirstObjectPosition" 
      ((group :pointer) (object :pointer) (position (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Group_GetLastObjectPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Group_GetLastObjectPosition" 
      ((group :pointer) (object :pointer) (position (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Group_GetNextObjectPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Group_GetNextObjectPosition" 
      ((group :pointer) (object :pointer) (position (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3Group_GetPreviousObjectPosition()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Group_GetPreviousObjectPosition" 
      ((group :pointer) (object :pointer) (position (:pointer :pointer))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Group Subclasses                                 **
;  **                                                                          **
;  ****************************************************************************
;  Must contain only lights 
; 
;  *  Q3LightGroup_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3LightGroup_New" 
      () 
  :pointer
   () )

;  Must contain only strings 
; 
;  *  Q3InfoGroup_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3InfoGroup_New" 
      () 
  :pointer
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Display Group Routines                               **
;  **                                                                          **
;  ****************************************************************************
;  May contain only drawables 
; 
;  *  Q3DisplayGroup_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DisplayGroup_New" 
      () 
  :pointer
   () )

; 
;  *  Q3DisplayGroup_GetType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DisplayGroup_GetType" 
      ((group :pointer)) 
  :tq3objecttype
   () )

; 
;  *  Q3DisplayGroup_GetState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DisplayGroup_GetState" 
      ((group :pointer) (state (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3DisplayGroup_SetState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DisplayGroup_SetState" 
      ((group :pointer) (state :unsigned-long)) 
  :tq3status
   () )

; 
;  *  Q3DisplayGroup_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DisplayGroup_Submit" 
      ((group :pointer) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3DisplayGroup_SetAndUseBoundingBox()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DisplayGroup_SetAndUseBoundingBox" 
      ((group :pointer) (bBox (:pointer :tq3boundingbox))) 
  :tq3status
   () )

; 
;  *  Q3DisplayGroup_GetBoundingBox()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DisplayGroup_GetBoundingBox" 
      ((group :pointer) (bBox (:pointer :tq3boundingbox))) 
  :tq3status
   () )

; 
;  *  Q3DisplayGroup_RemoveBoundingBox()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DisplayGroup_RemoveBoundingBox" 
      ((group :pointer)) 
  :tq3status
   () )

; 
;  *  Q3DisplayGroup_CalcAndUseBoundingBox()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3DisplayGroup_CalcAndUseBoundingBox" 
      ((group :pointer) (computeBounds :signed-long) (view :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **     Ordered Display Group                                                **
;  **                                                                          **
;  **     Ordered display groups keep objects in order by the type of object:  **
;  **                                                                          **
;  **     1   kQ3ShapeTypeTransform                                            **
;  **     2   kQ3ShapeTypeStyle                                                **
;  **     3   kQ3SetTypeAttribute                                              **
;  **     4   kQ3ShapeTypeShader                                               **
;  **     5   kQ3ShapeTypeCamera                                               **
;  **     6   kQ3ShapeTypeLight                                                **
;  **     7   kQ3ShapeTypeGeometry                                             **
;  **     8   kQ3ShapeTypeGroup                                                **         
;  **     9   kQ3ShapeTypeUnknown                                              **
;  **                                                                          **
;  **     Within a type, you are responsible for keeping things in order.      **
;  **                                                                          **
;  **     You may access and/or manipulate the group using the above types     **
;  **     (fast), or you may use any parent or leaf class types (slower).      **
;  **                                                                          **
;  **     Additional types will be added as functionality grows.               **
;  **                                                                          **
;  **     The group calls which access by type are much faster for ordered     ** 
;  **     display group for the types above.                                   **
;  **                                                                          **
;  **     N.B. Lights and Cameras in groups are a no-op when drawn and will    **
;  **          post an error with the debug libraries.                         **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3OrderedDisplayGroup_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3OrderedDisplayGroup_New" 
      () 
  :pointer
   () )

; *****************************************************************************
;  **                                                                          **
;  **     IO Proxy Display Group                                               **
;  **                                                                          **
;  **     IO Proxy display groups are used to place more than one              **
;  **     representation of an object in a metafile. For example, if you know  **
;  **     another program does not understand NURBPatches but does understand  **
;  **     Meshes, you may place a mesh and a NURB Patch in an IO Proxy Group,  **
;  **     and the reading program will select the desired representation.      **
;  **                                                                          **
;  **     Objects in an IO Proxy Display Group are placed in their preferencial**
;  **     order, with the FIRST object being the MOST preferred, the LAST      **
;  **     object the least preferred.                                          **
;  **                                                                          **
;  **     The behavior of an IO Proxy Display Group is that when drawn/picked/ **
;  **     bounded, the first object in the group that is not "Unknown" is used,**
;  **     and the other objects ignored.                                       **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3IOProxyDisplayGroup_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3IOProxyDisplayGroup_New" 
      () 
  :pointer
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Group Extension Definitions                          **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Searching methods - OPTIONAL
;  
; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $kQ3XMethodType_GroupAcceptObject :|gaco|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XGroupAcceptObjectMethod = FUNCTION(group: TQ3GroupObject; object: TQ3Object): TQ3Boolean; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xgroupacceptobjectmethod (find-mactype ':pointer))
; $ENDC

(defconstant $kQ3XMethodType_GroupAddObject :|gado|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XGroupAddObjectMethod = FUNCTION(group: TQ3GroupObject; object: TQ3Object): TQ3GroupPosition; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xgroupaddobjectmethod (find-mactype ':pointer))
; $ENDC

(defconstant $kQ3XMethodType_GroupAddObjectBefore :|gaob|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XGroupAddObjectBeforeMethod = FUNCTION(group: TQ3GroupObject; position: TQ3GroupPosition; object: TQ3Object): TQ3GroupPosition; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xgroupaddobjectbeforemethod (find-mactype ':pointer))
; $ENDC

(defconstant $kQ3XMethodType_GroupAddObjectAfter :|gaoa|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XGroupAddObjectAfterMethod = FUNCTION(group: TQ3GroupObject; position: TQ3GroupPosition; object: TQ3Object): TQ3GroupPosition; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xgroupaddobjectaftermethod (find-mactype ':pointer))
; $ENDC

(defconstant $kQ3XMethodType_GroupSetPositionObject :|gspo|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XGroupSetPositionObjectMethod = FUNCTION(group: TQ3GroupObject; gPos: TQ3GroupPosition; obj: TQ3Object): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xgroupsetpositionobjectmethod (find-mactype ':pointer))
; $ENDC

(defconstant $kQ3XMethodType_GroupRemovePosition :|grmp|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XGroupRemovePositionMethod = FUNCTION(group: TQ3GroupObject; position: TQ3GroupPosition): TQ3Object; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xgroupremovepositionmethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  Searching methods - OPTIONAL - default uses above methods
; 	 	

(defconstant $kQ3XMethodType_GroupGetFirstPositionOfType :|gfrt|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XGroupGetFirstPositionOfTypeMethod = FUNCTION(group: TQ3GroupObject; isType: TQ3ObjectType; VAR gPos: TQ3GroupPosition): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xgroupgetfirstpositionoftypemethod (find-mactype ':pointer))
; $ENDC

(defconstant $kQ3XMethodType_GroupGetLastPositionOfType :|glst|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XGroupGetLastPositionOfTypeMethod = FUNCTION(group: TQ3GroupObject; isType: TQ3ObjectType; VAR gPos: TQ3GroupPosition): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xgroupgetlastpositionoftypemethod (find-mactype ':pointer))
; $ENDC

(defconstant $kQ3XMethodType_GroupGetNextPositionOfType :|gnxt|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XGroupGetNextPositionOfTypeMethod = FUNCTION(group: TQ3GroupObject; isType: TQ3ObjectType; VAR gPos: TQ3GroupPosition): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xgroupgetnextpositionoftypemethod (find-mactype ':pointer))
; $ENDC

(defconstant $kQ3XMethodType_GroupGetPrevPositionOfType :|gpvt|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XGroupGetPrevPositionOfTypeMethod = FUNCTION(group: TQ3GroupObject; isType: TQ3ObjectType; VAR gPos: TQ3GroupPosition): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xgroupgetprevpositionoftypemethod (find-mactype ':pointer))
; $ENDC

(defconstant $kQ3XMethodType_GroupCountObjectsOfType :|gcnt|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XGroupCountObjectsOfTypeMethod = FUNCTION(group: TQ3GroupObject; isType: TQ3ObjectType; VAR nObjects: UInt32): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xgroupcountobjectsoftypemethod (find-mactype ':pointer))
; $ENDC

(defconstant $kQ3XMethodType_GroupEmptyObjectsOfType :|geot|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XGroupEmptyObjectsOfTypeMethod = FUNCTION(group: TQ3GroupObject; isType: TQ3ObjectType): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xgroupemptyobjectsoftypemethod (find-mactype ':pointer))
; $ENDC

(defconstant $kQ3XMethodType_GroupGetFirstObjectPosition :|gfop|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XGroupGetFirstObjectPositionMethod = FUNCTION(group: TQ3GroupObject; object: TQ3Object; VAR gPos: TQ3GroupPosition): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xgroupgetfirstobjectpositionmethod (find-mactype ':pointer))
; $ENDC

(defconstant $kQ3XMethodType_GroupGetLastObjectPosition :|glop|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XGroupGetLastObjectPositionMethod = FUNCTION(group: TQ3GroupObject; object: TQ3Object; VAR gPos: TQ3GroupPosition): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xgroupgetlastobjectpositionmethod (find-mactype ':pointer))
; $ENDC

(defconstant $kQ3XMethodType_GroupGetNextObjectPosition :|gnop|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XGroupGetNextObjectPositionMethod = FUNCTION(group: TQ3GroupObject; object: TQ3Object; VAR gPos: TQ3GroupPosition): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xgroupgetnextobjectpositionmethod (find-mactype ':pointer))
; $ENDC

(defconstant $kQ3XMethodType_GroupGetPrevObjectPosition :|gpop|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XGroupGetPrevObjectPositionMethod = FUNCTION(group: TQ3GroupObject; object: TQ3Object; VAR gPos: TQ3GroupPosition): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xgroupgetprevobjectpositionmethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  Group Position Methods
; 	 	

(defconstant $kQ3XMethodType_GroupPositionSize :|ggpz|)

(def-mactype :tq3xmethodtypegrouppositionsize (find-mactype ':unsigned-long))

(defconstant $kQ3XMethodType_GroupPositionNew :|ggpn|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XGroupPositionNewMethod = FUNCTION(gPos: UNIV Ptr; object: TQ3Object; initData: UNIV Ptr): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xgrouppositionnewmethod (find-mactype ':pointer))
; $ENDC

(defconstant $kQ3XMethodType_GroupPositionCopy :|ggpc|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XGroupPositionCopyMethod = FUNCTION(srcGPos: UNIV Ptr; dstGPos: UNIV Ptr): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xgrouppositioncopymethod (find-mactype ':pointer))
; $ENDC

(defconstant $kQ3XMethodType_GroupPositionDelete :|ggpd|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XGroupPositionDeleteMethod = PROCEDURE(gPos: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xgrouppositiondeletemethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  View Drawing Helpers
; 	 *  
; 	 *  TQ3XGroupStartIterateMethod
; 	 *
; 	 *      Pass back *object = NULL to NOT call EndIterate iterate
; 	 *      Pass back *object != NULL to draw object
; 	 *       (other side will pass it to EndIterate for deletion!)
; 	 *
; 	 *      *iterator is uninitialized, use for iteration state. Caller should 
; 	 *       ignore it.
; 	 *  
; 	 *  TQ3XGroupEndIterateMethod
; 	 *  
; 	 *      *object is previous object, dispose it or play with it.
; 	 *      Pass back NULL when last iteration has occurred
; 	 *      *iterator is previous value, use for iteration state Caller should 
; 	 *      ignore it.
; 	 	

(defconstant $kQ3XMethodType_GroupStartIterate :|gstd|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XGroupStartIterateMethod = FUNCTION(group: TQ3GroupObject; VAR iterator: TQ3GroupPosition; VAR object: TQ3Object; view: TQ3ViewObject): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xgroupstartiteratemethod (find-mactype ':pointer))
; $ENDC

(defconstant $kQ3XMethodType_GroupEndIterate :|gitd|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XGroupEndIterateMethod = FUNCTION(group: TQ3GroupObject; VAR iterator: TQ3GroupPosition; VAR object: TQ3Object; view: TQ3ViewObject): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xgroupenditeratemethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  IO  Helpers
; 	 *  
; 	 *  TQ3XGroupEndReadMethod
; 	 *      Called when a group has been completely read. Group should perform
; 	 *      validation and clean up any reading caches.
; 	 	

(defconstant $kQ3XMethodType_GroupEndRead :|gerd|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XGroupEndReadMethod = FUNCTION(group: TQ3GroupObject): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xgroupendreadmethod (find-mactype ':pointer))
; $ENDC

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3XGroup_GetPositionPrivate()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3XGroup_GetPositionPrivate" 
      ((group :pointer) (position :pointer)) 
  :pointer
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QD3DGroupIncludes

; $ENDC                                         ; __QD3DGROUP__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'QD3DGroup)