(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QD3DMath.p"
; at Wednesday May 1,2002 2:42:34 pm.
; 
;      File:       QD3DMath.p
;  
;      Contains:   Math & matrix routines and definitions.
;  
;      Version:    Technology: Quickdraw 3D 1.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __QD3DMATH__
; $SETC __QD3DMATH__ := 1

; $I+
; $SETC QD3DMathIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __QD3D__
|#

(require-interface 'QD3D)
#|                                              ; $I QD3D.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

; *****************************************************************************
;  **                                                                          **
;  **                         Constant Definitions                             **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Real zero definition
;  

(defconstant $kQ3RealZero 1.1920929E-7)
(defconstant $kQ3MaxFloat 3.40282347E+38)
; 
;  *  Values of PI
;  
(defconstant $kQ3Pi 3.1415926535898)
(defconstant $kQ32Pi 6.2831853071796)
(defconstant $kQ3PiOver2 1.5707963267949)
(defconstant $kQ33PiOver2 4.7123889803847)

; *****************************************************************************
;  **                                                                          **
;  **                         Miscellaneous Functions                          **
;  **                                                                          **
;  ****************************************************************************

; *****************************************************************************
;  **                                                                          **
;  **                         Point and Vector Creation                        **
;  **                                                                          **
;  ****************************************************************************
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Q3Point2D_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Point2D_Set" 
      ((point2D (:pointer :tq3point2d)) (x :single-float) (y :single-float)) 
  (:pointer :tq3point2d)
   () )

; 
;  *  Q3Param2D_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Param2D_Set" 
      ((param2D (:pointer :tq3param2d)) (u :single-float) (v :single-float)) 
  (:pointer :tq3param2d)
   () )

; 
;  *  Q3Point3D_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Point3D_Set" 
      ((point3D (:pointer :tq3point3d)) (x :single-float) (y :single-float) (z :single-float)) 
  (:pointer :tq3point3d)
   () )

; 
;  *  Q3RationalPoint3D_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3RationalPoint3D_Set" 
      ((point3D (:pointer :tq3rationalpoint3d)) (x :single-float) (y :single-float) (w :single-float)) 
  (:pointer :tq3rationalpoint3d)
   () )

; 
;  *  Q3RationalPoint4D_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3RationalPoint4D_Set" 
      ((point4D (:pointer :tq3rationalpoint4d)) (x :single-float) (y :single-float) (z :single-float) (w :single-float)) 
  (:pointer :tq3rationalpoint4d)
   () )

; 
;  *  Q3Vector2D_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Vector2D_Set" 
      ((vector2D (:pointer :tq3vector2d)) (x :single-float) (y :single-float)) 
  (:pointer :tq3vector2d)
   () )

; 
;  *  Q3Vector3D_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Vector3D_Set" 
      ((vector3D (:pointer :tq3vector3d)) (x :single-float) (y :single-float) (z :single-float)) 
  (:pointer :tq3vector3d)
   () )

; 
;  *  Q3PolarPoint_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PolarPoint_Set" 
      ((polarPoint (:pointer :tq3polarpoint)) (r :single-float) (theta :single-float)) 
  (:pointer :tq3polarpoint)
   () )

; 
;  *  Q3SphericalPoint_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3SphericalPoint_Set" 
      ((sphericalPoint (:pointer :tq3sphericalpoint)) (rho :single-float) (theta :single-float) (phi :single-float)) 
  (:pointer :tq3sphericalpoint)
   () )

; *****************************************************************************
;  **                                                                          **
;  **                 Point and Vector Dimension Conversion                    **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Point2D_To3D()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Point2D_To3D" 
      ((point2D (:pointer :tq3point2d)) (result (:pointer :tq3point3d))) 
  (:pointer :tq3point3d)
   () )

; 
;  *  Q3RationalPoint3D_To2D()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3RationalPoint3D_To2D" 
      ((point3D (:pointer :tq3rationalpoint3d)) (result (:pointer :tq3point2d))) 
  (:pointer :tq3point2d)
   () )

; 
;  *  Q3Point3D_To4D()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Point3D_To4D" 
      ((point3D (:pointer :tq3point3d)) (result (:pointer :tq3rationalpoint4d))) 
  (:pointer :tq3rationalpoint4d)
   () )

; 
;  *  Q3RationalPoint4D_To3D()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3RationalPoint4D_To3D" 
      ((point4D (:pointer :tq3rationalpoint4d)) (result (:pointer :tq3point3d))) 
  (:pointer :tq3point3d)
   () )

; 
;  *  Q3Vector2D_To3D()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Vector2D_To3D" 
      ((vector2D (:pointer :tq3vector2d)) (result (:pointer :tq3vector3d))) 
  (:pointer :tq3vector3d)
   () )

; 
;  *  Q3Vector3D_To2D()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Vector3D_To2D" 
      ((vector3D (:pointer :tq3vector3d)) (result (:pointer :tq3vector2d))) 
  (:pointer :tq3vector2d)
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Point Subtraction                                **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Point2D_Subtract()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Point2D_Subtract" 
      ((p1 (:pointer :tq3point2d)) (p2 (:pointer :tq3point2d)) (result (:pointer :tq3vector2d))) 
  (:pointer :tq3vector2d)
   () )

; 
;  *  Q3Param2D_Subtract()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Param2D_Subtract" 
      ((p1 (:pointer :tq3param2d)) (p2 (:pointer :tq3param2d)) (result (:pointer :tq3vector2d))) 
  (:pointer :tq3vector2d)
   () )

; 
;  *  Q3Point3D_Subtract()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Point3D_Subtract" 
      ((p1 (:pointer :tq3point3d)) (p2 (:pointer :tq3point3d)) (result (:pointer :tq3vector3d))) 
  (:pointer :tq3vector3d)
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Point Distance                                   **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Point2D_Distance()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Point2D_Distance" 
      ((p1 (:pointer :tq3point2d)) (p2 (:pointer :tq3point2d))) 
  :single-float
   () )

; 
;  *  Q3Point2D_DistanceSquared()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Point2D_DistanceSquared" 
      ((p1 (:pointer :tq3point2d)) (p2 (:pointer :tq3point2d))) 
  :single-float
   () )

; 
;  *  Q3Param2D_Distance()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Param2D_Distance" 
      ((p1 (:pointer :tq3param2d)) (p2 (:pointer :tq3param2d))) 
  :single-float
   () )

; 
;  *  Q3Param2D_DistanceSquared()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Param2D_DistanceSquared" 
      ((p1 (:pointer :tq3param2d)) (p2 (:pointer :tq3param2d))) 
  :single-float
   () )

; 
;  *  Q3RationalPoint3D_Distance()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3RationalPoint3D_Distance" 
      ((p1 (:pointer :tq3rationalpoint3d)) (p2 (:pointer :tq3rationalpoint3d))) 
  :single-float
   () )

; 
;  *  Q3RationalPoint3D_DistanceSquared()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3RationalPoint3D_DistanceSquared" 
      ((p1 (:pointer :tq3rationalpoint3d)) (p2 (:pointer :tq3rationalpoint3d))) 
  :single-float
   () )

; 
;  *  Q3Point3D_Distance()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Point3D_Distance" 
      ((p1 (:pointer :tq3point3d)) (p2 (:pointer :tq3point3d))) 
  :single-float
   () )

; 
;  *  Q3Point3D_DistanceSquared()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Point3D_DistanceSquared" 
      ((p1 (:pointer :tq3point3d)) (p2 (:pointer :tq3point3d))) 
  :single-float
   () )

; 
;  *  Q3RationalPoint4D_Distance()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3RationalPoint4D_Distance" 
      ((p1 (:pointer :tq3rationalpoint4d)) (p2 (:pointer :tq3rationalpoint4d))) 
  :single-float
   () )

; 
;  *  Q3RationalPoint4D_DistanceSquared()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3RationalPoint4D_DistanceSquared" 
      ((p1 (:pointer :tq3rationalpoint4d)) (p2 (:pointer :tq3rationalpoint4d))) 
  :single-float
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Point Relative Ratio                             **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Point2D_RRatio()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Point2D_RRatio" 
      ((p1 (:pointer :tq3point2d)) (p2 (:pointer :tq3point2d)) (r1 :single-float) (r2 :single-float) (result (:pointer :tq3point2d))) 
  (:pointer :tq3point2d)
   () )

; 
;  *  Q3Param2D_RRatio()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Param2D_RRatio" 
      ((p1 (:pointer :tq3param2d)) (p2 (:pointer :tq3param2d)) (r1 :single-float) (r2 :single-float) (result (:pointer :tq3param2d))) 
  (:pointer :tq3param2d)
   () )

; 
;  *  Q3Point3D_RRatio()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Point3D_RRatio" 
      ((p1 (:pointer :tq3point3d)) (p2 (:pointer :tq3point3d)) (r1 :single-float) (r2 :single-float) (result (:pointer :tq3point3d))) 
  (:pointer :tq3point3d)
   () )

; 
;  *  Q3RationalPoint4D_RRatio()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3RationalPoint4D_RRatio" 
      ((p1 (:pointer :tq3rationalpoint4d)) (p2 (:pointer :tq3rationalpoint4d)) (r1 :single-float) (r2 :single-float) (result (:pointer :tq3rationalpoint4d))) 
  (:pointer :tq3rationalpoint4d)
   () )

; *****************************************************************************
;  **                                                                          **
;  **                 Point / Vector Addition & Subtraction                    **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Point2D_Vector2D_Add()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Point2D_Vector2D_Add" 
      ((point2D (:pointer :tq3point2d)) (vector2D (:pointer :tq3vector2d)) (result (:pointer :tq3point2d))) 
  (:pointer :tq3point2d)
   () )

; 
;  *  Q3Param2D_Vector2D_Add()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Param2D_Vector2D_Add" 
      ((param2D (:pointer :tq3param2d)) (vector2D (:pointer :tq3vector2d)) (result (:pointer :tq3param2d))) 
  (:pointer :tq3param2d)
   () )

; 
;  *  Q3Point3D_Vector3D_Add()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Point3D_Vector3D_Add" 
      ((point3D (:pointer :tq3point3d)) (vector3D (:pointer :tq3vector3d)) (result (:pointer :tq3point3d))) 
  (:pointer :tq3point3d)
   () )

; 
;  *  Q3Point2D_Vector2D_Subtract()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Point2D_Vector2D_Subtract" 
      ((point2D (:pointer :tq3point2d)) (vector2D (:pointer :tq3vector2d)) (result (:pointer :tq3point2d))) 
  (:pointer :tq3point2d)
   () )

; 
;  *  Q3Param2D_Vector2D_Subtract()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Param2D_Vector2D_Subtract" 
      ((param2D (:pointer :tq3param2d)) (vector2D (:pointer :tq3vector2d)) (result (:pointer :tq3param2d))) 
  (:pointer :tq3param2d)
   () )

; 
;  *  Q3Point3D_Vector3D_Subtract()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Point3D_Vector3D_Subtract" 
      ((point3D (:pointer :tq3point3d)) (vector3D (:pointer :tq3vector3d)) (result (:pointer :tq3point3d))) 
  (:pointer :tq3point3d)
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Vector Scale                                 **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Vector2D_Scale()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Vector2D_Scale" 
      ((vector2D (:pointer :tq3vector2d)) (scalar :single-float) (result (:pointer :tq3vector2d))) 
  (:pointer :tq3vector2d)
   () )

; 
;  *  Q3Vector3D_Scale()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Vector3D_Scale" 
      ((vector3D (:pointer :tq3vector3d)) (scalar :single-float) (result (:pointer :tq3vector3d))) 
  (:pointer :tq3vector3d)
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Vector Length                                **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Vector2D_Length()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Vector2D_Length" 
      ((vector2D (:pointer :tq3vector2d))) 
  :single-float
   () )

; 
;  *  Q3Vector3D_Length()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Vector3D_Length" 
      ((vector3D (:pointer :tq3vector3d))) 
  :single-float
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Vector Normalize                             **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Vector2D_Normalize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Vector2D_Normalize" 
      ((vector2D (:pointer :tq3vector2d)) (result (:pointer :tq3vector2d))) 
  (:pointer :tq3vector2d)
   () )

; 
;  *  Q3Vector3D_Normalize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Vector3D_Normalize" 
      ((vector3D (:pointer :tq3vector3d)) (result (:pointer :tq3vector3d))) 
  (:pointer :tq3vector3d)
   () )

; *****************************************************************************
;  **                                                                          **
;  **                 Vector/Vector Addition and Subtraction                   **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Vector2D_Add()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Vector2D_Add" 
      ((v1 (:pointer :tq3vector2d)) (v2 (:pointer :tq3vector2d)) (result (:pointer :tq3vector2d))) 
  (:pointer :tq3vector2d)
   () )

; 
;  *  Q3Vector3D_Add()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Vector3D_Add" 
      ((v1 (:pointer :tq3vector3d)) (v2 (:pointer :tq3vector3d)) (result (:pointer :tq3vector3d))) 
  (:pointer :tq3vector3d)
   () )

; 
;  *  Q3Vector2D_Subtract()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Vector2D_Subtract" 
      ((v1 (:pointer :tq3vector2d)) (v2 (:pointer :tq3vector2d)) (result (:pointer :tq3vector2d))) 
  (:pointer :tq3vector2d)
   () )

; 
;  *  Q3Vector3D_Subtract()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Vector3D_Subtract" 
      ((v1 (:pointer :tq3vector3d)) (v2 (:pointer :tq3vector3d)) (result (:pointer :tq3vector3d))) 
  (:pointer :tq3vector3d)
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Cross Product                                **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Vector2D_Cross()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Vector2D_Cross" 
      ((v1 (:pointer :tq3vector2d)) (v2 (:pointer :tq3vector2d))) 
  :single-float
   () )

; 
;  *  Q3Vector3D_Cross()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Vector3D_Cross" 
      ((v1 (:pointer :tq3vector3d)) (v2 (:pointer :tq3vector3d)) (result (:pointer :tq3vector3d))) 
  (:pointer :tq3vector3d)
   () )

; 
;  *  Q3Point3D_CrossProductTri()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST; CONST
(deftrap-inline "_Q3Point3D_CrossProductTri" 
      ((point1 (:pointer :tq3point3d)) (point2 (:pointer :tq3point3d)) (point3 (:pointer :tq3point3d)) (crossVector (:pointer :tq3vector3d))) 
  (:pointer :tq3vector3d)
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Dot Product                                  **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Vector2D_Dot()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Vector2D_Dot" 
      ((v1 (:pointer :tq3vector2d)) (v2 (:pointer :tq3vector2d))) 
  :single-float
   () )

; 
;  *  Q3Vector3D_Dot()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Vector3D_Dot" 
      ((v1 (:pointer :tq3vector3d)) (v2 (:pointer :tq3vector3d))) 
  :single-float
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Point and Vector Transformation                      **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Vector2D_Transform()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Vector2D_Transform" 
      ((vector2D (:pointer :tq3vector2d)) (matrix3x3 (:pointer :tq3matrix3x3)) (result (:pointer :tq3vector2d))) 
  (:pointer :tq3vector2d)
   () )

; 
;  *  Q3Vector3D_Transform()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Vector3D_Transform" 
      ((vector3D (:pointer :tq3vector3d)) (matrix4x4 (:pointer :tq3matrix4x4)) (result (:pointer :tq3vector3d))) 
  (:pointer :tq3vector3d)
   () )

; 
;  *  Q3Point2D_Transform()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Point2D_Transform" 
      ((point2D (:pointer :tq3point2d)) (matrix3x3 (:pointer :tq3matrix3x3)) (result (:pointer :tq3point2d))) 
  (:pointer :tq3point2d)
   () )

; 
;  *  Q3Param2D_Transform()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Param2D_Transform" 
      ((param2D (:pointer :tq3param2d)) (matrix3x3 (:pointer :tq3matrix3x3)) (result (:pointer :tq3param2d))) 
  (:pointer :tq3param2d)
   () )

; 
;  *  Q3Point3D_Transform()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Point3D_Transform" 
      ((point3D (:pointer :tq3point3d)) (matrix4x4 (:pointer :tq3matrix4x4)) (result (:pointer :tq3point3d))) 
  (:pointer :tq3point3d)
   () )

; 
;  *  Q3RationalPoint4D_Transform()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3RationalPoint4D_Transform" 
      ((point4D (:pointer :tq3rationalpoint4d)) (matrix4x4 (:pointer :tq3matrix4x4)) (result (:pointer :tq3rationalpoint4d))) 
  (:pointer :tq3rationalpoint4d)
   () )

; 
;  *  Q3Point3D_To3DTransformArray()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Point3D_To3DTransformArray" 
      ((inPoint3D (:pointer :tq3point3d)) (matrix (:pointer :tq3matrix4x4)) (outPoint3D (:pointer :tq3point3d)) (numPoints :signed-long) (inStructSize :unsigned-long) (outStructSize :unsigned-long)) 
  :tq3status
   () )

; 
;  *  Q3Point3D_To4DTransformArray()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Point3D_To4DTransformArray" 
      ((inPoint3D (:pointer :tq3point3d)) (matrix (:pointer :tq3matrix4x4)) (outPoint4D (:pointer :tq3rationalpoint4d)) (numPoints :signed-long) (inStructSize :unsigned-long) (outStructSize :unsigned-long)) 
  :tq3status
   () )

; 
;  *  Q3RationalPoint4D_To4DTransformArray()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3RationalPoint4D_To4DTransformArray" 
      ((inPoint4D (:pointer :tq3rationalpoint4d)) (matrix (:pointer :tq3matrix4x4)) (outPoint4D (:pointer :tq3rationalpoint4d)) (numPoints :signed-long) (inStructSize :unsigned-long) (outStructSize :unsigned-long)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Vector Negation                              **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Vector2D_Negate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Vector2D_Negate" 
      ((vector2D (:pointer :tq3vector2d)) (result (:pointer :tq3vector2d))) 
  (:pointer :tq3vector2d)
   () )

; 
;  *  Q3Vector3D_Negate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Vector3D_Negate" 
      ((vector3D (:pointer :tq3vector3d)) (result (:pointer :tq3vector3d))) 
  (:pointer :tq3vector3d)
   () )

; *****************************************************************************
;  **                                                                          **
;  **                 Point conversion from cartesian to polar                 **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Point2D_ToPolar()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Point2D_ToPolar" 
      ((point2D (:pointer :tq3point2d)) (result (:pointer :tq3polarpoint))) 
  (:pointer :tq3polarpoint)
   () )

; 
;  *  Q3PolarPoint_ToPoint2D()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3PolarPoint_ToPoint2D" 
      ((polarPoint (:pointer :tq3polarpoint)) (result (:pointer :tq3point2d))) 
  (:pointer :tq3point2d)
   () )

; 
;  *  Q3Point3D_ToSpherical()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Point3D_ToSpherical" 
      ((point3D (:pointer :tq3point3d)) (result (:pointer :tq3sphericalpoint))) 
  (:pointer :tq3sphericalpoint)
   () )

; 
;  *  Q3SphericalPoint_ToPoint3D()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3SphericalPoint_ToPoint3D" 
      ((sphericalPoint (:pointer :tq3sphericalpoint)) (result (:pointer :tq3point3d))) 
  (:pointer :tq3point3d)
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Point Affine Combinations                        **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Point2D_AffineComb()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Point2D_AffineComb" 
      ((points2D (:pointer :tq3point2d)) (weights (:pointer :single-float)) (nPoints :unsigned-long) (result (:pointer :tq3point2d))) 
  (:pointer :tq3point2d)
   () )

; 
;  *  Q3Param2D_AffineComb()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Param2D_AffineComb" 
      ((params2D (:pointer :tq3param2d)) (weights (:pointer :single-float)) (nPoints :unsigned-long) (result (:pointer :tq3param2d))) 
  (:pointer :tq3param2d)
   () )

; 
;  *  Q3RationalPoint3D_AffineComb()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3RationalPoint3D_AffineComb" 
      ((points3D (:pointer :tq3rationalpoint3d)) (weights (:pointer :single-float)) (numPoints :unsigned-long) (result (:pointer :tq3rationalpoint3d))) 
  (:pointer :tq3rationalpoint3d)
   () )

; 
;  *  Q3Point3D_AffineComb()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Point3D_AffineComb" 
      ((points3D (:pointer :tq3point3d)) (weights (:pointer :single-float)) (numPoints :unsigned-long) (result (:pointer :tq3point3d))) 
  (:pointer :tq3point3d)
   () )

; 
;  *  Q3RationalPoint4D_AffineComb()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3RationalPoint4D_AffineComb" 
      ((points4D (:pointer :tq3rationalpoint4d)) (weights (:pointer :single-float)) (numPoints :unsigned-long) (result (:pointer :tq3rationalpoint4d))) 
  (:pointer :tq3rationalpoint4d)
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Matrix Functions                             **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Matrix3x3_Copy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Matrix3x3_Copy" 
      ((matrix3x3 (:pointer :tq3matrix3x3)) (result (:pointer :tq3matrix3x3))) 
  (:pointer :tq3matrix3x3)
   () )

; 
;  *  Q3Matrix4x4_Copy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Matrix4x4_Copy" 
      ((matrix4x4 (:pointer :tq3matrix4x4)) (result (:pointer :tq3matrix4x4))) 
  (:pointer :tq3matrix4x4)
   () )

; 
;  *  Q3Matrix3x3_SetIdentity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Matrix3x3_SetIdentity" 
      ((matrix3x3 (:pointer :tq3matrix3x3))) 
  (:pointer :tq3matrix3x3)
   () )

; 
;  *  Q3Matrix4x4_SetIdentity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Matrix4x4_SetIdentity" 
      ((matrix4x4 (:pointer :tq3matrix4x4))) 
  (:pointer :tq3matrix4x4)
   () )

; 
;  *  Q3Matrix3x3_Transpose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Matrix3x3_Transpose" 
      ((matrix3x3 (:pointer :tq3matrix3x3)) (result (:pointer :tq3matrix3x3))) 
  (:pointer :tq3matrix3x3)
   () )

; 
;  *  Q3Matrix4x4_Transpose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Matrix4x4_Transpose" 
      ((matrix4x4 (:pointer :tq3matrix4x4)) (result (:pointer :tq3matrix4x4))) 
  (:pointer :tq3matrix4x4)
   () )

; 
;  *  Q3Matrix3x3_Invert()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Matrix3x3_Invert" 
      ((matrix3x3 (:pointer :tq3matrix3x3)) (result (:pointer :tq3matrix3x3))) 
  (:pointer :tq3matrix3x3)
   () )

; 
;  *  Q3Matrix4x4_Invert()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Matrix4x4_Invert" 
      ((matrix4x4 (:pointer :tq3matrix4x4)) (result (:pointer :tq3matrix4x4))) 
  (:pointer :tq3matrix4x4)
   () )

; 
;  *  Q3Matrix3x3_Adjoint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Matrix3x3_Adjoint" 
      ((matrix3x3 (:pointer :tq3matrix3x3)) (result (:pointer :tq3matrix3x3))) 
  (:pointer :tq3matrix3x3)
   () )

; 
;  *  Q3Matrix3x3_Multiply()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Matrix3x3_Multiply" 
      ((matrixA (:pointer :tq3matrix3x3)) (matrixB (:pointer :tq3matrix3x3)) (result (:pointer :tq3matrix3x3))) 
  (:pointer :tq3matrix3x3)
   () )

; 
;  *  Q3Matrix4x4_Multiply()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Matrix4x4_Multiply" 
      ((matrixA (:pointer :tq3matrix4x4)) (matrixB (:pointer :tq3matrix4x4)) (result (:pointer :tq3matrix4x4))) 
  (:pointer :tq3matrix4x4)
   () )

; 
;  *  Q3Matrix3x3_SetTranslate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Matrix3x3_SetTranslate" 
      ((matrix3x3 (:pointer :tq3matrix3x3)) (xTrans :single-float) (yTrans :single-float)) 
  (:pointer :tq3matrix3x3)
   () )

; 
;  *  Q3Matrix3x3_SetScale()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Matrix3x3_SetScale" 
      ((matrix3x3 (:pointer :tq3matrix3x3)) (xScale :single-float) (yScale :single-float)) 
  (:pointer :tq3matrix3x3)
   () )

; 
;  *  Q3Matrix3x3_SetRotateAboutPoint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Matrix3x3_SetRotateAboutPoint" 
      ((matrix3x3 (:pointer :tq3matrix3x3)) (origin (:pointer :tq3point2d)) (angle :single-float)) 
  (:pointer :tq3matrix3x3)
   () )

; 
;  *  Q3Matrix4x4_SetTranslate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Matrix4x4_SetTranslate" 
      ((matrix4x4 (:pointer :tq3matrix4x4)) (xTrans :single-float) (yTrans :single-float) (zTrans :single-float)) 
  (:pointer :tq3matrix4x4)
   () )

; 
;  *  Q3Matrix4x4_SetScale()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Matrix4x4_SetScale" 
      ((matrix4x4 (:pointer :tq3matrix4x4)) (xScale :single-float) (yScale :single-float) (zScale :single-float)) 
  (:pointer :tq3matrix4x4)
   () )

; 
;  *  Q3Matrix4x4_SetRotateAboutPoint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Matrix4x4_SetRotateAboutPoint" 
      ((matrix4x4 (:pointer :tq3matrix4x4)) (origin (:pointer :tq3point3d)) (xAngle :single-float) (yAngle :single-float) (zAngle :single-float)) 
  (:pointer :tq3matrix4x4)
   () )

; 
;  *  Q3Matrix4x4_SetRotateAboutAxis()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Matrix4x4_SetRotateAboutAxis" 
      ((matrix4x4 (:pointer :tq3matrix4x4)) (origin (:pointer :tq3point3d)) (orientation (:pointer :tq3vector3d)) (angle :single-float)) 
  (:pointer :tq3matrix4x4)
   () )

; 
;  *  Q3Matrix4x4_SetRotate_X()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Matrix4x4_SetRotate_X" 
      ((matrix4x4 (:pointer :tq3matrix4x4)) (angle :single-float)) 
  (:pointer :tq3matrix4x4)
   () )

; 
;  *  Q3Matrix4x4_SetRotate_Y()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Matrix4x4_SetRotate_Y" 
      ((matrix4x4 (:pointer :tq3matrix4x4)) (angle :single-float)) 
  (:pointer :tq3matrix4x4)
   () )

; 
;  *  Q3Matrix4x4_SetRotate_Z()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Matrix4x4_SetRotate_Z" 
      ((matrix4x4 (:pointer :tq3matrix4x4)) (angle :single-float)) 
  (:pointer :tq3matrix4x4)
   () )

; 
;  *  Q3Matrix4x4_SetRotate_XYZ()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Matrix4x4_SetRotate_XYZ" 
      ((matrix4x4 (:pointer :tq3matrix4x4)) (xAngle :single-float) (yAngle :single-float) (zAngle :single-float)) 
  (:pointer :tq3matrix4x4)
   () )

; 
;  *  Q3Matrix4x4_SetRotateVectorToVector()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Matrix4x4_SetRotateVectorToVector" 
      ((matrix4x4 (:pointer :tq3matrix4x4)) (v1 (:pointer :tq3vector3d)) (v2 (:pointer :tq3vector3d))) 
  (:pointer :tq3matrix4x4)
   () )

; 
;  *  Q3Matrix4x4_SetQuaternion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Matrix4x4_SetQuaternion" 
      ((matrix (:pointer :tq3matrix4x4)) (quaternion (:pointer :tq3quaternion))) 
  (:pointer :tq3matrix4x4)
   () )

; 
;  *  Q3Matrix3x3_Determinant()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Matrix3x3_Determinant" 
      ((matrix3x3 (:pointer :tq3matrix3x3))) 
  :single-float
   () )

; 
;  *  Q3Matrix4x4_Determinant()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Matrix4x4_Determinant" 
      ((matrix4x4 (:pointer :tq3matrix4x4))) 
  :single-float
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Quaternion Routines                          **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Quaternion_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Quaternion_Set" 
      ((quaternion (:pointer :tq3quaternion)) (w :single-float) (x :single-float) (y :single-float) (z :single-float)) 
  (:pointer :tq3quaternion)
   () )

; 
;  *  Q3Quaternion_SetIdentity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Quaternion_SetIdentity" 
      ((quaternion (:pointer :tq3quaternion))) 
  (:pointer :tq3quaternion)
   () )

; 
;  *  Q3Quaternion_Copy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Quaternion_Copy" 
      ((quaternion (:pointer :tq3quaternion)) (result (:pointer :tq3quaternion))) 
  (:pointer :tq3quaternion)
   () )

; 
;  *  Q3Quaternion_IsIdentity()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Quaternion_IsIdentity" 
      ((quaternion (:pointer :tq3quaternion))) 
  :tq3boolean
   () )

; 
;  *  Q3Quaternion_Invert()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Quaternion_Invert" 
      ((quaternion (:pointer :tq3quaternion)) (result (:pointer :tq3quaternion))) 
  (:pointer :tq3quaternion)
   () )

; 
;  *  Q3Quaternion_Normalize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Quaternion_Normalize" 
      ((quaternion (:pointer :tq3quaternion)) (result (:pointer :tq3quaternion))) 
  (:pointer :tq3quaternion)
   () )

; 
;  *  Q3Quaternion_Dot()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Quaternion_Dot" 
      ((q1 (:pointer :tq3quaternion)) (q2 (:pointer :tq3quaternion))) 
  :single-float
   () )

; 
;  *  Q3Quaternion_Multiply()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Quaternion_Multiply" 
      ((q1 (:pointer :tq3quaternion)) (q2 (:pointer :tq3quaternion)) (result (:pointer :tq3quaternion))) 
  (:pointer :tq3quaternion)
   () )

; 
;  *  Q3Quaternion_SetRotateAboutAxis()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Quaternion_SetRotateAboutAxis" 
      ((quaternion (:pointer :tq3quaternion)) (axis (:pointer :tq3vector3d)) (angle :single-float)) 
  (:pointer :tq3quaternion)
   () )

; 
;  *  Q3Quaternion_SetRotate_XYZ()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Quaternion_SetRotate_XYZ" 
      ((quaternion (:pointer :tq3quaternion)) (xAngle :single-float) (yAngle :single-float) (zAngle :single-float)) 
  (:pointer :tq3quaternion)
   () )

; 
;  *  Q3Quaternion_SetRotate_X()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Quaternion_SetRotate_X" 
      ((quaternion (:pointer :tq3quaternion)) (angle :single-float)) 
  (:pointer :tq3quaternion)
   () )

; 
;  *  Q3Quaternion_SetRotate_Y()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Quaternion_SetRotate_Y" 
      ((quaternion (:pointer :tq3quaternion)) (angle :single-float)) 
  (:pointer :tq3quaternion)
   () )

; 
;  *  Q3Quaternion_SetRotate_Z()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Quaternion_SetRotate_Z" 
      ((quaternion (:pointer :tq3quaternion)) (angle :single-float)) 
  (:pointer :tq3quaternion)
   () )

; 
;  *  Q3Quaternion_SetMatrix()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Quaternion_SetMatrix" 
      ((quaternion (:pointer :tq3quaternion)) (matrix (:pointer :tq3matrix4x4))) 
  (:pointer :tq3quaternion)
   () )

; 
;  *  Q3Quaternion_SetRotateVectorToVector()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Quaternion_SetRotateVectorToVector" 
      ((quaternion (:pointer :tq3quaternion)) (v1 (:pointer :tq3vector3d)) (v2 (:pointer :tq3vector3d))) 
  (:pointer :tq3quaternion)
   () )

; 
;  *  Q3Quaternion_MatchReflection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Quaternion_MatchReflection" 
      ((q1 (:pointer :tq3quaternion)) (q2 (:pointer :tq3quaternion)) (result (:pointer :tq3quaternion))) 
  (:pointer :tq3quaternion)
   () )

; 
;  *  Q3Quaternion_InterpolateFast()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Quaternion_InterpolateFast" 
      ((q1 (:pointer :tq3quaternion)) (q2 (:pointer :tq3quaternion)) (t :single-float) (result (:pointer :tq3quaternion))) 
  (:pointer :tq3quaternion)
   () )

; 
;  *  Q3Quaternion_InterpolateLinear()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Quaternion_InterpolateLinear" 
      ((q1 (:pointer :tq3quaternion)) (q2 (:pointer :tq3quaternion)) (t :single-float) (result (:pointer :tq3quaternion))) 
  (:pointer :tq3quaternion)
   () )

; 
;  *  Q3Vector3D_TransformQuaternion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Vector3D_TransformQuaternion" 
      ((vector3D (:pointer :tq3vector3d)) (quaternion (:pointer :tq3quaternion)) (result (:pointer :tq3vector3d))) 
  (:pointer :tq3vector3d)
   () )

; 
;  *  Q3Point3D_TransformQuaternion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3Point3D_TransformQuaternion" 
      ((point3D (:pointer :tq3point3d)) (quaternion (:pointer :tq3quaternion)) (result (:pointer :tq3point3d))) 
  (:pointer :tq3point3d)
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Volume Routines                              **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3BoundingBox_Copy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3BoundingBox_Copy" 
      ((src (:pointer :tq3boundingbox)) (dest (:pointer :tq3boundingbox))) 
  (:pointer :tq3boundingbox)
   () )

; 
;  *  Q3BoundingBox_Union()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3BoundingBox_Union" 
      ((v1 (:pointer :tq3boundingbox)) (v2 (:pointer :tq3boundingbox)) (result (:pointer :tq3boundingbox))) 
  (:pointer :tq3boundingbox)
   () )

; 
;  *  Q3BoundingBox_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3BoundingBox_Set" 
      ((bBox (:pointer :tq3boundingbox)) (min (:pointer :tq3point3d)) (max (:pointer :tq3point3d)) (isEmpty :signed-long)) 
  (:pointer :tq3boundingbox)
   () )

; 
;  *  Q3BoundingBox_UnionPoint3D()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3BoundingBox_UnionPoint3D" 
      ((bBox (:pointer :tq3boundingbox)) (point3D (:pointer :tq3point3d)) (result (:pointer :tq3boundingbox))) 
  (:pointer :tq3boundingbox)
   () )

; 
;  *  Q3BoundingBox_UnionRationalPoint4D()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3BoundingBox_UnionRationalPoint4D" 
      ((bBox (:pointer :tq3boundingbox)) (point4D (:pointer :tq3rationalpoint4d)) (result (:pointer :tq3boundingbox))) 
  (:pointer :tq3boundingbox)
   () )

; 
;  *  Q3BoundingBox_SetFromPoints3D()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3BoundingBox_SetFromPoints3D" 
      ((bBox (:pointer :tq3boundingbox)) (points3D (:pointer :tq3point3d)) (numPoints :unsigned-long) (structSize :unsigned-long)) 
  (:pointer :tq3boundingbox)
   () )

; 
;  *  Q3BoundingBox_SetFromRationalPoints4D()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3BoundingBox_SetFromRationalPoints4D" 
      ((bBox (:pointer :tq3boundingbox)) (points4D (:pointer :tq3rationalpoint4d)) (numPoints :unsigned-long) (structSize :unsigned-long)) 
  (:pointer :tq3boundingbox)
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Sphere Routines                              **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3BoundingSphere_Copy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3BoundingSphere_Copy" 
      ((src (:pointer :tq3boundingsphere)) (dest (:pointer :tq3boundingsphere))) 
  (:pointer :tq3boundingsphere)
   () )

; 
;  *  Q3BoundingSphere_Union()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3BoundingSphere_Union" 
      ((s1 (:pointer :tq3boundingsphere)) (s2 (:pointer :tq3boundingsphere)) (result (:pointer :tq3boundingsphere))) 
  (:pointer :tq3boundingsphere)
   () )

; 
;  *  Q3BoundingSphere_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3BoundingSphere_Set" 
      ((bSphere (:pointer :tq3boundingsphere)) (origin (:pointer :tq3point3d)) (radius :single-float) (isEmpty :signed-long)) 
  (:pointer :tq3boundingsphere)
   () )

; 
;  *  Q3BoundingSphere_UnionPoint3D()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3BoundingSphere_UnionPoint3D" 
      ((bSphere (:pointer :tq3boundingsphere)) (point3D (:pointer :tq3point3d)) (result (:pointer :tq3boundingsphere))) 
  (:pointer :tq3boundingsphere)
   () )

; 
;  *  Q3BoundingSphere_UnionRationalPoint4D()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3BoundingSphere_UnionRationalPoint4D" 
      ((bSphere (:pointer :tq3boundingsphere)) (point4D (:pointer :tq3rationalpoint4d)) (result (:pointer :tq3boundingsphere))) 
  (:pointer :tq3boundingsphere)
   () )

; 
;  *  Q3BoundingSphere_SetFromPoints3D()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3BoundingSphere_SetFromPoints3D" 
      ((bSphere (:pointer :tq3boundingsphere)) (points3D (:pointer :tq3point3d)) (numPoints :unsigned-long) (structSize :unsigned-long)) 
  (:pointer :tq3boundingsphere)
   () )

; 
;  *  Q3BoundingSphere_SetFromRationalPoints4D()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3BoundingSphere_SetFromRationalPoints4D" 
      ((bSphere (:pointer :tq3boundingsphere)) (points4D (:pointer :tq3rationalpoint4d)) (numPoints :unsigned-long) (structSize :unsigned-long)) 
  (:pointer :tq3boundingsphere)
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QD3DMathIncludes

; $ENDC                                         ; __QD3DMATH__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'QD3DMath)