(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QD3DPick.p"
; at Wednesday May 1,2002 2:42:35 pm.
; 
;      File:       QD3DPick.p
;  
;      Contains:   Q3Pick methods
;  
;      Version:    Technology: Quickdraw 3D 1.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __QD3DPICK__
; $SETC __QD3DPICK__ := 1

; $I+
; $SETC QD3DPickIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __QD3D__
|#

(require-interface 'QD3D)
#|                                              ; $I QD3D.p
 |#                                             ; $ENDC

#|                                              ; $IFC UNDEFINED __QD3DSTYLE__
|#

(require-interface 'QD3DStyle)
#|                                              ; $I QD3DStyle.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QD3DGEOMETRY__
|#

(require-interface 'QD3DGeometry)
#|                                              ; $I QD3DGeometry.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

; ****************************************************************************
;  **                                                                         **
;  **                         Mask bits for hit information                   **
;  **                                                                         **
;  ****************************************************************************

(def-mactype :tq3pickdetailmasks (find-mactype ':signed-long))

(defconstant $kQ3PickDetailNone 0)
(defconstant $kQ3PickDetailMaskPickID #x1)
(defconstant $kQ3PickDetailMaskPath #x2)
(defconstant $kQ3PickDetailMaskObject #x4)
(defconstant $kQ3PickDetailMaskLocalToWorldMatrix #x8)
(defconstant $kQ3PickDetailMaskXYZ #x10)
(defconstant $kQ3PickDetailMaskDistance #x20)
(defconstant $kQ3PickDetailMaskNormal #x40)
(defconstant $kQ3PickDetailMaskShapePart #x80)
(defconstant $kQ3PickDetailMaskPickPart #x100)
(defconstant $kQ3PickDetailMaskUV #x200)

(def-mactype :tq3pickdetail (find-mactype ':unsigned-long))
; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             Hitlist sorting                              **
; 	 **                                                                          **
; 	 ****************************************************************************	
(def-mactype :tq3picksort (find-mactype ':signed-long))

(defconstant $kQ3PickSortNone 0)
(defconstant $kQ3PickSortNearToFar 1)
(defconstant $kQ3PickSortFarToNear 2)

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                 Data structures to set up the pick object                **
; 	 **                                                                          **
; 	 ****************************************************************************	

(def-mactype :tq3pickdataptr (find-mactype '(:pointer :tq3pickdata)))
(defrecord TQ3PickData 
   (sort :signed-long)
   (mask :unsigned-long)
   (numHitsToReturn :unsigned-long)
   )

(def-mactype :tq3windowpointpickdataptr (find-mactype '(:pointer :tq3windowpointpickdata)))
(defrecord TQ3WindowPointPickData 
   (data :tq3pickdata)
   (point :tq3point2d)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (vertexTolerance :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (edgeTolerance :single-float)
   )

(def-mactype :tq3windowrectpickdataptr (find-mactype '(:pointer :tq3windowrectpickdata)))
(defrecord TQ3WindowRectPickData 
   (data :tq3pickdata)
   (rect :tq3area)
   )

(def-mactype :tq3worldraypickdataptr (find-mactype '(:pointer :tq3worldraypickdata)))
(defrecord TQ3WorldRayPickData 
   (data :tq3pickdata)
   (ray :tq3ray3d)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (vertexTolerance :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (edgeTolerance :single-float)
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                                 Hit data                                 **
; 	 **                                                                          **
; 	 ****************************************************************************	
(def-mactype :tq3hitpathptr (find-mactype '(:pointer :tq3hitpath)))
(defrecord TQ3HitPath 
   (rootGroup :pointer)
   (depth :unsigned-long)
   (positions (:pointer :pointer))
   )

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             Pick class methods                           **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Pick_GetType()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3Pick_GetType" 
      ((pick :pointer)) 
  :tq3objecttype
   () )

; 
;  *  Q3Pick_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Pick_GetData" 
      ((pick :pointer) (data (:pointer :tq3pickdata))) 
  :tq3status
   () )

; 
;  *  Q3Pick_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Pick_SetData" 
      ((pick :pointer) (data (:pointer :tq3pickdata))) 
  :tq3status
   () )

; 
;  *  Q3Pick_GetVertexTolerance()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Pick_GetVertexTolerance" 
      ((pick :pointer) (vertexTolerance (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3Pick_GetEdgeTolerance()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Pick_GetEdgeTolerance" 
      ((pick :pointer) (edgeTolerance (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3Pick_SetVertexTolerance()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Pick_SetVertexTolerance" 
      ((pick :pointer) (vertexTolerance :single-float)) 
  :tq3status
   () )

; 
;  *  Q3Pick_SetEdgeTolerance()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Pick_SetEdgeTolerance" 
      ((pick :pointer) (edgeTolerance :single-float)) 
  :tq3status
   () )

; 
;  *  Q3Pick_GetNumHits()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Pick_GetNumHits" 
      ((pick :pointer) (numHits (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Pick_EmptyHitList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Pick_EmptyHitList" 
      ((pick :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Pick_GetPickDetailValidMask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Pick_GetPickDetailValidMask" 
      ((pick :pointer) (index :unsigned-long) (pickDetailValidMask (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Pick_GetPickDetailData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Pick_GetPickDetailData" 
      ((pick :pointer) (index :unsigned-long) (pickDetailValue :unsigned-long) (detailData :pointer)) 
  :tq3status
   () )

; 
;  *  Q3HitPath_EmptyData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3HitPath_EmptyData" 
      ((hitPath (:pointer :tq3hitpath))) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; *****************************************************************************
;  **                                                                          **
;  **                         Window point pick methods                        **
;  **                                                                          **
;  ****************************************************************************
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Q3WindowPointPick_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3WindowPointPick_New" 
      ((data (:pointer :tq3windowpointpickdata))) 
  :pointer
   () )

; 
;  *  Q3WindowPointPick_GetPoint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WindowPointPick_GetPoint" 
      ((pick :pointer) (point (:pointer :tq3point2d))) 
  :tq3status
   () )

; 
;  *  Q3WindowPointPick_SetPoint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3WindowPointPick_SetPoint" 
      ((pick :pointer) (point (:pointer :tq3point2d))) 
  :tq3status
   () )

; 
;  *  Q3WindowPointPick_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WindowPointPick_GetData" 
      ((pick :pointer) (data (:pointer :tq3windowpointpickdata))) 
  :tq3status
   () )

; 
;  *  Q3WindowPointPick_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3WindowPointPick_SetData" 
      ((pick :pointer) (data (:pointer :tq3windowpointpickdata))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Window rect pick methods                         **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3WindowRectPick_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3WindowRectPick_New" 
      ((data (:pointer :tq3windowrectpickdata))) 
  :pointer
   () )

; 
;  *  Q3WindowRectPick_GetRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WindowRectPick_GetRect" 
      ((pick :pointer) (rect (:pointer :tq3area))) 
  :tq3status
   () )

; 
;  *  Q3WindowRectPick_SetRect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3WindowRectPick_SetRect" 
      ((pick :pointer) (rect (:pointer :tq3area))) 
  :tq3status
   () )

; 
;  *  Q3WindowRectPick_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WindowRectPick_GetData" 
      ((pick :pointer) (data (:pointer :tq3windowrectpickdata))) 
  :tq3status
   () )

; 
;  *  Q3WindowRectPick_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3WindowRectPick_SetData" 
      ((pick :pointer) (data (:pointer :tq3windowrectpickdata))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         World ray pick methods                           **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3WorldRayPick_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3WorldRayPick_New" 
      ((data (:pointer :tq3worldraypickdata))) 
  :pointer
   () )

; 
;  *  Q3WorldRayPick_GetRay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WorldRayPick_GetRay" 
      ((pick :pointer) (ray (:pointer :tq3ray3d))) 
  :tq3status
   () )

; 
;  *  Q3WorldRayPick_SetRay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3WorldRayPick_SetRay" 
      ((pick :pointer) (ray (:pointer :tq3ray3d))) 
  :tq3status
   () )

; 
;  *  Q3WorldRayPick_GetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3WorldRayPick_GetData" 
      ((pick :pointer) (data (:pointer :tq3worldraypickdata))) 
  :tq3status
   () )

; 
;  *  Q3WorldRayPick_SetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3WorldRayPick_SetData" 
      ((pick :pointer) (data (:pointer :tq3worldraypickdata))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Shape Part methods                           **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3ShapePart_GetType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ShapePart_GetType" 
      ((shapePartObject :pointer)) 
  :tq3objecttype
   () )

; 
;  *  Q3MeshPart_GetType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3MeshPart_GetType" 
      ((meshPartObject :pointer)) 
  :tq3objecttype
   () )

; 
;  *  Q3ShapePart_GetShape()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ShapePart_GetShape" 
      ((shapePartObject :pointer) (shapeObject (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3MeshPart_GetComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3MeshPart_GetComponent" 
      ((meshPartObject :pointer) (component (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3MeshFacePart_GetFace()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3MeshFacePart_GetFace" 
      ((meshFacePartObject :pointer) (face (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3MeshEdgePart_GetEdge()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3MeshEdgePart_GetEdge" 
      ((meshEdgePartObject :pointer) (edge (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3MeshVertexPart_GetVertex()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3MeshVertexPart_GetVertex" 
      ((meshVertexPartObject :pointer) (vertex (:pointer :pointer))) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QD3DPickIncludes

; $ENDC                                         ; __QD3DPICK__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'QD3DPick)