(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QD3DRenderer.p"
; at Wednesday May 1,2002 2:42:36 pm.
; 
;      File:       QD3DRenderer.p
;  
;      Contains:   Q3Renderer types and routines
;  
;      Version:    Technology: Quickdraw 3D 1.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __QD3DRENDERER__
; $SETC __QD3DRENDERER__ := 1

; $I+
; $SETC QD3DRendererIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __QD3D__
|#

(require-interface 'QD3D)
#|                                              ; $I QD3D.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QD3DSET__
|#

(require-interface 'QD3DSet)
#|                                              ; $I QD3DSet.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QD3DVIEW__
|#

(require-interface 'QD3DView)
#|                                              ; $I QD3DView.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __RAVE__

(require-interface 'RAVE)                       ; $I RAVE.p
; $ENDC

; $IFC TARGET_OS_MAC 
#|                                              ; $IFC UNDEFINED __EVENTS__
|#

(require-interface 'Events)
#|                                              ; $I Events.p
 |#                                             ; $ENDC
; $ENDC                                         ; TARGET_OS_MAC

; $PUSH
; $ALIGN POWER
; $LibExport+

; *****************************************************************************
;  **                                                                          **
;  **                         User Interface Things                            **
;  **                                                                          **
;  ****************************************************************************
; $IFC TARGET_OS_MAC 
; 
;  *  A callback to an application's event handling code. This is needed to    
;  *  support movable modal dialogs. The dialog's event filter calls this      
;  *  callback with events it does not handle.                                 
;  *  If an application handles the event it should return kQ3True.            
;  *  If the application does not handle the event it must return kQ3False and 
;  *  the dialog's event filter will pass the event to the system unhandled.   
;  

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3MacOSDialogEventHandler = FUNCTION({CONST}VAR event: EventRecord): TQ3Boolean; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3macosdialogeventhandler (find-mactype ':pointer))
; $ENDC

(def-mactype :tq3dialoganchorptr (find-mactype '(:pointer :tq3dialoganchor)))
(defrecord TQ3DialogAnchor 
   (clientEventHandler :pointer)
   )

; $ENDC                                         ; TARGET_OS_MAC

#|                                              ; $IFC TARGET_OS_WIN32 

(defrecord TQ3DialogAnchor 
#|
; Warning: type-size: unknown type hwnd
|##|
; Warning: type-size: unknown type hwnd
|#
   (ownerWindow :hwnd)
   )

 |#                                             ; $ENDC; TARGET_OS_WIN32

#|                                              ; $IFC TARGET_OS_UNIX 

(def-mactype :tq3dialoganchorptr (find-mactype '(:pointer :tq3dialoganchor)))
(defrecord TQ3DialogAnchor 
   (notUsed :pointer)                           ;   place holder  
   )

 |#                                             ; $ENDC; TARGET_OS_UNIX

; *****************************************************************************
;  **                                                                          **
;  **                         Renderer Functions                               **
;  **                                                                          **
;  ****************************************************************************
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Q3Renderer_NewFromType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Renderer_NewFromType" 
      ((rendererObjectType :signed-long)) 
  :pointer
   () )

; 
;  *  Q3Renderer_GetType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Renderer_GetType" 
      ((renderer :pointer)) 
  :tq3objecttype
   () )

;  Q3Renderer_Flush has been replaced by Q3View_Flush 
;  Q3Renderer_Sync has been replaced by Q3View_Sync 
; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  Q3Renderer_IsInteractive
;  *      Determine if this renderer is intended to be used interactively.
;  
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Q3Renderer_IsInteractive()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Renderer_IsInteractive" 
      ((renderer :pointer)) 
  :tq3boolean
   () )

; 
;  *  Q3Renderer_HasModalConfigure
;  *      Determine if this renderer has a modal settings dialog.
;  *
;  *  Q3Renderer_ModalConfigure
;  *      Have the renderer pop up a modal dialog box to configure its settings.
;  *  dialogAnchor - is platform specific data passed by the client to support
;  *      movable modal dialogs. 
;  *    MacOS: this is a callback to the calling application's event handler.
;  *      The renderer calls this function with events not handled by the 
;  *      settings dialog. This is necessary in order to support movable modal 
;  *      dialogs. An application's event handler must return kQ3True if it 
;  *      handles the event passed to the callback or kQ3False if not. 
;  *      An application which doesn't want to support a movable modal configure
;  *      dialog should pass NULL for the clientEventHandler of TQ3DialogAnchor.
;  *    Win32: this is the HWND of the owning window (typically an application's
;  *      main window).
;  *  canceled - returns a boolean inditacating that the user canceled the 
;  *  dialog.
;  *      
;  
; 
;  *  Q3Renderer_HasModalConfigure()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Renderer_HasModalConfigure" 
      ((renderer :pointer)) 
  :tq3boolean
   () )

; 
;  *  Q3Renderer_ModalConfigure()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Renderer_ModalConfigure" 
      ((renderer :pointer) (dialogAnchor :tq3dialoganchor) (canceled (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3RendererClass_GetNickNameString
;  *      Allows an application to get a renderers name string, the 
;  *      renderer is responsible for storing this in a localizable format
;  *      for example as a resource.  This string can then be used to provide
;  *      a selection mechanism for an application (for example in a menu).
;  *
;  *      If this call returns nil in the supplied string, then the App may 
;  *      choose to use the class name for the renderer.  You should always 
;  *      try to get the name string before using the class name, since the
;  *      class name is not localizable.
;  
; 
;  *  Q3RendererClass_GetNickNameString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3RendererClass_GetNickNameString" 
      ((rendererClassType :signed-long) (rendererClassString (:pointer :tq3objectclassnamestring))) 
  :tq3status
   () )

; 
;  *  Q3Renderer_GetConfigurationData
;  *      Allows an application to collect private renderer configuration data
;  *      which it will then save. For example in a preference file or in a 
;  *      style template. An application should tag this data with the 
;  *      Renderer's object  name.
;  *  
;  *      if dataBuffer is NULL actualDataSize returns the required size in 
;  *      bytes of a data buffer large enough to store private data. 
;  *
;  *      bufferSize is the actual size of the memory block pointed to by 
;  *      dataBuffer
;  *
;  *      actualDataSize - on return the actual number of bytes written to the 
;  *      buffer or if dataBuffer is NULL the required size of dataBuffer
;  * 
;  
; 
;  *  Q3Renderer_GetConfigurationData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Renderer_GetConfigurationData" 
      ((renderer :pointer) (dataBuffer (:pointer :unsigned-byte)) (bufferSize :unsigned-long) (actualDataSize (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Renderer_SetConfigurationData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Renderer_SetConfigurationData" 
      ((renderer :pointer) (dataBuffer (:pointer :unsigned-byte)) (bufferSize :unsigned-long)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Interactive Renderer Specific Functions              **
;  **                                                                          **
;  ****************************************************************************
;  CSG IDs attribute 
;  Object IDs, to be applied as attributes on geometries 
; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $kQ3AttributeTypeConstructiveSolidGeometryID :|csgi|)

(defconstant $kQ3SolidGeometryObjNone -1)
(defconstant $kQ3SolidGeometryObjA 0)
(defconstant $kQ3SolidGeometryObjB 1)
(defconstant $kQ3SolidGeometryObjC 2)
(defconstant $kQ3SolidGeometryObjD 3)
(defconstant $kQ3SolidGeometryObjE 4)

; 	 Possible CSG equations 	

(def-mactype :tq3csgequation (find-mactype ':signed-long))

(defconstant $kQ3CSGEquationAandB #x88888888)
(defconstant $kQ3CSGEquationAandnotB #x22222222)
(defconstant $kQ3CSGEquationAanBonCad #x2F222F22)
(defconstant $kQ3CSGEquationnotAandB #x44444444)
(defconstant $kQ3CSGEquationnAaBorCanB #x74747474)

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3InteractiveRenderer_SetCSGEquation()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3InteractiveRenderer_SetCSGEquation" 
      ((renderer :pointer) (equation :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3InteractiveRenderer_GetCSGEquation()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3InteractiveRenderer_GetCSGEquation" 
      ((renderer :pointer) (equation (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3InteractiveRenderer_SetPreferences()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3InteractiveRenderer_SetPreferences" 
      ((renderer :pointer) (vendorID :signed-long) (engineID :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3InteractiveRenderer_GetPreferences()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3InteractiveRenderer_GetPreferences" 
      ((renderer :pointer) (vendorID (:pointer :signed-long)) (engineID (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3InteractiveRenderer_SetDoubleBufferBypass()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3InteractiveRenderer_SetDoubleBufferBypass" 
      ((renderer :pointer) (bypass :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3InteractiveRenderer_GetDoubleBufferBypass()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3InteractiveRenderer_GetDoubleBufferBypass" 
      ((renderer :pointer) (bypass (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3InteractiveRenderer_SetRAVEContextHints()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3InteractiveRenderer_SetRAVEContextHints" 
      ((renderer :pointer) (RAVEContextHints :unsigned-long)) 
  :tq3status
   () )

; 
;  *  Q3InteractiveRenderer_GetRAVEContextHints()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3InteractiveRenderer_GetRAVEContextHints" 
      ((renderer :pointer) (RAVEContextHints (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3InteractiveRenderer_SetRAVETextureFilter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3InteractiveRenderer_SetRAVETextureFilter" 
      ((renderer :pointer) (RAVEtextureFilterValue :unsigned-long)) 
  :tq3status
   () )

; 
;  *  Q3InteractiveRenderer_GetRAVETextureFilter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3InteractiveRenderer_GetRAVETextureFilter" 
      ((renderer :pointer) (RAVEtextureFilterValue (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3InteractiveRenderer_CountRAVEDrawContexts()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3InteractiveRenderer_CountRAVEDrawContexts" 
      ((renderer :pointer) (numRAVEContexts (:pointer :unsigned-long))) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3RaveDestroyCallback = PROCEDURE(renderer: TQ3RendererObject); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3ravedestroycallback (find-mactype ':pointer))
; $ENDC

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3InteractiveRenderer_GetRAVEDrawContexts()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3InteractiveRenderer_GetRAVEDrawContexts" 
      ((renderer :pointer) (raveDrawContextList (:pointer :pointer)) (raveDrawingEnginesList (:pointer :pointer)) (numRAVEContexts (:pointer :unsigned-long)) (raveDestroyCallback :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Renderer View Tools                              **
;  **                                                                          **
;  **                 You may only call these methods from a plug-in           **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Call by a renderer to call the user "idle" method, with progress 
;  *  information.
;  *  
;  *  Pass in (view, 0, n) on first call
;  *  Pass in (view, 1..n-1, n) during rendering
;  *  Pass in (view, n, n) upon completion
;  *  
;  *  Note: The user must have supplied an idleProgress method with 
;  *  Q3XView_SetIdleProgressMethod. Otherwise, the generic idle method is
;  *  called with no progress data. e.g. the Q3View_SetIdleMethod method
;  *  is called instead. (current and final are ignored, essentially.)
;  *
;  *  Returns kQ3Failure if rendering is cancelled.
;  
; 
;  *  Q3XView_IdleProgress()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XView_IdleProgress" 
      ((view :pointer) (current :unsigned-long) (completed :unsigned-long)) 
  :tq3status
   () )

; 
;  *  Called by an asynchronous renderer when it completes a frame.
;  
; 
;  *  Q3XView_EndFrame()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XView_EndFrame" 
      ((view :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Renderer AttributeSet Tools                      **
;  **                                                                          **
;  **                 You may only call these methods from a plug-in           **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Faster access to geometry attribute sets.
;  *  
;  *  Returns pointer to INTERNAL data structure for elements and attributes
;  *  in an attributeSet, or NULL if no attribute exists.
;  *  
;  *  For attributes of type kQ3AttributeType..., the internal data structure
;  *  is identical to the data structure used in Q3AttributeSet_Add.
;  
; 
;  *  Q3XAttributeSet_GetPointer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XAttributeSet_GetPointer" 
      ((attributeSet :pointer) (attributeType :signed-long)) 
  :pointer
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $kQ3XAttributeMaskNone 0)
(defconstant $kQ3XAttributeMaskSurfaceUV #x1)
(defconstant $kQ3XAttributeMaskShadingUV #x2)
(defconstant $kQ3XAttributeMaskNormal #x4)
(defconstant $kQ3XAttributeMaskAmbientCoefficient #x8)
(defconstant $kQ3XAttributeMaskDiffuseColor #x10)
(defconstant $kQ3XAttributeMaskSpecularColor #x20)
(defconstant $kQ3XAttributeMaskSpecularControl #x40)
(defconstant $kQ3XAttributeMaskTransparencyColor #x80)
(defconstant $kQ3XAttributeMaskSurfaceTangent #x100)
(defconstant $kQ3XAttributeMaskHighlightState #x200)
(defconstant $kQ3XAttributeMaskSurfaceShader #x400)
(defconstant $kQ3XAttributeMaskCustomAttribute #x80000000)
(defconstant $kQ3XAttributeMaskAll #x800007FF)
(defconstant $kQ3XAttributeMaskInherited #x3FF)
(defconstant $kQ3XAttributeMaskInterpolated #x1FF)

(def-mactype :tq3xattributemask (find-mactype ':unsigned-long))
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3XAttributeSet_GetMask()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3XAttributeSet_GetMask" 
      ((attributeSet :pointer)) 
  :unsigned-long
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Renderer Draw Context Tools                      **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3xdrawregion (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :tq3xdrawregionptr (find-mactype '(:pointer :pointer)));  when a VAR xx:TQ3XDrawRegion parameter can be nil, it is changed to xx: TQ3XDrawRegionPtr 
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3XDrawContext_GetDrawRegion()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3XDrawContext_GetDrawRegion" 
      ((drawContext :pointer) (drawRegion (:pointer :pointer))) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3xdrawcontextvalidationmasks (find-mactype ':signed-long))

(defconstant $kQ3XDrawContextValidationClearFlags #x0)
(defconstant $kQ3XDrawContextValidationDoubleBuffer #x1)
(defconstant $kQ3XDrawContextValidationShader #x2)
(defconstant $kQ3XDrawContextValidationClearFunction #x4)
(defconstant $kQ3XDrawContextValidationActiveBuffer #x8)
(defconstant $kQ3XDrawContextValidationInternalOffScreen #x10)
(defconstant $kQ3XDrawContextValidationPane #x20)
(defconstant $kQ3XDrawContextValidationMask #x40)
(defconstant $kQ3XDrawContextValidationDevice #x80)
(defconstant $kQ3XDrawContextValidationWindow #x100)
(defconstant $kQ3XDrawContextValidationWindowSize #x200)
(defconstant $kQ3XDrawContextValidationWindowClip #x400)
(defconstant $kQ3XDrawContextValidationWindowPosition #x800)
(defconstant $kQ3XDrawContextValidationPlatformAttributes #x1000)
(defconstant $kQ3XDrawContextValidationForegroundShader #x2000)
(defconstant $kQ3XDrawContextValidationBackgroundShader #x4000)
(defconstant $kQ3XDrawContextValidationColorPalette #x8000)
(defconstant $kQ3XDrawContextValidationAll #xFFFFFFFF)

(def-mactype :tq3xdrawcontextvalidation (find-mactype ':unsigned-long))
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3XDrawContext_ClearValidationFlags()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3XDrawContext_ClearValidationFlags" 
      ((drawContext :pointer)) 
  :tq3status
   () )

; 
;  *  Q3XDrawContext_GetValidationFlags()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawContext_GetValidationFlags" 
      ((drawContext :pointer) (validationFlags (:pointer :unsigned-long))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Renderer Draw Region Tools                       **
;  **                                                                          **
;  ****************************************************************************
; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :tq3xdevicepixeltype (find-mactype ':signed-long))

;   These do not indicate byte ordering    
(defconstant $kQ3XDevicePixelTypeInvalid 0)     ;   Unknown, un-initialized type     
(defconstant $kQ3XDevicePixelTypeRGB32 1)       ;   Alpha:8 (ignored), R:8, G:8, B:8  
(defconstant $kQ3XDevicePixelTypeARGB32 2)      ;   Alpha:8, R:8, G:8, B:8            
(defconstant $kQ3XDevicePixelTypeRGB24 3)       ;   24 bits/pixel, R:8, G:8, B:8     
(defconstant $kQ3XDevicePixelTypeRGB16 4)       ;   Alpha:1 (ignored), R:5, G:5, B:5  
(defconstant $kQ3XDevicePixelTypeARGB16 5)      ;   Alpha:1, R:5, G:5, B:5            
(defconstant $kQ3XDevicePixelTypeRGB16_565 6)   ;   16 bits/pixel, R:5, G:6, B:5     
(defconstant $kQ3XDevicePixelTypeIndexed8 7)    ;   8-bit color table index           
(defconstant $kQ3XDevicePixelTypeIndexed4 8)    ;   4-bit color table index           
(defconstant $kQ3XDevicePixelTypeIndexed2 9)    ;   2-bit color table index           
(defconstant $kQ3XDevicePixelTypeIndexed1 10)   ;   1-bit color table index           

(def-mactype :tq3xclipmaskstate (find-mactype ':signed-long))

(defconstant $kQ3XClipMaskFullyExposed 0)
(defconstant $kQ3XClipMaskPartiallyExposed 1)
(defconstant $kQ3XClipMaskNotExposed 2)

(def-mactype :tq3xcolordescriptorptr (find-mactype '(:pointer :tq3xcolordescriptor)))
(defrecord TQ3XColorDescriptor 
   (redShift :unsigned-long)
   (redMask :unsigned-long)
   (greenShift :unsigned-long)
   (greenMask :unsigned-long)
   (blueShift :unsigned-long)
   (blueMask :unsigned-long)
   (alphaShift :unsigned-long)
   (alphaMask :unsigned-long)
   )

(def-mactype :tq3xdrawregiondescriptorptr (find-mactype '(:pointer :tq3xdrawregiondescriptor)))
(defrecord TQ3XDrawRegionDescriptor 
   (width :unsigned-long)
   (height :unsigned-long)
   (rowBytes :unsigned-long)
   (pixelSize :unsigned-long)
   (pixelType :signed-long)
   (colorDescriptor :tq3xcolordescriptor)
   (bitOrder :signed-long)
   (byteOrder :signed-long)
   (clipMask (:pointer :tq3bitmap))
   )

(def-mactype :tq3xdrawregionservicesmasks (find-mactype ':signed-long))

(defconstant $kQ3XDrawRegionServicesNoneFlag 0)
(defconstant $kQ3XDrawRegionServicesClearFlag #x1)
(defconstant $kQ3XDrawRegionServicesDontLockDDSurfaceFlag #x2)

(def-mactype :tq3xdrawregionservices (find-mactype ':unsigned-long))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XDrawRegionRendererPrivateDeleteMethod = PROCEDURE(rendererPrivate: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xdrawregionrendererprivatedeletemethod (find-mactype ':pointer))
; $ENDC

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3XDrawRegion_GetDeviceScaleX()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3XDrawRegion_GetDeviceScaleX" 
      ((drawRegion :pointer) (deviceScaleX (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3XDrawRegion_GetDeviceScaleY()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawRegion_GetDeviceScaleY" 
      ((drawRegion :pointer) (deviceScaleY (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3XDrawRegion_GetDeviceOffsetX()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawRegion_GetDeviceOffsetX" 
      ((drawRegion :pointer) (deviceOffsetX (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3XDrawRegion_GetDeviceOffsetY()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawRegion_GetDeviceOffsetY" 
      ((drawRegion :pointer) (deviceOffsetX (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3XDrawRegion_GetWindowScaleX()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawRegion_GetWindowScaleX" 
      ((drawRegion :pointer) (windowScaleX (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3XDrawRegion_GetWindowScaleY()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawRegion_GetWindowScaleY" 
      ((drawRegion :pointer) (windowScaleY (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3XDrawRegion_GetWindowOffsetX()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawRegion_GetWindowOffsetX" 
      ((drawRegion :pointer) (windowOffsetX (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3XDrawRegion_GetWindowOffsetY()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawRegion_GetWindowOffsetY" 
      ((drawRegion :pointer) (windowOffsetY (:pointer :single-float))) 
  :tq3status
   () )

; 
;  *  Q3XDrawRegion_IsActive()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawRegion_IsActive" 
      ((drawRegion :pointer) (isActive (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3XDrawRegion_GetNextRegion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawRegion_GetNextRegion" 
      ((drawRegion :pointer) (nextDrawRegion (:pointer :pointer))) 
  :tq3status
   () )

;  
;  *  One of the next two functions must be called before using a draw region 
;  
; 
;  *  Use this Start function if double buffering/image access services from the
;  *  Draw Context are not needed, you may still request clear for example
;  
; 
;  *  Q3XDrawRegion_Start()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawRegion_Start" 
      ((drawRegion :pointer) (services :unsigned-long) (descriptor (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Use this Start function if double buffering or image access services from 
;  *  the Draw Context are needed.
;  
; 
;  *  Q3XDrawRegion_StartAccessToImageBuffer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawRegion_StartAccessToImageBuffer" 
      ((drawRegion :pointer) (services :unsigned-long) (descriptor (:pointer :pointer)) (image (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  This function is used to indicate that access to a DrawRegion is ended.
;  
; 
;  *  Q3XDrawRegion_End()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawRegion_End" 
      ((drawRegion :pointer)) 
  :tq3status
   () )

; 
;  *  Q3XDrawRegion_GetDeviceTransform()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawRegion_GetDeviceTransform" 
      ((drawRegion :pointer) (deviceTransform (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3XDrawRegion_GetClipFlags()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawRegion_GetClipFlags" 
      ((drawRegion :pointer) (clipMaskState (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3XDrawRegion_GetClipMask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawRegion_GetClipMask" 
      ((drawRegion :pointer) (clipMask (:pointer :pointer))) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC TARGET_OS_MAC 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Q3XDrawRegion_GetClipRegion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawRegion_GetClipRegion" 
      ((drawRegion :pointer) (RgnHandle (:pointer (:handle :macregion)))) 
  :tq3status
   () )

; 
;  *  Q3XDrawRegion_GetGDHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawRegion_GetGDHandle" 
      ((drawRegion :pointer) (GDHandle (:pointer (:handle :gdevice)))) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; TARGET_OS_MAC

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Q3XDrawRegion_GetRendererPrivate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawRegion_GetRendererPrivate" 
      ((drawRegion :pointer) (rendererPrivate (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3XDrawRegion_SetRendererPrivate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawRegion_SetRendererPrivate" 
      ((drawRegion :pointer) (rendererPrivate :pointer) (deleteMethod :pointer)) 
  :tq3status
   () )

; 
;  *  Q3XDrawRegion_SetUseDefaultRendererFlag()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawRegion_SetUseDefaultRendererFlag" 
      ((drawRegion :pointer) (flag :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3XDrawRegion_GetUseDefaultRendererFlag()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3XDrawRegion_GetUseDefaultRendererFlag" 
      ((drawRegion :pointer) (useDefaultRenderingFlag (:pointer :signed-long))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Renderer Class Methods                           **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Methods from Object
;  *      kQ3XMethodTypeObjectClassRegister
;  *      kQ3XMethodTypeObjectClassUnregister
;  *      kQ3XMethodTypeObjectNew
;  *      kQ3XMethodTypeObjectDelete
;  *      kQ3XMethodTypeObjectRead
;  *      kQ3XMethodTypeObjectTraverse
;  *      kQ3XMethodTypeObjectWrite
;  *      
;  *  Methods from Shared
;  *      kQ3MethodTypeSharedEdited
;  *
;  *  Renderer Methods
;  *  
;  *  The renderer methods should be implemented according to the type
;  *  of renderer being written.
;  *
;  *  For the purposes of documentation, there are two basic types of
;  *  renderers: 
;  *
;  *      Interactive
;  *          Interactive Renderer
;  *          WireFrame Renderer
;  *      
;  *      Deferred
;  *          a ray-tracer
;  *          painter's algorithm renderer (cached in a BSP triangle tree)
;  *          an artistic renderer (simulates a pencil drawing, etc.)
;  *
;  *  The main difference is how each renderer handles incoming state and 
;  *  geometry.
;  *
;  *  An interactive renderer immediately transforms, culls, and shades
;  *  incoming geometry and performs rasterization. For example, in a 
;  *  single-buffered WireFrame renderer, you will see a new triangle
;  *  immediately after Q3Triangle_Draw (if it's visible, of course).
;  *
;  *  A deferred renderer caches the view state and each geometry, 
;  *  converting into any internal queue of drawing commands. Rasterization
;  *  is not actually performed until all data has been submitted.
;  *  
;  *  For example, a ray-tracer may not rasterize anything until the
;  *  end of the rendering loop, or until an EndFrame call is made.
;  

; *****************************************************************************
;  **                                                                          **
;  **                     Renderer User Interface Methods                      **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  kQ3XMethodTypeRendererIsInteractive
;  *  
;  *  There is no actual method with this - the metahandler simply returns
;  *  "(TQ3XFunctionPointer)kQ3True" for this "method" if the renderer is 
;  *  intended to be used in interactive settings, and   
;  *  "(TQ3XFunctionPointer)kQ3False" otherwise. 
;  *  
;  *  If neither value is specified in the metahandler, the renderer 
;  *  is *assumed to be non-interactive*!!!
;  *  
;  *  OPTIONAL
;  
; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $kQ3XMethodTypeRendererIsInteractive :|isin|)

; 	
; 	 *  TQ3XRendererModalConfigureMethod
; 	 *  
; 	 *  This method should pop up a modal dialog to edit the renderer settings 
; 	 *  found in the renderer private. 
; 	 *  
; 	 *  dialogAnchor - is platform specific data passed by the client to support
; 	 *      movable modal dialogs. 
; 	 *    MacOS: this is a callback to the calling application's event handler.
; 	 *      The renderer calls this function with events not handled by the 
; 	 *      settings dialog. This is necessary in order to support movable modal 
; 	 *      dialogs. An application's event handler must return kQ3True if it 
; 	 *      handles the event passed to the callback or kQ3False if not. 
; 	 *      An application which doesn't want to support a movable modal configure
; 	 *      dialog should pass NULL for the clientEventHandler of TQ3DialogAnchor.
; 	 *      A renderer should implement a non-movable style dialog in that case.
; 	 *    Win32: this is the HWND of the owning window (typically an application's
; 	 *      main window).  (Win32 application modal dialogs are always movable.)
; 	 *  canceled - returns a boolean inditacating that the user canceled the 
; 	 *  dialog.
; 	 *  
; 	 *  OPTIONAL
; 	 	
(defconstant $kQ3XMethodTypeRendererModalConfigure :|rdmc|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererModalConfigureMethod = FUNCTION(renderer: TQ3RendererObject; dialogAnchor: TQ3DialogAnchor; VAR canceled: TQ3Boolean; rendererPrivate: UNIV Ptr): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrenderermodalconfiguremethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  kQ3XMethodTypeRendererGetNickNameString
; 	 *  
; 	 *      Allows an application to collect the name of the renderer for
; 	 *      display in a user interface item such as a menu.
; 	 *  
; 	 *      If dataBuffer is NULL actualDataSize returns the required size in 
; 	 *      bytes of a data buffer large enough to store the renderer name. 
; 	 *
; 	 *      bufferSize is the actual size of the memory block pointed to by 
; 	 *      dataBuffer
; 	 *
; 	 *      actualDataSize - on return the actual number of bytes written to the
; 	 *      buffer or if dataBuffer is NULL the required size of dataBuffer
; 	 *
; 	 *  OPTIONAL
; 	 	

(defconstant $kQ3XMethodTypeRendererGetNickNameString :|rdns|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererGetNickNameStringMethod = FUNCTION(VAR dataBuffer: UInt8; bufferSize: UInt32; VAR actualDataSize: UInt32): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrenderergetnicknamestringmethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  kQ3XMethodTypeRendererGetConfigurationData
; 	 *  
; 	 *      Allows an application to collect private configuration data from the
; 	 *      renderer which it will then save. For example in a preference file, 
; 	 *      a registry key (on Windows) or in a style template. An application 
; 	 *      should tag this data with the renderer's object name.
; 	 *  
; 	 *      If dataBuffer is NULL actualDataSize returns the required size in 
; 	 *      bytes of a data buffer large enough to store private data. 
; 	 *
; 	 *      bufferSize is the actual size of the memory block pointed to by 
; 	 *      dataBuffer
; 	 *
; 	 *      actualDataSize - on return the actual number of bytes written to the
; 	 *      buffer or if dataBuffer is NULL the required size of dataBuffer
; 	 *
; 	 *  OPTIONAL
; 	 	

(defconstant $kQ3XMethodTypeRendererGetConfigurationData :|rdgp|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererGetConfigurationDataMethod = FUNCTION(renderer: TQ3RendererObject; VAR dataBuffer: UInt8; bufferSize: UInt32; VAR actualDataSize: UInt32; rendererPrivate: UNIV Ptr): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrenderergetconfigurationdatamethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  TQ3XRendererSetConfigurationDataMethod
; 	 *  
; 	 *      Allows an application to pass private configuration data which has
; 	 *      previously  been obtained from a renderer via 
; 	 *      Q3Renderer_GetConfigurationData. For example in a preference file or 
; 	 *      in a style template. An application should tag this data with the 
; 	 *      renderer's object name.
; 	 *  
; 	 *      bufferSize is the actual size of the memory block pointed to by 
; 	 *      dataBuffer
; 	 *
; 	 *  OPTIONAL
; 	 	

(defconstant $kQ3XMethodTypeRendererSetConfigurationData :|rdsp|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererSetConfigurationDataMethod = FUNCTION(renderer: TQ3RendererObject; VAR dataBuffer: UInt8; bufferSize: UInt32; rendererPrivate: UNIV Ptr): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrenderersetconfigurationdatamethod (find-mactype ':pointer))
; $ENDC

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                     Renderer Drawing State Methods                       **
; 	 **                                                                          **
; 	 ****************************************************************************	
; 	
; 	 *  TQ3RendererStartFrame
; 	 *  
; 	 *  The StartFrame method is called first at Q3View_StartRendering
; 	 *  and should:
; 	 *      - initialize any renderer state to defaults
; 	 *      - extract any and all useful data from the drawContext
; 	 *
; 	 *  If your renderer passed in kQ3RendererFlagClearBuffer at 
; 	 *  registration, then it should also:
; 	 *      - clear the drawContext 
; 	 *  
; 	 *      When clearing, your renderer may opt to:
; 	 *      - NOT clear anything (if you touch every pixel, for example)
; 	 *      - to clear with your own routine, or
; 	 *      - to use the draw context default clear method by calling 
; 	 *      Q3DrawContext_Clear. Q3DrawContext_Clear takes advantage of
; 	 *      any available hardware in the system for clearing.
; 	 *  
; 	 *  This call also signals the start of all default submit commands from
; 	 *  the view. The renderer will receive updates for the default view
; 	 *  state via its Update methods before StartPass is called.
; 	 *  
; 	 *  REQUIRED
; 	 	

(defconstant $kQ3XMethodTypeRendererStartFrame :|rdcl|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererStartFrameMethod = FUNCTION(view: TQ3ViewObject; rendererPrivate: UNIV Ptr; drawContext: TQ3DrawContextObject): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrendererstartframemethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  kQ3XMethodTypeRendererStartPass
; 	 *  TQ3XRendererStartPassMethod
; 	 *  
; 	 *  The StartPass method is called during Q3View_StartRendering but after
; 	 *  the StartFrame command. It should:
; 	 *      - collect camera and light information
; 	 *  
; 	 *  If your renderer supports deferred camera transformation, camera is the
; 	 *  main camera which will be submitted in the hierarchy somewhere. It
; 	 *  is never NULL.
; 	 *
; 	 *  If your renderer does not support deferred camera transformation, camera
; 	 *  is the transformed camera.
; 	 *
; 	 *  If your renderer supports deferred light transformation, lights will be
; 	 *  NULL, and will be submitted to your light draw methods instead.
; 	 *
; 	 *  This call signals the end of the default update state, and the start of 
; 	 *  submit commands from the user to the view.
; 	 *
; 	 *  REQUIRED
; 	 	

(defconstant $kQ3XMethodTypeRendererStartPass :|rdst|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererStartPassMethod = FUNCTION(view: TQ3ViewObject; rendererPrivate: UNIV Ptr; camera: TQ3CameraObject; lightGroup: TQ3GroupObject): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrendererstartpassmethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  kQ3XMethodTypeRendererFlushFrame
; 	 *  TQ3XRendererFlushFrameMethod
; 	 *  
; 	 *  This call is only implemented by asynchronous renderers.
; 	 *  
; 	 *  The FlushFrame method is called between the StartPass and EndPass
; 	 *  methods and is called when the user wishes to flush any asynchronous
; 	 *  drawing tasks (which draw to the drawcontext), but does not want 
; 	 *  to block.
; 	 *  
; 	 *  The result of this call is that an image should "eventually" appear
; 	 *  asynchronously.
; 	 *  
; 	 *  For asynchronous rendering, this call is non-blocking.
; 	 *  
; 	 *  An interactive renderer should ensure that all received
; 	 *  geometries are drawn in the image.
; 	 *  
; 	 *  An interactive renderer that talks to hardware should force
; 	 *  the hardware to generate an image.
; 	 *  
; 	 *  A deferred renderer should exhibit a similar behaviour,
; 	 *  though it is not required.  A deferred renderer should spawn
; 	 *  a process that generates a partial image from the currently
; 	 *  accumulated drawing state. 
; 	 *  
; 	 *  However, for renderers such as ray-tracers which generally are
; 	 *  quite compute-intensive, FlushFrame is not required and is a no-op.
; 	 *
; 	 *  OPTIONAL
; 	 	

(defconstant $kQ3XMethodTypeRendererFlushFrame :|rdfl|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererFlushFrameMethod = FUNCTION(view: TQ3ViewObject; rendererPrivate: UNIV Ptr; drawContext: TQ3DrawContextObject): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrendererflushframemethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  kQ3XMethodTypeRendererEndPass
; 	 *  TQ3XRendererEndPassMethod
; 	 *  
; 	 *  The EndPass method is called at Q3View_EndRendering and signals
; 	 *  the end of submit commands to the view.
; 	 *
; 	 *  If an error occurs, the renderer should call Q3XError_Post and
; 	 *  return kQ3ViewStatusError.
; 	 *  
; 	 *  If a renderer requires another pass on the renderering data,
; 	 *  it should return kQ3ViewStatusRetraverse.
; 	 *  
; 	 *  If rendering was cancelled, this function will not be called
; 	 *  and the view will handle returning kQ3ViewStatusCancelled;
; 	 *  
; 	 *  Otherwise, your renderer should begin completing the process of 
; 	 *  generating the image in the drawcontext. If you have buffered
; 	 *  any drawing data, flush it. RendererEnd should have a similar
; 	 *  effect as RendererFlushFrame.
; 	 *  
; 	 *  If the renderer is synchronous:
; 	 *      - complete rendering of the entire frame
; 	 *      if the renderer supports kQ3RendererClassSupportDoubleBuffer
; 	 *          - Update the front buffer
; 	 *      else
; 	 *          - DrawContext will update the front buffer after returning
; 	 *
; 	 *  If the renderer is asynchronous
; 	 *      - spawn rendering thread for entire frame
; 	 *      if the renderer supports kQ3RendererClassSupportDoubleBuffer,
; 	 *          - you must eventually update the front buffer asynchronously
; 	 *      else
; 	 *          - you must eventually update the back buffer asynchronously
; 	 *          
; 	 *  REQUIRED
; 	 	

(defconstant $kQ3XMethodTypeRendererEndPass :|rded|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererEndPassMethod = FUNCTION(view: TQ3ViewObject; rendererPrivate: UNIV Ptr): TQ3ViewStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrendererendpassmethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  kQ3XMethodTypeRendererEndFrame
; 	 *  TQ3XRendererEndFrame
; 	 *  
; 	 *  This call is only implemented by asynchronous renderers.
; 	 *
; 	 *  The EndFrame method is called from Q3View_Sync, which is
; 	 *  called after Q3View_EndRendering and signals that the user
; 	 *  wishes to see the completed image and is willing to block.
; 	 *  
; 	 *  If your renderer supports kQ3RendererFlagDoubleBuffer
; 	 *      - update the front buffer completely 
; 	 *  else
; 	 *      - update the back buffer completely
; 	 *
; 	 *  This call is equivalent in functionality to RendererFlushFrame
; 	 *  but blocks until the image is completed.
; 	 *  
; 	 *  If no method is supplied, the default is a no-op.
; 	 *  
; 	 *  NOTE: Registering a method of this type indicates that your renderer will
; 	 *  be rendering after Q3View_EndRendering has been called.
; 	 *  
; 	 *  OPTIONAL
; 	 	

(defconstant $kQ3XMethodTypeRendererEndFrame :|rdsy|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererEndFrameMethod = FUNCTION(view: TQ3ViewObject; rendererPrivate: UNIV Ptr; drawContext: TQ3DrawContextObject): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrendererendframemethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  The RendererCancel method is called after Q3View_StartRendering
; 	 *  and signals the termination of all rendering operations.
; 	 *
; 	 *  A renderer should clean up any cached data, and cancel all 
; 	 *  rendering operations.
; 	 *  
; 	 *  If called before Q3View_EndRendering, the RendererEnd method
; 	 *  is NOT called.
; 	 *  
; 	 *  If called after Q3View_EndRendering, the renderer should kill
; 	 *  any threads and terminate any further rendering.
; 	 *  
; 	 *  REQUIRED
; 	 	

(defconstant $kQ3XMethodTypeRendererCancel :|rdab|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererCancelMethod = PROCEDURE(view: TQ3ViewObject; rendererPrivate: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrenderercancelmethod (find-mactype ':pointer))
; $ENDC

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                     Renderer DrawContext Methods                         **
; 	 **                                                                          **
; 	 ****************************************************************************	
; 	
; 	 *  kQ3XMethodTypeRendererPush
; 	 *  TQ3XRendererPushMethod
; 	 *  
; 	 *  kQ3XMethodTypeRendererPop
; 	 *  TQ3XRendererPopMethod
; 	 *  
; 	 *  These methods are called whenever the graphics state in the view
; 	 *  is pushed or popped. The user may isolate state by calling:
; 	 *  
; 	 *  Q3Attribute_Submit(kQ3AttributeTypeDiffuseColor, &red, view);
; 	 *  Q3Attribute_Submit(kQ3AttributeTypeTransparencyColor, &blue, view);
; 	 *  Q3Attribute_Submit(kQ3AttributeTypeSpecularColor, &white, view);
; 	 *  Q3Box_Submit(&unitBox, view);
; 	 *  Q3TranslateTransform_Submit(&unitVector, view);
; 	 *  Q3Push_Submit(view);
; 	 *      Q3Attribute_Submit(kQ3AttributeTypeDiffuseColor, &blue, view);
; 	 *      Q3Attribute_Submit(kQ3AttributeTypeTransparencyColor, &green, view);
; 	 *      Q3Box_Submit(&unitBox, view);
; 	 *  Q3Pop_Submit(view); 
; 	 *  Q3TranslateTransform_Submit(&unitVector, view);
; 	 *  Q3Box_Submit(&unitBox, view);
; 	 *  
; 	 *  or by submitting a display group which pushes and pops.
; 	 *  
; 	 *  If you support RendererPush and RendererPop in your renderer:
; 	 *      - you must maintain your drawing state as a stack, as well.
; 	 *      - you will not be updated with the popped state after
; 	 *          RendererPop is called.
; 	 *
; 	 *  If you do not support Push and Pop in your renderer:
; 	 *      - you may maintain a single copy of the drawing state.
; 	 *      - you will be updated with changed fields after the view stack is
; 	 *          popped.
; 	 *
; 	 *  A renderer that supports Push and Pop gets called in the following
; 	 *  sequence (from example above):
; 	 *  
; 	 *  RendererUpdateAttributeDiffuseColor(&red,...)
; 	 *  RendererUpdateAttributeTransparencyColor(&blue,...)
; 	 *  RendererUpdateAttributeSpecularColor(&white,...)
; 	 *  RendererUpdateMatrixLocalToWorld(...)
; 	 *  RendererSubmitGeometryBox(...)
; 	 *  RendererPush(...)
; 	 *      RendererUpdateAttributeDiffuseColor(&blue,...)
; 	 *      RendererUpdateAttributeTransparencyColor(&green,...)
; 	 *      RendererSubmitGeometryBox(...)
; 	 *  RendererPop(...)
; 	 *  RendererUpdateMatrixLocalToWorld(...)
; 	 *  RendererSubmitGeometryBox(...)
; 	 *
; 	 *  A renderer that does not supports Push and Pop gets called in the
; 	 *  following sequence:
; 	 *  
; 	 *  RendererUpdateAttributeDiffuseColor(&red,...)
; 	 *  RendererUpdateAttributeTransparencyColor(&blue,...)
; 	 *  RendererUpdateAttributeSpecularColor(&white,...)
; 	 *  RendererUpdateMatrixLocalToWorld(...)
; 	 *  RendererSubmitGeometryBox(...)
; 	 *      RendererUpdateAttributeDiffuseColor(&blue,...)
; 	 *      RendererUpdateAttributeTransparencyColor(&green,...)
; 	 *      RendererSubmitGeometryBox(...)
; 	 *  RendererUpdateAttributeDiffuseColor(&red,...)
; 	 *  RendererUpdateAttributeTransparencyColor(&blue,...)
; 	 *  RendererUpdateMatrixLocalToWorld(...)
; 	 *  RendererSubmitGeometryBox(...)
; 	 *  
; 	 	

(defconstant $kQ3XMethodTypeRendererPush :|rdps|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererPushMethod = FUNCTION(view: TQ3ViewObject; rendererPrivate: UNIV Ptr): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrendererpushmethod (find-mactype ':pointer))
; $ENDC

(defconstant $kQ3XMethodTypeRendererPop :|rdpo|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererPopMethod = FUNCTION(view: TQ3ViewObject; rendererPrivate: UNIV Ptr): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrendererpopmethod (find-mactype ':pointer))
; $ENDC

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                         Renderer Cull Methods                            **
; 	 **                                                                          **
; 	 ****************************************************************************	
; 	
; 	 *  kQ3XMethodTypeRendererIsBoundingBoxVisible
; 	 *  TQ3XRendererIsBoundingBoxVisibleMethod
; 	 *  
; 	 *  This method is called to cull complex groups and geometries 
; 	 *  given their bounding box in local space.
; 	 *  
; 	 *  It should transform the local-space bounding box coordinates to
; 	 *  frustum space and return a TQ3Boolean return value indicating
; 	 *  whether the box appears within the viewing frustum.
; 	 *  
; 	 *  If no method is supplied, the default behavior is to return
; 	 *  kQ3True.
; 	 *  
; 	 	

(defconstant $kQ3XMethodTypeRendererIsBoundingBoxVisible :|rdbx|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererIsBoundingBoxVisibleMethod = FUNCTION(view: TQ3ViewObject; rendererPrivate: UNIV Ptr; {CONST}VAR bBox: TQ3BoundingBox): TQ3Boolean; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrendererisboundingboxvisiblemethod (find-mactype ':pointer))
; $ENDC

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                     Renderer Object Support Methods                      **
; 	 **                                                                          **
; 	 ****************************************************************************	
; 	
; 	 *  Drawing methods (Geometry, Camera, Lights)
; 	 *
; 	 	
; 	
; 	 *  Geometry MetaHandler
; 	 *  
; 	 *  This metaHandler is required to support 
; 	 *  
; 	 *  kQ3GeometryTypeTriangle
; 	 *  kQ3GeometryTypeLine
; 	 *  kQ3GeometryTypePoint
; 	 *  kQ3GeometryTypeMarker
; 	 *  kQ3GeometryTypePixmapMarker
; 	 *  
; 	 *  REQUIRED
; 	 	

(defconstant $kQ3XMethodTypeRendererSubmitGeometryMetaHandler :|rdgm|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererSubmitGeometryMetaHandlerMethod = FUNCTION(geometryType: TQ3ObjectType): TQ3XFunctionPointer; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrenderersubmitgeometrymetahandlermethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  The TQ3XRendererSubmitGeometryMetaHandlerMethod switches on geometryType
; 	 *  of kQ3GeometryTypeFoo and returns methods of type:
; 	 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererSubmitGeometryMethod = FUNCTION(view: TQ3ViewObject; rendererPrivate: UNIV Ptr; geometry: TQ3GeometryObject; publicData: UNIV Ptr): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrenderersubmitgeometrymethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  Camera MetaHandler
; 	 *  
; 	 *  This metaHandler, if supplied, indicates that your renderer
; 	 *  handles deferred transformation of the main camera within a scene.
; 	 *  
; 	 *  If not supplied, or an unsupported camera is used, the view will do
; 	 *  the transformation for the renderer and pass in a camera in the 
; 	 *  StartPass method.
; 	 *  
; 	 *  OPTIONAL
; 	 	

(defconstant $kQ3XMethodTypeRendererSubmitCameraMetaHandler :|rdcm|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererSubmitCameraMetaHandlerMethod = FUNCTION(cameraType: TQ3ObjectType): TQ3XFunctionPointer; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrenderersubmitcamerametahandlermethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  The TQ3XRendererSubmitCameraMetaHandlerMethod switches on cameraType
; 	 *  of kQ3CameraTypeFoo and returns methods of type:
; 	 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererSubmitCameraMethod = FUNCTION(view: TQ3ViewObject; rendererPrivate: UNIV Ptr; camera: TQ3CameraObject; publicData: UNIV Ptr): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrenderersubmitcameramethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  Light MetaHandler
; 	 *  
; 	 *  This metaHandler, if supplied, indicates that your renderer
; 	 *  handles deferred transformation of lights within a scene.
; 	 *  
; 	 *  If an unsupported light is encountered, it is ignored.
; 	 *
; 	 *  OPTIONAL
; 	 	

(defconstant $kQ3XMethodTypeRendererSubmitLightMetaHandler :|rdlg|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererSubmitLightMetaHandlerMethod = FUNCTION(lightType: TQ3ObjectType): TQ3XFunctionPointer; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrenderersubmitlightmetahandlermethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  The TQ3XRendererSubmitLightMetaHandlerMethod switches on lightType
; 	 *  of kQ3LightTypeFoo and returns methods of type:
; 	 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererSubmitLightMethod = FUNCTION(view: TQ3ViewObject; rendererPrivate: UNIV Ptr; light: TQ3LightObject; publicData: UNIV Ptr): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrenderersubmitlightmethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *
; 	 *  Update methods
; 	 *
; 	 *  They are called whenever the state has changed. If the renderer supports
; 	 *  the RendererPush and RendererPop methods, it must maintain its own state
; 	 *  stack. Updates are not called for changed data when the view stack is
; 	 *  popped.
; 	 *
; 	 *  See the comments for the RendererPush and RendererPop methods above
; 	 *  for an example of how data is updated.
; 	 *
; 	 	
; 	
; 	 *  Style
; 	 	

(defconstant $kQ3XMethodTypeRendererUpdateStyleMetaHandler :|rdyu|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererUpdateStyleMetaHandlerMethod = FUNCTION(styleType: TQ3ObjectType): TQ3XFunctionPointer; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrendererupdatestylemetahandlermethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  The TQ3XRendererUpdateStyleMetaHandlerMethod switches on styleType
; 	 *  of kQ3StyleTypeFoo and returns methods of type:
; 	 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererUpdateStyleMethod = FUNCTION(view: TQ3ViewObject; rendererPrivate: UNIV Ptr; publicData: UNIV Ptr): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrendererupdatestylemethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  Attributes
; 	 	

(defconstant $kQ3XMethodTypeRendererUpdateAttributeMetaHandler :|rdau|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererUpdateAttributeMetaHandlerMethod = FUNCTION(attributeType: TQ3AttributeType): TQ3XFunctionPointer; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrendererupdateattributemetahandlermethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  The TQ3XRendererUpdateStyleMetaHandlerMethod switches on attributeType
; 	 *  of kQ3AttributeTypeFoo and returns methods of type:
; 	 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererUpdateAttributeMethod = FUNCTION(view: TQ3ViewObject; rendererPrivate: UNIV Ptr; publicData: UNIV Ptr): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrendererupdateattributemethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  Shaders
; 	 	

(defconstant $kQ3XMethodTypeRendererUpdateShaderMetaHandler :|rdsu|)

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererUpdateShaderMetaHandlerMethod = FUNCTION(shaderType: TQ3ObjectType): TQ3XFunctionPointer; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrendererupdateshadermetahandlermethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  The TQ3XRendererUpdateShaderMetaHandlerMethod switches on shaderType
; 	 *  of kQ3ShaderTypeFoo and returns methods of type:
; 	 	
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererUpdateShaderMethod = FUNCTION(view: TQ3ViewObject; rendererPrivate: UNIV Ptr; VAR shaderObject: TQ3Object): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrendererupdateshadermethod (find-mactype ':pointer))
; $ENDC

; 	
; 	 *  Matrices
; 	 	

(defconstant $kQ3XMethodTypeRendererUpdateMatrixMetaHandler :|rdxu|)

(def-mactype :tq3xrendererupdatematrixmetahandlermethod (find-mactype ':pointer))
; 	
; 	 *  The TQ3XRendererUpdateShaderMetaHandlerMethod switches on methods
; 	 *  of the form kQ3MethodTypeRendererUpdateMatrixFoo:
; 	 	

(defconstant $kQ3XMethodTypeRendererUpdateMatrixLocalToWorld :|ulwx|)

(defconstant $kQ3XMethodTypeRendererUpdateMatrixLocalToWorldInverse :|ulwi|)

(defconstant $kQ3XMethodTypeRendererUpdateMatrixLocalToWorldInverseTranspose :|ulwt|)

(defconstant $kQ3XMethodTypeRendererUpdateMatrixLocalToCamera :|ulcx|)

(defconstant $kQ3XMethodTypeRendererUpdateMatrixLocalToFrustum :|ulfx|)

(defconstant $kQ3XMethodTypeRendererUpdateMatrixWorldToFrustum :|uwfx|)

; 	
; 	 *  and returns methods of type:
; 	 	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3XRendererUpdateMatrixMethod = FUNCTION(view: TQ3ViewObject; rendererPrivate: UNIV Ptr; {CONST}VAR matrix: TQ3Matrix4x4): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3xrendererupdatematrixmethod (find-mactype ':pointer))
; $ENDC

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QD3DRendererIncludes

; $ENDC                                         ; __QD3DRENDERER__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'QD3DRenderer)#|
; Warning: Did not recognize these types or records: (hwnd)
|#