(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QD3DShader.p"
; at Wednesday May 1,2002 2:42:39 pm.
; 
;      File:       QD3DShader.p
;  
;      Contains:   QuickDraw 3D Shader / Color Routines
;  
;      Version:    Technology: Quickdraw 3D 1.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __QD3DSHADER__
; $SETC __QD3DSHADER__ := 1

; $I+
; $SETC QD3DShaderIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __QD3D__
|#

(require-interface 'QD3D)
#|                                              ; $I QD3D.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MOVIES__
|#

(require-interface 'Movies)
#|                                              ; $I Movies.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

; *****************************************************************************
;  **                                                                          **
;  **                             RGB Color routines                           **
;  **                                                                          **
;  ****************************************************************************
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Q3ColorRGB_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ColorRGB_Set" 
      ((color (:pointer :tq3colorrgb)) (r :single-float) (g :single-float) (b :single-float)) 
  (:pointer :tq3colorrgb)
   () )

; 
;  *  Q3ColorARGB_Set()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3ColorARGB_Set" 
      ((color (:pointer :tq3colorargb)) (a :single-float) (r :single-float) (g :single-float) (b :single-float)) 
  (:pointer :tq3colorargb)
   () )

; 
;  *  Q3ColorRGB_Add()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3ColorRGB_Add" 
      ((c1 (:pointer :tq3colorrgb)) (c2 (:pointer :tq3colorrgb)) (result (:pointer :tq3colorrgb))) 
  (:pointer :tq3colorrgb)
   () )

; 
;  *  Q3ColorRGB_Subtract()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3ColorRGB_Subtract" 
      ((c1 (:pointer :tq3colorrgb)) (c2 (:pointer :tq3colorrgb)) (result (:pointer :tq3colorrgb))) 
  (:pointer :tq3colorrgb)
   () )

; 
;  *  Q3ColorRGB_Scale()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3ColorRGB_Scale" 
      ((color (:pointer :tq3colorrgb)) (scale :single-float) (result (:pointer :tq3colorrgb))) 
  (:pointer :tq3colorrgb)
   () )

; 
;  *  Q3ColorRGB_Clamp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3ColorRGB_Clamp" 
      ((color (:pointer :tq3colorrgb)) (result (:pointer :tq3colorrgb))) 
  (:pointer :tq3colorrgb)
   () )

; 
;  *  Q3ColorRGB_Lerp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST                                         ; CONST
(deftrap-inline "_Q3ColorRGB_Lerp" 
      ((first (:pointer :tq3colorrgb)) (last (:pointer :tq3colorrgb)) (alpha :single-float) (result (:pointer :tq3colorrgb))) 
  (:pointer :tq3colorrgb)
   () )

; 
;  *  Q3ColorRGB_Accumulate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3ColorRGB_Accumulate" 
      ((src (:pointer :tq3colorrgb)) (result (:pointer :tq3colorrgb))) 
  (:pointer :tq3colorrgb)
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

;   Q3ColorRGB_Luminance really returns a pointer to a Single 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Q3ColorRGB_Luminance()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3ColorRGB_Luminance" 
      ((color (:pointer :tq3colorrgb)) (luminance (:pointer :single-float))) 
  :pointer
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; *****************************************************************************
;  **                                                                          **
;  **                             Shader Types                                 **
;  **                                                                          **
;  ****************************************************************************

(def-mactype :tq3shaderuvboundary (find-mactype ':signed-long))

(defconstant $kQ3ShaderUVBoundaryWrap 0)
(defconstant $kQ3ShaderUVBoundaryClamp 1)

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                             Shader Routines                              **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3Shader_GetType()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3Shader_GetType" 
      ((shader :pointer)) 
  :tq3objecttype
   () )

; 
;  *  Q3Shader_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Shader_Submit" 
      ((shader :pointer) (view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Shader_SetUVTransform()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3Shader_SetUVTransform" 
      ((shader :pointer) (uvTransform (:pointer :tq3matrix3x3))) 
  :tq3status
   () )

; 
;  *  Q3Shader_GetUVTransform()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Shader_GetUVTransform" 
      ((shader :pointer) (uvTransform (:pointer :tq3matrix3x3))) 
  :tq3status
   () )

; 
;  *  Q3Shader_SetUBoundary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Shader_SetUBoundary" 
      ((shader :pointer) (uBoundary :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3Shader_SetVBoundary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Shader_SetVBoundary" 
      ((shader :pointer) (vBoundary :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3Shader_GetUBoundary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Shader_GetUBoundary" 
      ((shader :pointer) (uBoundary (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3Shader_GetVBoundary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Shader_GetVBoundary" 
      ((shader :pointer) (vBoundary (:pointer :signed-long))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Illumination Shader Classes                      **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3IlluminationShader_GetType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3IlluminationShader_GetType" 
      ((shader :pointer)) 
  :tq3objecttype
   () )

; 
;  *  Q3PhongIllumination_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PhongIllumination_New" 
      () 
  :pointer
   () )

; 
;  *  Q3LambertIllumination_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3LambertIllumination_New" 
      () 
  :pointer
   () )

; 
;  *  Q3NULLIllumination_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3NULLIllumination_New" 
      () 
  :pointer
   () )

; *****************************************************************************
;  **                                                                          **
;  **                              Surface Shader                              **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3SurfaceShader_GetType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3SurfaceShader_GetType" 
      ((shader :pointer)) 
  :tq3objecttype
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Texture Shader                               **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3TextureShader_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3TextureShader_New" 
      ((texture :pointer)) 
  :pointer
   () )

; 
;  *  Q3TextureShader_GetTexture()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3TextureShader_GetTexture" 
      ((shader :pointer) (texture (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3TextureShader_SetTexture()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3TextureShader_SetTexture" 
      ((shader :pointer) (texture :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Texture Objects                              **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Texture_GetType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Texture_GetType" 
      ((texture :pointer)) 
  :tq3objecttype
   () )

; 
;  *  Q3Texture_GetWidth()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Texture_GetWidth" 
      ((texture :pointer) (width (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3Texture_GetHeight()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Texture_GetHeight" 
      ((texture :pointer) (height (:pointer :unsigned-long))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Pixmap Texture                               **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3PixmapTexture_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3PixmapTexture_New" 
      ((pixmap (:pointer :tq3storagepixmap))) 
  :pointer
   () )

; 
;  *  Q3PixmapTexture_GetPixmap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3PixmapTexture_GetPixmap" 
      ((texture :pointer) (pixmap (:pointer :tq3storagepixmap))) 
  :tq3status
   () )

; 
;  *  Q3PixmapTexture_SetPixmap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3PixmapTexture_SetPixmap" 
      ((texture :pointer) (pixmap (:pointer :tq3storagepixmap))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Mipmap Texture                               **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3MipmapTexture_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3MipmapTexture_New" 
      ((mipmap (:pointer :tq3mipmap))) 
  :pointer
   () )

; 
;  *  Q3MipmapTexture_GetMipmap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3MipmapTexture_GetMipmap" 
      ((texture :pointer) (mipmap (:pointer :tq3mipmap))) 
  :tq3status
   () )

; 
;  *  Q3MipmapTexture_SetMipmap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3MipmapTexture_SetMipmap" 
      ((texture :pointer) (mipmap (:pointer :tq3mipmap))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                 Compressed Pixmap Texture                                **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3CompressedPixmapTexture_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3CompressedPixmapTexture_New" 
      ((compressedPixmap (:pointer :tq3compressedpixmap))) 
  :pointer
   () )

; 
;  *  Q3CompressedPixmapTexture_GetCompressedPixmap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3CompressedPixmapTexture_GetCompressedPixmap" 
      ((texture :pointer) (compressedPixmap (:pointer :tq3compressedpixmap))) 
  :tq3status
   () )

; 
;  *  Q3CompressedPixmapTexture_SetCompressedPixmap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3CompressedPixmapTexture_SetCompressedPixmap" 
      ((texture :pointer) (compressedPixmap (:pointer :tq3compressedpixmap))) 
  :tq3status
   () )

; 
;  *  Q3CompressedPixmapTexture_CompressImage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3CompressedPixmapTexture_CompressImage" 
      ((compressedPixmap (:pointer :tq3compressedpixmap)) (sourcePixMap (:handle :pixmap)) (CodecType :ostype) (CodecComponent (:pointer :componentrecord)) (codedDepth :signed-integer) (codecQuality :unsigned-long)) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QD3DShaderIncludes

; $ENDC                                         ; __QD3DSHADER__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'QD3DShader)