(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QD3DView.p"
; at Wednesday May 1,2002 2:42:30 pm.
; 
;      File:       QD3DView.p
;  
;      Contains:   View types and routines
;  
;      Version:    Technology: Quickdraw 3D 1.6
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1995-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __QD3DVIEW__
; $SETC __QD3DVIEW__ := 1

; $I+
; $SETC QD3DViewIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __QD3D__
|#

(require-interface 'QD3D)
#|                                              ; $I QD3D.p
 |#                                             ; $ENDC

; $IFC UNDEFINED __QD3DSTYLE__

(require-interface 'QD3DStyle)                  ; $I QD3DStyle.p
; $ENDC
#|                                              ; $IFC UNDEFINED __QD3DSET__
|#

(require-interface 'QD3DSet)
#|                                              ; $I QD3DSet.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN POWER
; $LibExport+

; *****************************************************************************
;  **                                                                          **
;  **                     View Type Definitions                                **
;  **                                                                          **
;  ****************************************************************************

(def-mactype :tq3viewstatus (find-mactype ':signed-long))

(defconstant $kQ3ViewStatusDone 0)
(defconstant $kQ3ViewStatusRetraverse 1)
(defconstant $kQ3ViewStatusError 2)
(defconstant $kQ3ViewStatusCancelled 3)

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                     Default Attribute Set                                **
; 	 **                                                                          **
; 	 ****************************************************************************	

; 	*****************************************************************************
; 	 **                                                                          **
; 	 **                         View Routines                                    **
; 	 **                                                                          **
; 	 ****************************************************************************	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3View_New()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3View_New" 
      () 
  :pointer
   () )

; 
;  *  Q3View_Cancel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_Cancel" 
      ((view :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     View Rendering routines                              **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3View_SetRendererByType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_SetRendererByType" 
      ((view :pointer) (theType :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3View_SetRenderer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_SetRenderer" 
      ((view :pointer) (renderer :pointer)) 
  :tq3status
   () )

; 
;  *  Q3View_GetRenderer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_GetRenderer" 
      ((view :pointer) (renderer (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3View_StartRendering()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_StartRendering" 
      ((view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3View_EndRendering()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_EndRendering" 
      ((view :pointer)) 
  :tq3viewstatus
   () )

; 
;  *  Q3View_Flush()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_Flush" 
      ((view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3View_Sync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_Sync" 
      ((view :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     View/Bounds/Pick routines                            **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3View_StartBoundingBox()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_StartBoundingBox" 
      ((view :pointer) (computeBounds :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3View_EndBoundingBox()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_EndBoundingBox" 
      ((view :pointer) (result (:pointer :tq3boundingbox))) 
  :tq3viewstatus
   () )

; 
;  *  Q3View_StartBoundingSphere()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_StartBoundingSphere" 
      ((view :pointer) (computeBounds :signed-long)) 
  :tq3status
   () )

; 
;  *  Q3View_EndBoundingSphere()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_EndBoundingSphere" 
      ((view :pointer) (result (:pointer :tq3boundingsphere))) 
  :tq3viewstatus
   () )

; 
;  *  Q3View_StartPicking()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_StartPicking" 
      ((view :pointer) (pick :pointer)) 
  :tq3status
   () )

; 
;  *  Q3View_EndPicking()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_EndPicking" 
      ((view :pointer)) 
  :tq3viewstatus
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         View/Camera routines                             **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3View_GetCamera()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_GetCamera" 
      ((view :pointer) (camera (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3View_SetCamera()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_SetCamera" 
      ((view :pointer) (camera :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         View/Lights routines                             **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3View_SetLightGroup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_SetLightGroup" 
      ((view :pointer) (lightGroup :pointer)) 
  :tq3status
   () )

; 
;  *  Q3View_GetLightGroup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_GetLightGroup" 
      ((view :pointer) (lightGroup (:pointer :pointer))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             Idle Method                                  **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  The idle methods allow the application to register callback routines 
;  *  which will be called by the view during especially long operations.
;  *
;  *  The idle methods may also be used to interrupt long renderings or
;  *  traversals.  Inside the idler callback the application can check for
;  *  Command-Period, Control-C or clicking a "Cancel" button or whatever else
;  *  may be used to let the user interrupt rendering.    
;  *
;  *  It is NOT LEGAL to call QD3D routines inside an idler callback.
;  *
;  *  Return kQ3Failure to cancel rendering, kQ3Success to continue. Don't
;  *  bother posting an error.
;  *
;  *  Q3View_SetIdleMethod registers a callback that can be called
;  *  by the system during rendering.  Unfortunately there is no way yet
;  *  to set timer intervals when you want to be called.  Basically, it is
;  *  up to the application's idler callback to check clocks to see if you
;  *  were called back only a millisecond ago or an hour ago!
;  *
;  *  Q3View_SetIdleProgressMethod registers a callback that also gives
;  *  progress information. This information is supplied by the renderer, and
;  *  may or may not be based on real time.
;  *
;  *  If a renderer doesn't support the progress method, your method will be
;  *  called with current == 0 and completed == 0.
;  *  
;  *  Otherwise, you are GUARANTEED to get called at least 2 or more times:
;  *  
;  *  ONCE            idleMethod(view, 0, n)      -> Initialize, Show Dialog
;  *  zero or more    idleMethod(view, 1..n-1, n) -> Update progress
;  *  ONCE            idleMethod(view, n, n)      -> Exit, Hide Dialog
;  *  
;  *  "current" is guaranteed to be less than or equal to "completed"
;  *  "completed" may change values, but current/complete always indicates
;  *  the degree of completion.
;  *
;  *  The calling conventions aid in managing any data associated with a 
;  *  progress user interface indicator.
;  
; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3ViewIdleMethod = FUNCTION(view: TQ3ViewObject; idlerData: UNIV Ptr): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3viewidlemethod (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3ViewIdleProgressMethod = FUNCTION(view: TQ3ViewObject; idlerData: UNIV Ptr; current: UInt32; completed: UInt32): TQ3Status; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3viewidleprogressmethod (find-mactype ':pointer))
; $ENDC

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3View_SetIdleMethod()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3View_SetIdleMethod" 
      ((view :pointer) (idleMethod :pointer) (idleData :pointer)) 
  :tq3status
   () )

; 
;  *  Q3View_SetIdleProgressMethod()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_SetIdleProgressMethod" 
      ((view :pointer) (idleMethod :pointer) (idleData :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                             EndFrame Method                              **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  The end frame method is an alternate way of determining when an
;  *  asynchronous renderer has completed rendering a frame. It differs from
;  *  Q3View_Sync in that notification of the frame completion is the opposite
;  *  direction. 
;  *  
;  *  With Q3View_Sync the application asks a renderer to finish rendering
;  *  a frame, and blocks until the frame is complete.
;  *  
;  *  With the EndFrame method, the renderer tells the application that is has
;  *  completed a frame.
;  *
;  *  If "Q3View_Sync" is called BEFORE this method has been called, this
;  *  method will NOT be called ever.
;  *  
;  *  If "Q3View_Sync" is called AFTER this method has been called, the
;  *  call will return immediately (as the frame has already been completed).
;  
; $ENDC                                         ; CALL_NOT_IN_CARBON

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TQ3ViewEndFrameMethod = PROCEDURE(view: TQ3ViewObject; endFrameData: UNIV Ptr); C;

|#
 |#                                             ; $ELSEC
(def-mactype :tq3viewendframemethod (find-mactype ':pointer))
; $ENDC

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  Q3View_SetEndFrameMethod()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_Q3View_SetEndFrameMethod" 
      ((view :pointer) (endFrame :pointer) (endFrameData :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Push/Pop routines                                **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3Push_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Push_Submit" 
      ((view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Pop_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Pop_Submit" 
      ((view :pointer)) 
  :tq3status
   () )

; 
;  *  Q3Push_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Push_New" 
      () 
  :pointer
   () )

; 
;  *  Q3Pop_New()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3Pop_New" 
      () 
  :pointer
   () )

; 
;  *  Q3StateOperator_Submit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3StateOperator_Submit" 
      ((stateOperator :pointer) (view :pointer)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **     Check if bounding box is visible in the viewing frustum.  Transforms **
;  **     the bbox by the current local_to_world transformation matrix and     **
;  **     does a clip test to see if it lies in the viewing frustum.           **
;  **     This can be used by applications to cull out large chunks of scenes  **
;  **     that are not going to be visible.                                    **
;  **                                                                          **
;  **     The default implementation is to always return kQ3True.  Renderers   **
;  **     may override this routine however to do the checking.                **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3View_IsBoundingBoxVisible()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap-inline "_Q3View_IsBoundingBoxVisible" 
      ((view :pointer) (bbox (:pointer :tq3boundingbox))) 
  :tq3boolean
   () )

; *****************************************************************************
;  **                                                                          **
;  **     Allows display groups to be culled if they are assigned bounding     **
;  **     boxes.                                                               **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3View_AllowAllGroupCulling()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_AllowAllGroupCulling" 
      ((view :pointer) (allowCulling :signed-long)) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         DrawContext routines                             **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3View_SetDrawContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_SetDrawContext" 
      ((view :pointer) (drawContext :pointer)) 
  :tq3status
   () )

; 
;  *  Q3View_GetDrawContext()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_GetDrawContext" 
      ((view :pointer) (drawContext (:pointer :pointer))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Graphics State routines                          **
;  **                                                                          **
;  ** The graphics state routines can only be called while rendering (ie. in   **
;  ** between calls to start and end rendering calls).  If they are called     **
;  ** outside of a rendering loop, they will return with error.                **
;  **                                                                          **
;  ****************************************************************************
; *****************************************************************************
;  **                                                                          **
;  **                         Transform routines                               **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3View_GetLocalToWorldMatrixState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_GetLocalToWorldMatrixState" 
      ((view :pointer) (matrix (:pointer :tq3matrix4x4))) 
  :tq3status
   () )

; 
;  *  Q3View_GetWorldToFrustumMatrixState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_GetWorldToFrustumMatrixState" 
      ((view :pointer) (matrix (:pointer :tq3matrix4x4))) 
  :tq3status
   () )

; 
;  *  Q3View_GetFrustumToWindowMatrixState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_GetFrustumToWindowMatrixState" 
      ((view :pointer) (matrix (:pointer :tq3matrix4x4))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                         Style state routines                             **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3View_GetBackfacingStyleState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_GetBackfacingStyleState" 
      ((view :pointer) (backfacingStyle (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3View_GetInterpolationStyleState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_GetInterpolationStyleState" 
      ((view :pointer) (interpolationType (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3View_GetFillStyleState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_GetFillStyleState" 
      ((view :pointer) (fillStyle (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3View_GetHighlightStyleState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_GetHighlightStyleState" 
      ((view :pointer) (highlightStyle (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3View_GetSubdivisionStyleState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_GetSubdivisionStyleState" 
      ((view :pointer) (subdivisionStyle (:pointer :tq3subdivisionstyledata))) 
  :tq3status
   () )

; 
;  *  Q3View_GetOrientationStyleState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_GetOrientationStyleState" 
      ((view :pointer) (fontFacingDirectionStyle (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3View_GetReceiveShadowsStyleState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_GetReceiveShadowsStyleState" 
      ((view :pointer) (receives (:pointer :signed-long))) 
  :tq3status
   () )

; 
;  *  Q3View_GetPickIDStyleState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_GetPickIDStyleState" 
      ((view :pointer) (pickIDStyle (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3View_GetPickPartsStyleState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_GetPickPartsStyleState" 
      ((view :pointer) (pickPartsStyle (:pointer :unsigned-long))) 
  :tq3status
   () )

; 
;  *  Q3View_GetAntiAliasStyleState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_GetAntiAliasStyleState" 
      ((view :pointer) (antiAliasData (:pointer :tq3antialiasstyledata))) 
  :tq3status
   () )

; *****************************************************************************
;  **                                                                          **
;  **                     Attribute state routines                             **
;  **                                                                          **
;  ****************************************************************************
; 
;  *  Q3View_GetDefaultAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_GetDefaultAttributeSet" 
      ((view :pointer) (attributeSet (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3View_SetDefaultAttributeSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_SetDefaultAttributeSet" 
      ((view :pointer) (attributeSet :pointer)) 
  :tq3status
   () )

; 
;  *  Q3View_GetAttributeSetState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_GetAttributeSetState" 
      ((view :pointer) (attributeSet (:pointer :pointer))) 
  :tq3status
   () )

; 
;  *  Q3View_GetAttributeState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_Q3View_GetAttributeState" 
      ((view :pointer) (attributeType :signed-long) (data :pointer)) 
  :tq3status
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QD3DViewIncludes

; $ENDC                                         ; __QD3DVIEW__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'QD3DView)