(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QuickTimeMusic.p"
; at Wednesday May 1,2002 2:41:56 pm.
; 
;      File:       QuickTimeMusic.p
;  
;      Contains:   QuickTime Interfaces.
;  
;      Version:    Technology: QuickTime 5.0.1
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1990-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __QUICKTIMEMUSIC__
; $SETC __QUICKTIMEMUSIC__ := 1

; $I+
; $SETC QuickTimeMusicIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __COMPONENTS__
|#

(require-interface 'Components)
#|                                              ; $I Components.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKDRAW__
|#

(require-interface 'Quickdraw)
#|                                              ; $I Quickdraw.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __VIDEO__
|#

(require-interface 'Video)
#|                                              ; $I Video.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACMEMORY__
|#

(require-interface 'MacMemory)
#|                                              ; $I MacMemory.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __SOUND__
|#

(require-interface 'Sound)
#|                                              ; $I Sound.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __ENDIAN__
|#

(require-interface 'Endian)
#|                                              ; $I Endian.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __IMAGECOMPRESSION__
|#

(require-interface 'ImageCompression)
#|                                              ; $I ImageCompression.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MOVIES__
|#

(require-interface 'Movies)
#|                                              ; $I Movies.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $kaiToneDescType :|tone|)
(defconstant $kaiNoteRequestInfoType :|ntrq|)
(defconstant $kaiKnobListType :|knbl|)
(defconstant $kaiKeyRangeInfoType :|sinf|)
(defconstant $kaiSampleDescType :|sdsc|)
(defconstant $kaiSampleInfoType :|smin|)
(defconstant $kaiSampleDataType :|sdat|)
(defconstant $kaiSampleDataQUIDType :|quid|)
(defconstant $kaiInstInfoType :|iinf|)
(defconstant $kaiPictType :|pict|)
(defconstant $kaiWriterType :|wrt|)
(defconstant $kaiCopyrightType :|cpy|)
(defconstant $kaiOtherStrType :|str |)
(defconstant $kaiInstrumentRefType :|iref|)
(defconstant $kaiInstGMQualityType :|qual|)
(defconstant $kaiLibraryInfoType :|linf|)
(defconstant $kaiLibraryDescType :|ldsc|)

(def-mactype :instlibdescrecptr (find-mactype '(:pointer :instlibdescrec)))
(defrecord InstLibDescRec 
   (libIDName (:string 31))
   )

(def-mactype :instknobrecptr (find-mactype '(:pointer :instknobrec)))
(defrecord InstKnobRec 
   (number :signed-long)
   (value :signed-long)
   )

(defconstant $kInstKnobMissingUnknown 0)
(defconstant $kInstKnobMissingDefault #x1)

(def-mactype :instknoblistptr (find-mactype '(:pointer :instknoblist)))
(defrecord InstKnobList 
   (knobCount :signed-long)
   (knobFlags :signed-long)
   (knob (:array :instknobrec 1))
   )

(defconstant $kMusicLoopTypeNormal 0)
(defconstant $kMusicLoopTypePalindrome 1)       ;   back & forth 

(defconstant $instSamplePreProcessFlag #x1)

(def-mactype :instsampledescrecptr (find-mactype '(:pointer :instsampledescrec)))
(defrecord InstSampleDescRec 
   (dataFormat :ostype)
   ;;Changing field numchannels from signed-integer to unsigned-word to match C header (educated-guess)
   (numChannels :unsigned-word)
   ;;Changing field samplesize from signed-integer to unsigned-word to match C header (pretty-sure)
   (sampleSize :unsigned-word)
   (sampleRate :unsigned-long)
   (sampleDataID :signed-integer)
   (offset :signed-long)                        ;   offset within SampleData - this could be just for internal use 
   (numSamples :signed-long)                    ;   this could also just be for internal use, we'll see 
   (loopType :signed-long)
   (loopStart :signed-long)
   (loopEnd :signed-long)
   (pitchNormal :signed-long)
   (pitchLow :signed-long)
   (pitchHigh :signed-long)
   )

(def-mactype :atomicinstrument (find-mactype ':handle))
(def-mactype :atomicinstrumentptr (find-mactype ':pointer))

(defconstant $kQTMIDIComponentType :|midi|)

(defconstant $kOMSComponentSubType :|OMS |)
(defconstant $kFMSComponentSubType :|FMS |)
(defconstant $kMIDIManagerComponentSubType :|mmgr|)
(defconstant $kOSXMIDIComponentSubType :|osxm|)

(def-mactype :qtmidicomponent (find-mactype '(:pointer :componentinstancerecord)))

(defconstant $kMusicPacketPortLost 1)           ;   received when application loses the default input port  
(defconstant $kMusicPacketPortFound 2)          ;   received when application gets it back out from under someone else's claim  
(defconstant $kMusicPacketTimeGap 3)            ;   data[0] = number of milliseconds to keep the MIDI line silent  

(defconstant $kAppleSysexID #x11)               ;   apple sysex is followed by 2-byte command. 0001 is the command for samplesize  
(defconstant $kAppleSysexCmdSampleSize #x1)     ;   21 bit number in 3 midi bytes follows sysex ID and 2 cmd bytes  
(defconstant $kAppleSysexCmdSampleBreak #x2)    ;   specifies that the sample should break right here  
(defconstant $kAppleSysexCmdAtomicInstrument #x10);   contents of atomic instrument handle  
(defconstant $kAppleSysexCmdDeveloper #x7F00)   ;   F0 11 7F 00 ww xx yy zz ... F7 is available for non-Apple developers, where wxyz is unique app signature with 8th bit cleared, unique to developer, and 00 and 7f are reserved  

(def-mactype :musicmidipacketptr (find-mactype '(:pointer :musicmidipacket)))
(defrecord MusicMIDIPacket 
   (length :unsigned-integer)
   (reserved :unsigned-long)                    ;   if length zero, then reserved = above enum  
   (data (:array :unsigned-byte 249 :packed))
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	MusicMIDISendProcPtr = FUNCTION(self: ComponentInstance; refCon: LONGINT; VAR mmp: MusicMIDIPacket): ComponentResult;

|#
 |#                                             ; $ELSEC
(def-mactype :musicmidisendprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :musicmidisendupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :musicmidisendupp (find-mactype ':pointer))
; $ENDC

(defconstant $kSynthesizerConnectionFMS 1)      ;   this connection imported from FMS  
(defconstant $kSynthesizerConnectionMMgr 2)     ;   this connection imported from the MIDI Mgr  
(defconstant $kSynthesizerConnectionOMS 4)      ;   this connection imported from OMS  
(defconstant $kSynthesizerConnectionQT 8)       ;   this connection is a QuickTime-only port  
(defconstant $kSynthesizerConnectionOSXMIDI 16) ;   this connection is an OS X CoreMIDI port  
;   lowest five bits are mutually exclusive; combinations reserved for future use. 
(defconstant $kSynthesizerConnectionUnavailable 256);   port exists, but cannot be used just now  

; 	
; 	    The sampleBankFile field of this structure can be used to pass in a pointer to an FSSpec
; 	    that specifies a SoundFont 2 or DLS file (otherwise set it to NULL ).
; 	    
; 	    You then pass in a structure with this field set (all other fields should be zero) to
; 	    NARegisterMusicDevice:
; 	        - with synthType as kSoftSynthComponentSubType 
; 	        - with name being used to return to the application the "name" of the synth 
; 	        that should be used in the synthesiserName field of the ToneDescription structure
; 	        and is also used to retrieve a particular MusicComponent with the
; 	        NAGetRegisteredMusicDevice call
; 	    
; 	    This call will create a MusicComponent of kSoftSynthComponentSubType, with the specified
; 	    sound bank as the sample data source.
; 	
; 	    This field requires QuickTime 5.0 or later and should be set to NULL for prior versions.
; 		

(def-mactype :synthesizerconnectionsptr (find-mactype '(:pointer :synthesizerconnections)))
(defrecord SynthesizerConnections 
   (clientID :ostype)
   (inputPortID :ostype)                        ;   terminology death: this port is used to SEND to the midi synth  
   (outputPortID :ostype)                       ;   terminology death: this port receives from a keyboard or other control device  
   (midiChannel :signed-long)                   ;   The system channel; others are configurable (or the nubus slot number)  
   (flags :signed-long)
   (unique :signed-long)                        ;   unique id may be used instead of index, to getinfo and unregister calls  
   (sampleBankFile (:pointer :fsspec))          ;   see notes above  
   (reserved2 :signed-long)                     ;   should be zero  
   )

(def-mactype :qtmidiportptr (find-mactype '(:pointer :qtmidiport)))
(defrecord QTMIDIPort 
   (portConnections :synthesizerconnections)
   (portName (:string 63))
   )

(def-mactype :qtmidiportlistptr (find-mactype '(:pointer :qtmidiportlist)))
(defrecord QTMIDIPortList 
   (portCount :signed-integer)
   (port (:array :qtmidiport 1))
   )

(def-mactype :qtmidiportlisthandle (find-mactype '(:handle :qtmidiportlist)))
; 
; 	 *  QTMIDIGetMIDIPorts()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 *    Windows:          in qtmlClient.lib 3.0 and later
; 	 	

(deftrap "_QTMIDIGetMIDIPorts" 
      ((ci (:pointer :componentinstancerecord)) (inputPorts (:pointer (:handle :qtmidiportlist))) (outputPorts (:pointer (:handle :qtmidiportlist))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci inputPorts outputPorts ((+ (ash 8 16) 1) :signed-longint)))

; 
;  *  QTMIDIUseSendPort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_QTMIDIUseSendPort" 
      ((ci (:pointer :componentinstancerecord)) (portIndex :signed-long) (inUse :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci portIndex inUse ((+ (ash 8 16) 2) :signed-longint)))

; 
;  *  QTMIDISendMIDI()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_QTMIDISendMIDI" 
      ((ci (:pointer :componentinstancerecord)) (portIndex :signed-long) (mp (:pointer :musicmidipacket)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ci portIndex mp ((+ (ash 8 16) 3) :signed-longint)))

(defconstant $kMusicComponentType :|musi|)
(defconstant $kInstrumentComponentType :|inst|)

(defconstant $kSoftSynthComponentSubType :|ss  |)
(defconstant $kGMSynthComponentSubType :|gm  |)

(def-mactype :musiccomponent (find-mactype '(:pointer :componentinstancerecord)))
;   MusicSynthesizerFlags 

(defconstant $kSynthesizerDynamicVoice #x1)     ;   can assign voices on the fly (else, polyphony is very important  
(defconstant $kSynthesizerUsesMIDIPort #x2)     ;   must be patched through MIDI Manager  
(defconstant $kSynthesizerMicrotone #x4)        ;   can play microtonal scales  
(defconstant $kSynthesizerHasSamples #x8)       ;   synthesizer has some use for sampled data  
(defconstant $kSynthesizerMixedDrums #x10)      ;   any part can play drum parts, total = instrument parts  
(defconstant $kSynthesizerSoftware #x20)        ;   implemented in main CPU software == uses cpu cycles  
(defconstant $kSynthesizerHardware #x40)        ;   is a hardware device (such as nubus, or maybe DSP?)  
(defconstant $kSynthesizerDynamicChannel #x80)  ;   can move any part to any channel or disable each part. (else we assume it lives on all channels in masks)  
(defconstant $kSynthesizerHogsSystemChannel #x100);   can be channelwise dynamic, but always responds on its system channel  
(defconstant $kSynthesizerHasSystemChannel #x200);   has some "system channel" notion to distinguish it from multiple instances of the same device (GM devices dont)  
(defconstant $kSynthesizerSlowSetPart #x400)    ;   SetPart() and SetPartInstrumentNumber() calls do not have rapid response, may glitch notes  
(defconstant $kSynthesizerOffline #x1000)       ;   can enter an offline synthesis mode  
(defconstant $kSynthesizerGM #x4000)            ;   synth is a GM device  
(defconstant $kSynthesizerDLS #x8000)           ;   synth supports DLS level 1  
(defconstant $kSynthesizerSoundLocalization #x10000);   synth supports extremely baroque, nonstandard, and proprietary "apple game sprockets" localization parameter set  

; 	
; 	 * Note that these controller numbers
; 	 * are _not_ identical to the MIDI controller numbers.
; 	 * These are _signed_ 8.8 values, and the LSB's are
; 	 * always sent to a MIDI device. Controllers 32-63 are
; 	 * reserved (for MIDI, they are LSB's for 0-31, but we
; 	 * always send both).
; 	 *
; 	 * The full range, therefore, is -128.00 to 127.7f.
; 	 *
; 	 * _Excepting_ _volume_, all controls default to zero.
; 	 *
; 	 * Pitch bend is specified in fractional semitones! No
; 	 * more "pitch bend range" nonsense. You can bend as far
; 	 * as you want, any time you want.
; 	 	

(def-mactype :musiccontroller (find-mactype ':signed-long))

(defconstant $kControllerModulationWheel 1)
(defconstant $kControllerBreath 2)
(defconstant $kControllerFoot 4)
(defconstant $kControllerPortamentoTime 5)      ;   time in 8.8 seconds, portamento on/off is omitted, 0 time = 'off'  
(defconstant $kControllerVolume 7)              ;   main volume control  
(defconstant $kControllerBalance 8)
(defconstant $kControllerPan 10)                ;   0 - "default", 1 - n: positioned in output 1-n (incl fractions)  
(defconstant $kControllerExpression 11)         ;   secondary volume control  
(defconstant $kControllerLever1 16)             ;   general purpose controllers  
(defconstant $kControllerLever2 17)             ;   general purpose controllers  
(defconstant $kControllerLever3 18)             ;   general purpose controllers  
(defconstant $kControllerLever4 19)             ;   general purpose controllers  
(defconstant $kControllerLever5 80)             ;   general purpose controllers  
(defconstant $kControllerLever6 81)             ;   general purpose controllers  
(defconstant $kControllerLever7 82)             ;   general purpose controllers  
(defconstant $kControllerLever8 83)             ;   general purpose controllers  
(defconstant $kControllerPitchBend 32)          ;   positive & negative semitones, with 8 bits fraction, same units as transpose controllers 
(defconstant $kControllerAfterTouch 33)         ;   aka channel pressure  
(defconstant $kControllerPartTranspose 40)      ;   identical to pitchbend, for overall part xpose  
(defconstant $kControllerTuneTranspose 41)      ;   another pitchbend, for "song global" pitch offset  
(defconstant $kControllerPartVolume 42)         ;   another volume control, passed right down from note allocator part volume  
(defconstant $kControllerTuneVolume 43)         ;   another volume control, used for "song global" volume - since we share one synthesizer across multiple tuneplayers 
(defconstant $kControllerSustain 64)            ;   boolean - positive for on, 0 or negative off  
(defconstant $kControllerPortamento 65)         ;   boolean 
(defconstant $kControllerSostenuto 66)          ;   boolean  
(defconstant $kControllerSoftPedal 67)          ;   boolean  
(defconstant $kControllerReverb 91)
(defconstant $kControllerTremolo 92)
(defconstant $kControllerChorus 93)
(defconstant $kControllerCeleste 94)
(defconstant $kControllerPhaser 95)
(defconstant $kControllerEditPart 113)          ;   last 16 controllers 113-128 and above are global controllers which respond on part zero  
(defconstant $kControllerMasterTune 114)
(defconstant $kControllerMasterTranspose 114)   ;   preferred 
(defconstant $kControllerMasterVolume 115)
(defconstant $kControllerMasterCPULoad 116)
(defconstant $kControllerMasterPolyphony 117)
(defconstant $kControllerMasterFeatures 118)

;   ID's of knobs supported by the QuickTime Music Synthesizer built into QuickTime 

(defconstant $kQTMSKnobStartID #x2000000)
(defconstant $kQTMSKnobVolumeAttackTimeID #x2000001)
(defconstant $kQTMSKnobVolumeDecayTimeID #x2000002)
(defconstant $kQTMSKnobVolumeSustainLevelID #x2000003)
(defconstant $kQTMSKnobVolumeRelease1RateID #x2000004)
(defconstant $kQTMSKnobVolumeDecayKeyScalingID #x2000005)
(defconstant $kQTMSKnobVolumeReleaseTimeID #x2000006)
(defconstant $kQTMSKnobVolumeLFODelayID #x2000007)
(defconstant $kQTMSKnobVolumeLFORampTimeID #x2000008)
(defconstant $kQTMSKnobVolumeLFOPeriodID #x2000009)
(defconstant $kQTMSKnobVolumeLFOShapeID #x200000A)
(defconstant $kQTMSKnobVolumeLFODepthID #x200000B)
(defconstant $kQTMSKnobVolumeOverallID #x200000C)
(defconstant $kQTMSKnobVolumeVelocity127ID #x200000D)
(defconstant $kQTMSKnobVolumeVelocity96ID #x200000E)
(defconstant $kQTMSKnobVolumeVelocity64ID #x200000F)
(defconstant $kQTMSKnobVolumeVelocity32ID #x2000010)
(defconstant $kQTMSKnobVolumeVelocity16ID #x2000011);   Pitch related knobs 
(defconstant $kQTMSKnobPitchTransposeID #x2000012)
(defconstant $kQTMSKnobPitchLFODelayID #x2000013)
(defconstant $kQTMSKnobPitchLFORampTimeID #x2000014)
(defconstant $kQTMSKnobPitchLFOPeriodID #x2000015)
(defconstant $kQTMSKnobPitchLFOShapeID #x2000016)
(defconstant $kQTMSKnobPitchLFODepthID #x2000017)
(defconstant $kQTMSKnobPitchLFOQuantizeID #x2000018);   Stereo related knobs 
(defconstant $kQTMSKnobStereoDefaultPanID #x2000019)
(defconstant $kQTMSKnobStereoPositionKeyScalingID #x200001A)
(defconstant $kQTMSKnobPitchLFOOffsetID #x200001B)
(defconstant $kQTMSKnobExclusionGroupID #x200001C);   Misc knobs, late additions 
(defconstant $kQTMSKnobSustainTimeID #x200001D)
(defconstant $kQTMSKnobSustainInfiniteID #x200001E)
(defconstant $kQTMSKnobVolumeLFOStereoID #x200001F)
(defconstant $kQTMSKnobVelocityLowID #x2000020)
(defconstant $kQTMSKnobVelocityHighID #x2000021)
(defconstant $kQTMSKnobVelocitySensitivityID #x2000022)
(defconstant $kQTMSKnobPitchSensitivityID #x2000023)
(defconstant $kQTMSKnobVolumeLFODepthFromWheelID #x2000024)
(defconstant $kQTMSKnobPitchLFODepthFromWheelID #x2000025);   Volume Env again 
(defconstant $kQTMSKnobVolumeExpOptionsID #x2000026);   Env1 
(defconstant $kQTMSKnobEnv1AttackTimeID #x2000027)
(defconstant $kQTMSKnobEnv1DecayTimeID #x2000028)
(defconstant $kQTMSKnobEnv1SustainLevelID #x2000029)
(defconstant $kQTMSKnobEnv1SustainTimeID #x200002A)
(defconstant $kQTMSKnobEnv1SustainInfiniteID #x200002B)
(defconstant $kQTMSKnobEnv1ReleaseTimeID #x200002C)
(defconstant $kQTMSKnobEnv1ExpOptionsID #x200002D);   Env2 
(defconstant $kQTMSKnobEnv2AttackTimeID #x200002E)
(defconstant $kQTMSKnobEnv2DecayTimeID #x200002F)
(defconstant $kQTMSKnobEnv2SustainLevelID #x2000030)
(defconstant $kQTMSKnobEnv2SustainTimeID #x2000031)
(defconstant $kQTMSKnobEnv2SustainInfiniteID #x2000032)
(defconstant $kQTMSKnobEnv2ReleaseTimeID #x2000033)
(defconstant $kQTMSKnobEnv2ExpOptionsID #x2000034);   Pitch Env 
(defconstant $kQTMSKnobPitchEnvelopeID #x2000035)
(defconstant $kQTMSKnobPitchEnvelopeDepthID #x2000036);   Filter 
(defconstant $kQTMSKnobFilterKeyFollowID #x2000037)
(defconstant $kQTMSKnobFilterTransposeID #x2000038)
(defconstant $kQTMSKnobFilterQID #x2000039)
(defconstant $kQTMSKnobFilterFrequencyEnvelopeID #x200003A)
(defconstant $kQTMSKnobFilterFrequencyEnvelopeDepthID #x200003B)
(defconstant $kQTMSKnobFilterQEnvelopeID #x200003C)
(defconstant $kQTMSKnobFilterQEnvelopeDepthID #x200003D);   Reverb Threshhold 
(defconstant $kQTMSKnobReverbThresholdID #x200003E)
(defconstant $kQTMSKnobVolumeAttackVelScalingID #x200003F)
(defconstant $kQTMSKnobLastIDPlus1 #x2000040)

(defconstant $kControllerMaximum #x7FFF)        ;   +01111111.11111111  
(defconstant $kControllerMinimum #xFFFF8000)    ;   -10000000.00000000  

(def-mactype :synthesizerdescriptionptr (find-mactype '(:pointer :synthesizerdescription)))
(defrecord SynthesizerDescription 
   (synthesizerType :ostype)                    ;   synthesizer type (must be same as component subtype)  
   (name (:string 31))                          ;   text name of synthesizer type  
   (flags :unsigned-long)                       ;   from the above enum  
   (voiceCount :unsigned-long)                  ;   maximum polyphony  
   (partCount :unsigned-long)                   ;   maximum multi-timbrality (and midi channels)  
   (instrumentCount :unsigned-long)             ;   non gm, built in (rom) instruments only  
   (modifiableInstrumentCount :unsigned-long)   ;   plus n-more are user modifiable  
   (channelMask :unsigned-long)                 ;   (midi device only) which channels device always uses  
   (drumPartCount :unsigned-long)               ;   maximum multi-timbrality of drum parts  
   (drumCount :unsigned-long)                   ;   non gm, built in (rom) drumkits only  
   (modifiableDrumCount :unsigned-long)         ;   plus n-more are user modifiable  
   (drumChannelMask :unsigned-long)             ;   (midi device only) which channels device always uses  
   (outputCount :unsigned-long)                 ;   number of audio outputs (usually two)  
   (latency :unsigned-long)                     ;   response time in Sec  
   (controllers (:array :unsigned-long 4))      ;   array of 128 bits  
   (gmInstruments (:array :unsigned-long 4))    ;   array of 128 bits  
   (gmDrums (:array :unsigned-long 4))          ;   array of 128 bits  
   )

(defconstant $kVoiceCountDynamic -1)            ;   constant to use to specify dynamic voicing  

(def-mactype :tonedescriptionptr (find-mactype '(:pointer :tonedescription)))
(defrecord ToneDescription 
   (synthesizerType :ostype)                    ;   synthesizer type  
   (synthesizerName (:string 31))               ;   name of instantiation of synth  
   (instrumentName (:string 31))                ;   preferred name for human use  
   (instrumentNumber :signed-long)              ;   inst-number used if synth-name matches  
   (gmNumber :signed-long)                      ;   Best matching general MIDI number  
   )

(defconstant $kFirstGMInstrument #x1)
(defconstant $kLastGMInstrument #x80)
(defconstant $kFirstGSInstrument #x81)
(defconstant $kLastGSInstrument #x3FFF)
(defconstant $kFirstDrumkit #x4000)             ;   (first value is "no drum". instrument numbers from 16384->16384+128 are drumkits, and for GM they are _defined_ drumkits!  
(defconstant $kLastDrumkit #x4080)
(defconstant $kFirstROMInstrument #x8000)
(defconstant $kLastROMInstrument #xFFFF)
(defconstant $kFirstUserInstrument #x10000)
(defconstant $kLastUserInstrument #x1FFFF)

;   InstrumentMatch 
(defconstant $kInstrumentMatchSynthesizerType 1)
(defconstant $kInstrumentMatchSynthesizerName 2)
(defconstant $kInstrumentMatchName 4)
(defconstant $kInstrumentMatchNumber 8)
(defconstant $kInstrumentMatchGMNumber 16)
(defconstant $kInstrumentMatchGSNumber 32)

;   KnobFlags 
(defconstant $kKnobBasic 8)                     ;   knob shows up in certain simplified lists of knobs  
(defconstant $kKnobReadOnly 16)                 ;   knob value cannot be changed by user or with a SetKnob call  
(defconstant $kKnobInterruptUnsafe 32)          ;   only alter this knob from foreground task time (may access toolbox)  
(defconstant $kKnobKeyrangeOverride 64)         ;   knob can be overridden within a single keyrange (software synth only)  
(defconstant $kKnobGroupStart 128)              ;   knob is first in some logical group of knobs  
(defconstant $kKnobFixedPoint8 1024)
(defconstant $kKnobFixedPoint16 2048)           ;   One of these may be used at a time.  
(defconstant $kKnobTypeNumber #x0)
(defconstant $kKnobTypeGroupName #x1000)        ;   "knob" is really a group name for display purposes  
(defconstant $kKnobTypeBoolean #x2000)          ;   if range is greater than 1, its a multi-checkbox field  
(defconstant $kKnobTypeNote #x3000)             ;   knob range is equivalent to MIDI keys  
(defconstant $kKnobTypePan #x4000)              ;   range goes left/right (lose this? )  
(defconstant $kKnobTypeInstrument #x5000)       ;   knob value = reference to another instrument number  
(defconstant $kKnobTypeSetting #x6000)          ;   knob value is 1 of n different things (eg, fm algorithms) popup menu  
(defconstant $kKnobTypeMilliseconds #x7000)     ;   knob is a millisecond time range  
(defconstant $kKnobTypePercentage #x8000)       ;   knob range is displayed as a Percentage  
(defconstant $kKnobTypeHertz #x9000)            ;   knob represents frequency  
(defconstant $kKnobTypeButton #xA000)           ;   momentary trigger push button  

(defconstant $kUnknownKnobValue #x7FFFFFFF)     ;   a knob with this value means, we don't know it.  
(defconstant $kDefaultKnobValue #x7FFFFFFE)     ;   used to SET a knob to its default value.  

(def-mactype :knobdescriptionptr (find-mactype '(:pointer :knobdescription)))
(defrecord KnobDescription 
   (name (:string 63))
   (lowValue :signed-long)
   (highValue :signed-long)
   (defaultValue :signed-long)                  ;   a default instrument is made of all default values  
   (flags :signed-long)
   (knobID :signed-long)
   )

(def-mactype :gcinstrumentdataptr (find-mactype '(:pointer :gcinstrumentdata)))
(defrecord GCInstrumentData 
   (tone :tonedescription)
   (knobCount :signed-long)
   (knob (:array :signed-long 1))
   )

(def-mactype :gcinstrumentdatahandle (find-mactype '(:handle :gcinstrumentdata)))
(def-mactype :instrumentaboutinfoptr (find-mactype '(:pointer :instrumentaboutinfo)))
(defrecord InstrumentAboutInfo 
   (p (:handle :picture))
   (author (:string 255))
   (copyright (:string 255))
   (other (:string 255))
   )

(defconstant $notImplementedMusicErr #x8000F7E9)
(defconstant $cantSendToSynthesizerErr #x8000F7E8)
(defconstant $cantReceiveFromSynthesizerErr #x8000F7E7)
(defconstant $illegalVoiceAllocationErr #x8000F7E6)
(defconstant $illegalPartErr #x8000F7E5)
(defconstant $illegalChannelErr #x8000F7E4)
(defconstant $illegalKnobErr #x8000F7E3)
(defconstant $illegalKnobValueErr #x8000F7E2)
(defconstant $illegalInstrumentErr #x8000F7E1)
(defconstant $illegalControllerErr #x8000F7E0)
(defconstant $midiManagerAbsentErr #x8000F7DF)
(defconstant $synthesizerNotRespondingErr #x8000F7DE)
(defconstant $synthesizerErr #x8000F7DD)
(defconstant $illegalNoteChannelErr #x8000F7DC)
(defconstant $noteChannelNotAllocatedErr #x8000F7DB)
(defconstant $tunePlayerFullErr #x8000F7DA)
(defconstant $tuneParseErr #x8000F7D9)

(defconstant $kGetAtomicInstNoExpandedSamples #x1)
(defconstant $kGetAtomicInstNoOriginalSamples #x2)
(defconstant $kGetAtomicInstNoSamples #x3)
(defconstant $kGetAtomicInstNoKnobList #x4)
(defconstant $kGetAtomicInstNoInstrumentInfo #x8)
(defconstant $kGetAtomicInstOriginalKnobList #x10)
(defconstant $kGetAtomicInstAllKnobs #x20)      ;   return even those that are set to default 

; 
; 	   For non-gm instruments, instrument number of tone description == 0
; 	   If you want to speed up while running, slam the inst num with what Get instrument number returns
; 	   All missing knobs are slammed to the default value
; 	
(defconstant $kSetAtomicInstKeepOriginalInstrument #x1)
(defconstant $kSetAtomicInstShareAcrossParts #x2);   inst disappears when app goes away 
(defconstant $kSetAtomicInstCallerTosses #x4)   ;   the caller isn't keeping a copy around (for NASetAtomicInstrument) 
(defconstant $kSetAtomicInstCallerGuarantees #x8);   the caller guarantees a copy is around 
(defconstant $kSetAtomicInstInterruptSafe #x10) ;   dont move memory at this time (but process at next task time) 
(defconstant $kSetAtomicInstDontPreprocess #x80);   perform no further preprocessing because either 1)you know the instrument is digitally clean, or 2) you got it from a GetPartAtomic 

(defconstant $kInstrumentNamesModifiable 1)
(defconstant $kInstrumentNamesBoth 2)

; 	
; 	 * Structures specific to the GenericMusicComponent
; 	 	

(defconstant $kGenericMusicComponentSubtype :|gene|)

(def-mactype :genericknobdescriptionptr (find-mactype '(:pointer :genericknobdescription)))
(defrecord GenericKnobDescription 
   (kd :knobdescription)
   (hw1 :signed-long)                           ;   driver defined  
   (hw2 :signed-long)                           ;   driver defined  
   (hw3 :signed-long)                           ;   driver defined  
   (settingsID :signed-long)                    ;   resource ID list for boolean and popup names  
   )

(def-mactype :genericknobdescriptionlistptr (find-mactype '(:pointer :genericknobdescriptionlist)))
(defrecord GenericKnobDescriptionList 
   (knobCount :signed-long)
   (knob (:array :genericknobdescription 1))
   )

(def-mactype :genericknobdescriptionlisthandle (find-mactype '(:handle :genericknobdescriptionlist)))
; 	 knobTypes for MusicDerivedSetKnob 	

(defconstant $kGenericMusicKnob 1)
(defconstant $kGenericMusicInstrumentKnob 2)
(defconstant $kGenericMusicDrumKnob 3)
(defconstant $kGenericMusicGlobalController 4)

(defconstant $kGenericMusicResFirst 0)
(defconstant $kGenericMusicResMiscStringList 1) ;   STR# 1: synth name, 2:about author,3:aboutcopyright,4:aboutother  
(defconstant $kGenericMusicResMiscLongList 2)   ;   Long various params, see list below  
(defconstant $kGenericMusicResInstrumentList 3) ;   NmLs of names and shorts, categories prefixed by ''  
(defconstant $kGenericMusicResDrumList 4)       ;   NmLs of names and shorts  
(defconstant $kGenericMusicResInstrumentKnobDescriptionList 5);   Knob  
(defconstant $kGenericMusicResDrumKnobDescriptionList 6);   Knob  
(defconstant $kGenericMusicResKnobDescriptionList 7);   Knob  
(defconstant $kGenericMusicResBitsLongList 8)   ;   Long back to back bitmaps of controllers, gminstruments, and drums  
(defconstant $kGenericMusicResModifiableInstrumentHW 9);   Shrt same as the hw shorts trailing the instrument names, a shortlist  
(defconstant $kGenericMusicResGMTranslation 10) ;   Long 128 long entries, 1 for each gm inst, of local instrument numbers 1-n (not hw numbers)  
(defconstant $kGenericMusicResROMInstrumentData 11);   knob lists for ROM instruments, so the knob values may be known  
(defconstant $kGenericMusicResAboutPICT 12)     ;   picture for aboutlist. must be present for GetAbout call to work  
(defconstant $kGenericMusicResLast 13)

; 	 elements of the misc long list 	
(defconstant $kGenericMusicMiscLongFirst 0)
(defconstant $kGenericMusicMiscLongVoiceCount 1)
(defconstant $kGenericMusicMiscLongPartCount 2)
(defconstant $kGenericMusicMiscLongModifiableInstrumentCount 3)
(defconstant $kGenericMusicMiscLongChannelMask 4)
(defconstant $kGenericMusicMiscLongDrumPartCount 5)
(defconstant $kGenericMusicMiscLongModifiableDrumCount 6)
(defconstant $kGenericMusicMiscLongDrumChannelMask 7)
(defconstant $kGenericMusicMiscLongOutputCount 8)
(defconstant $kGenericMusicMiscLongLatency 9)
(defconstant $kGenericMusicMiscLongFlags 10)
(defconstant $kGenericMusicMiscLongFirstGMHW 11);   number to add to locate GM main instruments  
(defconstant $kGenericMusicMiscLongFirstGMDrumHW 12);   number to add to locate GM drumkits  
(defconstant $kGenericMusicMiscLongFirstUserHW 13);   First hw number of user instruments (presumed sequential)  
(defconstant $kGenericMusicMiscLongLast 14)

(def-mactype :gcpartptr (find-mactype '(:pointer :gcpart)))
(defrecord GCPart 
   (hwInstrumentNumber :signed-long)            ;   internal number of recalled instrument  
   (controller (:array :signed-integer 128))    ;   current values for all controllers  
   (volume :signed-long)                        ;   ctrl 7 is special case  
   (polyphony :signed-long)
   (midiChannel :signed-long)                   ;   1-16 if in use  
   (id :gcinstrumentdata)                       ;   ToneDescription & knoblist, uncertain length  
   )

; 	
; 	 * Calls specific to the GenericMusicComponent
; 	 	

(defconstant $kMusicGenericRange #x100)
(defconstant $kMusicDerivedRange #x200)

; 	
; 	 * Flags in GenericMusicConfigure call
; 	 	
(defconstant $kGenericMusicDoMIDI #x1)          ;   implement normal MIDI messages for note, controllers, and program changes 0-127  
(defconstant $kGenericMusicBank0 #x2)           ;   implement instrument bank changes on controller 0  
(defconstant $kGenericMusicBank32 #x4)          ;   implement instrument bank changes on controller 32  
(defconstant $kGenericMusicErsatzMIDI #x8)      ;   construct MIDI packets, but send them to the derived component  
(defconstant $kGenericMusicCallKnobs #x10)      ;   call the derived component with special knob format call  
(defconstant $kGenericMusicCallParts #x20)      ;   call the derived component with special part format call  
(defconstant $kGenericMusicCallInstrument #x40) ;   call MusicDerivedSetInstrument for MusicSetInstrument calls  
(defconstant $kGenericMusicCallNumber #x80)     ;   call MusicDerivedSetPartInstrumentNumber for MusicSetPartInstrumentNumber calls, & don't send any C0 or bank stuff  
(defconstant $kGenericMusicCallROMInstrument #x100);   call MusicSetInstrument for MusicSetPartInstrumentNumber for "ROM" instruments, passing params from the ROMi resource  
(defconstant $kGenericMusicAllDefaults #x200)   ;   indicates that when a new instrument is recalled, all knobs are reset to DEFAULT settings. True for GS modules  

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	MusicOfflineDataProcPtr = FUNCTION(SoundData: Ptr; numBytes: LONGINT; myRefCon: LONGINT): ComponentResult;

|#
 |#                                             ; $ELSEC
(def-mactype :musicofflinedataprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :musicofflinedataupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :musicofflinedataupp (find-mactype ':pointer))
; $ENDC
(def-mactype :offlinesampletypeptr (find-mactype '(:pointer :offlinesampletype)))
(defrecord OfflineSampleType 
   (numChannels :unsigned-long)                 ;  number of channels,  ie mono = 1 
   (sampleRate :unsigned-long)                  ;  sample rate in Apples Fixed point representation 
   (sampleSize :unsigned-integer)               ;  number of bits in sample 
   )

(def-mactype :instrumentinforecordptr (find-mactype '(:pointer :instrumentinforecord)))
(defrecord InstrumentInfoRecord 
   (instrumentNumber :signed-long)              ;   instrument number (if 0, name is a catagory) 
   (flags :signed-long)                         ;   show in picker, etc. 
   (toneNameIndex :signed-long)                 ;   index in toneNames (1 based) 
   (itxtNameAtomID :signed-long)                ;   index in itxtNames (itxt/name by index) 
   )

(def-mactype :instrumentinfolistptr (find-mactype '(:pointer :instrumentinfolist)))
(defrecord InstrumentInfoList 
   (recordCount :signed-long)
   (toneNames :handle)                          ;   name from tone description 
   (itxtNames :handle)                          ;   itxt/name atoms for instruments 
   (info (:array :instrumentinforecord 1))
   )

(def-mactype :instrumentinfolisthandle (find-mactype '(:handle :instrumentinfolist)))
; 
; 	 *  MusicGetDescription()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 *    Windows:          in qtmlClient.lib 3.0 and later
; 	 	

(deftrap "_MusicGetDescription" 
      ((mc (:pointer :componentinstancerecord)) (sd (:pointer :synthesizerdescription)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc sd ((+ (ash 4 16) 1) :signed-longint)))

; 
;  *  MusicGetPart()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicGetPart" 
      ((mc (:pointer :componentinstancerecord)) (part :signed-long) (midiChannel (:pointer :signed-long)) (polyphony (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc part midiChannel polyphony ((+ (ash 12 16) 2) :signed-longint)))

; 
;  *  MusicSetPart()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicSetPart" 
      ((mc (:pointer :componentinstancerecord)) (part :signed-long) (midiChannel :signed-long) (polyphony :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc part midiChannel polyphony ((+ (ash 12 16) 3) :signed-longint)))

; 
;  *  MusicSetPartInstrumentNumber()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicSetPartInstrumentNumber" 
      ((mc (:pointer :componentinstancerecord)) (part :signed-long) (instrumentNumber :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc part instrumentNumber ((+ (ash 8 16) 4) :signed-longint)))

; 
;  *  MusicGetPartInstrumentNumber()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicGetPartInstrumentNumber" 
      ((mc (:pointer :componentinstancerecord)) (part :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc part ((+ (ash 4 16) 5) :signed-longint)))

; 
;  *  MusicStorePartInstrument()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicStorePartInstrument" 
      ((mc (:pointer :componentinstancerecord)) (part :signed-long) (instrumentNumber :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc part instrumentNumber ((+ (ash 8 16) 6) :signed-longint)))

; 
;  *  MusicGetPartAtomicInstrument()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicGetPartAtomicInstrument" 
      ((mc (:pointer :componentinstancerecord)) (part :signed-long) (ai (:pointer :handle)) (flags :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc part ai flags ((+ (ash 12 16) 9) :signed-longint)))

; 
;  *  MusicSetPartAtomicInstrument()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicSetPartAtomicInstrument" 
      ((mc (:pointer :componentinstancerecord)) (part :signed-long) (aiP :pointer) (flags :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc part aiP flags ((+ (ash 12 16) 10) :signed-longint)))

; 
;  *  MusicGetPartKnob()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicGetPartKnob" 
      ((mc (:pointer :componentinstancerecord)) (part :signed-long) (knobID :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc part knobID ((+ (ash 8 16) 16) :signed-longint)))

; 
;  *  MusicSetPartKnob()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicSetPartKnob" 
      ((mc (:pointer :componentinstancerecord)) (part :signed-long) (knobID :signed-long) (knobValue :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc part knobID knobValue ((+ (ash 12 16) 17) :signed-longint)))

; 
;  *  MusicGetKnob()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicGetKnob" 
      ((mc (:pointer :componentinstancerecord)) (knobID :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc knobID ((+ (ash 4 16) 18) :signed-longint)))

; 
;  *  MusicSetKnob()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicSetKnob" 
      ((mc (:pointer :componentinstancerecord)) (knobID :signed-long) (knobValue :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc knobID knobValue ((+ (ash 8 16) 19) :signed-longint)))

; 
;  *  MusicGetPartName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicGetPartName" 
      ((mc (:pointer :componentinstancerecord)) (part :signed-long) (name (:pointer (:string 255))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc part name ((+ (ash 8 16) 20) :signed-longint)))

; 
;  *  MusicSetPartName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicSetPartName" 
      ((mc (:pointer :componentinstancerecord)) (part :signed-long) (name (:pointer (:string 255))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc part name ((+ (ash 8 16) 21) :signed-longint)))

; 
;  *  MusicFindTone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicFindTone" 
      ((mc (:pointer :componentinstancerecord)) (td (:pointer :tonedescription)) (libraryIndexOut (:pointer :signed-long)) (fit (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc td libraryIndexOut fit ((+ (ash 12 16) 22) :signed-longint)))

; 
;  *  MusicPlayNote()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicPlayNote" 
      ((mc (:pointer :componentinstancerecord)) (part :signed-long) (pitch :signed-long) (velocity :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc part pitch velocity ((+ (ash 12 16) 23) :signed-longint)))

; 
;  *  MusicResetPart()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicResetPart" 
      ((mc (:pointer :componentinstancerecord)) (part :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc part ((+ (ash 4 16) 24) :signed-longint)))

; 
;  *  MusicSetPartController()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicSetPartController" 
      ((mc (:pointer :componentinstancerecord)) (part :signed-long) (controllerNumber :signed-long) (controllerValue :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc part controllerNumber controllerValue ((+ (ash 12 16) 25) :signed-longint)))

; 
;  *  MusicGetPartController()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicGetPartController" 
      ((mc (:pointer :componentinstancerecord)) (part :signed-long) (controllerNumber :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc part controllerNumber ((+ (ash 8 16) 26) :signed-longint)))

; 
;  *  MusicGetMIDIProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicGetMIDIProc" 
      ((mc (:pointer :componentinstancerecord)) (midiSendProc (:pointer :pointer)) (refCon (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc midiSendProc refCon ((+ (ash 8 16) 27) :signed-longint)))

; 
;  *  MusicSetMIDIProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicSetMIDIProc" 
      ((mc (:pointer :componentinstancerecord)) (midiSendProc :pointer) (refCon :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc midiSendProc refCon ((+ (ash 8 16) 28) :signed-longint)))

; 
;  *  MusicGetInstrumentNames()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicGetInstrumentNames" 
      ((mc (:pointer :componentinstancerecord)) (modifiableInstruments :signed-long) (instrumentNames (:pointer :handle)) (instrumentCategoryLasts (:pointer :handle)) (instrumentCategoryNames (:pointer :handle)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc modifiableInstruments instrumentNames instrumentCategoryLasts instrumentCategoryNames ((+ (ash 16 16) 29) :signed-longint)))

; 
;  *  MusicGetDrumNames()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicGetDrumNames" 
      ((mc (:pointer :componentinstancerecord)) (modifiableInstruments :signed-long) (instrumentNumbers (:pointer :handle)) (instrumentNames (:pointer :handle)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc modifiableInstruments instrumentNumbers instrumentNames ((+ (ash 12 16) 30) :signed-longint)))

; 
;  *  MusicGetMasterTune()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicGetMasterTune" 
      ((mc (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc ((+ (ash 0 16) 31) :signed-longint)))

; 
;  *  MusicSetMasterTune()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicSetMasterTune" 
      ((mc (:pointer :componentinstancerecord)) (masterTune :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc masterTune ((+ (ash 4 16) 32) :signed-longint)))

; 
;  *  MusicGetInstrumentAboutInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicGetInstrumentAboutInfo" 
      ((mc (:pointer :componentinstancerecord)) (part :signed-long) (iai (:pointer :instrumentaboutinfo)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc part iai ((+ (ash 8 16) 34) :signed-longint)))

; 
;  *  MusicGetDeviceConnection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicGetDeviceConnection" 
      ((mc (:pointer :componentinstancerecord)) (index :signed-long) (id1 (:pointer :signed-long)) (id2 (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc index id1 id2 ((+ (ash 12 16) 35) :signed-longint)))

; 
;  *  MusicUseDeviceConnection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicUseDeviceConnection" 
      ((mc (:pointer :componentinstancerecord)) (id1 :signed-long) (id2 :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc id1 id2 ((+ (ash 8 16) 36) :signed-longint)))

; 
;  *  MusicGetKnobSettingStrings()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicGetKnobSettingStrings" 
      ((mc (:pointer :componentinstancerecord)) (knobIndex :signed-long) (isGlobal :signed-long) (settingsNames (:pointer :handle)) (settingsCategoryLasts (:pointer :handle)) (settingsCategoryNames (:pointer :handle)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc knobIndex isGlobal settingsNames settingsCategoryLasts settingsCategoryNames ((+ (ash 20 16) 37) :signed-longint)))

; 
;  *  MusicGetMIDIPorts()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicGetMIDIPorts" 
      ((mc (:pointer :componentinstancerecord)) (inputPortCount (:pointer :signed-long)) (outputPortCount (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc inputPortCount outputPortCount ((+ (ash 8 16) 38) :signed-longint)))

; 
;  *  MusicSendMIDI()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicSendMIDI" 
      ((mc (:pointer :componentinstancerecord)) (portIndex :signed-long) (mp (:pointer :musicmidipacket)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc portIndex mp ((+ (ash 8 16) 39) :signed-longint)))

; 
;  *  MusicStartOffline()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicStartOffline" 
      ((mc (:pointer :componentinstancerecord)) (numChannels (:pointer :unsigned-long)) (sampleRate (:pointer :unsigned-long)) (sampleSize (:pointer :unsigned-integer)) (dataProc :pointer) (dataProcRefCon :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc numChannels sampleRate sampleSize dataProc dataProcRefCon ((+ (ash 20 16) 41) :signed-longint)))

; 
;  *  MusicSetOfflineTimeTo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicSetOfflineTimeTo" 
      ((mc (:pointer :componentinstancerecord)) (newTimeStamp :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc newTimeStamp ((+ (ash 4 16) 42) :signed-longint)))

; 
;  *  MusicGetInstrumentKnobDescription()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicGetInstrumentKnobDescription" 
      ((mc (:pointer :componentinstancerecord)) (knobIndex :signed-long) (mkd (:pointer :knobdescription)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc knobIndex mkd ((+ (ash 8 16) 43) :signed-longint)))

; 
;  *  MusicGetDrumKnobDescription()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicGetDrumKnobDescription" 
      ((mc (:pointer :componentinstancerecord)) (knobIndex :signed-long) (mkd (:pointer :knobdescription)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc knobIndex mkd ((+ (ash 8 16) 44) :signed-longint)))

; 
;  *  MusicGetKnobDescription()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicGetKnobDescription" 
      ((mc (:pointer :componentinstancerecord)) (knobIndex :signed-long) (mkd (:pointer :knobdescription)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc knobIndex mkd ((+ (ash 8 16) 45) :signed-longint)))

; 
;  *  MusicGetInfoText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicGetInfoText" 
      ((mc (:pointer :componentinstancerecord)) (selector :signed-long) (textH (:pointer :handle)) (styleH (:pointer :handle)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc selector textH styleH ((+ (ash 12 16) 46) :signed-longint)))

(defconstant $kGetInstrumentInfoNoBuiltIn #x1)
(defconstant $kGetInstrumentInfoMidiUserInst #x2)
(defconstant $kGetInstrumentInfoNoIText #x4)

; 
; 	 *  MusicGetInstrumentInfo()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 *    Windows:          in qtmlClient.lib 3.0 and later
; 	 	

(deftrap "_MusicGetInstrumentInfo" 
      ((mc (:pointer :componentinstancerecord)) (getInstrumentInfoFlags :signed-long) (infoListH (:pointer (:handle :instrumentinfolist))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc getInstrumentInfoFlags infoListH ((+ (ash 8 16) 47) :signed-longint)))

; 
;  *  MusicTask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicTask" 
      ((mc (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc ((+ (ash 0 16) 49) :signed-longint)))

; 
;  *  MusicSetPartInstrumentNumberInterruptSafe()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicSetPartInstrumentNumberInterruptSafe" 
      ((mc (:pointer :componentinstancerecord)) (part :signed-long) (instrumentNumber :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc part instrumentNumber ((+ (ash 8 16) 50) :signed-longint)))

; 
;  *  MusicSetPartSoundLocalization()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicSetPartSoundLocalization" 
      ((mc (:pointer :componentinstancerecord)) (part :signed-long) (data :handle))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc part data ((+ (ash 8 16) 51) :signed-longint)))

; 
;  *  MusicGenericConfigure()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicGenericConfigure" 
      ((mc (:pointer :componentinstancerecord)) (mode :signed-long) (flags :signed-long) (baseResID :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc mode flags baseResID ((+ (ash 12 16) 256) :signed-longint)))

; 
;  *  MusicGenericGetPart()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicGenericGetPart" 
      ((mc (:pointer :componentinstancerecord)) (partNumber :signed-long) (part (:pointer :pointer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc partNumber part ((+ (ash 8 16) 257) :signed-longint)))

; 
;  *  MusicGenericGetKnobList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicGenericGetKnobList" 
      ((mc (:pointer :componentinstancerecord)) (knobType :signed-long) (gkdlH (:pointer (:handle :genericknobdescriptionlist))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc knobType gkdlH ((+ (ash 8 16) 258) :signed-longint)))

; 
;  *  MusicGenericSetResourceNumbers()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicGenericSetResourceNumbers" 
      ((mc (:pointer :componentinstancerecord)) (resourceIDH :handle))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc resourceIDH ((+ (ash 4 16) 259) :signed-longint)))

; 
;  *  MusicDerivedMIDISend()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicDerivedMIDISend" 
      ((mc (:pointer :componentinstancerecord)) (packet (:pointer :musicmidipacket)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc packet ((+ (ash 4 16) 512) :signed-longint)))

; 
;  *  MusicDerivedSetKnob()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicDerivedSetKnob" 
      ((mc (:pointer :componentinstancerecord)) (knobType :signed-long) (knobNumber :signed-long) (knobValue :signed-long) (partNumber :signed-long) (p (:pointer :gcpart)) (gkd (:pointer :genericknobdescription)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc knobType knobNumber knobValue partNumber p gkd ((+ (ash 24 16) 513) :signed-longint)))

; 
;  *  MusicDerivedSetPart()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicDerivedSetPart" 
      ((mc (:pointer :componentinstancerecord)) (partNumber :signed-long) (p (:pointer :gcpart)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc partNumber p ((+ (ash 8 16) 514) :signed-longint)))

; 
;  *  MusicDerivedSetInstrument()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicDerivedSetInstrument" 
      ((mc (:pointer :componentinstancerecord)) (partNumber :signed-long) (p (:pointer :gcpart)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc partNumber p ((+ (ash 8 16) 515) :signed-longint)))

; 
;  *  MusicDerivedSetPartInstrumentNumber()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicDerivedSetPartInstrumentNumber" 
      ((mc (:pointer :componentinstancerecord)) (partNumber :signed-long) (p (:pointer :gcpart)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc partNumber p ((+ (ash 8 16) 516) :signed-longint)))

; 
;  *  MusicDerivedSetMIDI()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicDerivedSetMIDI" 
      ((mc (:pointer :componentinstancerecord)) (midiProc :pointer) (refcon :signed-long) (midiChannel :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc midiProc refcon midiChannel ((+ (ash 12 16) 517) :signed-longint)))

; 
;  *  MusicDerivedStorePartInstrument()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicDerivedStorePartInstrument" 
      ((mc (:pointer :componentinstancerecord)) (partNumber :signed-long) (p (:pointer :gcpart)) (instrumentNumber :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc partNumber p instrumentNumber ((+ (ash 12 16) 518) :signed-longint)))

; 
;  *  MusicDerivedOpenResFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicDerivedOpenResFile" 
      ((mc (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc ((+ (ash 0 16) 519) :signed-longint)))

; 
;  *  MusicDerivedCloseResFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_MusicDerivedCloseResFile" 
      ((mc (:pointer :componentinstancerecord)) (resRefNum :signed-integer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 mc resRefNum ((+ (ash 2 16) 520) :signed-longint)))

; --------------------------
;     Types
; --------------------------

(def-mactype :noteallocator (find-mactype '(:pointer :componentinstancerecord)))

(defconstant $kNoteRequestNoGM 1)               ;   don't degrade to a GM synth  
(defconstant $kNoteRequestNoSynthType 2)        ;   don't degrade to another synth of same type but different name  
(defconstant $kNoteRequestSynthMustMatch 4)     ;   synthType must be a match, including kGMSynthComponentSubType  

(defconstant $kNoteRequestSpecifyMIDIChannel #x80)

; 	
; 	    The midiChannelAssignment field of this structure is used to assign a MIDI channel 
; 	    when a NoteChannel is created from a NoteRequest.
; 	    A value of 0 indicates a MIDI channel has *not* been assigned
; 	    A value of (kNoteRequestSpecifyMIDIChannel | 1->16) is a MIDI channel assignment
; 	
; 	    This field requires QuickTime 5.0 or later and should be set to 0 for prior versions.
; 		

(def-mactype :noterequestmidichannel (find-mactype ':unsigned-byte))
(def-mactype :noterequestinfoptr (find-mactype '(:pointer :noterequestinfo)))
(defrecord NoteRequestInfo 
   (flags :signed-byte)                         ;   kNoteRequest flags, above  
   (midiChannelAssignment :signed-byte)         ;   (kNoteRequestSpecifyMIDIChannel | 1->16) as MIDI Channel assignment or zero - see notes above  
   (polyphony :signed-integer)                  ;   Maximum number of voices  
   (typicalPolyphony :signed-long)              ;   Hint for level mixing  
   )

(def-mactype :noterequestptr (find-mactype '(:pointer :noterequest)))
(defrecord NoteRequest 
   (info :noterequestinfo)
   (tone :tonedescription)
   )

(def-mactype :notechannel (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :notechannelptr (find-mactype '(:pointer :pointer)));  when a VAR xx:NoteChannel parameter can be nil, it is changed to xx: NoteChannelPtr 

(defconstant $kPickDontMix 1)                   ;   dont mix instruments with drum sounds  
(defconstant $kPickSameSynth 2)                 ;   only allow the same device that went in, to come out  
(defconstant $kPickUserInsts 4)                 ;   show user insts in addition to ROM voices  
(defconstant $kPickEditAllowEdit 8)             ;   lets user switch over to edit mode  
(defconstant $kPickEditAllowPick 16)            ;   lets the user switch over to pick mode  
(defconstant $kPickEditSynthGlobal 32)          ;   edit the global knobs of the synth  
(defconstant $kPickEditControllers 64)          ;   edit the controllers of the notechannel  

(defconstant $kNoteAllocatorComponentType :|nota|)

; 	--------------------------------
; 	    Note Allocator Prototypes
; 	--------------------------------	
; 
; 	 *  NARegisterMusicDevice()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 *    Windows:          in qtmlClient.lib 3.0 and later
; 	 	

(deftrap "_NARegisterMusicDevice" 
      ((na (:pointer :componentinstancerecord)) (synthType :ostype) (name (:pointer (:string 31))) (connections (:pointer :synthesizerconnections)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na synthType name connections ((+ (ash 12 16) 0) :signed-longint)))

; 
;  *  NAUnregisterMusicDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NAUnregisterMusicDevice" 
      ((na (:pointer :componentinstancerecord)) (index :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na index ((+ (ash 4 16) 1) :signed-longint)))

; 
;  *  NAGetRegisteredMusicDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NAGetRegisteredMusicDevice" 
      ((na (:pointer :componentinstancerecord)) (index :signed-long) (synthType (:pointer :ostype)) (name (:pointer (:string 31))) (connections (:pointer :synthesizerconnections)) (mc (:pointer (:pointer :componentinstancerecord))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na index synthType name connections mc ((+ (ash 20 16) 2) :signed-longint)))

; 
;  *  NASaveMusicConfiguration()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NASaveMusicConfiguration" 
      ((na (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na ((+ (ash 0 16) 3) :signed-longint)))

; 
;  *  NANewNoteChannel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NANewNoteChannel" 
      ((na (:pointer :componentinstancerecord)) (NoteRequest (:pointer :noterequest)) (outChannel (:pointer :pointer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na NoteRequest outChannel ((+ (ash 8 16) 4) :signed-longint)))

; 
;  *  NADisposeNoteChannel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NADisposeNoteChannel" 
      ((na (:pointer :componentinstancerecord)) (NoteChannel :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na NoteChannel ((+ (ash 4 16) 5) :signed-longint)))

; 
;  *  NAGetNoteChannelInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NAGetNoteChannelInfo" 
      ((na (:pointer :componentinstancerecord)) (NoteChannel :pointer) (index (:pointer :signed-long)) (part (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na NoteChannel index part ((+ (ash 12 16) 6) :signed-longint)))

; 
;  *  NAPrerollNoteChannel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NAPrerollNoteChannel" 
      ((na (:pointer :componentinstancerecord)) (NoteChannel :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na NoteChannel ((+ (ash 4 16) 7) :signed-longint)))

; 
;  *  NAUnrollNoteChannel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NAUnrollNoteChannel" 
      ((na (:pointer :componentinstancerecord)) (NoteChannel :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na NoteChannel ((+ (ash 4 16) 8) :signed-longint)))

; 
;  *  NASetNoteChannelVolume()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NASetNoteChannelVolume" 
      ((na (:pointer :componentinstancerecord)) (NoteChannel :pointer) (volume :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na NoteChannel volume ((+ (ash 8 16) 11) :signed-longint)))

; 
;  *  NAResetNoteChannel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NAResetNoteChannel" 
      ((na (:pointer :componentinstancerecord)) (NoteChannel :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na NoteChannel ((+ (ash 4 16) 12) :signed-longint)))

; 
;  *  NAPlayNote()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NAPlayNote" 
      ((na (:pointer :componentinstancerecord)) (NoteChannel :pointer) (pitch :signed-long) (velocity :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na NoteChannel pitch velocity ((+ (ash 12 16) 13) :signed-longint)))

; 
;  *  NASetController()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NASetController" 
      ((na (:pointer :componentinstancerecord)) (NoteChannel :pointer) (controllerNumber :signed-long) (controllerValue :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na NoteChannel controllerNumber controllerValue ((+ (ash 12 16) 14) :signed-longint)))

; 
;  *  NASetKnob()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NASetKnob" 
      ((na (:pointer :componentinstancerecord)) (NoteChannel :pointer) (knobNumber :signed-long) (knobValue :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na NoteChannel knobNumber knobValue ((+ (ash 12 16) 15) :signed-longint)))

; 
;  *  NAFindNoteChannelTone()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NAFindNoteChannelTone" 
      ((na (:pointer :componentinstancerecord)) (NoteChannel :pointer) (td (:pointer :tonedescription)) (instrumentNumber (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na NoteChannel td instrumentNumber ((+ (ash 12 16) 16) :signed-longint)))

; 
;  *  NASetInstrumentNumber()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NASetInstrumentNumber" 
      ((na (:pointer :componentinstancerecord)) (NoteChannel :pointer) (instrumentNumber :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na NoteChannel instrumentNumber ((+ (ash 8 16) 17) :signed-longint)))

; 
;  *  NAPickInstrument()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NAPickInstrument" 
      ((na (:pointer :componentinstancerecord)) (filterProc :pointer) (prompt (:pointer (:string 255))) (sd (:pointer :tonedescription)) (flags :unsigned-long) (refCon :signed-long) (reserved1 :signed-long) (reserved2 :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na filterProc prompt sd flags refCon reserved1 reserved2 ((+ (ash 28 16) 18) :signed-longint)))

; 
;  *  NAPickArrangement()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NAPickArrangement" 
      ((na (:pointer :componentinstancerecord)) (filterProc :pointer) (prompt (:pointer (:string 255))) (zero1 :signed-long) (zero2 :signed-long) (t (:pointer :trackrecord)) (songName (:pointer (:string 255))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na filterProc prompt zero1 zero2 t songName ((+ (ash 24 16) 19) :signed-longint)))

; 
;  *  NAStuffToneDescription()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NAStuffToneDescription" 
      ((na (:pointer :componentinstancerecord)) (gmNumber :signed-long) (td (:pointer :tonedescription)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na gmNumber td ((+ (ash 8 16) 27) :signed-longint)))

; 
;  *  NACopyrightDialog()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NACopyrightDialog" 
      ((na (:pointer :componentinstancerecord)) (p (:handle :picture)) (author (:pointer (:string 255))) (copyright (:pointer (:string 255))) (other (:pointer (:string 255))) (title (:pointer (:string 255))) (filterProc :pointer) (refCon :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na p author copyright other title filterProc refCon ((+ (ash 28 16) 28) :signed-longint)))

; 
;     kNADummyOneSelect = 29
;     kNADummyTwoSelect = 30
; 

; 
;  *  NAGetIndNoteChannel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NAGetIndNoteChannel" 
      ((na (:pointer :componentinstancerecord)) (index :signed-long) (nc (:pointer :pointer)) (seed (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na index nc seed ((+ (ash 12 16) 31) :signed-longint)))

; 
;  *  NAGetMIDIPorts()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NAGetMIDIPorts" 
      ((na (:pointer :componentinstancerecord)) (inputPorts (:pointer (:handle :qtmidiportlist))) (outputPorts (:pointer (:handle :qtmidiportlist))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na inputPorts outputPorts ((+ (ash 8 16) 33) :signed-longint)))

; 
;  *  NAGetNoteRequest()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NAGetNoteRequest" 
      ((na (:pointer :componentinstancerecord)) (NoteChannel :pointer) (nrOut (:pointer :noterequest)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na NoteChannel nrOut ((+ (ash 8 16) 34) :signed-longint)))

; 
;  *  NASendMIDI()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NASendMIDI" 
      ((na (:pointer :componentinstancerecord)) (NoteChannel :pointer) (mp (:pointer :musicmidipacket)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na NoteChannel mp ((+ (ash 8 16) 35) :signed-longint)))

; 
;  *  NAPickEditInstrument()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NAPickEditInstrument" 
      ((na (:pointer :componentinstancerecord)) (filterProc :pointer) (prompt (:pointer (:string 255))) (refCon :signed-long) (nc :pointer) (ai :handle) (flags :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na filterProc prompt refCon nc ai flags ((+ (ash 24 16) 36) :signed-longint)))

; 
;  *  NANewNoteChannelFromAtomicInstrument()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NANewNoteChannelFromAtomicInstrument" 
      ((na (:pointer :componentinstancerecord)) (instrument :pointer) (flags :signed-long) (outChannel (:pointer :pointer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na instrument flags outChannel ((+ (ash 12 16) 37) :signed-longint)))

; 
;  *  NASetAtomicInstrument()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NASetAtomicInstrument" 
      ((na (:pointer :componentinstancerecord)) (NoteChannel :pointer) (instrument :pointer) (flags :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na NoteChannel instrument flags ((+ (ash 12 16) 38) :signed-longint)))

; 
;  *  NAGetKnob()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NAGetKnob" 
      ((na (:pointer :componentinstancerecord)) (NoteChannel :pointer) (knobNumber :signed-long) (knobValue (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na NoteChannel knobNumber knobValue ((+ (ash 12 16) 40) :signed-longint)))

; 
;  *  NATask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NATask" 
      ((na (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na ((+ (ash 0 16) 41) :signed-longint)))

; 
;  *  NASetNoteChannelBalance()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NASetNoteChannelBalance" 
      ((na (:pointer :componentinstancerecord)) (NoteChannel :pointer) (balance :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na NoteChannel balance ((+ (ash 8 16) 42) :signed-longint)))

; 
;  *  NASetInstrumentNumberInterruptSafe()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NASetInstrumentNumberInterruptSafe" 
      ((na (:pointer :componentinstancerecord)) (NoteChannel :pointer) (instrumentNumber :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na NoteChannel instrumentNumber ((+ (ash 8 16) 43) :signed-longint)))

; 
;  *  NASetNoteChannelSoundLocalization()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NASetNoteChannelSoundLocalization" 
      ((na (:pointer :componentinstancerecord)) (NoteChannel :pointer) (data :handle))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na NoteChannel data ((+ (ash 8 16) 44) :signed-longint)))

; 
;  *  NAGetController()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_NAGetController" 
      ((na (:pointer :componentinstancerecord)) (NoteChannel :pointer) (controllerNumber :signed-long) (controllerValue (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 na NoteChannel controllerNumber controllerValue ((+ (ash 12 16) 45) :signed-longint)))

(defconstant $kTuneQueueDepth 8)                ;   Deepest you can queue tune segments  

(def-mactype :tunestatusptr (find-mactype '(:pointer :tunestatus)))
(defrecord TuneStatus 
   (tune :pointer)                              ;   currently playing tune  
   (tunePtr :pointer)                           ;   position within currently playing piece  
   (time :signed-long)                          ;   current tune time  
   (queueCount :signed-integer)                 ;   how many pieces queued up?  
   (queueSpots :signed-integer)                 ;   How many more tunepieces can be queued  
   (queueTime :signed-long)                     ;   How much time is queued up? (can be very inaccurate)  
   (reserved (:array :signed-long 3))
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TuneCallBackProcPtr = PROCEDURE({CONST}VAR status: TuneStatus; refCon: LONGINT);

|#
 |#                                             ; $ELSEC
(def-mactype :tunecallbackprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TunePlayCallBackProcPtr = PROCEDURE(VAR event: UInt32; seed: LONGINT; refCon: LONGINT);

|#
 |#                                             ; $ELSEC
(def-mactype :tuneplaycallbackprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :tunecallbackupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :tunecallbackupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :tuneplaycallbackupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :tuneplaycallbackupp (find-mactype ':pointer))
; $ENDC
(def-mactype :tuneplayer (find-mactype '(:pointer :componentinstancerecord)))

(defconstant $kTunePlayerComponentType :|tune|)

; 
; 	 *  TuneSetHeader()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 *    Windows:          in qtmlClient.lib 3.0 and later
; 	 	

(deftrap "_TuneSetHeader" 
      ((tp (:pointer :componentinstancerecord)) (header (:pointer :unsigned-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 tp header ((+ (ash 4 16) 4) :signed-longint)))

; 
;  *  TuneGetTimeBase()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_TuneGetTimeBase" 
      ((tp (:pointer :componentinstancerecord)) (tb (:pointer :pointer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 tp tb ((+ (ash 4 16) 5) :signed-longint)))

; 
;  *  TuneSetTimeScale()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_TuneSetTimeScale" 
      ((tp (:pointer :componentinstancerecord)) (scale :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 tp scale ((+ (ash 4 16) 6) :signed-longint)))

; 
;  *  TuneGetTimeScale()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_TuneGetTimeScale" 
      ((tp (:pointer :componentinstancerecord)) (scale (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 tp scale ((+ (ash 4 16) 7) :signed-longint)))

; 
;  *  TuneGetIndexedNoteChannel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_TuneGetIndexedNoteChannel" 
      ((tp (:pointer :componentinstancerecord)) (i :signed-long) (nc (:pointer :pointer)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 tp i nc ((+ (ash 8 16) 8) :signed-longint)))

;  Values for when to start. 

(defconstant $kTuneStartNow 1)                  ;   start after buffer is implied  
(defconstant $kTuneDontClipNotes 2)             ;   allow notes to finish their durations outside sample  
(defconstant $kTuneExcludeEdgeNotes 4)          ;   dont play notes that start at end of tune  
(defconstant $kTuneQuickStart 8)                ;   Leave all the controllers where they are, ignore start time  
(defconstant $kTuneLoopUntil 16)                ;   loop a queued tune if there's nothing else in the queue 
(defconstant $kTunePlayDifference 32)           ;   by default, the tune difference is skipped 
(defconstant $kTunePlayConcurrent 64)           ;   dont block the next tune sequence with this one 
(defconstant $kTuneStartNewMaster 16384)

; 
; 	 *  TuneQueue()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 *    Windows:          in qtmlClient.lib 3.0 and later
; 	 	

(deftrap "_TuneQueue" 
      ((tp (:pointer :componentinstancerecord)) (tune (:pointer :unsigned-long)) (tuneRate :signed-long) (tuneStartPosition :unsigned-long) (tuneStopPosition :unsigned-long) (queueFlags :unsigned-long) (callBackProc :pointer) (refCon :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 tp tune tuneRate tuneStartPosition tuneStopPosition queueFlags callBackProc refCon ((+ (ash 28 16) 10) :signed-longint)))

; 
;  *  TuneInstant()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_TuneInstant" 
      ((tp (:pointer :componentinstancerecord)) (tune (:pointer :unsigned-long)) (tunePosition :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 tp tune tunePosition ((+ (ash 8 16) 11) :signed-longint)))

; 
;  *  TuneGetStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_TuneGetStatus" 
      ((tp (:pointer :componentinstancerecord)) (status (:pointer :tunestatus)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 tp status ((+ (ash 4 16) 12) :signed-longint)))

;  Values for stopping. 

(defconstant $kTuneStopFade 1)                  ;   do a quick, synchronous fadeout  
(defconstant $kTuneStopSustain 2)               ;   don't silece notes  
(defconstant $kTuneStopInstant 4)               ;   silence notes fast (else, decay them)  
(defconstant $kTuneStopReleaseChannels 8)       ;   afterwards, let the channels go  

; 
; 	 *  TuneStop()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 *    Windows:          in qtmlClient.lib 3.0 and later
; 	 	

(deftrap "_TuneStop" 
      ((tp (:pointer :componentinstancerecord)) (stopFlags :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 tp stopFlags ((+ (ash 4 16) 13) :signed-longint)))

; 
;  *  TuneSetVolume()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_TuneSetVolume" 
      ((tp (:pointer :componentinstancerecord)) (volume :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 tp volume ((+ (ash 4 16) 16) :signed-longint)))

; 
;  *  TuneGetVolume()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_TuneGetVolume" 
      ((tp (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 tp ((+ (ash 0 16) 17) :signed-longint)))

; 
;  *  TunePreroll()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_TunePreroll" 
      ((tp (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 tp ((+ (ash 0 16) 18) :signed-longint)))

; 
;  *  TuneUnroll()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_TuneUnroll" 
      ((tp (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 tp ((+ (ash 0 16) 19) :signed-longint)))

; 
;  *  TuneSetNoteChannels()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_TuneSetNoteChannels" 
      ((tp (:pointer :componentinstancerecord)) (count :unsigned-long) (noteChannelList (:pointer :pointer)) (playCallBackProc :pointer) (refCon :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 tp count noteChannelList playCallBackProc refCon ((+ (ash 16 16) 20) :signed-longint)))

; 
;  *  TuneSetPartTranspose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_TuneSetPartTranspose" 
      ((tp (:pointer :componentinstancerecord)) (part :unsigned-long) (transpose :signed-long) (velocityShift :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 tp part transpose velocityShift ((+ (ash 12 16) 21) :signed-longint)))

; 
;  *  TuneGetNoteAllocator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_TuneGetNoteAllocator" 
      ((tp (:pointer :componentinstancerecord)))
   (:stack (:pointer :componentinstancerecord))
   (:stack-trap #xA82A :d0 0 tp ((+ (ash 0 16) 23) :signed-longint)))

; 
;  *  TuneSetSofter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_TuneSetSofter" 
      ((tp (:pointer :componentinstancerecord)) (softer :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 tp softer ((+ (ash 4 16) 24) :signed-longint)))

; 
;  *  TuneTask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_TuneTask" 
      ((tp (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 tp ((+ (ash 0 16) 25) :signed-longint)))

; 
;  *  TuneSetBalance()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_TuneSetBalance" 
      ((tp (:pointer :componentinstancerecord)) (balance :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 tp balance ((+ (ash 4 16) 26) :signed-longint)))

; 
;  *  TuneSetSoundLocalization()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_TuneSetSoundLocalization" 
      ((tp (:pointer :componentinstancerecord)) (data :handle))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 tp data ((+ (ash 4 16) 27) :signed-longint)))

; 
;  *  TuneSetHeaderWithSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 2.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_TuneSetHeaderWithSize" 
      ((tp (:pointer :componentinstancerecord)) (header (:pointer :unsigned-long)) (size :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 tp header size ((+ (ash 8 16) 28) :signed-longint)))

;  flags for part mix. 

(defconstant $kTuneMixMute 1)                   ;   disable a part  
(defconstant $kTuneMixSolo 2)                   ;   if any parts soloed, play only soloed parts  

; 
; 	 *  TuneSetPartMix()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 *    Windows:          in qtmlClient.lib 3.0 and later
; 	 	

(deftrap "_TuneSetPartMix" 
      ((tp (:pointer :componentinstancerecord)) (partNumber :unsigned-long) (volume :signed-long) (balance :signed-long) (mixFlags :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 tp partNumber volume balance mixFlags ((+ (ash 16 16) 29) :signed-longint)))

; 
;  *  TuneGetPartMix()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickTimeLib 3.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  *    Windows:          in qtmlClient.lib 3.0 and later
;  

(deftrap "_TuneGetPartMix" 
      ((tp (:pointer :componentinstancerecord)) (partNumber :unsigned-long) (volumeOut (:pointer :signed-long)) (balanceOut (:pointer :signed-long)) (mixFlagsOut (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 tp partNumber volumeOut balanceOut mixFlagsOut ((+ (ash 16 16) 30) :signed-longint)))

(def-mactype :musicopword (find-mactype ':unsigned-long))
(def-mactype :musicopwordptr (find-mactype '(:pointer :unsigned-long)))
; 	    QuickTime Music Track Event Formats:
; 	
; 	    At this time, QuickTime music tracks support 5 different event types -- REST events,
; 	    short NOTE events, short CONTROL events, short GENERAL events, Long NOTE events, 
; 	    long CONTROL events, and variable GENERAL events.
; 	 
; 	         REST Event (4 bytes/event):
; 	    
; 	            (0 0 0) (5-bit UNUSED) (24-bit Rest Duration)
; 	        
; 	        Short NOTE Events (4 bytes/event):
; 	    
; 	            (0 0 1) (5-bit Part) (6-bit Pitch) (7-bit Volume) (11-bit Duration)
; 	        
; 	            where:  Pitch is offset by 32 (Actual pitch = pitch field + 32)
; 	
; 	        Short CONTROL Events (4 bytes/event):
; 	    
; 	            (0 1 0) (5-bit Part) (8-bit Controller) (1-bit UNUSED) (1-bit Sign) (7-bit MSB) (7-bit LSB)
; 	                                                                         ( or 15-bit Signed Value)
; 	         Short GENERAL Event (4 bytes/event):
; 	    
; 	            (0 1 1) (1-bit UNUSED) (12-bit Sub-Type) (16-bit Value)
; 	    
; 	         Long NOTE Events (8 bytes/event):
; 	    
; 	            (1 0 0 1) (12-bit Part) (1-bit UNUSED) (7-bit Pitch) (1-bit UNUSED) (7-bit Volume)
; 	            (1 0) (8-bit UNUSED) (22-bit Duration)
; 	        
; 	        Long CONTROL Event (8 bytes/event):
; 	        
; 	            (1 0 1 0) (12-bit Part) (16-bit Value MSB) 
; 	            (1 0) (14-bit Controller) (16-bit Value LSB)
; 	    
; 	        Long KNOB Event (8 bytes/event):
; 	    
; 	            (1 0 1 1) (12-bit Sub-Type) (16-bit Value MSB)
; 	            (1 0) (14-bit KNOB) (16-bit Value LSB)
; 	    
; 	        Variable GENERAL Length Events (N bytes/event):
; 	    
; 	            (1 1 1 1) (12-bit Sub-Type) (16-bit Length)
; 	                :
; 	            (32-bit Data values)
; 	                :
; 	            (1 1) (14-bit UNUSED) (16-bit Length)
; 	    
; 	            where:  Length field is the number of LONG words in the record.
; 	                    Lengths include the first and last long words (Minimum length = 2)
; 	                
; 	    The following event type values have not been used yet and are reserved for 
; 	    future expansion:
; 	        
; 	         (1 0 0 0)     (8 bytes/event)
; 	         (1 1 0 0)     (N bytes/event)
; 	         (1 1 0 1)     (N bytes/event)
; 	         (1 1 1 0)     (N bytes/event)
; 	        
; 	    For all events, the following generalizations apply:
; 	    
; 	        -   All duration values are specified in Millisecond units.
; 	        -   Pitch values are intended to map directly to the MIDI key numbers.
; 	        -   Controllers from 0 to 127 correspond to the standard MIDI controllers.
; 	            Controllers greater than 127 correspond to other controls (i.e., Pitch Bend, 
; 	            Key Pressure, and Channel Pressure).    
; 		

;   Defines for the implemented music event data fields 

(defconstant $kRestEventType #x0)               ;   lower 3-bits  
(defconstant $kNoteEventType #x1)               ;   lower 3-bits  
(defconstant $kControlEventType #x2)            ;   lower 3-bits  
(defconstant $kMarkerEventType #x3)             ;   lower 3-bits  
(defconstant $kUndefined1EventType #x8)         ;   4-bits  
(defconstant $kXNoteEventType #x9)              ;   4-bits  
(defconstant $kXControlEventType #xA)           ;   4-bits  
(defconstant $kKnobEventType #xB)               ;   4-bits  
(defconstant $kUndefined2EventType #xC)         ;   4-bits  
(defconstant $kUndefined3EventType #xD)         ;   4-bits  
(defconstant $kUndefined4EventType #xE)         ;   4-bits  
(defconstant $kGeneralEventType #xF)            ;   4-bits  
(defconstant $kXEventLengthBits #x2)            ;   2 bits: indicates 8-byte event record  
(defconstant $kGeneralEventLengthBits #x3)      ;   2 bits: indicates variable length event record  
(defconstant $kEventLen 1)                      ;   length of events in long words  
(defconstant $kXEventLen 2)
(defconstant $kRestEventLen 1)                  ;   length of events in long words  
(defconstant $kNoteEventLen 1)
(defconstant $kControlEventLen 1)
(defconstant $kMarkerEventLen 1)
(defconstant $kXNoteEventLen 2)
(defconstant $kXControlEventLen 2)
(defconstant $kGeneralEventLen 2)               ;   2 or more, however  
;   Universal Event Defines 
(defconstant $kEventLengthFieldPos 30)          ;   by looking at these two bits of the 1st or last word          
(defconstant $kEventLengthFieldWidth 2)         ;   of an event you can determine the event length                 
;   length field: 0 & 1 => 1 long; 2 => 2 longs; 3 => variable length  
(defconstant $kEventTypeFieldPos 29)            ;   event type field for short events  
(defconstant $kEventTypeFieldWidth 3)           ;   short type is 3 bits  
(defconstant $kXEventTypeFieldPos 28)           ;   event type field for extended events  
(defconstant $kXEventTypeFieldWidth 4)          ;   extended type is 4 bits  
(defconstant $kEventPartFieldPos 24)
(defconstant $kEventPartFieldWidth 5)
(defconstant $kXEventPartFieldPos 16)           ;   in the 1st long word  
(defconstant $kXEventPartFieldWidth 12)         ;   Rest Events 
(defconstant $kRestEventDurationFieldPos 0)
(defconstant $kRestEventDurationFieldWidth 24)
(defconstant $kRestEventDurationMax #xFFFFFF)   ;   Note Events 
(defconstant $kNoteEventPitchFieldPos 18)
(defconstant $kNoteEventPitchFieldWidth 6)
(defconstant $kNoteEventPitchOffset 32)         ;   add to value in pitch field to get actual pitch  
(defconstant $kNoteEventVolumeFieldPos 11)
(defconstant $kNoteEventVolumeFieldWidth 7)
(defconstant $kNoteEventVolumeOffset 0)         ;   add to value in volume field to get actual volume  
(defconstant $kNoteEventDurationFieldPos 0)
(defconstant $kNoteEventDurationFieldWidth 11)
(defconstant $kNoteEventDurationMax #x7FF)
(defconstant $kXNoteEventPitchFieldPos 0)       ;   in the 1st long word  
(defconstant $kXNoteEventPitchFieldWidth 16)
(defconstant $kXNoteEventDurationFieldPos 0)    ;   in the 2nd long word  
(defconstant $kXNoteEventDurationFieldWidth 22)
(defconstant $kXNoteEventDurationMax #x3FFFFF)
(defconstant $kXNoteEventVolumeFieldPos 22)     ;   in the 2nd long word  
(defconstant $kXNoteEventVolumeFieldWidth 7)    ;   Control Events 
(defconstant $kControlEventControllerFieldPos 16)
(defconstant $kControlEventControllerFieldWidth 8)
(defconstant $kControlEventValueFieldPos 0)
(defconstant $kControlEventValueFieldWidth 16)
(defconstant $kXControlEventControllerFieldPos 0);   in the 2nd long word  
(defconstant $kXControlEventControllerFieldWidth 16)
(defconstant $kXControlEventValueFieldPos 0)    ;   in the 1st long word  
(defconstant $kXControlEventValueFieldWidth 16) ;   Knob Events 
(defconstant $kKnobEventValueHighFieldPos 0)    ;   1st long word  
(defconstant $kKnobEventValueHighFieldWidth 16)
(defconstant $kKnobEventKnobFieldPos 16)        ;   2nd long word  
(defconstant $kKnobEventKnobFieldWidth 14)
(defconstant $kKnobEventValueLowFieldPos 0)     ;   2nd long word  
(defconstant $kKnobEventValueLowFieldWidth 16)  ;   Marker Events 
(defconstant $kMarkerEventSubtypeFieldPos 16)
(defconstant $kMarkerEventSubtypeFieldWidth 8)
(defconstant $kMarkerEventValueFieldPos 0)
(defconstant $kMarkerEventValueFieldWidth 16)   ;   General Events 
(defconstant $kGeneralEventSubtypeFieldPos 16)  ;   in the last long word  
(defconstant $kGeneralEventSubtypeFieldWidth 14)
(defconstant $kGeneralEventLengthFieldPos 0)    ;   in the 1st & last long words  
(defconstant $kGeneralEventLengthFieldWidth 16)

#|                                              ; $IFC TARGET_RT_LITTLE_ENDIAN 
(defconstant $kEndMarkerValue #x60)

 |#                                             ; $ELSEC
(defconstant $kEndMarkerValue #x60000000)

; $ENDC                                         ; TARGET_RT_LITTLE_ENDIAN

;   macros for extracting various fields from the QuickTime event records 

;   General Event Defined Types 
(defconstant $kGeneralEventNoteRequest 1)       ;   Encapsulates NoteRequest data structure  
(defconstant $kGeneralEventPartKey 4)
(defconstant $kGeneralEventTuneDifference 5)    ;   Contains a standard sequence, with end marker, for the tune difference of a sequence piece (halts QuickTime 2.0 Music)  
(defconstant $kGeneralEventAtomicInstrument 6)  ;   Encapsulates AtomicInstrument record  
(defconstant $kGeneralEventKnob 7)              ;   knobID/knobValue pairs; smallest event is 4 longs  
(defconstant $kGeneralEventMIDIChannel 8)       ;   used in tune header, one longword identifies the midi channel it originally came from  
(defconstant $kGeneralEventPartChange 9)        ;   used in tune sequence, one longword identifies the tune part which can now take over this part's note channel (similar to program change) (halts QuickTime 2.0 Music) 
(defconstant $kGeneralEventNoOp 10)             ;   guaranteed to do nothing and be ignored. (halts QuickTime 2.0 Music)  
(defconstant $kGeneralEventUsedNotes 11)        ;   four longwords specifying which midi notes are actually used, 0..127 msb to lsb  
(defconstant $kGeneralEventPartMix 12)          ;   three longwords: Fixed volume, long balance, long flags  

;   Marker Event Defined Types       // marker is 60 ee vv vv in hex, where e = event type, and v = value 
(defconstant $kMarkerEventEnd 0)                ;   marker type 0 means: value 0 - stop, value != 0 - ignore 
(defconstant $kMarkerEventBeat 1)               ;   value 0 = single beat; anything else is 65536ths-of-a-beat (quarter note) 
(defconstant $kMarkerEventTempo 2)              ;   value same as beat marker, but indicates that a tempo event should be computed (based on where the next beat or tempo marker is) and emitted upon export 

(defconstant $kCurrentlyNativeEndian 1)
(defconstant $kCurrentlyNotNativeEndian 2)

; 	 UPP call backs 	
(defconstant $uppMusicMIDISendProcInfo #xFF0)
(defconstant $uppMusicOfflineDataProcInfo #xFF0)
(defconstant $uppTuneCallBackProcInfo #x3C0)
(defconstant $uppTunePlayCallBackProcInfo #xFC0)
; 
; 	 *  NewMusicMIDISendUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewMusicMIDISendProc 
(deftrap "_NewMusicMIDISendUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewMusicOfflineDataUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewMusicOfflineDataProc 
(deftrap "_NewMusicOfflineDataUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewTuneCallBackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewTuneCallBackProc 
(deftrap "_NewTuneCallBackUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewTunePlayCallBackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewTunePlayCallBackProc 
(deftrap "_NewTunePlayCallBackUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeMusicMIDISendUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeMusicMIDISendUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeMusicOfflineDataUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeMusicOfflineDataUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeTuneCallBackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeTuneCallBackUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeTunePlayCallBackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeTunePlayCallBackUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeMusicMIDISendUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallMusicMIDISendProc 
(deftrap-inline "_InvokeMusicMIDISendUPP" 
      ((self (:pointer :componentinstancerecord)) (refCon :signed-long) (mmp (:pointer :musicmidipacket)) (userRoutine :pointer)) 
  :signed-long
   (#x205F #x4E90) )

; 
;  *  InvokeMusicOfflineDataUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallMusicOfflineDataProc 
(deftrap-inline "_InvokeMusicOfflineDataUPP" 
      ((SoundData :pointer) (numBytes :signed-long) (myRefCon :signed-long) (userRoutine :pointer)) 
  :signed-long
   (#x205F #x4E90) )

; 
;  *  InvokeTuneCallBackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ;  old name was CallTuneCallBackProc 
(deftrap-inline "_InvokeTuneCallBackUPP" 
      ((status (:pointer :tunestatus)) (refCon :signed-long) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeTunePlayCallBackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallTunePlayCallBackProc 
(deftrap-inline "_InvokeTunePlayCallBackUPP" 
      ((event (:pointer :unsigned-long)) (seed :signed-long) (refCon :signed-long) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QuickTimeMusicIncludes

; $ENDC                                         ; __QUICKTIMEMUSIC__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'QuickTimeMusic)