(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QuickTimeVRFormat.p"
; at Wednesday May 1,2002 2:42:47 pm.
; 
;      File:       QuickTimeVRFormat.p
;  
;      Contains:   QuickTime VR interfaces
;  
;      Version:    Technology: QuickTime VR 5.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1997-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __QUICKTIMEVRFORMAT__
; $SETC __QUICKTIMEVRFORMAT__ := 1

; $I+
; $SETC QuickTimeVRFormatIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MOVIES__
|#

(require-interface 'Movies)
#|                                              ; $I Movies.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __QUICKTIMEVR__
|#

(require-interface 'QuickTimeVR)
#|                                              ; $I QuickTimeVR.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;   User data type for the Movie Controller type specifier 

(defconstant $kQTControllerType :|ctyp|)        ;   Atom & ID of where our 
(defconstant $kQTControllerID 1)                ;   ...controller name is stored 

;   VRWorld atom types 
(defconstant $kQTVRWorldHeaderAtomType :|vrsc|)
(defconstant $kQTVRImagingParentAtomType :|imgp|)
(defconstant $kQTVRPanoImagingAtomType :|impn|)
(defconstant $kQTVRObjectImagingAtomType :|imob|)
(defconstant $kQTVRNodeParentAtomType :|vrnp|)
(defconstant $kQTVRNodeIDAtomType :|vrni|)
(defconstant $kQTVRNodeLocationAtomType :|nloc|)
(defconstant $kQTVRCursorParentAtomType :|vrcp|);   New with 2.1 
(defconstant $kQTVRCursorAtomType :|CURS|)      ;   New with 2.1 
(defconstant $kQTVRColorCursorAtomType :|crsr|) ;   New with 2.1 

;   NodeInfo atom types 
(defconstant $kQTVRNodeHeaderAtomType :|ndhd|)
(defconstant $kQTVRHotSpotParentAtomType :|hspa|)
(defconstant $kQTVRHotSpotAtomType :|hots|)
(defconstant $kQTVRHotSpotInfoAtomType :|hsin|)
(defconstant $kQTVRLinkInfoAtomType :|link|)

;   Miscellaneous atom types 
(defconstant $kQTVRStringAtomType :|vrsg|)
(defconstant $kQTVRStringEncodingAtomType :|vrse|);   New with 2.1 
(defconstant $kQTVRPanoSampleDataAtomType :|pdat|)
(defconstant $kQTVRObjectInfoAtomType :|obji|)
(defconstant $kQTVRImageTrackRefAtomType :|imtr|);   Parent is kQTVRObjectInfoAtomType. Required if track ref is not 1 as required by 2.0 format. 
(defconstant $kQTVRHotSpotTrackRefAtomType :|hstr|);   Parent is kQTVRObjectInfoAtomType. Required if track ref is not 1 as required by 2.0 format. 
(defconstant $kQTVRAngleRangeAtomType :|arng|)
(defconstant $kQTVRTrackRefArrayAtomType :|tref|)
(defconstant $kQTVRPanConstraintAtomType :|pcon|)
(defconstant $kQTVRTiltConstraintAtomType :|tcon|)
(defconstant $kQTVRFOVConstraintAtomType :|fcon|)
(defconstant $kQTVRCubicViewAtomType :|cuvw|)   ;   New with 5.0 
(defconstant $kQTVRCubicFaceDataAtomType :|cufa|);   New with 5.0 

(defconstant $kQTVRObjectInfoAtomID 1)
(defconstant $kQTVRObjectImageTrackRefAtomID 1) ;   New with 2.1, it adds a track reference to select between multiple image tracks 
(defconstant $kQTVRObjectHotSpotTrackRefAtomID 1);   New with 2.1, it adds a track reference to select between multiple hotspot tracks 

;   Track reference types 
(defconstant $kQTVRImageTrackRefType :|imgt|)
(defconstant $kQTVRHotSpotTrackRefType :|hott|)

;   Old hot spot types 
(defconstant $kQTVRHotSpotNavigableType :|navg|)

;   Valid bits used in QTVRLinkHotSpotAtom 
(defconstant $kQTVRValidPan #x1)
(defconstant $kQTVRValidTilt #x2)
(defconstant $kQTVRValidFOV #x4)
(defconstant $kQTVRValidViewCenter #x8)

;   Values for flags field in QTVRPanoSampleAtom 
(defconstant $kQTVRPanoFlagHorizontal #x1)
(defconstant $kQTVRPanoFlagLast #x80000000)

;   Values for locationFlags field in QTVRNodeLocationAtom 
(defconstant $kQTVRSameFile 0)

;   Header for QTVR track's Sample Description record (vrWorld atom container is appended) 

(def-mactype :qtvrsampledescriptionptr (find-mactype '(:pointer :qtvrsampledescription)))
(defrecord QTVRSampleDescription 
   (descSize :unsigned-long)                    ;   total size of the QTVRSampleDescription 
   (descType :unsigned-long)                    ;   must be 'qtvr' 
   (reserved1 :unsigned-long)                   ;   must be zero 
   (reserved2 :unsigned-integer)                ;   must be zero 
   (dataRefIndex :unsigned-integer)             ;   must be zero 
   (data :unsigned-long)                        ;   Will be extended to hold vrWorld QTAtomContainer 
   )

(def-mactype :qtvrsampledescriptionhandle (find-mactype '(:handle :qtvrsampledescription)))
; 
; 	  =================================================================================================
; 	   Definitions and structures used in the VRWorld QTAtomContainer
; 	  -------------------------------------------------------------------------------------------------
; 	

(def-mactype :qtvrstringatomptr (find-mactype '(:pointer :qtvrstringatom)))
(defrecord QTVRStringAtom 
   (stringUsage :unsigned-integer)
   (stringLength :unsigned-integer)
   (theString (:array :unsigned-byte 4 :packed));   field previously named "string" 
   )

(def-mactype :qtvrworldheaderatomptr (find-mactype '(:pointer :qtvrworldheaderatom)))
(defrecord QTVRWorldHeaderAtom 
   (majorVersion :unsigned-integer)
   (minorVersion :unsigned-integer)
   (nameAtomID :signed-long)
   (defaultNodeID :unsigned-long)
   (vrWorldFlags :unsigned-long)
   (reserved1 :unsigned-long)
   (reserved2 :unsigned-long)
   )

;   Valid bits used in QTVRPanoImagingAtom 

(defconstant $kQTVRValidCorrection #x1)
(defconstant $kQTVRValidQuality #x2)
(defconstant $kQTVRValidDirectDraw #x4)
(defconstant $kQTVRValidFirstExtraProperty #x8)

(def-mactype :qtvrpanoimagingatomptr (find-mactype '(:pointer :qtvrpanoimagingatom)))
(defrecord QTVRPanoImagingAtom 
   (majorVersion :unsigned-integer)
   (minorVersion :unsigned-integer)
   (imagingMode :unsigned-long)
   (imagingValidFlags :unsigned-long)
   (correction :unsigned-long)
   (quality :unsigned-long)
   (directDraw :unsigned-long)
   (imagingProperties (:array :unsigned-long 6));   for future properties 
   (reserved1 :unsigned-long)
   (reserved2 :unsigned-long)
   )

(def-mactype :qtvrnodelocationatomptr (find-mactype '(:pointer :qtvrnodelocationatom)))
(defrecord QTVRNodeLocationAtom 
   (majorVersion :unsigned-integer)
   (minorVersion :unsigned-integer)
   (nodeType :ostype)
   (locationFlags :unsigned-long)
   (locationData :unsigned-long)
   (reserved1 :unsigned-long)
   (reserved2 :unsigned-long)
   )

; 
; 	  =================================================================================================
; 	   Definitions and structures used in the Nodeinfo QTAtomContainer
; 	  -------------------------------------------------------------------------------------------------
; 	

(def-mactype :qtvrnodeheaderatomptr (find-mactype '(:pointer :qtvrnodeheaderatom)))
(defrecord QTVRNodeHeaderAtom 
   (majorVersion :unsigned-integer)
   (minorVersion :unsigned-integer)
   (nodeType :ostype)
   (nodeID :signed-long)
   (nameAtomID :signed-long)
   (commentAtomID :signed-long)
   (reserved1 :unsigned-long)
   (reserved2 :unsigned-long)
   )

(def-mactype :qtvranglerangeatomptr (find-mactype '(:pointer :qtvranglerangeatom)))
(defrecord QTVRAngleRangeAtom 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (minimumAngle :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (maximumAngle :single-float)
   )

(def-mactype :qtvrhotspotinfoatomptr (find-mactype '(:pointer :qtvrhotspotinfoatom)))
(defrecord QTVRHotSpotInfoAtom 
   (majorVersion :unsigned-integer)
   (minorVersion :unsigned-integer)
   (hotSpotType :ostype)
   (nameAtomID :signed-long)
   (commentAtomID :signed-long)
   (cursorID (:array :signed-long 3))
;   canonical view for this hot spot 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (bestPan :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (bestTilt :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (bestFOV :single-float)
   (bestViewCenter :qtvrfloatpoint)
;   Bounding box for this hot spot 
   (hotSpotRect :rect)
   (flags :unsigned-long)
   (reserved1 :unsigned-long)
   (reserved2 :unsigned-long)
   )

(def-mactype :qtvrlinkhotspotatomptr (find-mactype '(:pointer :qtvrlinkhotspotatom)))
(defrecord QTVRLinkHotSpotAtom 
   (majorVersion :unsigned-integer)
   (minorVersion :unsigned-integer)
   (toNodeID :unsigned-long)
   (fromValidFlags :unsigned-long)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (fromPan :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (fromTilt :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (fromFOV :single-float)
   (fromViewCenter :qtvrfloatpoint)
   (toValidFlags :unsigned-long)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (toPan :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (toTilt :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (toFOV :single-float)
   (toViewCenter :qtvrfloatpoint)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (distance :single-float)
   (flags :unsigned-long)
   (reserved1 :unsigned-long)
   (reserved2 :unsigned-long)
   )

; 
; 	  =================================================================================================
; 	   Definitions and structures used in Panorama and Object tracks
; 	  -------------------------------------------------------------------------------------------------
; 	

(def-mactype :qtvrpanosampleatomptr (find-mactype '(:pointer :qtvrpanosampleatom)))
(defrecord QTVRPanoSampleAtom 
   (majorVersion :unsigned-integer)
   (minorVersion :unsigned-integer)
   (imageRefTrackIndex :unsigned-long)          ;   track reference index of the full res image track 
   (hotSpotRefTrackIndex :unsigned-long)        ;   track reference index of the full res hot spot track 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (minPan :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (maxPan :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (minTilt :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (maxTilt :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (minFieldOfView :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (maxFieldOfView :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (defaultPan :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (defaultTilt :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (defaultFieldOfView :single-float)
;   Info for highest res version of image track 
   (imageSizeX :unsigned-long)                  ;   pixel width of the panorama (e.g. 768) 
   (imageSizeY :unsigned-long)                  ;   pixel height of the panorama (e.g. 2496) 
   (imageNumFramesX :unsigned-integer)          ;   diced frames wide (e.g. 1) 
   (imageNumFramesY :unsigned-integer)          ;   diced frames high (e.g. 24) 
;   Info for highest res version of hotSpot track 
   (hotSpotSizeX :unsigned-long)                ;   pixel width of the hot spot panorama (e.g. 768) 
   (hotSpotSizeY :unsigned-long)                ;   pixel height of the hot spot panorama (e.g. 2496) 
   (hotSpotNumFramesX :unsigned-integer)        ;   diced frames wide (e.g. 1) 
   (hotSpotNumFramesY :unsigned-integer)        ;   diced frames high (e.g. 24) 
   (flags :unsigned-long)
   (panoType :ostype)
   (reserved2 :unsigned-long)
   )

; 
; 	   View atom for cubes (since same fields in QTVRPanoSampleAtom are set to special
; 	   values for backwards compatibility and hence are ignored by the cubic engine)
; 	
(def-mactype :qtvrcubicviewatomptr (find-mactype '(:pointer :qtvrcubicviewatom)))
(defrecord QTVRCubicViewAtom 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (minPan :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (maxPan :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (minTilt :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (maxTilt :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (minFieldOfView :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (maxFieldOfView :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (defaultPan :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (defaultTilt :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (defaultFieldOfView :single-float)
   )

(def-mactype :qtvrcubicfacedataptr (find-mactype '(:pointer :qtvrcubicfacedata)))
(defrecord QTVRCubicFaceData 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (orientation (:array :single-float 4))       ;   WXYZ quaternion of absolute orientation 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (center (:array :single-float 2))            ;   Center of image relative to center of projection (default = (0,0)) in normalized units 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (aspect :single-float)                       ;   aspect>1 => tall pixels; aspect <1 => squat pixels (default = 1) 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (skew :single-float)                         ;   skew x by y (default = 0) 
   )

;   Special resolution values for the Image Track Reference Atoms. Use only one value per track reference. 

(defconstant $kQTVRFullTrackRes #x1)
(defconstant $kQTVRHalfTrackRes #x2)
(defconstant $kQTVRQuarterTrackRes #x4)
(defconstant $kQTVRPreviewTrackRes #x8000)

(def-mactype :qtvrtrackrefentryptr (find-mactype '(:pointer :qtvrtrackrefentry)))
(defrecord QTVRTrackRefEntry 
   (trackRefType :unsigned-long)
   (trackResolution :unsigned-integer)
   (trackRefIndex :unsigned-long)
   )

; 
; 	  =================================================================================================
; 	   Object File format 2.0
; 	  -------------------------------------------------------------------------------------------------
; 	

(defconstant $kQTVRObjectAnimateViewFramesOn #x1)
(defconstant $kQTVRObjectPalindromeViewFramesOn #x2)
(defconstant $kQTVRObjectStartFirstViewFrameOn #x4)
(defconstant $kQTVRObjectAnimateViewsOn #x8)
(defconstant $kQTVRObjectPalindromeViewsOn #x10)
(defconstant $kQTVRObjectSyncViewToFrameRate #x20)
(defconstant $kQTVRObjectDontLoopViewFramesOn #x40)
(defconstant $kQTVRObjectPlayEveryViewFrameOn #x80)
(defconstant $kQTVRObjectStreamingViewsOn #x100)

(defconstant $kQTVRObjectWrapPanOn #x1)
(defconstant $kQTVRObjectWrapTiltOn #x2)
(defconstant $kQTVRObjectCanZoomOn #x4)
(defconstant $kQTVRObjectReverseHControlOn #x8)
(defconstant $kQTVRObjectReverseVControlOn #x10)
(defconstant $kQTVRObjectSwapHVControlOn #x20)
(defconstant $kQTVRObjectTranslationOn #x40)

(defconstant $kGrabberScrollerUI 1)             ;   "Object"  
(defconstant $kOldJoyStickUI 2)                 ;    "1.0 Object as Scene"      
(defconstant $kJoystickUI 3)                    ;   "Object In Scene" 
(defconstant $kGrabberUI 4)                     ;   "Grabber only" 
(defconstant $kAbsoluteUI 5)                    ;   "Absolute pointer" 

(def-mactype :qtvrobjectsampleatomptr (find-mactype '(:pointer :qtvrobjectsampleatom)))
(defrecord QTVRObjectSampleAtom 
   (majorVersion :unsigned-integer)             ;   kQTVRMajorVersion 
   (minorVersion :unsigned-integer)             ;   kQTVRMinorVersion 
   (movieType :unsigned-integer)                ;   ObjectUITypes 
   (viewStateCount :unsigned-integer)           ;   The number of view states 1 based 
   (defaultViewState :unsigned-integer)         ;   The default view state number. The number must be 1 to viewStateCount 
   (mouseDownViewState :unsigned-integer)       ;   The mouse down view state.   The number must be 1 to viewStateCount 
   (viewDuration :unsigned-long)                ;   The duration of each view including all animation frames in a view 
   (columns :unsigned-long)                     ;   Number of columns in movie 
   (rows :unsigned-long)                        ;   Number rows in movie 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (mouseMotionScale :single-float)             ;   180.0 for kStandardObject or kQTVRObjectInScene, actual degrees for kOldNavigableMovieScene. 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (minPan :single-float)                       ;   Start   horizontal pan angle in degrees 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (maxPan :single-float)                       ;   End     horizontal pan angle in degrees 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (defaultPan :single-float)                   ;   Initial horizontal pan angle in degrees (poster view) 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (minTilt :single-float)                      ;   Start   vertical   pan angle in degrees 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (maxTilt :single-float)                      ;   End     vertical   pan angle in degrees 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (defaultTilt :single-float)                  ;   Initial vertical   pan angle in degrees (poster view)   
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (minFieldOfView :single-float)               ;   minimum field of view setting (appears as the maximum zoom effect) must be >= 1 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (fieldOfView :single-float)                  ;   the field of view range must be >= 1 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (defaultFieldOfView :single-float)           ;   must be in minFieldOfView and maxFieldOfView range inclusive 
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (defaultViewCenterH :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (defaultViewCenterV :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (viewRate :single-float)
#|
; Warning: type-size: unknown type single-float
|##|
; Warning: type-size: unknown type single-float
|#
   (frameRate :single-float)
   (animationSettings :unsigned-long)           ;   32 reserved bit fields 
   (controlSettings :unsigned-long)             ;   32 reserved bit fields 
   )

; 
; 	  =================================================================================================
; 	   QuickTime VR Authoring Components
; 	  -------------------------------------------------------------------------------------------------
; 	

; 
; 	   ComponentDescription constants for QTVR Export components   
; 	    (componentType = MovieExportType; componentSubType = MovieFileType)
; 	

(defconstant $kQTVRFlattenerManufacturer :|vrwe|);   aka QTVRFlattenerType 
(defconstant $kQTVRSplitterManufacturer :|vrsp|)
(defconstant $kQTVRObjExporterManufacturer :|vrob|)

;   QuickTime VR Flattener atom types 
(defconstant $kQTVRFlattenerSettingsParentAtomType :|VRWe|);   parent of settings atoms (other than compression) 
(defconstant $kQTVRFlattenerPreviewResAtomType :|PRes|);   preview resolution Int16 
(defconstant $kQTVRFlattenerImportSpecAtomType :|ISpe|);   import file spec FSSpec 
(defconstant $kQTVRFlattenerCreatePreviewAtomType :|Prev|);   Boolean 
(defconstant $kQTVRFlattenerImportPreviewAtomType :|IPre|);   Boolean 
(defconstant $kQTVRFlattenerBlurPreviewAtomType :|Blur|);   Boolean 

;   QuickTime VR Splitter atom types 
(defconstant $kQTVRSplitterSettingsParentAtomType :|VRSp|);   parent of settings atoms (other than compression) 
(defconstant $kQTVRSplitterGenerateHTMLAtomType :|Ghtm|);   Boolean 
(defconstant $kQTVRSplitterOverwriteFilesAtomType :|Owfi|);   Boolean 
(defconstant $kQTVRSplitterUseFlattenerAtomType :|Usef|);   Boolean 
(defconstant $kQTVRSplitterShowControllerAtomType :|Shco|);   Boolean 
(defconstant $kQTVRSplitterTargetMyselfAtomType :|Tgtm|);   Boolean 

;   QuickTime VR Object Exporter atom types 
(defconstant $kQTVRObjExporterSettingsBlockSize :|bsiz|);   block size for compression 
(defconstant $kQTVRObjExporterSettingsTargetSize :|tsiz|);   target file size 

; $IFC OLDROUTINENAMES 

(%define-record :vrstringatom (find-record-descriptor :qtvrstringatom))
(def-mactype :vrstringatomptr (find-mactype '(:pointer :qtvrstringatom)))
(%define-record :vrworldheaderatom (find-record-descriptor :qtvrworldheaderatom))
(def-mactype :vrworldheaderatomptr (find-mactype '(:pointer :qtvrworldheaderatom)))
(%define-record :vrpanoimagingatom (find-record-descriptor :qtvrpanoimagingatom))
(def-mactype :vrpanoimagingatomptr (find-mactype '(:pointer :qtvrpanoimagingatom)))
(%define-record :vrnodelocationatom (find-record-descriptor :qtvrnodelocationatom))
(def-mactype :vrnodelocationatomptr (find-mactype '(:pointer :qtvrnodelocationatom)))
(%define-record :vrnodeheaderatom (find-record-descriptor :qtvrnodeheaderatom))
(def-mactype :vrnodeheaderatomptr (find-mactype '(:pointer :qtvrnodeheaderatom)))
(%define-record :vranglerangeatom (find-record-descriptor :qtvranglerangeatom))
(def-mactype :vranglerangeatomptr (find-mactype '(:pointer :qtvranglerangeatom)))
(%define-record :vrhotspotinfoatom (find-record-descriptor :qtvrhotspotinfoatom))
(def-mactype :vrhotspotinfoatomptr (find-mactype '(:pointer :qtvrhotspotinfoatom)))
(%define-record :vrlinkhotspotatom (find-record-descriptor :qtvrlinkhotspotatom))
(def-mactype :vrlinkhotspotatomptr (find-mactype '(:pointer :qtvrlinkhotspotatom)))
(%define-record :vrpanosampleatom (find-record-descriptor :qtvrpanosampleatom))
(def-mactype :vrpanosampleatomptr (find-mactype '(:pointer :qtvrpanosampleatom)))
(%define-record :vrtrackrefentry (find-record-descriptor :qtvrtrackrefentry))
(def-mactype :vrtrackrefentryptr (find-mactype '(:pointer :qtvrtrackrefentry)))
(%define-record :vrobjectsampleatom (find-record-descriptor :qtvrobjectsampleatom))
(def-mactype :vrobjectsampleatomptr (find-mactype '(:pointer :qtvrobjectsampleatom)))
; $ENDC                                         ; OLDROUTINENAMES

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QuickTimeVRFormatIncludes

; $ENDC                                         ; __QUICKTIMEVRFORMAT__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'QuickTimeVRFormat)