(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:QuickdrawText.p"
; at Wednesday May 1,2002 2:39:15 pm.
; 
;      File:       QuickdrawText.p
;  
;      Contains:   Quickdraw Text Interfaces.
;  
;      Version:    Technology: Mac OS 8.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1983-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __QUICKDRAWTEXT__
; $SETC __QUICKDRAWTEXT__ := 1

; $I+
; $SETC QuickdrawTextIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __INTLRESOURCES__

(require-interface 'IntlResources)              ; $I IntlResources.p
; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  new CGrafPort bottleneck ("newProc2") function, used in Unicode Text drawing 
; 
;  *  StandardGlyphs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in QuickDrawText 8.5 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_StandardGlyphs" 
      ((dataStream :pointer) (size :unsigned-long)) 
  :osstatus
   () )

;   CharToPixel directions  
(defconstant $leftCaret 0)                      ;  Place caret for left block 
(defconstant $rightCaret -1)                    ;  Place caret for right block 
(defconstant $kHilite 1)                        ;  Direction is SysDirection 

(defconstant $smLeftCaret 0)                    ;  Place caret for left block - obsolete  
(defconstant $smRightCaret -1)                  ;  Place caret for right block - obsolete  
(defconstant $smHilite 1)                       ;  Direction is TESysJust - obsolete  

;  Constants for styleRunPosition argument in PortionLine, DrawJustified, MeasureJustified, CharToPixel, and PixelToChar. 
(defconstant $onlyStyleRun 0)                   ;   This is the only style run on the line  
(defconstant $leftStyleRun 1)                   ;   This is leftmost of multiple style runs on the line  
(defconstant $rightStyleRun 2)                  ;   This is rightmost of multiple style runs on the line  
(defconstant $middleStyleRun 3)                 ;   There are multiple style runs on the line and this is neither the leftmost nor the rightmost.  
(defconstant $smOnlyStyleRun 0)                 ;   obsolete  
(defconstant $smLeftStyleRun 1)                 ;   obsolete  
(defconstant $smRightStyleRun 2)                ;   obsolete  
(defconstant $smMiddleStyleRun 3)               ;   obsolete  

; 	 type for styleRunPosition parameter in PixelToChar etc. 	

(def-mactype :juststylecode (find-mactype ':signed-integer))
; 	 Type for truncWhere parameter in TruncString, TruncText 	
(def-mactype :trunccode (find-mactype ':signed-integer))

;   Constants for truncWhere argument in TruncString and TruncText  
(defconstant $truncEnd 0)                       ;   Truncate at end  
(defconstant $truncMiddle #x4000)               ;   Truncate in middle  
(defconstant $smTruncEnd 0)                     ;   Truncate at end - obsolete  
(defconstant $smTruncMiddle #x4000)             ;   Truncate in middle - obsolete  

;   Constants for TruncString and TruncText results  
(defconstant $notTruncated 0)                   ;   No truncation was necessary  
(defconstant $truncated 1)                      ;   Truncation performed  
(defconstant $truncErr -1)                      ;   General error  
(defconstant $smNotTruncated 0)                 ;   No truncation was necessary - obsolete  
(defconstant $smTruncated 1)                    ;   Truncation performed   - obsolete  
(defconstant $smTruncErr -1)                    ;   General error - obsolete  

(def-mactype :styledlinebreakcode (find-mactype ':signed-byte))

(defconstant $smBreakWord 0)
(defconstant $smBreakChar 1)
(defconstant $smBreakOverflow 2)

; 	QuickTime3.0	
;   Constants for txFlags (which used to be the pad field after txFace)  
(defconstant $tfAntiAlias #x1)
(defconstant $tfUnicode #x2)

(def-mactype :fontinfoptr (find-mactype '(:pointer :fontinfo)))
(defrecord FontInfo 
   (ascent :signed-integer)
   (descent :signed-integer)
   (widMax :signed-integer)
   (leading :signed-integer)
   )

(defrecord FormatOrder (array (:array :signed-integer 1)))
(def-mactype :formatorderptr (find-mactype '(:pointer :formatorder)))
; 	 FormatStatus was moved to TextUtils.i 	
; 	 OffsetTable moved to IntlResources.i 	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	StyleRunDirectionProcPtr = FUNCTION(styleRunIndex: INTEGER; dirParam: UNIV Ptr): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :stylerundirectionprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :stylerundirectionupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :stylerundirectionupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppStyleRunDirectionProcInfo #x390)
; 
; 	 *  NewStyleRunDirectionUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewStyleRunDirectionProc 
(deftrap "_NewStyleRunDirectionUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeStyleRunDirectionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeStyleRunDirectionUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeStyleRunDirectionUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallStyleRunDirectionProc 
(deftrap-inline "_InvokeStyleRunDirectionUPP" 
      ((styleRunIndex :signed-integer) (dirParam :pointer) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  Pixel2Char()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_Pixel2Char" 
      ((textBuf :pointer) (textLen :signed-integer) (slop :signed-integer) (pixelWidth :signed-integer) (leadingEdge (:pointer :boolean)))
   (:stack :signed-integer)
   (:stack-trap #xA8B5 textBuf textLen slop pixelWidth leadingEdge ((+ (ash 33294 16) 20) :signed-longint)))

; 
;  *  Char2Pixel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_Char2Pixel" 
      ((textBuf :pointer) (textLen :signed-integer) (slop :signed-integer) (offset :signed-integer) (direction :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA8B5 textBuf textLen slop offset direction ((+ (ash 33292 16) 22) :signed-longint)))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  PixelToChar()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PixelToChar" 
      ((textBuf :pointer) (textLength :signed-long) (slop :signed-long) (pixelWidth :signed-long) (leadingEdge (:pointer :boolean)) (widthRemaining (:pointer :signed-long)) (styleRunPosition :signed-integer) (numer :point) (denom :point))
   (:stack :signed-integer)
   (:stack-trap #xA8B5 textBuf textLength slop pixelWidth leadingEdge widthRemaining styleRunPosition numer denom ((+ (ash 33314 16) 46) :signed-longint)))

; 
;  *  CharToPixel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CharToPixel" 
      ((textBuf :pointer) (textLength :signed-long) (slop :signed-long) (offset :signed-long) (direction :signed-integer) (styleRunPosition :signed-integer) (numer :point) (denom :point))
   (:stack :signed-integer)
   (:stack-trap #xA8B5 textBuf textLength slop offset direction styleRunPosition numer denom ((+ (ash 33308 16) 48) :signed-longint)))

; 
;  *  DrawJustified()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DrawJustified" 
      ((textPtr :pointer) (textLength :signed-long) (slop :signed-long) (styleRunPosition :signed-integer) (numer :point) (denom :point))
   nil
   (:stack-trap #xA8B5 textPtr textLength slop styleRunPosition numer denom ((+ (ash 32790 16) 50) :signed-longint)))

; 
;  *  MeasureJustified()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_MeasureJustified" 
      ((textPtr :pointer) (textLength :signed-long) (slop :signed-long) (charLocs :pointer) (styleRunPosition :signed-integer) (numer :point) (denom :point))
   nil
   (:stack-trap #xA8B5 textPtr textLength slop charLocs styleRunPosition numer denom ((+ (ash 32794 16) 52) :signed-longint)))

; 
;  *  PortionLine()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PortionLine" 
      ((textPtr :pointer) (textLen :signed-long) (styleRunPosition :signed-integer) (numer :point) (denom :point))
   (:stack :fixed)
   (:stack-trap #xA8B5 textPtr textLen styleRunPosition numer denom ((+ (ash 33810 16) 54) :signed-longint)))

; 
;  *  HiliteText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_HiliteText" 
      ((textPtr :pointer) (textLength :signed-integer) (firstOffset :signed-integer) (secondOffset :signed-integer) (offsets (:pointer :offsettable)))
   nil
   (:stack-trap #xA8B5 textPtr textLength firstOffset secondOffset offsets ((+ (ash 32782 16) 28) :signed-longint)))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  DrawJust()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DrawJust" 
      ((textPtr :pointer) (textLength :signed-integer) (slop :signed-integer))
   nil
   (:stack-trap #xA8B5 textPtr textLength slop ((+ (ash 32776 16) 30) :signed-longint)))

; 
;  *  MeasureJust()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MeasureJust" 
      ((textPtr :pointer) (textLength :signed-integer) (slop :signed-integer) (charLocs :pointer))
   nil
   (:stack-trap #xA8B5 textPtr textLength slop charLocs ((+ (ash 32780 16) 32) :signed-longint)))

; 
;  *  PortionText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_PortionText" 
      ((textPtr :pointer) (textLength :signed-long))
   (:stack :fixed)
   (:stack-trap #xA8B5 textPtr textLength ((+ (ash 33800 16) 36) :signed-longint)))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  VisibleLength()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_VisibleLength" 
      ((textPtr :pointer) (textLength :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA8B5 textPtr textLength ((+ (ash 33800 16) 40) :signed-longint)))

; 
;  *  GetFormatOrder()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetFormatOrder" 
      ((ordering (:pointer :formatorder)) (firstFormat :signed-integer) (lastFormat :signed-integer) (lineRight :boolean) (rlDirProc :pointer) (dirParam :pointer))
   nil
   (:stack-trap #xA8B5 ordering firstFormat lastFormat lineRight rlDirProc dirParam ((+ (ash 32786 16) 65532) :signed-longint)))

; 
;  *  TextFont()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TextFont" 
      ((font :signed-integer))
   nil
   (:stack-trap #xA887))

; 
;  *  TextFace()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TextFace" 
      ((face (:unsigned-byte :set (#:bold #:italic #:underline #:outline shadow #:condense #:extend))))
   nil
   (:stack-trap #xA888))

; 
;  *  TextMode()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TextMode" 
      ((mode :signed-integer))
   nil
   (:stack-trap #xA889))

; 
;  *  TextSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TextSize" 
      ((size :signed-integer))
   nil
   (:stack-trap #xA88A))

; 
;  *  SpaceExtra()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SpaceExtra" 
      ((extra :signed-long))
   nil
   (:stack-trap #xA88E))

; 
;  *  DrawChar()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DrawChar" 
      ((ch :character))
   nil
   (:stack-trap #xA883))

; 
;  *  DrawString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DrawString" 
      ((s (:string 255)))
   nil
   (:stack-trap #xA884))

; 
;  *  [Mac]DrawText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DrawText" 
      ((textBuf :pointer) (firstByte :signed-integer) (byteCount :signed-integer))
   nil
   (:stack-trap #xA885))

; 
;  *  CharWidth()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CharWidth" 
      ((ch :character))
   (:stack :signed-integer)
   (:stack-trap #xA88D))

; 
;  *  StringWidth()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_StringWidth" 
      ((s (:string 255)))
   (:stack :signed-integer)
   (:stack-trap #xA88C))

; 
;  *  TextWidth()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TextWidth" 
      ((textBuf :pointer) (firstByte :signed-integer) (byteCount :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA886))

; 
;  *  MeasureText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_MeasureText" 
      ((count :signed-integer) (textAddr :pointer) (charLocs :pointer))
   nil
   (:stack-trap #xA837))

; 
;  *  GetFontInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetFontInfo" 
      ((info (:pointer :fontinfo)))
   nil
   (:stack-trap #xA88B))

; 
;  *  CharExtra()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CharExtra" 
      ((extra :signed-long))
   nil
   (:stack-trap #xAA23))

; 
;  *  StdText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_StdText" 
      ((count :signed-integer) (textAddr :pointer) (numer :point) (denom :point))
   nil
   (:stack-trap #xA882))

; 
;  *  StdTxMeas()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_StdTxMeas" 
      ((byteCount :signed-integer) (textAddr :pointer) (numer (:pointer :point)) (denom (:pointer :point)) (info (:pointer :fontinfo)))
   (:stack :signed-integer)
   (:stack-trap #xA8ED))

; 
;  *  StyledLineBreak()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_StyledLineBreak" 
      ((textPtr :pointer) (textLen :signed-long) (textStart :signed-long) (textEnd :signed-long) (flags :signed-long) (textWidth (:pointer :signed-long)) (textOffset (:pointer :signed-long)))
   (:stack :styledlinebreakcode)
   (:stack-trap #xA8B5 textPtr textLen textStart textEnd flags textWidth textOffset ((+ (ash 33308 16) 65534) :signed-longint)))

; 
;  *  TruncString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TruncString" 
      ((width :signed-integer) (theString (:pointer (:string 255))) (truncWhere :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA8B5 width theString truncWhere ((+ (ash 33288 16) 65504) :signed-longint)))

; 
;  *  TruncText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TruncText" 
      ((width :signed-integer) (textPtr :pointer) (length (:pointer :signed-integer)) (truncWhere :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA8B5 width textPtr length truncWhere ((+ (ash 33292 16) 65502) :signed-longint)))

; $IFC OLDROUTINENAMES 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  NPixel2Char()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_NPixel2Char" 
      ((textBuf :pointer) (textLength :signed-long) (slop :signed-long) (pixelWidth :signed-long) (leadingEdge (:pointer :boolean)) (widthRemaining (:pointer :signed-long)) (styleRunPosition :signed-integer) (numer :point) (denom :point))
   (:stack :signed-integer)
   (:stack-trap #xA8B5 textBuf textLength slop pixelWidth leadingEdge widthRemaining styleRunPosition numer denom ((+ (ash 33314 16) 46) :signed-longint)))

; 
;  *  NChar2Pixel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_NChar2Pixel" 
      ((textBuf :pointer) (textLength :signed-long) (slop :signed-long) (offset :signed-long) (direction :signed-integer) (styleRunPosition :signed-integer) (numer :point) (denom :point))
   (:stack :signed-integer)
   (:stack-trap #xA8B5 textBuf textLength slop offset direction styleRunPosition numer denom ((+ (ash 33308 16) 48) :signed-longint)))

; 
;  *  NDrawJust()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_NDrawJust" 
      ((textPtr :pointer) (textLength :signed-long) (slop :signed-long) (styleRunPosition :signed-integer) (numer :point) (denom :point))
   nil
   (:stack-trap #xA8B5 textPtr textLength slop styleRunPosition numer denom ((+ (ash 32790 16) 50) :signed-longint)))

; 
;  *  NMeasureJust()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_NMeasureJust" 
      ((textPtr :pointer) (textLength :signed-long) (slop :signed-long) (charLocs :pointer) (styleRunPosition :signed-integer) (numer :point) (denom :point))
   nil
   (:stack-trap #xA8B5 textPtr textLength slop charLocs styleRunPosition numer denom ((+ (ash 32794 16) 52) :signed-longint)))

; 
;  *  NPortionText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_NPortionText" 
      ((textPtr :pointer) (textLen :signed-long) (styleRunPosition :signed-integer) (numer :point) (denom :point))
   (:stack :signed-long)
   (:stack-trap #xA8B5 textPtr textLen styleRunPosition numer denom ((+ (ash 33810 16) 54) :signed-longint)))

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; OLDROUTINENAMES

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := QuickdrawTextIncludes

; $ENDC                                         ; __QUICKDRAWTEXT__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'QuickdrawText)