(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:ROMDefs.p"
; at Wednesday May 1,2002 2:42:49 pm.
; 
;      File:       ROMDefs.p
;  
;      Contains:   NuBus card ROM Definitions.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1986-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __ROMDEFS__
; $SETC __ROMDEFS__ := 1

; $I+
; $SETC ROMDefsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $appleFormat 1)                    ;  Format of Declaration Data (IEEE will assign real value) 
(defconstant $romRevision 1)                    ;  Revision of Declaration Data Format 
(defconstant $romRevRange 9)                    ;  Revision of Declaration Data Format [1..9] 
(defconstant $testPattern 1519594439)           ;  FHeader long word test pattern 
(defconstant $sCodeRev 2)                       ;  Revision of code (For sExec) 
(defconstant $sExec2 2)
(defconstant $sCPU68000 1)                      ;  CPU type = 68000 
(defconstant $sCPU68020 2)                      ;  CPU type = 68020 
(defconstant $sCPU68030 3)                      ;  CPU type = 68030 
(defconstant $sCPU68040 4)                      ;  CPU type = 68040 
(defconstant $sMacOS68000 1)                    ;  Mac OS, CPU type = 68000 
(defconstant $sMacOS68020 2)                    ;  Mac OS, CPU type = 68020 
(defconstant $sMacOS68030 3)                    ;  Mac OS, CPU type = 68030 
(defconstant $sMacOS68040 4)                    ;  Mac OS, CPU type = 68040 
(defconstant $board 0)                          ;  Board sResource - Required on all boards 
(defconstant $displayVideoAppleTFB 16843009)    ;  Video with Apple parameters for TFB card. 
(defconstant $displayVideoAppleGM 16843010)     ;  Video with Apple parameters for GM card. 
(defconstant $networkEtherNetApple3Com 33620225);  Ethernet with apple parameters for 3-Comm card. 
(defconstant $testSimpleAppleAny -2147417856)   ;  A simple test sResource. 
(defconstant $endOfList 255)                    ;  End of list 
(defconstant $defaultTO 100)                    ;  100 retries. 

;   sResource flags for sRsrc_Flags  
(defconstant $fOpenAtStart 1)                   ;   set => open the driver at start time, else do not  
(defconstant $f32BitMode 2)                     ;   set => a 32-bit address will be put into dctlDevBase (IM Devices 2-54)  

(defconstant $sRsrcType 1)                      ;  Type of sResource 
(defconstant $sRsrcName 2)                      ;  Name of sResource 
(defconstant $sRsrcIcon 3)                      ;  Icon 
(defconstant $sRsrcDrvrDir 4)                   ;  Driver directory 
(defconstant $sRsrcLoadDir 5)                   ;  Load directory 
(defconstant $sRsrcBootRec 6)                   ;  sBoot record 
(defconstant $sRsrcFlags 7)                     ;  sResource Flags 
(defconstant $sRsrcHWDevId 8)                   ;  Hardware Device Id 
(defconstant $minorBaseOS 10)                   ;  Offset to base of sResource in minor space. 
(defconstant $minorLength 11)                   ;  Length of sResources address space in standard slot space. 
(defconstant $majorBaseOS 12)                   ;  Offset to base of sResource in Major space. 
(defconstant $majorLength 13)                   ;  Length of sResource in super slot space. 
(defconstant $sRsrcTest 14)                     ;  sBlock diagnostic code 
(defconstant $sRsrccicn 15)                     ;  Color icon 
(defconstant $sRsrcicl8 16)                     ;  8-bit (indexed) icon 
(defconstant $sRsrcicl4 17)                     ;  4-bit (indexed) icon 
(defconstant $sDRVRDir 16)                      ;  sDriver directory 
(defconstant $sGammaDir 64)                     ;  sGamma directory 
(defconstant $sRsrcVidNames 65)                 ;  Video mode name directory 
(defconstant $sRsrcDock 80)                     ;  spID for Docking Handlers 
(defconstant $sDiagRec 85)                      ;  spID for board diagnostics 
(defconstant $sVidAuxParams 123)                ;  more video info for Display Manager -- timing information 
(defconstant $sDebugger 124)                    ;  DatLstEntry for debuggers indicating video anamolies 
(defconstant $sVidAttributes 125)               ;  video attributes data field (optional,word) 
(defconstant $fLCDScreen 0)                     ;   bit 0 - when set is LCD, else is CRT 
(defconstant $fBuiltInDisplay 1)                ;        1 - when set is built-in (in the box) display, else not 
(defconstant $fDefaultColor 2)                  ;        2 - when set display prefers multi-bit color, else gray 
(defconstant $fActiveBlack 3)                   ;        3 - when set black on display must be written, else display is naturally black 
(defconstant $fDimMinAt1 4)                     ;        4 - when set should dim backlight to level 1 instead of 0 
(defconstant $fBuiltInDetach 4)                 ;        4 - when set is built-in (in the box), but detaches 
(defconstant $sVidParmDir 126)
(defconstant $sBkltParmDir 140)                 ;  directory of backlight tables 
(defconstant $stdBkltTblSize 36)                ;  size of standard 0..31-entry backlight table 
(defconstant $sSuperDir 254)

; 	 =======================================================================  	
; 	 sResource types                                                          	
; 	 =======================================================================  	
(defconstant $catBoard #x1)                     ;  Category for board types. 
(defconstant $catTest #x2)                      ;  Category for test types -- not used much. 
(defconstant $catDisplay #x3)                   ;  Category for display (video) cards. 
(defconstant $catNetwork #x4)                   ;  Category for Networking cards. 
(defconstant $catScanner #x8)                   ;  scanners bring in data somehow 
(defconstant $catCPU #xA)
(defconstant $catIntBus #xC)
(defconstant $catProto #x11)
(defconstant $catDock #x20)                     ;  <Type> 
(defconstant $typeBoard #x0)
(defconstant $typeApple #x1)
(defconstant $typeVideo #x1)
(defconstant $typeEtherNet #x1)
(defconstant $typeStation #x1)
(defconstant $typeDesk #x2)
(defconstant $typeTravel #x3)
(defconstant $typeDSP #x4)
(defconstant $typeXPT #xB)
(defconstant $typeSIM #xC)
(defconstant $typeDebugger #x100)
(defconstant $type68000 #x2)
(defconstant $type68020 #x3)
(defconstant $type68030 #x4)
(defconstant $type68040 #x5)
(defconstant $type601 #x25)
(defconstant $type603 #x2E)
(defconstant $typeAppleII #x15)                 ;  Driver Interface : <id.SW> 
(defconstant $drSwMacCPU 0)
(defconstant $drSwAppleIIe #x1)
(defconstant $drSwApple 1)                      ;  To ask for or define an Apple-compatible SW device. 
(defconstant $drSwMacsBug #x104)
(defconstant $drSwDepewEngineering #x101)       ;  Driver Interface : <id.SW><id.HW> 
(defconstant $drHwTFB 1)                        ;  HW ID for the TFB (original Mac II) video card. 
(defconstant $drHw3Com 1)                       ;  HW ID for the Apple EtherTalk card. 
(defconstant $drHwBSC 3)
(defconstant $drHwGemini 1)
(defconstant $drHwDeskBar 1)
(defconstant $drHwHooperDock 2)                 ;  Hoopers CatDock,TypeDesk,DrSwApple ID; registered with DTS. 
(defconstant $drHwATT3210 #x1)
(defconstant $drHwBootBug #x100)
(defconstant $drHwMicroDock #x100)              ;   video hardware id's  - <catDisplay><typVideo> 
(defconstant $drHwSTB3 #x2)                     ;   Assigned by Kevin Mellander for STB-3 hardware.  
(defconstant $drHwSTB #x2)                      ;   (Both STB-3 and STB-4 share the same video hardware.)  
(defconstant $drHwRBV #x18)                     ;   IIci Aurora25/16 hw ID  
(defconstant $drHwJMFB #x19)                    ;   48/824 NuBus card  
(defconstant $drHwElsie #x1A)
(defconstant $drHwTim #x1B)
(defconstant $drHwDAFB #x1C)
(defconstant $drHwDolphin #x1D)                 ;   824GC NuBus card  
(defconstant $drHwGSC #x1E)                     ;   (Renamed from GSC drHWDBLite)  
(defconstant $drHwDAFBPDS #x1F)
(defconstant $drHWVSC #x20)
(defconstant $drHwApollo #x21)
(defconstant $drHwSonora #x22)
(defconstant $drHwReserved2 #x23)
(defconstant $drHwColumbia #x24)
(defconstant $drHwCivic #x25)
(defconstant $drHwBrazil #x26)
(defconstant $drHWPBLCD #x27)
(defconstant $drHWCSC #x28)
(defconstant $drHwJET #x29)
(defconstant $drHWMEMCjr #x2A)
(defconstant $drHwBoogie #x2B)                  ;   824AC nuBus video card (built by Radius)  
(defconstant $drHwHPV #x2C)                     ;   High performance Video (HPV) PDS card for original PowerMacs  
(defconstant $drHwPlanaria #x2D)                ;  PowerMac 6100/7100/8100 PDS AV video 
(defconstant $drHwValkyrie #x2E)
(defconstant $drHwKeystone #x2F)
(defconstant $drHWATI #x55)
(defconstant $drHwGammaFormula #x56)            ;   Use for gType of display mgr gamma tables  
;   other drHW id's for built-in functions 
(defconstant $drHwSonic #x110)
(defconstant $drHwMace #x114)
(defconstant $drHwDblExp #x1)                   ;   CPU board IDs - <catBoard> <typBoard> <0000> <0000> 
(defconstant $MIIBoardId #x10)                  ;  Mac II Board ID 
(defconstant $ciVidBoardID #x1F)                ;  Aurora25 board ID 
(defconstant $CX16VidBoardID #x20)              ;  Aurora16 board ID 
(defconstant $MIIxBoardId #x21)                 ;  Mac IIx Board ID 
(defconstant $SE30BoardID #x22)                 ;  Mac SE/30 Board ID 
(defconstant $MIIcxBoardId #x23)                ;  Mac IIcx Board ID 
(defconstant $MIIfxBoardId #x24)                ;  F19 board ID 
(defconstant $EricksonBoardID #x28)
(defconstant $ElsieBoardID #x29)
(defconstant $TIMBoardID #x2A)
(defconstant $EclipseBoardID #x2B)
(defconstant $SpikeBoardID #x33)
(defconstant $DBLiteBoardID #x35)
(defconstant $ZydecoBrdID #x36)
(defconstant $ApolloBoardID #x38)
(defconstant $PDMBrdID #x39)
(defconstant $VailBoardID #x3A)
(defconstant $WombatBrdID #x3B)
(defconstant $ColumbiaBrdID #x3C)
(defconstant $CycloneBrdID #x3D)
(defconstant $CompanionBrdID #x3E)
(defconstant $DartanianBoardID #x40)
(defconstant $DartExtVidBoardID #x46)
(defconstant $HookBoardID #x47)                 ;  Hook internal video board ID 
(defconstant $EscherBoardID #x4A)               ;  Board ID for Escher (CSC) 
(defconstant $POBoardID #x4D)                   ;  Board ID for Primus/Optimus/Aladdin 
(defconstant $TempestBrdID #x50)                ;  Non-official Board ID for Tempest 
(defconstant $BlackBirdBdID #x58)               ;  Board ID for BlackBird 
(defconstant $BBExtVidBdID #x59)                ;  Board ID for BlackBird built-in external video 
(defconstant $YeagerBoardID #x5A)               ;  Board ID for Yeager 
(defconstant $BBEtherNetBdID #x5E)              ;  Board ID for BlackBird Ethernet board 
(defconstant $TELLBoardID #x65)                 ;  Board ID for TELL (Valkyrie) 
(defconstant $MalcolmBoardID #x65E)             ;  Board ID for Malcolm 
(defconstant $AJBoardID #x65F)                  ;  Board ID for AJ 
(defconstant $M2BoardID #x660)                  ;  Board ID for M2 
(defconstant $OmegaBoardID #x661)               ;  Board ID for Omega 
(defconstant $TNTBoardID #x670)                 ;  Board ID for TNT/Alchemy/Hipclipper CPUs (did Nano just make this up?) 
(defconstant $HooperBoardID #x6CD)              ;  Board ID for Hooper 
;   other board IDs 
(defconstant $BoardIDDblExp #x2F)
(defconstant $DAFBPDSBoardID #x37)
(defconstant $MonetBoardID #x48)
(defconstant $SacSONIC16BoardID #x4E)
(defconstant $SacSONIC32BoardID #x4F)           ;   CPU board types - <CatCPU> <Typ680x0> <DrSwMacCPU> 
(defconstant $drHWMacII #x1)                    ;  Mac II hw ID 
(defconstant $drHwMacIIx #x2)                   ;  Mac IIx hw ID 
(defconstant $drHWSE30 #x3)                     ;  Mac SE/30 hw ID 
(defconstant $drHwMacIIcx #x4)                  ;  Mac IIcx hw ID 
(defconstant $drHWMacIIfx #x5)                  ;  Mac IIfx hw ID 
(defconstant $drHWF19 #x5)                      ;  F19 hw ID 
(defconstant $sBlockTransferInfo 20)            ;  general slot block xfer info 
(defconstant $sMaxLockedTransferCount 21)       ;  slot max. locked xfer count 
(defconstant $boardId 32)                       ;  Board Id 
(defconstant $pRAMInitData 33)                  ;  sPRAM init data 
(defconstant $primaryInit 34)                   ;  Primary init record 
(defconstant $timeOutConst 35)                  ;  Time out constant 
(defconstant $vendorInfo 36)                    ;  Vendor information List. See Vendor List, below 
(defconstant $boardFlags 37)                    ;  Board Flags 
(defconstant $secondaryInit 38)                 ;  Secondary init record/code 
;   The following Id's are associated with all CPU sResources. 
(defconstant $MajRAMSp 129)                     ;  ID of Major RAM space. 
(defconstant $MinROMSp 130)                     ;  ID of Minor ROM space. 
(defconstant $vendorId 1)                       ;  Vendor Id 
(defconstant $serialNum 2)                      ;  Serial number 
(defconstant $revLevel 3)                       ;  Revision level 
(defconstant $partNum 4)                        ;  Part number 
(defconstant $date 5)                           ;  Last revision date of the card 

(defconstant $testByte 32)                      ;  Test byte. 
(defconstant $testWord 33)                      ;  0021 
(defconstant $testLong 34)                      ;  Test Long. 
(defconstant $testString 35)                    ;  Test String. 

; 	 sResource List. Category: Display        Type: Video 	
; 	 The following Id's are common to all Mode sResources in Display_Video 	
; 	 functional sResources. 	
(defconstant $mBlockTransferInfo 5)             ;   slot block xfer info PER MODE  
(defconstant $mMaxLockedTransferCount 6)        ;   slot max. locked xfer count PER MODE  

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := ROMDefsIncludes

; $ENDC                                         ; __ROMDEFS__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'ROMDefs)