(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Resources.p"
; at Wednesday May 1,2002 2:39:59 pm.
; 
;      File:       Resources.p
;  
;      Contains:   Resource Manager Interfaces.
;  
;      Version:    Technology: Mac OS 8.1
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __RESOURCES__
; $SETC __RESOURCES__ := 1

; $I+
; $SETC ResourcesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $resSysHeap 64)                    ;  System or application heap? 
(defconstant $resPurgeable 32)                  ;  Purgeable resource? 
(defconstant $resLocked 16)                     ;  Load it in locked? 
(defconstant $resProtected 8)                   ;  Protected? 
(defconstant $resPreload 4)                     ;  Load in on OpenResFile? 
(defconstant $resChanged 2)                     ;  Resource changed? 
(defconstant $mapReadOnly 128)                  ;  Resource file read-only 
(defconstant $mapCompact 64)                    ;  Compact resource file 
(defconstant $mapChanged 32)                    ;  Write map out at update 

(defconstant $resSysRefBit 7)                   ;  reference to system/local reference 
(defconstant $resSysHeapBit 6)                  ;  In system/in application heap 
(defconstant $resPurgeableBit 5)                ;  Purgeable/not purgeable 
(defconstant $resLockedBit 4)                   ;  Locked/not locked 
(defconstant $resProtectedBit 3)                ;  Protected/not protected 
(defconstant $resPreloadBit 2)                  ;  Read in at OpenResource? 
(defconstant $resChangedBit 1)                  ;  Existing resource changed since last update 
(defconstant $mapReadOnlyBit 7)                 ;  is this file read-only? 
(defconstant $mapCompactBit 6)                  ;  Is a compact necessary? 
(defconstant $mapChangedBit 5)                  ;  Is it necessary to write map? 

(defconstant $kResFileNotOpened -1)             ;  ref num return as error when opening a resource file 
(defconstant $kSystemResFile 0)                 ;  this is the default ref num to the system file 

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ResErrProcPtr = PROCEDURE(thErr: OSErr);

|#
 |#                                             ; $ELSEC
(def-mactype :reserrprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :reserrupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :reserrupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppResErrProcInfo #x1002)
; 
; 	 *  NewResErrUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewResErrProc 
(deftrap "_NewResErrUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeResErrUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeResErrUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeResErrUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallResErrProc                  ;   QuickTime 3.0 
(deftrap-inline "_InvokeResErrUPP" 
      ((thErr :signed-integer) (userRoutine :pointer)) 
  nil
   () )
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ResourceEndianFilterPtr = FUNCTION(theResource: Handle; currentlyNativeEndian: BOOLEAN): OSErr;

|#
 |#                                             ; $ELSEC
(def-mactype :resourceendianfilterptr (find-mactype ':pointer))
; $ENDC

; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  InitResources()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_InitResources" 
      ()
   (:stack :signed-integer)
   (:stack-trap #xA995))

; 
;  *  RsrcZoneInit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_RsrcZoneInit" 
      ()
   nil
   (:stack-trap #xA996))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  CloseResFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CloseResFile" 
      ((refNum :signed-integer))
   nil
   (:stack-trap #xA99A))

; 
;  *  ResError()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ResError" 
      ()
   (:stack :signed-integer)
   (:stack-trap #xA9AF))

; 
;  *  CurResFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CurResFile" 
      ()
   (:stack :signed-integer)
   (:stack-trap #xA994))

; 
;  *  HomeResFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_HomeResFile" 
      ((theResource :handle))
   (:stack :signed-integer)
   (:stack-trap #xA9A4))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  CreateResFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CreateResFile" 
      ((fileName (:string 255)))
   nil
   (:stack-trap #xA9B1))

; 
;  *  OpenResFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_OpenResFile" 
      ((fileName (:string 255)))
   (:stack :signed-integer)
   (:stack-trap #xA997))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  UseResFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_UseResFile" 
      ((refNum :signed-integer))
   nil
   (:stack-trap #xA998))

; 
;  *  CountTypes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CountTypes" 
      ()
   (:stack :signed-integer)
   (:stack-trap #xA99E))

; 
;  *  Count1Types()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_Count1Types" 
      ()
   (:stack :signed-integer)
   (:stack-trap #xA81C))

; 
;  *  GetIndType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetIndType" 
      ((theType (:pointer :ostype)) (index :signed-integer))
   nil
   (:stack-trap #xA99F))

; 
;  *  Get1IndType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_Get1IndType" 
      ((theType (:pointer :ostype)) (index :signed-integer))
   nil
   (:stack-trap #xA80F))

; 
;  *  SetResLoad()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetResLoad" 
      ((load :boolean))
   nil
   (:stack-trap #xA99B))

; 
;  *  CountResources()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CountResources" 
      ((theType :ostype))
   (:stack :signed-integer)
   (:stack-trap #xA99C))

; 
;  *  Count1Resources()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_Count1Resources" 
      ((theType :ostype))
   (:stack :signed-integer)
   (:stack-trap #xA80D))

; 
;  *  GetIndResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetIndResource" 
      ((theType :ostype) (index :signed-integer))
   (:stack :handle)
   (:stack-trap #xA99D))

; 
;  *  Get1IndResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_Get1IndResource" 
      ((theType :ostype) (index :signed-integer))
   (:stack :handle)
   (:stack-trap #xA80E))

; 
;  *  GetResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetResource" 
      ((theType :ostype) (theID :signed-integer))
   (:stack :handle)
   (:stack-trap #xA9A0))

; 
;  *  Get1Resource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_Get1Resource" 
      ((theType :ostype) (theID :signed-integer))
   (:stack :handle)
   (:stack-trap #xA81F))

; 
;  *  GetNamedResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetNamedResource" 
      ((theType :ostype) (name (:string 255)))
   (:stack :handle)
   (:stack-trap #xA9A1))

; 
;  *  Get1NamedResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_Get1NamedResource" 
      ((theType :ostype) (name (:string 255)))
   (:stack :handle)
   (:stack-trap #xA820))

; 
;  *  [Mac]LoadResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LoadResource" 
      ((theResource :handle))
   nil
   (:stack-trap #xA9A2))

; 
;  *  ReleaseResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ReleaseResource" 
      ((theResource :handle))
   nil
   (:stack-trap #xA9A3))

; 
;  *  DetachResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DetachResource" 
      ((theResource :handle))
   nil
   (:stack-trap #xA992))

; 
;  *  UniqueID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_UniqueID" 
      ((theType :ostype))
   (:stack :signed-integer)
   (:stack-trap #xA9C1))

; 
;  *  Unique1ID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_Unique1ID" 
      ((theType :ostype))
   (:stack :signed-integer)
   (:stack-trap #xA810))

; 
;  *  GetResAttrs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetResAttrs" 
      ((theResource :handle))
   (:stack :signed-integer)
   (:stack-trap #xA9A6))

; 
;  *  GetResInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetResInfo" 
      ((theResource :handle) (theID (:pointer :signed-integer)) (theType (:pointer :ostype)) (name (:pointer (:string 255))))
   nil
   (:stack-trap #xA9A8))

; 
;  *  SetResInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetResInfo" 
      ((theResource :handle) (theID :signed-integer) (name (:string 255)))
   nil
   (:stack-trap #xA9A9))

; 
;  *  AddResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_AddResource" 
      ((theData :handle) (theType :ostype) (theID :signed-integer) (name (:string 255)))
   nil
   (:stack-trap #xA9AB))

; 
;  *  GetResourceSizeOnDisk()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetResourceSizeOnDisk" 
      ((theResource :handle))
   (:stack :signed-long)
   (:stack-trap #xA9A5))

; 
;  *  GetMaxResourceSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetMaxResourceSize" 
      ((theResource :handle))
   (:stack :signed-long)
   (:stack-trap #xA821))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  RsrcMapEntry()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_RsrcMapEntry" 
      ((theResource :handle))
   (:stack :signed-long)
   (:stack-trap #xA9C5))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  SetResAttrs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetResAttrs" 
      ((theResource :handle) (attrs :signed-integer))
   nil
   (:stack-trap #xA9A7))

; 
;  *  ChangedResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ChangedResource" 
      ((theResource :handle))
   nil
   (:stack-trap #xA9AA))

; 
;  *  RemoveResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_RemoveResource" 
      ((theResource :handle))
   nil
   (:stack-trap #xA9AD))

; 
;  *  UpdateResFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_UpdateResFile" 
      ((refNum :signed-integer))
   nil
   (:stack-trap #xA999))

; 
;  *  WriteResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_WriteResource" 
      ((theResource :handle))
   nil
   (:stack-trap #xA9B0))

; 
;  *  SetResPurge()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetResPurge" 
      ((install :boolean))
   nil
   (:stack-trap #xA993))

; 
;  *  GetResFileAttrs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetResFileAttrs" 
      ((refNum :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA9F6))

; 
;  *  SetResFileAttrs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetResFileAttrs" 
      ((refNum :signed-integer) (attrs :signed-integer))
   nil
   (:stack-trap #xA9F7))

; 
;  *  OpenRFPerm()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OpenRFPerm" 
      ((fileName (:string 255)) (vRefNum :signed-integer) (permission :signed-byte))
   (:stack :signed-integer)
   (:stack-trap #xA9C4))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  RGetResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_RGetResource" 
      ((theType :ostype) (theID :signed-integer))
   (:stack :handle)
   (:stack-trap #xA80C))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  HOpenResFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_HOpenResFile" 
      ((vRefNum :signed-integer) (dirID :signed-long) (fileName (:string 255)) (permission :signed-byte))
   (:stack :signed-integer)
   (:stack-trap #xA81A))

; 
;  *  HCreateResFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_HCreateResFile" 
      ((vRefNum :signed-integer) (dirID :signed-long) (fileName (:string 255)))
   nil
   (:stack-trap #xA81B))

; 
;  *  FSpOpenResFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_FSpOpenResFile" 
      ((spec (:pointer :fsspec)) (permission :signed-byte))
   (:stack :signed-integer)
   (:stack-trap #xAA52 :d0 13 spec permission))

; 
;  *  FSpCreateResFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_FSpCreateResFile" 
      ((spec (:pointer :fsspec)) (creator :ostype) (fileType :ostype) (scriptTag :signed-integer))
   nil
   (:stack-trap #xAA52 :d0 14 spec creator fileType scriptTag))

; 
;  *  ReadPartialResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ReadPartialResource" 
      ((theResource :handle) (offset :signed-long) (buffer :pointer) (count :signed-long))
   nil
   (:stack-trap #xA822 :d0 1 theResource offset buffer count))

; 
;  *  WritePartialResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_WritePartialResource" 
      ((theResource :handle) (offset :signed-long) (buffer :pointer) (count :signed-long))
   nil
   (:stack-trap #xA822 :d0 2 theResource offset buffer count))

; 
;  *  SetResourceSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetResourceSize" 
      ((theResource :handle) (newSize :signed-long))
   nil
   (:stack-trap #xA822 :d0 3 theResource newSize))

; 
;  *  GetNextFOND()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetNextFOND" 
      ((fondHandle :handle))
   (:stack :handle)
   (:stack-trap #xA822 :d0 10 fondHandle))

;   QuickTime 3.0 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  RegisterResourceEndianFilter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_RegisterResourceEndianFilter" 
      ((theType :ostype) (theFilterProc :pointer)) 
  :signed-integer
   () )

;  Use TempInsertROMMap to force the ROM resource map to be
;    inserted into the chain in front of the system. Note that
;    this call is only temporary - the modified resource chain
;    is only used for the next call to the resource manager.
;    See IM IV 19 for more information. 
; 
; 
;  *  TempInsertROMMap()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_TempInsertROMMap" 
      ((tempResLoad :boolean)) 
  nil
   (#x70FF #x4A1F #x56C0 #x31C0 #xB9E) )

; 
;   _________________________________________________________________________________________________________
;       
;     RESOURCE CHAIN LOCATION - for use with the Resource Manager chain manipulation routines under Carbon.
;   _________________________________________________________________________________________________________
; 

; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :rsrcchainlocation (find-mactype ':signed-integer))

(defconstant $kRsrcChainBelowSystemMap 0)       ;   Below the system's resource map 
(defconstant $kRsrcChainBelowApplicationMap 1)  ;   Below the application's resource map 
(defconstant $kRsrcChainAboveApplicationMap 2)  ;   Above the application's resource map 
(defconstant $kRsrcChainAboveAllMaps 4)         ;   Above all resource maps 

; 
; 	   If the file is already in the resource chain, it is removed and re-inserted at the specified location
; 	   If the file has been detached, it is added to the resource chain at the specified location
; 	   Returns resFNotFound if it's not currently open.
; 	
; 
; 	 *  InsertResourceFile()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; 
;    If the file is not currently in the resource chain, this returns resNotFound
;    Otherwise, the resource file is removed from the resource chain.
;                                               ; 
;  *  DetachResourceFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_InsertResourceFile" 
      ((refNum :signed-integer) (where :signed-integer)) 
  :signed-integer
   () )                                         ; 
;    Returns true if the resource file is already open and known by the Resource Manager (i.e., it is
;    either in the current resource chain or it's a detached resource file.)  If it's in the resource 
;    chain, the inChain Boolean is set to true on exit and true is returned.  If it's an open file, but
;    the file is currently detached, inChain is set to false and true is returned.  If the file is open,
;    the refNum to the file is returned.
;                                               ; 
;  *  FSpResourceFileAlreadyOpen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_DetachResourceFile" 
      ((refNum :signed-integer)) 
  :signed-integer
   () )                                         ; CONST
(deftrap "_FSpResourceFileAlreadyOpen" 
      ((resourceFile (:pointer :fsspec)) (inChain (:pointer :boolean)) (refNum (:pointer :signed-integer)))
   (:stack :boolean)
   (:stack-trap #xA822 :d0 16 resourceFile inChain refNum))

; 
;    FSpOpenOrphanResFile should be used to open a resource file that is persistent across all contexts,
;    because using OpenResFile normally loads a map and all preloaded resources into the application
;    context.  FSpOpenOrphanResFile loads everything into the system context and detaches the file 
;    from the context in which it was opened.  If the file is already in the resource chain and a new
;    instance is not opened, FSpOpenOrphanResFile will return a paramErr.
;    Use with care, as can and will fail if the map is very large or a lot of preload
;    resources exist.
; 
; 
;  *  FSpOpenOrphanResFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; 
;    GetTopResourceFile returns the refNum of the top most resource map in the current resource chain. If
;    the resource chain is empty it returns resFNotFound.
;                                               ; 
;  *  GetTopResourceFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_FSpOpenOrphanResFile" 
      ((spec (:pointer :fsspec)) (permission :signed-byte) (refNum (:pointer :signed-integer))) 
  :signed-integer
   () )                                         ; 
;    GetNextResourceFile can be used to iterate over resource files in the resource chain. By passing a
;    valid refNum in curRefNum it will return in nextRefNum the refNum of the next file in 
;    the chain. If curRefNum is not found in the resource chain, GetNextResourceFile returns resFNotFound.
;    When the end of the chain is reached GetNextResourceFile will return noErr and nextRefNum will be NIL.
;                                               ; 
;  *  GetNextResourceFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetTopResourceFile" 
      ((refNum (:pointer :signed-integer))) 
  :signed-integer
   () )                                         ; $IFC OLDROUTINENAMES ; $IFC CALL_NOT_IN_CARBON ; 
;  *  SizeResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_GetNextResourceFile" 
      ((curRefNum :signed-integer) (nextRefNum (:pointer :signed-integer))) 
  :signed-integer
   () )
(deftrap "_SizeResource" 
      ((theResource :handle))
   (:stack :signed-long)
   (:stack-trap #xA9A5))

; 
;  *  MaxSizeRsrc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_MaxSizeRsrc" 
      ((theResource :handle))
   (:stack :signed-long)
   (:stack-trap #xA821))

; 
;  *  RmveResource()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_RmveResource" 
      ((theResource :handle))
   nil
   (:stack-trap #xA9AD))

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; OLDROUTINENAMES

; 
;  *  FSOpenResFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_FSOpenResFile" 
      ((ref (:pointer :fsref)) (permission :signed-byte))
   (:stack :signed-integer)
   (:stack-trap #xA822 :d0 19 ref permission))

; 
;  *  FSCreateResFile()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST; CONST
(deftrap "_FSCreateResFile" 
      ((parentRef (:pointer :fsref)) (nameLength :unsigned-long) (name (:pointer :unsigned-integer)) (whichInfo :unsigned-long) (catalogInfo (:pointer :fscataloginfo)) (newRef (:pointer :fsref)) (newSpec (:pointer :fsspec)))
   nil
   (:stack-trap #xA822 :d0 20 parentRef nameLength name whichInfo catalogInfo newRef newSpec))

; 
;  *  FSResourceFileAlreadyOpen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_FSResourceFileAlreadyOpen" 
      ((resourceFileRef (:pointer :fsref)) (inChain (:pointer :boolean)) (refNum (:pointer :signed-integer)))
   (:stack :boolean)
   (:stack-trap #xA822 :d0 21 resourceFileRef inChain refNum))

; 
;  *  FSCreateResourceFile()
;  *  
;  *  Summary:
;  *    Creates a new resource file.
;  *  
;  *  Discussion:
;  *    This function creates a new file and initializes the specified
;  *    named fork as an empty resource fork.  This function allows for
;  *    the creation of data fork only files which can be used for
;  *    storing resources.  Passing in a null name defaults to using the
;  *    data fork.
;  *  
;  *  Parameters:
;  *    
;  *    parentRef:
;  *      The directory where the file is to be created
;  *    
;  *    nameLength:
;  *      Number of Unicode characters in the file's name
;  *    
;  *    name:
;  *      A pointer to the Unicode name
;  *    
;  *    whichInfo:
;  *      Which catalog info fields to set
;  *    
;  *    catalogInfo:
;  *      The values for catalog info fields to set; may be NULL
;  *    
;  *    forkNameLength:
;  *      The length of the fork name (in Unicode characters)
;  *    
;  *    forkName:
;  *      The name of the fork to initialize (in Unicode); may be NULL
;  *    
;  *    newRef:
;  *      A pointer to the FSRef for the new file; may be NULL
;  *    
;  *    newSpec:
;  *      A pointer to the FSSpec for the new directory; may be NULL
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST                                         ; CONST; Const; CONST; 
;  *  FSOpenResourceFile()
;  *  
;  *  Summary:
;  *    Opens the specified named fork as a resource fork.
;  *  
;  *  Discussion:
;  *    This function allows any named fork of a file to be used for
;  *    storing resources.  Passing in a null forkname will result in the
;  *    data fork being used.
;  *  
;  *  Parameters:
;  *    
;  *    ref:
;  *      The file containing the fork to open
;  *    
;  *    forkNameLength:
;  *      The length of the fork name (in Unicode characters)
;  *    
;  *    forkName:
;  *      The name of the fork to open (in Unicode); may be NULL
;  *    
;  *    permissions:
;  *      The access (read and/or write) you want
;  *    
;  *    refNum:
;  *      On exit the reference number for accessing the open fork
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_FSCreateResourceFile" 
      ((parentRef (:pointer :fsref)) (nameLength :unsigned-long) (name (:pointer :unsigned-integer)) (whichInfo :unsigned-long) (catalogInfo (:pointer :fscataloginfo)) (forkNameLength :unsigned-long) (forkName (:pointer :unsigned-integer)) (newRef (:pointer :fsref)) (newSpec (:pointer :fsspec))) 
  :signed-integer
   () )                                         ; CONST; CONST; 
;     These typedefs were originally created for the Copland Resource Mangager
; 
(deftrap-inline "_FSOpenResourceFile" 
      ((ref (:pointer :fsref)) (forkNameLength :unsigned-long) (forkName (:pointer :unsigned-integer)) (permissions :signed-byte) (refNum (:pointer :signed-integer))) 
  :signed-integer
   () )
(def-mactype :resfilerefnum (find-mactype ':signed-integer))
(def-mactype :resid (find-mactype ':signed-integer))
(def-mactype :resattributes (find-mactype ':signed-integer))
(def-mactype :resfileattributes (find-mactype ':signed-integer))

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := ResourcesIncludes

; $ENDC                                         ; __RESOURCES__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Resources)