(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Retrace.p"
; at Wednesday May 1,2002 2:42:49 pm.
; 
;      File:       Retrace.p
;  
;      Contains:   Vertical Retrace Interfaces.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __RETRACE__
; $SETC __RETRACE__ := 1

; $I+
; $SETC RetraceIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __OSUTILS__
|#

(require-interface 'OSUtils)
#|                                              ; $I OSUtils.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :vbltaskptr (find-mactype '(:pointer :vbltask)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	VBLProcPtr = PROCEDURE(vblTaskPtr: VBLTaskPtr);

|#
 |#                                             ; $ELSEC
(def-mactype :vblprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :vblupp (find-mactype ':pointer))  ;  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :vblupp (find-mactype ':pointer))
; $ENDC
(defrecord VBLTask 
   (qLink (:pointer :qelem))
   (qType :signed-integer)
   (vblAddr :pointer)
   (vblCount :signed-integer)
   (vblPhase :signed-integer)
   )

(defconstant $uppVBLProcInfo #x9802)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewVBLUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewVBLProc 
(deftrap "_NewVBLUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeVBLUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeVBLUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeVBLUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallVBLProc 
(deftrap-inline "_InvokeVBLUPP" 
      ((VBLTaskPtr (:pointer :vbltask)) (userRoutine :pointer)) 
  nil
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  GetVBLQHdr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetVBLQHdr" 
      () 
  (:pointer :qhdr)
   (#x2EBC #x0 #x160) )

; 
;  *  SlotVInstall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SlotVInstall" 
      ((vblBlockPtr (:pointer :qelem)) (theSlot :signed-integer))
   (:d0 :signed-integer)
   (:register-trap #xA06F :d0 theSlot :a0 vblBlockPtr))

; 
;  *  SlotVRemove()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SlotVRemove" 
      ((vblBlockPtr (:pointer :qelem)) (theSlot :signed-integer))
   (:d0 :signed-integer)
   (:register-trap #xA070 :d0 theSlot :a0 vblBlockPtr))

; 
;  *  AttachVBL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_AttachVBL" 
      ((theSlot :signed-integer))
   (:d0 :signed-integer)
   (:register-trap #xA071 :d0 theSlot))

; 
;  *  DoVBLTask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DoVBLTask" 
      ((theSlot :signed-integer))
   (:d0 :signed-integer)
   (:register-trap #xA072 :d0 theSlot))

; 
;  *  VInstall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_VInstall" 
      ((vblTaskPtr (:pointer :qelem)))
   (:d0 :signed-integer)
   (:register-trap #xA033 :a0 vblTaskPtr))

; 
;  *  VRemove()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_VRemove" 
      ((vblTaskPtr (:pointer :qelem)))
   (:d0 :signed-integer)
   (:register-trap #xA034 :a0 vblTaskPtr))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := RetraceIncludes

; $ENDC                                         ; __RETRACE__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'Retrace)