(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:SFNTTypes.p"
; at Wednesday May 1,2002 2:40:29 pm.
; 
;      File:       SFNTTypes.p
;  
;      Contains:   Font file structures.
;  
;      Version:    Technology: Mac OS 9 / Carbon
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1994-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __SFNTTYPES__
; $SETC __SFNTTYPES__ := 1

; $I+
; $SETC SFNTTypesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :sfntdirectoryentryptr (find-mactype '(:pointer :sfntdirectoryentry)))
(defrecord sfntDirectoryEntry 
   (tableTag :ostype)
   (checkSum :unsigned-long)
   (offset :unsigned-long)
   (length :unsigned-long)
   )

; 	 The search fields limits numOffsets to 4096. 	
(def-mactype :sfntdirectoryptr (find-mactype '(:pointer :sfntdirectory)))
(defrecord sfntDirectory 
   (format :ostype)
   (numOffsets :unsigned-integer)               ;   number of tables  
   (searchRange :unsigned-integer)              ;   (max2 <= numOffsets)*16  
   (entrySelector :unsigned-integer)            ;   log2(max2 <= numOffsets)  
   (rangeShift :unsigned-integer)               ;   numOffsets*16-searchRange 
   (table (:array :sfntdirectoryentry 1))       ;   table[numOffsets]  
   )

(defconstant $sizeof_sfntDirectory 12)

; 	 Cmap - character id to glyph id mapping 	
(defconstant $cmapFontTableTag :|cmap|)

(defconstant $kFontUnicodePlatform 0)
(defconstant $kFontMacintoshPlatform 1)
(defconstant $kFontReservedPlatform 2)
(defconstant $kFontMicrosoftPlatform 3)
(defconstant $kFontCustomPlatform 4)

(defconstant $kFontUnicodeDefaultSemantics 0)
(defconstant $kFontUnicodeV1_1Semantics 1)
(defconstant $kFontISO10646_1993Semantics 2)

(defconstant $kFontRomanScript 0)
(defconstant $kFontJapaneseScript 1)
(defconstant $kFontTraditionalChineseScript 2)
(defconstant $kFontChineseScript 2)
(defconstant $kFontKoreanScript 3)
(defconstant $kFontArabicScript 4)
(defconstant $kFontHebrewScript 5)
(defconstant $kFontGreekScript 6)
(defconstant $kFontCyrillicScript 7)
(defconstant $kFontRussian 7)
(defconstant $kFontRSymbolScript 8)
(defconstant $kFontDevanagariScript 9)
(defconstant $kFontGurmukhiScript 10)
(defconstant $kFontGujaratiScript 11)
(defconstant $kFontOriyaScript 12)
(defconstant $kFontBengaliScript 13)
(defconstant $kFontTamilScript 14)
(defconstant $kFontTeluguScript 15)
(defconstant $kFontKannadaScript 16)
(defconstant $kFontMalayalamScript 17)
(defconstant $kFontSinhaleseScript 18)
(defconstant $kFontBurmeseScript 19)
(defconstant $kFontKhmerScript 20)
(defconstant $kFontThaiScript 21)
(defconstant $kFontLaotianScript 22)
(defconstant $kFontGeorgianScript 23)
(defconstant $kFontArmenianScript 24)
(defconstant $kFontSimpleChineseScript 25)
(defconstant $kFontTibetanScript 26)
(defconstant $kFontMongolianScript 27)
(defconstant $kFontGeezScript 28)
(defconstant $kFontEthiopicScript 28)
(defconstant $kFontAmharicScript 28)
(defconstant $kFontSlavicScript 29)
(defconstant $kFontEastEuropeanRomanScript 29)
(defconstant $kFontVietnameseScript 30)
(defconstant $kFontExtendedArabicScript 31)
(defconstant $kFontSindhiScript 31)
(defconstant $kFontUninterpretedScript 32)

(defconstant $kFontMicrosoftSymbolScript 0)
(defconstant $kFontMicrosoftStandardScript 1)
(defconstant $kFontMicrosoftUCS4Script 10)

(defconstant $kFontCustom8BitScript 0)
(defconstant $kFontCustom816BitScript 1)
(defconstant $kFontCustom16BitScript 2)

; 	 Language codes are zero based everywhere but within a 'cmap' table 	
(defconstant $kFontEnglishLanguage 0)
(defconstant $kFontFrenchLanguage 1)
(defconstant $kFontGermanLanguage 2)
(defconstant $kFontItalianLanguage 3)
(defconstant $kFontDutchLanguage 4)
(defconstant $kFontSwedishLanguage 5)
(defconstant $kFontSpanishLanguage 6)
(defconstant $kFontDanishLanguage 7)
(defconstant $kFontPortugueseLanguage 8)
(defconstant $kFontNorwegianLanguage 9)
(defconstant $kFontHebrewLanguage 10)
(defconstant $kFontJapaneseLanguage 11)
(defconstant $kFontArabicLanguage 12)
(defconstant $kFontFinnishLanguage 13)
(defconstant $kFontGreekLanguage 14)
(defconstant $kFontIcelandicLanguage 15)
(defconstant $kFontMalteseLanguage 16)
(defconstant $kFontTurkishLanguage 17)
(defconstant $kFontCroatianLanguage 18)
(defconstant $kFontTradChineseLanguage 19)
(defconstant $kFontUrduLanguage 20)
(defconstant $kFontHindiLanguage 21)
(defconstant $kFontThaiLanguage 22)
(defconstant $kFontKoreanLanguage 23)
(defconstant $kFontLithuanianLanguage 24)
(defconstant $kFontPolishLanguage 25)
(defconstant $kFontHungarianLanguage 26)
(defconstant $kFontEstonianLanguage 27)
(defconstant $kFontLettishLanguage 28)
(defconstant $kFontLatvianLanguage 28)
(defconstant $kFontSaamiskLanguage 29)
(defconstant $kFontLappishLanguage 29)
(defconstant $kFontFaeroeseLanguage 30)
(defconstant $kFontFarsiLanguage 31)
(defconstant $kFontPersianLanguage 31)
(defconstant $kFontRussianLanguage 32)
(defconstant $kFontSimpChineseLanguage 33)
(defconstant $kFontFlemishLanguage 34)
(defconstant $kFontIrishLanguage 35)
(defconstant $kFontAlbanianLanguage 36)
(defconstant $kFontRomanianLanguage 37)
(defconstant $kFontCzechLanguage 38)
(defconstant $kFontSlovakLanguage 39)
(defconstant $kFontSlovenianLanguage 40)
(defconstant $kFontYiddishLanguage 41)
(defconstant $kFontSerbianLanguage 42)
(defconstant $kFontMacedonianLanguage 43)
(defconstant $kFontBulgarianLanguage 44)
(defconstant $kFontUkrainianLanguage 45)
(defconstant $kFontByelorussianLanguage 46)
(defconstant $kFontUzbekLanguage 47)
(defconstant $kFontKazakhLanguage 48)
(defconstant $kFontAzerbaijaniLanguage 49)
(defconstant $kFontAzerbaijanArLanguage 50)
(defconstant $kFontArmenianLanguage 51)
(defconstant $kFontGeorgianLanguage 52)
(defconstant $kFontMoldavianLanguage 53)
(defconstant $kFontKirghizLanguage 54)
(defconstant $kFontTajikiLanguage 55)
(defconstant $kFontTurkmenLanguage 56)
(defconstant $kFontMongolianLanguage 57)
(defconstant $kFontMongolianCyrLanguage 58)
(defconstant $kFontPashtoLanguage 59)
(defconstant $kFontKurdishLanguage 60)
(defconstant $kFontKashmiriLanguage 61)
(defconstant $kFontSindhiLanguage 62)
(defconstant $kFontTibetanLanguage 63)
(defconstant $kFontNepaliLanguage 64)
(defconstant $kFontSanskritLanguage 65)
(defconstant $kFontMarathiLanguage 66)
(defconstant $kFontBengaliLanguage 67)
(defconstant $kFontAssameseLanguage 68)
(defconstant $kFontGujaratiLanguage 69)
(defconstant $kFontPunjabiLanguage 70)
(defconstant $kFontOriyaLanguage 71)
(defconstant $kFontMalayalamLanguage 72)
(defconstant $kFontKannadaLanguage 73)
(defconstant $kFontTamilLanguage 74)
(defconstant $kFontTeluguLanguage 75)
(defconstant $kFontSinhaleseLanguage 76)
(defconstant $kFontBurmeseLanguage 77)
(defconstant $kFontKhmerLanguage 78)
(defconstant $kFontLaoLanguage 79)
(defconstant $kFontVietnameseLanguage 80)
(defconstant $kFontIndonesianLanguage 81)
(defconstant $kFontTagalogLanguage 82)
(defconstant $kFontMalayRomanLanguage 83)
(defconstant $kFontMalayArabicLanguage 84)
(defconstant $kFontAmharicLanguage 85)
(defconstant $kFontTigrinyaLanguage 86)
(defconstant $kFontGallaLanguage 87)
(defconstant $kFontOromoLanguage 87)
(defconstant $kFontSomaliLanguage 88)
(defconstant $kFontSwahiliLanguage 89)
(defconstant $kFontRuandaLanguage 90)
(defconstant $kFontRundiLanguage 91)
(defconstant $kFontChewaLanguage 92)
(defconstant $kFontMalagasyLanguage 93)
(defconstant $kFontEsperantoLanguage 94)
(defconstant $kFontWelshLanguage 128)
(defconstant $kFontBasqueLanguage 129)
(defconstant $kFontCatalanLanguage 130)
(defconstant $kFontLatinLanguage 131)
(defconstant $kFontQuechuaLanguage 132)
(defconstant $kFontGuaraniLanguage 133)
(defconstant $kFontAymaraLanguage 134)
(defconstant $kFontTatarLanguage 135)
(defconstant $kFontUighurLanguage 136)
(defconstant $kFontDzongkhaLanguage 137)
(defconstant $kFontJavaneseRomLanguage 138)
(defconstant $kFontSundaneseRomLanguage 139)

; 	 The following are special "don't care" values to be used in interfaces 	
(defconstant $kFontNoPlatform -1)
(defconstant $kFontNoScript -1)
(defconstant $kFontNoLanguage -1)

(def-mactype :sfntcmapsubheaderptr (find-mactype '(:pointer :sfntcmapsubheader)))
(defrecord sfntCMapSubHeader 
   (format :unsigned-integer)
   (length :unsigned-integer)
   (languageID :unsigned-integer)               ;   base-1  
   )

(defconstant $sizeof_sfntCMapSubHeader 6)

(def-mactype :sfntcmapencodingptr (find-mactype '(:pointer :sfntcmapencoding)))
(defrecord sfntCMapEncoding 
   (platformID :unsigned-integer)               ;   base-0  
   (scriptID :unsigned-integer)                 ;   base-0  
   (offset :unsigned-long)
   )

(defconstant $sizeof_sfntCMapEncoding 8)

(def-mactype :sfntcmapheaderptr (find-mactype '(:pointer :sfntcmapheader)))
(defrecord sfntCMapHeader 
   (version :unsigned-integer)
   (numTables :unsigned-integer)
   (encoding (:array :sfntcmapencoding 1))
   )

(defconstant $sizeof_sfntCMapHeader 4)

; 	 Name table 	
(defconstant $nameFontTableTag :|name|)

(defconstant $kFontCopyrightName 0)
(defconstant $kFontFamilyName 1)
(defconstant $kFontStyleName 2)
(defconstant $kFontUniqueName 3)
(defconstant $kFontFullName 4)
(defconstant $kFontVersionName 5)
(defconstant $kFontPostscriptName 6)
(defconstant $kFontTrademarkName 7)
(defconstant $kFontManufacturerName 8)
(defconstant $kFontDesignerName 9)
(defconstant $kFontDescriptionName 10)
(defconstant $kFontVendorURLName 11)
(defconstant $kFontDesignerURLName 12)
(defconstant $kFontLicenseDescriptionName 13)
(defconstant $kFontLicenseInfoURLName 14)
(defconstant $kFontLastReservedName 255)

; 	 The following is a special "don't care" value to be used in interfaces 	
(defconstant $kFontNoName -1)

(def-mactype :sfntnamerecordptr (find-mactype '(:pointer :sfntnamerecord)))
(defrecord sfntNameRecord 
   (platformID :unsigned-integer)               ;   base-0  
   (scriptID :unsigned-integer)                 ;   base-0  
   (languageID :unsigned-integer)               ;   base-0  
   (nameID :unsigned-integer)                   ;   base-0  
   (length :unsigned-integer)
   (offset :unsigned-integer)
   )

(defconstant $sizeof_sfntNameRecord 12)

(def-mactype :sfntnameheaderptr (find-mactype '(:pointer :sfntnameheader)))
(defrecord sfntNameHeader 
   (format :unsigned-integer)
   (count :unsigned-integer)
   (stringOffset :unsigned-integer)
   (rec (:array :sfntnamerecord 1))
   )

(defconstant $sizeof_sfntNameHeader 6)

; 	 Fvar table - font variations 	
(defconstant $variationFontTableTag :|fvar|)

; 	 These define each font variation 	

(def-mactype :sfntvariationaxisptr (find-mactype '(:pointer :sfntvariationaxis)))
(defrecord sfntVariationAxis 
   (axisTag :ostype)
   (minValue :signed-long)
   (defaultValue :signed-long)
   (maxValue :signed-long)
   (flags :signed-integer)
   (nameID :signed-integer)
   )

(defconstant $sizeof_sfntVariationAxis 20)

; 	 These are named locations in style-space for the user 	

(def-mactype :sfntinstanceptr (find-mactype '(:pointer :sfntinstance)))
(defrecord sfntInstance 
   (nameID :signed-integer)
   (flags :signed-integer)
   (coord (:array :signed-long 1))              ;   [axisCount]  
;   room to grow since the header carries a tupleSize field  
   )

(defconstant $sizeof_sfntInstance 4)

(def-mactype :sfntvariationheaderptr (find-mactype '(:pointer :sfntvariationheader)))
(defrecord sfntVariationHeader 
   (version :signed-long)                       ;   1.0 Fixed  
   (offsetToData :unsigned-integer)             ;   to first axis = 16 
   (countSizePairs :unsigned-integer)           ;   axis+inst = 2  
   (axisCount :unsigned-integer)
   (axisSize :unsigned-integer)
   (instanceCount :unsigned-integer)
   (instanceSize :unsigned-integer)
;   other <count,size> pairs  
   (axis (:array :sfntvariationaxis 1))         ;   [axisCount]  
   (instance (:array :sfntinstance 1))          ;   [instanceCount]  other arrays of data  
   )

(defconstant $sizeof_sfntVariationHeader 16)

; 	 Fdsc table - font descriptor 	
(defconstant $descriptorFontTableTag :|fdsc|)

(def-mactype :sfntfontdescriptorptr (find-mactype '(:pointer :sfntfontdescriptor)))
(defrecord sfntFontDescriptor 
   (name :ostype)
   (value :signed-long)
   )

(def-mactype :sfntdescriptorheaderptr (find-mactype '(:pointer :sfntdescriptorheader)))
(defrecord sfntDescriptorHeader 
   (version :signed-long)                       ;   1.0 in Fixed  
   (descriptorCount :signed-long)
   (descriptor (:array :sfntfontdescriptor 1))
   )

(defconstant $sizeof_sfntDescriptorHeader 8)

; 	 Feat Table - layout feature table 	
(defconstant $featureFontTableTag :|feat|)

(def-mactype :sfntfeaturenameptr (find-mactype '(:pointer :sfntfeaturename)))
(defrecord sfntFeatureName 
   (featureType :unsigned-integer)
   (settingCount :unsigned-integer)
   (offsetToSettings :signed-long)
   (featureFlags :unsigned-integer)
   (nameID :unsigned-integer)
   )

(def-mactype :sfntfontfeaturesettingptr (find-mactype '(:pointer :sfntfontfeaturesetting)))
(defrecord sfntFontFeatureSetting 
   (setting :unsigned-integer)
   (nameID :unsigned-integer)
   )

(def-mactype :sfntfontrunfeatureptr (find-mactype '(:pointer :sfntfontrunfeature)))
(defrecord sfntFontRunFeature 
   (featureType :unsigned-integer)
   (setting :unsigned-integer)
   )

(def-mactype :sfntfeatureheaderptr (find-mactype '(:pointer :sfntfeatureheader)))
(defrecord sfntFeatureHeader 
   (version :signed-long)                       ;   1.0  
   (featureNameCount :unsigned-integer)
   (featureSetCount :unsigned-integer)
   (reserved :signed-long)                      ;   set to 0  
   (names (:array :sfntfeaturename 1))
   (settings (:array :sfntfontfeaturesetting 1))
   (runs (:array :sfntfontrunfeature 1))
   )

; 	 OS/2 Table 	

(defconstant $os2FontTableTag :|OS/2|)

; 	  Special invalid glyph ID value, useful as a sentinel value, for example 	
(defconstant $nonGlyphID 65535)

; 	  Data type used to access names from font name table 	

(def-mactype :fontnamecode (find-mactype ':unsigned-long))
; 	 Data types for encoding components as used in interfaces 	
(def-mactype :fontplatformcode (find-mactype ':unsigned-long))
(def-mactype :fontscriptcode (find-mactype ':unsigned-long))
(def-mactype :fontlanguagecode (find-mactype ':unsigned-long))
; 	
; 	**  FontVariation is used to specify a coordinate along a variation axis. The name
; 	**  identifies the axes to be applied, and value is the setting to be used.
; 		
(def-mactype :fontvariationptr (find-mactype '(:pointer :fontvariation)))
(defrecord FontVariation 
   (name :ostype)
   (value :signed-long)
   )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := SFNTTypesIncludes

; $ENDC                                         ; __SFNTTYPES__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'SFNTTypes)