(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Serial.p"
; at Wednesday May 1,2002 2:42:49 pm.
; 
;      File:       Serial.p
;  
;      Contains:   Asynchronous Serial Driver (.AIn/.AOut/.BIn/.BOut) Interfaces
;  
;      Version:    Technology: System 7.6+
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __SERIAL__
; $SETC __SERIAL__ := 1

; $I+
; $SETC SerialIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $baud150 763)
(defconstant $baud300 380)
(defconstant $baud600 189)
(defconstant $baud1200 94)
(defconstant $baud1800 62)
(defconstant $baud2400 46)
(defconstant $baud3600 30)
(defconstant $baud4800 22)
(defconstant $baud7200 14)
(defconstant $baud9600 10)
(defconstant $baud14400 6)
(defconstant $baud19200 4)
(defconstant $baud28800 2)
(defconstant $baud38400 1)
(defconstant $baud57600 0)

(defconstant $stop10 16384)
(defconstant $stop15 -32768)
(defconstant $stop20 -16384)

(defconstant $noParity 0)
(defconstant $oddParity 4096)
(defconstant $evenParity 12288)

(defconstant $data5 0)
(defconstant $data6 2048)
(defconstant $data7 1024)
(defconstant $data8 3072)

(defconstant $aData 6)                          ;   channel A data in or out (historical)  
(defconstant $aCtl 2)                           ;   channel A control (historical)  
(defconstant $bData 4)                          ;   channel B data in or out (historical)  
(defconstant $bCtl 0)                           ;   channel B control (historical)  

(defconstant $dsrEvent 2)                       ;   flag for SerShk.evts  
(defconstant $riEvent 4)                        ;   flag for SerShk.evts  
(defconstant $dcdEvent 8)                       ;   flag for SerShk.evts  
(defconstant $ctsEvent 32)                      ;   flag for SerShk.evts  
(defconstant $breakEvent 128)                   ;   flag for SerShk.evts  

(defconstant $xOffWasSent 128)                  ;   flag for SerStaRec.xOffSent  
(defconstant $dtrNegated 64)                    ;   flag for SerStaRec.xOffSent  
(defconstant $rtsNegated 32)                    ;   flag for SerStaRec.xOffSent  

(defconstant $ainRefNum -6)                     ;   serial port A input  
(defconstant $aoutRefNum -7)                    ;   serial port A output  
(defconstant $binRefNum -8)                     ;   serial port B input  
(defconstant $boutRefNum -9)                    ;   serial port B output  

(defconstant $swOverrunErr 1)                   ;   serial driver error masks  
(defconstant $breakErr 8)                       ;   serial driver error masks  
(defconstant $parityErr 16)                     ;   serial driver error masks  
(defconstant $hwOverrunErr 32)                  ;   serial driver error masks  
(defconstant $framingErr 64)                    ;   serial driver error masks  

(defconstant $kOptionPreserveDTR 128)           ;   option bit used with Control code 16  
(defconstant $kOptionClockX1CTS 64)             ;   option bit used with Control code 16  

(defconstant $kUseCTSOutputFlowControl 128)     ;   flag for SerShk.fCTS  
(defconstant $kUseDSROutputFlowControl 64)      ;   flag for SerShk.fCTS  
(defconstant $kUseRTSInputFlowControl 128)      ;   flag for SerShk.fDTR  
(defconstant $kUseDTRInputFlowControl 64)       ;   flag for SerShk.fDTR  

(defconstant $sPortA 0)                         ;   Macintosh modem port  
(defconstant $sPortB 1)                         ;   Macintosh printer port  
(defconstant $sCOM1 2)                          ;   RS-232 port COM1  
(defconstant $sCOM2 3)                          ;   RS-232 port COM2  

(def-mactype :sportsel (find-mactype ':signed-byte))
; 	 csCodes for serial driver Control routines 	

(defconstant $kSERDConfiguration 8)             ;   program port speed, bits/char, parity, and stop bits  
(defconstant $kSERDInputBuffer 9)               ;   set buffer for chars received with no read pending  
(defconstant $kSERDSerHShake 10)                ;   equivalent to SerHShake, largely obsolete  
(defconstant $kSERDClearBreak 11)               ;   assert break signal on output  
(defconstant $kSERDSetBreak 12)                 ;   negate break state on output  
(defconstant $kSERDBaudRate 13)                 ;   set explicit baud rate, other settings unchanged  
(defconstant $kSERDHandshake 14)                ;   superset of 10, honors setting of fDTR  
(defconstant $kSERDClockMIDI 15)                ;   clock externally on CTS with specified multiplier  
(defconstant $kSERDMiscOptions 16)              ;   select clock source and DTR behavior on close  
(defconstant $kSERDAssertDTR 17)                ;   assert DTR output  
(defconstant $kSERDNegateDTR 18)                ;   negate DTR output  
(defconstant $kSERDSetPEChar 19)                ;   select char to replace chars with invalid parity  
(defconstant $kSERDSetPEAltChar 20)             ;   select char to replace char that replaces chars with invalid parity  
(defconstant $kSERDSetXOffFlag 21)              ;   set XOff output flow control (same as receiving XOff)  
(defconstant $kSERDClearXOffFlag 22)            ;   clear XOff output flow control (same as receiving XOn)  
(defconstant $kSERDSendXOn 23)                  ;   send XOn if input flow control state is XOff  
(defconstant $kSERDSendXOnOut 24)               ;   send XOn regardless of input flow control state  
(defconstant $kSERDSendXOff 25)                 ;   send XOff if input flow control state is XOn  
(defconstant $kSERDSendXOffOut 26)              ;   send XOff regardless of input flow control state  
(defconstant $kSERDResetChannel 27)             ;   reset serial I/O channel hardware  
(defconstant $kSERDHandshakeRS232 28)           ;   extension of 14, allows full RS-232 hardware handshaking  
(defconstant $kSERDStickParity 29)              ;   use mark/space parity  
(defconstant $kSERDAssertRTS 30)                ;   assert RTS output  
(defconstant $kSERDNegateRTS 31)                ;   negate RTS output  
(defconstant $kSERD115KBaud 115)                ;   set 115.2K baud data rate  
(defconstant $kSERD230KBaud 230)                ;   set 230.4K baud data rate  

; 	 csCodes for serial driver Status routines 	
(defconstant $kSERDInputCount 2)                ;   return characters available (SerGetBuf)  
(defconstant $kSERDStatus 8)                    ;   return characters available (SerStatus)  
(defconstant $kSERDVersion 9)                   ;   return version number in first byte of csParam  
(defconstant $kSERDGetDCD 256)                  ;   get instantaneous state of DCD (GPi)  

(def-mactype :sershkptr (find-mactype '(:pointer :sershk)))
(defrecord SerShk 
   (fXOn :unsigned-byte)                        ;   XOn/XOff output flow control flag  
   (fCTS :unsigned-byte)                        ;   hardware output flow control flags  
   (xOn :unsigned-byte)                         ;   XOn character  
   (xOff :unsigned-byte)                        ;   XOff character  
   (errs :unsigned-byte)                        ;   errors mask bits  
   (evts :unsigned-byte)                        ;   event enable mask bits  
   (fInX :unsigned-byte)                        ;   XOn/XOff input flow control flag  
   (fDTR :unsigned-byte)                        ;   hardware input flow control flags  
   )

(def-mactype :serstarecptr (find-mactype '(:pointer :serstarec)))
(defrecord SerStaRec 
   (cumErrs :unsigned-byte)                     ;   errors accumulated since last SerStatus() call  
   (xOffSent :unsigned-byte)                    ;   input (requested to be) held off by xOffWasSent or dtrNegated or rtsNegated  
   (rdPend :unsigned-byte)                      ;   incomplete read pending in I/O queue  
   (wrPend :unsigned-byte)                      ;   incomplete write pending in I/O queue  
   (ctsHold :unsigned-byte)                     ;   transmit disabled by hardware handshaking  
   (xOffHold :unsigned-byte)                    ;   transmit disabled by XOn/XOff handshaking  
   (dsrHold :unsigned-byte)                     ;   transmit disabled: external device not ready  
   (modemStatus :unsigned-byte)                 ;   reports modem status according to SerShk.evts  
   )

; $IFC OLDROUTINENAMES 
; 	 ********************************************************************************************* 	
; 	 The following constant names have been retired in favor of standard, more descriptive names.  	
; 	 You can still compile old code by defining OLDROUTINENAMES. There were several constants that 	
; 	 were formerly available that have been removed, as they are now regarded as either private or 	
; 	 unsupported. We advise that you stop using any constants that are not defined in this file.   	
; 	 ********************************************************************************************* 	

(defconstant $serdOptionClockExternal 64)       ;   option bit used with Control code 16  
(defconstant $serdOptionPreserveDTR 128)        ;   option bit used with Control code 16  

; 	 csCodes for serial driver Control routines 	
(defconstant $serdReset 8)
(defconstant $serdSetBuf 9)
(defconstant $serdHShake 10)
(defconstant $serdClrBrk 11)
(defconstant $serdSetBrk 12)
(defconstant $serdSetBaud 13)
(defconstant $serdHShakeDTR 14)
(defconstant $serdSetMIDI 15)
(defconstant $serdSetMisc 16)
(defconstant $serdSetDTR 17)
(defconstant $serdClrDTR 18)
(defconstant $serdSetPEChar 19)
(defconstant $serdSetPECharAlternate 20)
(defconstant $serdSetXOff 21)
(defconstant $serdClrXOff 22)
(defconstant $serdSendXOnConditional 23)
(defconstant $serdSendXOn 24)
(defconstant $serdSendXOffConditional 25)
(defconstant $serdSendXOff 26)
(defconstant $serdChannelReset 27)
(defconstant $serdSet230KBaud 230)              ;   set 230K baud data rate  

; 	 csCodes for serial driver Status routines 	
(defconstant $serdGetBuf 2)
(defconstant $serdStatus 8)
(defconstant $serdGetVers 9)

; $ENDC                                         ; OLDROUTINENAMES

; 
;     The following interfaces are for the legacy high-level serial driver glue in
;     the interface libraries of your development system. They merely substitue for
;     the corresponding synchronous calls to PBControl and PBStatus.
; 
;     They have not been updated as the serial driver API has evolved. Take note:
; 
;         SerHShake does not support hardware input flow control. Use csCode 14.
;         SerStatus returns only the first six bytes of SerStaRec (through xOffHold).
; 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SerReset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  SerSetBuf()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SerReset" 
      ((refNum :signed-integer) (serConfig :signed-integer)) 
  :signed-integer
   () )                                         ; 
;  *  SerHShake()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SerSetBuf" 
      ((refNum :signed-integer) (serBPtr :pointer) (serBLen :signed-integer)) 
  :signed-integer
   () )                                         ; CONST; 
;  *  SerSetBrk()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SerHShake" 
      ((refNum :signed-integer) (flags (:pointer :sershk))) 
  :signed-integer
   () )                                         ; 
;  *  SerClrBrk()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SerSetBrk" 
      ((refNum :signed-integer)) 
  :signed-integer
   () )                                         ; 
;  *  SerGetBuf()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SerClrBrk" 
      ((refNum :signed-integer)) 
  :signed-integer
   () )                                         ; 
;  *  SerStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SerGetBuf" 
      ((refNum :signed-integer) (count (:pointer :signed-long))) 
  :signed-integer
   () )
(deftrap-inline "_SerStatus" 
      ((refNum :signed-integer) (serSta (:pointer :serstarec))) 
  :signed-integer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := SerialIncludes

; $ENDC                                         ; __SERIAL__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'Serial)