(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:ShutDown.p"
; at Wednesday May 1,2002 2:42:50 pm.
; 
;      File:       ShutDown.p
;  
;      Contains:   Shutdown Manager Interfaces.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1987-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __SHUTDOWN__
; $SETC __SHUTDOWN__ := 1

; $I+
; $SETC ShutDownIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $sdOnPowerOff 1)                   ;  call procedure before power off. 
(defconstant $sdOnRestart 2)                    ;  call procedure before restart. 
(defconstant $sdOnUnmount 4)                    ;  call procedure before unmounting. 
(defconstant $sdOnDrivers 8)                    ;  call procedure before closing drivers. 
(defconstant $sdOnBootVolUnmount 16)            ;  call procedure before unmounting boot volume and VM volume but after unmounting all other volumes 
(defconstant $sdRestartOrPower 3)               ;  call before either power off or restart. 

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ShutDwnProcPtr = PROCEDURE(shutDownStage: INTEGER);

|#
 |#                                             ; $ELSEC
(def-mactype :shutdwnprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :shutdwnupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :shutdwnupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppShutDwnProcInfo #x1002)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewShutDwnUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewShutDwnProc 
(deftrap "_NewShutDwnUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeShutDwnUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeShutDwnUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeShutDwnUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallShutDwnProc 
(deftrap-inline "_InvokeShutDwnUPP" 
      ((shutDownStage :signed-integer) (userRoutine :pointer)) 
  nil
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  ShutDwnPower()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ShutDwnPower" 
      ()
   nil
   (:stack-trap #xA895 (1 :signed-integer)))

; 
;  *  ShutDwnStart()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ShutDwnStart" 
      ()
   nil
   (:stack-trap #xA895 (2 :signed-integer)))

; 
;  *  ShutDwnInstall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ShutDwnInstall" 
      ((shutDownProc :pointer) (flags :signed-integer))
   nil
   (:stack-trap #xA895 shutDownProc flags (3 :signed-integer)))

; 
;  *  ShutDwnRemove()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_ShutDwnRemove" 
      ((shutDownProc :pointer))
   nil
   (:stack-trap #xA895 shutDownProc (4 :signed-integer)))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := ShutDownIncludes

; $ENDC                                         ; __SHUTDOWN__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'ShutDown)