(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Slots.p"
; at Wednesday May 1,2002 2:42:50 pm.
; 
;      File:       Slots.p
;  
;      Contains:   Slot Manager Interfaces.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1986-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __SLOTS__
; $SETC __SLOTS__ := 1

; $I+
; $SETC SlotsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __EVENTS__
|#

(require-interface 'Events)
#|                                              ; $I Events.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $fCardIsChanged 1)                 ;  Card is Changed field in StatusFlags field of sInfoArray 
(defconstant $fCkForSame 0)                     ;  For SearchSRT. Flag to check for SAME sResource in the table.  
(defconstant $fCkForNext 1)                     ;  For SearchSRT. Flag to check for NEXT sResource in the table.  
(defconstant $fWarmStart 2)                     ;  If this bit is set then warm start else cold start. 

(defconstant $stateNil 0)                       ;  State 
(defconstant $stateSDMInit 1)                   ;  :Slot declaration manager Init 
(defconstant $statePRAMInit 2)                  ;  :sPRAM record init 
(defconstant $statePInit 3)                     ;  :Primary init 
(defconstant $stateSInit 4)                     ;  :Secondary init 

;   flags for spParamData  
(defconstant $fall 0)                           ;   bit 0: set=search enabled/disabled sRsrc's  
(defconstant $foneslot 1)                       ;      1: set=search sRsrc's in given slot only  
(defconstant $fnext 2)                          ;      2: set=search for next sRsrc  

;   Misc masks  
(defconstant $catMask #x8)                      ;   sets spCategory field of spTBMask (bit 3)  
(defconstant $cTypeMask #x4)                    ;   sets spCType    field of spTBMask (bit 2)  
(defconstant $drvrSWMask #x2)                   ;   sets spDrvrSW   field of spTBMask (bit 1)  
(defconstant $drvrHWMask #x1)                   ;   sets spDrvrHW    field of spTBMask (bit 0)  

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SlotIntServiceProcPtr = FUNCTION(sqParameter: LONGINT): INTEGER;

|#
 |#                                             ; $ELSEC
(def-mactype :slotintserviceprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :slotintserviceupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :slotintserviceupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppSlotIntServiceProcInfo #xB822)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewSlotIntServiceUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewSlotIntServiceProc 
(deftrap "_NewSlotIntServiceUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeSlotIntServiceUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeSlotIntServiceUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeSlotIntServiceUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallSlotIntServiceProc 
(deftrap-inline "_InvokeSlotIntServiceUPP" 
      ((sqParameter :signed-long) (userRoutine :pointer)) 
  :signed-integer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

(def-mactype :slotintqelementptr (find-mactype '(:pointer :slotintqelement)))
(defrecord SlotIntQElement 
   (sqLink :pointer)                            ;  ptr to next element 
   (sqType :signed-integer)                     ;  queue type ID for validity 
   (sqPrio :signed-integer)                     ;  priority 
   (sqAddr :pointer)                            ;  interrupt service routine 
   (sqParm :signed-long)                        ;  optional A1 parameter 
   )

(def-mactype :sqelemptr (find-mactype '(:pointer :slotintqelement)))
(def-mactype :spblockptr (find-mactype '(:pointer :spblock)))
(defrecord SpBlock 
   (spResult :signed-long)                      ;  FUNCTION Result 
   (spsPointer :pointer)                        ;  structure pointer 
   (spSize :signed-long)                        ;  size of structure 
   (spOffsetData :signed-long)                  ;  offset/data field used by sOffsetData 
   (spIOFileName :pointer)                      ;  ptr to IOFile name for sDisDrvrName 
   (spsExecPBlk :pointer)                       ;  pointer to sExec parameter block. 
   (spParamData :signed-long)                   ;  misc parameter data (formerly spStackPtr). 
   (spMisc :signed-long)                        ;  misc field for SDM. 
   (spReserved :signed-long)                    ;  reserved for future expansion 
   (spIOReserved :signed-integer)               ;  Reserved field of Slot Resource Table 
   (spRefNum :signed-integer)                   ;  RefNum 
   (spCategory :signed-integer)                 ;  sType: Category 
   (spCType :signed-integer)                    ;  Type 
   (spDrvrSW :signed-integer)                   ;  DrvrSW 
   (spDrvrHW :signed-integer)                   ;  DrvrHW 
   (spTBMask :signed-byte)                      ;  type bit mask bits 0..3 mask words 0..3 
   (spSlot :signed-byte)                        ;  slot number 
   (spID :signed-byte)                          ;  structure ID 
   (spExtDev :signed-byte)                      ;  ID of the external device 
   (spHwDev :signed-byte)                       ;  Id of the hardware device. 
   (spByteLanes :signed-byte)                   ;  bytelanes from card ROM format block 
   (spFlags :signed-byte)                       ;  standard flags 
   (spKey :signed-byte)                         ;  Internal use only 
   )

(def-mactype :sinforecordptr (find-mactype '(:pointer :sinforecord)))
(defrecord SInfoRecord 
   (siDirPtr :pointer)                          ;  Pointer to directory 
   (siInitStatusA :signed-integer)              ;  initialization E 
   (siInitStatusV :signed-integer)              ;  status returned by vendor init code 
   (siState :signed-byte)                       ;  initialization state 
   (siCPUByteLanes :signed-byte)                ;  0=[d0..d7] 1=[d8..d15] 
   (siTopOfROM :signed-byte)                    ;  Top of ROM= $FssFFFFx: x is TopOfROM 
   (siStatusFlags :signed-byte)                 ;  bit 0 - card is changed 
   (siTOConst :signed-integer)                  ;  Time Out C for BusErr 
   (siReserved (:array :signed-byte 2))         ;  reserved 
   (siROMAddr :pointer)                         ;   addr of top of ROM  
   (siSlot :signed-byte)                        ;   slot number  
   (siPadding (:array :signed-byte 3))          ;   reserved  
   )

(def-mactype :sinforecptr (find-mactype '(:pointer :sinforecord)))
(def-mactype :sdmrecordptr (find-mactype '(:pointer :sdmrecord)))
(defrecord SDMRecord 
   (sdBEVSave :pointer)                         ;  Save old BusErr vector 
   (sdBusErrProc :pointer)                      ;  Go here to determine if it is a BusErr 
   (sdErrorEntry :pointer)                      ;  Go here if BusErrProc finds real BusErr 
   (sdReserved :signed-long)                    ;  Reserved 
   )

(def-mactype :fheaderrecptr (find-mactype '(:pointer :fheaderrec)))
(defrecord FHeaderRec 
   (fhDirOffset :signed-long)                   ;  offset to directory 
   (fhLength :signed-long)                      ;  length of ROM 
   (fhCRC :signed-long)                         ;  CRC 
   (fhROMRev :signed-byte)                      ;  revision of ROM 
   (fhFormat :signed-byte)                      ;  format - 2 
   (fhTstPat :signed-long)                      ;  test pattern 
   (fhReserved :signed-byte)                    ;  reserved 
   (fhByteLanes :signed-byte)                   ;  ByteLanes 
   )

; 
; 	   
; 	    Extended Format header block  -  extended declaration ROM format header for super sRsrc directories.    <H2><SM0>
; 	   
; 	

(def-mactype :xfheaderrecptr (find-mactype '(:pointer :xfheaderrec)))
(defrecord XFHeaderRec 
   (fhXSuperInit :signed-long)                  ;  Offset to SuperInit SExecBlock  <fhFormat,offset> 
   (fhXSDirOffset :signed-long)                 ;  Offset to SuperDirectory         <$FE,offset> 
   (fhXEOL :signed-long)                        ;  Psuedo end-of-list          <$FF,nil> 
   (fhXSTstPat :signed-long)                    ;  TestPattern 
   (fhXDirOffset :signed-long)                  ;  Offset to (minimal) directory 
   (fhXLength :signed-long)                     ;  Length of ROM 
   (fhXCRC :signed-long)                        ;  CRC 
   (fhXROMRev :signed-byte)                     ;  Revision of ROM 
   (fhXFormat :signed-byte)                     ;  Format-2 
   (fhXTstPat :signed-long)                     ;  TestPattern 
   (fhXReserved :signed-byte)                   ;  Reserved 
   (fhXByteLanes :signed-byte)                  ;  ByteLanes 
   )

(def-mactype :seblockptr (find-mactype '(:pointer :seblock)))
(defrecord SEBlock 
   (seSlot :unsigned-byte)                      ;  Slot number. 
   (sesRsrcId :unsigned-byte)                   ;  sResource Id. 
   (seStatus :signed-integer)                   ;  Status of code executed by sExec. 
   (seFlags :unsigned-byte)                     ;  Flags 
   (seFiller0 :unsigned-byte)                   ;  Filler, must be SignedByte to align on odd boundry 
   (seFiller1 :unsigned-byte)                   ;  Filler 
   (seFiller2 :unsigned-byte)                   ;  Filler 
   (seResult :signed-long)                      ;  Result of sLoad. 
   (seIOFileName :signed-long)                  ;  Pointer to IOFile name. 
   (seDevice :unsigned-byte)                    ;  Which device to read from. 
   (sePartition :unsigned-byte)                 ;  The partition. 
   (seOSType :unsigned-byte)                    ;  Type of OS. 
   (seReserved :unsigned-byte)                  ;  Reserved field. 
   (seRefNum :unsigned-byte)                    ;  RefNum of the driver. 
   (seNumDevices :unsigned-byte)                ;   Number of devices to load. 
   (seBootState :unsigned-byte)                 ;  State of StartBoot code. 
   (filler :signed-byte)
   )

; 	  Principle  	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  SReadByte()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_SReadByte" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 0))

; 
;  *  SReadWord()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SReadWord" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 1))

; 
;  *  SReadLong()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SReadLong" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 2))

; 
;  *  SGetCString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SGetCString" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 3))

; 
;  *  SGetBlock()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SGetBlock" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 5))

; 
;  *  SFindStruct()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SFindStruct" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 6))

; 
;  *  SReadStruct()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SReadStruct" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 7))

;   Special  
; 
;  *  SReadInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SReadInfo" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 16))

; 
;  *  SReadPRAMRec()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SReadPRAMRec" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 17))

; 
;  *  SPutPRAMRec()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SPutPRAMRec" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 18))

; 
;  *  SReadFHeader()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SReadFHeader" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 19))

; 
;  *  SNextSRsrc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SNextSRsrc" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 20))

; 
;  *  SNextTypeSRsrc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SNextTypeSRsrc" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 21))

; 
;  *  SRsrcInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SRsrcInfo" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 22))

; 
;  *  SDisposePtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SDisposePtr" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 23))

; 
;  *  SCkCardStat()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SCkCardStat" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 24))

; 
;  *  SReadDrvrName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SReadDrvrName" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 25))

; 
;  *  SFindSRTRec()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SFindSRTRec" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 26))

; 
;  *  SFindDevBase()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SFindDevBase" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 27))

; 
;  *  SFindBigDevBase()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SFindBigDevBase" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 28))

;   Advanced  
; 
;  *  InitSDeclMgr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_InitSDeclMgr" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 32))

; 
;  *  SPrimaryInit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SPrimaryInit" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 33))

; 
;  *  SCardChanged()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SCardChanged" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 34))

; 
;  *  SExec()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SExec" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 35))

; 
;  *  SOffsetData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SOffsetData" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 36))

; 
;  *  SInitPRAMRecs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SInitPRAMRecs" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 37))

; 
;  *  SReadPBSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SReadPBSize" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 38))

; 
;  *  SCalcStep()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SCalcStep" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 40))

; 
;  *  SInitSRsrcTable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SInitSRsrcTable" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 41))

; 
;  *  SSearchSRT()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SSearchSRT" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 42))

; 
;  *  SUpdateSRT()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SUpdateSRT" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 43))

; 
;  *  SCalcSPointer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SCalcSPointer" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 44))

; 
;  *  SGetDriver()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SGetDriver" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 45))

; 
;  *  SPtrToSlot()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SPtrToSlot" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 46))

; 
;  *  SFindSInfoRecPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SFindSInfoRecPtr" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 47))

; 
;  *  SFindSRsrcPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SFindSRsrcPtr" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 48))

; 
;  *  SDeleteSRTRec()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SDeleteSRTRec" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 49))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  OpenSlot()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  OpenSlotSync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_OpenSlot" 
      ((paramBlock (:pointer :paramblockrec)) (async :boolean)) 
  :signed-integer
   () )
(deftrap "_OpenSlotSync" 
      ((paramBlock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA200 :a0 paramBlock))

; 
;  *  OpenSlotAsync()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_OpenSlotAsync" 
      ((paramBlock (:pointer :paramblockrec)))
   (:d0 :signed-integer)
   (:register-trap #xA600 :a0 paramBlock))

;   Device Manager Slot Support  
; 
;  *  SIntInstall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SIntInstall" 
      ((sIntQElemPtr (:pointer :slotintqelement)) (theSlot :signed-integer))
   (:d0 :signed-integer)
   (:register-trap #xA075 :d0 theSlot :a0 sIntQElemPtr))

; 
;  *  SIntRemove()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SIntRemove" 
      ((sIntQElemPtr (:pointer :slotintqelement)) (theSlot :signed-integer))
   (:d0 :signed-integer)
   (:register-trap #xA076 :d0 theSlot :a0 sIntQElemPtr))

; 
;  *  SVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SVersion" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 8))

; 
;  *  SetSRsrcState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetSRsrcState" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 9))

; 
;  *  InsertSRTRec()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_InsertSRTRec" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 10))

; 
;  *  SGetSRsrc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SGetSRsrc" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 11))

; 
;  *  SGetTypeSRsrc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SGetTypeSRsrc" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 12))

; 
;  *  SGetSRsrcPtr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SGetSRsrcPtr" 
      ((spBlkPtr (:pointer :spblock)))
   (:d0 :signed-integer)
   (:register-trap #xA06E :a0 spBlkPtr :d0 29))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := SlotsIncludes

; $ENDC                                         ; __SLOTS__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'Slots)