(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:SpeechSynthesis.p"
; at Wednesday May 1,2002 2:40:49 pm.
; 
;      File:       SpeechSynthesis.p
;  
;      Contains:   Speech Interfaces.
;  
;      Version:    Technology: Mac OS 8
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1989-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __SPEECHSYNTHESIS__
; $SETC __SPEECHSYNTHESIS__ := 1

; $I+
; $SETC SpeechSynthesisIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $kTextToSpeechSynthType :|ttsc|)
(defconstant $kTextToSpeechVoiceType :|ttvd|)
(defconstant $kTextToSpeechVoiceFileType :|ttvf|)
(defconstant $kTextToSpeechVoiceBundleType :|ttvb|)

(defconstant $kNoEndingProsody 1)
(defconstant $kNoSpeechInterrupt 2)
(defconstant $kPreflightThenPause 4)

(defconstant $kImmediate 0)
(defconstant $kEndOfWord 1)
(defconstant $kEndOfSentence 2)

; 	------------------------------------------	
; 	 GetSpeechInfo & SetSpeechInfo selectors  	
; 	------------------------------------------	
(defconstant $soStatus :|stat|)
(defconstant $soErrors :|erro|)
(defconstant $soInputMode :|inpt|)
(defconstant $soCharacterMode :|char|)
(defconstant $soNumberMode :|nmbr|)
(defconstant $soRate :|rate|)
(defconstant $soPitchBase :|pbas|)
(defconstant $soPitchMod :|pmod|)
(defconstant $soVolume :|volm|)
(defconstant $soSynthType :|vers|)
(defconstant $soRecentSync :|sync|)
(defconstant $soPhonemeSymbols :|phsy|)
(defconstant $soCurrentVoice :|cvox|)
(defconstant $soCommandDelimiter :|dlim|)
(defconstant $soReset :|rset|)
(defconstant $soCurrentA5 :|myA5|)
(defconstant $soRefCon :|refc|)
(defconstant $soTextDoneCallBack :|tdcb|)       ;   use with SpeechTextDoneProcPtr 
(defconstant $soSpeechDoneCallBack :|sdcb|)     ;   use with SpeechDoneProcPtr 
(defconstant $soSyncCallBack :|sycb|)           ;   use with SpeechSyncProcPtr 
(defconstant $soErrorCallBack :|ercb|)          ;   use with SpeechErrorProcPtr 
(defconstant $soPhonemeCallBack :|phcb|)        ;   use with SpeechPhonemeProcPtr 
(defconstant $soWordCallBack :|wdcb|)
(defconstant $soSynthExtension :|xtnd|)
(defconstant $soSoundOutput :|sndo|)

; 	------------------------------------------	
; 	 Speaking Mode Constants                  	
; 	------------------------------------------	
(defconstant $modeText :|TEXT|)                 ;   input mode constants              
(defconstant $modePhonemes :|PHON|)
(defconstant $modeNormal :|NORM|)               ;   character mode and number mode constants  
(defconstant $modeLiteral :|LTRL|)

(defconstant $soVoiceDescription :|info|)
(defconstant $soVoiceFile :|fref|)

(def-mactype :speechchannel (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :speechchannelptr (find-mactype '(:pointer :pointer)));  when a VAR xx:SpeechChannel parameter can be nil, it is changed to xx: SpeechChannelPtr 

(def-mactype :voicespecptr (find-mactype '(:pointer :voicespec)))
(defrecord VoiceSpec 
   (creator :ostype)
   (id :ostype)
   )

(defconstant $kNeuter 0)
(defconstant $kMale 1)
(defconstant $kFemale 2)

(def-mactype :voicedescriptionptr (find-mactype '(:pointer :voicedescription)))
(defrecord VoiceDescription 
   (length :signed-long)
   (voice :voicespec)
   (version :signed-long)
   (name (:string 63))
   (comment (:string 255))
   (gender :signed-integer)
   (age :signed-integer)
   (script :signed-integer)
   (language :signed-integer)
   (region :signed-integer)
   (reserved (:array :signed-long 4))
   )

(def-mactype :voicefileinfoptr (find-mactype '(:pointer :voicefileinfo)))
(defrecord VoiceFileInfo 
   (fileSpec :fsspec)
   (resID :signed-integer)
   )

(def-mactype :speechstatusinfoptr (find-mactype '(:pointer :speechstatusinfo)))
(defrecord SpeechStatusInfo 
   (outputBusy :boolean)
   (outputPaused :boolean)
   (inputBytesLeft :signed-long)
   (phonemeCode :signed-integer)
   )

(def-mactype :speecherrorinfoptr (find-mactype '(:pointer :speecherrorinfo)))
(defrecord SpeechErrorInfo 
   (count :signed-integer)
   (oldest :signed-integer)
   (oldPos :signed-long)
   (newest :signed-integer)
   (newPos :signed-long)
   )

(def-mactype :speechversioninfoptr (find-mactype '(:pointer :speechversioninfo)))
(defrecord SpeechVersionInfo 
   (synthType :ostype)
   (synthSubType :ostype)
   (synthManufacturer :ostype)
   (synthFlags :signed-long)
   (synthVersion :numversion)
   )

(def-mactype :phonemeinfoptr (find-mactype '(:pointer :phonemeinfo)))
(defrecord PhonemeInfo 
   (opcode :signed-integer)
   (phStr (:string 15))
   (exampleStr (:string 31))
   (hiliteStart :signed-integer)
   (hiliteEnd :signed-integer)
   )

(def-mactype :phonemedescriptorptr (find-mactype '(:pointer :phonemedescriptor)))
(defrecord PhonemeDescriptor 
   (phonemeCount :signed-integer)
   (thePhonemes (:array :phonemeinfo 1))
   )

(def-mactype :speechxtnddataptr (find-mactype '(:pointer :speechxtnddata)))
(defrecord SpeechXtndData 
   (synthCreator :ostype)
   (synthData (:array :unsigned-byte 2 :packed))
   )

(def-mactype :delimiterinfoptr (find-mactype '(:pointer :delimiterinfo)))
(defrecord DelimiterInfo 
   (startDelimiter (:array :unsigned-byte 2 :packed))
   (endDelimiter (:array :unsigned-byte 2 :packed))
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SpeechTextDoneProcPtr = PROCEDURE(chan: SpeechChannel; refCon: LONGINT; VAR nextBuf: UNIV Ptr; VAR byteLen: UInt32; VAR controlFlags: LONGINT);

|#
 |#                                             ; $ELSEC
(def-mactype :speechtextdoneprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SpeechDoneProcPtr = PROCEDURE(chan: SpeechChannel; refCon: LONGINT);

|#
 |#                                             ; $ELSEC
(def-mactype :speechdoneprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SpeechSyncProcPtr = PROCEDURE(chan: SpeechChannel; refCon: LONGINT; syncMessage: OSType);

|#
 |#                                             ; $ELSEC
(def-mactype :speechsyncprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SpeechErrorProcPtr = PROCEDURE(chan: SpeechChannel; refCon: LONGINT; theError: OSErr; bytePos: LONGINT);

|#
 |#                                             ; $ELSEC
(def-mactype :speecherrorprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SpeechPhonemeProcPtr = PROCEDURE(chan: SpeechChannel; refCon: LONGINT; phonemeOpcode: INTEGER);

|#
 |#                                             ; $ELSEC
(def-mactype :speechphonemeprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	SpeechWordProcPtr = PROCEDURE(chan: SpeechChannel; refCon: LONGINT; wordPos: UInt32; wordLen: UInt16);

|#
 |#                                             ; $ELSEC
(def-mactype :speechwordprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :speechtextdoneupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :speechtextdoneupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :speechdoneupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :speechdoneupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :speechsyncupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :speechsyncupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :speecherrorupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :speecherrorupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :speechphonemeupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :speechphonemeupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :speechwordupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :speechwordupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppSpeechTextDoneProcInfo #xFFC0)
(defconstant $uppSpeechDoneProcInfo #x3C0)
(defconstant $uppSpeechSyncProcInfo #xFC0)
(defconstant $uppSpeechErrorProcInfo #x3BC0)
(defconstant $uppSpeechPhonemeProcInfo #xBC0)
(defconstant $uppSpeechWordProcInfo #x2FC0)
; 
; 	 *  NewSpeechTextDoneUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0.2 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewSpeechTextDoneProc 
(deftrap "_NewSpeechTextDoneUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewSpeechDoneUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewSpeechDoneProc 
(deftrap "_NewSpeechDoneUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewSpeechSyncUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewSpeechSyncProc 
(deftrap "_NewSpeechSyncUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewSpeechErrorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewSpeechErrorProc 
(deftrap "_NewSpeechErrorUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewSpeechPhonemeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewSpeechPhonemeProc 
(deftrap "_NewSpeechPhonemeUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewSpeechWordUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewSpeechWordProc 
(deftrap "_NewSpeechWordUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeSpeechTextDoneUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeSpeechTextDoneUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeSpeechDoneUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeSpeechDoneUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeSpeechSyncUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeSpeechSyncUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeSpeechErrorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeSpeechErrorUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeSpeechPhonemeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeSpeechPhonemeUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeSpeechWordUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeSpeechWordUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeSpeechTextDoneUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallSpeechTextDoneProc 
(deftrap-inline "_InvokeSpeechTextDoneUPP" 
      ((chan :pointer) (refCon :signed-long) (nextBuf (:pointer :pointer)) (byteLen (:pointer :unsigned-long)) (controlFlags (:pointer :signed-long)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeSpeechDoneUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallSpeechDoneProc 
(deftrap-inline "_InvokeSpeechDoneUPP" 
      ((chan :pointer) (refCon :signed-long) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeSpeechSyncUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallSpeechSyncProc 
(deftrap-inline "_InvokeSpeechSyncUPP" 
      ((chan :pointer) (refCon :signed-long) (syncMessage :ostype) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeSpeechErrorUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallSpeechErrorProc 
(deftrap-inline "_InvokeSpeechErrorUPP" 
      ((chan :pointer) (refCon :signed-long) (theError :signed-integer) (bytePos :signed-long) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeSpeechPhonemeUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallSpeechPhonemeProc 
(deftrap-inline "_InvokeSpeechPhonemeUPP" 
      ((chan :pointer) (refCon :signed-long) (phonemeOpcode :signed-integer) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeSpeechWordUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallSpeechWordProc 
(deftrap-inline "_InvokeSpeechWordUPP" 
      ((chan :pointer) (refCon :signed-long) (wordPos :unsigned-long) (wordLen :unsigned-integer) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  SpeechManagerVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SpeechManagerVersion" 
      ()
   (:stack :numversion)
   (:stack-trap #xA800 :d0 (+ (ash 0 16) 12)))

; 
;  *  MakeVoiceSpec()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_MakeVoiceSpec" 
      ((creator :ostype) (id :ostype) (voice (:pointer :voicespec)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1540 16) 12) creator id voice))

; 
;  *  CountVoices()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CountVoices" 
      ((numVoices (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 264 16) 12) numVoices))

; 
;  *  GetIndVoice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetIndVoice" 
      ((index :signed-integer) (voice (:pointer :voicespec)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 780 16) 12) index voice))

; 
;  *  GetVoiceDescription()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_GetVoiceDescription" 
      ((voice (:pointer :voicespec)) (info (:pointer :voicedescription)) (infoLength :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1552 16) 12) voice info infoLength))

; 
;  *  GetVoiceInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_GetVoiceInfo" 
      ((voice (:pointer :voicespec)) (selector :ostype) (voiceInfo :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1556 16) 12) voice selector voiceInfo))

; 
;  *  NewSpeechChannel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_NewSpeechChannel" 
      ((voice (:pointer :voicespec)) (chan (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1048 16) 12) voice chan))

; 
;  *  DisposeSpeechChannel()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeSpeechChannel" 
      ((chan :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 540 16) 12) chan))

; 
;  *  SpeakString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SpeakString" 
      ((textToBeSpoken (:string 255)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 544 16) 12) textToBeSpoken))

; 
;  *  SpeakText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SpeakText" 
      ((chan :pointer) (textBuf :pointer) (textBytes :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1572 16) 12) chan textBuf textBytes))

; 
;  *  SpeakBuffer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SpeakBuffer" 
      ((chan :pointer) (textBuf :pointer) (textBytes :unsigned-long) (controlFlags :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 2088 16) 12) chan textBuf textBytes controlFlags))

; 
;  *  StopSpeech()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_StopSpeech" 
      ((chan :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 556 16) 12) chan))

; 
;  *  StopSpeechAt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_StopSpeechAt" 
      ((chan :pointer) (whereToStop :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1072 16) 12) chan whereToStop))

; 
;  *  PauseSpeechAt()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PauseSpeechAt" 
      ((chan :pointer) (whereToPause :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1076 16) 12) chan whereToPause))

; 
;  *  ContinueSpeech()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ContinueSpeech" 
      ((chan :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 568 16) 12) chan))

; 
;  *  SpeechBusy()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SpeechBusy" 
      ()
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 60 16) 12)))

; 
;  *  SpeechBusySystemWide()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SpeechBusySystemWide" 
      ()
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 64 16) 12)))

; 
;  *  SetSpeechRate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetSpeechRate" 
      ((chan :pointer) (rate :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1092 16) 12) chan rate))

; 
;  *  GetSpeechRate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetSpeechRate" 
      ((chan :pointer) (rate (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1096 16) 12) chan rate))

; 
;  *  SetSpeechPitch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetSpeechPitch" 
      ((chan :pointer) (pitch :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1100 16) 12) chan pitch))

; 
;  *  GetSpeechPitch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetSpeechPitch" 
      ((chan :pointer) (pitch (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1104 16) 12) chan pitch))

; 
;  *  SetSpeechInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetSpeechInfo" 
      ((chan :pointer) (selector :ostype) (speechInfo :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1620 16) 12) chan selector speechInfo))

; 
;  *  GetSpeechInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetSpeechInfo" 
      ((chan :pointer) (selector :ostype) (speechInfo :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1624 16) 12) chan selector speechInfo))

; 
;  *  TextToPhonemes()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TextToPhonemes" 
      ((chan :pointer) (textBuf :pointer) (textBytes :unsigned-long) (phonemeBuf :handle) (phonemeBytes (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 2652 16) 12) chan textBuf textBytes phonemeBuf phonemeBytes))

; 
;  *  UseDictionary()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in SpeechLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_UseDictionary" 
      ((chan :pointer) (dictionary :handle))
   (:stack :signed-integer)
   (:stack-trap #xA800 :d0 (+ (ash 1120 16) 12) chan dictionary))

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := SpeechSynthesisIncludes

; $ENDC                                         ; __SPEECHSYNTHESIS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'SpeechSynthesis)