(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Start.p"
; at Wednesday May 1,2002 2:42:53 pm.
; 
;      File:       Start.p
;  
;      Contains:   Start Manager Interfaces.
;  
;      Version:    Technology: Mac OS 8.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1987-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __START__
; $SETC __START__ := 1

; $I+
; $SETC StartIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;     Important: When the major version number of kExtensionTableVersion and the value
;     returned by gestaltExtensionTableVersion change, it indicates that the Extension
;     Table startup mechanism has radically changed and code that doesn't know about
;     the new major version must not attempt to use the Extension Table startup
;     mechanism.
;     
;     Changes to the minor version number of kExtensionTableVersion indicate that the
;     definition of the ExtensionElement structure has been extended, but the fields
;     defined for previous minor versions of kExtensionTableVersion have not changed.
; 

(defconstant $kExtensionTableVersion #x100)     ;   current ExtensionTable version (1.0.0)  

; 	 ExtensionNotification message codes 	
(defconstant $extNotificationBeforeFirst 0)     ;   Before any extensions have loaded  
(defconstant $extNotificationAfterLast 1)       ;   After all extensions have loaded  
(defconstant $extNotificationBeforeCurrent 2)   ;   Before extension at extElementIndex is loaded  
(defconstant $extNotificationAfterCurrent 3)    ;   After extension at extElementIndex is loaded  

(def-mactype :extensionelementptr (find-mactype '(:pointer :extensionelement)))
(defrecord ExtensionElement 
   (fileName (:string 31))                      ;   The file name  
   (parentDirID :signed-long)                   ;   the file's parent directory ID  
;   and everything after ioNamePtr in the HParamBlockRec.fileParam variant  
   (ioVRefNum :signed-integer)                  ;   always the real volume reference number (not a drive, default, or working dirID)  
   (ioFRefNum :signed-integer)
   (ioFVersNum :signed-byte)
   (filler1 :signed-byte)
   (ioFDirIndex :signed-integer)                ;   always 0 in table  
   (ioFlAttrib :signed-byte)
   (ioFlVersNum :signed-byte)
   (ioFlFndrInfo :finfo)
   (ioDirID :signed-long)
   (ioFlStBlk :unsigned-integer)
   (ioFlLgLen :signed-long)
   (ioFlPyLen :signed-long)
   (ioFlRStBlk :unsigned-integer)
   (ioFlRLgLen :signed-long)
   (ioFlRPyLen :signed-long)
   (ioFlCrDat :unsigned-long)
   (ioFlMdDat :unsigned-long)
   )

(def-mactype :extensiontableheaderptr (find-mactype '(:pointer :extensiontableheader)))
(defrecord ExtensionTableHeader 
   (extTableHeaderSize :unsigned-long)          ;   size of ExtensionTable header ( equal to offsetof(ExtensionTable, extElements[0]) )  
   (extTableVersion :unsigned-long)             ;   current ExtensionTable version (same as returned by gestaltExtTableVersion Gestalt selector)  
   (extElementIndex :unsigned-long)             ;   current index into ExtensionElement records (zero-based)  
   (extElementSize :unsigned-long)              ;   size of ExtensionElement  
   (extElementCount :unsigned-long)             ;   number of ExtensionElement records in table (1-based)  
   )

(def-mactype :extensiontableptr (find-mactype '(:pointer :extensiontable)))
(defrecord ExtensionTable 
   (extTableHeader :extensiontableheader)       ;   the ExtensionTableHeader  
   (extElements (:array :extensionelement 1))   ;   one element for each extension to load  
   )

(def-mactype :extensiontablehandle (find-mactype '(:handle :extensiontable)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ExtensionNotificationProcPtr = PROCEDURE(message: UInt32; param: UNIV Ptr; extElement: ExtensionElementPtr);

|#
 |#                                             ; $ELSEC
(def-mactype :extensionnotificationprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ExtensionTableHandlerProcPtr = PROCEDURE(message: UInt32; param: UNIV Ptr; extTableHandle: ExtensionTableHandle);

|#
 |#                                             ; $ELSEC
(def-mactype :extensiontablehandlerprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :extensionnotificationupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :extensionnotificationupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :extensiontablehandlerupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :extensiontablehandlerupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppExtensionNotificationProcInfo #xFC0)
(defconstant $uppExtensionTableHandlerProcInfo #xFC0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewExtensionNotificationUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewExtensionNotificationProc 
(deftrap "_NewExtensionNotificationUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewExtensionTableHandlerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewExtensionTableHandlerProc 
(deftrap "_NewExtensionTableHandlerUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeExtensionNotificationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeExtensionNotificationUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeExtensionTableHandlerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeExtensionTableHandlerUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeExtensionNotificationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallExtensionNotificationProc 
(deftrap-inline "_InvokeExtensionNotificationUPP" 
      ((message :unsigned-long) (param :pointer) (extElement (:pointer :extensionelement)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeExtensionTableHandlerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallExtensionTableHandlerProc 
(deftrap-inline "_InvokeExtensionTableHandlerUPP" 
      ((message :unsigned-long) (param :pointer) (extTableHandle (:handle :extensiontable)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

(def-mactype :defstartrecptr (find-mactype '(:pointer :defstartrec)))
(defrecord DefStartRec 
   (:variant 
      (
      (sdExtDevID :signed-byte)
      (sdPartition :signed-byte)
      (sdSlotNum :signed-byte)
      (sdSRsrcID :signed-byte)
      )
      (
      (sdReserved1 :signed-byte)
      (sdReserved2 :signed-byte)
      (sdRefNum :signed-integer)
      )
      )
   )

(def-mactype :defstartptr (find-mactype '(:pointer :defstartrec)))
(def-mactype :defstartptrptr (find-mactype '(:handle :defstartrec)))
(def-mactype :defvideorecptr (find-mactype '(:pointer :defvideorec)))
(defrecord DefVideoRec 
   (sdSlot :signed-byte)
   (sdsResource :signed-byte)
   )

(def-mactype :defvideoptr (find-mactype '(:pointer :defvideorec)))
(def-mactype :defosrecptr (find-mactype '(:pointer :defosrec)))
(defrecord DefOSRec 
   (sdReserved :signed-byte)
   (sdOSType :signed-byte)
   )

(def-mactype :defosptr (find-mactype '(:pointer :defosrec)))
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  GetDefaultStartup()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap "_GetDefaultStartup" 
      ((paramBlock (:pointer :defstartrec)))
   nil
   (:register-trap #xA07D :a0 paramBlock))

; 
;  *  SetDefaultStartup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetDefaultStartup" 
      ((paramBlock (:pointer :defstartrec)))
   nil
   (:register-trap #xA07E :a0 paramBlock))

; 
;  *  GetVideoDefault()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetVideoDefault" 
      ((paramBlock (:pointer :defvideorec)))
   nil
   (:register-trap #xA080 :a0 paramBlock))

; 
;  *  SetVideoDefault()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetVideoDefault" 
      ((paramBlock (:pointer :defvideorec)))
   nil
   (:register-trap #xA081 :a0 paramBlock))

; 
;  *  GetOSDefault()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetOSDefault" 
      ((paramBlock (:pointer :defosrec)))
   nil
   (:register-trap #xA084 :a0 paramBlock))

; 
;  *  SetOSDefault()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetOSDefault" 
      ((paramBlock (:pointer :defosrec)))
   nil
   (:register-trap #xA083 :a0 paramBlock))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  SetTimeout()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  GetTimeout()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_SetTimeout" 
      ((count :signed-integer)) 
  nil
   () )
(deftrap-inline "_GetTimeout" 
      ((count (:pointer :signed-integer))) 
  nil
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; 
;     InstallExtensionNotificationProc
; 
;     Installs an ExtensionNotificationUPP.
; 
;     Parameters:
;         extNotificationProc The ExtensionNotificationUPP to install.
; 
;     Results:
;         noErr       0       The ExtensionNotificationUPP was installed.
;         paramErr    -50     This ExtensionNotificationUPP has already been installed.
;         memFullErr  -108    Not enough memory to install the ExtensionNotificationUPP.
; 
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  InstallExtensionNotificationProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_InstallExtensionNotificationProc" 
      ((extNotificationProc :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA7D :d0 0 extNotificationProc))

; 
;     RemoveExtensionNotificationProc
; 
;     Removes an ExtensionNotificationUPP.
;     
;     Note:   ExtensionNotificationUPPs can't call RemoveExtensionNotificationProc.
; 
;     Parameters:
;         extNotificationProc The ExtensionNotificationUPP to remove.
; 
;     Results:
;         noErr       0       The ExtensionNotificationUPP was removed.
;         paramErr    -50     The ExtensionNotificationUPP was not found, or
;                             RemoveExtensionNotificationProc was called from within
;                             a ExtensionNotificationUPP (ExtensionNotificationUPPs can't
;                             call RemoveExtensionNotificationProc).
; 
; 
;  *  RemoveExtensionNotificationProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_RemoveExtensionNotificationProc" 
      ((extNotificationProc :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA7D :d0 1 extNotificationProc))

; 
;     InstallExtensionTableHandlerProc
; 
;     Installs an ExtensionTableHandlerUPP. Control is taken away from the system's default
;     handler and the ExtensionTableHandlerUPP is responsible for all changes to the
;     ExtensionTable (except for incrementing extElementIndex between extensions). This is
;     always the first handler called with extNotificationBeforeFirst and
;     extNotificationBeforeCurrent messages and the last handler called with
;     extNotificationAfterLast and extNotificationAfterCurrent messages. extElementIndex
;     is always incremented immediately after the ExtensionTableHandlerUPP is called with
;     the extNotificationAfterCurrent message.
;     
;     There can only be one ExtensionTableHandler installed.
;     
;     Warning:    The only safe time to change what ExtensionElement is at
;                 ExtensionTable.extElements[extElementIndex] is when your
;                 ExtensionTableHandlerUPP is called with the extNotificationAfterCurrent
;                 message. You may change the ExtensionTable or the extElementIndex at other
;                 times, but you must ensure that the ExtensionElement at
;                 ExtensionTable.extElements[extElementIndex] stays the same.
;                 
;     Note:       If the ExtensionTable or the contents of the folders included in the
;                 ExtensionTable are changed after installing an ExtensionTableHandler,
;                 RemoveExtensionTableHandlerProc cannot be called.
; 
;     Parameters:
;         extMgrProc          The ExtensionTableHandlerUPP to install.
;         extTable            A pointer to an ExtensionTableHandle where
;                             InstallExtensionTableHandlerProc will return the current
;                             ExtensionTableHandle. You don't own the handle itself and
;                             must not dispose of it, but you can change the extElementIndex.
;                             the extElementCount, and the ExtensionElements in the table.
; 
;     Results:
;         noErr       0       The ExtensionTableHandlerUPP was installed.
;         paramErr    -50     Another ExtensionTableHandlerUPP has already been installed.
;         memFullErr  -108    Not enough memory to install the ExtensionTableHandlerUPP.
; 
; 
;  *  InstallExtensionTableHandlerProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_InstallExtensionTableHandlerProc" 
      ((extMgrProc :pointer) (extTable (:pointer (:handle :extensiontable))))
   (:stack :signed-integer)
   (:stack-trap #xAA7D :d0 2 extMgrProc extTable))

; 
;     RemoveExtensionTableHandlerProc
; 
;     Remove an ExtensionTableUPP. Control is passed back to the default handler.
; 
;     Parameters:
;         extMgrProc          The ExtensionTableUPP to remove.
; 
;     Results:
;         noErr       0       The ExtensionTableUPP was removed.
;         paramErr    -50     This ExtensionTableUPP was not installed,
;                             or the ExtensionTable no longer matches the
;                             original boot ExtensionTable.
; 
; 
;  *  RemoveExtensionTableHandlerProc()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_RemoveExtensionTableHandlerProc" 
      ((extMgrProc :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA7D :d0 3 extMgrProc))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  * Native StartLib calls - these are implemented ONLY on NewWorld machines (iMac, etc.)
;  *
;  * These functions should be weak linked.  If unavailable, use older method (Get/SetDefaultStartup)
;  
; 
;  * The enums below define pseudo startup devices, such as a network disk.  They can be used in place
;  * of driveNums in various StartLib calls
;  *
;  * NOTE - the values are chosen to avoid conflict with vRefNums (low negative numbers), wdRefNums
;  *      (large negative numbers) and drive numbers (low positive numbers)
;  

(defconstant $kNetworkStartupDevice 32767)
(defconstant $kLocalStartupDevice 32766)

; 	
; 	 * The enums below determine the maximum string size of parameters for network startup device calls.
; 	 	
(defconstant $kSMProtocolStringSize 16)
(defconstant $kSMAddressStringSize 16)
(defconstant $kSMBootFilenameSize 128)

; 	
; 	 * GetSelectedStartupDevice - return the driveNum of the currently selected startup device.  This refers
; 	 * to the device selected by the user via Startup Disk control panel, which may or may not be the
; 	 * device currently booted.
; 	 	
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  GetSelectedStartupDevice()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in StartLib 1.0 and later
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	

(deftrap-inline "_GetSelectedStartupDevice" 
      ((driveNum (:pointer :unsigned-integer))) 
  :signed-integer
   () )

; 
;  * GetSelectedStartupDeviceType - return the type of the currently selected startup device.  This refers
;  * to the device selected by the user via Startup Disk control panel, which may or may not be the
;  * device currently booted.  Returned types are based on kdgInterface  DriverGestalt response 
;  * ('scsi', 'ata ', 'fire', etc.)
;  
; 
;  *  GetSelectedStartupDeviceType()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in StartLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetSelectedStartupDeviceType" 
      ((interfaceType (:pointer :ostype))) 
  :signed-integer
   () )

; 
;  * GetSelectedFirewireStartupDeviceInfo - for a startup device of type Firewire, get pertinent info, including
;  * GUID, mao and lun.  This refers to the device selected by the user via Startup Disk control panel, which 
;  * may or may not be the device currently booted.
;  *
;  * GetSelectedFirewireStartupDeviceInfo should only be called if GetSelectedStartupDeviceType returns
;  * the type kdgFireWireIntf.  If the selected startup device is not kdgFireWireIntf,
;  * GetSelectedFirewireStartupDeviceInfo returns an error (nsDrvErr) and the return parameters are
;  * undefined.
;  
; 
;  *  GetSelectedFirewireStartupDeviceInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in StartLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetSelectedFirewireStartupDeviceInfo" 
      ((GUID (:pointer :unsignedwide)) (mao (:pointer :unsigned-long)) (lun (:pointer :unsigned-long))) 
  :signed-integer
   () )

; 
;  * GetSelectedNetworkStartupDeviceInfo - for a network startup device, return relevant information (this refers
;  * to the device selected by the user via Startup Disk control panel, which may or may not be the
;  * device currently booted):
;  *
;  * See the Open Firmware netbooting recommended practices:
;  *      http://playground.sun.com/1275/practice/obp-tftp/tftp1_0.pdf
;  *
;  * The possible parameters for this call are:
;  *
;  *      [bootp,]siaddr,filename,ciaddr,giaddr,bootp-retries,tftp-retries
;  *
;  *          bootp...specifies the use of BOOTP as the discovery protocol to be used.
;  *          siaddr is the IP address of the intended server.
;  *          filename is the filename of the file that is to be loaded by TFTP from the server.
;  *          ciaddr is the IP address of the client (i.e., the system being booted).
;  *          giaddr is the IP address of the BOOTP gateway.
;  *          bootp-retries is the maximum number of retries that are attempted before the BOOTP process is determined to have failed.
;  *          tftp-retries is the maximum number of retries that are attempted before the TFTP process is stopped.
;  *
;  *      Address parameters are specified as strings, not binary (e.g., "128.1.1.1") and are limited to kSMAddressStringSize
;  *      (16 bytes) in length.  filename parameter is limited to kSMBootFilenameSize (128 bytes) in length.  protocol 
;  *      parameter is limited to kSMProtocolStringSize in length
;  
; 
;  *  GetSelectedNetworkStartupDeviceInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in StartLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_GetSelectedNetworkStartupDeviceInfo" 
      ((protocol :pointer) (siaddr :pointer) (filename :pointer) (ciaddr :pointer) (giaddr :pointer) (bootpRetries (:pointer :unsigned-long)) (tftpRetries (:pointer :unsigned-long)) (reserved :unsigned-long)) 
  :signed-integer
   () )

; 
;  * IsDriveSelectable - determines if the drive specified by driveNum is a candidate for booting.  This
;  * checks criteria, such as necessary driver support and Open Firmware support, which are minimal for
;  * the device to be considered as a startup device.  This call does not check other criteria, such as
;  * whether or not a valid System Folder is present on the volume.
;  
; 
;  *  IsDriveSelectable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in StartLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_IsDriveSelectable" 
      ((driveNum :unsigned-integer)) 
  :boolean
   () )

; 
;  * SetSelectedStartupDevice - set the device referred to by driveNum to be the startup device.  Passing
;  * the pseudo-device kNetworkStartupDevice sets default enet:bootp behavior.  For more complex 
;  * scenarios, use SetSelectedNetworkStartupDevice (q.v.).
;  
; 
;  *  SetSelectedStartupDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in StartLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SetSelectedStartupDevice" 
      ((driveNum :unsigned-integer)) 
  :signed-integer
   () )

; 
;  * SetSelectedNetworkStartupDevice - set a network device as the startup device.  This is for more
;  * complex setup than handled by SetSelectedStartupDevice.
;  *
;  * See the Open Firmware netbooting recommended practices:
;  *      http://playground.sun.com/1275/practice/obp-tftp/tftp1_0.pdf
;  *
;  * The possible parameters for this call are:
;  *
;  *      [bootp,]siaddr,filename,ciaddr,giaddr,bootp-retries,tftp-retries
;  *
;  *          bootp...specifies the use of BOOTP as the discovery protocol to be used.
;  *              if not specified (parameter is nil), bootp is used by default
;  *          siaddr is the IP address of the intended server.
;  *          filename is the filename of the file that is to be loaded by TFTP from the server.
;  *          ciaddr is the IP address of the client (i.e., the system being booted).
;  *          giaddr is the IP address of the BOOTP gateway.
;  *          bootp-retries is the maximum number of retries that are attempted before the BOOTP process is determined to have failed.
;  *          tftp-retries is the maximum number of retries that are attempted before the TFTP process is stopped.
;  *
;  *      Address parameters are specified as strings, not binary (e.g., "128.1.1.1") and are limited to kSMAddressStringSize
;  *      (16 bytes) in length.  filename parameter is limited to kSMBootFilenameSize (128 bytes) in length.  protocol 
;  *      parameter is limited to kSMProtocolStringSize in length
;  *
;  *  NOTE - unspecified parameters should be specified as nil, except for retry parameters which should be zero.
;  
; 
;  *  SetSelectedNetworkStartupDevice()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in StartLib 1.0 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap-inline "_SetSelectedNetworkStartupDevice" 
      ((protocol :pointer) (siaddr :pointer) (filename :pointer) (ciaddr :pointer) (giaddr :pointer) (bootpRetries :unsigned-long) (tftpRetries :unsigned-long) (reserved :unsigned-long)) 
  :signed-integer
   () )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := StartIncludes

; $ENDC                                         ; __START__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'Start)