(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:StringCompare.p"
; at Wednesday May 1,2002 2:39:49 pm.
; 
;      File:       StringCompare.p
;  
;      Contains:   Public interfaces for String Comparison and related operations
;  
;      Version:    Technology: Mac OS 8
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __STRINGCOMPARE__
; $SETC __STRINGCOMPARE__ := 1

; $I+
; $SETC StringCompareIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __TEXTCOMMON__
|#

(require-interface 'TextCommon)
#|                                              ; $I TextCommon.p
 |#                                             ; $ENDC
; $IFC UNDEFINED __SCRIPT__

(require-interface 'Script)                     ; $I Script.p
; $ENDC
; $IFC UNDEFINED __TYPESELECT__

(require-interface 'TypeSelect)                 ; $I TypeSelect.p
; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
; 
;     Here are the current System 7 routine names and the translations to the older forms.
;     Please use the newer forms in all new code and migrate the older names out of existing
;     code as maintenance permits.
;     
;     NEW NAME                    OLD NAME                    OBSOLETE FORM (no handle)
;     
;     CompareString (Str255)      IUCompPString (hp only)     IUCompString (hp only)
;     CompareText (ptr/len)       IUMagPString                IUMagString
;     IdenticalString (Str255)    IUEqualPString (hp only)    IUEqualString  (hp only)
;     IdenticalText (ptr/len)     IUMagIDPString              IUMagIDString
;     LanguageOrder               IULangOrder
;     ScriptOrder                 IUScriptOrder
;     StringOrder (Str255)        IUStringOrder (hp only)
;     TextOrder (ptr/len)         IUTextOrder
; 
;     RelString
;     CmpString (a only)                  
;     EqualString (hp only)
;     
;     ReplaceText
; 
;     Carbon only supports the new names.  The old names are undefined for Carbon targets.
; 
;     InterfaceLib always has exported the old names.  For C macros have been defined to allow
;     the use of the new names.  For Pascal and Assembly using the new names will result
;     in link errors. 
;     
; 

;   Special language code values for Language Order 
(defconstant $systemCurLang -2)                 ;   current (itlbLang) lang for system script 
(defconstant $systemDefLang -3)                 ;   default (table) lang for system script 
(defconstant $currentCurLang -4)                ;   current (itlbLang) lang for current script 
(defconstant $currentDefLang -5)                ;   default lang for current script 
(defconstant $scriptCurLang -6)                 ;   current (itlbLang) lang for specified script 
(defconstant $scriptDefLang -7)                 ;   default language for a specified script 

;   obsolete names 
(defconstant $iuSystemCurLang -2)
(defconstant $iuSystemDefLang -3)
(defconstant $iuCurrentCurLang -4)
(defconstant $iuCurrentDefLang -5)
(defconstant $iuScriptCurLang -6)
(defconstant $iuScriptDefLang -7)

; 	
; 	 *  These routines are available in Carbon with the new names.
; 	 	
; 
; 	 *  [Mac]ReplaceText()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_ReplaceText" 
      ((baseText :handle) (substitutionText :handle) (key (:pointer (:string 15))))
   (:stack :signed-integer)
   (:stack-trap #xA8B5 baseText substitutionText key ((+ (ash 33292 16) 65500) :signed-longint)))

; 
;  *  ScriptOrder()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ScriptOrder" 
      ((script1 :signed-integer) (script2 :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA9ED script1 script2 (30 :signed-integer)))

; 
;  *  [Mac]CompareString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  IdenticalString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_CompareString" 
      ((aStr (:string 255)) (bStr (:string 255)) (itl2Handle :handle)) 
  :signed-integer
   () )                                         ; 
;  *  StringOrder()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IdenticalString" 
      ((aStr (:string 255)) (bStr (:string 255)) (itl2Handle :handle)) 
  :signed-integer
   () )                                         ; 
;  *  CompareText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_StringOrder" 
      ((aStr (:string 255)) (bStr (:string 255)) (aScript :signed-integer) (bScript :signed-integer) (aLang :signed-integer) (bLang :signed-integer)) 
  :signed-integer
   () )
(deftrap "_CompareText" 
      ((aPtr :pointer) (bPtr :pointer) (aLen :signed-integer) (bLen :signed-integer) (itl2Handle :handle))
   (:stack :signed-integer)
   (:stack-trap #xA9ED aPtr bPtr aLen bLen itl2Handle (26 :signed-integer)))

; 
;  *  IdenticalText()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_IdenticalText" 
      ((aPtr :pointer) (bPtr :pointer) (aLen :signed-integer) (bLen :signed-integer) (itl2Handle :handle))
   (:stack :signed-integer)
   (:stack-trap #xA9ED aPtr bPtr aLen bLen itl2Handle (28 :signed-integer)))

; 
;  *  TextOrder()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TextOrder" 
      ((aPtr :pointer) (bPtr :pointer) (aLen :signed-integer) (bLen :signed-integer) (aScript :signed-integer) (bScript :signed-integer) (aLang :signed-integer) (bLang :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA9ED aPtr bPtr aLen bLen aScript bScript aLang bLang (34 :signed-integer)))

; 
;  *  LanguageOrder()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_LanguageOrder" 
      ((language1 :signed-integer) (language2 :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA9ED language1 language2 (32 :signed-integer)))

; 
;  *  These routines are available in InterfaceLib with old names.
;  *  Macros are provided for C to allow source code use to the new names.
;  
; $IFC CALL_NOT_IN_CARBON 
; 
;  *  IUMagPString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_IUMagPString" 
      ((aPtr :pointer) (bPtr :pointer) (aLen :signed-integer) (bLen :signed-integer) (itl2Handle :handle))
   (:stack :signed-integer)
   (:stack-trap #xA9ED aPtr bPtr aLen bLen itl2Handle (26 :signed-integer)))

; 
;  *  IUMagIDPString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_IUMagIDPString" 
      ((aPtr :pointer) (bPtr :pointer) (aLen :signed-integer) (bLen :signed-integer) (itl2Handle :handle))
   (:stack :signed-integer)
   (:stack-trap #xA9ED aPtr bPtr aLen bLen itl2Handle (28 :signed-integer)))

; 
;  *  IUTextOrder()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_IUTextOrder" 
      ((aPtr :pointer) (bPtr :pointer) (aLen :signed-integer) (bLen :signed-integer) (aScript :signed-integer) (bScript :signed-integer) (aLang :signed-integer) (bLang :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA9ED aPtr bPtr aLen bLen aScript bScript aLang bLang (34 :signed-integer)))

; 
;  *  IULangOrder()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_IULangOrder" 
      ((language1 :signed-integer) (language2 :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA9ED language1 language2 (32 :signed-integer)))

; 
;  *  IUScriptOrder()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_IUScriptOrder" 
      ((script1 :signed-integer) (script2 :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA9ED script1 script2 (30 :signed-integer)))

; 
;  *  IUMagString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_IUMagString" 
      ((aPtr :pointer) (bPtr :pointer) (aLen :signed-integer) (bLen :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA9ED aPtr bPtr aLen bLen (10 :signed-integer)))

; 
;  *  IUMagIDString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_IUMagIDString" 
      ((aPtr :pointer) (bPtr :pointer) (aLen :signed-integer) (bLen :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA9ED aPtr bPtr aLen bLen (12 :signed-integer)))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  IUCompPString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  IUEqualPString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_IUCompPString" 
      ((aStr (:string 255)) (bStr (:string 255)) (itl2Handle :handle)) 
  :signed-integer
   () )                                         ; 
;  *  IUStringOrder()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_IUEqualPString" 
      ((aStr (:string 255)) (bStr (:string 255)) (itl2Handle :handle)) 
  :signed-integer
   () )                                         ; 
;  *  IUCompString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_IUStringOrder" 
      ((aStr (:string 255)) (bStr (:string 255)) (aScript :signed-integer) (bScript :signed-integer) (aLang :signed-integer) (bLang :signed-integer)) 
  :signed-integer
   () )                                         ; 
;  *  IUEqualString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_IUCompString" 
      ((aStr (:string 255)) (bStr (:string 255))) 
  :signed-integer
   () )
(deftrap-inline "_IUEqualString" 
      ((aStr (:string 255)) (bStr (:string 255))) 
  :signed-integer
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; 
;  *  RelString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  EqualString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_RelString" 
      ((str1 (:string 255)) (str2 (:string 255)) (caseSensitive :boolean) (diacSensitive :boolean)) 
  :signed-integer
   () )                                         ; $ALIGN RESET; $POP; $SETC UsingIncludes := StringCompareIncludes
(deftrap-inline "_EqualString" 
      ((str1 (:string 255)) (str2 (:string 255)) (caseSensitive :boolean) (diacSensitive :boolean)) 
  :boolean
   () )                                         ; $ENDC; __STRINGCOMPARE__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'StringCompare)