(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:TSMTE.p"
; at Wednesday May 1,2002 2:41:01 pm.
; 
;      File:       TSMTE.p
;  
;      Contains:   Text Services Managerfor TextEdit Interfaces.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1991-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __TSMTE__
; $SETC __TSMTE__ := 1

; $I+
; $SETC TSMTEIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __TEXTEDIT__
|#

(require-interface 'TextEdit)
#|                                              ; $I TextEdit.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __DIALOGS__
|#

(require-interface 'Dialogs)
#|                                              ; $I Dialogs.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __APPLEEVENTS__
|#

(require-interface 'AppleEvents)
#|                                              ; $I AppleEvents.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __TEXTSERVICES__
|#

(require-interface 'TextServices)
#|                                              ; $I TextServices.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;   signature, interface types 

(defconstant $kTSMTESignature :|tmTE|)
(defconstant $kTSMTEInterfaceType :|tmTE|)

; 
; 	    In Carbon, since DialogRef is opaque, the TSMDialogRecord is removed.
; 	    Only one kind of TSMTE dialog remains, with extended data managed by TSMTE.
; 	    Use kTSMTESignature for the dialog refCon, and use the accessors below,
; 	    i.e. GetTSMTEDialogTSMTERecHandle, to get at the old TSMDialogRecord info.
; 	
; $IFC CALL_NOT_IN_CARBON 
(defconstant $kTSMTEDialog :|tmDI|)

; $ENDC                                         ; CALL_NOT_IN_CARBON

;   update flag for TSMTERec 
(defconstant $kTSMTEAutoScroll 1)

;   callback procedure definitions 

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TSMTEPreUpdateProcPtr = PROCEDURE(textH: TEHandle; refCon: LONGINT);

|#
 |#                                             ; $ELSEC
(def-mactype :tsmtepreupdateprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TSMTEPostUpdateProcPtr = PROCEDURE(textH: TEHandle; fixLen: LONGINT; inputAreaStart: LONGINT; inputAreaEnd: LONGINT; pinStart: LONGINT; pinEnd: LONGINT; refCon: LONGINT);

|#
 |#                                             ; $ELSEC
(def-mactype :tsmtepostupdateprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :tsmtepreupdateupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :tsmtepreupdateupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :tsmtepostupdateupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :tsmtepostupdateupp (find-mactype ':pointer))
; $ENDC

;   data types 
(def-mactype :tsmterecptr (find-mactype '(:pointer :tsmterec)))
(defrecord TSMTERec 
   (textH (:handle :terec))
   (preUpdateProc :pointer)
   (postUpdateProc :pointer)
   (updateFlag :signed-long)
   (refCon :signed-long)
   )

(def-mactype :tsmterechandle (find-mactype '(:handle :tsmterec)))
; $IFC NOT OPAQUE_TOOLBOX_STRUCTS 
(def-mactype :tsmdialogrecordptr (find-mactype '(:pointer :tsmdialogrecord)))
(defrecord TSMDialogRecord 
   (fDialog :dialogrecord)
   (fDocID :pointer)
   (fTSMTERecH (:handle :tsmterec))
   (fTSMTERsvd (:array :signed-long 3))         ;   reserved 
   )

(def-mactype :tsmdialogptr (find-mactype '(:pointer :tsmdialogrecord)))
(def-mactype :tsmdialogpeek (find-mactype '(:pointer :tsmdialogrecord)))
; $ENDC

(defconstant $uppTSMTEPreUpdateProcInfo #x3C0)
(defconstant $uppTSMTEPostUpdateProcInfo #xFFFC0)
; 
; 	 *  NewTSMTEPreUpdateUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewTSMTEPreUpdateProc 
(deftrap "_NewTSMTEPreUpdateUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewTSMTEPostUpdateUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was NewTSMTEPostUpdateProc 
(deftrap "_NewTSMTEPostUpdateUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeTSMTEPreUpdateUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeTSMTEPreUpdateUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeTSMTEPostUpdateUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeTSMTEPostUpdateUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeTSMTEPreUpdateUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallTSMTEPreUpdateProc 
(deftrap-inline "_InvokeTSMTEPreUpdateUPP" 
      ((textH (:handle :terec)) (refCon :signed-long) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeTSMTEPostUpdateUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallTSMTEPostUpdateProc 
(deftrap-inline "_InvokeTSMTEPostUpdateUPP" 
      ((textH (:handle :terec)) (fixLen :signed-long) (inputAreaStart :signed-long) (inputAreaEnd :signed-long) (pinStart :signed-long) (pinEnd :signed-long) (refCon :signed-long) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; $IFC ACCESSOR_CALLS_ARE_FUNCTIONS 
; 
;  *  IsTSMTEDialog()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0.2 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  Getters                                      ; 
;  *  GetTSMTEDialogDocumentID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0.2 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_IsTSMTEDialog" 
      ((dialog (:pointer :grafport))) 
  :boolean
   () )                                         ; 
;  *  GetTSMTEDialogTSMTERecHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0.2 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetTSMTEDialogDocumentID" 
      ((dialog (:pointer :grafport))) 
  :pointer
   () )                                         ;  Setters ; 
;  *  SetTSMTEDialogDocumentID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0.2 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_GetTSMTEDialogTSMTERecHandle" 
      ((dialog (:pointer :grafport))) 
  (:handle :tsmterec)
   () )                                         ; 
;  *  SetTSMTEDialogTSMTERecHandle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in CarbonAccessors.o 1.0.2 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SetTSMTEDialogDocumentID" 
      ((dialog (:pointer :grafport)) (documentID :pointer)) 
  nil
   () )
(deftrap-inline "_SetTSMTEDialogTSMTERecHandle" 
      ((dialog (:pointer :grafport)) (TSMTERecHandle (:handle :tsmterec))) 
  nil
   () )                                         ; $ENDC; ACCESSOR_CALLS_ARE_FUNCTIONS

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := TSMTEIncludes

; $ENDC                                         ; __TSMTE__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'TSMTE)