(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Telephones.p"
; at Wednesday May 1,2002 2:42:54 pm.
; 
;      File:       Telephones.p
;  
;      Contains:   Telephone Manager Interfaces.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1994-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED __TELEPHONES__
; $SETC __TELEPHONES__ := 1

; $I+
; $SETC TelephonesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __DIALOGS__
|#

(require-interface 'Dialogs)
#|                                              ; $I Dialogs.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __EVENTS__
|#

(require-interface 'Events)
#|                                              ; $I Events.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CTBUTILITIES__
|#

(require-interface 'CTBUtilities)
#|                                              ; $I CTBUtilities.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __COMPONENTS__
|#

(require-interface 'Components)
#|                                              ; $I Components.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; $IFC CALL_NOT_IN_CARBON 

(defconstant $curTELVersion 3)                  ;   current Telephone Manager version  
;      the chooseXXX symbols are defined in CTBUtilities.(pah)  
(defconstant $telChooseDisaster -2)
(defconstant $telChooseFailed -1)
(defconstant $telChooseAborted 0)
(defconstant $telChooseOKMinor 1)
(defconstant $telChooseOKMajor 2)
(defconstant $telChooseCancel 3)
(defconstant $telChooseOKTermChanged 4)

; $IFC UNDEFINED classTEL 
;   telephone tool file type  
(defconstant $classTEL :|vbnd|)

; $ENDC
; 	 PHYSICAL TERMINAL CONSTANTS 	
; 	 INDEPENDENT HANDSET CONSTANTS 	
(defconstant $telIndHSOnHook 0)                 ;   independent handset on hook  
(defconstant $telIndHSOffHook 1)                ;   independent handset off hook  

(defconstant $telIndHSDisconnected 0)           ;   handset disconnected from the line  
(defconstant $telIndHSConnected 1)              ;   handset connected to the line  

; 	 HOOK STATE CONSTANTS 	
(defconstant $telHandset 1)                     ;   handset hookswitch  
(defconstant $telSpeakerphone 2)                ;   speakerphone 'on' switch  

(defconstant $telDeviceOffHook 1)               ;   device off hook  
(defconstant $telDeviceOnHook 0)                ;   device on hook  

; 	 VOLUME CONTROL CONSTANTS 	
(defconstant $telHandsetSpeakerVol 1)           ;   volume of the handset speaker  
(defconstant $telHandsetMicVol 2)               ;   sensitivity of the handset mic  
(defconstant $telSpeakerphoneVol 3)             ;   speakerphone volume  
(defconstant $telSpeakerphoneMicVol 4)          ;   sensitivity of the spkrphone mic  
(defconstant $telRingerVol 5)                   ;   volume of the ringer  
(defconstant $telBuiltinSPVol 6)                ;   volume of the built-in speakerphone  
(defconstant $telBuiltinSPMicVol 7)             ;   sensitivity of the built-in speakerphone mic  

(defconstant $telVolSame 0)                     ;   leaves the volume at previous level  
(defconstant $telVolMin 1)                      ;   turns volume down to minimum level, but not off  
(defconstant $telVolMax 100)                    ;   highest level allowed by the Telephone Manager  

(defconstant $telVolStateSame 0)                ;   leaves device in same state  
(defconstant $telVolStateOff 1)                 ;   turns the device off, but doesn't change the volume setting. Use for mute functions.  
(defconstant $telVolStateOn 2)                  ;   turns the device on.  Volume setting is the same as previously set.  

; 	 DISPLAY CONSTANTS 	
(defconstant $telNormalDisplayMode 1)           ;   normal display mode  
(defconstant $telInspectMode 2)                 ;   inspect display mode  
(defconstant $telMiscMode 3)                    ;   miscellaneous display mode  
(defconstant $telRetrieveMode 4)                ;   message retrieval mode  
(defconstant $telDirectoryQueryMode 5)          ;   electronic directory mode  
(defconstant $telEntireDisplay 0)               ;   entire Display  

; 	 KEY PRESS CONSTANTS 	
(defconstant $telHangupKey 1)                   ;   drop, or release, key pressed  
(defconstant $telHoldKey 2)                     ;   hold key pressed  
(defconstant $telConferenceKey 3)               ;   conference key pressed  
(defconstant $telTransferKey 4)                 ;   transfer key pressed  
(defconstant $telForwardKey 5)                  ;   call forward key pressed  
(defconstant $telCallbackKey 6)                 ;   call back key pressed  
(defconstant $telDNDKey 7)                      ;   do not disturb key pressed  
(defconstant $telCallPickupKey 8)               ;   call Pickup key pressed  
(defconstant $telCallParkKey 9)                 ;   call Park key pressed  
(defconstant $telCallDeflectKey 10)             ;   call Deflect key pressed  
(defconstant $telVoiceMailAccessKey 11)         ;   voice Mail Access key pressed  
(defconstant $telCallRejectKey 12)              ;   call Reject key pressed  
(defconstant $telOtherKey 16)                   ;   other key pressed  

(defconstant $telKeyPadPress 1)                 ;   key pressed on 12 digit keypad 
(defconstant $telFeatureKeyPress 2)             ;   feature Key Pressed  

(defconstant $telTerminalEnabled 0)
(defconstant $telTerminalDisabled 1)

(defconstant $telUnknown 0)                     ;   unknown error  
(defconstant $telTerminalHWDisconnected 1)      ;   terminal hardware is disconnected  
(defconstant $telDeviceDriverClosed 2)          ;   device driver is closed  

; 	 ALERT PATTERN 	
(defconstant $telPattern0 0)
(defconstant $telPattern1 1)
(defconstant $telPattern2 2)
(defconstant $telPattern3 3)
(defconstant $telPattern4 4)
(defconstant $telPattern5 5)
(defconstant $telPattern6 6)
(defconstant $telPattern7 7)
(defconstant $telPatternOff 8)
(defconstant $telPatternUndefined 15)

; 	 DN TYPES 	
(defconstant $telAllDNs 0)                      ;   counts all types of DNs  
(defconstant $telInternalDNs 1)                 ;   connected to PBX or other non-public switch  
(defconstant $telInternalDNsOnly 2)             ;   connected to PBX or other non-public switch  
;   and able to place internal calls only  
(defconstant $telExternalDNs 3)                 ;   connected to public network  
(defconstant $telDNTypeUnknown 4)               ;   DN type unknown  

; 	 DN USAGE 	
(defconstant $telDNNotUsed 0)                   ;   DN is not used - onhook  
(defconstant $telDNPOTSCall 1)                  ;   DN used for POTs call  
(defconstant $telDNFaxCall 2)                   ;   DN used for fax call  
(defconstant $telDNDataCall 3)                  ;   DN used for data call  
(defconstant $telDNAlerting 4)                  ;   Incoming call at DN  
(defconstant $telDNUnknownState 5)              ;   DN is in unknown state  

; 	 CALL FORWARDING TYPES 	
(defconstant $telForwardImmediate 1)            ;   immediately forward calls  
(defconstant $telForwardBusy 2)                 ;   forward on Busy  
(defconstant $telForwardNoAnswer 3)             ;   forward on No answer  
(defconstant $telForwardBusyNA 4)               ;   forwarding for busy and no answer 
(defconstant $telForwardTypeUnknown 5)          ;   type of forwarding is unknown  

; 	 CALL FORWARDING MESSAGES 	
(defconstant $telForwardCleared 0)              ;   forwarding has been cleared  
(defconstant $telForwardEst 1)                  ;   forwarding has been established 
(defconstant $telForwardFailed 2)               ;   attempt to setup forwarding has failed 

; 	 DO NOT DISTURB TYPES 	
(defconstant $telDNDIntExt 0)                   ;   do not disturb for all internal and external calls 
(defconstant $telDNDExternal 1)                 ;   do not disturb for external calls only  
(defconstant $telDNDInternal 2)                 ;   do not disturb for internal calls only  
(defconstant $telDNDNonIntercom 3)              ;   do not disturb for all calls except intercom  

; 	 DO NOT DISTURB MESSAGES 	
(defconstant $telDNDCleared 0)                  ;   do not disturb has been cleared  
(defconstant $telDNDEst 1)                      ;   do not disturb has been established  
(defconstant $telDNDFailed 2)                   ;   attempt to setup do not disturb has failed  

; 	 VOICE MAIL MESSAGES 	
(defconstant $telAllVoiceMessagesRead 0)        ;   all messages have been read, none are  waiting  
;   to be read  
(defconstant $telNewVoiceMessage 1)             ;   a new message has arrived or messages are waiting for this DN  

; 	 DNSELECT MESSAGE 	
(defconstant $telDNDeselected 0)                ;   DN has been deselected  
(defconstant $telDNSelected 1)                  ;   DN has been selected  

; 	 CALL ORIGINATORS 	
(defconstant $telInternalCall 0)                ;   return nth internal CA  
(defconstant $telExternalCall 1)                ;   return nth external CA  
(defconstant $telUnknownCallOrigin 2)           ;   unknown call type  
(defconstant $telAllCallOrigins 2)              ;   return nth CA internal or external  

; 	 CALL TYPES 	
(defconstant $telVoiceMailAccessOut -7)
(defconstant $telPageOut -6)
(defconstant $telIntercomOut -5)
(defconstant $telCallbackOut -4)
(defconstant $telPickup -3)
(defconstant $telParkRetrieve -2)
(defconstant $telNormalOut -1)
(defconstant $telUnknownCallType 0)
(defconstant $telNormalIn 1)
(defconstant $telForwardedImmediate 2)
(defconstant $telForwardedBusy 3)
(defconstant $telForwardedNoAnswer 4)
(defconstant $telTransfer 5)
(defconstant $telDeflected 6)
(defconstant $telIntercepted 7)
(defconstant $telDeflectRecall 8)
(defconstant $telParkRecall 9)
(defconstant $telTransferredRecall 10)
(defconstant $telIntercomIn 11)
(defconstant $telCallbackIn 12)

; 	 DIAL TYPES 	
(defconstant $telDNDialable 0)                  ;   this DN could be dialed via TELSetupCall  
(defconstant $telDNNorthAmerican 1)             ;   rmtDN is standard North America 10 digit number  
(defconstant $telDNInternational 2)             ;   rmtDN is an international number  
(defconstant $telDNAlmostDialable 3)            ;   rmtDN is almost dialable, missing prefix such as 9 or 1  
(defconstant $telDNUnknown 15)                  ;   unknown whether DN is dialable  

; 	 CALL PROGRESS MESSAGES 	
(defconstant $telCAPDialTone 1)                 ;   dial tone  
(defconstant $telCAPRinging 2)                  ;   destination CA is alerting  
(defconstant $telCAPDialing 3)                  ;   dialing the other end  
(defconstant $telCAPReorder 4)                  ;   reorder  
(defconstant $telCAPBusy 5)                     ;   busy  
(defconstant $telCAPRouted 6)                   ;   call routed; rmtDN will hold the routing directory number routeDN and routePartyName have been updated  
(defconstant $telCAPRoutedOff 7)                ;   call routed off-network; no further progress will be available  
(defconstant $telCAPTimeout 8)                  ;   call timed out  
(defconstant $telCAPUpdate 9)                   ;   name and rmtDN information has been updated  
(defconstant $telCAPPrompt 10)                  ;   the network is prompting for more information  
(defconstant $telCAPWaiting 11)                 ;   call is proceeding, but there is no response yet from the destination  
(defconstant $telCAPCPC 12)                     ;   telephone tool detected CPC signal  
(defconstant $telCAPNoDialTone 13)              ;   dial tone not detected  
(defconstant $telCAPUnknown 15)                 ;   call progress state unknown  
(defconstant $telCAPDialDisabled 16)            ;   Blacklisting: Dial Disabled  
(defconstant $telCAPBlacklistedNumber 17)       ;   Blacklisting: Blacklisted Number  
(defconstant $telCAPForbiddenNumber 18)         ;   Blacklisting: Forbidden Number  
(defconstant $telCAPModemGuardTime 19)          ;   Modem Guard Timein force, unable to dial  
(defconstant $telCAPLCDetected 20)              ;   trying to dial a number while the handset is offhook  
(defconstant $telCAPLostLC 21)                  ;   trying manual dial or answer while handset not off hook or also lost line current during dialing.  

; 	 OUTGOING CALL MESSAGES 	
(defconstant $telPhysical 0)                    ;   user lifted handset and initiated call  
(defconstant $telProgrammatic 1)                ;   programmatic initiation of outgoing call  

; 	 DISCONNECT MESSAGES 	
(defconstant $telLocalDisconnect 0)             ;   local party, this user, responsible for disconnect  
(defconstant $telRemoteDisconnect 1)            ;   remote party responsible for disconnect  

; 	 DISCONNECT TYPES 	
(defconstant $telCADNormal 1)                   ;   normal disconnect  
(defconstant $telCADBusy 2)                     ;   remote user busy  
(defconstant $telCADNoResponse 3)               ;   remote not responding  
(defconstant $telCADRejected 4)                 ;   call rejected  
(defconstant $telCADNumberChanged 5)            ;   number changed  
(defconstant $telCADInvalidDest 6)              ;   invalid destination address  
(defconstant $telCADFacilityRejected 7)         ;   requested facility rejected  
(defconstant $telCADUnobtainableDest 9)         ;   destination not obtainable  
(defconstant $telCADCongested 10)               ;   network congestion  
(defconstant $telCADIncompatibleDest 11)        ;   incompatible destination  
(defconstant $telCADTimeout 12)                 ;   call timed out  
(defconstant $telCADUnknown 15)                 ;   reason unknown  

; 	 CONFERENCE MESSAGES 	
(defconstant $telConferencePrepFailed 0)        ;   conference could not be prepared  
(defconstant $telConferencePending 1)           ;   conference prepared successfully  
(defconstant $telConferenceEstFailed 2)         ;   conference could not be established  
(defconstant $telConferenceEst 3)               ;   conference established  

; 	 TRANSFER MESSAGES 	
(defconstant $telTransferPrepFailed 0)          ;   transfer could not be prepared  
(defconstant $telTransferPending 1)             ;   transfer prepared successfully  
(defconstant $telTransferEst 2)                 ;   consult or blind xfer successful  
(defconstant $telTransferFailed 3)              ;   consult or blind xfer failed  
(defconstant $telTransferred 4)                 ;   message to originator of CA specifying that call was transferred to rmtDN  

; 	 HOLD MESSAGES 	
(defconstant $telHoldCleared 0)
(defconstant $telHoldEst 1)
(defconstant $telHoldFailed 2)

; 	 RECEIVE DIGIT MESSAGES 	
(defconstant $telDigitAudible 0)
(defconstant $telDigitNotAudible 1)

; 	 CALL PARK MESSAGES 	
(defconstant $telCallParkEst 1)                 ;   call has been successfully parked  
(defconstant $telCallParkRetrieveEst 2)         ;   parked Call has been successfully retrieved  
(defconstant $telCallParkFailed 3)              ;   attempt to setup call park has failed  
(defconstant $telCallParkRetrieveFailed 4)      ;   attempt to retrieve parked call failed  
(defconstant $telCallParkRecall 5)              ;   call park has been recalled  

; 	 CALL BACK MESSAGES 	
(defconstant $telCallbackCleared 0)             ;   call back has been cleared  
(defconstant $telCallbackEst 1)                 ;   call back has been established  
(defconstant $telCallbackNowAvail 2)            ;   call can be called back with TELCallBackNow if CA is zero, else call IS calling back on CA  
(defconstant $telCallbackFailed 3)              ;   attempt to setup callback has failed  
(defconstant $telCallbackDesired 4)             ;   a user has called this terminal, received no answer and desires this terminal to call it back  
(defconstant $telCallbackDesiredCleared 5)      ;   call back for no answer no longer desired  
(defconstant $telCalledback 6)                  ;   callback has occurred successfully  

; 	 CALL REJECT MESSAGES 	
(defconstant $telCallRejectFailed 0)            ;   attempt to reject call has failed  
(defconstant $telCallRejectEst 1)               ;   call successfully rejected  
(defconstant $telCallRejected 2)                ;   message to originator that call was rejected  

; 	 CALL DEFLECT MESSAGES 	
(defconstant $telCallDeflectFailed 0)           ;   attempt to deflect call has failed  
(defconstant $telCallDeflectEst 1)              ;   call successfully deflected  
(defconstant $telCallDeflectRecall 2)           ;   deflected call has been recalled  
(defconstant $telCallDeflected 3)               ;   message to originator that call was deflected to rmtDN  
(defconstant $telAutoDeflectImmediate 4)        ;   a call was automatically deflected from this terminal as a result of immediate call forwarding  
(defconstant $telAutoDeflectBusy 5)             ;   a call was automatically deflected from this terminal as a result of call forwarding on busy  
(defconstant $telAutoDeflectNoAnswer 6)         ;   a call was automatically deflected from this terminal as a result of call forwarding on no answer  

; 	 CONFERENCE SPLIT MESSAGES 	
(defconstant $telConferenceSplitFailed 0)       ;   CA could not be split  
(defconstant $telConferenceSplitEst 1)          ;   CA split successfully  

; 	 CONFERENCE DROP MESSAGES 	
(defconstant $telConferenceDropFailed 0)        ;   CA could not be dropped  
(defconstant $telConferenceDropped 1)           ;   CA dropped successfully  

; 	 CALL PICKUP MESSAGES 	
(defconstant $telCallPickupEst 0)               ;   call pickup was successful  
(defconstant $telCallPickupFailed 1)            ;   call pickup failed  
(defconstant $telCallPickedUp 2)                ;   message to originator that call was picked up at a different DN  

; 	 PAGING MESSAGES 	
(defconstant $telPageEst 0)                     ;   paging was successful  
(defconstant $telPageComplete 1)                ;   paging activity completed  
(defconstant $telPageFailed 2)                  ;   paging failed  

; 	 INTERCOM MESSAGES 	
(defconstant $telIntercomEst 0)                 ;   intercom was successful  
(defconstant $telIntercomComplete 1)            ;   intercom activity completed  
(defconstant $telIntercomFailed 2)              ;   intercom failed  

; 	 MODEM TONE MESSAGES 	
(defconstant $telModemToneDetected 0)           ;   modem tone was detected  
(defconstant $telModemToneCleared 1)            ;   modem tone went away  

; 	 FAX TONE MESSAGES 	
(defconstant $telFaxToneDetected 0)             ;   fax tone was detected  
(defconstant $telFaxToneCleared 1)              ;   fax tone went away  

; 	 IN USE MESSAGES 	
(defconstant $telInUsePrivate 0)                ;   MADN is in use and can't be accessed  
(defconstant $telInUseCanAccess 1)              ;   MADN is in use, and others can access it and join in  
(defconstant $telInUseCanMakePrivate 2)         ;   MADN is in use, but available for any one person to access  
(defconstant $telInUseCleared 3)                ;   MADN is no longer in use  

; 	 CALL APPEARANCE STATES 	
(defconstant $telCAIdleState 0)                 ;   a call doesn't exist at this time  
(defconstant $telCAInUseState 1)                ;   the call is active but at another terminal  
(defconstant $telCAOfferState 2)                ;   a call is being offered to the terminal  
(defconstant $telCAQueuedState 3)               ;   a call is being queued at this terminal  
(defconstant $telCAAlertingState 4)             ;   a call is alerting at the terminal  
(defconstant $telCADialToneState 5)             ;   initiated outgoing call has dialtone  
(defconstant $telCADialingState 6)              ;   initiated outgoing call is dialing  
(defconstant $telCAWaitingState 7)              ;   initiated outgoing call is waiting for response from destination  
(defconstant $telCARingingState 8)              ;   the outgoing call is ringing.  
(defconstant $telCABusyState 9)                 ;   destination is busy or can't be reached  
(defconstant $telCAHeldState 10)                ;   call has been put on hold by this terminal  
(defconstant $telCAConferencedState 11)         ;   this CA is part of a conference now  
(defconstant $telCAActiveState 12)              ;   the call is active and parties are free to exchange data 
(defconstant $telCAReorderState 13)             ;   CA is in a reorder state  
(defconstant $telCAConferencedHeldState 14)     ;   CA is a conference call in a held state  
(defconstant $telCAUnknownState 15)             ;   the call state is unknown  

; 	 TERMINAL MESSAGE EVENTMASKS 	
(defconstant $telTermHookMsg #x1)               ;   the hookswitch state has changed  
(defconstant $telTermKeyMsg #x2)                ;   a phone pad key has been depressed  
(defconstant $telTermVolMsg #x4)                ;   volume setting has changed  
(defconstant $telTermDisplayMsg #x8)            ;   display has changed  
(defconstant $telTermEnableMsg #x10)            ;   terminal has become enabled  
(defconstant $telTermOpenMsg #x20)              ;   terminal has been opened  
(defconstant $telTermCloseMsg #x40)             ;   terminal is shutting down  
(defconstant $telTermResetMsg #x80)             ;   terminal has been reset  
(defconstant $telTermErrorMsg #x100)            ;   hard equipment error  
(defconstant $telTermIndHSStateChgMsg #x200)    ;   change in handset state from inacive to active or vice versa  
(defconstant $telTermIndHSConnectMsg #x400)     ;   independent handset connection has been changed  
(defconstant $telTermKeyImmMsg #x800)           ;   immidiate arrival of phone pad key  
(defconstant $telTermVolStateMsg #x1000)        ;   volume state has changed  
(defconstant $telTermOtherMsg #x80000000)       ;   vendor defined error  
(defconstant $telAllTermMsgs #x1FFF)            ;   mask to all non tool specific terminal events  

; 	 DN MESSAGE EVENTMASK CONSTANTS 	
(defconstant $telDNForwardMsg #x1)              ;   forward feature activity  
(defconstant $telDNDNDMsg #x2)                  ;   do not disturb feature activity  
(defconstant $telDNVoiceMailMsg #x4)            ;   message has arrived for this DN  
(defconstant $telDNSelectedMsg #x8)             ;   DN has been selected or deselected  
(defconstant $telDNOtherMsg #x80000000)         ;   a custom message for use by tools  
(defconstant $telAllDNMsgs #xF)                 ;   mask to all non tool specific dn events  

; 	 CA MESSAGE EVENTMASK CONSTANTS 	
(defconstant $telCAAlertingMsg #x1)             ;   CA is alerting   
(defconstant $telCAOfferMsg #x2)                ;   CA is being offered a call  
(defconstant $telCAProgressMsg #x4)             ;   call progress info for this CA  
(defconstant $telCAOutgoingMsg #x8)             ;   CA is initiating an outgoing call  
(defconstant $telCADisconnectMsg #x10)          ;   CA disconnected (dropped or rmt disc  
(defconstant $telCAActiveMsg #x20)              ;   CA is active and voice/data is free to flow end to end  
(defconstant $telCAConferenceMsg #x40)          ;   conference activity on CA  
(defconstant $telCATransferMsg #x80)            ;   transfer feature activity  
(defconstant $telCAHoldMsg #x100)               ;   hold feature activity  
(defconstant $telCADigitsMsg #x200)             ;   remote signaling digits arrived  
(defconstant $telCACallParkMsg #x400)           ;   CA call park feature activity  
(defconstant $telCACallbackMsg #x800)           ;   CA call back feature activity   
(defconstant $telCARejectMsg #x1000)            ;   CA is rejected  
(defconstant $telCADeflectMsg #x2000)           ;   CA is deflected  
(defconstant $telCAForwardMsg #x4000)           ;   CA is forwarded to this DN   
(defconstant $telCAConferenceSplitMsg #x8000)   ;   conference split activity   
(defconstant $telCAConferenceDropMsg #x10000)   ;   conference drop activity   
(defconstant $telCAQueuedMsg #x20000)           ;   CA has been queued   
(defconstant $telCAInUseMsg #x40000)            ;   CA is in use   
(defconstant $telCACallPickupMsg #x80000)       ;   CA pickup activity  
(defconstant $telCAPagingMsg #x100000)          ;   CA paging activity  
(defconstant $telCAIntercomMsg #x200000)        ;   CA intercom activity  
(defconstant $telCAModemToneMsg #x400000)       ;   modem tones detected  
(defconstant $telCAFaxToneMsg #x800000)         ;   fax tones detected  
(defconstant $telCAIdleMsg #x1000000)           ;   CA is in idle state  
(defconstant $telCASuccessiveAlertMsg #x2000000);   phone is alerting, one per ring  
(defconstant $telCAUserUserInfoMsg #x4000000)   ;   user to user information has arrrived for this CA  
(defconstant $telCAHandOffMsg #x8000000)        ;   CA is ready for hand-off  
(defconstant $telCAVoiceDetectedMsg #x10000000) ;   voice Detect related event  
(defconstant $telCASilenceDetectedMsg #x20000000);   silence Detect related event  
(defconstant $telCADigitsImmMsg #x40000000)     ;   immidiate arrival of remote signaling digits  
(defconstant $telCAOtherMsg #x80000000)         ;   tool specific CA message  
(defconstant $telAllCAMsgs #x7FFFFFFF)          ;   mask to all non tool specific CA events  

(def-mactype :telerr (find-mactype ':signed-integer))
(def-mactype :telflags (find-mactype ':unsigned-long))

(defconstant $telNoMenus #x10000)               ;   tells tool not to display any custom menus  
(defconstant $telQuiet #x20000)                 ;   tells tool not to display any dialog boxes or alerts  
(defconstant $telConfigChanged #x40000)         ;   notifies application that the config has changed  

(def-mactype :telfeatureflags (find-mactype ':unsigned-long))

(defconstant $pcmAvail #x1)                     ;   true if PCM voice data accessible  
(defconstant $hasHandset #x2)                   ;   true if a phone handset is attached   
(defconstant $hasSpeakerphone #x4)              ;   true if a 2 way speakerphone is attached  
(defconstant $canOnHookDial #x8)                ;   can on-hook dial  
(defconstant $hasRinger #x10)                   ;   terminal has its own ringer  
(defconstant $canSetDisplay #x20)               ;   application can write to the display  
(defconstant $hasKeypad #x40)                   ;   attached phone has standard 12 key pad  
(defconstant $hasVideo #x80)                    ;   terminal has a videophone  
(defconstant $hasOther #x100)                   ;   reserved for future use  
(defconstant $crossDNConference #x200)          ;   can perform cross-DN conferences  
(defconstant $hasSubaddress #x400)              ;   attached network supports subaddressing  
(defconstant $hasUserUserInfo #x800)            ;   network supports user-to-user info  
(defconstant $hasHandsetSoundStreams #x1000)    ;   sound streams are supported on the handset  
(defconstant $hasIndHandset #x2000)             ;   handset can be accessed independently of the phone line  
(defconstant $hasBuiltinSpeakerphone #x4000)    ;   speaker and microphone of the Mac can be used  

(def-mactype :teltermrecordptr (find-mactype '(:pointer :teltermrecord)))
(defrecord TELTermRecord 
   (tRef :signed-integer)
   (featureFlags :unsigned-long)
   (handsetSpeakerVol :signed-integer)
   (handsetMicVol :signed-integer)
   (speakerphoneVol :signed-integer)
   (speakerphoneMicVol :signed-integer)
   (ringerVol :signed-integer)
   (otherVol :signed-integer)
   (ringerTypes :signed-integer)
   (hasDisplay :signed-integer)
   (displayRows :signed-integer)
   (numDNs :signed-integer)
   (maxAllocCA :signed-integer)
   (curAllocCA :signed-integer)
   (builtinSpeakerVol :signed-integer)
   (builtinSpeakerMicVol :signed-integer)
   (reserved :signed-long)
   )

(def-mactype :teltermptr (find-mactype '(:pointer :teltermrecord)))
(def-mactype :telrecordptr (find-mactype '(:pointer :telrecord)))
(defrecord TELRecord 
   (procID :signed-integer)
   (flags :unsigned-long)
   (reserved :signed-integer)
   (refCon :signed-long)
   (userData :signed-long)
   (defproc :pointer)
   (config :pointer)
   (oldConfig :pointer)
   (pTELTerm (:pointer :teltermrecord))
   (telPrivate :signed-long)
   (reserved1 :signed-long)
   (reserved2 :signed-long)
   (pTELTermSize :signed-long)
   (version :signed-integer)
   )

(def-mactype :telptr (find-mactype '(:pointer :telrecord)))
(def-mactype :telhandle (find-mactype '(:handle :telrecord)))

(def-mactype :teldnfeatureflags (find-mactype ':unsigned-long))

(defconstant $dndSub #x1)                       ;   do not disturb subscribed  
(defconstant $dndAvail #x2)                     ;   do not disturb available  
(defconstant $dndActive #x4)                    ;   do not disturb active  
(defconstant $voiceMailAccessSub #x8)           ;   message waiting subscribed  
(defconstant $voiceMailAccessAvail #x10)        ;   message waiting available  
(defconstant $voiceMailAccessActive #x20)       ;   message waiting active  
(defconstant $pagingSub #x40)                   ;   paging is subscribed  
(defconstant $pagingAvail #x80)                 ;   paging is available  
(defconstant $pagingActive #x100)               ;   paging is active  
(defconstant $intercomSub #x200)                ;   intercom is subscribed  
(defconstant $intercomAvail #x400)              ;   intercom is available  
(defconstant $intercomActive #x800)             ;   intercom is active  
(defconstant $dnSelectSub #x1000)               ;   DN select is subscribed  
(defconstant $dnSelectAvail #x2000)             ;   DN select is available  
(defconstant $dnSelectActive #x4000)            ;   DN is selected  
(defconstant $callPickupSub #x8000)             ;   call pickup is subscribed  
(defconstant $callPickupAvail #x10000)          ;   call pickup is available  
(defconstant $dnInUse #x20000)                  ;   a CA is allocated for this DN  
(defconstant $logicalDN #x40000)                ;   this DN is not on this terminal  
(defconstant $dnAccessible #x80000)             ;   commands can be sent to this DN  
(defconstant $canInitiate #x100000)             ;   an outgoing CA can be initiated  
(defconstant $voiceMessageWaiting #x200000)     ;   voice mail waiting for this dn  
(defconstant $hasDNSoundStreams #x400000)       ;   sound streams are supported on this DN  
(defconstant $autoAnswerAvail #x800000)         ;   AutoAnswer is set for this DN  
(defconstant $autoAnswerActive #x1000000)       ;   AutoAnswer is currently applied to CA on this DN  
(defconstant $tollSaverAvail #x2000000)         ;   tollSaver is set for this DN  
(defconstant $tollSaverActive #x4000000)        ;   tollSaver is currently applied to CA on this DN  

(def-mactype :teldnforwardflags (find-mactype ':unsigned-long))

(defconstant $immediateForwardSub #x1)          ;   immediate call forward subscribed  
(defconstant $immediateForwardAvail #x2)        ;   immediate call forward available  
(defconstant $immediateForwardActive #x4)       ;   immediate call forward active  
(defconstant $busyForwardSub #x8)               ;   forward on busy subscribed  
(defconstant $busyForwardAvail #x10)            ;   forward on busy available  
(defconstant $busyForwardActive #x20)           ;   forward on busy active  
(defconstant $noAnswerForwardSub #x40)          ;   no answer call forward subscribed  
(defconstant $noAnswerForwardAvail #x80)        ;   no answer call forward available  
(defconstant $noAnswerForwardActive #x100)      ;   no answer call forward active  
(defconstant $busyNAForwardSub #x200)           ;   busy & no answer call forward subscribed  
(defconstant $busyNAForwardAvail #x400)         ;   busy & no answer call forward available  
(defconstant $busyNAForwardActive #x800)        ;   busy & no answer call forward active  

(def-mactype :teldnrecordptr (find-mactype '(:pointer :teldnrecord)))
(defrecord TELDNRecord 
   (dnRef :signed-integer)
   (dn (:pointer (:string 255)))
   (dnPartyName (:pointer (:string 255)))
   (dnSubaddress (:pointer (:string 255)))
   (hTEL (:handle :telrecord))
   (maxAllocCA :signed-integer)
   (curAllocCA :signed-integer)
   (dnType :signed-integer)
   (featureFlags :unsigned-long)
   (numPageIDs :signed-integer)
   (numIntercomIDs :signed-integer)
   (numPickupIDs :signed-integer)
   (forwardFlags :unsigned-long)
   (iForwardDN (:pointer (:string 255)))
   (iForwardSubaddress (:pointer (:string 255)))
   (iForwardPartyName (:pointer (:string 255)))
   (bForwardDN (:pointer (:string 255)))
   (bForwardSubaddress (:pointer (:string 255)))
   (bForwardPartyName (:pointer (:string 255)))
   (naForwardDN (:pointer (:string 255)))
   (naForwardSubaddress (:pointer (:string 255)))
   (naForwardPartyName (:pointer (:string 255)))
   (naForwardRings :signed-integer)
   (telDNPrivate :signed-long)
   (refCon :signed-long)
   (userData :signed-long)
   (reserved :signed-long)
   )

(def-mactype :teldnptr (find-mactype '(:pointer :teldnrecord)))
(def-mactype :teldnhandle (find-mactype '(:handle :teldnrecord)))
(def-mactype :telcafeatureflags (find-mactype ':unsigned-long))

(defconstant $holdSub #x1)                      ;   hold subscribed   
(defconstant $holdAvail #x2)                    ;   hold available   
(defconstant $holdActive #x4)                   ;   hold active   
(defconstant $conferenceSub #x8)                ;   conference subscribed  
(defconstant $conferenceAvail #x10)             ;   conference available  
(defconstant $conferenceActive #x20)            ;   conference active   
(defconstant $conferenceDropSub #x40)           ;   conference drop subscribed   
(defconstant $conferenceDropAvail #x80)         ;   a call to TELDrop will drop this CA only from a conference  
(defconstant $conferenceSplitSub #x100)         ;   conference split subscribed   
(defconstant $conferenceSplitAvail #x200)       ;   conference split available for this CA  
(defconstant $numToConferenceRequired #x400)    ;   the number of CAs to be conferenced is required in TELConfPrep  
(defconstant $transferSub #x800)                ;   transfer subscribed   
(defconstant $transferAvail #x1000)             ;   transfer available   
(defconstant $transferActive #x2000)            ;   transfer active  
(defconstant $caRelated #x4000)                 ;   this CA is the specified in some other CA's relatedCA field 

(def-mactype :telcaotherfeatures (find-mactype ':unsigned-long))

(defconstant $callbackSub #x1)                  ;   call back subscribed  
(defconstant $callbackAvail #x2)                ;   call back available  
(defconstant $callbackActive #x4)               ;   call back active   
(defconstant $callbackClearSub #x8)             ;   call back clearing subscribed  
(defconstant $callbackNowSub #x10)              ;   call back now subscribed  
(defconstant $callbackNowAvail #x20)            ;   call back now available   
(defconstant $callbackBusy #x40)                ;   call back on busy  
(defconstant $callbackNoAnswer #x80)            ;   call back on no answer  
(defconstant $callbackReturnsRef #x100)         ;   call back returns a reference  
(defconstant $parkSub #x200)                    ;   call park subscribed  
(defconstant $parkAvail #x400)                  ;   call park available  
(defconstant $parkActive #x800)                 ;   call park active  
(defconstant $parkRetrieveSub #x1000)           ;   call park retrieve subscribed  
(defconstant $parkRetrieveWithID #x2000)        ;   retrieve parked calls with IDs  
(defconstant $parkWithReturnedID #x4000)        ;   park call to a specific remote ID  
(defconstant $parkWithGivenID #x40000)          ;   for switch that requires ID for parking  
(defconstant $rejectable #x8000)                ;   CA is rejectable   
(defconstant $deflectable #x10000)              ;   CA is deflectable   
(defconstant $acceptable #x20000)               ;   CA is acceptable  
(defconstant $voiceDetected #x80000)            ;   voice has been detected on this CA incase of an incoming call 
(defconstant $callAnswdTSRings #x100000)        ;   incoimng call was answered on TollSaver rings  

(def-mactype :telcarecordptr (find-mactype '(:pointer :telcarecord)))
(def-mactype :telcaptr (find-mactype '(:pointer :telcarecord)))
(def-mactype :telcahandle (find-mactype '(:handle :telcarecord)))
(defrecord TELCARecord 
   (caRef :signed-integer)
   (hTELDN (:handle :teldnrecord))
   (hTEL (:handle :telrecord))
   (caState :signed-integer)
   (relatedCA (:handle :telcarecord))
   (connectTime :signed-long)                   ;   can be used by application to keep track of connect time  
   (intExt :signed-integer)
   (callType :signed-integer)
   (dialType :signed-integer)
   (bearerType :signed-integer)
   (rate :signed-integer)
   (rmtDN (:pointer (:string 255)))
   (rmtPartyName (:pointer (:string 255)))
   (rmtSubaddress (:pointer (:string 255)))
   (routeDN (:pointer (:string 255)))
   (routePartyName (:pointer (:string 255)))
   (routeSubaddress (:pointer (:string 255)))
   (priority :signed-integer)
   (conferenceLimit :signed-integer)
   (featureFlags :unsigned-long)
   (otherFeatures :unsigned-long)
   (telCAPrivate :signed-long)
   (refCon :signed-long)
   (userData :signed-long)
   (reserved :signed-long)
   )

; 	 Constants for HandleType in structure above 	

(defconstant $telHandleType 0)                  ;   feature requires a terminal handle  
(defconstant $telDNHandleType 1)                ;   feature requires a DN handle  
(defconstant $telCAHandleType 2)                ;   feature requires a CA handle  

(def-mactype :featurelistptr (find-mactype '(:pointer :featurelist)))
(defrecord FeatureList 
   (featureID :signed-integer)
   (featureName (:pointer (:string 255)))
   (handleType :signed-integer)
   (nextFeature (:pointer :featurelist))
   )

; 	 CA MESSAGE STRUCTURES FOR MSGINFO 	
(def-mactype :cagenericmsgrecptr (find-mactype '(:pointer :cagenericmsgrec)))
(defrecord CAGenericMsgRec 
   (rmtDN (:pointer (:string 255)))
   (rmtName (:pointer (:string 255)))
   (rmtSubaddress (:pointer (:string 255)))
   (dialType :signed-integer)
   )

(def-mactype :causeruserinfomsgrecptr (find-mactype '(:pointer :causeruserinfomsgrec)))
(defrecord CAUserUserInfoMsgRec 
   (userUserInfo (:pointer (:string 255)))
   )

(def-mactype :caconfmsgrecptr (find-mactype '(:pointer :caconfmsgrec)))
(defrecord CAConfMsgRec 
   (relatedCA (:handle :telcarecord))
   )

(def-mactype :catransfmsgrecptr (find-mactype '(:pointer :catransfmsgrec)))
(defrecord CATransfMsgRec 
   (rmtDN (:pointer (:string 255)))
   (rmtName (:pointer (:string 255)))
   (rmtSubaddress (:pointer (:string 255)))
   (dialType :signed-integer)
   (prepCA (:handle :telcarecord))
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TelephoneTermMsgProcPtr = PROCEDURE(hTEL: TELHandle; msg: LONGINT; mtype: INTEGER; value: INTEGER; globals: LONGINT);

|#
 |#                                             ; $ELSEC
(def-mactype :telephonetermmsgprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TelephoneDNMsgProcPtr = PROCEDURE(hTELDN: TELDNHandle; Msg: LONGINT; mtype: INTEGER; value: INTEGER; rmtDN: Str255; rmtName: Str255; rmtSubaddress: Str255; globals: LONGINT);

|#
 |#                                             ; $ELSEC
(def-mactype :telephonednmsgprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TelephoneCAMsgProcPtr = PROCEDURE(hTELCA: TELCAHandle; Msg: LONGINT; mtype: INTEGER; value: INTEGER; Msginfo: Ptr; globals: LONGINT);

|#
 |#                                             ; $ELSEC
(def-mactype :telephonecamsgprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TelephoneChooseIdleProcPtr = PROCEDURE;

|#
 |#                                             ; $ELSEC
(def-mactype :telephonechooseidleprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :telephonetermmsgupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :telephonetermmsgupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :telephonednmsgupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :telephonednmsgupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :telephonecamsgupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :telephonecamsgupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :telephonechooseidleupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :telephonechooseidleupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppTelephoneTermMsgProcInfo #xEBC0)
(defconstant $uppTelephoneDNMsgProcInfo #x3FEBC0)
(defconstant $uppTelephoneCAMsgProcInfo #x3EBC0)
(defconstant $uppTelephoneChooseIdleProcInfo #x0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewTelephoneTermMsgUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewTelephoneTermMsgProc 
(deftrap "_NewTelephoneTermMsgUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewTelephoneDNMsgUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewTelephoneDNMsgProc 
(deftrap "_NewTelephoneDNMsgUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewTelephoneCAMsgUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewTelephoneCAMsgProc 
(deftrap "_NewTelephoneCAMsgUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewTelephoneChooseIdleUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewTelephoneChooseIdleProc 
(deftrap "_NewTelephoneChooseIdleUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeTelephoneTermMsgUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeTelephoneTermMsgUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeTelephoneDNMsgUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeTelephoneDNMsgUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeTelephoneCAMsgUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeTelephoneCAMsgUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeTelephoneChooseIdleUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeTelephoneChooseIdleUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeTelephoneTermMsgUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallTelephoneTermMsgProc 
(deftrap-inline "_InvokeTelephoneTermMsgUPP" 
      ((hTEL (:handle :telrecord)) (msg :signed-long) (mtype :signed-integer) (value :signed-integer) (globals :signed-long) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeTelephoneDNMsgUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallTelephoneDNMsgProc 
(deftrap-inline "_InvokeTelephoneDNMsgUPP" 
      ((hTELDN (:handle :teldnrecord)) (Msg :signed-long) (mtype :signed-integer) (value :signed-integer) (rmtDN (:string 255)) (rmtName (:string 255)) (rmtSubaddress (:string 255)) (globals :signed-long) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeTelephoneCAMsgUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallTelephoneCAMsgProc 
(deftrap-inline "_InvokeTelephoneCAMsgUPP" 
      ((hTELCA (:handle :telcarecord)) (Msg :signed-long) (mtype :signed-integer) (value :signed-integer) (Msginfo :pointer) (globals :signed-long) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeTelephoneChooseIdleUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallTelephoneChooseIdleProc 
(deftrap "_InvokeTelephoneChooseIdleUPP" 
      ((userRoutine :pointer))
   nil
   (:register-trap #x4E90 :a0 userRoutine))

; $ENDC                                         ; CALL_NOT_IN_CARBON
; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  InitTEL()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  TELGetInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InitTEL" 
      () 
  :telerr
   () )                                         ; 
;  *  TELOpenTerm()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELGetInfo" 
      ((hTEL (:handle :telrecord))) 
  :telerr
   () )                                         ; 
;  *  TELResetTerm()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELOpenTerm" 
      ((hTEL (:handle :telrecord))) 
  :telerr
   () )                                         ; 
;  *  TELCloseTerm()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELResetTerm" 
      ((hTEL (:handle :telrecord))) 
  :telerr
   () )                                         ; 
;  *  TELTermMsgHand()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELCloseTerm" 
      ((hTEL (:handle :telrecord))) 
  :telerr
   () )                                         ; 
;  *  TELClrTermMsgHand()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELTermMsgHand" 
      ((hTEL (:handle :telrecord)) (eventMask :signed-long) (msgProc :pointer) (globals :signed-long)) 
  :telerr
   () )                                         ; 
;  *  TELTermEventsSupp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELClrTermMsgHand" 
      ((hTEL (:handle :telrecord)) (msgProc :pointer)) 
  :telerr
   () )                                         ; 
;  *  TELGetProcID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELTermEventsSupp" 
      ((hTEL (:handle :telrecord)) (eventMask (:pointer :signed-long))) 
  :telerr
   () )                                         ; 
;  *  TELNew()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELGetProcID" 
      ((name (:pointer (:string 255)))) 
  :signed-integer
   () )                                         ; 
;  *  TELNewWithResult()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELNew" 
      ((procID :signed-integer) (flags :unsigned-long) (refCon :signed-long) (userData :signed-long)) 
  (:handle :telrecord)
   () )                                         ; 
;  *  TELDefault()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELNewWithResult" 
      ((procID :signed-integer) (flags :unsigned-long) (refCon :signed-long) (userData :signed-long) (error (:pointer :signed-integer))) 
  (:handle :telrecord)
   () )                                         ; 
;  *  TELValidate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELDefault" 
      ((theConfig (:pointer :pointer)) (procID :signed-integer) (allocate :boolean)) 
  :telerr
   () )                                         ; 
;  *  TELGetConfig()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELValidate" 
      ((hTEL (:handle :telrecord))) 
  :boolean
   () )                                         ; 
;  *  TELSetConfig()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELGetConfig" 
      ((hTEL (:handle :telrecord))) 
  :pointer
   () )                                         ; 
;  *  TELChoose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELSetConfig" 
      ((hTEL (:handle :telrecord)) (thePtr :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  TELSetupPreflight()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELChoose" 
      ((hTEL (:pointer (:handle :telrecord))) (where :point) (idleProc :pointer)) 
  :telerr
   () )                                         ; 
;  *  TELSetupSetup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELSetupPreflight" 
      ((procID :signed-integer) (magicCookie (:pointer :signed-long))) 
  :handle
   () )                                         ; 
;  *  TELSetupFilter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELSetupSetup" 
      ((procID :signed-integer) (theConfig :pointer) (count :signed-integer) (theDialog (:pointer :grafport)) (magicCookie (:pointer :signed-long))) 
  nil
   () )                                         ; 
;  *  TELSetupItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELSetupFilter" 
      ((procID :signed-integer) (theConfig :pointer) (count :signed-integer) (theDialog (:pointer :grafport)) (theEvent (:pointer :eventrecord)) (theItem (:pointer :signed-integer)) (magicCookie (:pointer :signed-long))) 
  :boolean
   () )                                         ; 
;  *  TELSetupCleanup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELSetupItem" 
      ((procID :signed-integer) (theConfig :pointer) (count :signed-integer) (theDialog (:pointer :grafport)) (theItem (:pointer :signed-integer)) (magicCookie (:pointer :signed-long))) 
  nil
   () )                                         ; 
;  *  TELSetupXCleanup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELSetupCleanup" 
      ((procID :signed-integer) (theConfig :pointer) (count :signed-integer) (theDialog (:pointer :grafport)) (magicCookie (:pointer :signed-long))) 
  nil
   () )                                         ; 
;  *  TELSetupPostflight()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELSetupXCleanup" 
      ((procID :signed-integer) (theConfig :pointer) (count :signed-integer) (theDialog (:pointer :grafport)) (OKed :boolean) (magicCookie (:pointer :signed-long))) 
  nil
   () )                                         ; 
;  *  TELDispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELSetupPostflight" 
      ((procID :signed-integer)) 
  nil
   () )                                         ; 
;  *  TELCountDNs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELDispose" 
      ((hTEL (:handle :telrecord))) 
  :telerr
   () )                                         ; 
;  *  TELDNLookupByIndex()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELCountDNs" 
      ((hTEL (:handle :telrecord)) (dnType :signed-integer) (physical :boolean)) 
  :signed-integer
   () )                                         ; 
;  *  TELDNLookupByName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELDNLookupByIndex" 
      ((hTEL (:handle :telrecord)) (dnType :signed-integer) (physical :boolean) (index :signed-integer) (hTELDN (:pointer (:handle :teldnrecord)))) 
  :telerr
   () )                                         ; 
;  *  TELDNSelect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELDNLookupByName" 
      ((hTEL (:handle :telrecord)) (DN (:string 255)) (hTELDN (:pointer (:handle :teldnrecord)))) 
  :telerr
   () )                                         ; 
;  *  TELDNDispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELDNSelect" 
      ((hTELDN (:handle :teldnrecord)) (select :boolean)) 
  :telerr
   () )                                         ; 
;  *  TELGetDNInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELDNDispose" 
      ((hTELDN (:handle :teldnrecord))) 
  :telerr
   () )                                         ; 
;  *  TELGetDNFlags()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELGetDNInfo" 
      ((hTELDN (:handle :teldnrecord))) 
  :telerr
   () )                                         ; 
;  *  TELDNMsgHand()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELGetDNFlags" 
      ((hTELDN (:handle :teldnrecord)) (dnFeatureFlags (:pointer :signed-long)) (dnForwardFlags (:pointer :signed-long))) 
  :telerr
   () )                                         ; 
;  *  TELClrDNMsgHand()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELDNMsgHand" 
      ((hTELDN (:handle :teldnrecord)) (allDNs :boolean) (eventMask :signed-long) (msgProc :pointer) (globals :signed-long)) 
  :telerr
   () )                                         ; 
;  *  TELDNEventsSupp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELClrDNMsgHand" 
      ((hTELDN (:handle :teldnrecord)) (msgProc :pointer)) 
  :telerr
   () )                                         ; 
;  *  TELCountCAs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELDNEventsSupp" 
      ((hTELDN (:handle :teldnrecord)) (eventMask (:pointer :signed-long))) 
  :telerr
   () )                                         ; 
;  *  TELCALookup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELCountCAs" 
      ((hTELDN (:handle :teldnrecord)) (internalExternal :signed-integer)) 
  :signed-integer
   () )                                         ; 
;  *  TELCADispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELCALookup" 
      ((hTELDN (:handle :teldnrecord)) (internalExternal :signed-integer) (index :signed-integer) (hTELCA (:pointer (:handle :telcarecord)))) 
  :telerr
   () )                                         ; 
;  *  TELGetCAState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELCADispose" 
      ((hTELCA (:handle :telcarecord))) 
  :telerr
   () )                                         ; 
;  *  TELGetCAFlags()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELGetCAState" 
      ((hTELCA (:handle :telcarecord)) (state (:pointer :signed-integer))) 
  :telerr
   () )                                         ; 
;  *  TELGetCAInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELGetCAFlags" 
      ((hTELCA (:handle :telcarecord)) (caFeatureFlags (:pointer :signed-long)) (caOtherFeatures (:pointer :signed-long))) 
  :telerr
   () )                                         ; 
;  *  TELCAMsgHand()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELGetCAInfo" 
      ((hTELCA (:handle :telcarecord))) 
  :telerr
   () )                                         ; 
;  *  TELClrCAMsgHand()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELCAMsgHand" 
      ((hTELDN (:handle :teldnrecord)) (eventMask :signed-long) (msgProc :pointer) (globals :signed-long)) 
  :telerr
   () )                                         ; 
;  *  TELCAEventsSupp()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELClrCAMsgHand" 
      ((hTELDN (:handle :teldnrecord)) (msgProc :pointer)) 
  :telerr
   () )                                         ; 
;  *  TELSetupCall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELCAEventsSupp" 
      ((hTELDN (:handle :teldnrecord)) (eventMask (:pointer :signed-long))) 
  :telerr
   () )                                         ; 
;  *  TELConnect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELSetupCall" 
      ((hTELDN (:handle :teldnrecord)) (hTELCA (:pointer (:handle :telcarecord))) (destDN (:string 255)) (destName (:string 255)) (destSubaddress (:string 255)) (userUserInfo (:string 255)) (bearerType :signed-integer) (rate :signed-integer)) 
  :telerr
   () )                                         ; 
;  *  TELDialDigits()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELConnect" 
      ((hTELCA (:handle :telcarecord))) 
  :telerr
   () )                                         ; 
;  *  TELAcceptCall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELDialDigits" 
      ((hTELCA (:handle :telcarecord)) (digits (:string 255))) 
  :telerr
   () )                                         ; 
;  *  TELRejectCall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELAcceptCall" 
      ((hTELCA (:handle :telcarecord))) 
  :telerr
   () )                                         ; 
;  *  TELDeflectCall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELRejectCall" 
      ((hTELCA (:handle :telcarecord)) (reason :signed-integer)) 
  :telerr
   () )                                         ; 
;  *  TELAnswerCall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELDeflectCall" 
      ((hTELCA (:handle :telcarecord)) (rmtDN (:string 255)) (rmtName (:string 255)) (rmtSubaddress (:string 255))) 
  :telerr
   () )                                         ; 
;  *  TELDrop()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELAnswerCall" 
      ((hTELCA (:handle :telcarecord))) 
  :telerr
   () )                                         ; 
;  *  TELHold()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELDrop" 
      ((hTELCA (:handle :telcarecord)) (userUserInfo (:string 255))) 
  :telerr
   () )                                         ; 
;  *  TELRetrieve()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELHold" 
      ((hTELCA (:handle :telcarecord))) 
  :telerr
   () )                                         ; 
;  *  TELConferencePrep()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELRetrieve" 
      ((hTELCA (:handle :telcarecord))) 
  :telerr
   () )                                         ; 
;  *  TELConferenceEstablish()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELConferencePrep" 
      ((hTELCA1 (:handle :telcarecord)) (hTELCA2 (:handle :telcarecord)) (numToConference :signed-integer)) 
  :telerr
   () )                                         ; 
;  *  TELConferenceSplit()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELConferenceEstablish" 
      ((hTELCA1 (:handle :telcarecord)) (hTELCA2 (:handle :telcarecord))) 
  :telerr
   () )                                         ; 
;  *  TELTransferPrep()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELConferenceSplit" 
      ((hTELCA (:handle :telcarecord))) 
  :telerr
   () )                                         ; 
;  *  TELTransferEstablish()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELTransferPrep" 
      ((hTELCA1 (:handle :telcarecord)) (hTELCA2 (:handle :telcarecord))) 
  :telerr
   () )                                         ; 
;  *  TELTransferBlind()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELTransferEstablish" 
      ((hTELCA1 (:handle :telcarecord)) (hTELCA2 (:handle :telcarecord))) 
  :telerr
   () )                                         ; 
;  *  TELForwardSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELTransferBlind" 
      ((hTELCA (:handle :telcarecord)) (rmtDN (:string 255)) (rmtName (:string 255)) (rmtSubaddress (:string 255))) 
  :telerr
   () )                                         ; 
;  *  TELForwardClear()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELForwardSet" 
      ((hTELDN (:handle :teldnrecord)) (forwardDN (:string 255)) (forwardName (:string 255)) (forwardSubaddress (:string 255)) (forwardType :signed-integer) (numrings :signed-integer)) 
  :telerr
   () )                                         ; 
;  *  TELCallbackSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELForwardClear" 
      ((hTELDN (:handle :teldnrecord)) (forwardType :signed-integer)) 
  :telerr
   () )                                         ; 
;  *  TELCallbackClear()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELCallbackSet" 
      ((hTELCA (:handle :telcarecord)) (callbackRef (:pointer :signed-integer))) 
  :telerr
   () )                                         ; 
;  *  TELCallbackNow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELCallbackClear" 
      ((hTEL (:handle :telrecord)) (callbackRef :signed-integer)) 
  :telerr
   () )                                         ; 
;  *  TELDNDSet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELCallbackNow" 
      ((hTELCA (:handle :telcarecord)) (callbackRef :signed-integer)) 
  :telerr
   () )                                         ; 
;  *  TELDNDClear()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELDNDSet" 
      ((hTELDN (:handle :teldnrecord)) (dndType :signed-integer)) 
  :telerr
   () )                                         ; 
;  *  TELCallPickup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELDNDClear" 
      ((hTELDN (:handle :teldnrecord)) (dndType :signed-integer)) 
  :telerr
   () )                                         ; 
;  *  TELParkCall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELCallPickup" 
      ((hTELCA (:handle :telcarecord)) (pickupDN (:string 255)) (pickupGroupID :signed-integer)) 
  :telerr
   () )                                         ; 
;  *  TELRetrieveParkedCall()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELParkCall" 
      ((hTELCA (:handle :telcarecord)) (parkRetrieveID (:pointer (:pointer (:string 255)))) (parkID (:string 255))) 
  :telerr
   () )                                         ; 
;  *  TELVoiceMailAccess()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELRetrieveParkedCall" 
      ((hTELCA (:handle :telcarecord)) (parkRetrieveID (:string 255))) 
  :telerr
   () )                                         ; 
;  *  TELPaging()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELVoiceMailAccess" 
      ((hTELCA (:handle :telcarecord))) 
  :telerr
   () )                                         ; 
;  *  TELIntercom()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELPaging" 
      ((hTELCA (:handle :telcarecord)) (pageID :signed-integer)) 
  :telerr
   () )                                         ; 
;  *  TELOtherFeatureList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELIntercom" 
      ((hTELCA (:handle :telcarecord)) (intercomID :signed-integer)) 
  :telerr
   () )                                         ; 
;  *  TELOtherFeatureImplement()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELOtherFeatureList" 
      ((hTEL (:handle :telrecord)) (fList (:pointer (:pointer :featurelist)))) 
  :telerr
   () )                                         ; 
;  *  TELToolFunctions()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELOtherFeatureImplement" 
      ((hTEL (:handle :telrecord)) (theHandle :handle) (featureID :signed-integer)) 
  :telerr
   () )                                         ; 
;  *  TELOtherFunction()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELToolFunctions" 
      ((hTEL (:handle :telrecord)) (msgcode :signed-integer) (supportsIt (:pointer :boolean))) 
  :telerr
   () )                                         ; 
;  *  TELGetHooksw()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELOtherFunction" 
      ((hTEL (:handle :telrecord)) (paramblock :pointer) (size :signed-long)) 
  :telerr
   () )                                         ; 
;  *  TELSetHooksw()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELGetHooksw" 
      ((hTEL (:handle :telrecord)) (hookType :signed-integer) (offHook (:pointer :boolean))) 
  :telerr
   () )                                         ; 
;  *  TELGetVolume()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELSetHooksw" 
      ((hTEL (:handle :telrecord)) (hookType :signed-integer) (offHook :boolean)) 
  :telerr
   () )                                         ; 
;  *  TELSetVolume()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELGetVolume" 
      ((hTEL (:handle :telrecord)) (volType :signed-integer) (level (:pointer :signed-integer)) (volState (:pointer :signed-integer))) 
  :telerr
   () )                                         ; 
;  *  TELAlert()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELSetVolume" 
      ((hTEL (:handle :telrecord)) (volType :signed-integer) (level (:pointer :signed-integer)) (volState :signed-integer)) 
  :telerr
   () )                                         ; 
;  *  TELGetDisplay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELAlert" 
      ((hTEL (:handle :telrecord)) (level (:pointer :signed-integer)) (alertPattern :signed-integer)) 
  :telerr
   () )                                         ; 
;  *  TELSetDisplay()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELGetDisplay" 
      ((hTEL (:handle :telrecord)) (index :signed-integer) (displayMode (:pointer :signed-integer)) (text (:pointer (:pointer (:string 255))))) 
  :telerr
   () )                                         ; 
;  *  TELIdle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELSetDisplay" 
      ((hTEL (:handle :telrecord)) (index :signed-integer) (displayMode :signed-integer) (text (:string 255))) 
  :telerr
   () )                                         ; 
;  *  TELActivate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELIdle" 
      ((hTEL (:handle :telrecord))) 
  nil
   () )                                         ; 
;  *  TELResume()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELActivate" 
      ((hTEL (:handle :telrecord)) (activate :boolean)) 
  nil
   () )                                         ; 
;  *  TELMenu()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELResume" 
      ((hTEL (:handle :telrecord)) (resume :boolean)) 
  nil
   () )                                         ; 
;  *  TELEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELMenu" 
      ((hTEL (:handle :telrecord)) (menuID :signed-integer) (item :signed-integer)) 
  :boolean
   () )                                         ; CONST; 
;  *  TELGetToolName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELEvent" 
      ((hTEL (:handle :telrecord)) (theEvent (:pointer :eventrecord))) 
  nil
   () )                                         ; 
;  *  TELGetVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELGetToolName" 
      ((procID :signed-integer) (name (:pointer (:string 255)))) 
  nil
   () )                                         ; 
;  *  TELGetTELVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELGetVersion" 
      ((hTEL (:handle :telrecord))) 
  :handle
   () )                                         ; 
;  *  TELIntlToEnglish()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELGetTELVersion" 
      () 
  :signed-integer
   () )                                         ; 
;  *  TELEnglishToIntl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELIntlToEnglish" 
      ((hTEL (:handle :telrecord)) (inputPtr :pointer) (outputPtr (:pointer :pointer)) (language :signed-integer)) 
  :telerr
   () )                                         ; 
;  *  TELGetDNSoundInput()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELEnglishToIntl" 
      ((hTEL (:handle :telrecord)) (inputPtr :pointer) (outputPtr (:pointer :pointer)) (language :signed-integer)) 
  :telerr
   () )                                         ; 
;  *  TELDisposeDNSoundInput()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELGetDNSoundInput" 
      ((hTELDN (:handle :teldnrecord)) (deviceName (:pointer (:string 255)))) 
  :telerr
   () )                                         ; 
;  *  TELGetDNSoundOutput()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELDisposeDNSoundInput" 
      ((hTELDN (:handle :teldnrecord)) (deviceName (:string 255))) 
  :telerr
   () )                                         ; 
;  *  TELDisposeDNSoundOutput()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELGetDNSoundOutput" 
      ((hTELDN (:handle :teldnrecord)) (SndOut (:pointer (:pointer :componentrecord)))) 
  :telerr
   () )                                         ; 
;  *  TELGetHSSoundInput()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELDisposeDNSoundOutput" 
      ((hTELDN (:handle :teldnrecord)) (SndOut (:pointer :componentrecord))) 
  :telerr
   () )                                         ; 
;  *  TELDisposeHSSoundInput()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELGetHSSoundInput" 
      ((termHand (:handle :telrecord)) (deviceName (:pointer (:string 255)))) 
  :telerr
   () )                                         ; 
;  *  TELGetHSSoundOutput()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELDisposeHSSoundInput" 
      ((termHand (:handle :telrecord)) (deviceName (:string 255))) 
  :telerr
   () )                                         ; 
;  *  TELDisposeHSSoundOutput()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELGetHSSoundOutput" 
      ((termHand (:handle :telrecord)) (SndOut (:pointer (:pointer :componentrecord)))) 
  :telerr
   () )                                         ; 
;  *  TELDNSetAutoAnswer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELDisposeHSSoundOutput" 
      ((termHand (:handle :telrecord)) (SndOut (:pointer :componentrecord))) 
  :telerr
   () )                                         ; 
;  *  TELDNTollSaverControl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELDNSetAutoAnswer" 
      ((hTELDN (:handle :teldnrecord)) (AutoAnswerOn :boolean)) 
  :telerr
   () )                                         ; 
;  *  TELSetIndHSConnect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELDNTollSaverControl" 
      ((hTELDN (:handle :teldnrecord)) (QuickAnswer :boolean)) 
  :telerr
   () )                                         ; 
;  *  TELGetIndHSConnect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELSetIndHSConnect" 
      ((termHand (:handle :telrecord)) (Connect :boolean)) 
  :telerr
   () )                                         ; 
;  *  TELCAVoiceDetect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELGetIndHSConnect" 
      ((termHand (:handle :telrecord)) (Connect (:pointer :boolean))) 
  :telerr
   () )                                         ; 
;  *  TELCASilenceDetect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELCAVoiceDetect" 
      ((hTELCA (:handle :telcarecord)) (VoiceDetectOn :boolean)) 
  :telerr
   () )                                         ; 
;  *  TELGetTelNewErr()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELCASilenceDetect" 
      ((hTELCA (:handle :telcarecord)) (DetectOn :boolean) (Period :signed-long)) 
  :telerr
   () )                                         ; 
;  *  TELDNSetDTMF()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELGetTelNewErr" 
      () 
  :telerr
   () )                                         ; 
;  *  TELDNGetDTMF()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELDNSetDTMF" 
      ((hTELDN (:handle :teldnrecord)) (dtmfOn :boolean)) 
  :telerr
   () )                                         ; 
;  *  TELHSSetDTMF()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELDNGetDTMF" 
      ((hTELDN (:handle :teldnrecord)) (dtmfOn (:pointer :boolean))) 
  :telerr
   () )                                         ; 
;  *  TELHSGetDTMF()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELHSSetDTMF" 
      ((termHand (:handle :telrecord)) (dtmfOn :boolean)) 
  :telerr
   () )                                         ; 
;  *  TELGetDNStatus()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELHSGetDTMF" 
      ((termHand (:handle :telrecord)) (dtmfOn (:pointer :boolean))) 
  :telerr
   () )                                         ; 
;  *  TELGetDNProgressDet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELGetDNStatus" 
      ((hTELDN (:handle :teldnrecord)) (inUse (:pointer :signed-long))) 
  :telerr
   () )                                         ; 
;  *  TELSetDNProgressDet()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TELGetDNProgressDet" 
      ((hTELDN (:handle :teldnrecord)) (selector :signed-long) (prgDetOn (:pointer :boolean))) 
  :telerr
   () )
(deftrap-inline "_TELSetDNProgressDet" 
      ((hTELDN (:handle :teldnrecord)) (selector :signed-long) (prgDetOn :boolean)) 
  :telerr
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := TelephonesIncludes

; $ENDC                                         ; __TELEPHONES__

; $IFC NOT UsingIncludes

; $ENDC

(provide-interface 'Telephones)