(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Terminals.p"
; at Wednesday May 1,2002 2:41:26 pm.
; 
;      File:       Terminals.p
;  
;      Contains:   Communications Toolbox Terminal tool Interfaces.
;  
;      Version:    Technology: System 7.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1988-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __TERMINALS__
; $SETC __TERMINALS__ := 1

; $I+
; $SETC TerminalsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __DIALOGS__
|#

(require-interface 'Dialogs)
#|                                              ; $I Dialogs.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CTBUTILITIES__
|#

(require-interface 'CTBUtilities)
#|                                              ; $I CTBUtilities.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CONNECTIONS__
|#

(require-interface 'Connections)
#|                                              ; $I Connections.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; $IFC CALL_NOT_IN_CARBON 

(defconstant $curTMVersion 2)                   ;   current Terminal Manager version  

(defconstant $curTermEnvRecVers 0)              ;   current Terminal Manager Environment Record version  

;   error codes     
(defconstant $tmGenericError -1)
(defconstant $tmNoErr 0)
(defconstant $tmNotSent 1)
(defconstant $tmEnvironsChanged 2)
(defconstant $tmNotSupported 7)
(defconstant $tmNoTools 8)

(def-mactype :tmerr (find-mactype ':signed-integer))
(def-mactype :tmflags (find-mactype ':unsigned-long))

(defconstant $tmInvisible #x1)
(defconstant $tmSaveBeforeClear #x2)
(defconstant $tmNoMenus #x4)
(defconstant $tmAutoScroll #x8)
(defconstant $tmConfigChanged #x10)

(def-mactype :tmseltypes (find-mactype ':signed-integer))

(defconstant $selTextNormal #x1)
(defconstant $selTextBoxed #x2)
(defconstant $selGraphicsMarquee #x4)
(defconstant $selGraphicsLasso #x8)

(def-mactype :tmsearchtypes (find-mactype ':unsigned-integer))

(defconstant $tmSearchNoDiacrit #x100)
(defconstant $tmSearchNoCase #x200)

(def-mactype :tmcursortypes (find-mactype ':unsigned-integer))

(defconstant $cursorText 1)
(defconstant $cursorGraphics 2)

(def-mactype :tmtermtypes (find-mactype ':unsigned-integer))

(defconstant $tmTextTerminal #x1)
(defconstant $tmGraphicsTerminal #x2)

(def-mactype :termdatablockptr (find-mactype '(:pointer :termdatablock)))
(defrecord TermDataBlock 
   (flags :unsigned-integer)
   (theData :handle)
   (auxData :handle)
   (reserved :signed-long)
   )

(def-mactype :termdatablockh (find-mactype '(:handle :termdatablock)))
(def-mactype :termdatablockhandle (find-mactype '(:handle :termdatablock)))
(def-mactype :termenvironrecptr (find-mactype '(:pointer :termenvironrec)))
(defrecord TermEnvironRec 
   (version :signed-integer)
   (termType :unsigned-integer)
   (textRows :signed-integer)
   (textCols :signed-integer)
   (cellSize :point)
   (graphicSize :rect)
   (slop :point)
   (auxSpace :rect)
   )

(def-mactype :termenvironptr (find-mactype '(:pointer :termenvironrec)))
(def-mactype :tmselectionptr (find-mactype '(:pointer :tmselection)))
(defrecord TMSelection 
   (:variant 
      (
      (selRect :rect)
      )
      (
      (selRgnHandle (:handle :macregion))
      )
      )
   )

(def-mactype :termrecordptr (find-mactype '(:pointer :termrecord)))
(def-mactype :termptr (find-mactype '(:pointer :termrecord)))
(def-mactype :termhandle (find-mactype '(:handle :termrecord)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TerminalSendProcPtr = FUNCTION(thePtr: Ptr; theSize: LONGINT; refCon: LONGINT; flags: CMFlags): LONGINT;

|#
 |#                                             ; $ELSEC
(def-mactype :terminalsendprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TerminalBreakProcPtr = PROCEDURE(duration: LONGINT; refCon: LONGINT);

|#
 |#                                             ; $ELSEC
(def-mactype :terminalbreakprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TerminalCacheProcPtr = FUNCTION(refCon: LONGINT; theTermData: TermDataBlockPtr): LONGINT;

|#
 |#                                             ; $ELSEC
(def-mactype :terminalcacheprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TerminalSearchCallBackProcPtr = PROCEDURE(hTerm: TermHandle; refNum: INTEGER; VAR foundRect: Rect);

|#
 |#                                             ; $ELSEC
(def-mactype :terminalsearchcallbackprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TerminalClikLoopProcPtr = FUNCTION(refCon: LONGINT): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :terminalclikloopprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TerminalEnvironsProcPtr = FUNCTION(refCon: LONGINT; VAR theEnvirons: ConnEnvironRec): CMErr;

|#
 |#                                             ; $ELSEC
(def-mactype :terminalenvironsprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TerminalChooseIdleProcPtr = PROCEDURE;

|#
 |#                                             ; $ELSEC
(def-mactype :terminalchooseidleprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TerminalToolDefProcPtr = FUNCTION(hTerm: TermHandle; msg: INTEGER; p1: LONGINT; p2: LONGINT; p3: LONGINT): LONGINT;

|#
 |#                                             ; $ELSEC
(def-mactype :terminaltooldefprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :terminalsendupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :terminalsendupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :terminalbreakupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :terminalbreakupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :terminalcacheupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :terminalcacheupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :terminalsearchcallbackupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :terminalsearchcallbackupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :terminalclikloopupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :terminalclikloopupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :terminalenvironsupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :terminalenvironsupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :terminalchooseidleupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :terminalchooseidleupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :terminaltooldefupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :terminaltooldefupp (find-mactype ':pointer))
; $ENDC
; 	    TMTermTypes     	
(defrecord TermRecord 
   (procID :signed-integer)
   (flags :unsigned-long)
   (errCode :signed-integer)
   (refCon :signed-long)
   (userData :signed-long)
   (defProc :pointer)
   (config :pointer)
   (oldConfig :pointer)
   (environsProc :pointer)
   (reserved1 :signed-long)
   (reserved2 :signed-long)
   (tmPrivate :pointer)
   (sendProc :pointer)
   (breakProc :pointer)
   (cacheProc :pointer)
   (clikLoop :pointer)
   (owner (:pointer :windowrecord))
   (termRect :rect)
   (viewRect :rect)
   (visRect :rect)
   (lastIdle :signed-long)
   (selection :tmselection)
   (selType :signed-integer)
   (mluField :signed-long)
   )

; $ENDC                                         ; CALL_NOT_IN_CARBON

(defconstant $uppTerminalSendProcInfo #x2FF0)
(defconstant $uppTerminalBreakProcInfo #x3C0)
(defconstant $uppTerminalCacheProcInfo #x3F0)
(defconstant $uppTerminalSearchCallBackProcInfo #xEC0)
(defconstant $uppTerminalClikLoopProcInfo #xD0)
(defconstant $uppTerminalEnvironsProcInfo #x3E0)
(defconstant $uppTerminalChooseIdleProcInfo #x0)
(defconstant $uppTerminalToolDefProcInfo #xFEF0)
; $IFC CALL_NOT_IN_CARBON 
; 
; 	 *  NewTerminalSendUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        not available
; 	 *    Mac OS X:         not available
; 	 	
;  old name was NewTerminalSendProc 
(deftrap "_NewTerminalSendUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewTerminalBreakUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewTerminalBreakProc 
(deftrap "_NewTerminalBreakUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewTerminalCacheUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewTerminalCacheProc 
(deftrap "_NewTerminalCacheUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewTerminalSearchCallBackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewTerminalSearchCallBackProc 
(deftrap "_NewTerminalSearchCallBackUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewTerminalClikLoopUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewTerminalClikLoopProc 
(deftrap "_NewTerminalClikLoopUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewTerminalEnvironsUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewTerminalEnvironsProc 
(deftrap "_NewTerminalEnvironsUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewTerminalChooseIdleUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewTerminalChooseIdleProc 
(deftrap "_NewTerminalChooseIdleUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewTerminalToolDefUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was NewTerminalToolDefProc 
(deftrap "_NewTerminalToolDefUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeTerminalSendUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeTerminalSendUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeTerminalBreakUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeTerminalBreakUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeTerminalCacheUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeTerminalCacheUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeTerminalSearchCallBackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeTerminalSearchCallBackUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeTerminalClikLoopUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeTerminalClikLoopUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeTerminalEnvironsUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeTerminalEnvironsUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeTerminalChooseIdleUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeTerminalChooseIdleUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeTerminalToolDefUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_DisposeTerminalToolDefUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeTerminalSendUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallTerminalSendProc 
(deftrap-inline "_InvokeTerminalSendUPP" 
      ((thePtr :pointer) (theSize :signed-long) (refCon :signed-long) (flags :unsigned-integer) (userRoutine :pointer)) 
  :signed-long
   (#x205F #x4E90) )

; 
;  *  InvokeTerminalBreakUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallTerminalBreakProc 
(deftrap-inline "_InvokeTerminalBreakUPP" 
      ((duration :signed-long) (refCon :signed-long) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeTerminalCacheUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallTerminalCacheProc 
(deftrap-inline "_InvokeTerminalCacheUPP" 
      ((refCon :signed-long) (theTermData (:pointer :termdatablock)) (userRoutine :pointer)) 
  :signed-long
   (#x205F #x4E90) )

; 
;  *  InvokeTerminalSearchCallBackUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallTerminalSearchCallBackProc 
(deftrap-inline "_InvokeTerminalSearchCallBackUPP" 
      ((hTerm (:handle :termrecord)) (refNum :signed-integer) (foundRect (:pointer :rect)) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeTerminalClikLoopUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallTerminalClikLoopProc 
(deftrap-inline "_InvokeTerminalClikLoopUPP" 
      ((refCon :signed-long) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; 
;  *  InvokeTerminalEnvironsUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallTerminalEnvironsProc 
(deftrap-inline "_InvokeTerminalEnvironsUPP" 
      ((refCon :signed-long) (theEnvirons (:pointer :connenvironrec)) (userRoutine :pointer)) 
  :signed-integer
   (#x205F #x4E90) )

; 
;  *  InvokeTerminalChooseIdleUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallTerminalChooseIdleProc 
(deftrap "_InvokeTerminalChooseIdleUPP" 
      ((userRoutine :pointer))
   nil
   (:register-trap #x4E90 :a0 userRoutine))

; 
;  *  InvokeTerminalToolDefUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
;  old name was CallTerminalToolDefProc 
(deftrap-inline "_InvokeTerminalToolDefUPP" 
      ((hTerm (:handle :termrecord)) (msg :signed-integer) (p1 :signed-long) (p2 :signed-long) (p3 :signed-long) (userRoutine :pointer)) 
  :signed-long
   (#x205F #x4E90) )

; $ENDC                                         ; CALL_NOT_IN_CARBON

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  InitTM()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; 
;  *  TMGetVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_InitTM" 
      () 
  :tmerr
   () )                                         ; 
;  *  TMGetTMVersion()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMGetVersion" 
      ((hTerm (:handle :termrecord))) 
  :handle
   () )                                         ; 
;  *  TMNew()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMGetTMVersion" 
      () 
  :signed-integer
   () )                                         ; CONST; CONST; 
;  *  TMDispose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMNew" 
      ((termRect (:pointer :rect)) (viewRect (:pointer :rect)) (flags :unsigned-long) (procID :signed-integer) (owner (:pointer :windowrecord)) (sendProc :pointer) (cacheProc :pointer) (breakProc :pointer) (clikLoop :pointer) (environsProc :pointer) (refCon :signed-long) (userData :signed-long)) 
  (:handle :termrecord)
   () )                                         ; 
;  *  TMKey()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMDispose" 
      ((hTerm (:handle :termrecord))) 
  nil
   () )                                         ; CONST; 
;  *  TMUpdate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMKey" 
      ((hTerm (:handle :termrecord)) (theEvent (:pointer :eventrecord))) 
  nil
   () )                                         ; 
;  *  TMPaint()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMUpdate" 
      ((hTerm (:handle :termrecord)) (visRgn (:handle :macregion))) 
  nil
   () )                                         ; CONST; CONST; 
;  *  TMActivate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMPaint" 
      ((hTerm (:handle :termrecord)) (theTermData (:pointer :termdatablock)) (theRect (:pointer :rect))) 
  nil
   () )                                         ; 
;  *  TMResume()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMActivate" 
      ((hTerm (:handle :termrecord)) (activate :boolean)) 
  nil
   () )                                         ; 
;  *  TMClick()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMResume" 
      ((hTerm (:handle :termrecord)) (resume :boolean)) 
  nil
   () )                                         ; CONST; 
;  *  TMIdle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMClick" 
      ((hTerm (:handle :termrecord)) (theEvent (:pointer :eventrecord))) 
  nil
   () )                                         ; 
;  *  TMStream()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMIdle" 
      ((hTerm (:handle :termrecord))) 
  nil
   () )                                         ; 
;  *  TMMenu()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMStream" 
      ((hTerm (:handle :termrecord)) (theBuffer :pointer) (theLength :signed-long) (flags :unsigned-integer)) 
  :signed-long
   () )                                         ; 
;  *  TMReset()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMMenu" 
      ((hTerm (:handle :termrecord)) (menuID :signed-integer) (item :signed-integer)) 
  :boolean
   () )                                         ; 
;  *  TMClear()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMReset" 
      ((hTerm (:handle :termrecord))) 
  nil
   () )                                         ; 
;  *  TMResize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMClear" 
      ((hTerm (:handle :termrecord))) 
  nil
   () )                                         ; CONST; 
;  *  TMGetSelect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMResize" 
      ((hTerm (:handle :termrecord)) (newViewRect (:pointer :rect))) 
  nil
   () )                                         ; 
;  *  TMGetLine()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMGetSelect" 
      ((hTerm (:handle :termrecord)) (theData :handle) (theType (:pointer :ostype))) 
  :signed-long
   () )                                         ; 
;  *  TMSetSelection()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMGetLine" 
      ((hTerm (:handle :termrecord)) (lineNo :signed-integer) (theTermData (:pointer :termdatablock))) 
  nil
   () )                                         ; CONST; 
;  *  TMScroll()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMSetSelection" 
      ((hTerm (:handle :termrecord)) (theSelection (:pointer :tmselection)) (selType :signed-integer)) 
  nil
   () )                                         ; 
;  *  TMValidate()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMScroll" 
      ((hTerm (:handle :termrecord)) (dh :signed-integer) (dv :signed-integer)) 
  nil
   () )                                         ; 
;  *  TMDefault()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMValidate" 
      ((hTerm (:handle :termrecord))) 
  :boolean
   () )                                         ; 
;  *  TMSetupPreflight()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMDefault" 
      ((theConfig (:pointer :pointer)) (procID :signed-integer) (allocate :boolean)) 
  nil
   () )                                         ; 
;  *  TMSetupSetup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMSetupPreflight" 
      ((procID :signed-integer) (magicCookie (:pointer :signed-long))) 
  :handle
   () )                                         ; 
;  *  TMSetupFilter()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMSetupSetup" 
      ((procID :signed-integer) (theConfig :pointer) (count :signed-integer) (theDialog (:pointer :grafport)) (magicCookie (:pointer :signed-long))) 
  nil
   () )                                         ; 
;  *  TMSetupItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMSetupFilter" 
      ((procID :signed-integer) (theConfig :pointer) (count :signed-integer) (theDialog (:pointer :grafport)) (theEvent (:pointer :eventrecord)) (theItem (:pointer :signed-integer)) (magicCookie (:pointer :signed-long))) 
  :boolean
   () )                                         ; 
;  *  TMSetupXCleanup()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMSetupItem" 
      ((procID :signed-integer) (theConfig :pointer) (count :signed-integer) (theDialog (:pointer :grafport)) (theItem (:pointer :signed-integer)) (magicCookie (:pointer :signed-long))) 
  nil
   () )                                         ; 
;  *  TMSetupPostflight()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMSetupXCleanup" 
      ((procID :signed-integer) (theConfig :pointer) (count :signed-integer) (theDialog (:pointer :grafport)) (OKed :boolean) (magicCookie (:pointer :signed-long))) 
  nil
   () )                                         ; 
;  *  TMGetConfig()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMSetupPostflight" 
      ((procID :signed-integer)) 
  nil
   () )                                         ; 
;  *  TMSetConfig()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMGetConfig" 
      ((hTerm (:handle :termrecord))) 
  :pointer
   () )                                         ; 
;  *  TMIntlToEnglish()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMSetConfig" 
      ((hTerm (:handle :termrecord)) (thePtr :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  TMEnglishToIntl()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMIntlToEnglish" 
      ((hTerm (:handle :termrecord)) (inputPtr :pointer) (outputPtr (:pointer :pointer)) (language :signed-integer)) 
  :signed-integer
   () )                                         ; 
;  *  TMGetToolName()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMEnglishToIntl" 
      ((hTerm (:handle :termrecord)) (inputPtr :pointer) (outputPtr (:pointer :pointer)) (language :signed-integer)) 
  :signed-integer
   () )                                         ; 
;  *  TMGetProcID()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMGetToolName" 
      ((id :signed-integer) (name (:pointer (:string 255)))) 
  nil
   () )                                         ; 
;  *  TMSetRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMGetProcID" 
      ((name (:string 255))) 
  :signed-integer
   () )                                         ; 
;  *  TMGetRefCon()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMSetRefCon" 
      ((hTerm (:handle :termrecord)) (refCon :signed-long)) 
  nil
   () )                                         ; 
;  *  TMSetUserData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMGetRefCon" 
      ((hTerm (:handle :termrecord))) 
  :signed-long
   () )                                         ; 
;  *  TMGetUserData()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMSetUserData" 
      ((hTerm (:handle :termrecord)) (userData :signed-long)) 
  nil
   () )                                         ; 
;  *  TMAddSearch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMGetUserData" 
      ((hTerm (:handle :termrecord))) 
  :signed-long
   () )                                         ; CONST; 
;  *  TMRemoveSearch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMAddSearch" 
      ((hTerm (:handle :termrecord)) (theString (:string 255)) (where (:pointer :rect)) (searchType :unsigned-integer) (callBack :pointer)) 
  :signed-integer
   () )                                         ; 
;  *  TMClearSearch()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMRemoveSearch" 
      ((hTerm (:handle :termrecord)) (refnum :signed-integer)) 
  nil
   () )                                         ; 
;  *  TMGetCursor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMClearSearch" 
      ((hTerm (:handle :termrecord))) 
  nil
   () )                                         ; 
;  *  TMGetTermEnvirons()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMGetCursor" 
      ((hTerm (:handle :termrecord)) (cursType :unsigned-integer)) 
  :point
   () )                                         ; 
;  *  TMChoose()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMGetTermEnvirons" 
      ((hTerm (:handle :termrecord)) (theEnvirons (:pointer :termenvironrec))) 
  :tmerr
   () )                                         ; 
;  *  TMEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMChoose" 
      ((hTerm (:pointer (:handle :termrecord))) (where :point) (idleProc :pointer)) 
  :signed-integer
   () )                                         ; CONST; 
;  *  TMDoTermKey()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMEvent" 
      ((hTerm (:handle :termrecord)) (theEvent (:pointer :eventrecord))) 
  nil
   () )                                         ; 
;  *  TMCountTermKeys()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMDoTermKey" 
      ((hTerm (:handle :termrecord)) (theKey (:string 255))) 
  :boolean
   () )                                         ; 
;  *  TMGetIndTermKey()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMCountTermKeys" 
      ((hTerm (:handle :termrecord))) 
  :signed-integer
   () )                                         ; 
;  *  TMGetErrorString()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TMGetIndTermKey" 
      ((hTerm (:handle :termrecord)) (id :signed-integer) (theKey (:pointer (:string 255)))) 
  nil
   () )
(deftrap-inline "_TMGetErrorString" 
      ((hTerm (:handle :termrecord)) (id :signed-integer) (errMsg (:pointer (:string 255)))) 
  nil
   () )                                         ; $ENDC; CALL_NOT_IN_CARBON

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := TerminalsIncludes

; $ENDC                                         ; __TERMINALS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Terminals)