(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:TextEncodingPlugin.p"
; at Wednesday May 1,2002 2:40:12 pm.
; 
;      File:       TextEncodingPlugin.p
;  
;      Contains:   Required interface for Text Encoding Converter-Plugins
;  
;      Version:    Technology: Mac OS 8
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1996-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __TEXTENCODINGPLUGIN__
; $SETC __TEXTENCODINGPLUGIN__ := 1

; $I+
; $SETC TextEncodingPluginIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __TEXTCOMMON__
|#

(require-interface 'TextCommon)
#|                                              ; $I TextCommon.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __TEXTENCODINGCONVERTER__
|#

(require-interface 'TextEncodingConverter)
#|                                              ; $I TextEncodingConverter.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

; 
;   ####################################################################################
;         Constants
;   ####################################################################################
; 
; 
;   ####################################################################################
;         Structs
;   ####################################################################################
; 

(def-mactype :tecbuffercontextrecptr (find-mactype '(:pointer :tecbuffercontextrec)))
(defrecord TECBufferContextRec 
   (textInputBuffer (:pointer :unsigned-byte))
   (textInputBufferEnd (:pointer :unsigned-byte))
   (textOutputBuffer (:pointer :unsigned-byte))
   (textOutputBufferEnd (:pointer :unsigned-byte))
   (encodingInputBuffer (:pointer :textencodingrun))
   (encodingInputBufferEnd (:pointer :textencodingrun))
   (encodingOutputBuffer (:pointer :textencodingrun))
   (encodingOutputBufferEnd (:pointer :textencodingrun))
   )

(def-mactype :tecpluginstaterecptr (find-mactype '(:pointer :tecpluginstaterec)))
(defrecord TECPluginStateRec 
   (state1 :signed-byte)
   (state2 :signed-byte)
   (state3 :signed-byte)
   (state4 :signed-byte)
   (longState1 :unsigned-long)
   (longState2 :unsigned-long)
   (longState3 :unsigned-long)
   (longState4 :unsigned-long)
   )

(def-mactype :tecconvertercontextrecptr (find-mactype '(:pointer :tecconvertercontextrec)))
(defrecord TECConverterContextRec 
;   public - manipulated externally and by plugin 
   (pluginRec :pointer)
   (sourceEncoding :unsigned-long)
   (destEncoding :unsigned-long)
   (reserved1 :unsigned-long)
   (reserved2 :unsigned-long)
   (bufferContext :tecbuffercontextrec)
;   private - manipulated only within Plugin 
   (contextRefCon :unsigned-long)
   (conversionProc :pointer)
   (flushProc :pointer)
   (clearContextInfoProc :pointer)
   (options1 :unsigned-long)
   (options2 :unsigned-long)
   (pluginState :tecpluginstaterec)
   )

(def-mactype :tecsniffercontextrecptr (find-mactype '(:pointer :tecsniffercontextrec)))
(defrecord TECSnifferContextRec 
;   public - manipulated externally 
   (pluginRec :pointer)
   (encoding :unsigned-long)
   (maxErrors :unsigned-long)
   (maxFeatures :unsigned-long)
   (textInputBuffer (:pointer :unsigned-byte))
   (textInputBufferEnd (:pointer :unsigned-byte))
   (numFeatures :unsigned-long)
   (numErrors :unsigned-long)
;   private - manipulated only within Plugin 
   (contextRefCon :unsigned-long)
   (sniffProc :pointer)
   (clearContextInfoProc :pointer)
   (pluginState :tecpluginstaterec)
   )

; 
; 	  ####################################################################################
; 	        Functional Messages
; 	  ####################################################################################
; 	

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TECPluginNewEncodingConverterPtr = FUNCTION(VAR newEncodingConverter: TECObjectRef; VAR plugContext: TECConverterContextRec; inputEncoding: TextEncoding; outputEncoding: TextEncoding): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tecpluginnewencodingconverterptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TECPluginClearContextInfoPtr = FUNCTION(encodingConverter: TECObjectRef; VAR plugContext: TECConverterContextRec): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tecpluginclearcontextinfoptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TECPluginConvertTextEncodingPtr = FUNCTION(encodingConverter: TECObjectRef; VAR plugContext: TECConverterContextRec): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tecpluginconverttextencodingptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TECPluginFlushConversionPtr = FUNCTION(encodingConverter: TECObjectRef; VAR plugContext: TECConverterContextRec): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tecpluginflushconversionptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TECPluginDisposeEncodingConverterPtr = FUNCTION(newEncodingConverter: TECObjectRef; VAR plugContext: TECConverterContextRec): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tecplugindisposeencodingconverterptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TECPluginNewEncodingSnifferPtr = FUNCTION(VAR encodingSniffer: TECSnifferObjectRef; VAR snifContext: TECSnifferContextRec; inputEncoding: TextEncoding): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tecpluginnewencodingsnifferptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TECPluginClearSnifferContextInfoPtr = FUNCTION(encodingSniffer: TECSnifferObjectRef; VAR snifContext: TECSnifferContextRec): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tecpluginclearsniffercontextinfoptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TECPluginSniffTextEncodingPtr = FUNCTION(encodingSniffer: TECSnifferObjectRef; VAR snifContext: TECSnifferContextRec): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tecpluginsnifftextencodingptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TECPluginDisposeEncodingSnifferPtr = FUNCTION(encodingSniffer: TECSnifferObjectRef; VAR snifContext: TECSnifferContextRec): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tecplugindisposeencodingsnifferptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TECPluginGetCountAvailableTextEncodingsPtr = FUNCTION(VAR availableEncodings: TextEncoding; maxAvailableEncodings: ItemCount; VAR actualAvailableEncodings: ItemCount): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tecplugingetcountavailabletextencodingsptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TECPluginGetCountAvailableTextEncodingPairsPtr = FUNCTION(VAR availableEncodings: TECConversionInfo; maxAvailableEncodings: ItemCount; VAR actualAvailableEncodings: ItemCount): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tecplugingetcountavailabletextencodingpairsptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TECPluginGetCountDestinationTextEncodingsPtr = FUNCTION(inputEncoding: TextEncoding; VAR destinationEncodings: TextEncoding; maxDestinationEncodings: ItemCount; VAR actualDestinationEncodings: ItemCount): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tecplugingetcountdestinationtextencodingsptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TECPluginGetCountSubTextEncodingsPtr = FUNCTION(inputEncoding: TextEncoding; VAR subEncodings: TextEncoding; maxSubEncodings: ItemCount; VAR actualSubEncodings: ItemCount): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tecplugingetcountsubtextencodingsptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TECPluginGetCountAvailableSniffersPtr = FUNCTION(VAR availableEncodings: TextEncoding; maxAvailableEncodings: ItemCount; VAR actualAvailableEncodings: ItemCount): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tecplugingetcountavailablesniffersptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TECPluginGetTextEncodingInternetNamePtr = FUNCTION(textEncoding: TextEncoding; VAR encodingName: Str255): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tecplugingettextencodinginternetnameptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TECPluginGetTextEncodingFromInternetNamePtr = FUNCTION(VAR textEncoding: TextEncoding; encodingName: Str255): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tecplugingettextencodingfrominternetnameptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TECPluginGetCountWebEncodingsPtr = FUNCTION(VAR availableEncodings: TextEncoding; maxAvailableEncodings: ItemCount; VAR actualAvailableEncodings: ItemCount): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tecplugingetcountwebencodingsptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TECPluginGetCountMailEncodingsPtr = FUNCTION(VAR availableEncodings: TextEncoding; maxAvailableEncodings: ItemCount; VAR actualAvailableEncodings: ItemCount): OSStatus; C;

|#
 |#                                             ; $ELSEC
(def-mactype :tecplugingetcountmailencodingsptr (find-mactype ':pointer))
; $ENDC

; 
; 	  ####################################################################################
; 	        Dispatch Table Definition
; 	  ####################################################################################
; 	

(defconstant $kTECPluginDispatchTableVersion1 #x10000);   1.0 through 1.0.3 releases 
(defconstant $kTECPluginDispatchTableVersion1_1 #x10001);   1.1 releases 
(defconstant $kTECPluginDispatchTableVersion1_2 #x10002);   1.2 releases 
(defconstant $kTECPluginDispatchTableCurrentVersion #x10002)

(def-mactype :tecplugindispatchtableptr (find-mactype '(:pointer :tecplugindispatchtable)))
(defrecord TECPluginDispatchTable 
   (version :unsigned-long)
   (compatibleVersion :unsigned-long)
   (PluginID :ostype)
   (PluginNewEncodingConverter :pointer)
   (PluginClearContextInfo :pointer)
   (PluginConvertTextEncoding :pointer)
   (PluginFlushConversion :pointer)
   (PluginDisposeEncodingConverter :pointer)
   (PluginNewEncodingSniffer :pointer)
   (PluginClearSnifferContextInfo :pointer)
   (PluginSniffTextEncoding :pointer)
   (PluginDisposeEncodingSniffer :pointer)
   (PluginGetCountAvailableTextEncodings :pointer)
   (PluginGetCountAvailableTextEncodingPairs :pointer)
   (PluginGetCountDestinationTextEncodings :pointer)
   (PluginGetCountSubTextEncodings :pointer)
   (PluginGetCountAvailableSniffers :pointer)
   (PluginGetCountWebTextEncodings :pointer)
   (PluginGetCountMailTextEncodings :pointer)
   (PluginGetTextEncodingInternetName :pointer)
   (PluginGetTextEncodingFromInternetName :pointer)
   )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := TextEncodingPluginIncludes

; $ENDC                                         ; __TEXTENCODINGPLUGIN__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'TextEncodingPlugin)