(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:TextServices.p"
; at Wednesday May 1,2002 2:40:54 pm.
; 
;      File:       TextServices.p
;  
;      Contains:   Text Services Manager Interfaces.
;  
;      Version:    Technology: Mac OS 9
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1991-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __TEXTSERVICES__
; $SETC __TEXTSERVICES__ := 1

; $I+
; $SETC TextServicesIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __EVENTS__
|#

(require-interface 'Events)
#|                                              ; $I Events.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MENUS__
|#

(require-interface 'Menus)
#|                                              ; $I Menus.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __AEDATAMODEL__
|#

(require-interface 'AEDataModel)
#|                                              ; $I AEDataModel.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __AEREGISTRY__
|#

(require-interface 'AERegistry)
#|                                              ; $I AERegistry.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __AEINTERACTION__
|#

(require-interface 'AEInteraction)
#|                                              ; $I AEInteraction.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __COMPONENTS__
|#

(require-interface 'Components)
#|                                              ; $I Components.p
 |#                                             ; $ENDC

#|                                              ; $IFC UNDEFINED __CARBONEVENTS__
|#

(require-interface 'CarbonEvents)
#|                                              ; $I CarbonEvents.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(defconstant $kTextService :|tsvc|)             ;   component type for the component description  
(defconstant $kInputMethodService :|inpm|)      ;   component subtype for the component description  
(defconstant $kTSMVersion #x150)                ;   Version of the Text Services Manager is 1.5  

(defconstant $kUnicodeDocument :|udoc|)         ;   TSM Document type for Unicode-savvy application  
(defconstant $kUnicodeTextService :|utsv|)      ;   Component type for Unicode Text Service  

;   Language and Script constants 
(defconstant $kUnknownLanguage #xFFFF)
(defconstant $kUnknownScript #xFFFF)
(defconstant $kNeutralScript #xFFFF)

;   Component Flags in ComponentDescription  
(defconstant $bTakeActiveEvent 15)              ;   bit set if the component takes active event  
(defconstant $bHandleAERecording 16)            ;   bit set if the component takes care of recording Apple Events <new in vers2.0>  
(defconstant $bScriptMask #x7F00)               ;   bit 8 - 14  
(defconstant $bLanguageMask #xFF)               ;   bit 0 - 7   
(defconstant $bScriptLanguageMask #x7FFF)       ;   bit 0 - 14   

;   Typing method property constants for Input Methods  
(defconstant $kIMJaTypingMethodProperty :|jtyp|);   Typing method property for Japanese input methods 
(defconstant $kIMJaTypingMethodRoman :|roma|)   ;   Roman typing 
(defconstant $kIMJaTypingMethodKana :|kana|)    ;   Kana typing 

;   Low level routines which are dispatched directly to the Component Manager  
(defconstant $kCMGetScriptLangSupport #x1)      ;   Component Manager call selector 1  
(defconstant $kCMInitiateTextService #x2)       ;   Component Manager call selector 2  
(defconstant $kCMTerminateTextService #x3)      ;   Component Manager call selector 3  
(defconstant $kCMActivateTextService #x4)       ;   Component Manager call selector 4  
(defconstant $kCMDeactivateTextService #x5)     ;   Component Manager call selector 5  
(defconstant $kCMTextServiceEvent #x6)          ;   Component Manager call selector 6  
(defconstant $kCMGetTextServiceMenu #x7)        ;   Component Manager call selector 7  
(defconstant $kCMTextServiceMenuSelect #x8)     ;   Component Manager call selector 8  
(defconstant $kCMFixTextService #x9)            ;   Component Manager call selector 9  
(defconstant $kCMSetTextServiceCursor #xA)      ;   Component Manager call selector 10  
(defconstant $kCMHidePaletteWindows #xB)        ;   Component Manager call selector 11  
(defconstant $kCMGetTextServiceProperty #xC)    ;   Component Manager call selector 12  
(defconstant $kCMSetTextServiceProperty #xD)    ;   Component Manager call selector 13  

;   New low level routines which are dispatched directly to the Component Manager  
(defconstant $kCMUCTextServiceEvent #xE)        ;   Component Manager call selector 14  

; 	 New opaque definitions for types 	

(def-mactype :tsmdocumentid (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :tsmdocumentidptr (find-mactype '(:pointer :pointer)));  when a VAR xx:TSMDocumentID parameter can be nil, it is changed to xx: TSMDocumentIDPtr 
(defrecord InterfaceTypeList (array (:array :ostype 1)))

; 	 Text Service Info List 	
(def-mactype :textserviceinfoptr (find-mactype '(:pointer :textserviceinfo)))
(defrecord TextServiceInfo 
   (fComponent (:pointer :componentrecord))
   (fItemName (:string 255))
   )

(def-mactype :textservicelistptr (find-mactype '(:pointer :textservicelist)))
(defrecord TextServiceList 
   (fTextServiceCount :signed-integer)          ;   number of entries in the 'fServices' array  
   (fServices (:array :textserviceinfo 1))      ;   Note: array of 'TextServiceInfo' records follows  
   )

(def-mactype :textservicelisthandle (find-mactype '(:handle :textservicelist)))
(def-mactype :scriptlanguagerecordptr (find-mactype '(:pointer :scriptlanguagerecord)))
(defrecord ScriptLanguageRecord 
   (fScript :signed-integer)
   (fLanguage :signed-integer)
   )

(def-mactype :scriptlanguagesupportptr (find-mactype '(:pointer :scriptlanguagesupport)))
(defrecord ScriptLanguageSupport 
   (fScriptLanguageCount :signed-integer)       ;   number of entries in the 'fScriptLanguageArray' array  
   (fScriptLanguageArray (:array :scriptlanguagerecord 1));   Note: array of 'ScriptLanguageRecord' records follows  
   )

(def-mactype :scriptlanguagesupporthandle (find-mactype '(:handle :scriptlanguagesupport)))
; 	 High level TSM Doucment routines 	
; 
; 	 *  NewTSMDocument()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_NewTSMDocument" 
      ((numOfInterface :signed-integer) (supportedInterfaceTypes (:pointer :interfacetypelist)) (idocID (:pointer :pointer)) (refcon :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xAA54 :d0 0 numOfInterface supportedInterfaceTypes idocID refcon))

; 
;  *  DeleteTSMDocument()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DeleteTSMDocument" 
      ((idocID :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA54 :d0 1 idocID))

; 
;  *  ActivateTSMDocument()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ActivateTSMDocument" 
      ((idocID :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA54 :d0 2 idocID))

; 
;  *  DeactivateTSMDocument()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DeactivateTSMDocument" 
      ((idocID :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA54 :d0 3 idocID))

; 
;  *  FixTSMDocument()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FixTSMDocument" 
      ((idocID :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA54 :d0 7 idocID))

; 
;  *  GetServiceList()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetServiceList" 
      ((numOfInterface :signed-integer) (supportedInterfaceTypes (:pointer :ostype)) (serviceInfo (:pointer (:handle :textservicelist))) (seedValue (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xAA54 :d0 8 numOfInterface supportedInterfaceTypes serviceInfo seedValue))

; 
;  *  OpenTextService()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_OpenTextService" 
      ((idocID :pointer) (aComponent (:pointer :componentrecord)) (aComponentInstance (:pointer (:pointer :componentinstancerecord))))
   (:stack :signed-integer)
   (:stack-trap #xAA54 :d0 9 idocID aComponent aComponentInstance))

; 
;  *  CloseTextService()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CloseTextService" 
      ((idocID :pointer) (aComponentInstance (:pointer :componentinstancerecord)))
   (:stack :signed-integer)
   (:stack-trap #xAA54 :d0 10 idocID aComponentInstance))

; 
;  *  SendAEFromTSMComponent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_SendAEFromTSMComponent" 
      ((theAppleEvent (:pointer :aedesc)) (reply (:pointer :aedesc)) (sendMode :signed-long) (sendPriority :signed-integer) (timeOutInTicks :signed-long) (idleProc :pointer) (filterProc :pointer))
   (:stack :signed-integer)
   (:stack-trap #xAA54 :d0 11 theAppleEvent reply sendMode sendPriority timeOutInTicks idleProc filterProc))

; 
;  *  SendTextInputEvent()
;  *  
;  *  Discussion:
;  *    This API replaces SendAEFromTSMComponent on Mac OS X only. Input
;  *    Methods on Mac OS X are Carbon Event based instead of AppleEvent
;  *    based.  The Carbon TextInput events which they generate are
;  *    provided to TSM for dispatching via this API.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib N.e.v.e.r and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  SetDefaultInputMethod()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_SendTextInputEvent" 
      ((inEvent :pointer)) 
  :osstatus
   () )
(deftrap "_SetDefaultInputMethod" 
      ((ts (:pointer :componentrecord)) (slRecordPtr (:pointer :scriptlanguagerecord)))
   (:stack :signed-integer)
   (:stack-trap #xAA54 :d0 12 ts slRecordPtr))

; 
;  *  GetDefaultInputMethod()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetDefaultInputMethod" 
      ((ts (:pointer (:pointer :componentrecord))) (slRecordPtr (:pointer :scriptlanguagerecord)))
   (:stack :signed-integer)
   (:stack-trap #xAA54 :d0 13 ts slRecordPtr))

; 
;  *  SetTextServiceLanguage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetTextServiceLanguage" 
      ((slRecordPtr (:pointer :scriptlanguagerecord)))
   (:stack :signed-integer)
   (:stack-trap #xAA54 :d0 14 slRecordPtr))

; 
;  *  GetTextServiceLanguage()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetTextServiceLanguage" 
      ((slRecordPtr (:pointer :scriptlanguagerecord)))
   (:stack :signed-integer)
   (:stack-trap #xAA54 :d0 15 slRecordPtr))

; 
;  *  UseInputWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_UseInputWindow" 
      ((idocID :pointer) (useWindow :boolean))
   (:stack :signed-integer)
   (:stack-trap #xAA54 :d0 16 idocID useWindow))

; 
;  *  TSMSetInlineInputRegion()
;  *  
;  *  Discussion:
;  *    Tell TSM about the region occupied by an inline input session. If
;  *    the location of certain mouse events (clicks, mouse moved) occur
;  *    within the specified inline input region, TSM will forward these
;  *    events to the current Input Method so that it can interact with
;  *    the user. Note: If you do not specify this information, TSM will
;  *    need to intercept mouse events in the entire content region as
;  *    the default, when an input method is active, in order to ensure
;  *    that input methods can manage user interaction properly.
;  *  
;  *  Parameters:
;  *    
;  *    inTSMDocument:
;  *      The document.
;  *    
;  *    inWindow:
;  *      The window that contains the inline input session. You can pass
;  *      NULL for this parameter to indicate the user focus window.
;  *    
;  *    inRegion:
;  *      The region occupied by the current inline input region. This
;  *      should be in the coordinates of the port associated with the
;  *      window you passed to inPort. It will need to be recomputed when
;  *      the text content of the inline input session content changes
;  *      (i.e. due to Update Active Input Area events) and when the
;  *      region moves for other reasons, such as window resized,
;  *      scrolling, etc. If you pass a NULL region for this parameter,
;  *      TSM will default to intercept mouse events in the focus
;  *      window's content region.
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  Following calls from Classic event loops not needed for Carbon clients. ; $IFC CALL_NOT_IN_CARBON ; 
;  *  TSMEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
(deftrap-inline "_TSMSetInlineInputRegion" 
      ((inTSMDocument :pointer) (inWindow (:pointer :windowrecord)) (inRegion (:handle :macregion))) 
  :osstatus
   () )
(deftrap "_TSMEvent" 
      ((event (:pointer :eventrecord)))
   (:stack :boolean)
   (:stack-trap #xAA54 :d0 4 event))

; 
;  *  TSMMenuSelect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_TSMMenuSelect" 
      ((menuResult :signed-long))
   (:stack :boolean)
   (:stack-trap #xAA54 :d0 5 menuResult))

; 
;  *  SetTSMCursor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetTSMCursor" 
      ((mousePos :point))
   (:stack :boolean)
   (:stack-trap #xAA54 :d0 6 mousePos))

;  Following ServiceWindow API replaced by Window Manager API in Carbon. 
; 
;  *  NewServiceWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_NewServiceWindow" 
      ((wStorage :pointer) (boundsRect (:pointer :rect)) (title (:string 255)) (visible :boolean) (theProc :signed-integer) (behind (:pointer :windowrecord)) (goAwayFlag :boolean) (ts (:pointer :componentinstancerecord)) (window (:pointer (:pointer :windowrecord))))
   (:stack :signed-integer)
   (:stack-trap #xAA54 :d0 17 wStorage boundsRect title visible theProc behind goAwayFlag ts window))

; 
;  *  CloseServiceWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CloseServiceWindow" 
      ((window (:pointer :windowrecord)))
   (:stack :signed-integer)
   (:stack-trap #xAA54 :d0 18 window))

; 
;  *  GetFrontServiceWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_GetFrontServiceWindow" 
      ((window (:pointer (:pointer :windowrecord))))
   (:stack :signed-integer)
   (:stack-trap #xAA54 :d0 19 window))

; 
;  *  FindServiceWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_FindServiceWindow" 
      ((thePoint :point) (theWindow (:pointer (:pointer :windowrecord))))
   (:stack :signed-integer)
   (:stack-trap #xAA54 :d0 23 thePoint theWindow))

; 
;  *  NewCServiceWindow()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  
; CONST
(deftrap "_NewCServiceWindow" 
      ((wStorage :pointer) (boundsRect (:pointer :rect)) (title (:string 255)) (visible :boolean) (theProc :signed-integer) (behind (:pointer :windowrecord)) (goAwayFlag :boolean) (ts (:pointer :componentinstancerecord)) (window (:pointer (:pointer :windowrecord))))
   (:stack :signed-integer)
   (:stack-trap #xAA54 :d0 26 wStorage boundsRect title visible theProc behind goAwayFlag ts window))

;  Explicit initialization not needed for Carbon clients, since TSM is 
;  instanciated per-context. 
; 
;  *  InitTSMAwareApplication()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_InitTSMAwareApplication" 
      ()
   (:stack :signed-integer)
   (:stack-trap #xAA54 :d0 20))

; 
;  *  CloseTSMAwareApplication()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_CloseTSMAwareApplication" 
      ()
   (:stack :signed-integer)
   (:stack-trap #xAA54 :d0 21))

;  Component Manager Interfaces to Input Methods 
; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  GetScriptLanguageSupport()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetScriptLanguageSupport" 
      ((ts (:pointer :componentinstancerecord)) (scriptHdl (:pointer (:handle :scriptlanguagesupport))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ts scriptHdl ((+ (ash 4 16) 1) :signed-longint)))

; 
;  *  InitiateTextService()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_InitiateTextService" 
      ((ts (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ts ((+ (ash 0 16) 2) :signed-longint)))

; 
;  *  TerminateTextService()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TerminateTextService" 
      ((ts (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ts ((+ (ash 0 16) 3) :signed-longint)))

; 
;  *  ActivateTextService()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ActivateTextService" 
      ((ts (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ts ((+ (ash 0 16) 4) :signed-longint)))

; 
;  *  DeactivateTextService()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DeactivateTextService" 
      ((ts (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ts ((+ (ash 0 16) 5) :signed-longint)))

; 
;  *  GetTextServiceMenu()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetTextServiceMenu" 
      ((ts (:pointer :componentinstancerecord)) (serviceMenu (:pointer (:handle :menuinfo))))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ts serviceMenu ((+ (ash 4 16) 7) :signed-longint)))

;  New Text Service call in Carbon. 
;  Note: Only Raw Key and Mouse-flavored events are passed to Text Services on MacOS X. 
; 
;  *  TextServiceEventRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.1 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_TextServiceEventRef" 
      ((ts (:pointer :componentinstancerecord)) (event :pointer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ts event ((+ (ash 6 16) 6) :signed-longint)))

; $IFC CALL_NOT_IN_CARBON 
; 
;  *  TextServiceEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_TextServiceEvent" 
      ((ts (:pointer :componentinstancerecord)) (numOfEvents :signed-integer) (event (:pointer :eventrecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ts numOfEvents event ((+ (ash 6 16) 6) :signed-longint)))

; 
;  *  UCTextServiceEvent()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 8.5 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_UCTextServiceEvent" 
      ((ts (:pointer :componentinstancerecord)) (numOfEvents :signed-integer) (event (:pointer :eventrecord)) (unicodeString (:pointer :unsigned-integer)) (unicodeStrLength :unsigned-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ts numOfEvents event unicodeString unicodeStrLength ((+ (ash 14 16) 14) :signed-longint)))

; 
;  *  TextServiceMenuSelect()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_TextServiceMenuSelect" 
      ((ts (:pointer :componentinstancerecord)) (serviceMenu (:handle :menuinfo)) (item :signed-integer))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ts serviceMenu item ((+ (ash 6 16) 8) :signed-longint)))

; 
;  *  SetTextServiceCursor()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        not available
;  *    Mac OS X:         not available
;  

(deftrap "_SetTextServiceCursor" 
      ((ts (:pointer :componentinstancerecord)) (mousePos :point))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ts mousePos ((+ (ash 4 16) 10) :signed-longint)))

; $ENDC                                         ; CALL_NOT_IN_CARBON

; 
;  *  FixTextService()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_FixTextService" 
      ((ts (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ts ((+ (ash 0 16) 9) :signed-longint)))

; 
;  *  HidePaletteWindows()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_HidePaletteWindows" 
      ((ts (:pointer :componentinstancerecord)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ts ((+ (ash 0 16) 11) :signed-longint)))

; 
;  *  GetTextServiceProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetTextServiceProperty" 
      ((ts (:pointer :componentinstancerecord)) (propertySelector :ostype) (result (:pointer :signed-long)))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ts propertySelector result ((+ (ash 8 16) 12) :signed-longint)))

; 
;  *  SetTextServiceProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetTextServiceProperty" 
      ((ts (:pointer :componentinstancerecord)) (propertySelector :ostype) (value :signed-long))
   (:stack :signed-long)
   (:stack-trap #xA82A :d0 0 ts propertySelector value ((+ (ash 8 16) 13) :signed-longint)))

;  Get the active TSMDocument in the current application context.       
;  If TSM has enabled bottom line input mode because no TSMDocument     
;  is active, NULL will be returned.                                    
; 
;  *  TSMGetActiveDocument()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.3 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; $ALIGN RESET                                  ; $POP; $SETC UsingIncludes := TextServicesIncludes
(deftrap-inline "_TSMGetActiveDocument" 
      () 
  :pointer
   () )                                         ; $ENDC; __TEXTSERVICES__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'TextServices)