(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Threads.p"
; at Wednesday May 1,2002 2:40:06 pm.
; 
;      File:       Threads.p
;  
;      Contains:   Thread Manager Interfaces.
;  
;      Version:    Technology: Mac OS 8
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1991-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __THREADS__
; $SETC __THREADS__ := 1

; $I+
; $SETC ThreadsIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MIXEDMODE__
|#

(require-interface 'MixedMode)
#|                                              ; $I MixedMode.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;   Thread states 

(def-mactype :threadstate (find-mactype ':unsigned-integer))

(defconstant $kReadyThreadState 0)
(defconstant $kStoppedThreadState 1)
(defconstant $kRunningThreadState 2)

;   Error codes have been moved to Errors.(pah) 

;   Thread environment characteristics 

(def-mactype :threadtaskref (find-mactype ':pointer))
;   Thread characteristics 
(def-mactype :threadstyle (find-mactype ':unsigned-long))

(defconstant $kCooperativeThread #x1)
(defconstant $kPreemptiveThread #x2)

;   Thread identifiers 

(def-mactype :threadid (find-mactype ':unsigned-long))

(defconstant $kNoThreadID 0)
(defconstant $kCurrentThreadID 1)
(defconstant $kApplicationThreadID 2)

;   Options when creating a thread 

(def-mactype :threadoptions (find-mactype ':unsigned-long))

(defconstant $kNewSuspend #x1)
(defconstant $kUsePremadeThread #x2)
(defconstant $kCreateIfNeeded #x4)
(defconstant $kFPUNotNeeded #x8)
(defconstant $kExactMatchThread #x10)

;   Information supplied to the custom scheduler 

(def-mactype :schedulerinforecptr (find-mactype '(:pointer :schedulerinforec)))
(defrecord SchedulerInfoRec 
   (InfoRecSize :unsigned-long)
   (CurrentThreadID :unsigned-long)
   (SuggestedThreadID :unsigned-long)
   (InterruptedCoopThreadID :unsigned-long)
   )

; 	
; 	    The following ProcPtrs cannot be interchanged with UniversalProcPtrs because
; 	    of differences between 680x0 and PowerPC runtime architectures with regard to
; 	    the implementation of the Thread Manager.
; 	 	
(def-mactype :voidptr (find-mactype ':pointer))
;   Prototype for thread's entry (main) routine 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ThreadEntryProcPtr = FUNCTION(threadParam: UNIV Ptr): voidPtr;

|#
 |#                                             ; $ELSEC
(def-mactype :threadentryprocptr (find-mactype ':pointer))
; $ENDC

;   Prototype for custom thread scheduler routine 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ThreadSchedulerProcPtr = FUNCTION(schedulerInfo: SchedulerInfoRecPtr): ThreadID;

|#
 |#                                             ; $ELSEC
(def-mactype :threadschedulerprocptr (find-mactype ':pointer))
; $ENDC

;   Prototype for custom thread switcher routine 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ThreadSwitchProcPtr = PROCEDURE(threadBeingSwitched: ThreadID; switchProcParam: UNIV Ptr);

|#
 |#                                             ; $ELSEC
(def-mactype :threadswitchprocptr (find-mactype ':pointer))
; $ENDC

;   Prototype for thread termination notification routine 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	ThreadTerminationProcPtr = PROCEDURE(threadTerminated: ThreadID; terminationProcParam: UNIV Ptr);

|#
 |#                                             ; $ELSEC
(def-mactype :threadterminationprocptr (find-mactype ':pointer))
; $ENDC

;   Prototype for debugger NewThread notification 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DebuggerNewThreadProcPtr = PROCEDURE(threadCreated: ThreadID);

|#
 |#                                             ; $ELSEC
(def-mactype :debuggernewthreadprocptr (find-mactype ':pointer))
; $ENDC

;   Prototype for debugger DisposeThread notification 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DebuggerDisposeThreadProcPtr = PROCEDURE(threadDeleted: ThreadID);

|#
 |#                                             ; $ELSEC
(def-mactype :debuggerdisposethreadprocptr (find-mactype ':pointer))
; $ENDC

;   Prototype for debugger schedule notification 
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	DebuggerThreadSchedulerProcPtr = FUNCTION(schedulerInfo: SchedulerInfoRecPtr): ThreadID;

|#
 |#                                             ; $ELSEC
(def-mactype :debuggerthreadschedulerprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :threadentryupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :threadentryupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :threadschedulerupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :threadschedulerupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :threadswitchupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :threadswitchupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :threadterminationupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :threadterminationupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :debuggernewthreadupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :debuggernewthreadupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :debuggerdisposethreadupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :debuggerdisposethreadupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :debuggerthreadschedulerupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :debuggerthreadschedulerupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppThreadEntryProcInfo #xF0)
(defconstant $uppThreadSchedulerProcInfo #xF0)
(defconstant $uppThreadSwitchProcInfo #x3C0)
(defconstant $uppThreadTerminationProcInfo #x3C0)
(defconstant $uppDebuggerNewThreadProcInfo #xC0)
(defconstant $uppDebuggerDisposeThreadProcInfo #xC0)
(defconstant $uppDebuggerThreadSchedulerProcInfo #xF0)
; 
; 	 *  NewThreadEntryUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_NewThreadEntryUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewThreadSchedulerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_NewThreadSchedulerUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewThreadSwitchUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_NewThreadSwitchUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewThreadTerminationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_NewThreadTerminationUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewDebuggerNewThreadUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_NewDebuggerNewThreadUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewDebuggerDisposeThreadUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_NewDebuggerDisposeThreadUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewDebuggerThreadSchedulerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_NewDebuggerThreadSchedulerUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeThreadEntryUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeThreadEntryUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeThreadSchedulerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeThreadSchedulerUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeThreadSwitchUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeThreadSwitchUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeThreadTerminationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeThreadTerminationUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeDebuggerNewThreadUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeDebuggerNewThreadUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeDebuggerDisposeThreadUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeDebuggerDisposeThreadUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeDebuggerThreadSchedulerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeDebuggerThreadSchedulerUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeThreadEntryUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_InvokeThreadEntryUPP" 
      ((threadParam :pointer) (userRoutine :pointer)) 
  :pointer
   (#x205F #x4E90) )

; 
;  *  InvokeThreadSchedulerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_InvokeThreadSchedulerUPP" 
      ((schedulerInfo (:pointer :schedulerinforec)) (userRoutine :pointer)) 
  :unsigned-long
   (#x205F #x4E90) )

; 
;  *  InvokeThreadSwitchUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_InvokeThreadSwitchUPP" 
      ((threadBeingSwitched :unsigned-long) (switchProcParam :pointer) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeThreadTerminationUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_InvokeThreadTerminationUPP" 
      ((threadTerminated :unsigned-long) (terminationProcParam :pointer) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeDebuggerNewThreadUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_InvokeDebuggerNewThreadUPP" 
      ((threadCreated :unsigned-long) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeDebuggerDisposeThreadUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_InvokeDebuggerDisposeThreadUPP" 
      ((threadDeleted :unsigned-long) (userRoutine :pointer)) 
  nil
   (#x205F #x4E90) )

; 
;  *  InvokeDebuggerThreadSchedulerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_InvokeDebuggerThreadSchedulerUPP" 
      ((schedulerInfo (:pointer :schedulerinforec)) (userRoutine :pointer)) 
  :unsigned-long
   (#x205F #x4E90) )

; 
;    Thread Manager function pointers (TPP):
;    on classic 68k use raw function pointers (same as UPP's)
;    on classic PowerPC, use raw function pointers
;    on classic PowerPC with OPAQUE_UPP_TYPES=1, use UPP's
;    on CFM-68K, use UPP's
;    on Carbon, use UPP's
; 

; $IFC TARGET_OS_MAC AND TARGET_CPU_PPC AND NOT OPAQUE_UPP_TYPES 
;   use raw function pointers 

(def-mactype :threadentrytpp (find-mactype ':pointer))
(def-mactype :threadschedulertpp (find-mactype ':pointer))
(def-mactype :threadswitchtpp (find-mactype ':pointer))
(def-mactype :threadterminationtpp (find-mactype ':pointer))
(def-mactype :debuggernewthreadtpp (find-mactype ':pointer))
(def-mactype :debuggerdisposethreadtpp (find-mactype ':pointer))
(def-mactype :debuggerthreadschedulertpp (find-mactype ':pointer))
#|                                              ; $ELSEC
;   use UPP's 

(def-mactype :threadentrytpp (find-mactype ':pointer))
(def-mactype :threadschedulertpp (find-mactype ':pointer))
(def-mactype :threadswitchtpp (find-mactype ':pointer))
(def-mactype :threadterminationtpp (find-mactype ':pointer))
(def-mactype :debuggernewthreadtpp (find-mactype ':pointer))
(def-mactype :debuggerdisposethreadtpp (find-mactype ':pointer))
(def-mactype :debuggerthreadschedulertpp (find-mactype ':pointer))
 |#                                             ; $ENDC

; 
; 	 *  NewThread()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in ThreadsLib 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_NewThread" 
      ((ThreadStyle :unsigned-long) (threadEntry :pointer) (threadParam :pointer) (stackSize :signed-long) (options :unsigned-long) (threadResult :pointer) (threadMade (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xABF2 :d0 3587 ThreadStyle threadEntry threadParam stackSize options threadResult threadMade))

; 
;  *  SetThreadScheduler()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ThreadsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetThreadScheduler" 
      ((threadScheduler :pointer))
   (:stack :signed-integer)
   (:stack-trap #xABF2 :d0 521 threadScheduler))

; 
;  *  SetThreadSwitcher()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ThreadsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetThreadSwitcher" 
      ((thread :unsigned-long) (threadSwitcher :pointer) (switchProcParam :pointer) (inOrOut :boolean))
   (:stack :signed-integer)
   (:stack-trap #xABF2 :d0 1802 thread threadSwitcher switchProcParam inOrOut))

; 
;  *  SetThreadTerminator()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ThreadsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetThreadTerminator" 
      ((thread :unsigned-long) (threadTerminator :pointer) (terminationProcParam :pointer))
   (:stack :signed-integer)
   (:stack-trap #xABF2 :d0 1553 thread threadTerminator terminationProcParam))

; 
;  *  SetDebuggerNotificationProcs()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ThreadsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetDebuggerNotificationProcs" 
      ((notifyNewThread :pointer) (notifyDisposeThread :pointer) (notifyThreadScheduler :pointer))
   (:stack :signed-integer)
   (:stack-trap #xABF2 :d0 1549 notifyNewThread notifyDisposeThread notifyThreadScheduler))

; 
;  *  CreateThreadPool()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ThreadsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_CreateThreadPool" 
      ((ThreadStyle :unsigned-long) (numToCreate :signed-integer) (stackSize :signed-long))
   (:stack :signed-integer)
   (:stack-trap #xABF2 :d0 1281 ThreadStyle numToCreate stackSize))

; 
;  *  GetFreeThreadCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ThreadsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetFreeThreadCount" 
      ((ThreadStyle :unsigned-long) (freeCount (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xABF2 :d0 1026 ThreadStyle freeCount))

; 
;  *  GetSpecificFreeThreadCount()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ThreadsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetSpecificFreeThreadCount" 
      ((ThreadStyle :unsigned-long) (stackSize :signed-long) (freeCount (:pointer :signed-integer)))
   (:stack :signed-integer)
   (:stack-trap #xABF2 :d0 1557 ThreadStyle stackSize freeCount))

; 
;  *  GetDefaultThreadStackSize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ThreadsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetDefaultThreadStackSize" 
      ((ThreadStyle :unsigned-long) (stackSize (:pointer :signed-long)))
   (:stack :signed-integer)
   (:stack-trap #xABF2 :d0 1043 ThreadStyle stackSize))

; 
;  *  ThreadCurrentStackSpace()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ThreadsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ThreadCurrentStackSpace" 
      ((thread :unsigned-long) (freeStack (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xABF2 :d0 1044 thread freeStack))

; 
;  *  DisposeThread()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ThreadsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeThread" 
      ((threadToDump :unsigned-long) (threadResult :pointer) (recycleThread :boolean))
   (:stack :signed-integer)
   (:stack-trap #xABF2 :d0 1284 threadToDump threadResult recycleThread))

; 
;  *  YieldToThread()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ThreadsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_YieldToThread" 
      ((suggestedThread :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xABF2 :d0 517 suggestedThread))

; 
;  *  YieldToAnyThread()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ThreadsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_YieldToAnyThread" 
      () 
  :signed-integer
   (#x42A7 #x303C #x205 #xABF2) )

; 
;  *  [Mac]GetCurrentThread()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ThreadsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetCurrentThread" 
      ((currentThreadID (:pointer :unsigned-long)))
   (:stack :signed-integer)
   (:stack-trap #xABF2 :d0 518 currentThreadID))

; 
;  *  GetThreadState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ThreadsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetThreadState" 
      ((threadToGet :unsigned-long) (ThreadState (:pointer :unsigned-integer)))
   (:stack :signed-integer)
   (:stack-trap #xABF2 :d0 1031 threadToGet ThreadState))

; 
;  *  SetThreadState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ThreadsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetThreadState" 
      ((threadToSet :unsigned-long) (newState :unsigned-integer) (suggestedThread :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xABF2 :d0 1288 threadToSet newState suggestedThread))

; 
;  *  SetThreadStateEndCritical()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ThreadsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetThreadStateEndCritical" 
      ((threadToSet :unsigned-long) (newState :unsigned-integer) (suggestedThread :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xABF2 :d0 1298 threadToSet newState suggestedThread))

; 
;  *  ThreadBeginCritical()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ThreadsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ThreadBeginCritical" 
      ()
   (:stack :signed-integer)
   (:stack-trap #xABF2 :d0 11))

; 
;  *  ThreadEndCritical()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ThreadsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_ThreadEndCritical" 
      ()
   (:stack :signed-integer)
   (:stack-trap #xABF2 :d0 12))

; 
;  *  GetThreadCurrentTaskRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ThreadsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetThreadCurrentTaskRef" 
      ((threadTRef (:pointer :pointer)))
   (:stack :signed-integer)
   (:stack-trap #xABF2 :d0 526 threadTRef))

; 
;  *  GetThreadStateGivenTaskRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ThreadsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_GetThreadStateGivenTaskRef" 
      ((threadTRef :pointer) (threadToGet :unsigned-long) (ThreadState (:pointer :unsigned-integer)))
   (:stack :signed-integer)
   (:stack-trap #xABF2 :d0 1551 threadTRef threadToGet ThreadState))

; 
;  *  SetThreadReadyGivenTaskRef()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in ThreadsLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_SetThreadReadyGivenTaskRef" 
      ((threadTRef :pointer) (threadToSet :unsigned-long))
   (:stack :signed-integer)
   (:stack-trap #xABF2 :d0 1040 threadTRef threadToSet))

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := ThreadsIncludes

; $ENDC                                         ; __THREADS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Threads)