(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:Timer.p"
; at Wednesday May 1,2002 2:40:07 pm.
; 
;      File:       Timer.p
;  
;      Contains:   Time Manager interfaces.
;  
;      Version:    Technology: Mac OS 8.5
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1985-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __TIMER__
; $SETC __TIMER__ := 1

; $I+
; $SETC TimerIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __CONDITIONALMACROS__
|#

(require-interface 'ConditionalMacros)
#|                                              ; $I ConditionalMacros.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __OSUTILS__
|#

(require-interface 'OSUtils)
#|                                              ; $I OSUtils.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;   high bit of qType is set if task is active  
(defconstant $kTMTaskActive #x8000)

(def-mactype :tmtaskptr (find-mactype '(:pointer :tmtask)))
#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	TimerProcPtr = PROCEDURE(tmTaskPtr: TMTaskPtr);

|#
 |#                                             ; $ELSEC
(def-mactype :timerprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :timerupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :timerupp (find-mactype ':pointer))
; $ENDC
(defrecord TMTask 
   (qLink (:pointer :qelem))
   (qType :signed-integer)
   (tmAddr :pointer)
   (tmCount :signed-long)
   (tmWakeUp :signed-long)
   (tmReserved :signed-long)
   )

; 
; 	 *  InsTime()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_InsTime" 
      ((tmTaskPtr (:pointer :qelem)))
   nil
   (:register-trap #xA058 :a0 tmTaskPtr))

; 
;  *  InsXTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_InsXTime" 
      ((tmTaskPtr (:pointer :qelem)))
   nil
   (:register-trap #xA458 :a0 tmTaskPtr))

; 
;  *  PrimeTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PrimeTime" 
      ((tmTaskPtr (:pointer :qelem)) (count :signed-long))
   nil
   (:register-trap #xA05A :d0 count :a0 tmTaskPtr))

; 
;  *  RmvTime()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_RmvTime" 
      ((tmTaskPtr (:pointer :qelem)))
   nil
   (:register-trap #xA059 :a0 tmTaskPtr))

;  InstallTimeTask, InstallXTimeTask, PrimeTimeTask and RemoveTimeTask work 
;  just like InsTime, InsXTime, PrimeTime, and RmvTime except that they 
;  return an OSErr result. 
; 
;  *  InstallTimeTask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_InstallTimeTask" 
      ((tmTaskPtr (:pointer :qelem)))
   (:d0 :signed-integer)
   (:register-trap #xA058 :a0 tmTaskPtr))

; 
;  *  InstallXTimeTask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_InstallXTimeTask" 
      ((tmTaskPtr (:pointer :qelem)))
   (:d0 :signed-integer)
   (:register-trap #xA458 :a0 tmTaskPtr))

; 
;  *  PrimeTimeTask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_PrimeTimeTask" 
      ((tmTaskPtr (:pointer :qelem)) (count :signed-long))
   (:d0 :signed-integer)
   (:register-trap #xA05A :d0 count :a0 tmTaskPtr))

; 
;  *  RemoveTimeTask()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 9.1 and later
;  *    CarbonLib:        in CarbonLib 1.0.2 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_RemoveTimeTask" 
      ((tmTaskPtr (:pointer :qelem)))
   (:d0 :signed-integer)
   (:register-trap #xA059 :a0 tmTaskPtr))

; 
;  *  Microseconds()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in InterfaceLib 7.1 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_Microseconds" 
      ((microTickCount (:pointer :unsignedwide))) 
  nil
   (#xA193 #x225F #x22C8 #x2280) )

(defconstant $uppTimerProcInfo #xB802)
; 
; 	 *  NewTimerUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewTimerProc 
(deftrap "_NewTimerUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeTimerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeTimerUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeTimerUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallTimerProc                   ; $ALIGN RESET; $POP; $SETC UsingIncludes := TimerIncludes
(deftrap-inline "_InvokeTimerUPP" 
      ((TMTaskPtr (:pointer :tmtask)) (userRoutine :pointer)) 
  nil
   () )                                         ; $ENDC; __TIMER__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'Timer)