(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:TypeSelect.p"
; at Wednesday May 1,2002 2:39:51 pm.
; 
;      File:       TypeSelect.p
;  
;      Contains:   TypeSelect Utilties
;  
;      Version:    Technology: Mac OS 9
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   2000-2001 by Apple Computer, Inc., all rights reserved.
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __TYPESELECT__
; $SETC __TYPESELECT__ := 1

; $I+
; $SETC TypeSelectIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __EVENTS__
|#

(require-interface 'Events)
#|                                              ; $I Events.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

(def-mactype :tscode (find-mactype ':signed-integer))

(defconstant $tsPreviousSelectMode -1)
(defconstant $tsNormalSelectMode 0)
(defconstant $tsNextSelectMode 1)

(def-mactype :typeselectrecordptr (find-mactype '(:pointer :typeselectrecord)))
(defrecord TypeSelectRecord 
   (tsrLastKeyTime :unsigned-long)
   (tsrScript :signed-integer)
   (tsrKeyStrokes (:string 63))
   )

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	IndexToStringProcPtr = FUNCTION(item: INTEGER; VAR itemsScript: ScriptCode; VAR itemsStringPtr: StringPtr; yourDataPtr: UNIV Ptr): BOOLEAN;

|#
 |#                                             ; $ELSEC
(def-mactype :indextostringprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :indextostringupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :indextostringupp (find-mactype ':pointer))
; $ENDC
; 
; 	 *  TypeSelectClear()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   not available
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_TypeSelectClear" 
      ((tsr (:pointer :typeselectrecord)))
   nil
   (:stack-trap #xA9ED tsr (40 :signed-integer)))

; 
;         Long ago the implementation of TypeSelectNewKey had a bug that
;         required the high word of D0 to be zero or the function did not work.
;         Although fixed now, we are continuing to clear the high word
;         just in case someone tries to run on an older system.
;     
; 
;  *  TypeSelectNewKey()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap-inline "_TypeSelectNewKey" 
      ((theEvent (:pointer :eventrecord)) (tsr (:pointer :typeselectrecord))) 
  :boolean
   (#x7000 #x3F3C #x2A #xA9ED) )

; 
;  *  TypeSelectFindItem()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_TypeSelectFindItem" 
      ((tsr (:pointer :typeselectrecord)) (listSize :signed-integer) (selectMode :signed-integer) (getStringProc :pointer) (yourDataPtr :pointer))
   (:stack :signed-integer)
   (:stack-trap #xA9ED tsr listSize selectMode getStringProc yourDataPtr (44 :signed-integer)))

; 
;  *  TypeSelectCompare()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   not available
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; CONST
(deftrap "_TypeSelectCompare" 
      ((tsr (:pointer :typeselectrecord)) (testStringScript :signed-integer) (testStringPtr (:pointer (:string 255))))
   (:stack :signed-integer)
   (:stack-trap #xA9ED tsr testStringScript testStringPtr (46 :signed-integer)))

(defconstant $uppIndexToStringProcInfo #x3F90)
; 
; 	 *  NewIndexToStringUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
;  old name was NewIndexToStringProc 
(deftrap "_NewIndexToStringUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeIndexToStringUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeIndexToStringUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeIndexToStringUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
;  old name was CallIndexToStringProc 
(deftrap-inline "_InvokeIndexToStringUPP" 
      ((item :signed-integer) (itemsScript (:pointer :signed-integer)) (itemsStringPtr (:pointer (:pointer (:string 255)))) (yourDataPtr :pointer) (userRoutine :pointer)) 
  :boolean
   (#x205F #x4E90) )

; $ALIGN RESET
; $POP

; $SETC UsingIncludes := TypeSelectIncludes

; $ENDC                                         ; __TYPESELECT__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'TypeSelect)