(in-package :TRAPS)
; Generated from #P"OSX Drive:Users:bburns:Desktop:interface-translator:Source Interfaces:PInterfaces:URLAccess.p"
; at Wednesday May 1,2002 2:41:08 pm.
; 
;      File:       URLAccess.p
;  
;      Contains:   URL Access Interfaces.
;  
;      Version:    Technology: URLAccess 2.0
;                  Release:    Universal Interfaces 3.4.1
;  
;      Copyright:   1994-2001 by Apple Computer, Inc., all rights reserved
;  
;      Bugs?:      For bug reports, consult the following page on
;                  the World Wide Web:
;  
;                      http://developer.apple.com/bugreporter/
;  
; 
#|                                              ; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
 |#                                             ; $ENDC

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

; $IFC UNDEFINED __URLACCESS__
; $SETC __URLACCESS__ := 1

; $I+
; $SETC URLAccessIncludes := UsingIncludes
; $SETC UsingIncludes := 1

#|                                              ; $IFC UNDEFINED __MACTYPES__
|#

(require-interface 'MacTypes)
#|                                              ; $I MacTypes.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __FILES__
|#

(require-interface 'Files)
#|                                              ; $I Files.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __CODEFRAGMENTS__
|#

(require-interface 'CodeFragments)
#|                                              ; $I CodeFragments.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __MACERRORS__
|#

(require-interface 'MacErrors)
#|                                              ; $I MacErrors.p
 |#                                             ; $ENDC
#|                                              ; $IFC UNDEFINED __EVENTS__
|#

(require-interface 'Events)
#|                                              ; $I Events.p
 |#                                             ; $ENDC

; $PUSH
; $ALIGN MAC68K
; $LibExport+

;  Data structures and types 

(def-mactype :urlreference (find-mactype ':pointer));  an opaque 32-bit type 
(def-mactype :urlreferenceptr (find-mactype '(:pointer :pointer)));  when a VAR xx:URLReference parameter can be nil, it is changed to xx: URLReferencePtr 
(def-mactype :urlopenflags (find-mactype ':unsigned-long))

(defconstant $kURLReplaceExistingFlag #x1)
(defconstant $kURLBinHexFileFlag #x2)           ;   Binhex before uploading if necessary 
(defconstant $kURLExpandFileFlag #x4)           ;   Use StuffIt engine to expand file if necessary 
(defconstant $kURLDisplayProgressFlag #x8)
(defconstant $kURLDisplayAuthFlag #x10)         ;   Display auth dialog if guest connection fails 
(defconstant $kURLUploadFlag #x20)              ;   Do an upload instead of a download 
(defconstant $kURLIsDirectoryHintFlag #x40)     ;   Hint: the URL is a directory 
(defconstant $kURLDoNotTryAnonymousFlag #x80)   ;   Don't try to connect anonymously before getting logon info 
(defconstant $kURLDirectoryListingFlag #x100)   ;   Download the directory listing, not the whole directory 
(defconstant $kURLExpandAndVerifyFlag #x200)    ;   Expand file and then verify using signature resource 
(defconstant $kURLNoAutoRedirectFlag #x400)     ;   Do not automatically redirect to new URL 
(defconstant $kURLDebinhexOnlyFlag #x800)       ;   Do not use Stuffit Expander - just internal debinhex engine 
(defconstant $kURLDoNotDeleteOnErrorFlag #x1000);   Do not delete the downloaded file if an error or abort occurs. 
;   This flag applies to downloading only and should be used if 
;   interested in later resuming the download. 
(defconstant $kURLResumeDownloadFlag #x2000)    ;   The passed in file is partially downloaded, attempt to resume 
;   it.  Currently works for HTTP only.  If no FSSpec passed in, 
;   this flag will be ignored. Overriden by kURLReplaceExistingFlag.  
(defconstant $kURLReservedFlag #x80000000)      ;   reserved for Apple internal use 

(def-mactype :urlstate (find-mactype ':unsigned-long))

(defconstant $kURLNullState 0)
(defconstant $kURLInitiatingState 1)
(defconstant $kURLLookingUpHostState 2)
(defconstant $kURLConnectingState 3)
(defconstant $kURLResourceFoundState 4)
(defconstant $kURLDownloadingState 5)
(defconstant $kURLDataAvailableState #x15)
(defconstant $kURLTransactionCompleteState 6)
(defconstant $kURLErrorOccurredState 7)
(defconstant $kURLAbortingState 8)
(defconstant $kURLCompletedState 9)
(defconstant $kURLUploadingState 10)

(def-mactype :urlevent (find-mactype ':unsigned-long))

(defconstant $kURLInitiatedEvent 1)
(defconstant $kURLResourceFoundEvent 4)
(defconstant $kURLDownloadingEvent 5)
(defconstant $kURLAbortInitiatedEvent 8)
(defconstant $kURLCompletedEvent 9)
(defconstant $kURLErrorOccurredEvent 7)
(defconstant $kURLDataAvailableEvent #x15)
(defconstant $kURLTransactionCompleteEvent 6)
(defconstant $kURLUploadingEvent 10)
(defconstant $kURLSystemEvent 29)
(defconstant $kURLPercentEvent 30)
(defconstant $kURLPeriodicEvent 31)
(defconstant $kURLPropertyChangedEvent 32)

(def-mactype :urleventmask (find-mactype ':unsigned-long))

(defconstant $kURLInitiatedEventMask #x1)
(defconstant $kURLResourceFoundEventMask #x8)
(defconstant $kURLDownloadingMask #x10)
(defconstant $kURLUploadingMask #x200)
(defconstant $kURLAbortInitiatedMask #x80)
(defconstant $kURLCompletedEventMask #x100)
(defconstant $kURLErrorOccurredEventMask #x40)
(defconstant $kURLDataAvailableEventMask #x100000)
(defconstant $kURLTransactionCompleteEventMask #x20)
(defconstant $kURLSystemEventMask #x10000000)
(defconstant $kURLPercentEventMask #x20000000)
(defconstant $kURLPeriodicEventMask #x40000000)
(defconstant $kURLPropertyChangedEventMask #x80000000)
(defconstant $kURLAllBufferEventsMask #x100020)
(defconstant $kURLAllNonBufferEventsMask #xE00003D1)
(defconstant $kURLAllEventsMask #xFFFFFFFF)

(def-mactype :urlcallbackinfoptr (find-mactype '(:pointer :urlcallbackinfo)))
(defrecord URLCallbackInfo 
   (version :unsigned-long)
   (urlRef :pointer)
   (property :pointer)
   (currentSize :unsigned-long)
   (systemEvent (:pointer :eventrecord))
   )

;   authentication type flags 

(defconstant $kUserNameAndPasswordFlag #x1)

; $IFC NOT UNDEFINED MWERKS
(defconstant $kURLURL "URLString")
; $ENDC
; $IFC NOT UNDEFINED MWERKS
(defconstant $kURLResourceSize "URLResourceSize")
; $ENDC
; $IFC NOT UNDEFINED MWERKS
(defconstant $kURLLastModifiedTime "URLLastModifiedTime")
; $ENDC
; $IFC NOT UNDEFINED MWERKS
(defconstant $kURLMIMEType "URLMIMEType")
; $ENDC
; $IFC NOT UNDEFINED MWERKS
(defconstant $kURLFileType "URLFileType")
; $ENDC
; $IFC NOT UNDEFINED MWERKS
(defconstant $kURLFileCreator "URLFileCreator")
; $ENDC
; $IFC NOT UNDEFINED MWERKS
(defconstant $kURLCharacterSet "URLCharacterSet")
; $ENDC
; $IFC NOT UNDEFINED MWERKS
(defconstant $kURLResourceName "URLResourceName")
; $ENDC
; $IFC NOT UNDEFINED MWERKS
(defconstant $kURLHost "URLHost")
; $ENDC
; $IFC NOT UNDEFINED MWERKS
(defconstant $kURLAuthType "URLAuthType")
; $ENDC
; $IFC NOT UNDEFINED MWERKS
(defconstant $kURLUserName "URLUserName")
; $ENDC
; $IFC NOT UNDEFINED MWERKS
(defconstant $kURLPassword "URLPassword")
; $ENDC
; $IFC NOT UNDEFINED MWERKS
(defconstant $kURLStatusString "URLStatusString")
; $ENDC
; $IFC NOT UNDEFINED MWERKS
(defconstant $kURLIsSecure "URLIsSecure")
; $ENDC
; $IFC NOT UNDEFINED MWERKS
(defconstant $kURLCertificate "URLCertificate")
; $ENDC
; $IFC NOT UNDEFINED MWERKS
(defconstant $kURLTotalItems "URLTotalItems")
; $ENDC
; $IFC NOT UNDEFINED MWERKS
(defconstant $kURLConnectTimeout "URLConnectTimeout")
; $ENDC
;   http and https properties 
; $IFC NOT UNDEFINED MWERKS
(defconstant $kURLHTTPRequestMethod "URLHTTPRequestMethod")
; $ENDC
; $IFC NOT UNDEFINED MWERKS
(defconstant $kURLHTTPRequestHeader "URLHTTPRequestHeader")
; $ENDC
; $IFC NOT UNDEFINED MWERKS
(defconstant $kURLHTTPRequestBody "URLHTTPRequestBody")
; $ENDC
; $IFC NOT UNDEFINED MWERKS
(defconstant $kURLHTTPRespHeader "URLHTTPRespHeader")
; $ENDC
; $IFC NOT UNDEFINED MWERKS
(defconstant $kURLHTTPUserAgent "URLHTTPUserAgent")
; $ENDC
; $IFC NOT UNDEFINED MWERKS
(defconstant $kURLHTTPRedirectedURL "URLHTTPRedirectedURL")
; $ENDC
; $IFC NOT UNDEFINED MWERKS
(defconstant $kURLSSLCipherSuite "URLSSLCipherSuite")
; $ENDC

; 
; 	 *  URLGetURLAccessVersion()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   in URLAccessLib 1.0 and later
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	
; $IFC TARGET_RT_MAC_CFM                        ; 
;         URLAccessAvailable() is a macro/inline available only in C/C++.  
;         To get the same functionality from pascal or assembly, you need
;         to test if URLGetURLAccessVersion function is not NULL.  For instance:
;         
;             gURLAccessAvailable = FALSE;
;             IF @URLAccessAvailable <> kUnresolvedCFragSymbolAddress THEN
;                 gURLAccessAvailable = TRUE;
;             END
;     
;     
#|                                              ; $ELSEC; $IFC TARGET_RT_MAC_MACHO ;  URL Access is always available on OS X 
(deftrap-inline "_URLGetURLAccessVersion" 
      ((returnVers (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; $ENDC
 |#                                             ; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	URLNotifyProcPtr = FUNCTION(userContext: UNIV Ptr; event: URLEvent; VAR callbackInfo: URLCallbackInfo): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :urlnotifyprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC TYPED_FUNCTION_POINTERS
#|
	URLSystemEventProcPtr = FUNCTION(userContext: UNIV Ptr; VAR event: EventRecord): OSStatus;

|#
 |#                                             ; $ELSEC
(def-mactype :urlsystemeventprocptr (find-mactype ':pointer))
; $ENDC

#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :urlnotifyupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :urlnotifyupp (find-mactype ':pointer))
; $ENDC
#|                                              ; $IFC OPAQUE_UPP_TYPES
(def-mactype :urlsystemeventupp (find-mactype ':pointer));  an opaque UPP 
 |#                                             ; $ELSEC
(def-mactype :urlsystemeventupp (find-mactype ':pointer))
; $ENDC

(defconstant $uppURLNotifyProcInfo #xFF0)
(defconstant $uppURLSystemEventProcInfo #x3F0)
; 
; 	 *  NewURLNotifyUPP()
; 	 *  
; 	 *  Availability:
; 	 *    Non-Carbon CFM:   available as macro/inline
; 	 *    CarbonLib:        in CarbonLib 1.0 and later
; 	 *    Mac OS X:         in version 10.0 and later
; 	 	

(deftrap "_NewURLNotifyUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  NewURLSystemEventUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_NewURLSystemEventUPP" 
      ((userRoutine :pointer))
   (:stack :pointer)
   (:stack-trap #x2E9F))

; 
;  *  DisposeURLNotifyUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeURLNotifyUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  DisposeURLSystemEventUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap "_DisposeURLSystemEventUPP" 
      ((userUPP :pointer))
   nil
   (:stack-trap #x584F))

; 
;  *  InvokeURLNotifyUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_InvokeURLNotifyUPP" 
      ((userContext :pointer) (event :unsigned-long) (callbackInfo (:pointer :urlcallbackinfo)) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

; 
;  *  InvokeURLSystemEventUPP()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   available as macro/inline
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  

(deftrap-inline "_InvokeURLSystemEventUPP" 
      ((userContext :pointer) (event (:pointer :eventrecord)) (userRoutine :pointer)) 
  :osstatus
   (#x205F #x4E90) )

; 
;  *  URLSimpleDownload()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in URLAccessLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
; 
;  *  URLDownload()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in URLAccessLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_URLSimpleDownload" 
      ((url :pointer) (destination (:pointer :fsspec)) (destinationHandle :handle) (openFlags :unsigned-long) (eventProc :pointer) (userContext :pointer)) 
  :osstatus
   () )                                         ; 
;  *  URLSimpleUpload()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in URLAccessLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_URLDownload" 
      ((urlRef :pointer) (destination (:pointer :fsspec)) (destinationHandle :handle) (openFlags :unsigned-long) (eventProc :pointer) (userContext :pointer)) 
  :osstatus
   () )                                         ; CONST; 
;  *  URLUpload()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in URLAccessLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_URLSimpleUpload" 
      ((url :pointer) (source (:pointer :fsspec)) (openFlags :unsigned-long) (eventProc :pointer) (userContext :pointer)) 
  :osstatus
   () )                                         ; CONST; 
;  *  URLNewReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in URLAccessLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_URLUpload" 
      ((urlRef :pointer) (source (:pointer :fsspec)) (openFlags :unsigned-long) (eventProc :pointer) (userContext :pointer)) 
  :osstatus
   () )                                         ; 
;  *  URLDisposeReference()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in URLAccessLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_URLNewReference" 
      ((url :pointer) (urlRef (:pointer :pointer))) 
  :osstatus
   () )                                         ; 
;  *  URLOpen()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in URLAccessLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_URLDisposeReference" 
      ((urlRef :pointer)) 
  :osstatus
   () )                                         ; 
;  *  URLAbort()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in URLAccessLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_URLOpen" 
      ((urlRef :pointer) (fileSpec (:pointer :fsspec)) (openFlags :unsigned-long) (notifyProc :pointer) (eventRegister :unsigned-long) (userContext :pointer)) 
  :osstatus
   () )                                         ; 
;  *  URLGetDataAvailable()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in URLAccessLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_URLAbort" 
      ((urlRef :pointer)) 
  :osstatus
   () )                                         ; 
;  *  URLGetBuffer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in URLAccessLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_URLGetDataAvailable" 
      ((urlRef :pointer) (dataSize (:pointer :signed-long))) 
  :osstatus
   () )                                         ; 
;  *  URLReleaseBuffer()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in URLAccessLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_URLGetBuffer" 
      ((urlRef :pointer) (buffer (:pointer :pointer)) (bufferSize (:pointer :signed-long))) 
  :osstatus
   () )                                         ; 
;  *  URLGetProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in URLAccessLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_URLReleaseBuffer" 
      ((urlRef :pointer) (buffer :pointer)) 
  :osstatus
   () )                                         ; 
;  *  URLGetPropertySize()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in URLAccessLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_URLGetProperty" 
      ((urlRef :pointer) (property :pointer) (propertyBuffer :pointer) (bufferSize :signed-long)) 
  :osstatus
   () )                                         ; 
;  *  URLSetProperty()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in URLAccessLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_URLGetPropertySize" 
      ((urlRef :pointer) (property :pointer) (propertySize (:pointer :signed-long))) 
  :osstatus
   () )                                         ; 
;  *  URLGetCurrentState()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in URLAccessLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_URLSetProperty" 
      ((urlRef :pointer) (property :pointer) (propertyBuffer :pointer) (bufferSize :signed-long)) 
  :osstatus
   () )                                         ; 
;  *  URLGetError()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in URLAccessLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_URLGetCurrentState" 
      ((urlRef :pointer) (state (:pointer :unsigned-long))) 
  :osstatus
   () )                                         ; 
;  *  URLIdle()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in URLAccessLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_URLGetError" 
      ((urlRef :pointer) (urlError (:pointer :signed-long))) 
  :osstatus
   () )                                         ; 
;  *  URLGetFileInfo()
;  *  
;  *  Availability:
;  *    Non-Carbon CFM:   in URLAccessLib 1.0 and later
;  *    CarbonLib:        in CarbonLib 1.0 and later
;  *    Mac OS X:         in version 10.0 and later
;  
(deftrap-inline "_URLIdle" 
      () 
  :osstatus
   () )                                         ; $ALIGN RESET; $POP; $SETC UsingIncludes := URLAccessIncludes
(deftrap-inline "_URLGetFileInfo" 
      ((fName (:pointer (:string 255))) (fType (:pointer :ostype)) (fCreator (:pointer :ostype))) 
  :osstatus
   () )                                         ; $ENDC; __URLACCESS__

#|                                              ; $IFC NOT UsingIncludes

 |#                                             ; $ENDC

(provide-interface 'URLAccess)