(in-package :ccl)

;; fix get info dialog when making a method undefined
(let ((*warn-if-redefine* nil)
      (*warn-if-redefine-kernel* nil))


(defun forget-action-function (x)
  (declare (ignore x))
  (let* ((cell (first-selected-cell *ead-table-dialog-item*)))
    (if (not cell)
      nil
      (let  ((thing (cell-contents *ead-table-dialog-item* cell)))
        (with-event-processing-enabled
          (if (option-key-p) (window-close *edit-anything-dialog*))
          (if (symbolp thing)
            (fmakunbound thing)
            (let ((def (car thing)))
              (if (typep def 'method)
                (%remove-method def)
                (when (eq def 'function)            
                  (fmakunbound (thing-name-from-dialog *edit-anything-dialog*))))))
          (cell-deselect *ead-table-dialog-item* cell)
          (redraw-cell *ead-table-dialog-item* cell))))))
)