(in-package :ccl)

;; accept a class as well as class-name
(let ((*warn-if-redefine* nil)
      (*warn-if-redefine-kernel* nil))


(defun make-condition (name &rest init-list &aux class)
  (declare (dynamic-extent init-list))
  (if (and (setq class (if  (typep name 'standard-class) 
                         name
                         (find-class name nil)))
           (condition-p (class-prototype class)))
    (apply #'make-instance class init-list)
    (error "~S is not a defined condition type name" name)))

)