;;; static-text-control-item.lisp
;;; Wednesday March 26, 2003 SVS
;;; Originally from Brendan Burns

;;; This widget should probably replace most, if not all, uses of static-text-dialog-item
;;;   in MCL eventually.

(in-package :ccl)

(require :appearance-manager "ccl:examples;appearance-manager-folder;appearance-manager.lisp")
(require :new-control-dialog-item)

(export 'static-text-control-item)

(defclass static-text-control-item (new-control-dialog-item) ; SVS modified for Terje's appearance-manager
  ((procid :initarg :procid :initform #$kControlStaticTextProc
           :allocation :class)))

; Draws gray over theme-background windows. Should be transparent. Don't know how to fix it.
(defmethod install-view-in-window :after ((item static-text-control-item) dialog)
  (declare (ignore dialog))
  (with-cstrs ((str (dialog-item-text item)))
    (#_SetControlData (dialog-item-handle item) #$kControlEntireControl
     #$kControlStaticTextTextTag (length (dialog-item-text item)) str)
    ;(#_SetUpControlBackground (dialog-item-handle item) 32 t) ; doesn't seem to do anything
    ))

; SVS
(defmethod view-draw-contents :before ((item static-text-control-item))
  (with-cstrs ((str (dialog-item-text item)))
    (#_SetControlData (dialog-item-handle item) #$kControlEntireControl
     #$kControlStaticTextTextTag (length (dialog-item-text item)) str)))
