(defun pol-to-min (vlist)

       (let ((NF 0))

             (progn (setq ht (make-hash-table :test #'equal))

                    (dolist (face vlist nil)

                            (incf NF) 

                            (setq NF (gen-ht-face NF face ht)))

                    (ht-to-min (set-adjac ht) NF))))



(defun gen-ht-face (NF face table)

       (let ((rest face) (v1 (car face)) (ecount 0))

            (loop (if (null (cdr rest))

                      (progn (setf (gethash (cons (car rest) v1) table) (cons NF nil)) (return NF))

                      (setf (gethash (cons (car rest) (car (setq rest (cdr rest)))) table) (cons NF nil)))

                  (incf ecount)

                  (if (and (= ecount 2) (not (null (cdr rest))))

                      (progn (setf (gethash (cons (car rest) v1) table) (cons NF (1+ NF)))

                             (setf (gethash (cons v1 (car rest)) table) (cons (1+ NF) NF))

                             (incf NF)

                             (setq ecount 1))))))



(defun set-adjac (table)

            (maphash #'(lambda (key val)

                           (if (null (cdr val))

                               (let ((val-app (gethash (rev-key key) ht)))

                                    (setf (gethash key ht) (cons (car val) (car val-app)))

                                    (setf (gethash (rev-key key) ht) (cons (car val-app) (car val))))))

                       table)

            table)



(defun rev-key (key) (cons (cdr key) (car key)))



(defun ht-to-min (table NF)

       (let ((armin (make-array (list NF 6) :initial-element 0)))

            (maphash #'(lambda (key val)

                               (let ((k (1- (car val))))

                                    (cond ((= (aref armin k 0) 0) 

                                              (setf (aref armin k 0) (car key)) 

                                              (setf (aref armin k 1) (cdr key))

                                              (setf (aref armin k 3) (cdr val)))

                                          ((= (aref armin k 1) (car key))

                                              (setf (aref armin k 2) (cdr key))

                                              (setf (aref armin k 4) (cdr val)))

                                          (t 

                                              (setf (aref armin k 5) (cdr val))))))

                       table)

            armin))



                      