

(eval-plasm "

def vert_cell (V1,V2::isseq;delta::isreal) =

  <<x1+DX+DY,y1+DX+DY>,<x1+DX-DY,y1+DX+DY>,

   <x1+DX+DY,y1-DX+DY>,<x1+DX-DY,y1-DX+DY>,

   <x2-DX+DY,y2+DX-DY>,<x2-DX-DY,y2+DX-DY>,

   <x2-DX+DY,y2-DX-DY>,<x2-DX-DY,y2-DX-DY>>

where

 x1 = s1:v1, y1 = s2:v1,

 x2 = s1:v2, y2 = s2:v2,

 DX = delta*sign:(x2-x1),

 DY = delta*sign:(y2-y1)

end

")



(eval-plasm " 

def indici_cella (n_cells,dim_celle,offset::isreal) =

 if:<isintpos~s1,

     al~[k:(offset..(offset+dim_celle- 1)),

         indici_cella~[s1-k:1,s2, s3+s2 ]],

     k:<>>:<n_cells,dim_celle,offset>

")



(eval-plasm "

def member  =  or~aa:eq~distl ")



(eval-plasm "

def remove_duplicates  =

 if:<isnull,k:<>,

     if:<member,s2,al>~[s1,remove_duplicates ~tail]> 

")



(eval-plasm " 

def offset (pol::ispol;delta::isreal) =

  mkpol:<cat:<new_vert,cells_vert>, 

         cat:<new_cells,new_cells3>, new_pols >

where

  incr       = +~[id,k:delta],

  decr       = -~[id,k:delta],

  pol_data   = ukpol:pol,

  vertices   = (remove_duplicates~s1):pol_data,

  vertices1  = s1:pol_data,

  cells      = s2:pol_data,

  pols       = s3:pol_data,

  new_vert   = (cat~aa:[[incr~s1,incr~s2],[incr~s1,decr~s2],

                        [decr~s1,incr~s2],[decr~s1,decr~s2]])

                :vertices,

  new_cells  = indici_cella:<len:vertices,4,1>,

  cells_vert = (cat~aa:vert_cell~aa:ar~aa:[id,k:delta]~

                cons:(aa:cons:(aa:(aa:sel):cells))):vertices1,

  new_cells3 = indici_cella:<len:cells_vert/8,8,

                             1+(4*len:vertices)>,

  new_pols   =  <1..(len:new_cells+len:new_cells3)> 

end

")





(eval-plasm "(export~offset~cuboid):<1,1>")