; -*- package: kernel -*-
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;           Universita' di Roma "La Sapienza"                               ;
;       Dipartimento di Informatica e Sistemistica                          ;
;            Via Buonarroti 12 - 00185 Roma                                 ;
;                                                                           ;
;                      CAD Group                                            ;
;                                                                           ;
; Project: SimpleXn                                                         ;
; Identification: Package Kernel                                            ;
;                                                                           ;
;  Version: 1.0                                                             ;
;                                                                           ;
;  Author: V. Pascucci                                                      ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(provide 'embed)                              ;module name
(inpackage kernel) ;package name

(export '(embed-pol-complex))

(defun embed-pol-complex (pol-complex n)
  (let ((old-dim (get-npol-complex pol-complex))
        (new-complex (make-empty-polyhedra-complex )))
    (put-node-in-pol-complex 
     (make-pol-node pol-complex (mat-identity (+ n old-dim 1)))
                             new-complex)
    new-complex))
